/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AMDGPU target                          *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 127;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(6),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s64,
  GILLT_p1s64,
  GILLT_p2s32,
  GILLT_p3s32,
  GILLT_p4s64,
  GILLT_p5s32,
  GILLT_p6s32,
  GILLT_s1,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v3s32,
  GILLT_v3s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v5s32,
  GILLT_v6s32,
  GILLT_v7s32,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v9s32,
  GILLT_v10s32,
  GILLT_v11s32,
  GILLT_v12s32,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v16s64,
  GILLT_v32s16,
  GILLT_v32s32,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 64),
  LLT::pointer(1, 64),
  LLT::pointer(2, 32),
  LLT::pointer(3, 32),
  LLT::pointer(4, 64),
  LLT::pointer(5, 32),
  LLT::pointer(6, 32),
  LLT::scalar(1),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(3), 32),
  LLT::vector(ElementCount::getFixed(3), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(5), 32),
  LLT::vector(ElementCount::getFixed(6), 32),
  LLT::vector(ElementCount::getFixed(7), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(9), 32),
  LLT::vector(ElementCount::getFixed(10), 32),
  LLT::vector(ElementCount::getFixed(11), 32),
  LLT::vector(ElementCount::getFixed(12), 32),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(16), 64),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(32), 32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_FalsePredicateBit = 112,
  Feature_isGFX6Bit = 50,
  Feature_isGFX6GFX7Bit = 8,
  Feature_isGFX6GFX7GFX10Bit = 110,
  Feature_isGFX7OnlyBit = 84,
  Feature_isGFX7GFX8GFX9Bit = 45,
  Feature_isGFX6GFX7GFX8GFX9Bit = 66,
  Feature_isGFX6GFX7GFX8GFX9GFX10Bit = 123,
  Feature_isNotGFX12PlusBit = 19,
  Feature_isGFX8GFX9GFX10GFX11Bit = 21,
  Feature_isGFX7PlusBit = 13,
  Feature_isGFX8PlusBit = 4,
  Feature_isGFX8OnlyBit = 22,
  Feature_isGFX9PlusBit = 0,
  Feature_isNotGFX9PlusBit = 56,
  Feature_isGFX90APlusBit = 38,
  Feature_isNotGFX90APlusBit = 23,
  Feature_isGFX908orGFX90ABit = 39,
  Feature_isGFX940PlusBit = 40,
  Feature_isNotGFX940PlusBit = 51,
  Feature_HasGFX950InstsBit = 28,
  Feature_isGFX8GFX9Bit = 15,
  Feature_isGFX10OnlyBit = 62,
  Feature_isGFX10PlusBit = 5,
  Feature_isGFX9GFX10Bit = 57,
  Feature_isGFX11OnlyBit = 63,
  Feature_isGFX11PlusBit = 1,
  Feature_isGFX12OnlyBit = 64,
  Feature_isGFX12PlusBit = 3,
  Feature_HasMinimum3Maximum3F32Bit = 20,
  Feature_HasMinimum3Maximum3F16Bit = 25,
  Feature_HasMinimum3Maximum3PKF16Bit = 32,
  Feature_HasFlatAddressSpaceBit = 86,
  Feature_HasFlatBufferGlobalAtomicFaddF64InstBit = 102,
  Feature_HasAtomicFMinFMaxF32GlobalInstsBit = 96,
  Feature_HasAtomicFMinFMaxF64GlobalInstsBit = 101,
  Feature_HasAtomicFMinFMaxF32FlatInstsBit = 92,
  Feature_HasAtomicFMinFMaxF64FlatInstsBit = 93,
  Feature_HasLdsAtomicAddF64Bit = 126,
  Feature_HasFlatGlobalInstsBit = 87,
  Feature_HasFlatScratchInstsBit = 90,
  Feature_HasD16LoadStoreBit = 95,
  Feature_HasFlatScratchSVSModeBit = 91,
  Feature_HasGFX10_BEncodingBit = 49,
  Feature_HasUnpackedD16VMemBit = 106,
  Feature_HasPackedD16VMemBit = 107,
  Feature_HasUnrestrictedSOffsetBit = 105,
  Feature_D16PreservesUnusedBitsBit = 88,
  Feature_LDSRequiresM0InitBit = 119,
  Feature_NotLDSRequiresM0InitBit = 120,
  Feature_HasExportInstsBit = 7,
  Feature_HasLDSFPAtomicAddF32Bit = 125,
  Feature_HasAddNoCarryInstsBit = 65,
  Feature_NotHasAddNoCarryInstsBit = 117,
  Feature_HasXNACKEnabledBit = 83,
  Feature_Has16BitInstsBit = 9,
  Feature_NotHasTrue16BitInstsBit = 10,
  Feature_UseRealTrue16InstsBit = 11,
  Feature_UseFakeTrue16InstsBit = 12,
  Feature_HasVOP3PInstsBit = 77,
  Feature_HasMed3_16Bit = 118,
  Feature_HasMinMaxDenormModesBit = 111,
  Feature_NotHasMinMaxDenormModesBit = 113,
  Feature_HasSDWABit = 61,
  Feature_HasPackedFP32OpsBit = 43,
  Feature_HasImageInstsBit = 6,
  Feature_HasIntClampBit = 71,
  Feature_HasMadMixInstsBit = 78,
  Feature_HasScalarStoresBit = 46,
  Feature_has16BankLDSBit = 52,
  Feature_has32BankLDSBit = 24,
  Feature_HasFmaMixInstsBit = 80,
  Feature_HasDLInstsBit = 16,
  Feature_HasFmacF64InstBit = 116,
  Feature_HasDot1InstsBit = 36,
  Feature_HasDot2InstsBit = 33,
  Feature_HasDot3InstsBit = 70,
  Feature_HasDot4InstsBit = 69,
  Feature_HasDot5InstsBit = 67,
  Feature_HasDot6InstsBit = 68,
  Feature_HasDot7InstsBit = 35,
  Feature_HasDot8InstsBit = 81,
  Feature_HasDot9InstsBit = 29,
  Feature_HasDot10InstsBit = 34,
  Feature_HasDot11InstsBit = 82,
  Feature_HasGetWaveIdInstBit = 48,
  Feature_HasMAIInstsBit = 37,
  Feature_HasSMemRealTimeBit = 47,
  Feature_HasSMemTimeInstBit = 44,
  Feature_HasShaderCyclesRegisterBit = 85,
  Feature_HasShaderCyclesHiLoRegistersBit = 55,
  Feature_HasFP8InstsBit = 42,
  Feature_HasFP8ConversionInstsBit = 59,
  Feature_HasMadMacF32InstsBit = 17,
  Feature_HasFmaLegacy32Bit = 18,
  Feature_HasAtomicDsPkAdd16InstsBit = 124,
  Feature_HasAtomicFlatPkAdd16InstsBit = 104,
  Feature_HasAtomicFaddRtnInstsBit = 99,
  Feature_HasAtomicFaddNoRtnInstsBit = 97,
  Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit = 98,
  Feature_HasAtomicBufferGlobalPkAddF16InstsBit = 100,
  Feature_HasFlatAtomicFaddF32InstBit = 103,
  Feature_EnableFlatScratchBit = 89,
  Feature_DisableFlatScratchBit = 108,
  Feature_HasUnalignedAccessModeBit = 121,
  Feature_HasMADIntraFwdBugBit = 73,
  Feature_HasNotMADIntraFwdBugBit = 72,
  Feature_HasSALUFloatInstsBit = 2,
  Feature_NotHasSALUFloatInstsBit = 109,
  Feature_HasPseudoScalarTransBit = 30,
  Feature_HasBitOp3InstsBit = 75,
  Feature_HasPrngInstBit = 14,
  Feature_HasFP6BF6ConversionScaleInstsBit = 26,
  Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit = 27,
  Feature_HasCvtPkF16F32InstBit = 74,
  Feature_HasF32ToF16BF16ConversionSRInstsBit = 76,
  Feature_HasGDSBit = 122,
  Feature_HasCvtFP8VOP1BugBit = 58,
  Feature_HasNoCvtFP8VOP1BugBit = 60,
  Feature_HasAtomicCSubNoRtnInstsBit = 94,
  Feature_HasXF32InstsBit = 41,
  Feature_HasAshrPkInstsBit = 31,
  Feature_FP16DenormalsBit = 115,
  Feature_FP64DenormalsBit = 114,
  Feature_NoFP32DenormalsBit = 79,
  Feature_isWave32Bit = 53,
  Feature_isWave64Bit = 54,
};

PredicateBitset AMDGPUInstructionSelector::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (false)
    Features.set(Feature_FalsePredicateBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS)
    Features.set(Feature_isGFX6Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX6GFX7Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7OnlyBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX6GFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX8GFX9GFX10Bit);
  if (Subtarget->getGeneration() <= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isNotGFX12PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX8GFX9GFX10GFX11Bit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7PlusBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8PlusBit);
  if (Subtarget->getGeneration() ==AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX9PlusBit);
  if (Subtarget->getGeneration() < AMDGPUSubtarget::GFX9)
    Features.set(Feature_isNotGFX9PlusBit);
  if (Subtarget->hasGFX90AInsts())
    Features.set(Feature_isGFX90APlusBit);
  if (!Subtarget->hasGFX90AInsts())
    Features.set(Feature_isNotGFX90APlusBit);
  if (Subtarget->hasMAIInsts() && !Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX908orGFX90ABit);
  if (Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX940PlusBit);
  if (!Subtarget->hasGFX940Insts())
    Features.set(Feature_isNotGFX940PlusBit);
  if (Subtarget->hasGFX950Insts())
    Features.set(Feature_HasGFX950InstsBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX9GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12PlusBit);
  if (Subtarget->hasMinimum3Maximum3F32())
    Features.set(Feature_HasMinimum3Maximum3F32Bit);
  if (Subtarget->hasMinimum3Maximum3F16())
    Features.set(Feature_HasMinimum3Maximum3F16Bit);
  if (Subtarget->hasMinimum3Maximum3PKF16())
    Features.set(Feature_HasMinimum3Maximum3PKF16Bit);
  if (Subtarget->hasFlatAddressSpace())
    Features.set(Feature_HasFlatAddressSpaceBit);
  if (Subtarget->hasFlatBufferGlobalAtomicFaddF64Inst())
    Features.set(Feature_HasFlatBufferGlobalAtomicFaddF64InstBit);
  if (Subtarget->hasAtomicFMinFMaxF32GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF32FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32FlatInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64FlatInstsBit);
  if (Subtarget->hasLdsAtomicAddF64())
    Features.set(Feature_HasLdsAtomicAddF64Bit);
  if (Subtarget->hasFlatGlobalInsts())
    Features.set(Feature_HasFlatGlobalInstsBit);
  if (Subtarget->hasFlatScratchInsts())
    Features.set(Feature_HasFlatScratchInstsBit);
  if (Subtarget->hasD16LoadStore())
    Features.set(Feature_HasD16LoadStoreBit);
  if (Subtarget->hasFlatScratchSVSMode())
    Features.set(Feature_HasFlatScratchSVSModeBit);
  if (Subtarget->hasGFX10_BEncoding())
    Features.set(Feature_HasGFX10_BEncodingBit);
  if (Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasUnpackedD16VMemBit);
  if (!Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasPackedD16VMemBit);
  if (!Subtarget->hasRestrictedSOffset())
    Features.set(Feature_HasUnrestrictedSOffsetBit);
  if (Subtarget->d16PreservesUnusedBits())
    Features.set(Feature_D16PreservesUnusedBitsBit);
  if (Subtarget->ldsRequiresM0Init())
    Features.set(Feature_LDSRequiresM0InitBit);
  if (!Subtarget->ldsRequiresM0Init())
    Features.set(Feature_NotLDSRequiresM0InitBit);
  if (Subtarget->hasExportInsts())
    Features.set(Feature_HasExportInstsBit);
  if (Subtarget->hasLDSFPAtomicAddF32())
    Features.set(Feature_HasLDSFPAtomicAddF32Bit);
  if (Subtarget->hasAddNoCarry())
    Features.set(Feature_HasAddNoCarryInstsBit);
  if (!Subtarget->hasAddNoCarry())
    Features.set(Feature_NotHasAddNoCarryInstsBit);
  if (Subtarget->isXNACKEnabled())
    Features.set(Feature_HasXNACKEnabledBit);
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasTrue16BitInsts())
    Features.set(Feature_NotHasTrue16BitInstsBit);
  if (Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseRealTrue16InstsBit);
  if (Subtarget->hasTrue16BitInsts() && !Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseFakeTrue16InstsBit);
  if (Subtarget->hasVOP3PInsts())
    Features.set(Feature_HasVOP3PInstsBit);
  if (Subtarget->hasMed3_16())
    Features.set(Feature_HasMed3_16Bit);
  if (Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_HasMinMaxDenormModesBit);
  if (!Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_NotHasMinMaxDenormModesBit);
  if (Subtarget->hasSDWA())
    Features.set(Feature_HasSDWABit);
  if (Subtarget->hasPackedFP32Ops())
    Features.set(Feature_HasPackedFP32OpsBit);
  if (Subtarget->hasImageInsts())
    Features.set(Feature_HasImageInstsBit);
  if (Subtarget->hasIntClamp())
    Features.set(Feature_HasIntClampBit);
  if (Subtarget->hasMadMixInsts())
    Features.set(Feature_HasMadMixInstsBit);
  if (Subtarget->hasScalarStores())
    Features.set(Feature_HasScalarStoresBit);
  if (Subtarget->getLDSBankCount() == 16)
    Features.set(Feature_has16BankLDSBit);
  if (Subtarget->getLDSBankCount() == 32)
    Features.set(Feature_has32BankLDSBit);
  if (Subtarget->hasFmaMixInsts())
    Features.set(Feature_HasFmaMixInstsBit);
  if (Subtarget->hasDLInsts())
    Features.set(Feature_HasDLInstsBit);
  if (Subtarget->hasFmacF64Inst())
    Features.set(Feature_HasFmacF64InstBit);
  if (Subtarget->hasDot1Insts())
    Features.set(Feature_HasDot1InstsBit);
  if (Subtarget->hasDot2Insts())
    Features.set(Feature_HasDot2InstsBit);
  if (Subtarget->hasDot3Insts())
    Features.set(Feature_HasDot3InstsBit);
  if (Subtarget->hasDot4Insts())
    Features.set(Feature_HasDot4InstsBit);
  if (Subtarget->hasDot5Insts())
    Features.set(Feature_HasDot5InstsBit);
  if (Subtarget->hasDot6Insts())
    Features.set(Feature_HasDot6InstsBit);
  if (Subtarget->hasDot7Insts())
    Features.set(Feature_HasDot7InstsBit);
  if (Subtarget->hasDot8Insts())
    Features.set(Feature_HasDot8InstsBit);
  if (Subtarget->hasDot9Insts())
    Features.set(Feature_HasDot9InstsBit);
  if (Subtarget->hasDot10Insts())
    Features.set(Feature_HasDot10InstsBit);
  if (Subtarget->hasDot11Insts())
    Features.set(Feature_HasDot11InstsBit);
  if (Subtarget->hasGetWaveIdInst())
    Features.set(Feature_HasGetWaveIdInstBit);
  if (Subtarget->hasMAIInsts())
    Features.set(Feature_HasMAIInstsBit);
  if (Subtarget->hasSMemRealTime())
    Features.set(Feature_HasSMemRealTimeBit);
  if (Subtarget->hasSMemTimeInst())
    Features.set(Feature_HasSMemTimeInstBit);
  if (Subtarget->hasShaderCyclesRegister())
    Features.set(Feature_HasShaderCyclesRegisterBit);
  if (Subtarget->hasShaderCyclesHiLoRegisters())
    Features.set(Feature_HasShaderCyclesHiLoRegistersBit);
  if (Subtarget->hasFP8Insts())
    Features.set(Feature_HasFP8InstsBit);
  if (Subtarget->hasFP8ConversionInsts())
    Features.set(Feature_HasFP8ConversionInstsBit);
  if (Subtarget->hasMadMacF32Insts())
    Features.set(Feature_HasMadMacF32InstsBit);
  if (Subtarget->hasGFX10_3Insts())
    Features.set(Feature_HasFmaLegacy32Bit);
  if (Subtarget->hasAtomicDsPkAdd16Insts())
    Features.set(Feature_HasAtomicDsPkAdd16InstsBit);
  if (Subtarget->hasAtomicFlatPkAdd16Insts())
    Features.set(Feature_HasAtomicFlatPkAdd16InstsBit);
  if (Subtarget->hasAtomicFaddRtnInsts())
    Features.set(Feature_HasAtomicFaddRtnInstsBit);
  if (Subtarget->hasAtomicFaddNoRtnInsts())
    Features.set(Feature_HasAtomicFaddNoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16NoRtnInsts() || Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16InstsBit);
  if (Subtarget->hasFlatAtomicFaddF32Inst())
    Features.set(Feature_HasFlatAtomicFaddF32InstBit);
  if (Subtarget->enableFlatScratch())
    Features.set(Feature_EnableFlatScratchBit);
  if (!Subtarget->enableFlatScratch())
    Features.set(Feature_DisableFlatScratchBit);
  if (Subtarget->hasUnalignedAccessMode())
    Features.set(Feature_HasUnalignedAccessModeBit);
  if (Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasMADIntraFwdBugBit);
  if (!Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasNotMADIntraFwdBugBit);
  if (Subtarget->hasSALUFloatInsts())
    Features.set(Feature_HasSALUFloatInstsBit);
  if (!Subtarget->hasSALUFloatInsts())
    Features.set(Feature_NotHasSALUFloatInstsBit);
  if (Subtarget->hasPseudoScalarTrans())
    Features.set(Feature_HasPseudoScalarTransBit);
  if (Subtarget->hasBitOp3Insts())
    Features.set(Feature_HasBitOp3InstsBit);
  if (Subtarget->hasPrngInst())
    Features.set(Feature_HasPrngInstBit);
  if (Subtarget->hasFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasF16BF16ToFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasCvtPkF16F32Inst())
    Features.set(Feature_HasCvtPkF16F32InstBit);
  if (Subtarget->hasF32ToF16BF16ConversionSRInsts())
    Features.set(Feature_HasF32ToF16BF16ConversionSRInstsBit);
  if (Subtarget->hasGDS())
    Features.set(Feature_HasGDSBit);
  if (Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasCvtFP8VOP1BugBit);
  if (!Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasNoCvtFP8VOP1BugBit);
  if (Subtarget->hasAtomicCSubNoRtnInsts())
    Features.set(Feature_HasAtomicCSubNoRtnInstsBit);
  if (Subtarget->hasXF32Insts())
    Features.set(Feature_HasXF32InstsBit);
  if (Subtarget->hasAshrPkInsts())
    Features.set(Feature_HasAshrPkInstsBit);
  if (Subtarget->isWave32())
    Features.set(Feature_isWave32Bit);
  if (Subtarget->isWave64())
    Features.set(Feature_isWave64Bit);
  return Features;
}

void AMDGPUInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUInstructionSelector::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP16DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP64DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP32Denormals == DenormalMode::getPreserveSign())
    Features.set(Feature_NoFP32DenormalsBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_DisableFlatScratch,
  GIFBS_Has16BitInsts,
  GIFBS_HasAddNoCarryInsts,
  GIFBS_HasAshrPkInsts,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts,
  GIFBS_HasAtomicCSubNoRtnInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts,
  GIFBS_HasAtomicFaddNoRtnInsts,
  GIFBS_HasAtomicFaddRtnInsts,
  GIFBS_HasAtomicFlatPkAdd16Insts,
  GIFBS_HasBitOp3Insts,
  GIFBS_HasCvtPkF16F32Inst,
  GIFBS_HasD16LoadStore,
  GIFBS_HasDLInsts,
  GIFBS_HasDot10Insts,
  GIFBS_HasDot1Insts,
  GIFBS_HasDot2Insts,
  GIFBS_HasDot3Insts,
  GIFBS_HasDot4Insts,
  GIFBS_HasDot5Insts,
  GIFBS_HasDot6Insts,
  GIFBS_HasDot7Insts,
  GIFBS_HasDot8Insts,
  GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts,
  GIFBS_HasF32ToF16BF16ConversionSRInsts,
  GIFBS_HasFP6BF6ConversionScaleInsts,
  GIFBS_HasFP8Insts,
  GIFBS_HasFlatAddressSpace,
  GIFBS_HasFlatAtomicFaddF32Inst,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst,
  GIFBS_HasFlatGlobalInsts,
  GIFBS_HasFmaLegacy32,
  GIFBS_HasFmaMixInsts,
  GIFBS_HasFmacF64Inst,
  GIFBS_HasGDS,
  GIFBS_HasGFX10_BEncoding,
  GIFBS_HasGFX950Insts,
  GIFBS_HasGetWaveIdInst,
  GIFBS_HasIntClamp,
  GIFBS_HasLdsAtomicAddF64,
  GIFBS_HasMAIInsts,
  GIFBS_HasMadMacF32Insts,
  GIFBS_HasMinMaxDenormModes,
  GIFBS_HasMinimum3Maximum3F32,
  GIFBS_HasMinimum3Maximum3PKF16,
  GIFBS_HasPackedD16VMem,
  GIFBS_HasPackedFP32Ops,
  GIFBS_HasPrngInst,
  GIFBS_HasPseudoScalarTrans,
  GIFBS_HasSALUFloatInsts,
  GIFBS_HasSMemRealTime,
  GIFBS_HasSMemTimeInst,
  GIFBS_HasShaderCyclesHiLoRegisters,
  GIFBS_HasShaderCyclesRegister,
  GIFBS_HasUnpackedD16VMem,
  GIFBS_HasUnrestrictedSOffset,
  GIFBS_HasVOP3PInsts,
  GIFBS_HasXF32Insts,
  GIFBS_HasXNACKEnabled,
  GIFBS_LDSRequiresM0Init,
  GIFBS_NotHasAddNoCarryInsts,
  GIFBS_NotHasTrue16BitInsts,
  GIFBS_NotLDSRequiresM0Init,
  GIFBS_UseFakeTrue16Insts,
  GIFBS_UseRealTrue16Insts,
  GIFBS_isGFX10Only,
  GIFBS_isGFX10Plus,
  GIFBS_isGFX11Only,
  GIFBS_isGFX11Plus,
  GIFBS_isGFX12Only,
  GIFBS_isGFX12Plus,
  GIFBS_isGFX6,
  GIFBS_isGFX6GFX7,
  GIFBS_isGFX6GFX7GFX8GFX9,
  GIFBS_isGFX7GFX8GFX9,
  GIFBS_isGFX7Only,
  GIFBS_isGFX7Plus,
  GIFBS_isGFX8GFX9,
  GIFBS_isGFX8GFX9GFX10GFX11,
  GIFBS_isGFX8Plus,
  GIFBS_isGFX908orGFX90A,
  GIFBS_isGFX90APlus,
  GIFBS_isGFX940Plus,
  GIFBS_isGFX9GFX10,
  GIFBS_isGFX9Plus,
  GIFBS_isNotGFX12Plus,
  GIFBS_isNotGFX90APlus,
  GIFBS_isNotGFX940Plus,
  GIFBS_isNotGFX9Plus,
  GIFBS_isWave32,
  GIFBS_isWave64,
  GIFBS_DisableFlatScratch_HasD16LoadStore,
  GIFBS_DisableFlatScratch_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts,
  GIFBS_FP16Denormals_NotHasMinMaxDenormModes,
  GIFBS_FalsePredicate_NotHasMinMaxDenormModes,
  GIFBS_Has16BitInsts_HasIntClamp,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8Only,
  GIFBS_Has16BitInsts_isNotGFX90APlus,
  GIFBS_HasAddNoCarryInsts_HasIntClamp,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus,
  GIFBS_HasAtomicDsPkAdd16Insts_HasGDS,
  GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init,
  GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts,
  GIFBS_HasDot11Insts_isGFX12Plus,
  GIFBS_HasDot9Insts_NotHasTrue16BitInsts,
  GIFBS_HasDot9Insts_UseFakeTrue16Insts,
  GIFBS_HasDot9Insts_UseRealTrue16Insts,
  GIFBS_HasExportInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_HasSDWA,
  GIFBS_HasFP8ConversionInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_isGFX940Plus,
  GIFBS_HasFP8ConversionInsts_isGFX9Plus,
  GIFBS_HasFP8Insts_isGFX90APlus,
  GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts,
  GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts,
  GIFBS_HasFlatAddressSpace_isGFX12Plus,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset,
  GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts,
  GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts,
  GIFBS_HasFlatGlobalInsts_isGFX12Plus,
  GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts,
  GIFBS_HasFmaMixInsts_UseFakeTrue16Insts,
  GIFBS_HasFmaMixInsts_UseRealTrue16Insts,
  GIFBS_HasGDS_HasLDSFPAtomicAddF32,
  GIFBS_HasGDS_isGFX11Plus,
  GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_HasGFX950Insts_isGFX90APlus,
  GIFBS_HasImageInsts_isGFX12Plus,
  GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init,
  GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init,
  GIFBS_HasMADIntraFwdBug_isGFX11Only,
  GIFBS_HasMAIInsts_isGFX90APlus,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals,
  GIFBS_HasMadMixInsts_NoFP32Denormals,
  GIFBS_HasMed3_16_NotHasTrue16BitInsts,
  GIFBS_HasMed3_16_UseFakeTrue16Insts,
  GIFBS_HasMed3_16_UseRealTrue16Insts,
  GIFBS_HasMinMaxDenormModes_isGFX12Plus,
  GIFBS_HasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_HasNotMADIntraFwdBug_isGFX9Plus,
  GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset,
  GIFBS_HasScalarStores_isGFX8Plus,
  GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init,
  GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init,
  GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts,
  GIFBS_HasVOP3PInsts_UseFakeTrue16Insts,
  GIFBS_HasVOP3PInsts_UseRealTrue16Insts,
  GIFBS_HasXF32Insts_isGFX90APlus,
  GIFBS_HasXNACKEnabled_isGFX7Only,
  GIFBS_HasXNACKEnabled_isGFX9Plus,
  GIFBS_HasXNACKEnabled_isNotGFX9Plus,
  GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_LDSRequiresM0Init_isGFX7Plus,
  GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init,
  GIFBS_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX12Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX8Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX9Plus,
  GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_NotLDSRequiresM0Init_isGFX7Plus,
  GIFBS_UseFakeTrue16Insts_isGFX10Plus,
  GIFBS_UseFakeTrue16Insts_isGFX12Plus,
  GIFBS_UseFakeTrue16Insts_isGFX8Plus,
  GIFBS_UseFakeTrue16Insts_isGFX9Plus,
  GIFBS_UseRealTrue16Insts_isGFX10Plus,
  GIFBS_UseRealTrue16Insts_isGFX12Plus,
  GIFBS_UseRealTrue16Insts_isGFX8Plus,
  GIFBS_UseRealTrue16Insts_isGFX9Plus,
  GIFBS_has16BankLDS_isNotGFX90APlus,
  GIFBS_has32BankLDS_isNotGFX90APlus,
  GIFBS_isGFX11Only_isWave32,
  GIFBS_isGFX11Only_isWave64,
  GIFBS_isGFX12Plus_isWave32,
  GIFBS_isGFX12Plus_isWave64,
  GIFBS_isGFX90APlus_isGFX908orGFX90A,
  GIFBS_isGFX90APlus_isGFX940Plus,
  GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts,
  GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts,
  GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus,
  GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10,
  GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_DisableFlatScratchBit, },
  {Feature_Has16BitInstsBit, },
  {Feature_HasAddNoCarryInstsBit, },
  {Feature_HasAshrPkInstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, },
  {Feature_HasAtomicFaddRtnInstsBit, },
  {Feature_HasAtomicFlatPkAdd16InstsBit, },
  {Feature_HasBitOp3InstsBit, },
  {Feature_HasCvtPkF16F32InstBit, },
  {Feature_HasD16LoadStoreBit, },
  {Feature_HasDLInstsBit, },
  {Feature_HasDot10InstsBit, },
  {Feature_HasDot1InstsBit, },
  {Feature_HasDot2InstsBit, },
  {Feature_HasDot3InstsBit, },
  {Feature_HasDot4InstsBit, },
  {Feature_HasDot5InstsBit, },
  {Feature_HasDot6InstsBit, },
  {Feature_HasDot7InstsBit, },
  {Feature_HasDot8InstsBit, },
  {Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit, },
  {Feature_HasF32ToF16BF16ConversionSRInstsBit, },
  {Feature_HasFP6BF6ConversionScaleInstsBit, },
  {Feature_HasFP8InstsBit, },
  {Feature_HasFlatAddressSpaceBit, },
  {Feature_HasFlatAtomicFaddF32InstBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, },
  {Feature_HasFlatGlobalInstsBit, },
  {Feature_HasFmaLegacy32Bit, },
  {Feature_HasFmaMixInstsBit, },
  {Feature_HasFmacF64InstBit, },
  {Feature_HasGDSBit, },
  {Feature_HasGFX10_BEncodingBit, },
  {Feature_HasGFX950InstsBit, },
  {Feature_HasGetWaveIdInstBit, },
  {Feature_HasIntClampBit, },
  {Feature_HasLdsAtomicAddF64Bit, },
  {Feature_HasMAIInstsBit, },
  {Feature_HasMadMacF32InstsBit, },
  {Feature_HasMinMaxDenormModesBit, },
  {Feature_HasMinimum3Maximum3F32Bit, },
  {Feature_HasMinimum3Maximum3PKF16Bit, },
  {Feature_HasPackedD16VMemBit, },
  {Feature_HasPackedFP32OpsBit, },
  {Feature_HasPrngInstBit, },
  {Feature_HasPseudoScalarTransBit, },
  {Feature_HasSALUFloatInstsBit, },
  {Feature_HasSMemRealTimeBit, },
  {Feature_HasSMemTimeInstBit, },
  {Feature_HasShaderCyclesHiLoRegistersBit, },
  {Feature_HasShaderCyclesRegisterBit, },
  {Feature_HasUnpackedD16VMemBit, },
  {Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasVOP3PInstsBit, },
  {Feature_HasXF32InstsBit, },
  {Feature_HasXNACKEnabledBit, },
  {Feature_LDSRequiresM0InitBit, },
  {Feature_NotHasAddNoCarryInstsBit, },
  {Feature_NotHasTrue16BitInstsBit, },
  {Feature_NotLDSRequiresM0InitBit, },
  {Feature_UseFakeTrue16InstsBit, },
  {Feature_UseRealTrue16InstsBit, },
  {Feature_isGFX10OnlyBit, },
  {Feature_isGFX10PlusBit, },
  {Feature_isGFX11OnlyBit, },
  {Feature_isGFX11PlusBit, },
  {Feature_isGFX12OnlyBit, },
  {Feature_isGFX12PlusBit, },
  {Feature_isGFX6Bit, },
  {Feature_isGFX6GFX7Bit, },
  {Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_isGFX7GFX8GFX9Bit, },
  {Feature_isGFX7OnlyBit, },
  {Feature_isGFX7PlusBit, },
  {Feature_isGFX8GFX9Bit, },
  {Feature_isGFX8GFX9GFX10GFX11Bit, },
  {Feature_isGFX8PlusBit, },
  {Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, },
  {Feature_isGFX940PlusBit, },
  {Feature_isGFX9GFX10Bit, },
  {Feature_isGFX9PlusBit, },
  {Feature_isNotGFX12PlusBit, },
  {Feature_isNotGFX90APlusBit, },
  {Feature_isNotGFX940PlusBit, },
  {Feature_isNotGFX9PlusBit, },
  {Feature_isWave32Bit, },
  {Feature_isWave64Bit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, },
  {Feature_DisableFlatScratchBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, },
  {Feature_FP16DenormalsBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_FalsePredicateBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_Has16BitInstsBit, Feature_HasIntClampBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8OnlyBit, },
  {Feature_Has16BitInstsBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasAddNoCarryInstsBit, Feature_HasIntClampBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_HasGDSBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFMinFMaxF64FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasCvtFP8VOP1BugBit, Feature_HasFP8ConversionInstsBit, },
  {Feature_HasDot11InstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasDot9InstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasExportInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasSDWABit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX940PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX9PlusBit, },
  {Feature_HasFP8InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_isGFX12PlusBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFmaMixInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasGDSBit, Feature_HasLDSFPAtomicAddF32Bit, },
  {Feature_HasGDSBit, Feature_isGFX11PlusBit, },
  {Feature_HasGDSBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_HasGFX950InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasImageInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasMADIntraFwdBugBit, Feature_isGFX11OnlyBit, },
  {Feature_HasMAIInstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMed3_16Bit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_HasNotMADIntraFwdBugBit, Feature_isGFX9PlusBit, },
  {Feature_HasPackedD16VMemBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasScalarStoresBit, Feature_isGFX8PlusBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasVOP3PInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasXF32InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX7OnlyBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX9PlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isNotGFX9PlusBit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX12PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX8PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX9PlusBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseRealTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_has16BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_isGFX11OnlyBit, Feature_isWave32Bit, },
  {Feature_isGFX11OnlyBit, Feature_isWave64Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave32Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave64Bit, },
  {Feature_isGFX90APlusBit, Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, Feature_isGFX940PlusBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatAddressSpaceBit, Feature_UseRealTrue16InstsBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatGlobalInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_Has16BitInstsBit, Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasNoCvtFP8VOP1BugBit, Feature_HasSDWABit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, Feature_isGFX6GFX7GFX10Bit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_buf_soffset,
  GICP_gi_ds_128bit_8byte_aligned,
  GICP_gi_ds_1addr_1offset,
  GICP_gi_ds_64bit_4byte_aligned,
  GICP_gi_flat_offset,
  GICP_gi_flat_scratch_offset,
  GICP_gi_flat_scratch_saddr,
  GICP_gi_flat_scratch_svaddr,
  GICP_gi_global_offset,
  GICP_gi_global_saddr,
  GICP_gi_mubuf_addr64,
  GICP_gi_mubuf_offset,
  GICP_gi_mubuf_scratch_offen,
  GICP_gi_mubuf_scratch_offset,
  GICP_gi_smrd_buffer_imm,
  GICP_gi_smrd_buffer_imm32,
  GICP_gi_smrd_buffer_sgpr_imm,
  GICP_gi_smrd_imm,
  GICP_gi_smrd_imm32,
  GICP_gi_smrd_sgpr,
  GICP_gi_smrd_sgpr_imm,
  GICP_gi_swmmacindex16,
  GICP_gi_swmmacindex8,
  GICP_gi_vcsrc,
  GICP_gi_vinterpmods,
  GICP_gi_vinterpmods_hi,
  GICP_gi_vop3_mad_mix_mods,
  GICP_gi_vop3_mad_mix_mods_ext,
  GICP_gi_vop3_no_mods,
  GICP_gi_vop3mods,
  GICP_gi_vop3mods0,
  GICP_gi_vop3modsnoncanonicalizing,
  GICP_gi_vop3omods,
  GICP_gi_vop3opsel,
  GICP_gi_vop3opselmods,
  GICP_gi_vop3pmods,
  GICP_gi_vop3pmodsdot,
  GICP_gi_vop3pmodsneg,
  GICP_gi_vsrc0,
  GICP_gi_wmmamods,
  GICP_gi_wmmamodsf16Neg,
  GICP_gi_wmmamodsf16NegAbs,
  GICP_gi_wmmaopselvop3pmods,
  GICP_gi_wmmavisrc,
};
// See constructor for table contents

AMDGPUInstructionSelector::ComplexMatcherMemFn
AMDGPUInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AMDGPUInstructionSelector::selectBUFSOffset, // gi_buf_soffset
  &AMDGPUInstructionSelector::selectDS128Bit8ByteAligned, // gi_ds_128bit_8byte_aligned
  &AMDGPUInstructionSelector::selectDS1Addr1Offset, // gi_ds_1addr_1offset
  &AMDGPUInstructionSelector::selectDS64Bit4ByteAligned, // gi_ds_64bit_4byte_aligned
  &AMDGPUInstructionSelector::selectFlatOffset, // gi_flat_offset
  &AMDGPUInstructionSelector::selectScratchOffset, // gi_flat_scratch_offset
  &AMDGPUInstructionSelector::selectScratchSAddr, // gi_flat_scratch_saddr
  &AMDGPUInstructionSelector::selectScratchSVAddr, // gi_flat_scratch_svaddr
  &AMDGPUInstructionSelector::selectGlobalOffset, // gi_global_offset
  &AMDGPUInstructionSelector::selectGlobalSAddr, // gi_global_saddr
  &AMDGPUInstructionSelector::selectMUBUFAddr64, // gi_mubuf_addr64
  &AMDGPUInstructionSelector::selectMUBUFOffset, // gi_mubuf_offset
  &AMDGPUInstructionSelector::selectMUBUFScratchOffen, // gi_mubuf_scratch_offen
  &AMDGPUInstructionSelector::selectMUBUFScratchOffset, // gi_mubuf_scratch_offset
  &AMDGPUInstructionSelector::selectSMRDBufferImm, // gi_smrd_buffer_imm
  &AMDGPUInstructionSelector::selectSMRDBufferImm32, // gi_smrd_buffer_imm32
  &AMDGPUInstructionSelector::selectSMRDBufferSgprImm, // gi_smrd_buffer_sgpr_imm
  &AMDGPUInstructionSelector::selectSmrdImm, // gi_smrd_imm
  &AMDGPUInstructionSelector::selectSmrdImm32, // gi_smrd_imm32
  &AMDGPUInstructionSelector::selectSmrdSgpr, // gi_smrd_sgpr
  &AMDGPUInstructionSelector::selectSmrdSgprImm, // gi_smrd_sgpr_imm
  &AMDGPUInstructionSelector::selectSWMMACIndex16, // gi_swmmacindex16
  &AMDGPUInstructionSelector::selectSWMMACIndex8, // gi_swmmacindex8
  &AMDGPUInstructionSelector::selectVCSRC, // gi_vcsrc
  &AMDGPUInstructionSelector::selectVINTERPMods, // gi_vinterpmods
  &AMDGPUInstructionSelector::selectVINTERPModsHi, // gi_vinterpmods_hi
  &AMDGPUInstructionSelector::selectVOP3PMadMixMods, // gi_vop3_mad_mix_mods
  &AMDGPUInstructionSelector::selectVOP3PMadMixModsExt, // gi_vop3_mad_mix_mods_ext
  &AMDGPUInstructionSelector::selectVOP3NoMods, // gi_vop3_no_mods
  &AMDGPUInstructionSelector::selectVOP3Mods, // gi_vop3mods
  &AMDGPUInstructionSelector::selectVOP3Mods0, // gi_vop3mods0
  &AMDGPUInstructionSelector::selectVOP3ModsNonCanonicalizing, // gi_vop3modsnoncanonicalizing
  &AMDGPUInstructionSelector::selectVOP3OMods, // gi_vop3omods
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opsel
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opselmods
  &AMDGPUInstructionSelector::selectVOP3PMods, // gi_vop3pmods
  &AMDGPUInstructionSelector::selectVOP3PModsDOT, // gi_vop3pmodsdot
  &AMDGPUInstructionSelector::selectVOP3PModsNeg, // gi_vop3pmodsneg
  &AMDGPUInstructionSelector::selectVSRC0, // gi_vsrc0
  &AMDGPUInstructionSelector::selectWMMAModsF32NegAbs, // gi_wmmamods
  &AMDGPUInstructionSelector::selectWMMAModsF16Neg, // gi_wmmamodsf16Neg
  &AMDGPUInstructionSelector::selectWMMAModsF16NegAbs, // gi_wmmamodsf16NegAbs
  &AMDGPUInstructionSelector::selectWMMAOpSelVOP3PMods, // gi_wmmaopselvop3pmods
  &AMDGPUInstructionSelector::selectWMMAVISrc, // gi_wmmavisrc
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_aligned_smrd_load = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_anonymous_13722,
  GICXXPred_MI_Predicate_anonymous_13725,
  GICXXPred_MI_Predicate_anonymous_13726,
  GICXXPred_MI_Predicate_anonymous_13727,
  GICXXPred_MI_Predicate_anonymous_13728,
  GICXXPred_MI_Predicate_anonymous_13729,
  GICXXPred_MI_Predicate_anonymous_13732,
  GICXXPred_MI_Predicate_anonymous_13733,
  GICXXPred_MI_Predicate_anonymous_13734,
  GICXXPred_MI_Predicate_anonymous_13735,
  GICXXPred_MI_Predicate_anonymous_13736,
  GICXXPred_MI_Predicate_anonymous_13737,
  GICXXPred_MI_Predicate_anonymous_13738,
  GICXXPred_MI_Predicate_anonymous_13739,
  GICXXPred_MI_Predicate_anonymous_13740,
  GICXXPred_MI_Predicate_anonymous_13741,
  GICXXPred_MI_Predicate_anonymous_13742,
  GICXXPred_MI_Predicate_anonymous_13743,
  GICXXPred_MI_Predicate_anonymous_13744,
  GICXXPred_MI_Predicate_anonymous_13745,
  GICXXPred_MI_Predicate_anonymous_13746,
  GICXXPred_MI_Predicate_anonymous_13747,
  GICXXPred_MI_Predicate_anonymous_13748,
  GICXXPred_MI_Predicate_anonymous_13749,
  GICXXPred_MI_Predicate_anonymous_13750,
  GICXXPred_MI_Predicate_anonymous_13751,
  GICXXPred_MI_Predicate_anonymous_13752,
  GICXXPred_MI_Predicate_anonymous_13753,
  GICXXPred_MI_Predicate_anonymous_13754,
  GICXXPred_MI_Predicate_anonymous_13755,
  GICXXPred_MI_Predicate_anonymous_13756,
  GICXXPred_MI_Predicate_anonymous_13757,
  GICXXPred_MI_Predicate_anonymous_13758,
  GICXXPred_MI_Predicate_anonymous_13759,
  GICXXPred_MI_Predicate_anonymous_13760,
  GICXXPred_MI_Predicate_anonymous_13761,
  GICXXPred_MI_Predicate_anonymous_13762,
  GICXXPred_MI_Predicate_anonymous_13763,
  GICXXPred_MI_Predicate_anonymous_13764,
  GICXXPred_MI_Predicate_anonymous_13765,
  GICXXPred_MI_Predicate_anonymous_13766,
  GICXXPred_MI_Predicate_anonymous_13767,
  GICXXPred_MI_Predicate_anonymous_13768,
  GICXXPred_MI_Predicate_anonymous_13769,
  GICXXPred_MI_Predicate_anonymous_13770,
  GICXXPred_MI_Predicate_anonymous_13771,
  GICXXPred_MI_Predicate_anonymous_13772,
  GICXXPred_MI_Predicate_anonymous_13773,
  GICXXPred_MI_Predicate_anonymous_13780,
  GICXXPred_MI_Predicate_anonymous_13792,
  GICXXPred_MI_Predicate_anonymous_18332,
  GICXXPred_MI_Predicate_anonymous_19250,
  GICXXPred_MI_Predicate_anonymous_19252,
  GICXXPred_MI_Predicate_anonymous_19645,
  GICXXPred_MI_Predicate_anonymous_19647,
  GICXXPred_MI_Predicate_anonymous_19649,
  GICXXPred_MI_Predicate_anonymous_19651,
  GICXXPred_MI_Predicate_anonymous_19653,
  GICXXPred_MI_Predicate_anonymous_19657,
  GICXXPred_MI_Predicate_anonymous_19659,
  GICXXPred_MI_Predicate_anonymous_19661,
  GICXXPred_MI_Predicate_anonymous_19663,
  GICXXPred_MI_Predicate_anonymous_19665,
  GICXXPred_MI_Predicate_anonymous_19900,
  GICXXPred_MI_Predicate_anonymous_19902,
  GICXXPred_MI_Predicate_anonymous_20143,
  GICXXPred_MI_Predicate_anonymous_20153,
  GICXXPred_MI_Predicate_anonymous_20156,
  GICXXPred_MI_Predicate_anonymous_20318,
  GICXXPred_MI_Predicate_anonymous_20775,
  GICXXPred_MI_Predicate_anonymous_20778,
  GICXXPred_MI_Predicate_anonymous_20781,
  GICXXPred_MI_Predicate_anonymous_20783,
  GICXXPred_MI_Predicate_anonymous_20786,
  GICXXPred_MI_Predicate_anonymous_20788,
  GICXXPred_MI_Predicate_anonymous_20791,
  GICXXPred_MI_Predicate_anonymous_20794,
  GICXXPred_MI_Predicate_anonymous_20798,
  GICXXPred_MI_Predicate_anonymous_20810,
  GICXXPred_MI_Predicate_anonymous_21221,
  GICXXPred_MI_Predicate_anonymous_21494,
  GICXXPred_MI_Predicate_anonymous_21497,
  GICXXPred_MI_Predicate_anonymous_21499,
  GICXXPred_MI_Predicate_anonymous_21501,
  GICXXPred_MI_Predicate_anonymous_21503,
  GICXXPred_MI_Predicate_anonymous_21505,
  GICXXPred_MI_Predicate_anonymous_21507,
  GICXXPred_MI_Predicate_anonymous_23209,
  GICXXPred_MI_Predicate_anonymous_23211,
  GICXXPred_MI_Predicate_anonymous_23215,
  GICXXPred_MI_Predicate_anonymous_23217,
  GICXXPred_MI_Predicate_anonymous_23219,
  GICXXPred_MI_Predicate_anonymous_23221,
  GICXXPred_MI_Predicate_anonymous_23225,
  GICXXPred_MI_Predicate_anonymous_23227,
  GICXXPred_MI_Predicate_anonymous_23229,
  GICXXPred_MI_Predicate_anonymous_23231,
  GICXXPred_MI_Predicate_anonymous_23233,
  GICXXPred_MI_Predicate_anonymous_23235,
  GICXXPred_MI_Predicate_anonymous_23237,
  GICXXPred_MI_Predicate_anonymous_23239,
  GICXXPred_MI_Predicate_anonymous_23243,
  GICXXPred_MI_Predicate_anonymous_23245,
  GICXXPred_MI_Predicate_anonymous_23247,
  GICXXPred_MI_Predicate_anonymous_23249,
  GICXXPred_MI_Predicate_anonymous_23253,
  GICXXPred_MI_Predicate_anonymous_23255,
  GICXXPred_MI_Predicate_anonymous_23259,
  GICXXPred_MI_Predicate_anonymous_23261,
  GICXXPred_MI_Predicate_anonymous_23263,
  GICXXPred_MI_Predicate_anonymous_23265,
  GICXXPred_MI_Predicate_anonymous_23269,
  GICXXPred_MI_Predicate_anonymous_23271,
  GICXXPred_MI_Predicate_anonymous_23273,
  GICXXPred_MI_Predicate_anonymous_23275,
  GICXXPred_MI_Predicate_anonymous_23277,
  GICXXPred_MI_Predicate_anonymous_23279,
  GICXXPred_MI_Predicate_anonymous_23281,
  GICXXPred_MI_Predicate_anonymous_23283,
  GICXXPred_MI_Predicate_anonymous_23287,
  GICXXPred_MI_Predicate_anonymous_23289,
  GICXXPred_MI_Predicate_anonymous_23291,
  GICXXPred_MI_Predicate_anonymous_23293,
  GICXXPred_MI_Predicate_anonymous_23297,
  GICXXPred_MI_Predicate_anonymous_23299,
  GICXXPred_MI_Predicate_anonymous_23301,
  GICXXPred_MI_Predicate_anonymous_23303,
  GICXXPred_MI_Predicate_anonymous_23305,
  GICXXPred_MI_Predicate_anonymous_23307,
  GICXXPred_MI_Predicate_anonymous_23311,
  GICXXPred_MI_Predicate_anonymous_23313,
  GICXXPred_MI_Predicate_anonymous_23315,
  GICXXPred_MI_Predicate_anonymous_23317,
  GICXXPred_MI_Predicate_anonymous_23319,
  GICXXPred_MI_Predicate_anonymous_23321,
  GICXXPred_MI_Predicate_anonymous_23325,
  GICXXPred_MI_Predicate_anonymous_23327,
  GICXXPred_MI_Predicate_anonymous_23331,
  GICXXPred_MI_Predicate_anonymous_23333,
  GICXXPred_MI_Predicate_anonymous_23335,
  GICXXPred_MI_Predicate_anonymous_23337,
  GICXXPred_MI_Predicate_anonymous_23357,
  GICXXPred_MI_Predicate_anonymous_23359,
  GICXXPred_MI_Predicate_anonymous_23393,
  GICXXPred_MI_Predicate_anonymous_23395,
  GICXXPred_MI_Predicate_anonymous_23415,
  GICXXPred_MI_Predicate_anonymous_23417,
  GICXXPred_MI_Predicate_anonymous_23455,
  GICXXPred_MI_Predicate_anonymous_23457,
  GICXXPred_MI_Predicate_anonymous_23461,
  GICXXPred_MI_Predicate_anonymous_23463,
  GICXXPred_MI_Predicate_anonymous_23465,
  GICXXPred_MI_Predicate_anonymous_23467,
  GICXXPred_MI_Predicate_anonymous_23469,
  GICXXPred_MI_Predicate_anonymous_23471,
  GICXXPred_MI_Predicate_anonymous_23473,
  GICXXPred_MI_Predicate_anonymous_23475,
  GICXXPred_MI_Predicate_anonymous_23479,
  GICXXPred_MI_Predicate_anonymous_23481,
  GICXXPred_MI_Predicate_anonymous_23483,
  GICXXPred_MI_Predicate_anonymous_23485,
  GICXXPred_MI_Predicate_anonymous_23489,
  GICXXPred_MI_Predicate_anonymous_23491,
  GICXXPred_MI_Predicate_anonymous_23493,
  GICXXPred_MI_Predicate_anonymous_23495,
  GICXXPred_MI_Predicate_anonymous_23497,
  GICXXPred_MI_Predicate_anonymous_23499,
  GICXXPred_MI_Predicate_anonymous_23503,
  GICXXPred_MI_Predicate_anonymous_23505,
  GICXXPred_MI_Predicate_anonymous_23507,
  GICXXPred_MI_Predicate_anonymous_23509,
  GICXXPred_MI_Predicate_anonymous_23511,
  GICXXPred_MI_Predicate_anonymous_23513,
  GICXXPred_MI_Predicate_anonymous_23515,
  GICXXPred_MI_Predicate_anonymous_23517,
  GICXXPred_MI_Predicate_anonymous_23519,
  GICXXPred_MI_Predicate_anonymous_23521,
  GICXXPred_MI_Predicate_anonymous_23525,
  GICXXPred_MI_Predicate_anonymous_23527,
  GICXXPred_MI_Predicate_anonymous_23529,
  GICXXPred_MI_Predicate_anonymous_23531,
  GICXXPred_MI_Predicate_anonymous_23533,
  GICXXPred_MI_Predicate_anonymous_23535,
  GICXXPred_MI_Predicate_anonymous_23537,
  GICXXPred_MI_Predicate_anonymous_23539,
  GICXXPred_MI_Predicate_anonymous_34193,
  GICXXPred_MI_Predicate_anonymous_34508,
  GICXXPred_MI_Predicate_anonymous_34510,
  GICXXPred_MI_Predicate_anonymous_34556,
  GICXXPred_MI_Predicate_anonymous_34569,
  GICXXPred_MI_Predicate_anonymous_34570,
  GICXXPred_MI_Predicate_anonymous_34573,
  GICXXPred_MI_Predicate_anonymous_34576,
  GICXXPred_MI_Predicate_anonymous_34579,
  GICXXPred_MI_Predicate_anonymous_34583,
  GICXXPred_MI_Predicate_anonymous_34586,
  GICXXPred_MI_Predicate_anonymous_34589,
  GICXXPred_MI_Predicate_anonymous_34591,
  GICXXPred_MI_Predicate_anonymous_34592,
  GICXXPred_MI_Predicate_anonymous_34601,
  GICXXPred_MI_Predicate_anonymous_34603,
  GICXXPred_MI_Predicate_anonymous_34611,
  GICXXPred_MI_Predicate_anonymous_34616,
  GICXXPred_MI_Predicate_anonymous_34620,
  GICXXPred_MI_Predicate_anonymous_34624,
  GICXXPred_MI_Predicate_anonymous_34781,
  GICXXPred_MI_Predicate_anonymous_34784,
  GICXXPred_MI_Predicate_anonymous_34789,
  GICXXPred_MI_Predicate_anonymous_34793,
  GICXXPred_MI_Predicate_anonymous_34860,
  GICXXPred_MI_Predicate_anonymous_34862,
  GICXXPred_MI_Predicate_anonymous_34922,
  GICXXPred_MI_Predicate_anonymous_34950,
  GICXXPred_MI_Predicate_anonymous_34952,
  GICXXPred_MI_Predicate_anonymous_34981,
  GICXXPred_MI_Predicate_anonymous_34983,
  GICXXPred_MI_Predicate_anonymous_34985,
  GICXXPred_MI_Predicate_anonymous_34987,
  GICXXPred_MI_Predicate_anonymous_34989,
  GICXXPred_MI_Predicate_bf16_fpround,
  GICXXPred_MI_Predicate_csh_mask_16,
  GICXXPred_MI_Predicate_csh_mask_32,
  GICXXPred_MI_Predicate_csh_mask_64,
  GICXXPred_MI_Predicate_fmaxnum_like_nnan,
  GICXXPred_MI_Predicate_fminnum_like_nnan,
  GICXXPred_MI_Predicate_is_canonicalized,
  GICXXPred_MI_Predicate_load_align_less_than_4_local,
  GICXXPred_MI_Predicate_load_align_less_than_4_local_m0,
  GICXXPred_MI_Predicate_shl1_add,
  GICXXPred_MI_Predicate_shl2_add,
  GICXXPred_MI_Predicate_shl3_add,
  GICXXPred_MI_Predicate_shl4_add,
  GICXXPred_MI_Predicate_shl_0_to_4,
  GICXXPred_MI_Predicate_smrd_extloadi8,
  GICXXPred_MI_Predicate_smrd_extloadi16,
  GICXXPred_MI_Predicate_smrd_load,
  GICXXPred_MI_Predicate_smrd_prefetch,
  GICXXPred_MI_Predicate_smrd_sextloadi8,
  GICXXPred_MI_Predicate_smrd_sextloadi16,
  GICXXPred_MI_Predicate_smrd_zextloadi8,
  GICXXPred_MI_Predicate_smrd_zextloadi16,
  GICXXPred_MI_Predicate_store_align_less_than_4_local,
  GICXXPred_MI_Predicate_store_align_less_than_4_local_m0,
};
bool AMDGPUInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_aligned_smrd_load: {
    
      auto &Ld = cast<GLoad>(MI);
      TypeSize Size = Ld.getMMO().getSize().getValue();
      return Size <= 4 || Ld.getMMO().getAlign().value() >= Size;
      
    llvm_unreachable("aligned_smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_13722: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13725: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13726: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13727: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13728: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13729: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13732: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13733: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13734: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13735: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13736: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13737: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13738: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13739: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13740: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13741: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13742: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13743: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13744: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13745: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13746: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13747: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13748: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13749: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13750: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13751: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13752: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13753: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13754: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13755: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13756: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13757: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13758: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13759: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13760: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13761: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13762: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13763: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13764: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13765: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13766: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13767: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13768: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13769: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13770: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13771: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13772: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13773: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13780: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13792: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_18332: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19250: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19252: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19645: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19647: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19649: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19651: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19653: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19657: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19659: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19661: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19663: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19665: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19900: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19902: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20143: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20153: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20156: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20318: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20775: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20775 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20778: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20778 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20781: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20781 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20783: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20783 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20786: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20786 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20788: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20788 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20791: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20791 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20794: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20794 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20798: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20798 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20810: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20810 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21221: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_21221 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21494: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21497: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21499: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21501: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21503: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21505: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21507: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_23209: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23211: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23215: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23217: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23219: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23221: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23225: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23227: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23229: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23231: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23233: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23235: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23237: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23239: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23243: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23245: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23247: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23249: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23253: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23255: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23259: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23261: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23263: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23265: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23269: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23271: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23273: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23275: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23277: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23279: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23281: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23283: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23287: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23289: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23291: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23293: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23297: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23299: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23301: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23303: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23305: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23307: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23311: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23313: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23315: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23317: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23319: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23321: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23325: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23327: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23331: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23333: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23335: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23337: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23357: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23359: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23393: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23395: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23415: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23417: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23455: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23457: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23461: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23463: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23465: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23467: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23469: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23471: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23473: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23475: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23479: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23481: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23483: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23485: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23489: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23491: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23493: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23495: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23497: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23499: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23503: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23505: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23507: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23509: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23511: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23513: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23515: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23517: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23519: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23521: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23525: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23527: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23529: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23531: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23533: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23535: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23537: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23539: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_34193: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34508: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34510: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34556: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34569: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34570: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34573: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34576: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34579: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34583: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34586: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34589: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34591: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34592: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34601: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34603: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34611: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34616: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34620: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34624: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34781: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34784: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34789: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34793: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34860: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34862: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34922: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF) &&
          TLI->isCanonicalized(MI.getOperand(2).getReg(), MF);
      
    llvm_unreachable("anonymous_34922 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_34950: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34952: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34981: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF);
      
    llvm_unreachable("anonymous_34981 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_34983: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34985: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34987: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34989: {
    return true;
  }
  case GICXXPred_MI_Predicate_bf16_fpround: {
    return false;
  }
  case GICXXPred_MI_Predicate_csh_mask_16: {
     return isUnneededShiftMask(MI, 4); 
  }
  case GICXXPred_MI_Predicate_csh_mask_32: {
     return isUnneededShiftMask(MI, 5); 
  }
  case GICXXPred_MI_Predicate_csh_mask_64: {
     return isUnneededShiftMask(MI, 6); 
  }
  case GICXXPred_MI_Predicate_fmaxnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_fminnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_is_canonicalized: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
            MF.getSubtarget().getTargetLowering());
        const MachineOperand &Dst = MI.getOperand(0);
        assert(Dst.isDef());
        return TLI->isCanonicalized(Dst.getReg(), MF);
       
    llvm_unreachable("is_canonicalized should have returned");
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_shl1_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl2_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl3_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl4_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl_0_to_4: {
    
        int64_t Imm = 0;
        if (!mi_match(MI.getOperand(2).getReg(), MRI, m_ICst(Imm)) &&
            !mi_match(MI.getOperand(2).getReg(), MRI, m_Copy(m_ICst(Imm))))
          return false;
        return (uint64_t)Imm <= 4;
      
    llvm_unreachable("shl_0_to_4 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_load: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_prefetch: {
    
        return isInstrUniform(MI);
      
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_MFMALdScaleModifierOp,
  GICXXPred_I64_Predicate_NegSubInlineConst32,
  GICXXPred_I64_Predicate_NegSubInlineIntConst16,
  GICXXPred_I64_Predicate_SIMM16bit,
  GICXXPred_I64_Predicate_ShiftAmt32Imm,
  GICXXPred_I64_Predicate_SupportedRoundMode,
  GICXXPred_I64_Predicate_i32imm_one,
  GICXXPred_I64_Predicate_i32imm_zero,
  GICXXPred_I64_Predicate_i64imm_32bit,
};
bool AMDGPUInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask: {
    
      return isMask_32(Imm);
    
  }
  case GICXXPred_I64_Predicate_MFMALdScaleModifierOp: {
    
      return isUInt<2>(Imm);
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineConst32: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineIntConst16: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_SIMM16bit: {
    return isInt<16>(Imm) || isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_ShiftAmt32Imm: {
    
      return Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_SupportedRoundMode: {
    
      return Imm == (int)RoundingMode::TowardZero ||
             Imm == (int)RoundingMode::NearestTiesToEven ||
             Imm == (int)RoundingMode::TowardPositive ||
             Imm == (int)RoundingMode::TowardNegative;
    
  }
  case GICXXPred_I64_Predicate_i32imm_one: {
    
      return Imm == 1;
    
  }
  case GICXXPred_I64_Predicate_i32imm_zero: {
    
      return Imm == 0;
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_InlineImmFP32 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_InlineImmFP64,
  GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64,
  GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64,
};
bool AMDGPUInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_InlineImmFP32: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_InlineImmFP64: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64: {
    
        if (!Imm.isNegative())
          return false;
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_neg_pow2_prefer_ldexp_f64 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64: {
    
        if (Imm.isNegative())
          return false;
    
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_pos_pow2_prefer_ldexp_f64 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_InlineImm64 = GICXXPred_Invalid + 1,
};
bool AMDGPUInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_InlineImm64: {
    
      return isInlineImmediate(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderBitcastFPImm32,
  GICR_renderBitcastFPImm64,
  GICR_renderDstSelToOpSel3XFormXForm,
  GICR_renderDstSelToOpSelXForm,
  GICR_renderExtractCPol,
  GICR_renderExtractCpolSetGLC,
  GICR_renderExtractSWZ,
  GICR_renderFPPow2ToExponent,
  GICR_renderFrameIndex,
  GICR_renderNegateImm,
  GICR_renderOpSelTImm,
  GICR_renderPopcntImm,
  GICR_renderRoundMode,
  GICR_renderScaledMAIIntrinsicOperand,
  GICR_renderSrcAndDstSelToOpSelXForm_0_0,
  GICR_renderSrcAndDstSelToOpSelXForm_0_1,
  GICR_renderSrcAndDstSelToOpSelXForm_1_0,
  GICR_renderSrcAndDstSelToOpSelXForm_1_1,
  GICR_renderSrcAndDstSelToOpSelXForm_2_0,
  GICR_renderSrcSelToOpSelXForm,
  GICR_renderTruncTImm,
  GICR_renderZextBoolTImm,
};
AMDGPUInstructionSelector::CustomRendererFn
AMDGPUInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AMDGPUInstructionSelector::renderBitcastFPImm32,
  &AMDGPUInstructionSelector::renderBitcastFPImm64,
  &AMDGPUInstructionSelector::renderDstSelToOpSel3XFormXForm,
  &AMDGPUInstructionSelector::renderDstSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderExtractCPol,
  &AMDGPUInstructionSelector::renderExtractCpolSetGLC,
  &AMDGPUInstructionSelector::renderExtractSWZ,
  &AMDGPUInstructionSelector::renderFPPow2ToExponent,
  &AMDGPUInstructionSelector::renderFrameIndex,
  &AMDGPUInstructionSelector::renderNegateImm,
  &AMDGPUInstructionSelector::renderOpSelTImm,
  &AMDGPUInstructionSelector::renderPopcntImm,
  &AMDGPUInstructionSelector::renderRoundMode,
  &AMDGPUInstructionSelector::renderScaledMAIIntrinsicOperand,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_2_0,
  &AMDGPUInstructionSelector::renderSrcSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderTruncTImm,
  &AMDGPUInstructionSelector::renderZextBoolTImm,
};

bool AMDGPUInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AMDGPUInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(3740), /*)*//*default:*//*Label 167*/ GIMT_Encode4(774204),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(14758),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(38000),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(38623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(38969),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(40370),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(55882), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 6*/ GIMT_Encode4(60574), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 7*/ GIMT_Encode4(60629), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 8*/ GIMT_Encode4(65655), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    138 */ /*TargetOpcode::G_INTRINSIC_FPTRUNC_ROUND*//*Label 9*/ GIMT_Encode4(71484),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(71679), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 11*/ GIMT_Encode4(72007),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 12*/ GIMT_Encode4(72335),
     /*    166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 13*/ GIMT_Encode4(72475),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 14*/ GIMT_Encode4(72533),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 15*/ GIMT_Encode4(140025),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 16*/ GIMT_Encode4(147091), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 17*/ GIMT_Encode4(154072), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 18*/ GIMT_Encode4(187977),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 19*/ GIMT_Encode4(189103),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 20*/ GIMT_Encode4(191315),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 21*/ GIMT_Encode4(193827),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 22*/ GIMT_Encode4(196339), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 23*/ GIMT_Encode4(198851),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 24*/ GIMT_Encode4(201363),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 25*/ GIMT_Encode4(203875),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 26*/ GIMT_Encode4(206387),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 27*/ GIMT_Encode4(208899),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 28*/ GIMT_Encode4(211411),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 29*/ GIMT_Encode4(213923), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 30*/ GIMT_Encode4(216134),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 31*/ GIMT_Encode4(218780),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_UINC_WRAP*//*Label 32*/ GIMT_Encode4(221426),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_UDEC_WRAP*//*Label 33*/ GIMT_Encode4(223938), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(226450),
     /*    290 */ /*TargetOpcode::G_PREFETCH*//*Label 35*/ GIMT_Encode4(226469), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 36*/ GIMT_Encode4(226905),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 37*/ GIMT_Encode4(244173),
     /*    314 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT*//*Label 38*/ GIMT_Encode4(248884),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT_W_SIDE_EFFECTS*//*Label 39*/ GIMT_Encode4(273852),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 40*/ GIMT_Encode4(275103),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 41*/ GIMT_Encode4(275666),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 42*/ GIMT_Encode4(275906),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 43*/ GIMT_Encode4(276632), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 44*/ GIMT_Encode4(276914), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(277717),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(280920),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(282456),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(283618), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(284780),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(285042), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(285119),
     /*    390 */ /*TargetOpcode::G_FCMP*//*Label 52*/ GIMT_Encode4(286711), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 53*/ GIMT_Encode4(290874), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 54*/ GIMT_Encode4(291218),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 55*/ GIMT_Encode4(291327),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 56*/ GIMT_Encode4(291436),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 57*/ GIMT_Encode4(291824),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 58*/ GIMT_Encode4(292150),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 59*/ GIMT_Encode4(292538), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(292864),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(294222),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(294586),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(295972),
     /*    526 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(297841), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FPOW*//*Label 65*/ GIMT_Encode4(298787), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FEXP2*//*Label 66*/ GIMT_Encode4(298905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    562 */ /*TargetOpcode::G_FLOG2*//*Label 67*/ GIMT_Encode4(299128), GIMT_Encode4(0),
     /*    570 */ /*TargetOpcode::G_FLDEXP*//*Label 68*/ GIMT_Encode4(299351), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(299714),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 70*/ GIMT_Encode4(301577),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(301977),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(302913),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(303639),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(304365),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(305098), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(305831),
     /*    618 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 77*/ GIMT_Encode4(306632),
     /*    622 */ /*TargetOpcode::G_IS_FPCLASS*//*Label 78*/ GIMT_Encode4(306995),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 79*/ GIMT_Encode4(307326),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 80*/ GIMT_Encode4(308794),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 81*/ GIMT_Encode4(380573),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 82*/ GIMT_Encode4(452352),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 83*/ GIMT_Encode4(524131),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 84*/ GIMT_Encode4(595910),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 85*/ GIMT_Encode4(598037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    666 */ /*TargetOpcode::G_GET_FPMODE*//*Label 86*/ GIMT_Encode4(600164), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    678 */ /*TargetOpcode::G_PTR_ADD*//*Label 87*/ GIMT_Encode4(600288), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 88*/ GIMT_Encode4(600365),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 89*/ GIMT_Encode4(606729),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 90*/ GIMT_Encode4(613255),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 91*/ GIMT_Encode4(619619),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 92*/ GIMT_Encode4(625983), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 93*/ GIMT_Encode4(626120), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 94*/ GIMT_Encode4(626154), GIMT_Encode4(0),
     /*    770 */ /*TargetOpcode::G_CTLZ_ZERO_UNDEF*//*Label 95*/ GIMT_Encode4(626253),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(626355),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(626570),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(628319),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(628567), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(628895),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(629187), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 102*/ GIMT_Encode4(629701),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 103*/ GIMT_Encode4(630663),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 104*/ GIMT_Encode4(631027), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(632295), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FLDEXP*//*Label 106*/ GIMT_Encode4(633341), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14458 */ /*AMDGPU::G_AMDGPU_ATOMIC_CMPXCHG*//*Label 107*/ GIMT_Encode4(633704),
     /*  14462 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_ADD*//*Label 108*/ GIMT_Encode4(636008),
     /*  14466 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_AND*//*Label 109*/ GIMT_Encode4(638392),
     /*  14470 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_CMPSWAP*//*Label 110*/ GIMT_Encode4(640776),
     /*  14474 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_COND_SUB_U32*//*Label 111*/ GIMT_Encode4(645070),
     /*  14478 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_DEC*//*Label 112*/ GIMT_Encode4(645687),
     /*  14482 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FADD*//*Label 113*/ GIMT_Encode4(648071),
     /*  14486 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMAX*//*Label 114*/ GIMT_Encode4(651713),
     /*  14490 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMIN*//*Label 115*/ GIMT_Encode4(655329),
     /*  14494 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_INC*//*Label 116*/ GIMT_Encode4(658945),
     /*  14498 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_OR*//*Label 117*/ GIMT_Encode4(661329),
     /*  14502 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMAX*//*Label 118*/ GIMT_Encode4(663713),
     /*  14506 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMIN*//*Label 119*/ GIMT_Encode4(666097),
     /*  14510 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SUB*//*Label 120*/ GIMT_Encode4(668481),
     /*  14514 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SWAP*//*Label 121*/ GIMT_Encode4(670865),
     /*  14518 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMAX*//*Label 122*/ GIMT_Encode4(674409),
     /*  14522 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMIN*//*Label 123*/ GIMT_Encode4(676793),
     /*  14526 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_XOR*//*Label 124*/ GIMT_Encode4(679177),
     /*  14530 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD*//*Label 125*/ GIMT_Encode4(681561),
     /*  14534 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT*//*Label 126*/ GIMT_Encode4(696933),
     /*  14538 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_D16*//*Label 127*/ GIMT_Encode4(701841),
     /*  14542 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_TFE*//*Label 128*/ GIMT_Encode4(709586),
     /*  14546 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE*//*Label 129*/ GIMT_Encode4(712106),
     /*  14550 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE_TFE*//*Label 130*/ GIMT_Encode4(712712),
     /*  14554 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT*//*Label 131*/ GIMT_Encode4(713318),
     /*  14558 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT_TFE*//*Label 132*/ GIMT_Encode4(713924),
     /*  14562 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_TFE*//*Label 133*/ GIMT_Encode4(714530),
     /*  14566 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE*//*Label 134*/ GIMT_Encode4(717050),
     /*  14570 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE_TFE*//*Label 135*/ GIMT_Encode4(717656),
     /*  14574 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT*//*Label 136*/ GIMT_Encode4(718262),
     /*  14578 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT_TFE*//*Label 137*/ GIMT_Encode4(718868),
     /*  14582 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE*//*Label 138*/ GIMT_Encode4(719474),
     /*  14586 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_BYTE*//*Label 139*/ GIMT_Encode4(734782),
     /*  14590 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT*//*Label 140*/ GIMT_Encode4(735384),
     /*  14594 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT_D16*//*Label 141*/ GIMT_Encode4(740872),
     /*  14598 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_SHORT*//*Label 142*/ GIMT_Encode4(747137), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14614 */ /*AMDGPU::G_AMDGPU_CLAMP*//*Label 143*/ GIMT_Encode4(747739), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14626 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 144*/ GIMT_Encode4(748678),
     /*  14630 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 145*/ GIMT_Encode4(748723),
     /*  14634 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 146*/ GIMT_Encode4(748768),
     /*  14638 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 147*/ GIMT_Encode4(748813),
     /*  14642 */ /*AMDGPU::G_AMDGPU_CVT_PK_I16_I32*//*Label 148*/ GIMT_Encode4(748858),
     /*  14646 */ /*AMDGPU::G_AMDGPU_FFBH_U32*//*Label 149*/ GIMT_Encode4(748888),
     /*  14650 */ /*AMDGPU::G_AMDGPU_FFBL_B32*//*Label 150*/ GIMT_Encode4(748990),
     /*  14654 */ /*AMDGPU::G_AMDGPU_FMAX_LEGACY*//*Label 151*/ GIMT_Encode4(749089),
     /*  14658 */ /*AMDGPU::G_AMDGPU_FMED3*//*Label 152*/ GIMT_Encode4(749162),
     /*  14662 */ /*AMDGPU::G_AMDGPU_FMIN_LEGACY*//*Label 153*/ GIMT_Encode4(749522), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14694 */ /*AMDGPU::G_AMDGPU_RCP_IFLAG*//*Label 154*/ GIMT_Encode4(749595), GIMT_Encode4(0),
     /*  14702 */ /*AMDGPU::G_AMDGPU_SMED3*//*Label 155*/ GIMT_Encode4(749645),
     /*  14706 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD*//*Label 156*/ GIMT_Encode4(749951),
     /*  14710 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SBYTE*//*Label 157*/ GIMT_Encode4(752253),
     /*  14714 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SSHORT*//*Label 158*/ GIMT_Encode4(752391),
     /*  14718 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_UBYTE*//*Label 159*/ GIMT_Encode4(752529),
     /*  14722 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_USHORT*//*Label 160*/ GIMT_Encode4(752667),
     /*  14726 */ /*AMDGPU::G_AMDGPU_S_BUFFER_PREFETCH*//*Label 161*/ GIMT_Encode4(752805), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14738 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT*//*Label 162*/ GIMT_Encode4(752912),
     /*  14742 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT_D16*//*Label 163*/ GIMT_Encode4(758396),
     /*  14746 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT*//*Label 164*/ GIMT_Encode4(763825),
     /*  14750 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT_D16*//*Label 165*/ GIMT_Encode4(769293),
     /*  14754 */ /*AMDGPU::G_AMDGPU_UMED3*//*Label 166*/ GIMT_Encode4(773898),
     /*  14758 */ // Label 0: @14758
     /*  14758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 173*/ GIMT_Encode4(37999),
     /*  14769 */ /*GILLT_s1*//*Label 168*/ GIMT_Encode4(14789),
     /*  14773 */ /*GILLT_s16*//*Label 169*/ GIMT_Encode4(14908),
     /*  14777 */ /*GILLT_s32*//*Label 170*/ GIMT_Encode4(15899),
     /*  14781 */ /*GILLT_s64*//*Label 171*/ GIMT_Encode4(37258),
     /*  14785 */ /*GILLT_v2s16*//*Label 172*/ GIMT_Encode4(37729),
     /*  14789 */ // Label 168: @14789
     /*  14789 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(14907),
     /*  14794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14800 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(14828), // Rule ID 7421 //
     /*  14805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14816 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  14819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14826 */     GIR_RootConstrainSelectedInstOperands,
     /*  14827 */     // GIR_Coverage, 7421,
     /*  14827 */     GIR_EraseRootFromParent_Done,
     /*  14828 */   // Label 175: @14828
     /*  14828 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(14856), // Rule ID 7428 //
     /*  14833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14844 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  14847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14854 */     GIR_RootConstrainSelectedInstOperands,
     /*  14855 */     // GIR_Coverage, 7428,
     /*  14855 */     GIR_EraseRootFromParent_Done,
     /*  14856 */   // Label 176: @14856
     /*  14856 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(14881), // Rule ID 7419 //
     /*  14861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14868 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  14873 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14879 */     GIR_RootConstrainSelectedInstOperands,
     /*  14880 */     // GIR_Coverage, 7419,
     /*  14880 */     GIR_Done,
     /*  14881 */   // Label 177: @14881
     /*  14881 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(14906), // Rule ID 7426 //
     /*  14886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14893 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  14898 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14904 */     GIR_RootConstrainSelectedInstOperands,
     /*  14905 */     // GIR_Coverage, 7426,
     /*  14905 */     GIR_Done,
     /*  14906 */   // Label 178: @14906
     /*  14906 */   GIM_Reject,
     /*  14907 */ // Label 174: @14907
     /*  14907 */ GIM_Reject,
     /*  14908 */ // Label 169: @14908
     /*  14908 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(15898),
     /*  14913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  14916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  14919 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(14971), // Rule ID 7022 //
     /*  14924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  14948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14952 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34193),
     /*  14956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14958 */     // (add:{ *:[i16] } (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34193>>), i16:{ *:[i16] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  14958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  14961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  14967 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  14969 */     GIR_RootConstrainSelectedInstOperands,
     /*  14970 */     // GIR_Coverage, 7022,
     /*  14970 */     GIR_EraseRootFromParent_Done,
     /*  14971 */   // Label 180: @14971
     /*  14971 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(15023), // Rule ID 11155 //
     /*  14976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  15000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  15004 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34193),
     /*  15008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15010 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$val, (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34193>>))  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  15019 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  15021 */     GIR_RootConstrainSelectedInstOperands,
     /*  15022 */     // GIR_Coverage, 11155,
     /*  15022 */     GIR_EraseRootFromParent_Done,
     /*  15023 */   // Label 181: @15023
     /*  15023 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(15066), // Rule ID 2531 //
     /*  15028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /*  15031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15047 */     // MIs[1] Operand 1
     /*  15047 */     // No operand predicates
     /*  15047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15049 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /*  15049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  15052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15056 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15064 */     GIR_RootConstrainSelectedInstOperands,
     /*  15065 */     // GIR_Coverage, 2531,
     /*  15065 */     GIR_EraseRootFromParent_Done,
     /*  15066 */   // Label 182: @15066
     /*  15066 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(15118), // Rule ID 2667 //
     /*  15071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15090 */     // MIs[1] Operand 1
     /*  15090 */     // No operand predicates
     /*  15090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15092 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  15095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15105 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15116 */     GIR_RootConstrainSelectedInstOperands,
     /*  15117 */     // GIR_Coverage, 2667,
     /*  15117 */     GIR_EraseRootFromParent_Done,
     /*  15118 */   // Label 183: @15118
     /*  15118 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(15170), // Rule ID 2670 //
     /*  15123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15142 */     // MIs[1] Operand 1
     /*  15142 */     // No operand predicates
     /*  15142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15144 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 bf16 f16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  15147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15157 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15168 */     GIR_RootConstrainSelectedInstOperands,
     /*  15169 */     // GIR_Coverage, 2670,
     /*  15169 */     GIR_EraseRootFromParent_Done,
     /*  15170 */   // Label 184: @15170
     /*  15170 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(15222), // Rule ID 2673 //
     /*  15175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15194 */     // MIs[1] Operand 1
     /*  15194 */     // No operand predicates
     /*  15194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15196 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  15199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15209 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 2673,
     /*  15221 */     GIR_EraseRootFromParent_Done,
     /*  15222 */   // Label 185: @15222
     /*  15222 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(15272), // Rule ID 2571 //
     /*  15227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15252 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15270 */     GIR_RootConstrainSelectedInstOperands,
     /*  15271 */     // GIR_Coverage, 2571,
     /*  15271 */     GIR_EraseRootFromParent_Done,
     /*  15272 */   // Label 186: @15272
     /*  15272 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(15334), // Rule ID 2572 //
     /*  15277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15302 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15332 */     GIR_RootConstrainSelectedInstOperands,
     /*  15333 */     // GIR_Coverage, 2572,
     /*  15333 */     GIR_EraseRootFromParent_Done,
     /*  15334 */   // Label 187: @15334
     /*  15334 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(15396), // Rule ID 2573 //
     /*  15339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15364 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15394 */     GIR_RootConstrainSelectedInstOperands,
     /*  15395 */     // GIR_Coverage, 2573,
     /*  15395 */     GIR_EraseRootFromParent_Done,
     /*  15396 */   // Label 188: @15396
     /*  15396 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(15458), // Rule ID 2574 //
     /*  15401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15426 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15456 */     GIR_RootConstrainSelectedInstOperands,
     /*  15457 */     // GIR_Coverage, 2574,
     /*  15457 */     GIR_EraseRootFromParent_Done,
     /*  15458 */   // Label 189: @15458
     /*  15458 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(15508), // Rule ID 8491 //
     /*  15463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15488 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15506 */     GIR_RootConstrainSelectedInstOperands,
     /*  15507 */     // GIR_Coverage, 8491,
     /*  15507 */     GIR_EraseRootFromParent_Done,
     /*  15508 */   // Label 190: @15508
     /*  15508 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(15570), // Rule ID 8492 //
     /*  15513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15538 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15568 */     GIR_RootConstrainSelectedInstOperands,
     /*  15569 */     // GIR_Coverage, 8492,
     /*  15569 */     GIR_EraseRootFromParent_Done,
     /*  15570 */   // Label 191: @15570
     /*  15570 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(15632), // Rule ID 8493 //
     /*  15575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15600 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15622 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15630 */     GIR_RootConstrainSelectedInstOperands,
     /*  15631 */     // GIR_Coverage, 8493,
     /*  15631 */     GIR_EraseRootFromParent_Done,
     /*  15632 */   // Label 192: @15632
     /*  15632 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(15694), // Rule ID 8494 //
     /*  15637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15662 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15692 */     GIR_RootConstrainSelectedInstOperands,
     /*  15693 */     // GIR_Coverage, 8494,
     /*  15693 */     GIR_EraseRootFromParent_Done,
     /*  15694 */   // Label 193: @15694
     /*  15694 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(15753), // Rule ID 1066 //
     /*  15699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15720 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /*  15723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15751 */     GIR_RootConstrainSelectedInstOperands,
     /*  15752 */     // GIR_Coverage, 1066,
     /*  15752 */     GIR_EraseRootFromParent_Done,
     /*  15753 */   // Label 194: @15753
     /*  15753 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(15812), // Rule ID 1067 //
     /*  15758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  15761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15779 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /*  15782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_RootConstrainSelectedInstOperands,
     /*  15811 */     // GIR_Coverage, 1067,
     /*  15811 */     GIR_EraseRootFromParent_Done,
     /*  15812 */   // Label 195: @15812
     /*  15812 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(15871), // Rule ID 1068 //
     /*  15817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  15820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15838 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /*  15841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15869 */     GIR_RootConstrainSelectedInstOperands,
     /*  15870 */     // GIR_Coverage, 1068,
     /*  15870 */     GIR_EraseRootFromParent_Done,
     /*  15871 */   // Label 196: @15871
     /*  15871 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(15897), // Rule ID 909 //
     /*  15876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  15879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15883 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  15883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /*  15886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15895 */     GIR_RootConstrainSelectedInstOperands,
     /*  15896 */     // GIR_Coverage, 909,
     /*  15896 */     GIR_EraseRootFromParent_Done,
     /*  15897 */   // Label 197: @15897
     /*  15897 */   GIM_Reject,
     /*  15898 */ // Label 179: @15898
     /*  15898 */ GIM_Reject,
     /*  15899 */ // Label 170: @15899
     /*  15899 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(37257),
     /*  15904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15910 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(16409), // Rule ID 8600 //
     /*  15915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  15918 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  15920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15932 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15935 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  15940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15944 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  15948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  15950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  15962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  15966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  15970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  15974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  15982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  15986 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  15990 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  15994 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  15998 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16002 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16006 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16016 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16019 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16024 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16028 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16032 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16034 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16038 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16042 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16046 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16050 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16054 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16058 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16062 */     // MIs[7] src0
     /*  16062 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16067 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16071 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16082 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16086 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16090 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16094 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16098 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16102 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16106 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16110 */     // MIs[9] src1
     /*  16110 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16115 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16119 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16130 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16134 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16138 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16142 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16146 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16148 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16152 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16156 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  16159 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16164 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16168 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  16172 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16174 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16178 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16182 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16186 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16190 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16194 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16198 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16202 */     // MIs[13] src0
     /*  16202 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16211 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16222 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16226 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16230 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16234 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16238 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16242 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16246 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16250 */     // MIs[15] src1
     /*  16250 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16255 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16259 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16270 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16274 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16278 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16282 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16286 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  16292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16296 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16299 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16304 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16308 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16312 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16314 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16318 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16322 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16326 */     // MIs[18] src0
     /*  16326 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16331 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16342 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16346 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16350 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16354 */     // MIs[19] src1
     /*  16354 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16359 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16370 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16372 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  16398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16407 */     GIR_RootConstrainSelectedInstOperands,
     /*  16408 */     // GIR_Coverage, 8600,
     /*  16408 */     GIR_EraseRootFromParent_Done,
     /*  16409 */   // Label 199: @16409
     /*  16409 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(16908), // Rule ID 8599 //
     /*  16414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16417 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16431 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16434 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16443 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16465 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16481 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16485 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16489 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16493 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16497 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16501 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16505 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16511 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16515 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16518 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16523 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16527 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16531 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16533 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16537 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16541 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16545 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16549 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16553 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16557 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16561 */     // MIs[7] src0
     /*  16561 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16566 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16570 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16581 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16585 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16589 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16593 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16597 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16601 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16605 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16609 */     // MIs[9] src1
     /*  16609 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16614 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16618 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16629 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16633 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16637 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16641 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16645 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16647 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16651 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16655 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  16658 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16663 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16667 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  16671 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16673 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16677 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16681 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16685 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16689 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16693 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16697 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16701 */     // MIs[13] src0
     /*  16701 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16706 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16710 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16721 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16725 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16729 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16733 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16737 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16741 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16745 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16749 */     // MIs[15] src1
     /*  16749 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16754 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16758 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16773 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16777 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16781 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16785 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  16791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16795 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16798 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16803 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16807 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16811 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16813 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16817 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16821 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16825 */     // MIs[18] src0
     /*  16825 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16830 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16841 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16845 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16849 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16853 */     // MIs[19] src1
     /*  16853 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16858 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16869 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16871 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  16897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16906 */     GIR_RootConstrainSelectedInstOperands,
     /*  16907 */     // GIR_Coverage, 8599,
     /*  16907 */     GIR_EraseRootFromParent_Done,
     /*  16908 */   // Label 200: @16908
     /*  16908 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(17407), // Rule ID 8598 //
     /*  16913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16916 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16930 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16933 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16984 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16996 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17004 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17014 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  17017 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17022 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17026 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  17030 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17032 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  17036 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17040 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  17044 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17048 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  17052 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17056 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17060 */     // MIs[7] src0
     /*  17060 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17065 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  17069 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  17084 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17088 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  17092 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  17100 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17104 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17108 */     // MIs[9] src1
     /*  17108 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17113 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  17117 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  17128 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  17132 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17136 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  17140 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17144 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  17146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  17150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17162 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17164 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  17168 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17172 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17175 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17180 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17184 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17188 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17190 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17194 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17198 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17202 */     // MIs[13] src0
     /*  17202 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17207 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17222 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17226 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17230 */     // MIs[14] src1
     /*  17230 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17235 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17246 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17250 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17254 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17257 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17262 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17266 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17270 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17272 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17276 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17280 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17284 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17296 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17300 */     // MIs[17] src0
     /*  17300 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17305 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17309 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17324 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17328 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17332 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17336 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17340 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17344 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17348 */     // MIs[19] src1
     /*  17348 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17353 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17357 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17368 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17370 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  17396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17405 */     GIR_RootConstrainSelectedInstOperands,
     /*  17406 */     // GIR_Coverage, 8598,
     /*  17406 */     GIR_EraseRootFromParent_Done,
     /*  17407 */   // Label 201: @17407
     /*  17407 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(17906), // Rule ID 8597 //
     /*  17412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17415 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17429 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17432 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17441 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17463 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17483 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17503 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17505 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17509 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17513 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  17516 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17521 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17525 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  17529 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17531 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  17535 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17539 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  17543 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17547 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  17551 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17555 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17559 */     // MIs[7] src0
     /*  17559 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17564 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  17568 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  17579 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  17583 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17587 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  17591 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17595 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  17599 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17603 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17607 */     // MIs[9] src1
     /*  17607 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17612 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  17616 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  17631 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17635 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  17639 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17643 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  17645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  17649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17661 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17663 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  17667 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17671 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17674 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17679 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17683 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17687 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17689 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17693 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17697 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17701 */     // MIs[13] src0
     /*  17701 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17706 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17717 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17721 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17725 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17729 */     // MIs[14] src1
     /*  17729 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17734 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17745 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17749 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17753 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17756 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17761 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17765 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17769 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17771 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17775 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17779 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17783 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17795 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17799 */     // MIs[17] src0
     /*  17799 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17804 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17808 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17819 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17823 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17827 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17831 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17835 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17839 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17843 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17847 */     // MIs[19] src1
     /*  17847 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17852 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17856 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17867 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17869 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  17895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17904 */     GIR_RootConstrainSelectedInstOperands,
     /*  17905 */     // GIR_Coverage, 8597,
     /*  17905 */     GIR_EraseRootFromParent_Done,
     /*  17906 */   // Label 202: @17906
     /*  17906 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(18405), // Rule ID 8596 //
     /*  17911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17914 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17928 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17931 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17978 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17982 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17994 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17998 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18002 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18008 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18012 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18016 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18020 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18022 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18026 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18030 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  18033 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18038 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18042 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  18046 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18048 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  18052 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18056 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  18060 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18064 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  18068 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18072 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18076 */     // MIs[8] src0
     /*  18076 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18081 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  18085 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  18100 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18104 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  18108 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18112 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  18116 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18120 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18124 */     // MIs[10] src1
     /*  18124 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18129 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  18133 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18144 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  18148 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18152 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18156 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18160 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  18162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  18166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18170 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  18173 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18178 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18182 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18186 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18188 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18192 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18196 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18200 */     // MIs[13] src0
     /*  18200 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18205 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18216 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18220 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18224 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18228 */     // MIs[14] src1
     /*  18228 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18233 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18244 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18248 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18252 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18255 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18260 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18264 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18268 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18270 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18274 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18278 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18282 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18286 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18290 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18294 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18298 */     // MIs[17] src0
     /*  18298 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18303 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18307 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18318 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18322 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18326 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18330 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18334 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18338 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18342 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18346 */     // MIs[19] src1
     /*  18346 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18351 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18355 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18366 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18368 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  18394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18403 */     GIR_RootConstrainSelectedInstOperands,
     /*  18404 */     // GIR_Coverage, 8596,
     /*  18404 */     GIR_EraseRootFromParent_Done,
     /*  18405 */   // Label 203: @18405
     /*  18405 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(18904), // Rule ID 8595 //
     /*  18410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18413 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18427 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18430 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18473 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18477 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18481 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18485 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18489 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18493 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18497 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18501 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18511 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18515 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18519 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18529 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  18532 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18537 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18541 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  18545 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18547 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  18551 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18555 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  18559 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18563 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  18567 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18571 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18575 */     // MIs[8] src0
     /*  18575 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18580 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  18584 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  18595 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  18599 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18603 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  18607 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18611 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  18615 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18619 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18623 */     // MIs[10] src1
     /*  18623 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18628 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  18632 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18643 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  18647 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18651 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18655 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18659 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  18661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  18665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18669 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  18672 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18677 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18681 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18685 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18687 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18691 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18695 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18699 */     // MIs[13] src0
     /*  18699 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18704 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18715 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18719 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18723 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18727 */     // MIs[14] src1
     /*  18727 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18732 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18743 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18747 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18751 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18754 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18759 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18763 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18767 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18769 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18773 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18777 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18781 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18785 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18789 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18793 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18797 */     // MIs[17] src0
     /*  18797 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18802 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18806 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18817 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18821 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18825 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18829 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18833 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18837 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18841 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18845 */     // MIs[19] src1
     /*  18845 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18850 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18854 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18865 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18867 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  18893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18902 */     GIR_RootConstrainSelectedInstOperands,
     /*  18903 */     // GIR_Coverage, 8595,
     /*  18903 */     GIR_EraseRootFromParent_Done,
     /*  18904 */   // Label 204: @18904
     /*  18904 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(19403), // Rule ID 8594 //
     /*  18909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18912 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18926 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18929 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18938 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18980 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18996 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19000 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  19002 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19006 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19010 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19014 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19018 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  19020 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19024 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19028 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19032 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19036 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  19038 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  19042 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19046 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  19049 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19054 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19058 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  19062 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19064 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  19068 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19072 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19076 */     // MIs[8] src0
     /*  19076 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19081 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  19092 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  19096 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19100 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19104 */     // MIs[9] src1
     /*  19104 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19109 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19120 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  19124 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19128 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  19131 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19136 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19140 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  19144 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  19146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  19150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19170 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19174 */     // MIs[12] src0
     /*  19174 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19179 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19183 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19210 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19214 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19218 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19222 */     // MIs[14] src1
     /*  19222 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19227 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19231 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19242 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19246 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19250 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19253 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19258 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19262 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19266 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19268 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19272 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19276 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19280 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19288 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19292 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19296 */     // MIs[17] src0
     /*  19296 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19301 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19305 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19320 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19324 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19328 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19332 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19336 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19340 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19344 */     // MIs[19] src1
     /*  19344 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19349 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19353 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19364 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19366 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  19392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19401 */     GIR_RootConstrainSelectedInstOperands,
     /*  19402 */     // GIR_Coverage, 8594,
     /*  19402 */     GIR_EraseRootFromParent_Done,
     /*  19403 */   // Label 205: @19403
     /*  19403 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(19902), // Rule ID 8593 //
     /*  19408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19411 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  19428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  19441 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19459 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  19467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19471 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19475 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19479 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  19483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19499 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  19501 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19505 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19509 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19513 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19517 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  19519 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19523 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19527 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19531 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19535 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  19537 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  19541 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19545 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  19548 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19553 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  19561 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19563 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  19567 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19571 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19575 */     // MIs[8] src0
     /*  19575 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19580 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  19591 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  19595 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19599 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19603 */     // MIs[9] src1
     /*  19603 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19608 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19619 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  19623 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19627 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  19630 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19635 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19639 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  19643 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  19645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  19649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19669 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19673 */     // MIs[12] src0
     /*  19673 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19678 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19682 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19709 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19713 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19717 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19721 */     // MIs[14] src1
     /*  19721 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19726 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19730 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19741 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19745 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19749 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19752 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19757 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19761 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19765 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19767 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19771 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19775 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19779 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19783 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19787 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19791 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19795 */     // MIs[17] src0
     /*  19795 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19800 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19804 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19815 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19819 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19823 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19827 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19831 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19835 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19839 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     // MIs[19] src1
     /*  19843 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19848 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19852 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19863 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19865 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  19891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19900 */     GIR_RootConstrainSelectedInstOperands,
     /*  19901 */     // GIR_Coverage, 8593,
     /*  19901 */     GIR_EraseRootFromParent_Done,
     /*  19902 */   // Label 206: @19902
     /*  19902 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(20401), // Rule ID 8592 //
     /*  19907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19910 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19942 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  19945 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19954 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  19958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19984 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19988 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19992 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  19996 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20007 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20011 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20015 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20019 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20027 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20031 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20035 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20039 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20043 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20054 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20058 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20062 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20066 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20070 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20072 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20076 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20080 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  20083 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20088 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20092 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  20096 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20098 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  20102 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20106 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  20110 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20114 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  20118 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20122 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20126 */     // MIs[10] src0
     /*  20126 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20131 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  20135 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  20150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  20158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  20166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20170 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  20174 */     // MIs[12] src1
     /*  20174 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20179 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20183 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20210 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20212 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  20216 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20220 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20223 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20228 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20232 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20236 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20238 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20242 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20246 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20250 */     // MIs[15] src0
     /*  20250 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20255 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20266 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20270 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20274 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20278 */     // MIs[16] src1
     /*  20278 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20283 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20294 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20298 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20302 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20305 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20310 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20314 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20318 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20320 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20324 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20328 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20332 */     // MIs[18] src0
     /*  20332 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20337 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20341 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20345 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20349 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20353 */     // MIs[19] src1
     /*  20353 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20358 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20362 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20364 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  20390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20399 */     GIR_RootConstrainSelectedInstOperands,
     /*  20400 */     // GIR_Coverage, 8592,
     /*  20400 */     GIR_EraseRootFromParent_Done,
     /*  20401 */   // Label 207: @20401
     /*  20401 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(20900), // Rule ID 8591 //
     /*  20406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20409 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20441 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20444 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20453 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20457 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20487 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20491 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20495 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20518 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20522 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20526 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20530 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20534 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20538 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20542 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20553 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20557 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20561 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20565 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20569 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20571 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20575 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20579 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  20582 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20587 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20591 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  20595 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20597 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  20601 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20605 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  20609 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20613 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  20617 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20621 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     // MIs[10] src0
     /*  20625 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20630 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  20634 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  20645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  20649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  20657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  20665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20669 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     // MIs[12] src1
     /*  20673 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20678 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20682 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20709 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20711 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  20715 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20719 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20722 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20727 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20731 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20735 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20737 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20741 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20745 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20749 */     // MIs[15] src0
     /*  20749 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20754 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20765 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20769 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20773 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20777 */     // MIs[16] src1
     /*  20777 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20782 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20793 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20797 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20801 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20804 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20809 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20813 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20817 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20819 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20823 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20827 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20831 */     // MIs[18] src0
     /*  20831 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20836 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20844 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20848 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20852 */     // MIs[19] src1
     /*  20852 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20857 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20861 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20863 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  20889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20898 */     GIR_RootConstrainSelectedInstOperands,
     /*  20899 */     // GIR_Coverage, 8591,
     /*  20899 */     GIR_EraseRootFromParent_Done,
     /*  20900 */   // Label 208: @20900
     /*  20900 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(21399), // Rule ID 8590 //
     /*  20905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20908 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20940 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20943 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20952 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20990 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20994 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  21005 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  21009 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21013 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21017 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  21025 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21029 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21033 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21037 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  21041 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  21052 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  21056 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21060 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21064 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21068 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  21070 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  21074 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21078 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21082 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21086 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21088 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  21092 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21096 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21099 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21104 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21108 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21112 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21114 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21118 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21122 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21126 */     // MIs[10] src0
     /*  21126 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21131 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21146 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21150 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21154 */     // MIs[11] src1
     /*  21154 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21159 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21170 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  21174 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21178 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21181 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21186 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21190 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21194 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21196 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21200 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21204 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21208 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21212 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21216 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21220 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21224 */     // MIs[14] src0
     /*  21224 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21229 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21233 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21244 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21248 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21252 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21256 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21260 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21264 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21268 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21272 */     // MIs[16] src1
     /*  21272 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21277 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21281 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21292 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21296 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21300 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21303 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21308 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21312 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21316 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21318 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21322 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21326 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21330 */     // MIs[18] src0
     /*  21330 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21335 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21339 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21343 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21347 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21351 */     // MIs[19] src1
     /*  21351 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21356 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21362 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  21388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21397 */     GIR_RootConstrainSelectedInstOperands,
     /*  21398 */     // GIR_Coverage, 8590,
     /*  21398 */     GIR_EraseRootFromParent_Done,
     /*  21399 */   // Label 209: @21399
     /*  21399 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(21898), // Rule ID 8589 //
     /*  21404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21407 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21439 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  21442 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21451 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  21455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21473 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21477 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21481 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21485 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21489 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  21493 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  21504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  21508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21512 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21516 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  21524 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21528 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21532 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21536 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  21540 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  21551 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  21555 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21559 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21563 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21567 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  21569 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  21573 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21577 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21581 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21585 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21587 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  21591 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21595 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21598 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21603 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21607 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21611 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21617 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21625 */     // MIs[10] src0
     /*  21625 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21630 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21641 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21645 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21649 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21653 */     // MIs[11] src1
     /*  21653 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21658 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21669 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  21673 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21677 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21680 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21685 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21689 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21693 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21695 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21699 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21703 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21707 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21711 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21715 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21719 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21723 */     // MIs[14] src0
     /*  21723 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21728 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21732 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21743 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21747 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21751 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21755 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21759 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21763 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21767 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21771 */     // MIs[16] src1
     /*  21771 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21776 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21780 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21791 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21795 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21799 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21802 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21807 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21811 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21815 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21817 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21821 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21825 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21829 */     // MIs[18] src0
     /*  21829 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21834 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21842 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21846 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21850 */     // MIs[19] src1
     /*  21850 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21855 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21859 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21861 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  21887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21896 */     GIR_RootConstrainSelectedInstOperands,
     /*  21897 */     // GIR_Coverage, 8589,
     /*  21897 */     GIR_EraseRootFromParent_Done,
     /*  21898 */   // Label 210: @21898
     /*  21898 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(22397), // Rule ID 8588 //
     /*  21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21906 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  21952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21956 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  21959 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21968 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  21972 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  21974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  21978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21998 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22002 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22006 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  22010 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  22021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  22025 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22029 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22033 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  22041 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22045 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  22057 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22068 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  22072 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22076 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22080 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22084 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  22086 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  22090 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22094 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  22097 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22102 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22106 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  22110 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  22112 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  22116 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22120 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22124 */     // MIs[10] src0
     /*  22124 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22129 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22140 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  22144 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22148 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22152 */     // MIs[11] src1
     /*  22152 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22157 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  22168 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22172 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22176 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22179 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22184 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22210 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22214 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22218 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22222 */     // MIs[14] src0
     /*  22222 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22227 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22231 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22242 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22246 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22250 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22254 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22258 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22262 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22266 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22270 */     // MIs[16] src1
     /*  22270 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22275 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22279 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22290 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22294 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22298 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22301 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22306 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22310 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22314 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22316 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22320 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22324 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22328 */     // MIs[18] src0
     /*  22328 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22333 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22337 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22341 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22345 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22349 */     // MIs[19] src1
     /*  22349 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22354 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22358 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22360 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  22386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22395 */     GIR_RootConstrainSelectedInstOperands,
     /*  22396 */     // GIR_Coverage, 8588,
     /*  22396 */     GIR_EraseRootFromParent_Done,
     /*  22397 */   // Label 211: @22397
     /*  22397 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(22896), // Rule ID 8587 //
     /*  22402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22405 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22455 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  22458 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22463 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22467 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  22471 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22473 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22477 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22481 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  22485 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22489 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22493 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22497 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22501 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22505 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  22509 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  22524 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22528 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22532 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  22540 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22544 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  22548 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22552 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  22556 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  22571 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22575 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  22585 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  22589 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22593 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  22596 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22601 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22605 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  22609 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  22611 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  22615 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22619 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22623 */     // MIs[10] src0
     /*  22623 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22628 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22639 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  22643 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22647 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22651 */     // MIs[11] src1
     /*  22651 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22656 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  22667 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22671 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22675 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22678 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22683 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22687 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22691 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22709 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22713 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22717 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22721 */     // MIs[14] src0
     /*  22721 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22726 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22730 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22741 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22745 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22749 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22753 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22757 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22761 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22765 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22769 */     // MIs[16] src1
     /*  22769 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22774 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22778 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22789 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22793 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22797 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22800 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22805 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22809 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22813 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22815 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22819 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22823 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22827 */     // MIs[18] src0
     /*  22827 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22832 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22836 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22840 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22844 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22848 */     // MIs[19] src1
     /*  22848 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22853 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22857 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22859 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  22885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22894 */     GIR_RootConstrainSelectedInstOperands,
     /*  22895 */     // GIR_Coverage, 8587,
     /*  22895 */     GIR_EraseRootFromParent_Done,
     /*  22896 */   // Label 212: @22896
     /*  22896 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(23395), // Rule ID 8586 //
     /*  22901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22904 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22926 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22972 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  22975 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22980 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22984 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  22988 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  22990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22998 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  23002 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23006 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  23017 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  23021 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23025 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23029 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  23033 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  23044 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  23048 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23052 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  23055 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23060 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23064 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  23068 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  23070 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  23074 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23078 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23082 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  23086 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23090 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23094 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23098 */     // MIs[9] src0
     /*  23098 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23103 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  23107 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  23118 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  23122 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23126 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23130 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23134 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23138 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23142 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23146 */     // MIs[11] src1
     /*  23146 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23151 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  23155 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  23166 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  23170 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23174 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23177 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23182 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23186 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23190 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23196 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23200 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23204 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23208 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23212 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23216 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23220 */     // MIs[14] src0
     /*  23220 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23225 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23229 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23240 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23244 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23248 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23252 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23256 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23260 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23264 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23268 */     // MIs[16] src1
     /*  23268 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23273 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23277 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23296 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23299 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23304 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23308 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23312 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23314 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23318 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23322 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23326 */     // MIs[18] src0
     /*  23326 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23331 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23335 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23339 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23343 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23347 */     // MIs[19] src1
     /*  23347 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23352 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23356 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23358 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  23384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23393 */     GIR_RootConstrainSelectedInstOperands,
     /*  23394 */     // GIR_Coverage, 8586,
     /*  23394 */     GIR_EraseRootFromParent_Done,
     /*  23395 */   // Label 213: @23395
     /*  23395 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(23894), // Rule ID 2762 //
     /*  23400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  23403 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  23421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  23445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23457 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23461 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  23463 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23467 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23471 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  23474 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23479 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23483 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  23487 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23489 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23493 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23497 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  23501 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23505 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  23516 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  23520 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23524 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23528 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  23532 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  23543 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  23547 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23551 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  23554 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23559 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23563 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  23567 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  23569 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  23573 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23577 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23581 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  23585 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23589 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23593 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23597 */     // MIs[9] src0
     /*  23597 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23602 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  23606 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  23617 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  23621 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23625 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23629 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23633 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23637 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23641 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23645 */     // MIs[11] src1
     /*  23645 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23650 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  23654 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  23665 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  23669 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23673 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23676 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23681 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23685 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23689 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23691 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23695 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23699 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23703 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23707 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23711 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23715 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23719 */     // MIs[14] src0
     /*  23719 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23724 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23728 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23739 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23743 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23747 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23751 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23755 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23759 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23763 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23767 */     // MIs[16] src1
     /*  23767 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23772 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23776 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23795 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23798 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23803 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23807 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23811 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23813 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23817 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23821 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23825 */     // MIs[18] src0
     /*  23825 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23830 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23834 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23838 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23842 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23846 */     // MIs[19] src1
     /*  23846 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23851 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23855 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23857 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  23883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23892 */     GIR_RootConstrainSelectedInstOperands,
     /*  23893 */     // GIR_Coverage, 2762,
     /*  23893 */     GIR_EraseRootFromParent_Done,
     /*  23894 */   // Label 214: @23894
     /*  23894 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(24369), // Rule ID 9880 //
     /*  23899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  23902 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  23924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  23932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  23954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  23958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23966 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23970 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  23974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  23978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  23986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23990 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23992 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  23996 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24000 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24003 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24008 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24012 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24016 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24018 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24022 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24026 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24030 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24034 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24038 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24042 */     // MIs[7] src0
     /*  24042 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24047 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24051 */     // MIs[6] Operand 2
     /*  24051 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24062 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24066 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24070 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24074 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24078 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24082 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24086 */     // MIs[9] src1
     /*  24086 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24091 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24095 */     // MIs[8] Operand 2
     /*  24095 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24106 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24110 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24114 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24118 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24122 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24124 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24128 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24132 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  24135 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24140 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24144 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  24148 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24150 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  24154 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24158 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  24162 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  24166 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24170 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  24174 */     // MIs[13] src0
     /*  24174 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24179 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24183 */     // MIs[12] Operand 2
     /*  24183 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24194 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24198 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24202 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24206 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24210 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24214 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24218 */     // MIs[15] src1
     /*  24218 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24223 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24227 */     // MIs[14] Operand 2
     /*  24227 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24238 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24242 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24246 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24250 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24254 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24256 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  24260 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24264 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24267 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24272 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24276 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24280 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24282 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24286 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24290 */     // MIs[18] src0
     /*  24290 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24295 */     // MIs[18] Operand 2
     /*  24295 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24306 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24310 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24314 */     // MIs[19] src1
     /*  24314 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24319 */     // MIs[19] Operand 2
     /*  24319 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24330 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24332 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  24358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24367 */     GIR_RootConstrainSelectedInstOperands,
     /*  24368 */     // GIR_Coverage, 9880,
     /*  24368 */     GIR_EraseRootFromParent_Done,
     /*  24369 */   // Label 215: @24369
     /*  24369 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(24844), // Rule ID 9879 //
     /*  24374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24377 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24391 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24394 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24403 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24425 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24437 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24441 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24445 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24453 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24457 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24461 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24465 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24467 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24471 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24475 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24478 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24483 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24487 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24491 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24493 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24497 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24501 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24505 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24509 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24513 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24517 */     // MIs[7] src0
     /*  24517 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24522 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24526 */     // MIs[6] Operand 2
     /*  24526 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24537 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24541 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24545 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24549 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24553 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24557 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24561 */     // MIs[9] src1
     /*  24561 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24566 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24570 */     // MIs[8] Operand 2
     /*  24570 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24581 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24585 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24589 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24593 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24597 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24599 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24603 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24607 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  24610 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24615 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24619 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  24623 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24625 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  24629 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24633 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  24637 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  24641 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24645 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  24649 */     // MIs[13] src0
     /*  24649 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24654 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24658 */     // MIs[12] Operand 2
     /*  24658 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24669 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24673 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24677 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24681 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24685 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24689 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24693 */     // MIs[15] src1
     /*  24693 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24698 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24702 */     // MIs[14] Operand 2
     /*  24702 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24713 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24717 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24721 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24725 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24729 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24731 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  24735 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24739 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24742 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24747 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24751 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24755 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24757 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24761 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24765 */     // MIs[18] src0
     /*  24765 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24770 */     // MIs[18] Operand 2
     /*  24770 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24785 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24789 */     // MIs[19] src1
     /*  24789 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24794 */     // MIs[19] Operand 2
     /*  24794 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24805 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24807 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  24833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24842 */     GIR_RootConstrainSelectedInstOperands,
     /*  24843 */     // GIR_Coverage, 9879,
     /*  24843 */     GIR_EraseRootFromParent_Done,
     /*  24844 */   // Label 216: @24844
     /*  24844 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(25319), // Rule ID 9878 //
     /*  24849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24852 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24882 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24916 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24920 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24932 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24936 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24940 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24946 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24950 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24953 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24958 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24962 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24966 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24968 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24972 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24976 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24980 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24984 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24988 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24992 */     // MIs[7] src0
     /*  24992 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24997 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  25001 */     // MIs[6] Operand 2
     /*  25001 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  25012 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  25016 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25020 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  25028 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25032 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  25036 */     // MIs[9] src1
     /*  25036 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25041 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  25045 */     // MIs[8] Operand 2
     /*  25045 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  25056 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  25060 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25064 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  25068 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25072 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  25074 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  25078 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25082 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25086 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25090 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25092 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  25096 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25100 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25103 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25108 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25112 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25116 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25118 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25122 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25126 */     // MIs[13] src0
     /*  25126 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25131 */     // MIs[13] Operand 2
     /*  25131 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25142 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25146 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25150 */     // MIs[14] src1
     /*  25150 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25155 */     // MIs[14] Operand 2
     /*  25155 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25166 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  25170 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25174 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25177 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25182 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25186 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25190 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25192 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25196 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25200 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25204 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25208 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25212 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25216 */     // MIs[17] src0
     /*  25216 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25221 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25225 */     // MIs[16] Operand 2
     /*  25225 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25236 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25240 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25244 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25248 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25252 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25256 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25260 */     // MIs[19] src1
     /*  25260 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25265 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25269 */     // MIs[18] Operand 2
     /*  25269 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25280 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25282 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  25308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25317 */     GIR_RootConstrainSelectedInstOperands,
     /*  25318 */     // GIR_Coverage, 9878,
     /*  25318 */     GIR_EraseRootFromParent_Done,
     /*  25319 */   // Label 217: @25319
     /*  25319 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(25794), // Rule ID 9877 //
     /*  25324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25327 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25341 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25344 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25353 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25375 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25395 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25415 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25421 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25425 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  25428 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25433 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25437 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  25441 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25443 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  25447 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25451 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  25455 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  25459 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25463 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  25467 */     // MIs[7] src0
     /*  25467 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25472 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  25476 */     // MIs[6] Operand 2
     /*  25476 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  25487 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  25491 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25495 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  25499 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  25503 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25507 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  25511 */     // MIs[9] src1
     /*  25511 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25516 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  25520 */     // MIs[8] Operand 2
     /*  25520 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  25531 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  25535 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25539 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  25543 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25547 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  25549 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  25553 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25557 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25561 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25565 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25567 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  25571 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25575 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25578 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25583 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25587 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25591 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25593 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25597 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25601 */     // MIs[13] src0
     /*  25601 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25606 */     // MIs[13] Operand 2
     /*  25606 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25617 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25621 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25625 */     // MIs[14] src1
     /*  25625 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25630 */     // MIs[14] Operand 2
     /*  25630 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25641 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  25645 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25649 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25652 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25657 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25661 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25665 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25667 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25671 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25675 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25679 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25683 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25687 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25691 */     // MIs[17] src0
     /*  25691 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25696 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25700 */     // MIs[16] Operand 2
     /*  25700 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25711 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25715 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25719 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25723 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25727 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25731 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25735 */     // MIs[19] src1
     /*  25735 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25740 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25744 */     // MIs[18] Operand 2
     /*  25744 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25755 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25757 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  25783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25792 */     GIR_RootConstrainSelectedInstOperands,
     /*  25793 */     // GIR_Coverage, 9877,
     /*  25793 */     GIR_EraseRootFromParent_Done,
     /*  25794 */   // Label 218: @25794
     /*  25794 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(26269), // Rule ID 9876 //
     /*  25799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25802 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25816 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25819 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25870 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25886 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25890 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25900 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  25904 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25908 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25910 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25914 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25918 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  25921 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25926 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  25930 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  25934 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  25936 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  25940 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25944 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  25948 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  25952 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25956 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  25960 */     // MIs[8] src0
     /*  25960 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25965 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  25969 */     // MIs[7] Operand 2
     /*  25969 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  25980 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  25984 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25988 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  25992 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  25996 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26000 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26004 */     // MIs[10] src1
     /*  26004 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26009 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  26013 */     // MIs[9] Operand 2
     /*  26013 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26024 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  26028 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26032 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26036 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  26040 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  26042 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  26046 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26050 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  26053 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26058 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26062 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  26066 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  26068 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  26072 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26076 */     // MIs[13] src0
     /*  26076 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26081 */     // MIs[13] Operand 2
     /*  26081 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  26096 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26100 */     // MIs[14] src1
     /*  26100 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26105 */     // MIs[14] Operand 2
     /*  26105 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  26116 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26120 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26124 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26127 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26132 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26136 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26140 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26142 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26146 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26150 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26154 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26158 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26162 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26166 */     // MIs[17] src0
     /*  26166 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26171 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26175 */     // MIs[16] Operand 2
     /*  26175 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26186 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26190 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26194 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26198 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26202 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26206 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26210 */     // MIs[19] src1
     /*  26210 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26215 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26219 */     // MIs[18] Operand 2
     /*  26219 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26230 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26232 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  26258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26267 */     GIR_RootConstrainSelectedInstOperands,
     /*  26268 */     // GIR_Coverage, 9876,
     /*  26268 */     GIR_EraseRootFromParent_Done,
     /*  26269 */   // Label 219: @26269
     /*  26269 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(26744), // Rule ID 9875 //
     /*  26274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26277 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26325 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26341 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26345 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26349 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26353 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26357 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26361 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26365 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26371 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26375 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26379 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26383 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26385 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26389 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26393 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  26396 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26401 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26405 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  26409 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  26415 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26419 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  26423 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  26427 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26431 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  26435 */     // MIs[8] src0
     /*  26435 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26440 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  26444 */     // MIs[7] Operand 2
     /*  26444 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  26455 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  26459 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26463 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  26467 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  26471 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26475 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26479 */     // MIs[10] src1
     /*  26479 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26484 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  26488 */     // MIs[9] Operand 2
     /*  26488 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26499 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  26503 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26507 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26511 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  26515 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  26517 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  26521 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26525 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  26528 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26533 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26537 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  26541 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  26543 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  26547 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26551 */     // MIs[13] src0
     /*  26551 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26556 */     // MIs[13] Operand 2
     /*  26556 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  26571 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26575 */     // MIs[14] src1
     /*  26575 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26580 */     // MIs[14] Operand 2
     /*  26580 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  26591 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26595 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26599 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26602 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26607 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26611 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26615 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26617 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26621 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26625 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26629 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26633 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26637 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26641 */     // MIs[17] src0
     /*  26641 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26646 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26650 */     // MIs[16] Operand 2
     /*  26650 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26661 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26665 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26669 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26673 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26677 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26681 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26685 */     // MIs[19] src1
     /*  26685 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26690 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26694 */     // MIs[18] Operand 2
     /*  26694 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26705 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26707 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  26733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26742 */     GIR_RootConstrainSelectedInstOperands,
     /*  26743 */     // GIR_Coverage, 9875,
     /*  26743 */     GIR_EraseRootFromParent_Done,
     /*  26744 */   // Label 220: @26744
     /*  26744 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(27219), // Rule ID 9874 //
     /*  26749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26752 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26766 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26769 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26778 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26800 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26820 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26832 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26836 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26840 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26850 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26854 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26858 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26860 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26864 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26868 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  26872 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26876 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26878 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  26882 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26886 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  26889 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26894 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  26898 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  26902 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  26904 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  26908 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26912 */     // MIs[8] src0
     /*  26912 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26917 */     // MIs[8] Operand 2
     /*  26917 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  26928 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  26932 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26936 */     // MIs[9] src1
     /*  26936 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26941 */     // MIs[9] Operand 2
     /*  26941 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26952 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  26956 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26960 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  26963 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26968 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26972 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  26976 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  26982 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26986 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26990 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  26994 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26998 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27002 */     // MIs[12] src0
     /*  27002 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27007 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27011 */     // MIs[11] Operand 2
     /*  27011 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27022 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  27026 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27030 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27034 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27038 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27042 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27046 */     // MIs[14] src1
     /*  27046 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27051 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  27055 */     // MIs[13] Operand 2
     /*  27055 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  27066 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  27070 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27074 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  27077 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27082 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  27086 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  27090 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  27092 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  27096 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27100 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  27104 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  27108 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27112 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27116 */     // MIs[17] src0
     /*  27116 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27121 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  27125 */     // MIs[16] Operand 2
     /*  27125 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27136 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  27140 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27144 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  27148 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  27152 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27156 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27160 */     // MIs[19] src1
     /*  27160 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27165 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  27169 */     // MIs[18] Operand 2
     /*  27169 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27180 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27182 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  27208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27217 */     GIR_RootConstrainSelectedInstOperands,
     /*  27218 */     // GIR_Coverage, 9874,
     /*  27218 */     GIR_EraseRootFromParent_Done,
     /*  27219 */   // Label 221: @27219
     /*  27219 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(27694), // Rule ID 9873 //
     /*  27224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27227 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27241 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27244 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  27257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  27271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27275 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  27279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  27283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27291 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  27295 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  27299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  27303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27311 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27315 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  27317 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  27321 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27325 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27329 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  27333 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  27335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27343 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27347 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27351 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  27353 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  27357 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27361 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  27364 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27369 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27373 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  27377 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27379 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  27383 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27387 */     // MIs[8] src0
     /*  27387 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27392 */     // MIs[8] Operand 2
     /*  27392 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  27403 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  27407 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27411 */     // MIs[9] src1
     /*  27411 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27416 */     // MIs[9] Operand 2
     /*  27416 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27427 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  27431 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27435 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  27438 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27443 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27447 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  27451 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  27453 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  27457 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27461 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27465 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27469 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27473 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27477 */     // MIs[12] src0
     /*  27477 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27482 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27486 */     // MIs[11] Operand 2
     /*  27486 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27497 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  27501 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27505 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27509 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27513 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27517 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27521 */     // MIs[14] src1
     /*  27521 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27526 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  27530 */     // MIs[13] Operand 2
     /*  27530 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  27541 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  27545 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27549 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  27552 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27557 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  27561 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  27565 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  27567 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  27571 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27575 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  27579 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  27583 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27587 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27591 */     // MIs[17] src0
     /*  27591 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27596 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  27600 */     // MIs[16] Operand 2
     /*  27600 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27611 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  27615 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27619 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  27623 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  27627 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27631 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27635 */     // MIs[19] src1
     /*  27635 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27640 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  27644 */     // MIs[18] Operand 2
     /*  27644 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27655 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27657 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  27683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27692 */     GIR_RootConstrainSelectedInstOperands,
     /*  27693 */     // GIR_Coverage, 9873,
     /*  27693 */     GIR_EraseRootFromParent_Done,
     /*  27694 */   // Label 222: @27694
     /*  27694 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(28169), // Rule ID 9872 //
     /*  27699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27702 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27734 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27737 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27746 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  27750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  27752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  27768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27772 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27776 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27780 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  27784 */     // MIs[3] Operand 2
     /*  27784 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  27795 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  27799 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27803 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27811 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27815 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27819 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27823 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  27827 */     // MIs[5] Operand 2
     /*  27827 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  27838 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  27842 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27846 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  27850 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27854 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27856 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  27860 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27864 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  27867 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27872 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  27876 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  27880 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  27882 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  27886 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27890 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  27894 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  27898 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27902 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27906 */     // MIs[10] src0
     /*  27906 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  27911 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  27915 */     // MIs[9] Operand 2
     /*  27915 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27926 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  27930 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27934 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27938 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27942 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27946 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27950 */     // MIs[12] src1
     /*  27950 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  27955 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27959 */     // MIs[11] Operand 2
     /*  27959 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27970 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  27974 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27978 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27982 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  27986 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  27988 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27992 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27996 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  27999 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28004 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28008 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  28012 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  28014 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  28018 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28022 */     // MIs[15] src0
     /*  28022 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28027 */     // MIs[15] Operand 2
     /*  28027 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28038 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  28042 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28046 */     // MIs[16] src1
     /*  28046 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28051 */     // MIs[16] Operand 2
     /*  28051 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  28062 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28066 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28070 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28073 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28078 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28082 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28086 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28088 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28092 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28096 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28100 */     // MIs[18] src0
     /*  28100 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28105 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28109 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28113 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28117 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28121 */     // MIs[19] src1
     /*  28121 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28126 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28132 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  28158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28167 */     GIR_RootConstrainSelectedInstOperands,
     /*  28168 */     // GIR_Coverage, 9872,
     /*  28168 */     GIR_EraseRootFromParent_Done,
     /*  28169 */   // Label 223: @28169
     /*  28169 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(28644), // Rule ID 9871 //
     /*  28174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28177 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28199 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28209 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28212 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28221 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28259 */     // MIs[3] Operand 2
     /*  28259 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28270 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28274 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28278 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28282 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28286 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28290 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28294 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28298 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28302 */     // MIs[5] Operand 2
     /*  28302 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28313 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28317 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28321 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28325 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28329 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28331 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28335 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28339 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  28342 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28347 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28351 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  28355 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28357 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  28361 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28365 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  28369 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  28373 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28377 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  28381 */     // MIs[10] src0
     /*  28381 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28386 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  28390 */     // MIs[9] Operand 2
     /*  28390 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  28401 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  28405 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28409 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  28413 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  28417 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28421 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28425 */     // MIs[12] src1
     /*  28425 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28430 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  28434 */     // MIs[11] Operand 2
     /*  28434 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  28449 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28453 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28457 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  28461 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  28463 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  28467 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28471 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  28474 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28479 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28483 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  28487 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  28489 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  28493 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28497 */     // MIs[15] src0
     /*  28497 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28502 */     // MIs[15] Operand 2
     /*  28502 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28513 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  28517 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28521 */     // MIs[16] src1
     /*  28521 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28526 */     // MIs[16] Operand 2
     /*  28526 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  28537 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28541 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28545 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28548 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28553 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28557 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28561 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28563 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28567 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28571 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28575 */     // MIs[18] src0
     /*  28575 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28580 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28584 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28588 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28592 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28596 */     // MIs[19] src1
     /*  28596 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28601 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28605 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28607 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  28633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28642 */     GIR_RootConstrainSelectedInstOperands,
     /*  28643 */     // GIR_Coverage, 9871,
     /*  28643 */     GIR_EraseRootFromParent_Done,
     /*  28644 */   // Label 224: @28644
     /*  28644 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(29119), // Rule ID 9870 //
     /*  28649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28652 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28684 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28687 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28696 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28726 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28730 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28734 */     // MIs[3] Operand 2
     /*  28734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28749 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28753 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28769 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28773 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28777 */     // MIs[5] Operand 2
     /*  28777 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28788 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28792 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28796 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28800 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28804 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28806 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28810 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28814 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  28818 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28822 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28824 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  28828 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28832 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  28835 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28840 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  28844 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  28848 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  28850 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  28854 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28858 */     // MIs[10] src0
     /*  28858 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28863 */     // MIs[10] Operand 2
     /*  28863 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  28874 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  28878 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28882 */     // MIs[11] src1
     /*  28882 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28887 */     // MIs[11] Operand 2
     /*  28887 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28898 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  28902 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28906 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  28909 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28914 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28918 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  28922 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  28924 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  28928 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28932 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28936 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  28940 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28944 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28948 */     // MIs[14] src0
     /*  28948 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28953 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  28957 */     // MIs[13] Operand 2
     /*  28957 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  28968 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  28972 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28976 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  28984 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28988 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  28992 */     // MIs[16] src1
     /*  28992 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28997 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  29001 */     // MIs[15] Operand 2
     /*  29001 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29012 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29016 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29020 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29023 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29028 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29032 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29036 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29038 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29042 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29046 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29050 */     // MIs[18] src0
     /*  29050 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29055 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29059 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29063 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29067 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29071 */     // MIs[19] src1
     /*  29071 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29076 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29082 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  29094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  29101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  29108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29117 */     GIR_RootConstrainSelectedInstOperands,
     /*  29118 */     // GIR_Coverage, 9870,
     /*  29118 */     GIR_EraseRootFromParent_Done,
     /*  29119 */   // Label 225: @29119
     /*  29119 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(29594), // Rule ID 9869 //
     /*  29124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29127 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29159 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29162 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29171 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  29175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  29189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  29205 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  29209 */     // MIs[3] Operand 2
     /*  29209 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  29220 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  29224 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29228 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29232 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29236 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29240 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29244 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  29248 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  29252 */     // MIs[5] Operand 2
     /*  29252 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  29263 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  29267 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29271 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29275 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29279 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  29281 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  29285 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29289 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29293 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29297 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29299 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  29303 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29307 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29310 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29315 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29319 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29323 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29325 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29329 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29333 */     // MIs[10] src0
     /*  29333 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29338 */     // MIs[10] Operand 2
     /*  29338 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29349 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29353 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29357 */     // MIs[11] src1
     /*  29357 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29362 */     // MIs[11] Operand 2
     /*  29362 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29373 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  29377 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29381 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29384 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29389 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29393 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29397 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29399 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29403 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29407 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29411 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29415 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29419 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29423 */     // MIs[14] src0
     /*  29423 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29428 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  29432 */     // MIs[13] Operand 2
     /*  29432 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29443 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29447 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29451 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29455 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29459 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29463 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29467 */     // MIs[16] src1
     /*  29467 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29472 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  29476 */     // MIs[15] Operand 2
     /*  29476 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29487 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29491 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29495 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29498 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29503 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29507 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29511 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29513 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29517 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29521 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29525 */     // MIs[18] src0
     /*  29525 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29530 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29534 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29538 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29542 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29546 */     // MIs[19] src1
     /*  29546 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29551 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29555 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29557 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  29576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  29583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 9869,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 226: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(30069), // Rule ID 9868 //
     /*  29599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29602 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29624 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  29638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29652 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  29655 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  29664 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  29668 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  29670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  29674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29678 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29682 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29686 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29690 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29694 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  29698 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  29702 */     // MIs[4] Operand 2
     /*  29702 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  29713 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  29717 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29721 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29725 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  29729 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29733 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29737 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29741 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  29745 */     // MIs[6] Operand 2
     /*  29745 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  29756 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  29760 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29764 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29768 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29772 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29774 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  29778 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29782 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29785 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29790 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29794 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29798 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29800 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29804 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29808 */     // MIs[10] src0
     /*  29808 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29813 */     // MIs[10] Operand 2
     /*  29813 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29824 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29828 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29832 */     // MIs[11] src1
     /*  29832 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29837 */     // MIs[11] Operand 2
     /*  29837 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29848 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  29852 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29856 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29859 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29864 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29868 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29872 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29874 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29878 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29882 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29886 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29890 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29894 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29898 */     // MIs[14] src0
     /*  29898 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29903 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  29907 */     // MIs[13] Operand 2
     /*  29907 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29918 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29922 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29926 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29930 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29934 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29938 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29942 */     // MIs[16] src1
     /*  29942 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29947 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  29951 */     // MIs[15] Operand 2
     /*  29951 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29962 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29966 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29970 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29973 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29978 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29982 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29986 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29988 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29992 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29996 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30000 */     // MIs[18] src0
     /*  30000 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30005 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30009 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30013 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30017 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30021 */     // MIs[19] src1
     /*  30021 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30026 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30030 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30032 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  30051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  30058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30067 */     GIR_RootConstrainSelectedInstOperands,
     /*  30068 */     // GIR_Coverage, 9868,
     /*  30068 */     GIR_EraseRootFromParent_Done,
     /*  30069 */   // Label 227: @30069
     /*  30069 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(30544), // Rule ID 9867 //
     /*  30074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30077 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30127 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  30130 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30139 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  30143 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  30149 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30153 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  30157 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30161 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30165 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  30173 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  30177 */     // MIs[4] Operand 2
     /*  30177 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  30188 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  30192 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30196 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30200 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  30204 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30208 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  30212 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30216 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  30220 */     // MIs[6] Operand 2
     /*  30220 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  30235 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30239 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30243 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  30247 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  30249 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  30253 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30257 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  30260 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30265 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30269 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  30273 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  30275 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  30279 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30283 */     // MIs[10] src0
     /*  30283 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30288 */     // MIs[10] Operand 2
     /*  30288 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30299 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  30303 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30307 */     // MIs[11] src1
     /*  30307 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30312 */     // MIs[11] Operand 2
     /*  30312 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  30323 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30327 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30331 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30334 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30339 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30343 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30347 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30349 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30353 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30357 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30361 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30365 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30369 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30373 */     // MIs[14] src0
     /*  30373 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30378 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30382 */     // MIs[13] Operand 2
     /*  30382 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30393 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30397 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30401 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30405 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30409 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30413 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30417 */     // MIs[16] src1
     /*  30417 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30422 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30426 */     // MIs[15] Operand 2
     /*  30426 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30437 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30441 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30445 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30448 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30453 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30457 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30461 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30463 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30467 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30471 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30475 */     // MIs[18] src0
     /*  30475 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30480 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30484 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30488 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30492 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30496 */     // MIs[19] src1
     /*  30496 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30501 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30505 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30507 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  30526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  30533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30542 */     GIR_RootConstrainSelectedInstOperands,
     /*  30543 */     // GIR_Coverage, 9867,
     /*  30543 */     GIR_EraseRootFromParent_Done,
     /*  30544 */   // Label 228: @30544
     /*  30544 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(31019), // Rule ID 9866 //
     /*  30549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30552 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30592 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  30606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30610 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30620 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  30623 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  30632 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  30636 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  30638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30646 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30650 */     // MIs[5] Operand 2
     /*  30650 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  30661 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  30665 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30669 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30673 */     // MIs[6] Operand 2
     /*  30673 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30684 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  30688 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30692 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  30695 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30700 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30704 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  30708 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  30710 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  30714 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30718 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30722 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  30726 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30730 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30734 */     // MIs[9] src0
     /*  30734 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30739 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  30743 */     // MIs[8] Operand 2
     /*  30743 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  30754 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  30758 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30762 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  30770 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30774 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  30778 */     // MIs[11] src1
     /*  30778 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30783 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  30787 */     // MIs[10] Operand 2
     /*  30787 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30798 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30802 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30806 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30809 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30814 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30818 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30822 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30824 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30828 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30832 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30836 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30840 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30844 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30848 */     // MIs[14] src0
     /*  30848 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30853 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30857 */     // MIs[13] Operand 2
     /*  30857 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30868 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30872 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30876 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30880 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30884 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30888 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30892 */     // MIs[16] src1
     /*  30892 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30897 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30901 */     // MIs[15] Operand 2
     /*  30901 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30912 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30916 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30920 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30923 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30928 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30932 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30936 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30938 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30942 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30946 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30950 */     // MIs[18] src0
     /*  30950 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30955 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30959 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30963 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30967 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30971 */     // MIs[19] src1
     /*  30971 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30976 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30980 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30982 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  31001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  31008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31017 */     GIR_RootConstrainSelectedInstOperands,
     /*  31018 */     // GIR_Coverage, 9866,
     /*  31018 */     GIR_EraseRootFromParent_Done,
     /*  31019 */   // Label 229: @31019
     /*  31019 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(31494), // Rule ID 2778 //
     /*  31024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  31027 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  31029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  31045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31067 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  31069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31081 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31085 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  31087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  31091 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31095 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  31098 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31103 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31107 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  31111 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31113 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31117 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31121 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  31125 */     // MIs[5] Operand 2
     /*  31125 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  31136 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  31140 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31144 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  31148 */     // MIs[6] Operand 2
     /*  31148 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  31159 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  31163 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31167 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  31170 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31175 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31179 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  31183 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  31185 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  31189 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31193 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  31197 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  31201 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31205 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  31209 */     // MIs[9] src0
     /*  31209 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31214 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  31218 */     // MIs[8] Operand 2
     /*  31218 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  31233 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31237 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  31241 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  31245 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31249 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  31253 */     // MIs[11] src1
     /*  31253 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31258 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  31262 */     // MIs[10] Operand 2
     /*  31262 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  31273 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  31277 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31281 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  31284 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31289 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  31293 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  31297 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  31299 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  31303 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31307 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  31311 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  31315 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31319 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  31323 */     // MIs[14] src0
     /*  31323 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31328 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  31332 */     // MIs[13] Operand 2
     /*  31332 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  31343 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  31347 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31351 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  31355 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  31359 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31363 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  31367 */     // MIs[16] src1
     /*  31367 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31372 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  31376 */     // MIs[15] Operand 2
     /*  31376 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  31387 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  31391 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31395 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  31398 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31403 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  31407 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  31411 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  31413 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  31417 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31421 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  31425 */     // MIs[18] src0
     /*  31425 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31430 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  31434 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  31438 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31442 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  31446 */     // MIs[19] src1
     /*  31446 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31451 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  31455 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  31457 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  31460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  31469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  31476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  31483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31492 */     GIR_RootConstrainSelectedInstOperands,
     /*  31493 */     // GIR_Coverage, 2778,
     /*  31493 */     GIR_EraseRootFromParent_Done,
     /*  31494 */   // Label 230: @31494
     /*  31494 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(31717), // Rule ID 8523 //
     /*  31499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31514 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31517 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31526 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31530 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31548 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31567 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31575 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31594 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31598 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31602 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31604 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31608 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31612 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31615 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31620 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31624 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31628 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31630 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31634 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31638 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31642 */     // MIs[6] src0
     /*  31642 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31647 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31651 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31655 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31659 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31663 */     // MIs[7] src1
     /*  31663 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31668 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31672 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31674 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  31700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31715 */     GIR_RootConstrainSelectedInstOperands,
     /*  31716 */     // GIR_Coverage, 8523,
     /*  31716 */     GIR_EraseRootFromParent_Done,
     /*  31717 */   // Label 231: @31717
     /*  31717 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(31940), // Rule ID 8524 //
     /*  31722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31771 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31798 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31817 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31821 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31825 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31827 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31831 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31835 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31838 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31843 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31847 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31851 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31857 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31861 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31865 */     // MIs[6] src0
     /*  31865 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31870 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31874 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31878 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31882 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31886 */     // MIs[7] src1
     /*  31886 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31891 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31895 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31897 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  31923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31938 */     GIR_RootConstrainSelectedInstOperands,
     /*  31939 */     // GIR_Coverage, 8524,
     /*  31939 */     GIR_EraseRootFromParent_Done,
     /*  31940 */   // Label 232: @31940
     /*  31940 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(32163), // Rule ID 2754 //
     /*  31945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  31964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31978 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31981 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31990 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  31994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  31996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32012 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32020 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32024 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32028 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32032 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32036 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32040 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32044 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32047 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32052 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32056 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32060 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32062 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32066 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32070 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32074 */     // MIs[6] src0
     /*  32074 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32079 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  32090 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32094 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32098 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32102 */     // MIs[7] src1
     /*  32102 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32107 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  32118 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32120 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  32123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  32146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32161 */     GIR_RootConstrainSelectedInstOperands,
     /*  32162 */     // GIR_Coverage, 2754,
     /*  32162 */     GIR_EraseRootFromParent_Done,
     /*  32163 */   // Label 233: @32163
     /*  32163 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(32386), // Rule ID 8522 //
     /*  32168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32201 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32204 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32213 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32231 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32235 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32259 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32263 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32267 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32270 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32275 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32279 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32283 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32285 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32289 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32293 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32297 */     // MIs[6] src0
     /*  32297 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32302 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  32313 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32317 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32321 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32325 */     // MIs[7] src1
     /*  32325 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32330 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  32341 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32343 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  32369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32384 */     GIR_RootConstrainSelectedInstOperands,
     /*  32385 */     // GIR_Coverage, 8522,
     /*  32385 */     GIR_EraseRootFromParent_Done,
     /*  32386 */   // Label 234: @32386
     /*  32386 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(32601), // Rule ID 8555 //
     /*  32391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32406 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32409 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32436 */     // MIs[2] Operand 2
     /*  32436 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32459 */     // MIs[3] Operand 2
     /*  32459 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32482 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32486 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  32492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32496 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32499 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32504 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32508 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32512 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32518 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32522 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32526 */     // MIs[6] src0
     /*  32526 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32531 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32535 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32539 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32543 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32547 */     // MIs[7] src1
     /*  32547 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32552 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32556 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32558 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  32584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32599 */     GIR_RootConstrainSelectedInstOperands,
     /*  32600 */     // GIR_Coverage, 8555,
     /*  32600 */     GIR_EraseRootFromParent_Done,
     /*  32601 */   // Label 235: @32601
     /*  32601 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(32816), // Rule ID 8556 //
     /*  32606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32621 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32624 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32651 */     // MIs[2] Operand 2
     /*  32651 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32674 */     // MIs[3] Operand 2
     /*  32674 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32685 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32689 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32693 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32697 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32701 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  32707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32711 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32714 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32719 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32723 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32727 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32733 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32737 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32741 */     // MIs[6] src0
     /*  32741 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32746 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32750 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32754 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32758 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32762 */     // MIs[7] src1
     /*  32762 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32767 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32771 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32773 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  32799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32814 */     GIR_RootConstrainSelectedInstOperands,
     /*  32815 */     // GIR_Coverage, 8556,
     /*  32815 */     GIR_EraseRootFromParent_Done,
     /*  32816 */   // Label 236: @32816
     /*  32816 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(33031), // Rule ID 2758 //
     /*  32821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32854 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32857 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32866 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32870 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32888 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32908 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32912 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32916 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32920 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32923 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32932 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32936 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32938 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32942 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32946 */     // MIs[6] src0
     /*  32946 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32951 */     // MIs[6] Operand 2
     /*  32951 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  32962 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32966 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32970 */     // MIs[7] src1
     /*  32970 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32975 */     // MIs[7] Operand 2
     /*  32975 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  32986 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32988 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  33007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  33014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33029 */     GIR_RootConstrainSelectedInstOperands,
     /*  33030 */     // GIR_Coverage, 2758,
     /*  33030 */     GIR_EraseRootFromParent_Done,
     /*  33031 */   // Label 237: @33031
     /*  33031 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(33246), // Rule ID 8554 //
     /*  33036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  33039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  33051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33069 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33072 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33081 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  33087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  33095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  33099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  33103 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  33107 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  33111 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  33115 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  33119 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  33123 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  33127 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33131 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33135 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  33138 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33143 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  33147 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  33151 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  33153 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33157 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  33161 */     // MIs[6] src0
     /*  33161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33166 */     // MIs[6] Operand 2
     /*  33166 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  33177 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  33181 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  33185 */     // MIs[7] src1
     /*  33185 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  33190 */     // MIs[7] Operand 2
     /*  33190 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  33203 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  33206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  33215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  33222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  33229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33244 */     GIR_RootConstrainSelectedInstOperands,
     /*  33245 */     // GIR_Coverage, 8554,
     /*  33245 */     GIR_EraseRootFromParent_Done,
     /*  33246 */   // Label 238: @33246
     /*  33246 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(33299), // Rule ID 7571 //
     /*  33251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /*  33283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33285 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_13743>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /*  33288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33297 */     GIR_RootConstrainSelectedInstOperands,
     /*  33298 */     // GIR_Coverage, 7571,
     /*  33298 */     GIR_EraseRootFromParent_Done,
     /*  33299 */   // Label 239: @33299
     /*  33299 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(33352), // Rule ID 7573 //
     /*  33304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  33336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33338 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_19651>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /*  33341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33350 */     GIR_RootConstrainSelectedInstOperands,
     /*  33351 */     // GIR_Coverage, 7573,
     /*  33351 */     GIR_EraseRootFromParent_Done,
     /*  33352 */   // Label 240: @33352
     /*  33352 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(33462), // Rule ID 7382 //
     /*  33357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33377 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33395 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33399 */     // MIs[2] Operand 1
     /*  33399 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33412 */     // MIs[3] src0
     /*  33412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33417 */     // MIs[3] src1
     /*  33417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33426 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33430 */     // MIs[4] src1
     /*  33430 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33435 */     // MIs[4] src0
     /*  33435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33442 */     // (add:{ *:[i32] } (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33460 */     GIR_RootConstrainSelectedInstOperands,
     /*  33461 */     // GIR_Coverage, 7382,
     /*  33461 */     GIR_EraseRootFromParent_Done,
     /*  33462 */   // Label 241: @33462
     /*  33462 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(33572), // Rule ID 11196 //
     /*  33467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33505 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33509 */     // MIs[2] Operand 1
     /*  33509 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33522 */     // MIs[3] src0
     /*  33522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33527 */     // MIs[3] src1
     /*  33527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33540 */     // MIs[4] src1
     /*  33540 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33545 */     // MIs[4] src0
     /*  33545 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33550 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33552 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33570 */     GIR_RootConstrainSelectedInstOperands,
     /*  33571 */     // GIR_Coverage, 11196,
     /*  33571 */     GIR_EraseRootFromParent_Done,
     /*  33572 */   // Label 242: @33572
     /*  33572 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(33665), // Rule ID 2590 //
     /*  33577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33602 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33622 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33634 */     // MIs[3] Operand 1
     /*  33634 */     // No operand predicates
     /*  33634 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33638 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  33642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20775),
     /*  33646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33648 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20776>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20775>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33663 */     GIR_RootConstrainSelectedInstOperands,
     /*  33664 */     // GIR_Coverage, 2590,
     /*  33664 */     GIR_EraseRootFromParent_Done,
     /*  33665 */   // Label 243: @33665
     /*  33665 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(33758), // Rule ID 8496 //
     /*  33670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33677 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  33681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33699 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33719 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33731 */     // MIs[3] Operand 1
     /*  33731 */     // No operand predicates
     /*  33731 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20775),
     /*  33739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33741 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20776>>)<<P:1:Predicate_anonymous_20775>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33756 */     GIR_RootConstrainSelectedInstOperands,
     /*  33757 */     // GIR_Coverage, 8496,
     /*  33757 */     GIR_EraseRootFromParent_Done,
     /*  33758 */   // Label 244: @33758
     /*  33758 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(33813), // Rule ID 7322 //
     /*  33763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33775 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33778 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33793 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  33796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33811 */     GIR_RootConstrainSelectedInstOperands,
     /*  33812 */     // GIR_Coverage, 7322,
     /*  33812 */     GIR_EraseRootFromParent_Done,
     /*  33813 */   // Label 245: @33813
     /*  33813 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(33868), // Rule ID 7324 //
     /*  33818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33830 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33833 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  33838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33848 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  33851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33866 */     GIR_RootConstrainSelectedInstOperands,
     /*  33867 */     // GIR_Coverage, 7324,
     /*  33867 */     GIR_EraseRootFromParent_Done,
     /*  33868 */   // Label 246: @33868
     /*  33868 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(33933), // Rule ID 82 //
     /*  33873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33903 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  33907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  33915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33917 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  33920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33931 */     GIR_RootConstrainSelectedInstOperands,
     /*  33932 */     // GIR_Coverage, 82,
     /*  33932 */     GIR_EraseRootFromParent_Done,
     /*  33933 */   // Label 247: @33933
     /*  33933 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(33998), // Rule ID 83 //
     /*  33938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  33972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  33980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33982 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  33985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33996 */     GIR_RootConstrainSelectedInstOperands,
     /*  33997 */     // GIR_Coverage, 83,
     /*  33997 */     GIR_EraseRootFromParent_Done,
     /*  33998 */   // Label 248: @33998
     /*  33998 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(34063), // Rule ID 84 //
     /*  34003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  34037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34047 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34061 */     GIR_RootConstrainSelectedInstOperands,
     /*  34062 */     // GIR_Coverage, 84,
     /*  34062 */     GIR_EraseRootFromParent_Done,
     /*  34063 */   // Label 249: @34063
     /*  34063 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(34128), // Rule ID 85 //
     /*  34068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34098 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  34102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  34110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34112 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  34115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34126 */     GIR_RootConstrainSelectedInstOperands,
     /*  34127 */     // GIR_Coverage, 85,
     /*  34127 */     GIR_EraseRootFromParent_Done,
     /*  34128 */   // Label 250: @34128
     /*  34128 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(34211), // Rule ID 7381 //
     /*  34133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34153 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34179 */     // MIs[3] src0
     /*  34179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34184 */     // MIs[3] src1
     /*  34184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34191 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34209 */     GIR_RootConstrainSelectedInstOperands,
     /*  34210 */     // GIR_Coverage, 7381,
     /*  34210 */     GIR_EraseRootFromParent_Done,
     /*  34211 */   // Label 251: @34211
     /*  34211 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(34294), // Rule ID 11189 //
     /*  34216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34262 */     // MIs[3] src1
     /*  34262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34267 */     // MIs[3] src0
     /*  34267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34274 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34292 */     GIR_RootConstrainSelectedInstOperands,
     /*  34293 */     // GIR_Coverage, 11189,
     /*  34293 */     GIR_EraseRootFromParent_Done,
     /*  34294 */   // Label 252: @34294
     /*  34294 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(34377), // Rule ID 11190 //
     /*  34299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34345 */     // MIs[3] src0
     /*  34345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34350 */     // MIs[3] src1
     /*  34350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34357 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34375 */     GIR_RootConstrainSelectedInstOperands,
     /*  34376 */     // GIR_Coverage, 11190,
     /*  34376 */     GIR_EraseRootFromParent_Done,
     /*  34377 */   // Label 253: @34377
     /*  34377 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(34460), // Rule ID 11191 //
     /*  34382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34428 */     // MIs[3] src1
     /*  34428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34433 */     // MIs[3] src0
     /*  34433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34440 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34458 */     GIR_RootConstrainSelectedInstOperands,
     /*  34459 */     // GIR_Coverage, 11191,
     /*  34459 */     GIR_EraseRootFromParent_Done,
     /*  34460 */   // Label 254: @34460
     /*  34460 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(34525), // Rule ID 8413 //
     /*  34465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34499 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  34503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  34507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34509 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  34512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34523 */     GIR_RootConstrainSelectedInstOperands,
     /*  34524 */     // GIR_Coverage, 8413,
     /*  34524 */     GIR_EraseRootFromParent_Done,
     /*  34525 */   // Label 255: @34525
     /*  34525 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(34590), // Rule ID 8414 //
     /*  34530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  34568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  34572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34574 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  34577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34588 */     GIR_RootConstrainSelectedInstOperands,
     /*  34589 */     // GIR_Coverage, 8414,
     /*  34589 */     GIR_EraseRootFromParent_Done,
     /*  34590 */   // Label 256: @34590
     /*  34590 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(34655), // Rule ID 8415 //
     /*  34595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34629 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  34633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  34637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34639 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  34642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34653 */     GIR_RootConstrainSelectedInstOperands,
     /*  34654 */     // GIR_Coverage, 8415,
     /*  34654 */     GIR_EraseRootFromParent_Done,
     /*  34655 */   // Label 257: @34655
     /*  34655 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(34720), // Rule ID 8416 //
     /*  34660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  34698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  34702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34704 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  34707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34718 */     GIR_RootConstrainSelectedInstOperands,
     /*  34719 */     // GIR_Coverage, 8416,
     /*  34719 */     GIR_EraseRootFromParent_Done,
     /*  34720 */   // Label 258: @34720
     /*  34720 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(34775), // Rule ID 11156 //
     /*  34725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  34745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34755 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  34758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34773 */     GIR_RootConstrainSelectedInstOperands,
     /*  34774 */     // GIR_Coverage, 11156,
     /*  34774 */     GIR_EraseRootFromParent_Done,
     /*  34775 */   // Label 259: @34775
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(34830), // Rule ID 11158 //
     /*  34780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34792 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34795 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  34800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34810 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  34813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34828 */     GIR_RootConstrainSelectedInstOperands,
     /*  34829 */     // GIR_Coverage, 11158,
     /*  34829 */     GIR_EraseRootFromParent_Done,
     /*  34830 */   // Label 260: @34830
     /*  34830 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(34913), // Rule ID 11192 //
     /*  34835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34881 */     // MIs[3] src0
     /*  34881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34886 */     // MIs[3] src1
     /*  34886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34893 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34911 */     GIR_RootConstrainSelectedInstOperands,
     /*  34912 */     // GIR_Coverage, 11192,
     /*  34912 */     GIR_EraseRootFromParent_Done,
     /*  34913 */   // Label 261: @34913
     /*  34913 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(34996), // Rule ID 11193 //
     /*  34918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34938 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34964 */     // MIs[3] src1
     /*  34964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34969 */     // MIs[3] src0
     /*  34969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34976 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34994 */     GIR_RootConstrainSelectedInstOperands,
     /*  34995 */     // GIR_Coverage, 11193,
     /*  34995 */     GIR_EraseRootFromParent_Done,
     /*  34996 */   // Label 262: @34996
     /*  34996 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(35079), // Rule ID 11194 //
     /*  35001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  35013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  35031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  35035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  35039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  35043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  35047 */     // MIs[3] src0
     /*  35047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35052 */     // MIs[3] src1
     /*  35052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  35059 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  35059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  35062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  35068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  35072 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  35074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35077 */     GIR_RootConstrainSelectedInstOperands,
     /*  35078 */     // GIR_Coverage, 11194,
     /*  35078 */     GIR_EraseRootFromParent_Done,
     /*  35079 */   // Label 263: @35079
     /*  35079 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(35162), // Rule ID 11195 //
     /*  35084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  35096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35104 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  35114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  35118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  35122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  35126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  35130 */     // MIs[3] src1
     /*  35130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35135 */     // MIs[3] src0
     /*  35135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  35142 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  35142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  35151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  35155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  35157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35160 */     GIR_RootConstrainSelectedInstOperands,
     /*  35161 */     // GIR_Coverage, 11195,
     /*  35161 */     GIR_EraseRootFromParent_Done,
     /*  35162 */   // Label 264: @35162
     /*  35162 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(35327), // Rule ID 8506 //
     /*  35167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35174 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:11:z
     /*  35178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35200 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35204 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  35212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35214 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:11:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20811>>)<<P:11:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35214 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35244 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35247 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35250 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35326 */     // GIR_Coverage, 8506,
     /*  35326 */     GIR_EraseRootFromParent_Done,
     /*  35327 */   // Label 265: @35327
     /*  35327 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(35492), // Rule ID 8510 //
     /*  35332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35339 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:14:z
     /*  35343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35365 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35369 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  35377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35379 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:14:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20811>>)<<P:14:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35379 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35382 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35386 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35409 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35412 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35415 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35474 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35491 */     // GIR_Coverage, 8510,
     /*  35491 */     GIR_EraseRootFromParent_Done,
     /*  35492 */   // Label 266: @35492
     /*  35492 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(35557), // Rule ID 2593 //
     /*  35497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  35500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35522 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  35526 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  35530 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:3:z
     /*  35534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20781),
     /*  35538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35540 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20779>>, i32:{ *:[i32] }:$src2:$pred:3:z)<<P:3:Predicate_anonymous_20781>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  35540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  35543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  35555 */     GIR_RootConstrainSelectedInstOperands,
     /*  35556 */     // GIR_Coverage, 2593,
     /*  35556 */     GIR_EraseRootFromParent_Done,
     /*  35557 */   // Label 267: @35557
     /*  35557 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(35722), // Rule ID 2612 //
     /*  35562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35587 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35591 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35595 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:11:z
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  35607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35609 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20811>>, VGPR_32:{ *:[i32] }:$src2:$pred:11:z)<<P:11:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35609 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35639 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35645 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35721 */     // GIR_Coverage, 2612,
     /*  35721 */     GIR_EraseRootFromParent_Done,
     /*  35722 */   // Label 268: @35722
     /*  35722 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(35887), // Rule ID 2617 //
     /*  35727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35752 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35756 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:14:z
     /*  35764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  35772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35774 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20811>>, VGPR_32:{ *:[i32] }:$src2:$pred:14:z)<<P:14:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35777 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35781 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35800 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35804 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35807 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35810 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35886 */     // GIR_Coverage, 2617,
     /*  35886 */     GIR_EraseRootFromParent_Done,
     /*  35887 */   // Label 269: @35887
     /*  35887 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(36048), // Rule ID 2611 //
     /*  35892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35917 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  35921 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  35925 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:10:z
     /*  35929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  35933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35935 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20811>>, i32:{ *:[i32] }:$src2:$pred:10:z)<<P:10:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35935 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35949 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35961 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35965 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35968 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35971 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  35979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  35984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  35989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36047 */     // GIR_Coverage, 2611,
     /*  36047 */     GIR_EraseRootFromParent_Done,
     /*  36048 */   // Label 270: @36048
     /*  36048 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(36209), // Rule ID 2616 //
     /*  36053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  36056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36078 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  36082 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  36086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:13:z
     /*  36090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  36094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36096 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20811>>, i32:{ *:[i32] }:$src2:$pred:13:z)<<P:13:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36096 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36099 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36103 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  36126 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36129 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36132 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36145 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  36160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36191 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36208 */     // GIR_Coverage, 2616,
     /*  36208 */     GIR_EraseRootFromParent_Done,
     /*  36209 */   // Label 271: @36209
     /*  36209 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(36274), // Rule ID 2589 //
     /*  36214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36239 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36243 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36247 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  36251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20775),
     /*  36255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36257 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20776>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20775>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36272 */     GIR_RootConstrainSelectedInstOperands,
     /*  36273 */     // GIR_Coverage, 2589,
     /*  36273 */     GIR_EraseRootFromParent_Done,
     /*  36274 */   // Label 272: @36274
     /*  36274 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(36339), // Rule ID 2599 //
     /*  36279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36304 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36308 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36312 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:8:z
     /*  36316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20794),
     /*  36320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36322 */     // (add:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20795>>, i32:{ *:[i32] }:$src2:$pred:8:z)<<P:8:Predicate_anonymous_20794>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36337 */     GIR_RootConstrainSelectedInstOperands,
     /*  36338 */     // GIR_Coverage, 2599,
     /*  36338 */     GIR_EraseRootFromParent_Done,
     /*  36339 */   // Label 273: @36339
     /*  36339 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(36379), // Rule ID 7020 //
     /*  36344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36360 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34193),
     /*  36364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36366 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34193>>, i32:{ *:[i32] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36375 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  36377 */     GIR_RootConstrainSelectedInstOperands,
     /*  36378 */     // GIR_Coverage, 7020,
     /*  36378 */     GIR_EraseRootFromParent_Done,
     /*  36379 */   // Label 274: @36379
     /*  36379 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(36444), // Rule ID 8497 //
     /*  36384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:3:z
     /*  36395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36413 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  36417 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  36421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20781),
     /*  36425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36427 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:3:z, (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20779>>)<<P:3:Predicate_anonymous_20781>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  36430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36442 */     GIR_RootConstrainSelectedInstOperands,
     /*  36443 */     // GIR_Coverage, 8497,
     /*  36443 */     GIR_EraseRootFromParent_Done,
     /*  36444 */   // Label 275: @36444
     /*  36444 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(36605), // Rule ID 8505 //
     /*  36449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  36452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36456 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:10:z
     /*  36460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36478 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  36482 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  36486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  36490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36492 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:10:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20811>>)<<P:10:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36492 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36518 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36522 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36528 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  36556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36587 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36604 */     // GIR_Coverage, 8505,
     /*  36604 */     GIR_EraseRootFromParent_Done,
     /*  36605 */   // Label 276: @36605
     /*  36605 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(36766), // Rule ID 8509 //
     /*  36610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  36613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36617 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:13:z
     /*  36621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36639 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  36643 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  36647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20810),
     /*  36651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36653 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:13:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20811>>)<<P:13:Predicate_anonymous_20810>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36656 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36660 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36683 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36686 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36689 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  36717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36765 */     // GIR_Coverage, 8509,
     /*  36765 */     GIR_EraseRootFromParent_Done,
     /*  36766 */   // Label 277: @36766
     /*  36766 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(36831), // Rule ID 8495 //
     /*  36771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36778 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  36782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36800 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36804 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20775),
     /*  36812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36814 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20776>>)<<P:1:Predicate_anonymous_20775>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36829 */     GIR_RootConstrainSelectedInstOperands,
     /*  36830 */     // GIR_Coverage, 8495,
     /*  36830 */     GIR_EraseRootFromParent_Done,
     /*  36831 */   // Label 278: @36831
     /*  36831 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(36896), // Rule ID 8502 //
     /*  36836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:8:z
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36865 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36869 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20794),
     /*  36877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36879 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:8:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20795>>)<<P:8:Predicate_anonymous_20794>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36894 */     GIR_RootConstrainSelectedInstOperands,
     /*  36895 */     // GIR_Coverage, 8502,
     /*  36895 */     GIR_EraseRootFromParent_Done,
     /*  36896 */   // Label 279: @36896
     /*  36896 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(36936), // Rule ID 11154 //
     /*  36901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36917 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34193),
     /*  36921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36923 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$val, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34193>>)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36932 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36934 */     GIR_RootConstrainSelectedInstOperands,
     /*  36935 */     // GIR_Coverage, 11154,
     /*  36935 */     GIR_EraseRootFromParent_Done,
     /*  36936 */   // Label 280: @36936
     /*  36936 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(36980), // Rule ID 7566 //
     /*  36941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  36957 */     // MIs[1] Operand 1
     /*  36957 */     // No operand predicates
     /*  36957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /*  36961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36963 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i1 i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  36963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  36966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  36968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36970 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  36975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  36978 */     GIR_RootConstrainSelectedInstOperands,
     /*  36979 */     // GIR_Coverage, 7566,
     /*  36979 */     GIR_EraseRootFromParent_Done,
     /*  36980 */   // Label 281: @36980
     /*  36980 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(37027), // Rule ID 7567 //
     /*  36985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  36988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  37004 */     // MIs[1] Operand 1
     /*  37004 */     // No operand predicates
     /*  37004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  37008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37010 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19651>>  =>  (V_SUB_U32_e64:{ *:[i32] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  37010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  37013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37017 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  37022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37025 */     GIR_RootConstrainSelectedInstOperands,
     /*  37026 */     // GIR_Coverage, 7567,
     /*  37026 */     GIR_EraseRootFromParent_Done,
     /*  37027 */   // Label 282: @37027
     /*  37027 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(37082), // Rule ID 7568 //
     /*  37032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasAddNoCarryInsts),
     /*  37035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  37051 */     // MIs[1] Operand 1
     /*  37051 */     // No operand predicates
     /*  37051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  37055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37057 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19651>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  37057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  37063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37065 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37072 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  37077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37080 */     GIR_RootConstrainSelectedInstOperands,
     /*  37081 */     // GIR_Coverage, 7568,
     /*  37081 */     GIR_EraseRootFromParent_Done,
     /*  37082 */   // Label 283: @37082
     /*  37082 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(37116), // Rule ID 43 //
     /*  37087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /*  37103 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  37103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_I32),
     /*  37108 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37114 */     GIR_RootConstrainSelectedInstOperands,
     /*  37115 */     // GIR_Coverage, 43,
     /*  37115 */     GIR_Done,
     /*  37116 */   // Label 284: @37116
     /*  37116 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(37146), // Rule ID 2492 //
     /*  37121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  37124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  37132 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19651>>  =>  (V_ADD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  37132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /*  37135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37144 */     GIR_RootConstrainSelectedInstOperands,
     /*  37145 */     // GIR_Coverage, 2492,
     /*  37145 */     GIR_EraseRootFromParent_Done,
     /*  37146 */   // Label 285: @37146
     /*  37146 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(37184), // Rule ID 2494 //
     /*  37151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  37154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  37162 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19651>>  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  37162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /*  37168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37170 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37182 */     GIR_RootConstrainSelectedInstOperands,
     /*  37183 */     // GIR_Coverage, 2494,
     /*  37183 */     GIR_EraseRootFromParent_Done,
     /*  37184 */   // Label 286: @37184
     /*  37184 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(37220), // Rule ID 817 //
     /*  37189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37207 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37218 */     GIR_RootConstrainSelectedInstOperands,
     /*  37219 */     // GIR_Coverage, 817,
     /*  37219 */     GIR_EraseRootFromParent_Done,
     /*  37220 */   // Label 287: @37220
     /*  37220 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(37256), // Rule ID 8428 //
     /*  37225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37243 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src1, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37254 */     GIR_RootConstrainSelectedInstOperands,
     /*  37255 */     // GIR_Coverage, 8428,
     /*  37255 */     GIR_EraseRootFromParent_Done,
     /*  37256 */   // Label 288: @37256
     /*  37256 */   GIM_Reject,
     /*  37257 */ // Label 198: @37257
     /*  37257 */ GIM_Reject,
     /*  37258 */ // Label 171: @37258
     /*  37258 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(37728),
     /*  37263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37269 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(37335), // Rule ID 2614 //
     /*  37274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37289 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37292 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37301 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37307 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37315 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37333 */     GIR_RootConstrainSelectedInstOperands,
     /*  37334 */     // GIR_Coverage, 2614,
     /*  37334 */     GIR_EraseRootFromParent_Done,
     /*  37335 */   // Label 290: @37335
     /*  37335 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(37401), // Rule ID 2619 //
     /*  37340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37355 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37358 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37367 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37373 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37381 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37399 */     GIR_RootConstrainSelectedInstOperands,
     /*  37400 */     // GIR_Coverage, 2619,
     /*  37400 */     GIR_EraseRootFromParent_Done,
     /*  37401 */   // Label 291: @37401
     /*  37401 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(37467), // Rule ID 8507 //
     /*  37406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37421 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37424 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37433 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37439 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37447 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37465 */     GIR_RootConstrainSelectedInstOperands,
     /*  37466 */     // GIR_Coverage, 8507,
     /*  37466 */     GIR_EraseRootFromParent_Done,
     /*  37467 */   // Label 292: @37467
     /*  37467 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(37533), // Rule ID 8511 //
     /*  37472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37487 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37490 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37505 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37513 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37531 */     GIR_RootConstrainSelectedInstOperands,
     /*  37532 */     // GIR_Coverage, 8511,
     /*  37532 */     GIR_EraseRootFromParent_Done,
     /*  37533 */   // Label 293: @37533
     /*  37533 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(37602), // Rule ID 2601 //
     /*  37538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37563 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37567 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37571 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37575 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:9:z
     /*  37579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20798),
     /*  37583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37585 */     // (add:{ *:[i64] } (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20799>>, i64:{ *:[i64] }:$src2:$pred:9:z)<<P:9:Predicate_anonymous_20798>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37600 */     GIR_RootConstrainSelectedInstOperands,
     /*  37601 */     // GIR_Coverage, 2601,
     /*  37601 */     GIR_EraseRootFromParent_Done,
     /*  37602 */   // Label 294: @37602
     /*  37602 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(37671), // Rule ID 8503 //
     /*  37607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:9:z
     /*  37618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37636 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37640 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37644 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20798),
     /*  37652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37654 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2:$pred:9:z, (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20799>>)<<P:9:Predicate_anonymous_20798>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37669 */     GIR_RootConstrainSelectedInstOperands,
     /*  37670 */     // GIR_Coverage, 8503,
     /*  37670 */     GIR_EraseRootFromParent_Done,
     /*  37671 */   // Label 295: @37671
     /*  37671 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(37701), // Rule ID 1338 //
     /*  37676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  37684 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19651>>  =>  (V_ADD_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U64_PSEUDO),
     /*  37689 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  37695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  37699 */     GIR_RootConstrainSelectedInstOperands,
     /*  37700 */     // GIR_Coverage, 1338,
     /*  37700 */     GIR_Done,
     /*  37701 */   // Label 296: @37701
     /*  37701 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(37727), // Rule ID 1340 //
     /*  37706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  37710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /*  37714 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_U64_PSEUDO),
     /*  37719 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37725 */     GIR_RootConstrainSelectedInstOperands,
     /*  37726 */     // GIR_Coverage, 1340,
     /*  37726 */     GIR_Done,
     /*  37727 */   // Label 297: @37727
     /*  37727 */   GIM_Reject,
     /*  37728 */ // Label 289: @37728
     /*  37728 */ GIM_Reject,
     /*  37729 */ // Label 172: @37729
     /*  37729 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(37998),
     /*  37734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37744 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(37840), // Rule ID 8478 //
     /*  37749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37788 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /*  37798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /*  37803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_modifiers
     /*  37808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /*  37813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /*  37818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /*  37823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37838 */     GIR_RootConstrainSelectedInstOperands,
     /*  37839 */     // GIR_Coverage, 8478,
     /*  37839 */     GIR_EraseRootFromParent_Done,
     /*  37840 */   // Label 299: @37840
     /*  37840 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(37936), // Rule ID 1087 //
     /*  37845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37884 */     // (add:{ *:[v2i16] } (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  37914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  37919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37934 */     GIR_RootConstrainSelectedInstOperands,
     /*  37935 */     // GIR_Coverage, 1087,
     /*  37935 */     GIR_EraseRootFromParent_Done,
     /*  37936 */   // Label 300: @37936
     /*  37936 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(37997), // Rule ID 1098 //
     /*  37941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37955 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  37955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /*  37958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37995 */     GIR_RootConstrainSelectedInstOperands,
     /*  37996 */     // GIR_Coverage, 1098,
     /*  37996 */     GIR_EraseRootFromParent_Done,
     /*  37997 */   // Label 301: @37997
     /*  37997 */   GIM_Reject,
     /*  37998 */ // Label 298: @37998
     /*  37998 */ GIM_Reject,
     /*  37999 */ // Label 173: @37999
     /*  37999 */ GIM_Reject,
     /*  38000 */ // Label 1: @38000
     /*  38000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 307*/ GIMT_Encode4(38622),
     /*  38011 */ /*GILLT_s1*//*Label 302*/ GIMT_Encode4(38031),
     /*  38015 */ /*GILLT_s16*//*Label 303*/ GIMT_Encode4(38150),
     /*  38019 */ /*GILLT_s32*//*Label 304*/ GIMT_Encode4(38366),
     /*  38023 */ /*GILLT_s64*//*Label 305*/ GIMT_Encode4(38481),
     /*  38027 */ /*GILLT_v2s16*//*Label 306*/ GIMT_Encode4(38550),
     /*  38031 */ // Label 302: @38031
     /*  38031 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(38149),
     /*  38036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  38039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  38042 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(38070), // Rule ID 7422 //
     /*  38047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  38050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  38058 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  38058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  38061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  38063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  38068 */     GIR_RootConstrainSelectedInstOperands,
     /*  38069 */     // GIR_Coverage, 7422,
     /*  38069 */     GIR_EraseRootFromParent_Done,
     /*  38070 */   // Label 309: @38070
     /*  38070 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(38098), // Rule ID 7429 //
     /*  38075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  38086 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  38086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  38089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  38096 */     GIR_RootConstrainSelectedInstOperands,
     /*  38097 */     // GIR_Coverage, 7429,
     /*  38097 */     GIR_EraseRootFromParent_Done,
     /*  38098 */   // Label 310: @38098
     /*  38098 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(38123), // Rule ID 7420 //
     /*  38103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  38106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38110 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  38115 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38121 */     GIR_RootConstrainSelectedInstOperands,
     /*  38122 */     // GIR_Coverage, 7420,
     /*  38122 */     GIR_Done,
     /*  38123 */   // Label 311: @38123
     /*  38123 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(38148), // Rule ID 7427 //
     /*  38128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  38131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38135 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  38140 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38146 */     GIR_RootConstrainSelectedInstOperands,
     /*  38147 */     // GIR_Coverage, 7427,
     /*  38147 */     GIR_Done,
     /*  38148 */   // Label 312: @38148
     /*  38148 */   GIM_Reject,
     /*  38149 */ // Label 308: @38149
     /*  38149 */ GIM_Reject,
     /*  38150 */ // Label 303: @38150
     /*  38150 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(38365),
     /*  38155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38161 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(38220), // Rule ID 1069 //
     /*  38166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  38169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38187 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  38190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38218 */     GIR_RootConstrainSelectedInstOperands,
     /*  38219 */     // GIR_Coverage, 1069,
     /*  38219 */     GIR_EraseRootFromParent_Done,
     /*  38220 */   // Label 314: @38220
     /*  38220 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(38279), // Rule ID 1070 //
     /*  38225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  38228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38246 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38277 */     GIR_RootConstrainSelectedInstOperands,
     /*  38278 */     // GIR_Coverage, 1070,
     /*  38278 */     GIR_EraseRootFromParent_Done,
     /*  38279 */   // Label 315: @38279
     /*  38279 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(38338), // Rule ID 1071 //
     /*  38284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  38287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38305 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  38308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38336 */     GIR_RootConstrainSelectedInstOperands,
     /*  38337 */     // GIR_Coverage, 1071,
     /*  38337 */     GIR_EraseRootFromParent_Done,
     /*  38338 */   // Label 316: @38338
     /*  38338 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(38364), // Rule ID 910 //
     /*  38343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  38346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38350 */     // (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  38353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38362 */     GIR_RootConstrainSelectedInstOperands,
     /*  38363 */     // GIR_Coverage, 910,
     /*  38363 */     GIR_EraseRootFromParent_Done,
     /*  38364 */   // Label 317: @38364
     /*  38364 */   GIM_Reject,
     /*  38365 */ // Label 313: @38365
     /*  38365 */ GIM_Reject,
     /*  38366 */ // Label 304: @38366
     /*  38366 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(38480),
     /*  38371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38377 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(38411), // Rule ID 44 //
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /*  38398 */     // (sub:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  38398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  38403 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38409 */     GIR_RootConstrainSelectedInstOperands,
     /*  38410 */     // GIR_Coverage, 44,
     /*  38410 */     GIR_Done,
     /*  38411 */   // Label 319: @38411
     /*  38411 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(38441), // Rule ID 2493 //
     /*  38416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  38419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19653),
     /*  38427 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19653>>  =>  (V_SUB_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  38430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38439 */     GIR_RootConstrainSelectedInstOperands,
     /*  38440 */     // GIR_Coverage, 2493,
     /*  38440 */     GIR_EraseRootFromParent_Done,
     /*  38441 */   // Label 320: @38441
     /*  38441 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(38479), // Rule ID 2495 //
     /*  38446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  38449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19653),
     /*  38457 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19653>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  38460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  38463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38465 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  38470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38477 */     GIR_RootConstrainSelectedInstOperands,
     /*  38478 */     // GIR_Coverage, 2495,
     /*  38478 */     GIR_EraseRootFromParent_Done,
     /*  38479 */   // Label 321: @38479
     /*  38479 */   GIM_Reject,
     /*  38480 */ // Label 318: @38480
     /*  38480 */ GIM_Reject,
     /*  38481 */ // Label 305: @38481
     /*  38481 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(38549),
     /*  38486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38492 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(38522), // Rule ID 1339 //
     /*  38497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  38501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19653),
     /*  38505 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19653>>  =>  (V_SUB_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U64_PSEUDO),
     /*  38510 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  38516 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38520 */     GIR_RootConstrainSelectedInstOperands,
     /*  38521 */     // GIR_Coverage, 1339,
     /*  38521 */     GIR_Done,
     /*  38522 */   // Label 323: @38522
     /*  38522 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(38548), // Rule ID 1341 //
     /*  38527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /*  38535 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_SUB_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_U64_PSEUDO),
     /*  38540 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38546 */     GIR_RootConstrainSelectedInstOperands,
     /*  38547 */     // GIR_Coverage, 1341,
     /*  38547 */     GIR_Done,
     /*  38548 */   // Label 324: @38548
     /*  38548 */   GIM_Reject,
     /*  38549 */ // Label 322: @38549
     /*  38549 */ GIM_Reject,
     /*  38550 */ // Label 306: @38550
     /*  38550 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(38621), // Rule ID 1106 //
     /*  38555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38579 */   // (sub:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /*  38582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38619 */   GIR_RootConstrainSelectedInstOperands,
     /*  38620 */   // GIR_Coverage, 1106,
     /*  38620 */   GIR_EraseRootFromParent_Done,
     /*  38621 */ // Label 325: @38621
     /*  38621 */ GIM_Reject,
     /*  38622 */ // Label 307: @38622
     /*  38622 */ GIM_Reject,
     /*  38623 */ // Label 2: @38623
     /*  38623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 330*/ GIMT_Encode4(38968),
     /*  38634 */ /*GILLT_s16*//*Label 326*/ GIMT_Encode4(38650),
     /*  38638 */ /*GILLT_s32*//*Label 327*/ GIMT_Encode4(38765),
     /*  38642 */ /*GILLT_s64*//*Label 328*/ GIMT_Encode4(38866),
     /*  38646 */ /*GILLT_v2s16*//*Label 329*/ GIMT_Encode4(38896),
     /*  38650 */ // Label 326: @38650
     /*  38650 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(38764),
     /*  38655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38661 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(38717), // Rule ID 877 //
     /*  38666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  38669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38687 */     // (mul:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LO_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_t16_e64),
     /*  38690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38715 */     GIR_RootConstrainSelectedInstOperands,
     /*  38716 */     // GIR_Coverage, 877,
     /*  38716 */     GIR_EraseRootFromParent_Done,
     /*  38717 */   // Label 332: @38717
     /*  38717 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(38740), // Rule ID 876 //
     /*  38722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  38725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38729 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /*  38734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38738 */     GIR_RootConstrainSelectedInstOperands,
     /*  38739 */     // GIR_Coverage, 876,
     /*  38739 */     GIR_Done,
     /*  38740 */   // Label 333: @38740
     /*  38740 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(38763), // Rule ID 878 //
     /*  38745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  38748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38752 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_fake16_e64),
     /*  38757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38761 */     GIR_RootConstrainSelectedInstOperands,
     /*  38762 */     // GIR_Coverage, 878,
     /*  38762 */     GIR_Done,
     /*  38763 */   // Label 334: @38763
     /*  38763 */   GIM_Reject,
     /*  38764 */ // Label 331: @38764
     /*  38764 */ GIM_Reject,
     /*  38765 */ // Label 327: @38765
     /*  38765 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(38865),
     /*  38770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38776 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(38796), // Rule ID 81 //
     /*  38781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13751),
     /*  38789 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13751>>  =>  (S_MUL_I32:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_I32),
     /*  38794 */     GIR_RootConstrainSelectedInstOperands,
     /*  38795 */     // GIR_Coverage, 81,
     /*  38795 */     GIR_Done,
     /*  38796 */   // Label 336: @38796
     /*  38796 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(38830), // Rule ID 938 //
     /*  38801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20143),
     /*  38809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38816 */     // (mul:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_20143>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38828 */     GIR_RootConstrainSelectedInstOperands,
     /*  38829 */     // GIR_Coverage, 938,
     /*  38829 */     GIR_EraseRootFromParent_Done,
     /*  38830 */   // Label 337: @38830
     /*  38830 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(38864), // Rule ID 8468 //
     /*  38835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20143),
     /*  38843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38850 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_20143>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38862 */     GIR_RootConstrainSelectedInstOperands,
     /*  38863 */     // GIR_Coverage, 8468,
     /*  38863 */     GIR_EraseRootFromParent_Done,
     /*  38864 */   // Label 338: @38864
     /*  38864 */   GIM_Reject,
     /*  38865 */ // Label 335: @38865
     /*  38865 */ GIM_Reject,
     /*  38866 */ // Label 328: @38866
     /*  38866 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(38895), // Rule ID 51 //
     /*  38871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  38874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38884 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13751),
     /*  38888 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13751>>  =>  (S_MUL_U64:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_U64),
     /*  38893 */   GIR_RootConstrainSelectedInstOperands,
     /*  38894 */   // GIR_Coverage, 51,
     /*  38894 */   GIR_Done,
     /*  38895 */ // Label 339: @38895
     /*  38895 */ GIM_Reject,
     /*  38896 */ // Label 329: @38896
     /*  38896 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(38967), // Rule ID 1099 //
     /*  38901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38925 */   // (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_LO_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_LO_U16),
     /*  38928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38965 */   GIR_RootConstrainSelectedInstOperands,
     /*  38966 */   // GIR_Coverage, 1099,
     /*  38966 */   GIR_EraseRootFromParent_Done,
     /*  38967 */ // Label 340: @38967
     /*  38967 */ GIM_Reject,
     /*  38968 */ // Label 330: @38968
     /*  38968 */ GIM_Reject,
     /*  38969 */ // Label 3: @38969
     /*  38969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 348*/ GIMT_Encode4(40369),
     /*  38980 */ /*GILLT_s1*//*Label 341*/ GIMT_Encode4(39020),
     /*  38984 */ /*GILLT_s16*//*Label 342*/ GIMT_Encode4(39083),
     /*  38988 */ /*GILLT_s32*//*Label 343*/ GIMT_Encode4(39323),
     /*  38992 */ /*GILLT_s64*//*Label 344*/ GIMT_Encode4(39847),
     /*  38996 */ /*GILLT_v2s16*//*Label 345*/ GIMT_Encode4(39972),
     /*  39000 */ /*GILLT_v2s32*//*Label 346*/ GIMT_Encode4(40123), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  39016 */ /*GILLT_v4s16*//*Label 347*/ GIMT_Encode4(40246),
     /*  39020 */ // Label 341: @39020
     /*  39020 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(39082),
     /*  39025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  39028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  39031 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(39056), // Rule ID 7416 //
     /*  39036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  39039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39043 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  39043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  39048 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39054 */     GIR_RootConstrainSelectedInstOperands,
     /*  39055 */     // GIR_Coverage, 7416,
     /*  39055 */     GIR_Done,
     /*  39056 */   // Label 350: @39056
     /*  39056 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(39081), // Rule ID 7423 //
     /*  39061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  39064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39068 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  39068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  39073 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39079 */     GIR_RootConstrainSelectedInstOperands,
     /*  39080 */     // GIR_Coverage, 7423,
     /*  39080 */     GIR_Done,
     /*  39081 */   // Label 351: @39081
     /*  39081 */   GIM_Reject,
     /*  39082 */ // Label 349: @39082
     /*  39082 */ GIM_Reject,
     /*  39083 */ // Label 342: @39083
     /*  39083 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(39322),
     /*  39088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  39091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  39094 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(39145), // Rule ID 8480 //
     /*  39099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  39115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  39119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39129 */     // (and:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  39129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39143 */     GIR_RootConstrainSelectedInstOperands,
     /*  39144 */     // GIR_Coverage, 8480,
     /*  39144 */     GIR_EraseRootFromParent_Done,
     /*  39145 */   // Label 353: @39145
     /*  39145 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(39196), // Rule ID 1883 //
     /*  39150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  39166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  39170 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39180 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  39180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39194 */     GIR_RootConstrainSelectedInstOperands,
     /*  39195 */     // GIR_Coverage, 1883,
     /*  39195 */     GIR_EraseRootFromParent_Done,
     /*  39196 */   // Label 354: @39196
     /*  39196 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(39219), // Rule ID 2522 //
     /*  39201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  39204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39208 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39217 */     GIR_RootConstrainSelectedInstOperands,
     /*  39218 */     // GIR_Coverage, 2522,
     /*  39218 */     GIR_Done,
     /*  39219 */   // Label 355: @39219
     /*  39219 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(39242), // Rule ID 2525 //
     /*  39224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  39227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39231 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39240 */     GIR_RootConstrainSelectedInstOperands,
     /*  39241 */     // GIR_Coverage, 2525,
     /*  39241 */     GIR_Done,
     /*  39242 */   // Label 356: @39242
     /*  39242 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(39298), // Rule ID 903 //
     /*  39247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  39254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39268 */     // (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_AND_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  39268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /*  39271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  39278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  39283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  39288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  39293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39296 */     GIR_RootConstrainSelectedInstOperands,
     /*  39297 */     // GIR_Coverage, 903,
     /*  39297 */     GIR_EraseRootFromParent_Done,
     /*  39298 */   // Label 357: @39298
     /*  39298 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(39321), // Rule ID 904 //
     /*  39303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39310 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  39310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_fake16_e64),
     /*  39315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39319 */     GIR_RootConstrainSelectedInstOperands,
     /*  39320 */     // GIR_Coverage, 904,
     /*  39320 */     GIR_Done,
     /*  39321 */   // Label 358: @39321
     /*  39321 */   GIM_Reject,
     /*  39322 */ // Label 352: @39322
     /*  39322 */ GIM_Reject,
     /*  39323 */ // Label 343: @39323
     /*  39323 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(39846),
     /*  39328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  39331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  39334 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(39409), // Rule ID 11197 //
     /*  39339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39377 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39379 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39383 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19661),
     /*  39391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39393 */     // (and:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19661>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39407 */     GIR_RootConstrainSelectedInstOperands,
     /*  39408 */     // GIR_Coverage, 11197,
     /*  39408 */     GIR_EraseRootFromParent_Done,
     /*  39409 */   // Label 360: @39409
     /*  39409 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(39484), // Rule ID 11198 //
     /*  39414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39454 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39458 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19661),
     /*  39466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39468 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19661>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39482 */     GIR_RootConstrainSelectedInstOperands,
     /*  39483 */     // GIR_Coverage, 11198,
     /*  39483 */     GIR_EraseRootFromParent_Done,
     /*  39484 */   // Label 361: @39484
     /*  39484 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(39559), // Rule ID 7575 //
     /*  39489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39509 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39533 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19661),
     /*  39541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39543 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>)<<P:Predicate_anonymous_19661>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39548 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39557 */     GIR_RootConstrainSelectedInstOperands,
     /*  39558 */     // GIR_Coverage, 7575,
     /*  39558 */     GIR_EraseRootFromParent_Done,
     /*  39559 */   // Label 362: @39559
     /*  39559 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(39634), // Rule ID 7576 //
     /*  39564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39584 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39604 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19661),
     /*  39616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39618 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>)<<P:Predicate_anonymous_19661>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39632 */     GIR_RootConstrainSelectedInstOperands,
     /*  39633 */     // GIR_Coverage, 7576,
     /*  39633 */     GIR_EraseRootFromParent_Done,
     /*  39634 */   // Label 363: @39634
     /*  39634 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(39685), // Rule ID 8409 //
     /*  39639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39659 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39669 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39683 */     GIR_RootConstrainSelectedInstOperands,
     /*  39684 */     // GIR_Coverage, 8409,
     /*  39684 */     GIR_EraseRootFromParent_Done,
     /*  39685 */   // Label 364: @39685
     /*  39685 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(39736), // Rule ID 64 //
     /*  39690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39710 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39720 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39734 */     GIR_RootConstrainSelectedInstOperands,
     /*  39735 */     // GIR_Coverage, 64,
     /*  39735 */     GIR_EraseRootFromParent_Done,
     /*  39736 */   // Label 365: @39736
     /*  39736 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(39799), // Rule ID 7574 //
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  39753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  39765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask),
     /*  39773 */     // MIs[2] Operand 1
     /*  39773 */     // No operand predicates
     /*  39773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19661),
     /*  39777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39779 */     // (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$rshift), (imm:{ *:[i32] })<<P:Predicate_IMMZeroBasedBitfieldMask>>:$mask)<<P:Predicate_anonymous_19661>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, ?:{ *:[i32] }:$rshift, (IMMPopCount:{ *:[i32] } ?:{ *:[i32] }:$mask))
     /*  39779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  39788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rshift
     /*  39792 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderPopcntImm), // mask
     /*  39797 */     GIR_RootConstrainSelectedInstOperands,
     /*  39798 */     // GIR_Coverage, 7574,
     /*  39798 */     GIR_EraseRootFromParent_Done,
     /*  39799 */   // Label 366: @39799
     /*  39799 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(39825), // Rule ID 52 //
     /*  39804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39812 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13752>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  39817 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39823 */     GIR_RootConstrainSelectedInstOperands,
     /*  39824 */     // GIR_Coverage, 52,
     /*  39824 */     GIR_Done,
     /*  39825 */   // Label 367: @39825
     /*  39825 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(39845), // Rule ID 814 //
     /*  39830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39834 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_AND_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39843 */     GIR_RootConstrainSelectedInstOperands,
     /*  39844 */     // GIR_Coverage, 814,
     /*  39844 */     GIR_Done,
     /*  39845 */   // Label 368: @39845
     /*  39845 */   GIM_Reject,
     /*  39846 */ // Label 359: @39846
     /*  39846 */ GIM_Reject,
     /*  39847 */ // Label 344: @39847
     /*  39847 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(39971),
     /*  39852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  39855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  39858 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  39862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39866 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(39909), // Rule ID 8410 //
     /*  39871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39893 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39907 */     GIR_RootConstrainSelectedInstOperands,
     /*  39908 */     // GIR_Coverage, 8410,
     /*  39908 */     GIR_EraseRootFromParent_Done,
     /*  39909 */   // Label 370: @39909
     /*  39909 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(39952), // Rule ID 65 //
     /*  39914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39936 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39950 */     GIR_RootConstrainSelectedInstOperands,
     /*  39951 */     // GIR_Coverage, 65,
     /*  39951 */     GIR_EraseRootFromParent_Done,
     /*  39952 */   // Label 371: @39952
     /*  39952 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(39970), // Rule ID 53 //
     /*  39957 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13752>>  =>  (S_AND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  39962 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39968 */     GIR_RootConstrainSelectedInstOperands,
     /*  39969 */     // GIR_Coverage, 53,
     /*  39969 */     GIR_Done,
     /*  39970 */   // Label 372: @39970
     /*  39970 */   GIM_Reject,
     /*  39971 */ // Label 369: @39971
     /*  39971 */ GIM_Reject,
     /*  39972 */ // Label 345: @39972
     /*  39972 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(40122),
     /*  39977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  39980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  39983 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(40042), // Rule ID 8481 //
     /*  39988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  40004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  40008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40012 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  40024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40026 */     // (and:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  40026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  40029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40040 */     GIR_RootConstrainSelectedInstOperands,
     /*  40041 */     // GIR_Coverage, 8481,
     /*  40041 */     GIR_EraseRootFromParent_Done,
     /*  40042 */   // Label 374: @40042
     /*  40042 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(40101), // Rule ID 1884 //
     /*  40047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  40063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  40067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40071 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  40083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40085 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  40085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  40088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40099 */     GIR_RootConstrainSelectedInstOperands,
     /*  40100 */     // GIR_Coverage, 1884,
     /*  40100 */     GIR_EraseRootFromParent_Done,
     /*  40101 */   // Label 375: @40101
     /*  40101 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(40121), // Rule ID 2528 //
     /*  40106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40110 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  40110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  40115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40119 */     GIR_RootConstrainSelectedInstOperands,
     /*  40120 */     // GIR_Coverage, 2528,
     /*  40120 */     GIR_Done,
     /*  40121 */   // Label 376: @40121
     /*  40121 */   GIM_Reject,
     /*  40122 */ // Label 373: @40122
     /*  40122 */ GIM_Reject,
     /*  40123 */ // Label 346: @40123
     /*  40123 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(40245),
     /*  40128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40134 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  40138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40142 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(40193), // Rule ID 8483 //
     /*  40147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40177 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40191 */     GIR_RootConstrainSelectedInstOperands,
     /*  40192 */     // GIR_Coverage, 8483,
     /*  40192 */     GIR_EraseRootFromParent_Done,
     /*  40193 */   // Label 378: @40193
     /*  40193 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(40244), // Rule ID 1886 //
     /*  40198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40228 */     // (and:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40242 */     GIR_RootConstrainSelectedInstOperands,
     /*  40243 */     // GIR_Coverage, 1886,
     /*  40243 */     GIR_EraseRootFromParent_Done,
     /*  40244 */   // Label 379: @40244
     /*  40244 */   GIM_Reject,
     /*  40245 */ // Label 377: @40245
     /*  40245 */ GIM_Reject,
     /*  40246 */ // Label 347: @40246
     /*  40246 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(40368),
     /*  40251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40257 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /*  40261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40265 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(40316), // Rule ID 8482 //
     /*  40270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40290 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40300 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40314 */     GIR_RootConstrainSelectedInstOperands,
     /*  40315 */     // GIR_Coverage, 8482,
     /*  40315 */     GIR_EraseRootFromParent_Done,
     /*  40316 */   // Label 381: @40316
     /*  40316 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(40367), // Rule ID 1885 //
     /*  40321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40341 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40347 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40351 */     // (and:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13752>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40365 */     GIR_RootConstrainSelectedInstOperands,
     /*  40366 */     // GIR_Coverage, 1885,
     /*  40366 */     GIR_EraseRootFromParent_Done,
     /*  40367 */   // Label 382: @40367
     /*  40367 */   GIM_Reject,
     /*  40368 */ // Label 380: @40368
     /*  40368 */ GIM_Reject,
     /*  40369 */ // Label 348: @40369
     /*  40369 */ GIM_Reject,
     /*  40370 */ // Label 4: @40370
     /*  40370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 390*/ GIMT_Encode4(55881),
     /*  40381 */ /*GILLT_s1*//*Label 383*/ GIMT_Encode4(40421),
     /*  40385 */ /*GILLT_s16*//*Label 384*/ GIMT_Encode4(40484),
     /*  40389 */ /*GILLT_s32*//*Label 385*/ GIMT_Encode4(40724),
     /*  40393 */ /*GILLT_s64*//*Label 386*/ GIMT_Encode4(46295),
     /*  40397 */ /*GILLT_v2s16*//*Label 387*/ GIMT_Encode4(55484),
     /*  40401 */ /*GILLT_v2s32*//*Label 388*/ GIMT_Encode4(55635), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  40417 */ /*GILLT_v4s16*//*Label 389*/ GIMT_Encode4(55758),
     /*  40421 */ // Label 383: @40421
     /*  40421 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(40483),
     /*  40426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  40429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  40432 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(40457), // Rule ID 7417 //
     /*  40437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  40440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40444 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  40449 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40455 */     GIR_RootConstrainSelectedInstOperands,
     /*  40456 */     // GIR_Coverage, 7417,
     /*  40456 */     GIR_Done,
     /*  40457 */   // Label 392: @40457
     /*  40457 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(40482), // Rule ID 7424 //
     /*  40462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  40465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40469 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  40474 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40480 */     GIR_RootConstrainSelectedInstOperands,
     /*  40481 */     // GIR_Coverage, 7424,
     /*  40481 */     GIR_Done,
     /*  40482 */   // Label 393: @40482
     /*  40482 */   GIM_Reject,
     /*  40483 */ // Label 391: @40483
     /*  40483 */ GIM_Reject,
     /*  40484 */ // Label 384: @40484
     /*  40484 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(40723),
     /*  40489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  40492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  40495 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(40546), // Rule ID 8484 //
     /*  40500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  40528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40530 */     // (or:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40544 */     GIR_RootConstrainSelectedInstOperands,
     /*  40545 */     // GIR_Coverage, 8484,
     /*  40545 */     GIR_EraseRootFromParent_Done,
     /*  40546 */   // Label 395: @40546
     /*  40546 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(40597), // Rule ID 1887 //
     /*  40551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40571 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  40579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40581 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40595 */     GIR_RootConstrainSelectedInstOperands,
     /*  40596 */     // GIR_Coverage, 1887,
     /*  40596 */     GIR_EraseRootFromParent_Done,
     /*  40597 */   // Label 396: @40597
     /*  40597 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(40620), // Rule ID 2523 //
     /*  40602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  40605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40609 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40614 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40618 */     GIR_RootConstrainSelectedInstOperands,
     /*  40619 */     // GIR_Coverage, 2523,
     /*  40619 */     GIR_Done,
     /*  40620 */   // Label 397: @40620
     /*  40620 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(40643), // Rule ID 2526 //
     /*  40625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  40628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40632 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40641 */     GIR_RootConstrainSelectedInstOperands,
     /*  40642 */     // GIR_Coverage, 2526,
     /*  40642 */     GIR_Done,
     /*  40643 */   // Label 398: @40643
     /*  40643 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(40699), // Rule ID 905 //
     /*  40648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  40655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40669 */     // (or:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_OR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  40669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /*  40672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  40679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  40684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  40689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  40694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40697 */     GIR_RootConstrainSelectedInstOperands,
     /*  40698 */     // GIR_Coverage, 905,
     /*  40698 */     GIR_EraseRootFromParent_Done,
     /*  40699 */   // Label 399: @40699
     /*  40699 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(40722), // Rule ID 906 //
     /*  40704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40711 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  40711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_fake16_e64),
     /*  40716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40720 */     GIR_RootConstrainSelectedInstOperands,
     /*  40721 */     // GIR_Coverage, 906,
     /*  40721 */     GIR_Done,
     /*  40722 */   // Label 400: @40722
     /*  40722 */   GIM_Reject,
     /*  40723 */ // Label 394: @40723
     /*  40723 */ GIM_Reject,
     /*  40724 */ // Label 385: @40724
     /*  40724 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(46294),
     /*  40729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  40732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40735 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(40916), // Rule ID 8514 //
     /*  40740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40779 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40791 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40799 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40803 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40807 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  40818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  40830 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  40834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  40838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40842 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  40846 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  40850 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  40854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40858 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40862 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  40866 */     // MIs[6] src2
     /*  40866 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40871 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  40875 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  40879 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  40883 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40885 */     // (or:{ *:[i32] } (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  40885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  40888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  40897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  40904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  40911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40914 */     GIR_RootConstrainSelectedInstOperands,
     /*  40915 */     // GIR_Coverage, 8514,
     /*  40915 */     GIR_EraseRootFromParent_Done,
     /*  40916 */   // Label 402: @40916
     /*  40916 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(41097), // Rule ID 2699 //
     /*  40921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40960 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40984 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  40992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41016 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41020 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  41024 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  41028 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  41032 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41036 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  41040 */     // MIs[6] src2
     /*  41040 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41045 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  41049 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  41053 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  41064 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41066 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }), (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  41069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src0
     /*  41078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  41085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  41092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41095 */     GIR_RootConstrainSelectedInstOperands,
     /*  41096 */     // GIR_Coverage, 2699,
     /*  41096 */     GIR_EraseRootFromParent_Done,
     /*  41097 */   // Label 403: @41097
     /*  41097 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(41265), // Rule ID 8515 //
     /*  41102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  41105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41125 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  41129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  41149 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/3, GIMT_Encode8(255),
     /*  41160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41180 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41184 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41192 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41204 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41208 */     // MIs[5] src2
     /*  41208 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  41213 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41217 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41228 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*  41232 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41234 */     // (or:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  41246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src1
     /*  41253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*  41260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41263 */     GIR_RootConstrainSelectedInstOperands,
     /*  41264 */     // GIR_Coverage, 8515,
     /*  41264 */     GIR_EraseRootFromParent_Done,
     /*  41265 */   // Label 404: @41265
     /*  41265 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(41433), // Rule ID 2700 //
     /*  41270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  41273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41309 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  41313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*  41333 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/3, GIMT_Encode8(255),
     /*  41344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  41348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  41352 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41356 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41360 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41364 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41376 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41380 */     // MIs[5] src2
     /*  41380 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41385 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41389 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41400 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41402 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }), (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  41414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  41421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  41428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41431 */     GIR_RootConstrainSelectedInstOperands,
     /*  41432 */     // GIR_Coverage, 2700,
     /*  41432 */     GIR_EraseRootFromParent_Done,
     /*  41433 */   // Label 405: @41433
     /*  41433 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(41580), // Rule ID 11166 //
     /*  41438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41442 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41458 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41478 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41486 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41490 */     // MIs[3] x
     /*  41490 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  41499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41501 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41513 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41517 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41578 */     GIR_RootConstrainSelectedInstOperands,
     /*  41579 */     // GIR_Coverage, 11166,
     /*  41579 */     GIR_EraseRootFromParent_Done,
     /*  41580 */   // Label 406: @41580
     /*  41580 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(41727), // Rule ID 11165 //
     /*  41585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41589 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41605 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41625 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41633 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41637 */     // MIs[3] x
     /*  41637 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  41646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41648 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41660 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41725 */     GIR_RootConstrainSelectedInstOperands,
     /*  41726 */     // GIR_Coverage, 11165,
     /*  41726 */     GIR_EraseRootFromParent_Done,
     /*  41727 */   // Label 407: @41727
     /*  41727 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(41874), // Rule ID 11164 //
     /*  41732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41736 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41752 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41772 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41784 */     // MIs[3] x
     /*  41784 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  41793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41795 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41795 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41798 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41802 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41807 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41816 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41819 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41823 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41828 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41872 */     GIR_RootConstrainSelectedInstOperands,
     /*  41873 */     // GIR_Coverage, 11164,
     /*  41873 */     GIR_EraseRootFromParent_Done,
     /*  41874 */   // Label 408: @41874
     /*  41874 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(42021), // Rule ID 11163 //
     /*  41879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41883 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41899 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41915 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41919 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41931 */     // MIs[3] x
     /*  41931 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  41940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41942 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41942 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41945 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41949 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41954 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41958 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42019 */     GIR_RootConstrainSelectedInstOperands,
     /*  42020 */     // GIR_Coverage, 11163,
     /*  42020 */     GIR_EraseRootFromParent_Done,
     /*  42021 */   // Label 409: @42021
     /*  42021 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(42168), // Rule ID 11160 //
     /*  42026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42030 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42046 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42062 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42074 */     // MIs[3] x
     /*  42074 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42079 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  42087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42089 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42089 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42092 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42096 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42101 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42105 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  42126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  42147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42166 */     GIR_RootConstrainSelectedInstOperands,
     /*  42167 */     // GIR_Coverage, 11160,
     /*  42167 */     GIR_EraseRootFromParent_Done,
     /*  42168 */   // Label 410: @42168
     /*  42168 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(42315), // Rule ID 11162 //
     /*  42173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42177 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42193 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42209 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42221 */     // MIs[3] x
     /*  42221 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42226 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  42234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42236 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42236 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42239 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42243 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42248 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42252 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42313 */     GIR_RootConstrainSelectedInstOperands,
     /*  42314 */     // GIR_Coverage, 11162,
     /*  42314 */     GIR_EraseRootFromParent_Done,
     /*  42315 */   // Label 411: @42315
     /*  42315 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(42462), // Rule ID 7326 //
     /*  42320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42324 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42340 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42356 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42368 */     // MIs[3] x
     /*  42368 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42373 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  42381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42383 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  42420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  42441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42460 */     GIR_RootConstrainSelectedInstOperands,
     /*  42461 */     // GIR_Coverage, 7326,
     /*  42461 */     GIR_EraseRootFromParent_Done,
     /*  42462 */   // Label 412: @42462
     /*  42462 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(42609), // Rule ID 11161 //
     /*  42467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42471 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42487 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42503 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42515 */     // MIs[3] x
     /*  42515 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42520 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  42528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42530 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42542 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42546 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42567 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42607 */     GIR_RootConstrainSelectedInstOperands,
     /*  42608 */     // GIR_Coverage, 11161,
     /*  42608 */     GIR_EraseRootFromParent_Done,
     /*  42609 */   // Label 413: @42609
     /*  42609 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(42702), // Rule ID 2596 //
     /*  42614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42639 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42659 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42671 */     // MIs[3] Operand 1
     /*  42671 */     // No operand predicates
     /*  42671 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42675 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  42679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20786),
     /*  42683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42685 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20776>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20786>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42698 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42700 */     GIR_RootConstrainSelectedInstOperands,
     /*  42701 */     // GIR_Coverage, 2596,
     /*  42701 */     GIR_EraseRootFromParent_Done,
     /*  42702 */   // Label 414: @42702
     /*  42702 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(42795), // Rule ID 8499 //
     /*  42707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42714 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  42718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42736 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42756 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42768 */     // MIs[3] Operand 1
     /*  42768 */     // No operand predicates
     /*  42768 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20786),
     /*  42776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42778 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20776>>)<<P:5:Predicate_anonymous_20786>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42793 */     GIR_RootConstrainSelectedInstOperands,
     /*  42794 */     // GIR_Coverage, 8499,
     /*  42794 */     GIR_EraseRootFromParent_Done,
     /*  42795 */   // Label 415: @42795
     /*  42795 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(42980), // Rule ID 11211 //
     /*  42800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42804 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42820 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42836 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42844 */     // MIs[3] x
     /*  42844 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42849 */     // MIs[3] z
     /*  42849 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  42854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42860 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  42860 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  42863 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42867 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42872 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42876 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42881 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  42884 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42888 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42893 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42897 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42914 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42918 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  42951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42959 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  42962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  42975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  42978 */     GIR_RootConstrainSelectedInstOperands,
     /*  42979 */     // GIR_Coverage, 11211,
     /*  42979 */     GIR_EraseRootFromParent_Done,
     /*  42980 */   // Label 416: @42980
     /*  42980 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(43165), // Rule ID 11212 //
     /*  42985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42989 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43005 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43021 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43029 */     // MIs[3] z
     /*  43029 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43034 */     // MIs[3] x
     /*  43034 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43045 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43045 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43048 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43052 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43057 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43061 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43066 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43069 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43073 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43078 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43082 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43087 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43090 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43094 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43099 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43103 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43163 */     GIR_RootConstrainSelectedInstOperands,
     /*  43164 */     // GIR_Coverage, 11212,
     /*  43164 */     GIR_EraseRootFromParent_Done,
     /*  43165 */   // Label 417: @43165
     /*  43165 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(43350), // Rule ID 11213 //
     /*  43170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43174 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43190 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43206 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43214 */     // MIs[3] x
     /*  43214 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43219 */     // MIs[3] z
     /*  43219 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43230 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43230 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43233 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43237 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43242 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43246 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43251 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43254 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43258 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43263 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43267 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43284 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43288 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43348 */     GIR_RootConstrainSelectedInstOperands,
     /*  43349 */     // GIR_Coverage, 11213,
     /*  43349 */     GIR_EraseRootFromParent_Done,
     /*  43350 */   // Label 418: @43350
     /*  43350 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(43535), // Rule ID 11214 //
     /*  43355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43359 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43375 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43391 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43399 */     // MIs[3] z
     /*  43399 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43404 */     // MIs[3] x
     /*  43404 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43415 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43415 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43418 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43422 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43427 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43431 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43436 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43439 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43443 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43448 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43452 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43457 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43460 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43464 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43469 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43473 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43533 */     GIR_RootConstrainSelectedInstOperands,
     /*  43534 */     // GIR_Coverage, 11214,
     /*  43534 */     GIR_EraseRootFromParent_Done,
     /*  43535 */   // Label 419: @43535
     /*  43535 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(43720), // Rule ID 11207 //
     /*  43540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43544 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43560 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43576 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43584 */     // MIs[3] x
     /*  43584 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43589 */     // MIs[3] z
     /*  43589 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43600 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43600 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43603 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43607 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43612 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43616 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43621 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43624 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43628 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43633 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43637 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43654 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43658 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43718 */     GIR_RootConstrainSelectedInstOperands,
     /*  43719 */     // GIR_Coverage, 11207,
     /*  43719 */     GIR_EraseRootFromParent_Done,
     /*  43720 */   // Label 420: @43720
     /*  43720 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(43905), // Rule ID 11208 //
     /*  43725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43729 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43745 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43761 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43769 */     // MIs[3] z
     /*  43769 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43774 */     // MIs[3] x
     /*  43774 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43785 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43785 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43788 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43792 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43797 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43801 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43806 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43809 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43813 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43818 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43822 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43827 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43830 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43834 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43839 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43843 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43903 */     GIR_RootConstrainSelectedInstOperands,
     /*  43904 */     // GIR_Coverage, 11208,
     /*  43904 */     GIR_EraseRootFromParent_Done,
     /*  43905 */   // Label 421: @43905
     /*  43905 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(44090), // Rule ID 11209 //
     /*  43910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43914 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43930 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43946 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43954 */     // MIs[3] x
     /*  43954 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43959 */     // MIs[3] z
     /*  43959 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  43968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43970 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43970 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43973 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43977 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43982 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43986 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43991 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43994 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43998 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44003 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  44007 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44012 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44015 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44019 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44024 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44028 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  44049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44088 */     GIR_RootConstrainSelectedInstOperands,
     /*  44089 */     // GIR_Coverage, 11209,
     /*  44089 */     GIR_EraseRootFromParent_Done,
     /*  44090 */   // Label 422: @44090
     /*  44090 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(44275), // Rule ID 11210 //
     /*  44095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44099 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44115 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44131 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  44135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44139 */     // MIs[3] z
     /*  44139 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44144 */     // MIs[3] x
     /*  44144 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  44149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  44153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44155 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44155 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44158 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44162 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44167 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44171 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44176 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44179 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44183 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44188 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  44192 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44209 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44213 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44230 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  44234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44254 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44273 */     GIR_RootConstrainSelectedInstOperands,
     /*  44274 */     // GIR_Coverage, 11210,
     /*  44274 */     GIR_EraseRootFromParent_Done,
     /*  44275 */   // Label 423: @44275
     /*  44275 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(44460), // Rule ID 11201 //
     /*  44280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44284 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44300 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44316 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44324 */     // MIs[3] x
     /*  44324 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44329 */     // MIs[3] z
     /*  44329 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  44338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44340 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44340 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44343 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44347 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44352 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44356 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44361 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44364 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44368 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44373 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44377 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44394 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44398 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44458 */     GIR_RootConstrainSelectedInstOperands,
     /*  44459 */     // GIR_Coverage, 11201,
     /*  44459 */     GIR_EraseRootFromParent_Done,
     /*  44460 */   // Label 424: @44460
     /*  44460 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(44645), // Rule ID 11202 //
     /*  44465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44469 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44485 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44501 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44509 */     // MIs[3] z
     /*  44509 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44514 */     // MIs[3] x
     /*  44514 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  44523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44525 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44525 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44528 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44532 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44537 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44541 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44546 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44549 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44553 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44558 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44562 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44567 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44570 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44574 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44579 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44583 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44643 */     GIR_RootConstrainSelectedInstOperands,
     /*  44644 */     // GIR_Coverage, 11202,
     /*  44644 */     GIR_EraseRootFromParent_Done,
     /*  44645 */   // Label 425: @44645
     /*  44645 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(44830), // Rule ID 11205 //
     /*  44650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44654 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44670 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44686 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44694 */     // MIs[3] x
     /*  44694 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44699 */     // MIs[3] z
     /*  44699 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  44708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44710 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44710 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44713 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44717 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44722 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44726 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44743 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44747 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44764 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44768 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44828 */     GIR_RootConstrainSelectedInstOperands,
     /*  44829 */     // GIR_Coverage, 11205,
     /*  44829 */     GIR_EraseRootFromParent_Done,
     /*  44830 */   // Label 426: @44830
     /*  44830 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(45015), // Rule ID 11206 //
     /*  44835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44839 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44855 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44871 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44879 */     // MIs[3] z
     /*  44879 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44884 */     // MIs[3] x
     /*  44884 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  44893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44895 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44895 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44898 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44902 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44907 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44911 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44916 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44919 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44923 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44928 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44932 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44949 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44953 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45013 */     GIR_RootConstrainSelectedInstOperands,
     /*  45014 */     // GIR_Coverage, 11206,
     /*  45014 */     GIR_EraseRootFromParent_Done,
     /*  45015 */   // Label 427: @45015
     /*  45015 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(45200), // Rule ID 7578 //
     /*  45020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45024 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45040 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45056 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45064 */     // MIs[3] x
     /*  45064 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45069 */     // MIs[3] z
     /*  45069 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  45078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45080 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45080 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45083 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45087 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45092 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45096 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45101 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45104 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45108 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45113 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  45117 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45134 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45138 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  45159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45198 */     GIR_RootConstrainSelectedInstOperands,
     /*  45199 */     // GIR_Coverage, 7578,
     /*  45199 */     GIR_EraseRootFromParent_Done,
     /*  45200 */   // Label 428: @45200
     /*  45200 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(45385), // Rule ID 11200 //
     /*  45205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45209 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45225 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45241 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45249 */     // MIs[3] z
     /*  45249 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45254 */     // MIs[3] x
     /*  45254 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45265 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45265 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45268 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45272 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45277 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45281 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45286 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45289 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45293 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45298 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  45302 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45319 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45323 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  45344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45383 */     GIR_RootConstrainSelectedInstOperands,
     /*  45384 */     // GIR_Coverage, 11200,
     /*  45384 */     GIR_EraseRootFromParent_Done,
     /*  45385 */   // Label 429: @45385
     /*  45385 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(45570), // Rule ID 11203 //
     /*  45390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45394 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45410 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45426 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45434 */     // MIs[3] x
     /*  45434 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45439 */     // MIs[3] z
     /*  45439 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  45448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45450 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45450 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45453 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45457 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45462 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45466 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45471 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45474 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45483 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45504 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45508 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45549 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45568 */     GIR_RootConstrainSelectedInstOperands,
     /*  45569 */     // GIR_Coverage, 11203,
     /*  45569 */     GIR_EraseRootFromParent_Done,
     /*  45570 */   // Label 430: @45570
     /*  45570 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(45755), // Rule ID 11204 //
     /*  45575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45579 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45595 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45611 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45619 */     // MIs[3] z
     /*  45619 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45624 */     // MIs[3] x
     /*  45624 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  45633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45635 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19663>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45635 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45638 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45642 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45647 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45651 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45656 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45659 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45663 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45668 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45689 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45753 */     GIR_RootConstrainSelectedInstOperands,
     /*  45754 */     // GIR_Coverage, 11204,
     /*  45754 */     GIR_EraseRootFromParent_Done,
     /*  45755 */   // Label 431: @45755
     /*  45755 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(45806), // Rule ID 8411 //
     /*  45760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  45788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45790 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  45797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45804 */     GIR_RootConstrainSelectedInstOperands,
     /*  45805 */     // GIR_Coverage, 8411,
     /*  45805 */     GIR_EraseRootFromParent_Done,
     /*  45806 */   // Label 432: @45806
     /*  45806 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(45857), // Rule ID 66 //
     /*  45811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  45839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45841 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  45848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45855 */     GIR_RootConstrainSelectedInstOperands,
     /*  45856 */     // GIR_Coverage, 66,
     /*  45856 */     GIR_EraseRootFromParent_Done,
     /*  45857 */   // Label 433: @45857
     /*  45857 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(45922), // Rule ID 2597 //
     /*  45862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45887 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  45891 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  45895 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:6:z
     /*  45899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20788),
     /*  45903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45905 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20789>>, i32:{ *:[i32] }:$src2:$pred:6:z)<<P:6:Predicate_anonymous_20788>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  45908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45920 */     GIR_RootConstrainSelectedInstOperands,
     /*  45921 */     // GIR_Coverage, 2597,
     /*  45921 */     GIR_EraseRootFromParent_Done,
     /*  45922 */   // Label 434: @45922
     /*  45922 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(45987), // Rule ID 2598 //
     /*  45927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45952 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  45956 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  45960 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:7:z
     /*  45964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20791),
     /*  45968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45970 */     // (or:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20792>>, i32:{ *:[i32] }:$src2:$pred:7:z)<<P:7:Predicate_anonymous_20791>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  45973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45985 */     GIR_RootConstrainSelectedInstOperands,
     /*  45986 */     // GIR_Coverage, 2598,
     /*  45986 */     GIR_EraseRootFromParent_Done,
     /*  45987 */   // Label 435: @45987
     /*  45987 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(46052), // Rule ID 2595 //
     /*  45992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  46007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46017 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  46021 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  46025 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  46029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20786),
     /*  46033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46035 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20776>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20786>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  46038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46050 */     GIR_RootConstrainSelectedInstOperands,
     /*  46051 */     // GIR_Coverage, 2595,
     /*  46051 */     GIR_EraseRootFromParent_Done,
     /*  46052 */   // Label 436: @46052
     /*  46052 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(46117), // Rule ID 8500 //
     /*  46057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:6:z
     /*  46068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46086 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  46090 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  46094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20788),
     /*  46098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46100 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:6:z, (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20789>>)<<P:6:Predicate_anonymous_20788>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  46103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46115 */     GIR_RootConstrainSelectedInstOperands,
     /*  46116 */     // GIR_Coverage, 8500,
     /*  46116 */     GIR_EraseRootFromParent_Done,
     /*  46117 */   // Label 437: @46117
     /*  46117 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(46182), // Rule ID 8501 //
     /*  46122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46129 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:7:z
     /*  46133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46151 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  46155 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  46159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20791),
     /*  46163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46165 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:7:z, (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20792>>)<<P:7:Predicate_anonymous_20791>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  46168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46180 */     GIR_RootConstrainSelectedInstOperands,
     /*  46181 */     // GIR_Coverage, 8501,
     /*  46181 */     GIR_EraseRootFromParent_Done,
     /*  46182 */   // Label 438: @46182
     /*  46182 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(46247), // Rule ID 8498 //
     /*  46187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46194 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  46198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  46206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46216 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  46220 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  46224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20786),
     /*  46228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46230 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20776>>)<<P:5:Predicate_anonymous_20786>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  46233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46245 */     GIR_RootConstrainSelectedInstOperands,
     /*  46246 */     // GIR_Coverage, 8498,
     /*  46246 */     GIR_EraseRootFromParent_Done,
     /*  46247 */   // Label 439: @46247
     /*  46247 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(46273), // Rule ID 54 //
     /*  46252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  46256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  46260 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13753>>  =>  (S_OR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  46265 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  46271 */     GIR_RootConstrainSelectedInstOperands,
     /*  46272 */     // GIR_Coverage, 54,
     /*  46272 */     GIR_Done,
     /*  46273 */   // Label 440: @46273
     /*  46273 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(46293), // Rule ID 815 //
     /*  46278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46282 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_OR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  46287 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  46291 */     GIR_RootConstrainSelectedInstOperands,
     /*  46292 */     // GIR_Coverage, 815,
     /*  46292 */     GIR_Done,
     /*  46293 */   // Label 441: @46293
     /*  46293 */   GIM_Reject,
     /*  46294 */ // Label 401: @46294
     /*  46294 */ GIM_Reject,
     /*  46295 */ // Label 386: @46295
     /*  46295 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(55483),
     /*  46300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  46303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  46306 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(46621), // Rule ID 11174 //
     /*  46311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46315 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46331 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46351 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46363 */     // MIs[3] x
     /*  46363 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  46372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46374 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46374 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46377 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46381 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46386 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46392 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46397 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46402 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46405 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46409 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46414 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46420 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46425 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46430 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46433 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46437 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46442 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46448 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46458 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46461 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46465 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46470 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46473 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46476 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46481 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46484 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46488 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46493 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46499 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46504 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46509 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46512 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46516 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46521 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46527 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46532 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46549 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46577 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46596 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46602 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46620 */     // GIR_Coverage, 11174,
     /*  46620 */     GIR_EraseRootFromParent_Done,
     /*  46621 */   // Label 443: @46621
     /*  46621 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(46936), // Rule ID 11173 //
     /*  46626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46630 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46646 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46662 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46666 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  46678 */     // MIs[3] x
     /*  46678 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46689 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46689 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46692 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46696 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46701 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46707 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46712 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46717 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46720 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46724 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46729 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46735 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46740 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46745 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46748 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46752 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46757 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46763 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46768 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46773 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46776 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46780 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46785 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46788 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46791 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46796 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46799 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46803 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46808 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46814 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46819 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46836 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46864 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46911 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46917 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46935 */     // GIR_Coverage, 11173,
     /*  46935 */     GIR_EraseRootFromParent_Done,
     /*  46936 */   // Label 444: @46936
     /*  46936 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(47251), // Rule ID 11172 //
     /*  46941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46945 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46961 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46981 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     // MIs[3] x
     /*  46993 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  47002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47004 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47004 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47007 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47011 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47016 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47022 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47027 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47032 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47035 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47039 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47044 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47050 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47055 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47060 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47063 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47067 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47072 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47078 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47083 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47088 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47091 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47095 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47100 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47103 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47106 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47111 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47114 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47118 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47123 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47129 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47134 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47139 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47142 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47146 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47151 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47157 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47162 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47179 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47226 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47232 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47250 */     // GIR_Coverage, 11172,
     /*  47250 */     GIR_EraseRootFromParent_Done,
     /*  47251 */   // Label 445: @47251
     /*  47251 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(47566), // Rule ID 11171 //
     /*  47256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47260 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47276 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47292 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  47296 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  47308 */     // MIs[3] x
     /*  47308 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  47313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  47317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47319 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47319 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47322 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47326 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47331 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47337 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47342 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47347 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47350 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47354 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47359 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47365 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47370 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47375 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47378 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47382 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47387 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47393 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47398 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47403 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47406 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47410 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47415 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47418 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47421 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47426 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47429 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47433 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47438 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47444 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47449 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47454 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47457 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47461 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47466 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47472 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47494 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47547 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47565 */     // GIR_Coverage, 11171,
     /*  47565 */     GIR_EraseRootFromParent_Done,
     /*  47566 */   // Label 446: @47566
     /*  47566 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(47881), // Rule ID 11168 //
     /*  47571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47575 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47591 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47607 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47619 */     // MIs[3] x
     /*  47619 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  47624 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  47632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47634 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47634 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47637 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47641 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47646 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47652 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47657 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47662 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47665 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47669 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47674 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47680 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47685 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47690 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47693 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47697 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47702 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47708 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47713 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47718 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47721 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47725 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47730 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47733 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47736 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47741 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47744 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47748 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47753 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47759 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47764 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47769 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47772 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47776 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47781 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47787 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47792 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47809 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47837 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47840 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47856 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47862 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47880 */     // GIR_Coverage, 11168,
     /*  47880 */     GIR_EraseRootFromParent_Done,
     /*  47881 */   // Label 447: @47881
     /*  47881 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(48196), // Rule ID 11170 //
     /*  47886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47890 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47906 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47922 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47934 */     // MIs[3] x
     /*  47934 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  47939 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  47947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47949 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47949 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47952 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47956 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47961 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47967 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47972 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47977 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47980 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47984 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47989 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47995 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48000 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48005 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48008 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48012 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48017 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48023 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48028 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48033 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48036 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48040 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48045 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48048 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48051 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48056 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48059 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48063 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48068 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48074 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48079 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48096 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48102 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48107 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48124 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48171 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48177 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48195 */     // GIR_Coverage, 11170,
     /*  48195 */     GIR_EraseRootFromParent_Done,
     /*  48196 */   // Label 448: @48196
     /*  48196 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(48511), // Rule ID 7328 //
     /*  48201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48205 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48221 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48237 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48245 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48249 */     // MIs[3] x
     /*  48249 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  48254 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  48262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48264 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48264 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48267 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48271 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48276 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48282 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48287 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48292 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48295 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48299 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48304 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48310 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48315 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48320 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48323 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48327 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48332 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48338 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48343 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48348 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48351 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48355 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48360 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48363 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48366 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48371 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48374 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48378 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48383 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48389 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48394 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48411 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48422 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48439 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48486 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48492 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48510 */     // GIR_Coverage, 7328,
     /*  48510 */     GIR_EraseRootFromParent_Done,
     /*  48511 */   // Label 449: @48511
     /*  48511 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(48826), // Rule ID 11169 //
     /*  48516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48520 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48536 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48552 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48564 */     // MIs[3] x
     /*  48564 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  48569 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  48577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48579 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48579 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48582 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48586 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48591 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48597 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48602 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48607 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48610 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48614 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48619 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48625 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48630 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48635 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48638 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48642 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48647 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48653 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48658 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48663 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48666 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48670 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48675 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48678 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48681 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48686 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48689 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48693 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48698 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48704 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48709 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48726 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48732 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48737 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48754 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48801 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48807 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48825 */     // GIR_Coverage, 11169,
     /*  48825 */     GIR_EraseRootFromParent_Done,
     /*  48826 */   // Label 450: @48826
     /*  48826 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(49234), // Rule ID 11226 //
     /*  48831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48835 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48851 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48867 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  48871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48875 */     // MIs[3] x
     /*  48875 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  48880 */     // MIs[3] z
     /*  48880 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  48885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  48889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48891 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48891 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  48894 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48898 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48903 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48909 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48914 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48919 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  48922 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48926 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48931 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48937 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48942 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48947 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  48950 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48954 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48959 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48965 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48970 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48975 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  48978 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48982 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48987 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48993 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48998 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49003 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49006 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49010 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49015 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49018 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49023 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49026 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49030 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49035 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49038 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49041 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49046 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49049 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49053 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49058 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49064 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49069 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49074 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49077 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49081 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49086 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49092 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49097 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49102 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49105 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49109 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49114 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49120 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49125 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49142 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49148 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49153 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49170 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49190 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49209 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49215 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49233 */     // GIR_Coverage, 11226,
     /*  49233 */     GIR_EraseRootFromParent_Done,
     /*  49234 */   // Label 451: @49234
     /*  49234 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(49642), // Rule ID 11227 //
     /*  49239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49243 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49259 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49275 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49283 */     // MIs[3] z
     /*  49283 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49288 */     // MIs[3] x
     /*  49288 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  49297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49299 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49299 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49302 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49306 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49311 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49317 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49322 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49327 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49330 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49334 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49339 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49345 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49350 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49355 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49358 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49362 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49367 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49373 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49378 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49383 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49386 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49390 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49395 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49401 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49406 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49411 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49414 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49418 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49423 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49426 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49431 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49434 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49438 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49443 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49446 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49449 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49454 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49457 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49461 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49466 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49494 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49500 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49505 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49522 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49528 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49533 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49550 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49556 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49561 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49617 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49623 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49641 */     // GIR_Coverage, 11227,
     /*  49641 */     GIR_EraseRootFromParent_Done,
     /*  49642 */   // Label 452: @49642
     /*  49642 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(50050), // Rule ID 11228 //
     /*  49647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49651 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49667 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49683 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49691 */     // MIs[3] x
     /*  49691 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49696 */     // MIs[3] z
     /*  49696 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  49705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49707 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49707 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49710 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49714 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49719 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49725 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49730 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49735 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49738 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49742 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49747 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49753 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49758 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49763 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49766 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49770 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49775 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49781 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49786 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49791 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49794 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49798 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49803 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49809 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49814 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49819 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49822 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49826 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49831 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49834 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49839 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49842 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49846 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49851 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49854 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49857 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49862 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49865 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49869 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49874 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49880 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49885 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49902 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49908 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49913 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49918 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49921 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49925 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49930 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49941 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49958 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49964 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49969 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49986 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50025 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50031 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50049 */     // GIR_Coverage, 11228,
     /*  50049 */     GIR_EraseRootFromParent_Done,
     /*  50050 */   // Label 453: @50050
     /*  50050 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(50458), // Rule ID 11229 //
     /*  50055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50059 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50075 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50091 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50099 */     // MIs[3] z
     /*  50099 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50104 */     // MIs[3] x
     /*  50104 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  50113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50115 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50115 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50118 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50122 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50127 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50133 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50138 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50143 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50146 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50150 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50155 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50161 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50166 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50171 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50174 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50178 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50183 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50189 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50194 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50199 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50202 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50206 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50211 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50217 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50222 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50227 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50230 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50234 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50239 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50242 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50247 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50250 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50254 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50259 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50262 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50265 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50270 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50273 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50277 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50282 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50288 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50293 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50298 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50301 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50305 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50310 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50316 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50321 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50338 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50344 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50349 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50366 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50372 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50377 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50394 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50397 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50433 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50439 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50457 */     // GIR_Coverage, 11229,
     /*  50457 */     GIR_EraseRootFromParent_Done,
     /*  50458 */   // Label 454: @50458
     /*  50458 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(50866), // Rule ID 11222 //
     /*  50463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50467 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50483 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50499 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50507 */     // MIs[3] x
     /*  50507 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50512 */     // MIs[3] z
     /*  50512 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  50521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50523 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50523 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50526 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50530 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50535 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50541 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50546 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50551 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50554 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50558 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50563 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50569 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50574 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50579 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50582 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50586 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50591 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50597 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50602 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50607 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50610 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50614 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50619 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50625 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50630 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50635 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50638 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50642 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50647 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50650 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50655 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50658 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50662 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50667 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50670 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50673 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50678 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50681 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50685 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50690 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50696 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50701 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50706 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50709 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50713 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50718 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50724 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50729 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50734 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50737 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50741 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50746 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50752 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50757 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50762 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50765 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50769 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50774 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50780 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50785 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50805 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50841 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50847 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50865 */     // GIR_Coverage, 11222,
     /*  50865 */     GIR_EraseRootFromParent_Done,
     /*  50866 */   // Label 455: @50866
     /*  50866 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(51274), // Rule ID 11223 //
     /*  50871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50875 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50891 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50907 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50915 */     // MIs[3] z
     /*  50915 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50920 */     // MIs[3] x
     /*  50920 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  50929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50931 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50931 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50934 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50938 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50943 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50949 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50954 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50959 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50962 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50966 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50971 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50977 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50982 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50987 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50990 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50994 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50999 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51005 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51010 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51015 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51018 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51022 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51027 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51033 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51038 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51043 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51046 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51050 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51055 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51058 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51063 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51066 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51070 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51075 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51078 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51081 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51086 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51089 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51093 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51098 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51104 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51109 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51114 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51117 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51121 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51126 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51132 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51137 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51142 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51145 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51149 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51154 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51160 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51165 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51182 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51193 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51213 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51249 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51255 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51273 */     // GIR_Coverage, 11223,
     /*  51273 */     GIR_EraseRootFromParent_Done,
     /*  51274 */   // Label 456: @51274
     /*  51274 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(51682), // Rule ID 11224 //
     /*  51279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51283 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51299 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51315 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51323 */     // MIs[3] x
     /*  51323 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51328 */     // MIs[3] z
     /*  51328 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  51337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51339 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51339 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51342 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51346 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51351 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51357 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51362 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51385 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51390 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51395 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51398 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51402 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51407 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51413 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51418 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51423 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51426 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51430 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51435 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51441 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51446 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51451 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51454 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51458 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51463 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51466 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51471 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51474 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51478 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51483 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51486 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51489 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51494 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51497 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51501 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51506 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51512 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51522 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51525 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51529 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51534 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51540 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51545 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51550 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51553 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51557 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51562 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51568 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51573 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51578 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51581 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51585 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51590 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51596 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51601 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51618 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51621 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51641 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51657 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51663 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51681 */     // GIR_Coverage, 11224,
     /*  51681 */     GIR_EraseRootFromParent_Done,
     /*  51682 */   // Label 457: @51682
     /*  51682 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(52090), // Rule ID 11225 //
     /*  51687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51691 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51707 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51723 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51731 */     // MIs[3] z
     /*  51731 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51736 */     // MIs[3] x
     /*  51736 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  51745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51747 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51747 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51750 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51754 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51759 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51765 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51770 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51775 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51778 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51782 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51787 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51793 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51798 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51803 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51806 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51810 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51815 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51821 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51826 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51831 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51834 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51838 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51843 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51849 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51854 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51859 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51862 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51866 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51871 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51874 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51879 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51882 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51886 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51891 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51894 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51897 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51902 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51905 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51909 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51914 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51920 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51925 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51930 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51933 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51937 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51942 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51948 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51953 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51958 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51961 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51965 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51970 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51976 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51981 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51998 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52004 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52009 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52065 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52071 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52089 */     // GIR_Coverage, 11225,
     /*  52089 */     GIR_EraseRootFromParent_Done,
     /*  52090 */   // Label 458: @52090
     /*  52090 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(52498), // Rule ID 11216 //
     /*  52095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52099 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52115 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52131 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52139 */     // MIs[3] x
     /*  52139 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52144 */     // MIs[3] z
     /*  52144 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  52153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52155 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52155 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52158 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52162 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52167 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52173 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52178 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52183 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52186 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52190 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52195 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52201 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52206 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52211 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52214 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52218 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52223 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52229 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52234 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52239 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52242 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52246 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52251 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52257 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52262 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52267 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52270 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52274 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52279 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52282 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52287 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52290 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52294 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52299 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52302 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52305 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52310 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52313 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52317 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52322 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52338 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52341 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52345 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52350 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52356 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52361 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52366 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52369 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52373 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52378 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52384 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52389 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52394 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52397 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52401 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52406 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52412 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52473 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52479 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52497 */     // GIR_Coverage, 11216,
     /*  52497 */     GIR_EraseRootFromParent_Done,
     /*  52498 */   // Label 459: @52498
     /*  52498 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(52906), // Rule ID 11217 //
     /*  52503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52507 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52523 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52539 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52547 */     // MIs[3] z
     /*  52547 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52552 */     // MIs[3] x
     /*  52552 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  52561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52563 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52563 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52566 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52570 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52575 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52581 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52586 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52591 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52594 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52598 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52603 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52609 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52614 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52619 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52622 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52626 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52631 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52637 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52642 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52647 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52650 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52654 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52659 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52665 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52670 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52675 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52678 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52682 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52687 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52690 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52695 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52698 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52702 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52707 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52710 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52713 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52718 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52721 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52725 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52730 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52736 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52741 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52746 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52749 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52753 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52758 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52764 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52769 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52777 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52781 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52786 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52792 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52797 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52814 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52845 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52881 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52887 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52905 */     // GIR_Coverage, 11217,
     /*  52905 */     GIR_EraseRootFromParent_Done,
     /*  52906 */   // Label 460: @52906
     /*  52906 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(53314), // Rule ID 11220 //
     /*  52911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52915 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52931 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52947 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52955 */     // MIs[3] x
     /*  52955 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52960 */     // MIs[3] z
     /*  52960 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  52969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52971 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52971 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52974 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52978 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52983 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52989 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52994 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52999 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53002 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53006 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53011 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53017 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53022 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53027 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53030 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53034 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53039 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53045 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53050 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53055 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53058 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53062 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53067 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53073 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53078 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53083 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53086 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53090 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53095 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53098 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53103 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53106 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53110 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53115 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53118 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53121 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53126 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53129 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53133 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53138 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53144 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53149 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53154 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53157 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53161 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53166 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53172 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53177 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53182 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53185 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53189 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53194 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53200 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53205 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53210 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53213 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53217 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53222 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53228 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53233 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53253 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53273 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53276 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53289 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53295 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53313 */     // GIR_Coverage, 11220,
     /*  53313 */     GIR_EraseRootFromParent_Done,
     /*  53314 */   // Label 461: @53314
     /*  53314 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(53722), // Rule ID 11221 //
     /*  53319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53323 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53339 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53355 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  53359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53363 */     // MIs[3] z
     /*  53363 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53368 */     // MIs[3] x
     /*  53368 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  53377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53379 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53379 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53382 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53386 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53391 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53397 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53402 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53407 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53410 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53414 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53419 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53425 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53430 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53435 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53438 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53442 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53447 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53453 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53458 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53463 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53466 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53470 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53475 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53481 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53486 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53491 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53494 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53498 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53503 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53506 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53511 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53514 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53518 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53523 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53526 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53529 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53534 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53537 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53541 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53546 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53552 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53557 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53562 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53565 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53569 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53574 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53580 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53585 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53602 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53608 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53613 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53630 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53636 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53641 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53658 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53661 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53697 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53703 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53721 */     // GIR_Coverage, 11221,
     /*  53721 */     GIR_EraseRootFromParent_Done,
     /*  53722 */   // Label 462: @53722
     /*  53722 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(54130), // Rule ID 7579 //
     /*  53727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53731 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53747 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53763 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53771 */     // MIs[3] x
     /*  53771 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53776 */     // MIs[3] z
     /*  53776 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  53785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53787 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53787 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53790 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53794 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53799 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53805 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53810 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53815 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53818 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53822 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53827 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53833 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53838 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53843 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53846 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53850 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53855 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53861 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53866 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53871 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53874 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53878 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53883 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53889 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53894 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53899 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53902 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53906 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53911 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53914 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53919 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53922 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53926 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53931 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53934 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53937 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53942 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53945 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53949 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53954 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53960 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53965 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53970 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53973 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53977 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53982 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53988 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53993 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53998 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54001 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54005 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54010 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54016 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54021 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54026 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54029 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54033 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54038 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54044 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54066 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54069 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54105 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54111 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54129 */     // GIR_Coverage, 7579,
     /*  54129 */     GIR_EraseRootFromParent_Done,
     /*  54130 */   // Label 463: @54130
     /*  54130 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(54538), // Rule ID 11215 //
     /*  54135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54139 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54155 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54171 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54179 */     // MIs[3] z
     /*  54179 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54184 */     // MIs[3] x
     /*  54184 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  54193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54195 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54195 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54198 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54202 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54207 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54213 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54218 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54223 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54226 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54230 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54235 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54241 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54246 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54251 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54254 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54258 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54263 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54269 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54274 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54279 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54282 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54286 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54291 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54297 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54302 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54307 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54310 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54314 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54319 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54322 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54327 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54330 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54334 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54339 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54342 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54345 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54350 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54353 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54357 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54362 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54368 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54373 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54378 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54381 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54385 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54390 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54396 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54401 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54406 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54409 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54413 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54418 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54424 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54429 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54446 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54457 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54474 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54477 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54513 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54519 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54537 */     // GIR_Coverage, 11215,
     /*  54537 */     GIR_EraseRootFromParent_Done,
     /*  54538 */   // Label 464: @54538
     /*  54538 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(54946), // Rule ID 11218 //
     /*  54543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54547 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54563 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54579 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54587 */     // MIs[3] x
     /*  54587 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54592 */     // MIs[3] z
     /*  54592 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  54601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54603 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54603 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54606 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54610 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54615 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54621 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54626 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54631 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54634 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54638 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54643 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54649 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54654 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54659 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54662 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54666 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54671 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54677 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54682 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54687 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54690 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54694 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54699 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54705 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54710 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54715 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54718 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54722 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54727 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54730 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54735 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54738 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54742 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54747 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54750 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54753 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54758 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54761 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54765 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54770 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54776 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54781 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54786 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54789 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54793 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54798 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54804 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54809 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54814 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54817 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54821 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54826 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54832 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54837 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54842 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54845 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54849 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54854 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54860 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54865 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54882 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54921 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54927 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54945 */     // GIR_Coverage, 11218,
     /*  54945 */     GIR_EraseRootFromParent_Done,
     /*  54946 */   // Label 465: @54946
     /*  54946 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(55354), // Rule ID 11219 //
     /*  54951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54955 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54971 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54987 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54995 */     // MIs[3] z
     /*  54995 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  55000 */     // MIs[3] x
     /*  55000 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  55005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19663),
     /*  55009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55011 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19663>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  55011 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  55014 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55018 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55023 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  55029 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55034 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55039 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  55042 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55046 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55051 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  55057 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55062 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55067 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  55070 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55074 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55079 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  55085 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55090 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55095 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  55098 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55102 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55107 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  55113 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55118 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55123 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  55126 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  55130 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55135 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  55138 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  55141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  55143 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  55146 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  55150 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55155 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  55158 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  55161 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  55164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  55166 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  55169 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55173 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55178 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55184 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55189 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55194 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  55197 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55201 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55206 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  55212 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55217 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55222 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  55225 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55229 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55234 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55240 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55245 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  55253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55262 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  55268 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55273 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  55281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  55285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55290 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  55293 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  55296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  55298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  55301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  55305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  55316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  55319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  55324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55329 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  55332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  55335 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  55338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55353 */     // GIR_Coverage, 11219,
     /*  55353 */     GIR_EraseRootFromParent_Done,
     /*  55354 */   // Label 466: @55354
     /*  55354 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(55405), // Rule ID 8412 //
     /*  55359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55379 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55389 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55403 */     GIR_RootConstrainSelectedInstOperands,
     /*  55404 */     // GIR_Coverage, 8412,
     /*  55404 */     GIR_EraseRootFromParent_Done,
     /*  55405 */   // Label 467: @55405
     /*  55405 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(55456), // Rule ID 67 //
     /*  55410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55440 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55454 */     GIR_RootConstrainSelectedInstOperands,
     /*  55455 */     // GIR_Coverage, 67,
     /*  55455 */     GIR_EraseRootFromParent_Done,
     /*  55456 */   // Label 468: @55456
     /*  55456 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(55482), // Rule ID 55 //
     /*  55461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55469 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13753>>  =>  (S_OR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  55474 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55480 */     GIR_RootConstrainSelectedInstOperands,
     /*  55481 */     // GIR_Coverage, 55,
     /*  55481 */     GIR_Done,
     /*  55482 */   // Label 469: @55482
     /*  55482 */   GIM_Reject,
     /*  55483 */ // Label 442: @55483
     /*  55483 */ GIM_Reject,
     /*  55484 */ // Label 387: @55484
     /*  55484 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(55634),
     /*  55489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55495 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(55554), // Rule ID 8485 //
     /*  55500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55524 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55538 */     // (or:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55552 */     GIR_RootConstrainSelectedInstOperands,
     /*  55553 */     // GIR_Coverage, 8485,
     /*  55553 */     GIR_EraseRootFromParent_Done,
     /*  55554 */   // Label 471: @55554
     /*  55554 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(55613), // Rule ID 1888 //
     /*  55559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55583 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55589 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55597 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55611 */     GIR_RootConstrainSelectedInstOperands,
     /*  55612 */     // GIR_Coverage, 1888,
     /*  55612 */     GIR_EraseRootFromParent_Done,
     /*  55613 */   // Label 472: @55613
     /*  55613 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(55633), // Rule ID 2529 //
     /*  55618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55622 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  55622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  55627 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  55631 */     GIR_RootConstrainSelectedInstOperands,
     /*  55632 */     // GIR_Coverage, 2529,
     /*  55632 */     GIR_Done,
     /*  55633 */   // Label 473: @55633
     /*  55633 */   GIM_Reject,
     /*  55634 */ // Label 470: @55634
     /*  55634 */ GIM_Reject,
     /*  55635 */ // Label 388: @55635
     /*  55635 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(55757),
     /*  55640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55646 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55654 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(55705), // Rule ID 8487 //
     /*  55659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55679 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55689 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55703 */     GIR_RootConstrainSelectedInstOperands,
     /*  55704 */     // GIR_Coverage, 8487,
     /*  55704 */     GIR_EraseRootFromParent_Done,
     /*  55705 */   // Label 475: @55705
     /*  55705 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(55756), // Rule ID 1890 //
     /*  55710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55730 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55740 */     // (or:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55754 */     GIR_RootConstrainSelectedInstOperands,
     /*  55755 */     // GIR_Coverage, 1890,
     /*  55755 */     GIR_EraseRootFromParent_Done,
     /*  55756 */   // Label 476: @55756
     /*  55756 */   GIM_Reject,
     /*  55757 */ // Label 474: @55757
     /*  55757 */ GIM_Reject,
     /*  55758 */ // Label 389: @55758
     /*  55758 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(55880),
     /*  55763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55769 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /*  55773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55777 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(55828), // Rule ID 8486 //
     /*  55782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55802 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55812 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55817 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 8486,
     /*  55827 */     GIR_EraseRootFromParent_Done,
     /*  55828 */   // Label 478: @55828
     /*  55828 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(55879), // Rule ID 1889 //
     /*  55833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55853 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55863 */     // (or:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13753>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55877 */     GIR_RootConstrainSelectedInstOperands,
     /*  55878 */     // GIR_Coverage, 1889,
     /*  55878 */     GIR_EraseRootFromParent_Done,
     /*  55879 */   // Label 479: @55879
     /*  55879 */   GIM_Reject,
     /*  55880 */ // Label 477: @55880
     /*  55880 */ GIM_Reject,
     /*  55881 */ // Label 390: @55881
     /*  55881 */ GIM_Reject,
     /*  55882 */ // Label 5: @55882
     /*  55882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 485*/ GIMT_Encode4(60573),
     /*  55893 */ /*GILLT_s1*//*Label 480*/ GIMT_Encode4(55913),
     /*  55897 */ /*GILLT_s16*//*Label 481*/ GIMT_Encode4(55976),
     /*  55901 */ /*GILLT_s32*//*Label 482*/ GIMT_Encode4(56114),
     /*  55905 */ /*GILLT_s64*//*Label 483*/ GIMT_Encode4(57913),
     /*  55909 */ /*GILLT_v2s16*//*Label 484*/ GIMT_Encode4(60546),
     /*  55913 */ // Label 480: @55913
     /*  55913 */ GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(55975),
     /*  55918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  55921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  55924 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(55949), // Rule ID 7418 //
     /*  55929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  55932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55936 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  55941 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55947 */     GIR_RootConstrainSelectedInstOperands,
     /*  55948 */     // GIR_Coverage, 7418,
     /*  55948 */     GIR_Done,
     /*  55949 */   // Label 487: @55949
     /*  55949 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(55974), // Rule ID 7425 //
     /*  55954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  55957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55961 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  55966 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55972 */     GIR_RootConstrainSelectedInstOperands,
     /*  55973 */     // GIR_Coverage, 7425,
     /*  55973 */     GIR_Done,
     /*  55974 */   // Label 488: @55974
     /*  55974 */   GIM_Reject,
     /*  55975 */ // Label 486: @55975
     /*  55975 */ GIM_Reject,
     /*  55976 */ // Label 481: @55976
     /*  55976 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(56113),
     /*  55981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  55984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  55987 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(56010), // Rule ID 2524 //
     /*  55992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  55995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55999 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  55999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56004 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56008 */     GIR_RootConstrainSelectedInstOperands,
     /*  56009 */     // GIR_Coverage, 2524,
     /*  56009 */     GIR_Done,
     /*  56010 */   // Label 490: @56010
     /*  56010 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(56033), // Rule ID 2527 //
     /*  56015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  56018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56022 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  56022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56027 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56031 */     GIR_RootConstrainSelectedInstOperands,
     /*  56032 */     // GIR_Coverage, 2527,
     /*  56032 */     GIR_Done,
     /*  56033 */   // Label 491: @56033
     /*  56033 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(56089), // Rule ID 907 //
     /*  56038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  56045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56059 */     // (xor:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_XOR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  56059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /*  56062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  56069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  56074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  56079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  56084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56087 */     GIR_RootConstrainSelectedInstOperands,
     /*  56088 */     // GIR_Coverage, 907,
     /*  56088 */     GIR_EraseRootFromParent_Done,
     /*  56089 */   // Label 492: @56089
     /*  56089 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(56112), // Rule ID 908 //
     /*  56094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56101 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  56101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_fake16_e64),
     /*  56106 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56110 */     GIR_RootConstrainSelectedInstOperands,
     /*  56111 */     // GIR_Coverage, 908,
     /*  56111 */     GIR_Done,
     /*  56112 */   // Label 493: @56112
     /*  56112 */   GIM_Reject,
     /*  56113 */ // Label 489: @56113
     /*  56113 */ GIM_Reject,
     /*  56114 */ // Label 482: @56114
     /*  56114 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(57912),
     /*  56119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  56122 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(56180), // Rule ID 60 //
     /*  56127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  56160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56162 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13722>>  =>  (S_NAND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B32),
     /*  56165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56178 */     GIR_RootConstrainSelectedInstOperands,
     /*  56179 */     // GIR_Coverage, 60,
     /*  56179 */     GIR_EraseRootFromParent_Done,
     /*  56180 */   // Label 495: @56180
     /*  56180 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(56238), // Rule ID 62 //
     /*  56185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  56218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56220 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13722>>  =>  (S_NOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B32),
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56236 */     GIR_RootConstrainSelectedInstOperands,
     /*  56237 */     // GIR_Coverage, 62,
     /*  56237 */     GIR_EraseRootFromParent_Done,
     /*  56238 */   // Label 496: @56238
     /*  56238 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(56296), // Rule ID 58 //
     /*  56243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  56276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56278 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13722>>  =>  (S_XNOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B32),
     /*  56281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56294 */     GIR_RootConstrainSelectedInstOperands,
     /*  56295 */     // GIR_Coverage, 58,
     /*  56295 */     GIR_EraseRootFromParent_Done,
     /*  56296 */   // Label 497: @56296
     /*  56296 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(56354), // Rule ID 2511 //
     /*  56301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19900),
     /*  56337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56339 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_19900>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56352 */     GIR_RootConstrainSelectedInstOperands,
     /*  56353 */     // GIR_Coverage, 2511,
     /*  56353 */     GIR_EraseRootFromParent_Done,
     /*  56354 */   // Label 498: @56354
     /*  56354 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(56410), // Rule ID 2512 //
     /*  56359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56365 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56387 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19902),
     /*  56395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56397 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19902>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  56408 */     GIR_RootConstrainSelectedInstOperands,
     /*  56409 */     // GIR_Coverage, 2512,
     /*  56409 */     GIR_EraseRootFromParent_Done,
     /*  56410 */   // Label 499: @56410
     /*  56410 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(56466), // Rule ID 8488 //
     /*  56415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56421 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56443 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19902),
     /*  56451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56453 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19902>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  56464 */     GIR_RootConstrainSelectedInstOperands,
     /*  56465 */     // GIR_Coverage, 8488,
     /*  56465 */     GIR_EraseRootFromParent_Done,
     /*  56466 */   // Label 500: @56466
     /*  56466 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(56597), // Rule ID 11180 //
     /*  56471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56475 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56491 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56507 */     // MIs[0] z
     /*  56507 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  56516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56518 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56530 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56534 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56595 */     GIR_RootConstrainSelectedInstOperands,
     /*  56596 */     // GIR_Coverage, 11180,
     /*  56596 */     GIR_EraseRootFromParent_Done,
     /*  56597 */   // Label 501: @56597
     /*  56597 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(56728), // Rule ID 11181 //
     /*  56602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56606 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56622 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56638 */     // MIs[0] z
     /*  56638 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  56647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56649 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56661 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56665 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56726 */     GIR_RootConstrainSelectedInstOperands,
     /*  56727 */     // GIR_Coverage, 11181,
     /*  56727 */     GIR_EraseRootFromParent_Done,
     /*  56728 */   // Label 502: @56728
     /*  56728 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(56859), // Rule ID 11178 //
     /*  56733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56737 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56753 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56769 */     // MIs[0] z
     /*  56769 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  56778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56780 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56780 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56783 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56787 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56792 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56796 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56857 */     GIR_RootConstrainSelectedInstOperands,
     /*  56858 */     // GIR_Coverage, 11178,
     /*  56858 */     GIR_EraseRootFromParent_Done,
     /*  56859 */   // Label 503: @56859
     /*  56859 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(56990), // Rule ID 11179 //
     /*  56864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56868 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56884 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56900 */     // MIs[0] z
     /*  56900 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  56909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56911 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56923 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56927 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56988 */     GIR_RootConstrainSelectedInstOperands,
     /*  56989 */     // GIR_Coverage, 11179,
     /*  56989 */     GIR_EraseRootFromParent_Done,
     /*  56990 */   // Label 504: @56990
     /*  56990 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(57120), // Rule ID 11177 //
     /*  56995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57002 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57018 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57030 */     // MIs[2] z
     /*  57030 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  57039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57041 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57118 */     GIR_RootConstrainSelectedInstOperands,
     /*  57119 */     // GIR_Coverage, 11177,
     /*  57119 */     GIR_EraseRootFromParent_Done,
     /*  57120 */   // Label 505: @57120
     /*  57120 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(57250), // Rule ID 11176 //
     /*  57125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57132 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57148 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57160 */     // MIs[2] z
     /*  57160 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  57169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57171 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57171 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57174 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57178 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57183 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57187 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57204 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57248 */     GIR_RootConstrainSelectedInstOperands,
     /*  57249 */     // GIR_Coverage, 11176,
     /*  57249 */     GIR_EraseRootFromParent_Done,
     /*  57250 */   // Label 506: @57250
     /*  57250 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(57380), // Rule ID 11175 //
     /*  57255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57262 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57278 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57290 */     // MIs[2] z
     /*  57290 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  57299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57301 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)))<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57301 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57304 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57308 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57313 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57317 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57378 */     GIR_RootConstrainSelectedInstOperands,
     /*  57379 */     // GIR_Coverage, 11175,
     /*  57379 */     GIR_EraseRootFromParent_Done,
     /*  57380 */   // Label 507: @57380
     /*  57380 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(57510), // Rule ID 7329 //
     /*  57385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57392 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57408 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57420 */     // MIs[2] z
     /*  57420 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  57429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57431 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19665>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57431 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57434 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57438 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57443 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57447 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57464 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57508 */     GIR_RootConstrainSelectedInstOperands,
     /*  57509 */     // GIR_Coverage, 7329,
     /*  57509 */     GIR_EraseRootFromParent_Done,
     /*  57510 */   // Label 508: @57510
     /*  57510 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(57542), // Rule ID 0 //
     /*  57515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  57530 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_13722>>  =>  (S_NOT_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /*  57530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  57533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 0,
     /*  57541 */     GIR_EraseRootFromParent_Done,
     /*  57542 */   // Label 509: @57542
     /*  57542 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(57571), // Rule ID 7430 //
     /*  57547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  57562 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_19665>>  =>  (V_NOT_B32_e32:{ *:[i32] } ?:{ *:[i32] }:$src0)
     /*  57562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_NOT_B32_e32),
     /*  57565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57569 */     GIR_RootConstrainSelectedInstOperands,
     /*  57570 */     // GIR_Coverage, 7430,
     /*  57570 */     GIR_EraseRootFromParent_Done,
     /*  57571 */   // Label 510: @57571
     /*  57571 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(57639), // Rule ID 2648 //
     /*  57576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57604 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57608 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57612 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:16:z
     /*  57616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21221),
     /*  57620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57622 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20795>>, i32:{ *:[i32] }:$src2:$pred:16:z)<<P:16:Predicate_anonymous_21221>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  57637 */     GIR_RootConstrainSelectedInstOperands,
     /*  57638 */     // GIR_Coverage, 2648,
     /*  57638 */     GIR_EraseRootFromParent_Done,
     /*  57639 */   // Label 511: @57639
     /*  57639 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(57707), // Rule ID 8513 //
     /*  57644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57654 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:16:z
     /*  57658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57676 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57680 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21221),
     /*  57688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57690 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:16:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20795>>)<<P:16:Predicate_anonymous_21221>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  57705 */     GIR_RootConstrainSelectedInstOperands,
     /*  57706 */     // GIR_Coverage, 8513,
     /*  57706 */     GIR_EraseRootFromParent_Done,
     /*  57707 */   // Label 512: @57707
     /*  57707 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(57736), // Rule ID 56 //
     /*  57712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13754),
     /*  57723 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13754>>  =>  (S_XOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  57728 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  57734 */     GIR_RootConstrainSelectedInstOperands,
     /*  57735 */     // GIR_Coverage, 56,
     /*  57735 */     GIR_Done,
     /*  57736 */   // Label 513: @57736
     /*  57736 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(57786), // Rule ID 8445 //
     /*  57741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57767 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57773 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  57784 */     GIR_RootConstrainSelectedInstOperands,
     /*  57785 */     // GIR_Coverage, 8445,
     /*  57785 */     GIR_EraseRootFromParent_Done,
     /*  57786 */   // Label 514: @57786
     /*  57786 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(57838), // Rule ID 911 //
     /*  57791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57823 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), -1:{ *:[i32] })  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57836 */     GIR_RootConstrainSelectedInstOperands,
     /*  57837 */     // GIR_Coverage, 911,
     /*  57837 */     GIR_EraseRootFromParent_Done,
     /*  57838 */   // Label 515: @57838
     /*  57838 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(57888), // Rule ID 8446 //
     /*  57843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57875 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  57886 */     GIR_RootConstrainSelectedInstOperands,
     /*  57887 */     // GIR_Coverage, 8446,
     /*  57887 */     GIR_EraseRootFromParent_Done,
     /*  57888 */   // Label 516: @57888
     /*  57888 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(57911), // Rule ID 816 //
     /*  57893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57900 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  57905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  57909 */     GIR_RootConstrainSelectedInstOperands,
     /*  57910 */     // GIR_Coverage, 816,
     /*  57910 */     GIR_Done,
     /*  57911 */   // Label 517: @57911
     /*  57911 */   GIM_Reject,
     /*  57912 */ // Label 494: @57912
     /*  57912 */ GIM_Reject,
     /*  57913 */ // Label 483: @57913
     /*  57913 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(60545),
     /*  57918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57921 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(57979), // Rule ID 61 //
     /*  57926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  57949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  57959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57961 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13722>>  =>  (S_NAND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  57961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B64),
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57977 */     GIR_RootConstrainSelectedInstOperands,
     /*  57978 */     // GIR_Coverage, 61,
     /*  57978 */     GIR_EraseRootFromParent_Done,
     /*  57979 */   // Label 519: @57979
     /*  57979 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(58037), // Rule ID 63 //
     /*  57984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  58017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58019 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13722>>  =>  (S_NOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B64),
     /*  58022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58035 */     GIR_RootConstrainSelectedInstOperands,
     /*  58036 */     // GIR_Coverage, 63,
     /*  58036 */     GIR_EraseRootFromParent_Done,
     /*  58037 */   // Label 520: @58037
     /*  58037 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(58095), // Rule ID 59 //
     /*  58042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  58049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  58075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58077 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13722>>  =>  (S_XNOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B64),
     /*  58080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58093 */     GIR_RootConstrainSelectedInstOperands,
     /*  58094 */     // GIR_Coverage, 59,
     /*  58094 */     GIR_EraseRootFromParent_Done,
     /*  58095 */   // Label 521: @58095
     /*  58095 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(58394), // Rule ID 11187 //
     /*  58100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58104 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58120 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58136 */     // MIs[0] z
     /*  58136 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  58145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58147 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58147 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58150 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58154 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58159 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58165 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58170 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58175 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58178 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58182 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58187 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58193 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58198 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58203 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58206 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58210 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58215 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58221 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58226 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58231 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58234 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58238 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58243 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58246 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58249 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58254 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58257 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58261 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58266 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58272 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58277 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58294 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58300 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58305 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58322 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58369 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58375 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58393 */     // GIR_Coverage, 11187,
     /*  58393 */     GIR_EraseRootFromParent_Done,
     /*  58394 */   // Label 522: @58394
     /*  58394 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(58693), // Rule ID 11188 //
     /*  58399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58403 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58419 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58435 */     // MIs[0] z
     /*  58435 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  58444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58446 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58446 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58449 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58453 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58458 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58464 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58469 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58474 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58477 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58481 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58486 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58492 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58497 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58502 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58505 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58509 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58514 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58520 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58525 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58530 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58533 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58537 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58542 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58545 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58548 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58553 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58556 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58560 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58565 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58571 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58576 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58581 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58584 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58588 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58593 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58599 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58621 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58668 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58674 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58692 */     // GIR_Coverage, 11188,
     /*  58692 */     GIR_EraseRootFromParent_Done,
     /*  58693 */   // Label 523: @58693
     /*  58693 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(58992), // Rule ID 11185 //
     /*  58698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58702 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58718 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58734 */     // MIs[0] z
     /*  58734 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  58743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58745 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58745 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58748 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58752 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58757 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58763 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58768 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58773 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58776 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58780 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58785 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58791 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58796 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58801 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58804 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58808 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58813 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58819 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58824 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58829 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58832 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58836 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58841 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58844 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58847 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58852 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58855 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58859 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58864 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58870 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58875 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58892 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58898 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58903 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58920 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58951 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58967 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58973 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58991 */     // GIR_Coverage, 11185,
     /*  58991 */     GIR_EraseRootFromParent_Done,
     /*  58992 */   // Label 524: @58992
     /*  58992 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(59291), // Rule ID 11186 //
     /*  58997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59001 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59017 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59033 */     // MIs[0] z
     /*  59033 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  59038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  59042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59044 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59044 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59047 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59051 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59056 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59062 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59067 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59072 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59075 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59079 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59084 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59090 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59095 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59100 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59103 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59107 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59112 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59118 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59123 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59128 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59131 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59135 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59140 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59143 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59146 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59151 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59154 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59158 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59163 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59169 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59174 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59191 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59197 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59202 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59219 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59266 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59272 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59290 */     // GIR_Coverage, 11186,
     /*  59290 */     GIR_EraseRootFromParent_Done,
     /*  59291 */   // Label 525: @59291
     /*  59291 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(59589), // Rule ID 11184 //
     /*  59296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59303 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59319 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59331 */     // MIs[2] z
     /*  59331 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  59340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59342 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59342 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59345 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59349 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59354 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59360 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59365 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59370 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59373 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59377 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59382 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59388 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59393 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59398 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59401 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59405 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59410 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59416 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59421 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59426 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59429 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59433 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59438 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59441 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59444 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59449 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59452 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59456 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59461 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59467 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59472 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59477 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59489 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59495 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59500 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59505 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59508 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59512 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59517 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59523 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59545 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59564 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59570 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59588 */     // GIR_Coverage, 11184,
     /*  59588 */     GIR_EraseRootFromParent_Done,
     /*  59589 */   // Label 526: @59589
     /*  59589 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(59887), // Rule ID 11183 //
     /*  59594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59601 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59617 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59629 */     // MIs[2] z
     /*  59629 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  59638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59640 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59640 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59643 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59647 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59652 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59658 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59663 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59668 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59671 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59675 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59680 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59686 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59691 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59696 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59699 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59703 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59708 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59714 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59719 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59724 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59727 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59731 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59736 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59739 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59742 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59747 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59750 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59754 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59759 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59770 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59787 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59793 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59798 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59815 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59849 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59862 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59868 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59886 */     // GIR_Coverage, 11183,
     /*  59886 */     GIR_EraseRootFromParent_Done,
     /*  59887 */   // Label 527: @59887
     /*  59887 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(60185), // Rule ID 11182 //
     /*  59892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59899 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59915 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59927 */     // MIs[2] z
     /*  59927 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  59936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59938 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)))<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59938 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59941 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59945 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59950 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59956 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59961 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59966 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59969 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59973 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59978 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59984 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59989 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59994 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59997 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60001 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60006 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60012 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60017 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60022 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60025 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60029 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60034 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60037 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60040 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60045 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60048 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60052 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60057 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60063 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60068 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60073 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60076 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60080 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60085 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60091 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60096 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60113 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60160 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60166 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60184 */     // GIR_Coverage, 11182,
     /*  60184 */     GIR_EraseRootFromParent_Done,
     /*  60185 */   // Label 528: @60185
     /*  60185 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(60483), // Rule ID 7330 //
     /*  60190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60197 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60213 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60225 */     // MIs[2] z
     /*  60225 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  60230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19665),
     /*  60234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60236 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19665>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  60236 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  60239 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60243 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60248 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  60254 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60259 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60264 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  60267 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60271 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60276 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  60282 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60287 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60292 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  60295 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60299 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60304 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60310 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60315 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60332 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60335 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60338 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60343 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60346 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60350 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60355 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60361 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60366 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60383 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60389 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60394 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60411 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60458 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60464 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60482 */     // GIR_Coverage, 7330,
     /*  60482 */     GIR_EraseRootFromParent_Done,
     /*  60483 */   // Label 529: @60483
     /*  60483 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(60515), // Rule ID 1 //
     /*  60488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  60499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  60503 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, -1:{ *:[i64] })<<P:Predicate_anonymous_13722>>  =>  (S_NOT_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /*  60503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  60506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  60510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  60513 */     GIR_RootConstrainSelectedInstOperands,
     /*  60514 */     // GIR_Coverage, 1,
     /*  60514 */     GIR_EraseRootFromParent_Done,
     /*  60515 */   // Label 530: @60515
     /*  60515 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(60544), // Rule ID 57 //
     /*  60520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13754),
     /*  60531 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13754>>  =>  (S_XOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  60531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  60536 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  60542 */     GIR_RootConstrainSelectedInstOperands,
     /*  60543 */     // GIR_Coverage, 57,
     /*  60543 */     GIR_Done,
     /*  60544 */   // Label 531: @60544
     /*  60544 */   GIM_Reject,
     /*  60545 */ // Label 518: @60545
     /*  60545 */ GIM_Reject,
     /*  60546 */ // Label 484: @60546
     /*  60546 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(60572), // Rule ID 2530 //
     /*  60551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  60554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  60557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60561 */   // (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  60561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  60566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  60570 */   GIR_RootConstrainSelectedInstOperands,
     /*  60571 */   // GIR_Coverage, 2530,
     /*  60571 */   GIR_Done,
     /*  60572 */ // Label 532: @60572
     /*  60572 */ GIM_Reject,
     /*  60573 */ // Label 485: @60573
     /*  60573 */ GIM_Reject,
     /*  60574 */ // Label 6: @60574
     /*  60574 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(60603), // Rule ID 7282 //
     /*  60579 */   // MIs[0] DstI[vdst]
     /*  60579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60587 */   // MIs[0] Operand 1
     /*  60587 */   // No operand predicates
     /*  60587 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34583),
     /*  60591 */   // (frameindex:{ *:[i32] })<<P:Predicate_anonymous_34583>>:$fi  =>  (V_MOV_B32_e32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  60594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60596 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60601 */   GIR_RootConstrainSelectedInstOperands,
     /*  60602 */   // GIR_Coverage, 7282,
     /*  60602 */   GIR_EraseRootFromParent_Done,
     /*  60603 */ // Label 533: @60603
     /*  60603 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(60628), // Rule ID 7283 //
     /*  60608 */   // MIs[0] DstI[sdst]
     /*  60608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  60616 */   // MIs[0] Operand 1
     /*  60616 */   // No operand predicates
     /*  60616 */   // (frameindex:{ *:[i32] }):$fi  =>  (S_MOV_B32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  60619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60621 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60626 */   GIR_RootConstrainSelectedInstOperands,
     /*  60627 */   // GIR_Coverage, 7283,
     /*  60627 */   GIR_EraseRootFromParent_Done,
     /*  60628 */ // Label 534: @60628
     /*  60628 */ GIM_Reject,
     /*  60629 */ // Label 7: @60629
     /*  60629 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(65654),
     /*  60634 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  60637 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /*  60640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  60643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60646 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(62612),
     /*  60651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60655 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(60778), // Rule ID 2740 //
     /*  60660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  60663 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60667 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60671 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60675 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60679 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60683 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60687 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60691 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60695 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60699 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60703 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60707 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60709 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60716 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60723 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60730 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60730 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60733 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60735 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60740 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60745 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60750 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60755 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60760 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60765 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60768 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60773 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60776 */       GIR_RootConstrainSelectedInstOperands,
     /*  60777 */       // GIR_Coverage, 2740,
     /*  60777 */       GIR_EraseRootFromParent_Done,
     /*  60778 */     // Label 537: @60778
     /*  60778 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(60901), // Rule ID 2742 //
     /*  60783 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  60786 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60790 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60794 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60798 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60802 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60806 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60810 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60814 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60818 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60822 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60826 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60830 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60832 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60839 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60846 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60853 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60853 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60856 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60858 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60868 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60873 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60883 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60888 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60891 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60893 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60896 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60899 */       GIR_RootConstrainSelectedInstOperands,
     /*  60900 */       // GIR_Coverage, 2742,
     /*  60900 */       GIR_EraseRootFromParent_Done,
     /*  60901 */     // Label 538: @60901
     /*  60901 */     GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(61079), // Rule ID 2745 //
     /*  60906 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  60909 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60913 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60917 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60921 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60925 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60929 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60933 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60937 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60941 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60945 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60949 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60953 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60955 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60962 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60969 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60976 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  60976 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  60979 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  60983 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60988 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  60990 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60993 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60997 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61002 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61006 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61009 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61012 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61015 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61020 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61030 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61033 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61035 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61040 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61045 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61050 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61055 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61060 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61071 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61074 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61077 */       GIR_RootConstrainSelectedInstOperands,
     /*  61078 */       // GIR_Coverage, 2745,
     /*  61078 */       GIR_EraseRootFromParent_Done,
     /*  61079 */     // Label 539: @61079
     /*  61079 */     GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(61202), // Rule ID 2724 //
     /*  61084 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  61087 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61091 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61095 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61099 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61103 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61107 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61111 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61115 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61119 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61123 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61127 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61131 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61133 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61140 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61147 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61154 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61159 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61164 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61169 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61174 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61179 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61184 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61189 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61192 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61194 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61197 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61200 */       GIR_RootConstrainSelectedInstOperands,
     /*  61201 */       // GIR_Coverage, 2724,
     /*  61201 */       GIR_EraseRootFromParent_Done,
     /*  61202 */     // Label 540: @61202
     /*  61202 */     GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(61380), // Rule ID 2727 //
     /*  61207 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61210 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61214 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61218 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61222 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61226 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61230 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61234 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61238 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61242 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61246 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61250 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61254 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61256 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61263 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61270 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61277 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  61277 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61280 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61284 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61289 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61291 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61294 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61298 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61307 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61313 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61316 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61326 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61334 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61336 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61341 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61346 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61351 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61356 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61361 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61366 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61372 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61375 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61378 */       GIR_RootConstrainSelectedInstOperands,
     /*  61379 */       // GIR_Coverage, 2727,
     /*  61379 */       GIR_EraseRootFromParent_Done,
     /*  61380 */     // Label 541: @61380
     /*  61380 */     GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(61503), // Rule ID 2731 //
     /*  61385 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  61388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61396 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61400 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61404 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61408 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61416 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61420 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61424 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61428 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61432 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61434 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61441 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61448 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61455 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61455 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61458 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61460 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61465 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61470 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61475 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61480 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61485 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61493 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61495 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61501 */       GIR_RootConstrainSelectedInstOperands,
     /*  61502 */       // GIR_Coverage, 2731,
     /*  61502 */       GIR_EraseRootFromParent_Done,
     /*  61503 */     // Label 542: @61503
     /*  61503 */     GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(61669), // Rule ID 2743 //
     /*  61508 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  61511 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61515 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61519 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61523 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61527 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61531 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61535 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61539 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61543 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61545 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61552 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61559 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61566 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_FMA_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61566 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61569 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61573 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61578 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61580 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61583 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61587 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61592 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61595 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61598 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61602 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61605 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61610 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61615 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /*  61623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61625 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61630 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61635 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61640 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61645 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61655 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61658 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61661 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61664 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61667 */       GIR_RootConstrainSelectedInstOperands,
     /*  61668 */       // GIR_Coverage, 2743,
     /*  61668 */       GIR_EraseRootFromParent_Done,
     /*  61669 */     // Label 543: @61669
     /*  61669 */     GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(61835), // Rule ID 2725 //
     /*  61674 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61677 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61681 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61685 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61689 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61693 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61697 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61701 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61705 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61709 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61711 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61718 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61725 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61732 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_MAD_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61732 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61735 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61739 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61744 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61746 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61749 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61753 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61758 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61761 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61764 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61768 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61771 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61786 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /*  61789 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61791 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61796 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61801 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61806 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61811 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61816 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61821 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61827 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61830 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61833 */       GIR_RootConstrainSelectedInstOperands,
     /*  61834 */       // GIR_Coverage, 2725,
     /*  61834 */       GIR_EraseRootFromParent_Done,
     /*  61835 */     // Label 544: @61835
     /*  61835 */     GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(61946), // Rule ID 2739 //
     /*  61840 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  61843 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61847 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61851 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61855 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61859 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61863 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61867 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61871 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61875 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61877 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61884 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61891 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61898 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61898 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61901 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61903 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61908 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61913 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61918 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61923 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61928 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61933 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61936 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61938 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61941 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61944 */       GIR_RootConstrainSelectedInstOperands,
     /*  61945 */       // GIR_Coverage, 2739,
     /*  61945 */       GIR_EraseRootFromParent_Done,
     /*  61946 */     // Label 545: @61946
     /*  61946 */     GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(62057), // Rule ID 2741 //
     /*  61951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  61954 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61958 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61962 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61966 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61970 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61974 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61978 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61982 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61986 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61988 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61995 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62002 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62009 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62009 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62012 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62014 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62019 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62024 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62029 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62034 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62047 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62052 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62055 */       GIR_RootConstrainSelectedInstOperands,
     /*  62056 */       // GIR_Coverage, 2741,
     /*  62056 */       GIR_EraseRootFromParent_Done,
     /*  62057 */     // Label 546: @62057
     /*  62057 */     GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(62223), // Rule ID 2744 //
     /*  62062 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  62065 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62069 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62073 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62077 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62081 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  62085 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62089 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62093 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62097 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62099 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62106 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62113 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62120 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62120 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62123 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62127 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62132 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62134 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62137 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62141 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62150 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62156 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62159 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62164 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62169 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62174 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62177 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62179 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62184 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62189 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62194 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62199 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62204 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62212 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62215 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62218 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62221 */       GIR_RootConstrainSelectedInstOperands,
     /*  62222 */       // GIR_Coverage, 2744,
     /*  62222 */       GIR_EraseRootFromParent_Done,
     /*  62223 */     // Label 547: @62223
     /*  62223 */     GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(62334), // Rule ID 2723 //
     /*  62228 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  62231 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62235 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62239 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62243 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62247 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62251 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62255 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62259 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62263 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62265 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62272 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62279 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62286 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62291 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62296 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62301 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62306 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62311 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62316 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62321 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62324 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62326 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62329 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62332 */       GIR_RootConstrainSelectedInstOperands,
     /*  62333 */       // GIR_Coverage, 2723,
     /*  62333 */       GIR_EraseRootFromParent_Done,
     /*  62334 */     // Label 548: @62334
     /*  62334 */     GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(62500), // Rule ID 2726 //
     /*  62339 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  62342 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62346 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62350 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62354 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62358 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62362 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62366 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62370 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62374 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62376 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62383 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62390 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62397 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62397 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62400 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62404 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62409 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62411 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62414 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62418 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62423 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62427 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62430 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62433 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62436 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62451 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62454 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62456 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62461 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62466 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62476 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62481 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62486 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62489 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62492 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62495 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62498 */       GIR_RootConstrainSelectedInstOperands,
     /*  62499 */       // GIR_Coverage, 2726,
     /*  62499 */       GIR_EraseRootFromParent_Done,
     /*  62500 */     // Label 549: @62500
     /*  62500 */     GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(62611), // Rule ID 2730 //
     /*  62505 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  62508 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62512 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62516 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62520 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62524 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62528 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62532 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62536 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62540 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62542 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62549 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62556 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62563 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62563 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62566 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62568 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62583 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62598 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62601 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62603 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62606 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62609 */       GIR_RootConstrainSelectedInstOperands,
     /*  62610 */       // GIR_Coverage, 2730,
     /*  62610 */       GIR_EraseRootFromParent_Done,
     /*  62611 */     // Label 550: @62611
     /*  62611 */     GIM_Reject,
     /*  62612 */   // Label 536: @62612
     /*  62612 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(62926),
     /*  62617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  62621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62625 */     GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(62775), // Rule ID 7545 //
     /*  62630 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  62633 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62637 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62641 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62645 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62649 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62653 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62657 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62661 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62665 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62669 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62673 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62678 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62682 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62686 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62690 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62694 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62698 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62702 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62706 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62710 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62714 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62718 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62722 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62727 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62731 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62733 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62733 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62736 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62740 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62745 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62770 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62773 */       GIR_RootConstrainSelectedInstOperands,
     /*  62774 */       // GIR_Coverage, 7545,
     /*  62774 */       GIR_EraseRootFromParent_Done,
     /*  62775 */     // Label 552: @62775
     /*  62775 */     GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(62925), // Rule ID 7546 //
     /*  62780 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  62783 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62787 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62791 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62795 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62799 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62803 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62807 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62811 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62815 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62819 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62823 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62828 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62832 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62836 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62840 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62844 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62848 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62852 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62856 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62860 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62864 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62868 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62872 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62877 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62881 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62883 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62883 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62886 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62890 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62895 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62905 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62912 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62916 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62920 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62923 */       GIR_RootConstrainSelectedInstOperands,
     /*  62924 */       // GIR_Coverage, 7546,
     /*  62924 */       GIR_EraseRootFromParent_Done,
     /*  62925 */     // Label 553: @62925
     /*  62925 */     GIM_Reject,
     /*  62926 */   // Label 551: @62926
     /*  62926 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(63037), // Rule ID 7526 //
     /*  62931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  62934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62966 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  62968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62973 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  62977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  62981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  62993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62997 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63001 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63005 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  63007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  63012 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  63020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63022 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34860>>  =>  (S_PACK_HH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  63022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HH_B32_B16),
     /*  63025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  63027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  63031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  63035 */     GIR_RootConstrainSelectedInstOperands,
     /*  63036 */     // GIR_Coverage, 7526,
     /*  63036 */     GIR_EraseRootFromParent_Done,
     /*  63037 */   // Label 554: @63037
     /*  63037 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(63216),
     /*  63042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34922),
     /*  63046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63050 */     GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(63105), // Rule ID 7547 //
     /*  63055 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /*  63058 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63065 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63072 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34922>>  =>  (V_PACK_B32_F16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_e64),
     /*  63075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63077 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63092 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63097 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63100 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63103 */       GIR_RootConstrainSelectedInstOperands,
     /*  63104 */       // GIR_Coverage, 7547,
     /*  63104 */       GIR_EraseRootFromParent_Done,
     /*  63105 */     // Label 556: @63105
     /*  63105 */     GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(63160), // Rule ID 7548 //
     /*  63110 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /*  63113 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63120 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63127 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34922>>  =>  (V_PACK_B32_F16_t16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63127 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_t16_e64),
     /*  63130 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63132 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63137 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63142 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63147 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63152 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63155 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63158 */       GIR_RootConstrainSelectedInstOperands,
     /*  63159 */       // GIR_Coverage, 7548,
     /*  63159 */       GIR_EraseRootFromParent_Done,
     /*  63160 */     // Label 557: @63160
     /*  63160 */     GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(63215), // Rule ID 7549 //
     /*  63165 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /*  63168 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63175 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63182 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34922>>  =>  (V_PACK_B32_F16_fake16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_fake16_e64),
     /*  63185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63187 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63192 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63197 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63202 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63207 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63210 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63213 */       GIR_RootConstrainSelectedInstOperands,
     /*  63214 */       // GIR_Coverage, 7549,
     /*  63214 */       GIR_EraseRootFromParent_Done,
     /*  63215 */     // Label 558: @63215
     /*  63215 */     GIM_Reject,
     /*  63216 */   // Label 555: @63216
     /*  63216 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(63499),
     /*  63221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63225 */     GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(63306), // Rule ID 2623 //
     /*  63230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /*  63233 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63237 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63241 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63245 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63249 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63253 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63257 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63259 */       GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63266 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63273 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers)), (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1)
     /*  63273 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /*  63276 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63278 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63283 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63288 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63293 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63298 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63304 */       GIR_RootConstrainSelectedInstOperands,
     /*  63305 */       // GIR_Coverage, 2623,
     /*  63305 */       GIR_EraseRootFromParent_Done,
     /*  63306 */     // Label 560: @63306
     /*  63306 */     GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(63402), // Rule ID 2721 //
     /*  63311 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /*  63314 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63318 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63322 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63326 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63330 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63334 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63338 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63342 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63344 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63351 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63358 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63358 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  63361 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63363 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63368 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63373 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63378 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63383 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63386 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63389 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63392 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63394 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63397 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63400 */       GIR_RootConstrainSelectedInstOperands,
     /*  63401 */       // GIR_Coverage, 2721,
     /*  63401 */       GIR_EraseRootFromParent_Done,
     /*  63402 */     // Label 561: @63402
     /*  63402 */     GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(63498), // Rule ID 2737 //
     /*  63407 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /*  63410 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63414 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63418 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63422 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63426 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63430 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63434 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63438 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63440 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63447 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63454 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63454 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  63457 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63464 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63469 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63474 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63479 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63482 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63485 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63488 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63493 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63496 */       GIR_RootConstrainSelectedInstOperands,
     /*  63497 */       // GIR_Coverage, 2737,
     /*  63497 */       GIR_EraseRootFromParent_Done,
     /*  63498 */     // Label 562: @63498
     /*  63498 */     GIM_Reject,
     /*  63499 */   // Label 559: @63499
     /*  63499 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(64041),
     /*  63504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  63508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63512 */     GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(63638), // Rule ID 7534 //
     /*  63517 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63520 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63524 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63528 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63532 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63536 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63540 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63544 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63548 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63553 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63557 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63561 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63565 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63569 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63573 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63577 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63581 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63585 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63590 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63594 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63596 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63596 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63599 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63603 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63608 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63618 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63625 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63629 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63633 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63636 */       GIR_RootConstrainSelectedInstOperands,
     /*  63637 */       // GIR_Coverage, 7534,
     /*  63637 */       GIR_EraseRootFromParent_Done,
     /*  63638 */     // Label 564: @63638
     /*  63638 */     GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(63764), // Rule ID 7536 //
     /*  63643 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63646 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63650 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63654 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63658 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63662 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63666 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63670 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63674 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63679 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63683 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63687 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63691 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63695 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63699 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63703 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63707 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63711 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63716 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63720 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63722 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63734 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63744 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63746 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63749 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63751 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63755 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63762 */       GIR_RootConstrainSelectedInstOperands,
     /*  63763 */       // GIR_Coverage, 7536,
     /*  63763 */       GIR_EraseRootFromParent_Done,
     /*  63764 */     // Label 565: @63764
     /*  63764 */     GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(63843), // Rule ID 7543 //
     /*  63769 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63772 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63780 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63784 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63788 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63792 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63796 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63800 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63804 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63808 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63812 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63817 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63821 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63825 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63827 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  63827 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  63830 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63832 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63834 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63838 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63841 */       GIR_RootConstrainSelectedInstOperands,
     /*  63842 */       // GIR_Coverage, 7543,
     /*  63842 */       GIR_EraseRootFromParent_Done,
     /*  63843 */     // Label 566: @63843
     /*  63843 */     GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(63937), // Rule ID 7544 //
     /*  63848 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63896 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63900 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63904 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63906 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2f16] } 0:{ *:[i32] }, VGPR_32:{ *:[f16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  63906 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  63909 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63911 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63914 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63916 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63919 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63923 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63926 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63929 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63932 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63935 */       GIR_RootConstrainSelectedInstOperands,
     /*  63936 */       // GIR_Coverage, 7544,
     /*  63936 */       GIR_EraseRootFromParent_Done,
     /*  63937 */     // Label 567: @63937
     /*  63937 */     GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(64040), // Rule ID 7542 //
     /*  63942 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  63945 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63949 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63953 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63957 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63961 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63965 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63969 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63973 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63977 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63981 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63985 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63989 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63994 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63998 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  64000 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34862>>  =>  (V_BFI_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  64000 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64003 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64007 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64012 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64022 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64029 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64032 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64034 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // b
     /*  64038 */       GIR_RootConstrainSelectedInstOperands,
     /*  64039 */       // GIR_Coverage, 7542,
     /*  64039 */       GIR_EraseRootFromParent_Done,
     /*  64040 */     // Label 568: @64040
     /*  64040 */     GIM_Reject,
     /*  64041 */   // Label 563: @64041
     /*  64041 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(64115), // Rule ID 7525 //
     /*  64046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64102 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34860>>  =>  (S_PACK_LH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  64102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LH_B32_B16),
     /*  64105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  64113 */     GIR_RootConstrainSelectedInstOperands,
     /*  64114 */     // GIR_Coverage, 7525,
     /*  64114 */     GIR_EraseRootFromParent_Done,
     /*  64115 */   // Label 569: @64115
     /*  64115 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(64274),
     /*  64120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64132 */     GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(64195), // Rule ID 7532 //
     /*  64137 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  64140 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64144 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64148 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64152 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64156 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64160 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64164 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64168 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64173 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64177 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64179 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  64179 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  64182 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64184 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64190 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64193 */       GIR_RootConstrainSelectedInstOperands,
     /*  64194 */       // GIR_Coverage, 7532,
     /*  64194 */       GIR_EraseRootFromParent_Done,
     /*  64195 */     // Label 571: @64195
     /*  64195 */     GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(64273), // Rule ID 7533 //
     /*  64200 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  64203 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64207 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64211 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64215 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64219 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64223 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64227 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64231 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64236 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64240 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64242 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2i16] } 0:{ *:[i32] }, VGPR_32:{ *:[i16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  64242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  64245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64247 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64250 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64252 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64255 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64259 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64262 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64265 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64268 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64271 */       GIR_RootConstrainSelectedInstOperands,
     /*  64272 */       // GIR_Coverage, 7533,
     /*  64272 */       GIR_EraseRootFromParent_Done,
     /*  64273 */     // Label 572: @64273
     /*  64273 */     GIM_Reject,
     /*  64274 */   // Label 570: @64274
     /*  64274 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(64344), // Rule ID 7550 //
     /*  64279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  64282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64321 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64331 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), SReg_32:{ *:[i16] }:$src1)  =>  (S_PACK_HL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  64331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HL_B32_B16),
     /*  64334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  64340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64342 */     GIR_RootConstrainSelectedInstOperands,
     /*  64343 */     // GIR_Coverage, 7550,
     /*  64343 */     GIR_EraseRootFromParent_Done,
     /*  64344 */   // Label 573: @64344
     /*  64344 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(64443), // Rule ID 7531 //
     /*  64349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64403 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34862>>  =>  (V_BFI_B32_e64:{ *:[v2i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  64403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64415 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64435 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // b
     /*  64441 */     GIR_RootConstrainSelectedInstOperands,
     /*  64442 */     // GIR_Coverage, 7531,
     /*  64442 */     GIR_EraseRootFromParent_Done,
     /*  64443 */   // Label 574: @64443
     /*  64443 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(64479), // Rule ID 7505 //
     /*  64448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64464 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i16] })
     /*  64464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64477 */     GIR_RootConstrainSelectedInstOperands,
     /*  64478 */     // GIR_Coverage, 7505,
     /*  64478 */     GIR_EraseRootFromParent_Done,
     /*  64479 */   // Label 575: @64479
     /*  64479 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(64512), // Rule ID 7506 //
     /*  64484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64500 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34862>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64510 */     GIR_RootConstrainSelectedInstOperands,
     /*  64511 */     // GIR_Coverage, 7506,
     /*  64511 */     GIR_EraseRootFromParent_Done,
     /*  64512 */   // Label 576: @64512
     /*  64512 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(64572), // Rule ID 7507 //
     /*  64517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64533 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34860>>  =>  (S_AND_B32:{ *:[v2i16] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), SReg_32:{ *:[i16] }:$src1)
     /*  64533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  64536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64545 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64570 */     GIR_RootConstrainSelectedInstOperands,
     /*  64571 */     // GIR_Coverage, 7507,
     /*  64571 */     GIR_EraseRootFromParent_Done,
     /*  64572 */   // Label 577: @64572
     /*  64572 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(64629), // Rule ID 7508 //
     /*  64577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64593 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34862>>  =>  (V_AND_B32_e64:{ *:[v2i16] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$src1)
     /*  64593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  64596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  64600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64605 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  64620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64627 */     GIR_RootConstrainSelectedInstOperands,
     /*  64628 */     // GIR_Coverage, 7508,
     /*  64628 */     GIR_EraseRootFromParent_Done,
     /*  64629 */   // Label 578: @64629
     /*  64629 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(64674), // Rule ID 7513 //
     /*  64634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64659 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64672 */     GIR_RootConstrainSelectedInstOperands,
     /*  64673 */     // GIR_Coverage, 7513,
     /*  64673 */     GIR_EraseRootFromParent_Done,
     /*  64674 */   // Label 579: @64674
     /*  64674 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(64713), // Rule ID 7514 //
     /*  64679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64701 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34862>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i32] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64711 */     GIR_RootConstrainSelectedInstOperands,
     /*  64712 */     // GIR_Coverage, 7514,
     /*  64712 */     GIR_EraseRootFromParent_Done,
     /*  64713 */   // Label 580: @64713
     /*  64713 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(64830),
     /*  64718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64730 */     GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(64763), // Rule ID 7516 //
     /*  64735 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64738 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64742 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64746 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64748 */       // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64753 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64755 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64758 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64761 */       GIR_RootConstrainSelectedInstOperands,
     /*  64762 */       // GIR_Coverage, 7516,
     /*  64762 */       GIR_EraseRootFromParent_Done,
     /*  64763 */     // Label 582: @64763
     /*  64763 */     GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(64796), // Rule ID 7519 //
     /*  64768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64771 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64775 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64779 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64781 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64781 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64784 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64786 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64788 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64791 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64794 */       GIR_RootConstrainSelectedInstOperands,
     /*  64795 */       // GIR_Coverage, 7519,
     /*  64795 */       GIR_EraseRootFromParent_Done,
     /*  64796 */     // Label 583: @64796
     /*  64796 */     GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(64829), // Rule ID 7521 //
     /*  64801 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64804 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64808 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64814 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64814 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64817 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64819 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64821 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64824 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64827 */       GIR_RootConstrainSelectedInstOperands,
     /*  64828 */       // GIR_Coverage, 7521,
     /*  64828 */       GIR_EraseRootFromParent_Done,
     /*  64829 */     // Label 584: @64829
     /*  64829 */     GIM_Reject,
     /*  64830 */   // Label 581: @64830
     /*  64830 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(64869), // Rule ID 7522 //
     /*  64835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64857 */     // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), VGPR_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34862>>  =>  (V_LSHLREV_B32_e64:{ *:[v2f16] } 16:{ *:[i32] }, VGPR_32:{ *:[f16] }:$src1)
     /*  64857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64867 */     GIR_RootConstrainSelectedInstOperands,
     /*  64868 */     // GIR_Coverage, 7522,
     /*  64868 */     GIR_EraseRootFromParent_Done,
     /*  64869 */   // Label 585: @64869
     /*  64869 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(64909), // Rule ID 7511 //
     /*  64874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  64894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64896 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34860>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] })
     /*  64896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64908 */     // GIR_Coverage, 7511,
     /*  64908 */     GIR_EraseRootFromParent_Done,
     /*  64909 */   // Label 586: @64909
     /*  64909 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(64989),
     /*  64914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  64918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64926 */     GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(64957), // Rule ID 7512 //
     /*  64931 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64938 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64942 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64944 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34862>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64949 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64951 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64956 */       // GIR_Coverage, 7512,
     /*  64956 */       GIR_EraseRootFromParent_Done,
     /*  64957 */     // Label 588: @64957
     /*  64957 */     GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(64988), // Rule ID 7515 //
     /*  64962 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64965 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64969 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64973 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64975 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34862>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64975 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64978 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64980 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64987 */       // GIR_Coverage, 7515,
     /*  64987 */       GIR_EraseRootFromParent_Done,
     /*  64988 */     // Label 589: @64988
     /*  64988 */     GIM_Reject,
     /*  64989 */   // Label 587: @64989
     /*  64989 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(65029), // Rule ID 7517 //
     /*  64994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  65014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65016 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34860>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[i32] })
     /*  65016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65028 */     // GIR_Coverage, 7517,
     /*  65028 */     GIR_EraseRootFromParent_Done,
     /*  65029 */   // Label 590: @65029
     /*  65029 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(65253),
     /*  65034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  65038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65046 */     GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(65077), // Rule ID 7518 //
     /*  65051 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  65054 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65058 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65062 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65064 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34862>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65064 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65067 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65069 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65071 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65076 */       // GIR_Coverage, 7518,
     /*  65076 */       GIR_EraseRootFromParent_Done,
     /*  65077 */     // Label 592: @65077
     /*  65077 */     GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(65108), // Rule ID 7520 //
     /*  65082 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  65085 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65089 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65093 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65095 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34862>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65095 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65098 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65100 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65102 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65107 */       // GIR_Coverage, 7520,
     /*  65107 */       GIR_EraseRootFromParent_Done,
     /*  65108 */     // Label 593: @65108
     /*  65108 */     GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(65180), // Rule ID 7523 //
     /*  65113 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65116 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65120 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34862>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65120 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65123 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65127 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65132 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65142 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65144 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65147 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65151 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65156 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65159 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65163 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65165 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65168 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65170 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65172 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65175 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65178 */       GIR_RootConstrainSelectedInstOperands,
     /*  65179 */       // GIR_Coverage, 7523,
     /*  65179 */       GIR_EraseRootFromParent_Done,
     /*  65180 */     // Label 594: @65180
     /*  65180 */     GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(65252), // Rule ID 7524 //
     /*  65185 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65188 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65192 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34862>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65192 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65195 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65199 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65204 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65214 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65216 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65219 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65223 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65228 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65231 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65237 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65240 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65242 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65244 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65247 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65250 */       GIR_RootConstrainSelectedInstOperands,
     /*  65251 */       // GIR_Coverage, 7524,
     /*  65251 */       GIR_EraseRootFromParent_Done,
     /*  65252 */     // Label 595: @65252
     /*  65252 */     GIM_Reject,
     /*  65253 */   // Label 591: @65253
     /*  65253 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(65284), // Rule ID 7527 //
     /*  65258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  65277 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_PACK_LL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  65277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65282 */     GIR_RootConstrainSelectedInstOperands,
     /*  65283 */     // GIR_Coverage, 7527,
     /*  65283 */     GIR_Done,
     /*  65284 */   // Label 596: @65284
     /*  65284 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(65453),
     /*  65289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  65293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65297 */     GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(65351), // Rule ID 7528 //
     /*  65302 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65305 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65309 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65313 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65325 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65335 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65337 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65340 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65342 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65344 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65346 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65349 */       GIR_RootConstrainSelectedInstOperands,
     /*  65350 */       // GIR_Coverage, 7528,
     /*  65350 */       GIR_EraseRootFromParent_Done,
     /*  65351 */     // Label 598: @65351
     /*  65351 */     GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(65398), // Rule ID 7529 //
     /*  65356 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65359 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65363 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65367 */       // (build_vector:{ *:[v2i16] } VGPR_16:{ *:[i16] }:$a, VGPR_16:{ *:[i16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (REG_SEQUENCE:{ *:[v2i16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[i16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[i16] }:$b, hi16:{ *:[i32] })
     /*  65367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65372 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65374 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65377 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65382 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65397 */       // GIR_Coverage, 7529,
     /*  65397 */       GIR_EraseRootFromParent_Done,
     /*  65398 */     // Label 599: @65398
     /*  65398 */     GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(65452), // Rule ID 7535 //
     /*  65403 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65406 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65410 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65414 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65414 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65417 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65421 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65426 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65436 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65438 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65441 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65443 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65445 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65447 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65450 */       GIR_RootConstrainSelectedInstOperands,
     /*  65451 */       // GIR_Coverage, 7535,
     /*  65451 */       GIR_EraseRootFromParent_Done,
     /*  65452 */     // Label 600: @65452
     /*  65452 */     GIM_Reject,
     /*  65453 */   // Label 597: @65453
     /*  65453 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(65484), // Rule ID 7537 //
     /*  65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34860),
     /*  65477 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34860>>  =>  (S_PACK_LL_B32_B16:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)
     /*  65477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65482 */     GIR_RootConstrainSelectedInstOperands,
     /*  65483 */     // GIR_Coverage, 7537,
     /*  65483 */     GIR_Done,
     /*  65484 */   // Label 601: @65484
     /*  65484 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(65653),
     /*  65489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34862),
     /*  65493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65497 */     GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(65551), // Rule ID 7538 //
     /*  65502 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65505 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65509 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65513 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65513 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65516 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65520 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65525 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65535 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65542 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65544 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65546 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65549 */       GIR_RootConstrainSelectedInstOperands,
     /*  65550 */       // GIR_Coverage, 7538,
     /*  65550 */       GIR_EraseRootFromParent_Done,
     /*  65551 */     // Label 603: @65551
     /*  65551 */     GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(65605), // Rule ID 7539 //
     /*  65556 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65559 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65563 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65567 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65579 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65589 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65596 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65598 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65603 */       GIR_RootConstrainSelectedInstOperands,
     /*  65604 */       // GIR_Coverage, 7539,
     /*  65604 */       GIR_EraseRootFromParent_Done,
     /*  65605 */     // Label 604: @65605
     /*  65605 */     GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(65652), // Rule ID 7540 //
     /*  65610 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65613 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65617 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65621 */       // (build_vector:{ *:[v2f16] } VGPR_16:{ *:[f16] }:$a, VGPR_16:{ *:[f16] }:$b)<<P:Predicate_anonymous_34862>>  =>  (REG_SEQUENCE:{ *:[v2f16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[f16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[f16] }:$b, hi16:{ *:[i32] })
     /*  65621 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65624 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65626 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65628 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65631 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65633 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65636 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65641 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65646 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65651 */       // GIR_Coverage, 7540,
     /*  65651 */       GIR_EraseRootFromParent_Done,
     /*  65652 */     // Label 605: @65652
     /*  65652 */     GIM_Reject,
     /*  65653 */   // Label 602: @65653
     /*  65653 */   GIM_Reject,
     /*  65654 */ // Label 535: @65654
     /*  65654 */ GIM_Reject,
     /*  65655 */ // Label 8: @65655
     /*  65655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(34), /*)*//*default:*//*Label 632*/ GIMT_Encode4(71483),
     /*  65666 */ /*GILLT_s16*//*Label 606*/ GIMT_Encode4(65770),
     /*  65670 */ /*GILLT_s32*//*Label 607*/ GIMT_Encode4(65884),
     /*  65674 */ /*GILLT_s64*//*Label 608*/ GIMT_Encode4(66117),
     /*  65678 */ /*GILLT_v2s16*//*Label 609*/ GIMT_Encode4(66408),
     /*  65682 */ /*GILLT_v2s32*//*Label 610*/ GIMT_Encode4(66583),
     /*  65686 */ /*GILLT_v2s64*//*Label 611*/ GIMT_Encode4(66903),
     /*  65690 */ /*GILLT_v3s32*//*Label 612*/ GIMT_Encode4(67194),
     /*  65694 */ /*GILLT_v3s64*//*Label 613*/ GIMT_Encode4(67248),
     /*  65698 */ /*GILLT_v4s16*//*Label 614*/ GIMT_Encode4(67423),
     /*  65702 */ /*GILLT_v4s32*//*Label 615*/ GIMT_Encode4(67714),
     /*  65706 */ /*GILLT_v4s64*//*Label 616*/ GIMT_Encode4(68005),
     /*  65710 */ /*GILLT_v5s32*//*Label 617*/ GIMT_Encode4(68296),
     /*  65714 */ /*GILLT_v6s32*//*Label 618*/ GIMT_Encode4(68410),
     /*  65718 */ /*GILLT_v7s32*//*Label 619*/ GIMT_Encode4(68643),
     /*  65722 */ /*GILLT_v8s16*//*Label 620*/ GIMT_Encode4(68757),
     /*  65726 */ /*GILLT_v8s32*//*Label 621*/ GIMT_Encode4(69106),
     /*  65730 */ /*GILLT_v8s64*//*Label 622*/ GIMT_Encode4(69455),
     /*  65734 */ /*GILLT_v9s32*//*Label 623*/ GIMT_Encode4(69746),
     /*  65738 */ /*GILLT_v10s32*//*Label 624*/ GIMT_Encode4(69860),
     /*  65742 */ /*GILLT_v11s32*//*Label 625*/ GIMT_Encode4(69974),
     /*  65746 */ /*GILLT_v12s32*//*Label 626*/ GIMT_Encode4(70088),
     /*  65750 */ /*GILLT_v16s16*//*Label 627*/ GIMT_Encode4(70202),
     /*  65754 */ /*GILLT_v16s32*//*Label 628*/ GIMT_Encode4(70551),
     /*  65758 */ /*GILLT_v16s64*//*Label 629*/ GIMT_Encode4(70842),
     /*  65762 */ /*GILLT_v32s16*//*Label 630*/ GIMT_Encode4(71017),
     /*  65766 */ /*GILLT_v32s32*//*Label 631*/ GIMT_Encode4(71308),
     /*  65770 */ // Label 606: @65770
     /*  65770 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(65883),
     /*  65775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  65778 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(65804), // Rule ID 7028 //
     /*  65783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65791 */     // (bitconvert:{ *:[i16] } VGPR_32:{ *:[f16] }:$src0)  =>  VGPR_32:{ *:[i16] }:$src0
     /*  65791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65794 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65803 */     // GIR_Coverage, 7028,
     /*  65803 */     GIR_EraseRootFromParent_Done,
     /*  65804 */   // Label 634: @65804
     /*  65804 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(65830), // Rule ID 7029 //
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65817 */     // (bitconvert:{ *:[f16] } VGPR_32:{ *:[i16] }:$src0)  =>  VGPR_32:{ *:[f16] }:$src0
     /*  65817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65820 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65822 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65829 */     // GIR_Coverage, 7029,
     /*  65829 */     GIR_EraseRootFromParent_Done,
     /*  65830 */   // Label 635: @65830
     /*  65830 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(65856), // Rule ID 7030 //
     /*  65835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65843 */     // (bitconvert:{ *:[i16] } SReg_32:{ *:[f16] }:$src0)  =>  SReg_32:{ *:[i16] }:$src0
     /*  65843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65846 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65855 */     // GIR_Coverage, 7030,
     /*  65855 */     GIR_EraseRootFromParent_Done,
     /*  65856 */   // Label 636: @65856
     /*  65856 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(65882), // Rule ID 7031 //
     /*  65861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65869 */     // (bitconvert:{ *:[f16] } SReg_32:{ *:[i16] }:$src0)  =>  SReg_32:{ *:[f16] }:$src0
     /*  65869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65872 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65881 */     // GIR_Coverage, 7031,
     /*  65881 */     GIR_EraseRootFromParent_Done,
     /*  65882 */   // Label 637: @65882
     /*  65882 */   GIM_Reject,
     /*  65883 */ // Label 633: @65883
     /*  65883 */ GIM_Reject,
     /*  65884 */ // Label 607: @65884
     /*  65884 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(65913), // Rule ID 7032 //
     /*  65889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65900 */   // (bitconvert:{ *:[i32] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
     /*  65900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65912 */   // GIR_Coverage, 7032,
     /*  65912 */   GIR_EraseRootFromParent_Done,
     /*  65913 */ // Label 638: @65913
     /*  65913 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(65942), // Rule ID 7033 //
     /*  65918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65929 */   // (bitconvert:{ *:[f32] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
     /*  65929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65941 */   // GIR_Coverage, 7033,
     /*  65941 */   GIR_EraseRootFromParent_Done,
     /*  65942 */ // Label 639: @65942
     /*  65942 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(65971), // Rule ID 7034 //
     /*  65947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65958 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  65958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65970 */   // GIR_Coverage, 7034,
     /*  65970 */   GIR_EraseRootFromParent_Done,
     /*  65971 */ // Label 640: @65971
     /*  65971 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(66000), // Rule ID 7035 //
     /*  65976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65987 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  65987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65990 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65999 */   // GIR_Coverage, 7035,
     /*  65999 */   GIR_EraseRootFromParent_Done,
     /*  66000 */ // Label 641: @66000
     /*  66000 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(66029), // Rule ID 7037 //
     /*  66005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66016 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  66016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66019 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66021 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66023 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66028 */   // GIR_Coverage, 7037,
     /*  66028 */   GIR_EraseRootFromParent_Done,
     /*  66029 */ // Label 642: @66029
     /*  66029 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(66058), // Rule ID 7039 //
     /*  66034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66045 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  66045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66057 */   // GIR_Coverage, 7039,
     /*  66057 */   GIR_EraseRootFromParent_Done,
     /*  66058 */ // Label 643: @66058
     /*  66058 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(66087), // Rule ID 7043 //
     /*  66063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66074 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66086 */   // GIR_Coverage, 7043,
     /*  66086 */   GIR_EraseRootFromParent_Done,
     /*  66087 */ // Label 644: @66087
     /*  66087 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(66116), // Rule ID 7045 //
     /*  66092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66103 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66115 */   // GIR_Coverage, 7045,
     /*  66115 */   GIR_EraseRootFromParent_Done,
     /*  66116 */ // Label 645: @66116
     /*  66116 */ GIM_Reject,
     /*  66117 */ // Label 608: @66117
     /*  66117 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(66146), // Rule ID 7046 //
     /*  66122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66133 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66145 */   // GIR_Coverage, 7046,
     /*  66145 */   GIR_EraseRootFromParent_Done,
     /*  66146 */ // Label 646: @66146
     /*  66146 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(66175), // Rule ID 7047 //
     /*  66151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66162 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66174 */   // GIR_Coverage, 7047,
     /*  66174 */   GIR_EraseRootFromParent_Done,
     /*  66175 */ // Label 647: @66175
     /*  66175 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(66204), // Rule ID 7050 //
     /*  66180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66191 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66203 */   // GIR_Coverage, 7050,
     /*  66203 */   GIR_EraseRootFromParent_Done,
     /*  66204 */ // Label 648: @66204
     /*  66204 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(66233), // Rule ID 7052 //
     /*  66209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66220 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66223 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66225 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66232 */   // GIR_Coverage, 7052,
     /*  66232 */   GIR_EraseRootFromParent_Done,
     /*  66233 */ // Label 649: @66233
     /*  66233 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(66262), // Rule ID 7054 //
     /*  66238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66249 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66261 */   // GIR_Coverage, 7054,
     /*  66261 */   GIR_EraseRootFromParent_Done,
     /*  66262 */ // Label 650: @66262
     /*  66262 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(66291), // Rule ID 7056 //
     /*  66267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66278 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66290 */   // GIR_Coverage, 7056,
     /*  66290 */   GIR_EraseRootFromParent_Done,
     /*  66291 */ // Label 651: @66291
     /*  66291 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(66320), // Rule ID 7071 //
     /*  66296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66307 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66310 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66312 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66319 */   // GIR_Coverage, 7071,
     /*  66319 */   GIR_EraseRootFromParent_Done,
     /*  66320 */ // Label 652: @66320
     /*  66320 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(66349), // Rule ID 7072 //
     /*  66325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66336 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66339 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66348 */   // GIR_Coverage, 7072,
     /*  66348 */   GIR_EraseRootFromParent_Done,
     /*  66349 */ // Label 653: @66349
     /*  66349 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(66378), // Rule ID 7075 //
     /*  66354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66365 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66368 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66370 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66372 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66377 */   // GIR_Coverage, 7075,
     /*  66377 */   GIR_EraseRootFromParent_Done,
     /*  66378 */ // Label 654: @66378
     /*  66378 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(66407), // Rule ID 7076 //
     /*  66383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66394 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66397 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66406 */   // GIR_Coverage, 7076,
     /*  66406 */   GIR_EraseRootFromParent_Done,
     /*  66407 */ // Label 655: @66407
     /*  66407 */ GIM_Reject,
     /*  66408 */ // Label 609: @66408
     /*  66408 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(66437), // Rule ID 7036 //
     /*  66413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66424 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66436 */   // GIR_Coverage, 7036,
     /*  66436 */   GIR_EraseRootFromParent_Done,
     /*  66437 */ // Label 656: @66437
     /*  66437 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(66466), // Rule ID 7038 //
     /*  66442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66453 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66465 */   // GIR_Coverage, 7038,
     /*  66465 */   GIR_EraseRootFromParent_Done,
     /*  66466 */ // Label 657: @66466
     /*  66466 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(66495), // Rule ID 7040 //
     /*  66471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66482 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66485 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66494 */   // GIR_Coverage, 7040,
     /*  66494 */   GIR_EraseRootFromParent_Done,
     /*  66495 */ // Label 658: @66495
     /*  66495 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(66524), // Rule ID 7041 //
     /*  66500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66511 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66514 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66516 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66523 */   // GIR_Coverage, 7041,
     /*  66523 */   GIR_EraseRootFromParent_Done,
     /*  66524 */ // Label 659: @66524
     /*  66524 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(66553), // Rule ID 7042 //
     /*  66529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66540 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66552 */   // GIR_Coverage, 7042,
     /*  66552 */   GIR_EraseRootFromParent_Done,
     /*  66553 */ // Label 660: @66553
     /*  66553 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(66582), // Rule ID 7044 //
     /*  66558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66569 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66581 */   // GIR_Coverage, 7044,
     /*  66581 */   GIR_EraseRootFromParent_Done,
     /*  66582 */ // Label 661: @66582
     /*  66582 */ GIM_Reject,
     /*  66583 */ // Label 610: @66583
     /*  66583 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(66612), // Rule ID 7048 //
     /*  66588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66599 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66602 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66604 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66611 */   // GIR_Coverage, 7048,
     /*  66611 */   GIR_EraseRootFromParent_Done,
     /*  66612 */ // Label 662: @66612
     /*  66612 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(66641), // Rule ID 7049 //
     /*  66617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66628 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66640 */   // GIR_Coverage, 7049,
     /*  66640 */   GIR_EraseRootFromParent_Done,
     /*  66641 */ // Label 663: @66641
     /*  66641 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(66670), // Rule ID 7051 //
     /*  66646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66657 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66669 */   // GIR_Coverage, 7051,
     /*  66669 */   GIR_EraseRootFromParent_Done,
     /*  66670 */ // Label 664: @66670
     /*  66670 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(66699), // Rule ID 7053 //
     /*  66675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66686 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66698 */   // GIR_Coverage, 7053,
     /*  66698 */   GIR_EraseRootFromParent_Done,
     /*  66699 */ // Label 665: @66699
     /*  66699 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(66728), // Rule ID 7055 //
     /*  66704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66715 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66727 */   // GIR_Coverage, 7055,
     /*  66727 */   GIR_EraseRootFromParent_Done,
     /*  66728 */ // Label 666: @66728
     /*  66728 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(66757), // Rule ID 7057 //
     /*  66733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66744 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66756 */   // GIR_Coverage, 7057,
     /*  66756 */   GIR_EraseRootFromParent_Done,
     /*  66757 */ // Label 667: @66757
     /*  66757 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(66786), // Rule ID 7060 //
     /*  66762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66773 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66785 */   // GIR_Coverage, 7060,
     /*  66785 */   GIR_EraseRootFromParent_Done,
     /*  66786 */ // Label 668: @66786
     /*  66786 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(66815), // Rule ID 7062 //
     /*  66791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66802 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66814 */   // GIR_Coverage, 7062,
     /*  66814 */   GIR_EraseRootFromParent_Done,
     /*  66815 */ // Label 669: @66815
     /*  66815 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(66844), // Rule ID 7063 //
     /*  66820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66831 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66836 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66843 */   // GIR_Coverage, 7063,
     /*  66843 */   GIR_EraseRootFromParent_Done,
     /*  66844 */ // Label 670: @66844
     /*  66844 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(66873), // Rule ID 7065 //
     /*  66849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66860 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66872 */   // GIR_Coverage, 7065,
     /*  66872 */   GIR_EraseRootFromParent_Done,
     /*  66873 */ // Label 671: @66873
     /*  66873 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(66902), // Rule ID 7067 //
     /*  66878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66889 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66901 */   // GIR_Coverage, 7067,
     /*  66901 */   GIR_EraseRootFromParent_Done,
     /*  66902 */ // Label 672: @66902
     /*  66902 */ GIM_Reject,
     /*  66903 */ // Label 611: @66903
     /*  66903 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(66932), // Rule ID 7081 //
     /*  66908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66919 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  66919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66931 */   // GIR_Coverage, 7081,
     /*  66931 */   GIR_EraseRootFromParent_Done,
     /*  66932 */ // Label 673: @66932
     /*  66932 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(66961), // Rule ID 7083 //
     /*  66937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66948 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  66948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66960 */   // GIR_Coverage, 7083,
     /*  66960 */   GIR_EraseRootFromParent_Done,
     /*  66961 */ // Label 674: @66961
     /*  66961 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(66990), // Rule ID 7084 //
     /*  66966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66977 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  66977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66980 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66982 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66989 */   // GIR_Coverage, 7084,
     /*  66989 */   GIR_EraseRootFromParent_Done,
     /*  66990 */ // Label 675: @66990
     /*  66990 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(67019), // Rule ID 7087 //
     /*  66995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67006 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67009 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67018 */   // GIR_Coverage, 7087,
     /*  67018 */   GIR_EraseRootFromParent_Done,
     /*  67019 */ // Label 676: @67019
     /*  67019 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(67048), // Rule ID 7088 //
     /*  67024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67035 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67047 */   // GIR_Coverage, 7088,
     /*  67047 */   GIR_EraseRootFromParent_Done,
     /*  67048 */ // Label 677: @67048
     /*  67048 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(67077), // Rule ID 7090 //
     /*  67053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67064 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67076 */   // GIR_Coverage, 7090,
     /*  67076 */   GIR_EraseRootFromParent_Done,
     /*  67077 */ // Label 678: @67077
     /*  67077 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(67106), // Rule ID 7107 //
     /*  67082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67093 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67105 */   // GIR_Coverage, 7107,
     /*  67105 */   GIR_EraseRootFromParent_Done,
     /*  67106 */ // Label 679: @67106
     /*  67106 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(67135), // Rule ID 7108 //
     /*  67111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67122 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67134 */   // GIR_Coverage, 7108,
     /*  67134 */   GIR_EraseRootFromParent_Done,
     /*  67135 */ // Label 680: @67135
     /*  67135 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(67164), // Rule ID 7109 //
     /*  67140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67151 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67163 */   // GIR_Coverage, 7109,
     /*  67163 */   GIR_EraseRootFromParent_Done,
     /*  67164 */ // Label 681: @67164
     /*  67164 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(67193), // Rule ID 7110 //
     /*  67169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67180 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67192 */   // GIR_Coverage, 7110,
     /*  67192 */   GIR_EraseRootFromParent_Done,
     /*  67193 */ // Label 682: @67193
     /*  67193 */ GIM_Reject,
     /*  67194 */ // Label 612: @67194
     /*  67194 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(67247),
     /*  67199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s32,
     /*  67202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67210 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(67228), // Rule ID 7079 //
     /*  67215 */     // (bitconvert:{ *:[v3i32] } SGPR_96:{ *:[v3f32] }:$src0)  =>  SGPR_96:{ *:[v3i32] }:$src0
     /*  67215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67218 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67227 */     // GIR_Coverage, 7079,
     /*  67227 */     GIR_EraseRootFromParent_Done,
     /*  67228 */   // Label 684: @67228
     /*  67228 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(67246), // Rule ID 7080 //
     /*  67233 */     // (bitconvert:{ *:[v3f32] } SGPR_96:{ *:[v3i32] }:$src0)  =>  SGPR_96:{ *:[v3f32] }:$src0
     /*  67233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67236 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67245 */     // GIR_Coverage, 7080,
     /*  67245 */     GIR_EraseRootFromParent_Done,
     /*  67246 */   // Label 685: @67246
     /*  67246 */   GIM_Reject,
     /*  67247 */ // Label 683: @67247
     /*  67247 */ GIM_Reject,
     /*  67248 */ // Label 613: @67248
     /*  67248 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(67277), // Rule ID 7119 //
     /*  67253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67264 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67276 */   // GIR_Coverage, 7119,
     /*  67276 */   GIR_EraseRootFromParent_Done,
     /*  67277 */ // Label 686: @67277
     /*  67277 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(67306), // Rule ID 7120 //
     /*  67282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67293 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67305 */   // GIR_Coverage, 7120,
     /*  67305 */   GIR_EraseRootFromParent_Done,
     /*  67306 */ // Label 687: @67306
     /*  67306 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(67335), // Rule ID 7121 //
     /*  67311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67322 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67334 */   // GIR_Coverage, 7121,
     /*  67334 */   GIR_EraseRootFromParent_Done,
     /*  67335 */ // Label 688: @67335
     /*  67335 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(67364), // Rule ID 7122 //
     /*  67340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67351 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67354 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67356 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67363 */   // GIR_Coverage, 7122,
     /*  67363 */   GIR_EraseRootFromParent_Done,
     /*  67364 */ // Label 689: @67364
     /*  67364 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(67393), // Rule ID 7123 //
     /*  67369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67380 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67392 */   // GIR_Coverage, 7123,
     /*  67392 */   GIR_EraseRootFromParent_Done,
     /*  67393 */ // Label 690: @67393
     /*  67393 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(67422), // Rule ID 7124 //
     /*  67398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67409 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67412 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67414 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67421 */   // GIR_Coverage, 7124,
     /*  67421 */   GIR_EraseRootFromParent_Done,
     /*  67422 */ // Label 691: @67422
     /*  67422 */ GIM_Reject,
     /*  67423 */ // Label 614: @67423
     /*  67423 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(67452), // Rule ID 7058 //
     /*  67428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67439 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67442 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67444 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67451 */   // GIR_Coverage, 7058,
     /*  67451 */   GIR_EraseRootFromParent_Done,
     /*  67452 */ // Label 692: @67452
     /*  67452 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(67481), // Rule ID 7059 //
     /*  67457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67468 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67471 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67480 */   // GIR_Coverage, 7059,
     /*  67480 */   GIR_EraseRootFromParent_Done,
     /*  67481 */ // Label 693: @67481
     /*  67481 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(67510), // Rule ID 7061 //
     /*  67486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67497 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67500 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67502 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67509 */   // GIR_Coverage, 7061,
     /*  67509 */   GIR_EraseRootFromParent_Done,
     /*  67510 */ // Label 694: @67510
     /*  67510 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(67539), // Rule ID 7064 //
     /*  67515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67526 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67538 */   // GIR_Coverage, 7064,
     /*  67538 */   GIR_EraseRootFromParent_Done,
     /*  67539 */ // Label 695: @67539
     /*  67539 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(67568), // Rule ID 7066 //
     /*  67544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67555 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67567 */   // GIR_Coverage, 7066,
     /*  67567 */   GIR_EraseRootFromParent_Done,
     /*  67568 */ // Label 696: @67568
     /*  67568 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(67597), // Rule ID 7068 //
     /*  67573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67584 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67587 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67589 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67596 */   // GIR_Coverage, 7068,
     /*  67596 */   GIR_EraseRootFromParent_Done,
     /*  67597 */ // Label 697: @67597
     /*  67597 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(67626), // Rule ID 7069 //
     /*  67602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67613 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67616 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67618 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67625 */   // GIR_Coverage, 7069,
     /*  67625 */   GIR_EraseRootFromParent_Done,
     /*  67626 */ // Label 698: @67626
     /*  67626 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(67655), // Rule ID 7070 //
     /*  67631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67642 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67654 */   // GIR_Coverage, 7070,
     /*  67654 */   GIR_EraseRootFromParent_Done,
     /*  67655 */ // Label 699: @67655
     /*  67655 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(67684), // Rule ID 7073 //
     /*  67660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67671 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67674 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67676 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67683 */   // GIR_Coverage, 7073,
     /*  67683 */   GIR_EraseRootFromParent_Done,
     /*  67684 */ // Label 700: @67684
     /*  67684 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(67713), // Rule ID 7074 //
     /*  67689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67700 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67712 */   // GIR_Coverage, 7074,
     /*  67712 */   GIR_EraseRootFromParent_Done,
     /*  67713 */ // Label 701: @67713
     /*  67713 */ GIM_Reject,
     /*  67714 */ // Label 615: @67714
     /*  67714 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(67743), // Rule ID 7077 //
     /*  67719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67730 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67742 */   // GIR_Coverage, 7077,
     /*  67742 */   GIR_EraseRootFromParent_Done,
     /*  67743 */ // Label 702: @67743
     /*  67743 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(67772), // Rule ID 7078 //
     /*  67748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67759 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67762 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67771 */   // GIR_Coverage, 7078,
     /*  67771 */   GIR_EraseRootFromParent_Done,
     /*  67772 */ // Label 703: @67772
     /*  67772 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(67801), // Rule ID 7082 //
     /*  67777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67788 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  67788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67800 */   // GIR_Coverage, 7082,
     /*  67800 */   GIR_EraseRootFromParent_Done,
     /*  67801 */ // Label 704: @67801
     /*  67801 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(67830), // Rule ID 7085 //
     /*  67806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67817 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67829 */   // GIR_Coverage, 7085,
     /*  67829 */   GIR_EraseRootFromParent_Done,
     /*  67830 */ // Label 705: @67830
     /*  67830 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(67859), // Rule ID 7086 //
     /*  67835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67846 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67858 */   // GIR_Coverage, 7086,
     /*  67858 */   GIR_EraseRootFromParent_Done,
     /*  67859 */ // Label 706: @67859
     /*  67859 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(67888), // Rule ID 7089 //
     /*  67864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67875 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67887 */   // GIR_Coverage, 7089,
     /*  67887 */   GIR_EraseRootFromParent_Done,
     /*  67888 */ // Label 707: @67888
     /*  67888 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(67917), // Rule ID 7092 //
     /*  67893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67904 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  67904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67916 */   // GIR_Coverage, 7092,
     /*  67916 */   GIR_EraseRootFromParent_Done,
     /*  67917 */ // Label 708: @67917
     /*  67917 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(67946), // Rule ID 7095 //
     /*  67922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67933 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67945 */   // GIR_Coverage, 7095,
     /*  67945 */   GIR_EraseRootFromParent_Done,
     /*  67946 */ // Label 709: @67946
     /*  67946 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(67975), // Rule ID 7096 //
     /*  67951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67962 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67974 */   // GIR_Coverage, 7096,
     /*  67974 */   GIR_EraseRootFromParent_Done,
     /*  67975 */ // Label 710: @67975
     /*  67975 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(68004), // Rule ID 7099 //
     /*  67980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67991 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68003 */   // GIR_Coverage, 7099,
     /*  68003 */   GIR_EraseRootFromParent_Done,
     /*  68004 */ // Label 711: @68004
     /*  68004 */ GIM_Reject,
     /*  68005 */ // Label 616: @68005
     /*  68005 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(68034), // Rule ID 7137 //
     /*  68010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  68013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68021 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68024 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68026 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68028 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68033 */   // GIR_Coverage, 7137,
     /*  68033 */   GIR_EraseRootFromParent_Done,
     /*  68034 */ // Label 712: @68034
     /*  68034 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(68063), // Rule ID 7138 //
     /*  68039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  68042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68050 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68053 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68055 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68062 */   // GIR_Coverage, 7138,
     /*  68062 */   GIR_EraseRootFromParent_Done,
     /*  68063 */ // Label 713: @68063
     /*  68063 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(68092), // Rule ID 7139 //
     /*  68068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68079 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68091 */   // GIR_Coverage, 7139,
     /*  68091 */   GIR_EraseRootFromParent_Done,
     /*  68092 */ // Label 714: @68092
     /*  68092 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(68121), // Rule ID 7140 //
     /*  68097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68108 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68120 */   // GIR_Coverage, 7140,
     /*  68120 */   GIR_EraseRootFromParent_Done,
     /*  68121 */ // Label 715: @68121
     /*  68121 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(68150), // Rule ID 7141 //
     /*  68126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68137 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68140 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68142 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68149 */   // GIR_Coverage, 7141,
     /*  68149 */   GIR_EraseRootFromParent_Done,
     /*  68150 */ // Label 716: @68150
     /*  68150 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(68179), // Rule ID 7142 //
     /*  68155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68166 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68178 */   // GIR_Coverage, 7142,
     /*  68178 */   GIR_EraseRootFromParent_Done,
     /*  68179 */ // Label 717: @68179
     /*  68179 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(68208), // Rule ID 7163 //
     /*  68184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68195 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68207 */   // GIR_Coverage, 7163,
     /*  68207 */   GIR_EraseRootFromParent_Done,
     /*  68208 */ // Label 718: @68208
     /*  68208 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(68237), // Rule ID 7164 //
     /*  68213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68224 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68236 */   // GIR_Coverage, 7164,
     /*  68236 */   GIR_EraseRootFromParent_Done,
     /*  68237 */ // Label 719: @68237
     /*  68237 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(68266), // Rule ID 7165 //
     /*  68242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68253 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68265 */   // GIR_Coverage, 7165,
     /*  68265 */   GIR_EraseRootFromParent_Done,
     /*  68266 */ // Label 720: @68266
     /*  68266 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(68295), // Rule ID 7166 //
     /*  68271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68282 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68285 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68287 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68294 */   // GIR_Coverage, 7166,
     /*  68294 */   GIR_EraseRootFromParent_Done,
     /*  68295 */ // Label 721: @68295
     /*  68295 */ GIM_Reject,
     /*  68296 */ // Label 617: @68296
     /*  68296 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(68409),
     /*  68301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v5s32,
     /*  68304 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(68330), // Rule ID 7111 //
     /*  68309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68317 */     // (bitconvert:{ *:[v5i32] } SReg_160:{ *:[v5f32] }:$src0)  =>  SReg_160:{ *:[v5i32] }:$src0
     /*  68317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68320 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68329 */     // GIR_Coverage, 7111,
     /*  68329 */     GIR_EraseRootFromParent_Done,
     /*  68330 */   // Label 723: @68330
     /*  68330 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(68356), // Rule ID 7112 //
     /*  68335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68343 */     // (bitconvert:{ *:[v5f32] } SReg_160:{ *:[v5i32] }:$src0)  =>  SReg_160:{ *:[v5f32] }:$src0
     /*  68343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68346 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68355 */     // GIR_Coverage, 7112,
     /*  68355 */     GIR_EraseRootFromParent_Done,
     /*  68356 */   // Label 724: @68356
     /*  68356 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(68382), // Rule ID 7113 //
     /*  68361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68369 */     // (bitconvert:{ *:[v5i32] } VReg_160:{ *:[v5f32] }:$src0)  =>  VReg_160:{ *:[v5i32] }:$src0
     /*  68369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68372 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68381 */     // GIR_Coverage, 7113,
     /*  68381 */     GIR_EraseRootFromParent_Done,
     /*  68382 */   // Label 725: @68382
     /*  68382 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(68408), // Rule ID 7114 //
     /*  68387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68395 */     // (bitconvert:{ *:[v5f32] } VReg_160:{ *:[v5i32] }:$src0)  =>  VReg_160:{ *:[v5f32] }:$src0
     /*  68395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68398 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68407 */     // GIR_Coverage, 7114,
     /*  68407 */     GIR_EraseRootFromParent_Done,
     /*  68408 */   // Label 726: @68408
     /*  68408 */   GIM_Reject,
     /*  68409 */ // Label 722: @68409
     /*  68409 */ GIM_Reject,
     /*  68410 */ // Label 618: @68410
     /*  68410 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(68439), // Rule ID 7115 //
     /*  68415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68426 */   // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
     /*  68426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68429 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68431 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68438 */   // GIR_Coverage, 7115,
     /*  68438 */   GIR_EraseRootFromParent_Done,
     /*  68439 */ // Label 727: @68439
     /*  68439 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(68468), // Rule ID 7116 //
     /*  68444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68455 */   // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
     /*  68455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68467 */   // GIR_Coverage, 7116,
     /*  68467 */   GIR_EraseRootFromParent_Done,
     /*  68468 */ // Label 728: @68468
     /*  68468 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(68497), // Rule ID 7117 //
     /*  68473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68484 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68496 */   // GIR_Coverage, 7117,
     /*  68496 */   GIR_EraseRootFromParent_Done,
     /*  68497 */ // Label 729: @68497
     /*  68497 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(68526), // Rule ID 7118 //
     /*  68502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68513 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68525 */   // GIR_Coverage, 7118,
     /*  68525 */   GIR_EraseRootFromParent_Done,
     /*  68526 */ // Label 730: @68526
     /*  68526 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(68555), // Rule ID 7125 //
     /*  68531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68542 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68554 */   // GIR_Coverage, 7125,
     /*  68554 */   GIR_EraseRootFromParent_Done,
     /*  68555 */ // Label 731: @68555
     /*  68555 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(68584), // Rule ID 7126 //
     /*  68560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68571 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68583 */   // GIR_Coverage, 7126,
     /*  68583 */   GIR_EraseRootFromParent_Done,
     /*  68584 */ // Label 732: @68584
     /*  68584 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(68613), // Rule ID 7127 //
     /*  68589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68600 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68612 */   // GIR_Coverage, 7127,
     /*  68612 */   GIR_EraseRootFromParent_Done,
     /*  68613 */ // Label 733: @68613
     /*  68613 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(68642), // Rule ID 7128 //
     /*  68618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68629 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68632 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68634 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68641 */   // GIR_Coverage, 7128,
     /*  68641 */   GIR_EraseRootFromParent_Done,
     /*  68642 */ // Label 734: @68642
     /*  68642 */ GIM_Reject,
     /*  68643 */ // Label 619: @68643
     /*  68643 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(68756),
     /*  68648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v7s32,
     /*  68651 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(68677), // Rule ID 7129 //
     /*  68656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68664 */     // (bitconvert:{ *:[v7i32] } SReg_224:{ *:[v7f32] }:$src0)  =>  SReg_224:{ *:[v7i32] }:$src0
     /*  68664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68667 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68676 */     // GIR_Coverage, 7129,
     /*  68676 */     GIR_EraseRootFromParent_Done,
     /*  68677 */   // Label 736: @68677
     /*  68677 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(68703), // Rule ID 7130 //
     /*  68682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68690 */     // (bitconvert:{ *:[v7f32] } SReg_224:{ *:[v7i32] }:$src0)  =>  SReg_224:{ *:[v7f32] }:$src0
     /*  68690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68693 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68702 */     // GIR_Coverage, 7130,
     /*  68702 */     GIR_EraseRootFromParent_Done,
     /*  68703 */   // Label 737: @68703
     /*  68703 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(68729), // Rule ID 7131 //
     /*  68708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68716 */     // (bitconvert:{ *:[v7i32] } VReg_224:{ *:[v7f32] }:$src0)  =>  VReg_224:{ *:[v7i32] }:$src0
     /*  68716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68719 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68728 */     // GIR_Coverage, 7131,
     /*  68728 */     GIR_EraseRootFromParent_Done,
     /*  68729 */   // Label 738: @68729
     /*  68729 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(68755), // Rule ID 7132 //
     /*  68734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68742 */     // (bitconvert:{ *:[v7f32] } VReg_224:{ *:[v7i32] }:$src0)  =>  VReg_224:{ *:[v7f32] }:$src0
     /*  68742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68745 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68754 */     // GIR_Coverage, 7132,
     /*  68754 */     GIR_EraseRootFromParent_Done,
     /*  68755 */   // Label 739: @68755
     /*  68755 */   GIM_Reject,
     /*  68756 */ // Label 735: @68756
     /*  68756 */ GIM_Reject,
     /*  68757 */ // Label 620: @68757
     /*  68757 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(68786), // Rule ID 7091 //
     /*  68762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68773 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68785 */   // GIR_Coverage, 7091,
     /*  68785 */   GIR_EraseRootFromParent_Done,
     /*  68786 */ // Label 740: @68786
     /*  68786 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(68815), // Rule ID 7093 //
     /*  68791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68802 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68814 */   // GIR_Coverage, 7093,
     /*  68814 */   GIR_EraseRootFromParent_Done,
     /*  68815 */ // Label 741: @68815
     /*  68815 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(68844), // Rule ID 7094 //
     /*  68820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68831 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68836 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68843 */   // GIR_Coverage, 7094,
     /*  68843 */   GIR_EraseRootFromParent_Done,
     /*  68844 */ // Label 742: @68844
     /*  68844 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(68873), // Rule ID 7097 //
     /*  68849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68860 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  68860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68872 */   // GIR_Coverage, 7097,
     /*  68872 */   GIR_EraseRootFromParent_Done,
     /*  68873 */ // Label 743: @68873
     /*  68873 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(68902), // Rule ID 7098 //
     /*  68878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68889 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68901 */   // GIR_Coverage, 7098,
     /*  68901 */   GIR_EraseRootFromParent_Done,
     /*  68902 */ // Label 744: @68902
     /*  68902 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(68931), // Rule ID 7100 //
     /*  68907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68918 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  68918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68930 */   // GIR_Coverage, 7100,
     /*  68930 */   GIR_EraseRootFromParent_Done,
     /*  68931 */ // Label 745: @68931
     /*  68931 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(68960), // Rule ID 7101 //
     /*  68936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68947 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68950 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68952 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68959 */   // GIR_Coverage, 7101,
     /*  68959 */   GIR_EraseRootFromParent_Done,
     /*  68960 */ // Label 746: @68960
     /*  68960 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(68989), // Rule ID 7102 //
     /*  68965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68976 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68979 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68981 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68988 */   // GIR_Coverage, 7102,
     /*  68988 */   GIR_EraseRootFromParent_Done,
     /*  68989 */ // Label 747: @68989
     /*  68989 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(69018), // Rule ID 7103 //
     /*  68994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69005 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  69005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69017 */   // GIR_Coverage, 7103,
     /*  69017 */   GIR_EraseRootFromParent_Done,
     /*  69018 */ // Label 748: @69018
     /*  69018 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(69047), // Rule ID 7104 //
     /*  69023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  69026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69034 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69046 */   // GIR_Coverage, 7104,
     /*  69046 */   GIR_EraseRootFromParent_Done,
     /*  69047 */ // Label 749: @69047
     /*  69047 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(69076), // Rule ID 7105 //
     /*  69052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  69055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69063 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69075 */   // GIR_Coverage, 7105,
     /*  69075 */   GIR_EraseRootFromParent_Done,
     /*  69076 */ // Label 750: @69076
     /*  69076 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(69105), // Rule ID 7106 //
     /*  69081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69092 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69104 */   // GIR_Coverage, 7106,
     /*  69104 */   GIR_EraseRootFromParent_Done,
     /*  69105 */ // Label 751: @69105
     /*  69105 */ GIM_Reject,
     /*  69106 */ // Label 621: @69106
     /*  69106 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(69135), // Rule ID 7133 //
     /*  69111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69122 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  69122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69134 */   // GIR_Coverage, 7133,
     /*  69134 */   GIR_EraseRootFromParent_Done,
     /*  69135 */ // Label 752: @69135
     /*  69135 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(69164), // Rule ID 7134 //
     /*  69140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69151 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  69151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69163 */   // GIR_Coverage, 7134,
     /*  69163 */   GIR_EraseRootFromParent_Done,
     /*  69164 */ // Label 753: @69164
     /*  69164 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(69193), // Rule ID 7135 //
     /*  69169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69180 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69192 */   // GIR_Coverage, 7135,
     /*  69192 */   GIR_EraseRootFromParent_Done,
     /*  69193 */ // Label 754: @69193
     /*  69193 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(69222), // Rule ID 7136 //
     /*  69198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69209 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69221 */   // GIR_Coverage, 7136,
     /*  69221 */   GIR_EraseRootFromParent_Done,
     /*  69222 */ // Label 755: @69222
     /*  69222 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(69251), // Rule ID 7143 //
     /*  69227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69238 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69250 */   // GIR_Coverage, 7143,
     /*  69250 */   GIR_EraseRootFromParent_Done,
     /*  69251 */ // Label 756: @69251
     /*  69251 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(69280), // Rule ID 7144 //
     /*  69256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69267 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69279 */   // GIR_Coverage, 7144,
     /*  69279 */   GIR_EraseRootFromParent_Done,
     /*  69280 */ // Label 757: @69280
     /*  69280 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(69309), // Rule ID 7145 //
     /*  69285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69296 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69308 */   // GIR_Coverage, 7145,
     /*  69308 */   GIR_EraseRootFromParent_Done,
     /*  69309 */ // Label 758: @69309
     /*  69309 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(69338), // Rule ID 7146 //
     /*  69314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69325 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69337 */   // GIR_Coverage, 7146,
     /*  69337 */   GIR_EraseRootFromParent_Done,
     /*  69338 */ // Label 759: @69338
     /*  69338 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(69367), // Rule ID 7155 //
     /*  69343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69354 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69366 */   // GIR_Coverage, 7155,
     /*  69366 */   GIR_EraseRootFromParent_Done,
     /*  69367 */ // Label 760: @69367
     /*  69367 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(69396), // Rule ID 7156 //
     /*  69372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69383 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69386 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69395 */   // GIR_Coverage, 7156,
     /*  69395 */   GIR_EraseRootFromParent_Done,
     /*  69396 */ // Label 761: @69396
     /*  69396 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(69425), // Rule ID 7157 //
     /*  69401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69412 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69424 */   // GIR_Coverage, 7157,
     /*  69424 */   GIR_EraseRootFromParent_Done,
     /*  69425 */ // Label 762: @69425
     /*  69425 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(69454), // Rule ID 7158 //
     /*  69430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69441 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69444 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69453 */   // GIR_Coverage, 7158,
     /*  69453 */   GIR_EraseRootFromParent_Done,
     /*  69454 */ // Label 763: @69454
     /*  69454 */ GIM_Reject,
     /*  69455 */ // Label 622: @69455
     /*  69455 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(69484), // Rule ID 7195 //
     /*  69460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  69463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69471 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69474 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69483 */   // GIR_Coverage, 7195,
     /*  69483 */   GIR_EraseRootFromParent_Done,
     /*  69484 */ // Label 764: @69484
     /*  69484 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(69513), // Rule ID 7196 //
     /*  69489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  69492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69500 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69503 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69505 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69512 */   // GIR_Coverage, 7196,
     /*  69512 */   GIR_EraseRootFromParent_Done,
     /*  69513 */ // Label 765: @69513
     /*  69513 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(69542), // Rule ID 7197 //
     /*  69518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69529 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69532 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69541 */   // GIR_Coverage, 7197,
     /*  69541 */   GIR_EraseRootFromParent_Done,
     /*  69542 */ // Label 766: @69542
     /*  69542 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(69571), // Rule ID 7198 //
     /*  69547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69558 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69570 */   // GIR_Coverage, 7198,
     /*  69570 */   GIR_EraseRootFromParent_Done,
     /*  69571 */ // Label 767: @69571
     /*  69571 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(69600), // Rule ID 7201 //
     /*  69576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69587 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69599 */   // GIR_Coverage, 7201,
     /*  69599 */   GIR_EraseRootFromParent_Done,
     /*  69600 */ // Label 768: @69600
     /*  69600 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(69629), // Rule ID 7202 //
     /*  69605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69616 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69628 */   // GIR_Coverage, 7202,
     /*  69628 */   GIR_EraseRootFromParent_Done,
     /*  69629 */ // Label 769: @69629
     /*  69629 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(69658), // Rule ID 7205 //
     /*  69634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  69637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69645 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69648 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69650 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69657 */   // GIR_Coverage, 7205,
     /*  69657 */   GIR_EraseRootFromParent_Done,
     /*  69658 */ // Label 770: @69658
     /*  69658 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(69687), // Rule ID 7206 //
     /*  69663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  69666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69674 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69686 */   // GIR_Coverage, 7206,
     /*  69686 */   GIR_EraseRootFromParent_Done,
     /*  69687 */ // Label 771: @69687
     /*  69687 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(69716), // Rule ID 7207 //
     /*  69692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  69695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69703 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69706 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69708 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69715 */   // GIR_Coverage, 7207,
     /*  69715 */   GIR_EraseRootFromParent_Done,
     /*  69716 */ // Label 772: @69716
     /*  69716 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(69745), // Rule ID 7208 //
     /*  69721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  69724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69732 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69744 */   // GIR_Coverage, 7208,
     /*  69744 */   GIR_EraseRootFromParent_Done,
     /*  69745 */ // Label 773: @69745
     /*  69745 */ GIM_Reject,
     /*  69746 */ // Label 623: @69746
     /*  69746 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(69859),
     /*  69751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v9s32,
     /*  69754 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(69780), // Rule ID 7167 //
     /*  69759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69767 */     // (bitconvert:{ *:[v9i32] } SReg_288:{ *:[v9f32] }:$src0)  =>  SReg_288:{ *:[v9i32] }:$src0
     /*  69767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69770 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69779 */     // GIR_Coverage, 7167,
     /*  69779 */     GIR_EraseRootFromParent_Done,
     /*  69780 */   // Label 775: @69780
     /*  69780 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(69806), // Rule ID 7168 //
     /*  69785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69793 */     // (bitconvert:{ *:[v9f32] } SReg_288:{ *:[v9i32] }:$src0)  =>  SReg_288:{ *:[v9f32] }:$src0
     /*  69793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69796 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69805 */     // GIR_Coverage, 7168,
     /*  69805 */     GIR_EraseRootFromParent_Done,
     /*  69806 */   // Label 776: @69806
     /*  69806 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(69832), // Rule ID 7169 //
     /*  69811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69819 */     // (bitconvert:{ *:[v9i32] } VReg_288:{ *:[v9f32] }:$src0)  =>  VReg_288:{ *:[v9i32] }:$src0
     /*  69819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69822 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69831 */     // GIR_Coverage, 7169,
     /*  69831 */     GIR_EraseRootFromParent_Done,
     /*  69832 */   // Label 777: @69832
     /*  69832 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(69858), // Rule ID 7170 //
     /*  69837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69845 */     // (bitconvert:{ *:[v9f32] } VReg_288:{ *:[v9i32] }:$src0)  =>  VReg_288:{ *:[v9f32] }:$src0
     /*  69845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69848 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69857 */     // GIR_Coverage, 7170,
     /*  69857 */     GIR_EraseRootFromParent_Done,
     /*  69858 */   // Label 778: @69858
     /*  69858 */   GIM_Reject,
     /*  69859 */ // Label 774: @69859
     /*  69859 */ GIM_Reject,
     /*  69860 */ // Label 624: @69860
     /*  69860 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(69973),
     /*  69865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v10s32,
     /*  69868 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(69894), // Rule ID 7171 //
     /*  69873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69881 */     // (bitconvert:{ *:[v10i32] } SReg_320:{ *:[v10f32] }:$src0)  =>  SReg_320:{ *:[v10i32] }:$src0
     /*  69881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69884 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69893 */     // GIR_Coverage, 7171,
     /*  69893 */     GIR_EraseRootFromParent_Done,
     /*  69894 */   // Label 780: @69894
     /*  69894 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(69920), // Rule ID 7172 //
     /*  69899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69907 */     // (bitconvert:{ *:[v10f32] } SReg_320:{ *:[v10i32] }:$src0)  =>  SReg_320:{ *:[v10f32] }:$src0
     /*  69907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69910 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69919 */     // GIR_Coverage, 7172,
     /*  69919 */     GIR_EraseRootFromParent_Done,
     /*  69920 */   // Label 781: @69920
     /*  69920 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(69946), // Rule ID 7173 //
     /*  69925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69933 */     // (bitconvert:{ *:[v10i32] } VReg_320:{ *:[v10f32] }:$src0)  =>  VReg_320:{ *:[v10i32] }:$src0
     /*  69933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69936 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69945 */     // GIR_Coverage, 7173,
     /*  69945 */     GIR_EraseRootFromParent_Done,
     /*  69946 */   // Label 782: @69946
     /*  69946 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(69972), // Rule ID 7174 //
     /*  69951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69959 */     // (bitconvert:{ *:[v10f32] } VReg_320:{ *:[v10i32] }:$src0)  =>  VReg_320:{ *:[v10f32] }:$src0
     /*  69959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69962 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69971 */     // GIR_Coverage, 7174,
     /*  69971 */     GIR_EraseRootFromParent_Done,
     /*  69972 */   // Label 783: @69972
     /*  69972 */   GIM_Reject,
     /*  69973 */ // Label 779: @69973
     /*  69973 */ GIM_Reject,
     /*  69974 */ // Label 625: @69974
     /*  69974 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(70087),
     /*  69979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v11s32,
     /*  69982 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(70008), // Rule ID 7175 //
     /*  69987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69995 */     // (bitconvert:{ *:[v11i32] } SReg_352:{ *:[v11f32] }:$src0)  =>  SReg_352:{ *:[v11i32] }:$src0
     /*  69995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69998 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  70007 */     // GIR_Coverage, 7175,
     /*  70007 */     GIR_EraseRootFromParent_Done,
     /*  70008 */   // Label 785: @70008
     /*  70008 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(70034), // Rule ID 7176 //
     /*  70013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  70017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  70021 */     // (bitconvert:{ *:[v11f32] } SReg_352:{ *:[v11i32] }:$src0)  =>  SReg_352:{ *:[v11f32] }:$src0
     /*  70021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70024 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  70033 */     // GIR_Coverage, 7176,
     /*  70033 */     GIR_EraseRootFromParent_Done,
     /*  70034 */   // Label 786: @70034
     /*  70034 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(70060), // Rule ID 7177 //
     /*  70039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70047 */     // (bitconvert:{ *:[v11i32] } VReg_352:{ *:[v11f32] }:$src0)  =>  VReg_352:{ *:[v11i32] }:$src0
     /*  70047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70050 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70052 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70059 */     // GIR_Coverage, 7177,
     /*  70059 */     GIR_EraseRootFromParent_Done,
     /*  70060 */   // Label 787: @70060
     /*  70060 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(70086), // Rule ID 7178 //
     /*  70065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70073 */     // (bitconvert:{ *:[v11f32] } VReg_352:{ *:[v11i32] }:$src0)  =>  VReg_352:{ *:[v11f32] }:$src0
     /*  70073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70076 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  70085 */     // GIR_Coverage, 7178,
     /*  70085 */     GIR_EraseRootFromParent_Done,
     /*  70086 */   // Label 788: @70086
     /*  70086 */   GIM_Reject,
     /*  70087 */ // Label 784: @70087
     /*  70087 */ GIM_Reject,
     /*  70088 */ // Label 626: @70088
     /*  70088 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(70201),
     /*  70093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v12s32,
     /*  70096 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(70122), // Rule ID 7179 //
     /*  70101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70109 */     // (bitconvert:{ *:[v12i32] } SReg_384:{ *:[v12f32] }:$src0)  =>  SReg_384:{ *:[v12i32] }:$src0
     /*  70109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70112 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70121 */     // GIR_Coverage, 7179,
     /*  70121 */     GIR_EraseRootFromParent_Done,
     /*  70122 */   // Label 790: @70122
     /*  70122 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(70148), // Rule ID 7180 //
     /*  70127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70135 */     // (bitconvert:{ *:[v12f32] } SReg_384:{ *:[v12i32] }:$src0)  =>  SReg_384:{ *:[v12f32] }:$src0
     /*  70135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70138 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70147 */     // GIR_Coverage, 7180,
     /*  70147 */     GIR_EraseRootFromParent_Done,
     /*  70148 */   // Label 791: @70148
     /*  70148 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(70174), // Rule ID 7181 //
     /*  70153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70161 */     // (bitconvert:{ *:[v12i32] } VReg_384:{ *:[v12f32] }:$src0)  =>  VReg_384:{ *:[v12i32] }:$src0
     /*  70161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70164 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70173 */     // GIR_Coverage, 7181,
     /*  70173 */     GIR_EraseRootFromParent_Done,
     /*  70174 */   // Label 792: @70174
     /*  70174 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(70200), // Rule ID 7182 //
     /*  70179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70187 */     // (bitconvert:{ *:[v12f32] } VReg_384:{ *:[v12i32] }:$src0)  =>  VReg_384:{ *:[v12f32] }:$src0
     /*  70187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70190 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70199 */     // GIR_Coverage, 7182,
     /*  70199 */     GIR_EraseRootFromParent_Done,
     /*  70200 */   // Label 793: @70200
     /*  70200 */   GIM_Reject,
     /*  70201 */ // Label 789: @70201
     /*  70201 */ GIM_Reject,
     /*  70202 */ // Label 627: @70202
     /*  70202 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(70231), // Rule ID 7147 //
     /*  70207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70218 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  70218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70230 */   // GIR_Coverage, 7147,
     /*  70230 */   GIR_EraseRootFromParent_Done,
     /*  70231 */ // Label 794: @70231
     /*  70231 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(70260), // Rule ID 7148 //
     /*  70236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70247 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  70247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70259 */   // GIR_Coverage, 7148,
     /*  70259 */   GIR_EraseRootFromParent_Done,
     /*  70260 */ // Label 795: @70260
     /*  70260 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(70289), // Rule ID 7149 //
     /*  70265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70276 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70288 */   // GIR_Coverage, 7149,
     /*  70288 */   GIR_EraseRootFromParent_Done,
     /*  70289 */ // Label 796: @70289
     /*  70289 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(70318), // Rule ID 7150 //
     /*  70294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70305 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70308 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70310 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70317 */   // GIR_Coverage, 7150,
     /*  70317 */   GIR_EraseRootFromParent_Done,
     /*  70318 */ // Label 797: @70318
     /*  70318 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(70347), // Rule ID 7151 //
     /*  70323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70334 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70346 */   // GIR_Coverage, 7151,
     /*  70346 */   GIR_EraseRootFromParent_Done,
     /*  70347 */ // Label 798: @70347
     /*  70347 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(70376), // Rule ID 7152 //
     /*  70352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70363 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70366 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70368 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70375 */   // GIR_Coverage, 7152,
     /*  70375 */   GIR_EraseRootFromParent_Done,
     /*  70376 */ // Label 799: @70376
     /*  70376 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(70405), // Rule ID 7153 //
     /*  70381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70392 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70404 */   // GIR_Coverage, 7153,
     /*  70404 */   GIR_EraseRootFromParent_Done,
     /*  70405 */ // Label 800: @70405
     /*  70405 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(70434), // Rule ID 7154 //
     /*  70410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70421 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70433 */   // GIR_Coverage, 7154,
     /*  70433 */   GIR_EraseRootFromParent_Done,
     /*  70434 */ // Label 801: @70434
     /*  70434 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(70463), // Rule ID 7159 //
     /*  70439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70450 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70453 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70462 */   // GIR_Coverage, 7159,
     /*  70462 */   GIR_EraseRootFromParent_Done,
     /*  70463 */ // Label 802: @70463
     /*  70463 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(70492), // Rule ID 7160 //
     /*  70468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70479 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70482 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70484 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70491 */   // GIR_Coverage, 7160,
     /*  70491 */   GIR_EraseRootFromParent_Done,
     /*  70492 */ // Label 803: @70492
     /*  70492 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(70521), // Rule ID 7161 //
     /*  70497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70508 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70520 */   // GIR_Coverage, 7161,
     /*  70520 */   GIR_EraseRootFromParent_Done,
     /*  70521 */ // Label 804: @70521
     /*  70521 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(70550), // Rule ID 7162 //
     /*  70526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70537 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70540 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70549 */   // GIR_Coverage, 7162,
     /*  70549 */   GIR_EraseRootFromParent_Done,
     /*  70550 */ // Label 805: @70550
     /*  70550 */ GIM_Reject,
     /*  70551 */ // Label 628: @70551
     /*  70551 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(70580), // Rule ID 7187 //
     /*  70556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70567 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70570 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70579 */   // GIR_Coverage, 7187,
     /*  70579 */   GIR_EraseRootFromParent_Done,
     /*  70580 */ // Label 806: @70580
     /*  70580 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(70609), // Rule ID 7188 //
     /*  70585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70596 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70599 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70608 */   // GIR_Coverage, 7188,
     /*  70608 */   GIR_EraseRootFromParent_Done,
     /*  70609 */ // Label 807: @70609
     /*  70609 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(70638), // Rule ID 7191 //
     /*  70614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70625 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70637 */   // GIR_Coverage, 7191,
     /*  70637 */   GIR_EraseRootFromParent_Done,
     /*  70638 */ // Label 808: @70638
     /*  70638 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(70667), // Rule ID 7192 //
     /*  70643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70654 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70657 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70666 */   // GIR_Coverage, 7192,
     /*  70666 */   GIR_EraseRootFromParent_Done,
     /*  70667 */ // Label 809: @70667
     /*  70667 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(70696), // Rule ID 7193 //
     /*  70672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70683 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70686 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70688 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70695 */   // GIR_Coverage, 7193,
     /*  70695 */   GIR_EraseRootFromParent_Done,
     /*  70696 */ // Label 810: @70696
     /*  70696 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(70725), // Rule ID 7194 //
     /*  70701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70712 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70724 */   // GIR_Coverage, 7194,
     /*  70724 */   GIR_EraseRootFromParent_Done,
     /*  70725 */ // Label 811: @70725
     /*  70725 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(70754), // Rule ID 7199 //
     /*  70730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70741 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70744 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70746 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70753 */   // GIR_Coverage, 7199,
     /*  70753 */   GIR_EraseRootFromParent_Done,
     /*  70754 */ // Label 812: @70754
     /*  70754 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(70783), // Rule ID 7200 //
     /*  70759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70770 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70773 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70775 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70782 */   // GIR_Coverage, 7200,
     /*  70782 */   GIR_EraseRootFromParent_Done,
     /*  70783 */ // Label 813: @70783
     /*  70783 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(70812), // Rule ID 7203 //
     /*  70788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70799 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70802 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70804 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70811 */   // GIR_Coverage, 7203,
     /*  70811 */   GIR_EraseRootFromParent_Done,
     /*  70812 */ // Label 814: @70812
     /*  70812 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(70841), // Rule ID 7204 //
     /*  70817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70828 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70840 */   // GIR_Coverage, 7204,
     /*  70840 */   GIR_EraseRootFromParent_Done,
     /*  70841 */ // Label 815: @70841
     /*  70841 */ GIM_Reject,
     /*  70842 */ // Label 629: @70842
     /*  70842 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(70871), // Rule ID 7215 //
     /*  70847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  70850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70858 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70861 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70863 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70870 */   // GIR_Coverage, 7215,
     /*  70870 */   GIR_EraseRootFromParent_Done,
     /*  70871 */ // Label 816: @70871
     /*  70871 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(70900), // Rule ID 7216 //
     /*  70876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  70879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70887 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  70887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70899 */   // GIR_Coverage, 7216,
     /*  70899 */   GIR_EraseRootFromParent_Done,
     /*  70900 */ // Label 817: @70900
     /*  70900 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(70929), // Rule ID 7217 //
     /*  70905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70916 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70919 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70921 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70928 */   // GIR_Coverage, 7217,
     /*  70928 */   GIR_EraseRootFromParent_Done,
     /*  70929 */ // Label 818: @70929
     /*  70929 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(70958), // Rule ID 7219 //
     /*  70934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70945 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  70945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70948 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70957 */   // GIR_Coverage, 7219,
     /*  70957 */   GIR_EraseRootFromParent_Done,
     /*  70958 */ // Label 819: @70958
     /*  70958 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(70987), // Rule ID 7221 //
     /*  70963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70974 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70977 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70979 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70986 */   // GIR_Coverage, 7221,
     /*  70986 */   GIR_EraseRootFromParent_Done,
     /*  70987 */ // Label 820: @70987
     /*  70987 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(71016), // Rule ID 7223 //
     /*  70992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71003 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  71003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71006 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71008 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71015 */   // GIR_Coverage, 7223,
     /*  71015 */   GIR_EraseRootFromParent_Done,
     /*  71016 */ // Label 821: @71016
     /*  71016 */ GIM_Reject,
     /*  71017 */ // Label 630: @71017
     /*  71017 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(71046), // Rule ID 7183 //
     /*  71022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71033 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71045 */   // GIR_Coverage, 7183,
     /*  71045 */   GIR_EraseRootFromParent_Done,
     /*  71046 */ // Label 822: @71046
     /*  71046 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(71075), // Rule ID 7184 //
     /*  71051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71062 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71074 */   // GIR_Coverage, 7184,
     /*  71074 */   GIR_EraseRootFromParent_Done,
     /*  71075 */ // Label 823: @71075
     /*  71075 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(71104), // Rule ID 7185 //
     /*  71080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71091 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71094 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71096 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71103 */   // GIR_Coverage, 7185,
     /*  71103 */   GIR_EraseRootFromParent_Done,
     /*  71104 */ // Label 824: @71104
     /*  71104 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(71133), // Rule ID 7186 //
     /*  71109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71120 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71123 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71132 */   // GIR_Coverage, 7186,
     /*  71132 */   GIR_EraseRootFromParent_Done,
     /*  71133 */ // Label 825: @71133
     /*  71133 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(71162), // Rule ID 7189 //
     /*  71138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71149 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71152 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71154 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71161 */   // GIR_Coverage, 7189,
     /*  71161 */   GIR_EraseRootFromParent_Done,
     /*  71162 */ // Label 826: @71162
     /*  71162 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(71191), // Rule ID 7190 //
     /*  71167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71178 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71181 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71183 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71190 */   // GIR_Coverage, 7190,
     /*  71190 */   GIR_EraseRootFromParent_Done,
     /*  71191 */ // Label 827: @71191
     /*  71191 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(71220), // Rule ID 7209 //
     /*  71196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71207 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71210 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71212 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71219 */   // GIR_Coverage, 7209,
     /*  71219 */   GIR_EraseRootFromParent_Done,
     /*  71220 */ // Label 828: @71220
     /*  71220 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(71249), // Rule ID 7210 //
     /*  71225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71236 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71239 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71241 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71248 */   // GIR_Coverage, 7210,
     /*  71248 */   GIR_EraseRootFromParent_Done,
     /*  71249 */ // Label 829: @71249
     /*  71249 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(71278), // Rule ID 7211 //
     /*  71254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71265 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71268 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71270 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71272 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71277 */   // GIR_Coverage, 7211,
     /*  71277 */   GIR_EraseRootFromParent_Done,
     /*  71278 */ // Label 830: @71278
     /*  71278 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(71307), // Rule ID 7212 //
     /*  71283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71294 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71306 */   // GIR_Coverage, 7212,
     /*  71306 */   GIR_EraseRootFromParent_Done,
     /*  71307 */ // Label 831: @71307
     /*  71307 */ GIM_Reject,
     /*  71308 */ // Label 631: @71308
     /*  71308 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(71337), // Rule ID 7213 //
     /*  71313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  71316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71324 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71336 */   // GIR_Coverage, 7213,
     /*  71336 */   GIR_EraseRootFromParent_Done,
     /*  71337 */ // Label 832: @71337
     /*  71337 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(71366), // Rule ID 7214 //
     /*  71342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  71345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71353 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71365 */   // GIR_Coverage, 7214,
     /*  71365 */   GIR_EraseRootFromParent_Done,
     /*  71366 */ // Label 833: @71366
     /*  71366 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(71395), // Rule ID 7218 //
     /*  71371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71382 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71394 */   // GIR_Coverage, 7218,
     /*  71394 */   GIR_EraseRootFromParent_Done,
     /*  71395 */ // Label 834: @71395
     /*  71395 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(71424), // Rule ID 7220 //
     /*  71400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71411 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71423 */   // GIR_Coverage, 7220,
     /*  71423 */   GIR_EraseRootFromParent_Done,
     /*  71424 */ // Label 835: @71424
     /*  71424 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(71453), // Rule ID 7222 //
     /*  71429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71440 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71443 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71452 */   // GIR_Coverage, 7222,
     /*  71452 */   GIR_EraseRootFromParent_Done,
     /*  71453 */ // Label 836: @71453
     /*  71453 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(71482), // Rule ID 7224 //
     /*  71458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71469 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71472 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71474 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71481 */   // GIR_Coverage, 7224,
     /*  71481 */   GIR_EraseRootFromParent_Done,
     /*  71482 */ // Label 837: @71482
     /*  71482 */ GIM_Reject,
     /*  71483 */ // Label 632: @71483
     /*  71483 */ GIM_Reject,
     /*  71484 */ // Label 9: @71484
     /*  71484 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 840*/ GIMT_Encode4(71678),
     /*  71495 */ /*GILLT_s16*//*Label 838*/ GIMT_Encode4(71503),
     /*  71499 */ /*GILLT_s32*//*Label 839*/ GIMT_Encode4(71642),
     /*  71503 */ // Label 838: @71503
     /*  71503 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(71641),
     /*  71508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  71511 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(71570), // Rule ID 6937 //
     /*  71516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  71519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  71523 */     // MIs[0] round
     /*  71523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  71538 */     // (fptrunc_round:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64),
     /*  71541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71568 */     GIR_RootConstrainSelectedInstOperands,
     /*  71569 */     // GIR_Coverage, 6937,
     /*  71569 */     GIR_EraseRootFromParent_Done,
     /*  71570 */   // Label 842: @71570
     /*  71570 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(71605), // Rule ID 6935 //
     /*  71575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  71578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71582 */     // MIs[0] round
     /*  71582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71590 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO),
     /*  71593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71603 */     GIR_RootConstrainSelectedInstOperands,
     /*  71604 */     // GIR_Coverage, 6935,
     /*  71604 */     GIR_EraseRootFromParent_Done,
     /*  71605 */   // Label 843: @71605
     /*  71605 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(71640), // Rule ID 6936 //
     /*  71610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  71613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71617 */     // MIs[0] round
     /*  71617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71625 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32),
     /*  71628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71630 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71638 */     GIR_RootConstrainSelectedInstOperands,
     /*  71639 */     // GIR_Coverage, 6936,
     /*  71639 */     GIR_EraseRootFromParent_Done,
     /*  71640 */   // Label 844: @71640
     /*  71640 */   GIM_Reject,
     /*  71641 */ // Label 841: @71641
     /*  71641 */ GIM_Reject,
     /*  71642 */ // Label 839: @71642
     /*  71642 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(71677), // Rule ID 6938 //
     /*  71647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  71650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71654 */   // MIs[0] round
     /*  71654 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71657 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71662 */   // (fptrunc_round:{ *:[f32] } f64:{ *:[f64] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F32_F64_PSEUDO:{ *:[f32] } ?:{ *:[f64] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F32_F64_PSEUDO),
     /*  71665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71669 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71675 */   GIR_RootConstrainSelectedInstOperands,
     /*  71676 */   // GIR_Coverage, 6938,
     /*  71676 */   GIR_EraseRootFromParent_Done,
     /*  71677 */ // Label 845: @71677
     /*  71677 */ GIM_Reject,
     /*  71678 */ // Label 840: @71678
     /*  71678 */ GIM_Reject,
     /*  71679 */ // Label 10: @71679
     /*  71679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 849*/ GIMT_Encode4(72006),
     /*  71690 */ /*GILLT_s16*//*Label 846*/ GIMT_Encode4(71702),
     /*  71694 */ /*GILLT_s32*//*Label 847*/ GIMT_Encode4(71876),
     /*  71698 */ /*GILLT_s64*//*Label 848*/ GIMT_Encode4(71956),
     /*  71702 */ // Label 846: @71702
     /*  71702 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(71875),
     /*  71707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  71710 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(71737), // Rule ID 39 //
     /*  71715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13740),
     /*  71726 */     // (ftrunc:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13740>>  =>  (S_TRUNC_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  71726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F16),
     /*  71731 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  71735 */     GIR_RootConstrainSelectedInstOperands,
     /*  71736 */     // GIR_Coverage, 39,
     /*  71736 */     GIR_Done,
     /*  71737 */   // Label 851: @71737
     /*  71737 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(71783), // Rule ID 771 //
     /*  71742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  71745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71756 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_e64),
     /*  71759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71781 */     GIR_RootConstrainSelectedInstOperands,
     /*  71782 */     // GIR_Coverage, 771,
     /*  71782 */     GIR_EraseRootFromParent_Done,
     /*  71783 */   // Label 852: @71783
     /*  71783 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(71829), // Rule ID 773 //
     /*  71788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  71791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71802 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_fake16_e64),
     /*  71805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71827 */     GIR_RootConstrainSelectedInstOperands,
     /*  71828 */     // GIR_Coverage, 773,
     /*  71828 */     GIR_EraseRootFromParent_Done,
     /*  71829 */   // Label 853: @71829
     /*  71829 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(71874), // Rule ID 772 //
     /*  71834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  71837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  71841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  71848 */     // (ftrunc:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_TRUNC_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  71848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_t16_e64),
     /*  71851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71872 */     GIR_RootConstrainSelectedInstOperands,
     /*  71873 */     // GIR_Coverage, 772,
     /*  71873 */     GIR_EraseRootFromParent_Done,
     /*  71874 */   // Label 854: @71874
     /*  71874 */   GIM_Reject,
     /*  71875 */ // Label 850: @71875
     /*  71875 */ GIM_Reject,
     /*  71876 */ // Label 847: @71876
     /*  71876 */ GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(71955),
     /*  71881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  71884 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(71911), // Rule ID 34 //
     /*  71889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13740),
     /*  71900 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13740>>  =>  (S_TRUNC_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  71900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F32),
     /*  71905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  71909 */     GIR_RootConstrainSelectedInstOperands,
     /*  71910 */     // GIR_Coverage, 34,
     /*  71910 */     GIR_Done,
     /*  71911 */   // Label 856: @71911
     /*  71911 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(71954), // Rule ID 657 //
     /*  71916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71927 */     // (ftrunc:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F32_e64),
     /*  71930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71952 */     GIR_RootConstrainSelectedInstOperands,
     /*  71953 */     // GIR_Coverage, 657,
     /*  71953 */     GIR_EraseRootFromParent_Done,
     /*  71954 */   // Label 857: @71954
     /*  71954 */   GIM_Reject,
     /*  71955 */ // Label 855: @71955
     /*  71955 */ GIM_Reject,
     /*  71956 */ // Label 848: @71956
     /*  71956 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(72005), // Rule ID 701 //
     /*  71961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  71964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  71967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  71971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71978 */   // (ftrunc:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F64_e64),
     /*  71981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72003 */   GIR_RootConstrainSelectedInstOperands,
     /*  72004 */   // GIR_Coverage, 701,
     /*  72004 */   GIR_EraseRootFromParent_Done,
     /*  72005 */ // Label 858: @72005
     /*  72005 */ GIM_Reject,
     /*  72006 */ // Label 849: @72006
     /*  72006 */ GIM_Reject,
     /*  72007 */ // Label 11: @72007
     /*  72007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 862*/ GIMT_Encode4(72334),
     /*  72018 */ /*GILLT_s16*//*Label 859*/ GIMT_Encode4(72030),
     /*  72022 */ /*GILLT_s32*//*Label 860*/ GIMT_Encode4(72204),
     /*  72026 */ /*GILLT_s64*//*Label 861*/ GIMT_Encode4(72284),
     /*  72030 */ // Label 859: @72030
     /*  72030 */ GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(72203),
     /*  72035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  72038 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(72065), // Rule ID 40 //
     /*  72043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  72046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  72050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13741),
     /*  72054 */     // (froundeven:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13741>>  =>  (S_RNDNE_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  72054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F16),
     /*  72059 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  72063 */     GIR_RootConstrainSelectedInstOperands,
     /*  72064 */     // GIR_Coverage, 40,
     /*  72064 */     GIR_Done,
     /*  72065 */   // Label 864: @72065
     /*  72065 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(72111), // Rule ID 774 //
     /*  72070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  72073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  72077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72084 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_e64),
     /*  72087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72109 */     GIR_RootConstrainSelectedInstOperands,
     /*  72110 */     // GIR_Coverage, 774,
     /*  72110 */     GIR_EraseRootFromParent_Done,
     /*  72111 */   // Label 865: @72111
     /*  72111 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(72157), // Rule ID 776 //
     /*  72116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  72119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  72123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72130 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_fake16_e64),
     /*  72133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72155 */     GIR_RootConstrainSelectedInstOperands,
     /*  72156 */     // GIR_Coverage, 776,
     /*  72156 */     GIR_EraseRootFromParent_Done,
     /*  72157 */   // Label 866: @72157
     /*  72157 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(72202), // Rule ID 775 //
     /*  72162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  72165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  72169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  72176 */     // (froundeven:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RNDNE_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  72176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_t16_e64),
     /*  72179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72200 */     GIR_RootConstrainSelectedInstOperands,
     /*  72201 */     // GIR_Coverage, 775,
     /*  72201 */     GIR_EraseRootFromParent_Done,
     /*  72202 */   // Label 867: @72202
     /*  72202 */   GIM_Reject,
     /*  72203 */ // Label 863: @72203
     /*  72203 */ GIM_Reject,
     /*  72204 */ // Label 860: @72204
     /*  72204 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(72283),
     /*  72209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72212 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(72239), // Rule ID 35 //
     /*  72217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  72220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  72224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13741),
     /*  72228 */     // (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13741>>  =>  (S_RNDNE_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  72228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F32),
     /*  72233 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  72237 */     GIR_RootConstrainSelectedInstOperands,
     /*  72238 */     // GIR_Coverage, 35,
     /*  72238 */     GIR_Done,
     /*  72239 */   // Label 869: @72239
     /*  72239 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(72282), // Rule ID 659 //
     /*  72244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  72248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72255 */     // (froundeven:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F32_e64),
     /*  72258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72280 */     GIR_RootConstrainSelectedInstOperands,
     /*  72281 */     // GIR_Coverage, 659,
     /*  72281 */     GIR_EraseRootFromParent_Done,
     /*  72282 */   // Label 870: @72282
     /*  72282 */   GIM_Reject,
     /*  72283 */ // Label 868: @72283
     /*  72283 */ GIM_Reject,
     /*  72284 */ // Label 861: @72284
     /*  72284 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(72333), // Rule ID 703 //
     /*  72289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  72292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  72295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  72299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72306 */   // (froundeven:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F64_e64),
     /*  72309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72331 */   GIR_RootConstrainSelectedInstOperands,
     /*  72332 */   // GIR_Coverage, 703,
     /*  72332 */   GIR_EraseRootFromParent_Done,
     /*  72333 */ // Label 871: @72333
     /*  72333 */ GIM_Reject,
     /*  72334 */ // Label 862: @72334
     /*  72334 */ GIM_Reject,
     /*  72335 */ // Label 12: @72335
     /*  72335 */ GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(72474),
     /*  72340 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72343 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(72368), // Rule ID 1342 //
     /*  72348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesHiLoRegisters),
     /*  72351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72355 */     // (readcyclecounter:{ *:[i64] })  =>  (GET_SHADERCYCLESHILO:{ *:[i64] }:{ *:[i1] })
     /*  72355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::GET_SHADERCYCLESHILO),
     /*  72360 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  72366 */     GIR_RootConstrainSelectedInstOperands,
     /*  72367 */     // GIR_Coverage, 1342,
     /*  72367 */     GIR_Done,
     /*  72368 */   // Label 873: @72368
     /*  72368 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(72387), // Rule ID 3525 //
     /*  72373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /*  72376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72380 */     // (readcyclecounter:{ *:[i64] })  =>  (S_MEMTIME:{ *:[i64] })
     /*  72380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /*  72385 */     GIR_RootConstrainSelectedInstOperands,
     /*  72386 */     // GIR_Coverage, 3525,
     /*  72386 */     GIR_Done,
     /*  72387 */   // Label 874: @72387
     /*  72387 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(72473), // Rule ID 3526 //
     /*  72392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesRegister),
     /*  72395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72399 */     // (readcyclecounter:{ *:[i64] })  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 38941:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /*  72399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  72402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  72406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72411 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  72414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  72416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  72419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /*  72423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72428 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(38941),
     /*  72438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  72440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72448 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  72451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  72454 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  72457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  72467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  72472 */     // GIR_Coverage, 3526,
     /*  72472 */     GIR_EraseRootFromParent_Done,
     /*  72473 */   // Label 875: @72473
     /*  72473 */   GIM_Reject,
     /*  72474 */ // Label 872: @72474
     /*  72474 */ GIM_Reject,
     /*  72475 */ // Label 13: @72475
     /*  72475 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(72532),
     /*  72480 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72483 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(72502), // Rule ID 3527 //
     /*  72488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /*  72491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72495 */     // (readsteadycounter:{ *:[i64] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /*  72495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /*  72500 */     GIR_RootConstrainSelectedInstOperands,
     /*  72501 */     // GIR_Coverage, 3527,
     /*  72501 */     GIR_Done,
     /*  72502 */   // Label 877: @72502
     /*  72502 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(72531), // Rule ID 3528 //
     /*  72507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  72510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72514 */     // (readsteadycounter:{ *:[i64] })  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } 131:{ *:[i32] })
     /*  72514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /*  72517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72519 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  72529 */     GIR_RootConstrainSelectedInstOperands,
     /*  72530 */     // GIR_Coverage, 3528,
     /*  72530 */     GIR_EraseRootFromParent_Done,
     /*  72531 */   // Label 878: @72531
     /*  72531 */   GIM_Reject,
     /*  72532 */ // Label 876: @72532
     /*  72532 */ GIM_Reject,
     /*  72533 */ // Label 14: @72533
     /*  72533 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(33), /*)*//*default:*//*Label 903*/ GIMT_Encode4(140024),
     /*  72544 */ /*GILLT_p0s64*//*Label 879*/ GIMT_Encode4(72676),
     /*  72548 */ /*GILLT_p1s64*//*Label 880*/ GIMT_Encode4(74580),
     /*  72552 */ /*GILLT_p2s32*//*Label 881*/ GIMT_Encode4(76484),
     /*  72556 */ /*GILLT_p3s32*//*Label 882*/ GIMT_Encode4(78111),
     /*  72560 */ /*GILLT_p4s64*//*Label 883*/ GIMT_Encode4(79738),
     /*  72564 */ /*GILLT_p5s32*//*Label 884*/ GIMT_Encode4(81642),
     /*  72568 */ /*GILLT_p6s32*//*Label 885*/ GIMT_Encode4(83269),
     /*  72572 */ /*GILLT_s1*//*Label 886*/ GIMT_Encode4(84896),
     /*  72576 */ /*GILLT_s16*//*Label 887*/ GIMT_Encode4(85496),
     /*  72580 */ /*GILLT_s32*//*Label 888*/ GIMT_Encode4(90741),
     /*  72584 */ /*GILLT_s64*//*Label 889*/ GIMT_Encode4(98769),
     /*  72588 */ /*GILLT_v2s16*//*Label 890*/ GIMT_Encode4(104159),
     /*  72592 */ /*GILLT_v2s32*//*Label 891*/ GIMT_Encode4(107403),
     /*  72596 */ /*GILLT_v2s64*//*Label 892*/ GIMT_Encode4(111451),
     /*  72600 */ /*GILLT_v3s32*//*Label 893*/ GIMT_Encode4(115249), GIMT_Encode4(0),
     /*  72608 */ /*GILLT_v4s16*//*Label 894*/ GIMT_Encode4(118468),
     /*  72612 */ /*GILLT_v4s32*//*Label 895*/ GIMT_Encode4(122266),
     /*  72616 */ /*GILLT_v4s64*//*Label 896*/ GIMT_Encode4(126314), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72632 */ /*GILLT_v8s16*//*Label 897*/ GIMT_Encode4(127966),
     /*  72636 */ /*GILLT_v8s32*//*Label 898*/ GIMT_Encode4(131764),
     /*  72640 */ /*GILLT_v8s64*//*Label 899*/ GIMT_Encode4(133416), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72660 */ /*GILLT_v16s16*//*Label 900*/ GIMT_Encode4(135068),
     /*  72664 */ /*GILLT_v16s32*//*Label 901*/ GIMT_Encode4(136720), GIMT_Encode4(0),
     /*  72672 */ /*GILLT_v32s16*//*Label 902*/ GIMT_Encode4(138372),
     /*  72676 */ // Label 879: @72676
     /*  72676 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(74579),
     /*  72681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72684 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(72748), // Rule ID 8362 //
     /*  72689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72719 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  72722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72746 */     GIR_RootConstrainSelectedInstOperands,
     /*  72747 */     // GIR_Coverage, 8362,
     /*  72747 */     GIR_EraseRootFromParent_Done,
     /*  72748 */   // Label 905: @72748
     /*  72748 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(72808), // Rule ID 8367 //
     /*  72753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72779 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  72782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72806 */     GIR_RootConstrainSelectedInstOperands,
     /*  72807 */     // GIR_Coverage, 8367,
     /*  72807 */     GIR_EraseRootFromParent_Done,
     /*  72808 */   // Label 906: @72808
     /*  72808 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(72868), // Rule ID 8373 //
     /*  72813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  72816 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72839 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  72842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72866 */     GIR_RootConstrainSelectedInstOperands,
     /*  72867 */     // GIR_Coverage, 8373,
     /*  72867 */     GIR_EraseRootFromParent_Done,
     /*  72868 */   // Label 907: @72868
     /*  72868 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(72927), // Rule ID 8358 //
     /*  72873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  72876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  72903 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  72906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  72918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72925 */     GIR_RootConstrainSelectedInstOperands,
     /*  72926 */     // GIR_Coverage, 8358,
     /*  72926 */     GIR_EraseRootFromParent_Done,
     /*  72927 */   // Label 908: @72927
     /*  72927 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(72986), // Rule ID 8359 //
     /*  72932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  72935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  72962 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  72965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  72977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72984 */     GIR_RootConstrainSelectedInstOperands,
     /*  72985 */     // GIR_Coverage, 8359,
     /*  72985 */     GIR_EraseRootFromParent_Done,
     /*  72986 */   // Label 909: @72986
     /*  72986 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(73045), // Rule ID 8360 //
     /*  72991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  72994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  73014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73021 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  73021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  73024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73043 */     GIR_RootConstrainSelectedInstOperands,
     /*  73044 */     // GIR_Coverage, 8360,
     /*  73044 */     GIR_EraseRootFromParent_Done,
     /*  73045 */   // Label 910: @73045
     /*  73045 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(73107), // Rule ID 8361 //
     /*  73050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  73053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  73073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73080 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  73083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73105 */     GIR_RootConstrainSelectedInstOperands,
     /*  73106 */     // GIR_Coverage, 8361,
     /*  73106 */     GIR_EraseRootFromParent_Done,
     /*  73107 */   // Label 911: @73107
     /*  73107 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(73162), // Rule ID 8364 //
     /*  73112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  73115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  73138 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  73141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73160 */     GIR_RootConstrainSelectedInstOperands,
     /*  73161 */     // GIR_Coverage, 8364,
     /*  73161 */     GIR_EraseRootFromParent_Done,
     /*  73162 */   // Label 912: @73162
     /*  73162 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(73217), // Rule ID 8365 //
     /*  73167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  73170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73193 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  73193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  73196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73215 */     GIR_RootConstrainSelectedInstOperands,
     /*  73216 */     // GIR_Coverage, 8365,
     /*  73216 */     GIR_EraseRootFromParent_Done,
     /*  73217 */   // Label 913: @73217
     /*  73217 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(73275), // Rule ID 8366 //
     /*  73222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  73225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73248 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  73251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73273 */     GIR_RootConstrainSelectedInstOperands,
     /*  73274 */     // GIR_Coverage, 8366,
     /*  73274 */     GIR_EraseRootFromParent_Done,
     /*  73275 */   // Label 914: @73275
     /*  73275 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(73340), // Rule ID 8085 //
     /*  73280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  73283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73287 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  73309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73316 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  73319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73338 */     GIR_RootConstrainSelectedInstOperands,
     /*  73339 */     // GIR_Coverage, 8085,
     /*  73339 */     GIR_EraseRootFromParent_Done,
     /*  73340 */   // Label 915: @73340
     /*  73340 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(73400), // Rule ID 8017 //
     /*  73345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  73348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73357 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  73361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73376 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  73379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73398 */     GIR_RootConstrainSelectedInstOperands,
     /*  73399 */     // GIR_Coverage, 8017,
     /*  73399 */     GIR_EraseRootFromParent_Done,
     /*  73400 */   // Label 916: @73400
     /*  73400 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(73452), // Rule ID 8369 //
     /*  73405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  73428 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73450 */     GIR_RootConstrainSelectedInstOperands,
     /*  73451 */     // GIR_Coverage, 8369,
     /*  73451 */     GIR_EraseRootFromParent_Done,
     /*  73452 */   // Label 917: @73452
     /*  73452 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(73507), // Rule ID 8370 //
     /*  73457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  73460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  73483 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  73486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73505 */     GIR_RootConstrainSelectedInstOperands,
     /*  73506 */     // GIR_Coverage, 8370,
     /*  73506 */     GIR_EraseRootFromParent_Done,
     /*  73507 */   // Label 918: @73507
     /*  73507 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(73562), // Rule ID 8371 //
     /*  73512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  73515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73538 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  73538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  73541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73560 */     GIR_RootConstrainSelectedInstOperands,
     /*  73561 */     // GIR_Coverage, 8371,
     /*  73561 */     GIR_EraseRootFromParent_Done,
     /*  73562 */   // Label 919: @73562
     /*  73562 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(73620), // Rule ID 8372 //
     /*  73567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  73570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73593 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  73596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73618 */     GIR_RootConstrainSelectedInstOperands,
     /*  73619 */     // GIR_Coverage, 8372,
     /*  73619 */     GIR_EraseRootFromParent_Done,
     /*  73620 */   // Label 920: @73620
     /*  73620 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(73681), // Rule ID 8086 //
     /*  73625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  73628 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  73650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73657 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  73660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73679 */     GIR_RootConstrainSelectedInstOperands,
     /*  73680 */     // GIR_Coverage, 8086,
     /*  73680 */     GIR_EraseRootFromParent_Done,
     /*  73681 */   // Label 921: @73681
     /*  73681 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(73737), // Rule ID 8018 //
     /*  73686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  73689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73694 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  73698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73713 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  73716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73735 */     GIR_RootConstrainSelectedInstOperands,
     /*  73736 */     // GIR_Coverage, 8018,
     /*  73736 */     GIR_EraseRootFromParent_Done,
     /*  73737 */   // Label 922: @73737
     /*  73737 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(73788), // Rule ID 8363 //
     /*  73742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  73745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73753 */     // MIs[0] sbase
     /*  73753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  73769 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73774 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73786 */     GIR_RootConstrainSelectedInstOperands,
     /*  73787 */     // GIR_Coverage, 8363,
     /*  73787 */     GIR_EraseRootFromParent_Done,
     /*  73788 */   // Label 923: @73788
     /*  73788 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(73835), // Rule ID 8368 //
     /*  73793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  73796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73804 */     // MIs[0] sbase
     /*  73804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73816 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  73819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73833 */     GIR_RootConstrainSelectedInstOperands,
     /*  73834 */     // GIR_Coverage, 8368,
     /*  73834 */     GIR_EraseRootFromParent_Done,
     /*  73835 */   // Label 924: @73835
     /*  73835 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(73879), // Rule ID 8374 //
     /*  73840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73848 */     // MIs[0] sbase
     /*  73848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73860 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73865 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73877 */     GIR_RootConstrainSelectedInstOperands,
     /*  73878 */     // GIR_Coverage, 8374,
     /*  73878 */     GIR_EraseRootFromParent_Done,
     /*  73879 */   // Label 925: @73879
     /*  73879 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(73936), // Rule ID 4329 //
     /*  73884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  73887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  73892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  73907 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  73910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  73917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  73922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  73927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73934 */     GIR_RootConstrainSelectedInstOperands,
     /*  73935 */     // GIR_Coverage, 4329,
     /*  73935 */     GIR_EraseRootFromParent_Done,
     /*  73936 */   // Label 926: @73936
     /*  73936 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(73988), // Rule ID 4328 //
     /*  73941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  73944 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  73949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  73964 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  73964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  73967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  73974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73986 */     GIR_RootConstrainSelectedInstOperands,
     /*  73987 */     // GIR_Coverage, 4328,
     /*  73987 */     GIR_EraseRootFromParent_Done,
     /*  73988 */   // Label 927: @73988
     /*  73988 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(74040), // Rule ID 4327 //
     /*  73993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  73996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  74001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  74016 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  74026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74038 */     GIR_RootConstrainSelectedInstOperands,
     /*  74039 */     // GIR_Coverage, 4327,
     /*  74039 */     GIR_EraseRootFromParent_Done,
     /*  74040 */   // Label 928: @74040
     /*  74040 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(74107), // Rule ID 4551 //
     /*  74045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  74048 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  74070 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  74073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  74080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  74090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  74095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74105 */     GIR_RootConstrainSelectedInstOperands,
     /*  74106 */     // GIR_Coverage, 4551,
     /*  74106 */     GIR_EraseRootFromParent_Done,
     /*  74107 */   // Label 929: @74107
     /*  74107 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(74171), // Rule ID 4553 //
     /*  74112 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  74134 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  74137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  74144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  74154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  74159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74169 */     GIR_RootConstrainSelectedInstOperands,
     /*  74170 */     // GIR_Coverage, 4553,
     /*  74170 */     GIR_EraseRootFromParent_Done,
     /*  74171 */   // Label 930: @74171
     /*  74171 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(74232), // Rule ID 7961 //
     /*  74176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  74179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74183 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  74188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  74203 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  74203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  74206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  74213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  74218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  74223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74230 */     GIR_RootConstrainSelectedInstOperands,
     /*  74231 */     // GIR_Coverage, 7961,
     /*  74231 */     GIR_EraseRootFromParent_Done,
     /*  74232 */   // Label 931: @74232
     /*  74232 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(74294), // Rule ID 4550 //
     /*  74237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  74240 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  74262 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  74265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74292 */     GIR_RootConstrainSelectedInstOperands,
     /*  74293 */     // GIR_Coverage, 4550,
     /*  74293 */     GIR_EraseRootFromParent_Done,
     /*  74294 */   // Label 932: @74294
     /*  74294 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(74353), // Rule ID 4552 //
     /*  74299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  74321 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  74324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74351 */     GIR_RootConstrainSelectedInstOperands,
     /*  74352 */     // GIR_Coverage, 4552,
     /*  74352 */     GIR_EraseRootFromParent_Done,
     /*  74353 */   // Label 933: @74353
     /*  74353 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(74410), // Rule ID 7963 //
     /*  74358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  74361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  74366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  74381 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  74381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  74384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  74391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  74396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  74401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74408 */     GIR_RootConstrainSelectedInstOperands,
     /*  74409 */     // GIR_Coverage, 7963,
     /*  74409 */     GIR_EraseRootFromParent_Done,
     /*  74410 */   // Label 934: @74410
     /*  74410 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(74469), // Rule ID 3916 //
     /*  74415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  74418 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  74440 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  74443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  74450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  74455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74467 */     GIR_RootConstrainSelectedInstOperands,
     /*  74468 */     // GIR_Coverage, 3916,
     /*  74468 */     GIR_EraseRootFromParent_Done,
     /*  74469 */   // Label 935: @74469
     /*  74469 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(74523), // Rule ID 3915 //
     /*  74474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  74477 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  74499 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  74499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  74502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  74509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74521 */     GIR_RootConstrainSelectedInstOperands,
     /*  74522 */     // GIR_Coverage, 3915,
     /*  74522 */     GIR_EraseRootFromParent_Done,
     /*  74523 */   // Label 936: @74523
     /*  74523 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(74578), // Rule ID 3641 //
     /*  74528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  74531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  74554 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  74554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  74557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  74564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74576 */     GIR_RootConstrainSelectedInstOperands,
     /*  74577 */     // GIR_Coverage, 3641,
     /*  74577 */     GIR_EraseRootFromParent_Done,
     /*  74578 */   // Label 937: @74578
     /*  74578 */   GIM_Reject,
     /*  74579 */ // Label 904: @74579
     /*  74579 */ GIM_Reject,
     /*  74580 */ // Label 880: @74580
     /*  74580 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(76483),
     /*  74585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74588 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(74652), // Rule ID 8379 //
     /*  74593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74623 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74650 */     GIR_RootConstrainSelectedInstOperands,
     /*  74651 */     // GIR_Coverage, 8379,
     /*  74651 */     GIR_EraseRootFromParent_Done,
     /*  74652 */   // Label 939: @74652
     /*  74652 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(74712), // Rule ID 8384 //
     /*  74657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74683 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  74686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74710 */     GIR_RootConstrainSelectedInstOperands,
     /*  74711 */     // GIR_Coverage, 8384,
     /*  74711 */     GIR_EraseRootFromParent_Done,
     /*  74712 */   // Label 940: @74712
     /*  74712 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(74772), // Rule ID 8390 //
     /*  74717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  74720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74743 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74770 */     GIR_RootConstrainSelectedInstOperands,
     /*  74771 */     // GIR_Coverage, 8390,
     /*  74771 */     GIR_EraseRootFromParent_Done,
     /*  74772 */   // Label 941: @74772
     /*  74772 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(74831), // Rule ID 8375 //
     /*  74777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  74780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  74807 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  74810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74829 */     GIR_RootConstrainSelectedInstOperands,
     /*  74830 */     // GIR_Coverage, 8375,
     /*  74830 */     GIR_EraseRootFromParent_Done,
     /*  74831 */   // Label 942: @74831
     /*  74831 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(74890), // Rule ID 8376 //
     /*  74836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  74839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  74866 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  74869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74888 */     GIR_RootConstrainSelectedInstOperands,
     /*  74889 */     // GIR_Coverage, 8376,
     /*  74889 */     GIR_EraseRootFromParent_Done,
     /*  74890 */   // Label 943: @74890
     /*  74890 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(74949), // Rule ID 8377 //
     /*  74895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  74898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74925 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  74925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  74928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74947 */     GIR_RootConstrainSelectedInstOperands,
     /*  74948 */     // GIR_Coverage, 8377,
     /*  74948 */     GIR_EraseRootFromParent_Done,
     /*  74949 */   // Label 944: @74949
     /*  74949 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(75011), // Rule ID 8378 //
     /*  74954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74984 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  74984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75009 */     GIR_RootConstrainSelectedInstOperands,
     /*  75010 */     // GIR_Coverage, 8378,
     /*  75010 */     GIR_EraseRootFromParent_Done,
     /*  75011 */   // Label 945: @75011
     /*  75011 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(75066), // Rule ID 8381 //
     /*  75016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  75019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  75042 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  75045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75064 */     GIR_RootConstrainSelectedInstOperands,
     /*  75065 */     // GIR_Coverage, 8381,
     /*  75065 */     GIR_EraseRootFromParent_Done,
     /*  75066 */   // Label 946: @75066
     /*  75066 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(75121), // Rule ID 8382 //
     /*  75071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  75074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75097 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  75097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  75100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75119 */     GIR_RootConstrainSelectedInstOperands,
     /*  75120 */     // GIR_Coverage, 8382,
     /*  75120 */     GIR_EraseRootFromParent_Done,
     /*  75121 */   // Label 947: @75121
     /*  75121 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(75179), // Rule ID 8383 //
     /*  75126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  75129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75152 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  75155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75177 */     GIR_RootConstrainSelectedInstOperands,
     /*  75178 */     // GIR_Coverage, 8383,
     /*  75178 */     GIR_EraseRootFromParent_Done,
     /*  75179 */   // Label 948: @75179
     /*  75179 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(75244), // Rule ID 8089 //
     /*  75184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  75187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75196 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  75213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75220 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  75223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75242 */     GIR_RootConstrainSelectedInstOperands,
     /*  75243 */     // GIR_Coverage, 8089,
     /*  75243 */     GIR_EraseRootFromParent_Done,
     /*  75244 */   // Label 949: @75244
     /*  75244 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(75304), // Rule ID 8021 //
     /*  75249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  75252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75256 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75261 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  75265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75280 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  75283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75302 */     GIR_RootConstrainSelectedInstOperands,
     /*  75303 */     // GIR_Coverage, 8021,
     /*  75303 */     GIR_EraseRootFromParent_Done,
     /*  75304 */   // Label 950: @75304
     /*  75304 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(75356), // Rule ID 8386 //
     /*  75309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  75332 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75354 */     GIR_RootConstrainSelectedInstOperands,
     /*  75355 */     // GIR_Coverage, 8386,
     /*  75355 */     GIR_EraseRootFromParent_Done,
     /*  75356 */   // Label 951: @75356
     /*  75356 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(75411), // Rule ID 8387 //
     /*  75361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  75364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  75387 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  75390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75409 */     GIR_RootConstrainSelectedInstOperands,
     /*  75410 */     // GIR_Coverage, 8387,
     /*  75410 */     GIR_EraseRootFromParent_Done,
     /*  75411 */   // Label 952: @75411
     /*  75411 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(75466), // Rule ID 8388 //
     /*  75416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  75419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75442 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  75442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  75445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75464 */     GIR_RootConstrainSelectedInstOperands,
     /*  75465 */     // GIR_Coverage, 8388,
     /*  75465 */     GIR_EraseRootFromParent_Done,
     /*  75466 */   // Label 953: @75466
     /*  75466 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(75524), // Rule ID 8389 //
     /*  75471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  75474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75497 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  75500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75522 */     GIR_RootConstrainSelectedInstOperands,
     /*  75523 */     // GIR_Coverage, 8389,
     /*  75523 */     GIR_EraseRootFromParent_Done,
     /*  75524 */   // Label 954: @75524
     /*  75524 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(75585), // Rule ID 8090 //
     /*  75529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  75532 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  75554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75561 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  75564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75583 */     GIR_RootConstrainSelectedInstOperands,
     /*  75584 */     // GIR_Coverage, 8090,
     /*  75584 */     GIR_EraseRootFromParent_Done,
     /*  75585 */   // Label 955: @75585
     /*  75585 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(75641), // Rule ID 8022 //
     /*  75590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  75593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75598 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  75602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75617 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  75620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75639 */     GIR_RootConstrainSelectedInstOperands,
     /*  75640 */     // GIR_Coverage, 8022,
     /*  75640 */     GIR_EraseRootFromParent_Done,
     /*  75641 */   // Label 956: @75641
     /*  75641 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(75692), // Rule ID 8380 //
     /*  75646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  75649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75657 */     // MIs[0] sbase
     /*  75657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  75673 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75678 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75690 */     GIR_RootConstrainSelectedInstOperands,
     /*  75691 */     // GIR_Coverage, 8380,
     /*  75691 */     GIR_EraseRootFromParent_Done,
     /*  75692 */   // Label 957: @75692
     /*  75692 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(75739), // Rule ID 8385 //
     /*  75697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  75700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75708 */     // MIs[0] sbase
     /*  75708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75720 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  75723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75725 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75737 */     GIR_RootConstrainSelectedInstOperands,
     /*  75738 */     // GIR_Coverage, 8385,
     /*  75738 */     GIR_EraseRootFromParent_Done,
     /*  75739 */   // Label 958: @75739
     /*  75739 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(75783), // Rule ID 8391 //
     /*  75744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75752 */     // MIs[0] sbase
     /*  75752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75764 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75769 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75781 */     GIR_RootConstrainSelectedInstOperands,
     /*  75782 */     // GIR_Coverage, 8391,
     /*  75782 */     GIR_EraseRootFromParent_Done,
     /*  75783 */   // Label 959: @75783
     /*  75783 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(75840), // Rule ID 4335 //
     /*  75788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  75791 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  75811 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  75814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  75821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  75826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  75831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75838 */     GIR_RootConstrainSelectedInstOperands,
     /*  75839 */     // GIR_Coverage, 4335,
     /*  75839 */     GIR_EraseRootFromParent_Done,
     /*  75840 */   // Label 960: @75840
     /*  75840 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(75892), // Rule ID 4334 //
     /*  75845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  75848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  75868 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  75868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  75871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  75878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75890 */     GIR_RootConstrainSelectedInstOperands,
     /*  75891 */     // GIR_Coverage, 4334,
     /*  75891 */     GIR_EraseRootFromParent_Done,
     /*  75892 */   // Label 961: @75892
     /*  75892 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(75944), // Rule ID 4333 //
     /*  75897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  75900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  75920 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  75920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  75923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  75930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75942 */     GIR_RootConstrainSelectedInstOperands,
     /*  75943 */     // GIR_Coverage, 4333,
     /*  75943 */     GIR_EraseRootFromParent_Done,
     /*  75944 */   // Label 962: @75944
     /*  75944 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(76011), // Rule ID 4555 //
     /*  75949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  75952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  75959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  75974 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  75974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  75977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  75979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  75984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  75989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  75994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  75999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76009 */     GIR_RootConstrainSelectedInstOperands,
     /*  76010 */     // GIR_Coverage, 4555,
     /*  76010 */     GIR_EraseRootFromParent_Done,
     /*  76011 */   // Label 963: @76011
     /*  76011 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(76075), // Rule ID 4557 //
     /*  76016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  76038 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  76038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  76041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  76043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  76048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  76053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  76058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  76063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76073 */     GIR_RootConstrainSelectedInstOperands,
     /*  76074 */     // GIR_Coverage, 4557,
     /*  76074 */     GIR_EraseRootFromParent_Done,
     /*  76075 */   // Label 964: @76075
     /*  76075 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(76136), // Rule ID 7965 //
     /*  76080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  76083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76087 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  76107 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  76107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  76110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  76117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  76122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  76127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76134 */     GIR_RootConstrainSelectedInstOperands,
     /*  76135 */     // GIR_Coverage, 7965,
     /*  76135 */     GIR_EraseRootFromParent_Done,
     /*  76136 */   // Label 965: @76136
     /*  76136 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(76198), // Rule ID 4554 //
     /*  76141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  76144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  76166 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  76166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  76169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  76171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  76176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76196 */     GIR_RootConstrainSelectedInstOperands,
     /*  76197 */     // GIR_Coverage, 4554,
     /*  76197 */     GIR_EraseRootFromParent_Done,
     /*  76198 */   // Label 966: @76198
     /*  76198 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(76257), // Rule ID 4556 //
     /*  76203 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  76225 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  76225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  76228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  76230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  76235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76255 */     GIR_RootConstrainSelectedInstOperands,
     /*  76256 */     // GIR_Coverage, 4556,
     /*  76256 */     GIR_EraseRootFromParent_Done,
     /*  76257 */   // Label 967: @76257
     /*  76257 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(76314), // Rule ID 7967 //
     /*  76262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  76265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  76285 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  76285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  76288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  76295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  76300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  76305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76312 */     GIR_RootConstrainSelectedInstOperands,
     /*  76313 */     // GIR_Coverage, 7967,
     /*  76313 */     GIR_EraseRootFromParent_Done,
     /*  76314 */   // Label 968: @76314
     /*  76314 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(76373), // Rule ID 3920 //
     /*  76319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  76322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  76344 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  76347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  76354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  76359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76371 */     GIR_RootConstrainSelectedInstOperands,
     /*  76372 */     // GIR_Coverage, 3920,
     /*  76372 */     GIR_EraseRootFromParent_Done,
     /*  76373 */   // Label 969: @76373
     /*  76373 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(76427), // Rule ID 3919 //
     /*  76378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  76381 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  76403 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  76403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  76406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  76413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76425 */     GIR_RootConstrainSelectedInstOperands,
     /*  76426 */     // GIR_Coverage, 3919,
     /*  76426 */     GIR_EraseRootFromParent_Done,
     /*  76427 */   // Label 970: @76427
     /*  76427 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(76482), // Rule ID 3643 //
     /*  76432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  76435 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  76458 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  76458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  76461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  76468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76480 */     GIR_RootConstrainSelectedInstOperands,
     /*  76481 */     // GIR_Coverage, 3643,
     /*  76481 */     GIR_EraseRootFromParent_Done,
     /*  76482 */   // Label 971: @76482
     /*  76482 */   GIM_Reject,
     /*  76483 */ // Label 938: @76483
     /*  76483 */ GIM_Reject,
     /*  76484 */ // Label 881: @76484
     /*  76484 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(78110),
     /*  76489 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76492 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(76556), // Rule ID 2978 //
     /*  76497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76527 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76554 */     GIR_RootConstrainSelectedInstOperands,
     /*  76555 */     // GIR_Coverage, 2978,
     /*  76555 */     GIR_EraseRootFromParent_Done,
     /*  76556 */   // Label 973: @76556
     /*  76556 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(76616), // Rule ID 2984 //
     /*  76561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  76564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76587 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76614 */     GIR_RootConstrainSelectedInstOperands,
     /*  76615 */     // GIR_Coverage, 2984,
     /*  76615 */     GIR_EraseRootFromParent_Done,
     /*  76616 */   // Label 974: @76616
     /*  76616 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(76675), // Rule ID 2974 //
     /*  76621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  76624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76651 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76673 */     GIR_RootConstrainSelectedInstOperands,
     /*  76674 */     // GIR_Coverage, 2974,
     /*  76674 */     GIR_EraseRootFromParent_Done,
     /*  76675 */   // Label 975: @76675
     /*  76675 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(76734), // Rule ID 2975 //
     /*  76680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  76683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76710 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  76713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76732 */     GIR_RootConstrainSelectedInstOperands,
     /*  76733 */     // GIR_Coverage, 2975,
     /*  76733 */     GIR_EraseRootFromParent_Done,
     /*  76734 */   // Label 976: @76734
     /*  76734 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(76793), // Rule ID 2976 //
     /*  76739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  76742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76769 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  76772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76791 */     GIR_RootConstrainSelectedInstOperands,
     /*  76792 */     // GIR_Coverage, 2976,
     /*  76792 */     GIR_EraseRootFromParent_Done,
     /*  76793 */   // Label 977: @76793
     /*  76793 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(76855), // Rule ID 2977 //
     /*  76798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76828 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76853 */     GIR_RootConstrainSelectedInstOperands,
     /*  76854 */     // GIR_Coverage, 2977,
     /*  76854 */     GIR_EraseRootFromParent_Done,
     /*  76855 */   // Label 978: @76855
     /*  76855 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(76907), // Rule ID 2980 //
     /*  76860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76883 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76905 */     GIR_RootConstrainSelectedInstOperands,
     /*  76906 */     // GIR_Coverage, 2980,
     /*  76906 */     GIR_EraseRootFromParent_Done,
     /*  76907 */   // Label 979: @76907
     /*  76907 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(76962), // Rule ID 2981 //
     /*  76912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  76915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76938 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  76941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76960 */     GIR_RootConstrainSelectedInstOperands,
     /*  76961 */     // GIR_Coverage, 2981,
     /*  76961 */     GIR_EraseRootFromParent_Done,
     /*  76962 */   // Label 980: @76962
     /*  76962 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(77017), // Rule ID 2982 //
     /*  76967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  76970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76993 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  76996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  77003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77015 */     GIR_RootConstrainSelectedInstOperands,
     /*  77016 */     // GIR_Coverage, 2982,
     /*  77016 */     GIR_EraseRootFromParent_Done,
     /*  77017 */   // Label 981: @77017
     /*  77017 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(77075), // Rule ID 2983 //
     /*  77022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  77025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  77033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  77048 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  77051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  77058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77073 */     GIR_RootConstrainSelectedInstOperands,
     /*  77074 */     // GIR_Coverage, 2983,
     /*  77074 */     GIR_EraseRootFromParent_Done,
     /*  77075 */   // Label 982: @77075
     /*  77075 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(77126), // Rule ID 2979 //
     /*  77080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  77083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  77091 */     // MIs[0] sbase
     /*  77091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  77095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  77099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  77107 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  77110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77112 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  77114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77124 */     GIR_RootConstrainSelectedInstOperands,
     /*  77125 */     // GIR_Coverage, 2979,
     /*  77125 */     GIR_EraseRootFromParent_Done,
     /*  77126 */   // Label 983: @77126
     /*  77126 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(77170), // Rule ID 2985 //
     /*  77131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  77139 */     // MIs[0] sbase
     /*  77139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  77143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  77147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77151 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  77154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77156 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  77158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77168 */     GIR_RootConstrainSelectedInstOperands,
     /*  77169 */     // GIR_Coverage, 2985,
     /*  77169 */     GIR_EraseRootFromParent_Done,
     /*  77170 */   // Label 984: @77170
     /*  77170 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(77230), // Rule ID 6495 //
     /*  77175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  77178 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  77198 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  77201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77228 */     GIR_RootConstrainSelectedInstOperands,
     /*  77229 */     // GIR_Coverage, 6495,
     /*  77229 */     GIR_EraseRootFromParent_Done,
     /*  77230 */   // Label 985: @77230
     /*  77230 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(77290), // Rule ID 6497 //
     /*  77235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  77238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  77258 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  77261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77288 */     GIR_RootConstrainSelectedInstOperands,
     /*  77289 */     // GIR_Coverage, 6497,
     /*  77289 */     GIR_EraseRootFromParent_Done,
     /*  77290 */   // Label 986: @77290
     /*  77290 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(77347), // Rule ID 4269 //
     /*  77295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  77298 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  77318 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  77321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  77333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77345 */     GIR_RootConstrainSelectedInstOperands,
     /*  77346 */     // GIR_Coverage, 4269,
     /*  77346 */     GIR_EraseRootFromParent_Done,
     /*  77347 */   // Label 987: @77347
     /*  77347 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(77399), // Rule ID 4268 //
     /*  77352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77355 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  77375 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  77375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  77378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77397 */     GIR_RootConstrainSelectedInstOperands,
     /*  77398 */     // GIR_Coverage, 4268,
     /*  77398 */     GIR_EraseRootFromParent_Done,
     /*  77399 */   // Label 988: @77399
     /*  77399 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(77451), // Rule ID 4267 //
     /*  77404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  77427 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  77430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77449 */     GIR_RootConstrainSelectedInstOperands,
     /*  77450 */     // GIR_Coverage, 4267,
     /*  77450 */     GIR_EraseRootFromParent_Done,
     /*  77451 */   // Label 989: @77451
     /*  77451 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(77518), // Rule ID 4511 //
     /*  77456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77459 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77481 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  77484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77516 */     GIR_RootConstrainSelectedInstOperands,
     /*  77517 */     // GIR_Coverage, 4511,
     /*  77517 */     GIR_EraseRootFromParent_Done,
     /*  77518 */   // Label 990: @77518
     /*  77518 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(77582), // Rule ID 4513 //
     /*  77523 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77545 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  77548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77580 */     GIR_RootConstrainSelectedInstOperands,
     /*  77581 */     // GIR_Coverage, 4513,
     /*  77581 */     GIR_EraseRootFromParent_Done,
     /*  77582 */   // Label 991: @77582
     /*  77582 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(77647), // Rule ID 6494 //
     /*  77587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  77590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  77610 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  77613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77645 */     GIR_RootConstrainSelectedInstOperands,
     /*  77646 */     // GIR_Coverage, 6494,
     /*  77646 */     GIR_EraseRootFromParent_Done,
     /*  77647 */   // Label 992: @77647
     /*  77647 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(77712), // Rule ID 6496 //
     /*  77652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  77655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  77675 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  77678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77710 */     GIR_RootConstrainSelectedInstOperands,
     /*  77711 */     // GIR_Coverage, 6496,
     /*  77711 */     GIR_EraseRootFromParent_Done,
     /*  77712 */   // Label 993: @77712
     /*  77712 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(77774), // Rule ID 4510 //
     /*  77717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77720 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77742 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  77745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77772 */     GIR_RootConstrainSelectedInstOperands,
     /*  77773 */     // GIR_Coverage, 4510,
     /*  77773 */     GIR_EraseRootFromParent_Done,
     /*  77774 */   // Label 994: @77774
     /*  77774 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(77833), // Rule ID 4512 //
     /*  77779 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77801 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  77804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77831 */     GIR_RootConstrainSelectedInstOperands,
     /*  77832 */     // GIR_Coverage, 4512,
     /*  77832 */     GIR_EraseRootFromParent_Done,
     /*  77833 */   // Label 995: @77833
     /*  77833 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(77889), // Rule ID 7835 //
     /*  77838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  77841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  77865 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  77865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  77868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77887 */     GIR_RootConstrainSelectedInstOperands,
     /*  77888 */     // GIR_Coverage, 7835,
     /*  77888 */     GIR_EraseRootFromParent_Done,
     /*  77889 */   // Label 996: @77889
     /*  77889 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(77941), // Rule ID 7836 //
     /*  77894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  77897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  77917 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  77917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  77920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77939 */     GIR_RootConstrainSelectedInstOperands,
     /*  77940 */     // GIR_Coverage, 7836,
     /*  77940 */     GIR_EraseRootFromParent_Done,
     /*  77941 */   // Label 997: @77941
     /*  77941 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(78000), // Rule ID 3876 //
     /*  77946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  77949 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  77971 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  77974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  77986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77998 */     GIR_RootConstrainSelectedInstOperands,
     /*  77999 */     // GIR_Coverage, 3876,
     /*  77999 */     GIR_EraseRootFromParent_Done,
     /*  78000 */   // Label 998: @78000
     /*  78000 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(78054), // Rule ID 3875 //
     /*  78005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  78008 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  78015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  78030 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  78030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  78033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  78040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78052 */     GIR_RootConstrainSelectedInstOperands,
     /*  78053 */     // GIR_Coverage, 3875,
     /*  78053 */     GIR_EraseRootFromParent_Done,
     /*  78054 */   // Label 999: @78054
     /*  78054 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(78109), // Rule ID 3620 //
     /*  78059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  78062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  78070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  78085 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  78085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  78088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  78095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78107 */     GIR_RootConstrainSelectedInstOperands,
     /*  78108 */     // GIR_Coverage, 3620,
     /*  78108 */     GIR_EraseRootFromParent_Done,
     /*  78109 */   // Label 1000: @78109
     /*  78109 */   GIM_Reject,
     /*  78110 */ // Label 972: @78110
     /*  78110 */ GIM_Reject,
     /*  78111 */ // Label 882: @78111
     /*  78111 */ GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(79737),
     /*  78116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78119 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(78183), // Rule ID 2990 //
     /*  78124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  78127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  78154 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78181 */     GIR_RootConstrainSelectedInstOperands,
     /*  78182 */     // GIR_Coverage, 2990,
     /*  78182 */     GIR_EraseRootFromParent_Done,
     /*  78183 */   // Label 1002: @78183
     /*  78183 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(78243), // Rule ID 2996 //
     /*  78188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  78191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  78214 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78241 */     GIR_RootConstrainSelectedInstOperands,
     /*  78242 */     // GIR_Coverage, 2996,
     /*  78242 */     GIR_EraseRootFromParent_Done,
     /*  78243 */   // Label 1003: @78243
     /*  78243 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(78302), // Rule ID 2986 //
     /*  78248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78278 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78300 */     GIR_RootConstrainSelectedInstOperands,
     /*  78301 */     // GIR_Coverage, 2986,
     /*  78301 */     GIR_EraseRootFromParent_Done,
     /*  78302 */   // Label 1004: @78302
     /*  78302 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(78361), // Rule ID 2987 //
     /*  78307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  78310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78337 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  78340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78359 */     GIR_RootConstrainSelectedInstOperands,
     /*  78360 */     // GIR_Coverage, 2987,
     /*  78360 */     GIR_EraseRootFromParent_Done,
     /*  78361 */   // Label 1005: @78361
     /*  78361 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(78420), // Rule ID 2988 //
     /*  78366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  78369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78396 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  78399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78418 */     GIR_RootConstrainSelectedInstOperands,
     /*  78419 */     // GIR_Coverage, 2988,
     /*  78419 */     GIR_EraseRootFromParent_Done,
     /*  78420 */   // Label 1006: @78420
     /*  78420 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(78482), // Rule ID 2989 //
     /*  78425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  78428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78455 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78480 */     GIR_RootConstrainSelectedInstOperands,
     /*  78481 */     // GIR_Coverage, 2989,
     /*  78481 */     GIR_EraseRootFromParent_Done,
     /*  78482 */   // Label 1007: @78482
     /*  78482 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(78534), // Rule ID 2992 //
     /*  78487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78510 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78532 */     GIR_RootConstrainSelectedInstOperands,
     /*  78533 */     // GIR_Coverage, 2992,
     /*  78533 */     GIR_EraseRootFromParent_Done,
     /*  78534 */   // Label 1008: @78534
     /*  78534 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(78589), // Rule ID 2993 //
     /*  78539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  78542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78565 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  78568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78587 */     GIR_RootConstrainSelectedInstOperands,
     /*  78588 */     // GIR_Coverage, 2993,
     /*  78588 */     GIR_EraseRootFromParent_Done,
     /*  78589 */   // Label 1009: @78589
     /*  78589 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(78644), // Rule ID 2994 //
     /*  78594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  78597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78620 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  78623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78642 */     GIR_RootConstrainSelectedInstOperands,
     /*  78643 */     // GIR_Coverage, 2994,
     /*  78643 */     GIR_EraseRootFromParent_Done,
     /*  78644 */   // Label 1010: @78644
     /*  78644 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(78702), // Rule ID 2995 //
     /*  78649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  78652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78675 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78700 */     GIR_RootConstrainSelectedInstOperands,
     /*  78701 */     // GIR_Coverage, 2995,
     /*  78701 */     GIR_EraseRootFromParent_Done,
     /*  78702 */   // Label 1011: @78702
     /*  78702 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(78753), // Rule ID 2991 //
     /*  78707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78718 */     // MIs[0] sbase
     /*  78718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  78722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  78726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78734 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78739 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  78741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78751 */     GIR_RootConstrainSelectedInstOperands,
     /*  78752 */     // GIR_Coverage, 2991,
     /*  78752 */     GIR_EraseRootFromParent_Done,
     /*  78753 */   // Label 1012: @78753
     /*  78753 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(78797), // Rule ID 2997 //
     /*  78758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78766 */     // MIs[0] sbase
     /*  78766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  78770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  78774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78778 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78783 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  78785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78795 */     GIR_RootConstrainSelectedInstOperands,
     /*  78796 */     // GIR_Coverage, 2997,
     /*  78796 */     GIR_EraseRootFromParent_Done,
     /*  78797 */   // Label 1013: @78797
     /*  78797 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(78857), // Rule ID 6499 //
     /*  78802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  78805 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  78825 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  78825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  78828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78855 */     GIR_RootConstrainSelectedInstOperands,
     /*  78856 */     // GIR_Coverage, 6499,
     /*  78856 */     GIR_EraseRootFromParent_Done,
     /*  78857 */   // Label 1014: @78857
     /*  78857 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(78917), // Rule ID 6501 //
     /*  78862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  78865 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  78885 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  78885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  78888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78915 */     GIR_RootConstrainSelectedInstOperands,
     /*  78916 */     // GIR_Coverage, 6501,
     /*  78916 */     GIR_EraseRootFromParent_Done,
     /*  78917 */   // Label 1015: @78917
     /*  78917 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(78974), // Rule ID 4275 //
     /*  78922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  78925 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  78945 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  78948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  78955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  78960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78972 */     GIR_RootConstrainSelectedInstOperands,
     /*  78973 */     // GIR_Coverage, 4275,
     /*  78973 */     GIR_EraseRootFromParent_Done,
     /*  78974 */   // Label 1016: @78974
     /*  78974 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(79026), // Rule ID 4274 //
     /*  78979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  78982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  79002 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  79002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  79005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  79012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79024 */     GIR_RootConstrainSelectedInstOperands,
     /*  79025 */     // GIR_Coverage, 4274,
     /*  79025 */     GIR_EraseRootFromParent_Done,
     /*  79026 */   // Label 1017: @79026
     /*  79026 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(79078), // Rule ID 4273 //
     /*  79031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  79034 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  79054 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  79057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79076 */     GIR_RootConstrainSelectedInstOperands,
     /*  79077 */     // GIR_Coverage, 4273,
     /*  79077 */     GIR_EraseRootFromParent_Done,
     /*  79078 */   // Label 1018: @79078
     /*  79078 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(79145), // Rule ID 4515 //
     /*  79083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  79086 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  79108 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  79111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79143 */     GIR_RootConstrainSelectedInstOperands,
     /*  79144 */     // GIR_Coverage, 4515,
     /*  79144 */     GIR_EraseRootFromParent_Done,
     /*  79145 */   // Label 1019: @79145
     /*  79145 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(79209), // Rule ID 4517 //
     /*  79150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  79172 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  79175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79207 */     GIR_RootConstrainSelectedInstOperands,
     /*  79208 */     // GIR_Coverage, 4517,
     /*  79208 */     GIR_EraseRootFromParent_Done,
     /*  79209 */   // Label 1020: @79209
     /*  79209 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(79274), // Rule ID 6498 //
     /*  79214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  79217 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  79237 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  79237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  79240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79272 */     GIR_RootConstrainSelectedInstOperands,
     /*  79273 */     // GIR_Coverage, 6498,
     /*  79273 */     GIR_EraseRootFromParent_Done,
     /*  79274 */   // Label 1021: @79274
     /*  79274 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(79339), // Rule ID 6500 //
     /*  79279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  79282 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  79302 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  79302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  79305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79337 */     GIR_RootConstrainSelectedInstOperands,
     /*  79338 */     // GIR_Coverage, 6500,
     /*  79338 */     GIR_EraseRootFromParent_Done,
     /*  79339 */   // Label 1022: @79339
     /*  79339 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(79401), // Rule ID 4514 //
     /*  79344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  79347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79369 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  79372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79399 */     GIR_RootConstrainSelectedInstOperands,
     /*  79400 */     // GIR_Coverage, 4514,
     /*  79400 */     GIR_EraseRootFromParent_Done,
     /*  79401 */   // Label 1023: @79401
     /*  79401 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(79460), // Rule ID 4516 //
     /*  79406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79428 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  79431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79458 */     GIR_RootConstrainSelectedInstOperands,
     /*  79459 */     // GIR_Coverage, 4516,
     /*  79459 */     GIR_EraseRootFromParent_Done,
     /*  79460 */   // Label 1024: @79460
     /*  79460 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(79516), // Rule ID 7837 //
     /*  79465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  79468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79472 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  79492 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  79492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  79495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79514 */     GIR_RootConstrainSelectedInstOperands,
     /*  79515 */     // GIR_Coverage, 7837,
     /*  79515 */     GIR_EraseRootFromParent_Done,
     /*  79516 */   // Label 1025: @79516
     /*  79516 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(79568), // Rule ID 7838 //
     /*  79521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  79524 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  79544 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  79544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  79547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79566 */     GIR_RootConstrainSelectedInstOperands,
     /*  79567 */     // GIR_Coverage, 7838,
     /*  79567 */     GIR_EraseRootFromParent_Done,
     /*  79568 */   // Label 1026: @79568
     /*  79568 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(79627), // Rule ID 3880 //
     /*  79573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79576 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  79598 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  79601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  79608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  79613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79625 */     GIR_RootConstrainSelectedInstOperands,
     /*  79626 */     // GIR_Coverage, 3880,
     /*  79626 */     GIR_EraseRootFromParent_Done,
     /*  79627 */   // Label 1027: @79627
     /*  79627 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(79681), // Rule ID 3879 //
     /*  79632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79635 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  79657 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  79660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79679 */     GIR_RootConstrainSelectedInstOperands,
     /*  79680 */     // GIR_Coverage, 3879,
     /*  79680 */     GIR_EraseRootFromParent_Done,
     /*  79681 */   // Label 1028: @79681
     /*  79681 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(79736), // Rule ID 3622 //
     /*  79686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  79689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  79712 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  79715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79734 */     GIR_RootConstrainSelectedInstOperands,
     /*  79735 */     // GIR_Coverage, 3622,
     /*  79735 */     GIR_EraseRootFromParent_Done,
     /*  79736 */   // Label 1029: @79736
     /*  79736 */   GIM_Reject,
     /*  79737 */ // Label 1001: @79737
     /*  79737 */ GIM_Reject,
     /*  79738 */ // Label 883: @79738
     /*  79738 */ GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(81641),
     /*  79743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79746 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(79810), // Rule ID 8396 //
     /*  79751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79781 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  79784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79808 */     GIR_RootConstrainSelectedInstOperands,
     /*  79809 */     // GIR_Coverage, 8396,
     /*  79809 */     GIR_EraseRootFromParent_Done,
     /*  79810 */   // Label 1031: @79810
     /*  79810 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(79870), // Rule ID 8401 //
     /*  79815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79841 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  79844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79868 */     GIR_RootConstrainSelectedInstOperands,
     /*  79869 */     // GIR_Coverage, 8401,
     /*  79869 */     GIR_EraseRootFromParent_Done,
     /*  79870 */   // Label 1032: @79870
     /*  79870 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(79930), // Rule ID 8407 //
     /*  79875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  79878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79901 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  79904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79928 */     GIR_RootConstrainSelectedInstOperands,
     /*  79929 */     // GIR_Coverage, 8407,
     /*  79929 */     GIR_EraseRootFromParent_Done,
     /*  79930 */   // Label 1033: @79930
     /*  79930 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(79989), // Rule ID 8392 //
     /*  79935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  79938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  79965 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  79968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79987 */     GIR_RootConstrainSelectedInstOperands,
     /*  79988 */     // GIR_Coverage, 8392,
     /*  79988 */     GIR_EraseRootFromParent_Done,
     /*  79989 */   // Label 1034: @79989
     /*  79989 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(80048), // Rule ID 8393 //
     /*  79994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  79997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  80024 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  80027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80046 */     GIR_RootConstrainSelectedInstOperands,
     /*  80047 */     // GIR_Coverage, 8393,
     /*  80047 */     GIR_EraseRootFromParent_Done,
     /*  80048 */   // Label 1035: @80048
     /*  80048 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(80107), // Rule ID 8394 //
     /*  80053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  80056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80083 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  80086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80105 */     GIR_RootConstrainSelectedInstOperands,
     /*  80106 */     // GIR_Coverage, 8394,
     /*  80106 */     GIR_EraseRootFromParent_Done,
     /*  80107 */   // Label 1036: @80107
     /*  80107 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(80169), // Rule ID 8395 //
     /*  80112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  80115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80142 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  80145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80167 */     GIR_RootConstrainSelectedInstOperands,
     /*  80168 */     // GIR_Coverage, 8395,
     /*  80168 */     GIR_EraseRootFromParent_Done,
     /*  80169 */   // Label 1037: @80169
     /*  80169 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(80224), // Rule ID 8398 //
     /*  80174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  80200 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  80203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80222 */     GIR_RootConstrainSelectedInstOperands,
     /*  80223 */     // GIR_Coverage, 8398,
     /*  80223 */     GIR_EraseRootFromParent_Done,
     /*  80224 */   // Label 1038: @80224
     /*  80224 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(80279), // Rule ID 8399 //
     /*  80229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  80232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80255 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  80258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80277 */     GIR_RootConstrainSelectedInstOperands,
     /*  80278 */     // GIR_Coverage, 8399,
     /*  80278 */     GIR_EraseRootFromParent_Done,
     /*  80279 */   // Label 1039: @80279
     /*  80279 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(80337), // Rule ID 8400 //
     /*  80284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  80287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80310 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  80313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80335 */     GIR_RootConstrainSelectedInstOperands,
     /*  80336 */     // GIR_Coverage, 8400,
     /*  80336 */     GIR_EraseRootFromParent_Done,
     /*  80337 */   // Label 1040: @80337
     /*  80337 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(80402), // Rule ID 8093 //
     /*  80342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  80345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80349 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80354 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  80371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80378 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  80381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80400 */     GIR_RootConstrainSelectedInstOperands,
     /*  80401 */     // GIR_Coverage, 8093,
     /*  80401 */     GIR_EraseRootFromParent_Done,
     /*  80402 */   // Label 1041: @80402
     /*  80402 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(80462), // Rule ID 8025 //
     /*  80407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  80410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80414 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80419 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  80423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80438 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  80441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80460 */     GIR_RootConstrainSelectedInstOperands,
     /*  80461 */     // GIR_Coverage, 8025,
     /*  80461 */     GIR_EraseRootFromParent_Done,
     /*  80462 */   // Label 1042: @80462
     /*  80462 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(80514), // Rule ID 8403 //
     /*  80467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  80490 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80512 */     GIR_RootConstrainSelectedInstOperands,
     /*  80513 */     // GIR_Coverage, 8403,
     /*  80513 */     GIR_EraseRootFromParent_Done,
     /*  80514 */   // Label 1043: @80514
     /*  80514 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(80569), // Rule ID 8404 //
     /*  80519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  80522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  80545 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  80548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80567 */     GIR_RootConstrainSelectedInstOperands,
     /*  80568 */     // GIR_Coverage, 8404,
     /*  80568 */     GIR_EraseRootFromParent_Done,
     /*  80569 */   // Label 1044: @80569
     /*  80569 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(80624), // Rule ID 8405 //
     /*  80574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  80577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80600 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  80603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80622 */     GIR_RootConstrainSelectedInstOperands,
     /*  80623 */     // GIR_Coverage, 8405,
     /*  80623 */     GIR_EraseRootFromParent_Done,
     /*  80624 */   // Label 1045: @80624
     /*  80624 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(80682), // Rule ID 8406 //
     /*  80629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  80632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80655 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  80658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80680 */     GIR_RootConstrainSelectedInstOperands,
     /*  80681 */     // GIR_Coverage, 8406,
     /*  80681 */     GIR_EraseRootFromParent_Done,
     /*  80682 */   // Label 1046: @80682
     /*  80682 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(80743), // Rule ID 8094 //
     /*  80687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  80690 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  80712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80719 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  80722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80741 */     GIR_RootConstrainSelectedInstOperands,
     /*  80742 */     // GIR_Coverage, 8094,
     /*  80742 */     GIR_EraseRootFromParent_Done,
     /*  80743 */   // Label 1047: @80743
     /*  80743 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(80799), // Rule ID 8026 //
     /*  80748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  80751 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80756 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  80760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80775 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  80778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80797 */     GIR_RootConstrainSelectedInstOperands,
     /*  80798 */     // GIR_Coverage, 8026,
     /*  80798 */     GIR_EraseRootFromParent_Done,
     /*  80799 */   // Label 1048: @80799
     /*  80799 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(80850), // Rule ID 8397 //
     /*  80804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80815 */     // MIs[0] sbase
     /*  80815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80831 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80836 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80848 */     GIR_RootConstrainSelectedInstOperands,
     /*  80849 */     // GIR_Coverage, 8397,
     /*  80849 */     GIR_EraseRootFromParent_Done,
     /*  80850 */   // Label 1049: @80850
     /*  80850 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(80897), // Rule ID 8402 //
     /*  80855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80866 */     // MIs[0] sbase
     /*  80866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80878 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  80881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80883 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80895 */     GIR_RootConstrainSelectedInstOperands,
     /*  80896 */     // GIR_Coverage, 8402,
     /*  80896 */     GIR_EraseRootFromParent_Done,
     /*  80897 */   // Label 1050: @80897
     /*  80897 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(80941), // Rule ID 8408 //
     /*  80902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80910 */     // MIs[0] sbase
     /*  80910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80922 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80927 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80939 */     GIR_RootConstrainSelectedInstOperands,
     /*  80940 */     // GIR_Coverage, 8408,
     /*  80940 */     GIR_EraseRootFromParent_Done,
     /*  80941 */   // Label 1051: @80941
     /*  80941 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(80998), // Rule ID 4341 //
     /*  80946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  80949 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  80969 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  80972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  80979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  80984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  80989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80996 */     GIR_RootConstrainSelectedInstOperands,
     /*  80997 */     // GIR_Coverage, 4341,
     /*  80997 */     GIR_EraseRootFromParent_Done,
     /*  80998 */   // Label 1052: @80998
     /*  80998 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(81050), // Rule ID 4340 //
     /*  81003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  81006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  81011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  81026 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  81026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  81029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  81036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81048 */     GIR_RootConstrainSelectedInstOperands,
     /*  81049 */     // GIR_Coverage, 4340,
     /*  81049 */     GIR_EraseRootFromParent_Done,
     /*  81050 */   // Label 1053: @81050
     /*  81050 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(81102), // Rule ID 4339 //
     /*  81055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  81058 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  81063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  81078 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  81081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81100 */     GIR_RootConstrainSelectedInstOperands,
     /*  81101 */     // GIR_Coverage, 4339,
     /*  81101 */     GIR_EraseRootFromParent_Done,
     /*  81102 */   // Label 1054: @81102
     /*  81102 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(81169), // Rule ID 4559 //
     /*  81107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  81110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  81132 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  81135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  81142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  81152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  81157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81167 */     GIR_RootConstrainSelectedInstOperands,
     /*  81168 */     // GIR_Coverage, 4559,
     /*  81168 */     GIR_EraseRootFromParent_Done,
     /*  81169 */   // Label 1055: @81169
     /*  81169 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(81233), // Rule ID 4561 //
     /*  81174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  81196 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  81199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  81206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  81216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  81221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81231 */     GIR_RootConstrainSelectedInstOperands,
     /*  81232 */     // GIR_Coverage, 4561,
     /*  81232 */     GIR_EraseRootFromParent_Done,
     /*  81233 */   // Label 1056: @81233
     /*  81233 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(81294), // Rule ID 7969 //
     /*  81238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  81241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  81265 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  81265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  81268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  81280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  81285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81292 */     GIR_RootConstrainSelectedInstOperands,
     /*  81293 */     // GIR_Coverage, 7969,
     /*  81293 */     GIR_EraseRootFromParent_Done,
     /*  81294 */   // Label 1057: @81294
     /*  81294 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(81356), // Rule ID 4558 //
     /*  81299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  81302 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81324 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  81327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81354 */     GIR_RootConstrainSelectedInstOperands,
     /*  81355 */     // GIR_Coverage, 4558,
     /*  81355 */     GIR_EraseRootFromParent_Done,
     /*  81356 */   // Label 1058: @81356
     /*  81356 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(81415), // Rule ID 4560 //
     /*  81361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81383 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  81386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81413 */     GIR_RootConstrainSelectedInstOperands,
     /*  81414 */     // GIR_Coverage, 4560,
     /*  81414 */     GIR_EraseRootFromParent_Done,
     /*  81415 */   // Label 1059: @81415
     /*  81415 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(81472), // Rule ID 7971 //
     /*  81420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  81423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  81443 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  81443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  81446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  81458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  81463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81470 */     GIR_RootConstrainSelectedInstOperands,
     /*  81471 */     // GIR_Coverage, 7971,
     /*  81471 */     GIR_EraseRootFromParent_Done,
     /*  81472 */   // Label 1060: @81472
     /*  81472 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(81531), // Rule ID 3924 //
     /*  81477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  81502 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  81505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  81512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  81517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81529 */     GIR_RootConstrainSelectedInstOperands,
     /*  81530 */     // GIR_Coverage, 3924,
     /*  81530 */     GIR_EraseRootFromParent_Done,
     /*  81531 */   // Label 1061: @81531
     /*  81531 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(81585), // Rule ID 3923 //
     /*  81536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81539 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  81561 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  81564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81583 */     GIR_RootConstrainSelectedInstOperands,
     /*  81584 */     // GIR_Coverage, 3923,
     /*  81584 */     GIR_EraseRootFromParent_Done,
     /*  81585 */   // Label 1062: @81585
     /*  81585 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(81640), // Rule ID 3645 //
     /*  81590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  81593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  81616 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  81619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81638 */     GIR_RootConstrainSelectedInstOperands,
     /*  81639 */     // GIR_Coverage, 3645,
     /*  81639 */     GIR_EraseRootFromParent_Done,
     /*  81640 */   // Label 1063: @81640
     /*  81640 */   GIM_Reject,
     /*  81641 */ // Label 1030: @81641
     /*  81641 */ GIM_Reject,
     /*  81642 */ // Label 884: @81642
     /*  81642 */ GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(83268),
     /*  81647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81650 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(81714), // Rule ID 3002 //
     /*  81655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81685 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81712 */     GIR_RootConstrainSelectedInstOperands,
     /*  81713 */     // GIR_Coverage, 3002,
     /*  81713 */     GIR_EraseRootFromParent_Done,
     /*  81714 */   // Label 1065: @81714
     /*  81714 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(81774), // Rule ID 3008 //
     /*  81719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  81722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81745 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81772 */     GIR_RootConstrainSelectedInstOperands,
     /*  81773 */     // GIR_Coverage, 3008,
     /*  81773 */     GIR_EraseRootFromParent_Done,
     /*  81774 */   // Label 1066: @81774
     /*  81774 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(81833), // Rule ID 2998 //
     /*  81779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  81782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  81809 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  81812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81831 */     GIR_RootConstrainSelectedInstOperands,
     /*  81832 */     // GIR_Coverage, 2998,
     /*  81832 */     GIR_EraseRootFromParent_Done,
     /*  81833 */   // Label 1067: @81833
     /*  81833 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(81892), // Rule ID 2999 //
     /*  81838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  81841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  81868 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  81871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81890 */     GIR_RootConstrainSelectedInstOperands,
     /*  81891 */     // GIR_Coverage, 2999,
     /*  81891 */     GIR_EraseRootFromParent_Done,
     /*  81892 */   // Label 1068: @81892
     /*  81892 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(81951), // Rule ID 3000 //
     /*  81897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  81900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81927 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  81927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  81930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81949 */     GIR_RootConstrainSelectedInstOperands,
     /*  81950 */     // GIR_Coverage, 3000,
     /*  81950 */     GIR_EraseRootFromParent_Done,
     /*  81951 */   // Label 1069: @81951
     /*  81951 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(82013), // Rule ID 3001 //
     /*  81956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81986 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  81986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82011 */     GIR_RootConstrainSelectedInstOperands,
     /*  82012 */     // GIR_Coverage, 3001,
     /*  82012 */     GIR_EraseRootFromParent_Done,
     /*  82013 */   // Label 1070: @82013
     /*  82013 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(82065), // Rule ID 3004 //
     /*  82018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  82041 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  82051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82063 */     GIR_RootConstrainSelectedInstOperands,
     /*  82064 */     // GIR_Coverage, 3004,
     /*  82064 */     GIR_EraseRootFromParent_Done,
     /*  82065 */   // Label 1071: @82065
     /*  82065 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(82120), // Rule ID 3005 //
     /*  82070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  82073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  82096 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  82099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  82106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82118 */     GIR_RootConstrainSelectedInstOperands,
     /*  82119 */     // GIR_Coverage, 3005,
     /*  82119 */     GIR_EraseRootFromParent_Done,
     /*  82120 */   // Label 1072: @82120
     /*  82120 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(82175), // Rule ID 3006 //
     /*  82125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  82128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  82151 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  82151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  82154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  82161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82173 */     GIR_RootConstrainSelectedInstOperands,
     /*  82174 */     // GIR_Coverage, 3006,
     /*  82174 */     GIR_EraseRootFromParent_Done,
     /*  82175 */   // Label 1073: @82175
     /*  82175 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(82233), // Rule ID 3007 //
     /*  82180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  82183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  82206 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  82209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  82216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82231 */     GIR_RootConstrainSelectedInstOperands,
     /*  82232 */     // GIR_Coverage, 3007,
     /*  82232 */     GIR_EraseRootFromParent_Done,
     /*  82233 */   // Label 1074: @82233
     /*  82233 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(82284), // Rule ID 3003 //
     /*  82238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  82241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82249 */     // MIs[0] sbase
     /*  82249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  82265 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82270 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82282 */     GIR_RootConstrainSelectedInstOperands,
     /*  82283 */     // GIR_Coverage, 3003,
     /*  82283 */     GIR_EraseRootFromParent_Done,
     /*  82284 */   // Label 1075: @82284
     /*  82284 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(82328), // Rule ID 3009 //
     /*  82289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82297 */     // MIs[0] sbase
     /*  82297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82309 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82314 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82326 */     GIR_RootConstrainSelectedInstOperands,
     /*  82327 */     // GIR_Coverage, 3009,
     /*  82327 */     GIR_EraseRootFromParent_Done,
     /*  82328 */   // Label 1076: @82328
     /*  82328 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(82388), // Rule ID 6503 //
     /*  82333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82356 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82386 */     GIR_RootConstrainSelectedInstOperands,
     /*  82387 */     // GIR_Coverage, 6503,
     /*  82387 */     GIR_EraseRootFromParent_Done,
     /*  82388 */   // Label 1077: @82388
     /*  82388 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(82448), // Rule ID 6505 //
     /*  82393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82396 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82416 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82446 */     GIR_RootConstrainSelectedInstOperands,
     /*  82447 */     // GIR_Coverage, 6505,
     /*  82447 */     GIR_EraseRootFromParent_Done,
     /*  82448 */   // Label 1078: @82448
     /*  82448 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(82505), // Rule ID 4281 //
     /*  82453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  82456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  82476 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  82479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  82491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82503 */     GIR_RootConstrainSelectedInstOperands,
     /*  82504 */     // GIR_Coverage, 4281,
     /*  82504 */     GIR_EraseRootFromParent_Done,
     /*  82505 */   // Label 1079: @82505
     /*  82505 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(82557), // Rule ID 4280 //
     /*  82510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82513 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  82533 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  82533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  82536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  82543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82555 */     GIR_RootConstrainSelectedInstOperands,
     /*  82556 */     // GIR_Coverage, 4280,
     /*  82556 */     GIR_EraseRootFromParent_Done,
     /*  82557 */   // Label 1080: @82557
     /*  82557 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(82609), // Rule ID 4279 //
     /*  82562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82565 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  82585 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  82585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  82588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82607 */     GIR_RootConstrainSelectedInstOperands,
     /*  82608 */     // GIR_Coverage, 4279,
     /*  82608 */     GIR_EraseRootFromParent_Done,
     /*  82609 */   // Label 1081: @82609
     /*  82609 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(82676), // Rule ID 4519 //
     /*  82614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82639 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  82642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82674 */     GIR_RootConstrainSelectedInstOperands,
     /*  82675 */     // GIR_Coverage, 4519,
     /*  82675 */     GIR_EraseRootFromParent_Done,
     /*  82676 */   // Label 1082: @82676
     /*  82676 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(82740), // Rule ID 4521 //
     /*  82681 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82703 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  82706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82738 */     GIR_RootConstrainSelectedInstOperands,
     /*  82739 */     // GIR_Coverage, 4521,
     /*  82739 */     GIR_EraseRootFromParent_Done,
     /*  82740 */   // Label 1083: @82740
     /*  82740 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(82805), // Rule ID 6502 //
     /*  82745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82748 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82768 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  82771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82803 */     GIR_RootConstrainSelectedInstOperands,
     /*  82804 */     // GIR_Coverage, 6502,
     /*  82804 */     GIR_EraseRootFromParent_Done,
     /*  82805 */   // Label 1084: @82805
     /*  82805 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(82870), // Rule ID 6504 //
     /*  82810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82833 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  82836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82868 */     GIR_RootConstrainSelectedInstOperands,
     /*  82869 */     // GIR_Coverage, 6504,
     /*  82869 */     GIR_EraseRootFromParent_Done,
     /*  82870 */   // Label 1085: @82870
     /*  82870 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(82932), // Rule ID 4518 //
     /*  82875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82878 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82900 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82930 */     GIR_RootConstrainSelectedInstOperands,
     /*  82931 */     // GIR_Coverage, 4518,
     /*  82931 */     GIR_EraseRootFromParent_Done,
     /*  82932 */   // Label 1086: @82932
     /*  82932 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(82991), // Rule ID 4520 //
     /*  82937 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82959 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82989 */     GIR_RootConstrainSelectedInstOperands,
     /*  82990 */     // GIR_Coverage, 4520,
     /*  82990 */     GIR_EraseRootFromParent_Done,
     /*  82991 */   // Label 1087: @82991
     /*  82991 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(83047), // Rule ID 7839 //
     /*  82996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  82999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  83008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  83023 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  83023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  83026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  83033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83045 */     GIR_RootConstrainSelectedInstOperands,
     /*  83046 */     // GIR_Coverage, 7839,
     /*  83046 */     GIR_EraseRootFromParent_Done,
     /*  83047 */   // Label 1088: @83047
     /*  83047 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(83099), // Rule ID 7840 //
     /*  83052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  83055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  83060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  83075 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  83075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  83078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  83085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83097 */     GIR_RootConstrainSelectedInstOperands,
     /*  83098 */     // GIR_Coverage, 7840,
     /*  83098 */     GIR_EraseRootFromParent_Done,
     /*  83099 */   // Label 1089: @83099
     /*  83099 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(83158), // Rule ID 3884 //
     /*  83104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  83107 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  83114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  83129 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  83132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  83139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  83144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83156 */     GIR_RootConstrainSelectedInstOperands,
     /*  83157 */     // GIR_Coverage, 3884,
     /*  83157 */     GIR_EraseRootFromParent_Done,
     /*  83158 */   // Label 1090: @83158
     /*  83158 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(83212), // Rule ID 3883 //
     /*  83163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  83166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  83173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  83188 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  83188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  83191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83210 */     GIR_RootConstrainSelectedInstOperands,
     /*  83211 */     // GIR_Coverage, 3883,
     /*  83211 */     GIR_EraseRootFromParent_Done,
     /*  83212 */   // Label 1091: @83212
     /*  83212 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(83267), // Rule ID 3624 //
     /*  83217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  83220 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  83228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  83243 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  83243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  83246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83265 */     GIR_RootConstrainSelectedInstOperands,
     /*  83266 */     // GIR_Coverage, 3624,
     /*  83266 */     GIR_EraseRootFromParent_Done,
     /*  83267 */   // Label 1092: @83267
     /*  83267 */   GIM_Reject,
     /*  83268 */ // Label 1064: @83268
     /*  83268 */ GIM_Reject,
     /*  83269 */ // Label 885: @83269
     /*  83269 */ GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(84895),
     /*  83274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83277 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(83341), // Rule ID 3014 //
     /*  83282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83312 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83339 */     GIR_RootConstrainSelectedInstOperands,
     /*  83340 */     // GIR_Coverage, 3014,
     /*  83340 */     GIR_EraseRootFromParent_Done,
     /*  83341 */   // Label 1094: @83341
     /*  83341 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(83401), // Rule ID 3020 //
     /*  83346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83372 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83399 */     GIR_RootConstrainSelectedInstOperands,
     /*  83400 */     // GIR_Coverage, 3020,
     /*  83400 */     GIR_EraseRootFromParent_Done,
     /*  83401 */   // Label 1095: @83401
     /*  83401 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(83460), // Rule ID 3010 //
     /*  83406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83436 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83458 */     GIR_RootConstrainSelectedInstOperands,
     /*  83459 */     // GIR_Coverage, 3010,
     /*  83459 */     GIR_EraseRootFromParent_Done,
     /*  83460 */   // Label 1096: @83460
     /*  83460 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(83519), // Rule ID 3011 //
     /*  83465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  83468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83495 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  83498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83517 */     GIR_RootConstrainSelectedInstOperands,
     /*  83518 */     // GIR_Coverage, 3011,
     /*  83518 */     GIR_EraseRootFromParent_Done,
     /*  83519 */   // Label 1097: @83519
     /*  83519 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(83578), // Rule ID 3012 //
     /*  83524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  83527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83554 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  83557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83576 */     GIR_RootConstrainSelectedInstOperands,
     /*  83577 */     // GIR_Coverage, 3012,
     /*  83577 */     GIR_EraseRootFromParent_Done,
     /*  83578 */   // Label 1098: @83578
     /*  83578 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(83640), // Rule ID 3013 //
     /*  83583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83613 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83638 */     GIR_RootConstrainSelectedInstOperands,
     /*  83639 */     // GIR_Coverage, 3013,
     /*  83639 */     GIR_EraseRootFromParent_Done,
     /*  83640 */   // Label 1099: @83640
     /*  83640 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(83692), // Rule ID 3016 //
     /*  83645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83668 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83690 */     GIR_RootConstrainSelectedInstOperands,
     /*  83691 */     // GIR_Coverage, 3016,
     /*  83691 */     GIR_EraseRootFromParent_Done,
     /*  83692 */   // Label 1100: @83692
     /*  83692 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(83747), // Rule ID 3017 //
     /*  83697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  83700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83723 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  83726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83745 */     GIR_RootConstrainSelectedInstOperands,
     /*  83746 */     // GIR_Coverage, 3017,
     /*  83746 */     GIR_EraseRootFromParent_Done,
     /*  83747 */   // Label 1101: @83747
     /*  83747 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(83802), // Rule ID 3018 //
     /*  83752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  83755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83778 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  83781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83800 */     GIR_RootConstrainSelectedInstOperands,
     /*  83801 */     // GIR_Coverage, 3018,
     /*  83801 */     GIR_EraseRootFromParent_Done,
     /*  83802 */   // Label 1102: @83802
     /*  83802 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(83860), // Rule ID 3019 //
     /*  83807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83833 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83858 */     GIR_RootConstrainSelectedInstOperands,
     /*  83859 */     // GIR_Coverage, 3019,
     /*  83859 */     GIR_EraseRootFromParent_Done,
     /*  83860 */   // Label 1103: @83860
     /*  83860 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(83911), // Rule ID 3015 //
     /*  83865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83876 */     // MIs[0] sbase
     /*  83876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  83880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  83884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83892 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83897 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  83899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83909 */     GIR_RootConstrainSelectedInstOperands,
     /*  83910 */     // GIR_Coverage, 3015,
     /*  83910 */     GIR_EraseRootFromParent_Done,
     /*  83911 */   // Label 1104: @83911
     /*  83911 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(83955), // Rule ID 3021 //
     /*  83916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83924 */     // MIs[0] sbase
     /*  83924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  83928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  83932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83936 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83941 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  83943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83953 */     GIR_RootConstrainSelectedInstOperands,
     /*  83954 */     // GIR_Coverage, 3021,
     /*  83954 */     GIR_EraseRootFromParent_Done,
     /*  83955 */   // Label 1105: @83955
     /*  83955 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(84015), // Rule ID 6507 //
     /*  83960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  83963 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  83983 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  83983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  83986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  83988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  83993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84013 */     GIR_RootConstrainSelectedInstOperands,
     /*  84014 */     // GIR_Coverage, 6507,
     /*  84014 */     GIR_EraseRootFromParent_Done,
     /*  84015 */   // Label 1106: @84015
     /*  84015 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(84075), // Rule ID 6509 //
     /*  84020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  84023 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  84043 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  84043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  84046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84073 */     GIR_RootConstrainSelectedInstOperands,
     /*  84074 */     // GIR_Coverage, 6509,
     /*  84074 */     GIR_EraseRootFromParent_Done,
     /*  84075 */   // Label 1107: @84075
     /*  84075 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(84132), // Rule ID 4287 //
     /*  84080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  84083 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  84103 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  84106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  84118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84130 */     GIR_RootConstrainSelectedInstOperands,
     /*  84131 */     // GIR_Coverage, 4287,
     /*  84131 */     GIR_EraseRootFromParent_Done,
     /*  84132 */   // Label 1108: @84132
     /*  84132 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(84184), // Rule ID 4286 //
     /*  84137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  84140 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  84160 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  84160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  84163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  84170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84182 */     GIR_RootConstrainSelectedInstOperands,
     /*  84183 */     // GIR_Coverage, 4286,
     /*  84183 */     GIR_EraseRootFromParent_Done,
     /*  84184 */   // Label 1109: @84184
     /*  84184 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(84236), // Rule ID 4285 //
     /*  84189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  84192 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  84212 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  84215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84234 */     GIR_RootConstrainSelectedInstOperands,
     /*  84235 */     // GIR_Coverage, 4285,
     /*  84235 */     GIR_EraseRootFromParent_Done,
     /*  84236 */   // Label 1110: @84236
     /*  84236 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(84303), // Rule ID 4523 //
     /*  84241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84244 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84266 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  84269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84301 */     GIR_RootConstrainSelectedInstOperands,
     /*  84302 */     // GIR_Coverage, 4523,
     /*  84302 */     GIR_EraseRootFromParent_Done,
     /*  84303 */   // Label 1111: @84303
     /*  84303 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(84367), // Rule ID 4525 //
     /*  84308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84330 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  84333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84365 */     GIR_RootConstrainSelectedInstOperands,
     /*  84366 */     // GIR_Coverage, 4525,
     /*  84366 */     GIR_EraseRootFromParent_Done,
     /*  84367 */   // Label 1112: @84367
     /*  84367 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(84432), // Rule ID 6506 //
     /*  84372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  84375 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  84395 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  84395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  84398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84430 */     GIR_RootConstrainSelectedInstOperands,
     /*  84431 */     // GIR_Coverage, 6506,
     /*  84431 */     GIR_EraseRootFromParent_Done,
     /*  84432 */   // Label 1113: @84432
     /*  84432 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(84497), // Rule ID 6508 //
     /*  84437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  84440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  84460 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  84460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  84463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84495 */     GIR_RootConstrainSelectedInstOperands,
     /*  84496 */     // GIR_Coverage, 6508,
     /*  84496 */     GIR_EraseRootFromParent_Done,
     /*  84497 */   // Label 1114: @84497
     /*  84497 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(84559), // Rule ID 4522 //
     /*  84502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84527 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  84530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84557 */     GIR_RootConstrainSelectedInstOperands,
     /*  84558 */     // GIR_Coverage, 4522,
     /*  84558 */     GIR_EraseRootFromParent_Done,
     /*  84559 */   // Label 1115: @84559
     /*  84559 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(84618), // Rule ID 4524 //
     /*  84564 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84586 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  84589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84616 */     GIR_RootConstrainSelectedInstOperands,
     /*  84617 */     // GIR_Coverage, 4524,
     /*  84617 */     GIR_EraseRootFromParent_Done,
     /*  84618 */   // Label 1116: @84618
     /*  84618 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(84674), // Rule ID 7841 //
     /*  84623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  84626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84630 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84650 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  84653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84672 */     GIR_RootConstrainSelectedInstOperands,
     /*  84673 */     // GIR_Coverage, 7841,
     /*  84673 */     GIR_EraseRootFromParent_Done,
     /*  84674 */   // Label 1117: @84674
     /*  84674 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(84726), // Rule ID 7842 //
     /*  84679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  84682 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84702 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84724 */     GIR_RootConstrainSelectedInstOperands,
     /*  84725 */     // GIR_Coverage, 7842,
     /*  84725 */     GIR_EraseRootFromParent_Done,
     /*  84726 */   // Label 1118: @84726
     /*  84726 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(84785), // Rule ID 3888 //
     /*  84731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84734 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  84756 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  84759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  84766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  84771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84783 */     GIR_RootConstrainSelectedInstOperands,
     /*  84784 */     // GIR_Coverage, 3888,
     /*  84784 */     GIR_EraseRootFromParent_Done,
     /*  84785 */   // Label 1119: @84785
     /*  84785 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(84839), // Rule ID 3887 //
     /*  84790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  84815 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  84818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84837 */     GIR_RootConstrainSelectedInstOperands,
     /*  84838 */     // GIR_Coverage, 3887,
     /*  84838 */     GIR_EraseRootFromParent_Done,
     /*  84839 */   // Label 1120: @84839
     /*  84839 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(84894), // Rule ID 3626 //
     /*  84844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  84847 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  84870 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  84873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84892 */     GIR_RootConstrainSelectedInstOperands,
     /*  84893 */     // GIR_Coverage, 3626,
     /*  84893 */     GIR_EraseRootFromParent_Done,
     /*  84894 */   // Label 1121: @84894
     /*  84894 */   GIM_Reject,
     /*  84895 */ // Label 1093: @84895
     /*  84895 */ GIM_Reject,
     /*  84896 */ // Label 886: @84896
     /*  84896 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(85495),
     /*  84901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84908 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  84912 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(84968), // Rule ID 3094 //
     /*  84917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  84920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  84939 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  84942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84966 */     GIR_RootConstrainSelectedInstOperands,
     /*  84967 */     // GIR_Coverage, 3094,
     /*  84967 */     GIR_EraseRootFromParent_Done,
     /*  84968 */   // Label 1123: @84968
     /*  84968 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(85020), // Rule ID 3100 //
     /*  84973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  84976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  84991 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  84994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85018 */     GIR_RootConstrainSelectedInstOperands,
     /*  85019 */     // GIR_Coverage, 3100,
     /*  85019 */     GIR_EraseRootFromParent_Done,
     /*  85020 */   // Label 1124: @85020
     /*  85020 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(85071), // Rule ID 3090 //
     /*  85025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  85028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  85047 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85069 */     GIR_RootConstrainSelectedInstOperands,
     /*  85070 */     // GIR_Coverage, 3090,
     /*  85070 */     GIR_EraseRootFromParent_Done,
     /*  85071 */   // Label 1125: @85071
     /*  85071 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(85122), // Rule ID 3091 //
     /*  85076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  85079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  85098 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  85101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85120 */     GIR_RootConstrainSelectedInstOperands,
     /*  85121 */     // GIR_Coverage, 3091,
     /*  85121 */     GIR_EraseRootFromParent_Done,
     /*  85122 */   // Label 1126: @85122
     /*  85122 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(85173), // Rule ID 3092 //
     /*  85127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  85130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85149 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  85149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  85152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85171 */     GIR_RootConstrainSelectedInstOperands,
     /*  85172 */     // GIR_Coverage, 3092,
     /*  85172 */     GIR_EraseRootFromParent_Done,
     /*  85173 */   // Label 1127: @85173
     /*  85173 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(85227), // Rule ID 3093 //
     /*  85178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  85181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85200 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  85203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85225 */     GIR_RootConstrainSelectedInstOperands,
     /*  85226 */     // GIR_Coverage, 3093,
     /*  85226 */     GIR_EraseRootFromParent_Done,
     /*  85227 */   // Label 1128: @85227
     /*  85227 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(85271), // Rule ID 3096 //
     /*  85232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  85247 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85269 */     GIR_RootConstrainSelectedInstOperands,
     /*  85270 */     // GIR_Coverage, 3096,
     /*  85270 */     GIR_EraseRootFromParent_Done,
     /*  85271 */   // Label 1129: @85271
     /*  85271 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(85318), // Rule ID 3097 //
     /*  85276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  85279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  85294 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  85297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85316 */     GIR_RootConstrainSelectedInstOperands,
     /*  85317 */     // GIR_Coverage, 3097,
     /*  85317 */     GIR_EraseRootFromParent_Done,
     /*  85318 */   // Label 1130: @85318
     /*  85318 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(85365), // Rule ID 3098 //
     /*  85323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  85326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85341 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  85341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  85344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85363 */     GIR_RootConstrainSelectedInstOperands,
     /*  85364 */     // GIR_Coverage, 3098,
     /*  85364 */     GIR_EraseRootFromParent_Done,
     /*  85365 */   // Label 1131: @85365
     /*  85365 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(85415), // Rule ID 3099 //
     /*  85370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  85373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85388 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  85391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85413 */     GIR_RootConstrainSelectedInstOperands,
     /*  85414 */     // GIR_Coverage, 3099,
     /*  85414 */     GIR_EraseRootFromParent_Done,
     /*  85415 */   // Label 1132: @85415
     /*  85415 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(85458), // Rule ID 3095 //
     /*  85420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  85423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85427 */     // MIs[0] sbase
     /*  85427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85439 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85444 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85456 */     GIR_RootConstrainSelectedInstOperands,
     /*  85457 */     // GIR_Coverage, 3095,
     /*  85457 */     GIR_EraseRootFromParent_Done,
     /*  85458 */   // Label 1133: @85458
     /*  85458 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(85494), // Rule ID 3101 //
     /*  85463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85467 */     // MIs[0] sbase
     /*  85467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85475 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85480 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85492 */     GIR_RootConstrainSelectedInstOperands,
     /*  85493 */     // GIR_Coverage, 3101,
     /*  85493 */     GIR_EraseRootFromParent_Done,
     /*  85494 */   // Label 1134: @85494
     /*  85494 */   GIM_Reject,
     /*  85495 */ // Label 1122: @85495
     /*  85495 */ GIM_Reject,
     /*  85496 */ // Label 887: @85496
     /*  85496 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(85570), // Rule ID 6455 //
     /*  85501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  85504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85518 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85527 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85531 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85538 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  85541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85568 */   GIR_RootConstrainSelectedInstOperands,
     /*  85569 */   // GIR_Coverage, 6455,
     /*  85569 */   GIR_EraseRootFromParent_Done,
     /*  85570 */ // Label 1135: @85570
     /*  85570 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(85644), // Rule ID 6457 //
     /*  85575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  85578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85581 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85592 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85601 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85612 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  85615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85642 */   GIR_RootConstrainSelectedInstOperands,
     /*  85643 */   // GIR_Coverage, 6457,
     /*  85643 */   GIR_EraseRootFromParent_Done,
     /*  85644 */ // Label 1136: @85644
     /*  85644 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(85707), // Rule ID 6475 //
     /*  85649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  85652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85655 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85675 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  85678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85705 */   GIR_RootConstrainSelectedInstOperands,
     /*  85706 */   // GIR_Coverage, 6475,
     /*  85706 */   GIR_EraseRootFromParent_Done,
     /*  85707 */ // Label 1137: @85707
     /*  85707 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(85770), // Rule ID 6477 //
     /*  85712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  85715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85718 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85731 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85738 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  85741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85768 */   GIR_RootConstrainSelectedInstOperands,
     /*  85769 */   // GIR_Coverage, 6477,
     /*  85769 */   GIR_EraseRootFromParent_Done,
     /*  85770 */ // Label 1138: @85770
     /*  85770 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(85841), // Rule ID 3571 //
     /*  85775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  85778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85781 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85785 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85792 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  85801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85812 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /*  85815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85839 */   GIR_RootConstrainSelectedInstOperands,
     /*  85840 */   // GIR_Coverage, 3571,
     /*  85840 */   GIR_EraseRootFromParent_Done,
     /*  85841 */ // Label 1139: @85841
     /*  85841 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(85912), // Rule ID 4200 //
     /*  85846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  85849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85852 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85856 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85863 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85883 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  85886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85910 */   GIR_RootConstrainSelectedInstOperands,
     /*  85911 */   // GIR_Coverage, 4200,
     /*  85911 */   GIR_EraseRootFromParent_Done,
     /*  85912 */ // Label 1140: @85912
     /*  85912 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(85983), // Rule ID 4215 //
     /*  85917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  85920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85923 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85927 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85934 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85954 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  85957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85981 */   GIR_RootConstrainSelectedInstOperands,
     /*  85982 */   // GIR_Coverage, 4215,
     /*  85982 */   GIR_EraseRootFromParent_Done,
     /*  85983 */ // Label 1141: @85983
     /*  85983 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(86043), // Rule ID 4209 //
     /*  85988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  85991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85994 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86003 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  86014 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  86017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  86029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86041 */   GIR_RootConstrainSelectedInstOperands,
     /*  86042 */   // GIR_Coverage, 4209,
     /*  86042 */   GIR_EraseRootFromParent_Done,
     /*  86043 */ // Label 1142: @86043
     /*  86043 */ GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(86103), // Rule ID 4224 //
     /*  86048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  86051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86054 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  86074 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  86077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  86089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86101 */   GIR_RootConstrainSelectedInstOperands,
     /*  86102 */   // GIR_Coverage, 4224,
     /*  86102 */   GIR_EraseRootFromParent_Done,
     /*  86103 */ // Label 1143: @86103
     /*  86103 */ GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(86163), // Rule ID 4239 //
     /*  86108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  86111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86114 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  86134 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SVS_t16),
     /*  86137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  86149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86161 */   GIR_RootConstrainSelectedInstOperands,
     /*  86162 */   // GIR_Coverage, 4239,
     /*  86162 */   GIR_EraseRootFromParent_Done,
     /*  86163 */ // Label 1144: @86163
     /*  86163 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(86229), // Rule ID 3570 //
     /*  86168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86174 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86185 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86205 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /*  86208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86227 */   GIR_RootConstrainSelectedInstOperands,
     /*  86228 */   // GIR_Coverage, 3570,
     /*  86228 */   GIR_EraseRootFromParent_Done,
     /*  86229 */ // Label 1145: @86229
     /*  86229 */ GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(86295), // Rule ID 4199 //
     /*  86234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86251 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86271 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  86274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86293 */   GIR_RootConstrainSelectedInstOperands,
     /*  86294 */   // GIR_Coverage, 4199,
     /*  86294 */   GIR_EraseRootFromParent_Done,
     /*  86295 */ // Label 1146: @86295
     /*  86295 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(86361), // Rule ID 4214 //
     /*  86300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86306 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86310 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86317 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86337 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  86340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86355 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86359 */   GIR_RootConstrainSelectedInstOperands,
     /*  86360 */   // GIR_Coverage, 4214,
     /*  86360 */   GIR_EraseRootFromParent_Done,
     /*  86361 */ // Label 1147: @86361
     /*  86361 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(86416), // Rule ID 4208 //
     /*  86366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86372 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86392 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  86395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86414 */   GIR_RootConstrainSelectedInstOperands,
     /*  86415 */   // GIR_Coverage, 4208,
     /*  86415 */   GIR_EraseRootFromParent_Done,
     /*  86416 */ // Label 1148: @86416
     /*  86416 */ GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(86471), // Rule ID 4223 //
     /*  86421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86427 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86447 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  86450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86469 */   GIR_RootConstrainSelectedInstOperands,
     /*  86470 */   // GIR_Coverage, 4223,
     /*  86470 */   GIR_EraseRootFromParent_Done,
     /*  86471 */ // Label 1149: @86471
     /*  86471 */ GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(86526), // Rule ID 4238 //
     /*  86476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86482 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86502 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SADDR_t16),
     /*  86505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86524 */   GIR_RootConstrainSelectedInstOperands,
     /*  86525 */   // GIR_Coverage, 4238,
     /*  86525 */   GIR_EraseRootFromParent_Done,
     /*  86526 */ // Label 1150: @86526
     /*  86526 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(86592), // Rule ID 3569 //
     /*  86531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86537 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86541 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86548 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86568 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /*  86571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86590 */   GIR_RootConstrainSelectedInstOperands,
     /*  86591 */   // GIR_Coverage, 3569,
     /*  86591 */   GIR_EraseRootFromParent_Done,
     /*  86592 */ // Label 1151: @86592
     /*  86592 */ GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(86658), // Rule ID 4198 //
     /*  86597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86603 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86607 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86614 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86627 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86634 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  86637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86656 */   GIR_RootConstrainSelectedInstOperands,
     /*  86657 */   // GIR_Coverage, 4198,
     /*  86657 */   GIR_EraseRootFromParent_Done,
     /*  86658 */ // Label 1152: @86658
     /*  86658 */ GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(86724), // Rule ID 4213 //
     /*  86663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86666 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86669 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86680 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86700 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  86703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86722 */   GIR_RootConstrainSelectedInstOperands,
     /*  86723 */   // GIR_Coverage, 4213,
     /*  86723 */   GIR_EraseRootFromParent_Done,
     /*  86724 */ // Label 1153: @86724
     /*  86724 */ GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(86779), // Rule ID 4207 //
     /*  86729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86735 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86755 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  86758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86777 */   GIR_RootConstrainSelectedInstOperands,
     /*  86778 */   // GIR_Coverage, 4207,
     /*  86778 */   GIR_EraseRootFromParent_Done,
     /*  86779 */ // Label 1154: @86779
     /*  86779 */ GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(86834), // Rule ID 4222 //
     /*  86784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86790 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86810 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  86813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86832 */   GIR_RootConstrainSelectedInstOperands,
     /*  86833 */   // GIR_Coverage, 4222,
     /*  86833 */   GIR_EraseRootFromParent_Done,
     /*  86834 */ // Label 1155: @86834
     /*  86834 */ GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(86889), // Rule ID 4237 //
     /*  86839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86845 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86865 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_t16),
     /*  86868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86887 */   GIR_RootConstrainSelectedInstOperands,
     /*  86888 */   // GIR_Coverage, 4237,
     /*  86888 */   GIR_EraseRootFromParent_Done,
     /*  86889 */ // Label 1156: @86889
     /*  86889 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(86966), // Rule ID 4451 //
     /*  86894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  86897 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86929 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  86932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86964 */   GIR_RootConstrainSelectedInstOperands,
     /*  86965 */   // GIR_Coverage, 4451,
     /*  86965 */   GIR_EraseRootFromParent_Done,
     /*  86966 */ // Label 1157: @86966
     /*  86966 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(87040), // Rule ID 4453 //
     /*  86971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86981 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  87003 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  87006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87038 */   GIR_RootConstrainSelectedInstOperands,
     /*  87039 */   // GIR_Coverage, 4453,
     /*  87039 */   GIR_EraseRootFromParent_Done,
     /*  87040 */ // Label 1158: @87040
     /*  87040 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(87117), // Rule ID 4455 //
     /*  87045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87058 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  87080 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  87083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87115 */   GIR_RootConstrainSelectedInstOperands,
     /*  87116 */   // GIR_Coverage, 4455,
     /*  87116 */   GIR_EraseRootFromParent_Done,
     /*  87117 */ // Label 1159: @87117
     /*  87117 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(87191), // Rule ID 4457 //
     /*  87122 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87132 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  87154 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  87157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87189 */   GIR_RootConstrainSelectedInstOperands,
     /*  87190 */   // GIR_Coverage, 4457,
     /*  87190 */   GIR_EraseRootFromParent_Done,
     /*  87191 */ // Label 1160: @87191
     /*  87191 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(87270), // Rule ID 6454 //
     /*  87196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  87199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87202 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87213 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87226 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87233 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  87236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87268 */   GIR_RootConstrainSelectedInstOperands,
     /*  87269 */   // GIR_Coverage, 6454,
     /*  87269 */   GIR_EraseRootFromParent_Done,
     /*  87270 */ // Label 1161: @87270
     /*  87270 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(87349), // Rule ID 6456 //
     /*  87275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87281 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87292 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87312 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  87315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87347 */   GIR_RootConstrainSelectedInstOperands,
     /*  87348 */   // GIR_Coverage, 6456,
     /*  87348 */   GIR_EraseRootFromParent_Done,
     /*  87349 */ // Label 1162: @87349
     /*  87349 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(87417), // Rule ID 6474 //
     /*  87354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  87357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87360 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87380 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  87383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87415 */   GIR_RootConstrainSelectedInstOperands,
     /*  87416 */   // GIR_Coverage, 6474,
     /*  87416 */   GIR_EraseRootFromParent_Done,
     /*  87417 */ // Label 1163: @87417
     /*  87417 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(87485), // Rule ID 6476 //
     /*  87422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87428 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87448 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  87451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87483 */   GIR_RootConstrainSelectedInstOperands,
     /*  87484 */   // GIR_Coverage, 6476,
     /*  87484 */   GIR_EraseRootFromParent_Done,
     /*  87485 */ // Label 1164: @87485
     /*  87485 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(87557), // Rule ID 4450 //
     /*  87490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87503 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87525 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87551 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87555 */   GIR_RootConstrainSelectedInstOperands,
     /*  87556 */   // GIR_Coverage, 4450,
     /*  87556 */   GIR_EraseRootFromParent_Done,
     /*  87557 */ // Label 1165: @87557
     /*  87557 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(87626), // Rule ID 4452 //
     /*  87562 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87565 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87572 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87594 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  87597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87624 */   GIR_RootConstrainSelectedInstOperands,
     /*  87625 */   // GIR_Coverage, 4452,
     /*  87625 */   GIR_EraseRootFromParent_Done,
     /*  87626 */ // Label 1166: @87626
     /*  87626 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(87698), // Rule ID 4454 //
     /*  87631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87634 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87644 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87666 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  87669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87696 */   GIR_RootConstrainSelectedInstOperands,
     /*  87697 */   // GIR_Coverage, 4454,
     /*  87697 */   GIR_EraseRootFromParent_Done,
     /*  87698 */ // Label 1167: @87698
     /*  87698 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(87767), // Rule ID 4456 //
     /*  87703 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87706 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87713 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87735 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  87738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87765 */   GIR_RootConstrainSelectedInstOperands,
     /*  87766 */   // GIR_Coverage, 4456,
     /*  87766 */   GIR_EraseRootFromParent_Done,
     /*  87767 */ // Label 1168: @87767
     /*  87767 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(87842), // Rule ID 6424 //
     /*  87772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87789 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87810 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87840 */   GIR_RootConstrainSelectedInstOperands,
     /*  87841 */   // GIR_Coverage, 6424,
     /*  87841 */   GIR_EraseRootFromParent_Done,
     /*  87842 */ // Label 1169: @87842
     /*  87842 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(87917), // Rule ID 6425 //
     /*  87847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87864 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87885 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  87888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87915 */   GIR_RootConstrainSelectedInstOperands,
     /*  87916 */   // GIR_Coverage, 6425,
     /*  87916 */   GIR_EraseRootFromParent_Done,
     /*  87917 */ // Label 1170: @87917
     /*  87917 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(87993), // Rule ID 6430 //
     /*  87922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87928 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87939 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87961 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87991 */   GIR_RootConstrainSelectedInstOperands,
     /*  87992 */   // GIR_Coverage, 6430,
     /*  87992 */   GIR_EraseRootFromParent_Done,
     /*  87993 */ // Label 1171: @87993
     /*  87993 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(88069), // Rule ID 6431 //
     /*  87998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  88001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88004 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88015 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  88037 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  88037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  88040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  88042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  88047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88063 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88067 */   GIR_RootConstrainSelectedInstOperands,
     /*  88068 */   // GIR_Coverage, 6431,
     /*  88068 */   GIR_EraseRootFromParent_Done,
     /*  88069 */ // Label 1172: @88069
     /*  88069 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(88134), // Rule ID 6434 //
     /*  88074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  88077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88080 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  88102 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  88102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  88105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  88107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  88112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88132 */   GIR_RootConstrainSelectedInstOperands,
     /*  88133 */   // GIR_Coverage, 6434,
     /*  88133 */   GIR_EraseRootFromParent_Done,
     /*  88134 */ // Label 1173: @88134
     /*  88134 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(88199), // Rule ID 6435 //
     /*  88139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  88142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88145 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  88167 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  88167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  88170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  88172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  88177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88197 */   GIR_RootConstrainSelectedInstOperands,
     /*  88198 */   // GIR_Coverage, 6435,
     /*  88198 */   GIR_EraseRootFromParent_Done,
     /*  88199 */ // Label 1174: @88199
     /*  88199 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(88261), // Rule ID 7843 //
     /*  88204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88207 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88210 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88217 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88237 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  88240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88259 */   GIR_RootConstrainSelectedInstOperands,
     /*  88260 */   // GIR_Coverage, 7843,
     /*  88260 */   GIR_EraseRootFromParent_Done,
     /*  88261 */ // Label 1175: @88261
     /*  88261 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(88323), // Rule ID 7844 //
     /*  88266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88269 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88272 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88279 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88299 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88321 */   GIR_RootConstrainSelectedInstOperands,
     /*  88322 */   // GIR_Coverage, 7844,
     /*  88322 */   GIR_EraseRootFromParent_Done,
     /*  88323 */ // Label 1176: @88323
     /*  88323 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(88385), // Rule ID 7845 //
     /*  88328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88331 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88334 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88341 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88361 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88383 */   GIR_RootConstrainSelectedInstOperands,
     /*  88384 */   // GIR_Coverage, 7845,
     /*  88384 */   GIR_EraseRootFromParent_Done,
     /*  88385 */ // Label 1177: @88385
     /*  88385 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(88447), // Rule ID 7846 //
     /*  88390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88403 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88412 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88423 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  88426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88445 */   GIR_RootConstrainSelectedInstOperands,
     /*  88446 */   // GIR_Coverage, 7846,
     /*  88446 */   GIR_EraseRootFromParent_Done,
     /*  88447 */ // Label 1178: @88447
     /*  88447 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(88509), // Rule ID 7861 //
     /*  88452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88455 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88465 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88485 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  88488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88507 */   GIR_RootConstrainSelectedInstOperands,
     /*  88508 */   // GIR_Coverage, 7861,
     /*  88508 */   GIR_EraseRootFromParent_Done,
     /*  88509 */ // Label 1179: @88509
     /*  88509 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(88571), // Rule ID 7862 //
     /*  88514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88527 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88547 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88569 */   GIR_RootConstrainSelectedInstOperands,
     /*  88570 */   // GIR_Coverage, 7862,
     /*  88570 */   GIR_EraseRootFromParent_Done,
     /*  88571 */ // Label 1180: @88571
     /*  88571 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(88633), // Rule ID 7863 //
     /*  88576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88579 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88589 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88609 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88631 */   GIR_RootConstrainSelectedInstOperands,
     /*  88632 */   // GIR_Coverage, 7863,
     /*  88632 */   GIR_EraseRootFromParent_Done,
     /*  88633 */ // Label 1181: @88633
     /*  88633 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(88695), // Rule ID 7864 //
     /*  88638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88641 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88651 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88671 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  88674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88693 */   GIR_RootConstrainSelectedInstOperands,
     /*  88694 */   // GIR_Coverage, 7864,
     /*  88694 */   GIR_EraseRootFromParent_Done,
     /*  88695 */ // Label 1182: @88695
     /*  88695 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(88761), // Rule ID 7815 //
     /*  88700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88706 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88717 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88726 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88730 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88737 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  88740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88759 */   GIR_RootConstrainSelectedInstOperands,
     /*  88760 */   // GIR_Coverage, 7815,
     /*  88760 */   GIR_EraseRootFromParent_Done,
     /*  88761 */ // Label 1183: @88761
     /*  88761 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(88827), // Rule ID 7816 //
     /*  88766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88772 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88776 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88783 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88803 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88825 */   GIR_RootConstrainSelectedInstOperands,
     /*  88826 */   // GIR_Coverage, 7816,
     /*  88826 */   GIR_EraseRootFromParent_Done,
     /*  88827 */ // Label 1184: @88827
     /*  88827 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(88893), // Rule ID 7817 //
     /*  88832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88838 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88849 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88869 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88891 */   GIR_RootConstrainSelectedInstOperands,
     /*  88892 */   // GIR_Coverage, 7817,
     /*  88892 */   GIR_EraseRootFromParent_Done,
     /*  88893 */ // Label 1185: @88893
     /*  88893 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(88959), // Rule ID 7818 //
     /*  88898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88904 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88915 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88935 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  88938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88957 */   GIR_RootConstrainSelectedInstOperands,
     /*  88958 */   // GIR_Coverage, 7818,
     /*  88958 */   GIR_EraseRootFromParent_Done,
     /*  88959 */ // Label 1186: @88959
     /*  88959 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(89018), // Rule ID 7823 //
     /*  88964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88974 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88994 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  88997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  89004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89016 */   GIR_RootConstrainSelectedInstOperands,
     /*  89017 */   // GIR_Coverage, 7823,
     /*  89017 */   GIR_EraseRootFromParent_Done,
     /*  89018 */ // Label 1187: @89018
     /*  89018 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(89073), // Rule ID 7824 //
     /*  89023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  89026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89029 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  89034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  89049 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  89049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  89052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  89059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89071 */   GIR_RootConstrainSelectedInstOperands,
     /*  89072 */   // GIR_Coverage, 7824,
     /*  89072 */   GIR_EraseRootFromParent_Done,
     /*  89073 */ // Label 1188: @89073
     /*  89073 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(89128), // Rule ID 7825 //
     /*  89078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  89081 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89084 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  89089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89093 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  89104 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  89104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  89107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  89114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89126 */   GIR_RootConstrainSelectedInstOperands,
     /*  89127 */   // GIR_Coverage, 7825,
     /*  89127 */   GIR_EraseRootFromParent_Done,
     /*  89128 */ // Label 1189: @89128
     /*  89128 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(89183), // Rule ID 7826 //
     /*  89133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  89136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89139 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  89144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  89159 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  89159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  89162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  89169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89181 */   GIR_RootConstrainSelectedInstOperands,
     /*  89182 */   // GIR_Coverage, 7826,
     /*  89182 */   GIR_EraseRootFromParent_Done,
     /*  89183 */ // Label 1190: @89183
     /*  89183 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(89252), // Rule ID 3800 //
     /*  89188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89201 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89212 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89216 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89223 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  89226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89250 */   GIR_RootConstrainSelectedInstOperands,
     /*  89251 */   // GIR_Coverage, 3800,
     /*  89251 */   GIR_EraseRootFromParent_Done,
     /*  89252 */ // Label 1191: @89252
     /*  89252 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(89321), // Rule ID 3808 //
     /*  89257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89260 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89263 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  89270 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89285 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89292 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89319 */   GIR_RootConstrainSelectedInstOperands,
     /*  89320 */   // GIR_Coverage, 3808,
     /*  89320 */   GIR_EraseRootFromParent_Done,
     /*  89321 */ // Label 1192: @89321
     /*  89321 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(89394), // Rule ID 3548 //
     /*  89326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89343 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89365 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /*  89368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89392 */   GIR_RootConstrainSelectedInstOperands,
     /*  89393 */   // GIR_Coverage, 3548,
     /*  89393 */   GIR_EraseRootFromParent_Done,
     /*  89394 */ // Label 1193: @89394
     /*  89394 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(89467), // Rule ID 3830 //
     /*  89399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89405 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89409 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89416 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89431 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89438 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  89441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89465 */   GIR_RootConstrainSelectedInstOperands,
     /*  89466 */   // GIR_Coverage, 3830,
     /*  89466 */   GIR_EraseRootFromParent_Done,
     /*  89467 */ // Label 1194: @89467
     /*  89467 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(89540), // Rule ID 3842 //
     /*  89472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89478 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89489 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89504 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89511 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  89514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89538 */   GIR_RootConstrainSelectedInstOperands,
     /*  89539 */   // GIR_Coverage, 3842,
     /*  89539 */   GIR_EraseRootFromParent_Done,
     /*  89540 */ // Label 1195: @89540
     /*  89540 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(89602), // Rule ID 3840 //
     /*  89545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89551 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89573 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89600 */   GIR_RootConstrainSelectedInstOperands,
     /*  89601 */   // GIR_Coverage, 3840,
     /*  89601 */   GIR_EraseRootFromParent_Done,
     /*  89602 */ // Label 1196: @89602
     /*  89602 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(89664), // Rule ID 3852 //
     /*  89607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89635 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89662 */   GIR_RootConstrainSelectedInstOperands,
     /*  89663 */   // GIR_Coverage, 3852,
     /*  89663 */   GIR_EraseRootFromParent_Done,
     /*  89664 */ // Label 1197: @89664
     /*  89664 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(89726), // Rule ID 3858 //
     /*  89669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89675 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89697 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_SADDR_t16),
     /*  89700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89724 */   GIR_RootConstrainSelectedInstOperands,
     /*  89725 */   // GIR_Coverage, 3858,
     /*  89725 */   GIR_EraseRootFromParent_Done,
     /*  89726 */ // Label 1198: @89726
     /*  89726 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(89790), // Rule ID 3799 //
     /*  89731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89744 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89766 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  89769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89788 */   GIR_RootConstrainSelectedInstOperands,
     /*  89789 */   // GIR_Coverage, 3799,
     /*  89789 */   GIR_EraseRootFromParent_Done,
     /*  89790 */ // Label 1199: @89790
     /*  89790 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(89854), // Rule ID 3807 //
     /*  89795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  89808 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89830 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  89833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89852 */   GIR_RootConstrainSelectedInstOperands,
     /*  89853 */   // GIR_Coverage, 3807,
     /*  89853 */   GIR_EraseRootFromParent_Done,
     /*  89854 */ // Label 1200: @89854
     /*  89854 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(89922), // Rule ID 3547 //
     /*  89859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89876 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89898 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /*  89901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89920 */   GIR_RootConstrainSelectedInstOperands,
     /*  89921 */   // GIR_Coverage, 3547,
     /*  89921 */   GIR_EraseRootFromParent_Done,
     /*  89922 */ // Label 1201: @89922
     /*  89922 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(89990), // Rule ID 3829 //
     /*  89927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89933 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89944 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89966 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  89969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89988 */   GIR_RootConstrainSelectedInstOperands,
     /*  89989 */   // GIR_Coverage, 3829,
     /*  89989 */   GIR_EraseRootFromParent_Done,
     /*  89990 */ // Label 1202: @89990
     /*  89990 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(90058), // Rule ID 3841 //
     /*  89995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90001 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90012 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  90034 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  90037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90056 */   GIR_RootConstrainSelectedInstOperands,
     /*  90057 */   // GIR_Coverage, 3841,
     /*  90057 */   GIR_EraseRootFromParent_Done,
     /*  90058 */ // Label 1203: @90058
     /*  90058 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(90115), // Rule ID 3839 //
     /*  90063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  90066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90069 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90084 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  90091 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  90094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90113 */   GIR_RootConstrainSelectedInstOperands,
     /*  90114 */   // GIR_Coverage, 3839,
     /*  90114 */   GIR_EraseRootFromParent_Done,
     /*  90115 */ // Label 1204: @90115
     /*  90115 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(90172), // Rule ID 3851 //
     /*  90120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  90123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90126 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  90148 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  90151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90170 */   GIR_RootConstrainSelectedInstOperands,
     /*  90171 */   // GIR_Coverage, 3851,
     /*  90171 */   GIR_EraseRootFromParent_Done,
     /*  90172 */ // Label 1205: @90172
     /*  90172 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(90229), // Rule ID 3857 //
     /*  90177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  90180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90183 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  90205 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_t16),
     /*  90208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90227 */   GIR_RootConstrainSelectedInstOperands,
     /*  90228 */   // GIR_Coverage, 3857,
     /*  90228 */   GIR_EraseRootFromParent_Done,
     /*  90229 */ // Label 1206: @90229
     /*  90229 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(90294), // Rule ID 3573 //
     /*  90234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  90237 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90247 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90270 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90292 */   GIR_RootConstrainSelectedInstOperands,
     /*  90293 */   // GIR_Coverage, 3573,
     /*  90293 */   GIR_EraseRootFromParent_Done,
     /*  90294 */ // Label 1207: @90294
     /*  90294 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(90359), // Rule ID 3577 //
     /*  90299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  90302 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90312 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90335 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90357 */   GIR_RootConstrainSelectedInstOperands,
     /*  90358 */   // GIR_Coverage, 3577,
     /*  90358 */   GIR_EraseRootFromParent_Done,
     /*  90359 */ // Label 1208: @90359
     /*  90359 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(90428), // Rule ID 3590 //
     /*  90364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  90367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90370 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90374 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90381 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90404 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90426 */   GIR_RootConstrainSelectedInstOperands,
     /*  90427 */   // GIR_Coverage, 3590,
     /*  90427 */   GIR_EraseRootFromParent_Done,
     /*  90428 */ // Label 1209: @90428
     /*  90428 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(90497), // Rule ID 3596 //
     /*  90433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  90436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90439 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90443 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90450 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90473 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90495 */   GIR_RootConstrainSelectedInstOperands,
     /*  90496 */   // GIR_Coverage, 3596,
     /*  90496 */   GIR_EraseRootFromParent_Done,
     /*  90497 */ // Label 1210: @90497
     /*  90497 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(90566), // Rule ID 3602 //
     /*  90502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  90505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90508 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90542 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /*  90545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90564 */   GIR_RootConstrainSelectedInstOperands,
     /*  90565 */   // GIR_Coverage, 3602,
     /*  90565 */   GIR_EraseRootFromParent_Done,
     /*  90566 */ // Label 1211: @90566
     /*  90566 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(90624), // Rule ID 3593 //
     /*  90571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  90574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90577 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90600 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90622 */   GIR_RootConstrainSelectedInstOperands,
     /*  90623 */   // GIR_Coverage, 3593,
     /*  90623 */   GIR_EraseRootFromParent_Done,
     /*  90624 */ // Label 1212: @90624
     /*  90624 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(90682), // Rule ID 3599 //
     /*  90629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  90632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90635 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90658 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90680 */   GIR_RootConstrainSelectedInstOperands,
     /*  90681 */   // GIR_Coverage, 3599,
     /*  90681 */   GIR_EraseRootFromParent_Done,
     /*  90682 */ // Label 1213: @90682
     /*  90682 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(90740), // Rule ID 3605 //
     /*  90687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  90690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90693 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90705 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90709 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90716 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SHORT_D16_t16),
     /*  90719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90738 */   GIR_RootConstrainSelectedInstOperands,
     /*  90739 */   // GIR_Coverage, 3605,
     /*  90739 */   GIR_EraseRootFromParent_Done,
     /*  90740 */ // Label 1214: @90740
     /*  90740 */ GIM_Reject,
     /*  90741 */ // Label 888: @90741
     /*  90741 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(90808), // Rule ID 2889 //
     /*  90746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  90749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90764 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90768 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  90772 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90779 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90806 */   GIR_RootConstrainSelectedInstOperands,
     /*  90807 */   // GIR_Coverage, 2889,
     /*  90807 */   GIR_EraseRootFromParent_Done,
     /*  90808 */ // Label 1215: @90808
     /*  90808 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(90875), // Rule ID 2942 //
     /*  90813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  90816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90831 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90835 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  90839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90846 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90873 */   GIR_RootConstrainSelectedInstOperands,
     /*  90874 */   // GIR_Coverage, 2942,
     /*  90874 */   GIR_EraseRootFromParent_Done,
     /*  90875 */ // Label 1216: @90875
     /*  90875 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(90945), // Rule ID 2898 //
     /*  90880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  90883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90886 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90890 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90905 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  90909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90916 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  90919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90943 */   GIR_RootConstrainSelectedInstOperands,
     /*  90944 */   // GIR_Coverage, 2898,
     /*  90944 */   GIR_EraseRootFromParent_Done,
     /*  90945 */ // Label 1217: @90945
     /*  90945 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(91015), // Rule ID 2913 //
     /*  90950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  90953 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90956 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90960 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90975 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  90979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90986 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  90989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91013 */   GIR_RootConstrainSelectedInstOperands,
     /*  91014 */   // GIR_Coverage, 2913,
     /*  91014 */   GIR_EraseRootFromParent_Done,
     /*  91015 */ // Label 1218: @91015
     /*  91015 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(91078), // Rule ID 2936 //
     /*  91020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  91023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91026 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91038 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  91049 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91076 */   GIR_RootConstrainSelectedInstOperands,
     /*  91077 */   // GIR_Coverage, 2936,
     /*  91077 */   GIR_EraseRootFromParent_Done,
     /*  91078 */ // Label 1219: @91078
     /*  91078 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(91141), // Rule ID 2948 //
     /*  91083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  91086 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91089 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91101 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  91112 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91139 */   GIR_RootConstrainSelectedInstOperands,
     /*  91140 */   // GIR_Coverage, 2948,
     /*  91140 */   GIR_EraseRootFromParent_Done,
     /*  91141 */ // Label 1220: @91141
     /*  91141 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(91203), // Rule ID 2885 //
     /*  91146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  91149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91164 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91168 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91179 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91201 */   GIR_RootConstrainSelectedInstOperands,
     /*  91202 */   // GIR_Coverage, 2885,
     /*  91202 */   GIR_EraseRootFromParent_Done,
     /*  91203 */ // Label 1221: @91203
     /*  91203 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(91265), // Rule ID 2886 //
     /*  91208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  91211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91226 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91230 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91241 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  91244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91263 */   GIR_RootConstrainSelectedInstOperands,
     /*  91264 */   // GIR_Coverage, 2886,
     /*  91264 */   GIR_EraseRootFromParent_Done,
     /*  91265 */ // Label 1222: @91265
     /*  91265 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(91327), // Rule ID 2887 //
     /*  91270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  91273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91288 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91292 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91303 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  91303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  91306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91325 */   GIR_RootConstrainSelectedInstOperands,
     /*  91326 */   // GIR_Coverage, 2887,
     /*  91326 */   GIR_EraseRootFromParent_Done,
     /*  91327 */ // Label 1223: @91327
     /*  91327 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(91392), // Rule ID 2888 //
     /*  91332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  91335 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91338 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91350 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91354 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91365 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91390 */   GIR_RootConstrainSelectedInstOperands,
     /*  91391 */   // GIR_Coverage, 2888,
     /*  91391 */   GIR_EraseRootFromParent_Done,
     /*  91392 */ // Label 1224: @91392
     /*  91392 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(91454), // Rule ID 2938 //
     /*  91397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  91400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91415 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91419 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91430 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91452 */   GIR_RootConstrainSelectedInstOperands,
     /*  91453 */   // GIR_Coverage, 2938,
     /*  91453 */   GIR_EraseRootFromParent_Done,
     /*  91454 */ // Label 1225: @91454
     /*  91454 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(91516), // Rule ID 2939 //
     /*  91459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  91462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91477 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91481 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91485 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91492 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  91495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91514 */   GIR_RootConstrainSelectedInstOperands,
     /*  91515 */   // GIR_Coverage, 2939,
     /*  91515 */   GIR_EraseRootFromParent_Done,
     /*  91516 */ // Label 1226: @91516
     /*  91516 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(91578), // Rule ID 2940 //
     /*  91521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  91524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91539 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91543 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91554 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  91554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  91557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91576 */   GIR_RootConstrainSelectedInstOperands,
     /*  91577 */   // GIR_Coverage, 2940,
     /*  91577 */   GIR_EraseRootFromParent_Done,
     /*  91578 */ // Label 1227: @91578
     /*  91578 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(91643), // Rule ID 2941 //
     /*  91583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  91586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91589 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91601 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91605 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91616 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91641 */   GIR_RootConstrainSelectedInstOperands,
     /*  91642 */   // GIR_Coverage, 2941,
     /*  91642 */   GIR_EraseRootFromParent_Done,
     /*  91643 */ // Label 1228: @91643
     /*  91643 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(91708), // Rule ID 2896 //
     /*  91648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91654 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91673 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  91677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91684 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  91687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91706 */   GIR_RootConstrainSelectedInstOperands,
     /*  91707 */   // GIR_Coverage, 2896,
     /*  91707 */   GIR_EraseRootFromParent_Done,
     /*  91708 */ // Label 1229: @91708
     /*  91708 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(91776), // Rule ID 2897 //
     /*  91713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91719 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91738 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  91742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91749 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  91752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91774 */   GIR_RootConstrainSelectedInstOperands,
     /*  91775 */   // GIR_Coverage, 2897,
     /*  91775 */   GIR_EraseRootFromParent_Done,
     /*  91776 */ // Label 1230: @91776
     /*  91776 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(91841), // Rule ID 2911 //
     /*  91781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91784 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91787 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91791 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91806 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  91810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91817 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  91820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91839 */   GIR_RootConstrainSelectedInstOperands,
     /*  91840 */   // GIR_Coverage, 2911,
     /*  91840 */   GIR_EraseRootFromParent_Done,
     /*  91841 */ // Label 1231: @91841
     /*  91841 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(91909), // Rule ID 2912 //
     /*  91846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91852 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91856 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91867 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91871 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  91875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91882 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  91885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91907 */   GIR_RootConstrainSelectedInstOperands,
     /*  91908 */   // GIR_Coverage, 2912,
     /*  91908 */   GIR_EraseRootFromParent_Done,
     /*  91909 */ // Label 1232: @91909
     /*  91909 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(91964), // Rule ID 2932 //
     /*  91914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91929 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91940 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91962 */   GIR_RootConstrainSelectedInstOperands,
     /*  91963 */   // GIR_Coverage, 2932,
     /*  91963 */   GIR_EraseRootFromParent_Done,
     /*  91964 */ // Label 1233: @91964
     /*  91964 */ GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(92022), // Rule ID 2933 //
     /*  91969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  91972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91987 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91998 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  92001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92020 */   GIR_RootConstrainSelectedInstOperands,
     /*  92021 */   // GIR_Coverage, 2933,
     /*  92021 */   GIR_EraseRootFromParent_Done,
     /*  92022 */ // Label 1234: @92022
     /*  92022 */ GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(92080), // Rule ID 2934 //
     /*  92027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  92030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92045 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92056 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  92056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  92059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92078 */   GIR_RootConstrainSelectedInstOperands,
     /*  92079 */   // GIR_Coverage, 2934,
     /*  92079 */   GIR_EraseRootFromParent_Done,
     /*  92080 */ // Label 1235: @92080
     /*  92080 */ GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(92141), // Rule ID 2935 //
     /*  92085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  92088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92103 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92114 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  92117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92139 */   GIR_RootConstrainSelectedInstOperands,
     /*  92140 */   // GIR_Coverage, 2935,
     /*  92140 */   GIR_EraseRootFromParent_Done,
     /*  92141 */ // Label 1236: @92141
     /*  92141 */ GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(92196), // Rule ID 2944 //
     /*  92146 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92149 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92161 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  92172 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92194 */   GIR_RootConstrainSelectedInstOperands,
     /*  92195 */   // GIR_Coverage, 2944,
     /*  92195 */   GIR_EraseRootFromParent_Done,
     /*  92196 */ // Label 1237: @92196
     /*  92196 */ GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(92254), // Rule ID 2945 //
     /*  92201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  92204 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92207 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92219 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  92230 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  92233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92252 */   GIR_RootConstrainSelectedInstOperands,
     /*  92253 */   // GIR_Coverage, 2945,
     /*  92253 */   GIR_EraseRootFromParent_Done,
     /*  92254 */ // Label 1238: @92254
     /*  92254 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(92312), // Rule ID 2946 //
     /*  92259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  92262 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92265 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92273 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92277 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92288 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  92288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  92291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92310 */   GIR_RootConstrainSelectedInstOperands,
     /*  92311 */   // GIR_Coverage, 2946,
     /*  92311 */   GIR_EraseRootFromParent_Done,
     /*  92312 */ // Label 1239: @92312
     /*  92312 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(92373), // Rule ID 2947 //
     /*  92317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  92320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92323 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92335 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92346 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  92349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92371 */   GIR_RootConstrainSelectedInstOperands,
     /*  92372 */   // GIR_Coverage, 2947,
     /*  92372 */   GIR_EraseRootFromParent_Done,
     /*  92373 */ // Label 1240: @92373
     /*  92373 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(92427), // Rule ID 2890 //
     /*  92378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  92381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92392 */   // MIs[0] sbase
     /*  92392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92400 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92404 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  92408 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92413 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92421 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92425 */   GIR_RootConstrainSelectedInstOperands,
     /*  92426 */   // GIR_Coverage, 2890,
     /*  92426 */   GIR_EraseRootFromParent_Done,
     /*  92427 */ // Label 1241: @92427
     /*  92427 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(92481), // Rule ID 2943 //
     /*  92432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  92435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92446 */   // MIs[0] sbase
     /*  92446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92454 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92458 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  92462 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92467 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92479 */   GIR_RootConstrainSelectedInstOperands,
     /*  92480 */   // GIR_Coverage, 2943,
     /*  92480 */   GIR_EraseRootFromParent_Done,
     /*  92481 */ // Label 1242: @92481
     /*  92481 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(92538), // Rule ID 2899 //
     /*  92486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  92489 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92492 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92507 */   // MIs[0] sbase
     /*  92507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92515 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  92519 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  92522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92524 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92536 */   GIR_RootConstrainSelectedInstOperands,
     /*  92537 */   // GIR_Coverage, 2899,
     /*  92537 */   GIR_EraseRootFromParent_Done,
     /*  92538 */ // Label 1243: @92538
     /*  92538 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(92595), // Rule ID 2914 //
     /*  92543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  92546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92549 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92564 */   // MIs[0] sbase
     /*  92564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92572 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  92576 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  92579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92581 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92593 */   GIR_RootConstrainSelectedInstOperands,
     /*  92594 */   // GIR_Coverage, 2914,
     /*  92594 */   GIR_EraseRootFromParent_Done,
     /*  92595 */ // Label 1244: @92595
     /*  92595 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(92642), // Rule ID 2937 //
     /*  92600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92611 */   // MIs[0] sbase
     /*  92611 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92619 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92623 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92628 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92640 */   GIR_RootConstrainSelectedInstOperands,
     /*  92641 */   // GIR_Coverage, 2937,
     /*  92641 */   GIR_EraseRootFromParent_Done,
     /*  92642 */ // Label 1245: @92642
     /*  92642 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(92689), // Rule ID 2949 //
     /*  92647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92658 */   // MIs[0] sbase
     /*  92658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92666 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92670 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92675 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92687 */   GIR_RootConstrainSelectedInstOperands,
     /*  92688 */   // GIR_Coverage, 2949,
     /*  92688 */   GIR_EraseRootFromParent_Done,
     /*  92689 */ // Label 1246: @92689
     /*  92689 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(92763), // Rule ID 6443 //
     /*  92694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92700 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92711 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92724 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92731 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  92734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92761 */   GIR_RootConstrainSelectedInstOperands,
     /*  92762 */   // GIR_Coverage, 6443,
     /*  92762 */   GIR_EraseRootFromParent_Done,
     /*  92763 */ // Label 1247: @92763
     /*  92763 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(92837), // Rule ID 6445 //
     /*  92768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92774 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92785 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92805 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  92808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92835 */   GIR_RootConstrainSelectedInstOperands,
     /*  92836 */   // GIR_Coverage, 6445,
     /*  92836 */   GIR_EraseRootFromParent_Done,
     /*  92837 */ // Label 1248: @92837
     /*  92837 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(92911), // Rule ID 6467 //
     /*  92842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92859 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92879 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  92882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92909 */   GIR_RootConstrainSelectedInstOperands,
     /*  92910 */   // GIR_Coverage, 6467,
     /*  92910 */   GIR_EraseRootFromParent_Done,
     /*  92911 */ // Label 1249: @92911
     /*  92911 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(92985), // Rule ID 6469 //
     /*  92916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92922 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92926 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92933 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92953 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  92956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92983 */   GIR_RootConstrainSelectedInstOperands,
     /*  92984 */   // GIR_Coverage, 6469,
     /*  92984 */   GIR_EraseRootFromParent_Done,
     /*  92985 */ // Label 1250: @92985
     /*  92985 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(93048), // Rule ID 6479 //
     /*  92990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92996 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  93016 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  93016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  93019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  93031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93046 */   GIR_RootConstrainSelectedInstOperands,
     /*  93047 */   // GIR_Coverage, 6479,
     /*  93047 */   GIR_EraseRootFromParent_Done,
     /*  93048 */ // Label 1251: @93048
     /*  93048 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(93111), // Rule ID 6481 //
     /*  93053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  93056 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93059 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  93079 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  93079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  93082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  93094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93109 */   GIR_RootConstrainSelectedInstOperands,
     /*  93110 */   // GIR_Coverage, 6481,
     /*  93110 */   GIR_EraseRootFromParent_Done,
     /*  93111 */ // Label 1252: @93111
     /*  93111 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(93174), // Rule ID 6483 //
     /*  93116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  93119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93122 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93131 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  93142 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  93142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  93145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  93157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93172 */   GIR_RootConstrainSelectedInstOperands,
     /*  93173 */   // GIR_Coverage, 6483,
     /*  93173 */   GIR_EraseRootFromParent_Done,
     /*  93174 */ // Label 1253: @93174
     /*  93174 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(93237), // Rule ID 6485 //
     /*  93179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  93182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93185 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  93205 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  93205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  93208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  93220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93235 */   GIR_RootConstrainSelectedInstOperands,
     /*  93236 */   // GIR_Coverage, 6485,
     /*  93236 */   GIR_EraseRootFromParent_Done,
     /*  93237 */ // Label 1254: @93237
     /*  93237 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(93308), // Rule ID 3559 //
     /*  93242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93248 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93252 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93259 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93279 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  93282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93306 */   GIR_RootConstrainSelectedInstOperands,
     /*  93307 */   // GIR_Coverage, 3559,
     /*  93307 */   GIR_EraseRootFromParent_Done,
     /*  93308 */ // Label 1255: @93308
     /*  93308 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(93379), // Rule ID 4191 //
     /*  93313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93319 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93330 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93350 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  93353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93377 */   GIR_RootConstrainSelectedInstOperands,
     /*  93378 */   // GIR_Coverage, 4191,
     /*  93378 */   GIR_EraseRootFromParent_Done,
     /*  93379 */ // Label 1256: @93379
     /*  93379 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(93439), // Rule ID 4245 //
     /*  93384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93387 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93390 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93410 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  93413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93437 */   GIR_RootConstrainSelectedInstOperands,
     /*  93438 */   // GIR_Coverage, 4245,
     /*  93438 */   GIR_EraseRootFromParent_Done,
     /*  93439 */ // Label 1257: @93439
     /*  93439 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(93499), // Rule ID 4251 //
     /*  93444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93450 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93459 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93463 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93470 */   // (ld:{ *:[f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  93473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93497 */   GIR_RootConstrainSelectedInstOperands,
     /*  93498 */   // GIR_Coverage, 4251,
     /*  93498 */   GIR_EraseRootFromParent_Done,
     /*  93499 */ // Label 1258: @93499
     /*  93499 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(93565), // Rule ID 3558 //
     /*  93504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93510 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93521 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93541 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  93544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93563 */   GIR_RootConstrainSelectedInstOperands,
     /*  93564 */   // GIR_Coverage, 3558,
     /*  93564 */   GIR_EraseRootFromParent_Done,
     /*  93565 */ // Label 1259: @93565
     /*  93565 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(93631), // Rule ID 4190 //
     /*  93570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93576 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93587 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93607 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  93610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93629 */   GIR_RootConstrainSelectedInstOperands,
     /*  93630 */   // GIR_Coverage, 4190,
     /*  93630 */   GIR_EraseRootFromParent_Done,
     /*  93631 */ // Label 1260: @93631
     /*  93631 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(93686), // Rule ID 4244 //
     /*  93636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93642 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93662 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  93665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93684 */   GIR_RootConstrainSelectedInstOperands,
     /*  93685 */   // GIR_Coverage, 4244,
     /*  93685 */   GIR_EraseRootFromParent_Done,
     /*  93686 */ // Label 1261: @93686
     /*  93686 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(93741), // Rule ID 4250 //
     /*  93691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93697 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93717 */   // (ld:{ *:[f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  93720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93739 */   GIR_RootConstrainSelectedInstOperands,
     /*  93740 */   // GIR_Coverage, 4250,
     /*  93740 */   GIR_EraseRootFromParent_Done,
     /*  93741 */ // Label 1262: @93741
     /*  93741 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(93807), // Rule ID 3557 //
     /*  93746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93752 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93763 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93783 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  93786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93805 */   GIR_RootConstrainSelectedInstOperands,
     /*  93806 */   // GIR_Coverage, 3557,
     /*  93806 */   GIR_EraseRootFromParent_Done,
     /*  93807 */ // Label 1263: @93807
     /*  93807 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(93873), // Rule ID 4189 //
     /*  93812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93818 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93822 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93829 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93838 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93849 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  93852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93871 */   GIR_RootConstrainSelectedInstOperands,
     /*  93872 */   // GIR_Coverage, 4189,
     /*  93872 */   GIR_EraseRootFromParent_Done,
     /*  93873 */ // Label 1264: @93873
     /*  93873 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(93928), // Rule ID 4243 //
     /*  93878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93884 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93893 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93904 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  93907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93926 */   GIR_RootConstrainSelectedInstOperands,
     /*  93927 */   // GIR_Coverage, 4243,
     /*  93927 */   GIR_EraseRootFromParent_Done,
     /*  93928 */ // Label 1265: @93928
     /*  93928 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(93983), // Rule ID 4249 //
     /*  93933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93939 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93959 */   // (ld:{ *:[f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  93962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93981 */   GIR_RootConstrainSelectedInstOperands,
     /*  93982 */   // GIR_Coverage, 4249,
     /*  93982 */   GIR_EraseRootFromParent_Done,
     /*  93983 */ // Label 1266: @93983
     /*  93983 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(94060), // Rule ID 4433 //
     /*  93988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  93991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94001 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94023 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  94026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94058 */   GIR_RootConstrainSelectedInstOperands,
     /*  94059 */   // GIR_Coverage, 4433,
     /*  94059 */   GIR_EraseRootFromParent_Done,
     /*  94060 */ // Label 1267: @94060
     /*  94060 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(94134), // Rule ID 4437 //
     /*  94065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  94068 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94075 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94097 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  94100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94132 */   GIR_RootConstrainSelectedInstOperands,
     /*  94133 */   // GIR_Coverage, 4437,
     /*  94133 */   GIR_EraseRootFromParent_Done,
     /*  94134 */ // Label 1268: @94134
     /*  94134 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(94211), // Rule ID 4443 //
     /*  94139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94142 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  94145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94152 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94174 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  94177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94209 */   GIR_RootConstrainSelectedInstOperands,
     /*  94210 */   // GIR_Coverage, 4443,
     /*  94210 */   GIR_EraseRootFromParent_Done,
     /*  94211 */ // Label 1269: @94211
     /*  94211 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(94285), // Rule ID 4445 //
     /*  94216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  94219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94226 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94248 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  94251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94283 */   GIR_RootConstrainSelectedInstOperands,
     /*  94284 */   // GIR_Coverage, 4445,
     /*  94284 */   GIR_EraseRootFromParent_Done,
     /*  94285 */ // Label 1270: @94285
     /*  94285 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(94362), // Rule ID 6412 //
     /*  94290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  94296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  94303 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94325 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  94328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94360 */   GIR_RootConstrainSelectedInstOperands,
     /*  94361 */   // GIR_Coverage, 6412,
     /*  94361 */   GIR_EraseRootFromParent_Done,
     /*  94362 */ // Label 1271: @94362
     /*  94362 */ GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(94443), // Rule ID 4459 //
     /*  94367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94373 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94384 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94395 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94399 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94406 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  94409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94441 */   GIR_RootConstrainSelectedInstOperands,
     /*  94442 */   // GIR_Coverage, 4459,
     /*  94442 */   GIR_EraseRootFromParent_Done,
     /*  94443 */ // Label 1272: @94443
     /*  94443 */ GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(94521), // Rule ID 4461 //
     /*  94448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94462 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94477 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94484 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  94487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94519 */   GIR_RootConstrainSelectedInstOperands,
     /*  94520 */   // GIR_Coverage, 4461,
     /*  94520 */   GIR_EraseRootFromParent_Done,
     /*  94521 */ // Label 1273: @94521
     /*  94521 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(94602), // Rule ID 4479 //
     /*  94526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94529 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94532 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94543 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94565 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  94568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94600 */   GIR_RootConstrainSelectedInstOperands,
     /*  94601 */   // GIR_Coverage, 4479,
     /*  94601 */   GIR_EraseRootFromParent_Done,
     /*  94602 */ // Label 1274: @94602
     /*  94602 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(94680), // Rule ID 4481 //
     /*  94607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94610 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94621 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94643 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  94646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94678 */   GIR_RootConstrainSelectedInstOperands,
     /*  94679 */   // GIR_Coverage, 4481,
     /*  94679 */   GIR_EraseRootFromParent_Done,
     /*  94680 */ // Label 1275: @94680
     /*  94680 */ GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(94760), // Rule ID 6415 //
     /*  94685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94702 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94723 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  94726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94758 */   GIR_RootConstrainSelectedInstOperands,
     /*  94759 */   // GIR_Coverage, 6415,
     /*  94759 */   GIR_EraseRootFromParent_Done,
     /*  94760 */ // Label 1276: @94760
     /*  94760 */ GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(94840), // Rule ID 6418 //
     /*  94765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94782 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94803 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  94806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94838 */   GIR_RootConstrainSelectedInstOperands,
     /*  94839 */   // GIR_Coverage, 6418,
     /*  94839 */   GIR_EraseRootFromParent_Done,
     /*  94840 */ // Label 1277: @94840
     /*  94840 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(94919), // Rule ID 6442 //
     /*  94845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  94848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94851 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94862 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94882 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  94885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94917 */   GIR_RootConstrainSelectedInstOperands,
     /*  94918 */   // GIR_Coverage, 6442,
     /*  94918 */   GIR_EraseRootFromParent_Done,
     /*  94919 */ // Label 1278: @94919
     /*  94919 */ GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(94998), // Rule ID 6444 //
     /*  94924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  94927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94930 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94934 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94941 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94961 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  94964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94996 */   GIR_RootConstrainSelectedInstOperands,
     /*  94997 */   // GIR_Coverage, 6444,
     /*  94997 */   GIR_EraseRootFromParent_Done,
     /*  94998 */ // Label 1279: @94998
     /*  94998 */ GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(95077), // Rule ID 6466 //
     /*  95003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  95006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95009 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95020 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95040 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  95043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95071 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95075 */   GIR_RootConstrainSelectedInstOperands,
     /*  95076 */   // GIR_Coverage, 6466,
     /*  95076 */   GIR_EraseRootFromParent_Done,
     /*  95077 */ // Label 1280: @95077
     /*  95077 */ GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(95156), // Rule ID 6468 //
     /*  95082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  95085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95088 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95099 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95119 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  95122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95154 */   GIR_RootConstrainSelectedInstOperands,
     /*  95155 */   // GIR_Coverage, 6468,
     /*  95155 */   GIR_EraseRootFromParent_Done,
     /*  95156 */ // Label 1281: @95156
     /*  95156 */ GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(95226), // Rule ID 4495 //
     /*  95161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95167 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95189 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  95192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95220 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95224 */   GIR_RootConstrainSelectedInstOperands,
     /*  95225 */   // GIR_Coverage, 4495,
     /*  95225 */   GIR_EraseRootFromParent_Done,
     /*  95226 */ // Label 1282: @95226
     /*  95226 */ GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(95293), // Rule ID 4497 //
     /*  95231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95234 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95245 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95249 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95256 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  95259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95291 */   GIR_RootConstrainSelectedInstOperands,
     /*  95292 */   // GIR_Coverage, 4497,
     /*  95292 */   GIR_EraseRootFromParent_Done,
     /*  95293 */ // Label 1283: @95293
     /*  95293 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(95363), // Rule ID 4499 //
     /*  95298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95304 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95326 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  95329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95361 */   GIR_RootConstrainSelectedInstOperands,
     /*  95362 */   // GIR_Coverage, 4499,
     /*  95362 */   GIR_EraseRootFromParent_Done,
     /*  95363 */ // Label 1284: @95363
     /*  95363 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(95430), // Rule ID 4501 //
     /*  95368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95371 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95393 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  95396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95428 */   GIR_RootConstrainSelectedInstOperands,
     /*  95429 */   // GIR_Coverage, 4501,
     /*  95429 */   GIR_EraseRootFromParent_Done,
     /*  95430 */ // Label 1285: @95430
     /*  95430 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(95498), // Rule ID 6478 //
     /*  95435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  95438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95441 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95461 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  95464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95496 */   GIR_RootConstrainSelectedInstOperands,
     /*  95497 */   // GIR_Coverage, 6478,
     /*  95497 */   GIR_EraseRootFromParent_Done,
     /*  95498 */ // Label 1286: @95498
     /*  95498 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(95566), // Rule ID 6480 //
     /*  95503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  95506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95509 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95529 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  95532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95564 */   GIR_RootConstrainSelectedInstOperands,
     /*  95565 */   // GIR_Coverage, 6480,
     /*  95565 */   GIR_EraseRootFromParent_Done,
     /*  95566 */ // Label 1287: @95566
     /*  95566 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(95634), // Rule ID 6482 //
     /*  95571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  95574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95577 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95597 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  95600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95632 */   GIR_RootConstrainSelectedInstOperands,
     /*  95633 */   // GIR_Coverage, 6482,
     /*  95633 */   GIR_EraseRootFromParent_Done,
     /*  95634 */ // Label 1288: @95634
     /*  95634 */ GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(95702), // Rule ID 6484 //
     /*  95639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  95642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95645 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95665 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  95668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95700 */   GIR_RootConstrainSelectedInstOperands,
     /*  95701 */   // GIR_Coverage, 6484,
     /*  95701 */   GIR_EraseRootFromParent_Done,
     /*  95702 */ // Label 1289: @95702
     /*  95702 */ GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(95774), // Rule ID 4432 //
     /*  95707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95720 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95742 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  95745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95772 */   GIR_RootConstrainSelectedInstOperands,
     /*  95773 */   // GIR_Coverage, 4432,
     /*  95773 */   GIR_EraseRootFromParent_Done,
     /*  95774 */ // Label 1290: @95774
     /*  95774 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(95843), // Rule ID 4436 //
     /*  95779 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95789 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95811 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  95814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95841 */   GIR_RootConstrainSelectedInstOperands,
     /*  95842 */   // GIR_Coverage, 4436,
     /*  95842 */   GIR_EraseRootFromParent_Done,
     /*  95843 */ // Label 1291: @95843
     /*  95843 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(95915), // Rule ID 4442 //
     /*  95848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95851 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95854 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95861 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95883 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  95886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95913 */   GIR_RootConstrainSelectedInstOperands,
     /*  95914 */   // GIR_Coverage, 4442,
     /*  95914 */   GIR_EraseRootFromParent_Done,
     /*  95915 */ // Label 1292: @95915
     /*  95915 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(95984), // Rule ID 4444 //
     /*  95920 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95930 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95952 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  95955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95982 */   GIR_RootConstrainSelectedInstOperands,
     /*  95983 */   // GIR_Coverage, 4444,
     /*  95983 */   GIR_EraseRootFromParent_Done,
     /*  95984 */ // Label 1293: @95984
     /*  95984 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(96060), // Rule ID 4458 //
     /*  95989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95995 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96006 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96017 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96028 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  96031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96058 */   GIR_RootConstrainSelectedInstOperands,
     /*  96059 */   // GIR_Coverage, 4458,
     /*  96059 */   GIR_EraseRootFromParent_Done,
     /*  96060 */ // Label 1294: @96060
     /*  96060 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(96133), // Rule ID 4460 //
     /*  96065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96068 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96079 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96101 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  96104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96131 */   GIR_RootConstrainSelectedInstOperands,
     /*  96132 */   // GIR_Coverage, 4460,
     /*  96132 */   GIR_EraseRootFromParent_Done,
     /*  96133 */ // Label 1295: @96133
     /*  96133 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(96209), // Rule ID 4478 //
     /*  96138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  96141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96144 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96155 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96177 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  96180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96207 */   GIR_RootConstrainSelectedInstOperands,
     /*  96208 */   // GIR_Coverage, 4478,
     /*  96208 */   GIR_EraseRootFromParent_Done,
     /*  96209 */ // Label 1296: @96209
     /*  96209 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(96282), // Rule ID 4480 //
     /*  96214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96217 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96228 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96250 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  96253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96280 */   GIR_RootConstrainSelectedInstOperands,
     /*  96281 */   // GIR_Coverage, 4480,
     /*  96281 */   GIR_EraseRootFromParent_Done,
     /*  96282 */ // Label 1297: @96282
     /*  96282 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(96347), // Rule ID 4494 //
     /*  96287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  96290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96293 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96315 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96345 */   GIR_RootConstrainSelectedInstOperands,
     /*  96346 */   // GIR_Coverage, 4494,
     /*  96346 */   GIR_EraseRootFromParent_Done,
     /*  96347 */ // Label 1298: @96347
     /*  96347 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(96409), // Rule ID 4496 //
     /*  96352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96377 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96407 */   GIR_RootConstrainSelectedInstOperands,
     /*  96408 */   // GIR_Coverage, 4496,
     /*  96408 */   GIR_EraseRootFromParent_Done,
     /*  96409 */ // Label 1299: @96409
     /*  96409 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(96474), // Rule ID 4498 //
     /*  96414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  96417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96420 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96431 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96435 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96442 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96472 */   GIR_RootConstrainSelectedInstOperands,
     /*  96473 */   // GIR_Coverage, 4498,
     /*  96473 */   GIR_EraseRootFromParent_Done,
     /*  96474 */ // Label 1300: @96474
     /*  96474 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(96536), // Rule ID 4500 //
     /*  96479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96482 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96504 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96534 */   GIR_RootConstrainSelectedInstOperands,
     /*  96535 */   // GIR_Coverage, 4500,
     /*  96535 */   GIR_EraseRootFromParent_Done,
     /*  96536 */ // Label 1301: @96536
     /*  96536 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(96598), // Rule ID 7847 //
     /*  96541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96544 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96547 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96554 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96574 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  96577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96596 */   GIR_RootConstrainSelectedInstOperands,
     /*  96597 */   // GIR_Coverage, 7847,
     /*  96597 */   GIR_EraseRootFromParent_Done,
     /*  96598 */ // Label 1302: @96598
     /*  96598 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(96660), // Rule ID 7848 //
     /*  96603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96616 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96629 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96636 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  96639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96658 */   GIR_RootConstrainSelectedInstOperands,
     /*  96659 */   // GIR_Coverage, 7848,
     /*  96659 */   GIR_EraseRootFromParent_Done,
     /*  96660 */ // Label 1303: @96660
     /*  96660 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(96722), // Rule ID 7865 //
     /*  96665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96668 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96671 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96678 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96698 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  96701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96720 */   GIR_RootConstrainSelectedInstOperands,
     /*  96721 */   // GIR_Coverage, 7865,
     /*  96721 */   GIR_EraseRootFromParent_Done,
     /*  96722 */ // Label 1304: @96722
     /*  96722 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(96784), // Rule ID 7866 //
     /*  96727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96730 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96740 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96753 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96760 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  96763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96782 */   GIR_RootConstrainSelectedInstOperands,
     /*  96783 */   // GIR_Coverage, 7866,
     /*  96783 */   GIR_EraseRootFromParent_Done,
     /*  96784 */ // Label 1305: @96784
     /*  96784 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(96846), // Rule ID 7871 //
     /*  96789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96792 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96802 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96811 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96815 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96822 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32_glue>><<P:Predicate_atomic_load_32_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  96825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96844 */   GIR_RootConstrainSelectedInstOperands,
     /*  96845 */   // GIR_Coverage, 7871,
     /*  96845 */   GIR_EraseRootFromParent_Done,
     /*  96846 */ // Label 1306: @96846
     /*  96846 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(96908), // Rule ID 7872 //
     /*  96851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96864 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96884 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  96887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96906 */   GIR_RootConstrainSelectedInstOperands,
     /*  96907 */   // GIR_Coverage, 7872,
     /*  96907 */   GIR_EraseRootFromParent_Done,
     /*  96908 */ // Label 1307: @96908
     /*  96908 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(96974), // Rule ID 7802 //
     /*  96913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96919 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96930 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96950 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  96953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96972 */   GIR_RootConstrainSelectedInstOperands,
     /*  96973 */   // GIR_Coverage, 7802,
     /*  96973 */   GIR_EraseRootFromParent_Done,
     /*  96974 */ // Label 1308: @96974
     /*  96974 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(97040), // Rule ID 7803 //
     /*  96979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96985 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96996 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97016 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  97019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97038 */   GIR_RootConstrainSelectedInstOperands,
     /*  97039 */   // GIR_Coverage, 7803,
     /*  97039 */   GIR_EraseRootFromParent_Done,
     /*  97040 */ // Label 1309: @97040
     /*  97040 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(97106), // Rule ID 7810 //
     /*  97045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  97048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97051 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97062 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97075 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97082 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi16_glue>><<P:Predicate_extloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  97085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97100 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97104 */   GIR_RootConstrainSelectedInstOperands,
     /*  97105 */   // GIR_Coverage, 7810,
     /*  97105 */   GIR_EraseRootFromParent_Done,
     /*  97106 */ // Label 1310: @97106
     /*  97106 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(97172), // Rule ID 7811 //
     /*  97111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  97114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97117 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97128 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97148 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  97151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97170 */   GIR_RootConstrainSelectedInstOperands,
     /*  97171 */   // GIR_Coverage, 7811,
     /*  97171 */   GIR_EraseRootFromParent_Done,
     /*  97172 */ // Label 1311: @97172
     /*  97172 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(97231), // Rule ID 7827 //
     /*  97177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  97180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97187 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97207 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  97210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97229 */   GIR_RootConstrainSelectedInstOperands,
     /*  97230 */   // GIR_Coverage, 7827,
     /*  97230 */   GIR_EraseRootFromParent_Done,
     /*  97231 */ // Label 1312: @97231
     /*  97231 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(97290), // Rule ID 7829 //
     /*  97236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  97239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97246 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97266 */   // (AMDGPUld_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  97269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97288 */   GIR_RootConstrainSelectedInstOperands,
     /*  97289 */   // GIR_Coverage, 7829,
     /*  97289 */   GIR_EraseRootFromParent_Done,
     /*  97290 */ // Label 1313: @97290
     /*  97290 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(97345), // Rule ID 7828 //
     /*  97295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  97298 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97301 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97321 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  97324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97343 */   GIR_RootConstrainSelectedInstOperands,
     /*  97344 */   // GIR_Coverage, 7828,
     /*  97344 */   GIR_EraseRootFromParent_Done,
     /*  97345 */ // Label 1314: @97345
     /*  97345 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(97400), // Rule ID 7830 //
     /*  97350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  97353 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97356 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97376 */   // (ld:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  97379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97398 */   GIR_RootConstrainSelectedInstOperands,
     /*  97399 */   // GIR_Coverage, 7830,
     /*  97399 */   GIR_EraseRootFromParent_Done,
     /*  97400 */ // Label 1315: @97400
     /*  97400 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(97469), // Rule ID 3544 //
     /*  97405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97408 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97411 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97418 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97440 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  97443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97467 */   GIR_RootConstrainSelectedInstOperands,
     /*  97468 */   // GIR_Coverage, 3544,
     /*  97468 */   GIR_EraseRootFromParent_Done,
     /*  97469 */ // Label 1316: @97469
     /*  97469 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(97538), // Rule ID 3806 //
     /*  97474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97477 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97480 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97487 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97509 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  97512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97536 */   GIR_RootConstrainSelectedInstOperands,
     /*  97537 */   // GIR_Coverage, 3806,
     /*  97537 */   GIR_EraseRootFromParent_Done,
     /*  97538 */ // Label 1317: @97538
     /*  97538 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(97607), // Rule ID 3954 //
     /*  97543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97546 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97549 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97556 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97578 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97605 */   GIR_RootConstrainSelectedInstOperands,
     /*  97606 */   // GIR_Coverage, 3954,
     /*  97606 */   GIR_EraseRootFromParent_Done,
     /*  97607 */ // Label 1318: @97607
     /*  97607 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(97680), // Rule ID 3818 //
     /*  97612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97618 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97629 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97651 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  97654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97678 */   GIR_RootConstrainSelectedInstOperands,
     /*  97679 */   // GIR_Coverage, 3818,
     /*  97679 */   GIR_EraseRootFromParent_Done,
     /*  97680 */ // Label 1319: @97680
     /*  97680 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(97753), // Rule ID 3824 //
     /*  97685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97702 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97717 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97724 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  97727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97751 */   GIR_RootConstrainSelectedInstOperands,
     /*  97752 */   // GIR_Coverage, 3824,
     /*  97752 */   GIR_EraseRootFromParent_Done,
     /*  97753 */ // Label 1320: @97753
     /*  97753 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(97815), // Rule ID 3862 //
     /*  97758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97786 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97813 */   GIR_RootConstrainSelectedInstOperands,
     /*  97814 */   // GIR_Coverage, 3862,
     /*  97814 */   GIR_EraseRootFromParent_Done,
     /*  97815 */ // Label 1321: @97815
     /*  97815 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(97877), // Rule ID 3864 //
     /*  97820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97826 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97837 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97848 */   // (ld:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97875 */   GIR_RootConstrainSelectedInstOperands,
     /*  97876 */   // GIR_Coverage, 3864,
     /*  97876 */   GIR_EraseRootFromParent_Done,
     /*  97877 */ // Label 1322: @97877
     /*  97877 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(97941), // Rule ID 3543 //
     /*  97882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97885 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97895 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97917 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  97920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97939 */   GIR_RootConstrainSelectedInstOperands,
     /*  97940 */   // GIR_Coverage, 3543,
     /*  97940 */   GIR_EraseRootFromParent_Done,
     /*  97941 */ // Label 1323: @97941
     /*  97941 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(98005), // Rule ID 3805 //
     /*  97946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97949 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97952 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97959 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97970 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97974 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97981 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  97984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98003 */   GIR_RootConstrainSelectedInstOperands,
     /*  98004 */   // GIR_Coverage, 3805,
     /*  98004 */   GIR_EraseRootFromParent_Done,
     /*  98005 */ // Label 1324: @98005
     /*  98005 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(98069), // Rule ID 3953 //
     /*  98010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98013 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98023 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98038 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98045 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  98048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98063 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98067 */   GIR_RootConstrainSelectedInstOperands,
     /*  98068 */   // GIR_Coverage, 3953,
     /*  98068 */   GIR_EraseRootFromParent_Done,
     /*  98069 */ // Label 1325: @98069
     /*  98069 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(98137), // Rule ID 3817 //
     /*  98074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98080 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98091 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98106 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98113 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  98116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98135 */   GIR_RootConstrainSelectedInstOperands,
     /*  98136 */   // GIR_Coverage, 3817,
     /*  98136 */   GIR_EraseRootFromParent_Done,
     /*  98137 */ // Label 1326: @98137
     /*  98137 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(98205), // Rule ID 3823 //
     /*  98142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98148 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98159 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98181 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  98184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98203 */   GIR_RootConstrainSelectedInstOperands,
     /*  98204 */   // GIR_Coverage, 3823,
     /*  98204 */   GIR_EraseRootFromParent_Done,
     /*  98205 */ // Label 1327: @98205
     /*  98205 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(98262), // Rule ID 3861 //
     /*  98210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98216 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98238 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  98241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98260 */   GIR_RootConstrainSelectedInstOperands,
     /*  98261 */   // GIR_Coverage, 3861,
     /*  98261 */   GIR_EraseRootFromParent_Done,
     /*  98262 */ // Label 1328: @98262
     /*  98262 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(98319), // Rule ID 3863 //
     /*  98267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98273 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98295 */   // (ld:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  98298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98317 */   GIR_RootConstrainSelectedInstOperands,
     /*  98318 */   // GIR_Coverage, 3863,
     /*  98318 */   GIR_EraseRootFromParent_Done,
     /*  98319 */ // Label 1329: @98319
     /*  98319 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(98384), // Rule ID 3572 //
     /*  98324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98330 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98337 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98353 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98360 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  98363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98382 */   GIR_RootConstrainSelectedInstOperands,
     /*  98383 */   // GIR_Coverage, 3572,
     /*  98383 */   GIR_EraseRootFromParent_Done,
     /*  98384 */ // Label 1330: @98384
     /*  98384 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(98449), // Rule ID 3576 //
     /*  98389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98392 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98402 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98425 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  98428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98447 */   GIR_RootConstrainSelectedInstOperands,
     /*  98448 */   // GIR_Coverage, 3576,
     /*  98448 */   GIR_EraseRootFromParent_Done,
     /*  98449 */ // Label 1331: @98449
     /*  98449 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(98514), // Rule ID 3608 //
     /*  98454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98467 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98490 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98512 */   GIR_RootConstrainSelectedInstOperands,
     /*  98513 */   // GIR_Coverage, 3608,
     /*  98513 */   GIR_EraseRootFromParent_Done,
     /*  98514 */ // Label 1332: @98514
     /*  98514 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(98583), // Rule ID 3580 //
     /*  98519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98525 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98536 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98548 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98559 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  98562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98581 */   GIR_RootConstrainSelectedInstOperands,
     /*  98582 */   // GIR_Coverage, 3580,
     /*  98582 */   GIR_EraseRootFromParent_Done,
     /*  98583 */ // Label 1333: @98583
     /*  98583 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(98652), // Rule ID 3585 //
     /*  98588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98594 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98605 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98628 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  98631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98650 */   GIR_RootConstrainSelectedInstOperands,
     /*  98651 */   // GIR_Coverage, 3585,
     /*  98651 */   GIR_EraseRootFromParent_Done,
     /*  98652 */ // Label 1334: @98652
     /*  98652 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(98710), // Rule ID 3612 //
     /*  98657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98663 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98686 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98708 */   GIR_RootConstrainSelectedInstOperands,
     /*  98709 */   // GIR_Coverage, 3612,
     /*  98709 */   GIR_EraseRootFromParent_Done,
     /*  98710 */ // Label 1335: @98710
     /*  98710 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(98768), // Rule ID 3614 //
     /*  98715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98721 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98744 */   // (ld:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98766 */   GIR_RootConstrainSelectedInstOperands,
     /*  98767 */   // GIR_Coverage, 3614,
     /*  98767 */   GIR_EraseRootFromParent_Done,
     /*  98768 */ // Label 1336: @98768
     /*  98768 */ GIM_Reject,
     /*  98769 */ // Label 889: @98769
     /*  98769 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(98836), // Rule ID 3043 //
     /*  98774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98777 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98780 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98792 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98796 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98807 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98834 */   GIR_RootConstrainSelectedInstOperands,
     /*  98835 */   // GIR_Coverage, 3043,
     /*  98835 */   GIR_EraseRootFromParent_Done,
     /*  98836 */ // Label 1337: @98836
     /*  98836 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(98903), // Rule ID 3077 //
     /*  98841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98859 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98863 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98874 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98901 */   GIR_RootConstrainSelectedInstOperands,
     /*  98902 */   // GIR_Coverage, 3077,
     /*  98902 */   GIR_EraseRootFromParent_Done,
     /*  98903 */ // Label 1338: @98903
     /*  98903 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(98970), // Rule ID 8345 //
     /*  98908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98926 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98930 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98934 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98941 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98964 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98968 */   GIR_RootConstrainSelectedInstOperands,
     /*  98969 */   // GIR_Coverage, 8345,
     /*  98969 */   GIR_EraseRootFromParent_Done,
     /*  98970 */ // Label 1339: @98970
     /*  98970 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(99033), // Rule ID 3048 //
     /*  98975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98993 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99004 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  99007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99031 */   GIR_RootConstrainSelectedInstOperands,
     /*  99032 */   // GIR_Coverage, 3048,
     /*  99032 */   GIR_EraseRootFromParent_Done,
     /*  99033 */ // Label 1340: @99033
     /*  99033 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(99096), // Rule ID 3082 //
     /*  99038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99056 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99067 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  99070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99094 */   GIR_RootConstrainSelectedInstOperands,
     /*  99095 */   // GIR_Coverage, 3082,
     /*  99095 */   GIR_EraseRootFromParent_Done,
     /*  99096 */ // Label 1341: @99096
     /*  99096 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(99159), // Rule ID 8350 //
     /*  99101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99119 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99130 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  99133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99157 */   GIR_RootConstrainSelectedInstOperands,
     /*  99158 */   // GIR_Coverage, 8350,
     /*  99158 */   GIR_EraseRootFromParent_Done,
     /*  99159 */ // Label 1342: @99159
     /*  99159 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(99222), // Rule ID 3054 //
     /*  99164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  99167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99182 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99193 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99220 */   GIR_RootConstrainSelectedInstOperands,
     /*  99221 */   // GIR_Coverage, 3054,
     /*  99221 */   GIR_EraseRootFromParent_Done,
     /*  99222 */ // Label 1343: @99222
     /*  99222 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(99285), // Rule ID 3088 //
     /*  99227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  99230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99245 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99249 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99256 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99283 */   GIR_RootConstrainSelectedInstOperands,
     /*  99284 */   // GIR_Coverage, 3088,
     /*  99284 */   GIR_EraseRootFromParent_Done,
     /*  99285 */ // Label 1344: @99285
     /*  99285 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(99348), // Rule ID 8356 //
     /*  99290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  99293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99308 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99319 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99342 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99346 */   GIR_RootConstrainSelectedInstOperands,
     /*  99347 */   // GIR_Coverage, 8356,
     /*  99347 */   GIR_EraseRootFromParent_Done,
     /*  99348 */ // Label 1345: @99348
     /*  99348 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(99410), // Rule ID 3039 //
     /*  99353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99356 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99367 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99371 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99375 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99379 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99386 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99408 */   GIR_RootConstrainSelectedInstOperands,
     /*  99409 */   // GIR_Coverage, 3039,
     /*  99409 */   GIR_EraseRootFromParent_Done,
     /*  99410 */ // Label 1346: @99410
     /*  99410 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(99472), // Rule ID 3040 //
     /*  99415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99433 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99437 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99448 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99470 */   GIR_RootConstrainSelectedInstOperands,
     /*  99471 */   // GIR_Coverage, 3040,
     /*  99471 */   GIR_EraseRootFromParent_Done,
     /*  99472 */ // Label 1347: @99472
     /*  99472 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(99534), // Rule ID 3041 //
     /*  99477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99495 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99499 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99510 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  99513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99532 */   GIR_RootConstrainSelectedInstOperands,
     /*  99533 */   // GIR_Coverage, 3041,
     /*  99533 */   GIR_EraseRootFromParent_Done,
     /*  99534 */ // Label 1348: @99534
     /*  99534 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(99599), // Rule ID 3042 //
     /*  99539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99542 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99545 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99557 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99561 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99572 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  99572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99597 */   GIR_RootConstrainSelectedInstOperands,
     /*  99598 */   // GIR_Coverage, 3042,
     /*  99598 */   GIR_EraseRootFromParent_Done,
     /*  99599 */ // Label 1349: @99599
     /*  99599 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(99661), // Rule ID 3073 //
     /*  99604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99622 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99626 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99637 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99659 */   GIR_RootConstrainSelectedInstOperands,
     /*  99660 */   // GIR_Coverage, 3073,
     /*  99660 */   GIR_EraseRootFromParent_Done,
     /*  99661 */ // Label 1350: @99661
     /*  99661 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(99723), // Rule ID 3074 //
     /*  99666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99684 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99688 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99699 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99721 */   GIR_RootConstrainSelectedInstOperands,
     /*  99722 */   // GIR_Coverage, 3074,
     /*  99722 */   GIR_EraseRootFromParent_Done,
     /*  99723 */ // Label 1351: @99723
     /*  99723 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(99785), // Rule ID 3075 //
     /*  99728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99746 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99750 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99754 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99761 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  99764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99783 */   GIR_RootConstrainSelectedInstOperands,
     /*  99784 */   // GIR_Coverage, 3075,
     /*  99784 */   GIR_EraseRootFromParent_Done,
     /*  99785 */ // Label 1352: @99785
     /*  99785 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(99850), // Rule ID 3076 //
     /*  99790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99796 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99808 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99812 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99823 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  99823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99848 */   GIR_RootConstrainSelectedInstOperands,
     /*  99849 */   // GIR_Coverage, 3076,
     /*  99849 */   GIR_EraseRootFromParent_Done,
     /*  99850 */ // Label 1353: @99850
     /*  99850 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(99912), // Rule ID 8341 //
     /*  99855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99873 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99877 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99888 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99910 */   GIR_RootConstrainSelectedInstOperands,
     /*  99911 */   // GIR_Coverage, 8341,
     /*  99911 */   GIR_EraseRootFromParent_Done,
     /*  99912 */ // Label 1354: @99912
     /*  99912 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(99974), // Rule ID 8342 //
     /*  99917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99935 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99939 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99943 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99950 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99972 */   GIR_RootConstrainSelectedInstOperands,
     /*  99973 */   // GIR_Coverage, 8342,
     /*  99973 */   GIR_EraseRootFromParent_Done,
     /*  99974 */ // Label 1355: @99974
     /*  99974 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(100036), // Rule ID 8343 //
     /*  99979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99997 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100001 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 100005 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100012 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 100015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100034 */   GIR_RootConstrainSelectedInstOperands,
     /* 100035 */   // GIR_Coverage, 8343,
     /* 100035 */   GIR_EraseRootFromParent_Done,
     /* 100036 */ // Label 1356: @100036
     /* 100036 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(100101), // Rule ID 8344 //
     /* 100041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100059 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100063 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 100067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100074 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 100077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100099 */   GIR_RootConstrainSelectedInstOperands,
     /* 100100 */   // GIR_Coverage, 8344,
     /* 100100 */   GIR_EraseRootFromParent_Done,
     /* 100101 */ // Label 1357: @100101
     /* 100101 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(100159), // Rule ID 3045 //
     /* 100106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 100109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100124 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100135 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 100138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100157 */   GIR_RootConstrainSelectedInstOperands,
     /* 100158 */   // GIR_Coverage, 3045,
     /* 100158 */   GIR_EraseRootFromParent_Done,
     /* 100159 */ // Label 1358: @100159
     /* 100159 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(100217), // Rule ID 3046 //
     /* 100164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 100167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100182 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100193 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 100196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100215 */   GIR_RootConstrainSelectedInstOperands,
     /* 100216 */   // GIR_Coverage, 3046,
     /* 100216 */   GIR_EraseRootFromParent_Done,
     /* 100217 */ // Label 1359: @100217
     /* 100217 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(100278), // Rule ID 3047 //
     /* 100222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100240 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100251 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100276 */   GIR_RootConstrainSelectedInstOperands,
     /* 100277 */   // GIR_Coverage, 3047,
     /* 100277 */   GIR_EraseRootFromParent_Done,
     /* 100278 */ // Label 1360: @100278
     /* 100278 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(100336), // Rule ID 3079 //
     /* 100283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 100286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100301 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100312 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 100315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100334 */   GIR_RootConstrainSelectedInstOperands,
     /* 100335 */   // GIR_Coverage, 3079,
     /* 100335 */   GIR_EraseRootFromParent_Done,
     /* 100336 */ // Label 1361: @100336
     /* 100336 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(100394), // Rule ID 3080 //
     /* 100341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 100344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100359 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100363 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100370 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 100373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100392 */   GIR_RootConstrainSelectedInstOperands,
     /* 100393 */   // GIR_Coverage, 3080,
     /* 100393 */   GIR_EraseRootFromParent_Done,
     /* 100394 */ // Label 1362: @100394
     /* 100394 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(100455), // Rule ID 3081 //
     /* 100399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100417 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100428 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100453 */   GIR_RootConstrainSelectedInstOperands,
     /* 100454 */   // GIR_Coverage, 3081,
     /* 100454 */   GIR_EraseRootFromParent_Done,
     /* 100455 */ // Label 1363: @100455
     /* 100455 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(100513), // Rule ID 8347 //
     /* 100460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 100463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100478 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100489 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 100492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100511 */   GIR_RootConstrainSelectedInstOperands,
     /* 100512 */   // GIR_Coverage, 8347,
     /* 100512 */   GIR_EraseRootFromParent_Done,
     /* 100513 */ // Label 1364: @100513
     /* 100513 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(100571), // Rule ID 8348 //
     /* 100518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 100521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100524 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100536 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100547 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 100550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100569 */   GIR_RootConstrainSelectedInstOperands,
     /* 100570 */   // GIR_Coverage, 8348,
     /* 100570 */   GIR_EraseRootFromParent_Done,
     /* 100571 */ // Label 1365: @100571
     /* 100571 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(100632), // Rule ID 8349 //
     /* 100576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100594 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100605 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100630 */   GIR_RootConstrainSelectedInstOperands,
     /* 100631 */   // GIR_Coverage, 8349,
     /* 100631 */   GIR_EraseRootFromParent_Done,
     /* 100632 */ // Label 1366: @100632
     /* 100632 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(100700), // Rule ID 8061 //
     /* 100637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 100640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100647 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100652 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100665 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 100669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100676 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100694 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100698 */   GIR_RootConstrainSelectedInstOperands,
     /* 100699 */   // GIR_Coverage, 8061,
     /* 100699 */   GIR_EraseRootFromParent_Done,
     /* 100700 */ // Label 1367: @100700
     /* 100700 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(100768), // Rule ID 8065 //
     /* 100705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 100708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100715 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100720 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100733 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 100737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100744 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100766 */   GIR_RootConstrainSelectedInstOperands,
     /* 100767 */   // GIR_Coverage, 8065,
     /* 100767 */   GIR_EraseRootFromParent_Done,
     /* 100768 */ // Label 1368: @100768
     /* 100768 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(100831), // Rule ID 7993 //
     /* 100773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100783 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100788 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 100792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100807 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100829 */   GIR_RootConstrainSelectedInstOperands,
     /* 100830 */   // GIR_Coverage, 7993,
     /* 100830 */   GIR_EraseRootFromParent_Done,
     /* 100831 */ // Label 1369: @100831
     /* 100831 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(100894), // Rule ID 7997 //
     /* 100836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100846 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100851 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 100855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100870 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100892 */   GIR_RootConstrainSelectedInstOperands,
     /* 100893 */   // GIR_Coverage, 7997,
     /* 100893 */   GIR_EraseRootFromParent_Done,
     /* 100894 */ // Label 1370: @100894
     /* 100894 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(100949), // Rule ID 3050 //
     /* 100899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100914 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100925 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 100928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100947 */   GIR_RootConstrainSelectedInstOperands,
     /* 100948 */   // GIR_Coverage, 3050,
     /* 100948 */   GIR_EraseRootFromParent_Done,
     /* 100949 */ // Label 1371: @100949
     /* 100949 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(101007), // Rule ID 3051 //
     /* 100954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 100957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100972 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100976 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 100983 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 100986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101005 */   GIR_RootConstrainSelectedInstOperands,
     /* 101006 */   // GIR_Coverage, 3051,
     /* 101006 */   GIR_EraseRootFromParent_Done,
     /* 101007 */ // Label 1372: @101007
     /* 101007 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(101065), // Rule ID 3052 //
     /* 101012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 101015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101030 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101041 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 101041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 101044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101063 */   GIR_RootConstrainSelectedInstOperands,
     /* 101064 */   // GIR_Coverage, 3052,
     /* 101064 */   GIR_EraseRootFromParent_Done,
     /* 101065 */ // Label 1373: @101065
     /* 101065 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(101126), // Rule ID 3053 //
     /* 101070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 101073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101088 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101092 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101099 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 101102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101124 */   GIR_RootConstrainSelectedInstOperands,
     /* 101125 */   // GIR_Coverage, 3053,
     /* 101125 */   GIR_EraseRootFromParent_Done,
     /* 101126 */ // Label 1374: @101126
     /* 101126 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(101181), // Rule ID 3084 //
     /* 101131 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101134 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101146 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 101157 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101179 */   GIR_RootConstrainSelectedInstOperands,
     /* 101180 */   // GIR_Coverage, 3084,
     /* 101180 */   GIR_EraseRootFromParent_Done,
     /* 101181 */ // Label 1375: @101181
     /* 101181 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(101239), // Rule ID 3085 //
     /* 101186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 101189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101204 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 101215 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 101218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101237 */   GIR_RootConstrainSelectedInstOperands,
     /* 101238 */   // GIR_Coverage, 3085,
     /* 101238 */   GIR_EraseRootFromParent_Done,
     /* 101239 */ // Label 1376: @101239
     /* 101239 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(101297), // Rule ID 3086 //
     /* 101244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 101247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101262 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101273 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 101273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 101276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101295 */   GIR_RootConstrainSelectedInstOperands,
     /* 101296 */   // GIR_Coverage, 3086,
     /* 101296 */   GIR_EraseRootFromParent_Done,
     /* 101297 */ // Label 1377: @101297
     /* 101297 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(101358), // Rule ID 3087 //
     /* 101302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 101305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101320 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101331 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 101334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101356 */   GIR_RootConstrainSelectedInstOperands,
     /* 101357 */   // GIR_Coverage, 3087,
     /* 101357 */   GIR_EraseRootFromParent_Done,
     /* 101358 */ // Label 1378: @101358
     /* 101358 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(101413), // Rule ID 8352 //
     /* 101363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101378 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 101389 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101411 */   GIR_RootConstrainSelectedInstOperands,
     /* 101412 */   // GIR_Coverage, 8352,
     /* 101412 */   GIR_EraseRootFromParent_Done,
     /* 101413 */ // Label 1379: @101413
     /* 101413 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(101471), // Rule ID 8353 //
     /* 101418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 101421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101436 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 101447 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 101450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101469 */   GIR_RootConstrainSelectedInstOperands,
     /* 101470 */   // GIR_Coverage, 8353,
     /* 101470 */   GIR_EraseRootFromParent_Done,
     /* 101471 */ // Label 1380: @101471
     /* 101471 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(101529), // Rule ID 8354 //
     /* 101476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 101479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101494 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101505 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 101505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 101508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101527 */   GIR_RootConstrainSelectedInstOperands,
     /* 101528 */   // GIR_Coverage, 8354,
     /* 101528 */   GIR_EraseRootFromParent_Done,
     /* 101529 */ // Label 1381: @101529
     /* 101529 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(101590), // Rule ID 8355 //
     /* 101534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 101537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101548 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101552 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101563 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 101566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101588 */   GIR_RootConstrainSelectedInstOperands,
     /* 101589 */   // GIR_Coverage, 8355,
     /* 101589 */   GIR_EraseRootFromParent_Done,
     /* 101590 */ // Label 1382: @101590
     /* 101590 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(101654), // Rule ID 8062 //
     /* 101595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 101598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101601 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101606 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101619 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 101623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101630 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101652 */   GIR_RootConstrainSelectedInstOperands,
     /* 101653 */   // GIR_Coverage, 8062,
     /* 101653 */   GIR_EraseRootFromParent_Done,
     /* 101654 */ // Label 1383: @101654
     /* 101654 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(101718), // Rule ID 8066 //
     /* 101659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 101662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101665 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101670 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101683 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 101687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101694 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101716 */   GIR_RootConstrainSelectedInstOperands,
     /* 101717 */   // GIR_Coverage, 8066,
     /* 101717 */   GIR_EraseRootFromParent_Done,
     /* 101718 */ // Label 1384: @101718
     /* 101718 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(101777), // Rule ID 7994 //
     /* 101723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 101726 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101729 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101734 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 101738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101753 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101775 */   GIR_RootConstrainSelectedInstOperands,
     /* 101776 */   // GIR_Coverage, 7994,
     /* 101776 */   GIR_EraseRootFromParent_Done,
     /* 101777 */ // Label 1385: @101777
     /* 101777 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(101836), // Rule ID 7998 //
     /* 101782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 101785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101788 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101793 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 101797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101812 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101834 */   GIR_RootConstrainSelectedInstOperands,
     /* 101835 */   // GIR_Coverage, 7998,
     /* 101835 */   GIR_EraseRootFromParent_Done,
     /* 101836 */ // Label 1386: @101836
     /* 101836 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(101890), // Rule ID 3044 //
     /* 101841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101855 */   // MIs[0] sbase
     /* 101855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101863 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101867 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101871 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101876 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101888 */   GIR_RootConstrainSelectedInstOperands,
     /* 101889 */   // GIR_Coverage, 3044,
     /* 101889 */   GIR_EraseRootFromParent_Done,
     /* 101890 */ // Label 1387: @101890
     /* 101890 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(101944), // Rule ID 3078 //
     /* 101895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101909 */   // MIs[0] sbase
     /* 101909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101917 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101921 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101925 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101930 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101942 */   GIR_RootConstrainSelectedInstOperands,
     /* 101943 */   // GIR_Coverage, 3078,
     /* 101943 */   GIR_EraseRootFromParent_Done,
     /* 101944 */ // Label 1388: @101944
     /* 101944 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(101998), // Rule ID 8346 //
     /* 101949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101963 */   // MIs[0] sbase
     /* 101963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101971 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101975 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101979 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101984 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101996 */   GIR_RootConstrainSelectedInstOperands,
     /* 101997 */   // GIR_Coverage, 8346,
     /* 101997 */   GIR_EraseRootFromParent_Done,
     /* 101998 */ // Label 1389: @101998
     /* 101998 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(102048), // Rule ID 3049 //
     /* 102003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 102006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102009 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102017 */   // MIs[0] sbase
     /* 102017 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102025 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102029 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 102032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102034 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102046 */   GIR_RootConstrainSelectedInstOperands,
     /* 102047 */   // GIR_Coverage, 3049,
     /* 102047 */   GIR_EraseRootFromParent_Done,
     /* 102048 */ // Label 1390: @102048
     /* 102048 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(102098), // Rule ID 3083 //
     /* 102053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 102056 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102059 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102067 */   // MIs[0] sbase
     /* 102067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102075 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102079 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 102082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102084 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102096 */   GIR_RootConstrainSelectedInstOperands,
     /* 102097 */   // GIR_Coverage, 3083,
     /* 102097 */   GIR_EraseRootFromParent_Done,
     /* 102098 */ // Label 1391: @102098
     /* 102098 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(102148), // Rule ID 8351 //
     /* 102103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 102106 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102109 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102117 */   // MIs[0] sbase
     /* 102117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102125 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102129 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 102132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102134 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102146 */   GIR_RootConstrainSelectedInstOperands,
     /* 102147 */   // GIR_Coverage, 8351,
     /* 102147 */   GIR_EraseRootFromParent_Done,
     /* 102148 */ // Label 1392: @102148
     /* 102148 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(102195), // Rule ID 3055 //
     /* 102153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102164 */   // MIs[0] sbase
     /* 102164 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102172 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102176 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 102179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102181 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102193 */   GIR_RootConstrainSelectedInstOperands,
     /* 102194 */   // GIR_Coverage, 3055,
     /* 102194 */   GIR_EraseRootFromParent_Done,
     /* 102195 */ // Label 1393: @102195
     /* 102195 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(102242), // Rule ID 3089 //
     /* 102200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102203 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102211 */   // MIs[0] sbase
     /* 102211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102219 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102223 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 102226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102228 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102240 */   GIR_RootConstrainSelectedInstOperands,
     /* 102241 */   // GIR_Coverage, 3089,
     /* 102241 */   GIR_EraseRootFromParent_Done,
     /* 102242 */ // Label 1394: @102242
     /* 102242 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(102289), // Rule ID 8357 //
     /* 102247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102258 */   // MIs[0] sbase
     /* 102258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102266 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102270 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 102273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102275 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102287 */   GIR_RootConstrainSelectedInstOperands,
     /* 102288 */   // GIR_Coverage, 8357,
     /* 102288 */   GIR_EraseRootFromParent_Done,
     /* 102289 */ // Label 1395: @102289
     /* 102289 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(102349), // Rule ID 4293 //
     /* 102294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 102297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102300 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 102320 */   // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 102323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 102335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102347 */   GIR_RootConstrainSelectedInstOperands,
     /* 102348 */   // GIR_Coverage, 4293,
     /* 102348 */   GIR_EraseRootFromParent_Done,
     /* 102349 */ // Label 1396: @102349
     /* 102349 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(102409), // Rule ID 4299 //
     /* 102354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 102357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102360 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 102380 */   // (ld:{ *:[f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 102383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 102395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102407 */   GIR_RootConstrainSelectedInstOperands,
     /* 102408 */   // GIR_Coverage, 4299,
     /* 102408 */   GIR_EraseRootFromParent_Done,
     /* 102409 */ // Label 1397: @102409
     /* 102409 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(102464), // Rule ID 4292 //
     /* 102414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102420 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 102440 */   // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 102440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 102443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 102450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102462 */   GIR_RootConstrainSelectedInstOperands,
     /* 102463 */   // GIR_Coverage, 4292,
     /* 102463 */   GIR_EraseRootFromParent_Done,
     /* 102464 */ // Label 1398: @102464
     /* 102464 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(102519), // Rule ID 4298 //
     /* 102469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102472 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102475 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102488 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 102495 */   // (ld:{ *:[f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 102495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 102498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 102505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102517 */   GIR_RootConstrainSelectedInstOperands,
     /* 102518 */   // GIR_Coverage, 4298,
     /* 102518 */   GIR_EraseRootFromParent_Done,
     /* 102519 */ // Label 1399: @102519
     /* 102519 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(102574), // Rule ID 4291 //
     /* 102524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102530 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 102550 */   // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 102553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102568 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102572 */   GIR_RootConstrainSelectedInstOperands,
     /* 102573 */   // GIR_Coverage, 4291,
     /* 102573 */   GIR_EraseRootFromParent_Done,
     /* 102574 */ // Label 1400: @102574
     /* 102574 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(102629), // Rule ID 4297 //
     /* 102579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102582 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102585 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 102605 */   // (ld:{ *:[f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 102608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102627 */   GIR_RootConstrainSelectedInstOperands,
     /* 102628 */   // GIR_Coverage, 4297,
     /* 102628 */   GIR_EraseRootFromParent_Done,
     /* 102629 */ // Label 1401: @102629
     /* 102629 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(102706), // Rule ID 6420 //
     /* 102634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 102637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102647 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102669 */   // (atomic_load:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 102669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102704 */   GIR_RootConstrainSelectedInstOperands,
     /* 102705 */   // GIR_Coverage, 6420,
     /* 102705 */   GIR_EraseRootFromParent_Done,
     /* 102706 */ // Label 1402: @102706
     /* 102706 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(102776), // Rule ID 4527 //
     /* 102711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 102714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102717 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102739 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102774 */   GIR_RootConstrainSelectedInstOperands,
     /* 102775 */   // GIR_Coverage, 4527,
     /* 102775 */   GIR_EraseRootFromParent_Done,
     /* 102776 */ // Label 1403: @102776
     /* 102776 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(102843), // Rule ID 4529 //
     /* 102781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102784 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102806 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 102809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102841 */   GIR_RootConstrainSelectedInstOperands,
     /* 102842 */   // GIR_Coverage, 4529,
     /* 102842 */   GIR_EraseRootFromParent_Done,
     /* 102843 */ // Label 1404: @102843
     /* 102843 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(102913), // Rule ID 4531 //
     /* 102848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 102851 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102854 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102865 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102876 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102911 */   GIR_RootConstrainSelectedInstOperands,
     /* 102912 */   // GIR_Coverage, 4531,
     /* 102912 */   GIR_EraseRootFromParent_Done,
     /* 102913 */ // Label 1405: @102913
     /* 102913 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(102980), // Rule ID 4533 //
     /* 102918 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102921 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102943 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 102946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102978 */   GIR_RootConstrainSelectedInstOperands,
     /* 102979 */   // GIR_Coverage, 4533,
     /* 102979 */   GIR_EraseRootFromParent_Done,
     /* 102980 */ // Label 1406: @102980
     /* 102980 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(103044), // Rule ID 7933 //
     /* 102985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 102988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102995 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103015 */   // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 103018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103042 */   GIR_RootConstrainSelectedInstOperands,
     /* 103043 */   // GIR_Coverage, 7933,
     /* 103043 */   GIR_EraseRootFromParent_Done,
     /* 103044 */ // Label 1407: @103044
     /* 103044 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(103108), // Rule ID 7941 //
     /* 103049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 103052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103055 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103059 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103079 */   // (AMDGPUld_glue:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 103082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103106 */   GIR_RootConstrainSelectedInstOperands,
     /* 103107 */   // GIR_Coverage, 7941,
     /* 103107 */   GIR_EraseRootFromParent_Done,
     /* 103108 */ // Label 1408: @103108
     /* 103108 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(103173), // Rule ID 4526 //
     /* 103113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 103116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103119 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103141 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 103144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103171 */   GIR_RootConstrainSelectedInstOperands,
     /* 103172 */   // GIR_Coverage, 4526,
     /* 103172 */   GIR_EraseRootFromParent_Done,
     /* 103173 */ // Label 1409: @103173
     /* 103173 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(103235), // Rule ID 4528 //
     /* 103178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103181 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103203 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 103206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103233 */   GIR_RootConstrainSelectedInstOperands,
     /* 103234 */   // GIR_Coverage, 4528,
     /* 103234 */   GIR_EraseRootFromParent_Done,
     /* 103235 */ // Label 1410: @103235
     /* 103235 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(103300), // Rule ID 4530 //
     /* 103240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 103243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103246 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103268 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 103271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103298 */   GIR_RootConstrainSelectedInstOperands,
     /* 103299 */   // GIR_Coverage, 4530,
     /* 103299 */   GIR_EraseRootFromParent_Done,
     /* 103300 */ // Label 1411: @103300
     /* 103300 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(103362), // Rule ID 4532 //
     /* 103305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103308 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103330 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 103333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103360 */   GIR_RootConstrainSelectedInstOperands,
     /* 103361 */   // GIR_Coverage, 4532,
     /* 103361 */   GIR_EraseRootFromParent_Done,
     /* 103362 */ // Label 1412: @103362
     /* 103362 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(103422), // Rule ID 7935 //
     /* 103367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103373 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103393 */   // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 103396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103420 */   GIR_RootConstrainSelectedInstOperands,
     /* 103421 */   // GIR_Coverage, 7935,
     /* 103421 */   GIR_EraseRootFromParent_Done,
     /* 103422 */ // Label 1413: @103422
     /* 103422 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(103482), // Rule ID 7943 //
     /* 103427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103430 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103433 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103453 */   // (ld:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 103456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103480 */   GIR_RootConstrainSelectedInstOperands,
     /* 103481 */   // GIR_Coverage, 7943,
     /* 103481 */   GIR_EraseRootFromParent_Done,
     /* 103482 */ // Label 1414: @103482
     /* 103482 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(103544), // Rule ID 7873 //
     /* 103487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 103490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103500 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103509 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103513 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 103520 */   // (AMDGPUatomic_ld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64_glue>><<P:Predicate_atomic_load_64_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 103520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 103523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103542 */   GIR_RootConstrainSelectedInstOperands,
     /* 103543 */   // GIR_Coverage, 7873,
     /* 103543 */   GIR_EraseRootFromParent_Done,
     /* 103544 */ // Label 1415: @103544
     /* 103544 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(103606), // Rule ID 7874 //
     /* 103549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103562 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 103582 */   // (atomic_load:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 103582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 103585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103604 */   GIR_RootConstrainSelectedInstOperands,
     /* 103605 */   // GIR_Coverage, 7874,
     /* 103605 */   GIR_EraseRootFromParent_Done,
     /* 103606 */ // Label 1416: @103606
     /* 103606 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(103675), // Rule ID 3956 //
     /* 103611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103614 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103624 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103639 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103646 */   // (atomic_load:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103673 */   GIR_RootConstrainSelectedInstOperands,
     /* 103674 */   // GIR_Coverage, 3956,
     /* 103674 */   GIR_EraseRootFromParent_Done,
     /* 103675 */ // Label 1417: @103675
     /* 103675 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(103737), // Rule ID 3892 //
     /* 103680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103686 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103708 */   // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103731 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103735 */   GIR_RootConstrainSelectedInstOperands,
     /* 103736 */   // GIR_Coverage, 3892,
     /* 103736 */   GIR_EraseRootFromParent_Done,
     /* 103737 */ // Label 1418: @103737
     /* 103737 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(103799), // Rule ID 3896 //
     /* 103742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103748 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103770 */   // (ld:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103797 */   GIR_RootConstrainSelectedInstOperands,
     /* 103798 */   // GIR_Coverage, 3896,
     /* 103798 */   GIR_EraseRootFromParent_Done,
     /* 103799 */ // Label 1419: @103799
     /* 103799 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(103863), // Rule ID 3955 //
     /* 103804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103807 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103817 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103839 */   // (atomic_load:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103861 */   GIR_RootConstrainSelectedInstOperands,
     /* 103862 */   // GIR_Coverage, 3955,
     /* 103862 */   GIR_EraseRootFromParent_Done,
     /* 103863 */ // Label 1420: @103863
     /* 103863 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(103920), // Rule ID 3891 //
     /* 103868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103874 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103896 */   // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103914 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103918 */   GIR_RootConstrainSelectedInstOperands,
     /* 103919 */   // GIR_Coverage, 3891,
     /* 103919 */   GIR_EraseRootFromParent_Done,
     /* 103920 */ // Label 1421: @103920
     /* 103920 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(103977), // Rule ID 3895 //
     /* 103925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103931 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103953 */   // (ld:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103975 */   GIR_RootConstrainSelectedInstOperands,
     /* 103976 */   // GIR_Coverage, 3895,
     /* 103976 */   GIR_EraseRootFromParent_Done,
     /* 103977 */ // Label 1422: @103977
     /* 103977 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(104042), // Rule ID 3609 //
     /* 103982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 103985 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103988 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103995 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 104003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 104018 */   // (atomic_load:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 104018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 104021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 104028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104040 */   GIR_RootConstrainSelectedInstOperands,
     /* 104041 */   // GIR_Coverage, 3609,
     /* 104041 */   GIR_EraseRootFromParent_Done,
     /* 104042 */ // Label 1423: @104042
     /* 104042 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(104100), // Rule ID 3629 //
     /* 104047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 104050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104053 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 104061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 104076 */   // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 104076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 104079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 104086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104098 */   GIR_RootConstrainSelectedInstOperands,
     /* 104099 */   // GIR_Coverage, 3629,
     /* 104099 */   GIR_EraseRootFromParent_Done,
     /* 104100 */ // Label 1424: @104100
     /* 104100 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(104158), // Rule ID 3631 //
     /* 104105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 104108 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 104119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 104134 */   // (ld:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 104134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 104137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 104144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104156 */   GIR_RootConstrainSelectedInstOperands,
     /* 104157 */   // GIR_Coverage, 3631,
     /* 104157 */   GIR_EraseRootFromParent_Done,
     /* 104158 */ // Label 1425: @104158
     /* 104158 */ GIM_Reject,
     /* 104159 */ // Label 890: @104159
     /* 104159 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(107402),
     /* 104164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104167 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(104231), // Rule ID 2954 //
     /* 104172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104202 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104229 */     GIR_RootConstrainSelectedInstOperands,
     /* 104230 */     // GIR_Coverage, 2954,
     /* 104230 */     GIR_EraseRootFromParent_Done,
     /* 104231 */   // Label 1427: @104231
     /* 104231 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(104295), // Rule ID 2966 //
     /* 104236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104266 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104293 */     GIR_RootConstrainSelectedInstOperands,
     /* 104294 */     // GIR_Coverage, 2966,
     /* 104294 */     GIR_EraseRootFromParent_Done,
     /* 104295 */   // Label 1428: @104295
     /* 104295 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(104355), // Rule ID 2960 //
     /* 104300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104326 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104353 */     GIR_RootConstrainSelectedInstOperands,
     /* 104354 */     // GIR_Coverage, 2960,
     /* 104354 */     GIR_EraseRootFromParent_Done,
     /* 104355 */   // Label 1429: @104355
     /* 104355 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(104415), // Rule ID 2972 //
     /* 104360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104386 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104413 */     GIR_RootConstrainSelectedInstOperands,
     /* 104414 */     // GIR_Coverage, 2972,
     /* 104414 */     GIR_EraseRootFromParent_Done,
     /* 104415 */   // Label 1430: @104415
     /* 104415 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(104474), // Rule ID 2950 //
     /* 104420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 104423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104450 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104472 */     GIR_RootConstrainSelectedInstOperands,
     /* 104473 */     // GIR_Coverage, 2950,
     /* 104473 */     GIR_EraseRootFromParent_Done,
     /* 104474 */   // Label 1431: @104474
     /* 104474 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(104533), // Rule ID 2951 //
     /* 104479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 104482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104509 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104531 */     GIR_RootConstrainSelectedInstOperands,
     /* 104532 */     // GIR_Coverage, 2951,
     /* 104532 */     GIR_EraseRootFromParent_Done,
     /* 104533 */   // Label 1432: @104533
     /* 104533 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(104592), // Rule ID 2952 //
     /* 104538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 104541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104568 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 104571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104590 */     GIR_RootConstrainSelectedInstOperands,
     /* 104591 */     // GIR_Coverage, 2952,
     /* 104591 */     GIR_EraseRootFromParent_Done,
     /* 104592 */   // Label 1433: @104592
     /* 104592 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(104654), // Rule ID 2953 //
     /* 104597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104600 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104627 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104652 */     GIR_RootConstrainSelectedInstOperands,
     /* 104653 */     // GIR_Coverage, 2953,
     /* 104653 */     GIR_EraseRootFromParent_Done,
     /* 104654 */   // Label 1434: @104654
     /* 104654 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(104713), // Rule ID 2962 //
     /* 104659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 104662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104689 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104711 */     GIR_RootConstrainSelectedInstOperands,
     /* 104712 */     // GIR_Coverage, 2962,
     /* 104712 */     GIR_EraseRootFromParent_Done,
     /* 104713 */   // Label 1435: @104713
     /* 104713 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(104772), // Rule ID 2963 //
     /* 104718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 104721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104748 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104770 */     GIR_RootConstrainSelectedInstOperands,
     /* 104771 */     // GIR_Coverage, 2963,
     /* 104771 */     GIR_EraseRootFromParent_Done,
     /* 104772 */   // Label 1436: @104772
     /* 104772 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(104831), // Rule ID 2964 //
     /* 104777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 104780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104807 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 104810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104829 */     GIR_RootConstrainSelectedInstOperands,
     /* 104830 */     // GIR_Coverage, 2964,
     /* 104830 */     GIR_EraseRootFromParent_Done,
     /* 104831 */   // Label 1437: @104831
     /* 104831 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(104893), // Rule ID 2965 //
     /* 104836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104866 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104891 */     GIR_RootConstrainSelectedInstOperands,
     /* 104892 */     // GIR_Coverage, 2965,
     /* 104892 */     GIR_EraseRootFromParent_Done,
     /* 104893 */   // Label 1438: @104893
     /* 104893 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(104945), // Rule ID 2956 //
     /* 104898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104921 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104943 */     GIR_RootConstrainSelectedInstOperands,
     /* 104944 */     // GIR_Coverage, 2956,
     /* 104944 */     GIR_EraseRootFromParent_Done,
     /* 104945 */   // Label 1439: @104945
     /* 104945 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(105000), // Rule ID 2957 //
     /* 104950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104976 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104998 */     GIR_RootConstrainSelectedInstOperands,
     /* 104999 */     // GIR_Coverage, 2957,
     /* 104999 */     GIR_EraseRootFromParent_Done,
     /* 105000 */   // Label 1440: @105000
     /* 105000 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(105055), // Rule ID 2958 //
     /* 105005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 105008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105031 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 105031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 105034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105053 */     GIR_RootConstrainSelectedInstOperands,
     /* 105054 */     // GIR_Coverage, 2958,
     /* 105054 */     GIR_EraseRootFromParent_Done,
     /* 105055 */   // Label 1441: @105055
     /* 105055 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(105113), // Rule ID 2959 //
     /* 105060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 105063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105086 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 105089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105111 */     GIR_RootConstrainSelectedInstOperands,
     /* 105112 */     // GIR_Coverage, 2959,
     /* 105112 */     GIR_EraseRootFromParent_Done,
     /* 105113 */   // Label 1442: @105113
     /* 105113 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(105165), // Rule ID 2968 //
     /* 105118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 105141 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105163 */     GIR_RootConstrainSelectedInstOperands,
     /* 105164 */     // GIR_Coverage, 2968,
     /* 105164 */     GIR_EraseRootFromParent_Done,
     /* 105165 */   // Label 1443: @105165
     /* 105165 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(105220), // Rule ID 2969 //
     /* 105170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 105173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 105196 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 105199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105218 */     GIR_RootConstrainSelectedInstOperands,
     /* 105219 */     // GIR_Coverage, 2969,
     /* 105219 */     GIR_EraseRootFromParent_Done,
     /* 105220 */   // Label 1444: @105220
     /* 105220 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(105275), // Rule ID 2970 //
     /* 105225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 105228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105251 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 105251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 105254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105273 */     GIR_RootConstrainSelectedInstOperands,
     /* 105274 */     // GIR_Coverage, 2970,
     /* 105274 */     GIR_EraseRootFromParent_Done,
     /* 105275 */   // Label 1445: @105275
     /* 105275 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(105333), // Rule ID 2971 //
     /* 105280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 105283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105306 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 105309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105331 */     GIR_RootConstrainSelectedInstOperands,
     /* 105332 */     // GIR_Coverage, 2971,
     /* 105332 */     GIR_EraseRootFromParent_Done,
     /* 105333 */   // Label 1446: @105333
     /* 105333 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(105384), // Rule ID 2955 //
     /* 105338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105349 */     // MIs[0] sbase
     /* 105349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105365 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105370 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105382 */     GIR_RootConstrainSelectedInstOperands,
     /* 105383 */     // GIR_Coverage, 2955,
     /* 105383 */     GIR_EraseRootFromParent_Done,
     /* 105384 */   // Label 1447: @105384
     /* 105384 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(105435), // Rule ID 2967 //
     /* 105389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105400 */     // MIs[0] sbase
     /* 105400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105416 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105421 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105433 */     GIR_RootConstrainSelectedInstOperands,
     /* 105434 */     // GIR_Coverage, 2967,
     /* 105434 */     GIR_EraseRootFromParent_Done,
     /* 105435 */   // Label 1448: @105435
     /* 105435 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(105479), // Rule ID 2961 //
     /* 105440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105448 */     // MIs[0] sbase
     /* 105448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105460 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105465 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105477 */     GIR_RootConstrainSelectedInstOperands,
     /* 105478 */     // GIR_Coverage, 2961,
     /* 105478 */     GIR_EraseRootFromParent_Done,
     /* 105479 */   // Label 1449: @105479
     /* 105479 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(105523), // Rule ID 2973 //
     /* 105484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105492 */     // MIs[0] sbase
     /* 105492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105504 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105509 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105521 */     GIR_RootConstrainSelectedInstOperands,
     /* 105522 */     // GIR_Coverage, 2973,
     /* 105522 */     GIR_EraseRootFromParent_Done,
     /* 105523 */   // Label 1450: @105523
     /* 105523 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(105583), // Rule ID 6487 //
     /* 105528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 105531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105551 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 105554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105581 */     GIR_RootConstrainSelectedInstOperands,
     /* 105582 */     // GIR_Coverage, 6487,
     /* 105582 */     GIR_EraseRootFromParent_Done,
     /* 105583 */   // Label 1451: @105583
     /* 105583 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(105643), // Rule ID 6489 //
     /* 105588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 105591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105611 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 105614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105641 */     GIR_RootConstrainSelectedInstOperands,
     /* 105642 */     // GIR_Coverage, 6489,
     /* 105642 */     GIR_EraseRootFromParent_Done,
     /* 105643 */   // Label 1452: @105643
     /* 105643 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(105703), // Rule ID 6491 //
     /* 105648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 105651 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105671 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 105674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105701 */     GIR_RootConstrainSelectedInstOperands,
     /* 105702 */     // GIR_Coverage, 6491,
     /* 105702 */     GIR_EraseRootFromParent_Done,
     /* 105703 */   // Label 1453: @105703
     /* 105703 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(105763), // Rule ID 6493 //
     /* 105708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 105711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105731 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 105734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105761 */     GIR_RootConstrainSelectedInstOperands,
     /* 105762 */     // GIR_Coverage, 6493,
     /* 105762 */     GIR_EraseRootFromParent_Done,
     /* 105763 */   // Label 1454: @105763
     /* 105763 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(105820), // Rule ID 4257 //
     /* 105768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105791 */     // (ld:{ *:[v2i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 105794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105818 */     GIR_RootConstrainSelectedInstOperands,
     /* 105819 */     // GIR_Coverage, 4257,
     /* 105819 */     GIR_EraseRootFromParent_Done,
     /* 105820 */   // Label 1455: @105820
     /* 105820 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(105877), // Rule ID 4263 //
     /* 105825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105848 */     // (ld:{ *:[v2f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 105851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105875 */     GIR_RootConstrainSelectedInstOperands,
     /* 105876 */     // GIR_Coverage, 4263,
     /* 105876 */     GIR_EraseRootFromParent_Done,
     /* 105877 */   // Label 1456: @105877
     /* 105877 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(105929), // Rule ID 4256 //
     /* 105882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105885 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 105905 */     // (ld:{ *:[v2i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 105905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 105908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 105915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105927 */     GIR_RootConstrainSelectedInstOperands,
     /* 105928 */     // GIR_Coverage, 4256,
     /* 105928 */     GIR_EraseRootFromParent_Done,
     /* 105929 */   // Label 1457: @105929
     /* 105929 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(105981), // Rule ID 4262 //
     /* 105934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105937 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 105957 */     // (ld:{ *:[v2f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 105957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 105960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 105967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105979 */     GIR_RootConstrainSelectedInstOperands,
     /* 105980 */     // GIR_Coverage, 4262,
     /* 105980 */     GIR_EraseRootFromParent_Done,
     /* 105981 */   // Label 1458: @105981
     /* 105981 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(106033), // Rule ID 4255 //
     /* 105986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105989 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 106009 */     // (ld:{ *:[v2i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 106009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 106012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 106019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106031 */     GIR_RootConstrainSelectedInstOperands,
     /* 106032 */     // GIR_Coverage, 4255,
     /* 106032 */     GIR_EraseRootFromParent_Done,
     /* 106033 */   // Label 1459: @106033
     /* 106033 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(106085), // Rule ID 4261 //
     /* 106038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 106041 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 106061 */     // (ld:{ *:[v2f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 106061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 106064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 106071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106083 */     GIR_RootConstrainSelectedInstOperands,
     /* 106084 */     // GIR_Coverage, 4261,
     /* 106084 */     GIR_EraseRootFromParent_Done,
     /* 106085 */   // Label 1460: @106085
     /* 106085 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(106152), // Rule ID 4503 //
     /* 106090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106093 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106115 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 106118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106150 */     GIR_RootConstrainSelectedInstOperands,
     /* 106151 */     // GIR_Coverage, 4503,
     /* 106151 */     GIR_EraseRootFromParent_Done,
     /* 106152 */   // Label 1461: @106152
     /* 106152 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(106216), // Rule ID 4505 //
     /* 106157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106179 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 106182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106214 */     GIR_RootConstrainSelectedInstOperands,
     /* 106215 */     // GIR_Coverage, 4505,
     /* 106215 */     GIR_EraseRootFromParent_Done,
     /* 106216 */   // Label 1462: @106216
     /* 106216 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(106283), // Rule ID 4507 //
     /* 106221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106246 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 106249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106281 */     GIR_RootConstrainSelectedInstOperands,
     /* 106282 */     // GIR_Coverage, 4507,
     /* 106282 */     GIR_EraseRootFromParent_Done,
     /* 106283 */   // Label 1463: @106283
     /* 106283 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(106347), // Rule ID 4509 //
     /* 106288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106310 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 106313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106345 */     GIR_RootConstrainSelectedInstOperands,
     /* 106346 */     // GIR_Coverage, 4509,
     /* 106346 */     GIR_EraseRootFromParent_Done,
     /* 106347 */   // Label 1464: @106347
     /* 106347 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(106412), // Rule ID 6486 //
     /* 106352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 106355 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106375 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 106378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106410 */     GIR_RootConstrainSelectedInstOperands,
     /* 106411 */     // GIR_Coverage, 6486,
     /* 106411 */     GIR_EraseRootFromParent_Done,
     /* 106412 */   // Label 1465: @106412
     /* 106412 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(106477), // Rule ID 6488 //
     /* 106417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 106420 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106440 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 106443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106475 */     GIR_RootConstrainSelectedInstOperands,
     /* 106476 */     // GIR_Coverage, 6488,
     /* 106476 */     GIR_EraseRootFromParent_Done,
     /* 106477 */   // Label 1466: @106477
     /* 106477 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(106542), // Rule ID 6490 //
     /* 106482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 106485 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106505 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 106508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106540 */     GIR_RootConstrainSelectedInstOperands,
     /* 106541 */     // GIR_Coverage, 6490,
     /* 106541 */     GIR_EraseRootFromParent_Done,
     /* 106542 */   // Label 1467: @106542
     /* 106542 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(106607), // Rule ID 6492 //
     /* 106547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 106550 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106570 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 106573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106605 */     GIR_RootConstrainSelectedInstOperands,
     /* 106606 */     // GIR_Coverage, 6492,
     /* 106606 */     GIR_EraseRootFromParent_Done,
     /* 106607 */   // Label 1468: @106607
     /* 106607 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(106669), // Rule ID 4502 //
     /* 106612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106637 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 106640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106667 */     GIR_RootConstrainSelectedInstOperands,
     /* 106668 */     // GIR_Coverage, 4502,
     /* 106668 */     GIR_EraseRootFromParent_Done,
     /* 106669 */   // Label 1469: @106669
     /* 106669 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(106728), // Rule ID 4504 //
     /* 106674 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106696 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 106699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106726 */     GIR_RootConstrainSelectedInstOperands,
     /* 106727 */     // GIR_Coverage, 4504,
     /* 106727 */     GIR_EraseRootFromParent_Done,
     /* 106728 */   // Label 1470: @106728
     /* 106728 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(106790), // Rule ID 4506 //
     /* 106733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106758 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 106761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106788 */     GIR_RootConstrainSelectedInstOperands,
     /* 106789 */     // GIR_Coverage, 4506,
     /* 106789 */     GIR_EraseRootFromParent_Done,
     /* 106790 */   // Label 1471: @106790
     /* 106790 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(106849), // Rule ID 4508 //
     /* 106795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106817 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 106820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106847 */     GIR_RootConstrainSelectedInstOperands,
     /* 106848 */     // GIR_Coverage, 4508,
     /* 106848 */     GIR_EraseRootFromParent_Done,
     /* 106849 */   // Label 1472: @106849
     /* 106849 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(106905), // Rule ID 7831 //
     /* 106854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 106857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106881 */     // (AMDGPUld_glue:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 106884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106903 */     GIR_RootConstrainSelectedInstOperands,
     /* 106904 */     // GIR_Coverage, 7831,
     /* 106904 */     GIR_EraseRootFromParent_Done,
     /* 106905 */   // Label 1473: @106905
     /* 106905 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(106961), // Rule ID 7833 //
     /* 106910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 106913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106917 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106937 */     // (AMDGPUld_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 106940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106959 */     GIR_RootConstrainSelectedInstOperands,
     /* 106960 */     // GIR_Coverage, 7833,
     /* 106960 */     GIR_EraseRootFromParent_Done,
     /* 106961 */   // Label 1474: @106961
     /* 106961 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(107013), // Rule ID 7832 //
     /* 106966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 106969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106989 */     // (ld:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 106992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107011 */     GIR_RootConstrainSelectedInstOperands,
     /* 107012 */     // GIR_Coverage, 7832,
     /* 107012 */     GIR_EraseRootFromParent_Done,
     /* 107013 */   // Label 1475: @107013
     /* 107013 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(107065), // Rule ID 7834 //
     /* 107018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 107021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 107026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 107041 */     // (ld:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 107041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 107044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 107051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107063 */     GIR_RootConstrainSelectedInstOperands,
     /* 107064 */     // GIR_Coverage, 7834,
     /* 107064 */     GIR_EraseRootFromParent_Done,
     /* 107065 */   // Label 1476: @107065
     /* 107065 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(107124), // Rule ID 3868 //
     /* 107070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 107095 */     // (ld:{ *:[v2i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 107098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 107105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 107110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107122 */     GIR_RootConstrainSelectedInstOperands,
     /* 107123 */     // GIR_Coverage, 3868,
     /* 107123 */     GIR_EraseRootFromParent_Done,
     /* 107124 */   // Label 1477: @107124
     /* 107124 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(107183), // Rule ID 3872 //
     /* 107129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107132 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 107154 */     // (ld:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 107157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 107164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 107169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107181 */     GIR_RootConstrainSelectedInstOperands,
     /* 107182 */     // GIR_Coverage, 3872,
     /* 107182 */     GIR_EraseRootFromParent_Done,
     /* 107183 */   // Label 1478: @107183
     /* 107183 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(107237), // Rule ID 3867 //
     /* 107188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107213 */     // (ld:{ *:[v2i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 107216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107235 */     GIR_RootConstrainSelectedInstOperands,
     /* 107236 */     // GIR_Coverage, 3867,
     /* 107236 */     GIR_EraseRootFromParent_Done,
     /* 107237 */   // Label 1479: @107237
     /* 107237 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(107291), // Rule ID 3871 //
     /* 107242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107267 */     // (ld:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 107270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107289 */     GIR_RootConstrainSelectedInstOperands,
     /* 107290 */     // GIR_Coverage, 3871,
     /* 107290 */     GIR_EraseRootFromParent_Done,
     /* 107291 */   // Label 1480: @107291
     /* 107291 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(107346), // Rule ID 3616 //
     /* 107296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107322 */     // (ld:{ *:[v2i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 107325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107344 */     GIR_RootConstrainSelectedInstOperands,
     /* 107345 */     // GIR_Coverage, 3616,
     /* 107345 */     GIR_EraseRootFromParent_Done,
     /* 107346 */   // Label 1481: @107346
     /* 107346 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(107401), // Rule ID 3618 //
     /* 107351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107354 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107377 */     // (ld:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 107380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107399 */     GIR_RootConstrainSelectedInstOperands,
     /* 107400 */     // GIR_Coverage, 3618,
     /* 107400 */     GIR_EraseRootFromParent_Done,
     /* 107401 */   // Label 1482: @107401
     /* 107401 */   GIM_Reject,
     /* 107402 */ // Label 1426: @107402
     /* 107402 */ GIM_Reject,
     /* 107403 */ // Label 891: @107403
     /* 107403 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(111450),
     /* 107408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107411 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(107475), // Rule ID 3026 //
     /* 107416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107446 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107473 */     GIR_RootConstrainSelectedInstOperands,
     /* 107474 */     // GIR_Coverage, 3026,
     /* 107474 */     GIR_EraseRootFromParent_Done,
     /* 107475 */   // Label 1484: @107475
     /* 107475 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(107539), // Rule ID 3060 //
     /* 107480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107510 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107537 */     GIR_RootConstrainSelectedInstOperands,
     /* 107538 */     // GIR_Coverage, 3060,
     /* 107538 */     GIR_EraseRootFromParent_Done,
     /* 107539 */   // Label 1485: @107539
     /* 107539 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(107599), // Rule ID 3031 //
     /* 107544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107570 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 107573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107597 */     GIR_RootConstrainSelectedInstOperands,
     /* 107598 */     // GIR_Coverage, 3031,
     /* 107598 */     GIR_EraseRootFromParent_Done,
     /* 107599 */   // Label 1486: @107599
     /* 107599 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(107659), // Rule ID 3065 //
     /* 107604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107630 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 107633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107657 */     GIR_RootConstrainSelectedInstOperands,
     /* 107658 */     // GIR_Coverage, 3065,
     /* 107658 */     GIR_EraseRootFromParent_Done,
     /* 107659 */   // Label 1487: @107659
     /* 107659 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(107719), // Rule ID 3037 //
     /* 107664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107690 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107717 */     GIR_RootConstrainSelectedInstOperands,
     /* 107718 */     // GIR_Coverage, 3037,
     /* 107718 */     GIR_EraseRootFromParent_Done,
     /* 107719 */   // Label 1488: @107719
     /* 107719 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(107779), // Rule ID 3071 //
     /* 107724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107750 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107777 */     GIR_RootConstrainSelectedInstOperands,
     /* 107778 */     // GIR_Coverage, 3071,
     /* 107778 */     GIR_EraseRootFromParent_Done,
     /* 107779 */   // Label 1489: @107779
     /* 107779 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(107838), // Rule ID 3022 //
     /* 107784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 107787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 107814 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 107817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107836 */     GIR_RootConstrainSelectedInstOperands,
     /* 107837 */     // GIR_Coverage, 3022,
     /* 107837 */     GIR_EraseRootFromParent_Done,
     /* 107838 */   // Label 1490: @107838
     /* 107838 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(107897), // Rule ID 3023 //
     /* 107843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 107846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 107873 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 107876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107895 */     GIR_RootConstrainSelectedInstOperands,
     /* 107896 */     // GIR_Coverage, 3023,
     /* 107896 */     GIR_EraseRootFromParent_Done,
     /* 107897 */   // Label 1491: @107897
     /* 107897 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(107956), // Rule ID 3024 //
     /* 107902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 107905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107932 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 107932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 107935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107954 */     GIR_RootConstrainSelectedInstOperands,
     /* 107955 */     // GIR_Coverage, 3024,
     /* 107955 */     GIR_EraseRootFromParent_Done,
     /* 107956 */   // Label 1492: @107956
     /* 107956 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(108018), // Rule ID 3025 //
     /* 107961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107964 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107991 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 107991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108016 */     GIR_RootConstrainSelectedInstOperands,
     /* 108017 */     // GIR_Coverage, 3025,
     /* 108017 */     GIR_EraseRootFromParent_Done,
     /* 108018 */   // Label 1493: @108018
     /* 108018 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(108077), // Rule ID 3056 //
     /* 108023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108053 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 108056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108075 */     GIR_RootConstrainSelectedInstOperands,
     /* 108076 */     // GIR_Coverage, 3056,
     /* 108076 */     GIR_EraseRootFromParent_Done,
     /* 108077 */   // Label 1494: @108077
     /* 108077 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(108136), // Rule ID 3057 //
     /* 108082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 108085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108112 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 108115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108134 */     GIR_RootConstrainSelectedInstOperands,
     /* 108135 */     // GIR_Coverage, 3057,
     /* 108135 */     GIR_EraseRootFromParent_Done,
     /* 108136 */   // Label 1495: @108136
     /* 108136 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(108195), // Rule ID 3058 //
     /* 108141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108171 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 108174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108193 */     GIR_RootConstrainSelectedInstOperands,
     /* 108194 */     // GIR_Coverage, 3058,
     /* 108194 */     GIR_EraseRootFromParent_Done,
     /* 108195 */   // Label 1496: @108195
     /* 108195 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(108257), // Rule ID 3059 //
     /* 108200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108230 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 108233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108255 */     GIR_RootConstrainSelectedInstOperands,
     /* 108256 */     // GIR_Coverage, 3059,
     /* 108256 */     GIR_EraseRootFromParent_Done,
     /* 108257 */   // Label 1497: @108257
     /* 108257 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(108312), // Rule ID 3028 //
     /* 108262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108288 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 108291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108310 */     GIR_RootConstrainSelectedInstOperands,
     /* 108311 */     // GIR_Coverage, 3028,
     /* 108311 */     GIR_EraseRootFromParent_Done,
     /* 108312 */   // Label 1498: @108312
     /* 108312 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(108367), // Rule ID 3029 //
     /* 108317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108343 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 108346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108365 */     GIR_RootConstrainSelectedInstOperands,
     /* 108366 */     // GIR_Coverage, 3029,
     /* 108366 */     GIR_EraseRootFromParent_Done,
     /* 108367 */   // Label 1499: @108367
     /* 108367 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(108425), // Rule ID 3030 //
     /* 108372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108398 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 108401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108423 */     GIR_RootConstrainSelectedInstOperands,
     /* 108424 */     // GIR_Coverage, 3030,
     /* 108424 */     GIR_EraseRootFromParent_Done,
     /* 108425 */   // Label 1500: @108425
     /* 108425 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(108480), // Rule ID 3062 //
     /* 108430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108456 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 108459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108478 */     GIR_RootConstrainSelectedInstOperands,
     /* 108479 */     // GIR_Coverage, 3062,
     /* 108479 */     GIR_EraseRootFromParent_Done,
     /* 108480 */   // Label 1501: @108480
     /* 108480 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(108535), // Rule ID 3063 //
     /* 108485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108511 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 108514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108533 */     GIR_RootConstrainSelectedInstOperands,
     /* 108534 */     // GIR_Coverage, 3063,
     /* 108534 */     GIR_EraseRootFromParent_Done,
     /* 108535 */   // Label 1502: @108535
     /* 108535 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(108593), // Rule ID 3064 //
     /* 108540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108566 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 108569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108591 */     GIR_RootConstrainSelectedInstOperands,
     /* 108592 */     // GIR_Coverage, 3064,
     /* 108592 */     GIR_EraseRootFromParent_Done,
     /* 108593 */   // Label 1503: @108593
     /* 108593 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(108658), // Rule ID 8069 //
     /* 108598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 108601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108605 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108610 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 108627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108634 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108656 */     GIR_RootConstrainSelectedInstOperands,
     /* 108657 */     // GIR_Coverage, 8069,
     /* 108657 */     GIR_EraseRootFromParent_Done,
     /* 108658 */   // Label 1504: @108658
     /* 108658 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(108723), // Rule ID 8073 //
     /* 108663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 108666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108675 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 108692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108699 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108721 */     GIR_RootConstrainSelectedInstOperands,
     /* 108722 */     // GIR_Coverage, 8073,
     /* 108722 */     GIR_EraseRootFromParent_Done,
     /* 108723 */   // Label 1505: @108723
     /* 108723 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(108783), // Rule ID 8001 //
     /* 108728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 108731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108740 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 108744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108759 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108781 */     GIR_RootConstrainSelectedInstOperands,
     /* 108782 */     // GIR_Coverage, 8001,
     /* 108782 */     GIR_EraseRootFromParent_Done,
     /* 108783 */   // Label 1506: @108783
     /* 108783 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(108843), // Rule ID 8005 //
     /* 108788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 108791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108800 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 108804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108819 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108841 */     GIR_RootConstrainSelectedInstOperands,
     /* 108842 */     // GIR_Coverage, 8005,
     /* 108842 */     GIR_EraseRootFromParent_Done,
     /* 108843 */   // Label 1507: @108843
     /* 108843 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(108895), // Rule ID 3033 //
     /* 108848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108871 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 108874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108893 */     GIR_RootConstrainSelectedInstOperands,
     /* 108894 */     // GIR_Coverage, 3033,
     /* 108894 */     GIR_EraseRootFromParent_Done,
     /* 108895 */   // Label 1508: @108895
     /* 108895 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(108950), // Rule ID 3034 //
     /* 108900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 108903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108926 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 108929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108948 */     GIR_RootConstrainSelectedInstOperands,
     /* 108949 */     // GIR_Coverage, 3034,
     /* 108949 */     GIR_EraseRootFromParent_Done,
     /* 108950 */   // Label 1509: @108950
     /* 108950 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(109005), // Rule ID 3035 //
     /* 108955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 108958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108981 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 108984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109003 */     GIR_RootConstrainSelectedInstOperands,
     /* 109004 */     // GIR_Coverage, 3035,
     /* 109004 */     GIR_EraseRootFromParent_Done,
     /* 109005 */   // Label 1510: @109005
     /* 109005 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(109063), // Rule ID 3036 //
     /* 109010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 109013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 109036 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 109039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109061 */     GIR_RootConstrainSelectedInstOperands,
     /* 109062 */     // GIR_Coverage, 3036,
     /* 109062 */     GIR_EraseRootFromParent_Done,
     /* 109063 */   // Label 1511: @109063
     /* 109063 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(109115), // Rule ID 3067 //
     /* 109068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 109091 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109113 */     GIR_RootConstrainSelectedInstOperands,
     /* 109114 */     // GIR_Coverage, 3067,
     /* 109114 */     GIR_EraseRootFromParent_Done,
     /* 109115 */   // Label 1512: @109115
     /* 109115 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(109170), // Rule ID 3068 //
     /* 109120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 109123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 109146 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 109149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109168 */     GIR_RootConstrainSelectedInstOperands,
     /* 109169 */     // GIR_Coverage, 3068,
     /* 109169 */     GIR_EraseRootFromParent_Done,
     /* 109170 */   // Label 1513: @109170
     /* 109170 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(109225), // Rule ID 3069 //
     /* 109175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 109178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 109201 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 109201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 109204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109223 */     GIR_RootConstrainSelectedInstOperands,
     /* 109224 */     // GIR_Coverage, 3069,
     /* 109224 */     GIR_EraseRootFromParent_Done,
     /* 109225 */   // Label 1514: @109225
     /* 109225 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(109283), // Rule ID 3070 //
     /* 109230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 109233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 109256 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 109259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109281 */     GIR_RootConstrainSelectedInstOperands,
     /* 109282 */     // GIR_Coverage, 3070,
     /* 109282 */     GIR_EraseRootFromParent_Done,
     /* 109283 */   // Label 1515: @109283
     /* 109283 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(109344), // Rule ID 8070 //
     /* 109288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 109291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109296 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 109313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109320 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109342 */     GIR_RootConstrainSelectedInstOperands,
     /* 109343 */     // GIR_Coverage, 8070,
     /* 109343 */     GIR_EraseRootFromParent_Done,
     /* 109344 */   // Label 1516: @109344
     /* 109344 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(109405), // Rule ID 8074 //
     /* 109349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 109352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109357 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 109374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109381 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109403 */     GIR_RootConstrainSelectedInstOperands,
     /* 109404 */     // GIR_Coverage, 8074,
     /* 109404 */     GIR_EraseRootFromParent_Done,
     /* 109405 */   // Label 1517: @109405
     /* 109405 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(109461), // Rule ID 8002 //
     /* 109410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 109413 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109418 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 109422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109437 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109459 */     GIR_RootConstrainSelectedInstOperands,
     /* 109460 */     // GIR_Coverage, 8002,
     /* 109460 */     GIR_EraseRootFromParent_Done,
     /* 109461 */   // Label 1518: @109461
     /* 109461 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(109517), // Rule ID 8006 //
     /* 109466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 109469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109474 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 109478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109493 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109515 */     GIR_RootConstrainSelectedInstOperands,
     /* 109516 */     // GIR_Coverage, 8006,
     /* 109516 */     GIR_EraseRootFromParent_Done,
     /* 109517 */   // Label 1519: @109517
     /* 109517 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(109568), // Rule ID 3027 //
     /* 109522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109533 */     // MIs[0] sbase
     /* 109533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 109549 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109554 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109566 */     GIR_RootConstrainSelectedInstOperands,
     /* 109567 */     // GIR_Coverage, 3027,
     /* 109567 */     GIR_EraseRootFromParent_Done,
     /* 109568 */   // Label 1520: @109568
     /* 109568 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(109619), // Rule ID 3061 //
     /* 109573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109584 */     // MIs[0] sbase
     /* 109584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 109600 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109605 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109617 */     GIR_RootConstrainSelectedInstOperands,
     /* 109618 */     // GIR_Coverage, 3061,
     /* 109618 */     GIR_EraseRootFromParent_Done,
     /* 109619 */   // Label 1521: @109619
     /* 109619 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(109666), // Rule ID 3032 //
     /* 109624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109635 */     // MIs[0] sbase
     /* 109635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109647 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 109650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109652 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109664 */     GIR_RootConstrainSelectedInstOperands,
     /* 109665 */     // GIR_Coverage, 3032,
     /* 109665 */     GIR_EraseRootFromParent_Done,
     /* 109666 */   // Label 1522: @109666
     /* 109666 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(109713), // Rule ID 3066 //
     /* 109671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109682 */     // MIs[0] sbase
     /* 109682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109694 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 109697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109699 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109711 */     GIR_RootConstrainSelectedInstOperands,
     /* 109712 */     // GIR_Coverage, 3066,
     /* 109712 */     GIR_EraseRootFromParent_Done,
     /* 109713 */   // Label 1523: @109713
     /* 109713 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(109757), // Rule ID 3038 //
     /* 109718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109726 */     // MIs[0] sbase
     /* 109726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109738 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109743 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109755 */     GIR_RootConstrainSelectedInstOperands,
     /* 109756 */     // GIR_Coverage, 3038,
     /* 109756 */     GIR_EraseRootFromParent_Done,
     /* 109757 */   // Label 1524: @109757
     /* 109757 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(109801), // Rule ID 3072 //
     /* 109762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109770 */     // MIs[0] sbase
     /* 109770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109782 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109787 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109799 */     GIR_RootConstrainSelectedInstOperands,
     /* 109800 */     // GIR_Coverage, 3072,
     /* 109800 */     GIR_EraseRootFromParent_Done,
     /* 109801 */   // Label 1525: @109801
     /* 109801 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(109861), // Rule ID 6511 //
     /* 109806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 109809 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109829 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 109832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109859 */     GIR_RootConstrainSelectedInstOperands,
     /* 109860 */     // GIR_Coverage, 6511,
     /* 109860 */     GIR_EraseRootFromParent_Done,
     /* 109861 */   // Label 1526: @109861
     /* 109861 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(109921), // Rule ID 6513 //
     /* 109866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 109869 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109889 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 109892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109919 */     GIR_RootConstrainSelectedInstOperands,
     /* 109920 */     // GIR_Coverage, 6513,
     /* 109920 */     GIR_EraseRootFromParent_Done,
     /* 109921 */   // Label 1527: @109921
     /* 109921 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(109978), // Rule ID 4305 //
     /* 109926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109929 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 109949 */     // (ld:{ *:[v2i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 109952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 109964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109976 */     GIR_RootConstrainSelectedInstOperands,
     /* 109977 */     // GIR_Coverage, 4305,
     /* 109977 */     GIR_EraseRootFromParent_Done,
     /* 109978 */   // Label 1528: @109978
     /* 109978 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(110035), // Rule ID 4311 //
     /* 109983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109986 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 110006 */     // (ld:{ *:[v2f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 110009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 110021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110033 */     GIR_RootConstrainSelectedInstOperands,
     /* 110034 */     // GIR_Coverage, 4311,
     /* 110034 */     GIR_EraseRootFromParent_Done,
     /* 110035 */   // Label 1529: @110035
     /* 110035 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(110087), // Rule ID 4304 //
     /* 110040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 110043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 110063 */     // (ld:{ *:[v2i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 110063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 110066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110085 */     GIR_RootConstrainSelectedInstOperands,
     /* 110086 */     // GIR_Coverage, 4304,
     /* 110086 */     GIR_EraseRootFromParent_Done,
     /* 110087 */   // Label 1530: @110087
     /* 110087 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(110139), // Rule ID 4310 //
     /* 110092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 110095 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 110115 */     // (ld:{ *:[v2f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 110115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 110118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110137 */     GIR_RootConstrainSelectedInstOperands,
     /* 110138 */     // GIR_Coverage, 4310,
     /* 110138 */     GIR_EraseRootFromParent_Done,
     /* 110139 */   // Label 1531: @110139
     /* 110139 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(110191), // Rule ID 4303 //
     /* 110144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 110147 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 110167 */     // (ld:{ *:[v2i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 110170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110189 */     GIR_RootConstrainSelectedInstOperands,
     /* 110190 */     // GIR_Coverage, 4303,
     /* 110190 */     GIR_EraseRootFromParent_Done,
     /* 110191 */   // Label 1532: @110191
     /* 110191 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(110243), // Rule ID 4309 //
     /* 110196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 110199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 110219 */     // (ld:{ *:[v2f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 110222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110241 */     GIR_RootConstrainSelectedInstOperands,
     /* 110242 */     // GIR_Coverage, 4309,
     /* 110242 */     GIR_EraseRootFromParent_Done,
     /* 110243 */   // Label 1533: @110243
     /* 110243 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(110310), // Rule ID 4535 //
     /* 110248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110251 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110273 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 110276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110308 */     GIR_RootConstrainSelectedInstOperands,
     /* 110309 */     // GIR_Coverage, 4535,
     /* 110309 */     GIR_EraseRootFromParent_Done,
     /* 110310 */   // Label 1534: @110310
     /* 110310 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(110374), // Rule ID 4537 //
     /* 110315 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110337 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 110340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110372 */     GIR_RootConstrainSelectedInstOperands,
     /* 110373 */     // GIR_Coverage, 4537,
     /* 110373 */     GIR_EraseRootFromParent_Done,
     /* 110374 */   // Label 1535: @110374
     /* 110374 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(110441), // Rule ID 4539 //
     /* 110379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110404 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 110407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110439 */     GIR_RootConstrainSelectedInstOperands,
     /* 110440 */     // GIR_Coverage, 4539,
     /* 110440 */     GIR_EraseRootFromParent_Done,
     /* 110441 */   // Label 1536: @110441
     /* 110441 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(110505), // Rule ID 4541 //
     /* 110446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110468 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 110471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110503 */     GIR_RootConstrainSelectedInstOperands,
     /* 110504 */     // GIR_Coverage, 4541,
     /* 110504 */     GIR_EraseRootFromParent_Done,
     /* 110505 */   // Label 1537: @110505
     /* 110505 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(110570), // Rule ID 6510 //
     /* 110510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 110513 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110533 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 110536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110568 */     GIR_RootConstrainSelectedInstOperands,
     /* 110569 */     // GIR_Coverage, 6510,
     /* 110569 */     GIR_EraseRootFromParent_Done,
     /* 110570 */   // Label 1538: @110570
     /* 110570 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(110635), // Rule ID 6512 //
     /* 110575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 110578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110598 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 110601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110633 */     GIR_RootConstrainSelectedInstOperands,
     /* 110634 */     // GIR_Coverage, 6512,
     /* 110634 */     GIR_EraseRootFromParent_Done,
     /* 110635 */   // Label 1539: @110635
     /* 110635 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(110696), // Rule ID 7945 //
     /* 110640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 110643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110667 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 110670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110694 */     GIR_RootConstrainSelectedInstOperands,
     /* 110695 */     // GIR_Coverage, 7945,
     /* 110695 */     GIR_EraseRootFromParent_Done,
     /* 110696 */   // Label 1540: @110696
     /* 110696 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(110757), // Rule ID 7949 //
     /* 110701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 110704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110708 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110728 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 110731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110755 */     GIR_RootConstrainSelectedInstOperands,
     /* 110756 */     // GIR_Coverage, 7949,
     /* 110756 */     GIR_EraseRootFromParent_Done,
     /* 110757 */   // Label 1541: @110757
     /* 110757 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(110819), // Rule ID 4534 //
     /* 110762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110787 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 110790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110817 */     GIR_RootConstrainSelectedInstOperands,
     /* 110818 */     // GIR_Coverage, 4534,
     /* 110818 */     GIR_EraseRootFromParent_Done,
     /* 110819 */   // Label 1542: @110819
     /* 110819 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(110878), // Rule ID 4536 //
     /* 110824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110846 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 110849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110876 */     GIR_RootConstrainSelectedInstOperands,
     /* 110877 */     // GIR_Coverage, 4536,
     /* 110877 */     GIR_EraseRootFromParent_Done,
     /* 110878 */   // Label 1543: @110878
     /* 110878 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(110940), // Rule ID 4538 //
     /* 110883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110886 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110908 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 110911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110938 */     GIR_RootConstrainSelectedInstOperands,
     /* 110939 */     // GIR_Coverage, 4538,
     /* 110939 */     GIR_EraseRootFromParent_Done,
     /* 110940 */   // Label 1544: @110940
     /* 110940 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(110999), // Rule ID 4540 //
     /* 110945 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110967 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 110970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110997 */     GIR_RootConstrainSelectedInstOperands,
     /* 110998 */     // GIR_Coverage, 4540,
     /* 110998 */     GIR_EraseRootFromParent_Done,
     /* 110999 */   // Label 1545: @110999
     /* 110999 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(111056), // Rule ID 7947 //
     /* 111004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 111007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 111012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 111027 */     // (ld:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 111027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 111030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 111037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 111042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 111047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111054 */     GIR_RootConstrainSelectedInstOperands,
     /* 111055 */     // GIR_Coverage, 7947,
     /* 111055 */     GIR_EraseRootFromParent_Done,
     /* 111056 */   // Label 1546: @111056
     /* 111056 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(111113), // Rule ID 7951 //
     /* 111061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 111064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 111069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 111084 */     // (ld:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 111084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 111087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 111094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 111099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 111104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111111 */     GIR_RootConstrainSelectedInstOperands,
     /* 111112 */     // GIR_Coverage, 7951,
     /* 111112 */     GIR_EraseRootFromParent_Done,
     /* 111113 */   // Label 1547: @111113
     /* 111113 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(111172), // Rule ID 3900 //
     /* 111118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 111143 */     // (ld:{ *:[v2i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 111146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 111153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 111158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111170 */     GIR_RootConstrainSelectedInstOperands,
     /* 111171 */     // GIR_Coverage, 3900,
     /* 111171 */     GIR_EraseRootFromParent_Done,
     /* 111172 */   // Label 1548: @111172
     /* 111172 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(111231), // Rule ID 3904 //
     /* 111177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 111202 */     // (ld:{ *:[v2f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 111205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 111212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 111217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111229 */     GIR_RootConstrainSelectedInstOperands,
     /* 111230 */     // GIR_Coverage, 3904,
     /* 111230 */     GIR_EraseRootFromParent_Done,
     /* 111231 */   // Label 1549: @111231
     /* 111231 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(111285), // Rule ID 3899 //
     /* 111236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111239 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 111261 */     // (ld:{ *:[v2i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 111264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111283 */     GIR_RootConstrainSelectedInstOperands,
     /* 111284 */     // GIR_Coverage, 3899,
     /* 111284 */     GIR_EraseRootFromParent_Done,
     /* 111285 */   // Label 1550: @111285
     /* 111285 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(111339), // Rule ID 3903 //
     /* 111290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 111315 */     // (ld:{ *:[v2f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 111318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111337 */     GIR_RootConstrainSelectedInstOperands,
     /* 111338 */     // GIR_Coverage, 3903,
     /* 111338 */     GIR_EraseRootFromParent_Done,
     /* 111339 */   // Label 1551: @111339
     /* 111339 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(111394), // Rule ID 3633 //
     /* 111344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 111347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 111370 */     // (ld:{ *:[v2i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 111373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111392 */     GIR_RootConstrainSelectedInstOperands,
     /* 111393 */     // GIR_Coverage, 3633,
     /* 111393 */     GIR_EraseRootFromParent_Done,
     /* 111394 */   // Label 1552: @111394
     /* 111394 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(111449), // Rule ID 3635 //
     /* 111399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 111402 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 111425 */     // (ld:{ *:[v2f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 111428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111447 */     GIR_RootConstrainSelectedInstOperands,
     /* 111448 */     // GIR_Coverage, 3635,
     /* 111448 */     GIR_EraseRootFromParent_Done,
     /* 111449 */   // Label 1553: @111449
     /* 111449 */   GIM_Reject,
     /* 111450 */ // Label 1483: @111450
     /* 111450 */ GIM_Reject,
     /* 111451 */ // Label 892: @111451
     /* 111451 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(115248),
     /* 111456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111459 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(111523), // Rule ID 3204 //
     /* 111464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111494 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111521 */     GIR_RootConstrainSelectedInstOperands,
     /* 111522 */     // GIR_Coverage, 3204,
     /* 111522 */     GIR_EraseRootFromParent_Done,
     /* 111523 */   // Label 1555: @111523
     /* 111523 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(111587), // Rule ID 3221 //
     /* 111528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111558 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111585 */     GIR_RootConstrainSelectedInstOperands,
     /* 111586 */     // GIR_Coverage, 3221,
     /* 111586 */     GIR_EraseRootFromParent_Done,
     /* 111587 */   // Label 1556: @111587
     /* 111587 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(111647), // Rule ID 3209 //
     /* 111592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111618 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 111621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111645 */     GIR_RootConstrainSelectedInstOperands,
     /* 111646 */     // GIR_Coverage, 3209,
     /* 111646 */     GIR_EraseRootFromParent_Done,
     /* 111647 */   // Label 1557: @111647
     /* 111647 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(111707), // Rule ID 3226 //
     /* 111652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111678 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 111681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111705 */     GIR_RootConstrainSelectedInstOperands,
     /* 111706 */     // GIR_Coverage, 3226,
     /* 111706 */     GIR_EraseRootFromParent_Done,
     /* 111707 */   // Label 1558: @111707
     /* 111707 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(111767), // Rule ID 3215 //
     /* 111712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111738 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111765 */     GIR_RootConstrainSelectedInstOperands,
     /* 111766 */     // GIR_Coverage, 3215,
     /* 111766 */     GIR_EraseRootFromParent_Done,
     /* 111767 */   // Label 1559: @111767
     /* 111767 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(111827), // Rule ID 3232 //
     /* 111772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111798 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111825 */     GIR_RootConstrainSelectedInstOperands,
     /* 111826 */     // GIR_Coverage, 3232,
     /* 111826 */     GIR_EraseRootFromParent_Done,
     /* 111827 */   // Label 1560: @111827
     /* 111827 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(111886), // Rule ID 3200 //
     /* 111832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111862 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 111865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111884 */     GIR_RootConstrainSelectedInstOperands,
     /* 111885 */     // GIR_Coverage, 3200,
     /* 111885 */     GIR_EraseRootFromParent_Done,
     /* 111886 */   // Label 1561: @111886
     /* 111886 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(111945), // Rule ID 3201 //
     /* 111891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 111894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 111921 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 111924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111943 */     GIR_RootConstrainSelectedInstOperands,
     /* 111944 */     // GIR_Coverage, 3201,
     /* 111944 */     GIR_EraseRootFromParent_Done,
     /* 111945 */   // Label 1562: @111945
     /* 111945 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(112004), // Rule ID 3202 //
     /* 111950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111980 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 111983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112002 */     GIR_RootConstrainSelectedInstOperands,
     /* 112003 */     // GIR_Coverage, 3202,
     /* 112003 */     GIR_EraseRootFromParent_Done,
     /* 112004 */   // Label 1563: @112004
     /* 112004 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(112066), // Rule ID 3203 //
     /* 112009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112039 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 112042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112064 */     GIR_RootConstrainSelectedInstOperands,
     /* 112065 */     // GIR_Coverage, 3203,
     /* 112065 */     GIR_EraseRootFromParent_Done,
     /* 112066 */   // Label 1564: @112066
     /* 112066 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(112125), // Rule ID 3217 //
     /* 112071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 112074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112101 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 112104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112123 */     GIR_RootConstrainSelectedInstOperands,
     /* 112124 */     // GIR_Coverage, 3217,
     /* 112124 */     GIR_EraseRootFromParent_Done,
     /* 112125 */   // Label 1565: @112125
     /* 112125 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(112184), // Rule ID 3218 //
     /* 112130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 112133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112160 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 112163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112182 */     GIR_RootConstrainSelectedInstOperands,
     /* 112183 */     // GIR_Coverage, 3218,
     /* 112183 */     GIR_EraseRootFromParent_Done,
     /* 112184 */   // Label 1566: @112184
     /* 112184 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(112243), // Rule ID 3219 //
     /* 112189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112219 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 112222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112241 */     GIR_RootConstrainSelectedInstOperands,
     /* 112242 */     // GIR_Coverage, 3219,
     /* 112242 */     GIR_EraseRootFromParent_Done,
     /* 112243 */   // Label 1567: @112243
     /* 112243 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(112305), // Rule ID 3220 //
     /* 112248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112278 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 112281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112303 */     GIR_RootConstrainSelectedInstOperands,
     /* 112304 */     // GIR_Coverage, 3220,
     /* 112304 */     GIR_EraseRootFromParent_Done,
     /* 112305 */   // Label 1568: @112305
     /* 112305 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(112360), // Rule ID 3206 //
     /* 112310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 112313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112336 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 112339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112358 */     GIR_RootConstrainSelectedInstOperands,
     /* 112359 */     // GIR_Coverage, 3206,
     /* 112359 */     GIR_EraseRootFromParent_Done,
     /* 112360 */   // Label 1569: @112360
     /* 112360 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(112415), // Rule ID 3207 //
     /* 112365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112391 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 112394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112413 */     GIR_RootConstrainSelectedInstOperands,
     /* 112414 */     // GIR_Coverage, 3207,
     /* 112414 */     GIR_EraseRootFromParent_Done,
     /* 112415 */   // Label 1570: @112415
     /* 112415 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(112473), // Rule ID 3208 //
     /* 112420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112446 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 112449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112471 */     GIR_RootConstrainSelectedInstOperands,
     /* 112472 */     // GIR_Coverage, 3208,
     /* 112472 */     GIR_EraseRootFromParent_Done,
     /* 112473 */   // Label 1571: @112473
     /* 112473 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(112528), // Rule ID 3223 //
     /* 112478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 112481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112504 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 112507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112526 */     GIR_RootConstrainSelectedInstOperands,
     /* 112527 */     // GIR_Coverage, 3223,
     /* 112527 */     GIR_EraseRootFromParent_Done,
     /* 112528 */   // Label 1572: @112528
     /* 112528 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(112583), // Rule ID 3224 //
     /* 112533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112559 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 112562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112581 */     GIR_RootConstrainSelectedInstOperands,
     /* 112582 */     // GIR_Coverage, 3224,
     /* 112582 */     GIR_EraseRootFromParent_Done,
     /* 112583 */   // Label 1573: @112583
     /* 112583 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(112641), // Rule ID 3225 //
     /* 112588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112614 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 112617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112639 */     GIR_RootConstrainSelectedInstOperands,
     /* 112640 */     // GIR_Coverage, 3225,
     /* 112640 */     GIR_EraseRootFromParent_Done,
     /* 112641 */   // Label 1574: @112641
     /* 112641 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(112701), // Rule ID 8045 //
     /* 112646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 112649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112658 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 112662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112677 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112699 */     GIR_RootConstrainSelectedInstOperands,
     /* 112700 */     // GIR_Coverage, 8045,
     /* 112700 */     GIR_EraseRootFromParent_Done,
     /* 112701 */   // Label 1575: @112701
     /* 112701 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(112761), // Rule ID 8049 //
     /* 112706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 112709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112713 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112718 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 112722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112737 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112759 */     GIR_RootConstrainSelectedInstOperands,
     /* 112760 */     // GIR_Coverage, 8049,
     /* 112760 */     GIR_EraseRootFromParent_Done,
     /* 112761 */   // Label 1576: @112761
     /* 112761 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(112826), // Rule ID 8113 //
     /* 112766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112778 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112802 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112824 */     GIR_RootConstrainSelectedInstOperands,
     /* 112825 */     // GIR_Coverage, 8113,
     /* 112825 */     GIR_EraseRootFromParent_Done,
     /* 112826 */   // Label 1577: @112826
     /* 112826 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(112891), // Rule ID 8117 //
     /* 112831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112843 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112867 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112889 */     GIR_RootConstrainSelectedInstOperands,
     /* 112890 */     // GIR_Coverage, 8117,
     /* 112890 */     GIR_EraseRootFromParent_Done,
     /* 112891 */   // Label 1578: @112891
     /* 112891 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(112943), // Rule ID 3211 //
     /* 112896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112919 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 112922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112941 */     GIR_RootConstrainSelectedInstOperands,
     /* 112942 */     // GIR_Coverage, 3211,
     /* 112942 */     GIR_EraseRootFromParent_Done,
     /* 112943 */   // Label 1579: @112943
     /* 112943 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(112998), // Rule ID 3212 //
     /* 112948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 112951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112974 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 112977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112996 */     GIR_RootConstrainSelectedInstOperands,
     /* 112997 */     // GIR_Coverage, 3212,
     /* 112997 */     GIR_EraseRootFromParent_Done,
     /* 112998 */   // Label 1580: @112998
     /* 112998 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(113053), // Rule ID 3213 //
     /* 113003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 113006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113029 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 113029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 113032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113051 */     GIR_RootConstrainSelectedInstOperands,
     /* 113052 */     // GIR_Coverage, 3213,
     /* 113052 */     GIR_EraseRootFromParent_Done,
     /* 113053 */   // Label 1581: @113053
     /* 113053 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(113111), // Rule ID 3214 //
     /* 113058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 113061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113084 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 113087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113109 */     GIR_RootConstrainSelectedInstOperands,
     /* 113110 */     // GIR_Coverage, 3214,
     /* 113110 */     GIR_EraseRootFromParent_Done,
     /* 113111 */   // Label 1582: @113111
     /* 113111 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(113163), // Rule ID 3228 //
     /* 113116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 113139 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113161 */     GIR_RootConstrainSelectedInstOperands,
     /* 113162 */     // GIR_Coverage, 3228,
     /* 113162 */     GIR_EraseRootFromParent_Done,
     /* 113163 */   // Label 1583: @113163
     /* 113163 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(113218), // Rule ID 3229 //
     /* 113168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 113171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 113194 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 113197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113216 */     GIR_RootConstrainSelectedInstOperands,
     /* 113217 */     // GIR_Coverage, 3229,
     /* 113217 */     GIR_EraseRootFromParent_Done,
     /* 113218 */   // Label 1584: @113218
     /* 113218 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(113273), // Rule ID 3230 //
     /* 113223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 113226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113249 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 113249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 113252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113271 */     GIR_RootConstrainSelectedInstOperands,
     /* 113272 */     // GIR_Coverage, 3230,
     /* 113272 */     GIR_EraseRootFromParent_Done,
     /* 113273 */   // Label 1585: @113273
     /* 113273 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(113331), // Rule ID 3231 //
     /* 113278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 113281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113304 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 113307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113329 */     GIR_RootConstrainSelectedInstOperands,
     /* 113330 */     // GIR_Coverage, 3231,
     /* 113330 */     GIR_EraseRootFromParent_Done,
     /* 113331 */   // Label 1586: @113331
     /* 113331 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(113387), // Rule ID 8046 //
     /* 113336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 113339 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113344 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 113348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113363 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113385 */     GIR_RootConstrainSelectedInstOperands,
     /* 113386 */     // GIR_Coverage, 8046,
     /* 113386 */     GIR_EraseRootFromParent_Done,
     /* 113387 */   // Label 1587: @113387
     /* 113387 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(113443), // Rule ID 8050 //
     /* 113392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 113395 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113400 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 113404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113419 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113441 */     GIR_RootConstrainSelectedInstOperands,
     /* 113442 */     // GIR_Coverage, 8050,
     /* 113442 */     GIR_EraseRootFromParent_Done,
     /* 113443 */   // Label 1588: @113443
     /* 113443 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(113504), // Rule ID 8114 //
     /* 113448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 113451 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 113473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113480 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113502 */     GIR_RootConstrainSelectedInstOperands,
     /* 113503 */     // GIR_Coverage, 8114,
     /* 113503 */     GIR_EraseRootFromParent_Done,
     /* 113504 */   // Label 1589: @113504
     /* 113504 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(113565), // Rule ID 8118 //
     /* 113509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 113512 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 113534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113541 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113563 */     GIR_RootConstrainSelectedInstOperands,
     /* 113564 */     // GIR_Coverage, 8118,
     /* 113564 */     GIR_EraseRootFromParent_Done,
     /* 113565 */   // Label 1590: @113565
     /* 113565 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(113616), // Rule ID 3205 //
     /* 113570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113581 */     // MIs[0] sbase
     /* 113581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113597 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113602 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113614 */     GIR_RootConstrainSelectedInstOperands,
     /* 113615 */     // GIR_Coverage, 3205,
     /* 113615 */     GIR_EraseRootFromParent_Done,
     /* 113616 */   // Label 1591: @113616
     /* 113616 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(113667), // Rule ID 3222 //
     /* 113621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113632 */     // MIs[0] sbase
     /* 113632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113648 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113653 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113665 */     GIR_RootConstrainSelectedInstOperands,
     /* 113666 */     // GIR_Coverage, 3222,
     /* 113666 */     GIR_EraseRootFromParent_Done,
     /* 113667 */   // Label 1592: @113667
     /* 113667 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(113714), // Rule ID 3210 //
     /* 113672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113683 */     // MIs[0] sbase
     /* 113683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113695 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 113698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113700 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113712 */     GIR_RootConstrainSelectedInstOperands,
     /* 113713 */     // GIR_Coverage, 3210,
     /* 113713 */     GIR_EraseRootFromParent_Done,
     /* 113714 */   // Label 1593: @113714
     /* 113714 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(113761), // Rule ID 3227 //
     /* 113719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113730 */     // MIs[0] sbase
     /* 113730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113742 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 113745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113747 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113759 */     GIR_RootConstrainSelectedInstOperands,
     /* 113760 */     // GIR_Coverage, 3227,
     /* 113760 */     GIR_EraseRootFromParent_Done,
     /* 113761 */   // Label 1594: @113761
     /* 113761 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(113805), // Rule ID 3216 //
     /* 113766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113774 */     // MIs[0] sbase
     /* 113774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113786 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113791 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113803 */     GIR_RootConstrainSelectedInstOperands,
     /* 113804 */     // GIR_Coverage, 3216,
     /* 113804 */     GIR_EraseRootFromParent_Done,
     /* 113805 */   // Label 1595: @113805
     /* 113805 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(113849), // Rule ID 3233 //
     /* 113810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113818 */     // MIs[0] sbase
     /* 113818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113830 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113835 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113847 */     GIR_RootConstrainSelectedInstOperands,
     /* 113848 */     // GIR_Coverage, 3233,
     /* 113848 */     GIR_EraseRootFromParent_Done,
     /* 113849 */   // Label 1596: @113849
     /* 113849 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(113906), // Rule ID 4362 //
     /* 113854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113857 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113877 */     // (ld:{ *:[v2i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 113880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113904 */     GIR_RootConstrainSelectedInstOperands,
     /* 113905 */     // GIR_Coverage, 4362,
     /* 113905 */     GIR_EraseRootFromParent_Done,
     /* 113906 */   // Label 1597: @113906
     /* 113906 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(113963), // Rule ID 4368 //
     /* 113911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113914 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113934 */     // (ld:{ *:[v2f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 113937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113961 */     GIR_RootConstrainSelectedInstOperands,
     /* 113962 */     // GIR_Coverage, 4368,
     /* 113962 */     GIR_EraseRootFromParent_Done,
     /* 113963 */   // Label 1598: @113963
     /* 113963 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(114015), // Rule ID 4361 //
     /* 113968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 113991 */     // (ld:{ *:[v2i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 113991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 113994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114013 */     GIR_RootConstrainSelectedInstOperands,
     /* 114014 */     // GIR_Coverage, 4361,
     /* 114014 */     GIR_EraseRootFromParent_Done,
     /* 114015 */   // Label 1599: @114015
     /* 114015 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(114067), // Rule ID 4367 //
     /* 114020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 114023 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 114028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 114043 */     // (ld:{ *:[v2f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 114043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 114046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114065 */     GIR_RootConstrainSelectedInstOperands,
     /* 114066 */     // GIR_Coverage, 4367,
     /* 114066 */     GIR_EraseRootFromParent_Done,
     /* 114067 */   // Label 1600: @114067
     /* 114067 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(114119), // Rule ID 4360 //
     /* 114072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 114075 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 114080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 114095 */     // (ld:{ *:[v2i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 114098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114117 */     GIR_RootConstrainSelectedInstOperands,
     /* 114118 */     // GIR_Coverage, 4360,
     /* 114118 */     GIR_EraseRootFromParent_Done,
     /* 114119 */   // Label 1601: @114119
     /* 114119 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(114171), // Rule ID 4366 //
     /* 114124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 114127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 114132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 114147 */     // (ld:{ *:[v2f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 114150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114169 */     GIR_RootConstrainSelectedInstOperands,
     /* 114170 */     // GIR_Coverage, 4366,
     /* 114170 */     GIR_EraseRootFromParent_Done,
     /* 114171 */   // Label 1602: @114171
     /* 114171 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(114238), // Rule ID 4579 //
     /* 114176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114201 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 114204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114236 */     GIR_RootConstrainSelectedInstOperands,
     /* 114237 */     // GIR_Coverage, 4579,
     /* 114237 */     GIR_EraseRootFromParent_Done,
     /* 114238 */   // Label 1603: @114238
     /* 114238 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(114302), // Rule ID 4581 //
     /* 114243 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114265 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 114268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114300 */     GIR_RootConstrainSelectedInstOperands,
     /* 114301 */     // GIR_Coverage, 4581,
     /* 114301 */     GIR_EraseRootFromParent_Done,
     /* 114302 */   // Label 1604: @114302
     /* 114302 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(114369), // Rule ID 4583 //
     /* 114307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114310 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114332 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 114335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114367 */     GIR_RootConstrainSelectedInstOperands,
     /* 114368 */     // GIR_Coverage, 4583,
     /* 114368 */     GIR_EraseRootFromParent_Done,
     /* 114369 */   // Label 1605: @114369
     /* 114369 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(114433), // Rule ID 4585 //
     /* 114374 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114396 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 114399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114431 */     GIR_RootConstrainSelectedInstOperands,
     /* 114432 */     // GIR_Coverage, 4585,
     /* 114432 */     GIR_EraseRootFromParent_Done,
     /* 114433 */   // Label 1606: @114433
     /* 114433 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(114494), // Rule ID 7977 //
     /* 114438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114465 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 114468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114492 */     GIR_RootConstrainSelectedInstOperands,
     /* 114493 */     // GIR_Coverage, 7977,
     /* 114493 */     GIR_EraseRootFromParent_Done,
     /* 114494 */   // Label 1607: @114494
     /* 114494 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(114555), // Rule ID 7981 //
     /* 114499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114526 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 114529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114553 */     GIR_RootConstrainSelectedInstOperands,
     /* 114554 */     // GIR_Coverage, 7981,
     /* 114554 */     GIR_EraseRootFromParent_Done,
     /* 114555 */   // Label 1608: @114555
     /* 114555 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(114617), // Rule ID 4578 //
     /* 114560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114585 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 114588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114615 */     GIR_RootConstrainSelectedInstOperands,
     /* 114616 */     // GIR_Coverage, 4578,
     /* 114616 */     GIR_EraseRootFromParent_Done,
     /* 114617 */   // Label 1609: @114617
     /* 114617 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(114676), // Rule ID 4580 //
     /* 114622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114644 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 114647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114674 */     GIR_RootConstrainSelectedInstOperands,
     /* 114675 */     // GIR_Coverage, 4580,
     /* 114675 */     GIR_EraseRootFromParent_Done,
     /* 114676 */   // Label 1610: @114676
     /* 114676 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(114738), // Rule ID 4582 //
     /* 114681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114684 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114706 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 114709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114736 */     GIR_RootConstrainSelectedInstOperands,
     /* 114737 */     // GIR_Coverage, 4582,
     /* 114737 */     GIR_EraseRootFromParent_Done,
     /* 114738 */   // Label 1611: @114738
     /* 114738 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(114797), // Rule ID 4584 //
     /* 114743 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114765 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 114768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114795 */     GIR_RootConstrainSelectedInstOperands,
     /* 114796 */     // GIR_Coverage, 4584,
     /* 114796 */     GIR_EraseRootFromParent_Done,
     /* 114797 */   // Label 1612: @114797
     /* 114797 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(114854), // Rule ID 7979 //
     /* 114802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114805 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114825 */     // (ld:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 114828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114852 */     GIR_RootConstrainSelectedInstOperands,
     /* 114853 */     // GIR_Coverage, 7979,
     /* 114853 */     GIR_EraseRootFromParent_Done,
     /* 114854 */   // Label 1613: @114854
     /* 114854 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(114911), // Rule ID 7983 //
     /* 114859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114882 */     // (ld:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 114885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114909 */     GIR_RootConstrainSelectedInstOperands,
     /* 114910 */     // GIR_Coverage, 7983,
     /* 114910 */     GIR_EraseRootFromParent_Done,
     /* 114911 */   // Label 1614: @114911
     /* 114911 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(114970), // Rule ID 3938 //
     /* 114916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 114941 */     // (ld:{ *:[v2i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 114941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 114944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 114956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114968 */     GIR_RootConstrainSelectedInstOperands,
     /* 114969 */     // GIR_Coverage, 3938,
     /* 114969 */     GIR_EraseRootFromParent_Done,
     /* 114970 */   // Label 1615: @114970
     /* 114970 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(115029), // Rule ID 3942 //
     /* 114975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114978 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 115000 */     // (ld:{ *:[v2f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 115003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 115005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 115010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 115015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115027 */     GIR_RootConstrainSelectedInstOperands,
     /* 115028 */     // GIR_Coverage, 3942,
     /* 115028 */     GIR_EraseRootFromParent_Done,
     /* 115029 */   // Label 1616: @115029
     /* 115029 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(115083), // Rule ID 3937 //
     /* 115034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 115037 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 115044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 115048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 115059 */     // (ld:{ *:[v2i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 115059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 115062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 115064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 115069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115081 */     GIR_RootConstrainSelectedInstOperands,
     /* 115082 */     // GIR_Coverage, 3937,
     /* 115082 */     GIR_EraseRootFromParent_Done,
     /* 115083 */   // Label 1617: @115083
     /* 115083 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(115137), // Rule ID 3941 //
     /* 115088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 115091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 115098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 115102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 115113 */     // (ld:{ *:[v2f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 115113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 115116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 115118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 115123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115135 */     GIR_RootConstrainSelectedInstOperands,
     /* 115136 */     // GIR_Coverage, 3941,
     /* 115136 */     GIR_EraseRootFromParent_Done,
     /* 115137 */   // Label 1618: @115137
     /* 115137 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(115192), // Rule ID 3651 //
     /* 115142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 115145 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 115153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 115157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 115168 */     // (ld:{ *:[v2i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 115168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 115171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 115173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 115178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115190 */     GIR_RootConstrainSelectedInstOperands,
     /* 115191 */     // GIR_Coverage, 3651,
     /* 115191 */     GIR_EraseRootFromParent_Done,
     /* 115192 */   // Label 1619: @115192
     /* 115192 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(115247), // Rule ID 3653 //
     /* 115197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 115200 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 115208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 115212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 115223 */     // (ld:{ *:[v2f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 115223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 115226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 115228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 115233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115245 */     GIR_RootConstrainSelectedInstOperands,
     /* 115246 */     // GIR_Coverage, 3653,
     /* 115246 */     GIR_EraseRootFromParent_Done,
     /* 115247 */   // Label 1620: @115247
     /* 115247 */   GIM_Reject,
     /* 115248 */ // Label 1554: @115248
     /* 115248 */ GIM_Reject,
     /* 115249 */ // Label 893: @115249
     /* 115249 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(118467),
     /* 115254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115257 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(115321), // Rule ID 3139 //
     /* 115262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115292 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115319 */     GIR_RootConstrainSelectedInstOperands,
     /* 115320 */     // GIR_Coverage, 3139,
     /* 115320 */     GIR_EraseRootFromParent_Done,
     /* 115321 */   // Label 1622: @115321
     /* 115321 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(115385), // Rule ID 3154 //
     /* 115326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115356 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115383 */     GIR_RootConstrainSelectedInstOperands,
     /* 115384 */     // GIR_Coverage, 3154,
     /* 115384 */     GIR_EraseRootFromParent_Done,
     /* 115385 */   // Label 1623: @115385
     /* 115385 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(115445), // Rule ID 3144 //
     /* 115390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115416 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 115419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115443 */     GIR_RootConstrainSelectedInstOperands,
     /* 115444 */     // GIR_Coverage, 3144,
     /* 115444 */     GIR_EraseRootFromParent_Done,
     /* 115445 */   // Label 1624: @115445
     /* 115445 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(115505), // Rule ID 3159 //
     /* 115450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115476 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 115479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115503 */     GIR_RootConstrainSelectedInstOperands,
     /* 115504 */     // GIR_Coverage, 3159,
     /* 115504 */     GIR_EraseRootFromParent_Done,
     /* 115505 */   // Label 1625: @115505
     /* 115505 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(115565), // Rule ID 3149 //
     /* 115510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115536 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115563 */     GIR_RootConstrainSelectedInstOperands,
     /* 115564 */     // GIR_Coverage, 3149,
     /* 115564 */     GIR_EraseRootFromParent_Done,
     /* 115565 */   // Label 1626: @115565
     /* 115565 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(115625), // Rule ID 3164 //
     /* 115570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115596 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115623 */     GIR_RootConstrainSelectedInstOperands,
     /* 115624 */     // GIR_Coverage, 3164,
     /* 115624 */     GIR_EraseRootFromParent_Done,
     /* 115625 */   // Label 1627: @115625
     /* 115625 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(115684), // Rule ID 3136 //
     /* 115630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115660 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 115663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115682 */     GIR_RootConstrainSelectedInstOperands,
     /* 115683 */     // GIR_Coverage, 3136,
     /* 115683 */     GIR_EraseRootFromParent_Done,
     /* 115684 */   // Label 1628: @115684
     /* 115684 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(115743), // Rule ID 3137 //
     /* 115689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115719 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 115722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115741 */     GIR_RootConstrainSelectedInstOperands,
     /* 115742 */     // GIR_Coverage, 3137,
     /* 115742 */     GIR_EraseRootFromParent_Done,
     /* 115743 */   // Label 1629: @115743
     /* 115743 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(115805), // Rule ID 3138 //
     /* 115748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115778 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115803 */     GIR_RootConstrainSelectedInstOperands,
     /* 115804 */     // GIR_Coverage, 3138,
     /* 115804 */     GIR_EraseRootFromParent_Done,
     /* 115805 */   // Label 1630: @115805
     /* 115805 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(115864), // Rule ID 3151 //
     /* 115810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115840 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 115843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115862 */     GIR_RootConstrainSelectedInstOperands,
     /* 115863 */     // GIR_Coverage, 3151,
     /* 115863 */     GIR_EraseRootFromParent_Done,
     /* 115864 */   // Label 1631: @115864
     /* 115864 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(115923), // Rule ID 3152 //
     /* 115869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115899 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 115902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115921 */     GIR_RootConstrainSelectedInstOperands,
     /* 115922 */     // GIR_Coverage, 3152,
     /* 115922 */     GIR_EraseRootFromParent_Done,
     /* 115923 */   // Label 1632: @115923
     /* 115923 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(115985), // Rule ID 3153 //
     /* 115928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115958 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115983 */     GIR_RootConstrainSelectedInstOperands,
     /* 115984 */     // GIR_Coverage, 3153,
     /* 115984 */     GIR_EraseRootFromParent_Done,
     /* 115985 */   // Label 1633: @115985
     /* 115985 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(116040), // Rule ID 3141 //
     /* 115990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116016 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 116019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116038 */     GIR_RootConstrainSelectedInstOperands,
     /* 116039 */     // GIR_Coverage, 3141,
     /* 116039 */     GIR_EraseRootFromParent_Done,
     /* 116040 */   // Label 1634: @116040
     /* 116040 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(116095), // Rule ID 3142 //
     /* 116045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 116048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116071 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 116074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116093 */     GIR_RootConstrainSelectedInstOperands,
     /* 116094 */     // GIR_Coverage, 3142,
     /* 116094 */     GIR_EraseRootFromParent_Done,
     /* 116095 */   // Label 1635: @116095
     /* 116095 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(116153), // Rule ID 3143 //
     /* 116100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 116103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116126 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 116129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116151 */     GIR_RootConstrainSelectedInstOperands,
     /* 116152 */     // GIR_Coverage, 3143,
     /* 116152 */     GIR_EraseRootFromParent_Done,
     /* 116153 */   // Label 1636: @116153
     /* 116153 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(116208), // Rule ID 3156 //
     /* 116158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 116161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116184 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 116187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116206 */     GIR_RootConstrainSelectedInstOperands,
     /* 116207 */     // GIR_Coverage, 3156,
     /* 116207 */     GIR_EraseRootFromParent_Done,
     /* 116208 */   // Label 1637: @116208
     /* 116208 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(116263), // Rule ID 3157 //
     /* 116213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 116216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116239 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 116242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116261 */     GIR_RootConstrainSelectedInstOperands,
     /* 116262 */     // GIR_Coverage, 3157,
     /* 116262 */     GIR_EraseRootFromParent_Done,
     /* 116263 */   // Label 1638: @116263
     /* 116263 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(116321), // Rule ID 3158 //
     /* 116268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 116271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116294 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 116297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116319 */     GIR_RootConstrainSelectedInstOperands,
     /* 116320 */     // GIR_Coverage, 3158,
     /* 116320 */     GIR_EraseRootFromParent_Done,
     /* 116321 */   // Label 1639: @116321
     /* 116321 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(116381), // Rule ID 8029 //
     /* 116326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116333 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116338 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116357 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116379 */     GIR_RootConstrainSelectedInstOperands,
     /* 116380 */     // GIR_Coverage, 8029,
     /* 116380 */     GIR_EraseRootFromParent_Done,
     /* 116381 */   // Label 1640: @116381
     /* 116381 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(116441), // Rule ID 8033 //
     /* 116386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116393 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116398 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116417 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116439 */     GIR_RootConstrainSelectedInstOperands,
     /* 116440 */     // GIR_Coverage, 8033,
     /* 116440 */     GIR_EraseRootFromParent_Done,
     /* 116441 */   // Label 1641: @116441
     /* 116441 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(116497), // Rule ID 8097 //
     /* 116446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116453 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116473 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116495 */     GIR_RootConstrainSelectedInstOperands,
     /* 116496 */     // GIR_Coverage, 8097,
     /* 116496 */     GIR_EraseRootFromParent_Done,
     /* 116497 */   // Label 1642: @116497
     /* 116497 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(116553), // Rule ID 8101 //
     /* 116502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116509 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116529 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116551 */     GIR_RootConstrainSelectedInstOperands,
     /* 116552 */     // GIR_Coverage, 8101,
     /* 116552 */     GIR_EraseRootFromParent_Done,
     /* 116553 */   // Label 1643: @116553
     /* 116553 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(116605), // Rule ID 3146 //
     /* 116558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116581 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116603 */     GIR_RootConstrainSelectedInstOperands,
     /* 116604 */     // GIR_Coverage, 3146,
     /* 116604 */     GIR_EraseRootFromParent_Done,
     /* 116605 */   // Label 1644: @116605
     /* 116605 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(116660), // Rule ID 3147 //
     /* 116610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116636 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 116639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116658 */     GIR_RootConstrainSelectedInstOperands,
     /* 116659 */     // GIR_Coverage, 3147,
     /* 116659 */     GIR_EraseRootFromParent_Done,
     /* 116660 */   // Label 1645: @116660
     /* 116660 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(116718), // Rule ID 3148 //
     /* 116665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116691 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 116694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116716 */     GIR_RootConstrainSelectedInstOperands,
     /* 116717 */     // GIR_Coverage, 3148,
     /* 116717 */     GIR_EraseRootFromParent_Done,
     /* 116718 */   // Label 1646: @116718
     /* 116718 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(116770), // Rule ID 3161 //
     /* 116723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116746 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116768 */     GIR_RootConstrainSelectedInstOperands,
     /* 116769 */     // GIR_Coverage, 3161,
     /* 116769 */     GIR_EraseRootFromParent_Done,
     /* 116770 */   // Label 1647: @116770
     /* 116770 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(116825), // Rule ID 3162 //
     /* 116775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116801 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 116804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116823 */     GIR_RootConstrainSelectedInstOperands,
     /* 116824 */     // GIR_Coverage, 3162,
     /* 116824 */     GIR_EraseRootFromParent_Done,
     /* 116825 */   // Label 1648: @116825
     /* 116825 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(116883), // Rule ID 3163 //
     /* 116830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116833 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116856 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 116859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116881 */     GIR_RootConstrainSelectedInstOperands,
     /* 116882 */     // GIR_Coverage, 3163,
     /* 116882 */     GIR_EraseRootFromParent_Done,
     /* 116883 */   // Label 1649: @116883
     /* 116883 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(116939), // Rule ID 8030 //
     /* 116888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116891 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116896 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116915 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116937 */     GIR_RootConstrainSelectedInstOperands,
     /* 116938 */     // GIR_Coverage, 8030,
     /* 116938 */     GIR_EraseRootFromParent_Done,
     /* 116939 */   // Label 1650: @116939
     /* 116939 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(116995), // Rule ID 8034 //
     /* 116944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116952 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116971 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116993 */     GIR_RootConstrainSelectedInstOperands,
     /* 116994 */     // GIR_Coverage, 8034,
     /* 116994 */     GIR_EraseRootFromParent_Done,
     /* 116995 */   // Label 1651: @116995
     /* 116995 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(117047), // Rule ID 8098 //
     /* 117000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 117003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 117023 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 117023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 117026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 117033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117045 */     GIR_RootConstrainSelectedInstOperands,
     /* 117046 */     // GIR_Coverage, 8098,
     /* 117046 */     GIR_EraseRootFromParent_Done,
     /* 117047 */   // Label 1652: @117047
     /* 117047 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(117099), // Rule ID 8102 //
     /* 117052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 117055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 117075 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 117075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 117078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 117085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117097 */     GIR_RootConstrainSelectedInstOperands,
     /* 117098 */     // GIR_Coverage, 8102,
     /* 117098 */     GIR_EraseRootFromParent_Done,
     /* 117099 */   // Label 1653: @117099
     /* 117099 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(117150), // Rule ID 3140 //
     /* 117104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117115 */     // MIs[0] sbase
     /* 117115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 117131 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117136 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117148 */     GIR_RootConstrainSelectedInstOperands,
     /* 117149 */     // GIR_Coverage, 3140,
     /* 117149 */     GIR_EraseRootFromParent_Done,
     /* 117150 */   // Label 1654: @117150
     /* 117150 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(117201), // Rule ID 3155 //
     /* 117155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117166 */     // MIs[0] sbase
     /* 117166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 117182 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117187 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117199 */     GIR_RootConstrainSelectedInstOperands,
     /* 117200 */     // GIR_Coverage, 3155,
     /* 117200 */     GIR_EraseRootFromParent_Done,
     /* 117201 */   // Label 1655: @117201
     /* 117201 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(117248), // Rule ID 3145 //
     /* 117206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117217 */     // MIs[0] sbase
     /* 117217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117229 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 117232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117234 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117246 */     GIR_RootConstrainSelectedInstOperands,
     /* 117247 */     // GIR_Coverage, 3145,
     /* 117247 */     GIR_EraseRootFromParent_Done,
     /* 117248 */   // Label 1656: @117248
     /* 117248 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(117295), // Rule ID 3160 //
     /* 117253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117264 */     // MIs[0] sbase
     /* 117264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117276 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 117279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117281 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117293 */     GIR_RootConstrainSelectedInstOperands,
     /* 117294 */     // GIR_Coverage, 3160,
     /* 117294 */     GIR_EraseRootFromParent_Done,
     /* 117295 */   // Label 1657: @117295
     /* 117295 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(117339), // Rule ID 3150 //
     /* 117300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117308 */     // MIs[0] sbase
     /* 117308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117320 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117325 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117337 */     GIR_RootConstrainSelectedInstOperands,
     /* 117338 */     // GIR_Coverage, 3150,
     /* 117338 */     GIR_EraseRootFromParent_Done,
     /* 117339 */   // Label 1658: @117339
     /* 117339 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(117383), // Rule ID 3165 //
     /* 117344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117352 */     // MIs[0] sbase
     /* 117352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117364 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117369 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117381 */     GIR_RootConstrainSelectedInstOperands,
     /* 117382 */     // GIR_Coverage, 3165,
     /* 117382 */     GIR_EraseRootFromParent_Done,
     /* 117383 */   // Label 1659: @117383
     /* 117383 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(117443), // Rule ID 6515 //
     /* 117388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 117391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 117411 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 117414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117441 */     GIR_RootConstrainSelectedInstOperands,
     /* 117442 */     // GIR_Coverage, 6515,
     /* 117442 */     GIR_EraseRootFromParent_Done,
     /* 117443 */   // Label 1660: @117443
     /* 117443 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(117503), // Rule ID 6517 //
     /* 117448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 117451 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 117471 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 117474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117501 */     GIR_RootConstrainSelectedInstOperands,
     /* 117502 */     // GIR_Coverage, 6517,
     /* 117502 */     GIR_EraseRootFromParent_Done,
     /* 117503 */   // Label 1661: @117503
     /* 117503 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(117560), // Rule ID 4347 //
     /* 117508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 117511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 117531 */     // (ld:{ *:[v3i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SVS:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 117531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SVS),
     /* 117534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 117546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117558 */     GIR_RootConstrainSelectedInstOperands,
     /* 117559 */     // GIR_Coverage, 4347,
     /* 117559 */     GIR_EraseRootFromParent_Done,
     /* 117560 */   // Label 1662: @117560
     /* 117560 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(117612), // Rule ID 4346 //
     /* 117565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117568 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 117588 */     // (ld:{ *:[v3i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 117588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SADDR),
     /* 117591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 117598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117610 */     GIR_RootConstrainSelectedInstOperands,
     /* 117611 */     // GIR_Coverage, 4346,
     /* 117611 */     GIR_EraseRootFromParent_Done,
     /* 117612 */   // Label 1663: @117612
     /* 117612 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(117664), // Rule ID 4345 //
     /* 117617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 117640 */     // (ld:{ *:[v3i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 117640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3),
     /* 117643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117662 */     GIR_RootConstrainSelectedInstOperands,
     /* 117663 */     // GIR_Coverage, 4345,
     /* 117663 */     GIR_EraseRootFromParent_Done,
     /* 117664 */   // Label 1664: @117664
     /* 117664 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(117731), // Rule ID 4563 //
     /* 117669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117694 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 117697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117729 */     GIR_RootConstrainSelectedInstOperands,
     /* 117730 */     // GIR_Coverage, 4563,
     /* 117730 */     GIR_EraseRootFromParent_Done,
     /* 117731 */   // Label 1665: @117731
     /* 117731 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(117795), // Rule ID 4565 //
     /* 117736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117758 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 117761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117793 */     GIR_RootConstrainSelectedInstOperands,
     /* 117794 */     // GIR_Coverage, 4565,
     /* 117794 */     GIR_EraseRootFromParent_Done,
     /* 117795 */   // Label 1666: @117795
     /* 117795 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(117862), // Rule ID 4567 //
     /* 117800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117803 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117825 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 117828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117860 */     GIR_RootConstrainSelectedInstOperands,
     /* 117861 */     // GIR_Coverage, 4567,
     /* 117861 */     GIR_EraseRootFromParent_Done,
     /* 117862 */   // Label 1667: @117862
     /* 117862 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(117926), // Rule ID 4569 //
     /* 117867 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117889 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 117892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117924 */     GIR_RootConstrainSelectedInstOperands,
     /* 117925 */     // GIR_Coverage, 4569,
     /* 117925 */     GIR_EraseRootFromParent_Done,
     /* 117926 */   // Label 1668: @117926
     /* 117926 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(117991), // Rule ID 6514 //
     /* 117931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 117934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 117954 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 117957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117989 */     GIR_RootConstrainSelectedInstOperands,
     /* 117990 */     // GIR_Coverage, 6514,
     /* 117990 */     GIR_EraseRootFromParent_Done,
     /* 117991 */   // Label 1669: @117991
     /* 117991 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(118056), // Rule ID 6516 //
     /* 117996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 117999 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 118004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 118019 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 118019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 118022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 118029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 118039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 118044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118054 */     GIR_RootConstrainSelectedInstOperands,
     /* 118055 */     // GIR_Coverage, 6516,
     /* 118055 */     GIR_EraseRootFromParent_Done,
     /* 118056 */   // Label 1670: @118056
     /* 118056 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(118118), // Rule ID 4562 //
     /* 118061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 118064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118086 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 118089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118116 */     GIR_RootConstrainSelectedInstOperands,
     /* 118117 */     // GIR_Coverage, 4562,
     /* 118117 */     GIR_EraseRootFromParent_Done,
     /* 118118 */   // Label 1671: @118118
     /* 118118 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(118177), // Rule ID 4564 //
     /* 118123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118145 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 118148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118175 */     GIR_RootConstrainSelectedInstOperands,
     /* 118176 */     // GIR_Coverage, 4564,
     /* 118176 */     GIR_EraseRootFromParent_Done,
     /* 118177 */   // Label 1672: @118177
     /* 118177 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(118239), // Rule ID 4566 //
     /* 118182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 118185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118207 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 118210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118237 */     GIR_RootConstrainSelectedInstOperands,
     /* 118238 */     // GIR_Coverage, 4566,
     /* 118238 */     GIR_EraseRootFromParent_Done,
     /* 118239 */   // Label 1673: @118239
     /* 118239 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(118298), // Rule ID 4568 //
     /* 118244 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118266 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 118269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118296 */     GIR_RootConstrainSelectedInstOperands,
     /* 118297 */     // GIR_Coverage, 4568,
     /* 118297 */     GIR_EraseRootFromParent_Done,
     /* 118298 */   // Label 1674: @118298
     /* 118298 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(118357), // Rule ID 3928 //
     /* 118303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118306 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 118328 */     // (ld:{ *:[v3i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3_SADDR),
     /* 118331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 118338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 118343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118355 */     GIR_RootConstrainSelectedInstOperands,
     /* 118356 */     // GIR_Coverage, 3928,
     /* 118356 */     GIR_EraseRootFromParent_Done,
     /* 118357 */   // Label 1675: @118357
     /* 118357 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(118411), // Rule ID 3927 //
     /* 118362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118365 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 118387 */     // (ld:{ *:[v3i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3),
     /* 118390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118409 */     GIR_RootConstrainSelectedInstOperands,
     /* 118410 */     // GIR_Coverage, 3927,
     /* 118410 */     GIR_EraseRootFromParent_Done,
     /* 118411 */   // Label 1676: @118411
     /* 118411 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(118466), // Rule ID 3589 //
     /* 118416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 118419 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 118442 */     // (ld:{ *:[v3i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX3),
     /* 118445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118464 */     GIR_RootConstrainSelectedInstOperands,
     /* 118465 */     // GIR_Coverage, 3589,
     /* 118465 */     GIR_EraseRootFromParent_Done,
     /* 118466 */   // Label 1677: @118466
     /* 118466 */   GIM_Reject,
     /* 118467 */ // Label 1621: @118467
     /* 118467 */ GIM_Reject,
     /* 118468 */ // Label 894: @118468
     /* 118468 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(122265),
     /* 118473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118476 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(118540), // Rule ID 3106 //
     /* 118481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118511 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118538 */     GIR_RootConstrainSelectedInstOperands,
     /* 118539 */     // GIR_Coverage, 3106,
     /* 118539 */     GIR_EraseRootFromParent_Done,
     /* 118540 */   // Label 1679: @118540
     /* 118540 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(118604), // Rule ID 3123 //
     /* 118545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118575 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118602 */     GIR_RootConstrainSelectedInstOperands,
     /* 118603 */     // GIR_Coverage, 3123,
     /* 118603 */     GIR_EraseRootFromParent_Done,
     /* 118604 */   // Label 1680: @118604
     /* 118604 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(118664), // Rule ID 3111 //
     /* 118609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118635 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 118638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118662 */     GIR_RootConstrainSelectedInstOperands,
     /* 118663 */     // GIR_Coverage, 3111,
     /* 118663 */     GIR_EraseRootFromParent_Done,
     /* 118664 */   // Label 1681: @118664
     /* 118664 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(118724), // Rule ID 3128 //
     /* 118669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118672 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118695 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 118698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118722 */     GIR_RootConstrainSelectedInstOperands,
     /* 118723 */     // GIR_Coverage, 3128,
     /* 118723 */     GIR_EraseRootFromParent_Done,
     /* 118724 */   // Label 1682: @118724
     /* 118724 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(118784), // Rule ID 3117 //
     /* 118729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 118732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118755 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118782 */     GIR_RootConstrainSelectedInstOperands,
     /* 118783 */     // GIR_Coverage, 3117,
     /* 118783 */     GIR_EraseRootFromParent_Done,
     /* 118784 */   // Label 1683: @118784
     /* 118784 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(118844), // Rule ID 3134 //
     /* 118789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 118792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118815 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118842 */     GIR_RootConstrainSelectedInstOperands,
     /* 118843 */     // GIR_Coverage, 3134,
     /* 118843 */     GIR_EraseRootFromParent_Done,
     /* 118844 */   // Label 1684: @118844
     /* 118844 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(118903), // Rule ID 3102 //
     /* 118849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 118852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 118879 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 118882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118901 */     GIR_RootConstrainSelectedInstOperands,
     /* 118902 */     // GIR_Coverage, 3102,
     /* 118902 */     GIR_EraseRootFromParent_Done,
     /* 118903 */   // Label 1685: @118903
     /* 118903 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(118962), // Rule ID 3103 //
     /* 118908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 118911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 118938 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 118941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118960 */     GIR_RootConstrainSelectedInstOperands,
     /* 118961 */     // GIR_Coverage, 3103,
     /* 118961 */     GIR_EraseRootFromParent_Done,
     /* 118962 */   // Label 1686: @118962
     /* 118962 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(119021), // Rule ID 3104 //
     /* 118967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 118970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 118997 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 118997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 119000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119019 */     GIR_RootConstrainSelectedInstOperands,
     /* 119020 */     // GIR_Coverage, 3104,
     /* 119020 */     GIR_EraseRootFromParent_Done,
     /* 119021 */   // Label 1687: @119021
     /* 119021 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(119083), // Rule ID 3105 //
     /* 119026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119056 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 119059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119081 */     GIR_RootConstrainSelectedInstOperands,
     /* 119082 */     // GIR_Coverage, 3105,
     /* 119082 */     GIR_EraseRootFromParent_Done,
     /* 119083 */   // Label 1688: @119083
     /* 119083 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(119142), // Rule ID 3119 //
     /* 119088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119118 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 119121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119140 */     GIR_RootConstrainSelectedInstOperands,
     /* 119141 */     // GIR_Coverage, 3119,
     /* 119141 */     GIR_EraseRootFromParent_Done,
     /* 119142 */   // Label 1689: @119142
     /* 119142 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(119201), // Rule ID 3120 //
     /* 119147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 119150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 119177 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 119180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119199 */     GIR_RootConstrainSelectedInstOperands,
     /* 119200 */     // GIR_Coverage, 3120,
     /* 119200 */     GIR_EraseRootFromParent_Done,
     /* 119201 */   // Label 1690: @119201
     /* 119201 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(119260), // Rule ID 3121 //
     /* 119206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119236 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 119239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119258 */     GIR_RootConstrainSelectedInstOperands,
     /* 119259 */     // GIR_Coverage, 3121,
     /* 119259 */     GIR_EraseRootFromParent_Done,
     /* 119260 */   // Label 1691: @119260
     /* 119260 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(119322), // Rule ID 3122 //
     /* 119265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119295 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 119298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119320 */     GIR_RootConstrainSelectedInstOperands,
     /* 119321 */     // GIR_Coverage, 3122,
     /* 119321 */     GIR_EraseRootFromParent_Done,
     /* 119322 */   // Label 1692: @119322
     /* 119322 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(119377), // Rule ID 3108 //
     /* 119327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119353 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 119356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119375 */     GIR_RootConstrainSelectedInstOperands,
     /* 119376 */     // GIR_Coverage, 3108,
     /* 119376 */     GIR_EraseRootFromParent_Done,
     /* 119377 */   // Label 1693: @119377
     /* 119377 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(119432), // Rule ID 3109 //
     /* 119382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119385 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119408 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119430 */     GIR_RootConstrainSelectedInstOperands,
     /* 119431 */     // GIR_Coverage, 3109,
     /* 119431 */     GIR_EraseRootFromParent_Done,
     /* 119432 */   // Label 1694: @119432
     /* 119432 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(119490), // Rule ID 3110 //
     /* 119437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119463 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 119466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119488 */     GIR_RootConstrainSelectedInstOperands,
     /* 119489 */     // GIR_Coverage, 3110,
     /* 119489 */     GIR_EraseRootFromParent_Done,
     /* 119490 */   // Label 1695: @119490
     /* 119490 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(119545), // Rule ID 3125 //
     /* 119495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119521 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 119524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119543 */     GIR_RootConstrainSelectedInstOperands,
     /* 119544 */     // GIR_Coverage, 3125,
     /* 119544 */     GIR_EraseRootFromParent_Done,
     /* 119545 */   // Label 1696: @119545
     /* 119545 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(119600), // Rule ID 3126 //
     /* 119550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119576 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 119579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119598 */     GIR_RootConstrainSelectedInstOperands,
     /* 119599 */     // GIR_Coverage, 3126,
     /* 119599 */     GIR_EraseRootFromParent_Done,
     /* 119600 */   // Label 1697: @119600
     /* 119600 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(119658), // Rule ID 3127 //
     /* 119605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119631 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 119634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119656 */     GIR_RootConstrainSelectedInstOperands,
     /* 119657 */     // GIR_Coverage, 3127,
     /* 119657 */     GIR_EraseRootFromParent_Done,
     /* 119658 */   // Label 1698: @119658
     /* 119658 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(119723), // Rule ID 8077 //
     /* 119663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 119666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119675 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 119692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119699 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119721 */     GIR_RootConstrainSelectedInstOperands,
     /* 119722 */     // GIR_Coverage, 8077,
     /* 119722 */     GIR_EraseRootFromParent_Done,
     /* 119723 */   // Label 1699: @119723
     /* 119723 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(119788), // Rule ID 8081 //
     /* 119728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 119731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 119757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119764 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119786 */     GIR_RootConstrainSelectedInstOperands,
     /* 119787 */     // GIR_Coverage, 8081,
     /* 119787 */     GIR_EraseRootFromParent_Done,
     /* 119788 */   // Label 1700: @119788
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(119848), // Rule ID 8009 //
     /* 119793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 119796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119805 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 119809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119824 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119846 */     GIR_RootConstrainSelectedInstOperands,
     /* 119847 */     // GIR_Coverage, 8009,
     /* 119847 */     GIR_EraseRootFromParent_Done,
     /* 119848 */   // Label 1701: @119848
     /* 119848 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(119908), // Rule ID 8013 //
     /* 119853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 119856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119865 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 119869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119884 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119906 */     GIR_RootConstrainSelectedInstOperands,
     /* 119907 */     // GIR_Coverage, 8013,
     /* 119907 */     GIR_EraseRootFromParent_Done,
     /* 119908 */   // Label 1702: @119908
     /* 119908 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(119960), // Rule ID 3113 //
     /* 119913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119936 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 119939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119958 */     GIR_RootConstrainSelectedInstOperands,
     /* 119959 */     // GIR_Coverage, 3113,
     /* 119959 */     GIR_EraseRootFromParent_Done,
     /* 119960 */   // Label 1703: @119960
     /* 119960 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(120015), // Rule ID 3114 //
     /* 119965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 119968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 119991 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 119994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120013 */     GIR_RootConstrainSelectedInstOperands,
     /* 120014 */     // GIR_Coverage, 3114,
     /* 120014 */     GIR_EraseRootFromParent_Done,
     /* 120015 */   // Label 1704: @120015
     /* 120015 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(120070), // Rule ID 3115 //
     /* 120020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 120023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120046 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 120046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 120049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120068 */     GIR_RootConstrainSelectedInstOperands,
     /* 120069 */     // GIR_Coverage, 3115,
     /* 120069 */     GIR_EraseRootFromParent_Done,
     /* 120070 */   // Label 1705: @120070
     /* 120070 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(120128), // Rule ID 3116 //
     /* 120075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 120078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120101 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 120104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120126 */     GIR_RootConstrainSelectedInstOperands,
     /* 120127 */     // GIR_Coverage, 3116,
     /* 120127 */     GIR_EraseRootFromParent_Done,
     /* 120128 */   // Label 1706: @120128
     /* 120128 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(120180), // Rule ID 3130 //
     /* 120133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 120156 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120178 */     GIR_RootConstrainSelectedInstOperands,
     /* 120179 */     // GIR_Coverage, 3130,
     /* 120179 */     GIR_EraseRootFromParent_Done,
     /* 120180 */   // Label 1707: @120180
     /* 120180 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(120235), // Rule ID 3131 //
     /* 120185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 120188 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 120211 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 120214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120233 */     GIR_RootConstrainSelectedInstOperands,
     /* 120234 */     // GIR_Coverage, 3131,
     /* 120234 */     GIR_EraseRootFromParent_Done,
     /* 120235 */   // Label 1708: @120235
     /* 120235 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(120290), // Rule ID 3132 //
     /* 120240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 120243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120266 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 120266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 120269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120288 */     GIR_RootConstrainSelectedInstOperands,
     /* 120289 */     // GIR_Coverage, 3132,
     /* 120289 */     GIR_EraseRootFromParent_Done,
     /* 120290 */   // Label 1709: @120290
     /* 120290 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(120348), // Rule ID 3133 //
     /* 120295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 120298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120321 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 120324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120346 */     GIR_RootConstrainSelectedInstOperands,
     /* 120347 */     // GIR_Coverage, 3133,
     /* 120347 */     GIR_EraseRootFromParent_Done,
     /* 120348 */   // Label 1710: @120348
     /* 120348 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(120409), // Rule ID 8078 //
     /* 120353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120356 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 120378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120385 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120407 */     GIR_RootConstrainSelectedInstOperands,
     /* 120408 */     // GIR_Coverage, 8078,
     /* 120408 */     GIR_EraseRootFromParent_Done,
     /* 120409 */   // Label 1711: @120409
     /* 120409 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(120470), // Rule ID 8082 //
     /* 120414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 120439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120446 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120468 */     GIR_RootConstrainSelectedInstOperands,
     /* 120469 */     // GIR_Coverage, 8082,
     /* 120469 */     GIR_EraseRootFromParent_Done,
     /* 120470 */   // Label 1712: @120470
     /* 120470 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(120526), // Rule ID 8010 //
     /* 120475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 120478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120483 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 120487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120502 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120524 */     GIR_RootConstrainSelectedInstOperands,
     /* 120525 */     // GIR_Coverage, 8010,
     /* 120525 */     GIR_EraseRootFromParent_Done,
     /* 120526 */   // Label 1713: @120526
     /* 120526 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(120582), // Rule ID 8014 //
     /* 120531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 120534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120539 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 120543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120558 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120580 */     GIR_RootConstrainSelectedInstOperands,
     /* 120581 */     // GIR_Coverage, 8014,
     /* 120581 */     GIR_EraseRootFromParent_Done,
     /* 120582 */   // Label 1714: @120582
     /* 120582 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(120633), // Rule ID 3107 //
     /* 120587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120598 */     // MIs[0] sbase
     /* 120598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120614 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120619 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120631 */     GIR_RootConstrainSelectedInstOperands,
     /* 120632 */     // GIR_Coverage, 3107,
     /* 120632 */     GIR_EraseRootFromParent_Done,
     /* 120633 */   // Label 1715: @120633
     /* 120633 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(120684), // Rule ID 3124 //
     /* 120638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120649 */     // MIs[0] sbase
     /* 120649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120665 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120670 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120682 */     GIR_RootConstrainSelectedInstOperands,
     /* 120683 */     // GIR_Coverage, 3124,
     /* 120683 */     GIR_EraseRootFromParent_Done,
     /* 120684 */   // Label 1716: @120684
     /* 120684 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(120731), // Rule ID 3112 //
     /* 120689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120700 */     // MIs[0] sbase
     /* 120700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120712 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 120715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120717 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120729 */     GIR_RootConstrainSelectedInstOperands,
     /* 120730 */     // GIR_Coverage, 3112,
     /* 120730 */     GIR_EraseRootFromParent_Done,
     /* 120731 */   // Label 1717: @120731
     /* 120731 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(120778), // Rule ID 3129 //
     /* 120736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120747 */     // MIs[0] sbase
     /* 120747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120759 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 120762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120764 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120776 */     GIR_RootConstrainSelectedInstOperands,
     /* 120777 */     // GIR_Coverage, 3129,
     /* 120777 */     GIR_EraseRootFromParent_Done,
     /* 120778 */   // Label 1718: @120778
     /* 120778 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(120822), // Rule ID 3118 //
     /* 120783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120791 */     // MIs[0] sbase
     /* 120791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120803 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120808 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120820 */     GIR_RootConstrainSelectedInstOperands,
     /* 120821 */     // GIR_Coverage, 3118,
     /* 120821 */     GIR_EraseRootFromParent_Done,
     /* 120822 */   // Label 1719: @120822
     /* 120822 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(120866), // Rule ID 3135 //
     /* 120827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120835 */     // MIs[0] sbase
     /* 120835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120847 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120852 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120864 */     GIR_RootConstrainSelectedInstOperands,
     /* 120865 */     // GIR_Coverage, 3135,
     /* 120865 */     GIR_EraseRootFromParent_Done,
     /* 120866 */   // Label 1720: @120866
     /* 120866 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(120923), // Rule ID 4317 //
     /* 120871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 120874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 120894 */     // (ld:{ *:[v4f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 120897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 120909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 120914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120921 */     GIR_RootConstrainSelectedInstOperands,
     /* 120922 */     // GIR_Coverage, 4317,
     /* 120922 */     GIR_EraseRootFromParent_Done,
     /* 120923 */   // Label 1721: @120923
     /* 120923 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(120980), // Rule ID 4323 //
     /* 120928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 120931 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 120951 */     // (ld:{ *:[v4i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 120954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 120966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 120971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120978 */     GIR_RootConstrainSelectedInstOperands,
     /* 120979 */     // GIR_Coverage, 4323,
     /* 120979 */     GIR_EraseRootFromParent_Done,
     /* 120980 */   // Label 1722: @120980
     /* 120980 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(121032), // Rule ID 4316 //
     /* 120985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 120988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 121008 */     // (ld:{ *:[v4f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 121008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 121011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121030 */     GIR_RootConstrainSelectedInstOperands,
     /* 121031 */     // GIR_Coverage, 4316,
     /* 121031 */     GIR_EraseRootFromParent_Done,
     /* 121032 */   // Label 1723: @121032
     /* 121032 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(121084), // Rule ID 4322 //
     /* 121037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 121040 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 121060 */     // (ld:{ *:[v4i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 121060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 121063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121082 */     GIR_RootConstrainSelectedInstOperands,
     /* 121083 */     // GIR_Coverage, 4322,
     /* 121083 */     GIR_EraseRootFromParent_Done,
     /* 121084 */   // Label 1724: @121084
     /* 121084 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(121136), // Rule ID 4315 //
     /* 121089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 121092 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 121112 */     // (ld:{ *:[v4f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 121115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121134 */     GIR_RootConstrainSelectedInstOperands,
     /* 121135 */     // GIR_Coverage, 4315,
     /* 121135 */     GIR_EraseRootFromParent_Done,
     /* 121136 */   // Label 1725: @121136
     /* 121136 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(121188), // Rule ID 4321 //
     /* 121141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 121144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 121164 */     // (ld:{ *:[v4i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 121167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121186 */     GIR_RootConstrainSelectedInstOperands,
     /* 121187 */     // GIR_Coverage, 4321,
     /* 121187 */     GIR_EraseRootFromParent_Done,
     /* 121188 */   // Label 1726: @121188
     /* 121188 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(121255), // Rule ID 4543 //
     /* 121193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121196 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121218 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 121221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121253 */     GIR_RootConstrainSelectedInstOperands,
     /* 121254 */     // GIR_Coverage, 4543,
     /* 121254 */     GIR_EraseRootFromParent_Done,
     /* 121255 */   // Label 1727: @121255
     /* 121255 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(121319), // Rule ID 4545 //
     /* 121260 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121282 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 121285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121317 */     GIR_RootConstrainSelectedInstOperands,
     /* 121318 */     // GIR_Coverage, 4545,
     /* 121318 */     GIR_EraseRootFromParent_Done,
     /* 121319 */   // Label 1728: @121319
     /* 121319 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(121386), // Rule ID 4547 //
     /* 121324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121327 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121349 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 121352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121384 */     GIR_RootConstrainSelectedInstOperands,
     /* 121385 */     // GIR_Coverage, 4547,
     /* 121385 */     GIR_EraseRootFromParent_Done,
     /* 121386 */   // Label 1729: @121386
     /* 121386 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(121450), // Rule ID 4549 //
     /* 121391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121413 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 121416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121448 */     GIR_RootConstrainSelectedInstOperands,
     /* 121449 */     // GIR_Coverage, 4549,
     /* 121449 */     GIR_EraseRootFromParent_Done,
     /* 121450 */   // Label 1730: @121450
     /* 121450 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(121511), // Rule ID 7953 //
     /* 121455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 121458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121462 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121482 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 121485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121509 */     GIR_RootConstrainSelectedInstOperands,
     /* 121510 */     // GIR_Coverage, 7953,
     /* 121510 */     GIR_EraseRootFromParent_Done,
     /* 121511 */   // Label 1731: @121511
     /* 121511 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(121572), // Rule ID 7957 //
     /* 121516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 121519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121523 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121543 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 121546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121570 */     GIR_RootConstrainSelectedInstOperands,
     /* 121571 */     // GIR_Coverage, 7957,
     /* 121571 */     GIR_EraseRootFromParent_Done,
     /* 121572 */   // Label 1732: @121572
     /* 121572 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(121634), // Rule ID 4542 //
     /* 121577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121602 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 121605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121632 */     GIR_RootConstrainSelectedInstOperands,
     /* 121633 */     // GIR_Coverage, 4542,
     /* 121633 */     GIR_EraseRootFromParent_Done,
     /* 121634 */   // Label 1733: @121634
     /* 121634 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(121693), // Rule ID 4544 //
     /* 121639 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121661 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 121664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121691 */     GIR_RootConstrainSelectedInstOperands,
     /* 121692 */     // GIR_Coverage, 4544,
     /* 121692 */     GIR_EraseRootFromParent_Done,
     /* 121693 */   // Label 1734: @121693
     /* 121693 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(121755), // Rule ID 4546 //
     /* 121698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121723 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 121726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121753 */     GIR_RootConstrainSelectedInstOperands,
     /* 121754 */     // GIR_Coverage, 4546,
     /* 121754 */     GIR_EraseRootFromParent_Done,
     /* 121755 */   // Label 1735: @121755
     /* 121755 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(121814), // Rule ID 4548 //
     /* 121760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121782 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 121785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121812 */     GIR_RootConstrainSelectedInstOperands,
     /* 121813 */     // GIR_Coverage, 4548,
     /* 121813 */     GIR_EraseRootFromParent_Done,
     /* 121814 */   // Label 1736: @121814
     /* 121814 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(121871), // Rule ID 7955 //
     /* 121819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 121822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121842 */     // (ld:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 121845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121869 */     GIR_RootConstrainSelectedInstOperands,
     /* 121870 */     // GIR_Coverage, 7955,
     /* 121870 */     GIR_EraseRootFromParent_Done,
     /* 121871 */   // Label 1737: @121871
     /* 121871 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(121928), // Rule ID 7959 //
     /* 121876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 121879 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121899 */     // (ld:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 121902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121926 */     GIR_RootConstrainSelectedInstOperands,
     /* 121927 */     // GIR_Coverage, 7959,
     /* 121927 */     GIR_EraseRootFromParent_Done,
     /* 121928 */   // Label 1738: @121928
     /* 121928 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(121987), // Rule ID 3908 //
     /* 121933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121936 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 121958 */     // (ld:{ *:[v4f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 121958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 121961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 121973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121985 */     GIR_RootConstrainSelectedInstOperands,
     /* 121986 */     // GIR_Coverage, 3908,
     /* 121986 */     GIR_EraseRootFromParent_Done,
     /* 121987 */   // Label 1739: @121987
     /* 121987 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(122046), // Rule ID 3912 //
     /* 121992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121995 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 122002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 122006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 122017 */     // (ld:{ *:[v4i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 122020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 122027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 122032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122044 */     GIR_RootConstrainSelectedInstOperands,
     /* 122045 */     // GIR_Coverage, 3912,
     /* 122045 */     GIR_EraseRootFromParent_Done,
     /* 122046 */   // Label 1740: @122046
     /* 122046 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(122100), // Rule ID 3907 //
     /* 122051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 122054 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 122061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 122065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 122076 */     // (ld:{ *:[v4f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 122076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 122079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 122086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122098 */     GIR_RootConstrainSelectedInstOperands,
     /* 122099 */     // GIR_Coverage, 3907,
     /* 122099 */     GIR_EraseRootFromParent_Done,
     /* 122100 */   // Label 1741: @122100
     /* 122100 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(122154), // Rule ID 3911 //
     /* 122105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 122108 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 122115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 122119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 122130 */     // (ld:{ *:[v4i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 122130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 122133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 122140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122152 */     GIR_RootConstrainSelectedInstOperands,
     /* 122153 */     // GIR_Coverage, 3911,
     /* 122153 */     GIR_EraseRootFromParent_Done,
     /* 122154 */   // Label 1742: @122154
     /* 122154 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(122209), // Rule ID 3637 //
     /* 122159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 122162 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 122170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 122174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 122185 */     // (ld:{ *:[v4f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 122185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 122188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 122195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122207 */     GIR_RootConstrainSelectedInstOperands,
     /* 122208 */     // GIR_Coverage, 3637,
     /* 122208 */     GIR_EraseRootFromParent_Done,
     /* 122209 */   // Label 1743: @122209
     /* 122209 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(122264), // Rule ID 3639 //
     /* 122214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 122217 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 122225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 122229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 122240 */     // (ld:{ *:[v4i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 122240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 122243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 122250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122262 */     GIR_RootConstrainSelectedInstOperands,
     /* 122263 */     // GIR_Coverage, 3639,
     /* 122263 */     GIR_EraseRootFromParent_Done,
     /* 122264 */   // Label 1744: @122264
     /* 122264 */   GIM_Reject,
     /* 122265 */ // Label 1678: @122265
     /* 122265 */ GIM_Reject,
     /* 122266 */ // Label 895: @122266
     /* 122266 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(126313),
     /* 122271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122274 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(122338), // Rule ID 3170 //
     /* 122279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122309 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122336 */     GIR_RootConstrainSelectedInstOperands,
     /* 122337 */     // GIR_Coverage, 3170,
     /* 122337 */     GIR_EraseRootFromParent_Done,
     /* 122338 */   // Label 1746: @122338
     /* 122338 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(122402), // Rule ID 3187 //
     /* 122343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122373 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122400 */     GIR_RootConstrainSelectedInstOperands,
     /* 122401 */     // GIR_Coverage, 3187,
     /* 122401 */     GIR_EraseRootFromParent_Done,
     /* 122402 */   // Label 1747: @122402
     /* 122402 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(122462), // Rule ID 3175 //
     /* 122407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122433 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 122436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122460 */     GIR_RootConstrainSelectedInstOperands,
     /* 122461 */     // GIR_Coverage, 3175,
     /* 122461 */     GIR_EraseRootFromParent_Done,
     /* 122462 */   // Label 1748: @122462
     /* 122462 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(122522), // Rule ID 3192 //
     /* 122467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122493 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 122496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122520 */     GIR_RootConstrainSelectedInstOperands,
     /* 122521 */     // GIR_Coverage, 3192,
     /* 122521 */     GIR_EraseRootFromParent_Done,
     /* 122522 */   // Label 1749: @122522
     /* 122522 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(122582), // Rule ID 3181 //
     /* 122527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122553 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122580 */     GIR_RootConstrainSelectedInstOperands,
     /* 122581 */     // GIR_Coverage, 3181,
     /* 122581 */     GIR_EraseRootFromParent_Done,
     /* 122582 */   // Label 1750: @122582
     /* 122582 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(122642), // Rule ID 3198 //
     /* 122587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122613 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122640 */     GIR_RootConstrainSelectedInstOperands,
     /* 122641 */     // GIR_Coverage, 3198,
     /* 122641 */     GIR_EraseRootFromParent_Done,
     /* 122642 */   // Label 1751: @122642
     /* 122642 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(122701), // Rule ID 3166 //
     /* 122647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122650 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122677 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 122680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122699 */     GIR_RootConstrainSelectedInstOperands,
     /* 122700 */     // GIR_Coverage, 3166,
     /* 122700 */     GIR_EraseRootFromParent_Done,
     /* 122701 */   // Label 1752: @122701
     /* 122701 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(122760), // Rule ID 3167 //
     /* 122706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122736 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 122739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122758 */     GIR_RootConstrainSelectedInstOperands,
     /* 122759 */     // GIR_Coverage, 3167,
     /* 122759 */     GIR_EraseRootFromParent_Done,
     /* 122760 */   // Label 1753: @122760
     /* 122760 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(122819), // Rule ID 3168 //
     /* 122765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122795 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 122798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122817 */     GIR_RootConstrainSelectedInstOperands,
     /* 122818 */     // GIR_Coverage, 3168,
     /* 122818 */     GIR_EraseRootFromParent_Done,
     /* 122819 */   // Label 1754: @122819
     /* 122819 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(122881), // Rule ID 3169 //
     /* 122824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122854 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 122854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122879 */     GIR_RootConstrainSelectedInstOperands,
     /* 122880 */     // GIR_Coverage, 3169,
     /* 122880 */     GIR_EraseRootFromParent_Done,
     /* 122881 */   // Label 1755: @122881
     /* 122881 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(122940), // Rule ID 3183 //
     /* 122886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122889 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122916 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 122919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122938 */     GIR_RootConstrainSelectedInstOperands,
     /* 122939 */     // GIR_Coverage, 3183,
     /* 122939 */     GIR_EraseRootFromParent_Done,
     /* 122940 */   // Label 1756: @122940
     /* 122940 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(122999), // Rule ID 3184 //
     /* 122945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122975 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 122978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122997 */     GIR_RootConstrainSelectedInstOperands,
     /* 122998 */     // GIR_Coverage, 3184,
     /* 122998 */     GIR_EraseRootFromParent_Done,
     /* 122999 */   // Label 1757: @122999
     /* 122999 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(123058), // Rule ID 3185 //
     /* 123004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 123007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 123027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123034 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 123037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123056 */     GIR_RootConstrainSelectedInstOperands,
     /* 123057 */     // GIR_Coverage, 3185,
     /* 123057 */     GIR_EraseRootFromParent_Done,
     /* 123058 */   // Label 1758: @123058
     /* 123058 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(123120), // Rule ID 3186 //
     /* 123063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 123086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123093 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 123096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123118 */     GIR_RootConstrainSelectedInstOperands,
     /* 123119 */     // GIR_Coverage, 3186,
     /* 123119 */     GIR_EraseRootFromParent_Done,
     /* 123120 */   // Label 1759: @123120
     /* 123120 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(123175), // Rule ID 3172 //
     /* 123125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 123128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123151 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 123154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123173 */     GIR_RootConstrainSelectedInstOperands,
     /* 123174 */     // GIR_Coverage, 3172,
     /* 123174 */     GIR_EraseRootFromParent_Done,
     /* 123175 */   // Label 1760: @123175
     /* 123175 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(123230), // Rule ID 3173 //
     /* 123180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 123183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123206 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 123209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123228 */     GIR_RootConstrainSelectedInstOperands,
     /* 123229 */     // GIR_Coverage, 3173,
     /* 123229 */     GIR_EraseRootFromParent_Done,
     /* 123230 */   // Label 1761: @123230
     /* 123230 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(123288), // Rule ID 3174 //
     /* 123235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123261 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 123264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123286 */     GIR_RootConstrainSelectedInstOperands,
     /* 123287 */     // GIR_Coverage, 3174,
     /* 123287 */     GIR_EraseRootFromParent_Done,
     /* 123288 */   // Label 1762: @123288
     /* 123288 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(123343), // Rule ID 3189 //
     /* 123293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 123296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123319 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 123322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123341 */     GIR_RootConstrainSelectedInstOperands,
     /* 123342 */     // GIR_Coverage, 3189,
     /* 123342 */     GIR_EraseRootFromParent_Done,
     /* 123343 */   // Label 1763: @123343
     /* 123343 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(123398), // Rule ID 3190 //
     /* 123348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 123351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123374 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 123377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123396 */     GIR_RootConstrainSelectedInstOperands,
     /* 123397 */     // GIR_Coverage, 3190,
     /* 123397 */     GIR_EraseRootFromParent_Done,
     /* 123398 */   // Label 1764: @123398
     /* 123398 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(123456), // Rule ID 3191 //
     /* 123403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123429 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 123432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123454 */     GIR_RootConstrainSelectedInstOperands,
     /* 123455 */     // GIR_Coverage, 3191,
     /* 123455 */     GIR_EraseRootFromParent_Done,
     /* 123456 */   // Label 1765: @123456
     /* 123456 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(123516), // Rule ID 8037 //
     /* 123461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 123464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123468 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123473 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123492 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123514 */     GIR_RootConstrainSelectedInstOperands,
     /* 123515 */     // GIR_Coverage, 8037,
     /* 123515 */     GIR_EraseRootFromParent_Done,
     /* 123516 */   // Label 1766: @123516
     /* 123516 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(123576), // Rule ID 8041 //
     /* 123521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 123524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123533 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123552 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123574 */     GIR_RootConstrainSelectedInstOperands,
     /* 123575 */     // GIR_Coverage, 8041,
     /* 123575 */     GIR_EraseRootFromParent_Done,
     /* 123576 */   // Label 1767: @123576
     /* 123576 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(123641), // Rule ID 8105 //
     /* 123581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123588 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123617 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123639 */     GIR_RootConstrainSelectedInstOperands,
     /* 123640 */     // GIR_Coverage, 8105,
     /* 123640 */     GIR_EraseRootFromParent_Done,
     /* 123641 */   // Label 1768: @123641
     /* 123641 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(123706), // Rule ID 8109 //
     /* 123646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123658 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123682 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123704 */     GIR_RootConstrainSelectedInstOperands,
     /* 123705 */     // GIR_Coverage, 8109,
     /* 123705 */     GIR_EraseRootFromParent_Done,
     /* 123706 */   // Label 1769: @123706
     /* 123706 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123758), // Rule ID 3177 //
     /* 123711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123734 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 123737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123756 */     GIR_RootConstrainSelectedInstOperands,
     /* 123757 */     // GIR_Coverage, 3177,
     /* 123757 */     GIR_EraseRootFromParent_Done,
     /* 123758 */   // Label 1770: @123758
     /* 123758 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(123813), // Rule ID 3178 //
     /* 123763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 123789 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 123792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123811 */     GIR_RootConstrainSelectedInstOperands,
     /* 123812 */     // GIR_Coverage, 3178,
     /* 123812 */     GIR_EraseRootFromParent_Done,
     /* 123813 */   // Label 1771: @123813
     /* 123813 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(123868), // Rule ID 3179 //
     /* 123818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 123821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123844 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 123847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123866 */     GIR_RootConstrainSelectedInstOperands,
     /* 123867 */     // GIR_Coverage, 3179,
     /* 123867 */     GIR_EraseRootFromParent_Done,
     /* 123868 */   // Label 1772: @123868
     /* 123868 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(123926), // Rule ID 3180 //
     /* 123873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 123876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123899 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 123902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123924 */     GIR_RootConstrainSelectedInstOperands,
     /* 123925 */     // GIR_Coverage, 3180,
     /* 123925 */     GIR_EraseRootFromParent_Done,
     /* 123926 */   // Label 1773: @123926
     /* 123926 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(123978), // Rule ID 3194 //
     /* 123931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123954 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 123957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123976 */     GIR_RootConstrainSelectedInstOperands,
     /* 123977 */     // GIR_Coverage, 3194,
     /* 123977 */     GIR_EraseRootFromParent_Done,
     /* 123978 */   // Label 1774: @123978
     /* 123978 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(124033), // Rule ID 3195 //
     /* 123983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 124009 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 124012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 124019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124031 */     GIR_RootConstrainSelectedInstOperands,
     /* 124032 */     // GIR_Coverage, 3195,
     /* 124032 */     GIR_EraseRootFromParent_Done,
     /* 124033 */   // Label 1775: @124033
     /* 124033 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(124088), // Rule ID 3196 //
     /* 124038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 124041 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 124064 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 124064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 124067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 124074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124086 */     GIR_RootConstrainSelectedInstOperands,
     /* 124087 */     // GIR_Coverage, 3196,
     /* 124087 */     GIR_EraseRootFromParent_Done,
     /* 124088 */   // Label 1776: @124088
     /* 124088 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124146), // Rule ID 3197 //
     /* 124093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 124096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 124119 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 124122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 124129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124144 */     GIR_RootConstrainSelectedInstOperands,
     /* 124145 */     // GIR_Coverage, 3197,
     /* 124145 */     GIR_EraseRootFromParent_Done,
     /* 124146 */   // Label 1777: @124146
     /* 124146 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124202), // Rule ID 8038 //
     /* 124151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 124154 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124159 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 124163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124178 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124200 */     GIR_RootConstrainSelectedInstOperands,
     /* 124201 */     // GIR_Coverage, 8038,
     /* 124201 */     GIR_EraseRootFromParent_Done,
     /* 124202 */   // Label 1778: @124202
     /* 124202 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124258), // Rule ID 8042 //
     /* 124207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 124210 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124215 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 124219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124234 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124256 */     GIR_RootConstrainSelectedInstOperands,
     /* 124257 */     // GIR_Coverage, 8042,
     /* 124257 */     GIR_EraseRootFromParent_Done,
     /* 124258 */   // Label 1779: @124258
     /* 124258 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124319), // Rule ID 8106 //
     /* 124263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 124266 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124271 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 124288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124295 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124317 */     GIR_RootConstrainSelectedInstOperands,
     /* 124318 */     // GIR_Coverage, 8106,
     /* 124318 */     GIR_EraseRootFromParent_Done,
     /* 124319 */   // Label 1780: @124319
     /* 124319 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124380), // Rule ID 8110 //
     /* 124324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 124327 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124332 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 124349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124356 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124378 */     GIR_RootConstrainSelectedInstOperands,
     /* 124379 */     // GIR_Coverage, 8110,
     /* 124379 */     GIR_EraseRootFromParent_Done,
     /* 124380 */   // Label 1781: @124380
     /* 124380 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124431), // Rule ID 3171 //
     /* 124385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124396 */     // MIs[0] sbase
     /* 124396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124412 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124417 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124429 */     GIR_RootConstrainSelectedInstOperands,
     /* 124430 */     // GIR_Coverage, 3171,
     /* 124430 */     GIR_EraseRootFromParent_Done,
     /* 124431 */   // Label 1782: @124431
     /* 124431 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(124482), // Rule ID 3188 //
     /* 124436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124447 */     // MIs[0] sbase
     /* 124447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124463 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124468 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124480 */     GIR_RootConstrainSelectedInstOperands,
     /* 124481 */     // GIR_Coverage, 3188,
     /* 124481 */     GIR_EraseRootFromParent_Done,
     /* 124482 */   // Label 1783: @124482
     /* 124482 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(124529), // Rule ID 3176 //
     /* 124487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124498 */     // MIs[0] sbase
     /* 124498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124510 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 124513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124515 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124527 */     GIR_RootConstrainSelectedInstOperands,
     /* 124528 */     // GIR_Coverage, 3176,
     /* 124528 */     GIR_EraseRootFromParent_Done,
     /* 124529 */   // Label 1784: @124529
     /* 124529 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(124576), // Rule ID 3193 //
     /* 124534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124545 */     // MIs[0] sbase
     /* 124545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124557 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 124560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124562 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124574 */     GIR_RootConstrainSelectedInstOperands,
     /* 124575 */     // GIR_Coverage, 3193,
     /* 124575 */     GIR_EraseRootFromParent_Done,
     /* 124576 */   // Label 1785: @124576
     /* 124576 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(124620), // Rule ID 3182 //
     /* 124581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124589 */     // MIs[0] sbase
     /* 124589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124601 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124606 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124618 */     GIR_RootConstrainSelectedInstOperands,
     /* 124619 */     // GIR_Coverage, 3182,
     /* 124619 */     GIR_EraseRootFromParent_Done,
     /* 124620 */   // Label 1786: @124620
     /* 124620 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(124664), // Rule ID 3199 //
     /* 124625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124633 */     // MIs[0] sbase
     /* 124633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124645 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124650 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124662 */     GIR_RootConstrainSelectedInstOperands,
     /* 124663 */     // GIR_Coverage, 3199,
     /* 124663 */     GIR_EraseRootFromParent_Done,
     /* 124664 */   // Label 1787: @124664
     /* 124664 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(124724), // Rule ID 6519 //
     /* 124669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 124672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 124692 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 124692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 124695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124722 */     GIR_RootConstrainSelectedInstOperands,
     /* 124723 */     // GIR_Coverage, 6519,
     /* 124723 */     GIR_EraseRootFromParent_Done,
     /* 124724 */   // Label 1788: @124724
     /* 124724 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(124784), // Rule ID 6521 //
     /* 124729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 124732 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 124752 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 124752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 124755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124782 */     GIR_RootConstrainSelectedInstOperands,
     /* 124783 */     // GIR_Coverage, 6521,
     /* 124783 */     GIR_EraseRootFromParent_Done,
     /* 124784 */   // Label 1789: @124784
     /* 124784 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(124841), // Rule ID 4350 //
     /* 124789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124792 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124812 */     // (ld:{ *:[v4i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 124815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124839 */     GIR_RootConstrainSelectedInstOperands,
     /* 124840 */     // GIR_Coverage, 4350,
     /* 124840 */     GIR_EraseRootFromParent_Done,
     /* 124841 */   // Label 1790: @124841
     /* 124841 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(124898), // Rule ID 4356 //
     /* 124846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124849 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124869 */     // (ld:{ *:[v4f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 124872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124896 */     GIR_RootConstrainSelectedInstOperands,
     /* 124897 */     // GIR_Coverage, 4356,
     /* 124897 */     GIR_EraseRootFromParent_Done,
     /* 124898 */   // Label 1791: @124898
     /* 124898 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(124950), // Rule ID 4349 //
     /* 124903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124906 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124926 */     // (ld:{ *:[v4i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 124929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124948 */     GIR_RootConstrainSelectedInstOperands,
     /* 124949 */     // GIR_Coverage, 4349,
     /* 124949 */     GIR_EraseRootFromParent_Done,
     /* 124950 */   // Label 1792: @124950
     /* 124950 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(125002), // Rule ID 4355 //
     /* 124955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124958 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124978 */     // (ld:{ *:[v4f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 124981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125000 */     GIR_RootConstrainSelectedInstOperands,
     /* 125001 */     // GIR_Coverage, 4355,
     /* 125001 */     GIR_EraseRootFromParent_Done,
     /* 125002 */   // Label 1793: @125002
     /* 125002 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(125054), // Rule ID 4348 //
     /* 125007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 125010 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 125030 */     // (ld:{ *:[v4i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 125033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125052 */     GIR_RootConstrainSelectedInstOperands,
     /* 125053 */     // GIR_Coverage, 4348,
     /* 125053 */     GIR_EraseRootFromParent_Done,
     /* 125054 */   // Label 1794: @125054
     /* 125054 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(125106), // Rule ID 4354 //
     /* 125059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 125062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 125082 */     // (ld:{ *:[v4f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 125085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125104 */     GIR_RootConstrainSelectedInstOperands,
     /* 125105 */     // GIR_Coverage, 4354,
     /* 125105 */     GIR_EraseRootFromParent_Done,
     /* 125106 */   // Label 1795: @125106
     /* 125106 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(125173), // Rule ID 4571 //
     /* 125111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125114 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125136 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 125139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125171 */     GIR_RootConstrainSelectedInstOperands,
     /* 125172 */     // GIR_Coverage, 4571,
     /* 125172 */     GIR_EraseRootFromParent_Done,
     /* 125173 */   // Label 1796: @125173
     /* 125173 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(125237), // Rule ID 4573 //
     /* 125178 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125200 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 125203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125235 */     GIR_RootConstrainSelectedInstOperands,
     /* 125236 */     // GIR_Coverage, 4573,
     /* 125236 */     GIR_EraseRootFromParent_Done,
     /* 125237 */   // Label 1797: @125237
     /* 125237 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(125304), // Rule ID 4575 //
     /* 125242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125267 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 125270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125302 */     GIR_RootConstrainSelectedInstOperands,
     /* 125303 */     // GIR_Coverage, 4575,
     /* 125303 */     GIR_EraseRootFromParent_Done,
     /* 125304 */   // Label 1798: @125304
     /* 125304 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(125368), // Rule ID 4577 //
     /* 125309 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125331 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 125334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125366 */     GIR_RootConstrainSelectedInstOperands,
     /* 125367 */     // GIR_Coverage, 4577,
     /* 125367 */     GIR_EraseRootFromParent_Done,
     /* 125368 */   // Label 1799: @125368
     /* 125368 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(125433), // Rule ID 6518 //
     /* 125373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 125376 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 125396 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 125396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 125399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125431 */     GIR_RootConstrainSelectedInstOperands,
     /* 125432 */     // GIR_Coverage, 6518,
     /* 125432 */     GIR_EraseRootFromParent_Done,
     /* 125433 */   // Label 1800: @125433
     /* 125433 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(125498), // Rule ID 6520 //
     /* 125438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 125441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 125461 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 125461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 125464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125496 */     GIR_RootConstrainSelectedInstOperands,
     /* 125497 */     // GIR_Coverage, 6520,
     /* 125497 */     GIR_EraseRootFromParent_Done,
     /* 125498 */   // Label 1801: @125498
     /* 125498 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(125559), // Rule ID 7937 //
     /* 125503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125510 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125530 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 125533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125557 */     GIR_RootConstrainSelectedInstOperands,
     /* 125558 */     // GIR_Coverage, 7937,
     /* 125558 */     GIR_EraseRootFromParent_Done,
     /* 125559 */   // Label 1802: @125559
     /* 125559 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(125620), // Rule ID 7973 //
     /* 125564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125571 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125591 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 125594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125618 */     GIR_RootConstrainSelectedInstOperands,
     /* 125619 */     // GIR_Coverage, 7973,
     /* 125619 */     GIR_EraseRootFromParent_Done,
     /* 125620 */   // Label 1803: @125620
     /* 125620 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(125682), // Rule ID 4570 //
     /* 125625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125628 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125650 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 125653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125680 */     GIR_RootConstrainSelectedInstOperands,
     /* 125681 */     // GIR_Coverage, 4570,
     /* 125681 */     GIR_EraseRootFromParent_Done,
     /* 125682 */   // Label 1804: @125682
     /* 125682 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(125741), // Rule ID 4572 //
     /* 125687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125709 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 125712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125739 */     GIR_RootConstrainSelectedInstOperands,
     /* 125740 */     // GIR_Coverage, 4572,
     /* 125740 */     GIR_EraseRootFromParent_Done,
     /* 125741 */   // Label 1805: @125741
     /* 125741 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(125803), // Rule ID 4574 //
     /* 125746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125771 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 125774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125801 */     GIR_RootConstrainSelectedInstOperands,
     /* 125802 */     // GIR_Coverage, 4574,
     /* 125802 */     GIR_EraseRootFromParent_Done,
     /* 125803 */   // Label 1806: @125803
     /* 125803 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(125862), // Rule ID 4576 //
     /* 125808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125830 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 125833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125860 */     GIR_RootConstrainSelectedInstOperands,
     /* 125861 */     // GIR_Coverage, 4576,
     /* 125861 */     GIR_EraseRootFromParent_Done,
     /* 125862 */   // Label 1807: @125862
     /* 125862 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(125919), // Rule ID 7939 //
     /* 125867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125890 */     // (ld:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 125893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125917 */     GIR_RootConstrainSelectedInstOperands,
     /* 125918 */     // GIR_Coverage, 7939,
     /* 125918 */     GIR_EraseRootFromParent_Done,
     /* 125919 */   // Label 1808: @125919
     /* 125919 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(125976), // Rule ID 7975 //
     /* 125924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125947 */     // (ld:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125974 */     GIR_RootConstrainSelectedInstOperands,
     /* 125975 */     // GIR_Coverage, 7975,
     /* 125975 */     GIR_EraseRootFromParent_Done,
     /* 125976 */   // Label 1809: @125976
     /* 125976 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(126035), // Rule ID 3930 //
     /* 125981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125984 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 126006 */     // (ld:{ *:[v4i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 126009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 126016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 126021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126033 */     GIR_RootConstrainSelectedInstOperands,
     /* 126034 */     // GIR_Coverage, 3930,
     /* 126034 */     GIR_EraseRootFromParent_Done,
     /* 126035 */   // Label 1810: @126035
     /* 126035 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(126094), // Rule ID 3934 //
     /* 126040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 126043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 126065 */     // (ld:{ *:[v4f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 126068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 126075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126092 */     GIR_RootConstrainSelectedInstOperands,
     /* 126093 */     // GIR_Coverage, 3934,
     /* 126093 */     GIR_EraseRootFromParent_Done,
     /* 126094 */   // Label 1811: @126094
     /* 126094 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(126148), // Rule ID 3929 //
     /* 126099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 126102 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 126124 */     // (ld:{ *:[v4i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 126127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126146 */     GIR_RootConstrainSelectedInstOperands,
     /* 126147 */     // GIR_Coverage, 3929,
     /* 126147 */     GIR_EraseRootFromParent_Done,
     /* 126148 */   // Label 1812: @126148
     /* 126148 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(126202), // Rule ID 3933 //
     /* 126153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 126156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 126178 */     // (ld:{ *:[v4f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 126181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126200 */     GIR_RootConstrainSelectedInstOperands,
     /* 126201 */     // GIR_Coverage, 3933,
     /* 126201 */     GIR_EraseRootFromParent_Done,
     /* 126202 */   // Label 1813: @126202
     /* 126202 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(126257), // Rule ID 3647 //
     /* 126207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 126210 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 126233 */     // (ld:{ *:[v4i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 126236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126255 */     GIR_RootConstrainSelectedInstOperands,
     /* 126256 */     // GIR_Coverage, 3647,
     /* 126256 */     GIR_EraseRootFromParent_Done,
     /* 126257 */   // Label 1814: @126257
     /* 126257 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(126312), // Rule ID 3649 //
     /* 126262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 126265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 126288 */     // (ld:{ *:[v4f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 126291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126310 */     GIR_RootConstrainSelectedInstOperands,
     /* 126311 */     // GIR_Coverage, 3649,
     /* 126311 */     GIR_EraseRootFromParent_Done,
     /* 126312 */   // Label 1815: @126312
     /* 126312 */   GIM_Reject,
     /* 126313 */ // Label 1745: @126313
     /* 126313 */ GIM_Reject,
     /* 126314 */ // Label 896: @126314
     /* 126314 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(127965),
     /* 126319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126322 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126326 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126330 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(126386), // Rule ID 3306 //
     /* 126335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126357 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126384 */     GIR_RootConstrainSelectedInstOperands,
     /* 126385 */     // GIR_Coverage, 3306,
     /* 126385 */     GIR_EraseRootFromParent_Done,
     /* 126386 */   // Label 1817: @126386
     /* 126386 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(126442), // Rule ID 3323 //
     /* 126391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126413 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126440 */     GIR_RootConstrainSelectedInstOperands,
     /* 126441 */     // GIR_Coverage, 3323,
     /* 126441 */     GIR_EraseRootFromParent_Done,
     /* 126442 */   // Label 1818: @126442
     /* 126442 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(126494), // Rule ID 3311 //
     /* 126447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126465 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 126468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126492 */     GIR_RootConstrainSelectedInstOperands,
     /* 126493 */     // GIR_Coverage, 3311,
     /* 126493 */     GIR_EraseRootFromParent_Done,
     /* 126494 */   // Label 1819: @126494
     /* 126494 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(126546), // Rule ID 3328 //
     /* 126499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126517 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 126520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126544 */     GIR_RootConstrainSelectedInstOperands,
     /* 126545 */     // GIR_Coverage, 3328,
     /* 126545 */     GIR_EraseRootFromParent_Done,
     /* 126546 */   // Label 1820: @126546
     /* 126546 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(126598), // Rule ID 3317 //
     /* 126551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126569 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126596 */     GIR_RootConstrainSelectedInstOperands,
     /* 126597 */     // GIR_Coverage, 3317,
     /* 126597 */     GIR_EraseRootFromParent_Done,
     /* 126598 */   // Label 1821: @126598
     /* 126598 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(126650), // Rule ID 3334 //
     /* 126603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126621 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126648 */     GIR_RootConstrainSelectedInstOperands,
     /* 126649 */     // GIR_Coverage, 3334,
     /* 126649 */     GIR_EraseRootFromParent_Done,
     /* 126650 */   // Label 1822: @126650
     /* 126650 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(126701), // Rule ID 3302 //
     /* 126655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126677 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 126680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126699 */     GIR_RootConstrainSelectedInstOperands,
     /* 126700 */     // GIR_Coverage, 3302,
     /* 126700 */     GIR_EraseRootFromParent_Done,
     /* 126701 */   // Label 1823: @126701
     /* 126701 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(126752), // Rule ID 3303 //
     /* 126706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126728 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 126731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126750 */     GIR_RootConstrainSelectedInstOperands,
     /* 126751 */     // GIR_Coverage, 3303,
     /* 126751 */     GIR_EraseRootFromParent_Done,
     /* 126752 */   // Label 1824: @126752
     /* 126752 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(126803), // Rule ID 3304 //
     /* 126757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126779 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 126782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126801 */     GIR_RootConstrainSelectedInstOperands,
     /* 126802 */     // GIR_Coverage, 3304,
     /* 126802 */     GIR_EraseRootFromParent_Done,
     /* 126803 */   // Label 1825: @126803
     /* 126803 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(126857), // Rule ID 3305 //
     /* 126808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126830 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126855 */     GIR_RootConstrainSelectedInstOperands,
     /* 126856 */     // GIR_Coverage, 3305,
     /* 126856 */     GIR_EraseRootFromParent_Done,
     /* 126857 */   // Label 1826: @126857
     /* 126857 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(126908), // Rule ID 3319 //
     /* 126862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126884 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 126887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126906 */     GIR_RootConstrainSelectedInstOperands,
     /* 126907 */     // GIR_Coverage, 3319,
     /* 126907 */     GIR_EraseRootFromParent_Done,
     /* 126908 */   // Label 1827: @126908
     /* 126908 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(126959), // Rule ID 3320 //
     /* 126913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126935 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 126938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126957 */     GIR_RootConstrainSelectedInstOperands,
     /* 126958 */     // GIR_Coverage, 3320,
     /* 126958 */     GIR_EraseRootFromParent_Done,
     /* 126959 */   // Label 1828: @126959
     /* 126959 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(127010), // Rule ID 3321 //
     /* 126964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126986 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 126989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127008 */     GIR_RootConstrainSelectedInstOperands,
     /* 127009 */     // GIR_Coverage, 3321,
     /* 127009 */     GIR_EraseRootFromParent_Done,
     /* 127010 */   // Label 1829: @127010
     /* 127010 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(127064), // Rule ID 3322 //
     /* 127015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127037 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 127040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127062 */     GIR_RootConstrainSelectedInstOperands,
     /* 127063 */     // GIR_Coverage, 3322,
     /* 127063 */     GIR_EraseRootFromParent_Done,
     /* 127064 */   // Label 1830: @127064
     /* 127064 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(127111), // Rule ID 3308 //
     /* 127069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127087 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127109 */     GIR_RootConstrainSelectedInstOperands,
     /* 127110 */     // GIR_Coverage, 3308,
     /* 127110 */     GIR_EraseRootFromParent_Done,
     /* 127111 */   // Label 1831: @127111
     /* 127111 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(127158), // Rule ID 3309 //
     /* 127116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 127119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127134 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 127137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127156 */     GIR_RootConstrainSelectedInstOperands,
     /* 127157 */     // GIR_Coverage, 3309,
     /* 127157 */     GIR_EraseRootFromParent_Done,
     /* 127158 */   // Label 1832: @127158
     /* 127158 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(127208), // Rule ID 3310 //
     /* 127163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127181 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 127184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127206 */     GIR_RootConstrainSelectedInstOperands,
     /* 127207 */     // GIR_Coverage, 3310,
     /* 127207 */     GIR_EraseRootFromParent_Done,
     /* 127208 */   // Label 1833: @127208
     /* 127208 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(127255), // Rule ID 3325 //
     /* 127213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127231 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127253 */     GIR_RootConstrainSelectedInstOperands,
     /* 127254 */     // GIR_Coverage, 3325,
     /* 127254 */     GIR_EraseRootFromParent_Done,
     /* 127255 */   // Label 1834: @127255
     /* 127255 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(127302), // Rule ID 3326 //
     /* 127260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 127263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127278 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 127281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127300 */     GIR_RootConstrainSelectedInstOperands,
     /* 127301 */     // GIR_Coverage, 3326,
     /* 127301 */     GIR_EraseRootFromParent_Done,
     /* 127302 */   // Label 1835: @127302
     /* 127302 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(127352), // Rule ID 3327 //
     /* 127307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127325 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 127328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127350 */     GIR_RootConstrainSelectedInstOperands,
     /* 127351 */     // GIR_Coverage, 3327,
     /* 127351 */     GIR_EraseRootFromParent_Done,
     /* 127352 */   // Label 1836: @127352
     /* 127352 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(127396), // Rule ID 3313 //
     /* 127357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127372 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127394 */     GIR_RootConstrainSelectedInstOperands,
     /* 127395 */     // GIR_Coverage, 3313,
     /* 127395 */     GIR_EraseRootFromParent_Done,
     /* 127396 */   // Label 1837: @127396
     /* 127396 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(127443), // Rule ID 3314 //
     /* 127401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127419 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 127422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127441 */     GIR_RootConstrainSelectedInstOperands,
     /* 127442 */     // GIR_Coverage, 3314,
     /* 127442 */     GIR_EraseRootFromParent_Done,
     /* 127443 */   // Label 1838: @127443
     /* 127443 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(127490), // Rule ID 3315 //
     /* 127448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127466 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 127469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127488 */     GIR_RootConstrainSelectedInstOperands,
     /* 127489 */     // GIR_Coverage, 3315,
     /* 127489 */     GIR_EraseRootFromParent_Done,
     /* 127490 */   // Label 1839: @127490
     /* 127490 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(127540), // Rule ID 3316 //
     /* 127495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127513 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 127516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127538 */     GIR_RootConstrainSelectedInstOperands,
     /* 127539 */     // GIR_Coverage, 3316,
     /* 127539 */     GIR_EraseRootFromParent_Done,
     /* 127540 */   // Label 1840: @127540
     /* 127540 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(127584), // Rule ID 3330 //
     /* 127545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127560 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127582 */     GIR_RootConstrainSelectedInstOperands,
     /* 127583 */     // GIR_Coverage, 3330,
     /* 127583 */     GIR_EraseRootFromParent_Done,
     /* 127584 */   // Label 1841: @127584
     /* 127584 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(127631), // Rule ID 3331 //
     /* 127589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127607 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 127610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127629 */     GIR_RootConstrainSelectedInstOperands,
     /* 127630 */     // GIR_Coverage, 3331,
     /* 127630 */     GIR_EraseRootFromParent_Done,
     /* 127631 */   // Label 1842: @127631
     /* 127631 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(127678), // Rule ID 3332 //
     /* 127636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127654 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 127657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127676 */     GIR_RootConstrainSelectedInstOperands,
     /* 127677 */     // GIR_Coverage, 3332,
     /* 127677 */     GIR_EraseRootFromParent_Done,
     /* 127678 */   // Label 1843: @127678
     /* 127678 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(127728), // Rule ID 3333 //
     /* 127683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127701 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 127704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127726 */     GIR_RootConstrainSelectedInstOperands,
     /* 127727 */     // GIR_Coverage, 3333,
     /* 127727 */     GIR_EraseRootFromParent_Done,
     /* 127728 */   // Label 1844: @127728
     /* 127728 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(127771), // Rule ID 3307 //
     /* 127733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127740 */     // MIs[0] sbase
     /* 127740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127752 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127757 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127769 */     GIR_RootConstrainSelectedInstOperands,
     /* 127770 */     // GIR_Coverage, 3307,
     /* 127770 */     GIR_EraseRootFromParent_Done,
     /* 127771 */   // Label 1845: @127771
     /* 127771 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(127814), // Rule ID 3324 //
     /* 127776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127783 */     // MIs[0] sbase
     /* 127783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127795 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127800 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127812 */     GIR_RootConstrainSelectedInstOperands,
     /* 127813 */     // GIR_Coverage, 3324,
     /* 127813 */     GIR_EraseRootFromParent_Done,
     /* 127814 */   // Label 1846: @127814
     /* 127814 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(127853), // Rule ID 3312 //
     /* 127819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127826 */     // MIs[0] sbase
     /* 127826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127834 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127839 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127851 */     GIR_RootConstrainSelectedInstOperands,
     /* 127852 */     // GIR_Coverage, 3312,
     /* 127852 */     GIR_EraseRootFromParent_Done,
     /* 127853 */   // Label 1847: @127853
     /* 127853 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(127892), // Rule ID 3329 //
     /* 127858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127865 */     // MIs[0] sbase
     /* 127865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127873 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127878 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127890 */     GIR_RootConstrainSelectedInstOperands,
     /* 127891 */     // GIR_Coverage, 3329,
     /* 127891 */     GIR_EraseRootFromParent_Done,
     /* 127892 */   // Label 1848: @127892
     /* 127892 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(127928), // Rule ID 3318 //
     /* 127897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127901 */     // MIs[0] sbase
     /* 127901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127909 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127914 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127926 */     GIR_RootConstrainSelectedInstOperands,
     /* 127927 */     // GIR_Coverage, 3318,
     /* 127927 */     GIR_EraseRootFromParent_Done,
     /* 127928 */   // Label 1849: @127928
     /* 127928 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(127964), // Rule ID 3335 //
     /* 127933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127937 */     // MIs[0] sbase
     /* 127937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127945 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127950 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127962 */     GIR_RootConstrainSelectedInstOperands,
     /* 127963 */     // GIR_Coverage, 3335,
     /* 127963 */     GIR_EraseRootFromParent_Done,
     /* 127964 */   // Label 1850: @127964
     /* 127964 */   GIM_Reject,
     /* 127965 */ // Label 1816: @127965
     /* 127965 */ GIM_Reject,
     /* 127966 */ // Label 897: @127966
     /* 127966 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(131763),
     /* 127971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127974 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(128038), // Rule ID 3238 //
     /* 127979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128009 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128036 */     GIR_RootConstrainSelectedInstOperands,
     /* 128037 */     // GIR_Coverage, 3238,
     /* 128037 */     GIR_EraseRootFromParent_Done,
     /* 128038 */   // Label 1852: @128038
     /* 128038 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(128102), // Rule ID 3255 //
     /* 128043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128073 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128100 */     GIR_RootConstrainSelectedInstOperands,
     /* 128101 */     // GIR_Coverage, 3255,
     /* 128101 */     GIR_EraseRootFromParent_Done,
     /* 128102 */   // Label 1853: @128102
     /* 128102 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(128162), // Rule ID 3243 //
     /* 128107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128133 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 128136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128160 */     GIR_RootConstrainSelectedInstOperands,
     /* 128161 */     // GIR_Coverage, 3243,
     /* 128161 */     GIR_EraseRootFromParent_Done,
     /* 128162 */   // Label 1854: @128162
     /* 128162 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(128222), // Rule ID 3260 //
     /* 128167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128193 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 128196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128220 */     GIR_RootConstrainSelectedInstOperands,
     /* 128221 */     // GIR_Coverage, 3260,
     /* 128221 */     GIR_EraseRootFromParent_Done,
     /* 128222 */   // Label 1855: @128222
     /* 128222 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(128282), // Rule ID 3249 //
     /* 128227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 128230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128253 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128280 */     GIR_RootConstrainSelectedInstOperands,
     /* 128281 */     // GIR_Coverage, 3249,
     /* 128281 */     GIR_EraseRootFromParent_Done,
     /* 128282 */   // Label 1856: @128282
     /* 128282 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(128342), // Rule ID 3266 //
     /* 128287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 128290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128313 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128340 */     GIR_RootConstrainSelectedInstOperands,
     /* 128341 */     // GIR_Coverage, 3266,
     /* 128341 */     GIR_EraseRootFromParent_Done,
     /* 128342 */   // Label 1857: @128342
     /* 128342 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(128401), // Rule ID 3234 //
     /* 128347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128377 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128399 */     GIR_RootConstrainSelectedInstOperands,
     /* 128400 */     // GIR_Coverage, 3234,
     /* 128400 */     GIR_EraseRootFromParent_Done,
     /* 128401 */   // Label 1858: @128401
     /* 128401 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(128460), // Rule ID 3235 //
     /* 128406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 128409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 128436 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 128439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128458 */     GIR_RootConstrainSelectedInstOperands,
     /* 128459 */     // GIR_Coverage, 3235,
     /* 128459 */     GIR_EraseRootFromParent_Done,
     /* 128460 */   // Label 1859: @128460
     /* 128460 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(128519), // Rule ID 3236 //
     /* 128465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128495 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 128498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128517 */     GIR_RootConstrainSelectedInstOperands,
     /* 128518 */     // GIR_Coverage, 3236,
     /* 128518 */     GIR_EraseRootFromParent_Done,
     /* 128519 */   // Label 1860: @128519
     /* 128519 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(128581), // Rule ID 3237 //
     /* 128524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128554 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128579 */     GIR_RootConstrainSelectedInstOperands,
     /* 128580 */     // GIR_Coverage, 3237,
     /* 128580 */     GIR_EraseRootFromParent_Done,
     /* 128581 */   // Label 1861: @128581
     /* 128581 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(128640), // Rule ID 3251 //
     /* 128586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128616 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128638 */     GIR_RootConstrainSelectedInstOperands,
     /* 128639 */     // GIR_Coverage, 3251,
     /* 128639 */     GIR_EraseRootFromParent_Done,
     /* 128640 */   // Label 1862: @128640
     /* 128640 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(128699), // Rule ID 3252 //
     /* 128645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 128648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 128675 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 128678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128697 */     GIR_RootConstrainSelectedInstOperands,
     /* 128698 */     // GIR_Coverage, 3252,
     /* 128698 */     GIR_EraseRootFromParent_Done,
     /* 128699 */   // Label 1863: @128699
     /* 128699 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(128758), // Rule ID 3253 //
     /* 128704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128734 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 128737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128756 */     GIR_RootConstrainSelectedInstOperands,
     /* 128757 */     // GIR_Coverage, 3253,
     /* 128757 */     GIR_EraseRootFromParent_Done,
     /* 128758 */   // Label 1864: @128758
     /* 128758 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(128820), // Rule ID 3254 //
     /* 128763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128793 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128818 */     GIR_RootConstrainSelectedInstOperands,
     /* 128819 */     // GIR_Coverage, 3254,
     /* 128819 */     GIR_EraseRootFromParent_Done,
     /* 128820 */   // Label 1865: @128820
     /* 128820 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(128875), // Rule ID 3240 //
     /* 128825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128851 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 128854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128873 */     GIR_RootConstrainSelectedInstOperands,
     /* 128874 */     // GIR_Coverage, 3240,
     /* 128874 */     GIR_EraseRootFromParent_Done,
     /* 128875 */   // Label 1866: @128875
     /* 128875 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(128930), // Rule ID 3241 //
     /* 128880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128906 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 128909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128928 */     GIR_RootConstrainSelectedInstOperands,
     /* 128929 */     // GIR_Coverage, 3241,
     /* 128929 */     GIR_EraseRootFromParent_Done,
     /* 128930 */   // Label 1867: @128930
     /* 128930 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(128988), // Rule ID 3242 //
     /* 128935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128961 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 128964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128986 */     GIR_RootConstrainSelectedInstOperands,
     /* 128987 */     // GIR_Coverage, 3242,
     /* 128987 */     GIR_EraseRootFromParent_Done,
     /* 128988 */   // Label 1868: @128988
     /* 128988 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(129043), // Rule ID 3257 //
     /* 128993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 129019 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 129022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129041 */     GIR_RootConstrainSelectedInstOperands,
     /* 129042 */     // GIR_Coverage, 3257,
     /* 129042 */     GIR_EraseRootFromParent_Done,
     /* 129043 */   // Label 1869: @129043
     /* 129043 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(129098), // Rule ID 3258 //
     /* 129048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 129051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129074 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 129074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 129077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129096 */     GIR_RootConstrainSelectedInstOperands,
     /* 129097 */     // GIR_Coverage, 3258,
     /* 129097 */     GIR_EraseRootFromParent_Done,
     /* 129098 */   // Label 1870: @129098
     /* 129098 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(129156), // Rule ID 3259 //
     /* 129103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 129106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129118 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129129 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 129132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129154 */     GIR_RootConstrainSelectedInstOperands,
     /* 129155 */     // GIR_Coverage, 3259,
     /* 129155 */     GIR_EraseRootFromParent_Done,
     /* 129156 */   // Label 1871: @129156
     /* 129156 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(129216), // Rule ID 8053 //
     /* 129161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 129164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129168 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129173 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129192 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129214 */     GIR_RootConstrainSelectedInstOperands,
     /* 129215 */     // GIR_Coverage, 8053,
     /* 129215 */     GIR_EraseRootFromParent_Done,
     /* 129216 */   // Label 1872: @129216
     /* 129216 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(129276), // Rule ID 8057 //
     /* 129221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 129224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129228 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129233 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129252 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129274 */     GIR_RootConstrainSelectedInstOperands,
     /* 129275 */     // GIR_Coverage, 8057,
     /* 129275 */     GIR_EraseRootFromParent_Done,
     /* 129276 */   // Label 1873: @129276
     /* 129276 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(129341), // Rule ID 8121 //
     /* 129281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 129284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 129310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129317 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129339 */     GIR_RootConstrainSelectedInstOperands,
     /* 129340 */     // GIR_Coverage, 8121,
     /* 129340 */     GIR_EraseRootFromParent_Done,
     /* 129341 */   // Label 1874: @129341
     /* 129341 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(129406), // Rule ID 8125 //
     /* 129346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 129349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129353 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 129375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129382 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129404 */     GIR_RootConstrainSelectedInstOperands,
     /* 129405 */     // GIR_Coverage, 8125,
     /* 129405 */     GIR_EraseRootFromParent_Done,
     /* 129406 */   // Label 1875: @129406
     /* 129406 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(129458), // Rule ID 3245 //
     /* 129411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 129434 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129456 */     GIR_RootConstrainSelectedInstOperands,
     /* 129457 */     // GIR_Coverage, 3245,
     /* 129457 */     GIR_EraseRootFromParent_Done,
     /* 129458 */   // Label 1876: @129458
     /* 129458 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(129513), // Rule ID 3246 //
     /* 129463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 129466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 129489 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 129492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129511 */     GIR_RootConstrainSelectedInstOperands,
     /* 129512 */     // GIR_Coverage, 3246,
     /* 129512 */     GIR_EraseRootFromParent_Done,
     /* 129513 */   // Label 1877: @129513
     /* 129513 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(129568), // Rule ID 3247 //
     /* 129518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 129521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129544 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 129544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 129547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129566 */     GIR_RootConstrainSelectedInstOperands,
     /* 129567 */     // GIR_Coverage, 3247,
     /* 129567 */     GIR_EraseRootFromParent_Done,
     /* 129568 */   // Label 1878: @129568
     /* 129568 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(129626), // Rule ID 3248 //
     /* 129573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 129576 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129599 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 129602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129624 */     GIR_RootConstrainSelectedInstOperands,
     /* 129625 */     // GIR_Coverage, 3248,
     /* 129625 */     GIR_EraseRootFromParent_Done,
     /* 129626 */   // Label 1879: @129626
     /* 129626 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(129678), // Rule ID 3262 //
     /* 129631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 129654 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129676 */     GIR_RootConstrainSelectedInstOperands,
     /* 129677 */     // GIR_Coverage, 3262,
     /* 129677 */     GIR_EraseRootFromParent_Done,
     /* 129678 */   // Label 1880: @129678
     /* 129678 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(129733), // Rule ID 3263 //
     /* 129683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 129686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 129709 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 129712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129731 */     GIR_RootConstrainSelectedInstOperands,
     /* 129732 */     // GIR_Coverage, 3263,
     /* 129732 */     GIR_EraseRootFromParent_Done,
     /* 129733 */   // Label 1881: @129733
     /* 129733 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(129788), // Rule ID 3264 //
     /* 129738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 129741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129764 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 129764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 129767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129786 */     GIR_RootConstrainSelectedInstOperands,
     /* 129787 */     // GIR_Coverage, 3264,
     /* 129787 */     GIR_EraseRootFromParent_Done,
     /* 129788 */   // Label 1882: @129788
     /* 129788 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(129846), // Rule ID 3265 //
     /* 129793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 129796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129819 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 129822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129844 */     GIR_RootConstrainSelectedInstOperands,
     /* 129845 */     // GIR_Coverage, 3265,
     /* 129845 */     GIR_EraseRootFromParent_Done,
     /* 129846 */   // Label 1883: @129846
     /* 129846 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(129902), // Rule ID 8054 //
     /* 129851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 129854 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129859 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129878 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129900 */     GIR_RootConstrainSelectedInstOperands,
     /* 129901 */     // GIR_Coverage, 8054,
     /* 129901 */     GIR_EraseRootFromParent_Done,
     /* 129902 */   // Label 1884: @129902
     /* 129902 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(129958), // Rule ID 8058 //
     /* 129907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 129910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129915 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129934 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129956 */     GIR_RootConstrainSelectedInstOperands,
     /* 129957 */     // GIR_Coverage, 8058,
     /* 129957 */     GIR_EraseRootFromParent_Done,
     /* 129958 */   // Label 1885: @129958
     /* 129958 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(130019), // Rule ID 8122 //
     /* 129963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 129966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 129988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129995 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 130005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130017 */     GIR_RootConstrainSelectedInstOperands,
     /* 130018 */     // GIR_Coverage, 8122,
     /* 130018 */     GIR_EraseRootFromParent_Done,
     /* 130019 */   // Label 1886: @130019
     /* 130019 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(130080), // Rule ID 8126 //
     /* 130024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 130027 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 130032 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 130037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 130049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 130056 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 130056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 130059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 130066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130078 */     GIR_RootConstrainSelectedInstOperands,
     /* 130079 */     // GIR_Coverage, 8126,
     /* 130079 */     GIR_EraseRootFromParent_Done,
     /* 130080 */   // Label 1887: @130080
     /* 130080 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(130131), // Rule ID 3239 //
     /* 130085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130096 */     // MIs[0] sbase
     /* 130096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130112 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130117 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130129 */     GIR_RootConstrainSelectedInstOperands,
     /* 130130 */     // GIR_Coverage, 3239,
     /* 130130 */     GIR_EraseRootFromParent_Done,
     /* 130131 */   // Label 1888: @130131
     /* 130131 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(130182), // Rule ID 3256 //
     /* 130136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130139 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130147 */     // MIs[0] sbase
     /* 130147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130163 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130168 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130180 */     GIR_RootConstrainSelectedInstOperands,
     /* 130181 */     // GIR_Coverage, 3256,
     /* 130181 */     GIR_EraseRootFromParent_Done,
     /* 130182 */   // Label 1889: @130182
     /* 130182 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(130229), // Rule ID 3244 //
     /* 130187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130198 */     // MIs[0] sbase
     /* 130198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130210 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 130213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130215 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130227 */     GIR_RootConstrainSelectedInstOperands,
     /* 130228 */     // GIR_Coverage, 3244,
     /* 130228 */     GIR_EraseRootFromParent_Done,
     /* 130229 */   // Label 1890: @130229
     /* 130229 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(130276), // Rule ID 3261 //
     /* 130234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130245 */     // MIs[0] sbase
     /* 130245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130257 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 130260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130262 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130274 */     GIR_RootConstrainSelectedInstOperands,
     /* 130275 */     // GIR_Coverage, 3261,
     /* 130275 */     GIR_EraseRootFromParent_Done,
     /* 130276 */   // Label 1891: @130276
     /* 130276 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(130320), // Rule ID 3250 //
     /* 130281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130289 */     // MIs[0] sbase
     /* 130289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130301 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130306 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130318 */     GIR_RootConstrainSelectedInstOperands,
     /* 130319 */     // GIR_Coverage, 3250,
     /* 130319 */     GIR_EraseRootFromParent_Done,
     /* 130320 */   // Label 1892: @130320
     /* 130320 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(130364), // Rule ID 3267 //
     /* 130325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130333 */     // MIs[0] sbase
     /* 130333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130345 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130350 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130362 */     GIR_RootConstrainSelectedInstOperands,
     /* 130363 */     // GIR_Coverage, 3267,
     /* 130363 */     GIR_EraseRootFromParent_Done,
     /* 130364 */   // Label 1893: @130364
     /* 130364 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(130421), // Rule ID 4374 //
     /* 130369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 130372 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 130392 */     // (ld:{ *:[v8i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 130395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 130407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130419 */     GIR_RootConstrainSelectedInstOperands,
     /* 130420 */     // GIR_Coverage, 4374,
     /* 130420 */     GIR_EraseRootFromParent_Done,
     /* 130421 */   // Label 1894: @130421
     /* 130421 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(130478), // Rule ID 4380 //
     /* 130426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 130429 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 130449 */     // (ld:{ *:[v8f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 130452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 130464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130476 */     GIR_RootConstrainSelectedInstOperands,
     /* 130477 */     // GIR_Coverage, 4380,
     /* 130477 */     GIR_EraseRootFromParent_Done,
     /* 130478 */   // Label 1895: @130478
     /* 130478 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(130530), // Rule ID 4373 //
     /* 130483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130486 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 130506 */     // (ld:{ *:[v8i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 130506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 130509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 130516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130528 */     GIR_RootConstrainSelectedInstOperands,
     /* 130529 */     // GIR_Coverage, 4373,
     /* 130529 */     GIR_EraseRootFromParent_Done,
     /* 130530 */   // Label 1896: @130530
     /* 130530 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(130582), // Rule ID 4379 //
     /* 130535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130538 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 130558 */     // (ld:{ *:[v8f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 130558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 130561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 130568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130580 */     GIR_RootConstrainSelectedInstOperands,
     /* 130581 */     // GIR_Coverage, 4379,
     /* 130581 */     GIR_EraseRootFromParent_Done,
     /* 130582 */   // Label 1897: @130582
     /* 130582 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(130634), // Rule ID 4372 //
     /* 130587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 130610 */     // (ld:{ *:[v8i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 130610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 130613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130632 */     GIR_RootConstrainSelectedInstOperands,
     /* 130633 */     // GIR_Coverage, 4372,
     /* 130633 */     GIR_EraseRootFromParent_Done,
     /* 130634 */   // Label 1898: @130634
     /* 130634 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(130686), // Rule ID 4378 //
     /* 130639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130642 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 130662 */     // (ld:{ *:[v8f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 130662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 130665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130684 */     GIR_RootConstrainSelectedInstOperands,
     /* 130685 */     // GIR_Coverage, 4378,
     /* 130685 */     GIR_EraseRootFromParent_Done,
     /* 130686 */   // Label 1899: @130686
     /* 130686 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(130753), // Rule ID 4587 //
     /* 130691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130694 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130716 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 130719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130751 */     GIR_RootConstrainSelectedInstOperands,
     /* 130752 */     // GIR_Coverage, 4587,
     /* 130752 */     GIR_EraseRootFromParent_Done,
     /* 130753 */   // Label 1900: @130753
     /* 130753 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(130817), // Rule ID 4589 //
     /* 130758 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130780 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 130783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130815 */     GIR_RootConstrainSelectedInstOperands,
     /* 130816 */     // GIR_Coverage, 4589,
     /* 130816 */     GIR_EraseRootFromParent_Done,
     /* 130817 */   // Label 1901: @130817
     /* 130817 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(130884), // Rule ID 4591 //
     /* 130822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130825 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130847 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 130850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130882 */     GIR_RootConstrainSelectedInstOperands,
     /* 130883 */     // GIR_Coverage, 4591,
     /* 130883 */     GIR_EraseRootFromParent_Done,
     /* 130884 */   // Label 1902: @130884
     /* 130884 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(130948), // Rule ID 4593 //
     /* 130889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130911 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 130914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130946 */     GIR_RootConstrainSelectedInstOperands,
     /* 130947 */     // GIR_Coverage, 4593,
     /* 130947 */     GIR_EraseRootFromParent_Done,
     /* 130948 */   // Label 1903: @130948
     /* 130948 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(131009), // Rule ID 7985 //
     /* 130953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 130956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130960 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 130965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 130980 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 130980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 130983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 130990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 130995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131007 */     GIR_RootConstrainSelectedInstOperands,
     /* 131008 */     // GIR_Coverage, 7985,
     /* 131008 */     GIR_EraseRootFromParent_Done,
     /* 131009 */   // Label 1904: @131009
     /* 131009 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(131070), // Rule ID 7989 //
     /* 131014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 131017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 131026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 131041 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 131041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 131044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 131051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 131056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131068 */     GIR_RootConstrainSelectedInstOperands,
     /* 131069 */     // GIR_Coverage, 7989,
     /* 131069 */     GIR_EraseRootFromParent_Done,
     /* 131070 */   // Label 1905: @131070
     /* 131070 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(131132), // Rule ID 4586 //
     /* 131075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 131078 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 131100 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 131100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 131103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 131105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 131110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131130 */     GIR_RootConstrainSelectedInstOperands,
     /* 131131 */     // GIR_Coverage, 4586,
     /* 131131 */     GIR_EraseRootFromParent_Done,
     /* 131132 */   // Label 1906: @131132
     /* 131132 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(131191), // Rule ID 4588 //
     /* 131137 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 131159 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 131159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 131162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 131164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 131169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131189 */     GIR_RootConstrainSelectedInstOperands,
     /* 131190 */     // GIR_Coverage, 4588,
     /* 131190 */     GIR_EraseRootFromParent_Done,
     /* 131191 */   // Label 1907: @131191
     /* 131191 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(131253), // Rule ID 4590 //
     /* 131196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 131199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 131221 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 131221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 131224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 131226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 131231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131251 */     GIR_RootConstrainSelectedInstOperands,
     /* 131252 */     // GIR_Coverage, 4590,
     /* 131252 */     GIR_EraseRootFromParent_Done,
     /* 131253 */   // Label 1908: @131253
     /* 131253 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(131312), // Rule ID 4592 //
     /* 131258 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 131280 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 131280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 131283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 131285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 131290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131310 */     GIR_RootConstrainSelectedInstOperands,
     /* 131311 */     // GIR_Coverage, 4592,
     /* 131311 */     GIR_EraseRootFromParent_Done,
     /* 131312 */   // Label 1909: @131312
     /* 131312 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(131369), // Rule ID 7987 //
     /* 131317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 131320 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 131325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 131340 */     // (ld:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 131340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 131343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 131350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 131355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131367 */     GIR_RootConstrainSelectedInstOperands,
     /* 131368 */     // GIR_Coverage, 7987,
     /* 131368 */     GIR_EraseRootFromParent_Done,
     /* 131369 */   // Label 1910: @131369
     /* 131369 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(131426), // Rule ID 7991 //
     /* 131374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 131377 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 131382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 131397 */     // (ld:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 131397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 131400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 131407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 131412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131424 */     GIR_RootConstrainSelectedInstOperands,
     /* 131425 */     // GIR_Coverage, 7991,
     /* 131425 */     GIR_EraseRootFromParent_Done,
     /* 131426 */   // Label 1911: @131426
     /* 131426 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(131485), // Rule ID 3946 //
     /* 131431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131434 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 131456 */     // (ld:{ *:[v8i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 131459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 131466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 131471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131483 */     GIR_RootConstrainSelectedInstOperands,
     /* 131484 */     // GIR_Coverage, 3946,
     /* 131484 */     GIR_EraseRootFromParent_Done,
     /* 131485 */   // Label 1912: @131485
     /* 131485 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(131544), // Rule ID 3950 //
     /* 131490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 131515 */     // (ld:{ *:[v8f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 131518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 131525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 131530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131542 */     GIR_RootConstrainSelectedInstOperands,
     /* 131543 */     // GIR_Coverage, 3950,
     /* 131543 */     GIR_EraseRootFromParent_Done,
     /* 131544 */   // Label 1913: @131544
     /* 131544 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(131598), // Rule ID 3945 //
     /* 131549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 131574 */     // (ld:{ *:[v8i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 131577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131596 */     GIR_RootConstrainSelectedInstOperands,
     /* 131597 */     // GIR_Coverage, 3945,
     /* 131597 */     GIR_EraseRootFromParent_Done,
     /* 131598 */   // Label 1914: @131598
     /* 131598 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(131652), // Rule ID 3949 //
     /* 131603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 131628 */     // (ld:{ *:[v8f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 131631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131650 */     GIR_RootConstrainSelectedInstOperands,
     /* 131651 */     // GIR_Coverage, 3949,
     /* 131651 */     GIR_EraseRootFromParent_Done,
     /* 131652 */   // Label 1915: @131652
     /* 131652 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(131707), // Rule ID 3655 //
     /* 131657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 131660 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 131683 */     // (ld:{ *:[v8i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 131686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131705 */     GIR_RootConstrainSelectedInstOperands,
     /* 131706 */     // GIR_Coverage, 3655,
     /* 131706 */     GIR_EraseRootFromParent_Done,
     /* 131707 */   // Label 1916: @131707
     /* 131707 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(131762), // Rule ID 3657 //
     /* 131712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 131715 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 131738 */     // (ld:{ *:[v8f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 131741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131760 */     GIR_RootConstrainSelectedInstOperands,
     /* 131761 */     // GIR_Coverage, 3657,
     /* 131761 */     GIR_EraseRootFromParent_Done,
     /* 131762 */   // Label 1917: @131762
     /* 131762 */   GIM_Reject,
     /* 131763 */ // Label 1851: @131763
     /* 131763 */ GIM_Reject,
     /* 131764 */ // Label 898: @131764
     /* 131764 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(133415),
     /* 131769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131776 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131780 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(131836), // Rule ID 3272 //
     /* 131785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131807 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131834 */     GIR_RootConstrainSelectedInstOperands,
     /* 131835 */     // GIR_Coverage, 3272,
     /* 131835 */     GIR_EraseRootFromParent_Done,
     /* 131836 */   // Label 1919: @131836
     /* 131836 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(131892), // Rule ID 3289 //
     /* 131841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131863 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131890 */     GIR_RootConstrainSelectedInstOperands,
     /* 131891 */     // GIR_Coverage, 3289,
     /* 131891 */     GIR_EraseRootFromParent_Done,
     /* 131892 */   // Label 1920: @131892
     /* 131892 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(131944), // Rule ID 3277 //
     /* 131897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131915 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 131918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131942 */     GIR_RootConstrainSelectedInstOperands,
     /* 131943 */     // GIR_Coverage, 3277,
     /* 131943 */     GIR_EraseRootFromParent_Done,
     /* 131944 */   // Label 1921: @131944
     /* 131944 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(131996), // Rule ID 3294 //
     /* 131949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131967 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 131970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131994 */     GIR_RootConstrainSelectedInstOperands,
     /* 131995 */     // GIR_Coverage, 3294,
     /* 131995 */     GIR_EraseRootFromParent_Done,
     /* 131996 */   // Label 1922: @131996
     /* 131996 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(132048), // Rule ID 3283 //
     /* 132001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 132004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 132019 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 132039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132046 */     GIR_RootConstrainSelectedInstOperands,
     /* 132047 */     // GIR_Coverage, 3283,
     /* 132047 */     GIR_EraseRootFromParent_Done,
     /* 132048 */   // Label 1923: @132048
     /* 132048 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(132100), // Rule ID 3300 //
     /* 132053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 132056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 132071 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 132091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132098 */     GIR_RootConstrainSelectedInstOperands,
     /* 132099 */     // GIR_Coverage, 3300,
     /* 132099 */     GIR_EraseRootFromParent_Done,
     /* 132100 */   // Label 1924: @132100
     /* 132100 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(132151), // Rule ID 3268 //
     /* 132105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132127 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132149 */     GIR_RootConstrainSelectedInstOperands,
     /* 132150 */     // GIR_Coverage, 3268,
     /* 132150 */     GIR_EraseRootFromParent_Done,
     /* 132151 */   // Label 1925: @132151
     /* 132151 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(132202), // Rule ID 3269 //
     /* 132156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 132159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132178 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132200 */     GIR_RootConstrainSelectedInstOperands,
     /* 132201 */     // GIR_Coverage, 3269,
     /* 132201 */     GIR_EraseRootFromParent_Done,
     /* 132202 */   // Label 1926: @132202
     /* 132202 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(132253), // Rule ID 3270 //
     /* 132207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132229 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132251 */     GIR_RootConstrainSelectedInstOperands,
     /* 132252 */     // GIR_Coverage, 3270,
     /* 132252 */     GIR_EraseRootFromParent_Done,
     /* 132253 */   // Label 1927: @132253
     /* 132253 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(132307), // Rule ID 3271 //
     /* 132258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132280 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132305 */     GIR_RootConstrainSelectedInstOperands,
     /* 132306 */     // GIR_Coverage, 3271,
     /* 132306 */     GIR_EraseRootFromParent_Done,
     /* 132307 */   // Label 1928: @132307
     /* 132307 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(132358), // Rule ID 3285 //
     /* 132312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132334 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132356 */     GIR_RootConstrainSelectedInstOperands,
     /* 132357 */     // GIR_Coverage, 3285,
     /* 132357 */     GIR_EraseRootFromParent_Done,
     /* 132358 */   // Label 1929: @132358
     /* 132358 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(132409), // Rule ID 3286 //
     /* 132363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 132366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132385 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132407 */     GIR_RootConstrainSelectedInstOperands,
     /* 132408 */     // GIR_Coverage, 3286,
     /* 132408 */     GIR_EraseRootFromParent_Done,
     /* 132409 */   // Label 1930: @132409
     /* 132409 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(132460), // Rule ID 3287 //
     /* 132414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132436 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132458 */     GIR_RootConstrainSelectedInstOperands,
     /* 132459 */     // GIR_Coverage, 3287,
     /* 132459 */     GIR_EraseRootFromParent_Done,
     /* 132460 */   // Label 1931: @132460
     /* 132460 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(132514), // Rule ID 3288 //
     /* 132465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132487 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132512 */     GIR_RootConstrainSelectedInstOperands,
     /* 132513 */     // GIR_Coverage, 3288,
     /* 132513 */     GIR_EraseRootFromParent_Done,
     /* 132514 */   // Label 1932: @132514
     /* 132514 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(132561), // Rule ID 3274 //
     /* 132519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132537 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 132540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132559 */     GIR_RootConstrainSelectedInstOperands,
     /* 132560 */     // GIR_Coverage, 3274,
     /* 132560 */     GIR_EraseRootFromParent_Done,
     /* 132561 */   // Label 1933: @132561
     /* 132561 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(132608), // Rule ID 3275 //
     /* 132566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132584 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 132587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132606 */     GIR_RootConstrainSelectedInstOperands,
     /* 132607 */     // GIR_Coverage, 3275,
     /* 132607 */     GIR_EraseRootFromParent_Done,
     /* 132608 */   // Label 1934: @132608
     /* 132608 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(132658), // Rule ID 3276 //
     /* 132613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132631 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 132634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132656 */     GIR_RootConstrainSelectedInstOperands,
     /* 132657 */     // GIR_Coverage, 3276,
     /* 132657 */     GIR_EraseRootFromParent_Done,
     /* 132658 */   // Label 1935: @132658
     /* 132658 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(132705), // Rule ID 3291 //
     /* 132663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132681 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 132684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132703 */     GIR_RootConstrainSelectedInstOperands,
     /* 132704 */     // GIR_Coverage, 3291,
     /* 132704 */     GIR_EraseRootFromParent_Done,
     /* 132705 */   // Label 1936: @132705
     /* 132705 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(132752), // Rule ID 3292 //
     /* 132710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132728 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 132731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132750 */     GIR_RootConstrainSelectedInstOperands,
     /* 132751 */     // GIR_Coverage, 3292,
     /* 132751 */     GIR_EraseRootFromParent_Done,
     /* 132752 */   // Label 1937: @132752
     /* 132752 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(132802), // Rule ID 3293 //
     /* 132757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132775 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 132778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132800 */     GIR_RootConstrainSelectedInstOperands,
     /* 132801 */     // GIR_Coverage, 3293,
     /* 132801 */     GIR_EraseRootFromParent_Done,
     /* 132802 */   // Label 1938: @132802
     /* 132802 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(132846), // Rule ID 3279 //
     /* 132807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132822 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132844 */     GIR_RootConstrainSelectedInstOperands,
     /* 132845 */     // GIR_Coverage, 3279,
     /* 132845 */     GIR_EraseRootFromParent_Done,
     /* 132846 */   // Label 1939: @132846
     /* 132846 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(132893), // Rule ID 3280 //
     /* 132851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 132854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132869 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132891 */     GIR_RootConstrainSelectedInstOperands,
     /* 132892 */     // GIR_Coverage, 3280,
     /* 132892 */     GIR_EraseRootFromParent_Done,
     /* 132893 */   // Label 1940: @132893
     /* 132893 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(132940), // Rule ID 3281 //
     /* 132898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 132901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132916 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132938 */     GIR_RootConstrainSelectedInstOperands,
     /* 132939 */     // GIR_Coverage, 3281,
     /* 132939 */     GIR_EraseRootFromParent_Done,
     /* 132940 */   // Label 1941: @132940
     /* 132940 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(132990), // Rule ID 3282 //
     /* 132945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 132948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132963 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132988 */     GIR_RootConstrainSelectedInstOperands,
     /* 132989 */     // GIR_Coverage, 3282,
     /* 132989 */     GIR_EraseRootFromParent_Done,
     /* 132990 */   // Label 1942: @132990
     /* 132990 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(133034), // Rule ID 3296 //
     /* 132995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133010 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133032 */     GIR_RootConstrainSelectedInstOperands,
     /* 133033 */     // GIR_Coverage, 3296,
     /* 133033 */     GIR_EraseRootFromParent_Done,
     /* 133034 */   // Label 1943: @133034
     /* 133034 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(133081), // Rule ID 3297 //
     /* 133039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 133042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133057 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 133060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133079 */     GIR_RootConstrainSelectedInstOperands,
     /* 133080 */     // GIR_Coverage, 3297,
     /* 133080 */     GIR_EraseRootFromParent_Done,
     /* 133081 */   // Label 1944: @133081
     /* 133081 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(133128), // Rule ID 3298 //
     /* 133086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 133089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133104 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 133107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133126 */     GIR_RootConstrainSelectedInstOperands,
     /* 133127 */     // GIR_Coverage, 3298,
     /* 133127 */     GIR_EraseRootFromParent_Done,
     /* 133128 */   // Label 1945: @133128
     /* 133128 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(133178), // Rule ID 3299 //
     /* 133133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133151 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 133154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133176 */     GIR_RootConstrainSelectedInstOperands,
     /* 133177 */     // GIR_Coverage, 3299,
     /* 133177 */     GIR_EraseRootFromParent_Done,
     /* 133178 */   // Label 1946: @133178
     /* 133178 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(133221), // Rule ID 3273 //
     /* 133183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133190 */     // MIs[0] sbase
     /* 133190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133202 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133207 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133219 */     GIR_RootConstrainSelectedInstOperands,
     /* 133220 */     // GIR_Coverage, 3273,
     /* 133220 */     GIR_EraseRootFromParent_Done,
     /* 133221 */   // Label 1947: @133221
     /* 133221 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(133264), // Rule ID 3290 //
     /* 133226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133233 */     // MIs[0] sbase
     /* 133233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133245 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133250 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133262 */     GIR_RootConstrainSelectedInstOperands,
     /* 133263 */     // GIR_Coverage, 3290,
     /* 133263 */     GIR_EraseRootFromParent_Done,
     /* 133264 */   // Label 1948: @133264
     /* 133264 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(133303), // Rule ID 3278 //
     /* 133269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133276 */     // MIs[0] sbase
     /* 133276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133284 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 133287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133289 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133301 */     GIR_RootConstrainSelectedInstOperands,
     /* 133302 */     // GIR_Coverage, 3278,
     /* 133302 */     GIR_EraseRootFromParent_Done,
     /* 133303 */   // Label 1949: @133303
     /* 133303 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(133342), // Rule ID 3295 //
     /* 133308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133315 */     // MIs[0] sbase
     /* 133315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133323 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 133326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133328 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133340 */     GIR_RootConstrainSelectedInstOperands,
     /* 133341 */     // GIR_Coverage, 3295,
     /* 133341 */     GIR_EraseRootFromParent_Done,
     /* 133342 */   // Label 1950: @133342
     /* 133342 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(133378), // Rule ID 3284 //
     /* 133347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133351 */     // MIs[0] sbase
     /* 133351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133359 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133364 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133376 */     GIR_RootConstrainSelectedInstOperands,
     /* 133377 */     // GIR_Coverage, 3284,
     /* 133377 */     GIR_EraseRootFromParent_Done,
     /* 133378 */   // Label 1951: @133378
     /* 133378 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(133414), // Rule ID 3301 //
     /* 133383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133387 */     // MIs[0] sbase
     /* 133387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133395 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133400 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133412 */     GIR_RootConstrainSelectedInstOperands,
     /* 133413 */     // GIR_Coverage, 3301,
     /* 133413 */     GIR_EraseRootFromParent_Done,
     /* 133414 */   // Label 1952: @133414
     /* 133414 */   GIM_Reject,
     /* 133415 */ // Label 1918: @133415
     /* 133415 */ GIM_Reject,
     /* 133416 */ // Label 899: @133416
     /* 133416 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(135067),
     /* 133421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133428 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133432 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(133488), // Rule ID 3408 //
     /* 133437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133459 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133486 */     GIR_RootConstrainSelectedInstOperands,
     /* 133487 */     // GIR_Coverage, 3408,
     /* 133487 */     GIR_EraseRootFromParent_Done,
     /* 133488 */   // Label 1954: @133488
     /* 133488 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(133544), // Rule ID 3425 //
     /* 133493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133515 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133542 */     GIR_RootConstrainSelectedInstOperands,
     /* 133543 */     // GIR_Coverage, 3425,
     /* 133543 */     GIR_EraseRootFromParent_Done,
     /* 133544 */   // Label 1955: @133544
     /* 133544 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(133596), // Rule ID 3413 //
     /* 133549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133567 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 133570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133594 */     GIR_RootConstrainSelectedInstOperands,
     /* 133595 */     // GIR_Coverage, 3413,
     /* 133595 */     GIR_EraseRootFromParent_Done,
     /* 133596 */   // Label 1956: @133596
     /* 133596 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(133648), // Rule ID 3430 //
     /* 133601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133619 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 133622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133646 */     GIR_RootConstrainSelectedInstOperands,
     /* 133647 */     // GIR_Coverage, 3430,
     /* 133647 */     GIR_EraseRootFromParent_Done,
     /* 133648 */   // Label 1957: @133648
     /* 133648 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(133700), // Rule ID 3419 //
     /* 133653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133671 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133698 */     GIR_RootConstrainSelectedInstOperands,
     /* 133699 */     // GIR_Coverage, 3419,
     /* 133699 */     GIR_EraseRootFromParent_Done,
     /* 133700 */   // Label 1958: @133700
     /* 133700 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(133752), // Rule ID 3436 //
     /* 133705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133723 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133750 */     GIR_RootConstrainSelectedInstOperands,
     /* 133751 */     // GIR_Coverage, 3436,
     /* 133751 */     GIR_EraseRootFromParent_Done,
     /* 133752 */   // Label 1959: @133752
     /* 133752 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(133803), // Rule ID 3404 //
     /* 133757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133779 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 133782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133801 */     GIR_RootConstrainSelectedInstOperands,
     /* 133802 */     // GIR_Coverage, 3404,
     /* 133802 */     GIR_EraseRootFromParent_Done,
     /* 133803 */   // Label 1960: @133803
     /* 133803 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(133854), // Rule ID 3405 //
     /* 133808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 133811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133830 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 133833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133852 */     GIR_RootConstrainSelectedInstOperands,
     /* 133853 */     // GIR_Coverage, 3405,
     /* 133853 */     GIR_EraseRootFromParent_Done,
     /* 133854 */   // Label 1961: @133854
     /* 133854 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(133905), // Rule ID 3406 //
     /* 133859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 133862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133881 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 133884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133903 */     GIR_RootConstrainSelectedInstOperands,
     /* 133904 */     // GIR_Coverage, 3406,
     /* 133904 */     GIR_EraseRootFromParent_Done,
     /* 133905 */   // Label 1962: @133905
     /* 133905 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(133959), // Rule ID 3407 //
     /* 133910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133932 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133957 */     GIR_RootConstrainSelectedInstOperands,
     /* 133958 */     // GIR_Coverage, 3407,
     /* 133958 */     GIR_EraseRootFromParent_Done,
     /* 133959 */   // Label 1963: @133959
     /* 133959 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(134010), // Rule ID 3421 //
     /* 133964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133986 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 133989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134008 */     GIR_RootConstrainSelectedInstOperands,
     /* 134009 */     // GIR_Coverage, 3421,
     /* 134009 */     GIR_EraseRootFromParent_Done,
     /* 134010 */   // Label 1964: @134010
     /* 134010 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(134061), // Rule ID 3422 //
     /* 134015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 134018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 134037 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 134040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134059 */     GIR_RootConstrainSelectedInstOperands,
     /* 134060 */     // GIR_Coverage, 3422,
     /* 134060 */     GIR_EraseRootFromParent_Done,
     /* 134061 */   // Label 1965: @134061
     /* 134061 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(134112), // Rule ID 3423 //
     /* 134066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 134069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134088 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 134091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134110 */     GIR_RootConstrainSelectedInstOperands,
     /* 134111 */     // GIR_Coverage, 3423,
     /* 134111 */     GIR_EraseRootFromParent_Done,
     /* 134112 */   // Label 1966: @134112
     /* 134112 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(134166), // Rule ID 3424 //
     /* 134117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134139 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 134142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134164 */     GIR_RootConstrainSelectedInstOperands,
     /* 134165 */     // GIR_Coverage, 3424,
     /* 134165 */     GIR_EraseRootFromParent_Done,
     /* 134166 */   // Label 1967: @134166
     /* 134166 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(134213), // Rule ID 3410 //
     /* 134171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134189 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134211 */     GIR_RootConstrainSelectedInstOperands,
     /* 134212 */     // GIR_Coverage, 3410,
     /* 134212 */     GIR_EraseRootFromParent_Done,
     /* 134213 */   // Label 1968: @134213
     /* 134213 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(134260), // Rule ID 3411 //
     /* 134218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 134221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134236 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 134239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134258 */     GIR_RootConstrainSelectedInstOperands,
     /* 134259 */     // GIR_Coverage, 3411,
     /* 134259 */     GIR_EraseRootFromParent_Done,
     /* 134260 */   // Label 1969: @134260
     /* 134260 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(134310), // Rule ID 3412 //
     /* 134265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134283 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 134286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134308 */     GIR_RootConstrainSelectedInstOperands,
     /* 134309 */     // GIR_Coverage, 3412,
     /* 134309 */     GIR_EraseRootFromParent_Done,
     /* 134310 */   // Label 1970: @134310
     /* 134310 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(134357), // Rule ID 3427 //
     /* 134315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134333 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134355 */     GIR_RootConstrainSelectedInstOperands,
     /* 134356 */     // GIR_Coverage, 3427,
     /* 134356 */     GIR_EraseRootFromParent_Done,
     /* 134357 */   // Label 1971: @134357
     /* 134357 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(134404), // Rule ID 3428 //
     /* 134362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 134365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134380 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 134383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134402 */     GIR_RootConstrainSelectedInstOperands,
     /* 134403 */     // GIR_Coverage, 3428,
     /* 134403 */     GIR_EraseRootFromParent_Done,
     /* 134404 */   // Label 1972: @134404
     /* 134404 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(134454), // Rule ID 3429 //
     /* 134409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134427 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 134430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134452 */     GIR_RootConstrainSelectedInstOperands,
     /* 134453 */     // GIR_Coverage, 3429,
     /* 134453 */     GIR_EraseRootFromParent_Done,
     /* 134454 */   // Label 1973: @134454
     /* 134454 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(134498), // Rule ID 3415 //
     /* 134459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134474 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134496 */     GIR_RootConstrainSelectedInstOperands,
     /* 134497 */     // GIR_Coverage, 3415,
     /* 134497 */     GIR_EraseRootFromParent_Done,
     /* 134498 */   // Label 1974: @134498
     /* 134498 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(134545), // Rule ID 3416 //
     /* 134503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 134506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 134521 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 134524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134543 */     GIR_RootConstrainSelectedInstOperands,
     /* 134544 */     // GIR_Coverage, 3416,
     /* 134544 */     GIR_EraseRootFromParent_Done,
     /* 134545 */   // Label 1975: @134545
     /* 134545 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(134592), // Rule ID 3417 //
     /* 134550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 134553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134568 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 134571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134590 */     GIR_RootConstrainSelectedInstOperands,
     /* 134591 */     // GIR_Coverage, 3417,
     /* 134591 */     GIR_EraseRootFromParent_Done,
     /* 134592 */   // Label 1976: @134592
     /* 134592 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(134642), // Rule ID 3418 //
     /* 134597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 134600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134615 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 134618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134640 */     GIR_RootConstrainSelectedInstOperands,
     /* 134641 */     // GIR_Coverage, 3418,
     /* 134641 */     GIR_EraseRootFromParent_Done,
     /* 134642 */   // Label 1977: @134642
     /* 134642 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(134686), // Rule ID 3432 //
     /* 134647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134662 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134684 */     GIR_RootConstrainSelectedInstOperands,
     /* 134685 */     // GIR_Coverage, 3432,
     /* 134685 */     GIR_EraseRootFromParent_Done,
     /* 134686 */   // Label 1978: @134686
     /* 134686 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(134733), // Rule ID 3433 //
     /* 134691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 134694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 134709 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 134712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134731 */     GIR_RootConstrainSelectedInstOperands,
     /* 134732 */     // GIR_Coverage, 3433,
     /* 134732 */     GIR_EraseRootFromParent_Done,
     /* 134733 */   // Label 1979: @134733
     /* 134733 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(134780), // Rule ID 3434 //
     /* 134738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 134741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134756 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 134759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134778 */     GIR_RootConstrainSelectedInstOperands,
     /* 134779 */     // GIR_Coverage, 3434,
     /* 134779 */     GIR_EraseRootFromParent_Done,
     /* 134780 */   // Label 1980: @134780
     /* 134780 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(134830), // Rule ID 3435 //
     /* 134785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 134788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134803 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 134806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134828 */     GIR_RootConstrainSelectedInstOperands,
     /* 134829 */     // GIR_Coverage, 3435,
     /* 134829 */     GIR_EraseRootFromParent_Done,
     /* 134830 */   // Label 1981: @134830
     /* 134830 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(134873), // Rule ID 3409 //
     /* 134835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134842 */     // MIs[0] sbase
     /* 134842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134854 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134859 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134871 */     GIR_RootConstrainSelectedInstOperands,
     /* 134872 */     // GIR_Coverage, 3409,
     /* 134872 */     GIR_EraseRootFromParent_Done,
     /* 134873 */   // Label 1982: @134873
     /* 134873 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(134916), // Rule ID 3426 //
     /* 134878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134885 */     // MIs[0] sbase
     /* 134885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134897 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134902 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134914 */     GIR_RootConstrainSelectedInstOperands,
     /* 134915 */     // GIR_Coverage, 3426,
     /* 134915 */     GIR_EraseRootFromParent_Done,
     /* 134916 */   // Label 1983: @134916
     /* 134916 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(134955), // Rule ID 3414 //
     /* 134921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134928 */     // MIs[0] sbase
     /* 134928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134936 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134941 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134953 */     GIR_RootConstrainSelectedInstOperands,
     /* 134954 */     // GIR_Coverage, 3414,
     /* 134954 */     GIR_EraseRootFromParent_Done,
     /* 134955 */   // Label 1984: @134955
     /* 134955 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(134994), // Rule ID 3431 //
     /* 134960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134967 */     // MIs[0] sbase
     /* 134967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134975 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134980 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134992 */     GIR_RootConstrainSelectedInstOperands,
     /* 134993 */     // GIR_Coverage, 3431,
     /* 134993 */     GIR_EraseRootFromParent_Done,
     /* 134994 */   // Label 1985: @134994
     /* 134994 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(135030), // Rule ID 3420 //
     /* 134999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 135003 */     // MIs[0] sbase
     /* 135003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 135011 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 135014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135016 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 135018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135028 */     GIR_RootConstrainSelectedInstOperands,
     /* 135029 */     // GIR_Coverage, 3420,
     /* 135029 */     GIR_EraseRootFromParent_Done,
     /* 135030 */   // Label 1986: @135030
     /* 135030 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(135066), // Rule ID 3437 //
     /* 135035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 135039 */     // MIs[0] sbase
     /* 135039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 135047 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 135050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135052 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 135054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135064 */     GIR_RootConstrainSelectedInstOperands,
     /* 135065 */     // GIR_Coverage, 3437,
     /* 135065 */     GIR_EraseRootFromParent_Done,
     /* 135066 */   // Label 1987: @135066
     /* 135066 */   GIM_Reject,
     /* 135067 */ // Label 1953: @135067
     /* 135067 */ GIM_Reject,
     /* 135068 */ // Label 900: @135068
     /* 135068 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(136719),
     /* 135073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135080 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 135084 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(135140), // Rule ID 3340 //
     /* 135089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135111 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135138 */     GIR_RootConstrainSelectedInstOperands,
     /* 135139 */     // GIR_Coverage, 3340,
     /* 135139 */     GIR_EraseRootFromParent_Done,
     /* 135140 */   // Label 1989: @135140
     /* 135140 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(135196), // Rule ID 3357 //
     /* 135145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135167 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135194 */     GIR_RootConstrainSelectedInstOperands,
     /* 135195 */     // GIR_Coverage, 3357,
     /* 135195 */     GIR_EraseRootFromParent_Done,
     /* 135196 */   // Label 1990: @135196
     /* 135196 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(135248), // Rule ID 3345 //
     /* 135201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135219 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135246 */     GIR_RootConstrainSelectedInstOperands,
     /* 135247 */     // GIR_Coverage, 3345,
     /* 135247 */     GIR_EraseRootFromParent_Done,
     /* 135248 */   // Label 1991: @135248
     /* 135248 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(135300), // Rule ID 3362 //
     /* 135253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135271 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135298 */     GIR_RootConstrainSelectedInstOperands,
     /* 135299 */     // GIR_Coverage, 3362,
     /* 135299 */     GIR_EraseRootFromParent_Done,
     /* 135300 */   // Label 1992: @135300
     /* 135300 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(135352), // Rule ID 3351 //
     /* 135305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135323 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135350 */     GIR_RootConstrainSelectedInstOperands,
     /* 135351 */     // GIR_Coverage, 3351,
     /* 135351 */     GIR_EraseRootFromParent_Done,
     /* 135352 */   // Label 1993: @135352
     /* 135352 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(135404), // Rule ID 3368 //
     /* 135357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135375 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135402 */     GIR_RootConstrainSelectedInstOperands,
     /* 135403 */     // GIR_Coverage, 3368,
     /* 135403 */     GIR_EraseRootFromParent_Done,
     /* 135404 */   // Label 1994: @135404
     /* 135404 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(135455), // Rule ID 3336 //
     /* 135409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135431 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135453 */     GIR_RootConstrainSelectedInstOperands,
     /* 135454 */     // GIR_Coverage, 3336,
     /* 135454 */     GIR_EraseRootFromParent_Done,
     /* 135455 */   // Label 1995: @135455
     /* 135455 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(135506), // Rule ID 3337 //
     /* 135460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135482 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135504 */     GIR_RootConstrainSelectedInstOperands,
     /* 135505 */     // GIR_Coverage, 3337,
     /* 135505 */     GIR_EraseRootFromParent_Done,
     /* 135506 */   // Label 1996: @135506
     /* 135506 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(135557), // Rule ID 3338 //
     /* 135511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135533 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135555 */     GIR_RootConstrainSelectedInstOperands,
     /* 135556 */     // GIR_Coverage, 3338,
     /* 135556 */     GIR_EraseRootFromParent_Done,
     /* 135557 */   // Label 1997: @135557
     /* 135557 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(135611), // Rule ID 3339 //
     /* 135562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135584 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135609 */     GIR_RootConstrainSelectedInstOperands,
     /* 135610 */     // GIR_Coverage, 3339,
     /* 135610 */     GIR_EraseRootFromParent_Done,
     /* 135611 */   // Label 1998: @135611
     /* 135611 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(135662), // Rule ID 3353 //
     /* 135616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135638 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135660 */     GIR_RootConstrainSelectedInstOperands,
     /* 135661 */     // GIR_Coverage, 3353,
     /* 135661 */     GIR_EraseRootFromParent_Done,
     /* 135662 */   // Label 1999: @135662
     /* 135662 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(135713), // Rule ID 3354 //
     /* 135667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135689 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135711 */     GIR_RootConstrainSelectedInstOperands,
     /* 135712 */     // GIR_Coverage, 3354,
     /* 135712 */     GIR_EraseRootFromParent_Done,
     /* 135713 */   // Label 2000: @135713
     /* 135713 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(135764), // Rule ID 3355 //
     /* 135718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135740 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135762 */     GIR_RootConstrainSelectedInstOperands,
     /* 135763 */     // GIR_Coverage, 3355,
     /* 135763 */     GIR_EraseRootFromParent_Done,
     /* 135764 */   // Label 2001: @135764
     /* 135764 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(135818), // Rule ID 3356 //
     /* 135769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135791 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135816 */     GIR_RootConstrainSelectedInstOperands,
     /* 135817 */     // GIR_Coverage, 3356,
     /* 135817 */     GIR_EraseRootFromParent_Done,
     /* 135818 */   // Label 2002: @135818
     /* 135818 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(135865), // Rule ID 3342 //
     /* 135823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135841 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 135844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135863 */     GIR_RootConstrainSelectedInstOperands,
     /* 135864 */     // GIR_Coverage, 3342,
     /* 135864 */     GIR_EraseRootFromParent_Done,
     /* 135865 */   // Label 2003: @135865
     /* 135865 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(135912), // Rule ID 3343 //
     /* 135870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135888 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 135891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135910 */     GIR_RootConstrainSelectedInstOperands,
     /* 135911 */     // GIR_Coverage, 3343,
     /* 135911 */     GIR_EraseRootFromParent_Done,
     /* 135912 */   // Label 2004: @135912
     /* 135912 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(135962), // Rule ID 3344 //
     /* 135917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135935 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135960 */     GIR_RootConstrainSelectedInstOperands,
     /* 135961 */     // GIR_Coverage, 3344,
     /* 135961 */     GIR_EraseRootFromParent_Done,
     /* 135962 */   // Label 2005: @135962
     /* 135962 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(136009), // Rule ID 3359 //
     /* 135967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135985 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 135988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136007 */     GIR_RootConstrainSelectedInstOperands,
     /* 136008 */     // GIR_Coverage, 3359,
     /* 136008 */     GIR_EraseRootFromParent_Done,
     /* 136009 */   // Label 2006: @136009
     /* 136009 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(136056), // Rule ID 3360 //
     /* 136014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 136017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136032 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 136035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136054 */     GIR_RootConstrainSelectedInstOperands,
     /* 136055 */     // GIR_Coverage, 3360,
     /* 136055 */     GIR_EraseRootFromParent_Done,
     /* 136056 */   // Label 2007: @136056
     /* 136056 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(136106), // Rule ID 3361 //
     /* 136061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136079 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 136082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136104 */     GIR_RootConstrainSelectedInstOperands,
     /* 136105 */     // GIR_Coverage, 3361,
     /* 136105 */     GIR_EraseRootFromParent_Done,
     /* 136106 */   // Label 2008: @136106
     /* 136106 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(136150), // Rule ID 3347 //
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136126 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136148 */     GIR_RootConstrainSelectedInstOperands,
     /* 136149 */     // GIR_Coverage, 3347,
     /* 136149 */     GIR_EraseRootFromParent_Done,
     /* 136150 */   // Label 2009: @136150
     /* 136150 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(136197), // Rule ID 3348 //
     /* 136155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 136158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136173 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 136176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136195 */     GIR_RootConstrainSelectedInstOperands,
     /* 136196 */     // GIR_Coverage, 3348,
     /* 136196 */     GIR_EraseRootFromParent_Done,
     /* 136197 */   // Label 2010: @136197
     /* 136197 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(136244), // Rule ID 3349 //
     /* 136202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 136205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136220 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 136223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136242 */     GIR_RootConstrainSelectedInstOperands,
     /* 136243 */     // GIR_Coverage, 3349,
     /* 136243 */     GIR_EraseRootFromParent_Done,
     /* 136244 */   // Label 2011: @136244
     /* 136244 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(136294), // Rule ID 3350 //
     /* 136249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136267 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136292 */     GIR_RootConstrainSelectedInstOperands,
     /* 136293 */     // GIR_Coverage, 3350,
     /* 136293 */     GIR_EraseRootFromParent_Done,
     /* 136294 */   // Label 2012: @136294
     /* 136294 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(136338), // Rule ID 3364 //
     /* 136299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136314 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136336 */     GIR_RootConstrainSelectedInstOperands,
     /* 136337 */     // GIR_Coverage, 3364,
     /* 136337 */     GIR_EraseRootFromParent_Done,
     /* 136338 */   // Label 2013: @136338
     /* 136338 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(136385), // Rule ID 3365 //
     /* 136343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 136346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136361 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 136364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136383 */     GIR_RootConstrainSelectedInstOperands,
     /* 136384 */     // GIR_Coverage, 3365,
     /* 136384 */     GIR_EraseRootFromParent_Done,
     /* 136385 */   // Label 2014: @136385
     /* 136385 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(136432), // Rule ID 3366 //
     /* 136390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 136393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136408 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 136411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136430 */     GIR_RootConstrainSelectedInstOperands,
     /* 136431 */     // GIR_Coverage, 3366,
     /* 136431 */     GIR_EraseRootFromParent_Done,
     /* 136432 */   // Label 2015: @136432
     /* 136432 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(136482), // Rule ID 3367 //
     /* 136437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136455 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136480 */     GIR_RootConstrainSelectedInstOperands,
     /* 136481 */     // GIR_Coverage, 3367,
     /* 136481 */     GIR_EraseRootFromParent_Done,
     /* 136482 */   // Label 2016: @136482
     /* 136482 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(136525), // Rule ID 3341 //
     /* 136487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136494 */     // MIs[0] sbase
     /* 136494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136506 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136511 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136523 */     GIR_RootConstrainSelectedInstOperands,
     /* 136524 */     // GIR_Coverage, 3341,
     /* 136524 */     GIR_EraseRootFromParent_Done,
     /* 136525 */   // Label 2017: @136525
     /* 136525 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(136568), // Rule ID 3358 //
     /* 136530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136537 */     // MIs[0] sbase
     /* 136537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136549 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136554 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136566 */     GIR_RootConstrainSelectedInstOperands,
     /* 136567 */     // GIR_Coverage, 3358,
     /* 136567 */     GIR_EraseRootFromParent_Done,
     /* 136568 */   // Label 2018: @136568
     /* 136568 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(136607), // Rule ID 3346 //
     /* 136573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136580 */     // MIs[0] sbase
     /* 136580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136588 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136593 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136605 */     GIR_RootConstrainSelectedInstOperands,
     /* 136606 */     // GIR_Coverage, 3346,
     /* 136606 */     GIR_EraseRootFromParent_Done,
     /* 136607 */   // Label 2019: @136607
     /* 136607 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(136646), // Rule ID 3363 //
     /* 136612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136619 */     // MIs[0] sbase
     /* 136619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136627 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136632 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136644 */     GIR_RootConstrainSelectedInstOperands,
     /* 136645 */     // GIR_Coverage, 3363,
     /* 136645 */     GIR_EraseRootFromParent_Done,
     /* 136646 */   // Label 2020: @136646
     /* 136646 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(136682), // Rule ID 3352 //
     /* 136651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136655 */     // MIs[0] sbase
     /* 136655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136663 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136668 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136680 */     GIR_RootConstrainSelectedInstOperands,
     /* 136681 */     // GIR_Coverage, 3352,
     /* 136681 */     GIR_EraseRootFromParent_Done,
     /* 136682 */   // Label 2021: @136682
     /* 136682 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(136718), // Rule ID 3369 //
     /* 136687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136691 */     // MIs[0] sbase
     /* 136691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136699 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136704 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136716 */     GIR_RootConstrainSelectedInstOperands,
     /* 136717 */     // GIR_Coverage, 3369,
     /* 136717 */     GIR_EraseRootFromParent_Done,
     /* 136718 */   // Label 2022: @136718
     /* 136718 */   GIM_Reject,
     /* 136719 */ // Label 1988: @136719
     /* 136719 */ GIM_Reject,
     /* 136720 */ // Label 901: @136720
     /* 136720 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(138371),
     /* 136725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136732 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 136736 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(136792), // Rule ID 3374 //
     /* 136741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136763 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136790 */     GIR_RootConstrainSelectedInstOperands,
     /* 136791 */     // GIR_Coverage, 3374,
     /* 136791 */     GIR_EraseRootFromParent_Done,
     /* 136792 */   // Label 2024: @136792
     /* 136792 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(136848), // Rule ID 3391 //
     /* 136797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136819 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136846 */     GIR_RootConstrainSelectedInstOperands,
     /* 136847 */     // GIR_Coverage, 3391,
     /* 136847 */     GIR_EraseRootFromParent_Done,
     /* 136848 */   // Label 2025: @136848
     /* 136848 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(136900), // Rule ID 3379 //
     /* 136853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136871 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 136874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136898 */     GIR_RootConstrainSelectedInstOperands,
     /* 136899 */     // GIR_Coverage, 3379,
     /* 136899 */     GIR_EraseRootFromParent_Done,
     /* 136900 */   // Label 2026: @136900
     /* 136900 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(136952), // Rule ID 3396 //
     /* 136905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136923 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 136926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136950 */     GIR_RootConstrainSelectedInstOperands,
     /* 136951 */     // GIR_Coverage, 3396,
     /* 136951 */     GIR_EraseRootFromParent_Done,
     /* 136952 */   // Label 2027: @136952
     /* 136952 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(137004), // Rule ID 3385 //
     /* 136957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136975 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137002 */     GIR_RootConstrainSelectedInstOperands,
     /* 137003 */     // GIR_Coverage, 3385,
     /* 137003 */     GIR_EraseRootFromParent_Done,
     /* 137004 */   // Label 2028: @137004
     /* 137004 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(137056), // Rule ID 3402 //
     /* 137009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137027 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137054 */     GIR_RootConstrainSelectedInstOperands,
     /* 137055 */     // GIR_Coverage, 3402,
     /* 137055 */     GIR_EraseRootFromParent_Done,
     /* 137056 */   // Label 2029: @137056
     /* 137056 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(137107), // Rule ID 3370 //
     /* 137061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137083 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137105 */     GIR_RootConstrainSelectedInstOperands,
     /* 137106 */     // GIR_Coverage, 3370,
     /* 137106 */     GIR_EraseRootFromParent_Done,
     /* 137107 */   // Label 2030: @137107
     /* 137107 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(137158), // Rule ID 3371 //
     /* 137112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 137115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137134 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137156 */     GIR_RootConstrainSelectedInstOperands,
     /* 137157 */     // GIR_Coverage, 3371,
     /* 137157 */     GIR_EraseRootFromParent_Done,
     /* 137158 */   // Label 2031: @137158
     /* 137158 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(137209), // Rule ID 3372 //
     /* 137163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137185 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137207 */     GIR_RootConstrainSelectedInstOperands,
     /* 137208 */     // GIR_Coverage, 3372,
     /* 137208 */     GIR_EraseRootFromParent_Done,
     /* 137209 */   // Label 2032: @137209
     /* 137209 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(137263), // Rule ID 3373 //
     /* 137214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137236 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137261 */     GIR_RootConstrainSelectedInstOperands,
     /* 137262 */     // GIR_Coverage, 3373,
     /* 137262 */     GIR_EraseRootFromParent_Done,
     /* 137263 */   // Label 2033: @137263
     /* 137263 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(137314), // Rule ID 3387 //
     /* 137268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137290 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137312 */     GIR_RootConstrainSelectedInstOperands,
     /* 137313 */     // GIR_Coverage, 3387,
     /* 137313 */     GIR_EraseRootFromParent_Done,
     /* 137314 */   // Label 2034: @137314
     /* 137314 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(137365), // Rule ID 3388 //
     /* 137319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 137322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137341 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137363 */     GIR_RootConstrainSelectedInstOperands,
     /* 137364 */     // GIR_Coverage, 3388,
     /* 137364 */     GIR_EraseRootFromParent_Done,
     /* 137365 */   // Label 2035: @137365
     /* 137365 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(137416), // Rule ID 3389 //
     /* 137370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137392 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137414 */     GIR_RootConstrainSelectedInstOperands,
     /* 137415 */     // GIR_Coverage, 3389,
     /* 137415 */     GIR_EraseRootFromParent_Done,
     /* 137416 */   // Label 2036: @137416
     /* 137416 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(137470), // Rule ID 3390 //
     /* 137421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137443 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137468 */     GIR_RootConstrainSelectedInstOperands,
     /* 137469 */     // GIR_Coverage, 3390,
     /* 137469 */     GIR_EraseRootFromParent_Done,
     /* 137470 */   // Label 2037: @137470
     /* 137470 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(137517), // Rule ID 3376 //
     /* 137475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137493 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137515 */     GIR_RootConstrainSelectedInstOperands,
     /* 137516 */     // GIR_Coverage, 3376,
     /* 137516 */     GIR_EraseRootFromParent_Done,
     /* 137517 */   // Label 2038: @137517
     /* 137517 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(137564), // Rule ID 3377 //
     /* 137522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137540 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137562 */     GIR_RootConstrainSelectedInstOperands,
     /* 137563 */     // GIR_Coverage, 3377,
     /* 137563 */     GIR_EraseRootFromParent_Done,
     /* 137564 */   // Label 2039: @137564
     /* 137564 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(137614), // Rule ID 3378 //
     /* 137569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137587 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137612 */     GIR_RootConstrainSelectedInstOperands,
     /* 137613 */     // GIR_Coverage, 3378,
     /* 137613 */     GIR_EraseRootFromParent_Done,
     /* 137614 */   // Label 2040: @137614
     /* 137614 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(137661), // Rule ID 3393 //
     /* 137619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137637 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137659 */     GIR_RootConstrainSelectedInstOperands,
     /* 137660 */     // GIR_Coverage, 3393,
     /* 137660 */     GIR_EraseRootFromParent_Done,
     /* 137661 */   // Label 2041: @137661
     /* 137661 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(137708), // Rule ID 3394 //
     /* 137666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137684 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137706 */     GIR_RootConstrainSelectedInstOperands,
     /* 137707 */     // GIR_Coverage, 3394,
     /* 137707 */     GIR_EraseRootFromParent_Done,
     /* 137708 */   // Label 2042: @137708
     /* 137708 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(137758), // Rule ID 3395 //
     /* 137713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137731 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */     GIR_RootConstrainSelectedInstOperands,
     /* 137757 */     // GIR_Coverage, 3395,
     /* 137757 */     GIR_EraseRootFromParent_Done,
     /* 137758 */   // Label 2043: @137758
     /* 137758 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(137802), // Rule ID 3381 //
     /* 137763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137778 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137800 */     GIR_RootConstrainSelectedInstOperands,
     /* 137801 */     // GIR_Coverage, 3381,
     /* 137801 */     GIR_EraseRootFromParent_Done,
     /* 137802 */   // Label 2044: @137802
     /* 137802 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(137849), // Rule ID 3382 //
     /* 137807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 137810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137825 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137847 */     GIR_RootConstrainSelectedInstOperands,
     /* 137848 */     // GIR_Coverage, 3382,
     /* 137848 */     GIR_EraseRootFromParent_Done,
     /* 137849 */   // Label 2045: @137849
     /* 137849 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(137896), // Rule ID 3383 //
     /* 137854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 137857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137872 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137894 */     GIR_RootConstrainSelectedInstOperands,
     /* 137895 */     // GIR_Coverage, 3383,
     /* 137895 */     GIR_EraseRootFromParent_Done,
     /* 137896 */   // Label 2046: @137896
     /* 137896 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(137946), // Rule ID 3384 //
     /* 137901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137919 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137944 */     GIR_RootConstrainSelectedInstOperands,
     /* 137945 */     // GIR_Coverage, 3384,
     /* 137945 */     GIR_EraseRootFromParent_Done,
     /* 137946 */   // Label 2047: @137946
     /* 137946 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(137990), // Rule ID 3398 //
     /* 137951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137966 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137988 */     GIR_RootConstrainSelectedInstOperands,
     /* 137989 */     // GIR_Coverage, 3398,
     /* 137989 */     GIR_EraseRootFromParent_Done,
     /* 137990 */   // Label 2048: @137990
     /* 137990 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(138037), // Rule ID 3399 //
     /* 137995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 137998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138013 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138035 */     GIR_RootConstrainSelectedInstOperands,
     /* 138036 */     // GIR_Coverage, 3399,
     /* 138036 */     GIR_EraseRootFromParent_Done,
     /* 138037 */   // Label 2049: @138037
     /* 138037 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(138084), // Rule ID 3400 //
     /* 138042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 138045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138060 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138082 */     GIR_RootConstrainSelectedInstOperands,
     /* 138083 */     // GIR_Coverage, 3400,
     /* 138083 */     GIR_EraseRootFromParent_Done,
     /* 138084 */   // Label 2050: @138084
     /* 138084 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(138134), // Rule ID 3401 //
     /* 138089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138107 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138132 */     GIR_RootConstrainSelectedInstOperands,
     /* 138133 */     // GIR_Coverage, 3401,
     /* 138133 */     GIR_EraseRootFromParent_Done,
     /* 138134 */   // Label 2051: @138134
     /* 138134 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(138177), // Rule ID 3375 //
     /* 138139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138146 */     // MIs[0] sbase
     /* 138146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138158 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138163 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138175 */     GIR_RootConstrainSelectedInstOperands,
     /* 138176 */     // GIR_Coverage, 3375,
     /* 138176 */     GIR_EraseRootFromParent_Done,
     /* 138177 */   // Label 2052: @138177
     /* 138177 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(138220), // Rule ID 3392 //
     /* 138182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138189 */     // MIs[0] sbase
     /* 138189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138201 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138206 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138218 */     GIR_RootConstrainSelectedInstOperands,
     /* 138219 */     // GIR_Coverage, 3392,
     /* 138219 */     GIR_EraseRootFromParent_Done,
     /* 138220 */   // Label 2053: @138220
     /* 138220 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(138259), // Rule ID 3380 //
     /* 138225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138232 */     // MIs[0] sbase
     /* 138232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138240 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138245 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138257 */     GIR_RootConstrainSelectedInstOperands,
     /* 138258 */     // GIR_Coverage, 3380,
     /* 138258 */     GIR_EraseRootFromParent_Done,
     /* 138259 */   // Label 2054: @138259
     /* 138259 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(138298), // Rule ID 3397 //
     /* 138264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138271 */     // MIs[0] sbase
     /* 138271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138279 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138284 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138296 */     GIR_RootConstrainSelectedInstOperands,
     /* 138297 */     // GIR_Coverage, 3397,
     /* 138297 */     GIR_EraseRootFromParent_Done,
     /* 138298 */   // Label 2055: @138298
     /* 138298 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(138334), // Rule ID 3386 //
     /* 138303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138307 */     // MIs[0] sbase
     /* 138307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138315 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138320 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138332 */     GIR_RootConstrainSelectedInstOperands,
     /* 138333 */     // GIR_Coverage, 3386,
     /* 138333 */     GIR_EraseRootFromParent_Done,
     /* 138334 */   // Label 2056: @138334
     /* 138334 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(138370), // Rule ID 3403 //
     /* 138339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138343 */     // MIs[0] sbase
     /* 138343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138351 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138356 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138368 */     GIR_RootConstrainSelectedInstOperands,
     /* 138369 */     // GIR_Coverage, 3403,
     /* 138369 */     GIR_EraseRootFromParent_Done,
     /* 138370 */   // Label 2057: @138370
     /* 138370 */   GIM_Reject,
     /* 138371 */ // Label 2023: @138371
     /* 138371 */ GIM_Reject,
     /* 138372 */ // Label 902: @138372
     /* 138372 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(140023),
     /* 138377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138384 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 138388 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(138444), // Rule ID 3442 //
     /* 138393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138415 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138442 */     GIR_RootConstrainSelectedInstOperands,
     /* 138443 */     // GIR_Coverage, 3442,
     /* 138443 */     GIR_EraseRootFromParent_Done,
     /* 138444 */   // Label 2059: @138444
     /* 138444 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(138500), // Rule ID 3459 //
     /* 138449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138471 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138498 */     GIR_RootConstrainSelectedInstOperands,
     /* 138499 */     // GIR_Coverage, 3459,
     /* 138499 */     GIR_EraseRootFromParent_Done,
     /* 138500 */   // Label 2060: @138500
     /* 138500 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(138552), // Rule ID 3447 //
     /* 138505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138523 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 138526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138550 */     GIR_RootConstrainSelectedInstOperands,
     /* 138551 */     // GIR_Coverage, 3447,
     /* 138551 */     GIR_EraseRootFromParent_Done,
     /* 138552 */   // Label 2061: @138552
     /* 138552 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(138604), // Rule ID 3464 //
     /* 138557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138575 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 138578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138602 */     GIR_RootConstrainSelectedInstOperands,
     /* 138603 */     // GIR_Coverage, 3464,
     /* 138603 */     GIR_EraseRootFromParent_Done,
     /* 138604 */   // Label 2062: @138604
     /* 138604 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(138656), // Rule ID 3453 //
     /* 138609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138627 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138654 */     GIR_RootConstrainSelectedInstOperands,
     /* 138655 */     // GIR_Coverage, 3453,
     /* 138655 */     GIR_EraseRootFromParent_Done,
     /* 138656 */   // Label 2063: @138656
     /* 138656 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(138708), // Rule ID 3470 //
     /* 138661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138679 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138706 */     GIR_RootConstrainSelectedInstOperands,
     /* 138707 */     // GIR_Coverage, 3470,
     /* 138707 */     GIR_EraseRootFromParent_Done,
     /* 138708 */   // Label 2064: @138708
     /* 138708 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(138759), // Rule ID 3438 //
     /* 138713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138735 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138757 */     GIR_RootConstrainSelectedInstOperands,
     /* 138758 */     // GIR_Coverage, 3438,
     /* 138758 */     GIR_EraseRootFromParent_Done,
     /* 138759 */   // Label 2065: @138759
     /* 138759 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(138810), // Rule ID 3439 //
     /* 138764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 138767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138786 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138808 */     GIR_RootConstrainSelectedInstOperands,
     /* 138809 */     // GIR_Coverage, 3439,
     /* 138809 */     GIR_EraseRootFromParent_Done,
     /* 138810 */   // Label 2066: @138810
     /* 138810 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(138861), // Rule ID 3440 //
     /* 138815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 138818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138837 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138859 */     GIR_RootConstrainSelectedInstOperands,
     /* 138860 */     // GIR_Coverage, 3440,
     /* 138860 */     GIR_EraseRootFromParent_Done,
     /* 138861 */   // Label 2067: @138861
     /* 138861 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(138915), // Rule ID 3441 //
     /* 138866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138888 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138913 */     GIR_RootConstrainSelectedInstOperands,
     /* 138914 */     // GIR_Coverage, 3441,
     /* 138914 */     GIR_EraseRootFromParent_Done,
     /* 138915 */   // Label 2068: @138915
     /* 138915 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(138966), // Rule ID 3455 //
     /* 138920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138942 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138964 */     GIR_RootConstrainSelectedInstOperands,
     /* 138965 */     // GIR_Coverage, 3455,
     /* 138965 */     GIR_EraseRootFromParent_Done,
     /* 138966 */   // Label 2069: @138966
     /* 138966 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(139017), // Rule ID 3456 //
     /* 138971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 138974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138993 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139015 */     GIR_RootConstrainSelectedInstOperands,
     /* 139016 */     // GIR_Coverage, 3456,
     /* 139016 */     GIR_EraseRootFromParent_Done,
     /* 139017 */   // Label 2070: @139017
     /* 139017 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(139068), // Rule ID 3457 //
     /* 139022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139044 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 139047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139066 */     GIR_RootConstrainSelectedInstOperands,
     /* 139067 */     // GIR_Coverage, 3457,
     /* 139067 */     GIR_EraseRootFromParent_Done,
     /* 139068 */   // Label 2071: @139068
     /* 139068 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(139122), // Rule ID 3458 //
     /* 139073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139095 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 139098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139120 */     GIR_RootConstrainSelectedInstOperands,
     /* 139121 */     // GIR_Coverage, 3458,
     /* 139121 */     GIR_EraseRootFromParent_Done,
     /* 139122 */   // Label 2072: @139122
     /* 139122 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(139169), // Rule ID 3444 //
     /* 139127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139145 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139167 */     GIR_RootConstrainSelectedInstOperands,
     /* 139168 */     // GIR_Coverage, 3444,
     /* 139168 */     GIR_EraseRootFromParent_Done,
     /* 139169 */   // Label 2073: @139169
     /* 139169 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(139216), // Rule ID 3445 //
     /* 139174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139192 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 139195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139214 */     GIR_RootConstrainSelectedInstOperands,
     /* 139215 */     // GIR_Coverage, 3445,
     /* 139215 */     GIR_EraseRootFromParent_Done,
     /* 139216 */   // Label 2074: @139216
     /* 139216 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(139266), // Rule ID 3446 //
     /* 139221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139239 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 139242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139264 */     GIR_RootConstrainSelectedInstOperands,
     /* 139265 */     // GIR_Coverage, 3446,
     /* 139265 */     GIR_EraseRootFromParent_Done,
     /* 139266 */   // Label 2075: @139266
     /* 139266 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(139313), // Rule ID 3461 //
     /* 139271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139289 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139311 */     GIR_RootConstrainSelectedInstOperands,
     /* 139312 */     // GIR_Coverage, 3461,
     /* 139312 */     GIR_EraseRootFromParent_Done,
     /* 139313 */   // Label 2076: @139313
     /* 139313 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(139360), // Rule ID 3462 //
     /* 139318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139336 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 139339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139358 */     GIR_RootConstrainSelectedInstOperands,
     /* 139359 */     // GIR_Coverage, 3462,
     /* 139359 */     GIR_EraseRootFromParent_Done,
     /* 139360 */   // Label 2077: @139360
     /* 139360 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(139410), // Rule ID 3463 //
     /* 139365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139383 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 139386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139408 */     GIR_RootConstrainSelectedInstOperands,
     /* 139409 */     // GIR_Coverage, 3463,
     /* 139409 */     GIR_EraseRootFromParent_Done,
     /* 139410 */   // Label 2078: @139410
     /* 139410 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(139454), // Rule ID 3449 //
     /* 139415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139430 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139452 */     GIR_RootConstrainSelectedInstOperands,
     /* 139453 */     // GIR_Coverage, 3449,
     /* 139453 */     GIR_EraseRootFromParent_Done,
     /* 139454 */   // Label 2079: @139454
     /* 139454 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(139501), // Rule ID 3450 //
     /* 139459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139477 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 139480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139499 */     GIR_RootConstrainSelectedInstOperands,
     /* 139500 */     // GIR_Coverage, 3450,
     /* 139500 */     GIR_EraseRootFromParent_Done,
     /* 139501 */   // Label 2080: @139501
     /* 139501 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(139548), // Rule ID 3451 //
     /* 139506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139524 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 139527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139546 */     GIR_RootConstrainSelectedInstOperands,
     /* 139547 */     // GIR_Coverage, 3451,
     /* 139547 */     GIR_EraseRootFromParent_Done,
     /* 139548 */   // Label 2081: @139548
     /* 139548 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(139598), // Rule ID 3452 //
     /* 139553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139571 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 139574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139596 */     GIR_RootConstrainSelectedInstOperands,
     /* 139597 */     // GIR_Coverage, 3452,
     /* 139597 */     GIR_EraseRootFromParent_Done,
     /* 139598 */   // Label 2082: @139598
     /* 139598 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(139642), // Rule ID 3466 //
     /* 139603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139618 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139640 */     GIR_RootConstrainSelectedInstOperands,
     /* 139641 */     // GIR_Coverage, 3466,
     /* 139641 */     GIR_EraseRootFromParent_Done,
     /* 139642 */   // Label 2083: @139642
     /* 139642 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(139689), // Rule ID 3467 //
     /* 139647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139665 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 139668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139687 */     GIR_RootConstrainSelectedInstOperands,
     /* 139688 */     // GIR_Coverage, 3467,
     /* 139688 */     GIR_EraseRootFromParent_Done,
     /* 139689 */   // Label 2084: @139689
     /* 139689 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(139736), // Rule ID 3468 //
     /* 139694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139712 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 139715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139734 */     GIR_RootConstrainSelectedInstOperands,
     /* 139735 */     // GIR_Coverage, 3468,
     /* 139735 */     GIR_EraseRootFromParent_Done,
     /* 139736 */   // Label 2085: @139736
     /* 139736 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(139786), // Rule ID 3469 //
     /* 139741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139759 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 139762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139784 */     GIR_RootConstrainSelectedInstOperands,
     /* 139785 */     // GIR_Coverage, 3469,
     /* 139785 */     GIR_EraseRootFromParent_Done,
     /* 139786 */   // Label 2086: @139786
     /* 139786 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(139829), // Rule ID 3443 //
     /* 139791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139798 */     // MIs[0] sbase
     /* 139798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139810 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139815 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139827 */     GIR_RootConstrainSelectedInstOperands,
     /* 139828 */     // GIR_Coverage, 3443,
     /* 139828 */     GIR_EraseRootFromParent_Done,
     /* 139829 */   // Label 2087: @139829
     /* 139829 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(139872), // Rule ID 3460 //
     /* 139834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139841 */     // MIs[0] sbase
     /* 139841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139853 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139858 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139870 */     GIR_RootConstrainSelectedInstOperands,
     /* 139871 */     // GIR_Coverage, 3460,
     /* 139871 */     GIR_EraseRootFromParent_Done,
     /* 139872 */   // Label 2088: @139872
     /* 139872 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(139911), // Rule ID 3448 //
     /* 139877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139884 */     // MIs[0] sbase
     /* 139884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139892 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139897 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139909 */     GIR_RootConstrainSelectedInstOperands,
     /* 139910 */     // GIR_Coverage, 3448,
     /* 139910 */     GIR_EraseRootFromParent_Done,
     /* 139911 */   // Label 2089: @139911
     /* 139911 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(139950), // Rule ID 3465 //
     /* 139916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139923 */     // MIs[0] sbase
     /* 139923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139931 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139936 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139948 */     GIR_RootConstrainSelectedInstOperands,
     /* 139949 */     // GIR_Coverage, 3465,
     /* 139949 */     GIR_EraseRootFromParent_Done,
     /* 139950 */   // Label 2090: @139950
     /* 139950 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(139986), // Rule ID 3454 //
     /* 139955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139959 */     // MIs[0] sbase
     /* 139959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139967 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139972 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139984 */     GIR_RootConstrainSelectedInstOperands,
     /* 139985 */     // GIR_Coverage, 3454,
     /* 139985 */     GIR_EraseRootFromParent_Done,
     /* 139986 */   // Label 2091: @139986
     /* 139986 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(140022), // Rule ID 3471 //
     /* 139991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139995 */     // MIs[0] sbase
     /* 139995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140003 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 140006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140008 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140020 */     GIR_RootConstrainSelectedInstOperands,
     /* 140021 */     // GIR_Coverage, 3471,
     /* 140021 */     GIR_EraseRootFromParent_Done,
     /* 140022 */   // Label 2092: @140022
     /* 140022 */   GIM_Reject,
     /* 140023 */ // Label 2058: @140023
     /* 140023 */ GIM_Reject,
     /* 140024 */ // Label 903: @140024
     /* 140024 */ GIM_Reject,
     /* 140025 */ // Label 15: @140025
     /* 140025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2095*/ GIMT_Encode4(147090),
     /* 140036 */ /*GILLT_s16*//*Label 2093*/ GIMT_Encode4(140044),
     /* 140040 */ /*GILLT_s32*//*Label 2094*/ GIMT_Encode4(142482),
     /* 140044 */ // Label 2093: @140044
     /* 140044 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(140114), // Rule ID 6451 //
     /* 140049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 140052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140062 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140075 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 140082 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 140085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140112 */   GIR_RootConstrainSelectedInstOperands,
     /* 140113 */   // GIR_Coverage, 6451,
     /* 140113 */   GIR_EraseRootFromParent_Done,
     /* 140114 */ // Label 2096: @140114
     /* 140114 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(140184), // Rule ID 6453 //
     /* 140119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 140122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140132 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 140152 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 140155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140182 */   GIR_RootConstrainSelectedInstOperands,
     /* 140183 */   // GIR_Coverage, 6453,
     /* 140183 */   GIR_EraseRootFromParent_Done,
     /* 140184 */ // Label 2097: @140184
     /* 140184 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(140251), // Rule ID 4206 //
     /* 140189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 140192 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140195 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140202 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 140222 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 140225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140249 */   GIR_RootConstrainSelectedInstOperands,
     /* 140250 */   // GIR_Coverage, 4206,
     /* 140250 */   GIR_EraseRootFromParent_Done,
     /* 140251 */ // Label 2098: @140251
     /* 140251 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(140318), // Rule ID 4221 //
     /* 140256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 140259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140262 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140269 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140278 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140282 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 140289 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 140292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140316 */   GIR_RootConstrainSelectedInstOperands,
     /* 140317 */   // GIR_Coverage, 4221,
     /* 140317 */   GIR_EraseRootFromParent_Done,
     /* 140318 */ // Label 2099: @140318
     /* 140318 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(140385), // Rule ID 4236 //
     /* 140323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 140326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140329 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140336 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140345 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140349 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 140356 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SVS_t16),
     /* 140359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140383 */   GIR_RootConstrainSelectedInstOperands,
     /* 140384 */   // GIR_Coverage, 4236,
     /* 140384 */   GIR_EraseRootFromParent_Done,
     /* 140385 */ // Label 2100: @140385
     /* 140385 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(140447), // Rule ID 4205 //
     /* 140390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 140393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140403 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140412 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140423 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 140423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 140426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140445 */   GIR_RootConstrainSelectedInstOperands,
     /* 140446 */   // GIR_Coverage, 4205,
     /* 140446 */   GIR_EraseRootFromParent_Done,
     /* 140447 */ // Label 2101: @140447
     /* 140447 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(140509), // Rule ID 4220 //
     /* 140452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 140455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140465 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140485 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 140485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 140488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140507 */   GIR_RootConstrainSelectedInstOperands,
     /* 140508 */   // GIR_Coverage, 4220,
     /* 140508 */   GIR_EraseRootFromParent_Done,
     /* 140509 */ // Label 2102: @140509
     /* 140509 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(140571), // Rule ID 4235 //
     /* 140514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 140517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140527 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140547 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SADDR_t16),
     /* 140550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140569 */   GIR_RootConstrainSelectedInstOperands,
     /* 140570 */   // GIR_Coverage, 4235,
     /* 140570 */   GIR_EraseRootFromParent_Done,
     /* 140571 */ // Label 2103: @140571
     /* 140571 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(140633), // Rule ID 4204 //
     /* 140576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 140579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140589 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140609 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 140609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 140612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140631 */   GIR_RootConstrainSelectedInstOperands,
     /* 140632 */   // GIR_Coverage, 4204,
     /* 140632 */   GIR_EraseRootFromParent_Done,
     /* 140633 */ // Label 2104: @140633
     /* 140633 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(140695), // Rule ID 4219 //
     /* 140638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 140641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140651 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140671 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 140671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 140674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140693 */   GIR_RootConstrainSelectedInstOperands,
     /* 140694 */   // GIR_Coverage, 4219,
     /* 140694 */   GIR_EraseRootFromParent_Done,
     /* 140695 */ // Label 2105: @140695
     /* 140695 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(140757), // Rule ID 4234 //
     /* 140700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 140703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140706 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140713 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140733 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_t16),
     /* 140736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140755 */   GIR_RootConstrainSelectedInstOperands,
     /* 140756 */   // GIR_Coverage, 4234,
     /* 140756 */   GIR_EraseRootFromParent_Done,
     /* 140757 */ // Label 2106: @140757
     /* 140757 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(140832), // Rule ID 6450 //
     /* 140762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 140765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140775 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 140795 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 140798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 140805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 140815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 140820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140830 */   GIR_RootConstrainSelectedInstOperands,
     /* 140831 */   // GIR_Coverage, 6450,
     /* 140831 */   GIR_EraseRootFromParent_Done,
     /* 140832 */ // Label 2107: @140832
     /* 140832 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(140907), // Rule ID 6452 //
     /* 140837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 140840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140850 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 140870 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 140873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 140880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 140890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 140895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140905 */   GIR_RootConstrainSelectedInstOperands,
     /* 140906 */   // GIR_Coverage, 6452,
     /* 140906 */   GIR_EraseRootFromParent_Done,
     /* 140907 */ // Label 2108: @140907
     /* 140907 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(140978), // Rule ID 6422 //
     /* 140912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140925 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 140931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 140946 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 140946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 140949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140976 */   GIR_RootConstrainSelectedInstOperands,
     /* 140977 */   // GIR_Coverage, 6422,
     /* 140977 */   GIR_EraseRootFromParent_Done,
     /* 140978 */ // Label 2109: @140978
     /* 140978 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(141049), // Rule ID 6423 //
     /* 140983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140996 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 141017 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 141017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 141020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 141022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 141027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141047 */   GIR_RootConstrainSelectedInstOperands,
     /* 141048 */   // GIR_Coverage, 6423,
     /* 141048 */   GIR_EraseRootFromParent_Done,
     /* 141049 */ // Label 2110: @141049
     /* 141049 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(141121), // Rule ID 6428 //
     /* 141054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 141057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141067 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 141089 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 141089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 141092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 141094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 141099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141119 */   GIR_RootConstrainSelectedInstOperands,
     /* 141120 */   // GIR_Coverage, 6428,
     /* 141120 */   GIR_EraseRootFromParent_Done,
     /* 141121 */ // Label 2111: @141121
     /* 141121 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(141193), // Rule ID 6429 //
     /* 141126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 141129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141139 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 141161 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 141161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 141164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 141166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 141171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141191 */   GIR_RootConstrainSelectedInstOperands,
     /* 141192 */   // GIR_Coverage, 6429,
     /* 141192 */   GIR_EraseRootFromParent_Done,
     /* 141193 */ // Label 2112: @141193
     /* 141193 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(141255), // Rule ID 7799 //
     /* 141198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 141201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141211 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141231 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 141234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141253 */   GIR_RootConstrainSelectedInstOperands,
     /* 141254 */   // GIR_Coverage, 7799,
     /* 141254 */   GIR_EraseRootFromParent_Done,
     /* 141255 */ // Label 2113: @141255
     /* 141255 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(141317), // Rule ID 7800 //
     /* 141260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 141263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141266 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141273 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141293 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141315 */   GIR_RootConstrainSelectedInstOperands,
     /* 141316 */   // GIR_Coverage, 7800,
     /* 141316 */   GIR_EraseRootFromParent_Done,
     /* 141317 */ // Label 2114: @141317
     /* 141317 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(141379), // Rule ID 7801 //
     /* 141322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 141325 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141335 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141355 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 141358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141377 */   GIR_RootConstrainSelectedInstOperands,
     /* 141378 */   // GIR_Coverage, 7801,
     /* 141378 */   GIR_EraseRootFromParent_Done,
     /* 141379 */ // Label 2115: @141379
     /* 141379 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(141441), // Rule ID 7814 //
     /* 141384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 141387 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141390 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141397 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141417 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141435 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141439 */   GIR_RootConstrainSelectedInstOperands,
     /* 141440 */   // GIR_Coverage, 7814,
     /* 141440 */   GIR_EraseRootFromParent_Done,
     /* 141441 */ // Label 2116: @141441
     /* 141441 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(141503), // Rule ID 7855 //
     /* 141446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 141449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141459 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141479 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 141482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141501 */   GIR_RootConstrainSelectedInstOperands,
     /* 141502 */   // GIR_Coverage, 7855,
     /* 141502 */   GIR_EraseRootFromParent_Done,
     /* 141503 */ // Label 2117: @141503
     /* 141503 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(141565), // Rule ID 7856 //
     /* 141508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 141511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141514 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141521 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141541 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141563 */   GIR_RootConstrainSelectedInstOperands,
     /* 141564 */   // GIR_Coverage, 7856,
     /* 141564 */   GIR_EraseRootFromParent_Done,
     /* 141565 */ // Label 2118: @141565
     /* 141565 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(141627), // Rule ID 7857 //
     /* 141570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 141573 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141583 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141603 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141625 */   GIR_RootConstrainSelectedInstOperands,
     /* 141626 */   // GIR_Coverage, 7857,
     /* 141626 */   GIR_EraseRootFromParent_Done,
     /* 141627 */ // Label 2119: @141627
     /* 141627 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(141689), // Rule ID 7858 //
     /* 141632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 141635 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141638 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141645 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141665 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 141668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141687 */   GIR_RootConstrainSelectedInstOperands,
     /* 141688 */   // GIR_Coverage, 7858,
     /* 141688 */   GIR_EraseRootFromParent_Done,
     /* 141689 */ // Label 2120: @141689
     /* 141689 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(141758), // Rule ID 3816 //
     /* 141694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 141697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141707 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141729 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141756 */   GIR_RootConstrainSelectedInstOperands,
     /* 141757 */   // GIR_Coverage, 3816,
     /* 141757 */   GIR_EraseRootFromParent_Done,
     /* 141758 */ // Label 2121: @141758
     /* 141758 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(141827), // Rule ID 3834 //
     /* 141763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 141766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141776 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141787 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141798 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141825 */   GIR_RootConstrainSelectedInstOperands,
     /* 141826 */   // GIR_Coverage, 3834,
     /* 141826 */   GIR_EraseRootFromParent_Done,
     /* 141827 */ // Label 2122: @141827
     /* 141827 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(141896), // Rule ID 3846 //
     /* 141832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 141835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141845 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141867 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141894 */   GIR_RootConstrainSelectedInstOperands,
     /* 141895 */   // GIR_Coverage, 3846,
     /* 141895 */   GIR_EraseRootFromParent_Done,
     /* 141896 */ // Label 2123: @141896
     /* 141896 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(141965), // Rule ID 3856 //
     /* 141901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 141904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141907 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141914 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141936 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_SADDR_t16),
     /* 141939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141963 */   GIR_RootConstrainSelectedInstOperands,
     /* 141964 */   // GIR_Coverage, 3856,
     /* 141964 */   GIR_EraseRootFromParent_Done,
     /* 141965 */ // Label 2124: @141965
     /* 141965 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(142029), // Rule ID 3815 //
     /* 141970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 141973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141983 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 142005 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 142008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142027 */   GIR_RootConstrainSelectedInstOperands,
     /* 142028 */   // GIR_Coverage, 3815,
     /* 142028 */   GIR_EraseRootFromParent_Done,
     /* 142029 */ // Label 2125: @142029
     /* 142029 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(142093), // Rule ID 3833 //
     /* 142034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 142037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142047 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 142069 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 142072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142091 */   GIR_RootConstrainSelectedInstOperands,
     /* 142092 */   // GIR_Coverage, 3833,
     /* 142092 */   GIR_EraseRootFromParent_Done,
     /* 142093 */ // Label 2126: @142093
     /* 142093 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(142157), // Rule ID 3845 //
     /* 142098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 142101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 142133 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 142136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142155 */   GIR_RootConstrainSelectedInstOperands,
     /* 142156 */   // GIR_Coverage, 3845,
     /* 142156 */   GIR_EraseRootFromParent_Done,
     /* 142157 */ // Label 2127: @142157
     /* 142157 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(142221), // Rule ID 3855 //
     /* 142162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 142165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142175 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 142186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142190 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 142197 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_t16),
     /* 142200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142219 */   GIR_RootConstrainSelectedInstOperands,
     /* 142220 */   // GIR_Coverage, 3855,
     /* 142220 */   GIR_EraseRootFromParent_Done,
     /* 142221 */ // Label 2128: @142221
     /* 142221 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(142286), // Rule ID 3584 //
     /* 142226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 142229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 142232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142239 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142262 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142284 */   GIR_RootConstrainSelectedInstOperands,
     /* 142285 */   // GIR_Coverage, 3584,
     /* 142285 */   GIR_EraseRootFromParent_Done,
     /* 142286 */ // Label 2129: @142286
     /* 142286 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(142351), // Rule ID 3592 //
     /* 142291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 142294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142304 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142327 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142349 */   GIR_RootConstrainSelectedInstOperands,
     /* 142350 */   // GIR_Coverage, 3592,
     /* 142350 */   GIR_EraseRootFromParent_Done,
     /* 142351 */ // Label 2130: @142351
     /* 142351 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(142416), // Rule ID 3598 //
     /* 142356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 142359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142369 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142392 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142414 */   GIR_RootConstrainSelectedInstOperands,
     /* 142415 */   // GIR_Coverage, 3598,
     /* 142415 */   GIR_EraseRootFromParent_Done,
     /* 142416 */ // Label 2131: @142416
     /* 142416 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(142481), // Rule ID 3604 //
     /* 142421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 142424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142427 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142434 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 142446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142457 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE_D16_t16),
     /* 142460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142479 */   GIR_RootConstrainSelectedInstOperands,
     /* 142480 */   // GIR_Coverage, 3604,
     /* 142480 */   GIR_EraseRootFromParent_Done,
     /* 142481 */ // Label 2132: @142481
     /* 142481 */ GIM_Reject,
     /* 142482 */ // Label 2094: @142482
     /* 142482 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(142548), // Rule ID 2909 //
     /* 142487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142493 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142508 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142519 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 142522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142546 */   GIR_RootConstrainSelectedInstOperands,
     /* 142547 */   // GIR_Coverage, 2909,
     /* 142547 */   GIR_EraseRootFromParent_Done,
     /* 142548 */ // Label 2133: @142548
     /* 142548 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(142614), // Rule ID 2921 //
     /* 142553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142574 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142585 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 142588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142612 */   GIR_RootConstrainSelectedInstOperands,
     /* 142613 */   // GIR_Coverage, 2921,
     /* 142613 */   GIR_EraseRootFromParent_Done,
     /* 142614 */ // Label 2134: @142614
     /* 142614 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(142675), // Rule ID 2907 //
     /* 142619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142640 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142651 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 142654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142673 */   GIR_RootConstrainSelectedInstOperands,
     /* 142674 */   // GIR_Coverage, 2907,
     /* 142674 */   GIR_EraseRootFromParent_Done,
     /* 142675 */ // Label 2135: @142675
     /* 142675 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(142739), // Rule ID 2908 //
     /* 142680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142701 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142712 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 142715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142733 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142737 */   GIR_RootConstrainSelectedInstOperands,
     /* 142738 */   // GIR_Coverage, 2908,
     /* 142738 */   GIR_EraseRootFromParent_Done,
     /* 142739 */ // Label 2136: @142739
     /* 142739 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(142800), // Rule ID 2919 //
     /* 142744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142747 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142750 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142765 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142776 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 142779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142798 */   GIR_RootConstrainSelectedInstOperands,
     /* 142799 */   // GIR_Coverage, 2919,
     /* 142799 */   GIR_EraseRootFromParent_Done,
     /* 142800 */ // Label 2137: @142800
     /* 142800 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(142864), // Rule ID 2920 //
     /* 142805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142826 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142837 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 142840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142862 */   GIR_RootConstrainSelectedInstOperands,
     /* 142863 */   // GIR_Coverage, 2920,
     /* 142863 */   GIR_EraseRootFromParent_Done,
     /* 142864 */ // Label 2138: @142864
     /* 142864 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(142917), // Rule ID 2910 //
     /* 142869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142886 */   // MIs[0] sbase
     /* 142886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 142894 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142898 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 142901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142903 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 142905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142915 */   GIR_RootConstrainSelectedInstOperands,
     /* 142916 */   // GIR_Coverage, 2910,
     /* 142916 */   GIR_EraseRootFromParent_Done,
     /* 142917 */ // Label 2139: @142917
     /* 142917 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(142970), // Rule ID 2922 //
     /* 142922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142928 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142939 */   // MIs[0] sbase
     /* 142939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 142947 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142951 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 142954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142956 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 142958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142964 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142968 */   GIR_RootConstrainSelectedInstOperands,
     /* 142969 */   // GIR_Coverage, 2922,
     /* 142969 */   GIR_EraseRootFromParent_Done,
     /* 142970 */ // Label 2140: @142970
     /* 142970 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(143040), // Rule ID 6437 //
     /* 142975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 142978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142988 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 142993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143008 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 143011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143038 */   GIR_RootConstrainSelectedInstOperands,
     /* 143039 */   // GIR_Coverage, 6437,
     /* 143039 */   GIR_EraseRootFromParent_Done,
     /* 143040 */ // Label 2141: @143040
     /* 143040 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(143110), // Rule ID 6441 //
     /* 143045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 143048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143058 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143078 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 143081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143108 */   GIR_RootConstrainSelectedInstOperands,
     /* 143109 */   // GIR_Coverage, 6441,
     /* 143109 */   GIR_EraseRootFromParent_Done,
     /* 143110 */ // Label 2142: @143110
     /* 143110 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(143180), // Rule ID 6463 //
     /* 143115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 143118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143128 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143148 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 143151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143174 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143178 */   GIR_RootConstrainSelectedInstOperands,
     /* 143179 */   // GIR_Coverage, 6463,
     /* 143179 */   GIR_EraseRootFromParent_Done,
     /* 143180 */ // Label 2143: @143180
     /* 143180 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(143250), // Rule ID 6465 //
     /* 143185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 143188 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143191 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143198 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143218 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 143221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143248 */   GIR_RootConstrainSelectedInstOperands,
     /* 143249 */   // GIR_Coverage, 6465,
     /* 143249 */   GIR_EraseRootFromParent_Done,
     /* 143250 */ // Label 2144: @143250
     /* 143250 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(143317), // Rule ID 4188 //
     /* 143255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 143258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143268 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143288 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 143291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143315 */   GIR_RootConstrainSelectedInstOperands,
     /* 143316 */   // GIR_Coverage, 4188,
     /* 143316 */   GIR_EraseRootFromParent_Done,
     /* 143317 */ // Label 2145: @143317
     /* 143317 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(143384), // Rule ID 4197 //
     /* 143322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 143325 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143335 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143355 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SVS),
     /* 143358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143382 */   GIR_RootConstrainSelectedInstOperands,
     /* 143383 */   // GIR_Coverage, 4197,
     /* 143383 */   GIR_EraseRootFromParent_Done,
     /* 143384 */ // Label 2146: @143384
     /* 143384 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(143446), // Rule ID 4187 //
     /* 143389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143402 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 143422 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 143422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 143425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 143432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143444 */   GIR_RootConstrainSelectedInstOperands,
     /* 143445 */   // GIR_Coverage, 4187,
     /* 143445 */   GIR_EraseRootFromParent_Done,
     /* 143446 */ // Label 2147: @143446
     /* 143446 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(143508), // Rule ID 4196 //
     /* 143451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143454 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143464 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143477 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 143484 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 143484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SADDR),
     /* 143487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 143494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143506 */   GIR_RootConstrainSelectedInstOperands,
     /* 143507 */   // GIR_Coverage, 4196,
     /* 143507 */   GIR_EraseRootFromParent_Done,
     /* 143508 */ // Label 2148: @143508
     /* 143508 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(143570), // Rule ID 4186 //
     /* 143513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143526 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 143546 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 143546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 143549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143568 */   GIR_RootConstrainSelectedInstOperands,
     /* 143569 */   // GIR_Coverage, 4186,
     /* 143569 */   GIR_EraseRootFromParent_Done,
     /* 143570 */ // Label 2149: @143570
     /* 143570 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(143632), // Rule ID 4195 //
     /* 143575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143588 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 143608 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 143608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT),
     /* 143611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143630 */   GIR_RootConstrainSelectedInstOperands,
     /* 143631 */   // GIR_Coverage, 4195,
     /* 143631 */   GIR_EraseRootFromParent_Done,
     /* 143632 */ // Label 2150: @143632
     /* 143632 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(143709), // Rule ID 4467 //
     /* 143637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143643 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143650 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143672 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143707 */   GIR_RootConstrainSelectedInstOperands,
     /* 143708 */   // GIR_Coverage, 4467,
     /* 143708 */   GIR_EraseRootFromParent_Done,
     /* 143709 */ // Label 2151: @143709
     /* 143709 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(143783), // Rule ID 4469 //
     /* 143714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143724 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143746 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 143749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143777 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143781 */   GIR_RootConstrainSelectedInstOperands,
     /* 143782 */   // GIR_Coverage, 4469,
     /* 143782 */   GIR_EraseRootFromParent_Done,
     /* 143783 */ // Label 2152: @143783
     /* 143783 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(143860), // Rule ID 4471 //
     /* 143788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143794 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143801 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143823 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143858 */   GIR_RootConstrainSelectedInstOperands,
     /* 143859 */   // GIR_Coverage, 4471,
     /* 143859 */   GIR_EraseRootFromParent_Done,
     /* 143860 */ // Label 2153: @143860
     /* 143860 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(143934), // Rule ID 4473 //
     /* 143865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143875 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143897 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 143900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143932 */   GIR_RootConstrainSelectedInstOperands,
     /* 143933 */   // GIR_Coverage, 4473,
     /* 143933 */   GIR_EraseRootFromParent_Done,
     /* 143934 */ // Label 2154: @143934
     /* 143934 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(144011), // Rule ID 4475 //
     /* 143939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143945 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143952 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143974 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144009 */   GIR_RootConstrainSelectedInstOperands,
     /* 144010 */   // GIR_Coverage, 4475,
     /* 144010 */   GIR_EraseRootFromParent_Done,
     /* 144011 */ // Label 2155: @144011
     /* 144011 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(144085), // Rule ID 4477 //
     /* 144016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144026 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144048 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 144051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144083 */   GIR_RootConstrainSelectedInstOperands,
     /* 144084 */   // GIR_Coverage, 4477,
     /* 144084 */   GIR_EraseRootFromParent_Done,
     /* 144085 */ // Label 2156: @144085
     /* 144085 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(144162), // Rule ID 4487 //
     /* 144090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144118 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144125 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 144128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144160 */   GIR_RootConstrainSelectedInstOperands,
     /* 144161 */   // GIR_Coverage, 4487,
     /* 144161 */   GIR_EraseRootFromParent_Done,
     /* 144162 */ // Label 2157: @144162
     /* 144162 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(144236), // Rule ID 4489 //
     /* 144167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144177 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144199 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 144202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144234 */   GIR_RootConstrainSelectedInstOperands,
     /* 144235 */   // GIR_Coverage, 4489,
     /* 144235 */   GIR_EraseRootFromParent_Done,
     /* 144236 */ // Label 2158: @144236
     /* 144236 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(144313), // Rule ID 4491 //
     /* 144241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144244 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144247 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144254 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144269 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144276 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 144279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144311 */   GIR_RootConstrainSelectedInstOperands,
     /* 144312 */   // GIR_Coverage, 4491,
     /* 144312 */   GIR_EraseRootFromParent_Done,
     /* 144313 */ // Label 2159: @144313
     /* 144313 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(144387), // Rule ID 4493 //
     /* 144318 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144328 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144350 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 144353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144385 */   GIR_RootConstrainSelectedInstOperands,
     /* 144386 */   // GIR_Coverage, 4493,
     /* 144386 */   GIR_EraseRootFromParent_Done,
     /* 144387 */ // Label 2160: @144387
     /* 144387 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(144463), // Rule ID 6414 //
     /* 144392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 144395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144405 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144426 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 144429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144461 */   GIR_RootConstrainSelectedInstOperands,
     /* 144462 */   // GIR_Coverage, 6414,
     /* 144462 */   GIR_EraseRootFromParent_Done,
     /* 144463 */ // Label 2161: @144463
     /* 144463 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(144539), // Rule ID 6417 //
     /* 144468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 144471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144481 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144502 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_constant>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 144505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144533 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144537 */   GIR_RootConstrainSelectedInstOperands,
     /* 144538 */   // GIR_Coverage, 6417,
     /* 144538 */   GIR_EraseRootFromParent_Done,
     /* 144539 */ // Label 2162: @144539
     /* 144539 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(144614), // Rule ID 6436 //
     /* 144544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 144547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144557 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144577 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 144580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144612 */   GIR_RootConstrainSelectedInstOperands,
     /* 144613 */   // GIR_Coverage, 6436,
     /* 144613 */   GIR_EraseRootFromParent_Done,
     /* 144614 */ // Label 2163: @144614
     /* 144614 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(144689), // Rule ID 6440 //
     /* 144619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 144622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144632 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144641 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144652 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 144655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144687 */   GIR_RootConstrainSelectedInstOperands,
     /* 144688 */   // GIR_Coverage, 6440,
     /* 144688 */   GIR_EraseRootFromParent_Done,
     /* 144689 */ // Label 2164: @144689
     /* 144689 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(144764), // Rule ID 6462 //
     /* 144694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 144697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144707 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144727 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 144730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144762 */   GIR_RootConstrainSelectedInstOperands,
     /* 144763 */   // GIR_Coverage, 6462,
     /* 144763 */   GIR_EraseRootFromParent_Done,
     /* 144764 */ // Label 2165: @144764
     /* 144764 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(144839), // Rule ID 6464 //
     /* 144769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 144772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144782 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144802 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 144805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144837 */   GIR_RootConstrainSelectedInstOperands,
     /* 144838 */   // GIR_Coverage, 6464,
     /* 144838 */   GIR_EraseRootFromParent_Done,
     /* 144839 */ // Label 2166: @144839
     /* 144839 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(144911), // Rule ID 4466 //
     /* 144844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144850 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144857 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144879 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144909 */   GIR_RootConstrainSelectedInstOperands,
     /* 144910 */   // GIR_Coverage, 4466,
     /* 144910 */   GIR_EraseRootFromParent_Done,
     /* 144911 */ // Label 2167: @144911
     /* 144911 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(144980), // Rule ID 4468 //
     /* 144916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144919 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144926 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144948 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 144951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144978 */   GIR_RootConstrainSelectedInstOperands,
     /* 144979 */   // GIR_Coverage, 4468,
     /* 144979 */   GIR_EraseRootFromParent_Done,
     /* 144980 */ // Label 2168: @144980
     /* 144980 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(145052), // Rule ID 4470 //
     /* 144985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144998 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145020 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 145023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145050 */   GIR_RootConstrainSelectedInstOperands,
     /* 145051 */   // GIR_Coverage, 4470,
     /* 145051 */   GIR_EraseRootFromParent_Done,
     /* 145052 */ // Label 2169: @145052
     /* 145052 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(145121), // Rule ID 4472 //
     /* 145057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145067 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145089 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 145092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145119 */   GIR_RootConstrainSelectedInstOperands,
     /* 145120 */   // GIR_Coverage, 4472,
     /* 145120 */   GIR_EraseRootFromParent_Done,
     /* 145121 */ // Label 2170: @145121
     /* 145121 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(145193), // Rule ID 4474 //
     /* 145126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 145129 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145139 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145161 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 145164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145191 */   GIR_RootConstrainSelectedInstOperands,
     /* 145192 */   // GIR_Coverage, 4474,
     /* 145192 */   GIR_EraseRootFromParent_Done,
     /* 145193 */ // Label 2171: @145193
     /* 145193 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(145262), // Rule ID 4476 //
     /* 145198 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145208 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145230 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 145233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145260 */   GIR_RootConstrainSelectedInstOperands,
     /* 145261 */   // GIR_Coverage, 4476,
     /* 145261 */   GIR_EraseRootFromParent_Done,
     /* 145262 */ // Label 2172: @145262
     /* 145262 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(145334), // Rule ID 4486 //
     /* 145267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 145270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145273 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145280 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145302 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 145305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145332 */   GIR_RootConstrainSelectedInstOperands,
     /* 145333 */   // GIR_Coverage, 4486,
     /* 145333 */   GIR_EraseRootFromParent_Done,
     /* 145334 */ // Label 2173: @145334
     /* 145334 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(145403), // Rule ID 4488 //
     /* 145339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145349 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145371 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 145374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145401 */   GIR_RootConstrainSelectedInstOperands,
     /* 145402 */   // GIR_Coverage, 4488,
     /* 145402 */   GIR_EraseRootFromParent_Done,
     /* 145403 */ // Label 2174: @145403
     /* 145403 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(145475), // Rule ID 4490 //
     /* 145408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 145411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145421 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145443 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 145446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145473 */   GIR_RootConstrainSelectedInstOperands,
     /* 145474 */   // GIR_Coverage, 4490,
     /* 145474 */   GIR_EraseRootFromParent_Done,
     /* 145475 */ // Label 2175: @145475
     /* 145475 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(145544), // Rule ID 4492 //
     /* 145480 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145490 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145512 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 145515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145542 */   GIR_RootConstrainSelectedInstOperands,
     /* 145543 */   // GIR_Coverage, 4492,
     /* 145543 */   GIR_EraseRootFromParent_Done,
     /* 145544 */ // Label 2176: @145544
     /* 145544 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(145606), // Rule ID 7797 //
     /* 145549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145562 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145582 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 145585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145604 */   GIR_RootConstrainSelectedInstOperands,
     /* 145605 */   // GIR_Coverage, 7797,
     /* 145605 */   GIR_EraseRootFromParent_Done,
     /* 145606 */ // Label 2177: @145606
     /* 145606 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(145668), // Rule ID 7798 //
     /* 145611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145614 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145624 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145644 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 145647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145666 */   GIR_RootConstrainSelectedInstOperands,
     /* 145667 */   // GIR_Coverage, 7798,
     /* 145667 */   GIR_EraseRootFromParent_Done,
     /* 145668 */ // Label 2178: @145668
     /* 145668 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(145730), // Rule ID 7806 //
     /* 145673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145679 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145686 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145706 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 145709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145728 */   GIR_RootConstrainSelectedInstOperands,
     /* 145729 */   // GIR_Coverage, 7806,
     /* 145729 */   GIR_EraseRootFromParent_Done,
     /* 145730 */ // Label 2179: @145730
     /* 145730 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(145792), // Rule ID 7807 //
     /* 145735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145741 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145748 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145768 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 145771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145790 */   GIR_RootConstrainSelectedInstOperands,
     /* 145791 */   // GIR_Coverage, 7807,
     /* 145791 */   GIR_EraseRootFromParent_Done,
     /* 145792 */ // Label 2180: @145792
     /* 145792 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(145854), // Rule ID 7808 //
     /* 145797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145810 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145830 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 145833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145852 */   GIR_RootConstrainSelectedInstOperands,
     /* 145853 */   // GIR_Coverage, 7808,
     /* 145853 */   GIR_EraseRootFromParent_Done,
     /* 145854 */ // Label 2181: @145854
     /* 145854 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(145916), // Rule ID 7809 //
     /* 145859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145872 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145892 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 145895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145914 */   GIR_RootConstrainSelectedInstOperands,
     /* 145915 */   // GIR_Coverage, 7809,
     /* 145915 */   GIR_EraseRootFromParent_Done,
     /* 145916 */ // Label 2182: @145916
     /* 145916 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(145978), // Rule ID 7859 //
     /* 145921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145924 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145927 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145934 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145943 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145954 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 145957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145976 */   GIR_RootConstrainSelectedInstOperands,
     /* 145977 */   // GIR_Coverage, 7859,
     /* 145977 */   GIR_EraseRootFromParent_Done,
     /* 145978 */ // Label 2183: @145978
     /* 145978 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(146040), // Rule ID 7860 //
     /* 145983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145986 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145996 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 146001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 146016 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 146016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 146019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 146026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146038 */   GIR_RootConstrainSelectedInstOperands,
     /* 146039 */   // GIR_Coverage, 7860,
     /* 146039 */   GIR_EraseRootFromParent_Done,
     /* 146040 */ // Label 2184: @146040
     /* 146040 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(146102), // Rule ID 7869 //
     /* 146045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 146048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146058 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 146063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 146078 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_16_glue>><<P:Predicate_atomic_load_sext_16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 146078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 146081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 146088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146100 */   GIR_RootConstrainSelectedInstOperands,
     /* 146101 */   // GIR_Coverage, 7869,
     /* 146101 */   GIR_EraseRootFromParent_Done,
     /* 146102 */ // Label 2185: @146102
     /* 146102 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(146164), // Rule ID 7870 //
     /* 146107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 146110 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146120 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 146125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146133 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 146140 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 146140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 146143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 146150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146162 */   GIR_RootConstrainSelectedInstOperands,
     /* 146163 */   // GIR_Coverage, 7870,
     /* 146163 */   GIR_EraseRootFromParent_Done,
     /* 146164 */ // Label 2186: @146164
     /* 146164 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(146233), // Rule ID 3814 //
     /* 146169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146172 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146175 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146182 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146204 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 146207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146231 */   GIR_RootConstrainSelectedInstOperands,
     /* 146232 */   // GIR_Coverage, 3814,
     /* 146232 */   GIR_EraseRootFromParent_Done,
     /* 146233 */ // Label 2187: @146233
     /* 146233 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(146302), // Rule ID 3822 //
     /* 146238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146251 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146273 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 146276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146300 */   GIR_RootConstrainSelectedInstOperands,
     /* 146301 */   // GIR_Coverage, 3822,
     /* 146301 */   GIR_EraseRootFromParent_Done,
     /* 146302 */ // Label 2188: @146302
     /* 146302 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(146371), // Rule ID 3828 //
     /* 146307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146320 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146342 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146369 */   GIR_RootConstrainSelectedInstOperands,
     /* 146370 */   // GIR_Coverage, 3828,
     /* 146370 */   GIR_EraseRootFromParent_Done,
     /* 146371 */ // Label 2189: @146371
     /* 146371 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(146440), // Rule ID 3836 //
     /* 146376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 146379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146389 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146411 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146438 */   GIR_RootConstrainSelectedInstOperands,
     /* 146439 */   // GIR_Coverage, 3836,
     /* 146439 */   GIR_EraseRootFromParent_Done,
     /* 146440 */ // Label 2190: @146440
     /* 146440 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(146509), // Rule ID 3848 //
     /* 146445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 146448 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146458 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146480 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146507 */   GIR_RootConstrainSelectedInstOperands,
     /* 146508 */   // GIR_Coverage, 3848,
     /* 146508 */   GIR_EraseRootFromParent_Done,
     /* 146509 */ // Label 2191: @146509
     /* 146509 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(146573), // Rule ID 3813 //
     /* 146514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146527 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146549 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 146552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146571 */   GIR_RootConstrainSelectedInstOperands,
     /* 146572 */   // GIR_Coverage, 3813,
     /* 146572 */   GIR_EraseRootFromParent_Done,
     /* 146573 */ // Label 2192: @146573
     /* 146573 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(146637), // Rule ID 3821 //
     /* 146578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146584 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146591 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146613 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 146616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146635 */   GIR_RootConstrainSelectedInstOperands,
     /* 146636 */   // GIR_Coverage, 3821,
     /* 146636 */   GIR_EraseRootFromParent_Done,
     /* 146637 */ // Label 2193: @146637
     /* 146637 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(146701), // Rule ID 3827 //
     /* 146642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146648 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146655 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146670 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146677 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146699 */   GIR_RootConstrainSelectedInstOperands,
     /* 146700 */   // GIR_Coverage, 3827,
     /* 146700 */   GIR_EraseRootFromParent_Done,
     /* 146701 */ // Label 2194: @146701
     /* 146701 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(146765), // Rule ID 3835 //
     /* 146706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 146709 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146719 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146741 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146763 */   GIR_RootConstrainSelectedInstOperands,
     /* 146764 */   // GIR_Coverage, 3835,
     /* 146764 */   GIR_EraseRootFromParent_Done,
     /* 146765 */ // Label 2195: @146765
     /* 146765 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(146829), // Rule ID 3847 //
     /* 146770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 146773 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146776 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146783 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146805 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146827 */   GIR_RootConstrainSelectedInstOperands,
     /* 146828 */   // GIR_Coverage, 3847,
     /* 146828 */   GIR_EraseRootFromParent_Done,
     /* 146829 */ // Label 2196: @146829
     /* 146829 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(146894), // Rule ID 3582 //
     /* 146834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146847 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146870 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 146873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146892 */   GIR_RootConstrainSelectedInstOperands,
     /* 146893 */   // GIR_Coverage, 3582,
     /* 146893 */   GIR_EraseRootFromParent_Done,
     /* 146894 */ // Label 2197: @146894
     /* 146894 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(146959), // Rule ID 3583 //
     /* 146899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146912 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146935 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 146938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146957 */   GIR_RootConstrainSelectedInstOperands,
     /* 146958 */   // GIR_Coverage, 3583,
     /* 146958 */   GIR_EraseRootFromParent_Done,
     /* 146959 */ // Label 2198: @146959
     /* 146959 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(147024), // Rule ID 3587 //
     /* 146964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146977 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146989 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146993 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 147000 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 147003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147022 */   GIR_RootConstrainSelectedInstOperands,
     /* 147023 */   // GIR_Coverage, 3587,
     /* 147023 */   GIR_EraseRootFromParent_Done,
     /* 147024 */ // Label 2199: @147024
     /* 147024 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(147089), // Rule ID 3588 //
     /* 147029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 147032 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147035 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147042 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 147065 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 147068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147087 */   GIR_RootConstrainSelectedInstOperands,
     /* 147088 */   // GIR_Coverage, 3588,
     /* 147088 */   GIR_EraseRootFromParent_Done,
     /* 147089 */ // Label 2200: @147089
     /* 147089 */ GIM_Reject,
     /* 147090 */ // Label 2095: @147090
     /* 147090 */ GIM_Reject,
     /* 147091 */ // Label 16: @147091
     /* 147091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2203*/ GIMT_Encode4(154071),
     /* 147102 */ /*GILLT_s16*//*Label 2201*/ GIMT_Encode4(147110),
     /* 147106 */ /*GILLT_s32*//*Label 2202*/ GIMT_Encode4(149746),
     /* 147110 */ // Label 2201: @147110
     /* 147110 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(147180), // Rule ID 6459 //
     /* 147115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 147118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147128 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 147148 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 147151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147174 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147178 */   GIR_RootConstrainSelectedInstOperands,
     /* 147179 */   // GIR_Coverage, 6459,
     /* 147179 */   GIR_EraseRootFromParent_Done,
     /* 147180 */ // Label 2204: @147180
     /* 147180 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(147250), // Rule ID 6461 //
     /* 147185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 147188 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147191 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147198 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 147218 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 147221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147248 */   GIR_RootConstrainSelectedInstOperands,
     /* 147249 */   // GIR_Coverage, 6461,
     /* 147249 */   GIR_EraseRootFromParent_Done,
     /* 147250 */ // Label 2205: @147250
     /* 147250 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(147317), // Rule ID 4203 //
     /* 147255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 147258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147268 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147288 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 147291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147315 */   GIR_RootConstrainSelectedInstOperands,
     /* 147316 */   // GIR_Coverage, 4203,
     /* 147316 */   GIR_EraseRootFromParent_Done,
     /* 147317 */ // Label 2206: @147317
     /* 147317 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(147384), // Rule ID 4218 //
     /* 147322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 147325 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147335 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147355 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 147358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147382 */   GIR_RootConstrainSelectedInstOperands,
     /* 147383 */   // GIR_Coverage, 4218,
     /* 147383 */   GIR_EraseRootFromParent_Done,
     /* 147384 */ // Label 2207: @147384
     /* 147384 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(147451), // Rule ID 4233 //
     /* 147389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 147392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147402 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147422 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /* 147425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147449 */   GIR_RootConstrainSelectedInstOperands,
     /* 147450 */   // GIR_Coverage, 4233,
     /* 147450 */   GIR_EraseRootFromParent_Done,
     /* 147451 */ // Label 2208: @147451
     /* 147451 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(147513), // Rule ID 4202 //
     /* 147456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 147459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147462 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147469 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147489 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 147489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 147492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147511 */   GIR_RootConstrainSelectedInstOperands,
     /* 147512 */   // GIR_Coverage, 4202,
     /* 147512 */   GIR_EraseRootFromParent_Done,
     /* 147513 */ // Label 2209: @147513
     /* 147513 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(147575), // Rule ID 4217 //
     /* 147518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 147521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147531 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147551 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 147551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 147554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147573 */   GIR_RootConstrainSelectedInstOperands,
     /* 147574 */   // GIR_Coverage, 4217,
     /* 147574 */   GIR_EraseRootFromParent_Done,
     /* 147575 */ // Label 2210: @147575
     /* 147575 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(147637), // Rule ID 4232 //
     /* 147580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 147583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147593 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147613 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /* 147616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147635 */   GIR_RootConstrainSelectedInstOperands,
     /* 147636 */   // GIR_Coverage, 4232,
     /* 147636 */   GIR_EraseRootFromParent_Done,
     /* 147637 */ // Label 2211: @147637
     /* 147637 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(147699), // Rule ID 4201 //
     /* 147642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 147645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147648 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147655 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147675 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 147678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147697 */   GIR_RootConstrainSelectedInstOperands,
     /* 147698 */   // GIR_Coverage, 4201,
     /* 147698 */   GIR_EraseRootFromParent_Done,
     /* 147699 */ // Label 2212: @147699
     /* 147699 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(147761), // Rule ID 4216 //
     /* 147704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 147707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147717 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147726 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147730 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147737 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 147740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147759 */   GIR_RootConstrainSelectedInstOperands,
     /* 147760 */   // GIR_Coverage, 4216,
     /* 147760 */   GIR_EraseRootFromParent_Done,
     /* 147761 */ // Label 2213: @147761
     /* 147761 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(147823), // Rule ID 4231 //
     /* 147766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 147769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147772 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147779 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147792 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147799 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /* 147802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147821 */   GIR_RootConstrainSelectedInstOperands,
     /* 147822 */   // GIR_Coverage, 4231,
     /* 147822 */   GIR_EraseRootFromParent_Done,
     /* 147823 */ // Label 2214: @147823
     /* 147823 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(147898), // Rule ID 6458 //
     /* 147828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 147831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147834 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147841 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147850 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 147861 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 147864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147896 */   GIR_RootConstrainSelectedInstOperands,
     /* 147897 */   // GIR_Coverage, 6458,
     /* 147897 */   GIR_EraseRootFromParent_Done,
     /* 147898 */ // Label 2215: @147898
     /* 147898 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(147973), // Rule ID 6460 //
     /* 147903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 147906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147909 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147916 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 147936 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 147939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147971 */   GIR_RootConstrainSelectedInstOperands,
     /* 147972 */   // GIR_Coverage, 6460,
     /* 147972 */   GIR_EraseRootFromParent_Done,
     /* 147973 */ // Label 2216: @147973
     /* 147973 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(148044), // Rule ID 6426 //
     /* 147978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 147981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147991 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148001 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148005 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148012 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 148012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 148015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148042 */   GIR_RootConstrainSelectedInstOperands,
     /* 148043 */   // GIR_Coverage, 6426,
     /* 148043 */   GIR_EraseRootFromParent_Done,
     /* 148044 */ // Label 2217: @148044
     /* 148044 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(148115), // Rule ID 6427 //
     /* 148049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 148052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148062 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148083 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 148083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 148086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148113 */   GIR_RootConstrainSelectedInstOperands,
     /* 148114 */   // GIR_Coverage, 6427,
     /* 148114 */   GIR_EraseRootFromParent_Done,
     /* 148115 */ // Label 2218: @148115
     /* 148115 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(148187), // Rule ID 6432 //
     /* 148120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 148123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148126 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148133 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148155 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 148155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 148158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148185 */   GIR_RootConstrainSelectedInstOperands,
     /* 148186 */   // GIR_Coverage, 6432,
     /* 148186 */   GIR_EraseRootFromParent_Done,
     /* 148187 */ // Label 2219: @148187
     /* 148187 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(148259), // Rule ID 6433 //
     /* 148192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 148195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148198 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148205 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148227 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 148227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 148230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148257 */   GIR_RootConstrainSelectedInstOperands,
     /* 148258 */   // GIR_Coverage, 6433,
     /* 148258 */   GIR_EraseRootFromParent_Done,
     /* 148259 */ // Label 2220: @148259
     /* 148259 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(148321), // Rule ID 7819 //
     /* 148264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 148267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148277 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148297 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 148300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148319 */   GIR_RootConstrainSelectedInstOperands,
     /* 148320 */   // GIR_Coverage, 7819,
     /* 148320 */   GIR_EraseRootFromParent_Done,
     /* 148321 */ // Label 2221: @148321
     /* 148321 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(148383), // Rule ID 7820 //
     /* 148326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 148329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148332 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148339 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148359 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148381 */   GIR_RootConstrainSelectedInstOperands,
     /* 148382 */   // GIR_Coverage, 7820,
     /* 148382 */   GIR_EraseRootFromParent_Done,
     /* 148383 */ // Label 2222: @148383
     /* 148383 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(148445), // Rule ID 7821 //
     /* 148388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 148391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148401 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148421 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148439 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148443 */   GIR_RootConstrainSelectedInstOperands,
     /* 148444 */   // GIR_Coverage, 7821,
     /* 148444 */   GIR_EraseRootFromParent_Done,
     /* 148445 */ // Label 2223: @148445
     /* 148445 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(148507), // Rule ID 7822 //
     /* 148450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 148453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148456 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148463 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 148472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148483 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 148486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148505 */   GIR_RootConstrainSelectedInstOperands,
     /* 148506 */   // GIR_Coverage, 7822,
     /* 148506 */   GIR_EraseRootFromParent_Done,
     /* 148507 */ // Label 2224: @148507
     /* 148507 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(148569), // Rule ID 7849 //
     /* 148512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 148515 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148525 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148545 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 148548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148567 */   GIR_RootConstrainSelectedInstOperands,
     /* 148568 */   // GIR_Coverage, 7849,
     /* 148568 */   GIR_EraseRootFromParent_Done,
     /* 148569 */ // Label 2225: @148569
     /* 148569 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(148631), // Rule ID 7850 //
     /* 148574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 148577 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148587 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148607 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148629 */   GIR_RootConstrainSelectedInstOperands,
     /* 148630 */   // GIR_Coverage, 7850,
     /* 148630 */   GIR_EraseRootFromParent_Done,
     /* 148631 */ // Label 2226: @148631
     /* 148631 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(148693), // Rule ID 7851 //
     /* 148636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 148639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148649 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148669 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148691 */   GIR_RootConstrainSelectedInstOperands,
     /* 148692 */   // GIR_Coverage, 7851,
     /* 148692 */   GIR_EraseRootFromParent_Done,
     /* 148693 */ // Label 2227: @148693
     /* 148693 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(148755), // Rule ID 7852 //
     /* 148698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 148701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148711 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 148720 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148724 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148731 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 148734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148749 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148753 */   GIR_RootConstrainSelectedInstOperands,
     /* 148754 */   // GIR_Coverage, 7852,
     /* 148754 */   GIR_EraseRootFromParent_Done,
     /* 148755 */ // Label 2228: @148755
     /* 148755 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(148824), // Rule ID 3804 //
     /* 148760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148763 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148766 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148773 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148795 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 148798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148822 */   GIR_RootConstrainSelectedInstOperands,
     /* 148823 */   // GIR_Coverage, 3804,
     /* 148823 */   GIR_EraseRootFromParent_Done,
     /* 148824 */ // Label 2229: @148824
     /* 148824 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(148893), // Rule ID 3812 //
     /* 148829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148842 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148864 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 148867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148891 */   GIR_RootConstrainSelectedInstOperands,
     /* 148892 */   // GIR_Coverage, 3812,
     /* 148892 */   GIR_EraseRootFromParent_Done,
     /* 148893 */ // Label 2230: @148893
     /* 148893 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(148962), // Rule ID 3832 //
     /* 148898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 148901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148911 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148933 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 148936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148960 */   GIR_RootConstrainSelectedInstOperands,
     /* 148961 */   // GIR_Coverage, 3832,
     /* 148961 */   GIR_EraseRootFromParent_Done,
     /* 148962 */ // Label 2231: @148962
     /* 148962 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(149031), // Rule ID 3844 //
     /* 148967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 148970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148980 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149002 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 149005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149029 */   GIR_RootConstrainSelectedInstOperands,
     /* 149030 */   // GIR_Coverage, 3844,
     /* 149030 */   GIR_EraseRootFromParent_Done,
     /* 149031 */ // Label 2232: @149031
     /* 149031 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(149100), // Rule ID 3854 //
     /* 149036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 149039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149049 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 149060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149071 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /* 149074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149098 */   GIR_RootConstrainSelectedInstOperands,
     /* 149099 */   // GIR_Coverage, 3854,
     /* 149099 */   GIR_EraseRootFromParent_Done,
     /* 149100 */ // Label 2233: @149100
     /* 149100 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(149164), // Rule ID 3803 //
     /* 149105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 149108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149118 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149133 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149140 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 149143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149162 */   GIR_RootConstrainSelectedInstOperands,
     /* 149163 */   // GIR_Coverage, 3803,
     /* 149163 */   GIR_EraseRootFromParent_Done,
     /* 149164 */ // Label 2234: @149164
     /* 149164 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(149228), // Rule ID 3811 //
     /* 149169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 149172 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149175 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149182 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149204 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 149207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149226 */   GIR_RootConstrainSelectedInstOperands,
     /* 149227 */   // GIR_Coverage, 3811,
     /* 149227 */   GIR_EraseRootFromParent_Done,
     /* 149228 */ // Label 2235: @149228
     /* 149228 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(149292), // Rule ID 3831 //
     /* 149233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 149236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149239 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149246 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149268 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 149271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149290 */   GIR_RootConstrainSelectedInstOperands,
     /* 149291 */   // GIR_Coverage, 3831,
     /* 149291 */   GIR_EraseRootFromParent_Done,
     /* 149292 */ // Label 2236: @149292
     /* 149292 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(149356), // Rule ID 3843 //
     /* 149297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 149300 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149303 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149310 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149325 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149332 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 149335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149354 */   GIR_RootConstrainSelectedInstOperands,
     /* 149355 */   // GIR_Coverage, 3843,
     /* 149355 */   GIR_EraseRootFromParent_Done,
     /* 149356 */ // Label 2237: @149356
     /* 149356 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(149420), // Rule ID 3853 //
     /* 149361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 149364 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149367 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149374 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 149385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149396 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /* 149399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149418 */   GIR_RootConstrainSelectedInstOperands,
     /* 149419 */   // GIR_Coverage, 3853,
     /* 149419 */   GIR_EraseRootFromParent_Done,
     /* 149420 */ // Label 2238: @149420
     /* 149420 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(149485), // Rule ID 3575 //
     /* 149425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 149428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149438 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149461 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149483 */   GIR_RootConstrainSelectedInstOperands,
     /* 149484 */   // GIR_Coverage, 3575,
     /* 149484 */   GIR_EraseRootFromParent_Done,
     /* 149485 */ // Label 2239: @149485
     /* 149485 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(149550), // Rule ID 3579 //
     /* 149490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 149493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149503 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149526 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 149529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149548 */   GIR_RootConstrainSelectedInstOperands,
     /* 149549 */   // GIR_Coverage, 3579,
     /* 149549 */   GIR_EraseRootFromParent_Done,
     /* 149550 */ // Label 2240: @149550
     /* 149550 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(149615), // Rule ID 3591 //
     /* 149555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 149558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149568 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149591 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149613 */   GIR_RootConstrainSelectedInstOperands,
     /* 149614 */   // GIR_Coverage, 3591,
     /* 149614 */   GIR_EraseRootFromParent_Done,
     /* 149615 */ // Label 2241: @149615
     /* 149615 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(149680), // Rule ID 3597 //
     /* 149620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 149623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149633 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149656 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149678 */   GIR_RootConstrainSelectedInstOperands,
     /* 149679 */   // GIR_Coverage, 3597,
     /* 149679 */   GIR_EraseRootFromParent_Done,
     /* 149680 */ // Label 2242: @149680
     /* 149680 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(149745), // Rule ID 3603 //
     /* 149685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 149688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149691 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149698 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 149710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149721 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /* 149724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149743 */   GIR_RootConstrainSelectedInstOperands,
     /* 149744 */   // GIR_Coverage, 3603,
     /* 149744 */   GIR_EraseRootFromParent_Done,
     /* 149745 */ // Label 2243: @149745
     /* 149745 */ GIM_Reject,
     /* 149746 */ // Label 2202: @149746
     /* 149746 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(149812), // Rule ID 2905 //
     /* 149751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149754 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149772 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 149783 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 149786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149806 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149810 */   GIR_RootConstrainSelectedInstOperands,
     /* 149811 */   // GIR_Coverage, 2905,
     /* 149811 */   GIR_EraseRootFromParent_Done,
     /* 149812 */ // Label 2244: @149812
     /* 149812 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(149878), // Rule ID 2917 //
     /* 149817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149823 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149838 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 149842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 149849 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 149852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149876 */   GIR_RootConstrainSelectedInstOperands,
     /* 149877 */   // GIR_Coverage, 2917,
     /* 149877 */   GIR_EraseRootFromParent_Done,
     /* 149878 */ // Label 2245: @149878
     /* 149878 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(149939), // Rule ID 2903 //
     /* 149883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149904 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 149915 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 149918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149937 */   GIR_RootConstrainSelectedInstOperands,
     /* 149938 */   // GIR_Coverage, 2903,
     /* 149938 */   GIR_EraseRootFromParent_Done,
     /* 149939 */ // Label 2246: @149939
     /* 149939 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(150003), // Rule ID 2904 //
     /* 149944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149950 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149965 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 149976 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 149976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 149979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150001 */   GIR_RootConstrainSelectedInstOperands,
     /* 150002 */   // GIR_Coverage, 2904,
     /* 150002 */   GIR_EraseRootFromParent_Done,
     /* 150003 */ // Label 2247: @150003
     /* 150003 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(150064), // Rule ID 2915 //
     /* 150008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 150011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 150025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150029 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 150033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 150040 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 150043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 150045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 150050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150062 */   GIR_RootConstrainSelectedInstOperands,
     /* 150063 */   // GIR_Coverage, 2915,
     /* 150063 */   GIR_EraseRootFromParent_Done,
     /* 150064 */ // Label 2248: @150064
     /* 150064 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(150128), // Rule ID 2916 //
     /* 150069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 150072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 150086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150090 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 150094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 150101 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 150101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 150104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 150106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 150111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150126 */   GIR_RootConstrainSelectedInstOperands,
     /* 150127 */   // GIR_Coverage, 2916,
     /* 150127 */   GIR_EraseRootFromParent_Done,
     /* 150128 */ // Label 2249: @150128
     /* 150128 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(150181), // Rule ID 2906 //
     /* 150133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 150136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 150150 */   // MIs[0] sbase
     /* 150150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 150158 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 150162 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 150162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 150165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 150167 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 150169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150179 */   GIR_RootConstrainSelectedInstOperands,
     /* 150180 */   // GIR_Coverage, 2906,
     /* 150180 */   GIR_EraseRootFromParent_Done,
     /* 150181 */ // Label 2250: @150181
     /* 150181 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(150234), // Rule ID 2918 //
     /* 150186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 150189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150192 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 150203 */   // MIs[0] sbase
     /* 150203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 150211 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 150215 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 150215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 150218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 150220 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 150222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150232 */   GIR_RootConstrainSelectedInstOperands,
     /* 150233 */   // GIR_Coverage, 2918,
     /* 150233 */   GIR_EraseRootFromParent_Done,
     /* 150234 */ // Label 2251: @150234
     /* 150234 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(150304), // Rule ID 6447 //
     /* 150239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 150242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150245 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150252 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150272 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 150275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150302 */   GIR_RootConstrainSelectedInstOperands,
     /* 150303 */   // GIR_Coverage, 6447,
     /* 150303 */   GIR_EraseRootFromParent_Done,
     /* 150304 */ // Label 2252: @150304
     /* 150304 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(150374), // Rule ID 6449 //
     /* 150309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 150312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150322 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150342 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 150345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150372 */   GIR_RootConstrainSelectedInstOperands,
     /* 150373 */   // GIR_Coverage, 6449,
     /* 150373 */   GIR_EraseRootFromParent_Done,
     /* 150374 */ // Label 2253: @150374
     /* 150374 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(150444), // Rule ID 6471 //
     /* 150379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 150382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150392 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150412 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 150415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150442 */   GIR_RootConstrainSelectedInstOperands,
     /* 150443 */   // GIR_Coverage, 6471,
     /* 150443 */   GIR_EraseRootFromParent_Done,
     /* 150444 */ // Label 2254: @150444
     /* 150444 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(150514), // Rule ID 6473 //
     /* 150449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 150452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150462 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150482 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 150485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150512 */   GIR_RootConstrainSelectedInstOperands,
     /* 150513 */   // GIR_Coverage, 6473,
     /* 150513 */   GIR_EraseRootFromParent_Done,
     /* 150514 */ // Label 2255: @150514
     /* 150514 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(150581), // Rule ID 4185 //
     /* 150519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 150522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150532 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150552 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 150555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150579 */   GIR_RootConstrainSelectedInstOperands,
     /* 150580 */   // GIR_Coverage, 4185,
     /* 150580 */   GIR_EraseRootFromParent_Done,
     /* 150581 */ // Label 2256: @150581
     /* 150581 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(150648), // Rule ID 4194 //
     /* 150586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 150589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150592 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150599 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150619 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /* 150622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150646 */   GIR_RootConstrainSelectedInstOperands,
     /* 150647 */   // GIR_Coverage, 4194,
     /* 150647 */   GIR_EraseRootFromParent_Done,
     /* 150648 */ // Label 2257: @150648
     /* 150648 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(150710), // Rule ID 4184 //
     /* 150653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150656 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150666 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 150686 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 150686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 150689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 150696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150708 */   GIR_RootConstrainSelectedInstOperands,
     /* 150709 */   // GIR_Coverage, 4184,
     /* 150709 */   GIR_EraseRootFromParent_Done,
     /* 150710 */ // Label 2258: @150710
     /* 150710 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(150772), // Rule ID 4193 //
     /* 150715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150728 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150737 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150741 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 150748 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 150748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /* 150751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 150758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150770 */   GIR_RootConstrainSelectedInstOperands,
     /* 150771 */   // GIR_Coverage, 4193,
     /* 150771 */   GIR_EraseRootFromParent_Done,
     /* 150772 */ // Label 2259: @150772
     /* 150772 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(150834), // Rule ID 4183 //
     /* 150777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150790 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 150810 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 150813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150832 */   GIR_RootConstrainSelectedInstOperands,
     /* 150833 */   // GIR_Coverage, 4183,
     /* 150833 */   GIR_EraseRootFromParent_Done,
     /* 150834 */ // Label 2260: @150834
     /* 150834 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(150896), // Rule ID 4192 //
     /* 150839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150852 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 150872 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /* 150875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150894 */   GIR_RootConstrainSelectedInstOperands,
     /* 150895 */   // GIR_Coverage, 4192,
     /* 150895 */   GIR_EraseRootFromParent_Done,
     /* 150896 */ // Label 2261: @150896
     /* 150896 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(150973), // Rule ID 4439 //
     /* 150901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 150904 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150907 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150914 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 150936 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 150936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 150939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 150946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 150956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 150961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150971 */   GIR_RootConstrainSelectedInstOperands,
     /* 150972 */   // GIR_Coverage, 4439,
     /* 150972 */   GIR_EraseRootFromParent_Done,
     /* 150973 */ // Label 2262: @150973
     /* 150973 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(151047), // Rule ID 4441 //
     /* 150978 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150988 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151010 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 151013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151045 */   GIR_RootConstrainSelectedInstOperands,
     /* 151046 */   // GIR_Coverage, 4441,
     /* 151046 */   GIR_EraseRootFromParent_Done,
     /* 151047 */ // Label 2263: @151047
     /* 151047 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(151124), // Rule ID 4447 //
     /* 151052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151055 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151058 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151065 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151087 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 151090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151122 */   GIR_RootConstrainSelectedInstOperands,
     /* 151123 */   // GIR_Coverage, 4447,
     /* 151123 */   GIR_EraseRootFromParent_Done,
     /* 151124 */ // Label 2264: @151124
     /* 151124 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(151198), // Rule ID 4449 //
     /* 151129 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151139 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151161 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 151164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151196 */   GIR_RootConstrainSelectedInstOperands,
     /* 151197 */   // GIR_Coverage, 4449,
     /* 151197 */   GIR_EraseRootFromParent_Done,
     /* 151198 */ // Label 2265: @151198
     /* 151198 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(151275), // Rule ID 4463 //
     /* 151203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151216 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151238 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 151241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151273 */   GIR_RootConstrainSelectedInstOperands,
     /* 151274 */   // GIR_Coverage, 4463,
     /* 151274 */   GIR_EraseRootFromParent_Done,
     /* 151275 */ // Label 2266: @151275
     /* 151275 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(151349), // Rule ID 4465 //
     /* 151280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151290 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151312 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 151315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151347 */   GIR_RootConstrainSelectedInstOperands,
     /* 151348 */   // GIR_Coverage, 4465,
     /* 151348 */   GIR_EraseRootFromParent_Done,
     /* 151349 */ // Label 2267: @151349
     /* 151349 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(151426), // Rule ID 4483 //
     /* 151354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151367 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151389 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 151392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151424 */   GIR_RootConstrainSelectedInstOperands,
     /* 151425 */   // GIR_Coverage, 4483,
     /* 151425 */   GIR_EraseRootFromParent_Done,
     /* 151426 */ // Label 2268: @151426
     /* 151426 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(151500), // Rule ID 4485 //
     /* 151431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151441 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151463 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 151466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151498 */   GIR_RootConstrainSelectedInstOperands,
     /* 151499 */   // GIR_Coverage, 4485,
     /* 151499 */   GIR_EraseRootFromParent_Done,
     /* 151500 */ // Label 2269: @151500
     /* 151500 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(151576), // Rule ID 6416 //
     /* 151505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 151508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151518 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151539 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 151542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151574 */   GIR_RootConstrainSelectedInstOperands,
     /* 151575 */   // GIR_Coverage, 6416,
     /* 151575 */   GIR_EraseRootFromParent_Done,
     /* 151576 */ // Label 2270: @151576
     /* 151576 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(151652), // Rule ID 6419 //
     /* 151581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 151584 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151587 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151594 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151608 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151615 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 151618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151650 */   GIR_RootConstrainSelectedInstOperands,
     /* 151651 */   // GIR_Coverage, 6419,
     /* 151651 */   GIR_EraseRootFromParent_Done,
     /* 151652 */ // Label 2271: @151652
     /* 151652 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(151727), // Rule ID 6446 //
     /* 151657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 151660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151670 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151690 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 151693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151725 */   GIR_RootConstrainSelectedInstOperands,
     /* 151726 */   // GIR_Coverage, 6446,
     /* 151726 */   GIR_EraseRootFromParent_Done,
     /* 151727 */ // Label 2272: @151727
     /* 151727 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(151802), // Rule ID 6448 //
     /* 151732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 151735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151745 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151765 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 151768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151796 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151800 */   GIR_RootConstrainSelectedInstOperands,
     /* 151801 */   // GIR_Coverage, 6448,
     /* 151801 */   GIR_EraseRootFromParent_Done,
     /* 151802 */ // Label 2273: @151802
     /* 151802 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(151877), // Rule ID 6470 //
     /* 151807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 151810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151820 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151840 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 151843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151875 */   GIR_RootConstrainSelectedInstOperands,
     /* 151876 */   // GIR_Coverage, 6470,
     /* 151876 */   GIR_EraseRootFromParent_Done,
     /* 151877 */ // Label 2274: @151877
     /* 151877 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(151952), // Rule ID 6472 //
     /* 151882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 151885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151895 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151915 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 151918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151950 */   GIR_RootConstrainSelectedInstOperands,
     /* 151951 */   // GIR_Coverage, 6472,
     /* 151951 */   GIR_EraseRootFromParent_Done,
     /* 151952 */ // Label 2275: @151952
     /* 151952 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(152024), // Rule ID 4438 //
     /* 151957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151960 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151963 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151970 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151992 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 151995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152022 */   GIR_RootConstrainSelectedInstOperands,
     /* 152023 */   // GIR_Coverage, 4438,
     /* 152023 */   GIR_EraseRootFromParent_Done,
     /* 152024 */ // Label 2276: @152024
     /* 152024 */ GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(152093), // Rule ID 4440 //
     /* 152029 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152039 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152061 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 152064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152091 */   GIR_RootConstrainSelectedInstOperands,
     /* 152092 */   // GIR_Coverage, 4440,
     /* 152092 */   GIR_EraseRootFromParent_Done,
     /* 152093 */ // Label 2277: @152093
     /* 152093 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(152165), // Rule ID 4446 //
     /* 152098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 152101 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152133 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 152136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152159 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152163 */   GIR_RootConstrainSelectedInstOperands,
     /* 152164 */   // GIR_Coverage, 4446,
     /* 152164 */   GIR_EraseRootFromParent_Done,
     /* 152165 */ // Label 2278: @152165
     /* 152165 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(152234), // Rule ID 4448 //
     /* 152170 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152180 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152202 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 152205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152232 */   GIR_RootConstrainSelectedInstOperands,
     /* 152233 */   // GIR_Coverage, 4448,
     /* 152233 */   GIR_EraseRootFromParent_Done,
     /* 152234 */ // Label 2279: @152234
     /* 152234 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(152306), // Rule ID 4462 //
     /* 152239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 152242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152245 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152252 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152263 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152267 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152274 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 152277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152304 */   GIR_RootConstrainSelectedInstOperands,
     /* 152305 */   // GIR_Coverage, 4462,
     /* 152305 */   GIR_EraseRootFromParent_Done,
     /* 152306 */ // Label 2280: @152306
     /* 152306 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(152375), // Rule ID 4464 //
     /* 152311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152321 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152332 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152336 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152343 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 152346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152373 */   GIR_RootConstrainSelectedInstOperands,
     /* 152374 */   // GIR_Coverage, 4464,
     /* 152374 */   GIR_EraseRootFromParent_Done,
     /* 152375 */ // Label 2281: @152375
     /* 152375 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(152447), // Rule ID 4482 //
     /* 152380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 152383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152393 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152415 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 152418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152445 */   GIR_RootConstrainSelectedInstOperands,
     /* 152446 */   // GIR_Coverage, 4482,
     /* 152446 */   GIR_EraseRootFromParent_Done,
     /* 152447 */ // Label 2282: @152447
     /* 152447 */ GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(152516), // Rule ID 4484 //
     /* 152452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152462 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152477 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152484 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 152487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152514 */   GIR_RootConstrainSelectedInstOperands,
     /* 152515 */   // GIR_Coverage, 4484,
     /* 152515 */   GIR_EraseRootFromParent_Done,
     /* 152516 */ // Label 2283: @152516
     /* 152516 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(152578), // Rule ID 7804 //
     /* 152521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152534 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152554 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152576 */   GIR_RootConstrainSelectedInstOperands,
     /* 152577 */   // GIR_Coverage, 7804,
     /* 152577 */   GIR_EraseRootFromParent_Done,
     /* 152578 */ // Label 2284: @152578
     /* 152578 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(152640), // Rule ID 7805 //
     /* 152583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152596 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152616 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152638 */   GIR_RootConstrainSelectedInstOperands,
     /* 152639 */   // GIR_Coverage, 7805,
     /* 152639 */   GIR_EraseRootFromParent_Done,
     /* 152640 */ // Label 2285: @152640
     /* 152640 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(152702), // Rule ID 7812 //
     /* 152645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152651 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152658 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152678 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi16_glue>><<P:Predicate_zextloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 152681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152700 */   GIR_RootConstrainSelectedInstOperands,
     /* 152701 */   // GIR_Coverage, 7812,
     /* 152701 */   GIR_EraseRootFromParent_Done,
     /* 152702 */ // Label 2286: @152702
     /* 152702 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(152764), // Rule ID 7813 //
     /* 152707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152720 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152740 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 152743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152762 */   GIR_RootConstrainSelectedInstOperands,
     /* 152763 */   // GIR_Coverage, 7813,
     /* 152763 */   GIR_EraseRootFromParent_Done,
     /* 152764 */ // Label 2287: @152764
     /* 152764 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(152826), // Rule ID 7853 //
     /* 152769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152772 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152782 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152802 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152824 */   GIR_RootConstrainSelectedInstOperands,
     /* 152825 */   // GIR_Coverage, 7853,
     /* 152825 */   GIR_EraseRootFromParent_Done,
     /* 152826 */ // Label 2288: @152826
     /* 152826 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(152888), // Rule ID 7854 //
     /* 152831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152834 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152844 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152864 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152886 */   GIR_RootConstrainSelectedInstOperands,
     /* 152887 */   // GIR_Coverage, 7854,
     /* 152887 */   GIR_EraseRootFromParent_Done,
     /* 152888 */ // Label 2289: @152888
     /* 152888 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(152950), // Rule ID 7867 //
     /* 152893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152906 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152926 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_16_glue>><<P:Predicate_atomic_load_zext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 152929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152948 */   GIR_RootConstrainSelectedInstOperands,
     /* 152949 */   // GIR_Coverage, 7867,
     /* 152949 */   GIR_EraseRootFromParent_Done,
     /* 152950 */ // Label 2290: @152950
     /* 152950 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(153012), // Rule ID 7868 //
     /* 152955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152958 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152961 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152968 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152988 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 152991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153010 */   GIR_RootConstrainSelectedInstOperands,
     /* 153011 */   // GIR_Coverage, 7868,
     /* 153011 */   GIR_EraseRootFromParent_Done,
     /* 153012 */ // Label 2291: @153012
     /* 153012 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(153081), // Rule ID 3802 //
     /* 153017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153030 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153045 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153052 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 153055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153079 */   GIR_RootConstrainSelectedInstOperands,
     /* 153080 */   // GIR_Coverage, 3802,
     /* 153080 */   GIR_EraseRootFromParent_Done,
     /* 153081 */ // Label 2292: @153081
     /* 153081 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(153150), // Rule ID 3810 //
     /* 153086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153089 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153099 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153121 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153148 */   GIR_RootConstrainSelectedInstOperands,
     /* 153149 */   // GIR_Coverage, 3810,
     /* 153149 */   GIR_EraseRootFromParent_Done,
     /* 153150 */ // Label 2293: @153150
     /* 153150 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(153219), // Rule ID 3820 //
     /* 153155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153168 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153190 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 153193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153217 */   GIR_RootConstrainSelectedInstOperands,
     /* 153218 */   // GIR_Coverage, 3820,
     /* 153218 */   GIR_EraseRootFromParent_Done,
     /* 153219 */ // Label 2294: @153219
     /* 153219 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(153288), // Rule ID 3826 //
     /* 153224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153237 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153259 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153286 */   GIR_RootConstrainSelectedInstOperands,
     /* 153287 */   // GIR_Coverage, 3826,
     /* 153287 */   GIR_EraseRootFromParent_Done,
     /* 153288 */ // Label 2295: @153288
     /* 153288 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(153357), // Rule ID 3838 //
     /* 153293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 153296 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153306 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153328 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153355 */   GIR_RootConstrainSelectedInstOperands,
     /* 153356 */   // GIR_Coverage, 3838,
     /* 153356 */   GIR_EraseRootFromParent_Done,
     /* 153357 */ // Label 2296: @153357
     /* 153357 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(153426), // Rule ID 3850 //
     /* 153362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 153365 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153375 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153397 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153424 */   GIR_RootConstrainSelectedInstOperands,
     /* 153425 */   // GIR_Coverage, 3850,
     /* 153425 */   GIR_EraseRootFromParent_Done,
     /* 153426 */ // Label 2297: @153426
     /* 153426 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(153490), // Rule ID 3801 //
     /* 153431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153434 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153437 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153444 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153466 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153488 */   GIR_RootConstrainSelectedInstOperands,
     /* 153489 */   // GIR_Coverage, 3801,
     /* 153489 */   GIR_EraseRootFromParent_Done,
     /* 153490 */ // Label 2298: @153490
     /* 153490 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(153554), // Rule ID 3809 //
     /* 153495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153508 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153530 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153552 */   GIR_RootConstrainSelectedInstOperands,
     /* 153553 */   // GIR_Coverage, 3809,
     /* 153553 */   GIR_EraseRootFromParent_Done,
     /* 153554 */ // Label 2299: @153554
     /* 153554 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(153618), // Rule ID 3819 //
     /* 153559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153565 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153572 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153594 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153612 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153616 */   GIR_RootConstrainSelectedInstOperands,
     /* 153617 */   // GIR_Coverage, 3819,
     /* 153617 */   GIR_EraseRootFromParent_Done,
     /* 153618 */ // Label 2300: @153618
     /* 153618 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(153682), // Rule ID 3825 //
     /* 153623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153629 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153636 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153658 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153680 */   GIR_RootConstrainSelectedInstOperands,
     /* 153681 */   // GIR_Coverage, 3825,
     /* 153681 */   GIR_EraseRootFromParent_Done,
     /* 153682 */ // Label 2301: @153682
     /* 153682 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(153746), // Rule ID 3837 //
     /* 153687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 153690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153700 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153722 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153744 */   GIR_RootConstrainSelectedInstOperands,
     /* 153745 */   // GIR_Coverage, 3837,
     /* 153745 */   GIR_EraseRootFromParent_Done,
     /* 153746 */ // Label 2302: @153746
     /* 153746 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(153810), // Rule ID 3849 //
     /* 153751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 153754 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153786 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153808 */   GIR_RootConstrainSelectedInstOperands,
     /* 153809 */   // GIR_Coverage, 3849,
     /* 153809 */   GIR_EraseRootFromParent_Done,
     /* 153810 */ // Label 2303: @153810
     /* 153810 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(153875), // Rule ID 3574 //
     /* 153815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153818 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153821 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153828 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153851 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153873 */   GIR_RootConstrainSelectedInstOperands,
     /* 153874 */   // GIR_Coverage, 3574,
     /* 153874 */   GIR_EraseRootFromParent_Done,
     /* 153875 */ // Label 2304: @153875
     /* 153875 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(153940), // Rule ID 3578 //
     /* 153880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153893 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153916 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 153919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153938 */   GIR_RootConstrainSelectedInstOperands,
     /* 153939 */   // GIR_Coverage, 3578,
     /* 153939 */   GIR_EraseRootFromParent_Done,
     /* 153940 */ // Label 2305: @153940
     /* 153940 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(154005), // Rule ID 3581 //
     /* 153945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153958 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153970 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153974 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153981 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154003 */   GIR_RootConstrainSelectedInstOperands,
     /* 154004 */   // GIR_Coverage, 3581,
     /* 154004 */   GIR_EraseRootFromParent_Done,
     /* 154005 */ // Label 2306: @154005
     /* 154005 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(154070), // Rule ID 3586 //
     /* 154010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 154013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154023 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 154046 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 154046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 154049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154068 */   GIR_RootConstrainSelectedInstOperands,
     /* 154069 */   // GIR_Coverage, 3586,
     /* 154069 */   GIR_EraseRootFromParent_Done,
     /* 154070 */ // Label 2307: @154070
     /* 154070 */ GIM_Reject,
     /* 154071 */ // Label 2203: @154071
     /* 154071 */ GIM_Reject,
     /* 154072 */ // Label 17: @154072
     /* 154072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 2325*/ GIMT_Encode4(187976),
     /* 154083 */ /*GILLT_p0s64*//*Label 2308*/ GIMT_Encode4(154175),
     /* 154087 */ /*GILLT_p1s64*//*Label 2309*/ GIMT_Encode4(155168),
     /* 154091 */ /*GILLT_p2s32*//*Label 2310*/ GIMT_Encode4(156161),
     /* 154095 */ /*GILLT_p3s32*//*Label 2311*/ GIMT_Encode4(157032),
     /* 154099 */ /*GILLT_p4s64*//*Label 2312*/ GIMT_Encode4(157903),
     /* 154103 */ /*GILLT_p5s32*//*Label 2313*/ GIMT_Encode4(158896),
     /* 154107 */ /*GILLT_p6s32*//*Label 2314*/ GIMT_Encode4(159767), GIMT_Encode4(0),
     /* 154115 */ /*GILLT_s16*//*Label 2315*/ GIMT_Encode4(160638),
     /* 154119 */ /*GILLT_s32*//*Label 2316*/ GIMT_Encode4(164949),
     /* 154123 */ /*GILLT_s64*//*Label 2317*/ GIMT_Encode4(172051),
     /* 154127 */ /*GILLT_v2s16*//*Label 2318*/ GIMT_Encode4(174481),
     /* 154131 */ /*GILLT_v2s32*//*Label 2319*/ GIMT_Encode4(176213),
     /* 154135 */ /*GILLT_v2s64*//*Label 2320*/ GIMT_Encode4(178423),
     /* 154139 */ /*GILLT_v3s32*//*Label 2321*/ GIMT_Encode4(180399), GIMT_Encode4(0),
     /* 154147 */ /*GILLT_v4s16*//*Label 2322*/ GIMT_Encode4(181814),
     /* 154151 */ /*GILLT_v4s32*//*Label 2323*/ GIMT_Encode4(183790), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 154171 */ /*GILLT_v8s16*//*Label 2324*/ GIMT_Encode4(186000),
     /* 154175 */ // Label 2308: @154175
     /* 154175 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(155167),
     /* 154180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154183 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(154244), // Rule ID 8087 //
     /* 154188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 154191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154195 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154200 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 154213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154220 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 154223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154242 */     GIR_RootConstrainSelectedInstOperands,
     /* 154243 */     // GIR_Coverage, 8087,
     /* 154243 */     GIR_EraseRootFromParent_Done,
     /* 154244 */   // Label 2327: @154244
     /* 154244 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(154300), // Rule ID 8019 //
     /* 154249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 154252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154256 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154261 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 154265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154276 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 154279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154284 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154298 */     GIR_RootConstrainSelectedInstOperands,
     /* 154299 */     // GIR_Coverage, 8019,
     /* 154299 */     GIR_EraseRootFromParent_Done,
     /* 154300 */   // Label 2328: @154300
     /* 154300 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(154357), // Rule ID 8088 //
     /* 154305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 154308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154313 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 154326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154333 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 154336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154341 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154355 */     GIR_RootConstrainSelectedInstOperands,
     /* 154356 */     // GIR_Coverage, 8088,
     /* 154356 */     GIR_EraseRootFromParent_Done,
     /* 154357 */   // Label 2329: @154357
     /* 154357 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(154409), // Rule ID 8020 //
     /* 154362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 154365 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154370 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 154374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154385 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 154388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154393 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154407 */     GIR_RootConstrainSelectedInstOperands,
     /* 154408 */     // GIR_Coverage, 8020,
     /* 154408 */     GIR_EraseRootFromParent_Done,
     /* 154409 */   // Label 2330: @154409
     /* 154409 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(154462), // Rule ID 4332 //
     /* 154414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 154417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 154433 */     // (st p0:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 154436 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 154448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154460 */     GIR_RootConstrainSelectedInstOperands,
     /* 154461 */     // GIR_Coverage, 4332,
     /* 154461 */     GIR_EraseRootFromParent_Done,
     /* 154462 */   // Label 2331: @154462
     /* 154462 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(154510), // Rule ID 4331 //
     /* 154467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154470 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 154486 */     // (st p0:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 154489 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 154496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154508 */     GIR_RootConstrainSelectedInstOperands,
     /* 154509 */     // GIR_Coverage, 4331,
     /* 154509 */     GIR_EraseRootFromParent_Done,
     /* 154510 */   // Label 2332: @154510
     /* 154510 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(154558), // Rule ID 4330 //
     /* 154515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154518 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 154534 */     // (st p0:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 154534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 154537 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154556 */     GIR_RootConstrainSelectedInstOperands,
     /* 154557 */     // GIR_Coverage, 4330,
     /* 154557 */     GIR_EraseRootFromParent_Done,
     /* 154558 */   // Label 2333: @154558
     /* 154558 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(154619), // Rule ID 4657 //
     /* 154563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154566 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154582 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 154585 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154617 */     GIR_RootConstrainSelectedInstOperands,
     /* 154618 */     // GIR_Coverage, 4657,
     /* 154618 */     GIR_EraseRootFromParent_Done,
     /* 154619 */   // Label 2334: @154619
     /* 154619 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(154677), // Rule ID 4659 //
     /* 154624 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154640 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 154643 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154675 */     GIR_RootConstrainSelectedInstOperands,
     /* 154676 */     // GIR_Coverage, 4659,
     /* 154676 */     GIR_EraseRootFromParent_Done,
     /* 154677 */   // Label 2335: @154677
     /* 154677 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(154794), // Rule ID 7962 //
     /* 154682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 154685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 154705 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 154705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154717 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 154723 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 154751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 154764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 154780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 154785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154792 */     GIR_RootConstrainSelectedInstOperands,
     /* 154793 */     // GIR_Coverage, 7962,
     /* 154793 */     GIR_EraseRootFromParent_Done,
     /* 154794 */   // Label 2336: @154794
     /* 154794 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(154850), // Rule ID 4656 //
     /* 154799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154802 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 154818 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 154821 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154848 */     GIR_RootConstrainSelectedInstOperands,
     /* 154849 */     // GIR_Coverage, 4656,
     /* 154849 */     GIR_EraseRootFromParent_Done,
     /* 154850 */   // Label 2337: @154850
     /* 154850 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(154903), // Rule ID 4658 //
     /* 154855 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 154871 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 154874 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154901 */     GIR_RootConstrainSelectedInstOperands,
     /* 154902 */     // GIR_Coverage, 4658,
     /* 154902 */     GIR_EraseRootFromParent_Done,
     /* 154903 */   // Label 2338: @154903
     /* 154903 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(155016), // Rule ID 7964 //
     /* 154908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 154911 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 154927 */     // (st p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 154927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 154945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 154973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 154986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 155002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 155007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155014 */     GIR_RootConstrainSelectedInstOperands,
     /* 155015 */     // GIR_Coverage, 7964,
     /* 155015 */     GIR_EraseRootFromParent_Done,
     /* 155016 */   // Label 2339: @155016
     /* 155016 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(155069), // Rule ID 3918 //
     /* 155021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 155024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 155040 */     // (st p0:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 155043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 155048 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 155055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155067 */     GIR_RootConstrainSelectedInstOperands,
     /* 155068 */     // GIR_Coverage, 3918,
     /* 155068 */     GIR_EraseRootFromParent_Done,
     /* 155069 */   // Label 2340: @155069
     /* 155069 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(155117), // Rule ID 3917 //
     /* 155074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 155077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 155093 */     // (st p0:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 155093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 155096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155101 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155115 */     GIR_RootConstrainSelectedInstOperands,
     /* 155116 */     // GIR_Coverage, 3917,
     /* 155116 */     GIR_EraseRootFromParent_Done,
     /* 155117 */   // Label 2341: @155117
     /* 155117 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(155166), // Rule ID 3640 //
     /* 155122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 155125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 155131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 155142 */     // (st p0:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 155142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 155145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155150 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155164 */     GIR_RootConstrainSelectedInstOperands,
     /* 155165 */     // GIR_Coverage, 3640,
     /* 155165 */     GIR_EraseRootFromParent_Done,
     /* 155166 */   // Label 2342: @155166
     /* 155166 */   GIM_Reject,
     /* 155167 */ // Label 2326: @155167
     /* 155167 */ GIM_Reject,
     /* 155168 */ // Label 2309: @155168
     /* 155168 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(156160),
     /* 155173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155176 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(155237), // Rule ID 8091 //
     /* 155181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 155184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 155188 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 155206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155213 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 155216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155221 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155235 */     GIR_RootConstrainSelectedInstOperands,
     /* 155236 */     // GIR_Coverage, 8091,
     /* 155236 */     GIR_EraseRootFromParent_Done,
     /* 155237 */   // Label 2344: @155237
     /* 155237 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(155293), // Rule ID 8023 //
     /* 155242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 155245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 155249 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155254 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 155258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155269 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 155272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155277 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155291 */     GIR_RootConstrainSelectedInstOperands,
     /* 155292 */     // GIR_Coverage, 8023,
     /* 155292 */     GIR_EraseRootFromParent_Done,
     /* 155293 */   // Label 2345: @155293
     /* 155293 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(155350), // Rule ID 8092 //
     /* 155298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 155301 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155306 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 155319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155326 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 155329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155334 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155348 */     GIR_RootConstrainSelectedInstOperands,
     /* 155349 */     // GIR_Coverage, 8092,
     /* 155349 */     GIR_EraseRootFromParent_Done,
     /* 155350 */   // Label 2346: @155350
     /* 155350 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(155402), // Rule ID 8024 //
     /* 155355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 155358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155363 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 155367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155378 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 155381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155386 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155400 */     GIR_RootConstrainSelectedInstOperands,
     /* 155401 */     // GIR_Coverage, 8024,
     /* 155401 */     GIR_EraseRootFromParent_Done,
     /* 155402 */   // Label 2347: @155402
     /* 155402 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(155455), // Rule ID 4338 //
     /* 155407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 155410 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 155426 */     // (st p1:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 155429 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 155441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155453 */     GIR_RootConstrainSelectedInstOperands,
     /* 155454 */     // GIR_Coverage, 4338,
     /* 155454 */     GIR_EraseRootFromParent_Done,
     /* 155455 */   // Label 2348: @155455
     /* 155455 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(155503), // Rule ID 4337 //
     /* 155460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 155463 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 155479 */     // (st p1:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 155482 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 155489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155501 */     GIR_RootConstrainSelectedInstOperands,
     /* 155502 */     // GIR_Coverage, 4337,
     /* 155502 */     GIR_EraseRootFromParent_Done,
     /* 155503 */   // Label 2349: @155503
     /* 155503 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(155551), // Rule ID 4336 //
     /* 155508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 155511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 155527 */     // (st p1:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 155527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 155530 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155549 */     GIR_RootConstrainSelectedInstOperands,
     /* 155550 */     // GIR_Coverage, 4336,
     /* 155550 */     GIR_EraseRootFromParent_Done,
     /* 155551 */   // Label 2350: @155551
     /* 155551 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(155612), // Rule ID 4661 //
     /* 155556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155559 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155575 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 155578 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155610 */     GIR_RootConstrainSelectedInstOperands,
     /* 155611 */     // GIR_Coverage, 4661,
     /* 155611 */     GIR_EraseRootFromParent_Done,
     /* 155612 */   // Label 2351: @155612
     /* 155612 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(155670), // Rule ID 4663 //
     /* 155617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155633 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 155636 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155668 */     GIR_RootConstrainSelectedInstOperands,
     /* 155669 */     // GIR_Coverage, 4663,
     /* 155669 */     GIR_EraseRootFromParent_Done,
     /* 155670 */   // Label 2352: @155670
     /* 155670 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(155787), // Rule ID 7966 //
     /* 155675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 155678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 155682 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 155698 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 155698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155710 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 155716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155738 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 155744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 155757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 155773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 155778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155785 */     GIR_RootConstrainSelectedInstOperands,
     /* 155786 */     // GIR_Coverage, 7966,
     /* 155786 */     GIR_EraseRootFromParent_Done,
     /* 155787 */   // Label 2353: @155787
     /* 155787 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(155843), // Rule ID 4660 //
     /* 155792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155811 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 155814 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155841 */     GIR_RootConstrainSelectedInstOperands,
     /* 155842 */     // GIR_Coverage, 4660,
     /* 155842 */     GIR_EraseRootFromParent_Done,
     /* 155843 */   // Label 2354: @155843
     /* 155843 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(155896), // Rule ID 4662 //
     /* 155848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155864 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 155867 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155894 */     GIR_RootConstrainSelectedInstOperands,
     /* 155895 */     // GIR_Coverage, 4662,
     /* 155895 */     GIR_EraseRootFromParent_Done,
     /* 155896 */   // Label 2355: @155896
     /* 155896 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(156009), // Rule ID 7968 //
     /* 155901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 155904 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 155920 */     // (st p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 155920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155932 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 155938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 155966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 155979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 155995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 156000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156007 */     GIR_RootConstrainSelectedInstOperands,
     /* 156008 */     // GIR_Coverage, 7968,
     /* 156008 */     GIR_EraseRootFromParent_Done,
     /* 156009 */   // Label 2356: @156009
     /* 156009 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(156062), // Rule ID 3922 //
     /* 156014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156017 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156033 */     // (st p1:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 156036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156041 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156060 */     GIR_RootConstrainSelectedInstOperands,
     /* 156061 */     // GIR_Coverage, 3922,
     /* 156061 */     GIR_EraseRootFromParent_Done,
     /* 156062 */   // Label 2357: @156062
     /* 156062 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(156110), // Rule ID 3921 //
     /* 156067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 156086 */     // (st p1:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 156086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 156089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156094 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156108 */     GIR_RootConstrainSelectedInstOperands,
     /* 156109 */     // GIR_Coverage, 3921,
     /* 156109 */     GIR_EraseRootFromParent_Done,
     /* 156110 */   // Label 2358: @156110
     /* 156110 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(156159), // Rule ID 3642 //
     /* 156115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 156118 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 156124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 156135 */     // (st p1:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 156135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 156138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156143 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156157 */     GIR_RootConstrainSelectedInstOperands,
     /* 156158 */     // GIR_Coverage, 3642,
     /* 156158 */     GIR_EraseRootFromParent_Done,
     /* 156159 */   // Label 2359: @156159
     /* 156159 */   GIM_Reject,
     /* 156160 */ // Label 2343: @156160
     /* 156160 */ GIM_Reject,
     /* 156161 */ // Label 2310: @156161
     /* 156161 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(157031),
     /* 156166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156169 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(156225), // Rule ID 6617 //
     /* 156174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 156177 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 156193 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 156196 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156223 */     GIR_RootConstrainSelectedInstOperands,
     /* 156224 */     // GIR_Coverage, 6617,
     /* 156224 */     GIR_EraseRootFromParent_Done,
     /* 156225 */   // Label 2361: @156225
     /* 156225 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(156281), // Rule ID 6619 //
     /* 156230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 156233 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 156249 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 156252 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156279 */     GIR_RootConstrainSelectedInstOperands,
     /* 156280 */     // GIR_Coverage, 6619,
     /* 156280 */     GIR_EraseRootFromParent_Done,
     /* 156281 */   // Label 2362: @156281
     /* 156281 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(156334), // Rule ID 4272 //
     /* 156286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 156289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 156305 */     // (st p2:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 156308 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 156320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156332 */     GIR_RootConstrainSelectedInstOperands,
     /* 156333 */     // GIR_Coverage, 4272,
     /* 156333 */     GIR_EraseRootFromParent_Done,
     /* 156334 */   // Label 2363: @156334
     /* 156334 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(156382), // Rule ID 4271 //
     /* 156339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 156342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 156358 */     // (st p2:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 156361 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156380 */     GIR_RootConstrainSelectedInstOperands,
     /* 156381 */     // GIR_Coverage, 4271,
     /* 156381 */     GIR_EraseRootFromParent_Done,
     /* 156382 */   // Label 2364: @156382
     /* 156382 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(156430), // Rule ID 4270 //
     /* 156387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 156390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 156406 */     // (st p2:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 156406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 156409 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156428 */     GIR_RootConstrainSelectedInstOperands,
     /* 156429 */     // GIR_Coverage, 4270,
     /* 156429 */     GIR_EraseRootFromParent_Done,
     /* 156430 */   // Label 2365: @156430
     /* 156430 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(156491), // Rule ID 4617 //
     /* 156435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 156454 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 156457 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156489 */     GIR_RootConstrainSelectedInstOperands,
     /* 156490 */     // GIR_Coverage, 4617,
     /* 156490 */     GIR_EraseRootFromParent_Done,
     /* 156491 */   // Label 2366: @156491
     /* 156491 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(156549), // Rule ID 4619 //
     /* 156496 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 156512 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156547 */     GIR_RootConstrainSelectedInstOperands,
     /* 156548 */     // GIR_Coverage, 4619,
     /* 156548 */     GIR_EraseRootFromParent_Done,
     /* 156549 */   // Label 2367: @156549
     /* 156549 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(156610), // Rule ID 6616 //
     /* 156554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 156557 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 156573 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 156576 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156608 */     GIR_RootConstrainSelectedInstOperands,
     /* 156609 */     // GIR_Coverage, 6616,
     /* 156609 */     GIR_EraseRootFromParent_Done,
     /* 156610 */   // Label 2368: @156610
     /* 156610 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(156671), // Rule ID 6618 //
     /* 156615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 156618 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 156634 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 156637 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156669 */     GIR_RootConstrainSelectedInstOperands,
     /* 156670 */     // GIR_Coverage, 6618,
     /* 156670 */     GIR_EraseRootFromParent_Done,
     /* 156671 */   // Label 2369: @156671
     /* 156671 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(156727), // Rule ID 4616 //
     /* 156676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156679 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156695 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 156698 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156725 */     GIR_RootConstrainSelectedInstOperands,
     /* 156726 */     // GIR_Coverage, 4616,
     /* 156726 */     GIR_EraseRootFromParent_Done,
     /* 156727 */   // Label 2370: @156727
     /* 156727 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(156780), // Rule ID 4618 //
     /* 156732 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156748 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 156751 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156778 */     GIR_RootConstrainSelectedInstOperands,
     /* 156779 */     // GIR_Coverage, 4618,
     /* 156779 */     GIR_EraseRootFromParent_Done,
     /* 156780 */   // Label 2371: @156780
     /* 156780 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(156832), // Rule ID 7907 //
     /* 156785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 156792 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156808 */     // (AMDGPUst_glue p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 156811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156816 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156830 */     GIR_RootConstrainSelectedInstOperands,
     /* 156831 */     // GIR_Coverage, 7907,
     /* 156831 */     GIR_EraseRootFromParent_Done,
     /* 156832 */   // Label 2372: @156832
     /* 156832 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(156880), // Rule ID 7908 //
     /* 156837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156840 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156856 */     // (st p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 156859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156864 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156878 */     GIR_RootConstrainSelectedInstOperands,
     /* 156879 */     // GIR_Coverage, 7908,
     /* 156879 */     GIR_EraseRootFromParent_Done,
     /* 156880 */   // Label 2373: @156880
     /* 156880 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(156933), // Rule ID 3878 //
     /* 156885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156888 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156904 */     // (st p2:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 156907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156912 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156931 */     GIR_RootConstrainSelectedInstOperands,
     /* 156932 */     // GIR_Coverage, 3878,
     /* 156932 */     GIR_EraseRootFromParent_Done,
     /* 156933 */   // Label 2374: @156933
     /* 156933 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(156981), // Rule ID 3877 //
     /* 156938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156941 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 156957 */     // (st p2:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 156957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 156960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156965 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156979 */     GIR_RootConstrainSelectedInstOperands,
     /* 156980 */     // GIR_Coverage, 3877,
     /* 156980 */     GIR_EraseRootFromParent_Done,
     /* 156981 */   // Label 2375: @156981
     /* 156981 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(157030), // Rule ID 3621 //
     /* 156986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 156989 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 156995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157006 */     // (st p2:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 157006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 157009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157014 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157028 */     GIR_RootConstrainSelectedInstOperands,
     /* 157029 */     // GIR_Coverage, 3621,
     /* 157029 */     GIR_EraseRootFromParent_Done,
     /* 157030 */   // Label 2376: @157030
     /* 157030 */   GIM_Reject,
     /* 157031 */ // Label 2360: @157031
     /* 157031 */ GIM_Reject,
     /* 157032 */ // Label 2311: @157032
     /* 157032 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(157902),
     /* 157037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157040 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(157096), // Rule ID 6621 //
     /* 157045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 157048 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 157064 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 157067 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157094 */     GIR_RootConstrainSelectedInstOperands,
     /* 157095 */     // GIR_Coverage, 6621,
     /* 157095 */     GIR_EraseRootFromParent_Done,
     /* 157096 */   // Label 2378: @157096
     /* 157096 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(157152), // Rule ID 6623 //
     /* 157101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 157104 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 157120 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 157123 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157150 */     GIR_RootConstrainSelectedInstOperands,
     /* 157151 */     // GIR_Coverage, 6623,
     /* 157151 */     GIR_EraseRootFromParent_Done,
     /* 157152 */   // Label 2379: @157152
     /* 157152 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(157205), // Rule ID 4278 //
     /* 157157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 157160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 157176 */     // (st p3:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 157179 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 157191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157203 */     GIR_RootConstrainSelectedInstOperands,
     /* 157204 */     // GIR_Coverage, 4278,
     /* 157204 */     GIR_EraseRootFromParent_Done,
     /* 157205 */   // Label 2380: @157205
     /* 157205 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(157253), // Rule ID 4277 //
     /* 157210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 157213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 157229 */     // (st p3:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 157232 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157251 */     GIR_RootConstrainSelectedInstOperands,
     /* 157252 */     // GIR_Coverage, 4277,
     /* 157252 */     GIR_EraseRootFromParent_Done,
     /* 157253 */   // Label 2381: @157253
     /* 157253 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(157301), // Rule ID 4276 //
     /* 157258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 157261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 157277 */     // (st p3:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 157280 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157299 */     GIR_RootConstrainSelectedInstOperands,
     /* 157300 */     // GIR_Coverage, 4276,
     /* 157300 */     GIR_EraseRootFromParent_Done,
     /* 157301 */   // Label 2382: @157301
     /* 157301 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(157362), // Rule ID 4621 //
     /* 157306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 157309 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 157325 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157360 */     GIR_RootConstrainSelectedInstOperands,
     /* 157361 */     // GIR_Coverage, 4621,
     /* 157361 */     GIR_EraseRootFromParent_Done,
     /* 157362 */   // Label 2383: @157362
     /* 157362 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(157420), // Rule ID 4623 //
     /* 157367 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 157383 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 157386 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157418 */     GIR_RootConstrainSelectedInstOperands,
     /* 157419 */     // GIR_Coverage, 4623,
     /* 157419 */     GIR_EraseRootFromParent_Done,
     /* 157420 */   // Label 2384: @157420
     /* 157420 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(157481), // Rule ID 6620 //
     /* 157425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 157428 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 157444 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 157447 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157479 */     GIR_RootConstrainSelectedInstOperands,
     /* 157480 */     // GIR_Coverage, 6620,
     /* 157480 */     GIR_EraseRootFromParent_Done,
     /* 157481 */   // Label 2385: @157481
     /* 157481 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(157542), // Rule ID 6622 //
     /* 157486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 157489 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 157505 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 157508 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157540 */     GIR_RootConstrainSelectedInstOperands,
     /* 157541 */     // GIR_Coverage, 6622,
     /* 157541 */     GIR_EraseRootFromParent_Done,
     /* 157542 */   // Label 2386: @157542
     /* 157542 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(157598), // Rule ID 4620 //
     /* 157547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 157550 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 157566 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157596 */     GIR_RootConstrainSelectedInstOperands,
     /* 157597 */     // GIR_Coverage, 4620,
     /* 157597 */     GIR_EraseRootFromParent_Done,
     /* 157598 */   // Label 2387: @157598
     /* 157598 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(157651), // Rule ID 4622 //
     /* 157603 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 157619 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 157622 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157649 */     GIR_RootConstrainSelectedInstOperands,
     /* 157650 */     // GIR_Coverage, 4622,
     /* 157650 */     GIR_EraseRootFromParent_Done,
     /* 157651 */   // Label 2388: @157651
     /* 157651 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(157703), // Rule ID 7909 //
     /* 157656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 157659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157679 */     // (AMDGPUst_glue p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 157682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157687 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157701 */     GIR_RootConstrainSelectedInstOperands,
     /* 157702 */     // GIR_Coverage, 7909,
     /* 157702 */     GIR_EraseRootFromParent_Done,
     /* 157703 */   // Label 2389: @157703
     /* 157703 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(157751), // Rule ID 7910 //
     /* 157708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 157711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157727 */     // (st p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 157730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157735 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157749 */     GIR_RootConstrainSelectedInstOperands,
     /* 157750 */     // GIR_Coverage, 7910,
     /* 157750 */     GIR_EraseRootFromParent_Done,
     /* 157751 */   // Label 2390: @157751
     /* 157751 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(157804), // Rule ID 3882 //
     /* 157756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 157775 */     // (st p3:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 157778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 157783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157802 */     GIR_RootConstrainSelectedInstOperands,
     /* 157803 */     // GIR_Coverage, 3882,
     /* 157803 */     GIR_EraseRootFromParent_Done,
     /* 157804 */   // Label 2391: @157804
     /* 157804 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(157852), // Rule ID 3881 //
     /* 157809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157828 */     // (st p3:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 157828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 157831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157836 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157850 */     GIR_RootConstrainSelectedInstOperands,
     /* 157851 */     // GIR_Coverage, 3881,
     /* 157851 */     GIR_EraseRootFromParent_Done,
     /* 157852 */   // Label 2392: @157852
     /* 157852 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(157901), // Rule ID 3623 //
     /* 157857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 157866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157877 */     // (st p3:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 157877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 157880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157885 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157899 */     GIR_RootConstrainSelectedInstOperands,
     /* 157900 */     // GIR_Coverage, 3623,
     /* 157900 */     GIR_EraseRootFromParent_Done,
     /* 157901 */   // Label 2393: @157901
     /* 157901 */   GIM_Reject,
     /* 157902 */ // Label 2377: @157902
     /* 157902 */ GIM_Reject,
     /* 157903 */ // Label 2312: @157903
     /* 157903 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(158895),
     /* 157908 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157911 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(157972), // Rule ID 8095 //
     /* 157916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 157919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157923 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 157941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157948 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 157951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157956 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157970 */     GIR_RootConstrainSelectedInstOperands,
     /* 157971 */     // GIR_Coverage, 8095,
     /* 157971 */     GIR_EraseRootFromParent_Done,
     /* 157972 */   // Label 2395: @157972
     /* 157972 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(158028), // Rule ID 8027 //
     /* 157977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 157980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157984 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157989 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 157993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158004 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 158007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158012 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158026 */     GIR_RootConstrainSelectedInstOperands,
     /* 158027 */     // GIR_Coverage, 8027,
     /* 158027 */     GIR_EraseRootFromParent_Done,
     /* 158028 */   // Label 2396: @158028
     /* 158028 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(158085), // Rule ID 8096 //
     /* 158033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 158036 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158041 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 158054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158061 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 158064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158069 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158083 */     GIR_RootConstrainSelectedInstOperands,
     /* 158084 */     // GIR_Coverage, 8096,
     /* 158084 */     GIR_EraseRootFromParent_Done,
     /* 158085 */   // Label 2397: @158085
     /* 158085 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(158137), // Rule ID 8028 //
     /* 158090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 158093 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158098 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 158102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158113 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 158116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158121 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158135 */     GIR_RootConstrainSelectedInstOperands,
     /* 158136 */     // GIR_Coverage, 8028,
     /* 158136 */     GIR_EraseRootFromParent_Done,
     /* 158137 */   // Label 2398: @158137
     /* 158137 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(158190), // Rule ID 4344 //
     /* 158142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 158145 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 158161 */     // (st p4:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 158164 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 158176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158188 */     GIR_RootConstrainSelectedInstOperands,
     /* 158189 */     // GIR_Coverage, 4344,
     /* 158189 */     GIR_EraseRootFromParent_Done,
     /* 158190 */   // Label 2399: @158190
     /* 158190 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(158238), // Rule ID 4343 //
     /* 158195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 158214 */     // (st p4:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 158217 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158236 */     GIR_RootConstrainSelectedInstOperands,
     /* 158237 */     // GIR_Coverage, 4343,
     /* 158237 */     GIR_EraseRootFromParent_Done,
     /* 158238 */   // Label 2400: @158238
     /* 158238 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(158286), // Rule ID 4342 //
     /* 158243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158246 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 158262 */     // (st p4:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 158262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 158265 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158284 */     GIR_RootConstrainSelectedInstOperands,
     /* 158285 */     // GIR_Coverage, 4342,
     /* 158285 */     GIR_EraseRootFromParent_Done,
     /* 158286 */   // Label 2401: @158286
     /* 158286 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(158347), // Rule ID 4665 //
     /* 158291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158294 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158310 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 158313 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158345 */     GIR_RootConstrainSelectedInstOperands,
     /* 158346 */     // GIR_Coverage, 4665,
     /* 158346 */     GIR_EraseRootFromParent_Done,
     /* 158347 */   // Label 2402: @158347
     /* 158347 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(158405), // Rule ID 4667 //
     /* 158352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158368 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 158371 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158403 */     GIR_RootConstrainSelectedInstOperands,
     /* 158404 */     // GIR_Coverage, 4667,
     /* 158404 */     GIR_EraseRootFromParent_Done,
     /* 158405 */   // Label 2403: @158405
     /* 158405 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(158522), // Rule ID 7970 //
     /* 158410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 158413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 158417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158433 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158445 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158451 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158473 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 158492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158520 */     GIR_RootConstrainSelectedInstOperands,
     /* 158521 */     // GIR_Coverage, 7970,
     /* 158521 */     GIR_EraseRootFromParent_Done,
     /* 158522 */   // Label 2404: @158522
     /* 158522 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(158578), // Rule ID 4664 //
     /* 158527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158546 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 158549 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158576 */     GIR_RootConstrainSelectedInstOperands,
     /* 158577 */     // GIR_Coverage, 4664,
     /* 158577 */     GIR_EraseRootFromParent_Done,
     /* 158578 */   // Label 2405: @158578
     /* 158578 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(158631), // Rule ID 4666 //
     /* 158583 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158599 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 158602 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158629 */     GIR_RootConstrainSelectedInstOperands,
     /* 158630 */     // GIR_Coverage, 4666,
     /* 158630 */     GIR_EraseRootFromParent_Done,
     /* 158631 */   // Label 2406: @158631
     /* 158631 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(158744), // Rule ID 7972 //
     /* 158636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 158639 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158655 */     // (st p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158667 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158695 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 158714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158742 */     GIR_RootConstrainSelectedInstOperands,
     /* 158743 */     // GIR_Coverage, 7972,
     /* 158743 */     GIR_EraseRootFromParent_Done,
     /* 158744 */   // Label 2407: @158744
     /* 158744 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(158797), // Rule ID 3926 //
     /* 158749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 158768 */     // (st p4:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 158771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 158776 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158795 */     GIR_RootConstrainSelectedInstOperands,
     /* 158796 */     // GIR_Coverage, 3926,
     /* 158796 */     GIR_EraseRootFromParent_Done,
     /* 158797 */   // Label 2408: @158797
     /* 158797 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(158845), // Rule ID 3925 //
     /* 158802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158805 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 158821 */     // (st p4:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 158824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158829 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158843 */     GIR_RootConstrainSelectedInstOperands,
     /* 158844 */     // GIR_Coverage, 3925,
     /* 158844 */     GIR_EraseRootFromParent_Done,
     /* 158845 */   // Label 2409: @158845
     /* 158845 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(158894), // Rule ID 3644 //
     /* 158850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 158853 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 158859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 158870 */     // (st p4:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 158873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158878 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158892 */     GIR_RootConstrainSelectedInstOperands,
     /* 158893 */     // GIR_Coverage, 3644,
     /* 158893 */     GIR_EraseRootFromParent_Done,
     /* 158894 */   // Label 2410: @158894
     /* 158894 */   GIM_Reject,
     /* 158895 */ // Label 2394: @158895
     /* 158895 */ GIM_Reject,
     /* 158896 */ // Label 2313: @158896
     /* 158896 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(159766),
     /* 158901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158904 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(158960), // Rule ID 6625 //
     /* 158909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 158912 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 158928 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 158928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 158931 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158958 */     GIR_RootConstrainSelectedInstOperands,
     /* 158959 */     // GIR_Coverage, 6625,
     /* 158959 */     GIR_EraseRootFromParent_Done,
     /* 158960 */   // Label 2412: @158960
     /* 158960 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(159016), // Rule ID 6627 //
     /* 158965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 158968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 158984 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 158984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 158987 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159014 */     GIR_RootConstrainSelectedInstOperands,
     /* 159015 */     // GIR_Coverage, 6627,
     /* 159015 */     GIR_EraseRootFromParent_Done,
     /* 159016 */   // Label 2413: @159016
     /* 159016 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(159069), // Rule ID 4284 //
     /* 159021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 159024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 159040 */     // (st p5:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 159043 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 159055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159067 */     GIR_RootConstrainSelectedInstOperands,
     /* 159068 */     // GIR_Coverage, 4284,
     /* 159068 */     GIR_EraseRootFromParent_Done,
     /* 159069 */   // Label 2414: @159069
     /* 159069 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(159117), // Rule ID 4283 //
     /* 159074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 159093 */     // (st p5:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 159096 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159115 */     GIR_RootConstrainSelectedInstOperands,
     /* 159116 */     // GIR_Coverage, 4283,
     /* 159116 */     GIR_EraseRootFromParent_Done,
     /* 159117 */   // Label 2415: @159117
     /* 159117 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(159165), // Rule ID 4282 //
     /* 159122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 159141 */     // (st p5:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 159141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 159144 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159163 */     GIR_RootConstrainSelectedInstOperands,
     /* 159164 */     // GIR_Coverage, 4282,
     /* 159164 */     GIR_EraseRootFromParent_Done,
     /* 159165 */   // Label 2416: @159165
     /* 159165 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(159226), // Rule ID 4625 //
     /* 159170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159173 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159189 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 159192 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159224 */     GIR_RootConstrainSelectedInstOperands,
     /* 159225 */     // GIR_Coverage, 4625,
     /* 159225 */     GIR_EraseRootFromParent_Done,
     /* 159226 */   // Label 2417: @159226
     /* 159226 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(159284), // Rule ID 4627 //
     /* 159231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159247 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 159250 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159282 */     GIR_RootConstrainSelectedInstOperands,
     /* 159283 */     // GIR_Coverage, 4627,
     /* 159283 */     GIR_EraseRootFromParent_Done,
     /* 159284 */   // Label 2418: @159284
     /* 159284 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(159345), // Rule ID 6624 //
     /* 159289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 159308 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 159311 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159343 */     GIR_RootConstrainSelectedInstOperands,
     /* 159344 */     // GIR_Coverage, 6624,
     /* 159344 */     GIR_EraseRootFromParent_Done,
     /* 159345 */   // Label 2419: @159345
     /* 159345 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(159406), // Rule ID 6626 //
     /* 159350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 159353 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 159369 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 159372 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159404 */     GIR_RootConstrainSelectedInstOperands,
     /* 159405 */     // GIR_Coverage, 6626,
     /* 159405 */     GIR_EraseRootFromParent_Done,
     /* 159406 */   // Label 2420: @159406
     /* 159406 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(159462), // Rule ID 4624 //
     /* 159411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159414 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159430 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 159433 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159460 */     GIR_RootConstrainSelectedInstOperands,
     /* 159461 */     // GIR_Coverage, 4624,
     /* 159461 */     GIR_EraseRootFromParent_Done,
     /* 159462 */   // Label 2421: @159462
     /* 159462 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(159515), // Rule ID 4626 //
     /* 159467 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159483 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 159486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159513 */     GIR_RootConstrainSelectedInstOperands,
     /* 159514 */     // GIR_Coverage, 4626,
     /* 159514 */     GIR_EraseRootFromParent_Done,
     /* 159515 */   // Label 2422: @159515
     /* 159515 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(159567), // Rule ID 7911 //
     /* 159520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 159523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 159527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159543 */     // (AMDGPUst_glue p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 159546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159551 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159565 */     GIR_RootConstrainSelectedInstOperands,
     /* 159566 */     // GIR_Coverage, 7911,
     /* 159566 */     GIR_EraseRootFromParent_Done,
     /* 159567 */   // Label 2423: @159567
     /* 159567 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(159615), // Rule ID 7912 //
     /* 159572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 159575 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159591 */     // (st p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 159594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159599 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159613 */     GIR_RootConstrainSelectedInstOperands,
     /* 159614 */     // GIR_Coverage, 7912,
     /* 159614 */     GIR_EraseRootFromParent_Done,
     /* 159615 */   // Label 2424: @159615
     /* 159615 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(159668), // Rule ID 3886 //
     /* 159620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159623 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 159639 */     // (st p5:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 159642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 159647 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159666 */     GIR_RootConstrainSelectedInstOperands,
     /* 159667 */     // GIR_Coverage, 3886,
     /* 159667 */     GIR_EraseRootFromParent_Done,
     /* 159668 */   // Label 2425: @159668
     /* 159668 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(159716), // Rule ID 3885 //
     /* 159673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159676 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 159692 */     // (st p5:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 159692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 159695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159700 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159714 */     GIR_RootConstrainSelectedInstOperands,
     /* 159715 */     // GIR_Coverage, 3885,
     /* 159715 */     GIR_EraseRootFromParent_Done,
     /* 159716 */   // Label 2426: @159716
     /* 159716 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(159765), // Rule ID 3625 //
     /* 159721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 159724 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 159730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 159741 */     // (st p5:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 159741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 159744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159763 */     GIR_RootConstrainSelectedInstOperands,
     /* 159764 */     // GIR_Coverage, 3625,
     /* 159764 */     GIR_EraseRootFromParent_Done,
     /* 159765 */   // Label 2427: @159765
     /* 159765 */   GIM_Reject,
     /* 159766 */ // Label 2411: @159766
     /* 159766 */ GIM_Reject,
     /* 159767 */ // Label 2314: @159767
     /* 159767 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(160637),
     /* 159772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159775 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(159831), // Rule ID 6629 //
     /* 159780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 159799 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 159802 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159829 */     GIR_RootConstrainSelectedInstOperands,
     /* 159830 */     // GIR_Coverage, 6629,
     /* 159830 */     GIR_EraseRootFromParent_Done,
     /* 159831 */   // Label 2429: @159831
     /* 159831 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(159887), // Rule ID 6631 //
     /* 159836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 159839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 159855 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 159858 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159885 */     GIR_RootConstrainSelectedInstOperands,
     /* 159886 */     // GIR_Coverage, 6631,
     /* 159886 */     GIR_EraseRootFromParent_Done,
     /* 159887 */   // Label 2430: @159887
     /* 159887 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(159940), // Rule ID 4290 //
     /* 159892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 159895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 159911 */     // (st p6:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 159914 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 159926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159938 */     GIR_RootConstrainSelectedInstOperands,
     /* 159939 */     // GIR_Coverage, 4290,
     /* 159939 */     GIR_EraseRootFromParent_Done,
     /* 159940 */   // Label 2431: @159940
     /* 159940 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(159988), // Rule ID 4289 //
     /* 159945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 159964 */     // (st p6:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 159967 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159986 */     GIR_RootConstrainSelectedInstOperands,
     /* 159987 */     // GIR_Coverage, 4289,
     /* 159987 */     GIR_EraseRootFromParent_Done,
     /* 159988 */   // Label 2432: @159988
     /* 159988 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(160036), // Rule ID 4288 //
     /* 159993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 160012 */     // (st p6:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 160012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 160015 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160034 */     GIR_RootConstrainSelectedInstOperands,
     /* 160035 */     // GIR_Coverage, 4288,
     /* 160035 */     GIR_EraseRootFromParent_Done,
     /* 160036 */   // Label 2433: @160036
     /* 160036 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(160097), // Rule ID 4629 //
     /* 160041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 160044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 160060 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 160063 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160095 */     GIR_RootConstrainSelectedInstOperands,
     /* 160096 */     // GIR_Coverage, 4629,
     /* 160096 */     GIR_EraseRootFromParent_Done,
     /* 160097 */   // Label 2434: @160097
     /* 160097 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(160155), // Rule ID 4631 //
     /* 160102 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 160118 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 160121 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160153 */     GIR_RootConstrainSelectedInstOperands,
     /* 160154 */     // GIR_Coverage, 4631,
     /* 160154 */     GIR_EraseRootFromParent_Done,
     /* 160155 */   // Label 2435: @160155
     /* 160155 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(160216), // Rule ID 6628 //
     /* 160160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160163 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 160179 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 160182 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160214 */     GIR_RootConstrainSelectedInstOperands,
     /* 160215 */     // GIR_Coverage, 6628,
     /* 160215 */     GIR_EraseRootFromParent_Done,
     /* 160216 */   // Label 2436: @160216
     /* 160216 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(160277), // Rule ID 6630 //
     /* 160221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 160240 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 160243 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160275 */     GIR_RootConstrainSelectedInstOperands,
     /* 160276 */     // GIR_Coverage, 6630,
     /* 160276 */     GIR_EraseRootFromParent_Done,
     /* 160277 */   // Label 2437: @160277
     /* 160277 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(160333), // Rule ID 4628 //
     /* 160282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 160285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160301 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 160304 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160331 */     GIR_RootConstrainSelectedInstOperands,
     /* 160332 */     // GIR_Coverage, 4628,
     /* 160332 */     GIR_EraseRootFromParent_Done,
     /* 160333 */   // Label 2438: @160333
     /* 160333 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(160386), // Rule ID 4630 //
     /* 160338 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160354 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 160357 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160384 */     GIR_RootConstrainSelectedInstOperands,
     /* 160385 */     // GIR_Coverage, 4630,
     /* 160385 */     GIR_EraseRootFromParent_Done,
     /* 160386 */   // Label 2439: @160386
     /* 160386 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(160438), // Rule ID 7913 //
     /* 160391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 160394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160414 */     // (AMDGPUst_glue p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 160417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160422 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160436 */     GIR_RootConstrainSelectedInstOperands,
     /* 160437 */     // GIR_Coverage, 7913,
     /* 160437 */     GIR_EraseRootFromParent_Done,
     /* 160438 */   // Label 2440: @160438
     /* 160438 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(160486), // Rule ID 7914 //
     /* 160443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 160446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160462 */     // (st p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 160465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160470 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160484 */     GIR_RootConstrainSelectedInstOperands,
     /* 160485 */     // GIR_Coverage, 7914,
     /* 160485 */     GIR_EraseRootFromParent_Done,
     /* 160486 */   // Label 2441: @160486
     /* 160486 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(160539), // Rule ID 3890 //
     /* 160491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 160510 */     // (st p6:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 160513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 160518 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 160525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160537 */     GIR_RootConstrainSelectedInstOperands,
     /* 160538 */     // GIR_Coverage, 3890,
     /* 160538 */     GIR_EraseRootFromParent_Done,
     /* 160539 */   // Label 2442: @160539
     /* 160539 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(160587), // Rule ID 3889 //
     /* 160544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160547 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 160563 */     // (st p6:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 160566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160571 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160585 */     GIR_RootConstrainSelectedInstOperands,
     /* 160586 */     // GIR_Coverage, 3889,
     /* 160586 */     GIR_EraseRootFromParent_Done,
     /* 160587 */   // Label 2443: @160587
     /* 160587 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(160636), // Rule ID 3627 //
     /* 160592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 160595 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 160601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 160612 */     // (st p6:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 160615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160620 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160634 */     GIR_RootConstrainSelectedInstOperands,
     /* 160635 */     // GIR_Coverage, 3627,
     /* 160635 */     GIR_EraseRootFromParent_Done,
     /* 160636 */   // Label 2444: @160636
     /* 160636 */   GIM_Reject,
     /* 160637 */ // Label 2428: @160637
     /* 160637 */ GIM_Reject,
     /* 160638 */ // Label 2315: @160638
     /* 160638 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(160708), // Rule ID 6593 //
     /* 160643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160649 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160653 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160660 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160665 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160676 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 160679 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160706 */   GIR_RootConstrainSelectedInstOperands,
     /* 160707 */   // GIR_Coverage, 6593,
     /* 160707 */   GIR_EraseRootFromParent_Done,
     /* 160708 */ // Label 2445: @160708
     /* 160708 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(160778), // Rule ID 6595 //
     /* 160713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160719 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160730 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160746 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 160749 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160776 */   GIR_RootConstrainSelectedInstOperands,
     /* 160777 */   // GIR_Coverage, 6595,
     /* 160777 */   GIR_EraseRootFromParent_Done,
     /* 160778 */ // Label 2446: @160778
     /* 160778 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(160837), // Rule ID 6597 //
     /* 160783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160789 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160805 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 160808 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160835 */   GIR_RootConstrainSelectedInstOperands,
     /* 160836 */   // GIR_Coverage, 6597,
     /* 160836 */   GIR_EraseRootFromParent_Done,
     /* 160837 */ // Label 2447: @160837
     /* 160837 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(160896), // Rule ID 6599 //
     /* 160842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160848 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160864 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 160867 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160894 */   GIR_RootConstrainSelectedInstOperands,
     /* 160895 */   // GIR_Coverage, 6599,
     /* 160895 */   GIR_EraseRootFromParent_Done,
     /* 160896 */ // Label 2448: @160896
     /* 160896 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(160963), // Rule ID 4212 //
     /* 160901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 160904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160907 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160911 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160918 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160934 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 160937 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160961 */   GIR_RootConstrainSelectedInstOperands,
     /* 160962 */   // GIR_Coverage, 4212,
     /* 160962 */   GIR_EraseRootFromParent_Done,
     /* 160963 */ // Label 2449: @160963
     /* 160963 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(161030), // Rule ID 4230 //
     /* 160968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 160971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160985 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160994 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161001 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 161004 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161028 */   GIR_RootConstrainSelectedInstOperands,
     /* 161029 */   // GIR_Coverage, 4230,
     /* 161029 */   GIR_EraseRootFromParent_Done,
     /* 161030 */ // Label 2450: @161030
     /* 161030 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(161097), // Rule ID 4242 //
     /* 161035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 161038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161041 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161052 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161068 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS_t16),
     /* 161071 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161095 */   GIR_RootConstrainSelectedInstOperands,
     /* 161096 */   // GIR_Coverage, 4242,
     /* 161096 */   GIR_EraseRootFromParent_Done,
     /* 161097 */ // Label 2451: @161097
     /* 161097 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(161153), // Rule ID 3562 //
     /* 161102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 161105 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161108 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161124 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 161127 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161151 */   GIR_RootConstrainSelectedInstOperands,
     /* 161152 */   // GIR_Coverage, 3562,
     /* 161152 */   GIR_EraseRootFromParent_Done,
     /* 161153 */ // Label 2452: @161153
     /* 161153 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(161209), // Rule ID 3565 //
     /* 161158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 161161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161164 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161180 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS_t16),
     /* 161183 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161207 */   GIR_RootConstrainSelectedInstOperands,
     /* 161208 */   // GIR_Coverage, 3565,
     /* 161208 */   GIR_EraseRootFromParent_Done,
     /* 161209 */ // Label 2453: @161209
     /* 161209 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(161265), // Rule ID 4227 //
     /* 161214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 161217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161220 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161236 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 161239 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161263 */   GIR_RootConstrainSelectedInstOperands,
     /* 161264 */   // GIR_Coverage, 4227,
     /* 161264 */   GIR_EraseRootFromParent_Done,
     /* 161265 */ // Label 2454: @161265
     /* 161265 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(161327), // Rule ID 4211 //
     /* 161270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161287 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161303 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 161306 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161325 */   GIR_RootConstrainSelectedInstOperands,
     /* 161326 */   // GIR_Coverage, 4211,
     /* 161326 */   GIR_EraseRootFromParent_Done,
     /* 161327 */ // Label 2455: @161327
     /* 161327 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(161389), // Rule ID 4229 //
     /* 161332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161335 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161338 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161349 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161365 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 161368 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161387 */   GIR_RootConstrainSelectedInstOperands,
     /* 161388 */   // GIR_Coverage, 4229,
     /* 161388 */   GIR_EraseRootFromParent_Done,
     /* 161389 */ // Label 2456: @161389
     /* 161389 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(161451), // Rule ID 4241 //
     /* 161394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161397 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161400 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161404 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161411 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161427 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR_t16),
     /* 161430 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161449 */   GIR_RootConstrainSelectedInstOperands,
     /* 161450 */   // GIR_Coverage, 4241,
     /* 161450 */   GIR_EraseRootFromParent_Done,
     /* 161451 */ // Label 2457: @161451
     /* 161451 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(161502), // Rule ID 3561 //
     /* 161456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161462 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161467 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161478 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 161481 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161500 */   GIR_RootConstrainSelectedInstOperands,
     /* 161501 */   // GIR_Coverage, 3561,
     /* 161501 */   GIR_EraseRootFromParent_Done,
     /* 161502 */ // Label 2458: @161502
     /* 161502 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(161553), // Rule ID 3564 //
     /* 161507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161513 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161529 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR_t16),
     /* 161532 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161547 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161551 */   GIR_RootConstrainSelectedInstOperands,
     /* 161552 */   // GIR_Coverage, 3564,
     /* 161552 */   GIR_EraseRootFromParent_Done,
     /* 161553 */ // Label 2459: @161553
     /* 161553 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(161604), // Rule ID 4226 //
     /* 161558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161564 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161580 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 161583 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161602 */   GIR_RootConstrainSelectedInstOperands,
     /* 161603 */   // GIR_Coverage, 4226,
     /* 161603 */   GIR_EraseRootFromParent_Done,
     /* 161604 */ // Label 2460: @161604
     /* 161604 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(161666), // Rule ID 4210 //
     /* 161609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161615 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161619 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161626 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161642 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 161645 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161664 */   GIR_RootConstrainSelectedInstOperands,
     /* 161665 */   // GIR_Coverage, 4210,
     /* 161665 */   GIR_EraseRootFromParent_Done,
     /* 161666 */ // Label 2461: @161666
     /* 161666 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(161728), // Rule ID 4228 //
     /* 161671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161688 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161704 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 161707 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161726 */   GIR_RootConstrainSelectedInstOperands,
     /* 161727 */   // GIR_Coverage, 4228,
     /* 161727 */   GIR_EraseRootFromParent_Done,
     /* 161728 */ // Label 2462: @161728
     /* 161728 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(161790), // Rule ID 4240 //
     /* 161733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161736 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161739 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161750 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161766 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_t16),
     /* 161769 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161788 */   GIR_RootConstrainSelectedInstOperands,
     /* 161789 */   // GIR_Coverage, 4240,
     /* 161789 */   GIR_EraseRootFromParent_Done,
     /* 161790 */ // Label 2463: @161790
     /* 161790 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(161841), // Rule ID 3560 //
     /* 161795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161801 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161817 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 161820 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161839 */   GIR_RootConstrainSelectedInstOperands,
     /* 161840 */   // GIR_Coverage, 3560,
     /* 161840 */   GIR_EraseRootFromParent_Done,
     /* 161841 */ // Label 2464: @161841
     /* 161841 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(161892), // Rule ID 3563 //
     /* 161846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161852 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161868 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_t16 anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_t16),
     /* 161871 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161890 */   GIR_RootConstrainSelectedInstOperands,
     /* 161891 */   // GIR_Coverage, 3563,
     /* 161891 */   GIR_EraseRootFromParent_Done,
     /* 161892 */ // Label 2465: @161892
     /* 161892 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(161943), // Rule ID 4225 //
     /* 161897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161900 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161903 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161919 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 161922 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161941 */   GIR_RootConstrainSelectedInstOperands,
     /* 161942 */   // GIR_Coverage, 4225,
     /* 161942 */   GIR_EraseRootFromParent_Done,
     /* 161943 */ // Label 2466: @161943
     /* 161943 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(162014), // Rule ID 6570 //
     /* 161948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 161951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 161954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161961 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 161977 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 161977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 161980 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 161982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162012 */   GIR_RootConstrainSelectedInstOperands,
     /* 162013 */   // GIR_Coverage, 6570,
     /* 162013 */   GIR_EraseRootFromParent_Done,
     /* 162014 */ // Label 2467: @162014
     /* 162014 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(162085), // Rule ID 6574 //
     /* 162019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 162022 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162032 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 162048 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 162051 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 162053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162083 */   GIR_RootConstrainSelectedInstOperands,
     /* 162084 */   // GIR_Coverage, 6574,
     /* 162084 */   GIR_EraseRootFromParent_Done,
     /* 162085 */ // Label 2468: @162085
     /* 162085 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(162160), // Rule ID 6592 //
     /* 162090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 162093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162096 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162107 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162123 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 162126 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162158 */   GIR_RootConstrainSelectedInstOperands,
     /* 162159 */   // GIR_Coverage, 6592,
     /* 162159 */   GIR_EraseRootFromParent_Done,
     /* 162160 */ // Label 2469: @162160
     /* 162160 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(162235), // Rule ID 6594 //
     /* 162165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 162168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162171 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162175 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162182 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162198 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 162201 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162233 */   GIR_RootConstrainSelectedInstOperands,
     /* 162234 */   // GIR_Coverage, 6594,
     /* 162234 */   GIR_EraseRootFromParent_Done,
     /* 162235 */ // Label 2470: @162235
     /* 162235 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(162299), // Rule ID 6596 //
     /* 162240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 162243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162246 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162262 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 162265 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162297 */   GIR_RootConstrainSelectedInstOperands,
     /* 162298 */   // GIR_Coverage, 6596,
     /* 162298 */   GIR_EraseRootFromParent_Done,
     /* 162299 */ // Label 2471: @162299
     /* 162299 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(162363), // Rule ID 6598 //
     /* 162304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 162307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162310 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162326 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 162329 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162361 */   GIR_RootConstrainSelectedInstOperands,
     /* 162362 */   // GIR_Coverage, 6598,
     /* 162362 */   GIR_EraseRootFromParent_Done,
     /* 162363 */ // Label 2472: @162363
     /* 162363 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(162433), // Rule ID 6580 //
     /* 162368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162374 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162378 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162385 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162401 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 162404 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162431 */   GIR_RootConstrainSelectedInstOperands,
     /* 162432 */   // GIR_Coverage, 6580,
     /* 162432 */   GIR_EraseRootFromParent_Done,
     /* 162433 */ // Label 2473: @162433
     /* 162433 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(162500), // Rule ID 6581 //
     /* 162438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162441 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162445 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162452 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162468 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 162471 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162498 */   GIR_RootConstrainSelectedInstOperands,
     /* 162499 */   // GIR_Coverage, 6581,
     /* 162499 */   GIR_EraseRootFromParent_Done,
     /* 162500 */ // Label 2474: @162500
     /* 162500 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(162559), // Rule ID 6582 //
     /* 162505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162511 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162527 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 162530 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162557 */   GIR_RootConstrainSelectedInstOperands,
     /* 162558 */   // GIR_Coverage, 6582,
     /* 162558 */   GIR_EraseRootFromParent_Done,
     /* 162559 */ // Label 2475: @162559
     /* 162559 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(162615), // Rule ID 6583 //
     /* 162564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162567 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162583 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 162586 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162613 */   GIR_RootConstrainSelectedInstOperands,
     /* 162614 */   // GIR_Coverage, 6583,
     /* 162614 */   GIR_EraseRootFromParent_Done,
     /* 162615 */ // Label 2476: @162615
     /* 162615 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(162673), // Rule ID 7915 //
     /* 162620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 162623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162633 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162649 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 162652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162657 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162671 */   GIR_RootConstrainSelectedInstOperands,
     /* 162672 */   // GIR_Coverage, 7915,
     /* 162672 */   GIR_EraseRootFromParent_Done,
     /* 162673 */ // Label 2477: @162673
     /* 162673 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(162731), // Rule ID 7916 //
     /* 162678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 162681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162691 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162707 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 162710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162715 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162729 */   GIR_RootConstrainSelectedInstOperands,
     /* 162730 */   // GIR_Coverage, 7916,
     /* 162730 */   GIR_EraseRootFromParent_Done,
     /* 162731 */ // Label 2478: @162731
     /* 162731 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(162789), // Rule ID 7917 //
     /* 162736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 162739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162749 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162765 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 162768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162773 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162787 */   GIR_RootConstrainSelectedInstOperands,
     /* 162788 */   // GIR_Coverage, 7917,
     /* 162788 */   GIR_EraseRootFromParent_Done,
     /* 162789 */ // Label 2479: @162789
     /* 162789 */ GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(162847), // Rule ID 7918 //
     /* 162794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 162797 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162807 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162823 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 162826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162831 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162845 */   GIR_RootConstrainSelectedInstOperands,
     /* 162846 */   // GIR_Coverage, 7918,
     /* 162846 */   GIR_EraseRootFromParent_Done,
     /* 162847 */ // Label 2480: @162847
     /* 162847 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(162905), // Rule ID 7921 //
     /* 162852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 162855 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162858 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162865 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162881 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 162884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162889 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162903 */   GIR_RootConstrainSelectedInstOperands,
     /* 162904 */   // GIR_Coverage, 7921,
     /* 162904 */   GIR_EraseRootFromParent_Done,
     /* 162905 */ // Label 2481: @162905
     /* 162905 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(162963), // Rule ID 7922 //
     /* 162910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 162913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162923 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162939 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 162942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162947 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162961 */   GIR_RootConstrainSelectedInstOperands,
     /* 162962 */   // GIR_Coverage, 7922,
     /* 162962 */   GIR_EraseRootFromParent_Done,
     /* 162963 */ // Label 2482: @162963
     /* 162963 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(163021), // Rule ID 7923 //
     /* 162968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 162971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162981 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162986 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162997 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 163000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163005 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163019 */   GIR_RootConstrainSelectedInstOperands,
     /* 163020 */   // GIR_Coverage, 7923,
     /* 163020 */   GIR_EraseRootFromParent_Done,
     /* 163021 */ // Label 2483: @163021
     /* 163021 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(163079), // Rule ID 7924 //
     /* 163026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 163029 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 163039 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163055 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 163058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163063 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163077 */   GIR_RootConstrainSelectedInstOperands,
     /* 163078 */   // GIR_Coverage, 7924,
     /* 163078 */   GIR_EraseRootFromParent_Done,
     /* 163079 */ // Label 2484: @163079
     /* 163079 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(163141), // Rule ID 7889 //
     /* 163084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 163087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163090 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163094 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163101 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163106 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163110 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163117 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 163120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163125 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163139 */   GIR_RootConstrainSelectedInstOperands,
     /* 163140 */   // GIR_Coverage, 7889,
     /* 163140 */   GIR_EraseRootFromParent_Done,
     /* 163141 */ // Label 2485: @163141
     /* 163141 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(163203), // Rule ID 7890 //
     /* 163146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 163149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163163 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163179 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 163182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163187 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163201 */   GIR_RootConstrainSelectedInstOperands,
     /* 163202 */   // GIR_Coverage, 7890,
     /* 163202 */   GIR_EraseRootFromParent_Done,
     /* 163203 */ // Label 2486: @163203
     /* 163203 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(163265), // Rule ID 7891 //
     /* 163208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 163211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163214 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163218 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163225 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163241 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 163244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163249 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163263 */   GIR_RootConstrainSelectedInstOperands,
     /* 163264 */   // GIR_Coverage, 7891,
     /* 163264 */   GIR_EraseRootFromParent_Done,
     /* 163265 */ // Label 2487: @163265
     /* 163265 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(163327), // Rule ID 7894 //
     /* 163270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 163273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163287 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163303 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 163306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163311 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163325 */   GIR_RootConstrainSelectedInstOperands,
     /* 163326 */   // GIR_Coverage, 7894,
     /* 163326 */   GIR_EraseRootFromParent_Done,
     /* 163327 */ // Label 2488: @163327
     /* 163327 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(163382), // Rule ID 7895 //
     /* 163332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 163335 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163338 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163342 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163358 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 163361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163366 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163380 */   GIR_RootConstrainSelectedInstOperands,
     /* 163381 */   // GIR_Coverage, 7895,
     /* 163381 */   GIR_EraseRootFromParent_Done,
     /* 163382 */ // Label 2489: @163382
     /* 163382 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(163433), // Rule ID 7896 //
     /* 163387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 163390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163393 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163409 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 163412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163417 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163431 */   GIR_RootConstrainSelectedInstOperands,
     /* 163432 */   // GIR_Coverage, 7896,
     /* 163432 */   GIR_EraseRootFromParent_Done,
     /* 163433 */ // Label 2490: @163433
     /* 163433 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(163484), // Rule ID 7897 //
     /* 163438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 163441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163444 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163460 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 163463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163468 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163482 */   GIR_RootConstrainSelectedInstOperands,
     /* 163483 */   // GIR_Coverage, 7897,
     /* 163483 */   GIR_EraseRootFromParent_Done,
     /* 163484 */ // Label 2491: @163484
     /* 163484 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(163535), // Rule ID 7898 //
     /* 163489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 163492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163495 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163504 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163511 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 163514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163519 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163533 */   GIR_RootConstrainSelectedInstOperands,
     /* 163534 */   // GIR_Coverage, 7898,
     /* 163534 */   GIR_EraseRootFromParent_Done,
     /* 163535 */ // Label 2492: @163535
     /* 163535 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(163598), // Rule ID 4000 //
     /* 163540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163553 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163562 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163569 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163577 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163596 */   GIR_RootConstrainSelectedInstOperands,
     /* 163597 */   // GIR_Coverage, 4000,
     /* 163597 */   GIR_EraseRootFromParent_Done,
     /* 163598 */ // Label 2493: @163598
     /* 163598 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(163661), // Rule ID 4004 //
     /* 163603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 163616 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163632 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 163635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163640 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163659 */   GIR_RootConstrainSelectedInstOperands,
     /* 163660 */   // GIR_Coverage, 4004,
     /* 163660 */   GIR_EraseRootFromParent_Done,
     /* 163661 */ // Label 2494: @163661
     /* 163661 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(163728), // Rule ID 3552 //
     /* 163666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 163669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163672 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163683 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163699 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR_t16),
     /* 163702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163707 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163726 */   GIR_RootConstrainSelectedInstOperands,
     /* 163727 */   // GIR_Coverage, 3552,
     /* 163727 */   GIR_EraseRootFromParent_Done,
     /* 163728 */ // Label 2495: @163728
     /* 163728 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(163795), // Rule ID 3964 //
     /* 163733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 163736 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163739 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163750 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163766 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163774 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163793 */   GIR_RootConstrainSelectedInstOperands,
     /* 163794 */   // GIR_Coverage, 3964,
     /* 163794 */   GIR_EraseRootFromParent_Done,
     /* 163795 */ // Label 2496: @163795
     /* 163795 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(163862), // Rule ID 3968 //
     /* 163800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 163803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163806 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163817 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163833 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163841 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163860 */   GIR_RootConstrainSelectedInstOperands,
     /* 163861 */   // GIR_Coverage, 3968,
     /* 163861 */   GIR_EraseRootFromParent_Done,
     /* 163862 */ // Label 2497: @163862
     /* 163862 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(163918), // Rule ID 3860 //
     /* 163867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 163870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163873 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163889 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR_t16),
     /* 163892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163897 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163916 */   GIR_RootConstrainSelectedInstOperands,
     /* 163917 */   // GIR_Coverage, 3860,
     /* 163917 */   GIR_EraseRootFromParent_Done,
     /* 163918 */ // Label 2498: @163918
     /* 163918 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(163974), // Rule ID 3966 //
     /* 163923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 163926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163929 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163945 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 163948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163953 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163972 */   GIR_RootConstrainSelectedInstOperands,
     /* 163973 */   // GIR_Coverage, 3966,
     /* 163973 */   GIR_EraseRootFromParent_Done,
     /* 163974 */ // Label 2499: @163974
     /* 163974 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(164030), // Rule ID 3970 //
     /* 163979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 163982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163985 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163994 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 164001 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 164004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 164009 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 164016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164028 */   GIR_RootConstrainSelectedInstOperands,
     /* 164029 */   // GIR_Coverage, 3970,
     /* 164029 */   GIR_EraseRootFromParent_Done,
     /* 164030 */ // Label 2500: @164030
     /* 164030 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(164088), // Rule ID 3999 //
     /* 164035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 164038 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164041 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164048 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164053 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164057 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164064 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 164067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164072 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164082 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164086 */   GIR_RootConstrainSelectedInstOperands,
     /* 164087 */   // GIR_Coverage, 3999,
     /* 164087 */   GIR_EraseRootFromParent_Done,
     /* 164088 */ // Label 2501: @164088
     /* 164088 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(164146), // Rule ID 4003 //
     /* 164093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 164096 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164099 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164106 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164122 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 164125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164130 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164144 */   GIR_RootConstrainSelectedInstOperands,
     /* 164145 */   // GIR_Coverage, 4003,
     /* 164145 */   GIR_EraseRootFromParent_Done,
     /* 164146 */ // Label 2502: @164146
     /* 164146 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(164208), // Rule ID 3551 //
     /* 164151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 164154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164168 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164184 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_t16),
     /* 164187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164192 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164206 */   GIR_RootConstrainSelectedInstOperands,
     /* 164207 */   // GIR_Coverage, 3551,
     /* 164207 */   GIR_EraseRootFromParent_Done,
     /* 164208 */ // Label 2503: @164208
     /* 164208 */ GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(164270), // Rule ID 3963 //
     /* 164213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 164216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164219 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164246 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 164249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164254 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164268 */   GIR_RootConstrainSelectedInstOperands,
     /* 164269 */   // GIR_Coverage, 3963,
     /* 164269 */   GIR_EraseRootFromParent_Done,
     /* 164270 */ // Label 2504: @164270
     /* 164270 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(164332), // Rule ID 3967 //
     /* 164275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 164278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164281 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164292 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164308 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 164311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164316 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164330 */   GIR_RootConstrainSelectedInstOperands,
     /* 164331 */   // GIR_Coverage, 3967,
     /* 164331 */   GIR_EraseRootFromParent_Done,
     /* 164332 */ // Label 2505: @164332
     /* 164332 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(164383), // Rule ID 3859 //
     /* 164337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 164340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164343 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164359 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_t16),
     /* 164362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164367 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164381 */   GIR_RootConstrainSelectedInstOperands,
     /* 164382 */   // GIR_Coverage, 3859,
     /* 164382 */   GIR_EraseRootFromParent_Done,
     /* 164383 */ // Label 2506: @164383
     /* 164383 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(164434), // Rule ID 3965 //
     /* 164388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 164391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164394 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164410 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 164413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164418 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164432 */   GIR_RootConstrainSelectedInstOperands,
     /* 164433 */   // GIR_Coverage, 3965,
     /* 164433 */   GIR_EraseRootFromParent_Done,
     /* 164434 */ // Label 2507: @164434
     /* 164434 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(164485), // Rule ID 3969 //
     /* 164439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 164442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164445 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164461 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 164464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164469 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164483 */   GIR_RootConstrainSelectedInstOperands,
     /* 164484 */   // GIR_Coverage, 3969,
     /* 164484 */   GIR_EraseRootFromParent_Done,
     /* 164485 */ // Label 2508: @164485
     /* 164485 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(164544), // Rule ID 3662 //
     /* 164490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 164493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164496 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164503 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164509 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164513 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164520 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164528 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164542 */   GIR_RootConstrainSelectedInstOperands,
     /* 164543 */   // GIR_Coverage, 3662,
     /* 164543 */   GIR_EraseRootFromParent_Done,
     /* 164544 */ // Label 2509: @164544
     /* 164544 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(164603), // Rule ID 3664 //
     /* 164549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 164552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164562 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164579 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164587 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164601 */   GIR_RootConstrainSelectedInstOperands,
     /* 164602 */   // GIR_Coverage, 3664,
     /* 164602 */   GIR_EraseRootFromParent_Done,
     /* 164603 */ // Label 2510: @164603
     /* 164603 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(164666), // Rule ID 3594 //
     /* 164608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 164611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164614 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164625 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164642 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164650 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164664 */   GIR_RootConstrainSelectedInstOperands,
     /* 164665 */   // GIR_Coverage, 3594,
     /* 164665 */   GIR_EraseRootFromParent_Done,
     /* 164666 */ // Label 2511: @164666
     /* 164666 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(164729), // Rule ID 3600 //
     /* 164671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 164674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164688 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164698 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164705 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164713 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164727 */   GIR_RootConstrainSelectedInstOperands,
     /* 164728 */   // GIR_Coverage, 3600,
     /* 164728 */   GIR_EraseRootFromParent_Done,
     /* 164729 */ // Label 2512: @164729
     /* 164729 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(164792), // Rule ID 3606 //
     /* 164734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 164737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164740 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164751 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164768 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_t16),
     /* 164771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164776 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164790 */   GIR_RootConstrainSelectedInstOperands,
     /* 164791 */   // GIR_Coverage, 3606,
     /* 164791 */   GIR_EraseRootFromParent_Done,
     /* 164792 */ // Label 2513: @164792
     /* 164792 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(164844), // Rule ID 3595 //
     /* 164797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 164800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164803 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164809 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164820 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164828 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164842 */   GIR_RootConstrainSelectedInstOperands,
     /* 164843 */   // GIR_Coverage, 3595,
     /* 164843 */   GIR_EraseRootFromParent_Done,
     /* 164844 */ // Label 2514: @164844
     /* 164844 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(164896), // Rule ID 3601 //
     /* 164849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 164852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164855 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164872 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164880 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164894 */   GIR_RootConstrainSelectedInstOperands,
     /* 164895 */   // GIR_Coverage, 3601,
     /* 164895 */   GIR_EraseRootFromParent_Done,
     /* 164896 */ // Label 2515: @164896
     /* 164896 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(164948), // Rule ID 3607 //
     /* 164901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 164904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164924 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_t16),
     /* 164927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164932 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164946 */   GIR_RootConstrainSelectedInstOperands,
     /* 164947 */   // GIR_Coverage, 3607,
     /* 164947 */   GIR_EraseRootFromParent_Done,
     /* 164948 */ // Label 2516: @164948
     /* 164948 */ GIM_Reject,
     /* 164949 */ // Label 2316: @164949
     /* 164949 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(165044), // Rule ID 6645 //
     /* 164954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 164957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164960 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164971 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 164980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 164984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164992 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 164996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 165009 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFSET),
     /* 165012 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 165026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165042 */   GIR_RootConstrainSelectedInstOperands,
     /* 165043 */   // GIR_Coverage, 6645,
     /* 165043 */   GIR_EraseRootFromParent_Done,
     /* 165044 */ // Label 2517: @165044
     /* 165044 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(165139), // Rule ID 6647 //
     /* 165049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165055 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165066 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165087 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 165104 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET),
     /* 165107 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 165121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165137 */   GIR_RootConstrainSelectedInstOperands,
     /* 165138 */   // GIR_Coverage, 6647,
     /* 165138 */   GIR_EraseRootFromParent_Done,
     /* 165139 */ // Label 2518: @165139
     /* 165139 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(165234), // Rule ID 6649 //
     /* 165144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 165147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165150 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165161 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165174 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165178 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165182 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 165199 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFSET),
     /* 165202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 165216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165232 */   GIR_RootConstrainSelectedInstOperands,
     /* 165233 */   // GIR_Coverage, 6649,
     /* 165233 */   GIR_EraseRootFromParent_Done,
     /* 165234 */ // Label 2519: @165234
     /* 165234 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(165329), // Rule ID 6651 //
     /* 165239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165245 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165256 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165269 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165273 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165277 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 165294 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET),
     /* 165297 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 165311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165327 */   GIR_RootConstrainSelectedInstOperands,
     /* 165328 */   // GIR_Coverage, 6651,
     /* 165328 */   GIR_EraseRootFromParent_Done,
     /* 165329 */ // Label 2520: @165329
     /* 165329 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(165421), // Rule ID 4395 //
     /* 165334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 165337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165340 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165351 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165364 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165368 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165372 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 165389 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SVS),
     /* 165392 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 165406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165419 */   GIR_RootConstrainSelectedInstOperands,
     /* 165420 */   // GIR_Coverage, 4395,
     /* 165420 */   GIR_EraseRootFromParent_Done,
     /* 165421 */ // Label 2521: @165421
     /* 165421 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(165513), // Rule ID 4398 //
     /* 165426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 165429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165432 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165436 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165443 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165456 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165460 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165464 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165474 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 165481 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SVS),
     /* 165484 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 165498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165511 */   GIR_RootConstrainSelectedInstOperands,
     /* 165512 */   // GIR_Coverage, 4398,
     /* 165512 */   GIR_EraseRootFromParent_Done,
     /* 165513 */ // Label 2522: @165513
     /* 165513 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(165600), // Rule ID 4394 //
     /* 165518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165524 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165535 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165548 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165552 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165556 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165573 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SADDR),
     /* 165576 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165598 */   GIR_RootConstrainSelectedInstOperands,
     /* 165599 */   // GIR_Coverage, 4394,
     /* 165599 */   GIR_EraseRootFromParent_Done,
     /* 165600 */ // Label 2523: @165600
     /* 165600 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(165687), // Rule ID 4397 //
     /* 165605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165611 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165622 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165635 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165639 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165643 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165660 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SADDR),
     /* 165663 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165685 */   GIR_RootConstrainSelectedInstOperands,
     /* 165686 */   // GIR_Coverage, 4397,
     /* 165686 */   GIR_EraseRootFromParent_Done,
     /* 165687 */ // Label 2524: @165687
     /* 165687 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(165774), // Rule ID 4393 //
     /* 165692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165698 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165709 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165730 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165747 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI),
     /* 165750 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165772 */   GIR_RootConstrainSelectedInstOperands,
     /* 165773 */   // GIR_Coverage, 4393,
     /* 165773 */   GIR_EraseRootFromParent_Done,
     /* 165774 */ // Label 2525: @165774
     /* 165774 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(165861), // Rule ID 4396 //
     /* 165779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165796 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165809 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165813 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165817 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165827 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165834 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI),
     /* 165837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165859 */   GIR_RootConstrainSelectedInstOperands,
     /* 165860 */   // GIR_Coverage, 4396,
     /* 165860 */   GIR_EraseRootFromParent_Done,
     /* 165861 */ // Label 2526: @165861
     /* 165861 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(165961), // Rule ID 6644 //
     /* 165866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 165869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165872 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165883 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165896 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165900 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165921 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFEN),
     /* 165924 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165959 */   GIR_RootConstrainSelectedInstOperands,
     /* 165960 */   // GIR_Coverage, 6644,
     /* 165960 */   GIR_EraseRootFromParent_Done,
     /* 165961 */ // Label 2527: @165961
     /* 165961 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(166061), // Rule ID 6646 //
     /* 165966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165972 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165983 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 166004 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 166008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 166021 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN),
     /* 166024 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 166028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166059 */   GIR_RootConstrainSelectedInstOperands,
     /* 166060 */   // GIR_Coverage, 6646,
     /* 166060 */   GIR_EraseRootFromParent_Done,
     /* 166061 */ // Label 2528: @166061
     /* 166061 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(166161), // Rule ID 6648 //
     /* 166066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 166069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166072 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166076 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166083 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 166092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 166096 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166100 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 166104 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 166108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 166121 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFEN),
     /* 166124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 166128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166159 */   GIR_RootConstrainSelectedInstOperands,
     /* 166160 */   // GIR_Coverage, 6648,
     /* 166160 */   GIR_EraseRootFromParent_Done,
     /* 166161 */ // Label 2529: @166161
     /* 166161 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(166261), // Rule ID 6650 //
     /* 166166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 166169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166172 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166176 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166183 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 166192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 166196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 166204 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 166208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 166221 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN),
     /* 166224 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 166228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166254 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166259 */   GIR_RootConstrainSelectedInstOperands,
     /* 166260 */   // GIR_Coverage, 6650,
     /* 166260 */   GIR_EraseRootFromParent_Done,
     /* 166261 */ // Label 2530: @166261
     /* 166261 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(166331), // Rule ID 6585 //
     /* 166266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166272 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166283 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166299 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 166302 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166329 */   GIR_RootConstrainSelectedInstOperands,
     /* 166330 */   // GIR_Coverage, 6585,
     /* 166330 */   GIR_EraseRootFromParent_Done,
     /* 166331 */ // Label 2531: @166331
     /* 166331 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(166401), // Rule ID 6587 //
     /* 166336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166342 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166353 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166369 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 166372 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166399 */   GIR_RootConstrainSelectedInstOperands,
     /* 166400 */   // GIR_Coverage, 6587,
     /* 166400 */   GIR_EraseRootFromParent_Done,
     /* 166401 */ // Label 2532: @166401
     /* 166401 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(166471), // Rule ID 6589 //
     /* 166406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166412 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166423 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166439 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 166442 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166469 */   GIR_RootConstrainSelectedInstOperands,
     /* 166470 */   // GIR_Coverage, 6589,
     /* 166470 */   GIR_EraseRootFromParent_Done,
     /* 166471 */ // Label 2533: @166471
     /* 166471 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(166541), // Rule ID 6591 //
     /* 166476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166482 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166493 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166509 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 166512 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166539 */   GIR_RootConstrainSelectedInstOperands,
     /* 166540 */   // GIR_Coverage, 6591,
     /* 166540 */   GIR_EraseRootFromParent_Done,
     /* 166541 */ // Label 2534: @166541
     /* 166541 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(166600), // Rule ID 6601 //
     /* 166546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166552 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166557 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166568 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 166571 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166598 */   GIR_RootConstrainSelectedInstOperands,
     /* 166599 */   // GIR_Coverage, 6601,
     /* 166599 */   GIR_EraseRootFromParent_Done,
     /* 166600 */ // Label 2535: @166600
     /* 166600 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(166659), // Rule ID 6603 //
     /* 166605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166611 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166627 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 166630 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166657 */   GIR_RootConstrainSelectedInstOperands,
     /* 166658 */   // GIR_Coverage, 6603,
     /* 166658 */   GIR_EraseRootFromParent_Done,
     /* 166659 */ // Label 2536: @166659
     /* 166659 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(166718), // Rule ID 6605 //
     /* 166664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166670 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166686 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 166689 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166716 */   GIR_RootConstrainSelectedInstOperands,
     /* 166717 */   // GIR_Coverage, 6605,
     /* 166717 */   GIR_EraseRootFromParent_Done,
     /* 166718 */ // Label 2537: @166718
     /* 166718 */ GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(166777), // Rule ID 6607 //
     /* 166723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166726 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166729 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166745 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 166748 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166775 */   GIR_RootConstrainSelectedInstOperands,
     /* 166776 */   // GIR_Coverage, 6607,
     /* 166776 */   GIR_EraseRootFromParent_Done,
     /* 166777 */ // Label 2538: @166777
     /* 166777 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(166844), // Rule ID 4386 //
     /* 166782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166788 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166792 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166799 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166815 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 166818 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166842 */   GIR_RootConstrainSelectedInstOperands,
     /* 166843 */   // GIR_Coverage, 4386,
     /* 166843 */   GIR_EraseRootFromParent_Done,
     /* 166844 */ // Label 2539: @166844
     /* 166844 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(166911), // Rule ID 4389 //
     /* 166849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166855 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166866 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166882 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 166885 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166909 */   GIR_RootConstrainSelectedInstOperands,
     /* 166910 */   // GIR_Coverage, 4389,
     /* 166910 */   GIR_EraseRootFromParent_Done,
     /* 166911 */ // Label 2540: @166911
     /* 166911 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(166967), // Rule ID 4248 //
     /* 166916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166922 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166931 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166938 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 166941 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166965 */   GIR_RootConstrainSelectedInstOperands,
     /* 166966 */   // GIR_Coverage, 4248,
     /* 166966 */   GIR_EraseRootFromParent_Done,
     /* 166967 */ // Label 2541: @166967
     /* 166967 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(167023), // Rule ID 4254 //
     /* 166972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166978 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166994 */   // (st f32:{ *:[f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 166997 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 167009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167021 */   GIR_RootConstrainSelectedInstOperands,
     /* 167022 */   // GIR_Coverage, 4254,
     /* 167022 */   GIR_EraseRootFromParent_Done,
     /* 167023 */ // Label 2542: @167023
     /* 167023 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(167085), // Rule ID 4385 //
     /* 167028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167034 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167045 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 167061 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 167064 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167083 */   GIR_RootConstrainSelectedInstOperands,
     /* 167084 */   // GIR_Coverage, 4385,
     /* 167084 */   GIR_EraseRootFromParent_Done,
     /* 167085 */ // Label 2543: @167085
     /* 167085 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(167147), // Rule ID 4388 //
     /* 167090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167096 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167107 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 167123 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 167126 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167145 */   GIR_RootConstrainSelectedInstOperands,
     /* 167146 */   // GIR_Coverage, 4388,
     /* 167146 */   GIR_EraseRootFromParent_Done,
     /* 167147 */ // Label 2544: @167147
     /* 167147 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167198), // Rule ID 4247 //
     /* 167152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167158 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 167174 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 167177 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167196 */   GIR_RootConstrainSelectedInstOperands,
     /* 167197 */   // GIR_Coverage, 4247,
     /* 167197 */   GIR_EraseRootFromParent_Done,
     /* 167198 */ // Label 2545: @167198
     /* 167198 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167249), // Rule ID 4253 //
     /* 167203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167209 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 167225 */   // (st f32:{ *:[f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 167228 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167247 */   GIR_RootConstrainSelectedInstOperands,
     /* 167248 */   // GIR_Coverage, 4253,
     /* 167248 */   GIR_EraseRootFromParent_Done,
     /* 167249 */ // Label 2546: @167249
     /* 167249 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(167311), // Rule ID 4384 //
     /* 167254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167260 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167271 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167287 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 167290 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167309 */   GIR_RootConstrainSelectedInstOperands,
     /* 167310 */   // GIR_Coverage, 4384,
     /* 167310 */   GIR_EraseRootFromParent_Done,
     /* 167311 */ // Label 2547: @167311
     /* 167311 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(167373), // Rule ID 4387 //
     /* 167316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167322 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167326 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167333 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167349 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 167352 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167371 */   GIR_RootConstrainSelectedInstOperands,
     /* 167372 */   // GIR_Coverage, 4387,
     /* 167372 */   GIR_EraseRootFromParent_Done,
     /* 167373 */ // Label 2548: @167373
     /* 167373 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(167424), // Rule ID 4246 //
     /* 167378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167384 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167400 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 167403 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167422 */   GIR_RootConstrainSelectedInstOperands,
     /* 167423 */   // GIR_Coverage, 4246,
     /* 167423 */   GIR_EraseRootFromParent_Done,
     /* 167424 */ // Label 2549: @167424
     /* 167424 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(167475), // Rule ID 4252 //
     /* 167429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167435 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167451 */   // (st f32:{ *:[f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 167454 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167473 */   GIR_RootConstrainSelectedInstOperands,
     /* 167474 */   // GIR_Coverage, 4252,
     /* 167474 */   GIR_EraseRootFromParent_Done,
     /* 167475 */ // Label 2550: @167475
     /* 167475 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(167562), // Rule ID 7931 //
     /* 167480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 167483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167486 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167490 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167497 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 167506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 167510 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167514 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 167518 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 167522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167535 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_local>>  =>  (DS_WRITE_B16_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_D16_HI),
     /* 167538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 167547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167560 */   GIR_RootConstrainSelectedInstOperands,
     /* 167561 */   // GIR_Coverage, 7931,
     /* 167561 */   GIR_EraseRootFromParent_Done,
     /* 167562 */ // Label 2551: @167562
     /* 167562 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167649), // Rule ID 7932 //
     /* 167567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 167570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167573 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167584 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 167593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 167597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 167605 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 167609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167615 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167622 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_local>>  =>  (DS_WRITE_B8_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_D16_HI),
     /* 167625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 167634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167647 */   GIR_RootConstrainSelectedInstOperands,
     /* 167648 */   // GIR_Coverage, 7932,
     /* 167648 */   GIR_EraseRootFromParent_Done,
     /* 167649 */ // Label 2552: @167649
     /* 167649 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(167720), // Rule ID 6568 //
     /* 167654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167660 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167667 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167683 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 167686 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167718 */   GIR_RootConstrainSelectedInstOperands,
     /* 167719 */   // GIR_Coverage, 6568,
     /* 167719 */   GIR_EraseRootFromParent_Done,
     /* 167720 */ // Label 2553: @167720
     /* 167720 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(167791), // Rule ID 6572 //
     /* 167725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167728 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167731 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167738 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167754 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 167757 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167789 */   GIR_RootConstrainSelectedInstOperands,
     /* 167790 */   // GIR_Coverage, 6572,
     /* 167790 */   GIR_EraseRootFromParent_Done,
     /* 167791 */ // Label 2554: @167791
     /* 167791 */ GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(167862), // Rule ID 6576 //
     /* 167796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167799 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167802 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167809 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167825 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 167828 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167860 */   GIR_RootConstrainSelectedInstOperands,
     /* 167861 */   // GIR_Coverage, 6576,
     /* 167861 */   GIR_EraseRootFromParent_Done,
     /* 167862 */ // Label 2555: @167862
     /* 167862 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(167937), // Rule ID 4435 //
     /* 167867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 167870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167884 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167900 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 167903 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167935 */   GIR_RootConstrainSelectedInstOperands,
     /* 167936 */   // GIR_Coverage, 4435,
     /* 167936 */   GIR_EraseRootFromParent_Done,
     /* 167937 */ // Label 2556: @167937
     /* 167937 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(168009), // Rule ID 4595 //
     /* 167942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167945 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167949 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167956 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167972 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_ADDR64),
     /* 167975 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168003 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168007 */   GIR_RootConstrainSelectedInstOperands,
     /* 168008 */   // GIR_Coverage, 4595,
     /* 168008 */   GIR_EraseRootFromParent_Done,
     /* 168009 */ // Label 2557: @168009
     /* 168009 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(168084), // Rule ID 4597 //
     /* 168014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168020 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168031 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168047 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 168050 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168078 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168082 */   GIR_RootConstrainSelectedInstOperands,
     /* 168083 */   // GIR_Coverage, 4597,
     /* 168083 */   GIR_EraseRootFromParent_Done,
     /* 168084 */ // Label 2558: @168084
     /* 168084 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(168156), // Rule ID 4599 //
     /* 168089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168092 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168119 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_ADDR64),
     /* 168122 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168154 */   GIR_RootConstrainSelectedInstOperands,
     /* 168155 */   // GIR_Coverage, 4599,
     /* 168155 */   GIR_EraseRootFromParent_Done,
     /* 168156 */ // Label 2559: @168156
     /* 168156 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(168231), // Rule ID 6584 //
     /* 168161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168178 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168194 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 168197 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168229 */   GIR_RootConstrainSelectedInstOperands,
     /* 168230 */   // GIR_Coverage, 6584,
     /* 168230 */   GIR_EraseRootFromParent_Done,
     /* 168231 */ // Label 2560: @168231
     /* 168231 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(168306), // Rule ID 6586 //
     /* 168236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168242 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168246 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168253 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168269 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 168272 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168304 */   GIR_RootConstrainSelectedInstOperands,
     /* 168305 */   // GIR_Coverage, 6586,
     /* 168305 */   GIR_EraseRootFromParent_Done,
     /* 168306 */ // Label 2561: @168306
     /* 168306 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(168381), // Rule ID 6588 //
     /* 168311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168314 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168317 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168328 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168344 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 168347 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168379 */   GIR_RootConstrainSelectedInstOperands,
     /* 168380 */   // GIR_Coverage, 6588,
     /* 168380 */   GIR_EraseRootFromParent_Done,
     /* 168381 */ // Label 2562: @168381
     /* 168381 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(168456), // Rule ID 6590 //
     /* 168386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168392 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168403 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168419 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 168422 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168454 */   GIR_RootConstrainSelectedInstOperands,
     /* 168455 */   // GIR_Coverage, 6590,
     /* 168455 */   GIR_EraseRootFromParent_Done,
     /* 168456 */ // Label 2563: @168456
     /* 168456 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(168520), // Rule ID 4601 //
     /* 168461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168467 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168483 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 168486 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168518 */   GIR_RootConstrainSelectedInstOperands,
     /* 168519 */   // GIR_Coverage, 4601,
     /* 168519 */   GIR_EraseRootFromParent_Done,
     /* 168520 */ // Label 2564: @168520
     /* 168520 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(168581), // Rule ID 4603 //
     /* 168525 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168528 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168544 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 168547 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168579 */   GIR_RootConstrainSelectedInstOperands,
     /* 168580 */   // GIR_Coverage, 4603,
     /* 168580 */   GIR_EraseRootFromParent_Done,
     /* 168581 */ // Label 2565: @168581
     /* 168581 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(168645), // Rule ID 4605 //
     /* 168586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168592 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168608 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 168611 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168643 */   GIR_RootConstrainSelectedInstOperands,
     /* 168644 */   // GIR_Coverage, 4605,
     /* 168644 */   GIR_EraseRootFromParent_Done,
     /* 168645 */ // Label 2566: @168645
     /* 168645 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(168706), // Rule ID 4607 //
     /* 168650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168669 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 168672 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168704 */   GIR_RootConstrainSelectedInstOperands,
     /* 168705 */   // GIR_Coverage, 4607,
     /* 168705 */   GIR_EraseRootFromParent_Done,
     /* 168706 */ // Label 2567: @168706
     /* 168706 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(168770), // Rule ID 6600 //
     /* 168711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168714 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168717 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168733 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 168736 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168768 */   GIR_RootConstrainSelectedInstOperands,
     /* 168769 */   // GIR_Coverage, 6600,
     /* 168769 */   GIR_EraseRootFromParent_Done,
     /* 168770 */ // Label 2568: @168770
     /* 168770 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(168834), // Rule ID 6602 //
     /* 168775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168781 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168797 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 168800 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168832 */   GIR_RootConstrainSelectedInstOperands,
     /* 168833 */   // GIR_Coverage, 6602,
     /* 168833 */   GIR_EraseRootFromParent_Done,
     /* 168834 */ // Label 2569: @168834
     /* 168834 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(168898), // Rule ID 6604 //
     /* 168839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168845 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168850 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168861 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 168864 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168892 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168896 */   GIR_RootConstrainSelectedInstOperands,
     /* 168897 */   // GIR_Coverage, 6604,
     /* 168897 */   GIR_EraseRootFromParent_Done,
     /* 168898 */ // Label 2570: @168898
     /* 168898 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(168962), // Rule ID 6606 //
     /* 168903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168909 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168925 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 168928 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168960 */   GIR_RootConstrainSelectedInstOperands,
     /* 168961 */   // GIR_Coverage, 6606,
     /* 168961 */   GIR_EraseRootFromParent_Done,
     /* 168962 */ // Label 2571: @168962
     /* 168962 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(169054), // Rule ID 3972 //
     /* 168967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 168970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168973 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168984 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169005 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169013 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 169022 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI_SADDR),
     /* 169025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 169030 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 169039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169052 */   GIR_RootConstrainSelectedInstOperands,
     /* 169053 */   // GIR_Coverage, 3972,
     /* 169053 */   GIR_EraseRootFromParent_Done,
     /* 169054 */ // Label 2572: @169054
     /* 169054 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(169146), // Rule ID 3974 //
     /* 169059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 169062 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169065 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169076 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169081 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169089 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169093 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169097 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 169114 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI_SADDR),
     /* 169117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 169122 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 169131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169144 */   GIR_RootConstrainSelectedInstOperands,
     /* 169145 */   // GIR_Coverage, 3974,
     /* 169145 */   GIR_EraseRootFromParent_Done,
     /* 169146 */ // Label 2573: @169146
     /* 169146 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(169216), // Rule ID 4434 //
     /* 169151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169168 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169184 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 169187 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169214 */   GIR_RootConstrainSelectedInstOperands,
     /* 169215 */   // GIR_Coverage, 4434,
     /* 169215 */   GIR_EraseRootFromParent_Done,
     /* 169216 */ // Label 2574: @169216
     /* 169216 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(169283), // Rule ID 4594 //
     /* 169221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169224 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169235 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169251 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 169254 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169281 */   GIR_RootConstrainSelectedInstOperands,
     /* 169282 */   // GIR_Coverage, 4594,
     /* 169282 */   GIR_EraseRootFromParent_Done,
     /* 169283 */ // Label 2575: @169283
     /* 169283 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(169353), // Rule ID 4596 //
     /* 169288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169294 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169305 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169321 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 169324 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169351 */   GIR_RootConstrainSelectedInstOperands,
     /* 169352 */   // GIR_Coverage, 4596,
     /* 169352 */   GIR_EraseRootFromParent_Done,
     /* 169353 */ // Label 2576: @169353
     /* 169353 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(169420), // Rule ID 4598 //
     /* 169358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169361 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169365 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169372 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169388 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 169391 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169418 */   GIR_RootConstrainSelectedInstOperands,
     /* 169419 */   // GIR_Coverage, 4598,
     /* 169419 */   GIR_EraseRootFromParent_Done,
     /* 169420 */ // Label 2577: @169420
     /* 169420 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(169479), // Rule ID 4600 //
     /* 169425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169431 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169447 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 169450 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169477 */   GIR_RootConstrainSelectedInstOperands,
     /* 169478 */   // GIR_Coverage, 4600,
     /* 169478 */   GIR_EraseRootFromParent_Done,
     /* 169479 */ // Label 2578: @169479
     /* 169479 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(169535), // Rule ID 4602 //
     /* 169484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169487 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169503 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 169506 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169533 */   GIR_RootConstrainSelectedInstOperands,
     /* 169534 */   // GIR_Coverage, 4602,
     /* 169534 */   GIR_EraseRootFromParent_Done,
     /* 169535 */ // Label 2579: @169535
     /* 169535 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(169594), // Rule ID 4604 //
     /* 169540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169546 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169555 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169562 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 169565 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169592 */   GIR_RootConstrainSelectedInstOperands,
     /* 169593 */   // GIR_Coverage, 4604,
     /* 169593 */   GIR_EraseRootFromParent_Done,
     /* 169594 */ // Label 2580: @169594
     /* 169594 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(169650), // Rule ID 4606 //
     /* 169599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169602 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169618 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 169621 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169648 */   GIR_RootConstrainSelectedInstOperands,
     /* 169649 */   // GIR_Coverage, 4606,
     /* 169649 */   GIR_EraseRootFromParent_Done,
     /* 169650 */ // Label 2581: @169650
     /* 169650 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(169737), // Rule ID 3971 //
     /* 169655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 169658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169661 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169672 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169693 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 169710 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 169710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI),
     /* 169713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169718 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169735 */   GIR_RootConstrainSelectedInstOperands,
     /* 169736 */   // GIR_Coverage, 3971,
     /* 169736 */   GIR_EraseRootFromParent_Done,
     /* 169737 */ // Label 2582: @169737
     /* 169737 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(169824), // Rule ID 3973 //
     /* 169742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 169745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169748 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169759 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169772 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169776 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169780 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169788 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 169797 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 169797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI),
     /* 169800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169805 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169822 */   GIR_RootConstrainSelectedInstOperands,
     /* 169823 */   // GIR_Coverage, 3973,
     /* 169823 */   GIR_EraseRootFromParent_Done,
     /* 169824 */ // Label 2583: @169824
     /* 169824 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(169882), // Rule ID 7919 //
     /* 169829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169842 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169858 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 169861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169866 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169880 */   GIR_RootConstrainSelectedInstOperands,
     /* 169881 */   // GIR_Coverage, 7919,
     /* 169881 */   GIR_EraseRootFromParent_Done,
     /* 169882 */ // Label 2584: @169882
     /* 169882 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(169940), // Rule ID 7920 //
     /* 169887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 169890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169900 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169916 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 169919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169924 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169938 */   GIR_RootConstrainSelectedInstOperands,
     /* 169939 */   // GIR_Coverage, 7920,
     /* 169939 */   GIR_EraseRootFromParent_Done,
     /* 169940 */ // Label 2585: @169940
     /* 169940 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(169998), // Rule ID 7925 //
     /* 169945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169948 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169958 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169974 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 169977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169982 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169996 */   GIR_RootConstrainSelectedInstOperands,
     /* 169997 */   // GIR_Coverage, 7925,
     /* 169997 */   GIR_EraseRootFromParent_Done,
     /* 169998 */ // Label 2586: @169998
     /* 169998 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(170056), // Rule ID 7926 //
     /* 170003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170006 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170016 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170021 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170025 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170032 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 170035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170040 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170054 */   GIR_RootConstrainSelectedInstOperands,
     /* 170055 */   // GIR_Coverage, 7926,
     /* 170055 */   GIR_EraseRootFromParent_Done,
     /* 170056 */ // Label 2587: @170056
     /* 170056 */ GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(170114), // Rule ID 7927 //
     /* 170061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170064 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170074 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170090 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32_glue>><<P:Predicate_atomic_store_32_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 170093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170098 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170112 */   GIR_RootConstrainSelectedInstOperands,
     /* 170113 */   // GIR_Coverage, 7927,
     /* 170113 */   GIR_EraseRootFromParent_Done,
     /* 170114 */ // Label 2588: @170114
     /* 170114 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(170172), // Rule ID 7928 //
     /* 170119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170122 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170132 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170148 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 170151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170156 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170170 */   GIR_RootConstrainSelectedInstOperands,
     /* 170171 */   // GIR_Coverage, 7928,
     /* 170171 */   GIR_EraseRootFromParent_Done,
     /* 170172 */ // Label 2589: @170172
     /* 170172 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(170234), // Rule ID 7887 //
     /* 170177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170183 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170194 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170203 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170210 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 170213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170218 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170232 */   GIR_RootConstrainSelectedInstOperands,
     /* 170233 */   // GIR_Coverage, 7887,
     /* 170233 */   GIR_EraseRootFromParent_Done,
     /* 170234 */ // Label 2590: @170234
     /* 170234 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(170296), // Rule ID 7888 //
     /* 170239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170245 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170256 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170272 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 170275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170280 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170294 */   GIR_RootConstrainSelectedInstOperands,
     /* 170295 */   // GIR_Coverage, 7888,
     /* 170295 */   GIR_EraseRootFromParent_Done,
     /* 170296 */ // Label 2591: @170296
     /* 170296 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(170358), // Rule ID 7892 //
     /* 170301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170307 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170318 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170327 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170334 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei16_glue>><<P:Predicate_truncstorei16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 170337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170342 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170356 */   GIR_RootConstrainSelectedInstOperands,
     /* 170357 */   // GIR_Coverage, 7892,
     /* 170357 */   GIR_EraseRootFromParent_Done,
     /* 170358 */ // Label 2592: @170358
     /* 170358 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(170420), // Rule ID 7893 //
     /* 170363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170366 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170369 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170373 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170380 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170396 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 170399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170404 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170418 */   GIR_RootConstrainSelectedInstOperands,
     /* 170419 */   // GIR_Coverage, 7893,
     /* 170419 */   GIR_EraseRootFromParent_Done,
     /* 170420 */ // Label 2593: @170420
     /* 170420 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(170475), // Rule ID 7899 //
     /* 170425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170435 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170451 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 170454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170459 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170473 */   GIR_RootConstrainSelectedInstOperands,
     /* 170474 */   // GIR_Coverage, 7899,
     /* 170474 */   GIR_EraseRootFromParent_Done,
     /* 170475 */ // Label 2594: @170475
     /* 170475 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(170530), // Rule ID 7901 //
     /* 170480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170490 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170506 */   // (AMDGPUst_glue f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 170509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170514 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170528 */   GIR_RootConstrainSelectedInstOperands,
     /* 170529 */   // GIR_Coverage, 7901,
     /* 170529 */   GIR_EraseRootFromParent_Done,
     /* 170530 */ // Label 2595: @170530
     /* 170530 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(170581), // Rule ID 7900 //
     /* 170535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170541 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170557 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 170560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170565 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170579 */   GIR_RootConstrainSelectedInstOperands,
     /* 170580 */   // GIR_Coverage, 7900,
     /* 170580 */   GIR_EraseRootFromParent_Done,
     /* 170581 */ // Label 2596: @170581
     /* 170581 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(170632), // Rule ID 7902 //
     /* 170586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170592 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170608 */   // (st f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 170611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170616 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170630 */   GIR_RootConstrainSelectedInstOperands,
     /* 170631 */   // GIR_Coverage, 7902,
     /* 170631 */   GIR_EraseRootFromParent_Done,
     /* 170632 */ // Label 2597: @170632
     /* 170632 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(170695), // Rule ID 3998 //
     /* 170637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170640 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170643 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170650 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170666 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 170669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170674 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170693 */   GIR_RootConstrainSelectedInstOperands,
     /* 170694 */   // GIR_Coverage, 3998,
     /* 170694 */   GIR_EraseRootFromParent_Done,
     /* 170695 */ // Label 2598: @170695
     /* 170695 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(170758), // Rule ID 4002 //
     /* 170700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170703 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170706 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170713 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170729 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 170732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170737 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170756 */   GIR_RootConstrainSelectedInstOperands,
     /* 170757 */   // GIR_Coverage, 4002,
     /* 170757 */   GIR_EraseRootFromParent_Done,
     /* 170758 */ // Label 2599: @170758
     /* 170758 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(170821), // Rule ID 4006 //
     /* 170763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170766 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170769 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170776 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170792 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 170795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170800 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170819 */   GIR_RootConstrainSelectedInstOperands,
     /* 170820 */   // GIR_Coverage, 4006,
     /* 170820 */   GIR_EraseRootFromParent_Done,
     /* 170821 */ // Label 2600: @170821
     /* 170821 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(170888), // Rule ID 3958 //
     /* 170826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170832 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170836 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170843 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170859 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 170862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170867 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170886 */   GIR_RootConstrainSelectedInstOperands,
     /* 170887 */   // GIR_Coverage, 3958,
     /* 170887 */   GIR_EraseRootFromParent_Done,
     /* 170888 */ // Label 2601: @170888
     /* 170888 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(170955), // Rule ID 3960 //
     /* 170893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170899 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170903 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170910 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170926 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 170929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170934 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170953 */   GIR_RootConstrainSelectedInstOperands,
     /* 170954 */   // GIR_Coverage, 3960,
     /* 170954 */   GIR_EraseRootFromParent_Done,
     /* 170955 */ // Label 2602: @170955
     /* 170955 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(171011), // Rule ID 3550 //
     /* 170960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170966 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170982 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 170985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170990 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 171002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171009 */   GIR_RootConstrainSelectedInstOperands,
     /* 171010 */   // GIR_Coverage, 3550,
     /* 171010 */   GIR_EraseRootFromParent_Done,
     /* 171011 */ // Label 2603: @171011
     /* 171011 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(171067), // Rule ID 3866 //
     /* 171016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171022 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171031 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 171038 */   // (st f32:{ *:[f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 171038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 171041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 171046 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 171053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 171058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171065 */   GIR_RootConstrainSelectedInstOperands,
     /* 171066 */   // GIR_Coverage, 3866,
     /* 171066 */   GIR_EraseRootFromParent_Done,
     /* 171067 */ // Label 2604: @171067
     /* 171067 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(171125), // Rule ID 3997 //
     /* 171072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171075 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171085 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171101 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 171104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171109 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171123 */   GIR_RootConstrainSelectedInstOperands,
     /* 171124 */   // GIR_Coverage, 3997,
     /* 171124 */   GIR_EraseRootFromParent_Done,
     /* 171125 */ // Label 2605: @171125
     /* 171125 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(171183), // Rule ID 4001 //
     /* 171130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171143 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171159 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 171162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171167 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171181 */   GIR_RootConstrainSelectedInstOperands,
     /* 171182 */   // GIR_Coverage, 4001,
     /* 171182 */   GIR_EraseRootFromParent_Done,
     /* 171183 */ // Label 2606: @171183
     /* 171183 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(171241), // Rule ID 4005 //
     /* 171188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171201 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171217 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 171220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171225 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171239 */   GIR_RootConstrainSelectedInstOperands,
     /* 171240 */   // GIR_Coverage, 4005,
     /* 171240 */   GIR_EraseRootFromParent_Done,
     /* 171241 */ // Label 2607: @171241
     /* 171241 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(171303), // Rule ID 3957 //
     /* 171246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171252 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171263 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171279 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 171282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171287 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171301 */   GIR_RootConstrainSelectedInstOperands,
     /* 171302 */   // GIR_Coverage, 3957,
     /* 171302 */   GIR_EraseRootFromParent_Done,
     /* 171303 */ // Label 2608: @171303
     /* 171303 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(171365), // Rule ID 3959 //
     /* 171308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171314 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171325 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171341 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 171344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171349 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171363 */   GIR_RootConstrainSelectedInstOperands,
     /* 171364 */   // GIR_Coverage, 3959,
     /* 171364 */   GIR_EraseRootFromParent_Done,
     /* 171365 */ // Label 2609: @171365
     /* 171365 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(171416), // Rule ID 3549 //
     /* 171370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171376 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171392 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 171395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171400 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171414 */   GIR_RootConstrainSelectedInstOperands,
     /* 171415 */   // GIR_Coverage, 3549,
     /* 171415 */   GIR_EraseRootFromParent_Done,
     /* 171416 */ // Label 2610: @171416
     /* 171416 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(171467), // Rule ID 3865 //
     /* 171421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171427 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171443 */   // (st f32:{ *:[f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 171446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171451 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171465 */   GIR_RootConstrainSelectedInstOperands,
     /* 171466 */   // GIR_Coverage, 3865,
     /* 171466 */   GIR_EraseRootFromParent_Done,
     /* 171467 */ // Label 2611: @171467
     /* 171467 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(171555), // Rule ID 3785 //
     /* 171472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171478 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171489 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171503 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171507 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171511 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171528 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_flat>>  =>  (FLAT_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_D16_HI),
     /* 171531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171536 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 171540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171553 */   GIR_RootConstrainSelectedInstOperands,
     /* 171554 */   // GIR_Coverage, 3785,
     /* 171554 */   GIR_EraseRootFromParent_Done,
     /* 171555 */ // Label 2612: @171555
     /* 171555 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(171643), // Rule ID 3786 //
     /* 171560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171566 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171577 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171599 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171603 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171616 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_flat>>  =>  (FLAT_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_D16_HI),
     /* 171619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171624 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 171628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171641 */   GIR_RootConstrainSelectedInstOperands,
     /* 171642 */   // GIR_Coverage, 3786,
     /* 171642 */   GIR_EraseRootFromParent_Done,
     /* 171643 */ // Label 2613: @171643
     /* 171643 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(171702), // Rule ID 3659 //
     /* 171648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171661 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171678 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 171681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171686 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171700 */   GIR_RootConstrainSelectedInstOperands,
     /* 171701 */   // GIR_Coverage, 3659,
     /* 171701 */   GIR_EraseRootFromParent_Done,
     /* 171702 */ // Label 2614: @171702
     /* 171702 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(171761), // Rule ID 3661 //
     /* 171707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171720 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171726 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171730 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171737 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 171740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171745 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171759 */   GIR_RootConstrainSelectedInstOperands,
     /* 171760 */   // GIR_Coverage, 3661,
     /* 171760 */   GIR_EraseRootFromParent_Done,
     /* 171761 */ // Label 2615: @171761
     /* 171761 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(171820), // Rule ID 3663 //
     /* 171766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171769 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171772 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171779 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171789 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171796 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 171799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171804 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171814 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171818 */   GIR_RootConstrainSelectedInstOperands,
     /* 171819 */   // GIR_Coverage, 3663,
     /* 171819 */   GIR_EraseRootFromParent_Done,
     /* 171820 */ // Label 2616: @171820
     /* 171820 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(171883), // Rule ID 3610 //
     /* 171825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171831 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171842 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171859 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 171862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171867 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171881 */   GIR_RootConstrainSelectedInstOperands,
     /* 171882 */   // GIR_Coverage, 3610,
     /* 171882 */   GIR_EraseRootFromParent_Done,
     /* 171883 */ // Label 2617: @171883
     /* 171883 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(171946), // Rule ID 3611 //
     /* 171888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171894 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171905 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171911 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171922 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 171925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171930 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171944 */   GIR_RootConstrainSelectedInstOperands,
     /* 171945 */   // GIR_Coverage, 3611,
     /* 171945 */   GIR_EraseRootFromParent_Done,
     /* 171946 */ // Label 2618: @171946
     /* 171946 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(171998), // Rule ID 3613 //
     /* 171951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171957 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171974 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 171977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171982 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171996 */   GIR_RootConstrainSelectedInstOperands,
     /* 171997 */   // GIR_Coverage, 3613,
     /* 171997 */   GIR_EraseRootFromParent_Done,
     /* 171998 */ // Label 2619: @171998
     /* 171998 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(172050), // Rule ID 3615 //
     /* 172003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 172006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172009 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 172015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 172026 */   // (st f32:{ *:[f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 172026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 172029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172034 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172048 */   GIR_RootConstrainSelectedInstOperands,
     /* 172049 */   // GIR_Coverage, 3615,
     /* 172049 */   GIR_EraseRootFromParent_Done,
     /* 172050 */ // Label 2620: @172050
     /* 172050 */ GIM_Reject,
     /* 172051 */ // Label 2317: @172051
     /* 172051 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(172115), // Rule ID 8063 //
     /* 172056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 172059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172066 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172071 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172080 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 172084 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172091 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 172094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172099 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172113 */   GIR_RootConstrainSelectedInstOperands,
     /* 172114 */   // GIR_Coverage, 8063,
     /* 172114 */   GIR_EraseRootFromParent_Done,
     /* 172115 */ // Label 2621: @172115
     /* 172115 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(172179), // Rule ID 8067 //
     /* 172120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 172123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172130 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172135 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172144 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 172148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172155 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 172158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172163 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172177 */   GIR_RootConstrainSelectedInstOperands,
     /* 172178 */   // GIR_Coverage, 8067,
     /* 172178 */   GIR_EraseRootFromParent_Done,
     /* 172179 */ // Label 2622: @172179
     /* 172179 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(172238), // Rule ID 7995 //
     /* 172184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 172187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172194 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172199 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172214 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 172217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172222 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172236 */   GIR_RootConstrainSelectedInstOperands,
     /* 172237 */   // GIR_Coverage, 7995,
     /* 172237 */   GIR_EraseRootFromParent_Done,
     /* 172238 */ // Label 2623: @172238
     /* 172238 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(172297), // Rule ID 7999 //
     /* 172243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 172246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172253 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172258 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172273 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 172276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172281 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172295 */   GIR_RootConstrainSelectedInstOperands,
     /* 172296 */   // GIR_Coverage, 7999,
     /* 172296 */   GIR_EraseRootFromParent_Done,
     /* 172297 */ // Label 2624: @172297
     /* 172297 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(172357), // Rule ID 8064 //
     /* 172302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 172305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172308 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172313 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172322 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 172326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172333 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172341 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172355 */   GIR_RootConstrainSelectedInstOperands,
     /* 172356 */   // GIR_Coverage, 8064,
     /* 172356 */   GIR_EraseRootFromParent_Done,
     /* 172357 */ // Label 2625: @172357
     /* 172357 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(172417), // Rule ID 8068 //
     /* 172362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 172365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172368 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172373 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172382 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 172386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172393 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172401 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172415 */   GIR_RootConstrainSelectedInstOperands,
     /* 172416 */   // GIR_Coverage, 8068,
     /* 172416 */   GIR_EraseRootFromParent_Done,
     /* 172417 */ // Label 2626: @172417
     /* 172417 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(172472), // Rule ID 7996 //
     /* 172422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 172425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172428 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172433 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172448 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172456 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172470 */   GIR_RootConstrainSelectedInstOperands,
     /* 172471 */   // GIR_Coverage, 7996,
     /* 172471 */   GIR_EraseRootFromParent_Done,
     /* 172472 */ // Label 2627: @172472
     /* 172472 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(172527), // Rule ID 8000 //
     /* 172477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 172480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172483 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172488 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172503 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172511 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172525 */   GIR_RootConstrainSelectedInstOperands,
     /* 172526 */   // GIR_Coverage, 8000,
     /* 172526 */   GIR_EraseRootFromParent_Done,
     /* 172527 */ // Label 2628: @172527
     /* 172527 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(172583), // Rule ID 4296 //
     /* 172532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 172535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172538 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 172554 */   // (st i64:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 172557 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 172569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172581 */   GIR_RootConstrainSelectedInstOperands,
     /* 172582 */   // GIR_Coverage, 4296,
     /* 172582 */   GIR_EraseRootFromParent_Done,
     /* 172583 */ // Label 2629: @172583
     /* 172583 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(172639), // Rule ID 4302 //
     /* 172588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 172591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172594 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 172610 */   // (st f64:{ *:[f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 172613 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 172625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172637 */   GIR_RootConstrainSelectedInstOperands,
     /* 172638 */   // GIR_Coverage, 4302,
     /* 172638 */   GIR_EraseRootFromParent_Done,
     /* 172639 */ // Label 2630: @172639
     /* 172639 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(172690), // Rule ID 4295 //
     /* 172644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172650 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 172666 */   // (st i64:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 172669 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172688 */   GIR_RootConstrainSelectedInstOperands,
     /* 172689 */   // GIR_Coverage, 4295,
     /* 172689 */   GIR_EraseRootFromParent_Done,
     /* 172690 */ // Label 2631: @172690
     /* 172690 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(172741), // Rule ID 4301 //
     /* 172695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172701 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 172717 */   // (st f64:{ *:[f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 172720 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172739 */   GIR_RootConstrainSelectedInstOperands,
     /* 172740 */   // GIR_Coverage, 4301,
     /* 172740 */   GIR_EraseRootFromParent_Done,
     /* 172741 */ // Label 2632: @172741
     /* 172741 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(172792), // Rule ID 4294 //
     /* 172746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172752 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 172768 */   // (st i64:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 172768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 172771 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172790 */   GIR_RootConstrainSelectedInstOperands,
     /* 172791 */   // GIR_Coverage, 4294,
     /* 172791 */   GIR_EraseRootFromParent_Done,
     /* 172792 */ // Label 2633: @172792
     /* 172792 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(172843), // Rule ID 4300 //
     /* 172797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172803 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172808 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172812 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 172819 */   // (st f64:{ *:[f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 172819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 172822 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172837 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172841 */   GIR_RootConstrainSelectedInstOperands,
     /* 172842 */   // GIR_Coverage, 4300,
     /* 172842 */   GIR_EraseRootFromParent_Done,
     /* 172843 */ // Label 2634: @172843
     /* 172843 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(172914), // Rule ID 6578 //
     /* 172848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 172851 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 172854 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172861 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172870 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172877 */   // (atomic_store i64:{ *:[i64] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 ?:{ *:[i64] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 172877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 172880 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 172882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172912 */   GIR_RootConstrainSelectedInstOperands,
     /* 172913 */   // GIR_Coverage, 6578,
     /* 172913 */   GIR_EraseRootFromParent_Done,
     /* 172914 */ // Label 2635: @172914
     /* 172914 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(172978), // Rule ID 4633 //
     /* 172919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172925 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172934 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172941 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 172944 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172976 */   GIR_RootConstrainSelectedInstOperands,
     /* 172977 */   // GIR_Coverage, 4633,
     /* 172977 */   GIR_EraseRootFromParent_Done,
     /* 172978 */ // Label 2636: @172978
     /* 172978 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(173039), // Rule ID 4635 //
     /* 172983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172986 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 173002 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 173005 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 173012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 173022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 173027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173037 */   GIR_RootConstrainSelectedInstOperands,
     /* 173038 */   // GIR_Coverage, 4635,
     /* 173038 */   GIR_EraseRootFromParent_Done,
     /* 173039 */ // Label 2637: @173039
     /* 173039 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(173103), // Rule ID 4637 //
     /* 173044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173050 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173059 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 173066 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 173069 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 173076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 173086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 173091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173101 */   GIR_RootConstrainSelectedInstOperands,
     /* 173102 */   // GIR_Coverage, 4637,
     /* 173102 */   GIR_EraseRootFromParent_Done,
     /* 173103 */ // Label 2638: @173103
     /* 173103 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(173164), // Rule ID 4639 //
     /* 173108 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 173127 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 173130 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 173137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 173147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 173152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173162 */   GIR_RootConstrainSelectedInstOperands,
     /* 173163 */   // GIR_Coverage, 4639,
     /* 173163 */   GIR_EraseRootFromParent_Done,
     /* 173164 */ // Label 2639: @173164
     /* 173164 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(173284), // Rule ID 7934 //
     /* 173169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 173172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173179 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173195 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173195 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173198 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173202 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173207 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173213 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173218 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173235 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 173254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173282 */   GIR_RootConstrainSelectedInstOperands,
     /* 173283 */   // GIR_Coverage, 7934,
     /* 173283 */   GIR_EraseRootFromParent_Done,
     /* 173284 */ // Label 2640: @173284
     /* 173284 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(173404), // Rule ID 7942 //
     /* 173289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 173292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173299 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173315 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173315 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173318 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173322 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173327 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173333 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173338 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173355 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173366 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 173374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173379 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173402 */   GIR_RootConstrainSelectedInstOperands,
     /* 173403 */   // GIR_Coverage, 7942,
     /* 173403 */   GIR_EraseRootFromParent_Done,
     /* 173404 */ // Label 2641: @173404
     /* 173404 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(173463), // Rule ID 4632 //
     /* 173409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173412 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173415 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173420 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173431 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 173434 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173461 */   GIR_RootConstrainSelectedInstOperands,
     /* 173462 */   // GIR_Coverage, 4632,
     /* 173462 */   GIR_EraseRootFromParent_Done,
     /* 173463 */ // Label 2642: @173463
     /* 173463 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(173519), // Rule ID 4634 //
     /* 173468 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173471 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173487 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 173490 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173517 */   GIR_RootConstrainSelectedInstOperands,
     /* 173518 */   // GIR_Coverage, 4634,
     /* 173518 */   GIR_EraseRootFromParent_Done,
     /* 173519 */ // Label 2643: @173519
     /* 173519 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(173578), // Rule ID 4636 //
     /* 173524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173530 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173546 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 173549 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173576 */   GIR_RootConstrainSelectedInstOperands,
     /* 173577 */   // GIR_Coverage, 4636,
     /* 173577 */   GIR_EraseRootFromParent_Done,
     /* 173578 */ // Label 2644: @173578
     /* 173578 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(173634), // Rule ID 4638 //
     /* 173583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173586 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173602 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 173605 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173632 */   GIR_RootConstrainSelectedInstOperands,
     /* 173633 */   // GIR_Coverage, 4638,
     /* 173633 */   GIR_EraseRootFromParent_Done,
     /* 173634 */ // Label 2645: @173634
     /* 173634 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(173750), // Rule ID 7936 //
     /* 173639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173645 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173661 */   // (st i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173661 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173664 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173668 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173673 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173679 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173684 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173692 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173696 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173701 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 173720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173748 */   GIR_RootConstrainSelectedInstOperands,
     /* 173749 */   // GIR_Coverage, 7936,
     /* 173749 */   GIR_EraseRootFromParent_Done,
     /* 173750 */ // Label 2646: @173750
     /* 173750 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(173866), // Rule ID 7944 //
     /* 173755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173761 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173777 */   // (st f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173777 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173780 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173784 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173789 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173795 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173800 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173817 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 173836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173864 */   GIR_RootConstrainSelectedInstOperands,
     /* 173865 */   // GIR_Coverage, 7944,
     /* 173865 */   GIR_EraseRootFromParent_Done,
     /* 173866 */ // Label 2647: @173866
     /* 173866 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(173924), // Rule ID 7929 //
     /* 173871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173874 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173884 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173900 */   // (AMDGPUatomic_st_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64_glue>><<P:Predicate_atomic_store_64_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 173903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173908 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173922 */   GIR_RootConstrainSelectedInstOperands,
     /* 173923 */   // GIR_Coverage, 7929,
     /* 173923 */   GIR_EraseRootFromParent_Done,
     /* 173924 */ // Label 2648: @173924
     /* 173924 */ GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(173982), // Rule ID 7930 //
     /* 173929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173935 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173942 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173958 */   // (atomic_store i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 173961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173966 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173980 */   GIR_RootConstrainSelectedInstOperands,
     /* 173981 */   // GIR_Coverage, 7930,
     /* 173981 */   GIR_EraseRootFromParent_Done,
     /* 173982 */ // Label 2649: @173982
     /* 173982 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(174045), // Rule ID 4008 //
     /* 173987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 174000 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174016 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 174019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174024 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174043 */   GIR_RootConstrainSelectedInstOperands,
     /* 174044 */   // GIR_Coverage, 4008,
     /* 174044 */   GIR_EraseRootFromParent_Done,
     /* 174045 */ // Label 2650: @174045
     /* 174045 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(174101), // Rule ID 3894 //
     /* 174050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174056 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174072 */   // (st i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 174075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174080 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174099 */   GIR_RootConstrainSelectedInstOperands,
     /* 174100 */   // GIR_Coverage, 3894,
     /* 174100 */   GIR_EraseRootFromParent_Done,
     /* 174101 */ // Label 2651: @174101
     /* 174101 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(174157), // Rule ID 3898 //
     /* 174106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174112 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174128 */   // (st f64:{ *:[f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 174131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174136 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174155 */   GIR_RootConstrainSelectedInstOperands,
     /* 174156 */   // GIR_Coverage, 3898,
     /* 174156 */   GIR_EraseRootFromParent_Done,
     /* 174157 */ // Label 2652: @174157
     /* 174157 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(174215), // Rule ID 4007 //
     /* 174162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 174175 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174191 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 174194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174199 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174213 */   GIR_RootConstrainSelectedInstOperands,
     /* 174214 */   // GIR_Coverage, 4007,
     /* 174214 */   GIR_EraseRootFromParent_Done,
     /* 174215 */ // Label 2653: @174215
     /* 174215 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(174266), // Rule ID 3893 //
     /* 174220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174226 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174231 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174242 */   // (st i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 174245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174250 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174264 */   GIR_RootConstrainSelectedInstOperands,
     /* 174265 */   // GIR_Coverage, 3893,
     /* 174265 */   GIR_EraseRootFromParent_Done,
     /* 174266 */ // Label 2654: @174266
     /* 174266 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(174317), // Rule ID 3897 //
     /* 174271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174277 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174293 */   // (st f64:{ *:[f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 174296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174301 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174315 */   GIR_RootConstrainSelectedInstOperands,
     /* 174316 */   // GIR_Coverage, 3897,
     /* 174316 */   GIR_EraseRootFromParent_Done,
     /* 174317 */ // Label 2655: @174317
     /* 174317 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(174376), // Rule ID 3660 //
     /* 174322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174325 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174328 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 174335 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174345 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174352 */   // (atomic_store i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174360 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174374 */   GIR_RootConstrainSelectedInstOperands,
     /* 174375 */   // GIR_Coverage, 3660,
     /* 174375 */   GIR_EraseRootFromParent_Done,
     /* 174376 */ // Label 2656: @174376
     /* 174376 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(174428), // Rule ID 3628 //
     /* 174381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174387 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174404 */   // (st i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174412 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174426 */   GIR_RootConstrainSelectedInstOperands,
     /* 174427 */   // GIR_Coverage, 3628,
     /* 174427 */   GIR_EraseRootFromParent_Done,
     /* 174428 */ // Label 2657: @174428
     /* 174428 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(174480), // Rule ID 3630 //
     /* 174433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174439 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174456 */   // (st f64:{ *:[f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174464 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174478 */   GIR_RootConstrainSelectedInstOperands,
     /* 174479 */   // GIR_Coverage, 3630,
     /* 174479 */   GIR_EraseRootFromParent_Done,
     /* 174480 */ // Label 2658: @174480
     /* 174480 */ GIM_Reject,
     /* 174481 */ // Label 2318: @174481
     /* 174481 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(176212),
     /* 174486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174489 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(174545), // Rule ID 6609 //
     /* 174494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 174497 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174513 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 174516 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174543 */     GIR_RootConstrainSelectedInstOperands,
     /* 174544 */     // GIR_Coverage, 6609,
     /* 174544 */     GIR_EraseRootFromParent_Done,
     /* 174545 */   // Label 2660: @174545
     /* 174545 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(174601), // Rule ID 6611 //
     /* 174550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 174553 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174569 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 174572 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174599 */     GIR_RootConstrainSelectedInstOperands,
     /* 174600 */     // GIR_Coverage, 6611,
     /* 174600 */     GIR_EraseRootFromParent_Done,
     /* 174601 */   // Label 2661: @174601
     /* 174601 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(174657), // Rule ID 6613 //
     /* 174606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 174609 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174625 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 174628 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174655 */     GIR_RootConstrainSelectedInstOperands,
     /* 174656 */     // GIR_Coverage, 6613,
     /* 174656 */     GIR_EraseRootFromParent_Done,
     /* 174657 */   // Label 2662: @174657
     /* 174657 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(174713), // Rule ID 6615 //
     /* 174662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 174665 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174681 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 174684 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174711 */     GIR_RootConstrainSelectedInstOperands,
     /* 174712 */     // GIR_Coverage, 6615,
     /* 174712 */     GIR_EraseRootFromParent_Done,
     /* 174713 */   // Label 2663: @174713
     /* 174713 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(174766), // Rule ID 4260 //
     /* 174718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 174721 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 174737 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 174740 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 174752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174764 */     GIR_RootConstrainSelectedInstOperands,
     /* 174765 */     // GIR_Coverage, 4260,
     /* 174765 */     GIR_EraseRootFromParent_Done,
     /* 174766 */   // Label 2664: @174766
     /* 174766 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(174819), // Rule ID 4266 //
     /* 174771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 174774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 174790 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 174793 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 174805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174817 */     GIR_RootConstrainSelectedInstOperands,
     /* 174818 */     // GIR_Coverage, 4266,
     /* 174818 */     GIR_EraseRootFromParent_Done,
     /* 174819 */   // Label 2665: @174819
     /* 174819 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(174867), // Rule ID 4259 //
     /* 174824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174827 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 174843 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 174846 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174865 */     GIR_RootConstrainSelectedInstOperands,
     /* 174866 */     // GIR_Coverage, 4259,
     /* 174866 */     GIR_EraseRootFromParent_Done,
     /* 174867 */   // Label 2666: @174867
     /* 174867 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(174915), // Rule ID 4265 //
     /* 174872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174875 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 174891 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 174894 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174913 */     GIR_RootConstrainSelectedInstOperands,
     /* 174914 */     // GIR_Coverage, 4265,
     /* 174914 */     GIR_EraseRootFromParent_Done,
     /* 174915 */   // Label 2667: @174915
     /* 174915 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(174963), // Rule ID 4258 //
     /* 174920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174923 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 174939 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 174939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 174942 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174961 */     GIR_RootConstrainSelectedInstOperands,
     /* 174962 */     // GIR_Coverage, 4258,
     /* 174962 */     GIR_EraseRootFromParent_Done,
     /* 174963 */   // Label 2668: @174963
     /* 174963 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(175011), // Rule ID 4264 //
     /* 174968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 174987 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 174987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 174990 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175009 */     GIR_RootConstrainSelectedInstOperands,
     /* 175010 */     // GIR_Coverage, 4264,
     /* 175010 */     GIR_EraseRootFromParent_Done,
     /* 175011 */   // Label 2669: @175011
     /* 175011 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(175072), // Rule ID 4609 //
     /* 175016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175019 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 175035 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 175038 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175070 */     GIR_RootConstrainSelectedInstOperands,
     /* 175071 */     // GIR_Coverage, 4609,
     /* 175071 */     GIR_EraseRootFromParent_Done,
     /* 175072 */   // Label 2670: @175072
     /* 175072 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(175130), // Rule ID 4611 //
     /* 175077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 175093 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 175096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175128 */     GIR_RootConstrainSelectedInstOperands,
     /* 175129 */     // GIR_Coverage, 4611,
     /* 175129 */     GIR_EraseRootFromParent_Done,
     /* 175130 */   // Label 2671: @175130
     /* 175130 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(175191), // Rule ID 4613 //
     /* 175135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175138 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 175154 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 175157 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175189 */     GIR_RootConstrainSelectedInstOperands,
     /* 175190 */     // GIR_Coverage, 4613,
     /* 175190 */     GIR_EraseRootFromParent_Done,
     /* 175191 */   // Label 2672: @175191
     /* 175191 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(175249), // Rule ID 4615 //
     /* 175196 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 175212 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 175215 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175247 */     GIR_RootConstrainSelectedInstOperands,
     /* 175248 */     // GIR_Coverage, 4615,
     /* 175248 */     GIR_EraseRootFromParent_Done,
     /* 175249 */   // Label 2673: @175249
     /* 175249 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(175310), // Rule ID 6608 //
     /* 175254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 175257 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175273 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 175276 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175308 */     GIR_RootConstrainSelectedInstOperands,
     /* 175309 */     // GIR_Coverage, 6608,
     /* 175309 */     GIR_EraseRootFromParent_Done,
     /* 175310 */   // Label 2674: @175310
     /* 175310 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(175371), // Rule ID 6610 //
     /* 175315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 175318 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175334 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 175337 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175369 */     GIR_RootConstrainSelectedInstOperands,
     /* 175370 */     // GIR_Coverage, 6610,
     /* 175370 */     GIR_EraseRootFromParent_Done,
     /* 175371 */   // Label 2675: @175371
     /* 175371 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(175432), // Rule ID 6612 //
     /* 175376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 175379 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175395 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 175398 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175430 */     GIR_RootConstrainSelectedInstOperands,
     /* 175431 */     // GIR_Coverage, 6612,
     /* 175431 */     GIR_EraseRootFromParent_Done,
     /* 175432 */   // Label 2676: @175432
     /* 175432 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(175493), // Rule ID 6614 //
     /* 175437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 175440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175456 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 175459 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175491 */     GIR_RootConstrainSelectedInstOperands,
     /* 175492 */     // GIR_Coverage, 6614,
     /* 175492 */     GIR_EraseRootFromParent_Done,
     /* 175493 */   // Label 2677: @175493
     /* 175493 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(175549), // Rule ID 4608 //
     /* 175498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175501 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175517 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 175520 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175547 */     GIR_RootConstrainSelectedInstOperands,
     /* 175548 */     // GIR_Coverage, 4608,
     /* 175548 */     GIR_EraseRootFromParent_Done,
     /* 175549 */   // Label 2678: @175549
     /* 175549 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(175602), // Rule ID 4610 //
     /* 175554 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175570 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 175573 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175600 */     GIR_RootConstrainSelectedInstOperands,
     /* 175601 */     // GIR_Coverage, 4610,
     /* 175601 */     GIR_EraseRootFromParent_Done,
     /* 175602 */   // Label 2679: @175602
     /* 175602 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(175658), // Rule ID 4612 //
     /* 175607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175610 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175626 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 175629 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175656 */     GIR_RootConstrainSelectedInstOperands,
     /* 175657 */     // GIR_Coverage, 4612,
     /* 175657 */     GIR_EraseRootFromParent_Done,
     /* 175658 */   // Label 2680: @175658
     /* 175658 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(175711), // Rule ID 4614 //
     /* 175663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175679 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 175682 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175709 */     GIR_RootConstrainSelectedInstOperands,
     /* 175710 */     // GIR_Coverage, 4614,
     /* 175710 */     GIR_EraseRootFromParent_Done,
     /* 175711 */   // Label 2681: @175711
     /* 175711 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(175763), // Rule ID 7903 //
     /* 175716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 175719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175723 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175739 */     // (AMDGPUst_glue v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 175742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175747 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175761 */     GIR_RootConstrainSelectedInstOperands,
     /* 175762 */     // GIR_Coverage, 7903,
     /* 175762 */     GIR_EraseRootFromParent_Done,
     /* 175763 */   // Label 2682: @175763
     /* 175763 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(175815), // Rule ID 7905 //
     /* 175768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 175771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175775 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175791 */     // (AMDGPUst_glue v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 175794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175799 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175813 */     GIR_RootConstrainSelectedInstOperands,
     /* 175814 */     // GIR_Coverage, 7905,
     /* 175814 */     GIR_EraseRootFromParent_Done,
     /* 175815 */   // Label 2683: @175815
     /* 175815 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(175863), // Rule ID 7904 //
     /* 175820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 175823 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175839 */     // (st v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 175842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175847 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175861 */     GIR_RootConstrainSelectedInstOperands,
     /* 175862 */     // GIR_Coverage, 7904,
     /* 175862 */     GIR_EraseRootFromParent_Done,
     /* 175863 */   // Label 2684: @175863
     /* 175863 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(175911), // Rule ID 7906 //
     /* 175868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 175871 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175887 */     // (st v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 175890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175895 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175909 */     GIR_RootConstrainSelectedInstOperands,
     /* 175910 */     // GIR_Coverage, 7906,
     /* 175910 */     GIR_EraseRootFromParent_Done,
     /* 175911 */   // Label 2685: @175911
     /* 175911 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(175964), // Rule ID 3870 //
     /* 175916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 175935 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 175935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 175938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 175943 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 175950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175962 */     GIR_RootConstrainSelectedInstOperands,
     /* 175963 */     // GIR_Coverage, 3870,
     /* 175963 */     GIR_EraseRootFromParent_Done,
     /* 175964 */   // Label 2686: @175964
     /* 175964 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(176017), // Rule ID 3874 //
     /* 175969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175972 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 175988 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 175988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 175991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 175996 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176015 */     GIR_RootConstrainSelectedInstOperands,
     /* 176016 */     // GIR_Coverage, 3874,
     /* 176016 */     GIR_EraseRootFromParent_Done,
     /* 176017 */   // Label 2687: @176017
     /* 176017 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(176065), // Rule ID 3869 //
     /* 176022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 176025 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 176041 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 176041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 176044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176049 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176063 */     GIR_RootConstrainSelectedInstOperands,
     /* 176064 */     // GIR_Coverage, 3869,
     /* 176064 */     GIR_EraseRootFromParent_Done,
     /* 176065 */   // Label 2688: @176065
     /* 176065 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(176113), // Rule ID 3873 //
     /* 176070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 176073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 176089 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 176089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 176092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176097 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176111 */     GIR_RootConstrainSelectedInstOperands,
     /* 176112 */     // GIR_Coverage, 3873,
     /* 176112 */     GIR_EraseRootFromParent_Done,
     /* 176113 */   // Label 2689: @176113
     /* 176113 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(176162), // Rule ID 3617 //
     /* 176118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 176121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 176127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 176138 */     // (st v2i16:{ *:[v2i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 176138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 176141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176146 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176160 */     GIR_RootConstrainSelectedInstOperands,
     /* 176161 */     // GIR_Coverage, 3617,
     /* 176161 */     GIR_EraseRootFromParent_Done,
     /* 176162 */   // Label 2690: @176162
     /* 176162 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(176211), // Rule ID 3619 //
     /* 176167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 176170 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 176176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 176187 */     // (st v2f16:{ *:[v2f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 176187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 176190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176195 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176209 */     GIR_RootConstrainSelectedInstOperands,
     /* 176210 */     // GIR_Coverage, 3619,
     /* 176210 */     GIR_EraseRootFromParent_Done,
     /* 176211 */   // Label 2691: @176211
     /* 176211 */   GIM_Reject,
     /* 176212 */ // Label 2659: @176212
     /* 176212 */ GIM_Reject,
     /* 176213 */ // Label 2319: @176213
     /* 176213 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(178422),
     /* 176218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176221 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(176282), // Rule ID 8071 //
     /* 176226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 176229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176233 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 176251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176258 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176266 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176280 */     GIR_RootConstrainSelectedInstOperands,
     /* 176281 */     // GIR_Coverage, 8071,
     /* 176281 */     GIR_EraseRootFromParent_Done,
     /* 176282 */   // Label 2693: @176282
     /* 176282 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(176343), // Rule ID 8075 //
     /* 176287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 176290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176294 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 176312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176319 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176327 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176341 */     GIR_RootConstrainSelectedInstOperands,
     /* 176342 */     // GIR_Coverage, 8075,
     /* 176342 */     GIR_EraseRootFromParent_Done,
     /* 176343 */   // Label 2694: @176343
     /* 176343 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(176399), // Rule ID 8003 //
     /* 176348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 176351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176355 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176360 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176375 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176383 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176397 */     GIR_RootConstrainSelectedInstOperands,
     /* 176398 */     // GIR_Coverage, 8003,
     /* 176398 */     GIR_EraseRootFromParent_Done,
     /* 176399 */   // Label 2695: @176399
     /* 176399 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(176455), // Rule ID 8007 //
     /* 176404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 176407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176411 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176416 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176431 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176439 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176453 */     GIR_RootConstrainSelectedInstOperands,
     /* 176454 */     // GIR_Coverage, 8007,
     /* 176454 */     GIR_EraseRootFromParent_Done,
     /* 176455 */   // Label 2696: @176455
     /* 176455 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(176512), // Rule ID 8072 //
     /* 176460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176463 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176468 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176488 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176496 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176510 */     GIR_RootConstrainSelectedInstOperands,
     /* 176511 */     // GIR_Coverage, 8072,
     /* 176511 */     GIR_EraseRootFromParent_Done,
     /* 176512 */   // Label 2697: @176512
     /* 176512 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(176569), // Rule ID 8076 //
     /* 176517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176525 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176545 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176553 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176567 */     GIR_RootConstrainSelectedInstOperands,
     /* 176568 */     // GIR_Coverage, 8076,
     /* 176568 */     GIR_EraseRootFromParent_Done,
     /* 176569 */   // Label 2698: @176569
     /* 176569 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(176621), // Rule ID 8004 //
     /* 176574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176577 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176582 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176597 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176605 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176619 */     GIR_RootConstrainSelectedInstOperands,
     /* 176620 */     // GIR_Coverage, 8004,
     /* 176620 */     GIR_EraseRootFromParent_Done,
     /* 176621 */   // Label 2699: @176621
     /* 176621 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(176673), // Rule ID 8008 //
     /* 176626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176629 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176634 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176649 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176657 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176671 */     GIR_RootConstrainSelectedInstOperands,
     /* 176672 */     // GIR_Coverage, 8008,
     /* 176672 */     GIR_EraseRootFromParent_Done,
     /* 176673 */   // Label 2700: @176673
     /* 176673 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(176729), // Rule ID 6633 //
     /* 176678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 176681 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 176697 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 176697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 176700 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 176712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176727 */     GIR_RootConstrainSelectedInstOperands,
     /* 176728 */     // GIR_Coverage, 6633,
     /* 176728 */     GIR_EraseRootFromParent_Done,
     /* 176729 */   // Label 2701: @176729
     /* 176729 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(176785), // Rule ID 6635 //
     /* 176734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 176737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 176753 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 176753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 176756 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 176768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176783 */     GIR_RootConstrainSelectedInstOperands,
     /* 176784 */     // GIR_Coverage, 6635,
     /* 176784 */     GIR_EraseRootFromParent_Done,
     /* 176785 */   // Label 2702: @176785
     /* 176785 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(176838), // Rule ID 4308 //
     /* 176790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176809 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176812 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176836 */     GIR_RootConstrainSelectedInstOperands,
     /* 176837 */     // GIR_Coverage, 4308,
     /* 176837 */     GIR_EraseRootFromParent_Done,
     /* 176838 */   // Label 2703: @176838
     /* 176838 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(176891), // Rule ID 4314 //
     /* 176843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176862 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176865 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176889 */     GIR_RootConstrainSelectedInstOperands,
     /* 176890 */     // GIR_Coverage, 4314,
     /* 176890 */     GIR_EraseRootFromParent_Done,
     /* 176891 */   // Label 2704: @176891
     /* 176891 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(176939), // Rule ID 4307 //
     /* 176896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176899 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176915 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176918 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176937 */     GIR_RootConstrainSelectedInstOperands,
     /* 176938 */     // GIR_Coverage, 4307,
     /* 176938 */     GIR_EraseRootFromParent_Done,
     /* 176939 */   // Label 2705: @176939
     /* 176939 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(176987), // Rule ID 4313 //
     /* 176944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176963 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176966 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176985 */     GIR_RootConstrainSelectedInstOperands,
     /* 176986 */     // GIR_Coverage, 4313,
     /* 176986 */     GIR_EraseRootFromParent_Done,
     /* 176987 */   // Label 2706: @176987
     /* 176987 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(177035), // Rule ID 4306 //
     /* 176992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176995 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 177011 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 177011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 177014 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 177021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 177026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177033 */     GIR_RootConstrainSelectedInstOperands,
     /* 177034 */     // GIR_Coverage, 4306,
     /* 177034 */     GIR_EraseRootFromParent_Done,
     /* 177035 */   // Label 2707: @177035
     /* 177035 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(177083), // Rule ID 4312 //
     /* 177040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 177043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 177059 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 177059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 177062 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 177069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 177074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177081 */     GIR_RootConstrainSelectedInstOperands,
     /* 177082 */     // GIR_Coverage, 4312,
     /* 177082 */     GIR_EraseRootFromParent_Done,
     /* 177083 */   // Label 2708: @177083
     /* 177083 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(177144), // Rule ID 4641 //
     /* 177088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 177107 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 177110 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177142 */     GIR_RootConstrainSelectedInstOperands,
     /* 177143 */     // GIR_Coverage, 4641,
     /* 177143 */     GIR_EraseRootFromParent_Done,
     /* 177144 */   // Label 2709: @177144
     /* 177144 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(177202), // Rule ID 4643 //
     /* 177149 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 177165 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 177168 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177200 */     GIR_RootConstrainSelectedInstOperands,
     /* 177201 */     // GIR_Coverage, 4643,
     /* 177201 */     GIR_EraseRootFromParent_Done,
     /* 177202 */   // Label 2710: @177202
     /* 177202 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(177263), // Rule ID 4645 //
     /* 177207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177210 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 177226 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 177229 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177261 */     GIR_RootConstrainSelectedInstOperands,
     /* 177262 */     // GIR_Coverage, 4645,
     /* 177262 */     GIR_EraseRootFromParent_Done,
     /* 177263 */   // Label 2711: @177263
     /* 177263 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(177321), // Rule ID 4647 //
     /* 177268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 177284 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 177287 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177319 */     GIR_RootConstrainSelectedInstOperands,
     /* 177320 */     // GIR_Coverage, 4647,
     /* 177320 */     GIR_EraseRootFromParent_Done,
     /* 177321 */   // Label 2712: @177321
     /* 177321 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(177382), // Rule ID 6632 //
     /* 177326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 177329 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 177345 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 177345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN),
     /* 177348 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177380 */     GIR_RootConstrainSelectedInstOperands,
     /* 177381 */     // GIR_Coverage, 6632,
     /* 177381 */     GIR_EraseRootFromParent_Done,
     /* 177382 */   // Label 2713: @177382
     /* 177382 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(177443), // Rule ID 6634 //
     /* 177387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 177390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 177406 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 177406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN),
     /* 177409 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177441 */     GIR_RootConstrainSelectedInstOperands,
     /* 177442 */     // GIR_Coverage, 6634,
     /* 177442 */     GIR_EraseRootFromParent_Done,
     /* 177443 */   // Label 2714: @177443
     /* 177443 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(177560), // Rule ID 7946 //
     /* 177448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 177451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 177455 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177471 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177483 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177558 */     GIR_RootConstrainSelectedInstOperands,
     /* 177559 */     // GIR_Coverage, 7946,
     /* 177559 */     GIR_EraseRootFromParent_Done,
     /* 177560 */   // Label 2715: @177560
     /* 177560 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(177677), // Rule ID 7950 //
     /* 177565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 177568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 177572 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177588 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177600 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177628 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177675 */     GIR_RootConstrainSelectedInstOperands,
     /* 177676 */     // GIR_Coverage, 7950,
     /* 177676 */     GIR_EraseRootFromParent_Done,
     /* 177677 */   // Label 2716: @177677
     /* 177677 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(177733), // Rule ID 4640 //
     /* 177682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177685 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177701 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177704 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177731 */     GIR_RootConstrainSelectedInstOperands,
     /* 177732 */     // GIR_Coverage, 4640,
     /* 177732 */     GIR_EraseRootFromParent_Done,
     /* 177733 */   // Label 2717: @177733
     /* 177733 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(177786), // Rule ID 4642 //
     /* 177738 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177754 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177757 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177784 */     GIR_RootConstrainSelectedInstOperands,
     /* 177785 */     // GIR_Coverage, 4642,
     /* 177785 */     GIR_EraseRootFromParent_Done,
     /* 177786 */   // Label 2718: @177786
     /* 177786 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(177842), // Rule ID 4644 //
     /* 177791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177794 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177810 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177813 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177840 */     GIR_RootConstrainSelectedInstOperands,
     /* 177841 */     // GIR_Coverage, 4644,
     /* 177841 */     GIR_EraseRootFromParent_Done,
     /* 177842 */   // Label 2719: @177842
     /* 177842 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(177895), // Rule ID 4646 //
     /* 177847 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177863 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177866 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177893 */     GIR_RootConstrainSelectedInstOperands,
     /* 177894 */     // GIR_Coverage, 4646,
     /* 177894 */     GIR_EraseRootFromParent_Done,
     /* 177895 */   // Label 2720: @177895
     /* 177895 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(178008), // Rule ID 7948 //
     /* 177900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177903 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177919 */     // (st v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177931 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 177978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 178007 */     // GIR_Coverage, 7948,
     /* 178007 */     GIR_EraseRootFromParent_Done,
     /* 178008 */   // Label 2721: @178008
     /* 178008 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(178121), // Rule ID 7952 //
     /* 178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 178016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 178032 */     // (st v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 178032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 178035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178044 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 178050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 178055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 178060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 178078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 178083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 178088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 178091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 178102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 178107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 178112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178119 */     GIR_RootConstrainSelectedInstOperands,
     /* 178120 */     // GIR_Coverage, 7952,
     /* 178120 */     GIR_EraseRootFromParent_Done,
     /* 178121 */   // Label 2722: @178121
     /* 178121 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(178174), // Rule ID 3902 //
     /* 178126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 178145 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 178148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 178153 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178172 */     GIR_RootConstrainSelectedInstOperands,
     /* 178173 */     // GIR_Coverage, 3902,
     /* 178173 */     GIR_EraseRootFromParent_Done,
     /* 178174 */   // Label 2723: @178174
     /* 178174 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(178227), // Rule ID 3906 //
     /* 178179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 178198 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 178201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 178206 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178225 */     GIR_RootConstrainSelectedInstOperands,
     /* 178226 */     // GIR_Coverage, 3906,
     /* 178226 */     GIR_EraseRootFromParent_Done,
     /* 178227 */   // Label 2724: @178227
     /* 178227 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(178275), // Rule ID 3901 //
     /* 178232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178235 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178251 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178259 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178273 */     GIR_RootConstrainSelectedInstOperands,
     /* 178274 */     // GIR_Coverage, 3901,
     /* 178274 */     GIR_EraseRootFromParent_Done,
     /* 178275 */   // Label 2725: @178275
     /* 178275 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(178323), // Rule ID 3905 //
     /* 178280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178283 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178299 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178307 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178321 */     GIR_RootConstrainSelectedInstOperands,
     /* 178322 */     // GIR_Coverage, 3905,
     /* 178322 */     GIR_EraseRootFromParent_Done,
     /* 178323 */   // Label 2726: @178323
     /* 178323 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(178372), // Rule ID 3632 //
     /* 178328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178331 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178348 */     // (st v2i32:{ *:[v2i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178356 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178370 */     GIR_RootConstrainSelectedInstOperands,
     /* 178371 */     // GIR_Coverage, 3632,
     /* 178371 */     GIR_EraseRootFromParent_Done,
     /* 178372 */   // Label 2727: @178372
     /* 178372 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(178421), // Rule ID 3634 //
     /* 178377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178380 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178397 */     // (st v2f32:{ *:[v2f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178405 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178419 */     GIR_RootConstrainSelectedInstOperands,
     /* 178420 */     // GIR_Coverage, 3634,
     /* 178420 */     GIR_EraseRootFromParent_Done,
     /* 178421 */   // Label 2728: @178421
     /* 178421 */   GIM_Reject,
     /* 178422 */ // Label 2692: @178422
     /* 178422 */ GIM_Reject,
     /* 178423 */ // Label 2320: @178423
     /* 178423 */ GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(180398),
     /* 178428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178431 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(178487), // Rule ID 8047 //
     /* 178436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 178439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178443 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178448 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178463 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178471 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178485 */     GIR_RootConstrainSelectedInstOperands,
     /* 178486 */     // GIR_Coverage, 8047,
     /* 178486 */     GIR_EraseRootFromParent_Done,
     /* 178487 */   // Label 2730: @178487
     /* 178487 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(178543), // Rule ID 8051 //
     /* 178492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 178495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178499 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178504 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178519 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178527 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178541 */     GIR_RootConstrainSelectedInstOperands,
     /* 178542 */     // GIR_Coverage, 8051,
     /* 178542 */     GIR_EraseRootFromParent_Done,
     /* 178543 */   // Label 2731: @178543
     /* 178543 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(178604), // Rule ID 8115 //
     /* 178548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 178551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178555 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 178573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178580 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178588 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178602 */     GIR_RootConstrainSelectedInstOperands,
     /* 178603 */     // GIR_Coverage, 8115,
     /* 178603 */     GIR_EraseRootFromParent_Done,
     /* 178604 */   // Label 2732: @178604
     /* 178604 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(178665), // Rule ID 8119 //
     /* 178609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 178612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178621 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 178634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178641 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178649 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178663 */     GIR_RootConstrainSelectedInstOperands,
     /* 178664 */     // GIR_Coverage, 8119,
     /* 178664 */     GIR_EraseRootFromParent_Done,
     /* 178665 */   // Label 2733: @178665
     /* 178665 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(178717), // Rule ID 8048 //
     /* 178670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 178673 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178678 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178693 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178701 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178715 */     GIR_RootConstrainSelectedInstOperands,
     /* 178716 */     // GIR_Coverage, 8048,
     /* 178716 */     GIR_EraseRootFromParent_Done,
     /* 178717 */   // Label 2734: @178717
     /* 178717 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(178769), // Rule ID 8052 //
     /* 178722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 178725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178730 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178745 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178753 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178767 */     GIR_RootConstrainSelectedInstOperands,
     /* 178768 */     // GIR_Coverage, 8052,
     /* 178768 */     GIR_EraseRootFromParent_Done,
     /* 178769 */   // Label 2735: @178769
     /* 178769 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(178826), // Rule ID 8116 //
     /* 178774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 178777 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178782 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 178795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178802 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178810 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178824 */     GIR_RootConstrainSelectedInstOperands,
     /* 178825 */     // GIR_Coverage, 8116,
     /* 178825 */     GIR_EraseRootFromParent_Done,
     /* 178826 */   // Label 2736: @178826
     /* 178826 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(178883), // Rule ID 8120 //
     /* 178831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 178834 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 178852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178859 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178867 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178881 */     GIR_RootConstrainSelectedInstOperands,
     /* 178882 */     // GIR_Coverage, 8120,
     /* 178882 */     GIR_EraseRootFromParent_Done,
     /* 178883 */   // Label 2737: @178883
     /* 178883 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(178936), // Rule ID 4365 //
     /* 178888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178891 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178907 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 178910 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178934 */     GIR_RootConstrainSelectedInstOperands,
     /* 178935 */     // GIR_Coverage, 4365,
     /* 178935 */     GIR_EraseRootFromParent_Done,
     /* 178936 */   // Label 2738: @178936
     /* 178936 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(178989), // Rule ID 4371 //
     /* 178941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178944 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178960 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 178963 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178987 */     GIR_RootConstrainSelectedInstOperands,
     /* 178988 */     // GIR_Coverage, 4371,
     /* 178988 */     GIR_EraseRootFromParent_Done,
     /* 178989 */   // Label 2739: @178989
     /* 178989 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(179037), // Rule ID 4364 //
     /* 178994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178997 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 179013 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 179016 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179035 */     GIR_RootConstrainSelectedInstOperands,
     /* 179036 */     // GIR_Coverage, 4364,
     /* 179036 */     GIR_EraseRootFromParent_Done,
     /* 179037 */   // Label 2740: @179037
     /* 179037 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(179085), // Rule ID 4370 //
     /* 179042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 179045 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 179061 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 179064 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179083 */     GIR_RootConstrainSelectedInstOperands,
     /* 179084 */     // GIR_Coverage, 4370,
     /* 179084 */     GIR_EraseRootFromParent_Done,
     /* 179085 */   // Label 2741: @179085
     /* 179085 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(179133), // Rule ID 4363 //
     /* 179090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 179093 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 179109 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 179109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 179112 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179131 */     GIR_RootConstrainSelectedInstOperands,
     /* 179132 */     // GIR_Coverage, 4363,
     /* 179132 */     GIR_EraseRootFromParent_Done,
     /* 179133 */   // Label 2742: @179133
     /* 179133 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(179181), // Rule ID 4369 //
     /* 179138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 179141 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 179157 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 179157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 179160 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179179 */     GIR_RootConstrainSelectedInstOperands,
     /* 179180 */     // GIR_Coverage, 4369,
     /* 179180 */     GIR_EraseRootFromParent_Done,
     /* 179181 */   // Label 2743: @179181
     /* 179181 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(179242), // Rule ID 4685 //
     /* 179186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179189 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179205 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 179208 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179240 */     GIR_RootConstrainSelectedInstOperands,
     /* 179241 */     // GIR_Coverage, 4685,
     /* 179241 */     GIR_EraseRootFromParent_Done,
     /* 179242 */   // Label 2744: @179242
     /* 179242 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(179300), // Rule ID 4687 //
     /* 179247 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179263 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 179266 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179298 */     GIR_RootConstrainSelectedInstOperands,
     /* 179299 */     // GIR_Coverage, 4687,
     /* 179299 */     GIR_EraseRootFromParent_Done,
     /* 179300 */   // Label 2745: @179300
     /* 179300 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(179361), // Rule ID 4689 //
     /* 179305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179324 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 179327 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179359 */     GIR_RootConstrainSelectedInstOperands,
     /* 179360 */     // GIR_Coverage, 4689,
     /* 179360 */     GIR_EraseRootFromParent_Done,
     /* 179361 */   // Label 2746: @179361
     /* 179361 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(179419), // Rule ID 4691 //
     /* 179366 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179382 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 179385 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179417 */     GIR_RootConstrainSelectedInstOperands,
     /* 179418 */     // GIR_Coverage, 4691,
     /* 179418 */     GIR_EraseRootFromParent_Done,
     /* 179419 */   // Label 2747: @179419
     /* 179419 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(179536), // Rule ID 7978 //
     /* 179424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 179427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179447 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179459 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179487 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 179506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179534 */     GIR_RootConstrainSelectedInstOperands,
     /* 179535 */     // GIR_Coverage, 7978,
     /* 179535 */     GIR_EraseRootFromParent_Done,
     /* 179536 */   // Label 2748: @179536
     /* 179536 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(179653), // Rule ID 7982 //
     /* 179541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 179544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179548 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179564 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179564 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179567 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179571 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179576 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179604 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 179623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179651 */     GIR_RootConstrainSelectedInstOperands,
     /* 179652 */     // GIR_Coverage, 7982,
     /* 179652 */     GIR_EraseRootFromParent_Done,
     /* 179653 */   // Label 2749: @179653
     /* 179653 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(179709), // Rule ID 4684 //
     /* 179658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179661 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179677 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 179680 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179707 */     GIR_RootConstrainSelectedInstOperands,
     /* 179708 */     // GIR_Coverage, 4684,
     /* 179708 */     GIR_EraseRootFromParent_Done,
     /* 179709 */   // Label 2750: @179709
     /* 179709 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(179762), // Rule ID 4686 //
     /* 179714 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179730 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 179733 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179760 */     GIR_RootConstrainSelectedInstOperands,
     /* 179761 */     // GIR_Coverage, 4686,
     /* 179761 */     GIR_EraseRootFromParent_Done,
     /* 179762 */   // Label 2751: @179762
     /* 179762 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(179818), // Rule ID 4688 //
     /* 179767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179770 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179786 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 179789 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179816 */     GIR_RootConstrainSelectedInstOperands,
     /* 179817 */     // GIR_Coverage, 4688,
     /* 179817 */     GIR_EraseRootFromParent_Done,
     /* 179818 */   // Label 2752: @179818
     /* 179818 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(179871), // Rule ID 4690 //
     /* 179823 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179839 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 179842 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179869 */     GIR_RootConstrainSelectedInstOperands,
     /* 179870 */     // GIR_Coverage, 4690,
     /* 179870 */     GIR_EraseRootFromParent_Done,
     /* 179871 */   // Label 2753: @179871
     /* 179871 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(179984), // Rule ID 7980 //
     /* 179876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179879 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179895 */     // (st v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179907 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179935 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 179954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179982 */     GIR_RootConstrainSelectedInstOperands,
     /* 179983 */     // GIR_Coverage, 7980,
     /* 179983 */     GIR_EraseRootFromParent_Done,
     /* 179984 */   // Label 2754: @179984
     /* 179984 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(180097), // Rule ID 7984 //
     /* 179989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 180008 */     // (st v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 180008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 180011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180020 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 180026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 180031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 180036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 180039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180048 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 180054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 180059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 180064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 180067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 180078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 180083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 180088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180095 */     GIR_RootConstrainSelectedInstOperands,
     /* 180096 */     // GIR_Coverage, 7984,
     /* 180096 */     GIR_EraseRootFromParent_Done,
     /* 180097 */   // Label 2755: @180097
     /* 180097 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(180150), // Rule ID 3940 //
     /* 180102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 180105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 180121 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 180124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 180129 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 180136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180148 */     GIR_RootConstrainSelectedInstOperands,
     /* 180149 */     // GIR_Coverage, 3940,
     /* 180149 */     GIR_EraseRootFromParent_Done,
     /* 180150 */   // Label 2756: @180150
     /* 180150 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(180203), // Rule ID 3944 //
     /* 180155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 180158 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 180174 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 180177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 180182 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 180189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180201 */     GIR_RootConstrainSelectedInstOperands,
     /* 180202 */     // GIR_Coverage, 3944,
     /* 180202 */     GIR_EraseRootFromParent_Done,
     /* 180203 */   // Label 2757: @180203
     /* 180203 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(180251), // Rule ID 3939 //
     /* 180208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 180211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 180227 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 180230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180235 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180249 */     GIR_RootConstrainSelectedInstOperands,
     /* 180250 */     // GIR_Coverage, 3939,
     /* 180250 */     GIR_EraseRootFromParent_Done,
     /* 180251 */   // Label 2758: @180251
     /* 180251 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(180299), // Rule ID 3943 //
     /* 180256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 180259 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 180275 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 180278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180283 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180297 */     GIR_RootConstrainSelectedInstOperands,
     /* 180298 */     // GIR_Coverage, 3943,
     /* 180298 */     GIR_EraseRootFromParent_Done,
     /* 180299 */   // Label 2759: @180299
     /* 180299 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(180348), // Rule ID 3652 //
     /* 180304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 180307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 180313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 180324 */     // (st v2i64:{ *:[v2i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 180327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180332 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180346 */     GIR_RootConstrainSelectedInstOperands,
     /* 180347 */     // GIR_Coverage, 3652,
     /* 180347 */     GIR_EraseRootFromParent_Done,
     /* 180348 */   // Label 2760: @180348
     /* 180348 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(180397), // Rule ID 3654 //
     /* 180353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 180356 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 180362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 180373 */     // (st v2f64:{ *:[v2f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 180376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180381 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180395 */     GIR_RootConstrainSelectedInstOperands,
     /* 180396 */     // GIR_Coverage, 3654,
     /* 180396 */     GIR_EraseRootFromParent_Done,
     /* 180397 */   // Label 2761: @180397
     /* 180397 */   GIM_Reject,
     /* 180398 */ // Label 2729: @180398
     /* 180398 */ GIM_Reject,
     /* 180399 */ // Label 2321: @180399
     /* 180399 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(181813),
     /* 180404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180407 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(180463), // Rule ID 8031 //
     /* 180412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 180415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180419 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180424 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180439 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180447 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180461 */     GIR_RootConstrainSelectedInstOperands,
     /* 180462 */     // GIR_Coverage, 8031,
     /* 180462 */     GIR_EraseRootFromParent_Done,
     /* 180463 */   // Label 2763: @180463
     /* 180463 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(180519), // Rule ID 8035 //
     /* 180468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 180471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180475 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180480 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180495 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180503 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180517 */     GIR_RootConstrainSelectedInstOperands,
     /* 180518 */     // GIR_Coverage, 8035,
     /* 180518 */     GIR_EraseRootFromParent_Done,
     /* 180519 */   // Label 2764: @180519
     /* 180519 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(180571), // Rule ID 8099 //
     /* 180524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 180527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180547 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180555 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180569 */     GIR_RootConstrainSelectedInstOperands,
     /* 180570 */     // GIR_Coverage, 8099,
     /* 180570 */     GIR_EraseRootFromParent_Done,
     /* 180571 */   // Label 2765: @180571
     /* 180571 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(180623), // Rule ID 8103 //
     /* 180576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 180579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180583 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180599 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180607 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180621 */     GIR_RootConstrainSelectedInstOperands,
     /* 180622 */     // GIR_Coverage, 8103,
     /* 180622 */     GIR_EraseRootFromParent_Done,
     /* 180623 */   // Label 2766: @180623
     /* 180623 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(180675), // Rule ID 8032 //
     /* 180628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 180631 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180636 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180651 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180659 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180673 */     GIR_RootConstrainSelectedInstOperands,
     /* 180674 */     // GIR_Coverage, 8032,
     /* 180674 */     GIR_EraseRootFromParent_Done,
     /* 180675 */   // Label 2767: @180675
     /* 180675 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(180727), // Rule ID 8036 //
     /* 180680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 180683 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180688 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180703 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180711 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180725 */     GIR_RootConstrainSelectedInstOperands,
     /* 180726 */     // GIR_Coverage, 8036,
     /* 180726 */     GIR_EraseRootFromParent_Done,
     /* 180727 */   // Label 2768: @180727
     /* 180727 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(180775), // Rule ID 8100 //
     /* 180732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180751 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180759 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180773 */     GIR_RootConstrainSelectedInstOperands,
     /* 180774 */     // GIR_Coverage, 8100,
     /* 180774 */     GIR_EraseRootFromParent_Done,
     /* 180775 */   // Label 2769: @180775
     /* 180775 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(180823), // Rule ID 8104 //
     /* 180780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180799 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9785:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180807 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180821 */     GIR_RootConstrainSelectedInstOperands,
     /* 180822 */     // GIR_Coverage, 8104,
     /* 180822 */     GIR_EraseRootFromParent_Done,
     /* 180823 */   // Label 2770: @180823
     /* 180823 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(180879), // Rule ID 6637 //
     /* 180828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 180831 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180847 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 180850 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180877 */     GIR_RootConstrainSelectedInstOperands,
     /* 180878 */     // GIR_Coverage, 6637,
     /* 180878 */     GIR_EraseRootFromParent_Done,
     /* 180879 */   // Label 2771: @180879
     /* 180879 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(180935), // Rule ID 6639 //
     /* 180884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 180887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180903 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 180906 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180933 */     GIR_RootConstrainSelectedInstOperands,
     /* 180934 */     // GIR_Coverage, 6639,
     /* 180934 */     GIR_EraseRootFromParent_Done,
     /* 180935 */   // Label 2772: @180935
     /* 180935 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(180988), // Rule ID 4392 //
     /* 180940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 180943 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 180959 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SVS anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SVS),
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 180974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180986 */     GIR_RootConstrainSelectedInstOperands,
     /* 180987 */     // GIR_Coverage, 4392,
     /* 180987 */     GIR_EraseRootFromParent_Done,
     /* 180988 */   // Label 2773: @180988
     /* 180988 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(181036), // Rule ID 4391 //
     /* 180993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 181012 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SADDR anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 181012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SADDR),
     /* 181015 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 181022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181034 */     GIR_RootConstrainSelectedInstOperands,
     /* 181035 */     // GIR_Coverage, 4391,
     /* 181035 */     GIR_EraseRootFromParent_Done,
     /* 181036 */   // Label 2774: @181036
     /* 181036 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(181084), // Rule ID 4390 //
     /* 181041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 181044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 181060 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3 anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 181060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3),
     /* 181063 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 181070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181082 */     GIR_RootConstrainSelectedInstOperands,
     /* 181083 */     // GIR_Coverage, 4390,
     /* 181083 */     GIR_EraseRootFromParent_Done,
     /* 181084 */   // Label 2775: @181084
     /* 181084 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(181145), // Rule ID 4669 //
     /* 181089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181092 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181108 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 181111 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181143 */     GIR_RootConstrainSelectedInstOperands,
     /* 181144 */     // GIR_Coverage, 4669,
     /* 181144 */     GIR_EraseRootFromParent_Done,
     /* 181145 */   // Label 2776: @181145
     /* 181145 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(181203), // Rule ID 4671 //
     /* 181150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181166 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 181169 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181201 */     GIR_RootConstrainSelectedInstOperands,
     /* 181202 */     // GIR_Coverage, 4671,
     /* 181202 */     GIR_EraseRootFromParent_Done,
     /* 181203 */   // Label 2777: @181203
     /* 181203 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(181264), // Rule ID 4673 //
     /* 181208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181227 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 181230 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181262 */     GIR_RootConstrainSelectedInstOperands,
     /* 181263 */     // GIR_Coverage, 4673,
     /* 181263 */     GIR_EraseRootFromParent_Done,
     /* 181264 */   // Label 2778: @181264
     /* 181264 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(181322), // Rule ID 4675 //
     /* 181269 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181285 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 181288 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181320 */     GIR_RootConstrainSelectedInstOperands,
     /* 181321 */     // GIR_Coverage, 4675,
     /* 181321 */     GIR_EraseRootFromParent_Done,
     /* 181322 */   // Label 2779: @181322
     /* 181322 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(181383), // Rule ID 6636 //
     /* 181327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 181330 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181346 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN),
     /* 181349 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181381 */     GIR_RootConstrainSelectedInstOperands,
     /* 181382 */     // GIR_Coverage, 6636,
     /* 181382 */     GIR_EraseRootFromParent_Done,
     /* 181383 */   // Label 2780: @181383
     /* 181383 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(181444), // Rule ID 6638 //
     /* 181388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 181391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181407 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN),
     /* 181410 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181442 */     GIR_RootConstrainSelectedInstOperands,
     /* 181443 */     // GIR_Coverage, 6638,
     /* 181443 */     GIR_EraseRootFromParent_Done,
     /* 181444 */   // Label 2781: @181444
     /* 181444 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(181500), // Rule ID 4668 //
     /* 181449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181452 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181468 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 181471 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181498 */     GIR_RootConstrainSelectedInstOperands,
     /* 181499 */     // GIR_Coverage, 4668,
     /* 181499 */     GIR_EraseRootFromParent_Done,
     /* 181500 */   // Label 2782: @181500
     /* 181500 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(181553), // Rule ID 4670 //
     /* 181505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181521 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 181524 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181551 */     GIR_RootConstrainSelectedInstOperands,
     /* 181552 */     // GIR_Coverage, 4670,
     /* 181552 */     GIR_EraseRootFromParent_Done,
     /* 181553 */   // Label 2783: @181553
     /* 181553 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(181609), // Rule ID 4672 //
     /* 181558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181577 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 181580 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181607 */     GIR_RootConstrainSelectedInstOperands,
     /* 181608 */     // GIR_Coverage, 4672,
     /* 181608 */     GIR_EraseRootFromParent_Done,
     /* 181609 */   // Label 2784: @181609
     /* 181609 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(181662), // Rule ID 4674 //
     /* 181614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181630 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 181633 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181660 */     GIR_RootConstrainSelectedInstOperands,
     /* 181661 */     // GIR_Coverage, 4674,
     /* 181661 */     GIR_EraseRootFromParent_Done,
     /* 181662 */   // Label 2785: @181662
     /* 181662 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(181715), // Rule ID 3962 //
     /* 181667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 181686 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3_SADDR ?:{ *:[i32] }:$voffset, anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 181686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3_SADDR),
     /* 181689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 181694 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 181701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181713 */     GIR_RootConstrainSelectedInstOperands,
     /* 181714 */     // GIR_Coverage, 3962,
     /* 181714 */     GIR_EraseRootFromParent_Done,
     /* 181715 */   // Label 2786: @181715
     /* 181715 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(181763), // Rule ID 3961 //
     /* 181720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181723 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 181739 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 181739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3),
     /* 181742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 181747 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181761 */     GIR_RootConstrainSelectedInstOperands,
     /* 181762 */     // GIR_Coverage, 3961,
     /* 181762 */     GIR_EraseRootFromParent_Done,
     /* 181763 */   // Label 2787: @181763
     /* 181763 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(181812), // Rule ID 3646 //
     /* 181768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 181771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 181777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 181788 */     // (st v3i32:{ *:[v3i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9785:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 181788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX3),
     /* 181791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 181796 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181810 */     GIR_RootConstrainSelectedInstOperands,
     /* 181811 */     // GIR_Coverage, 3646,
     /* 181811 */     GIR_EraseRootFromParent_Done,
     /* 181812 */   // Label 2788: @181812
     /* 181812 */   GIM_Reject,
     /* 181813 */ // Label 2762: @181813
     /* 181813 */ GIM_Reject,
     /* 181814 */ // Label 2322: @181814
     /* 181814 */ GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(183789),
     /* 181819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181822 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(181883), // Rule ID 8079 //
     /* 181827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 181830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181834 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 181852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181859 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181867 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181881 */     GIR_RootConstrainSelectedInstOperands,
     /* 181882 */     // GIR_Coverage, 8079,
     /* 181882 */     GIR_EraseRootFromParent_Done,
     /* 181883 */   // Label 2790: @181883
     /* 181883 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(181944), // Rule ID 8083 //
     /* 181888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 181891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 181913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181920 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181928 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181942 */     GIR_RootConstrainSelectedInstOperands,
     /* 181943 */     // GIR_Coverage, 8083,
     /* 181943 */     GIR_EraseRootFromParent_Done,
     /* 181944 */   // Label 2791: @181944
     /* 181944 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(182000), // Rule ID 8011 //
     /* 181949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 181952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181956 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181961 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 181965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181976 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181984 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181998 */     GIR_RootConstrainSelectedInstOperands,
     /* 181999 */     // GIR_Coverage, 8011,
     /* 181999 */     GIR_EraseRootFromParent_Done,
     /* 182000 */   // Label 2792: @182000
     /* 182000 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(182056), // Rule ID 8015 //
     /* 182005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 182008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182012 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182017 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 182021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182032 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 182035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182040 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182054 */     GIR_RootConstrainSelectedInstOperands,
     /* 182055 */     // GIR_Coverage, 8015,
     /* 182055 */     GIR_EraseRootFromParent_Done,
     /* 182056 */   // Label 2793: @182056
     /* 182056 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(182113), // Rule ID 8080 //
     /* 182061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 182064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182069 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 182082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182089 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 182092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182097 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182111 */     GIR_RootConstrainSelectedInstOperands,
     /* 182112 */     // GIR_Coverage, 8080,
     /* 182112 */     GIR_EraseRootFromParent_Done,
     /* 182113 */   // Label 2794: @182113
     /* 182113 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(182170), // Rule ID 8084 //
     /* 182118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 182121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 182139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182146 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 182149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182154 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182168 */     GIR_RootConstrainSelectedInstOperands,
     /* 182169 */     // GIR_Coverage, 8084,
     /* 182169 */     GIR_EraseRootFromParent_Done,
     /* 182170 */   // Label 2795: @182170
     /* 182170 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(182222), // Rule ID 8012 //
     /* 182175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 182178 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182183 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 182187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182198 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 182201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182206 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182220 */     GIR_RootConstrainSelectedInstOperands,
     /* 182221 */     // GIR_Coverage, 8012,
     /* 182221 */     GIR_EraseRootFromParent_Done,
     /* 182222 */   // Label 2796: @182222
     /* 182222 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(182274), // Rule ID 8016 //
     /* 182227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 182230 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182235 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 182239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182250 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 182253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182258 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182272 */     GIR_RootConstrainSelectedInstOperands,
     /* 182273 */     // GIR_Coverage, 8016,
     /* 182273 */     GIR_EraseRootFromParent_Done,
     /* 182274 */   // Label 2797: @182274
     /* 182274 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(182327), // Rule ID 4320 //
     /* 182279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182282 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182298 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 182301 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182325 */     GIR_RootConstrainSelectedInstOperands,
     /* 182326 */     // GIR_Coverage, 4320,
     /* 182326 */     GIR_EraseRootFromParent_Done,
     /* 182327 */   // Label 2798: @182327
     /* 182327 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(182380), // Rule ID 4326 //
     /* 182332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182335 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182351 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 182354 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182378 */     GIR_RootConstrainSelectedInstOperands,
     /* 182379 */     // GIR_Coverage, 4326,
     /* 182379 */     GIR_EraseRootFromParent_Done,
     /* 182380 */   // Label 2799: @182380
     /* 182380 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(182428), // Rule ID 4319 //
     /* 182385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182404 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 182407 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182426 */     GIR_RootConstrainSelectedInstOperands,
     /* 182427 */     // GIR_Coverage, 4319,
     /* 182427 */     GIR_EraseRootFromParent_Done,
     /* 182428 */   // Label 2800: @182428
     /* 182428 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(182476), // Rule ID 4325 //
     /* 182433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182452 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 182455 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182474 */     GIR_RootConstrainSelectedInstOperands,
     /* 182475 */     // GIR_Coverage, 4325,
     /* 182475 */     GIR_EraseRootFromParent_Done,
     /* 182476 */   // Label 2801: @182476
     /* 182476 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(182524), // Rule ID 4318 //
     /* 182481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182500 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 182503 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182522 */     GIR_RootConstrainSelectedInstOperands,
     /* 182523 */     // GIR_Coverage, 4318,
     /* 182523 */     GIR_EraseRootFromParent_Done,
     /* 182524 */   // Label 2802: @182524
     /* 182524 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(182572), // Rule ID 4324 //
     /* 182529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182532 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182548 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 182551 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182570 */     GIR_RootConstrainSelectedInstOperands,
     /* 182571 */     // GIR_Coverage, 4324,
     /* 182571 */     GIR_EraseRootFromParent_Done,
     /* 182572 */   // Label 2803: @182572
     /* 182572 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(182633), // Rule ID 4649 //
     /* 182577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182596 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 182599 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182631 */     GIR_RootConstrainSelectedInstOperands,
     /* 182632 */     // GIR_Coverage, 4649,
     /* 182632 */     GIR_EraseRootFromParent_Done,
     /* 182633 */   // Label 2804: @182633
     /* 182633 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(182691), // Rule ID 4651 //
     /* 182638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182654 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 182657 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182689 */     GIR_RootConstrainSelectedInstOperands,
     /* 182690 */     // GIR_Coverage, 4651,
     /* 182690 */     GIR_EraseRootFromParent_Done,
     /* 182691 */   // Label 2805: @182691
     /* 182691 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(182752), // Rule ID 4653 //
     /* 182696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182699 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182715 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 182718 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182750 */     GIR_RootConstrainSelectedInstOperands,
     /* 182751 */     // GIR_Coverage, 4653,
     /* 182751 */     GIR_EraseRootFromParent_Done,
     /* 182752 */   // Label 2806: @182752
     /* 182752 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(182810), // Rule ID 4655 //
     /* 182757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182773 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 182776 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182808 */     GIR_RootConstrainSelectedInstOperands,
     /* 182809 */     // GIR_Coverage, 4655,
     /* 182809 */     GIR_EraseRootFromParent_Done,
     /* 182810 */   // Label 2807: @182810
     /* 182810 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(182927), // Rule ID 7954 //
     /* 182815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 182838 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 182838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182850 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 182856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 182884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 182897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 182913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 182918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182925 */     GIR_RootConstrainSelectedInstOperands,
     /* 182926 */     // GIR_Coverage, 7954,
     /* 182926 */     GIR_EraseRootFromParent_Done,
     /* 182927 */   // Label 2808: @182927
     /* 182927 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(183044), // Rule ID 7958 //
     /* 182932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182939 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 182955 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 182955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182967 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 182973 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 183001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 183014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183042 */     GIR_RootConstrainSelectedInstOperands,
     /* 183043 */     // GIR_Coverage, 7958,
     /* 183043 */     GIR_EraseRootFromParent_Done,
     /* 183044 */   // Label 2809: @183044
     /* 183044 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(183100), // Rule ID 4648 //
     /* 183049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 183052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183068 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 183071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183098 */     GIR_RootConstrainSelectedInstOperands,
     /* 183099 */     // GIR_Coverage, 4648,
     /* 183099 */     GIR_EraseRootFromParent_Done,
     /* 183100 */   // Label 2810: @183100
     /* 183100 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(183153), // Rule ID 4650 //
     /* 183105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183121 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183151 */     GIR_RootConstrainSelectedInstOperands,
     /* 183152 */     // GIR_Coverage, 4650,
     /* 183152 */     GIR_EraseRootFromParent_Done,
     /* 183153 */   // Label 2811: @183153
     /* 183153 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(183209), // Rule ID 4652 //
     /* 183158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 183161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183177 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 183180 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183207 */     GIR_RootConstrainSelectedInstOperands,
     /* 183208 */     // GIR_Coverage, 4652,
     /* 183208 */     GIR_EraseRootFromParent_Done,
     /* 183209 */   // Label 2812: @183209
     /* 183209 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(183262), // Rule ID 4654 //
     /* 183214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183230 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 183233 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183260 */     GIR_RootConstrainSelectedInstOperands,
     /* 183261 */     // GIR_Coverage, 4654,
     /* 183261 */     GIR_EraseRootFromParent_Done,
     /* 183262 */   // Label 2813: @183262
     /* 183262 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(183375), // Rule ID 7956 //
     /* 183267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183270 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 183286 */     // (st v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 183289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183298 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 183304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 183332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 183345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183373 */     GIR_RootConstrainSelectedInstOperands,
     /* 183374 */     // GIR_Coverage, 7956,
     /* 183374 */     GIR_EraseRootFromParent_Done,
     /* 183375 */   // Label 2814: @183375
     /* 183375 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(183488), // Rule ID 7960 //
     /* 183380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183383 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 183399 */     // (st v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 183402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183411 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 183417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 183445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 183458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183486 */     GIR_RootConstrainSelectedInstOperands,
     /* 183487 */     // GIR_Coverage, 7960,
     /* 183487 */     GIR_EraseRootFromParent_Done,
     /* 183488 */   // Label 2815: @183488
     /* 183488 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(183541), // Rule ID 3910 //
     /* 183493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183496 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183512 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 183515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183520 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183539 */     GIR_RootConstrainSelectedInstOperands,
     /* 183540 */     // GIR_Coverage, 3910,
     /* 183540 */     GIR_EraseRootFromParent_Done,
     /* 183541 */   // Label 2816: @183541
     /* 183541 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(183594), // Rule ID 3914 //
     /* 183546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183549 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183565 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 183568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183573 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183592 */     GIR_RootConstrainSelectedInstOperands,
     /* 183593 */     // GIR_Coverage, 3914,
     /* 183593 */     GIR_EraseRootFromParent_Done,
     /* 183594 */   // Label 2817: @183594
     /* 183594 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(183642), // Rule ID 3909 //
     /* 183599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183602 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 183618 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 183621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183626 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183640 */     GIR_RootConstrainSelectedInstOperands,
     /* 183641 */     // GIR_Coverage, 3909,
     /* 183641 */     GIR_EraseRootFromParent_Done,
     /* 183642 */   // Label 2818: @183642
     /* 183642 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(183690), // Rule ID 3913 //
     /* 183647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183650 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 183666 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 183669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183674 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183688 */     GIR_RootConstrainSelectedInstOperands,
     /* 183689 */     // GIR_Coverage, 3913,
     /* 183689 */     GIR_EraseRootFromParent_Done,
     /* 183690 */   // Label 2819: @183690
     /* 183690 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(183739), // Rule ID 3636 //
     /* 183695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 183698 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 183704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 183715 */     // (st v4f16:{ *:[v4f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 183718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183723 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183737 */     GIR_RootConstrainSelectedInstOperands,
     /* 183738 */     // GIR_Coverage, 3636,
     /* 183738 */     GIR_EraseRootFromParent_Done,
     /* 183739 */   // Label 2820: @183739
     /* 183739 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(183788), // Rule ID 3638 //
     /* 183744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 183747 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 183753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 183764 */     // (st v4i16:{ *:[v4i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 183767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183772 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183786 */     GIR_RootConstrainSelectedInstOperands,
     /* 183787 */     // GIR_Coverage, 3638,
     /* 183787 */     GIR_EraseRootFromParent_Done,
     /* 183788 */   // Label 2821: @183788
     /* 183788 */   GIM_Reject,
     /* 183789 */ // Label 2789: @183789
     /* 183789 */ GIM_Reject,
     /* 183790 */ // Label 2323: @183790
     /* 183790 */ GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(185999),
     /* 183795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183798 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(183854), // Rule ID 8039 //
     /* 183803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183815 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183830 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183838 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183852 */     GIR_RootConstrainSelectedInstOperands,
     /* 183853 */     // GIR_Coverage, 8039,
     /* 183853 */     GIR_EraseRootFromParent_Done,
     /* 183854 */   // Label 2823: @183854
     /* 183854 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(183910), // Rule ID 8043 //
     /* 183859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183866 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183871 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183886 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183894 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183908 */     GIR_RootConstrainSelectedInstOperands,
     /* 183909 */     // GIR_Coverage, 8043,
     /* 183909 */     GIR_EraseRootFromParent_Done,
     /* 183910 */   // Label 2824: @183910
     /* 183910 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(183971), // Rule ID 8107 //
     /* 183915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 183918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183922 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 183940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183947 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183955 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183969 */     GIR_RootConstrainSelectedInstOperands,
     /* 183970 */     // GIR_Coverage, 8107,
     /* 183970 */     GIR_EraseRootFromParent_Done,
     /* 183971 */   // Label 2825: @183971
     /* 183971 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(184032), // Rule ID 8111 //
     /* 183976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 183979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 184001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184008 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 184011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184016 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184030 */     GIR_RootConstrainSelectedInstOperands,
     /* 184031 */     // GIR_Coverage, 8111,
     /* 184031 */     GIR_EraseRootFromParent_Done,
     /* 184032 */   // Label 2826: @184032
     /* 184032 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(184084), // Rule ID 8040 //
     /* 184037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 184040 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184045 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184060 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 184063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184068 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184082 */     GIR_RootConstrainSelectedInstOperands,
     /* 184083 */     // GIR_Coverage, 8040,
     /* 184083 */     GIR_EraseRootFromParent_Done,
     /* 184084 */   // Label 2827: @184084
     /* 184084 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(184136), // Rule ID 8044 //
     /* 184089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 184092 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184097 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184112 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 184115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184120 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184134 */     GIR_RootConstrainSelectedInstOperands,
     /* 184135 */     // GIR_Coverage, 8044,
     /* 184135 */     GIR_EraseRootFromParent_Done,
     /* 184136 */   // Label 2828: @184136
     /* 184136 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(184193), // Rule ID 8108 //
     /* 184141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 184144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184149 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 184162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184169 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 184172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184177 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184191 */     GIR_RootConstrainSelectedInstOperands,
     /* 184192 */     // GIR_Coverage, 8108,
     /* 184192 */     GIR_EraseRootFromParent_Done,
     /* 184193 */   // Label 2829: @184193
     /* 184193 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(184250), // Rule ID 8112 //
     /* 184198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 184201 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184206 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 184219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184226 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 184229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184234 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184248 */     GIR_RootConstrainSelectedInstOperands,
     /* 184249 */     // GIR_Coverage, 8112,
     /* 184249 */     GIR_EraseRootFromParent_Done,
     /* 184250 */   // Label 2830: @184250
     /* 184250 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(184306), // Rule ID 6641 //
     /* 184255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 184258 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184274 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 184277 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184304 */     GIR_RootConstrainSelectedInstOperands,
     /* 184305 */     // GIR_Coverage, 6641,
     /* 184305 */     GIR_EraseRootFromParent_Done,
     /* 184306 */   // Label 2831: @184306
     /* 184306 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(184362), // Rule ID 6643 //
     /* 184311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 184314 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184330 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 184333 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184360 */     GIR_RootConstrainSelectedInstOperands,
     /* 184361 */     // GIR_Coverage, 6643,
     /* 184361 */     GIR_EraseRootFromParent_Done,
     /* 184362 */   // Label 2832: @184362
     /* 184362 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(184415), // Rule ID 4353 //
     /* 184367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 184370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 184386 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 184389 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 184401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184413 */     GIR_RootConstrainSelectedInstOperands,
     /* 184414 */     // GIR_Coverage, 4353,
     /* 184414 */     GIR_EraseRootFromParent_Done,
     /* 184415 */   // Label 2833: @184415
     /* 184415 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(184468), // Rule ID 4359 //
     /* 184420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 184423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 184439 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 184442 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 184454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184466 */     GIR_RootConstrainSelectedInstOperands,
     /* 184467 */     // GIR_Coverage, 4359,
     /* 184467 */     GIR_EraseRootFromParent_Done,
     /* 184468 */   // Label 2834: @184468
     /* 184468 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(184516), // Rule ID 4352 //
     /* 184473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184476 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 184492 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 184495 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 184502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 4352,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 2835: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(184564), // Rule ID 4358 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184524 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 184540 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 184543 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 184550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184562 */     GIR_RootConstrainSelectedInstOperands,
     /* 184563 */     // GIR_Coverage, 4358,
     /* 184563 */     GIR_EraseRootFromParent_Done,
     /* 184564 */   // Label 2836: @184564
     /* 184564 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(184612), // Rule ID 4351 //
     /* 184569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184572 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 184588 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 184588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 184591 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184610 */     GIR_RootConstrainSelectedInstOperands,
     /* 184611 */     // GIR_Coverage, 4351,
     /* 184611 */     GIR_EraseRootFromParent_Done,
     /* 184612 */   // Label 2837: @184612
     /* 184612 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(184660), // Rule ID 4357 //
     /* 184617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 184636 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 184636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 184639 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184658 */     GIR_RootConstrainSelectedInstOperands,
     /* 184659 */     // GIR_Coverage, 4357,
     /* 184659 */     GIR_EraseRootFromParent_Done,
     /* 184660 */   // Label 2838: @184660
     /* 184660 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(184721), // Rule ID 4677 //
     /* 184665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184684 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 184687 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184719 */     GIR_RootConstrainSelectedInstOperands,
     /* 184720 */     // GIR_Coverage, 4677,
     /* 184720 */     GIR_EraseRootFromParent_Done,
     /* 184721 */   // Label 2839: @184721
     /* 184721 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(184779), // Rule ID 4679 //
     /* 184726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184742 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 184745 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184777 */     GIR_RootConstrainSelectedInstOperands,
     /* 184778 */     // GIR_Coverage, 4679,
     /* 184778 */     GIR_EraseRootFromParent_Done,
     /* 184779 */   // Label 2840: @184779
     /* 184779 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(184840), // Rule ID 4681 //
     /* 184784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184787 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184803 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 184806 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184838 */     GIR_RootConstrainSelectedInstOperands,
     /* 184839 */     // GIR_Coverage, 4681,
     /* 184839 */     GIR_EraseRootFromParent_Done,
     /* 184840 */   // Label 2841: @184840
     /* 184840 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(184898), // Rule ID 4683 //
     /* 184845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184861 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 184864 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184896 */     GIR_RootConstrainSelectedInstOperands,
     /* 184897 */     // GIR_Coverage, 4683,
     /* 184897 */     GIR_EraseRootFromParent_Done,
     /* 184898 */   // Label 2842: @184898
     /* 184898 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(184959), // Rule ID 6640 //
     /* 184903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 184906 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 184922 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN),
     /* 184925 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184957 */     GIR_RootConstrainSelectedInstOperands,
     /* 184958 */     // GIR_Coverage, 6640,
     /* 184958 */     GIR_EraseRootFromParent_Done,
     /* 184959 */   // Label 2843: @184959
     /* 184959 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(185020), // Rule ID 6642 //
     /* 184964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 184967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 184983 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN),
     /* 184986 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 185003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 185008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185018 */     GIR_RootConstrainSelectedInstOperands,
     /* 185019 */     // GIR_Coverage, 6642,
     /* 185019 */     GIR_EraseRootFromParent_Done,
     /* 185020 */   // Label 2844: @185020
     /* 185020 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(185137), // Rule ID 7938 //
     /* 185025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 185028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185032 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185048 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185060 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185088 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 185107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185135 */     GIR_RootConstrainSelectedInstOperands,
     /* 185136 */     // GIR_Coverage, 7938,
     /* 185136 */     GIR_EraseRootFromParent_Done,
     /* 185137 */   // Label 2845: @185137
     /* 185137 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(185254), // Rule ID 7974 //
     /* 185142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 185145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185149 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185165 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185165 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185168 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185172 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185177 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 185224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185252 */     GIR_RootConstrainSelectedInstOperands,
     /* 185253 */     // GIR_Coverage, 7974,
     /* 185253 */     GIR_EraseRootFromParent_Done,
     /* 185254 */   // Label 2846: @185254
     /* 185254 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(185310), // Rule ID 4676 //
     /* 185259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185262 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185278 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185308 */     GIR_RootConstrainSelectedInstOperands,
     /* 185309 */     // GIR_Coverage, 4676,
     /* 185309 */     GIR_EraseRootFromParent_Done,
     /* 185310 */   // Label 2847: @185310
     /* 185310 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(185363), // Rule ID 4678 //
     /* 185315 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185331 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 185334 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185361 */     GIR_RootConstrainSelectedInstOperands,
     /* 185362 */     // GIR_Coverage, 4678,
     /* 185362 */     GIR_EraseRootFromParent_Done,
     /* 185363 */   // Label 2848: @185363
     /* 185363 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(185419), // Rule ID 4680 //
     /* 185368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185387 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 185390 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185417 */     GIR_RootConstrainSelectedInstOperands,
     /* 185418 */     // GIR_Coverage, 4680,
     /* 185418 */     GIR_EraseRootFromParent_Done,
     /* 185419 */   // Label 2849: @185419
     /* 185419 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(185472), // Rule ID 4682 //
     /* 185424 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185440 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 185443 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185470 */     GIR_RootConstrainSelectedInstOperands,
     /* 185471 */     // GIR_Coverage, 4682,
     /* 185471 */     GIR_EraseRootFromParent_Done,
     /* 185472 */   // Label 2850: @185472
     /* 185472 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(185585), // Rule ID 7940 //
     /* 185477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185496 */     // (st v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185508 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 185555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185583 */     GIR_RootConstrainSelectedInstOperands,
     /* 185584 */     // GIR_Coverage, 7940,
     /* 185584 */     GIR_EraseRootFromParent_Done,
     /* 185585 */   // Label 2851: @185585
     /* 185585 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(185698), // Rule ID 7976 //
     /* 185590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185609 */     // (st v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185621 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 185668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185696 */     GIR_RootConstrainSelectedInstOperands,
     /* 185697 */     // GIR_Coverage, 7976,
     /* 185697 */     GIR_EraseRootFromParent_Done,
     /* 185698 */   // Label 2852: @185698
     /* 185698 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(185751), // Rule ID 3932 //
     /* 185703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185706 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 185722 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 185722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 185725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 185730 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 185737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185749 */     GIR_RootConstrainSelectedInstOperands,
     /* 185750 */     // GIR_Coverage, 3932,
     /* 185750 */     GIR_EraseRootFromParent_Done,
     /* 185751 */   // Label 2853: @185751
     /* 185751 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(185804), // Rule ID 3936 //
     /* 185756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 185775 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 185775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 185778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 185783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 185790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185802 */     GIR_RootConstrainSelectedInstOperands,
     /* 185803 */     // GIR_Coverage, 3936,
     /* 185803 */     GIR_EraseRootFromParent_Done,
     /* 185804 */   // Label 2854: @185804
     /* 185804 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(185852), // Rule ID 3931 //
     /* 185809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 185828 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 185831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185836 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185850 */     GIR_RootConstrainSelectedInstOperands,
     /* 185851 */     // GIR_Coverage, 3931,
     /* 185851 */     GIR_EraseRootFromParent_Done,
     /* 185852 */   // Label 2855: @185852
     /* 185852 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(185900), // Rule ID 3935 //
     /* 185857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 185876 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 185879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185884 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185898 */     GIR_RootConstrainSelectedInstOperands,
     /* 185899 */     // GIR_Coverage, 3935,
     /* 185899 */     GIR_EraseRootFromParent_Done,
     /* 185900 */   // Label 2856: @185900
     /* 185900 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(185949), // Rule ID 3648 //
     /* 185905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 185908 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 185914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 185925 */     // (st v4i32:{ *:[v4i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 185928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185933 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185947 */     GIR_RootConstrainSelectedInstOperands,
     /* 185948 */     // GIR_Coverage, 3648,
     /* 185948 */     GIR_EraseRootFromParent_Done,
     /* 185949 */   // Label 2857: @185949
     /* 185949 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(185998), // Rule ID 3650 //
     /* 185954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 185957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 185963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 185974 */     // (st v4f32:{ *:[v4f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 185977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185982 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185996 */     GIR_RootConstrainSelectedInstOperands,
     /* 185997 */     // GIR_Coverage, 3650,
     /* 185997 */     GIR_EraseRootFromParent_Done,
     /* 185998 */   // Label 2858: @185998
     /* 185998 */   GIM_Reject,
     /* 185999 */ // Label 2822: @185999
     /* 185999 */ GIM_Reject,
     /* 186000 */ // Label 2324: @186000
     /* 186000 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(187975),
     /* 186005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186008 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(186064), // Rule ID 8055 //
     /* 186013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186020 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186025 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186040 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 186043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186048 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186062 */     GIR_RootConstrainSelectedInstOperands,
     /* 186063 */     // GIR_Coverage, 8055,
     /* 186063 */     GIR_EraseRootFromParent_Done,
     /* 186064 */   // Label 2860: @186064
     /* 186064 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(186120), // Rule ID 8059 //
     /* 186069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186081 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186096 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 186099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186104 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186118 */     GIR_RootConstrainSelectedInstOperands,
     /* 186119 */     // GIR_Coverage, 8059,
     /* 186119 */     GIR_EraseRootFromParent_Done,
     /* 186120 */   // Label 2861: @186120
     /* 186120 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(186181), // Rule ID 8123 //
     /* 186125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 186128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186132 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186137 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 186150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186157 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 186160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186165 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186179 */     GIR_RootConstrainSelectedInstOperands,
     /* 186180 */     // GIR_Coverage, 8123,
     /* 186180 */     GIR_EraseRootFromParent_Done,
     /* 186181 */   // Label 2862: @186181
     /* 186181 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(186242), // Rule ID 8127 //
     /* 186186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 186189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 186211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186218 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 186221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186226 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186240 */     GIR_RootConstrainSelectedInstOperands,
     /* 186241 */     // GIR_Coverage, 8127,
     /* 186241 */     GIR_EraseRootFromParent_Done,
     /* 186242 */   // Label 2863: @186242
     /* 186242 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(186294), // Rule ID 8056 //
     /* 186247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 186250 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186255 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186270 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186278 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186292 */     GIR_RootConstrainSelectedInstOperands,
     /* 186293 */     // GIR_Coverage, 8056,
     /* 186293 */     GIR_EraseRootFromParent_Done,
     /* 186294 */   // Label 2864: @186294
     /* 186294 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(186346), // Rule ID 8060 //
     /* 186299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 186302 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186307 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186322 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186330 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186344 */     GIR_RootConstrainSelectedInstOperands,
     /* 186345 */     // GIR_Coverage, 8060,
     /* 186345 */     GIR_EraseRootFromParent_Done,
     /* 186346 */   // Label 2865: @186346
     /* 186346 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(186403), // Rule ID 8124 //
     /* 186351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 186354 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186359 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 186372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186379 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186387 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186401 */     GIR_RootConstrainSelectedInstOperands,
     /* 186402 */     // GIR_Coverage, 8124,
     /* 186402 */     GIR_EraseRootFromParent_Done,
     /* 186403 */   // Label 2866: @186403
     /* 186403 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(186460), // Rule ID 8128 //
     /* 186408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 186411 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 186429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186436 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9784:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186444 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186458 */     GIR_RootConstrainSelectedInstOperands,
     /* 186459 */     // GIR_Coverage, 8128,
     /* 186459 */     GIR_EraseRootFromParent_Done,
     /* 186460 */   // Label 2867: @186460
     /* 186460 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(186513), // Rule ID 4377 //
     /* 186465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186468 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186484 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 186487 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186511 */     GIR_RootConstrainSelectedInstOperands,
     /* 186512 */     // GIR_Coverage, 4377,
     /* 186512 */     GIR_EraseRootFromParent_Done,
     /* 186513 */   // Label 2868: @186513
     /* 186513 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(186566), // Rule ID 4383 //
     /* 186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186521 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186537 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 186540 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186564 */     GIR_RootConstrainSelectedInstOperands,
     /* 186565 */     // GIR_Coverage, 4383,
     /* 186565 */     GIR_EraseRootFromParent_Done,
     /* 186566 */   // Label 2869: @186566
     /* 186566 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(186614), // Rule ID 4376 //
     /* 186571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186574 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186590 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 186593 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186612 */     GIR_RootConstrainSelectedInstOperands,
     /* 186613 */     // GIR_Coverage, 4376,
     /* 186613 */     GIR_EraseRootFromParent_Done,
     /* 186614 */   // Label 2870: @186614
     /* 186614 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(186662), // Rule ID 4382 //
     /* 186619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186638 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 186641 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186660 */     GIR_RootConstrainSelectedInstOperands,
     /* 186661 */     // GIR_Coverage, 4382,
     /* 186661 */     GIR_EraseRootFromParent_Done,
     /* 186662 */   // Label 2871: @186662
     /* 186662 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(186710), // Rule ID 4375 //
     /* 186667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186686 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 186689 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186708 */     GIR_RootConstrainSelectedInstOperands,
     /* 186709 */     // GIR_Coverage, 4375,
     /* 186709 */     GIR_EraseRootFromParent_Done,
     /* 186710 */   // Label 2872: @186710
     /* 186710 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(186758), // Rule ID 4381 //
     /* 186715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186718 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186734 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 186737 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186756 */     GIR_RootConstrainSelectedInstOperands,
     /* 186757 */     // GIR_Coverage, 4381,
     /* 186757 */     GIR_EraseRootFromParent_Done,
     /* 186758 */   // Label 2873: @186758
     /* 186758 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(186819), // Rule ID 4693 //
     /* 186763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186766 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186782 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 186785 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186817 */     GIR_RootConstrainSelectedInstOperands,
     /* 186818 */     // GIR_Coverage, 4693,
     /* 186818 */     GIR_EraseRootFromParent_Done,
     /* 186819 */   // Label 2874: @186819
     /* 186819 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(186877), // Rule ID 4695 //
     /* 186824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186840 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 186843 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186875 */     GIR_RootConstrainSelectedInstOperands,
     /* 186876 */     // GIR_Coverage, 4695,
     /* 186876 */     GIR_EraseRootFromParent_Done,
     /* 186877 */   // Label 2875: @186877
     /* 186877 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(186938), // Rule ID 4697 //
     /* 186882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186885 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186901 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 186904 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186936 */     GIR_RootConstrainSelectedInstOperands,
     /* 186937 */     // GIR_Coverage, 4697,
     /* 186937 */     GIR_EraseRootFromParent_Done,
     /* 186938 */   // Label 2876: @186938
     /* 186938 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(186996), // Rule ID 4699 //
     /* 186943 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186959 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 186962 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186994 */     GIR_RootConstrainSelectedInstOperands,
     /* 186995 */     // GIR_Coverage, 4699,
     /* 186995 */     GIR_EraseRootFromParent_Done,
     /* 186996 */   // Label 2877: @186996
     /* 186996 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(187113), // Rule ID 7986 //
     /* 187001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 187004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187008 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187024 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187036 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187047 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 187083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187111 */     GIR_RootConstrainSelectedInstOperands,
     /* 187112 */     // GIR_Coverage, 7986,
     /* 187112 */     GIR_EraseRootFromParent_Done,
     /* 187113 */   // Label 2878: @187113
     /* 187113 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(187230), // Rule ID 7990 //
     /* 187118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 187121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187141 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187153 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187181 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 187200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187228 */     GIR_RootConstrainSelectedInstOperands,
     /* 187229 */     // GIR_Coverage, 7990,
     /* 187229 */     GIR_EraseRootFromParent_Done,
     /* 187230 */   // Label 2879: @187230
     /* 187230 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(187286), // Rule ID 4692 //
     /* 187235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 187238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187254 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 187257 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187284 */     GIR_RootConstrainSelectedInstOperands,
     /* 187285 */     // GIR_Coverage, 4692,
     /* 187285 */     GIR_EraseRootFromParent_Done,
     /* 187286 */   // Label 2880: @187286
     /* 187286 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(187339), // Rule ID 4694 //
     /* 187291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187307 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 187310 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187337 */     GIR_RootConstrainSelectedInstOperands,
     /* 187338 */     // GIR_Coverage, 4694,
     /* 187338 */     GIR_EraseRootFromParent_Done,
     /* 187339 */   // Label 2881: @187339
     /* 187339 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(187395), // Rule ID 4696 //
     /* 187344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 187347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187363 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 187366 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187393 */     GIR_RootConstrainSelectedInstOperands,
     /* 187394 */     // GIR_Coverage, 4696,
     /* 187394 */     GIR_EraseRootFromParent_Done,
     /* 187395 */   // Label 2882: @187395
     /* 187395 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(187448), // Rule ID 4698 //
     /* 187400 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187416 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 187419 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187446 */     GIR_RootConstrainSelectedInstOperands,
     /* 187447 */     // GIR_Coverage, 4698,
     /* 187447 */     GIR_EraseRootFromParent_Done,
     /* 187448 */   // Label 2883: @187448
     /* 187448 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(187561), // Rule ID 7988 //
     /* 187453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187472 */     // (st v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187484 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187490 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187512 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 187531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187559 */     GIR_RootConstrainSelectedInstOperands,
     /* 187560 */     // GIR_Coverage, 7988,
     /* 187560 */     GIR_EraseRootFromParent_Done,
     /* 187561 */   // Label 2884: @187561
     /* 187561 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(187674), // Rule ID 7992 //
     /* 187566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187569 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187585 */     // (st v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187597 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187603 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187625 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 187644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187672 */     GIR_RootConstrainSelectedInstOperands,
     /* 187673 */     // GIR_Coverage, 7992,
     /* 187673 */     GIR_EraseRootFromParent_Done,
     /* 187674 */   // Label 2885: @187674
     /* 187674 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(187727), // Rule ID 3948 //
     /* 187679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187682 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187698 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 187701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187706 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187725 */     GIR_RootConstrainSelectedInstOperands,
     /* 187726 */     // GIR_Coverage, 3948,
     /* 187726 */     GIR_EraseRootFromParent_Done,
     /* 187727 */   // Label 2886: @187727
     /* 187727 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(187780), // Rule ID 3952 //
     /* 187732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187751 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 187754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187759 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187778 */     GIR_RootConstrainSelectedInstOperands,
     /* 187779 */     // GIR_Coverage, 3952,
     /* 187779 */     GIR_EraseRootFromParent_Done,
     /* 187780 */   // Label 2887: @187780
     /* 187780 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(187828), // Rule ID 3947 //
     /* 187785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187788 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187804 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 187807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187812 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187826 */     GIR_RootConstrainSelectedInstOperands,
     /* 187827 */     // GIR_Coverage, 3947,
     /* 187827 */     GIR_EraseRootFromParent_Done,
     /* 187828 */   // Label 2888: @187828
     /* 187828 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(187876), // Rule ID 3951 //
     /* 187833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187836 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187852 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 187855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187860 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187874 */     GIR_RootConstrainSelectedInstOperands,
     /* 187875 */     // GIR_Coverage, 3951,
     /* 187875 */     GIR_EraseRootFromParent_Done,
     /* 187876 */   // Label 2889: @187876
     /* 187876 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(187925), // Rule ID 3656 //
     /* 187881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187884 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187901 */     // (st v8i16:{ *:[v8i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 187904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187909 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187923 */     GIR_RootConstrainSelectedInstOperands,
     /* 187924 */     // GIR_Coverage, 3656,
     /* 187924 */     GIR_EraseRootFromParent_Done,
     /* 187925 */   // Label 2890: @187925
     /* 187925 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(187974), // Rule ID 3658 //
     /* 187930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187950 */     // (st v8f16:{ *:[v8f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 187953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187958 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187972 */     GIR_RootConstrainSelectedInstOperands,
     /* 187973 */     // GIR_Coverage, 3658,
     /* 187973 */     GIR_EraseRootFromParent_Done,
     /* 187974 */   // Label 2891: @187974
     /* 187974 */   GIM_Reject,
     /* 187975 */ // Label 2859: @187975
     /* 187975 */ GIM_Reject,
     /* 187976 */ // Label 2325: @187976
     /* 187976 */ GIM_Reject,
     /* 187977 */ // Label 18: @187977
     /* 187977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2894*/ GIMT_Encode4(189102),
     /* 187988 */ /*GILLT_s32*//*Label 2892*/ GIMT_Encode4(187996),
     /* 187992 */ /*GILLT_s64*//*Label 2893*/ GIMT_Encode4(188549),
     /* 187996 */ // Label 2892: @187996
     /* 187996 */ GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(188548),
     /* 188001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188007 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(188059), // Rule ID 8139 //
     /* 188012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188020 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188033 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 188036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188041 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188043 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188057 */     GIR_RootConstrainSelectedInstOperands,
     /* 188058 */     // GIR_Coverage, 8139,
     /* 188058 */     GIR_EraseRootFromParent_Done,
     /* 188059 */   // Label 2896: @188059
     /* 188059 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(188111), // Rule ID 8141 //
     /* 188064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188067 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188072 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188085 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPST_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32_gfx9),
     /* 188088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188093 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188095 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188109 */     GIR_RootConstrainSelectedInstOperands,
     /* 188110 */     // GIR_Coverage, 8141,
     /* 188110 */     GIR_EraseRootFromParent_Done,
     /* 188111 */   // Label 2897: @188111
     /* 188111 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(188163), // Rule ID 8143 //
     /* 188116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188119 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188124 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188137 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 188140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188145 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188161 */     GIR_RootConstrainSelectedInstOperands,
     /* 188162 */     // GIR_Coverage, 8143,
     /* 188162 */     GIR_EraseRootFromParent_Done,
     /* 188163 */   // Label 2898: @188163
     /* 188163 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(188215), // Rule ID 8145 //
     /* 188168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188171 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188176 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188189 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPSTORE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$swap, anonymous_9787:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32_gfx9),
     /* 188192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188197 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188199 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188213 */     GIR_RootConstrainSelectedInstOperands,
     /* 188214 */     // GIR_Coverage, 8145,
     /* 188214 */     GIR_EraseRootFromParent_Done,
     /* 188215 */   // Label 2899: @188215
     /* 188215 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(188267), // Rule ID 8147 //
     /* 188220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188223 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188228 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188241 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPSTORE_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$swap, anonymous_9787:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32),
     /* 188244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188249 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188251 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188265 */     GIR_RootConstrainSelectedInstOperands,
     /* 188266 */     // GIR_Coverage, 8147,
     /* 188266 */     GIR_EraseRootFromParent_Done,
     /* 188267 */   // Label 2900: @188267
     /* 188267 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(188323), // Rule ID 8138 //
     /* 188272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188275 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188295 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 188298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188305 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188307 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188321 */     GIR_RootConstrainSelectedInstOperands,
     /* 188322 */     // GIR_Coverage, 8138,
     /* 188322 */     GIR_EraseRootFromParent_Done,
     /* 188323 */   // Label 2901: @188323
     /* 188323 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(188379), // Rule ID 8140 //
     /* 188328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188331 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188351 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPST_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32_gfx9),
     /* 188354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188361 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188363 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188377 */     GIR_RootConstrainSelectedInstOperands,
     /* 188378 */     // GIR_Coverage, 8140,
     /* 188378 */     GIR_EraseRootFromParent_Done,
     /* 188379 */   // Label 2902: @188379
     /* 188379 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(188435), // Rule ID 8142 //
     /* 188384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188387 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188407 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$cmp, anonymous_9787:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 188410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188417 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188419 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188433 */     GIR_RootConstrainSelectedInstOperands,
     /* 188434 */     // GIR_Coverage, 8142,
     /* 188434 */     GIR_EraseRootFromParent_Done,
     /* 188435 */   // Label 2903: @188435
     /* 188435 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(188491), // Rule ID 8144 //
     /* 188440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188443 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188463 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPSTORE_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$swap, anonymous_9787:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32_gfx9),
     /* 188466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188473 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188475 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188489 */     GIR_RootConstrainSelectedInstOperands,
     /* 188490 */     // GIR_Coverage, 8144,
     /* 188490 */     GIR_EraseRootFromParent_Done,
     /* 188491 */   // Label 2904: @188491
     /* 188491 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(188547), // Rule ID 8146 //
     /* 188496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188499 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188519 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPSTORE_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$swap, anonymous_9787:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32),
     /* 188522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188529 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188531 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188545 */     GIR_RootConstrainSelectedInstOperands,
     /* 188546 */     // GIR_Coverage, 8146,
     /* 188546 */     GIR_EraseRootFromParent_Done,
     /* 188547 */   // Label 2905: @188547
     /* 188547 */   GIM_Reject,
     /* 188548 */ // Label 2895: @188548
     /* 188548 */ GIM_Reject,
     /* 188549 */ // Label 2893: @188549
     /* 188549 */ GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(189101),
     /* 188554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188560 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(188612), // Rule ID 8314 //
     /* 188565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188568 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188573 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188586 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 188589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188594 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188596 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188610 */     GIR_RootConstrainSelectedInstOperands,
     /* 188611 */     // GIR_Coverage, 8314,
     /* 188611 */     GIR_EraseRootFromParent_Done,
     /* 188612 */   // Label 2907: @188612
     /* 188612 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(188664), // Rule ID 8316 //
     /* 188617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188625 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188638 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPST_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64_gfx9),
     /* 188641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188646 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188648 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188662 */     GIR_RootConstrainSelectedInstOperands,
     /* 188663 */     // GIR_Coverage, 8316,
     /* 188663 */     GIR_EraseRootFromParent_Done,
     /* 188664 */   // Label 2908: @188664
     /* 188664 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(188716), // Rule ID 8318 //
     /* 188669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188677 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188690 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 188693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188698 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188700 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188714 */     GIR_RootConstrainSelectedInstOperands,
     /* 188715 */     // GIR_Coverage, 8318,
     /* 188715 */     GIR_EraseRootFromParent_Done,
     /* 188716 */   // Label 2909: @188716
     /* 188716 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(188768), // Rule ID 8320 //
     /* 188721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188724 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188729 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188742 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPSTORE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$swap, anonymous_9786:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64_gfx9),
     /* 188745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188750 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188752 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188766 */     GIR_RootConstrainSelectedInstOperands,
     /* 188767 */     // GIR_Coverage, 8320,
     /* 188767 */     GIR_EraseRootFromParent_Done,
     /* 188768 */   // Label 2910: @188768
     /* 188768 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(188820), // Rule ID 8322 //
     /* 188773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188776 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188781 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188794 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPSTORE_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$swap, anonymous_9786:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64),
     /* 188797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188802 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188804 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188818 */     GIR_RootConstrainSelectedInstOperands,
     /* 188819 */     // GIR_Coverage, 8322,
     /* 188819 */     GIR_EraseRootFromParent_Done,
     /* 188820 */   // Label 2911: @188820
     /* 188820 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(188876), // Rule ID 8313 //
     /* 188825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188848 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 188851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188858 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188860 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188874 */     GIR_RootConstrainSelectedInstOperands,
     /* 188875 */     // GIR_Coverage, 8313,
     /* 188875 */     GIR_EraseRootFromParent_Done,
     /* 188876 */   // Label 2912: @188876
     /* 188876 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(188932), // Rule ID 8315 //
     /* 188881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188884 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188904 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPST_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64_gfx9),
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188914 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188916 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188930 */     GIR_RootConstrainSelectedInstOperands,
     /* 188931 */     // GIR_Coverage, 8315,
     /* 188931 */     GIR_EraseRootFromParent_Done,
     /* 188932 */   // Label 2913: @188932
     /* 188932 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(188988), // Rule ID 8317 //
     /* 188937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188940 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188960 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$cmp, anonymous_9786:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 188963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188970 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188972 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188986 */     GIR_RootConstrainSelectedInstOperands,
     /* 188987 */     // GIR_Coverage, 8317,
     /* 188987 */     GIR_EraseRootFromParent_Done,
     /* 188988 */   // Label 2914: @188988
     /* 188988 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(189044), // Rule ID 8319 //
     /* 188993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 189005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189016 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPSTORE_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$swap, anonymous_9786:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64_gfx9),
     /* 189019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189026 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 189028 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 189030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189042 */     GIR_RootConstrainSelectedInstOperands,
     /* 189043 */     // GIR_Coverage, 8319,
     /* 189043 */     GIR_EraseRootFromParent_Done,
     /* 189044 */   // Label 2915: @189044
     /* 189044 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(189100), // Rule ID 8321 //
     /* 189049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 189052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 189057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 189061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189072 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPSTORE_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$swap, anonymous_9786:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 189072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64),
     /* 189075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189082 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 189084 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 189086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189098 */     GIR_RootConstrainSelectedInstOperands,
     /* 189099 */     // GIR_Coverage, 8321,
     /* 189099 */     GIR_EraseRootFromParent_Done,
     /* 189100 */   // Label 2916: @189100
     /* 189100 */   GIM_Reject,
     /* 189101 */ // Label 2906: @189101
     /* 189101 */ GIM_Reject,
     /* 189102 */ // Label 2894: @189102
     /* 189102 */ GIM_Reject,
     /* 189103 */ // Label 19: @189103
     /* 189103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2919*/ GIMT_Encode4(191314),
     /* 189114 */ /*GILLT_s32*//*Label 2917*/ GIMT_Encode4(189122),
     /* 189118 */ /*GILLT_s64*//*Label 2918*/ GIMT_Encode4(190218),
     /* 189122 */ // Label 2917: @189122
     /* 189122 */ GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(190217),
     /* 189127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189130 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(189192), // Rule ID 5577 //
     /* 189135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189138 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189145 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189158 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64),
     /* 189161 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189190 */     GIR_RootConstrainSelectedInstOperands,
     /* 189191 */     // GIR_Coverage, 5577,
     /* 189191 */     GIR_EraseRootFromParent_Done,
     /* 189192 */   // Label 2921: @189192
     /* 189192 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(189251), // Rule ID 5581 //
     /* 189197 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189204 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189217 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64),
     /* 189220 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189249 */     GIR_RootConstrainSelectedInstOperands,
     /* 189250 */     // GIR_Coverage, 5581,
     /* 189250 */     GIR_EraseRootFromParent_Done,
     /* 189251 */   // Label 2922: @189251
     /* 189251 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(189317), // Rule ID 5573 //
     /* 189256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189259 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189281 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64_RTN),
     /* 189284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189286 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189315 */     GIR_RootConstrainSelectedInstOperands,
     /* 189316 */     // GIR_Coverage, 5573,
     /* 189316 */     GIR_EraseRootFromParent_Done,
     /* 189317 */   // Label 2923: @189317
     /* 189317 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(189380), // Rule ID 5579 //
     /* 189322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189344 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN),
     /* 189347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189349 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189378 */     GIR_RootConstrainSelectedInstOperands,
     /* 189379 */     // GIR_Coverage, 5579,
     /* 189379 */     GIR_EraseRootFromParent_Done,
     /* 189380 */   // Label 2924: @189380
     /* 189380 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(189437), // Rule ID 5576 //
     /* 189385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189408 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 189411 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189435 */     GIR_RootConstrainSelectedInstOperands,
     /* 189436 */     // GIR_Coverage, 5576,
     /* 189436 */     GIR_EraseRootFromParent_Done,
     /* 189437 */   // Label 2925: @189437
     /* 189437 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(189491), // Rule ID 5580 //
     /* 189442 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189449 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189462 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 189465 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189489 */     GIR_RootConstrainSelectedInstOperands,
     /* 189490 */     // GIR_Coverage, 5580,
     /* 189490 */     GIR_EraseRootFromParent_Done,
     /* 189491 */   // Label 2926: @189491
     /* 189491 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(189552), // Rule ID 5572 //
     /* 189496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189499 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189521 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 189524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189526 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189550 */     GIR_RootConstrainSelectedInstOperands,
     /* 189551 */     // GIR_Coverage, 5572,
     /* 189551 */     GIR_EraseRootFromParent_Done,
     /* 189552 */   // Label 2927: @189552
     /* 189552 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(189610), // Rule ID 5578 //
     /* 189557 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189579 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189584 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189608 */     GIR_RootConstrainSelectedInstOperands,
     /* 189609 */     // GIR_Coverage, 5578,
     /* 189609 */     GIR_EraseRootFromParent_Done,
     /* 189610 */   // Label 2928: @189610
     /* 189610 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(189664), // Rule ID 8129 //
     /* 189615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 189618 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189638 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 189641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189648 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189662 */     GIR_RootConstrainSelectedInstOperands,
     /* 189663 */     // GIR_Coverage, 8129,
     /* 189663 */     GIR_EraseRootFromParent_Done,
     /* 189664 */   // Label 2929: @189664
     /* 189664 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(189718), // Rule ID 8130 //
     /* 189669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 189672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189692 */     // (atomic_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_i32>>  =>  (DS_WRXCHG_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32_gfx9),
     /* 189695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189702 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189716 */     GIR_RootConstrainSelectedInstOperands,
     /* 189717 */     // GIR_Coverage, 8130,
     /* 189717 */     GIR_EraseRootFromParent_Done,
     /* 189718 */   // Label 2930: @189718
     /* 189718 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(189772), // Rule ID 8131 //
     /* 189723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 189726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 189731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189746 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_region_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 189746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 189749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189756 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189770 */     GIR_RootConstrainSelectedInstOperands,
     /* 189771 */     // GIR_Coverage, 8131,
     /* 189771 */     GIR_EraseRootFromParent_Done,
     /* 189772 */   // Label 2931: @189772
     /* 189772 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(189829), // Rule ID 4046 //
     /* 189777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189787 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189800 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR),
     /* 189803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189808 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189827 */     GIR_RootConstrainSelectedInstOperands,
     /* 189828 */     // GIR_Coverage, 4046,
     /* 189828 */     GIR_EraseRootFromParent_Done,
     /* 189829 */   // Label 2932: @189829
     /* 189829 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(189890), // Rule ID 4048 //
     /* 189834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189837 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189859 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR_RTN),
     /* 189862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189869 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189888 */     GIR_RootConstrainSelectedInstOperands,
     /* 189889 */     // GIR_Coverage, 4048,
     /* 189889 */     GIR_EraseRootFromParent_Done,
     /* 189890 */   // Label 2933: @189890
     /* 189890 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(189942), // Rule ID 4045 //
     /* 189895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189905 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189918 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP),
     /* 189921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189926 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189940 */     GIR_RootConstrainSelectedInstOperands,
     /* 189941 */     // GIR_Coverage, 4045,
     /* 189941 */     GIR_EraseRootFromParent_Done,
     /* 189942 */   // Label 2934: @189942
     /* 189942 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(189998), // Rule ID 4047 //
     /* 189947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189950 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189972 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_RTN),
     /* 189975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189982 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189996 */     GIR_RootConstrainSelectedInstOperands,
     /* 189997 */     // GIR_Coverage, 4047,
     /* 189997 */     GIR_EraseRootFromParent_Done,
     /* 189998 */   // Label 2935: @189998
     /* 189998 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(190051), // Rule ID 3684 //
     /* 190003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190014 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190027 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 190027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 190030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190035 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190049 */     GIR_RootConstrainSelectedInstOperands,
     /* 190050 */     // GIR_Coverage, 3684,
     /* 190050 */     GIR_EraseRootFromParent_Done,
     /* 190051 */   // Label 2936: @190051
     /* 190051 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(190103), // Rule ID 3744 //
     /* 190056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190059 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190066 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190079 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 190079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 190082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190087 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190101 */     GIR_RootConstrainSelectedInstOperands,
     /* 190102 */     // GIR_Coverage, 3744,
     /* 190102 */     GIR_EraseRootFromParent_Done,
     /* 190103 */   // Label 2937: @190103
     /* 190103 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(190160), // Rule ID 3683 //
     /* 190108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190111 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 190123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190134 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 190134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 190137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190144 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190158 */     GIR_RootConstrainSelectedInstOperands,
     /* 190159 */     // GIR_Coverage, 3683,
     /* 190159 */     GIR_EraseRootFromParent_Done,
     /* 190160 */   // Label 2938: @190160
     /* 190160 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(190216), // Rule ID 3743 //
     /* 190165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190168 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 190179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190190 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 190190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 190193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190200 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190214 */     GIR_RootConstrainSelectedInstOperands,
     /* 190215 */     // GIR_Coverage, 3743,
     /* 190215 */     GIR_EraseRootFromParent_Done,
     /* 190216 */   // Label 2939: @190216
     /* 190216 */   GIM_Reject,
     /* 190217 */ // Label 2920: @190217
     /* 190217 */ GIM_Reject,
     /* 190218 */ // Label 2918: @190218
     /* 190218 */ GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(191313),
     /* 190223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 190226 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(190288), // Rule ID 5673 //
     /* 190231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190234 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190241 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190254 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64),
     /* 190257 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190286 */     GIR_RootConstrainSelectedInstOperands,
     /* 190287 */     // GIR_Coverage, 5673,
     /* 190287 */     GIR_EraseRootFromParent_Done,
     /* 190288 */   // Label 2941: @190288
     /* 190288 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(190347), // Rule ID 5677 //
     /* 190293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190300 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190313 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64),
     /* 190316 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190345 */     GIR_RootConstrainSelectedInstOperands,
     /* 190346 */     // GIR_Coverage, 5677,
     /* 190346 */     GIR_EraseRootFromParent_Done,
     /* 190347 */   // Label 2942: @190347
     /* 190347 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(190413), // Rule ID 5671 //
     /* 190352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190355 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190377 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN),
     /* 190380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190382 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190411 */     GIR_RootConstrainSelectedInstOperands,
     /* 190412 */     // GIR_Coverage, 5671,
     /* 190412 */     GIR_EraseRootFromParent_Done,
     /* 190413 */   // Label 2943: @190413
     /* 190413 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(190476), // Rule ID 5675 //
     /* 190418 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190440 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN),
     /* 190443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190445 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190474 */     GIR_RootConstrainSelectedInstOperands,
     /* 190475 */     // GIR_Coverage, 5675,
     /* 190475 */     GIR_EraseRootFromParent_Done,
     /* 190476 */   // Label 2944: @190476
     /* 190476 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(190533), // Rule ID 5672 //
     /* 190481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190491 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190504 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 190507 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190531 */     GIR_RootConstrainSelectedInstOperands,
     /* 190532 */     // GIR_Coverage, 5672,
     /* 190532 */     GIR_EraseRootFromParent_Done,
     /* 190533 */   // Label 2945: @190533
     /* 190533 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(190587), // Rule ID 5676 //
     /* 190538 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190545 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190558 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 190561 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190585 */     GIR_RootConstrainSelectedInstOperands,
     /* 190586 */     // GIR_Coverage, 5676,
     /* 190586 */     GIR_EraseRootFromParent_Done,
     /* 190587 */   // Label 2946: @190587
     /* 190587 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(190648), // Rule ID 5670 //
     /* 190592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190595 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190617 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 190620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190622 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190646 */     GIR_RootConstrainSelectedInstOperands,
     /* 190647 */     // GIR_Coverage, 5670,
     /* 190647 */     GIR_EraseRootFromParent_Done,
     /* 190648 */   // Label 2947: @190648
     /* 190648 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(190706), // Rule ID 5674 //
     /* 190653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190675 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 190678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190680 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190704 */     GIR_RootConstrainSelectedInstOperands,
     /* 190705 */     // GIR_Coverage, 5674,
     /* 190705 */     GIR_EraseRootFromParent_Done,
     /* 190706 */   // Label 2948: @190706
     /* 190706 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(190760), // Rule ID 8232 //
     /* 190711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 190714 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190734 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 190737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190744 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190758 */     GIR_RootConstrainSelectedInstOperands,
     /* 190759 */     // GIR_Coverage, 8232,
     /* 190759 */     GIR_EraseRootFromParent_Done,
     /* 190760 */   // Label 2949: @190760
     /* 190760 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(190814), // Rule ID 8233 //
     /* 190765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 190768 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190788 */     // (atomic_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_i64>>  =>  (DS_WRXCHG_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64_gfx9),
     /* 190791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190798 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190812 */     GIR_RootConstrainSelectedInstOperands,
     /* 190813 */     // GIR_Coverage, 8233,
     /* 190813 */     GIR_EraseRootFromParent_Done,
     /* 190814 */   // Label 2950: @190814
     /* 190814 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(190868), // Rule ID 8234 //
     /* 190819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 190822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 190827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190842 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_region_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 190842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 190845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190852 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190866 */     GIR_RootConstrainSelectedInstOperands,
     /* 190867 */     // GIR_Coverage, 8234,
     /* 190867 */     GIR_EraseRootFromParent_Done,
     /* 190868 */   // Label 2951: @190868
     /* 190868 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(190925), // Rule ID 4102 //
     /* 190873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190876 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190883 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 190896 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR),
     /* 190899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 190904 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190923 */     GIR_RootConstrainSelectedInstOperands,
     /* 190924 */     // GIR_Coverage, 4102,
     /* 190924 */     GIR_EraseRootFromParent_Done,
     /* 190925 */   // Label 2952: @190925
     /* 190925 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(190986), // Rule ID 4104 //
     /* 190930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 190955 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN),
     /* 190958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 190965 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190984 */     GIR_RootConstrainSelectedInstOperands,
     /* 190985 */     // GIR_Coverage, 4104,
     /* 190985 */     GIR_EraseRootFromParent_Done,
     /* 190986 */   // Label 2953: @190986
     /* 190986 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(191038), // Rule ID 4101 //
     /* 190991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190994 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191001 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 191014 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2),
     /* 191017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191022 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191036 */     GIR_RootConstrainSelectedInstOperands,
     /* 191037 */     // GIR_Coverage, 4101,
     /* 191037 */     GIR_EraseRootFromParent_Done,
     /* 191038 */   // Label 2954: @191038
     /* 191038 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(191094), // Rule ID 4103 //
     /* 191043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191046 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 191057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 191068 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_RTN),
     /* 191071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191078 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191092 */     GIR_RootConstrainSelectedInstOperands,
     /* 191093 */     // GIR_Coverage, 4103,
     /* 191093 */     GIR_EraseRootFromParent_Done,
     /* 191094 */   // Label 2955: @191094
     /* 191094 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(191147), // Rule ID 3710 //
     /* 191099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191102 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191110 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191123 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 191126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191131 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191145 */     GIR_RootConstrainSelectedInstOperands,
     /* 191146 */     // GIR_Coverage, 3710,
     /* 191146 */     GIR_EraseRootFromParent_Done,
     /* 191147 */   // Label 2956: @191147
     /* 191147 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(191199), // Rule ID 3770 //
     /* 191152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191155 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191162 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191175 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 191178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191183 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191197 */     GIR_RootConstrainSelectedInstOperands,
     /* 191198 */     // GIR_Coverage, 3770,
     /* 191198 */     GIR_EraseRootFromParent_Done,
     /* 191199 */   // Label 2957: @191199
     /* 191199 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(191256), // Rule ID 3709 //
     /* 191204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191207 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 191219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191230 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 191233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191240 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191254 */     GIR_RootConstrainSelectedInstOperands,
     /* 191255 */     // GIR_Coverage, 3709,
     /* 191255 */     GIR_EraseRootFromParent_Done,
     /* 191256 */   // Label 2958: @191256
     /* 191256 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(191312), // Rule ID 3769 //
     /* 191261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191264 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 191275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191286 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 191289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191296 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191310 */     GIR_RootConstrainSelectedInstOperands,
     /* 191311 */     // GIR_Coverage, 3769,
     /* 191311 */     GIR_EraseRootFromParent_Done,
     /* 191312 */   // Label 2959: @191312
     /* 191312 */   GIM_Reject,
     /* 191313 */ // Label 2940: @191313
     /* 191313 */ GIM_Reject,
     /* 191314 */ // Label 2919: @191314
     /* 191314 */ GIM_Reject,
     /* 191315 */ // Label 20: @191315
     /* 191315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2962*/ GIMT_Encode4(193826),
     /* 191326 */ /*GILLT_s32*//*Label 2960*/ GIMT_Encode4(191334),
     /* 191330 */ /*GILLT_s64*//*Label 2961*/ GIMT_Encode4(192580),
     /* 191334 */ // Label 2960: @191334
     /* 191334 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(192579),
     /* 191339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 191342 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(191404), // Rule ID 5585 //
     /* 191347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191357 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191370 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64),
     /* 191373 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191402 */     GIR_RootConstrainSelectedInstOperands,
     /* 191403 */     // GIR_Coverage, 5585,
     /* 191403 */     GIR_EraseRootFromParent_Done,
     /* 191404 */   // Label 2964: @191404
     /* 191404 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(191463), // Rule ID 5589 //
     /* 191409 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191416 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191429 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64),
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191461 */     GIR_RootConstrainSelectedInstOperands,
     /* 191462 */     // GIR_Coverage, 5589,
     /* 191462 */     GIR_EraseRootFromParent_Done,
     /* 191463 */   // Label 2965: @191463
     /* 191463 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(191529), // Rule ID 5583 //
     /* 191468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191471 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191493 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64_RTN),
     /* 191496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191498 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191527 */     GIR_RootConstrainSelectedInstOperands,
     /* 191528 */     // GIR_Coverage, 5583,
     /* 191528 */     GIR_EraseRootFromParent_Done,
     /* 191529 */   // Label 2966: @191529
     /* 191529 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(191592), // Rule ID 5587 //
     /* 191534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191556 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN),
     /* 191559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191561 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191590 */     GIR_RootConstrainSelectedInstOperands,
     /* 191591 */     // GIR_Coverage, 5587,
     /* 191591 */     GIR_EraseRootFromParent_Done,
     /* 191592 */   // Label 2967: @191592
     /* 191592 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(191649), // Rule ID 5584 //
     /* 191597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191600 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191607 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191620 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 191623 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191647 */     GIR_RootConstrainSelectedInstOperands,
     /* 191648 */     // GIR_Coverage, 5584,
     /* 191648 */     GIR_EraseRootFromParent_Done,
     /* 191649 */   // Label 2968: @191649
     /* 191649 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(191703), // Rule ID 5588 //
     /* 191654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191661 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191674 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 191677 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 191702 */     // GIR_Coverage, 5588,
     /* 191702 */     GIR_EraseRootFromParent_Done,
     /* 191703 */   // Label 2969: @191703
     /* 191703 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(191764), // Rule ID 5582 //
     /* 191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191733 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 191736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191738 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191762 */     GIR_RootConstrainSelectedInstOperands,
     /* 191763 */     // GIR_Coverage, 5582,
     /* 191763 */     GIR_EraseRootFromParent_Done,
     /* 191764 */   // Label 2970: @191764
     /* 191764 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(191822), // Rule ID 5586 //
     /* 191769 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191791 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 191794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191796 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191820 */     GIR_RootConstrainSelectedInstOperands,
     /* 191821 */     // GIR_Coverage, 5586,
     /* 191821 */     GIR_EraseRootFromParent_Done,
     /* 191822 */   // Label 2971: @191822
     /* 191822 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(191872), // Rule ID 8133 //
     /* 191827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 191830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191835 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191848 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 191851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191856 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191870 */     GIR_RootConstrainSelectedInstOperands,
     /* 191871 */     // GIR_Coverage, 8133,
     /* 191871 */     GIR_EraseRootFromParent_Done,
     /* 191872 */   // Label 2972: @191872
     /* 191872 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(191922), // Rule ID 8135 //
     /* 191877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 191880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191885 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191898 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_noret_i32>>  =>  (DS_ADD_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32_gfx9),
     /* 191901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191906 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191920 */     GIR_RootConstrainSelectedInstOperands,
     /* 191921 */     // GIR_Coverage, 8135,
     /* 191921 */     GIR_EraseRootFromParent_Done,
     /* 191922 */   // Label 2973: @191922
     /* 191922 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(191972), // Rule ID 8137 //
     /* 191927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 191930 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 191935 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191948 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 191948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 191951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191956 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191970 */     GIR_RootConstrainSelectedInstOperands,
     /* 191971 */     // GIR_Coverage, 8137,
     /* 191971 */     GIR_EraseRootFromParent_Done,
     /* 191972 */   // Label 2974: @191972
     /* 191972 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(192026), // Rule ID 8132 //
     /* 191977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 191980 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192000 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 192003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192024 */     GIR_RootConstrainSelectedInstOperands,
     /* 192025 */     // GIR_Coverage, 8132,
     /* 192025 */     GIR_EraseRootFromParent_Done,
     /* 192026 */   // Label 2975: @192026
     /* 192026 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(192080), // Rule ID 8134 //
     /* 192031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 192034 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192054 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_i32>>  =>  (DS_ADD_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32_gfx9),
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192064 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192078 */     GIR_RootConstrainSelectedInstOperands,
     /* 192079 */     // GIR_Coverage, 8134,
     /* 192079 */     GIR_EraseRootFromParent_Done,
     /* 192080 */   // Label 2976: @192080
     /* 192080 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(192134), // Rule ID 8136 //
     /* 192085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 192088 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192108 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 192111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192118 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192132 */     GIR_RootConstrainSelectedInstOperands,
     /* 192133 */     // GIR_Coverage, 8136,
     /* 192133 */     GIR_EraseRootFromParent_Done,
     /* 192134 */   // Label 2977: @192134
     /* 192134 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(192191), // Rule ID 3554 //
     /* 192139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192142 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192149 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 192162 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 192162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR),
     /* 192165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 192170 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 192177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192189 */     GIR_RootConstrainSelectedInstOperands,
     /* 192190 */     // GIR_Coverage, 3554,
     /* 192190 */     GIR_EraseRootFromParent_Done,
     /* 192191 */   // Label 2978: @192191
     /* 192191 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(192252), // Rule ID 3556 //
     /* 192196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 192221 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 192221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR_RTN),
     /* 192224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 192231 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 192238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192250 */     GIR_RootConstrainSelectedInstOperands,
     /* 192251 */     // GIR_Coverage, 3556,
     /* 192251 */     GIR_EraseRootFromParent_Done,
     /* 192252 */   // Label 2979: @192252
     /* 192252 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(192304), // Rule ID 3553 //
     /* 192257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192260 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192267 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 192280 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD),
     /* 192283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192288 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192302 */     GIR_RootConstrainSelectedInstOperands,
     /* 192303 */     // GIR_Coverage, 3553,
     /* 192303 */     GIR_EraseRootFromParent_Done,
     /* 192304 */   // Label 2980: @192304
     /* 192304 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(192360), // Rule ID 3555 //
     /* 192309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192312 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 192334 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_RTN),
     /* 192337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192344 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192358 */     GIR_RootConstrainSelectedInstOperands,
     /* 192359 */     // GIR_Coverage, 3555,
     /* 192359 */     GIR_EraseRootFromParent_Done,
     /* 192360 */   // Label 2981: @192360
     /* 192360 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(192413), // Rule ID 3541 //
     /* 192365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192376 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192389 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 192392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192397 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192411 */     GIR_RootConstrainSelectedInstOperands,
     /* 192412 */     // GIR_Coverage, 3541,
     /* 192412 */     GIR_EraseRootFromParent_Done,
     /* 192413 */   // Label 2982: @192413
     /* 192413 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(192465), // Rule ID 3724 //
     /* 192418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192428 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192441 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 192444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192449 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192463 */     GIR_RootConstrainSelectedInstOperands,
     /* 192464 */     // GIR_Coverage, 3724,
     /* 192464 */     GIR_EraseRootFromParent_Done,
     /* 192465 */   // Label 2983: @192465
     /* 192465 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(192522), // Rule ID 3542 //
     /* 192470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192473 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192496 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 192499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192506 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192520 */     GIR_RootConstrainSelectedInstOperands,
     /* 192521 */     // GIR_Coverage, 3542,
     /* 192521 */     GIR_EraseRootFromParent_Done,
     /* 192522 */   // Label 2984: @192522
     /* 192522 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(192578), // Rule ID 3723 //
     /* 192527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192552 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 192555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192562 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192576 */     GIR_RootConstrainSelectedInstOperands,
     /* 192577 */     // GIR_Coverage, 3723,
     /* 192577 */     GIR_EraseRootFromParent_Done,
     /* 192578 */   // Label 2985: @192578
     /* 192578 */   GIM_Reject,
     /* 192579 */ // Label 2963: @192579
     /* 192579 */ GIM_Reject,
     /* 192580 */ // Label 2961: @192580
     /* 192580 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(193825),
     /* 192585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 192588 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(192650), // Rule ID 5681 //
     /* 192593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192603 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192616 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64),
     /* 192619 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192648 */     GIR_RootConstrainSelectedInstOperands,
     /* 192649 */     // GIR_Coverage, 5681,
     /* 192649 */     GIR_EraseRootFromParent_Done,
     /* 192650 */   // Label 2987: @192650
     /* 192650 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(192709), // Rule ID 5685 //
     /* 192655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192662 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192675 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64),
     /* 192678 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192707 */     GIR_RootConstrainSelectedInstOperands,
     /* 192708 */     // GIR_Coverage, 5685,
     /* 192708 */     GIR_EraseRootFromParent_Done,
     /* 192709 */   // Label 2988: @192709
     /* 192709 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(192775), // Rule ID 5679 //
     /* 192714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192739 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64_RTN),
     /* 192742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192744 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192773 */     GIR_RootConstrainSelectedInstOperands,
     /* 192774 */     // GIR_Coverage, 5679,
     /* 192774 */     GIR_EraseRootFromParent_Done,
     /* 192775 */   // Label 2989: @192775
     /* 192775 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(192838), // Rule ID 5683 //
     /* 192780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192802 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN),
     /* 192805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192807 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192836 */     GIR_RootConstrainSelectedInstOperands,
     /* 192837 */     // GIR_Coverage, 5683,
     /* 192837 */     GIR_EraseRootFromParent_Done,
     /* 192838 */   // Label 2990: @192838
     /* 192838 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(192895), // Rule ID 5680 //
     /* 192843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192853 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192866 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192893 */     GIR_RootConstrainSelectedInstOperands,
     /* 192894 */     // GIR_Coverage, 5680,
     /* 192894 */     GIR_EraseRootFromParent_Done,
     /* 192895 */   // Label 2991: @192895
     /* 192895 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(192949), // Rule ID 5684 //
     /* 192900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192907 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192920 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 192923 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192947 */     GIR_RootConstrainSelectedInstOperands,
     /* 192948 */     // GIR_Coverage, 5684,
     /* 192948 */     GIR_EraseRootFromParent_Done,
     /* 192949 */   // Label 2992: @192949
     /* 192949 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(193010), // Rule ID 5678 //
     /* 192954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192979 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 192982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192984 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193008 */     GIR_RootConstrainSelectedInstOperands,
     /* 193009 */     // GIR_Coverage, 5678,
     /* 193009 */     GIR_EraseRootFromParent_Done,
     /* 193010 */   // Label 2993: @193010
     /* 193010 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(193068), // Rule ID 5682 //
     /* 193015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193037 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 193040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193042 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193066 */     GIR_RootConstrainSelectedInstOperands,
     /* 193067 */     // GIR_Coverage, 5682,
     /* 193067 */     GIR_EraseRootFromParent_Done,
     /* 193068 */   // Label 2994: @193068
     /* 193068 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(193118), // Rule ID 8236 //
     /* 193073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 193076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193081 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193094 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 193097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193102 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193116 */     GIR_RootConstrainSelectedInstOperands,
     /* 193117 */     // GIR_Coverage, 8236,
     /* 193117 */     GIR_EraseRootFromParent_Done,
     /* 193118 */   // Label 2995: @193118
     /* 193118 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(193168), // Rule ID 8238 //
     /* 193123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 193126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193131 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193144 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_noret_i64>>  =>  (DS_ADD_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64_gfx9),
     /* 193147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193152 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193166 */     GIR_RootConstrainSelectedInstOperands,
     /* 193167 */     // GIR_Coverage, 8238,
     /* 193167 */     GIR_EraseRootFromParent_Done,
     /* 193168 */   // Label 2996: @193168
     /* 193168 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(193218), // Rule ID 8240 //
     /* 193173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 193176 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 193181 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193194 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 193194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 193197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193202 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193216 */     GIR_RootConstrainSelectedInstOperands,
     /* 193217 */     // GIR_Coverage, 8240,
     /* 193217 */     GIR_EraseRootFromParent_Done,
     /* 193218 */   // Label 2997: @193218
     /* 193218 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(193272), // Rule ID 8235 //
     /* 193223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 193226 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193246 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 193249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193256 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193270 */     GIR_RootConstrainSelectedInstOperands,
     /* 193271 */     // GIR_Coverage, 8235,
     /* 193271 */     GIR_EraseRootFromParent_Done,
     /* 193272 */   // Label 2998: @193272
     /* 193272 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(193326), // Rule ID 8237 //
     /* 193277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 193280 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193300 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_i64>>  =>  (DS_ADD_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64_gfx9),
     /* 193303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193310 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193324 */     GIR_RootConstrainSelectedInstOperands,
     /* 193325 */     // GIR_Coverage, 8237,
     /* 193325 */     GIR_EraseRootFromParent_Done,
     /* 193326 */   // Label 2999: @193326
     /* 193326 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(193380), // Rule ID 8239 //
     /* 193331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 193334 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 193339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193354 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 193354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 193357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193364 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193378 */     GIR_RootConstrainSelectedInstOperands,
     /* 193379 */     // GIR_Coverage, 8239,
     /* 193379 */     GIR_EraseRootFromParent_Done,
     /* 193380 */   // Label 3000: @193380
     /* 193380 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(193437), // Rule ID 4062 //
     /* 193385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193408 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR),
     /* 193411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193416 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193435 */     GIR_RootConstrainSelectedInstOperands,
     /* 193436 */     // GIR_Coverage, 4062,
     /* 193436 */     GIR_EraseRootFromParent_Done,
     /* 193437 */   // Label 3001: @193437
     /* 193437 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(193498), // Rule ID 4064 //
     /* 193442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193467 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR_RTN),
     /* 193470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193477 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193496 */     GIR_RootConstrainSelectedInstOperands,
     /* 193497 */     // GIR_Coverage, 4064,
     /* 193497 */     GIR_EraseRootFromParent_Done,
     /* 193498 */   // Label 3002: @193498
     /* 193498 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(193550), // Rule ID 4061 //
     /* 193503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193513 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193526 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2),
     /* 193529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193534 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193548 */     GIR_RootConstrainSelectedInstOperands,
     /* 193549 */     // GIR_Coverage, 4061,
     /* 193549 */     GIR_EraseRootFromParent_Done,
     /* 193550 */   // Label 3003: @193550
     /* 193550 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(193606), // Rule ID 4063 //
     /* 193555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193558 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193580 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_RTN),
     /* 193583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193590 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193604 */     GIR_RootConstrainSelectedInstOperands,
     /* 193605 */     // GIR_Coverage, 4063,
     /* 193605 */     GIR_EraseRootFromParent_Done,
     /* 193606 */   // Label 3004: @193606
     /* 193606 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(193659), // Rule ID 3690 //
     /* 193611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193622 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193635 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 193638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193643 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193657 */     GIR_RootConstrainSelectedInstOperands,
     /* 193658 */     // GIR_Coverage, 3690,
     /* 193658 */     GIR_EraseRootFromParent_Done,
     /* 193659 */   // Label 3005: @193659
     /* 193659 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(193711), // Rule ID 3750 //
     /* 193664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193667 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193674 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193687 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 193690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193709 */     GIR_RootConstrainSelectedInstOperands,
     /* 193710 */     // GIR_Coverage, 3750,
     /* 193710 */     GIR_EraseRootFromParent_Done,
     /* 193711 */   // Label 3006: @193711
     /* 193711 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(193768), // Rule ID 3689 //
     /* 193716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193719 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193742 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 193745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193752 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193766 */     GIR_RootConstrainSelectedInstOperands,
     /* 193767 */     // GIR_Coverage, 3689,
     /* 193767 */     GIR_EraseRootFromParent_Done,
     /* 193768 */   // Label 3007: @193768
     /* 193768 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(193824), // Rule ID 3749 //
     /* 193773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193776 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193798 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 193801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193808 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193822 */     GIR_RootConstrainSelectedInstOperands,
     /* 193823 */     // GIR_Coverage, 3749,
     /* 193823 */     GIR_EraseRootFromParent_Done,
     /* 193824 */   // Label 3008: @193824
     /* 193824 */   GIM_Reject,
     /* 193825 */ // Label 2986: @193825
     /* 193825 */ GIM_Reject,
     /* 193826 */ // Label 2962: @193826
     /* 193826 */ GIM_Reject,
     /* 193827 */ // Label 21: @193827
     /* 193827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3011*/ GIMT_Encode4(196338),
     /* 193838 */ /*GILLT_s32*//*Label 3009*/ GIMT_Encode4(193846),
     /* 193842 */ /*GILLT_s64*//*Label 3010*/ GIMT_Encode4(195092),
     /* 193846 */ // Label 3009: @193846
     /* 193846 */ GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(195091),
     /* 193851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193854 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(193916), // Rule ID 5593 //
     /* 193859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193869 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193882 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64),
     /* 193885 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193914 */     GIR_RootConstrainSelectedInstOperands,
     /* 193915 */     // GIR_Coverage, 5593,
     /* 193915 */     GIR_EraseRootFromParent_Done,
     /* 193916 */   // Label 3013: @193916
     /* 193916 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(193975), // Rule ID 5597 //
     /* 193921 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193928 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193941 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64),
     /* 193944 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193973 */     GIR_RootConstrainSelectedInstOperands,
     /* 193974 */     // GIR_Coverage, 5597,
     /* 193974 */     GIR_EraseRootFromParent_Done,
     /* 193975 */   // Label 3014: @193975
     /* 193975 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(194041), // Rule ID 5591 //
     /* 193980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194005 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64_RTN),
     /* 194008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194010 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194039 */     GIR_RootConstrainSelectedInstOperands,
     /* 194040 */     // GIR_Coverage, 5591,
     /* 194040 */     GIR_EraseRootFromParent_Done,
     /* 194041 */   // Label 3015: @194041
     /* 194041 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(194104), // Rule ID 5595 //
     /* 194046 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194068 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN),
     /* 194071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194073 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194102 */     GIR_RootConstrainSelectedInstOperands,
     /* 194103 */     // GIR_Coverage, 5595,
     /* 194103 */     GIR_EraseRootFromParent_Done,
     /* 194104 */   // Label 3016: @194104
     /* 194104 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(194161), // Rule ID 5592 //
     /* 194109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194112 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194119 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194132 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 194135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194159 */     GIR_RootConstrainSelectedInstOperands,
     /* 194160 */     // GIR_Coverage, 5592,
     /* 194160 */     GIR_EraseRootFromParent_Done,
     /* 194161 */   // Label 3017: @194161
     /* 194161 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(194215), // Rule ID 5596 //
     /* 194166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194173 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194186 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 194189 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194213 */     GIR_RootConstrainSelectedInstOperands,
     /* 194214 */     // GIR_Coverage, 5596,
     /* 194214 */     GIR_EraseRootFromParent_Done,
     /* 194215 */   // Label 3018: @194215
     /* 194215 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(194276), // Rule ID 5590 //
     /* 194220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194223 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194245 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 194248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194250 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194274 */     GIR_RootConstrainSelectedInstOperands,
     /* 194275 */     // GIR_Coverage, 5590,
     /* 194275 */     GIR_EraseRootFromParent_Done,
     /* 194276 */   // Label 3019: @194276
     /* 194276 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(194334), // Rule ID 5594 //
     /* 194281 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194303 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 194306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194308 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194332 */     GIR_RootConstrainSelectedInstOperands,
     /* 194333 */     // GIR_Coverage, 5594,
     /* 194333 */     GIR_EraseRootFromParent_Done,
     /* 194334 */   // Label 3020: @194334
     /* 194334 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(194384), // Rule ID 8149 //
     /* 194339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 194342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194347 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194360 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 194363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194368 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194382 */     GIR_RootConstrainSelectedInstOperands,
     /* 194383 */     // GIR_Coverage, 8149,
     /* 194383 */     GIR_EraseRootFromParent_Done,
     /* 194384 */   // Label 3021: @194384
     /* 194384 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(194434), // Rule ID 8151 //
     /* 194389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 194392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194397 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194410 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i32>>  =>  (DS_SUB_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32_gfx9),
     /* 194413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194418 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194432 */     GIR_RootConstrainSelectedInstOperands,
     /* 194433 */     // GIR_Coverage, 8151,
     /* 194433 */     GIR_EraseRootFromParent_Done,
     /* 194434 */   // Label 3022: @194434
     /* 194434 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(194484), // Rule ID 8153 //
     /* 194439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 194442 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 194447 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194460 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 194460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 194463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194468 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194482 */     GIR_RootConstrainSelectedInstOperands,
     /* 194483 */     // GIR_Coverage, 8153,
     /* 194483 */     GIR_EraseRootFromParent_Done,
     /* 194484 */   // Label 3023: @194484
     /* 194484 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(194538), // Rule ID 8148 //
     /* 194489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 194492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194512 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 194515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194522 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194536 */     GIR_RootConstrainSelectedInstOperands,
     /* 194537 */     // GIR_Coverage, 8148,
     /* 194537 */     GIR_EraseRootFromParent_Done,
     /* 194538 */   // Label 3024: @194538
     /* 194538 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(194592), // Rule ID 8150 //
     /* 194543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 194546 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194566 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_i32>>  =>  (DS_SUB_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32_gfx9),
     /* 194569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194576 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194590 */     GIR_RootConstrainSelectedInstOperands,
     /* 194591 */     // GIR_Coverage, 8150,
     /* 194591 */     GIR_EraseRootFromParent_Done,
     /* 194592 */   // Label 3025: @194592
     /* 194592 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(194646), // Rule ID 8152 //
     /* 194597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 194600 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 194605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194620 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 194620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 194623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194630 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194644 */     GIR_RootConstrainSelectedInstOperands,
     /* 194645 */     // GIR_Coverage, 8152,
     /* 194645 */     GIR_EraseRootFromParent_Done,
     /* 194646 */   // Label 3026: @194646
     /* 194646 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(194703), // Rule ID 4010 //
     /* 194651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194661 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194674 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR),
     /* 194677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194682 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194701 */     GIR_RootConstrainSelectedInstOperands,
     /* 194702 */     // GIR_Coverage, 4010,
     /* 194702 */     GIR_EraseRootFromParent_Done,
     /* 194703 */   // Label 3027: @194703
     /* 194703 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(194764), // Rule ID 4012 //
     /* 194708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194733 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR_RTN),
     /* 194736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194743 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194762 */     GIR_RootConstrainSelectedInstOperands,
     /* 194763 */     // GIR_Coverage, 4012,
     /* 194763 */     GIR_EraseRootFromParent_Done,
     /* 194764 */   // Label 3028: @194764
     /* 194764 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(194816), // Rule ID 4009 //
     /* 194769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194772 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194779 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194792 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB),
     /* 194795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194800 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194814 */     GIR_RootConstrainSelectedInstOperands,
     /* 194815 */     // GIR_Coverage, 4009,
     /* 194815 */     GIR_EraseRootFromParent_Done,
     /* 194816 */   // Label 3029: @194816
     /* 194816 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(194872), // Rule ID 4011 //
     /* 194821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194846 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_RTN),
     /* 194849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194856 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194870 */     GIR_RootConstrainSelectedInstOperands,
     /* 194871 */     // GIR_Coverage, 4011,
     /* 194871 */     GIR_EraseRootFromParent_Done,
     /* 194872 */   // Label 3030: @194872
     /* 194872 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(194925), // Rule ID 3666 //
     /* 194877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194888 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194901 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 194904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194909 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194923 */     GIR_RootConstrainSelectedInstOperands,
     /* 194924 */     // GIR_Coverage, 3666,
     /* 194924 */     GIR_EraseRootFromParent_Done,
     /* 194925 */   // Label 3031: @194925
     /* 194925 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(194977), // Rule ID 3726 //
     /* 194930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194940 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194953 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 194956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194961 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194975 */     GIR_RootConstrainSelectedInstOperands,
     /* 194976 */     // GIR_Coverage, 3726,
     /* 194976 */     GIR_EraseRootFromParent_Done,
     /* 194977 */   // Label 3032: @194977
     /* 194977 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(195034), // Rule ID 3665 //
     /* 194982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194985 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 195008 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 195008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 195011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195018 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195032 */     GIR_RootConstrainSelectedInstOperands,
     /* 195033 */     // GIR_Coverage, 3665,
     /* 195033 */     GIR_EraseRootFromParent_Done,
     /* 195034 */   // Label 3033: @195034
     /* 195034 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(195090), // Rule ID 3725 //
     /* 195039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 195042 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 195064 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 195064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 195067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195074 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195088 */     GIR_RootConstrainSelectedInstOperands,
     /* 195089 */     // GIR_Coverage, 3725,
     /* 195089 */     GIR_EraseRootFromParent_Done,
     /* 195090 */   // Label 3034: @195090
     /* 195090 */   GIM_Reject,
     /* 195091 */ // Label 3012: @195091
     /* 195091 */ GIM_Reject,
     /* 195092 */ // Label 3010: @195092
     /* 195092 */ GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(196337),
     /* 195097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195100 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(195162), // Rule ID 5689 //
     /* 195105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195108 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195115 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195128 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64),
     /* 195131 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195160 */     GIR_RootConstrainSelectedInstOperands,
     /* 195161 */     // GIR_Coverage, 5689,
     /* 195161 */     GIR_EraseRootFromParent_Done,
     /* 195162 */   // Label 3036: @195162
     /* 195162 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(195221), // Rule ID 5693 //
     /* 195167 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195174 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195187 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64),
     /* 195190 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195219 */     GIR_RootConstrainSelectedInstOperands,
     /* 195220 */     // GIR_Coverage, 5693,
     /* 195220 */     GIR_EraseRootFromParent_Done,
     /* 195221 */   // Label 3037: @195221
     /* 195221 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(195287), // Rule ID 5687 //
     /* 195226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195229 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195251 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64_RTN),
     /* 195254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195256 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195285 */     GIR_RootConstrainSelectedInstOperands,
     /* 195286 */     // GIR_Coverage, 5687,
     /* 195286 */     GIR_EraseRootFromParent_Done,
     /* 195287 */   // Label 3038: @195287
     /* 195287 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(195350), // Rule ID 5691 //
     /* 195292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195314 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN),
     /* 195317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195319 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195348 */     GIR_RootConstrainSelectedInstOperands,
     /* 195349 */     // GIR_Coverage, 5691,
     /* 195349 */     GIR_EraseRootFromParent_Done,
     /* 195350 */   // Label 3039: @195350
     /* 195350 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(195407), // Rule ID 5688 //
     /* 195355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195365 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195378 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 195381 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195405 */     GIR_RootConstrainSelectedInstOperands,
     /* 195406 */     // GIR_Coverage, 5688,
     /* 195406 */     GIR_EraseRootFromParent_Done,
     /* 195407 */   // Label 3040: @195407
     /* 195407 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(195461), // Rule ID 5692 //
     /* 195412 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195419 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195432 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 195435 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195459 */     GIR_RootConstrainSelectedInstOperands,
     /* 195460 */     // GIR_Coverage, 5692,
     /* 195460 */     GIR_EraseRootFromParent_Done,
     /* 195461 */   // Label 3041: @195461
     /* 195461 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(195522), // Rule ID 5686 //
     /* 195466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195491 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 195494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195496 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195520 */     GIR_RootConstrainSelectedInstOperands,
     /* 195521 */     // GIR_Coverage, 5686,
     /* 195521 */     GIR_EraseRootFromParent_Done,
     /* 195522 */   // Label 3042: @195522
     /* 195522 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(195580), // Rule ID 5690 //
     /* 195527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195549 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 195552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195554 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195578 */     GIR_RootConstrainSelectedInstOperands,
     /* 195579 */     // GIR_Coverage, 5690,
     /* 195579 */     GIR_EraseRootFromParent_Done,
     /* 195580 */   // Label 3043: @195580
     /* 195580 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(195630), // Rule ID 8242 //
     /* 195585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195588 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195593 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195606 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 195609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195614 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195628 */     GIR_RootConstrainSelectedInstOperands,
     /* 195629 */     // GIR_Coverage, 8242,
     /* 195629 */     GIR_EraseRootFromParent_Done,
     /* 195630 */   // Label 3044: @195630
     /* 195630 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(195680), // Rule ID 8244 //
     /* 195635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195643 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195656 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i64>>  =>  (DS_SUB_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64_gfx9),
     /* 195659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195664 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195678 */     GIR_RootConstrainSelectedInstOperands,
     /* 195679 */     // GIR_Coverage, 8244,
     /* 195679 */     GIR_EraseRootFromParent_Done,
     /* 195680 */   // Label 3045: @195680
     /* 195680 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(195730), // Rule ID 8246 //
     /* 195685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195688 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195693 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195706 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 195709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195714 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195728 */     GIR_RootConstrainSelectedInstOperands,
     /* 195729 */     // GIR_Coverage, 8246,
     /* 195729 */     GIR_EraseRootFromParent_Done,
     /* 195730 */   // Label 3046: @195730
     /* 195730 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(195784), // Rule ID 8241 //
     /* 195735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195738 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195758 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 195761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195768 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195782 */     GIR_RootConstrainSelectedInstOperands,
     /* 195783 */     // GIR_Coverage, 8241,
     /* 195783 */     GIR_EraseRootFromParent_Done,
     /* 195784 */   // Label 3047: @195784
     /* 195784 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(195838), // Rule ID 8243 //
     /* 195789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195792 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195812 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_i64>>  =>  (DS_SUB_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64_gfx9),
     /* 195815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195822 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195836 */     GIR_RootConstrainSelectedInstOperands,
     /* 195837 */     // GIR_Coverage, 8243,
     /* 195837 */     GIR_EraseRootFromParent_Done,
     /* 195838 */   // Label 3048: @195838
     /* 195838 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(195892), // Rule ID 8245 //
     /* 195843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195866 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 195869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195876 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195890 */     GIR_RootConstrainSelectedInstOperands,
     /* 195891 */     // GIR_Coverage, 8245,
     /* 195891 */     GIR_EraseRootFromParent_Done,
     /* 195892 */   // Label 3049: @195892
     /* 195892 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(195949), // Rule ID 4066 //
     /* 195897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195907 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195920 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR),
     /* 195923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 195928 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 195935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195947 */     GIR_RootConstrainSelectedInstOperands,
     /* 195948 */     // GIR_Coverage, 4066,
     /* 195948 */     GIR_EraseRootFromParent_Done,
     /* 195949 */   // Label 3050: @195949
     /* 195949 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(196010), // Rule ID 4068 //
     /* 195954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195979 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR_RTN),
     /* 195982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 195989 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 195996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196008 */     GIR_RootConstrainSelectedInstOperands,
     /* 196009 */     // GIR_Coverage, 4068,
     /* 196009 */     GIR_EraseRootFromParent_Done,
     /* 196010 */   // Label 3051: @196010
     /* 196010 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(196062), // Rule ID 4065 //
     /* 196015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196018 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196025 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 196038 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2),
     /* 196041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196046 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196060 */     GIR_RootConstrainSelectedInstOperands,
     /* 196061 */     // GIR_Coverage, 4065,
     /* 196061 */     GIR_EraseRootFromParent_Done,
     /* 196062 */   // Label 3052: @196062
     /* 196062 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(196118), // Rule ID 4067 //
     /* 196067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 196092 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_RTN),
     /* 196095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196102 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196116 */     GIR_RootConstrainSelectedInstOperands,
     /* 196117 */     // GIR_Coverage, 4067,
     /* 196117 */     GIR_EraseRootFromParent_Done,
     /* 196118 */   // Label 3053: @196118
     /* 196118 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(196171), // Rule ID 3692 //
     /* 196123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196134 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196147 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 196150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196155 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196169 */     GIR_RootConstrainSelectedInstOperands,
     /* 196170 */     // GIR_Coverage, 3692,
     /* 196170 */     GIR_EraseRootFromParent_Done,
     /* 196171 */   // Label 3054: @196171
     /* 196171 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(196223), // Rule ID 3752 //
     /* 196176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196186 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196199 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 196202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196207 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196221 */     GIR_RootConstrainSelectedInstOperands,
     /* 196222 */     // GIR_Coverage, 3752,
     /* 196222 */     GIR_EraseRootFromParent_Done,
     /* 196223 */   // Label 3055: @196223
     /* 196223 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(196280), // Rule ID 3691 //
     /* 196228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196254 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 196257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196264 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196278 */     GIR_RootConstrainSelectedInstOperands,
     /* 196279 */     // GIR_Coverage, 3691,
     /* 196279 */     GIR_EraseRootFromParent_Done,
     /* 196280 */   // Label 3056: @196280
     /* 196280 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(196336), // Rule ID 3751 //
     /* 196285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196310 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 196313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196320 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196334 */     GIR_RootConstrainSelectedInstOperands,
     /* 196335 */     // GIR_Coverage, 3751,
     /* 196335 */     GIR_EraseRootFromParent_Done,
     /* 196336 */   // Label 3057: @196336
     /* 196336 */   GIM_Reject,
     /* 196337 */ // Label 3035: @196337
     /* 196337 */ GIM_Reject,
     /* 196338 */ // Label 3011: @196338
     /* 196338 */ GIM_Reject,
     /* 196339 */ // Label 22: @196339
     /* 196339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3060*/ GIMT_Encode4(198850),
     /* 196350 */ /*GILLT_s32*//*Label 3058*/ GIMT_Encode4(196358),
     /* 196354 */ /*GILLT_s64*//*Label 3059*/ GIMT_Encode4(197604),
     /* 196358 */ // Label 3058: @196358
     /* 196358 */ GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(197603),
     /* 196363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196366 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(196428), // Rule ID 5633 //
     /* 196371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196374 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196381 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196394 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64),
     /* 196397 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196426 */     GIR_RootConstrainSelectedInstOperands,
     /* 196427 */     // GIR_Coverage, 5633,
     /* 196427 */     GIR_EraseRootFromParent_Done,
     /* 196428 */   // Label 3062: @196428
     /* 196428 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(196487), // Rule ID 5637 //
     /* 196433 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196440 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196453 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64),
     /* 196456 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196485 */     GIR_RootConstrainSelectedInstOperands,
     /* 196486 */     // GIR_Coverage, 5637,
     /* 196486 */     GIR_EraseRootFromParent_Done,
     /* 196487 */   // Label 3063: @196487
     /* 196487 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(196553), // Rule ID 5631 //
     /* 196492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196517 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64_RTN),
     /* 196520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196522 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196551 */     GIR_RootConstrainSelectedInstOperands,
     /* 196552 */     // GIR_Coverage, 5631,
     /* 196552 */     GIR_EraseRootFromParent_Done,
     /* 196553 */   // Label 3064: @196553
     /* 196553 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(196616), // Rule ID 5635 //
     /* 196558 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196580 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN),
     /* 196583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196585 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196614 */     GIR_RootConstrainSelectedInstOperands,
     /* 196615 */     // GIR_Coverage, 5635,
     /* 196615 */     GIR_EraseRootFromParent_Done,
     /* 196616 */   // Label 3065: @196616
     /* 196616 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(196673), // Rule ID 5632 //
     /* 196621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196624 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196631 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196644 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 196647 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196671 */     GIR_RootConstrainSelectedInstOperands,
     /* 196672 */     // GIR_Coverage, 5632,
     /* 196672 */     GIR_EraseRootFromParent_Done,
     /* 196673 */   // Label 3066: @196673
     /* 196673 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(196727), // Rule ID 5636 //
     /* 196678 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196685 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196698 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 196701 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196725 */     GIR_RootConstrainSelectedInstOperands,
     /* 196726 */     // GIR_Coverage, 5636,
     /* 196726 */     GIR_EraseRootFromParent_Done,
     /* 196727 */   // Label 3067: @196727
     /* 196727 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(196788), // Rule ID 5630 //
     /* 196732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196757 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 196760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196786 */     GIR_RootConstrainSelectedInstOperands,
     /* 196787 */     // GIR_Coverage, 5630,
     /* 196787 */     GIR_EraseRootFromParent_Done,
     /* 196788 */   // Label 3068: @196788
     /* 196788 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(196846), // Rule ID 5634 //
     /* 196793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196815 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 196818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196820 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196844 */     GIR_RootConstrainSelectedInstOperands,
     /* 196845 */     // GIR_Coverage, 5634,
     /* 196845 */     GIR_EraseRootFromParent_Done,
     /* 196846 */   // Label 3069: @196846
     /* 196846 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(196896), // Rule ID 8167 //
     /* 196851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 196854 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196859 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196872 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 196875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196880 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196894 */     GIR_RootConstrainSelectedInstOperands,
     /* 196895 */     // GIR_Coverage, 8167,
     /* 196895 */     GIR_EraseRootFromParent_Done,
     /* 196896 */   // Label 3070: @196896
     /* 196896 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(196946), // Rule ID 8169 //
     /* 196901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 196904 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196909 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196922 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_noret_i32>>  =>  (DS_AND_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32_gfx9),
     /* 196925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196930 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196944 */     GIR_RootConstrainSelectedInstOperands,
     /* 196945 */     // GIR_Coverage, 8169,
     /* 196945 */     GIR_EraseRootFromParent_Done,
     /* 196946 */   // Label 3071: @196946
     /* 196946 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(196996), // Rule ID 8171 //
     /* 196951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 196954 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 196959 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196972 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 196972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 196975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196980 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196994 */     GIR_RootConstrainSelectedInstOperands,
     /* 196995 */     // GIR_Coverage, 8171,
     /* 196995 */     GIR_EraseRootFromParent_Done,
     /* 196996 */   // Label 3072: @196996
     /* 196996 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(197050), // Rule ID 8166 //
     /* 197001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 197004 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197024 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 197027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197034 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197048 */     GIR_RootConstrainSelectedInstOperands,
     /* 197049 */     // GIR_Coverage, 8166,
     /* 197049 */     GIR_EraseRootFromParent_Done,
     /* 197050 */   // Label 3073: @197050
     /* 197050 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(197104), // Rule ID 8168 //
     /* 197055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 197058 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197078 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_i32>>  =>  (DS_AND_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32_gfx9),
     /* 197081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197088 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197102 */     GIR_RootConstrainSelectedInstOperands,
     /* 197103 */     // GIR_Coverage, 8168,
     /* 197103 */     GIR_EraseRootFromParent_Done,
     /* 197104 */   // Label 3074: @197104
     /* 197104 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(197158), // Rule ID 8170 //
     /* 197109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 197112 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 197117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197132 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 197132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 197135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197142 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197156 */     GIR_RootConstrainSelectedInstOperands,
     /* 197157 */     // GIR_Coverage, 8170,
     /* 197157 */     GIR_EraseRootFromParent_Done,
     /* 197158 */   // Label 3075: @197158
     /* 197158 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(197215), // Rule ID 4022 //
     /* 197163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197173 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 197186 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 197186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR),
     /* 197189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 197194 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 197201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197213 */     GIR_RootConstrainSelectedInstOperands,
     /* 197214 */     // GIR_Coverage, 4022,
     /* 197214 */     GIR_EraseRootFromParent_Done,
     /* 197215 */   // Label 3076: @197215
     /* 197215 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(197276), // Rule ID 4024 //
     /* 197220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197223 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 197245 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 197245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR_RTN),
     /* 197248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 197255 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 197262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197274 */     GIR_RootConstrainSelectedInstOperands,
     /* 197275 */     // GIR_Coverage, 4024,
     /* 197275 */     GIR_EraseRootFromParent_Done,
     /* 197276 */   // Label 3077: @197276
     /* 197276 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(197328), // Rule ID 4021 //
     /* 197281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197284 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197291 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197304 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND),
     /* 197307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197312 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197326 */     GIR_RootConstrainSelectedInstOperands,
     /* 197327 */     // GIR_Coverage, 4021,
     /* 197327 */     GIR_EraseRootFromParent_Done,
     /* 197328 */   // Label 3078: @197328
     /* 197328 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(197384), // Rule ID 4023 //
     /* 197333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197358 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_RTN),
     /* 197361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197368 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197382 */     GIR_RootConstrainSelectedInstOperands,
     /* 197383 */     // GIR_Coverage, 4023,
     /* 197383 */     GIR_EraseRootFromParent_Done,
     /* 197384 */   // Label 3079: @197384
     /* 197384 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(197437), // Rule ID 3672 //
     /* 197389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197400 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197413 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 197416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197421 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197435 */     GIR_RootConstrainSelectedInstOperands,
     /* 197436 */     // GIR_Coverage, 3672,
     /* 197436 */     GIR_EraseRootFromParent_Done,
     /* 197437 */   // Label 3080: @197437
     /* 197437 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(197489), // Rule ID 3732 //
     /* 197442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197452 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197465 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 197468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197473 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197487 */     GIR_RootConstrainSelectedInstOperands,
     /* 197488 */     // GIR_Coverage, 3732,
     /* 197488 */     GIR_EraseRootFromParent_Done,
     /* 197489 */   // Label 3081: @197489
     /* 197489 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(197546), // Rule ID 3671 //
     /* 197494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197497 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197520 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 197523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197530 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197544 */     GIR_RootConstrainSelectedInstOperands,
     /* 197545 */     // GIR_Coverage, 3671,
     /* 197545 */     GIR_EraseRootFromParent_Done,
     /* 197546 */   // Label 3082: @197546
     /* 197546 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(197602), // Rule ID 3731 //
     /* 197551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197554 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197576 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 197579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197586 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197600 */     GIR_RootConstrainSelectedInstOperands,
     /* 197601 */     // GIR_Coverage, 3731,
     /* 197601 */     GIR_EraseRootFromParent_Done,
     /* 197602 */   // Label 3083: @197602
     /* 197602 */   GIM_Reject,
     /* 197603 */ // Label 3061: @197603
     /* 197603 */ GIM_Reject,
     /* 197604 */ // Label 3059: @197604
     /* 197604 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(198849),
     /* 197609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197612 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(197674), // Rule ID 5729 //
     /* 197617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197627 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197640 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64),
     /* 197643 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197672 */     GIR_RootConstrainSelectedInstOperands,
     /* 197673 */     // GIR_Coverage, 5729,
     /* 197673 */     GIR_EraseRootFromParent_Done,
     /* 197674 */   // Label 3085: @197674
     /* 197674 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(197733), // Rule ID 5733 //
     /* 197679 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197699 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64),
     /* 197702 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197731 */     GIR_RootConstrainSelectedInstOperands,
     /* 197732 */     // GIR_Coverage, 5733,
     /* 197732 */     GIR_EraseRootFromParent_Done,
     /* 197733 */   // Label 3086: @197733
     /* 197733 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(197799), // Rule ID 5727 //
     /* 197738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197763 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64_RTN),
     /* 197766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197768 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197797 */     GIR_RootConstrainSelectedInstOperands,
     /* 197798 */     // GIR_Coverage, 5727,
     /* 197798 */     GIR_EraseRootFromParent_Done,
     /* 197799 */   // Label 3087: @197799
     /* 197799 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(197862), // Rule ID 5731 //
     /* 197804 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197826 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN),
     /* 197829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197831 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197860 */     GIR_RootConstrainSelectedInstOperands,
     /* 197861 */     // GIR_Coverage, 5731,
     /* 197861 */     GIR_EraseRootFromParent_Done,
     /* 197862 */   // Label 3088: @197862
     /* 197862 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(197919), // Rule ID 5728 //
     /* 197867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197877 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197890 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 197893 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197917 */     GIR_RootConstrainSelectedInstOperands,
     /* 197918 */     // GIR_Coverage, 5728,
     /* 197918 */     GIR_EraseRootFromParent_Done,
     /* 197919 */   // Label 3089: @197919
     /* 197919 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(197973), // Rule ID 5732 //
     /* 197924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197944 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 197947 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197971 */     GIR_RootConstrainSelectedInstOperands,
     /* 197972 */     // GIR_Coverage, 5732,
     /* 197972 */     GIR_EraseRootFromParent_Done,
     /* 197973 */   // Label 3090: @197973
     /* 197973 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(198034), // Rule ID 5726 //
     /* 197978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197981 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198003 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 198006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198008 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198032 */     GIR_RootConstrainSelectedInstOperands,
     /* 198033 */     // GIR_Coverage, 5726,
     /* 198033 */     GIR_EraseRootFromParent_Done,
     /* 198034 */   // Label 3091: @198034
     /* 198034 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(198092), // Rule ID 5730 //
     /* 198039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198061 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 198064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198066 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198090 */     GIR_RootConstrainSelectedInstOperands,
     /* 198091 */     // GIR_Coverage, 5730,
     /* 198091 */     GIR_EraseRootFromParent_Done,
     /* 198092 */   // Label 3092: @198092
     /* 198092 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(198142), // Rule ID 8260 //
     /* 198097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 198100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198105 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198118 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 198121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198126 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198140 */     GIR_RootConstrainSelectedInstOperands,
     /* 198141 */     // GIR_Coverage, 8260,
     /* 198141 */     GIR_EraseRootFromParent_Done,
     /* 198142 */   // Label 3093: @198142
     /* 198142 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(198192), // Rule ID 8262 //
     /* 198147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 198150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198155 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198168 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_noret_i64>>  =>  (DS_AND_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64_gfx9),
     /* 198171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198176 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198190 */     GIR_RootConstrainSelectedInstOperands,
     /* 198191 */     // GIR_Coverage, 8262,
     /* 198191 */     GIR_EraseRootFromParent_Done,
     /* 198192 */   // Label 3094: @198192
     /* 198192 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(198242), // Rule ID 8264 //
     /* 198197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 198200 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 198205 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198218 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 198218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 198221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198226 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198240 */     GIR_RootConstrainSelectedInstOperands,
     /* 198241 */     // GIR_Coverage, 8264,
     /* 198241 */     GIR_EraseRootFromParent_Done,
     /* 198242 */   // Label 3095: @198242
     /* 198242 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(198296), // Rule ID 8259 //
     /* 198247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 198250 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198270 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 198273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198280 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198294 */     GIR_RootConstrainSelectedInstOperands,
     /* 198295 */     // GIR_Coverage, 8259,
     /* 198295 */     GIR_EraseRootFromParent_Done,
     /* 198296 */   // Label 3096: @198296
     /* 198296 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(198350), // Rule ID 8261 //
     /* 198301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 198304 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198324 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_i64>>  =>  (DS_AND_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64_gfx9),
     /* 198327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198334 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198348 */     GIR_RootConstrainSelectedInstOperands,
     /* 198349 */     // GIR_Coverage, 8261,
     /* 198349 */     GIR_EraseRootFromParent_Done,
     /* 198350 */   // Label 3097: @198350
     /* 198350 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(198404), // Rule ID 8263 //
     /* 198355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 198358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 198363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198378 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 198378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 198381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198388 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198402 */     GIR_RootConstrainSelectedInstOperands,
     /* 198403 */     // GIR_Coverage, 8263,
     /* 198403 */     GIR_EraseRootFromParent_Done,
     /* 198404 */   // Label 3098: @198404
     /* 198404 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(198461), // Rule ID 4078 //
     /* 198409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198412 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198419 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198432 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR),
     /* 198435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198440 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198459 */     GIR_RootConstrainSelectedInstOperands,
     /* 198460 */     // GIR_Coverage, 4078,
     /* 198460 */     GIR_EraseRootFromParent_Done,
     /* 198461 */   // Label 3099: @198461
     /* 198461 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(198522), // Rule ID 4080 //
     /* 198466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198491 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR_RTN),
     /* 198494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198501 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198520 */     GIR_RootConstrainSelectedInstOperands,
     /* 198521 */     // GIR_Coverage, 4080,
     /* 198521 */     GIR_EraseRootFromParent_Done,
     /* 198522 */   // Label 3100: @198522
     /* 198522 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(198574), // Rule ID 4077 //
     /* 198527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198537 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198550 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2),
     /* 198553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198558 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198572 */     GIR_RootConstrainSelectedInstOperands,
     /* 198573 */     // GIR_Coverage, 4077,
     /* 198573 */     GIR_EraseRootFromParent_Done,
     /* 198574 */   // Label 3101: @198574
     /* 198574 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(198630), // Rule ID 4079 //
     /* 198579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198582 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198604 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_RTN),
     /* 198607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198614 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198628 */     GIR_RootConstrainSelectedInstOperands,
     /* 198629 */     // GIR_Coverage, 4079,
     /* 198629 */     GIR_EraseRootFromParent_Done,
     /* 198630 */   // Label 3102: @198630
     /* 198630 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(198683), // Rule ID 3698 //
     /* 198635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198646 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198659 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 198662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198667 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198681 */     GIR_RootConstrainSelectedInstOperands,
     /* 198682 */     // GIR_Coverage, 3698,
     /* 198682 */     GIR_EraseRootFromParent_Done,
     /* 198683 */   // Label 3103: @198683
     /* 198683 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(198735), // Rule ID 3758 //
     /* 198688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198691 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198698 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198711 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 198714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198719 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198733 */     GIR_RootConstrainSelectedInstOperands,
     /* 198734 */     // GIR_Coverage, 3758,
     /* 198734 */     GIR_EraseRootFromParent_Done,
     /* 198735 */   // Label 3104: @198735
     /* 198735 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(198792), // Rule ID 3697 //
     /* 198740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198743 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198766 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 198769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198776 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198790 */     GIR_RootConstrainSelectedInstOperands,
     /* 198791 */     // GIR_Coverage, 3697,
     /* 198791 */     GIR_EraseRootFromParent_Done,
     /* 198792 */   // Label 3105: @198792
     /* 198792 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(198848), // Rule ID 3757 //
     /* 198797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198822 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 198825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198832 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198846 */     GIR_RootConstrainSelectedInstOperands,
     /* 198847 */     // GIR_Coverage, 3757,
     /* 198847 */     GIR_EraseRootFromParent_Done,
     /* 198848 */   // Label 3106: @198848
     /* 198848 */   GIM_Reject,
     /* 198849 */ // Label 3084: @198849
     /* 198849 */ GIM_Reject,
     /* 198850 */ // Label 3060: @198850
     /* 198850 */ GIM_Reject,
     /* 198851 */ // Label 23: @198851
     /* 198851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3109*/ GIMT_Encode4(201362),
     /* 198862 */ /*GILLT_s32*//*Label 3107*/ GIMT_Encode4(198870),
     /* 198866 */ /*GILLT_s64*//*Label 3108*/ GIMT_Encode4(200116),
     /* 198870 */ // Label 3107: @198870
     /* 198870 */ GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(200115),
     /* 198875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198878 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(198940), // Rule ID 5641 //
     /* 198883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198886 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198893 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198906 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64),
     /* 198909 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198938 */     GIR_RootConstrainSelectedInstOperands,
     /* 198939 */     // GIR_Coverage, 5641,
     /* 198939 */     GIR_EraseRootFromParent_Done,
     /* 198940 */   // Label 3111: @198940
     /* 198940 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(198999), // Rule ID 5645 //
     /* 198945 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198952 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198965 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64),
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198997 */     GIR_RootConstrainSelectedInstOperands,
     /* 198998 */     // GIR_Coverage, 5645,
     /* 198998 */     GIR_EraseRootFromParent_Done,
     /* 198999 */   // Label 3112: @198999
     /* 198999 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(199065), // Rule ID 5639 //
     /* 199004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199029 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64_RTN),
     /* 199032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199034 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 199056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199063 */     GIR_RootConstrainSelectedInstOperands,
     /* 199064 */     // GIR_Coverage, 5639,
     /* 199064 */     GIR_EraseRootFromParent_Done,
     /* 199065 */   // Label 3113: @199065
     /* 199065 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(199128), // Rule ID 5643 //
     /* 199070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199092 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN),
     /* 199095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199097 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 199119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199126 */     GIR_RootConstrainSelectedInstOperands,
     /* 199127 */     // GIR_Coverage, 5643,
     /* 199127 */     GIR_EraseRootFromParent_Done,
     /* 199128 */   // Label 3114: @199128
     /* 199128 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(199185), // Rule ID 5640 //
     /* 199133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199136 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199143 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199156 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 199159 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199183 */     GIR_RootConstrainSelectedInstOperands,
     /* 199184 */     // GIR_Coverage, 5640,
     /* 199184 */     GIR_EraseRootFromParent_Done,
     /* 199185 */   // Label 3115: @199185
     /* 199185 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(199239), // Rule ID 5644 //
     /* 199190 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199197 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199210 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 199213 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199237 */     GIR_RootConstrainSelectedInstOperands,
     /* 199238 */     // GIR_Coverage, 5644,
     /* 199238 */     GIR_EraseRootFromParent_Done,
     /* 199239 */   // Label 3116: @199239
     /* 199239 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(199300), // Rule ID 5638 //
     /* 199244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199247 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199269 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 199272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199298 */     GIR_RootConstrainSelectedInstOperands,
     /* 199299 */     // GIR_Coverage, 5638,
     /* 199299 */     GIR_EraseRootFromParent_Done,
     /* 199300 */   // Label 3117: @199300
     /* 199300 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(199358), // Rule ID 5642 //
     /* 199305 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199327 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 199330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199332 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199356 */     GIR_RootConstrainSelectedInstOperands,
     /* 199357 */     // GIR_Coverage, 5642,
     /* 199357 */     GIR_EraseRootFromParent_Done,
     /* 199358 */   // Label 3118: @199358
     /* 199358 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(199408), // Rule ID 8173 //
     /* 199363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199366 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199371 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199384 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 199387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199392 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199406 */     GIR_RootConstrainSelectedInstOperands,
     /* 199407 */     // GIR_Coverage, 8173,
     /* 199407 */     GIR_EraseRootFromParent_Done,
     /* 199408 */   // Label 3119: @199408
     /* 199408 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(199458), // Rule ID 8175 //
     /* 199413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199421 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199434 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_noret_i32>>  =>  (DS_OR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32_gfx9),
     /* 199437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199442 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199456 */     GIR_RootConstrainSelectedInstOperands,
     /* 199457 */     // GIR_Coverage, 8175,
     /* 199457 */     GIR_EraseRootFromParent_Done,
     /* 199458 */   // Label 3120: @199458
     /* 199458 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(199508), // Rule ID 8177 //
     /* 199463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199466 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199471 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199484 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 199487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199492 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199506 */     GIR_RootConstrainSelectedInstOperands,
     /* 199507 */     // GIR_Coverage, 8177,
     /* 199507 */     GIR_EraseRootFromParent_Done,
     /* 199508 */   // Label 3121: @199508
     /* 199508 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(199562), // Rule ID 8172 //
     /* 199513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199516 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199536 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 199539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199546 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199560 */     GIR_RootConstrainSelectedInstOperands,
     /* 199561 */     // GIR_Coverage, 8172,
     /* 199561 */     GIR_EraseRootFromParent_Done,
     /* 199562 */   // Label 3122: @199562
     /* 199562 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(199616), // Rule ID 8174 //
     /* 199567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199570 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199590 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_i32>>  =>  (DS_OR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32_gfx9),
     /* 199593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199600 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199614 */     GIR_RootConstrainSelectedInstOperands,
     /* 199615 */     // GIR_Coverage, 8174,
     /* 199615 */     GIR_EraseRootFromParent_Done,
     /* 199616 */   // Label 3123: @199616
     /* 199616 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(199670), // Rule ID 8176 //
     /* 199621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199624 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199644 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 199647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199654 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199668 */     GIR_RootConstrainSelectedInstOperands,
     /* 199669 */     // GIR_Coverage, 8176,
     /* 199669 */     GIR_EraseRootFromParent_Done,
     /* 199670 */   // Label 3124: @199670
     /* 199670 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(199727), // Rule ID 4042 //
     /* 199675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199678 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199685 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199698 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR),
     /* 199701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199706 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199725 */     GIR_RootConstrainSelectedInstOperands,
     /* 199726 */     // GIR_Coverage, 4042,
     /* 199726 */     GIR_EraseRootFromParent_Done,
     /* 199727 */   // Label 3125: @199727
     /* 199727 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(199788), // Rule ID 4044 //
     /* 199732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199757 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR_RTN),
     /* 199760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199786 */     GIR_RootConstrainSelectedInstOperands,
     /* 199787 */     // GIR_Coverage, 4044,
     /* 199787 */     GIR_EraseRootFromParent_Done,
     /* 199788 */   // Label 3126: @199788
     /* 199788 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(199840), // Rule ID 4041 //
     /* 199793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199796 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199803 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199816 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR),
     /* 199819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199824 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199838 */     GIR_RootConstrainSelectedInstOperands,
     /* 199839 */     // GIR_Coverage, 4041,
     /* 199839 */     GIR_EraseRootFromParent_Done,
     /* 199840 */   // Label 3127: @199840
     /* 199840 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(199896), // Rule ID 4043 //
     /* 199845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199870 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_RTN),
     /* 199873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199880 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199894 */     GIR_RootConstrainSelectedInstOperands,
     /* 199895 */     // GIR_Coverage, 4043,
     /* 199895 */     GIR_EraseRootFromParent_Done,
     /* 199896 */   // Label 3128: @199896
     /* 199896 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(199949), // Rule ID 3682 //
     /* 199901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199904 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199912 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199925 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 199928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199933 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199947 */     GIR_RootConstrainSelectedInstOperands,
     /* 199948 */     // GIR_Coverage, 3682,
     /* 199948 */     GIR_EraseRootFromParent_Done,
     /* 199949 */   // Label 3129: @199949
     /* 199949 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(200001), // Rule ID 3742 //
     /* 199954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199964 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199977 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 199980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199985 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199999 */     GIR_RootConstrainSelectedInstOperands,
     /* 200000 */     // GIR_Coverage, 3742,
     /* 200000 */     GIR_EraseRootFromParent_Done,
     /* 200001 */   // Label 3130: @200001
     /* 200001 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(200058), // Rule ID 3681 //
     /* 200006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200009 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200032 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 200032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 200035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200042 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200056 */     GIR_RootConstrainSelectedInstOperands,
     /* 200057 */     // GIR_Coverage, 3681,
     /* 200057 */     GIR_EraseRootFromParent_Done,
     /* 200058 */   // Label 3131: @200058
     /* 200058 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(200114), // Rule ID 3741 //
     /* 200063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200066 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200088 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 200088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 200091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200098 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200112 */     GIR_RootConstrainSelectedInstOperands,
     /* 200113 */     // GIR_Coverage, 3741,
     /* 200113 */     GIR_EraseRootFromParent_Done,
     /* 200114 */   // Label 3132: @200114
     /* 200114 */   GIM_Reject,
     /* 200115 */ // Label 3110: @200115
     /* 200115 */ GIM_Reject,
     /* 200116 */ // Label 3108: @200116
     /* 200116 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(201361),
     /* 200121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200124 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(200186), // Rule ID 5737 //
     /* 200129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200132 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200139 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200152 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64),
     /* 200155 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200184 */     GIR_RootConstrainSelectedInstOperands,
     /* 200185 */     // GIR_Coverage, 5737,
     /* 200185 */     GIR_EraseRootFromParent_Done,
     /* 200186 */   // Label 3134: @200186
     /* 200186 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(200245), // Rule ID 5741 //
     /* 200191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200198 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200211 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64),
     /* 200214 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200243 */     GIR_RootConstrainSelectedInstOperands,
     /* 200244 */     // GIR_Coverage, 5741,
     /* 200244 */     GIR_EraseRootFromParent_Done,
     /* 200245 */   // Label 3135: @200245
     /* 200245 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(200311), // Rule ID 5735 //
     /* 200250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200275 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64_RTN),
     /* 200278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200280 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200309 */     GIR_RootConstrainSelectedInstOperands,
     /* 200310 */     // GIR_Coverage, 5735,
     /* 200310 */     GIR_EraseRootFromParent_Done,
     /* 200311 */   // Label 3136: @200311
     /* 200311 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(200374), // Rule ID 5739 //
     /* 200316 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200338 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN),
     /* 200341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200343 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200372 */     GIR_RootConstrainSelectedInstOperands,
     /* 200373 */     // GIR_Coverage, 5739,
     /* 200373 */     GIR_EraseRootFromParent_Done,
     /* 200374 */   // Label 3137: @200374
     /* 200374 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(200431), // Rule ID 5736 //
     /* 200379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200389 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200402 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 200405 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200429 */     GIR_RootConstrainSelectedInstOperands,
     /* 200430 */     // GIR_Coverage, 5736,
     /* 200430 */     GIR_EraseRootFromParent_Done,
     /* 200431 */   // Label 3138: @200431
     /* 200431 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(200485), // Rule ID 5740 //
     /* 200436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200443 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200456 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 200459 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200483 */     GIR_RootConstrainSelectedInstOperands,
     /* 200484 */     // GIR_Coverage, 5740,
     /* 200484 */     GIR_EraseRootFromParent_Done,
     /* 200485 */   // Label 3139: @200485
     /* 200485 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(200546), // Rule ID 5734 //
     /* 200490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200515 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 200518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200520 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200544 */     GIR_RootConstrainSelectedInstOperands,
     /* 200545 */     // GIR_Coverage, 5734,
     /* 200545 */     GIR_EraseRootFromParent_Done,
     /* 200546 */   // Label 3140: @200546
     /* 200546 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(200604), // Rule ID 5738 //
     /* 200551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200573 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 200576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200578 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200602 */     GIR_RootConstrainSelectedInstOperands,
     /* 200603 */     // GIR_Coverage, 5738,
     /* 200603 */     GIR_EraseRootFromParent_Done,
     /* 200604 */   // Label 3141: @200604
     /* 200604 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(200654), // Rule ID 8266 //
     /* 200609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200612 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200617 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200630 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 200633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200638 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200652 */     GIR_RootConstrainSelectedInstOperands,
     /* 200653 */     // GIR_Coverage, 8266,
     /* 200653 */     GIR_EraseRootFromParent_Done,
     /* 200654 */   // Label 3142: @200654
     /* 200654 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(200704), // Rule ID 8268 //
     /* 200659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200662 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200667 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200680 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_noret_i64>>  =>  (DS_OR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64_gfx9),
     /* 200683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200688 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200702 */     GIR_RootConstrainSelectedInstOperands,
     /* 200703 */     // GIR_Coverage, 8268,
     /* 200703 */     GIR_EraseRootFromParent_Done,
     /* 200704 */   // Label 3143: @200704
     /* 200704 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(200754), // Rule ID 8270 //
     /* 200709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200712 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200717 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200730 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 200733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200738 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200752 */     GIR_RootConstrainSelectedInstOperands,
     /* 200753 */     // GIR_Coverage, 8270,
     /* 200753 */     GIR_EraseRootFromParent_Done,
     /* 200754 */   // Label 3144: @200754
     /* 200754 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(200808), // Rule ID 8265 //
     /* 200759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200762 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200782 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 200785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200792 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200806 */     GIR_RootConstrainSelectedInstOperands,
     /* 200807 */     // GIR_Coverage, 8265,
     /* 200807 */     GIR_EraseRootFromParent_Done,
     /* 200808 */   // Label 3145: @200808
     /* 200808 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(200862), // Rule ID 8267 //
     /* 200813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200816 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200836 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_i64>>  =>  (DS_OR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64_gfx9),
     /* 200839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200846 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200860 */     GIR_RootConstrainSelectedInstOperands,
     /* 200861 */     // GIR_Coverage, 8267,
     /* 200861 */     GIR_EraseRootFromParent_Done,
     /* 200862 */   // Label 3146: @200862
     /* 200862 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(200916), // Rule ID 8269 //
     /* 200867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200890 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 200893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200900 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200914 */     GIR_RootConstrainSelectedInstOperands,
     /* 200915 */     // GIR_Coverage, 8269,
     /* 200915 */     GIR_EraseRootFromParent_Done,
     /* 200916 */   // Label 3147: @200916
     /* 200916 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(200973), // Rule ID 4098 //
     /* 200921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 200944 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 200944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR),
     /* 200947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 200952 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 200959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200971 */     GIR_RootConstrainSelectedInstOperands,
     /* 200972 */     // GIR_Coverage, 4098,
     /* 200972 */     GIR_EraseRootFromParent_Done,
     /* 200973 */   // Label 3148: @200973
     /* 200973 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(201034), // Rule ID 4100 //
     /* 200978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200981 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 201003 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 201003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR_RTN),
     /* 201006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 201013 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 201020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201032 */     GIR_RootConstrainSelectedInstOperands,
     /* 201033 */     // GIR_Coverage, 4100,
     /* 201033 */     GIR_EraseRootFromParent_Done,
     /* 201034 */   // Label 3149: @201034
     /* 201034 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(201086), // Rule ID 4097 //
     /* 201039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 201042 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201049 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 201062 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2),
     /* 201065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201070 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201084 */     GIR_RootConstrainSelectedInstOperands,
     /* 201085 */     // GIR_Coverage, 4097,
     /* 201085 */     GIR_EraseRootFromParent_Done,
     /* 201086 */   // Label 3150: @201086
     /* 201086 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(201142), // Rule ID 4099 //
     /* 201091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 201094 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 201116 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_RTN),
     /* 201119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201126 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201140 */     GIR_RootConstrainSelectedInstOperands,
     /* 201141 */     // GIR_Coverage, 4099,
     /* 201141 */     GIR_EraseRootFromParent_Done,
     /* 201142 */   // Label 3151: @201142
     /* 201142 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(201195), // Rule ID 3708 //
     /* 201147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201158 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201171 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 201174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201179 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201193 */     GIR_RootConstrainSelectedInstOperands,
     /* 201194 */     // GIR_Coverage, 3708,
     /* 201194 */     GIR_EraseRootFromParent_Done,
     /* 201195 */   // Label 3152: @201195
     /* 201195 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(201247), // Rule ID 3768 //
     /* 201200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201203 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201210 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201223 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 201226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201231 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201245 */     GIR_RootConstrainSelectedInstOperands,
     /* 201246 */     // GIR_Coverage, 3768,
     /* 201246 */     GIR_EraseRootFromParent_Done,
     /* 201247 */   // Label 3153: @201247
     /* 201247 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(201304), // Rule ID 3707 //
     /* 201252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201255 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201278 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 201281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201288 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201302 */     GIR_RootConstrainSelectedInstOperands,
     /* 201303 */     // GIR_Coverage, 3707,
     /* 201303 */     GIR_EraseRootFromParent_Done,
     /* 201304 */   // Label 3154: @201304
     /* 201304 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(201360), // Rule ID 3767 //
     /* 201309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201312 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201334 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 201337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201358 */     GIR_RootConstrainSelectedInstOperands,
     /* 201359 */     // GIR_Coverage, 3767,
     /* 201359 */     GIR_EraseRootFromParent_Done,
     /* 201360 */   // Label 3155: @201360
     /* 201360 */   GIM_Reject,
     /* 201361 */ // Label 3133: @201361
     /* 201361 */ GIM_Reject,
     /* 201362 */ // Label 3109: @201362
     /* 201362 */ GIM_Reject,
     /* 201363 */ // Label 24: @201363
     /* 201363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3158*/ GIMT_Encode4(203874),
     /* 201374 */ /*GILLT_s32*//*Label 3156*/ GIMT_Encode4(201382),
     /* 201378 */ /*GILLT_s64*//*Label 3157*/ GIMT_Encode4(202628),
     /* 201382 */ // Label 3156: @201382
     /* 201382 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(202627),
     /* 201387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201390 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(201452), // Rule ID 5649 //
     /* 201395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201405 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201418 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64),
     /* 201421 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201450 */     GIR_RootConstrainSelectedInstOperands,
     /* 201451 */     // GIR_Coverage, 5649,
     /* 201451 */     GIR_EraseRootFromParent_Done,
     /* 201452 */   // Label 3160: @201452
     /* 201452 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(201511), // Rule ID 5653 //
     /* 201457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201464 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201477 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64),
     /* 201480 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201509 */     GIR_RootConstrainSelectedInstOperands,
     /* 201510 */     // GIR_Coverage, 5653,
     /* 201510 */     GIR_EraseRootFromParent_Done,
     /* 201511 */   // Label 3161: @201511
     /* 201511 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(201577), // Rule ID 5647 //
     /* 201516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201519 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201541 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64_RTN),
     /* 201544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201546 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201575 */     GIR_RootConstrainSelectedInstOperands,
     /* 201576 */     // GIR_Coverage, 5647,
     /* 201576 */     GIR_EraseRootFromParent_Done,
     /* 201577 */   // Label 3162: @201577
     /* 201577 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(201640), // Rule ID 5651 //
     /* 201582 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201604 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN),
     /* 201607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201609 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201638 */     GIR_RootConstrainSelectedInstOperands,
     /* 201639 */     // GIR_Coverage, 5651,
     /* 201639 */     GIR_EraseRootFromParent_Done,
     /* 201640 */   // Label 3163: @201640
     /* 201640 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(201697), // Rule ID 5648 //
     /* 201645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201655 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201668 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201695 */     GIR_RootConstrainSelectedInstOperands,
     /* 201696 */     // GIR_Coverage, 5648,
     /* 201696 */     GIR_EraseRootFromParent_Done,
     /* 201697 */   // Label 3164: @201697
     /* 201697 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(201751), // Rule ID 5652 //
     /* 201702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201709 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201722 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 201725 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201749 */     GIR_RootConstrainSelectedInstOperands,
     /* 201750 */     // GIR_Coverage, 5652,
     /* 201750 */     GIR_EraseRootFromParent_Done,
     /* 201751 */   // Label 3165: @201751
     /* 201751 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(201812), // Rule ID 5646 //
     /* 201756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201781 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 201784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201786 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201810 */     GIR_RootConstrainSelectedInstOperands,
     /* 201811 */     // GIR_Coverage, 5646,
     /* 201811 */     GIR_EraseRootFromParent_Done,
     /* 201812 */   // Label 3166: @201812
     /* 201812 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(201870), // Rule ID 5650 //
     /* 201817 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201839 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 201842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201844 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201868 */     GIR_RootConstrainSelectedInstOperands,
     /* 201869 */     // GIR_Coverage, 5650,
     /* 201869 */     GIR_EraseRootFromParent_Done,
     /* 201870 */   // Label 3167: @201870
     /* 201870 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(201920), // Rule ID 8179 //
     /* 201875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 201878 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201883 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201896 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 201899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201904 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201918 */     GIR_RootConstrainSelectedInstOperands,
     /* 201919 */     // GIR_Coverage, 8179,
     /* 201919 */     GIR_EraseRootFromParent_Done,
     /* 201920 */   // Label 3168: @201920
     /* 201920 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(201970), // Rule ID 8181 //
     /* 201925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 201928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201933 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201946 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i32>>  =>  (DS_XOR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32_gfx9),
     /* 201949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201954 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201968 */     GIR_RootConstrainSelectedInstOperands,
     /* 201969 */     // GIR_Coverage, 8181,
     /* 201969 */     GIR_EraseRootFromParent_Done,
     /* 201970 */   // Label 3169: @201970
     /* 201970 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(202020), // Rule ID 8183 //
     /* 201975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 201978 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 201983 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201996 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 201996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 201999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202004 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202018 */     GIR_RootConstrainSelectedInstOperands,
     /* 202019 */     // GIR_Coverage, 8183,
     /* 202019 */     GIR_EraseRootFromParent_Done,
     /* 202020 */   // Label 3170: @202020
     /* 202020 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(202074), // Rule ID 8178 //
     /* 202025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 202028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202048 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 202051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202058 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202072 */     GIR_RootConstrainSelectedInstOperands,
     /* 202073 */     // GIR_Coverage, 8178,
     /* 202073 */     GIR_EraseRootFromParent_Done,
     /* 202074 */   // Label 3171: @202074
     /* 202074 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(202128), // Rule ID 8180 //
     /* 202079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 202082 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202102 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_i32>>  =>  (DS_XOR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32_gfx9),
     /* 202105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202112 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202126 */     GIR_RootConstrainSelectedInstOperands,
     /* 202127 */     // GIR_Coverage, 8180,
     /* 202127 */     GIR_EraseRootFromParent_Done,
     /* 202128 */   // Label 3172: @202128
     /* 202128 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(202182), // Rule ID 8182 //
     /* 202133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 202136 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 202141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202156 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 202156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 202159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202166 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202180 */     GIR_RootConstrainSelectedInstOperands,
     /* 202181 */     // GIR_Coverage, 8182,
     /* 202181 */     GIR_EraseRootFromParent_Done,
     /* 202182 */   // Label 3173: @202182
     /* 202182 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(202239), // Rule ID 4054 //
     /* 202187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202190 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202197 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 202210 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 202210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR),
     /* 202213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 202218 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 202225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202237 */     GIR_RootConstrainSelectedInstOperands,
     /* 202238 */     // GIR_Coverage, 4054,
     /* 202238 */     GIR_EraseRootFromParent_Done,
     /* 202239 */   // Label 3174: @202239
     /* 202239 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(202300), // Rule ID 4056 //
     /* 202244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202247 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 202269 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 202269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR_RTN),
     /* 202272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 202279 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 202286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202298 */     GIR_RootConstrainSelectedInstOperands,
     /* 202299 */     // GIR_Coverage, 4056,
     /* 202299 */     GIR_EraseRootFromParent_Done,
     /* 202300 */   // Label 3175: @202300
     /* 202300 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(202352), // Rule ID 4053 //
     /* 202305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202315 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202328 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR),
     /* 202331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202336 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202350 */     GIR_RootConstrainSelectedInstOperands,
     /* 202351 */     // GIR_Coverage, 4053,
     /* 202351 */     GIR_EraseRootFromParent_Done,
     /* 202352 */   // Label 3176: @202352
     /* 202352 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(202408), // Rule ID 4055 //
     /* 202357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202360 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202382 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_RTN),
     /* 202385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202392 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202406 */     GIR_RootConstrainSelectedInstOperands,
     /* 202407 */     // GIR_Coverage, 4055,
     /* 202407 */     GIR_EraseRootFromParent_Done,
     /* 202408 */   // Label 3177: @202408
     /* 202408 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(202461), // Rule ID 3688 //
     /* 202413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202424 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202437 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 202440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202445 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202459 */     GIR_RootConstrainSelectedInstOperands,
     /* 202460 */     // GIR_Coverage, 3688,
     /* 202460 */     GIR_EraseRootFromParent_Done,
     /* 202461 */   // Label 3178: @202461
     /* 202461 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(202513), // Rule ID 3748 //
     /* 202466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202476 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202489 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 202492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202497 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202511 */     GIR_RootConstrainSelectedInstOperands,
     /* 202512 */     // GIR_Coverage, 3748,
     /* 202512 */     GIR_EraseRootFromParent_Done,
     /* 202513 */   // Label 3179: @202513
     /* 202513 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(202570), // Rule ID 3687 //
     /* 202518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202521 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202544 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 202547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202554 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202568 */     GIR_RootConstrainSelectedInstOperands,
     /* 202569 */     // GIR_Coverage, 3687,
     /* 202569 */     GIR_EraseRootFromParent_Done,
     /* 202570 */   // Label 3180: @202570
     /* 202570 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(202626), // Rule ID 3747 //
     /* 202575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202600 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 202603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202610 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202624 */     GIR_RootConstrainSelectedInstOperands,
     /* 202625 */     // GIR_Coverage, 3747,
     /* 202625 */     GIR_EraseRootFromParent_Done,
     /* 202626 */   // Label 3181: @202626
     /* 202626 */   GIM_Reject,
     /* 202627 */ // Label 3159: @202627
     /* 202627 */ GIM_Reject,
     /* 202628 */ // Label 3157: @202628
     /* 202628 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(203873),
     /* 202633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202636 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(202698), // Rule ID 5745 //
     /* 202641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202644 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202651 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202664 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64),
     /* 202667 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202696 */     GIR_RootConstrainSelectedInstOperands,
     /* 202697 */     // GIR_Coverage, 5745,
     /* 202697 */     GIR_EraseRootFromParent_Done,
     /* 202698 */   // Label 3183: @202698
     /* 202698 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(202757), // Rule ID 5749 //
     /* 202703 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202710 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202723 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64),
     /* 202726 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202755 */     GIR_RootConstrainSelectedInstOperands,
     /* 202756 */     // GIR_Coverage, 5749,
     /* 202756 */     GIR_EraseRootFromParent_Done,
     /* 202757 */   // Label 3184: @202757
     /* 202757 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(202823), // Rule ID 5743 //
     /* 202762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202787 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64_RTN),
     /* 202790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202792 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202821 */     GIR_RootConstrainSelectedInstOperands,
     /* 202822 */     // GIR_Coverage, 5743,
     /* 202822 */     GIR_EraseRootFromParent_Done,
     /* 202823 */   // Label 3185: @202823
     /* 202823 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(202886), // Rule ID 5747 //
     /* 202828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202850 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN),
     /* 202853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202855 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202884 */     GIR_RootConstrainSelectedInstOperands,
     /* 202885 */     // GIR_Coverage, 5747,
     /* 202885 */     GIR_EraseRootFromParent_Done,
     /* 202886 */   // Label 3186: @202886
     /* 202886 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(202943), // Rule ID 5744 //
     /* 202891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202901 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202914 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 202917 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202941 */     GIR_RootConstrainSelectedInstOperands,
     /* 202942 */     // GIR_Coverage, 5744,
     /* 202942 */     GIR_EraseRootFromParent_Done,
     /* 202943 */   // Label 3187: @202943
     /* 202943 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(202997), // Rule ID 5748 //
     /* 202948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202955 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202968 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 202971 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202995 */     GIR_RootConstrainSelectedInstOperands,
     /* 202996 */     // GIR_Coverage, 5748,
     /* 202996 */     GIR_EraseRootFromParent_Done,
     /* 202997 */   // Label 3188: @202997
     /* 202997 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(203058), // Rule ID 5742 //
     /* 203002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 203027 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 203044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203056 */     GIR_RootConstrainSelectedInstOperands,
     /* 203057 */     // GIR_Coverage, 5742,
     /* 203057 */     GIR_EraseRootFromParent_Done,
     /* 203058 */   // Label 3189: @203058
     /* 203058 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(203116), // Rule ID 5746 //
     /* 203063 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 203085 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 203088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203090 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 203102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203114 */     GIR_RootConstrainSelectedInstOperands,
     /* 203115 */     // GIR_Coverage, 5746,
     /* 203115 */     GIR_EraseRootFromParent_Done,
     /* 203116 */   // Label 3190: @203116
     /* 203116 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(203166), // Rule ID 8272 //
     /* 203121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 203124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203129 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203142 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 203145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203150 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203164 */     GIR_RootConstrainSelectedInstOperands,
     /* 203165 */     // GIR_Coverage, 8272,
     /* 203165 */     GIR_EraseRootFromParent_Done,
     /* 203166 */   // Label 3191: @203166
     /* 203166 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(203216), // Rule ID 8274 //
     /* 203171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 203174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203179 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203192 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i64>>  =>  (DS_XOR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64_gfx9),
     /* 203195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203200 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203214 */     GIR_RootConstrainSelectedInstOperands,
     /* 203215 */     // GIR_Coverage, 8274,
     /* 203215 */     GIR_EraseRootFromParent_Done,
     /* 203216 */   // Label 3192: @203216
     /* 203216 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(203266), // Rule ID 8276 //
     /* 203221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 203224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 203229 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203242 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 203245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203250 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203264 */     GIR_RootConstrainSelectedInstOperands,
     /* 203265 */     // GIR_Coverage, 8276,
     /* 203265 */     GIR_EraseRootFromParent_Done,
     /* 203266 */   // Label 3193: @203266
     /* 203266 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(203320), // Rule ID 8271 //
     /* 203271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 203274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203294 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 203297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203304 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203318 */     GIR_RootConstrainSelectedInstOperands,
     /* 203319 */     // GIR_Coverage, 8271,
     /* 203319 */     GIR_EraseRootFromParent_Done,
     /* 203320 */   // Label 3194: @203320
     /* 203320 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(203374), // Rule ID 8273 //
     /* 203325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 203328 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203348 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_i64>>  =>  (DS_XOR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64_gfx9),
     /* 203351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203358 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203372 */     GIR_RootConstrainSelectedInstOperands,
     /* 203373 */     // GIR_Coverage, 8273,
     /* 203373 */     GIR_EraseRootFromParent_Done,
     /* 203374 */   // Label 3195: @203374
     /* 203374 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(203428), // Rule ID 8275 //
     /* 203379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 203382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 203387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203402 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 203405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203412 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203426 */     GIR_RootConstrainSelectedInstOperands,
     /* 203427 */     // GIR_Coverage, 8275,
     /* 203427 */     GIR_EraseRootFromParent_Done,
     /* 203428 */   // Label 3196: @203428
     /* 203428 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(203485), // Rule ID 4110 //
     /* 203433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203443 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203456 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR),
     /* 203459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203464 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203483 */     GIR_RootConstrainSelectedInstOperands,
     /* 203484 */     // GIR_Coverage, 4110,
     /* 203484 */     GIR_EraseRootFromParent_Done,
     /* 203485 */   // Label 3197: @203485
     /* 203485 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(203546), // Rule ID 4112 //
     /* 203490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203515 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR_RTN),
     /* 203518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203525 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203544 */     GIR_RootConstrainSelectedInstOperands,
     /* 203545 */     // GIR_Coverage, 4112,
     /* 203545 */     GIR_EraseRootFromParent_Done,
     /* 203546 */   // Label 3198: @203546
     /* 203546 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(203598), // Rule ID 4109 //
     /* 203551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203554 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203561 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203574 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2),
     /* 203577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203582 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203596 */     GIR_RootConstrainSelectedInstOperands,
     /* 203597 */     // GIR_Coverage, 4109,
     /* 203597 */     GIR_EraseRootFromParent_Done,
     /* 203598 */   // Label 3199: @203598
     /* 203598 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(203654), // Rule ID 4111 //
     /* 203603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203628 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_RTN),
     /* 203631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203638 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203652 */     GIR_RootConstrainSelectedInstOperands,
     /* 203653 */     // GIR_Coverage, 4111,
     /* 203653 */     GIR_EraseRootFromParent_Done,
     /* 203654 */   // Label 3200: @203654
     /* 203654 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(203707), // Rule ID 3714 //
     /* 203659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203662 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203670 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203683 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 203686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203691 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203705 */     GIR_RootConstrainSelectedInstOperands,
     /* 203706 */     // GIR_Coverage, 3714,
     /* 203706 */     GIR_EraseRootFromParent_Done,
     /* 203707 */   // Label 3201: @203707
     /* 203707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(203759), // Rule ID 3774 //
     /* 203712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203715 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203722 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203735 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 203738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203743 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203757 */     GIR_RootConstrainSelectedInstOperands,
     /* 203758 */     // GIR_Coverage, 3774,
     /* 203758 */     GIR_EraseRootFromParent_Done,
     /* 203759 */   // Label 3202: @203759
     /* 203759 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(203816), // Rule ID 3713 //
     /* 203764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203767 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203790 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 203793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203800 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203814 */     GIR_RootConstrainSelectedInstOperands,
     /* 203815 */     // GIR_Coverage, 3713,
     /* 203815 */     GIR_EraseRootFromParent_Done,
     /* 203816 */   // Label 3203: @203816
     /* 203816 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(203872), // Rule ID 3773 //
     /* 203821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203846 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 203849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203856 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203870 */     GIR_RootConstrainSelectedInstOperands,
     /* 203871 */     // GIR_Coverage, 3773,
     /* 203871 */     GIR_EraseRootFromParent_Done,
     /* 203872 */   // Label 3204: @203872
     /* 203872 */   GIM_Reject,
     /* 203873 */ // Label 3182: @203873
     /* 203873 */ GIM_Reject,
     /* 203874 */ // Label 3158: @203874
     /* 203874 */ GIM_Reject,
     /* 203875 */ // Label 25: @203875
     /* 203875 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3207*/ GIMT_Encode4(206386),
     /* 203886 */ /*GILLT_s32*//*Label 3205*/ GIMT_Encode4(203894),
     /* 203890 */ /*GILLT_s64*//*Label 3206*/ GIMT_Encode4(205140),
     /* 203894 */ // Label 3205: @203894
     /* 203894 */ GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(205139),
     /* 203899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203902 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(203964), // Rule ID 5617 //
     /* 203907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203917 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203930 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64),
     /* 203933 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203962 */     GIR_RootConstrainSelectedInstOperands,
     /* 203963 */     // GIR_Coverage, 5617,
     /* 203963 */     GIR_EraseRootFromParent_Done,
     /* 203964 */   // Label 3209: @203964
     /* 203964 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(204023), // Rule ID 5621 //
     /* 203969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203976 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203989 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64),
     /* 203992 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204021 */     GIR_RootConstrainSelectedInstOperands,
     /* 204022 */     // GIR_Coverage, 5621,
     /* 204022 */     GIR_EraseRootFromParent_Done,
     /* 204023 */   // Label 3210: @204023
     /* 204023 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(204089), // Rule ID 5615 //
     /* 204028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204031 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 204053 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64_RTN),
     /* 204056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204058 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 204065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204087 */     GIR_RootConstrainSelectedInstOperands,
     /* 204088 */     // GIR_Coverage, 5615,
     /* 204088 */     GIR_EraseRootFromParent_Done,
     /* 204089 */   // Label 3211: @204089
     /* 204089 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(204152), // Rule ID 5619 //
     /* 204094 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 204116 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN),
     /* 204119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204121 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 204128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204150 */     GIR_RootConstrainSelectedInstOperands,
     /* 204151 */     // GIR_Coverage, 5619,
     /* 204151 */     GIR_EraseRootFromParent_Done,
     /* 204152 */   // Label 3212: @204152
     /* 204152 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(204209), // Rule ID 5616 //
     /* 204157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204167 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204180 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 204183 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204207 */     GIR_RootConstrainSelectedInstOperands,
     /* 204208 */     // GIR_Coverage, 5616,
     /* 204208 */     GIR_EraseRootFromParent_Done,
     /* 204209 */   // Label 3213: @204209
     /* 204209 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(204263), // Rule ID 5620 //
     /* 204214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204221 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204234 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 204237 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204261 */     GIR_RootConstrainSelectedInstOperands,
     /* 204262 */     // GIR_Coverage, 5620,
     /* 204262 */     GIR_EraseRootFromParent_Done,
     /* 204263 */   // Label 3214: @204263
     /* 204263 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(204324), // Rule ID 5614 //
     /* 204268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204271 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204293 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 204296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204298 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204322 */     GIR_RootConstrainSelectedInstOperands,
     /* 204323 */     // GIR_Coverage, 5614,
     /* 204323 */     GIR_EraseRootFromParent_Done,
     /* 204324 */   // Label 3215: @204324
     /* 204324 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(204382), // Rule ID 5618 //
     /* 204329 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204351 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 204354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204356 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204380 */     GIR_RootConstrainSelectedInstOperands,
     /* 204381 */     // GIR_Coverage, 5618,
     /* 204381 */     GIR_EraseRootFromParent_Done,
     /* 204382 */   // Label 3216: @204382
     /* 204382 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(204432), // Rule ID 8191 //
     /* 204387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204408 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 204411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204416 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204430 */     GIR_RootConstrainSelectedInstOperands,
     /* 204431 */     // GIR_Coverage, 8191,
     /* 204431 */     GIR_EraseRootFromParent_Done,
     /* 204432 */   // Label 3217: @204432
     /* 204432 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(204482), // Rule ID 8193 //
     /* 204437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204445 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204458 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_noret_i32>>  =>  (DS_MAX_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32_gfx9),
     /* 204461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204466 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204480 */     GIR_RootConstrainSelectedInstOperands,
     /* 204481 */     // GIR_Coverage, 8193,
     /* 204481 */     GIR_EraseRootFromParent_Done,
     /* 204482 */   // Label 3218: @204482
     /* 204482 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(204532), // Rule ID 8195 //
     /* 204487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204490 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204495 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204508 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 204511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204516 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204530 */     GIR_RootConstrainSelectedInstOperands,
     /* 204531 */     // GIR_Coverage, 8195,
     /* 204531 */     GIR_EraseRootFromParent_Done,
     /* 204532 */   // Label 3219: @204532
     /* 204532 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(204586), // Rule ID 8190 //
     /* 204537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204540 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204560 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 204563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204570 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204584 */     GIR_RootConstrainSelectedInstOperands,
     /* 204585 */     // GIR_Coverage, 8190,
     /* 204585 */     GIR_EraseRootFromParent_Done,
     /* 204586 */   // Label 3220: @204586
     /* 204586 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(204640), // Rule ID 8192 //
     /* 204591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204594 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204614 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_i32>>  =>  (DS_MAX_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32_gfx9),
     /* 204617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204624 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204638 */     GIR_RootConstrainSelectedInstOperands,
     /* 204639 */     // GIR_Coverage, 8192,
     /* 204639 */     GIR_EraseRootFromParent_Done,
     /* 204640 */   // Label 3221: @204640
     /* 204640 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(204694), // Rule ID 8194 //
     /* 204645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204668 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 204671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204678 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204692 */     GIR_RootConstrainSelectedInstOperands,
     /* 204693 */     // GIR_Coverage, 8194,
     /* 204693 */     GIR_EraseRootFromParent_Done,
     /* 204694 */   // Label 3222: @204694
     /* 204694 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(204751), // Rule ID 4026 //
     /* 204699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204709 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204722 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR),
     /* 204725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204730 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204749 */     GIR_RootConstrainSelectedInstOperands,
     /* 204750 */     // GIR_Coverage, 4026,
     /* 204750 */     GIR_EraseRootFromParent_Done,
     /* 204751 */   // Label 3223: @204751
     /* 204751 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(204812), // Rule ID 4028 //
     /* 204756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204781 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR_RTN),
     /* 204784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204791 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204810 */     GIR_RootConstrainSelectedInstOperands,
     /* 204811 */     // GIR_Coverage, 4028,
     /* 204811 */     GIR_EraseRootFromParent_Done,
     /* 204812 */   // Label 3224: @204812
     /* 204812 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(204864), // Rule ID 4025 //
     /* 204817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204820 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204827 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204840 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX),
     /* 204843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204848 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204862 */     GIR_RootConstrainSelectedInstOperands,
     /* 204863 */     // GIR_Coverage, 4025,
     /* 204863 */     GIR_EraseRootFromParent_Done,
     /* 204864 */   // Label 3225: @204864
     /* 204864 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(204920), // Rule ID 4027 //
     /* 204869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204872 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204894 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_RTN),
     /* 204897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204918 */     GIR_RootConstrainSelectedInstOperands,
     /* 204919 */     // GIR_Coverage, 4027,
     /* 204919 */     GIR_EraseRootFromParent_Done,
     /* 204920 */   // Label 3226: @204920
     /* 204920 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(204973), // Rule ID 3674 //
     /* 204925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204936 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204949 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 204952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204957 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204971 */     GIR_RootConstrainSelectedInstOperands,
     /* 204972 */     // GIR_Coverage, 3674,
     /* 204972 */     GIR_EraseRootFromParent_Done,
     /* 204973 */   // Label 3227: @204973
     /* 204973 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(205025), // Rule ID 3734 //
     /* 204978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204981 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204988 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205001 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 205001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 205004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205009 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205023 */     GIR_RootConstrainSelectedInstOperands,
     /* 205024 */     // GIR_Coverage, 3734,
     /* 205024 */     GIR_EraseRootFromParent_Done,
     /* 205025 */   // Label 3228: @205025
     /* 205025 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(205082), // Rule ID 3673 //
     /* 205030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205033 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205056 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 205056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 205059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205066 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205080 */     GIR_RootConstrainSelectedInstOperands,
     /* 205081 */     // GIR_Coverage, 3673,
     /* 205081 */     GIR_EraseRootFromParent_Done,
     /* 205082 */   // Label 3229: @205082
     /* 205082 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(205138), // Rule ID 3733 //
     /* 205087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205090 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205112 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 205112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 205115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205122 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205136 */     GIR_RootConstrainSelectedInstOperands,
     /* 205137 */     // GIR_Coverage, 3733,
     /* 205137 */     GIR_EraseRootFromParent_Done,
     /* 205138 */   // Label 3230: @205138
     /* 205138 */   GIM_Reject,
     /* 205139 */ // Label 3208: @205139
     /* 205139 */ GIM_Reject,
     /* 205140 */ // Label 3206: @205140
     /* 205140 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(206385),
     /* 205145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205148 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(205210), // Rule ID 5713 //
     /* 205153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205176 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64),
     /* 205179 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205208 */     GIR_RootConstrainSelectedInstOperands,
     /* 205209 */     // GIR_Coverage, 5713,
     /* 205209 */     GIR_EraseRootFromParent_Done,
     /* 205210 */   // Label 3232: @205210
     /* 205210 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(205269), // Rule ID 5717 //
     /* 205215 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205222 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205235 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64),
     /* 205238 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205267 */     GIR_RootConstrainSelectedInstOperands,
     /* 205268 */     // GIR_Coverage, 5717,
     /* 205268 */     GIR_EraseRootFromParent_Done,
     /* 205269 */   // Label 3233: @205269
     /* 205269 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(205335), // Rule ID 5711 //
     /* 205274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205277 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205299 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN),
     /* 205302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205304 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205333 */     GIR_RootConstrainSelectedInstOperands,
     /* 205334 */     // GIR_Coverage, 5711,
     /* 205334 */     GIR_EraseRootFromParent_Done,
     /* 205335 */   // Label 3234: @205335
     /* 205335 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(205398), // Rule ID 5715 //
     /* 205340 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205362 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN),
     /* 205365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205367 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205396 */     GIR_RootConstrainSelectedInstOperands,
     /* 205397 */     // GIR_Coverage, 5715,
     /* 205397 */     GIR_EraseRootFromParent_Done,
     /* 205398 */   // Label 3235: @205398
     /* 205398 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(205455), // Rule ID 5712 //
     /* 205403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205413 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205426 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 205429 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205453 */     GIR_RootConstrainSelectedInstOperands,
     /* 205454 */     // GIR_Coverage, 5712,
     /* 205454 */     GIR_EraseRootFromParent_Done,
     /* 205455 */   // Label 3236: @205455
     /* 205455 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(205509), // Rule ID 5716 //
     /* 205460 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205480 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 205483 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205507 */     GIR_RootConstrainSelectedInstOperands,
     /* 205508 */     // GIR_Coverage, 5716,
     /* 205508 */     GIR_EraseRootFromParent_Done,
     /* 205509 */   // Label 3237: @205509
     /* 205509 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(205570), // Rule ID 5710 //
     /* 205514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205539 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 205542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205544 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205568 */     GIR_RootConstrainSelectedInstOperands,
     /* 205569 */     // GIR_Coverage, 5710,
     /* 205569 */     GIR_EraseRootFromParent_Done,
     /* 205570 */   // Label 3238: @205570
     /* 205570 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(205628), // Rule ID 5714 //
     /* 205575 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205597 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 205600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205602 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205626 */     GIR_RootConstrainSelectedInstOperands,
     /* 205627 */     // GIR_Coverage, 5714,
     /* 205627 */     GIR_EraseRootFromParent_Done,
     /* 205628 */   // Label 3239: @205628
     /* 205628 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(205678), // Rule ID 8284 //
     /* 205633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205636 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205641 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205654 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 205657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205662 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205676 */     GIR_RootConstrainSelectedInstOperands,
     /* 205677 */     // GIR_Coverage, 8284,
     /* 205677 */     GIR_EraseRootFromParent_Done,
     /* 205678 */   // Label 3240: @205678
     /* 205678 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(205728), // Rule ID 8286 //
     /* 205683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205691 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205704 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_noret_i64>>  =>  (DS_MAX_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64_gfx9),
     /* 205707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205712 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205726 */     GIR_RootConstrainSelectedInstOperands,
     /* 205727 */     // GIR_Coverage, 8286,
     /* 205727 */     GIR_EraseRootFromParent_Done,
     /* 205728 */   // Label 3241: @205728
     /* 205728 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(205778), // Rule ID 8288 //
     /* 205733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205741 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205754 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 205757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205762 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205776 */     GIR_RootConstrainSelectedInstOperands,
     /* 205777 */     // GIR_Coverage, 8288,
     /* 205777 */     GIR_EraseRootFromParent_Done,
     /* 205778 */   // Label 3242: @205778
     /* 205778 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(205832), // Rule ID 8283 //
     /* 205783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205786 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205806 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 205809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205816 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205830 */     GIR_RootConstrainSelectedInstOperands,
     /* 205831 */     // GIR_Coverage, 8283,
     /* 205831 */     GIR_EraseRootFromParent_Done,
     /* 205832 */   // Label 3243: @205832
     /* 205832 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(205886), // Rule ID 8285 //
     /* 205837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205840 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205860 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_i64>>  =>  (DS_MAX_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64_gfx9),
     /* 205863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205870 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205884 */     GIR_RootConstrainSelectedInstOperands,
     /* 205885 */     // GIR_Coverage, 8285,
     /* 205885 */     GIR_EraseRootFromParent_Done,
     /* 205886 */   // Label 3244: @205886
     /* 205886 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(205940), // Rule ID 8287 //
     /* 205891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205914 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 205917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205924 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205938 */     GIR_RootConstrainSelectedInstOperands,
     /* 205939 */     // GIR_Coverage, 8287,
     /* 205939 */     GIR_EraseRootFromParent_Done,
     /* 205940 */   // Label 3245: @205940
     /* 205940 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(205997), // Rule ID 4082 //
     /* 205945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205955 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 205968 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 205968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR),
     /* 205971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 205976 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 205983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205995 */     GIR_RootConstrainSelectedInstOperands,
     /* 205996 */     // GIR_Coverage, 4082,
     /* 205996 */     GIR_EraseRootFromParent_Done,
     /* 205997 */   // Label 3246: @205997
     /* 205997 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(206058), // Rule ID 4084 //
     /* 206002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 206027 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 206027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN),
     /* 206030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 206037 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 206044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206056 */     GIR_RootConstrainSelectedInstOperands,
     /* 206057 */     // GIR_Coverage, 4084,
     /* 206057 */     GIR_EraseRootFromParent_Done,
     /* 206058 */   // Label 3247: @206058
     /* 206058 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(206110), // Rule ID 4081 //
     /* 206063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206066 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206073 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 206086 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2),
     /* 206089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206094 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206108 */     GIR_RootConstrainSelectedInstOperands,
     /* 206109 */     // GIR_Coverage, 4081,
     /* 206109 */     GIR_EraseRootFromParent_Done,
     /* 206110 */   // Label 3248: @206110
     /* 206110 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(206166), // Rule ID 4083 //
     /* 206115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206118 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 206140 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_RTN),
     /* 206143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206150 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206164 */     GIR_RootConstrainSelectedInstOperands,
     /* 206165 */     // GIR_Coverage, 4083,
     /* 206165 */     GIR_EraseRootFromParent_Done,
     /* 206166 */   // Label 3249: @206166
     /* 206166 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(206219), // Rule ID 3700 //
     /* 206171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206182 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206195 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 206198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206203 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206217 */     GIR_RootConstrainSelectedInstOperands,
     /* 206218 */     // GIR_Coverage, 3700,
     /* 206218 */     GIR_EraseRootFromParent_Done,
     /* 206219 */   // Label 3250: @206219
     /* 206219 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(206271), // Rule ID 3760 //
     /* 206224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206227 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206234 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206247 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 206250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206255 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206269 */     GIR_RootConstrainSelectedInstOperands,
     /* 206270 */     // GIR_Coverage, 3760,
     /* 206270 */     GIR_EraseRootFromParent_Done,
     /* 206271 */   // Label 3251: @206271
     /* 206271 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(206328), // Rule ID 3699 //
     /* 206276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206279 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206302 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 206305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206312 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206326 */     GIR_RootConstrainSelectedInstOperands,
     /* 206327 */     // GIR_Coverage, 3699,
     /* 206327 */     GIR_EraseRootFromParent_Done,
     /* 206328 */   // Label 3252: @206328
     /* 206328 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(206384), // Rule ID 3759 //
     /* 206333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206358 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 206361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206368 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206382 */     GIR_RootConstrainSelectedInstOperands,
     /* 206383 */     // GIR_Coverage, 3759,
     /* 206383 */     GIR_EraseRootFromParent_Done,
     /* 206384 */   // Label 3253: @206384
     /* 206384 */   GIM_Reject,
     /* 206385 */ // Label 3231: @206385
     /* 206385 */ GIM_Reject,
     /* 206386 */ // Label 3207: @206386
     /* 206386 */ GIM_Reject,
     /* 206387 */ // Label 26: @206387
     /* 206387 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3256*/ GIMT_Encode4(208898),
     /* 206398 */ /*GILLT_s32*//*Label 3254*/ GIMT_Encode4(206406),
     /* 206402 */ /*GILLT_s64*//*Label 3255*/ GIMT_Encode4(207652),
     /* 206406 */ // Label 3254: @206406
     /* 206406 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(207651),
     /* 206411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206414 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(206476), // Rule ID 5601 //
     /* 206419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206429 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206442 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64),
     /* 206445 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206474 */     GIR_RootConstrainSelectedInstOperands,
     /* 206475 */     // GIR_Coverage, 5601,
     /* 206475 */     GIR_EraseRootFromParent_Done,
     /* 206476 */   // Label 3258: @206476
     /* 206476 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(206535), // Rule ID 5605 //
     /* 206481 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206488 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206501 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64),
     /* 206504 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206533 */     GIR_RootConstrainSelectedInstOperands,
     /* 206534 */     // GIR_Coverage, 5605,
     /* 206534 */     GIR_EraseRootFromParent_Done,
     /* 206535 */   // Label 3259: @206535
     /* 206535 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(206601), // Rule ID 5599 //
     /* 206540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206543 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206565 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64_RTN),
     /* 206568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206570 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206599 */     GIR_RootConstrainSelectedInstOperands,
     /* 206600 */     // GIR_Coverage, 5599,
     /* 206600 */     GIR_EraseRootFromParent_Done,
     /* 206601 */   // Label 3260: @206601
     /* 206601 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(206664), // Rule ID 5603 //
     /* 206606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206628 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN),
     /* 206631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206633 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206662 */     GIR_RootConstrainSelectedInstOperands,
     /* 206663 */     // GIR_Coverage, 5603,
     /* 206663 */     GIR_EraseRootFromParent_Done,
     /* 206664 */   // Label 3261: @206664
     /* 206664 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(206721), // Rule ID 5600 //
     /* 206669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206679 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206692 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206719 */     GIR_RootConstrainSelectedInstOperands,
     /* 206720 */     // GIR_Coverage, 5600,
     /* 206720 */     GIR_EraseRootFromParent_Done,
     /* 206721 */   // Label 3262: @206721
     /* 206721 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(206775), // Rule ID 5604 //
     /* 206726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206733 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206746 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 206749 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206773 */     GIR_RootConstrainSelectedInstOperands,
     /* 206774 */     // GIR_Coverage, 5604,
     /* 206774 */     GIR_EraseRootFromParent_Done,
     /* 206775 */   // Label 3263: @206775
     /* 206775 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(206836), // Rule ID 5598 //
     /* 206780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206805 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 206808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206810 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206834 */     GIR_RootConstrainSelectedInstOperands,
     /* 206835 */     // GIR_Coverage, 5598,
     /* 206835 */     GIR_EraseRootFromParent_Done,
     /* 206836 */   // Label 3264: @206836
     /* 206836 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(206894), // Rule ID 5602 //
     /* 206841 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206863 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 206866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206868 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206892 */     GIR_RootConstrainSelectedInstOperands,
     /* 206893 */     // GIR_Coverage, 5602,
     /* 206893 */     GIR_EraseRootFromParent_Done,
     /* 206894 */   // Label 3265: @206894
     /* 206894 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(206944), // Rule ID 8185 //
     /* 206899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 206902 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206907 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206920 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 206923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206928 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206942 */     GIR_RootConstrainSelectedInstOperands,
     /* 206943 */     // GIR_Coverage, 8185,
     /* 206943 */     GIR_EraseRootFromParent_Done,
     /* 206944 */   // Label 3266: @206944
     /* 206944 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(206994), // Rule ID 8187 //
     /* 206949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 206952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206957 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206970 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_noret_i32>>  =>  (DS_MIN_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32_gfx9),
     /* 206973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206978 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206992 */     GIR_RootConstrainSelectedInstOperands,
     /* 206993 */     // GIR_Coverage, 8187,
     /* 206993 */     GIR_EraseRootFromParent_Done,
     /* 206994 */   // Label 3267: @206994
     /* 206994 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(207044), // Rule ID 8189 //
     /* 206999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 207002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 207007 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207020 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 207020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 207023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207042 */     GIR_RootConstrainSelectedInstOperands,
     /* 207043 */     // GIR_Coverage, 8189,
     /* 207043 */     GIR_EraseRootFromParent_Done,
     /* 207044 */   // Label 3268: @207044
     /* 207044 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(207098), // Rule ID 8184 //
     /* 207049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 207052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207072 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 207075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207082 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207096 */     GIR_RootConstrainSelectedInstOperands,
     /* 207097 */     // GIR_Coverage, 8184,
     /* 207097 */     GIR_EraseRootFromParent_Done,
     /* 207098 */   // Label 3269: @207098
     /* 207098 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(207152), // Rule ID 8186 //
     /* 207103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 207106 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207126 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_i32>>  =>  (DS_MIN_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32_gfx9),
     /* 207129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207136 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207150 */     GIR_RootConstrainSelectedInstOperands,
     /* 207151 */     // GIR_Coverage, 8186,
     /* 207151 */     GIR_EraseRootFromParent_Done,
     /* 207152 */   // Label 3270: @207152
     /* 207152 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(207206), // Rule ID 8188 //
     /* 207157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 207160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 207165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207180 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 207180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 207183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207190 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207204 */     GIR_RootConstrainSelectedInstOperands,
     /* 207205 */     // GIR_Coverage, 8188,
     /* 207205 */     GIR_EraseRootFromParent_Done,
     /* 207206 */   // Label 3271: @207206
     /* 207206 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(207263), // Rule ID 4034 //
     /* 207211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207221 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207234 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR),
     /* 207237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207242 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207261 */     GIR_RootConstrainSelectedInstOperands,
     /* 207262 */     // GIR_Coverage, 4034,
     /* 207262 */     GIR_EraseRootFromParent_Done,
     /* 207263 */   // Label 3272: @207263
     /* 207263 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(207324), // Rule ID 4036 //
     /* 207268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207271 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207293 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR_RTN),
     /* 207296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207303 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207322 */     GIR_RootConstrainSelectedInstOperands,
     /* 207323 */     // GIR_Coverage, 4036,
     /* 207323 */     GIR_EraseRootFromParent_Done,
     /* 207324 */   // Label 3273: @207324
     /* 207324 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(207376), // Rule ID 4033 //
     /* 207329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207332 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207339 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207352 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN),
     /* 207355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207360 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207374 */     GIR_RootConstrainSelectedInstOperands,
     /* 207375 */     // GIR_Coverage, 4033,
     /* 207375 */     GIR_EraseRootFromParent_Done,
     /* 207376 */   // Label 3274: @207376
     /* 207376 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(207432), // Rule ID 4035 //
     /* 207381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207384 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207406 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_RTN),
     /* 207409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207416 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207430 */     GIR_RootConstrainSelectedInstOperands,
     /* 207431 */     // GIR_Coverage, 4035,
     /* 207431 */     GIR_EraseRootFromParent_Done,
     /* 207432 */   // Label 3275: @207432
     /* 207432 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(207485), // Rule ID 3678 //
     /* 207437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207448 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207461 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 207464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207469 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207483 */     GIR_RootConstrainSelectedInstOperands,
     /* 207484 */     // GIR_Coverage, 3678,
     /* 207484 */     GIR_EraseRootFromParent_Done,
     /* 207485 */   // Label 3276: @207485
     /* 207485 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(207537), // Rule ID 3738 //
     /* 207490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207500 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207513 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 207516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207521 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207535 */     GIR_RootConstrainSelectedInstOperands,
     /* 207536 */     // GIR_Coverage, 3738,
     /* 207536 */     GIR_EraseRootFromParent_Done,
     /* 207537 */   // Label 3277: @207537
     /* 207537 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(207594), // Rule ID 3677 //
     /* 207542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207568 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 207571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207578 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207592 */     GIR_RootConstrainSelectedInstOperands,
     /* 207593 */     // GIR_Coverage, 3677,
     /* 207593 */     GIR_EraseRootFromParent_Done,
     /* 207594 */   // Label 3278: @207594
     /* 207594 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(207650), // Rule ID 3737 //
     /* 207599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207602 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207624 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 207627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207634 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207648 */     GIR_RootConstrainSelectedInstOperands,
     /* 207649 */     // GIR_Coverage, 3737,
     /* 207649 */     GIR_EraseRootFromParent_Done,
     /* 207650 */   // Label 3279: @207650
     /* 207650 */   GIM_Reject,
     /* 207651 */ // Label 3257: @207651
     /* 207651 */ GIM_Reject,
     /* 207652 */ // Label 3255: @207652
     /* 207652 */ GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(208897),
     /* 207657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207660 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(207722), // Rule ID 5697 //
     /* 207665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207675 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207688 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64),
     /* 207691 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207720 */     GIR_RootConstrainSelectedInstOperands,
     /* 207721 */     // GIR_Coverage, 5697,
     /* 207721 */     GIR_EraseRootFromParent_Done,
     /* 207722 */   // Label 3281: @207722
     /* 207722 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(207781), // Rule ID 5701 //
     /* 207727 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207734 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207747 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64),
     /* 207750 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207779 */     GIR_RootConstrainSelectedInstOperands,
     /* 207780 */     // GIR_Coverage, 5701,
     /* 207780 */     GIR_EraseRootFromParent_Done,
     /* 207781 */   // Label 3282: @207781
     /* 207781 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(207847), // Rule ID 5695 //
     /* 207786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207789 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207811 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN),
     /* 207814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207816 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207845 */     GIR_RootConstrainSelectedInstOperands,
     /* 207846 */     // GIR_Coverage, 5695,
     /* 207846 */     GIR_EraseRootFromParent_Done,
     /* 207847 */   // Label 3283: @207847
     /* 207847 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(207910), // Rule ID 5699 //
     /* 207852 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207874 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN),
     /* 207877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207879 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207908 */     GIR_RootConstrainSelectedInstOperands,
     /* 207909 */     // GIR_Coverage, 5699,
     /* 207909 */     GIR_EraseRootFromParent_Done,
     /* 207910 */   // Label 3284: @207910
     /* 207910 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(207967), // Rule ID 5696 //
     /* 207915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207925 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207938 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 207941 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207965 */     GIR_RootConstrainSelectedInstOperands,
     /* 207966 */     // GIR_Coverage, 5696,
     /* 207966 */     GIR_EraseRootFromParent_Done,
     /* 207967 */   // Label 3285: @207967
     /* 207967 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(208021), // Rule ID 5700 //
     /* 207972 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207979 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207992 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 207995 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208019 */     GIR_RootConstrainSelectedInstOperands,
     /* 208020 */     // GIR_Coverage, 5700,
     /* 208020 */     GIR_EraseRootFromParent_Done,
     /* 208021 */   // Label 3286: @208021
     /* 208021 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(208082), // Rule ID 5694 //
     /* 208026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208051 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 208054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208056 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208080 */     GIR_RootConstrainSelectedInstOperands,
     /* 208081 */     // GIR_Coverage, 5694,
     /* 208081 */     GIR_EraseRootFromParent_Done,
     /* 208082 */   // Label 3287: @208082
     /* 208082 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(208140), // Rule ID 5698 //
     /* 208087 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208109 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 208112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208114 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208138 */     GIR_RootConstrainSelectedInstOperands,
     /* 208139 */     // GIR_Coverage, 5698,
     /* 208139 */     GIR_EraseRootFromParent_Done,
     /* 208140 */   // Label 3288: @208140
     /* 208140 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(208190), // Rule ID 8278 //
     /* 208145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 208148 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208153 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208166 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 208169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208174 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208188 */     GIR_RootConstrainSelectedInstOperands,
     /* 208189 */     // GIR_Coverage, 8278,
     /* 208189 */     GIR_EraseRootFromParent_Done,
     /* 208190 */   // Label 3289: @208190
     /* 208190 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(208240), // Rule ID 8280 //
     /* 208195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 208198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208203 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208216 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_noret_i64>>  =>  (DS_MIN_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64_gfx9),
     /* 208219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208224 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208238 */     GIR_RootConstrainSelectedInstOperands,
     /* 208239 */     // GIR_Coverage, 8280,
     /* 208239 */     GIR_EraseRootFromParent_Done,
     /* 208240 */   // Label 3290: @208240
     /* 208240 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(208290), // Rule ID 8282 //
     /* 208245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208248 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208253 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208266 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 208269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208274 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208288 */     GIR_RootConstrainSelectedInstOperands,
     /* 208289 */     // GIR_Coverage, 8282,
     /* 208289 */     GIR_EraseRootFromParent_Done,
     /* 208290 */   // Label 3291: @208290
     /* 208290 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(208344), // Rule ID 8277 //
     /* 208295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 208298 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208318 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208328 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208342 */     GIR_RootConstrainSelectedInstOperands,
     /* 208343 */     // GIR_Coverage, 8277,
     /* 208343 */     GIR_EraseRootFromParent_Done,
     /* 208344 */   // Label 3292: @208344
     /* 208344 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(208398), // Rule ID 8279 //
     /* 208349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 208352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208372 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_i64>>  =>  (DS_MIN_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64_gfx9),
     /* 208375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208382 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208396 */     GIR_RootConstrainSelectedInstOperands,
     /* 208397 */     // GIR_Coverage, 8279,
     /* 208397 */     GIR_EraseRootFromParent_Done,
     /* 208398 */   // Label 3293: @208398
     /* 208398 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(208452), // Rule ID 8281 //
     /* 208403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208426 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 208429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208436 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208450 */     GIR_RootConstrainSelectedInstOperands,
     /* 208451 */     // GIR_Coverage, 8281,
     /* 208451 */     GIR_EraseRootFromParent_Done,
     /* 208452 */   // Label 3294: @208452
     /* 208452 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(208509), // Rule ID 4090 //
     /* 208457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208460 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208480 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR),
     /* 208483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208488 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208507 */     GIR_RootConstrainSelectedInstOperands,
     /* 208508 */     // GIR_Coverage, 4090,
     /* 208508 */     GIR_EraseRootFromParent_Done,
     /* 208509 */   // Label 3295: @208509
     /* 208509 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(208570), // Rule ID 4092 //
     /* 208514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208539 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN),
     /* 208542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208549 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208568 */     GIR_RootConstrainSelectedInstOperands,
     /* 208569 */     // GIR_Coverage, 4092,
     /* 208569 */     GIR_EraseRootFromParent_Done,
     /* 208570 */   // Label 3296: @208570
     /* 208570 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(208622), // Rule ID 4089 //
     /* 208575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208585 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208598 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2),
     /* 208601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208606 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208620 */     GIR_RootConstrainSelectedInstOperands,
     /* 208621 */     // GIR_Coverage, 4089,
     /* 208621 */     GIR_EraseRootFromParent_Done,
     /* 208622 */   // Label 3297: @208622
     /* 208622 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(208678), // Rule ID 4091 //
     /* 208627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208630 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208652 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_RTN),
     /* 208655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208662 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208676 */     GIR_RootConstrainSelectedInstOperands,
     /* 208677 */     // GIR_Coverage, 4091,
     /* 208677 */     GIR_EraseRootFromParent_Done,
     /* 208678 */   // Label 3298: @208678
     /* 208678 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(208731), // Rule ID 3704 //
     /* 208683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208694 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208707 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 208710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208715 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208729 */     GIR_RootConstrainSelectedInstOperands,
     /* 208730 */     // GIR_Coverage, 3704,
     /* 208730 */     GIR_EraseRootFromParent_Done,
     /* 208731 */   // Label 3299: @208731
     /* 208731 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(208783), // Rule ID 3764 //
     /* 208736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208746 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208759 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 208762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208781 */     GIR_RootConstrainSelectedInstOperands,
     /* 208782 */     // GIR_Coverage, 3764,
     /* 208782 */     GIR_EraseRootFromParent_Done,
     /* 208783 */   // Label 3300: @208783
     /* 208783 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(208840), // Rule ID 3703 //
     /* 208788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208791 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208814 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 208817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208824 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208838 */     GIR_RootConstrainSelectedInstOperands,
     /* 208839 */     // GIR_Coverage, 3703,
     /* 208839 */     GIR_EraseRootFromParent_Done,
     /* 208840 */   // Label 3301: @208840
     /* 208840 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(208896), // Rule ID 3763 //
     /* 208845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208870 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 208873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208880 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208894 */     GIR_RootConstrainSelectedInstOperands,
     /* 208895 */     // GIR_Coverage, 3763,
     /* 208895 */     GIR_EraseRootFromParent_Done,
     /* 208896 */   // Label 3302: @208896
     /* 208896 */   GIM_Reject,
     /* 208897 */ // Label 3280: @208897
     /* 208897 */ GIM_Reject,
     /* 208898 */ // Label 3256: @208898
     /* 208898 */ GIM_Reject,
     /* 208899 */ // Label 27: @208899
     /* 208899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3305*/ GIMT_Encode4(211410),
     /* 208910 */ /*GILLT_s32*//*Label 3303*/ GIMT_Encode4(208918),
     /* 208914 */ /*GILLT_s64*//*Label 3304*/ GIMT_Encode4(210164),
     /* 208918 */ // Label 3303: @208918
     /* 208918 */ GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(210163),
     /* 208923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 208926 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(208988), // Rule ID 5625 //
     /* 208931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208941 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208954 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64),
     /* 208957 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208986 */     GIR_RootConstrainSelectedInstOperands,
     /* 208987 */     // GIR_Coverage, 5625,
     /* 208987 */     GIR_EraseRootFromParent_Done,
     /* 208988 */   // Label 3307: @208988
     /* 208988 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(209047), // Rule ID 5629 //
     /* 208993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209000 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209013 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64),
     /* 209016 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209045 */     GIR_RootConstrainSelectedInstOperands,
     /* 209046 */     // GIR_Coverage, 5629,
     /* 209046 */     GIR_EraseRootFromParent_Done,
     /* 209047 */   // Label 3308: @209047
     /* 209047 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(209113), // Rule ID 5623 //
     /* 209052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209077 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64_RTN),
     /* 209080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209082 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209111 */     GIR_RootConstrainSelectedInstOperands,
     /* 209112 */     // GIR_Coverage, 5623,
     /* 209112 */     GIR_EraseRootFromParent_Done,
     /* 209113 */   // Label 3309: @209113
     /* 209113 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(209176), // Rule ID 5627 //
     /* 209118 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209140 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN),
     /* 209143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209145 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209174 */     GIR_RootConstrainSelectedInstOperands,
     /* 209175 */     // GIR_Coverage, 5627,
     /* 209175 */     GIR_EraseRootFromParent_Done,
     /* 209176 */   // Label 3310: @209176
     /* 209176 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(209233), // Rule ID 5624 //
     /* 209181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209191 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209204 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209231 */     GIR_RootConstrainSelectedInstOperands,
     /* 209232 */     // GIR_Coverage, 5624,
     /* 209232 */     GIR_EraseRootFromParent_Done,
     /* 209233 */   // Label 3311: @209233
     /* 209233 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(209287), // Rule ID 5628 //
     /* 209238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209245 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209258 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 209261 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209285 */     GIR_RootConstrainSelectedInstOperands,
     /* 209286 */     // GIR_Coverage, 5628,
     /* 209286 */     GIR_EraseRootFromParent_Done,
     /* 209287 */   // Label 3312: @209287
     /* 209287 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(209348), // Rule ID 5622 //
     /* 209292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209295 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209317 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 209320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209322 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209346 */     GIR_RootConstrainSelectedInstOperands,
     /* 209347 */     // GIR_Coverage, 5622,
     /* 209347 */     GIR_EraseRootFromParent_Done,
     /* 209348 */   // Label 3313: @209348
     /* 209348 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(209406), // Rule ID 5626 //
     /* 209353 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209375 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 209378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209380 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209404 */     GIR_RootConstrainSelectedInstOperands,
     /* 209405 */     // GIR_Coverage, 5626,
     /* 209405 */     GIR_EraseRootFromParent_Done,
     /* 209406 */   // Label 3314: @209406
     /* 209406 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(209456), // Rule ID 8203 //
     /* 209411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209414 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209419 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209432 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 209435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209440 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209454 */     GIR_RootConstrainSelectedInstOperands,
     /* 209455 */     // GIR_Coverage, 8203,
     /* 209455 */     GIR_EraseRootFromParent_Done,
     /* 209456 */   // Label 3315: @209456
     /* 209456 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(209506), // Rule ID 8205 //
     /* 209461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209464 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209469 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209482 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i32>>  =>  (DS_MAX_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32_gfx9),
     /* 209485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209490 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209504 */     GIR_RootConstrainSelectedInstOperands,
     /* 209505 */     // GIR_Coverage, 8205,
     /* 209505 */     GIR_EraseRootFromParent_Done,
     /* 209506 */   // Label 3316: @209506
     /* 209506 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(209556), // Rule ID 8207 //
     /* 209511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209514 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209519 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209532 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 209535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209540 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209554 */     GIR_RootConstrainSelectedInstOperands,
     /* 209555 */     // GIR_Coverage, 8207,
     /* 209555 */     GIR_EraseRootFromParent_Done,
     /* 209556 */   // Label 3317: @209556
     /* 209556 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(209610), // Rule ID 8202 //
     /* 209561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209564 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209584 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 209587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209594 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209608 */     GIR_RootConstrainSelectedInstOperands,
     /* 209609 */     // GIR_Coverage, 8202,
     /* 209609 */     GIR_EraseRootFromParent_Done,
     /* 209610 */   // Label 3318: @209610
     /* 209610 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(209664), // Rule ID 8204 //
     /* 209615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209618 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209638 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_i32>>  =>  (DS_MAX_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32_gfx9),
     /* 209641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209648 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209662 */     GIR_RootConstrainSelectedInstOperands,
     /* 209663 */     // GIR_Coverage, 8204,
     /* 209663 */     GIR_EraseRootFromParent_Done,
     /* 209664 */   // Label 3319: @209664
     /* 209664 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(209718), // Rule ID 8206 //
     /* 209669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209692 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 209695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209702 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209716 */     GIR_RootConstrainSelectedInstOperands,
     /* 209717 */     // GIR_Coverage, 8206,
     /* 209717 */     GIR_EraseRootFromParent_Done,
     /* 209718 */   // Label 3320: @209718
     /* 209718 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(209775), // Rule ID 4030 //
     /* 209723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209733 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209746 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR),
     /* 209749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209754 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209773 */     GIR_RootConstrainSelectedInstOperands,
     /* 209774 */     // GIR_Coverage, 4030,
     /* 209774 */     GIR_EraseRootFromParent_Done,
     /* 209775 */   // Label 3321: @209775
     /* 209775 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(209836), // Rule ID 4032 //
     /* 209780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209805 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR_RTN),
     /* 209808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209815 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209834 */     GIR_RootConstrainSelectedInstOperands,
     /* 209835 */     // GIR_Coverage, 4032,
     /* 209835 */     GIR_EraseRootFromParent_Done,
     /* 209836 */   // Label 3322: @209836
     /* 209836 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(209888), // Rule ID 4029 //
     /* 209841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209844 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209851 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209864 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX),
     /* 209867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209872 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209886 */     GIR_RootConstrainSelectedInstOperands,
     /* 209887 */     // GIR_Coverage, 4029,
     /* 209887 */     GIR_EraseRootFromParent_Done,
     /* 209888 */   // Label 3323: @209888
     /* 209888 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(209944), // Rule ID 4031 //
     /* 209893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209896 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209918 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_RTN),
     /* 209921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209928 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209942 */     GIR_RootConstrainSelectedInstOperands,
     /* 209943 */     // GIR_Coverage, 4031,
     /* 209943 */     GIR_EraseRootFromParent_Done,
     /* 209944 */   // Label 3324: @209944
     /* 209944 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(209997), // Rule ID 3676 //
     /* 209949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209960 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209973 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 209976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209981 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209995 */     GIR_RootConstrainSelectedInstOperands,
     /* 209996 */     // GIR_Coverage, 3676,
     /* 209996 */     GIR_EraseRootFromParent_Done,
     /* 209997 */   // Label 3325: @209997
     /* 209997 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(210049), // Rule ID 3736 //
     /* 210002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210012 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210025 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 210025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 210028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210033 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210047 */     GIR_RootConstrainSelectedInstOperands,
     /* 210048 */     // GIR_Coverage, 3736,
     /* 210048 */     GIR_EraseRootFromParent_Done,
     /* 210049 */   // Label 3326: @210049
     /* 210049 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(210106), // Rule ID 3675 //
     /* 210054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210057 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210080 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 210080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 210083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210090 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210104 */     GIR_RootConstrainSelectedInstOperands,
     /* 210105 */     // GIR_Coverage, 3675,
     /* 210105 */     GIR_EraseRootFromParent_Done,
     /* 210106 */   // Label 3327: @210106
     /* 210106 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(210162), // Rule ID 3735 //
     /* 210111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210114 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210136 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 210136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 210139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210146 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210160 */     GIR_RootConstrainSelectedInstOperands,
     /* 210161 */     // GIR_Coverage, 3735,
     /* 210161 */     GIR_EraseRootFromParent_Done,
     /* 210162 */   // Label 3328: @210162
     /* 210162 */   GIM_Reject,
     /* 210163 */ // Label 3306: @210163
     /* 210163 */ GIM_Reject,
     /* 210164 */ // Label 3304: @210164
     /* 210164 */ GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(211409),
     /* 210169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210172 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(210234), // Rule ID 5721 //
     /* 210177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210187 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210200 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64),
     /* 210203 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210232 */     GIR_RootConstrainSelectedInstOperands,
     /* 210233 */     // GIR_Coverage, 5721,
     /* 210233 */     GIR_EraseRootFromParent_Done,
     /* 210234 */   // Label 3330: @210234
     /* 210234 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(210293), // Rule ID 5725 //
     /* 210239 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210246 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210259 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64),
     /* 210262 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210291 */     GIR_RootConstrainSelectedInstOperands,
     /* 210292 */     // GIR_Coverage, 5725,
     /* 210292 */     GIR_EraseRootFromParent_Done,
     /* 210293 */   // Label 3331: @210293
     /* 210293 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(210359), // Rule ID 5719 //
     /* 210298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210301 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210323 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN),
     /* 210326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210328 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210357 */     GIR_RootConstrainSelectedInstOperands,
     /* 210358 */     // GIR_Coverage, 5719,
     /* 210358 */     GIR_EraseRootFromParent_Done,
     /* 210359 */   // Label 3332: @210359
     /* 210359 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(210422), // Rule ID 5723 //
     /* 210364 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210386 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN),
     /* 210389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210420 */     GIR_RootConstrainSelectedInstOperands,
     /* 210421 */     // GIR_Coverage, 5723,
     /* 210421 */     GIR_EraseRootFromParent_Done,
     /* 210422 */   // Label 3333: @210422
     /* 210422 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(210479), // Rule ID 5720 //
     /* 210427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210437 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210450 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 210453 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210477 */     GIR_RootConstrainSelectedInstOperands,
     /* 210478 */     // GIR_Coverage, 5720,
     /* 210478 */     GIR_EraseRootFromParent_Done,
     /* 210479 */   // Label 3334: @210479
     /* 210479 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(210533), // Rule ID 5724 //
     /* 210484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210491 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210504 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 210507 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210531 */     GIR_RootConstrainSelectedInstOperands,
     /* 210532 */     // GIR_Coverage, 5724,
     /* 210532 */     GIR_EraseRootFromParent_Done,
     /* 210533 */   // Label 3335: @210533
     /* 210533 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(210594), // Rule ID 5718 //
     /* 210538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210541 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210563 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 210566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210568 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210592 */     GIR_RootConstrainSelectedInstOperands,
     /* 210593 */     // GIR_Coverage, 5718,
     /* 210593 */     GIR_EraseRootFromParent_Done,
     /* 210594 */   // Label 3336: @210594
     /* 210594 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(210652), // Rule ID 5722 //
     /* 210599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210621 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 210624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210626 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210650 */     GIR_RootConstrainSelectedInstOperands,
     /* 210651 */     // GIR_Coverage, 5722,
     /* 210651 */     GIR_EraseRootFromParent_Done,
     /* 210652 */   // Label 3337: @210652
     /* 210652 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(210702), // Rule ID 8296 //
     /* 210657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210660 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210665 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210678 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 210681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210686 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210700 */     GIR_RootConstrainSelectedInstOperands,
     /* 210701 */     // GIR_Coverage, 8296,
     /* 210701 */     GIR_EraseRootFromParent_Done,
     /* 210702 */   // Label 3338: @210702
     /* 210702 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(210752), // Rule ID 8298 //
     /* 210707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210715 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210728 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i64>>  =>  (DS_MAX_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64_gfx9),
     /* 210731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210736 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210750 */     GIR_RootConstrainSelectedInstOperands,
     /* 210751 */     // GIR_Coverage, 8298,
     /* 210751 */     GIR_EraseRootFromParent_Done,
     /* 210752 */   // Label 3339: @210752
     /* 210752 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(210802), // Rule ID 8300 //
     /* 210757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210765 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210778 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 210781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210786 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210800 */     GIR_RootConstrainSelectedInstOperands,
     /* 210801 */     // GIR_Coverage, 8300,
     /* 210801 */     GIR_EraseRootFromParent_Done,
     /* 210802 */   // Label 3340: @210802
     /* 210802 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(210856), // Rule ID 8295 //
     /* 210807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210830 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 210833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210840 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210854 */     GIR_RootConstrainSelectedInstOperands,
     /* 210855 */     // GIR_Coverage, 8295,
     /* 210855 */     GIR_EraseRootFromParent_Done,
     /* 210856 */   // Label 3341: @210856
     /* 210856 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(210910), // Rule ID 8297 //
     /* 210861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210864 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210884 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_i64>>  =>  (DS_MAX_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64_gfx9),
     /* 210887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210894 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210908 */     GIR_RootConstrainSelectedInstOperands,
     /* 210909 */     // GIR_Coverage, 8297,
     /* 210909 */     GIR_EraseRootFromParent_Done,
     /* 210910 */   // Label 3342: @210910
     /* 210910 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(210964), // Rule ID 8299 //
     /* 210915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210938 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 210941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210962 */     GIR_RootConstrainSelectedInstOperands,
     /* 210963 */     // GIR_Coverage, 8299,
     /* 210963 */     GIR_EraseRootFromParent_Done,
     /* 210964 */   // Label 3343: @210964
     /* 210964 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(211021), // Rule ID 4086 //
     /* 210969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210972 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210979 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 210992 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 210992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR),
     /* 210995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 211000 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 211007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211019 */     GIR_RootConstrainSelectedInstOperands,
     /* 211020 */     // GIR_Coverage, 4086,
     /* 211020 */     GIR_EraseRootFromParent_Done,
     /* 211021 */   // Label 3344: @211021
     /* 211021 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(211082), // Rule ID 4088 //
     /* 211026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 211051 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 211051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN),
     /* 211054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 211061 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 211068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211080 */     GIR_RootConstrainSelectedInstOperands,
     /* 211081 */     // GIR_Coverage, 4088,
     /* 211081 */     GIR_EraseRootFromParent_Done,
     /* 211082 */   // Label 3345: @211082
     /* 211082 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(211134), // Rule ID 4085 //
     /* 211087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211090 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211097 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 211110 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2),
     /* 211113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211118 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211132 */     GIR_RootConstrainSelectedInstOperands,
     /* 211133 */     // GIR_Coverage, 4085,
     /* 211133 */     GIR_EraseRootFromParent_Done,
     /* 211134 */   // Label 3346: @211134
     /* 211134 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(211190), // Rule ID 4087 //
     /* 211139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211142 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 211164 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_RTN),
     /* 211167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211174 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211188 */     GIR_RootConstrainSelectedInstOperands,
     /* 211189 */     // GIR_Coverage, 4087,
     /* 211189 */     GIR_EraseRootFromParent_Done,
     /* 211190 */   // Label 3347: @211190
     /* 211190 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(211243), // Rule ID 3702 //
     /* 211195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211206 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211219 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 211222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211227 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211241 */     GIR_RootConstrainSelectedInstOperands,
     /* 211242 */     // GIR_Coverage, 3702,
     /* 211242 */     GIR_EraseRootFromParent_Done,
     /* 211243 */   // Label 3348: @211243
     /* 211243 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(211295), // Rule ID 3762 //
     /* 211248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211251 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211258 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211271 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 211274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211279 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211293 */     GIR_RootConstrainSelectedInstOperands,
     /* 211294 */     // GIR_Coverage, 3762,
     /* 211294 */     GIR_EraseRootFromParent_Done,
     /* 211295 */   // Label 3349: @211295
     /* 211295 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(211352), // Rule ID 3701 //
     /* 211300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211303 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211326 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 211329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211336 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211350 */     GIR_RootConstrainSelectedInstOperands,
     /* 211351 */     // GIR_Coverage, 3701,
     /* 211351 */     GIR_EraseRootFromParent_Done,
     /* 211352 */   // Label 3350: @211352
     /* 211352 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(211408), // Rule ID 3761 //
     /* 211357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211360 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211382 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 211385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211392 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211406 */     GIR_RootConstrainSelectedInstOperands,
     /* 211407 */     // GIR_Coverage, 3761,
     /* 211407 */     GIR_EraseRootFromParent_Done,
     /* 211408 */   // Label 3351: @211408
     /* 211408 */   GIM_Reject,
     /* 211409 */ // Label 3329: @211409
     /* 211409 */ GIM_Reject,
     /* 211410 */ // Label 3305: @211410
     /* 211410 */ GIM_Reject,
     /* 211411 */ // Label 28: @211411
     /* 211411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3354*/ GIMT_Encode4(213922),
     /* 211422 */ /*GILLT_s32*//*Label 3352*/ GIMT_Encode4(211430),
     /* 211426 */ /*GILLT_s64*//*Label 3353*/ GIMT_Encode4(212676),
     /* 211430 */ // Label 3352: @211430
     /* 211430 */ GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(212675),
     /* 211435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211438 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(211500), // Rule ID 5609 //
     /* 211443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211453 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211466 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64),
     /* 211469 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211498 */     GIR_RootConstrainSelectedInstOperands,
     /* 211499 */     // GIR_Coverage, 5609,
     /* 211499 */     GIR_EraseRootFromParent_Done,
     /* 211500 */   // Label 3356: @211500
     /* 211500 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(211559), // Rule ID 5613 //
     /* 211505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211512 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211525 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64),
     /* 211528 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211557 */     GIR_RootConstrainSelectedInstOperands,
     /* 211558 */     // GIR_Coverage, 5613,
     /* 211558 */     GIR_EraseRootFromParent_Done,
     /* 211559 */   // Label 3357: @211559
     /* 211559 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(211625), // Rule ID 5607 //
     /* 211564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211567 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211589 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64_RTN),
     /* 211592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211594 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211623 */     GIR_RootConstrainSelectedInstOperands,
     /* 211624 */     // GIR_Coverage, 5607,
     /* 211624 */     GIR_EraseRootFromParent_Done,
     /* 211625 */   // Label 3358: @211625
     /* 211625 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(211688), // Rule ID 5611 //
     /* 211630 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211652 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN),
     /* 211655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211657 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211686 */     GIR_RootConstrainSelectedInstOperands,
     /* 211687 */     // GIR_Coverage, 5611,
     /* 211687 */     GIR_EraseRootFromParent_Done,
     /* 211688 */   // Label 3359: @211688
     /* 211688 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(211745), // Rule ID 5608 //
     /* 211693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211703 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211716 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 211719 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211743 */     GIR_RootConstrainSelectedInstOperands,
     /* 211744 */     // GIR_Coverage, 5608,
     /* 211744 */     GIR_EraseRootFromParent_Done,
     /* 211745 */   // Label 3360: @211745
     /* 211745 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(211799), // Rule ID 5612 //
     /* 211750 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211757 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211770 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 211773 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211797 */     GIR_RootConstrainSelectedInstOperands,
     /* 211798 */     // GIR_Coverage, 5612,
     /* 211798 */     GIR_EraseRootFromParent_Done,
     /* 211799 */   // Label 3361: @211799
     /* 211799 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(211860), // Rule ID 5606 //
     /* 211804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211807 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211829 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 211832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211834 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211858 */     GIR_RootConstrainSelectedInstOperands,
     /* 211859 */     // GIR_Coverage, 5606,
     /* 211859 */     GIR_EraseRootFromParent_Done,
     /* 211860 */   // Label 3362: @211860
     /* 211860 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(211918), // Rule ID 5610 //
     /* 211865 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211887 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 211890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211892 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211916 */     GIR_RootConstrainSelectedInstOperands,
     /* 211917 */     // GIR_Coverage, 5610,
     /* 211917 */     GIR_EraseRootFromParent_Done,
     /* 211918 */   // Label 3363: @211918
     /* 211918 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(211968), // Rule ID 8197 //
     /* 211923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 211926 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211944 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 211947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211952 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211966 */     GIR_RootConstrainSelectedInstOperands,
     /* 211967 */     // GIR_Coverage, 8197,
     /* 211967 */     GIR_EraseRootFromParent_Done,
     /* 211968 */   // Label 3364: @211968
     /* 211968 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(212018), // Rule ID 8199 //
     /* 211973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 211976 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211981 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211994 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i32>>  =>  (DS_MIN_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32_gfx9),
     /* 211997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212002 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212016 */     GIR_RootConstrainSelectedInstOperands,
     /* 212017 */     // GIR_Coverage, 8199,
     /* 212017 */     GIR_EraseRootFromParent_Done,
     /* 212018 */   // Label 3365: @212018
     /* 212018 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(212068), // Rule ID 8201 //
     /* 212023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 212026 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 212031 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212044 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 212044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 212047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212052 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212066 */     GIR_RootConstrainSelectedInstOperands,
     /* 212067 */     // GIR_Coverage, 8201,
     /* 212067 */     GIR_EraseRootFromParent_Done,
     /* 212068 */   // Label 3366: @212068
     /* 212068 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(212122), // Rule ID 8196 //
     /* 212073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 212076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212096 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 212096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 212099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212106 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212120 */     GIR_RootConstrainSelectedInstOperands,
     /* 212121 */     // GIR_Coverage, 8196,
     /* 212121 */     GIR_EraseRootFromParent_Done,
     /* 212122 */   // Label 3367: @212122
     /* 212122 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(212176), // Rule ID 8198 //
     /* 212127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 212130 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212150 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_i32>>  =>  (DS_MIN_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 212150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32_gfx9),
     /* 212153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212160 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212174 */     GIR_RootConstrainSelectedInstOperands,
     /* 212175 */     // GIR_Coverage, 8198,
     /* 212175 */     GIR_EraseRootFromParent_Done,
     /* 212176 */   // Label 3368: @212176
     /* 212176 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(212230), // Rule ID 8200 //
     /* 212181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 212184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 212189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212204 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 212204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 212207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212214 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212228 */     GIR_RootConstrainSelectedInstOperands,
     /* 212229 */     // GIR_Coverage, 8200,
     /* 212229 */     GIR_EraseRootFromParent_Done,
     /* 212230 */   // Label 3369: @212230
     /* 212230 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(212287), // Rule ID 4038 //
     /* 212235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212245 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212258 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR),
     /* 212261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212266 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212285 */     GIR_RootConstrainSelectedInstOperands,
     /* 212286 */     // GIR_Coverage, 4038,
     /* 212286 */     GIR_EraseRootFromParent_Done,
     /* 212287 */   // Label 3370: @212287
     /* 212287 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(212348), // Rule ID 4040 //
     /* 212292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212295 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212317 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR_RTN),
     /* 212320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212327 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212346 */     GIR_RootConstrainSelectedInstOperands,
     /* 212347 */     // GIR_Coverage, 4040,
     /* 212347 */     GIR_EraseRootFromParent_Done,
     /* 212348 */   // Label 3371: @212348
     /* 212348 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(212400), // Rule ID 4037 //
     /* 212353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212356 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212363 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212376 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN),
     /* 212379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212384 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212398 */     GIR_RootConstrainSelectedInstOperands,
     /* 212399 */     // GIR_Coverage, 4037,
     /* 212399 */     GIR_EraseRootFromParent_Done,
     /* 212400 */   // Label 3372: @212400
     /* 212400 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(212456), // Rule ID 4039 //
     /* 212405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212408 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212430 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_RTN),
     /* 212433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212440 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212454 */     GIR_RootConstrainSelectedInstOperands,
     /* 212455 */     // GIR_Coverage, 4039,
     /* 212455 */     GIR_EraseRootFromParent_Done,
     /* 212456 */   // Label 3373: @212456
     /* 212456 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(212509), // Rule ID 3680 //
     /* 212461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212464 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212472 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212485 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 212488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212493 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212507 */     GIR_RootConstrainSelectedInstOperands,
     /* 212508 */     // GIR_Coverage, 3680,
     /* 212508 */     GIR_EraseRootFromParent_Done,
     /* 212509 */   // Label 3374: @212509
     /* 212509 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(212561), // Rule ID 3740 //
     /* 212514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212524 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212537 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 212540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212545 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212559 */     GIR_RootConstrainSelectedInstOperands,
     /* 212560 */     // GIR_Coverage, 3740,
     /* 212560 */     GIR_EraseRootFromParent_Done,
     /* 212561 */   // Label 3375: @212561
     /* 212561 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(212618), // Rule ID 3679 //
     /* 212566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212569 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212592 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 212595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212602 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212616 */     GIR_RootConstrainSelectedInstOperands,
     /* 212617 */     // GIR_Coverage, 3679,
     /* 212617 */     GIR_EraseRootFromParent_Done,
     /* 212618 */   // Label 3376: @212618
     /* 212618 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(212674), // Rule ID 3739 //
     /* 212623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212626 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212648 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 212651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212658 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212672 */     GIR_RootConstrainSelectedInstOperands,
     /* 212673 */     // GIR_Coverage, 3739,
     /* 212673 */     GIR_EraseRootFromParent_Done,
     /* 212674 */   // Label 3377: @212674
     /* 212674 */   GIM_Reject,
     /* 212675 */ // Label 3355: @212675
     /* 212675 */ GIM_Reject,
     /* 212676 */ // Label 3353: @212676
     /* 212676 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(213921),
     /* 212681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212684 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(212746), // Rule ID 5705 //
     /* 212689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212692 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212712 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64),
     /* 212715 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212744 */     GIR_RootConstrainSelectedInstOperands,
     /* 212745 */     // GIR_Coverage, 5705,
     /* 212745 */     GIR_EraseRootFromParent_Done,
     /* 212746 */   // Label 3379: @212746
     /* 212746 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(212805), // Rule ID 5709 //
     /* 212751 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212758 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212771 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64),
     /* 212774 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212803 */     GIR_RootConstrainSelectedInstOperands,
     /* 212804 */     // GIR_Coverage, 5709,
     /* 212804 */     GIR_EraseRootFromParent_Done,
     /* 212805 */   // Label 3380: @212805
     /* 212805 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(212871), // Rule ID 5703 //
     /* 212810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212835 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN),
     /* 212838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212840 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212869 */     GIR_RootConstrainSelectedInstOperands,
     /* 212870 */     // GIR_Coverage, 5703,
     /* 212870 */     GIR_EraseRootFromParent_Done,
     /* 212871 */   // Label 3381: @212871
     /* 212871 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(212934), // Rule ID 5707 //
     /* 212876 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212898 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN),
     /* 212901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212903 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212932 */     GIR_RootConstrainSelectedInstOperands,
     /* 212933 */     // GIR_Coverage, 5707,
     /* 212933 */     GIR_EraseRootFromParent_Done,
     /* 212934 */   // Label 3382: @212934
     /* 212934 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(212991), // Rule ID 5704 //
     /* 212939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212949 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212962 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 212965 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212989 */     GIR_RootConstrainSelectedInstOperands,
     /* 212990 */     // GIR_Coverage, 5704,
     /* 212990 */     GIR_EraseRootFromParent_Done,
     /* 212991 */   // Label 3383: @212991
     /* 212991 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(213045), // Rule ID 5708 //
     /* 212996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213003 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213016 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213043 */     GIR_RootConstrainSelectedInstOperands,
     /* 213044 */     // GIR_Coverage, 5708,
     /* 213044 */     GIR_EraseRootFromParent_Done,
     /* 213045 */   // Label 3384: @213045
     /* 213045 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(213106), // Rule ID 5702 //
     /* 213050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 213053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213075 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 213078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 213080 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213104 */     GIR_RootConstrainSelectedInstOperands,
     /* 213105 */     // GIR_Coverage, 5702,
     /* 213105 */     GIR_EraseRootFromParent_Done,
     /* 213106 */   // Label 3385: @213106
     /* 213106 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(213164), // Rule ID 5706 //
     /* 213111 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213133 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 213136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 213138 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213162 */     GIR_RootConstrainSelectedInstOperands,
     /* 213163 */     // GIR_Coverage, 5706,
     /* 213163 */     GIR_EraseRootFromParent_Done,
     /* 213164 */   // Label 3386: @213164
     /* 213164 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(213214), // Rule ID 8290 //
     /* 213169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 213172 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213177 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213190 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 213193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213198 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213212 */     GIR_RootConstrainSelectedInstOperands,
     /* 213213 */     // GIR_Coverage, 8290,
     /* 213213 */     GIR_EraseRootFromParent_Done,
     /* 213214 */   // Label 3387: @213214
     /* 213214 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(213264), // Rule ID 8292 //
     /* 213219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 213222 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213227 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213240 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i64>>  =>  (DS_MIN_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64_gfx9),
     /* 213243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213248 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213262 */     GIR_RootConstrainSelectedInstOperands,
     /* 213263 */     // GIR_Coverage, 8292,
     /* 213263 */     GIR_EraseRootFromParent_Done,
     /* 213264 */   // Label 3388: @213264
     /* 213264 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(213314), // Rule ID 8294 //
     /* 213269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213272 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213277 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213290 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 213293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213298 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213312 */     GIR_RootConstrainSelectedInstOperands,
     /* 213313 */     // GIR_Coverage, 8294,
     /* 213313 */     GIR_EraseRootFromParent_Done,
     /* 213314 */   // Label 3389: @213314
     /* 213314 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(213368), // Rule ID 8289 //
     /* 213319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 213322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213342 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 213345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213366 */     GIR_RootConstrainSelectedInstOperands,
     /* 213367 */     // GIR_Coverage, 8289,
     /* 213367 */     GIR_EraseRootFromParent_Done,
     /* 213368 */   // Label 3390: @213368
     /* 213368 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(213422), // Rule ID 8291 //
     /* 213373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 213376 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213396 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_i64>>  =>  (DS_MIN_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64_gfx9),
     /* 213399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213406 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213420 */     GIR_RootConstrainSelectedInstOperands,
     /* 213421 */     // GIR_Coverage, 8291,
     /* 213421 */     GIR_EraseRootFromParent_Done,
     /* 213422 */   // Label 3391: @213422
     /* 213422 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(213476), // Rule ID 8293 //
     /* 213427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213450 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 213453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213460 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213474 */     GIR_RootConstrainSelectedInstOperands,
     /* 213475 */     // GIR_Coverage, 8293,
     /* 213475 */     GIR_EraseRootFromParent_Done,
     /* 213476 */   // Label 3392: @213476
     /* 213476 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(213533), // Rule ID 4094 //
     /* 213481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213491 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213504 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR),
     /* 213507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213512 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213531 */     GIR_RootConstrainSelectedInstOperands,
     /* 213532 */     // GIR_Coverage, 4094,
     /* 213532 */     GIR_EraseRootFromParent_Done,
     /* 213533 */   // Label 3393: @213533
     /* 213533 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(213594), // Rule ID 4096 //
     /* 213538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213541 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213563 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN),
     /* 213566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213573 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213592 */     GIR_RootConstrainSelectedInstOperands,
     /* 213593 */     // GIR_Coverage, 4096,
     /* 213593 */     GIR_EraseRootFromParent_Done,
     /* 213594 */   // Label 3394: @213594
     /* 213594 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(213646), // Rule ID 4093 //
     /* 213599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213602 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213609 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213622 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2),
     /* 213625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213630 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213644 */     GIR_RootConstrainSelectedInstOperands,
     /* 213645 */     // GIR_Coverage, 4093,
     /* 213645 */     GIR_EraseRootFromParent_Done,
     /* 213646 */   // Label 3395: @213646
     /* 213646 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(213702), // Rule ID 4095 //
     /* 213651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213676 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_RTN),
     /* 213679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213686 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213700 */     GIR_RootConstrainSelectedInstOperands,
     /* 213701 */     // GIR_Coverage, 4095,
     /* 213701 */     GIR_EraseRootFromParent_Done,
     /* 213702 */   // Label 3396: @213702
     /* 213702 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(213755), // Rule ID 3706 //
     /* 213707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213731 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 213734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213739 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213753 */     GIR_RootConstrainSelectedInstOperands,
     /* 213754 */     // GIR_Coverage, 3706,
     /* 213754 */     GIR_EraseRootFromParent_Done,
     /* 213755 */   // Label 3397: @213755
     /* 213755 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(213807), // Rule ID 3766 //
     /* 213760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213763 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213770 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213783 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 213786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213791 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213805 */     GIR_RootConstrainSelectedInstOperands,
     /* 213806 */     // GIR_Coverage, 3766,
     /* 213806 */     GIR_EraseRootFromParent_Done,
     /* 213807 */   // Label 3398: @213807
     /* 213807 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(213864), // Rule ID 3705 //
     /* 213812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213815 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213838 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 213841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213848 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213862 */     GIR_RootConstrainSelectedInstOperands,
     /* 213863 */     // GIR_Coverage, 3705,
     /* 213863 */     GIR_EraseRootFromParent_Done,
     /* 213864 */   // Label 3399: @213864
     /* 213864 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(213920), // Rule ID 3765 //
     /* 213869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213872 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213894 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 213897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213904 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213918 */     GIR_RootConstrainSelectedInstOperands,
     /* 213919 */     // GIR_Coverage, 3765,
     /* 213919 */     GIR_EraseRootFromParent_Done,
     /* 213920 */   // Label 3400: @213920
     /* 213920 */   GIM_Reject,
     /* 213921 */ // Label 3378: @213921
     /* 213921 */ GIM_Reject,
     /* 213922 */ // Label 3354: @213922
     /* 213922 */ GIM_Reject,
     /* 213923 */ // Label 29: @213923
     /* 213923 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 3404*/ GIMT_Encode4(216133),
     /* 213934 */ /*GILLT_s32*//*Label 3401*/ GIMT_Encode4(213946),
     /* 213938 */ /*GILLT_s64*//*Label 3402*/ GIMT_Encode4(214604),
     /* 213942 */ /*GILLT_v2s16*//*Label 3403*/ GIMT_Encode4(215054),
     /* 213946 */ // Label 3401: @213946
     /* 213946 */ GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(214603),
     /* 213951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213954 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(214004), // Rule ID 8227 //
     /* 213959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 213962 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213967 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213980 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 213983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213988 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214002 */     GIR_RootConstrainSelectedInstOperands,
     /* 214003 */     // GIR_Coverage, 8227,
     /* 214003 */     GIR_EraseRootFromParent_Done,
     /* 214004 */   // Label 3406: @214004
     /* 214004 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(214054), // Rule ID 8229 //
     /* 214009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 214012 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214017 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214030 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f32>>  =>  (DS_ADD_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32_gfx9),
     /* 214033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214038 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214052 */     GIR_RootConstrainSelectedInstOperands,
     /* 214053 */     // GIR_Coverage, 8229,
     /* 214053 */     GIR_EraseRootFromParent_Done,
     /* 214054 */   // Label 3407: @214054
     /* 214054 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(214104), // Rule ID 8231 //
     /* 214059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 214062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 214067 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214080 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 214083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214088 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214102 */     GIR_RootConstrainSelectedInstOperands,
     /* 214103 */     // GIR_Coverage, 8231,
     /* 214103 */     GIR_EraseRootFromParent_Done,
     /* 214104 */   // Label 3408: @214104
     /* 214104 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(214158), // Rule ID 8226 //
     /* 214109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 214112 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214132 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 214135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214142 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 214157 */     // GIR_Coverage, 8226,
     /* 214157 */     GIR_EraseRootFromParent_Done,
     /* 214158 */   // Label 3409: @214158
     /* 214158 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(214212), // Rule ID 8228 //
     /* 214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 214166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214186 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_f32>>  =>  (DS_ADD_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32_gfx9),
     /* 214189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214196 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214210 */     GIR_RootConstrainSelectedInstOperands,
     /* 214211 */     // GIR_Coverage, 8228,
     /* 214211 */     GIR_EraseRootFromParent_Done,
     /* 214212 */   // Label 3410: @214212
     /* 214212 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(214266), // Rule ID 8230 //
     /* 214217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 214220 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 214225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214240 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 214243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214250 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214264 */     GIR_RootConstrainSelectedInstOperands,
     /* 214265 */     // GIR_Coverage, 8230,
     /* 214265 */     GIR_EraseRootFromParent_Done,
     /* 214266 */   // Label 3411: @214266
     /* 214266 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(214323), // Rule ID 4156 //
     /* 214271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 214274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214281 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214294 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR),
     /* 214297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214302 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214321 */     GIR_RootConstrainSelectedInstOperands,
     /* 214322 */     // GIR_Coverage, 4156,
     /* 214322 */     GIR_EraseRootFromParent_Done,
     /* 214323 */   // Label 3412: @214323
     /* 214323 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(214384), // Rule ID 4160 //
     /* 214328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 214331 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214353 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR_RTN),
     /* 214356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214363 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214382 */     GIR_RootConstrainSelectedInstOperands,
     /* 214383 */     // GIR_Coverage, 4160,
     /* 214383 */     GIR_EraseRootFromParent_Done,
     /* 214384 */   // Label 3413: @214384
     /* 214384 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(214436), // Rule ID 4155 //
     /* 214389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 214392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214399 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214412 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32),
     /* 214415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214420 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214434 */     GIR_RootConstrainSelectedInstOperands,
     /* 214435 */     // GIR_Coverage, 4155,
     /* 214435 */     GIR_EraseRootFromParent_Done,
     /* 214436 */   // Label 3414: @214436
     /* 214436 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(214492), // Rule ID 4159 //
     /* 214441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 214444 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214466 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_RTN),
     /* 214469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214476 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214490 */     GIR_RootConstrainSelectedInstOperands,
     /* 214491 */     // GIR_Coverage, 4159,
     /* 214491 */     GIR_EraseRootFromParent_Done,
     /* 214492 */   // Label 3415: @214492
     /* 214492 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(214545), // Rule ID 4180 //
     /* 214497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 214500 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214508 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214521 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f32>>  =>  (FLAT_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32),
     /* 214524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214529 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214543 */     GIR_RootConstrainSelectedInstOperands,
     /* 214544 */     // GIR_Coverage, 4180,
     /* 214544 */     GIR_EraseRootFromParent_Done,
     /* 214545 */   // Label 3416: @214545
     /* 214545 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(214602), // Rule ID 4179 //
     /* 214550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 214553 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214576 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_f32>>  =>  (FLAT_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32_RTN),
     /* 214579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214586 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 4179,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 3417: @214602
     /* 214602 */   GIM_Reject,
     /* 214603 */ // Label 3405: @214603
     /* 214603 */ GIM_Reject,
     /* 214604 */ // Label 3402: @214604
     /* 214604 */ GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(215053),
     /* 214609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214612 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(214662), // Rule ID 8324 //
     /* 214617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 214620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214625 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214638 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f64>>  =>  (DS_ADD_F64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F64),
     /* 214641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214646 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214660 */     GIR_RootConstrainSelectedInstOperands,
     /* 214661 */     // GIR_Coverage, 8324,
     /* 214661 */     GIR_EraseRootFromParent_Done,
     /* 214662 */   // Label 3419: @214662
     /* 214662 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(214716), // Rule ID 8323 //
     /* 214667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 214670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214690 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_f64>>  =>  (DS_ADD_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F64),
     /* 214693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214700 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214714 */     GIR_RootConstrainSelectedInstOperands,
     /* 214715 */     // GIR_Coverage, 8323,
     /* 214715 */     GIR_EraseRootFromParent_Done,
     /* 214716 */   // Label 3420: @214716
     /* 214716 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(214773), // Rule ID 4174 //
     /* 214721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214724 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214731 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214744 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR),
     /* 214747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214752 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214771 */     GIR_RootConstrainSelectedInstOperands,
     /* 214772 */     // GIR_Coverage, 4174,
     /* 214772 */     GIR_EraseRootFromParent_Done,
     /* 214773 */   // Label 3421: @214773
     /* 214773 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(214834), // Rule ID 4176 //
     /* 214778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214781 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214803 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR_RTN),
     /* 214806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214813 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214832 */     GIR_RootConstrainSelectedInstOperands,
     /* 214833 */     // GIR_Coverage, 4176,
     /* 214833 */     GIR_EraseRootFromParent_Done,
     /* 214834 */   // Label 3422: @214834
     /* 214834 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(214886), // Rule ID 4173 //
     /* 214839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214842 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214849 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214862 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64),
     /* 214865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214870 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214884 */     GIR_RootConstrainSelectedInstOperands,
     /* 214885 */     // GIR_Coverage, 4173,
     /* 214885 */     GIR_EraseRootFromParent_Done,
     /* 214886 */   // Label 3423: @214886
     /* 214886 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(214942), // Rule ID 4175 //
     /* 214891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214916 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_RTN),
     /* 214919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214926 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214940 */     GIR_RootConstrainSelectedInstOperands,
     /* 214941 */     // GIR_Coverage, 4175,
     /* 214941 */     GIR_EraseRootFromParent_Done,
     /* 214942 */   // Label 3424: @214942
     /* 214942 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(214995), // Rule ID 4178 //
     /* 214947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214950 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214958 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214971 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f64>>  =>  (FLAT_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64),
     /* 214974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214979 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214993 */     GIR_RootConstrainSelectedInstOperands,
     /* 214994 */     // GIR_Coverage, 4178,
     /* 214994 */     GIR_EraseRootFromParent_Done,
     /* 214995 */   // Label 3425: @214995
     /* 214995 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(215052), // Rule ID 4177 //
     /* 215000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 215003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 215015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215026 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_f64>>  =>  (FLAT_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 215026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64_RTN),
     /* 215029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215036 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215050 */     GIR_RootConstrainSelectedInstOperands,
     /* 215051 */     // GIR_Coverage, 4177,
     /* 215051 */     GIR_EraseRootFromParent_Done,
     /* 215052 */   // Label 3426: @215052
     /* 215052 */   GIM_Reject,
     /* 215053 */ // Label 3418: @215053
     /* 215053 */ GIM_Reject,
     /* 215054 */ // Label 3403: @215054
     /* 215054 */ GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(216132),
     /* 215059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 215062 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(215112), // Rule ID 8221 //
     /* 215067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215075 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215088 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215096 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215110 */     GIR_RootConstrainSelectedInstOperands,
     /* 215111 */     // GIR_Coverage, 8221,
     /* 215111 */     GIR_EraseRootFromParent_Done,
     /* 215112 */   // Label 3428: @215112
     /* 215112 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(215162), // Rule ID 8223 //
     /* 215117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215125 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215138 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 215141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215146 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215160 */     GIR_RootConstrainSelectedInstOperands,
     /* 215161 */     // GIR_Coverage, 8223,
     /* 215161 */     GIR_EraseRootFromParent_Done,
     /* 215162 */   // Label 3429: @215162
     /* 215162 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(215212), // Rule ID 8225 //
     /* 215167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215170 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215175 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215188 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215196 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215210 */     GIR_RootConstrainSelectedInstOperands,
     /* 215211 */     // GIR_Coverage, 8225,
     /* 215211 */     GIR_EraseRootFromParent_Done,
     /* 215212 */   // Label 3430: @215212
     /* 215212 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(215262), // Rule ID 8326 //
     /* 215217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215220 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215225 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215238 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215246 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215260 */     GIR_RootConstrainSelectedInstOperands,
     /* 215261 */     // GIR_Coverage, 8326,
     /* 215261 */     GIR_EraseRootFromParent_Done,
     /* 215262 */   // Label 3431: @215262
     /* 215262 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(215312), // Rule ID 8328 //
     /* 215267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215270 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215275 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215288 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 215291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215296 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215310 */     GIR_RootConstrainSelectedInstOperands,
     /* 215311 */     // GIR_Coverage, 8328,
     /* 215311 */     GIR_EraseRootFromParent_Done,
     /* 215312 */   // Label 3432: @215312
     /* 215312 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(215362), // Rule ID 8330 //
     /* 215317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215320 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215325 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215338 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215346 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215360 */     GIR_RootConstrainSelectedInstOperands,
     /* 215361 */     // GIR_Coverage, 8330,
     /* 215361 */     GIR_EraseRootFromParent_Done,
     /* 215362 */   // Label 3433: @215362
     /* 215362 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(215416), // Rule ID 8220 //
     /* 215367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215390 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215400 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215414 */     GIR_RootConstrainSelectedInstOperands,
     /* 215415 */     // GIR_Coverage, 8220,
     /* 215415 */     GIR_EraseRootFromParent_Done,
     /* 215416 */   // Label 3434: @215416
     /* 215416 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(215470), // Rule ID 8222 //
     /* 215421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215424 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215444 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 215447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215454 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215468 */     GIR_RootConstrainSelectedInstOperands,
     /* 215469 */     // GIR_Coverage, 8222,
     /* 215469 */     GIR_EraseRootFromParent_Done,
     /* 215470 */   // Label 3435: @215470
     /* 215470 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(215524), // Rule ID 8224 //
     /* 215475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215498 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215508 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215522 */     GIR_RootConstrainSelectedInstOperands,
     /* 215523 */     // GIR_Coverage, 8224,
     /* 215523 */     GIR_EraseRootFromParent_Done,
     /* 215524 */   // Label 3436: @215524
     /* 215524 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(215578), // Rule ID 8325 //
     /* 215529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215532 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215552 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215562 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215576 */     GIR_RootConstrainSelectedInstOperands,
     /* 215577 */     // GIR_Coverage, 8325,
     /* 215577 */     GIR_EraseRootFromParent_Done,
     /* 215578 */   // Label 3437: @215578
     /* 215578 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(215632), // Rule ID 8327 //
     /* 215583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215586 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215606 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 215609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215616 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215630 */     GIR_RootConstrainSelectedInstOperands,
     /* 215631 */     // GIR_Coverage, 8327,
     /* 215631 */     GIR_EraseRootFromParent_Done,
     /* 215632 */   // Label 3438: @215632
     /* 215632 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(215686), // Rule ID 8329 //
     /* 215637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215640 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215660 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215670 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215684 */     GIR_RootConstrainSelectedInstOperands,
     /* 215685 */     // GIR_Coverage, 8329,
     /* 215685 */     GIR_EraseRootFromParent_Done,
     /* 215686 */   // Label 3439: @215686
     /* 215686 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(215743), // Rule ID 4158 //
     /* 215691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 215694 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215701 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215714 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 215717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215722 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215741 */     GIR_RootConstrainSelectedInstOperands,
     /* 215742 */     // GIR_Coverage, 4158,
     /* 215742 */     GIR_EraseRootFromParent_Done,
     /* 215743 */   // Label 3440: @215743
     /* 215743 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(215800), // Rule ID 4162 //
     /* 215748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215751 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215758 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215771 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 215774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215779 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215798 */     GIR_RootConstrainSelectedInstOperands,
     /* 215799 */     // GIR_Coverage, 4162,
     /* 215799 */     GIR_EraseRootFromParent_Done,
     /* 215800 */   // Label 3441: @215800
     /* 215800 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(215861), // Rule ID 4164 //
     /* 215805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215830 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN:{ *:[v2f16] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN),
     /* 215833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215840 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215859 */     GIR_RootConstrainSelectedInstOperands,
     /* 215860 */     // GIR_Coverage, 4164,
     /* 215860 */     GIR_EraseRootFromParent_Done,
     /* 215861 */   // Label 3442: @215861
     /* 215861 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(215913), // Rule ID 4157 //
     /* 215866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 215869 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215876 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215889 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 215892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215897 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215911 */     GIR_RootConstrainSelectedInstOperands,
     /* 215912 */     // GIR_Coverage, 4157,
     /* 215912 */     GIR_EraseRootFromParent_Done,
     /* 215913 */   // Label 3443: @215913
     /* 215913 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(215965), // Rule ID 4161 //
     /* 215918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215921 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215928 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215941 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 215944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215949 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215963 */     GIR_RootConstrainSelectedInstOperands,
     /* 215964 */     // GIR_Coverage, 4161,
     /* 215964 */     GIR_EraseRootFromParent_Done,
     /* 215965 */   // Label 3444: @215965
     /* 215965 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(216021), // Rule ID 4163 //
     /* 215970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215973 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215995 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_RTN),
     /* 215998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216005 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216019 */     GIR_RootConstrainSelectedInstOperands,
     /* 216020 */     // GIR_Coverage, 4163,
     /* 216020 */     GIR_EraseRootFromParent_Done,
     /* 216021 */   // Label 3445: @216021
     /* 216021 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(216074), // Rule ID 4182 //
     /* 216026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 216029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216037 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216050 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 216050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16),
     /* 216053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216058 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216072 */     GIR_RootConstrainSelectedInstOperands,
     /* 216073 */     // GIR_Coverage, 4182,
     /* 216073 */     GIR_EraseRootFromParent_Done,
     /* 216074 */   // Label 3446: @216074
     /* 216074 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(216131), // Rule ID 4181 //
     /* 216079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 216082 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216105 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 216105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16_RTN),
     /* 216108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216115 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216129 */     GIR_RootConstrainSelectedInstOperands,
     /* 216130 */     // GIR_Coverage, 4181,
     /* 216130 */     GIR_EraseRootFromParent_Done,
     /* 216131 */   // Label 3447: @216131
     /* 216131 */   GIM_Reject,
     /* 216132 */ // Label 3427: @216132
     /* 216132 */ GIM_Reject,
     /* 216133 */ // Label 3404: @216133
     /* 216133 */ GIM_Reject,
     /* 216134 */ // Label 30: @216134
     /* 216134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3450*/ GIMT_Encode4(218779),
     /* 216145 */ /*GILLT_s32*//*Label 3448*/ GIMT_Encode4(216153),
     /* 216149 */ /*GILLT_s64*//*Label 3449*/ GIMT_Encode4(217521),
     /* 216153 */ // Label 3448: @216153
     /* 216153 */ GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(217520),
     /* 216158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 216161 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(216223), // Rule ID 5777 //
     /* 216166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216169 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216176 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216189 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64 anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64),
     /* 216192 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216221 */     GIR_RootConstrainSelectedInstOperands,
     /* 216222 */     // GIR_Coverage, 5777,
     /* 216222 */     GIR_EraseRootFromParent_Done,
     /* 216223 */   // Label 3452: @216223
     /* 216223 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(216285), // Rule ID 5781 //
     /* 216228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216238 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216251 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64 anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64),
     /* 216254 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216283 */     GIR_RootConstrainSelectedInstOperands,
     /* 216284 */     // GIR_Coverage, 5781,
     /* 216284 */     GIR_EraseRootFromParent_Done,
     /* 216285 */   // Label 3453: @216285
     /* 216285 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(216351), // Rule ID 5775 //
     /* 216290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216315 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64_RTN),
     /* 216318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216320 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216349 */     GIR_RootConstrainSelectedInstOperands,
     /* 216350 */     // GIR_Coverage, 5775,
     /* 216350 */     GIR_EraseRootFromParent_Done,
     /* 216351 */   // Label 3454: @216351
     /* 216351 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(216417), // Rule ID 5779 //
     /* 216356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216359 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216381 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN),
     /* 216384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216386 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216415 */     GIR_RootConstrainSelectedInstOperands,
     /* 216416 */     // GIR_Coverage, 5779,
     /* 216416 */     GIR_EraseRootFromParent_Done,
     /* 216417 */   // Label 3455: @216417
     /* 216417 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(216474), // Rule ID 5776 //
     /* 216422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216425 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216432 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216445 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 216448 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216472 */     GIR_RootConstrainSelectedInstOperands,
     /* 216473 */     // GIR_Coverage, 5776,
     /* 216473 */     GIR_EraseRootFromParent_Done,
     /* 216474 */   // Label 3456: @216474
     /* 216474 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(216531), // Rule ID 5780 //
     /* 216479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216482 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216489 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216502 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216529 */     GIR_RootConstrainSelectedInstOperands,
     /* 216530 */     // GIR_Coverage, 5780,
     /* 216530 */     GIR_EraseRootFromParent_Done,
     /* 216531 */   // Label 3457: @216531
     /* 216531 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(216592), // Rule ID 5774 //
     /* 216536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216539 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216561 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 216564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216566 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216590 */     GIR_RootConstrainSelectedInstOperands,
     /* 216591 */     // GIR_Coverage, 5774,
     /* 216591 */     GIR_EraseRootFromParent_Done,
     /* 216592 */   // Label 3458: @216592
     /* 216592 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(216653), // Rule ID 5778 //
     /* 216597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216600 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216622 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 216625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216627 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216651 */     GIR_RootConstrainSelectedInstOperands,
     /* 216652 */     // GIR_Coverage, 5778,
     /* 216652 */     GIR_EraseRootFromParent_Done,
     /* 216653 */   // Label 3459: @216653
     /* 216653 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(216703), // Rule ID 8215 //
     /* 216658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 216661 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216666 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216679 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 216682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216687 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216701 */     GIR_RootConstrainSelectedInstOperands,
     /* 216702 */     // GIR_Coverage, 8215,
     /* 216702 */     GIR_EraseRootFromParent_Done,
     /* 216703 */   // Label 3460: @216703
     /* 216703 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(216753), // Rule ID 8217 //
     /* 216708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 216711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216716 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216729 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f32>>  =>  (DS_MAX_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32_gfx9),
     /* 216732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216737 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216751 */     GIR_RootConstrainSelectedInstOperands,
     /* 216752 */     // GIR_Coverage, 8217,
     /* 216752 */     GIR_EraseRootFromParent_Done,
     /* 216753 */   // Label 3461: @216753
     /* 216753 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(216803), // Rule ID 8219 //
     /* 216758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 216761 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 216766 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216779 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 216779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 216782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216787 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216801 */     GIR_RootConstrainSelectedInstOperands,
     /* 216802 */     // GIR_Coverage, 8219,
     /* 216802 */     GIR_EraseRootFromParent_Done,
     /* 216803 */   // Label 3462: @216803
     /* 216803 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(216857), // Rule ID 8214 //
     /* 216808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 216811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216831 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 216834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216841 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216855 */     GIR_RootConstrainSelectedInstOperands,
     /* 216856 */     // GIR_Coverage, 8214,
     /* 216856 */     GIR_EraseRootFromParent_Done,
     /* 216857 */   // Label 3463: @216857
     /* 216857 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(216911), // Rule ID 8216 //
     /* 216862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 216865 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216885 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_f32>>  =>  (DS_MAX_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32_gfx9),
     /* 216888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216895 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216909 */     GIR_RootConstrainSelectedInstOperands,
     /* 216910 */     // GIR_Coverage, 8216,
     /* 216910 */     GIR_EraseRootFromParent_Done,
     /* 216911 */   // Label 3464: @216911
     /* 216911 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(216965), // Rule ID 8218 //
     /* 216916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 216919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 216924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216939 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 216939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 216942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216949 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216963 */     GIR_RootConstrainSelectedInstOperands,
     /* 216964 */     // GIR_Coverage, 8218,
     /* 216964 */     GIR_EraseRootFromParent_Done,
     /* 216965 */   // Label 3465: @216965
     /* 216965 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(217022), // Rule ID 4136 //
     /* 216970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 216973 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216980 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 216993 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 216993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 216996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 217001 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 217008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217020 */     GIR_RootConstrainSelectedInstOperands,
     /* 217021 */     // GIR_Coverage, 4136,
     /* 217021 */     GIR_EraseRootFromParent_Done,
     /* 217022 */   // Label 3466: @217022
     /* 217022 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(217083), // Rule ID 4138 //
     /* 217027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 217030 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 217052 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 217052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 217055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 217062 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 217069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217081 */     GIR_RootConstrainSelectedInstOperands,
     /* 217082 */     // GIR_Coverage, 4138,
     /* 217082 */     GIR_EraseRootFromParent_Done,
     /* 217083 */   // Label 3467: @217083
     /* 217083 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(217135), // Rule ID 4135 //
     /* 217088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 217091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217098 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 217111 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 217114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217119 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217133 */     GIR_RootConstrainSelectedInstOperands,
     /* 217134 */     // GIR_Coverage, 4135,
     /* 217134 */     GIR_EraseRootFromParent_Done,
     /* 217135 */   // Label 3468: @217135
     /* 217135 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(217191), // Rule ID 4137 //
     /* 217140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 217143 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 217165 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 217168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217175 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217189 */     GIR_RootConstrainSelectedInstOperands,
     /* 217190 */     // GIR_Coverage, 4137,
     /* 217190 */     GIR_EraseRootFromParent_Done,
     /* 217191 */   // Label 3469: @217191
     /* 217191 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(217244), // Rule ID 3718 //
     /* 217196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217207 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217220 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 217223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217228 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217242 */     GIR_RootConstrainSelectedInstOperands,
     /* 217243 */     // GIR_Coverage, 3718,
     /* 217243 */     GIR_EraseRootFromParent_Done,
     /* 217244 */   // Label 3470: @217244
     /* 217244 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(217296), // Rule ID 3778 //
     /* 217249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217272 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 217275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217280 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217294 */     GIR_RootConstrainSelectedInstOperands,
     /* 217295 */     // GIR_Coverage, 3778,
     /* 217295 */     GIR_EraseRootFromParent_Done,
     /* 217296 */   // Label 3471: @217296
     /* 217296 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(217349), // Rule ID 4142 //
     /* 217301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 217304 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217312 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217325 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 217328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217333 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217347 */     GIR_RootConstrainSelectedInstOperands,
     /* 217348 */     // GIR_Coverage, 4142,
     /* 217348 */     GIR_EraseRootFromParent_Done,
     /* 217349 */   // Label 3472: @217349
     /* 217349 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(217406), // Rule ID 3717 //
     /* 217354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217357 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217380 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217390 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217404 */     GIR_RootConstrainSelectedInstOperands,
     /* 217405 */     // GIR_Coverage, 3717,
     /* 217405 */     GIR_EraseRootFromParent_Done,
     /* 217406 */   // Label 3473: @217406
     /* 217406 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(217462), // Rule ID 3777 //
     /* 217411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217414 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217436 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217446 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217460 */     GIR_RootConstrainSelectedInstOperands,
     /* 217461 */     // GIR_Coverage, 3777,
     /* 217461 */     GIR_EraseRootFromParent_Done,
     /* 217462 */   // Label 3474: @217462
     /* 217462 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(217519), // Rule ID 4141 //
     /* 217467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 217470 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217493 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217503 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217517 */     GIR_RootConstrainSelectedInstOperands,
     /* 217518 */     // GIR_Coverage, 4141,
     /* 217518 */     GIR_EraseRootFromParent_Done,
     /* 217519 */   // Label 3475: @217519
     /* 217519 */   GIM_Reject,
     /* 217520 */ // Label 3451: @217520
     /* 217520 */ GIM_Reject,
     /* 217521 */ // Label 3449: @217521
     /* 217521 */ GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(218778),
     /* 217526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217529 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(217591), // Rule ID 5793 //
     /* 217534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217544 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217557 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64 anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64),
     /* 217560 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217589 */     GIR_RootConstrainSelectedInstOperands,
     /* 217590 */     // GIR_Coverage, 5793,
     /* 217590 */     GIR_EraseRootFromParent_Done,
     /* 217591 */   // Label 3477: @217591
     /* 217591 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(217653), // Rule ID 5797 //
     /* 217596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217606 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217619 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64 anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64),
     /* 217622 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217651 */     GIR_RootConstrainSelectedInstOperands,
     /* 217652 */     // GIR_Coverage, 5797,
     /* 217652 */     GIR_EraseRootFromParent_Done,
     /* 217653 */   // Label 3478: @217653
     /* 217653 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(217719), // Rule ID 5791 //
     /* 217658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217661 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217683 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64_RTN),
     /* 217686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217688 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217717 */     GIR_RootConstrainSelectedInstOperands,
     /* 217718 */     // GIR_Coverage, 5791,
     /* 217718 */     GIR_EraseRootFromParent_Done,
     /* 217719 */   // Label 3479: @217719
     /* 217719 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(217785), // Rule ID 5795 //
     /* 217724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217727 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217749 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN),
     /* 217752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217754 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217783 */     GIR_RootConstrainSelectedInstOperands,
     /* 217784 */     // GIR_Coverage, 5795,
     /* 217784 */     GIR_EraseRootFromParent_Done,
     /* 217785 */   // Label 3480: @217785
     /* 217785 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(217842), // Rule ID 5792 //
     /* 217790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217800 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217813 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 217816 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217840 */     GIR_RootConstrainSelectedInstOperands,
     /* 217841 */     // GIR_Coverage, 5792,
     /* 217841 */     GIR_EraseRootFromParent_Done,
     /* 217842 */   // Label 3481: @217842
     /* 217842 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(217899), // Rule ID 5796 //
     /* 217847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217850 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217857 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217870 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 217873 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217897 */     GIR_RootConstrainSelectedInstOperands,
     /* 217898 */     // GIR_Coverage, 5796,
     /* 217898 */     GIR_EraseRootFromParent_Done,
     /* 217899 */   // Label 3482: @217899
     /* 217899 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(217960), // Rule ID 5790 //
     /* 217904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217907 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217929 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 217932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217934 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217958 */     GIR_RootConstrainSelectedInstOperands,
     /* 217959 */     // GIR_Coverage, 5790,
     /* 217959 */     GIR_EraseRootFromParent_Done,
     /* 217960 */   // Label 3483: @217960
     /* 217960 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(218021), // Rule ID 5794 //
     /* 217965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217990 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 217993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217995 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 218007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218019 */     GIR_RootConstrainSelectedInstOperands,
     /* 218020 */     // GIR_Coverage, 5794,
     /* 218020 */     GIR_EraseRootFromParent_Done,
     /* 218021 */   // Label 3484: @218021
     /* 218021 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(218071), // Rule ID 8308 //
     /* 218026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 218029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218034 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218047 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 218050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218055 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218069 */     GIR_RootConstrainSelectedInstOperands,
     /* 218070 */     // GIR_Coverage, 8308,
     /* 218070 */     GIR_EraseRootFromParent_Done,
     /* 218071 */   // Label 3485: @218071
     /* 218071 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(218121), // Rule ID 8310 //
     /* 218076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 218079 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218084 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218097 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f64>>  =>  (DS_MAX_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64_gfx9),
     /* 218100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218105 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218119 */     GIR_RootConstrainSelectedInstOperands,
     /* 218120 */     // GIR_Coverage, 8310,
     /* 218120 */     GIR_EraseRootFromParent_Done,
     /* 218121 */   // Label 3486: @218121
     /* 218121 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(218171), // Rule ID 8312 //
     /* 218126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 218129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 218134 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218147 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 218147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 218150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218155 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218169 */     GIR_RootConstrainSelectedInstOperands,
     /* 218170 */     // GIR_Coverage, 8312,
     /* 218170 */     GIR_EraseRootFromParent_Done,
     /* 218171 */   // Label 3487: @218171
     /* 218171 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(218225), // Rule ID 8307 //
     /* 218176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 218179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218199 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 218202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218209 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218223 */     GIR_RootConstrainSelectedInstOperands,
     /* 218224 */     // GIR_Coverage, 8307,
     /* 218224 */     GIR_EraseRootFromParent_Done,
     /* 218225 */   // Label 3488: @218225
     /* 218225 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(218279), // Rule ID 8309 //
     /* 218230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 218233 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218253 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_f64>>  =>  (DS_MAX_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64_gfx9),
     /* 218256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218263 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218277 */     GIR_RootConstrainSelectedInstOperands,
     /* 218278 */     // GIR_Coverage, 8309,
     /* 218278 */     GIR_EraseRootFromParent_Done,
     /* 218279 */   // Label 3489: @218279
     /* 218279 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(218333), // Rule ID 8311 //
     /* 218284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 218287 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 218292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218307 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 218307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 218310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218317 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218331 */     GIR_RootConstrainSelectedInstOperands,
     /* 218332 */     // GIR_Coverage, 8311,
     /* 218332 */     GIR_EraseRootFromParent_Done,
     /* 218333 */   // Label 3490: @218333
     /* 218333 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(218390), // Rule ID 4170 //
     /* 218338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218341 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218348 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218361 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR),
     /* 218364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218369 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218388 */     GIR_RootConstrainSelectedInstOperands,
     /* 218389 */     // GIR_Coverage, 4170,
     /* 218389 */     GIR_EraseRootFromParent_Done,
     /* 218390 */   // Label 3491: @218390
     /* 218390 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(218451), // Rule ID 4172 //
     /* 218395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218420 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR_RTN),
     /* 218423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218430 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218449 */     GIR_RootConstrainSelectedInstOperands,
     /* 218450 */     // GIR_Coverage, 4172,
     /* 218450 */     GIR_EraseRootFromParent_Done,
     /* 218451 */   // Label 3492: @218451
     /* 218451 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(218503), // Rule ID 4169 //
     /* 218456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218459 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218466 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218479 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64),
     /* 218482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218487 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218501 */     GIR_RootConstrainSelectedInstOperands,
     /* 218502 */     // GIR_Coverage, 4169,
     /* 218502 */     GIR_EraseRootFromParent_Done,
     /* 218503 */   // Label 3493: @218503
     /* 218503 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(218559), // Rule ID 4171 //
     /* 218508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218533 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_RTN),
     /* 218536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218543 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218557 */     GIR_RootConstrainSelectedInstOperands,
     /* 218558 */     // GIR_Coverage, 4171,
     /* 218558 */     GIR_EraseRootFromParent_Done,
     /* 218559 */   // Label 3494: @218559
     /* 218559 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(218612), // Rule ID 3722 //
     /* 218564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218567 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218575 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218588 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 218591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218596 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218610 */     GIR_RootConstrainSelectedInstOperands,
     /* 218611 */     // GIR_Coverage, 3722,
     /* 218611 */     GIR_EraseRootFromParent_Done,
     /* 218612 */   // Label 3495: @218612
     /* 218612 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(218664), // Rule ID 3782 //
     /* 218617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218627 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218640 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 218643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218648 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218662 */     GIR_RootConstrainSelectedInstOperands,
     /* 218663 */     // GIR_Coverage, 3782,
     /* 218663 */     GIR_EraseRootFromParent_Done,
     /* 218664 */   // Label 3496: @218664
     /* 218664 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(218721), // Rule ID 3721 //
     /* 218669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218695 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 218698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218705 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218719 */     GIR_RootConstrainSelectedInstOperands,
     /* 218720 */     // GIR_Coverage, 3721,
     /* 218720 */     GIR_EraseRootFromParent_Done,
     /* 218721 */   // Label 3497: @218721
     /* 218721 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(218777), // Rule ID 3781 //
     /* 218726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218729 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218751 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 218754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218761 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218775 */     GIR_RootConstrainSelectedInstOperands,
     /* 218776 */     // GIR_Coverage, 3781,
     /* 218776 */     GIR_EraseRootFromParent_Done,
     /* 218777 */   // Label 3498: @218777
     /* 218777 */   GIM_Reject,
     /* 218778 */ // Label 3476: @218778
     /* 218778 */ GIM_Reject,
     /* 218779 */ // Label 3450: @218779
     /* 218779 */ GIM_Reject,
     /* 218780 */ // Label 31: @218780
     /* 218780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3501*/ GIMT_Encode4(221425),
     /* 218791 */ /*GILLT_s32*//*Label 3499*/ GIMT_Encode4(218799),
     /* 218795 */ /*GILLT_s64*//*Label 3500*/ GIMT_Encode4(220167),
     /* 218799 */ // Label 3499: @218799
     /* 218799 */ GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(220166),
     /* 218804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218807 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(218869), // Rule ID 5769 //
     /* 218812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218815 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218822 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218835 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64 anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64),
     /* 218838 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218867 */     GIR_RootConstrainSelectedInstOperands,
     /* 218868 */     // GIR_Coverage, 5769,
     /* 218868 */     GIR_EraseRootFromParent_Done,
     /* 218869 */   // Label 3503: @218869
     /* 218869 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(218931), // Rule ID 5773 //
     /* 218874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218877 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218884 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218897 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64 anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64),
     /* 218900 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218929 */     GIR_RootConstrainSelectedInstOperands,
     /* 218930 */     // GIR_Coverage, 5773,
     /* 218930 */     GIR_EraseRootFromParent_Done,
     /* 218931 */   // Label 3504: @218931
     /* 218931 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(218997), // Rule ID 5767 //
     /* 218936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218939 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218961 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64_RTN),
     /* 218964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 218966 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218995 */     GIR_RootConstrainSelectedInstOperands,
     /* 218996 */     // GIR_Coverage, 5767,
     /* 218996 */     GIR_EraseRootFromParent_Done,
     /* 218997 */   // Label 3505: @218997
     /* 218997 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(219063), // Rule ID 5771 //
     /* 219002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 219027 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN),
     /* 219030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 219032 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 219039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 219049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 219054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219061 */     GIR_RootConstrainSelectedInstOperands,
     /* 219062 */     // GIR_Coverage, 5771,
     /* 219062 */     GIR_EraseRootFromParent_Done,
     /* 219063 */   // Label 3506: @219063
     /* 219063 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(219120), // Rule ID 5768 //
     /* 219068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219071 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219078 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 219091 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 219094 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 219106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219118 */     GIR_RootConstrainSelectedInstOperands,
     /* 219119 */     // GIR_Coverage, 5768,
     /* 219119 */     GIR_EraseRootFromParent_Done,
     /* 219120 */   // Label 3507: @219120
     /* 219120 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(219177), // Rule ID 5772 //
     /* 219125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219128 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219135 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 219148 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 219151 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 219163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219175 */     GIR_RootConstrainSelectedInstOperands,
     /* 219176 */     // GIR_Coverage, 5772,
     /* 219176 */     GIR_EraseRootFromParent_Done,
     /* 219177 */   // Label 3508: @219177
     /* 219177 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(219238), // Rule ID 5766 //
     /* 219182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 219207 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 219210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 219212 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 219224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219236 */     GIR_RootConstrainSelectedInstOperands,
     /* 219237 */     // GIR_Coverage, 5766,
     /* 219237 */     GIR_EraseRootFromParent_Done,
     /* 219238 */   // Label 3509: @219238
     /* 219238 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(219299), // Rule ID 5770 //
     /* 219243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219246 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 219268 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 219271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 219273 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 219285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219297 */     GIR_RootConstrainSelectedInstOperands,
     /* 219298 */     // GIR_Coverage, 5770,
     /* 219298 */     GIR_EraseRootFromParent_Done,
     /* 219299 */   // Label 3510: @219299
     /* 219299 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(219349), // Rule ID 8209 //
     /* 219304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 219307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219312 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219325 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 219328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219333 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219347 */     GIR_RootConstrainSelectedInstOperands,
     /* 219348 */     // GIR_Coverage, 8209,
     /* 219348 */     GIR_EraseRootFromParent_Done,
     /* 219349 */   // Label 3511: @219349
     /* 219349 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(219399), // Rule ID 8211 //
     /* 219354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 219357 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219362 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219375 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f32>>  =>  (DS_MIN_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32_gfx9),
     /* 219378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219383 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219397 */     GIR_RootConstrainSelectedInstOperands,
     /* 219398 */     // GIR_Coverage, 8211,
     /* 219398 */     GIR_EraseRootFromParent_Done,
     /* 219399 */   // Label 3512: @219399
     /* 219399 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(219449), // Rule ID 8213 //
     /* 219404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 219407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219412 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219425 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 219428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219433 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219447 */     GIR_RootConstrainSelectedInstOperands,
     /* 219448 */     // GIR_Coverage, 8213,
     /* 219448 */     GIR_EraseRootFromParent_Done,
     /* 219449 */   // Label 3513: @219449
     /* 219449 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(219503), // Rule ID 8208 //
     /* 219454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 219457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219477 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 219480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219487 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219501 */     GIR_RootConstrainSelectedInstOperands,
     /* 219502 */     // GIR_Coverage, 8208,
     /* 219502 */     GIR_EraseRootFromParent_Done,
     /* 219503 */   // Label 3514: @219503
     /* 219503 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(219557), // Rule ID 8210 //
     /* 219508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 219511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219531 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_f32>>  =>  (DS_MIN_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32_gfx9),
     /* 219534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219541 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219555 */     GIR_RootConstrainSelectedInstOperands,
     /* 219556 */     // GIR_Coverage, 8210,
     /* 219556 */     GIR_EraseRootFromParent_Done,
     /* 219557 */   // Label 3515: @219557
     /* 219557 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(219611), // Rule ID 8212 //
     /* 219562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 219565 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219585 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 219588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219595 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219609 */     GIR_RootConstrainSelectedInstOperands,
     /* 219610 */     // GIR_Coverage, 8212,
     /* 219610 */     GIR_EraseRootFromParent_Done,
     /* 219611 */   // Label 3516: @219611
     /* 219611 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(219668), // Rule ID 4132 //
     /* 219616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219619 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219626 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219639 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 219642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219647 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219666 */     GIR_RootConstrainSelectedInstOperands,
     /* 219667 */     // GIR_Coverage, 4132,
     /* 219667 */     GIR_EraseRootFromParent_Done,
     /* 219668 */   // Label 3517: @219668
     /* 219668 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(219729), // Rule ID 4134 //
     /* 219673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219676 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219698 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 219701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219708 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219727 */     GIR_RootConstrainSelectedInstOperands,
     /* 219728 */     // GIR_Coverage, 4134,
     /* 219728 */     GIR_EraseRootFromParent_Done,
     /* 219729 */   // Label 3518: @219729
     /* 219729 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(219781), // Rule ID 4131 //
     /* 219734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219744 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219757 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 219760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219765 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219779 */     GIR_RootConstrainSelectedInstOperands,
     /* 219780 */     // GIR_Coverage, 4131,
     /* 219780 */     GIR_EraseRootFromParent_Done,
     /* 219781 */   // Label 3519: @219781
     /* 219781 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(219837), // Rule ID 4133 //
     /* 219786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219789 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219811 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 219814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219821 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219835 */     GIR_RootConstrainSelectedInstOperands,
     /* 219836 */     // GIR_Coverage, 4133,
     /* 219836 */     GIR_EraseRootFromParent_Done,
     /* 219837 */   // Label 3520: @219837
     /* 219837 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(219890), // Rule ID 3716 //
     /* 219842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219853 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219866 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219874 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219888 */     GIR_RootConstrainSelectedInstOperands,
     /* 219889 */     // GIR_Coverage, 3716,
     /* 219889 */     GIR_EraseRootFromParent_Done,
     /* 219890 */   // Label 3521: @219890
     /* 219890 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(219942), // Rule ID 3776 //
     /* 219895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219905 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219918 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219940 */     GIR_RootConstrainSelectedInstOperands,
     /* 219941 */     // GIR_Coverage, 3776,
     /* 219941 */     GIR_EraseRootFromParent_Done,
     /* 219942 */   // Label 3522: @219942
     /* 219942 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(219995), // Rule ID 4140 //
     /* 219947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 219950 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219958 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219971 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219979 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219993 */     GIR_RootConstrainSelectedInstOperands,
     /* 219994 */     // GIR_Coverage, 4140,
     /* 219994 */     GIR_EraseRootFromParent_Done,
     /* 219995 */   // Label 3523: @219995
     /* 219995 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(220052), // Rule ID 3715 //
     /* 220000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 220003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 220026 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 220029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220036 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220050 */     GIR_RootConstrainSelectedInstOperands,
     /* 220051 */     // GIR_Coverage, 3715,
     /* 220051 */     GIR_EraseRootFromParent_Done,
     /* 220052 */   // Label 3524: @220052
     /* 220052 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(220108), // Rule ID 3775 //
     /* 220057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 220060 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 220082 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 220085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220092 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220106 */     GIR_RootConstrainSelectedInstOperands,
     /* 220107 */     // GIR_Coverage, 3775,
     /* 220107 */     GIR_EraseRootFromParent_Done,
     /* 220108 */   // Label 3525: @220108
     /* 220108 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(220165), // Rule ID 4139 //
     /* 220113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 220116 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 220139 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 220142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220149 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220163 */     GIR_RootConstrainSelectedInstOperands,
     /* 220164 */     // GIR_Coverage, 4139,
     /* 220164 */     GIR_EraseRootFromParent_Done,
     /* 220165 */   // Label 3526: @220165
     /* 220165 */   GIM_Reject,
     /* 220166 */ // Label 3502: @220166
     /* 220166 */ GIM_Reject,
     /* 220167 */ // Label 3500: @220167
     /* 220167 */ GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(221424),
     /* 220172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220175 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(220237), // Rule ID 5785 //
     /* 220180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220183 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220190 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220203 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64 anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64),
     /* 220206 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220235 */     GIR_RootConstrainSelectedInstOperands,
     /* 220236 */     // GIR_Coverage, 5785,
     /* 220236 */     GIR_EraseRootFromParent_Done,
     /* 220237 */   // Label 3528: @220237
     /* 220237 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(220299), // Rule ID 5789 //
     /* 220242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220252 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220265 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64 anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64),
     /* 220268 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220297 */     GIR_RootConstrainSelectedInstOperands,
     /* 220298 */     // GIR_Coverage, 5789,
     /* 220298 */     GIR_EraseRootFromParent_Done,
     /* 220299 */   // Label 3529: @220299
     /* 220299 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(220365), // Rule ID 5783 //
     /* 220304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220329 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64_RTN),
     /* 220332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220334 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220363 */     GIR_RootConstrainSelectedInstOperands,
     /* 220364 */     // GIR_Coverage, 5783,
     /* 220364 */     GIR_EraseRootFromParent_Done,
     /* 220365 */   // Label 3530: @220365
     /* 220365 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(220431), // Rule ID 5787 //
     /* 220370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220373 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220395 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN),
     /* 220398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220400 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220429 */     GIR_RootConstrainSelectedInstOperands,
     /* 220430 */     // GIR_Coverage, 5787,
     /* 220430 */     GIR_EraseRootFromParent_Done,
     /* 220431 */   // Label 3531: @220431
     /* 220431 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(220488), // Rule ID 5784 //
     /* 220436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220439 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220446 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220459 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 220462 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220486 */     GIR_RootConstrainSelectedInstOperands,
     /* 220487 */     // GIR_Coverage, 5784,
     /* 220487 */     GIR_EraseRootFromParent_Done,
     /* 220488 */   // Label 3532: @220488
     /* 220488 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(220545), // Rule ID 5788 //
     /* 220493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220496 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220503 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220516 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220543 */     GIR_RootConstrainSelectedInstOperands,
     /* 220544 */     // GIR_Coverage, 5788,
     /* 220544 */     GIR_EraseRootFromParent_Done,
     /* 220545 */   // Label 3533: @220545
     /* 220545 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(220606), // Rule ID 5782 //
     /* 220550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220553 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220575 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 220578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220580 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220604 */     GIR_RootConstrainSelectedInstOperands,
     /* 220605 */     // GIR_Coverage, 5782,
     /* 220605 */     GIR_EraseRootFromParent_Done,
     /* 220606 */   // Label 3534: @220606
     /* 220606 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(220667), // Rule ID 5786 //
     /* 220611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220636 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 220639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220641 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220665 */     GIR_RootConstrainSelectedInstOperands,
     /* 220666 */     // GIR_Coverage, 5786,
     /* 220666 */     GIR_EraseRootFromParent_Done,
     /* 220667 */   // Label 3535: @220667
     /* 220667 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(220717), // Rule ID 8302 //
     /* 220672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220675 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220680 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220693 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 220696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220701 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220715 */     GIR_RootConstrainSelectedInstOperands,
     /* 220716 */     // GIR_Coverage, 8302,
     /* 220716 */     GIR_EraseRootFromParent_Done,
     /* 220717 */   // Label 3536: @220717
     /* 220717 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(220767), // Rule ID 8304 //
     /* 220722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220730 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220743 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f64>>  =>  (DS_MIN_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64_gfx9),
     /* 220746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220751 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220765 */     GIR_RootConstrainSelectedInstOperands,
     /* 220766 */     // GIR_Coverage, 8304,
     /* 220766 */     GIR_EraseRootFromParent_Done,
     /* 220767 */   // Label 3537: @220767
     /* 220767 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(220817), // Rule ID 8306 //
     /* 220772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220775 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220780 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220793 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 220796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220801 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220815 */     GIR_RootConstrainSelectedInstOperands,
     /* 220816 */     // GIR_Coverage, 8306,
     /* 220816 */     GIR_EraseRootFromParent_Done,
     /* 220817 */   // Label 3538: @220817
     /* 220817 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(220871), // Rule ID 8301 //
     /* 220822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220825 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220845 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 220848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220855 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220869 */     GIR_RootConstrainSelectedInstOperands,
     /* 220870 */     // GIR_Coverage, 8301,
     /* 220870 */     GIR_EraseRootFromParent_Done,
     /* 220871 */   // Label 3539: @220871
     /* 220871 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(220925), // Rule ID 8303 //
     /* 220876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220879 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220899 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_f64>>  =>  (DS_MIN_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64_gfx9),
     /* 220902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220909 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220923 */     GIR_RootConstrainSelectedInstOperands,
     /* 220924 */     // GIR_Coverage, 8303,
     /* 220924 */     GIR_EraseRootFromParent_Done,
     /* 220925 */   // Label 3540: @220925
     /* 220925 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(220979), // Rule ID 8305 //
     /* 220930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220953 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 220956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220963 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220977 */     GIR_RootConstrainSelectedInstOperands,
     /* 220978 */     // GIR_Coverage, 8305,
     /* 220978 */     GIR_EraseRootFromParent_Done,
     /* 220979 */   // Label 3541: @220979
     /* 220979 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(221036), // Rule ID 4166 //
     /* 220984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 220987 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220994 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 221007 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 221007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR),
     /* 221010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 221015 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 221022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221034 */     GIR_RootConstrainSelectedInstOperands,
     /* 221035 */     // GIR_Coverage, 4166,
     /* 221035 */     GIR_EraseRootFromParent_Done,
     /* 221036 */   // Label 3542: @221036
     /* 221036 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(221097), // Rule ID 4168 //
     /* 221041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 221044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 221066 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 221066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR_RTN),
     /* 221069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 221076 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 221083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221095 */     GIR_RootConstrainSelectedInstOperands,
     /* 221096 */     // GIR_Coverage, 4168,
     /* 221096 */     GIR_EraseRootFromParent_Done,
     /* 221097 */   // Label 3543: @221097
     /* 221097 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(221149), // Rule ID 4165 //
     /* 221102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 221105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221112 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 221125 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64),
     /* 221128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221133 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221147 */     GIR_RootConstrainSelectedInstOperands,
     /* 221148 */     // GIR_Coverage, 4165,
     /* 221148 */     GIR_EraseRootFromParent_Done,
     /* 221149 */   // Label 3544: @221149
     /* 221149 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(221205), // Rule ID 4167 //
     /* 221154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 221157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 221179 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_RTN),
     /* 221182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221189 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221203 */     GIR_RootConstrainSelectedInstOperands,
     /* 221204 */     // GIR_Coverage, 4167,
     /* 221204 */     GIR_EraseRootFromParent_Done,
     /* 221205 */   // Label 3545: @221205
     /* 221205 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(221258), // Rule ID 3720 //
     /* 221210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221221 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221234 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 221237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221242 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221256 */     GIR_RootConstrainSelectedInstOperands,
     /* 221257 */     // GIR_Coverage, 3720,
     /* 221257 */     GIR_EraseRootFromParent_Done,
     /* 221258 */   // Label 3546: @221258
     /* 221258 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(221310), // Rule ID 3780 //
     /* 221263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221266 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221273 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221286 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 221289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221294 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221308 */     GIR_RootConstrainSelectedInstOperands,
     /* 221309 */     // GIR_Coverage, 3780,
     /* 221309 */     GIR_EraseRootFromParent_Done,
     /* 221310 */   // Label 3547: @221310
     /* 221310 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(221367), // Rule ID 3719 //
     /* 221315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221318 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221341 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 221344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221351 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221365 */     GIR_RootConstrainSelectedInstOperands,
     /* 221366 */     // GIR_Coverage, 3719,
     /* 221366 */     GIR_EraseRootFromParent_Done,
     /* 221367 */   // Label 3548: @221367
     /* 221367 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(221423), // Rule ID 3779 //
     /* 221372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221375 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221397 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 221400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221407 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221421 */     GIR_RootConstrainSelectedInstOperands,
     /* 221422 */     // GIR_Coverage, 3779,
     /* 221422 */     GIR_EraseRootFromParent_Done,
     /* 221423 */   // Label 3549: @221423
     /* 221423 */   GIM_Reject,
     /* 221424 */ // Label 3527: @221424
     /* 221424 */ GIM_Reject,
     /* 221425 */ // Label 3501: @221425
     /* 221425 */ GIM_Reject,
     /* 221426 */ // Label 32: @221426
     /* 221426 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3552*/ GIMT_Encode4(223937),
     /* 221437 */ /*GILLT_s32*//*Label 3550*/ GIMT_Encode4(221445),
     /* 221441 */ /*GILLT_s64*//*Label 3551*/ GIMT_Encode4(222691),
     /* 221445 */ // Label 3550: @221445
     /* 221445 */ GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(222690),
     /* 221450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221453 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(221515), // Rule ID 5657 //
     /* 221458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221461 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221468 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221481 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64),
     /* 221484 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221513 */     GIR_RootConstrainSelectedInstOperands,
     /* 221514 */     // GIR_Coverage, 5657,
     /* 221514 */     GIR_EraseRootFromParent_Done,
     /* 221515 */   // Label 3554: @221515
     /* 221515 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(221574), // Rule ID 5661 //
     /* 221520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221527 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221540 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64),
     /* 221543 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221572 */     GIR_RootConstrainSelectedInstOperands,
     /* 221573 */     // GIR_Coverage, 5661,
     /* 221573 */     GIR_EraseRootFromParent_Done,
     /* 221574 */   // Label 3555: @221574
     /* 221574 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(221640), // Rule ID 5655 //
     /* 221579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221582 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221604 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64_RTN),
     /* 221607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221609 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221638 */     GIR_RootConstrainSelectedInstOperands,
     /* 221639 */     // GIR_Coverage, 5655,
     /* 221639 */     GIR_EraseRootFromParent_Done,
     /* 221640 */   // Label 3556: @221640
     /* 221640 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(221703), // Rule ID 5659 //
     /* 221645 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221667 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN),
     /* 221670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221672 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221701 */     GIR_RootConstrainSelectedInstOperands,
     /* 221702 */     // GIR_Coverage, 5659,
     /* 221702 */     GIR_EraseRootFromParent_Done,
     /* 221703 */   // Label 3557: @221703
     /* 221703 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(221760), // Rule ID 5656 //
     /* 221708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221731 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 221734 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221758 */     GIR_RootConstrainSelectedInstOperands,
     /* 221759 */     // GIR_Coverage, 5656,
     /* 221759 */     GIR_EraseRootFromParent_Done,
     /* 221760 */   // Label 3558: @221760
     /* 221760 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(221814), // Rule ID 5660 //
     /* 221765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221772 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221785 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 221788 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221812 */     GIR_RootConstrainSelectedInstOperands,
     /* 221813 */     // GIR_Coverage, 5660,
     /* 221813 */     GIR_EraseRootFromParent_Done,
     /* 221814 */   // Label 3559: @221814
     /* 221814 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(221875), // Rule ID 5654 //
     /* 221819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221844 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 221847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221849 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221873 */     GIR_RootConstrainSelectedInstOperands,
     /* 221874 */     // GIR_Coverage, 5654,
     /* 221874 */     GIR_EraseRootFromParent_Done,
     /* 221875 */   // Label 3560: @221875
     /* 221875 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(221933), // Rule ID 5658 //
     /* 221880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221902 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 221905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221907 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221931 */     GIR_RootConstrainSelectedInstOperands,
     /* 221932 */     // GIR_Coverage, 5658,
     /* 221932 */     GIR_EraseRootFromParent_Done,
     /* 221933 */   // Label 3561: @221933
     /* 221933 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(221983), // Rule ID 8155 //
     /* 221938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 221941 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221946 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221959 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 221962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221967 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221981 */     GIR_RootConstrainSelectedInstOperands,
     /* 221982 */     // GIR_Coverage, 8155,
     /* 221982 */     GIR_EraseRootFromParent_Done,
     /* 221983 */   // Label 3562: @221983
     /* 221983 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(222033), // Rule ID 8157 //
     /* 221988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 221991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221996 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222009 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i32>>  =>  (DS_INC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 222009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32_gfx9),
     /* 222012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222017 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222031 */     GIR_RootConstrainSelectedInstOperands,
     /* 222032 */     // GIR_Coverage, 8157,
     /* 222032 */     GIR_EraseRootFromParent_Done,
     /* 222033 */   // Label 3563: @222033
     /* 222033 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(222083), // Rule ID 8159 //
     /* 222038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 222041 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 222046 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222059 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 222059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 222062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222067 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222081 */     GIR_RootConstrainSelectedInstOperands,
     /* 222082 */     // GIR_Coverage, 8159,
     /* 222082 */     GIR_EraseRootFromParent_Done,
     /* 222083 */   // Label 3564: @222083
     /* 222083 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(222137), // Rule ID 8154 //
     /* 222088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 222091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 222096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222111 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 222111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 222114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222121 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222135 */     GIR_RootConstrainSelectedInstOperands,
     /* 222136 */     // GIR_Coverage, 8154,
     /* 222136 */     GIR_EraseRootFromParent_Done,
     /* 222137 */   // Label 3565: @222137
     /* 222137 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(222191), // Rule ID 8156 //
     /* 222142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 222145 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 222150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222165 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i32>>  =>  (DS_INC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 222165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32_gfx9),
     /* 222168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222175 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222189 */     GIR_RootConstrainSelectedInstOperands,
     /* 222190 */     // GIR_Coverage, 8156,
     /* 222190 */     GIR_EraseRootFromParent_Done,
     /* 222191 */   // Label 3566: @222191
     /* 222191 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(222245), // Rule ID 8158 //
     /* 222196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 222199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 222204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222219 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 222219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 222222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222229 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222243 */     GIR_RootConstrainSelectedInstOperands,
     /* 222244 */     // GIR_Coverage, 8158,
     /* 222244 */     GIR_EraseRootFromParent_Done,
     /* 222245 */   // Label 3567: @222245
     /* 222245 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(222302), // Rule ID 4014 //
     /* 222250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222260 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222273 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR),
     /* 222276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222281 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222300 */     GIR_RootConstrainSelectedInstOperands,
     /* 222301 */     // GIR_Coverage, 4014,
     /* 222301 */     GIR_EraseRootFromParent_Done,
     /* 222302 */   // Label 3568: @222302
     /* 222302 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(222363), // Rule ID 4016 //
     /* 222307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222310 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222332 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR_RTN),
     /* 222335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222342 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222361 */     GIR_RootConstrainSelectedInstOperands,
     /* 222362 */     // GIR_Coverage, 4016,
     /* 222362 */     GIR_EraseRootFromParent_Done,
     /* 222363 */   // Label 3569: @222363
     /* 222363 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(222415), // Rule ID 4013 //
     /* 222368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222378 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222391 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC),
     /* 222394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222399 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222413 */     GIR_RootConstrainSelectedInstOperands,
     /* 222414 */     // GIR_Coverage, 4013,
     /* 222414 */     GIR_EraseRootFromParent_Done,
     /* 222415 */   // Label 3570: @222415
     /* 222415 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(222471), // Rule ID 4015 //
     /* 222420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222445 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_RTN),
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222455 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222469 */     GIR_RootConstrainSelectedInstOperands,
     /* 222470 */     // GIR_Coverage, 4015,
     /* 222470 */     GIR_EraseRootFromParent_Done,
     /* 222471 */   // Label 3571: @222471
     /* 222471 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(222524), // Rule ID 3668 //
     /* 222476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222487 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222500 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 222503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222508 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222522 */     GIR_RootConstrainSelectedInstOperands,
     /* 222523 */     // GIR_Coverage, 3668,
     /* 222523 */     GIR_EraseRootFromParent_Done,
     /* 222524 */   // Label 3572: @222524
     /* 222524 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(222576), // Rule ID 3728 //
     /* 222529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222532 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222539 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222552 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 222555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222560 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222574 */     GIR_RootConstrainSelectedInstOperands,
     /* 222575 */     // GIR_Coverage, 3728,
     /* 222575 */     GIR_EraseRootFromParent_Done,
     /* 222576 */   // Label 3573: @222576
     /* 222576 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(222633), // Rule ID 3667 //
     /* 222581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222584 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222607 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 222610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222617 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222631 */     GIR_RootConstrainSelectedInstOperands,
     /* 222632 */     // GIR_Coverage, 3667,
     /* 222632 */     GIR_EraseRootFromParent_Done,
     /* 222633 */   // Label 3574: @222633
     /* 222633 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(222689), // Rule ID 3727 //
     /* 222638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222641 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222663 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 222666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222673 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222687 */     GIR_RootConstrainSelectedInstOperands,
     /* 222688 */     // GIR_Coverage, 3727,
     /* 222688 */     GIR_EraseRootFromParent_Done,
     /* 222689 */   // Label 3575: @222689
     /* 222689 */   GIM_Reject,
     /* 222690 */ // Label 3553: @222690
     /* 222690 */ GIM_Reject,
     /* 222691 */ // Label 3551: @222691
     /* 222691 */ GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(223936),
     /* 222696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 222699 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(222761), // Rule ID 5753 //
     /* 222704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222707 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222714 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222727 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64),
     /* 222730 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222759 */     GIR_RootConstrainSelectedInstOperands,
     /* 222760 */     // GIR_Coverage, 5753,
     /* 222760 */     GIR_EraseRootFromParent_Done,
     /* 222761 */   // Label 3577: @222761
     /* 222761 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(222820), // Rule ID 5757 //
     /* 222766 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222773 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222786 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64),
     /* 222789 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222818 */     GIR_RootConstrainSelectedInstOperands,
     /* 222819 */     // GIR_Coverage, 5757,
     /* 222819 */     GIR_EraseRootFromParent_Done,
     /* 222820 */   // Label 3578: @222820
     /* 222820 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(222886), // Rule ID 5751 //
     /* 222825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222850 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64_RTN),
     /* 222853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222855 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222884 */     GIR_RootConstrainSelectedInstOperands,
     /* 222885 */     // GIR_Coverage, 5751,
     /* 222885 */     GIR_EraseRootFromParent_Done,
     /* 222886 */   // Label 3579: @222886
     /* 222886 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(222949), // Rule ID 5755 //
     /* 222891 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222913 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN),
     /* 222916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222918 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222947 */     GIR_RootConstrainSelectedInstOperands,
     /* 222948 */     // GIR_Coverage, 5755,
     /* 222948 */     GIR_EraseRootFromParent_Done,
     /* 222949 */   // Label 3580: @222949
     /* 222949 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(223006), // Rule ID 5752 //
     /* 222954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222964 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222977 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 222980 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223004 */     GIR_RootConstrainSelectedInstOperands,
     /* 223005 */     // GIR_Coverage, 5752,
     /* 223005 */     GIR_EraseRootFromParent_Done,
     /* 223006 */   // Label 3581: @223006
     /* 223006 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(223060), // Rule ID 5756 //
     /* 223011 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223018 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 223031 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 223034 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 223046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223058 */     GIR_RootConstrainSelectedInstOperands,
     /* 223059 */     // GIR_Coverage, 5756,
     /* 223059 */     GIR_EraseRootFromParent_Done,
     /* 223060 */   // Label 3582: @223060
     /* 223060 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(223121), // Rule ID 5750 //
     /* 223065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 223068 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 223090 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 223095 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 223107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223119 */     GIR_RootConstrainSelectedInstOperands,
     /* 223120 */     // GIR_Coverage, 5750,
     /* 223120 */     GIR_EraseRootFromParent_Done,
     /* 223121 */   // Label 3583: @223121
     /* 223121 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(223179), // Rule ID 5754 //
     /* 223126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 223148 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 223151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 223153 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 223165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223177 */     GIR_RootConstrainSelectedInstOperands,
     /* 223178 */     // GIR_Coverage, 5754,
     /* 223178 */     GIR_EraseRootFromParent_Done,
     /* 223179 */   // Label 3584: @223179
     /* 223179 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(223229), // Rule ID 8248 //
     /* 223184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 223187 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223192 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223205 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 223208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223213 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223227 */     GIR_RootConstrainSelectedInstOperands,
     /* 223228 */     // GIR_Coverage, 8248,
     /* 223228 */     GIR_EraseRootFromParent_Done,
     /* 223229 */   // Label 3585: @223229
     /* 223229 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(223279), // Rule ID 8250 //
     /* 223234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223242 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223255 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i64>>  =>  (DS_INC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64_gfx9),
     /* 223258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223263 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223277 */     GIR_RootConstrainSelectedInstOperands,
     /* 223278 */     // GIR_Coverage, 8250,
     /* 223278 */     GIR_EraseRootFromParent_Done,
     /* 223279 */   // Label 3586: @223279
     /* 223279 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(223329), // Rule ID 8252 //
     /* 223284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223287 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223292 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223305 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 223308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223313 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223327 */     GIR_RootConstrainSelectedInstOperands,
     /* 223328 */     // GIR_Coverage, 8252,
     /* 223328 */     GIR_EraseRootFromParent_Done,
     /* 223329 */   // Label 3587: @223329
     /* 223329 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(223383), // Rule ID 8247 //
     /* 223334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 223337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223357 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 223360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223367 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223381 */     GIR_RootConstrainSelectedInstOperands,
     /* 223382 */     // GIR_Coverage, 8247,
     /* 223382 */     GIR_EraseRootFromParent_Done,
     /* 223383 */   // Label 3588: @223383
     /* 223383 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(223437), // Rule ID 8249 //
     /* 223388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223411 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i64>>  =>  (DS_INC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64_gfx9),
     /* 223414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223421 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223435 */     GIR_RootConstrainSelectedInstOperands,
     /* 223436 */     // GIR_Coverage, 8249,
     /* 223436 */     GIR_EraseRootFromParent_Done,
     /* 223437 */   // Label 3589: @223437
     /* 223437 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(223491), // Rule ID 8251 //
     /* 223442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223465 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 223468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223475 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223489 */     GIR_RootConstrainSelectedInstOperands,
     /* 223490 */     // GIR_Coverage, 8251,
     /* 223490 */     GIR_EraseRootFromParent_Done,
     /* 223491 */   // Label 3590: @223491
     /* 223491 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(223548), // Rule ID 4070 //
     /* 223496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223499 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223506 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223519 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR),
     /* 223522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223527 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223546 */     GIR_RootConstrainSelectedInstOperands,
     /* 223547 */     // GIR_Coverage, 4070,
     /* 223547 */     GIR_EraseRootFromParent_Done,
     /* 223548 */   // Label 3591: @223548
     /* 223548 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(223609), // Rule ID 4072 //
     /* 223553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223556 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223578 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR_RTN),
     /* 223581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223588 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223607 */     GIR_RootConstrainSelectedInstOperands,
     /* 223608 */     // GIR_Coverage, 4072,
     /* 223608 */     GIR_EraseRootFromParent_Done,
     /* 223609 */   // Label 3592: @223609
     /* 223609 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(223661), // Rule ID 4069 //
     /* 223614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223624 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223637 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2),
     /* 223640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223645 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223659 */     GIR_RootConstrainSelectedInstOperands,
     /* 223660 */     // GIR_Coverage, 4069,
     /* 223660 */     GIR_EraseRootFromParent_Done,
     /* 223661 */   // Label 3593: @223661
     /* 223661 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(223717), // Rule ID 4071 //
     /* 223666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223669 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223691 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_RTN),
     /* 223694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223701 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223715 */     GIR_RootConstrainSelectedInstOperands,
     /* 223716 */     // GIR_Coverage, 4071,
     /* 223716 */     GIR_EraseRootFromParent_Done,
     /* 223717 */   // Label 3594: @223717
     /* 223717 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(223770), // Rule ID 3694 //
     /* 223722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223733 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223746 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 223749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223754 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223768 */     GIR_RootConstrainSelectedInstOperands,
     /* 223769 */     // GIR_Coverage, 3694,
     /* 223769 */     GIR_EraseRootFromParent_Done,
     /* 223770 */   // Label 3595: @223770
     /* 223770 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(223822), // Rule ID 3754 //
     /* 223775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223778 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223785 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223798 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 223801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223806 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223820 */     GIR_RootConstrainSelectedInstOperands,
     /* 223821 */     // GIR_Coverage, 3754,
     /* 223821 */     GIR_EraseRootFromParent_Done,
     /* 223822 */   // Label 3596: @223822
     /* 223822 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(223879), // Rule ID 3693 //
     /* 223827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223853 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 223856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223863 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223877 */     GIR_RootConstrainSelectedInstOperands,
     /* 223878 */     // GIR_Coverage, 3693,
     /* 223878 */     GIR_EraseRootFromParent_Done,
     /* 223879 */   // Label 3597: @223879
     /* 223879 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(223935), // Rule ID 3753 //
     /* 223884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223909 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 223912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223919 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223933 */     GIR_RootConstrainSelectedInstOperands,
     /* 223934 */     // GIR_Coverage, 3753,
     /* 223934 */     GIR_EraseRootFromParent_Done,
     /* 223935 */   // Label 3598: @223935
     /* 223935 */   GIM_Reject,
     /* 223936 */ // Label 3576: @223936
     /* 223936 */ GIM_Reject,
     /* 223937 */ // Label 3552: @223937
     /* 223937 */ GIM_Reject,
     /* 223938 */ // Label 33: @223938
     /* 223938 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3601*/ GIMT_Encode4(226449),
     /* 223949 */ /*GILLT_s32*//*Label 3599*/ GIMT_Encode4(223957),
     /* 223953 */ /*GILLT_s64*//*Label 3600*/ GIMT_Encode4(225203),
     /* 223957 */ // Label 3599: @223957
     /* 223957 */ GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(225202),
     /* 223962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223965 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(224027), // Rule ID 5665 //
     /* 223970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 223973 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223980 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223993 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64),
     /* 223996 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224025 */     GIR_RootConstrainSelectedInstOperands,
     /* 224026 */     // GIR_Coverage, 5665,
     /* 224026 */     GIR_EraseRootFromParent_Done,
     /* 224027 */   // Label 3603: @224027
     /* 224027 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(224086), // Rule ID 5669 //
     /* 224032 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224039 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224052 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64 anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64),
     /* 224055 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224084 */     GIR_RootConstrainSelectedInstOperands,
     /* 224085 */     // GIR_Coverage, 5669,
     /* 224085 */     GIR_EraseRootFromParent_Done,
     /* 224086 */   // Label 3604: @224086
     /* 224086 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(224152), // Rule ID 5663 //
     /* 224091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 224094 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224116 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64_RTN),
     /* 224119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224121 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224150 */     GIR_RootConstrainSelectedInstOperands,
     /* 224151 */     // GIR_Coverage, 5663,
     /* 224151 */     GIR_EraseRootFromParent_Done,
     /* 224152 */   // Label 3605: @224152
     /* 224152 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(224215), // Rule ID 5667 //
     /* 224157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224179 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN),
     /* 224182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224184 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224213 */     GIR_RootConstrainSelectedInstOperands,
     /* 224214 */     // GIR_Coverage, 5667,
     /* 224214 */     GIR_EraseRootFromParent_Done,
     /* 224215 */   // Label 3606: @224215
     /* 224215 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(224272), // Rule ID 5664 //
     /* 224220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 224223 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224230 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224243 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 224246 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224270 */     GIR_RootConstrainSelectedInstOperands,
     /* 224271 */     // GIR_Coverage, 5664,
     /* 224271 */     GIR_EraseRootFromParent_Done,
     /* 224272 */   // Label 3607: @224272
     /* 224272 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(224326), // Rule ID 5668 //
     /* 224277 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224284 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224297 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 224300 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224324 */     GIR_RootConstrainSelectedInstOperands,
     /* 224325 */     // GIR_Coverage, 5668,
     /* 224325 */     GIR_EraseRootFromParent_Done,
     /* 224326 */   // Label 3608: @224326
     /* 224326 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(224387), // Rule ID 5662 //
     /* 224331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 224334 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224356 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 224359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224361 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224385 */     GIR_RootConstrainSelectedInstOperands,
     /* 224386 */     // GIR_Coverage, 5662,
     /* 224386 */     GIR_EraseRootFromParent_Done,
     /* 224387 */   // Label 3609: @224387
     /* 224387 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(224445), // Rule ID 5666 //
     /* 224392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224414 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 224417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224419 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224443 */     GIR_RootConstrainSelectedInstOperands,
     /* 224444 */     // GIR_Coverage, 5666,
     /* 224444 */     GIR_EraseRootFromParent_Done,
     /* 224445 */   // Label 3610: @224445
     /* 224445 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(224495), // Rule ID 8161 //
     /* 224450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224453 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224458 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224471 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 224474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224479 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224493 */     GIR_RootConstrainSelectedInstOperands,
     /* 224494 */     // GIR_Coverage, 8161,
     /* 224494 */     GIR_EraseRootFromParent_Done,
     /* 224495 */   // Label 3611: @224495
     /* 224495 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(224545), // Rule ID 8163 //
     /* 224500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224508 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224521 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i32>>  =>  (DS_DEC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32_gfx9),
     /* 224524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224529 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224543 */     GIR_RootConstrainSelectedInstOperands,
     /* 224544 */     // GIR_Coverage, 8163,
     /* 224544 */     GIR_EraseRootFromParent_Done,
     /* 224545 */   // Label 3612: @224545
     /* 224545 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(224595), // Rule ID 8165 //
     /* 224550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224553 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224558 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224571 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 224574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224579 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224593 */     GIR_RootConstrainSelectedInstOperands,
     /* 224594 */     // GIR_Coverage, 8165,
     /* 224594 */     GIR_EraseRootFromParent_Done,
     /* 224595 */   // Label 3613: @224595
     /* 224595 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(224649), // Rule ID 8160 //
     /* 224600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224603 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224623 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 224626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224633 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224647 */     GIR_RootConstrainSelectedInstOperands,
     /* 224648 */     // GIR_Coverage, 8160,
     /* 224648 */     GIR_EraseRootFromParent_Done,
     /* 224649 */   // Label 3614: @224649
     /* 224649 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(224703), // Rule ID 8162 //
     /* 224654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224657 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224677 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i32>>  =>  (DS_DEC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32_gfx9),
     /* 224680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224687 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224701 */     GIR_RootConstrainSelectedInstOperands,
     /* 224702 */     // GIR_Coverage, 8162,
     /* 224702 */     GIR_EraseRootFromParent_Done,
     /* 224703 */   // Label 3615: @224703
     /* 224703 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(224757), // Rule ID 8164 //
     /* 224708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224731 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 224734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224741 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224755 */     GIR_RootConstrainSelectedInstOperands,
     /* 224756 */     // GIR_Coverage, 8164,
     /* 224756 */     GIR_EraseRootFromParent_Done,
     /* 224757 */   // Label 3616: @224757
     /* 224757 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(224814), // Rule ID 4018 //
     /* 224762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224772 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224785 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR),
     /* 224788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224793 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224812 */     GIR_RootConstrainSelectedInstOperands,
     /* 224813 */     // GIR_Coverage, 4018,
     /* 224813 */     GIR_EraseRootFromParent_Done,
     /* 224814 */   // Label 3617: @224814
     /* 224814 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(224875), // Rule ID 4020 //
     /* 224819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224844 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR_RTN),
     /* 224847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224854 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224873 */     GIR_RootConstrainSelectedInstOperands,
     /* 224874 */     // GIR_Coverage, 4020,
     /* 224874 */     GIR_EraseRootFromParent_Done,
     /* 224875 */   // Label 3618: @224875
     /* 224875 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(224927), // Rule ID 4017 //
     /* 224880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224883 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224890 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224903 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC),
     /* 224906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224911 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224925 */     GIR_RootConstrainSelectedInstOperands,
     /* 224926 */     // GIR_Coverage, 4017,
     /* 224926 */     GIR_EraseRootFromParent_Done,
     /* 224927 */   // Label 3619: @224927
     /* 224927 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(224983), // Rule ID 4019 //
     /* 224932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224957 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_RTN),
     /* 224960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224967 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224981 */     GIR_RootConstrainSelectedInstOperands,
     /* 224982 */     // GIR_Coverage, 4019,
     /* 224982 */     GIR_EraseRootFromParent_Done,
     /* 224983 */   // Label 3620: @224983
     /* 224983 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(225036), // Rule ID 3670 //
     /* 224988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 224991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224999 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225012 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 225012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 225015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225020 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225034 */     GIR_RootConstrainSelectedInstOperands,
     /* 225035 */     // GIR_Coverage, 3670,
     /* 225035 */     GIR_EraseRootFromParent_Done,
     /* 225036 */   // Label 3621: @225036
     /* 225036 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(225088), // Rule ID 3730 //
     /* 225041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 225044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225051 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225064 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 225064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 225067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225086 */     GIR_RootConstrainSelectedInstOperands,
     /* 225087 */     // GIR_Coverage, 3730,
     /* 225087 */     GIR_EraseRootFromParent_Done,
     /* 225088 */   // Label 3622: @225088
     /* 225088 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(225145), // Rule ID 3669 //
     /* 225093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 225096 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225119 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 225119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 225122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225129 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225143 */     GIR_RootConstrainSelectedInstOperands,
     /* 225144 */     // GIR_Coverage, 3669,
     /* 225144 */     GIR_EraseRootFromParent_Done,
     /* 225145 */   // Label 3623: @225145
     /* 225145 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(225201), // Rule ID 3729 //
     /* 225150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 225153 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225175 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 225175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 225178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225185 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225199 */     GIR_RootConstrainSelectedInstOperands,
     /* 225200 */     // GIR_Coverage, 3729,
     /* 225200 */     GIR_EraseRootFromParent_Done,
     /* 225201 */   // Label 3624: @225201
     /* 225201 */   GIM_Reject,
     /* 225202 */ // Label 3602: @225202
     /* 225202 */ GIM_Reject,
     /* 225203 */ // Label 3600: @225203
     /* 225203 */ GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(226448),
     /* 225208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 225211 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(225273), // Rule ID 5761 //
     /* 225216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225219 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225226 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225239 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64),
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225271 */     GIR_RootConstrainSelectedInstOperands,
     /* 225272 */     // GIR_Coverage, 5761,
     /* 225272 */     GIR_EraseRootFromParent_Done,
     /* 225273 */   // Label 3626: @225273
     /* 225273 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(225332), // Rule ID 5765 //
     /* 225278 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225285 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225298 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64 anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64),
     /* 225301 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225330 */     GIR_RootConstrainSelectedInstOperands,
     /* 225331 */     // GIR_Coverage, 5765,
     /* 225331 */     GIR_EraseRootFromParent_Done,
     /* 225332 */   // Label 3627: @225332
     /* 225332 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(225398), // Rule ID 5759 //
     /* 225337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225340 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225362 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64_RTN),
     /* 225365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225367 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225396 */     GIR_RootConstrainSelectedInstOperands,
     /* 225397 */     // GIR_Coverage, 5759,
     /* 225397 */     GIR_EraseRootFromParent_Done,
     /* 225398 */   // Label 3628: @225398
     /* 225398 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(225461), // Rule ID 5763 //
     /* 225403 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225425 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN),
     /* 225428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225430 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225459 */     GIR_RootConstrainSelectedInstOperands,
     /* 225460 */     // GIR_Coverage, 5763,
     /* 225460 */     GIR_EraseRootFromParent_Done,
     /* 225461 */   // Label 3629: @225461
     /* 225461 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(225518), // Rule ID 5760 //
     /* 225466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225476 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225489 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225516 */     GIR_RootConstrainSelectedInstOperands,
     /* 225517 */     // GIR_Coverage, 5760,
     /* 225517 */     GIR_EraseRootFromParent_Done,
     /* 225518 */   // Label 3630: @225518
     /* 225518 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(225572), // Rule ID 5764 //
     /* 225523 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225530 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225543 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 225546 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225570 */     GIR_RootConstrainSelectedInstOperands,
     /* 225571 */     // GIR_Coverage, 5764,
     /* 225571 */     GIR_EraseRootFromParent_Done,
     /* 225572 */   // Label 3631: @225572
     /* 225572 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(225633), // Rule ID 5758 //
     /* 225577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225602 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 225605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225607 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225631 */     GIR_RootConstrainSelectedInstOperands,
     /* 225632 */     // GIR_Coverage, 5758,
     /* 225632 */     GIR_EraseRootFromParent_Done,
     /* 225633 */   // Label 3632: @225633
     /* 225633 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(225691), // Rule ID 5762 //
     /* 225638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225660 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 225663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225665 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225689 */     GIR_RootConstrainSelectedInstOperands,
     /* 225690 */     // GIR_Coverage, 5762,
     /* 225690 */     GIR_EraseRootFromParent_Done,
     /* 225691 */   // Label 3633: @225691
     /* 225691 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(225741), // Rule ID 8254 //
     /* 225696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225699 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225704 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225717 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 225720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225725 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225739 */     GIR_RootConstrainSelectedInstOperands,
     /* 225740 */     // GIR_Coverage, 8254,
     /* 225740 */     GIR_EraseRootFromParent_Done,
     /* 225741 */   // Label 3634: @225741
     /* 225741 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(225791), // Rule ID 8256 //
     /* 225746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225767 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i64>>  =>  (DS_DEC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64_gfx9),
     /* 225770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225775 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225789 */     GIR_RootConstrainSelectedInstOperands,
     /* 225790 */     // GIR_Coverage, 8256,
     /* 225790 */     GIR_EraseRootFromParent_Done,
     /* 225791 */   // Label 3635: @225791
     /* 225791 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(225841), // Rule ID 8258 //
     /* 225796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225799 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225804 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225817 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 225820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225839 */     GIR_RootConstrainSelectedInstOperands,
     /* 225840 */     // GIR_Coverage, 8258,
     /* 225840 */     GIR_EraseRootFromParent_Done,
     /* 225841 */   // Label 3636: @225841
     /* 225841 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(225895), // Rule ID 8253 //
     /* 225846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225849 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225869 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225879 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225893 */     GIR_RootConstrainSelectedInstOperands,
     /* 225894 */     // GIR_Coverage, 8253,
     /* 225894 */     GIR_EraseRootFromParent_Done,
     /* 225895 */   // Label 3637: @225895
     /* 225895 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(225949), // Rule ID 8255 //
     /* 225900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225903 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225923 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i64>>  =>  (DS_DEC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64_gfx9),
     /* 225926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225933 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225947 */     GIR_RootConstrainSelectedInstOperands,
     /* 225948 */     // GIR_Coverage, 8255,
     /* 225948 */     GIR_EraseRootFromParent_Done,
     /* 225949 */   // Label 3638: @225949
     /* 225949 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(226003), // Rule ID 8257 //
     /* 225954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225977 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9786:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 225980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225987 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226001 */     GIR_RootConstrainSelectedInstOperands,
     /* 226002 */     // GIR_Coverage, 8257,
     /* 226002 */     GIR_EraseRootFromParent_Done,
     /* 226003 */   // Label 3639: @226003
     /* 226003 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(226060), // Rule ID 4074 //
     /* 226008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226011 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226018 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 226031 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 226031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR),
     /* 226034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 226046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226058 */     GIR_RootConstrainSelectedInstOperands,
     /* 226059 */     // GIR_Coverage, 4074,
     /* 226059 */     GIR_EraseRootFromParent_Done,
     /* 226060 */   // Label 3640: @226060
     /* 226060 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(226121), // Rule ID 4076 //
     /* 226065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226068 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 226090 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 226090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR_RTN),
     /* 226093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 226100 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 226107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226119 */     GIR_RootConstrainSelectedInstOperands,
     /* 226120 */     // GIR_Coverage, 4076,
     /* 226120 */     GIR_EraseRootFromParent_Done,
     /* 226121 */   // Label 3641: @226121
     /* 226121 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(226173), // Rule ID 4073 //
     /* 226126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226136 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 226149 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2),
     /* 226152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226157 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226171 */     GIR_RootConstrainSelectedInstOperands,
     /* 226172 */     // GIR_Coverage, 4073,
     /* 226172 */     GIR_EraseRootFromParent_Done,
     /* 226173 */   // Label 3642: @226173
     /* 226173 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(226229), // Rule ID 4075 //
     /* 226178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 226203 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_RTN),
     /* 226206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226213 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226227 */     GIR_RootConstrainSelectedInstOperands,
     /* 226228 */     // GIR_Coverage, 4075,
     /* 226228 */     GIR_EraseRootFromParent_Done,
     /* 226229 */   // Label 3643: @226229
     /* 226229 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(226282), // Rule ID 3696 //
     /* 226234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226245 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226258 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 226261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226266 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226280 */     GIR_RootConstrainSelectedInstOperands,
     /* 226281 */     // GIR_Coverage, 3696,
     /* 226281 */     GIR_EraseRootFromParent_Done,
     /* 226282 */   // Label 3644: @226282
     /* 226282 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(226334), // Rule ID 3756 //
     /* 226287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226290 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226297 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226310 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 226313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226318 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226332 */     GIR_RootConstrainSelectedInstOperands,
     /* 226333 */     // GIR_Coverage, 3756,
     /* 226333 */     GIR_EraseRootFromParent_Done,
     /* 226334 */   // Label 3645: @226334
     /* 226334 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(226391), // Rule ID 3695 //
     /* 226339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226365 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 226368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226375 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226389 */     GIR_RootConstrainSelectedInstOperands,
     /* 226390 */     // GIR_Coverage, 3695,
     /* 226390 */     GIR_EraseRootFromParent_Done,
     /* 226391 */   // Label 3646: @226391
     /* 226391 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(226447), // Rule ID 3755 //
     /* 226396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226399 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226421 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 226424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226431 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226445 */     GIR_RootConstrainSelectedInstOperands,
     /* 226446 */     // GIR_Coverage, 3755,
     /* 226446 */     GIR_EraseRootFromParent_Done,
     /* 226447 */   // Label 3647: @226447
     /* 226447 */   GIM_Reject,
     /* 226448 */ // Label 3625: @226448
     /* 226448 */ GIM_Reject,
     /* 226449 */ // Label 3601: @226449
     /* 226449 */ GIM_Reject,
     /* 226450 */ // Label 34: @226450
     /* 226450 */ GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(226468), // Rule ID 1333 //
     /* 226455 */   // MIs[0] ordering
     /* 226455 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 226458 */   // MIs[0] scope
     /* 226458 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226461 */   // (atomic_fence (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)  =>  (ATOMIC_FENCE (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)
     /* 226461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::ATOMIC_FENCE),
     /* 226466 */   GIR_RootConstrainSelectedInstOperands,
     /* 226467 */   // GIR_Coverage, 1333,
     /* 226467 */   GIR_Done,
     /* 226468 */ // Label 3648: @226468
     /* 226468 */ GIM_Reject,
     /* 226469 */ // Label 35: @226469
     /* 226469 */ GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(226904),
     /* 226474 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_prefetch),
     /* 226478 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(226587),
     /* 226483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /* 226487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226496 */     GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(226541), // Rule ID 3529 //
     /* 226501 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226506 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 226513 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226513 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226516 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 226521 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226526 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226532 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226535 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226539 */       GIR_RootConstrainSelectedInstOperands,
     /* 226540 */       // GIR_Coverage, 3529,
     /* 226540 */       GIR_EraseRootFromParent_Done,
     /* 226541 */     // Label 3651: @226541
     /* 226541 */     GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(226586), // Rule ID 3532 //
     /* 226546 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226551 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 226558 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226558 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226561 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 226566 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226571 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226577 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226580 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226584 */       GIR_RootConstrainSelectedInstOperands,
     /* 226585 */       // GIR_Coverage, 3532,
     /* 226585 */       GIR_EraseRootFromParent_Done,
     /* 226586 */     // Label 3652: @226586
     /* 226586 */     GIM_Reject,
     /* 226587 */   // Label 3650: @226587
     /* 226587 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(226637), // Rule ID 3530 //
     /* 226592 */     // MIs[0] sbase
     /* 226592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 226596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226600 */     // MIs[0] Operand 1
     /* 226600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226603 */     // MIs[0] Operand 2
     /* 226603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226606 */     // MIs[0] Operand 3
     /* 226606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226614 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226617 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 226619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226635 */     GIR_RootConstrainSelectedInstOperands,
     /* 226636 */     // GIR_Coverage, 3530,
     /* 226636 */     GIR_EraseRootFromParent_Done,
     /* 226637 */   // Label 3653: @226637
     /* 226637 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(226745), // Rule ID 3531 //
     /* 226642 */     // MIs[0] sbase
     /* 226642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 226646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226650 */     // MIs[0] Operand 1
     /* 226650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226653 */     // MIs[0] Operand 2
     /* 226653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226656 */     // MIs[0] Operand 3
     /* 226656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226664 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 226667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 226671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 226679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 226681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 226684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 226688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 226697 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 226700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 226703 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 226706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 226716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 226721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226743 */     GIR_RootConstrainSelectedInstOperands,
     /* 226744 */     // GIR_Coverage, 3531,
     /* 226744 */     GIR_EraseRootFromParent_Done,
     /* 226745 */   // Label 3654: @226745
     /* 226745 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(226795), // Rule ID 3533 //
     /* 226750 */     // MIs[0] sbase
     /* 226750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 226754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226758 */     // MIs[0] Operand 1
     /* 226758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226761 */     // MIs[0] Operand 2
     /* 226761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226764 */     // MIs[0] Operand 3
     /* 226764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226772 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226775 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 226777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226793 */     GIR_RootConstrainSelectedInstOperands,
     /* 226794 */     // GIR_Coverage, 3533,
     /* 226794 */     GIR_EraseRootFromParent_Done,
     /* 226795 */   // Label 3655: @226795
     /* 226795 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(226903), // Rule ID 3534 //
     /* 226800 */     // MIs[0] sbase
     /* 226800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 226804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226808 */     // MIs[0] Operand 1
     /* 226808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226811 */     // MIs[0] Operand 2
     /* 226811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226814 */     // MIs[0] Operand 3
     /* 226814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226822 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 226825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 226829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226834 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 226837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 226839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 226842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 226846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 226855 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 226858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 226861 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 226864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 226874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 226879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226901 */     GIR_RootConstrainSelectedInstOperands,
     /* 226902 */     // GIR_Coverage, 3534,
     /* 226902 */     GIR_EraseRootFromParent_Done,
     /* 226903 */   // Label 3656: @226903
     /* 226903 */   GIM_Reject,
     /* 226904 */ // Label 3649: @226904
     /* 226904 */ GIM_Reject,
     /* 226905 */ // Label 36: @226905
     /* 226905 */ GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(226986),
     /* 226910 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 226913 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(226937), // Rule ID 20 //
     /* 226918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getpc),
     /* 226923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 226926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226930 */     // (intrinsic_wo_chain:{ *:[i64] } 3163:{ *:[iPTR] })  =>  (S_GETPC_B64_pseudo:{ *:[i64] })
     /* 226930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETPC_B64_pseudo),
     /* 226933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 226935 */     GIR_RootConstrainSelectedInstOperands,
     /* 226936 */     // GIR_Coverage, 20,
     /* 226936 */     GIR_EraseRootFromParent_Done,
     /* 226937 */   // Label 3658: @226937
     /* 226937 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(226961), // Rule ID 1343 //
     /* 226942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_groupstaticsize),
     /* 226947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 226950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226954 */     // (intrinsic_wo_chain:{ *:[i32] } 2222:{ *:[iPTR] })  =>  (GET_GROUPSTATICSIZE:{ *:[i32] })
     /* 226954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GET_GROUPSTATICSIZE),
     /* 226957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 226959 */     GIR_RootConstrainSelectedInstOperands,
     /* 226960 */     // GIR_Coverage, 1343,
     /* 226960 */     GIR_EraseRootFromParent_Done,
     /* 226961 */   // Label 3659: @226961
     /* 226961 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(226985), // Rule ID 1350 //
     /* 226966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ps_live),
     /* 226971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 226974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 226978 */     // (intrinsic_wo_chain:{ *:[i1] } 3086:{ *:[iPTR] })  =>  (SI_PS_LIVE:{ *:[i1] })
     /* 226978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_PS_LIVE),
     /* 226981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226983 */     GIR_RootConstrainSelectedInstOperands,
     /* 226984 */     // GIR_Coverage, 1350,
     /* 226984 */     GIR_EraseRootFromParent_Done,
     /* 226985 */   // Label 3660: @226985
     /* 226985 */   GIM_Reject,
     /* 226986 */ // Label 3657: @226986
     /* 226986 */ GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(230793),
     /* 226991 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 226994 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(227076), // Rule ID 2689 //
     /* 226999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 227007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21505),
     /* 227021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227028 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21505>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 227035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227075 */     // GIR_Coverage, 2689,
     /* 227075 */     GIR_EraseRootFromParent_Done,
     /* 227076 */   // Label 3662: @227076
     /* 227076 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(227158), // Rule ID 2691 //
     /* 227081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 227089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21507),
     /* 227103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227110 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21507>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 227117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227157 */     // GIR_Coverage, 2691,
     /* 227157 */     GIR_EraseRootFromParent_Done,
     /* 227158 */   // Label 3663: @227158
     /* 227158 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(227240), // Rule ID 2693 //
     /* 227163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 227171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21499),
     /* 227185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227192 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21499>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RCP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F16_e64),
     /* 227199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227239 */     // GIR_Coverage, 2693,
     /* 227239 */     GIR_EraseRootFromParent_Done,
     /* 227240 */   // Label 3664: @227240
     /* 227240 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(227322), // Rule ID 2695 //
     /* 227245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21501),
     /* 227267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227274 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21501>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RSQ_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F16_e64),
     /* 227281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227321 */     // GIR_Coverage, 2695,
     /* 227321 */     GIR_EraseRootFromParent_Done,
     /* 227322 */   // Label 3665: @227322
     /* 227322 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(227404), // Rule ID 2698 //
     /* 227327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 227335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21503),
     /* 227349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227356 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21503>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 227363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227403 */     // GIR_Coverage, 2698,
     /* 227403 */     GIR_EraseRootFromParent_Done,
     /* 227404 */   // Label 3666: @227404
     /* 227404 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(227437), // Rule ID 16 //
     /* 227409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 227414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 227424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13729),
     /* 227428 */     // (intrinsic_wo_chain:{ *:[i32] } 3202:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13729>>  =>  (S_FLBIT_I32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 227428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32),
     /* 227431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 227435 */     GIR_RootConstrainSelectedInstOperands,
     /* 227436 */     // GIR_Coverage, 16,
     /* 227436 */     GIR_EraseRootFromParent_Done,
     /* 227437 */   // Label 3667: @227437
     /* 227437 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(227469), // Rule ID 1334 //
     /* 227442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 227445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 227450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 227453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 227460 */     // (intrinsic_wo_chain:{ *:[i1] } 3004:{ *:[iPTR] }, i32:{ *:[i32] }:$mask)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } i32:{ *:[i32] }:$mask)
     /* 227460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
     /* 227463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227465 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 227467 */     GIR_RootConstrainSelectedInstOperands,
     /* 227468 */     // GIR_Coverage, 1334,
     /* 227468 */     GIR_EraseRootFromParent_Done,
     /* 227469 */   // Label 3668: @227469
     /* 227469 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(227501), // Rule ID 1335 //
     /* 227474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 227477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 227482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 227485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 227492 */     // (intrinsic_wo_chain:{ *:[i1] } 3004:{ *:[iPTR] }, i64:{ *:[i64] }:$mask)  =>  (S_INVERSE_BALLOT_U64:{ *:[i1] } i64:{ *:[i64] }:$mask)
     /* 227492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U64),
     /* 227495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227497 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 227499 */     GIR_RootConstrainSelectedInstOperands,
     /* 227500 */     // GIR_Coverage, 1335,
     /* 227500 */     GIR_EraseRootFromParent_Done,
     /* 227501 */   // Label 3669: @227501
     /* 227501 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(227562), // Rule ID 6934 //
     /* 227506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 227509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 227514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 227517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 227524 */     // (intrinsic_wo_chain:{ *:[i1] } 3004:{ *:[iPTR] }, i64:{ *:[i64] }:$src)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[i64] }:$src, sub0:{ *:[i32] }))
     /* 227524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 227542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 227547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 227552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
     /* 227555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227560 */     GIR_RootConstrainSelectedInstOperands,
     /* 227561 */     // GIR_Coverage, 6934,
     /* 227561 */     GIR_EraseRootFromParent_Done,
     /* 227562 */   // Label 3670: @227562
     /* 227562 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(227623), // Rule ID 1075 //
     /* 227567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 227575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21494),
     /* 227589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227596 */     // (intrinsic_wo_chain:{ *:[f32] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21494>>  =>  (V_S_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F32_e64),
     /* 227599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227621 */     GIR_RootConstrainSelectedInstOperands,
     /* 227622 */     // GIR_Coverage, 1075,
     /* 227622 */     GIR_EraseRootFromParent_Done,
     /* 227623 */   // Label 3671: @227623
     /* 227623 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(227684), // Rule ID 1077 //
     /* 227628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 227636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21497),
     /* 227650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227657 */     // (intrinsic_wo_chain:{ *:[f32] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21497>>  =>  (V_S_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F32_e64),
     /* 227660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227682 */     GIR_RootConstrainSelectedInstOperands,
     /* 227683 */     // GIR_Coverage, 1077,
     /* 227683 */     GIR_EraseRootFromParent_Done,
     /* 227684 */   // Label 3672: @227684
     /* 227684 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(227745), // Rule ID 1079 //
     /* 227689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 227697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21499),
     /* 227711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227718 */     // (intrinsic_wo_chain:{ *:[f32] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21499>>  =>  (V_S_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F32_e64),
     /* 227721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227743 */     GIR_RootConstrainSelectedInstOperands,
     /* 227744 */     // GIR_Coverage, 1079,
     /* 227744 */     GIR_EraseRootFromParent_Done,
     /* 227745 */   // Label 3673: @227745
     /* 227745 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(227806), // Rule ID 1081 //
     /* 227750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21501),
     /* 227772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227779 */     // (intrinsic_wo_chain:{ *:[f32] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21501>>  =>  (V_S_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F32_e64),
     /* 227782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227804 */     GIR_RootConstrainSelectedInstOperands,
     /* 227805 */     // GIR_Coverage, 1081,
     /* 227805 */     GIR_EraseRootFromParent_Done,
     /* 227806 */   // Label 3674: @227806
     /* 227806 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(227867), // Rule ID 1084 //
     /* 227811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 227819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21503),
     /* 227833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227840 */     // (intrinsic_wo_chain:{ *:[f32] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21503>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 227843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227865 */     GIR_RootConstrainSelectedInstOperands,
     /* 227866 */     // GIR_Coverage, 1084,
     /* 227866 */     GIR_EraseRootFromParent_Done,
     /* 227867 */   // Label 3675: @227867
     /* 227867 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(227921), // Rule ID 655 //
     /* 227872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 227877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227894 */     // (intrinsic_wo_chain:{ *:[f32] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F32_e64),
     /* 227897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227919 */     GIR_RootConstrainSelectedInstOperands,
     /* 227920 */     // GIR_Coverage, 655,
     /* 227920 */     GIR_EraseRootFromParent_Done,
     /* 227921 */   // Label 3676: @227921
     /* 227921 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(227975), // Rule ID 661 //
     /* 227926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 227931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227948 */     // (intrinsic_wo_chain:{ *:[f32] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 227951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227973 */     GIR_RootConstrainSelectedInstOperands,
     /* 227974 */     // GIR_Coverage, 661,
     /* 227974 */     GIR_EraseRootFromParent_Done,
     /* 227975 */   // Label 3677: @227975
     /* 227975 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(228029), // Rule ID 663 //
     /* 227980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 227985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228002 */     // (intrinsic_wo_chain:{ *:[f32] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 228005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228027 */     GIR_RootConstrainSelectedInstOperands,
     /* 228028 */     // GIR_Coverage, 663,
     /* 228028 */     GIR_EraseRootFromParent_Done,
     /* 228029 */   // Label 3678: @228029
     /* 228029 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(228083), // Rule ID 665 //
     /* 228034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 228039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228056 */     // (intrinsic_wo_chain:{ *:[f32] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F32_e64),
     /* 228059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228081 */     GIR_RootConstrainSelectedInstOperands,
     /* 228082 */     // GIR_Coverage, 665,
     /* 228082 */     GIR_EraseRootFromParent_Done,
     /* 228083 */   // Label 3679: @228083
     /* 228083 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(228137), // Rule ID 668 //
     /* 228088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 228093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228110 */     // (intrinsic_wo_chain:{ *:[f32] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F32_e64),
     /* 228113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228135 */     GIR_RootConstrainSelectedInstOperands,
     /* 228136 */     // GIR_Coverage, 668,
     /* 228136 */     GIR_EraseRootFromParent_Done,
     /* 228137 */   // Label 3680: @228137
     /* 228137 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(228191), // Rule ID 670 //
     /* 228142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 228147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228164 */     // (intrinsic_wo_chain:{ *:[f32] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F32_e64),
     /* 228167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228189 */     GIR_RootConstrainSelectedInstOperands,
     /* 228190 */     // GIR_Coverage, 670,
     /* 228190 */     GIR_EraseRootFromParent_Done,
     /* 228191 */   // Label 3681: @228191
     /* 228191 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(228245), // Rule ID 671 //
     /* 228196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 228201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228218 */     // (intrinsic_wo_chain:{ *:[f64] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F64_e64),
     /* 228221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228243 */     GIR_RootConstrainSelectedInstOperands,
     /* 228244 */     // GIR_Coverage, 671,
     /* 228244 */     GIR_EraseRootFromParent_Done,
     /* 228245 */   // Label 3682: @228245
     /* 228245 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(228299), // Rule ID 673 //
     /* 228250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 228255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228272 */     // (intrinsic_wo_chain:{ *:[f64] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F64_e64),
     /* 228275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228297 */     GIR_RootConstrainSelectedInstOperands,
     /* 228298 */     // GIR_Coverage, 673,
     /* 228298 */     GIR_EraseRootFromParent_Done,
     /* 228299 */   // Label 3683: @228299
     /* 228299 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(228353), // Rule ID 675 //
     /* 228304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 228309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228326 */     // (intrinsic_wo_chain:{ *:[f64] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F64_e64),
     /* 228329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228351 */     GIR_RootConstrainSelectedInstOperands,
     /* 228352 */     // GIR_Coverage, 675,
     /* 228352 */     GIR_EraseRootFromParent_Done,
     /* 228353 */   // Label 3684: @228353
     /* 228353 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(228407), // Rule ID 676 //
     /* 228358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 228363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228380 */     // (intrinsic_wo_chain:{ *:[f32] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F32_e64),
     /* 228383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228405 */     GIR_RootConstrainSelectedInstOperands,
     /* 228406 */     // GIR_Coverage, 676,
     /* 228406 */     GIR_EraseRootFromParent_Done,
     /* 228407 */   // Label 3685: @228407
     /* 228407 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(228461), // Rule ID 678 //
     /* 228412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 228417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228434 */     // (intrinsic_wo_chain:{ *:[f32] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F32_e64),
     /* 228437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228459 */     GIR_RootConstrainSelectedInstOperands,
     /* 228460 */     // GIR_Coverage, 678,
     /* 228460 */     GIR_EraseRootFromParent_Done,
     /* 228461 */   // Label 3686: @228461
     /* 228461 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(228500), // Rule ID 685 //
     /* 228466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 228471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228488 */     // (intrinsic_wo_chain:{ *:[i32] } 3202:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 228488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_I32_e64),
     /* 228491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228498 */     GIR_RootConstrainSelectedInstOperands,
     /* 228499 */     // GIR_Coverage, 685,
     /* 228499 */     GIR_EraseRootFromParent_Done,
     /* 228500 */   // Label 3687: @228500
     /* 228500 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(228554), // Rule ID 687 //
     /* 228505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 228510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228527 */     // (intrinsic_wo_chain:{ *:[i32] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F64_e64),
     /* 228530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228552 */     GIR_RootConstrainSelectedInstOperands,
     /* 228553 */     // GIR_Coverage, 687,
     /* 228553 */     GIR_EraseRootFromParent_Done,
     /* 228554 */   // Label 3688: @228554
     /* 228554 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(228608), // Rule ID 688 //
     /* 228559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 228564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228581 */     // (intrinsic_wo_chain:{ *:[f64] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F64_e64),
     /* 228584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228606 */     GIR_RootConstrainSelectedInstOperands,
     /* 228607 */     // GIR_Coverage, 688,
     /* 228607 */     GIR_EraseRootFromParent_Done,
     /* 228608 */   // Label 3689: @228608
     /* 228608 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(228662), // Rule ID 689 //
     /* 228613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 228618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228635 */     // (intrinsic_wo_chain:{ *:[f64] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 228638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228660 */     GIR_RootConstrainSelectedInstOperands,
     /* 228661 */     // GIR_Coverage, 689,
     /* 228661 */     GIR_EraseRootFromParent_Done,
     /* 228662 */   // Label 3690: @228662
     /* 228662 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(228711), // Rule ID 691 //
     /* 228667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 228672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228689 */     // (intrinsic_wo_chain:{ *:[i32] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp))  =>  (V_FREXP_EXP_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp)
     /* 228689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F32_e64),
     /* 228692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228709 */     GIR_RootConstrainSelectedInstOperands,
     /* 228710 */     // GIR_Coverage, 691,
     /* 228710 */     GIR_EraseRootFromParent_Done,
     /* 228711 */   // Label 3691: @228711
     /* 228711 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(228765), // Rule ID 692 //
     /* 228716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 228721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228738 */     // (intrinsic_wo_chain:{ *:[f32] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F32_e64),
     /* 228741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228763 */     GIR_RootConstrainSelectedInstOperands,
     /* 228764 */     // GIR_Coverage, 692,
     /* 228764 */     GIR_EraseRootFromParent_Done,
     /* 228765 */   // Label 3692: @228765
     /* 228765 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(228822), // Rule ID 693 //
     /* 228770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log_clamp),
     /* 228778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228795 */     // (intrinsic_wo_chain:{ *:[f32] } 3015:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_CLAMP_F32_e64),
     /* 228798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228820 */     GIR_RootConstrainSelectedInstOperands,
     /* 228821 */     // GIR_Coverage, 693,
     /* 228821 */     GIR_EraseRootFromParent_Done,
     /* 228822 */   // Label 3693: @228822
     /* 228822 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(228879), // Rule ID 694 //
     /* 228827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp_legacy),
     /* 228835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228852 */     // (intrinsic_wo_chain:{ *:[f32] } 3140:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_LEGACY_F32_e64),
     /* 228855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228877 */     GIR_RootConstrainSelectedInstOperands,
     /* 228878 */     // GIR_Coverage, 694,
     /* 228878 */     GIR_EraseRootFromParent_Done,
     /* 228879 */   // Label 3694: @228879
     /* 228879 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(228936), // Rule ID 696 //
     /* 228884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 228892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228909 */     // (intrinsic_wo_chain:{ *:[f32] } 3145:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F32_e64),
     /* 228912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228934 */     GIR_RootConstrainSelectedInstOperands,
     /* 228935 */     // GIR_Coverage, 696,
     /* 228935 */     GIR_EraseRootFromParent_Done,
     /* 228936 */   // Label 3695: @228936
     /* 228936 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(228993), // Rule ID 698 //
     /* 228941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_legacy),
     /* 228949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228966 */     // (intrinsic_wo_chain:{ *:[f32] } 3146:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_LEGACY_F32_e64),
     /* 228969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228991 */     GIR_RootConstrainSelectedInstOperands,
     /* 228992 */     // GIR_Coverage, 698,
     /* 228992 */     GIR_EraseRootFromParent_Done,
     /* 228993 */   // Label 3696: @228993
     /* 228993 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(229050), // Rule ID 699 //
     /* 228998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 229001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 229006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 229009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 229012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 229016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229023 */     // (intrinsic_wo_chain:{ *:[f64] } 3145:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F64_e64),
     /* 229026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229048 */     GIR_RootConstrainSelectedInstOperands,
     /* 229049 */     // GIR_Coverage, 699,
     /* 229049 */     GIR_EraseRootFromParent_Done,
     /* 229050 */   // Label 3697: @229050
     /* 229050 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(229107), // Rule ID 717 //
     /* 229055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 229063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229080 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_e64),
     /* 229083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229105 */     GIR_RootConstrainSelectedInstOperands,
     /* 229106 */     // GIR_Coverage, 717,
     /* 229106 */     GIR_EraseRootFromParent_Done,
     /* 229107 */   // Label 3698: @229107
     /* 229107 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(229164), // Rule ID 721 //
     /* 229112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 229120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229137 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_fake16_e64),
     /* 229140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229162 */     GIR_RootConstrainSelectedInstOperands,
     /* 229163 */     // GIR_Coverage, 721,
     /* 229163 */     GIR_EraseRootFromParent_Done,
     /* 229164 */   // Label 3699: @229164
     /* 229164 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(229221), // Rule ID 724 //
     /* 229169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 229177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229194 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 229197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229219 */     GIR_RootConstrainSelectedInstOperands,
     /* 229220 */     // GIR_Coverage, 724,
     /* 229220 */     GIR_EraseRootFromParent_Done,
     /* 229221 */   // Label 3700: @229221
     /* 229221 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(229278), // Rule ID 728 //
     /* 229226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 229234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229251 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 229254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229276 */     GIR_RootConstrainSelectedInstOperands,
     /* 229277 */     // GIR_Coverage, 728,
     /* 229277 */     GIR_EraseRootFromParent_Done,
     /* 229278 */   // Label 3701: @229278
     /* 229278 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(229335), // Rule ID 729 //
     /* 229283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 229291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229308 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_e64),
     /* 229311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229333 */     GIR_RootConstrainSelectedInstOperands,
     /* 229334 */     // GIR_Coverage, 729,
     /* 229334 */     GIR_EraseRootFromParent_Done,
     /* 229335 */   // Label 3702: @229335
     /* 229335 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(229392), // Rule ID 733 //
     /* 229340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 229348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229365 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_fake16_e64),
     /* 229368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229390 */     GIR_RootConstrainSelectedInstOperands,
     /* 229391 */     // GIR_Coverage, 733,
     /* 229391 */     GIR_EraseRootFromParent_Done,
     /* 229392 */   // Label 3703: @229392
     /* 229392 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(229449), // Rule ID 735 //
     /* 229397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 229405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229422 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 229425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229447 */     GIR_RootConstrainSelectedInstOperands,
     /* 229448 */     // GIR_Coverage, 735,
     /* 229448 */     GIR_EraseRootFromParent_Done,
     /* 229449 */   // Label 3704: @229449
     /* 229449 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(229506), // Rule ID 739 //
     /* 229454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 229462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229479 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 229482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229504 */     GIR_RootConstrainSelectedInstOperands,
     /* 229505 */     // GIR_Coverage, 739,
     /* 229505 */     GIR_EraseRootFromParent_Done,
     /* 229506 */   // Label 3705: @229506
     /* 229506 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(229563), // Rule ID 741 //
     /* 229511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 229519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229536 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 229539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229561 */     GIR_RootConstrainSelectedInstOperands,
     /* 229562 */     // GIR_Coverage, 741,
     /* 229562 */     GIR_EraseRootFromParent_Done,
     /* 229563 */   // Label 3706: @229563
     /* 229563 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(229620), // Rule ID 745 //
     /* 229568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 229576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229593 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 229596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229618 */     GIR_RootConstrainSelectedInstOperands,
     /* 229619 */     // GIR_Coverage, 745,
     /* 229619 */     GIR_EraseRootFromParent_Done,
     /* 229620 */   // Label 3707: @229620
     /* 229620 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(229677), // Rule ID 747 //
     /* 229625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 229633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229650 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_e64),
     /* 229653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229675 */     GIR_RootConstrainSelectedInstOperands,
     /* 229676 */     // GIR_Coverage, 747,
     /* 229676 */     GIR_EraseRootFromParent_Done,
     /* 229677 */   // Label 3708: @229677
     /* 229677 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(229734), // Rule ID 751 //
     /* 229682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 229690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229707 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_fake16_e64),
     /* 229710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229732 */     GIR_RootConstrainSelectedInstOperands,
     /* 229733 */     // GIR_Coverage, 751,
     /* 229733 */     GIR_EraseRootFromParent_Done,
     /* 229734 */   // Label 3709: @229734
     /* 229734 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(229791), // Rule ID 753 //
     /* 229739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 229747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229764 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_e64),
     /* 229767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229789 */     GIR_RootConstrainSelectedInstOperands,
     /* 229790 */     // GIR_Coverage, 753,
     /* 229790 */     GIR_EraseRootFromParent_Done,
     /* 229791 */   // Label 3710: @229791
     /* 229791 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(229848), // Rule ID 757 //
     /* 229796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 229804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229821 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_fake16_e64),
     /* 229824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229846 */     GIR_RootConstrainSelectedInstOperands,
     /* 229847 */     // GIR_Coverage, 757,
     /* 229847 */     GIR_EraseRootFromParent_Done,
     /* 229848 */   // Label 3711: @229848
     /* 229848 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(229905), // Rule ID 759 //
     /* 229853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 229861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229878 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_e64),
     /* 229881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229903 */     GIR_RootConstrainSelectedInstOperands,
     /* 229904 */     // GIR_Coverage, 759,
     /* 229904 */     GIR_EraseRootFromParent_Done,
     /* 229905 */   // Label 3712: @229905
     /* 229905 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(229962), // Rule ID 761 //
     /* 229910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 229918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229935 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_fake16_e64),
     /* 229938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229960 */     GIR_RootConstrainSelectedInstOperands,
     /* 229961 */     // GIR_Coverage, 761,
     /* 229961 */     GIR_EraseRootFromParent_Done,
     /* 229962 */   // Label 3713: @229962
     /* 229962 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(230019), // Rule ID 762 //
     /* 229967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 229975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229992 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_e64),
     /* 229995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230017 */     GIR_RootConstrainSelectedInstOperands,
     /* 230018 */     // GIR_Coverage, 762,
     /* 230018 */     GIR_EraseRootFromParent_Done,
     /* 230019 */   // Label 3714: @230019
     /* 230019 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(230076), // Rule ID 764 //
     /* 230024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 230027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 230032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230049 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 230049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_fake16_e64),
     /* 230052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230074 */     GIR_RootConstrainSelectedInstOperands,
     /* 230075 */     // GIR_Coverage, 764,
     /* 230075 */     GIR_EraseRootFromParent_Done,
     /* 230076 */   // Label 3715: @230076
     /* 230076 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(230133), // Rule ID 777 //
     /* 230081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 230084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 230089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230106 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 230106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_e64),
     /* 230109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230131 */     GIR_RootConstrainSelectedInstOperands,
     /* 230132 */     // GIR_Coverage, 777,
     /* 230132 */     GIR_EraseRootFromParent_Done,
     /* 230133 */   // Label 3716: @230133
     /* 230133 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(230190), // Rule ID 781 //
     /* 230138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 230141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 230146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230163 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 230163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_fake16_e64),
     /* 230166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230188 */     GIR_RootConstrainSelectedInstOperands,
     /* 230189 */     // GIR_Coverage, 781,
     /* 230189 */     GIR_EraseRootFromParent_Done,
     /* 230190 */   // Label 3717: @230190
     /* 230190 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(230232), // Rule ID 783 //
     /* 230195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrngInst),
     /* 230198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_prng_b32),
     /* 230203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230220 */     // (intrinsic_wo_chain:{ *:[i32] } 3085:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_PRNG_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 230220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PRNG_B32_e64),
     /* 230223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230230 */     GIR_RootConstrainSelectedInstOperands,
     /* 230231 */     // GIR_Coverage, 783,
     /* 230231 */     GIR_EraseRootFromParent_Done,
     /* 230232 */   // Label 3718: @230232
     /* 230232 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(230288), // Rule ID 719 //
     /* 230237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 230245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230262 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RCP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_t16_e64),
     /* 230265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230286 */     GIR_RootConstrainSelectedInstOperands,
     /* 230287 */     // GIR_Coverage, 719,
     /* 230287 */     GIR_EraseRootFromParent_Done,
     /* 230288 */   // Label 3719: @230288
     /* 230288 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(230344), // Rule ID 726 //
     /* 230293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 230301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230318 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 230321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230342 */     GIR_RootConstrainSelectedInstOperands,
     /* 230343 */     // GIR_Coverage, 726,
     /* 230343 */     GIR_EraseRootFromParent_Done,
     /* 230344 */   // Label 3720: @230344
     /* 230344 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(230400), // Rule ID 731 //
     /* 230349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 230357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230374 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RSQ_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_t16_e64),
     /* 230377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230398 */     GIR_RootConstrainSelectedInstOperands,
     /* 230399 */     // GIR_Coverage, 731,
     /* 230399 */     GIR_EraseRootFromParent_Done,
     /* 230400 */   // Label 3721: @230400
     /* 230400 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(230456), // Rule ID 737 //
     /* 230405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 230413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230430 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 230433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230454 */     GIR_RootConstrainSelectedInstOperands,
     /* 230455 */     // GIR_Coverage, 737,
     /* 230455 */     GIR_EraseRootFromParent_Done,
     /* 230456 */   // Label 3722: @230456
     /* 230456 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(230512), // Rule ID 743 //
     /* 230461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 230469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230486 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 230489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230510 */     GIR_RootConstrainSelectedInstOperands,
     /* 230511 */     // GIR_Coverage, 743,
     /* 230511 */     GIR_EraseRootFromParent_Done,
     /* 230512 */   // Label 3723: @230512
     /* 230512 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(230568), // Rule ID 749 //
     /* 230517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 230525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230542 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_t16_e64),
     /* 230545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230566 */     GIR_RootConstrainSelectedInstOperands,
     /* 230567 */     // GIR_Coverage, 749,
     /* 230567 */     GIR_EraseRootFromParent_Done,
     /* 230568 */   // Label 3724: @230568
     /* 230568 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(230624), // Rule ID 755 //
     /* 230573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 230581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230598 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_COS_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_t16_e64),
     /* 230601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230622 */     GIR_RootConstrainSelectedInstOperands,
     /* 230623 */     // GIR_Coverage, 755,
     /* 230623 */     GIR_EraseRootFromParent_Done,
     /* 230624 */   // Label 3725: @230624
     /* 230624 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(230680), // Rule ID 760 //
     /* 230629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 230637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230654 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_MANT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_t16_e64),
     /* 230657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230678 */     GIR_RootConstrainSelectedInstOperands,
     /* 230679 */     // GIR_Coverage, 760,
     /* 230679 */     GIR_EraseRootFromParent_Done,
     /* 230680 */   // Label 3726: @230680
     /* 230680 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(230736), // Rule ID 763 //
     /* 230685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 230693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230710 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_EXP_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_t16_e64),
     /* 230713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230734 */     GIR_RootConstrainSelectedInstOperands,
     /* 230735 */     // GIR_Coverage, 763,
     /* 230735 */     GIR_EraseRootFromParent_Done,
     /* 230736 */   // Label 3727: @230736
     /* 230736 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(230792), // Rule ID 779 //
     /* 230741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 230749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230766 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FRACT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_t16_e64),
     /* 230769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230790 */     GIR_RootConstrainSelectedInstOperands,
     /* 230791 */     // GIR_Coverage, 779,
     /* 230791 */     GIR_EraseRootFromParent_Done,
     /* 230792 */   // Label 3728: @230792
     /* 230792 */   GIM_Reject,
     /* 230793 */ // Label 3661: @230793
     /* 230793 */ GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(233331),
     /* 230798 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 230801 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(230850), // Rule ID 1891 //
     /* 230806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230831 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 230831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 230834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230846 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230848 */     GIR_RootConstrainSelectedInstOperands,
     /* 230849 */     // GIR_Coverage, 1891,
     /* 230849 */     GIR_EraseRootFromParent_Done,
     /* 230850 */   // Label 3730: @230850
     /* 230850 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(230937), // Rule ID 1893 //
     /* 230855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230883 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, VSrcT_f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[i32] }:$src1, lo16:{ *:[i32] }), 0:{ *:[i32] })
     /* 230883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 230886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 230890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230895 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src1
     /* 230901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 230914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230935 */     GIR_RootConstrainSelectedInstOperands,
     /* 230936 */     // GIR_Coverage, 1893,
     /* 230936 */     GIR_EraseRootFromParent_Done,
     /* 230937 */   // Label 3731: @230937
     /* 230937 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(230992), // Rule ID 1895 //
     /* 230942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 230945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230970 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src1)
     /* 230970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 230973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230988 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230990 */     GIR_RootConstrainSelectedInstOperands,
     /* 230991 */     // GIR_Coverage, 1895,
     /* 230991 */     GIR_EraseRootFromParent_Done,
     /* 230992 */   // Label 3732: @230992
     /* 230992 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(231041), // Rule ID 1897 //
     /* 230997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 231002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 231005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 231008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 231015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 231022 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 231022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 231025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231037 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231039 */     GIR_RootConstrainSelectedInstOperands,
     /* 231040 */     // GIR_Coverage, 1897,
     /* 231040 */     GIR_EraseRootFromParent_Done,
     /* 231041 */   // Label 3733: @231041
     /* 231041 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(231093), // Rule ID 1899 //
     /* 231046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 231049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 231054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 231057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 231060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 231067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 231074 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1)
     /* 231074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 231077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231089 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231091 */     GIR_RootConstrainSelectedInstOperands,
     /* 231092 */     // GIR_Coverage, 1899,
     /* 231092 */     GIR_EraseRootFromParent_Done,
     /* 231093 */   // Label 3734: @231093
     /* 231093 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(231148), // Rule ID 2395 //
     /* 231098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 231101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231116 */     // MIs[0] Operand 3
     /* 231116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231127 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 231127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231146 */     GIR_RootConstrainSelectedInstOperands,
     /* 231147 */     // GIR_Coverage, 2395,
     /* 231147 */     GIR_EraseRootFromParent_Done,
     /* 231148 */   // Label 3735: @231148
     /* 231148 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(231203), // Rule ID 2396 //
     /* 231153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 231156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231171 */     // MIs[0] Operand 3
     /* 231171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231182 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 231182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231201 */     GIR_RootConstrainSelectedInstOperands,
     /* 231202 */     // GIR_Coverage, 2396,
     /* 231202 */     GIR_EraseRootFromParent_Done,
     /* 231203 */   // Label 3736: @231203
     /* 231203 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(231246), // Rule ID 2397 //
     /* 231208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 231211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231226 */     // MIs[0] Operand 3
     /* 231226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231237 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 231237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_e32),
     /* 231240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231242 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231244 */     GIR_RootConstrainSelectedInstOperands,
     /* 231245 */     // GIR_Coverage, 2397,
     /* 231245 */     GIR_EraseRootFromParent_Done,
     /* 231246 */   // Label 3737: @231246
     /* 231246 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(231289), // Rule ID 2398 //
     /* 231251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 231254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231269 */     // MIs[0] Operand 3
     /* 231269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231280 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 231280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_e32),
     /* 231283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231287 */     GIR_RootConstrainSelectedInstOperands,
     /* 231288 */     // GIR_Coverage, 2398,
     /* 231288 */     GIR_EraseRootFromParent_Done,
     /* 231289 */   // Label 3738: @231289
     /* 231289 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(231344), // Rule ID 2399 //
     /* 231294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231312 */     // MIs[0] Operand 3
     /* 231312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 231323 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 231323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231331 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 231342 */     GIR_RootConstrainSelectedInstOperands,
     /* 231343 */     // GIR_Coverage, 2399,
     /* 231343 */     GIR_EraseRootFromParent_Done,
     /* 231344 */   // Label 3739: @231344
     /* 231344 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(231399), // Rule ID 2400 //
     /* 231349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231367 */     // MIs[0] Operand 3
     /* 231367 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 231378 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 231378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 231397 */     GIR_RootConstrainSelectedInstOperands,
     /* 231398 */     // GIR_Coverage, 2400,
     /* 231398 */     GIR_EraseRootFromParent_Done,
     /* 231399 */   // Label 3740: @231399
     /* 231399 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(231454), // Rule ID 2401 //
     /* 231404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231422 */     // MIs[0] Operand 3
     /* 231422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 231433 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 231433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 231452 */     GIR_RootConstrainSelectedInstOperands,
     /* 231453 */     // GIR_Coverage, 2401,
     /* 231453 */     GIR_EraseRootFromParent_Done,
     /* 231454 */   // Label 3741: @231454
     /* 231454 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(231509), // Rule ID 2402 //
     /* 231459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231477 */     // MIs[0] Operand 3
     /* 231477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 231488 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 231488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 231507 */     GIR_RootConstrainSelectedInstOperands,
     /* 231508 */     // GIR_Coverage, 2402,
     /* 231508 */     GIR_EraseRootFromParent_Done,
     /* 231509 */   // Label 3742: @231509
     /* 231509 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(231564), // Rule ID 2403 //
     /* 231514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231532 */     // MIs[0] Operand 3
     /* 231532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 231543 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 231543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 231562 */     GIR_RootConstrainSelectedInstOperands,
     /* 231563 */     // GIR_Coverage, 2403,
     /* 231563 */     GIR_EraseRootFromParent_Done,
     /* 231564 */   // Label 3743: @231564
     /* 231564 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(231619), // Rule ID 2404 //
     /* 231569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231587 */     // MIs[0] Operand 3
     /* 231587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 231598 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 231598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 231617 */     GIR_RootConstrainSelectedInstOperands,
     /* 231618 */     // GIR_Coverage, 2404,
     /* 231618 */     GIR_EraseRootFromParent_Done,
     /* 231619 */   // Label 3744: @231619
     /* 231619 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(231662), // Rule ID 2405 //
     /* 231624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231642 */     // MIs[0] Operand 3
     /* 231642 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231653 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_e32),
     /* 231656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231660 */     GIR_RootConstrainSelectedInstOperands,
     /* 231661 */     // GIR_Coverage, 2405,
     /* 231661 */     GIR_EraseRootFromParent_Done,
     /* 231662 */   // Label 3745: @231662
     /* 231662 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(231705), // Rule ID 2406 //
     /* 231667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231685 */     // MIs[0] Operand 3
     /* 231685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231696 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_e32),
     /* 231699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231703 */     GIR_RootConstrainSelectedInstOperands,
     /* 231704 */     // GIR_Coverage, 2406,
     /* 231704 */     GIR_EraseRootFromParent_Done,
     /* 231705 */   // Label 3746: @231705
     /* 231705 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(231760), // Rule ID 2407 //
     /* 231710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231728 */     // MIs[0] Operand 3
     /* 231728 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231739 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 231739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_sdwa),
     /* 231742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 231758 */     GIR_RootConstrainSelectedInstOperands,
     /* 231759 */     // GIR_Coverage, 2407,
     /* 231759 */     GIR_EraseRootFromParent_Done,
     /* 231760 */   // Label 3747: @231760
     /* 231760 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(231815), // Rule ID 2408 //
     /* 231765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231783 */     // MIs[0] Operand 3
     /* 231783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231794 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 231794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_sdwa),
     /* 231797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231802 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 231813 */     GIR_RootConstrainSelectedInstOperands,
     /* 231814 */     // GIR_Coverage, 2408,
     /* 231814 */     GIR_EraseRootFromParent_Done,
     /* 231815 */   // Label 3748: @231815
     /* 231815 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(231858), // Rule ID 2411 //
     /* 231820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231838 */     // MIs[0] Operand 3
     /* 231838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231849 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e32),
     /* 231852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231856 */     GIR_RootConstrainSelectedInstOperands,
     /* 231857 */     // GIR_Coverage, 2411,
     /* 231857 */     GIR_EraseRootFromParent_Done,
     /* 231858 */   // Label 3749: @231858
     /* 231858 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(231901), // Rule ID 2412 //
     /* 231863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231881 */     // MIs[0] Operand 3
     /* 231881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231892 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e32),
     /* 231895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231899 */     GIR_RootConstrainSelectedInstOperands,
     /* 231900 */     // GIR_Coverage, 2412,
     /* 231900 */     GIR_EraseRootFromParent_Done,
     /* 231901 */   // Label 3750: @231901
     /* 231901 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(231950), // Rule ID 2413 //
     /* 231906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231924 */     // MIs[0] Operand 3
     /* 231924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231935 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 231935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e64),
     /* 231938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 231943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231948 */     GIR_RootConstrainSelectedInstOperands,
     /* 231949 */     // GIR_Coverage, 2413,
     /* 231949 */     GIR_EraseRootFromParent_Done,
     /* 231950 */   // Label 3751: @231950
     /* 231950 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(231999), // Rule ID 2414 //
     /* 231955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231973 */     // MIs[0] Operand 3
     /* 231973 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231984 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 231984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e64),
     /* 231987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 231992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231997 */     GIR_RootConstrainSelectedInstOperands,
     /* 231998 */     // GIR_Coverage, 2414,
     /* 231998 */     GIR_EraseRootFromParent_Done,
     /* 231999 */   // Label 3752: @231999
     /* 231999 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(232040), // Rule ID 2409 //
     /* 232004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 232007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 232012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232022 */     // MIs[0] byte_sel
     /* 232022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 232025 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_FP8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 232025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_OP_SEL_e64),
     /* 232028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232032 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 232038 */     GIR_RootConstrainSelectedInstOperands,
     /* 232039 */     // GIR_Coverage, 2409,
     /* 232039 */     GIR_EraseRootFromParent_Done,
     /* 232040 */   // Label 3753: @232040
     /* 232040 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(232081), // Rule ID 2410 //
     /* 232045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 232048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 232053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232063 */     // MIs[0] byte_sel
     /* 232063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 232066 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_BF8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 232066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_OP_SEL_e64),
     /* 232069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 232079 */     GIR_RootConstrainSelectedInstOperands,
     /* 232080 */     // GIR_Coverage, 2410,
     /* 232080 */     GIR_EraseRootFromParent_Done,
     /* 232081 */   // Label 3754: @232081
     /* 232081 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(232130), // Rule ID 108 //
     /* 232086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 232089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 232094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 232107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 232111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 232115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13769),
     /* 232119 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2104:{ *:[iPTR] }, SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13769>>  =>  (S_CVT_PK_RTZ_F16_F32:{ *:[v2f16] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 232119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_PK_RTZ_F16_F32),
     /* 232122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 232124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232126 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232128 */     GIR_RootConstrainSelectedInstOperands,
     /* 232129 */     // GIR_Coverage, 108,
     /* 232129 */     GIR_EraseRootFromParent_Done,
     /* 232130 */   // Label 3755: @232130
     /* 232130 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(232233), // Rule ID 2501 //
     /* 232135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 232140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232153 */     // (intrinsic_wo_chain:{ *:[i64] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 232153 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 232156 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 232160 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 232169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 232173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 232175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 232178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 232182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 232191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 232195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 232198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 232203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232208 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 232211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 232214 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 232217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232232 */     // GIR_Coverage, 2501,
     /* 232232 */     GIR_EraseRootFromParent_Done,
     /* 232233 */   // Label 3756: @232233
     /* 232233 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(232336), // Rule ID 2503 //
     /* 232238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 232243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232256 */     // (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 232256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 232259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 232263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 232272 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 232276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 232278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 232281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 232285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 232294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 232298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 232301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 232306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232311 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 232314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 232317 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 232320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232335 */     // GIR_Coverage, 2503,
     /* 232335 */     GIR_EraseRootFromParent_Done,
     /* 232336 */   // Label 3757: @232336
     /* 232336 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(232410), // Rule ID 788 //
     /* 232341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 232346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232373 */     // (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 232376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232408 */     GIR_RootConstrainSelectedInstOperands,
     /* 232409 */     // GIR_Coverage, 788,
     /* 232409 */     GIR_EraseRootFromParent_Done,
     /* 232410 */   // Label 3758: @232410
     /* 232410 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(232479), // Rule ID 822 //
     /* 232415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_i16),
     /* 232420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232447 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2102:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_I16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 232447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_I16_F32_e64),
     /* 232450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232477 */     GIR_RootConstrainSelectedInstOperands,
     /* 232478 */     // GIR_Coverage, 822,
     /* 232478 */     GIR_EraseRootFromParent_Done,
     /* 232479 */   // Label 3759: @232479
     /* 232479 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(232548), // Rule ID 824 //
     /* 232484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_u16),
     /* 232489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232516 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2103:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_U16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 232516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_U16_F32_e64),
     /* 232519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232546 */     GIR_RootConstrainSelectedInstOperands,
     /* 232547 */     // GIR_Coverage, 824,
     /* 232547 */     GIR_EraseRootFromParent_Done,
     /* 232548 */   // Label 3760: @232548
     /* 232548 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(232622), // Rule ID 826 //
     /* 232553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 232558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232585 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2104:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKRTZ_F16_F32_e64:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKRTZ_F16_F32_e64),
     /* 232588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232620 */     GIR_RootConstrainSelectedInstOperands,
     /* 232621 */     // GIR_Coverage, 826,
     /* 232621 */     GIR_EraseRootFromParent_Done,
     /* 232622 */   // Label 3761: @232622
     /* 232622 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(232696), // Rule ID 982 //
     /* 232627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_trig_preop),
     /* 232632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232659 */     // (intrinsic_wo_chain:{ *:[f64] } 3299:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_TRIG_PREOP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRIG_PREOP_F64_e64),
     /* 232662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232694 */     GIR_RootConstrainSelectedInstOperands,
     /* 232695 */     // GIR_Coverage, 982,
     /* 232695 */     GIR_EraseRootFromParent_Done,
     /* 232696 */   // Label 3762: @232696
     /* 232696 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(232770), // Rule ID 8420 //
     /* 232701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 232706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232733 */     // (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 232736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 232743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 232748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 232753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 232758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 232763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 232768 */     GIR_RootConstrainSelectedInstOperands,
     /* 232769 */     // GIR_Coverage, 8420,
     /* 232769 */     GIR_EraseRootFromParent_Done,
     /* 232770 */   // Label 3763: @232770
     /* 232770 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(232817), // Rule ID 1054 //
     /* 232775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_fp6),
     /* 232783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 232786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 232796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232803 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2136:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_FP6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_FP6_e64),
     /* 232806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232813 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232815 */     GIR_RootConstrainSelectedInstOperands,
     /* 232816 */     // GIR_Coverage, 1054,
     /* 232816 */     GIR_EraseRootFromParent_Done,
     /* 232817 */   // Label 3764: @232817
     /* 232817 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(232864), // Rule ID 1055 //
     /* 232822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_bf6),
     /* 232830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 232833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 232843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232850 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2135:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_BF6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_BF6_e64),
     /* 232853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232862 */     GIR_RootConstrainSelectedInstOperands,
     /* 232863 */     // GIR_Coverage, 1055,
     /* 232863 */     GIR_EraseRootFromParent_Done,
     /* 232864 */   // Label 3765: @232864
     /* 232864 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(232911), // Rule ID 1056 //
     /* 232869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_fp6),
     /* 232877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 232880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 232890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232897 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2134:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_FP6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_FP6_e64),
     /* 232900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232907 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232909 */     GIR_RootConstrainSelectedInstOperands,
     /* 232910 */     // GIR_Coverage, 1056,
     /* 232910 */     GIR_EraseRootFromParent_Done,
     /* 232911 */   // Label 3766: @232911
     /* 232911 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(232958), // Rule ID 1057 //
     /* 232916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_bf6),
     /* 232924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 232927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 232937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232944 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2133:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_BF6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_BF6_e64),
     /* 232947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232954 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232956 */     GIR_RootConstrainSelectedInstOperands,
     /* 232957 */     // GIR_Coverage, 1057,
     /* 232957 */     GIR_EraseRootFromParent_Done,
     /* 232958 */   // Label 3767: @232958
     /* 232958 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(233005), // Rule ID 1058 //
     /* 232963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 232966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_fp6_f16),
     /* 232971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 232974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 232977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 232984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232991 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2138:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_FP6_F16_e64),
     /* 232994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233003 */     GIR_RootConstrainSelectedInstOperands,
     /* 233004 */     // GIR_Coverage, 1058,
     /* 233004 */     GIR_EraseRootFromParent_Done,
     /* 233005 */   // Label 3768: @233005
     /* 233005 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(233052), // Rule ID 1059 //
     /* 233010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 233013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf6_f16),
     /* 233018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 233021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 233024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 233031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233038 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2132:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 233038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF6_F16_e64),
     /* 233041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233050 */     GIR_RootConstrainSelectedInstOperands,
     /* 233051 */     // GIR_Coverage, 1059,
     /* 233051 */     GIR_EraseRootFromParent_Done,
     /* 233052 */   // Label 3769: @233052
     /* 233052 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(233089), // Rule ID 792 //
     /* 233057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 233062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233075 */     // (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 233078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233082 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233087 */     GIR_RootConstrainSelectedInstOperands,
     /* 233088 */     // GIR_Coverage, 792,
     /* 233088 */     GIR_EraseRootFromParent_Done,
     /* 233089 */   // Label 3770: @233089
     /* 233089 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(233123), // Rule ID 794 //
     /* 233094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_i24),
     /* 233099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233112 */     // (intrinsic_wo_chain:{ *:[i32] } 3074:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 233115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233119 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233121 */     GIR_RootConstrainSelectedInstOperands,
     /* 233122 */     // GIR_Coverage, 794,
     /* 233122 */     GIR_EraseRootFromParent_Done,
     /* 233123 */   // Label 3771: @233123
     /* 233123 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(233160), // Rule ID 796 //
     /* 233128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 233133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233146 */     // (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 233149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233151 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233153 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233158 */     GIR_RootConstrainSelectedInstOperands,
     /* 233159 */     // GIR_Coverage, 796,
     /* 233159 */     GIR_EraseRootFromParent_Done,
     /* 233160 */   // Label 3772: @233160
     /* 233160 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(233194), // Rule ID 798 //
     /* 233165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_u24),
     /* 233170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233183 */     // (intrinsic_wo_chain:{ *:[i32] } 3075:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 233186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233190 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233192 */     GIR_RootConstrainSelectedInstOperands,
     /* 233193 */     // GIR_Coverage, 798,
     /* 233193 */     GIR_EraseRootFromParent_Done,
     /* 233194 */   // Label 3773: @233194
     /* 233194 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(233228), // Rule ID 818 //
     /* 233199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_lo),
     /* 233204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233217 */     // (intrinsic_wo_chain:{ *:[i32] } 3019:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_LO_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_LO_U32_B32_e64),
     /* 233220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233224 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233226 */     GIR_RootConstrainSelectedInstOperands,
     /* 233227 */     // GIR_Coverage, 818,
     /* 233227 */     GIR_EraseRootFromParent_Done,
     /* 233228 */   // Label 3774: @233228
     /* 233228 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(233262), // Rule ID 819 //
     /* 233233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_hi),
     /* 233238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233251 */     // (intrinsic_wo_chain:{ *:[i32] } 3018:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_HI_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_HI_U32_B32_e64),
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233258 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233260 */     GIR_RootConstrainSelectedInstOperands,
     /* 233261 */     // GIR_Coverage, 819,
     /* 233261 */     GIR_EraseRootFromParent_Done,
     /* 233262 */   // Label 3775: @233262
     /* 233262 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(233296), // Rule ID 828 //
     /* 233267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u16),
     /* 233272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 233275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233285 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_U16_U32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U16_U32_e64),
     /* 233288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233294 */     GIR_RootConstrainSelectedInstOperands,
     /* 233295 */     // GIR_Coverage, 828,
     /* 233295 */     GIR_EraseRootFromParent_Done,
     /* 233296 */   // Label 3776: @233296
     /* 233296 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(233330), // Rule ID 830 //
     /* 233301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_i16),
     /* 233306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 233309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233319 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2099:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 233322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233326 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233328 */     GIR_RootConstrainSelectedInstOperands,
     /* 233329 */     // GIR_Coverage, 830,
     /* 233329 */     GIR_EraseRootFromParent_Done,
     /* 233330 */   // Label 3777: @233330
     /* 233330 */   GIM_Reject,
     /* 233331 */ // Label 3729: @233331
     /* 233331 */ GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(237895),
     /* 233336 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 233339 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(233432), // Rule ID 2566 //
     /* 233344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 233352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233389 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[i32] }:$src2)
     /* 233389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_fake16_e64),
     /* 233392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233430 */     GIR_RootConstrainSelectedInstOperands,
     /* 233431 */     // GIR_Coverage, 2566,
     /* 233431 */     GIR_EraseRootFromParent_Done,
     /* 233432 */   // Label 3779: @233432
     /* 233432 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(233552), // Rule ID 2567 //
     /* 233437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 233440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 233445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233482 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_t16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }))
     /* 233482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 233489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233494 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 233501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 233506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_t16_e64),
     /* 233514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233550 */     GIR_RootConstrainSelectedInstOperands,
     /* 233551 */     // GIR_Coverage, 2567,
     /* 233551 */     GIR_EraseRootFromParent_Done,
     /* 233552 */   // Label 3780: @233552
     /* 233552 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(233642), // Rule ID 6920 //
     /* 233557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10),
     /* 233562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233599 */     // (intrinsic_wo_chain:{ *:[f32] } 2993:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P10_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 233599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F32_inreg),
     /* 233602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 233640 */     GIR_RootConstrainSelectedInstOperands,
     /* 233641 */     // GIR_Coverage, 6920,
     /* 233641 */     GIR_EraseRootFromParent_Done,
     /* 233642 */   // Label 3781: @233642
     /* 233642 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(233732), // Rule ID 6921 //
     /* 233647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2),
     /* 233652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233689 */     // (intrinsic_wo_chain:{ *:[f32] } 2995:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P2_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 233689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32_inreg),
     /* 233692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 233730 */     GIR_RootConstrainSelectedInstOperands,
     /* 233731 */     // GIR_Coverage, 6921,
     /* 233731 */     GIR_EraseRootFromParent_Done,
     /* 233732 */   // Label 3782: @233732
     /* 233732 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(233819), // Rule ID 7002 //
     /* 233737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 233740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 233745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233782 */     // (intrinsic_wo_chain:{ *:[f32] } 2209:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 233785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233817 */     GIR_RootConstrainSelectedInstOperands,
     /* 233818 */     // GIR_Coverage, 7002,
     /* 233818 */     GIR_EraseRootFromParent_Done,
     /* 233819 */   // Label 3783: @233819
     /* 233819 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(233906), // Rule ID 7006 //
     /* 233824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 233827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 233832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233869 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_LEGACY_F32_e64),
     /* 233872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233904 */     GIR_RootConstrainSelectedInstOperands,
     /* 233905 */     // GIR_Coverage, 7006,
     /* 233905 */     GIR_EraseRootFromParent_Done,
     /* 233906 */   // Label 3784: @233906
     /* 233906 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(233993), // Rule ID 7008 //
     /* 233911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 233914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 233919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 233928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 233931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233956 */     // (intrinsic_wo_chain:{ *:[f16] } 2209:{ *:[iPTR] }, (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 233959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233991 */     GIR_RootConstrainSelectedInstOperands,
     /* 233992 */     // GIR_Coverage, 7008,
     /* 233992 */     GIR_EraseRootFromParent_Done,
     /* 233993 */   // Label 3785: @233993
     /* 233993 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(234056), // Rule ID 2750 //
     /* 233998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 234001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_bf8),
     /* 234006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234029 */     // (intrinsic_wo_chain:{ *:[f32] } 2166:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 234029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_BF8),
     /* 234032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 234043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 234048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234054 */     GIR_RootConstrainSelectedInstOperands,
     /* 234055 */     // GIR_Coverage, 2750,
     /* 234055 */     GIR_EraseRootFromParent_Done,
     /* 234056 */   // Label 3786: @234056
     /* 234056 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(234119), // Rule ID 2751 //
     /* 234061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 234064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_fp8),
     /* 234069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234092 */     // (intrinsic_wo_chain:{ *:[f32] } 2165:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 234092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_FP8),
     /* 234095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234099 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 234106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 234111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234117 */     GIR_RootConstrainSelectedInstOperands,
     /* 234118 */     // GIR_Coverage, 2751,
     /* 234118 */     GIR_EraseRootFromParent_Done,
     /* 234119 */   // Label 3787: @234119
     /* 234119 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(234182), // Rule ID 2752 //
     /* 234124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 234127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_fp8),
     /* 234132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234155 */     // (intrinsic_wo_chain:{ *:[f32] } 2167:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 234155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_FP8),
     /* 234158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234162 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 234169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 234174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234180 */     GIR_RootConstrainSelectedInstOperands,
     /* 234181 */     // GIR_Coverage, 2752,
     /* 234181 */     GIR_EraseRootFromParent_Done,
     /* 234182 */   // Label 3788: @234182
     /* 234182 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(234245), // Rule ID 2753 //
     /* 234187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 234190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_bf8),
     /* 234195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234218 */     // (intrinsic_wo_chain:{ *:[f32] } 2164:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 234218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_BF8),
     /* 234221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234225 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 234232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 234237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234243 */     GIR_RootConstrainSelectedInstOperands,
     /* 234244 */     // GIR_Coverage, 2753,
     /* 234244 */     GIR_EraseRootFromParent_Done,
     /* 234245 */   // Label 3789: @234245
     /* 234245 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(234310), // Rule ID 6913 //
     /* 234250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 234253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 234258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234268 */     // MIs[0] attrchan
     /* 234268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 234271 */     // MIs[0] attr
     /* 234271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 234274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 234278 */     // (intrinsic_wo_chain:{ *:[f32] } 3011:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (LDS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] })
     /* 234278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 234282 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 234292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_PARAM_LOAD),
     /* 234295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234297 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 234299 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 234301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 234308 */     GIR_RootConstrainSelectedInstOperands,
     /* 234309 */     // GIR_Coverage, 6913,
     /* 234309 */     GIR_EraseRootFromParent_Done,
     /* 234310 */   // Label 3790: @234310
     /* 234310 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(234378), // Rule ID 6915 //
     /* 234315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 234318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 234323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234333 */     // MIs[0] attrchan
     /* 234333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 234336 */     // MIs[0] attr
     /* 234336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 234339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 234343 */     // (intrinsic_wo_chain:{ *:[f32] } 3011:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (DS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 234343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 234347 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 234357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PARAM_LOAD),
     /* 234360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234362 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 234364 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 234366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 234376 */     GIR_RootConstrainSelectedInstOperands,
     /* 234377 */     // GIR_Coverage, 6915,
     /* 234377 */     GIR_EraseRootFromParent_Done,
     /* 234378 */   // Label 3791: @234378
     /* 234378 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(234430), // Rule ID 2624 //
     /* 234383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_fp8),
     /* 234388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234401 */     // MIs[0] index
     /* 234401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234404 */     // (intrinsic_wo_chain:{ *:[f32] } 2110:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_FP8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_FP8_e64),
     /* 234407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234423 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234428 */     GIR_RootConstrainSelectedInstOperands,
     /* 234429 */     // GIR_Coverage, 2624,
     /* 234429 */     GIR_EraseRootFromParent_Done,
     /* 234430 */   // Label 3792: @234430
     /* 234430 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(234482), // Rule ID 2625 //
     /* 234435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_bf8),
     /* 234440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234453 */     // MIs[0] index
     /* 234453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234456 */     // (intrinsic_wo_chain:{ *:[f32] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_BF8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_BF8_e64),
     /* 234459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234480 */     GIR_RootConstrainSelectedInstOperands,
     /* 234481 */     // GIR_Coverage, 2625,
     /* 234481 */     GIR_EraseRootFromParent_Done,
     /* 234482 */   // Label 3793: @234482
     /* 234482 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(234534), // Rule ID 2626 //
     /* 234487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp4),
     /* 234492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234505 */     // MIs[0] index
     /* 234505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234508 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F16_FP4_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP4_e64),
     /* 234511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234527 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234532 */     GIR_RootConstrainSelectedInstOperands,
     /* 234533 */     // GIR_Coverage, 2626,
     /* 234533 */     GIR_EraseRootFromParent_Done,
     /* 234534 */   // Label 3794: @234534
     /* 234534 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(234583), // Rule ID 2633 //
     /* 234539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp8),
     /* 234544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234557 */     // MIs[0] word_sel
     /* 234557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234560 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2122:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_FP8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP8_e64),
     /* 234563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234581 */     GIR_RootConstrainSelectedInstOperands,
     /* 234582 */     // GIR_Coverage, 2633,
     /* 234582 */     GIR_EraseRootFromParent_Done,
     /* 234583 */   // Label 3795: @234583
     /* 234583 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(234632), // Rule ID 2634 //
     /* 234588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_bf8),
     /* 234593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234606 */     // MIs[0] word_sel
     /* 234606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234609 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_BF8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_BF8_e64),
     /* 234612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234614 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234630 */     GIR_RootConstrainSelectedInstOperands,
     /* 234631 */     // GIR_Coverage, 2634,
     /* 234631 */     GIR_EraseRootFromParent_Done,
     /* 234632 */   // Label 3796: @234632
     /* 234632 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(234681), // Rule ID 2635 //
     /* 234637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_bf8),
     /* 234642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234655 */     // MIs[0] word_sel
     /* 234655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234658 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2117:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_BF8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_BF8_e64),
     /* 234661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234674 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234679 */     GIR_RootConstrainSelectedInstOperands,
     /* 234680 */     // GIR_Coverage, 2635,
     /* 234680 */     GIR_EraseRootFromParent_Done,
     /* 234681 */   // Label 3797: @234681
     /* 234681 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(234730), // Rule ID 2636 //
     /* 234686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp8),
     /* 234691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234704 */     // MIs[0] word_sel
     /* 234704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234707 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2119:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_FP8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP8_e64),
     /* 234710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234728 */     GIR_RootConstrainSelectedInstOperands,
     /* 234729 */     // GIR_Coverage, 2636,
     /* 234729 */     GIR_EraseRootFromParent_Done,
     /* 234730 */   // Label 3798: @234730
     /* 234730 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(234782), // Rule ID 2639 //
     /* 234735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp4),
     /* 234740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234753 */     // MIs[0] index
     /* 234753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234756 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F32_FP4_e64:{ *:[v2f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP4_e64),
     /* 234759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234775 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234780 */     GIR_RootConstrainSelectedInstOperands,
     /* 234781 */     // GIR_Coverage, 2639,
     /* 234781 */     GIR_EraseRootFromParent_Done,
     /* 234782 */   // Label 3799: @234782
     /* 234782 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(234824), // Rule ID 2703 //
     /* 234787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u8),
     /* 234792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234808 */     // (intrinsic_wo_chain:{ *:[i32] } 3193:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U8_e64),
     /* 234811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234817 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234822 */     GIR_RootConstrainSelectedInstOperands,
     /* 234823 */     // GIR_Coverage, 2703,
     /* 234823 */     GIR_EraseRootFromParent_Done,
     /* 234824 */   // Label 3800: @234824
     /* 234824 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(234866), // Rule ID 2704 //
     /* 234829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_hi_u8),
     /* 234834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234850 */     // (intrinsic_wo_chain:{ *:[i32] } 3191:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_HI_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_HI_U8_e64),
     /* 234853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234857 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234859 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234864 */     GIR_RootConstrainSelectedInstOperands,
     /* 234865 */     // GIR_Coverage, 2704,
     /* 234865 */     GIR_EraseRootFromParent_Done,
     /* 234866 */   // Label 3801: @234866
     /* 234866 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(234908), // Rule ID 2705 //
     /* 234871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u16),
     /* 234876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234892 */     // (intrinsic_wo_chain:{ *:[i32] } 3192:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U16_e64),
     /* 234895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234899 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234901 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234906 */     GIR_RootConstrainSelectedInstOperands,
     /* 234907 */     // GIR_Coverage, 2705,
     /* 234907 */     GIR_EraseRootFromParent_Done,
     /* 234908 */   // Label 3802: @234908
     /* 234908 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(234950), // Rule ID 2706 //
     /* 234913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_msad_u8),
     /* 234918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234934 */     // (intrinsic_wo_chain:{ *:[i32] } 3071:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MSAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MSAD_U8_e64),
     /* 234937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234943 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234948 */     GIR_RootConstrainSelectedInstOperands,
     /* 234949 */     // GIR_Coverage, 2706,
     /* 234949 */     GIR_EraseRootFromParent_Done,
     /* 234950 */   // Label 3803: @234950
     /* 234950 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(234992), // Rule ID 2707 //
     /* 234955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_pk_u16_u8),
     /* 234960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 234963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 234966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 234972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234976 */     // (intrinsic_wo_chain:{ *:[i64] } 3069:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_MQSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 234976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_PK_U16_U8_e64),
     /* 234979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234983 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234985 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234990 */     GIR_RootConstrainSelectedInstOperands,
     /* 234991 */     // GIR_Coverage, 2707,
     /* 234991 */     GIR_EraseRootFromParent_Done,
     /* 234992 */   // Label 3804: @234992
     /* 234992 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(235034), // Rule ID 2708 //
     /* 234997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_qsad_pk_u16_u8),
     /* 235002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 235005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 235008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 235014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235018 */     // (intrinsic_wo_chain:{ *:[i64] } 3087:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_QSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 235018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_QSAD_PK_U16_U8_e64),
     /* 235021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 235025 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 235027 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 235029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235032 */     GIR_RootConstrainSelectedInstOperands,
     /* 235033 */     // GIR_Coverage, 2708,
     /* 235033 */     GIR_EraseRootFromParent_Done,
     /* 235034 */   // Label 3805: @235034
     /* 235034 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(235076), // Rule ID 2709 //
     /* 235039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_u32_u8),
     /* 235044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 235050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 235060 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3070:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (V_MQSAD_U32_U8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, 0:{ *:[i1] })
     /* 235060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_U32_U8_e64),
     /* 235063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 235067 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 235069 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 235071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235074 */     GIR_RootConstrainSelectedInstOperands,
     /* 235075 */     // GIR_Coverage, 2709,
     /* 235075 */     GIR_EraseRootFromParent_Done,
     /* 235076 */   // Label 3806: @235076
     /* 235076 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(235173), // Rule ID 922 //
     /* 235081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 235084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 235089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235126 */     // (intrinsic_wo_chain:{ *:[f32] } 2209:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 235129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235171 */     GIR_RootConstrainSelectedInstOperands,
     /* 235172 */     // GIR_Coverage, 922,
     /* 235172 */     GIR_EraseRootFromParent_Done,
     /* 235173 */   // Label 3807: @235173
     /* 235173 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(235270), // Rule ID 924 //
     /* 235178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 235181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 235186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235223 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 235226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235268 */     GIR_RootConstrainSelectedInstOperands,
     /* 235269 */     // GIR_Coverage, 924,
     /* 235269 */     GIR_EraseRootFromParent_Done,
     /* 235270 */   // Label 3808: @235270
     /* 235270 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(235364), // Rule ID 951 //
     /* 235275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubeid),
     /* 235280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235317 */     // (intrinsic_wo_chain:{ *:[f32] } 2089:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEID_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEID_F32_e64),
     /* 235320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235362 */     GIR_RootConstrainSelectedInstOperands,
     /* 235363 */     // GIR_Coverage, 951,
     /* 235363 */     GIR_EraseRootFromParent_Done,
     /* 235364 */   // Label 3809: @235364
     /* 235364 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(235458), // Rule ID 952 //
     /* 235369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubesc),
     /* 235374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235411 */     // (intrinsic_wo_chain:{ *:[f32] } 2091:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBESC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBESC_F32_e64),
     /* 235414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235456 */     GIR_RootConstrainSelectedInstOperands,
     /* 235457 */     // GIR_Coverage, 952,
     /* 235457 */     GIR_EraseRootFromParent_Done,
     /* 235458 */   // Label 3810: @235458
     /* 235458 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(235552), // Rule ID 953 //
     /* 235463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubetc),
     /* 235468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235505 */     // (intrinsic_wo_chain:{ *:[f32] } 2092:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBETC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBETC_F32_e64),
     /* 235508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235550 */     GIR_RootConstrainSelectedInstOperands,
     /* 235551 */     // GIR_Coverage, 953,
     /* 235551 */     GIR_EraseRootFromParent_Done,
     /* 235552 */   // Label 3811: @235552
     /* 235552 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(235646), // Rule ID 954 //
     /* 235557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubema),
     /* 235562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235599 */     // (intrinsic_wo_chain:{ *:[f32] } 2090:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEMA_F32_e64),
     /* 235602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235644 */     GIR_RootConstrainSelectedInstOperands,
     /* 235645 */     // GIR_Coverage, 954,
     /* 235645 */     GIR_EraseRootFromParent_Done,
     /* 235646 */   // Label 3812: @235646
     /* 235646 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(235740), // Rule ID 971 //
     /* 235651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 235656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235693 */     // (intrinsic_wo_chain:{ *:[f32] } 2210:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 235696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235738 */     GIR_RootConstrainSelectedInstOperands,
     /* 235739 */     // GIR_Coverage, 971,
     /* 235739 */     GIR_EraseRootFromParent_Done,
     /* 235740 */   // Label 3813: @235740
     /* 235740 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(235829), // Rule ID 975 //
     /* 235745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u8_f32),
     /* 235750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235787 */     // (intrinsic_wo_chain:{ *:[i32] } 2101:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CVT_PK_U8_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 235787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U8_F32_e64),
     /* 235790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235827 */     GIR_RootConstrainSelectedInstOperands,
     /* 235828 */     // GIR_Coverage, 975,
     /* 235828 */     GIR_EraseRootFromParent_Done,
     /* 235829 */   // Label 3814: @235829
     /* 235829 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(235923), // Rule ID 976 //
     /* 235834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 235839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235876 */     // (intrinsic_wo_chain:{ *:[f32] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F32_e64),
     /* 235879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235921 */     GIR_RootConstrainSelectedInstOperands,
     /* 235922 */     // GIR_Coverage, 976,
     /* 235922 */     GIR_EraseRootFromParent_Done,
     /* 235923 */   // Label 3815: @235923
     /* 235923 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(236017), // Rule ID 978 //
     /* 235928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 235933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 235936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 235939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 235942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 235945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235970 */     // (intrinsic_wo_chain:{ *:[f64] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F64_e64),
     /* 235973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236015 */     GIR_RootConstrainSelectedInstOperands,
     /* 236016 */     // GIR_Coverage, 978,
     /* 236016 */     GIR_EraseRootFromParent_Done,
     /* 236017 */   // Label 3816: @236017
     /* 236017 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(236114), // Rule ID 997 //
     /* 236022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 236025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236067 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_e64),
     /* 236070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236112 */     GIR_RootConstrainSelectedInstOperands,
     /* 236113 */     // GIR_Coverage, 997,
     /* 236113 */     GIR_EraseRootFromParent_Done,
     /* 236114 */   // Label 3817: @236114
     /* 236114 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(236211), // Rule ID 1014 //
     /* 236119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 236122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 236127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236164 */     // (intrinsic_wo_chain:{ *:[f16] } 2209:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 236167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236209 */     GIR_RootConstrainSelectedInstOperands,
     /* 236210 */     // GIR_Coverage, 1014,
     /* 236210 */     GIR_EraseRootFromParent_Done,
     /* 236211 */   // Label 3818: @236211
     /* 236211 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(236308), // Rule ID 8455 //
     /* 236216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 236219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 236224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 236236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236261 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 236264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 236271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 236276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 236281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 236286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 236301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 236306 */     GIR_RootConstrainSelectedInstOperands,
     /* 236307 */     // GIR_Coverage, 8455,
     /* 236307 */     GIR_EraseRootFromParent_Done,
     /* 236308 */   // Label 3819: @236308
     /* 236308 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(236404), // Rule ID 1001 //
     /* 236313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 236316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236358 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_e64),
     /* 236361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236402 */     GIR_RootConstrainSelectedInstOperands,
     /* 236403 */     // GIR_Coverage, 1001,
     /* 236403 */     GIR_EraseRootFromParent_Done,
     /* 236404 */   // Label 3820: @236404
     /* 236404 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(236500), // Rule ID 1003 //
     /* 236409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 236412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 236433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236454 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_t16_e64),
     /* 236457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236498 */     GIR_RootConstrainSelectedInstOperands,
     /* 236499 */     // GIR_Coverage, 1003,
     /* 236499 */     GIR_EraseRootFromParent_Done,
     /* 236500 */   // Label 3821: @236500
     /* 236500 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(236596), // Rule ID 1005 //
     /* 236505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 236508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236550 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_fake16_e64),
     /* 236553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236594 */     GIR_RootConstrainSelectedInstOperands,
     /* 236595 */     // GIR_Coverage, 1005,
     /* 236595 */     GIR_EraseRootFromParent_Done,
     /* 236596 */   // Label 3822: @236596
     /* 236596 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(236692), // Rule ID 1018 //
     /* 236601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 236604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236646 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 236649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236690 */     GIR_RootConstrainSelectedInstOperands,
     /* 236691 */     // GIR_Coverage, 1018,
     /* 236691 */     GIR_EraseRootFromParent_Done,
     /* 236692 */   // Label 3823: @236692
     /* 236692 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(236788), // Rule ID 1020 //
     /* 236697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 236700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 236721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236742 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 236745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236786 */     GIR_RootConstrainSelectedInstOperands,
     /* 236787 */     // GIR_Coverage, 1020,
     /* 236787 */     GIR_EraseRootFromParent_Done,
     /* 236788 */   // Label 3824: @236788
     /* 236788 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(236884), // Rule ID 1022 //
     /* 236793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 236796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236838 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 236841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236882 */     GIR_RootConstrainSelectedInstOperands,
     /* 236883 */     // GIR_Coverage, 1022,
     /* 236883 */     GIR_EraseRootFromParent_Done,
     /* 236884 */   // Label 3825: @236884
     /* 236884 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(236974), // Rule ID 1072 //
     /* 236889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_NotHasTrue16BitInsts),
     /* 236892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 236897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 236903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 236906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236934 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_e64),
     /* 236937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236972 */     GIR_RootConstrainSelectedInstOperands,
     /* 236973 */     // GIR_Coverage, 1072,
     /* 236973 */     GIR_EraseRootFromParent_Done,
     /* 236974 */   // Label 3826: @236974
     /* 236974 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(237064), // Rule ID 1073 //
     /* 236979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseRealTrue16Insts),
     /* 236982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 236987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 236993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 236996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 237003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237024 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 237024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_t16_e64),
     /* 237027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237062 */     GIR_RootConstrainSelectedInstOperands,
     /* 237063 */     // GIR_Coverage, 1073,
     /* 237063 */     GIR_EraseRootFromParent_Done,
     /* 237064 */   // Label 3827: @237064
     /* 237064 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(237154), // Rule ID 1074 //
     /* 237069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseFakeTrue16Insts),
     /* 237072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 237077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 237080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 237083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 237086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 237089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237114 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 237114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_fake16_e64),
     /* 237117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237152 */     GIR_RootConstrainSelectedInstOperands,
     /* 237153 */     // GIR_Coverage, 1074,
     /* 237153 */     GIR_EraseRootFromParent_Done,
     /* 237154 */   // Label 3828: @237154
     /* 237154 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(237244), // Rule ID 1085 //
     /* 237159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 237162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_i8_i32),
     /* 237167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 237170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237204 */     // (intrinsic_wo_chain:{ *:[i16] } 2078:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 237204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /* 237207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237242 */     GIR_RootConstrainSelectedInstOperands,
     /* 237243 */     // GIR_Coverage, 1085,
     /* 237243 */     GIR_EraseRootFromParent_Done,
     /* 237244 */   // Label 3829: @237244
     /* 237244 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(237334), // Rule ID 1086 //
     /* 237249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 237252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_u8_i32),
     /* 237257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 237260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237294 */     // (intrinsic_wo_chain:{ *:[i16] } 2079:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 237294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /* 237297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237332 */     GIR_RootConstrainSelectedInstOperands,
     /* 237333 */     // GIR_Coverage, 1086,
     /* 237333 */     GIR_EraseRootFromParent_Done,
     /* 237334 */   // Label 3830: @237334
     /* 237334 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(237383), // Rule ID 927 //
     /* 237339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lerp),
     /* 237344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237367 */     // (intrinsic_wo_chain:{ *:[i32] } 3012:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_LERP_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LERP_U8_e64),
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237377 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237379 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237381 */     GIR_RootConstrainSelectedInstOperands,
     /* 237382 */     // GIR_Coverage, 927,
     /* 237382 */     GIR_EraseRootFromParent_Done,
     /* 237383 */   // Label 3831: @237383
     /* 237383 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(237432), // Rule ID 955 //
     /* 237388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ubfe),
     /* 237393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237416 */     // (intrinsic_wo_chain:{ *:[i32] } 3300:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /* 237419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237426 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237428 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237430 */     GIR_RootConstrainSelectedInstOperands,
     /* 237431 */     // GIR_Coverage, 955,
     /* 237431 */     GIR_EraseRootFromParent_Done,
     /* 237432 */   // Label 3832: @237432
     /* 237432 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(237481), // Rule ID 957 //
     /* 237437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sbfe),
     /* 237442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237465 */     // (intrinsic_wo_chain:{ *:[i32] } 3194:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 237468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237477 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237479 */     GIR_RootConstrainSelectedInstOperands,
     /* 237480 */     // GIR_Coverage, 957,
     /* 237480 */     GIR_EraseRootFromParent_Done,
     /* 237481 */   // Label 3833: @237481
     /* 237481 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(237530), // Rule ID 962 //
     /* 237486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 237491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237514 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBYTE_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_e64),
     /* 237517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237526 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237528 */     GIR_RootConstrainSelectedInstOperands,
     /* 237529 */     // GIR_Coverage, 962,
     /* 237529 */     GIR_EraseRootFromParent_Done,
     /* 237530 */   // Label 3834: @237530
     /* 237530 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(237582), // Rule ID 995 //
     /* 237535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 237538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_perm),
     /* 237543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237566 */     // (intrinsic_wo_chain:{ *:[i32] } 3076:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_PERM_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 237569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237580 */     GIR_RootConstrainSelectedInstOperands,
     /* 237581 */     // GIR_Coverage, 995,
     /* 237581 */     GIR_EraseRootFromParent_Done,
     /* 237582 */   // Label 3835: @237582
     /* 237582 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(237634), // Rule ID 1060 //
     /* 237587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f16),
     /* 237595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 237601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237618 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2149:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F16_e64),
     /* 237621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237630 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237632 */     GIR_RootConstrainSelectedInstOperands,
     /* 237633 */     // GIR_Coverage, 1060,
     /* 237633 */     GIR_EraseRootFromParent_Done,
     /* 237634 */   // Label 3836: @237634
     /* 237634 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(237686), // Rule ID 1061 //
     /* 237639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f32),
     /* 237647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 237653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237670 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2150:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F32_e64),
     /* 237673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237680 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237682 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237684 */     GIR_RootConstrainSelectedInstOperands,
     /* 237685 */     // GIR_Coverage, 1061,
     /* 237685 */     GIR_EraseRootFromParent_Done,
     /* 237686 */   // Label 3837: @237686
     /* 237686 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(237738), // Rule ID 1062 //
     /* 237691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f16),
     /* 237699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 237705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237722 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2152:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F16_e64),
     /* 237725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237732 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237734 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237736 */     GIR_RootConstrainSelectedInstOperands,
     /* 237737 */     // GIR_Coverage, 1062,
     /* 237737 */     GIR_EraseRootFromParent_Done,
     /* 237738 */   // Label 3838: @237738
     /* 237738 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(237790), // Rule ID 1063 //
     /* 237743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f32),
     /* 237751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 237757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237774 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2153:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F32_e64),
     /* 237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237784 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237786 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237788 */     GIR_RootConstrainSelectedInstOperands,
     /* 237789 */     // GIR_Coverage, 1063,
     /* 237789 */     GIR_EraseRootFromParent_Done,
     /* 237790 */   // Label 3839: @237790
     /* 237790 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(237842), // Rule ID 1064 //
     /* 237795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 237798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_fp6_f32),
     /* 237803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 237809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 237812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237826 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2106:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_FP6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_FP6_F32_e64),
     /* 237829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237840 */     GIR_RootConstrainSelectedInstOperands,
     /* 237841 */     // GIR_Coverage, 1064,
     /* 237841 */     GIR_EraseRootFromParent_Done,
     /* 237842 */   // Label 3840: @237842
     /* 237842 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(237894), // Rule ID 1065 //
     /* 237847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 237850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_bf6_f32),
     /* 237855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 237861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 237864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237878 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2105:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_BF6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_BF6_F32_e64),
     /* 237881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237888 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237890 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237892 */     GIR_RootConstrainSelectedInstOperands,
     /* 237893 */     // GIR_Coverage, 1065,
     /* 237893 */     GIR_EraseRootFromParent_Done,
     /* 237894 */   // Label 3841: @237894
     /* 237894 */   GIM_Reject,
     /* 237895 */ // Label 3778: @237895
     /* 237895 */ GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(242880),
     /* 237900 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 237903 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(237956), // Rule ID 2515 //
     /* 237908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot5Insts),
     /* 237911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 237916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 237922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 237925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237932 */     // MIs[0] Operand 5
     /* 237932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237943 */     // (intrinsic_wo_chain:{ *:[f32] } 2201:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, v2f16:{ *:[v2f16] }:$src1, f32:{ *:[f32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_F32_F16_e32:{ *:[f32] } ?:{ *:[v2f16] }:$src0, ?:{ *:[v2f16] }:$src1, ?:{ *:[f32] }:$src2)
     /* 237943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_F32_F16_e32),
     /* 237946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237950 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237952 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237954 */     GIR_RootConstrainSelectedInstOperands,
     /* 237955 */     // GIR_Coverage, 2515,
     /* 237955 */     GIR_EraseRootFromParent_Done,
     /* 237956 */   // Label 3843: @237956
     /* 237956 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(238009), // Rule ID 2517 //
     /* 237961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot6Insts),
     /* 237964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 237969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237985 */     // MIs[0] Operand 5
     /* 237985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237996 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT4C_I32_I8_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 237996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4C_I32_I8_e32),
     /* 237999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238005 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238007 */     GIR_RootConstrainSelectedInstOperands,
     /* 238008 */     // GIR_Coverage, 2517,
     /* 238008 */     GIR_EraseRootFromParent_Done,
     /* 238009 */   // Label 3844: @238009
     /* 238009 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(238062), // Rule ID 2518 //
     /* 238014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot4Insts),
     /* 238017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 238022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 238028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 238031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238038 */     // MIs[0] Operand 5
     /* 238038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238049 */     // (intrinsic_wo_chain:{ *:[i32] } 3197:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_I32_I16_e32:{ *:[i32] } ?:{ *:[v2i16] }:$src0, ?:{ *:[v2i16] }:$src1, ?:{ *:[i32] }:$src2)
     /* 238049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_I32_I16_e32),
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238056 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238058 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238060 */     GIR_RootConstrainSelectedInstOperands,
     /* 238061 */     // GIR_Coverage, 2518,
     /* 238061 */     GIR_EraseRootFromParent_Done,
     /* 238062 */   // Label 3845: @238062
     /* 238062 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(238115), // Rule ID 2519 //
     /* 238067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot3Insts),
     /* 238070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 238075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238091 */     // MIs[0] Operand 5
     /* 238091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238102 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT8C_I32_I4_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 238102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8C_I32_I4_e32),
     /* 238105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238111 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238113 */     GIR_RootConstrainSelectedInstOperands,
     /* 238114 */     // GIR_Coverage, 2519,
     /* 238114 */     GIR_EraseRootFromParent_Done,
     /* 238115 */   // Label 3846: @238115
     /* 238115 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(238222), // Rule ID 6916 //
     /* 238120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 238123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238144 */     // MIs[0] Operand 5
     /* 238144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238176 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 238179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 238191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238220 */     GIR_RootConstrainSelectedInstOperands,
     /* 238221 */     // GIR_Coverage, 6916,
     /* 238221 */     GIR_EraseRootFromParent_Done,
     /* 238222 */   // Label 3847: @238222
     /* 238222 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(238329), // Rule ID 6917 //
     /* 238227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 238230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238251 */     // MIs[0] Operand 5
     /* 238251 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 238269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 238283 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 238286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 238298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238327 */     GIR_RootConstrainSelectedInstOperands,
     /* 238328 */     // GIR_Coverage, 6917,
     /* 238328 */     GIR_EraseRootFromParent_Done,
     /* 238329 */   // Label 3848: @238329
     /* 238329 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(238490), // Rule ID 6918 //
     /* 238334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238358 */     // MIs[0] Operand 5
     /* 238358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238390 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238402 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 238409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238414 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238431 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 238438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 238451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238488 */     GIR_RootConstrainSelectedInstOperands,
     /* 238489 */     // GIR_Coverage, 6918,
     /* 238489 */     GIR_EraseRootFromParent_Done,
     /* 238490 */   // Label 3849: @238490
     /* 238490 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(238651), // Rule ID 6919 //
     /* 238495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238519 */     // MIs[0] Operand 5
     /* 238519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238551 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238563 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 238570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238592 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 238599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 238612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238649 */     GIR_RootConstrainSelectedInstOperands,
     /* 238650 */     // GIR_Coverage, 6919,
     /* 238650 */     GIR_EraseRootFromParent_Done,
     /* 238651 */   // Label 3850: @238651
     /* 238651 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(238785), // Rule ID 6922 //
     /* 238656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 238664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 238667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238680 */     // MIs[0] Operand 5
     /* 238680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238712 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238724 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 238731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 238744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238783 */     GIR_RootConstrainSelectedInstOperands,
     /* 238784 */     // GIR_Coverage, 6922,
     /* 238784 */     GIR_EraseRootFromParent_Done,
     /* 238785 */   // Label 3851: @238785
     /* 238785 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(238919), // Rule ID 6923 //
     /* 238790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 238798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 238801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238814 */     // MIs[0] Operand 5
     /* 238814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238846 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238858 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 238865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 238878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238917 */     GIR_RootConstrainSelectedInstOperands,
     /* 238918 */     // GIR_Coverage, 6923,
     /* 238918 */     GIR_EraseRootFromParent_Done,
     /* 238919 */   // Label 3852: @238919
     /* 238919 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(239080), // Rule ID 6924 //
     /* 238924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 238932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238948 */     // MIs[0] Operand 5
     /* 238948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238980 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238980 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238983 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238987 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238992 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 238999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239021 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 239028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 239041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 239069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239078 */     GIR_RootConstrainSelectedInstOperands,
     /* 239079 */     // GIR_Coverage, 6924,
     /* 239079 */     GIR_EraseRootFromParent_Done,
     /* 239080 */   // Label 3853: @239080
     /* 239080 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(239241), // Rule ID 6925 //
     /* 239085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 239088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 239093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239109 */     // MIs[0] Operand 5
     /* 239109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239141 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 239144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239153 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 239160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239182 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 239189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 239202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 239230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239239 */     GIR_RootConstrainSelectedInstOperands,
     /* 239240 */     // GIR_Coverage, 6925,
     /* 239240 */     GIR_EraseRootFromParent_Done,
     /* 239241 */   // Label 3854: @239241
     /* 239241 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(239375), // Rule ID 6926 //
     /* 239246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 239249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239270 */     // MIs[0] Operand 5
     /* 239270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239302 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239314 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 239321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 239334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239373 */     GIR_RootConstrainSelectedInstOperands,
     /* 239374 */     // GIR_Coverage, 6926,
     /* 239374 */     GIR_EraseRootFromParent_Done,
     /* 239375 */   // Label 3855: @239375
     /* 239375 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(239509), // Rule ID 6927 //
     /* 239380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 239383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239404 */     // MIs[0] Operand 5
     /* 239404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239436 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239448 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 239455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 239468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239507 */     GIR_RootConstrainSelectedInstOperands,
     /* 239508 */     // GIR_Coverage, 6927,
     /* 239508 */     GIR_EraseRootFromParent_Done,
     /* 239509 */   // Label 3856: @239509
     /* 239509 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(239616), // Rule ID 6928 //
     /* 239514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 239522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239538 */     // MIs[0] Operand 5
     /* 239538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239570 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 239573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239614 */     GIR_RootConstrainSelectedInstOperands,
     /* 239615 */     // GIR_Coverage, 6928,
     /* 239615 */     GIR_EraseRootFromParent_Done,
     /* 239616 */   // Label 3857: @239616
     /* 239616 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(239723), // Rule ID 6929 //
     /* 239621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 239629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239645 */     // MIs[0] Operand 5
     /* 239645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239677 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 239680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239721 */     GIR_RootConstrainSelectedInstOperands,
     /* 239722 */     // GIR_Coverage, 6929,
     /* 239722 */     GIR_EraseRootFromParent_Done,
     /* 239723 */   // Label 3858: @239723
     /* 239723 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(239830), // Rule ID 6930 //
     /* 239728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 239736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239752 */     // MIs[0] Operand 5
     /* 239752 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239784 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 239787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239828 */     GIR_RootConstrainSelectedInstOperands,
     /* 239829 */     // GIR_Coverage, 6930,
     /* 239829 */     GIR_EraseRootFromParent_Done,
     /* 239830 */   // Label 3859: @239830
     /* 239830 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(239937), // Rule ID 6931 //
     /* 239835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 239843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239859 */     // MIs[0] Operand 5
     /* 239859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239891 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239935 */     GIR_RootConstrainSelectedInstOperands,
     /* 239936 */     // GIR_Coverage, 6931,
     /* 239936 */     GIR_EraseRootFromParent_Done,
     /* 239937 */   // Label 3860: @239937
     /* 239937 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(240044), // Rule ID 6932 //
     /* 239942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239966 */     // MIs[0] Operand 5
     /* 239966 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239998 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 240001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 240042 */     GIR_RootConstrainSelectedInstOperands,
     /* 240043 */     // GIR_Coverage, 6932,
     /* 240043 */     GIR_EraseRootFromParent_Done,
     /* 240044 */   // Label 3861: @240044
     /* 240044 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(240151), // Rule ID 6933 //
     /* 240049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 240052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 240057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240073 */     // MIs[0] Operand 5
     /* 240073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 240084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 240091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 240098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 240105 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 240105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 240108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 240149 */     GIR_RootConstrainSelectedInstOperands,
     /* 240150 */     // GIR_Coverage, 6933,
     /* 240150 */     GIR_EraseRootFromParent_Done,
     /* 240151 */   // Label 3862: @240151
     /* 240151 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(240265), // Rule ID 2680 //
     /* 240156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 240159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 240187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240208 */     // (intrinsic_wo_chain:{ *:[f32] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 240208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 240222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 240225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240263 */     GIR_RootConstrainSelectedInstOperands,
     /* 240264 */     // GIR_Coverage, 2680,
     /* 240264 */     GIR_EraseRootFromParent_Done,
     /* 240265 */   // Label 3863: @240265
     /* 240265 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(240379), // Rule ID 2682 //
     /* 240270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 240273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 240281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 240284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 240287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 240290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 240297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 240301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240322 */     // (intrinsic_wo_chain:{ *:[f64] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 240322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240326 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 240336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 240339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240377 */     GIR_RootConstrainSelectedInstOperands,
     /* 240378 */     // GIR_Coverage, 2682,
     /* 240378 */     GIR_EraseRootFromParent_Done,
     /* 240379 */   // Label 3864: @240379
     /* 240379 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(240493), // Rule ID 2684 //
     /* 240384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 240387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 240415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240436 */     // (intrinsic_wo_chain:{ *:[f32] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 240436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240440 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 240450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 240453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240491 */     GIR_RootConstrainSelectedInstOperands,
     /* 240492 */     // GIR_Coverage, 2684,
     /* 240492 */     GIR_EraseRootFromParent_Done,
     /* 240493 */   // Label 3865: @240493
     /* 240493 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(240607), // Rule ID 2686 //
     /* 240498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 240501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 240509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 240512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 240515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 240518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 240525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 240529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240550 */     // (intrinsic_wo_chain:{ *:[f64] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 240550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240554 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 240564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 240567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240605 */     GIR_RootConstrainSelectedInstOperands,
     /* 240606 */     // GIR_Coverage, 2686,
     /* 240606 */     GIR_EraseRootFromParent_Done,
     /* 240607 */   // Label 3866: @240607
     /* 240607 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(240688), // Rule ID 2587 //
     /* 240612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 240615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 240620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240636 */     // MIs[0] byte_sel
     /* 240636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240653 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_FP8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 240653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_gfx12_e64),
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240678 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 240686 */     GIR_RootConstrainSelectedInstOperands,
     /* 240687 */     // GIR_Coverage, 2587,
     /* 240687 */     GIR_EraseRootFromParent_Done,
     /* 240688 */   // Label 3867: @240688
     /* 240688 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(240769), // Rule ID 2588 //
     /* 240693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 240696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 240701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240717 */     // MIs[0] byte_sel
     /* 240717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240734 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_BF8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 240734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_gfx12_e64),
     /* 240737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240759 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 240767 */     GIR_RootConstrainSelectedInstOperands,
     /* 240768 */     // GIR_Coverage, 2588,
     /* 240768 */     GIR_EraseRootFromParent_Done,
     /* 240769 */   // Label 3868: @240769
     /* 240769 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(240832), // Rule ID 1330 //
     /* 240774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 240777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_mov),
     /* 240782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240792 */     // MIs[0] vsrc
     /* 240792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 240795 */     // MIs[0] attrchan
     /* 240795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240798 */     // MIs[0] attr
     /* 240798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240805 */     // (intrinsic_wo_chain:{ *:[f32] } 2997:{ *:[iPTR] }, (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_MOV_F32:{ *:[f32] } (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240809 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_MOV_F32),
     /* 240822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240824 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240826 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240828 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240830 */     GIR_RootConstrainSelectedInstOperands,
     /* 240831 */     // GIR_Coverage, 1330,
     /* 240831 */     GIR_EraseRootFromParent_Done,
     /* 240832 */   // Label 3869: @240832
     /* 240832 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(240895), // Rule ID 1327 //
     /* 240837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has32BankLDS_isNotGFX90APlus),
     /* 240840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 240845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240858 */     // MIs[0] attrchan
     /* 240858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240861 */     // MIs[0] attr
     /* 240861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240868 */     // (intrinsic_wo_chain:{ *:[f32] } 2998:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240872 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32),
     /* 240885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240887 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240889 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240891 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240893 */     GIR_RootConstrainSelectedInstOperands,
     /* 240894 */     // GIR_Coverage, 1327,
     /* 240894 */     GIR_EraseRootFromParent_Done,
     /* 240895 */   // Label 3870: @240895
     /* 240895 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(240958), // Rule ID 1328 //
     /* 240900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has16BankLDS_isNotGFX90APlus),
     /* 240903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 240908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240921 */     // MIs[0] attrchan
     /* 240921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240924 */     // MIs[0] attr
     /* 240924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240931 */     // (intrinsic_wo_chain:{ *:[f32] } 2998:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32_16bank:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240935 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32_16bank),
     /* 240948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240950 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240952 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240954 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240956 */     GIR_RootConstrainSelectedInstOperands,
     /* 240957 */     // GIR_Coverage, 1328,
     /* 240957 */     GIR_EraseRootFromParent_Done,
     /* 240958 */   // Label 3871: @240958
     /* 240958 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(241020), // Rule ID 2575 //
     /* 240963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 240966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 240971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240987 */     // MIs[0] Operand 5
     /* 240987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 240998 */     // (intrinsic_wo_chain:{ *:[i32] } 2098:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 241001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241011 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241013 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241018 */     GIR_RootConstrainSelectedInstOperands,
     /* 241019 */     // GIR_Coverage, 2575,
     /* 241019 */     GIR_EraseRootFromParent_Done,
     /* 241020 */   // Label 3872: @241020
     /* 241020 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(241082), // Rule ID 2576 //
     /* 241025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 241028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 241033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241049 */     // MIs[0] Operand 5
     /* 241049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241060 */     // (intrinsic_wo_chain:{ *:[i32] } 2095:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 241063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241073 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241075 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241080 */     GIR_RootConstrainSelectedInstOperands,
     /* 241081 */     // GIR_Coverage, 2576,
     /* 241081 */     GIR_EraseRootFromParent_Done,
     /* 241082 */   // Label 3873: @241082
     /* 241082 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(241144), // Rule ID 2577 //
     /* 241087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 241090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 241095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241111 */     // MIs[0] Operand 5
     /* 241111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 241122 */     // (intrinsic_wo_chain:{ *:[i32] } 2098:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 241125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241135 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241137 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241142 */     GIR_RootConstrainSelectedInstOperands,
     /* 241143 */     // GIR_Coverage, 2577,
     /* 241143 */     GIR_EraseRootFromParent_Done,
     /* 241144 */   // Label 3874: @241144
     /* 241144 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(241206), // Rule ID 2578 //
     /* 241149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 241152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 241157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241173 */     // MIs[0] Operand 5
     /* 241173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 241184 */     // (intrinsic_wo_chain:{ *:[i32] } 2095:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 241187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241199 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241204 */     GIR_RootConstrainSelectedInstOperands,
     /* 241205 */     // GIR_Coverage, 2578,
     /* 241205 */     GIR_EraseRootFromParent_Done,
     /* 241206 */   // Label 3875: @241206
     /* 241206 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(241271), // Rule ID 2579 //
     /* 241211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241235 */     // MIs[0] Operand 5
     /* 241235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241246 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241259 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241264 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241269 */     GIR_RootConstrainSelectedInstOperands,
     /* 241270 */     // GIR_Coverage, 2579,
     /* 241270 */     GIR_EraseRootFromParent_Done,
     /* 241271 */   // Label 3876: @241271
     /* 241271 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(241336), // Rule ID 2580 //
     /* 241276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241300 */     // MIs[0] Operand 5
     /* 241300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241311 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241319 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241324 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241329 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241334 */     GIR_RootConstrainSelectedInstOperands,
     /* 241335 */     // GIR_Coverage, 2580,
     /* 241335 */     GIR_EraseRootFromParent_Done,
     /* 241336 */   // Label 3877: @241336
     /* 241336 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(241401), // Rule ID 2581 //
     /* 241341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241365 */     // MIs[0] Operand 5
     /* 241365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 241376 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241394 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241399 */     GIR_RootConstrainSelectedInstOperands,
     /* 241400 */     // GIR_Coverage, 2581,
     /* 241400 */     GIR_EraseRootFromParent_Done,
     /* 241401 */   // Label 3878: @241401
     /* 241401 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(241466), // Rule ID 2582 //
     /* 241406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241430 */     // MIs[0] Operand 5
     /* 241430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 241441 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241454 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241459 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241464 */     GIR_RootConstrainSelectedInstOperands,
     /* 241465 */     // GIR_Coverage, 2582,
     /* 241465 */     GIR_EraseRootFromParent_Done,
     /* 241466 */   // Label 3879: @241466
     /* 241466 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(241531), // Rule ID 2583 //
     /* 241471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241495 */     // MIs[0] Operand 5
     /* 241495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 241506 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241519 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241524 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241529 */     GIR_RootConstrainSelectedInstOperands,
     /* 241530 */     // GIR_Coverage, 2583,
     /* 241530 */     GIR_EraseRootFromParent_Done,
     /* 241531 */   // Label 3880: @241531
     /* 241531 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(241596), // Rule ID 2584 //
     /* 241536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241560 */     // MIs[0] Operand 5
     /* 241560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 241571 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241584 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241589 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241594 */     GIR_RootConstrainSelectedInstOperands,
     /* 241595 */     // GIR_Coverage, 2584,
     /* 241595 */     GIR_EraseRootFromParent_Done,
     /* 241596 */   // Label 3881: @241596
     /* 241596 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(241661), // Rule ID 2585 //
     /* 241601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241625 */     // MIs[0] Operand 5
     /* 241625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 241636 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241654 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241659 */     GIR_RootConstrainSelectedInstOperands,
     /* 241660 */     // GIR_Coverage, 2585,
     /* 241660 */     GIR_EraseRootFromParent_Done,
     /* 241661 */   // Label 3882: @241661
     /* 241661 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(241726), // Rule ID 2586 //
     /* 241666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241690 */     // MIs[0] Operand 5
     /* 241690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 241701 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241714 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241719 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241724 */     GIR_RootConstrainSelectedInstOperands,
     /* 241725 */     // GIR_Coverage, 2586,
     /* 241725 */     GIR_EraseRootFromParent_Done,
     /* 241726 */   // Label 3883: @241726
     /* 241726 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(241780), // Rule ID 2637 //
     /* 241731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f16),
     /* 241736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241752 */     // MIs[0] word_sel
     /* 241752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241755 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2127:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 241755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F16_e64),
     /* 241758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241766 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241771 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241773 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241778 */     GIR_RootConstrainSelectedInstOperands,
     /* 241779 */     // GIR_Coverage, 2637,
     /* 241779 */     GIR_EraseRootFromParent_Done,
     /* 241780 */   // Label 3884: @241780
     /* 241780 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(241834), // Rule ID 2638 //
     /* 241785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f16),
     /* 241790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241806 */     // MIs[0] word_sel
     /* 241806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241809 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2115:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 241809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F16_e64),
     /* 241812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241820 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241825 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241827 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241832 */     GIR_RootConstrainSelectedInstOperands,
     /* 241833 */     // GIR_Coverage, 2638,
     /* 241833 */     GIR_EraseRootFromParent_Done,
     /* 241834 */   // Label 3885: @241834
     /* 241834 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(241894), // Rule ID 2641 //
     /* 241839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f16),
     /* 241844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241860 */     // MIs[0] index
     /* 241860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241863 */     // (intrinsic_wo_chain:{ *:[i32] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$src2, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src2)
     /* 241863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F16_e64),
     /* 241866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 241874 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241879 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 241887 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 241889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241892 */     GIR_RootConstrainSelectedInstOperands,
     /* 241893 */     // GIR_Coverage, 2641,
     /* 241893 */     GIR_EraseRootFromParent_Done,
     /* 241894 */   // Label 3886: @241894
     /* 241894 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(241951), // Rule ID 2688 //
     /* 241899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF32ToF16BF16ConversionSRInsts),
     /* 241902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_f16_f32),
     /* 241907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241923 */     // MIs[0] word_sel
     /* 241923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241926 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2156:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SR_F16_F32_e64:{ *:[v2f16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 241926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_F16_F32_e64),
     /* 241929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241942 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241944 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241949 */     GIR_RootConstrainSelectedInstOperands,
     /* 241950 */     // GIR_Coverage, 2688,
     /* 241950 */     GIR_EraseRootFromParent_Done,
     /* 241951 */   // Label 3887: @241951
     /* 241951 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(242013), // Rule ID 2748 //
     /* 241956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 241959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 241964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241980 */     // MIs[0] clamp
     /* 241980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241983 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 241983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 241986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241996 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 242001 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 242003 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242011 */     GIR_RootConstrainSelectedInstOperands,
     /* 242012 */     // GIR_Coverage, 2748,
     /* 242012 */     GIR_EraseRootFromParent_Done,
     /* 242013 */   // Label 3888: @242013
     /* 242013 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(242075), // Rule ID 2749 //
     /* 242018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 242021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 242026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242042 */     // MIs[0] clamp
     /* 242042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242045 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 242045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 242048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 242053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 242055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 242058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 242060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 242063 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 242065 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242073 */     GIR_RootConstrainSelectedInstOperands,
     /* 242074 */     // GIR_Coverage, 2749,
     /* 242074 */     GIR_EraseRootFromParent_Done,
     /* 242075 */   // Label 3889: @242075
     /* 242075 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(242119), // Rule ID 2676 //
     /* 242080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 242083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 242088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242104 */     // MIs[0] bitop3
     /* 242104 */     // No operand predicates
     /* 242104 */     // (intrinsic_wo_chain:{ *:[i32] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2, (timm:{ *:[i32] }):$bitop3)
     /* 242104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B32_e64),
     /* 242107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242109 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 242111 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 242113 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 242115 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 242117 */     GIR_RootConstrainSelectedInstOperands,
     /* 242118 */     // GIR_Coverage, 2676,
     /* 242118 */     GIR_EraseRootFromParent_Done,
     /* 242119 */   // Label 3890: @242119
     /* 242119 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(242175), // Rule ID 2677 //
     /* 242124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 242127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 242132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 242135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 242138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 242141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 242144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242148 */     // MIs[0] bitop3
     /* 242148 */     // No operand predicates
     /* 242148 */     // (intrinsic_wo_chain:{ *:[i16] } 2082:{ *:[iPTR] }, i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, (timm:{ *:[i32] }):$bitop3, 0:{ *:[i32] })
     /* 242148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B16_e64),
     /* 242151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 242158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242161 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 242163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242166 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 242168 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 242170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242173 */     GIR_RootConstrainSelectedInstOperands,
     /* 242174 */     // GIR_Coverage, 2677,
     /* 242174 */     GIR_EraseRootFromParent_Done,
     /* 242175 */   // Label 3891: @242175
     /* 242175 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(242279), // Rule ID 1115 //
     /* 242180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 242183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 242188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 242197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242204 */     // MIs[0] clamp
     /* 242204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242228 */     // (intrinsic_wo_chain:{ *:[i32] } 3197:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_I32_I16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /* 242231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242263 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242277 */     GIR_RootConstrainSelectedInstOperands,
     /* 242278 */     // GIR_Coverage, 1115,
     /* 242278 */     GIR_EraseRootFromParent_Done,
     /* 242279 */   // Label 3892: @242279
     /* 242279 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(242383), // Rule ID 1116 //
     /* 242284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 242287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot2),
     /* 242292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 242301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242308 */     // MIs[0] clamp
     /* 242308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242332 */     // (intrinsic_wo_chain:{ *:[i32] } 3301:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_U32_U16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /* 242335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242367 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242381 */     GIR_RootConstrainSelectedInstOperands,
     /* 242382 */     // GIR_Coverage, 1116,
     /* 242382 */     GIR_EraseRootFromParent_Done,
     /* 242383 */   // Label 3893: @242383
     /* 242383 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(242487), // Rule ID 1117 //
     /* 242388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot10Insts),
     /* 242391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 242396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 242405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242412 */     // MIs[0] clamp
     /* 242412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242436 */     // (intrinsic_wo_chain:{ *:[f32] } 2201:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_F32_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F32_F16),
     /* 242439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242471 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242485 */     GIR_RootConstrainSelectedInstOperands,
     /* 242486 */     // GIR_Coverage, 1117,
     /* 242486 */     GIR_EraseRootFromParent_Done,
     /* 242487 */   // Label 3894: @242487
     /* 242487 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(242585), // Rule ID 1119 //
     /* 242492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 242495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot4),
     /* 242500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242516 */     // MIs[0] clamp
     /* 242516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242540 */     // (intrinsic_wo_chain:{ *:[i32] } 3302:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_U32_U8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /* 242543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242575 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242583 */     GIR_RootConstrainSelectedInstOperands,
     /* 242584 */     // GIR_Coverage, 1119,
     /* 242584 */     GIR_EraseRootFromParent_Done,
     /* 242585 */   // Label 3895: @242585
     /* 242585 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(242683), // Rule ID 1120 //
     /* 242590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 242593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot8),
     /* 242598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242614 */     // MIs[0] clamp
     /* 242614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242638 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_U32_U4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_U32_U4),
     /* 242641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242673 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 242682 */     // GIR_Coverage, 1120,
     /* 242682 */     GIR_EraseRootFromParent_Done,
     /* 242683 */   // Label 3896: @242683
     /* 242683 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(242781), // Rule ID 1121 //
     /* 242688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 242691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 242696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242712 */     // MIs[0] clamp
     /* 242712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242736 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_I8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /* 242739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242771 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242779 */     GIR_RootConstrainSelectedInstOperands,
     /* 242780 */     // GIR_Coverage, 1121,
     /* 242780 */     GIR_EraseRootFromParent_Done,
     /* 242781 */   // Label 3897: @242781
     /* 242781 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(242879), // Rule ID 1122 //
     /* 242786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 242789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 242794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242810 */     // MIs[0] clamp
     /* 242810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242834 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_I4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_I4),
     /* 242837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242869 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242877 */     GIR_RootConstrainSelectedInstOperands,
     /* 242878 */     // GIR_Coverage, 1122,
     /* 242878 */     GIR_EraseRootFromParent_Done,
     /* 242879 */   // Label 3898: @242879
     /* 242879 */   GIM_Reject,
     /* 242880 */ // Label 3842: @242880
     /* 242880 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(243897),
     /* 242885 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 242888 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(242956), // Rule ID 2627 //
     /* 242893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 242898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242914 */     // MIs[0] src_sel
     /* 242914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242917 */     // MIs[0] Operand 6
     /* 242917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 242928 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2108:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 242931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 242939 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 242947 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242949 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242954 */     GIR_RootConstrainSelectedInstOperands,
     /* 242955 */     // GIR_Coverage, 2627,
     /* 242955 */     GIR_EraseRootFromParent_Done,
     /* 242956 */   // Label 3900: @242956
     /* 242956 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(243024), // Rule ID 2628 //
     /* 242961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 242966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242982 */     // MIs[0] src_sel
     /* 242982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242985 */     // MIs[0] Operand 6
     /* 242985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 242996 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2107:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 242999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 243007 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 243015 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243017 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243022 */     GIR_RootConstrainSelectedInstOperands,
     /* 243023 */     // GIR_Coverage, 2628,
     /* 243023 */     GIR_EraseRootFromParent_Done,
     /* 243024 */   // Label 3901: @243024
     /* 243024 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(243092), // Rule ID 2629 //
     /* 243029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 243034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 243037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 243040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243050 */     // MIs[0] src_sel
     /* 243050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243053 */     // MIs[0] Operand 6
     /* 243053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 243064 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2108:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 243064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 243067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 243075 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 243083 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243085 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243090 */     GIR_RootConstrainSelectedInstOperands,
     /* 243091 */     // GIR_Coverage, 2629,
     /* 243091 */     GIR_EraseRootFromParent_Done,
     /* 243092 */   // Label 3902: @243092
     /* 243092 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(243160), // Rule ID 2630 //
     /* 243097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 243102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 243105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 243108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243118 */     // MIs[0] src_sel
     /* 243118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243121 */     // MIs[0] Operand 6
     /* 243121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 243132 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2107:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 243132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 243135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 243143 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 243151 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243153 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243158 */     GIR_RootConstrainSelectedInstOperands,
     /* 243159 */     // GIR_Coverage, 2630,
     /* 243159 */     GIR_EraseRootFromParent_Done,
     /* 243160 */   // Label 3903: @243160
     /* 243160 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(243228), // Rule ID 1329 //
     /* 243165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 243168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2),
     /* 243173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243189 */     // MIs[0] attrchan
     /* 243189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 243192 */     // MIs[0] attr
     /* 243192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243195 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 243199 */     // (intrinsic_wo_chain:{ *:[f32] } 3001:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P2_F32:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 243199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243203 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 243213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32),
     /* 243216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 243220 */     GIR_RootToRootCopy, /*OpIdx*/3, // vsrc
     /* 243222 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 243224 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 243226 */     GIR_RootConstrainSelectedInstOperands,
     /* 243227 */     // GIR_Coverage, 1329,
     /* 243227 */     GIR_EraseRootFromParent_Done,
     /* 243228 */   // Label 3904: @243228
     /* 243228 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(243290), // Rule ID 2631 //
     /* 243233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f32),
     /* 243238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 243241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 243244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243257 */     // MIs[0] word_sel
     /* 243257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243260 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2128:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 243260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F32_e64),
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 243271 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243276 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243281 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243283 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243288 */     GIR_RootConstrainSelectedInstOperands,
     /* 243289 */     // GIR_Coverage, 2631,
     /* 243289 */     GIR_EraseRootFromParent_Done,
     /* 243290 */   // Label 3905: @243290
     /* 243290 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(243352), // Rule ID 2632 //
     /* 243295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f32),
     /* 243300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 243303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 243306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243319 */     // MIs[0] word_sel
     /* 243319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243322 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2116:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 243322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F32_e64),
     /* 243325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 243333 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243338 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243343 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243345 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243350 */     GIR_RootConstrainSelectedInstOperands,
     /* 243351 */     // GIR_Coverage, 2632,
     /* 243351 */     GIR_EraseRootFromParent_Done,
     /* 243352 */   // Label 3906: @243352
     /* 243352 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(243417), // Rule ID 2640 //
     /* 243357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f32),
     /* 243362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243381 */     // MIs[0] index
     /* 243381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243384 */     // (intrinsic_wo_chain:{ *:[i32] } 2125:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F32_e64),
     /* 243387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243389 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243395 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243400 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243408 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243410 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243415 */     GIR_RootConstrainSelectedInstOperands,
     /* 243416 */     // GIR_Coverage, 2640,
     /* 243416 */     GIR_EraseRootFromParent_Done,
     /* 243417 */   // Label 3907: @243417
     /* 243417 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(243482), // Rule ID 2642 //
     /* 243422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f16),
     /* 243427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 243436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243446 */     // MIs[0] index
     /* 243446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243449 */     // (intrinsic_wo_chain:{ *:[i32] } 2146:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F16_e64),
     /* 243452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243460 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243465 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243473 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243475 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243480 */     GIR_RootConstrainSelectedInstOperands,
     /* 243481 */     // GIR_Coverage, 2642,
     /* 243481 */     GIR_EraseRootFromParent_Done,
     /* 243482 */   // Label 3908: @243482
     /* 243482 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(243547), // Rule ID 2643 //
     /* 243487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f32),
     /* 243492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 243501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243511 */     // MIs[0] index
     /* 243511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243514 */     // (intrinsic_wo_chain:{ *:[i32] } 2147:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F32_e64),
     /* 243517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243525 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243530 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243538 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243540 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243545 */     GIR_RootConstrainSelectedInstOperands,
     /* 243546 */     // GIR_Coverage, 2643,
     /* 243546 */     GIR_EraseRootFromParent_Done,
     /* 243547 */   // Label 3909: @243547
     /* 243547 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(243612), // Rule ID 2644 //
     /* 243552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f16),
     /* 243557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 243566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243576 */     // MIs[0] index
     /* 243576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243579 */     // (intrinsic_wo_chain:{ *:[i32] } 2140:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F16_e64),
     /* 243582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243590 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243595 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243603 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243605 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243610 */     GIR_RootConstrainSelectedInstOperands,
     /* 243611 */     // GIR_Coverage, 2644,
     /* 243611 */     GIR_EraseRootFromParent_Done,
     /* 243612 */   // Label 3910: @243612
     /* 243612 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(243677), // Rule ID 2645 //
     /* 243617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f32),
     /* 243622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243641 */     // MIs[0] index
     /* 243641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243644 */     // (intrinsic_wo_chain:{ *:[i32] } 2141:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F32_e64),
     /* 243647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243655 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243660 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243670 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243675 */     GIR_RootConstrainSelectedInstOperands,
     /* 243676 */     // GIR_Coverage, 2645,
     /* 243676 */     GIR_EraseRootFromParent_Done,
     /* 243677 */   // Label 3911: @243677
     /* 243677 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(243742), // Rule ID 2646 //
     /* 243682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f16),
     /* 243687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 243696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243706 */     // MIs[0] index
     /* 243706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243709 */     // (intrinsic_wo_chain:{ *:[i32] } 2143:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F16_e64),
     /* 243712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243720 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243725 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243733 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243735 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243740 */     GIR_RootConstrainSelectedInstOperands,
     /* 243741 */     // GIR_Coverage, 2646,
     /* 243741 */     GIR_EraseRootFromParent_Done,
     /* 243742 */   // Label 3912: @243742
     /* 243742 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(243807), // Rule ID 2647 //
     /* 243747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f32),
     /* 243752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243771 */     // MIs[0] index
     /* 243771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243774 */     // (intrinsic_wo_chain:{ *:[i32] } 2144:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F32_e64),
     /* 243777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243785 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243790 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243798 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243800 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243805 */     GIR_RootConstrainSelectedInstOperands,
     /* 243806 */     // GIR_Coverage, 2647,
     /* 243806 */     GIR_EraseRootFromParent_Done,
     /* 243807 */   // Label 3913: @243807
     /* 243807 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(243896), // Rule ID 1017 //
     /* 243812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus),
     /* 243815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1_f16),
     /* 243820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243833 */     // MIs[0] attrchan
     /* 243833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 243836 */     // MIs[0] attr
     /* 243836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 243839 */     // MIs[0] high
     /* 243839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243842 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 243846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 243853 */     // (intrinsic_wo_chain:{ *:[f32] } 2999:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P1LL_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i1] }):$high)
     /* 243853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243857 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 243867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1LL_F16),
     /* 243870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243882 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 243884 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 243886 */     GIR_RootToRootCopy, /*OpIdx*/5, // high
     /* 243888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243894 */     GIR_RootConstrainSelectedInstOperands,
     /* 243895 */     // GIR_Coverage, 1017,
     /* 243895 */     GIR_EraseRootFromParent_Done,
     /* 243896 */   // Label 3914: @243896
     /* 243896 */   GIM_Reject,
     /* 243897 */ // Label 3899: @243897
     /* 243897 */ GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(244172),
     /* 243902 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 243905 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(243985), // Rule ID 2746 //
     /* 243910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 243913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot4),
     /* 243918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243934 */     // MIs[0] clamp
     /* 243934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 243937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243951 */     // (intrinsic_wo_chain:{ *:[i32] } 3286:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 243951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 243954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 243961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 243968 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 243970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 243973 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 243975 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 243977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243983 */     GIR_RootConstrainSelectedInstOperands,
     /* 243984 */     // GIR_Coverage, 2746,
     /* 243984 */     GIR_EraseRootFromParent_Done,
     /* 243985 */   // Label 3916: @243985
     /* 243985 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(244065), // Rule ID 2747 //
     /* 243990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 243993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot8),
     /* 243998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 244007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 244010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244014 */     // MIs[0] clamp
     /* 244014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 244017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 244024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 244031 */     // (intrinsic_wo_chain:{ *:[i32] } 3287:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 244031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 244034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 244041 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 244043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 244048 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 244050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 244053 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 244055 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 244057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244063 */     GIR_RootConstrainSelectedInstOperands,
     /* 244064 */     // GIR_Coverage, 2747,
     /* 244064 */     GIR_EraseRootFromParent_Done,
     /* 244065 */   // Label 3917: @244065
     /* 244065 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(244171), // Rule ID 1016 //
     /* 244070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isNotGFX90APlus),
     /* 244073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_f16),
     /* 244078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 244081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 244090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244094 */     // MIs[0] attrchan
     /* 244094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 244097 */     // MIs[0] attr
     /* 244097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244100 */     // MIs[0] high
     /* 244100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 244103 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244121 */     // (intrinsic_wo_chain:{ *:[f16] } 3002:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P2_F16:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$high)
     /* 244121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244125 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // M0
     /* 244135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16),
     /* 244138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 244145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 244150 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 244152 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 244154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 244159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 244164 */     GIR_RootToRootCopy, /*OpIdx*/6, // high
     /* 244166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244169 */     GIR_RootConstrainSelectedInstOperands,
     /* 244170 */     // GIR_Coverage, 1016,
     /* 244170 */     GIR_EraseRootFromParent_Done,
     /* 244171 */   // Label 3918: @244171
     /* 244171 */   GIM_Reject,
     /* 244172 */ // Label 3915: @244172
     /* 244172 */ GIM_Reject,
     /* 244173 */ // Label 37: @244173
     /* 244173 */ GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(244347),
     /* 244178 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 244181 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(244196), // Rule ID 1314 //
     /* 244186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv),
     /* 244191 */     // (intrinsic_void 3155:{ *:[iPTR] })  =>  (S_DCACHE_INV)
     /* 244191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV),
     /* 244194 */     GIR_RootConstrainSelectedInstOperands,
     /* 244195 */     // GIR_Coverage, 1314,
     /* 244195 */     GIR_EraseRootFromParent_Done,
     /* 244196 */   // Label 3920: @244196
     /* 244196 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(244214), // Rule ID 1315 //
     /* 244201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7GFX8GFX9),
     /* 244204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv_vol),
     /* 244209 */     // (intrinsic_void 3156:{ *:[iPTR] })  =>  (S_DCACHE_INV_VOL)
     /* 244209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV_VOL),
     /* 244212 */     GIR_RootConstrainSelectedInstOperands,
     /* 244213 */     // GIR_Coverage, 1315,
     /* 244213 */     GIR_EraseRootFromParent_Done,
     /* 244214 */   // Label 3921: @244214
     /* 244214 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(244232), // Rule ID 1316 //
     /* 244219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 244222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb),
     /* 244227 */     // (intrinsic_void 3157:{ *:[iPTR] })  =>  (S_DCACHE_WB)
     /* 244227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB),
     /* 244230 */     GIR_RootConstrainSelectedInstOperands,
     /* 244231 */     // GIR_Coverage, 1316,
     /* 244231 */     GIR_EraseRootFromParent_Done,
     /* 244232 */   // Label 3922: @244232
     /* 244232 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(244250), // Rule ID 1317 //
     /* 244237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 244240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb_vol),
     /* 244245 */     // (intrinsic_void 3158:{ *:[iPTR] })  =>  (S_DCACHE_WB_VOL)
     /* 244245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB_VOL),
     /* 244248 */     GIR_RootConstrainSelectedInstOperands,
     /* 244249 */     // GIR_Coverage, 1317,
     /* 244249 */     GIR_EraseRootFromParent_Done,
     /* 244250 */   // Label 3923: @244250
     /* 244250 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(244268), // Rule ID 1324 //
     /* 244255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 244258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_sc),
     /* 244263 */     // (intrinsic_void 2084:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_SC)
     /* 244263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_SC),
     /* 244266 */     GIR_RootConstrainSelectedInstOperands,
     /* 244267 */     // GIR_Coverage, 1324,
     /* 244267 */     GIR_EraseRootFromParent_Done,
     /* 244268 */   // Label 3924: @244268
     /* 244268 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(244286), // Rule ID 1325 //
     /* 244273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 244276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1),
     /* 244281 */     // (intrinsic_void 2083:{ *:[iPTR] })  =>  (BUFFER_WBINVL1)
     /* 244281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1),
     /* 244284 */     GIR_RootConstrainSelectedInstOperands,
     /* 244285 */     // GIR_Coverage, 1325,
     /* 244285 */     GIR_EraseRootFromParent_Done,
     /* 244286 */   // Label 3925: @244286
     /* 244286 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(244304), // Rule ID 1326 //
     /* 244291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 244294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_vol),
     /* 244299 */     // (intrinsic_void 2085:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_VOL)
     /* 244299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_VOL),
     /* 244302 */     GIR_RootConstrainSelectedInstOperands,
     /* 244303 */     // GIR_Coverage, 1326,
     /* 244303 */     GIR_EraseRootFromParent_Done,
     /* 244304 */   // Label 3926: @244304
     /* 244304 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(244325), // Rule ID 1872 //
     /* 244309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 244312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 244317 */     // (intrinsic_void 3183:{ *:[iPTR] })  =>  (S_WAIT_EVENT 0:{ *:[i16] })
     /* 244317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 244320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244323 */     GIR_RootConstrainSelectedInstOperands,
     /* 244324 */     // GIR_Coverage, 1872,
     /* 244324 */     GIR_EraseRootFromParent_Done,
     /* 244325 */   // Label 3927: @244325
     /* 244325 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(244346), // Rule ID 1873 //
     /* 244330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 244338 */     // (intrinsic_void 3183:{ *:[iPTR] })  =>  (S_WAIT_EVENT 2:{ *:[i16] })
     /* 244338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 244341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 244344 */     GIR_RootConstrainSelectedInstOperands,
     /* 244345 */     // GIR_Coverage, 1873,
     /* 244345 */     GIR_EraseRootFromParent_Done,
     /* 244346 */   // Label 3928: @244346
     /* 244346 */   GIM_Reject,
     /* 244347 */ // Label 3919: @244347
     /* 244347 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(245064),
     /* 244352 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 244355 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(244413), // Rule ID 6961 //
     /* 244360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 244365 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 244372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 244376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 244380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 244384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 244388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 244390 */     // (intrinsic_void 3008:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 244390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 244393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 244397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 244400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 244411 */     GIR_RootConstrainSelectedInstOperands,
     /* 244412 */     // GIR_Coverage, 6961,
     /* 244412 */     GIR_EraseRootFromParent_Done,
     /* 244413 */   // Label 3930: @244413
     /* 244413 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(244471), // Rule ID 6964 //
     /* 244418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 244423 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 244430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 244434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 244438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 244442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 244446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 244448 */     // (intrinsic_void 3331:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 244448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 244451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 244455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 244458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 244469 */     GIR_RootConstrainSelectedInstOperands,
     /* 244470 */     // GIR_Coverage, 6964,
     /* 244470 */     GIR_EraseRootFromParent_Done,
     /* 244471 */   // Label 3931: @244471
     /* 244471 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(244491), // Rule ID 178 //
     /* 244476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_nop),
     /* 244481 */     // MIs[0] simm16
     /* 244481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244484 */     // (intrinsic_void 3168:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_NOP (timm:{ *:[i16] }):$simm16)
     /* 244484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOP),
     /* 244487 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244489 */     GIR_RootConstrainSelectedInstOperands,
     /* 244490 */     // GIR_Coverage, 178,
     /* 244490 */     GIR_EraseRootFromParent_Done,
     /* 244491 */   // Label 3932: @244491
     /* 244491 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(244511), // Rule ID 183 //
     /* 244496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_waitcnt),
     /* 244501 */     // MIs[0] simm16
     /* 244501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244504 */     // (intrinsic_void 3189:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_WAITCNT (timm:{ *:[i32] }):$simm16)
     /* 244504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAITCNT),
     /* 244507 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244509 */     GIR_RootConstrainSelectedInstOperands,
     /* 244510 */     // GIR_Coverage, 183,
     /* 244510 */     GIR_EraseRootFromParent_Done,
     /* 244511 */   // Label 3933: @244511
     /* 244511 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(244531), // Rule ID 184 //
     /* 244516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sethalt),
     /* 244521 */     // MIs[0] simm16
     /* 244521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244524 */     // (intrinsic_void 3174:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SETHALT (timm:{ *:[i32] }):$simm16)
     /* 244524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETHALT),
     /* 244527 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244529 */     GIR_RootConstrainSelectedInstOperands,
     /* 244530 */     // GIR_Coverage, 184,
     /* 244530 */     GIR_EraseRootFromParent_Done,
     /* 244531 */   // Label 3934: @244531
     /* 244531 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(244551), // Rule ID 185 //
     /* 244536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep),
     /* 244541 */     // MIs[0] simm16
     /* 244541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244544 */     // (intrinsic_void 3177:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SLEEP (timm:{ *:[i32] }):$simm16)
     /* 244544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP),
     /* 244547 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244549 */     GIR_RootConstrainSelectedInstOperands,
     /* 244550 */     // GIR_Coverage, 185,
     /* 244550 */     GIR_EraseRootFromParent_Done,
     /* 244551 */   // Label 3935: @244551
     /* 244551 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(244571), // Rule ID 187 //
     /* 244556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setprio),
     /* 244561 */     // MIs[0] simm16
     /* 244561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244564 */     // (intrinsic_void 3175:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_SETPRIO (timm:{ *:[i16] }):$simm16)
     /* 244564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETPRIO),
     /* 244567 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244569 */     GIR_RootConstrainSelectedInstOperands,
     /* 244570 */     // GIR_Coverage, 187,
     /* 244570 */     GIR_EraseRootFromParent_Done,
     /* 244571 */   // Label 3936: @244571
     /* 244571 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(244591), // Rule ID 190 //
     /* 244576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_incperflevel),
     /* 244581 */     // MIs[0] simm16
     /* 244581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244584 */     // (intrinsic_void 3165:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_INCPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 244584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INCPERFLEVEL),
     /* 244587 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244589 */     GIR_RootConstrainSelectedInstOperands,
     /* 244590 */     // GIR_Coverage, 190,
     /* 244590 */     GIR_EraseRootFromParent_Done,
     /* 244591 */   // Label 3937: @244591
     /* 244591 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(244611), // Rule ID 191 //
     /* 244596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_decperflevel),
     /* 244601 */     // MIs[0] simm16
     /* 244601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244604 */     // (intrinsic_void 3159:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_DECPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 244604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DECPERFLEVEL),
     /* 244607 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244609 */     GIR_RootConstrainSelectedInstOperands,
     /* 244610 */     // GIR_Coverage, 191,
     /* 244610 */     GIR_EraseRootFromParent_Done,
     /* 244611 */   // Label 3938: @244611
     /* 244611 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(244634), // Rule ID 194 //
     /* 244616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 244619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata_imm),
     /* 244624 */     // MIs[0] simm16
     /* 244624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244627 */     // (intrinsic_void 3180:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_TTRACEDATA_IMM (timm:{ *:[i16] }):$simm16)
     /* 244627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA_IMM),
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244632 */     GIR_RootConstrainSelectedInstOperands,
     /* 244633 */     // GIR_Coverage, 194,
     /* 244633 */     GIR_EraseRootFromParent_Done,
     /* 244634 */   // Label 3939: @244634
     /* 244634 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(244657), // Rule ID 195 //
     /* 244639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_loadcnt),
     /* 244647 */     // MIs[0] simm16
     /* 244647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244650 */     // (intrinsic_void 3186:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_LOADCNT (timm:{ *:[i16] }):$simm16)
     /* 244650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_LOADCNT),
     /* 244653 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244655 */     GIR_RootConstrainSelectedInstOperands,
     /* 244656 */     // GIR_Coverage, 195,
     /* 244656 */     GIR_EraseRootFromParent_Done,
     /* 244657 */   // Label 3940: @244657
     /* 244657 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(244680), // Rule ID 196 //
     /* 244662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_storecnt),
     /* 244670 */     // MIs[0] simm16
     /* 244670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244673 */     // (intrinsic_void 3188:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_STORECNT (timm:{ *:[i16] }):$simm16)
     /* 244673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_STORECNT),
     /* 244676 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244678 */     GIR_RootConstrainSelectedInstOperands,
     /* 244679 */     // GIR_Coverage, 196,
     /* 244679 */     GIR_EraseRootFromParent_Done,
     /* 244680 */   // Label 3941: @244680
     /* 244680 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(244703), // Rule ID 197 //
     /* 244685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 244688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_samplecnt),
     /* 244693 */     // MIs[0] simm16
     /* 244693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244696 */     // (intrinsic_void 3187:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_SAMPLECNT (timm:{ *:[i16] }):$simm16)
     /* 244696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_SAMPLECNT),
     /* 244699 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244701 */     GIR_RootConstrainSelectedInstOperands,
     /* 244702 */     // GIR_Coverage, 197,
     /* 244702 */     GIR_EraseRootFromParent_Done,
     /* 244703 */   // Label 3942: @244703
     /* 244703 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(244726), // Rule ID 198 //
     /* 244708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 244711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_bvhcnt),
     /* 244716 */     // MIs[0] simm16
     /* 244716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244719 */     // (intrinsic_void 3181:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_BVHCNT (timm:{ *:[i16] }):$simm16)
     /* 244719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_BVHCNT),
     /* 244722 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244724 */     GIR_RootConstrainSelectedInstOperands,
     /* 244725 */     // GIR_Coverage, 198,
     /* 244725 */     GIR_EraseRootFromParent_Done,
     /* 244726 */   // Label 3943: @244726
     /* 244726 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(244749), // Rule ID 199 //
     /* 244731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExportInsts_isGFX12Plus),
     /* 244734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_expcnt),
     /* 244739 */     // MIs[0] simm16
     /* 244739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244742 */     // (intrinsic_void 3184:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_EXPCNT (timm:{ *:[i16] }):$simm16)
     /* 244742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EXPCNT),
     /* 244745 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244747 */     GIR_RootConstrainSelectedInstOperands,
     /* 244748 */     // GIR_Coverage, 199,
     /* 244748 */     GIR_EraseRootFromParent_Done,
     /* 244749 */   // Label 3944: @244749
     /* 244749 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(244772), // Rule ID 200 //
     /* 244754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_dscnt),
     /* 244762 */     // MIs[0] simm16
     /* 244762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244765 */     // (intrinsic_void 3182:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_DSCNT (timm:{ *:[i16] }):$simm16)
     /* 244765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_DSCNT),
     /* 244768 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244770 */     GIR_RootConstrainSelectedInstOperands,
     /* 244771 */     // GIR_Coverage, 200,
     /* 244771 */     GIR_EraseRootFromParent_Done,
     /* 244772 */   // Label 3945: @244772
     /* 244772 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(244795), // Rule ID 201 //
     /* 244777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_kmcnt),
     /* 244785 */     // MIs[0] simm16
     /* 244785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244788 */     // (intrinsic_void 3185:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_KMCNT (timm:{ *:[i16] }):$simm16)
     /* 244788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_KMCNT),
     /* 244791 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244793 */     GIR_RootConstrainSelectedInstOperands,
     /* 244794 */     // GIR_Coverage, 201,
     /* 244794 */     GIR_EraseRootFromParent_Done,
     /* 244795 */   // Label 3946: @244795
     /* 244795 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(244822), // Rule ID 1313 //
     /* 244800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /* 244803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memtime),
     /* 244808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 244815 */     // (intrinsic_w_chain:{ *:[i64] } 3167:{ *:[iPTR] })  =>  (S_MEMTIME:{ *:[i64] })
     /* 244815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /* 244818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244820 */     GIR_RootConstrainSelectedInstOperands,
     /* 244821 */     // GIR_Coverage, 1313,
     /* 244821 */     GIR_EraseRootFromParent_Done,
     /* 244822 */   // Label 3947: @244822
     /* 244822 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(244849), // Rule ID 1318 //
     /* 244827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /* 244830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memrealtime),
     /* 244835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 244842 */     // (intrinsic_w_chain:{ *:[i64] } 3166:{ *:[iPTR] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /* 244842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /* 244845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244847 */     GIR_RootConstrainSelectedInstOperands,
     /* 244848 */     // GIR_Coverage, 1318,
     /* 244848 */     GIR_EraseRootFromParent_Done,
     /* 244849 */   // Label 3948: @244849
     /* 244849 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(244876), // Rule ID 1319 //
     /* 244854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGetWaveIdInst),
     /* 244857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_get_waveid_in_workgroup),
     /* 244862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 244869 */     // (intrinsic_w_chain:{ *:[i32] } 3162:{ *:[iPTR] })  =>  (S_GET_WAVEID_IN_WORKGROUP:{ *:[i32] })
     /* 244869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GET_WAVEID_IN_WORKGROUP),
     /* 244872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244874 */     GIR_RootConstrainSelectedInstOperands,
     /* 244875 */     // GIR_Coverage, 1319,
     /* 244875 */     GIR_EraseRootFromParent_Done,
     /* 244876 */   // Label 3949: @244876
     /* 244876 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(244904), // Rule ID 1351 //
     /* 244881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_live_mask),
     /* 244886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 244889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 244893 */     // (intrinsic_w_chain:{ *:[i1] } 3013:{ *:[iPTR] })  =>  (SI_LIVE_MASK:{ *:[i1] })
     /* 244893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_LIVE_MASK),
     /* 244896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244902 */     GIR_RootConstrainSelectedInstOperands,
     /* 244903 */     // GIR_Coverage, 1351,
     /* 244903 */     GIR_EraseRootFromParent_Done,
     /* 244904 */   // Label 3950: @244904
     /* 244904 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(244937), // Rule ID 1876 //
     /* 244909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9GFX10),
     /* 244912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_pops_exiting_wave_id),
     /* 244917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244924 */     // (intrinsic_w_chain:{ *:[i32] } 3084:{ *:[iPTR] })  =>  (S_MOV_B32_sideeffects:{ *:[i32] } SRC_POPS_EXITING_WAVE_ID:{ *:[i32] })
     /* 244924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32_sideeffects),
     /* 244927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SRC_POPS_EXITING_WAVE_ID), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 244935 */     GIR_RootConstrainSelectedInstOperands,
     /* 244936 */     // GIR_Coverage, 1876,
     /* 244936 */     GIR_EraseRootFromParent_Done,
     /* 244937 */   // Label 3951: @244937
     /* 244937 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(244961), // Rule ID 186 //
     /* 244942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep_var),
     /* 244947 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 244950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244954 */     // (intrinsic_void 3178:{ *:[iPTR] }, SSrc_b32:{ *:[i32] }:$src0)  =>  (S_SLEEP_VAR SSrc_b32:{ *:[i32] }:$src0)
     /* 244954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP_VAR),
     /* 244957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 244959 */     GIR_RootConstrainSelectedInstOperands,
     /* 244960 */     // GIR_Coverage, 186,
     /* 244960 */     GIR_EraseRootFromParent_Done,
     /* 244961 */   // Label 3952: @244961
     /* 244961 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(244997), // Rule ID 192 //
     /* 244966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata),
     /* 244971 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 244974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244978 */     // (intrinsic_void 3179:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (S_TTRACEDATA)
     /* 244978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244982 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // M0
     /* 244992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA),
     /* 244995 */     GIR_RootConstrainSelectedInstOperands,
     /* 244996 */     // GIR_Coverage, 192,
     /* 244996 */     GIR_EraseRootFromParent_Done,
     /* 244997 */   // Label 3953: @244997
     /* 244997 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(245030), // Rule ID 6960 //
     /* 245002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 245007 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 245010 */     // (intrinsic_void 3008:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 245010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 245013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 245015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 245021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 245024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245028 */     GIR_RootConstrainSelectedInstOperands,
     /* 245029 */     // GIR_Coverage, 6960,
     /* 245029 */     GIR_EraseRootFromParent_Done,
     /* 245030 */   // Label 3954: @245030
     /* 245030 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(245063), // Rule ID 6963 //
     /* 245035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 245040 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 245043 */     // (intrinsic_void 3331:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 245043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 245046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 245048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 245054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 245057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245061 */     GIR_RootConstrainSelectedInstOperands,
     /* 245062 */     // GIR_Coverage, 6963,
     /* 245062 */     GIR_EraseRootFromParent_Done,
     /* 245063 */   // Label 3955: @245063
     /* 245063 */   GIM_Reject,
     /* 245064 */ // Label 3929: @245064
     /* 245064 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(245630),
     /* 245069 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 245072 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(245141), // Rule ID 3537 //
     /* 245077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 245092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245100 */     // MIs[1] Operand 1
     /* 245100 */     // No operand predicates
     /* 245100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 245109 */     // (intrinsic_void 3169:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 245109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 245117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 245122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 245128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 245134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245139 */     GIR_RootConstrainSelectedInstOperands,
     /* 245140 */     // GIR_Coverage, 3537,
     /* 245140 */     GIR_EraseRootFromParent_Done,
     /* 245141 */   // Label 3957: @245141
     /* 245141 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(245196), // Rule ID 3535 //
     /* 245146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 245161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 245172 */     // (intrinsic_void 3169:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 245172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 245180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 245185 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 245187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245194 */     GIR_RootConstrainSelectedInstOperands,
     /* 245195 */     // GIR_Coverage, 3535,
     /* 245195 */     GIR_EraseRootFromParent_Done,
     /* 245196 */   // Label 3958: @245196
     /* 245196 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(245233), // Rule ID 119 //
     /* 245201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setreg),
     /* 245206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245209 */     // MIs[0] simm16
     /* 245209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SIMM16bit),
     /* 245217 */     // (intrinsic_void 3176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_SIMM16bit>><<X:as_i16timm>>:$simm16, i32:{ *:[i32] }:$sdst)  =>  (S_SETREG_B32 i32:{ *:[i32] }:$sdst, (as_i16timm:{ *:[i32] } (timm:{ *:[i32] }):$simm16))
     /* 245217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETREG_B32),
     /* 245220 */     GIR_RootToRootCopy, /*OpIdx*/2, // sdst
     /* 245222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // simm16
     /* 245228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::MODE*/0,
     /* 245231 */     GIR_RootConstrainSelectedInstOperands,
     /* 245232 */     // GIR_Coverage, 119,
     /* 245232 */     GIR_EraseRootFromParent_Done,
     /* 245233 */   // Label 3959: @245233
     /* 245233 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(245265), // Rule ID 25 //
     /* 245238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 245241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 245246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245253 */     // MIs[0] src0
     /* 245253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245256 */     // (intrinsic_w_chain:{ *:[i32] } 3172:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B32:{ *:[i32] } (timm:{ *:[i32] }):$src0)
     /* 245256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B32),
     /* 245259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 245261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245263 */     GIR_RootConstrainSelectedInstOperands,
     /* 245264 */     // GIR_Coverage, 25,
     /* 245264 */     GIR_EraseRootFromParent_Done,
     /* 245265 */   // Label 3960: @245265
     /* 245265 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(245297), // Rule ID 26 //
     /* 245270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 245273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 245278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 245281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 245285 */     // MIs[0] src0
     /* 245285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245288 */     // (intrinsic_w_chain:{ *:[i64] } 3172:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } (timm:{ *:[i32] }):$src0)
     /* 245288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /* 245291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 245293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245295 */     GIR_RootConstrainSelectedInstOperands,
     /* 245296 */     // GIR_Coverage, 26,
     /* 245296 */     GIR_EraseRootFromParent_Done,
     /* 245297 */   // Label 3961: @245297
     /* 245297 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(245326), // Rule ID 118 //
     /* 245302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getreg),
     /* 245307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245314 */     // MIs[0] simm16
     /* 245314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245317 */     // (intrinsic_w_chain:{ *:[i32] } 3164:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_GETREG_B32:{ *:[i32] } (timm:{ *:[i32] }):$simm16)
     /* 245317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 245320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 245322 */     GIR_RootToRootCopy, /*OpIdx*/2, // simm16
     /* 245324 */     GIR_RootConstrainSelectedInstOperands,
     /* 245325 */     // GIR_Coverage, 118,
     /* 245325 */     GIR_EraseRootFromParent_Done,
     /* 245326 */   // Label 3962: @245326
     /* 245326 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(245387), // Rule ID 3538 //
     /* 245331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245342 */     // MIs[0] sbase
     /* 245342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 245350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245358 */     // MIs[1] Operand 1
     /* 245358 */     // No operand predicates
     /* 245358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245360 */     // (intrinsic_void 3169:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 245360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245363 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 245365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 245374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 245380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245385 */     GIR_RootConstrainSelectedInstOperands,
     /* 245386 */     // GIR_Coverage, 3538,
     /* 245386 */     GIR_EraseRootFromParent_Done,
     /* 245387 */   // Label 3963: @245387
     /* 245387 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(245428), // Rule ID 188 //
     /* 245392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg),
     /* 245397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245400 */     // MIs[0] simm16
     /* 245400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245407 */     // (intrinsic_void 3171:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSG (timm:{ *:[i32] }):$simm16)
     /* 245407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245411 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG),
     /* 245424 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 245426 */     GIR_RootConstrainSelectedInstOperands,
     /* 245427 */     // GIR_Coverage, 188,
     /* 245427 */     GIR_EraseRootFromParent_Done,
     /* 245428 */   // Label 3964: @245428
     /* 245428 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(245469), // Rule ID 189 //
     /* 245433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsghalt),
     /* 245438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245441 */     // MIs[0] simm16
     /* 245441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245448 */     // (intrinsic_void 3173:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSGHALT (timm:{ *:[i32] }):$simm16)
     /* 245448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245452 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSGHALT),
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 245467 */     GIR_RootConstrainSelectedInstOperands,
     /* 245468 */     // GIR_Coverage, 189,
     /* 245468 */     GIR_EraseRootFromParent_Done,
     /* 245469 */   // Label 3965: @245469
     /* 245469 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(245524), // Rule ID 6912 //
     /* 245474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 245477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 245482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245496 */     // (intrinsic_w_chain:{ *:[f32] } 3009:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (LDS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] })
     /* 245496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245500 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_DIRECT_LOAD),
     /* 245513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245522 */     GIR_RootConstrainSelectedInstOperands,
     /* 245523 */     // GIR_Coverage, 6912,
     /* 245523 */     GIR_EraseRootFromParent_Done,
     /* 245524 */   // Label 3966: @245524
     /* 245524 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(245582), // Rule ID 6914 //
     /* 245529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 245537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245551 */     // (intrinsic_w_chain:{ *:[f32] } 3009:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (DS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 245551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245555 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DIRECT_LOAD),
     /* 245568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245580 */     GIR_RootConstrainSelectedInstOperands,
     /* 245581 */     // GIR_Coverage, 6914,
     /* 245581 */     GIR_EraseRootFromParent_Done,
     /* 245582 */   // Label 3967: @245582
     /* 245582 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(245629), // Rule ID 3536 //
     /* 245587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245598 */     // MIs[0] sbase
     /* 245598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 245606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245610 */     // (intrinsic_void 3169:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 245610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245613 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 245615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245618 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 245620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245627 */     GIR_RootConstrainSelectedInstOperands,
     /* 245628 */     // GIR_Coverage, 3536,
     /* 245628 */     GIR_EraseRootFromParent_Done,
     /* 245629 */   // Label 3968: @245629
     /* 245629 */   GIM_Reject,
     /* 245630 */ // Label 3956: @245630
     /* 245630 */ GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(247792),
     /* 245635 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 245638 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(245708), // Rule ID 1321 //
     /* 245643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 245672 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_ADDR64_RTN),
     /* 245675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245677 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 245684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 245694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 245699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245706 */     GIR_RootConstrainSelectedInstOperands,
     /* 245707 */     // GIR_Coverage, 1321,
     /* 245707 */     GIR_EraseRootFromParent_Done,
     /* 245708 */   // Label 3970: @245708
     /* 245708 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(245778), // Rule ID 1323 //
     /* 245713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 245742 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN),
     /* 245745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245747 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 245754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 245764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 245769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245776 */     GIR_RootConstrainSelectedInstOperands,
     /* 245777 */     // GIR_Coverage, 1323,
     /* 245777 */     GIR_EraseRootFromParent_Done,
     /* 245778 */   // Label 3971: @245778
     /* 245778 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(245843), // Rule ID 1320 //
     /* 245783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 245812 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_OFFSET_RTN),
     /* 245815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245817 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 245829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245841 */     GIR_RootConstrainSelectedInstOperands,
     /* 245842 */     // GIR_Coverage, 1320,
     /* 245842 */     GIR_EraseRootFromParent_Done,
     /* 245843 */   // Label 3972: @245843
     /* 245843 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(245908), // Rule ID 1322 //
     /* 245848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 245877 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN),
     /* 245880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245882 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 245894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245906 */     GIR_RootConstrainSelectedInstOperands,
     /* 245907 */     // GIR_Coverage, 1322,
     /* 245907 */     GIR_EraseRootFromParent_Done,
     /* 245908 */   // Label 3973: @245908
     /* 245908 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(245969), // Rule ID 7795 //
     /* 245913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 245916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 245921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 245932 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 245945 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_local_addrspace>>  =>  (DS_COND_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 245945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_U32),
     /* 245948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 245953 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 245955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 245960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245967 */     GIR_RootConstrainSelectedInstOperands,
     /* 245968 */     // GIR_Coverage, 7795,
     /* 245968 */     GIR_EraseRootFromParent_Done,
     /* 245969 */   // Label 3974: @245969
     /* 245969 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(246034), // Rule ID 7794 //
     /* 245974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 245982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 245993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 246008 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_local_addrspace>>  =>  (DS_COND_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9787:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 246008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_RTN_U32),
     /* 246011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 246018 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 246020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246032 */     GIR_RootConstrainSelectedInstOperands,
     /* 246033 */     // GIR_Coverage, 7794,
     /* 246033 */     GIR_EraseRootFromParent_Done,
     /* 246034 */   // Label 3975: @246034
     /* 246034 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(246102), // Rule ID 4116 //
     /* 246039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 246042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246060 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246073 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR),
     /* 246076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246081 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246100 */     GIR_RootConstrainSelectedInstOperands,
     /* 246101 */     // GIR_Coverage, 4116,
     /* 246101 */     GIR_EraseRootFromParent_Done,
     /* 246102 */   // Label 3976: @246102
     /* 246102 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(246163), // Rule ID 4060 //
     /* 246107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 246110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246121 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246134 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR),
     /* 246137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246142 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246161 */     GIR_RootConstrainSelectedInstOperands,
     /* 246162 */     // GIR_Coverage, 4060,
     /* 246162 */     GIR_EraseRootFromParent_Done,
     /* 246163 */   // Label 3977: @246163
     /* 246163 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(246224), // Rule ID 4144 //
     /* 246168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246182 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246195 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 246198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246203 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246222 */     GIR_RootConstrainSelectedInstOperands,
     /* 246223 */     // GIR_Coverage, 4144,
     /* 246223 */     GIR_EraseRootFromParent_Done,
     /* 246224 */   // Label 3978: @246224
     /* 246224 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(246285), // Rule ID 4148 //
     /* 246229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246243 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246256 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 246259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246264 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246283 */     GIR_RootConstrainSelectedInstOperands,
     /* 246284 */     // GIR_Coverage, 4148,
     /* 246284 */     GIR_EraseRootFromParent_Done,
     /* 246285 */   // Label 3979: @246285
     /* 246285 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(246357), // Rule ID 4114 //
     /* 246290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 246293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246304 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246326 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN),
     /* 246329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246336 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246355 */     GIR_RootConstrainSelectedInstOperands,
     /* 246356 */     // GIR_Coverage, 4114,
     /* 246356 */     GIR_EraseRootFromParent_Done,
     /* 246357 */   // Label 3980: @246357
     /* 246357 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(246422), // Rule ID 4058 //
     /* 246362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 246365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246391 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR_RTN),
     /* 246394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246401 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246420 */     GIR_RootConstrainSelectedInstOperands,
     /* 246421 */     // GIR_Coverage, 4058,
     /* 246421 */     GIR_EraseRootFromParent_Done,
     /* 246422 */   // Label 3981: @246422
     /* 246422 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(246487), // Rule ID 4118 //
     /* 246427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 246430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 246435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 246445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246456 */     // (intrinsic_w_chain:{ *:[i64] } 2218:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN),
     /* 246459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246466 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246485 */     GIR_RootConstrainSelectedInstOperands,
     /* 246486 */     // GIR_Coverage, 4118,
     /* 246486 */     GIR_EraseRootFromParent_Done,
     /* 246487 */   // Label 3982: @246487
     /* 246487 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(246552), // Rule ID 4146 //
     /* 246492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246521 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 246524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246531 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246550 */     GIR_RootConstrainSelectedInstOperands,
     /* 246551 */     // GIR_Coverage, 4146,
     /* 246551 */     GIR_EraseRootFromParent_Done,
     /* 246552 */   // Label 3983: @246552
     /* 246552 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(246617), // Rule ID 4150 //
     /* 246557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246586 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 246589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246596 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246615 */     GIR_RootConstrainSelectedInstOperands,
     /* 246616 */     // GIR_Coverage, 4150,
     /* 246616 */     GIR_EraseRootFromParent_Done,
     /* 246617 */   // Label 3984: @246617
     /* 246617 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(246680), // Rule ID 4115 //
     /* 246622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 246625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246636 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246643 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246656 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32),
     /* 246659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246664 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246678 */     GIR_RootConstrainSelectedInstOperands,
     /* 246679 */     // GIR_Coverage, 4115,
     /* 246679 */     GIR_EraseRootFromParent_Done,
     /* 246680 */   // Label 3985: @246680
     /* 246680 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(246736), // Rule ID 4059 //
     /* 246685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 246688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246712 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB),
     /* 246715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246720 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246734 */     GIR_RootConstrainSelectedInstOperands,
     /* 246735 */     // GIR_Coverage, 4059,
     /* 246735 */     GIR_EraseRootFromParent_Done,
     /* 246736 */   // Label 3986: @246736
     /* 246736 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(246792), // Rule ID 4143 //
     /* 246741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246755 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246768 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 246771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246776 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246790 */     GIR_RootConstrainSelectedInstOperands,
     /* 246791 */     // GIR_Coverage, 4143,
     /* 246791 */     GIR_EraseRootFromParent_Done,
     /* 246792 */   // Label 3987: @246792
     /* 246792 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(246848), // Rule ID 4147 //
     /* 246797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246811 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246824 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 246827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246832 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246846 */     GIR_RootConstrainSelectedInstOperands,
     /* 246847 */     // GIR_Coverage, 4147,
     /* 246847 */     GIR_EraseRootFromParent_Done,
     /* 246848 */   // Label 3988: @246848
     /* 246848 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(246915), // Rule ID 4113 //
     /* 246853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 246856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246867 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246889 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_RTN),
     /* 246892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246899 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246913 */     GIR_RootConstrainSelectedInstOperands,
     /* 246914 */     // GIR_Coverage, 4113,
     /* 246914 */     GIR_EraseRootFromParent_Done,
     /* 246915 */   // Label 3989: @246915
     /* 246915 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(246975), // Rule ID 4057 //
     /* 246920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 246923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246949 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_RTN),
     /* 246952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246959 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246973 */     GIR_RootConstrainSelectedInstOperands,
     /* 246974 */     // GIR_Coverage, 4057,
     /* 246974 */     GIR_EraseRootFromParent_Done,
     /* 246975 */   // Label 3990: @246975
     /* 246975 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(247035), // Rule ID 4117 //
     /* 246980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 246983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 246988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 246998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 247009 */     // (intrinsic_w_chain:{ *:[i64] } 2218:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 247009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN),
     /* 247012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247019 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247033 */     GIR_RootConstrainSelectedInstOperands,
     /* 247034 */     // GIR_Coverage, 4117,
     /* 247034 */     GIR_EraseRootFromParent_Done,
     /* 247035 */   // Label 3991: @247035
     /* 247035 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(247095), // Rule ID 4145 //
     /* 247040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 247048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 247069 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 247072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247079 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247093 */     GIR_RootConstrainSelectedInstOperands,
     /* 247094 */     // GIR_Coverage, 4145,
     /* 247094 */     GIR_EraseRootFromParent_Done,
     /* 247095 */   // Label 3992: @247095
     /* 247095 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(247155), // Rule ID 4149 //
     /* 247100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 247108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 247129 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 247132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247139 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247153 */     GIR_RootConstrainSelectedInstOperands,
     /* 247154 */     // GIR_Coverage, 4149,
     /* 247154 */     GIR_EraseRootFromParent_Done,
     /* 247155 */   // Label 3993: @247155
     /* 247155 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(247197), // Rule ID 8332 //
     /* 247160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 247165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 247175 */     // MIs[0] offset32
     /* 247175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247178 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 247178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 247181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247183 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 247185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247195 */     GIR_RootConstrainSelectedInstOperands,
     /* 247196 */     // GIR_Coverage, 8332,
     /* 247196 */     GIR_EraseRootFromParent_Done,
     /* 247197 */   // Label 3994: @247197
     /* 247197 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(247291), // Rule ID 8333 //
     /* 247202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 247207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247217 */     // MIs[0] offset32
     /* 247217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247220 */     // (intrinsic_w_chain:{ *:[i32] } 2168:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 247220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 247223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 247227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247232 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 247236 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247242 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 247251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 247263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 247273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 247280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247290 */     // GIR_Coverage, 8333,
     /* 247290 */     GIR_EraseRootFromParent_Done,
     /* 247291 */   // Label 3995: @247291
     /* 247291 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(247333), // Rule ID 8334 //
     /* 247296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 247301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 247311 */     // MIs[0] offset32
     /* 247311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247314 */     // (intrinsic_w_chain:{ *:[i64] } 2190:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 247314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 247317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247319 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 247321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247331 */     GIR_RootConstrainSelectedInstOperands,
     /* 247332 */     // GIR_Coverage, 8334,
     /* 247332 */     GIR_EraseRootFromParent_Done,
     /* 247333 */   // Label 3996: @247333
     /* 247333 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(247427), // Rule ID 8335 //
     /* 247338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 247343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247353 */     // MIs[0] offset32
     /* 247353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247356 */     // (intrinsic_w_chain:{ *:[i32] } 2190:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 247356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 247359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 247363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247368 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 247372 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247378 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 247387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 247399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 247409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 247416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247426 */     // GIR_Coverage, 8335,
     /* 247426 */     GIR_EraseRootFromParent_Done,
     /* 247427 */   // Label 3997: @247427
     /* 247427 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(247491), // Rule ID 3784 //
     /* 247432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 247435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 247440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 247454 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247467 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32),
     /* 247470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247475 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247489 */     GIR_RootConstrainSelectedInstOperands,
     /* 247490 */     // GIR_Coverage, 3784,
     /* 247490 */     GIR_EraseRootFromParent_Done,
     /* 247491 */   // Label 3998: @247491
     /* 247491 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(247547), // Rule ID 4152 //
     /* 247496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 247504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247510 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247523 */     // (intrinsic_w_chain:{ *:[f32] } 2207:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmin_num_noret>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 247526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247545 */     GIR_RootConstrainSelectedInstOperands,
     /* 247546 */     // GIR_Coverage, 4152,
     /* 247546 */     GIR_EraseRootFromParent_Done,
     /* 247547 */   // Label 3999: @247547
     /* 247547 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(247603), // Rule ID 4154 //
     /* 247552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 247560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247566 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247579 */     // (intrinsic_w_chain:{ *:[f32] } 2206:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmax_num_noret>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 247582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247587 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247601 */     GIR_RootConstrainSelectedInstOperands,
     /* 247602 */     // GIR_Coverage, 4154,
     /* 247602 */     GIR_EraseRootFromParent_Done,
     /* 247603 */   // Label 4000: @247603
     /* 247603 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(247671), // Rule ID 3783 //
     /* 247608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_isGFX12Plus),
     /* 247611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 247616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 247630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247645 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32_RTN),
     /* 247648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247655 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247669 */     GIR_RootConstrainSelectedInstOperands,
     /* 247670 */     // GIR_Coverage, 3783,
     /* 247670 */     GIR_EraseRootFromParent_Done,
     /* 247671 */   // Label 4001: @247671
     /* 247671 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(247731), // Rule ID 4151 //
     /* 247676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 247684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247705 */     // (intrinsic_w_chain:{ *:[f32] } 2207:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 247708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247715 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247729 */     GIR_RootConstrainSelectedInstOperands,
     /* 247730 */     // GIR_Coverage, 4151,
     /* 247730 */     GIR_EraseRootFromParent_Done,
     /* 247731 */   // Label 4002: @247731
     /* 247731 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(247791), // Rule ID 4153 //
     /* 247736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 247744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247765 */     // (intrinsic_w_chain:{ *:[f32] } 2206:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9787:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247775 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247789 */     GIR_RootConstrainSelectedInstOperands,
     /* 247790 */     // GIR_Coverage, 4153,
     /* 247790 */     GIR_EraseRootFromParent_Done,
     /* 247791 */   // Label 4003: @247791
     /* 247791 */   GIM_Reject,
     /* 247792 */ // Label 3969: @247792
     /* 247792 */ GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(248126),
     /* 247797 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 247800 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_compr),
     /* 247805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 247808 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 247811 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247814 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 247817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247821 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247825 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(247900), // Rule ID 6908 //
     /* 247830 */     // MIs[0] Operand 5
     /* 247830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 247841 */     // MIs[0] vm
     /* 247841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247844 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 247875 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247877 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247879 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247887 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247892 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247898 */     GIR_RootConstrainSelectedInstOperands,
     /* 247899 */     // GIR_Coverage, 6908,
     /* 247899 */     GIR_EraseRootFromParent_Done,
     /* 247900 */   // Label 4005: @247900
     /* 247900 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(247975), // Rule ID 6909 //
     /* 247905 */     // MIs[0] Operand 5
     /* 247905 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 247916 */     // MIs[0] vm
     /* 247916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247919 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 247950 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247952 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247954 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247962 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247967 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247973 */     GIR_RootConstrainSelectedInstOperands,
     /* 247974 */     // GIR_Coverage, 6909,
     /* 247974 */     GIR_EraseRootFromParent_Done,
     /* 247975 */   // Label 4006: @247975
     /* 247975 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(248050), // Rule ID 6910 //
     /* 247980 */     // MIs[0] Operand 5
     /* 247980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 247991 */     // MIs[0] vm
     /* 247991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247994 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 248001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 248008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 248011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 248015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 248022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 248025 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248027 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248029 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 248037 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 248039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 248042 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248048 */     GIR_RootConstrainSelectedInstOperands,
     /* 248049 */     // GIR_Coverage, 6910,
     /* 248049 */     GIR_EraseRootFromParent_Done,
     /* 248050 */   // Label 4007: @248050
     /* 248050 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(248125), // Rule ID 6911 //
     /* 248055 */     // MIs[0] Operand 5
     /* 248055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 248066 */     // MIs[0] vm
     /* 248066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 248069 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 248072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 248076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 248083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 248086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 248090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 248097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 248100 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248104 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 248109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 248112 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 248114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 248117 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248123 */     GIR_RootConstrainSelectedInstOperands,
     /* 248124 */     // GIR_Coverage, 6911,
     /* 248124 */     GIR_EraseRootFromParent_Done,
     /* 248125 */   // Label 4008: @248125
     /* 248125 */   GIM_Reject,
     /* 248126 */ // Label 4004: @248126
     /* 248126 */ GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(248883),
     /* 248131 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 248134 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(248218), // Rule ID 6900 //
     /* 248139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248156 */     // MIs[0] tgt
     /* 248156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248159 */     // MIs[0] en
     /* 248159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248174 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248178 */     // MIs[0] Operand 7
     /* 248178 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248189 */     // MIs[0] vm
     /* 248189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248192 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 248195 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248199 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248201 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248203 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248210 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248216 */     GIR_RootConstrainSelectedInstOperands,
     /* 248217 */     // GIR_Coverage, 6900,
     /* 248217 */     GIR_EraseRootFromParent_Done,
     /* 248218 */   // Label 4010: @248218
     /* 248218 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(248302), // Rule ID 6901 //
     /* 248223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248240 */     // MIs[0] tgt
     /* 248240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248243 */     // MIs[0] en
     /* 248243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248258 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248262 */     // MIs[0] Operand 7
     /* 248262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248273 */     // MIs[0] vm
     /* 248273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248276 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 248279 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248281 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248283 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248285 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248287 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248294 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248300 */     GIR_RootConstrainSelectedInstOperands,
     /* 248301 */     // GIR_Coverage, 6901,
     /* 248301 */     GIR_EraseRootFromParent_Done,
     /* 248302 */   // Label 4011: @248302
     /* 248302 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(248386), // Rule ID 6902 //
     /* 248307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248324 */     // MIs[0] tgt
     /* 248324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248327 */     // MIs[0] en
     /* 248327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248342 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248346 */     // MIs[0] Operand 7
     /* 248346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248357 */     // MIs[0] vm
     /* 248357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248360 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 248363 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248367 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248369 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248371 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248373 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248378 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248384 */     GIR_RootConstrainSelectedInstOperands,
     /* 248385 */     // GIR_Coverage, 6902,
     /* 248385 */     GIR_EraseRootFromParent_Done,
     /* 248386 */   // Label 4012: @248386
     /* 248386 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(248470), // Rule ID 6903 //
     /* 248391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248408 */     // MIs[0] tgt
     /* 248408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248411 */     // MIs[0] en
     /* 248411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248426 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248430 */     // MIs[0] Operand 7
     /* 248430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248441 */     // MIs[0] vm
     /* 248441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248444 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 248447 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248449 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248451 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248453 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248455 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248457 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248462 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248468 */     GIR_RootConstrainSelectedInstOperands,
     /* 248469 */     // GIR_Coverage, 6903,
     /* 248469 */     GIR_EraseRootFromParent_Done,
     /* 248470 */   // Label 4013: @248470
     /* 248470 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(248573), // Rule ID 6904 //
     /* 248475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248492 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248495 */     // MIs[0] tgt
     /* 248495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248498 */     // MIs[0] en
     /* 248498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248513 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248517 */     // MIs[0] Operand 7
     /* 248517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248528 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248532 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248536 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 248549 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248551 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248553 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248555 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248557 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248565 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248571 */     GIR_RootConstrainSelectedInstOperands,
     /* 248572 */     // GIR_Coverage, 6904,
     /* 248572 */     GIR_EraseRootFromParent_Done,
     /* 248573 */   // Label 4014: @248573
     /* 248573 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(248676), // Rule ID 6905 //
     /* 248578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248595 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248598 */     // MIs[0] tgt
     /* 248598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248601 */     // MIs[0] en
     /* 248601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248616 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248620 */     // MIs[0] Operand 7
     /* 248620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248631 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248635 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248639 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 248652 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248654 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248656 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248658 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248660 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248668 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248674 */     GIR_RootConstrainSelectedInstOperands,
     /* 248675 */     // GIR_Coverage, 6905,
     /* 248675 */     GIR_EraseRootFromParent_Done,
     /* 248676 */   // Label 4015: @248676
     /* 248676 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(248779), // Rule ID 6906 //
     /* 248681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248698 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248701 */     // MIs[0] tgt
     /* 248701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248704 */     // MIs[0] en
     /* 248704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248719 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248723 */     // MIs[0] Operand 7
     /* 248723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248734 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248738 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248742 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 248755 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248757 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248759 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248761 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248763 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248777 */     GIR_RootConstrainSelectedInstOperands,
     /* 248778 */     // GIR_Coverage, 6906,
     /* 248778 */     GIR_EraseRootFromParent_Done,
     /* 248779 */   // Label 4016: @248779
     /* 248779 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(248882), // Rule ID 6907 //
     /* 248784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248801 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248804 */     // MIs[0] tgt
     /* 248804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248807 */     // MIs[0] en
     /* 248807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248822 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248826 */     // MIs[0] Operand 7
     /* 248826 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248837 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248841 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248845 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 248858 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248862 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248864 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248866 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248874 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248880 */     GIR_RootConstrainSelectedInstOperands,
     /* 248881 */     // GIR_Coverage, 6907,
     /* 248881 */     GIR_EraseRootFromParent_Done,
     /* 248882 */   // Label 4017: @248882
     /* 248882 */   GIM_Reject,
     /* 248883 */ // Label 4009: @248883
     /* 248883 */ GIM_Reject,
     /* 248884 */ // Label 38: @248884
     /* 248884 */ GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(249684),
     /* 248889 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 248892 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(248931), // Rule ID 7569 //
     /* 248897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 248912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248920 */     // MIs[1] Operand 1
     /* 248920 */     // No operand predicates
     /* 248920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248922 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, (imm:{ *:[i32] }):$src)  =>  (S_MOV_B32:{ *:[i32] } SReg_32:{ *:[i32] }:$src)
     /* 248922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 248925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 248929 */     GIR_RootConstrainSelectedInstOperands,
     /* 248930 */     // GIR_Coverage, 7569,
     /* 248930 */     GIR_EraseRootFromParent_Done,
     /* 248931 */   // Label 4019: @248931
     /* 248931 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(248964), // Rule ID 2381 //
     /* 248936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248955 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248962 */     GIR_RootConstrainSelectedInstOperands,
     /* 248963 */     // GIR_Coverage, 2381,
     /* 248963 */     GIR_EraseRootFromParent_Done,
     /* 248964 */   // Label 4020: @248964
     /* 248964 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(248997), // Rule ID 2382 //
     /* 248969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248988 */     // (intrinsic_wo_chain:{ *:[f32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[f32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0)
     /* 248988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248995 */     GIR_RootConstrainSelectedInstOperands,
     /* 248996 */     // GIR_Coverage, 2382,
     /* 248996 */     GIR_EraseRootFromParent_Done,
     /* 248997 */   // Label 4021: @248997
     /* 248997 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(249030), // Rule ID 2383 //
     /* 249002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249021 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)
     /* 249021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249028 */     GIR_RootConstrainSelectedInstOperands,
     /* 249029 */     // GIR_Coverage, 2383,
     /* 249029 */     GIR_EraseRootFromParent_Done,
     /* 249030 */   // Label 4022: @249030
     /* 249030 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(249063), // Rule ID 2384 //
     /* 249035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249054 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)
     /* 249054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249061 */     GIR_RootConstrainSelectedInstOperands,
     /* 249062 */     // GIR_Coverage, 2384,
     /* 249062 */     GIR_EraseRootFromParent_Done,
     /* 249063 */   // Label 4023: @249063
     /* 249063 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(249096), // Rule ID 2385 //
     /* 249068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 249076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 249079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249087 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 249087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249094 */     GIR_RootConstrainSelectedInstOperands,
     /* 249095 */     // GIR_Coverage, 2385,
     /* 249095 */     GIR_EraseRootFromParent_Done,
     /* 249096 */   // Label 4024: @249096
     /* 249096 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(249129), // Rule ID 2386 //
     /* 249101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 249109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 249112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249120 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 249120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249127 */     GIR_RootConstrainSelectedInstOperands,
     /* 249128 */     // GIR_Coverage, 2386,
     /* 249128 */     GIR_EraseRootFromParent_Done,
     /* 249129 */   // Label 4025: @249129
     /* 249129 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(249162), // Rule ID 2387 //
     /* 249134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 249142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 249145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249153 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 249153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249160 */     GIR_RootConstrainSelectedInstOperands,
     /* 249161 */     // GIR_Coverage, 2387,
     /* 249161 */     GIR_EraseRootFromParent_Done,
     /* 249162 */   // Label 4026: @249162
     /* 249162 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(249195), // Rule ID 2388 //
     /* 249167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 249172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 249175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 249178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 249182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 249186 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 249186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 249189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249193 */     GIR_RootConstrainSelectedInstOperands,
     /* 249194 */     // GIR_Coverage, 2388,
     /* 249194 */     GIR_EraseRootFromParent_Done,
     /* 249195 */   // Label 4027: @249195
     /* 249195 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(249228), // Rule ID 2415 //
     /* 249200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249219 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249226 */     GIR_RootConstrainSelectedInstOperands,
     /* 249227 */     // GIR_Coverage, 2415,
     /* 249227 */     GIR_EraseRootFromParent_Done,
     /* 249228 */   // Label 4028: @249228
     /* 249228 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(249261), // Rule ID 2416 //
     /* 249233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249252 */     // (intrinsic_wo_chain:{ *:[f32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[f32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[f32] } VRegSrc_32:{ *:[f32] }:$src0)
     /* 249252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249259 */     GIR_RootConstrainSelectedInstOperands,
     /* 249260 */     // GIR_Coverage, 2416,
     /* 249260 */     GIR_EraseRootFromParent_Done,
     /* 249261 */   // Label 4029: @249261
     /* 249261 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(249294), // Rule ID 2417 //
     /* 249266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249285 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[v2i16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2i16] } VRegSrc_32:{ *:[v2i16] }:$src0)
     /* 249285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249292 */     GIR_RootConstrainSelectedInstOperands,
     /* 249293 */     // GIR_Coverage, 2417,
     /* 249293 */     GIR_EraseRootFromParent_Done,
     /* 249294 */   // Label 4030: @249294
     /* 249294 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(249327), // Rule ID 2418 //
     /* 249299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249318 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[v2f16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2f16] } VRegSrc_32:{ *:[v2f16] }:$src0)
     /* 249318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249325 */     GIR_RootConstrainSelectedInstOperands,
     /* 249326 */     // GIR_Coverage, 2418,
     /* 249326 */     GIR_EraseRootFromParent_Done,
     /* 249327 */   // Label 4031: @249327
     /* 249327 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(249360), // Rule ID 2419 //
     /* 249332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 249343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249351 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249358 */     GIR_RootConstrainSelectedInstOperands,
     /* 249359 */     // GIR_Coverage, 2419,
     /* 249359 */     GIR_EraseRootFromParent_Done,
     /* 249360 */   // Label 4032: @249360
     /* 249360 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(249393), // Rule ID 2420 //
     /* 249365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 249376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249384 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249391 */     GIR_RootConstrainSelectedInstOperands,
     /* 249392 */     // GIR_Coverage, 2420,
     /* 249392 */     GIR_EraseRootFromParent_Done,
     /* 249393 */   // Label 4033: @249393
     /* 249393 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(249426), // Rule ID 2421 //
     /* 249398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 249409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249417 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249424 */     GIR_RootConstrainSelectedInstOperands,
     /* 249425 */     // GIR_Coverage, 2421,
     /* 249425 */     GIR_EraseRootFromParent_Done,
     /* 249426 */   // Label 4034: @249426
     /* 249426 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(249459), // Rule ID 2422 //
     /* 249431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 249442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249450 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249457 */     GIR_RootConstrainSelectedInstOperands,
     /* 249458 */     // GIR_Coverage, 2422,
     /* 249458 */     GIR_EraseRootFromParent_Done,
     /* 249459 */   // Label 4035: @249459
     /* 249459 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(249491), // Rule ID 2 //
     /* 249464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 249469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249479 */     // (intrinsic_wo_chain:{ *:[i32] } 3190:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_WQM_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 249479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 249482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249489 */     GIR_RootConstrainSelectedInstOperands,
     /* 249490 */     // GIR_Coverage, 2,
     /* 249490 */     GIR_EraseRootFromParent_Done,
     /* 249491 */   // Label 4036: @249491
     /* 249491 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(249523), // Rule ID 3 //
     /* 249496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 249501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249511 */     // (intrinsic_wo_chain:{ *:[i64] } 3190:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_WQM_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 249511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 249514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249521 */     GIR_RootConstrainSelectedInstOperands,
     /* 249522 */     // GIR_Coverage, 3,
     /* 249522 */     GIR_EraseRootFromParent_Done,
     /* 249523 */   // Label 4037: @249523
     /* 249523 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(249552), // Rule ID 21 //
     /* 249528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 249533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249543 */     // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_QUADMASK_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 249543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B32),
     /* 249546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249550 */     GIR_RootConstrainSelectedInstOperands,
     /* 249551 */     // GIR_Coverage, 21,
     /* 249551 */     GIR_EraseRootFromParent_Done,
     /* 249552 */   // Label 4038: @249552
     /* 249552 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(249581), // Rule ID 22 //
     /* 249557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 249562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249572 */     // (intrinsic_wo_chain:{ *:[i64] } 3170:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_QUADMASK_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 249572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B64),
     /* 249575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249579 */     GIR_RootConstrainSelectedInstOperands,
     /* 249580 */     // GIR_Coverage, 22,
     /* 249580 */     GIR_EraseRootFromParent_Done,
     /* 249581 */   // Label 4039: @249581
     /* 249581 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(249613), // Rule ID 24 //
     /* 249586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 249589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_bitreplicate),
     /* 249594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249604 */     // (intrinsic_wo_chain:{ *:[i64] } 3152:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_BITREPLICATE_B64_B32:{ *:[i64] } i32:{ *:[i32] }:$src0)
     /* 249604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BITREPLICATE_B64_B32),
     /* 249607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249611 */     GIR_RootConstrainSelectedInstOperands,
     /* 249612 */     // GIR_Coverage, 24,
     /* 249612 */     GIR_EraseRootFromParent_Done,
     /* 249613 */   // Label 4040: @249613
     /* 249613 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(249648), // Rule ID 1864 //
     /* 249618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 249621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 249626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 249629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 249632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249636 */     // (intrinsic_wo_chain:{ *:[i1] } 3332:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B32:{ *:[i1] }:{ *:[i1] } SSrc_b32:{ *:[i1] }:$src0)
     /* 249636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249646 */     GIR_RootConstrainSelectedInstOperands,
     /* 249647 */     // GIR_Coverage, 1864,
     /* 249647 */     GIR_EraseRootFromParent_Done,
     /* 249648 */   // Label 4041: @249648
     /* 249648 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(249683), // Rule ID 1865 //
     /* 249653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 249656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 249661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 249664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 249667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249671 */     // (intrinsic_wo_chain:{ *:[i1] } 3332:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B64:{ *:[i1] }:{ *:[i1] } SSrc_b64:{ *:[i1] }:$src0)
     /* 249671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 249674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249681 */     GIR_RootConstrainSelectedInstOperands,
     /* 249682 */     // GIR_Coverage, 1865,
     /* 249682 */     GIR_EraseRootFromParent_Done,
     /* 249683 */   // Label 4042: @249683
     /* 249683 */   GIM_Reject,
     /* 249684 */ // Label 4018: @249684
     /* 249684 */ GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(252009),
     /* 249689 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 249692 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(249744), // Rule ID 1364 //
     /* 249697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 249700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_permute),
     /* 249705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249725 */     // (intrinsic_wo_chain:{ *:[i32] } 2185:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_PERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PERMUTE_B32),
     /* 249728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249735 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249742 */     GIR_RootConstrainSelectedInstOperands,
     /* 249743 */     // GIR_Coverage, 1364,
     /* 249743 */     GIR_EraseRootFromParent_Done,
     /* 249744 */   // Label 4044: @249744
     /* 249744 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(249796), // Rule ID 1365 //
     /* 249749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 249752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute),
     /* 249757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249777 */     // (intrinsic_wo_chain:{ *:[i32] } 2170:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_B32),
     /* 249780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249787 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249794 */     GIR_RootConstrainSelectedInstOperands,
     /* 249795 */     // GIR_Coverage, 1365,
     /* 249795 */     GIR_EraseRootFromParent_Done,
     /* 249796 */   // Label 4045: @249796
     /* 249796 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(249848), // Rule ID 1366 //
     /* 249801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute_fi_b32),
     /* 249809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249829 */     // (intrinsic_wo_chain:{ *:[i32] } 2171:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_FI_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_FI_B32),
     /* 249832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249839 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249846 */     GIR_RootConstrainSelectedInstOperands,
     /* 249847 */     // GIR_Coverage, 1366,
     /* 249847 */     GIR_EraseRootFromParent_Done,
     /* 249848 */   // Label 4046: @249848
     /* 249848 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(249901), // Rule ID 2446 //
     /* 249853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 249856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249871 */     // MIs[0] dpp8
     /* 249871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249874 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 249877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249889 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249899 */     GIR_RootConstrainSelectedInstOperands,
     /* 249900 */     // GIR_Coverage, 2446,
     /* 249900 */     GIR_EraseRootFromParent_Done,
     /* 249901 */   // Label 4047: @249901
     /* 249901 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(249954), // Rule ID 2447 //
     /* 249906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 249909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249924 */     // MIs[0] dpp8
     /* 249924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249927 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 249930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249942 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249952 */     GIR_RootConstrainSelectedInstOperands,
     /* 249953 */     // GIR_Coverage, 2447,
     /* 249953 */     GIR_EraseRootFromParent_Done,
     /* 249954 */   // Label 4048: @249954
     /* 249954 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(250007), // Rule ID 2448 //
     /* 249959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 249962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249977 */     // MIs[0] dpp8
     /* 249977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249980 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 249983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249995 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250005 */     GIR_RootConstrainSelectedInstOperands,
     /* 250006 */     // GIR_Coverage, 2448,
     /* 250006 */     GIR_EraseRootFromParent_Done,
     /* 250007 */   // Label 4049: @250007
     /* 250007 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(250060), // Rule ID 2449 //
     /* 250012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250030 */     // MIs[0] dpp8
     /* 250030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250033 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250058 */     GIR_RootConstrainSelectedInstOperands,
     /* 250059 */     // GIR_Coverage, 2449,
     /* 250059 */     GIR_EraseRootFromParent_Done,
     /* 250060 */   // Label 4050: @250060
     /* 250060 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(250113), // Rule ID 2450 //
     /* 250065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250083 */     // MIs[0] dpp8
     /* 250083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250086 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250101 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250111 */     GIR_RootConstrainSelectedInstOperands,
     /* 250112 */     // GIR_Coverage, 2450,
     /* 250112 */     GIR_EraseRootFromParent_Done,
     /* 250113 */   // Label 4051: @250113
     /* 250113 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(250166), // Rule ID 2451 //
     /* 250118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250136 */     // MIs[0] dpp8
     /* 250136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250139 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250154 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250164 */     GIR_RootConstrainSelectedInstOperands,
     /* 250165 */     // GIR_Coverage, 2451,
     /* 250165 */     GIR_EraseRootFromParent_Done,
     /* 250166 */   // Label 4052: @250166
     /* 250166 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(250219), // Rule ID 2452 //
     /* 250171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250189 */     // MIs[0] dpp8
     /* 250189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250192 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250207 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250217 */     GIR_RootConstrainSelectedInstOperands,
     /* 250218 */     // GIR_Coverage, 2452,
     /* 250218 */     GIR_EraseRootFromParent_Done,
     /* 250219 */   // Label 4053: @250219
     /* 250219 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(250272), // Rule ID 2453 //
     /* 250224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250242 */     // MIs[0] dpp8
     /* 250242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250245 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250250 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250252 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250260 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250270 */     GIR_RootConstrainSelectedInstOperands,
     /* 250271 */     // GIR_Coverage, 2453,
     /* 250271 */     GIR_EraseRootFromParent_Done,
     /* 250272 */   // Label 4054: @250272
     /* 250272 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(250325), // Rule ID 2454 //
     /* 250277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250295 */     // MIs[0] dpp8
     /* 250295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250298 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250313 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250323 */     GIR_RootConstrainSelectedInstOperands,
     /* 250324 */     // GIR_Coverage, 2454,
     /* 250324 */     GIR_EraseRootFromParent_Done,
     /* 250325 */   // Label 4055: @250325
     /* 250325 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(250378), // Rule ID 2455 //
     /* 250330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250348 */     // MIs[0] dpp8
     /* 250348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250351 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250366 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250376 */     GIR_RootConstrainSelectedInstOperands,
     /* 250377 */     // GIR_Coverage, 2455,
     /* 250377 */     GIR_EraseRootFromParent_Done,
     /* 250378 */   // Label 4056: @250378
     /* 250378 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(250431), // Rule ID 2456 //
     /* 250383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250401 */     // MIs[0] dpp8
     /* 250401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250404 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250419 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250429 */     GIR_RootConstrainSelectedInstOperands,
     /* 250430 */     // GIR_Coverage, 2456,
     /* 250430 */     GIR_EraseRootFromParent_Done,
     /* 250431 */   // Label 4057: @250431
     /* 250431 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(250484), // Rule ID 2457 //
     /* 250436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250454 */     // MIs[0] dpp8
     /* 250454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250457 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250472 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250482 */     GIR_RootConstrainSelectedInstOperands,
     /* 250483 */     // GIR_Coverage, 2457,
     /* 250483 */     GIR_EraseRootFromParent_Done,
     /* 250484 */   // Label 4058: @250484
     /* 250484 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(250537), // Rule ID 2458 //
     /* 250489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250507 */     // MIs[0] dpp8
     /* 250507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250510 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250525 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250535 */     GIR_RootConstrainSelectedInstOperands,
     /* 250536 */     // GIR_Coverage, 2458,
     /* 250536 */     GIR_EraseRootFromParent_Done,
     /* 250537 */   // Label 4059: @250537
     /* 250537 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(250590), // Rule ID 2459 //
     /* 250542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250560 */     // MIs[0] dpp8
     /* 250560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250563 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250578 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250588 */     GIR_RootConstrainSelectedInstOperands,
     /* 250589 */     // GIR_Coverage, 2459,
     /* 250589 */     GIR_EraseRootFromParent_Done,
     /* 250590 */   // Label 4060: @250590
     /* 250590 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(250643), // Rule ID 2460 //
     /* 250595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250613 */     // MIs[0] dpp8
     /* 250613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250616 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250623 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250631 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250641 */     GIR_RootConstrainSelectedInstOperands,
     /* 250642 */     // GIR_Coverage, 2460,
     /* 250642 */     GIR_EraseRootFromParent_Done,
     /* 250643 */   // Label 4061: @250643
     /* 250643 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(250696), // Rule ID 2461 //
     /* 250648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250666 */     // MIs[0] dpp8
     /* 250666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250669 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250684 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250694 */     GIR_RootConstrainSelectedInstOperands,
     /* 250695 */     // GIR_Coverage, 2461,
     /* 250695 */     GIR_EraseRootFromParent_Done,
     /* 250696 */   // Label 4062: @250696
     /* 250696 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(250749), // Rule ID 2462 //
     /* 250701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250719 */     // MIs[0] dpp8
     /* 250719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250722 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250737 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250747 */     GIR_RootConstrainSelectedInstOperands,
     /* 250748 */     // GIR_Coverage, 2462,
     /* 250748 */     GIR_EraseRootFromParent_Done,
     /* 250749 */   // Label 4063: @250749
     /* 250749 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(250802), // Rule ID 2463 //
     /* 250754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250772 */     // MIs[0] dpp8
     /* 250772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250775 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250790 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250800 */     GIR_RootConstrainSelectedInstOperands,
     /* 250801 */     // GIR_Coverage, 2463,
     /* 250801 */     GIR_EraseRootFromParent_Done,
     /* 250802 */   // Label 4064: @250802
     /* 250802 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(250855), // Rule ID 2464 //
     /* 250807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250825 */     // MIs[0] dpp8
     /* 250825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250828 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250835 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250843 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250853 */     GIR_RootConstrainSelectedInstOperands,
     /* 250854 */     // GIR_Coverage, 2464,
     /* 250854 */     GIR_EraseRootFromParent_Done,
     /* 250855 */   // Label 4065: @250855
     /* 250855 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(250908), // Rule ID 2465 //
     /* 250860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250878 */     // MIs[0] dpp8
     /* 250878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250881 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250896 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250906 */     GIR_RootConstrainSelectedInstOperands,
     /* 250907 */     // GIR_Coverage, 2465,
     /* 250907 */     GIR_EraseRootFromParent_Done,
     /* 250908 */   // Label 4066: @250908
     /* 250908 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(250961), // Rule ID 2466 //
     /* 250913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250931 */     // MIs[0] dpp8
     /* 250931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250934 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250949 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250959 */     GIR_RootConstrainSelectedInstOperands,
     /* 250960 */     // GIR_Coverage, 2466,
     /* 250960 */     GIR_EraseRootFromParent_Done,
     /* 250961 */   // Label 4067: @250961
     /* 250961 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(251014), // Rule ID 2467 //
     /* 250966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 250977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 250980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250984 */     // MIs[0] dpp8
     /* 250984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250987 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250994 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 251002 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 251012 */     GIR_RootConstrainSelectedInstOperands,
     /* 251013 */     // GIR_Coverage, 2467,
     /* 251013 */     GIR_EraseRootFromParent_Done,
     /* 251014 */   // Label 4068: @251014
     /* 251014 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(251067), // Rule ID 2468 //
     /* 251019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 251022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 251027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251037 */     // MIs[0] dpp8
     /* 251037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251040 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 251040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 251043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 251055 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 251065 */     GIR_RootConstrainSelectedInstOperands,
     /* 251066 */     // GIR_Coverage, 2468,
     /* 251066 */     GIR_EraseRootFromParent_Done,
     /* 251067 */   // Label 4069: @251067
     /* 251067 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(251120), // Rule ID 2469 //
     /* 251072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 251080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251090 */     // MIs[0] dpp8
     /* 251090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251093 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 251093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 251096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251102 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 251108 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 251118 */     GIR_RootConstrainSelectedInstOperands,
     /* 251119 */     // GIR_Coverage, 2469,
     /* 251119 */     GIR_EraseRootFromParent_Done,
     /* 251120 */   // Label 4070: @251120
     /* 251120 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(251161), // Rule ID 7796 //
     /* 251125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_swizzle),
     /* 251130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251140 */     // MIs[0] offset16
     /* 251140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251143 */     // (intrinsic_wo_chain:{ *:[i32] } 2191:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset16)  =>  (DS_SWIZZLE_B32:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, (as_i16timm:{ *:[i16] } ?:{ *:[i32] }:$offset16), 0:{ *:[i1] })
     /* 251143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SWIZZLE_B32),
     /* 251146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset16
     /* 251156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251159 */     GIR_RootConstrainSelectedInstOperands,
     /* 251160 */     // GIR_Coverage, 7796,
     /* 251160 */     GIR_EraseRootFromParent_Done,
     /* 251161 */   // Label 4071: @251161
     /* 251161 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(251195), // Rule ID 2470 //
     /* 251166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251184 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251191 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251193 */     GIR_RootConstrainSelectedInstOperands,
     /* 251194 */     // GIR_Coverage, 2470,
     /* 251194 */     GIR_EraseRootFromParent_Done,
     /* 251195 */   // Label 4072: @251195
     /* 251195 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(251229), // Rule ID 2472 //
     /* 251200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251218 */     // (intrinsic_wo_chain:{ *:[f32] } 3142:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251225 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251227 */     GIR_RootConstrainSelectedInstOperands,
     /* 251228 */     // GIR_Coverage, 2472,
     /* 251228 */     GIR_EraseRootFromParent_Done,
     /* 251229 */   // Label 4073: @251229
     /* 251229 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(251263), // Rule ID 2474 //
     /* 251234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251252 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3142:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251259 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251261 */     GIR_RootConstrainSelectedInstOperands,
     /* 251262 */     // GIR_Coverage, 2474,
     /* 251262 */     GIR_EraseRootFromParent_Done,
     /* 251263 */   // Label 4074: @251263
     /* 251263 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(251297), // Rule ID 2476 //
     /* 251268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251286 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3142:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251295 */     GIR_RootConstrainSelectedInstOperands,
     /* 251296 */     // GIR_Coverage, 2476,
     /* 251296 */     GIR_EraseRootFromParent_Done,
     /* 251297 */   // Label 4075: @251297
     /* 251297 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(251331), // Rule ID 2478 //
     /* 251302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 251310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 251313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251320 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251329 */     GIR_RootConstrainSelectedInstOperands,
     /* 251330 */     // GIR_Coverage, 2478,
     /* 251330 */     GIR_EraseRootFromParent_Done,
     /* 251331 */   // Label 4076: @251331
     /* 251331 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(251365), // Rule ID 2480 //
     /* 251336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 251344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 251347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251354 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251361 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251363 */     GIR_RootConstrainSelectedInstOperands,
     /* 251364 */     // GIR_Coverage, 2480,
     /* 251364 */     GIR_EraseRootFromParent_Done,
     /* 251365 */   // Label 4077: @251365
     /* 251365 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(251399), // Rule ID 2482 //
     /* 251370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 251378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 251381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251388 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251395 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251397 */     GIR_RootConstrainSelectedInstOperands,
     /* 251398 */     // GIR_Coverage, 2482,
     /* 251398 */     GIR_EraseRootFromParent_Done,
     /* 251399 */   // Label 4078: @251399
     /* 251399 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(251433), // Rule ID 2484 //
     /* 251404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251422 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251429 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251431 */     GIR_RootConstrainSelectedInstOperands,
     /* 251432 */     // GIR_Coverage, 2484,
     /* 251432 */     GIR_EraseRootFromParent_Done,
     /* 251433 */   // Label 4079: @251433
     /* 251433 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(251490), // Rule ID 6939 //
     /* 251438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251456 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251483 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251488 */     GIR_RootConstrainSelectedInstOperands,
     /* 251489 */     // GIR_Coverage, 6939,
     /* 251489 */     GIR_EraseRootFromParent_Done,
     /* 251490 */   // Label 4080: @251490
     /* 251490 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(251547), // Rule ID 6940 //
     /* 251495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251513 */     // (intrinsic_wo_chain:{ *:[f32] } 3200:{ *:[iPTR] }, f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[f32] } 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251540 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251545 */     GIR_RootConstrainSelectedInstOperands,
     /* 251546 */     // GIR_Coverage, 6940,
     /* 251546 */     GIR_EraseRootFromParent_Done,
     /* 251547 */   // Label 4081: @251547
     /* 251547 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(251604), // Rule ID 6941 //
     /* 251552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 251566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251570 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3200:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, v2i16:{ *:[v2i16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251592 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251597 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251602 */     GIR_RootConstrainSelectedInstOperands,
     /* 251603 */     // GIR_Coverage, 6941,
     /* 251603 */     GIR_EraseRootFromParent_Done,
     /* 251604 */   // Label 4082: @251604
     /* 251604 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(251661), // Rule ID 6942 //
     /* 251609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 251623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251627 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3200:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, v2f16:{ *:[v2f16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251654 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251659 */     GIR_RootConstrainSelectedInstOperands,
     /* 251660 */     // GIR_Coverage, 6942,
     /* 251660 */     GIR_EraseRootFromParent_Done,
     /* 251661 */   // Label 4083: @251661
     /* 251661 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(251718), // Rule ID 6943 //
     /* 251666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 251674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 251677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 251680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251684 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p2:{ *:[i32] }:$src, p2:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251711 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251716 */     GIR_RootConstrainSelectedInstOperands,
     /* 251717 */     // GIR_Coverage, 6943,
     /* 251717 */     GIR_EraseRootFromParent_Done,
     /* 251718 */   // Label 4084: @251718
     /* 251718 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(251775), // Rule ID 6944 //
     /* 251723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 251731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 251734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 251737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251741 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p3:{ *:[i32] }:$src, p3:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251768 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251773 */     GIR_RootConstrainSelectedInstOperands,
     /* 251774 */     // GIR_Coverage, 6944,
     /* 251774 */     GIR_EraseRootFromParent_Done,
     /* 251775 */   // Label 4085: @251775
     /* 251775 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(251832), // Rule ID 6945 //
     /* 251780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 251788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 251791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 251794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251798 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p5:{ *:[i32] }:$src, p5:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251825 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251830 */     GIR_RootConstrainSelectedInstOperands,
     /* 251831 */     // GIR_Coverage, 6945,
     /* 251831 */     GIR_EraseRootFromParent_Done,
     /* 251832 */   // Label 4086: @251832
     /* 251832 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(251889), // Rule ID 6946 //
     /* 251837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 251851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251855 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p6:{ *:[i32] }:$src, p6:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251882 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251887 */     GIR_RootConstrainSelectedInstOperands,
     /* 251888 */     // GIR_Coverage, 6946,
     /* 251888 */     GIR_EraseRootFromParent_Done,
     /* 251889 */   // Label 4087: @251889
     /* 251889 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(251946), // Rule ID 6947 //
     /* 251894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive_chain_arg),
     /* 251899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251912 */     // (intrinsic_wo_chain:{ *:[i32] } 3201:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251939 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251944 */     GIR_RootConstrainSelectedInstOperands,
     /* 251945 */     // GIR_Coverage, 6947,
     /* 251945 */     GIR_EraseRootFromParent_Done,
     /* 251946 */   // Label 4088: @251946
     /* 251946 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(251977), // Rule ID 1336 //
     /* 251951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umin),
     /* 251956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 251966 */     // MIs[0] strategy
     /* 251966 */     // No operand predicates
     /* 251966 */     // (intrinsic_wo_chain:{ *:[i32] } 3309:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMIN_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 251966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMIN_PSEUDO_U32),
     /* 251969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 251971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251973 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 251975 */     GIR_RootConstrainSelectedInstOperands,
     /* 251976 */     // GIR_Coverage, 1336,
     /* 251976 */     GIR_EraseRootFromParent_Done,
     /* 251977 */   // Label 4089: @251977
     /* 251977 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(252008), // Rule ID 1337 //
     /* 251982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umax),
     /* 251987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 251997 */     // MIs[0] strategy
     /* 251997 */     // No operand predicates
     /* 251997 */     // (intrinsic_wo_chain:{ *:[i32] } 3308:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMAX_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 251997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMAX_PSEUDO_U32),
     /* 252000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 252002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 252004 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 252006 */     GIR_RootConstrainSelectedInstOperands,
     /* 252007 */     // GIR_Coverage, 1337,
     /* 252007 */     GIR_EraseRootFromParent_Done,
     /* 252008 */   // Label 4090: @252008
     /* 252008 */   GIM_Reject,
     /* 252009 */ // Label 4043: @252009
     /* 252009 */ GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(254334),
     /* 252014 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 252017 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(252108), // Rule ID 2815 //
     /* 252022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 252039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252067 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w32_threeaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_threeaddr),
     /* 252070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252106 */     GIR_RootConstrainSelectedInstOperands,
     /* 252107 */     // GIR_Coverage, 2815,
     /* 252107 */     GIR_EraseRootFromParent_Done,
     /* 252108 */   // Label 4092: @252108
     /* 252108 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(252199), // Rule ID 2848 //
     /* 252113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 252127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 252130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252158 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 252158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_threeaddr),
     /* 252161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252197 */     GIR_RootConstrainSelectedInstOperands,
     /* 252198 */     // GIR_Coverage, 2848,
     /* 252198 */     GIR_EraseRootFromParent_Done,
     /* 252199 */   // Label 4093: @252199
     /* 252199 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(252292), // Rule ID 2800 //
     /* 252204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 252207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252249 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 252249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w32),
     /* 252252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252290 */     GIR_RootConstrainSelectedInstOperands,
     /* 252291 */     // GIR_Coverage, 2800,
     /* 252291 */     GIR_EraseRootFromParent_Done,
     /* 252292 */   // Label 4094: @252292
     /* 252292 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(252385), // Rule ID 2801 //
     /* 252297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 252300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252342 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 252342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w32),
     /* 252345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252383 */     GIR_RootConstrainSelectedInstOperands,
     /* 252384 */     // GIR_Coverage, 2801,
     /* 252384 */     GIR_EraseRootFromParent_Done,
     /* 252385 */   // Label 4095: @252385
     /* 252385 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(252478), // Rule ID 2806 //
     /* 252390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 252393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252435 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w64),
     /* 252438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252476 */     GIR_RootConstrainSelectedInstOperands,
     /* 252477 */     // GIR_Coverage, 2806,
     /* 252477 */     GIR_EraseRootFromParent_Done,
     /* 252478 */   // Label 4096: @252478
     /* 252478 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(252571), // Rule ID 2807 //
     /* 252483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 252486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252528 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w64),
     /* 252531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252569 */     GIR_RootConstrainSelectedInstOperands,
     /* 252570 */     // GIR_Coverage, 2807,
     /* 252570 */     GIR_EraseRootFromParent_Done,
     /* 252571 */   // Label 4097: @252571
     /* 252571 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(252664), // Rule ID 2814 //
     /* 252576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 252593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 252621 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 252621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_twoaddr),
     /* 252624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252662 */     GIR_RootConstrainSelectedInstOperands,
     /* 252663 */     // GIR_Coverage, 2814,
     /* 252663 */     GIR_EraseRootFromParent_Done,
     /* 252664 */   // Label 4098: @252664
     /* 252664 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(252757), // Rule ID 2847 //
     /* 252669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 252683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 252686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 252714 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_twoaddr),
     /* 252717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252755 */     GIR_RootConstrainSelectedInstOperands,
     /* 252756 */     // GIR_Coverage, 2847,
     /* 252756 */     GIR_EraseRootFromParent_Done,
     /* 252757 */   // Label 4099: @252757
     /* 252757 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(252824), // Rule ID 2817 //
     /* 252762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 252779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252793 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w32_threeaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_threeaddr),
     /* 252796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252806 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252822 */     GIR_RootConstrainSelectedInstOperands,
     /* 252823 */     // GIR_Coverage, 2817,
     /* 252823 */     GIR_EraseRootFromParent_Done,
     /* 252824 */   // Label 4100: @252824
     /* 252824 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(252885), // Rule ID 2827 //
     /* 252829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 252837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252860 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3320:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr),
     /* 252863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252867 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252883 */     GIR_RootConstrainSelectedInstOperands,
     /* 252884 */     // GIR_Coverage, 2827,
     /* 252884 */     GIR_EraseRootFromParent_Done,
     /* 252885 */   // Label 4101: @252885
     /* 252885 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(252946), // Rule ID 2829 //
     /* 252890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 252898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252921 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3319:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr),
     /* 252924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252928 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252944 */     GIR_RootConstrainSelectedInstOperands,
     /* 252945 */     // GIR_Coverage, 2829,
     /* 252945 */     GIR_EraseRootFromParent_Done,
     /* 252946 */   // Label 4102: @252946
     /* 252946 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(253007), // Rule ID 2831 //
     /* 252951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 252959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252982 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3317:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr),
     /* 252985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252987 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252989 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253005 */     GIR_RootConstrainSelectedInstOperands,
     /* 253006 */     // GIR_Coverage, 2831,
     /* 253006 */     GIR_EraseRootFromParent_Done,
     /* 253007 */   // Label 4103: @253007
     /* 253007 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(253068), // Rule ID 2833 //
     /* 253012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253043 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3316:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 253043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr),
     /* 253046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253050 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253066 */     GIR_RootConstrainSelectedInstOperands,
     /* 253067 */     // GIR_Coverage, 2833,
     /* 253067 */     GIR_EraseRootFromParent_Done,
     /* 253068 */   // Label 4104: @253068
     /* 253068 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(253135), // Rule ID 2850 //
     /* 253073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 253081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 253087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 253090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253104 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w64_threeaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_threeaddr),
     /* 253107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253112 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253117 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253133 */     GIR_RootConstrainSelectedInstOperands,
     /* 253134 */     // GIR_Coverage, 2850,
     /* 253134 */     GIR_EraseRootFromParent_Done,
     /* 253135 */   // Label 4105: @253135
     /* 253135 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(253196), // Rule ID 2860 //
     /* 253140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 253148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253171 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3320:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr),
     /* 253174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253178 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253194 */     GIR_RootConstrainSelectedInstOperands,
     /* 253195 */     // GIR_Coverage, 2860,
     /* 253195 */     GIR_EraseRootFromParent_Done,
     /* 253196 */   // Label 4106: @253196
     /* 253196 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(253257), // Rule ID 2862 //
     /* 253201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 253209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253232 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3319:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr),
     /* 253235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253239 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253255 */     GIR_RootConstrainSelectedInstOperands,
     /* 253256 */     // GIR_Coverage, 2862,
     /* 253256 */     GIR_EraseRootFromParent_Done,
     /* 253257 */   // Label 4107: @253257
     /* 253257 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(253318), // Rule ID 2864 //
     /* 253262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 253270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253293 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3317:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr),
     /* 253296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253300 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253316 */     GIR_RootConstrainSelectedInstOperands,
     /* 253317 */     // GIR_Coverage, 2864,
     /* 253317 */     GIR_EraseRootFromParent_Done,
     /* 253318 */   // Label 4108: @253318
     /* 253318 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(253379), // Rule ID 2866 //
     /* 253323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253354 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3316:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr),
     /* 253357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253361 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253377 */     GIR_RootConstrainSelectedInstOperands,
     /* 253378 */     // GIR_Coverage, 2866,
     /* 253378 */     GIR_EraseRootFromParent_Done,
     /* 253379 */   // Label 4109: @253379
     /* 253379 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(253448), // Rule ID 2816 //
     /* 253384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 253392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 253398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 253401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253415 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_twoaddr),
     /* 253418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253428 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253446 */     GIR_RootConstrainSelectedInstOperands,
     /* 253447 */     // GIR_Coverage, 2816,
     /* 253447 */     GIR_EraseRootFromParent_Done,
     /* 253448 */   // Label 4110: @253448
     /* 253448 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(253511), // Rule ID 2826 //
     /* 253453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 253461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253484 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3320:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr),
     /* 253487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253491 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253509 */     GIR_RootConstrainSelectedInstOperands,
     /* 253510 */     // GIR_Coverage, 2826,
     /* 253510 */     GIR_EraseRootFromParent_Done,
     /* 253511 */   // Label 4111: @253511
     /* 253511 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(253574), // Rule ID 2828 //
     /* 253516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 253524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253547 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3319:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr),
     /* 253550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253552 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253554 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253572 */     GIR_RootConstrainSelectedInstOperands,
     /* 253573 */     // GIR_Coverage, 2828,
     /* 253573 */     GIR_EraseRootFromParent_Done,
     /* 253574 */   // Label 4112: @253574
     /* 253574 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(253637), // Rule ID 2830 //
     /* 253579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 253587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253610 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3317:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr),
     /* 253613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253635 */     GIR_RootConstrainSelectedInstOperands,
     /* 253636 */     // GIR_Coverage, 2830,
     /* 253636 */     GIR_EraseRootFromParent_Done,
     /* 253637 */   // Label 4113: @253637
     /* 253637 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(253700), // Rule ID 2832 //
     /* 253642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253673 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3316:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr),
     /* 253676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253680 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253698 */     GIR_RootConstrainSelectedInstOperands,
     /* 253699 */     // GIR_Coverage, 2832,
     /* 253699 */     GIR_EraseRootFromParent_Done,
     /* 253700 */   // Label 4114: @253700
     /* 253700 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(253769), // Rule ID 2849 //
     /* 253705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 253713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 253719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 253722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253736 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_twoaddr),
     /* 253739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253749 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253767 */     GIR_RootConstrainSelectedInstOperands,
     /* 253768 */     // GIR_Coverage, 2849,
     /* 253768 */     GIR_EraseRootFromParent_Done,
     /* 253769 */   // Label 4115: @253769
     /* 253769 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(253832), // Rule ID 2859 //
     /* 253774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 253782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253805 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3320:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr),
     /* 253808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253812 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253830 */     GIR_RootConstrainSelectedInstOperands,
     /* 253831 */     // GIR_Coverage, 2859,
     /* 253831 */     GIR_EraseRootFromParent_Done,
     /* 253832 */   // Label 4116: @253832
     /* 253832 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(253895), // Rule ID 2861 //
     /* 253837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 253845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253868 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3319:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr),
     /* 253871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253873 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253875 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253893 */     GIR_RootConstrainSelectedInstOperands,
     /* 253894 */     // GIR_Coverage, 2861,
     /* 253894 */     GIR_EraseRootFromParent_Done,
     /* 253895 */   // Label 4117: @253895
     /* 253895 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(253958), // Rule ID 2863 //
     /* 253900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 253908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253931 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3317:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr),
     /* 253934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253956 */     GIR_RootConstrainSelectedInstOperands,
     /* 253957 */     // GIR_Coverage, 2863,
     /* 253957 */     GIR_EraseRootFromParent_Done,
     /* 253958 */   // Label 4118: @253958
     /* 253958 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(254021), // Rule ID 2865 //
     /* 253963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253994 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3316:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr),
     /* 253997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 254008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 254013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254019 */     GIR_RootConstrainSelectedInstOperands,
     /* 254020 */     // GIR_Coverage, 2865,
     /* 254020 */     GIR_EraseRootFromParent_Done,
     /* 254021 */   // Label 4119: @254021
     /* 254021 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(254060), // Rule ID 2471 //
     /* 254026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 254043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254047 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254054 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254056 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254058 */     GIR_RootConstrainSelectedInstOperands,
     /* 254059 */     // GIR_Coverage, 2471,
     /* 254059 */     GIR_EraseRootFromParent_Done,
     /* 254060 */   // Label 4120: @254060
     /* 254060 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(254099), // Rule ID 2473 //
     /* 254065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 254082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254086 */     // (intrinsic_wo_chain:{ *:[f32] } 3333:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[f32] } SCSrc_b32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[f32] }:$src2)
     /* 254086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254095 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254097 */     GIR_RootConstrainSelectedInstOperands,
     /* 254098 */     // GIR_Coverage, 2473,
     /* 254098 */     GIR_EraseRootFromParent_Done,
     /* 254099 */   // Label 4121: @254099
     /* 254099 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(254138), // Rule ID 2475 //
     /* 254104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 254121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254125 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3333:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, v2i16:{ *:[v2i16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2i16] } SCSrc_b32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2i16] }:$src2)
     /* 254125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254132 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254134 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254136 */     GIR_RootConstrainSelectedInstOperands,
     /* 254137 */     // GIR_Coverage, 2475,
     /* 254137 */     GIR_EraseRootFromParent_Done,
     /* 254138 */   // Label 4122: @254138
     /* 254138 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(254177), // Rule ID 2477 //
     /* 254143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 254160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254164 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3333:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, v2f16:{ *:[v2f16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2f16] } SCSrc_b32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$src2)
     /* 254164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254171 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254173 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254175 */     GIR_RootConstrainSelectedInstOperands,
     /* 254176 */     // GIR_Coverage, 2477,
     /* 254176 */     GIR_EraseRootFromParent_Done,
     /* 254177 */   // Label 4123: @254177
     /* 254177 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(254216), // Rule ID 2479 //
     /* 254182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 254190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 254193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p2s32,
     /* 254199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254203 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p2:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254210 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254212 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254214 */     GIR_RootConstrainSelectedInstOperands,
     /* 254215 */     // GIR_Coverage, 2479,
     /* 254215 */     GIR_EraseRootFromParent_Done,
     /* 254216 */   // Label 4124: @254216
     /* 254216 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(254255), // Rule ID 2481 //
     /* 254221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 254229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 254232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p3s32,
     /* 254238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254242 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p3:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254247 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254249 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254251 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254253 */     GIR_RootConstrainSelectedInstOperands,
     /* 254254 */     // GIR_Coverage, 2481,
     /* 254254 */     GIR_EraseRootFromParent_Done,
     /* 254255 */   // Label 4125: @254255
     /* 254255 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(254294), // Rule ID 2483 //
     /* 254260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 254268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 254271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p5s32,
     /* 254277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254281 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p5:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254286 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254288 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254290 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254292 */     GIR_RootConstrainSelectedInstOperands,
     /* 254293 */     // GIR_Coverage, 2483,
     /* 254293 */     GIR_EraseRootFromParent_Done,
     /* 254294 */   // Label 4126: @254294
     /* 254294 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(254333), // Rule ID 2485 //
     /* 254299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 254307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 254310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p6s32,
     /* 254316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254320 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p6:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254329 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254331 */     GIR_RootConstrainSelectedInstOperands,
     /* 254332 */     // GIR_Coverage, 2485,
     /* 254332 */     GIR_EraseRootFromParent_Done,
     /* 254333 */   // Label 4127: @254333
     /* 254333 */   GIM_Reject,
     /* 254334 */ // Label 4091: @254334
     /* 254334 */ GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(256807),
     /* 254339 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 254342 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(254444), // Rule ID 2819 //
     /* 254347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254371 */     // MIs[0] Operand 5
     /* 254371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254403 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_threeaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f16:{ *:[v8f16] }:$src2)
     /* 254403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_threeaddr),
     /* 254406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254442 */     GIR_RootConstrainSelectedInstOperands,
     /* 254443 */     // GIR_Coverage, 2819,
     /* 254443 */     GIR_EraseRootFromParent_Done,
     /* 254444 */   // Label 4129: @254444
     /* 254444 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(254546), // Rule ID 2852 //
     /* 254449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254473 */     // MIs[0] Operand 5
     /* 254473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254505 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_threeaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f16:{ *:[v4f16] }:$src2)
     /* 254505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_threeaddr),
     /* 254508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254544 */     GIR_RootConstrainSelectedInstOperands,
     /* 254545 */     // GIR_Coverage, 2852,
     /* 254545 */     GIR_EraseRootFromParent_Done,
     /* 254546 */   // Label 4130: @254546
     /* 254546 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(254650), // Rule ID 2818 //
     /* 254551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254575 */     // MIs[0] Operand 5
     /* 254575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 254607 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 254607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_twoaddr),
     /* 254610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 254637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254648 */     GIR_RootConstrainSelectedInstOperands,
     /* 254649 */     // GIR_Coverage, 2818,
     /* 254649 */     GIR_EraseRootFromParent_Done,
     /* 254650 */   // Label 4131: @254650
     /* 254650 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(254754), // Rule ID 2851 //
     /* 254655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254679 */     // MIs[0] Operand 5
     /* 254679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 254711 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f16:{ *:[v4f16] }:$src2)
     /* 254711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_twoaddr),
     /* 254714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 254741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254752 */     GIR_RootConstrainSelectedInstOperands,
     /* 254753 */     // GIR_Coverage, 2851,
     /* 254753 */     GIR_EraseRootFromParent_Done,
     /* 254754 */   // Label 4132: @254754
     /* 254754 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(254852), // Rule ID 2836 //
     /* 254759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 254767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 254770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 254776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 254779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 254786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 254807 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3293:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 254807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w32_twoaddr),
     /* 254810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254832 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 254844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254850 */     GIR_RootConstrainSelectedInstOperands,
     /* 254851 */     // GIR_Coverage, 2836,
     /* 254851 */     GIR_EraseRootFromParent_Done,
     /* 254852 */   // Label 4133: @254852
     /* 254852 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(254950), // Rule ID 2838 //
     /* 254857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 254865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 254874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 254905 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f16:{ *:[v8f16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 254905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w32_twoaddr),
     /* 254908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254930 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 254942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254948 */     GIR_RootConstrainSelectedInstOperands,
     /* 254949 */     // GIR_Coverage, 2838,
     /* 254949 */     GIR_EraseRootFromParent_Done,
     /* 254950 */   // Label 4134: @254950
     /* 254950 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(255048), // Rule ID 2869 //
     /* 254955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 254963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 254966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 254975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255003 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3293:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w64_twoaddr),
     /* 255006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 255013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 255018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 255023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 255028 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 255035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 255040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255046 */     GIR_RootConstrainSelectedInstOperands,
     /* 255047 */     // GIR_Coverage, 2869,
     /* 255047 */     GIR_EraseRootFromParent_Done,
     /* 255048 */   // Label 4135: @255048
     /* 255048 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(255146), // Rule ID 2871 //
     /* 255053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 255061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 255064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 255073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 255080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 255087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 255094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255101 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f16:{ *:[v4f16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f16:{ *:[v4f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w64_twoaddr),
     /* 255104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 255111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 255116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 255121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 255126 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 255133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 255138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255144 */     GIR_RootConstrainSelectedInstOperands,
     /* 255145 */     // GIR_Coverage, 2871,
     /* 255145 */     GIR_EraseRootFromParent_Done,
     /* 255146 */   // Label 4136: @255146
     /* 255146 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(255224), // Rule ID 2821 //
     /* 255151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 255159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 255162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 255171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255175 */     // MIs[0] Operand 5
     /* 255175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 255186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 255193 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_threeaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 255193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_threeaddr),
     /* 255196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255222 */     GIR_RootConstrainSelectedInstOperands,
     /* 255223 */     // GIR_Coverage, 2821,
     /* 255223 */     GIR_EraseRootFromParent_Done,
     /* 255224 */   // Label 4137: @255224
     /* 255224 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(255302), // Rule ID 2854 //
     /* 255229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 255237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 255240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 255246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 255249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 255253 */     // MIs[0] Operand 5
     /* 255253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 255264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 255271 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3311:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_threeaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 255271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_threeaddr),
     /* 255274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255284 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255300 */     GIR_RootConstrainSelectedInstOperands,
     /* 255301 */     // GIR_Coverage, 2854,
     /* 255301 */     GIR_EraseRootFromParent_Done,
     /* 255302 */   // Label 4138: @255302
     /* 255302 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(255376), // Rule ID 2837 //
     /* 255307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 255315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255341 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3290:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr),
     /* 255344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255356 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255374 */     GIR_RootConstrainSelectedInstOperands,
     /* 255375 */     // GIR_Coverage, 2837,
     /* 255375 */     GIR_EraseRootFromParent_Done,
     /* 255376 */   // Label 4139: @255376
     /* 255376 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(255450), // Rule ID 2839 //
     /* 255381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 255389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 255392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 255401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255415 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3288:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr),
     /* 255418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255428 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255430 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255448 */     GIR_RootConstrainSelectedInstOperands,
     /* 255449 */     // GIR_Coverage, 2839,
     /* 255449 */     GIR_EraseRootFromParent_Done,
     /* 255450 */   // Label 4140: @255450
     /* 255450 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(255512), // Rule ID 2843 //
     /* 255455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 255463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255489 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3295:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr),
     /* 255492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255496 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255498 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255510 */     GIR_RootConstrainSelectedInstOperands,
     /* 255511 */     // GIR_Coverage, 2843,
     /* 255511 */     GIR_EraseRootFromParent_Done,
     /* 255512 */   // Label 4141: @255512
     /* 255512 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(255574), // Rule ID 2844 //
     /* 255517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 255525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255551 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3294:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr),
     /* 255554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255558 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255560 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255572 */     GIR_RootConstrainSelectedInstOperands,
     /* 255573 */     // GIR_Coverage, 2844,
     /* 255573 */     GIR_EraseRootFromParent_Done,
     /* 255574 */   // Label 4142: @255574
     /* 255574 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(255636), // Rule ID 2845 //
     /* 255579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 255587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255613 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3292:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr),
     /* 255616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255634 */     GIR_RootConstrainSelectedInstOperands,
     /* 255635 */     // GIR_Coverage, 2845,
     /* 255635 */     GIR_EraseRootFromParent_Done,
     /* 255636 */   // Label 4143: @255636
     /* 255636 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(255698), // Rule ID 2846 //
     /* 255641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 255649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255675 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3291:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr),
     /* 255678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255684 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255696 */     GIR_RootConstrainSelectedInstOperands,
     /* 255697 */     // GIR_Coverage, 2846,
     /* 255697 */     GIR_EraseRootFromParent_Done,
     /* 255698 */   // Label 4144: @255698
     /* 255698 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(255772), // Rule ID 2870 //
     /* 255703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 255711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255737 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3290:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr),
     /* 255740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255750 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255752 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255770 */     GIR_RootConstrainSelectedInstOperands,
     /* 255771 */     // GIR_Coverage, 2870,
     /* 255771 */     GIR_EraseRootFromParent_Done,
     /* 255772 */   // Label 4145: @255772
     /* 255772 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(255846), // Rule ID 2872 //
     /* 255777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 255785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 255788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 255797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 255804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255811 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3288:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr),
     /* 255814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255824 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255826 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255844 */     GIR_RootConstrainSelectedInstOperands,
     /* 255845 */     // GIR_Coverage, 2872,
     /* 255845 */     GIR_EraseRootFromParent_Done,
     /* 255846 */   // Label 4146: @255846
     /* 255846 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(255908), // Rule ID 2876 //
     /* 255851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 255859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255885 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3295:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr),
     /* 255888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255892 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255894 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255906 */     GIR_RootConstrainSelectedInstOperands,
     /* 255907 */     // GIR_Coverage, 2876,
     /* 255907 */     GIR_EraseRootFromParent_Done,
     /* 255908 */   // Label 4147: @255908
     /* 255908 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(255970), // Rule ID 2877 //
     /* 255913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 255921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255947 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3294:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr),
     /* 255950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255954 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255956 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255968 */     GIR_RootConstrainSelectedInstOperands,
     /* 255969 */     // GIR_Coverage, 2877,
     /* 255969 */     GIR_EraseRootFromParent_Done,
     /* 255970 */   // Label 4148: @255970
     /* 255970 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(256032), // Rule ID 2878 //
     /* 255975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 255983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 256009 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3292:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 256009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr),
     /* 256012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256016 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256018 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 256020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 256025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 256030 */     GIR_RootConstrainSelectedInstOperands,
     /* 256031 */     // GIR_Coverage, 2878,
     /* 256031 */     GIR_EraseRootFromParent_Done,
     /* 256032 */   // Label 4149: @256032
     /* 256032 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(256094), // Rule ID 2879 //
     /* 256037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 256040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 256045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 256054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 256060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 256071 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3291:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 256071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr),
     /* 256074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256078 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256080 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 256082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 256087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 256092 */     GIR_RootConstrainSelectedInstOperands,
     /* 256093 */     // GIR_Coverage, 2879,
     /* 256093 */     GIR_EraseRootFromParent_Done,
     /* 256094 */   // Label 4150: @256094
     /* 256094 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(256166), // Rule ID 2798 //
     /* 256099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 256107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 256110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 256119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256130 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3313:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 256130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w32),
     /* 256133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256143 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256150 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256164 */     GIR_RootConstrainSelectedInstOperands,
     /* 256165 */     // GIR_Coverage, 2798,
     /* 256165 */     GIR_EraseRootFromParent_Done,
     /* 256166 */   // Label 4151: @256166
     /* 256166 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(256238), // Rule ID 2802 //
     /* 256171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 256182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 256191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256202 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3311:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 256202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w32),
     /* 256205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256215 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256222 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256236 */     GIR_RootConstrainSelectedInstOperands,
     /* 256237 */     // GIR_Coverage, 2802,
     /* 256237 */     GIR_EraseRootFromParent_Done,
     /* 256238 */   // Label 4152: @256238
     /* 256238 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(256310), // Rule ID 2803 //
     /* 256243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 256251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 256254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 256263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256274 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3314:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 256274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32),
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256287 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256294 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256308 */     GIR_RootConstrainSelectedInstOperands,
     /* 256309 */     // GIR_Coverage, 2803,
     /* 256309 */     GIR_EraseRootFromParent_Done,
     /* 256310 */   // Label 4153: @256310
     /* 256310 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(256382), // Rule ID 2804 //
     /* 256315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 256323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 256326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 256335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256346 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3312:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 256346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32),
     /* 256349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256366 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256380 */     GIR_RootConstrainSelectedInstOperands,
     /* 256381 */     // GIR_Coverage, 2804,
     /* 256381 */     GIR_EraseRootFromParent_Done,
     /* 256382 */   // Label 4154: @256382
     /* 256382 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(256454), // Rule ID 2808 //
     /* 256387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 256395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256418 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 256418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w64),
     /* 256421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256438 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256452 */     GIR_RootConstrainSelectedInstOperands,
     /* 256453 */     // GIR_Coverage, 2808,
     /* 256453 */     GIR_EraseRootFromParent_Done,
     /* 256454 */   // Label 4155: @256454
     /* 256454 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(256526), // Rule ID 2809 //
     /* 256459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256490 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 256490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w64),
     /* 256493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256503 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256524 */     GIR_RootConstrainSelectedInstOperands,
     /* 256525 */     // GIR_Coverage, 2809,
     /* 256525 */     GIR_EraseRootFromParent_Done,
     /* 256526 */   // Label 4156: @256526
     /* 256526 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(256598), // Rule ID 2810 //
     /* 256531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 256539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256562 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3314:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 256562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64),
     /* 256565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256582 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256596 */     GIR_RootConstrainSelectedInstOperands,
     /* 256597 */     // GIR_Coverage, 2810,
     /* 256597 */     GIR_EraseRootFromParent_Done,
     /* 256598 */   // Label 4157: @256598
     /* 256598 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(256670), // Rule ID 2811 //
     /* 256603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 256611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256634 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3312:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 256634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64),
     /* 256637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256647 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256654 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256668 */     GIR_RootConstrainSelectedInstOperands,
     /* 256669 */     // GIR_Coverage, 2811,
     /* 256669 */     GIR_EraseRootFromParent_Done,
     /* 256670 */   // Label 4158: @256670
     /* 256670 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(256738), // Rule ID 2820 //
     /* 256675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256699 */     // MIs[0] Operand 5
     /* 256699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 256710 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 256710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_twoaddr),
     /* 256713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256728 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256736 */     GIR_RootConstrainSelectedInstOperands,
     /* 256737 */     // GIR_Coverage, 2820,
     /* 256737 */     GIR_EraseRootFromParent_Done,
     /* 256738 */   // Label 4159: @256738
     /* 256738 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(256806), // Rule ID 2853 //
     /* 256743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 256746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 256754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 256763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 256767 */     // MIs[0] Operand 5
     /* 256767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 256778 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3311:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4i16:{ *:[v4i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 256778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_twoaddr),
     /* 256781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256791 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256796 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256804 */     GIR_RootConstrainSelectedInstOperands,
     /* 256805 */     // GIR_Coverage, 2853,
     /* 256805 */     GIR_EraseRootFromParent_Done,
     /* 256806 */   // Label 4160: @256806
     /* 256806 */   GIM_Reject,
     /* 256807 */ // Label 4128: @256807
     /* 256807 */ GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(257079),
     /* 256812 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 256815 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(256885), // Rule ID 2423 //
     /* 256820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 256823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 256828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 256838 */     // MIs[0] dpp_ctrl
     /* 256838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256841 */     // MIs[0] row_mask
     /* 256841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256844 */     // MIs[0] bank_mask
     /* 256844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256847 */     // MIs[0] bound_ctrl
     /* 256847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256850 */     // (intrinsic_wo_chain:{ *:[i32] } 3067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 256850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 256853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 256865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 256871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 256877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 256883 */     GIR_RootConstrainSelectedInstOperands,
     /* 256884 */     // GIR_Coverage, 2423,
     /* 256884 */     GIR_EraseRootFromParent_Done,
     /* 256885 */   // Label 4162: @256885
     /* 256885 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(256952), // Rule ID 7555 //
     /* 256890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 256895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 256898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 256905 */     // MIs[0] dpp_ctrl
     /* 256905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256908 */     // MIs[0] row_mask
     /* 256908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256911 */     // MIs[0] bank_mask
     /* 256911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256914 */     // MIs[0] bound_ctrl
     /* 256914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256917 */     // (intrinsic_wo_chain:{ *:[i64] } 3067:{ *:[iPTR] }, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$src, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 256917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 256920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 256932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 256938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 256944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 256950 */     GIR_RootConstrainSelectedInstOperands,
     /* 256951 */     // GIR_Coverage, 7555,
     /* 256951 */     GIR_EraseRootFromParent_Done,
     /* 256952 */   // Label 4163: @256952
     /* 256952 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(257015), // Rule ID 2674 //
     /* 256957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 256960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16_var),
     /* 256965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 256974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 256977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 256981 */     // MIs[0] fi
     /* 256981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256984 */     // MIs[0] bc
     /* 256984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256987 */     // (intrinsic_wo_chain:{ *:[i32] } 3079:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 256987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_VAR_B32_e64),
     /* 256990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 256998 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 257006 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 257008 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 257010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257013 */     GIR_RootConstrainSelectedInstOperands,
     /* 257014 */     // GIR_Coverage, 2674,
     /* 257014 */     GIR_EraseRootFromParent_Done,
     /* 257015 */   // Label 4164: @257015
     /* 257015 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(257078), // Rule ID 2675 //
     /* 257020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 257023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16_var),
     /* 257028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 257040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 257044 */     // MIs[0] fi
     /* 257044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257047 */     // MIs[0] bc
     /* 257047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 257050 */     // (intrinsic_wo_chain:{ *:[i32] } 3083:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 257050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_VAR_B32_e64),
     /* 257053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 257061 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 257069 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 257071 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 257073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257076 */     GIR_RootConstrainSelectedInstOperands,
     /* 257077 */     // GIR_Coverage, 2675,
     /* 257077 */     GIR_EraseRootFromParent_Done,
     /* 257078 */   // Label 4165: @257078
     /* 257078 */   GIM_Reject,
     /* 257079 */ // Label 4161: @257079
     /* 257079 */ GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(267398),
     /* 257084 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 257087 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(257168), // Rule ID 2823 //
     /* 257092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257116 */     // MIs[0] clamp
     /* 257116 */     // No operand predicates
     /* 257116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257137 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_threeaddr),
     /* 257140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257147 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257154 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257161 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257166 */     GIR_RootConstrainSelectedInstOperands,
     /* 257167 */     // GIR_Coverage, 2823,
     /* 257167 */     GIR_EraseRootFromParent_Done,
     /* 257168 */   // Label 4167: @257168
     /* 257168 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(257249), // Rule ID 2825 //
     /* 257173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257197 */     // MIs[0] clamp
     /* 257197 */     // No operand predicates
     /* 257197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257218 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_threeaddr),
     /* 257221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257235 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257242 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257247 */     GIR_RootConstrainSelectedInstOperands,
     /* 257248 */     // GIR_Coverage, 2825,
     /* 257248 */     GIR_EraseRootFromParent_Done,
     /* 257249 */   // Label 4168: @257249
     /* 257249 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(257330), // Rule ID 2835 //
     /* 257254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 257262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257278 */     // MIs[0] clamp
     /* 257278 */     // No operand predicates
     /* 257278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257299 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_threeaddr),
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257309 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257316 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257323 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257328 */     GIR_RootConstrainSelectedInstOperands,
     /* 257329 */     // GIR_Coverage, 2835,
     /* 257329 */     GIR_EraseRootFromParent_Done,
     /* 257330 */   // Label 4169: @257330
     /* 257330 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(257411), // Rule ID 2856 //
     /* 257335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257359 */     // MIs[0] clamp
     /* 257359 */     // No operand predicates
     /* 257359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257380 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_threeaddr),
     /* 257383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257397 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257404 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257409 */     GIR_RootConstrainSelectedInstOperands,
     /* 257410 */     // GIR_Coverage, 2856,
     /* 257410 */     GIR_EraseRootFromParent_Done,
     /* 257411 */   // Label 4170: @257411
     /* 257411 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(257492), // Rule ID 2858 //
     /* 257416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257440 */     // MIs[0] clamp
     /* 257440 */     // No operand predicates
     /* 257440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257461 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_threeaddr),
     /* 257464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257471 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257478 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257485 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257490 */     GIR_RootConstrainSelectedInstOperands,
     /* 257491 */     // GIR_Coverage, 2858,
     /* 257491 */     GIR_EraseRootFromParent_Done,
     /* 257492 */   // Label 4171: @257492
     /* 257492 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(257573), // Rule ID 2868 //
     /* 257497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 257505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257521 */     // MIs[0] clamp
     /* 257521 */     // No operand predicates
     /* 257521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_threeaddr),
     /* 257545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257552 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257559 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257566 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257571 */     GIR_RootConstrainSelectedInstOperands,
     /* 257572 */     // GIR_Coverage, 2868,
     /* 257572 */     GIR_EraseRootFromParent_Done,
     /* 257573 */   // Label 4172: @257573
     /* 257573 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(257653), // Rule ID 2799 //
     /* 257578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 257581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 257595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257602 */     // MIs[0] clamp
     /* 257602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257619 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w32),
     /* 257622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257629 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257636 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257641 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257643 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257651 */     GIR_RootConstrainSelectedInstOperands,
     /* 257652 */     // GIR_Coverage, 2799,
     /* 257652 */     GIR_EraseRootFromParent_Done,
     /* 257653 */   // Label 4173: @257653
     /* 257653 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(257733), // Rule ID 2805 //
     /* 257658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 257661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257682 */     // MIs[0] clamp
     /* 257682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257699 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w32),
     /* 257702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257709 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257716 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257721 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257723 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257731 */     GIR_RootConstrainSelectedInstOperands,
     /* 257732 */     // GIR_Coverage, 2805,
     /* 257732 */     GIR_EraseRootFromParent_Done,
     /* 257733 */   // Label 4174: @257733
     /* 257733 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(257813), // Rule ID 2812 //
     /* 257738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 257741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 257755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257762 */     // MIs[0] clamp
     /* 257762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257779 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w64),
     /* 257782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257789 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257796 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257801 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257803 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257811 */     GIR_RootConstrainSelectedInstOperands,
     /* 257812 */     // GIR_Coverage, 2812,
     /* 257812 */     GIR_EraseRootFromParent_Done,
     /* 257813 */   // Label 4175: @257813
     /* 257813 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(257893), // Rule ID 2813 //
     /* 257818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 257821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257842 */     // MIs[0] clamp
     /* 257842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w64),
     /* 257862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257869 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257876 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257881 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257883 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257891 */     GIR_RootConstrainSelectedInstOperands,
     /* 257892 */     // GIR_Coverage, 2813,
     /* 257892 */     GIR_EraseRootFromParent_Done,
     /* 257893 */   // Label 4176: @257893
     /* 257893 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(257964), // Rule ID 2822 //
     /* 257898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257922 */     // MIs[0] clamp
     /* 257922 */     // No operand predicates
     /* 257922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257936 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_twoaddr),
     /* 257939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257946 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257953 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257955 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257957 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257962 */     GIR_RootConstrainSelectedInstOperands,
     /* 257963 */     // GIR_Coverage, 2822,
     /* 257963 */     GIR_EraseRootFromParent_Done,
     /* 257964 */   // Label 4177: @257964
     /* 257964 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(258035), // Rule ID 2824 //
     /* 257969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257993 */     // MIs[0] clamp
     /* 257993 */     // No operand predicates
     /* 257993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258007 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 258007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_twoaddr),
     /* 258010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258017 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258024 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258026 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258028 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258033 */     GIR_RootConstrainSelectedInstOperands,
     /* 258034 */     // GIR_Coverage, 2824,
     /* 258034 */     GIR_EraseRootFromParent_Done,
     /* 258035 */   // Label 4178: @258035
     /* 258035 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(258106), // Rule ID 2834 //
     /* 258040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 258043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 258048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 258051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 258054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 258057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 258060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 258064 */     // MIs[0] clamp
     /* 258064 */     // No operand predicates
     /* 258064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258078 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 258078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_twoaddr),
     /* 258081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258088 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258095 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258097 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258099 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258104 */     GIR_RootConstrainSelectedInstOperands,
     /* 258105 */     // GIR_Coverage, 2834,
     /* 258105 */     GIR_EraseRootFromParent_Done,
     /* 258106 */   // Label 4179: @258106
     /* 258106 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(258177), // Rule ID 2855 //
     /* 258111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 258119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 258128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 258131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258135 */     // MIs[0] clamp
     /* 258135 */     // No operand predicates
     /* 258135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258149 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 258149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_twoaddr),
     /* 258152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258159 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258166 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258168 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258170 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258175 */     GIR_RootConstrainSelectedInstOperands,
     /* 258176 */     // GIR_Coverage, 2855,
     /* 258176 */     GIR_EraseRootFromParent_Done,
     /* 258177 */   // Label 4180: @258177
     /* 258177 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(258248), // Rule ID 2857 //
     /* 258182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 258190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 258199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 258202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258206 */     // MIs[0] clamp
     /* 258206 */     // No operand predicates
     /* 258206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258220 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 258220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_twoaddr),
     /* 258223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258230 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258237 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258239 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258241 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258246 */     GIR_RootConstrainSelectedInstOperands,
     /* 258247 */     // GIR_Coverage, 2857,
     /* 258247 */     GIR_EraseRootFromParent_Done,
     /* 258248 */   // Label 4181: @258248
     /* 258248 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(258319), // Rule ID 2867 //
     /* 258253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 258261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 258270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 258273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258277 */     // MIs[0] clamp
     /* 258277 */     // No operand predicates
     /* 258277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 258291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 258291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_twoaddr),
     /* 258294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258301 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258308 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258310 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258312 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258317 */     GIR_RootConstrainSelectedInstOperands,
     /* 258318 */     // GIR_Coverage, 2867,
     /* 258318 */     GIR_EraseRootFromParent_Done,
     /* 258319 */   // Label 4182: @258319
     /* 258319 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(258392), // Rule ID 2424 //
     /* 258324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258345 */     // MIs[0] dpp_ctrl
     /* 258345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258348 */     // MIs[0] row_mask
     /* 258348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258351 */     // MIs[0] bank_mask
     /* 258351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258354 */     // MIs[0] bound_ctrl
     /* 258354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258357 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, i32:{ *:[i32] }:$old, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258362 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258364 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258390 */     GIR_RootConstrainSelectedInstOperands,
     /* 258391 */     // GIR_Coverage, 2424,
     /* 258391 */     GIR_EraseRootFromParent_Done,
     /* 258392 */   // Label 4183: @258392
     /* 258392 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(258465), // Rule ID 2425 //
     /* 258397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258418 */     // MIs[0] dpp_ctrl
     /* 258418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258421 */     // MIs[0] row_mask
     /* 258421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258424 */     // MIs[0] bank_mask
     /* 258424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258427 */     // MIs[0] bound_ctrl
     /* 258427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258430 */     // (intrinsic_wo_chain:{ *:[f32] } 3305:{ *:[iPTR] }, f32:{ *:[f32] }:$old, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[f32] } VGPR_32:{ *:[f32] }:$old, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258435 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258437 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258463 */     GIR_RootConstrainSelectedInstOperands,
     /* 258464 */     // GIR_Coverage, 2425,
     /* 258464 */     GIR_EraseRootFromParent_Done,
     /* 258465 */   // Label 4184: @258465
     /* 258465 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(258538), // Rule ID 2426 //
     /* 258470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 258487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258491 */     // MIs[0] dpp_ctrl
     /* 258491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258494 */     // MIs[0] row_mask
     /* 258494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258497 */     // MIs[0] bank_mask
     /* 258497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258500 */     // MIs[0] bound_ctrl
     /* 258500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258503 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3305:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$old, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$old, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258508 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258536 */     GIR_RootConstrainSelectedInstOperands,
     /* 258537 */     // GIR_Coverage, 2426,
     /* 258537 */     GIR_EraseRootFromParent_Done,
     /* 258538 */   // Label 4185: @258538
     /* 258538 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(258611), // Rule ID 2427 //
     /* 258543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 258560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258564 */     // MIs[0] dpp_ctrl
     /* 258564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258567 */     // MIs[0] row_mask
     /* 258567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258570 */     // MIs[0] bank_mask
     /* 258570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258573 */     // MIs[0] bound_ctrl
     /* 258573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258576 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3305:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$old, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$old, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258581 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258583 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258609 */     GIR_RootConstrainSelectedInstOperands,
     /* 258610 */     // GIR_Coverage, 2427,
     /* 258610 */     GIR_EraseRootFromParent_Done,
     /* 258611 */   // Label 4186: @258611
     /* 258611 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(258684), // Rule ID 2428 //
     /* 258616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 258627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 258630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 258633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258637 */     // MIs[0] dpp_ctrl
     /* 258637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258640 */     // MIs[0] row_mask
     /* 258640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258643 */     // MIs[0] bank_mask
     /* 258643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258646 */     // MIs[0] bound_ctrl
     /* 258646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258649 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p2:{ *:[i32] }:$old, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258654 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258656 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258682 */     GIR_RootConstrainSelectedInstOperands,
     /* 258683 */     // GIR_Coverage, 2428,
     /* 258683 */     GIR_EraseRootFromParent_Done,
     /* 258684 */   // Label 4187: @258684
     /* 258684 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(258757), // Rule ID 2429 //
     /* 258689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 258700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 258703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 258706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258710 */     // MIs[0] dpp_ctrl
     /* 258710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258713 */     // MIs[0] row_mask
     /* 258713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258716 */     // MIs[0] bank_mask
     /* 258716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258719 */     // MIs[0] bound_ctrl
     /* 258719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258722 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p3:{ *:[i32] }:$old, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258727 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258729 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258755 */     GIR_RootConstrainSelectedInstOperands,
     /* 258756 */     // GIR_Coverage, 2429,
     /* 258756 */     GIR_EraseRootFromParent_Done,
     /* 258757 */   // Label 4188: @258757
     /* 258757 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(258830), // Rule ID 2430 //
     /* 258762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 258773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 258776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 258779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258783 */     // MIs[0] dpp_ctrl
     /* 258783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258786 */     // MIs[0] row_mask
     /* 258786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258789 */     // MIs[0] bank_mask
     /* 258789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258792 */     // MIs[0] bound_ctrl
     /* 258792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258795 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p5:{ *:[i32] }:$old, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258800 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258802 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258828 */     GIR_RootConstrainSelectedInstOperands,
     /* 258829 */     // GIR_Coverage, 2430,
     /* 258829 */     GIR_EraseRootFromParent_Done,
     /* 258830 */   // Label 4189: @258830
     /* 258830 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(258903), // Rule ID 2431 //
     /* 258835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 258846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 258849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 258852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258856 */     // MIs[0] dpp_ctrl
     /* 258856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258859 */     // MIs[0] row_mask
     /* 258859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258862 */     // MIs[0] bank_mask
     /* 258862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258865 */     // MIs[0] bound_ctrl
     /* 258865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258868 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p6:{ *:[i32] }:$old, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258873 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258875 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258901 */     GIR_RootConstrainSelectedInstOperands,
     /* 258902 */     // GIR_Coverage, 2431,
     /* 258902 */     GIR_EraseRootFromParent_Done,
     /* 258903 */   // Label 4190: @258903
     /* 258903 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(258973), // Rule ID 7556 //
     /* 258908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 258916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258926 */     // MIs[0] dpp_ctrl
     /* 258926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258929 */     // MIs[0] row_mask
     /* 258929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258932 */     // MIs[0] bank_mask
     /* 258932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258935 */     // MIs[0] bound_ctrl
     /* 258935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258938 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, i64:{ *:[i64] }:$old, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258943 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258945 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258971 */     GIR_RootConstrainSelectedInstOperands,
     /* 258972 */     // GIR_Coverage, 7556,
     /* 258972 */     GIR_EraseRootFromParent_Done,
     /* 258973 */   // Label 4191: @258973
     /* 258973 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(259043), // Rule ID 7557 //
     /* 258978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 258986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258996 */     // MIs[0] dpp_ctrl
     /* 258996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258999 */     // MIs[0] row_mask
     /* 258999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259002 */     // MIs[0] bank_mask
     /* 259002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259005 */     // MIs[0] bound_ctrl
     /* 259005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259008 */     // (intrinsic_wo_chain:{ *:[f64] } 3305:{ *:[iPTR] }, f64:{ *:[f64] }:$old, f64:{ *:[f64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[f64] } VReg_64_Align2:{ *:[f64] }:$old, VReg_64_Align2:{ *:[f64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259013 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259015 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259041 */     GIR_RootConstrainSelectedInstOperands,
     /* 259042 */     // GIR_Coverage, 7557,
     /* 259042 */     GIR_EraseRootFromParent_Done,
     /* 259043 */   // Label 4192: @259043
     /* 259043 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(259113), // Rule ID 7558 //
     /* 259048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 259056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 259062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259066 */     // MIs[0] dpp_ctrl
     /* 259066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259069 */     // MIs[0] row_mask
     /* 259069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259072 */     // MIs[0] bank_mask
     /* 259072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259075 */     // MIs[0] bound_ctrl
     /* 259075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259078 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3305:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$old, v2i32:{ *:[v2i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2i32] } VReg_64_Align2:{ *:[v2i32] }:$old, VReg_64_Align2:{ *:[v2i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259083 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259111 */     GIR_RootConstrainSelectedInstOperands,
     /* 259112 */     // GIR_Coverage, 7558,
     /* 259112 */     GIR_EraseRootFromParent_Done,
     /* 259113 */   // Label 4193: @259113
     /* 259113 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(259183), // Rule ID 7559 //
     /* 259118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 259126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 259132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259136 */     // MIs[0] dpp_ctrl
     /* 259136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259139 */     // MIs[0] row_mask
     /* 259139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259142 */     // MIs[0] bank_mask
     /* 259142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259145 */     // MIs[0] bound_ctrl
     /* 259145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259148 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3305:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$old, v2f32:{ *:[v2f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2f32] } VReg_64_Align2:{ *:[v2f32] }:$old, VReg_64_Align2:{ *:[v2f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259153 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259155 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259181 */     GIR_RootConstrainSelectedInstOperands,
     /* 259182 */     // GIR_Coverage, 7559,
     /* 259182 */     GIR_EraseRootFromParent_Done,
     /* 259183 */   // Label 4194: @259183
     /* 259183 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(259253), // Rule ID 7560 //
     /* 259188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p0s64,
     /* 259196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 259199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 259202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259206 */     // MIs[0] dpp_ctrl
     /* 259206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259209 */     // MIs[0] row_mask
     /* 259209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259212 */     // MIs[0] bank_mask
     /* 259212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259215 */     // MIs[0] bound_ctrl
     /* 259215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259218 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p0:{ *:[i64] }:$old, p0:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259223 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259225 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259251 */     GIR_RootConstrainSelectedInstOperands,
     /* 259252 */     // GIR_Coverage, 7560,
     /* 259252 */     GIR_EraseRootFromParent_Done,
     /* 259253 */   // Label 4195: @259253
     /* 259253 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(259323), // Rule ID 7561 //
     /* 259258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p1s64,
     /* 259266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p1s64,
     /* 259269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p1s64,
     /* 259272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259276 */     // MIs[0] dpp_ctrl
     /* 259276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259279 */     // MIs[0] row_mask
     /* 259279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259282 */     // MIs[0] bank_mask
     /* 259282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259285 */     // MIs[0] bound_ctrl
     /* 259285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259288 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p1:{ *:[i64] }:$old, p1:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259293 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259295 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259321 */     GIR_RootConstrainSelectedInstOperands,
     /* 259322 */     // GIR_Coverage, 7561,
     /* 259322 */     GIR_EraseRootFromParent_Done,
     /* 259323 */   // Label 4196: @259323
     /* 259323 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(259393), // Rule ID 7562 //
     /* 259328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p4s64,
     /* 259336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p4s64,
     /* 259339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p4s64,
     /* 259342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259346 */     // MIs[0] dpp_ctrl
     /* 259346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259349 */     // MIs[0] row_mask
     /* 259349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259352 */     // MIs[0] bank_mask
     /* 259352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259355 */     // MIs[0] bound_ctrl
     /* 259355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259358 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p4:{ *:[i64] }:$old, p4:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259363 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259379 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259391 */     GIR_RootConstrainSelectedInstOperands,
     /* 259392 */     // GIR_Coverage, 7562,
     /* 259392 */     GIR_EraseRootFromParent_Done,
     /* 259393 */   // Label 4197: @259393
     /* 259393 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(259463), // Rule ID 7563 //
     /* 259398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 259412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259416 */     // MIs[0] dpp_ctrl
     /* 259416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259419 */     // MIs[0] row_mask
     /* 259419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259422 */     // MIs[0] bank_mask
     /* 259422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259425 */     // MIs[0] bound_ctrl
     /* 259425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259428 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3305:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$old, v4i16:{ *:[v4i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4i16] } VReg_64_Align2:{ *:[v4i16] }:$old, VReg_64_Align2:{ *:[v4i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259433 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259435 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259461 */     GIR_RootConstrainSelectedInstOperands,
     /* 259462 */     // GIR_Coverage, 7563,
     /* 259462 */     GIR_EraseRootFromParent_Done,
     /* 259463 */   // Label 4198: @259463
     /* 259463 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(259533), // Rule ID 7564 //
     /* 259468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 259482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259486 */     // MIs[0] dpp_ctrl
     /* 259486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259489 */     // MIs[0] row_mask
     /* 259489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259492 */     // MIs[0] bank_mask
     /* 259492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259495 */     // MIs[0] bound_ctrl
     /* 259495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259498 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3305:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$old, v4f16:{ *:[v4f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4f16] } VReg_64_Align2:{ *:[v4f16] }:$old, VReg_64_Align2:{ *:[v4f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259503 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259505 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259531 */     GIR_RootConstrainSelectedInstOperands,
     /* 259532 */     // GIR_Coverage, 7564,
     /* 259532 */     GIR_EraseRootFromParent_Done,
     /* 259533 */   // Label 4199: @259533
     /* 259533 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(259604), // Rule ID 2649 //
     /* 259538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259565 */     // MIs[0] fi
     /* 259565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259568 */     // MIs[0] bc
     /* 259568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259571 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259582 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259590 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259595 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259597 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259602 */     GIR_RootConstrainSelectedInstOperands,
     /* 259603 */     // GIR_Coverage, 2649,
     /* 259603 */     GIR_EraseRootFromParent_Done,
     /* 259604 */   // Label 4200: @259604
     /* 259604 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(259675), // Rule ID 2650 //
     /* 259609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259636 */     // MIs[0] fi
     /* 259636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259639 */     // MIs[0] bc
     /* 259639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259642 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259653 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259661 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259666 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259668 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259673 */     GIR_RootConstrainSelectedInstOperands,
     /* 259674 */     // GIR_Coverage, 2650,
     /* 259674 */     GIR_EraseRootFromParent_Done,
     /* 259675 */   // Label 4201: @259675
     /* 259675 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(259746), // Rule ID 2651 //
     /* 259680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259707 */     // MIs[0] fi
     /* 259707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259710 */     // MIs[0] bc
     /* 259710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259713 */     // (intrinsic_wo_chain:{ *:[f32] } 3077:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 259713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259724 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259732 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259737 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259739 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259744 */     GIR_RootConstrainSelectedInstOperands,
     /* 259745 */     // GIR_Coverage, 2651,
     /* 259745 */     GIR_EraseRootFromParent_Done,
     /* 259746 */   // Label 4202: @259746
     /* 259746 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(259817), // Rule ID 2652 //
     /* 259751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259778 */     // MIs[0] fi
     /* 259778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259781 */     // MIs[0] bc
     /* 259781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259784 */     // (intrinsic_wo_chain:{ *:[f32] } 3082:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 259784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259803 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259808 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259810 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259815 */     GIR_RootConstrainSelectedInstOperands,
     /* 259816 */     // GIR_Coverage, 2652,
     /* 259816 */     GIR_EraseRootFromParent_Done,
     /* 259817 */   // Label 4203: @259817
     /* 259817 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(259888), // Rule ID 2653 //
     /* 259822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259849 */     // MIs[0] fi
     /* 259849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259852 */     // MIs[0] bc
     /* 259852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259855 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3077:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 259855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259874 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259879 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259881 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259886 */     GIR_RootConstrainSelectedInstOperands,
     /* 259887 */     // GIR_Coverage, 2653,
     /* 259887 */     GIR_EraseRootFromParent_Done,
     /* 259888 */   // Label 4204: @259888
     /* 259888 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(259959), // Rule ID 2654 //
     /* 259893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259920 */     // MIs[0] fi
     /* 259920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259923 */     // MIs[0] bc
     /* 259923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259926 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3082:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 259926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259945 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259950 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259952 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259957 */     GIR_RootConstrainSelectedInstOperands,
     /* 259958 */     // GIR_Coverage, 2654,
     /* 259958 */     GIR_EraseRootFromParent_Done,
     /* 259959 */   // Label 4205: @259959
     /* 259959 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(260030), // Rule ID 2655 //
     /* 259964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259991 */     // MIs[0] fi
     /* 259991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259994 */     // MIs[0] bc
     /* 259994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259997 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3077:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 259997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260016 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260021 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260023 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260028 */     GIR_RootConstrainSelectedInstOperands,
     /* 260029 */     // GIR_Coverage, 2655,
     /* 260029 */     GIR_EraseRootFromParent_Done,
     /* 260030 */   // Label 4206: @260030
     /* 260030 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(260101), // Rule ID 2656 //
     /* 260035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 260046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 260049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 260052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260062 */     // MIs[0] fi
     /* 260062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260065 */     // MIs[0] bc
     /* 260065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260068 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3082:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 260068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260079 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260087 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260092 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260094 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260099 */     GIR_RootConstrainSelectedInstOperands,
     /* 260100 */     // GIR_Coverage, 2656,
     /* 260100 */     GIR_EraseRootFromParent_Done,
     /* 260101 */   // Label 4207: @260101
     /* 260101 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(260172), // Rule ID 2657 //
     /* 260106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 260117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 260120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 260123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260133 */     // MIs[0] fi
     /* 260133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260136 */     // MIs[0] bc
     /* 260136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260139 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260158 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260163 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260165 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260170 */     GIR_RootConstrainSelectedInstOperands,
     /* 260171 */     // GIR_Coverage, 2657,
     /* 260171 */     GIR_EraseRootFromParent_Done,
     /* 260172 */   // Label 4208: @260172
     /* 260172 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(260243), // Rule ID 2658 //
     /* 260177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 260188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 260191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 260194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260204 */     // MIs[0] fi
     /* 260204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260207 */     // MIs[0] bc
     /* 260207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260210 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260221 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260229 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260234 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260236 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260241 */     GIR_RootConstrainSelectedInstOperands,
     /* 260242 */     // GIR_Coverage, 2658,
     /* 260242 */     GIR_EraseRootFromParent_Done,
     /* 260243 */   // Label 4209: @260243
     /* 260243 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(260314), // Rule ID 2659 //
     /* 260248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 260259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 260262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 260265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260275 */     // MIs[0] fi
     /* 260275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260278 */     // MIs[0] bc
     /* 260278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260281 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260300 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260305 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260307 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260312 */     GIR_RootConstrainSelectedInstOperands,
     /* 260313 */     // GIR_Coverage, 2659,
     /* 260313 */     GIR_EraseRootFromParent_Done,
     /* 260314 */   // Label 4210: @260314
     /* 260314 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(260385), // Rule ID 2660 //
     /* 260319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 260330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 260333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 260336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260346 */     // MIs[0] fi
     /* 260346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260349 */     // MIs[0] bc
     /* 260349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260352 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260371 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260376 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260378 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260383 */     GIR_RootConstrainSelectedInstOperands,
     /* 260384 */     // GIR_Coverage, 2660,
     /* 260384 */     GIR_EraseRootFromParent_Done,
     /* 260385 */   // Label 4211: @260385
     /* 260385 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(260456), // Rule ID 2661 //
     /* 260390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 260401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 260404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 260407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260417 */     // MIs[0] fi
     /* 260417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260420 */     // MIs[0] bc
     /* 260420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260423 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260434 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260442 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260447 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260449 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260454 */     GIR_RootConstrainSelectedInstOperands,
     /* 260455 */     // GIR_Coverage, 2661,
     /* 260455 */     GIR_EraseRootFromParent_Done,
     /* 260456 */   // Label 4212: @260456
     /* 260456 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(260527), // Rule ID 2662 //
     /* 260461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 260472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 260475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 260478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260488 */     // MIs[0] fi
     /* 260488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260491 */     // MIs[0] bc
     /* 260491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260494 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260505 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260513 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260518 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260520 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260525 */     GIR_RootConstrainSelectedInstOperands,
     /* 260526 */     // GIR_Coverage, 2662,
     /* 260526 */     GIR_EraseRootFromParent_Done,
     /* 260527 */   // Label 4213: @260527
     /* 260527 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(260598), // Rule ID 2663 //
     /* 260532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 260543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 260546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 260549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260559 */     // MIs[0] fi
     /* 260559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260562 */     // MIs[0] bc
     /* 260562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260565 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260584 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260589 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260591 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260596 */     GIR_RootConstrainSelectedInstOperands,
     /* 260597 */     // GIR_Coverage, 2663,
     /* 260597 */     GIR_EraseRootFromParent_Done,
     /* 260598 */   // Label 4214: @260598
     /* 260598 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(260669), // Rule ID 2664 //
     /* 260603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 260614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 260617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 260620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260630 */     // MIs[0] fi
     /* 260630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260633 */     // MIs[0] bc
     /* 260633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260636 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260647 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260655 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260660 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260662 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260667 */     GIR_RootConstrainSelectedInstOperands,
     /* 260668 */     // GIR_Coverage, 2664,
     /* 260668 */     GIR_EraseRootFromParent_Done,
     /* 260669 */   // Label 4215: @260669
     /* 260669 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(260730), // Rule ID 1123 //
     /* 260674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 260682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 260698 */     // MIs[0] cbsz
     /* 260698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260701 */     // MIs[0] abid
     /* 260701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260704 */     // MIs[0] blgp
     /* 260704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23209),
     /* 260711 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3050:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23209>>  =>  (V_MFMA_F32_4X4X1F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_e64),
     /* 260714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260716 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260720 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260722 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260724 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260726 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260728 */     GIR_RootConstrainSelectedInstOperands,
     /* 260729 */     // GIR_Coverage, 1123,
     /* 260729 */     GIR_EraseRootFromParent_Done,
     /* 260730 */   // Label 4216: @260730
     /* 260730 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(260791), // Rule ID 1124 //
     /* 260735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 260743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260759 */     // MIs[0] cbsz
     /* 260759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260762 */     // MIs[0] abid
     /* 260762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260765 */     // MIs[0] blgp
     /* 260765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23211),
     /* 260772 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3050:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23211>>  =>  (V_MFMA_F32_4X4X1F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_vgprcd_e64),
     /* 260775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260777 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260779 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260781 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260783 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260785 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260787 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260789 */     GIR_RootConstrainSelectedInstOperands,
     /* 260790 */     // GIR_Coverage, 1124,
     /* 260790 */     GIR_EraseRootFromParent_Done,
     /* 260791 */   // Label 4217: @260791
     /* 260791 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(260852), // Rule ID 1125 //
     /* 260796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 260804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 260820 */     // MIs[0] cbsz
     /* 260820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260823 */     // MIs[0] abid
     /* 260823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260826 */     // MIs[0] blgp
     /* 260826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23215),
     /* 260833 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3022:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23215>>  =>  (V_MFMA_F32_16X16X1F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_e64),
     /* 260836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260840 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260842 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260844 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260846 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260848 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260850 */     GIR_RootConstrainSelectedInstOperands,
     /* 260851 */     // GIR_Coverage, 1125,
     /* 260851 */     GIR_EraseRootFromParent_Done,
     /* 260852 */   // Label 4218: @260852
     /* 260852 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(260913), // Rule ID 1126 //
     /* 260857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 260865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 260881 */     // MIs[0] cbsz
     /* 260881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260884 */     // MIs[0] abid
     /* 260884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260887 */     // MIs[0] blgp
     /* 260887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23217),
     /* 260894 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3022:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23217>>  =>  (V_MFMA_F32_16X16X1F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_vgprcd_e64),
     /* 260897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260901 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260903 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260905 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260907 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260909 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260911 */     GIR_RootConstrainSelectedInstOperands,
     /* 260912 */     // GIR_Coverage, 1126,
     /* 260912 */     GIR_EraseRootFromParent_Done,
     /* 260913 */   // Label 4219: @260913
     /* 260913 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(260974), // Rule ID 1127 //
     /* 260918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 260926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 260942 */     // MIs[0] cbsz
     /* 260942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260945 */     // MIs[0] abid
     /* 260945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260948 */     // MIs[0] blgp
     /* 260948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23219),
     /* 260955 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23219>>  =>  (V_MFMA_F32_16X16X4F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_e64),
     /* 260958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260962 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260964 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260966 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260968 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260970 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260972 */     GIR_RootConstrainSelectedInstOperands,
     /* 260973 */     // GIR_Coverage, 1127,
     /* 260973 */     GIR_EraseRootFromParent_Done,
     /* 260974 */   // Label 4220: @260974
     /* 260974 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(261035), // Rule ID 1128 //
     /* 260979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 260987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261003 */     // MIs[0] cbsz
     /* 261003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261006 */     // MIs[0] abid
     /* 261006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261009 */     // MIs[0] blgp
     /* 261009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23221),
     /* 261016 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23221>>  =>  (V_MFMA_F32_16X16X4F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_vgprcd_e64),
     /* 261019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261023 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261025 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261027 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261029 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261031 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261033 */     GIR_RootConstrainSelectedInstOperands,
     /* 261034 */     // GIR_Coverage, 1128,
     /* 261034 */     GIR_EraseRootFromParent_Done,
     /* 261035 */   // Label 4221: @261035
     /* 261035 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(261096), // Rule ID 1129 //
     /* 261040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 261048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 261064 */     // MIs[0] cbsz
     /* 261064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261067 */     // MIs[0] abid
     /* 261067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261070 */     // MIs[0] blgp
     /* 261070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23225),
     /* 261077 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3041:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23225>>  =>  (V_MFMA_F32_32X32X1F32_mac_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_e64),
     /* 261080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261084 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261086 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261088 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261090 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261092 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261094 */     GIR_RootConstrainSelectedInstOperands,
     /* 261095 */     // GIR_Coverage, 1129,
     /* 261095 */     GIR_EraseRootFromParent_Done,
     /* 261096 */   // Label 4222: @261096
     /* 261096 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(261157), // Rule ID 1130 //
     /* 261101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 261109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 261125 */     // MIs[0] cbsz
     /* 261125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261128 */     // MIs[0] abid
     /* 261128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261131 */     // MIs[0] blgp
     /* 261131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23227),
     /* 261138 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3041:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23227>>  =>  (V_MFMA_F32_32X32X1F32_mac_vgprcd_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_vgprcd_e64),
     /* 261141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261147 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261149 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261151 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261153 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261155 */     GIR_RootConstrainSelectedInstOperands,
     /* 261156 */     // GIR_Coverage, 1130,
     /* 261156 */     GIR_EraseRootFromParent_Done,
     /* 261157 */   // Label 4223: @261157
     /* 261157 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(261218), // Rule ID 1131 //
     /* 261162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 261170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261186 */     // MIs[0] cbsz
     /* 261186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261189 */     // MIs[0] abid
     /* 261189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261192 */     // MIs[0] blgp
     /* 261192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23229),
     /* 261199 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3043:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23229>>  =>  (V_MFMA_F32_32X32X2F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_e64),
     /* 261202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261208 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261210 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261212 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261214 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261216 */     GIR_RootConstrainSelectedInstOperands,
     /* 261217 */     // GIR_Coverage, 1131,
     /* 261217 */     GIR_EraseRootFromParent_Done,
     /* 261218 */   // Label 4224: @261218
     /* 261218 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(261279), // Rule ID 1132 //
     /* 261223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 261231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261247 */     // MIs[0] cbsz
     /* 261247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261250 */     // MIs[0] abid
     /* 261250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261253 */     // MIs[0] blgp
     /* 261253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23231),
     /* 261260 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3043:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23231>>  =>  (V_MFMA_F32_32X32X2F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_vgprcd_e64),
     /* 261263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261267 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261269 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261271 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261273 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261275 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261277 */     GIR_RootConstrainSelectedInstOperands,
     /* 261278 */     // GIR_Coverage, 1132,
     /* 261278 */     GIR_EraseRootFromParent_Done,
     /* 261279 */   // Label 4225: @261279
     /* 261279 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(261340), // Rule ID 1133 //
     /* 261284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 261292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261308 */     // MIs[0] cbsz
     /* 261308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261311 */     // MIs[0] abid
     /* 261311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261314 */     // MIs[0] blgp
     /* 261314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23233),
     /* 261321 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3053:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23233>>  =>  (V_MFMA_F32_4X4X4F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_e64),
     /* 261324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261330 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261332 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261334 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261336 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261338 */     GIR_RootConstrainSelectedInstOperands,
     /* 261339 */     // GIR_Coverage, 1133,
     /* 261339 */     GIR_EraseRootFromParent_Done,
     /* 261340 */   // Label 4226: @261340
     /* 261340 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(261401), // Rule ID 1134 //
     /* 261345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 261353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261369 */     // MIs[0] cbsz
     /* 261369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261372 */     // MIs[0] abid
     /* 261372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261375 */     // MIs[0] blgp
     /* 261375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23235),
     /* 261382 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3053:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23235>>  =>  (V_MFMA_F32_4X4X4F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_vgprcd_e64),
     /* 261385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261391 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261393 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261395 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261397 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261399 */     GIR_RootConstrainSelectedInstOperands,
     /* 261400 */     // GIR_Coverage, 1134,
     /* 261400 */     GIR_EraseRootFromParent_Done,
     /* 261401 */   // Label 4227: @261401
     /* 261401 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(261462), // Rule ID 1135 //
     /* 261406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 261414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261430 */     // MIs[0] cbsz
     /* 261430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261433 */     // MIs[0] abid
     /* 261433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261436 */     // MIs[0] blgp
     /* 261436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23237),
     /* 261443 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3064:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23237>>  =>  (V_MFMA_I32_4X4X4I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_e64),
     /* 261446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261450 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261452 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261454 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261456 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261458 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261460 */     GIR_RootConstrainSelectedInstOperands,
     /* 261461 */     // GIR_Coverage, 1135,
     /* 261461 */     GIR_EraseRootFromParent_Done,
     /* 261462 */   // Label 4228: @261462
     /* 261462 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(261523), // Rule ID 1136 //
     /* 261467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 261475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261491 */     // MIs[0] cbsz
     /* 261491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261494 */     // MIs[0] abid
     /* 261494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261497 */     // MIs[0] blgp
     /* 261497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23239),
     /* 261504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3064:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23239>>  =>  (V_MFMA_I32_4X4X4I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_vgprcd_e64),
     /* 261507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261511 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261513 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261515 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261517 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261519 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261521 */     GIR_RootConstrainSelectedInstOperands,
     /* 261522 */     // GIR_Coverage, 1136,
     /* 261522 */     GIR_EraseRootFromParent_Done,
     /* 261523 */   // Label 4229: @261523
     /* 261523 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(261584), // Rule ID 1137 //
     /* 261528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 261536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261552 */     // MIs[0] cbsz
     /* 261552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261555 */     // MIs[0] abid
     /* 261555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261558 */     // MIs[0] blgp
     /* 261558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23243),
     /* 261565 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3031:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23243>>  =>  (V_MFMA_F32_16X16X4F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_e64),
     /* 261568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261572 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261574 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261576 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261578 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261580 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261582 */     GIR_RootConstrainSelectedInstOperands,
     /* 261583 */     // GIR_Coverage, 1137,
     /* 261583 */     GIR_EraseRootFromParent_Done,
     /* 261584 */   // Label 4230: @261584
     /* 261584 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(261645), // Rule ID 1138 //
     /* 261589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 261597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261613 */     // MIs[0] cbsz
     /* 261613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261616 */     // MIs[0] abid
     /* 261616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261619 */     // MIs[0] blgp
     /* 261619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23245),
     /* 261626 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3031:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23245>>  =>  (V_MFMA_F32_16X16X4F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_vgprcd_e64),
     /* 261629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261635 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261637 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261639 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261641 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261643 */     GIR_RootConstrainSelectedInstOperands,
     /* 261644 */     // GIR_Coverage, 1138,
     /* 261644 */     GIR_EraseRootFromParent_Done,
     /* 261645 */   // Label 4231: @261645
     /* 261645 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(261706), // Rule ID 1139 //
     /* 261650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 261658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261674 */     // MIs[0] cbsz
     /* 261674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261677 */     // MIs[0] abid
     /* 261677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261680 */     // MIs[0] blgp
     /* 261680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23247),
     /* 261687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3021:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23247>>  =>  (V_MFMA_F32_16X16X16F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_e64),
     /* 261690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261692 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261694 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261696 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261698 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261700 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261702 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261704 */     GIR_RootConstrainSelectedInstOperands,
     /* 261705 */     // GIR_Coverage, 1139,
     /* 261705 */     GIR_EraseRootFromParent_Done,
     /* 261706 */   // Label 4232: @261706
     /* 261706 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(261767), // Rule ID 1140 //
     /* 261711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 261719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261735 */     // MIs[0] cbsz
     /* 261735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261738 */     // MIs[0] abid
     /* 261738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261741 */     // MIs[0] blgp
     /* 261741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23249),
     /* 261748 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3021:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23249>>  =>  (V_MFMA_F32_16X16X16F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_vgprcd_e64),
     /* 261751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261755 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261757 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261759 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261761 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261763 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261765 */     GIR_RootConstrainSelectedInstOperands,
     /* 261766 */     // GIR_Coverage, 1140,
     /* 261766 */     GIR_EraseRootFromParent_Done,
     /* 261767 */   // Label 4233: @261767
     /* 261767 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(261828), // Rule ID 1141 //
     /* 261772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 261780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261796 */     // MIs[0] cbsz
     /* 261796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261799 */     // MIs[0] abid
     /* 261799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261802 */     // MIs[0] blgp
     /* 261802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23253),
     /* 261809 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3058:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23253>>  =>  (V_MFMA_I32_16X16X4I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_e64),
     /* 261812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261818 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261820 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261822 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261824 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261826 */     GIR_RootConstrainSelectedInstOperands,
     /* 261827 */     // GIR_Coverage, 1141,
     /* 261827 */     GIR_EraseRootFromParent_Done,
     /* 261828 */   // Label 4234: @261828
     /* 261828 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(261889), // Rule ID 1142 //
     /* 261833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 261841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261857 */     // MIs[0] cbsz
     /* 261857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261860 */     // MIs[0] abid
     /* 261860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261863 */     // MIs[0] blgp
     /* 261863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23255),
     /* 261870 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3058:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23255>>  =>  (V_MFMA_I32_16X16X4I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_vgprcd_e64),
     /* 261873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261881 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261883 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261885 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261887 */     GIR_RootConstrainSelectedInstOperands,
     /* 261888 */     // GIR_Coverage, 1142,
     /* 261888 */     GIR_EraseRootFromParent_Done,
     /* 261889 */   // Label 4235: @261889
     /* 261889 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(261950), // Rule ID 1143 //
     /* 261894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 261902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 261918 */     // MIs[0] cbsz
     /* 261918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261921 */     // MIs[0] abid
     /* 261921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261924 */     // MIs[0] blgp
     /* 261924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23259),
     /* 261931 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3047:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23259>>  =>  (V_MFMA_F32_32X32X4F16_mac_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_e64),
     /* 261934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261940 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261942 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261944 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261946 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261948 */     GIR_RootConstrainSelectedInstOperands,
     /* 261949 */     // GIR_Coverage, 1143,
     /* 261949 */     GIR_EraseRootFromParent_Done,
     /* 261950 */   // Label 4236: @261950
     /* 261950 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(262011), // Rule ID 1144 //
     /* 261955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 261963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 261979 */     // MIs[0] cbsz
     /* 261979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261982 */     // MIs[0] abid
     /* 261982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261985 */     // MIs[0] blgp
     /* 261985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23261),
     /* 261992 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3047:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23261>>  =>  (V_MFMA_F32_32X32X4F16_mac_vgprcd_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_vgprcd_e64),
     /* 261995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261999 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262001 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262003 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262005 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262007 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262009 */     GIR_RootConstrainSelectedInstOperands,
     /* 262010 */     // GIR_Coverage, 1144,
     /* 262010 */     GIR_EraseRootFromParent_Done,
     /* 262011 */   // Label 4237: @262011
     /* 262011 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(262072), // Rule ID 1145 //
     /* 262016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 262019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 262024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 262033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262040 */     // MIs[0] cbsz
     /* 262040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262043 */     // MIs[0] abid
     /* 262043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262046 */     // MIs[0] blgp
     /* 262046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23263),
     /* 262053 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3049:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23263>>  =>  (V_MFMA_F32_32X32X8F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_e64),
     /* 262056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262060 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262062 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262064 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262066 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262068 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262070 */     GIR_RootConstrainSelectedInstOperands,
     /* 262071 */     // GIR_Coverage, 1145,
     /* 262071 */     GIR_EraseRootFromParent_Done,
     /* 262072 */   // Label 4238: @262072
     /* 262072 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(262133), // Rule ID 1146 //
     /* 262077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 262080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 262085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 262094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262101 */     // MIs[0] cbsz
     /* 262101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262104 */     // MIs[0] abid
     /* 262104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262107 */     // MIs[0] blgp
     /* 262107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23265),
     /* 262114 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3049:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23265>>  =>  (V_MFMA_F32_32X32X8F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_vgprcd_e64),
     /* 262117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262121 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262123 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262125 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262127 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262129 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262131 */     GIR_RootConstrainSelectedInstOperands,
     /* 262132 */     // GIR_Coverage, 1146,
     /* 262132 */     GIR_EraseRootFromParent_Done,
     /* 262133 */   // Label 4239: @262133
     /* 262133 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(262194), // Rule ID 1147 //
     /* 262138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 262141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 262146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 262162 */     // MIs[0] cbsz
     /* 262162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262165 */     // MIs[0] abid
     /* 262165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262168 */     // MIs[0] blgp
     /* 262168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23269),
     /* 262175 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3062:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23269>>  =>  (V_MFMA_I32_32X32X4I8_mac_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_e64),
     /* 262178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262182 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262184 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262186 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262188 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262190 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262192 */     GIR_RootConstrainSelectedInstOperands,
     /* 262193 */     // GIR_Coverage, 1147,
     /* 262193 */     GIR_EraseRootFromParent_Done,
     /* 262194 */   // Label 4240: @262194
     /* 262194 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(262255), // Rule ID 1148 //
     /* 262199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 262202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 262207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 262223 */     // MIs[0] cbsz
     /* 262223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262226 */     // MIs[0] abid
     /* 262226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262229 */     // MIs[0] blgp
     /* 262229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23271),
     /* 262236 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3062:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23271>>  =>  (V_MFMA_I32_32X32X4I8_mac_vgprcd_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_vgprcd_e64),
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262243 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262247 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262249 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262251 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262253 */     GIR_RootConstrainSelectedInstOperands,
     /* 262254 */     // GIR_Coverage, 1148,
     /* 262254 */     GIR_EraseRootFromParent_Done,
     /* 262255 */   // Label 4241: @262255
     /* 262255 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(262316), // Rule ID 1149 //
     /* 262260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 262268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262284 */     // MIs[0] cbsz
     /* 262284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262287 */     // MIs[0] abid
     /* 262287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262290 */     // MIs[0] blgp
     /* 262290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23273),
     /* 262297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3056:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23273>>  =>  (V_MFMA_I32_16X16X16I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_e64),
     /* 262300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262302 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262304 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262306 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262308 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262310 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262312 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262314 */     GIR_RootConstrainSelectedInstOperands,
     /* 262315 */     // GIR_Coverage, 1149,
     /* 262315 */     GIR_EraseRootFromParent_Done,
     /* 262316 */   // Label 4242: @262316
     /* 262316 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(262377), // Rule ID 1150 //
     /* 262321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 262329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262345 */     // MIs[0] cbsz
     /* 262345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262348 */     // MIs[0] abid
     /* 262348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262351 */     // MIs[0] blgp
     /* 262351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23275),
     /* 262358 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3056:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23275>>  =>  (V_MFMA_I32_16X16X16I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_vgprcd_e64),
     /* 262361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262367 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262369 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262371 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262373 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262375 */     GIR_RootConstrainSelectedInstOperands,
     /* 262376 */     // GIR_Coverage, 1150,
     /* 262376 */     GIR_EraseRootFromParent_Done,
     /* 262377 */   // Label 4243: @262377
     /* 262377 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(262438), // Rule ID 1151 //
     /* 262382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 262390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262406 */     // MIs[0] cbsz
     /* 262406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262409 */     // MIs[0] abid
     /* 262409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262412 */     // MIs[0] blgp
     /* 262412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23277),
     /* 262419 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3063:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23277>>  =>  (V_MFMA_I32_32X32X8I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_e64),
     /* 262422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262426 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262428 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262430 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262432 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262434 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262436 */     GIR_RootConstrainSelectedInstOperands,
     /* 262437 */     // GIR_Coverage, 1151,
     /* 262437 */     GIR_EraseRootFromParent_Done,
     /* 262438 */   // Label 4244: @262438
     /* 262438 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(262499), // Rule ID 1152 //
     /* 262443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 262451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262467 */     // MIs[0] cbsz
     /* 262467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262470 */     // MIs[0] abid
     /* 262470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262473 */     // MIs[0] blgp
     /* 262473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23279),
     /* 262480 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3063:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23279>>  =>  (V_MFMA_I32_32X32X8I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_vgprcd_e64),
     /* 262483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262487 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262489 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262491 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262493 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262495 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262497 */     GIR_RootConstrainSelectedInstOperands,
     /* 262498 */     // GIR_Coverage, 1152,
     /* 262498 */     GIR_EraseRootFromParent_Done,
     /* 262499 */   // Label 4245: @262499
     /* 262499 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(262560), // Rule ID 1153 //
     /* 262504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 262512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262528 */     // MIs[0] cbsz
     /* 262528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262531 */     // MIs[0] abid
     /* 262531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262534 */     // MIs[0] blgp
     /* 262534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23281),
     /* 262541 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3051:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23281>>  =>  (V_MFMA_F32_4X4X2BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_e64),
     /* 262544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262546 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262548 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262550 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262552 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262554 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262556 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262558 */     GIR_RootConstrainSelectedInstOperands,
     /* 262559 */     // GIR_Coverage, 1153,
     /* 262559 */     GIR_EraseRootFromParent_Done,
     /* 262560 */   // Label 4246: @262560
     /* 262560 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(262621), // Rule ID 1154 //
     /* 262565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 262573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262589 */     // MIs[0] cbsz
     /* 262589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262592 */     // MIs[0] abid
     /* 262592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262595 */     // MIs[0] blgp
     /* 262595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23283),
     /* 262602 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3051:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23283>>  =>  (V_MFMA_F32_4X4X2BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_vgprcd_e64),
     /* 262605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262609 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262611 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262613 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262615 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262617 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262619 */     GIR_RootConstrainSelectedInstOperands,
     /* 262620 */     // GIR_Coverage, 1154,
     /* 262620 */     GIR_EraseRootFromParent_Done,
     /* 262621 */   // Label 4247: @262621
     /* 262621 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(262682), // Rule ID 1155 //
     /* 262626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 262634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262650 */     // MIs[0] cbsz
     /* 262650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262653 */     // MIs[0] abid
     /* 262653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262656 */     // MIs[0] blgp
     /* 262656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23287),
     /* 262663 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3023:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23287>>  =>  (V_MFMA_F32_16X16X2BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_e64),
     /* 262666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262672 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262674 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262676 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262678 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262680 */     GIR_RootConstrainSelectedInstOperands,
     /* 262681 */     // GIR_Coverage, 1155,
     /* 262681 */     GIR_EraseRootFromParent_Done,
     /* 262682 */   // Label 4248: @262682
     /* 262682 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(262743), // Rule ID 1156 //
     /* 262687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 262695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262711 */     // MIs[0] cbsz
     /* 262711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262714 */     // MIs[0] abid
     /* 262714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262717 */     // MIs[0] blgp
     /* 262717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23289),
     /* 262724 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3023:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23289>>  =>  (V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64),
     /* 262727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262731 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262733 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262735 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262737 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262739 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262741 */     GIR_RootConstrainSelectedInstOperands,
     /* 262742 */     // GIR_Coverage, 1156,
     /* 262742 */     GIR_EraseRootFromParent_Done,
     /* 262743 */   // Label 4249: @262743
     /* 262743 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(262804), // Rule ID 1157 //
     /* 262748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 262756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262772 */     // MIs[0] cbsz
     /* 262772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262775 */     // MIs[0] abid
     /* 262775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262778 */     // MIs[0] blgp
     /* 262778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23291),
     /* 262785 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3034:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23291>>  =>  (V_MFMA_F32_16X16X8BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_e64),
     /* 262788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262792 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262794 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262796 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262798 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262800 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262802 */     GIR_RootConstrainSelectedInstOperands,
     /* 262803 */     // GIR_Coverage, 1157,
     /* 262803 */     GIR_EraseRootFromParent_Done,
     /* 262804 */   // Label 4250: @262804
     /* 262804 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(262865), // Rule ID 1158 //
     /* 262809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 262817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262833 */     // MIs[0] cbsz
     /* 262833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262836 */     // MIs[0] abid
     /* 262836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262839 */     // MIs[0] blgp
     /* 262839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23293),
     /* 262846 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3034:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23293>>  =>  (V_MFMA_F32_16X16X8BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_vgprcd_e64),
     /* 262849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262851 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262853 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262855 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262857 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262859 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262861 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262863 */     GIR_RootConstrainSelectedInstOperands,
     /* 262864 */     // GIR_Coverage, 1158,
     /* 262864 */     GIR_EraseRootFromParent_Done,
     /* 262865 */   // Label 4251: @262865
     /* 262865 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(262926), // Rule ID 1159 //
     /* 262870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 262878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 262894 */     // MIs[0] cbsz
     /* 262894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262897 */     // MIs[0] abid
     /* 262897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262900 */     // MIs[0] blgp
     /* 262900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23297),
     /* 262907 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3042:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23297>>  =>  (V_MFMA_F32_32X32X2BF16_mac_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_e64),
     /* 262910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262912 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262914 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262916 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262918 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262920 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262922 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262924 */     GIR_RootConstrainSelectedInstOperands,
     /* 262925 */     // GIR_Coverage, 1159,
     /* 262925 */     GIR_EraseRootFromParent_Done,
     /* 262926 */   // Label 4252: @262926
     /* 262926 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(262987), // Rule ID 1160 //
     /* 262931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 262939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 262955 */     // MIs[0] cbsz
     /* 262955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262958 */     // MIs[0] abid
     /* 262958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262961 */     // MIs[0] blgp
     /* 262961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23299),
     /* 262968 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3042:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23299>>  =>  (V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64),
     /* 262971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262977 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262979 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262981 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262983 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262985 */     GIR_RootConstrainSelectedInstOperands,
     /* 262986 */     // GIR_Coverage, 1160,
     /* 262986 */     GIR_EraseRootFromParent_Done,
     /* 262987 */   // Label 4253: @262987
     /* 262987 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(263048), // Rule ID 1161 //
     /* 262992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 263000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 263006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 263009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263016 */     // MIs[0] cbsz
     /* 263016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263019 */     // MIs[0] abid
     /* 263019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263022 */     // MIs[0] blgp
     /* 263022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23301),
     /* 263029 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3045:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23301>>  =>  (V_MFMA_F32_32X32X4BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_e64),
     /* 263032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263038 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263040 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263042 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263046 */     GIR_RootConstrainSelectedInstOperands,
     /* 263047 */     // GIR_Coverage, 1161,
     /* 263047 */     GIR_EraseRootFromParent_Done,
     /* 263048 */   // Label 4254: @263048
     /* 263048 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(263109), // Rule ID 1162 //
     /* 263053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 263056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 263061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 263067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 263070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263077 */     // MIs[0] cbsz
     /* 263077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263080 */     // MIs[0] abid
     /* 263080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263083 */     // MIs[0] blgp
     /* 263083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23303),
     /* 263090 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3045:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23303>>  =>  (V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64),
     /* 263093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263097 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263099 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263101 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263103 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263105 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263107 */     GIR_RootConstrainSelectedInstOperands,
     /* 263108 */     // GIR_Coverage, 1162,
     /* 263108 */     GIR_EraseRootFromParent_Done,
     /* 263109 */   // Label 4255: @263109
     /* 263109 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(263170), // Rule ID 1163 //
     /* 263114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 263122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 263131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263138 */     // MIs[0] cbsz
     /* 263138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263141 */     // MIs[0] abid
     /* 263141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263144 */     // MIs[0] blgp
     /* 263144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23305),
     /* 263151 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3027:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23305>>  =>  (V_MFMA_F32_16X16X32_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_e64),
     /* 263154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263158 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263160 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263162 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263164 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263166 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263168 */     GIR_RootConstrainSelectedInstOperands,
     /* 263169 */     // GIR_Coverage, 1163,
     /* 263169 */     GIR_EraseRootFromParent_Done,
     /* 263170 */   // Label 4256: @263170
     /* 263170 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(263231), // Rule ID 1164 //
     /* 263175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 263183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 263192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263199 */     // MIs[0] cbsz
     /* 263199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263202 */     // MIs[0] abid
     /* 263202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263205 */     // MIs[0] blgp
     /* 263205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23307),
     /* 263212 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3027:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23307>>  =>  (V_MFMA_F32_16X16X32_F16_vgprcd_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_vgprcd_e64),
     /* 263215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263219 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263221 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263223 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263225 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263227 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263229 */     GIR_RootConstrainSelectedInstOperands,
     /* 263230 */     // GIR_Coverage, 1164,
     /* 263230 */     GIR_EraseRootFromParent_Done,
     /* 263231 */   // Label 4257: @263231
     /* 263231 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(263292), // Rule ID 1165 //
     /* 263236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 263244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 263253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263260 */     // MIs[0] cbsz
     /* 263260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263263 */     // MIs[0] abid
     /* 263263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263266 */     // MIs[0] blgp
     /* 263266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23311),
     /* 263273 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3038:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23311>>  =>  (V_MFMA_F32_32X32X16_F16_mac_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_e64),
     /* 263276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263280 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263282 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263284 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263286 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263288 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263290 */     GIR_RootConstrainSelectedInstOperands,
     /* 263291 */     // GIR_Coverage, 1165,
     /* 263291 */     GIR_EraseRootFromParent_Done,
     /* 263292 */   // Label 4258: @263292
     /* 263292 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(263353), // Rule ID 1166 //
     /* 263297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 263305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 263314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263321 */     // MIs[0] cbsz
     /* 263321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263324 */     // MIs[0] abid
     /* 263324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263327 */     // MIs[0] blgp
     /* 263327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23313),
     /* 263334 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3038:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23313>>  =>  (V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64),
     /* 263337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263341 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263343 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263345 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263347 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263349 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263351 */     GIR_RootConstrainSelectedInstOperands,
     /* 263352 */     // GIR_Coverage, 1166,
     /* 263352 */     GIR_EraseRootFromParent_Done,
     /* 263353 */   // Label 4259: @263353
     /* 263353 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(263414), // Rule ID 1167 //
     /* 263358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 263366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263382 */     // MIs[0] cbsz
     /* 263382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263385 */     // MIs[0] abid
     /* 263385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263388 */     // MIs[0] blgp
     /* 263388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23319),
     /* 263395 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3059:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23319>>  =>  (V_MFMA_I32_16X16X64_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_e64),
     /* 263398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263402 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263404 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263406 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263408 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263410 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263412 */     GIR_RootConstrainSelectedInstOperands,
     /* 263413 */     // GIR_Coverage, 1167,
     /* 263413 */     GIR_EraseRootFromParent_Done,
     /* 263414 */   // Label 4260: @263414
     /* 263414 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(263475), // Rule ID 1168 //
     /* 263419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 263427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263443 */     // MIs[0] cbsz
     /* 263443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263446 */     // MIs[0] abid
     /* 263446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263449 */     // MIs[0] blgp
     /* 263449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23321),
     /* 263456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3059:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23321>>  =>  (V_MFMA_I32_16X16X64_I8_vgprcd_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_vgprcd_e64),
     /* 263459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263463 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263465 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263467 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263469 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263471 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263473 */     GIR_RootConstrainSelectedInstOperands,
     /* 263474 */     // GIR_Coverage, 1168,
     /* 263474 */     GIR_EraseRootFromParent_Done,
     /* 263475 */   // Label 4261: @263475
     /* 263475 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(263536), // Rule ID 1169 //
     /* 263480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 263488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263504 */     // MIs[0] cbsz
     /* 263504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263507 */     // MIs[0] abid
     /* 263507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263510 */     // MIs[0] blgp
     /* 263510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23331),
     /* 263517 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3061:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23331>>  =>  (V_MFMA_I32_32X32X32_I8_mac_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_e64),
     /* 263520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263526 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263528 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263530 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263532 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263534 */     GIR_RootConstrainSelectedInstOperands,
     /* 263535 */     // GIR_Coverage, 1169,
     /* 263535 */     GIR_EraseRootFromParent_Done,
     /* 263536 */   // Label 4262: @263536
     /* 263536 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(263597), // Rule ID 1170 //
     /* 263541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 263549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263565 */     // MIs[0] cbsz
     /* 263565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263568 */     // MIs[0] abid
     /* 263568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263571 */     // MIs[0] blgp
     /* 263571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23333),
     /* 263578 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3061:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23333>>  =>  (V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64),
     /* 263581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263585 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263587 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263589 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263591 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263593 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263595 */     GIR_RootConstrainSelectedInstOperands,
     /* 263596 */     // GIR_Coverage, 1170,
     /* 263596 */     GIR_EraseRootFromParent_Done,
     /* 263597 */   // Label 4263: @263597
     /* 263597 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(263658), // Rule ID 1243 //
     /* 263602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 263610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 263613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 263622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 263626 */     // MIs[0] cbsz
     /* 263626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263629 */     // MIs[0] abid
     /* 263629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263632 */     // MIs[0] blgp
     /* 263632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23455),
     /* 263639 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3046:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23455>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_e64),
     /* 263642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263646 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263648 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263650 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263652 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263654 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263656 */     GIR_RootConstrainSelectedInstOperands,
     /* 263657 */     // GIR_Coverage, 1243,
     /* 263657 */     GIR_EraseRootFromParent_Done,
     /* 263658 */   // Label 4264: @263658
     /* 263658 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(263719), // Rule ID 1244 //
     /* 263663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 263671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 263674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 263683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 263687 */     // MIs[0] cbsz
     /* 263687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263690 */     // MIs[0] abid
     /* 263690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263693 */     // MIs[0] blgp
     /* 263693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23457),
     /* 263700 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3046:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23457>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64),
     /* 263703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263707 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263709 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263711 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263713 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263715 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263717 */     GIR_RootConstrainSelectedInstOperands,
     /* 263718 */     // GIR_Coverage, 1244,
     /* 263718 */     GIR_EraseRootFromParent_Done,
     /* 263719 */   // Label 4265: @263719
     /* 263719 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(263780), // Rule ID 1245 //
     /* 263724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 263732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263748 */     // MIs[0] cbsz
     /* 263748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263751 */     // MIs[0] abid
     /* 263751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263754 */     // MIs[0] blgp
     /* 263754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23461),
     /* 263761 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3030:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23461>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_e64),
     /* 263764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263770 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263772 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263774 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263776 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263778 */     GIR_RootConstrainSelectedInstOperands,
     /* 263779 */     // GIR_Coverage, 1245,
     /* 263779 */     GIR_EraseRootFromParent_Done,
     /* 263780 */   // Label 4266: @263780
     /* 263780 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(263841), // Rule ID 1246 //
     /* 263785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 263793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263809 */     // MIs[0] cbsz
     /* 263809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263812 */     // MIs[0] abid
     /* 263812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263815 */     // MIs[0] blgp
     /* 263815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23463),
     /* 263822 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3030:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23463>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64),
     /* 263825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263827 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263829 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263831 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263833 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263835 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263837 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263839 */     GIR_RootConstrainSelectedInstOperands,
     /* 263840 */     // GIR_Coverage, 1246,
     /* 263840 */     GIR_EraseRootFromParent_Done,
     /* 263841 */   // Label 4267: @263841
     /* 263841 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(263902), // Rule ID 1247 //
     /* 263846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 263854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263870 */     // MIs[0] cbsz
     /* 263870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263873 */     // MIs[0] abid
     /* 263873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263876 */     // MIs[0] blgp
     /* 263876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23465),
     /* 263883 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3052:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23465>>  =>  (V_MFMA_F32_4X4X4BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_e64),
     /* 263886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263892 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263894 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263896 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263898 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263900 */     GIR_RootConstrainSelectedInstOperands,
     /* 263901 */     // GIR_Coverage, 1247,
     /* 263901 */     GIR_EraseRootFromParent_Done,
     /* 263902 */   // Label 4268: @263902
     /* 263902 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(263963), // Rule ID 1248 //
     /* 263907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 263915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263931 */     // MIs[0] cbsz
     /* 263931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263934 */     // MIs[0] abid
     /* 263934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263937 */     // MIs[0] blgp
     /* 263937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23467),
     /* 263944 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3052:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23467>>  =>  (V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64),
     /* 263947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263951 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263953 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263955 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263957 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263959 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263961 */     GIR_RootConstrainSelectedInstOperands,
     /* 263962 */     // GIR_Coverage, 1248,
     /* 263962 */     GIR_EraseRootFromParent_Done,
     /* 263963 */   // Label 4269: @263963
     /* 263963 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(264024), // Rule ID 1249 //
     /* 263968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 263976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263992 */     // MIs[0] cbsz
     /* 263992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263995 */     // MIs[0] abid
     /* 263995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263998 */     // MIs[0] blgp
     /* 263998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23469),
     /* 264005 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3048:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23469>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_e64),
     /* 264008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264012 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264014 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264016 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264018 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264020 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264022 */     GIR_RootConstrainSelectedInstOperands,
     /* 264023 */     // GIR_Coverage, 1249,
     /* 264023 */     GIR_EraseRootFromParent_Done,
     /* 264024 */   // Label 4270: @264024
     /* 264024 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(264085), // Rule ID 1250 //
     /* 264029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 264037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 264046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264053 */     // MIs[0] cbsz
     /* 264053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264056 */     // MIs[0] abid
     /* 264056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264059 */     // MIs[0] blgp
     /* 264059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23471),
     /* 264066 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3048:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23471>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64),
     /* 264069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264073 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264075 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264077 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264079 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264081 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264083 */     GIR_RootConstrainSelectedInstOperands,
     /* 264084 */     // GIR_Coverage, 1250,
     /* 264084 */     GIR_EraseRootFromParent_Done,
     /* 264085 */   // Label 4271: @264085
     /* 264085 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(264146), // Rule ID 1251 //
     /* 264090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 264098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 264107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264114 */     // MIs[0] cbsz
     /* 264114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264117 */     // MIs[0] abid
     /* 264117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264120 */     // MIs[0] blgp
     /* 264120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23473),
     /* 264127 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23473>>  =>  (V_MFMA_F32_16X16X16BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_e64),
     /* 264130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264132 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264134 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264136 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264138 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264140 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264142 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264144 */     GIR_RootConstrainSelectedInstOperands,
     /* 264145 */     // GIR_Coverage, 1251,
     /* 264145 */     GIR_EraseRootFromParent_Done,
     /* 264146 */   // Label 4272: @264146
     /* 264146 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(264207), // Rule ID 1252 //
     /* 264151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 264159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 264168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264175 */     // MIs[0] cbsz
     /* 264175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264178 */     // MIs[0] abid
     /* 264178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264181 */     // MIs[0] blgp
     /* 264181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23475),
     /* 264188 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23475>>  =>  (V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64),
     /* 264191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264197 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264199 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264201 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264203 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264205 */     GIR_RootConstrainSelectedInstOperands,
     /* 264206 */     // GIR_Coverage, 1252,
     /* 264206 */     GIR_EraseRootFromParent_Done,
     /* 264207 */   // Label 4273: @264207
     /* 264207 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(264268), // Rule ID 1253 //
     /* 264212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 264220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 264223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 264232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_256RegClassID),
     /* 264236 */     // MIs[0] cbsz
     /* 264236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264239 */     // MIs[0] abid
     /* 264239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264242 */     // MIs[0] blgp
     /* 264242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23479),
     /* 264249 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3054:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23479>>  =>  (V_MFMA_F64_16X16X4F64_mac_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_e64),
     /* 264252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264256 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264258 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264260 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264262 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264264 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264266 */     GIR_RootConstrainSelectedInstOperands,
     /* 264267 */     // GIR_Coverage, 1253,
     /* 264267 */     GIR_EraseRootFromParent_Done,
     /* 264268 */   // Label 4274: @264268
     /* 264268 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(264329), // Rule ID 1254 //
     /* 264273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 264281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 264284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 264293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 264297 */     // MIs[0] cbsz
     /* 264297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264300 */     // MIs[0] abid
     /* 264300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264303 */     // MIs[0] blgp
     /* 264303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23481),
     /* 264310 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3054:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23481>>  =>  (V_MFMA_F64_16X16X4F64_mac_vgprcd_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_vgprcd_e64),
     /* 264313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264317 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264319 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264321 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264323 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264325 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264327 */     GIR_RootConstrainSelectedInstOperands,
     /* 264328 */     // GIR_Coverage, 1254,
     /* 264328 */     GIR_EraseRootFromParent_Done,
     /* 264329 */   // Label 4275: @264329
     /* 264329 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(264390), // Rule ID 1255 //
     /* 264334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 264342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 264354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_64RegClassID),
     /* 264358 */     // MIs[0] cbsz
     /* 264358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264361 */     // MIs[0] abid
     /* 264361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264364 */     // MIs[0] blgp
     /* 264364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23483),
     /* 264371 */     // (intrinsic_wo_chain:{ *:[f64] } 3055:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23483>>  =>  (V_MFMA_F64_4X4X4F64_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_e64),
     /* 264374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264378 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264380 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264382 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264384 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264386 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264388 */     GIR_RootConstrainSelectedInstOperands,
     /* 264389 */     // GIR_Coverage, 1255,
     /* 264389 */     GIR_EraseRootFromParent_Done,
     /* 264390 */   // Label 4276: @264390
     /* 264390 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(264451), // Rule ID 1256 //
     /* 264395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 264403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 264415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 264419 */     // MIs[0] cbsz
     /* 264419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264422 */     // MIs[0] abid
     /* 264422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264425 */     // MIs[0] blgp
     /* 264425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23485),
     /* 264432 */     // (intrinsic_wo_chain:{ *:[f64] } 3055:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23485>>  =>  (V_MFMA_F64_4X4X4F64_vgprcd_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_vgprcd_e64),
     /* 264435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264441 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264443 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264445 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264447 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264449 */     GIR_RootConstrainSelectedInstOperands,
     /* 264450 */     // GIR_Coverage, 1256,
     /* 264450 */     GIR_EraseRootFromParent_Done,
     /* 264451 */   // Label 4277: @264451
     /* 264451 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(264512), // Rule ID 1257 //
     /* 264456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 264459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 264464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 264480 */     // MIs[0] cbsz
     /* 264480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264483 */     // MIs[0] abid
     /* 264483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264486 */     // MIs[0] blgp
     /* 264486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23489),
     /* 264493 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3060:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23489>>  =>  (V_MFMA_I32_32X32X16I8_mac_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_e64),
     /* 264496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264502 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264504 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264506 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264508 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264510 */     GIR_RootConstrainSelectedInstOperands,
     /* 264511 */     // GIR_Coverage, 1257,
     /* 264511 */     GIR_EraseRootFromParent_Done,
     /* 264512 */   // Label 4278: @264512
     /* 264512 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(264573), // Rule ID 1258 //
     /* 264517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 264520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 264525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264541 */     // MIs[0] cbsz
     /* 264541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264544 */     // MIs[0] abid
     /* 264544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264547 */     // MIs[0] blgp
     /* 264547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23491),
     /* 264554 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3060:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23491>>  =>  (V_MFMA_I32_32X32X16I8_mac_vgprcd_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_vgprcd_e64),
     /* 264557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264561 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264563 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264565 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264567 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264569 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264571 */     GIR_RootConstrainSelectedInstOperands,
     /* 264572 */     // GIR_Coverage, 1258,
     /* 264572 */     GIR_EraseRootFromParent_Done,
     /* 264573 */   // Label 4279: @264573
     /* 264573 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(264634), // Rule ID 1259 //
     /* 264578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 264581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 264586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264602 */     // MIs[0] cbsz
     /* 264602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264605 */     // MIs[0] abid
     /* 264605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264608 */     // MIs[0] blgp
     /* 264608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23493),
     /* 264615 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3057:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23493>>  =>  (V_MFMA_I32_16X16X32I8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_e64),
     /* 264618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264624 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264626 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264628 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264630 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264632 */     GIR_RootConstrainSelectedInstOperands,
     /* 264633 */     // GIR_Coverage, 1259,
     /* 264633 */     GIR_EraseRootFromParent_Done,
     /* 264634 */   // Label 4280: @264634
     /* 264634 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(264695), // Rule ID 1260 //
     /* 264639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 264642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 264647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264663 */     // MIs[0] cbsz
     /* 264663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264666 */     // MIs[0] abid
     /* 264666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264669 */     // MIs[0] blgp
     /* 264669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23495),
     /* 264676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3057:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23495>>  =>  (V_MFMA_I32_16X16X32I8_vgprcd_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_vgprcd_e64),
     /* 264679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264683 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264685 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264687 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264689 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264691 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264693 */     GIR_RootConstrainSelectedInstOperands,
     /* 264694 */     // GIR_Coverage, 1260,
     /* 264694 */     GIR_EraseRootFromParent_Done,
     /* 264695 */   // Label 4281: @264695
     /* 264695 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(264756), // Rule ID 1261 //
     /* 264700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 264703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 264708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264724 */     // MIs[0] cbsz
     /* 264724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264727 */     // MIs[0] abid
     /* 264727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264730 */     // MIs[0] blgp
     /* 264730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23497),
     /* 264737 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3033:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23497>>  =>  (V_MFMA_F32_16X16X8XF32_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_e64),
     /* 264740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264744 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264746 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264748 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264750 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264752 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264754 */     GIR_RootConstrainSelectedInstOperands,
     /* 264755 */     // GIR_Coverage, 1261,
     /* 264755 */     GIR_EraseRootFromParent_Done,
     /* 264756 */   // Label 4282: @264756
     /* 264756 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(264817), // Rule ID 1262 //
     /* 264761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 264764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 264769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264785 */     // MIs[0] cbsz
     /* 264785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264788 */     // MIs[0] abid
     /* 264788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264791 */     // MIs[0] blgp
     /* 264791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23499),
     /* 264798 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3033:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23499>>  =>  (V_MFMA_F32_16X16X8XF32_vgprcd_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_vgprcd_e64),
     /* 264801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264807 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264809 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264811 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264813 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264815 */     GIR_RootConstrainSelectedInstOperands,
     /* 264816 */     // GIR_Coverage, 1262,
     /* 264816 */     GIR_EraseRootFromParent_Done,
     /* 264817 */   // Label 4283: @264817
     /* 264817 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(264878), // Rule ID 1263 //
     /* 264822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 264825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 264830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 264846 */     // MIs[0] cbsz
     /* 264846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264849 */     // MIs[0] abid
     /* 264849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264852 */     // MIs[0] blgp
     /* 264852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23503),
     /* 264859 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3044:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23503>>  =>  (V_MFMA_F32_32X32X4XF32_mac_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_e64),
     /* 264862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264868 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264870 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264872 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264874 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264876 */     GIR_RootConstrainSelectedInstOperands,
     /* 264877 */     // GIR_Coverage, 1263,
     /* 264877 */     GIR_EraseRootFromParent_Done,
     /* 264878 */   // Label 4284: @264878
     /* 264878 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(264939), // Rule ID 1264 //
     /* 264883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 264886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 264891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264907 */     // MIs[0] cbsz
     /* 264907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264910 */     // MIs[0] abid
     /* 264910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264913 */     // MIs[0] blgp
     /* 264913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23505),
     /* 264920 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3044:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23505>>  =>  (V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64),
     /* 264923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264927 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264929 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264931 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264933 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264935 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264937 */     GIR_RootConstrainSelectedInstOperands,
     /* 264938 */     // GIR_Coverage, 1264,
     /* 264938 */     GIR_EraseRootFromParent_Done,
     /* 264939 */   // Label 4285: @264939
     /* 264939 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(265000), // Rule ID 1265 //
     /* 264944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 264947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 264952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264968 */     // MIs[0] cbsz
     /* 264968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264971 */     // MIs[0] abid
     /* 264971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264974 */     // MIs[0] blgp
     /* 264974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23507),
     /* 264981 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3025:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23507>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_e64),
     /* 264984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264988 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264990 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264992 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264994 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264996 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264998 */     GIR_RootConstrainSelectedInstOperands,
     /* 264999 */     // GIR_Coverage, 1265,
     /* 264999 */     GIR_EraseRootFromParent_Done,
     /* 265000 */   // Label 4286: @265000
     /* 265000 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(265061), // Rule ID 1266 //
     /* 265005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 265013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265029 */     // MIs[0] cbsz
     /* 265029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265032 */     // MIs[0] abid
     /* 265032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265035 */     // MIs[0] blgp
     /* 265035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23509),
     /* 265042 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3025:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23509>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64),
     /* 265045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265049 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265051 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265053 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265055 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265057 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265059 */     GIR_RootConstrainSelectedInstOperands,
     /* 265060 */     // GIR_Coverage, 1266,
     /* 265060 */     GIR_EraseRootFromParent_Done,
     /* 265061 */   // Label 4287: @265061
     /* 265061 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(265122), // Rule ID 1267 //
     /* 265066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 265074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265090 */     // MIs[0] cbsz
     /* 265090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265093 */     // MIs[0] abid
     /* 265093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265096 */     // MIs[0] blgp
     /* 265096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23511),
     /* 265103 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3026:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23511>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_e64),
     /* 265106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265110 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265112 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265114 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265116 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265118 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265120 */     GIR_RootConstrainSelectedInstOperands,
     /* 265121 */     // GIR_Coverage, 1267,
     /* 265121 */     GIR_EraseRootFromParent_Done,
     /* 265122 */   // Label 4288: @265122
     /* 265122 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(265183), // Rule ID 1268 //
     /* 265127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 265135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265151 */     // MIs[0] cbsz
     /* 265151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265154 */     // MIs[0] abid
     /* 265154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265157 */     // MIs[0] blgp
     /* 265157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23513),
     /* 265164 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3026:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23513>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64),
     /* 265167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265171 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265173 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265175 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265177 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265179 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265181 */     GIR_RootConstrainSelectedInstOperands,
     /* 265182 */     // GIR_Coverage, 1268,
     /* 265182 */     GIR_EraseRootFromParent_Done,
     /* 265183 */   // Label 4289: @265183
     /* 265183 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(265244), // Rule ID 1269 //
     /* 265188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 265196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265212 */     // MIs[0] cbsz
     /* 265212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265215 */     // MIs[0] abid
     /* 265215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265218 */     // MIs[0] blgp
     /* 265218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23515),
     /* 265225 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3028:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23515>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_e64),
     /* 265228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265234 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265236 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265238 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265240 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265242 */     GIR_RootConstrainSelectedInstOperands,
     /* 265243 */     // GIR_Coverage, 1269,
     /* 265243 */     GIR_EraseRootFromParent_Done,
     /* 265244 */   // Label 4290: @265244
     /* 265244 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(265305), // Rule ID 1270 //
     /* 265249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 265257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265273 */     // MIs[0] cbsz
     /* 265273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265276 */     // MIs[0] abid
     /* 265276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265279 */     // MIs[0] blgp
     /* 265279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23517),
     /* 265286 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3028:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23517>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64),
     /* 265289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265295 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265297 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265299 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265301 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265303 */     GIR_RootConstrainSelectedInstOperands,
     /* 265304 */     // GIR_Coverage, 1270,
     /* 265304 */     GIR_EraseRootFromParent_Done,
     /* 265305 */   // Label 4291: @265305
     /* 265305 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(265366), // Rule ID 1271 //
     /* 265310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 265318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265334 */     // MIs[0] cbsz
     /* 265334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265337 */     // MIs[0] abid
     /* 265337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265340 */     // MIs[0] blgp
     /* 265340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23519),
     /* 265347 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3029:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23519>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_e64),
     /* 265350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265356 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265358 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265360 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265362 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265364 */     GIR_RootConstrainSelectedInstOperands,
     /* 265365 */     // GIR_Coverage, 1271,
     /* 265365 */     GIR_EraseRootFromParent_Done,
     /* 265366 */   // Label 4292: @265366
     /* 265366 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(265427), // Rule ID 1272 //
     /* 265371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 265379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265395 */     // MIs[0] cbsz
     /* 265395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265398 */     // MIs[0] abid
     /* 265398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265401 */     // MIs[0] blgp
     /* 265401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23521),
     /* 265408 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3029:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23521>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64),
     /* 265411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265415 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265417 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265419 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265421 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265423 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265425 */     GIR_RootConstrainSelectedInstOperands,
     /* 265426 */     // GIR_Coverage, 1272,
     /* 265426 */     GIR_EraseRootFromParent_Done,
     /* 265427 */   // Label 4293: @265427
     /* 265427 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(265488), // Rule ID 1273 //
     /* 265432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 265440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265456 */     // MIs[0] cbsz
     /* 265456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265459 */     // MIs[0] abid
     /* 265459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265462 */     // MIs[0] blgp
     /* 265462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23525),
     /* 265469 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3036:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23525>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_e64),
     /* 265472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265476 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265478 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265480 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265482 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265484 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265486 */     GIR_RootConstrainSelectedInstOperands,
     /* 265487 */     // GIR_Coverage, 1273,
     /* 265487 */     GIR_EraseRootFromParent_Done,
     /* 265488 */   // Label 4294: @265488
     /* 265488 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(265549), // Rule ID 1274 //
     /* 265493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 265501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265517 */     // MIs[0] cbsz
     /* 265517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265520 */     // MIs[0] abid
     /* 265520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265523 */     // MIs[0] blgp
     /* 265523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23527),
     /* 265530 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3036:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23527>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64),
     /* 265533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265539 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265541 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265543 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265545 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265547 */     GIR_RootConstrainSelectedInstOperands,
     /* 265548 */     // GIR_Coverage, 1274,
     /* 265548 */     GIR_EraseRootFromParent_Done,
     /* 265549 */   // Label 4295: @265549
     /* 265549 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(265610), // Rule ID 1275 //
     /* 265554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 265562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265578 */     // MIs[0] cbsz
     /* 265578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265581 */     // MIs[0] abid
     /* 265581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265584 */     // MIs[0] blgp
     /* 265584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23529),
     /* 265591 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3037:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23529>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_e64),
     /* 265594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265598 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265600 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265602 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265604 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265606 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265608 */     GIR_RootConstrainSelectedInstOperands,
     /* 265609 */     // GIR_Coverage, 1275,
     /* 265609 */     GIR_EraseRootFromParent_Done,
     /* 265610 */   // Label 4296: @265610
     /* 265610 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(265671), // Rule ID 1276 //
     /* 265615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 265623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265639 */     // MIs[0] cbsz
     /* 265639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265642 */     // MIs[0] abid
     /* 265642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265645 */     // MIs[0] blgp
     /* 265645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23531),
     /* 265652 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3037:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23531>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64),
     /* 265655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265659 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265661 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265663 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265665 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265667 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265669 */     GIR_RootConstrainSelectedInstOperands,
     /* 265670 */     // GIR_Coverage, 1276,
     /* 265670 */     GIR_EraseRootFromParent_Done,
     /* 265671 */   // Label 4297: @265671
     /* 265671 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(265732), // Rule ID 1277 //
     /* 265676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 265684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265700 */     // MIs[0] cbsz
     /* 265700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265703 */     // MIs[0] abid
     /* 265703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265706 */     // MIs[0] blgp
     /* 265706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23533),
     /* 265713 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3039:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23533>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_e64),
     /* 265716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265720 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265722 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265724 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265726 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265728 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265730 */     GIR_RootConstrainSelectedInstOperands,
     /* 265731 */     // GIR_Coverage, 1277,
     /* 265731 */     GIR_EraseRootFromParent_Done,
     /* 265732 */   // Label 4298: @265732
     /* 265732 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(265793), // Rule ID 1278 //
     /* 265737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 265745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265761 */     // MIs[0] cbsz
     /* 265761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265764 */     // MIs[0] abid
     /* 265764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265767 */     // MIs[0] blgp
     /* 265767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23535),
     /* 265774 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3039:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23535>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64),
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265783 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265785 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265787 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265789 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265791 */     GIR_RootConstrainSelectedInstOperands,
     /* 265792 */     // GIR_Coverage, 1278,
     /* 265792 */     GIR_EraseRootFromParent_Done,
     /* 265793 */   // Label 4299: @265793
     /* 265793 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(265854), // Rule ID 1279 //
     /* 265798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 265806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265822 */     // MIs[0] cbsz
     /* 265822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265825 */     // MIs[0] abid
     /* 265825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265828 */     // MIs[0] blgp
     /* 265828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23537),
     /* 265835 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3040:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23537>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_e64),
     /* 265838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265842 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265844 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265846 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265848 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265850 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265852 */     GIR_RootConstrainSelectedInstOperands,
     /* 265853 */     // GIR_Coverage, 1279,
     /* 265853 */     GIR_EraseRootFromParent_Done,
     /* 265854 */   // Label 4300: @265854
     /* 265854 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(265915), // Rule ID 1280 //
     /* 265859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 265867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265883 */     // MIs[0] cbsz
     /* 265883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265886 */     // MIs[0] abid
     /* 265886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265889 */     // MIs[0] blgp
     /* 265889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23539),
     /* 265896 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3040:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23539>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64),
     /* 265899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265903 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265905 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265907 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265909 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265911 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265913 */     GIR_RootConstrainSelectedInstOperands,
     /* 265914 */     // GIR_Coverage, 1280,
     /* 265914 */     GIR_EraseRootFromParent_Done,
     /* 265915 */   // Label 4301: @265915
     /* 265915 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(265972), // Rule ID 1281 //
     /* 265920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_f16),
     /* 265928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 265947 */     // MIs[0] cbsz
     /* 265947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265950 */     // MIs[0] abid
     /* 265950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265953 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3209:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 265953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_F16_e64),
     /* 265956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265960 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265962 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265964 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265966 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265968 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265970 */     GIR_RootConstrainSelectedInstOperands,
     /* 265971 */     // GIR_Coverage, 1281,
     /* 265971 */     GIR_EraseRootFromParent_Done,
     /* 265972 */   // Label 4302: @265972
     /* 265972 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(266029), // Rule ID 1282 //
     /* 265977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_f16),
     /* 265985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266004 */     // MIs[0] cbsz
     /* 266004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266007 */     // MIs[0] abid
     /* 266007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266010 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3217:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_F16_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_F16_e64),
     /* 266013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266017 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266019 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266021 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266023 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266025 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266027 */     GIR_RootConstrainSelectedInstOperands,
     /* 266028 */     // GIR_Coverage, 1282,
     /* 266028 */     GIR_EraseRootFromParent_Done,
     /* 266029 */   // Label 4303: @266029
     /* 266029 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(266086), // Rule ID 1283 //
     /* 266034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 266037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_bf16),
     /* 266042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 266051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266061 */     // MIs[0] cbsz
     /* 266061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266064 */     // MIs[0] abid
     /* 266064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266067 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3208:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_BF16_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_BF16_e64),
     /* 266070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266074 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266076 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266078 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266080 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266082 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266084 */     GIR_RootConstrainSelectedInstOperands,
     /* 266085 */     // GIR_Coverage, 1283,
     /* 266085 */     GIR_EraseRootFromParent_Done,
     /* 266086 */   // Label 4304: @266086
     /* 266086 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(266143), // Rule ID 1284 //
     /* 266091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 266094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_bf16),
     /* 266099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 266108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266118 */     // MIs[0] cbsz
     /* 266118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266121 */     // MIs[0] abid
     /* 266121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266124 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3216:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_BF16_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_BF16_e64),
     /* 266127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266131 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266133 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266135 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266137 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266139 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266141 */     GIR_RootConstrainSelectedInstOperands,
     /* 266142 */     // GIR_Coverage, 1284,
     /* 266142 */     GIR_EraseRootFromParent_Done,
     /* 266143 */   // Label 4305: @266143
     /* 266143 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(266200), // Rule ID 1285 //
     /* 266148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 266151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x64_i8),
     /* 266156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266175 */     // MIs[0] cbsz
     /* 266175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266178 */     // MIs[0] abid
     /* 266178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3229:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X64_I8_e64:{ *:[v4i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 266181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X64_I8_e64),
     /* 266184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266188 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266190 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266192 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266194 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266196 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266198 */     GIR_RootConstrainSelectedInstOperands,
     /* 266199 */     // GIR_Coverage, 1285,
     /* 266199 */     GIR_EraseRootFromParent_Done,
     /* 266200 */   // Label 4306: @266200
     /* 266200 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(266257), // Rule ID 1286 //
     /* 266205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 266208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x32_i8),
     /* 266213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266232 */     // MIs[0] cbsz
     /* 266232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266235 */     // MIs[0] abid
     /* 266235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266238 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3230:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X32_I8_e64:{ *:[v16i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 266238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X32_I8_e64),
     /* 266241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266245 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266247 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266249 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266251 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266253 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266255 */     GIR_RootConstrainSelectedInstOperands,
     /* 266256 */     // GIR_Coverage, 1286,
     /* 266256 */     GIR_EraseRootFromParent_Done,
     /* 266257 */   // Label 4307: @266257
     /* 266257 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(266314), // Rule ID 1287 //
     /* 266262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_bf8),
     /* 266270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266289 */     // MIs[0] cbsz
     /* 266289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266292 */     // MIs[0] abid
     /* 266292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266295 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3211:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_BF8_e64),
     /* 266298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266302 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266304 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266306 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266308 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266310 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266312 */     GIR_RootConstrainSelectedInstOperands,
     /* 266313 */     // GIR_Coverage, 1287,
     /* 266313 */     GIR_EraseRootFromParent_Done,
     /* 266314 */   // Label 4308: @266314
     /* 266314 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(266371), // Rule ID 1288 //
     /* 266319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_fp8),
     /* 266327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266346 */     // MIs[0] cbsz
     /* 266346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266349 */     // MIs[0] abid
     /* 266349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3212:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_FP8_e64),
     /* 266355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266361 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266363 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266365 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266367 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266369 */     GIR_RootConstrainSelectedInstOperands,
     /* 266370 */     // GIR_Coverage, 1288,
     /* 266370 */     GIR_EraseRootFromParent_Done,
     /* 266371 */   // Label 4309: @266371
     /* 266371 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(266428), // Rule ID 1289 //
     /* 266376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_bf8),
     /* 266384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266403 */     // MIs[0] cbsz
     /* 266403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266406 */     // MIs[0] abid
     /* 266406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266409 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3214:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_BF8_e64),
     /* 266412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266414 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266416 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266418 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266420 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266422 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266424 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266426 */     GIR_RootConstrainSelectedInstOperands,
     /* 266427 */     // GIR_Coverage, 1289,
     /* 266427 */     GIR_EraseRootFromParent_Done,
     /* 266428 */   // Label 4310: @266428
     /* 266428 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(266485), // Rule ID 1290 //
     /* 266433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_fp8),
     /* 266441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266460 */     // MIs[0] cbsz
     /* 266460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266463 */     // MIs[0] abid
     /* 266463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266466 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3215:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_FP8_e64),
     /* 266469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266473 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266475 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266477 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266479 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266481 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266483 */     GIR_RootConstrainSelectedInstOperands,
     /* 266484 */     // GIR_Coverage, 1290,
     /* 266484 */     GIR_EraseRootFromParent_Done,
     /* 266485 */   // Label 4311: @266485
     /* 266485 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(266542), // Rule ID 1291 //
     /* 266490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_bf8),
     /* 266498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266517 */     // MIs[0] cbsz
     /* 266517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266520 */     // MIs[0] abid
     /* 266520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266523 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3219:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_BF8_e64),
     /* 266526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266530 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266532 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266534 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266536 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266538 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266540 */     GIR_RootConstrainSelectedInstOperands,
     /* 266541 */     // GIR_Coverage, 1291,
     /* 266541 */     GIR_EraseRootFromParent_Done,
     /* 266542 */   // Label 4312: @266542
     /* 266542 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(266599), // Rule ID 1292 //
     /* 266547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_fp8),
     /* 266555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266574 */     // MIs[0] cbsz
     /* 266574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266577 */     // MIs[0] abid
     /* 266577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266580 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3220:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_FP8_e64),
     /* 266583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266587 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266589 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266591 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266593 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266595 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266597 */     GIR_RootConstrainSelectedInstOperands,
     /* 266598 */     // GIR_Coverage, 1292,
     /* 266598 */     GIR_EraseRootFromParent_Done,
     /* 266599 */   // Label 4313: @266599
     /* 266599 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(266656), // Rule ID 1293 //
     /* 266604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_bf8),
     /* 266612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266631 */     // MIs[0] cbsz
     /* 266631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266634 */     // MIs[0] abid
     /* 266634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266637 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3222:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_BF8_e64),
     /* 266640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266644 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266646 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266648 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266650 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266652 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266654 */     GIR_RootConstrainSelectedInstOperands,
     /* 266655 */     // GIR_Coverage, 1293,
     /* 266655 */     GIR_EraseRootFromParent_Done,
     /* 266656 */   // Label 4314: @266656
     /* 266656 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(266713), // Rule ID 1294 //
     /* 266661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_fp8),
     /* 266669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266688 */     // MIs[0] cbsz
     /* 266688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266691 */     // MIs[0] abid
     /* 266691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266694 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3223:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_FP8_e64),
     /* 266697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266701 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266703 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266705 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266707 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266709 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266711 */     GIR_RootConstrainSelectedInstOperands,
     /* 266712 */     // GIR_Coverage, 1294,
     /* 266712 */     GIR_EraseRootFromParent_Done,
     /* 266713 */   // Label 4315: @266713
     /* 266713 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(266770), // Rule ID 1295 //
     /* 266718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_f16),
     /* 266726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 266735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266745 */     // MIs[0] cbsz
     /* 266745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266748 */     // MIs[0] abid
     /* 266748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266751 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3213:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_F16_e64),
     /* 266754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266758 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266760 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266762 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266764 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266766 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266768 */     GIR_RootConstrainSelectedInstOperands,
     /* 266769 */     // GIR_Coverage, 1295,
     /* 266769 */     GIR_EraseRootFromParent_Done,
     /* 266770 */   // Label 4316: @266770
     /* 266770 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(266827), // Rule ID 1296 //
     /* 266775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_f16),
     /* 266783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 266792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266802 */     // MIs[0] cbsz
     /* 266802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266805 */     // MIs[0] abid
     /* 266805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266808 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3221:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_F16_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_F16_e64),
     /* 266811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266817 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266819 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266821 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266823 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266825 */     GIR_RootConstrainSelectedInstOperands,
     /* 266826 */     // GIR_Coverage, 1296,
     /* 266826 */     GIR_EraseRootFromParent_Done,
     /* 266827 */   // Label 4317: @266827
     /* 266827 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(266884), // Rule ID 1297 //
     /* 266832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x128_i8),
     /* 266840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266859 */     // MIs[0] cbsz
     /* 266859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266862 */     // MIs[0] abid
     /* 266862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266865 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3228:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X128_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 266865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X128_I8_e64),
     /* 266868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266872 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266874 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266876 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266878 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266880 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266882 */     GIR_RootConstrainSelectedInstOperands,
     /* 266883 */     // GIR_Coverage, 1297,
     /* 266883 */     GIR_EraseRootFromParent_Done,
     /* 266884 */   // Label 4318: @266884
     /* 266884 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(266941), // Rule ID 1298 //
     /* 266889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x64_i8),
     /* 266897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266916 */     // MIs[0] cbsz
     /* 266916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266919 */     // MIs[0] abid
     /* 266919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266922 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3231:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X64_I8_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 266922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X64_I8_e64),
     /* 266925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266929 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266931 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266933 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266935 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266937 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266939 */     GIR_RootConstrainSelectedInstOperands,
     /* 266940 */     // GIR_Coverage, 1298,
     /* 266940 */     GIR_EraseRootFromParent_Done,
     /* 266941 */   // Label 4319: @266941
     /* 266941 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(266998), // Rule ID 1299 //
     /* 266946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_bf8),
     /* 266954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266973 */     // MIs[0] cbsz
     /* 266973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266976 */     // MIs[0] abid
     /* 266976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266979 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3204:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_BF8_e64),
     /* 266982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266986 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266988 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266990 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266992 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266994 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266996 */     GIR_RootConstrainSelectedInstOperands,
     /* 266997 */     // GIR_Coverage, 1299,
     /* 266997 */     GIR_EraseRootFromParent_Done,
     /* 266998 */   // Label 4320: @266998
     /* 266998 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(267055), // Rule ID 1300 //
     /* 267003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_fp8),
     /* 267011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 267030 */     // MIs[0] cbsz
     /* 267030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267033 */     // MIs[0] abid
     /* 267033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267036 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3205:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 267036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_FP8_e64),
     /* 267039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267043 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267045 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267047 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267049 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267051 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267053 */     GIR_RootConstrainSelectedInstOperands,
     /* 267054 */     // GIR_Coverage, 1300,
     /* 267054 */     GIR_EraseRootFromParent_Done,
     /* 267055 */   // Label 4321: @267055
     /* 267055 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(267112), // Rule ID 1301 //
     /* 267060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_bf8),
     /* 267068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 267087 */     // MIs[0] cbsz
     /* 267087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267090 */     // MIs[0] abid
     /* 267090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267093 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3206:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 267093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_BF8_e64),
     /* 267096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267100 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267102 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267104 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267106 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267108 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267110 */     GIR_RootConstrainSelectedInstOperands,
     /* 267111 */     // GIR_Coverage, 1301,
     /* 267111 */     GIR_EraseRootFromParent_Done,
     /* 267112 */   // Label 4322: @267112
     /* 267112 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(267169), // Rule ID 1302 //
     /* 267117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_fp8),
     /* 267125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 267144 */     // MIs[0] cbsz
     /* 267144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267147 */     // MIs[0] abid
     /* 267147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267150 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3207:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 267150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_FP8_e64),
     /* 267153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267159 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267161 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267163 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267165 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267167 */     GIR_RootConstrainSelectedInstOperands,
     /* 267168 */     // GIR_Coverage, 1302,
     /* 267168 */     GIR_EraseRootFromParent_Done,
     /* 267169 */   // Label 4323: @267169
     /* 267169 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(267226), // Rule ID 1303 //
     /* 267174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_bf8),
     /* 267182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267201 */     // MIs[0] cbsz
     /* 267201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267204 */     // MIs[0] abid
     /* 267204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267207 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3224:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_BF8_e64),
     /* 267210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267214 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267216 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267218 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267220 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267222 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267224 */     GIR_RootConstrainSelectedInstOperands,
     /* 267225 */     // GIR_Coverage, 1303,
     /* 267225 */     GIR_EraseRootFromParent_Done,
     /* 267226 */   // Label 4324: @267226
     /* 267226 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(267283), // Rule ID 1304 //
     /* 267231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_fp8),
     /* 267239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267258 */     // MIs[0] cbsz
     /* 267258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267261 */     // MIs[0] abid
     /* 267261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267264 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3225:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_FP8_e64),
     /* 267267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267271 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267273 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267275 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267277 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267279 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267281 */     GIR_RootConstrainSelectedInstOperands,
     /* 267282 */     // GIR_Coverage, 1304,
     /* 267282 */     GIR_EraseRootFromParent_Done,
     /* 267283 */   // Label 4325: @267283
     /* 267283 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(267340), // Rule ID 1305 //
     /* 267288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_bf8),
     /* 267296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267315 */     // MIs[0] cbsz
     /* 267315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267318 */     // MIs[0] abid
     /* 267318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267321 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3226:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_BF8_e64),
     /* 267324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267330 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267332 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267334 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267336 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267338 */     GIR_RootConstrainSelectedInstOperands,
     /* 267339 */     // GIR_Coverage, 1305,
     /* 267339 */     GIR_EraseRootFromParent_Done,
     /* 267340 */   // Label 4326: @267340
     /* 267340 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(267397), // Rule ID 1306 //
     /* 267345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_fp8),
     /* 267353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267372 */     // MIs[0] cbsz
     /* 267372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267375 */     // MIs[0] abid
     /* 267375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267378 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3227:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_FP8_e64),
     /* 267381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267385 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267387 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267389 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267391 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267393 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267395 */     GIR_RootConstrainSelectedInstOperands,
     /* 267396 */     // GIR_Coverage, 1306,
     /* 267396 */     GIR_EraseRootFromParent_Done,
     /* 267397 */   // Label 4327: @267397
     /* 267397 */   GIM_Reject,
     /* 267398 */ // Label 4166: @267398
     /* 267398 */ GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(267938),
     /* 267403 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 267406 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(267497), // Rule ID 2840 //
     /* 267411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 267419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 267428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267438 */     // MIs[0] clamp
     /* 267438 */     // No operand predicates
     /* 267438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267459 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3297:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr),
     /* 267462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267469 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267476 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267478 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267490 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267495 */     GIR_RootConstrainSelectedInstOperands,
     /* 267496 */     // GIR_Coverage, 2840,
     /* 267496 */     GIR_EraseRootFromParent_Done,
     /* 267497 */   // Label 4329: @267497
     /* 267497 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(267588), // Rule ID 2841 //
     /* 267502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 267510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267529 */     // MIs[0] clamp
     /* 267529 */     // No operand predicates
     /* 267529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267550 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3296:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr),
     /* 267553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267567 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267569 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267581 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267586 */     GIR_RootConstrainSelectedInstOperands,
     /* 267587 */     // GIR_Coverage, 2841,
     /* 267587 */     GIR_EraseRootFromParent_Done,
     /* 267588 */   // Label 4330: @267588
     /* 267588 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(267679), // Rule ID 2873 //
     /* 267593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 267601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267620 */     // MIs[0] clamp
     /* 267620 */     // No operand predicates
     /* 267620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 267641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3297:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit, i1:{ *:[i1] }:$clamp)
     /* 267641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr),
     /* 267644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267651 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267658 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267660 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 267672 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267677 */     GIR_RootConstrainSelectedInstOperands,
     /* 267678 */     // GIR_Coverage, 2873,
     /* 267678 */     GIR_EraseRootFromParent_Done,
     /* 267679 */   // Label 4331: @267679
     /* 267679 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(267770), // Rule ID 2874 //
     /* 267684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 267692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267711 */     // MIs[0] clamp
     /* 267711 */     // No operand predicates
     /* 267711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3296:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr),
     /* 267735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267742 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267749 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267751 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267763 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267768 */     GIR_RootConstrainSelectedInstOperands,
     /* 267769 */     // GIR_Coverage, 2874,
     /* 267769 */     GIR_EraseRootFromParent_Done,
     /* 267770 */   // Label 4332: @267770
     /* 267770 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(267861), // Rule ID 2875 //
     /* 267775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 267783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267802 */     // MIs[0] clamp
     /* 267802 */     // No operand predicates
     /* 267802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267823 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3298:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr),
     /* 267826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267840 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267842 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267854 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267859 */     GIR_RootConstrainSelectedInstOperands,
     /* 267860 */     // GIR_Coverage, 2875,
     /* 267860 */     GIR_EraseRootFromParent_Done,
     /* 267861 */   // Label 4333: @267861
     /* 267861 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(267937), // Rule ID 2842 //
     /* 267866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 267874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 267883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267893 */     // MIs[0] clamp
     /* 267893 */     // No operand predicates
     /* 267893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267907 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3298:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 267907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr),
     /* 267910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267917 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267924 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267926 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267928 */     GIR_RootToRootCopy, /*OpIdx*/7, // src2
     /* 267930 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267935 */     GIR_RootConstrainSelectedInstOperands,
     /* 267936 */     // GIR_Coverage, 2842,
     /* 267936 */     GIR_EraseRootFromParent_Done,
     /* 267937 */   // Label 4334: @267937
     /* 267937 */   GIM_Reject,
     /* 267938 */ // Label 4328: @267938
     /* 267938 */ GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(273851),
     /* 267943 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/11,
     /* 267946 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(268016), // Rule ID 1171 //
     /* 267951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 267965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267971 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267974 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267981 */     // MIs[0] cbsz
     /* 267981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267984 */     // MIs[0] blgp
     /* 267984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267987 */     // MIs[0] Operand 7
     /* 267987 */     // No operand predicates
     /* 267987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267991 */     // MIs[0] Operand 9
     /* 267991 */     // No operand predicates
     /* 267991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 267999 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 268002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268008 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268010 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268012 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268014 */     GIR_RootConstrainSelectedInstOperands,
     /* 268015 */     // GIR_Coverage, 1171,
     /* 268015 */     GIR_EraseRootFromParent_Done,
     /* 268016 */   // Label 4336: @268016
     /* 268016 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(268086), // Rule ID 1172 //
     /* 268021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268041 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268044 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268051 */     // MIs[0] cbsz
     /* 268051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268054 */     // MIs[0] blgp
     /* 268054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268057 */     // MIs[0] Operand 7
     /* 268057 */     // No operand predicates
     /* 268057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268061 */     // MIs[0] Operand 9
     /* 268061 */     // No operand predicates
     /* 268061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268069 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 268072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268076 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268078 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268080 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268082 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268084 */     GIR_RootConstrainSelectedInstOperands,
     /* 268085 */     // GIR_Coverage, 1172,
     /* 268085 */     GIR_EraseRootFromParent_Done,
     /* 268086 */   // Label 4337: @268086
     /* 268086 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(268156), // Rule ID 1173 //
     /* 268091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268111 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268114 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268121 */     // MIs[0] cbsz
     /* 268121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268124 */     // MIs[0] blgp
     /* 268124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268127 */     // MIs[0] Operand 7
     /* 268127 */     // No operand predicates
     /* 268127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268131 */     // MIs[0] Operand 9
     /* 268131 */     // No operand predicates
     /* 268131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268139 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 268142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268146 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268148 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268150 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268152 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268154 */     GIR_RootConstrainSelectedInstOperands,
     /* 268155 */     // GIR_Coverage, 1173,
     /* 268155 */     GIR_EraseRootFromParent_Done,
     /* 268156 */   // Label 4338: @268156
     /* 268156 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(268226), // Rule ID 1174 //
     /* 268161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268181 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268184 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268191 */     // MIs[0] cbsz
     /* 268191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268194 */     // MIs[0] blgp
     /* 268194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268197 */     // MIs[0] Operand 7
     /* 268197 */     // No operand predicates
     /* 268197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268201 */     // MIs[0] Operand 9
     /* 268201 */     // No operand predicates
     /* 268201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268209 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 268212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268216 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268218 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268220 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268222 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268224 */     GIR_RootConstrainSelectedInstOperands,
     /* 268225 */     // GIR_Coverage, 1174,
     /* 268225 */     GIR_EraseRootFromParent_Done,
     /* 268226 */   // Label 4339: @268226
     /* 268226 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(268296), // Rule ID 1175 //
     /* 268231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268251 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268254 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268261 */     // MIs[0] cbsz
     /* 268261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268264 */     // MIs[0] blgp
     /* 268264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268267 */     // MIs[0] Operand 7
     /* 268267 */     // No operand predicates
     /* 268267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268271 */     // MIs[0] Operand 9
     /* 268271 */     // No operand predicates
     /* 268271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268279 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 268282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268286 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268288 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268290 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268292 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268294 */     GIR_RootConstrainSelectedInstOperands,
     /* 268295 */     // GIR_Coverage, 1175,
     /* 268295 */     GIR_EraseRootFromParent_Done,
     /* 268296 */   // Label 4340: @268296
     /* 268296 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(268366), // Rule ID 1176 //
     /* 268301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268321 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268324 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268331 */     // MIs[0] cbsz
     /* 268331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268334 */     // MIs[0] blgp
     /* 268334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268337 */     // MIs[0] Operand 7
     /* 268337 */     // No operand predicates
     /* 268337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268341 */     // MIs[0] Operand 9
     /* 268341 */     // No operand predicates
     /* 268341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268349 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 268352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268356 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268358 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268360 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268362 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268364 */     GIR_RootConstrainSelectedInstOperands,
     /* 268365 */     // GIR_Coverage, 1176,
     /* 268365 */     GIR_EraseRootFromParent_Done,
     /* 268366 */   // Label 4341: @268366
     /* 268366 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(268436), // Rule ID 1177 //
     /* 268371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268391 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268394 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268401 */     // MIs[0] cbsz
     /* 268401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268404 */     // MIs[0] blgp
     /* 268404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268407 */     // MIs[0] Operand 7
     /* 268407 */     // No operand predicates
     /* 268407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268411 */     // MIs[0] Operand 9
     /* 268411 */     // No operand predicates
     /* 268411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268419 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 268422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268426 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268428 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268430 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268432 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268434 */     GIR_RootConstrainSelectedInstOperands,
     /* 268435 */     // GIR_Coverage, 1177,
     /* 268435 */     GIR_EraseRootFromParent_Done,
     /* 268436 */   // Label 4342: @268436
     /* 268436 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(268506), // Rule ID 1178 //
     /* 268441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268461 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268464 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268471 */     // MIs[0] cbsz
     /* 268471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268474 */     // MIs[0] blgp
     /* 268474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268477 */     // MIs[0] Operand 7
     /* 268477 */     // No operand predicates
     /* 268477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268481 */     // MIs[0] Operand 9
     /* 268481 */     // No operand predicates
     /* 268481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268489 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 268492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268496 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268498 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268500 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268502 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268504 */     GIR_RootConstrainSelectedInstOperands,
     /* 268505 */     // GIR_Coverage, 1178,
     /* 268505 */     GIR_EraseRootFromParent_Done,
     /* 268506 */   // Label 4343: @268506
     /* 268506 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(268576), // Rule ID 1179 //
     /* 268511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268531 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268534 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268541 */     // MIs[0] cbsz
     /* 268541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268544 */     // MIs[0] blgp
     /* 268544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268547 */     // MIs[0] Operand 7
     /* 268547 */     // No operand predicates
     /* 268547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268551 */     // MIs[0] Operand 9
     /* 268551 */     // No operand predicates
     /* 268551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268559 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 268562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268566 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268568 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268570 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268572 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268574 */     GIR_RootConstrainSelectedInstOperands,
     /* 268575 */     // GIR_Coverage, 1179,
     /* 268575 */     GIR_EraseRootFromParent_Done,
     /* 268576 */   // Label 4344: @268576
     /* 268576 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(268646), // Rule ID 1180 //
     /* 268581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268601 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268604 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268611 */     // MIs[0] cbsz
     /* 268611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268614 */     // MIs[0] blgp
     /* 268614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268617 */     // MIs[0] Operand 7
     /* 268617 */     // No operand predicates
     /* 268617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268621 */     // MIs[0] Operand 9
     /* 268621 */     // No operand predicates
     /* 268621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268629 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 268632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268636 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268638 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268640 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268642 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268644 */     GIR_RootConstrainSelectedInstOperands,
     /* 268645 */     // GIR_Coverage, 1180,
     /* 268645 */     GIR_EraseRootFromParent_Done,
     /* 268646 */   // Label 4345: @268646
     /* 268646 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(268716), // Rule ID 1181 //
     /* 268651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268671 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268674 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268681 */     // MIs[0] cbsz
     /* 268681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268684 */     // MIs[0] blgp
     /* 268684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268687 */     // MIs[0] Operand 7
     /* 268687 */     // No operand predicates
     /* 268687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268691 */     // MIs[0] Operand 9
     /* 268691 */     // No operand predicates
     /* 268691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268699 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 268702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268708 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268710 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268712 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268714 */     GIR_RootConstrainSelectedInstOperands,
     /* 268715 */     // GIR_Coverage, 1181,
     /* 268715 */     GIR_EraseRootFromParent_Done,
     /* 268716 */   // Label 4346: @268716
     /* 268716 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(268786), // Rule ID 1182 //
     /* 268721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268741 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268744 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268751 */     // MIs[0] cbsz
     /* 268751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268754 */     // MIs[0] blgp
     /* 268754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268757 */     // MIs[0] Operand 7
     /* 268757 */     // No operand predicates
     /* 268757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268761 */     // MIs[0] Operand 9
     /* 268761 */     // No operand predicates
     /* 268761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268769 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 268772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268776 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268778 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268780 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268782 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268784 */     GIR_RootConstrainSelectedInstOperands,
     /* 268785 */     // GIR_Coverage, 1182,
     /* 268785 */     GIR_EraseRootFromParent_Done,
     /* 268786 */   // Label 4347: @268786
     /* 268786 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(268856), // Rule ID 1183 //
     /* 268791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268811 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268814 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268821 */     // MIs[0] cbsz
     /* 268821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268824 */     // MIs[0] blgp
     /* 268824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268827 */     // MIs[0] Operand 7
     /* 268827 */     // No operand predicates
     /* 268827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268831 */     // MIs[0] Operand 9
     /* 268831 */     // No operand predicates
     /* 268831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268839 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 268842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268846 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268848 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268850 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268852 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268854 */     GIR_RootConstrainSelectedInstOperands,
     /* 268855 */     // GIR_Coverage, 1183,
     /* 268855 */     GIR_EraseRootFromParent_Done,
     /* 268856 */   // Label 4348: @268856
     /* 268856 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(268926), // Rule ID 1184 //
     /* 268861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268881 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268884 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268891 */     // MIs[0] cbsz
     /* 268891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268894 */     // MIs[0] blgp
     /* 268894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268897 */     // MIs[0] Operand 7
     /* 268897 */     // No operand predicates
     /* 268897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268901 */     // MIs[0] Operand 9
     /* 268901 */     // No operand predicates
     /* 268901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 268909 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 268912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268916 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268918 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268920 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268922 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268924 */     GIR_RootConstrainSelectedInstOperands,
     /* 268925 */     // GIR_Coverage, 1184,
     /* 268925 */     GIR_EraseRootFromParent_Done,
     /* 268926 */   // Label 4349: @268926
     /* 268926 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(268996), // Rule ID 1185 //
     /* 268931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268951 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268954 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268961 */     // MIs[0] cbsz
     /* 268961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268964 */     // MIs[0] blgp
     /* 268964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268967 */     // MIs[0] Operand 7
     /* 268967 */     // No operand predicates
     /* 268967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268971 */     // MIs[0] Operand 9
     /* 268971 */     // No operand predicates
     /* 268971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 268979 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 268982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268986 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268988 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268990 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268992 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268994 */     GIR_RootConstrainSelectedInstOperands,
     /* 268995 */     // GIR_Coverage, 1185,
     /* 268995 */     GIR_EraseRootFromParent_Done,
     /* 268996 */   // Label 4350: @268996
     /* 268996 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(269066), // Rule ID 1186 //
     /* 269001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 269009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269021 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269024 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269031 */     // MIs[0] cbsz
     /* 269031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269034 */     // MIs[0] blgp
     /* 269034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269037 */     // MIs[0] Operand 7
     /* 269037 */     // No operand predicates
     /* 269037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269041 */     // MIs[0] Operand 9
     /* 269041 */     // No operand predicates
     /* 269041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 269049 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 269052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269056 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269058 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269060 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269062 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269064 */     GIR_RootConstrainSelectedInstOperands,
     /* 269065 */     // GIR_Coverage, 1186,
     /* 269065 */     GIR_EraseRootFromParent_Done,
     /* 269066 */   // Label 4351: @269066
     /* 269066 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(269136), // Rule ID 1187 //
     /* 269071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 269079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269091 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269094 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 269101 */     // MIs[0] cbsz
     /* 269101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269104 */     // MIs[0] blgp
     /* 269104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269107 */     // MIs[0] Operand 7
     /* 269107 */     // No operand predicates
     /* 269107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269111 */     // MIs[0] Operand 9
     /* 269111 */     // No operand predicates
     /* 269111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23335),
     /* 269119 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23335>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 269122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269126 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269128 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269130 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269132 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269134 */     GIR_RootConstrainSelectedInstOperands,
     /* 269135 */     // GIR_Coverage, 1187,
     /* 269135 */     GIR_EraseRootFromParent_Done,
     /* 269136 */   // Label 4352: @269136
     /* 269136 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(269206), // Rule ID 1188 //
     /* 269141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 269149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269161 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269164 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269171 */     // MIs[0] cbsz
     /* 269171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269174 */     // MIs[0] blgp
     /* 269174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269177 */     // MIs[0] Operand 7
     /* 269177 */     // No operand predicates
     /* 269177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269181 */     // MIs[0] Operand 9
     /* 269181 */     // No operand predicates
     /* 269181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23337),
     /* 269189 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23337>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 269192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269196 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269198 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269200 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269202 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269204 */     GIR_RootConstrainSelectedInstOperands,
     /* 269205 */     // GIR_Coverage, 1188,
     /* 269205 */     GIR_EraseRootFromParent_Done,
     /* 269206 */   // Label 4353: @269206
     /* 269206 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(269276), // Rule ID 1189 //
     /* 269211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269231 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269234 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269241 */     // MIs[0] cbsz
     /* 269241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269244 */     // MIs[0] blgp
     /* 269244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269247 */     // MIs[0] Operand 7
     /* 269247 */     // No operand predicates
     /* 269247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269251 */     // MIs[0] Operand 9
     /* 269251 */     // No operand predicates
     /* 269251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269259 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 269262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269266 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269268 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269270 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269272 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269274 */     GIR_RootConstrainSelectedInstOperands,
     /* 269275 */     // GIR_Coverage, 1189,
     /* 269275 */     GIR_EraseRootFromParent_Done,
     /* 269276 */   // Label 4354: @269276
     /* 269276 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(269346), // Rule ID 1190 //
     /* 269281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269301 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269304 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269311 */     // MIs[0] cbsz
     /* 269311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269314 */     // MIs[0] blgp
     /* 269314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269317 */     // MIs[0] Operand 7
     /* 269317 */     // No operand predicates
     /* 269317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269321 */     // MIs[0] Operand 9
     /* 269321 */     // No operand predicates
     /* 269321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 269329 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 269332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269336 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269338 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269340 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269342 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269344 */     GIR_RootConstrainSelectedInstOperands,
     /* 269345 */     // GIR_Coverage, 1190,
     /* 269345 */     GIR_EraseRootFromParent_Done,
     /* 269346 */   // Label 4355: @269346
     /* 269346 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(269416), // Rule ID 1191 //
     /* 269351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269371 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269374 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269381 */     // MIs[0] cbsz
     /* 269381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269384 */     // MIs[0] blgp
     /* 269384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269387 */     // MIs[0] Operand 7
     /* 269387 */     // No operand predicates
     /* 269387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269391 */     // MIs[0] Operand 9
     /* 269391 */     // No operand predicates
     /* 269391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269399 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 269402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269406 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269408 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269410 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269412 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269414 */     GIR_RootConstrainSelectedInstOperands,
     /* 269415 */     // GIR_Coverage, 1191,
     /* 269415 */     GIR_EraseRootFromParent_Done,
     /* 269416 */   // Label 4356: @269416
     /* 269416 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(269486), // Rule ID 1192 //
     /* 269421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269441 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269444 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269451 */     // MIs[0] cbsz
     /* 269451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269454 */     // MIs[0] blgp
     /* 269454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269457 */     // MIs[0] Operand 7
     /* 269457 */     // No operand predicates
     /* 269457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269461 */     // MIs[0] Operand 9
     /* 269461 */     // No operand predicates
     /* 269461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 269469 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 269472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269476 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269478 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269480 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269482 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269484 */     GIR_RootConstrainSelectedInstOperands,
     /* 269485 */     // GIR_Coverage, 1192,
     /* 269485 */     GIR_EraseRootFromParent_Done,
     /* 269486 */   // Label 4357: @269486
     /* 269486 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(269556), // Rule ID 1193 //
     /* 269491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269511 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269514 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269521 */     // MIs[0] cbsz
     /* 269521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269524 */     // MIs[0] blgp
     /* 269524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269527 */     // MIs[0] Operand 7
     /* 269527 */     // No operand predicates
     /* 269527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269531 */     // MIs[0] Operand 9
     /* 269531 */     // No operand predicates
     /* 269531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269539 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 269542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269546 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269548 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269550 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269552 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269554 */     GIR_RootConstrainSelectedInstOperands,
     /* 269555 */     // GIR_Coverage, 1193,
     /* 269555 */     GIR_EraseRootFromParent_Done,
     /* 269556 */   // Label 4358: @269556
     /* 269556 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(269626), // Rule ID 1194 //
     /* 269561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269581 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269584 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269591 */     // MIs[0] cbsz
     /* 269591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269594 */     // MIs[0] blgp
     /* 269594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269597 */     // MIs[0] Operand 7
     /* 269597 */     // No operand predicates
     /* 269597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269601 */     // MIs[0] Operand 9
     /* 269601 */     // No operand predicates
     /* 269601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 269609 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 269612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269616 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269618 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269620 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269622 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269624 */     GIR_RootConstrainSelectedInstOperands,
     /* 269625 */     // GIR_Coverage, 1194,
     /* 269625 */     GIR_EraseRootFromParent_Done,
     /* 269626 */   // Label 4359: @269626
     /* 269626 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(269696), // Rule ID 1195 //
     /* 269631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269651 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269654 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269661 */     // MIs[0] cbsz
     /* 269661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269664 */     // MIs[0] blgp
     /* 269664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269667 */     // MIs[0] Operand 7
     /* 269667 */     // No operand predicates
     /* 269667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269671 */     // MIs[0] Operand 9
     /* 269671 */     // No operand predicates
     /* 269671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269679 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 269682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269688 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269690 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269692 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269694 */     GIR_RootConstrainSelectedInstOperands,
     /* 269695 */     // GIR_Coverage, 1195,
     /* 269695 */     GIR_EraseRootFromParent_Done,
     /* 269696 */   // Label 4360: @269696
     /* 269696 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(269766), // Rule ID 1196 //
     /* 269701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269721 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269724 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269731 */     // MIs[0] cbsz
     /* 269731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269734 */     // MIs[0] blgp
     /* 269734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269737 */     // MIs[0] Operand 7
     /* 269737 */     // No operand predicates
     /* 269737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269741 */     // MIs[0] Operand 9
     /* 269741 */     // No operand predicates
     /* 269741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 269749 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 269752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269758 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269760 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269762 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269764 */     GIR_RootConstrainSelectedInstOperands,
     /* 269765 */     // GIR_Coverage, 1196,
     /* 269765 */     GIR_EraseRootFromParent_Done,
     /* 269766 */   // Label 4361: @269766
     /* 269766 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(269836), // Rule ID 1197 //
     /* 269771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269791 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269794 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269801 */     // MIs[0] cbsz
     /* 269801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269804 */     // MIs[0] blgp
     /* 269804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269807 */     // MIs[0] Operand 7
     /* 269807 */     // No operand predicates
     /* 269807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269811 */     // MIs[0] Operand 9
     /* 269811 */     // No operand predicates
     /* 269811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269819 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 269822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269826 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269828 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269830 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269832 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269834 */     GIR_RootConstrainSelectedInstOperands,
     /* 269835 */     // GIR_Coverage, 1197,
     /* 269835 */     GIR_EraseRootFromParent_Done,
     /* 269836 */   // Label 4362: @269836
     /* 269836 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(269906), // Rule ID 1198 //
     /* 269841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269861 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269864 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269871 */     // MIs[0] cbsz
     /* 269871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269874 */     // MIs[0] blgp
     /* 269874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269877 */     // MIs[0] Operand 7
     /* 269877 */     // No operand predicates
     /* 269877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269881 */     // MIs[0] Operand 9
     /* 269881 */     // No operand predicates
     /* 269881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 269889 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 269892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269894 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269896 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269898 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269900 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269902 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269904 */     GIR_RootConstrainSelectedInstOperands,
     /* 269905 */     // GIR_Coverage, 1198,
     /* 269905 */     GIR_EraseRootFromParent_Done,
     /* 269906 */   // Label 4363: @269906
     /* 269906 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(269976), // Rule ID 1199 //
     /* 269911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269931 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269934 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269941 */     // MIs[0] cbsz
     /* 269941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269944 */     // MIs[0] blgp
     /* 269944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269947 */     // MIs[0] Operand 7
     /* 269947 */     // No operand predicates
     /* 269947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269951 */     // MIs[0] Operand 9
     /* 269951 */     // No operand predicates
     /* 269951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 269959 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 269962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269966 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269968 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269970 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269972 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269974 */     GIR_RootConstrainSelectedInstOperands,
     /* 269975 */     // GIR_Coverage, 1199,
     /* 269975 */     GIR_EraseRootFromParent_Done,
     /* 269976 */   // Label 4364: @269976
     /* 269976 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(270046), // Rule ID 1200 //
     /* 269981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270001 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270004 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 270011 */     // MIs[0] cbsz
     /* 270011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270014 */     // MIs[0] blgp
     /* 270014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270017 */     // MIs[0] Operand 7
     /* 270017 */     // No operand predicates
     /* 270017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270021 */     // MIs[0] Operand 9
     /* 270021 */     // No operand predicates
     /* 270021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 270029 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 270032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270038 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270040 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270042 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270044 */     GIR_RootConstrainSelectedInstOperands,
     /* 270045 */     // GIR_Coverage, 1200,
     /* 270045 */     GIR_EraseRootFromParent_Done,
     /* 270046 */   // Label 4365: @270046
     /* 270046 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(270116), // Rule ID 1201 //
     /* 270051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270071 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270074 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 270081 */     // MIs[0] cbsz
     /* 270081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270084 */     // MIs[0] blgp
     /* 270084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270087 */     // MIs[0] Operand 7
     /* 270087 */     // No operand predicates
     /* 270087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270091 */     // MIs[0] Operand 9
     /* 270091 */     // No operand predicates
     /* 270091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 270099 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 270102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270106 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270108 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270110 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270112 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270114 */     GIR_RootConstrainSelectedInstOperands,
     /* 270115 */     // GIR_Coverage, 1201,
     /* 270115 */     GIR_EraseRootFromParent_Done,
     /* 270116 */   // Label 4366: @270116
     /* 270116 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(270186), // Rule ID 1202 //
     /* 270121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 270124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270141 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270144 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 270151 */     // MIs[0] cbsz
     /* 270151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270154 */     // MIs[0] blgp
     /* 270154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270157 */     // MIs[0] Operand 7
     /* 270157 */     // No operand predicates
     /* 270157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270161 */     // MIs[0] Operand 9
     /* 270161 */     // No operand predicates
     /* 270161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 270169 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 270172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270176 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270178 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270180 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270182 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270184 */     GIR_RootConstrainSelectedInstOperands,
     /* 270185 */     // GIR_Coverage, 1202,
     /* 270185 */     GIR_EraseRootFromParent_Done,
     /* 270186 */   // Label 4367: @270186
     /* 270186 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(270256), // Rule ID 1203 //
     /* 270191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270211 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270214 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 270221 */     // MIs[0] cbsz
     /* 270221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270224 */     // MIs[0] blgp
     /* 270224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270227 */     // MIs[0] Operand 7
     /* 270227 */     // No operand predicates
     /* 270227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270231 */     // MIs[0] Operand 9
     /* 270231 */     // No operand predicates
     /* 270231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 270239 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 270242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270244 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270246 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270248 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270250 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270252 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270254 */     GIR_RootConstrainSelectedInstOperands,
     /* 270255 */     // GIR_Coverage, 1203,
     /* 270255 */     GIR_EraseRootFromParent_Done,
     /* 270256 */   // Label 4368: @270256
     /* 270256 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(270326), // Rule ID 1204 //
     /* 270261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 270264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270281 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270284 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 270291 */     // MIs[0] cbsz
     /* 270291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270294 */     // MIs[0] blgp
     /* 270294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270297 */     // MIs[0] Operand 7
     /* 270297 */     // No operand predicates
     /* 270297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270301 */     // MIs[0] Operand 9
     /* 270301 */     // No operand predicates
     /* 270301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 270309 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 270312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270316 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270318 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270320 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270322 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270324 */     GIR_RootConstrainSelectedInstOperands,
     /* 270325 */     // GIR_Coverage, 1204,
     /* 270325 */     GIR_EraseRootFromParent_Done,
     /* 270326 */   // Label 4369: @270326
     /* 270326 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(270396), // Rule ID 1205 //
     /* 270331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270351 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270354 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 270361 */     // MIs[0] cbsz
     /* 270361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270364 */     // MIs[0] blgp
     /* 270364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270367 */     // MIs[0] Operand 7
     /* 270367 */     // No operand predicates
     /* 270367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270371 */     // MIs[0] Operand 9
     /* 270371 */     // No operand predicates
     /* 270371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23357),
     /* 270379 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23357>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 270382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270386 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270388 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270392 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270394 */     GIR_RootConstrainSelectedInstOperands,
     /* 270395 */     // GIR_Coverage, 1205,
     /* 270395 */     GIR_EraseRootFromParent_Done,
     /* 270396 */   // Label 4370: @270396
     /* 270396 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(270466), // Rule ID 1206 //
     /* 270401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 270404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270421 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270424 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 270431 */     // MIs[0] cbsz
     /* 270431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270434 */     // MIs[0] blgp
     /* 270434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270437 */     // MIs[0] Operand 7
     /* 270437 */     // No operand predicates
     /* 270437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270441 */     // MIs[0] Operand 9
     /* 270441 */     // No operand predicates
     /* 270441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23359),
     /* 270449 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23359>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 270452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270458 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270460 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270462 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270464 */     GIR_RootConstrainSelectedInstOperands,
     /* 270465 */     // GIR_Coverage, 1206,
     /* 270465 */     GIR_EraseRootFromParent_Done,
     /* 270466 */   // Label 4371: @270466
     /* 270466 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(270560), // Rule ID 1207 //
     /* 270471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270491 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270494 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270501 */     // MIs[0] cbsz
     /* 270501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270504 */     // MIs[0] blgp
     /* 270504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270507 */     // MIs[0] scale_src0_opsel
     /* 270507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270515 */     // MIs[0] scale_src1_opsel
     /* 270515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 270527 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 270530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270534 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270536 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270538 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270540 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270542 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270544 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270558 */     GIR_RootConstrainSelectedInstOperands,
     /* 270559 */     // GIR_Coverage, 1207,
     /* 270559 */     GIR_EraseRootFromParent_Done,
     /* 270560 */   // Label 4372: @270560
     /* 270560 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(270654), // Rule ID 1208 //
     /* 270565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270585 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270588 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270595 */     // MIs[0] cbsz
     /* 270595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270598 */     // MIs[0] blgp
     /* 270598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270601 */     // MIs[0] scale_src0_opsel
     /* 270601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270609 */     // MIs[0] scale_src1_opsel
     /* 270609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 270621 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 270624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270630 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270632 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270634 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270636 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270638 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270652 */     GIR_RootConstrainSelectedInstOperands,
     /* 270653 */     // GIR_Coverage, 1208,
     /* 270653 */     GIR_EraseRootFromParent_Done,
     /* 270654 */   // Label 4373: @270654
     /* 270654 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(270748), // Rule ID 1209 //
     /* 270659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270679 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270682 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270689 */     // MIs[0] cbsz
     /* 270689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270692 */     // MIs[0] blgp
     /* 270692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270695 */     // MIs[0] scale_src0_opsel
     /* 270695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270703 */     // MIs[0] scale_src1_opsel
     /* 270703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 270715 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 270718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270720 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270722 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270724 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270726 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270728 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270730 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270732 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270746 */     GIR_RootConstrainSelectedInstOperands,
     /* 270747 */     // GIR_Coverage, 1209,
     /* 270747 */     GIR_EraseRootFromParent_Done,
     /* 270748 */   // Label 4374: @270748
     /* 270748 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(270842), // Rule ID 1210 //
     /* 270753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270773 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270776 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270783 */     // MIs[0] cbsz
     /* 270783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270786 */     // MIs[0] blgp
     /* 270786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270789 */     // MIs[0] scale_src0_opsel
     /* 270789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270797 */     // MIs[0] scale_src1_opsel
     /* 270797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 270809 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 270812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270818 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270820 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270822 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270824 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270826 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270840 */     GIR_RootConstrainSelectedInstOperands,
     /* 270841 */     // GIR_Coverage, 1210,
     /* 270841 */     GIR_EraseRootFromParent_Done,
     /* 270842 */   // Label 4375: @270842
     /* 270842 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(270936), // Rule ID 1211 //
     /* 270847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270867 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270870 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270877 */     // MIs[0] cbsz
     /* 270877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270880 */     // MIs[0] blgp
     /* 270880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270883 */     // MIs[0] scale_src0_opsel
     /* 270883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270891 */     // MIs[0] scale_src1_opsel
     /* 270891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 270903 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 270906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270908 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270910 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270912 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270914 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270916 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270918 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270920 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270934 */     GIR_RootConstrainSelectedInstOperands,
     /* 270935 */     // GIR_Coverage, 1211,
     /* 270935 */     GIR_EraseRootFromParent_Done,
     /* 270936 */   // Label 4376: @270936
     /* 270936 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(271030), // Rule ID 1212 //
     /* 270941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270961 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270964 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270971 */     // MIs[0] cbsz
     /* 270971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270974 */     // MIs[0] blgp
     /* 270974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270977 */     // MIs[0] scale_src0_opsel
     /* 270977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270985 */     // MIs[0] scale_src1_opsel
     /* 270985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 270997 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 271000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271004 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271006 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271008 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271010 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271012 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271014 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271028 */     GIR_RootConstrainSelectedInstOperands,
     /* 271029 */     // GIR_Coverage, 1212,
     /* 271029 */     GIR_EraseRootFromParent_Done,
     /* 271030 */   // Label 4377: @271030
     /* 271030 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(271124), // Rule ID 1213 //
     /* 271035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271055 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271058 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271065 */     // MIs[0] cbsz
     /* 271065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271068 */     // MIs[0] blgp
     /* 271068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271071 */     // MIs[0] scale_src0_opsel
     /* 271071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271079 */     // MIs[0] scale_src1_opsel
     /* 271079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 271091 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 271094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271098 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271100 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271102 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271104 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271106 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271108 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271122 */     GIR_RootConstrainSelectedInstOperands,
     /* 271123 */     // GIR_Coverage, 1213,
     /* 271123 */     GIR_EraseRootFromParent_Done,
     /* 271124 */   // Label 4378: @271124
     /* 271124 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(271218), // Rule ID 1214 //
     /* 271129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271149 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271152 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271159 */     // MIs[0] cbsz
     /* 271159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271162 */     // MIs[0] blgp
     /* 271162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271165 */     // MIs[0] scale_src0_opsel
     /* 271165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271173 */     // MIs[0] scale_src1_opsel
     /* 271173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 271185 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 271188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271192 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271194 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271196 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271198 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271200 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271202 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271216 */     GIR_RootConstrainSelectedInstOperands,
     /* 271217 */     // GIR_Coverage, 1214,
     /* 271217 */     GIR_EraseRootFromParent_Done,
     /* 271218 */   // Label 4379: @271218
     /* 271218 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(271312), // Rule ID 1215 //
     /* 271223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 271237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271243 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271246 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271253 */     // MIs[0] cbsz
     /* 271253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271256 */     // MIs[0] blgp
     /* 271256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271259 */     // MIs[0] scale_src0_opsel
     /* 271259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271267 */     // MIs[0] scale_src1_opsel
     /* 271267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 271279 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 271282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271286 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271288 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271290 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271292 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271294 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271296 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271310 */     GIR_RootConstrainSelectedInstOperands,
     /* 271311 */     // GIR_Coverage, 1215,
     /* 271311 */     GIR_EraseRootFromParent_Done,
     /* 271312 */   // Label 4380: @271312
     /* 271312 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(271406), // Rule ID 1216 //
     /* 271317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 271331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271337 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271340 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271347 */     // MIs[0] cbsz
     /* 271347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271350 */     // MIs[0] blgp
     /* 271350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271353 */     // MIs[0] scale_src0_opsel
     /* 271353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271361 */     // MIs[0] scale_src1_opsel
     /* 271361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 271373 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 271376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271380 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271382 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271384 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271386 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271388 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271390 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271404 */     GIR_RootConstrainSelectedInstOperands,
     /* 271405 */     // GIR_Coverage, 1216,
     /* 271405 */     GIR_EraseRootFromParent_Done,
     /* 271406 */   // Label 4381: @271406
     /* 271406 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(271500), // Rule ID 1217 //
     /* 271411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271431 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271434 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271441 */     // MIs[0] cbsz
     /* 271441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271444 */     // MIs[0] blgp
     /* 271444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271447 */     // MIs[0] scale_src0_opsel
     /* 271447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271455 */     // MIs[0] scale_src1_opsel
     /* 271455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 271467 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 271470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271474 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271476 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271478 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271480 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271482 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271484 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271498 */     GIR_RootConstrainSelectedInstOperands,
     /* 271499 */     // GIR_Coverage, 1217,
     /* 271499 */     GIR_EraseRootFromParent_Done,
     /* 271500 */   // Label 4382: @271500
     /* 271500 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(271594), // Rule ID 1218 //
     /* 271505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271525 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271528 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271535 */     // MIs[0] cbsz
     /* 271535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271538 */     // MIs[0] blgp
     /* 271538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271541 */     // MIs[0] scale_src0_opsel
     /* 271541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271549 */     // MIs[0] scale_src1_opsel
     /* 271549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 271561 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 271564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271568 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271570 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271572 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271574 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271576 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271578 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271592 */     GIR_RootConstrainSelectedInstOperands,
     /* 271593 */     // GIR_Coverage, 1218,
     /* 271593 */     GIR_EraseRootFromParent_Done,
     /* 271594 */   // Label 4383: @271594
     /* 271594 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(271688), // Rule ID 1219 //
     /* 271599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271619 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271622 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271629 */     // MIs[0] cbsz
     /* 271629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271632 */     // MIs[0] blgp
     /* 271632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271635 */     // MIs[0] scale_src0_opsel
     /* 271635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271643 */     // MIs[0] scale_src1_opsel
     /* 271643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 271655 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 271658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271662 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271664 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271666 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271668 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271670 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271672 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271686 */     GIR_RootConstrainSelectedInstOperands,
     /* 271687 */     // GIR_Coverage, 1219,
     /* 271687 */     GIR_EraseRootFromParent_Done,
     /* 271688 */   // Label 4384: @271688
     /* 271688 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(271782), // Rule ID 1220 //
     /* 271693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271713 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271716 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271723 */     // MIs[0] cbsz
     /* 271723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271726 */     // MIs[0] blgp
     /* 271726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271729 */     // MIs[0] scale_src0_opsel
     /* 271729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271737 */     // MIs[0] scale_src1_opsel
     /* 271737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 271749 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 271752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271758 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271760 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271762 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271764 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271766 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271780 */     GIR_RootConstrainSelectedInstOperands,
     /* 271781 */     // GIR_Coverage, 1220,
     /* 271781 */     GIR_EraseRootFromParent_Done,
     /* 271782 */   // Label 4385: @271782
     /* 271782 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(271876), // Rule ID 1221 //
     /* 271787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271807 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271810 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271817 */     // MIs[0] cbsz
     /* 271817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271820 */     // MIs[0] blgp
     /* 271820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271823 */     // MIs[0] scale_src0_opsel
     /* 271823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271831 */     // MIs[0] scale_src1_opsel
     /* 271831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 271843 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 271846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271852 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271854 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271856 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271858 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271860 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271874 */     GIR_RootConstrainSelectedInstOperands,
     /* 271875 */     // GIR_Coverage, 1221,
     /* 271875 */     GIR_EraseRootFromParent_Done,
     /* 271876 */   // Label 4386: @271876
     /* 271876 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(271970), // Rule ID 1222 //
     /* 271881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271901 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271904 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271911 */     // MIs[0] cbsz
     /* 271911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271914 */     // MIs[0] blgp
     /* 271914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271917 */     // MIs[0] scale_src0_opsel
     /* 271917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271925 */     // MIs[0] scale_src1_opsel
     /* 271925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 271937 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 271940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271946 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271948 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271950 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271952 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271954 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271956 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271962 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271968 */     GIR_RootConstrainSelectedInstOperands,
     /* 271969 */     // GIR_Coverage, 1222,
     /* 271969 */     GIR_EraseRootFromParent_Done,
     /* 271970 */   // Label 4387: @271970
     /* 271970 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(272064), // Rule ID 1223 //
     /* 271975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271995 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271998 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272005 */     // MIs[0] cbsz
     /* 272005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272008 */     // MIs[0] blgp
     /* 272008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272011 */     // MIs[0] scale_src0_opsel
     /* 272011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272019 */     // MIs[0] scale_src1_opsel
     /* 272019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23393),
     /* 272031 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23393>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 272034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272038 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272040 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272042 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272044 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272046 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272048 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272062 */     GIR_RootConstrainSelectedInstOperands,
     /* 272063 */     // GIR_Coverage, 1223,
     /* 272063 */     GIR_EraseRootFromParent_Done,
     /* 272064 */   // Label 4388: @272064
     /* 272064 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(272158), // Rule ID 1224 //
     /* 272069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272089 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272092 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272099 */     // MIs[0] cbsz
     /* 272099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272102 */     // MIs[0] blgp
     /* 272102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272105 */     // MIs[0] scale_src0_opsel
     /* 272105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272113 */     // MIs[0] scale_src1_opsel
     /* 272113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23395),
     /* 272125 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23395>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 272128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272132 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272134 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272136 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272138 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272140 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272142 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272156 */     GIR_RootConstrainSelectedInstOperands,
     /* 272157 */     // GIR_Coverage, 1224,
     /* 272157 */     GIR_EraseRootFromParent_Done,
     /* 272158 */   // Label 4389: @272158
     /* 272158 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(272252), // Rule ID 1225 //
     /* 272163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272183 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272186 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272193 */     // MIs[0] cbsz
     /* 272193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272196 */     // MIs[0] blgp
     /* 272196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272199 */     // MIs[0] scale_src0_opsel
     /* 272199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272207 */     // MIs[0] scale_src1_opsel
     /* 272207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 272219 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 272222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272226 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272228 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272230 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272232 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272234 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272236 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272250 */     GIR_RootConstrainSelectedInstOperands,
     /* 272251 */     // GIR_Coverage, 1225,
     /* 272251 */     GIR_EraseRootFromParent_Done,
     /* 272252 */   // Label 4390: @272252
     /* 272252 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(272346), // Rule ID 1226 //
     /* 272257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272277 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272280 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272287 */     // MIs[0] cbsz
     /* 272287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272290 */     // MIs[0] blgp
     /* 272290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272293 */     // MIs[0] scale_src0_opsel
     /* 272293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272301 */     // MIs[0] scale_src1_opsel
     /* 272301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 272313 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 272316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272320 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272322 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272324 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272326 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272328 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272330 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272344 */     GIR_RootConstrainSelectedInstOperands,
     /* 272345 */     // GIR_Coverage, 1226,
     /* 272345 */     GIR_EraseRootFromParent_Done,
     /* 272346 */   // Label 4391: @272346
     /* 272346 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(272440), // Rule ID 1227 //
     /* 272351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272371 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272374 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272381 */     // MIs[0] cbsz
     /* 272381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272384 */     // MIs[0] blgp
     /* 272384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272387 */     // MIs[0] scale_src0_opsel
     /* 272387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272395 */     // MIs[0] scale_src1_opsel
     /* 272395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 272407 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 272410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272414 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272416 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272418 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272420 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272422 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272424 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272438 */     GIR_RootConstrainSelectedInstOperands,
     /* 272439 */     // GIR_Coverage, 1227,
     /* 272439 */     GIR_EraseRootFromParent_Done,
     /* 272440 */   // Label 4392: @272440
     /* 272440 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(272534), // Rule ID 1228 //
     /* 272445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272465 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272468 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272475 */     // MIs[0] cbsz
     /* 272475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272478 */     // MIs[0] blgp
     /* 272478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272481 */     // MIs[0] scale_src0_opsel
     /* 272481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272489 */     // MIs[0] scale_src1_opsel
     /* 272489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 272501 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 272504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272512 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272514 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272516 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272518 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272532 */     GIR_RootConstrainSelectedInstOperands,
     /* 272533 */     // GIR_Coverage, 1228,
     /* 272533 */     GIR_EraseRootFromParent_Done,
     /* 272534 */   // Label 4393: @272534
     /* 272534 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(272628), // Rule ID 1229 //
     /* 272539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272559 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272562 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272569 */     // MIs[0] cbsz
     /* 272569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272572 */     // MIs[0] blgp
     /* 272572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272575 */     // MIs[0] scale_src0_opsel
     /* 272575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272583 */     // MIs[0] scale_src1_opsel
     /* 272583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 272595 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 272598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272600 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272604 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272606 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272608 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272610 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272612 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272614 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272626 */     GIR_RootConstrainSelectedInstOperands,
     /* 272627 */     // GIR_Coverage, 1229,
     /* 272627 */     GIR_EraseRootFromParent_Done,
     /* 272628 */   // Label 4394: @272628
     /* 272628 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(272722), // Rule ID 1230 //
     /* 272633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272653 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272656 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272663 */     // MIs[0] cbsz
     /* 272663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272666 */     // MIs[0] blgp
     /* 272666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272669 */     // MIs[0] scale_src0_opsel
     /* 272669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272677 */     // MIs[0] scale_src1_opsel
     /* 272677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 272689 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 272692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272698 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272700 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272702 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272704 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272706 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272720 */     GIR_RootConstrainSelectedInstOperands,
     /* 272721 */     // GIR_Coverage, 1230,
     /* 272721 */     GIR_EraseRootFromParent_Done,
     /* 272722 */   // Label 4395: @272722
     /* 272722 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(272816), // Rule ID 1231 //
     /* 272727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272747 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272750 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272757 */     // MIs[0] cbsz
     /* 272757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272760 */     // MIs[0] blgp
     /* 272760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272763 */     // MIs[0] scale_src0_opsel
     /* 272763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272771 */     // MIs[0] scale_src1_opsel
     /* 272771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 272783 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 272786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272790 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272792 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272794 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272796 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272798 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272800 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272814 */     GIR_RootConstrainSelectedInstOperands,
     /* 272815 */     // GIR_Coverage, 1231,
     /* 272815 */     GIR_EraseRootFromParent_Done,
     /* 272816 */   // Label 4396: @272816
     /* 272816 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(272910), // Rule ID 1232 //
     /* 272821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272841 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272844 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272851 */     // MIs[0] cbsz
     /* 272851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272854 */     // MIs[0] blgp
     /* 272854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272857 */     // MIs[0] scale_src0_opsel
     /* 272857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272865 */     // MIs[0] scale_src1_opsel
     /* 272865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 272877 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 272880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272884 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272886 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272888 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272890 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272892 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272894 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272908 */     GIR_RootConstrainSelectedInstOperands,
     /* 272909 */     // GIR_Coverage, 1232,
     /* 272909 */     GIR_EraseRootFromParent_Done,
     /* 272910 */   // Label 4397: @272910
     /* 272910 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(273004), // Rule ID 1233 //
     /* 272915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272935 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272938 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272945 */     // MIs[0] cbsz
     /* 272945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272948 */     // MIs[0] blgp
     /* 272948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272951 */     // MIs[0] scale_src0_opsel
     /* 272951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272959 */     // MIs[0] scale_src1_opsel
     /* 272959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 272971 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 272974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272978 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272980 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272982 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272984 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272986 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272988 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273002 */     GIR_RootConstrainSelectedInstOperands,
     /* 273003 */     // GIR_Coverage, 1233,
     /* 273003 */     GIR_EraseRootFromParent_Done,
     /* 273004 */   // Label 4398: @273004
     /* 273004 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(273098), // Rule ID 1234 //
     /* 273009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273029 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273032 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273039 */     // MIs[0] cbsz
     /* 273039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273042 */     // MIs[0] blgp
     /* 273042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273045 */     // MIs[0] scale_src0_opsel
     /* 273045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273053 */     // MIs[0] scale_src1_opsel
     /* 273053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 273065 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 273068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273074 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273076 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273078 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273080 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273082 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273096 */     GIR_RootConstrainSelectedInstOperands,
     /* 273097 */     // GIR_Coverage, 1234,
     /* 273097 */     GIR_EraseRootFromParent_Done,
     /* 273098 */   // Label 4399: @273098
     /* 273098 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(273192), // Rule ID 1235 //
     /* 273103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273123 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273126 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273133 */     // MIs[0] cbsz
     /* 273133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273136 */     // MIs[0] blgp
     /* 273136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273139 */     // MIs[0] scale_src0_opsel
     /* 273139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273147 */     // MIs[0] scale_src1_opsel
     /* 273147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 273159 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 273162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273166 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273168 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273170 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273172 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273174 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273176 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273190 */     GIR_RootConstrainSelectedInstOperands,
     /* 273191 */     // GIR_Coverage, 1235,
     /* 273191 */     GIR_EraseRootFromParent_Done,
     /* 273192 */   // Label 4400: @273192
     /* 273192 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(273286), // Rule ID 1236 //
     /* 273197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273217 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273220 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273227 */     // MIs[0] cbsz
     /* 273227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273230 */     // MIs[0] blgp
     /* 273230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273233 */     // MIs[0] scale_src0_opsel
     /* 273233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273241 */     // MIs[0] scale_src1_opsel
     /* 273241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 273253 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 273256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273260 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273262 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273264 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273266 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273268 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273270 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273284 */     GIR_RootConstrainSelectedInstOperands,
     /* 273285 */     // GIR_Coverage, 1236,
     /* 273285 */     GIR_EraseRootFromParent_Done,
     /* 273286 */   // Label 4401: @273286
     /* 273286 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(273380), // Rule ID 1237 //
     /* 273291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273311 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273314 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273321 */     // MIs[0] cbsz
     /* 273321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273324 */     // MIs[0] blgp
     /* 273324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273327 */     // MIs[0] scale_src0_opsel
     /* 273327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273335 */     // MIs[0] scale_src1_opsel
     /* 273335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 273347 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 273350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273356 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273358 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273360 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273362 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273364 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273378 */     GIR_RootConstrainSelectedInstOperands,
     /* 273379 */     // GIR_Coverage, 1237,
     /* 273379 */     GIR_EraseRootFromParent_Done,
     /* 273380 */   // Label 4402: @273380
     /* 273380 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(273474), // Rule ID 1238 //
     /* 273385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273405 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273408 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273415 */     // MIs[0] cbsz
     /* 273415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273418 */     // MIs[0] blgp
     /* 273418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273421 */     // MIs[0] scale_src0_opsel
     /* 273421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273429 */     // MIs[0] scale_src1_opsel
     /* 273429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 273441 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 273444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273450 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273452 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273454 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273456 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273458 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273472 */     GIR_RootConstrainSelectedInstOperands,
     /* 273473 */     // GIR_Coverage, 1238,
     /* 273473 */     GIR_EraseRootFromParent_Done,
     /* 273474 */   // Label 4403: @273474
     /* 273474 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(273568), // Rule ID 1239 //
     /* 273479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273499 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273502 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273509 */     // MIs[0] cbsz
     /* 273509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273512 */     // MIs[0] blgp
     /* 273512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273515 */     // MIs[0] scale_src0_opsel
     /* 273515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273523 */     // MIs[0] scale_src1_opsel
     /* 273523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 273535 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 273538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273544 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273546 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273548 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273550 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273552 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273566 */     GIR_RootConstrainSelectedInstOperands,
     /* 273567 */     // GIR_Coverage, 1239,
     /* 273567 */     GIR_EraseRootFromParent_Done,
     /* 273568 */   // Label 4404: @273568
     /* 273568 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(273662), // Rule ID 1240 //
     /* 273573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273593 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273596 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273603 */     // MIs[0] cbsz
     /* 273603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273606 */     // MIs[0] blgp
     /* 273606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273609 */     // MIs[0] scale_src0_opsel
     /* 273609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273617 */     // MIs[0] scale_src1_opsel
     /* 273617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 273629 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 273632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273636 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273638 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273640 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273642 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273644 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273646 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273660 */     GIR_RootConstrainSelectedInstOperands,
     /* 273661 */     // GIR_Coverage, 1240,
     /* 273661 */     GIR_EraseRootFromParent_Done,
     /* 273662 */   // Label 4405: @273662
     /* 273662 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(273756), // Rule ID 1241 //
     /* 273667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273687 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273690 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273697 */     // MIs[0] cbsz
     /* 273697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273700 */     // MIs[0] blgp
     /* 273700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273703 */     // MIs[0] scale_src0_opsel
     /* 273703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273711 */     // MIs[0] scale_src1_opsel
     /* 273711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23415),
     /* 273723 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23415>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 273726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273730 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273732 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273734 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273736 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273738 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273740 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273754 */     GIR_RootConstrainSelectedInstOperands,
     /* 273755 */     // GIR_Coverage, 1241,
     /* 273755 */     GIR_EraseRootFromParent_Done,
     /* 273756 */   // Label 4406: @273756
     /* 273756 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(273850), // Rule ID 1242 //
     /* 273761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273781 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273784 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273791 */     // MIs[0] cbsz
     /* 273791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273794 */     // MIs[0] blgp
     /* 273794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273797 */     // MIs[0] scale_src0_opsel
     /* 273797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273805 */     // MIs[0] scale_src1_opsel
     /* 273805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23417),
     /* 273817 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23417>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 273820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273824 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273826 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273828 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273830 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273832 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273834 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273848 */     GIR_RootConstrainSelectedInstOperands,
     /* 273849 */     // GIR_Coverage, 1242,
     /* 273849 */     GIR_EraseRootFromParent_Done,
     /* 273850 */   // Label 4407: @273850
     /* 273850 */   GIM_Reject,
     /* 273851 */ // Label 4335: @273851
     /* 273851 */ GIM_Reject,
     /* 273852 */ // Label 39: @273852
     /* 273852 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(273928),
     /* 273857 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 273860 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(273875), // Rule ID 181 //
     /* 273865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier),
     /* 273870 */     // (intrinsic_void 3147:{ *:[iPTR] })  =>  (S_BARRIER)
     /* 273870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER),
     /* 273873 */     GIR_RootConstrainSelectedInstOperands,
     /* 273874 */     // GIR_Coverage, 181,
     /* 273874 */     GIR_EraseRootFromParent_Done,
     /* 273875 */   // Label 4409: @273875
     /* 273875 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(273890), // Rule ID 1344 //
     /* 273880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wave_barrier),
     /* 273885 */     // (intrinsic_void 3306:{ *:[iPTR] })  =>  (WAVE_BARRIER)
     /* 273885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_BARRIER),
     /* 273888 */     GIR_RootConstrainSelectedInstOperands,
     /* 273889 */     // GIR_Coverage, 1344,
     /* 273889 */     GIR_EraseRootFromParent_Done,
     /* 273890 */   // Label 4410: @273890
     /* 273890 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(273909), // Rule ID 1352 //
     /* 273895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_unreachable),
     /* 273900 */     // (intrinsic_void 3304:{ *:[iPTR] })  =>  (SI_MASKED_UNREACHABLE)
     /* 273900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_MASKED_UNREACHABLE),
     /* 273903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273907 */     GIR_RootConstrainSelectedInstOperands,
     /* 273908 */     // GIR_Coverage, 1352,
     /* 273908 */     GIR_EraseRootFromParent_Done,
     /* 273909 */   // Label 4411: @273909
     /* 273909 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(273927), // Rule ID 1867 //
     /* 273914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_endpgm),
     /* 273919 */     // (intrinsic_void 2194:{ *:[iPTR] })  =>  (S_ENDPGM 0:{ *:[i16] })
     /* 273919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ENDPGM),
     /* 273922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273925 */     GIR_RootConstrainSelectedInstOperands,
     /* 273926 */     // GIR_Coverage, 1867,
     /* 273926 */     GIR_EraseRootFromParent_Done,
     /* 273927 */   // Label 4412: @273927
     /* 273927 */   GIM_Reject,
     /* 273928 */ // Label 4408: @273928
     /* 273928 */ GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(274067),
     /* 273933 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 273936 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(273956), // Rule ID 41 //
     /* 273941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_signal),
     /* 273946 */     // MIs[0] src0
     /* 273946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273949 */     // (intrinsic_void 3148:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_BARRIER_SIGNAL_IMM (timm:{ *:[i32] }):$src0)
     /* 273949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_SIGNAL_IMM),
     /* 273952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 273954 */     GIR_RootConstrainSelectedInstOperands,
     /* 273955 */     // GIR_Coverage, 41,
     /* 273955 */     GIR_EraseRootFromParent_Done,
     /* 273956 */   // Label 4414: @273956
     /* 273956 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(273976), // Rule ID 182 //
     /* 273961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_wait),
     /* 273966 */     // MIs[0] simm16
     /* 273966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273969 */     // (intrinsic_void 3151:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_BARRIER_WAIT (timm:{ *:[i16] }):$simm16)
     /* 273969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_WAIT),
     /* 273972 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 273974 */     GIR_RootConstrainSelectedInstOperands,
     /* 273975 */     // GIR_Coverage, 182,
     /* 273975 */     GIR_EraseRootFromParent_Done,
     /* 273976 */   // Label 4415: @273976
     /* 273976 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(273996), // Rule ID 1345 //
     /* 273981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_barrier),
     /* 273986 */     // MIs[0] mask
     /* 273986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273989 */     // (intrinsic_void 3195:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (SCHED_BARRIER (timm:{ *:[i32] }):$mask)
     /* 273989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_BARRIER),
     /* 273992 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 273994 */     GIR_RootConstrainSelectedInstOperands,
     /* 273995 */     // GIR_Coverage, 1345,
     /* 273995 */     GIR_EraseRootFromParent_Done,
     /* 273996 */   // Label 4416: @273996
     /* 273996 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(274016), // Rule ID 1347 //
     /* 274001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_iglp_opt),
     /* 274006 */     // MIs[0] mask
     /* 274006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274009 */     // (intrinsic_void 2226:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (IGLP_OPT (timm:{ *:[i32] }):$mask)
     /* 274009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::IGLP_OPT),
     /* 274012 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 274014 */     GIR_RootConstrainSelectedInstOperands,
     /* 274015 */     // GIR_Coverage, 1347,
     /* 274015 */     GIR_EraseRootFromParent_Done,
     /* 274016 */   // Label 4417: @274016
     /* 274016 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(274039), // Rule ID 1353 //
     /* 274021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec),
     /* 274026 */     // MIs[0] src
     /* 274026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274029 */     // (intrinsic_void 2990:{ *:[iPTR] }, (timm:{ *:[i64] }):$src)  =>  (SI_INIT_EXEC (timm:{ *:[i64] }):$src)
     /* 274029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC),
     /* 274032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 274034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 274037 */     GIR_RootConstrainSelectedInstOperands,
     /* 274038 */     // GIR_Coverage, 1353,
     /* 274038 */     GIR_EraseRootFromParent_Done,
     /* 274039 */   // Label 4418: @274039
     /* 274039 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(274066), // Rule ID 1355 //
     /* 274044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_init_whole_wave),
     /* 274049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 274052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 274056 */     // (intrinsic_w_chain:{ *:[i1] } 2992:{ *:[iPTR] })  =>  (SI_INIT_WHOLE_WAVE:{ *:[i1] })
     /* 274056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_WHOLE_WAVE),
     /* 274059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 274064 */     GIR_RootConstrainSelectedInstOperands,
     /* 274065 */     // GIR_Coverage, 1355,
     /* 274065 */     GIR_EraseRootFromParent_Done,
     /* 274066 */   // Label 4419: @274066
     /* 274066 */   GIM_Reject,
     /* 274067 */ // Label 4413: @274067
     /* 274067 */ GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(275069),
     /* 274072 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 274075 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(274130), // Rule ID 8336 //
     /* 274080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr4_b64),
     /* 274088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274106 */     // (intrinsic_w_chain:{ *:[v2i32] } 2187:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B4:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B4),
     /* 274109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274128 */     GIR_RootConstrainSelectedInstOperands,
     /* 274129 */     // GIR_Coverage, 8336,
     /* 274129 */     GIR_EraseRootFromParent_Done,
     /* 274130 */   // Label 4421: @274130
     /* 274130 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(274185), // Rule ID 8337 //
     /* 274135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr8_b64),
     /* 274143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274161 */     // (intrinsic_w_chain:{ *:[v2i32] } 2189:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B8:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B8),
     /* 274164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274183 */     GIR_RootConstrainSelectedInstOperands,
     /* 274184 */     // GIR_Coverage, 8337,
     /* 274184 */     GIR_EraseRootFromParent_Done,
     /* 274185 */   // Label 4422: @274185
     /* 274185 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(274240), // Rule ID 8338 //
     /* 274190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr6_b96),
     /* 274198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v3s32,
     /* 274201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 274205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274216 */     // (intrinsic_w_chain:{ *:[v3i32] } 2188:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B96_TR_B6:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_TR_B6),
     /* 274219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274238 */     GIR_RootConstrainSelectedInstOperands,
     /* 274239 */     // GIR_Coverage, 8338,
     /* 274239 */     GIR_EraseRootFromParent_Done,
     /* 274240 */   // Label 4423: @274240
     /* 274240 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(274295), // Rule ID 8339 //
     /* 274245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 274253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274271 */     // (intrinsic_w_chain:{ *:[v4i16] } 2186:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 274274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274293 */     GIR_RootConstrainSelectedInstOperands,
     /* 274294 */     // GIR_Coverage, 8339,
     /* 274294 */     GIR_EraseRootFromParent_Done,
     /* 274295 */   // Label 4424: @274295
     /* 274295 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(274350), // Rule ID 8340 //
     /* 274300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 274308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274326 */     // (intrinsic_w_chain:{ *:[v4f16] } 2186:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 274329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274348 */     GIR_RootConstrainSelectedInstOperands,
     /* 274349 */     // GIR_Coverage, 8340,
     /* 274349 */     GIR_EraseRootFromParent_Done,
     /* 274350 */   // Label 4425: @274350
     /* 274350 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(274410), // Rule ID 4120 //
     /* 274355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274381 */     // (intrinsic_w_chain:{ *:[v2i32] } 2221:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32_SADDR),
     /* 274384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274408 */     GIR_RootConstrainSelectedInstOperands,
     /* 274409 */     // GIR_Coverage, 4120,
     /* 274409 */     GIR_EraseRootFromParent_Done,
     /* 274410 */   // Label 4426: @274410
     /* 274410 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(274470), // Rule ID 4122 //
     /* 274415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274441 */     // (intrinsic_w_chain:{ *:[v8i16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 274444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274468 */     GIR_RootConstrainSelectedInstOperands,
     /* 274469 */     // GIR_Coverage, 4122,
     /* 274469 */     GIR_EraseRootFromParent_Done,
     /* 274470 */   // Label 4427: @274470
     /* 274470 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(274530), // Rule ID 4124 //
     /* 274475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274501 */     // (intrinsic_w_chain:{ *:[v8f16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 274504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274528 */     GIR_RootConstrainSelectedInstOperands,
     /* 274529 */     // GIR_Coverage, 4124,
     /* 274529 */     GIR_EraseRootFromParent_Done,
     /* 274530 */   // Label 4428: @274530
     /* 274530 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(274590), // Rule ID 4126 //
     /* 274535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 274550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274561 */     // (intrinsic_w_chain:{ *:[i32] } 2221:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64_SADDR),
     /* 274564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274588 */     GIR_RootConstrainSelectedInstOperands,
     /* 274589 */     // GIR_Coverage, 4126,
     /* 274589 */     GIR_EraseRootFromParent_Done,
     /* 274590 */   // Label 4429: @274590
     /* 274590 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(274650), // Rule ID 4128 //
     /* 274595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274621 */     // (intrinsic_w_chain:{ *:[v4i16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 274624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274648 */     GIR_RootConstrainSelectedInstOperands,
     /* 274649 */     // GIR_Coverage, 4128,
     /* 274649 */     GIR_EraseRootFromParent_Done,
     /* 274650 */   // Label 4430: @274650
     /* 274650 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(274710), // Rule ID 4130 //
     /* 274655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274681 */     // (intrinsic_w_chain:{ *:[v4f16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 274684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274708 */     GIR_RootConstrainSelectedInstOperands,
     /* 274709 */     // GIR_Coverage, 4130,
     /* 274709 */     GIR_EraseRootFromParent_Done,
     /* 274710 */   // Label 4431: @274710
     /* 274710 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(274765), // Rule ID 4119 //
     /* 274715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274741 */     // (intrinsic_w_chain:{ *:[v2i32] } 2221:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32),
     /* 274744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274763 */     GIR_RootConstrainSelectedInstOperands,
     /* 274764 */     // GIR_Coverage, 4119,
     /* 274764 */     GIR_EraseRootFromParent_Done,
     /* 274765 */   // Label 4432: @274765
     /* 274765 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(274820), // Rule ID 4121 //
     /* 274770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274796 */     // (intrinsic_w_chain:{ *:[v8i16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 274799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274818 */     GIR_RootConstrainSelectedInstOperands,
     /* 274819 */     // GIR_Coverage, 4121,
     /* 274819 */     GIR_EraseRootFromParent_Done,
     /* 274820 */   // Label 4433: @274820
     /* 274820 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(274875), // Rule ID 4123 //
     /* 274825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274851 */     // (intrinsic_w_chain:{ *:[v8f16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 274854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274873 */     GIR_RootConstrainSelectedInstOperands,
     /* 274874 */     // GIR_Coverage, 4123,
     /* 274874 */     GIR_EraseRootFromParent_Done,
     /* 274875 */   // Label 4434: @274875
     /* 274875 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(274930), // Rule ID 4125 //
     /* 274880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 274895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274906 */     // (intrinsic_w_chain:{ *:[i32] } 2221:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64),
     /* 274909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274928 */     GIR_RootConstrainSelectedInstOperands,
     /* 274929 */     // GIR_Coverage, 4125,
     /* 274929 */     GIR_EraseRootFromParent_Done,
     /* 274930 */   // Label 4435: @274930
     /* 274930 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(274985), // Rule ID 4127 //
     /* 274935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274961 */     // (intrinsic_w_chain:{ *:[v4i16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 274964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274983 */     GIR_RootConstrainSelectedInstOperands,
     /* 274984 */     // GIR_Coverage, 4127,
     /* 274984 */     GIR_EraseRootFromParent_Done,
     /* 274985 */   // Label 4436: @274985
     /* 274985 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(275040), // Rule ID 4129 //
     /* 274990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 275001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 275005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 275009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 275016 */     // (intrinsic_w_chain:{ *:[v4f16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 275016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 275019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 275026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 275031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275038 */     GIR_RootConstrainSelectedInstOperands,
     /* 275039 */     // GIR_Coverage, 4129,
     /* 275039 */     GIR_EraseRootFromParent_Done,
     /* 275040 */   // Label 4437: @275040
     /* 275040 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(275068), // Rule ID 1354 //
     /* 275045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec_from_input),
     /* 275050 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275053 */     // MIs[0] shift
     /* 275053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 275056 */     // (intrinsic_void 2991:{ *:[iPTR] }, i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)  =>  (SI_INIT_EXEC_FROM_INPUT i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)
     /* 275056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC_FROM_INPUT),
     /* 275059 */     GIR_RootToRootCopy, /*OpIdx*/1, // input
     /* 275061 */     GIR_RootToRootCopy, /*OpIdx*/2, // shift
     /* 275063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 275066 */     GIR_RootConstrainSelectedInstOperands,
     /* 275067 */     // GIR_Coverage, 1354,
     /* 275067 */     GIR_EraseRootFromParent_Done,
     /* 275068 */   // Label 4438: @275068
     /* 275068 */   GIM_Reject,
     /* 275069 */ // Label 4420: @275069
     /* 275069 */ GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(275102), // Rule ID 1346 //
     /* 275074 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 275077 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_group_barrier),
     /* 275082 */   // MIs[0] mask
     /* 275082 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275085 */   // MIs[0] size
     /* 275085 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 275088 */   // MIs[0] syncid
     /* 275088 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 275091 */   // (intrinsic_void 3196:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)  =>  (SCHED_GROUP_BARRIER (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)
     /* 275091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_GROUP_BARRIER),
     /* 275094 */   GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 275096 */   GIR_RootToRootCopy, /*OpIdx*/2, // size
     /* 275098 */   GIR_RootToRootCopy, /*OpIdx*/3, // syncid
     /* 275100 */   GIR_RootConstrainSelectedInstOperands,
     /* 275101 */   // GIR_Coverage, 1346,
     /* 275101 */   GIR_EraseRootFromParent_Done,
     /* 275102 */ // Label 4439: @275102
     /* 275102 */ GIM_Reject,
     /* 275103 */ // Label 40: @275103
     /* 275103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4443*/ GIMT_Encode4(275665),
     /* 275114 */ /*GILLT_s16*//*Label 4440*/ GIMT_Encode4(275126),
     /* 275118 */ /*GILLT_s32*//*Label 4441*/ GIMT_Encode4(275163),
     /* 275122 */ /*GILLT_s64*//*Label 4442*/ GIMT_Encode4(275262),
     /* 275126 */ // Label 4440: @275126
     /* 275126 */ GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(275162), // Rule ID 2558 //
     /* 275131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 275134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 275137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275141 */   // (anyext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 275141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 275144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275160 */   GIR_RootConstrainSelectedInstOperands,
     /* 275161 */   // GIR_Coverage, 2558,
     /* 275161 */   GIR_EraseRootFromParent_Done,
     /* 275162 */ // Label 4444: @275162
     /* 275162 */ GIM_Reject,
     /* 275163 */ // Label 4441: @275163
     /* 275163 */ GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(275228), // Rule ID 2442 //
     /* 275168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 275171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275178 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19250),
     /* 275182 */   // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_19250>>  =>  (REG_SEQUENCE:{ *:[i32] } VGPR_32:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] })
     /* 275182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275203 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 275206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275209 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 275212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275227 */   // GIR_Coverage, 2442,
     /* 275227 */   GIR_EraseRootFromParent_Done,
     /* 275228 */ // Label 4445: @275228
     /* 275228 */ GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(275261), // Rule ID 7320 //
     /* 275233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 275236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275240 */   // (anyext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 275240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 275243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 275254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 275259 */   GIR_RootConstrainSelectedInstOperands,
     /* 275260 */   // GIR_Coverage, 7320,
     /* 275260 */   GIR_EraseRootFromParent_Done,
     /* 275261 */ // Label 4446: @275261
     /* 275261 */ GIM_Reject,
     /* 275262 */ // Label 4442: @275262
     /* 275262 */ GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(275345), // Rule ID 2433 //
     /* 275267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 275270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275277 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275277 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 275280 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275284 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275289 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 275292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275306 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275320 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275326 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275344 */   // GIR_Coverage, 2433,
     /* 275344 */   GIR_EraseRootFromParent_Done,
     /* 275345 */ // Label 4447: @275345
     /* 275345 */ GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(275428), // Rule ID 2437 //
     /* 275350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 275353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275360 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275360 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 275363 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275367 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275372 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 275375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275389 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275403 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275409 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275427 */   // GIR_Coverage, 2437,
     /* 275427 */   GIR_EraseRootFromParent_Done,
     /* 275428 */ // Label 4448: @275428
     /* 275428 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(275514), // Rule ID 2443 //
     /* 275433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 275436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275443 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275443 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 275446 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275450 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275478 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 275481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275484 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 275487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275490 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275503 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/5, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275513 */   // GIR_Coverage, 2443,
     /* 275513 */   GIR_EraseRootFromParent_Done,
     /* 275514 */ // Label 4449: @275514
     /* 275514 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(275572), // Rule ID 7400 //
     /* 275519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275526 */   // (anyext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275547 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275553 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 275566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 275571 */   // GIR_Coverage, 7400,
     /* 275571 */   GIR_EraseRootFromParent_Done,
     /* 275572 */ // Label 4450: @275572
     /* 275572 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(275664), // Rule ID 7402 //
     /* 275577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 275580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275584 */   // (anyext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275584 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 275587 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275591 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275596 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 275599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 275608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275613 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275616 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275619 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275622 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275639 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275645 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275663 */   // GIR_Coverage, 7402,
     /* 275663 */   GIR_EraseRootFromParent_Done,
     /* 275664 */ // Label 4451: @275664
     /* 275664 */ GIM_Reject,
     /* 275665 */ // Label 4443: @275665
     /* 275665 */ GIM_Reject,
     /* 275666 */ // Label 41: @275666
     /* 275666 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(275905),
     /* 275671 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 275674 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4455*/ GIMT_Encode4(275789),
     /* 275685 */   /*GILLT_s16*//*Label 4453*/ GIMT_Encode4(275693),
     /* 275689 */   /*GILLT_s32*//*Label 4454*/ GIMT_Encode4(275741),
     /* 275693 */   // Label 4453: @275693
     /* 275693 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(275740), // Rule ID 7452 //
     /* 275698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 275702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34793),
     /* 275706 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34793>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 275706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 275713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 275730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275738 */     GIR_RootConstrainSelectedInstOperands,
     /* 275739 */     // GIR_Coverage, 7452,
     /* 275739 */     GIR_EraseRootFromParent_Done,
     /* 275740 */   // Label 4456: @275740
     /* 275740 */   GIM_Reject,
     /* 275741 */   // Label 4454: @275741
     /* 275741 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(275788), // Rule ID 7451 //
     /* 275746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 275750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34793),
     /* 275754 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34793>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 275754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 275761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 275778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275786 */     GIR_RootConstrainSelectedInstOperands,
     /* 275787 */     // GIR_Coverage, 7451,
     /* 275787 */     GIR_EraseRootFromParent_Done,
     /* 275788 */   // Label 4457: @275788
     /* 275788 */   GIM_Reject,
     /* 275789 */   // Label 4455: @275789
     /* 275789 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4460*/ GIMT_Encode4(275904),
     /* 275800 */   /*GILLT_s16*//*Label 4458*/ GIMT_Encode4(275808),
     /* 275804 */   /*GILLT_s32*//*Label 4459*/ GIMT_Encode4(275856),
     /* 275808 */   // Label 4458: @275808
     /* 275808 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(275855), // Rule ID 7449 //
     /* 275813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34789),
     /* 275817 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34789>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 275817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 275820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 275824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275836 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 275839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 275844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 275853 */     GIR_RootConstrainSelectedInstOperands,
     /* 275854 */     // GIR_Coverage, 7449,
     /* 275854 */     GIR_EraseRootFromParent_Done,
     /* 275855 */   // Label 4461: @275855
     /* 275855 */   GIM_Reject,
     /* 275856 */   // Label 4459: @275856
     /* 275856 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(275903), // Rule ID 7448 //
     /* 275861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34789),
     /* 275865 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34789>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 275865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 275868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 275872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275884 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 275887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 275892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 275901 */     GIR_RootConstrainSelectedInstOperands,
     /* 275902 */     // GIR_Coverage, 7448,
     /* 275902 */     GIR_EraseRootFromParent_Done,
     /* 275903 */   // Label 4462: @275903
     /* 275903 */   GIM_Reject,
     /* 275904 */   // Label 4460: @275904
     /* 275904 */   GIM_Reject,
     /* 275905 */ // Label 4452: @275905
     /* 275905 */ GIM_Reject,
     /* 275906 */ // Label 42: @275906
     /* 275906 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(11), /*)*//*default:*//*Label 4474*/ GIMT_Encode4(276631),
     /* 275917 */ /*GILLT_p0s64*//*Label 4463*/ GIMT_Encode4(275961),
     /* 275921 */ /*GILLT_p1s64*//*Label 4464*/ GIMT_Encode4(276004),
     /* 275925 */ /*GILLT_p2s32*//*Label 4465*/ GIMT_Encode4(276047),
     /* 275929 */ /*GILLT_p3s32*//*Label 4466*/ GIMT_Encode4(276090),
     /* 275933 */ /*GILLT_p4s64*//*Label 4467*/ GIMT_Encode4(276133),
     /* 275937 */ /*GILLT_p5s32*//*Label 4468*/ GIMT_Encode4(276176),
     /* 275941 */ /*GILLT_p6s32*//*Label 4469*/ GIMT_Encode4(276219),
     /* 275945 */ /*GILLT_s1*//*Label 4470*/ GIMT_Encode4(276262),
     /* 275949 */ /*GILLT_s16*//*Label 4471*/ GIMT_Encode4(276307),
     /* 275953 */ /*GILLT_s32*//*Label 4472*/ GIMT_Encode4(276411),
     /* 275957 */ /*GILLT_s64*//*Label 4473*/ GIMT_Encode4(276454),
     /* 275961 */ // Label 4463: @275961
     /* 275961 */ GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(275984), // Rule ID 7306 //
     /* 275966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275970 */   // MIs[0] Operand 1
     /* 275970 */   // No operand predicates
     /* 275970 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34620),
     /* 275974 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34620>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 275977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275979 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275982 */   GIR_RootConstrainSelectedInstOperands,
     /* 275983 */   // GIR_Coverage, 7306,
     /* 275983 */   GIR_EraseRootFromParent_Done,
     /* 275984 */ // Label 4475: @275984
     /* 275984 */ GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(276003), // Rule ID 7308 //
     /* 275989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275993 */   // MIs[0] Operand 1
     /* 275993 */   // No operand predicates
     /* 275993 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 275996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275998 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276001 */   GIR_RootConstrainSelectedInstOperands,
     /* 276002 */   // GIR_Coverage, 7308,
     /* 276002 */   GIR_EraseRootFromParent_Done,
     /* 276003 */ // Label 4476: @276003
     /* 276003 */ GIM_Reject,
     /* 276004 */ // Label 4464: @276004
     /* 276004 */ GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(276027), // Rule ID 7303 //
     /* 276009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276013 */   // MIs[0] Operand 1
     /* 276013 */   // No operand predicates
     /* 276013 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34616),
     /* 276017 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34616>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276022 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276025 */   GIR_RootConstrainSelectedInstOperands,
     /* 276026 */   // GIR_Coverage, 7303,
     /* 276026 */   GIR_EraseRootFromParent_Done,
     /* 276027 */ // Label 4477: @276027
     /* 276027 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(276046), // Rule ID 7305 //
     /* 276032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276036 */   // MIs[0] Operand 1
     /* 276036 */   // No operand predicates
     /* 276036 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276041 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276044 */   GIR_RootConstrainSelectedInstOperands,
     /* 276045 */   // GIR_Coverage, 7305,
     /* 276045 */   GIR_EraseRootFromParent_Done,
     /* 276046 */ // Label 4478: @276046
     /* 276046 */ GIM_Reject,
     /* 276047 */ // Label 4465: @276047
     /* 276047 */ GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(276070), // Rule ID 7280 //
     /* 276052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276056 */   // MIs[0] Operand 1
     /* 276056 */   // No operand predicates
     /* 276056 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34579),
     /* 276060 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34579>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276065 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276068 */   GIR_RootConstrainSelectedInstOperands,
     /* 276069 */   // GIR_Coverage, 7280,
     /* 276069 */   GIR_EraseRootFromParent_Done,
     /* 276070 */ // Label 4479: @276070
     /* 276070 */ GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(276089), // Rule ID 7281 //
     /* 276075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276079 */   // MIs[0] Operand 1
     /* 276079 */   // No operand predicates
     /* 276079 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276084 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276087 */   GIR_RootConstrainSelectedInstOperands,
     /* 276088 */   // GIR_Coverage, 7281,
     /* 276088 */   GIR_EraseRootFromParent_Done,
     /* 276089 */ // Label 4480: @276089
     /* 276089 */ GIM_Reject,
     /* 276090 */ // Label 4466: @276090
     /* 276090 */ GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(276113), // Rule ID 7274 //
     /* 276095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276099 */   // MIs[0] Operand 1
     /* 276099 */   // No operand predicates
     /* 276099 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34570),
     /* 276103 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34570>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276108 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276111 */   GIR_RootConstrainSelectedInstOperands,
     /* 276112 */   // GIR_Coverage, 7274,
     /* 276112 */   GIR_EraseRootFromParent_Done,
     /* 276113 */ // Label 4481: @276113
     /* 276113 */ GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(276132), // Rule ID 7275 //
     /* 276118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276122 */   // MIs[0] Operand 1
     /* 276122 */   // No operand predicates
     /* 276122 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276127 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276130 */   GIR_RootConstrainSelectedInstOperands,
     /* 276131 */   // GIR_Coverage, 7275,
     /* 276131 */   GIR_EraseRootFromParent_Done,
     /* 276132 */ // Label 4482: @276132
     /* 276132 */ GIM_Reject,
     /* 276133 */ // Label 4467: @276133
     /* 276133 */ GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(276156), // Rule ID 7309 //
     /* 276138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276142 */   // MIs[0] Operand 1
     /* 276142 */   // No operand predicates
     /* 276142 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34624),
     /* 276146 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34624>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276151 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276154 */   GIR_RootConstrainSelectedInstOperands,
     /* 276155 */   // GIR_Coverage, 7309,
     /* 276155 */   GIR_EraseRootFromParent_Done,
     /* 276156 */ // Label 4483: @276156
     /* 276156 */ GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(276175), // Rule ID 7311 //
     /* 276161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276165 */   // MIs[0] Operand 1
     /* 276165 */   // No operand predicates
     /* 276165 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276170 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276173 */   GIR_RootConstrainSelectedInstOperands,
     /* 276174 */   // GIR_Coverage, 7311,
     /* 276174 */   GIR_EraseRootFromParent_Done,
     /* 276175 */ // Label 4484: @276175
     /* 276175 */ GIM_Reject,
     /* 276176 */ // Label 4468: @276176
     /* 276176 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(276199), // Rule ID 7276 //
     /* 276181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276185 */   // MIs[0] Operand 1
     /* 276185 */   // No operand predicates
     /* 276185 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34573),
     /* 276189 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34573>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276194 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276197 */   GIR_RootConstrainSelectedInstOperands,
     /* 276198 */   // GIR_Coverage, 7276,
     /* 276198 */   GIR_EraseRootFromParent_Done,
     /* 276199 */ // Label 4485: @276199
     /* 276199 */ GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(276218), // Rule ID 7277 //
     /* 276204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276208 */   // MIs[0] Operand 1
     /* 276208 */   // No operand predicates
     /* 276208 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276213 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276216 */   GIR_RootConstrainSelectedInstOperands,
     /* 276217 */   // GIR_Coverage, 7277,
     /* 276217 */   GIR_EraseRootFromParent_Done,
     /* 276218 */ // Label 4486: @276218
     /* 276218 */ GIM_Reject,
     /* 276219 */ // Label 4469: @276219
     /* 276219 */ GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(276242), // Rule ID 7278 //
     /* 276224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276228 */   // MIs[0] Operand 1
     /* 276228 */   // No operand predicates
     /* 276228 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34576),
     /* 276232 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34576>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276237 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276240 */   GIR_RootConstrainSelectedInstOperands,
     /* 276241 */   // GIR_Coverage, 7278,
     /* 276241 */   GIR_EraseRootFromParent_Done,
     /* 276242 */ // Label 4487: @276242
     /* 276242 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(276261), // Rule ID 7279 //
     /* 276247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276251 */   // MIs[0] Operand 1
     /* 276251 */   // No operand predicates
     /* 276251 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276256 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276259 */   GIR_RootConstrainSelectedInstOperands,
     /* 276260 */   // GIR_Coverage, 7279,
     /* 276260 */   GIR_EraseRootFromParent_Done,
     /* 276261 */ // Label 4488: @276261
     /* 276261 */ GIM_Reject,
     /* 276262 */ // Label 4470: @276262
     /* 276262 */ GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(276284), // Rule ID 7315 //
     /* 276267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 276270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276274 */   // MIs[0] Operand 1
     /* 276274 */   // No operand predicates
     /* 276274 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B64:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 276274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276282 */   GIR_RootConstrainSelectedInstOperands,
     /* 276283 */   // GIR_Coverage, 7315,
     /* 276283 */   GIR_EraseRootFromParent_Done,
     /* 276284 */ // Label 4489: @276284
     /* 276284 */ GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(276306), // Rule ID 7316 //
     /* 276289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 276292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276296 */   // MIs[0] Operand 1
     /* 276296 */   // No operand predicates
     /* 276296 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B32:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 276296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276301 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276304 */   GIR_RootConstrainSelectedInstOperands,
     /* 276305 */   // GIR_Coverage, 7316,
     /* 276305 */   GIR_EraseRootFromParent_Done,
     /* 276306 */ // Label 4490: @276306
     /* 276306 */ GIM_Reject,
     /* 276307 */ // Label 4471: @276307
     /* 276307 */ GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(276333), // Rule ID 7286 //
     /* 276312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 276315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276319 */   // MIs[0] Operand 1
     /* 276319 */   // No operand predicates
     /* 276319 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34589),
     /* 276323 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34589>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276328 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276331 */   GIR_RootConstrainSelectedInstOperands,
     /* 276332 */   // GIR_Coverage, 7286,
     /* 276332 */   GIR_EraseRootFromParent_Done,
     /* 276333 */ // Label 4491: @276333
     /* 276333 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(276359), // Rule ID 7288 //
     /* 276338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 276341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276345 */   // MIs[0] Operand 1
     /* 276345 */   // No operand predicates
     /* 276345 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34589),
     /* 276349 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34589>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276357 */   GIR_RootConstrainSelectedInstOperands,
     /* 276358 */   // GIR_Coverage, 7288,
     /* 276358 */   GIR_EraseRootFromParent_Done,
     /* 276359 */ // Label 4492: @276359
     /* 276359 */ GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(276391), // Rule ID 7290 //
     /* 276364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 276367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 276371 */   // MIs[0] Operand 1
     /* 276371 */   // No operand predicates
     /* 276371 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34589),
     /* 276375 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34589>>:$imm  =>  (V_MOV_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, (imm:{ *:[i16] }):$imm, 0:{ *:[i32] })
     /* 276375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B16_t16_e64),
     /* 276378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276383 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276389 */   GIR_RootConstrainSelectedInstOperands,
     /* 276390 */   // GIR_Coverage, 7290,
     /* 276390 */   GIR_EraseRootFromParent_Done,
     /* 276391 */ // Label 4493: @276391
     /* 276391 */ GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(276410), // Rule ID 1870 //
     /* 276396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276400 */   // MIs[0] Operand 1
     /* 276400 */   // No operand predicates
     /* 276400 */   // (imm:{ *:[i16] }):$imm  =>  (S_MOV_B32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276405 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276408 */   GIR_RootConstrainSelectedInstOperands,
     /* 276409 */   // GIR_Coverage, 1870,
     /* 276409 */   GIR_EraseRootFromParent_Done,
     /* 276410 */ // Label 4494: @276410
     /* 276410 */ GIM_Reject,
     /* 276411 */ // Label 4472: @276411
     /* 276411 */ GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(276434), // Rule ID 7272 //
     /* 276416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276420 */   // MIs[0] Operand 1
     /* 276420 */   // No operand predicates
     /* 276420 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34569),
     /* 276424 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34569>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276432 */   GIR_RootConstrainSelectedInstOperands,
     /* 276433 */   // GIR_Coverage, 7272,
     /* 276433 */   GIR_EraseRootFromParent_Done,
     /* 276434 */ // Label 4495: @276434
     /* 276434 */ GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(276453), // Rule ID 7273 //
     /* 276439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276443 */   // MIs[0] Operand 1
     /* 276443 */   // No operand predicates
     /* 276443 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276448 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276451 */   GIR_RootConstrainSelectedInstOperands,
     /* 276452 */   // GIR_Coverage, 7273,
     /* 276452 */   GIR_EraseRootFromParent_Done,
     /* 276453 */ // Label 4496: @276453
     /* 276453 */ GIM_Reject,
     /* 276454 */ // Label 4473: @276454
     /* 276454 */ GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(276477), // Rule ID 7301 //
     /* 276459 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276467 */   // MIs[0] Operand 1
     /* 276467 */   // No operand predicates
     /* 276467 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276472 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276475 */   GIR_RootConstrainSelectedInstOperands,
     /* 276476 */   // GIR_Coverage, 7301,
     /* 276476 */   GIR_EraseRootFromParent_Done,
     /* 276477 */ // Label 4497: @276477
     /* 276477 */ GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(276500), // Rule ID 7304 //
     /* 276482 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276490 */   // MIs[0] Operand 1
     /* 276490 */   // No operand predicates
     /* 276490 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276495 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276498 */   GIR_RootConstrainSelectedInstOperands,
     /* 276499 */   // GIR_Coverage, 7304,
     /* 276499 */   GIR_EraseRootFromParent_Done,
     /* 276500 */ // Label 4498: @276500
     /* 276500 */ GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(276523), // Rule ID 7307 //
     /* 276505 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276513 */   // MIs[0] Operand 1
     /* 276513 */   // No operand predicates
     /* 276513 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276518 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276521 */   GIR_RootConstrainSelectedInstOperands,
     /* 276522 */   // GIR_Coverage, 7307,
     /* 276522 */   GIR_EraseRootFromParent_Done,
     /* 276523 */ // Label 4499: @276523
     /* 276523 */ GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(276546), // Rule ID 7310 //
     /* 276528 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276536 */   // MIs[0] Operand 1
     /* 276536 */   // No operand predicates
     /* 276536 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276541 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276544 */   GIR_RootConstrainSelectedInstOperands,
     /* 276545 */   // GIR_Coverage, 7310,
     /* 276545 */   GIR_EraseRootFromParent_Done,
     /* 276546 */ // Label 4500: @276546
     /* 276546 */ GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(276569), // Rule ID 7292 //
     /* 276551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276555 */   // MIs[0] Operand 1
     /* 276555 */   // No operand predicates
     /* 276555 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34601),
     /* 276559 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34601>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276564 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276567 */   GIR_RootConstrainSelectedInstOperands,
     /* 276568 */   // GIR_Coverage, 7292,
     /* 276568 */   GIR_EraseRootFromParent_Done,
     /* 276569 */ // Label 4501: @276569
     /* 276569 */ GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(276592), // Rule ID 7300 //
     /* 276574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276578 */   // MIs[0] Operand 1
     /* 276578 */   // No operand predicates
     /* 276578 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34601),
     /* 276582 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34601>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276587 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276590 */   GIR_RootConstrainSelectedInstOperands,
     /* 276591 */   // GIR_Coverage, 7300,
     /* 276591 */   GIR_EraseRootFromParent_Done,
     /* 276592 */ // Label 4502: @276592
     /* 276592 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(276611), // Rule ID 7294 //
     /* 276597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276601 */   // MIs[0] Operand 1
     /* 276601 */   // No operand predicates
     /* 276601 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276606 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276609 */   GIR_RootConstrainSelectedInstOperands,
     /* 276610 */   // GIR_Coverage, 7294,
     /* 276610 */   GIR_EraseRootFromParent_Done,
     /* 276611 */ // Label 4503: @276611
     /* 276611 */ GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(276630), // Rule ID 7302 //
     /* 276616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276620 */   // MIs[0] Operand 1
     /* 276620 */   // No operand predicates
     /* 276620 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276625 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276628 */   GIR_RootConstrainSelectedInstOperands,
     /* 276629 */   // GIR_Coverage, 7302,
     /* 276629 */   GIR_EraseRootFromParent_Done,
     /* 276630 */ // Label 4504: @276630
     /* 276630 */ GIM_Reject,
     /* 276631 */ // Label 4474: @276631
     /* 276631 */ GIM_Reject,
     /* 276632 */ // Label 43: @276632
     /* 276632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4508*/ GIMT_Encode4(276913),
     /* 276643 */ /*GILLT_s16*//*Label 4505*/ GIMT_Encode4(276655),
     /* 276647 */ /*GILLT_s32*//*Label 4506*/ GIMT_Encode4(276727),
     /* 276651 */ /*GILLT_s64*//*Label 4507*/ GIMT_Encode4(276795),
     /* 276655 */ // Label 4505: @276655
     /* 276655 */ GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(276680), // Rule ID 7287 //
     /* 276660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276664 */   // MIs[0] Operand 1
     /* 276664 */   // No operand predicates
     /* 276664 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34591),
     /* 276668 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34591>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 276668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276673 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276678 */   GIR_RootConstrainSelectedInstOperands,
     /* 276679 */   // GIR_Coverage, 7287,
     /* 276679 */   GIR_EraseRootFromParent_Done,
     /* 276680 */ // Label 4509: @276680
     /* 276680 */ GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(276705), // Rule ID 7289 //
     /* 276685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276689 */   // MIs[0] Operand 1
     /* 276689 */   // No operand predicates
     /* 276689 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34591),
     /* 276693 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34591>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 276693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276698 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276703 */   GIR_RootConstrainSelectedInstOperands,
     /* 276704 */   // GIR_Coverage, 7289,
     /* 276704 */   GIR_EraseRootFromParent_Done,
     /* 276705 */ // Label 4510: @276705
     /* 276705 */ GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(276726), // Rule ID 7297 //
     /* 276710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276714 */   // MIs[0] Operand 1
     /* 276714 */   // No operand predicates
     /* 276714 */   // (fpimm:{ *:[f16] }):$imm  =>  (S_MOV_B32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[i32] } ?:{ *:[f16] }:$imm))
     /* 276714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276719 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276724 */   GIR_RootConstrainSelectedInstOperands,
     /* 276725 */   // GIR_Coverage, 7297,
     /* 276725 */   GIR_EraseRootFromParent_Done,
     /* 276726 */ // Label 4511: @276726
     /* 276726 */ GIM_Reject,
     /* 276727 */ // Label 4506: @276727
     /* 276727 */ GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(276752), // Rule ID 7298 //
     /* 276732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276736 */   // MIs[0] Operand 1
     /* 276736 */   // No operand predicates
     /* 276736 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34611),
     /* 276740 */   // (fpimm:{ *:[f32] })<<P:Predicate_anonymous_34611>>:$imm  =>  (V_MOV_B32_e32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276745 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276750 */   GIR_RootConstrainSelectedInstOperands,
     /* 276751 */   // GIR_Coverage, 7298,
     /* 276751 */   GIR_EraseRootFromParent_Done,
     /* 276752 */ // Label 4512: @276752
     /* 276752 */ GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(276773), // Rule ID 7296 //
     /* 276757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276761 */   // MIs[0] Operand 1
     /* 276761 */   // No operand predicates
     /* 276761 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276766 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276771 */   GIR_RootConstrainSelectedInstOperands,
     /* 276772 */   // GIR_Coverage, 7296,
     /* 276772 */   GIR_EraseRootFromParent_Done,
     /* 276773 */ // Label 4513: @276773
     /* 276773 */ GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(276794), // Rule ID 7299 //
     /* 276778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276782 */   // MIs[0] Operand 1
     /* 276782 */   // No operand predicates
     /* 276782 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276787 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276792 */   GIR_RootConstrainSelectedInstOperands,
     /* 276793 */   // GIR_Coverage, 7299,
     /* 276793 */   GIR_EraseRootFromParent_Done,
     /* 276794 */ // Label 4514: @276794
     /* 276794 */ GIM_Reject,
     /* 276795 */ // Label 4507: @276795
     /* 276795 */ GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(276820), // Rule ID 7313 //
     /* 276800 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_InlineImmFP64),
     /* 276804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276808 */   // MIs[0] Operand 1
     /* 276808 */   // No operand predicates
     /* 276808 */   // (fpimm:{ *:[f64] })<<P:Predicate_InlineImmFP64>>:$imm  =>  (S_MOV_B64:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } ?:{ *:[f64] }:$imm))
     /* 276808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276813 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276818 */   GIR_RootConstrainSelectedInstOperands,
     /* 276819 */   // GIR_Coverage, 7313,
     /* 276819 */   GIR_EraseRootFromParent_Done,
     /* 276820 */ // Label 4515: @276820
     /* 276820 */ GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(276845), // Rule ID 7293 //
     /* 276825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276829 */   // MIs[0] Operand 1
     /* 276829 */   // No operand predicates
     /* 276829 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34603),
     /* 276833 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34603>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 276833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276838 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276843 */   GIR_RootConstrainSelectedInstOperands,
     /* 276844 */   // GIR_Coverage, 7293,
     /* 276844 */   GIR_EraseRootFromParent_Done,
     /* 276845 */ // Label 4516: @276845
     /* 276845 */ GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(276870), // Rule ID 7312 //
     /* 276850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276854 */   // MIs[0] Operand 1
     /* 276854 */   // No operand predicates
     /* 276854 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34603),
     /* 276858 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34603>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 276858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276863 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276868 */   GIR_RootConstrainSelectedInstOperands,
     /* 276869 */   // GIR_Coverage, 7312,
     /* 276869 */   GIR_EraseRootFromParent_Done,
     /* 276870 */ // Label 4517: @276870
     /* 276870 */ GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(276891), // Rule ID 7295 //
     /* 276875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276879 */   // MIs[0] Operand 1
     /* 276879 */   // No operand predicates
     /* 276879 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 276879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276884 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276889 */   GIR_RootConstrainSelectedInstOperands,
     /* 276890 */   // GIR_Coverage, 7295,
     /* 276890 */   GIR_EraseRootFromParent_Done,
     /* 276891 */ // Label 4518: @276891
     /* 276891 */ GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(276912), // Rule ID 7314 //
     /* 276896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276900 */   // MIs[0] Operand 1
     /* 276900 */   // No operand predicates
     /* 276900 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 276900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276905 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276910 */   GIR_RootConstrainSelectedInstOperands,
     /* 276911 */   // GIR_Coverage, 7314,
     /* 276911 */   GIR_EraseRootFromParent_Done,
     /* 276912 */ // Label 4519: @276912
     /* 276912 */ GIM_Reject,
     /* 276913 */ // Label 4508: @276913
     /* 276913 */ GIM_Reject,
     /* 276914 */ // Label 44: @276914
     /* 276914 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4523*/ GIMT_Encode4(277716),
     /* 276925 */ /*GILLT_s16*//*Label 4520*/ GIMT_Encode4(276937),
     /* 276929 */ /*GILLT_s32*//*Label 4521*/ GIMT_Encode4(276974),
     /* 276933 */ /*GILLT_s64*//*Label 4522*/ GIMT_Encode4(277062),
     /* 276937 */ // Label 4520: @276937
     /* 276937 */ GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(276973), // Rule ID 2559 //
     /* 276942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 276945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 276948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276952 */   // (sext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 276952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 276955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 276969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 276971 */   GIR_RootConstrainSelectedInstOperands,
     /* 276972 */   // GIR_Coverage, 2559,
     /* 276972 */   GIR_EraseRootFromParent_Done,
     /* 276973 */ // Label 4524: @276973
     /* 276973 */ GIM_Reject,
     /* 276974 */ // Label 4521: @276974
     /* 276974 */ GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(276997), // Rule ID 1871 //
     /* 276979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 276982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276986 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13780),
     /* 276990 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13780>>  =>  (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src)
     /* 276990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 276995 */   GIR_RootConstrainSelectedInstOperands,
     /* 276996 */   // GIR_Coverage, 1871,
     /* 276996 */   GIR_Done,
     /* 276997 */ // Label 4525: @276997
     /* 276997 */ GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(277028), // Rule ID 2568 //
     /* 277002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277009 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20318),
     /* 277013 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20318>>  =>  (V_BFE_I32_e64:{ *:[i32] } i16:{ *:[i16] }:$src, 0:{ *:[i32] }, 16:{ *:[i32] })
     /* 277013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 277016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 277026 */   GIR_RootConstrainSelectedInstOperands,
     /* 277027 */   // GIR_Coverage, 2568,
     /* 277027 */   GIR_EraseRootFromParent_Done,
     /* 277028 */ // Label 4526: @277028
     /* 277028 */ GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(277061), // Rule ID 7318 //
     /* 277033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 277036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277040 */   // (sext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 277040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 277057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 277059 */   GIR_RootConstrainSelectedInstOperands,
     /* 277060 */   // GIR_Coverage, 7318,
     /* 277060 */   GIR_EraseRootFromParent_Done,
     /* 277061 */ // Label 4527: @277061
     /* 277061 */ GIM_Reject,
     /* 277062 */ // Label 4522: @277062
     /* 277062 */ GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(277207), // Rule ID 1881 //
     /* 277067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277074 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13780),
     /* 277078 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13780>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), (S_MOV_B32:{ *:[i1] } 31:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277078 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 277081 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277085 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277090 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 277093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 277095 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 277098 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 277102 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277107 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 277113 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 277116 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 277120 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277125 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 277128 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 277131 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 277134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277136 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 277139 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277143 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277148 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 277151 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 277156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 277163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277168 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277182 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 277188 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 277201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 277206 */   // GIR_Coverage, 1881,
     /* 277206 */   GIR_EraseRootFromParent_Done,
     /* 277207 */ // Label 4528: @277207
     /* 277207 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(277429), // Rule ID 2569 //
     /* 277212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277219 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20318),
     /* 277223 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20318>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] })), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e32:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 31:{ *:[i32] }), (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] }))), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277223 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 277226 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277230 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277235 */   GIR_AddImm8, /*InsnID*/9, /*Imm*/16,
     /* 277238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 277240 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /* 277243 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277247 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277252 */   GIR_AddImm8, /*InsnID*/8, /*Imm*/0,
     /* 277255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 277257 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 277260 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 277264 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277269 */   GIR_Copy, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277273 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 277276 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
     /* 277279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 277281 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 277284 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277288 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277293 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 277296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 277298 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 277301 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e32),
     /* 277305 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277310 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 277313 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 277316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 277318 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 277321 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277325 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277330 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 277333 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277338 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 277341 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277345 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277350 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/16,
     /* 277353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277367 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 277379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277384 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277388 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277391 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277404 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 277410 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277428 */   // GIR_Coverage, 2569,
     /* 277428 */   GIR_EraseRootFromParent_Done,
     /* 277429 */ // Label 4529: @277429
     /* 277429 */ GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(277521), // Rule ID 7403 //
     /* 277434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277441 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13780),
     /* 277445 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_13780>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i32] }:$src, 31:{ *:[i32] }), SReg_32_XM0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277445 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 277448 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 277452 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277457 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277461 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 277464 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 277467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277481 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277484 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 277489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277496 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277502 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 277515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 277520 */   // GIR_Coverage, 7403,
     /* 277520 */   GIR_EraseRootFromParent_Done,
     /* 277521 */ // Label 4530: @277521
     /* 277521 */ GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(277610), // Rule ID 7404 //
     /* 277526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277533 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20318),
     /* 277537 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_20318>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e64:{ *:[i16] } 31:{ *:[i32] }, ?:{ *:[i32] }:$src), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277537 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277540 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 277544 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277549 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 277552 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277570 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277583 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277585 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277591 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277604 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277609 */   // GIR_Coverage, 7404,
     /* 277609 */   GIR_EraseRootFromParent_Done,
     /* 277610 */ // Label 4531: @277610
     /* 277610 */ GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(277715), // Rule ID 7405 //
     /* 277615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 277618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277622 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub1:{ *:[i32] })
     /* 277622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277634 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277637 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277640 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277643 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 277646 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 277655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277664 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277667 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277670 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277673 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 277676 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277690 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 277696 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277714 */   // GIR_Coverage, 7405,
     /* 277714 */   GIR_EraseRootFromParent_Done,
     /* 277715 */ // Label 4532: @277715
     /* 277715 */ GIM_Reject,
     /* 277716 */ // Label 4523: @277716
     /* 277716 */ GIM_Reject,
     /* 277717 */ // Label 45: @277717
     /* 277717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4536*/ GIMT_Encode4(280919),
     /* 277728 */ /*GILLT_s16*//*Label 4533*/ GIMT_Encode4(277740),
     /* 277732 */ /*GILLT_s32*//*Label 4534*/ GIMT_Encode4(277777),
     /* 277736 */ /*GILLT_s64*//*Label 4535*/ GIMT_Encode4(279065),
     /* 277740 */ // Label 4533: @277740
     /* 277740 */ GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(277776), // Rule ID 2557 //
     /* 277745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 277748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 277751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277755 */   // (zext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 277755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 277772 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277774 */   GIR_RootConstrainSelectedInstOperands,
     /* 277775 */   // GIR_Coverage, 2557,
     /* 277775 */   GIR_EraseRootFromParent_Done,
     /* 277776 */ // Label 4537: @277776
     /* 277776 */ GIM_Reject,
     /* 277777 */ // Label 4534: @277777
     /* 277777 */ GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(277853), // Rule ID 2554 //
     /* 277782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 277800 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277804 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277808 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277812 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277816 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277820 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277824 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277828 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277832 */   // MIs[3] Operand 1
     /* 277832 */   // No operand predicates
     /* 277832 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277836 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277838 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 277841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277843 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277847 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 277851 */   GIR_RootConstrainSelectedInstOperands,
     /* 277852 */   // GIR_Coverage, 2554,
     /* 277852 */   GIR_EraseRootFromParent_Done,
     /* 277853 */ // Label 4538: @277853
     /* 277853 */ GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(277929), // Rule ID 2550 //
     /* 277858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 277876 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277880 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277884 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277888 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277892 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277896 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277900 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277904 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277908 */   // MIs[3] Operand 1
     /* 277908 */   // No operand predicates
     /* 277908 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277912 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277914 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 277917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277919 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277923 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 277927 */   GIR_RootConstrainSelectedInstOperands,
     /* 277928 */   // GIR_Coverage, 2550,
     /* 277928 */   GIR_EraseRootFromParent_Done,
     /* 277929 */ // Label 4539: @277929
     /* 277929 */ GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(278005), // Rule ID 2546 //
     /* 277934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 277952 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277956 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277960 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277968 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277972 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277976 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277980 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277984 */   // MIs[3] Operand 1
     /* 277984 */   // No operand predicates
     /* 277984 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277988 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277990 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 277993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277995 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277999 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278003 */   GIR_RootConstrainSelectedInstOperands,
     /* 278004 */   // GIR_Coverage, 2546,
     /* 278004 */   GIR_EraseRootFromParent_Done,
     /* 278005 */ // Label 4540: @278005
     /* 278005 */ GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(278069), // Rule ID 2532 //
     /* 278010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278036 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278040 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278044 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /* 278048 */   // MIs[2] Operand 1
     /* 278048 */   // No operand predicates
     /* 278048 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278050 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /* 278050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 278053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278059 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /* 278064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278067 */   GIR_RootConstrainSelectedInstOperands,
     /* 278068 */   // GIR_Coverage, 2532,
     /* 278068 */   GIR_EraseRootFromParent_Done,
     /* 278069 */ // Label 4541: @278069
     /* 278069 */ GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(278140), // Rule ID 2570 //
     /* 278074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278092 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278096 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278100 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278104 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 278108 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 278112 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 278116 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278118 */   // (zext:{ *:[i32] } (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 278118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 278121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278123 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 278127 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 278131 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 278135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278138 */   GIR_RootConstrainSelectedInstOperands,
     /* 278139 */   // GIR_Coverage, 2570,
     /* 278139 */   GIR_EraseRootFromParent_Done,
     /* 278140 */ // Label 4542: @278140
     /* 278140 */ GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(278211), // Rule ID 8490 //
     /* 278145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278163 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278171 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278175 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 278179 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 278183 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 278187 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278189 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 278189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 278192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278194 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 278198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 278202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 278206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278209 */   GIR_RootConstrainSelectedInstOperands,
     /* 278210 */   // GIR_Coverage, 8490,
     /* 278210 */   GIR_EraseRootFromParent_Done,
     /* 278211 */ // Label 4543: @278211
     /* 278211 */ GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(278281), // Rule ID 7463 //
     /* 278216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 278219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 278234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278238 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278240 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 278240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278252 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 278262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 278267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278279 */   GIR_RootConstrainSelectedInstOperands,
     /* 278280 */   // GIR_Coverage, 7463,
     /* 278280 */   GIR_EraseRootFromParent_Done,
     /* 278281 */ // Label 4544: @278281
     /* 278281 */ GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(278351), // Rule ID 7465 //
     /* 278286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 278289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 278304 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278308 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278310 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 278310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278322 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 278332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 278337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278349 */   GIR_RootConstrainSelectedInstOperands,
     /* 278350 */   // GIR_Coverage, 7465,
     /* 278350 */   GIR_EraseRootFromParent_Done,
     /* 278351 */ // Label 4545: @278351
     /* 278351 */ GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(278438), // Rule ID 7467 //
     /* 278356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 278359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 278374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278380 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 278380 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 278383 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278387 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278392 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(202113025),
     /* 278402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278416 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 278425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 278436 */   GIR_RootConstrainSelectedInstOperands,
     /* 278437 */   // GIR_Coverage, 7467,
     /* 278437 */   GIR_EraseRootFromParent_Done,
     /* 278438 */ // Label 4546: @278438
     /* 278438 */ GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(278489), // Rule ID 2520 //
     /* 278443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278461 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278471 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_ADD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 278474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278476 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278480 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278487 */   GIR_RootConstrainSelectedInstOperands,
     /* 278488 */   // GIR_Coverage, 2520,
     /* 278488 */   GIR_EraseRootFromParent_Done,
     /* 278489 */ // Label 4547: @278489
     /* 278489 */ GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(278537), // Rule ID 2553 //
     /* 278494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 278512 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278516 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278522 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 278525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278531 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278535 */   GIR_RootConstrainSelectedInstOperands,
     /* 278536 */   // GIR_Coverage, 2553,
     /* 278536 */   GIR_EraseRootFromParent_Done,
     /* 278537 */ // Label 4548: @278537
     /* 278537 */ GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(278585), // Rule ID 2549 //
     /* 278542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 278560 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278564 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278570 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 278573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278575 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278579 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278583 */   GIR_RootConstrainSelectedInstOperands,
     /* 278584 */   // GIR_Coverage, 2549,
     /* 278584 */   GIR_EraseRootFromParent_Done,
     /* 278585 */ // Label 4549: @278585
     /* 278585 */ GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(278633), // Rule ID 2533 //
     /* 278590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 278608 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278612 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278618 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MUL_LO_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 278621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278623 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278627 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278631 */   GIR_RootConstrainSelectedInstOperands,
     /* 278632 */   // GIR_Coverage, 2533,
     /* 278632 */   GIR_EraseRootFromParent_Done,
     /* 278633 */ // Label 4550: @278633
     /* 278633 */ GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(278681), // Rule ID 2545 //
     /* 278638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 278656 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278666 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 278669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278675 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278679 */   GIR_RootConstrainSelectedInstOperands,
     /* 278680 */   // GIR_Coverage, 2545,
     /* 278680 */   GIR_EraseRootFromParent_Done,
     /* 278681 */ // Label 4551: @278681
     /* 278681 */ GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(278729), // Rule ID 2539 //
     /* 278686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 278704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278712 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278714 */   // (zext:{ *:[i32] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 278717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278719 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278727 */   GIR_RootConstrainSelectedInstOperands,
     /* 278728 */   // GIR_Coverage, 2539,
     /* 278728 */   GIR_EraseRootFromParent_Done,
     /* 278729 */ // Label 4552: @278729
     /* 278729 */ GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(278777), // Rule ID 2537 //
     /* 278734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 278752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278762 */   // (zext:{ *:[i32] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 278765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278767 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278771 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278775 */   GIR_RootConstrainSelectedInstOperands,
     /* 278776 */   // GIR_Coverage, 2537,
     /* 278776 */   GIR_EraseRootFromParent_Done,
     /* 278777 */ // Label 4553: @278777
     /* 278777 */ GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(278828), // Rule ID 2535 //
     /* 278782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278800 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278804 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278810 */   // (zext:{ *:[i32] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 278813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278815 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278819 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278826 */   GIR_RootConstrainSelectedInstOperands,
     /* 278827 */   // GIR_Coverage, 2535,
     /* 278827 */   GIR_EraseRootFromParent_Done,
     /* 278828 */ // Label 4554: @278828
     /* 278828 */ GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(278876), // Rule ID 2543 //
     /* 278833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 278851 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278861 */   // (zext:{ *:[i32] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 278864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278866 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278870 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278874 */   GIR_RootConstrainSelectedInstOperands,
     /* 278875 */   // GIR_Coverage, 2543,
     /* 278875 */   GIR_EraseRootFromParent_Done,
     /* 278876 */ // Label 4555: @278876
     /* 278876 */ GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(278924), // Rule ID 2541 //
     /* 278881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 278899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278909 */   // (zext:{ *:[i32] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 278912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278914 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278918 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278922 */   GIR_RootConstrainSelectedInstOperands,
     /* 278923 */   // GIR_Coverage, 2541,
     /* 278923 */   GIR_EraseRootFromParent_Done,
     /* 278924 */ // Label 4556: @278924
     /* 278924 */ GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(278979), // Rule ID 1882 //
     /* 278929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 278936 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13792),
     /* 278940 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13792>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 278940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 278943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278952 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 278962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 278967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 278969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 278974 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 278977 */   GIR_RootConstrainSelectedInstOperands,
     /* 278978 */   // GIR_Coverage, 1882,
     /* 278978 */   GIR_EraseRootFromParent_Done,
     /* 278979 */ // Label 4557: @278979
     /* 278979 */ GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(279031), // Rule ID 7444 //
     /* 278984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278991 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34784),
     /* 278995 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34784>>  =>  (V_AND_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 278995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 279002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279007 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 279017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 279022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279027 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279029 */   GIR_RootConstrainSelectedInstOperands,
     /* 279030 */   // GIR_Coverage, 7444,
     /* 279030 */   GIR_EraseRootFromParent_Done,
     /* 279031 */ // Label 4558: @279031
     /* 279031 */ GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(279064), // Rule ID 7319 //
     /* 279036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 279039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279043 */   // (zext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 279043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 279046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279060 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 279062 */   GIR_RootConstrainSelectedInstOperands,
     /* 279063 */   // GIR_Coverage, 7319,
     /* 279063 */   GIR_EraseRootFromParent_Done,
     /* 279064 */ // Label 4559: @279064
     /* 279064 */ GIM_Reject,
     /* 279065 */ // Label 4535: @279065
     /* 279065 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(279198), // Rule ID 2556 //
     /* 279070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 279088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279096 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279100 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 279104 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279108 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 279112 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279116 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279120 */   // MIs[3] Operand 1
     /* 279120 */   // No operand predicates
     /* 279120 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 279124 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279126 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279138 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 279150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279155 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 279159 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279173 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279179 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279197 */   // GIR_Coverage, 2556,
     /* 279197 */   GIR_EraseRootFromParent_Done,
     /* 279198 */ // Label 4560: @279198
     /* 279198 */ GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(279331), // Rule ID 2552 //
     /* 279203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 279221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279229 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279233 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 279237 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279241 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 279245 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279249 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279253 */   // MIs[3] Operand 1
     /* 279253 */   // No operand predicates
     /* 279253 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 279257 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279259 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279259 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279262 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279266 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279271 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 279283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279288 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 279292 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279306 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279312 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279325 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279330 */   // GIR_Coverage, 2552,
     /* 279330 */   GIR_EraseRootFromParent_Done,
     /* 279331 */ // Label 4561: @279331
     /* 279331 */ GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(279464), // Rule ID 2548 //
     /* 279336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 279354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279358 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279362 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279366 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 279370 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279374 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 279378 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279382 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279386 */   // MIs[3] Operand 1
     /* 279386 */   // No operand predicates
     /* 279386 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 279390 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279392 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279392 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279395 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279399 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279404 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 279416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 279425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279439 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279445 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279463 */   // GIR_Coverage, 2548,
     /* 279463 */   GIR_EraseRootFromParent_Done,
     /* 279464 */ // Label 4562: @279464
     /* 279464 */ GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(279572), // Rule ID 2521 //
     /* 279469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 279487 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279497 */   // (zext:{ *:[i64] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ADD_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279497 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279500 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279504 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279509 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 279521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279534 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279547 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279553 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279566 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279571 */   // GIR_Coverage, 2521,
     /* 279571 */   GIR_EraseRootFromParent_Done,
     /* 279572 */ // Label 4563: @279572
     /* 279572 */ GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(279677), // Rule ID 2555 //
     /* 279577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 279595 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279599 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279605 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279605 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279608 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279612 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279617 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 279629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279634 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279638 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279652 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279658 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279676 */   // GIR_Coverage, 2555,
     /* 279676 */   GIR_EraseRootFromParent_Done,
     /* 279677 */ // Label 4564: @279677
     /* 279677 */ GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(279782), // Rule ID 2551 //
     /* 279682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 279700 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279704 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279710 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279710 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279713 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279717 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279722 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 279734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279739 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279743 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279757 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279763 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279781 */   // GIR_Coverage, 2551,
     /* 279781 */   GIR_EraseRootFromParent_Done,
     /* 279782 */ // Label 4565: @279782
     /* 279782 */ GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(279887), // Rule ID 2534 //
     /* 279787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 279805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279809 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279815 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_LO_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279827 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 279839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279844 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279848 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279862 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279868 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279886 */   // GIR_Coverage, 2534,
     /* 279886 */   GIR_EraseRootFromParent_Done,
     /* 279887 */ // Label 4566: @279887
     /* 279887 */ GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(279992), // Rule ID 2547 //
     /* 279892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 279910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279920 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279920 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279923 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279927 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279932 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 279944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279949 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279953 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279967 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279973 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279991 */   // GIR_Coverage, 2547,
     /* 279991 */   GIR_EraseRootFromParent_Done,
     /* 279992 */ // Label 4567: @279992
     /* 279992 */ GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(280097), // Rule ID 2540 //
     /* 279997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 280015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280023 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280025 */   // (zext:{ *:[i64] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280025 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280028 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280032 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280037 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 280049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280054 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280072 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280078 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280096 */   // GIR_Coverage, 2540,
     /* 280096 */   GIR_EraseRootFromParent_Done,
     /* 280097 */ // Label 4568: @280097
     /* 280097 */ GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(280202), // Rule ID 2538 //
     /* 280102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 280120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280124 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280130 */   // (zext:{ *:[i64] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280142 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 280154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280159 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280163 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280177 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280183 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280201 */   // GIR_Coverage, 2538,
     /* 280201 */   GIR_EraseRootFromParent_Done,
     /* 280202 */ // Label 4569: @280202
     /* 280202 */ GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(280310), // Rule ID 2536 //
     /* 280207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280235 */   // (zext:{ *:[i64] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_SUB_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280235 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280238 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280242 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280247 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 280259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280264 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280268 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280272 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280285 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280291 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280309 */   // GIR_Coverage, 2536,
     /* 280309 */   GIR_EraseRootFromParent_Done,
     /* 280310 */ // Label 4570: @280310
     /* 280310 */ GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(280415), // Rule ID 2544 //
     /* 280315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 280333 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280337 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280343 */   // (zext:{ *:[i64] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280355 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 280367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280390 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280396 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280414 */   // GIR_Coverage, 2544,
     /* 280414 */   GIR_EraseRootFromParent_Done,
     /* 280415 */ // Label 4571: @280415
     /* 280415 */ GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(280520), // Rule ID 2542 //
     /* 280420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 280438 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280442 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280446 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280448 */   // (zext:{ *:[i64] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280448 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280451 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280455 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280460 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 280472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280477 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280495 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280501 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280509 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280519 */   // GIR_Coverage, 2542,
     /* 280519 */   GIR_EraseRootFromParent_Done,
     /* 280520 */ // Label 4572: @280520
     /* 280520 */ GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(280654), // Rule ID 1880 //
     /* 280525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280532 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13792),
     /* 280536 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13792>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280536 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s1,
     /* 280539 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280543 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280548 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 280551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280553 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 280556 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280560 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280565 */   GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(65535),
     /* 280575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280577 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 280580 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 280584 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280589 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280593 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 280596 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 280599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 280604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280613 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 280621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280629 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280635 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280638 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 280648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 280653 */   // GIR_Coverage, 1880,
     /* 280653 */   GIR_EraseRootFromParent_Done,
     /* 280654 */ // Label 4573: @280654
     /* 280654 */ GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(280765), // Rule ID 7445 //
     /* 280659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280666 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34784),
     /* 280670 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34784>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280670 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 280673 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280677 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280682 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 280685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280699 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /* 280709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 280718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280723 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280726 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280740 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 280746 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280764 */   // GIR_Coverage, 7445,
     /* 280764 */   GIR_EraseRootFromParent_Done,
     /* 280765 */ // Label 4574: @280765
     /* 280765 */ GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(280826), // Rule ID 7399 //
     /* 280770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280777 */   // (zext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 280780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280789 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280799 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280801 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280807 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 280820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 280825 */   // GIR_Coverage, 7399,
     /* 280825 */   GIR_EraseRootFromParent_Done,
     /* 280826 */ // Label 4575: @280826
     /* 280826 */ GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(280918), // Rule ID 7401 //
     /* 280831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 280834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280838 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280838 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 280841 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280845 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280850 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 280862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280867 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280870 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280873 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280876 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280893 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280899 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280917 */   // GIR_Coverage, 7401,
     /* 280917 */   GIR_EraseRootFromParent_Done,
     /* 280918 */ // Label 4576: @280918
     /* 280918 */ GIM_Reject,
     /* 280919 */ // Label 4536: @280919
     /* 280919 */ GIM_Reject,
     /* 280920 */ // Label 46: @280920
     /* 280920 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4581*/ GIMT_Encode4(282455),
     /* 280931 */ /*GILLT_s16*//*Label 4577*/ GIMT_Encode4(280947),
     /* 280935 */ /*GILLT_s32*//*Label 4578*/ GIMT_Encode4(281258),
     /* 280939 */ /*GILLT_s64*//*Label 4579*/ GIMT_Encode4(281899),
     /* 280943 */ /*GILLT_v2s16*//*Label 4580*/ GIMT_Encode4(282286),
     /* 280947 */ // Label 4577: @280947
     /* 280947 */ GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(281257),
     /* 280952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 280958 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(281044), // Rule ID 843 //
     /* 280963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 280966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 280970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 280978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280994 */     // MIs[2] Operand 1
     /* 280994 */     // No operand predicates
     /* 280994 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 280998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 281007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 281014 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 281014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 281017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 281024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 281029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 281034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 281039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281042 */     GIR_RootConstrainSelectedInstOperands,
     /* 281043 */     // GIR_Coverage, 843,
     /* 281043 */     GIR_EraseRootFromParent_Done,
     /* 281044 */   // Label 4583: @281044
     /* 281044 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(281100), // Rule ID 842 //
     /* 281049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 281052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 281056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 281063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 281070 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 281070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 281073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 281080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 281085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 281090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 281095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281098 */     GIR_RootConstrainSelectedInstOperands,
     /* 281099 */     // GIR_Coverage, 842,
     /* 281099 */     GIR_EraseRootFromParent_Done,
     /* 281100 */   // Label 4584: @281100
     /* 281100 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(281155), // Rule ID 841 //
     /* 281105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 281108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 281128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281136 */     // MIs[2] Operand 1
     /* 281136 */     // No operand predicates
     /* 281136 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 281140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281142 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 281142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 281145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281151 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281153 */     GIR_RootConstrainSelectedInstOperands,
     /* 281154 */     // GIR_Coverage, 841,
     /* 281154 */     GIR_EraseRootFromParent_Done,
     /* 281155 */   // Label 4585: @281155
     /* 281155 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(281210), // Rule ID 845 //
     /* 281160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 281163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 281183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281191 */     // MIs[2] Operand 1
     /* 281191 */     // No operand predicates
     /* 281191 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 281195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281197 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 281197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 281200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281208 */     GIR_RootConstrainSelectedInstOperands,
     /* 281209 */     // GIR_Coverage, 845,
     /* 281209 */     GIR_EraseRootFromParent_Done,
     /* 281210 */   // Label 4586: @281210
     /* 281210 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(281233), // Rule ID 840 //
     /* 281215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 281218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281222 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 281222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 281225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281227 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 281229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281231 */     GIR_RootConstrainSelectedInstOperands,
     /* 281232 */     // GIR_Coverage, 840,
     /* 281232 */     GIR_EraseRootFromParent_Done,
     /* 281233 */   // Label 4587: @281233
     /* 281233 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(281256), // Rule ID 844 //
     /* 281238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 281241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281245 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 281245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 281248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281250 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 281252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281254 */     GIR_RootConstrainSelectedInstOperands,
     /* 281255 */     // GIR_Coverage, 844,
     /* 281255 */     GIR_EraseRootFromParent_Done,
     /* 281256 */   // Label 4588: @281256
     /* 281256 */   GIM_Reject,
     /* 281257 */ // Label 4582: @281257
     /* 281257 */ GIM_Reject,
     /* 281258 */ // Label 4578: @281258
     /* 281258 */ GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(281898),
     /* 281263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 281269 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(281337), // Rule ID 7570 //
     /* 281274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 281302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281310 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 281314 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 281318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34950),
     /* 281322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281324 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34950>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 281324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /* 281327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 281333 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 281335 */     GIR_RootConstrainSelectedInstOperands,
     /* 281336 */     // GIR_Coverage, 7570,
     /* 281336 */     GIR_EraseRootFromParent_Done,
     /* 281337 */   // Label 4590: @281337
     /* 281337 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(281405), // Rule ID 7572 //
     /* 281342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 281370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281378 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 281382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 281386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34952),
     /* 281390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281392 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34952>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 281392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /* 281395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 281401 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 281403 */     GIR_RootConstrainSelectedInstOperands,
     /* 281404 */     // GIR_Coverage, 7572,
     /* 281404 */     GIR_EraseRootFromParent_Done,
     /* 281405 */   // Label 4591: @281405
     /* 281405 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(281500), // Rule ID 2592 //
     /* 281410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 281413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281433 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 281435 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 281439 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 281443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281459 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/2, // Name : pred:2:z
     /* 281463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281471 */     // MIs[3] Operand 1
     /* 281471 */     // No operand predicates
     /* 281471 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20778),
     /* 281479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281481 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20779>>, (and:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:2:z, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:2:Predicate_anonymous_20778>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 281481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 281484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 281494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 281498 */     GIR_RootConstrainSelectedInstOperands,
     /* 281499 */     // GIR_Coverage, 2592,
     /* 281499 */     GIR_EraseRootFromParent_Done,
     /* 281500 */   // Label 4592: @281500
     /* 281500 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(281568), // Rule ID 69 //
     /* 281505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281542 */     // MIs[2] Operand 1
     /* 281542 */     // No operand predicates
     /* 281542 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /* 281550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281552 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13755>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 281555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 281566 */     GIR_RootConstrainSelectedInstOperands,
     /* 281567 */     // GIR_Coverage, 69,
     /* 281567 */     GIR_EraseRootFromParent_Done,
     /* 281568 */   // Label 4593: @281568
     /* 281568 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(281624), // Rule ID 2491 //
     /* 281573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281601 */     // MIs[2] Operand 1
     /* 281601 */     // No operand predicates
     /* 281601 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /* 281609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281611 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19649>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 281611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281622 */     GIR_RootConstrainSelectedInstOperands,
     /* 281623 */     // GIR_Coverage, 2491,
     /* 281623 */     GIR_EraseRootFromParent_Done,
     /* 281624 */   // Label 4594: @281624
     /* 281624 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(281689), // Rule ID 2591 //
     /* 281629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 281632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281652 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 281654 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 281658 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 281662 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:2:z
     /* 281666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20778),
     /* 281670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281672 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20779>>, i32:{ *:[i32] }:$src2:$pred:2:z)<<P:2:Predicate_anonymous_20778>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 281672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 281675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 281685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 281687 */     GIR_RootConstrainSelectedInstOperands,
     /* 281688 */     // GIR_Coverage, 2591,
     /* 281688 */     GIR_EraseRootFromParent_Done,
     /* 281689 */   // Label 4595: @281689
     /* 281689 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(281723), // Rule ID 68 //
     /* 281694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /* 281710 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13755>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 281715 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 281721 */     GIR_RootConstrainSelectedInstOperands,
     /* 281722 */     // GIR_Coverage, 68,
     /* 281722 */     GIR_Done,
     /* 281723 */   // Label 4596: @281723
     /* 281723 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(281747), // Rule ID 2490 //
     /* 281728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /* 281736 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19649>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 281736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 281743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281745 */     GIR_RootConstrainSelectedInstOperands,
     /* 281746 */     // GIR_Coverage, 2490,
     /* 281746 */     GIR_EraseRootFromParent_Done,
     /* 281747 */   // Label 4597: @281747
     /* 281747 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(281799), // Rule ID 813 //
     /* 281752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281780 */     // MIs[2] Operand 1
     /* 281780 */     // No operand predicates
     /* 281780 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281786 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281797 */     GIR_RootConstrainSelectedInstOperands,
     /* 281798 */     // GIR_Coverage, 813,
     /* 281798 */     GIR_EraseRootFromParent_Done,
     /* 281799 */   // Label 4598: @281799
     /* 281799 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(281854), // Rule ID 839 //
     /* 281804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281835 */     // MIs[2] Operand 1
     /* 281835 */     // No operand predicates
     /* 281835 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281841 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 281844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281852 */     GIR_RootConstrainSelectedInstOperands,
     /* 281853 */     // GIR_Coverage, 839,
     /* 281853 */     GIR_EraseRootFromParent_Done,
     /* 281854 */   // Label 4599: @281854
     /* 281854 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(281874), // Rule ID 812 //
     /* 281859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281863 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 281870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281872 */     GIR_RootConstrainSelectedInstOperands,
     /* 281873 */     // GIR_Coverage, 812,
     /* 281873 */     GIR_EraseRootFromParent_Done,
     /* 281874 */   // Label 4600: @281874
     /* 281874 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(281897), // Rule ID 838 //
     /* 281879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281886 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 281891 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 281895 */     GIR_RootConstrainSelectedInstOperands,
     /* 281896 */     // GIR_Coverage, 838,
     /* 281896 */     GIR_Done,
     /* 281897 */   // Label 4601: @281897
     /* 281897 */   GIM_Reject,
     /* 281898 */ // Label 4589: @281898
     /* 281898 */ GIM_Reject,
     /* 281899 */ // Label 4579: @281899
     /* 281899 */ GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(282285),
     /* 281904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 281910 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(281978), // Rule ID 71 //
     /* 281915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281952 */     // MIs[2] Operand 1
     /* 281952 */     // No operand predicates
     /* 281952 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 281956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13756),
     /* 281960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281962 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13756>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 281965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 281976 */     GIR_RootConstrainSelectedInstOperands,
     /* 281977 */     // GIR_Coverage, 71,
     /* 281977 */     GIR_EraseRootFromParent_Done,
     /* 281978 */   // Label 4603: @281978
     /* 281978 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(282012), // Rule ID 70 //
     /* 281983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13756),
     /* 281999 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13756>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 282004 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 282010 */     GIR_RootConstrainSelectedInstOperands,
     /* 282011 */     // GIR_Coverage, 70,
     /* 282011 */     GIR_Done,
     /* 282012 */   // Label 4604: @282012
     /* 282012 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(282077), // Rule ID 984 //
     /* 282017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 282020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282048 */     // MIs[2] Operand 1
     /* 282048 */     // No operand predicates
     /* 282048 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 282052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 282061 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 282064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 282071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282075 */     GIR_RootConstrainSelectedInstOperands,
     /* 282076 */     // GIR_Coverage, 984,
     /* 282076 */     GIR_EraseRootFromParent_Done,
     /* 282077 */   // Label 4605: @282077
     /* 282077 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(282140), // Rule ID 994 //
     /* 282082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 282085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282113 */     // MIs[2] Operand 1
     /* 282113 */     // No operand predicates
     /* 282113 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 282117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 282126 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 282126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 282129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 282136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282138 */     GIR_RootConstrainSelectedInstOperands,
     /* 282139 */     // GIR_Coverage, 994,
     /* 282139 */     GIR_EraseRootFromParent_Done,
     /* 282140 */   // Label 4606: @282140
     /* 282140 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(282173), // Rule ID 983 //
     /* 282145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 282148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 282159 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 282162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 282169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 282171 */     GIR_RootConstrainSelectedInstOperands,
     /* 282172 */     // GIR_Coverage, 983,
     /* 282172 */     GIR_EraseRootFromParent_Done,
     /* 282173 */   // Label 4607: @282173
     /* 282173 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(282206), // Rule ID 993 //
     /* 282178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 282181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 282192 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 282192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 282195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 282202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282204 */     GIR_RootConstrainSelectedInstOperands,
     /* 282205 */     // GIR_Coverage, 993,
     /* 282205 */     GIR_EraseRootFromParent_Done,
     /* 282206 */   // Label 4608: @282206
     /* 282206 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(282261), // Rule ID 920 //
     /* 282211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 282214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282242 */     // MIs[2] Operand 1
     /* 282242 */     // No operand predicates
     /* 282242 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 282246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282248 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 282248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 282251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282259 */     GIR_RootConstrainSelectedInstOperands,
     /* 282260 */     // GIR_Coverage, 920,
     /* 282260 */     GIR_EraseRootFromParent_Done,
     /* 282261 */   // Label 4609: @282261
     /* 282261 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(282284), // Rule ID 919 //
     /* 282266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 282269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282273 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 282273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 282276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282280 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282282 */     GIR_RootConstrainSelectedInstOperands,
     /* 282283 */     // GIR_Coverage, 919,
     /* 282283 */     GIR_EraseRootFromParent_Done,
     /* 282284 */   // Label 4610: @282284
     /* 282284 */   GIM_Reject,
     /* 282285 */ // Label 4602: @282285
     /* 282285 */ GIM_Reject,
     /* 282286 */ // Label 4580: @282286
     /* 282286 */ GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(282454),
     /* 282291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 282294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 282297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282301 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(282392), // Rule ID 1108 //
     /* 282306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 282318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 282322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282330 */     // MIs[2] Operand 1
     /* 282330 */     // No operand predicates
     /* 282330 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282350 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 282350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 282353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282390 */     GIR_RootConstrainSelectedInstOperands,
     /* 282391 */     // GIR_Coverage, 1108,
     /* 282391 */     GIR_EraseRootFromParent_Done,
     /* 282392 */   // Label 4612: @282392
     /* 282392 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(282453), // Rule ID 1107 //
     /* 282397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282411 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 282411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 282414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282451 */     GIR_RootConstrainSelectedInstOperands,
     /* 282452 */     // GIR_Coverage, 1107,
     /* 282452 */     GIR_EraseRootFromParent_Done,
     /* 282453 */   // Label 4613: @282453
     /* 282453 */   GIM_Reject,
     /* 282454 */ // Label 4611: @282454
     /* 282454 */ GIM_Reject,
     /* 282455 */ // Label 4581: @282455
     /* 282455 */ GIM_Reject,
     /* 282456 */ // Label 47: @282456
     /* 282456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4618*/ GIMT_Encode4(283617),
     /* 282467 */ /*GILLT_s16*//*Label 4614*/ GIMT_Encode4(282483),
     /* 282471 */ /*GILLT_s32*//*Label 4615*/ GIMT_Encode4(282794),
     /* 282475 */ /*GILLT_s64*//*Label 4616*/ GIMT_Encode4(283139),
     /* 282479 */ /*GILLT_v2s16*//*Label 4617*/ GIMT_Encode4(283448),
     /* 282483 */ // Label 4614: @282483
     /* 282483 */ GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(282793),
     /* 282488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 282494 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(282580), // Rule ID 849 //
     /* 282499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 282502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 282506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282530 */     // MIs[2] Operand 1
     /* 282530 */     // No operand predicates
     /* 282530 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282550 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 282550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 282553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282578 */     GIR_RootConstrainSelectedInstOperands,
     /* 282579 */     // GIR_Coverage, 849,
     /* 282579 */     GIR_EraseRootFromParent_Done,
     /* 282580 */   // Label 4620: @282580
     /* 282580 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(282636), // Rule ID 848 //
     /* 282585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 282588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 282592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282606 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 282606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 282609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282634 */     GIR_RootConstrainSelectedInstOperands,
     /* 282635 */     // GIR_Coverage, 848,
     /* 282635 */     GIR_EraseRootFromParent_Done,
     /* 282636 */   // Label 4621: @282636
     /* 282636 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(282691), // Rule ID 847 //
     /* 282641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 282644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282672 */     // MIs[2] Operand 1
     /* 282672 */     // No operand predicates
     /* 282672 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282678 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 282681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282689 */     GIR_RootConstrainSelectedInstOperands,
     /* 282690 */     // GIR_Coverage, 847,
     /* 282690 */     GIR_EraseRootFromParent_Done,
     /* 282691 */   // Label 4622: @282691
     /* 282691 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(282746), // Rule ID 851 //
     /* 282696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 282699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282727 */     // MIs[2] Operand 1
     /* 282727 */     // No operand predicates
     /* 282727 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282733 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 282736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282744 */     GIR_RootConstrainSelectedInstOperands,
     /* 282745 */     // GIR_Coverage, 851,
     /* 282745 */     GIR_EraseRootFromParent_Done,
     /* 282746 */   // Label 4623: @282746
     /* 282746 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(282769), // Rule ID 846 //
     /* 282751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 282754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282758 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 282761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282767 */     GIR_RootConstrainSelectedInstOperands,
     /* 282768 */     // GIR_Coverage, 846,
     /* 282768 */     GIR_EraseRootFromParent_Done,
     /* 282769 */   // Label 4624: @282769
     /* 282769 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(282792), // Rule ID 850 //
     /* 282774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 282777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282781 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 282784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282790 */     GIR_RootConstrainSelectedInstOperands,
     /* 282791 */     // GIR_Coverage, 850,
     /* 282791 */     GIR_EraseRootFromParent_Done,
     /* 282792 */   // Label 4625: @282792
     /* 282792 */   GIM_Reject,
     /* 282793 */ // Label 4619: @282793
     /* 282793 */ GIM_Reject,
     /* 282794 */ // Label 4615: @282794
     /* 282794 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(283138),
     /* 282799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282805 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(282873), // Rule ID 73 //
     /* 282810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282847 */     // MIs[2] Operand 1
     /* 282847 */     // No operand predicates
     /* 282847 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13757),
     /* 282855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282857 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13757>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 282860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 282862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 282871 */     GIR_RootConstrainSelectedInstOperands,
     /* 282872 */     // GIR_Coverage, 73,
     /* 282872 */     GIR_EraseRootFromParent_Done,
     /* 282873 */   // Label 4627: @282873
     /* 282873 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(282929), // Rule ID 2487 //
     /* 282878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282906 */     // MIs[2] Operand 1
     /* 282906 */     // No operand predicates
     /* 282906 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19645),
     /* 282914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282916 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19645>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 282916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282927 */     GIR_RootConstrainSelectedInstOperands,
     /* 282928 */     // GIR_Coverage, 2487,
     /* 282928 */     GIR_EraseRootFromParent_Done,
     /* 282929 */   // Label 4628: @282929
     /* 282929 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(282963), // Rule ID 72 //
     /* 282934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13757),
     /* 282950 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13757>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 282955 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 282961 */     GIR_RootConstrainSelectedInstOperands,
     /* 282962 */     // GIR_Coverage, 72,
     /* 282962 */     GIR_Done,
     /* 282963 */   // Label 4629: @282963
     /* 282963 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(282987), // Rule ID 2486 //
     /* 282968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19645),
     /* 282976 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19645>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 282976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 282983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282985 */     GIR_RootConstrainSelectedInstOperands,
     /* 282986 */     // GIR_Coverage, 2486,
     /* 282986 */     GIR_EraseRootFromParent_Done,
     /* 282987 */   // Label 4630: @282987
     /* 282987 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(283039), // Rule ID 809 //
     /* 282992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283020 */     // MIs[2] Operand 1
     /* 283020 */     // No operand predicates
     /* 283020 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283026 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 283029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283037 */     GIR_RootConstrainSelectedInstOperands,
     /* 283038 */     // GIR_Coverage, 809,
     /* 283038 */     GIR_EraseRootFromParent_Done,
     /* 283039 */   // Label 4631: @283039
     /* 283039 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(283094), // Rule ID 835 //
     /* 283044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283075 */     // MIs[2] Operand 1
     /* 283075 */     // No operand predicates
     /* 283075 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283081 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 283084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283086 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283092 */     GIR_RootConstrainSelectedInstOperands,
     /* 283093 */     // GIR_Coverage, 835,
     /* 283093 */     GIR_EraseRootFromParent_Done,
     /* 283094 */   // Label 4632: @283094
     /* 283094 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(283114), // Rule ID 808 //
     /* 283099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283103 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 283106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283112 */     GIR_RootConstrainSelectedInstOperands,
     /* 283113 */     // GIR_Coverage, 808,
     /* 283113 */     GIR_EraseRootFromParent_Done,
     /* 283114 */   // Label 4633: @283114
     /* 283114 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(283137), // Rule ID 834 //
     /* 283119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283126 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 283131 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 283135 */     GIR_RootConstrainSelectedInstOperands,
     /* 283136 */     // GIR_Coverage, 834,
     /* 283136 */     GIR_Done,
     /* 283137 */   // Label 4634: @283137
     /* 283137 */   GIM_Reject,
     /* 283138 */ // Label 4626: @283138
     /* 283138 */ GIM_Reject,
     /* 283139 */ // Label 4616: @283139
     /* 283139 */ GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(283447),
     /* 283144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283150 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(283218), // Rule ID 75 //
     /* 283155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 283159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 283163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283192 */     // MIs[2] Operand 1
     /* 283192 */     // No operand predicates
     /* 283192 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 283196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13758),
     /* 283200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283202 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13758>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 283202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 283205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 283207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 283216 */     GIR_RootConstrainSelectedInstOperands,
     /* 283217 */     // GIR_Coverage, 75,
     /* 283217 */     GIR_EraseRootFromParent_Done,
     /* 283218 */   // Label 4636: @283218
     /* 283218 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(283252), // Rule ID 74 //
     /* 283223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 283227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 283231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13758),
     /* 283239 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13758>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 283239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 283244 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 283250 */     GIR_RootConstrainSelectedInstOperands,
     /* 283251 */     // GIR_Coverage, 74,
     /* 283251 */     GIR_Done,
     /* 283252 */   // Label 4637: @283252
     /* 283252 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(283317), // Rule ID 986 //
     /* 283257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283288 */     // MIs[2] Operand 1
     /* 283288 */     // No operand predicates
     /* 283288 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 283292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283301 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 283304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283315 */     GIR_RootConstrainSelectedInstOperands,
     /* 283316 */     // GIR_Coverage, 986,
     /* 283316 */     GIR_EraseRootFromParent_Done,
     /* 283317 */   // Label 4638: @283317
     /* 283317 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(283380), // Rule ID 990 //
     /* 283322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 283325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283353 */     // MIs[2] Operand 1
     /* 283353 */     // No operand predicates
     /* 283353 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 283357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283366 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 283366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 283369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283378 */     GIR_RootConstrainSelectedInstOperands,
     /* 283379 */     // GIR_Coverage, 990,
     /* 283379 */     GIR_EraseRootFromParent_Done,
     /* 283380 */   // Label 4639: @283380
     /* 283380 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(283413), // Rule ID 985 //
     /* 283385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283399 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 283402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 283411 */     GIR_RootConstrainSelectedInstOperands,
     /* 283412 */     // GIR_Coverage, 985,
     /* 283412 */     GIR_EraseRootFromParent_Done,
     /* 283413 */   // Label 4640: @283413
     /* 283413 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(283446), // Rule ID 989 //
     /* 283418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 283421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283432 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 283432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 283435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283444 */     GIR_RootConstrainSelectedInstOperands,
     /* 283445 */     // GIR_Coverage, 989,
     /* 283445 */     GIR_EraseRootFromParent_Done,
     /* 283446 */   // Label 4641: @283446
     /* 283446 */   GIM_Reject,
     /* 283447 */ // Label 4635: @283447
     /* 283447 */ GIM_Reject,
     /* 283448 */ // Label 4617: @283448
     /* 283448 */ GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(283616),
     /* 283453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 283456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 283459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283463 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(283554), // Rule ID 1112 //
     /* 283468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 283480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 283484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283492 */     // MIs[2] Operand 1
     /* 283492 */     // No operand predicates
     /* 283492 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283512 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 283512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 283515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283552 */     GIR_RootConstrainSelectedInstOperands,
     /* 283553 */     // GIR_Coverage, 1112,
     /* 283553 */     GIR_EraseRootFromParent_Done,
     /* 283554 */   // Label 4643: @283554
     /* 283554 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(283615), // Rule ID 1111 //
     /* 283559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283573 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 283573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 283576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283613 */     GIR_RootConstrainSelectedInstOperands,
     /* 283614 */     // GIR_Coverage, 1111,
     /* 283614 */     GIR_EraseRootFromParent_Done,
     /* 283615 */   // Label 4644: @283615
     /* 283615 */   GIM_Reject,
     /* 283616 */ // Label 4642: @283616
     /* 283616 */ GIM_Reject,
     /* 283617 */ // Label 4618: @283617
     /* 283617 */ GIM_Reject,
     /* 283618 */ // Label 48: @283618
     /* 283618 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4649*/ GIMT_Encode4(284779),
     /* 283629 */ /*GILLT_s16*//*Label 4645*/ GIMT_Encode4(283645),
     /* 283633 */ /*GILLT_s32*//*Label 4646*/ GIMT_Encode4(283956),
     /* 283637 */ /*GILLT_s64*//*Label 4647*/ GIMT_Encode4(284301),
     /* 283641 */ /*GILLT_v2s16*//*Label 4648*/ GIMT_Encode4(284610),
     /* 283645 */ // Label 4645: @283645
     /* 283645 */ GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(283955),
     /* 283650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283656 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(283742), // Rule ID 855 //
     /* 283661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 283664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 283668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283692 */     // MIs[2] Operand 1
     /* 283692 */     // No operand predicates
     /* 283692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283712 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 283712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 283715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283740 */     GIR_RootConstrainSelectedInstOperands,
     /* 283741 */     // GIR_Coverage, 855,
     /* 283741 */     GIR_EraseRootFromParent_Done,
     /* 283742 */   // Label 4651: @283742
     /* 283742 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(283798), // Rule ID 854 //
     /* 283747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 283750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 283754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283768 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 283768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 283771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283796 */     GIR_RootConstrainSelectedInstOperands,
     /* 283797 */     // GIR_Coverage, 854,
     /* 283797 */     GIR_EraseRootFromParent_Done,
     /* 283798 */   // Label 4652: @283798
     /* 283798 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(283853), // Rule ID 853 //
     /* 283803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 283806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283834 */     // MIs[2] Operand 1
     /* 283834 */     // No operand predicates
     /* 283834 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283840 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283851 */     GIR_RootConstrainSelectedInstOperands,
     /* 283852 */     // GIR_Coverage, 853,
     /* 283852 */     GIR_EraseRootFromParent_Done,
     /* 283853 */   // Label 4653: @283853
     /* 283853 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(283908), // Rule ID 857 //
     /* 283858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 283861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283889 */     // MIs[2] Operand 1
     /* 283889 */     // No operand predicates
     /* 283889 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283895 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 283898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283906 */     GIR_RootConstrainSelectedInstOperands,
     /* 283907 */     // GIR_Coverage, 857,
     /* 283907 */     GIR_EraseRootFromParent_Done,
     /* 283908 */   // Label 4654: @283908
     /* 283908 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(283931), // Rule ID 852 //
     /* 283913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 283916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283920 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283929 */     GIR_RootConstrainSelectedInstOperands,
     /* 283930 */     // GIR_Coverage, 852,
     /* 283930 */     GIR_EraseRootFromParent_Done,
     /* 283931 */   // Label 4655: @283931
     /* 283931 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(283954), // Rule ID 856 //
     /* 283936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 283939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283943 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 283946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283952 */     GIR_RootConstrainSelectedInstOperands,
     /* 283953 */     // GIR_Coverage, 856,
     /* 283953 */     GIR_EraseRootFromParent_Done,
     /* 283954 */   // Label 4656: @283954
     /* 283954 */   GIM_Reject,
     /* 283955 */ // Label 4650: @283955
     /* 283955 */ GIM_Reject,
     /* 283956 */ // Label 4646: @283956
     /* 283956 */ GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(284300),
     /* 283961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283967 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(284035), // Rule ID 77 //
     /* 283972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284009 */     // MIs[2] Operand 1
     /* 284009 */     // No operand predicates
     /* 284009 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 284013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13759),
     /* 284017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284019 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13759>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 284022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 284024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 284033 */     GIR_RootConstrainSelectedInstOperands,
     /* 284034 */     // GIR_Coverage, 77,
     /* 284034 */     GIR_EraseRootFromParent_Done,
     /* 284035 */   // Label 4658: @284035
     /* 284035 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(284091), // Rule ID 2489 //
     /* 284040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284068 */     // MIs[2] Operand 1
     /* 284068 */     // No operand predicates
     /* 284068 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 284072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /* 284076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284078 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19647>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 284078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 284081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284089 */     GIR_RootConstrainSelectedInstOperands,
     /* 284090 */     // GIR_Coverage, 2489,
     /* 284090 */     GIR_EraseRootFromParent_Done,
     /* 284091 */   // Label 4659: @284091
     /* 284091 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(284125), // Rule ID 76 //
     /* 284096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13759),
     /* 284112 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13759>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 284117 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 284123 */     GIR_RootConstrainSelectedInstOperands,
     /* 284124 */     // GIR_Coverage, 76,
     /* 284124 */     GIR_Done,
     /* 284125 */   // Label 4660: @284125
     /* 284125 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(284149), // Rule ID 2488 //
     /* 284130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /* 284138 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19647>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 284138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 284141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284147 */     GIR_RootConstrainSelectedInstOperands,
     /* 284148 */     // GIR_Coverage, 2488,
     /* 284148 */     GIR_EraseRootFromParent_Done,
     /* 284149 */   // Label 4661: @284149
     /* 284149 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(284201), // Rule ID 811 //
     /* 284154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284182 */     // MIs[2] Operand 1
     /* 284182 */     // No operand predicates
     /* 284182 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 284186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284188 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 284191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284199 */     GIR_RootConstrainSelectedInstOperands,
     /* 284200 */     // GIR_Coverage, 811,
     /* 284200 */     GIR_EraseRootFromParent_Done,
     /* 284201 */   // Label 4662: @284201
     /* 284201 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(284256), // Rule ID 837 //
     /* 284206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284237 */     // MIs[2] Operand 1
     /* 284237 */     // No operand predicates
     /* 284237 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 284241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284243 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 284246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284254 */     GIR_RootConstrainSelectedInstOperands,
     /* 284255 */     // GIR_Coverage, 837,
     /* 284255 */     GIR_EraseRootFromParent_Done,
     /* 284256 */   // Label 4663: @284256
     /* 284256 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(284276), // Rule ID 810 //
     /* 284261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284265 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 284268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 284272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284274 */     GIR_RootConstrainSelectedInstOperands,
     /* 284275 */     // GIR_Coverage, 810,
     /* 284275 */     GIR_EraseRootFromParent_Done,
     /* 284276 */   // Label 4664: @284276
     /* 284276 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(284299), // Rule ID 836 //
     /* 284281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284288 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 284293 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 284297 */     GIR_RootConstrainSelectedInstOperands,
     /* 284298 */     // GIR_Coverage, 836,
     /* 284298 */     GIR_Done,
     /* 284299 */   // Label 4665: @284299
     /* 284299 */   GIM_Reject,
     /* 284300 */ // Label 4657: @284300
     /* 284300 */ GIM_Reject,
     /* 284301 */ // Label 4647: @284301
     /* 284301 */ GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(284609),
     /* 284306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284312 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(284380), // Rule ID 79 //
     /* 284317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284354 */     // MIs[2] Operand 1
     /* 284354 */     // No operand predicates
     /* 284354 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 284362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284364 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13760>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 284367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 284369 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 284378 */     GIR_RootConstrainSelectedInstOperands,
     /* 284379 */     // GIR_Coverage, 79,
     /* 284379 */     GIR_EraseRootFromParent_Done,
     /* 284380 */   // Label 4667: @284380
     /* 284380 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(284414), // Rule ID 78 //
     /* 284385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 284401 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13760>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 284406 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 284412 */     GIR_RootConstrainSelectedInstOperands,
     /* 284413 */     // GIR_Coverage, 78,
     /* 284413 */     GIR_Done,
     /* 284414 */   // Label 4668: @284414
     /* 284414 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(284479), // Rule ID 988 //
     /* 284419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284450 */     // MIs[2] Operand 1
     /* 284450 */     // No operand predicates
     /* 284450 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284463 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 284466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284477 */     GIR_RootConstrainSelectedInstOperands,
     /* 284478 */     // GIR_Coverage, 988,
     /* 284478 */     GIR_EraseRootFromParent_Done,
     /* 284479 */   // Label 4669: @284479
     /* 284479 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(284542), // Rule ID 992 //
     /* 284484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 284487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284515 */     // MIs[2] Operand 1
     /* 284515 */     // No operand predicates
     /* 284515 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284528 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 284528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 284531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284538 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284540 */     GIR_RootConstrainSelectedInstOperands,
     /* 284541 */     // GIR_Coverage, 992,
     /* 284541 */     GIR_EraseRootFromParent_Done,
     /* 284542 */   // Label 4670: @284542
     /* 284542 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(284575), // Rule ID 987 //
     /* 284547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284561 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 284564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284573 */     GIR_RootConstrainSelectedInstOperands,
     /* 284574 */     // GIR_Coverage, 987,
     /* 284574 */     GIR_EraseRootFromParent_Done,
     /* 284575 */   // Label 4671: @284575
     /* 284575 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(284608), // Rule ID 991 //
     /* 284580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 284583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284594 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 284594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 284597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284606 */     GIR_RootConstrainSelectedInstOperands,
     /* 284607 */     // GIR_Coverage, 991,
     /* 284607 */     GIR_EraseRootFromParent_Done,
     /* 284608 */   // Label 4672: @284608
     /* 284608 */   GIM_Reject,
     /* 284609 */ // Label 4666: @284609
     /* 284609 */ GIM_Reject,
     /* 284610 */ // Label 4648: @284610
     /* 284610 */ GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(284778),
     /* 284615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 284618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 284621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284625 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(284716), // Rule ID 1110 //
     /* 284630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 284642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 284646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284654 */     // MIs[2] Operand 1
     /* 284654 */     // No operand predicates
     /* 284654 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 284658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284674 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 284674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 284677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 284684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 284689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 284694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 284699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284714 */     GIR_RootConstrainSelectedInstOperands,
     /* 284715 */     // GIR_Coverage, 1110,
     /* 284715 */     GIR_EraseRootFromParent_Done,
     /* 284716 */   // Label 4674: @284716
     /* 284716 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(284777), // Rule ID 1109 //
     /* 284721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284735 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 284735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 284738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 284745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 284750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 284755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 284760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284775 */     GIR_RootConstrainSelectedInstOperands,
     /* 284776 */     // GIR_Coverage, 1109,
     /* 284776 */     GIR_EraseRootFromParent_Done,
     /* 284777 */   // Label 4675: @284777
     /* 284777 */   GIM_Reject,
     /* 284778 */ // Label 4673: @284778
     /* 284778 */ GIM_Reject,
     /* 284779 */ // Label 4649: @284779
     /* 284779 */ GIM_Reject,
     /* 284780 */ // Label 49: @284780
     /* 284780 */ GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(285041),
     /* 284785 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 284788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284794 */   GIM_SwitchType, /*MI*/0, /*Op*/3, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4679*/ GIMT_Encode4(285002),
     /* 284805 */   /*GILLT_s16*//*Label 4677*/ GIMT_Encode4(284813),
     /* 284809 */   /*GILLT_s32*//*Label 4678*/ GIMT_Encode4(284890),
     /* 284813 */   // Label 4677: @284813
     /* 284813 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(284889), // Rule ID 961 //
     /* 284818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 284821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284846 */     // (fshr:{ *:[i32] } (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 284846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 284849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 284856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 284866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 284871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 284876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 284881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284887 */     GIR_RootConstrainSelectedInstOperands,
     /* 284888 */     // GIR_Coverage, 961,
     /* 284888 */     GIR_EraseRootFromParent_Done,
     /* 284889 */   // Label 4680: @284889
     /* 284889 */   GIM_Reject,
     /* 284890 */   // Label 4678: @284890
     /* 284890 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(285001),
     /* 284895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284899 */     GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(284964), // Rule ID 7340 //
     /* 284904 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 284907 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_t16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 284907 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284910 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284914 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284919 */       GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 284925 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 284930 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284935 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_t16_e64),
     /* 284938 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284940 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284943 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284945 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284948 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284950 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284953 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284956 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284959 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284962 */       GIR_RootConstrainSelectedInstOperands,
     /* 284963 */       // GIR_Coverage, 7340,
     /* 284963 */       GIR_EraseRootFromParent_Done,
     /* 284964 */     // Label 4682: @284964
     /* 284964 */     GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(285000), // Rule ID 7344 //
     /* 284969 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 284972 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 284972 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 284975 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284977 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284980 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284982 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284985 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284987 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284990 */       GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 284992 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284995 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284998 */       GIR_RootConstrainSelectedInstOperands,
     /* 284999 */       // GIR_Coverage, 7344,
     /* 284999 */       GIR_EraseRootFromParent_Done,
     /* 285000 */     // Label 4683: @285000
     /* 285000 */     GIM_Reject,
     /* 285001 */   // Label 4681: @285001
     /* 285001 */   GIM_Reject,
     /* 285002 */   // Label 4679: @285002
     /* 285002 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(285040), // Rule ID 960 //
     /* 285007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 285010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 285013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285024 */     // (fshr:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 285024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 285027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 285036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 285038 */     GIR_RootConstrainSelectedInstOperands,
     /* 285039 */     // GIR_Coverage, 960,
     /* 285039 */     GIR_EraseRootFromParent_Done,
     /* 285040 */   // Label 4684: @285040
     /* 285040 */   GIM_Reject,
     /* 285041 */ // Label 4676: @285041
     /* 285041 */ GIM_Reject,
     /* 285042 */ // Label 50: @285042
     /* 285042 */ GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(285118),
     /* 285047 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 285050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285060 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(285081), // Rule ID 7335 //
     /* 285065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 285068 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /* 285068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 285071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285077 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 285079 */     GIR_RootConstrainSelectedInstOperands,
     /* 285080 */     // GIR_Coverage, 7335,
     /* 285080 */     GIR_EraseRootFromParent_Done,
     /* 285081 */   // Label 4686: @285081
     /* 285081 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(285117), // Rule ID 7341 //
     /* 285086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 285089 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 285089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 285092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 285109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285115 */     GIR_RootConstrainSelectedInstOperands,
     /* 285116 */     // GIR_Coverage, 7341,
     /* 285116 */     GIR_EraseRootFromParent_Done,
     /* 285117 */   // Label 4687: @285117
     /* 285117 */   GIM_Reject,
     /* 285118 */ // Label 4685: @285118
     /* 285118 */ GIM_Reject,
     /* 285119 */ // Label 51: @285119
     /* 285119 */ GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(286710),
     /* 285124 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 285127 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4692*/ GIMT_Encode4(286410),
     /* 285138 */   /*GILLT_s16*//*Label 4689*/ GIMT_Encode4(285150),
     /* 285142 */   /*GILLT_s32*//*Label 4690*/ GIMT_Encode4(286214),
     /* 285146 */   /*GILLT_s64*//*Label 4691*/ GIMT_Encode4(286312),
     /* 285150 */   // Label 4689: @285150
     /* 285150 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(286213),
     /* 285155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 285158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 285162 */     GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(285219), // Rule ID 460 //
     /* 285167 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285170 */       // MIs[0] Operand 1
     /* 285170 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285175 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285182 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285189 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285189 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_t16_e64),
     /* 285192 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285194 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285199 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285204 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285209 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285214 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285217 */       GIR_RootConstrainSelectedInstOperands,
     /* 285218 */       // GIR_Coverage, 460,
     /* 285218 */       GIR_EraseRootFromParent_Done,
     /* 285219 */     // Label 4694: @285219
     /* 285219 */     GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(285276), // Rule ID 466 //
     /* 285224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285227 */       // MIs[0] Operand 1
     /* 285227 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285232 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285239 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285246 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285246 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_t16_e64),
     /* 285249 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285251 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285256 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285261 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285266 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285271 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285274 */       GIR_RootConstrainSelectedInstOperands,
     /* 285275 */       // GIR_Coverage, 466,
     /* 285275 */       GIR_EraseRootFromParent_Done,
     /* 285276 */     // Label 4695: @285276
     /* 285276 */     GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(285333), // Rule ID 469 //
     /* 285281 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285284 */       // MIs[0] Operand 1
     /* 285284 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285289 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285296 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285303 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285303 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_t16_e64),
     /* 285306 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285308 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285313 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285318 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285323 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285328 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285331 */       GIR_RootConstrainSelectedInstOperands,
     /* 285332 */       // GIR_Coverage, 469,
     /* 285332 */       GIR_EraseRootFromParent_Done,
     /* 285333 */     // Label 4696: @285333
     /* 285333 */     GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(285390), // Rule ID 475 //
     /* 285338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285341 */       // MIs[0] Operand 1
     /* 285341 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285346 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285353 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285360 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285360 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_t16_e64),
     /* 285363 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285365 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285370 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285375 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285380 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285385 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285388 */       GIR_RootConstrainSelectedInstOperands,
     /* 285389 */       // GIR_Coverage, 475,
     /* 285389 */       GIR_EraseRootFromParent_Done,
     /* 285390 */     // Label 4697: @285390
     /* 285390 */     GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(285447), // Rule ID 484 //
     /* 285395 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285398 */       // MIs[0] Operand 1
     /* 285398 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285403 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285410 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285417 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285417 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_t16_e64),
     /* 285420 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285422 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285427 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285432 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285437 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285442 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285445 */       GIR_RootConstrainSelectedInstOperands,
     /* 285446 */       // GIR_Coverage, 484,
     /* 285446 */       GIR_EraseRootFromParent_Done,
     /* 285447 */     // Label 4698: @285447
     /* 285447 */     GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(285504), // Rule ID 488 //
     /* 285452 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285455 */       // MIs[0] Operand 1
     /* 285455 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 285460 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285467 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285474 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_t16_e64),
     /* 285477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285479 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285484 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285489 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285494 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285499 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285502 */       GIR_RootConstrainSelectedInstOperands,
     /* 285503 */       // GIR_Coverage, 488,
     /* 285503 */       GIR_EraseRootFromParent_Done,
     /* 285504 */     // Label 4699: @285504
     /* 285504 */     GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(285561), // Rule ID 493 //
     /* 285509 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285512 */       // MIs[0] Operand 1
     /* 285512 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 285517 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285524 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285531 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_t16_e64),
     /* 285534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285536 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285541 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285546 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285551 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285556 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285559 */       GIR_RootConstrainSelectedInstOperands,
     /* 285560 */       // GIR_Coverage, 493,
     /* 285560 */       GIR_EraseRootFromParent_Done,
     /* 285561 */     // Label 4700: @285561
     /* 285561 */     GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(285618), // Rule ID 496 //
     /* 285566 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285569 */       // MIs[0] Operand 1
     /* 285569 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 285574 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285581 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285588 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285588 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_t16_e64),
     /* 285591 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285598 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285603 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285608 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285613 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285616 */       GIR_RootConstrainSelectedInstOperands,
     /* 285617 */       // GIR_Coverage, 496,
     /* 285617 */       GIR_EraseRootFromParent_Done,
     /* 285618 */     // Label 4701: @285618
     /* 285618 */     GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(285675), // Rule ID 500 //
     /* 285623 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285626 */       // MIs[0] Operand 1
     /* 285626 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 285631 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285638 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285645 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285645 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_t16_e64),
     /* 285648 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285655 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285660 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285665 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285670 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285673 */       GIR_RootConstrainSelectedInstOperands,
     /* 285674 */       // GIR_Coverage, 500,
     /* 285674 */       GIR_EraseRootFromParent_Done,
     /* 285675 */     // Label 4702: @285675
     /* 285675 */     GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(285732), // Rule ID 505 //
     /* 285680 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285683 */       // MIs[0] Operand 1
     /* 285683 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 285688 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285695 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285702 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_t16_e64),
     /* 285705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285712 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285717 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285722 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285727 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285730 */       GIR_RootConstrainSelectedInstOperands,
     /* 285731 */       // GIR_Coverage, 505,
     /* 285731 */       GIR_EraseRootFromParent_Done,
     /* 285732 */     // Label 4703: @285732
     /* 285732 */     GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(285756), // Rule ID 459 //
     /* 285737 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285740 */       // MIs[0] Operand 1
     /* 285740 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285745 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_e64),
     /* 285748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285750 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285752 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285754 */       GIR_RootConstrainSelectedInstOperands,
     /* 285755 */       // GIR_Coverage, 459,
     /* 285755 */       GIR_EraseRootFromParent_Done,
     /* 285756 */     // Label 4704: @285756
     /* 285756 */     GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(285780), // Rule ID 461 //
     /* 285761 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285764 */       // MIs[0] Operand 1
     /* 285764 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285769 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_fake16_e64),
     /* 285772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285774 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285776 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285778 */       GIR_RootConstrainSelectedInstOperands,
     /* 285779 */       // GIR_Coverage, 461,
     /* 285779 */       GIR_EraseRootFromParent_Done,
     /* 285780 */     // Label 4705: @285780
     /* 285780 */     GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(285804), // Rule ID 465 //
     /* 285785 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285788 */       // MIs[0] Operand 1
     /* 285788 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285793 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285793 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_e64),
     /* 285796 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285798 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285800 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285802 */       GIR_RootConstrainSelectedInstOperands,
     /* 285803 */       // GIR_Coverage, 465,
     /* 285803 */       GIR_EraseRootFromParent_Done,
     /* 285804 */     // Label 4706: @285804
     /* 285804 */     GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(285828), // Rule ID 467 //
     /* 285809 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285812 */       // MIs[0] Operand 1
     /* 285812 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285817 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285817 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_fake16_e64),
     /* 285820 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285822 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285824 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285826 */       GIR_RootConstrainSelectedInstOperands,
     /* 285827 */       // GIR_Coverage, 467,
     /* 285827 */       GIR_EraseRootFromParent_Done,
     /* 285828 */     // Label 4707: @285828
     /* 285828 */     GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(285852), // Rule ID 468 //
     /* 285833 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285836 */       // MIs[0] Operand 1
     /* 285836 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285841 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285841 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_e64),
     /* 285844 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285846 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285848 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285850 */       GIR_RootConstrainSelectedInstOperands,
     /* 285851 */       // GIR_Coverage, 468,
     /* 285851 */       GIR_EraseRootFromParent_Done,
     /* 285852 */     // Label 4708: @285852
     /* 285852 */     GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(285876), // Rule ID 470 //
     /* 285857 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285860 */       // MIs[0] Operand 1
     /* 285860 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285865 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_fake16_e64),
     /* 285868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285870 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285872 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285874 */       GIR_RootConstrainSelectedInstOperands,
     /* 285875 */       // GIR_Coverage, 470,
     /* 285875 */       GIR_EraseRootFromParent_Done,
     /* 285876 */     // Label 4709: @285876
     /* 285876 */     GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(285900), // Rule ID 474 //
     /* 285881 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285884 */       // MIs[0] Operand 1
     /* 285884 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285889 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_e64),
     /* 285892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285894 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285896 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285898 */       GIR_RootConstrainSelectedInstOperands,
     /* 285899 */       // GIR_Coverage, 474,
     /* 285899 */       GIR_EraseRootFromParent_Done,
     /* 285900 */     // Label 4710: @285900
     /* 285900 */     GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(285924), // Rule ID 476 //
     /* 285905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285908 */       // MIs[0] Operand 1
     /* 285908 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285913 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_fake16_e64),
     /* 285916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285918 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285920 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285922 */       GIR_RootConstrainSelectedInstOperands,
     /* 285923 */       // GIR_Coverage, 476,
     /* 285923 */       GIR_EraseRootFromParent_Done,
     /* 285924 */     // Label 4711: @285924
     /* 285924 */     GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(285948), // Rule ID 483 //
     /* 285929 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285932 */       // MIs[0] Operand 1
     /* 285932 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285937 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285937 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_e64),
     /* 285940 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285942 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285944 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285946 */       GIR_RootConstrainSelectedInstOperands,
     /* 285947 */       // GIR_Coverage, 483,
     /* 285947 */       GIR_EraseRootFromParent_Done,
     /* 285948 */     // Label 4712: @285948
     /* 285948 */     GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(285972), // Rule ID 485 //
     /* 285953 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285956 */       // MIs[0] Operand 1
     /* 285956 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285961 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285961 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_fake16_e64),
     /* 285964 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285966 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285968 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285970 */       GIR_RootConstrainSelectedInstOperands,
     /* 285971 */       // GIR_Coverage, 485,
     /* 285971 */       GIR_EraseRootFromParent_Done,
     /* 285972 */     // Label 4713: @285972
     /* 285972 */     GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(285996), // Rule ID 486 //
     /* 285977 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285980 */       // MIs[0] Operand 1
     /* 285980 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 285985 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_e64),
     /* 285988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285990 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285992 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285994 */       GIR_RootConstrainSelectedInstOperands,
     /* 285995 */       // GIR_Coverage, 486,
     /* 285995 */       GIR_EraseRootFromParent_Done,
     /* 285996 */     // Label 4714: @285996
     /* 285996 */     GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(286020), // Rule ID 490 //
     /* 286001 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286004 */       // MIs[0] Operand 1
     /* 286004 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286009 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286009 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_fake16_e64),
     /* 286012 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286014 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286016 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286018 */       GIR_RootConstrainSelectedInstOperands,
     /* 286019 */       // GIR_Coverage, 490,
     /* 286019 */       GIR_EraseRootFromParent_Done,
     /* 286020 */     // Label 4715: @286020
     /* 286020 */     GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(286044), // Rule ID 492 //
     /* 286025 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286028 */       // MIs[0] Operand 1
     /* 286028 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286033 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286033 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_e64),
     /* 286036 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286038 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286040 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286042 */       GIR_RootConstrainSelectedInstOperands,
     /* 286043 */       // GIR_Coverage, 492,
     /* 286043 */       GIR_EraseRootFromParent_Done,
     /* 286044 */     // Label 4716: @286044
     /* 286044 */     GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(286068), // Rule ID 494 //
     /* 286049 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286052 */       // MIs[0] Operand 1
     /* 286052 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286057 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_fake16_e64),
     /* 286060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286062 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286064 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286066 */       GIR_RootConstrainSelectedInstOperands,
     /* 286067 */       // GIR_Coverage, 494,
     /* 286067 */       GIR_EraseRootFromParent_Done,
     /* 286068 */     // Label 4717: @286068
     /* 286068 */     GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(286092), // Rule ID 495 //
     /* 286073 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286076 */       // MIs[0] Operand 1
     /* 286076 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286081 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286081 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_e64),
     /* 286084 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286086 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286088 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286090 */       GIR_RootConstrainSelectedInstOperands,
     /* 286091 */       // GIR_Coverage, 495,
     /* 286091 */       GIR_EraseRootFromParent_Done,
     /* 286092 */     // Label 4718: @286092
     /* 286092 */     GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(286116), // Rule ID 497 //
     /* 286097 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286100 */       // MIs[0] Operand 1
     /* 286100 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286105 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286105 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_fake16_e64),
     /* 286108 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286110 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286112 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286114 */       GIR_RootConstrainSelectedInstOperands,
     /* 286115 */       // GIR_Coverage, 497,
     /* 286115 */       GIR_EraseRootFromParent_Done,
     /* 286116 */     // Label 4719: @286116
     /* 286116 */     GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(286140), // Rule ID 498 //
     /* 286121 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286124 */       // MIs[0] Operand 1
     /* 286124 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286129 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286129 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_e64),
     /* 286132 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286134 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286136 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286138 */       GIR_RootConstrainSelectedInstOperands,
     /* 286139 */       // GIR_Coverage, 498,
     /* 286139 */       GIR_EraseRootFromParent_Done,
     /* 286140 */     // Label 4720: @286140
     /* 286140 */     GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(286164), // Rule ID 502 //
     /* 286145 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286148 */       // MIs[0] Operand 1
     /* 286148 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286153 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286153 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_fake16_e64),
     /* 286156 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286158 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286160 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286162 */       GIR_RootConstrainSelectedInstOperands,
     /* 286163 */       // GIR_Coverage, 502,
     /* 286163 */       GIR_EraseRootFromParent_Done,
     /* 286164 */     // Label 4721: @286164
     /* 286164 */     GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(286188), // Rule ID 504 //
     /* 286169 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286172 */       // MIs[0] Operand 1
     /* 286172 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286177 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286177 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_e64),
     /* 286180 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286182 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286184 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286186 */       GIR_RootConstrainSelectedInstOperands,
     /* 286187 */       // GIR_Coverage, 504,
     /* 286187 */       GIR_EraseRootFromParent_Done,
     /* 286188 */     // Label 4722: @286188
     /* 286188 */     GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(286212), // Rule ID 506 //
     /* 286193 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286196 */       // MIs[0] Operand 1
     /* 286196 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286201 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286201 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_fake16_e64),
     /* 286204 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286206 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286208 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286210 */       GIR_RootConstrainSelectedInstOperands,
     /* 286211 */       // GIR_Coverage, 506,
     /* 286211 */       GIR_EraseRootFromParent_Done,
     /* 286212 */     // Label 4723: @286212
     /* 286212 */     GIM_Reject,
     /* 286213 */   // Label 4693: @286213
     /* 286213 */   GIM_Reject,
     /* 286214 */   // Label 4690: @286214
     /* 286214 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(286311),
     /* 286219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 286222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286226 */     GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(286247), // Rule ID 559 //
     /* 286231 */       // MIs[0] Operand 1
     /* 286231 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 286236 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286236 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I32_e64),
     /* 286239 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286241 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286243 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286245 */       GIR_RootConstrainSelectedInstOperands,
     /* 286246 */       // GIR_Coverage, 559,
     /* 286246 */       GIR_EraseRootFromParent_Done,
     /* 286247 */     // Label 4725: @286247
     /* 286247 */     GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(286268), // Rule ID 561 //
     /* 286252 */       // MIs[0] Operand 1
     /* 286252 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 286257 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286257 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I32_e64),
     /* 286260 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286262 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286264 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286266 */       GIR_RootConstrainSelectedInstOperands,
     /* 286267 */       // GIR_Coverage, 561,
     /* 286267 */       GIR_EraseRootFromParent_Done,
     /* 286268 */     // Label 4726: @286268
     /* 286268 */     GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(286289), // Rule ID 562 //
     /* 286273 */       // MIs[0] Operand 1
     /* 286273 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 286278 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I32_e64),
     /* 286281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286283 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286285 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286287 */       GIR_RootConstrainSelectedInstOperands,
     /* 286288 */       // GIR_Coverage, 562,
     /* 286288 */       GIR_EraseRootFromParent_Done,
     /* 286289 */     // Label 4727: @286289
     /* 286289 */     GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(286310), // Rule ID 564 //
     /* 286294 */       // MIs[0] Operand 1
     /* 286294 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 286299 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I32_e64),
     /* 286302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286304 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286306 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286308 */       GIR_RootConstrainSelectedInstOperands,
     /* 286309 */       // GIR_Coverage, 564,
     /* 286309 */       GIR_EraseRootFromParent_Done,
     /* 286310 */     // Label 4728: @286310
     /* 286310 */     GIM_Reject,
     /* 286311 */   // Label 4724: @286311
     /* 286311 */   GIM_Reject,
     /* 286312 */   // Label 4691: @286312
     /* 286312 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(286409),
     /* 286317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286324 */     GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(286345), // Rule ID 575 //
     /* 286329 */       // MIs[0] Operand 1
     /* 286329 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 286334 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I64_e64),
     /* 286337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286339 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286341 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286343 */       GIR_RootConstrainSelectedInstOperands,
     /* 286344 */       // GIR_Coverage, 575,
     /* 286344 */       GIR_EraseRootFromParent_Done,
     /* 286345 */     // Label 4730: @286345
     /* 286345 */     GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(286366), // Rule ID 577 //
     /* 286350 */       // MIs[0] Operand 1
     /* 286350 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 286355 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286355 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I64_e64),
     /* 286358 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286360 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286362 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286364 */       GIR_RootConstrainSelectedInstOperands,
     /* 286365 */       // GIR_Coverage, 577,
     /* 286365 */       GIR_EraseRootFromParent_Done,
     /* 286366 */     // Label 4731: @286366
     /* 286366 */     GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(286387), // Rule ID 578 //
     /* 286371 */       // MIs[0] Operand 1
     /* 286371 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 286376 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286376 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I64_e64),
     /* 286379 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286381 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286383 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286385 */       GIR_RootConstrainSelectedInstOperands,
     /* 286386 */       // GIR_Coverage, 578,
     /* 286386 */       GIR_EraseRootFromParent_Done,
     /* 286387 */     // Label 4732: @286387
     /* 286387 */     GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(286408), // Rule ID 580 //
     /* 286392 */       // MIs[0] Operand 1
     /* 286392 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 286397 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286397 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I64_e64),
     /* 286400 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286402 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286404 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286406 */       GIR_RootConstrainSelectedInstOperands,
     /* 286407 */       // GIR_Coverage, 580,
     /* 286407 */       GIR_EraseRootFromParent_Done,
     /* 286408 */     // Label 4733: @286408
     /* 286408 */     GIM_Reject,
     /* 286409 */   // Label 4729: @286409
     /* 286409 */   GIM_Reject,
     /* 286410 */   // Label 4692: @286410
     /* 286410 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 4736*/ GIMT_Encode4(286709),
     /* 286421 */   /*GILLT_s32*//*Label 4734*/ GIMT_Encode4(286429),
     /* 286425 */   /*GILLT_s64*//*Label 4735*/ GIMT_Encode4(286569),
     /* 286429 */   // Label 4734: @286429
     /* 286429 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(286568),
     /* 286434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 286437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286441 */     GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(286462), // Rule ID 591 //
     /* 286446 */       // MIs[0] Operand 1
     /* 286446 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 286451 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286451 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U32_e64),
     /* 286454 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286456 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286458 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286460 */       GIR_RootConstrainSelectedInstOperands,
     /* 286461 */       // GIR_Coverage, 591,
     /* 286461 */       GIR_EraseRootFromParent_Done,
     /* 286462 */     // Label 4738: @286462
     /* 286462 */     GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(286483), // Rule ID 592 //
     /* 286467 */       // MIs[0] Operand 1
     /* 286467 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286472 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286472 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 286475 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286477 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286479 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286481 */       GIR_RootConstrainSelectedInstOperands,
     /* 286482 */       // GIR_Coverage, 592,
     /* 286482 */       GIR_EraseRootFromParent_Done,
     /* 286483 */     // Label 4739: @286483
     /* 286483 */     GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(286504), // Rule ID 594 //
     /* 286488 */       // MIs[0] Operand 1
     /* 286488 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286493 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U32_e64),
     /* 286496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286498 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286500 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286502 */       GIR_RootConstrainSelectedInstOperands,
     /* 286503 */       // GIR_Coverage, 594,
     /* 286503 */       GIR_EraseRootFromParent_Done,
     /* 286504 */     // Label 4740: @286504
     /* 286504 */     GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(286525), // Rule ID 595 //
     /* 286509 */       // MIs[0] Operand 1
     /* 286509 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286514 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286514 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U32_e64),
     /* 286517 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286519 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286521 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286523 */       GIR_RootConstrainSelectedInstOperands,
     /* 286524 */       // GIR_Coverage, 595,
     /* 286524 */       GIR_EraseRootFromParent_Done,
     /* 286525 */     // Label 4741: @286525
     /* 286525 */     GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(286546), // Rule ID 596 //
     /* 286530 */       // MIs[0] Operand 1
     /* 286530 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286535 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286535 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U32_e64),
     /* 286538 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286540 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286542 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286544 */       GIR_RootConstrainSelectedInstOperands,
     /* 286545 */       // GIR_Coverage, 596,
     /* 286545 */       GIR_EraseRootFromParent_Done,
     /* 286546 */     // Label 4742: @286546
     /* 286546 */     GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(286567), // Rule ID 598 //
     /* 286551 */       // MIs[0] Operand 1
     /* 286551 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286556 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U32_e64),
     /* 286559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286561 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286563 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286565 */       GIR_RootConstrainSelectedInstOperands,
     /* 286566 */       // GIR_Coverage, 598,
     /* 286566 */       GIR_EraseRootFromParent_Done,
     /* 286567 */     // Label 4743: @286567
     /* 286567 */     GIM_Reject,
     /* 286568 */   // Label 4737: @286568
     /* 286568 */   GIM_Reject,
     /* 286569 */   // Label 4735: @286569
     /* 286569 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(286708),
     /* 286574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286581 */     GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(286602), // Rule ID 609 //
     /* 286586 */       // MIs[0] Operand 1
     /* 286586 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 286591 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U64_e64),
     /* 286594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286596 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286598 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286600 */       GIR_RootConstrainSelectedInstOperands,
     /* 286601 */       // GIR_Coverage, 609,
     /* 286601 */       GIR_EraseRootFromParent_Done,
     /* 286602 */     // Label 4745: @286602
     /* 286602 */     GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(286623), // Rule ID 610 //
     /* 286607 */       // MIs[0] Operand 1
     /* 286607 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286612 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286612 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U64_e64),
     /* 286615 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286617 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286619 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286621 */       GIR_RootConstrainSelectedInstOperands,
     /* 286622 */       // GIR_Coverage, 610,
     /* 286622 */       GIR_EraseRootFromParent_Done,
     /* 286623 */     // Label 4746: @286623
     /* 286623 */     GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(286644), // Rule ID 612 //
     /* 286628 */       // MIs[0] Operand 1
     /* 286628 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286633 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286633 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U64_e64),
     /* 286636 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286638 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286640 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286642 */       GIR_RootConstrainSelectedInstOperands,
     /* 286643 */       // GIR_Coverage, 612,
     /* 286643 */       GIR_EraseRootFromParent_Done,
     /* 286644 */     // Label 4747: @286644
     /* 286644 */     GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(286665), // Rule ID 613 //
     /* 286649 */       // MIs[0] Operand 1
     /* 286649 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286654 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U64_e64),
     /* 286657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286659 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286661 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286663 */       GIR_RootConstrainSelectedInstOperands,
     /* 286664 */       // GIR_Coverage, 613,
     /* 286664 */       GIR_EraseRootFromParent_Done,
     /* 286665 */     // Label 4748: @286665
     /* 286665 */     GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(286686), // Rule ID 614 //
     /* 286670 */       // MIs[0] Operand 1
     /* 286670 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286675 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286675 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U64_e64),
     /* 286678 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286680 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286682 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286684 */       GIR_RootConstrainSelectedInstOperands,
     /* 286685 */       // GIR_Coverage, 614,
     /* 286685 */       GIR_EraseRootFromParent_Done,
     /* 286686 */     // Label 4749: @286686
     /* 286686 */     GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(286707), // Rule ID 616 //
     /* 286691 */       // MIs[0] Operand 1
     /* 286691 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286696 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286696 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U64_e64),
     /* 286699 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286701 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286703 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286705 */       GIR_RootConstrainSelectedInstOperands,
     /* 286706 */       // GIR_Coverage, 616,
     /* 286706 */       GIR_EraseRootFromParent_Done,
     /* 286707 */     // Label 4750: @286707
     /* 286707 */     GIM_Reject,
     /* 286708 */   // Label 4744: @286708
     /* 286708 */   GIM_Reject,
     /* 286709 */   // Label 4736: @286709
     /* 286709 */   GIM_Reject,
     /* 286710 */ // Label 4688: @286710
     /* 286710 */ GIM_Reject,
     /* 286711 */ // Label 52: @286711
     /* 286711 */ GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(290873),
     /* 286716 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 286719 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4755*/ GIMT_Encode4(290872),
     /* 286730 */   /*GILLT_s16*//*Label 4752*/ GIMT_Encode4(286742),
     /* 286734 */   /*GILLT_s32*//*Label 4753*/ GIMT_Encode4(289276),
     /* 286738 */   /*GILLT_s64*//*Label 4754*/ GIMT_Encode4(290074),
     /* 286742 */   // Label 4752: @286742
     /* 286742 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(289275),
     /* 286747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 286750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286754 */     GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(286813), // Rule ID 345 //
     /* 286759 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286762 */       // MIs[0] Operand 1
     /* 286762 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286767 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286774 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286781 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286781 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_e64),
     /* 286784 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286786 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286791 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286796 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286801 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286806 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286811 */       GIR_RootConstrainSelectedInstOperands,
     /* 286812 */       // GIR_Coverage, 345,
     /* 286812 */       GIR_EraseRootFromParent_Done,
     /* 286813 */     // Label 4757: @286813
     /* 286813 */     GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(286875), // Rule ID 347 //
     /* 286818 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 286821 */       // MIs[0] Operand 1
     /* 286821 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286826 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286840 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286840 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_t16_e64),
     /* 286843 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286845 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286850 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286855 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286860 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286865 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286870 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286873 */       GIR_RootConstrainSelectedInstOperands,
     /* 286874 */       // GIR_Coverage, 347,
     /* 286874 */       GIR_EraseRootFromParent_Done,
     /* 286875 */     // Label 4758: @286875
     /* 286875 */     GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(286934), // Rule ID 349 //
     /* 286880 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286883 */       // MIs[0] Operand 1
     /* 286883 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286888 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286895 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286902 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_fake16_e64),
     /* 286905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286907 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286912 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286917 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286922 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286927 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286932 */       GIR_RootConstrainSelectedInstOperands,
     /* 286933 */       // GIR_Coverage, 349,
     /* 286933 */       GIR_EraseRootFromParent_Done,
     /* 286934 */     // Label 4759: @286934
     /* 286934 */     GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(286993), // Rule ID 351 //
     /* 286939 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286942 */       // MIs[0] Operand 1
     /* 286942 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 286947 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286954 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286961 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286961 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 286964 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286966 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286971 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286976 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286981 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286986 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286991 */       GIR_RootConstrainSelectedInstOperands,
     /* 286992 */       // GIR_Coverage, 351,
     /* 286992 */       GIR_EraseRootFromParent_Done,
     /* 286993 */     // Label 4760: @286993
     /* 286993 */     GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(287055), // Rule ID 353 //
     /* 286998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287001 */       // MIs[0] Operand 1
     /* 287001 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 287006 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287013 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287020 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287020 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 287023 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287025 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287030 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287035 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287040 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287045 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287050 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287053 */       GIR_RootConstrainSelectedInstOperands,
     /* 287054 */       // GIR_Coverage, 353,
     /* 287054 */       GIR_EraseRootFromParent_Done,
     /* 287055 */     // Label 4761: @287055
     /* 287055 */     GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(287114), // Rule ID 355 //
     /* 287060 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287063 */       // MIs[0] Operand 1
     /* 287063 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 287068 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287075 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287082 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287082 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 287085 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287092 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287097 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287102 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287107 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287112 */       GIR_RootConstrainSelectedInstOperands,
     /* 287113 */       // GIR_Coverage, 355,
     /* 287113 */       GIR_EraseRootFromParent_Done,
     /* 287114 */     // Label 4762: @287114
     /* 287114 */     GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(287173), // Rule ID 357 //
     /* 287119 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287122 */       // MIs[0] Operand 1
     /* 287122 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 287127 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287134 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287141 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287141 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_e64),
     /* 287144 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287146 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287151 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287156 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287161 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287166 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287171 */       GIR_RootConstrainSelectedInstOperands,
     /* 287172 */       // GIR_Coverage, 357,
     /* 287172 */       GIR_EraseRootFromParent_Done,
     /* 287173 */     // Label 4763: @287173
     /* 287173 */     GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(287235), // Rule ID 359 //
     /* 287178 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287181 */       // MIs[0] Operand 1
     /* 287181 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 287186 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287193 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287200 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287200 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_t16_e64),
     /* 287203 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287205 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287210 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287215 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287220 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287225 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287230 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287233 */       GIR_RootConstrainSelectedInstOperands,
     /* 287234 */       // GIR_Coverage, 359,
     /* 287234 */       GIR_EraseRootFromParent_Done,
     /* 287235 */     // Label 4764: @287235
     /* 287235 */     GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(287294), // Rule ID 361 //
     /* 287240 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287243 */       // MIs[0] Operand 1
     /* 287243 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 287248 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287255 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287262 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_fake16_e64),
     /* 287265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287267 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287272 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287277 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287282 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287287 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287292 */       GIR_RootConstrainSelectedInstOperands,
     /* 287293 */       // GIR_Coverage, 361,
     /* 287293 */       GIR_EraseRootFromParent_Done,
     /* 287294 */     // Label 4765: @287294
     /* 287294 */     GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(287353), // Rule ID 363 //
     /* 287299 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287302 */       // MIs[0] Operand 1
     /* 287302 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287307 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287314 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287321 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287321 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_e64),
     /* 287324 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287326 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287331 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287336 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287341 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287346 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287351 */       GIR_RootConstrainSelectedInstOperands,
     /* 287352 */       // GIR_Coverage, 363,
     /* 287352 */       GIR_EraseRootFromParent_Done,
     /* 287353 */     // Label 4766: @287353
     /* 287353 */     GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(287415), // Rule ID 365 //
     /* 287358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287361 */       // MIs[0] Operand 1
     /* 287361 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287366 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287373 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287380 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287380 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_t16_e64),
     /* 287383 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287385 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287390 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287395 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287400 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287405 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287410 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287413 */       GIR_RootConstrainSelectedInstOperands,
     /* 287414 */       // GIR_Coverage, 365,
     /* 287414 */       GIR_EraseRootFromParent_Done,
     /* 287415 */     // Label 4767: @287415
     /* 287415 */     GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(287474), // Rule ID 367 //
     /* 287420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287423 */       // MIs[0] Operand 1
     /* 287423 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287435 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287442 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287442 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_fake16_e64),
     /* 287445 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287447 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287452 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287457 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287462 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287467 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287472 */       GIR_RootConstrainSelectedInstOperands,
     /* 287473 */       // GIR_Coverage, 367,
     /* 287473 */       GIR_EraseRootFromParent_Done,
     /* 287474 */     // Label 4768: @287474
     /* 287474 */     GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(287533), // Rule ID 369 //
     /* 287479 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287482 */       // MIs[0] Operand 1
     /* 287482 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287487 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287494 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287501 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287501 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_e64),
     /* 287504 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287506 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287511 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287516 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287521 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287526 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287531 */       GIR_RootConstrainSelectedInstOperands,
     /* 287532 */       // GIR_Coverage, 369,
     /* 287532 */       GIR_EraseRootFromParent_Done,
     /* 287533 */     // Label 4769: @287533
     /* 287533 */     GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(287595), // Rule ID 371 //
     /* 287538 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287541 */       // MIs[0] Operand 1
     /* 287541 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287546 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287553 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287560 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287560 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_t16_e64),
     /* 287563 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287565 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287570 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287575 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287580 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287585 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287590 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287593 */       GIR_RootConstrainSelectedInstOperands,
     /* 287594 */       // GIR_Coverage, 371,
     /* 287594 */       GIR_EraseRootFromParent_Done,
     /* 287595 */     // Label 4770: @287595
     /* 287595 */     GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(287654), // Rule ID 373 //
     /* 287600 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287603 */       // MIs[0] Operand 1
     /* 287603 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287608 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287615 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287622 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_fake16_e64),
     /* 287625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287627 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287632 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287637 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287642 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287647 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287652 */       GIR_RootConstrainSelectedInstOperands,
     /* 287653 */       // GIR_Coverage, 373,
     /* 287653 */       GIR_EraseRootFromParent_Done,
     /* 287654 */     // Label 4771: @287654
     /* 287654 */     GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(287713), // Rule ID 375 //
     /* 287659 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287662 */       // MIs[0] Operand 1
     /* 287662 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287667 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287674 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287681 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287681 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_e64),
     /* 287684 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287686 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287691 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287696 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287701 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287706 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287711 */       GIR_RootConstrainSelectedInstOperands,
     /* 287712 */       // GIR_Coverage, 375,
     /* 287712 */       GIR_EraseRootFromParent_Done,
     /* 287713 */     // Label 4772: @287713
     /* 287713 */     GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(287775), // Rule ID 377 //
     /* 287718 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287721 */       // MIs[0] Operand 1
     /* 287721 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287726 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287733 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287740 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287740 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_t16_e64),
     /* 287743 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287745 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287750 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287755 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287760 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287765 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287773 */       GIR_RootConstrainSelectedInstOperands,
     /* 287774 */       // GIR_Coverage, 377,
     /* 287774 */       GIR_EraseRootFromParent_Done,
     /* 287775 */     // Label 4773: @287775
     /* 287775 */     GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(287834), // Rule ID 379 //
     /* 287780 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287783 */       // MIs[0] Operand 1
     /* 287783 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287788 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287795 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287802 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_fake16_e64),
     /* 287805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287807 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287812 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287817 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287822 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287827 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287832 */       GIR_RootConstrainSelectedInstOperands,
     /* 287833 */       // GIR_Coverage, 379,
     /* 287833 */       GIR_EraseRootFromParent_Done,
     /* 287834 */     // Label 4774: @287834
     /* 287834 */     GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(287893), // Rule ID 381 //
     /* 287839 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287842 */       // MIs[0] Operand 1
     /* 287842 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287847 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287854 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287861 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287861 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_e64),
     /* 287864 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287866 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287871 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287876 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287881 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287886 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287891 */       GIR_RootConstrainSelectedInstOperands,
     /* 287892 */       // GIR_Coverage, 381,
     /* 287892 */       GIR_EraseRootFromParent_Done,
     /* 287893 */     // Label 4775: @287893
     /* 287893 */     GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(287955), // Rule ID 382 //
     /* 287898 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287901 */       // MIs[0] Operand 1
     /* 287901 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287906 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287913 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287920 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287920 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_t16_e64),
     /* 287923 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287925 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287930 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287935 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287940 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287945 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287950 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287953 */       GIR_RootConstrainSelectedInstOperands,
     /* 287954 */       // GIR_Coverage, 382,
     /* 287954 */       GIR_EraseRootFromParent_Done,
     /* 287955 */     // Label 4776: @287955
     /* 287955 */     GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(288014), // Rule ID 383 //
     /* 287960 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287963 */       // MIs[0] Operand 1
     /* 287963 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287968 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287975 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287982 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287982 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_fake16_e64),
     /* 287985 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287987 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287992 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288002 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288007 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288012 */       GIR_RootConstrainSelectedInstOperands,
     /* 288013 */       // GIR_Coverage, 383,
     /* 288013 */       GIR_EraseRootFromParent_Done,
     /* 288014 */     // Label 4777: @288014
     /* 288014 */     GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(288073), // Rule ID 384 //
     /* 288019 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288022 */       // MIs[0] Operand 1
     /* 288022 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 288027 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288034 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288041 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_e64),
     /* 288044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288046 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288051 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288056 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288061 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288066 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288071 */       GIR_RootConstrainSelectedInstOperands,
     /* 288072 */       // GIR_Coverage, 384,
     /* 288072 */       GIR_EraseRootFromParent_Done,
     /* 288073 */     // Label 4778: @288073
     /* 288073 */     GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(288135), // Rule ID 385 //
     /* 288078 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288081 */       // MIs[0] Operand 1
     /* 288081 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 288086 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288093 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288100 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288100 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_t16_e64),
     /* 288103 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288105 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288110 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288115 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288120 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288125 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288130 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288133 */       GIR_RootConstrainSelectedInstOperands,
     /* 288134 */       // GIR_Coverage, 385,
     /* 288134 */       GIR_EraseRootFromParent_Done,
     /* 288135 */     // Label 4779: @288135
     /* 288135 */     GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(288194), // Rule ID 386 //
     /* 288140 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288143 */       // MIs[0] Operand 1
     /* 288143 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 288148 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288155 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288162 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288162 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_fake16_e64),
     /* 288165 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288167 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288172 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288177 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288182 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288187 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288192 */       GIR_RootConstrainSelectedInstOperands,
     /* 288193 */       // GIR_Coverage, 386,
     /* 288193 */       GIR_EraseRootFromParent_Done,
     /* 288194 */     // Label 4780: @288194
     /* 288194 */     GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(288253), // Rule ID 387 //
     /* 288199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288202 */       // MIs[0] Operand 1
     /* 288202 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 288207 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288214 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288221 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_e64),
     /* 288224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288226 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288231 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288236 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288241 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288246 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288251 */       GIR_RootConstrainSelectedInstOperands,
     /* 288252 */       // GIR_Coverage, 387,
     /* 288252 */       GIR_EraseRootFromParent_Done,
     /* 288253 */     // Label 4781: @288253
     /* 288253 */     GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(288315), // Rule ID 388 //
     /* 288258 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288261 */       // MIs[0] Operand 1
     /* 288261 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 288266 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288273 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288280 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288280 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_t16_e64),
     /* 288283 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288285 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288295 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288300 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288305 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288310 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288313 */       GIR_RootConstrainSelectedInstOperands,
     /* 288314 */       // GIR_Coverage, 388,
     /* 288314 */       GIR_EraseRootFromParent_Done,
     /* 288315 */     // Label 4782: @288315
     /* 288315 */     GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(288374), // Rule ID 389 //
     /* 288320 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288323 */       // MIs[0] Operand 1
     /* 288323 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 288328 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288335 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288342 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288342 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_fake16_e64),
     /* 288345 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288347 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288352 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288357 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288362 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288367 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288372 */       GIR_RootConstrainSelectedInstOperands,
     /* 288373 */       // GIR_Coverage, 389,
     /* 288373 */       GIR_EraseRootFromParent_Done,
     /* 288374 */     // Label 4783: @288374
     /* 288374 */     GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(288433), // Rule ID 390 //
     /* 288379 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288382 */       // MIs[0] Operand 1
     /* 288382 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288387 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288394 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288401 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288401 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_e64),
     /* 288404 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288406 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288411 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288416 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288421 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288426 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288431 */       GIR_RootConstrainSelectedInstOperands,
     /* 288432 */       // GIR_Coverage, 390,
     /* 288432 */       GIR_EraseRootFromParent_Done,
     /* 288433 */     // Label 4784: @288433
     /* 288433 */     GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(288495), // Rule ID 391 //
     /* 288438 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288441 */       // MIs[0] Operand 1
     /* 288441 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288446 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288453 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288460 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288460 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_t16_e64),
     /* 288463 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288465 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288470 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288475 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288480 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288485 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288493 */       GIR_RootConstrainSelectedInstOperands,
     /* 288494 */       // GIR_Coverage, 391,
     /* 288494 */       GIR_EraseRootFromParent_Done,
     /* 288495 */     // Label 4785: @288495
     /* 288495 */     GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(288554), // Rule ID 392 //
     /* 288500 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288503 */       // MIs[0] Operand 1
     /* 288503 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288508 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288515 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288522 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288522 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_fake16_e64),
     /* 288525 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288527 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288532 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288537 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288542 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288547 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288552 */       GIR_RootConstrainSelectedInstOperands,
     /* 288553 */       // GIR_Coverage, 392,
     /* 288553 */       GIR_EraseRootFromParent_Done,
     /* 288554 */     // Label 4786: @288554
     /* 288554 */     GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(288613), // Rule ID 393 //
     /* 288559 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288562 */       // MIs[0] Operand 1
     /* 288562 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288567 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288574 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288581 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288581 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_e64),
     /* 288584 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288586 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288591 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288596 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288601 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288606 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288611 */       GIR_RootConstrainSelectedInstOperands,
     /* 288612 */       // GIR_Coverage, 393,
     /* 288612 */       GIR_EraseRootFromParent_Done,
     /* 288613 */     // Label 4787: @288613
     /* 288613 */     GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(288675), // Rule ID 394 //
     /* 288618 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288621 */       // MIs[0] Operand 1
     /* 288621 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288626 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288633 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288640 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288640 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_t16_e64),
     /* 288643 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288645 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288655 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288660 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288665 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288670 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288673 */       GIR_RootConstrainSelectedInstOperands,
     /* 288674 */       // GIR_Coverage, 394,
     /* 288674 */       GIR_EraseRootFromParent_Done,
     /* 288675 */     // Label 4788: @288675
     /* 288675 */     GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(288734), // Rule ID 395 //
     /* 288680 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288683 */       // MIs[0] Operand 1
     /* 288683 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288688 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288695 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288702 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_fake16_e64),
     /* 288705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288712 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288717 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288722 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288727 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288732 */       GIR_RootConstrainSelectedInstOperands,
     /* 288733 */       // GIR_Coverage, 395,
     /* 288733 */       GIR_EraseRootFromParent_Done,
     /* 288734 */     // Label 4789: @288734
     /* 288734 */     GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(288793), // Rule ID 396 //
     /* 288739 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288742 */       // MIs[0] Operand 1
     /* 288742 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288747 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288754 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288761 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288761 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_e64),
     /* 288764 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288766 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288771 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288776 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288781 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288786 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288791 */       GIR_RootConstrainSelectedInstOperands,
     /* 288792 */       // GIR_Coverage, 396,
     /* 288792 */       GIR_EraseRootFromParent_Done,
     /* 288793 */     // Label 4790: @288793
     /* 288793 */     GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(288855), // Rule ID 397 //
     /* 288798 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288801 */       // MIs[0] Operand 1
     /* 288801 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288806 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288813 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288820 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288820 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_t16_e64),
     /* 288823 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288825 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288830 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288835 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288840 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288845 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288850 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288853 */       GIR_RootConstrainSelectedInstOperands,
     /* 288854 */       // GIR_Coverage, 397,
     /* 288854 */       GIR_EraseRootFromParent_Done,
     /* 288855 */     // Label 4791: @288855
     /* 288855 */     GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(288914), // Rule ID 398 //
     /* 288860 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288863 */       // MIs[0] Operand 1
     /* 288863 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288868 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288875 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288882 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288882 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_fake16_e64),
     /* 288885 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288887 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288892 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288897 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288902 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288907 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288912 */       GIR_RootConstrainSelectedInstOperands,
     /* 288913 */       // GIR_Coverage, 398,
     /* 288913 */       GIR_EraseRootFromParent_Done,
     /* 288914 */     // Label 4792: @288914
     /* 288914 */     GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(288973), // Rule ID 399 //
     /* 288919 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288922 */       // MIs[0] Operand 1
     /* 288922 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 288927 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288934 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288941 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288941 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_e64),
     /* 288944 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288946 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288951 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288956 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288961 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288966 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288971 */       GIR_RootConstrainSelectedInstOperands,
     /* 288972 */       // GIR_Coverage, 399,
     /* 288972 */       GIR_EraseRootFromParent_Done,
     /* 288973 */     // Label 4793: @288973
     /* 288973 */     GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(289035), // Rule ID 400 //
     /* 288978 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288981 */       // MIs[0] Operand 1
     /* 288981 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 288986 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288993 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289000 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289000 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_t16_e64),
     /* 289003 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289005 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289010 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289015 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289020 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289025 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289030 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289033 */       GIR_RootConstrainSelectedInstOperands,
     /* 289034 */       // GIR_Coverage, 400,
     /* 289034 */       GIR_EraseRootFromParent_Done,
     /* 289035 */     // Label 4794: @289035
     /* 289035 */     GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(289094), // Rule ID 401 //
     /* 289040 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289043 */       // MIs[0] Operand 1
     /* 289043 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 289048 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289055 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289062 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289062 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_fake16_e64),
     /* 289065 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289067 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289072 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289077 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289092 */       GIR_RootConstrainSelectedInstOperands,
     /* 289093 */       // GIR_Coverage, 401,
     /* 289093 */       GIR_EraseRootFromParent_Done,
     /* 289094 */     // Label 4795: @289094
     /* 289094 */     GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(289153), // Rule ID 402 //
     /* 289099 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289102 */       // MIs[0] Operand 1
     /* 289102 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 289107 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289114 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289121 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289121 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_e64),
     /* 289124 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289126 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289131 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289136 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289141 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289146 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289151 */       GIR_RootConstrainSelectedInstOperands,
     /* 289152 */       // GIR_Coverage, 402,
     /* 289152 */       GIR_EraseRootFromParent_Done,
     /* 289153 */     // Label 4796: @289153
     /* 289153 */     GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(289215), // Rule ID 403 //
     /* 289158 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289161 */       // MIs[0] Operand 1
     /* 289161 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 289166 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289173 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289180 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289180 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_t16_e64),
     /* 289183 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289185 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289190 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289195 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289200 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289205 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289210 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289213 */       GIR_RootConstrainSelectedInstOperands,
     /* 289214 */       // GIR_Coverage, 403,
     /* 289214 */       GIR_EraseRootFromParent_Done,
     /* 289215 */     // Label 4797: @289215
     /* 289215 */     GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(289274), // Rule ID 404 //
     /* 289220 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289223 */       // MIs[0] Operand 1
     /* 289223 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 289228 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289235 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289242 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_fake16_e64),
     /* 289245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289247 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289252 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289257 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289262 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289267 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289272 */       GIR_RootConstrainSelectedInstOperands,
     /* 289273 */       // GIR_Coverage, 404,
     /* 289273 */       GIR_EraseRootFromParent_Done,
     /* 289274 */     // Label 4798: @289274
     /* 289274 */     GIM_Reject,
     /* 289275 */   // Label 4756: @289275
     /* 289275 */   GIM_Reject,
     /* 289276 */   // Label 4753: @289276
     /* 289276 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(290073),
     /* 289281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 289284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 289288 */     GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(289344), // Rule ID 203 //
     /* 289293 */       // MIs[0] Operand 1
     /* 289293 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 289298 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289305 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289312 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289312 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F32_e64),
     /* 289315 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289317 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289322 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289327 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289332 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289337 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289342 */       GIR_RootConstrainSelectedInstOperands,
     /* 289343 */       // GIR_Coverage, 203,
     /* 289343 */       GIR_EraseRootFromParent_Done,
     /* 289344 */     // Label 4800: @289344
     /* 289344 */     GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(289400), // Rule ID 205 //
     /* 289349 */       // MIs[0] Operand 1
     /* 289349 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 289354 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289361 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289368 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289368 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 289371 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289373 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289378 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289383 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289388 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289393 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289398 */       GIR_RootConstrainSelectedInstOperands,
     /* 289399 */       // GIR_Coverage, 205,
     /* 289399 */       GIR_EraseRootFromParent_Done,
     /* 289400 */     // Label 4801: @289400
     /* 289400 */     GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(289456), // Rule ID 207 //
     /* 289405 */       // MIs[0] Operand 1
     /* 289405 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 289410 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289417 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289424 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289424 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F32_e64),
     /* 289427 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289429 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289434 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289439 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289444 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289449 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289454 */       GIR_RootConstrainSelectedInstOperands,
     /* 289455 */       // GIR_Coverage, 207,
     /* 289455 */       GIR_EraseRootFromParent_Done,
     /* 289456 */     // Label 4802: @289456
     /* 289456 */     GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(289512), // Rule ID 209 //
     /* 289461 */       // MIs[0] Operand 1
     /* 289461 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 289466 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289473 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289480 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289480 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F32_e64),
     /* 289483 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289485 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289490 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289495 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289500 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289505 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289510 */       GIR_RootConstrainSelectedInstOperands,
     /* 289511 */       // GIR_Coverage, 209,
     /* 289511 */       GIR_EraseRootFromParent_Done,
     /* 289512 */     // Label 4803: @289512
     /* 289512 */     GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(289568), // Rule ID 211 //
     /* 289517 */       // MIs[0] Operand 1
     /* 289517 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 289522 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289529 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289536 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289536 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F32_e64),
     /* 289539 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289541 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289546 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289551 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289556 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289561 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289566 */       GIR_RootConstrainSelectedInstOperands,
     /* 289567 */       // GIR_Coverage, 211,
     /* 289567 */       GIR_EraseRootFromParent_Done,
     /* 289568 */     // Label 4804: @289568
     /* 289568 */     GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(289624), // Rule ID 213 //
     /* 289573 */       // MIs[0] Operand 1
     /* 289573 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 289578 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289585 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289592 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F32_e64),
     /* 289595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289597 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289602 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289607 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289612 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289617 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289622 */       GIR_RootConstrainSelectedInstOperands,
     /* 289623 */       // GIR_Coverage, 213,
     /* 289623 */       GIR_EraseRootFromParent_Done,
     /* 289624 */     // Label 4805: @289624
     /* 289624 */     GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(289680), // Rule ID 215 //
     /* 289629 */       // MIs[0] Operand 1
     /* 289629 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 289634 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289641 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289648 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F32_e64),
     /* 289651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289653 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289658 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289663 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289668 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289673 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289678 */       GIR_RootConstrainSelectedInstOperands,
     /* 289679 */       // GIR_Coverage, 215,
     /* 289679 */       GIR_EraseRootFromParent_Done,
     /* 289680 */     // Label 4806: @289680
     /* 289680 */     GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(289736), // Rule ID 216 //
     /* 289685 */       // MIs[0] Operand 1
     /* 289685 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 289690 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289697 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289704 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289704 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F32_e64),
     /* 289707 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289709 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289714 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289719 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289724 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289729 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289734 */       GIR_RootConstrainSelectedInstOperands,
     /* 289735 */       // GIR_Coverage, 216,
     /* 289735 */       GIR_EraseRootFromParent_Done,
     /* 289736 */     // Label 4807: @289736
     /* 289736 */     GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(289792), // Rule ID 217 //
     /* 289741 */       // MIs[0] Operand 1
     /* 289741 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 289746 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289753 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289760 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289760 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F32_e64),
     /* 289763 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289765 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289770 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289775 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289780 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289785 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289790 */       GIR_RootConstrainSelectedInstOperands,
     /* 289791 */       // GIR_Coverage, 217,
     /* 289791 */       GIR_EraseRootFromParent_Done,
     /* 289792 */     // Label 4808: @289792
     /* 289792 */     GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(289848), // Rule ID 218 //
     /* 289797 */       // MIs[0] Operand 1
     /* 289797 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 289802 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289809 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289816 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F32_e64),
     /* 289819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289821 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289826 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289831 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289836 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289841 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289846 */       GIR_RootConstrainSelectedInstOperands,
     /* 289847 */       // GIR_Coverage, 218,
     /* 289847 */       GIR_EraseRootFromParent_Done,
     /* 289848 */     // Label 4809: @289848
     /* 289848 */     GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(289904), // Rule ID 219 //
     /* 289853 */       // MIs[0] Operand 1
     /* 289853 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 289858 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289865 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289872 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289872 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F32_e64),
     /* 289875 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289877 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289882 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289887 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289892 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289897 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289902 */       GIR_RootConstrainSelectedInstOperands,
     /* 289903 */       // GIR_Coverage, 219,
     /* 289903 */       GIR_EraseRootFromParent_Done,
     /* 289904 */     // Label 4810: @289904
     /* 289904 */     GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(289960), // Rule ID 220 //
     /* 289909 */       // MIs[0] Operand 1
     /* 289909 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 289914 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289921 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289928 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289928 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F32_e64),
     /* 289931 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289933 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289938 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289943 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289948 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289953 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289958 */       GIR_RootConstrainSelectedInstOperands,
     /* 289959 */       // GIR_Coverage, 220,
     /* 289959 */       GIR_EraseRootFromParent_Done,
     /* 289960 */     // Label 4811: @289960
     /* 289960 */     GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(290016), // Rule ID 221 //
     /* 289965 */       // MIs[0] Operand 1
     /* 289965 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 289970 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289977 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289984 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289984 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F32_e64),
     /* 289987 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289989 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289994 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289999 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290004 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290009 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290014 */       GIR_RootConstrainSelectedInstOperands,
     /* 290015 */       // GIR_Coverage, 221,
     /* 290015 */       GIR_EraseRootFromParent_Done,
     /* 290016 */     // Label 4812: @290016
     /* 290016 */     GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(290072), // Rule ID 222 //
     /* 290021 */       // MIs[0] Operand 1
     /* 290021 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 290026 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290033 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290040 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F32_e64),
     /* 290043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290045 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290050 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290055 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290060 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290065 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290070 */       GIR_RootConstrainSelectedInstOperands,
     /* 290071 */       // GIR_Coverage, 222,
     /* 290071 */       GIR_EraseRootFromParent_Done,
     /* 290072 */     // Label 4813: @290072
     /* 290072 */     GIM_Reject,
     /* 290073 */   // Label 4799: @290073
     /* 290073 */   GIM_Reject,
     /* 290074 */   // Label 4754: @290074
     /* 290074 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(290871),
     /* 290079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290086 */     GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(290142), // Rule ID 241 //
     /* 290091 */       // MIs[0] Operand 1
     /* 290091 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 290096 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290103 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290110 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290110 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F64_e64),
     /* 290113 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290115 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290120 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290125 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290130 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290135 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290140 */       GIR_RootConstrainSelectedInstOperands,
     /* 290141 */       // GIR_Coverage, 241,
     /* 290141 */       GIR_EraseRootFromParent_Done,
     /* 290142 */     // Label 4815: @290142
     /* 290142 */     GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(290198), // Rule ID 243 //
     /* 290147 */       // MIs[0] Operand 1
     /* 290147 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 290152 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290159 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290166 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 290169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290171 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290176 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290181 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290186 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290196 */       GIR_RootConstrainSelectedInstOperands,
     /* 290197 */       // GIR_Coverage, 243,
     /* 290197 */       GIR_EraseRootFromParent_Done,
     /* 290198 */     // Label 4816: @290198
     /* 290198 */     GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(290254), // Rule ID 245 //
     /* 290203 */       // MIs[0] Operand 1
     /* 290203 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 290208 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290215 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290222 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290222 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F64_e64),
     /* 290225 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290232 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290237 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290242 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290247 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290252 */       GIR_RootConstrainSelectedInstOperands,
     /* 290253 */       // GIR_Coverage, 245,
     /* 290253 */       GIR_EraseRootFromParent_Done,
     /* 290254 */     // Label 4817: @290254
     /* 290254 */     GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(290310), // Rule ID 247 //
     /* 290259 */       // MIs[0] Operand 1
     /* 290259 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 290264 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290271 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290278 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F64_e64),
     /* 290281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290283 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290288 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290293 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290303 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290308 */       GIR_RootConstrainSelectedInstOperands,
     /* 290309 */       // GIR_Coverage, 247,
     /* 290309 */       GIR_EraseRootFromParent_Done,
     /* 290310 */     // Label 4818: @290310
     /* 290310 */     GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(290366), // Rule ID 249 //
     /* 290315 */       // MIs[0] Operand 1
     /* 290315 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 290320 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290327 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290334 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F64_e64),
     /* 290337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290339 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290344 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290349 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290354 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290359 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290364 */       GIR_RootConstrainSelectedInstOperands,
     /* 290365 */       // GIR_Coverage, 249,
     /* 290365 */       GIR_EraseRootFromParent_Done,
     /* 290366 */     // Label 4819: @290366
     /* 290366 */     GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(290422), // Rule ID 251 //
     /* 290371 */       // MIs[0] Operand 1
     /* 290371 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 290376 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290383 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290390 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290390 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F64_e64),
     /* 290393 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290395 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290400 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290405 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290410 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290415 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290420 */       GIR_RootConstrainSelectedInstOperands,
     /* 290421 */       // GIR_Coverage, 251,
     /* 290421 */       GIR_EraseRootFromParent_Done,
     /* 290422 */     // Label 4820: @290422
     /* 290422 */     GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(290478), // Rule ID 253 //
     /* 290427 */       // MIs[0] Operand 1
     /* 290427 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 290432 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290439 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290446 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290446 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F64_e64),
     /* 290449 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290451 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290456 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290461 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290466 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290476 */       GIR_RootConstrainSelectedInstOperands,
     /* 290477 */       // GIR_Coverage, 253,
     /* 290477 */       GIR_EraseRootFromParent_Done,
     /* 290478 */     // Label 4821: @290478
     /* 290478 */     GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(290534), // Rule ID 254 //
     /* 290483 */       // MIs[0] Operand 1
     /* 290483 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 290488 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290495 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290502 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290502 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F64_e64),
     /* 290505 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290507 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290512 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290517 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290522 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290527 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290532 */       GIR_RootConstrainSelectedInstOperands,
     /* 290533 */       // GIR_Coverage, 254,
     /* 290533 */       GIR_EraseRootFromParent_Done,
     /* 290534 */     // Label 4822: @290534
     /* 290534 */     GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(290590), // Rule ID 255 //
     /* 290539 */       // MIs[0] Operand 1
     /* 290539 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 290544 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290551 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290558 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290558 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F64_e64),
     /* 290561 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290563 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290568 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290583 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290588 */       GIR_RootConstrainSelectedInstOperands,
     /* 290589 */       // GIR_Coverage, 255,
     /* 290589 */       GIR_EraseRootFromParent_Done,
     /* 290590 */     // Label 4823: @290590
     /* 290590 */     GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(290646), // Rule ID 256 //
     /* 290595 */       // MIs[0] Operand 1
     /* 290595 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 290600 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290607 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290614 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290614 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F64_e64),
     /* 290617 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290619 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290624 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290629 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290634 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290639 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290644 */       GIR_RootConstrainSelectedInstOperands,
     /* 290645 */       // GIR_Coverage, 256,
     /* 290645 */       GIR_EraseRootFromParent_Done,
     /* 290646 */     // Label 4824: @290646
     /* 290646 */     GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(290702), // Rule ID 257 //
     /* 290651 */       // MIs[0] Operand 1
     /* 290651 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 290656 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290663 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290670 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290670 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F64_e64),
     /* 290673 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290675 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290680 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290685 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290690 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290695 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290700 */       GIR_RootConstrainSelectedInstOperands,
     /* 290701 */       // GIR_Coverage, 257,
     /* 290701 */       GIR_EraseRootFromParent_Done,
     /* 290702 */     // Label 4825: @290702
     /* 290702 */     GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(290758), // Rule ID 258 //
     /* 290707 */       // MIs[0] Operand 1
     /* 290707 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 290712 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290719 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290726 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290726 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F64_e64),
     /* 290729 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290731 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290736 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290741 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290746 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290751 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290756 */       GIR_RootConstrainSelectedInstOperands,
     /* 290757 */       // GIR_Coverage, 258,
     /* 290757 */       GIR_EraseRootFromParent_Done,
     /* 290758 */     // Label 4826: @290758
     /* 290758 */     GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(290814), // Rule ID 259 //
     /* 290763 */       // MIs[0] Operand 1
     /* 290763 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 290768 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290775 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290782 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290782 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F64_e64),
     /* 290785 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290787 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290792 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290797 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290802 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290807 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290812 */       GIR_RootConstrainSelectedInstOperands,
     /* 290813 */       // GIR_Coverage, 259,
     /* 290813 */       GIR_EraseRootFromParent_Done,
     /* 290814 */     // Label 4827: @290814
     /* 290814 */     GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(290870), // Rule ID 260 //
     /* 290819 */       // MIs[0] Operand 1
     /* 290819 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 290824 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290831 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290838 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290838 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F64_e64),
     /* 290841 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290843 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290848 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290858 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290868 */       GIR_RootConstrainSelectedInstOperands,
     /* 290869 */       // GIR_Coverage, 260,
     /* 290869 */       GIR_EraseRootFromParent_Done,
     /* 290870 */     // Label 4828: @290870
     /* 290870 */     GIM_Reject,
     /* 290871 */   // Label 4814: @290871
     /* 290871 */   GIM_Reject,
     /* 290872 */   // Label 4755: @290872
     /* 290872 */   GIM_Reject,
     /* 290873 */ // Label 4751: @290873
     /* 290873 */ GIM_Reject,
     /* 290874 */ // Label 53: @290874
     /* 290874 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4831*/ GIMT_Encode4(291217),
     /* 290885 */ /*GILLT_s16*//*Label 4829*/ GIMT_Encode4(290893),
     /* 290889 */ /*GILLT_s32*//*Label 4830*/ GIMT_Encode4(291101),
     /* 290893 */ // Label 4829: @290893
     /* 290893 */ GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(291100),
     /* 290898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 290901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 290904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 290907 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(290938), // Rule ID 7014 //
     /* 290912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 290915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290919 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290927 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290936 */     GIR_RootConstrainSelectedInstOperands,
     /* 290937 */     // GIR_Coverage, 7014,
     /* 290937 */     GIR_EraseRootFromParent_Done,
     /* 290938 */   // Label 4833: @290938
     /* 290938 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(290969), // Rule ID 7015 //
     /* 290943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 290946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290950 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290967 */     GIR_RootConstrainSelectedInstOperands,
     /* 290968 */     // GIR_Coverage, 7015,
     /* 290968 */     GIR_EraseRootFromParent_Done,
     /* 290969 */   // Label 4834: @290969
     /* 290969 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(291000), // Rule ID 7016 //
     /* 290974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 290977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290981 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290989 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290994 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290998 */     GIR_RootConstrainSelectedInstOperands,
     /* 290999 */     // GIR_Coverage, 7016,
     /* 290999 */     GIR_EraseRootFromParent_Done,
     /* 291000 */   // Label 4835: @291000
     /* 291000 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(291031), // Rule ID 7017 //
     /* 291005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 291008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291012 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 291012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 291015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291020 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 291022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291029 */     GIR_RootConstrainSelectedInstOperands,
     /* 291030 */     // GIR_Coverage, 7017,
     /* 291030 */     GIR_EraseRootFromParent_Done,
     /* 291031 */   // Label 4836: @291031
     /* 291031 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(291065), // Rule ID 7018 //
     /* 291036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291043 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 291043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 291046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291051 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 291053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291063 */     GIR_RootConstrainSelectedInstOperands,
     /* 291064 */     // GIR_Coverage, 7018,
     /* 291064 */     GIR_EraseRootFromParent_Done,
     /* 291065 */   // Label 4837: @291065
     /* 291065 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(291099), // Rule ID 7019 //
     /* 291070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291077 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 291077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 291080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 291087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291090 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291097 */     GIR_RootConstrainSelectedInstOperands,
     /* 291098 */     // GIR_Coverage, 7019,
     /* 291098 */     GIR_EraseRootFromParent_Done,
     /* 291099 */   // Label 4838: @291099
     /* 291099 */   GIM_Reject,
     /* 291100 */ // Label 4832: @291100
     /* 291100 */ GIM_Reject,
     /* 291101 */ // Label 4830: @291101
     /* 291101 */ GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(291216),
     /* 291106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 291109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 291115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291119 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(291167), // Rule ID 7012 //
     /* 291124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 291131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 291138 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[i32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[i32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[i32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 291138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 291141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 291148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 291153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 291158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 291163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291165 */     GIR_RootConstrainSelectedInstOperands,
     /* 291166 */     // GIR_Coverage, 7012,
     /* 291166 */     GIR_EraseRootFromParent_Done,
     /* 291167 */   // Label 4840: @291167
     /* 291167 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(291215), // Rule ID 7013 //
     /* 291172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 291179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 291186 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[f32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[f32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[f32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 291186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 291189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 291196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 291201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 291206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 291211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291213 */     GIR_RootConstrainSelectedInstOperands,
     /* 291214 */     // GIR_Coverage, 7013,
     /* 291214 */     GIR_EraseRootFromParent_Done,
     /* 291215 */   // Label 4841: @291215
     /* 291215 */   GIM_Reject,
     /* 291216 */ // Label 4839: @291216
     /* 291216 */ GIM_Reject,
     /* 291217 */ // Label 4831: @291217
     /* 291217 */ GIM_Reject,
     /* 291218 */ // Label 54: @291218
     /* 291218 */ GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(291326),
     /* 291223 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 291226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291232 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(291263), // Rule ID 86 //
     /* 291237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 291240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13762),
     /* 291256 */     // (mulhu:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13762>>  =>  (S_MUL_HI_U32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 291256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_U32),
     /* 291261 */     GIR_RootConstrainSelectedInstOperands,
     /* 291262 */     // GIR_Coverage, 86,
     /* 291262 */     GIR_Done,
     /* 291263 */   // Label 4843: @291263
     /* 291263 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(291325),
     /* 291268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291272 */     GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(291298), // Rule ID 939 //
     /* 291277 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291284 */       // (mulhu:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291284 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 291287 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291289 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291294 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291296 */       GIR_RootConstrainSelectedInstOperands,
     /* 291297 */       // GIR_Coverage, 939,
     /* 291297 */       GIR_EraseRootFromParent_Done,
     /* 291298 */     // Label 4845: @291298
     /* 291298 */     GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(291324), // Rule ID 8469 //
     /* 291303 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291310 */       // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291310 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 291313 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291315 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291320 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 291322 */       GIR_RootConstrainSelectedInstOperands,
     /* 291323 */       // GIR_Coverage, 8469,
     /* 291323 */       GIR_EraseRootFromParent_Done,
     /* 291324 */     // Label 4846: @291324
     /* 291324 */     GIM_Reject,
     /* 291325 */   // Label 4844: @291325
     /* 291325 */   GIM_Reject,
     /* 291326 */ // Label 4842: @291326
     /* 291326 */ GIM_Reject,
     /* 291327 */ // Label 55: @291327
     /* 291327 */ GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(291435),
     /* 291332 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 291335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291341 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(291372), // Rule ID 87 //
     /* 291346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 291349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13763),
     /* 291365 */     // (mulhs:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13763>>  =>  (S_MUL_HI_I32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 291365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_I32),
     /* 291370 */     GIR_RootConstrainSelectedInstOperands,
     /* 291371 */     // GIR_Coverage, 87,
     /* 291371 */     GIR_Done,
     /* 291372 */   // Label 4848: @291372
     /* 291372 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(291434),
     /* 291377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291381 */     GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(291407), // Rule ID 940 //
     /* 291386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291393 */       // (mulhs:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 291396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291403 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291405 */       GIR_RootConstrainSelectedInstOperands,
     /* 291406 */       // GIR_Coverage, 940,
     /* 291406 */       GIR_EraseRootFromParent_Done,
     /* 291407 */     // Label 4850: @291407
     /* 291407 */     GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(291433), // Rule ID 8470 //
     /* 291412 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291419 */       // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291419 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 291422 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291424 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291429 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 291431 */       GIR_RootConstrainSelectedInstOperands,
     /* 291432 */       // GIR_Coverage, 8470,
     /* 291432 */       GIR_EraseRootFromParent_Done,
     /* 291433 */     // Label 4851: @291433
     /* 291433 */     GIM_Reject,
     /* 291434 */   // Label 4849: @291434
     /* 291434 */   GIM_Reject,
     /* 291435 */ // Label 4847: @291435
     /* 291435 */ GIM_Reject,
     /* 291436 */ // Label 56: @291436
     /* 291436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4855*/ GIMT_Encode4(291823),
     /* 291447 */ /*GILLT_s16*//*Label 4852*/ GIMT_Encode4(291463),
     /* 291451 */ /*GILLT_s32*//*Label 4853*/ GIMT_Encode4(291679), GIMT_Encode4(0),
     /* 291459 */ /*GILLT_v2s16*//*Label 4854*/ GIMT_Encode4(291748),
     /* 291463 */ // Label 4852: @291463
     /* 291463 */ GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(291678),
     /* 291468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 291471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 291474 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(291533), // Rule ID 2665 //
     /* 291479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 291482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291500 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /* 291503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291531 */     GIR_RootConstrainSelectedInstOperands,
     /* 291532 */     // GIR_Coverage, 2665,
     /* 291532 */     GIR_EraseRootFromParent_Done,
     /* 291533 */   // Label 4857: @291533
     /* 291533 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(291592), // Rule ID 2668 //
     /* 291538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291559 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /* 291562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291590 */     GIR_RootConstrainSelectedInstOperands,
     /* 291591 */     // GIR_Coverage, 2668,
     /* 291591 */     GIR_EraseRootFromParent_Done,
     /* 291592 */   // Label 4858: @291592
     /* 291592 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(291651), // Rule ID 2671 //
     /* 291597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 291600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291618 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /* 291621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291649 */     GIR_RootConstrainSelectedInstOperands,
     /* 291650 */     // GIR_Coverage, 2671,
     /* 291650 */     GIR_EraseRootFromParent_Done,
     /* 291651 */   // Label 4859: @291651
     /* 291651 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(291677), // Rule ID 2564 //
     /* 291656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 291659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291663 */     // (uaddsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 291663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 291666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291675 */     GIR_RootConstrainSelectedInstOperands,
     /* 291676 */     // GIR_Coverage, 2564,
     /* 291676 */     GIR_EraseRootFromParent_Done,
     /* 291677 */   // Label 4860: @291677
     /* 291677 */   GIM_Reject,
     /* 291678 */ // Label 4856: @291678
     /* 291678 */ GIM_Reject,
     /* 291679 */ // Label 4853: @291679
     /* 291679 */ GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(291747),
     /* 291684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291694 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(291716), // Rule ID 2562 //
     /* 291699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 291702 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 291702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /* 291705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291714 */     GIR_RootConstrainSelectedInstOperands,
     /* 291715 */     // GIR_Coverage, 2562,
     /* 291715 */     GIR_EraseRootFromParent_Done,
     /* 291716 */   // Label 4862: @291716
     /* 291716 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(291746), // Rule ID 2560 //
     /* 291721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 291724 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 291724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 291727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /* 291730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291732 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 291737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291744 */     GIR_RootConstrainSelectedInstOperands,
     /* 291745 */     // GIR_Coverage, 2560,
     /* 291745 */     GIR_EraseRootFromParent_Done,
     /* 291746 */   // Label 4863: @291746
     /* 291746 */   GIM_Reject,
     /* 291747 */ // Label 4861: @291747
     /* 291747 */ GIM_Reject,
     /* 291748 */ // Label 4854: @291748
     /* 291748 */ GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(291822), // Rule ID 2712 //
     /* 291753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 291756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 291759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 291762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291780 */   // (uaddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 291780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /* 291783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291820 */   GIR_RootConstrainSelectedInstOperands,
     /* 291821 */   // GIR_Coverage, 2712,
     /* 291821 */   GIR_EraseRootFromParent_Done,
     /* 291822 */ // Label 4864: @291822
     /* 291822 */ GIM_Reject,
     /* 291823 */ // Label 4855: @291823
     /* 291823 */ GIM_Reject,
     /* 291824 */ // Label 57: @291824
     /* 291824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4868*/ GIMT_Encode4(292149),
     /* 291835 */ /*GILLT_s16*//*Label 4865*/ GIMT_Encode4(291851),
     /* 291839 */ /*GILLT_s32*//*Label 4866*/ GIMT_Encode4(292041), GIMT_Encode4(0),
     /* 291847 */ /*GILLT_v2s16*//*Label 4867*/ GIMT_Encode4(292074),
     /* 291851 */ // Label 4865: @291851
     /* 291851 */ GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(292040),
     /* 291856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 291859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 291862 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(291921), // Rule ID 2605 //
     /* 291867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 291870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291888 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_e64),
     /* 291891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291919 */     GIR_RootConstrainSelectedInstOperands,
     /* 291920 */     // GIR_Coverage, 2605,
     /* 291920 */     GIR_EraseRootFromParent_Done,
     /* 291921 */   // Label 4870: @291921
     /* 291921 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(291980), // Rule ID 2607 //
     /* 291926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291947 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_t16_e64),
     /* 291950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291978 */     GIR_RootConstrainSelectedInstOperands,
     /* 291979 */     // GIR_Coverage, 2607,
     /* 291979 */     GIR_EraseRootFromParent_Done,
     /* 291980 */   // Label 4871: @291980
     /* 291980 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(292039), // Rule ID 2609 //
     /* 291985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 291988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292006 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_fake16_e64),
     /* 292009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292037 */     GIR_RootConstrainSelectedInstOperands,
     /* 292038 */     // GIR_Coverage, 2609,
     /* 292038 */     GIR_EraseRootFromParent_Done,
     /* 292039 */   // Label 4872: @292039
     /* 292039 */   GIM_Reject,
     /* 292040 */ // Label 4869: @292040
     /* 292040 */ GIM_Reject,
     /* 292041 */ // Label 4866: @292041
     /* 292041 */ GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(292073), // Rule ID 2602 //
     /* 292046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 292049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292059 */   // (saddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I32_e64),
     /* 292062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292064 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292066 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292071 */   GIR_RootConstrainSelectedInstOperands,
     /* 292072 */   // GIR_Coverage, 2602,
     /* 292072 */   GIR_EraseRootFromParent_Done,
     /* 292073 */ // Label 4873: @292073
     /* 292073 */ GIM_Reject,
     /* 292074 */ // Label 4867: @292074
     /* 292074 */ GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(292148), // Rule ID 2713 //
     /* 292079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 292082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 292085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 292088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292092 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292106 */   // (saddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 292106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_I16),
     /* 292109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292146 */   GIR_RootConstrainSelectedInstOperands,
     /* 292147 */   // GIR_Coverage, 2713,
     /* 292147 */   GIR_EraseRootFromParent_Done,
     /* 292148 */ // Label 4874: @292148
     /* 292148 */ GIM_Reject,
     /* 292149 */ // Label 4868: @292149
     /* 292149 */ GIM_Reject,
     /* 292150 */ // Label 58: @292150
     /* 292150 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4878*/ GIMT_Encode4(292537),
     /* 292161 */ /*GILLT_s16*//*Label 4875*/ GIMT_Encode4(292177),
     /* 292165 */ /*GILLT_s32*//*Label 4876*/ GIMT_Encode4(292393), GIMT_Encode4(0),
     /* 292173 */ /*GILLT_v2s16*//*Label 4877*/ GIMT_Encode4(292462),
     /* 292177 */ // Label 4875: @292177
     /* 292177 */ GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(292392),
     /* 292182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292188 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(292247), // Rule ID 2666 //
     /* 292193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 292196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292214 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /* 292217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292245 */     GIR_RootConstrainSelectedInstOperands,
     /* 292246 */     // GIR_Coverage, 2666,
     /* 292246 */     GIR_EraseRootFromParent_Done,
     /* 292247 */   // Label 4880: @292247
     /* 292247 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(292306), // Rule ID 2669 //
     /* 292252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 292255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 292259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292273 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /* 292276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292304 */     GIR_RootConstrainSelectedInstOperands,
     /* 292305 */     // GIR_Coverage, 2669,
     /* 292305 */     GIR_EraseRootFromParent_Done,
     /* 292306 */   // Label 4881: @292306
     /* 292306 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(292365), // Rule ID 2672 //
     /* 292311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292332 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /* 292335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292363 */     GIR_RootConstrainSelectedInstOperands,
     /* 292364 */     // GIR_Coverage, 2672,
     /* 292364 */     GIR_EraseRootFromParent_Done,
     /* 292365 */   // Label 4882: @292365
     /* 292365 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(292391), // Rule ID 2565 //
     /* 292370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 292373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292377 */     // (usubsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 292377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 292380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292389 */     GIR_RootConstrainSelectedInstOperands,
     /* 292390 */     // GIR_Coverage, 2565,
     /* 292390 */     GIR_EraseRootFromParent_Done,
     /* 292391 */   // Label 4883: @292391
     /* 292391 */   GIM_Reject,
     /* 292392 */ // Label 4879: @292392
     /* 292392 */ GIM_Reject,
     /* 292393 */ // Label 4876: @292393
     /* 292393 */ GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(292461),
     /* 292398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292408 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(292430), // Rule ID 2563 //
     /* 292413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 292416 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /* 292419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292428 */     GIR_RootConstrainSelectedInstOperands,
     /* 292429 */     // GIR_Coverage, 2563,
     /* 292429 */     GIR_EraseRootFromParent_Done,
     /* 292430 */   // Label 4885: @292430
     /* 292430 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(292460), // Rule ID 2561 //
     /* 292435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 292438 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 292441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /* 292444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292446 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 292451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292458 */     GIR_RootConstrainSelectedInstOperands,
     /* 292459 */     // GIR_Coverage, 2561,
     /* 292459 */     GIR_EraseRootFromParent_Done,
     /* 292460 */   // Label 4886: @292460
     /* 292460 */   GIM_Reject,
     /* 292461 */ // Label 4884: @292461
     /* 292461 */ GIM_Reject,
     /* 292462 */ // Label 4877: @292462
     /* 292462 */ GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(292536), // Rule ID 2714 //
     /* 292467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 292470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 292473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 292476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292487 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292494 */   // (usubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 292494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_U16),
     /* 292497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292534 */   GIR_RootConstrainSelectedInstOperands,
     /* 292535 */   // GIR_Coverage, 2714,
     /* 292535 */   GIR_EraseRootFromParent_Done,
     /* 292536 */ // Label 4887: @292536
     /* 292536 */ GIM_Reject,
     /* 292537 */ // Label 4878: @292537
     /* 292537 */ GIM_Reject,
     /* 292538 */ // Label 59: @292538
     /* 292538 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4891*/ GIMT_Encode4(292863),
     /* 292549 */ /*GILLT_s16*//*Label 4888*/ GIMT_Encode4(292565),
     /* 292553 */ /*GILLT_s32*//*Label 4889*/ GIMT_Encode4(292755), GIMT_Encode4(0),
     /* 292561 */ /*GILLT_v2s16*//*Label 4890*/ GIMT_Encode4(292788),
     /* 292565 */ // Label 4888: @292565
     /* 292565 */ GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(292754),
     /* 292570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292576 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(292635), // Rule ID 2606 //
     /* 292581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 292584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292602 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_e64),
     /* 292605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292633 */     GIR_RootConstrainSelectedInstOperands,
     /* 292634 */     // GIR_Coverage, 2606,
     /* 292634 */     GIR_EraseRootFromParent_Done,
     /* 292635 */   // Label 4893: @292635
     /* 292635 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(292694), // Rule ID 2608 //
     /* 292640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 292643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 292647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292661 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_t16_e64),
     /* 292664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292692 */     GIR_RootConstrainSelectedInstOperands,
     /* 292693 */     // GIR_Coverage, 2608,
     /* 292693 */     GIR_EraseRootFromParent_Done,
     /* 292694 */   // Label 4894: @292694
     /* 292694 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(292753), // Rule ID 2610 //
     /* 292699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292720 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_fake16_e64),
     /* 292723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292751 */     GIR_RootConstrainSelectedInstOperands,
     /* 292752 */     // GIR_Coverage, 2610,
     /* 292752 */     GIR_EraseRootFromParent_Done,
     /* 292753 */   // Label 4895: @292753
     /* 292753 */   GIM_Reject,
     /* 292754 */ // Label 4892: @292754
     /* 292754 */ GIM_Reject,
     /* 292755 */ // Label 4889: @292755
     /* 292755 */ GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(292787), // Rule ID 2603 //
     /* 292760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 292763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292773 */   // (ssubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I32_e64),
     /* 292776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292780 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292785 */   GIR_RootConstrainSelectedInstOperands,
     /* 292786 */   // GIR_Coverage, 2603,
     /* 292786 */   GIR_EraseRootFromParent_Done,
     /* 292787 */ // Label 4896: @292787
     /* 292787 */ GIM_Reject,
     /* 292788 */ // Label 4890: @292788
     /* 292788 */ GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(292862), // Rule ID 2715 //
     /* 292793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 292796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 292799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 292802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292806 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292820 */   // (ssubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 292820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /* 292823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292860 */   GIR_RootConstrainSelectedInstOperands,
     /* 292861 */   // GIR_Coverage, 2715,
     /* 292861 */   GIR_EraseRootFromParent_Done,
     /* 292862 */ // Label 4897: @292862
     /* 292862 */ GIM_Reject,
     /* 292863 */ // Label 4891: @292863
     /* 292863 */ GIM_Reject,
     /* 292864 */ // Label 60: @292864
     /* 292864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4903*/ GIMT_Encode4(294221),
     /* 292875 */ /*GILLT_s16*//*Label 4898*/ GIMT_Encode4(292895),
     /* 292879 */ /*GILLT_s32*//*Label 4899*/ GIMT_Encode4(293257),
     /* 292883 */ /*GILLT_s64*//*Label 4900*/ GIMT_Encode4(293821),
     /* 292887 */ /*GILLT_v2s16*//*Label 4901*/ GIMT_Encode4(294074),
     /* 292891 */ /*GILLT_v2s32*//*Label 4902*/ GIMT_Encode4(294146),
     /* 292895 */ // Label 4898: @292895
     /* 292895 */ GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(293256),
     /* 292900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292906 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(292941), // Rule ID 97 //
     /* 292911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 292914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13764),
     /* 292930 */     // (fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13764>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 292930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 292935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 292939 */     GIR_RootConstrainSelectedInstOperands,
     /* 292940 */     // GIR_Coverage, 97,
     /* 292940 */     GIR_Done,
     /* 292941 */   // Label 4905: @292941
     /* 292941 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(293004), // Rule ID 859 //
     /* 292946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292967 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 292967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 292970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293002 */     GIR_RootConstrainSelectedInstOperands,
     /* 293003 */     // GIR_Coverage, 859,
     /* 293003 */     GIR_EraseRootFromParent_Done,
     /* 293004 */   // Label 4906: @293004
     /* 293004 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(293067), // Rule ID 863 //
     /* 293009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 293012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293030 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 293033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293065 */     GIR_RootConstrainSelectedInstOperands,
     /* 293066 */     // GIR_Coverage, 863,
     /* 293066 */     GIR_EraseRootFromParent_Done,
     /* 293067 */   // Label 4907: @293067
     /* 293067 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(293130), // Rule ID 8430 //
     /* 293072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 293075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293093 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 293096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293128 */     GIR_RootConstrainSelectedInstOperands,
     /* 293129 */     // GIR_Coverage, 8430,
     /* 293129 */     GIR_EraseRootFromParent_Done,
     /* 293130 */   // Label 4908: @293130
     /* 293130 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(293193), // Rule ID 8432 //
     /* 293135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 293138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293156 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 293159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293191 */     GIR_RootConstrainSelectedInstOperands,
     /* 293192 */     // GIR_Coverage, 8432,
     /* 293192 */     GIR_EraseRootFromParent_Done,
     /* 293193 */   // Label 4909: @293193
     /* 293193 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(293255), // Rule ID 861 //
     /* 293198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 293201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 293205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 293212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 293219 */     // (fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 293219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 293222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293253 */     GIR_RootConstrainSelectedInstOperands,
     /* 293254 */     // GIR_Coverage, 861,
     /* 293254 */     GIR_EraseRootFromParent_Done,
     /* 293255 */   // Label 4910: @293255
     /* 293255 */   GIM_Reject,
     /* 293256 */ // Label 4904: @293256
     /* 293256 */ GIM_Reject,
     /* 293257 */ // Label 4899: @293257
     /* 293257 */ GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(293820),
     /* 293262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 293265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 293268 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(293364), // Rule ID 11150 //
     /* 293273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 293276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293288 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293291 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293300 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293327 */     // (fadd:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2), (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 293330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 293348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 293356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293362 */     GIR_RootConstrainSelectedInstOperands,
     /* 293363 */     // GIR_Coverage, 11150,
     /* 293363 */     GIR_EraseRootFromParent_Done,
     /* 293364 */   // Label 4912: @293364
     /* 293364 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(293466), // Rule ID 11152 //
     /* 293369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 293372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293384 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293387 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293396 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293423 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod), (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 293426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mod
     /* 293433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mod
     /* 293443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 293448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mod
     /* 293453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 293458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293464 */     GIR_RootConstrainSelectedInstOperands,
     /* 293465 */     // GIR_Coverage, 11152,
     /* 293465 */     GIR_EraseRootFromParent_Done,
     /* 293466 */   // Label 4913: @293466
     /* 293466 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(293562), // Rule ID 7004 //
     /* 293471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 293474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293486 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293489 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293498 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293525 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 293528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 293554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293560 */     GIR_RootConstrainSelectedInstOperands,
     /* 293561 */     // GIR_Coverage, 7004,
     /* 293561 */     GIR_EraseRootFromParent_Done,
     /* 293562 */   // Label 4914: @293562
     /* 293562 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(293664), // Rule ID 7010 //
     /* 293567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 293570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293582 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293585 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293594 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293621 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 293624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mod
     /* 293631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mod
     /* 293641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mod
     /* 293651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 293656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293662 */     GIR_RootConstrainSelectedInstOperands,
     /* 293663 */     // GIR_Coverage, 7010,
     /* 293663 */     GIR_EraseRootFromParent_Done,
     /* 293664 */   // Label 4915: @293664
     /* 293664 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(293699), // Rule ID 89 //
     /* 293669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 293672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13764),
     /* 293688 */     // (fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13764>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 293688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 293693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 293697 */     GIR_RootConstrainSelectedInstOperands,
     /* 293698 */     // GIR_Coverage, 89,
     /* 293698 */     GIR_Done,
     /* 293699 */   // Label 4916: @293699
     /* 293699 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(293759), // Rule ID 785 //
     /* 293704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293722 */     // (fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 293725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293757 */     GIR_RootConstrainSelectedInstOperands,
     /* 293758 */     // GIR_Coverage, 785,
     /* 293758 */     GIR_EraseRootFromParent_Done,
     /* 293759 */   // Label 4917: @293759
     /* 293759 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(293819), // Rule ID 8419 //
     /* 293764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293782 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 293785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293817 */     GIR_RootConstrainSelectedInstOperands,
     /* 293818 */     // GIR_Coverage, 8419,
     /* 293818 */     GIR_EraseRootFromParent_Done,
     /* 293819 */   // Label 4918: @293819
     /* 293819 */   GIM_Reject,
     /* 293820 */ // Label 4911: @293820
     /* 293820 */ GIM_Reject,
     /* 293821 */ // Label 4900: @293821
     /* 293821 */ GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(294073),
     /* 293826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 293829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 293832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 293836 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(293895), // Rule ID 913 //
     /* 293841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 293844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293858 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 293861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293893 */     GIR_RootConstrainSelectedInstOperands,
     /* 293894 */     // GIR_Coverage, 913,
     /* 293894 */     GIR_EraseRootFromParent_Done,
     /* 293895 */   // Label 4920: @293895
     /* 293895 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(293954), // Rule ID 931 //
     /* 293900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 293903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293917 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 293920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293952 */     GIR_RootConstrainSelectedInstOperands,
     /* 293953 */     // GIR_Coverage, 931,
     /* 293953 */     GIR_EraseRootFromParent_Done,
     /* 293954 */   // Label 4921: @293954
     /* 293954 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(294013), // Rule ID 8448 //
     /* 293959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 293962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293976 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 293979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294011 */     GIR_RootConstrainSelectedInstOperands,
     /* 294012 */     // GIR_Coverage, 8448,
     /* 294012 */     GIR_EraseRootFromParent_Done,
     /* 294013 */   // Label 4922: @294013
     /* 294013 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(294072), // Rule ID 8461 //
     /* 294018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 294021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294035 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 294038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294070 */     GIR_RootConstrainSelectedInstOperands,
     /* 294071 */     // GIR_Coverage, 8461,
     /* 294071 */     GIR_EraseRootFromParent_Done,
     /* 294072 */   // Label 4923: @294072
     /* 294072 */   GIM_Reject,
     /* 294073 */ // Label 4919: @294073
     /* 294073 */ GIM_Reject,
     /* 294074 */ // Label 4901: @294074
     /* 294074 */ GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(294145), // Rule ID 1091 //
     /* 294079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 294082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 294085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294089 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 294096 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 294103 */   // (fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 294103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 294106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294143 */   GIR_RootConstrainSelectedInstOperands,
     /* 294144 */   // GIR_Coverage, 1091,
     /* 294144 */   GIR_EraseRootFromParent_Done,
     /* 294145 */ // Label 4924: @294145
     /* 294145 */ GIM_Reject,
     /* 294146 */ // Label 4902: @294146
     /* 294146 */ GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(294220), // Rule ID 1312 //
     /* 294151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 294154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 294157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 294160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 294164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 294171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 294178 */   // (fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 294178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 294181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294218 */   GIR_RootConstrainSelectedInstOperands,
     /* 294219 */   // GIR_Coverage, 1312,
     /* 294219 */   GIR_EraseRootFromParent_Done,
     /* 294220 */ // Label 4925: @294220
     /* 294220 */ GIM_Reject,
     /* 294221 */ // Label 4903: @294221
     /* 294221 */ GIM_Reject,
     /* 294222 */ // Label 61: @294222
     /* 294222 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4928*/ GIMT_Encode4(294585),
     /* 294233 */ /*GILLT_s16*//*Label 4926*/ GIMT_Encode4(294241),
     /* 294237 */ /*GILLT_s32*//*Label 4927*/ GIMT_Encode4(294477),
     /* 294241 */ // Label 4926: @294241
     /* 294241 */ GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(294476),
     /* 294246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 294249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 294252 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(294287), // Rule ID 105 //
     /* 294257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13768),
     /* 294276 */     // (fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13768>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 294276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 294281 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294285 */     GIR_RootConstrainSelectedInstOperands,
     /* 294286 */     // GIR_Coverage, 105,
     /* 294286 */     GIR_Done,
     /* 294287 */   // Label 4930: @294287
     /* 294287 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(294350), // Rule ID 865 //
     /* 294292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294313 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 294316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294348 */     GIR_RootConstrainSelectedInstOperands,
     /* 294349 */     // GIR_Coverage, 865,
     /* 294349 */     GIR_EraseRootFromParent_Done,
     /* 294350 */   // Label 4931: @294350
     /* 294350 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(294413), // Rule ID 869 //
     /* 294355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294376 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 294379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294411 */     GIR_RootConstrainSelectedInstOperands,
     /* 294412 */     // GIR_Coverage, 869,
     /* 294412 */     GIR_EraseRootFromParent_Done,
     /* 294413 */   // Label 4932: @294413
     /* 294413 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(294475), // Rule ID 867 //
     /* 294418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 294421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 294425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294439 */     // (fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 294439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 294442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294473 */     GIR_RootConstrainSelectedInstOperands,
     /* 294474 */     // GIR_Coverage, 867,
     /* 294474 */     GIR_EraseRootFromParent_Done,
     /* 294475 */   // Label 4933: @294475
     /* 294475 */   GIM_Reject,
     /* 294476 */ // Label 4929: @294476
     /* 294476 */ GIM_Reject,
     /* 294477 */ // Label 4927: @294477
     /* 294477 */ GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(294584),
     /* 294482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 294485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 294488 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(294523), // Rule ID 107 //
     /* 294493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13768),
     /* 294512 */     // (fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13768>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 294512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 294517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294521 */     GIR_RootConstrainSelectedInstOperands,
     /* 294522 */     // GIR_Coverage, 107,
     /* 294522 */     GIR_Done,
     /* 294523 */   // Label 4935: @294523
     /* 294523 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(294583), // Rule ID 787 //
     /* 294528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294546 */     // (fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 294549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294581 */     GIR_RootConstrainSelectedInstOperands,
     /* 294582 */     // GIR_Coverage, 787,
     /* 294582 */     GIR_EraseRootFromParent_Done,
     /* 294583 */   // Label 4936: @294583
     /* 294583 */   GIM_Reject,
     /* 294584 */ // Label 4934: @294584
     /* 294584 */ GIM_Reject,
     /* 294585 */ // Label 4928: @294585
     /* 294585 */ GIM_Reject,
     /* 294586 */ // Label 62: @294586
     /* 294586 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4942*/ GIMT_Encode4(295971),
     /* 294597 */ /*GILLT_s16*//*Label 4937*/ GIMT_Encode4(294617),
     /* 294601 */ /*GILLT_s32*//*Label 4938*/ GIMT_Encode4(294979),
     /* 294605 */ /*GILLT_s64*//*Label 4939*/ GIMT_Encode4(295147),
     /* 294609 */ /*GILLT_v2s16*//*Label 4940*/ GIMT_Encode4(295824),
     /* 294613 */ /*GILLT_v2s32*//*Label 4941*/ GIMT_Encode4(295896),
     /* 294617 */ // Label 4937: @294617
     /* 294617 */ GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(294978),
     /* 294622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 294625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 294628 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(294663), // Rule ID 99 //
     /* 294633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13767),
     /* 294652 */     // (fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13767>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 294652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 294657 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294661 */     GIR_RootConstrainSelectedInstOperands,
     /* 294662 */     // GIR_Coverage, 99,
     /* 294662 */     GIR_Done,
     /* 294663 */   // Label 4944: @294663
     /* 294663 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(294726), // Rule ID 871 //
     /* 294668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294689 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 294692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294724 */     GIR_RootConstrainSelectedInstOperands,
     /* 294725 */     // GIR_Coverage, 871,
     /* 294725 */     GIR_EraseRootFromParent_Done,
     /* 294726 */   // Label 4945: @294726
     /* 294726 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(294789), // Rule ID 875 //
     /* 294731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294752 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 294755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294787 */     GIR_RootConstrainSelectedInstOperands,
     /* 294788 */     // GIR_Coverage, 875,
     /* 294788 */     GIR_EraseRootFromParent_Done,
     /* 294789 */   // Label 4946: @294789
     /* 294789 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(294852), // Rule ID 8434 //
     /* 294794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294815 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 294818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294850 */     GIR_RootConstrainSelectedInstOperands,
     /* 294851 */     // GIR_Coverage, 8434,
     /* 294851 */     GIR_EraseRootFromParent_Done,
     /* 294852 */   // Label 4947: @294852
     /* 294852 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(294915), // Rule ID 8436 //
     /* 294857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294878 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 294881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294913 */     GIR_RootConstrainSelectedInstOperands,
     /* 294914 */     // GIR_Coverage, 8436,
     /* 294914 */     GIR_EraseRootFromParent_Done,
     /* 294915 */   // Label 4948: @294915
     /* 294915 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(294977), // Rule ID 873 //
     /* 294920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 294923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 294927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294941 */     // (fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 294941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 294944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294975 */     GIR_RootConstrainSelectedInstOperands,
     /* 294976 */     // GIR_Coverage, 873,
     /* 294976 */     GIR_EraseRootFromParent_Done,
     /* 294977 */   // Label 4949: @294977
     /* 294977 */   GIM_Reject,
     /* 294978 */ // Label 4943: @294978
     /* 294978 */ GIM_Reject,
     /* 294979 */ // Label 4938: @294979
     /* 294979 */ GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(295146),
     /* 294984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 294987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 294990 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(295025), // Rule ID 95 //
     /* 294995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13767),
     /* 295014 */     // (fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13767>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 295014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 295019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 295023 */     GIR_RootConstrainSelectedInstOperands,
     /* 295024 */     // GIR_Coverage, 95,
     /* 295024 */     GIR_Done,
     /* 295025 */   // Label 4951: @295025
     /* 295025 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(295085), // Rule ID 791 //
     /* 295030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295048 */     // (fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 295051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 295078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 295083 */     GIR_RootConstrainSelectedInstOperands,
     /* 295084 */     // GIR_Coverage, 791,
     /* 295084 */     GIR_EraseRootFromParent_Done,
     /* 295085 */   // Label 4952: @295085
     /* 295085 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(295145), // Rule ID 8423 //
     /* 295090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295108 */     // (fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 295111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 295118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 295123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 295128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 295138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 295143 */     GIR_RootConstrainSelectedInstOperands,
     /* 295144 */     // GIR_Coverage, 8423,
     /* 295144 */     GIR_EraseRootFromParent_Done,
     /* 295145 */   // Label 4953: @295145
     /* 295145 */   GIM_Reject,
     /* 295146 */ // Label 4950: @295146
     /* 295146 */ GIM_Reject,
     /* 295147 */ // Label 4939: @295147
     /* 295147 */ GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(295823),
     /* 295152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 295162 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(295236), // Rule ID 7789 //
     /* 295167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295175 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 295179 */     // MIs[1] Operand 1
     /* 295179 */     // No operand predicates
     /* 295179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295188 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295200 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 295217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295234 */     GIR_RootConstrainSelectedInstOperands,
     /* 295235 */     // GIR_Coverage, 7789,
     /* 295235 */     GIR_EraseRootFromParent_Done,
     /* 295236 */   // Label 4955: @295236
     /* 295236 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(295310), // Rule ID 13455 //
     /* 295241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295249 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 295253 */     // MIs[1] Operand 1
     /* 295253 */     // No operand predicates
     /* 295253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295262 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295274 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 295291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295308 */     GIR_RootConstrainSelectedInstOperands,
     /* 295309 */     // GIR_Coverage, 13455,
     /* 295309 */     GIR_EraseRootFromParent_Done,
     /* 295310 */   // Label 4956: @295310
     /* 295310 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(295386), // Rule ID 7793 //
     /* 295315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 295323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 295327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295335 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295339 */     // MIs[2] Operand 1
     /* 295339 */     // No operand predicates
     /* 295339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295341 */     // (fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 295368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 295372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295384 */     GIR_RootConstrainSelectedInstOperands,
     /* 295385 */     // GIR_Coverage, 7793,
     /* 295385 */     GIR_EraseRootFromParent_Done,
     /* 295386 */   // Label 4957: @295386
     /* 295386 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(295462), // Rule ID 13459 //
     /* 295391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295399 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295403 */     // MIs[1] Operand 1
     /* 295403 */     // No operand predicates
     /* 295403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 295411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 295415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295417 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295429 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 295444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 295448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295460 */     GIR_RootConstrainSelectedInstOperands,
     /* 295461 */     // GIR_Coverage, 13459,
     /* 295461 */     GIR_EraseRootFromParent_Done,
     /* 295462 */   // Label 4958: @295462
     /* 295462 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(295524), // Rule ID 13457 //
     /* 295467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295475 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295479 */     // MIs[1] Operand 1
     /* 295479 */     // No operand predicates
     /* 295479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295481 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295493 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 295510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295522 */     GIR_RootConstrainSelectedInstOperands,
     /* 295523 */     // GIR_Coverage, 13457,
     /* 295523 */     GIR_EraseRootFromParent_Done,
     /* 295524 */   // Label 4959: @295524
     /* 295524 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(295586), // Rule ID 7791 //
     /* 295529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295537 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295541 */     // MIs[1] Operand 1
     /* 295541 */     // No operand predicates
     /* 295541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295543 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295555 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295584 */     GIR_RootConstrainSelectedInstOperands,
     /* 295585 */     // GIR_Coverage, 7791,
     /* 295585 */     GIR_EraseRootFromParent_Done,
     /* 295586 */   // Label 4960: @295586
     /* 295586 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(295645), // Rule ID 914 //
     /* 295591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 295594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295608 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 295611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 295638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 295643 */     GIR_RootConstrainSelectedInstOperands,
     /* 295644 */     // GIR_Coverage, 914,
     /* 295644 */     GIR_EraseRootFromParent_Done,
     /* 295645 */   // Label 4961: @295645
     /* 295645 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(295704), // Rule ID 933 //
     /* 295650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 295653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295667 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 295670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 295697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 295702 */     GIR_RootConstrainSelectedInstOperands,
     /* 295703 */     // GIR_Coverage, 933,
     /* 295703 */     GIR_EraseRootFromParent_Done,
     /* 295704 */   // Label 4962: @295704
     /* 295704 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(295763), // Rule ID 8449 //
     /* 295709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 295712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295726 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 295729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 295736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 295741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 295746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 295756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 295761 */     GIR_RootConstrainSelectedInstOperands,
     /* 295762 */     // GIR_Coverage, 8449,
     /* 295762 */     GIR_EraseRootFromParent_Done,
     /* 295763 */   // Label 4963: @295763
     /* 295763 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(295822), // Rule ID 8463 //
     /* 295768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 295771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295785 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 295788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 295795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 295800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 295805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 295815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 295820 */     GIR_RootConstrainSelectedInstOperands,
     /* 295821 */     // GIR_Coverage, 8463,
     /* 295821 */     GIR_EraseRootFromParent_Done,
     /* 295822 */   // Label 4964: @295822
     /* 295822 */   GIM_Reject,
     /* 295823 */ // Label 4954: @295823
     /* 295823 */ GIM_Reject,
     /* 295824 */ // Label 4940: @295824
     /* 295824 */ GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(295895), // Rule ID 1093 //
     /* 295829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 295832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 295835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295853 */   // (fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 295853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 295856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295893 */   GIR_RootConstrainSelectedInstOperands,
     /* 295894 */   // GIR_Coverage, 1093,
     /* 295894 */   GIR_EraseRootFromParent_Done,
     /* 295895 */ // Label 4965: @295895
     /* 295895 */ GIM_Reject,
     /* 295896 */ // Label 4941: @295896
     /* 295896 */ GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(295970), // Rule ID 1310 //
     /* 295901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 295904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 295914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295928 */   // (fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 295928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 295931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295968 */   GIR_RootConstrainSelectedInstOperands,
     /* 295969 */   // GIR_Coverage, 1310,
     /* 295969 */   GIR_EraseRootFromParent_Done,
     /* 295970 */ // Label 4966: @295970
     /* 295970 */ GIM_Reject,
     /* 295971 */ // Label 4942: @295971
     /* 295971 */ GIM_Reject,
     /* 295972 */ // Label 63: @295972
     /* 295972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4972*/ GIMT_Encode4(297840),
     /* 295983 */ /*GILLT_s16*//*Label 4967*/ GIMT_Encode4(296003),
     /* 295987 */ /*GILLT_s32*//*Label 4968*/ GIMT_Encode4(296668),
     /* 295991 */ /*GILLT_s64*//*Label 4969*/ GIMT_Encode4(297421),
     /* 295995 */ /*GILLT_v2s16*//*Label 4970*/ GIMT_Encode4(297653),
     /* 295999 */ /*GILLT_v2s32*//*Label 4971*/ GIMT_Encode4(297745),
     /* 296003 */ // Label 4967: @296003
     /* 296003 */ GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(296667),
     /* 296008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 296011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 296014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 296017 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(296056), // Rule ID 113 //
     /* 296022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 296025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13770),
     /* 296045 */     // (fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13770>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 296045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 296050 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 296054 */     GIR_RootConstrainSelectedInstOperands,
     /* 296055 */     // GIR_Coverage, 113,
     /* 296055 */     GIR_Done,
     /* 296056 */   // Label 4974: @296056
     /* 296056 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(296126), // Rule ID 7501 //
     /* 296061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 296064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296089 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 296089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_e64),
     /* 296092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296124 */     GIR_RootConstrainSelectedInstOperands,
     /* 296125 */     // GIR_Coverage, 7501,
     /* 296125 */     GIR_EraseRootFromParent_Done,
     /* 296126 */   // Label 4975: @296126
     /* 296126 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(296199), // Rule ID 7502 //
     /* 296131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /* 296134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 296138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296159 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 296159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_t16_e64),
     /* 296162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296197 */     GIR_RootConstrainSelectedInstOperands,
     /* 296198 */     // GIR_Coverage, 7502,
     /* 296198 */     GIR_EraseRootFromParent_Done,
     /* 296199 */   // Label 4976: @296199
     /* 296199 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(296269), // Rule ID 7503 //
     /* 296204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /* 296207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296232 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 296232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_fake16_e64),
     /* 296235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296267 */     GIR_RootConstrainSelectedInstOperands,
     /* 296268 */     // GIR_Coverage, 7503,
     /* 296268 */     GIR_EraseRootFromParent_Done,
     /* 296269 */   // Label 4977: @296269
     /* 296269 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(296349), // Rule ID 1000 //
     /* 296274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 296277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 296288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296302 */     // (fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 296302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 296305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 296342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 296347 */     GIR_RootConstrainSelectedInstOperands,
     /* 296348 */     // GIR_Coverage, 1000,
     /* 296348 */     GIR_EraseRootFromParent_Done,
     /* 296349 */   // Label 4978: @296349
     /* 296349 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(296429), // Rule ID 8476 //
     /* 296354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 296357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 296375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296382 */     // (fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 296382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 296385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 296392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 296402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 296422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 296427 */     GIR_RootConstrainSelectedInstOperands,
     /* 296428 */     // GIR_Coverage, 8476,
     /* 296428 */     GIR_EraseRootFromParent_Done,
     /* 296429 */   // Label 4979: @296429
     /* 296429 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(296508), // Rule ID 1008 //
     /* 296434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 296437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296462 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 296465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296506 */     GIR_RootConstrainSelectedInstOperands,
     /* 296507 */     // GIR_Coverage, 1008,
     /* 296507 */     GIR_EraseRootFromParent_Done,
     /* 296508 */   // Label 4980: @296508
     /* 296508 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(296587), // Rule ID 1010 //
     /* 296513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 296516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 296520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296541 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 296544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296585 */     GIR_RootConstrainSelectedInstOperands,
     /* 296586 */     // GIR_Coverage, 1010,
     /* 296586 */     GIR_EraseRootFromParent_Done,
     /* 296587 */   // Label 4981: @296587
     /* 296587 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(296666), // Rule ID 1012 //
     /* 296592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 296595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296620 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 296623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296664 */     GIR_RootConstrainSelectedInstOperands,
     /* 296665 */     // GIR_Coverage, 1012,
     /* 296665 */     GIR_EraseRootFromParent_Done,
     /* 296666 */   // Label 4982: @296666
     /* 296666 */   GIM_Reject,
     /* 296667 */ // Label 4973: @296667
     /* 296667 */ GIM_Reject,
     /* 296668 */ // Label 4968: @296668
     /* 296668 */ GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(297420),
     /* 296673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 296676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 296679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 296682 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(296761), // Rule ID 2732 //
     /* 296687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296715 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296759 */     GIR_RootConstrainSelectedInstOperands,
     /* 296760 */     // GIR_Coverage, 2732,
     /* 296760 */     GIR_EraseRootFromParent_Done,
     /* 296761 */   // Label 4984: @296761
     /* 296761 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(296840), // Rule ID 2733 //
     /* 296766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296794 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 296794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296838 */     GIR_RootConstrainSelectedInstOperands,
     /* 296839 */     // GIR_Coverage, 2733,
     /* 296839 */     GIR_EraseRootFromParent_Done,
     /* 296840 */   // Label 4985: @296840
     /* 296840 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(296919), // Rule ID 2734 //
     /* 296845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296873 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296917 */     GIR_RootConstrainSelectedInstOperands,
     /* 296918 */     // GIR_Coverage, 2734,
     /* 296918 */     GIR_EraseRootFromParent_Done,
     /* 296919 */   // Label 4986: @296919
     /* 296919 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(296998), // Rule ID 8519 //
     /* 296924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296952 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 296962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 296972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296996 */     GIR_RootConstrainSelectedInstOperands,
     /* 296997 */     // GIR_Coverage, 8519,
     /* 296997 */     GIR_EraseRootFromParent_Done,
     /* 296998 */   // Label 4987: @296998
     /* 296998 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(297077), // Rule ID 8520 //
     /* 297003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 297006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 297017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297031 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 297031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 297034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 297041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 297051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 297061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297075 */     GIR_RootConstrainSelectedInstOperands,
     /* 297076 */     // GIR_Coverage, 8520,
     /* 297076 */     GIR_EraseRootFromParent_Done,
     /* 297077 */   // Label 4988: @297077
     /* 297077 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(297156), // Rule ID 8521 //
     /* 297082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 297085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 297110 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 297110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 297113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 297120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 297130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 297140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297154 */     GIR_RootConstrainSelectedInstOperands,
     /* 297155 */     // GIR_Coverage, 8521,
     /* 297155 */     GIR_EraseRootFromParent_Done,
     /* 297156 */   // Label 4989: @297156
     /* 297156 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(297195), // Rule ID 111 //
     /* 297161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 297164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13770),
     /* 297184 */     // (fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13770>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 297184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 297189 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 297193 */     GIR_RootConstrainSelectedInstOperands,
     /* 297194 */     // GIR_Coverage, 111,
     /* 297194 */     GIR_Done,
     /* 297195 */   // Label 4990: @297195
     /* 297195 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(297265), // Rule ID 7500 //
     /* 297200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /* 297203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297228 */     // (fma:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 297228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F32_e64),
     /* 297231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297263 */     GIR_RootConstrainSelectedInstOperands,
     /* 297264 */     // GIR_Coverage, 7500,
     /* 297264 */     GIR_EraseRootFromParent_Done,
     /* 297265 */   // Label 4991: @297265
     /* 297265 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(297342), // Rule ID 926 //
     /* 297270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297295 */     // (fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 297298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297340 */     GIR_RootConstrainSelectedInstOperands,
     /* 297341 */     // GIR_Coverage, 926,
     /* 297341 */     GIR_EraseRootFromParent_Done,
     /* 297342 */   // Label 4992: @297342
     /* 297342 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(297419), // Rule ID 8457 //
     /* 297347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297372 */     // (fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 297375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297417 */     GIR_RootConstrainSelectedInstOperands,
     /* 297418 */     // GIR_Coverage, 8457,
     /* 297418 */     GIR_EraseRootFromParent_Done,
     /* 297419 */   // Label 4993: @297419
     /* 297419 */   GIM_Reject,
     /* 297420 */ // Label 4983: @297420
     /* 297420 */ GIM_Reject,
     /* 297421 */ // Label 4969: @297421
     /* 297421 */ GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(297652),
     /* 297426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 297435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 297439 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(297505), // Rule ID 7504 //
     /* 297444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmacF64Inst),
     /* 297447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297468 */     // (fma:{ *:[f64] } (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src0), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src1), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src2))  =>  (V_FMAC_F64_e64:{ *:[f64] } 0:{ *:[i32] }, ?:{ *:[f64] }:$src0, 0:{ *:[i32] }, ?:{ *:[f64] }:$src1, 0:{ *:[i32] }, ?:{ *:[f64] }:$src2)
     /* 297468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F64_e64),
     /* 297471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297503 */     GIR_RootConstrainSelectedInstOperands,
     /* 297504 */     // GIR_Coverage, 7504,
     /* 297504 */     GIR_EraseRootFromParent_Done,
     /* 297505 */   // Label 4995: @297505
     /* 297505 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(297578), // Rule ID 929 //
     /* 297510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297531 */     // (fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 297534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297576 */     GIR_RootConstrainSelectedInstOperands,
     /* 297577 */     // GIR_Coverage, 929,
     /* 297577 */     GIR_EraseRootFromParent_Done,
     /* 297578 */   // Label 4996: @297578
     /* 297578 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(297651), // Rule ID 8459 //
     /* 297583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297604 */     // (fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 297607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297649 */     GIR_RootConstrainSelectedInstOperands,
     /* 297650 */     // GIR_Coverage, 8459,
     /* 297650 */     GIR_EraseRootFromParent_Done,
     /* 297651 */   // Label 4997: @297651
     /* 297651 */   GIM_Reject,
     /* 297652 */ // Label 4994: @297652
     /* 297652 */ GIM_Reject,
     /* 297653 */ // Label 4970: @297653
     /* 297653 */ GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(297744), // Rule ID 1089 //
     /* 297658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 297661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 297664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 297667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297692 */   // (fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 297692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 297695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297742 */   GIR_RootConstrainSelectedInstOperands,
     /* 297743 */   // GIR_Coverage, 1089,
     /* 297743 */   GIR_EraseRootFromParent_Done,
     /* 297744 */ // Label 4998: @297744
     /* 297744 */ GIM_Reject,
     /* 297745 */ // Label 4971: @297745
     /* 297745 */ GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(297839), // Rule ID 1308 //
     /* 297750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 297753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 297756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 297766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297780 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297787 */   // (fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 297787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 297790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297837 */   GIR_RootConstrainSelectedInstOperands,
     /* 297838 */   // GIR_Coverage, 1308,
     /* 297838 */   GIR_EraseRootFromParent_Done,
     /* 297839 */ // Label 4999: @297839
     /* 297839 */ GIM_Reject,
     /* 297840 */ // Label 4972: @297840
     /* 297840 */ GIM_Reject,
     /* 297841 */ // Label 64: @297841
     /* 297841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5002*/ GIMT_Encode4(298786),
     /* 297852 */ /*GILLT_s16*//*Label 5000*/ GIMT_Encode4(297860),
     /* 297856 */ /*GILLT_s32*//*Label 5001*/ GIMT_Encode4(298098),
     /* 297860 */ // Label 5000: @297860
     /* 297860 */ GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(298097),
     /* 297865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 297868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 297871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 297874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297878 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(297944), // Rule ID 7007 //
     /* 297883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 297886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297907 */     // (fmad:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 297910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297942 */     GIR_RootConstrainSelectedInstOperands,
     /* 297943 */     // GIR_Coverage, 7007,
     /* 297943 */     GIR_EraseRootFromParent_Done,
     /* 297944 */   // Label 5004: @297944
     /* 297944 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(298020), // Rule ID 1013 //
     /* 297949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 297952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297973 */     // (fmad:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 297976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298018 */     GIR_RootConstrainSelectedInstOperands,
     /* 298019 */     // GIR_Coverage, 1013,
     /* 298019 */     GIR_EraseRootFromParent_Done,
     /* 298020 */   // Label 5005: @298020
     /* 298020 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(298096), // Rule ID 8477 //
     /* 298025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 298028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298049 */     // (fmad:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 298052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298094 */     GIR_RootConstrainSelectedInstOperands,
     /* 298095 */     // GIR_Coverage, 8477,
     /* 298095 */     GIR_EraseRootFromParent_Done,
     /* 298096 */   // Label 5006: @298096
     /* 298096 */   GIM_Reject,
     /* 298097 */ // Label 5003: @298097
     /* 298097 */ GIM_Reject,
     /* 298098 */ // Label 5001: @298098
     /* 298098 */ GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(298785),
     /* 298103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 298106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 298109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 298112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298116 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(298191), // Rule ID 2716 //
     /* 298121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298145 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298189 */     GIR_RootConstrainSelectedInstOperands,
     /* 298190 */     // GIR_Coverage, 2716,
     /* 298190 */     GIR_EraseRootFromParent_Done,
     /* 298191 */   // Label 5008: @298191
     /* 298191 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(298266), // Rule ID 2717 //
     /* 298196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298220 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 298220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298264 */     GIR_RootConstrainSelectedInstOperands,
     /* 298265 */     // GIR_Coverage, 2717,
     /* 298265 */     GIR_EraseRootFromParent_Done,
     /* 298266 */   // Label 5009: @298266
     /* 298266 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(298341), // Rule ID 2718 //
     /* 298271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298295 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298339 */     GIR_RootConstrainSelectedInstOperands,
     /* 298340 */     // GIR_Coverage, 2718,
     /* 298340 */     GIR_EraseRootFromParent_Done,
     /* 298341 */   // Label 5010: @298341
     /* 298341 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(298407), // Rule ID 7001 //
     /* 298346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298370 */     // (fmad:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 298370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 298373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298405 */     GIR_RootConstrainSelectedInstOperands,
     /* 298406 */     // GIR_Coverage, 7001,
     /* 298406 */     GIR_EraseRootFromParent_Done,
     /* 298407 */   // Label 5011: @298407
     /* 298407 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(298482), // Rule ID 8516 //
     /* 298412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298436 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298480 */     GIR_RootConstrainSelectedInstOperands,
     /* 298481 */     // GIR_Coverage, 8516,
     /* 298481 */     GIR_EraseRootFromParent_Done,
     /* 298482 */   // Label 5012: @298482
     /* 298482 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(298557), // Rule ID 8517 //
     /* 298487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298511 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 298511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298555 */     GIR_RootConstrainSelectedInstOperands,
     /* 298556 */     // GIR_Coverage, 8517,
     /* 298556 */     GIR_EraseRootFromParent_Done,
     /* 298557 */   // Label 5013: @298557
     /* 298557 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(298632), // Rule ID 8518 //
     /* 298562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298586 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298630 */     GIR_RootConstrainSelectedInstOperands,
     /* 298631 */     // GIR_Coverage, 8518,
     /* 298631 */     GIR_EraseRootFromParent_Done,
     /* 298632 */   // Label 5014: @298632
     /* 298632 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(298708), // Rule ID 921 //
     /* 298637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298661 */     // (fmad:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 298664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298706 */     GIR_RootConstrainSelectedInstOperands,
     /* 298707 */     // GIR_Coverage, 921,
     /* 298707 */     GIR_EraseRootFromParent_Done,
     /* 298708 */   // Label 5015: @298708
     /* 298708 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(298784), // Rule ID 8454 //
     /* 298713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298737 */     // (fmad:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 298740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298782 */     GIR_RootConstrainSelectedInstOperands,
     /* 298783 */     // GIR_Coverage, 8454,
     /* 298783 */     GIR_EraseRootFromParent_Done,
     /* 298784 */   // Label 5016: @298784
     /* 298784 */   GIM_Reject,
     /* 298785 */ // Label 5007: @298785
     /* 298785 */ GIM_Reject,
     /* 298786 */ // Label 5002: @298786
     /* 298786 */ GIM_Reject,
     /* 298787 */ // Label 65: @298787
     /* 298787 */ GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(298904), // Rule ID 7317 //
     /* 298792 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 298795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 298798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 298801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298812 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298819 */   // (fpow:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_EXP_F32_e64:{ *:[f32] } 0:{ *:[i32] }, (V_MUL_LEGACY_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, (V_LOG_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0), 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 298819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 298822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 298826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298841 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 298844 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 298847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 298849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 298852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 298856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298871 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298874 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298877 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298880 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 298888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298902 */   GIR_RootConstrainSelectedInstOperands,
     /* 298903 */   // GIR_Coverage, 7317,
     /* 298903 */   GIR_EraseRootFromParent_Done,
     /* 298904 */ // Label 5017: @298904
     /* 298904 */ GIM_Reject,
     /* 298905 */ // Label 66: @298905
     /* 298905 */ GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(299127),
     /* 298910 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 298913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298916 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(298987), // Rule ID 2690 //
     /* 298921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 298924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21505),
     /* 298932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298939 */     // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21505>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 298939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 298946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298986 */     // GIR_Coverage, 2690,
     /* 298986 */     GIR_EraseRootFromParent_Done,
     /* 298987 */   // Label 5019: @298987
     /* 298987 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(299081),
     /* 298992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298996 */     GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(299038), // Rule ID 742 //
     /* 299001 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 299004 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299011 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299011 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 299014 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299016 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299021 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299026 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299031 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299036 */       GIR_RootConstrainSelectedInstOperands,
     /* 299037 */       // GIR_Coverage, 742,
     /* 299037 */       GIR_EraseRootFromParent_Done,
     /* 299038 */     // Label 5021: @299038
     /* 299038 */     GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(299080), // Rule ID 746 //
     /* 299043 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299046 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299053 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 299056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299058 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299063 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299068 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299073 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299078 */       GIR_RootConstrainSelectedInstOperands,
     /* 299079 */       // GIR_Coverage, 746,
     /* 299079 */       GIR_EraseRootFromParent_Done,
     /* 299080 */     // Label 5022: @299080
     /* 299080 */     GIM_Reject,
     /* 299081 */   // Label 5020: @299081
     /* 299081 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(299126), // Rule ID 744 //
     /* 299086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 299100 */     // (fexp2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 299100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 299103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299124 */     GIR_RootConstrainSelectedInstOperands,
     /* 299125 */     // GIR_Coverage, 744,
     /* 299125 */     GIR_EraseRootFromParent_Done,
     /* 299126 */   // Label 5023: @299126
     /* 299126 */   GIM_Reject,
     /* 299127 */ // Label 5018: @299127
     /* 299127 */ GIM_Reject,
     /* 299128 */ // Label 67: @299128
     /* 299128 */ GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(299350),
     /* 299133 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 299136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299139 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(299210), // Rule ID 2692 //
     /* 299144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 299147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 299151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21507),
     /* 299155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299162 */     // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21507>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 299162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 299165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 299169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 299209 */     // GIR_Coverage, 2692,
     /* 299209 */     GIR_EraseRootFromParent_Done,
     /* 299210 */   // Label 5025: @299210
     /* 299210 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(299304),
     /* 299215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299219 */     GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(299261), // Rule ID 736 //
     /* 299224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 299227 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299234 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299234 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 299237 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299239 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299244 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299249 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299254 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299259 */       GIR_RootConstrainSelectedInstOperands,
     /* 299260 */       // GIR_Coverage, 736,
     /* 299260 */       GIR_EraseRootFromParent_Done,
     /* 299261 */     // Label 5027: @299261
     /* 299261 */     GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(299303), // Rule ID 740 //
     /* 299266 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299269 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299276 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299276 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 299279 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299281 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299286 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299291 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299296 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299301 */       GIR_RootConstrainSelectedInstOperands,
     /* 299302 */       // GIR_Coverage, 740,
     /* 299302 */       GIR_EraseRootFromParent_Done,
     /* 299303 */     // Label 5028: @299303
     /* 299303 */     GIM_Reject,
     /* 299304 */   // Label 5026: @299304
     /* 299304 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(299349), // Rule ID 738 //
     /* 299309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 299323 */     // (flog2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 299323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 299326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299347 */     GIR_RootConstrainSelectedInstOperands,
     /* 299348 */     // GIR_Coverage, 738,
     /* 299348 */     GIR_EraseRootFromParent_Done,
     /* 299349 */   // Label 5029: @299349
     /* 299349 */   GIM_Reject,
     /* 299350 */ // Label 5024: @299350
     /* 299350 */ GIM_Reject,
     /* 299351 */ // Label 68: @299351
     /* 299351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5033*/ GIMT_Encode4(299713),
     /* 299362 */ /*GILLT_s16*//*Label 5030*/ GIMT_Encode4(299374),
     /* 299366 */ /*GILLT_s32*//*Label 5031*/ GIMT_Encode4(299579),
     /* 299370 */ /*GILLT_s64*//*Label 5032*/ GIMT_Encode4(299646),
     /* 299374 */ // Label 5030: @299374
     /* 299374 */ GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(299578),
     /* 299379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 299385 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(299448), // Rule ID 2506 //
     /* 299390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 299393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299411 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 299411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 299414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299446 */     GIR_RootConstrainSelectedInstOperands,
     /* 299447 */     // GIR_Coverage, 2506,
     /* 299447 */     GIR_EraseRootFromParent_Done,
     /* 299448 */   // Label 5035: @299448
     /* 299448 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(299514), // Rule ID 2508 //
     /* 299453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299474 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 299474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 299477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299512 */     GIR_RootConstrainSelectedInstOperands,
     /* 299513 */     // GIR_Coverage, 2508,
     /* 299513 */     GIR_EraseRootFromParent_Done,
     /* 299514 */   // Label 5036: @299514
     /* 299514 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(299577), // Rule ID 2510 //
     /* 299519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299540 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 299540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 299543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299575 */     GIR_RootConstrainSelectedInstOperands,
     /* 299576 */     // GIR_Coverage, 2510,
     /* 299576 */     GIR_EraseRootFromParent_Done,
     /* 299577 */   // Label 5037: @299577
     /* 299577 */   GIM_Reject,
     /* 299578 */ // Label 5034: @299578
     /* 299578 */ GIM_Reject,
     /* 299579 */ // Label 5031: @299579
     /* 299579 */ GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(299645), // Rule ID 821 //
     /* 299584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 299590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299608 */   // (fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 299611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299643 */   GIR_RootConstrainSelectedInstOperands,
     /* 299644 */   // GIR_Coverage, 821,
     /* 299644 */   GIR_EraseRootFromParent_Done,
     /* 299645 */ // Label 5038: @299645
     /* 299645 */ GIM_Reject,
     /* 299646 */ // Label 5032: @299646
     /* 299646 */ GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(299712), // Rule ID 981 //
     /* 299651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 299657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 299661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299675 */   // (fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299710 */   GIR_RootConstrainSelectedInstOperands,
     /* 299711 */   // GIR_Coverage, 981,
     /* 299711 */   GIR_EraseRootFromParent_Done,
     /* 299712 */ // Label 5039: @299712
     /* 299712 */ GIM_Reject,
     /* 299713 */ // Label 5033: @299713
     /* 299713 */ GIM_Reject,
     /* 299714 */ // Label 69: @299714
     /* 299714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5045*/ GIMT_Encode4(301576),
     /* 299725 */ /*GILLT_s16*//*Label 5040*/ GIMT_Encode4(299745),
     /* 299729 */ /*GILLT_s32*//*Label 5041*/ GIMT_Encode4(300231),
     /* 299733 */ /*GILLT_s64*//*Label 5042*/ GIMT_Encode4(300485),
     /* 299737 */ /*GILLT_v2s16*//*Label 5043*/ GIMT_Encode4(301163),
     /* 299741 */ /*GILLT_v2s32*//*Label 5044*/ GIMT_Encode4(301519),
     /* 299745 */ // Label 5040: @299745
     /* 299745 */ GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(300230),
     /* 299750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299753 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(299826), // Rule ID 7237 //
     /* 299758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 299783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299785 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src))<<P:Predicate_anonymous_34508>>  =>  (S_OR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 299785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 299788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299797 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 299812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 299814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 299824 */     GIR_RootConstrainSelectedInstOperands,
     /* 299825 */     // GIR_Coverage, 7237,
     /* 299825 */     GIR_EraseRootFromParent_Done,
     /* 299826 */   // Label 5047: @299826
     /* 299826 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(299895), // Rule ID 7253 //
     /* 299831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 299834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299857 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299869 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 299884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299893 */     GIR_RootConstrainSelectedInstOperands,
     /* 299894 */     // GIR_Coverage, 7253,
     /* 299894 */     GIR_EraseRootFromParent_Done,
     /* 299895 */   // Label 5048: @299895
     /* 299895 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(299956), // Rule ID 7256 //
     /* 299900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299926 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src))  =>  (V_OR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 299926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /* 299929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299934 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 299944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299954 */     GIR_RootConstrainSelectedInstOperands,
     /* 299955 */     // GIR_Coverage, 7256,
     /* 299955 */     GIR_EraseRootFromParent_Done,
     /* 299956 */   // Label 5049: @299956
     /* 299956 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(300025), // Rule ID 7259 //
     /* 299961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299987 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299999 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 300009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 300014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 300023 */     GIR_RootConstrainSelectedInstOperands,
     /* 300024 */     // GIR_Coverage, 7259,
     /* 300024 */     GIR_EraseRootFromParent_Done,
     /* 300025 */   // Label 5050: @300025
     /* 300025 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(300081), // Rule ID 7235 //
     /* 300030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 300042 */     // (fneg:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34508>>  =>  (S_XOR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 300042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 300045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300054 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 300064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 300069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300071 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300079 */     GIR_RootConstrainSelectedInstOperands,
     /* 300080 */     // GIR_Coverage, 7235,
     /* 300080 */     GIR_EraseRootFromParent_Done,
     /* 300081 */   // Label 5051: @300081
     /* 300081 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(300133), // Rule ID 7252 //
     /* 300086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 300089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300097 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 300097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300109 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 300119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 300124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300129 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300131 */     GIR_RootConstrainSelectedInstOperands,
     /* 300132 */     // GIR_Coverage, 7252,
     /* 300132 */     GIR_EraseRootFromParent_Done,
     /* 300133 */   // Label 5052: @300133
     /* 300133 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(300177), // Rule ID 7255 //
     /* 300138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 300141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 300145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 300149 */     // (fneg:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_XOR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 300149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /* 300152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300157 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 300167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300175 */     GIR_RootConstrainSelectedInstOperands,
     /* 300176 */     // GIR_Coverage, 7255,
     /* 300176 */     GIR_EraseRootFromParent_Done,
     /* 300177 */   // Label 5053: @300177
     /* 300177 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(300229), // Rule ID 7258 //
     /* 300182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 300185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300193 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 300193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300205 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 300215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 300220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300227 */     GIR_RootConstrainSelectedInstOperands,
     /* 300228 */     // GIR_Coverage, 7258,
     /* 300228 */     GIR_EraseRootFromParent_Done,
     /* 300229 */   // Label 5054: @300229
     /* 300229 */   GIM_Reject,
     /* 300230 */ // Label 5046: @300230
     /* 300230 */ GIM_Reject,
     /* 300231 */ // Label 5041: @300231
     /* 300231 */ GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(300484),
     /* 300236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300239 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(300312), // Rule ID 7232 //
     /* 300244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 300269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300271 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src))<<P:Predicate_anonymous_34508>>  =>  (S_OR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 300271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 300274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300283 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 300298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 300304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300310 */     GIR_RootConstrainSelectedInstOperands,
     /* 300311 */     // GIR_Coverage, 7232,
     /* 300311 */     GIR_EraseRootFromParent_Done,
     /* 300312 */   // Label 5056: @300312
     /* 300312 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(300378), // Rule ID 7248 //
     /* 300317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300340 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src))  =>  (V_OR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 300340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300352 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 300367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 300376 */     GIR_RootConstrainSelectedInstOperands,
     /* 300377 */     // GIR_Coverage, 7248,
     /* 300377 */     GIR_EraseRootFromParent_Done,
     /* 300378 */   // Label 5057: @300378
     /* 300378 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(300434), // Rule ID 7234 //
     /* 300383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 300395 */     // (fneg:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34508>>  =>  (S_XOR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 300395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 300398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300407 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 300422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300424 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300432 */     GIR_RootConstrainSelectedInstOperands,
     /* 300433 */     // GIR_Coverage, 7234,
     /* 300433 */     GIR_EraseRootFromParent_Done,
     /* 300434 */   // Label 5058: @300434
     /* 300434 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(300483), // Rule ID 7250 //
     /* 300439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300447 */     // (fneg:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_XOR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 300447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300459 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 300474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300479 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300481 */     GIR_RootConstrainSelectedInstOperands,
     /* 300482 */     // GIR_Coverage, 7250,
     /* 300482 */     GIR_EraseRootFromParent_Done,
     /* 300483 */   // Label 5059: @300483
     /* 300483 */   GIM_Reject,
     /* 300484 */ // Label 5055: @300484
     /* 300484 */ GIM_Reject,
     /* 300485 */ // Label 5042: @300485
     /* 300485 */ GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(301162),
     /* 300490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300493 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(300681), // Rule ID 7247 //
     /* 300498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 300523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300525 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src))<<P:Predicate_anonymous_34508>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_OR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 300525 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 300528 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300532 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300537 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 300547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 300549 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300552 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300556 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300561 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300567 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300572 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 300580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 300584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300589 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 300592 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 300595 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 300598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300600 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300603 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300607 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300612 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300632 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300656 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300662 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300680 */     // GIR_Coverage, 7247,
     /* 300680 */     GIR_EraseRootFromParent_Done,
     /* 300681 */   // Label 5061: @300681
     /* 300681 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(300842), // Rule ID 7265 //
     /* 300686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300709 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src))  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_OR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 300709 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300712 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300716 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300721 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300727 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300732 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300737 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 300740 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300744 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300749 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 300759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 300764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 300768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300776 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 300779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 300781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300793 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300817 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300823 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300841 */     // GIR_Coverage, 7265,
     /* 300841 */     GIR_EraseRootFromParent_Done,
     /* 300842 */   // Label 5062: @300842
     /* 300842 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(301015), // Rule ID 7246 //
     /* 300847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 300859 */     // (fneg:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34508>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_XOR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 300859 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 300862 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300866 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300871 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 300881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 300883 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300886 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300890 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300895 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300901 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300906 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 300914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 300918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300923 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 300926 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 300929 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 300932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300946 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300966 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300990 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300996 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 301004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 301009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 301014 */     // GIR_Coverage, 7246,
     /* 301014 */     GIR_EraseRootFromParent_Done,
     /* 301015 */   // Label 5063: @301015
     /* 301015 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(301161), // Rule ID 7264 //
     /* 301020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301028 */     // (fneg:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_XOR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 301028 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 301031 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301035 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301040 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 301046 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301051 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 301059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301068 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 301078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 301080 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 301083 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 301087 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301092 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 301095 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 301098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 301100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 301103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 301107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301112 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 301118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 301131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301136 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 301139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 301142 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 301145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301160 */     // GIR_Coverage, 7264,
     /* 301160 */     GIR_EraseRootFromParent_Done,
     /* 301161 */   // Label 5064: @301161
     /* 301161 */   GIM_Reject,
     /* 301162 */ // Label 5060: @301162
     /* 301162 */ GIM_Reject,
     /* 301163 */ // Label 5043: @301163
     /* 301163 */ GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(301518),
     /* 301168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301171 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(301273), // Rule ID 7240 //
     /* 301176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 301188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 301200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 301204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 301208 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 301210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301215 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2147450879),
     /* 301226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 301230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301232 */     // (fneg:{ *:[v2f16] } (bitconvert:{ *:[v2f16] } (and:{ *:[i32] } SReg_32:{ *:[i32] }:$src, 2147450879:{ *:[i32] })<<P:Predicate_and_oneuse>>))<<P:Predicate_anonymous_34508>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 301232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 301235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301244 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 301259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 301261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 301265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 301271 */     GIR_RootConstrainSelectedInstOperands,
     /* 301272 */     // GIR_Coverage, 7240,
     /* 301272 */     GIR_EraseRootFromParent_Done,
     /* 301273 */   // Label 5066: @301273
     /* 301273 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(301346), // Rule ID 7241 //
     /* 301278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 301290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 301303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301305 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src))<<P:Predicate_anonymous_34508>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 301305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 301308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301317 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 301332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 301334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 301338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 301344 */     GIR_RootConstrainSelectedInstOperands,
     /* 301345 */     // GIR_Coverage, 7241,
     /* 301345 */     GIR_EraseRootFromParent_Done,
     /* 301346 */   // Label 5067: @301346
     /* 301346 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(301412), // Rule ID 7262 //
     /* 301351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 301363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301374 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src))  =>  (V_OR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 301374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301386 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 301401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 301410 */     GIR_RootConstrainSelectedInstOperands,
     /* 301411 */     // GIR_Coverage, 7262,
     /* 301411 */     GIR_EraseRootFromParent_Done,
     /* 301412 */   // Label 5068: @301412
     /* 301412 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(301468), // Rule ID 7238 //
     /* 301417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34508),
     /* 301429 */     // (fneg:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34508>>  =>  (S_XOR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 301429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 301432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301441 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 301456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 301458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 301466 */     GIR_RootConstrainSelectedInstOperands,
     /* 301467 */     // GIR_Coverage, 7238,
     /* 301467 */     GIR_EraseRootFromParent_Done,
     /* 301468 */   // Label 5069: @301468
     /* 301468 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(301517), // Rule ID 7260 //
     /* 301473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301481 */     // (fneg:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 301481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301493 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 301508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301515 */     GIR_RootConstrainSelectedInstOperands,
     /* 301516 */     // GIR_Coverage, 7260,
     /* 301516 */     GIR_EraseRootFromParent_Done,
     /* 301517 */   // Label 5070: @301517
     /* 301517 */   GIM_Reject,
     /* 301518 */ // Label 5065: @301518
     /* 301518 */ GIM_Reject,
     /* 301519 */ // Label 5044: @301519
     /* 301519 */ GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(301575), // Rule ID 7266 //
     /* 301524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 301527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301538 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34556),
     /* 301542 */   // (fneg:{ *:[v2f32] } VReg_64:{ *:[v2f32] }:$src)<<P:Predicate_anonymous_34556>>  =>  (V_PK_ADD_F32:{ *:[v2f32] } 11:{ *:[i32] }, VReg_64:{ *:[v2f32] }:$src, 11:{ *:[i32] }, 0:{ *:[i64] }, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 301542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 301545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 301550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 301555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301573 */   GIR_RootConstrainSelectedInstOperands,
     /* 301574 */   // GIR_Coverage, 7266,
     /* 301574 */   GIR_EraseRootFromParent_Done,
     /* 301575 */ // Label 5071: @301575
     /* 301575 */ GIM_Reject,
     /* 301576 */ // Label 5045: @301576
     /* 301576 */ GIM_Reject,
     /* 301577 */ // Label 70: @301577
     /* 301577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 5074*/ GIMT_Encode4(301976),
     /* 301588 */ /*GILLT_s32*//*Label 5072*/ GIMT_Encode4(301596),
     /* 301592 */ /*GILLT_s64*//*Label 5073*/ GIMT_Encode4(301770),
     /* 301596 */ // Label 5072: @301596
     /* 301596 */ GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(301769),
     /* 301601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301604 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(301631), // Rule ID 31 //
     /* 301609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 301612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13737),
     /* 301620 */     // (fpextend:{ *:[f32] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13737>>  =>  (S_CVT_F32_F16:{ *:[f32] } f16:{ *:[f16] }:$src0)
     /* 301620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_F16),
     /* 301625 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 301629 */     GIR_RootConstrainSelectedInstOperands,
     /* 301630 */     // GIR_Coverage, 31,
     /* 301630 */     GIR_Done,
     /* 301631 */   // Label 5076: @301631
     /* 301631 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(301677), // Rule ID 644 //
     /* 301636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 301639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301650 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 301653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301675 */     GIR_RootConstrainSelectedInstOperands,
     /* 301676 */     // GIR_Coverage, 644,
     /* 301676 */     GIR_EraseRootFromParent_Done,
     /* 301677 */   // Label 5077: @301677
     /* 301677 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(301723), // Rule ID 648 //
     /* 301682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 301685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301696 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_fake16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 301699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301721 */     GIR_RootConstrainSelectedInstOperands,
     /* 301722 */     // GIR_Coverage, 648,
     /* 301722 */     GIR_EraseRootFromParent_Done,
     /* 301723 */   // Label 5078: @301723
     /* 301723 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(301768), // Rule ID 646 //
     /* 301728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 301731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 301742 */     // (fpextend:{ *:[f32] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F32_F16_t16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 301742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 301745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301766 */     GIR_RootConstrainSelectedInstOperands,
     /* 301767 */     // GIR_Coverage, 646,
     /* 301767 */     GIR_EraseRootFromParent_Done,
     /* 301768 */   // Label 5079: @301768
     /* 301768 */   GIM_Reject,
     /* 301769 */ // Label 5075: @301769
     /* 301769 */ GIM_Reject,
     /* 301770 */ // Label 5073: @301770
     /* 301770 */ GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(301822), // Rule ID 6984 //
     /* 301775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 301778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301785 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 301792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301797 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301800 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301804 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301807 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301820 */   GIR_RootConstrainSelectedInstOperands,
     /* 301821 */   // GIR_Coverage, 6984,
     /* 301821 */   GIR_EraseRootFromParent_Done,
     /* 301822 */ // Label 5080: @301822
     /* 301822 */ GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(301877), // Rule ID 6990 //
     /* 301827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 301830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301837 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 301844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301849 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301852 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301856 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301859 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301862 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301875 */   GIR_RootConstrainSelectedInstOperands,
     /* 301876 */   // GIR_Coverage, 6990,
     /* 301876 */   GIR_EraseRootFromParent_Done,
     /* 301877 */ // Label 5081: @301877
     /* 301877 */ GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(301929), // Rule ID 6996 //
     /* 301882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 301885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301892 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 301899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301904 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301911 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301914 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301927 */   GIR_RootConstrainSelectedInstOperands,
     /* 301928 */   // GIR_Coverage, 6996,
     /* 301928 */   GIR_EraseRootFromParent_Done,
     /* 301929 */ // Label 5082: @301929
     /* 301929 */ GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(301975), // Rule ID 630 //
     /* 301934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301948 */   // (fpextend:{ *:[f64] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_F32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e64),
     /* 301951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301973 */   GIR_RootConstrainSelectedInstOperands,
     /* 301974 */   // GIR_Coverage, 630,
     /* 301974 */   GIR_EraseRootFromParent_Done,
     /* 301975 */ // Label 5083: @301975
     /* 301975 */ GIM_Reject,
     /* 301976 */ // Label 5074: @301976
     /* 301976 */ GIM_Reject,
     /* 301977 */ // Label 71: @301977
     /* 301977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5087*/ GIMT_Encode4(302912),
     /* 301988 */ /*GILLT_s16*//*Label 5084*/ GIMT_Encode4(302004),
     /* 301992 */ /*GILLT_s32*//*Label 5085*/ GIMT_Encode4(302620), GIMT_Encode4(0),
     /* 302000 */ /*GILLT_v2s16*//*Label 5086*/ GIMT_Encode4(302667),
     /* 302004 */ // Label 5084: @302004
     /* 302004 */ GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(302619),
     /* 302009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302012 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(302130), // Rule ID 2738 //
     /* 302017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 302020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 302032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 302040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 302044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302067 */     // (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 302067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 302084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302128 */     GIR_RootConstrainSelectedInstOperands,
     /* 302129 */     // GIR_Coverage, 2738,
     /* 302129 */     GIR_EraseRootFromParent_Done,
     /* 302130 */   // Label 5089: @302130
     /* 302130 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(302248), // Rule ID 2722 //
     /* 302135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 302150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 302158 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 302162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302185 */     // (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 302185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 302202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302246 */     GIR_RootConstrainSelectedInstOperands,
     /* 302247 */     // GIR_Coverage, 2722,
     /* 302247 */     GIR_EraseRootFromParent_Done,
     /* 302248 */   // Label 5090: @302248
     /* 302248 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(302351), // Rule ID 2720 //
     /* 302253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 302268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 302276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302292 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 302292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 302309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302349 */     GIR_RootConstrainSelectedInstOperands,
     /* 302350 */     // GIR_Coverage, 2720,
     /* 302350 */     GIR_EraseRootFromParent_Done,
     /* 302351 */   // Label 5091: @302351
     /* 302351 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(302454), // Rule ID 2736 //
     /* 302356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 302359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 302371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 302379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302395 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 302395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 302412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302452 */     GIR_RootConstrainSelectedInstOperands,
     /* 302453 */     // GIR_Coverage, 2736,
     /* 302453 */     GIR_EraseRootFromParent_Done,
     /* 302454 */   // Label 5092: @302454
     /* 302454 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(302481), // Rule ID 36 //
     /* 302459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 302462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 302466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13742),
     /* 302470 */     // (fpround:{ *:[f16] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13742>>  =>  (S_CVT_F16_F32:{ *:[f16] } f32:{ *:[f32] }:$src0)
     /* 302470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F16_F32),
     /* 302475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 302479 */     GIR_RootConstrainSelectedInstOperands,
     /* 302480 */     // GIR_Coverage, 36,
     /* 302480 */     GIR_Done,
     /* 302481 */   // Label 5093: @302481
     /* 302481 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(302527), // Rule ID 638 //
     /* 302486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 302489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302500 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 302503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302525 */     GIR_RootConstrainSelectedInstOperands,
     /* 302526 */     // GIR_Coverage, 638,
     /* 302526 */     GIR_EraseRootFromParent_Done,
     /* 302527 */   // Label 5094: @302527
     /* 302527 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(302573), // Rule ID 642 //
     /* 302532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 302535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302546 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 302549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302571 */     GIR_RootConstrainSelectedInstOperands,
     /* 302572 */     // GIR_Coverage, 642,
     /* 302572 */     GIR_EraseRootFromParent_Done,
     /* 302573 */   // Label 5095: @302573
     /* 302573 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(302618), // Rule ID 640 //
     /* 302578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 302581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 302585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 302592 */     // (fpround:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0)
     /* 302592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 302595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302616 */     GIR_RootConstrainSelectedInstOperands,
     /* 302617 */     // GIR_Coverage, 640,
     /* 302617 */     GIR_EraseRootFromParent_Done,
     /* 302618 */   // Label 5096: @302618
     /* 302618 */   GIM_Reject,
     /* 302619 */ // Label 5088: @302619
     /* 302619 */ GIM_Reject,
     /* 302620 */ // Label 5085: @302620
     /* 302620 */ GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(302666), // Rule ID 628 //
     /* 302625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302639 */   // (fpround:{ *:[f32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F64_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302664 */   GIR_RootConstrainSelectedInstOperands,
     /* 302665 */   // GIR_Coverage, 628,
     /* 302665 */   GIR_EraseRootFromParent_Done,
     /* 302666 */ // Label 5097: @302666
     /* 302666 */ GIM_Reject,
     /* 302667 */ // Label 5086: @302667
     /* 302667 */ GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(302763), // Rule ID 2621 //
     /* 302672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 302675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302682 */   // (fpround:{ *:[v2f16] } v2f32:{ *:[v2f32] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub1:{ *:[i32] }))
     /* 302682 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 302685 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302689 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302694 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 302700 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302705 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302722 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 302728 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 302741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 302755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302761 */   GIR_RootConstrainSelectedInstOperands,
     /* 302762 */   // GIR_Coverage, 2621,
     /* 302762 */   GIR_EraseRootFromParent_Done,
     /* 302763 */ // Label 5098: @302763
     /* 302763 */ GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(302911), // Rule ID 2622 //
     /* 302768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 302771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302778 */   // (fpround:{ *:[v2f16] } v2f64:{ *:[v2f64] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub0_sub1:{ *:[i32] })), 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub2_sub3:{ *:[i32] })))
     /* 302778 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302781 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302785 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302790 */   GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(24), // src
     /* 302796 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302801 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 302806 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 302809 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302813 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302818 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302821 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302824 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302827 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 302832 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 302835 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302839 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302844 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 302850 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302855 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 302860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302872 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 302878 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302881 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 302889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 302903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302909 */   GIR_RootConstrainSelectedInstOperands,
     /* 302910 */   // GIR_Coverage, 2622,
     /* 302910 */   GIR_EraseRootFromParent_Done,
     /* 302911 */ // Label 5099: @302911
     /* 302911 */ GIM_Reject,
     /* 302912 */ // Label 5087: @302912
     /* 302912 */ GIM_Reject,
     /* 302913 */ // Label 72: @302913
     /* 302913 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5103*/ GIMT_Encode4(303638),
     /* 302924 */ /*GILLT_s1*//*Label 5100*/ GIMT_Encode4(302936),
     /* 302928 */ /*GILLT_s16*//*Label 5101*/ GIMT_Encode4(303209),
     /* 302932 */ /*GILLT_s32*//*Label 5102*/ GIMT_Encode4(303356),
     /* 302936 */ // Label 5100: @302936
     /* 302936 */ GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(302991), // Rule ID 7407 //
     /* 302941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 302944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302958 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 302958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 302961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302966 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 302976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302989 */   GIR_RootConstrainSelectedInstOperands,
     /* 302990 */   // GIR_Coverage, 7407,
     /* 302990 */   GIR_EraseRootFromParent_Done,
     /* 302991 */ // Label 5104: @302991
     /* 302991 */ GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(303049), // Rule ID 7409 //
     /* 302996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 302999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303013 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 303016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303021 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 303031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303047 */   GIR_RootConstrainSelectedInstOperands,
     /* 303048 */   // GIR_Coverage, 7409,
     /* 303048 */   GIR_EraseRootFromParent_Done,
     /* 303049 */ // Label 5105: @303049
     /* 303049 */ GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(303104), // Rule ID 7411 //
     /* 303054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303071 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 303074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303079 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 303089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303102 */   GIR_RootConstrainSelectedInstOperands,
     /* 303103 */   // GIR_Coverage, 7411,
     /* 303103 */   GIR_EraseRootFromParent_Done,
     /* 303104 */ // Label 5106: @303104
     /* 303104 */ GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(303156), // Rule ID 7413 //
     /* 303109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303123 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 303123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 303126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303131 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 303141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303154 */   GIR_RootConstrainSelectedInstOperands,
     /* 303155 */   // GIR_Coverage, 7413,
     /* 303155 */   GIR_EraseRootFromParent_Done,
     /* 303156 */ // Label 5107: @303156
     /* 303156 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(303208), // Rule ID 7415 //
     /* 303161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303168 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303175 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, -4616189618054758400:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 303175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 303178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303183 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-4616189618054758400),
     /* 303193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303206 */   GIR_RootConstrainSelectedInstOperands,
     /* 303207 */   // GIR_Coverage, 7415,
     /* 303207 */   GIR_EraseRootFromParent_Done,
     /* 303208 */ // Label 5108: @303208
     /* 303208 */ GIM_Reject,
     /* 303209 */ // Label 5101: @303209
     /* 303209 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(303355),
     /* 303214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303217 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(303263), // Rule ID 714 //
     /* 303222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 303225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303236 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_e64),
     /* 303239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303261 */     GIR_RootConstrainSelectedInstOperands,
     /* 303262 */     // GIR_Coverage, 714,
     /* 303262 */     GIR_EraseRootFromParent_Done,
     /* 303263 */   // Label 5110: @303263
     /* 303263 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(303309), // Rule ID 716 //
     /* 303268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303282 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_fake16_e64),
     /* 303285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303307 */     GIR_RootConstrainSelectedInstOperands,
     /* 303308 */     // GIR_Coverage, 716,
     /* 303308 */     GIR_EraseRootFromParent_Done,
     /* 303309 */   // Label 5111: @303309
     /* 303309 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(303354), // Rule ID 715 //
     /* 303314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 303328 */     // (fp_to_sint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 303328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_t16_e64),
     /* 303331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303352 */     GIR_RootConstrainSelectedInstOperands,
     /* 303353 */     // GIR_Coverage, 715,
     /* 303353 */     GIR_EraseRootFromParent_Done,
     /* 303354 */   // Label 5112: @303354
     /* 303354 */   GIM_Reject,
     /* 303355 */ // Label 5109: @303355
     /* 303355 */ GIM_Reject,
     /* 303356 */ // Label 5102: @303356
     /* 303356 */ GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(303386), // Rule ID 29 //
     /* 303361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 303364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 303371 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13735),
     /* 303375 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13735>>  =>  (S_CVT_I32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 303375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_I32_F32),
     /* 303380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 303384 */   GIR_RootConstrainSelectedInstOperands,
     /* 303385 */   // GIR_Coverage, 29,
     /* 303385 */   GIR_Done,
     /* 303386 */ // Label 5113: @303386
     /* 303386 */ GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(303438), // Rule ID 6985 //
     /* 303391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303401 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 303401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 303408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303413 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303416 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303420 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303423 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303436 */   GIR_RootConstrainSelectedInstOperands,
     /* 303437 */   // GIR_Coverage, 6985,
     /* 303437 */   GIR_EraseRootFromParent_Done,
     /* 303438 */ // Label 5114: @303438
     /* 303438 */ GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(303493), // Rule ID 6991 //
     /* 303443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303453 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 303453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 303460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303465 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303472 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303475 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303478 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303491 */   GIR_RootConstrainSelectedInstOperands,
     /* 303492 */   // GIR_Coverage, 6991,
     /* 303492 */   GIR_EraseRootFromParent_Done,
     /* 303493 */ // Label 5115: @303493
     /* 303493 */ GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(303545), // Rule ID 6997 //
     /* 303498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303508 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 303508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 303515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303520 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303527 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303543 */   GIR_RootConstrainSelectedInstOperands,
     /* 303544 */   // GIR_Coverage, 6997,
     /* 303544 */   GIR_EraseRootFromParent_Done,
     /* 303545 */ // Label 5116: @303545
     /* 303545 */ GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(303591), // Rule ID 626 //
     /* 303550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303564 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F64_e64),
     /* 303567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303589 */   GIR_RootConstrainSelectedInstOperands,
     /* 303590 */   // GIR_Coverage, 626,
     /* 303590 */   GIR_EraseRootFromParent_Done,
     /* 303591 */ // Label 5117: @303591
     /* 303591 */ GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(303637), // Rule ID 636 //
     /* 303596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303610 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e64),
     /* 303613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303635 */   GIR_RootConstrainSelectedInstOperands,
     /* 303636 */   // GIR_Coverage, 636,
     /* 303636 */   GIR_EraseRootFromParent_Done,
     /* 303637 */ // Label 5118: @303637
     /* 303637 */ GIM_Reject,
     /* 303638 */ // Label 5103: @303638
     /* 303638 */ GIM_Reject,
     /* 303639 */ // Label 73: @303639
     /* 303639 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5122*/ GIMT_Encode4(304364),
     /* 303650 */ /*GILLT_s1*//*Label 5119*/ GIMT_Encode4(303662),
     /* 303654 */ /*GILLT_s16*//*Label 5120*/ GIMT_Encode4(303935),
     /* 303658 */ /*GILLT_s32*//*Label 5121*/ GIMT_Encode4(304082),
     /* 303662 */ // Label 5119: @303662
     /* 303662 */ GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(303717), // Rule ID 7406 //
     /* 303667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303684 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 303687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303692 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303715 */   GIR_RootConstrainSelectedInstOperands,
     /* 303716 */   // GIR_Coverage, 7406,
     /* 303716 */   GIR_EraseRootFromParent_Done,
     /* 303717 */ // Label 5123: @303717
     /* 303717 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(303775), // Rule ID 7408 //
     /* 303722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303739 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 303742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303747 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303773 */   GIR_RootConstrainSelectedInstOperands,
     /* 303774 */   // GIR_Coverage, 7408,
     /* 303774 */   GIR_EraseRootFromParent_Done,
     /* 303775 */ // Label 5124: @303775
     /* 303775 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(303830), // Rule ID 7410 //
     /* 303780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303797 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 303800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303805 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303828 */   GIR_RootConstrainSelectedInstOperands,
     /* 303829 */   // GIR_Coverage, 7410,
     /* 303829 */   GIR_EraseRootFromParent_Done,
     /* 303830 */ // Label 5125: @303830
     /* 303830 */ GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(303882), // Rule ID 7412 //
     /* 303835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303849 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 303849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 303852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303857 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 303867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303880 */   GIR_RootConstrainSelectedInstOperands,
     /* 303881 */   // GIR_Coverage, 7412,
     /* 303881 */   GIR_EraseRootFromParent_Done,
     /* 303882 */ // Label 5126: @303882
     /* 303882 */ GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(303934), // Rule ID 7414 //
     /* 303887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303901 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 303901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 303904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303909 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 303919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303932 */   GIR_RootConstrainSelectedInstOperands,
     /* 303933 */   // GIR_Coverage, 7414,
     /* 303933 */   GIR_EraseRootFromParent_Done,
     /* 303934 */ // Label 5127: @303934
     /* 303934 */ GIM_Reject,
     /* 303935 */ // Label 5120: @303935
     /* 303935 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(304081),
     /* 303940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303943 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(303989), // Rule ID 711 //
     /* 303948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 303951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303962 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_e64),
     /* 303965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303987 */     GIR_RootConstrainSelectedInstOperands,
     /* 303988 */     // GIR_Coverage, 711,
     /* 303988 */     GIR_EraseRootFromParent_Done,
     /* 303989 */   // Label 5129: @303989
     /* 303989 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(304035), // Rule ID 713 //
     /* 303994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304008 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_fake16_e64),
     /* 304011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 304028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 304033 */     GIR_RootConstrainSelectedInstOperands,
     /* 304034 */     // GIR_Coverage, 713,
     /* 304034 */     GIR_EraseRootFromParent_Done,
     /* 304035 */   // Label 5130: @304035
     /* 304035 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(304080), // Rule ID 712 //
     /* 304040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 304054 */     // (fp_to_uint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_U16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 304054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_t16_e64),
     /* 304057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304078 */     GIR_RootConstrainSelectedInstOperands,
     /* 304079 */     // GIR_Coverage, 712,
     /* 304079 */     GIR_EraseRootFromParent_Done,
     /* 304080 */   // Label 5131: @304080
     /* 304080 */   GIM_Reject,
     /* 304081 */ // Label 5128: @304081
     /* 304081 */ GIM_Reject,
     /* 304082 */ // Label 5121: @304082
     /* 304082 */ GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(304112), // Rule ID 30 //
     /* 304087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 304090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304097 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13736),
     /* 304101 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13736>>  =>  (S_CVT_U32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 304101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_U32_F32),
     /* 304106 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 304110 */   GIR_RootConstrainSelectedInstOperands,
     /* 304111 */   // GIR_Coverage, 30,
     /* 304111 */   GIR_Done,
     /* 304112 */ // Label 5132: @304112
     /* 304112 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(304164), // Rule ID 6986 //
     /* 304117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304127 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 304127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 304134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304139 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304146 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304149 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 304157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304162 */   GIR_RootConstrainSelectedInstOperands,
     /* 304163 */   // GIR_Coverage, 6986,
     /* 304163 */   GIR_EraseRootFromParent_Done,
     /* 304164 */ // Label 5133: @304164
     /* 304164 */ GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(304219), // Rule ID 6992 //
     /* 304169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304179 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 304179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 304186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304191 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304194 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304198 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304201 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304204 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 304212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304217 */   GIR_RootConstrainSelectedInstOperands,
     /* 304218 */   // GIR_Coverage, 6992,
     /* 304218 */   GIR_EraseRootFromParent_Done,
     /* 304219 */ // Label 5134: @304219
     /* 304219 */ GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(304271), // Rule ID 6998 //
     /* 304224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304234 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 304234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 304241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304246 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304249 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304253 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304256 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 304264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304269 */   GIR_RootConstrainSelectedInstOperands,
     /* 304270 */   // GIR_Coverage, 6998,
     /* 304270 */   GIR_EraseRootFromParent_Done,
     /* 304271 */ // Label 5135: @304271
     /* 304271 */ GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(304317), // Rule ID 631 //
     /* 304276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304290 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F64_e64),
     /* 304293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 304310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 304315 */   GIR_RootConstrainSelectedInstOperands,
     /* 304316 */   // GIR_Coverage, 631,
     /* 304316 */   GIR_EraseRootFromParent_Done,
     /* 304317 */ // Label 5136: @304317
     /* 304317 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(304363), // Rule ID 635 //
     /* 304322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304336 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e64),
     /* 304339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 304356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 304361 */   GIR_RootConstrainSelectedInstOperands,
     /* 304362 */   // GIR_Coverage, 635,
     /* 304362 */   GIR_EraseRootFromParent_Done,
     /* 304363 */ // Label 5137: @304363
     /* 304363 */ GIM_Reject,
     /* 304364 */ // Label 5122: @304364
     /* 304364 */ GIM_Reject,
     /* 304365 */ // Label 74: @304365
     /* 304365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5141*/ GIMT_Encode4(305097),
     /* 304376 */ /*GILLT_s16*//*Label 5138*/ GIMT_Encode4(304388),
     /* 304380 */ /*GILLT_s32*//*Label 5139*/ GIMT_Encode4(304891),
     /* 304384 */ /*GILLT_s64*//*Label 5140*/ GIMT_Encode4(305003),
     /* 304388 */ // Label 5138: @304388
     /* 304388 */ GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(304440), // Rule ID 6987 //
     /* 304393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304403 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 304424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304438 */   GIR_RootConstrainSelectedInstOperands,
     /* 304439 */   // GIR_Coverage, 6987,
     /* 304439 */   GIR_EraseRootFromParent_Done,
     /* 304440 */ // Label 5142: @304440
     /* 304440 */ GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(304495), // Rule ID 6993 //
     /* 304445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304455 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304467 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 304476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304493 */   GIR_RootConstrainSelectedInstOperands,
     /* 304494 */   // GIR_Coverage, 6993,
     /* 304494 */   GIR_EraseRootFromParent_Done,
     /* 304495 */ // Label 5143: @304495
     /* 304495 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(304547), // Rule ID 6999 //
     /* 304500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304510 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304522 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 304531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304545 */   GIR_RootConstrainSelectedInstOperands,
     /* 304546 */   // GIR_Coverage, 6999,
     /* 304546 */   GIR_EraseRootFromParent_Done,
     /* 304547 */ // Label 5144: @304547
     /* 304547 */ GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(304609), // Rule ID 7432 //
     /* 304552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304562 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 304562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304574 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304577 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304580 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304583 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 304602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304607 */   GIR_RootConstrainSelectedInstOperands,
     /* 304608 */   // GIR_Coverage, 7432,
     /* 304608 */   GIR_EraseRootFromParent_Done,
     /* 304609 */ // Label 5145: @304609
     /* 304609 */ GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(304683), // Rule ID 7433 //
     /* 304614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304624 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 304624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304636 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304639 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304642 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304645 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 304664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304681 */   GIR_RootConstrainSelectedInstOperands,
     /* 304682 */   // GIR_Coverage, 7433,
     /* 304682 */   GIR_EraseRootFromParent_Done,
     /* 304683 */ // Label 5146: @304683
     /* 304683 */ GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(304754), // Rule ID 7434 //
     /* 304688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304698 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 304698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304710 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304713 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304716 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304719 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 304738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304752 */   GIR_RootConstrainSelectedInstOperands,
     /* 304753 */   // GIR_Coverage, 7434,
     /* 304753 */   GIR_EraseRootFromParent_Done,
     /* 304754 */ // Label 5147: @304754
     /* 304754 */ GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(304798), // Rule ID 708 //
     /* 304759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 304762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304776 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_e64),
     /* 304779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304796 */   GIR_RootConstrainSelectedInstOperands,
     /* 304797 */   // GIR_Coverage, 708,
     /* 304797 */   GIR_EraseRootFromParent_Done,
     /* 304798 */ // Label 5148: @304798
     /* 304798 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(304842), // Rule ID 710 //
     /* 304803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304820 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_fake16_e64),
     /* 304823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304840 */   GIR_RootConstrainSelectedInstOperands,
     /* 304841 */   // GIR_Coverage, 710,
     /* 304841 */   GIR_EraseRootFromParent_Done,
     /* 304842 */ // Label 5149: @304842
     /* 304842 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(304890), // Rule ID 709 //
     /* 304847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 304864 */   // (sint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_I16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 304864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_t16_e64),
     /* 304867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304888 */   GIR_RootConstrainSelectedInstOperands,
     /* 304889 */   // GIR_Coverage, 709,
     /* 304889 */   GIR_EraseRootFromParent_Done,
     /* 304890 */ // Label 5150: @304890
     /* 304890 */ GIM_Reject,
     /* 304891 */ // Label 5139: @304891
     /* 304891 */ GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(304921), // Rule ID 27 //
     /* 304896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 304899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304906 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13733),
     /* 304910 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13733>>  =>  (S_CVT_F32_I32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 304910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_I32),
     /* 304915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 304919 */   GIR_RootConstrainSelectedInstOperands,
     /* 304920 */   // GIR_Coverage, 27,
     /* 304920 */   GIR_Done,
     /* 304921 */ // Label 5151: @304921
     /* 304921 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(304961), // Rule ID 7438 //
     /* 304926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304933 */   // (sint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 304933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304947 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 304957 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304959 */   GIR_RootConstrainSelectedInstOperands,
     /* 304960 */   // GIR_Coverage, 7438,
     /* 304960 */   GIR_EraseRootFromParent_Done,
     /* 304961 */ // Label 5152: @304961
     /* 304961 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(305002), // Rule ID 633 //
     /* 304966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304980 */   // (sint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_I32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e64),
     /* 304983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305000 */   GIR_RootConstrainSelectedInstOperands,
     /* 305001 */   // GIR_Coverage, 633,
     /* 305001 */   GIR_EraseRootFromParent_Done,
     /* 305002 */ // Label 5153: @305002
     /* 305002 */ GIM_Reject,
     /* 305003 */ // Label 5140: @305003
     /* 305003 */ GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(305055), // Rule ID 7440 //
     /* 305008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305015 */   // (sint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_I32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 305015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305027 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305030 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305033 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305036 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 305039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e32),
     /* 305048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305053 */   GIR_RootConstrainSelectedInstOperands,
     /* 305054 */   // GIR_Coverage, 7440,
     /* 305054 */   GIR_EraseRootFromParent_Done,
     /* 305055 */ // Label 5154: @305055
     /* 305055 */ GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(305096), // Rule ID 627 //
     /* 305060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305074 */   // (sint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_I32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e64),
     /* 305077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305094 */   GIR_RootConstrainSelectedInstOperands,
     /* 305095 */   // GIR_Coverage, 627,
     /* 305095 */   GIR_EraseRootFromParent_Done,
     /* 305096 */ // Label 5155: @305096
     /* 305096 */ GIM_Reject,
     /* 305097 */ // Label 5141: @305097
     /* 305097 */ GIM_Reject,
     /* 305098 */ // Label 75: @305098
     /* 305098 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5159*/ GIMT_Encode4(305830),
     /* 305109 */ /*GILLT_s16*//*Label 5156*/ GIMT_Encode4(305121),
     /* 305113 */ /*GILLT_s32*//*Label 5157*/ GIMT_Encode4(305624),
     /* 305117 */ /*GILLT_s64*//*Label 5158*/ GIMT_Encode4(305736),
     /* 305121 */ // Label 5156: @305121
     /* 305121 */ GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(305173), // Rule ID 6988 //
     /* 305126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305136 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 305136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 305143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305148 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 305157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305171 */   GIR_RootConstrainSelectedInstOperands,
     /* 305172 */   // GIR_Coverage, 6988,
     /* 305172 */   GIR_EraseRootFromParent_Done,
     /* 305173 */ // Label 5160: @305173
     /* 305173 */ GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(305228), // Rule ID 6994 //
     /* 305178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305188 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 305188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 305195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 305209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305226 */   GIR_RootConstrainSelectedInstOperands,
     /* 305227 */   // GIR_Coverage, 6994,
     /* 305227 */   GIR_EraseRootFromParent_Done,
     /* 305228 */ // Label 5161: @305228
     /* 305228 */ GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(305280), // Rule ID 7000 //
     /* 305233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305243 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 305243 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305246 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 305250 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305255 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 305264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305278 */   GIR_RootConstrainSelectedInstOperands,
     /* 305279 */   // GIR_Coverage, 7000,
     /* 305279 */   GIR_EraseRootFromParent_Done,
     /* 305280 */ // Label 5162: @305280
     /* 305280 */ GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(305342), // Rule ID 7435 //
     /* 305285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305295 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 305295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305307 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305310 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305313 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305316 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 305335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305340 */   GIR_RootConstrainSelectedInstOperands,
     /* 305341 */   // GIR_Coverage, 7435,
     /* 305341 */   GIR_EraseRootFromParent_Done,
     /* 305342 */ // Label 5163: @305342
     /* 305342 */ GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(305416), // Rule ID 7436 //
     /* 305347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305357 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 305357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305369 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305372 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305375 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305378 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305388 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 305397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305414 */   GIR_RootConstrainSelectedInstOperands,
     /* 305415 */   // GIR_Coverage, 7436,
     /* 305415 */   GIR_EraseRootFromParent_Done,
     /* 305416 */ // Label 5164: @305416
     /* 305416 */ GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(305487), // Rule ID 7437 //
     /* 305421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305431 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 305431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305443 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305449 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305452 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 305471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305485 */   GIR_RootConstrainSelectedInstOperands,
     /* 305486 */   // GIR_Coverage, 7437,
     /* 305486 */   GIR_EraseRootFromParent_Done,
     /* 305487 */ // Label 5165: @305487
     /* 305487 */ GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(305531), // Rule ID 705 //
     /* 305492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 305495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305509 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_e64),
     /* 305512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305529 */   GIR_RootConstrainSelectedInstOperands,
     /* 305530 */   // GIR_Coverage, 705,
     /* 305530 */   GIR_EraseRootFromParent_Done,
     /* 305531 */ // Label 5166: @305531
     /* 305531 */ GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(305575), // Rule ID 707 //
     /* 305536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305546 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305553 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_fake16_e64),
     /* 305556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305573 */   GIR_RootConstrainSelectedInstOperands,
     /* 305574 */   // GIR_Coverage, 707,
     /* 305574 */   GIR_EraseRootFromParent_Done,
     /* 305575 */ // Label 5167: @305575
     /* 305575 */ GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(305623), // Rule ID 706 //
     /* 305580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 305597 */   // (uint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_U16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 305597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_t16_e64),
     /* 305600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 305607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305621 */   GIR_RootConstrainSelectedInstOperands,
     /* 305622 */   // GIR_Coverage, 706,
     /* 305622 */   GIR_EraseRootFromParent_Done,
     /* 305623 */ // Label 5168: @305623
     /* 305623 */ GIM_Reject,
     /* 305624 */ // Label 5157: @305624
     /* 305624 */ GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(305654), // Rule ID 28 //
     /* 305629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 305632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305639 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13734),
     /* 305643 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13734>>  =>  (S_CVT_F32_U32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 305643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_U32),
     /* 305648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 305652 */   GIR_RootConstrainSelectedInstOperands,
     /* 305653 */   // GIR_Coverage, 28,
     /* 305653 */   GIR_Done,
     /* 305654 */ // Label 5169: @305654
     /* 305654 */ GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(305694), // Rule ID 7439 //
     /* 305659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305666 */   // (uint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 305666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305680 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 305690 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305692 */   GIR_RootConstrainSelectedInstOperands,
     /* 305693 */   // GIR_Coverage, 7439,
     /* 305693 */   GIR_EraseRootFromParent_Done,
     /* 305694 */ // Label 5170: @305694
     /* 305694 */ GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(305735), // Rule ID 634 //
     /* 305699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305713 */   // (uint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_U32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e64),
     /* 305716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305733 */   GIR_RootConstrainSelectedInstOperands,
     /* 305734 */   // GIR_Coverage, 634,
     /* 305734 */   GIR_EraseRootFromParent_Done,
     /* 305735 */ // Label 5171: @305735
     /* 305735 */ GIM_Reject,
     /* 305736 */ // Label 5158: @305736
     /* 305736 */ GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(305788), // Rule ID 7441 //
     /* 305741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305748 */   // (uint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_U32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 305748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305760 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305763 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305766 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305769 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 305772 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e32),
     /* 305781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305786 */   GIR_RootConstrainSelectedInstOperands,
     /* 305787 */   // GIR_Coverage, 7441,
     /* 305787 */   GIR_EraseRootFromParent_Done,
     /* 305788 */ // Label 5172: @305788
     /* 305788 */ GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(305829), // Rule ID 632 //
     /* 305793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305807 */   // (uint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_U32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e64),
     /* 305810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305827 */   GIR_RootConstrainSelectedInstOperands,
     /* 305828 */   // GIR_Coverage, 632,
     /* 305828 */   GIR_EraseRootFromParent_Done,
     /* 305829 */ // Label 5173: @305829
     /* 305829 */ GIM_Reject,
     /* 305830 */ // Label 5159: @305830
     /* 305830 */ GIM_Reject,
     /* 305831 */ // Label 76: @305831
     /* 305831 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5178*/ GIMT_Encode4(306631),
     /* 305842 */ /*GILLT_s16*//*Label 5174*/ GIMT_Encode4(305858),
     /* 305846 */ /*GILLT_s32*//*Label 5175*/ GIMT_Encode4(306072),
     /* 305850 */ /*GILLT_s64*//*Label 5176*/ GIMT_Encode4(306187),
     /* 305854 */ /*GILLT_v2s16*//*Label 5177*/ GIMT_Encode4(306516),
     /* 305858 */ // Label 5174: @305858
     /* 305858 */ GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(306071),
     /* 305863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305866 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(305922), // Rule ID 7236 //
     /* 305871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34510),
     /* 305883 */     // (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34510>>  =>  (S_AND_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32767:{ *:[i32] }))
     /* 305883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305895 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 305905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 305910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305920 */     GIR_RootConstrainSelectedInstOperands,
     /* 305921 */     // GIR_Coverage, 7236,
     /* 305921 */     GIR_EraseRootFromParent_Done,
     /* 305922 */   // Label 5180: @305922
     /* 305922 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(305974), // Rule ID 7251 //
     /* 305927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305938 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 305938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305950 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 305960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 305965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305972 */     GIR_RootConstrainSelectedInstOperands,
     /* 305973 */     // GIR_Coverage, 7251,
     /* 305973 */     GIR_EraseRootFromParent_Done,
     /* 305974 */   // Label 5181: @305974
     /* 305974 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(306018), // Rule ID 7254 //
     /* 305979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305990 */     // (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_AND_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32767:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 305990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /* 305993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32767),
     /* 306008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306016 */     GIR_RootConstrainSelectedInstOperands,
     /* 306017 */     // GIR_Coverage, 7254,
     /* 306017 */     GIR_EraseRootFromParent_Done,
     /* 306018 */   // Label 5182: @306018
     /* 306018 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(306070), // Rule ID 7257 //
     /* 306023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 306026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306034 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 306034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306046 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 306056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306068 */     GIR_RootConstrainSelectedInstOperands,
     /* 306069 */     // GIR_Coverage, 7257,
     /* 306069 */     GIR_EraseRootFromParent_Done,
     /* 306070 */   // Label 5183: @306070
     /* 306070 */   GIM_Reject,
     /* 306071 */ // Label 5179: @306071
     /* 306071 */ GIM_Reject,
     /* 306072 */ // Label 5175: @306072
     /* 306072 */ GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(306186),
     /* 306077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306080 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(306136), // Rule ID 7233 //
     /* 306085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34510),
     /* 306097 */     // (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34510>>  =>  (S_AND_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] }))
     /* 306097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 306100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306109 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 306124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306126 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 306134 */     GIR_RootConstrainSelectedInstOperands,
     /* 306135 */     // GIR_Coverage, 7233,
     /* 306135 */     GIR_EraseRootFromParent_Done,
     /* 306136 */   // Label 5185: @306136
     /* 306136 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(306185), // Rule ID 7249 //
     /* 306141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306149 */     // (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_AND_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 306149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306161 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306183 */     GIR_RootConstrainSelectedInstOperands,
     /* 306184 */     // GIR_Coverage, 7249,
     /* 306184 */     GIR_EraseRootFromParent_Done,
     /* 306185 */   // Label 5186: @306185
     /* 306185 */   GIM_Reject,
     /* 306186 */ // Label 5184: @306186
     /* 306186 */ GIM_Reject,
     /* 306187 */ // Label 5176: @306187
     /* 306187 */ GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(306515),
     /* 306192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306195 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(306368), // Rule ID 7245 //
     /* 306200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34510),
     /* 306212 */     // (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34510>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 306212 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 306215 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306219 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306224 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483647),
     /* 306234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306236 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 306239 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306243 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306248 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 306254 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 306259 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306264 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 306267 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 306271 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306276 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306279 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 306282 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 306285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306287 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306290 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306294 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306299 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 306325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 306330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 306338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306343 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 306346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306349 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 306352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 306362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 306367 */     // GIR_Coverage, 7245,
     /* 306367 */     GIR_EraseRootFromParent_Done,
     /* 306368 */   // Label 5188: @306368
     /* 306368 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(306514), // Rule ID 7263 //
     /* 306373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306381 */     // (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483647:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 306381 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 306384 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306388 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306393 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 306399 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306404 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 306412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306421 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483647),
     /* 306431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306445 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306448 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 306451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306465 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 306471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 306484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306489 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 306492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306495 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 306498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306513 */     // GIR_Coverage, 7263,
     /* 306513 */     GIR_EraseRootFromParent_Done,
     /* 306514 */   // Label 5189: @306514
     /* 306514 */   GIM_Reject,
     /* 306515 */ // Label 5187: @306515
     /* 306515 */ GIM_Reject,
     /* 306516 */ // Label 5177: @306516
     /* 306516 */ GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(306630),
     /* 306521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 306524 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(306580), // Rule ID 7239 //
     /* 306529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34510),
     /* 306541 */     // (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34510>>  =>  (S_AND_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147450879:{ *:[i32] }))
     /* 306541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 306544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306553 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 306563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 306568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 306578 */     GIR_RootConstrainSelectedInstOperands,
     /* 306579 */     // GIR_Coverage, 7239,
     /* 306579 */     GIR_EraseRootFromParent_Done,
     /* 306580 */   // Label 5191: @306580
     /* 306580 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(306629), // Rule ID 7261 //
     /* 306585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306593 */     // (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_AND_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147450879:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 306593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306605 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 306615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306627 */     GIR_RootConstrainSelectedInstOperands,
     /* 306628 */     // GIR_Coverage, 7261,
     /* 306628 */     GIR_EraseRootFromParent_Done,
     /* 306629 */   // Label 5192: @306629
     /* 306629 */   GIM_Reject,
     /* 306630 */ // Label 5190: @306630
     /* 306630 */ GIM_Reject,
     /* 306631 */ // Label 5178: @306631
     /* 306631 */ GIM_Reject,
     /* 306632 */ // Label 77: @306632
     /* 306632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5195*/ GIMT_Encode4(306994),
     /* 306643 */ /*GILLT_s16*//*Label 5193*/ GIMT_Encode4(306651),
     /* 306647 */ /*GILLT_s32*//*Label 5194*/ GIMT_Encode4(306783),
     /* 306651 */ // Label 5193: @306651
     /* 306651 */ GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(306782),
     /* 306656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306659 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(306709), // Rule ID 7267 //
     /* 306664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306671 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, ?:{ *:[f16] }:$src1)
     /* 306671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306683 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 306693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 306707 */     GIR_RootConstrainSelectedInstOperands,
     /* 306708 */     // GIR_Coverage, 7267,
     /* 306708 */     GIR_EraseRootFromParent_Done,
     /* 306709 */   // Label 5197: @306709
     /* 306709 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(306781), // Rule ID 7270 //
     /* 306714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306721 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, (V_LSHRREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f32] }:$src1))
     /* 306721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 306728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306733 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 306736 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 306740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306754 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 306764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306779 */     GIR_RootConstrainSelectedInstOperands,
     /* 306780 */     // GIR_Coverage, 7270,
     /* 306780 */     GIR_EraseRootFromParent_Done,
     /* 306781 */   // Label 5198: @306781
     /* 306781 */   GIM_Reject,
     /* 306782 */ // Label 5196: @306782
     /* 306782 */ GIM_Reject,
     /* 306783 */ // Label 5194: @306783
     /* 306783 */ GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(306993),
     /* 306788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306791 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(306863), // Rule ID 7268 //
     /* 306796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306803 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (V_LSHLREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f16] }:$src1))
     /* 306803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 306810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306815 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 306818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 306822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306836 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306861 */     GIR_RootConstrainSelectedInstOperands,
     /* 306862 */     // GIR_Coverage, 7268,
     /* 306862 */     GIR_EraseRootFromParent_Done,
     /* 306863 */   // Label 5200: @306863
     /* 306863 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(306913), // Rule ID 7331 //
     /* 306868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306875 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, ?:{ *:[f32] }:$src1)
     /* 306875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306887 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 306911 */     GIR_RootConstrainSelectedInstOperands,
     /* 306912 */     // GIR_Coverage, 7331,
     /* 306912 */     GIR_EraseRootFromParent_Done,
     /* 306913 */   // Label 5201: @306913
     /* 306913 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(306992), // Rule ID 7332 //
     /* 306918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306925 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f64:{ *:[f64] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src1, sub1:{ *:[i32] }))
     /* 306925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306937 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // src1
     /* 306943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 306948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306965 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306990 */     GIR_RootConstrainSelectedInstOperands,
     /* 306991 */     // GIR_Coverage, 7332,
     /* 306991 */     GIR_EraseRootFromParent_Done,
     /* 306992 */   // Label 5202: @306992
     /* 306992 */   GIM_Reject,
     /* 306993 */ // Label 5199: @306993
     /* 306993 */ GIM_Reject,
     /* 306994 */ // Label 5195: @306994
     /* 306994 */ GIM_Reject,
     /* 306995 */ // Label 78: @306995
     /* 306995 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(307325),
     /* 307000 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 307003 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5207*/ GIMT_Encode4(307324),
     /* 307014 */   /*GILLT_s16*//*Label 5204*/ GIMT_Encode4(307026),
     /* 307018 */   /*GILLT_s32*//*Label 5205*/ GIMT_Encode4(307208),
     /* 307022 */   /*GILLT_s64*//*Label 5206*/ GIMT_Encode4(307266),
     /* 307026 */   // Label 5204: @307026
     /* 307026 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(307207),
     /* 307031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 307038 */     GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(307091), // Rule ID 2880 //
     /* 307043 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 307046 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 307053 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 307053 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307056 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 307060 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307065 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307069 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307071 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 307074 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307076 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307081 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307086 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307089 */       GIR_RootConstrainSelectedInstOperands,
     /* 307090 */       // GIR_Coverage, 2880,
     /* 307090 */       GIR_EraseRootFromParent_Done,
     /* 307091 */     // Label 5209: @307091
     /* 307091 */     GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(307150), // Rule ID 2881 //
     /* 307096 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307099 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 307106 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 307106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 307113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307118 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307122 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307124 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 307127 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307129 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307134 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307139 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307142 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307145 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307148 */       GIR_RootConstrainSelectedInstOperands,
     /* 307149 */       // GIR_Coverage, 2881,
     /* 307149 */       GIR_EraseRootFromParent_Done,
     /* 307150 */     // Label 5210: @307150
     /* 307150 */     GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(307206), // Rule ID 2882 //
     /* 307155 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307158 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 307165 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 307165 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307168 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 307172 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307177 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307181 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307183 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 307186 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307188 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307193 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307198 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307201 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307204 */       GIR_RootConstrainSelectedInstOperands,
     /* 307205 */       // GIR_Coverage, 2882,
     /* 307205 */       GIR_EraseRootFromParent_Done,
     /* 307206 */     // Label 5211: @307206
     /* 307206 */     GIM_Reject,
     /* 307207 */   // Label 5208: @307207
     /* 307207 */   GIM_Reject,
     /* 307208 */   // Label 5205: @307208
     /* 307208 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(307265), // Rule ID 2883 //
     /* 307213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307217 */     // MIs[0] mask
     /* 307217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 307220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 307227 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f32:{ *:[f32] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 307227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 307234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 307248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307263 */     GIR_RootConstrainSelectedInstOperands,
     /* 307264 */     // GIR_Coverage, 2883,
     /* 307264 */     GIR_EraseRootFromParent_Done,
     /* 307265 */   // Label 5212: @307265
     /* 307265 */   GIM_Reject,
     /* 307266 */   // Label 5206: @307266
     /* 307266 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(307323), // Rule ID 2884 //
     /* 307271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307275 */     // MIs[0] mask
     /* 307275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 307278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 307285 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f64:{ *:[f64] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 307285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 307292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 307306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307321 */     GIR_RootConstrainSelectedInstOperands,
     /* 307322 */     // GIR_Coverage, 2884,
     /* 307322 */     GIR_EraseRootFromParent_Done,
     /* 307323 */   // Label 5213: @307323
     /* 307323 */   GIM_Reject,
     /* 307324 */   // Label 5207: @307324
     /* 307324 */   GIM_Reject,
     /* 307325 */ // Label 5203: @307325
     /* 307325 */ GIM_Reject,
     /* 307326 */ // Label 79: @307326
     /* 307326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5219*/ GIMT_Encode4(308793),
     /* 307337 */ /*GILLT_s16*//*Label 5214*/ GIMT_Encode4(307357),
     /* 307341 */ /*GILLT_s32*//*Label 5215*/ GIMT_Encode4(308063),
     /* 307345 */ /*GILLT_s64*//*Label 5216*/ GIMT_Encode4(308283),
     /* 307349 */ /*GILLT_v2s16*//*Label 5217*/ GIMT_Encode4(308540),
     /* 307353 */ /*GILLT_v2s32*//*Label 5218*/ GIMT_Encode4(308725),
     /* 307357 */ // Label 5214: @307357
     /* 307357 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(308062),
     /* 307362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307365 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(307417), // Rule ID 7489 //
     /* 307370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 307373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307384 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 307387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307415 */     GIR_RootConstrainSelectedInstOperands,
     /* 307416 */     // GIR_Coverage, 7489,
     /* 307416 */     GIR_EraseRootFromParent_Done,
     /* 307417 */   // Label 5221: @307417
     /* 307417 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(307472), // Rule ID 7490 //
     /* 307422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts),
     /* 307425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307436 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 307439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307470 */     GIR_RootConstrainSelectedInstOperands,
     /* 307471 */     // GIR_Coverage, 7490,
     /* 307471 */     GIR_EraseRootFromParent_Done,
     /* 307472 */   // Label 5222: @307472
     /* 307472 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(307524), // Rule ID 7491 //
     /* 307477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 307480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307491 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 307494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307522 */     GIR_RootConstrainSelectedInstOperands,
     /* 307523 */     // GIR_Coverage, 7491,
     /* 307523 */     GIR_EraseRootFromParent_Done,
     /* 307524 */   // Label 5223: @307524
     /* 307524 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(307576), // Rule ID 7496 //
     /* 307529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 307532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307543 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 307546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307574 */     GIR_RootConstrainSelectedInstOperands,
     /* 307575 */     // GIR_Coverage, 7496,
     /* 307575 */     GIR_EraseRootFromParent_Done,
     /* 307576 */   // Label 5224: @307576
     /* 307576 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(307631), // Rule ID 7497 //
     /* 307581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts),
     /* 307584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307595 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 307598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307629 */     GIR_RootConstrainSelectedInstOperands,
     /* 307630 */     // GIR_Coverage, 7497,
     /* 307630 */     GIR_EraseRootFromParent_Done,
     /* 307631 */   // Label 5225: @307631
     /* 307631 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(307683), // Rule ID 7498 //
     /* 307636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 307639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307650 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 307653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307681 */     GIR_RootConstrainSelectedInstOperands,
     /* 307682 */     // GIR_Coverage, 7498,
     /* 307682 */     GIR_EraseRootFromParent_Done,
     /* 307683 */   // Label 5226: @307683
     /* 307683 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(307752), // Rule ID 7476 //
     /* 307688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307716 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 307719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307724 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307750 */     GIR_RootConstrainSelectedInstOperands,
     /* 307751 */     // GIR_Coverage, 7476,
     /* 307751 */     GIR_EraseRootFromParent_Done,
     /* 307752 */   // Label 5227: @307752
     /* 307752 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(307824), // Rule ID 7478 //
     /* 307757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307785 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 307785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 307788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307793 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307822 */     GIR_RootConstrainSelectedInstOperands,
     /* 307823 */     // GIR_Coverage, 7478,
     /* 307823 */     GIR_EraseRootFromParent_Done,
     /* 307824 */   // Label 5228: @307824
     /* 307824 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(307893), // Rule ID 7480 //
     /* 307829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307857 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 307860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307865 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307891 */     GIR_RootConstrainSelectedInstOperands,
     /* 307892 */     // GIR_Coverage, 7480,
     /* 307892 */     GIR_EraseRootFromParent_Done,
     /* 307893 */   // Label 5229: @307893
     /* 307893 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(307948), // Rule ID 7475 //
     /* 307898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307912 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 307915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307946 */     GIR_RootConstrainSelectedInstOperands,
     /* 307947 */     // GIR_Coverage, 7475,
     /* 307947 */     GIR_EraseRootFromParent_Done,
     /* 307948 */   // Label 5230: @307948
     /* 307948 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(308006), // Rule ID 7477 //
     /* 307953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307967 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 307967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 307970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307975 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308004 */     GIR_RootConstrainSelectedInstOperands,
     /* 308005 */     // GIR_Coverage, 7477,
     /* 308005 */     GIR_EraseRootFromParent_Done,
     /* 308006 */   // Label 5231: @308006
     /* 308006 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(308061), // Rule ID 7479 //
     /* 308011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308025 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 308025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 308028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308033 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 308043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308059 */     GIR_RootConstrainSelectedInstOperands,
     /* 308060 */     // GIR_Coverage, 7479,
     /* 308060 */     GIR_EraseRootFromParent_Done,
     /* 308061 */   // Label 5232: @308061
     /* 308061 */   GIM_Reject,
     /* 308062 */ // Label 5220: @308062
     /* 308062 */ GIM_Reject,
     /* 308063 */ // Label 5215: @308063
     /* 308063 */ GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(308282),
     /* 308068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308075 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(308123), // Rule ID 7486 //
     /* 308080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 308083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308090 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 308090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 308093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308121 */     GIR_RootConstrainSelectedInstOperands,
     /* 308122 */     // GIR_Coverage, 7486,
     /* 308122 */     GIR_EraseRootFromParent_Done,
     /* 308123 */   // Label 5234: @308123
     /* 308123 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(308171), // Rule ID 7493 //
     /* 308128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FalsePredicate_NotHasMinMaxDenormModes),
     /* 308131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308138 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 308138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 308141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308169 */     GIR_RootConstrainSelectedInstOperands,
     /* 308170 */     // GIR_Coverage, 7493,
     /* 308170 */     GIR_EraseRootFromParent_Done,
     /* 308171 */   // Label 5235: @308171
     /* 308171 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(308233), // Rule ID 7483 //
     /* 308176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 308184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308197 */     // (fcanonicalize:{ *:[f32] } (fneg:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 308197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 308200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308205 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 308215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308231 */     GIR_RootConstrainSelectedInstOperands,
     /* 308232 */     // GIR_Coverage, 7483,
     /* 308232 */     GIR_EraseRootFromParent_Done,
     /* 308233 */   // Label 5236: @308233
     /* 308233 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(308281), // Rule ID 7482 //
     /* 308238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308245 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 308245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 308248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308253 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 308263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308279 */     GIR_RootConstrainSelectedInstOperands,
     /* 308280 */     // GIR_Coverage, 7482,
     /* 308280 */     GIR_EraseRootFromParent_Done,
     /* 308281 */   // Label 5237: @308281
     /* 308281 */   GIM_Reject,
     /* 308282 */ // Label 5233: @308282
     /* 308282 */ GIM_Reject,
     /* 308283 */ // Label 5216: @308283
     /* 308283 */ GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(308539),
     /* 308288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 308295 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(308343), // Rule ID 7487 //
     /* 308300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isNotGFX12Plus),
     /* 308303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308310 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 308313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308341 */     GIR_RootConstrainSelectedInstOperands,
     /* 308342 */     // GIR_Coverage, 7487,
     /* 308342 */     GIR_EraseRootFromParent_Done,
     /* 308343 */   // Label 5239: @308343
     /* 308343 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(308391), // Rule ID 7488 //
     /* 308348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isGFX12Plus),
     /* 308351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308358 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 308361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308389 */     GIR_RootConstrainSelectedInstOperands,
     /* 308390 */     // GIR_Coverage, 7488,
     /* 308390 */     GIR_EraseRootFromParent_Done,
     /* 308391 */   // Label 5240: @308391
     /* 308391 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(308439), // Rule ID 7494 //
     /* 308396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus),
     /* 308399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308406 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 308409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308437 */     GIR_RootConstrainSelectedInstOperands,
     /* 308438 */     // GIR_Coverage, 7494,
     /* 308438 */     GIR_EraseRootFromParent_Done,
     /* 308439 */   // Label 5241: @308439
     /* 308439 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(308487), // Rule ID 7495 //
     /* 308444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus),
     /* 308447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308454 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 308457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308485 */     GIR_RootConstrainSelectedInstOperands,
     /* 308486 */     // GIR_Coverage, 7495,
     /* 308486 */     GIR_EraseRootFromParent_Done,
     /* 308487 */   // Label 5242: @308487
     /* 308487 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(308538), // Rule ID 7485 //
     /* 308492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 308495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308502 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F64_e64:{ *:[f64] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 308505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308510 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 308520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308536 */     GIR_RootConstrainSelectedInstOperands,
     /* 308537 */     // GIR_Coverage, 7485,
     /* 308537 */     GIR_EraseRootFromParent_Done,
     /* 308538 */   // Label 5243: @308538
     /* 308538 */   GIM_Reject,
     /* 308539 */ // Label 5238: @308539
     /* 308539 */ GIM_Reject,
     /* 308540 */ // Label 5217: @308540
     /* 308540 */ GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(308724),
     /* 308545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 308548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308552 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(308609), // Rule ID 7492 //
     /* 308557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 308560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308567 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 308570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308607 */     GIR_RootConstrainSelectedInstOperands,
     /* 308608 */     // GIR_Coverage, 7492,
     /* 308608 */     GIR_EraseRootFromParent_Done,
     /* 308609 */   // Label 5245: @308609
     /* 308609 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(308666), // Rule ID 7499 //
     /* 308614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_NotHasMinMaxDenormModes),
     /* 308617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308624 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 308627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308664 */     GIR_RootConstrainSelectedInstOperands,
     /* 308665 */     // GIR_Coverage, 7499,
     /* 308665 */     GIR_EraseRootFromParent_Done,
     /* 308666 */   // Label 5246: @308666
     /* 308666 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(308723), // Rule ID 7481 //
     /* 308671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308678 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F16:{ *:[v2f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 308681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308686 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 308696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308721 */     GIR_RootConstrainSelectedInstOperands,
     /* 308722 */     // GIR_Coverage, 7481,
     /* 308722 */     GIR_EraseRootFromParent_Done,
     /* 308723 */   // Label 5247: @308723
     /* 308723 */   GIM_Reject,
     /* 308724 */ // Label 5244: @308724
     /* 308724 */ GIM_Reject,
     /* 308725 */ // Label 5218: @308725
     /* 308725 */ GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(308792), // Rule ID 7484 //
     /* 308730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 308733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 308740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308747 */   // (fcanonicalize:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F32:{ *:[v2f32] } 0:{ *:[i32] }, 1065353216:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f32] }:$src)
     /* 308747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 308750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308755 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 308765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308790 */   GIR_RootConstrainSelectedInstOperands,
     /* 308791 */   // GIR_Coverage, 7484,
     /* 308791 */   GIR_EraseRootFromParent_Done,
     /* 308792 */ // Label 5248: @308792
     /* 308792 */ GIM_Reject,
     /* 308793 */ // Label 5219: @308793
     /* 308793 */ GIM_Reject,
     /* 308794 */ // Label 80: @308794
     /* 308794 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5253*/ GIMT_Encode4(380572),
     /* 308805 */ /*GILLT_s16*//*Label 5249*/ GIMT_Encode4(308821),
     /* 308809 */ /*GILLT_s32*//*Label 5250*/ GIMT_Encode4(362735),
     /* 308813 */ /*GILLT_s64*//*Label 5251*/ GIMT_Encode4(380247),
     /* 308817 */ /*GILLT_v2s16*//*Label 5252*/ GIMT_Encode4(380500),
     /* 308821 */ // Label 5249: @308821
     /* 308821 */ GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(362734),
     /* 308826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308832 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(308967), // Rule ID 12266 //
     /* 308837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 308876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 308884 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 308884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 308889 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 308889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 308894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 308898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308921 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 308921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 308924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 308931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 308941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 308946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 308951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 308956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308965 */     GIR_RootConstrainSelectedInstOperands,
     /* 308966 */     // GIR_Coverage, 12266,
     /* 308966 */     GIR_EraseRootFromParent_Done,
     /* 308967 */   // Label 5255: @308967
     /* 308967 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(309102), // Rule ID 12267 //
     /* 308972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309056 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 309059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309100 */     GIR_RootConstrainSelectedInstOperands,
     /* 309101 */     // GIR_Coverage, 12267,
     /* 309101 */     GIR_EraseRootFromParent_Done,
     /* 309102 */   // Label 5256: @309102
     /* 309102 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(309237), // Rule ID 12270 //
     /* 309107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 309110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309191 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 309194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309235 */     GIR_RootConstrainSelectedInstOperands,
     /* 309236 */     // GIR_Coverage, 12270,
     /* 309236 */     GIR_EraseRootFromParent_Done,
     /* 309237 */   // Label 5257: @309237
     /* 309237 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(309372), // Rule ID 12271 //
     /* 309242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 309245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309326 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 309329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309370 */     GIR_RootConstrainSelectedInstOperands,
     /* 309371 */     // GIR_Coverage, 12271,
     /* 309371 */     GIR_EraseRootFromParent_Done,
     /* 309372 */   // Label 5258: @309372
     /* 309372 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(309507), // Rule ID 12746 //
     /* 309377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309429 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309461 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309505 */     GIR_RootConstrainSelectedInstOperands,
     /* 309506 */     // GIR_Coverage, 12746,
     /* 309506 */     GIR_EraseRootFromParent_Done,
     /* 309507 */   // Label 5259: @309507
     /* 309507 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(309642), // Rule ID 12747 //
     /* 309512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309559 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309564 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309596 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309640 */     GIR_RootConstrainSelectedInstOperands,
     /* 309641 */     // GIR_Coverage, 12747,
     /* 309641 */     GIR_EraseRootFromParent_Done,
     /* 309642 */   // Label 5260: @309642
     /* 309642 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(309777), // Rule ID 12750 //
     /* 309647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309694 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309731 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309775 */     GIR_RootConstrainSelectedInstOperands,
     /* 309776 */     // GIR_Coverage, 12750,
     /* 309776 */     GIR_EraseRootFromParent_Done,
     /* 309777 */   // Label 5261: @309777
     /* 309777 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(309912), // Rule ID 12751 //
     /* 309782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309866 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309910 */     GIR_RootConstrainSelectedInstOperands,
     /* 309911 */     // GIR_Coverage, 12751,
     /* 309911 */     GIR_EraseRootFromParent_Done,
     /* 309912 */   // Label 5262: @309912
     /* 309912 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(310047), // Rule ID 13226 //
     /* 309917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 309920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310001 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 310004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310045 */     GIR_RootConstrainSelectedInstOperands,
     /* 310046 */     // GIR_Coverage, 13226,
     /* 310046 */     GIR_EraseRootFromParent_Done,
     /* 310047 */   // Label 5263: @310047
     /* 310047 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(310182), // Rule ID 13227 //
     /* 310052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 310055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 310099 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310104 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310136 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 310139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310180 */     GIR_RootConstrainSelectedInstOperands,
     /* 310181 */     // GIR_Coverage, 13227,
     /* 310181 */     GIR_EraseRootFromParent_Done,
     /* 310182 */   // Label 5264: @310182
     /* 310182 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(310317), // Rule ID 13230 //
     /* 310187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 310190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 310234 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310239 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310271 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 310274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310315 */     GIR_RootConstrainSelectedInstOperands,
     /* 310316 */     // GIR_Coverage, 13230,
     /* 310316 */     GIR_EraseRootFromParent_Done,
     /* 310317 */   // Label 5265: @310317
     /* 310317 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(310452), // Rule ID 13231 //
     /* 310322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 310325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 310369 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310374 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310406 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 310409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310450 */     GIR_RootConstrainSelectedInstOperands,
     /* 310451 */     // GIR_Coverage, 13231,
     /* 310451 */     GIR_EraseRootFromParent_Done,
     /* 310452 */   // Label 5266: @310452
     /* 310452 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(310587), // Rule ID 12251 //
     /* 310457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310541 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310585 */     GIR_RootConstrainSelectedInstOperands,
     /* 310586 */     // GIR_Coverage, 12251,
     /* 310586 */     GIR_EraseRootFromParent_Done,
     /* 310587 */   // Label 5267: @310587
     /* 310587 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(310722), // Rule ID 12252 //
     /* 310592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310676 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310720 */     GIR_RootConstrainSelectedInstOperands,
     /* 310721 */     // GIR_Coverage, 12252,
     /* 310721 */     GIR_EraseRootFromParent_Done,
     /* 310722 */   // Label 5268: @310722
     /* 310722 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(310857), // Rule ID 12255 //
     /* 310727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310811 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310855 */     GIR_RootConstrainSelectedInstOperands,
     /* 310856 */     // GIR_Coverage, 12255,
     /* 310856 */     GIR_EraseRootFromParent_Done,
     /* 310857 */   // Label 5269: @310857
     /* 310857 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(310992), // Rule ID 12256 //
     /* 310862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310914 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310946 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310990 */     GIR_RootConstrainSelectedInstOperands,
     /* 310991 */     // GIR_Coverage, 12256,
     /* 310991 */     GIR_EraseRootFromParent_Done,
     /* 310992 */   // Label 5270: @310992
     /* 310992 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(311127), // Rule ID 12731 //
     /* 310997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311044 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311049 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311081 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311125 */     GIR_RootConstrainSelectedInstOperands,
     /* 311126 */     // GIR_Coverage, 12731,
     /* 311126 */     GIR_EraseRootFromParent_Done,
     /* 311127 */   // Label 5271: @311127
     /* 311127 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(311262), // Rule ID 12732 //
     /* 311132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311179 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311216 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311260 */     GIR_RootConstrainSelectedInstOperands,
     /* 311261 */     // GIR_Coverage, 12732,
     /* 311261 */     GIR_EraseRootFromParent_Done,
     /* 311262 */   // Label 5272: @311262
     /* 311262 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(311397), // Rule ID 12735 //
     /* 311267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311351 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311395 */     GIR_RootConstrainSelectedInstOperands,
     /* 311396 */     // GIR_Coverage, 12735,
     /* 311396 */     GIR_EraseRootFromParent_Done,
     /* 311397 */   // Label 5273: @311397
     /* 311397 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(311532), // Rule ID 12736 //
     /* 311402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311486 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311530 */     GIR_RootConstrainSelectedInstOperands,
     /* 311531 */     // GIR_Coverage, 12736,
     /* 311531 */     GIR_EraseRootFromParent_Done,
     /* 311532 */   // Label 5274: @311532
     /* 311532 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(311667), // Rule ID 13211 //
     /* 311537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311584 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311589 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311621 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311665 */     GIR_RootConstrainSelectedInstOperands,
     /* 311666 */     // GIR_Coverage, 13211,
     /* 311666 */     GIR_EraseRootFromParent_Done,
     /* 311667 */   // Label 5275: @311667
     /* 311667 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(311802), // Rule ID 13212 //
     /* 311672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311719 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311724 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311756 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311800 */     GIR_RootConstrainSelectedInstOperands,
     /* 311801 */     // GIR_Coverage, 13212,
     /* 311801 */     GIR_EraseRootFromParent_Done,
     /* 311802 */   // Label 5276: @311802
     /* 311802 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(311937), // Rule ID 13215 //
     /* 311807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311854 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311859 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311891 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311935 */     GIR_RootConstrainSelectedInstOperands,
     /* 311936 */     // GIR_Coverage, 13215,
     /* 311936 */     GIR_EraseRootFromParent_Done,
     /* 311937 */   // Label 5277: @311937
     /* 311937 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(312072), // Rule ID 13216 //
     /* 311942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311989 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311994 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312026 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 312029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312070 */     GIR_RootConstrainSelectedInstOperands,
     /* 312071 */     // GIR_Coverage, 13216,
     /* 312071 */     GIR_EraseRootFromParent_Done,
     /* 312072 */   // Label 5278: @312072
     /* 312072 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(312207), // Rule ID 7649 //
     /* 312077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312161 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312205 */     GIR_RootConstrainSelectedInstOperands,
     /* 312206 */     // GIR_Coverage, 7649,
     /* 312206 */     GIR_EraseRootFromParent_Done,
     /* 312207 */   // Label 5279: @312207
     /* 312207 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(312342), // Rule ID 7681 //
     /* 312212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 312215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312296 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312340 */     GIR_RootConstrainSelectedInstOperands,
     /* 312341 */     // GIR_Coverage, 7681,
     /* 312341 */     GIR_EraseRootFromParent_Done,
     /* 312342 */   // Label 5280: @312342
     /* 312342 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(312477), // Rule ID 7713 //
     /* 312347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 312350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312399 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312431 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 312434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312475 */     GIR_RootConstrainSelectedInstOperands,
     /* 312476 */     // GIR_Coverage, 7713,
     /* 312476 */     GIR_EraseRootFromParent_Done,
     /* 312477 */   // Label 5281: @312477
     /* 312477 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(312612), // Rule ID 12265 //
     /* 312482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312529 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312534 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312566 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312610 */     GIR_RootConstrainSelectedInstOperands,
     /* 312611 */     // GIR_Coverage, 12265,
     /* 312611 */     GIR_EraseRootFromParent_Done,
     /* 312612 */   // Label 5282: @312612
     /* 312612 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(312747), // Rule ID 12268 //
     /* 312617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312664 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312701 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312745 */     GIR_RootConstrainSelectedInstOperands,
     /* 312746 */     // GIR_Coverage, 12268,
     /* 312746 */     GIR_EraseRootFromParent_Done,
     /* 312747 */   // Label 5283: @312747
     /* 312747 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(312882), // Rule ID 12269 //
     /* 312752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312804 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312836 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312880 */     GIR_RootConstrainSelectedInstOperands,
     /* 312881 */     // GIR_Coverage, 12269,
     /* 312881 */     GIR_EraseRootFromParent_Done,
     /* 312882 */   // Label 5284: @312882
     /* 312882 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(313017), // Rule ID 12745 //
     /* 312887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 312890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312971 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313015 */     GIR_RootConstrainSelectedInstOperands,
     /* 313016 */     // GIR_Coverage, 12745,
     /* 313016 */     GIR_EraseRootFromParent_Done,
     /* 313017 */   // Label 5285: @313017
     /* 313017 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(313152), // Rule ID 12748 //
     /* 313022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313106 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313150 */     GIR_RootConstrainSelectedInstOperands,
     /* 313151 */     // GIR_Coverage, 12748,
     /* 313151 */     GIR_EraseRootFromParent_Done,
     /* 313152 */   // Label 5286: @313152
     /* 313152 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(313287), // Rule ID 12749 //
     /* 313157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313241 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313285 */     GIR_RootConstrainSelectedInstOperands,
     /* 313286 */     // GIR_Coverage, 12749,
     /* 313286 */     GIR_EraseRootFromParent_Done,
     /* 313287 */   // Label 5287: @313287
     /* 313287 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(313422), // Rule ID 13225 //
     /* 313292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313339 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313376 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313420 */     GIR_RootConstrainSelectedInstOperands,
     /* 313421 */     // GIR_Coverage, 13225,
     /* 313421 */     GIR_EraseRootFromParent_Done,
     /* 313422 */   // Label 5288: @313422
     /* 313422 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(313557), // Rule ID 13228 //
     /* 313427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313479 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313511 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313555 */     GIR_RootConstrainSelectedInstOperands,
     /* 313556 */     // GIR_Coverage, 13228,
     /* 313556 */     GIR_EraseRootFromParent_Done,
     /* 313557 */   // Label 5289: @313557
     /* 313557 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(313692), // Rule ID 13229 //
     /* 313562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313609 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313614 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313646 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313690 */     GIR_RootConstrainSelectedInstOperands,
     /* 313691 */     // GIR_Coverage, 13229,
     /* 313691 */     GIR_EraseRootFromParent_Done,
     /* 313692 */   // Label 5290: @313692
     /* 313692 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(313827), // Rule ID 7648 //
     /* 313697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313744 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313749 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313781 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313825 */     GIR_RootConstrainSelectedInstOperands,
     /* 313826 */     // GIR_Coverage, 7648,
     /* 313826 */     GIR_EraseRootFromParent_Done,
     /* 313827 */   // Label 5291: @313827
     /* 313827 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(313962), // Rule ID 7680 //
     /* 313832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313916 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313960 */     GIR_RootConstrainSelectedInstOperands,
     /* 313961 */     // GIR_Coverage, 7680,
     /* 313961 */     GIR_EraseRootFromParent_Done,
     /* 313962 */   // Label 5292: @313962
     /* 313962 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(314097), // Rule ID 7712 //
     /* 313967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314051 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314095 */     GIR_RootConstrainSelectedInstOperands,
     /* 314096 */     // GIR_Coverage, 7712,
     /* 314096 */     GIR_EraseRootFromParent_Done,
     /* 314097 */   // Label 5293: @314097
     /* 314097 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(314232), // Rule ID 12250 //
     /* 314102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314186 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314230 */     GIR_RootConstrainSelectedInstOperands,
     /* 314231 */     // GIR_Coverage, 12250,
     /* 314231 */     GIR_EraseRootFromParent_Done,
     /* 314232 */   // Label 5294: @314232
     /* 314232 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(314367), // Rule ID 12253 //
     /* 314237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314284 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314321 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314365 */     GIR_RootConstrainSelectedInstOperands,
     /* 314366 */     // GIR_Coverage, 12253,
     /* 314366 */     GIR_EraseRootFromParent_Done,
     /* 314367 */   // Label 5295: @314367
     /* 314367 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(314502), // Rule ID 12254 //
     /* 314372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314456 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314500 */     GIR_RootConstrainSelectedInstOperands,
     /* 314501 */     // GIR_Coverage, 12254,
     /* 314501 */     GIR_EraseRootFromParent_Done,
     /* 314502 */   // Label 5296: @314502
     /* 314502 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(314637), // Rule ID 12730 //
     /* 314507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314591 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314635 */     GIR_RootConstrainSelectedInstOperands,
     /* 314636 */     // GIR_Coverage, 12730,
     /* 314636 */     GIR_EraseRootFromParent_Done,
     /* 314637 */   // Label 5297: @314637
     /* 314637 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(314772), // Rule ID 12733 //
     /* 314642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314726 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314770 */     GIR_RootConstrainSelectedInstOperands,
     /* 314771 */     // GIR_Coverage, 12733,
     /* 314771 */     GIR_EraseRootFromParent_Done,
     /* 314772 */   // Label 5298: @314772
     /* 314772 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(314907), // Rule ID 12734 //
     /* 314777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314861 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314905 */     GIR_RootConstrainSelectedInstOperands,
     /* 314906 */     // GIR_Coverage, 12734,
     /* 314906 */     GIR_EraseRootFromParent_Done,
     /* 314907 */   // Label 5299: @314907
     /* 314907 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(315042), // Rule ID 13210 //
     /* 314912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314996 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315040 */     GIR_RootConstrainSelectedInstOperands,
     /* 315041 */     // GIR_Coverage, 13210,
     /* 315041 */     GIR_EraseRootFromParent_Done,
     /* 315042 */   // Label 5300: @315042
     /* 315042 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(315177), // Rule ID 13213 //
     /* 315047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 315050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315099 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315131 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 315134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315175 */     GIR_RootConstrainSelectedInstOperands,
     /* 315176 */     // GIR_Coverage, 13213,
     /* 315176 */     GIR_EraseRootFromParent_Done,
     /* 315177 */   // Label 5301: @315177
     /* 315177 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(315312), // Rule ID 13214 //
     /* 315182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 315185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315229 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315234 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315266 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 315269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315310 */     GIR_RootConstrainSelectedInstOperands,
     /* 315311 */     // GIR_Coverage, 13214,
     /* 315311 */     GIR_EraseRootFromParent_Done,
     /* 315312 */   // Label 5302: @315312
     /* 315312 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(315447), // Rule ID 12236 //
     /* 315317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315364 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315369 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315401 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315445 */     GIR_RootConstrainSelectedInstOperands,
     /* 315446 */     // GIR_Coverage, 12236,
     /* 315446 */     GIR_EraseRootFromParent_Done,
     /* 315447 */   // Label 5303: @315447
     /* 315447 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(315582), // Rule ID 12237 //
     /* 315452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315536 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315580 */     GIR_RootConstrainSelectedInstOperands,
     /* 315581 */     // GIR_Coverage, 12237,
     /* 315581 */     GIR_EraseRootFromParent_Done,
     /* 315582 */   // Label 5304: @315582
     /* 315582 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(315717), // Rule ID 12240 //
     /* 315587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315671 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315715 */     GIR_RootConstrainSelectedInstOperands,
     /* 315716 */     // GIR_Coverage, 12240,
     /* 315716 */     GIR_EraseRootFromParent_Done,
     /* 315717 */   // Label 5305: @315717
     /* 315717 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(315852), // Rule ID 12241 //
     /* 315722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315806 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315850 */     GIR_RootConstrainSelectedInstOperands,
     /* 315851 */     // GIR_Coverage, 12241,
     /* 315851 */     GIR_EraseRootFromParent_Done,
     /* 315852 */   // Label 5306: @315852
     /* 315852 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(315987), // Rule ID 12716 //
     /* 315857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315941 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315985 */     GIR_RootConstrainSelectedInstOperands,
     /* 315986 */     // GIR_Coverage, 12716,
     /* 315986 */     GIR_EraseRootFromParent_Done,
     /* 315987 */   // Label 5307: @315987
     /* 315987 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(316122), // Rule ID 12717 //
     /* 315992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316039 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316044 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316076 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 316079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316120 */     GIR_RootConstrainSelectedInstOperands,
     /* 316121 */     // GIR_Coverage, 12717,
     /* 316121 */     GIR_EraseRootFromParent_Done,
     /* 316122 */   // Label 5308: @316122
     /* 316122 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(316257), // Rule ID 12720 //
     /* 316127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 316130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 316134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316174 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316179 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316211 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 316214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316255 */     GIR_RootConstrainSelectedInstOperands,
     /* 316256 */     // GIR_Coverage, 12720,
     /* 316256 */     GIR_EraseRootFromParent_Done,
     /* 316257 */   // Label 5309: @316257
     /* 316257 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(316392), // Rule ID 12721 //
     /* 316262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 316265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 316269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316309 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316346 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 316349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316390 */     GIR_RootConstrainSelectedInstOperands,
     /* 316391 */     // GIR_Coverage, 12721,
     /* 316391 */     GIR_EraseRootFromParent_Done,
     /* 316392 */   // Label 5310: @316392
     /* 316392 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(316527), // Rule ID 13196 //
     /* 316397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316481 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316525 */     GIR_RootConstrainSelectedInstOperands,
     /* 316526 */     // GIR_Coverage, 13196,
     /* 316526 */     GIR_EraseRootFromParent_Done,
     /* 316527 */   // Label 5311: @316527
     /* 316527 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(316662), // Rule ID 13197 //
     /* 316532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316584 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316616 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316660 */     GIR_RootConstrainSelectedInstOperands,
     /* 316661 */     // GIR_Coverage, 13197,
     /* 316661 */     GIR_EraseRootFromParent_Done,
     /* 316662 */   // Label 5312: @316662
     /* 316662 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(316797), // Rule ID 13200 //
     /* 316667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316719 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316751 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316795 */     GIR_RootConstrainSelectedInstOperands,
     /* 316796 */     // GIR_Coverage, 13200,
     /* 316796 */     GIR_EraseRootFromParent_Done,
     /* 316797 */   // Label 5313: @316797
     /* 316797 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(316932), // Rule ID 13201 //
     /* 316802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316849 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316854 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316886 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316930 */     GIR_RootConstrainSelectedInstOperands,
     /* 316931 */     // GIR_Coverage, 13201,
     /* 316931 */     GIR_EraseRootFromParent_Done,
     /* 316932 */   // Label 5314: @316932
     /* 316932 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(317067), // Rule ID 12221 //
     /* 316937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 316984 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316989 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317021 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317065 */     GIR_RootConstrainSelectedInstOperands,
     /* 317066 */     // GIR_Coverage, 12221,
     /* 317066 */     GIR_EraseRootFromParent_Done,
     /* 317067 */   // Label 5315: @317067
     /* 317067 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(317202), // Rule ID 12222 //
     /* 317072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 317075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317156 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317200 */     GIR_RootConstrainSelectedInstOperands,
     /* 317201 */     // GIR_Coverage, 12222,
     /* 317201 */     GIR_EraseRootFromParent_Done,
     /* 317202 */   // Label 5316: @317202
     /* 317202 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(317337), // Rule ID 12225 //
     /* 317207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 317210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317291 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317335 */     GIR_RootConstrainSelectedInstOperands,
     /* 317336 */     // GIR_Coverage, 12225,
     /* 317336 */     GIR_EraseRootFromParent_Done,
     /* 317337 */   // Label 5317: @317337
     /* 317337 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(317472), // Rule ID 12226 //
     /* 317342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 317345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317426 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317470 */     GIR_RootConstrainSelectedInstOperands,
     /* 317471 */     // GIR_Coverage, 12226,
     /* 317471 */     GIR_EraseRootFromParent_Done,
     /* 317472 */   // Label 5318: @317472
     /* 317472 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(317607), // Rule ID 12701 //
     /* 317477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317529 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317561 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317605 */     GIR_RootConstrainSelectedInstOperands,
     /* 317606 */     // GIR_Coverage, 12701,
     /* 317606 */     GIR_EraseRootFromParent_Done,
     /* 317607 */   // Label 5319: @317607
     /* 317607 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(317742), // Rule ID 12702 //
     /* 317612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317659 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317664 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317696 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317740 */     GIR_RootConstrainSelectedInstOperands,
     /* 317741 */     // GIR_Coverage, 12702,
     /* 317741 */     GIR_EraseRootFromParent_Done,
     /* 317742 */   // Label 5320: @317742
     /* 317742 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(317877), // Rule ID 12705 //
     /* 317747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317794 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317831 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317875 */     GIR_RootConstrainSelectedInstOperands,
     /* 317876 */     // GIR_Coverage, 12705,
     /* 317876 */     GIR_EraseRootFromParent_Done,
     /* 317877 */   // Label 5321: @317877
     /* 317877 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(318012), // Rule ID 12706 //
     /* 317882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317966 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318010 */     GIR_RootConstrainSelectedInstOperands,
     /* 318011 */     // GIR_Coverage, 12706,
     /* 318011 */     GIR_EraseRootFromParent_Done,
     /* 318012 */   // Label 5322: @318012
     /* 318012 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(318147), // Rule ID 13181 //
     /* 318017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318101 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318145 */     GIR_RootConstrainSelectedInstOperands,
     /* 318146 */     // GIR_Coverage, 13181,
     /* 318146 */     GIR_EraseRootFromParent_Done,
     /* 318147 */   // Label 5323: @318147
     /* 318147 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(318282), // Rule ID 13182 //
     /* 318152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318204 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318236 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318280 */     GIR_RootConstrainSelectedInstOperands,
     /* 318281 */     // GIR_Coverage, 13182,
     /* 318281 */     GIR_EraseRootFromParent_Done,
     /* 318282 */   // Label 5324: @318282
     /* 318282 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(318417), // Rule ID 13185 //
     /* 318287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318334 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318339 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318371 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318415 */     GIR_RootConstrainSelectedInstOperands,
     /* 318416 */     // GIR_Coverage, 13185,
     /* 318416 */     GIR_EraseRootFromParent_Done,
     /* 318417 */   // Label 5325: @318417
     /* 318417 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(318552), // Rule ID 13186 //
     /* 318422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318469 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318506 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318550 */     GIR_RootConstrainSelectedInstOperands,
     /* 318551 */     // GIR_Coverage, 13186,
     /* 318551 */     GIR_EraseRootFromParent_Done,
     /* 318552 */   // Label 5326: @318552
     /* 318552 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(318687), // Rule ID 7647 //
     /* 318557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318609 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318641 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318685 */     GIR_RootConstrainSelectedInstOperands,
     /* 318686 */     // GIR_Coverage, 7647,
     /* 318686 */     GIR_EraseRootFromParent_Done,
     /* 318687 */   // Label 5327: @318687
     /* 318687 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(318822), // Rule ID 7679 //
     /* 318692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 318695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 318699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318776 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318820 */     GIR_RootConstrainSelectedInstOperands,
     /* 318821 */     // GIR_Coverage, 7679,
     /* 318821 */     GIR_EraseRootFromParent_Done,
     /* 318822 */   // Label 5328: @318822
     /* 318822 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(318957), // Rule ID 7711 //
     /* 318827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318879 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318911 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318955 */     GIR_RootConstrainSelectedInstOperands,
     /* 318956 */     // GIR_Coverage, 7711,
     /* 318956 */     GIR_EraseRootFromParent_Done,
     /* 318957 */   // Label 5329: @318957
     /* 318957 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(319092), // Rule ID 12235 //
     /* 318962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319046 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319090 */     GIR_RootConstrainSelectedInstOperands,
     /* 319091 */     // GIR_Coverage, 12235,
     /* 319091 */     GIR_EraseRootFromParent_Done,
     /* 319092 */   // Label 5330: @319092
     /* 319092 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(319227), // Rule ID 12238 //
     /* 319097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319181 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319225 */     GIR_RootConstrainSelectedInstOperands,
     /* 319226 */     // GIR_Coverage, 12238,
     /* 319226 */     GIR_EraseRootFromParent_Done,
     /* 319227 */   // Label 5331: @319227
     /* 319227 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(319362), // Rule ID 12239 //
     /* 319232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319279 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319284 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319316 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319360 */     GIR_RootConstrainSelectedInstOperands,
     /* 319361 */     // GIR_Coverage, 12239,
     /* 319361 */     GIR_EraseRootFromParent_Done,
     /* 319362 */   // Label 5332: @319362
     /* 319362 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(319497), // Rule ID 12715 //
     /* 319367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319451 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319495 */     GIR_RootConstrainSelectedInstOperands,
     /* 319496 */     // GIR_Coverage, 12715,
     /* 319496 */     GIR_EraseRootFromParent_Done,
     /* 319497 */   // Label 5333: @319497
     /* 319497 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(319632), // Rule ID 12718 //
     /* 319502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319586 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319630 */     GIR_RootConstrainSelectedInstOperands,
     /* 319631 */     // GIR_Coverage, 12718,
     /* 319631 */     GIR_EraseRootFromParent_Done,
     /* 319632 */   // Label 5334: @319632
     /* 319632 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(319767), // Rule ID 12719 //
     /* 319637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319721 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319765 */     GIR_RootConstrainSelectedInstOperands,
     /* 319766 */     // GIR_Coverage, 12719,
     /* 319766 */     GIR_EraseRootFromParent_Done,
     /* 319767 */   // Label 5335: @319767
     /* 319767 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(319902), // Rule ID 13195 //
     /* 319772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319856 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319900 */     GIR_RootConstrainSelectedInstOperands,
     /* 319901 */     // GIR_Coverage, 13195,
     /* 319901 */     GIR_EraseRootFromParent_Done,
     /* 319902 */   // Label 5336: @319902
     /* 319902 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(320037), // Rule ID 13198 //
     /* 319907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319954 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319991 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320035 */     GIR_RootConstrainSelectedInstOperands,
     /* 320036 */     // GIR_Coverage, 13198,
     /* 320036 */     GIR_EraseRootFromParent_Done,
     /* 320037 */   // Label 5337: @320037
     /* 320037 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(320172), // Rule ID 13199 //
     /* 320042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320126 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320170 */     GIR_RootConstrainSelectedInstOperands,
     /* 320171 */     // GIR_Coverage, 13199,
     /* 320171 */     GIR_EraseRootFromParent_Done,
     /* 320172 */   // Label 5338: @320172
     /* 320172 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(320307), // Rule ID 7646 //
     /* 320177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320229 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320261 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320305 */     GIR_RootConstrainSelectedInstOperands,
     /* 320306 */     // GIR_Coverage, 7646,
     /* 320306 */     GIR_EraseRootFromParent_Done,
     /* 320307 */   // Label 5339: @320307
     /* 320307 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(320442), // Rule ID 7678 //
     /* 320312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320396 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320440 */     GIR_RootConstrainSelectedInstOperands,
     /* 320441 */     // GIR_Coverage, 7678,
     /* 320441 */     GIR_EraseRootFromParent_Done,
     /* 320442 */   // Label 5340: @320442
     /* 320442 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(320577), // Rule ID 7710 //
     /* 320447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320494 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320531 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320575 */     GIR_RootConstrainSelectedInstOperands,
     /* 320576 */     // GIR_Coverage, 7710,
     /* 320576 */     GIR_EraseRootFromParent_Done,
     /* 320577 */   // Label 5341: @320577
     /* 320577 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(320712), // Rule ID 12220 //
     /* 320582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320666 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320710 */     GIR_RootConstrainSelectedInstOperands,
     /* 320711 */     // GIR_Coverage, 12220,
     /* 320711 */     GIR_EraseRootFromParent_Done,
     /* 320712 */   // Label 5342: @320712
     /* 320712 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(320847), // Rule ID 12223 //
     /* 320717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320801 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320845 */     GIR_RootConstrainSelectedInstOperands,
     /* 320846 */     // GIR_Coverage, 12223,
     /* 320846 */     GIR_EraseRootFromParent_Done,
     /* 320847 */   // Label 5343: @320847
     /* 320847 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(320982), // Rule ID 12224 //
     /* 320852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320936 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320980 */     GIR_RootConstrainSelectedInstOperands,
     /* 320981 */     // GIR_Coverage, 12224,
     /* 320981 */     GIR_EraseRootFromParent_Done,
     /* 320982 */   // Label 5344: @320982
     /* 320982 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(321117), // Rule ID 12700 //
     /* 320987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321071 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321115 */     GIR_RootConstrainSelectedInstOperands,
     /* 321116 */     // GIR_Coverage, 12700,
     /* 321116 */     GIR_EraseRootFromParent_Done,
     /* 321117 */   // Label 5345: @321117
     /* 321117 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(321252), // Rule ID 12703 //
     /* 321122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 321125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 321129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321206 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321250 */     GIR_RootConstrainSelectedInstOperands,
     /* 321251 */     // GIR_Coverage, 12703,
     /* 321251 */     GIR_EraseRootFromParent_Done,
     /* 321252 */   // Label 5346: @321252
     /* 321252 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(321387), // Rule ID 12704 //
     /* 321257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 321260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 321264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321341 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321385 */     GIR_RootConstrainSelectedInstOperands,
     /* 321386 */     // GIR_Coverage, 12704,
     /* 321386 */     GIR_EraseRootFromParent_Done,
     /* 321387 */   // Label 5347: @321387
     /* 321387 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(321522), // Rule ID 13180 //
     /* 321392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321476 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321520 */     GIR_RootConstrainSelectedInstOperands,
     /* 321521 */     // GIR_Coverage, 13180,
     /* 321521 */     GIR_EraseRootFromParent_Done,
     /* 321522 */   // Label 5348: @321522
     /* 321522 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(321657), // Rule ID 13183 //
     /* 321527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321611 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321655 */     GIR_RootConstrainSelectedInstOperands,
     /* 321656 */     // GIR_Coverage, 13183,
     /* 321656 */     GIR_EraseRootFromParent_Done,
     /* 321657 */   // Label 5349: @321657
     /* 321657 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(321792), // Rule ID 13184 //
     /* 321662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321746 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321790 */     GIR_RootConstrainSelectedInstOperands,
     /* 321791 */     // GIR_Coverage, 13184,
     /* 321791 */     GIR_EraseRootFromParent_Done,
     /* 321792 */   // Label 5350: @321792
     /* 321792 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(321927), // Rule ID 12276 //
     /* 321797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321849 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321881 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 321901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 321906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 321911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 321916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321925 */     GIR_RootConstrainSelectedInstOperands,
     /* 321926 */     // GIR_Coverage, 12276,
     /* 321926 */     GIR_EraseRootFromParent_Done,
     /* 321927 */   // Label 5351: @321927
     /* 321927 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(322062), // Rule ID 12277 //
     /* 321932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321979 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321984 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322016 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 322019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322060 */     GIR_RootConstrainSelectedInstOperands,
     /* 322061 */     // GIR_Coverage, 12277,
     /* 322061 */     GIR_EraseRootFromParent_Done,
     /* 322062 */   // Label 5352: @322062
     /* 322062 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(322197), // Rule ID 12278 //
     /* 322067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 322070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322114 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322151 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 322154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322195 */     GIR_RootConstrainSelectedInstOperands,
     /* 322196 */     // GIR_Coverage, 12278,
     /* 322196 */     GIR_EraseRootFromParent_Done,
     /* 322197 */   // Label 5353: @322197
     /* 322197 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(322332), // Rule ID 12279 //
     /* 322202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 322205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322286 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 322289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322330 */     GIR_RootConstrainSelectedInstOperands,
     /* 322331 */     // GIR_Coverage, 12279,
     /* 322331 */     GIR_EraseRootFromParent_Done,
     /* 322332 */   // Label 5354: @322332
     /* 322332 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(322467), // Rule ID 12756 //
     /* 322337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322421 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322465 */     GIR_RootConstrainSelectedInstOperands,
     /* 322466 */     // GIR_Coverage, 12756,
     /* 322466 */     GIR_EraseRootFromParent_Done,
     /* 322467 */   // Label 5355: @322467
     /* 322467 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(322602), // Rule ID 12757 //
     /* 322472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322556 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322600 */     GIR_RootConstrainSelectedInstOperands,
     /* 322601 */     // GIR_Coverage, 12757,
     /* 322601 */     GIR_EraseRootFromParent_Done,
     /* 322602 */   // Label 5356: @322602
     /* 322602 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(322737), // Rule ID 12758 //
     /* 322607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322654 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322659 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322691 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322735 */     GIR_RootConstrainSelectedInstOperands,
     /* 322736 */     // GIR_Coverage, 12758,
     /* 322736 */     GIR_EraseRootFromParent_Done,
     /* 322737 */   // Label 5357: @322737
     /* 322737 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(322872), // Rule ID 12759 //
     /* 322742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322789 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322794 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322826 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322870 */     GIR_RootConstrainSelectedInstOperands,
     /* 322871 */     // GIR_Coverage, 12759,
     /* 322871 */     GIR_EraseRootFromParent_Done,
     /* 322872 */   // Label 5358: @322872
     /* 322872 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(323007), // Rule ID 13236 //
     /* 322877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322961 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323005 */     GIR_RootConstrainSelectedInstOperands,
     /* 323006 */     // GIR_Coverage, 13236,
     /* 323006 */     GIR_EraseRootFromParent_Done,
     /* 323007 */   // Label 5359: @323007
     /* 323007 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(323142), // Rule ID 13237 //
     /* 323012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 323015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323096 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323140 */     GIR_RootConstrainSelectedInstOperands,
     /* 323141 */     // GIR_Coverage, 13237,
     /* 323141 */     GIR_EraseRootFromParent_Done,
     /* 323142 */   // Label 5360: @323142
     /* 323142 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(323277), // Rule ID 13238 //
     /* 323147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 323150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323231 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323275 */     GIR_RootConstrainSelectedInstOperands,
     /* 323276 */     // GIR_Coverage, 13238,
     /* 323276 */     GIR_EraseRootFromParent_Done,
     /* 323277 */   // Label 5361: @323277
     /* 323277 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(323412), // Rule ID 13239 //
     /* 323282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 323285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323334 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323366 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323410 */     GIR_RootConstrainSelectedInstOperands,
     /* 323411 */     // GIR_Coverage, 13239,
     /* 323411 */     GIR_EraseRootFromParent_Done,
     /* 323412 */   // Label 5362: @323412
     /* 323412 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(323547), // Rule ID 12216 //
     /* 323417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323464 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323469 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323501 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323545 */     GIR_RootConstrainSelectedInstOperands,
     /* 323546 */     // GIR_Coverage, 12216,
     /* 323546 */     GIR_EraseRootFromParent_Done,
     /* 323547 */   // Label 5363: @323547
     /* 323547 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(323682), // Rule ID 12217 //
     /* 323552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323599 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323636 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323680 */     GIR_RootConstrainSelectedInstOperands,
     /* 323681 */     // GIR_Coverage, 12217,
     /* 323681 */     GIR_EraseRootFromParent_Done,
     /* 323682 */   // Label 5364: @323682
     /* 323682 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(323817), // Rule ID 12218 //
     /* 323687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323771 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323815 */     GIR_RootConstrainSelectedInstOperands,
     /* 323816 */     // GIR_Coverage, 12218,
     /* 323816 */     GIR_EraseRootFromParent_Done,
     /* 323817 */   // Label 5365: @323817
     /* 323817 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(323952), // Rule ID 12219 //
     /* 323822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323906 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323950 */     GIR_RootConstrainSelectedInstOperands,
     /* 323951 */     // GIR_Coverage, 12219,
     /* 323951 */     GIR_EraseRootFromParent_Done,
     /* 323952 */   // Label 5366: @323952
     /* 323952 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(324087), // Rule ID 12696 //
     /* 323957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324041 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324085 */     GIR_RootConstrainSelectedInstOperands,
     /* 324086 */     // GIR_Coverage, 12696,
     /* 324086 */     GIR_EraseRootFromParent_Done,
     /* 324087 */   // Label 5367: @324087
     /* 324087 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(324222), // Rule ID 12697 //
     /* 324092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 324095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 324099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324139 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324176 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324220 */     GIR_RootConstrainSelectedInstOperands,
     /* 324221 */     // GIR_Coverage, 12697,
     /* 324221 */     GIR_EraseRootFromParent_Done,
     /* 324222 */   // Label 5368: @324222
     /* 324222 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(324357), // Rule ID 12698 //
     /* 324227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 324230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 324234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324274 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324279 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324311 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324355 */     GIR_RootConstrainSelectedInstOperands,
     /* 324356 */     // GIR_Coverage, 12698,
     /* 324356 */     GIR_EraseRootFromParent_Done,
     /* 324357 */   // Label 5369: @324357
     /* 324357 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(324492), // Rule ID 12699 //
     /* 324362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 324365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 324369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324446 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324490 */     GIR_RootConstrainSelectedInstOperands,
     /* 324491 */     // GIR_Coverage, 12699,
     /* 324491 */     GIR_EraseRootFromParent_Done,
     /* 324492 */   // Label 5370: @324492
     /* 324492 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(324627), // Rule ID 13176 //
     /* 324497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324581 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324625 */     GIR_RootConstrainSelectedInstOperands,
     /* 324626 */     // GIR_Coverage, 13176,
     /* 324626 */     GIR_EraseRootFromParent_Done,
     /* 324627 */   // Label 5371: @324627
     /* 324627 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(324762), // Rule ID 13177 //
     /* 324632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324716 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324760 */     GIR_RootConstrainSelectedInstOperands,
     /* 324761 */     // GIR_Coverage, 13177,
     /* 324761 */     GIR_EraseRootFromParent_Done,
     /* 324762 */   // Label 5372: @324762
     /* 324762 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(324897), // Rule ID 13178 //
     /* 324767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324851 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324895 */     GIR_RootConstrainSelectedInstOperands,
     /* 324896 */     // GIR_Coverage, 13178,
     /* 324896 */     GIR_EraseRootFromParent_Done,
     /* 324897 */   // Label 5373: @324897
     /* 324897 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(325032), // Rule ID 13179 //
     /* 324902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324949 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324954 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324986 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325030 */     GIR_RootConstrainSelectedInstOperands,
     /* 325031 */     // GIR_Coverage, 13179,
     /* 325031 */     GIR_EraseRootFromParent_Done,
     /* 325032 */   // Label 5374: @325032
     /* 325032 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(325167), // Rule ID 12261 //
     /* 325037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325084 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325121 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325165 */     GIR_RootConstrainSelectedInstOperands,
     /* 325166 */     // GIR_Coverage, 12261,
     /* 325166 */     GIR_EraseRootFromParent_Done,
     /* 325167 */   // Label 5375: @325167
     /* 325167 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(325302), // Rule ID 12262 //
     /* 325172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325256 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325300 */     GIR_RootConstrainSelectedInstOperands,
     /* 325301 */     // GIR_Coverage, 12262,
     /* 325301 */     GIR_EraseRootFromParent_Done,
     /* 325302 */   // Label 5376: @325302
     /* 325302 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(325437), // Rule ID 12263 //
     /* 325307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325391 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325435 */     GIR_RootConstrainSelectedInstOperands,
     /* 325436 */     // GIR_Coverage, 12263,
     /* 325436 */     GIR_EraseRootFromParent_Done,
     /* 325437 */   // Label 5377: @325437
     /* 325437 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(325572), // Rule ID 12264 //
     /* 325442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325494 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325526 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325570 */     GIR_RootConstrainSelectedInstOperands,
     /* 325571 */     // GIR_Coverage, 12264,
     /* 325571 */     GIR_EraseRootFromParent_Done,
     /* 325572 */   // Label 5378: @325572
     /* 325572 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(325707), // Rule ID 12741 //
     /* 325577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325624 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325661 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325705 */     GIR_RootConstrainSelectedInstOperands,
     /* 325706 */     // GIR_Coverage, 12741,
     /* 325706 */     GIR_EraseRootFromParent_Done,
     /* 325707 */   // Label 5379: @325707
     /* 325707 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(325842), // Rule ID 12742 //
     /* 325712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325759 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325796 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325840 */     GIR_RootConstrainSelectedInstOperands,
     /* 325841 */     // GIR_Coverage, 12742,
     /* 325841 */     GIR_EraseRootFromParent_Done,
     /* 325842 */   // Label 5380: @325842
     /* 325842 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(325977), // Rule ID 12743 //
     /* 325847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325931 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325975 */     GIR_RootConstrainSelectedInstOperands,
     /* 325976 */     // GIR_Coverage, 12743,
     /* 325976 */     GIR_EraseRootFromParent_Done,
     /* 325977 */   // Label 5381: @325977
     /* 325977 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(326112), // Rule ID 12744 //
     /* 325982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326034 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326066 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326110 */     GIR_RootConstrainSelectedInstOperands,
     /* 326111 */     // GIR_Coverage, 12744,
     /* 326111 */     GIR_EraseRootFromParent_Done,
     /* 326112 */   // Label 5382: @326112
     /* 326112 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(326247), // Rule ID 13221 //
     /* 326117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326164 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326169 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326201 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326245 */     GIR_RootConstrainSelectedInstOperands,
     /* 326246 */     // GIR_Coverage, 13221,
     /* 326246 */     GIR_EraseRootFromParent_Done,
     /* 326247 */   // Label 5383: @326247
     /* 326247 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(326382), // Rule ID 13222 //
     /* 326252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326299 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326304 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326336 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326380 */     GIR_RootConstrainSelectedInstOperands,
     /* 326381 */     // GIR_Coverage, 13222,
     /* 326381 */     GIR_EraseRootFromParent_Done,
     /* 326382 */   // Label 5384: @326382
     /* 326382 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(326517), // Rule ID 13223 //
     /* 326387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326471 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326515 */     GIR_RootConstrainSelectedInstOperands,
     /* 326516 */     // GIR_Coverage, 13223,
     /* 326516 */     GIR_EraseRootFromParent_Done,
     /* 326517 */   // Label 5385: @326517
     /* 326517 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(326652), // Rule ID 13224 //
     /* 326522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326606 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326650 */     GIR_RootConstrainSelectedInstOperands,
     /* 326651 */     // GIR_Coverage, 13224,
     /* 326651 */     GIR_EraseRootFromParent_Done,
     /* 326652 */   // Label 5386: @326652
     /* 326652 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(326787), // Rule ID 12201 //
     /* 326657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326741 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326785 */     GIR_RootConstrainSelectedInstOperands,
     /* 326786 */     // GIR_Coverage, 12201,
     /* 326786 */     GIR_EraseRootFromParent_Done,
     /* 326787 */   // Label 5387: @326787
     /* 326787 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(326922), // Rule ID 12202 //
     /* 326792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326876 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326920 */     GIR_RootConstrainSelectedInstOperands,
     /* 326921 */     // GIR_Coverage, 12202,
     /* 326921 */     GIR_EraseRootFromParent_Done,
     /* 326922 */   // Label 5388: @326922
     /* 326922 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(327057), // Rule ID 12203 //
     /* 326927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326979 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327011 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 327014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327055 */     GIR_RootConstrainSelectedInstOperands,
     /* 327056 */     // GIR_Coverage, 12203,
     /* 327056 */     GIR_EraseRootFromParent_Done,
     /* 327057 */   // Label 5389: @327057
     /* 327057 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(327192), // Rule ID 12204 //
     /* 327062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327109 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327114 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327146 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 327149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327190 */     GIR_RootConstrainSelectedInstOperands,
     /* 327191 */     // GIR_Coverage, 12204,
     /* 327191 */     GIR_EraseRootFromParent_Done,
     /* 327192 */   // Label 5390: @327192
     /* 327192 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(327327), // Rule ID 12681 //
     /* 327197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327244 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327281 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327325 */     GIR_RootConstrainSelectedInstOperands,
     /* 327326 */     // GIR_Coverage, 12681,
     /* 327326 */     GIR_EraseRootFromParent_Done,
     /* 327327 */   // Label 5391: @327327
     /* 327327 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(327462), // Rule ID 12682 //
     /* 327332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327416 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327460 */     GIR_RootConstrainSelectedInstOperands,
     /* 327461 */     // GIR_Coverage, 12682,
     /* 327461 */     GIR_EraseRootFromParent_Done,
     /* 327462 */   // Label 5392: @327462
     /* 327462 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(327597), // Rule ID 12683 //
     /* 327467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327551 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327595 */     GIR_RootConstrainSelectedInstOperands,
     /* 327596 */     // GIR_Coverage, 12683,
     /* 327596 */     GIR_EraseRootFromParent_Done,
     /* 327597 */   // Label 5393: @327597
     /* 327597 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(327732), // Rule ID 12684 //
     /* 327602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327654 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327686 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327730 */     GIR_RootConstrainSelectedInstOperands,
     /* 327731 */     // GIR_Coverage, 12684,
     /* 327731 */     GIR_EraseRootFromParent_Done,
     /* 327732 */   // Label 5394: @327732
     /* 327732 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(327867), // Rule ID 13161 //
     /* 327737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327784 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327789 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327821 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327865 */     GIR_RootConstrainSelectedInstOperands,
     /* 327866 */     // GIR_Coverage, 13161,
     /* 327866 */     GIR_EraseRootFromParent_Done,
     /* 327867 */   // Label 5395: @327867
     /* 327867 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(328002), // Rule ID 13162 //
     /* 327872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327919 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327956 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328000 */     GIR_RootConstrainSelectedInstOperands,
     /* 328001 */     // GIR_Coverage, 13162,
     /* 328001 */     GIR_EraseRootFromParent_Done,
     /* 328002 */   // Label 5396: @328002
     /* 328002 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(328137), // Rule ID 13163 //
     /* 328007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 328010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 328038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328091 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 328094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328135 */     GIR_RootConstrainSelectedInstOperands,
     /* 328136 */     // GIR_Coverage, 13163,
     /* 328136 */     GIR_EraseRootFromParent_Done,
     /* 328137 */   // Label 5397: @328137
     /* 328137 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(328272), // Rule ID 13164 //
     /* 328142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 328145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 328173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328226 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 328229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328270 */     GIR_RootConstrainSelectedInstOperands,
     /* 328271 */     // GIR_Coverage, 13164,
     /* 328271 */     GIR_EraseRootFromParent_Done,
     /* 328272 */   // Label 5398: @328272
     /* 328272 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(328407), // Rule ID 12272 //
     /* 328277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328361 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328405 */     GIR_RootConstrainSelectedInstOperands,
     /* 328406 */     // GIR_Coverage, 12272,
     /* 328406 */     GIR_EraseRootFromParent_Done,
     /* 328407 */   // Label 5399: @328407
     /* 328407 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(328542), // Rule ID 12273 //
     /* 328412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328464 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328496 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328540 */     GIR_RootConstrainSelectedInstOperands,
     /* 328541 */     // GIR_Coverage, 12273,
     /* 328541 */     GIR_EraseRootFromParent_Done,
     /* 328542 */   // Label 5400: @328542
     /* 328542 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(328677), // Rule ID 12274 //
     /* 328547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328594 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328599 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328631 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 328651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 328656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328675 */     GIR_RootConstrainSelectedInstOperands,
     /* 328676 */     // GIR_Coverage, 12274,
     /* 328676 */     GIR_EraseRootFromParent_Done,
     /* 328677 */   // Label 5401: @328677
     /* 328677 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(328812), // Rule ID 12275 //
     /* 328682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328729 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328766 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 328786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 328791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328810 */     GIR_RootConstrainSelectedInstOperands,
     /* 328811 */     // GIR_Coverage, 12275,
     /* 328811 */     GIR_EraseRootFromParent_Done,
     /* 328812 */   // Label 5402: @328812
     /* 328812 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(328947), // Rule ID 12752 //
     /* 328817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328864 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328901 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328945 */     GIR_RootConstrainSelectedInstOperands,
     /* 328946 */     // GIR_Coverage, 12752,
     /* 328946 */     GIR_EraseRootFromParent_Done,
     /* 328947 */   // Label 5403: @328947
     /* 328947 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(329082), // Rule ID 12753 //
     /* 328952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329036 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329080 */     GIR_RootConstrainSelectedInstOperands,
     /* 329081 */     // GIR_Coverage, 12753,
     /* 329081 */     GIR_EraseRootFromParent_Done,
     /* 329082 */   // Label 5404: @329082
     /* 329082 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(329217), // Rule ID 12754 //
     /* 329087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 329090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 329094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329134 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329139 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329171 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329215 */     GIR_RootConstrainSelectedInstOperands,
     /* 329216 */     // GIR_Coverage, 12754,
     /* 329216 */     GIR_EraseRootFromParent_Done,
     /* 329217 */   // Label 5405: @329217
     /* 329217 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(329352), // Rule ID 12755 //
     /* 329222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 329225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 329229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329269 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329274 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329306 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329350 */     GIR_RootConstrainSelectedInstOperands,
     /* 329351 */     // GIR_Coverage, 12755,
     /* 329351 */     GIR_EraseRootFromParent_Done,
     /* 329352 */   // Label 5406: @329352
     /* 329352 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(329487), // Rule ID 13232 //
     /* 329357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329404 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329441 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329485 */     GIR_RootConstrainSelectedInstOperands,
     /* 329486 */     // GIR_Coverage, 13232,
     /* 329486 */     GIR_EraseRootFromParent_Done,
     /* 329487 */   // Label 5407: @329487
     /* 329487 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(329622), // Rule ID 13233 //
     /* 329492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329576 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329620 */     GIR_RootConstrainSelectedInstOperands,
     /* 329621 */     // GIR_Coverage, 13233,
     /* 329621 */     GIR_EraseRootFromParent_Done,
     /* 329622 */   // Label 5408: @329622
     /* 329622 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(329757), // Rule ID 13234 //
     /* 329627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329711 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329755 */     GIR_RootConstrainSelectedInstOperands,
     /* 329756 */     // GIR_Coverage, 13234,
     /* 329756 */     GIR_EraseRootFromParent_Done,
     /* 329757 */   // Label 5409: @329757
     /* 329757 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(329892), // Rule ID 13235 //
     /* 329762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329809 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329846 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329890 */     GIR_RootConstrainSelectedInstOperands,
     /* 329891 */     // GIR_Coverage, 13235,
     /* 329891 */     GIR_EraseRootFromParent_Done,
     /* 329892 */   // Label 5410: @329892
     /* 329892 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(330027), // Rule ID 12212 //
     /* 329897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 329944 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329949 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329981 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330025 */     GIR_RootConstrainSelectedInstOperands,
     /* 330026 */     // GIR_Coverage, 12212,
     /* 330026 */     GIR_EraseRootFromParent_Done,
     /* 330027 */   // Label 5411: @330027
     /* 330027 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(330162), // Rule ID 12213 //
     /* 330032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330079 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330084 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330116 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 330119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330160 */     GIR_RootConstrainSelectedInstOperands,
     /* 330161 */     // GIR_Coverage, 12213,
     /* 330161 */     GIR_EraseRootFromParent_Done,
     /* 330162 */   // Label 5412: @330162
     /* 330162 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(330297), // Rule ID 12214 //
     /* 330167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330214 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330251 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 330254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330295 */     GIR_RootConstrainSelectedInstOperands,
     /* 330296 */     // GIR_Coverage, 12214,
     /* 330296 */     GIR_EraseRootFromParent_Done,
     /* 330297 */   // Label 5413: @330297
     /* 330297 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(330432), // Rule ID 12215 //
     /* 330302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330386 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 330389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330430 */     GIR_RootConstrainSelectedInstOperands,
     /* 330431 */     // GIR_Coverage, 12215,
     /* 330431 */     GIR_EraseRootFromParent_Done,
     /* 330432 */   // Label 5414: @330432
     /* 330432 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(330567), // Rule ID 12692 //
     /* 330437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330521 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330565 */     GIR_RootConstrainSelectedInstOperands,
     /* 330566 */     // GIR_Coverage, 12692,
     /* 330566 */     GIR_EraseRootFromParent_Done,
     /* 330567 */   // Label 5415: @330567
     /* 330567 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(330702), // Rule ID 12693 //
     /* 330572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330619 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330624 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330656 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330700 */     GIR_RootConstrainSelectedInstOperands,
     /* 330701 */     // GIR_Coverage, 12693,
     /* 330701 */     GIR_EraseRootFromParent_Done,
     /* 330702 */   // Label 5416: @330702
     /* 330702 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(330837), // Rule ID 12694 //
     /* 330707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330754 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330759 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330791 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330835 */     GIR_RootConstrainSelectedInstOperands,
     /* 330836 */     // GIR_Coverage, 12694,
     /* 330836 */     GIR_EraseRootFromParent_Done,
     /* 330837 */   // Label 5417: @330837
     /* 330837 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(330972), // Rule ID 12695 //
     /* 330842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330889 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330926 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330970 */     GIR_RootConstrainSelectedInstOperands,
     /* 330971 */     // GIR_Coverage, 12695,
     /* 330971 */     GIR_EraseRootFromParent_Done,
     /* 330972 */   // Label 5418: @330972
     /* 330972 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(331107), // Rule ID 13172 //
     /* 330977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 331008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331061 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331105 */     GIR_RootConstrainSelectedInstOperands,
     /* 331106 */     // GIR_Coverage, 13172,
     /* 331106 */     GIR_EraseRootFromParent_Done,
     /* 331107 */   // Label 5419: @331107
     /* 331107 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(331242), // Rule ID 13173 //
     /* 331112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 331115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 331143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331164 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331196 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331240 */     GIR_RootConstrainSelectedInstOperands,
     /* 331241 */     // GIR_Coverage, 13173,
     /* 331241 */     GIR_EraseRootFromParent_Done,
     /* 331242 */   // Label 5420: @331242
     /* 331242 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(331377), // Rule ID 13174 //
     /* 331247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 331250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 331278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331299 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331331 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331375 */     GIR_RootConstrainSelectedInstOperands,
     /* 331376 */     // GIR_Coverage, 13174,
     /* 331376 */     GIR_EraseRootFromParent_Done,
     /* 331377 */   // Label 5421: @331377
     /* 331377 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(331512), // Rule ID 13175 //
     /* 331382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 331385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 331413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331429 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331466 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331510 */     GIR_RootConstrainSelectedInstOperands,
     /* 331511 */     // GIR_Coverage, 13175,
     /* 331511 */     GIR_EraseRootFromParent_Done,
     /* 331512 */   // Label 5422: @331512
     /* 331512 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(331647), // Rule ID 12257 //
     /* 331517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331564 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331601 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331645 */     GIR_RootConstrainSelectedInstOperands,
     /* 331646 */     // GIR_Coverage, 12257,
     /* 331646 */     GIR_EraseRootFromParent_Done,
     /* 331647 */   // Label 5423: @331647
     /* 331647 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(331782), // Rule ID 12258 //
     /* 331652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331736 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331780 */     GIR_RootConstrainSelectedInstOperands,
     /* 331781 */     // GIR_Coverage, 12258,
     /* 331781 */     GIR_EraseRootFromParent_Done,
     /* 331782 */   // Label 5424: @331782
     /* 331782 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(331917), // Rule ID 12259 //
     /* 331787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331871 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331915 */     GIR_RootConstrainSelectedInstOperands,
     /* 331916 */     // GIR_Coverage, 12259,
     /* 331916 */     GIR_EraseRootFromParent_Done,
     /* 331917 */   // Label 5425: @331917
     /* 331917 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(332052), // Rule ID 12260 //
     /* 331922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332006 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332050 */     GIR_RootConstrainSelectedInstOperands,
     /* 332051 */     // GIR_Coverage, 12260,
     /* 332051 */     GIR_EraseRootFromParent_Done,
     /* 332052 */   // Label 5426: @332052
     /* 332052 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(332187), // Rule ID 12737 //
     /* 332057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332104 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332109 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332141 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332185 */     GIR_RootConstrainSelectedInstOperands,
     /* 332186 */     // GIR_Coverage, 12737,
     /* 332186 */     GIR_EraseRootFromParent_Done,
     /* 332187 */   // Label 5427: @332187
     /* 332187 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(332322), // Rule ID 12738 //
     /* 332192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332239 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332244 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332276 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332320 */     GIR_RootConstrainSelectedInstOperands,
     /* 332321 */     // GIR_Coverage, 12738,
     /* 332321 */     GIR_EraseRootFromParent_Done,
     /* 332322 */   // Label 5428: @332322
     /* 332322 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(332457), // Rule ID 12739 //
     /* 332327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332374 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332411 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332455 */     GIR_RootConstrainSelectedInstOperands,
     /* 332456 */     // GIR_Coverage, 12739,
     /* 332456 */     GIR_EraseRootFromParent_Done,
     /* 332457 */   // Label 5429: @332457
     /* 332457 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(332592), // Rule ID 12740 //
     /* 332462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332546 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332590 */     GIR_RootConstrainSelectedInstOperands,
     /* 332591 */     // GIR_Coverage, 12740,
     /* 332591 */     GIR_EraseRootFromParent_Done,
     /* 332592 */   // Label 5430: @332592
     /* 332592 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(332727), // Rule ID 13217 //
     /* 332597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332681 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332725 */     GIR_RootConstrainSelectedInstOperands,
     /* 332726 */     // GIR_Coverage, 13217,
     /* 332726 */     GIR_EraseRootFromParent_Done,
     /* 332727 */   // Label 5431: @332727
     /* 332727 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(332862), // Rule ID 13218 //
     /* 332732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332784 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332816 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332860 */     GIR_RootConstrainSelectedInstOperands,
     /* 332861 */     // GIR_Coverage, 13218,
     /* 332861 */     GIR_EraseRootFromParent_Done,
     /* 332862 */   // Label 5432: @332862
     /* 332862 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(332997), // Rule ID 13219 //
     /* 332867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332914 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332919 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332951 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332995 */     GIR_RootConstrainSelectedInstOperands,
     /* 332996 */     // GIR_Coverage, 13219,
     /* 332996 */     GIR_EraseRootFromParent_Done,
     /* 332997 */   // Label 5433: @332997
     /* 332997 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(333132), // Rule ID 13220 //
     /* 333002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333049 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333086 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 333089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333130 */     GIR_RootConstrainSelectedInstOperands,
     /* 333131 */     // GIR_Coverage, 13220,
     /* 333131 */     GIR_EraseRootFromParent_Done,
     /* 333132 */   // Label 5434: @333132
     /* 333132 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(333267), // Rule ID 12197 //
     /* 333137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333221 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333265 */     GIR_RootConstrainSelectedInstOperands,
     /* 333266 */     // GIR_Coverage, 12197,
     /* 333266 */     GIR_EraseRootFromParent_Done,
     /* 333267 */   // Label 5435: @333267
     /* 333267 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(333402), // Rule ID 12198 //
     /* 333272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333356 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333400 */     GIR_RootConstrainSelectedInstOperands,
     /* 333401 */     // GIR_Coverage, 12198,
     /* 333401 */     GIR_EraseRootFromParent_Done,
     /* 333402 */   // Label 5436: @333402
     /* 333402 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(333537), // Rule ID 12199 //
     /* 333407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333491 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333535 */     GIR_RootConstrainSelectedInstOperands,
     /* 333536 */     // GIR_Coverage, 12199,
     /* 333536 */     GIR_EraseRootFromParent_Done,
     /* 333537 */   // Label 5437: @333537
     /* 333537 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(333672), // Rule ID 12200 //
     /* 333542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333589 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333594 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333626 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333670 */     GIR_RootConstrainSelectedInstOperands,
     /* 333671 */     // GIR_Coverage, 12200,
     /* 333671 */     GIR_EraseRootFromParent_Done,
     /* 333672 */   // Label 5438: @333672
     /* 333672 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(333807), // Rule ID 12677 //
     /* 333677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333724 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333729 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333761 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333805 */     GIR_RootConstrainSelectedInstOperands,
     /* 333806 */     // GIR_Coverage, 12677,
     /* 333806 */     GIR_EraseRootFromParent_Done,
     /* 333807 */   // Label 5439: @333807
     /* 333807 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(333942), // Rule ID 12678 //
     /* 333812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333859 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333864 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333896 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333940 */     GIR_RootConstrainSelectedInstOperands,
     /* 333941 */     // GIR_Coverage, 12678,
     /* 333941 */     GIR_EraseRootFromParent_Done,
     /* 333942 */   // Label 5440: @333942
     /* 333942 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(334077), // Rule ID 12679 //
     /* 333947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333994 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334031 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 334034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334075 */     GIR_RootConstrainSelectedInstOperands,
     /* 334076 */     // GIR_Coverage, 12679,
     /* 334076 */     GIR_EraseRootFromParent_Done,
     /* 334077 */   // Label 5441: @334077
     /* 334077 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(334212), // Rule ID 12680 //
     /* 334082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 334085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 334089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334134 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334166 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 334169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334210 */     GIR_RootConstrainSelectedInstOperands,
     /* 334211 */     // GIR_Coverage, 12680,
     /* 334211 */     GIR_EraseRootFromParent_Done,
     /* 334212 */   // Label 5442: @334212
     /* 334212 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(334347), // Rule ID 13157 //
     /* 334217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334264 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334269 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334301 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334345 */     GIR_RootConstrainSelectedInstOperands,
     /* 334346 */     // GIR_Coverage, 13157,
     /* 334346 */     GIR_EraseRootFromParent_Done,
     /* 334347 */   // Label 5443: @334347
     /* 334347 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(334482), // Rule ID 13158 //
     /* 334352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334399 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334404 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334436 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334480 */     GIR_RootConstrainSelectedInstOperands,
     /* 334481 */     // GIR_Coverage, 13158,
     /* 334481 */     GIR_EraseRootFromParent_Done,
     /* 334482 */   // Label 5444: @334482
     /* 334482 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(334617), // Rule ID 13159 //
     /* 334487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334534 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334571 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334615 */     GIR_RootConstrainSelectedInstOperands,
     /* 334616 */     // GIR_Coverage, 13159,
     /* 334616 */     GIR_EraseRootFromParent_Done,
     /* 334617 */   // Label 5445: @334617
     /* 334617 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(334752), // Rule ID 13160 //
     /* 334622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334706 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334750 */     GIR_RootConstrainSelectedInstOperands,
     /* 334751 */     // GIR_Coverage, 13160,
     /* 334751 */     GIR_EraseRootFromParent_Done,
     /* 334752 */   // Label 5446: @334752
     /* 334752 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(334887), // Rule ID 12206 //
     /* 334757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334804 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334809 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334841 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334885 */     GIR_RootConstrainSelectedInstOperands,
     /* 334886 */     // GIR_Coverage, 12206,
     /* 334886 */     GIR_EraseRootFromParent_Done,
     /* 334887 */   // Label 5447: @334887
     /* 334887 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(335022), // Rule ID 12207 //
     /* 334892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334939 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334944 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334976 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335020 */     GIR_RootConstrainSelectedInstOperands,
     /* 335021 */     // GIR_Coverage, 12207,
     /* 335021 */     GIR_EraseRootFromParent_Done,
     /* 335022 */   // Label 5448: @335022
     /* 335022 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(335157), // Rule ID 12210 //
     /* 335027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 335030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335074 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335079 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335111 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 335114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335155 */     GIR_RootConstrainSelectedInstOperands,
     /* 335156 */     // GIR_Coverage, 12210,
     /* 335156 */     GIR_EraseRootFromParent_Done,
     /* 335157 */   // Label 5449: @335157
     /* 335157 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(335292), // Rule ID 12211 //
     /* 335162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 335165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335209 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335214 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335246 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 335249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335290 */     GIR_RootConstrainSelectedInstOperands,
     /* 335291 */     // GIR_Coverage, 12211,
     /* 335291 */     GIR_EraseRootFromParent_Done,
     /* 335292 */   // Label 5450: @335292
     /* 335292 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(335427), // Rule ID 12686 //
     /* 335297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335381 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335425 */     GIR_RootConstrainSelectedInstOperands,
     /* 335426 */     // GIR_Coverage, 12686,
     /* 335426 */     GIR_EraseRootFromParent_Done,
     /* 335427 */   // Label 5451: @335427
     /* 335427 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(335562), // Rule ID 12687 //
     /* 335432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335479 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335516 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335560 */     GIR_RootConstrainSelectedInstOperands,
     /* 335561 */     // GIR_Coverage, 12687,
     /* 335561 */     GIR_EraseRootFromParent_Done,
     /* 335562 */   // Label 5452: @335562
     /* 335562 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(335697), // Rule ID 12690 //
     /* 335567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335614 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335619 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335651 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335695 */     GIR_RootConstrainSelectedInstOperands,
     /* 335696 */     // GIR_Coverage, 12690,
     /* 335696 */     GIR_EraseRootFromParent_Done,
     /* 335697 */   // Label 5453: @335697
     /* 335697 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(335832), // Rule ID 12691 //
     /* 335702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335749 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335754 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335786 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335830 */     GIR_RootConstrainSelectedInstOperands,
     /* 335831 */     // GIR_Coverage, 12691,
     /* 335831 */     GIR_EraseRootFromParent_Done,
     /* 335832 */   // Label 5454: @335832
     /* 335832 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(335967), // Rule ID 13166 //
     /* 335837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335884 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335889 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335921 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335965 */     GIR_RootConstrainSelectedInstOperands,
     /* 335966 */     // GIR_Coverage, 13166,
     /* 335966 */     GIR_EraseRootFromParent_Done,
     /* 335967 */   // Label 5455: @335967
     /* 335967 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(336102), // Rule ID 13167 //
     /* 335972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 336019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336056 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336100 */     GIR_RootConstrainSelectedInstOperands,
     /* 336101 */     // GIR_Coverage, 13167,
     /* 336101 */     GIR_EraseRootFromParent_Done,
     /* 336102 */   // Label 5456: @336102
     /* 336102 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(336237), // Rule ID 13170 //
     /* 336107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 336110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 336154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336191 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336235 */     GIR_RootConstrainSelectedInstOperands,
     /* 336236 */     // GIR_Coverage, 13170,
     /* 336236 */     GIR_EraseRootFromParent_Done,
     /* 336237 */   // Label 5457: @336237
     /* 336237 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(336372), // Rule ID 13171 //
     /* 336242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 336245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 336289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336326 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336370 */     GIR_RootConstrainSelectedInstOperands,
     /* 336371 */     // GIR_Coverage, 13171,
     /* 336371 */     GIR_EraseRootFromParent_Done,
     /* 336372 */   // Label 5458: @336372
     /* 336372 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(336507), // Rule ID 12191 //
     /* 336377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336429 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336461 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336505 */     GIR_RootConstrainSelectedInstOperands,
     /* 336506 */     // GIR_Coverage, 12191,
     /* 336506 */     GIR_EraseRootFromParent_Done,
     /* 336507 */   // Label 5459: @336507
     /* 336507 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(336642), // Rule ID 12192 //
     /* 336512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336559 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336564 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336596 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336640 */     GIR_RootConstrainSelectedInstOperands,
     /* 336641 */     // GIR_Coverage, 12192,
     /* 336641 */     GIR_EraseRootFromParent_Done,
     /* 336642 */   // Label 5460: @336642
     /* 336642 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(336777), // Rule ID 12195 //
     /* 336647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336694 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336731 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336775 */     GIR_RootConstrainSelectedInstOperands,
     /* 336776 */     // GIR_Coverage, 12195,
     /* 336776 */     GIR_EraseRootFromParent_Done,
     /* 336777 */   // Label 5461: @336777
     /* 336777 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(336912), // Rule ID 12196 //
     /* 336782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336866 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336910 */     GIR_RootConstrainSelectedInstOperands,
     /* 336911 */     // GIR_Coverage, 12196,
     /* 336911 */     GIR_EraseRootFromParent_Done,
     /* 336912 */   // Label 5462: @336912
     /* 336912 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(337047), // Rule ID 12671 //
     /* 336917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337001 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337045 */     GIR_RootConstrainSelectedInstOperands,
     /* 337046 */     // GIR_Coverage, 12671,
     /* 337046 */     GIR_EraseRootFromParent_Done,
     /* 337047 */   // Label 5463: @337047
     /* 337047 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(337182), // Rule ID 12672 //
     /* 337052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337099 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337104 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337136 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337180 */     GIR_RootConstrainSelectedInstOperands,
     /* 337181 */     // GIR_Coverage, 12672,
     /* 337181 */     GIR_EraseRootFromParent_Done,
     /* 337182 */   // Label 5464: @337182
     /* 337182 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(337317), // Rule ID 12675 //
     /* 337187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337234 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337239 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337271 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337315 */     GIR_RootConstrainSelectedInstOperands,
     /* 337316 */     // GIR_Coverage, 12675,
     /* 337316 */     GIR_EraseRootFromParent_Done,
     /* 337317 */   // Label 5465: @337317
     /* 337317 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(337452), // Rule ID 12676 //
     /* 337322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337369 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337374 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337406 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337450 */     GIR_RootConstrainSelectedInstOperands,
     /* 337451 */     // GIR_Coverage, 12676,
     /* 337451 */     GIR_EraseRootFromParent_Done,
     /* 337452 */   // Label 5466: @337452
     /* 337452 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(337587), // Rule ID 13151 //
     /* 337457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337541 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337585 */     GIR_RootConstrainSelectedInstOperands,
     /* 337586 */     // GIR_Coverage, 13151,
     /* 337586 */     GIR_EraseRootFromParent_Done,
     /* 337587 */   // Label 5467: @337587
     /* 337587 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(337722), // Rule ID 13152 //
     /* 337592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337676 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337720 */     GIR_RootConstrainSelectedInstOperands,
     /* 337721 */     // GIR_Coverage, 13152,
     /* 337721 */     GIR_EraseRootFromParent_Done,
     /* 337722 */   // Label 5468: @337722
     /* 337722 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(337857), // Rule ID 13155 //
     /* 337727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337811 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337855 */     GIR_RootConstrainSelectedInstOperands,
     /* 337856 */     // GIR_Coverage, 13155,
     /* 337856 */     GIR_EraseRootFromParent_Done,
     /* 337857 */   // Label 5469: @337857
     /* 337857 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(337992), // Rule ID 13156 //
     /* 337862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337914 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337946 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337990 */     GIR_RootConstrainSelectedInstOperands,
     /* 337991 */     // GIR_Coverage, 13156,
     /* 337991 */     GIR_EraseRootFromParent_Done,
     /* 337992 */   // Label 5470: @337992
     /* 337992 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(338127), // Rule ID 7645 //
     /* 337997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338044 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338049 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338081 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338125 */     GIR_RootConstrainSelectedInstOperands,
     /* 338126 */     // GIR_Coverage, 7645,
     /* 338126 */     GIR_EraseRootFromParent_Done,
     /* 338127 */   // Label 5471: @338127
     /* 338127 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(338262), // Rule ID 7677 //
     /* 338132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338216 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338260 */     GIR_RootConstrainSelectedInstOperands,
     /* 338261 */     // GIR_Coverage, 7677,
     /* 338261 */     GIR_EraseRootFromParent_Done,
     /* 338262 */   // Label 5472: @338262
     /* 338262 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(338397), // Rule ID 7709 //
     /* 338267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338351 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338395 */     GIR_RootConstrainSelectedInstOperands,
     /* 338396 */     // GIR_Coverage, 7709,
     /* 338396 */     GIR_EraseRootFromParent_Done,
     /* 338397 */   // Label 5473: @338397
     /* 338397 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(338532), // Rule ID 12205 //
     /* 338402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338486 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338530 */     GIR_RootConstrainSelectedInstOperands,
     /* 338531 */     // GIR_Coverage, 12205,
     /* 338531 */     GIR_EraseRootFromParent_Done,
     /* 338532 */   // Label 5474: @338532
     /* 338532 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(338667), // Rule ID 12208 //
     /* 338537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338584 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338589 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338621 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338665 */     GIR_RootConstrainSelectedInstOperands,
     /* 338666 */     // GIR_Coverage, 12208,
     /* 338666 */     GIR_EraseRootFromParent_Done,
     /* 338667 */   // Label 5475: @338667
     /* 338667 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(338802), // Rule ID 12209 //
     /* 338672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338719 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338724 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338756 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338800 */     GIR_RootConstrainSelectedInstOperands,
     /* 338801 */     // GIR_Coverage, 12209,
     /* 338801 */     GIR_EraseRootFromParent_Done,
     /* 338802 */   // Label 5476: @338802
     /* 338802 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(338937), // Rule ID 12685 //
     /* 338807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338891 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338935 */     GIR_RootConstrainSelectedInstOperands,
     /* 338936 */     // GIR_Coverage, 12685,
     /* 338936 */     GIR_EraseRootFromParent_Done,
     /* 338937 */   // Label 5477: @338937
     /* 338937 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(339072), // Rule ID 12688 //
     /* 338942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339026 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339070 */     GIR_RootConstrainSelectedInstOperands,
     /* 339071 */     // GIR_Coverage, 12688,
     /* 339071 */     GIR_EraseRootFromParent_Done,
     /* 339072 */   // Label 5478: @339072
     /* 339072 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(339207), // Rule ID 12689 //
     /* 339077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339161 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339205 */     GIR_RootConstrainSelectedInstOperands,
     /* 339206 */     // GIR_Coverage, 12689,
     /* 339206 */     GIR_EraseRootFromParent_Done,
     /* 339207 */   // Label 5479: @339207
     /* 339207 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(339342), // Rule ID 13165 //
     /* 339212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339264 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339296 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339340 */     GIR_RootConstrainSelectedInstOperands,
     /* 339341 */     // GIR_Coverage, 13165,
     /* 339341 */     GIR_EraseRootFromParent_Done,
     /* 339342 */   // Label 5480: @339342
     /* 339342 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(339477), // Rule ID 13168 //
     /* 339347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339399 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339431 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339475 */     GIR_RootConstrainSelectedInstOperands,
     /* 339476 */     // GIR_Coverage, 13168,
     /* 339476 */     GIR_EraseRootFromParent_Done,
     /* 339477 */   // Label 5481: @339477
     /* 339477 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(339612), // Rule ID 13169 //
     /* 339482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339529 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339534 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339566 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339610 */     GIR_RootConstrainSelectedInstOperands,
     /* 339611 */     // GIR_Coverage, 13169,
     /* 339611 */     GIR_EraseRootFromParent_Done,
     /* 339612 */   // Label 5482: @339612
     /* 339612 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(339747), // Rule ID 7644 //
     /* 339617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339664 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339701 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339745 */     GIR_RootConstrainSelectedInstOperands,
     /* 339746 */     // GIR_Coverage, 7644,
     /* 339746 */     GIR_EraseRootFromParent_Done,
     /* 339747 */   // Label 5483: @339747
     /* 339747 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(339882), // Rule ID 7676 //
     /* 339752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339836 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339880 */     GIR_RootConstrainSelectedInstOperands,
     /* 339881 */     // GIR_Coverage, 7676,
     /* 339881 */     GIR_EraseRootFromParent_Done,
     /* 339882 */   // Label 5484: @339882
     /* 339882 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(340017), // Rule ID 7708 //
     /* 339887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339939 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339971 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340015 */     GIR_RootConstrainSelectedInstOperands,
     /* 340016 */     // GIR_Coverage, 7708,
     /* 340016 */     GIR_EraseRootFromParent_Done,
     /* 340017 */   // Label 5485: @340017
     /* 340017 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(340152), // Rule ID 12190 //
     /* 340022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340074 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340106 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340150 */     GIR_RootConstrainSelectedInstOperands,
     /* 340151 */     // GIR_Coverage, 12190,
     /* 340151 */     GIR_EraseRootFromParent_Done,
     /* 340152 */   // Label 5486: @340152
     /* 340152 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(340287), // Rule ID 12193 //
     /* 340157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340204 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340209 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340241 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340285 */     GIR_RootConstrainSelectedInstOperands,
     /* 340286 */     // GIR_Coverage, 12193,
     /* 340286 */     GIR_EraseRootFromParent_Done,
     /* 340287 */   // Label 5487: @340287
     /* 340287 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(340422), // Rule ID 12194 //
     /* 340292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340339 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340376 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340420 */     GIR_RootConstrainSelectedInstOperands,
     /* 340421 */     // GIR_Coverage, 12194,
     /* 340421 */     GIR_EraseRootFromParent_Done,
     /* 340422 */   // Label 5488: @340422
     /* 340422 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(340557), // Rule ID 12670 //
     /* 340427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340511 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340555 */     GIR_RootConstrainSelectedInstOperands,
     /* 340556 */     // GIR_Coverage, 12670,
     /* 340556 */     GIR_EraseRootFromParent_Done,
     /* 340557 */   // Label 5489: @340557
     /* 340557 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(340692), // Rule ID 12673 //
     /* 340562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340646 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340690 */     GIR_RootConstrainSelectedInstOperands,
     /* 340691 */     // GIR_Coverage, 12673,
     /* 340691 */     GIR_EraseRootFromParent_Done,
     /* 340692 */   // Label 5490: @340692
     /* 340692 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(340827), // Rule ID 12674 //
     /* 340697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340781 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340825 */     GIR_RootConstrainSelectedInstOperands,
     /* 340826 */     // GIR_Coverage, 12674,
     /* 340826 */     GIR_EraseRootFromParent_Done,
     /* 340827 */   // Label 5491: @340827
     /* 340827 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(340962), // Rule ID 13150 //
     /* 340832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340879 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340884 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340916 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340960 */     GIR_RootConstrainSelectedInstOperands,
     /* 340961 */     // GIR_Coverage, 13150,
     /* 340961 */     GIR_EraseRootFromParent_Done,
     /* 340962 */   // Label 5492: @340962
     /* 340962 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(341097), // Rule ID 13153 //
     /* 340967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 341010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341051 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 341054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341095 */     GIR_RootConstrainSelectedInstOperands,
     /* 341096 */     // GIR_Coverage, 13153,
     /* 341096 */     GIR_EraseRootFromParent_Done,
     /* 341097 */   // Label 5493: @341097
     /* 341097 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(341232), // Rule ID 13154 //
     /* 341102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 341105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 341145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341186 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 341189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341230 */     GIR_RootConstrainSelectedInstOperands,
     /* 341231 */     // GIR_Coverage, 13154,
     /* 341231 */     GIR_EraseRootFromParent_Done,
     /* 341232 */   // Label 5494: @341232
     /* 341232 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(341367), // Rule ID 12176 //
     /* 341237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341284 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341321 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341365 */     GIR_RootConstrainSelectedInstOperands,
     /* 341366 */     // GIR_Coverage, 12176,
     /* 341366 */     GIR_EraseRootFromParent_Done,
     /* 341367 */   // Label 5495: @341367
     /* 341367 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(341502), // Rule ID 12177 //
     /* 341372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341456 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341500 */     GIR_RootConstrainSelectedInstOperands,
     /* 341501 */     // GIR_Coverage, 12177,
     /* 341501 */     GIR_EraseRootFromParent_Done,
     /* 341502 */   // Label 5496: @341502
     /* 341502 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(341637), // Rule ID 12180 //
     /* 341507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341554 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341559 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341591 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341635 */     GIR_RootConstrainSelectedInstOperands,
     /* 341636 */     // GIR_Coverage, 12180,
     /* 341636 */     GIR_EraseRootFromParent_Done,
     /* 341637 */   // Label 5497: @341637
     /* 341637 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(341772), // Rule ID 12181 //
     /* 341642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341689 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341694 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341726 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341770 */     GIR_RootConstrainSelectedInstOperands,
     /* 341771 */     // GIR_Coverage, 12181,
     /* 341771 */     GIR_EraseRootFromParent_Done,
     /* 341772 */   // Label 5498: @341772
     /* 341772 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(341907), // Rule ID 12656 //
     /* 341777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341861 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341905 */     GIR_RootConstrainSelectedInstOperands,
     /* 341906 */     // GIR_Coverage, 12656,
     /* 341906 */     GIR_EraseRootFromParent_Done,
     /* 341907 */   // Label 5499: @341907
     /* 341907 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(342042), // Rule ID 12657 //
     /* 341912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341996 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342040 */     GIR_RootConstrainSelectedInstOperands,
     /* 342041 */     // GIR_Coverage, 12657,
     /* 342041 */     GIR_EraseRootFromParent_Done,
     /* 342042 */   // Label 5500: @342042
     /* 342042 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(342177), // Rule ID 12660 //
     /* 342047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 342050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 342054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342099 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342131 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 342134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342175 */     GIR_RootConstrainSelectedInstOperands,
     /* 342176 */     // GIR_Coverage, 12660,
     /* 342176 */     GIR_EraseRootFromParent_Done,
     /* 342177 */   // Label 5501: @342177
     /* 342177 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(342312), // Rule ID 12661 //
     /* 342182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 342185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 342189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342229 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342234 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342266 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 342269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342310 */     GIR_RootConstrainSelectedInstOperands,
     /* 342311 */     // GIR_Coverage, 12661,
     /* 342311 */     GIR_EraseRootFromParent_Done,
     /* 342312 */   // Label 5502: @342312
     /* 342312 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(342447), // Rule ID 13136 //
     /* 342317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342364 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342369 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342401 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342445 */     GIR_RootConstrainSelectedInstOperands,
     /* 342446 */     // GIR_Coverage, 13136,
     /* 342446 */     GIR_EraseRootFromParent_Done,
     /* 342447 */   // Label 5503: @342447
     /* 342447 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(342582), // Rule ID 13137 //
     /* 342452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342536 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342580 */     GIR_RootConstrainSelectedInstOperands,
     /* 342581 */     // GIR_Coverage, 13137,
     /* 342581 */     GIR_EraseRootFromParent_Done,
     /* 342582 */   // Label 5504: @342582
     /* 342582 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(342717), // Rule ID 13140 //
     /* 342587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342671 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342715 */     GIR_RootConstrainSelectedInstOperands,
     /* 342716 */     // GIR_Coverage, 13140,
     /* 342716 */     GIR_EraseRootFromParent_Done,
     /* 342717 */   // Label 5505: @342717
     /* 342717 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(342852), // Rule ID 13141 //
     /* 342722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342806 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342850 */     GIR_RootConstrainSelectedInstOperands,
     /* 342851 */     // GIR_Coverage, 13141,
     /* 342851 */     GIR_EraseRootFromParent_Done,
     /* 342852 */   // Label 5506: @342852
     /* 342852 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(342987), // Rule ID 12161 //
     /* 342857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 342904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342941 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342985 */     GIR_RootConstrainSelectedInstOperands,
     /* 342986 */     // GIR_Coverage, 12161,
     /* 342986 */     GIR_EraseRootFromParent_Done,
     /* 342987 */   // Label 5507: @342987
     /* 342987 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(343122), // Rule ID 12162 //
     /* 342992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343039 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343044 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343076 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 343079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343120 */     GIR_RootConstrainSelectedInstOperands,
     /* 343121 */     // GIR_Coverage, 12162,
     /* 343121 */     GIR_EraseRootFromParent_Done,
     /* 343122 */   // Label 5508: @343122
     /* 343122 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(343257), // Rule ID 12165 //
     /* 343127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 343130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343174 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343179 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343211 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 343214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343255 */     GIR_RootConstrainSelectedInstOperands,
     /* 343256 */     // GIR_Coverage, 12165,
     /* 343256 */     GIR_EraseRootFromParent_Done,
     /* 343257 */   // Label 5509: @343257
     /* 343257 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(343392), // Rule ID 12166 //
     /* 343262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 343265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343309 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343346 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 343349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343390 */     GIR_RootConstrainSelectedInstOperands,
     /* 343391 */     // GIR_Coverage, 12166,
     /* 343391 */     GIR_EraseRootFromParent_Done,
     /* 343392 */   // Label 5510: @343392
     /* 343392 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(343527), // Rule ID 12641 //
     /* 343397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343481 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343525 */     GIR_RootConstrainSelectedInstOperands,
     /* 343526 */     // GIR_Coverage, 12641,
     /* 343526 */     GIR_EraseRootFromParent_Done,
     /* 343527 */   // Label 5511: @343527
     /* 343527 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(343662), // Rule ID 12642 //
     /* 343532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343584 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343616 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343660 */     GIR_RootConstrainSelectedInstOperands,
     /* 343661 */     // GIR_Coverage, 12642,
     /* 343661 */     GIR_EraseRootFromParent_Done,
     /* 343662 */   // Label 5512: @343662
     /* 343662 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(343797), // Rule ID 12645 //
     /* 343667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343719 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343751 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343795 */     GIR_RootConstrainSelectedInstOperands,
     /* 343796 */     // GIR_Coverage, 12645,
     /* 343796 */     GIR_EraseRootFromParent_Done,
     /* 343797 */   // Label 5513: @343797
     /* 343797 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(343932), // Rule ID 12646 //
     /* 343802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343849 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343854 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343886 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343930 */     GIR_RootConstrainSelectedInstOperands,
     /* 343931 */     // GIR_Coverage, 12646,
     /* 343931 */     GIR_EraseRootFromParent_Done,
     /* 343932 */   // Label 5514: @343932
     /* 343932 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(344067), // Rule ID 13121 //
     /* 343937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343984 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343989 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344021 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344065 */     GIR_RootConstrainSelectedInstOperands,
     /* 344066 */     // GIR_Coverage, 13121,
     /* 344066 */     GIR_EraseRootFromParent_Done,
     /* 344067 */   // Label 5515: @344067
     /* 344067 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(344202), // Rule ID 13122 //
     /* 344072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 344115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344156 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344200 */     GIR_RootConstrainSelectedInstOperands,
     /* 344201 */     // GIR_Coverage, 13122,
     /* 344201 */     GIR_EraseRootFromParent_Done,
     /* 344202 */   // Label 5516: @344202
     /* 344202 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(344337), // Rule ID 13125 //
     /* 344207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 344250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344291 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344335 */     GIR_RootConstrainSelectedInstOperands,
     /* 344336 */     // GIR_Coverage, 13125,
     /* 344336 */     GIR_EraseRootFromParent_Done,
     /* 344337 */   // Label 5517: @344337
     /* 344337 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(344472), // Rule ID 13126 //
     /* 344342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 344385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344426 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344470 */     GIR_RootConstrainSelectedInstOperands,
     /* 344471 */     // GIR_Coverage, 13126,
     /* 344471 */     GIR_EraseRootFromParent_Done,
     /* 344472 */   // Label 5518: @344472
     /* 344472 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(344607), // Rule ID 7643 //
     /* 344477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344529 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344561 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344605 */     GIR_RootConstrainSelectedInstOperands,
     /* 344606 */     // GIR_Coverage, 7643,
     /* 344606 */     GIR_EraseRootFromParent_Done,
     /* 344607 */   // Label 5519: @344607
     /* 344607 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(344742), // Rule ID 7675 //
     /* 344612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 344619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344696 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 344699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344740 */     GIR_RootConstrainSelectedInstOperands,
     /* 344741 */     // GIR_Coverage, 7675,
     /* 344741 */     GIR_EraseRootFromParent_Done,
     /* 344742 */   // Label 5520: @344742
     /* 344742 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(344877), // Rule ID 7707 //
     /* 344747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344794 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344831 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344875 */     GIR_RootConstrainSelectedInstOperands,
     /* 344876 */     // GIR_Coverage, 7707,
     /* 344876 */     GIR_EraseRootFromParent_Done,
     /* 344877 */   // Label 5521: @344877
     /* 344877 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(345012), // Rule ID 12175 //
     /* 344882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344966 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345010 */     GIR_RootConstrainSelectedInstOperands,
     /* 345011 */     // GIR_Coverage, 12175,
     /* 345011 */     GIR_EraseRootFromParent_Done,
     /* 345012 */   // Label 5522: @345012
     /* 345012 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(345147), // Rule ID 12178 //
     /* 345017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345101 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345145 */     GIR_RootConstrainSelectedInstOperands,
     /* 345146 */     // GIR_Coverage, 12178,
     /* 345146 */     GIR_EraseRootFromParent_Done,
     /* 345147 */   // Label 5523: @345147
     /* 345147 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(345282), // Rule ID 12179 //
     /* 345152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345204 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345236 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345280 */     GIR_RootConstrainSelectedInstOperands,
     /* 345281 */     // GIR_Coverage, 12179,
     /* 345281 */     GIR_EraseRootFromParent_Done,
     /* 345282 */   // Label 5524: @345282
     /* 345282 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(345417), // Rule ID 12655 //
     /* 345287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345371 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345415 */     GIR_RootConstrainSelectedInstOperands,
     /* 345416 */     // GIR_Coverage, 12655,
     /* 345416 */     GIR_EraseRootFromParent_Done,
     /* 345417 */   // Label 5525: @345417
     /* 345417 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(345552), // Rule ID 12658 //
     /* 345422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345506 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345550 */     GIR_RootConstrainSelectedInstOperands,
     /* 345551 */     // GIR_Coverage, 12658,
     /* 345551 */     GIR_EraseRootFromParent_Done,
     /* 345552 */   // Label 5526: @345552
     /* 345552 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(345687), // Rule ID 12659 //
     /* 345557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345641 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345685 */     GIR_RootConstrainSelectedInstOperands,
     /* 345686 */     // GIR_Coverage, 12659,
     /* 345686 */     GIR_EraseRootFromParent_Done,
     /* 345687 */   // Label 5527: @345687
     /* 345687 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(345822), // Rule ID 13135 //
     /* 345692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345744 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345776 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345820 */     GIR_RootConstrainSelectedInstOperands,
     /* 345821 */     // GIR_Coverage, 13135,
     /* 345821 */     GIR_EraseRootFromParent_Done,
     /* 345822 */   // Label 5528: @345822
     /* 345822 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(345957), // Rule ID 13138 //
     /* 345827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345879 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345911 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345955 */     GIR_RootConstrainSelectedInstOperands,
     /* 345956 */     // GIR_Coverage, 13138,
     /* 345956 */     GIR_EraseRootFromParent_Done,
     /* 345957 */   // Label 5529: @345957
     /* 345957 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(346092), // Rule ID 13139 //
     /* 345962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346046 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346090 */     GIR_RootConstrainSelectedInstOperands,
     /* 346091 */     // GIR_Coverage, 13139,
     /* 346091 */     GIR_EraseRootFromParent_Done,
     /* 346092 */   // Label 5530: @346092
     /* 346092 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(346227), // Rule ID 7642 //
     /* 346097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346181 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346225 */     GIR_RootConstrainSelectedInstOperands,
     /* 346226 */     // GIR_Coverage, 7642,
     /* 346226 */     GIR_EraseRootFromParent_Done,
     /* 346227 */   // Label 5531: @346227
     /* 346227 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(346362), // Rule ID 7674 //
     /* 346232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346316 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346360 */     GIR_RootConstrainSelectedInstOperands,
     /* 346361 */     // GIR_Coverage, 7674,
     /* 346361 */     GIR_EraseRootFromParent_Done,
     /* 346362 */   // Label 5532: @346362
     /* 346362 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(346497), // Rule ID 7706 //
     /* 346367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346451 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346495 */     GIR_RootConstrainSelectedInstOperands,
     /* 346496 */     // GIR_Coverage, 7706,
     /* 346496 */     GIR_EraseRootFromParent_Done,
     /* 346497 */   // Label 5533: @346497
     /* 346497 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(346632), // Rule ID 12160 //
     /* 346502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346554 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346586 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346630 */     GIR_RootConstrainSelectedInstOperands,
     /* 346631 */     // GIR_Coverage, 12160,
     /* 346631 */     GIR_EraseRootFromParent_Done,
     /* 346632 */   // Label 5534: @346632
     /* 346632 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(346767), // Rule ID 12163 //
     /* 346637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346689 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346721 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346765 */     GIR_RootConstrainSelectedInstOperands,
     /* 346766 */     // GIR_Coverage, 12163,
     /* 346766 */     GIR_EraseRootFromParent_Done,
     /* 346767 */   // Label 5535: @346767
     /* 346767 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(346902), // Rule ID 12164 //
     /* 346772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346856 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346900 */     GIR_RootConstrainSelectedInstOperands,
     /* 346901 */     // GIR_Coverage, 12164,
     /* 346901 */     GIR_EraseRootFromParent_Done,
     /* 346902 */   // Label 5536: @346902
     /* 346902 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(347037), // Rule ID 12640 //
     /* 346907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346991 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347035 */     GIR_RootConstrainSelectedInstOperands,
     /* 347036 */     // GIR_Coverage, 12640,
     /* 347036 */     GIR_EraseRootFromParent_Done,
     /* 347037 */   // Label 5537: @347037
     /* 347037 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(347172), // Rule ID 12643 //
     /* 347042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347126 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 347129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347170 */     GIR_RootConstrainSelectedInstOperands,
     /* 347171 */     // GIR_Coverage, 12643,
     /* 347171 */     GIR_EraseRootFromParent_Done,
     /* 347172 */   // Label 5538: @347172
     /* 347172 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(347307), // Rule ID 12644 //
     /* 347177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347261 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 347264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347305 */     GIR_RootConstrainSelectedInstOperands,
     /* 347306 */     // GIR_Coverage, 12644,
     /* 347306 */     GIR_EraseRootFromParent_Done,
     /* 347307 */   // Label 5539: @347307
     /* 347307 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(347442), // Rule ID 13120 //
     /* 347312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347364 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347396 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347440 */     GIR_RootConstrainSelectedInstOperands,
     /* 347441 */     // GIR_Coverage, 13120,
     /* 347441 */     GIR_EraseRootFromParent_Done,
     /* 347442 */   // Label 5540: @347442
     /* 347442 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(347577), // Rule ID 13123 //
     /* 347447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347494 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347531 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347575 */     GIR_RootConstrainSelectedInstOperands,
     /* 347576 */     // GIR_Coverage, 13123,
     /* 347576 */     GIR_EraseRootFromParent_Done,
     /* 347577 */   // Label 5541: @347577
     /* 347577 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(347712), // Rule ID 13124 //
     /* 347582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347666 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347710 */     GIR_RootConstrainSelectedInstOperands,
     /* 347711 */     // GIR_Coverage, 13124,
     /* 347711 */     GIR_EraseRootFromParent_Done,
     /* 347712 */   // Label 5542: @347712
     /* 347712 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(347847), // Rule ID 12246 //
     /* 347717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347801 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 347821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 347826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347845 */     GIR_RootConstrainSelectedInstOperands,
     /* 347846 */     // GIR_Coverage, 12246,
     /* 347846 */     GIR_EraseRootFromParent_Done,
     /* 347847 */   // Label 5543: @347847
     /* 347847 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(347982), // Rule ID 12247 //
     /* 347852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347936 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 347956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 347961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347980 */     GIR_RootConstrainSelectedInstOperands,
     /* 347981 */     // GIR_Coverage, 12247,
     /* 347981 */     GIR_EraseRootFromParent_Done,
     /* 347982 */   // Label 5544: @347982
     /* 347982 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(348117), // Rule ID 12248 //
     /* 347987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348034 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348039 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348071 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 348074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348115 */     GIR_RootConstrainSelectedInstOperands,
     /* 348116 */     // GIR_Coverage, 12248,
     /* 348116 */     GIR_EraseRootFromParent_Done,
     /* 348117 */   // Label 5545: @348117
     /* 348117 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(348252), // Rule ID 12249 //
     /* 348122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 348125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348169 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348174 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348206 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 348209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348250 */     GIR_RootConstrainSelectedInstOperands,
     /* 348251 */     // GIR_Coverage, 12249,
     /* 348251 */     GIR_EraseRootFromParent_Done,
     /* 348252 */   // Label 5546: @348252
     /* 348252 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(348387), // Rule ID 12726 //
     /* 348257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348304 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348309 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348341 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348385 */     GIR_RootConstrainSelectedInstOperands,
     /* 348386 */     // GIR_Coverage, 12726,
     /* 348386 */     GIR_EraseRootFromParent_Done,
     /* 348387 */   // Label 5547: @348387
     /* 348387 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(348522), // Rule ID 12727 //
     /* 348392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348476 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348520 */     GIR_RootConstrainSelectedInstOperands,
     /* 348521 */     // GIR_Coverage, 12727,
     /* 348521 */     GIR_EraseRootFromParent_Done,
     /* 348522 */   // Label 5548: @348522
     /* 348522 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(348657), // Rule ID 12728 //
     /* 348527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348611 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348655 */     GIR_RootConstrainSelectedInstOperands,
     /* 348656 */     // GIR_Coverage, 12728,
     /* 348656 */     GIR_EraseRootFromParent_Done,
     /* 348657 */   // Label 5549: @348657
     /* 348657 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(348792), // Rule ID 12729 //
     /* 348662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348746 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348790 */     GIR_RootConstrainSelectedInstOperands,
     /* 348791 */     // GIR_Coverage, 12729,
     /* 348791 */     GIR_EraseRootFromParent_Done,
     /* 348792 */   // Label 5550: @348792
     /* 348792 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(348927), // Rule ID 13206 //
     /* 348797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348849 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348881 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348925 */     GIR_RootConstrainSelectedInstOperands,
     /* 348926 */     // GIR_Coverage, 13206,
     /* 348926 */     GIR_EraseRootFromParent_Done,
     /* 348927 */   // Label 5551: @348927
     /* 348927 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(349062), // Rule ID 13207 //
     /* 348932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348979 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348984 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349016 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 349019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349060 */     GIR_RootConstrainSelectedInstOperands,
     /* 349061 */     // GIR_Coverage, 13207,
     /* 349061 */     GIR_EraseRootFromParent_Done,
     /* 349062 */   // Label 5552: @349062
     /* 349062 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(349197), // Rule ID 13208 //
     /* 349067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 349070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 349114 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349151 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 349154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349195 */     GIR_RootConstrainSelectedInstOperands,
     /* 349196 */     // GIR_Coverage, 13208,
     /* 349196 */     GIR_EraseRootFromParent_Done,
     /* 349197 */   // Label 5553: @349197
     /* 349197 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(349332), // Rule ID 13209 //
     /* 349202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 349205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 349249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349286 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 349289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349330 */     GIR_RootConstrainSelectedInstOperands,
     /* 349331 */     // GIR_Coverage, 13209,
     /* 349331 */     GIR_EraseRootFromParent_Done,
     /* 349332 */   // Label 5554: @349332
     /* 349332 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(349467), // Rule ID 12186 //
     /* 349337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349421 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349465 */     GIR_RootConstrainSelectedInstOperands,
     /* 349466 */     // GIR_Coverage, 12186,
     /* 349466 */     GIR_EraseRootFromParent_Done,
     /* 349467 */   // Label 5555: @349467
     /* 349467 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(349602), // Rule ID 12187 //
     /* 349472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349556 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349600 */     GIR_RootConstrainSelectedInstOperands,
     /* 349601 */     // GIR_Coverage, 12187,
     /* 349601 */     GIR_EraseRootFromParent_Done,
     /* 349602 */   // Label 5556: @349602
     /* 349602 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(349737), // Rule ID 12188 //
     /* 349607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349654 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349659 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349691 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349735 */     GIR_RootConstrainSelectedInstOperands,
     /* 349736 */     // GIR_Coverage, 12188,
     /* 349736 */     GIR_EraseRootFromParent_Done,
     /* 349737 */   // Label 5557: @349737
     /* 349737 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(349872), // Rule ID 12189 //
     /* 349742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349789 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349794 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349826 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349870 */     GIR_RootConstrainSelectedInstOperands,
     /* 349871 */     // GIR_Coverage, 12189,
     /* 349871 */     GIR_EraseRootFromParent_Done,
     /* 349872 */   // Label 5558: @349872
     /* 349872 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(350007), // Rule ID 12666 //
     /* 349877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349961 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350005 */     GIR_RootConstrainSelectedInstOperands,
     /* 350006 */     // GIR_Coverage, 12666,
     /* 350006 */     GIR_EraseRootFromParent_Done,
     /* 350007 */   // Label 5559: @350007
     /* 350007 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(350142), // Rule ID 12667 //
     /* 350012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 350015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 350019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350096 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 350099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350140 */     GIR_RootConstrainSelectedInstOperands,
     /* 350141 */     // GIR_Coverage, 12667,
     /* 350141 */     GIR_EraseRootFromParent_Done,
     /* 350142 */   // Label 5560: @350142
     /* 350142 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(350277), // Rule ID 12668 //
     /* 350147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 350150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 350154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350231 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 350234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350275 */     GIR_RootConstrainSelectedInstOperands,
     /* 350276 */     // GIR_Coverage, 12668,
     /* 350276 */     GIR_EraseRootFromParent_Done,
     /* 350277 */   // Label 5561: @350277
     /* 350277 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(350412), // Rule ID 12669 //
     /* 350282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 350285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 350289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350334 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350366 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 350369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350410 */     GIR_RootConstrainSelectedInstOperands,
     /* 350411 */     // GIR_Coverage, 12669,
     /* 350411 */     GIR_EraseRootFromParent_Done,
     /* 350412 */   // Label 5562: @350412
     /* 350412 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(350547), // Rule ID 13146 //
     /* 350417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350464 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350469 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350501 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350545 */     GIR_RootConstrainSelectedInstOperands,
     /* 350546 */     // GIR_Coverage, 13146,
     /* 350546 */     GIR_EraseRootFromParent_Done,
     /* 350547 */   // Label 5563: @350547
     /* 350547 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(350682), // Rule ID 13147 //
     /* 350552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350599 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350636 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350680 */     GIR_RootConstrainSelectedInstOperands,
     /* 350681 */     // GIR_Coverage, 13147,
     /* 350681 */     GIR_EraseRootFromParent_Done,
     /* 350682 */   // Label 5564: @350682
     /* 350682 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(350817), // Rule ID 13148 //
     /* 350687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350771 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350815 */     GIR_RootConstrainSelectedInstOperands,
     /* 350816 */     // GIR_Coverage, 13148,
     /* 350816 */     GIR_EraseRootFromParent_Done,
     /* 350817 */   // Label 5565: @350817
     /* 350817 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(350952), // Rule ID 13149 //
     /* 350822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350906 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350950 */     GIR_RootConstrainSelectedInstOperands,
     /* 350951 */     // GIR_Coverage, 13149,
     /* 350951 */     GIR_EraseRootFromParent_Done,
     /* 350952 */   // Label 5566: @350952
     /* 350952 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(351087), // Rule ID 12231 //
     /* 350957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351041 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351085 */     GIR_RootConstrainSelectedInstOperands,
     /* 351086 */     // GIR_Coverage, 12231,
     /* 351086 */     GIR_EraseRootFromParent_Done,
     /* 351087 */   // Label 5567: @351087
     /* 351087 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(351222), // Rule ID 12232 //
     /* 351092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351139 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351176 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351220 */     GIR_RootConstrainSelectedInstOperands,
     /* 351221 */     // GIR_Coverage, 12232,
     /* 351221 */     GIR_EraseRootFromParent_Done,
     /* 351222 */   // Label 5568: @351222
     /* 351222 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(351357), // Rule ID 12233 //
     /* 351227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351274 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351279 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351311 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351355 */     GIR_RootConstrainSelectedInstOperands,
     /* 351356 */     // GIR_Coverage, 12233,
     /* 351356 */     GIR_EraseRootFromParent_Done,
     /* 351357 */   // Label 5569: @351357
     /* 351357 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(351492), // Rule ID 12234 //
     /* 351362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351446 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351490 */     GIR_RootConstrainSelectedInstOperands,
     /* 351491 */     // GIR_Coverage, 12234,
     /* 351491 */     GIR_EraseRootFromParent_Done,
     /* 351492 */   // Label 5570: @351492
     /* 351492 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(351627), // Rule ID 12711 //
     /* 351497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351581 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351625 */     GIR_RootConstrainSelectedInstOperands,
     /* 351626 */     // GIR_Coverage, 12711,
     /* 351626 */     GIR_EraseRootFromParent_Done,
     /* 351627 */   // Label 5571: @351627
     /* 351627 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(351762), // Rule ID 12712 //
     /* 351632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351716 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351760 */     GIR_RootConstrainSelectedInstOperands,
     /* 351761 */     // GIR_Coverage, 12712,
     /* 351761 */     GIR_EraseRootFromParent_Done,
     /* 351762 */   // Label 5572: @351762
     /* 351762 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(351897), // Rule ID 12713 //
     /* 351767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351851 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351895 */     GIR_RootConstrainSelectedInstOperands,
     /* 351896 */     // GIR_Coverage, 12713,
     /* 351896 */     GIR_EraseRootFromParent_Done,
     /* 351897 */   // Label 5573: @351897
     /* 351897 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(352032), // Rule ID 12714 //
     /* 351902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351949 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351954 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351986 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352030 */     GIR_RootConstrainSelectedInstOperands,
     /* 352031 */     // GIR_Coverage, 12714,
     /* 352031 */     GIR_EraseRootFromParent_Done,
     /* 352032 */   // Label 5574: @352032
     /* 352032 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(352167), // Rule ID 13191 //
     /* 352037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352084 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352121 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352165 */     GIR_RootConstrainSelectedInstOperands,
     /* 352166 */     // GIR_Coverage, 13191,
     /* 352166 */     GIR_EraseRootFromParent_Done,
     /* 352167 */   // Label 5575: @352167
     /* 352167 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(352302), // Rule ID 13192 //
     /* 352172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352256 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352300 */     GIR_RootConstrainSelectedInstOperands,
     /* 352301 */     // GIR_Coverage, 13192,
     /* 352301 */     GIR_EraseRootFromParent_Done,
     /* 352302 */   // Label 5576: @352302
     /* 352302 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(352437), // Rule ID 13193 //
     /* 352307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352391 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352435 */     GIR_RootConstrainSelectedInstOperands,
     /* 352436 */     // GIR_Coverage, 13193,
     /* 352436 */     GIR_EraseRootFromParent_Done,
     /* 352437 */   // Label 5577: @352437
     /* 352437 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(352572), // Rule ID 13194 //
     /* 352442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352494 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352526 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352570 */     GIR_RootConstrainSelectedInstOperands,
     /* 352571 */     // GIR_Coverage, 13194,
     /* 352571 */     GIR_EraseRootFromParent_Done,
     /* 352572 */   // Label 5578: @352572
     /* 352572 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(352707), // Rule ID 12171 //
     /* 352577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352624 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352661 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352705 */     GIR_RootConstrainSelectedInstOperands,
     /* 352706 */     // GIR_Coverage, 12171,
     /* 352706 */     GIR_EraseRootFromParent_Done,
     /* 352707 */   // Label 5579: @352707
     /* 352707 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(352842), // Rule ID 12172 //
     /* 352712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352759 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352796 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352840 */     GIR_RootConstrainSelectedInstOperands,
     /* 352841 */     // GIR_Coverage, 12172,
     /* 352841 */     GIR_EraseRootFromParent_Done,
     /* 352842 */   // Label 5580: @352842
     /* 352842 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(352977), // Rule ID 12173 //
     /* 352847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352931 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352975 */     GIR_RootConstrainSelectedInstOperands,
     /* 352976 */     // GIR_Coverage, 12173,
     /* 352976 */     GIR_EraseRootFromParent_Done,
     /* 352977 */   // Label 5581: @352977
     /* 352977 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(353112), // Rule ID 12174 //
     /* 352982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353034 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353066 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353110 */     GIR_RootConstrainSelectedInstOperands,
     /* 353111 */     // GIR_Coverage, 12174,
     /* 353111 */     GIR_EraseRootFromParent_Done,
     /* 353112 */   // Label 5582: @353112
     /* 353112 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(353247), // Rule ID 12651 //
     /* 353117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353164 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353169 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353201 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353245 */     GIR_RootConstrainSelectedInstOperands,
     /* 353246 */     // GIR_Coverage, 12651,
     /* 353246 */     GIR_EraseRootFromParent_Done,
     /* 353247 */   // Label 5583: @353247
     /* 353247 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(353382), // Rule ID 12652 //
     /* 353252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353299 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353304 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353336 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353380 */     GIR_RootConstrainSelectedInstOperands,
     /* 353381 */     // GIR_Coverage, 12652,
     /* 353381 */     GIR_EraseRootFromParent_Done,
     /* 353382 */   // Label 5584: @353382
     /* 353382 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(353517), // Rule ID 12653 //
     /* 353387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353471 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353515 */     GIR_RootConstrainSelectedInstOperands,
     /* 353516 */     // GIR_Coverage, 12653,
     /* 353516 */     GIR_EraseRootFromParent_Done,
     /* 353517 */   // Label 5585: @353517
     /* 353517 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(353652), // Rule ID 12654 //
     /* 353522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353606 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353650 */     GIR_RootConstrainSelectedInstOperands,
     /* 353651 */     // GIR_Coverage, 12654,
     /* 353651 */     GIR_EraseRootFromParent_Done,
     /* 353652 */   // Label 5586: @353652
     /* 353652 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(353787), // Rule ID 13131 //
     /* 353657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353741 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353785 */     GIR_RootConstrainSelectedInstOperands,
     /* 353786 */     // GIR_Coverage, 13131,
     /* 353786 */     GIR_EraseRootFromParent_Done,
     /* 353787 */   // Label 5587: @353787
     /* 353787 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(353922), // Rule ID 13132 //
     /* 353792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353876 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353920 */     GIR_RootConstrainSelectedInstOperands,
     /* 353921 */     // GIR_Coverage, 13132,
     /* 353921 */     GIR_EraseRootFromParent_Done,
     /* 353922 */   // Label 5588: @353922
     /* 353922 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(354057), // Rule ID 13133 //
     /* 353927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353979 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354011 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 354014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 354021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 354026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354055 */     GIR_RootConstrainSelectedInstOperands,
     /* 354056 */     // GIR_Coverage, 13133,
     /* 354056 */     GIR_EraseRootFromParent_Done,
     /* 354057 */   // Label 5589: @354057
     /* 354057 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(354192), // Rule ID 13134 //
     /* 354062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 354093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354109 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354114 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354146 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 354149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 354156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 354161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354190 */     GIR_RootConstrainSelectedInstOperands,
     /* 354191 */     // GIR_Coverage, 13134,
     /* 354191 */     GIR_EraseRootFromParent_Done,
     /* 354192 */   // Label 5590: @354192
     /* 354192 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(354327), // Rule ID 12242 //
     /* 354197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354244 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354281 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354325 */     GIR_RootConstrainSelectedInstOperands,
     /* 354326 */     // GIR_Coverage, 12242,
     /* 354326 */     GIR_EraseRootFromParent_Done,
     /* 354327 */   // Label 5591: @354327
     /* 354327 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(354462), // Rule ID 12243 //
     /* 354332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354416 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354460 */     GIR_RootConstrainSelectedInstOperands,
     /* 354461 */     // GIR_Coverage, 12243,
     /* 354461 */     GIR_EraseRootFromParent_Done,
     /* 354462 */   // Label 5592: @354462
     /* 354462 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(354597), // Rule ID 12244 //
     /* 354467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354551 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354595 */     GIR_RootConstrainSelectedInstOperands,
     /* 354596 */     // GIR_Coverage, 12244,
     /* 354596 */     GIR_EraseRootFromParent_Done,
     /* 354597 */   // Label 5593: @354597
     /* 354597 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(354732), // Rule ID 12245 //
     /* 354602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354654 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354686 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354730 */     GIR_RootConstrainSelectedInstOperands,
     /* 354731 */     // GIR_Coverage, 12245,
     /* 354731 */     GIR_EraseRootFromParent_Done,
     /* 354732 */   // Label 5594: @354732
     /* 354732 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(354867), // Rule ID 12722 //
     /* 354737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354784 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354789 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354821 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354865 */     GIR_RootConstrainSelectedInstOperands,
     /* 354866 */     // GIR_Coverage, 12722,
     /* 354866 */     GIR_EraseRootFromParent_Done,
     /* 354867 */   // Label 5595: @354867
     /* 354867 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(355002), // Rule ID 12723 //
     /* 354872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354919 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354956 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355000 */     GIR_RootConstrainSelectedInstOperands,
     /* 355001 */     // GIR_Coverage, 12723,
     /* 355001 */     GIR_EraseRootFromParent_Done,
     /* 355002 */   // Label 5596: @355002
     /* 355002 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(355137), // Rule ID 12724 //
     /* 355007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 355010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 355014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355091 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 355094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355135 */     GIR_RootConstrainSelectedInstOperands,
     /* 355136 */     // GIR_Coverage, 12724,
     /* 355136 */     GIR_EraseRootFromParent_Done,
     /* 355137 */   // Label 5597: @355137
     /* 355137 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(355272), // Rule ID 12725 //
     /* 355142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 355145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 355149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355226 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 355229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355270 */     GIR_RootConstrainSelectedInstOperands,
     /* 355271 */     // GIR_Coverage, 12725,
     /* 355271 */     GIR_EraseRootFromParent_Done,
     /* 355272 */   // Label 5598: @355272
     /* 355272 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(355407), // Rule ID 13202 //
     /* 355277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355361 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355405 */     GIR_RootConstrainSelectedInstOperands,
     /* 355406 */     // GIR_Coverage, 13202,
     /* 355406 */     GIR_EraseRootFromParent_Done,
     /* 355407 */   // Label 5599: @355407
     /* 355407 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(355542), // Rule ID 13203 //
     /* 355412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355464 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355496 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355540 */     GIR_RootConstrainSelectedInstOperands,
     /* 355541 */     // GIR_Coverage, 13203,
     /* 355541 */     GIR_EraseRootFromParent_Done,
     /* 355542 */   // Label 5600: @355542
     /* 355542 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(355677), // Rule ID 13204 //
     /* 355547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355594 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355599 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355631 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355675 */     GIR_RootConstrainSelectedInstOperands,
     /* 355676 */     // GIR_Coverage, 13204,
     /* 355676 */     GIR_EraseRootFromParent_Done,
     /* 355677 */   // Label 5601: @355677
     /* 355677 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(355812), // Rule ID 13205 //
     /* 355682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355729 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355766 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355810 */     GIR_RootConstrainSelectedInstOperands,
     /* 355811 */     // GIR_Coverage, 13205,
     /* 355811 */     GIR_EraseRootFromParent_Done,
     /* 355812 */   // Label 5602: @355812
     /* 355812 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(355947), // Rule ID 12182 //
     /* 355817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355864 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355901 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355945 */     GIR_RootConstrainSelectedInstOperands,
     /* 355946 */     // GIR_Coverage, 12182,
     /* 355946 */     GIR_EraseRootFromParent_Done,
     /* 355947 */   // Label 5603: @355947
     /* 355947 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(356082), // Rule ID 12183 //
     /* 355952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356036 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356080 */     GIR_RootConstrainSelectedInstOperands,
     /* 356081 */     // GIR_Coverage, 12183,
     /* 356081 */     GIR_EraseRootFromParent_Done,
     /* 356082 */   // Label 5604: @356082
     /* 356082 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(356217), // Rule ID 12184 //
     /* 356087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 356090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356134 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356139 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356171 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356215 */     GIR_RootConstrainSelectedInstOperands,
     /* 356216 */     // GIR_Coverage, 12184,
     /* 356216 */     GIR_EraseRootFromParent_Done,
     /* 356217 */   // Label 5605: @356217
     /* 356217 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(356352), // Rule ID 12185 //
     /* 356222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 356225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356269 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356274 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356306 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356350 */     GIR_RootConstrainSelectedInstOperands,
     /* 356351 */     // GIR_Coverage, 12185,
     /* 356351 */     GIR_EraseRootFromParent_Done,
     /* 356352 */   // Label 5606: @356352
     /* 356352 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(356487), // Rule ID 12662 //
     /* 356357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356404 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356441 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356485 */     GIR_RootConstrainSelectedInstOperands,
     /* 356486 */     // GIR_Coverage, 12662,
     /* 356486 */     GIR_EraseRootFromParent_Done,
     /* 356487 */   // Label 5607: @356487
     /* 356487 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(356622), // Rule ID 12663 //
     /* 356492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356576 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356620 */     GIR_RootConstrainSelectedInstOperands,
     /* 356621 */     // GIR_Coverage, 12663,
     /* 356621 */     GIR_EraseRootFromParent_Done,
     /* 356622 */   // Label 5608: @356622
     /* 356622 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(356757), // Rule ID 12664 //
     /* 356627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356711 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356755 */     GIR_RootConstrainSelectedInstOperands,
     /* 356756 */     // GIR_Coverage, 12664,
     /* 356756 */     GIR_EraseRootFromParent_Done,
     /* 356757 */   // Label 5609: @356757
     /* 356757 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(356892), // Rule ID 12665 //
     /* 356762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356809 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356846 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356890 */     GIR_RootConstrainSelectedInstOperands,
     /* 356891 */     // GIR_Coverage, 12665,
     /* 356891 */     GIR_EraseRootFromParent_Done,
     /* 356892 */   // Label 5610: @356892
     /* 356892 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(357027), // Rule ID 13142 //
     /* 356897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356944 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356949 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356981 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357025 */     GIR_RootConstrainSelectedInstOperands,
     /* 357026 */     // GIR_Coverage, 13142,
     /* 357026 */     GIR_EraseRootFromParent_Done,
     /* 357027 */   // Label 5611: @357027
     /* 357027 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(357162), // Rule ID 13143 //
     /* 357032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 357063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357079 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357084 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357116 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 357119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357160 */     GIR_RootConstrainSelectedInstOperands,
     /* 357161 */     // GIR_Coverage, 13143,
     /* 357161 */     GIR_EraseRootFromParent_Done,
     /* 357162 */   // Label 5612: @357162
     /* 357162 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(357297), // Rule ID 13144 //
     /* 357167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 357198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357214 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357251 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 357254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357295 */     GIR_RootConstrainSelectedInstOperands,
     /* 357296 */     // GIR_Coverage, 13144,
     /* 357296 */     GIR_EraseRootFromParent_Done,
     /* 357297 */   // Label 5613: @357297
     /* 357297 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(357432), // Rule ID 13145 //
     /* 357302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 357333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357386 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 357389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357430 */     GIR_RootConstrainSelectedInstOperands,
     /* 357431 */     // GIR_Coverage, 13145,
     /* 357431 */     GIR_EraseRootFromParent_Done,
     /* 357432 */   // Label 5614: @357432
     /* 357432 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(357567), // Rule ID 12227 //
     /* 357437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357521 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357565 */     GIR_RootConstrainSelectedInstOperands,
     /* 357566 */     // GIR_Coverage, 12227,
     /* 357566 */     GIR_EraseRootFromParent_Done,
     /* 357567 */   // Label 5615: @357567
     /* 357567 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(357702), // Rule ID 12228 //
     /* 357572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357619 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357624 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357656 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357700 */     GIR_RootConstrainSelectedInstOperands,
     /* 357701 */     // GIR_Coverage, 12228,
     /* 357701 */     GIR_EraseRootFromParent_Done,
     /* 357702 */   // Label 5616: @357702
     /* 357702 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(357837), // Rule ID 12229 //
     /* 357707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357754 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357759 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357791 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357835 */     GIR_RootConstrainSelectedInstOperands,
     /* 357836 */     // GIR_Coverage, 12229,
     /* 357836 */     GIR_EraseRootFromParent_Done,
     /* 357837 */   // Label 5617: @357837
     /* 357837 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(357972), // Rule ID 12230 //
     /* 357842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357889 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357926 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357970 */     GIR_RootConstrainSelectedInstOperands,
     /* 357971 */     // GIR_Coverage, 12230,
     /* 357971 */     GIR_EraseRootFromParent_Done,
     /* 357972 */   // Label 5618: @357972
     /* 357972 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(358107), // Rule ID 12707 //
     /* 357977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358061 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358105 */     GIR_RootConstrainSelectedInstOperands,
     /* 358106 */     // GIR_Coverage, 12707,
     /* 358106 */     GIR_EraseRootFromParent_Done,
     /* 358107 */   // Label 5619: @358107
     /* 358107 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(358242), // Rule ID 12708 //
     /* 358112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 358115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 358119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358164 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358196 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358240 */     GIR_RootConstrainSelectedInstOperands,
     /* 358241 */     // GIR_Coverage, 12708,
     /* 358241 */     GIR_EraseRootFromParent_Done,
     /* 358242 */   // Label 5620: @358242
     /* 358242 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(358377), // Rule ID 12709 //
     /* 358247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 358250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 358254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358299 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358331 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358375 */     GIR_RootConstrainSelectedInstOperands,
     /* 358376 */     // GIR_Coverage, 12709,
     /* 358376 */     GIR_EraseRootFromParent_Done,
     /* 358377 */   // Label 5621: @358377
     /* 358377 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(358512), // Rule ID 12710 //
     /* 358382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 358385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 358389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358429 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358466 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358510 */     GIR_RootConstrainSelectedInstOperands,
     /* 358511 */     // GIR_Coverage, 12710,
     /* 358511 */     GIR_EraseRootFromParent_Done,
     /* 358512 */   // Label 5622: @358512
     /* 358512 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(358647), // Rule ID 13187 //
     /* 358517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358564 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358601 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358645 */     GIR_RootConstrainSelectedInstOperands,
     /* 358646 */     // GIR_Coverage, 13187,
     /* 358646 */     GIR_EraseRootFromParent_Done,
     /* 358647 */   // Label 5623: @358647
     /* 358647 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(358782), // Rule ID 13188 //
     /* 358652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358736 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358780 */     GIR_RootConstrainSelectedInstOperands,
     /* 358781 */     // GIR_Coverage, 13188,
     /* 358781 */     GIR_EraseRootFromParent_Done,
     /* 358782 */   // Label 5624: @358782
     /* 358782 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(358917), // Rule ID 13189 //
     /* 358787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358871 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358915 */     GIR_RootConstrainSelectedInstOperands,
     /* 358916 */     // GIR_Coverage, 13189,
     /* 358916 */     GIR_EraseRootFromParent_Done,
     /* 358917 */   // Label 5625: @358917
     /* 358917 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(359052), // Rule ID 13190 //
     /* 358922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359006 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359050 */     GIR_RootConstrainSelectedInstOperands,
     /* 359051 */     // GIR_Coverage, 13190,
     /* 359051 */     GIR_EraseRootFromParent_Done,
     /* 359052 */   // Label 5626: @359052
     /* 359052 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(359187), // Rule ID 12167 //
     /* 359057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359104 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359109 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359141 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359185 */     GIR_RootConstrainSelectedInstOperands,
     /* 359186 */     // GIR_Coverage, 12167,
     /* 359186 */     GIR_EraseRootFromParent_Done,
     /* 359187 */   // Label 5627: @359187
     /* 359187 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(359322), // Rule ID 12168 //
     /* 359192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359239 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359244 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359276 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359320 */     GIR_RootConstrainSelectedInstOperands,
     /* 359321 */     // GIR_Coverage, 12168,
     /* 359321 */     GIR_EraseRootFromParent_Done,
     /* 359322 */   // Label 5628: @359322
     /* 359322 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(359457), // Rule ID 12169 //
     /* 359327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359374 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359411 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359455 */     GIR_RootConstrainSelectedInstOperands,
     /* 359456 */     // GIR_Coverage, 12169,
     /* 359456 */     GIR_EraseRootFromParent_Done,
     /* 359457 */   // Label 5629: @359457
     /* 359457 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(359592), // Rule ID 12170 //
     /* 359462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359546 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359590 */     GIR_RootConstrainSelectedInstOperands,
     /* 359591 */     // GIR_Coverage, 12170,
     /* 359591 */     GIR_EraseRootFromParent_Done,
     /* 359592 */   // Label 5630: @359592
     /* 359592 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(359727), // Rule ID 12647 //
     /* 359597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359681 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359725 */     GIR_RootConstrainSelectedInstOperands,
     /* 359726 */     // GIR_Coverage, 12647,
     /* 359726 */     GIR_EraseRootFromParent_Done,
     /* 359727 */   // Label 5631: @359727
     /* 359727 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(359862), // Rule ID 12648 //
     /* 359732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359784 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359816 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359860 */     GIR_RootConstrainSelectedInstOperands,
     /* 359861 */     // GIR_Coverage, 12648,
     /* 359861 */     GIR_EraseRootFromParent_Done,
     /* 359862 */   // Label 5632: @359862
     /* 359862 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(359997), // Rule ID 12649 //
     /* 359867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359914 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359919 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359951 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359995 */     GIR_RootConstrainSelectedInstOperands,
     /* 359996 */     // GIR_Coverage, 12649,
     /* 359996 */     GIR_EraseRootFromParent_Done,
     /* 359997 */   // Label 5633: @359997
     /* 359997 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(360132), // Rule ID 12650 //
     /* 360002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 360005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360049 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360086 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 360089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360130 */     GIR_RootConstrainSelectedInstOperands,
     /* 360131 */     // GIR_Coverage, 12650,
     /* 360131 */     GIR_EraseRootFromParent_Done,
     /* 360132 */   // Label 5634: @360132
     /* 360132 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(360267), // Rule ID 13127 //
     /* 360137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360221 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360265 */     GIR_RootConstrainSelectedInstOperands,
     /* 360266 */     // GIR_Coverage, 13127,
     /* 360266 */     GIR_EraseRootFromParent_Done,
     /* 360267 */   // Label 5635: @360267
     /* 360267 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(360402), // Rule ID 13128 //
     /* 360272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360356 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360400 */     GIR_RootConstrainSelectedInstOperands,
     /* 360401 */     // GIR_Coverage, 13128,
     /* 360401 */     GIR_EraseRootFromParent_Done,
     /* 360402 */   // Label 5636: @360402
     /* 360402 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(360537), // Rule ID 13129 //
     /* 360407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360491 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360535 */     GIR_RootConstrainSelectedInstOperands,
     /* 360536 */     // GIR_Coverage, 13129,
     /* 360536 */     GIR_EraseRootFromParent_Done,
     /* 360537 */   // Label 5637: @360537
     /* 360537 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(360672), // Rule ID 13130 //
     /* 360542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360589 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360594 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360626 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360670 */     GIR_RootConstrainSelectedInstOperands,
     /* 360671 */     // GIR_Coverage, 13130,
     /* 360671 */     GIR_EraseRootFromParent_Done,
     /* 360672 */   // Label 5638: @360672
     /* 360672 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(360787), // Rule ID 13275 //
     /* 360677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 360680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360712 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360714 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 360718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360741 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 360744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360785 */     GIR_RootConstrainSelectedInstOperands,
     /* 360786 */     // GIR_Coverage, 13275,
     /* 360786 */     GIR_EraseRootFromParent_Done,
     /* 360787 */   // Label 5639: @360787
     /* 360787 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(360902), // Rule ID 13291 //
     /* 360792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 360795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360827 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360829 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 360833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360856 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 360859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360900 */     GIR_RootConstrainSelectedInstOperands,
     /* 360901 */     // GIR_Coverage, 13291,
     /* 360901 */     GIR_EraseRootFromParent_Done,
     /* 360902 */   // Label 5640: @360902
     /* 360902 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(361017), // Rule ID 13274 //
     /* 360907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 360910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360942 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360944 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 360948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360971 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 360974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361015 */     GIR_RootConstrainSelectedInstOperands,
     /* 361016 */     // GIR_Coverage, 13274,
     /* 361016 */     GIR_EraseRootFromParent_Done,
     /* 361017 */   // Label 5641: @361017
     /* 361017 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(361132), // Rule ID 13290 //
     /* 361022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361057 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361059 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 361063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361086 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361130 */     GIR_RootConstrainSelectedInstOperands,
     /* 361131 */     // GIR_Coverage, 13290,
     /* 361131 */     GIR_EraseRootFromParent_Done,
     /* 361132 */   // Label 5642: @361132
     /* 361132 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(361247), // Rule ID 7749 //
     /* 361137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361172 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361174 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 361178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361201 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361245 */     GIR_RootConstrainSelectedInstOperands,
     /* 361246 */     // GIR_Coverage, 7749,
     /* 361246 */     GIR_EraseRootFromParent_Done,
     /* 361247 */   // Label 5643: @361247
     /* 361247 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(361362), // Rule ID 7765 //
     /* 361252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361287 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361289 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 361293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361316 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361360 */     GIR_RootConstrainSelectedInstOperands,
     /* 361361 */     // GIR_Coverage, 7765,
     /* 361361 */     GIR_EraseRootFromParent_Done,
     /* 361362 */   // Label 5644: @361362
     /* 361362 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(361477), // Rule ID 7748 //
     /* 361367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361402 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361404 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 361408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361431 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361475 */     GIR_RootConstrainSelectedInstOperands,
     /* 361476 */     // GIR_Coverage, 7748,
     /* 361476 */     GIR_EraseRootFromParent_Done,
     /* 361477 */   // Label 5645: @361477
     /* 361477 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(361592), // Rule ID 7764 //
     /* 361482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361517 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361519 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 361523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361546 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361590 */     GIR_RootConstrainSelectedInstOperands,
     /* 361591 */     // GIR_Coverage, 7764,
     /* 361591 */     GIR_EraseRootFromParent_Done,
     /* 361592 */   // Label 5646: @361592
     /* 361592 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(361691), // Rule ID 13267 //
     /* 361597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361620 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361645 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361689 */     GIR_RootConstrainSelectedInstOperands,
     /* 361690 */     // GIR_Coverage, 13267,
     /* 361690 */     GIR_EraseRootFromParent_Done,
     /* 361691 */   // Label 5647: @361691
     /* 361691 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(361790), // Rule ID 13283 //
     /* 361696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361719 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361744 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361788 */     GIR_RootConstrainSelectedInstOperands,
     /* 361789 */     // GIR_Coverage, 13283,
     /* 361789 */     GIR_EraseRootFromParent_Done,
     /* 361790 */   // Label 5648: @361790
     /* 361790 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(361889), // Rule ID 13266 //
     /* 361795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361818 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361843 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361887 */     GIR_RootConstrainSelectedInstOperands,
     /* 361888 */     // GIR_Coverage, 13266,
     /* 361888 */     GIR_EraseRootFromParent_Done,
     /* 361889 */   // Label 5649: @361889
     /* 361889 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(361988), // Rule ID 13282 //
     /* 361894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361917 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361942 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361986 */     GIR_RootConstrainSelectedInstOperands,
     /* 361987 */     // GIR_Coverage, 13282,
     /* 361987 */     GIR_EraseRootFromParent_Done,
     /* 361988 */   // Label 5650: @361988
     /* 361988 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(362087), // Rule ID 7741 //
     /* 361993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362016 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 362018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362041 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 362044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362085 */     GIR_RootConstrainSelectedInstOperands,
     /* 362086 */     // GIR_Coverage, 7741,
     /* 362086 */     GIR_EraseRootFromParent_Done,
     /* 362087 */   // Label 5651: @362087
     /* 362087 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(362186), // Rule ID 7757 //
     /* 362092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362115 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 362117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362140 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 362143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362184 */     GIR_RootConstrainSelectedInstOperands,
     /* 362185 */     // GIR_Coverage, 7757,
     /* 362185 */     GIR_EraseRootFromParent_Done,
     /* 362186 */   // Label 5652: @362186
     /* 362186 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(362285), // Rule ID 7740 //
     /* 362191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 362194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362214 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 362216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362239 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 362242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362283 */     GIR_RootConstrainSelectedInstOperands,
     /* 362284 */     // GIR_Coverage, 7740,
     /* 362284 */     GIR_EraseRootFromParent_Done,
     /* 362285 */   // Label 5653: @362285
     /* 362285 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(362384), // Rule ID 7756 //
     /* 362290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362313 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 362315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362338 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 362341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362382 */     GIR_RootConstrainSelectedInstOperands,
     /* 362383 */     // GIR_Coverage, 7756,
     /* 362383 */     GIR_EraseRootFromParent_Done,
     /* 362384 */   // Label 5654: @362384
     /* 362384 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(362419), // Rule ID 101 //
     /* 362389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 362392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13765),
     /* 362408 */     // (fminnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13765>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 362408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 362413 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 362417 */     GIR_RootConstrainSelectedInstOperands,
     /* 362418 */     // GIR_Coverage, 101,
     /* 362418 */     GIR_Done,
     /* 362419 */   // Label 5655: @362419
     /* 362419 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(362482), // Rule ID 886 //
     /* 362424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 362427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362445 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 362448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 362475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 362480 */     GIR_RootConstrainSelectedInstOperands,
     /* 362481 */     // GIR_Coverage, 886,
     /* 362481 */     GIR_EraseRootFromParent_Done,
     /* 362482 */   // Label 5656: @362482
     /* 362482 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(362545), // Rule ID 890 //
     /* 362487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362508 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 362511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 362538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 362543 */     GIR_RootConstrainSelectedInstOperands,
     /* 362544 */     // GIR_Coverage, 890,
     /* 362544 */     GIR_EraseRootFromParent_Done,
     /* 362545 */   // Label 5657: @362545
     /* 362545 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(362608), // Rule ID 8442 //
     /* 362550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 362553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362571 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 362574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 362581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 362591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 362601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 362606 */     GIR_RootConstrainSelectedInstOperands,
     /* 362607 */     // GIR_Coverage, 8442,
     /* 362607 */     GIR_EraseRootFromParent_Done,
     /* 362608 */   // Label 5658: @362608
     /* 362608 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(362671), // Rule ID 8444 //
     /* 362613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362634 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 362637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 362644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 362654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 362664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 362669 */     GIR_RootConstrainSelectedInstOperands,
     /* 362670 */     // GIR_Coverage, 8444,
     /* 362670 */     GIR_EraseRootFromParent_Done,
     /* 362671 */   // Label 5659: @362671
     /* 362671 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(362733), // Rule ID 888 //
     /* 362676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 362679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 362690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 362697 */     // (fminnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 362697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 362700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362731 */     GIR_RootConstrainSelectedInstOperands,
     /* 362732 */     // GIR_Coverage, 888,
     /* 362732 */     GIR_EraseRootFromParent_Done,
     /* 362733 */   // Label 5660: @362733
     /* 362733 */   GIM_Reject,
     /* 362734 */ // Label 5254: @362734
     /* 362734 */ GIM_Reject,
     /* 362735 */ // Label 5250: @362735
     /* 362735 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(380246),
     /* 362740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362746 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(362875), // Rule ID 11756 //
     /* 362751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362795 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362800 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362832 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362873 */     GIR_RootConstrainSelectedInstOperands,
     /* 362874 */     // GIR_Coverage, 11756,
     /* 362874 */     GIR_EraseRootFromParent_Done,
     /* 362875 */   // Label 5662: @362875
     /* 362875 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(363004), // Rule ID 11757 //
     /* 362880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362961 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363002 */     GIR_RootConstrainSelectedInstOperands,
     /* 363003 */     // GIR_Coverage, 11757,
     /* 363003 */     GIR_EraseRootFromParent_Done,
     /* 363004 */   // Label 5663: @363004
     /* 363004 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(363133), // Rule ID 11760 //
     /* 363009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363090 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363131 */     GIR_RootConstrainSelectedInstOperands,
     /* 363132 */     // GIR_Coverage, 11760,
     /* 363132 */     GIR_EraseRootFromParent_Done,
     /* 363133 */   // Label 5664: @363133
     /* 363133 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(363262), // Rule ID 11761 //
     /* 363138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363182 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363187 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363219 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363260 */     GIR_RootConstrainSelectedInstOperands,
     /* 363261 */     // GIR_Coverage, 11761,
     /* 363261 */     GIR_EraseRootFromParent_Done,
     /* 363262 */   // Label 5665: @363262
     /* 363262 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(363391), // Rule ID 11741 //
     /* 363267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363348 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363389 */     GIR_RootConstrainSelectedInstOperands,
     /* 363390 */     // GIR_Coverage, 11741,
     /* 363390 */     GIR_EraseRootFromParent_Done,
     /* 363391 */   // Label 5666: @363391
     /* 363391 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(363520), // Rule ID 11742 //
     /* 363396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363440 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363445 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363477 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363518 */     GIR_RootConstrainSelectedInstOperands,
     /* 363519 */     // GIR_Coverage, 11742,
     /* 363519 */     GIR_EraseRootFromParent_Done,
     /* 363520 */   // Label 5667: @363520
     /* 363520 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(363649), // Rule ID 11745 //
     /* 363525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363606 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363647 */     GIR_RootConstrainSelectedInstOperands,
     /* 363648 */     // GIR_Coverage, 11745,
     /* 363648 */     GIR_EraseRootFromParent_Done,
     /* 363649 */   // Label 5668: @363649
     /* 363649 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(363778), // Rule ID 11746 //
     /* 363654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363735 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363776 */     GIR_RootConstrainSelectedInstOperands,
     /* 363777 */     // GIR_Coverage, 11746,
     /* 363777 */     GIR_EraseRootFromParent_Done,
     /* 363778 */   // Label 5669: @363778
     /* 363778 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(363907), // Rule ID 7615 //
     /* 363783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363827 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363832 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363864 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363905 */     GIR_RootConstrainSelectedInstOperands,
     /* 363906 */     // GIR_Coverage, 7615,
     /* 363906 */     GIR_EraseRootFromParent_Done,
     /* 363907 */   // Label 5670: @363907
     /* 363907 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(364036), // Rule ID 11755 //
     /* 363912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363993 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364034 */     GIR_RootConstrainSelectedInstOperands,
     /* 364035 */     // GIR_Coverage, 11755,
     /* 364035 */     GIR_EraseRootFromParent_Done,
     /* 364036 */   // Label 5671: @364036
     /* 364036 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(364165), // Rule ID 11758 //
     /* 364041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364085 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364090 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364122 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364163 */     GIR_RootConstrainSelectedInstOperands,
     /* 364164 */     // GIR_Coverage, 11758,
     /* 364164 */     GIR_EraseRootFromParent_Done,
     /* 364165 */   // Label 5672: @364165
     /* 364165 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(364294), // Rule ID 11759 //
     /* 364170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364251 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364292 */     GIR_RootConstrainSelectedInstOperands,
     /* 364293 */     // GIR_Coverage, 11759,
     /* 364293 */     GIR_EraseRootFromParent_Done,
     /* 364294 */   // Label 5673: @364294
     /* 364294 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(364423), // Rule ID 7614 //
     /* 364299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364380 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364421 */     GIR_RootConstrainSelectedInstOperands,
     /* 364422 */     // GIR_Coverage, 7614,
     /* 364422 */     GIR_EraseRootFromParent_Done,
     /* 364423 */   // Label 5674: @364423
     /* 364423 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(364552), // Rule ID 11740 //
     /* 364428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364472 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364477 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364509 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364550 */     GIR_RootConstrainSelectedInstOperands,
     /* 364551 */     // GIR_Coverage, 11740,
     /* 364551 */     GIR_EraseRootFromParent_Done,
     /* 364552 */   // Label 5675: @364552
     /* 364552 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(364681), // Rule ID 11743 //
     /* 364557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364638 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364679 */     GIR_RootConstrainSelectedInstOperands,
     /* 364680 */     // GIR_Coverage, 11743,
     /* 364680 */     GIR_EraseRootFromParent_Done,
     /* 364681 */   // Label 5676: @364681
     /* 364681 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(364810), // Rule ID 11744 //
     /* 364686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364730 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364735 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364767 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364808 */     GIR_RootConstrainSelectedInstOperands,
     /* 364809 */     // GIR_Coverage, 11744,
     /* 364809 */     GIR_EraseRootFromParent_Done,
     /* 364810 */   // Label 5677: @364810
     /* 364810 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(364939), // Rule ID 11726 //
     /* 364815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364896 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364937 */     GIR_RootConstrainSelectedInstOperands,
     /* 364938 */     // GIR_Coverage, 11726,
     /* 364938 */     GIR_EraseRootFromParent_Done,
     /* 364939 */   // Label 5678: @364939
     /* 364939 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(365068), // Rule ID 11727 //
     /* 364944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364988 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364993 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365025 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365066 */     GIR_RootConstrainSelectedInstOperands,
     /* 365067 */     // GIR_Coverage, 11727,
     /* 365067 */     GIR_EraseRootFromParent_Done,
     /* 365068 */   // Label 5679: @365068
     /* 365068 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(365197), // Rule ID 11730 //
     /* 365073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365117 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365122 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365154 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365195 */     GIR_RootConstrainSelectedInstOperands,
     /* 365196 */     // GIR_Coverage, 11730,
     /* 365196 */     GIR_EraseRootFromParent_Done,
     /* 365197 */   // Label 5680: @365197
     /* 365197 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(365326), // Rule ID 11731 //
     /* 365202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365283 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365324 */     GIR_RootConstrainSelectedInstOperands,
     /* 365325 */     // GIR_Coverage, 11731,
     /* 365325 */     GIR_EraseRootFromParent_Done,
     /* 365326 */   // Label 5681: @365326
     /* 365326 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(365455), // Rule ID 11711 //
     /* 365331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365375 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365380 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365412 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365453 */     GIR_RootConstrainSelectedInstOperands,
     /* 365454 */     // GIR_Coverage, 11711,
     /* 365454 */     GIR_EraseRootFromParent_Done,
     /* 365455 */   // Label 5682: @365455
     /* 365455 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(365584), // Rule ID 11712 //
     /* 365460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365541 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365582 */     GIR_RootConstrainSelectedInstOperands,
     /* 365583 */     // GIR_Coverage, 11712,
     /* 365583 */     GIR_EraseRootFromParent_Done,
     /* 365584 */   // Label 5683: @365584
     /* 365584 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(365713), // Rule ID 11715 //
     /* 365589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365633 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365638 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365670 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365711 */     GIR_RootConstrainSelectedInstOperands,
     /* 365712 */     // GIR_Coverage, 11715,
     /* 365712 */     GIR_EraseRootFromParent_Done,
     /* 365713 */   // Label 5684: @365713
     /* 365713 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(365842), // Rule ID 11716 //
     /* 365718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365762 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365767 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365799 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365840 */     GIR_RootConstrainSelectedInstOperands,
     /* 365841 */     // GIR_Coverage, 11716,
     /* 365841 */     GIR_EraseRootFromParent_Done,
     /* 365842 */   // Label 5685: @365842
     /* 365842 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(365971), // Rule ID 7613 //
     /* 365847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365928 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365969 */     GIR_RootConstrainSelectedInstOperands,
     /* 365970 */     // GIR_Coverage, 7613,
     /* 365970 */     GIR_EraseRootFromParent_Done,
     /* 365971 */   // Label 5686: @365971
     /* 365971 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(366100), // Rule ID 11725 //
     /* 365976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366020 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366025 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366057 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366098 */     GIR_RootConstrainSelectedInstOperands,
     /* 366099 */     // GIR_Coverage, 11725,
     /* 366099 */     GIR_EraseRootFromParent_Done,
     /* 366100 */   // Label 5687: @366100
     /* 366100 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(366229), // Rule ID 11728 //
     /* 366105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366186 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366227 */     GIR_RootConstrainSelectedInstOperands,
     /* 366228 */     // GIR_Coverage, 11728,
     /* 366228 */     GIR_EraseRootFromParent_Done,
     /* 366229 */   // Label 5688: @366229
     /* 366229 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(366358), // Rule ID 11729 //
     /* 366234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366315 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366356 */     GIR_RootConstrainSelectedInstOperands,
     /* 366357 */     // GIR_Coverage, 11729,
     /* 366357 */     GIR_EraseRootFromParent_Done,
     /* 366358 */   // Label 5689: @366358
     /* 366358 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(366487), // Rule ID 7612 //
     /* 366363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366407 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366412 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366444 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366485 */     GIR_RootConstrainSelectedInstOperands,
     /* 366486 */     // GIR_Coverage, 7612,
     /* 366486 */     GIR_EraseRootFromParent_Done,
     /* 366487 */   // Label 5690: @366487
     /* 366487 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(366616), // Rule ID 11710 //
     /* 366492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366573 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366614 */     GIR_RootConstrainSelectedInstOperands,
     /* 366615 */     // GIR_Coverage, 11710,
     /* 366615 */     GIR_EraseRootFromParent_Done,
     /* 366616 */   // Label 5691: @366616
     /* 366616 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(366745), // Rule ID 11713 //
     /* 366621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366665 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366670 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366702 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366743 */     GIR_RootConstrainSelectedInstOperands,
     /* 366744 */     // GIR_Coverage, 11713,
     /* 366744 */     GIR_EraseRootFromParent_Done,
     /* 366745 */   // Label 5692: @366745
     /* 366745 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(366874), // Rule ID 11714 //
     /* 366750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366831 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366872 */     GIR_RootConstrainSelectedInstOperands,
     /* 366873 */     // GIR_Coverage, 11714,
     /* 366873 */     GIR_EraseRootFromParent_Done,
     /* 366874 */   // Label 5693: @366874
     /* 366874 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(367003), // Rule ID 11766 //
     /* 366879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 366928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 366933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366960 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 366980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 366985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367001 */     GIR_RootConstrainSelectedInstOperands,
     /* 367002 */     // GIR_Coverage, 11766,
     /* 367002 */     GIR_EraseRootFromParent_Done,
     /* 367003 */   // Label 5694: @367003
     /* 367003 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(367132), // Rule ID 11767 //
     /* 367008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367052 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367057 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367089 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367130 */     GIR_RootConstrainSelectedInstOperands,
     /* 367131 */     // GIR_Coverage, 11767,
     /* 367131 */     GIR_EraseRootFromParent_Done,
     /* 367132 */   // Label 5695: @367132
     /* 367132 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(367261), // Rule ID 11768 //
     /* 367137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367218 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367259 */     GIR_RootConstrainSelectedInstOperands,
     /* 367260 */     // GIR_Coverage, 11768,
     /* 367260 */     GIR_EraseRootFromParent_Done,
     /* 367261 */   // Label 5696: @367261
     /* 367261 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(367390), // Rule ID 11769 //
     /* 367266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367310 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367315 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367347 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367388 */     GIR_RootConstrainSelectedInstOperands,
     /* 367389 */     // GIR_Coverage, 11769,
     /* 367389 */     GIR_EraseRootFromParent_Done,
     /* 367390 */   // Label 5697: @367390
     /* 367390 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(367519), // Rule ID 11706 //
     /* 367395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367476 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367517 */     GIR_RootConstrainSelectedInstOperands,
     /* 367518 */     // GIR_Coverage, 11706,
     /* 367518 */     GIR_EraseRootFromParent_Done,
     /* 367519 */   // Label 5698: @367519
     /* 367519 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(367648), // Rule ID 11707 //
     /* 367524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367605 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367646 */     GIR_RootConstrainSelectedInstOperands,
     /* 367647 */     // GIR_Coverage, 11707,
     /* 367647 */     GIR_EraseRootFromParent_Done,
     /* 367648 */   // Label 5699: @367648
     /* 367648 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(367777), // Rule ID 11708 //
     /* 367653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367697 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367702 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367734 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367775 */     GIR_RootConstrainSelectedInstOperands,
     /* 367776 */     // GIR_Coverage, 11708,
     /* 367776 */     GIR_EraseRootFromParent_Done,
     /* 367777 */   // Label 5700: @367777
     /* 367777 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(367906), // Rule ID 11709 //
     /* 367782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367863 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367904 */     GIR_RootConstrainSelectedInstOperands,
     /* 367905 */     // GIR_Coverage, 11709,
     /* 367905 */     GIR_EraseRootFromParent_Done,
     /* 367906 */   // Label 5701: @367906
     /* 367906 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(368035), // Rule ID 11751 //
     /* 367911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367955 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367960 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367992 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368033 */     GIR_RootConstrainSelectedInstOperands,
     /* 368034 */     // GIR_Coverage, 11751,
     /* 368034 */     GIR_EraseRootFromParent_Done,
     /* 368035 */   // Label 5702: @368035
     /* 368035 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(368164), // Rule ID 11752 //
     /* 368040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368121 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368162 */     GIR_RootConstrainSelectedInstOperands,
     /* 368163 */     // GIR_Coverage, 11752,
     /* 368163 */     GIR_EraseRootFromParent_Done,
     /* 368164 */   // Label 5703: @368164
     /* 368164 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(368293), // Rule ID 11753 //
     /* 368169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368250 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368291 */     GIR_RootConstrainSelectedInstOperands,
     /* 368292 */     // GIR_Coverage, 11753,
     /* 368292 */     GIR_EraseRootFromParent_Done,
     /* 368293 */   // Label 5704: @368293
     /* 368293 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(368422), // Rule ID 11754 //
     /* 368298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368342 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368347 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368379 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368420 */     GIR_RootConstrainSelectedInstOperands,
     /* 368421 */     // GIR_Coverage, 11754,
     /* 368421 */     GIR_EraseRootFromParent_Done,
     /* 368422 */   // Label 5705: @368422
     /* 368422 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(368551), // Rule ID 11691 //
     /* 368427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368508 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368549 */     GIR_RootConstrainSelectedInstOperands,
     /* 368550 */     // GIR_Coverage, 11691,
     /* 368550 */     GIR_EraseRootFromParent_Done,
     /* 368551 */   // Label 5706: @368551
     /* 368551 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(368680), // Rule ID 11692 //
     /* 368556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368600 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368605 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368637 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368678 */     GIR_RootConstrainSelectedInstOperands,
     /* 368679 */     // GIR_Coverage, 11692,
     /* 368679 */     GIR_EraseRootFromParent_Done,
     /* 368680 */   // Label 5707: @368680
     /* 368680 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(368809), // Rule ID 11693 //
     /* 368685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368766 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368807 */     GIR_RootConstrainSelectedInstOperands,
     /* 368808 */     // GIR_Coverage, 11693,
     /* 368808 */     GIR_EraseRootFromParent_Done,
     /* 368809 */   // Label 5708: @368809
     /* 368809 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(368938), // Rule ID 11694 //
     /* 368814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368895 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368936 */     GIR_RootConstrainSelectedInstOperands,
     /* 368937 */     // GIR_Coverage, 11694,
     /* 368937 */     GIR_EraseRootFromParent_Done,
     /* 368938 */   // Label 5709: @368938
     /* 368938 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(369067), // Rule ID 11762 //
     /* 368943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368987 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368992 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369024 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369065 */     GIR_RootConstrainSelectedInstOperands,
     /* 369066 */     // GIR_Coverage, 11762,
     /* 369066 */     GIR_EraseRootFromParent_Done,
     /* 369067 */   // Label 5710: @369067
     /* 369067 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(369196), // Rule ID 11763 //
     /* 369072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369153 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369194 */     GIR_RootConstrainSelectedInstOperands,
     /* 369195 */     // GIR_Coverage, 11763,
     /* 369195 */     GIR_EraseRootFromParent_Done,
     /* 369196 */   // Label 5711: @369196
     /* 369196 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(369325), // Rule ID 11764 //
     /* 369201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369245 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369250 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369282 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369323 */     GIR_RootConstrainSelectedInstOperands,
     /* 369324 */     // GIR_Coverage, 11764,
     /* 369324 */     GIR_EraseRootFromParent_Done,
     /* 369325 */   // Label 5712: @369325
     /* 369325 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(369454), // Rule ID 11765 //
     /* 369330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369411 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369452 */     GIR_RootConstrainSelectedInstOperands,
     /* 369453 */     // GIR_Coverage, 11765,
     /* 369453 */     GIR_EraseRootFromParent_Done,
     /* 369454 */   // Label 5713: @369454
     /* 369454 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(369583), // Rule ID 11702 //
     /* 369459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369540 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369581 */     GIR_RootConstrainSelectedInstOperands,
     /* 369582 */     // GIR_Coverage, 11702,
     /* 369582 */     GIR_EraseRootFromParent_Done,
     /* 369583 */   // Label 5714: @369583
     /* 369583 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(369712), // Rule ID 11703 //
     /* 369588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369632 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369637 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369669 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369710 */     GIR_RootConstrainSelectedInstOperands,
     /* 369711 */     // GIR_Coverage, 11703,
     /* 369711 */     GIR_EraseRootFromParent_Done,
     /* 369712 */   // Label 5715: @369712
     /* 369712 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(369841), // Rule ID 11704 //
     /* 369717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369798 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369839 */     GIR_RootConstrainSelectedInstOperands,
     /* 369840 */     // GIR_Coverage, 11704,
     /* 369840 */     GIR_EraseRootFromParent_Done,
     /* 369841 */   // Label 5716: @369841
     /* 369841 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(369970), // Rule ID 11705 //
     /* 369846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369890 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369895 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369927 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369968 */     GIR_RootConstrainSelectedInstOperands,
     /* 369969 */     // GIR_Coverage, 11705,
     /* 369969 */     GIR_EraseRootFromParent_Done,
     /* 369970 */   // Label 5717: @369970
     /* 369970 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(370099), // Rule ID 11747 //
     /* 369975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370056 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370097 */     GIR_RootConstrainSelectedInstOperands,
     /* 370098 */     // GIR_Coverage, 11747,
     /* 370098 */     GIR_EraseRootFromParent_Done,
     /* 370099 */   // Label 5718: @370099
     /* 370099 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(370228), // Rule ID 11748 //
     /* 370104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370185 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370226 */     GIR_RootConstrainSelectedInstOperands,
     /* 370227 */     // GIR_Coverage, 11748,
     /* 370227 */     GIR_EraseRootFromParent_Done,
     /* 370228 */   // Label 5719: @370228
     /* 370228 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(370357), // Rule ID 11749 //
     /* 370233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370277 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370282 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370314 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370355 */     GIR_RootConstrainSelectedInstOperands,
     /* 370356 */     // GIR_Coverage, 11749,
     /* 370356 */     GIR_EraseRootFromParent_Done,
     /* 370357 */   // Label 5720: @370357
     /* 370357 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(370486), // Rule ID 11750 //
     /* 370362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370443 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370484 */     GIR_RootConstrainSelectedInstOperands,
     /* 370485 */     // GIR_Coverage, 11750,
     /* 370485 */     GIR_EraseRootFromParent_Done,
     /* 370486 */   // Label 5721: @370486
     /* 370486 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(370615), // Rule ID 11687 //
     /* 370491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370535 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370540 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370572 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370613 */     GIR_RootConstrainSelectedInstOperands,
     /* 370614 */     // GIR_Coverage, 11687,
     /* 370614 */     GIR_EraseRootFromParent_Done,
     /* 370615 */   // Label 5722: @370615
     /* 370615 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(370744), // Rule ID 11688 //
     /* 370620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370701 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370742 */     GIR_RootConstrainSelectedInstOperands,
     /* 370743 */     // GIR_Coverage, 11688,
     /* 370743 */     GIR_EraseRootFromParent_Done,
     /* 370744 */   // Label 5723: @370744
     /* 370744 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(370873), // Rule ID 11689 //
     /* 370749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370830 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370871 */     GIR_RootConstrainSelectedInstOperands,
     /* 370872 */     // GIR_Coverage, 11689,
     /* 370872 */     GIR_EraseRootFromParent_Done,
     /* 370873 */   // Label 5724: @370873
     /* 370873 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(371002), // Rule ID 11690 //
     /* 370878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370922 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370927 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370959 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371000 */     GIR_RootConstrainSelectedInstOperands,
     /* 371001 */     // GIR_Coverage, 11690,
     /* 371001 */     GIR_EraseRootFromParent_Done,
     /* 371002 */   // Label 5725: @371002
     /* 371002 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(371131), // Rule ID 11696 //
     /* 371007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371088 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371129 */     GIR_RootConstrainSelectedInstOperands,
     /* 371130 */     // GIR_Coverage, 11696,
     /* 371130 */     GIR_EraseRootFromParent_Done,
     /* 371131 */   // Label 5726: @371131
     /* 371131 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(371260), // Rule ID 11697 //
     /* 371136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371180 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371185 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371217 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371258 */     GIR_RootConstrainSelectedInstOperands,
     /* 371259 */     // GIR_Coverage, 11697,
     /* 371259 */     GIR_EraseRootFromParent_Done,
     /* 371260 */   // Label 5727: @371260
     /* 371260 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(371389), // Rule ID 11700 //
     /* 371265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371346 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371387 */     GIR_RootConstrainSelectedInstOperands,
     /* 371388 */     // GIR_Coverage, 11700,
     /* 371388 */     GIR_EraseRootFromParent_Done,
     /* 371389 */   // Label 5728: @371389
     /* 371389 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(371518), // Rule ID 11701 //
     /* 371394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371438 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371443 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371475 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371516 */     GIR_RootConstrainSelectedInstOperands,
     /* 371517 */     // GIR_Coverage, 11701,
     /* 371517 */     GIR_EraseRootFromParent_Done,
     /* 371518 */   // Label 5729: @371518
     /* 371518 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(371647), // Rule ID 11681 //
     /* 371523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371567 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371572 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371604 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371645 */     GIR_RootConstrainSelectedInstOperands,
     /* 371646 */     // GIR_Coverage, 11681,
     /* 371646 */     GIR_EraseRootFromParent_Done,
     /* 371647 */   // Label 5730: @371647
     /* 371647 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(371776), // Rule ID 11682 //
     /* 371652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371733 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371774 */     GIR_RootConstrainSelectedInstOperands,
     /* 371775 */     // GIR_Coverage, 11682,
     /* 371775 */     GIR_EraseRootFromParent_Done,
     /* 371776 */   // Label 5731: @371776
     /* 371776 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(371905), // Rule ID 11685 //
     /* 371781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371825 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371830 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371862 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371903 */     GIR_RootConstrainSelectedInstOperands,
     /* 371904 */     // GIR_Coverage, 11685,
     /* 371904 */     GIR_EraseRootFromParent_Done,
     /* 371905 */   // Label 5732: @371905
     /* 371905 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(372034), // Rule ID 11686 //
     /* 371910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371991 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372032 */     GIR_RootConstrainSelectedInstOperands,
     /* 372033 */     // GIR_Coverage, 11686,
     /* 372033 */     GIR_EraseRootFromParent_Done,
     /* 372034 */   // Label 5733: @372034
     /* 372034 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(372163), // Rule ID 7611 //
     /* 372039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372088 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372120 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372161 */     GIR_RootConstrainSelectedInstOperands,
     /* 372162 */     // GIR_Coverage, 7611,
     /* 372162 */     GIR_EraseRootFromParent_Done,
     /* 372163 */   // Label 5734: @372163
     /* 372163 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(372292), // Rule ID 11695 //
     /* 372168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372212 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372217 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372249 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372290 */     GIR_RootConstrainSelectedInstOperands,
     /* 372291 */     // GIR_Coverage, 11695,
     /* 372291 */     GIR_EraseRootFromParent_Done,
     /* 372292 */   // Label 5735: @372292
     /* 372292 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(372421), // Rule ID 11698 //
     /* 372297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372378 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372419 */     GIR_RootConstrainSelectedInstOperands,
     /* 372420 */     // GIR_Coverage, 11698,
     /* 372420 */     GIR_EraseRootFromParent_Done,
     /* 372421 */   // Label 5736: @372421
     /* 372421 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(372550), // Rule ID 11699 //
     /* 372426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372470 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372475 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372507 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372548 */     GIR_RootConstrainSelectedInstOperands,
     /* 372549 */     // GIR_Coverage, 11699,
     /* 372549 */     GIR_EraseRootFromParent_Done,
     /* 372550 */   // Label 5737: @372550
     /* 372550 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(372679), // Rule ID 7610 //
     /* 372555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372636 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372677 */     GIR_RootConstrainSelectedInstOperands,
     /* 372678 */     // GIR_Coverage, 7610,
     /* 372678 */     GIR_EraseRootFromParent_Done,
     /* 372679 */   // Label 5738: @372679
     /* 372679 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(372808), // Rule ID 11680 //
     /* 372684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372765 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372806 */     GIR_RootConstrainSelectedInstOperands,
     /* 372807 */     // GIR_Coverage, 11680,
     /* 372807 */     GIR_EraseRootFromParent_Done,
     /* 372808 */   // Label 5739: @372808
     /* 372808 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(372937), // Rule ID 11683 //
     /* 372813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372857 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372862 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372894 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372935 */     GIR_RootConstrainSelectedInstOperands,
     /* 372936 */     // GIR_Coverage, 11683,
     /* 372936 */     GIR_EraseRootFromParent_Done,
     /* 372937 */   // Label 5740: @372937
     /* 372937 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(373066), // Rule ID 11684 //
     /* 372942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373023 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373064 */     GIR_RootConstrainSelectedInstOperands,
     /* 373065 */     // GIR_Coverage, 11684,
     /* 373065 */     GIR_EraseRootFromParent_Done,
     /* 373066 */   // Label 5741: @373066
     /* 373066 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(373195), // Rule ID 11666 //
     /* 373071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373115 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373120 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373152 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373193 */     GIR_RootConstrainSelectedInstOperands,
     /* 373194 */     // GIR_Coverage, 11666,
     /* 373194 */     GIR_EraseRootFromParent_Done,
     /* 373195 */   // Label 5742: @373195
     /* 373195 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(373324), // Rule ID 11667 //
     /* 373200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373281 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373322 */     GIR_RootConstrainSelectedInstOperands,
     /* 373323 */     // GIR_Coverage, 11667,
     /* 373323 */     GIR_EraseRootFromParent_Done,
     /* 373324 */   // Label 5743: @373324
     /* 373324 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(373453), // Rule ID 11670 //
     /* 373329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373410 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373451 */     GIR_RootConstrainSelectedInstOperands,
     /* 373452 */     // GIR_Coverage, 11670,
     /* 373452 */     GIR_EraseRootFromParent_Done,
     /* 373453 */   // Label 5744: @373453
     /* 373453 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(373582), // Rule ID 11671 //
     /* 373458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373502 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373507 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373539 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373580 */     GIR_RootConstrainSelectedInstOperands,
     /* 373581 */     // GIR_Coverage, 11671,
     /* 373581 */     GIR_EraseRootFromParent_Done,
     /* 373582 */   // Label 5745: @373582
     /* 373582 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(373711), // Rule ID 11651 //
     /* 373587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373668 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373709 */     GIR_RootConstrainSelectedInstOperands,
     /* 373710 */     // GIR_Coverage, 11651,
     /* 373710 */     GIR_EraseRootFromParent_Done,
     /* 373711 */   // Label 5746: @373711
     /* 373711 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(373840), // Rule ID 11652 //
     /* 373716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373760 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373765 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373797 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373838 */     GIR_RootConstrainSelectedInstOperands,
     /* 373839 */     // GIR_Coverage, 11652,
     /* 373839 */     GIR_EraseRootFromParent_Done,
     /* 373840 */   // Label 5747: @373840
     /* 373840 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(373969), // Rule ID 11655 //
     /* 373845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373926 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373967 */     GIR_RootConstrainSelectedInstOperands,
     /* 373968 */     // GIR_Coverage, 11655,
     /* 373968 */     GIR_EraseRootFromParent_Done,
     /* 373969 */   // Label 5748: @373969
     /* 373969 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(374098), // Rule ID 11656 //
     /* 373974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374055 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374096 */     GIR_RootConstrainSelectedInstOperands,
     /* 374097 */     // GIR_Coverage, 11656,
     /* 374097 */     GIR_EraseRootFromParent_Done,
     /* 374098 */   // Label 5749: @374098
     /* 374098 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(374227), // Rule ID 7609 //
     /* 374103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374147 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374152 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374184 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374225 */     GIR_RootConstrainSelectedInstOperands,
     /* 374226 */     // GIR_Coverage, 7609,
     /* 374226 */     GIR_EraseRootFromParent_Done,
     /* 374227 */   // Label 5750: @374227
     /* 374227 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(374356), // Rule ID 11665 //
     /* 374232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374313 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374354 */     GIR_RootConstrainSelectedInstOperands,
     /* 374355 */     // GIR_Coverage, 11665,
     /* 374355 */     GIR_EraseRootFromParent_Done,
     /* 374356 */   // Label 5751: @374356
     /* 374356 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(374485), // Rule ID 11668 //
     /* 374361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374405 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374410 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374442 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374483 */     GIR_RootConstrainSelectedInstOperands,
     /* 374484 */     // GIR_Coverage, 11668,
     /* 374484 */     GIR_EraseRootFromParent_Done,
     /* 374485 */   // Label 5752: @374485
     /* 374485 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(374614), // Rule ID 11669 //
     /* 374490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374571 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374612 */     GIR_RootConstrainSelectedInstOperands,
     /* 374613 */     // GIR_Coverage, 11669,
     /* 374613 */     GIR_EraseRootFromParent_Done,
     /* 374614 */   // Label 5753: @374614
     /* 374614 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(374743), // Rule ID 7608 //
     /* 374619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374663 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374700 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374741 */     GIR_RootConstrainSelectedInstOperands,
     /* 374742 */     // GIR_Coverage, 7608,
     /* 374742 */     GIR_EraseRootFromParent_Done,
     /* 374743 */   // Label 5754: @374743
     /* 374743 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(374872), // Rule ID 11650 //
     /* 374748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374792 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374797 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374829 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374870 */     GIR_RootConstrainSelectedInstOperands,
     /* 374871 */     // GIR_Coverage, 11650,
     /* 374871 */     GIR_EraseRootFromParent_Done,
     /* 374872 */   // Label 5755: @374872
     /* 374872 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(375001), // Rule ID 11653 //
     /* 374877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374958 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374999 */     GIR_RootConstrainSelectedInstOperands,
     /* 375000 */     // GIR_Coverage, 11653,
     /* 375000 */     GIR_EraseRootFromParent_Done,
     /* 375001 */   // Label 5756: @375001
     /* 375001 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(375130), // Rule ID 11654 //
     /* 375006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 375046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375050 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375055 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375087 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 375107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 375112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375128 */     GIR_RootConstrainSelectedInstOperands,
     /* 375129 */     // GIR_Coverage, 11654,
     /* 375129 */     GIR_EraseRootFromParent_Done,
     /* 375130 */   // Label 5757: @375130
     /* 375130 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(375259), // Rule ID 11736 //
     /* 375135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375216 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375257 */     GIR_RootConstrainSelectedInstOperands,
     /* 375258 */     // GIR_Coverage, 11736,
     /* 375258 */     GIR_EraseRootFromParent_Done,
     /* 375259 */   // Label 5758: @375259
     /* 375259 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(375388), // Rule ID 11737 //
     /* 375264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375345 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375386 */     GIR_RootConstrainSelectedInstOperands,
     /* 375387 */     // GIR_Coverage, 11737,
     /* 375387 */     GIR_EraseRootFromParent_Done,
     /* 375388 */   // Label 5759: @375388
     /* 375388 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(375517), // Rule ID 11738 //
     /* 375393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375437 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375442 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375474 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375515 */     GIR_RootConstrainSelectedInstOperands,
     /* 375516 */     // GIR_Coverage, 11738,
     /* 375516 */     GIR_EraseRootFromParent_Done,
     /* 375517 */   // Label 5760: @375517
     /* 375517 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(375646), // Rule ID 11739 //
     /* 375522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375603 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375644 */     GIR_RootConstrainSelectedInstOperands,
     /* 375645 */     // GIR_Coverage, 11739,
     /* 375645 */     GIR_EraseRootFromParent_Done,
     /* 375646 */   // Label 5761: @375646
     /* 375646 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(375775), // Rule ID 11676 //
     /* 375651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375695 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375700 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375732 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375773 */     GIR_RootConstrainSelectedInstOperands,
     /* 375774 */     // GIR_Coverage, 11676,
     /* 375774 */     GIR_EraseRootFromParent_Done,
     /* 375775 */   // Label 5762: @375775
     /* 375775 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(375904), // Rule ID 11677 //
     /* 375780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375861 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375902 */     GIR_RootConstrainSelectedInstOperands,
     /* 375903 */     // GIR_Coverage, 11677,
     /* 375903 */     GIR_EraseRootFromParent_Done,
     /* 375904 */   // Label 5763: @375904
     /* 375904 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(376033), // Rule ID 11678 //
     /* 375909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375953 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375990 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376031 */     GIR_RootConstrainSelectedInstOperands,
     /* 376032 */     // GIR_Coverage, 11678,
     /* 376032 */     GIR_EraseRootFromParent_Done,
     /* 376033 */   // Label 5764: @376033
     /* 376033 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(376162), // Rule ID 11679 //
     /* 376038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376082 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376087 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376119 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376160 */     GIR_RootConstrainSelectedInstOperands,
     /* 376161 */     // GIR_Coverage, 11679,
     /* 376161 */     GIR_EraseRootFromParent_Done,
     /* 376162 */   // Label 5765: @376162
     /* 376162 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(376291), // Rule ID 11721 //
     /* 376167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376248 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376289 */     GIR_RootConstrainSelectedInstOperands,
     /* 376290 */     // GIR_Coverage, 11721,
     /* 376290 */     GIR_EraseRootFromParent_Done,
     /* 376291 */   // Label 5766: @376291
     /* 376291 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(376420), // Rule ID 11722 //
     /* 376296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376340 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376345 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376377 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376418 */     GIR_RootConstrainSelectedInstOperands,
     /* 376419 */     // GIR_Coverage, 11722,
     /* 376419 */     GIR_EraseRootFromParent_Done,
     /* 376420 */   // Label 5767: @376420
     /* 376420 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(376549), // Rule ID 11723 //
     /* 376425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376506 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376547 */     GIR_RootConstrainSelectedInstOperands,
     /* 376548 */     // GIR_Coverage, 11723,
     /* 376548 */     GIR_EraseRootFromParent_Done,
     /* 376549 */   // Label 5768: @376549
     /* 376549 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(376678), // Rule ID 11724 //
     /* 376554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376635 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376676 */     GIR_RootConstrainSelectedInstOperands,
     /* 376677 */     // GIR_Coverage, 11724,
     /* 376677 */     GIR_EraseRootFromParent_Done,
     /* 376678 */   // Label 5769: @376678
     /* 376678 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(376807), // Rule ID 11661 //
     /* 376683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376727 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376732 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376764 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376805 */     GIR_RootConstrainSelectedInstOperands,
     /* 376806 */     // GIR_Coverage, 11661,
     /* 376806 */     GIR_EraseRootFromParent_Done,
     /* 376807 */   // Label 5770: @376807
     /* 376807 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(376936), // Rule ID 11662 //
     /* 376812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376893 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376934 */     GIR_RootConstrainSelectedInstOperands,
     /* 376935 */     // GIR_Coverage, 11662,
     /* 376935 */     GIR_EraseRootFromParent_Done,
     /* 376936 */   // Label 5771: @376936
     /* 376936 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(377065), // Rule ID 11663 //
     /* 376941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376985 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376990 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377022 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 377032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 377037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 377052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 377057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377063 */     GIR_RootConstrainSelectedInstOperands,
     /* 377064 */     // GIR_Coverage, 11663,
     /* 377064 */     GIR_EraseRootFromParent_Done,
     /* 377065 */   // Label 5772: @377065
     /* 377065 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(377194), // Rule ID 11664 //
     /* 377070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 377098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377151 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 377161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 377166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 377181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 377186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377192 */     GIR_RootConstrainSelectedInstOperands,
     /* 377193 */     // GIR_Coverage, 11664,
     /* 377193 */     GIR_EraseRootFromParent_Done,
     /* 377194 */   // Label 5773: @377194
     /* 377194 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(377323), // Rule ID 11732 //
     /* 377199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377280 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377321 */     GIR_RootConstrainSelectedInstOperands,
     /* 377322 */     // GIR_Coverage, 11732,
     /* 377322 */     GIR_EraseRootFromParent_Done,
     /* 377323 */   // Label 5774: @377323
     /* 377323 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(377452), // Rule ID 11733 //
     /* 377328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377372 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377377 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377409 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377450 */     GIR_RootConstrainSelectedInstOperands,
     /* 377451 */     // GIR_Coverage, 11733,
     /* 377451 */     GIR_EraseRootFromParent_Done,
     /* 377452 */   // Label 5775: @377452
     /* 377452 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(377581), // Rule ID 11734 //
     /* 377457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377538 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377579 */     GIR_RootConstrainSelectedInstOperands,
     /* 377580 */     // GIR_Coverage, 11734,
     /* 377580 */     GIR_EraseRootFromParent_Done,
     /* 377581 */   // Label 5776: @377581
     /* 377581 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(377710), // Rule ID 11735 //
     /* 377586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377630 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377635 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377667 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377708 */     GIR_RootConstrainSelectedInstOperands,
     /* 377709 */     // GIR_Coverage, 11735,
     /* 377709 */     GIR_EraseRootFromParent_Done,
     /* 377710 */   // Label 5777: @377710
     /* 377710 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(377839), // Rule ID 11672 //
     /* 377715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377796 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377837 */     GIR_RootConstrainSelectedInstOperands,
     /* 377838 */     // GIR_Coverage, 11672,
     /* 377838 */     GIR_EraseRootFromParent_Done,
     /* 377839 */   // Label 5778: @377839
     /* 377839 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(377968), // Rule ID 11673 //
     /* 377844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377925 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377966 */     GIR_RootConstrainSelectedInstOperands,
     /* 377967 */     // GIR_Coverage, 11673,
     /* 377967 */     GIR_EraseRootFromParent_Done,
     /* 377968 */   // Label 5779: @377968
     /* 377968 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(378097), // Rule ID 11674 //
     /* 377973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378017 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378022 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378054 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378095 */     GIR_RootConstrainSelectedInstOperands,
     /* 378096 */     // GIR_Coverage, 11674,
     /* 378096 */     GIR_EraseRootFromParent_Done,
     /* 378097 */   // Label 5780: @378097
     /* 378097 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(378226), // Rule ID 11675 //
     /* 378102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378183 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378224 */     GIR_RootConstrainSelectedInstOperands,
     /* 378225 */     // GIR_Coverage, 11675,
     /* 378225 */     GIR_EraseRootFromParent_Done,
     /* 378226 */   // Label 5781: @378226
     /* 378226 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(378355), // Rule ID 11717 //
     /* 378231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378275 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378280 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378312 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378353 */     GIR_RootConstrainSelectedInstOperands,
     /* 378354 */     // GIR_Coverage, 11717,
     /* 378354 */     GIR_EraseRootFromParent_Done,
     /* 378355 */   // Label 5782: @378355
     /* 378355 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(378484), // Rule ID 11718 //
     /* 378360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378441 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378482 */     GIR_RootConstrainSelectedInstOperands,
     /* 378483 */     // GIR_Coverage, 11718,
     /* 378483 */     GIR_EraseRootFromParent_Done,
     /* 378484 */   // Label 5783: @378484
     /* 378484 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(378613), // Rule ID 11719 //
     /* 378489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378533 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378570 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378611 */     GIR_RootConstrainSelectedInstOperands,
     /* 378612 */     // GIR_Coverage, 11719,
     /* 378612 */     GIR_EraseRootFromParent_Done,
     /* 378613 */   // Label 5784: @378613
     /* 378613 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(378742), // Rule ID 11720 //
     /* 378618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378662 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378667 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378699 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378740 */     GIR_RootConstrainSelectedInstOperands,
     /* 378741 */     // GIR_Coverage, 11720,
     /* 378741 */     GIR_EraseRootFromParent_Done,
     /* 378742 */   // Label 5785: @378742
     /* 378742 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(378871), // Rule ID 11657 //
     /* 378747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378828 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378869 */     GIR_RootConstrainSelectedInstOperands,
     /* 378870 */     // GIR_Coverage, 11657,
     /* 378870 */     GIR_EraseRootFromParent_Done,
     /* 378871 */   // Label 5786: @378871
     /* 378871 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(379000), // Rule ID 11658 //
     /* 378876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378920 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378925 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378957 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378998 */     GIR_RootConstrainSelectedInstOperands,
     /* 378999 */     // GIR_Coverage, 11658,
     /* 378999 */     GIR_EraseRootFromParent_Done,
     /* 379000 */   // Label 5787: @379000
     /* 379000 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(379129), // Rule ID 11659 //
     /* 379005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 379033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379086 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 379106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 379111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379127 */     GIR_RootConstrainSelectedInstOperands,
     /* 379128 */     // GIR_Coverage, 11659,
     /* 379128 */     GIR_EraseRootFromParent_Done,
     /* 379129 */   // Label 5788: @379129
     /* 379129 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(379258), // Rule ID 11660 //
     /* 379134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 379162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379178 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379215 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 379235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 379240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379256 */     GIR_RootConstrainSelectedInstOperands,
     /* 379257 */     // GIR_Coverage, 11660,
     /* 379257 */     GIR_EraseRootFromParent_Done,
     /* 379258 */   // Label 5789: @379258
     /* 379258 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(379370), // Rule ID 13259 //
     /* 379263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379298 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379300 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 379304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379327 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379368 */     GIR_RootConstrainSelectedInstOperands,
     /* 379369 */     // GIR_Coverage, 13259,
     /* 379369 */     GIR_EraseRootFromParent_Done,
     /* 379370 */   // Label 5790: @379370
     /* 379370 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(379482), // Rule ID 13258 //
     /* 379375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379410 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379412 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 379416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379439 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379480 */     GIR_RootConstrainSelectedInstOperands,
     /* 379481 */     // GIR_Coverage, 13258,
     /* 379481 */     GIR_EraseRootFromParent_Done,
     /* 379482 */   // Label 5791: @379482
     /* 379482 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(379594), // Rule ID 7733 //
     /* 379487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379522 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379524 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 379528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379551 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379592 */     GIR_RootConstrainSelectedInstOperands,
     /* 379593 */     // GIR_Coverage, 7733,
     /* 379593 */     GIR_EraseRootFromParent_Done,
     /* 379594 */   // Label 5792: @379594
     /* 379594 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(379706), // Rule ID 7732 //
     /* 379599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379634 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379636 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 379640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379663 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379704 */     GIR_RootConstrainSelectedInstOperands,
     /* 379705 */     // GIR_Coverage, 7732,
     /* 379705 */     GIR_EraseRootFromParent_Done,
     /* 379706 */   // Label 5793: @379706
     /* 379706 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(379802), // Rule ID 13251 //
     /* 379711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379734 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379759 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379800 */     GIR_RootConstrainSelectedInstOperands,
     /* 379801 */     // GIR_Coverage, 13251,
     /* 379801 */     GIR_EraseRootFromParent_Done,
     /* 379802 */   // Label 5794: @379802
     /* 379802 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(379898), // Rule ID 13250 //
     /* 379807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379830 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379855 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379896 */     GIR_RootConstrainSelectedInstOperands,
     /* 379897 */     // GIR_Coverage, 13250,
     /* 379897 */     GIR_EraseRootFromParent_Done,
     /* 379898 */   // Label 5795: @379898
     /* 379898 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(379994), // Rule ID 7725 //
     /* 379903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379926 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379951 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379992 */     GIR_RootConstrainSelectedInstOperands,
     /* 379993 */     // GIR_Coverage, 7725,
     /* 379993 */     GIR_EraseRootFromParent_Done,
     /* 379994 */   // Label 5796: @379994
     /* 379994 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(380090), // Rule ID 7724 //
     /* 379999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 380002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380022 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 380024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380047 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 380050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380088 */     GIR_RootConstrainSelectedInstOperands,
     /* 380089 */     // GIR_Coverage, 7724,
     /* 380089 */     GIR_EraseRootFromParent_Done,
     /* 380090 */   // Label 5797: @380090
     /* 380090 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(380125), // Rule ID 91 //
     /* 380095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 380098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 380102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 380106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 380110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13765),
     /* 380114 */     // (fminnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13765>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 380114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 380119 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 380123 */     GIR_RootConstrainSelectedInstOperands,
     /* 380124 */     // GIR_Coverage, 91,
     /* 380124 */     GIR_Done,
     /* 380125 */   // Label 5798: @380125
     /* 380125 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(380185), // Rule ID 801 //
     /* 380130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380148 */     // (fminnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 380151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 380178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 380183 */     GIR_RootConstrainSelectedInstOperands,
     /* 380184 */     // GIR_Coverage, 801,
     /* 380184 */     GIR_EraseRootFromParent_Done,
     /* 380185 */   // Label 5799: @380185
     /* 380185 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(380245), // Rule ID 8425 //
     /* 380190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380208 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 380211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 380218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 380228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 380238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 380243 */     GIR_RootConstrainSelectedInstOperands,
     /* 380244 */     // GIR_Coverage, 8425,
     /* 380244 */     GIR_EraseRootFromParent_Done,
     /* 380245 */   // Label 5800: @380245
     /* 380245 */   GIM_Reject,
     /* 380246 */ // Label 5661: @380246
     /* 380246 */ GIM_Reject,
     /* 380247 */ // Label 5251: @380247
     /* 380247 */ GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(380499),
     /* 380252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 380255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 380258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 380262 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(380321), // Rule ID 916 //
     /* 380267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 380270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380284 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 380287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 380314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 380319 */     GIR_RootConstrainSelectedInstOperands,
     /* 380320 */     // GIR_Coverage, 916,
     /* 380320 */     GIR_EraseRootFromParent_Done,
     /* 380321 */   // Label 5802: @380321
     /* 380321 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(380380), // Rule ID 935 //
     /* 380326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 380329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380343 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 380346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 380373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 380378 */     GIR_RootConstrainSelectedInstOperands,
     /* 380379 */     // GIR_Coverage, 935,
     /* 380379 */     GIR_EraseRootFromParent_Done,
     /* 380380 */   // Label 5803: @380380
     /* 380380 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(380439), // Rule ID 8451 //
     /* 380385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 380388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380402 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 380405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 380412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 380422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 380432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 380437 */     GIR_RootConstrainSelectedInstOperands,
     /* 380438 */     // GIR_Coverage, 8451,
     /* 380438 */     GIR_EraseRootFromParent_Done,
     /* 380439 */   // Label 5804: @380439
     /* 380439 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(380498), // Rule ID 8465 //
     /* 380444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 380447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380461 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 380464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 380471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 380481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 380491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 380496 */     GIR_RootConstrainSelectedInstOperands,
     /* 380497 */     // GIR_Coverage, 8465,
     /* 380497 */     GIR_EraseRootFromParent_Done,
     /* 380498 */   // Label 5805: @380498
     /* 380498 */   GIM_Reject,
     /* 380499 */ // Label 5801: @380499
     /* 380499 */ GIM_Reject,
     /* 380500 */ // Label 5252: @380500
     /* 380500 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(380571), // Rule ID 1097 //
     /* 380505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 380508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 380511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 380522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 380529 */   // (fminnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 380529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 380532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380569 */   GIR_RootConstrainSelectedInstOperands,
     /* 380570 */   // GIR_Coverage, 1097,
     /* 380570 */   GIR_EraseRootFromParent_Done,
     /* 380571 */ // Label 5806: @380571
     /* 380571 */ GIM_Reject,
     /* 380572 */ // Label 5253: @380572
     /* 380572 */ GIM_Reject,
     /* 380573 */ // Label 81: @380573
     /* 380573 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5811*/ GIMT_Encode4(452351),
     /* 380584 */ /*GILLT_s16*//*Label 5807*/ GIMT_Encode4(380600),
     /* 380588 */ /*GILLT_s32*//*Label 5808*/ GIMT_Encode4(434514),
     /* 380592 */ /*GILLT_s64*//*Label 5809*/ GIMT_Encode4(452026),
     /* 380596 */ /*GILLT_v2s16*//*Label 5810*/ GIMT_Encode4(452279),
     /* 380600 */ // Label 5807: @380600
     /* 380600 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(434513),
     /* 380605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380611 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(380746), // Rule ID 12026 //
     /* 380616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380663 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380700 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380744 */     GIR_RootConstrainSelectedInstOperands,
     /* 380745 */     // GIR_Coverage, 12026,
     /* 380745 */     GIR_EraseRootFromParent_Done,
     /* 380746 */   // Label 5813: @380746
     /* 380746 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(380881), // Rule ID 12027 //
     /* 380751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380835 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380879 */     GIR_RootConstrainSelectedInstOperands,
     /* 380880 */     // GIR_Coverage, 12027,
     /* 380880 */     GIR_EraseRootFromParent_Done,
     /* 380881 */   // Label 5814: @380881
     /* 380881 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(381016), // Rule ID 12030 //
     /* 380886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380970 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 380990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381014 */     GIR_RootConstrainSelectedInstOperands,
     /* 381015 */     // GIR_Coverage, 12030,
     /* 381015 */     GIR_EraseRootFromParent_Done,
     /* 381016 */   // Label 5815: @381016
     /* 381016 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(381151), // Rule ID 12031 //
     /* 381021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 381024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381068 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381073 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381105 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 381108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381149 */     GIR_RootConstrainSelectedInstOperands,
     /* 381150 */     // GIR_Coverage, 12031,
     /* 381150 */     GIR_EraseRootFromParent_Done,
     /* 381151 */   // Label 5816: @381151
     /* 381151 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(381286), // Rule ID 12506 //
     /* 381156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381203 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381208 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381240 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381284 */     GIR_RootConstrainSelectedInstOperands,
     /* 381285 */     // GIR_Coverage, 12506,
     /* 381285 */     GIR_EraseRootFromParent_Done,
     /* 381286 */   // Label 5817: @381286
     /* 381286 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(381421), // Rule ID 12507 //
     /* 381291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381338 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381375 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381419 */     GIR_RootConstrainSelectedInstOperands,
     /* 381420 */     // GIR_Coverage, 12507,
     /* 381420 */     GIR_EraseRootFromParent_Done,
     /* 381421 */   // Label 5818: @381421
     /* 381421 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(381556), // Rule ID 12510 //
     /* 381426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381473 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381510 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381554 */     GIR_RootConstrainSelectedInstOperands,
     /* 381555 */     // GIR_Coverage, 12510,
     /* 381555 */     GIR_EraseRootFromParent_Done,
     /* 381556 */   // Label 5819: @381556
     /* 381556 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(381691), // Rule ID 12511 //
     /* 381561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381645 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381689 */     GIR_RootConstrainSelectedInstOperands,
     /* 381690 */     // GIR_Coverage, 12511,
     /* 381690 */     GIR_EraseRootFromParent_Done,
     /* 381691 */   // Label 5820: @381691
     /* 381691 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(381826), // Rule ID 12986 //
     /* 381696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381748 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381780 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381824 */     GIR_RootConstrainSelectedInstOperands,
     /* 381825 */     // GIR_Coverage, 12986,
     /* 381825 */     GIR_EraseRootFromParent_Done,
     /* 381826 */   // Label 5821: @381826
     /* 381826 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(381961), // Rule ID 12987 //
     /* 381831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381878 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381883 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381915 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381959 */     GIR_RootConstrainSelectedInstOperands,
     /* 381960 */     // GIR_Coverage, 12987,
     /* 381960 */     GIR_EraseRootFromParent_Done,
     /* 381961 */   // Label 5822: @381961
     /* 381961 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(382096), // Rule ID 12990 //
     /* 381966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382013 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382050 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 382053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382094 */     GIR_RootConstrainSelectedInstOperands,
     /* 382095 */     // GIR_Coverage, 12990,
     /* 382095 */     GIR_EraseRootFromParent_Done,
     /* 382096 */   // Label 5823: @382096
     /* 382096 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(382231), // Rule ID 12991 //
     /* 382101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 382104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382185 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 382188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382229 */     GIR_RootConstrainSelectedInstOperands,
     /* 382230 */     // GIR_Coverage, 12991,
     /* 382230 */     GIR_EraseRootFromParent_Done,
     /* 382231 */   // Label 5824: @382231
     /* 382231 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(382366), // Rule ID 12011 //
     /* 382236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382320 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382364 */     GIR_RootConstrainSelectedInstOperands,
     /* 382365 */     // GIR_Coverage, 12011,
     /* 382365 */     GIR_EraseRootFromParent_Done,
     /* 382366 */   // Label 5825: @382366
     /* 382366 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(382501), // Rule ID 12012 //
     /* 382371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382423 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382455 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382499 */     GIR_RootConstrainSelectedInstOperands,
     /* 382500 */     // GIR_Coverage, 12012,
     /* 382500 */     GIR_EraseRootFromParent_Done,
     /* 382501 */   // Label 5826: @382501
     /* 382501 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(382636), // Rule ID 12015 //
     /* 382506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382553 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382558 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382590 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382634 */     GIR_RootConstrainSelectedInstOperands,
     /* 382635 */     // GIR_Coverage, 12015,
     /* 382635 */     GIR_EraseRootFromParent_Done,
     /* 382636 */   // Label 5827: @382636
     /* 382636 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(382771), // Rule ID 12016 //
     /* 382641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382688 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382693 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382725 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382769 */     GIR_RootConstrainSelectedInstOperands,
     /* 382770 */     // GIR_Coverage, 12016,
     /* 382770 */     GIR_EraseRootFromParent_Done,
     /* 382771 */   // Label 5828: @382771
     /* 382771 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(382906), // Rule ID 12491 //
     /* 382776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382823 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382860 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382904 */     GIR_RootConstrainSelectedInstOperands,
     /* 382905 */     // GIR_Coverage, 12491,
     /* 382905 */     GIR_EraseRootFromParent_Done,
     /* 382906 */   // Label 5829: @382906
     /* 382906 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(383041), // Rule ID 12492 //
     /* 382911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382995 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383039 */     GIR_RootConstrainSelectedInstOperands,
     /* 383040 */     // GIR_Coverage, 12492,
     /* 383040 */     GIR_EraseRootFromParent_Done,
     /* 383041 */   // Label 5830: @383041
     /* 383041 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(383176), // Rule ID 12495 //
     /* 383046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 383049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 383053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383130 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 383133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383174 */     GIR_RootConstrainSelectedInstOperands,
     /* 383175 */     // GIR_Coverage, 12495,
     /* 383175 */     GIR_EraseRootFromParent_Done,
     /* 383176 */   // Label 5831: @383176
     /* 383176 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(383311), // Rule ID 12496 //
     /* 383181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 383184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 383188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383233 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383265 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 383268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383309 */     GIR_RootConstrainSelectedInstOperands,
     /* 383310 */     // GIR_Coverage, 12496,
     /* 383310 */     GIR_EraseRootFromParent_Done,
     /* 383311 */   // Label 5832: @383311
     /* 383311 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(383446), // Rule ID 12971 //
     /* 383316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383363 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383368 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383400 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383444 */     GIR_RootConstrainSelectedInstOperands,
     /* 383445 */     // GIR_Coverage, 12971,
     /* 383445 */     GIR_EraseRootFromParent_Done,
     /* 383446 */   // Label 5833: @383446
     /* 383446 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(383581), // Rule ID 12972 //
     /* 383451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383498 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383535 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383579 */     GIR_RootConstrainSelectedInstOperands,
     /* 383580 */     // GIR_Coverage, 12972,
     /* 383580 */     GIR_EraseRootFromParent_Done,
     /* 383581 */   // Label 5834: @383581
     /* 383581 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(383716), // Rule ID 12975 //
     /* 383586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383633 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383638 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383670 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383714 */     GIR_RootConstrainSelectedInstOperands,
     /* 383715 */     // GIR_Coverage, 12975,
     /* 383715 */     GIR_EraseRootFromParent_Done,
     /* 383716 */   // Label 5835: @383716
     /* 383716 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(383851), // Rule ID 12976 //
     /* 383721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383768 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383773 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383805 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383849 */     GIR_RootConstrainSelectedInstOperands,
     /* 383850 */     // GIR_Coverage, 12976,
     /* 383850 */     GIR_EraseRootFromParent_Done,
     /* 383851 */   // Label 5836: @383851
     /* 383851 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(383986), // Rule ID 7633 //
     /* 383856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 383859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383908 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383940 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 383943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383984 */     GIR_RootConstrainSelectedInstOperands,
     /* 383985 */     // GIR_Coverage, 7633,
     /* 383985 */     GIR_EraseRootFromParent_Done,
     /* 383986 */   // Label 5837: @383986
     /* 383986 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(384121), // Rule ID 7665 //
     /* 383991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 383994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 383998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384038 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384043 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384075 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384119 */     GIR_RootConstrainSelectedInstOperands,
     /* 384120 */     // GIR_Coverage, 7665,
     /* 384120 */     GIR_EraseRootFromParent_Done,
     /* 384121 */   // Label 5838: @384121
     /* 384121 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(384256), // Rule ID 7697 //
     /* 384126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 384129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384173 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384178 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384210 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 384213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384254 */     GIR_RootConstrainSelectedInstOperands,
     /* 384255 */     // GIR_Coverage, 7697,
     /* 384255 */     GIR_EraseRootFromParent_Done,
     /* 384256 */   // Label 5839: @384256
     /* 384256 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(384391), // Rule ID 12025 //
     /* 384261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384345 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384389 */     GIR_RootConstrainSelectedInstOperands,
     /* 384390 */     // GIR_Coverage, 12025,
     /* 384390 */     GIR_EraseRootFromParent_Done,
     /* 384391 */   // Label 5840: @384391
     /* 384391 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(384526), // Rule ID 12028 //
     /* 384396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384443 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384480 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384524 */     GIR_RootConstrainSelectedInstOperands,
     /* 384525 */     // GIR_Coverage, 12028,
     /* 384525 */     GIR_EraseRootFromParent_Done,
     /* 384526 */   // Label 5841: @384526
     /* 384526 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(384661), // Rule ID 12029 //
     /* 384531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384578 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384583 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384615 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384659 */     GIR_RootConstrainSelectedInstOperands,
     /* 384660 */     // GIR_Coverage, 12029,
     /* 384660 */     GIR_EraseRootFromParent_Done,
     /* 384661 */   // Label 5842: @384661
     /* 384661 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(384796), // Rule ID 12505 //
     /* 384666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384713 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384718 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384750 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384794 */     GIR_RootConstrainSelectedInstOperands,
     /* 384795 */     // GIR_Coverage, 12505,
     /* 384795 */     GIR_EraseRootFromParent_Done,
     /* 384796 */   // Label 5843: @384796
     /* 384796 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(384931), // Rule ID 12508 //
     /* 384801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384848 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384853 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384885 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384929 */     GIR_RootConstrainSelectedInstOperands,
     /* 384930 */     // GIR_Coverage, 12508,
     /* 384930 */     GIR_EraseRootFromParent_Done,
     /* 384931 */   // Label 5844: @384931
     /* 384931 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(385066), // Rule ID 12509 //
     /* 384936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384983 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384988 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385020 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385064 */     GIR_RootConstrainSelectedInstOperands,
     /* 385065 */     // GIR_Coverage, 12509,
     /* 385065 */     GIR_EraseRootFromParent_Done,
     /* 385066 */   // Label 5845: @385066
     /* 385066 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(385201), // Rule ID 12985 //
     /* 385071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385123 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385155 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385199 */     GIR_RootConstrainSelectedInstOperands,
     /* 385200 */     // GIR_Coverage, 12985,
     /* 385200 */     GIR_EraseRootFromParent_Done,
     /* 385201 */   // Label 5846: @385201
     /* 385201 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(385336), // Rule ID 12988 //
     /* 385206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385258 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385290 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385334 */     GIR_RootConstrainSelectedInstOperands,
     /* 385335 */     // GIR_Coverage, 12988,
     /* 385335 */     GIR_EraseRootFromParent_Done,
     /* 385336 */   // Label 5847: @385336
     /* 385336 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(385471), // Rule ID 12989 //
     /* 385341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385388 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385393 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385425 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385469 */     GIR_RootConstrainSelectedInstOperands,
     /* 385470 */     // GIR_Coverage, 12989,
     /* 385470 */     GIR_EraseRootFromParent_Done,
     /* 385471 */   // Label 5848: @385471
     /* 385471 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(385606), // Rule ID 7632 //
     /* 385476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385523 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385528 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385560 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385604 */     GIR_RootConstrainSelectedInstOperands,
     /* 385605 */     // GIR_Coverage, 7632,
     /* 385605 */     GIR_EraseRootFromParent_Done,
     /* 385606 */   // Label 5849: @385606
     /* 385606 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(385741), // Rule ID 7664 //
     /* 385611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385658 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385663 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385695 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385739 */     GIR_RootConstrainSelectedInstOperands,
     /* 385740 */     // GIR_Coverage, 7664,
     /* 385740 */     GIR_EraseRootFromParent_Done,
     /* 385741 */   // Label 5850: @385741
     /* 385741 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(385876), // Rule ID 7696 //
     /* 385746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385830 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385874 */     GIR_RootConstrainSelectedInstOperands,
     /* 385875 */     // GIR_Coverage, 7696,
     /* 385875 */     GIR_EraseRootFromParent_Done,
     /* 385876 */   // Label 5851: @385876
     /* 385876 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(386011), // Rule ID 12010 //
     /* 385881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385965 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386009 */     GIR_RootConstrainSelectedInstOperands,
     /* 386010 */     // GIR_Coverage, 12010,
     /* 386010 */     GIR_EraseRootFromParent_Done,
     /* 386011 */   // Label 5852: @386011
     /* 386011 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(386146), // Rule ID 12013 //
     /* 386016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386063 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386068 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386100 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386144 */     GIR_RootConstrainSelectedInstOperands,
     /* 386145 */     // GIR_Coverage, 12013,
     /* 386145 */     GIR_EraseRootFromParent_Done,
     /* 386146 */   // Label 5853: @386146
     /* 386146 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(386281), // Rule ID 12014 //
     /* 386151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386198 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386203 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386235 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386279 */     GIR_RootConstrainSelectedInstOperands,
     /* 386280 */     // GIR_Coverage, 12014,
     /* 386280 */     GIR_EraseRootFromParent_Done,
     /* 386281 */   // Label 5854: @386281
     /* 386281 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(386416), // Rule ID 12490 //
     /* 386286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386370 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386414 */     GIR_RootConstrainSelectedInstOperands,
     /* 386415 */     // GIR_Coverage, 12490,
     /* 386415 */     GIR_EraseRootFromParent_Done,
     /* 386416 */   // Label 5855: @386416
     /* 386416 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(386551), // Rule ID 12493 //
     /* 386421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386505 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386549 */     GIR_RootConstrainSelectedInstOperands,
     /* 386550 */     // GIR_Coverage, 12493,
     /* 386550 */     GIR_EraseRootFromParent_Done,
     /* 386551 */   // Label 5856: @386551
     /* 386551 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(386686), // Rule ID 12494 //
     /* 386556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386640 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386684 */     GIR_RootConstrainSelectedInstOperands,
     /* 386685 */     // GIR_Coverage, 12494,
     /* 386685 */     GIR_EraseRootFromParent_Done,
     /* 386686 */   // Label 5857: @386686
     /* 386686 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(386821), // Rule ID 12970 //
     /* 386691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386775 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386819 */     GIR_RootConstrainSelectedInstOperands,
     /* 386820 */     // GIR_Coverage, 12970,
     /* 386820 */     GIR_EraseRootFromParent_Done,
     /* 386821 */   // Label 5858: @386821
     /* 386821 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(386956), // Rule ID 12973 //
     /* 386826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386878 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386910 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386954 */     GIR_RootConstrainSelectedInstOperands,
     /* 386955 */     // GIR_Coverage, 12973,
     /* 386955 */     GIR_EraseRootFromParent_Done,
     /* 386956 */   // Label 5859: @386956
     /* 386956 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(387091), // Rule ID 12974 //
     /* 386961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 387004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387008 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387013 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387045 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387089 */     GIR_RootConstrainSelectedInstOperands,
     /* 387090 */     // GIR_Coverage, 12974,
     /* 387090 */     GIR_EraseRootFromParent_Done,
     /* 387091 */   // Label 5860: @387091
     /* 387091 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(387226), // Rule ID 11996 //
     /* 387096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387143 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387180 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387224 */     GIR_RootConstrainSelectedInstOperands,
     /* 387225 */     // GIR_Coverage, 11996,
     /* 387225 */     GIR_EraseRootFromParent_Done,
     /* 387226 */   // Label 5861: @387226
     /* 387226 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(387361), // Rule ID 11997 //
     /* 387231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387315 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387359 */     GIR_RootConstrainSelectedInstOperands,
     /* 387360 */     // GIR_Coverage, 11997,
     /* 387360 */     GIR_EraseRootFromParent_Done,
     /* 387361 */   // Label 5862: @387361
     /* 387361 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(387496), // Rule ID 12000 //
     /* 387366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387450 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387494 */     GIR_RootConstrainSelectedInstOperands,
     /* 387495 */     // GIR_Coverage, 12000,
     /* 387495 */     GIR_EraseRootFromParent_Done,
     /* 387496 */   // Label 5863: @387496
     /* 387496 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(387631), // Rule ID 12001 //
     /* 387501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387553 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387585 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387629 */     GIR_RootConstrainSelectedInstOperands,
     /* 387630 */     // GIR_Coverage, 12001,
     /* 387630 */     GIR_EraseRootFromParent_Done,
     /* 387631 */   // Label 5864: @387631
     /* 387631 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(387766), // Rule ID 12476 //
     /* 387636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387683 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387688 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387720 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387764 */     GIR_RootConstrainSelectedInstOperands,
     /* 387765 */     // GIR_Coverage, 12476,
     /* 387765 */     GIR_EraseRootFromParent_Done,
     /* 387766 */   // Label 5865: @387766
     /* 387766 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(387901), // Rule ID 12477 //
     /* 387771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387818 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387823 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387855 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387899 */     GIR_RootConstrainSelectedInstOperands,
     /* 387900 */     // GIR_Coverage, 12477,
     /* 387900 */     GIR_EraseRootFromParent_Done,
     /* 387901 */   // Label 5866: @387901
     /* 387901 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(388036), // Rule ID 12480 //
     /* 387906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387953 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387990 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388034 */     GIR_RootConstrainSelectedInstOperands,
     /* 388035 */     // GIR_Coverage, 12480,
     /* 388035 */     GIR_EraseRootFromParent_Done,
     /* 388036 */   // Label 5867: @388036
     /* 388036 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(388171), // Rule ID 12481 //
     /* 388041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 388044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 388048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388088 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388125 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 388128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388169 */     GIR_RootConstrainSelectedInstOperands,
     /* 388170 */     // GIR_Coverage, 12481,
     /* 388170 */     GIR_EraseRootFromParent_Done,
     /* 388171 */   // Label 5868: @388171
     /* 388171 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(388306), // Rule ID 12956 //
     /* 388176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388260 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388304 */     GIR_RootConstrainSelectedInstOperands,
     /* 388305 */     // GIR_Coverage, 12956,
     /* 388305 */     GIR_EraseRootFromParent_Done,
     /* 388306 */   // Label 5869: @388306
     /* 388306 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(388441), // Rule ID 12957 //
     /* 388311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388363 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388395 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388439 */     GIR_RootConstrainSelectedInstOperands,
     /* 388440 */     // GIR_Coverage, 12957,
     /* 388440 */     GIR_EraseRootFromParent_Done,
     /* 388441 */   // Label 5870: @388441
     /* 388441 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(388576), // Rule ID 12960 //
     /* 388446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388493 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388498 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388530 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388574 */     GIR_RootConstrainSelectedInstOperands,
     /* 388575 */     // GIR_Coverage, 12960,
     /* 388575 */     GIR_EraseRootFromParent_Done,
     /* 388576 */   // Label 5871: @388576
     /* 388576 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(388711), // Rule ID 12961 //
     /* 388581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388628 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388633 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388665 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388709 */     GIR_RootConstrainSelectedInstOperands,
     /* 388710 */     // GIR_Coverage, 12961,
     /* 388710 */     GIR_EraseRootFromParent_Done,
     /* 388711 */   // Label 5872: @388711
     /* 388711 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(388846), // Rule ID 11981 //
     /* 388716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388768 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388800 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388844 */     GIR_RootConstrainSelectedInstOperands,
     /* 388845 */     // GIR_Coverage, 11981,
     /* 388845 */     GIR_EraseRootFromParent_Done,
     /* 388846 */   // Label 5873: @388846
     /* 388846 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(388981), // Rule ID 11982 //
     /* 388851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388935 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388979 */     GIR_RootConstrainSelectedInstOperands,
     /* 388980 */     // GIR_Coverage, 11982,
     /* 388980 */     GIR_EraseRootFromParent_Done,
     /* 388981 */   // Label 5874: @388981
     /* 388981 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(389116), // Rule ID 11985 //
     /* 388986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389038 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389070 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 389073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389114 */     GIR_RootConstrainSelectedInstOperands,
     /* 389115 */     // GIR_Coverage, 11985,
     /* 389115 */     GIR_EraseRootFromParent_Done,
     /* 389116 */   // Label 5875: @389116
     /* 389116 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(389251), // Rule ID 11986 //
     /* 389121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 389124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389168 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389173 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389205 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 389208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389249 */     GIR_RootConstrainSelectedInstOperands,
     /* 389250 */     // GIR_Coverage, 11986,
     /* 389250 */     GIR_EraseRootFromParent_Done,
     /* 389251 */   // Label 5876: @389251
     /* 389251 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(389386), // Rule ID 12461 //
     /* 389256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389303 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389340 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389384 */     GIR_RootConstrainSelectedInstOperands,
     /* 389385 */     // GIR_Coverage, 12461,
     /* 389385 */     GIR_EraseRootFromParent_Done,
     /* 389386 */   // Label 5877: @389386
     /* 389386 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(389521), // Rule ID 12462 //
     /* 389391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389438 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389443 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389475 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389519 */     GIR_RootConstrainSelectedInstOperands,
     /* 389520 */     // GIR_Coverage, 12462,
     /* 389520 */     GIR_EraseRootFromParent_Done,
     /* 389521 */   // Label 5878: @389521
     /* 389521 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(389656), // Rule ID 12465 //
     /* 389526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389578 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389610 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389654 */     GIR_RootConstrainSelectedInstOperands,
     /* 389655 */     // GIR_Coverage, 12465,
     /* 389655 */     GIR_EraseRootFromParent_Done,
     /* 389656 */   // Label 5879: @389656
     /* 389656 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(389791), // Rule ID 12466 //
     /* 389661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389713 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389745 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389789 */     GIR_RootConstrainSelectedInstOperands,
     /* 389790 */     // GIR_Coverage, 12466,
     /* 389790 */     GIR_EraseRootFromParent_Done,
     /* 389791 */   // Label 5880: @389791
     /* 389791 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(389926), // Rule ID 12941 //
     /* 389796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389848 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389880 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389924 */     GIR_RootConstrainSelectedInstOperands,
     /* 389925 */     // GIR_Coverage, 12941,
     /* 389925 */     GIR_EraseRootFromParent_Done,
     /* 389926 */   // Label 5881: @389926
     /* 389926 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(390061), // Rule ID 12942 //
     /* 389931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389978 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389983 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390015 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390059 */     GIR_RootConstrainSelectedInstOperands,
     /* 390060 */     // GIR_Coverage, 12942,
     /* 390060 */     GIR_EraseRootFromParent_Done,
     /* 390061 */   // Label 5882: @390061
     /* 390061 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(390196), // Rule ID 12945 //
     /* 390066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390113 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390150 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390194 */     GIR_RootConstrainSelectedInstOperands,
     /* 390195 */     // GIR_Coverage, 12945,
     /* 390195 */     GIR_EraseRootFromParent_Done,
     /* 390196 */   // Label 5883: @390196
     /* 390196 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(390331), // Rule ID 12946 //
     /* 390201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390285 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390329 */     GIR_RootConstrainSelectedInstOperands,
     /* 390330 */     // GIR_Coverage, 12946,
     /* 390330 */     GIR_EraseRootFromParent_Done,
     /* 390331 */   // Label 5884: @390331
     /* 390331 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(390466), // Rule ID 7631 //
     /* 390336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390388 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390420 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390464 */     GIR_RootConstrainSelectedInstOperands,
     /* 390465 */     // GIR_Coverage, 7631,
     /* 390465 */     GIR_EraseRootFromParent_Done,
     /* 390466 */   // Label 5885: @390466
     /* 390466 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(390601), // Rule ID 7663 //
     /* 390471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390518 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390555 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390599 */     GIR_RootConstrainSelectedInstOperands,
     /* 390600 */     // GIR_Coverage, 7663,
     /* 390600 */     GIR_EraseRootFromParent_Done,
     /* 390601 */   // Label 5886: @390601
     /* 390601 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(390736), // Rule ID 7695 //
     /* 390606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390658 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390690 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390734 */     GIR_RootConstrainSelectedInstOperands,
     /* 390735 */     // GIR_Coverage, 7695,
     /* 390735 */     GIR_EraseRootFromParent_Done,
     /* 390736 */   // Label 5887: @390736
     /* 390736 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(390871), // Rule ID 11995 //
     /* 390741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390825 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390869 */     GIR_RootConstrainSelectedInstOperands,
     /* 390870 */     // GIR_Coverage, 11995,
     /* 390870 */     GIR_EraseRootFromParent_Done,
     /* 390871 */   // Label 5888: @390871
     /* 390871 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(391006), // Rule ID 11998 //
     /* 390876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390960 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391004 */     GIR_RootConstrainSelectedInstOperands,
     /* 391005 */     // GIR_Coverage, 11998,
     /* 391005 */     GIR_EraseRootFromParent_Done,
     /* 391006 */   // Label 5889: @391006
     /* 391006 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(391141), // Rule ID 11999 //
     /* 391011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391063 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391095 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391139 */     GIR_RootConstrainSelectedInstOperands,
     /* 391140 */     // GIR_Coverage, 11999,
     /* 391140 */     GIR_EraseRootFromParent_Done,
     /* 391141 */   // Label 5890: @391141
     /* 391141 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(391276), // Rule ID 12475 //
     /* 391146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391230 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391274 */     GIR_RootConstrainSelectedInstOperands,
     /* 391275 */     // GIR_Coverage, 12475,
     /* 391275 */     GIR_EraseRootFromParent_Done,
     /* 391276 */   // Label 5891: @391276
     /* 391276 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(391411), // Rule ID 12478 //
     /* 391281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391365 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391409 */     GIR_RootConstrainSelectedInstOperands,
     /* 391410 */     // GIR_Coverage, 12478,
     /* 391410 */     GIR_EraseRootFromParent_Done,
     /* 391411 */   // Label 5892: @391411
     /* 391411 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(391546), // Rule ID 12479 //
     /* 391416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391463 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391500 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391544 */     GIR_RootConstrainSelectedInstOperands,
     /* 391545 */     // GIR_Coverage, 12479,
     /* 391545 */     GIR_EraseRootFromParent_Done,
     /* 391546 */   // Label 5893: @391546
     /* 391546 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(391681), // Rule ID 12955 //
     /* 391551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391635 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391679 */     GIR_RootConstrainSelectedInstOperands,
     /* 391680 */     // GIR_Coverage, 12955,
     /* 391680 */     GIR_EraseRootFromParent_Done,
     /* 391681 */   // Label 5894: @391681
     /* 391681 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(391816), // Rule ID 12958 //
     /* 391686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391770 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391814 */     GIR_RootConstrainSelectedInstOperands,
     /* 391815 */     // GIR_Coverage, 12958,
     /* 391815 */     GIR_EraseRootFromParent_Done,
     /* 391816 */   // Label 5895: @391816
     /* 391816 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(391951), // Rule ID 12959 //
     /* 391821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391905 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391949 */     GIR_RootConstrainSelectedInstOperands,
     /* 391950 */     // GIR_Coverage, 12959,
     /* 391950 */     GIR_EraseRootFromParent_Done,
     /* 391951 */   // Label 5896: @391951
     /* 391951 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(392086), // Rule ID 7630 //
     /* 391956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392008 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392040 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392084 */     GIR_RootConstrainSelectedInstOperands,
     /* 392085 */     // GIR_Coverage, 7630,
     /* 392085 */     GIR_EraseRootFromParent_Done,
     /* 392086 */   // Label 5897: @392086
     /* 392086 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(392221), // Rule ID 7662 //
     /* 392091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392138 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392143 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392175 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392219 */     GIR_RootConstrainSelectedInstOperands,
     /* 392220 */     // GIR_Coverage, 7662,
     /* 392220 */     GIR_EraseRootFromParent_Done,
     /* 392221 */   // Label 5898: @392221
     /* 392221 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(392356), // Rule ID 7694 //
     /* 392226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392273 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392310 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392354 */     GIR_RootConstrainSelectedInstOperands,
     /* 392355 */     // GIR_Coverage, 7694,
     /* 392355 */     GIR_EraseRootFromParent_Done,
     /* 392356 */   // Label 5899: @392356
     /* 392356 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(392491), // Rule ID 11980 //
     /* 392361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392445 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392489 */     GIR_RootConstrainSelectedInstOperands,
     /* 392490 */     // GIR_Coverage, 11980,
     /* 392490 */     GIR_EraseRootFromParent_Done,
     /* 392491 */   // Label 5900: @392491
     /* 392491 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(392626), // Rule ID 11983 //
     /* 392496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392580 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392624 */     GIR_RootConstrainSelectedInstOperands,
     /* 392625 */     // GIR_Coverage, 11983,
     /* 392625 */     GIR_EraseRootFromParent_Done,
     /* 392626 */   // Label 5901: @392626
     /* 392626 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(392761), // Rule ID 11984 //
     /* 392631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392683 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392715 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392759 */     GIR_RootConstrainSelectedInstOperands,
     /* 392760 */     // GIR_Coverage, 11984,
     /* 392760 */     GIR_EraseRootFromParent_Done,
     /* 392761 */   // Label 5902: @392761
     /* 392761 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(392896), // Rule ID 12460 //
     /* 392766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392818 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392850 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392894 */     GIR_RootConstrainSelectedInstOperands,
     /* 392895 */     // GIR_Coverage, 12460,
     /* 392895 */     GIR_EraseRootFromParent_Done,
     /* 392896 */   // Label 5903: @392896
     /* 392896 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(393031), // Rule ID 12463 //
     /* 392901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392948 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392985 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393029 */     GIR_RootConstrainSelectedInstOperands,
     /* 393030 */     // GIR_Coverage, 12463,
     /* 393030 */     GIR_EraseRootFromParent_Done,
     /* 393031 */   // Label 5904: @393031
     /* 393031 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(393166), // Rule ID 12464 //
     /* 393036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393083 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393120 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393164 */     GIR_RootConstrainSelectedInstOperands,
     /* 393165 */     // GIR_Coverage, 12464,
     /* 393165 */     GIR_EraseRootFromParent_Done,
     /* 393166 */   // Label 5905: @393166
     /* 393166 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(393301), // Rule ID 12940 //
     /* 393171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393255 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 393258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 393265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 393270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393299 */     GIR_RootConstrainSelectedInstOperands,
     /* 393300 */     // GIR_Coverage, 12940,
     /* 393300 */     GIR_EraseRootFromParent_Done,
     /* 393301 */   // Label 5906: @393301
     /* 393301 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(393436), // Rule ID 12943 //
     /* 393306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393390 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 393393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393434 */     GIR_RootConstrainSelectedInstOperands,
     /* 393435 */     // GIR_Coverage, 12943,
     /* 393435 */     GIR_EraseRootFromParent_Done,
     /* 393436 */   // Label 5907: @393436
     /* 393436 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(393571), // Rule ID 12944 //
     /* 393441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393488 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393493 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393525 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 393528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393569 */     GIR_RootConstrainSelectedInstOperands,
     /* 393570 */     // GIR_Coverage, 12944,
     /* 393570 */     GIR_EraseRootFromParent_Done,
     /* 393571 */   // Label 5908: @393571
     /* 393571 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(393706), // Rule ID 12036 //
     /* 393576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393623 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393628 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393660 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 393680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 393685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393704 */     GIR_RootConstrainSelectedInstOperands,
     /* 393705 */     // GIR_Coverage, 12036,
     /* 393705 */     GIR_EraseRootFromParent_Done,
     /* 393706 */   // Label 5909: @393706
     /* 393706 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(393841), // Rule ID 12037 //
     /* 393711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393758 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393795 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 393815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 393820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393839 */     GIR_RootConstrainSelectedInstOperands,
     /* 393840 */     // GIR_Coverage, 12037,
     /* 393840 */     GIR_EraseRootFromParent_Done,
     /* 393841 */   // Label 5910: @393841
     /* 393841 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(393976), // Rule ID 12038 //
     /* 393846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393930 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 393940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 393945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393974 */     GIR_RootConstrainSelectedInstOperands,
     /* 393975 */     // GIR_Coverage, 12038,
     /* 393975 */     GIR_EraseRootFromParent_Done,
     /* 393976 */   // Label 5911: @393976
     /* 393976 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(394111), // Rule ID 12039 //
     /* 393981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394065 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 394068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394109 */     GIR_RootConstrainSelectedInstOperands,
     /* 394110 */     // GIR_Coverage, 12039,
     /* 394110 */     GIR_EraseRootFromParent_Done,
     /* 394111 */   // Label 5912: @394111
     /* 394111 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(394246), // Rule ID 12516 //
     /* 394116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394168 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394200 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394244 */     GIR_RootConstrainSelectedInstOperands,
     /* 394245 */     // GIR_Coverage, 12516,
     /* 394245 */     GIR_EraseRootFromParent_Done,
     /* 394246 */   // Label 5913: @394246
     /* 394246 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(394381), // Rule ID 12517 //
     /* 394251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394298 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394303 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394335 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394379 */     GIR_RootConstrainSelectedInstOperands,
     /* 394380 */     // GIR_Coverage, 12517,
     /* 394380 */     GIR_EraseRootFromParent_Done,
     /* 394381 */   // Label 5914: @394381
     /* 394381 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(394516), // Rule ID 12518 //
     /* 394386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394433 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394438 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394443 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394470 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394514 */     GIR_RootConstrainSelectedInstOperands,
     /* 394515 */     // GIR_Coverage, 12518,
     /* 394515 */     GIR_EraseRootFromParent_Done,
     /* 394516 */   // Label 5915: @394516
     /* 394516 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(394651), // Rule ID 12519 //
     /* 394521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394605 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394649 */     GIR_RootConstrainSelectedInstOperands,
     /* 394650 */     // GIR_Coverage, 12519,
     /* 394650 */     GIR_EraseRootFromParent_Done,
     /* 394651 */   // Label 5916: @394651
     /* 394651 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(394786), // Rule ID 12996 //
     /* 394656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394740 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394784 */     GIR_RootConstrainSelectedInstOperands,
     /* 394785 */     // GIR_Coverage, 12996,
     /* 394785 */     GIR_EraseRootFromParent_Done,
     /* 394786 */   // Label 5917: @394786
     /* 394786 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(394921), // Rule ID 12997 //
     /* 394791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394875 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394919 */     GIR_RootConstrainSelectedInstOperands,
     /* 394920 */     // GIR_Coverage, 12997,
     /* 394920 */     GIR_EraseRootFromParent_Done,
     /* 394921 */   // Label 5918: @394921
     /* 394921 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(395056), // Rule ID 12998 //
     /* 394926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394973 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394978 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395010 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 395013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395054 */     GIR_RootConstrainSelectedInstOperands,
     /* 395055 */     // GIR_Coverage, 12998,
     /* 395055 */     GIR_EraseRootFromParent_Done,
     /* 395056 */   // Label 5919: @395056
     /* 395056 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(395191), // Rule ID 12999 //
     /* 395061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 395064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395108 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395113 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395118 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395145 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 395148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395189 */     GIR_RootConstrainSelectedInstOperands,
     /* 395190 */     // GIR_Coverage, 12999,
     /* 395190 */     GIR_EraseRootFromParent_Done,
     /* 395191 */   // Label 5920: @395191
     /* 395191 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(395326), // Rule ID 11976 //
     /* 395196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395280 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395324 */     GIR_RootConstrainSelectedInstOperands,
     /* 395325 */     // GIR_Coverage, 11976,
     /* 395325 */     GIR_EraseRootFromParent_Done,
     /* 395326 */   // Label 5921: @395326
     /* 395326 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(395461), // Rule ID 11977 //
     /* 395331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395415 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395459 */     GIR_RootConstrainSelectedInstOperands,
     /* 395460 */     // GIR_Coverage, 11977,
     /* 395460 */     GIR_EraseRootFromParent_Done,
     /* 395461 */   // Label 5922: @395461
     /* 395461 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(395596), // Rule ID 11978 //
     /* 395466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395550 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395594 */     GIR_RootConstrainSelectedInstOperands,
     /* 395595 */     // GIR_Coverage, 11978,
     /* 395595 */     GIR_EraseRootFromParent_Done,
     /* 395596 */   // Label 5923: @395596
     /* 395596 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(395731), // Rule ID 11979 //
     /* 395601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395685 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395729 */     GIR_RootConstrainSelectedInstOperands,
     /* 395730 */     // GIR_Coverage, 11979,
     /* 395730 */     GIR_EraseRootFromParent_Done,
     /* 395731 */   // Label 5924: @395731
     /* 395731 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(395866), // Rule ID 12456 //
     /* 395736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395783 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395820 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395864 */     GIR_RootConstrainSelectedInstOperands,
     /* 395865 */     // GIR_Coverage, 12456,
     /* 395865 */     GIR_EraseRootFromParent_Done,
     /* 395866 */   // Label 5925: @395866
     /* 395866 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(396001), // Rule ID 12457 //
     /* 395871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395918 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395955 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395999 */     GIR_RootConstrainSelectedInstOperands,
     /* 396000 */     // GIR_Coverage, 12457,
     /* 396000 */     GIR_EraseRootFromParent_Done,
     /* 396001 */   // Label 5926: @396001
     /* 396001 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(396136), // Rule ID 12458 //
     /* 396006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 396009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 396013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396090 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 396093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396134 */     GIR_RootConstrainSelectedInstOperands,
     /* 396135 */     // GIR_Coverage, 12458,
     /* 396135 */     GIR_EraseRootFromParent_Done,
     /* 396136 */   // Label 5927: @396136
     /* 396136 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(396271), // Rule ID 12459 //
     /* 396141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 396144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 396148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396225 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 396228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396269 */     GIR_RootConstrainSelectedInstOperands,
     /* 396270 */     // GIR_Coverage, 12459,
     /* 396270 */     GIR_EraseRootFromParent_Done,
     /* 396271 */   // Label 5928: @396271
     /* 396271 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(396406), // Rule ID 12936 //
     /* 396276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396328 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396360 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396404 */     GIR_RootConstrainSelectedInstOperands,
     /* 396405 */     // GIR_Coverage, 12936,
     /* 396405 */     GIR_EraseRootFromParent_Done,
     /* 396406 */   // Label 5929: @396406
     /* 396406 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(396541), // Rule ID 12937 //
     /* 396411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396458 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396463 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396495 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396539 */     GIR_RootConstrainSelectedInstOperands,
     /* 396540 */     // GIR_Coverage, 12937,
     /* 396540 */     GIR_EraseRootFromParent_Done,
     /* 396541 */   // Label 5930: @396541
     /* 396541 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(396676), // Rule ID 12938 //
     /* 396546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396593 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396630 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396674 */     GIR_RootConstrainSelectedInstOperands,
     /* 396675 */     // GIR_Coverage, 12938,
     /* 396675 */     GIR_EraseRootFromParent_Done,
     /* 396676 */   // Label 5931: @396676
     /* 396676 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(396811), // Rule ID 12939 //
     /* 396681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396765 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396809 */     GIR_RootConstrainSelectedInstOperands,
     /* 396810 */     // GIR_Coverage, 12939,
     /* 396810 */     GIR_EraseRootFromParent_Done,
     /* 396811 */   // Label 5932: @396811
     /* 396811 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(396946), // Rule ID 12021 //
     /* 396816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396900 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396944 */     GIR_RootConstrainSelectedInstOperands,
     /* 396945 */     // GIR_Coverage, 12021,
     /* 396945 */     GIR_EraseRootFromParent_Done,
     /* 396946 */   // Label 5933: @396946
     /* 396946 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(397081), // Rule ID 12022 //
     /* 396951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397035 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397079 */     GIR_RootConstrainSelectedInstOperands,
     /* 397080 */     // GIR_Coverage, 12022,
     /* 397080 */     GIR_EraseRootFromParent_Done,
     /* 397081 */   // Label 5934: @397081
     /* 397081 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(397216), // Rule ID 12023 //
     /* 397086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 397089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397138 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397170 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397214 */     GIR_RootConstrainSelectedInstOperands,
     /* 397215 */     // GIR_Coverage, 12023,
     /* 397215 */     GIR_EraseRootFromParent_Done,
     /* 397216 */   // Label 5935: @397216
     /* 397216 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(397351), // Rule ID 12024 //
     /* 397221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 397224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397268 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397273 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397305 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397349 */     GIR_RootConstrainSelectedInstOperands,
     /* 397350 */     // GIR_Coverage, 12024,
     /* 397350 */     GIR_EraseRootFromParent_Done,
     /* 397351 */   // Label 5936: @397351
     /* 397351 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(397486), // Rule ID 12501 //
     /* 397356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397440 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397484 */     GIR_RootConstrainSelectedInstOperands,
     /* 397485 */     // GIR_Coverage, 12501,
     /* 397485 */     GIR_EraseRootFromParent_Done,
     /* 397486 */   // Label 5937: @397486
     /* 397486 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(397621), // Rule ID 12502 //
     /* 397491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397575 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397619 */     GIR_RootConstrainSelectedInstOperands,
     /* 397620 */     // GIR_Coverage, 12502,
     /* 397620 */     GIR_EraseRootFromParent_Done,
     /* 397621 */   // Label 5938: @397621
     /* 397621 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(397756), // Rule ID 12503 //
     /* 397626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397710 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397754 */     GIR_RootConstrainSelectedInstOperands,
     /* 397755 */     // GIR_Coverage, 12503,
     /* 397755 */     GIR_EraseRootFromParent_Done,
     /* 397756 */   // Label 5939: @397756
     /* 397756 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(397891), // Rule ID 12504 //
     /* 397761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397813 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397845 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397889 */     GIR_RootConstrainSelectedInstOperands,
     /* 397890 */     // GIR_Coverage, 12504,
     /* 397890 */     GIR_EraseRootFromParent_Done,
     /* 397891 */   // Label 5940: @397891
     /* 397891 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(398026), // Rule ID 12981 //
     /* 397896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397943 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397948 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397980 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398024 */     GIR_RootConstrainSelectedInstOperands,
     /* 398025 */     // GIR_Coverage, 12981,
     /* 398025 */     GIR_EraseRootFromParent_Done,
     /* 398026 */   // Label 5941: @398026
     /* 398026 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(398161), // Rule ID 12982 //
     /* 398031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398078 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398115 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 398118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398159 */     GIR_RootConstrainSelectedInstOperands,
     /* 398160 */     // GIR_Coverage, 12982,
     /* 398160 */     GIR_EraseRootFromParent_Done,
     /* 398161 */   // Label 5942: @398161
     /* 398161 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(398296), // Rule ID 12983 //
     /* 398166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398250 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 398253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398294 */     GIR_RootConstrainSelectedInstOperands,
     /* 398295 */     // GIR_Coverage, 12983,
     /* 398295 */     GIR_EraseRootFromParent_Done,
     /* 398296 */   // Label 5943: @398296
     /* 398296 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(398431), // Rule ID 12984 //
     /* 398301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398385 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 398388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398429 */     GIR_RootConstrainSelectedInstOperands,
     /* 398430 */     // GIR_Coverage, 12984,
     /* 398430 */     GIR_EraseRootFromParent_Done,
     /* 398431 */   // Label 5944: @398431
     /* 398431 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(398566), // Rule ID 11961 //
     /* 398436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398488 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398520 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398564 */     GIR_RootConstrainSelectedInstOperands,
     /* 398565 */     // GIR_Coverage, 11961,
     /* 398565 */     GIR_EraseRootFromParent_Done,
     /* 398566 */   // Label 5945: @398566
     /* 398566 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(398701), // Rule ID 11962 //
     /* 398571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398618 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398623 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398655 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398699 */     GIR_RootConstrainSelectedInstOperands,
     /* 398700 */     // GIR_Coverage, 11962,
     /* 398700 */     GIR_EraseRootFromParent_Done,
     /* 398701 */   // Label 5946: @398701
     /* 398701 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(398836), // Rule ID 11963 //
     /* 398706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398753 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398758 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398790 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398834 */     GIR_RootConstrainSelectedInstOperands,
     /* 398835 */     // GIR_Coverage, 11963,
     /* 398835 */     GIR_EraseRootFromParent_Done,
     /* 398836 */   // Label 5947: @398836
     /* 398836 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(398971), // Rule ID 11964 //
     /* 398841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398925 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398969 */     GIR_RootConstrainSelectedInstOperands,
     /* 398970 */     // GIR_Coverage, 11964,
     /* 398970 */     GIR_EraseRootFromParent_Done,
     /* 398971 */   // Label 5948: @398971
     /* 398971 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(399106), // Rule ID 12441 //
     /* 398976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399060 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399104 */     GIR_RootConstrainSelectedInstOperands,
     /* 399105 */     // GIR_Coverage, 12441,
     /* 399105 */     GIR_EraseRootFromParent_Done,
     /* 399106 */   // Label 5949: @399106
     /* 399106 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(399241), // Rule ID 12442 //
     /* 399111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 399114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 399118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399195 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399239 */     GIR_RootConstrainSelectedInstOperands,
     /* 399240 */     // GIR_Coverage, 12442,
     /* 399240 */     GIR_EraseRootFromParent_Done,
     /* 399241 */   // Label 5950: @399241
     /* 399241 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(399376), // Rule ID 12443 //
     /* 399246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 399249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 399253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399298 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399330 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399374 */     GIR_RootConstrainSelectedInstOperands,
     /* 399375 */     // GIR_Coverage, 12443,
     /* 399375 */     GIR_EraseRootFromParent_Done,
     /* 399376 */   // Label 5951: @399376
     /* 399376 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(399511), // Rule ID 12444 //
     /* 399381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 399384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 399388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399428 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399433 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399438 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399465 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399509 */     GIR_RootConstrainSelectedInstOperands,
     /* 399510 */     // GIR_Coverage, 12444,
     /* 399510 */     GIR_EraseRootFromParent_Done,
     /* 399511 */   // Label 5952: @399511
     /* 399511 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(399646), // Rule ID 12921 //
     /* 399516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399563 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399600 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399644 */     GIR_RootConstrainSelectedInstOperands,
     /* 399645 */     // GIR_Coverage, 12921,
     /* 399645 */     GIR_EraseRootFromParent_Done,
     /* 399646 */   // Label 5953: @399646
     /* 399646 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(399781), // Rule ID 12922 //
     /* 399651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399735 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399779 */     GIR_RootConstrainSelectedInstOperands,
     /* 399780 */     // GIR_Coverage, 12922,
     /* 399780 */     GIR_EraseRootFromParent_Done,
     /* 399781 */   // Label 5954: @399781
     /* 399781 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(399916), // Rule ID 12923 //
     /* 399786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399870 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399914 */     GIR_RootConstrainSelectedInstOperands,
     /* 399915 */     // GIR_Coverage, 12923,
     /* 399915 */     GIR_EraseRootFromParent_Done,
     /* 399916 */   // Label 5955: @399916
     /* 399916 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(400051), // Rule ID 12924 //
     /* 399921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399973 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400005 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 400015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 400020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400049 */     GIR_RootConstrainSelectedInstOperands,
     /* 400050 */     // GIR_Coverage, 12924,
     /* 400050 */     GIR_EraseRootFromParent_Done,
     /* 400051 */   // Label 5956: @400051
     /* 400051 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(400186), // Rule ID 12032 //
     /* 400056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400103 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400108 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400140 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400184 */     GIR_RootConstrainSelectedInstOperands,
     /* 400185 */     // GIR_Coverage, 12032,
     /* 400185 */     GIR_EraseRootFromParent_Done,
     /* 400186 */   // Label 5957: @400186
     /* 400186 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(400321), // Rule ID 12033 //
     /* 400191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400238 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400275 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400319 */     GIR_RootConstrainSelectedInstOperands,
     /* 400320 */     // GIR_Coverage, 12033,
     /* 400320 */     GIR_EraseRootFromParent_Done,
     /* 400321 */   // Label 5958: @400321
     /* 400321 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(400456), // Rule ID 12034 //
     /* 400326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400410 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400454 */     GIR_RootConstrainSelectedInstOperands,
     /* 400455 */     // GIR_Coverage, 12034,
     /* 400455 */     GIR_EraseRootFromParent_Done,
     /* 400456 */   // Label 5959: @400456
     /* 400456 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(400591), // Rule ID 12035 //
     /* 400461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400545 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400589 */     GIR_RootConstrainSelectedInstOperands,
     /* 400590 */     // GIR_Coverage, 12035,
     /* 400590 */     GIR_EraseRootFromParent_Done,
     /* 400591 */   // Label 5960: @400591
     /* 400591 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(400726), // Rule ID 12512 //
     /* 400596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400643 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400680 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400724 */     GIR_RootConstrainSelectedInstOperands,
     /* 400725 */     // GIR_Coverage, 12512,
     /* 400725 */     GIR_EraseRootFromParent_Done,
     /* 400726 */   // Label 5961: @400726
     /* 400726 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(400861), // Rule ID 12513 //
     /* 400731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400778 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400783 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400815 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400859 */     GIR_RootConstrainSelectedInstOperands,
     /* 400860 */     // GIR_Coverage, 12513,
     /* 400860 */     GIR_EraseRootFromParent_Done,
     /* 400861 */   // Label 5962: @400861
     /* 400861 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(400996), // Rule ID 12514 //
     /* 400866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400913 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400918 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400950 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400994 */     GIR_RootConstrainSelectedInstOperands,
     /* 400995 */     // GIR_Coverage, 12514,
     /* 400995 */     GIR_EraseRootFromParent_Done,
     /* 400996 */   // Label 5963: @400996
     /* 400996 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(401131), // Rule ID 12515 //
     /* 401001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401048 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401085 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 401088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401129 */     GIR_RootConstrainSelectedInstOperands,
     /* 401130 */     // GIR_Coverage, 12515,
     /* 401130 */     GIR_EraseRootFromParent_Done,
     /* 401131 */   // Label 5964: @401131
     /* 401131 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(401266), // Rule ID 12992 //
     /* 401136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401220 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401264 */     GIR_RootConstrainSelectedInstOperands,
     /* 401265 */     // GIR_Coverage, 12992,
     /* 401265 */     GIR_EraseRootFromParent_Done,
     /* 401266 */   // Label 5965: @401266
     /* 401266 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(401401), // Rule ID 12993 //
     /* 401271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401355 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401399 */     GIR_RootConstrainSelectedInstOperands,
     /* 401400 */     // GIR_Coverage, 12993,
     /* 401400 */     GIR_EraseRootFromParent_Done,
     /* 401401 */   // Label 5966: @401401
     /* 401401 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(401536), // Rule ID 12994 //
     /* 401406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401458 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401490 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401534 */     GIR_RootConstrainSelectedInstOperands,
     /* 401535 */     // GIR_Coverage, 12994,
     /* 401535 */     GIR_EraseRootFromParent_Done,
     /* 401536 */   // Label 5967: @401536
     /* 401536 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(401671), // Rule ID 12995 //
     /* 401541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401588 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401593 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401625 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401669 */     GIR_RootConstrainSelectedInstOperands,
     /* 401670 */     // GIR_Coverage, 12995,
     /* 401670 */     GIR_EraseRootFromParent_Done,
     /* 401671 */   // Label 5968: @401671
     /* 401671 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(401806), // Rule ID 11972 //
     /* 401676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401723 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401760 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401804 */     GIR_RootConstrainSelectedInstOperands,
     /* 401805 */     // GIR_Coverage, 11972,
     /* 401805 */     GIR_EraseRootFromParent_Done,
     /* 401806 */   // Label 5969: @401806
     /* 401806 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(401941), // Rule ID 11973 //
     /* 401811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401895 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401939 */     GIR_RootConstrainSelectedInstOperands,
     /* 401940 */     // GIR_Coverage, 11973,
     /* 401940 */     GIR_EraseRootFromParent_Done,
     /* 401941 */   // Label 5970: @401941
     /* 401941 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(402076), // Rule ID 11974 //
     /* 401946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401993 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402030 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 402033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402074 */     GIR_RootConstrainSelectedInstOperands,
     /* 402075 */     // GIR_Coverage, 11974,
     /* 402075 */     GIR_EraseRootFromParent_Done,
     /* 402076 */   // Label 5971: @402076
     /* 402076 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(402211), // Rule ID 11975 //
     /* 402081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 402084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402128 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402165 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 402168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402209 */     GIR_RootConstrainSelectedInstOperands,
     /* 402210 */     // GIR_Coverage, 11975,
     /* 402210 */     GIR_EraseRootFromParent_Done,
     /* 402211 */   // Label 5972: @402211
     /* 402211 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(402346), // Rule ID 12452 //
     /* 402216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402263 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402268 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402300 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402344 */     GIR_RootConstrainSelectedInstOperands,
     /* 402345 */     // GIR_Coverage, 12452,
     /* 402345 */     GIR_EraseRootFromParent_Done,
     /* 402346 */   // Label 5973: @402346
     /* 402346 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(402481), // Rule ID 12453 //
     /* 402351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402398 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402435 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402479 */     GIR_RootConstrainSelectedInstOperands,
     /* 402480 */     // GIR_Coverage, 12453,
     /* 402480 */     GIR_EraseRootFromParent_Done,
     /* 402481 */   // Label 5974: @402481
     /* 402481 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(402616), // Rule ID 12454 //
     /* 402486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402533 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402570 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402614 */     GIR_RootConstrainSelectedInstOperands,
     /* 402615 */     // GIR_Coverage, 12454,
     /* 402615 */     GIR_EraseRootFromParent_Done,
     /* 402616 */   // Label 5975: @402616
     /* 402616 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(402751), // Rule ID 12455 //
     /* 402621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402705 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402749 */     GIR_RootConstrainSelectedInstOperands,
     /* 402750 */     // GIR_Coverage, 12455,
     /* 402750 */     GIR_EraseRootFromParent_Done,
     /* 402751 */   // Label 5976: @402751
     /* 402751 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(402886), // Rule ID 12932 //
     /* 402756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402840 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402884 */     GIR_RootConstrainSelectedInstOperands,
     /* 402885 */     // GIR_Coverage, 12932,
     /* 402885 */     GIR_EraseRootFromParent_Done,
     /* 402886 */   // Label 5977: @402886
     /* 402886 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(403021), // Rule ID 12933 //
     /* 402891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402943 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402975 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403019 */     GIR_RootConstrainSelectedInstOperands,
     /* 403020 */     // GIR_Coverage, 12933,
     /* 403020 */     GIR_EraseRootFromParent_Done,
     /* 403021 */   // Label 5978: @403021
     /* 403021 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(403156), // Rule ID 12934 //
     /* 403026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 403029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 403057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403073 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403078 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403110 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 403113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403154 */     GIR_RootConstrainSelectedInstOperands,
     /* 403155 */     // GIR_Coverage, 12934,
     /* 403155 */     GIR_EraseRootFromParent_Done,
     /* 403156 */   // Label 5979: @403156
     /* 403156 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(403291), // Rule ID 12935 //
     /* 403161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 403164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 403192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403208 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403245 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 403248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403289 */     GIR_RootConstrainSelectedInstOperands,
     /* 403290 */     // GIR_Coverage, 12935,
     /* 403290 */     GIR_EraseRootFromParent_Done,
     /* 403291 */   // Label 5980: @403291
     /* 403291 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(403426), // Rule ID 12017 //
     /* 403296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403380 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403424 */     GIR_RootConstrainSelectedInstOperands,
     /* 403425 */     // GIR_Coverage, 12017,
     /* 403425 */     GIR_EraseRootFromParent_Done,
     /* 403426 */   // Label 5981: @403426
     /* 403426 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(403561), // Rule ID 12018 //
     /* 403431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403515 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403559 */     GIR_RootConstrainSelectedInstOperands,
     /* 403560 */     // GIR_Coverage, 12018,
     /* 403560 */     GIR_EraseRootFromParent_Done,
     /* 403561 */   // Label 5982: @403561
     /* 403561 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(403696), // Rule ID 12019 //
     /* 403566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403618 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403650 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403694 */     GIR_RootConstrainSelectedInstOperands,
     /* 403695 */     // GIR_Coverage, 12019,
     /* 403695 */     GIR_EraseRootFromParent_Done,
     /* 403696 */   // Label 5983: @403696
     /* 403696 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(403831), // Rule ID 12020 //
     /* 403701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403748 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403753 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403785 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403829 */     GIR_RootConstrainSelectedInstOperands,
     /* 403830 */     // GIR_Coverage, 12020,
     /* 403830 */     GIR_EraseRootFromParent_Done,
     /* 403831 */   // Label 5984: @403831
     /* 403831 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(403966), // Rule ID 12497 //
     /* 403836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403883 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403920 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403964 */     GIR_RootConstrainSelectedInstOperands,
     /* 403965 */     // GIR_Coverage, 12497,
     /* 403965 */     GIR_EraseRootFromParent_Done,
     /* 403966 */   // Label 5985: @403966
     /* 403966 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(404101), // Rule ID 12498 //
     /* 403971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404055 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404099 */     GIR_RootConstrainSelectedInstOperands,
     /* 404100 */     // GIR_Coverage, 12498,
     /* 404100 */     GIR_EraseRootFromParent_Done,
     /* 404101 */   // Label 5986: @404101
     /* 404101 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(404236), // Rule ID 12499 //
     /* 404106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 404109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 404113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404190 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404234 */     GIR_RootConstrainSelectedInstOperands,
     /* 404235 */     // GIR_Coverage, 12499,
     /* 404235 */     GIR_EraseRootFromParent_Done,
     /* 404236 */   // Label 5987: @404236
     /* 404236 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(404371), // Rule ID 12500 //
     /* 404241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 404244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 404248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404325 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404369 */     GIR_RootConstrainSelectedInstOperands,
     /* 404370 */     // GIR_Coverage, 12500,
     /* 404370 */     GIR_EraseRootFromParent_Done,
     /* 404371 */   // Label 5988: @404371
     /* 404371 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(404506), // Rule ID 12977 //
     /* 404376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404423 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404428 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404460 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404504 */     GIR_RootConstrainSelectedInstOperands,
     /* 404505 */     // GIR_Coverage, 12977,
     /* 404505 */     GIR_EraseRootFromParent_Done,
     /* 404506 */   // Label 5989: @404506
     /* 404506 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(404641), // Rule ID 12978 //
     /* 404511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404558 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404563 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404595 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404639 */     GIR_RootConstrainSelectedInstOperands,
     /* 404640 */     // GIR_Coverage, 12978,
     /* 404640 */     GIR_EraseRootFromParent_Done,
     /* 404641 */   // Label 5990: @404641
     /* 404641 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(404776), // Rule ID 12979 //
     /* 404646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404693 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404730 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404774 */     GIR_RootConstrainSelectedInstOperands,
     /* 404775 */     // GIR_Coverage, 12979,
     /* 404775 */     GIR_EraseRootFromParent_Done,
     /* 404776 */   // Label 5991: @404776
     /* 404776 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(404911), // Rule ID 12980 //
     /* 404781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404865 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404909 */     GIR_RootConstrainSelectedInstOperands,
     /* 404910 */     // GIR_Coverage, 12980,
     /* 404910 */     GIR_EraseRootFromParent_Done,
     /* 404911 */   // Label 5992: @404911
     /* 404911 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(405046), // Rule ID 11957 //
     /* 404916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 404963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405000 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405044 */     GIR_RootConstrainSelectedInstOperands,
     /* 405045 */     // GIR_Coverage, 11957,
     /* 405045 */     GIR_EraseRootFromParent_Done,
     /* 405046 */   // Label 5993: @405046
     /* 405046 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(405181), // Rule ID 11958 //
     /* 405051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405103 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405135 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405179 */     GIR_RootConstrainSelectedInstOperands,
     /* 405180 */     // GIR_Coverage, 11958,
     /* 405180 */     GIR_EraseRootFromParent_Done,
     /* 405181 */   // Label 5994: @405181
     /* 405181 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(405316), // Rule ID 11959 //
     /* 405186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405233 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405238 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405270 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405314 */     GIR_RootConstrainSelectedInstOperands,
     /* 405315 */     // GIR_Coverage, 11959,
     /* 405315 */     GIR_EraseRootFromParent_Done,
     /* 405316 */   // Label 5995: @405316
     /* 405316 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(405451), // Rule ID 11960 //
     /* 405321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405368 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405405 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405449 */     GIR_RootConstrainSelectedInstOperands,
     /* 405450 */     // GIR_Coverage, 11960,
     /* 405450 */     GIR_EraseRootFromParent_Done,
     /* 405451 */   // Label 5996: @405451
     /* 405451 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(405586), // Rule ID 12437 //
     /* 405456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405540 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405584 */     GIR_RootConstrainSelectedInstOperands,
     /* 405585 */     // GIR_Coverage, 12437,
     /* 405585 */     GIR_EraseRootFromParent_Done,
     /* 405586 */   // Label 5997: @405586
     /* 405586 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(405721), // Rule ID 12438 //
     /* 405591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405638 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405643 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405675 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405719 */     GIR_RootConstrainSelectedInstOperands,
     /* 405720 */     // GIR_Coverage, 12438,
     /* 405720 */     GIR_EraseRootFromParent_Done,
     /* 405721 */   // Label 5998: @405721
     /* 405721 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(405856), // Rule ID 12439 //
     /* 405726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405773 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405778 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405810 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405854 */     GIR_RootConstrainSelectedInstOperands,
     /* 405855 */     // GIR_Coverage, 12439,
     /* 405855 */     GIR_EraseRootFromParent_Done,
     /* 405856 */   // Label 5999: @405856
     /* 405856 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(405991), // Rule ID 12440 //
     /* 405861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405908 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405913 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405945 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405989 */     GIR_RootConstrainSelectedInstOperands,
     /* 405990 */     // GIR_Coverage, 12440,
     /* 405990 */     GIR_EraseRootFromParent_Done,
     /* 405991 */   // Label 6000: @405991
     /* 405991 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(406126), // Rule ID 12917 //
     /* 405996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406043 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406048 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406080 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406124 */     GIR_RootConstrainSelectedInstOperands,
     /* 406125 */     // GIR_Coverage, 12917,
     /* 406125 */     GIR_EraseRootFromParent_Done,
     /* 406126 */   // Label 6001: @406126
     /* 406126 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(406261), // Rule ID 12918 //
     /* 406131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 406134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406178 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406215 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406259 */     GIR_RootConstrainSelectedInstOperands,
     /* 406260 */     // GIR_Coverage, 12918,
     /* 406260 */     GIR_EraseRootFromParent_Done,
     /* 406261 */   // Label 6002: @406261
     /* 406261 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(406396), // Rule ID 12919 //
     /* 406266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 406269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406350 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406394 */     GIR_RootConstrainSelectedInstOperands,
     /* 406395 */     // GIR_Coverage, 12919,
     /* 406395 */     GIR_EraseRootFromParent_Done,
     /* 406396 */   // Label 6003: @406396
     /* 406396 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(406531), // Rule ID 12920 //
     /* 406401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 406404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406485 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406529 */     GIR_RootConstrainSelectedInstOperands,
     /* 406530 */     // GIR_Coverage, 12920,
     /* 406530 */     GIR_EraseRootFromParent_Done,
     /* 406531 */   // Label 6004: @406531
     /* 406531 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(406666), // Rule ID 11966 //
     /* 406536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406583 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406588 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406620 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406664 */     GIR_RootConstrainSelectedInstOperands,
     /* 406665 */     // GIR_Coverage, 11966,
     /* 406665 */     GIR_EraseRootFromParent_Done,
     /* 406666 */   // Label 6005: @406666
     /* 406666 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(406801), // Rule ID 11967 //
     /* 406671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406718 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406723 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406728 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406755 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406799 */     GIR_RootConstrainSelectedInstOperands,
     /* 406800 */     // GIR_Coverage, 11967,
     /* 406800 */     GIR_EraseRootFromParent_Done,
     /* 406801 */   // Label 6006: @406801
     /* 406801 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(406936), // Rule ID 11970 //
     /* 406806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406853 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406863 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406890 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406934 */     GIR_RootConstrainSelectedInstOperands,
     /* 406935 */     // GIR_Coverage, 11970,
     /* 406935 */     GIR_EraseRootFromParent_Done,
     /* 406936 */   // Label 6007: @406936
     /* 406936 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(407071), // Rule ID 11971 //
     /* 406941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406988 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406993 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407025 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407069 */     GIR_RootConstrainSelectedInstOperands,
     /* 407070 */     // GIR_Coverage, 11971,
     /* 407070 */     GIR_EraseRootFromParent_Done,
     /* 407071 */   // Label 6008: @407071
     /* 407071 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(407206), // Rule ID 12446 //
     /* 407076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407123 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407128 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407160 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407204 */     GIR_RootConstrainSelectedInstOperands,
     /* 407205 */     // GIR_Coverage, 12446,
     /* 407205 */     GIR_EraseRootFromParent_Done,
     /* 407206 */   // Label 6009: @407206
     /* 407206 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(407341), // Rule ID 12447 //
     /* 407211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407258 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407263 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407295 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407339 */     GIR_RootConstrainSelectedInstOperands,
     /* 407340 */     // GIR_Coverage, 12447,
     /* 407340 */     GIR_EraseRootFromParent_Done,
     /* 407341 */   // Label 6010: @407341
     /* 407341 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(407476), // Rule ID 12450 //
     /* 407346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407393 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407398 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407430 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407474 */     GIR_RootConstrainSelectedInstOperands,
     /* 407475 */     // GIR_Coverage, 12450,
     /* 407475 */     GIR_EraseRootFromParent_Done,
     /* 407476 */   // Label 6011: @407476
     /* 407476 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(407611), // Rule ID 12451 //
     /* 407481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407528 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407533 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407565 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407609 */     GIR_RootConstrainSelectedInstOperands,
     /* 407610 */     // GIR_Coverage, 12451,
     /* 407610 */     GIR_EraseRootFromParent_Done,
     /* 407611 */   // Label 6012: @407611
     /* 407611 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(407746), // Rule ID 12926 //
     /* 407616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407663 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407700 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407744 */     GIR_RootConstrainSelectedInstOperands,
     /* 407745 */     // GIR_Coverage, 12926,
     /* 407745 */     GIR_EraseRootFromParent_Done,
     /* 407746 */   // Label 6013: @407746
     /* 407746 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(407881), // Rule ID 12927 //
     /* 407751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407835 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407879 */     GIR_RootConstrainSelectedInstOperands,
     /* 407880 */     // GIR_Coverage, 12927,
     /* 407880 */     GIR_EraseRootFromParent_Done,
     /* 407881 */   // Label 6014: @407881
     /* 407881 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(408016), // Rule ID 12930 //
     /* 407886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407970 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408014 */     GIR_RootConstrainSelectedInstOperands,
     /* 408015 */     // GIR_Coverage, 12930,
     /* 408015 */     GIR_EraseRootFromParent_Done,
     /* 408016 */   // Label 6015: @408016
     /* 408016 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(408151), // Rule ID 12931 //
     /* 408021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 408068 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408073 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408105 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 408108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408149 */     GIR_RootConstrainSelectedInstOperands,
     /* 408150 */     // GIR_Coverage, 12931,
     /* 408150 */     GIR_EraseRootFromParent_Done,
     /* 408151 */   // Label 6016: @408151
     /* 408151 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(408286), // Rule ID 11951 //
     /* 408156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408203 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408208 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408240 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408284 */     GIR_RootConstrainSelectedInstOperands,
     /* 408285 */     // GIR_Coverage, 11951,
     /* 408285 */     GIR_EraseRootFromParent_Done,
     /* 408286 */   // Label 6017: @408286
     /* 408286 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(408421), // Rule ID 11952 //
     /* 408291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408338 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408375 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408419 */     GIR_RootConstrainSelectedInstOperands,
     /* 408420 */     // GIR_Coverage, 11952,
     /* 408420 */     GIR_EraseRootFromParent_Done,
     /* 408421 */   // Label 6018: @408421
     /* 408421 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(408556), // Rule ID 11955 //
     /* 408426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408473 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408510 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408554 */     GIR_RootConstrainSelectedInstOperands,
     /* 408555 */     // GIR_Coverage, 11955,
     /* 408555 */     GIR_EraseRootFromParent_Done,
     /* 408556 */   // Label 6019: @408556
     /* 408556 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(408691), // Rule ID 11956 //
     /* 408561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408645 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408689 */     GIR_RootConstrainSelectedInstOperands,
     /* 408690 */     // GIR_Coverage, 11956,
     /* 408690 */     GIR_EraseRootFromParent_Done,
     /* 408691 */   // Label 6020: @408691
     /* 408691 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(408826), // Rule ID 12431 //
     /* 408696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408748 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408780 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408824 */     GIR_RootConstrainSelectedInstOperands,
     /* 408825 */     // GIR_Coverage, 12431,
     /* 408825 */     GIR_EraseRootFromParent_Done,
     /* 408826 */   // Label 6021: @408826
     /* 408826 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(408961), // Rule ID 12432 //
     /* 408831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408878 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408883 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408915 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408959 */     GIR_RootConstrainSelectedInstOperands,
     /* 408960 */     // GIR_Coverage, 12432,
     /* 408960 */     GIR_EraseRootFromParent_Done,
     /* 408961 */   // Label 6022: @408961
     /* 408961 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(409096), // Rule ID 12435 //
     /* 408966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409013 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409050 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409094 */     GIR_RootConstrainSelectedInstOperands,
     /* 409095 */     // GIR_Coverage, 12435,
     /* 409095 */     GIR_EraseRootFromParent_Done,
     /* 409096 */   // Label 6023: @409096
     /* 409096 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(409231), // Rule ID 12436 //
     /* 409101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409185 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409229 */     GIR_RootConstrainSelectedInstOperands,
     /* 409230 */     // GIR_Coverage, 12436,
     /* 409230 */     GIR_EraseRootFromParent_Done,
     /* 409231 */   // Label 6024: @409231
     /* 409231 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(409366), // Rule ID 12911 //
     /* 409236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409320 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409364 */     GIR_RootConstrainSelectedInstOperands,
     /* 409365 */     // GIR_Coverage, 12911,
     /* 409365 */     GIR_EraseRootFromParent_Done,
     /* 409366 */   // Label 6025: @409366
     /* 409366 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(409501), // Rule ID 12912 //
     /* 409371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409423 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409455 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409499 */     GIR_RootConstrainSelectedInstOperands,
     /* 409500 */     // GIR_Coverage, 12912,
     /* 409500 */     GIR_EraseRootFromParent_Done,
     /* 409501 */   // Label 6026: @409501
     /* 409501 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(409636), // Rule ID 12915 //
     /* 409506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409553 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409558 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409590 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409634 */     GIR_RootConstrainSelectedInstOperands,
     /* 409635 */     // GIR_Coverage, 12915,
     /* 409635 */     GIR_EraseRootFromParent_Done,
     /* 409636 */   // Label 6027: @409636
     /* 409636 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(409771), // Rule ID 12916 //
     /* 409641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409688 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409693 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409725 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409769 */     GIR_RootConstrainSelectedInstOperands,
     /* 409770 */     // GIR_Coverage, 12916,
     /* 409770 */     GIR_EraseRootFromParent_Done,
     /* 409771 */   // Label 6028: @409771
     /* 409771 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(409906), // Rule ID 7629 //
     /* 409776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409823 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409860 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409904 */     GIR_RootConstrainSelectedInstOperands,
     /* 409905 */     // GIR_Coverage, 7629,
     /* 409905 */     GIR_EraseRootFromParent_Done,
     /* 409906 */   // Label 6029: @409906
     /* 409906 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(410041), // Rule ID 7661 //
     /* 409911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409995 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410039 */     GIR_RootConstrainSelectedInstOperands,
     /* 410040 */     // GIR_Coverage, 7661,
     /* 410040 */     GIR_EraseRootFromParent_Done,
     /* 410041 */   // Label 6030: @410041
     /* 410041 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(410176), // Rule ID 7693 //
     /* 410046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410130 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410174 */     GIR_RootConstrainSelectedInstOperands,
     /* 410175 */     // GIR_Coverage, 7693,
     /* 410175 */     GIR_EraseRootFromParent_Done,
     /* 410176 */   // Label 6031: @410176
     /* 410176 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(410311), // Rule ID 11965 //
     /* 410181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410233 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410265 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410309 */     GIR_RootConstrainSelectedInstOperands,
     /* 410310 */     // GIR_Coverage, 11965,
     /* 410310 */     GIR_EraseRootFromParent_Done,
     /* 410311 */   // Label 6032: @410311
     /* 410311 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(410446), // Rule ID 11968 //
     /* 410316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410363 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410368 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410400 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410444 */     GIR_RootConstrainSelectedInstOperands,
     /* 410445 */     // GIR_Coverage, 11968,
     /* 410445 */     GIR_EraseRootFromParent_Done,
     /* 410446 */   // Label 6033: @410446
     /* 410446 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(410581), // Rule ID 11969 //
     /* 410451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410498 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410535 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410579 */     GIR_RootConstrainSelectedInstOperands,
     /* 410580 */     // GIR_Coverage, 11969,
     /* 410580 */     GIR_EraseRootFromParent_Done,
     /* 410581 */   // Label 6034: @410581
     /* 410581 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(410716), // Rule ID 12445 //
     /* 410586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410670 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410714 */     GIR_RootConstrainSelectedInstOperands,
     /* 410715 */     // GIR_Coverage, 12445,
     /* 410715 */     GIR_EraseRootFromParent_Done,
     /* 410716 */   // Label 6035: @410716
     /* 410716 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(410851), // Rule ID 12448 //
     /* 410721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410805 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410849 */     GIR_RootConstrainSelectedInstOperands,
     /* 410850 */     // GIR_Coverage, 12448,
     /* 410850 */     GIR_EraseRootFromParent_Done,
     /* 410851 */   // Label 6036: @410851
     /* 410851 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(410986), // Rule ID 12449 //
     /* 410856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410940 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410984 */     GIR_RootConstrainSelectedInstOperands,
     /* 410985 */     // GIR_Coverage, 12449,
     /* 410985 */     GIR_EraseRootFromParent_Done,
     /* 410986 */   // Label 6037: @410986
     /* 410986 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(411121), // Rule ID 12925 //
     /* 410991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411038 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411043 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411075 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411119 */     GIR_RootConstrainSelectedInstOperands,
     /* 411120 */     // GIR_Coverage, 12925,
     /* 411120 */     GIR_EraseRootFromParent_Done,
     /* 411121 */   // Label 6038: @411121
     /* 411121 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(411256), // Rule ID 12928 //
     /* 411126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411173 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411178 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411210 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411254 */     GIR_RootConstrainSelectedInstOperands,
     /* 411255 */     // GIR_Coverage, 12928,
     /* 411255 */     GIR_EraseRootFromParent_Done,
     /* 411256 */   // Label 6039: @411256
     /* 411256 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(411391), // Rule ID 12929 //
     /* 411261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411345 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411389 */     GIR_RootConstrainSelectedInstOperands,
     /* 411390 */     // GIR_Coverage, 12929,
     /* 411390 */     GIR_EraseRootFromParent_Done,
     /* 411391 */   // Label 6040: @411391
     /* 411391 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(411526), // Rule ID 7628 //
     /* 411396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411443 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411480 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411524 */     GIR_RootConstrainSelectedInstOperands,
     /* 411525 */     // GIR_Coverage, 7628,
     /* 411525 */     GIR_EraseRootFromParent_Done,
     /* 411526 */   // Label 6041: @411526
     /* 411526 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(411661), // Rule ID 7660 //
     /* 411531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411583 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411615 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411659 */     GIR_RootConstrainSelectedInstOperands,
     /* 411660 */     // GIR_Coverage, 7660,
     /* 411660 */     GIR_EraseRootFromParent_Done,
     /* 411661 */   // Label 6042: @411661
     /* 411661 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(411796), // Rule ID 7692 //
     /* 411666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411713 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411718 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411750 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411794 */     GIR_RootConstrainSelectedInstOperands,
     /* 411795 */     // GIR_Coverage, 7692,
     /* 411795 */     GIR_EraseRootFromParent_Done,
     /* 411796 */   // Label 6043: @411796
     /* 411796 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(411931), // Rule ID 11950 //
     /* 411801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411848 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411853 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411885 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411929 */     GIR_RootConstrainSelectedInstOperands,
     /* 411930 */     // GIR_Coverage, 11950,
     /* 411930 */     GIR_EraseRootFromParent_Done,
     /* 411931 */   // Label 6044: @411931
     /* 411931 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(412066), // Rule ID 11953 //
     /* 411936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411983 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411988 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412020 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412064 */     GIR_RootConstrainSelectedInstOperands,
     /* 412065 */     // GIR_Coverage, 11953,
     /* 412065 */     GIR_EraseRootFromParent_Done,
     /* 412066 */   // Label 6045: @412066
     /* 412066 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(412201), // Rule ID 11954 //
     /* 412071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412123 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412155 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412199 */     GIR_RootConstrainSelectedInstOperands,
     /* 412200 */     // GIR_Coverage, 11954,
     /* 412200 */     GIR_EraseRootFromParent_Done,
     /* 412201 */   // Label 6046: @412201
     /* 412201 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(412336), // Rule ID 12430 //
     /* 412206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412290 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412334 */     GIR_RootConstrainSelectedInstOperands,
     /* 412335 */     // GIR_Coverage, 12430,
     /* 412335 */     GIR_EraseRootFromParent_Done,
     /* 412336 */   // Label 6047: @412336
     /* 412336 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(412471), // Rule ID 12433 //
     /* 412341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412425 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412469 */     GIR_RootConstrainSelectedInstOperands,
     /* 412470 */     // GIR_Coverage, 12433,
     /* 412470 */     GIR_EraseRootFromParent_Done,
     /* 412471 */   // Label 6048: @412471
     /* 412471 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(412606), // Rule ID 12434 //
     /* 412476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412528 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412560 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412604 */     GIR_RootConstrainSelectedInstOperands,
     /* 412605 */     // GIR_Coverage, 12434,
     /* 412605 */     GIR_EraseRootFromParent_Done,
     /* 412606 */   // Label 6049: @412606
     /* 412606 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(412741), // Rule ID 12910 //
     /* 412611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412658 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412663 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412695 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412739 */     GIR_RootConstrainSelectedInstOperands,
     /* 412740 */     // GIR_Coverage, 12910,
     /* 412740 */     GIR_EraseRootFromParent_Done,
     /* 412741 */   // Label 6050: @412741
     /* 412741 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(412876), // Rule ID 12913 //
     /* 412746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412830 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412874 */     GIR_RootConstrainSelectedInstOperands,
     /* 412875 */     // GIR_Coverage, 12913,
     /* 412875 */     GIR_EraseRootFromParent_Done,
     /* 412876 */   // Label 6051: @412876
     /* 412876 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(413011), // Rule ID 12914 //
     /* 412881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412965 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413009 */     GIR_RootConstrainSelectedInstOperands,
     /* 413010 */     // GIR_Coverage, 12914,
     /* 413010 */     GIR_EraseRootFromParent_Done,
     /* 413011 */   // Label 6052: @413011
     /* 413011 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(413146), // Rule ID 11936 //
     /* 413016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413063 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413068 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413100 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413144 */     GIR_RootConstrainSelectedInstOperands,
     /* 413145 */     // GIR_Coverage, 11936,
     /* 413145 */     GIR_EraseRootFromParent_Done,
     /* 413146 */   // Label 6053: @413146
     /* 413146 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(413281), // Rule ID 11937 //
     /* 413151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413198 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413203 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413235 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413279 */     GIR_RootConstrainSelectedInstOperands,
     /* 413280 */     // GIR_Coverage, 11937,
     /* 413280 */     GIR_EraseRootFromParent_Done,
     /* 413281 */   // Label 6054: @413281
     /* 413281 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(413416), // Rule ID 11940 //
     /* 413286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413333 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413338 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413370 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413414 */     GIR_RootConstrainSelectedInstOperands,
     /* 413415 */     // GIR_Coverage, 11940,
     /* 413415 */     GIR_EraseRootFromParent_Done,
     /* 413416 */   // Label 6055: @413416
     /* 413416 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(413551), // Rule ID 11941 //
     /* 413421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413468 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413473 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413505 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413549 */     GIR_RootConstrainSelectedInstOperands,
     /* 413550 */     // GIR_Coverage, 11941,
     /* 413550 */     GIR_EraseRootFromParent_Done,
     /* 413551 */   // Label 6056: @413551
     /* 413551 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(413686), // Rule ID 12416 //
     /* 413556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413640 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413684 */     GIR_RootConstrainSelectedInstOperands,
     /* 413685 */     // GIR_Coverage, 12416,
     /* 413685 */     GIR_EraseRootFromParent_Done,
     /* 413686 */   // Label 6057: @413686
     /* 413686 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(413821), // Rule ID 12417 //
     /* 413691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413775 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413819 */     GIR_RootConstrainSelectedInstOperands,
     /* 413820 */     // GIR_Coverage, 12417,
     /* 413820 */     GIR_EraseRootFromParent_Done,
     /* 413821 */   // Label 6058: @413821
     /* 413821 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(413956), // Rule ID 12420 //
     /* 413826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413878 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413910 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413954 */     GIR_RootConstrainSelectedInstOperands,
     /* 413955 */     // GIR_Coverage, 12420,
     /* 413955 */     GIR_EraseRootFromParent_Done,
     /* 413956 */   // Label 6059: @413956
     /* 413956 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(414091), // Rule ID 12421 //
     /* 413961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414008 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414013 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414045 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 414048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414089 */     GIR_RootConstrainSelectedInstOperands,
     /* 414090 */     // GIR_Coverage, 12421,
     /* 414090 */     GIR_EraseRootFromParent_Done,
     /* 414091 */   // Label 6060: @414091
     /* 414091 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(414226), // Rule ID 12896 //
     /* 414096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414143 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414180 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414224 */     GIR_RootConstrainSelectedInstOperands,
     /* 414225 */     // GIR_Coverage, 12896,
     /* 414225 */     GIR_EraseRootFromParent_Done,
     /* 414226 */   // Label 6061: @414226
     /* 414226 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(414361), // Rule ID 12897 //
     /* 414231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414315 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414359 */     GIR_RootConstrainSelectedInstOperands,
     /* 414360 */     // GIR_Coverage, 12897,
     /* 414360 */     GIR_EraseRootFromParent_Done,
     /* 414361 */   // Label 6062: @414361
     /* 414361 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(414496), // Rule ID 12900 //
     /* 414366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414450 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414494 */     GIR_RootConstrainSelectedInstOperands,
     /* 414495 */     // GIR_Coverage, 12900,
     /* 414495 */     GIR_EraseRootFromParent_Done,
     /* 414496 */   // Label 6063: @414496
     /* 414496 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(414631), // Rule ID 12901 //
     /* 414501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414553 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414585 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414629 */     GIR_RootConstrainSelectedInstOperands,
     /* 414630 */     // GIR_Coverage, 12901,
     /* 414630 */     GIR_EraseRootFromParent_Done,
     /* 414631 */   // Label 6064: @414631
     /* 414631 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(414766), // Rule ID 11921 //
     /* 414636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414683 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414688 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414720 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414764 */     GIR_RootConstrainSelectedInstOperands,
     /* 414765 */     // GIR_Coverage, 11921,
     /* 414765 */     GIR_EraseRootFromParent_Done,
     /* 414766 */   // Label 6065: @414766
     /* 414766 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(414901), // Rule ID 11922 //
     /* 414771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414818 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414823 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414855 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414899 */     GIR_RootConstrainSelectedInstOperands,
     /* 414900 */     // GIR_Coverage, 11922,
     /* 414900 */     GIR_EraseRootFromParent_Done,
     /* 414901 */   // Label 6066: @414901
     /* 414901 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(415036), // Rule ID 11925 //
     /* 414906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414953 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414990 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415034 */     GIR_RootConstrainSelectedInstOperands,
     /* 415035 */     // GIR_Coverage, 11925,
     /* 415035 */     GIR_EraseRootFromParent_Done,
     /* 415036 */   // Label 6067: @415036
     /* 415036 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(415171), // Rule ID 11926 //
     /* 415041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 415044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415088 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415125 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 415128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415169 */     GIR_RootConstrainSelectedInstOperands,
     /* 415170 */     // GIR_Coverage, 11926,
     /* 415170 */     GIR_EraseRootFromParent_Done,
     /* 415171 */   // Label 6068: @415171
     /* 415171 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(415306), // Rule ID 12401 //
     /* 415176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415260 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415304 */     GIR_RootConstrainSelectedInstOperands,
     /* 415305 */     // GIR_Coverage, 12401,
     /* 415305 */     GIR_EraseRootFromParent_Done,
     /* 415306 */   // Label 6069: @415306
     /* 415306 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(415441), // Rule ID 12402 //
     /* 415311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415363 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415395 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415439 */     GIR_RootConstrainSelectedInstOperands,
     /* 415440 */     // GIR_Coverage, 12402,
     /* 415440 */     GIR_EraseRootFromParent_Done,
     /* 415441 */   // Label 6070: @415441
     /* 415441 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(415576), // Rule ID 12405 //
     /* 415446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415493 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415498 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415530 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415574 */     GIR_RootConstrainSelectedInstOperands,
     /* 415575 */     // GIR_Coverage, 12405,
     /* 415575 */     GIR_EraseRootFromParent_Done,
     /* 415576 */   // Label 6071: @415576
     /* 415576 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(415711), // Rule ID 12406 //
     /* 415581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415628 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415633 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415665 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415709 */     GIR_RootConstrainSelectedInstOperands,
     /* 415710 */     // GIR_Coverage, 12406,
     /* 415710 */     GIR_EraseRootFromParent_Done,
     /* 415711 */   // Label 6072: @415711
     /* 415711 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(415846), // Rule ID 12881 //
     /* 415716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415768 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415800 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415844 */     GIR_RootConstrainSelectedInstOperands,
     /* 415845 */     // GIR_Coverage, 12881,
     /* 415845 */     GIR_EraseRootFromParent_Done,
     /* 415846 */   // Label 6073: @415846
     /* 415846 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(415981), // Rule ID 12882 //
     /* 415851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415935 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415979 */     GIR_RootConstrainSelectedInstOperands,
     /* 415980 */     // GIR_Coverage, 12882,
     /* 415980 */     GIR_EraseRootFromParent_Done,
     /* 415981 */   // Label 6074: @415981
     /* 415981 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(416116), // Rule ID 12885 //
     /* 415986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416038 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416070 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416114 */     GIR_RootConstrainSelectedInstOperands,
     /* 416115 */     // GIR_Coverage, 12885,
     /* 416115 */     GIR_EraseRootFromParent_Done,
     /* 416116 */   // Label 6075: @416116
     /* 416116 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(416251), // Rule ID 12886 //
     /* 416121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 416124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416168 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416173 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416205 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416249 */     GIR_RootConstrainSelectedInstOperands,
     /* 416250 */     // GIR_Coverage, 12886,
     /* 416250 */     GIR_EraseRootFromParent_Done,
     /* 416251 */   // Label 6076: @416251
     /* 416251 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(416386), // Rule ID 7627 //
     /* 416256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416303 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416340 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416384 */     GIR_RootConstrainSelectedInstOperands,
     /* 416385 */     // GIR_Coverage, 7627,
     /* 416385 */     GIR_EraseRootFromParent_Done,
     /* 416386 */   // Label 6077: @416386
     /* 416386 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(416521), // Rule ID 7659 //
     /* 416391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416438 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416475 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416519 */     GIR_RootConstrainSelectedInstOperands,
     /* 416520 */     // GIR_Coverage, 7659,
     /* 416520 */     GIR_EraseRootFromParent_Done,
     /* 416521 */   // Label 6078: @416521
     /* 416521 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(416656), // Rule ID 7691 //
     /* 416526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 416529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416578 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416610 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416654 */     GIR_RootConstrainSelectedInstOperands,
     /* 416655 */     // GIR_Coverage, 7691,
     /* 416655 */     GIR_EraseRootFromParent_Done,
     /* 416656 */   // Label 6079: @416656
     /* 416656 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(416791), // Rule ID 11935 //
     /* 416661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416713 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416745 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416789 */     GIR_RootConstrainSelectedInstOperands,
     /* 416790 */     // GIR_Coverage, 11935,
     /* 416790 */     GIR_EraseRootFromParent_Done,
     /* 416791 */   // Label 6080: @416791
     /* 416791 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(416926), // Rule ID 11938 //
     /* 416796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416848 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416880 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416924 */     GIR_RootConstrainSelectedInstOperands,
     /* 416925 */     // GIR_Coverage, 11938,
     /* 416925 */     GIR_EraseRootFromParent_Done,
     /* 416926 */   // Label 6081: @416926
     /* 416926 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(417061), // Rule ID 11939 //
     /* 416931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416978 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416983 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417015 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417059 */     GIR_RootConstrainSelectedInstOperands,
     /* 417060 */     // GIR_Coverage, 11939,
     /* 417060 */     GIR_EraseRootFromParent_Done,
     /* 417061 */   // Label 6082: @417061
     /* 417061 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(417196), // Rule ID 12415 //
     /* 417066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417113 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417118 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417150 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417194 */     GIR_RootConstrainSelectedInstOperands,
     /* 417195 */     // GIR_Coverage, 12415,
     /* 417195 */     GIR_EraseRootFromParent_Done,
     /* 417196 */   // Label 6083: @417196
     /* 417196 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(417331), // Rule ID 12418 //
     /* 417201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417285 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417329 */     GIR_RootConstrainSelectedInstOperands,
     /* 417330 */     // GIR_Coverage, 12418,
     /* 417330 */     GIR_EraseRootFromParent_Done,
     /* 417331 */   // Label 6084: @417331
     /* 417331 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(417466), // Rule ID 12419 //
     /* 417336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417420 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417464 */     GIR_RootConstrainSelectedInstOperands,
     /* 417465 */     // GIR_Coverage, 12419,
     /* 417465 */     GIR_EraseRootFromParent_Done,
     /* 417466 */   // Label 6085: @417466
     /* 417466 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(417601), // Rule ID 12895 //
     /* 417471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417523 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417555 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417599 */     GIR_RootConstrainSelectedInstOperands,
     /* 417600 */     // GIR_Coverage, 12895,
     /* 417600 */     GIR_EraseRootFromParent_Done,
     /* 417601 */   // Label 6086: @417601
     /* 417601 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(417736), // Rule ID 12898 //
     /* 417606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417658 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417690 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417734 */     GIR_RootConstrainSelectedInstOperands,
     /* 417735 */     // GIR_Coverage, 12898,
     /* 417735 */     GIR_EraseRootFromParent_Done,
     /* 417736 */   // Label 6087: @417736
     /* 417736 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(417871), // Rule ID 12899 //
     /* 417741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417825 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417869 */     GIR_RootConstrainSelectedInstOperands,
     /* 417870 */     // GIR_Coverage, 12899,
     /* 417870 */     GIR_EraseRootFromParent_Done,
     /* 417871 */   // Label 6088: @417871
     /* 417871 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(418006), // Rule ID 7626 //
     /* 417876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 417923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417960 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418004 */     GIR_RootConstrainSelectedInstOperands,
     /* 418005 */     // GIR_Coverage, 7626,
     /* 418005 */     GIR_EraseRootFromParent_Done,
     /* 418006 */   // Label 6089: @418006
     /* 418006 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(418141), // Rule ID 7658 //
     /* 418011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418095 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418139 */     GIR_RootConstrainSelectedInstOperands,
     /* 418140 */     // GIR_Coverage, 7658,
     /* 418140 */     GIR_EraseRootFromParent_Done,
     /* 418141 */   // Label 6090: @418141
     /* 418141 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(418276), // Rule ID 7690 //
     /* 418146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418198 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418230 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418274 */     GIR_RootConstrainSelectedInstOperands,
     /* 418275 */     // GIR_Coverage, 7690,
     /* 418275 */     GIR_EraseRootFromParent_Done,
     /* 418276 */   // Label 6091: @418276
     /* 418276 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(418411), // Rule ID 11920 //
     /* 418281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418328 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418333 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418365 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418409 */     GIR_RootConstrainSelectedInstOperands,
     /* 418410 */     // GIR_Coverage, 11920,
     /* 418410 */     GIR_EraseRootFromParent_Done,
     /* 418411 */   // Label 6092: @418411
     /* 418411 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(418546), // Rule ID 11923 //
     /* 418416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418463 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418468 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418500 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418544 */     GIR_RootConstrainSelectedInstOperands,
     /* 418545 */     // GIR_Coverage, 11923,
     /* 418545 */     GIR_EraseRootFromParent_Done,
     /* 418546 */   // Label 6093: @418546
     /* 418546 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(418681), // Rule ID 11924 //
     /* 418551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418635 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418679 */     GIR_RootConstrainSelectedInstOperands,
     /* 418680 */     // GIR_Coverage, 11924,
     /* 418680 */     GIR_EraseRootFromParent_Done,
     /* 418681 */   // Label 6094: @418681
     /* 418681 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(418816), // Rule ID 12400 //
     /* 418686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418733 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418770 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418814 */     GIR_RootConstrainSelectedInstOperands,
     /* 418815 */     // GIR_Coverage, 12400,
     /* 418815 */     GIR_EraseRootFromParent_Done,
     /* 418816 */   // Label 6095: @418816
     /* 418816 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(418951), // Rule ID 12403 //
     /* 418821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418873 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418905 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418949 */     GIR_RootConstrainSelectedInstOperands,
     /* 418950 */     // GIR_Coverage, 12403,
     /* 418950 */     GIR_EraseRootFromParent_Done,
     /* 418951 */   // Label 6096: @418951
     /* 418951 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(419086), // Rule ID 12404 //
     /* 418956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419003 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419008 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419040 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419084 */     GIR_RootConstrainSelectedInstOperands,
     /* 419085 */     // GIR_Coverage, 12404,
     /* 419085 */     GIR_EraseRootFromParent_Done,
     /* 419086 */   // Label 6097: @419086
     /* 419086 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(419221), // Rule ID 12880 //
     /* 419091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 419134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419138 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419143 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419175 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 419185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 419190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419219 */     GIR_RootConstrainSelectedInstOperands,
     /* 419220 */     // GIR_Coverage, 12880,
     /* 419220 */     GIR_EraseRootFromParent_Done,
     /* 419221 */   // Label 6098: @419221
     /* 419221 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(419356), // Rule ID 12883 //
     /* 419226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 419269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419273 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419310 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419354 */     GIR_RootConstrainSelectedInstOperands,
     /* 419355 */     // GIR_Coverage, 12883,
     /* 419355 */     GIR_EraseRootFromParent_Done,
     /* 419356 */   // Label 6099: @419356
     /* 419356 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(419491), // Rule ID 12884 //
     /* 419361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 419404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419445 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419489 */     GIR_RootConstrainSelectedInstOperands,
     /* 419490 */     // GIR_Coverage, 12884,
     /* 419490 */     GIR_EraseRootFromParent_Done,
     /* 419491 */   // Label 6100: @419491
     /* 419491 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(419626), // Rule ID 12006 //
     /* 419496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419580 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419624 */     GIR_RootConstrainSelectedInstOperands,
     /* 419625 */     // GIR_Coverage, 12006,
     /* 419625 */     GIR_EraseRootFromParent_Done,
     /* 419626 */   // Label 6101: @419626
     /* 419626 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(419761), // Rule ID 12007 //
     /* 419631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419683 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419715 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419759 */     GIR_RootConstrainSelectedInstOperands,
     /* 419760 */     // GIR_Coverage, 12007,
     /* 419760 */     GIR_EraseRootFromParent_Done,
     /* 419761 */   // Label 6102: @419761
     /* 419761 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(419896), // Rule ID 12008 //
     /* 419766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419813 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419818 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419850 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 419860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 419865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419894 */     GIR_RootConstrainSelectedInstOperands,
     /* 419895 */     // GIR_Coverage, 12008,
     /* 419895 */     GIR_EraseRootFromParent_Done,
     /* 419896 */   // Label 6103: @419896
     /* 419896 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(420031), // Rule ID 12009 //
     /* 419901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419948 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419953 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419985 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 419995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420029 */     GIR_RootConstrainSelectedInstOperands,
     /* 420030 */     // GIR_Coverage, 12009,
     /* 420030 */     GIR_EraseRootFromParent_Done,
     /* 420031 */   // Label 6104: @420031
     /* 420031 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(420166), // Rule ID 12486 //
     /* 420036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420088 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420120 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420164 */     GIR_RootConstrainSelectedInstOperands,
     /* 420165 */     // GIR_Coverage, 12486,
     /* 420165 */     GIR_EraseRootFromParent_Done,
     /* 420166 */   // Label 6105: @420166
     /* 420166 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(420301), // Rule ID 12487 //
     /* 420171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420255 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420299 */     GIR_RootConstrainSelectedInstOperands,
     /* 420300 */     // GIR_Coverage, 12487,
     /* 420300 */     GIR_EraseRootFromParent_Done,
     /* 420301 */   // Label 6106: @420301
     /* 420301 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(420436), // Rule ID 12488 //
     /* 420306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420390 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420434 */     GIR_RootConstrainSelectedInstOperands,
     /* 420435 */     // GIR_Coverage, 12488,
     /* 420435 */     GIR_EraseRootFromParent_Done,
     /* 420436 */   // Label 6107: @420436
     /* 420436 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(420571), // Rule ID 12489 //
     /* 420441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420488 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420493 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420525 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420569 */     GIR_RootConstrainSelectedInstOperands,
     /* 420570 */     // GIR_Coverage, 12489,
     /* 420570 */     GIR_EraseRootFromParent_Done,
     /* 420571 */   // Label 6108: @420571
     /* 420571 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(420706), // Rule ID 12966 //
     /* 420576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420623 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420628 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420660 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420704 */     GIR_RootConstrainSelectedInstOperands,
     /* 420705 */     // GIR_Coverage, 12966,
     /* 420705 */     GIR_EraseRootFromParent_Done,
     /* 420706 */   // Label 6109: @420706
     /* 420706 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(420841), // Rule ID 12967 //
     /* 420711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420758 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420795 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420839 */     GIR_RootConstrainSelectedInstOperands,
     /* 420840 */     // GIR_Coverage, 12967,
     /* 420840 */     GIR_EraseRootFromParent_Done,
     /* 420841 */   // Label 6110: @420841
     /* 420841 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(420976), // Rule ID 12968 //
     /* 420846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420930 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420974 */     GIR_RootConstrainSelectedInstOperands,
     /* 420975 */     // GIR_Coverage, 12968,
     /* 420975 */     GIR_EraseRootFromParent_Done,
     /* 420976 */   // Label 6111: @420976
     /* 420976 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(421111), // Rule ID 12969 //
     /* 420981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 421028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421065 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 421068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421109 */     GIR_RootConstrainSelectedInstOperands,
     /* 421110 */     // GIR_Coverage, 12969,
     /* 421110 */     GIR_EraseRootFromParent_Done,
     /* 421111 */   // Label 6112: @421111
     /* 421111 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(421246), // Rule ID 11946 //
     /* 421116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421168 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421200 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421244 */     GIR_RootConstrainSelectedInstOperands,
     /* 421245 */     // GIR_Coverage, 11946,
     /* 421245 */     GIR_EraseRootFromParent_Done,
     /* 421246 */   // Label 6113: @421246
     /* 421246 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(421381), // Rule ID 11947 //
     /* 421251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421298 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421303 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421335 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421379 */     GIR_RootConstrainSelectedInstOperands,
     /* 421380 */     // GIR_Coverage, 11947,
     /* 421380 */     GIR_EraseRootFromParent_Done,
     /* 421381 */   // Label 6114: @421381
     /* 421381 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(421516), // Rule ID 11948 //
     /* 421386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421433 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421438 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421443 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421470 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421514 */     GIR_RootConstrainSelectedInstOperands,
     /* 421515 */     // GIR_Coverage, 11948,
     /* 421515 */     GIR_EraseRootFromParent_Done,
     /* 421516 */   // Label 6115: @421516
     /* 421516 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(421651), // Rule ID 11949 //
     /* 421521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421605 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421649 */     GIR_RootConstrainSelectedInstOperands,
     /* 421650 */     // GIR_Coverage, 11949,
     /* 421650 */     GIR_EraseRootFromParent_Done,
     /* 421651 */   // Label 6116: @421651
     /* 421651 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(421786), // Rule ID 12426 //
     /* 421656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421740 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421784 */     GIR_RootConstrainSelectedInstOperands,
     /* 421785 */     // GIR_Coverage, 12426,
     /* 421785 */     GIR_EraseRootFromParent_Done,
     /* 421786 */   // Label 6117: @421786
     /* 421786 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(421921), // Rule ID 12427 //
     /* 421791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421875 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421919 */     GIR_RootConstrainSelectedInstOperands,
     /* 421920 */     // GIR_Coverage, 12427,
     /* 421920 */     GIR_EraseRootFromParent_Done,
     /* 421921 */   // Label 6118: @421921
     /* 421921 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(422056), // Rule ID 12428 //
     /* 421926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421973 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421978 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422010 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 422013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422054 */     GIR_RootConstrainSelectedInstOperands,
     /* 422055 */     // GIR_Coverage, 12428,
     /* 422055 */     GIR_EraseRootFromParent_Done,
     /* 422056 */   // Label 6119: @422056
     /* 422056 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(422191), // Rule ID 12429 //
     /* 422061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 422064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 422068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422108 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422113 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422118 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422145 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 422148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422189 */     GIR_RootConstrainSelectedInstOperands,
     /* 422190 */     // GIR_Coverage, 12429,
     /* 422190 */     GIR_EraseRootFromParent_Done,
     /* 422191 */   // Label 6120: @422191
     /* 422191 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(422326), // Rule ID 12906 //
     /* 422196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422280 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422324 */     GIR_RootConstrainSelectedInstOperands,
     /* 422325 */     // GIR_Coverage, 12906,
     /* 422325 */     GIR_EraseRootFromParent_Done,
     /* 422326 */   // Label 6121: @422326
     /* 422326 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(422461), // Rule ID 12907 //
     /* 422331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422415 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422459 */     GIR_RootConstrainSelectedInstOperands,
     /* 422460 */     // GIR_Coverage, 12907,
     /* 422460 */     GIR_EraseRootFromParent_Done,
     /* 422461 */   // Label 6122: @422461
     /* 422461 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(422596), // Rule ID 12908 //
     /* 422466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422550 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422594 */     GIR_RootConstrainSelectedInstOperands,
     /* 422595 */     // GIR_Coverage, 12908,
     /* 422595 */     GIR_EraseRootFromParent_Done,
     /* 422596 */   // Label 6123: @422596
     /* 422596 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(422731), // Rule ID 12909 //
     /* 422601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422685 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422729 */     GIR_RootConstrainSelectedInstOperands,
     /* 422730 */     // GIR_Coverage, 12909,
     /* 422730 */     GIR_EraseRootFromParent_Done,
     /* 422731 */   // Label 6124: @422731
     /* 422731 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(422866), // Rule ID 11991 //
     /* 422736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422783 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422820 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422864 */     GIR_RootConstrainSelectedInstOperands,
     /* 422865 */     // GIR_Coverage, 11991,
     /* 422865 */     GIR_EraseRootFromParent_Done,
     /* 422866 */   // Label 6125: @422866
     /* 422866 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(423001), // Rule ID 11992 //
     /* 422871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422918 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422955 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422999 */     GIR_RootConstrainSelectedInstOperands,
     /* 423000 */     // GIR_Coverage, 11992,
     /* 423000 */     GIR_EraseRootFromParent_Done,
     /* 423001 */   // Label 6126: @423001
     /* 423001 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(423136), // Rule ID 11993 //
     /* 423006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 423009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423090 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 423093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423134 */     GIR_RootConstrainSelectedInstOperands,
     /* 423135 */     // GIR_Coverage, 11993,
     /* 423135 */     GIR_EraseRootFromParent_Done,
     /* 423136 */   // Label 6127: @423136
     /* 423136 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(423271), // Rule ID 11994 //
     /* 423141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 423144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423225 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 423228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423269 */     GIR_RootConstrainSelectedInstOperands,
     /* 423270 */     // GIR_Coverage, 11994,
     /* 423270 */     GIR_EraseRootFromParent_Done,
     /* 423271 */   // Label 6128: @423271
     /* 423271 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(423406), // Rule ID 12471 //
     /* 423276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423328 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423360 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423404 */     GIR_RootConstrainSelectedInstOperands,
     /* 423405 */     // GIR_Coverage, 12471,
     /* 423405 */     GIR_EraseRootFromParent_Done,
     /* 423406 */   // Label 6129: @423406
     /* 423406 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(423541), // Rule ID 12472 //
     /* 423411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423458 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423463 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423495 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423539 */     GIR_RootConstrainSelectedInstOperands,
     /* 423540 */     // GIR_Coverage, 12472,
     /* 423540 */     GIR_EraseRootFromParent_Done,
     /* 423541 */   // Label 6130: @423541
     /* 423541 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(423676), // Rule ID 12473 //
     /* 423546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423593 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423630 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423674 */     GIR_RootConstrainSelectedInstOperands,
     /* 423675 */     // GIR_Coverage, 12473,
     /* 423675 */     GIR_EraseRootFromParent_Done,
     /* 423676 */   // Label 6131: @423676
     /* 423676 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(423811), // Rule ID 12474 //
     /* 423681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423765 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423809 */     GIR_RootConstrainSelectedInstOperands,
     /* 423810 */     // GIR_Coverage, 12474,
     /* 423810 */     GIR_EraseRootFromParent_Done,
     /* 423811 */   // Label 6132: @423811
     /* 423811 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(423946), // Rule ID 12951 //
     /* 423816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423900 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423944 */     GIR_RootConstrainSelectedInstOperands,
     /* 423945 */     // GIR_Coverage, 12951,
     /* 423945 */     GIR_EraseRootFromParent_Done,
     /* 423946 */   // Label 6133: @423946
     /* 423946 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(424081), // Rule ID 12952 //
     /* 423951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424035 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424079 */     GIR_RootConstrainSelectedInstOperands,
     /* 424080 */     // GIR_Coverage, 12952,
     /* 424080 */     GIR_EraseRootFromParent_Done,
     /* 424081 */   // Label 6134: @424081
     /* 424081 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(424216), // Rule ID 12953 //
     /* 424086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 424089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424138 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424170 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424214 */     GIR_RootConstrainSelectedInstOperands,
     /* 424215 */     // GIR_Coverage, 12953,
     /* 424215 */     GIR_EraseRootFromParent_Done,
     /* 424216 */   // Label 6135: @424216
     /* 424216 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(424351), // Rule ID 12954 //
     /* 424221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 424224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424268 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424273 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424305 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424349 */     GIR_RootConstrainSelectedInstOperands,
     /* 424350 */     // GIR_Coverage, 12954,
     /* 424350 */     GIR_EraseRootFromParent_Done,
     /* 424351 */   // Label 6136: @424351
     /* 424351 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(424486), // Rule ID 11931 //
     /* 424356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424440 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424484 */     GIR_RootConstrainSelectedInstOperands,
     /* 424485 */     // GIR_Coverage, 11931,
     /* 424485 */     GIR_EraseRootFromParent_Done,
     /* 424486 */   // Label 6137: @424486
     /* 424486 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(424621), // Rule ID 11932 //
     /* 424491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424575 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424619 */     GIR_RootConstrainSelectedInstOperands,
     /* 424620 */     // GIR_Coverage, 11932,
     /* 424620 */     GIR_EraseRootFromParent_Done,
     /* 424621 */   // Label 6138: @424621
     /* 424621 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(424756), // Rule ID 11933 //
     /* 424626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424710 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424754 */     GIR_RootConstrainSelectedInstOperands,
     /* 424755 */     // GIR_Coverage, 11933,
     /* 424755 */     GIR_EraseRootFromParent_Done,
     /* 424756 */   // Label 6139: @424756
     /* 424756 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(424891), // Rule ID 11934 //
     /* 424761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424813 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424845 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424889 */     GIR_RootConstrainSelectedInstOperands,
     /* 424890 */     // GIR_Coverage, 11934,
     /* 424890 */     GIR_EraseRootFromParent_Done,
     /* 424891 */   // Label 6140: @424891
     /* 424891 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(425026), // Rule ID 12411 //
     /* 424896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424943 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424948 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424980 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425024 */     GIR_RootConstrainSelectedInstOperands,
     /* 425025 */     // GIR_Coverage, 12411,
     /* 425025 */     GIR_EraseRootFromParent_Done,
     /* 425026 */   // Label 6141: @425026
     /* 425026 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(425161), // Rule ID 12412 //
     /* 425031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425078 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425115 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 425118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425159 */     GIR_RootConstrainSelectedInstOperands,
     /* 425160 */     // GIR_Coverage, 12412,
     /* 425160 */     GIR_EraseRootFromParent_Done,
     /* 425161 */   // Label 6142: @425161
     /* 425161 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(425296), // Rule ID 12413 //
     /* 425166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425250 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 425253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425294 */     GIR_RootConstrainSelectedInstOperands,
     /* 425295 */     // GIR_Coverage, 12413,
     /* 425295 */     GIR_EraseRootFromParent_Done,
     /* 425296 */   // Label 6143: @425296
     /* 425296 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(425431), // Rule ID 12414 //
     /* 425301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425385 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 425388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425429 */     GIR_RootConstrainSelectedInstOperands,
     /* 425430 */     // GIR_Coverage, 12414,
     /* 425430 */     GIR_EraseRootFromParent_Done,
     /* 425431 */   // Label 6144: @425431
     /* 425431 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(425566), // Rule ID 12891 //
     /* 425436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425488 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425520 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425564 */     GIR_RootConstrainSelectedInstOperands,
     /* 425565 */     // GIR_Coverage, 12891,
     /* 425565 */     GIR_EraseRootFromParent_Done,
     /* 425566 */   // Label 6145: @425566
     /* 425566 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(425701), // Rule ID 12892 //
     /* 425571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425618 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425623 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425655 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425699 */     GIR_RootConstrainSelectedInstOperands,
     /* 425700 */     // GIR_Coverage, 12892,
     /* 425700 */     GIR_EraseRootFromParent_Done,
     /* 425701 */   // Label 6146: @425701
     /* 425701 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(425836), // Rule ID 12893 //
     /* 425706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425753 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425758 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425790 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425834 */     GIR_RootConstrainSelectedInstOperands,
     /* 425835 */     // GIR_Coverage, 12893,
     /* 425835 */     GIR_EraseRootFromParent_Done,
     /* 425836 */   // Label 6147: @425836
     /* 425836 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(425971), // Rule ID 12894 //
     /* 425841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425925 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425969 */     GIR_RootConstrainSelectedInstOperands,
     /* 425970 */     // GIR_Coverage, 12894,
     /* 425970 */     GIR_EraseRootFromParent_Done,
     /* 425971 */   // Label 6148: @425971
     /* 425971 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(426106), // Rule ID 12002 //
     /* 425976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426060 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426104 */     GIR_RootConstrainSelectedInstOperands,
     /* 426105 */     // GIR_Coverage, 12002,
     /* 426105 */     GIR_EraseRootFromParent_Done,
     /* 426106 */   // Label 6149: @426106
     /* 426106 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(426241), // Rule ID 12003 //
     /* 426111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 426114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426195 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426239 */     GIR_RootConstrainSelectedInstOperands,
     /* 426240 */     // GIR_Coverage, 12003,
     /* 426240 */     GIR_EraseRootFromParent_Done,
     /* 426241 */   // Label 6150: @426241
     /* 426241 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(426376), // Rule ID 12004 //
     /* 426246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 426249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426298 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426330 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426374 */     GIR_RootConstrainSelectedInstOperands,
     /* 426375 */     // GIR_Coverage, 12004,
     /* 426375 */     GIR_EraseRootFromParent_Done,
     /* 426376 */   // Label 6151: @426376
     /* 426376 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(426511), // Rule ID 12005 //
     /* 426381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 426384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426428 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426433 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426438 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426465 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426509 */     GIR_RootConstrainSelectedInstOperands,
     /* 426510 */     // GIR_Coverage, 12005,
     /* 426510 */     GIR_EraseRootFromParent_Done,
     /* 426511 */   // Label 6152: @426511
     /* 426511 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(426646), // Rule ID 12482 //
     /* 426516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426563 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426600 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426644 */     GIR_RootConstrainSelectedInstOperands,
     /* 426645 */     // GIR_Coverage, 12482,
     /* 426645 */     GIR_EraseRootFromParent_Done,
     /* 426646 */   // Label 6153: @426646
     /* 426646 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(426781), // Rule ID 12483 //
     /* 426651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426735 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426779 */     GIR_RootConstrainSelectedInstOperands,
     /* 426780 */     // GIR_Coverage, 12483,
     /* 426780 */     GIR_EraseRootFromParent_Done,
     /* 426781 */   // Label 6154: @426781
     /* 426781 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(426916), // Rule ID 12484 //
     /* 426786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426870 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426914 */     GIR_RootConstrainSelectedInstOperands,
     /* 426915 */     // GIR_Coverage, 12484,
     /* 426915 */     GIR_EraseRootFromParent_Done,
     /* 426916 */   // Label 6155: @426916
     /* 426916 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(427051), // Rule ID 12485 //
     /* 426921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426973 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427005 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427049 */     GIR_RootConstrainSelectedInstOperands,
     /* 427050 */     // GIR_Coverage, 12485,
     /* 427050 */     GIR_EraseRootFromParent_Done,
     /* 427051 */   // Label 6156: @427051
     /* 427051 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(427186), // Rule ID 12962 //
     /* 427056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427103 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427108 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427140 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427184 */     GIR_RootConstrainSelectedInstOperands,
     /* 427185 */     // GIR_Coverage, 12962,
     /* 427185 */     GIR_EraseRootFromParent_Done,
     /* 427186 */   // Label 6157: @427186
     /* 427186 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(427321), // Rule ID 12963 //
     /* 427191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427238 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427275 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427319 */     GIR_RootConstrainSelectedInstOperands,
     /* 427320 */     // GIR_Coverage, 12963,
     /* 427320 */     GIR_EraseRootFromParent_Done,
     /* 427321 */   // Label 6158: @427321
     /* 427321 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(427456), // Rule ID 12964 //
     /* 427326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427410 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427454 */     GIR_RootConstrainSelectedInstOperands,
     /* 427455 */     // GIR_Coverage, 12964,
     /* 427455 */     GIR_EraseRootFromParent_Done,
     /* 427456 */   // Label 6159: @427456
     /* 427456 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(427591), // Rule ID 12965 //
     /* 427461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427545 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427589 */     GIR_RootConstrainSelectedInstOperands,
     /* 427590 */     // GIR_Coverage, 12965,
     /* 427590 */     GIR_EraseRootFromParent_Done,
     /* 427591 */   // Label 6160: @427591
     /* 427591 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(427726), // Rule ID 11942 //
     /* 427596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427643 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427680 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427724 */     GIR_RootConstrainSelectedInstOperands,
     /* 427725 */     // GIR_Coverage, 11942,
     /* 427725 */     GIR_EraseRootFromParent_Done,
     /* 427726 */   // Label 6161: @427726
     /* 427726 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(427861), // Rule ID 11943 //
     /* 427731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427778 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427783 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427815 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427859 */     GIR_RootConstrainSelectedInstOperands,
     /* 427860 */     // GIR_Coverage, 11943,
     /* 427860 */     GIR_EraseRootFromParent_Done,
     /* 427861 */   // Label 6162: @427861
     /* 427861 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(427996), // Rule ID 11944 //
     /* 427866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427913 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427918 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427950 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427994 */     GIR_RootConstrainSelectedInstOperands,
     /* 427995 */     // GIR_Coverage, 11944,
     /* 427995 */     GIR_EraseRootFromParent_Done,
     /* 427996 */   // Label 6163: @427996
     /* 427996 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(428131), // Rule ID 11945 //
     /* 428001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428048 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428085 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 428088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428129 */     GIR_RootConstrainSelectedInstOperands,
     /* 428130 */     // GIR_Coverage, 11945,
     /* 428130 */     GIR_EraseRootFromParent_Done,
     /* 428131 */   // Label 6164: @428131
     /* 428131 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(428266), // Rule ID 12422 //
     /* 428136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428220 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428264 */     GIR_RootConstrainSelectedInstOperands,
     /* 428265 */     // GIR_Coverage, 12422,
     /* 428265 */     GIR_EraseRootFromParent_Done,
     /* 428266 */   // Label 6165: @428266
     /* 428266 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(428401), // Rule ID 12423 //
     /* 428271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428355 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428399 */     GIR_RootConstrainSelectedInstOperands,
     /* 428400 */     // GIR_Coverage, 12423,
     /* 428400 */     GIR_EraseRootFromParent_Done,
     /* 428401 */   // Label 6166: @428401
     /* 428401 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(428536), // Rule ID 12424 //
     /* 428406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428458 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428490 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428534 */     GIR_RootConstrainSelectedInstOperands,
     /* 428535 */     // GIR_Coverage, 12424,
     /* 428535 */     GIR_EraseRootFromParent_Done,
     /* 428536 */   // Label 6167: @428536
     /* 428536 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(428671), // Rule ID 12425 //
     /* 428541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428588 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428593 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428625 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428669 */     GIR_RootConstrainSelectedInstOperands,
     /* 428670 */     // GIR_Coverage, 12425,
     /* 428670 */     GIR_EraseRootFromParent_Done,
     /* 428671 */   // Label 6168: @428671
     /* 428671 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(428806), // Rule ID 12902 //
     /* 428676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428723 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428760 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428804 */     GIR_RootConstrainSelectedInstOperands,
     /* 428805 */     // GIR_Coverage, 12902,
     /* 428805 */     GIR_EraseRootFromParent_Done,
     /* 428806 */   // Label 6169: @428806
     /* 428806 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(428941), // Rule ID 12903 //
     /* 428811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428895 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428939 */     GIR_RootConstrainSelectedInstOperands,
     /* 428940 */     // GIR_Coverage, 12903,
     /* 428940 */     GIR_EraseRootFromParent_Done,
     /* 428941 */   // Label 6170: @428941
     /* 428941 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(429076), // Rule ID 12904 //
     /* 428946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428993 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429030 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 429033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429074 */     GIR_RootConstrainSelectedInstOperands,
     /* 429075 */     // GIR_Coverage, 12904,
     /* 429075 */     GIR_EraseRootFromParent_Done,
     /* 429076 */   // Label 6171: @429076
     /* 429076 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(429211), // Rule ID 12905 //
     /* 429081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 429084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 429112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429128 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429165 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 429168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429209 */     GIR_RootConstrainSelectedInstOperands,
     /* 429210 */     // GIR_Coverage, 12905,
     /* 429210 */     GIR_EraseRootFromParent_Done,
     /* 429211 */   // Label 6172: @429211
     /* 429211 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(429346), // Rule ID 11987 //
     /* 429216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429263 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429268 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429300 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429344 */     GIR_RootConstrainSelectedInstOperands,
     /* 429345 */     // GIR_Coverage, 11987,
     /* 429345 */     GIR_EraseRootFromParent_Done,
     /* 429346 */   // Label 6173: @429346
     /* 429346 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(429481), // Rule ID 11988 //
     /* 429351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429398 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429435 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429479 */     GIR_RootConstrainSelectedInstOperands,
     /* 429480 */     // GIR_Coverage, 11988,
     /* 429480 */     GIR_EraseRootFromParent_Done,
     /* 429481 */   // Label 6174: @429481
     /* 429481 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(429616), // Rule ID 11989 //
     /* 429486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429533 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429570 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429614 */     GIR_RootConstrainSelectedInstOperands,
     /* 429615 */     // GIR_Coverage, 11989,
     /* 429615 */     GIR_EraseRootFromParent_Done,
     /* 429616 */   // Label 6175: @429616
     /* 429616 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(429751), // Rule ID 11990 //
     /* 429621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429705 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429749 */     GIR_RootConstrainSelectedInstOperands,
     /* 429750 */     // GIR_Coverage, 11990,
     /* 429750 */     GIR_EraseRootFromParent_Done,
     /* 429751 */   // Label 6176: @429751
     /* 429751 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(429886), // Rule ID 12467 //
     /* 429756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429840 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429884 */     GIR_RootConstrainSelectedInstOperands,
     /* 429885 */     // GIR_Coverage, 12467,
     /* 429885 */     GIR_EraseRootFromParent_Done,
     /* 429886 */   // Label 6177: @429886
     /* 429886 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(430021), // Rule ID 12468 //
     /* 429891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429943 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429975 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430019 */     GIR_RootConstrainSelectedInstOperands,
     /* 430020 */     // GIR_Coverage, 12468,
     /* 430020 */     GIR_EraseRootFromParent_Done,
     /* 430021 */   // Label 6178: @430021
     /* 430021 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(430156), // Rule ID 12469 //
     /* 430026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 430029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 430033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430073 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430078 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430110 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 430113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430154 */     GIR_RootConstrainSelectedInstOperands,
     /* 430155 */     // GIR_Coverage, 12469,
     /* 430155 */     GIR_EraseRootFromParent_Done,
     /* 430156 */   // Label 6179: @430156
     /* 430156 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(430291), // Rule ID 12470 //
     /* 430161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 430164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 430168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430208 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430245 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 430248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430289 */     GIR_RootConstrainSelectedInstOperands,
     /* 430290 */     // GIR_Coverage, 12470,
     /* 430290 */     GIR_EraseRootFromParent_Done,
     /* 430291 */   // Label 6180: @430291
     /* 430291 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(430426), // Rule ID 12947 //
     /* 430296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430380 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430424 */     GIR_RootConstrainSelectedInstOperands,
     /* 430425 */     // GIR_Coverage, 12947,
     /* 430425 */     GIR_EraseRootFromParent_Done,
     /* 430426 */   // Label 6181: @430426
     /* 430426 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(430561), // Rule ID 12948 //
     /* 430431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430515 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430559 */     GIR_RootConstrainSelectedInstOperands,
     /* 430560 */     // GIR_Coverage, 12948,
     /* 430560 */     GIR_EraseRootFromParent_Done,
     /* 430561 */   // Label 6182: @430561
     /* 430561 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(430696), // Rule ID 12949 //
     /* 430566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430618 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430650 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430694 */     GIR_RootConstrainSelectedInstOperands,
     /* 430695 */     // GIR_Coverage, 12949,
     /* 430695 */     GIR_EraseRootFromParent_Done,
     /* 430696 */   // Label 6183: @430696
     /* 430696 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(430831), // Rule ID 12950 //
     /* 430701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430748 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430753 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430785 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430829 */     GIR_RootConstrainSelectedInstOperands,
     /* 430830 */     // GIR_Coverage, 12950,
     /* 430830 */     GIR_EraseRootFromParent_Done,
     /* 430831 */   // Label 6184: @430831
     /* 430831 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(430966), // Rule ID 11927 //
     /* 430836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430883 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430920 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430964 */     GIR_RootConstrainSelectedInstOperands,
     /* 430965 */     // GIR_Coverage, 11927,
     /* 430965 */     GIR_EraseRootFromParent_Done,
     /* 430966 */   // Label 6185: @430966
     /* 430966 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(431101), // Rule ID 11928 //
     /* 430971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431055 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431099 */     GIR_RootConstrainSelectedInstOperands,
     /* 431100 */     // GIR_Coverage, 11928,
     /* 431100 */     GIR_EraseRootFromParent_Done,
     /* 431101 */   // Label 6186: @431101
     /* 431101 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(431236), // Rule ID 11929 //
     /* 431106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 431109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431190 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431234 */     GIR_RootConstrainSelectedInstOperands,
     /* 431235 */     // GIR_Coverage, 11929,
     /* 431235 */     GIR_EraseRootFromParent_Done,
     /* 431236 */   // Label 6187: @431236
     /* 431236 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(431371), // Rule ID 11930 //
     /* 431241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 431244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431325 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431369 */     GIR_RootConstrainSelectedInstOperands,
     /* 431370 */     // GIR_Coverage, 11930,
     /* 431370 */     GIR_EraseRootFromParent_Done,
     /* 431371 */   // Label 6188: @431371
     /* 431371 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(431506), // Rule ID 12407 //
     /* 431376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431423 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431428 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431460 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431504 */     GIR_RootConstrainSelectedInstOperands,
     /* 431505 */     // GIR_Coverage, 12407,
     /* 431505 */     GIR_EraseRootFromParent_Done,
     /* 431506 */   // Label 6189: @431506
     /* 431506 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(431641), // Rule ID 12408 //
     /* 431511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431558 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431563 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431595 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431639 */     GIR_RootConstrainSelectedInstOperands,
     /* 431640 */     // GIR_Coverage, 12408,
     /* 431640 */     GIR_EraseRootFromParent_Done,
     /* 431641 */   // Label 6190: @431641
     /* 431641 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(431776), // Rule ID 12409 //
     /* 431646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431693 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431730 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431774 */     GIR_RootConstrainSelectedInstOperands,
     /* 431775 */     // GIR_Coverage, 12409,
     /* 431775 */     GIR_EraseRootFromParent_Done,
     /* 431776 */   // Label 6191: @431776
     /* 431776 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(431911), // Rule ID 12410 //
     /* 431781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431865 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431909 */     GIR_RootConstrainSelectedInstOperands,
     /* 431910 */     // GIR_Coverage, 12410,
     /* 431910 */     GIR_EraseRootFromParent_Done,
     /* 431911 */   // Label 6192: @431911
     /* 431911 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(432046), // Rule ID 12887 //
     /* 431916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432000 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432044 */     GIR_RootConstrainSelectedInstOperands,
     /* 432045 */     // GIR_Coverage, 12887,
     /* 432045 */     GIR_EraseRootFromParent_Done,
     /* 432046 */   // Label 6193: @432046
     /* 432046 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(432181), // Rule ID 12888 //
     /* 432051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 432082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432103 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432135 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432179 */     GIR_RootConstrainSelectedInstOperands,
     /* 432180 */     // GIR_Coverage, 12888,
     /* 432180 */     GIR_EraseRootFromParent_Done,
     /* 432181 */   // Label 6194: @432181
     /* 432181 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(432316), // Rule ID 12889 //
     /* 432186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 432217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432233 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432238 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432270 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432314 */     GIR_RootConstrainSelectedInstOperands,
     /* 432315 */     // GIR_Coverage, 12889,
     /* 432315 */     GIR_EraseRootFromParent_Done,
     /* 432316 */   // Label 6195: @432316
     /* 432316 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(432451), // Rule ID 12890 //
     /* 432321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 432352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432368 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432405 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432449 */     GIR_RootConstrainSelectedInstOperands,
     /* 432450 */     // GIR_Coverage, 12890,
     /* 432450 */     GIR_EraseRootFromParent_Done,
     /* 432451 */   // Label 6196: @432451
     /* 432451 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(432566), // Rule ID 13271 //
     /* 432456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432491 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432493 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 432497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432520 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432564 */     GIR_RootConstrainSelectedInstOperands,
     /* 432565 */     // GIR_Coverage, 13271,
     /* 432565 */     GIR_EraseRootFromParent_Done,
     /* 432566 */   // Label 6197: @432566
     /* 432566 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(432681), // Rule ID 13287 //
     /* 432571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432606 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432608 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 432612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432635 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 432638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432679 */     GIR_RootConstrainSelectedInstOperands,
     /* 432680 */     // GIR_Coverage, 13287,
     /* 432680 */     GIR_EraseRootFromParent_Done,
     /* 432681 */   // Label 6198: @432681
     /* 432681 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(432796), // Rule ID 13270 //
     /* 432686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432721 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432723 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 432727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432750 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432794 */     GIR_RootConstrainSelectedInstOperands,
     /* 432795 */     // GIR_Coverage, 13270,
     /* 432795 */     GIR_EraseRootFromParent_Done,
     /* 432796 */   // Label 6199: @432796
     /* 432796 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(432911), // Rule ID 13286 //
     /* 432801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432836 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432838 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 432842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432865 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 432868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432909 */     GIR_RootConstrainSelectedInstOperands,
     /* 432910 */     // GIR_Coverage, 13286,
     /* 432910 */     GIR_EraseRootFromParent_Done,
     /* 432911 */   // Label 6200: @432911
     /* 432911 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(433026), // Rule ID 7745 //
     /* 432916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432951 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432953 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 432957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432980 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433024 */     GIR_RootConstrainSelectedInstOperands,
     /* 433025 */     // GIR_Coverage, 7745,
     /* 433025 */     GIR_EraseRootFromParent_Done,
     /* 433026 */   // Label 6201: @433026
     /* 433026 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(433141), // Rule ID 7761 //
     /* 433031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 433046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433066 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 433068 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 433072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433095 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433139 */     GIR_RootConstrainSelectedInstOperands,
     /* 433140 */     // GIR_Coverage, 7761,
     /* 433140 */     GIR_EraseRootFromParent_Done,
     /* 433141 */   // Label 6202: @433141
     /* 433141 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(433256), // Rule ID 7744 //
     /* 433146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 433161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433181 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 433183 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 433187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433210 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433254 */     GIR_RootConstrainSelectedInstOperands,
     /* 433255 */     // GIR_Coverage, 7744,
     /* 433255 */     GIR_EraseRootFromParent_Done,
     /* 433256 */   // Label 6203: @433256
     /* 433256 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(433371), // Rule ID 7760 //
     /* 433261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 433276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433296 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 433298 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 433302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433325 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433369 */     GIR_RootConstrainSelectedInstOperands,
     /* 433370 */     // GIR_Coverage, 7760,
     /* 433370 */     GIR_EraseRootFromParent_Done,
     /* 433371 */   // Label 6204: @433371
     /* 433371 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(433470), // Rule ID 13263 //
     /* 433376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433399 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433424 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433468 */     GIR_RootConstrainSelectedInstOperands,
     /* 433469 */     // GIR_Coverage, 13263,
     /* 433469 */     GIR_EraseRootFromParent_Done,
     /* 433470 */   // Label 6205: @433470
     /* 433470 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(433569), // Rule ID 13279 //
     /* 433475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433498 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433523 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433567 */     GIR_RootConstrainSelectedInstOperands,
     /* 433568 */     // GIR_Coverage, 13279,
     /* 433568 */     GIR_EraseRootFromParent_Done,
     /* 433569 */   // Label 6206: @433569
     /* 433569 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(433668), // Rule ID 13262 //
     /* 433574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433597 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433622 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433666 */     GIR_RootConstrainSelectedInstOperands,
     /* 433667 */     // GIR_Coverage, 13262,
     /* 433667 */     GIR_EraseRootFromParent_Done,
     /* 433668 */   // Label 6207: @433668
     /* 433668 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(433767), // Rule ID 13278 //
     /* 433673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433696 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433721 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433765 */     GIR_RootConstrainSelectedInstOperands,
     /* 433766 */     // GIR_Coverage, 13278,
     /* 433766 */     GIR_EraseRootFromParent_Done,
     /* 433767 */   // Label 6208: @433767
     /* 433767 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(433866), // Rule ID 7737 //
     /* 433772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433795 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433820 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433864 */     GIR_RootConstrainSelectedInstOperands,
     /* 433865 */     // GIR_Coverage, 7737,
     /* 433865 */     GIR_EraseRootFromParent_Done,
     /* 433866 */   // Label 6209: @433866
     /* 433866 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(433965), // Rule ID 7753 //
     /* 433871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433894 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433919 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433963 */     GIR_RootConstrainSelectedInstOperands,
     /* 433964 */     // GIR_Coverage, 7753,
     /* 433964 */     GIR_EraseRootFromParent_Done,
     /* 433965 */   // Label 6210: @433965
     /* 433965 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(434064), // Rule ID 7736 //
     /* 433970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433993 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434018 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 434021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434062 */     GIR_RootConstrainSelectedInstOperands,
     /* 434063 */     // GIR_Coverage, 7736,
     /* 434063 */     GIR_EraseRootFromParent_Done,
     /* 434064 */   // Label 6211: @434064
     /* 434064 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(434163), // Rule ID 7752 //
     /* 434069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 434072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434092 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 434094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434117 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 434120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434161 */     GIR_RootConstrainSelectedInstOperands,
     /* 434162 */     // GIR_Coverage, 7752,
     /* 434162 */     GIR_EraseRootFromParent_Done,
     /* 434163 */   // Label 6212: @434163
     /* 434163 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(434198), // Rule ID 103 //
     /* 434168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 434171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 434175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 434179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 434183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13766),
     /* 434187 */     // (fmaxnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13766>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 434187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 434192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 434196 */     GIR_RootConstrainSelectedInstOperands,
     /* 434197 */     // GIR_Coverage, 103,
     /* 434197 */     GIR_Done,
     /* 434198 */   // Label 6213: @434198
     /* 434198 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(434261), // Rule ID 880 //
     /* 434203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 434206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434224 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 434227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 434234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 434244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 434254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 434259 */     GIR_RootConstrainSelectedInstOperands,
     /* 434260 */     // GIR_Coverage, 880,
     /* 434260 */     GIR_EraseRootFromParent_Done,
     /* 434261 */   // Label 6214: @434261
     /* 434261 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(434324), // Rule ID 884 //
     /* 434266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 434269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434287 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 434290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 434297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 434307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 434317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 434322 */     GIR_RootConstrainSelectedInstOperands,
     /* 434323 */     // GIR_Coverage, 884,
     /* 434323 */     GIR_EraseRootFromParent_Done,
     /* 434324 */   // Label 6215: @434324
     /* 434324 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(434387), // Rule ID 8438 //
     /* 434329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 434332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434350 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 434353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 434360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 434370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 434380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 434385 */     GIR_RootConstrainSelectedInstOperands,
     /* 434386 */     // GIR_Coverage, 8438,
     /* 434386 */     GIR_EraseRootFromParent_Done,
     /* 434387 */   // Label 6216: @434387
     /* 434387 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(434450), // Rule ID 8440 //
     /* 434392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 434395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434413 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 434416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 434423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 434433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 434443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 434448 */     GIR_RootConstrainSelectedInstOperands,
     /* 434449 */     // GIR_Coverage, 8440,
     /* 434449 */     GIR_EraseRootFromParent_Done,
     /* 434450 */   // Label 6217: @434450
     /* 434450 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(434512), // Rule ID 882 //
     /* 434455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 434458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 434462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 434469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 434476 */     // (fmaxnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 434476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 434479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 434486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 434496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434510 */     GIR_RootConstrainSelectedInstOperands,
     /* 434511 */     // GIR_Coverage, 882,
     /* 434511 */     GIR_EraseRootFromParent_Done,
     /* 434512 */   // Label 6218: @434512
     /* 434512 */   GIM_Reject,
     /* 434513 */ // Label 5812: @434513
     /* 434513 */ GIM_Reject,
     /* 434514 */ // Label 5808: @434514
     /* 434514 */ GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(452025),
     /* 434519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 434522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 434525 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(434654), // Rule ID 11516 //
     /* 434530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434611 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434652 */     GIR_RootConstrainSelectedInstOperands,
     /* 434653 */     // GIR_Coverage, 11516,
     /* 434653 */     GIR_EraseRootFromParent_Done,
     /* 434654 */   // Label 6220: @434654
     /* 434654 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(434783), // Rule ID 11517 //
     /* 434659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434740 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434781 */     GIR_RootConstrainSelectedInstOperands,
     /* 434782 */     // GIR_Coverage, 11517,
     /* 434782 */     GIR_EraseRootFromParent_Done,
     /* 434783 */   // Label 6221: @434783
     /* 434783 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(434912), // Rule ID 11520 //
     /* 434788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434869 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434910 */     GIR_RootConstrainSelectedInstOperands,
     /* 434911 */     // GIR_Coverage, 11520,
     /* 434911 */     GIR_EraseRootFromParent_Done,
     /* 434912 */   // Label 6222: @434912
     /* 434912 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(435041), // Rule ID 11521 //
     /* 434917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434961 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434966 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434998 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435039 */     GIR_RootConstrainSelectedInstOperands,
     /* 435040 */     // GIR_Coverage, 11521,
     /* 435040 */     GIR_EraseRootFromParent_Done,
     /* 435041 */   // Label 6223: @435041
     /* 435041 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(435170), // Rule ID 11501 //
     /* 435046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435127 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435168 */     GIR_RootConstrainSelectedInstOperands,
     /* 435169 */     // GIR_Coverage, 11501,
     /* 435169 */     GIR_EraseRootFromParent_Done,
     /* 435170 */   // Label 6224: @435170
     /* 435170 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(435299), // Rule ID 11502 //
     /* 435175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435256 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435297 */     GIR_RootConstrainSelectedInstOperands,
     /* 435298 */     // GIR_Coverage, 11502,
     /* 435298 */     GIR_EraseRootFromParent_Done,
     /* 435299 */   // Label 6225: @435299
     /* 435299 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(435428), // Rule ID 11505 //
     /* 435304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435348 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435385 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435426 */     GIR_RootConstrainSelectedInstOperands,
     /* 435427 */     // GIR_Coverage, 11505,
     /* 435427 */     GIR_EraseRootFromParent_Done,
     /* 435428 */   // Label 6226: @435428
     /* 435428 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(435557), // Rule ID 11506 //
     /* 435433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435514 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435555 */     GIR_RootConstrainSelectedInstOperands,
     /* 435556 */     // GIR_Coverage, 11506,
     /* 435556 */     GIR_EraseRootFromParent_Done,
     /* 435557 */   // Label 6227: @435557
     /* 435557 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(435686), // Rule ID 7599 //
     /* 435562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435606 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435611 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435643 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435684 */     GIR_RootConstrainSelectedInstOperands,
     /* 435685 */     // GIR_Coverage, 7599,
     /* 435685 */     GIR_EraseRootFromParent_Done,
     /* 435686 */   // Label 6228: @435686
     /* 435686 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(435815), // Rule ID 11515 //
     /* 435691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435772 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435813 */     GIR_RootConstrainSelectedInstOperands,
     /* 435814 */     // GIR_Coverage, 11515,
     /* 435814 */     GIR_EraseRootFromParent_Done,
     /* 435815 */   // Label 6229: @435815
     /* 435815 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(435944), // Rule ID 11518 //
     /* 435820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435864 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435901 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435942 */     GIR_RootConstrainSelectedInstOperands,
     /* 435943 */     // GIR_Coverage, 11518,
     /* 435943 */     GIR_EraseRootFromParent_Done,
     /* 435944 */   // Label 6230: @435944
     /* 435944 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(436073), // Rule ID 11519 //
     /* 435949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436030 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436071 */     GIR_RootConstrainSelectedInstOperands,
     /* 436072 */     // GIR_Coverage, 11519,
     /* 436072 */     GIR_EraseRootFromParent_Done,
     /* 436073 */   // Label 6231: @436073
     /* 436073 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(436202), // Rule ID 7598 //
     /* 436078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436159 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436200 */     GIR_RootConstrainSelectedInstOperands,
     /* 436201 */     // GIR_Coverage, 7598,
     /* 436201 */     GIR_EraseRootFromParent_Done,
     /* 436202 */   // Label 6232: @436202
     /* 436202 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(436331), // Rule ID 11500 //
     /* 436207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436251 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436256 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436288 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436329 */     GIR_RootConstrainSelectedInstOperands,
     /* 436330 */     // GIR_Coverage, 11500,
     /* 436330 */     GIR_EraseRootFromParent_Done,
     /* 436331 */   // Label 6233: @436331
     /* 436331 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(436460), // Rule ID 11503 //
     /* 436336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436417 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436458 */     GIR_RootConstrainSelectedInstOperands,
     /* 436459 */     // GIR_Coverage, 11503,
     /* 436459 */     GIR_EraseRootFromParent_Done,
     /* 436460 */   // Label 6234: @436460
     /* 436460 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(436589), // Rule ID 11504 //
     /* 436465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436546 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436587 */     GIR_RootConstrainSelectedInstOperands,
     /* 436588 */     // GIR_Coverage, 11504,
     /* 436588 */     GIR_EraseRootFromParent_Done,
     /* 436589 */   // Label 6235: @436589
     /* 436589 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(436718), // Rule ID 11486 //
     /* 436594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436675 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436716 */     GIR_RootConstrainSelectedInstOperands,
     /* 436717 */     // GIR_Coverage, 11486,
     /* 436717 */     GIR_EraseRootFromParent_Done,
     /* 436718 */   // Label 6236: @436718
     /* 436718 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(436847), // Rule ID 11487 //
     /* 436723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436804 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436845 */     GIR_RootConstrainSelectedInstOperands,
     /* 436846 */     // GIR_Coverage, 11487,
     /* 436846 */     GIR_EraseRootFromParent_Done,
     /* 436847 */   // Label 6237: @436847
     /* 436847 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(436976), // Rule ID 11490 //
     /* 436852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436896 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436901 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436933 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436974 */     GIR_RootConstrainSelectedInstOperands,
     /* 436975 */     // GIR_Coverage, 11490,
     /* 436975 */     GIR_EraseRootFromParent_Done,
     /* 436976 */   // Label 6238: @436976
     /* 436976 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(437105), // Rule ID 11491 //
     /* 436981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437062 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437103 */     GIR_RootConstrainSelectedInstOperands,
     /* 437104 */     // GIR_Coverage, 11491,
     /* 437104 */     GIR_EraseRootFromParent_Done,
     /* 437105 */   // Label 6239: @437105
     /* 437105 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(437234), // Rule ID 11471 //
     /* 437110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437191 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437232 */     GIR_RootConstrainSelectedInstOperands,
     /* 437233 */     // GIR_Coverage, 11471,
     /* 437233 */     GIR_EraseRootFromParent_Done,
     /* 437234 */   // Label 6240: @437234
     /* 437234 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(437363), // Rule ID 11472 //
     /* 437239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437320 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437361 */     GIR_RootConstrainSelectedInstOperands,
     /* 437362 */     // GIR_Coverage, 11472,
     /* 437362 */     GIR_EraseRootFromParent_Done,
     /* 437363 */   // Label 6241: @437363
     /* 437363 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(437492), // Rule ID 11475 //
     /* 437368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437449 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437490 */     GIR_RootConstrainSelectedInstOperands,
     /* 437491 */     // GIR_Coverage, 11475,
     /* 437491 */     GIR_EraseRootFromParent_Done,
     /* 437492 */   // Label 6242: @437492
     /* 437492 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(437621), // Rule ID 11476 //
     /* 437497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437541 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437546 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437578 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437619 */     GIR_RootConstrainSelectedInstOperands,
     /* 437620 */     // GIR_Coverage, 11476,
     /* 437620 */     GIR_EraseRootFromParent_Done,
     /* 437621 */   // Label 6243: @437621
     /* 437621 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(437750), // Rule ID 7597 //
     /* 437626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437707 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437748 */     GIR_RootConstrainSelectedInstOperands,
     /* 437749 */     // GIR_Coverage, 7597,
     /* 437749 */     GIR_EraseRootFromParent_Done,
     /* 437750 */   // Label 6244: @437750
     /* 437750 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(437879), // Rule ID 11485 //
     /* 437755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437804 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437836 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437877 */     GIR_RootConstrainSelectedInstOperands,
     /* 437878 */     // GIR_Coverage, 11485,
     /* 437878 */     GIR_EraseRootFromParent_Done,
     /* 437879 */   // Label 6245: @437879
     /* 437879 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(438008), // Rule ID 11488 //
     /* 437884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437928 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437965 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438006 */     GIR_RootConstrainSelectedInstOperands,
     /* 438007 */     // GIR_Coverage, 11488,
     /* 438007 */     GIR_EraseRootFromParent_Done,
     /* 438008 */   // Label 6246: @438008
     /* 438008 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(438137), // Rule ID 11489 //
     /* 438013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438094 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 438114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438135 */     GIR_RootConstrainSelectedInstOperands,
     /* 438136 */     // GIR_Coverage, 11489,
     /* 438136 */     GIR_EraseRootFromParent_Done,
     /* 438137 */   // Label 6247: @438137
     /* 438137 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(438266), // Rule ID 7596 //
     /* 438142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438186 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438191 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438223 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438264 */     GIR_RootConstrainSelectedInstOperands,
     /* 438265 */     // GIR_Coverage, 7596,
     /* 438265 */     GIR_EraseRootFromParent_Done,
     /* 438266 */   // Label 6248: @438266
     /* 438266 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(438395), // Rule ID 11470 //
     /* 438271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438352 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438393 */     GIR_RootConstrainSelectedInstOperands,
     /* 438394 */     // GIR_Coverage, 11470,
     /* 438394 */     GIR_EraseRootFromParent_Done,
     /* 438395 */   // Label 6249: @438395
     /* 438395 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(438524), // Rule ID 11473 //
     /* 438400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438481 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 438501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438522 */     GIR_RootConstrainSelectedInstOperands,
     /* 438523 */     // GIR_Coverage, 11473,
     /* 438523 */     GIR_EraseRootFromParent_Done,
     /* 438524 */   // Label 6250: @438524
     /* 438524 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(438653), // Rule ID 11474 //
     /* 438529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438610 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 438630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438651 */     GIR_RootConstrainSelectedInstOperands,
     /* 438652 */     // GIR_Coverage, 11474,
     /* 438652 */     GIR_EraseRootFromParent_Done,
     /* 438653 */   // Label 6251: @438653
     /* 438653 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(438782), // Rule ID 11526 //
     /* 438658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438739 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 438759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 438764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438780 */     GIR_RootConstrainSelectedInstOperands,
     /* 438781 */     // GIR_Coverage, 11526,
     /* 438781 */     GIR_EraseRootFromParent_Done,
     /* 438782 */   // Label 6252: @438782
     /* 438782 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(438911), // Rule ID 11527 //
     /* 438787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438831 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438836 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438868 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 438888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 438893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438909 */     GIR_RootConstrainSelectedInstOperands,
     /* 438910 */     // GIR_Coverage, 11527,
     /* 438910 */     GIR_EraseRootFromParent_Done,
     /* 438911 */   // Label 6253: @438911
     /* 438911 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(439040), // Rule ID 11528 //
     /* 438916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438997 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439038 */     GIR_RootConstrainSelectedInstOperands,
     /* 439039 */     // GIR_Coverage, 11528,
     /* 439039 */     GIR_EraseRootFromParent_Done,
     /* 439040 */   // Label 6254: @439040
     /* 439040 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(439169), // Rule ID 11529 //
     /* 439045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439126 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439167 */     GIR_RootConstrainSelectedInstOperands,
     /* 439168 */     // GIR_Coverage, 11529,
     /* 439168 */     GIR_EraseRootFromParent_Done,
     /* 439169 */   // Label 6255: @439169
     /* 439169 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(439298), // Rule ID 11466 //
     /* 439174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439255 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439296 */     GIR_RootConstrainSelectedInstOperands,
     /* 439297 */     // GIR_Coverage, 11466,
     /* 439297 */     GIR_EraseRootFromParent_Done,
     /* 439298 */   // Label 6256: @439298
     /* 439298 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(439427), // Rule ID 11467 //
     /* 439303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439384 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439425 */     GIR_RootConstrainSelectedInstOperands,
     /* 439426 */     // GIR_Coverage, 11467,
     /* 439426 */     GIR_EraseRootFromParent_Done,
     /* 439427 */   // Label 6257: @439427
     /* 439427 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(439556), // Rule ID 11468 //
     /* 439432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439476 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439481 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439513 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439554 */     GIR_RootConstrainSelectedInstOperands,
     /* 439555 */     // GIR_Coverage, 11468,
     /* 439555 */     GIR_EraseRootFromParent_Done,
     /* 439556 */   // Label 6258: @439556
     /* 439556 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(439685), // Rule ID 11469 //
     /* 439561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439642 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439683 */     GIR_RootConstrainSelectedInstOperands,
     /* 439684 */     // GIR_Coverage, 11469,
     /* 439684 */     GIR_EraseRootFromParent_Done,
     /* 439685 */   // Label 6259: @439685
     /* 439685 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(439814), // Rule ID 11511 //
     /* 439690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439771 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439812 */     GIR_RootConstrainSelectedInstOperands,
     /* 439813 */     // GIR_Coverage, 11511,
     /* 439813 */     GIR_EraseRootFromParent_Done,
     /* 439814 */   // Label 6260: @439814
     /* 439814 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(439943), // Rule ID 11512 //
     /* 439819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439900 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439941 */     GIR_RootConstrainSelectedInstOperands,
     /* 439942 */     // GIR_Coverage, 11512,
     /* 439942 */     GIR_EraseRootFromParent_Done,
     /* 439943 */   // Label 6261: @439943
     /* 439943 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(440072), // Rule ID 11513 //
     /* 439948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440029 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440070 */     GIR_RootConstrainSelectedInstOperands,
     /* 440071 */     // GIR_Coverage, 11513,
     /* 440071 */     GIR_EraseRootFromParent_Done,
     /* 440072 */   // Label 6262: @440072
     /* 440072 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(440201), // Rule ID 11514 //
     /* 440077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440121 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440126 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440158 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440199 */     GIR_RootConstrainSelectedInstOperands,
     /* 440200 */     // GIR_Coverage, 11514,
     /* 440200 */     GIR_EraseRootFromParent_Done,
     /* 440201 */   // Label 6263: @440201
     /* 440201 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(440330), // Rule ID 11451 //
     /* 440206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440287 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 440307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 440312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440328 */     GIR_RootConstrainSelectedInstOperands,
     /* 440329 */     // GIR_Coverage, 11451,
     /* 440329 */     GIR_EraseRootFromParent_Done,
     /* 440330 */   // Label 6264: @440330
     /* 440330 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(440459), // Rule ID 11452 //
     /* 440335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440416 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 440436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 440441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440457 */     GIR_RootConstrainSelectedInstOperands,
     /* 440458 */     // GIR_Coverage, 11452,
     /* 440458 */     GIR_EraseRootFromParent_Done,
     /* 440459 */   // Label 6265: @440459
     /* 440459 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(440588), // Rule ID 11453 //
     /* 440464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440545 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440586 */     GIR_RootConstrainSelectedInstOperands,
     /* 440587 */     // GIR_Coverage, 11453,
     /* 440587 */     GIR_EraseRootFromParent_Done,
     /* 440588 */   // Label 6266: @440588
     /* 440588 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(440717), // Rule ID 11454 //
     /* 440593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440674 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440715 */     GIR_RootConstrainSelectedInstOperands,
     /* 440716 */     // GIR_Coverage, 11454,
     /* 440716 */     GIR_EraseRootFromParent_Done,
     /* 440717 */   // Label 6267: @440717
     /* 440717 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(440846), // Rule ID 11522 //
     /* 440722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440766 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440771 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440803 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440844 */     GIR_RootConstrainSelectedInstOperands,
     /* 440845 */     // GIR_Coverage, 11522,
     /* 440845 */     GIR_EraseRootFromParent_Done,
     /* 440846 */   // Label 6268: @440846
     /* 440846 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(440975), // Rule ID 11523 //
     /* 440851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440932 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440973 */     GIR_RootConstrainSelectedInstOperands,
     /* 440974 */     // GIR_Coverage, 11523,
     /* 440974 */     GIR_EraseRootFromParent_Done,
     /* 440975 */   // Label 6269: @440975
     /* 440975 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(441104), // Rule ID 11524 //
     /* 440980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441061 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441102 */     GIR_RootConstrainSelectedInstOperands,
     /* 441103 */     // GIR_Coverage, 11524,
     /* 441103 */     GIR_EraseRootFromParent_Done,
     /* 441104 */   // Label 6270: @441104
     /* 441104 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(441233), // Rule ID 11525 //
     /* 441109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441190 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441231 */     GIR_RootConstrainSelectedInstOperands,
     /* 441232 */     // GIR_Coverage, 11525,
     /* 441232 */     GIR_EraseRootFromParent_Done,
     /* 441233 */   // Label 6271: @441233
     /* 441233 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(441362), // Rule ID 11462 //
     /* 441238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441319 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441360 */     GIR_RootConstrainSelectedInstOperands,
     /* 441361 */     // GIR_Coverage, 11462,
     /* 441361 */     GIR_EraseRootFromParent_Done,
     /* 441362 */   // Label 6272: @441362
     /* 441362 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(441491), // Rule ID 11463 //
     /* 441367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441411 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441416 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441448 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441489 */     GIR_RootConstrainSelectedInstOperands,
     /* 441490 */     // GIR_Coverage, 11463,
     /* 441490 */     GIR_EraseRootFromParent_Done,
     /* 441491 */   // Label 6273: @441491
     /* 441491 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(441620), // Rule ID 11464 //
     /* 441496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441577 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441618 */     GIR_RootConstrainSelectedInstOperands,
     /* 441619 */     // GIR_Coverage, 11464,
     /* 441619 */     GIR_EraseRootFromParent_Done,
     /* 441620 */   // Label 6274: @441620
     /* 441620 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(441749), // Rule ID 11465 //
     /* 441625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441706 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441747 */     GIR_RootConstrainSelectedInstOperands,
     /* 441748 */     // GIR_Coverage, 11465,
     /* 441748 */     GIR_EraseRootFromParent_Done,
     /* 441749 */   // Label 6275: @441749
     /* 441749 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(441878), // Rule ID 11507 //
     /* 441754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441835 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441876 */     GIR_RootConstrainSelectedInstOperands,
     /* 441877 */     // GIR_Coverage, 11507,
     /* 441877 */     GIR_EraseRootFromParent_Done,
     /* 441878 */   // Label 6276: @441878
     /* 441878 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(442007), // Rule ID 11508 //
     /* 441883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441964 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442005 */     GIR_RootConstrainSelectedInstOperands,
     /* 442006 */     // GIR_Coverage, 11508,
     /* 442006 */     GIR_EraseRootFromParent_Done,
     /* 442007 */   // Label 6277: @442007
     /* 442007 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(442136), // Rule ID 11509 //
     /* 442012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442056 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442061 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442093 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442134 */     GIR_RootConstrainSelectedInstOperands,
     /* 442135 */     // GIR_Coverage, 11509,
     /* 442135 */     GIR_EraseRootFromParent_Done,
     /* 442136 */   // Label 6278: @442136
     /* 442136 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(442265), // Rule ID 11510 //
     /* 442141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442222 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442263 */     GIR_RootConstrainSelectedInstOperands,
     /* 442264 */     // GIR_Coverage, 11510,
     /* 442264 */     GIR_EraseRootFromParent_Done,
     /* 442265 */   // Label 6279: @442265
     /* 442265 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(442394), // Rule ID 11447 //
     /* 442270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442351 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442392 */     GIR_RootConstrainSelectedInstOperands,
     /* 442393 */     // GIR_Coverage, 11447,
     /* 442393 */     GIR_EraseRootFromParent_Done,
     /* 442394 */   // Label 6280: @442394
     /* 442394 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(442523), // Rule ID 11448 //
     /* 442399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442480 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442521 */     GIR_RootConstrainSelectedInstOperands,
     /* 442522 */     // GIR_Coverage, 11448,
     /* 442522 */     GIR_EraseRootFromParent_Done,
     /* 442523 */   // Label 6281: @442523
     /* 442523 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(442652), // Rule ID 11449 //
     /* 442528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442609 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442650 */     GIR_RootConstrainSelectedInstOperands,
     /* 442651 */     // GIR_Coverage, 11449,
     /* 442651 */     GIR_EraseRootFromParent_Done,
     /* 442652 */   // Label 6282: @442652
     /* 442652 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(442781), // Rule ID 11450 //
     /* 442657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442701 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442706 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442738 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442779 */     GIR_RootConstrainSelectedInstOperands,
     /* 442780 */     // GIR_Coverage, 11450,
     /* 442780 */     GIR_EraseRootFromParent_Done,
     /* 442781 */   // Label 6283: @442781
     /* 442781 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(442910), // Rule ID 11456 //
     /* 442786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442867 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442908 */     GIR_RootConstrainSelectedInstOperands,
     /* 442909 */     // GIR_Coverage, 11456,
     /* 442909 */     GIR_EraseRootFromParent_Done,
     /* 442910 */   // Label 6284: @442910
     /* 442910 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(443039), // Rule ID 11457 //
     /* 442915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442996 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443037 */     GIR_RootConstrainSelectedInstOperands,
     /* 443038 */     // GIR_Coverage, 11457,
     /* 443038 */     GIR_EraseRootFromParent_Done,
     /* 443039 */   // Label 6285: @443039
     /* 443039 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(443168), // Rule ID 11460 //
     /* 443044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443125 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443166 */     GIR_RootConstrainSelectedInstOperands,
     /* 443167 */     // GIR_Coverage, 11460,
     /* 443167 */     GIR_EraseRootFromParent_Done,
     /* 443168 */   // Label 6286: @443168
     /* 443168 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(443297), // Rule ID 11461 //
     /* 443173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443254 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443295 */     GIR_RootConstrainSelectedInstOperands,
     /* 443296 */     // GIR_Coverage, 11461,
     /* 443296 */     GIR_EraseRootFromParent_Done,
     /* 443297 */   // Label 6287: @443297
     /* 443297 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(443426), // Rule ID 11441 //
     /* 443302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443346 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443351 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443383 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443424 */     GIR_RootConstrainSelectedInstOperands,
     /* 443425 */     // GIR_Coverage, 11441,
     /* 443425 */     GIR_EraseRootFromParent_Done,
     /* 443426 */   // Label 6288: @443426
     /* 443426 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(443555), // Rule ID 11442 //
     /* 443431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443512 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443553 */     GIR_RootConstrainSelectedInstOperands,
     /* 443554 */     // GIR_Coverage, 11442,
     /* 443554 */     GIR_EraseRootFromParent_Done,
     /* 443555 */   // Label 6289: @443555
     /* 443555 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(443684), // Rule ID 11445 //
     /* 443560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443609 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443641 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443682 */     GIR_RootConstrainSelectedInstOperands,
     /* 443683 */     // GIR_Coverage, 11445,
     /* 443683 */     GIR_EraseRootFromParent_Done,
     /* 443684 */   // Label 6290: @443684
     /* 443684 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(443813), // Rule ID 11446 //
     /* 443689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443733 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443770 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443811 */     GIR_RootConstrainSelectedInstOperands,
     /* 443812 */     // GIR_Coverage, 11446,
     /* 443812 */     GIR_EraseRootFromParent_Done,
     /* 443813 */   // Label 6291: @443813
     /* 443813 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(443942), // Rule ID 7595 //
     /* 443818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443899 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443940 */     GIR_RootConstrainSelectedInstOperands,
     /* 443941 */     // GIR_Coverage, 7595,
     /* 443941 */     GIR_EraseRootFromParent_Done,
     /* 443942 */   // Label 6292: @443942
     /* 443942 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(444071), // Rule ID 11455 //
     /* 443947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443991 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443996 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444028 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444069 */     GIR_RootConstrainSelectedInstOperands,
     /* 444070 */     // GIR_Coverage, 11455,
     /* 444070 */     GIR_EraseRootFromParent_Done,
     /* 444071 */   // Label 6293: @444071
     /* 444071 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(444200), // Rule ID 11458 //
     /* 444076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444157 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444198 */     GIR_RootConstrainSelectedInstOperands,
     /* 444199 */     // GIR_Coverage, 11458,
     /* 444199 */     GIR_EraseRootFromParent_Done,
     /* 444200 */   // Label 6294: @444200
     /* 444200 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(444329), // Rule ID 11459 //
     /* 444205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444286 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444327 */     GIR_RootConstrainSelectedInstOperands,
     /* 444328 */     // GIR_Coverage, 11459,
     /* 444328 */     GIR_EraseRootFromParent_Done,
     /* 444329 */   // Label 6295: @444329
     /* 444329 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(444458), // Rule ID 7594 //
     /* 444334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444378 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444415 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444456 */     GIR_RootConstrainSelectedInstOperands,
     /* 444457 */     // GIR_Coverage, 7594,
     /* 444457 */     GIR_EraseRootFromParent_Done,
     /* 444458 */   // Label 6296: @444458
     /* 444458 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(444587), // Rule ID 11440 //
     /* 444463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444544 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444585 */     GIR_RootConstrainSelectedInstOperands,
     /* 444586 */     // GIR_Coverage, 11440,
     /* 444586 */     GIR_EraseRootFromParent_Done,
     /* 444587 */   // Label 6297: @444587
     /* 444587 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(444716), // Rule ID 11443 //
     /* 444592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444636 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444641 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444673 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444714 */     GIR_RootConstrainSelectedInstOperands,
     /* 444715 */     // GIR_Coverage, 11443,
     /* 444715 */     GIR_EraseRootFromParent_Done,
     /* 444716 */   // Label 6298: @444716
     /* 444716 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(444845), // Rule ID 11444 //
     /* 444721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444802 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444843 */     GIR_RootConstrainSelectedInstOperands,
     /* 444844 */     // GIR_Coverage, 11444,
     /* 444844 */     GIR_EraseRootFromParent_Done,
     /* 444845 */   // Label 6299: @444845
     /* 444845 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(444974), // Rule ID 11426 //
     /* 444850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 444890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444931 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444972 */     GIR_RootConstrainSelectedInstOperands,
     /* 444973 */     // GIR_Coverage, 11426,
     /* 444973 */     GIR_EraseRootFromParent_Done,
     /* 444974 */   // Label 6300: @444974
     /* 444974 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(445103), // Rule ID 11427 //
     /* 444979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445060 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445101 */     GIR_RootConstrainSelectedInstOperands,
     /* 445102 */     // GIR_Coverage, 11427,
     /* 445102 */     GIR_EraseRootFromParent_Done,
     /* 445103 */   // Label 6301: @445103
     /* 445103 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(445232), // Rule ID 11430 //
     /* 445108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445189 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445230 */     GIR_RootConstrainSelectedInstOperands,
     /* 445231 */     // GIR_Coverage, 11430,
     /* 445231 */     GIR_EraseRootFromParent_Done,
     /* 445232 */   // Label 6302: @445232
     /* 445232 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(445361), // Rule ID 11431 //
     /* 445237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445281 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445286 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445318 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445359 */     GIR_RootConstrainSelectedInstOperands,
     /* 445360 */     // GIR_Coverage, 11431,
     /* 445360 */     GIR_EraseRootFromParent_Done,
     /* 445361 */   // Label 6303: @445361
     /* 445361 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(445490), // Rule ID 11411 //
     /* 445366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445447 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445488 */     GIR_RootConstrainSelectedInstOperands,
     /* 445489 */     // GIR_Coverage, 11411,
     /* 445489 */     GIR_EraseRootFromParent_Done,
     /* 445490 */   // Label 6304: @445490
     /* 445490 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(445619), // Rule ID 11412 //
     /* 445495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445576 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445617 */     GIR_RootConstrainSelectedInstOperands,
     /* 445618 */     // GIR_Coverage, 11412,
     /* 445618 */     GIR_EraseRootFromParent_Done,
     /* 445619 */   // Label 6305: @445619
     /* 445619 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(445748), // Rule ID 11415 //
     /* 445624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445705 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445746 */     GIR_RootConstrainSelectedInstOperands,
     /* 445747 */     // GIR_Coverage, 11415,
     /* 445747 */     GIR_EraseRootFromParent_Done,
     /* 445748 */   // Label 6306: @445748
     /* 445748 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(445877), // Rule ID 11416 //
     /* 445753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445834 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445875 */     GIR_RootConstrainSelectedInstOperands,
     /* 445876 */     // GIR_Coverage, 11416,
     /* 445876 */     GIR_EraseRootFromParent_Done,
     /* 445877 */   // Label 6307: @445877
     /* 445877 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(446006), // Rule ID 7593 //
     /* 445882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 445922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445926 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445931 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445963 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446004 */     GIR_RootConstrainSelectedInstOperands,
     /* 446005 */     // GIR_Coverage, 7593,
     /* 446005 */     GIR_EraseRootFromParent_Done,
     /* 446006 */   // Label 6308: @446006
     /* 446006 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(446135), // Rule ID 11425 //
     /* 446011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446092 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446133 */     GIR_RootConstrainSelectedInstOperands,
     /* 446134 */     // GIR_Coverage, 11425,
     /* 446134 */     GIR_EraseRootFromParent_Done,
     /* 446135 */   // Label 6309: @446135
     /* 446135 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(446264), // Rule ID 11428 //
     /* 446140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446221 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446262 */     GIR_RootConstrainSelectedInstOperands,
     /* 446263 */     // GIR_Coverage, 11428,
     /* 446263 */     GIR_EraseRootFromParent_Done,
     /* 446264 */   // Label 6310: @446264
     /* 446264 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(446393), // Rule ID 11429 //
     /* 446269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446350 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446391 */     GIR_RootConstrainSelectedInstOperands,
     /* 446392 */     // GIR_Coverage, 11429,
     /* 446392 */     GIR_EraseRootFromParent_Done,
     /* 446393 */   // Label 6311: @446393
     /* 446393 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(446522), // Rule ID 7592 //
     /* 446398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446479 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446520 */     GIR_RootConstrainSelectedInstOperands,
     /* 446521 */     // GIR_Coverage, 7592,
     /* 446521 */     GIR_EraseRootFromParent_Done,
     /* 446522 */   // Label 6312: @446522
     /* 446522 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(446651), // Rule ID 11410 //
     /* 446527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446571 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446576 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446608 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446649 */     GIR_RootConstrainSelectedInstOperands,
     /* 446650 */     // GIR_Coverage, 11410,
     /* 446650 */     GIR_EraseRootFromParent_Done,
     /* 446651 */   // Label 6313: @446651
     /* 446651 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(446780), // Rule ID 11413 //
     /* 446656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446737 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446778 */     GIR_RootConstrainSelectedInstOperands,
     /* 446779 */     // GIR_Coverage, 11413,
     /* 446779 */     GIR_EraseRootFromParent_Done,
     /* 446780 */   // Label 6314: @446780
     /* 446780 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(446909), // Rule ID 11414 //
     /* 446785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446866 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446907 */     GIR_RootConstrainSelectedInstOperands,
     /* 446908 */     // GIR_Coverage, 11414,
     /* 446908 */     GIR_EraseRootFromParent_Done,
     /* 446909 */   // Label 6315: @446909
     /* 446909 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(447038), // Rule ID 11496 //
     /* 446914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 446938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446995 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447036 */     GIR_RootConstrainSelectedInstOperands,
     /* 447037 */     // GIR_Coverage, 11496,
     /* 447037 */     GIR_EraseRootFromParent_Done,
     /* 447038 */   // Label 6316: @447038
     /* 447038 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(447167), // Rule ID 11497 //
     /* 447043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447124 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447165 */     GIR_RootConstrainSelectedInstOperands,
     /* 447166 */     // GIR_Coverage, 11497,
     /* 447166 */     GIR_EraseRootFromParent_Done,
     /* 447167 */   // Label 6317: @447167
     /* 447167 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(447296), // Rule ID 11498 //
     /* 447172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447216 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447221 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447253 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447294 */     GIR_RootConstrainSelectedInstOperands,
     /* 447295 */     // GIR_Coverage, 11498,
     /* 447295 */     GIR_EraseRootFromParent_Done,
     /* 447296 */   // Label 6318: @447296
     /* 447296 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(447425), // Rule ID 11499 //
     /* 447301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447382 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447423 */     GIR_RootConstrainSelectedInstOperands,
     /* 447424 */     // GIR_Coverage, 11499,
     /* 447424 */     GIR_EraseRootFromParent_Done,
     /* 447425 */   // Label 6319: @447425
     /* 447425 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(447554), // Rule ID 11436 //
     /* 447430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447479 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447511 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447552 */     GIR_RootConstrainSelectedInstOperands,
     /* 447553 */     // GIR_Coverage, 11436,
     /* 447553 */     GIR_EraseRootFromParent_Done,
     /* 447554 */   // Label 6320: @447554
     /* 447554 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(447683), // Rule ID 11437 //
     /* 447559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447640 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447681 */     GIR_RootConstrainSelectedInstOperands,
     /* 447682 */     // GIR_Coverage, 11437,
     /* 447682 */     GIR_EraseRootFromParent_Done,
     /* 447683 */   // Label 6321: @447683
     /* 447683 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(447812), // Rule ID 11438 //
     /* 447688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447769 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447810 */     GIR_RootConstrainSelectedInstOperands,
     /* 447811 */     // GIR_Coverage, 11438,
     /* 447811 */     GIR_EraseRootFromParent_Done,
     /* 447812 */   // Label 6322: @447812
     /* 447812 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(447941), // Rule ID 11439 //
     /* 447817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447861 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447866 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447898 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447939 */     GIR_RootConstrainSelectedInstOperands,
     /* 447940 */     // GIR_Coverage, 11439,
     /* 447940 */     GIR_EraseRootFromParent_Done,
     /* 447941 */   // Label 6323: @447941
     /* 447941 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(448070), // Rule ID 11481 //
     /* 447946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448027 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448068 */     GIR_RootConstrainSelectedInstOperands,
     /* 448069 */     // GIR_Coverage, 11481,
     /* 448069 */     GIR_EraseRootFromParent_Done,
     /* 448070 */   // Label 6324: @448070
     /* 448070 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(448199), // Rule ID 11482 //
     /* 448075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448156 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448197 */     GIR_RootConstrainSelectedInstOperands,
     /* 448198 */     // GIR_Coverage, 11482,
     /* 448198 */     GIR_EraseRootFromParent_Done,
     /* 448199 */   // Label 6325: @448199
     /* 448199 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(448328), // Rule ID 11483 //
     /* 448204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448285 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448326 */     GIR_RootConstrainSelectedInstOperands,
     /* 448327 */     // GIR_Coverage, 11483,
     /* 448327 */     GIR_EraseRootFromParent_Done,
     /* 448328 */   // Label 6326: @448328
     /* 448328 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(448457), // Rule ID 11484 //
     /* 448333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448414 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448455 */     GIR_RootConstrainSelectedInstOperands,
     /* 448456 */     // GIR_Coverage, 11484,
     /* 448456 */     GIR_EraseRootFromParent_Done,
     /* 448457 */   // Label 6327: @448457
     /* 448457 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(448586), // Rule ID 11421 //
     /* 448462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448506 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448543 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448584 */     GIR_RootConstrainSelectedInstOperands,
     /* 448585 */     // GIR_Coverage, 11421,
     /* 448585 */     GIR_EraseRootFromParent_Done,
     /* 448586 */   // Label 6328: @448586
     /* 448586 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(448715), // Rule ID 11422 //
     /* 448591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448672 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448713 */     GIR_RootConstrainSelectedInstOperands,
     /* 448714 */     // GIR_Coverage, 11422,
     /* 448714 */     GIR_EraseRootFromParent_Done,
     /* 448715 */   // Label 6329: @448715
     /* 448715 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(448844), // Rule ID 11423 //
     /* 448720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448801 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448842 */     GIR_RootConstrainSelectedInstOperands,
     /* 448843 */     // GIR_Coverage, 11423,
     /* 448843 */     GIR_EraseRootFromParent_Done,
     /* 448844 */   // Label 6330: @448844
     /* 448844 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(448973), // Rule ID 11424 //
     /* 448849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448930 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448971 */     GIR_RootConstrainSelectedInstOperands,
     /* 448972 */     // GIR_Coverage, 11424,
     /* 448972 */     GIR_EraseRootFromParent_Done,
     /* 448973 */   // Label 6331: @448973
     /* 448973 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(449102), // Rule ID 11492 //
     /* 448978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449059 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449100 */     GIR_RootConstrainSelectedInstOperands,
     /* 449101 */     // GIR_Coverage, 11492,
     /* 449101 */     GIR_EraseRootFromParent_Done,
     /* 449102 */   // Label 6332: @449102
     /* 449102 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(449231), // Rule ID 11493 //
     /* 449107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449151 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449156 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449188 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449229 */     GIR_RootConstrainSelectedInstOperands,
     /* 449230 */     // GIR_Coverage, 11493,
     /* 449230 */     GIR_EraseRootFromParent_Done,
     /* 449231 */   // Label 6333: @449231
     /* 449231 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(449360), // Rule ID 11494 //
     /* 449236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449317 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449358 */     GIR_RootConstrainSelectedInstOperands,
     /* 449359 */     // GIR_Coverage, 11494,
     /* 449359 */     GIR_EraseRootFromParent_Done,
     /* 449360 */   // Label 6334: @449360
     /* 449360 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(449489), // Rule ID 11495 //
     /* 449365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449446 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449487 */     GIR_RootConstrainSelectedInstOperands,
     /* 449488 */     // GIR_Coverage, 11495,
     /* 449488 */     GIR_EraseRootFromParent_Done,
     /* 449489 */   // Label 6335: @449489
     /* 449489 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(449618), // Rule ID 11432 //
     /* 449494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449575 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449616 */     GIR_RootConstrainSelectedInstOperands,
     /* 449617 */     // GIR_Coverage, 11432,
     /* 449617 */     GIR_EraseRootFromParent_Done,
     /* 449618 */   // Label 6336: @449618
     /* 449618 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(449747), // Rule ID 11433 //
     /* 449623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449704 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449745 */     GIR_RootConstrainSelectedInstOperands,
     /* 449746 */     // GIR_Coverage, 11433,
     /* 449746 */     GIR_EraseRootFromParent_Done,
     /* 449747 */   // Label 6337: @449747
     /* 449747 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(449876), // Rule ID 11434 //
     /* 449752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449796 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449801 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449833 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449874 */     GIR_RootConstrainSelectedInstOperands,
     /* 449875 */     // GIR_Coverage, 11434,
     /* 449875 */     GIR_EraseRootFromParent_Done,
     /* 449876 */   // Label 6338: @449876
     /* 449876 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(450005), // Rule ID 11435 //
     /* 449881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449962 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450003 */     GIR_RootConstrainSelectedInstOperands,
     /* 450004 */     // GIR_Coverage, 11435,
     /* 450004 */     GIR_EraseRootFromParent_Done,
     /* 450005 */   // Label 6339: @450005
     /* 450005 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(450134), // Rule ID 11477 //
     /* 450010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450091 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450132 */     GIR_RootConstrainSelectedInstOperands,
     /* 450133 */     // GIR_Coverage, 11477,
     /* 450133 */     GIR_EraseRootFromParent_Done,
     /* 450134 */   // Label 6340: @450134
     /* 450134 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(450263), // Rule ID 11478 //
     /* 450139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450220 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450261 */     GIR_RootConstrainSelectedInstOperands,
     /* 450262 */     // GIR_Coverage, 11478,
     /* 450262 */     GIR_EraseRootFromParent_Done,
     /* 450263 */   // Label 6341: @450263
     /* 450263 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(450392), // Rule ID 11479 //
     /* 450268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450349 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450390 */     GIR_RootConstrainSelectedInstOperands,
     /* 450391 */     // GIR_Coverage, 11479,
     /* 450391 */     GIR_EraseRootFromParent_Done,
     /* 450392 */   // Label 6342: @450392
     /* 450392 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(450521), // Rule ID 11480 //
     /* 450397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450441 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450446 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450478 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450519 */     GIR_RootConstrainSelectedInstOperands,
     /* 450520 */     // GIR_Coverage, 11480,
     /* 450520 */     GIR_EraseRootFromParent_Done,
     /* 450521 */   // Label 6343: @450521
     /* 450521 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(450650), // Rule ID 11417 //
     /* 450526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450607 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450648 */     GIR_RootConstrainSelectedInstOperands,
     /* 450649 */     // GIR_Coverage, 11417,
     /* 450649 */     GIR_EraseRootFromParent_Done,
     /* 450650 */   // Label 6344: @450650
     /* 450650 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(450779), // Rule ID 11418 //
     /* 450655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450736 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450777 */     GIR_RootConstrainSelectedInstOperands,
     /* 450778 */     // GIR_Coverage, 11418,
     /* 450778 */     GIR_EraseRootFromParent_Done,
     /* 450779 */   // Label 6345: @450779
     /* 450779 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(450908), // Rule ID 11419 //
     /* 450784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450865 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450906 */     GIR_RootConstrainSelectedInstOperands,
     /* 450907 */     // GIR_Coverage, 11419,
     /* 450907 */     GIR_EraseRootFromParent_Done,
     /* 450908 */   // Label 6346: @450908
     /* 450908 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(451037), // Rule ID 11420 //
     /* 450913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450994 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 451014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 451019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451035 */     GIR_RootConstrainSelectedInstOperands,
     /* 451036 */     // GIR_Coverage, 11420,
     /* 451036 */     GIR_EraseRootFromParent_Done,
     /* 451037 */   // Label 6347: @451037
     /* 451037 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(451149), // Rule ID 13255 //
     /* 451042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 451057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 451065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451077 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451079 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 451083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451106 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451147 */     GIR_RootConstrainSelectedInstOperands,
     /* 451148 */     // GIR_Coverage, 13255,
     /* 451148 */     GIR_EraseRootFromParent_Done,
     /* 451149 */   // Label 6348: @451149
     /* 451149 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(451261), // Rule ID 13254 //
     /* 451154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 451169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 451177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451189 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451191 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 451195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451218 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451259 */     GIR_RootConstrainSelectedInstOperands,
     /* 451260 */     // GIR_Coverage, 13254,
     /* 451260 */     GIR_EraseRootFromParent_Done,
     /* 451261 */   // Label 6349: @451261
     /* 451261 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(451373), // Rule ID 7729 //
     /* 451266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 451281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 451289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451301 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451303 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 451307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451330 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451371 */     GIR_RootConstrainSelectedInstOperands,
     /* 451372 */     // GIR_Coverage, 7729,
     /* 451372 */     GIR_EraseRootFromParent_Done,
     /* 451373 */   // Label 6350: @451373
     /* 451373 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(451485), // Rule ID 7728 //
     /* 451378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 451393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 451401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451413 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451415 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 451419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451442 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451483 */     GIR_RootConstrainSelectedInstOperands,
     /* 451484 */     // GIR_Coverage, 7728,
     /* 451484 */     GIR_EraseRootFromParent_Done,
     /* 451485 */   // Label 6351: @451485
     /* 451485 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(451581), // Rule ID 13247 //
     /* 451490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451513 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451538 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451579 */     GIR_RootConstrainSelectedInstOperands,
     /* 451580 */     // GIR_Coverage, 13247,
     /* 451580 */     GIR_EraseRootFromParent_Done,
     /* 451581 */   // Label 6352: @451581
     /* 451581 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(451677), // Rule ID 13246 //
     /* 451586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451609 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451634 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451675 */     GIR_RootConstrainSelectedInstOperands,
     /* 451676 */     // GIR_Coverage, 13246,
     /* 451676 */     GIR_EraseRootFromParent_Done,
     /* 451677 */   // Label 6353: @451677
     /* 451677 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(451773), // Rule ID 7721 //
     /* 451682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451705 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451730 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451771 */     GIR_RootConstrainSelectedInstOperands,
     /* 451772 */     // GIR_Coverage, 7721,
     /* 451772 */     GIR_EraseRootFromParent_Done,
     /* 451773 */   // Label 6354: @451773
     /* 451773 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(451869), // Rule ID 7720 //
     /* 451778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451801 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451826 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451867 */     GIR_RootConstrainSelectedInstOperands,
     /* 451868 */     // GIR_Coverage, 7720,
     /* 451868 */     GIR_EraseRootFromParent_Done,
     /* 451869 */   // Label 6355: @451869
     /* 451869 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(451904), // Rule ID 93 //
     /* 451874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 451877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13766),
     /* 451893 */     // (fmaxnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13766>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 451893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 451898 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 451902 */     GIR_RootConstrainSelectedInstOperands,
     /* 451903 */     // GIR_Coverage, 93,
     /* 451903 */     GIR_Done,
     /* 451904 */   // Label 6356: @451904
     /* 451904 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(451964), // Rule ID 803 //
     /* 451909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451927 */     // (fmaxnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 451930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 451937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 451947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 451957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 451962 */     GIR_RootConstrainSelectedInstOperands,
     /* 451963 */     // GIR_Coverage, 803,
     /* 451963 */     GIR_EraseRootFromParent_Done,
     /* 451964 */   // Label 6357: @451964
     /* 451964 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(452024), // Rule ID 8427 //
     /* 451969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451987 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 451990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 451997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 452007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 452017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 452022 */     GIR_RootConstrainSelectedInstOperands,
     /* 452023 */     // GIR_Coverage, 8427,
     /* 452023 */     GIR_EraseRootFromParent_Done,
     /* 452024 */   // Label 6358: @452024
     /* 452024 */   GIM_Reject,
     /* 452025 */ // Label 6219: @452025
     /* 452025 */ GIM_Reject,
     /* 452026 */ // Label 5809: @452026
     /* 452026 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(452278),
     /* 452031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 452034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 452037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 452041 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(452100), // Rule ID 918 //
     /* 452046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 452049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 452056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452063 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 452063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 452066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 452073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 452083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 452093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 452098 */     GIR_RootConstrainSelectedInstOperands,
     /* 452099 */     // GIR_Coverage, 918,
     /* 452099 */     GIR_EraseRootFromParent_Done,
     /* 452100 */   // Label 6360: @452100
     /* 452100 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(452159), // Rule ID 937 //
     /* 452105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 452108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 452115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452122 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 452122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 452125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 452132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 452142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 452152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 452157 */     GIR_RootConstrainSelectedInstOperands,
     /* 452158 */     // GIR_Coverage, 937,
     /* 452158 */     GIR_EraseRootFromParent_Done,
     /* 452159 */   // Label 6361: @452159
     /* 452159 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(452218), // Rule ID 8453 //
     /* 452164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 452167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 452181 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 452181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 452184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 452191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 452201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 452211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 452216 */     GIR_RootConstrainSelectedInstOperands,
     /* 452217 */     // GIR_Coverage, 8453,
     /* 452217 */     GIR_EraseRootFromParent_Done,
     /* 452218 */   // Label 6362: @452218
     /* 452218 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(452277), // Rule ID 8467 //
     /* 452223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 452226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 452240 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 452240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 452243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 452250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 452260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 452270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 452275 */     GIR_RootConstrainSelectedInstOperands,
     /* 452276 */     // GIR_Coverage, 8467,
     /* 452276 */     GIR_EraseRootFromParent_Done,
     /* 452277 */   // Label 6363: @452277
     /* 452277 */   GIM_Reject,
     /* 452278 */ // Label 6359: @452278
     /* 452278 */ GIM_Reject,
     /* 452279 */ // Label 5810: @452279
     /* 452279 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(452350), // Rule ID 1095 //
     /* 452284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 452287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 452290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 452301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 452308 */   // (fmaxnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 452308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 452311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 452318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 452328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452348 */   GIR_RootConstrainSelectedInstOperands,
     /* 452349 */   // GIR_Coverage, 1095,
     /* 452349 */   GIR_EraseRootFromParent_Done,
     /* 452350 */ // Label 6364: @452350
     /* 452350 */ GIM_Reject,
     /* 452351 */ // Label 5811: @452351
     /* 452351 */ GIM_Reject,
     /* 452352 */ // Label 82: @452352
     /* 452352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6369*/ GIMT_Encode4(524130),
     /* 452363 */ /*GILLT_s16*//*Label 6365*/ GIMT_Encode4(452379),
     /* 452367 */ /*GILLT_s32*//*Label 6366*/ GIMT_Encode4(506293),
     /* 452371 */ /*GILLT_s64*//*Label 6367*/ GIMT_Encode4(523805),
     /* 452375 */ /*GILLT_v2s16*//*Label 6368*/ GIMT_Encode4(524058),
     /* 452379 */ // Label 6365: @452379
     /* 452379 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(506292),
     /* 452384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 452387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 452390 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(452525), // Rule ID 12146 //
     /* 452395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452479 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452523 */     GIR_RootConstrainSelectedInstOperands,
     /* 452524 */     // GIR_Coverage, 12146,
     /* 452524 */     GIR_EraseRootFromParent_Done,
     /* 452525 */   // Label 6371: @452525
     /* 452525 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(452660), // Rule ID 12147 //
     /* 452530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452614 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452658 */     GIR_RootConstrainSelectedInstOperands,
     /* 452659 */     // GIR_Coverage, 12147,
     /* 452659 */     GIR_EraseRootFromParent_Done,
     /* 452660 */   // Label 6372: @452660
     /* 452660 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(452795), // Rule ID 12150 //
     /* 452665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452749 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 452769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452793 */     GIR_RootConstrainSelectedInstOperands,
     /* 452794 */     // GIR_Coverage, 12150,
     /* 452794 */     GIR_EraseRootFromParent_Done,
     /* 452795 */   // Label 6373: @452795
     /* 452795 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(452930), // Rule ID 12151 //
     /* 452800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452884 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 452904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452928 */     GIR_RootConstrainSelectedInstOperands,
     /* 452929 */     // GIR_Coverage, 12151,
     /* 452929 */     GIR_EraseRootFromParent_Done,
     /* 452930 */   // Label 6374: @452930
     /* 452930 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(453065), // Rule ID 12626 //
     /* 452935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 452938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 452942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453019 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 453022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453063 */     GIR_RootConstrainSelectedInstOperands,
     /* 453064 */     // GIR_Coverage, 12626,
     /* 453064 */     GIR_EraseRootFromParent_Done,
     /* 453065 */   // Label 6375: @453065
     /* 453065 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(453200), // Rule ID 12627 //
     /* 453070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 453073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 453077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453154 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 453157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453198 */     GIR_RootConstrainSelectedInstOperands,
     /* 453199 */     // GIR_Coverage, 12627,
     /* 453199 */     GIR_EraseRootFromParent_Done,
     /* 453200 */   // Label 6376: @453200
     /* 453200 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(453335), // Rule ID 12630 //
     /* 453205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 453208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 453212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453289 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 453292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453333 */     GIR_RootConstrainSelectedInstOperands,
     /* 453334 */     // GIR_Coverage, 12630,
     /* 453334 */     GIR_EraseRootFromParent_Done,
     /* 453335 */   // Label 6377: @453335
     /* 453335 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(453470), // Rule ID 12631 //
     /* 453340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 453343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 453347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453424 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 453427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453468 */     GIR_RootConstrainSelectedInstOperands,
     /* 453469 */     // GIR_Coverage, 12631,
     /* 453469 */     GIR_EraseRootFromParent_Done,
     /* 453470 */   // Label 6378: @453470
     /* 453470 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(453605), // Rule ID 13106 //
     /* 453475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453559 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453603 */     GIR_RootConstrainSelectedInstOperands,
     /* 453604 */     // GIR_Coverage, 13106,
     /* 453604 */     GIR_EraseRootFromParent_Done,
     /* 453605 */   // Label 6379: @453605
     /* 453605 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(453740), // Rule ID 13107 //
     /* 453610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453694 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453738 */     GIR_RootConstrainSelectedInstOperands,
     /* 453739 */     // GIR_Coverage, 13107,
     /* 453739 */     GIR_EraseRootFromParent_Done,
     /* 453740 */   // Label 6380: @453740
     /* 453740 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(453875), // Rule ID 13110 //
     /* 453745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453829 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453873 */     GIR_RootConstrainSelectedInstOperands,
     /* 453874 */     // GIR_Coverage, 13110,
     /* 453874 */     GIR_EraseRootFromParent_Done,
     /* 453875 */   // Label 6381: @453875
     /* 453875 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(454010), // Rule ID 13111 //
     /* 453880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453964 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454008 */     GIR_RootConstrainSelectedInstOperands,
     /* 454009 */     // GIR_Coverage, 13111,
     /* 454009 */     GIR_EraseRootFromParent_Done,
     /* 454010 */   // Label 6382: @454010
     /* 454010 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(454145), // Rule ID 12131 //
     /* 454015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 454018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454099 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454143 */     GIR_RootConstrainSelectedInstOperands,
     /* 454144 */     // GIR_Coverage, 12131,
     /* 454144 */     GIR_EraseRootFromParent_Done,
     /* 454145 */   // Label 6383: @454145
     /* 454145 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(454280), // Rule ID 12132 //
     /* 454150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 454153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454234 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454278 */     GIR_RootConstrainSelectedInstOperands,
     /* 454279 */     // GIR_Coverage, 12132,
     /* 454279 */     GIR_EraseRootFromParent_Done,
     /* 454280 */   // Label 6384: @454280
     /* 454280 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(454415), // Rule ID 12135 //
     /* 454285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 454288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454369 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454413 */     GIR_RootConstrainSelectedInstOperands,
     /* 454414 */     // GIR_Coverage, 12135,
     /* 454414 */     GIR_EraseRootFromParent_Done,
     /* 454415 */   // Label 6385: @454415
     /* 454415 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(454550), // Rule ID 12136 //
     /* 454420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 454423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454504 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454548 */     GIR_RootConstrainSelectedInstOperands,
     /* 454549 */     // GIR_Coverage, 12136,
     /* 454549 */     GIR_EraseRootFromParent_Done,
     /* 454550 */   // Label 6386: @454550
     /* 454550 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(454685), // Rule ID 12611 //
     /* 454555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454639 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454683 */     GIR_RootConstrainSelectedInstOperands,
     /* 454684 */     // GIR_Coverage, 12611,
     /* 454684 */     GIR_EraseRootFromParent_Done,
     /* 454685 */   // Label 6387: @454685
     /* 454685 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(454820), // Rule ID 12612 //
     /* 454690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454774 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454818 */     GIR_RootConstrainSelectedInstOperands,
     /* 454819 */     // GIR_Coverage, 12612,
     /* 454819 */     GIR_EraseRootFromParent_Done,
     /* 454820 */   // Label 6388: @454820
     /* 454820 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(454955), // Rule ID 12615 //
     /* 454825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454909 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454953 */     GIR_RootConstrainSelectedInstOperands,
     /* 454954 */     // GIR_Coverage, 12615,
     /* 454954 */     GIR_EraseRootFromParent_Done,
     /* 454955 */   // Label 6389: @454955
     /* 454955 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(455090), // Rule ID 12616 //
     /* 454960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455037 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455044 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 455047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455088 */     GIR_RootConstrainSelectedInstOperands,
     /* 455089 */     // GIR_Coverage, 12616,
     /* 455089 */     GIR_EraseRootFromParent_Done,
     /* 455090 */   // Label 6390: @455090
     /* 455090 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(455225), // Rule ID 13091 //
     /* 455095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455179 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455223 */     GIR_RootConstrainSelectedInstOperands,
     /* 455224 */     // GIR_Coverage, 13091,
     /* 455224 */     GIR_EraseRootFromParent_Done,
     /* 455225 */   // Label 6391: @455225
     /* 455225 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(455360), // Rule ID 13092 //
     /* 455230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455314 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455358 */     GIR_RootConstrainSelectedInstOperands,
     /* 455359 */     // GIR_Coverage, 13092,
     /* 455359 */     GIR_EraseRootFromParent_Done,
     /* 455360 */   // Label 6392: @455360
     /* 455360 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(455495), // Rule ID 13095 //
     /* 455365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455449 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455493 */     GIR_RootConstrainSelectedInstOperands,
     /* 455494 */     // GIR_Coverage, 13095,
     /* 455494 */     GIR_EraseRootFromParent_Done,
     /* 455495 */   // Label 6393: @455495
     /* 455495 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(455630), // Rule ID 13096 //
     /* 455500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455584 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455628 */     GIR_RootConstrainSelectedInstOperands,
     /* 455629 */     // GIR_Coverage, 13096,
     /* 455629 */     GIR_EraseRootFromParent_Done,
     /* 455630 */   // Label 6394: @455630
     /* 455630 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(455765), // Rule ID 7641 //
     /* 455635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 455638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455687 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455692 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455719 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 455722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455763 */     GIR_RootConstrainSelectedInstOperands,
     /* 455764 */     // GIR_Coverage, 7641,
     /* 455764 */     GIR_EraseRootFromParent_Done,
     /* 455765 */   // Label 6395: @455765
     /* 455765 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(455900), // Rule ID 7673 //
     /* 455770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 455773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 455777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455817 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455822 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455854 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 455857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455898 */     GIR_RootConstrainSelectedInstOperands,
     /* 455899 */     // GIR_Coverage, 7673,
     /* 455899 */     GIR_EraseRootFromParent_Done,
     /* 455900 */   // Label 6396: @455900
     /* 455900 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(456035), // Rule ID 7705 //
     /* 455905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455989 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456033 */     GIR_RootConstrainSelectedInstOperands,
     /* 456034 */     // GIR_Coverage, 7705,
     /* 456034 */     GIR_EraseRootFromParent_Done,
     /* 456035 */   // Label 6397: @456035
     /* 456035 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(456170), // Rule ID 12145 //
     /* 456040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456124 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456168 */     GIR_RootConstrainSelectedInstOperands,
     /* 456169 */     // GIR_Coverage, 12145,
     /* 456169 */     GIR_EraseRootFromParent_Done,
     /* 456170 */   // Label 6398: @456170
     /* 456170 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(456305), // Rule ID 12148 //
     /* 456175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456259 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456303 */     GIR_RootConstrainSelectedInstOperands,
     /* 456304 */     // GIR_Coverage, 12148,
     /* 456304 */     GIR_EraseRootFromParent_Done,
     /* 456305 */   // Label 6399: @456305
     /* 456305 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(456440), // Rule ID 12149 //
     /* 456310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456394 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456438 */     GIR_RootConstrainSelectedInstOperands,
     /* 456439 */     // GIR_Coverage, 12149,
     /* 456439 */     GIR_EraseRootFromParent_Done,
     /* 456440 */   // Label 6400: @456440
     /* 456440 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(456575), // Rule ID 12625 //
     /* 456445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456492 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456497 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456529 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456573 */     GIR_RootConstrainSelectedInstOperands,
     /* 456574 */     // GIR_Coverage, 12625,
     /* 456574 */     GIR_EraseRootFromParent_Done,
     /* 456575 */   // Label 6401: @456575
     /* 456575 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(456710), // Rule ID 12628 //
     /* 456580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456627 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456632 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456664 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456708 */     GIR_RootConstrainSelectedInstOperands,
     /* 456709 */     // GIR_Coverage, 12628,
     /* 456709 */     GIR_EraseRootFromParent_Done,
     /* 456710 */   // Label 6402: @456710
     /* 456710 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(456845), // Rule ID 12629 //
     /* 456715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456762 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456767 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456799 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456843 */     GIR_RootConstrainSelectedInstOperands,
     /* 456844 */     // GIR_Coverage, 12629,
     /* 456844 */     GIR_EraseRootFromParent_Done,
     /* 456845 */   // Label 6403: @456845
     /* 456845 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(456980), // Rule ID 13105 //
     /* 456850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 456853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456934 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 456937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456978 */     GIR_RootConstrainSelectedInstOperands,
     /* 456979 */     // GIR_Coverage, 13105,
     /* 456979 */     GIR_EraseRootFromParent_Done,
     /* 456980 */   // Label 6404: @456980
     /* 456980 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(457115), // Rule ID 13108 //
     /* 456985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 456988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457069 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457113 */     GIR_RootConstrainSelectedInstOperands,
     /* 457114 */     // GIR_Coverage, 13108,
     /* 457114 */     GIR_EraseRootFromParent_Done,
     /* 457115 */   // Label 6405: @457115
     /* 457115 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(457250), // Rule ID 13109 //
     /* 457120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457204 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457248 */     GIR_RootConstrainSelectedInstOperands,
     /* 457249 */     // GIR_Coverage, 13109,
     /* 457249 */     GIR_EraseRootFromParent_Done,
     /* 457250 */   // Label 6406: @457250
     /* 457250 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(457385), // Rule ID 7640 //
     /* 457255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457302 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457339 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457383 */     GIR_RootConstrainSelectedInstOperands,
     /* 457384 */     // GIR_Coverage, 7640,
     /* 457384 */     GIR_EraseRootFromParent_Done,
     /* 457385 */   // Label 6407: @457385
     /* 457385 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(457520), // Rule ID 7672 //
     /* 457390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457437 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457442 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457474 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457518 */     GIR_RootConstrainSelectedInstOperands,
     /* 457519 */     // GIR_Coverage, 7672,
     /* 457519 */     GIR_EraseRootFromParent_Done,
     /* 457520 */   // Label 6408: @457520
     /* 457520 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(457655), // Rule ID 7704 //
     /* 457525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457609 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457653 */     GIR_RootConstrainSelectedInstOperands,
     /* 457654 */     // GIR_Coverage, 7704,
     /* 457654 */     GIR_EraseRootFromParent_Done,
     /* 457655 */   // Label 6409: @457655
     /* 457655 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(457790), // Rule ID 12130 //
     /* 457660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457744 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457788 */     GIR_RootConstrainSelectedInstOperands,
     /* 457789 */     // GIR_Coverage, 12130,
     /* 457789 */     GIR_EraseRootFromParent_Done,
     /* 457790 */   // Label 6410: @457790
     /* 457790 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(457925), // Rule ID 12133 //
     /* 457795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457879 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457923 */     GIR_RootConstrainSelectedInstOperands,
     /* 457924 */     // GIR_Coverage, 12133,
     /* 457924 */     GIR_EraseRootFromParent_Done,
     /* 457925 */   // Label 6411: @457925
     /* 457925 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(458060), // Rule ID 12134 //
     /* 457930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458014 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458058 */     GIR_RootConstrainSelectedInstOperands,
     /* 458059 */     // GIR_Coverage, 12134,
     /* 458059 */     GIR_EraseRootFromParent_Done,
     /* 458060 */   // Label 6412: @458060
     /* 458060 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(458195), // Rule ID 12610 //
     /* 458065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458112 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458117 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458149 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458193 */     GIR_RootConstrainSelectedInstOperands,
     /* 458194 */     // GIR_Coverage, 12610,
     /* 458194 */     GIR_EraseRootFromParent_Done,
     /* 458195 */   // Label 6413: @458195
     /* 458195 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(458330), // Rule ID 12613 //
     /* 458200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458247 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458252 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458284 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458328 */     GIR_RootConstrainSelectedInstOperands,
     /* 458329 */     // GIR_Coverage, 12613,
     /* 458329 */     GIR_EraseRootFromParent_Done,
     /* 458330 */   // Label 6414: @458330
     /* 458330 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(458465), // Rule ID 12614 //
     /* 458335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458382 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458387 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458419 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458463 */     GIR_RootConstrainSelectedInstOperands,
     /* 458464 */     // GIR_Coverage, 12614,
     /* 458464 */     GIR_EraseRootFromParent_Done,
     /* 458465 */   // Label 6415: @458465
     /* 458465 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(458600), // Rule ID 13090 //
     /* 458470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458554 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458598 */     GIR_RootConstrainSelectedInstOperands,
     /* 458599 */     // GIR_Coverage, 13090,
     /* 458599 */     GIR_EraseRootFromParent_Done,
     /* 458600 */   // Label 6416: @458600
     /* 458600 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(458735), // Rule ID 13093 //
     /* 458605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458689 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458733 */     GIR_RootConstrainSelectedInstOperands,
     /* 458734 */     // GIR_Coverage, 13093,
     /* 458734 */     GIR_EraseRootFromParent_Done,
     /* 458735 */   // Label 6417: @458735
     /* 458735 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(458870), // Rule ID 13094 //
     /* 458740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458824 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458868 */     GIR_RootConstrainSelectedInstOperands,
     /* 458869 */     // GIR_Coverage, 13094,
     /* 458869 */     GIR_EraseRootFromParent_Done,
     /* 458870 */   // Label 6418: @458870
     /* 458870 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(459005), // Rule ID 12116 //
     /* 458875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 458906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 458922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458959 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459003 */     GIR_RootConstrainSelectedInstOperands,
     /* 459004 */     // GIR_Coverage, 12116,
     /* 459004 */     GIR_EraseRootFromParent_Done,
     /* 459005 */   // Label 6419: @459005
     /* 459005 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(459140), // Rule ID 12117 //
     /* 459010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 459013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459094 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 459097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459138 */     GIR_RootConstrainSelectedInstOperands,
     /* 459139 */     // GIR_Coverage, 12117,
     /* 459139 */     GIR_EraseRootFromParent_Done,
     /* 459140 */   // Label 6420: @459140
     /* 459140 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(459275), // Rule ID 12120 //
     /* 459145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 459148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459229 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 459232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459273 */     GIR_RootConstrainSelectedInstOperands,
     /* 459274 */     // GIR_Coverage, 12120,
     /* 459274 */     GIR_EraseRootFromParent_Done,
     /* 459275 */   // Label 6421: @459275
     /* 459275 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(459410), // Rule ID 12121 //
     /* 459280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 459283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459364 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 459367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459408 */     GIR_RootConstrainSelectedInstOperands,
     /* 459409 */     // GIR_Coverage, 12121,
     /* 459409 */     GIR_EraseRootFromParent_Done,
     /* 459410 */   // Label 6422: @459410
     /* 459410 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(459545), // Rule ID 12596 //
     /* 459415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459499 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459543 */     GIR_RootConstrainSelectedInstOperands,
     /* 459544 */     // GIR_Coverage, 12596,
     /* 459544 */     GIR_EraseRootFromParent_Done,
     /* 459545 */   // Label 6423: @459545
     /* 459545 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(459680), // Rule ID 12597 //
     /* 459550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459634 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459678 */     GIR_RootConstrainSelectedInstOperands,
     /* 459679 */     // GIR_Coverage, 12597,
     /* 459679 */     GIR_EraseRootFromParent_Done,
     /* 459680 */   // Label 6424: @459680
     /* 459680 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(459815), // Rule ID 12600 //
     /* 459685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459769 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459813 */     GIR_RootConstrainSelectedInstOperands,
     /* 459814 */     // GIR_Coverage, 12600,
     /* 459814 */     GIR_EraseRootFromParent_Done,
     /* 459815 */   // Label 6425: @459815
     /* 459815 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(459950), // Rule ID 12601 //
     /* 459820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459904 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459948 */     GIR_RootConstrainSelectedInstOperands,
     /* 459949 */     // GIR_Coverage, 12601,
     /* 459949 */     GIR_EraseRootFromParent_Done,
     /* 459950 */   // Label 6426: @459950
     /* 459950 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(460085), // Rule ID 13076 //
     /* 459955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460039 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460083 */     GIR_RootConstrainSelectedInstOperands,
     /* 460084 */     // GIR_Coverage, 13076,
     /* 460084 */     GIR_EraseRootFromParent_Done,
     /* 460085 */   // Label 6427: @460085
     /* 460085 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(460220), // Rule ID 13077 //
     /* 460090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460174 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460218 */     GIR_RootConstrainSelectedInstOperands,
     /* 460219 */     // GIR_Coverage, 13077,
     /* 460219 */     GIR_EraseRootFromParent_Done,
     /* 460220 */   // Label 6428: @460220
     /* 460220 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(460355), // Rule ID 13080 //
     /* 460225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460309 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460353 */     GIR_RootConstrainSelectedInstOperands,
     /* 460354 */     // GIR_Coverage, 13080,
     /* 460354 */     GIR_EraseRootFromParent_Done,
     /* 460355 */   // Label 6429: @460355
     /* 460355 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(460490), // Rule ID 13081 //
     /* 460360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460444 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460488 */     GIR_RootConstrainSelectedInstOperands,
     /* 460489 */     // GIR_Coverage, 13081,
     /* 460489 */     GIR_EraseRootFromParent_Done,
     /* 460490 */   // Label 6430: @460490
     /* 460490 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(460625), // Rule ID 12101 //
     /* 460495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460579 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460623 */     GIR_RootConstrainSelectedInstOperands,
     /* 460624 */     // GIR_Coverage, 12101,
     /* 460624 */     GIR_EraseRootFromParent_Done,
     /* 460625 */   // Label 6431: @460625
     /* 460625 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(460760), // Rule ID 12102 //
     /* 460630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460714 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460758 */     GIR_RootConstrainSelectedInstOperands,
     /* 460759 */     // GIR_Coverage, 12102,
     /* 460759 */     GIR_EraseRootFromParent_Done,
     /* 460760 */   // Label 6432: @460760
     /* 460760 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(460895), // Rule ID 12105 //
     /* 460765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460817 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460849 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460893 */     GIR_RootConstrainSelectedInstOperands,
     /* 460894 */     // GIR_Coverage, 12105,
     /* 460894 */     GIR_EraseRootFromParent_Done,
     /* 460895 */   // Label 6433: @460895
     /* 460895 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(461030), // Rule ID 12106 //
     /* 460900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460984 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461028 */     GIR_RootConstrainSelectedInstOperands,
     /* 461029 */     // GIR_Coverage, 12106,
     /* 461029 */     GIR_EraseRootFromParent_Done,
     /* 461030 */   // Label 6434: @461030
     /* 461030 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(461165), // Rule ID 12581 //
     /* 461035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461119 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461163 */     GIR_RootConstrainSelectedInstOperands,
     /* 461164 */     // GIR_Coverage, 12581,
     /* 461164 */     GIR_EraseRootFromParent_Done,
     /* 461165 */   // Label 6435: @461165
     /* 461165 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(461300), // Rule ID 12582 //
     /* 461170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461254 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461298 */     GIR_RootConstrainSelectedInstOperands,
     /* 461299 */     // GIR_Coverage, 12582,
     /* 461299 */     GIR_EraseRootFromParent_Done,
     /* 461300 */   // Label 6436: @461300
     /* 461300 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(461435), // Rule ID 12585 //
     /* 461305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461389 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461433 */     GIR_RootConstrainSelectedInstOperands,
     /* 461434 */     // GIR_Coverage, 12585,
     /* 461434 */     GIR_EraseRootFromParent_Done,
     /* 461435 */   // Label 6437: @461435
     /* 461435 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(461570), // Rule ID 12586 //
     /* 461440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461524 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461568 */     GIR_RootConstrainSelectedInstOperands,
     /* 461569 */     // GIR_Coverage, 12586,
     /* 461569 */     GIR_EraseRootFromParent_Done,
     /* 461570 */   // Label 6438: @461570
     /* 461570 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(461705), // Rule ID 13061 //
     /* 461575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461659 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461703 */     GIR_RootConstrainSelectedInstOperands,
     /* 461704 */     // GIR_Coverage, 13061,
     /* 461704 */     GIR_EraseRootFromParent_Done,
     /* 461705 */   // Label 6439: @461705
     /* 461705 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(461840), // Rule ID 13062 //
     /* 461710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461794 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461838 */     GIR_RootConstrainSelectedInstOperands,
     /* 461839 */     // GIR_Coverage, 13062,
     /* 461839 */     GIR_EraseRootFromParent_Done,
     /* 461840 */   // Label 6440: @461840
     /* 461840 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(461975), // Rule ID 13065 //
     /* 461845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461929 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461973 */     GIR_RootConstrainSelectedInstOperands,
     /* 461974 */     // GIR_Coverage, 13065,
     /* 461974 */     GIR_EraseRootFromParent_Done,
     /* 461975 */   // Label 6441: @461975
     /* 461975 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(462110), // Rule ID 13066 //
     /* 461980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 462023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462064 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462108 */     GIR_RootConstrainSelectedInstOperands,
     /* 462109 */     // GIR_Coverage, 13066,
     /* 462109 */     GIR_EraseRootFromParent_Done,
     /* 462110 */   // Label 6442: @462110
     /* 462110 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(462245), // Rule ID 7639 //
     /* 462115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462199 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462243 */     GIR_RootConstrainSelectedInstOperands,
     /* 462244 */     // GIR_Coverage, 7639,
     /* 462244 */     GIR_EraseRootFromParent_Done,
     /* 462245 */   // Label 6443: @462245
     /* 462245 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(462380), // Rule ID 7671 //
     /* 462250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462297 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462302 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462334 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462378 */     GIR_RootConstrainSelectedInstOperands,
     /* 462379 */     // GIR_Coverage, 7671,
     /* 462379 */     GIR_EraseRootFromParent_Done,
     /* 462380 */   // Label 6444: @462380
     /* 462380 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(462515), // Rule ID 7703 //
     /* 462385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 462388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462469 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462513 */     GIR_RootConstrainSelectedInstOperands,
     /* 462514 */     // GIR_Coverage, 7703,
     /* 462514 */     GIR_EraseRootFromParent_Done,
     /* 462515 */   // Label 6445: @462515
     /* 462515 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(462650), // Rule ID 12115 //
     /* 462520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462604 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462648 */     GIR_RootConstrainSelectedInstOperands,
     /* 462649 */     // GIR_Coverage, 12115,
     /* 462649 */     GIR_EraseRootFromParent_Done,
     /* 462650 */   // Label 6446: @462650
     /* 462650 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(462785), // Rule ID 12118 //
     /* 462655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462739 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462783 */     GIR_RootConstrainSelectedInstOperands,
     /* 462784 */     // GIR_Coverage, 12118,
     /* 462784 */     GIR_EraseRootFromParent_Done,
     /* 462785 */   // Label 6447: @462785
     /* 462785 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(462920), // Rule ID 12119 //
     /* 462790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462874 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462918 */     GIR_RootConstrainSelectedInstOperands,
     /* 462919 */     // GIR_Coverage, 12119,
     /* 462919 */     GIR_EraseRootFromParent_Done,
     /* 462920 */   // Label 6448: @462920
     /* 462920 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(463055), // Rule ID 12595 //
     /* 462925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462972 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462977 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463009 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463053 */     GIR_RootConstrainSelectedInstOperands,
     /* 463054 */     // GIR_Coverage, 12595,
     /* 463054 */     GIR_EraseRootFromParent_Done,
     /* 463055 */   // Label 6449: @463055
     /* 463055 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(463190), // Rule ID 12598 //
     /* 463060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463107 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463112 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463144 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463188 */     GIR_RootConstrainSelectedInstOperands,
     /* 463189 */     // GIR_Coverage, 12598,
     /* 463189 */     GIR_EraseRootFromParent_Done,
     /* 463190 */   // Label 6450: @463190
     /* 463190 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(463325), // Rule ID 12599 //
     /* 463195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463242 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463247 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463279 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463323 */     GIR_RootConstrainSelectedInstOperands,
     /* 463324 */     // GIR_Coverage, 12599,
     /* 463324 */     GIR_EraseRootFromParent_Done,
     /* 463325 */   // Label 6451: @463325
     /* 463325 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(463460), // Rule ID 13075 //
     /* 463330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463414 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463458 */     GIR_RootConstrainSelectedInstOperands,
     /* 463459 */     // GIR_Coverage, 13075,
     /* 463459 */     GIR_EraseRootFromParent_Done,
     /* 463460 */   // Label 6452: @463460
     /* 463460 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(463595), // Rule ID 13078 //
     /* 463465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463549 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463593 */     GIR_RootConstrainSelectedInstOperands,
     /* 463594 */     // GIR_Coverage, 13078,
     /* 463594 */     GIR_EraseRootFromParent_Done,
     /* 463595 */   // Label 6453: @463595
     /* 463595 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(463730), // Rule ID 13079 //
     /* 463600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463684 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463728 */     GIR_RootConstrainSelectedInstOperands,
     /* 463729 */     // GIR_Coverage, 13079,
     /* 463729 */     GIR_EraseRootFromParent_Done,
     /* 463730 */   // Label 6454: @463730
     /* 463730 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(463865), // Rule ID 7638 //
     /* 463735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463819 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463863 */     GIR_RootConstrainSelectedInstOperands,
     /* 463864 */     // GIR_Coverage, 7638,
     /* 463864 */     GIR_EraseRootFromParent_Done,
     /* 463865 */   // Label 6455: @463865
     /* 463865 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(464000), // Rule ID 7670 //
     /* 463870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463917 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463922 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463954 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463998 */     GIR_RootConstrainSelectedInstOperands,
     /* 463999 */     // GIR_Coverage, 7670,
     /* 463999 */     GIR_EraseRootFromParent_Done,
     /* 464000 */   // Label 6456: @464000
     /* 464000 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(464135), // Rule ID 7702 //
     /* 464005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464089 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464133 */     GIR_RootConstrainSelectedInstOperands,
     /* 464134 */     // GIR_Coverage, 7702,
     /* 464134 */     GIR_EraseRootFromParent_Done,
     /* 464135 */   // Label 6457: @464135
     /* 464135 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(464270), // Rule ID 12100 //
     /* 464140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464224 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464268 */     GIR_RootConstrainSelectedInstOperands,
     /* 464269 */     // GIR_Coverage, 12100,
     /* 464269 */     GIR_EraseRootFromParent_Done,
     /* 464270 */   // Label 6458: @464270
     /* 464270 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(464405), // Rule ID 12103 //
     /* 464275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464359 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464403 */     GIR_RootConstrainSelectedInstOperands,
     /* 464404 */     // GIR_Coverage, 12103,
     /* 464404 */     GIR_EraseRootFromParent_Done,
     /* 464405 */   // Label 6459: @464405
     /* 464405 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(464540), // Rule ID 12104 //
     /* 464410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464494 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464538 */     GIR_RootConstrainSelectedInstOperands,
     /* 464539 */     // GIR_Coverage, 12104,
     /* 464539 */     GIR_EraseRootFromParent_Done,
     /* 464540 */   // Label 6460: @464540
     /* 464540 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(464675), // Rule ID 12580 //
     /* 464545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464592 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464597 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464629 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464673 */     GIR_RootConstrainSelectedInstOperands,
     /* 464674 */     // GIR_Coverage, 12580,
     /* 464674 */     GIR_EraseRootFromParent_Done,
     /* 464675 */   // Label 6461: @464675
     /* 464675 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(464810), // Rule ID 12583 //
     /* 464680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464727 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464732 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464764 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464808 */     GIR_RootConstrainSelectedInstOperands,
     /* 464809 */     // GIR_Coverage, 12583,
     /* 464809 */     GIR_EraseRootFromParent_Done,
     /* 464810 */   // Label 6462: @464810
     /* 464810 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(464945), // Rule ID 12584 //
     /* 464815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464862 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464867 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464899 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464943 */     GIR_RootConstrainSelectedInstOperands,
     /* 464944 */     // GIR_Coverage, 12584,
     /* 464944 */     GIR_EraseRootFromParent_Done,
     /* 464945 */   // Label 6463: @464945
     /* 464945 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(465080), // Rule ID 13060 //
     /* 464950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465034 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 465044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 465049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465078 */     GIR_RootConstrainSelectedInstOperands,
     /* 465079 */     // GIR_Coverage, 13060,
     /* 465079 */     GIR_EraseRootFromParent_Done,
     /* 465080 */   // Label 6464: @465080
     /* 465080 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(465215), // Rule ID 13063 //
     /* 465085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 465088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 465128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465169 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465213 */     GIR_RootConstrainSelectedInstOperands,
     /* 465214 */     // GIR_Coverage, 13063,
     /* 465214 */     GIR_EraseRootFromParent_Done,
     /* 465215 */   // Label 6465: @465215
     /* 465215 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(465350), // Rule ID 13064 //
     /* 465220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 465223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 465263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465304 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465348 */     GIR_RootConstrainSelectedInstOperands,
     /* 465349 */     // GIR_Coverage, 13064,
     /* 465349 */     GIR_EraseRootFromParent_Done,
     /* 465350 */   // Label 6466: @465350
     /* 465350 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(465485), // Rule ID 12156 //
     /* 465355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465439 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465483 */     GIR_RootConstrainSelectedInstOperands,
     /* 465484 */     // GIR_Coverage, 12156,
     /* 465484 */     GIR_EraseRootFromParent_Done,
     /* 465485 */   // Label 6467: @465485
     /* 465485 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(465620), // Rule ID 12157 //
     /* 465490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465574 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465618 */     GIR_RootConstrainSelectedInstOperands,
     /* 465619 */     // GIR_Coverage, 12157,
     /* 465619 */     GIR_EraseRootFromParent_Done,
     /* 465620 */   // Label 6468: @465620
     /* 465620 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(465755), // Rule ID 12158 //
     /* 465625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465709 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 465719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 465724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465753 */     GIR_RootConstrainSelectedInstOperands,
     /* 465754 */     // GIR_Coverage, 12158,
     /* 465754 */     GIR_EraseRootFromParent_Done,
     /* 465755 */   // Label 6469: @465755
     /* 465755 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(465890), // Rule ID 12159 //
     /* 465760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465844 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 465854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 465859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465888 */     GIR_RootConstrainSelectedInstOperands,
     /* 465889 */     // GIR_Coverage, 12159,
     /* 465889 */     GIR_EraseRootFromParent_Done,
     /* 465890 */   // Label 6470: @465890
     /* 465890 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(466025), // Rule ID 12636 //
     /* 465895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465979 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466023 */     GIR_RootConstrainSelectedInstOperands,
     /* 466024 */     // GIR_Coverage, 12636,
     /* 466024 */     GIR_EraseRootFromParent_Done,
     /* 466025 */   // Label 6471: @466025
     /* 466025 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(466160), // Rule ID 12637 //
     /* 466030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 466033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 466037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466114 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 466117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466158 */     GIR_RootConstrainSelectedInstOperands,
     /* 466159 */     // GIR_Coverage, 12637,
     /* 466159 */     GIR_EraseRootFromParent_Done,
     /* 466160 */   // Label 6472: @466160
     /* 466160 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(466295), // Rule ID 12638 //
     /* 466165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 466168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 466172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466249 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 466252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466293 */     GIR_RootConstrainSelectedInstOperands,
     /* 466294 */     // GIR_Coverage, 12638,
     /* 466294 */     GIR_EraseRootFromParent_Done,
     /* 466295 */   // Label 6473: @466295
     /* 466295 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(466430), // Rule ID 12639 //
     /* 466300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 466303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 466307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466384 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 466387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466428 */     GIR_RootConstrainSelectedInstOperands,
     /* 466429 */     // GIR_Coverage, 12639,
     /* 466429 */     GIR_EraseRootFromParent_Done,
     /* 466430 */   // Label 6474: @466430
     /* 466430 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(466565), // Rule ID 13116 //
     /* 466435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466519 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466563 */     GIR_RootConstrainSelectedInstOperands,
     /* 466564 */     // GIR_Coverage, 13116,
     /* 466564 */     GIR_EraseRootFromParent_Done,
     /* 466565 */   // Label 6475: @466565
     /* 466565 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(466700), // Rule ID 13117 //
     /* 466570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466654 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466698 */     GIR_RootConstrainSelectedInstOperands,
     /* 466699 */     // GIR_Coverage, 13117,
     /* 466699 */     GIR_EraseRootFromParent_Done,
     /* 466700 */   // Label 6476: @466700
     /* 466700 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(466835), // Rule ID 13118 //
     /* 466705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466789 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466833 */     GIR_RootConstrainSelectedInstOperands,
     /* 466834 */     // GIR_Coverage, 13118,
     /* 466834 */     GIR_EraseRootFromParent_Done,
     /* 466835 */   // Label 6477: @466835
     /* 466835 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(466970), // Rule ID 13119 //
     /* 466840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466924 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466968 */     GIR_RootConstrainSelectedInstOperands,
     /* 466969 */     // GIR_Coverage, 13119,
     /* 466969 */     GIR_EraseRootFromParent_Done,
     /* 466970 */   // Label 6478: @466970
     /* 466970 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(467105), // Rule ID 12096 //
     /* 466975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467059 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467103 */     GIR_RootConstrainSelectedInstOperands,
     /* 467104 */     // GIR_Coverage, 12096,
     /* 467104 */     GIR_EraseRootFromParent_Done,
     /* 467105 */   // Label 6479: @467105
     /* 467105 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(467240), // Rule ID 12097 //
     /* 467110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 467113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467194 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467238 */     GIR_RootConstrainSelectedInstOperands,
     /* 467239 */     // GIR_Coverage, 12097,
     /* 467239 */     GIR_EraseRootFromParent_Done,
     /* 467240 */   // Label 6480: @467240
     /* 467240 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(467375), // Rule ID 12098 //
     /* 467245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 467248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467329 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467373 */     GIR_RootConstrainSelectedInstOperands,
     /* 467374 */     // GIR_Coverage, 12098,
     /* 467374 */     GIR_EraseRootFromParent_Done,
     /* 467375 */   // Label 6481: @467375
     /* 467375 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(467510), // Rule ID 12099 //
     /* 467380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 467383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467464 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467508 */     GIR_RootConstrainSelectedInstOperands,
     /* 467509 */     // GIR_Coverage, 12099,
     /* 467509 */     GIR_EraseRootFromParent_Done,
     /* 467510 */   // Label 6482: @467510
     /* 467510 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(467645), // Rule ID 12576 //
     /* 467515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467599 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467643 */     GIR_RootConstrainSelectedInstOperands,
     /* 467644 */     // GIR_Coverage, 12576,
     /* 467644 */     GIR_EraseRootFromParent_Done,
     /* 467645 */   // Label 6483: @467645
     /* 467645 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(467780), // Rule ID 12577 //
     /* 467650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467734 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467778 */     GIR_RootConstrainSelectedInstOperands,
     /* 467779 */     // GIR_Coverage, 12577,
     /* 467779 */     GIR_EraseRootFromParent_Done,
     /* 467780 */   // Label 6484: @467780
     /* 467780 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(467915), // Rule ID 12578 //
     /* 467785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467869 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467913 */     GIR_RootConstrainSelectedInstOperands,
     /* 467914 */     // GIR_Coverage, 12578,
     /* 467914 */     GIR_EraseRootFromParent_Done,
     /* 467915 */   // Label 6485: @467915
     /* 467915 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(468050), // Rule ID 12579 //
     /* 467920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468004 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 468007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468048 */     GIR_RootConstrainSelectedInstOperands,
     /* 468049 */     // GIR_Coverage, 12579,
     /* 468049 */     GIR_EraseRootFromParent_Done,
     /* 468050 */   // Label 6486: @468050
     /* 468050 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(468185), // Rule ID 13056 //
     /* 468055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468112 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468139 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468183 */     GIR_RootConstrainSelectedInstOperands,
     /* 468184 */     // GIR_Coverage, 13056,
     /* 468184 */     GIR_EraseRootFromParent_Done,
     /* 468185 */   // Label 6487: @468185
     /* 468185 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(468320), // Rule ID 13057 //
     /* 468190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468274 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468318 */     GIR_RootConstrainSelectedInstOperands,
     /* 468319 */     // GIR_Coverage, 13057,
     /* 468319 */     GIR_EraseRootFromParent_Done,
     /* 468320 */   // Label 6488: @468320
     /* 468320 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(468455), // Rule ID 13058 //
     /* 468325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468409 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468453 */     GIR_RootConstrainSelectedInstOperands,
     /* 468454 */     // GIR_Coverage, 13058,
     /* 468454 */     GIR_EraseRootFromParent_Done,
     /* 468455 */   // Label 6489: @468455
     /* 468455 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(468590), // Rule ID 13059 //
     /* 468460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468544 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468588 */     GIR_RootConstrainSelectedInstOperands,
     /* 468589 */     // GIR_Coverage, 13059,
     /* 468589 */     GIR_EraseRootFromParent_Done,
     /* 468590 */   // Label 6490: @468590
     /* 468590 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(468725), // Rule ID 12141 //
     /* 468595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468679 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468723 */     GIR_RootConstrainSelectedInstOperands,
     /* 468724 */     // GIR_Coverage, 12141,
     /* 468724 */     GIR_EraseRootFromParent_Done,
     /* 468725 */   // Label 6491: @468725
     /* 468725 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(468860), // Rule ID 12142 //
     /* 468730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468814 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468858 */     GIR_RootConstrainSelectedInstOperands,
     /* 468859 */     // GIR_Coverage, 12142,
     /* 468859 */     GIR_EraseRootFromParent_Done,
     /* 468860 */   // Label 6492: @468860
     /* 468860 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(468995), // Rule ID 12143 //
     /* 468865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468949 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468993 */     GIR_RootConstrainSelectedInstOperands,
     /* 468994 */     // GIR_Coverage, 12143,
     /* 468994 */     GIR_EraseRootFromParent_Done,
     /* 468995 */   // Label 6493: @468995
     /* 468995 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(469130), // Rule ID 12144 //
     /* 469000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469084 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 469087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469128 */     GIR_RootConstrainSelectedInstOperands,
     /* 469129 */     // GIR_Coverage, 12144,
     /* 469129 */     GIR_EraseRootFromParent_Done,
     /* 469130 */   // Label 6494: @469130
     /* 469130 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(469265), // Rule ID 12621 //
     /* 469135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469219 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469263 */     GIR_RootConstrainSelectedInstOperands,
     /* 469264 */     // GIR_Coverage, 12621,
     /* 469264 */     GIR_EraseRootFromParent_Done,
     /* 469265 */   // Label 6495: @469265
     /* 469265 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(469400), // Rule ID 12622 //
     /* 469270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469354 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469398 */     GIR_RootConstrainSelectedInstOperands,
     /* 469399 */     // GIR_Coverage, 12622,
     /* 469399 */     GIR_EraseRootFromParent_Done,
     /* 469400 */   // Label 6496: @469400
     /* 469400 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(469535), // Rule ID 12623 //
     /* 469405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469489 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469533 */     GIR_RootConstrainSelectedInstOperands,
     /* 469534 */     // GIR_Coverage, 12623,
     /* 469534 */     GIR_EraseRootFromParent_Done,
     /* 469535 */   // Label 6497: @469535
     /* 469535 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(469670), // Rule ID 12624 //
     /* 469540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469624 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469668 */     GIR_RootConstrainSelectedInstOperands,
     /* 469669 */     // GIR_Coverage, 12624,
     /* 469669 */     GIR_EraseRootFromParent_Done,
     /* 469670 */   // Label 6498: @469670
     /* 469670 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(469805), // Rule ID 13101 //
     /* 469675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469759 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469803 */     GIR_RootConstrainSelectedInstOperands,
     /* 469804 */     // GIR_Coverage, 13101,
     /* 469804 */     GIR_EraseRootFromParent_Done,
     /* 469805 */   // Label 6499: @469805
     /* 469805 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(469940), // Rule ID 13102 //
     /* 469810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469894 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469938 */     GIR_RootConstrainSelectedInstOperands,
     /* 469939 */     // GIR_Coverage, 13102,
     /* 469939 */     GIR_EraseRootFromParent_Done,
     /* 469940 */   // Label 6500: @469940
     /* 469940 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(470075), // Rule ID 13103 //
     /* 469945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470029 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 470032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470073 */     GIR_RootConstrainSelectedInstOperands,
     /* 470074 */     // GIR_Coverage, 13103,
     /* 470074 */     GIR_EraseRootFromParent_Done,
     /* 470075 */   // Label 6501: @470075
     /* 470075 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(470210), // Rule ID 13104 //
     /* 470080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 470083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470164 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 470167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470208 */     GIR_RootConstrainSelectedInstOperands,
     /* 470209 */     // GIR_Coverage, 13104,
     /* 470209 */     GIR_EraseRootFromParent_Done,
     /* 470210 */   // Label 6502: @470210
     /* 470210 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(470345), // Rule ID 12081 //
     /* 470215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470299 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470343 */     GIR_RootConstrainSelectedInstOperands,
     /* 470344 */     // GIR_Coverage, 12081,
     /* 470344 */     GIR_EraseRootFromParent_Done,
     /* 470345 */   // Label 6503: @470345
     /* 470345 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(470480), // Rule ID 12082 //
     /* 470350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470407 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470434 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470478 */     GIR_RootConstrainSelectedInstOperands,
     /* 470479 */     // GIR_Coverage, 12082,
     /* 470479 */     GIR_EraseRootFromParent_Done,
     /* 470480 */   // Label 6504: @470480
     /* 470480 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(470615), // Rule ID 12083 //
     /* 470485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470569 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470613 */     GIR_RootConstrainSelectedInstOperands,
     /* 470614 */     // GIR_Coverage, 12083,
     /* 470614 */     GIR_EraseRootFromParent_Done,
     /* 470615 */   // Label 6505: @470615
     /* 470615 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(470750), // Rule ID 12084 //
     /* 470620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470704 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470748 */     GIR_RootConstrainSelectedInstOperands,
     /* 470749 */     // GIR_Coverage, 12084,
     /* 470749 */     GIR_EraseRootFromParent_Done,
     /* 470750 */   // Label 6506: @470750
     /* 470750 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(470885), // Rule ID 12561 //
     /* 470755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470839 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470883 */     GIR_RootConstrainSelectedInstOperands,
     /* 470884 */     // GIR_Coverage, 12561,
     /* 470884 */     GIR_EraseRootFromParent_Done,
     /* 470885 */   // Label 6507: @470885
     /* 470885 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(471020), // Rule ID 12562 //
     /* 470890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470974 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471018 */     GIR_RootConstrainSelectedInstOperands,
     /* 471019 */     // GIR_Coverage, 12562,
     /* 471019 */     GIR_EraseRootFromParent_Done,
     /* 471020 */   // Label 6508: @471020
     /* 471020 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(471155), // Rule ID 12563 //
     /* 471025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 471028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 471032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471109 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 471112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471153 */     GIR_RootConstrainSelectedInstOperands,
     /* 471154 */     // GIR_Coverage, 12563,
     /* 471154 */     GIR_EraseRootFromParent_Done,
     /* 471155 */   // Label 6509: @471155
     /* 471155 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(471290), // Rule ID 12564 //
     /* 471160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 471163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 471167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471244 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 471247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471288 */     GIR_RootConstrainSelectedInstOperands,
     /* 471289 */     // GIR_Coverage, 12564,
     /* 471289 */     GIR_EraseRootFromParent_Done,
     /* 471290 */   // Label 6510: @471290
     /* 471290 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(471425), // Rule ID 13041 //
     /* 471295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471379 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471423 */     GIR_RootConstrainSelectedInstOperands,
     /* 471424 */     // GIR_Coverage, 13041,
     /* 471424 */     GIR_EraseRootFromParent_Done,
     /* 471425 */   // Label 6511: @471425
     /* 471425 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(471560), // Rule ID 13042 //
     /* 471430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471514 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471558 */     GIR_RootConstrainSelectedInstOperands,
     /* 471559 */     // GIR_Coverage, 13042,
     /* 471559 */     GIR_EraseRootFromParent_Done,
     /* 471560 */   // Label 6512: @471560
     /* 471560 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(471695), // Rule ID 13043 //
     /* 471565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471649 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471693 */     GIR_RootConstrainSelectedInstOperands,
     /* 471694 */     // GIR_Coverage, 13043,
     /* 471694 */     GIR_EraseRootFromParent_Done,
     /* 471695 */   // Label 6513: @471695
     /* 471695 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(471830), // Rule ID 13044 //
     /* 471700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471784 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471828 */     GIR_RootConstrainSelectedInstOperands,
     /* 471829 */     // GIR_Coverage, 13044,
     /* 471829 */     GIR_EraseRootFromParent_Done,
     /* 471830 */   // Label 6514: @471830
     /* 471830 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(471965), // Rule ID 12152 //
     /* 471835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471919 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 471929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 471934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 471949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 471954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471963 */     GIR_RootConstrainSelectedInstOperands,
     /* 471964 */     // GIR_Coverage, 12152,
     /* 471964 */     GIR_EraseRootFromParent_Done,
     /* 471965 */   // Label 6515: @471965
     /* 471965 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(472100), // Rule ID 12153 //
     /* 471970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472054 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472098 */     GIR_RootConstrainSelectedInstOperands,
     /* 472099 */     // GIR_Coverage, 12153,
     /* 472099 */     GIR_EraseRootFromParent_Done,
     /* 472100 */   // Label 6516: @472100
     /* 472100 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(472235), // Rule ID 12154 //
     /* 472105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 472108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472189 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472233 */     GIR_RootConstrainSelectedInstOperands,
     /* 472234 */     // GIR_Coverage, 12154,
     /* 472234 */     GIR_EraseRootFromParent_Done,
     /* 472235 */   // Label 6517: @472235
     /* 472235 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(472370), // Rule ID 12155 //
     /* 472240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 472243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472324 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472368 */     GIR_RootConstrainSelectedInstOperands,
     /* 472369 */     // GIR_Coverage, 12155,
     /* 472369 */     GIR_EraseRootFromParent_Done,
     /* 472370 */   // Label 6518: @472370
     /* 472370 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(472505), // Rule ID 12632 //
     /* 472375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472459 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472503 */     GIR_RootConstrainSelectedInstOperands,
     /* 472504 */     // GIR_Coverage, 12632,
     /* 472504 */     GIR_EraseRootFromParent_Done,
     /* 472505 */   // Label 6519: @472505
     /* 472505 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(472640), // Rule ID 12633 //
     /* 472510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472594 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472638 */     GIR_RootConstrainSelectedInstOperands,
     /* 472639 */     // GIR_Coverage, 12633,
     /* 472639 */     GIR_EraseRootFromParent_Done,
     /* 472640 */   // Label 6520: @472640
     /* 472640 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(472775), // Rule ID 12634 //
     /* 472645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472729 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472773 */     GIR_RootConstrainSelectedInstOperands,
     /* 472774 */     // GIR_Coverage, 12634,
     /* 472774 */     GIR_EraseRootFromParent_Done,
     /* 472775 */   // Label 6521: @472775
     /* 472775 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(472910), // Rule ID 12635 //
     /* 472780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472864 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472908 */     GIR_RootConstrainSelectedInstOperands,
     /* 472909 */     // GIR_Coverage, 12635,
     /* 472909 */     GIR_EraseRootFromParent_Done,
     /* 472910 */   // Label 6522: @472910
     /* 472910 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(473045), // Rule ID 13112 //
     /* 472915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472999 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473043 */     GIR_RootConstrainSelectedInstOperands,
     /* 473044 */     // GIR_Coverage, 13112,
     /* 473044 */     GIR_EraseRootFromParent_Done,
     /* 473045 */   // Label 6523: @473045
     /* 473045 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(473180), // Rule ID 13113 //
     /* 473050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473134 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473178 */     GIR_RootConstrainSelectedInstOperands,
     /* 473179 */     // GIR_Coverage, 13113,
     /* 473179 */     GIR_EraseRootFromParent_Done,
     /* 473180 */   // Label 6524: @473180
     /* 473180 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(473315), // Rule ID 13114 //
     /* 473185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473269 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473313 */     GIR_RootConstrainSelectedInstOperands,
     /* 473314 */     // GIR_Coverage, 13114,
     /* 473314 */     GIR_EraseRootFromParent_Done,
     /* 473315 */   // Label 6525: @473315
     /* 473315 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(473450), // Rule ID 13115 //
     /* 473320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473404 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473448 */     GIR_RootConstrainSelectedInstOperands,
     /* 473449 */     // GIR_Coverage, 13115,
     /* 473449 */     GIR_EraseRootFromParent_Done,
     /* 473450 */   // Label 6526: @473450
     /* 473450 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(473585), // Rule ID 12092 //
     /* 473455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473539 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473583 */     GIR_RootConstrainSelectedInstOperands,
     /* 473584 */     // GIR_Coverage, 12092,
     /* 473584 */     GIR_EraseRootFromParent_Done,
     /* 473585 */   // Label 6527: @473585
     /* 473585 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(473720), // Rule ID 12093 //
     /* 473590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473674 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473718 */     GIR_RootConstrainSelectedInstOperands,
     /* 473719 */     // GIR_Coverage, 12093,
     /* 473719 */     GIR_EraseRootFromParent_Done,
     /* 473720 */   // Label 6528: @473720
     /* 473720 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(473855), // Rule ID 12094 //
     /* 473725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473809 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473853 */     GIR_RootConstrainSelectedInstOperands,
     /* 473854 */     // GIR_Coverage, 12094,
     /* 473854 */     GIR_EraseRootFromParent_Done,
     /* 473855 */   // Label 6529: @473855
     /* 473855 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(473990), // Rule ID 12095 //
     /* 473860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473944 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473988 */     GIR_RootConstrainSelectedInstOperands,
     /* 473989 */     // GIR_Coverage, 12095,
     /* 473989 */     GIR_EraseRootFromParent_Done,
     /* 473990 */   // Label 6530: @473990
     /* 473990 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(474125), // Rule ID 12572 //
     /* 473995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474079 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474123 */     GIR_RootConstrainSelectedInstOperands,
     /* 474124 */     // GIR_Coverage, 12572,
     /* 474124 */     GIR_EraseRootFromParent_Done,
     /* 474125 */   // Label 6531: @474125
     /* 474125 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(474260), // Rule ID 12573 //
     /* 474130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 474133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474214 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474258 */     GIR_RootConstrainSelectedInstOperands,
     /* 474259 */     // GIR_Coverage, 12573,
     /* 474259 */     GIR_EraseRootFromParent_Done,
     /* 474260 */   // Label 6532: @474260
     /* 474260 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(474395), // Rule ID 12574 //
     /* 474265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 474268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474349 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474393 */     GIR_RootConstrainSelectedInstOperands,
     /* 474394 */     // GIR_Coverage, 12574,
     /* 474394 */     GIR_EraseRootFromParent_Done,
     /* 474395 */   // Label 6533: @474395
     /* 474395 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(474530), // Rule ID 12575 //
     /* 474400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 474403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474484 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474528 */     GIR_RootConstrainSelectedInstOperands,
     /* 474529 */     // GIR_Coverage, 12575,
     /* 474529 */     GIR_EraseRootFromParent_Done,
     /* 474530 */   // Label 6534: @474530
     /* 474530 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(474665), // Rule ID 13052 //
     /* 474535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474619 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474663 */     GIR_RootConstrainSelectedInstOperands,
     /* 474664 */     // GIR_Coverage, 13052,
     /* 474664 */     GIR_EraseRootFromParent_Done,
     /* 474665 */   // Label 6535: @474665
     /* 474665 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(474800), // Rule ID 13053 //
     /* 474670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474754 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474798 */     GIR_RootConstrainSelectedInstOperands,
     /* 474799 */     // GIR_Coverage, 13053,
     /* 474799 */     GIR_EraseRootFromParent_Done,
     /* 474800 */   // Label 6536: @474800
     /* 474800 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(474935), // Rule ID 13054 //
     /* 474805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474889 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474933 */     GIR_RootConstrainSelectedInstOperands,
     /* 474934 */     // GIR_Coverage, 13054,
     /* 474934 */     GIR_EraseRootFromParent_Done,
     /* 474935 */   // Label 6537: @474935
     /* 474935 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(475070), // Rule ID 13055 //
     /* 474940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475024 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475068 */     GIR_RootConstrainSelectedInstOperands,
     /* 475069 */     // GIR_Coverage, 13055,
     /* 475069 */     GIR_EraseRootFromParent_Done,
     /* 475070 */   // Label 6538: @475070
     /* 475070 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(475205), // Rule ID 12137 //
     /* 475075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475159 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475203 */     GIR_RootConstrainSelectedInstOperands,
     /* 475204 */     // GIR_Coverage, 12137,
     /* 475204 */     GIR_EraseRootFromParent_Done,
     /* 475205 */   // Label 6539: @475205
     /* 475205 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(475340), // Rule ID 12138 //
     /* 475210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475294 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475338 */     GIR_RootConstrainSelectedInstOperands,
     /* 475339 */     // GIR_Coverage, 12138,
     /* 475339 */     GIR_EraseRootFromParent_Done,
     /* 475340 */   // Label 6540: @475340
     /* 475340 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(475475), // Rule ID 12139 //
     /* 475345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475429 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475473 */     GIR_RootConstrainSelectedInstOperands,
     /* 475474 */     // GIR_Coverage, 12139,
     /* 475474 */     GIR_EraseRootFromParent_Done,
     /* 475475 */   // Label 6541: @475475
     /* 475475 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(475610), // Rule ID 12140 //
     /* 475480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475564 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475608 */     GIR_RootConstrainSelectedInstOperands,
     /* 475609 */     // GIR_Coverage, 12140,
     /* 475609 */     GIR_EraseRootFromParent_Done,
     /* 475610 */   // Label 6542: @475610
     /* 475610 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(475745), // Rule ID 12617 //
     /* 475615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475699 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475743 */     GIR_RootConstrainSelectedInstOperands,
     /* 475744 */     // GIR_Coverage, 12617,
     /* 475744 */     GIR_EraseRootFromParent_Done,
     /* 475745 */   // Label 6543: @475745
     /* 475745 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(475880), // Rule ID 12618 //
     /* 475750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475834 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475878 */     GIR_RootConstrainSelectedInstOperands,
     /* 475879 */     // GIR_Coverage, 12618,
     /* 475879 */     GIR_EraseRootFromParent_Done,
     /* 475880 */   // Label 6544: @475880
     /* 475880 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(476015), // Rule ID 12619 //
     /* 475885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475969 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476013 */     GIR_RootConstrainSelectedInstOperands,
     /* 476014 */     // GIR_Coverage, 12619,
     /* 476014 */     GIR_EraseRootFromParent_Done,
     /* 476015 */   // Label 6545: @476015
     /* 476015 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(476150), // Rule ID 12620 //
     /* 476020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476104 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 476107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476148 */     GIR_RootConstrainSelectedInstOperands,
     /* 476149 */     // GIR_Coverage, 12620,
     /* 476149 */     GIR_EraseRootFromParent_Done,
     /* 476150 */   // Label 6546: @476150
     /* 476150 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(476285), // Rule ID 13097 //
     /* 476155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476239 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476283 */     GIR_RootConstrainSelectedInstOperands,
     /* 476284 */     // GIR_Coverage, 13097,
     /* 476284 */     GIR_EraseRootFromParent_Done,
     /* 476285 */   // Label 6547: @476285
     /* 476285 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(476420), // Rule ID 13098 //
     /* 476290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476374 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476418 */     GIR_RootConstrainSelectedInstOperands,
     /* 476419 */     // GIR_Coverage, 13098,
     /* 476419 */     GIR_EraseRootFromParent_Done,
     /* 476420 */   // Label 6548: @476420
     /* 476420 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(476555), // Rule ID 13099 //
     /* 476425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476509 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476553 */     GIR_RootConstrainSelectedInstOperands,
     /* 476554 */     // GIR_Coverage, 13099,
     /* 476554 */     GIR_EraseRootFromParent_Done,
     /* 476555 */   // Label 6549: @476555
     /* 476555 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(476690), // Rule ID 13100 //
     /* 476560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476644 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476688 */     GIR_RootConstrainSelectedInstOperands,
     /* 476689 */     // GIR_Coverage, 13100,
     /* 476689 */     GIR_EraseRootFromParent_Done,
     /* 476690 */   // Label 6550: @476690
     /* 476690 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(476825), // Rule ID 12077 //
     /* 476695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476779 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476823 */     GIR_RootConstrainSelectedInstOperands,
     /* 476824 */     // GIR_Coverage, 12077,
     /* 476824 */     GIR_EraseRootFromParent_Done,
     /* 476825 */   // Label 6551: @476825
     /* 476825 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(476960), // Rule ID 12078 //
     /* 476830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476914 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476958 */     GIR_RootConstrainSelectedInstOperands,
     /* 476959 */     // GIR_Coverage, 12078,
     /* 476959 */     GIR_EraseRootFromParent_Done,
     /* 476960 */   // Label 6552: @476960
     /* 476960 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(477095), // Rule ID 12079 //
     /* 476965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477049 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 477052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477093 */     GIR_RootConstrainSelectedInstOperands,
     /* 477094 */     // GIR_Coverage, 12079,
     /* 477094 */     GIR_EraseRootFromParent_Done,
     /* 477095 */   // Label 6553: @477095
     /* 477095 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(477230), // Rule ID 12080 //
     /* 477100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 477103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477184 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 477187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477228 */     GIR_RootConstrainSelectedInstOperands,
     /* 477229 */     // GIR_Coverage, 12080,
     /* 477229 */     GIR_EraseRootFromParent_Done,
     /* 477230 */   // Label 6554: @477230
     /* 477230 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(477365), // Rule ID 12557 //
     /* 477235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477319 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477363 */     GIR_RootConstrainSelectedInstOperands,
     /* 477364 */     // GIR_Coverage, 12557,
     /* 477364 */     GIR_EraseRootFromParent_Done,
     /* 477365 */   // Label 6555: @477365
     /* 477365 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(477500), // Rule ID 12558 //
     /* 477370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477454 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477498 */     GIR_RootConstrainSelectedInstOperands,
     /* 477499 */     // GIR_Coverage, 12558,
     /* 477499 */     GIR_EraseRootFromParent_Done,
     /* 477500 */   // Label 6556: @477500
     /* 477500 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(477635), // Rule ID 12559 //
     /* 477505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477589 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477633 */     GIR_RootConstrainSelectedInstOperands,
     /* 477634 */     // GIR_Coverage, 12559,
     /* 477634 */     GIR_EraseRootFromParent_Done,
     /* 477635 */   // Label 6557: @477635
     /* 477635 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(477770), // Rule ID 12560 //
     /* 477640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477687 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477724 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477768 */     GIR_RootConstrainSelectedInstOperands,
     /* 477769 */     // GIR_Coverage, 12560,
     /* 477769 */     GIR_EraseRootFromParent_Done,
     /* 477770 */   // Label 6558: @477770
     /* 477770 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(477905), // Rule ID 13037 //
     /* 477775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477859 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477903 */     GIR_RootConstrainSelectedInstOperands,
     /* 477904 */     // GIR_Coverage, 13037,
     /* 477904 */     GIR_EraseRootFromParent_Done,
     /* 477905 */   // Label 6559: @477905
     /* 477905 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(478040), // Rule ID 13038 //
     /* 477910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477994 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478038 */     GIR_RootConstrainSelectedInstOperands,
     /* 478039 */     // GIR_Coverage, 13038,
     /* 478039 */     GIR_EraseRootFromParent_Done,
     /* 478040 */   // Label 6560: @478040
     /* 478040 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(478175), // Rule ID 13039 //
     /* 478045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 478048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 478076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478129 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 478132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478173 */     GIR_RootConstrainSelectedInstOperands,
     /* 478174 */     // GIR_Coverage, 13039,
     /* 478174 */     GIR_EraseRootFromParent_Done,
     /* 478175 */   // Label 6561: @478175
     /* 478175 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(478310), // Rule ID 13040 //
     /* 478180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 478183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 478211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478264 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 478267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478308 */     GIR_RootConstrainSelectedInstOperands,
     /* 478309 */     // GIR_Coverage, 13040,
     /* 478309 */     GIR_EraseRootFromParent_Done,
     /* 478310 */   // Label 6562: @478310
     /* 478310 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(478445), // Rule ID 12086 //
     /* 478315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478399 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478443 */     GIR_RootConstrainSelectedInstOperands,
     /* 478444 */     // GIR_Coverage, 12086,
     /* 478444 */     GIR_EraseRootFromParent_Done,
     /* 478445 */   // Label 6563: @478445
     /* 478445 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(478580), // Rule ID 12087 //
     /* 478450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478534 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478578 */     GIR_RootConstrainSelectedInstOperands,
     /* 478579 */     // GIR_Coverage, 12087,
     /* 478579 */     GIR_EraseRootFromParent_Done,
     /* 478580 */   // Label 6564: @478580
     /* 478580 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(478715), // Rule ID 12090 //
     /* 478585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478669 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478713 */     GIR_RootConstrainSelectedInstOperands,
     /* 478714 */     // GIR_Coverage, 12090,
     /* 478714 */     GIR_EraseRootFromParent_Done,
     /* 478715 */   // Label 6565: @478715
     /* 478715 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(478850), // Rule ID 12091 //
     /* 478720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478804 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478848 */     GIR_RootConstrainSelectedInstOperands,
     /* 478849 */     // GIR_Coverage, 12091,
     /* 478849 */     GIR_EraseRootFromParent_Done,
     /* 478850 */   // Label 6566: @478850
     /* 478850 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(478985), // Rule ID 12566 //
     /* 478855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478939 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478983 */     GIR_RootConstrainSelectedInstOperands,
     /* 478984 */     // GIR_Coverage, 12566,
     /* 478984 */     GIR_EraseRootFromParent_Done,
     /* 478985 */   // Label 6567: @478985
     /* 478985 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(479120), // Rule ID 12567 //
     /* 478990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479074 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479118 */     GIR_RootConstrainSelectedInstOperands,
     /* 479119 */     // GIR_Coverage, 12567,
     /* 479119 */     GIR_EraseRootFromParent_Done,
     /* 479120 */   // Label 6568: @479120
     /* 479120 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(479255), // Rule ID 12570 //
     /* 479125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 479128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 479132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479209 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479253 */     GIR_RootConstrainSelectedInstOperands,
     /* 479254 */     // GIR_Coverage, 12570,
     /* 479254 */     GIR_EraseRootFromParent_Done,
     /* 479255 */   // Label 6569: @479255
     /* 479255 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(479390), // Rule ID 12571 //
     /* 479260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 479263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 479267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479344 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479388 */     GIR_RootConstrainSelectedInstOperands,
     /* 479389 */     // GIR_Coverage, 12571,
     /* 479389 */     GIR_EraseRootFromParent_Done,
     /* 479390 */   // Label 6570: @479390
     /* 479390 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(479525), // Rule ID 13046 //
     /* 479395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479479 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479523 */     GIR_RootConstrainSelectedInstOperands,
     /* 479524 */     // GIR_Coverage, 13046,
     /* 479524 */     GIR_EraseRootFromParent_Done,
     /* 479525 */   // Label 6571: @479525
     /* 479525 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(479660), // Rule ID 13047 //
     /* 479530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479614 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479658 */     GIR_RootConstrainSelectedInstOperands,
     /* 479659 */     // GIR_Coverage, 13047,
     /* 479659 */     GIR_EraseRootFromParent_Done,
     /* 479660 */   // Label 6572: @479660
     /* 479660 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(479795), // Rule ID 13050 //
     /* 479665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479749 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479793 */     GIR_RootConstrainSelectedInstOperands,
     /* 479794 */     // GIR_Coverage, 13050,
     /* 479794 */     GIR_EraseRootFromParent_Done,
     /* 479795 */   // Label 6573: @479795
     /* 479795 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(479930), // Rule ID 13051 //
     /* 479800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479884 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479928 */     GIR_RootConstrainSelectedInstOperands,
     /* 479929 */     // GIR_Coverage, 13051,
     /* 479929 */     GIR_EraseRootFromParent_Done,
     /* 479930 */   // Label 6574: @479930
     /* 479930 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(480065), // Rule ID 12071 //
     /* 479935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480019 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480063 */     GIR_RootConstrainSelectedInstOperands,
     /* 480064 */     // GIR_Coverage, 12071,
     /* 480064 */     GIR_EraseRootFromParent_Done,
     /* 480065 */   // Label 6575: @480065
     /* 480065 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(480200), // Rule ID 12072 //
     /* 480070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480154 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480198 */     GIR_RootConstrainSelectedInstOperands,
     /* 480199 */     // GIR_Coverage, 12072,
     /* 480199 */     GIR_EraseRootFromParent_Done,
     /* 480200 */   // Label 6576: @480200
     /* 480200 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(480335), // Rule ID 12075 //
     /* 480205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480289 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480333 */     GIR_RootConstrainSelectedInstOperands,
     /* 480334 */     // GIR_Coverage, 12075,
     /* 480334 */     GIR_EraseRootFromParent_Done,
     /* 480335 */   // Label 6577: @480335
     /* 480335 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(480470), // Rule ID 12076 //
     /* 480340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480424 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480468 */     GIR_RootConstrainSelectedInstOperands,
     /* 480469 */     // GIR_Coverage, 12076,
     /* 480469 */     GIR_EraseRootFromParent_Done,
     /* 480470 */   // Label 6578: @480470
     /* 480470 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(480605), // Rule ID 12551 //
     /* 480475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480559 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480603 */     GIR_RootConstrainSelectedInstOperands,
     /* 480604 */     // GIR_Coverage, 12551,
     /* 480604 */     GIR_EraseRootFromParent_Done,
     /* 480605 */   // Label 6579: @480605
     /* 480605 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(480740), // Rule ID 12552 //
     /* 480610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480694 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480738 */     GIR_RootConstrainSelectedInstOperands,
     /* 480739 */     // GIR_Coverage, 12552,
     /* 480739 */     GIR_EraseRootFromParent_Done,
     /* 480740 */   // Label 6580: @480740
     /* 480740 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(480875), // Rule ID 12555 //
     /* 480745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480829 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480873 */     GIR_RootConstrainSelectedInstOperands,
     /* 480874 */     // GIR_Coverage, 12555,
     /* 480874 */     GIR_EraseRootFromParent_Done,
     /* 480875 */   // Label 6581: @480875
     /* 480875 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(481010), // Rule ID 12556 //
     /* 480880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480964 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481008 */     GIR_RootConstrainSelectedInstOperands,
     /* 481009 */     // GIR_Coverage, 12556,
     /* 481009 */     GIR_EraseRootFromParent_Done,
     /* 481010 */   // Label 6582: @481010
     /* 481010 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(481145), // Rule ID 13031 //
     /* 481015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481099 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481143 */     GIR_RootConstrainSelectedInstOperands,
     /* 481144 */     // GIR_Coverage, 13031,
     /* 481144 */     GIR_EraseRootFromParent_Done,
     /* 481145 */   // Label 6583: @481145
     /* 481145 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(481280), // Rule ID 13032 //
     /* 481150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481234 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481278 */     GIR_RootConstrainSelectedInstOperands,
     /* 481279 */     // GIR_Coverage, 13032,
     /* 481279 */     GIR_EraseRootFromParent_Done,
     /* 481280 */   // Label 6584: @481280
     /* 481280 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(481415), // Rule ID 13035 //
     /* 481285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481369 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481413 */     GIR_RootConstrainSelectedInstOperands,
     /* 481414 */     // GIR_Coverage, 13035,
     /* 481414 */     GIR_EraseRootFromParent_Done,
     /* 481415 */   // Label 6585: @481415
     /* 481415 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(481550), // Rule ID 13036 //
     /* 481420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481504 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481548 */     GIR_RootConstrainSelectedInstOperands,
     /* 481549 */     // GIR_Coverage, 13036,
     /* 481549 */     GIR_EraseRootFromParent_Done,
     /* 481550 */   // Label 6586: @481550
     /* 481550 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(481685), // Rule ID 7637 //
     /* 481555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481639 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481683 */     GIR_RootConstrainSelectedInstOperands,
     /* 481684 */     // GIR_Coverage, 7637,
     /* 481684 */     GIR_EraseRootFromParent_Done,
     /* 481685 */   // Label 6587: @481685
     /* 481685 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(481820), // Rule ID 7669 //
     /* 481690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481742 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481774 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481818 */     GIR_RootConstrainSelectedInstOperands,
     /* 481819 */     // GIR_Coverage, 7669,
     /* 481819 */     GIR_EraseRootFromParent_Done,
     /* 481820 */   // Label 6588: @481820
     /* 481820 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(481955), // Rule ID 7701 //
     /* 481825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481909 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481953 */     GIR_RootConstrainSelectedInstOperands,
     /* 481954 */     // GIR_Coverage, 7701,
     /* 481954 */     GIR_EraseRootFromParent_Done,
     /* 481955 */   // Label 6589: @481955
     /* 481955 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(482090), // Rule ID 12085 //
     /* 481960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482037 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482044 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482088 */     GIR_RootConstrainSelectedInstOperands,
     /* 482089 */     // GIR_Coverage, 12085,
     /* 482089 */     GIR_EraseRootFromParent_Done,
     /* 482090 */   // Label 6590: @482090
     /* 482090 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(482225), // Rule ID 12088 //
     /* 482095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482179 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482223 */     GIR_RootConstrainSelectedInstOperands,
     /* 482224 */     // GIR_Coverage, 12088,
     /* 482224 */     GIR_EraseRootFromParent_Done,
     /* 482225 */   // Label 6591: @482225
     /* 482225 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(482360), // Rule ID 12089 //
     /* 482230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482314 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482358 */     GIR_RootConstrainSelectedInstOperands,
     /* 482359 */     // GIR_Coverage, 12089,
     /* 482359 */     GIR_EraseRootFromParent_Done,
     /* 482360 */   // Label 6592: @482360
     /* 482360 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(482495), // Rule ID 12565 //
     /* 482365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482412 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482417 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482449 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482493 */     GIR_RootConstrainSelectedInstOperands,
     /* 482494 */     // GIR_Coverage, 12565,
     /* 482494 */     GIR_EraseRootFromParent_Done,
     /* 482495 */   // Label 6593: @482495
     /* 482495 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(482630), // Rule ID 12568 //
     /* 482500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482547 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482552 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482584 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482628 */     GIR_RootConstrainSelectedInstOperands,
     /* 482629 */     // GIR_Coverage, 12568,
     /* 482629 */     GIR_EraseRootFromParent_Done,
     /* 482630 */   // Label 6594: @482630
     /* 482630 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(482765), // Rule ID 12569 //
     /* 482635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482682 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482687 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482692 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482719 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482763 */     GIR_RootConstrainSelectedInstOperands,
     /* 482764 */     // GIR_Coverage, 12569,
     /* 482764 */     GIR_EraseRootFromParent_Done,
     /* 482765 */   // Label 6595: @482765
     /* 482765 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(482900), // Rule ID 13045 //
     /* 482770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482817 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482854 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482898 */     GIR_RootConstrainSelectedInstOperands,
     /* 482899 */     // GIR_Coverage, 13045,
     /* 482899 */     GIR_EraseRootFromParent_Done,
     /* 482900 */   // Label 6596: @482900
     /* 482900 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(483035), // Rule ID 13048 //
     /* 482905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482989 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483033 */     GIR_RootConstrainSelectedInstOperands,
     /* 483034 */     // GIR_Coverage, 13048,
     /* 483034 */     GIR_EraseRootFromParent_Done,
     /* 483035 */   // Label 6597: @483035
     /* 483035 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(483170), // Rule ID 13049 //
     /* 483040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483124 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483168 */     GIR_RootConstrainSelectedInstOperands,
     /* 483169 */     // GIR_Coverage, 13049,
     /* 483169 */     GIR_EraseRootFromParent_Done,
     /* 483170 */   // Label 6598: @483170
     /* 483170 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(483305), // Rule ID 7636 //
     /* 483175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483259 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483303 */     GIR_RootConstrainSelectedInstOperands,
     /* 483304 */     // GIR_Coverage, 7636,
     /* 483304 */     GIR_EraseRootFromParent_Done,
     /* 483305 */   // Label 6599: @483305
     /* 483305 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(483440), // Rule ID 7668 //
     /* 483310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483357 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483362 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483394 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483438 */     GIR_RootConstrainSelectedInstOperands,
     /* 483439 */     // GIR_Coverage, 7668,
     /* 483439 */     GIR_EraseRootFromParent_Done,
     /* 483440 */   // Label 6600: @483440
     /* 483440 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(483575), // Rule ID 7700 //
     /* 483445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483529 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483573 */     GIR_RootConstrainSelectedInstOperands,
     /* 483574 */     // GIR_Coverage, 7700,
     /* 483574 */     GIR_EraseRootFromParent_Done,
     /* 483575 */   // Label 6601: @483575
     /* 483575 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(483710), // Rule ID 12070 //
     /* 483580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483664 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483708 */     GIR_RootConstrainSelectedInstOperands,
     /* 483709 */     // GIR_Coverage, 12070,
     /* 483709 */     GIR_EraseRootFromParent_Done,
     /* 483710 */   // Label 6602: @483710
     /* 483710 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(483845), // Rule ID 12073 //
     /* 483715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483799 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483843 */     GIR_RootConstrainSelectedInstOperands,
     /* 483844 */     // GIR_Coverage, 12073,
     /* 483844 */     GIR_EraseRootFromParent_Done,
     /* 483845 */   // Label 6603: @483845
     /* 483845 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(483980), // Rule ID 12074 //
     /* 483850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483934 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483978 */     GIR_RootConstrainSelectedInstOperands,
     /* 483979 */     // GIR_Coverage, 12074,
     /* 483979 */     GIR_EraseRootFromParent_Done,
     /* 483980 */   // Label 6604: @483980
     /* 483980 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(484115), // Rule ID 12550 //
     /* 483985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484032 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484037 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484069 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484113 */     GIR_RootConstrainSelectedInstOperands,
     /* 484114 */     // GIR_Coverage, 12550,
     /* 484114 */     GIR_EraseRootFromParent_Done,
     /* 484115 */   // Label 6605: @484115
     /* 484115 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(484250), // Rule ID 12553 //
     /* 484120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 484123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 484127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484167 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484172 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484204 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484248 */     GIR_RootConstrainSelectedInstOperands,
     /* 484249 */     // GIR_Coverage, 12553,
     /* 484249 */     GIR_EraseRootFromParent_Done,
     /* 484250 */   // Label 6606: @484250
     /* 484250 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(484385), // Rule ID 12554 //
     /* 484255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 484258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 484262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484302 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484307 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484339 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484383 */     GIR_RootConstrainSelectedInstOperands,
     /* 484384 */     // GIR_Coverage, 12554,
     /* 484384 */     GIR_EraseRootFromParent_Done,
     /* 484385 */   // Label 6607: @484385
     /* 484385 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(484520), // Rule ID 13030 //
     /* 484390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484474 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484518 */     GIR_RootConstrainSelectedInstOperands,
     /* 484519 */     // GIR_Coverage, 13030,
     /* 484519 */     GIR_EraseRootFromParent_Done,
     /* 484520 */   // Label 6608: @484520
     /* 484520 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(484655), // Rule ID 13033 //
     /* 484525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484609 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484653 */     GIR_RootConstrainSelectedInstOperands,
     /* 484654 */     // GIR_Coverage, 13033,
     /* 484654 */     GIR_EraseRootFromParent_Done,
     /* 484655 */   // Label 6609: @484655
     /* 484655 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(484790), // Rule ID 13034 //
     /* 484660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484744 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484788 */     GIR_RootConstrainSelectedInstOperands,
     /* 484789 */     // GIR_Coverage, 13034,
     /* 484789 */     GIR_EraseRootFromParent_Done,
     /* 484790 */   // Label 6610: @484790
     /* 484790 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(484925), // Rule ID 12056 //
     /* 484795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484879 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484923 */     GIR_RootConstrainSelectedInstOperands,
     /* 484924 */     // GIR_Coverage, 12056,
     /* 484924 */     GIR_EraseRootFromParent_Done,
     /* 484925 */   // Label 6611: @484925
     /* 484925 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(485060), // Rule ID 12057 //
     /* 484930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485014 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 485017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485058 */     GIR_RootConstrainSelectedInstOperands,
     /* 485059 */     // GIR_Coverage, 12057,
     /* 485059 */     GIR_EraseRootFromParent_Done,
     /* 485060 */   // Label 6612: @485060
     /* 485060 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(485195), // Rule ID 12060 //
     /* 485065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 485068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485149 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 485152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485193 */     GIR_RootConstrainSelectedInstOperands,
     /* 485194 */     // GIR_Coverage, 12060,
     /* 485194 */     GIR_EraseRootFromParent_Done,
     /* 485195 */   // Label 6613: @485195
     /* 485195 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(485330), // Rule ID 12061 //
     /* 485200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 485203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485284 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 485287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485328 */     GIR_RootConstrainSelectedInstOperands,
     /* 485329 */     // GIR_Coverage, 12061,
     /* 485329 */     GIR_EraseRootFromParent_Done,
     /* 485330 */   // Label 6614: @485330
     /* 485330 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(485465), // Rule ID 12536 //
     /* 485335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485419 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485463 */     GIR_RootConstrainSelectedInstOperands,
     /* 485464 */     // GIR_Coverage, 12536,
     /* 485464 */     GIR_EraseRootFromParent_Done,
     /* 485465 */   // Label 6615: @485465
     /* 485465 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(485600), // Rule ID 12537 //
     /* 485470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485554 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485598 */     GIR_RootConstrainSelectedInstOperands,
     /* 485599 */     // GIR_Coverage, 12537,
     /* 485599 */     GIR_EraseRootFromParent_Done,
     /* 485600 */   // Label 6616: @485600
     /* 485600 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(485735), // Rule ID 12540 //
     /* 485605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485689 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485733 */     GIR_RootConstrainSelectedInstOperands,
     /* 485734 */     // GIR_Coverage, 12540,
     /* 485734 */     GIR_EraseRootFromParent_Done,
     /* 485735 */   // Label 6617: @485735
     /* 485735 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(485870), // Rule ID 12541 //
     /* 485740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485824 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485868 */     GIR_RootConstrainSelectedInstOperands,
     /* 485869 */     // GIR_Coverage, 12541,
     /* 485869 */     GIR_EraseRootFromParent_Done,
     /* 485870 */   // Label 6618: @485870
     /* 485870 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(486005), // Rule ID 13016 //
     /* 485875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485959 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486003 */     GIR_RootConstrainSelectedInstOperands,
     /* 486004 */     // GIR_Coverage, 13016,
     /* 486004 */     GIR_EraseRootFromParent_Done,
     /* 486005 */   // Label 6619: @486005
     /* 486005 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(486140), // Rule ID 13017 //
     /* 486010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 486013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486094 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486138 */     GIR_RootConstrainSelectedInstOperands,
     /* 486139 */     // GIR_Coverage, 13017,
     /* 486139 */     GIR_EraseRootFromParent_Done,
     /* 486140 */   // Label 6620: @486140
     /* 486140 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(486275), // Rule ID 13020 //
     /* 486145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 486148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486229 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486273 */     GIR_RootConstrainSelectedInstOperands,
     /* 486274 */     // GIR_Coverage, 13020,
     /* 486274 */     GIR_EraseRootFromParent_Done,
     /* 486275 */   // Label 6621: @486275
     /* 486275 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(486410), // Rule ID 13021 //
     /* 486280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 486283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486364 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486408 */     GIR_RootConstrainSelectedInstOperands,
     /* 486409 */     // GIR_Coverage, 13021,
     /* 486409 */     GIR_EraseRootFromParent_Done,
     /* 486410 */   // Label 6622: @486410
     /* 486410 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(486545), // Rule ID 12041 //
     /* 486415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486499 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486543 */     GIR_RootConstrainSelectedInstOperands,
     /* 486544 */     // GIR_Coverage, 12041,
     /* 486544 */     GIR_EraseRootFromParent_Done,
     /* 486545 */   // Label 6623: @486545
     /* 486545 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(486680), // Rule ID 12042 //
     /* 486550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486634 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486678 */     GIR_RootConstrainSelectedInstOperands,
     /* 486679 */     // GIR_Coverage, 12042,
     /* 486679 */     GIR_EraseRootFromParent_Done,
     /* 486680 */   // Label 6624: @486680
     /* 486680 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(486815), // Rule ID 12045 //
     /* 486685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486769 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486813 */     GIR_RootConstrainSelectedInstOperands,
     /* 486814 */     // GIR_Coverage, 12045,
     /* 486814 */     GIR_EraseRootFromParent_Done,
     /* 486815 */   // Label 6625: @486815
     /* 486815 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(486950), // Rule ID 12046 //
     /* 486820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486904 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486948 */     GIR_RootConstrainSelectedInstOperands,
     /* 486949 */     // GIR_Coverage, 12046,
     /* 486949 */     GIR_EraseRootFromParent_Done,
     /* 486950 */   // Label 6626: @486950
     /* 486950 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(487085), // Rule ID 12521 //
     /* 486955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487039 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487083 */     GIR_RootConstrainSelectedInstOperands,
     /* 487084 */     // GIR_Coverage, 12521,
     /* 487084 */     GIR_EraseRootFromParent_Done,
     /* 487085 */   // Label 6627: @487085
     /* 487085 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(487220), // Rule ID 12522 //
     /* 487090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487174 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487218 */     GIR_RootConstrainSelectedInstOperands,
     /* 487219 */     // GIR_Coverage, 12522,
     /* 487219 */     GIR_EraseRootFromParent_Done,
     /* 487220 */   // Label 6628: @487220
     /* 487220 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(487355), // Rule ID 12525 //
     /* 487225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487309 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487353 */     GIR_RootConstrainSelectedInstOperands,
     /* 487354 */     // GIR_Coverage, 12525,
     /* 487354 */     GIR_EraseRootFromParent_Done,
     /* 487355 */   // Label 6629: @487355
     /* 487355 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(487490), // Rule ID 12526 //
     /* 487360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487444 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487488 */     GIR_RootConstrainSelectedInstOperands,
     /* 487489 */     // GIR_Coverage, 12526,
     /* 487489 */     GIR_EraseRootFromParent_Done,
     /* 487490 */   // Label 6630: @487490
     /* 487490 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(487625), // Rule ID 13001 //
     /* 487495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487579 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487623 */     GIR_RootConstrainSelectedInstOperands,
     /* 487624 */     // GIR_Coverage, 13001,
     /* 487624 */     GIR_EraseRootFromParent_Done,
     /* 487625 */   // Label 6631: @487625
     /* 487625 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(487760), // Rule ID 13002 //
     /* 487630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487714 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487758 */     GIR_RootConstrainSelectedInstOperands,
     /* 487759 */     // GIR_Coverage, 13002,
     /* 487759 */     GIR_EraseRootFromParent_Done,
     /* 487760 */   // Label 6632: @487760
     /* 487760 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(487895), // Rule ID 13005 //
     /* 487765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487817 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487849 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487893 */     GIR_RootConstrainSelectedInstOperands,
     /* 487894 */     // GIR_Coverage, 13005,
     /* 487894 */     GIR_EraseRootFromParent_Done,
     /* 487895 */   // Label 6633: @487895
     /* 487895 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(488030), // Rule ID 13006 //
     /* 487900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487984 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488028 */     GIR_RootConstrainSelectedInstOperands,
     /* 488029 */     // GIR_Coverage, 13006,
     /* 488029 */     GIR_EraseRootFromParent_Done,
     /* 488030 */   // Label 6634: @488030
     /* 488030 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(488165), // Rule ID 7635 //
     /* 488035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488119 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488163 */     GIR_RootConstrainSelectedInstOperands,
     /* 488164 */     // GIR_Coverage, 7635,
     /* 488164 */     GIR_EraseRootFromParent_Done,
     /* 488165 */   // Label 6635: @488165
     /* 488165 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(488300), // Rule ID 7667 //
     /* 488170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488217 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488222 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488254 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488298 */     GIR_RootConstrainSelectedInstOperands,
     /* 488299 */     // GIR_Coverage, 7667,
     /* 488299 */     GIR_EraseRootFromParent_Done,
     /* 488300 */   // Label 6636: @488300
     /* 488300 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(488435), // Rule ID 7699 //
     /* 488305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488389 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 488392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488433 */     GIR_RootConstrainSelectedInstOperands,
     /* 488434 */     // GIR_Coverage, 7699,
     /* 488434 */     GIR_EraseRootFromParent_Done,
     /* 488435 */   // Label 6637: @488435
     /* 488435 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(488570), // Rule ID 12055 //
     /* 488440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488524 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488568 */     GIR_RootConstrainSelectedInstOperands,
     /* 488569 */     // GIR_Coverage, 12055,
     /* 488569 */     GIR_EraseRootFromParent_Done,
     /* 488570 */   // Label 6638: @488570
     /* 488570 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(488705), // Rule ID 12058 //
     /* 488575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488659 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488703 */     GIR_RootConstrainSelectedInstOperands,
     /* 488704 */     // GIR_Coverage, 12058,
     /* 488704 */     GIR_EraseRootFromParent_Done,
     /* 488705 */   // Label 6639: @488705
     /* 488705 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(488840), // Rule ID 12059 //
     /* 488710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488794 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488838 */     GIR_RootConstrainSelectedInstOperands,
     /* 488839 */     // GIR_Coverage, 12059,
     /* 488839 */     GIR_EraseRootFromParent_Done,
     /* 488840 */   // Label 6640: @488840
     /* 488840 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(488975), // Rule ID 12535 //
     /* 488845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488892 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488897 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488929 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488973 */     GIR_RootConstrainSelectedInstOperands,
     /* 488974 */     // GIR_Coverage, 12535,
     /* 488974 */     GIR_EraseRootFromParent_Done,
     /* 488975 */   // Label 6641: @488975
     /* 488975 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(489110), // Rule ID 12538 //
     /* 488980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489027 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489032 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489064 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489108 */     GIR_RootConstrainSelectedInstOperands,
     /* 489109 */     // GIR_Coverage, 12538,
     /* 489109 */     GIR_EraseRootFromParent_Done,
     /* 489110 */   // Label 6642: @489110
     /* 489110 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(489245), // Rule ID 12539 //
     /* 489115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489162 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489167 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489199 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489243 */     GIR_RootConstrainSelectedInstOperands,
     /* 489244 */     // GIR_Coverage, 12539,
     /* 489244 */     GIR_EraseRootFromParent_Done,
     /* 489245 */   // Label 6643: @489245
     /* 489245 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(489380), // Rule ID 13015 //
     /* 489250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489302 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489334 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489378 */     GIR_RootConstrainSelectedInstOperands,
     /* 489379 */     // GIR_Coverage, 13015,
     /* 489379 */     GIR_EraseRootFromParent_Done,
     /* 489380 */   // Label 6644: @489380
     /* 489380 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(489515), // Rule ID 13018 //
     /* 489385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489469 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489513 */     GIR_RootConstrainSelectedInstOperands,
     /* 489514 */     // GIR_Coverage, 13018,
     /* 489514 */     GIR_EraseRootFromParent_Done,
     /* 489515 */   // Label 6645: @489515
     /* 489515 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(489650), // Rule ID 13019 //
     /* 489520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489604 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489648 */     GIR_RootConstrainSelectedInstOperands,
     /* 489649 */     // GIR_Coverage, 13019,
     /* 489649 */     GIR_EraseRootFromParent_Done,
     /* 489650 */   // Label 6646: @489650
     /* 489650 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(489785), // Rule ID 7634 //
     /* 489655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489739 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489783 */     GIR_RootConstrainSelectedInstOperands,
     /* 489784 */     // GIR_Coverage, 7634,
     /* 489784 */     GIR_EraseRootFromParent_Done,
     /* 489785 */   // Label 6647: @489785
     /* 489785 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(489920), // Rule ID 7666 //
     /* 489790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489837 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489842 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489874 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489918 */     GIR_RootConstrainSelectedInstOperands,
     /* 489919 */     // GIR_Coverage, 7666,
     /* 489919 */     GIR_EraseRootFromParent_Done,
     /* 489920 */   // Label 6648: @489920
     /* 489920 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(490055), // Rule ID 7698 //
     /* 489925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490009 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490053 */     GIR_RootConstrainSelectedInstOperands,
     /* 490054 */     // GIR_Coverage, 7698,
     /* 490054 */     GIR_EraseRootFromParent_Done,
     /* 490055 */   // Label 6649: @490055
     /* 490055 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(490190), // Rule ID 12040 //
     /* 490060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490144 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490188 */     GIR_RootConstrainSelectedInstOperands,
     /* 490189 */     // GIR_Coverage, 12040,
     /* 490189 */     GIR_EraseRootFromParent_Done,
     /* 490190 */   // Label 6650: @490190
     /* 490190 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(490325), // Rule ID 12043 //
     /* 490195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490279 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490323 */     GIR_RootConstrainSelectedInstOperands,
     /* 490324 */     // GIR_Coverage, 12043,
     /* 490324 */     GIR_EraseRootFromParent_Done,
     /* 490325 */   // Label 6651: @490325
     /* 490325 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(490460), // Rule ID 12044 //
     /* 490330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490414 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490458 */     GIR_RootConstrainSelectedInstOperands,
     /* 490459 */     // GIR_Coverage, 12044,
     /* 490459 */     GIR_EraseRootFromParent_Done,
     /* 490460 */   // Label 6652: @490460
     /* 490460 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(490595), // Rule ID 12520 //
     /* 490465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490512 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490517 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490549 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490593 */     GIR_RootConstrainSelectedInstOperands,
     /* 490594 */     // GIR_Coverage, 12520,
     /* 490594 */     GIR_EraseRootFromParent_Done,
     /* 490595 */   // Label 6653: @490595
     /* 490595 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(490730), // Rule ID 12523 //
     /* 490600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490647 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490652 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490684 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490728 */     GIR_RootConstrainSelectedInstOperands,
     /* 490729 */     // GIR_Coverage, 12523,
     /* 490729 */     GIR_EraseRootFromParent_Done,
     /* 490730 */   // Label 6654: @490730
     /* 490730 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(490865), // Rule ID 12524 //
     /* 490735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490782 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490787 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490819 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490863 */     GIR_RootConstrainSelectedInstOperands,
     /* 490864 */     // GIR_Coverage, 12524,
     /* 490864 */     GIR_EraseRootFromParent_Done,
     /* 490865 */   // Label 6655: @490865
     /* 490865 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(491000), // Rule ID 13000 //
     /* 490870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490954 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490998 */     GIR_RootConstrainSelectedInstOperands,
     /* 490999 */     // GIR_Coverage, 13000,
     /* 490999 */     GIR_EraseRootFromParent_Done,
     /* 491000 */   // Label 6656: @491000
     /* 491000 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(491135), // Rule ID 13003 //
     /* 491005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 491008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 491048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491089 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 491092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 491114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491133 */     GIR_RootConstrainSelectedInstOperands,
     /* 491134 */     // GIR_Coverage, 13003,
     /* 491134 */     GIR_EraseRootFromParent_Done,
     /* 491135 */   // Label 6657: @491135
     /* 491135 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(491270), // Rule ID 13004 //
     /* 491140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 491143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 491183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491224 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 491227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 491249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491268 */     GIR_RootConstrainSelectedInstOperands,
     /* 491269 */     // GIR_Coverage, 13004,
     /* 491269 */     GIR_EraseRootFromParent_Done,
     /* 491270 */   // Label 6658: @491270
     /* 491270 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(491405), // Rule ID 12126 //
     /* 491275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491359 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491403 */     GIR_RootConstrainSelectedInstOperands,
     /* 491404 */     // GIR_Coverage, 12126,
     /* 491404 */     GIR_EraseRootFromParent_Done,
     /* 491405 */   // Label 6659: @491405
     /* 491405 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(491540), // Rule ID 12127 //
     /* 491410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491494 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491538 */     GIR_RootConstrainSelectedInstOperands,
     /* 491539 */     // GIR_Coverage, 12127,
     /* 491539 */     GIR_EraseRootFromParent_Done,
     /* 491540 */   // Label 6660: @491540
     /* 491540 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(491675), // Rule ID 12128 //
     /* 491545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491629 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 491639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 491644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491673 */     GIR_RootConstrainSelectedInstOperands,
     /* 491674 */     // GIR_Coverage, 12128,
     /* 491674 */     GIR_EraseRootFromParent_Done,
     /* 491675 */   // Label 6661: @491675
     /* 491675 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(491810), // Rule ID 12129 //
     /* 491680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491764 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 491774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 491779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491808 */     GIR_RootConstrainSelectedInstOperands,
     /* 491809 */     // GIR_Coverage, 12129,
     /* 491809 */     GIR_EraseRootFromParent_Done,
     /* 491810 */   // Label 6662: @491810
     /* 491810 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(491945), // Rule ID 12606 //
     /* 491815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491899 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491943 */     GIR_RootConstrainSelectedInstOperands,
     /* 491944 */     // GIR_Coverage, 12606,
     /* 491944 */     GIR_EraseRootFromParent_Done,
     /* 491945 */   // Label 6663: @491945
     /* 491945 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(492080), // Rule ID 12607 //
     /* 491950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492034 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 492037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492078 */     GIR_RootConstrainSelectedInstOperands,
     /* 492079 */     // GIR_Coverage, 12607,
     /* 492079 */     GIR_EraseRootFromParent_Done,
     /* 492080 */   // Label 6664: @492080
     /* 492080 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(492215), // Rule ID 12608 //
     /* 492085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 492088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 492092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492169 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 492172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492213 */     GIR_RootConstrainSelectedInstOperands,
     /* 492214 */     // GIR_Coverage, 12608,
     /* 492214 */     GIR_EraseRootFromParent_Done,
     /* 492215 */   // Label 6665: @492215
     /* 492215 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(492350), // Rule ID 12609 //
     /* 492220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 492223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 492227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492304 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 492307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492348 */     GIR_RootConstrainSelectedInstOperands,
     /* 492349 */     // GIR_Coverage, 12609,
     /* 492349 */     GIR_EraseRootFromParent_Done,
     /* 492350 */   // Label 6666: @492350
     /* 492350 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(492485), // Rule ID 13086 //
     /* 492355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492439 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492483 */     GIR_RootConstrainSelectedInstOperands,
     /* 492484 */     // GIR_Coverage, 13086,
     /* 492484 */     GIR_EraseRootFromParent_Done,
     /* 492485 */   // Label 6667: @492485
     /* 492485 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(492620), // Rule ID 13087 //
     /* 492490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492574 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492618 */     GIR_RootConstrainSelectedInstOperands,
     /* 492619 */     // GIR_Coverage, 13087,
     /* 492619 */     GIR_EraseRootFromParent_Done,
     /* 492620 */   // Label 6668: @492620
     /* 492620 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(492755), // Rule ID 13088 //
     /* 492625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492709 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492753 */     GIR_RootConstrainSelectedInstOperands,
     /* 492754 */     // GIR_Coverage, 13088,
     /* 492754 */     GIR_EraseRootFromParent_Done,
     /* 492755 */   // Label 6669: @492755
     /* 492755 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(492890), // Rule ID 13089 //
     /* 492760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492844 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492888 */     GIR_RootConstrainSelectedInstOperands,
     /* 492889 */     // GIR_Coverage, 13089,
     /* 492889 */     GIR_EraseRootFromParent_Done,
     /* 492890 */   // Label 6670: @492890
     /* 492890 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(493025), // Rule ID 12066 //
     /* 492895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492979 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493023 */     GIR_RootConstrainSelectedInstOperands,
     /* 493024 */     // GIR_Coverage, 12066,
     /* 493024 */     GIR_EraseRootFromParent_Done,
     /* 493025 */   // Label 6671: @493025
     /* 493025 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(493160), // Rule ID 12067 //
     /* 493030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 493033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493114 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 493117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493158 */     GIR_RootConstrainSelectedInstOperands,
     /* 493159 */     // GIR_Coverage, 12067,
     /* 493159 */     GIR_EraseRootFromParent_Done,
     /* 493160 */   // Label 6672: @493160
     /* 493160 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(493295), // Rule ID 12068 //
     /* 493165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 493168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493249 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 493252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493293 */     GIR_RootConstrainSelectedInstOperands,
     /* 493294 */     // GIR_Coverage, 12068,
     /* 493294 */     GIR_EraseRootFromParent_Done,
     /* 493295 */   // Label 6673: @493295
     /* 493295 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(493430), // Rule ID 12069 //
     /* 493300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 493303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493384 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 493387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493428 */     GIR_RootConstrainSelectedInstOperands,
     /* 493429 */     // GIR_Coverage, 12069,
     /* 493429 */     GIR_EraseRootFromParent_Done,
     /* 493430 */   // Label 6674: @493430
     /* 493430 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(493565), // Rule ID 12546 //
     /* 493435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493519 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493563 */     GIR_RootConstrainSelectedInstOperands,
     /* 493564 */     // GIR_Coverage, 12546,
     /* 493564 */     GIR_EraseRootFromParent_Done,
     /* 493565 */   // Label 6675: @493565
     /* 493565 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(493700), // Rule ID 12547 //
     /* 493570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493654 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493698 */     GIR_RootConstrainSelectedInstOperands,
     /* 493699 */     // GIR_Coverage, 12547,
     /* 493699 */     GIR_EraseRootFromParent_Done,
     /* 493700 */   // Label 6676: @493700
     /* 493700 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(493835), // Rule ID 12548 //
     /* 493705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493789 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493833 */     GIR_RootConstrainSelectedInstOperands,
     /* 493834 */     // GIR_Coverage, 12548,
     /* 493834 */     GIR_EraseRootFromParent_Done,
     /* 493835 */   // Label 6677: @493835
     /* 493835 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(493970), // Rule ID 12549 //
     /* 493840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493924 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493968 */     GIR_RootConstrainSelectedInstOperands,
     /* 493969 */     // GIR_Coverage, 12549,
     /* 493969 */     GIR_EraseRootFromParent_Done,
     /* 493970 */   // Label 6678: @493970
     /* 493970 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(494105), // Rule ID 13026 //
     /* 493975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 494006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494059 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494103 */     GIR_RootConstrainSelectedInstOperands,
     /* 494104 */     // GIR_Coverage, 13026,
     /* 494104 */     GIR_EraseRootFromParent_Done,
     /* 494105 */   // Label 6679: @494105
     /* 494105 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(494240), // Rule ID 13027 //
     /* 494110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 494113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 494141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494194 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494238 */     GIR_RootConstrainSelectedInstOperands,
     /* 494239 */     // GIR_Coverage, 13027,
     /* 494239 */     GIR_EraseRootFromParent_Done,
     /* 494240 */   // Label 6680: @494240
     /* 494240 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(494375), // Rule ID 13028 //
     /* 494245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 494248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 494276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494329 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494373 */     GIR_RootConstrainSelectedInstOperands,
     /* 494374 */     // GIR_Coverage, 13028,
     /* 494374 */     GIR_EraseRootFromParent_Done,
     /* 494375 */   // Label 6681: @494375
     /* 494375 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(494510), // Rule ID 13029 //
     /* 494380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 494383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 494411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494464 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494508 */     GIR_RootConstrainSelectedInstOperands,
     /* 494509 */     // GIR_Coverage, 13029,
     /* 494509 */     GIR_EraseRootFromParent_Done,
     /* 494510 */   // Label 6682: @494510
     /* 494510 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(494645), // Rule ID 12111 //
     /* 494515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494599 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494643 */     GIR_RootConstrainSelectedInstOperands,
     /* 494644 */     // GIR_Coverage, 12111,
     /* 494644 */     GIR_EraseRootFromParent_Done,
     /* 494645 */   // Label 6683: @494645
     /* 494645 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(494780), // Rule ID 12112 //
     /* 494650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494734 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494778 */     GIR_RootConstrainSelectedInstOperands,
     /* 494779 */     // GIR_Coverage, 12112,
     /* 494779 */     GIR_EraseRootFromParent_Done,
     /* 494780 */   // Label 6684: @494780
     /* 494780 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(494915), // Rule ID 12113 //
     /* 494785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494869 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494913 */     GIR_RootConstrainSelectedInstOperands,
     /* 494914 */     // GIR_Coverage, 12113,
     /* 494914 */     GIR_EraseRootFromParent_Done,
     /* 494915 */   // Label 6685: @494915
     /* 494915 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(495050), // Rule ID 12114 //
     /* 494920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495004 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495048 */     GIR_RootConstrainSelectedInstOperands,
     /* 495049 */     // GIR_Coverage, 12114,
     /* 495049 */     GIR_EraseRootFromParent_Done,
     /* 495050 */   // Label 6686: @495050
     /* 495050 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(495185), // Rule ID 12591 //
     /* 495055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495112 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495139 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495183 */     GIR_RootConstrainSelectedInstOperands,
     /* 495184 */     // GIR_Coverage, 12591,
     /* 495184 */     GIR_EraseRootFromParent_Done,
     /* 495185 */   // Label 6687: @495185
     /* 495185 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(495320), // Rule ID 12592 //
     /* 495190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495274 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495318 */     GIR_RootConstrainSelectedInstOperands,
     /* 495319 */     // GIR_Coverage, 12592,
     /* 495319 */     GIR_EraseRootFromParent_Done,
     /* 495320 */   // Label 6688: @495320
     /* 495320 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(495455), // Rule ID 12593 //
     /* 495325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495409 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495453 */     GIR_RootConstrainSelectedInstOperands,
     /* 495454 */     // GIR_Coverage, 12593,
     /* 495454 */     GIR_EraseRootFromParent_Done,
     /* 495455 */   // Label 6689: @495455
     /* 495455 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(495590), // Rule ID 12594 //
     /* 495460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495544 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495588 */     GIR_RootConstrainSelectedInstOperands,
     /* 495589 */     // GIR_Coverage, 12594,
     /* 495589 */     GIR_EraseRootFromParent_Done,
     /* 495590 */   // Label 6690: @495590
     /* 495590 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(495725), // Rule ID 13071 //
     /* 495595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495679 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495723 */     GIR_RootConstrainSelectedInstOperands,
     /* 495724 */     // GIR_Coverage, 13071,
     /* 495724 */     GIR_EraseRootFromParent_Done,
     /* 495725 */   // Label 6691: @495725
     /* 495725 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(495860), // Rule ID 13072 //
     /* 495730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495814 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495858 */     GIR_RootConstrainSelectedInstOperands,
     /* 495859 */     // GIR_Coverage, 13072,
     /* 495859 */     GIR_EraseRootFromParent_Done,
     /* 495860 */   // Label 6692: @495860
     /* 495860 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(495995), // Rule ID 13073 //
     /* 495865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495949 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495993 */     GIR_RootConstrainSelectedInstOperands,
     /* 495994 */     // GIR_Coverage, 13073,
     /* 495994 */     GIR_EraseRootFromParent_Done,
     /* 495995 */   // Label 6693: @495995
     /* 495995 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(496130), // Rule ID 13074 //
     /* 496000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496084 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 496087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496128 */     GIR_RootConstrainSelectedInstOperands,
     /* 496129 */     // GIR_Coverage, 13074,
     /* 496129 */     GIR_EraseRootFromParent_Done,
     /* 496130 */   // Label 6694: @496130
     /* 496130 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(496265), // Rule ID 12051 //
     /* 496135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496219 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496263 */     GIR_RootConstrainSelectedInstOperands,
     /* 496264 */     // GIR_Coverage, 12051,
     /* 496264 */     GIR_EraseRootFromParent_Done,
     /* 496265 */   // Label 6695: @496265
     /* 496265 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(496400), // Rule ID 12052 //
     /* 496270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496354 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496398 */     GIR_RootConstrainSelectedInstOperands,
     /* 496399 */     // GIR_Coverage, 12052,
     /* 496399 */     GIR_EraseRootFromParent_Done,
     /* 496400 */   // Label 6696: @496400
     /* 496400 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(496535), // Rule ID 12053 //
     /* 496405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496489 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496533 */     GIR_RootConstrainSelectedInstOperands,
     /* 496534 */     // GIR_Coverage, 12053,
     /* 496534 */     GIR_EraseRootFromParent_Done,
     /* 496535 */   // Label 6697: @496535
     /* 496535 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(496670), // Rule ID 12054 //
     /* 496540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496624 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496668 */     GIR_RootConstrainSelectedInstOperands,
     /* 496669 */     // GIR_Coverage, 12054,
     /* 496669 */     GIR_EraseRootFromParent_Done,
     /* 496670 */   // Label 6698: @496670
     /* 496670 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(496805), // Rule ID 12531 //
     /* 496675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496759 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496803 */     GIR_RootConstrainSelectedInstOperands,
     /* 496804 */     // GIR_Coverage, 12531,
     /* 496804 */     GIR_EraseRootFromParent_Done,
     /* 496805 */   // Label 6699: @496805
     /* 496805 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(496940), // Rule ID 12532 //
     /* 496810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496894 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496938 */     GIR_RootConstrainSelectedInstOperands,
     /* 496939 */     // GIR_Coverage, 12532,
     /* 496939 */     GIR_EraseRootFromParent_Done,
     /* 496940 */   // Label 6700: @496940
     /* 496940 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(497075), // Rule ID 12533 //
     /* 496945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497029 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 497032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497073 */     GIR_RootConstrainSelectedInstOperands,
     /* 497074 */     // GIR_Coverage, 12533,
     /* 497074 */     GIR_EraseRootFromParent_Done,
     /* 497075 */   // Label 6701: @497075
     /* 497075 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(497210), // Rule ID 12534 //
     /* 497080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 497083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 497087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497164 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 497167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497208 */     GIR_RootConstrainSelectedInstOperands,
     /* 497209 */     // GIR_Coverage, 12534,
     /* 497209 */     GIR_EraseRootFromParent_Done,
     /* 497210 */   // Label 6702: @497210
     /* 497210 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(497345), // Rule ID 13011 //
     /* 497215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497299 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497343 */     GIR_RootConstrainSelectedInstOperands,
     /* 497344 */     // GIR_Coverage, 13011,
     /* 497344 */     GIR_EraseRootFromParent_Done,
     /* 497345 */   // Label 6703: @497345
     /* 497345 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(497480), // Rule ID 13012 //
     /* 497350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497407 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497434 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497478 */     GIR_RootConstrainSelectedInstOperands,
     /* 497479 */     // GIR_Coverage, 13012,
     /* 497479 */     GIR_EraseRootFromParent_Done,
     /* 497480 */   // Label 6704: @497480
     /* 497480 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(497615), // Rule ID 13013 //
     /* 497485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497569 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497613 */     GIR_RootConstrainSelectedInstOperands,
     /* 497614 */     // GIR_Coverage, 13013,
     /* 497614 */     GIR_EraseRootFromParent_Done,
     /* 497615 */   // Label 6705: @497615
     /* 497615 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(497750), // Rule ID 13014 //
     /* 497620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497704 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497748 */     GIR_RootConstrainSelectedInstOperands,
     /* 497749 */     // GIR_Coverage, 13014,
     /* 497749 */     GIR_EraseRootFromParent_Done,
     /* 497750 */   // Label 6706: @497750
     /* 497750 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(497885), // Rule ID 12122 //
     /* 497755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497839 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 497849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 497854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 497869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 497874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497883 */     GIR_RootConstrainSelectedInstOperands,
     /* 497884 */     // GIR_Coverage, 12122,
     /* 497884 */     GIR_EraseRootFromParent_Done,
     /* 497885 */   // Label 6707: @497885
     /* 497885 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(498020), // Rule ID 12123 //
     /* 497890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497974 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 497984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 497989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498018 */     GIR_RootConstrainSelectedInstOperands,
     /* 498019 */     // GIR_Coverage, 12123,
     /* 498019 */     GIR_EraseRootFromParent_Done,
     /* 498020 */   // Label 6708: @498020
     /* 498020 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(498155), // Rule ID 12124 //
     /* 498025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 498028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498109 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 498112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498153 */     GIR_RootConstrainSelectedInstOperands,
     /* 498154 */     // GIR_Coverage, 12124,
     /* 498154 */     GIR_EraseRootFromParent_Done,
     /* 498155 */   // Label 6709: @498155
     /* 498155 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(498290), // Rule ID 12125 //
     /* 498160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 498163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498244 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 498247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498288 */     GIR_RootConstrainSelectedInstOperands,
     /* 498289 */     // GIR_Coverage, 12125,
     /* 498289 */     GIR_EraseRootFromParent_Done,
     /* 498290 */   // Label 6710: @498290
     /* 498290 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(498425), // Rule ID 12602 //
     /* 498295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498379 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498423 */     GIR_RootConstrainSelectedInstOperands,
     /* 498424 */     // GIR_Coverage, 12602,
     /* 498424 */     GIR_EraseRootFromParent_Done,
     /* 498425 */   // Label 6711: @498425
     /* 498425 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(498560), // Rule ID 12603 //
     /* 498430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498514 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498558 */     GIR_RootConstrainSelectedInstOperands,
     /* 498559 */     // GIR_Coverage, 12603,
     /* 498559 */     GIR_EraseRootFromParent_Done,
     /* 498560 */   // Label 6712: @498560
     /* 498560 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(498695), // Rule ID 12604 //
     /* 498565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498649 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498693 */     GIR_RootConstrainSelectedInstOperands,
     /* 498694 */     // GIR_Coverage, 12604,
     /* 498694 */     GIR_EraseRootFromParent_Done,
     /* 498695 */   // Label 6713: @498695
     /* 498695 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(498830), // Rule ID 12605 //
     /* 498700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498784 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498828 */     GIR_RootConstrainSelectedInstOperands,
     /* 498829 */     // GIR_Coverage, 12605,
     /* 498829 */     GIR_EraseRootFromParent_Done,
     /* 498830 */   // Label 6714: @498830
     /* 498830 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(498965), // Rule ID 13082 //
     /* 498835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498919 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498963 */     GIR_RootConstrainSelectedInstOperands,
     /* 498964 */     // GIR_Coverage, 13082,
     /* 498964 */     GIR_EraseRootFromParent_Done,
     /* 498965 */   // Label 6715: @498965
     /* 498965 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(499100), // Rule ID 13083 //
     /* 498970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499054 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499098 */     GIR_RootConstrainSelectedInstOperands,
     /* 499099 */     // GIR_Coverage, 13083,
     /* 499099 */     GIR_EraseRootFromParent_Done,
     /* 499100 */   // Label 6716: @499100
     /* 499100 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(499235), // Rule ID 13084 //
     /* 499105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 499108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499189 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499233 */     GIR_RootConstrainSelectedInstOperands,
     /* 499234 */     // GIR_Coverage, 13084,
     /* 499234 */     GIR_EraseRootFromParent_Done,
     /* 499235 */   // Label 6717: @499235
     /* 499235 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(499370), // Rule ID 13085 //
     /* 499240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 499243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499324 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499368 */     GIR_RootConstrainSelectedInstOperands,
     /* 499369 */     // GIR_Coverage, 13085,
     /* 499369 */     GIR_EraseRootFromParent_Done,
     /* 499370 */   // Label 6718: @499370
     /* 499370 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(499505), // Rule ID 12062 //
     /* 499375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499459 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499503 */     GIR_RootConstrainSelectedInstOperands,
     /* 499504 */     // GIR_Coverage, 12062,
     /* 499504 */     GIR_EraseRootFromParent_Done,
     /* 499505 */   // Label 6719: @499505
     /* 499505 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(499640), // Rule ID 12063 //
     /* 499510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499594 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499638 */     GIR_RootConstrainSelectedInstOperands,
     /* 499639 */     // GIR_Coverage, 12063,
     /* 499639 */     GIR_EraseRootFromParent_Done,
     /* 499640 */   // Label 6720: @499640
     /* 499640 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(499775), // Rule ID 12064 //
     /* 499645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499729 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499773 */     GIR_RootConstrainSelectedInstOperands,
     /* 499774 */     // GIR_Coverage, 12064,
     /* 499774 */     GIR_EraseRootFromParent_Done,
     /* 499775 */   // Label 6721: @499775
     /* 499775 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(499910), // Rule ID 12065 //
     /* 499780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499864 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499908 */     GIR_RootConstrainSelectedInstOperands,
     /* 499909 */     // GIR_Coverage, 12065,
     /* 499909 */     GIR_EraseRootFromParent_Done,
     /* 499910 */   // Label 6722: @499910
     /* 499910 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(500045), // Rule ID 12542 //
     /* 499915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499999 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500043 */     GIR_RootConstrainSelectedInstOperands,
     /* 500044 */     // GIR_Coverage, 12542,
     /* 500044 */     GIR_EraseRootFromParent_Done,
     /* 500045 */   // Label 6723: @500045
     /* 500045 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(500180), // Rule ID 12543 //
     /* 500050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500134 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500178 */     GIR_RootConstrainSelectedInstOperands,
     /* 500179 */     // GIR_Coverage, 12543,
     /* 500179 */     GIR_EraseRootFromParent_Done,
     /* 500180 */   // Label 6724: @500180
     /* 500180 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(500315), // Rule ID 12544 //
     /* 500185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500269 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500313 */     GIR_RootConstrainSelectedInstOperands,
     /* 500314 */     // GIR_Coverage, 12544,
     /* 500314 */     GIR_EraseRootFromParent_Done,
     /* 500315 */   // Label 6725: @500315
     /* 500315 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(500450), // Rule ID 12545 //
     /* 500320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500404 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500448 */     GIR_RootConstrainSelectedInstOperands,
     /* 500449 */     // GIR_Coverage, 12545,
     /* 500449 */     GIR_EraseRootFromParent_Done,
     /* 500450 */   // Label 6726: @500450
     /* 500450 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(500585), // Rule ID 13022 //
     /* 500455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500539 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500583 */     GIR_RootConstrainSelectedInstOperands,
     /* 500584 */     // GIR_Coverage, 13022,
     /* 500584 */     GIR_EraseRootFromParent_Done,
     /* 500585 */   // Label 6727: @500585
     /* 500585 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(500720), // Rule ID 13023 //
     /* 500590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500674 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500718 */     GIR_RootConstrainSelectedInstOperands,
     /* 500719 */     // GIR_Coverage, 13023,
     /* 500719 */     GIR_EraseRootFromParent_Done,
     /* 500720 */   // Label 6728: @500720
     /* 500720 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(500855), // Rule ID 13024 //
     /* 500725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500809 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500853 */     GIR_RootConstrainSelectedInstOperands,
     /* 500854 */     // GIR_Coverage, 13024,
     /* 500854 */     GIR_EraseRootFromParent_Done,
     /* 500855 */   // Label 6729: @500855
     /* 500855 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(500990), // Rule ID 13025 //
     /* 500860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500944 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500988 */     GIR_RootConstrainSelectedInstOperands,
     /* 500989 */     // GIR_Coverage, 13025,
     /* 500989 */     GIR_EraseRootFromParent_Done,
     /* 500990 */   // Label 6730: @500990
     /* 500990 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(501125), // Rule ID 12107 //
     /* 500995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501079 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501123 */     GIR_RootConstrainSelectedInstOperands,
     /* 501124 */     // GIR_Coverage, 12107,
     /* 501124 */     GIR_EraseRootFromParent_Done,
     /* 501125 */   // Label 6731: @501125
     /* 501125 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(501260), // Rule ID 12108 //
     /* 501130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 501133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501214 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501258 */     GIR_RootConstrainSelectedInstOperands,
     /* 501259 */     // GIR_Coverage, 12108,
     /* 501259 */     GIR_EraseRootFromParent_Done,
     /* 501260 */   // Label 6732: @501260
     /* 501260 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(501395), // Rule ID 12109 //
     /* 501265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 501268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501349 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501393 */     GIR_RootConstrainSelectedInstOperands,
     /* 501394 */     // GIR_Coverage, 12109,
     /* 501394 */     GIR_EraseRootFromParent_Done,
     /* 501395 */   // Label 6733: @501395
     /* 501395 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(501530), // Rule ID 12110 //
     /* 501400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 501403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501484 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501528 */     GIR_RootConstrainSelectedInstOperands,
     /* 501529 */     // GIR_Coverage, 12110,
     /* 501529 */     GIR_EraseRootFromParent_Done,
     /* 501530 */   // Label 6734: @501530
     /* 501530 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(501665), // Rule ID 12587 //
     /* 501535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501619 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501663 */     GIR_RootConstrainSelectedInstOperands,
     /* 501664 */     // GIR_Coverage, 12587,
     /* 501664 */     GIR_EraseRootFromParent_Done,
     /* 501665 */   // Label 6735: @501665
     /* 501665 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(501800), // Rule ID 12588 //
     /* 501670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501754 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501798 */     GIR_RootConstrainSelectedInstOperands,
     /* 501799 */     // GIR_Coverage, 12588,
     /* 501799 */     GIR_EraseRootFromParent_Done,
     /* 501800 */   // Label 6736: @501800
     /* 501800 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(501935), // Rule ID 12589 //
     /* 501805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501889 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501933 */     GIR_RootConstrainSelectedInstOperands,
     /* 501934 */     // GIR_Coverage, 12589,
     /* 501934 */     GIR_EraseRootFromParent_Done,
     /* 501935 */   // Label 6737: @501935
     /* 501935 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(502070), // Rule ID 12590 //
     /* 501940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502024 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502068 */     GIR_RootConstrainSelectedInstOperands,
     /* 502069 */     // GIR_Coverage, 12590,
     /* 502069 */     GIR_EraseRootFromParent_Done,
     /* 502070 */   // Label 6738: @502070
     /* 502070 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(502205), // Rule ID 13067 //
     /* 502075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502159 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502203 */     GIR_RootConstrainSelectedInstOperands,
     /* 502204 */     // GIR_Coverage, 13067,
     /* 502204 */     GIR_EraseRootFromParent_Done,
     /* 502205 */   // Label 6739: @502205
     /* 502205 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(502340), // Rule ID 13068 //
     /* 502210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502294 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502338 */     GIR_RootConstrainSelectedInstOperands,
     /* 502339 */     // GIR_Coverage, 13068,
     /* 502339 */     GIR_EraseRootFromParent_Done,
     /* 502340 */   // Label 6740: @502340
     /* 502340 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(502475), // Rule ID 13069 //
     /* 502345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502429 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502473 */     GIR_RootConstrainSelectedInstOperands,
     /* 502474 */     // GIR_Coverage, 13069,
     /* 502474 */     GIR_EraseRootFromParent_Done,
     /* 502475 */   // Label 6741: @502475
     /* 502475 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(502610), // Rule ID 13070 //
     /* 502480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502564 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502608 */     GIR_RootConstrainSelectedInstOperands,
     /* 502609 */     // GIR_Coverage, 13070,
     /* 502609 */     GIR_EraseRootFromParent_Done,
     /* 502610 */   // Label 6742: @502610
     /* 502610 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(502745), // Rule ID 12047 //
     /* 502615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502699 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502743 */     GIR_RootConstrainSelectedInstOperands,
     /* 502744 */     // GIR_Coverage, 12047,
     /* 502744 */     GIR_EraseRootFromParent_Done,
     /* 502745 */   // Label 6743: @502745
     /* 502745 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(502880), // Rule ID 12048 //
     /* 502750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502834 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502878 */     GIR_RootConstrainSelectedInstOperands,
     /* 502879 */     // GIR_Coverage, 12048,
     /* 502879 */     GIR_EraseRootFromParent_Done,
     /* 502880 */   // Label 6744: @502880
     /* 502880 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(503015), // Rule ID 12049 //
     /* 502885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502969 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503013 */     GIR_RootConstrainSelectedInstOperands,
     /* 503014 */     // GIR_Coverage, 12049,
     /* 503014 */     GIR_EraseRootFromParent_Done,
     /* 503015 */   // Label 6745: @503015
     /* 503015 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(503150), // Rule ID 12050 //
     /* 503020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 503023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503104 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 503107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503148 */     GIR_RootConstrainSelectedInstOperands,
     /* 503149 */     // GIR_Coverage, 12050,
     /* 503149 */     GIR_EraseRootFromParent_Done,
     /* 503150 */   // Label 6746: @503150
     /* 503150 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(503285), // Rule ID 12527 //
     /* 503155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503239 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503283 */     GIR_RootConstrainSelectedInstOperands,
     /* 503284 */     // GIR_Coverage, 12527,
     /* 503284 */     GIR_EraseRootFromParent_Done,
     /* 503285 */   // Label 6747: @503285
     /* 503285 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(503420), // Rule ID 12528 //
     /* 503290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503374 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503418 */     GIR_RootConstrainSelectedInstOperands,
     /* 503419 */     // GIR_Coverage, 12528,
     /* 503419 */     GIR_EraseRootFromParent_Done,
     /* 503420 */   // Label 6748: @503420
     /* 503420 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(503555), // Rule ID 12529 //
     /* 503425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503509 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503553 */     GIR_RootConstrainSelectedInstOperands,
     /* 503554 */     // GIR_Coverage, 12529,
     /* 503554 */     GIR_EraseRootFromParent_Done,
     /* 503555 */   // Label 6749: @503555
     /* 503555 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(503690), // Rule ID 12530 //
     /* 503560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503644 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503688 */     GIR_RootConstrainSelectedInstOperands,
     /* 503689 */     // GIR_Coverage, 12530,
     /* 503689 */     GIR_EraseRootFromParent_Done,
     /* 503690 */   // Label 6750: @503690
     /* 503690 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(503825), // Rule ID 13007 //
     /* 503695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503779 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503823 */     GIR_RootConstrainSelectedInstOperands,
     /* 503824 */     // GIR_Coverage, 13007,
     /* 503824 */     GIR_EraseRootFromParent_Done,
     /* 503825 */   // Label 6751: @503825
     /* 503825 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(503960), // Rule ID 13008 //
     /* 503830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503914 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503958 */     GIR_RootConstrainSelectedInstOperands,
     /* 503959 */     // GIR_Coverage, 13008,
     /* 503959 */     GIR_EraseRootFromParent_Done,
     /* 503960 */   // Label 6752: @503960
     /* 503960 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(504095), // Rule ID 13009 //
     /* 503965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504049 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 504052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504093 */     GIR_RootConstrainSelectedInstOperands,
     /* 504094 */     // GIR_Coverage, 13009,
     /* 504094 */     GIR_EraseRootFromParent_Done,
     /* 504095 */   // Label 6753: @504095
     /* 504095 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(504230), // Rule ID 13010 //
     /* 504100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 504103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 504131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504184 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 504187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504228 */     GIR_RootConstrainSelectedInstOperands,
     /* 504229 */     // GIR_Coverage, 13010,
     /* 504229 */     GIR_EraseRootFromParent_Done,
     /* 504230 */   // Label 6754: @504230
     /* 504230 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(504345), // Rule ID 13273 //
     /* 504235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504270 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504272 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504299 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504343 */     GIR_RootConstrainSelectedInstOperands,
     /* 504344 */     // GIR_Coverage, 13273,
     /* 504344 */     GIR_EraseRootFromParent_Done,
     /* 504345 */   // Label 6755: @504345
     /* 504345 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(504460), // Rule ID 13289 //
     /* 504350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504385 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504387 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504414 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504458 */     GIR_RootConstrainSelectedInstOperands,
     /* 504459 */     // GIR_Coverage, 13289,
     /* 504459 */     GIR_EraseRootFromParent_Done,
     /* 504460 */   // Label 6756: @504460
     /* 504460 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(504575), // Rule ID 13272 //
     /* 504465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504500 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504502 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504529 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504573 */     GIR_RootConstrainSelectedInstOperands,
     /* 504574 */     // GIR_Coverage, 13272,
     /* 504574 */     GIR_EraseRootFromParent_Done,
     /* 504575 */   // Label 6757: @504575
     /* 504575 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(504690), // Rule ID 13288 //
     /* 504580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504615 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504617 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504644 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504688 */     GIR_RootConstrainSelectedInstOperands,
     /* 504689 */     // GIR_Coverage, 13288,
     /* 504689 */     GIR_EraseRootFromParent_Done,
     /* 504690 */   // Label 6758: @504690
     /* 504690 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(504805), // Rule ID 7747 //
     /* 504695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504730 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504732 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504759 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504803 */     GIR_RootConstrainSelectedInstOperands,
     /* 504804 */     // GIR_Coverage, 7747,
     /* 504804 */     GIR_EraseRootFromParent_Done,
     /* 504805 */   // Label 6759: @504805
     /* 504805 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(504920), // Rule ID 7763 //
     /* 504810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504845 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504847 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504874 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504918 */     GIR_RootConstrainSelectedInstOperands,
     /* 504919 */     // GIR_Coverage, 7763,
     /* 504919 */     GIR_EraseRootFromParent_Done,
     /* 504920 */   // Label 6760: @504920
     /* 504920 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(505035), // Rule ID 7746 //
     /* 504925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504960 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504962 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 504966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504989 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505033 */     GIR_RootConstrainSelectedInstOperands,
     /* 505034 */     // GIR_Coverage, 7746,
     /* 505034 */     GIR_EraseRootFromParent_Done,
     /* 505035 */   // Label 6761: @505035
     /* 505035 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(505150), // Rule ID 7762 //
     /* 505040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 505055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505075 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 505077 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 505081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 505083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505104 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505148 */     GIR_RootConstrainSelectedInstOperands,
     /* 505149 */     // GIR_Coverage, 7762,
     /* 505149 */     GIR_EraseRootFromParent_Done,
     /* 505150 */   // Label 6762: @505150
     /* 505150 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(505249), // Rule ID 13265 //
     /* 505155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505178 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505203 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505247 */     GIR_RootConstrainSelectedInstOperands,
     /* 505248 */     // GIR_Coverage, 13265,
     /* 505248 */     GIR_EraseRootFromParent_Done,
     /* 505249 */   // Label 6763: @505249
     /* 505249 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(505348), // Rule ID 13281 //
     /* 505254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505277 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505302 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505346 */     GIR_RootConstrainSelectedInstOperands,
     /* 505347 */     // GIR_Coverage, 13281,
     /* 505347 */     GIR_EraseRootFromParent_Done,
     /* 505348 */   // Label 6764: @505348
     /* 505348 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(505447), // Rule ID 13264 //
     /* 505353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505376 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505401 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505445 */     GIR_RootConstrainSelectedInstOperands,
     /* 505446 */     // GIR_Coverage, 13264,
     /* 505446 */     GIR_EraseRootFromParent_Done,
     /* 505447 */   // Label 6765: @505447
     /* 505447 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(505546), // Rule ID 13280 //
     /* 505452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505475 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505500 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505544 */     GIR_RootConstrainSelectedInstOperands,
     /* 505545 */     // GIR_Coverage, 13280,
     /* 505545 */     GIR_EraseRootFromParent_Done,
     /* 505546 */   // Label 6766: @505546
     /* 505546 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(505645), // Rule ID 7739 //
     /* 505551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505574 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505599 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505643 */     GIR_RootConstrainSelectedInstOperands,
     /* 505644 */     // GIR_Coverage, 7739,
     /* 505644 */     GIR_EraseRootFromParent_Done,
     /* 505645 */   // Label 6767: @505645
     /* 505645 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(505744), // Rule ID 7755 //
     /* 505650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505673 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505698 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505742 */     GIR_RootConstrainSelectedInstOperands,
     /* 505743 */     // GIR_Coverage, 7755,
     /* 505743 */     GIR_EraseRootFromParent_Done,
     /* 505744 */   // Label 6768: @505744
     /* 505744 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(505843), // Rule ID 7738 //
     /* 505749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505772 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505797 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505841 */     GIR_RootConstrainSelectedInstOperands,
     /* 505842 */     // GIR_Coverage, 7738,
     /* 505842 */     GIR_EraseRootFromParent_Done,
     /* 505843 */   // Label 6769: @505843
     /* 505843 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(505942), // Rule ID 7754 //
     /* 505848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505871 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505896 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505940 */     GIR_RootConstrainSelectedInstOperands,
     /* 505941 */     // GIR_Coverage, 7754,
     /* 505941 */     GIR_EraseRootFromParent_Done,
     /* 505942 */   // Label 6770: @505942
     /* 505942 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(505977), // Rule ID 100 //
     /* 505947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 505950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13765),
     /* 505966 */     // (fminnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13765>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 505966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 505971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 505975 */     GIR_RootConstrainSelectedInstOperands,
     /* 505976 */     // GIR_Coverage, 100,
     /* 505976 */     GIR_Done,
     /* 505977 */   // Label 6771: @505977
     /* 505977 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(506040), // Rule ID 885 //
     /* 505982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 505985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 505996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506003 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 506003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 506006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 506013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 506023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 506033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 506038 */     GIR_RootConstrainSelectedInstOperands,
     /* 506039 */     // GIR_Coverage, 885,
     /* 506039 */     GIR_EraseRootFromParent_Done,
     /* 506040 */   // Label 6772: @506040
     /* 506040 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(506103), // Rule ID 889 //
     /* 506045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 506048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 506059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506066 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 506066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 506069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 506076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 506086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 506096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 506101 */     GIR_RootConstrainSelectedInstOperands,
     /* 506102 */     // GIR_Coverage, 889,
     /* 506102 */     GIR_EraseRootFromParent_Done,
     /* 506103 */   // Label 6773: @506103
     /* 506103 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(506166), // Rule ID 8441 //
     /* 506108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 506111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 506129 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 506129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 506132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 506139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 506149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 506159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 506164 */     GIR_RootConstrainSelectedInstOperands,
     /* 506165 */     // GIR_Coverage, 8441,
     /* 506165 */     GIR_EraseRootFromParent_Done,
     /* 506166 */   // Label 6774: @506166
     /* 506166 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(506229), // Rule ID 8443 //
     /* 506171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 506174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 506192 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 506192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 506195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 506202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 506212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 506222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 506227 */     GIR_RootConstrainSelectedInstOperands,
     /* 506228 */     // GIR_Coverage, 8443,
     /* 506228 */     GIR_EraseRootFromParent_Done,
     /* 506229 */   // Label 6775: @506229
     /* 506229 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(506291), // Rule ID 887 //
     /* 506234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 506237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 506241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 506248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 506255 */     // (fminnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 506255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 506258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 506265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 506275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506289 */     GIR_RootConstrainSelectedInstOperands,
     /* 506290 */     // GIR_Coverage, 887,
     /* 506290 */     GIR_EraseRootFromParent_Done,
     /* 506291 */   // Label 6776: @506291
     /* 506291 */   GIM_Reject,
     /* 506292 */ // Label 6370: @506292
     /* 506292 */ GIM_Reject,
     /* 506293 */ // Label 6366: @506293
     /* 506293 */ GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(523804),
     /* 506298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 506301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 506304 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(506433), // Rule ID 11636 //
     /* 506309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506390 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506431 */     GIR_RootConstrainSelectedInstOperands,
     /* 506432 */     // GIR_Coverage, 11636,
     /* 506432 */     GIR_EraseRootFromParent_Done,
     /* 506433 */   // Label 6778: @506433
     /* 506433 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(506562), // Rule ID 11637 //
     /* 506438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506482 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506487 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506519 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506560 */     GIR_RootConstrainSelectedInstOperands,
     /* 506561 */     // GIR_Coverage, 11637,
     /* 506561 */     GIR_EraseRootFromParent_Done,
     /* 506562 */   // Label 6779: @506562
     /* 506562 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(506691), // Rule ID 11640 //
     /* 506567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506648 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506689 */     GIR_RootConstrainSelectedInstOperands,
     /* 506690 */     // GIR_Coverage, 11640,
     /* 506690 */     GIR_EraseRootFromParent_Done,
     /* 506691 */   // Label 6780: @506691
     /* 506691 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(506820), // Rule ID 11641 //
     /* 506696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506740 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506745 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506777 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506818 */     GIR_RootConstrainSelectedInstOperands,
     /* 506819 */     // GIR_Coverage, 11641,
     /* 506819 */     GIR_EraseRootFromParent_Done,
     /* 506820 */   // Label 6781: @506820
     /* 506820 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(506949), // Rule ID 11621 //
     /* 506825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506906 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506947 */     GIR_RootConstrainSelectedInstOperands,
     /* 506948 */     // GIR_Coverage, 11621,
     /* 506948 */     GIR_EraseRootFromParent_Done,
     /* 506949 */   // Label 6782: @506949
     /* 506949 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(507078), // Rule ID 11622 //
     /* 506954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507035 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507076 */     GIR_RootConstrainSelectedInstOperands,
     /* 507077 */     // GIR_Coverage, 11622,
     /* 507077 */     GIR_EraseRootFromParent_Done,
     /* 507078 */   // Label 6783: @507078
     /* 507078 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(507207), // Rule ID 11625 //
     /* 507083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 507123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507127 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507132 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507164 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507205 */     GIR_RootConstrainSelectedInstOperands,
     /* 507206 */     // GIR_Coverage, 11625,
     /* 507206 */     GIR_EraseRootFromParent_Done,
     /* 507207 */   // Label 6784: @507207
     /* 507207 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(507336), // Rule ID 11626 //
     /* 507212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 507252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507293 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507334 */     GIR_RootConstrainSelectedInstOperands,
     /* 507335 */     // GIR_Coverage, 11626,
     /* 507335 */     GIR_EraseRootFromParent_Done,
     /* 507336 */   // Label 6785: @507336
     /* 507336 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(507465), // Rule ID 7607 //
     /* 507341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507385 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507390 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507422 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507463 */     GIR_RootConstrainSelectedInstOperands,
     /* 507464 */     // GIR_Coverage, 7607,
     /* 507464 */     GIR_EraseRootFromParent_Done,
     /* 507465 */   // Label 6786: @507465
     /* 507465 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(507594), // Rule ID 11635 //
     /* 507470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507551 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507592 */     GIR_RootConstrainSelectedInstOperands,
     /* 507593 */     // GIR_Coverage, 11635,
     /* 507593 */     GIR_EraseRootFromParent_Done,
     /* 507594 */   // Label 6787: @507594
     /* 507594 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(507723), // Rule ID 11638 //
     /* 507599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507643 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507680 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507721 */     GIR_RootConstrainSelectedInstOperands,
     /* 507722 */     // GIR_Coverage, 11638,
     /* 507722 */     GIR_EraseRootFromParent_Done,
     /* 507723 */   // Label 6788: @507723
     /* 507723 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(507852), // Rule ID 11639 //
     /* 507728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507772 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507777 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507809 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507850 */     GIR_RootConstrainSelectedInstOperands,
     /* 507851 */     // GIR_Coverage, 11639,
     /* 507851 */     GIR_EraseRootFromParent_Done,
     /* 507852 */   // Label 6789: @507852
     /* 507852 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(507981), // Rule ID 7606 //
     /* 507857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507938 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507979 */     GIR_RootConstrainSelectedInstOperands,
     /* 507980 */     // GIR_Coverage, 7606,
     /* 507980 */     GIR_EraseRootFromParent_Done,
     /* 507981 */   // Label 6790: @507981
     /* 507981 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(508110), // Rule ID 11620 //
     /* 507986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 508026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508030 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508035 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508067 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508108 */     GIR_RootConstrainSelectedInstOperands,
     /* 508109 */     // GIR_Coverage, 11620,
     /* 508109 */     GIR_EraseRootFromParent_Done,
     /* 508110 */   // Label 6791: @508110
     /* 508110 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(508239), // Rule ID 11623 //
     /* 508115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 508155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508196 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508237 */     GIR_RootConstrainSelectedInstOperands,
     /* 508238 */     // GIR_Coverage, 11623,
     /* 508238 */     GIR_EraseRootFromParent_Done,
     /* 508239 */   // Label 6792: @508239
     /* 508239 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(508368), // Rule ID 11624 //
     /* 508244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 508284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508325 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508366 */     GIR_RootConstrainSelectedInstOperands,
     /* 508367 */     // GIR_Coverage, 11624,
     /* 508367 */     GIR_EraseRootFromParent_Done,
     /* 508368 */   // Label 6793: @508368
     /* 508368 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(508497), // Rule ID 11606 //
     /* 508373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508417 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508422 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508454 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508495 */     GIR_RootConstrainSelectedInstOperands,
     /* 508496 */     // GIR_Coverage, 11606,
     /* 508496 */     GIR_EraseRootFromParent_Done,
     /* 508497 */   // Label 6794: @508497
     /* 508497 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(508626), // Rule ID 11607 //
     /* 508502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508583 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508624 */     GIR_RootConstrainSelectedInstOperands,
     /* 508625 */     // GIR_Coverage, 11607,
     /* 508625 */     GIR_EraseRootFromParent_Done,
     /* 508626 */   // Label 6795: @508626
     /* 508626 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(508755), // Rule ID 11610 //
     /* 508631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508675 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508680 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508712 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508753 */     GIR_RootConstrainSelectedInstOperands,
     /* 508754 */     // GIR_Coverage, 11610,
     /* 508754 */     GIR_EraseRootFromParent_Done,
     /* 508755 */   // Label 6796: @508755
     /* 508755 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(508884), // Rule ID 11611 //
     /* 508760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508841 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508882 */     GIR_RootConstrainSelectedInstOperands,
     /* 508883 */     // GIR_Coverage, 11611,
     /* 508883 */     GIR_EraseRootFromParent_Done,
     /* 508884 */   // Label 6797: @508884
     /* 508884 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(509013), // Rule ID 11591 //
     /* 508889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508970 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509011 */     GIR_RootConstrainSelectedInstOperands,
     /* 509012 */     // GIR_Coverage, 11591,
     /* 509012 */     GIR_EraseRootFromParent_Done,
     /* 509013 */   // Label 6798: @509013
     /* 509013 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(509142), // Rule ID 11592 //
     /* 509018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 509058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509062 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509067 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509099 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509140 */     GIR_RootConstrainSelectedInstOperands,
     /* 509141 */     // GIR_Coverage, 11592,
     /* 509141 */     GIR_EraseRootFromParent_Done,
     /* 509142 */   // Label 6799: @509142
     /* 509142 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(509271), // Rule ID 11595 //
     /* 509147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 509187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509228 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509269 */     GIR_RootConstrainSelectedInstOperands,
     /* 509270 */     // GIR_Coverage, 11595,
     /* 509270 */     GIR_EraseRootFromParent_Done,
     /* 509271 */   // Label 6800: @509271
     /* 509271 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(509400), // Rule ID 11596 //
     /* 509276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 509316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509320 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509325 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509357 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509398 */     GIR_RootConstrainSelectedInstOperands,
     /* 509399 */     // GIR_Coverage, 11596,
     /* 509399 */     GIR_EraseRootFromParent_Done,
     /* 509400 */   // Label 6801: @509400
     /* 509400 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(509529), // Rule ID 7605 //
     /* 509405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509486 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509527 */     GIR_RootConstrainSelectedInstOperands,
     /* 509528 */     // GIR_Coverage, 7605,
     /* 509528 */     GIR_EraseRootFromParent_Done,
     /* 509529 */   // Label 6802: @509529
     /* 509529 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(509658), // Rule ID 11605 //
     /* 509534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509578 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509583 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509615 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509656 */     GIR_RootConstrainSelectedInstOperands,
     /* 509657 */     // GIR_Coverage, 11605,
     /* 509657 */     GIR_EraseRootFromParent_Done,
     /* 509658 */   // Label 6803: @509658
     /* 509658 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(509787), // Rule ID 11608 //
     /* 509663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509707 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509712 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509744 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509785 */     GIR_RootConstrainSelectedInstOperands,
     /* 509786 */     // GIR_Coverage, 11608,
     /* 509786 */     GIR_EraseRootFromParent_Done,
     /* 509787 */   // Label 6804: @509787
     /* 509787 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(509916), // Rule ID 11609 //
     /* 509792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509873 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509914 */     GIR_RootConstrainSelectedInstOperands,
     /* 509915 */     // GIR_Coverage, 11609,
     /* 509915 */     GIR_EraseRootFromParent_Done,
     /* 509916 */   // Label 6805: @509916
     /* 509916 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(510045), // Rule ID 7604 //
     /* 509921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509965 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509970 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510002 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 510012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510043 */     GIR_RootConstrainSelectedInstOperands,
     /* 510044 */     // GIR_Coverage, 7604,
     /* 510044 */     GIR_EraseRootFromParent_Done,
     /* 510045 */   // Label 6806: @510045
     /* 510045 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(510174), // Rule ID 11590 //
     /* 510050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 510090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 510094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510131 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 510141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510172 */     GIR_RootConstrainSelectedInstOperands,
     /* 510173 */     // GIR_Coverage, 11590,
     /* 510173 */     GIR_EraseRootFromParent_Done,
     /* 510174 */   // Label 6807: @510174
     /* 510174 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(510303), // Rule ID 11593 //
     /* 510179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 510219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 510223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510260 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 510280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510301 */     GIR_RootConstrainSelectedInstOperands,
     /* 510302 */     // GIR_Coverage, 11593,
     /* 510302 */     GIR_EraseRootFromParent_Done,
     /* 510303 */   // Label 6808: @510303
     /* 510303 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(510432), // Rule ID 11594 //
     /* 510308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 510348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 510352 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510357 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510389 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 510409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510430 */     GIR_RootConstrainSelectedInstOperands,
     /* 510431 */     // GIR_Coverage, 11594,
     /* 510431 */     GIR_EraseRootFromParent_Done,
     /* 510432 */   // Label 6809: @510432
     /* 510432 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(510561), // Rule ID 11646 //
     /* 510437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510518 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510559 */     GIR_RootConstrainSelectedInstOperands,
     /* 510560 */     // GIR_Coverage, 11646,
     /* 510560 */     GIR_EraseRootFromParent_Done,
     /* 510561 */   // Label 6810: @510561
     /* 510561 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(510690), // Rule ID 11647 //
     /* 510566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510610 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510615 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510647 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510688 */     GIR_RootConstrainSelectedInstOperands,
     /* 510689 */     // GIR_Coverage, 11647,
     /* 510689 */     GIR_EraseRootFromParent_Done,
     /* 510690 */   // Label 6811: @510690
     /* 510690 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(510819), // Rule ID 11648 //
     /* 510695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510776 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 510786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 510791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510817 */     GIR_RootConstrainSelectedInstOperands,
     /* 510818 */     // GIR_Coverage, 11648,
     /* 510818 */     GIR_EraseRootFromParent_Done,
     /* 510819 */   // Label 6812: @510819
     /* 510819 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(510948), // Rule ID 11649 //
     /* 510824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510905 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 510915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 510920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510946 */     GIR_RootConstrainSelectedInstOperands,
     /* 510947 */     // GIR_Coverage, 11649,
     /* 510947 */     GIR_EraseRootFromParent_Done,
     /* 510948 */   // Label 6813: @510948
     /* 510948 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(511077), // Rule ID 11586 //
     /* 510953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510997 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511002 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511034 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511075 */     GIR_RootConstrainSelectedInstOperands,
     /* 511076 */     // GIR_Coverage, 11586,
     /* 511076 */     GIR_EraseRootFromParent_Done,
     /* 511077 */   // Label 6814: @511077
     /* 511077 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(511206), // Rule ID 11587 //
     /* 511082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511163 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511204 */     GIR_RootConstrainSelectedInstOperands,
     /* 511205 */     // GIR_Coverage, 11587,
     /* 511205 */     GIR_EraseRootFromParent_Done,
     /* 511206 */   // Label 6815: @511206
     /* 511206 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(511335), // Rule ID 11588 //
     /* 511211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511255 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511260 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511292 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511333 */     GIR_RootConstrainSelectedInstOperands,
     /* 511334 */     // GIR_Coverage, 11588,
     /* 511334 */     GIR_EraseRootFromParent_Done,
     /* 511335 */   // Label 6816: @511335
     /* 511335 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(511464), // Rule ID 11589 //
     /* 511340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511421 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511462 */     GIR_RootConstrainSelectedInstOperands,
     /* 511463 */     // GIR_Coverage, 11589,
     /* 511463 */     GIR_EraseRootFromParent_Done,
     /* 511464 */   // Label 6817: @511464
     /* 511464 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(511593), // Rule ID 11631 //
     /* 511469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511550 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511591 */     GIR_RootConstrainSelectedInstOperands,
     /* 511592 */     // GIR_Coverage, 11631,
     /* 511592 */     GIR_EraseRootFromParent_Done,
     /* 511593 */   // Label 6818: @511593
     /* 511593 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(511722), // Rule ID 11632 //
     /* 511598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511642 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511647 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511679 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511720 */     GIR_RootConstrainSelectedInstOperands,
     /* 511721 */     // GIR_Coverage, 11632,
     /* 511721 */     GIR_EraseRootFromParent_Done,
     /* 511722 */   // Label 6819: @511722
     /* 511722 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(511851), // Rule ID 11633 //
     /* 511727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511808 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511849 */     GIR_RootConstrainSelectedInstOperands,
     /* 511850 */     // GIR_Coverage, 11633,
     /* 511850 */     GIR_EraseRootFromParent_Done,
     /* 511851 */   // Label 6820: @511851
     /* 511851 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(511980), // Rule ID 11634 //
     /* 511856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511900 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511905 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511937 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511978 */     GIR_RootConstrainSelectedInstOperands,
     /* 511979 */     // GIR_Coverage, 11634,
     /* 511979 */     GIR_EraseRootFromParent_Done,
     /* 511980 */   // Label 6821: @511980
     /* 511980 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(512109), // Rule ID 11571 //
     /* 511985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 512009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512066 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 512086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 512091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512107 */     GIR_RootConstrainSelectedInstOperands,
     /* 512108 */     // GIR_Coverage, 11571,
     /* 512108 */     GIR_EraseRootFromParent_Done,
     /* 512109 */   // Label 6822: @512109
     /* 512109 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(512238), // Rule ID 11572 //
     /* 512114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 512138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512195 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 512215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 512220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512236 */     GIR_RootConstrainSelectedInstOperands,
     /* 512237 */     // GIR_Coverage, 11572,
     /* 512237 */     GIR_EraseRootFromParent_Done,
     /* 512238 */   // Label 6823: @512238
     /* 512238 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(512367), // Rule ID 11573 //
     /* 512243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 512267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512287 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512292 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512324 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 512334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 512339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512365 */     GIR_RootConstrainSelectedInstOperands,
     /* 512366 */     // GIR_Coverage, 11573,
     /* 512366 */     GIR_EraseRootFromParent_Done,
     /* 512367 */   // Label 6824: @512367
     /* 512367 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(512496), // Rule ID 11574 //
     /* 512372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 512396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512453 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 512463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 512468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512494 */     GIR_RootConstrainSelectedInstOperands,
     /* 512495 */     // GIR_Coverage, 11574,
     /* 512495 */     GIR_EraseRootFromParent_Done,
     /* 512496 */   // Label 6825: @512496
     /* 512496 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(512625), // Rule ID 11642 //
     /* 512501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512545 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512550 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512582 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512623 */     GIR_RootConstrainSelectedInstOperands,
     /* 512624 */     // GIR_Coverage, 11642,
     /* 512624 */     GIR_EraseRootFromParent_Done,
     /* 512625 */   // Label 6826: @512625
     /* 512625 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(512754), // Rule ID 11643 //
     /* 512630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512711 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512752 */     GIR_RootConstrainSelectedInstOperands,
     /* 512753 */     // GIR_Coverage, 11643,
     /* 512753 */     GIR_EraseRootFromParent_Done,
     /* 512754 */   // Label 6827: @512754
     /* 512754 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(512883), // Rule ID 11644 //
     /* 512759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512840 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512881 */     GIR_RootConstrainSelectedInstOperands,
     /* 512882 */     // GIR_Coverage, 11644,
     /* 512882 */     GIR_EraseRootFromParent_Done,
     /* 512883 */   // Label 6828: @512883
     /* 512883 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(513012), // Rule ID 11645 //
     /* 512888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512932 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512937 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512969 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513010 */     GIR_RootConstrainSelectedInstOperands,
     /* 513011 */     // GIR_Coverage, 11645,
     /* 513011 */     GIR_EraseRootFromParent_Done,
     /* 513012 */   // Label 6829: @513012
     /* 513012 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(513141), // Rule ID 11582 //
     /* 513017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513098 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513139 */     GIR_RootConstrainSelectedInstOperands,
     /* 513140 */     // GIR_Coverage, 11582,
     /* 513140 */     GIR_EraseRootFromParent_Done,
     /* 513141 */   // Label 6830: @513141
     /* 513141 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(513270), // Rule ID 11583 //
     /* 513146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513190 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513195 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513227 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513268 */     GIR_RootConstrainSelectedInstOperands,
     /* 513269 */     // GIR_Coverage, 11583,
     /* 513269 */     GIR_EraseRootFromParent_Done,
     /* 513270 */   // Label 6831: @513270
     /* 513270 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(513399), // Rule ID 11584 //
     /* 513275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513356 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513397 */     GIR_RootConstrainSelectedInstOperands,
     /* 513398 */     // GIR_Coverage, 11584,
     /* 513398 */     GIR_EraseRootFromParent_Done,
     /* 513399 */   // Label 6832: @513399
     /* 513399 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(513528), // Rule ID 11585 //
     /* 513404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513485 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513526 */     GIR_RootConstrainSelectedInstOperands,
     /* 513527 */     // GIR_Coverage, 11585,
     /* 513527 */     GIR_EraseRootFromParent_Done,
     /* 513528 */   // Label 6833: @513528
     /* 513528 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(513657), // Rule ID 11627 //
     /* 513533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513577 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513582 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513614 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513655 */     GIR_RootConstrainSelectedInstOperands,
     /* 513656 */     // GIR_Coverage, 11627,
     /* 513656 */     GIR_EraseRootFromParent_Done,
     /* 513657 */   // Label 6834: @513657
     /* 513657 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(513786), // Rule ID 11628 //
     /* 513662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513743 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513784 */     GIR_RootConstrainSelectedInstOperands,
     /* 513785 */     // GIR_Coverage, 11628,
     /* 513785 */     GIR_EraseRootFromParent_Done,
     /* 513786 */   // Label 6835: @513786
     /* 513786 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(513915), // Rule ID 11629 //
     /* 513791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513835 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513840 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513872 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513913 */     GIR_RootConstrainSelectedInstOperands,
     /* 513914 */     // GIR_Coverage, 11629,
     /* 513914 */     GIR_EraseRootFromParent_Done,
     /* 513915 */   // Label 6836: @513915
     /* 513915 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(514044), // Rule ID 11630 //
     /* 513920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514001 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514042 */     GIR_RootConstrainSelectedInstOperands,
     /* 514043 */     // GIR_Coverage, 11630,
     /* 514043 */     GIR_EraseRootFromParent_Done,
     /* 514044 */   // Label 6837: @514044
     /* 514044 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(514173), // Rule ID 11567 //
     /* 514049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514130 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514171 */     GIR_RootConstrainSelectedInstOperands,
     /* 514172 */     // GIR_Coverage, 11567,
     /* 514172 */     GIR_EraseRootFromParent_Done,
     /* 514173 */   // Label 6838: @514173
     /* 514173 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(514302), // Rule ID 11568 //
     /* 514178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514222 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514227 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514259 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514300 */     GIR_RootConstrainSelectedInstOperands,
     /* 514301 */     // GIR_Coverage, 11568,
     /* 514301 */     GIR_EraseRootFromParent_Done,
     /* 514302 */   // Label 6839: @514302
     /* 514302 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(514431), // Rule ID 11569 //
     /* 514307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514388 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514429 */     GIR_RootConstrainSelectedInstOperands,
     /* 514430 */     // GIR_Coverage, 11569,
     /* 514430 */     GIR_EraseRootFromParent_Done,
     /* 514431 */   // Label 6840: @514431
     /* 514431 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(514560), // Rule ID 11570 //
     /* 514436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514480 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514485 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514517 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514558 */     GIR_RootConstrainSelectedInstOperands,
     /* 514559 */     // GIR_Coverage, 11570,
     /* 514559 */     GIR_EraseRootFromParent_Done,
     /* 514560 */   // Label 6841: @514560
     /* 514560 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(514689), // Rule ID 11576 //
     /* 514565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514646 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514687 */     GIR_RootConstrainSelectedInstOperands,
     /* 514688 */     // GIR_Coverage, 11576,
     /* 514688 */     GIR_EraseRootFromParent_Done,
     /* 514689 */   // Label 6842: @514689
     /* 514689 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(514818), // Rule ID 11577 //
     /* 514694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514775 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514816 */     GIR_RootConstrainSelectedInstOperands,
     /* 514817 */     // GIR_Coverage, 11577,
     /* 514817 */     GIR_EraseRootFromParent_Done,
     /* 514818 */   // Label 6843: @514818
     /* 514818 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(514947), // Rule ID 11580 //
     /* 514823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514867 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514872 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514904 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514945 */     GIR_RootConstrainSelectedInstOperands,
     /* 514946 */     // GIR_Coverage, 11580,
     /* 514946 */     GIR_EraseRootFromParent_Done,
     /* 514947 */   // Label 6844: @514947
     /* 514947 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(515076), // Rule ID 11581 //
     /* 514952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515033 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515074 */     GIR_RootConstrainSelectedInstOperands,
     /* 515075 */     // GIR_Coverage, 11581,
     /* 515075 */     GIR_EraseRootFromParent_Done,
     /* 515076 */   // Label 6845: @515076
     /* 515076 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(515205), // Rule ID 11561 //
     /* 515081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515125 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515130 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515162 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515203 */     GIR_RootConstrainSelectedInstOperands,
     /* 515204 */     // GIR_Coverage, 11561,
     /* 515204 */     GIR_EraseRootFromParent_Done,
     /* 515205 */   // Label 6846: @515205
     /* 515205 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(515334), // Rule ID 11562 //
     /* 515210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515291 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515332 */     GIR_RootConstrainSelectedInstOperands,
     /* 515333 */     // GIR_Coverage, 11562,
     /* 515333 */     GIR_EraseRootFromParent_Done,
     /* 515334 */   // Label 6847: @515334
     /* 515334 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(515463), // Rule ID 11565 //
     /* 515339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515388 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515420 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515461 */     GIR_RootConstrainSelectedInstOperands,
     /* 515462 */     // GIR_Coverage, 11565,
     /* 515462 */     GIR_EraseRootFromParent_Done,
     /* 515463 */   // Label 6848: @515463
     /* 515463 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(515592), // Rule ID 11566 //
     /* 515468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515512 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515517 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515549 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515590 */     GIR_RootConstrainSelectedInstOperands,
     /* 515591 */     // GIR_Coverage, 11566,
     /* 515591 */     GIR_EraseRootFromParent_Done,
     /* 515592 */   // Label 6849: @515592
     /* 515592 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(515721), // Rule ID 7603 //
     /* 515597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515678 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515719 */     GIR_RootConstrainSelectedInstOperands,
     /* 515720 */     // GIR_Coverage, 7603,
     /* 515720 */     GIR_EraseRootFromParent_Done,
     /* 515721 */   // Label 6850: @515721
     /* 515721 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(515850), // Rule ID 11575 //
     /* 515726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515770 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515775 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515807 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515848 */     GIR_RootConstrainSelectedInstOperands,
     /* 515849 */     // GIR_Coverage, 11575,
     /* 515849 */     GIR_EraseRootFromParent_Done,
     /* 515850 */   // Label 6851: @515850
     /* 515850 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(515979), // Rule ID 11578 //
     /* 515855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515936 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515977 */     GIR_RootConstrainSelectedInstOperands,
     /* 515978 */     // GIR_Coverage, 11578,
     /* 515978 */     GIR_EraseRootFromParent_Done,
     /* 515979 */   // Label 6852: @515979
     /* 515979 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(516108), // Rule ID 11579 //
     /* 515984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516065 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516106 */     GIR_RootConstrainSelectedInstOperands,
     /* 516107 */     // GIR_Coverage, 11579,
     /* 516107 */     GIR_EraseRootFromParent_Done,
     /* 516108 */   // Label 6853: @516108
     /* 516108 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(516237), // Rule ID 7602 //
     /* 516113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516157 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516162 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516194 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516235 */     GIR_RootConstrainSelectedInstOperands,
     /* 516236 */     // GIR_Coverage, 7602,
     /* 516236 */     GIR_EraseRootFromParent_Done,
     /* 516237 */   // Label 6854: @516237
     /* 516237 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(516366), // Rule ID 11560 //
     /* 516242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516323 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516364 */     GIR_RootConstrainSelectedInstOperands,
     /* 516365 */     // GIR_Coverage, 11560,
     /* 516365 */     GIR_EraseRootFromParent_Done,
     /* 516366 */   // Label 6855: @516366
     /* 516366 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(516495), // Rule ID 11563 //
     /* 516371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516415 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516420 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516452 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516493 */     GIR_RootConstrainSelectedInstOperands,
     /* 516494 */     // GIR_Coverage, 11563,
     /* 516494 */     GIR_EraseRootFromParent_Done,
     /* 516495 */   // Label 6856: @516495
     /* 516495 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(516624), // Rule ID 11564 //
     /* 516500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516581 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516622 */     GIR_RootConstrainSelectedInstOperands,
     /* 516623 */     // GIR_Coverage, 11564,
     /* 516623 */     GIR_EraseRootFromParent_Done,
     /* 516624 */   // Label 6857: @516624
     /* 516624 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(516753), // Rule ID 11546 //
     /* 516629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516710 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516751 */     GIR_RootConstrainSelectedInstOperands,
     /* 516752 */     // GIR_Coverage, 11546,
     /* 516752 */     GIR_EraseRootFromParent_Done,
     /* 516753 */   // Label 6858: @516753
     /* 516753 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(516882), // Rule ID 11547 //
     /* 516758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516802 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516807 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516839 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516880 */     GIR_RootConstrainSelectedInstOperands,
     /* 516881 */     // GIR_Coverage, 11547,
     /* 516881 */     GIR_EraseRootFromParent_Done,
     /* 516882 */   // Label 6859: @516882
     /* 516882 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(517011), // Rule ID 11550 //
     /* 516887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516968 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517009 */     GIR_RootConstrainSelectedInstOperands,
     /* 517010 */     // GIR_Coverage, 11550,
     /* 517010 */     GIR_EraseRootFromParent_Done,
     /* 517011 */   // Label 6860: @517011
     /* 517011 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(517140), // Rule ID 11551 //
     /* 517016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517060 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517065 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517097 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517138 */     GIR_RootConstrainSelectedInstOperands,
     /* 517139 */     // GIR_Coverage, 11551,
     /* 517139 */     GIR_EraseRootFromParent_Done,
     /* 517140 */   // Label 6861: @517140
     /* 517140 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(517269), // Rule ID 11531 //
     /* 517145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517226 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517267 */     GIR_RootConstrainSelectedInstOperands,
     /* 517268 */     // GIR_Coverage, 11531,
     /* 517268 */     GIR_EraseRootFromParent_Done,
     /* 517269 */   // Label 6862: @517269
     /* 517269 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(517398), // Rule ID 11532 //
     /* 517274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517355 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517396 */     GIR_RootConstrainSelectedInstOperands,
     /* 517397 */     // GIR_Coverage, 11532,
     /* 517397 */     GIR_EraseRootFromParent_Done,
     /* 517398 */   // Label 6863: @517398
     /* 517398 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(517527), // Rule ID 11535 //
     /* 517403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517447 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517452 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517484 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517525 */     GIR_RootConstrainSelectedInstOperands,
     /* 517526 */     // GIR_Coverage, 11535,
     /* 517526 */     GIR_EraseRootFromParent_Done,
     /* 517527 */   // Label 6864: @517527
     /* 517527 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(517656), // Rule ID 11536 //
     /* 517532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517613 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517654 */     GIR_RootConstrainSelectedInstOperands,
     /* 517655 */     // GIR_Coverage, 11536,
     /* 517655 */     GIR_EraseRootFromParent_Done,
     /* 517656 */   // Label 6865: @517656
     /* 517656 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(517785), // Rule ID 7601 //
     /* 517661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517705 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517710 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517742 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517783 */     GIR_RootConstrainSelectedInstOperands,
     /* 517784 */     // GIR_Coverage, 7601,
     /* 517784 */     GIR_EraseRootFromParent_Done,
     /* 517785 */   // Label 6866: @517785
     /* 517785 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(517914), // Rule ID 11545 //
     /* 517790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517871 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517912 */     GIR_RootConstrainSelectedInstOperands,
     /* 517913 */     // GIR_Coverage, 11545,
     /* 517913 */     GIR_EraseRootFromParent_Done,
     /* 517914 */   // Label 6867: @517914
     /* 517914 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(518043), // Rule ID 11548 //
     /* 517919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518000 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518041 */     GIR_RootConstrainSelectedInstOperands,
     /* 518042 */     // GIR_Coverage, 11548,
     /* 518042 */     GIR_EraseRootFromParent_Done,
     /* 518043 */   // Label 6868: @518043
     /* 518043 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(518172), // Rule ID 11549 //
     /* 518048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518092 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518097 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518129 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518170 */     GIR_RootConstrainSelectedInstOperands,
     /* 518171 */     // GIR_Coverage, 11549,
     /* 518171 */     GIR_EraseRootFromParent_Done,
     /* 518172 */   // Label 6869: @518172
     /* 518172 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(518301), // Rule ID 7600 //
     /* 518177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518258 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518299 */     GIR_RootConstrainSelectedInstOperands,
     /* 518300 */     // GIR_Coverage, 7600,
     /* 518300 */     GIR_EraseRootFromParent_Done,
     /* 518301 */   // Label 6870: @518301
     /* 518301 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(518430), // Rule ID 11530 //
     /* 518306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518350 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518355 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518387 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518428 */     GIR_RootConstrainSelectedInstOperands,
     /* 518429 */     // GIR_Coverage, 11530,
     /* 518429 */     GIR_EraseRootFromParent_Done,
     /* 518430 */   // Label 6871: @518430
     /* 518430 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(518559), // Rule ID 11533 //
     /* 518435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518516 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518557 */     GIR_RootConstrainSelectedInstOperands,
     /* 518558 */     // GIR_Coverage, 11533,
     /* 518558 */     GIR_EraseRootFromParent_Done,
     /* 518559 */   // Label 6872: @518559
     /* 518559 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(518688), // Rule ID 11534 //
     /* 518564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518645 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518686 */     GIR_RootConstrainSelectedInstOperands,
     /* 518687 */     // GIR_Coverage, 11534,
     /* 518687 */     GIR_EraseRootFromParent_Done,
     /* 518688 */   // Label 6873: @518688
     /* 518688 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(518817), // Rule ID 11616 //
     /* 518693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518742 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518774 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 518794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 518799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518815 */     GIR_RootConstrainSelectedInstOperands,
     /* 518816 */     // GIR_Coverage, 11616,
     /* 518816 */     GIR_EraseRootFromParent_Done,
     /* 518817 */   // Label 6874: @518817
     /* 518817 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(518946), // Rule ID 11617 //
     /* 518822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518903 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 518923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 518928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518944 */     GIR_RootConstrainSelectedInstOperands,
     /* 518945 */     // GIR_Coverage, 11617,
     /* 518945 */     GIR_EraseRootFromParent_Done,
     /* 518946 */   // Label 6875: @518946
     /* 518946 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(519075), // Rule ID 11618 //
     /* 518951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518995 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519000 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519032 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519073 */     GIR_RootConstrainSelectedInstOperands,
     /* 519074 */     // GIR_Coverage, 11618,
     /* 519074 */     GIR_EraseRootFromParent_Done,
     /* 519075 */   // Label 6876: @519075
     /* 519075 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(519204), // Rule ID 11619 //
     /* 519080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519161 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519202 */     GIR_RootConstrainSelectedInstOperands,
     /* 519203 */     // GIR_Coverage, 11619,
     /* 519203 */     GIR_EraseRootFromParent_Done,
     /* 519204 */   // Label 6877: @519204
     /* 519204 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(519333), // Rule ID 11556 //
     /* 519209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519258 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519290 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519331 */     GIR_RootConstrainSelectedInstOperands,
     /* 519332 */     // GIR_Coverage, 11556,
     /* 519332 */     GIR_EraseRootFromParent_Done,
     /* 519333 */   // Label 6878: @519333
     /* 519333 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(519462), // Rule ID 11557 //
     /* 519338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519382 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519387 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519419 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519460 */     GIR_RootConstrainSelectedInstOperands,
     /* 519461 */     // GIR_Coverage, 11557,
     /* 519461 */     GIR_EraseRootFromParent_Done,
     /* 519462 */   // Label 6879: @519462
     /* 519462 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(519591), // Rule ID 11558 //
     /* 519467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519548 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519589 */     GIR_RootConstrainSelectedInstOperands,
     /* 519590 */     // GIR_Coverage, 11558,
     /* 519590 */     GIR_EraseRootFromParent_Done,
     /* 519591 */   // Label 6880: @519591
     /* 519591 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(519720), // Rule ID 11559 //
     /* 519596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519640 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519645 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519677 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519718 */     GIR_RootConstrainSelectedInstOperands,
     /* 519719 */     // GIR_Coverage, 11559,
     /* 519719 */     GIR_EraseRootFromParent_Done,
     /* 519720 */   // Label 6881: @519720
     /* 519720 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(519849), // Rule ID 11601 //
     /* 519725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519806 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519847 */     GIR_RootConstrainSelectedInstOperands,
     /* 519848 */     // GIR_Coverage, 11601,
     /* 519848 */     GIR_EraseRootFromParent_Done,
     /* 519849 */   // Label 6882: @519849
     /* 519849 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(519978), // Rule ID 11602 //
     /* 519854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519935 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519976 */     GIR_RootConstrainSelectedInstOperands,
     /* 519977 */     // GIR_Coverage, 11602,
     /* 519977 */     GIR_EraseRootFromParent_Done,
     /* 519978 */   // Label 6883: @519978
     /* 519978 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(520107), // Rule ID 11603 //
     /* 519983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520027 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520032 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520064 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520105 */     GIR_RootConstrainSelectedInstOperands,
     /* 520106 */     // GIR_Coverage, 11603,
     /* 520106 */     GIR_EraseRootFromParent_Done,
     /* 520107 */   // Label 6884: @520107
     /* 520107 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(520236), // Rule ID 11604 //
     /* 520112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520193 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520234 */     GIR_RootConstrainSelectedInstOperands,
     /* 520235 */     // GIR_Coverage, 11604,
     /* 520235 */     GIR_EraseRootFromParent_Done,
     /* 520236 */   // Label 6885: @520236
     /* 520236 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(520365), // Rule ID 11541 //
     /* 520241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520285 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520290 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520322 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 520342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 520347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520363 */     GIR_RootConstrainSelectedInstOperands,
     /* 520364 */     // GIR_Coverage, 11541,
     /* 520364 */     GIR_EraseRootFromParent_Done,
     /* 520365 */   // Label 6886: @520365
     /* 520365 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(520494), // Rule ID 11542 //
     /* 520370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520451 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 520471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 520476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520492 */     GIR_RootConstrainSelectedInstOperands,
     /* 520493 */     // GIR_Coverage, 11542,
     /* 520493 */     GIR_EraseRootFromParent_Done,
     /* 520494 */   // Label 6887: @520494
     /* 520494 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(520623), // Rule ID 11543 //
     /* 520499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520580 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520621 */     GIR_RootConstrainSelectedInstOperands,
     /* 520622 */     // GIR_Coverage, 11543,
     /* 520622 */     GIR_EraseRootFromParent_Done,
     /* 520623 */   // Label 6888: @520623
     /* 520623 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(520752), // Rule ID 11544 //
     /* 520628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520672 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520677 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520709 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520750 */     GIR_RootConstrainSelectedInstOperands,
     /* 520751 */     // GIR_Coverage, 11544,
     /* 520751 */     GIR_EraseRootFromParent_Done,
     /* 520752 */   // Label 6889: @520752
     /* 520752 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(520881), // Rule ID 11612 //
     /* 520757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520838 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520879 */     GIR_RootConstrainSelectedInstOperands,
     /* 520880 */     // GIR_Coverage, 11612,
     /* 520880 */     GIR_EraseRootFromParent_Done,
     /* 520881 */   // Label 6890: @520881
     /* 520881 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(521010), // Rule ID 11613 //
     /* 520886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520930 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520935 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520967 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521008 */     GIR_RootConstrainSelectedInstOperands,
     /* 521009 */     // GIR_Coverage, 11613,
     /* 521009 */     GIR_EraseRootFromParent_Done,
     /* 521010 */   // Label 6891: @521010
     /* 521010 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(521139), // Rule ID 11614 //
     /* 521015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521096 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521137 */     GIR_RootConstrainSelectedInstOperands,
     /* 521138 */     // GIR_Coverage, 11614,
     /* 521138 */     GIR_EraseRootFromParent_Done,
     /* 521139 */   // Label 6892: @521139
     /* 521139 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(521268), // Rule ID 11615 //
     /* 521144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521225 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521266 */     GIR_RootConstrainSelectedInstOperands,
     /* 521267 */     // GIR_Coverage, 11615,
     /* 521267 */     GIR_EraseRootFromParent_Done,
     /* 521268 */   // Label 6893: @521268
     /* 521268 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(521397), // Rule ID 11552 //
     /* 521273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521317 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521322 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521354 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521395 */     GIR_RootConstrainSelectedInstOperands,
     /* 521396 */     // GIR_Coverage, 11552,
     /* 521396 */     GIR_EraseRootFromParent_Done,
     /* 521397 */   // Label 6894: @521397
     /* 521397 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(521526), // Rule ID 11553 //
     /* 521402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521483 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521524 */     GIR_RootConstrainSelectedInstOperands,
     /* 521525 */     // GIR_Coverage, 11553,
     /* 521525 */     GIR_EraseRootFromParent_Done,
     /* 521526 */   // Label 6895: @521526
     /* 521526 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(521655), // Rule ID 11554 //
     /* 521531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521575 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521580 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521612 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521653 */     GIR_RootConstrainSelectedInstOperands,
     /* 521654 */     // GIR_Coverage, 11554,
     /* 521654 */     GIR_EraseRootFromParent_Done,
     /* 521655 */   // Label 6896: @521655
     /* 521655 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(521784), // Rule ID 11555 //
     /* 521660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521741 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521782 */     GIR_RootConstrainSelectedInstOperands,
     /* 521783 */     // GIR_Coverage, 11555,
     /* 521783 */     GIR_EraseRootFromParent_Done,
     /* 521784 */   // Label 6897: @521784
     /* 521784 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(521913), // Rule ID 11597 //
     /* 521789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521870 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521911 */     GIR_RootConstrainSelectedInstOperands,
     /* 521912 */     // GIR_Coverage, 11597,
     /* 521912 */     GIR_EraseRootFromParent_Done,
     /* 521913 */   // Label 6898: @521913
     /* 521913 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(522042), // Rule ID 11598 //
     /* 521918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521962 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521967 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521999 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522040 */     GIR_RootConstrainSelectedInstOperands,
     /* 522041 */     // GIR_Coverage, 11598,
     /* 522041 */     GIR_EraseRootFromParent_Done,
     /* 522042 */   // Label 6899: @522042
     /* 522042 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(522171), // Rule ID 11599 //
     /* 522047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522128 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522169 */     GIR_RootConstrainSelectedInstOperands,
     /* 522170 */     // GIR_Coverage, 11599,
     /* 522170 */     GIR_EraseRootFromParent_Done,
     /* 522171 */   // Label 6900: @522171
     /* 522171 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(522300), // Rule ID 11600 //
     /* 522176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522220 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522225 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522257 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522298 */     GIR_RootConstrainSelectedInstOperands,
     /* 522299 */     // GIR_Coverage, 11600,
     /* 522299 */     GIR_EraseRootFromParent_Done,
     /* 522300 */   // Label 6901: @522300
     /* 522300 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(522429), // Rule ID 11537 //
     /* 522305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522386 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522427 */     GIR_RootConstrainSelectedInstOperands,
     /* 522428 */     // GIR_Coverage, 11537,
     /* 522428 */     GIR_EraseRootFromParent_Done,
     /* 522429 */   // Label 6902: @522429
     /* 522429 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(522558), // Rule ID 11538 //
     /* 522434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522515 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522556 */     GIR_RootConstrainSelectedInstOperands,
     /* 522557 */     // GIR_Coverage, 11538,
     /* 522557 */     GIR_EraseRootFromParent_Done,
     /* 522558 */   // Label 6903: @522558
     /* 522558 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(522687), // Rule ID 11539 //
     /* 522563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522607 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522612 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522644 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522685 */     GIR_RootConstrainSelectedInstOperands,
     /* 522686 */     // GIR_Coverage, 11539,
     /* 522686 */     GIR_EraseRootFromParent_Done,
     /* 522687 */   // Label 6904: @522687
     /* 522687 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(522816), // Rule ID 11540 //
     /* 522692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522773 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522814 */     GIR_RootConstrainSelectedInstOperands,
     /* 522815 */     // GIR_Coverage, 11540,
     /* 522815 */     GIR_EraseRootFromParent_Done,
     /* 522816 */   // Label 6905: @522816
     /* 522816 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(522928), // Rule ID 13257 //
     /* 522821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 522832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522856 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522858 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 522862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522885 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 522888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 522905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 522910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 522915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 522920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522926 */     GIR_RootConstrainSelectedInstOperands,
     /* 522927 */     // GIR_Coverage, 13257,
     /* 522927 */     GIR_EraseRootFromParent_Done,
     /* 522928 */   // Label 6906: @522928
     /* 522928 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(523040), // Rule ID 13256 //
     /* 522933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 522944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522968 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522970 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 522974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522997 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523038 */     GIR_RootConstrainSelectedInstOperands,
     /* 523039 */     // GIR_Coverage, 13256,
     /* 523039 */     GIR_EraseRootFromParent_Done,
     /* 523040 */   // Label 6907: @523040
     /* 523040 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(523152), // Rule ID 7731 //
     /* 523045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 523060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 523068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523080 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 523082 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 523086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 523088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523109 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523150 */     GIR_RootConstrainSelectedInstOperands,
     /* 523151 */     // GIR_Coverage, 7731,
     /* 523151 */     GIR_EraseRootFromParent_Done,
     /* 523152 */   // Label 6908: @523152
     /* 523152 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(523264), // Rule ID 7730 //
     /* 523157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 523172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 523180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523192 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 523194 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 523198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 523200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523221 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523262 */     GIR_RootConstrainSelectedInstOperands,
     /* 523263 */     // GIR_Coverage, 7730,
     /* 523263 */     GIR_EraseRootFromParent_Done,
     /* 523264 */   // Label 6909: @523264
     /* 523264 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(523360), // Rule ID 13249 //
     /* 523269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 523280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523292 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523317 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523358 */     GIR_RootConstrainSelectedInstOperands,
     /* 523359 */     // GIR_Coverage, 13249,
     /* 523359 */     GIR_EraseRootFromParent_Done,
     /* 523360 */   // Label 6910: @523360
     /* 523360 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(523456), // Rule ID 13248 //
     /* 523365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 523376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523388 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523413 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523454 */     GIR_RootConstrainSelectedInstOperands,
     /* 523455 */     // GIR_Coverage, 13248,
     /* 523455 */     GIR_EraseRootFromParent_Done,
     /* 523456 */   // Label 6911: @523456
     /* 523456 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(523552), // Rule ID 7723 //
     /* 523461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523484 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523509 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523550 */     GIR_RootConstrainSelectedInstOperands,
     /* 523551 */     // GIR_Coverage, 7723,
     /* 523551 */     GIR_EraseRootFromParent_Done,
     /* 523552 */   // Label 6912: @523552
     /* 523552 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(523648), // Rule ID 7722 //
     /* 523557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523580 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523605 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523646 */     GIR_RootConstrainSelectedInstOperands,
     /* 523647 */     // GIR_Coverage, 7722,
     /* 523647 */     GIR_EraseRootFromParent_Done,
     /* 523648 */   // Label 6913: @523648
     /* 523648 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(523683), // Rule ID 90 //
     /* 523653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 523656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13765),
     /* 523672 */     // (fminnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13765>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 523672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 523677 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 523681 */     GIR_RootConstrainSelectedInstOperands,
     /* 523682 */     // GIR_Coverage, 90,
     /* 523682 */     GIR_Done,
     /* 523683 */   // Label 6914: @523683
     /* 523683 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(523743), // Rule ID 800 //
     /* 523688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523706 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 523709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523741 */     GIR_RootConstrainSelectedInstOperands,
     /* 523742 */     // GIR_Coverage, 800,
     /* 523742 */     GIR_EraseRootFromParent_Done,
     /* 523743 */   // Label 6915: @523743
     /* 523743 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(523803), // Rule ID 8424 //
     /* 523748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523766 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 523769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 523776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 523786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 523791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 523796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 523801 */     GIR_RootConstrainSelectedInstOperands,
     /* 523802 */     // GIR_Coverage, 8424,
     /* 523802 */     GIR_EraseRootFromParent_Done,
     /* 523803 */   // Label 6916: @523803
     /* 523803 */   GIM_Reject,
     /* 523804 */ // Label 6777: @523804
     /* 523804 */ GIM_Reject,
     /* 523805 */ // Label 6367: @523805
     /* 523805 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(524057),
     /* 523810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 523813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 523816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 523820 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(523879), // Rule ID 915 //
     /* 523825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 523828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523842 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 523845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523877 */     GIR_RootConstrainSelectedInstOperands,
     /* 523878 */     // GIR_Coverage, 915,
     /* 523878 */     GIR_EraseRootFromParent_Done,
     /* 523879 */   // Label 6918: @523879
     /* 523879 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(523938), // Rule ID 934 //
     /* 523884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 523887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523901 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 523904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523936 */     GIR_RootConstrainSelectedInstOperands,
     /* 523937 */     // GIR_Coverage, 934,
     /* 523937 */     GIR_EraseRootFromParent_Done,
     /* 523938 */   // Label 6919: @523938
     /* 523938 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(523997), // Rule ID 8450 //
     /* 523943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 523946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523960 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 523963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 523970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 523980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 523985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 523990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 523995 */     GIR_RootConstrainSelectedInstOperands,
     /* 523996 */     // GIR_Coverage, 8450,
     /* 523996 */     GIR_EraseRootFromParent_Done,
     /* 523997 */   // Label 6920: @523997
     /* 523997 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(524056), // Rule ID 8464 //
     /* 524002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 524005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 524019 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 524019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 524022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 524029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 524039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 524049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 524054 */     GIR_RootConstrainSelectedInstOperands,
     /* 524055 */     // GIR_Coverage, 8464,
     /* 524055 */     GIR_EraseRootFromParent_Done,
     /* 524056 */   // Label 6921: @524056
     /* 524056 */   GIM_Reject,
     /* 524057 */ // Label 6917: @524057
     /* 524057 */ GIM_Reject,
     /* 524058 */ // Label 6368: @524058
     /* 524058 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(524129), // Rule ID 1096 //
     /* 524063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 524066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 524069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 524080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 524087 */   // (fminnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 524087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 524090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 524097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 524107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524127 */   GIR_RootConstrainSelectedInstOperands,
     /* 524128 */   // GIR_Coverage, 1096,
     /* 524128 */   GIR_EraseRootFromParent_Done,
     /* 524129 */ // Label 6922: @524129
     /* 524129 */ GIM_Reject,
     /* 524130 */ // Label 6369: @524130
     /* 524130 */ GIM_Reject,
     /* 524131 */ // Label 83: @524131
     /* 524131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6927*/ GIMT_Encode4(595909),
     /* 524142 */ /*GILLT_s16*//*Label 6923*/ GIMT_Encode4(524158),
     /* 524146 */ /*GILLT_s32*//*Label 6924*/ GIMT_Encode4(578072),
     /* 524150 */ /*GILLT_s64*//*Label 6925*/ GIMT_Encode4(595584),
     /* 524154 */ /*GILLT_v2s16*//*Label 6926*/ GIMT_Encode4(595837),
     /* 524158 */ // Label 6923: @524158
     /* 524158 */ GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(578071),
     /* 524163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 524166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 524169 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(524304), // Rule ID 11906 //
     /* 524174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524258 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524302 */     GIR_RootConstrainSelectedInstOperands,
     /* 524303 */     // GIR_Coverage, 11906,
     /* 524303 */     GIR_EraseRootFromParent_Done,
     /* 524304 */   // Label 6929: @524304
     /* 524304 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(524439), // Rule ID 11907 //
     /* 524309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524393 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524437 */     GIR_RootConstrainSelectedInstOperands,
     /* 524438 */     // GIR_Coverage, 11907,
     /* 524438 */     GIR_EraseRootFromParent_Done,
     /* 524439 */   // Label 6930: @524439
     /* 524439 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(524574), // Rule ID 11910 //
     /* 524444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524528 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524572 */     GIR_RootConstrainSelectedInstOperands,
     /* 524573 */     // GIR_Coverage, 11910,
     /* 524573 */     GIR_EraseRootFromParent_Done,
     /* 524574 */   // Label 6931: @524574
     /* 524574 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(524709), // Rule ID 11911 //
     /* 524579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524663 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524707 */     GIR_RootConstrainSelectedInstOperands,
     /* 524708 */     // GIR_Coverage, 11911,
     /* 524708 */     GIR_EraseRootFromParent_Done,
     /* 524709 */   // Label 6932: @524709
     /* 524709 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(524844), // Rule ID 12386 //
     /* 524714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524798 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524842 */     GIR_RootConstrainSelectedInstOperands,
     /* 524843 */     // GIR_Coverage, 12386,
     /* 524843 */     GIR_EraseRootFromParent_Done,
     /* 524844 */   // Label 6933: @524844
     /* 524844 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(524979), // Rule ID 12387 //
     /* 524849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524933 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524977 */     GIR_RootConstrainSelectedInstOperands,
     /* 524978 */     // GIR_Coverage, 12387,
     /* 524978 */     GIR_EraseRootFromParent_Done,
     /* 524979 */   // Label 6934: @524979
     /* 524979 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(525114), // Rule ID 12390 //
     /* 524984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525068 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 525071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525112 */     GIR_RootConstrainSelectedInstOperands,
     /* 525113 */     // GIR_Coverage, 12390,
     /* 525113 */     GIR_EraseRootFromParent_Done,
     /* 525114 */   // Label 6935: @525114
     /* 525114 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(525249), // Rule ID 12391 //
     /* 525119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 525122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 525126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525203 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 525206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525247 */     GIR_RootConstrainSelectedInstOperands,
     /* 525248 */     // GIR_Coverage, 12391,
     /* 525248 */     GIR_EraseRootFromParent_Done,
     /* 525249 */   // Label 6936: @525249
     /* 525249 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(525384), // Rule ID 12866 //
     /* 525254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525338 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525382 */     GIR_RootConstrainSelectedInstOperands,
     /* 525383 */     // GIR_Coverage, 12866,
     /* 525383 */     GIR_EraseRootFromParent_Done,
     /* 525384 */   // Label 6937: @525384
     /* 525384 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(525519), // Rule ID 12867 //
     /* 525389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525473 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525517 */     GIR_RootConstrainSelectedInstOperands,
     /* 525518 */     // GIR_Coverage, 12867,
     /* 525518 */     GIR_EraseRootFromParent_Done,
     /* 525519 */   // Label 6938: @525519
     /* 525519 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(525654), // Rule ID 12870 //
     /* 525524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525608 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525652 */     GIR_RootConstrainSelectedInstOperands,
     /* 525653 */     // GIR_Coverage, 12870,
     /* 525653 */     GIR_EraseRootFromParent_Done,
     /* 525654 */   // Label 6939: @525654
     /* 525654 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(525789), // Rule ID 12871 //
     /* 525659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525743 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525787 */     GIR_RootConstrainSelectedInstOperands,
     /* 525788 */     // GIR_Coverage, 12871,
     /* 525788 */     GIR_EraseRootFromParent_Done,
     /* 525789 */   // Label 6940: @525789
     /* 525789 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(525924), // Rule ID 11891 //
     /* 525794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525878 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 525881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525922 */     GIR_RootConstrainSelectedInstOperands,
     /* 525923 */     // GIR_Coverage, 11891,
     /* 525923 */     GIR_EraseRootFromParent_Done,
     /* 525924 */   // Label 6941: @525924
     /* 525924 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(526059), // Rule ID 11892 //
     /* 525929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526013 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 526016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526057 */     GIR_RootConstrainSelectedInstOperands,
     /* 526058 */     // GIR_Coverage, 11892,
     /* 526058 */     GIR_EraseRootFromParent_Done,
     /* 526059 */   // Label 6942: @526059
     /* 526059 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(526194), // Rule ID 11895 //
     /* 526064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 526067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526148 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 526151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526192 */     GIR_RootConstrainSelectedInstOperands,
     /* 526193 */     // GIR_Coverage, 11895,
     /* 526193 */     GIR_EraseRootFromParent_Done,
     /* 526194 */   // Label 6943: @526194
     /* 526194 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(526329), // Rule ID 11896 //
     /* 526199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 526202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526283 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 526286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526327 */     GIR_RootConstrainSelectedInstOperands,
     /* 526328 */     // GIR_Coverage, 11896,
     /* 526328 */     GIR_EraseRootFromParent_Done,
     /* 526329 */   // Label 6944: @526329
     /* 526329 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(526464), // Rule ID 12371 //
     /* 526334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526418 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526462 */     GIR_RootConstrainSelectedInstOperands,
     /* 526463 */     // GIR_Coverage, 12371,
     /* 526463 */     GIR_EraseRootFromParent_Done,
     /* 526464 */   // Label 6945: @526464
     /* 526464 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(526599), // Rule ID 12372 //
     /* 526469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526553 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526597 */     GIR_RootConstrainSelectedInstOperands,
     /* 526598 */     // GIR_Coverage, 12372,
     /* 526598 */     GIR_EraseRootFromParent_Done,
     /* 526599 */   // Label 6946: @526599
     /* 526599 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(526734), // Rule ID 12375 //
     /* 526604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526688 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526732 */     GIR_RootConstrainSelectedInstOperands,
     /* 526733 */     // GIR_Coverage, 12375,
     /* 526733 */     GIR_EraseRootFromParent_Done,
     /* 526734 */   // Label 6947: @526734
     /* 526734 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(526869), // Rule ID 12376 //
     /* 526739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526823 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526867 */     GIR_RootConstrainSelectedInstOperands,
     /* 526868 */     // GIR_Coverage, 12376,
     /* 526868 */     GIR_EraseRootFromParent_Done,
     /* 526869 */   // Label 6948: @526869
     /* 526869 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(527004), // Rule ID 12851 //
     /* 526874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 526877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526958 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 526961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527002 */     GIR_RootConstrainSelectedInstOperands,
     /* 527003 */     // GIR_Coverage, 12851,
     /* 527003 */     GIR_EraseRootFromParent_Done,
     /* 527004 */   // Label 6949: @527004
     /* 527004 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(527139), // Rule ID 12852 //
     /* 527009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 527012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 527052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527093 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527137 */     GIR_RootConstrainSelectedInstOperands,
     /* 527138 */     // GIR_Coverage, 12852,
     /* 527138 */     GIR_EraseRootFromParent_Done,
     /* 527139 */   // Label 6950: @527139
     /* 527139 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(527274), // Rule ID 12855 //
     /* 527144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 527147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 527187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527228 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 527248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527272 */     GIR_RootConstrainSelectedInstOperands,
     /* 527273 */     // GIR_Coverage, 12855,
     /* 527273 */     GIR_EraseRootFromParent_Done,
     /* 527274 */   // Label 6951: @527274
     /* 527274 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(527409), // Rule ID 12856 //
     /* 527279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 527282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 527322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527363 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 527383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527407 */     GIR_RootConstrainSelectedInstOperands,
     /* 527408 */     // GIR_Coverage, 12856,
     /* 527408 */     GIR_EraseRootFromParent_Done,
     /* 527409 */   // Label 6952: @527409
     /* 527409 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(527544), // Rule ID 7625 //
     /* 527414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527498 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527542 */     GIR_RootConstrainSelectedInstOperands,
     /* 527543 */     // GIR_Coverage, 7625,
     /* 527543 */     GIR_EraseRootFromParent_Done,
     /* 527544 */   // Label 6953: @527544
     /* 527544 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(527679), // Rule ID 7657 //
     /* 527549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 527552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 527556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527596 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527601 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527633 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 527636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527677 */     GIR_RootConstrainSelectedInstOperands,
     /* 527678 */     // GIR_Coverage, 7657,
     /* 527678 */     GIR_EraseRootFromParent_Done,
     /* 527679 */   // Label 6954: @527679
     /* 527679 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(527814), // Rule ID 7689 //
     /* 527684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 527687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527768 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527812 */     GIR_RootConstrainSelectedInstOperands,
     /* 527813 */     // GIR_Coverage, 7689,
     /* 527813 */     GIR_EraseRootFromParent_Done,
     /* 527814 */   // Label 6955: @527814
     /* 527814 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(527949), // Rule ID 11905 //
     /* 527819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527903 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527947 */     GIR_RootConstrainSelectedInstOperands,
     /* 527948 */     // GIR_Coverage, 11905,
     /* 527948 */     GIR_EraseRootFromParent_Done,
     /* 527949 */   // Label 6956: @527949
     /* 527949 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(528084), // Rule ID 11908 //
     /* 527954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528038 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528082 */     GIR_RootConstrainSelectedInstOperands,
     /* 528083 */     // GIR_Coverage, 11908,
     /* 528083 */     GIR_EraseRootFromParent_Done,
     /* 528084 */   // Label 6957: @528084
     /* 528084 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(528219), // Rule ID 11909 //
     /* 528089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528173 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528217 */     GIR_RootConstrainSelectedInstOperands,
     /* 528218 */     // GIR_Coverage, 11909,
     /* 528218 */     GIR_EraseRootFromParent_Done,
     /* 528219 */   // Label 6958: @528219
     /* 528219 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(528354), // Rule ID 12385 //
     /* 528224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528271 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528276 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528308 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528352 */     GIR_RootConstrainSelectedInstOperands,
     /* 528353 */     // GIR_Coverage, 12385,
     /* 528353 */     GIR_EraseRootFromParent_Done,
     /* 528354 */   // Label 6959: @528354
     /* 528354 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(528489), // Rule ID 12388 //
     /* 528359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528406 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528411 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528443 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528487 */     GIR_RootConstrainSelectedInstOperands,
     /* 528488 */     // GIR_Coverage, 12388,
     /* 528488 */     GIR_EraseRootFromParent_Done,
     /* 528489 */   // Label 6960: @528489
     /* 528489 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(528624), // Rule ID 12389 //
     /* 528494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528541 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528546 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528578 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528622 */     GIR_RootConstrainSelectedInstOperands,
     /* 528623 */     // GIR_Coverage, 12389,
     /* 528623 */     GIR_EraseRootFromParent_Done,
     /* 528624 */   // Label 6961: @528624
     /* 528624 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(528759), // Rule ID 12865 //
     /* 528629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528713 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528757 */     GIR_RootConstrainSelectedInstOperands,
     /* 528758 */     // GIR_Coverage, 12865,
     /* 528758 */     GIR_EraseRootFromParent_Done,
     /* 528759 */   // Label 6962: @528759
     /* 528759 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(528894), // Rule ID 12868 //
     /* 528764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528848 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528892 */     GIR_RootConstrainSelectedInstOperands,
     /* 528893 */     // GIR_Coverage, 12868,
     /* 528893 */     GIR_EraseRootFromParent_Done,
     /* 528894 */   // Label 6963: @528894
     /* 528894 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(529029), // Rule ID 12869 //
     /* 528899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528983 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529027 */     GIR_RootConstrainSelectedInstOperands,
     /* 529028 */     // GIR_Coverage, 12869,
     /* 529028 */     GIR_EraseRootFromParent_Done,
     /* 529029 */   // Label 6964: @529029
     /* 529029 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(529164), // Rule ID 7624 //
     /* 529034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529118 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529162 */     GIR_RootConstrainSelectedInstOperands,
     /* 529163 */     // GIR_Coverage, 7624,
     /* 529163 */     GIR_EraseRootFromParent_Done,
     /* 529164 */   // Label 6965: @529164
     /* 529164 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(529299), // Rule ID 7656 //
     /* 529169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529216 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529221 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529253 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529297 */     GIR_RootConstrainSelectedInstOperands,
     /* 529298 */     // GIR_Coverage, 7656,
     /* 529298 */     GIR_EraseRootFromParent_Done,
     /* 529299 */   // Label 6966: @529299
     /* 529299 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(529434), // Rule ID 7688 //
     /* 529304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529388 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529432 */     GIR_RootConstrainSelectedInstOperands,
     /* 529433 */     // GIR_Coverage, 7688,
     /* 529433 */     GIR_EraseRootFromParent_Done,
     /* 529434 */   // Label 6967: @529434
     /* 529434 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(529569), // Rule ID 11890 //
     /* 529439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529523 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529567 */     GIR_RootConstrainSelectedInstOperands,
     /* 529568 */     // GIR_Coverage, 11890,
     /* 529568 */     GIR_EraseRootFromParent_Done,
     /* 529569 */   // Label 6968: @529569
     /* 529569 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(529704), // Rule ID 11893 //
     /* 529574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529658 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529702 */     GIR_RootConstrainSelectedInstOperands,
     /* 529703 */     // GIR_Coverage, 11893,
     /* 529703 */     GIR_EraseRootFromParent_Done,
     /* 529704 */   // Label 6969: @529704
     /* 529704 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(529839), // Rule ID 11894 //
     /* 529709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529793 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529837 */     GIR_RootConstrainSelectedInstOperands,
     /* 529838 */     // GIR_Coverage, 11894,
     /* 529838 */     GIR_EraseRootFromParent_Done,
     /* 529839 */   // Label 6970: @529839
     /* 529839 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(529974), // Rule ID 12370 //
     /* 529844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529891 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529896 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529928 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529972 */     GIR_RootConstrainSelectedInstOperands,
     /* 529973 */     // GIR_Coverage, 12370,
     /* 529973 */     GIR_EraseRootFromParent_Done,
     /* 529974 */   // Label 6971: @529974
     /* 529974 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(530109), // Rule ID 12373 //
     /* 529979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530026 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530031 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530063 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530107 */     GIR_RootConstrainSelectedInstOperands,
     /* 530108 */     // GIR_Coverage, 12373,
     /* 530108 */     GIR_EraseRootFromParent_Done,
     /* 530109 */   // Label 6972: @530109
     /* 530109 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(530244), // Rule ID 12374 //
     /* 530114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530161 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530166 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530198 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530242 */     GIR_RootConstrainSelectedInstOperands,
     /* 530243 */     // GIR_Coverage, 12374,
     /* 530243 */     GIR_EraseRootFromParent_Done,
     /* 530244 */   // Label 6973: @530244
     /* 530244 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(530379), // Rule ID 12850 //
     /* 530249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 530252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530333 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530377 */     GIR_RootConstrainSelectedInstOperands,
     /* 530378 */     // GIR_Coverage, 12850,
     /* 530378 */     GIR_EraseRootFromParent_Done,
     /* 530379 */   // Label 6974: @530379
     /* 530379 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(530514), // Rule ID 12853 //
     /* 530384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 530387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530468 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530512 */     GIR_RootConstrainSelectedInstOperands,
     /* 530513 */     // GIR_Coverage, 12853,
     /* 530513 */     GIR_EraseRootFromParent_Done,
     /* 530514 */   // Label 6975: @530514
     /* 530514 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(530649), // Rule ID 12854 //
     /* 530519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 530522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530603 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530647 */     GIR_RootConstrainSelectedInstOperands,
     /* 530648 */     // GIR_Coverage, 12854,
     /* 530648 */     GIR_EraseRootFromParent_Done,
     /* 530649 */   // Label 6976: @530649
     /* 530649 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(530784), // Rule ID 11876 //
     /* 530654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530738 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530782 */     GIR_RootConstrainSelectedInstOperands,
     /* 530783 */     // GIR_Coverage, 11876,
     /* 530783 */     GIR_EraseRootFromParent_Done,
     /* 530784 */   // Label 6977: @530784
     /* 530784 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(530919), // Rule ID 11877 //
     /* 530789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530873 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530917 */     GIR_RootConstrainSelectedInstOperands,
     /* 530918 */     // GIR_Coverage, 11877,
     /* 530918 */     GIR_EraseRootFromParent_Done,
     /* 530919 */   // Label 6978: @530919
     /* 530919 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(531054), // Rule ID 11880 //
     /* 530924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531008 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 531011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531052 */     GIR_RootConstrainSelectedInstOperands,
     /* 531053 */     // GIR_Coverage, 11880,
     /* 531053 */     GIR_EraseRootFromParent_Done,
     /* 531054 */   // Label 6979: @531054
     /* 531054 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(531189), // Rule ID 11881 //
     /* 531059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 531062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531143 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 531146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531187 */     GIR_RootConstrainSelectedInstOperands,
     /* 531188 */     // GIR_Coverage, 11881,
     /* 531188 */     GIR_EraseRootFromParent_Done,
     /* 531189 */   // Label 6980: @531189
     /* 531189 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(531324), // Rule ID 12356 //
     /* 531194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531278 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531322 */     GIR_RootConstrainSelectedInstOperands,
     /* 531323 */     // GIR_Coverage, 12356,
     /* 531323 */     GIR_EraseRootFromParent_Done,
     /* 531324 */   // Label 6981: @531324
     /* 531324 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(531459), // Rule ID 12357 //
     /* 531329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531413 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531457 */     GIR_RootConstrainSelectedInstOperands,
     /* 531458 */     // GIR_Coverage, 12357,
     /* 531458 */     GIR_EraseRootFromParent_Done,
     /* 531459 */   // Label 6982: @531459
     /* 531459 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(531594), // Rule ID 12360 //
     /* 531464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531548 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531592 */     GIR_RootConstrainSelectedInstOperands,
     /* 531593 */     // GIR_Coverage, 12360,
     /* 531593 */     GIR_EraseRootFromParent_Done,
     /* 531594 */   // Label 6983: @531594
     /* 531594 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(531729), // Rule ID 12361 //
     /* 531599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531683 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531727 */     GIR_RootConstrainSelectedInstOperands,
     /* 531728 */     // GIR_Coverage, 12361,
     /* 531728 */     GIR_EraseRootFromParent_Done,
     /* 531729 */   // Label 6984: @531729
     /* 531729 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(531864), // Rule ID 12836 //
     /* 531734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531818 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531862 */     GIR_RootConstrainSelectedInstOperands,
     /* 531863 */     // GIR_Coverage, 12836,
     /* 531863 */     GIR_EraseRootFromParent_Done,
     /* 531864 */   // Label 6985: @531864
     /* 531864 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(531999), // Rule ID 12837 //
     /* 531869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531953 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531997 */     GIR_RootConstrainSelectedInstOperands,
     /* 531998 */     // GIR_Coverage, 12837,
     /* 531998 */     GIR_EraseRootFromParent_Done,
     /* 531999 */   // Label 6986: @531999
     /* 531999 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(532134), // Rule ID 12840 //
     /* 532004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 532007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532088 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 532091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532132 */     GIR_RootConstrainSelectedInstOperands,
     /* 532133 */     // GIR_Coverage, 12840,
     /* 532133 */     GIR_EraseRootFromParent_Done,
     /* 532134 */   // Label 6987: @532134
     /* 532134 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(532269), // Rule ID 12841 //
     /* 532139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 532142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532223 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 532226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532267 */     GIR_RootConstrainSelectedInstOperands,
     /* 532268 */     // GIR_Coverage, 12841,
     /* 532268 */     GIR_EraseRootFromParent_Done,
     /* 532269 */   // Label 6988: @532269
     /* 532269 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(532404), // Rule ID 11861 //
     /* 532274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532358 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532402 */     GIR_RootConstrainSelectedInstOperands,
     /* 532403 */     // GIR_Coverage, 11861,
     /* 532403 */     GIR_EraseRootFromParent_Done,
     /* 532404 */   // Label 6989: @532404
     /* 532404 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(532539), // Rule ID 11862 //
     /* 532409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532493 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532537 */     GIR_RootConstrainSelectedInstOperands,
     /* 532538 */     // GIR_Coverage, 11862,
     /* 532538 */     GIR_EraseRootFromParent_Done,
     /* 532539 */   // Label 6990: @532539
     /* 532539 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(532674), // Rule ID 11865 //
     /* 532544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532628 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532672 */     GIR_RootConstrainSelectedInstOperands,
     /* 532673 */     // GIR_Coverage, 11865,
     /* 532673 */     GIR_EraseRootFromParent_Done,
     /* 532674 */   // Label 6991: @532674
     /* 532674 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(532809), // Rule ID 11866 //
     /* 532679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532763 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532807 */     GIR_RootConstrainSelectedInstOperands,
     /* 532808 */     // GIR_Coverage, 11866,
     /* 532808 */     GIR_EraseRootFromParent_Done,
     /* 532809 */   // Label 6992: @532809
     /* 532809 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(532944), // Rule ID 12341 //
     /* 532814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532898 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532942 */     GIR_RootConstrainSelectedInstOperands,
     /* 532943 */     // GIR_Coverage, 12341,
     /* 532943 */     GIR_EraseRootFromParent_Done,
     /* 532944 */   // Label 6993: @532944
     /* 532944 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(533079), // Rule ID 12342 //
     /* 532949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533033 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533077 */     GIR_RootConstrainSelectedInstOperands,
     /* 533078 */     // GIR_Coverage, 12342,
     /* 533078 */     GIR_EraseRootFromParent_Done,
     /* 533079 */   // Label 6994: @533079
     /* 533079 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(533214), // Rule ID 12345 //
     /* 533084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 533087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 533091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533168 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533212 */     GIR_RootConstrainSelectedInstOperands,
     /* 533213 */     // GIR_Coverage, 12345,
     /* 533213 */     GIR_EraseRootFromParent_Done,
     /* 533214 */   // Label 6995: @533214
     /* 533214 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(533349), // Rule ID 12346 //
     /* 533219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 533222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 533226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533303 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533347 */     GIR_RootConstrainSelectedInstOperands,
     /* 533348 */     // GIR_Coverage, 12346,
     /* 533348 */     GIR_EraseRootFromParent_Done,
     /* 533349 */   // Label 6996: @533349
     /* 533349 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(533484), // Rule ID 12821 //
     /* 533354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533438 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533482 */     GIR_RootConstrainSelectedInstOperands,
     /* 533483 */     // GIR_Coverage, 12821,
     /* 533483 */     GIR_EraseRootFromParent_Done,
     /* 533484 */   // Label 6997: @533484
     /* 533484 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(533619), // Rule ID 12822 //
     /* 533489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533573 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533617 */     GIR_RootConstrainSelectedInstOperands,
     /* 533618 */     // GIR_Coverage, 12822,
     /* 533618 */     GIR_EraseRootFromParent_Done,
     /* 533619 */   // Label 6998: @533619
     /* 533619 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(533754), // Rule ID 12825 //
     /* 533624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533708 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533752 */     GIR_RootConstrainSelectedInstOperands,
     /* 533753 */     // GIR_Coverage, 12825,
     /* 533753 */     GIR_EraseRootFromParent_Done,
     /* 533754 */   // Label 6999: @533754
     /* 533754 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(533889), // Rule ID 12826 //
     /* 533759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533843 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533887 */     GIR_RootConstrainSelectedInstOperands,
     /* 533888 */     // GIR_Coverage, 12826,
     /* 533888 */     GIR_EraseRootFromParent_Done,
     /* 533889 */   // Label 7000: @533889
     /* 533889 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(534024), // Rule ID 7623 //
     /* 533894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 533941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533978 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534022 */     GIR_RootConstrainSelectedInstOperands,
     /* 534023 */     // GIR_Coverage, 7623,
     /* 534023 */     GIR_EraseRootFromParent_Done,
     /* 534024 */   // Label 7001: @534024
     /* 534024 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(534159), // Rule ID 7655 //
     /* 534029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534076 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534081 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534113 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534157 */     GIR_RootConstrainSelectedInstOperands,
     /* 534158 */     // GIR_Coverage, 7655,
     /* 534158 */     GIR_EraseRootFromParent_Done,
     /* 534159 */   // Label 7002: @534159
     /* 534159 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(534294), // Rule ID 7687 //
     /* 534164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534248 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 534251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534292 */     GIR_RootConstrainSelectedInstOperands,
     /* 534293 */     // GIR_Coverage, 7687,
     /* 534293 */     GIR_EraseRootFromParent_Done,
     /* 534294 */   // Label 7003: @534294
     /* 534294 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(534429), // Rule ID 11875 //
     /* 534299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534383 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534427 */     GIR_RootConstrainSelectedInstOperands,
     /* 534428 */     // GIR_Coverage, 11875,
     /* 534428 */     GIR_EraseRootFromParent_Done,
     /* 534429 */   // Label 7004: @534429
     /* 534429 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(534564), // Rule ID 11878 //
     /* 534434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534518 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534562 */     GIR_RootConstrainSelectedInstOperands,
     /* 534563 */     // GIR_Coverage, 11878,
     /* 534563 */     GIR_EraseRootFromParent_Done,
     /* 534564 */   // Label 7005: @534564
     /* 534564 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(534699), // Rule ID 11879 //
     /* 534569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534653 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534697 */     GIR_RootConstrainSelectedInstOperands,
     /* 534698 */     // GIR_Coverage, 11879,
     /* 534698 */     GIR_EraseRootFromParent_Done,
     /* 534699 */   // Label 7006: @534699
     /* 534699 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(534834), // Rule ID 12355 //
     /* 534704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534751 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534756 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534788 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534832 */     GIR_RootConstrainSelectedInstOperands,
     /* 534833 */     // GIR_Coverage, 12355,
     /* 534833 */     GIR_EraseRootFromParent_Done,
     /* 534834 */   // Label 7007: @534834
     /* 534834 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(534969), // Rule ID 12358 //
     /* 534839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534886 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534891 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534923 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534967 */     GIR_RootConstrainSelectedInstOperands,
     /* 534968 */     // GIR_Coverage, 12358,
     /* 534968 */     GIR_EraseRootFromParent_Done,
     /* 534969 */   // Label 7008: @534969
     /* 534969 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(535104), // Rule ID 12359 //
     /* 534974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535021 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535026 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535058 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535102 */     GIR_RootConstrainSelectedInstOperands,
     /* 535103 */     // GIR_Coverage, 12359,
     /* 535103 */     GIR_EraseRootFromParent_Done,
     /* 535104 */   // Label 7009: @535104
     /* 535104 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(535239), // Rule ID 12835 //
     /* 535109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535193 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535237 */     GIR_RootConstrainSelectedInstOperands,
     /* 535238 */     // GIR_Coverage, 12835,
     /* 535238 */     GIR_EraseRootFromParent_Done,
     /* 535239 */   // Label 7010: @535239
     /* 535239 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(535374), // Rule ID 12838 //
     /* 535244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535328 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535372 */     GIR_RootConstrainSelectedInstOperands,
     /* 535373 */     // GIR_Coverage, 12838,
     /* 535373 */     GIR_EraseRootFromParent_Done,
     /* 535374 */   // Label 7011: @535374
     /* 535374 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(535509), // Rule ID 12839 //
     /* 535379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535463 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535507 */     GIR_RootConstrainSelectedInstOperands,
     /* 535508 */     // GIR_Coverage, 12839,
     /* 535508 */     GIR_EraseRootFromParent_Done,
     /* 535509 */   // Label 7012: @535509
     /* 535509 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(535644), // Rule ID 7622 //
     /* 535514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535598 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535642 */     GIR_RootConstrainSelectedInstOperands,
     /* 535643 */     // GIR_Coverage, 7622,
     /* 535643 */     GIR_EraseRootFromParent_Done,
     /* 535644 */   // Label 7013: @535644
     /* 535644 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(535779), // Rule ID 7654 //
     /* 535649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535696 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535701 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535733 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535777 */     GIR_RootConstrainSelectedInstOperands,
     /* 535778 */     // GIR_Coverage, 7654,
     /* 535778 */     GIR_EraseRootFromParent_Done,
     /* 535779 */   // Label 7014: @535779
     /* 535779 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(535914), // Rule ID 7686 //
     /* 535784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535868 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535912 */     GIR_RootConstrainSelectedInstOperands,
     /* 535913 */     // GIR_Coverage, 7686,
     /* 535913 */     GIR_EraseRootFromParent_Done,
     /* 535914 */   // Label 7015: @535914
     /* 535914 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(536049), // Rule ID 11860 //
     /* 535919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536003 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536047 */     GIR_RootConstrainSelectedInstOperands,
     /* 536048 */     // GIR_Coverage, 11860,
     /* 536048 */     GIR_EraseRootFromParent_Done,
     /* 536049 */   // Label 7016: @536049
     /* 536049 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(536184), // Rule ID 11863 //
     /* 536054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536138 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536182 */     GIR_RootConstrainSelectedInstOperands,
     /* 536183 */     // GIR_Coverage, 11863,
     /* 536183 */     GIR_EraseRootFromParent_Done,
     /* 536184 */   // Label 7017: @536184
     /* 536184 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(536319), // Rule ID 11864 //
     /* 536189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536273 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536317 */     GIR_RootConstrainSelectedInstOperands,
     /* 536318 */     // GIR_Coverage, 11864,
     /* 536318 */     GIR_EraseRootFromParent_Done,
     /* 536319 */   // Label 7018: @536319
     /* 536319 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(536454), // Rule ID 12340 //
     /* 536324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536371 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536376 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536408 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536452 */     GIR_RootConstrainSelectedInstOperands,
     /* 536453 */     // GIR_Coverage, 12340,
     /* 536453 */     GIR_EraseRootFromParent_Done,
     /* 536454 */   // Label 7019: @536454
     /* 536454 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(536589), // Rule ID 12343 //
     /* 536459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536506 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536543 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536587 */     GIR_RootConstrainSelectedInstOperands,
     /* 536588 */     // GIR_Coverage, 12343,
     /* 536588 */     GIR_EraseRootFromParent_Done,
     /* 536589 */   // Label 7020: @536589
     /* 536589 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(536724), // Rule ID 12344 //
     /* 536594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536641 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536646 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536678 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536722 */     GIR_RootConstrainSelectedInstOperands,
     /* 536723 */     // GIR_Coverage, 12344,
     /* 536723 */     GIR_EraseRootFromParent_Done,
     /* 536724 */   // Label 7021: @536724
     /* 536724 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(536859), // Rule ID 12820 //
     /* 536729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536813 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536857 */     GIR_RootConstrainSelectedInstOperands,
     /* 536858 */     // GIR_Coverage, 12820,
     /* 536858 */     GIR_EraseRootFromParent_Done,
     /* 536859 */   // Label 7022: @536859
     /* 536859 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(536994), // Rule ID 12823 //
     /* 536864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536948 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536992 */     GIR_RootConstrainSelectedInstOperands,
     /* 536993 */     // GIR_Coverage, 12823,
     /* 536993 */     GIR_EraseRootFromParent_Done,
     /* 536994 */   // Label 7023: @536994
     /* 536994 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(537129), // Rule ID 12824 //
     /* 536999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 537042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537083 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 537086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 537103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 537108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537127 */     GIR_RootConstrainSelectedInstOperands,
     /* 537128 */     // GIR_Coverage, 12824,
     /* 537128 */     GIR_EraseRootFromParent_Done,
     /* 537129 */   // Label 7024: @537129
     /* 537129 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(537264), // Rule ID 11916 //
     /* 537134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537218 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537262 */     GIR_RootConstrainSelectedInstOperands,
     /* 537263 */     // GIR_Coverage, 11916,
     /* 537263 */     GIR_EraseRootFromParent_Done,
     /* 537264 */   // Label 7025: @537264
     /* 537264 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(537399), // Rule ID 11917 //
     /* 537269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537353 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537397 */     GIR_RootConstrainSelectedInstOperands,
     /* 537398 */     // GIR_Coverage, 11917,
     /* 537398 */     GIR_EraseRootFromParent_Done,
     /* 537399 */   // Label 7026: @537399
     /* 537399 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(537534), // Rule ID 11918 //
     /* 537404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537488 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537532 */     GIR_RootConstrainSelectedInstOperands,
     /* 537533 */     // GIR_Coverage, 11918,
     /* 537533 */     GIR_EraseRootFromParent_Done,
     /* 537534 */   // Label 7027: @537534
     /* 537534 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(537669), // Rule ID 11919 //
     /* 537539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537623 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537667 */     GIR_RootConstrainSelectedInstOperands,
     /* 537668 */     // GIR_Coverage, 11919,
     /* 537668 */     GIR_EraseRootFromParent_Done,
     /* 537669 */   // Label 7028: @537669
     /* 537669 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(537804), // Rule ID 12396 //
     /* 537674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537758 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537802 */     GIR_RootConstrainSelectedInstOperands,
     /* 537803 */     // GIR_Coverage, 12396,
     /* 537803 */     GIR_EraseRootFromParent_Done,
     /* 537804 */   // Label 7029: @537804
     /* 537804 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(537939), // Rule ID 12397 //
     /* 537809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537893 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537937 */     GIR_RootConstrainSelectedInstOperands,
     /* 537938 */     // GIR_Coverage, 12397,
     /* 537938 */     GIR_EraseRootFromParent_Done,
     /* 537939 */   // Label 7030: @537939
     /* 537939 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(538074), // Rule ID 12398 //
     /* 537944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538028 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 538031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538072 */     GIR_RootConstrainSelectedInstOperands,
     /* 538073 */     // GIR_Coverage, 12398,
     /* 538073 */     GIR_EraseRootFromParent_Done,
     /* 538074 */   // Label 7031: @538074
     /* 538074 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(538209), // Rule ID 12399 //
     /* 538079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 538082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 538086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538163 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 538166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538207 */     GIR_RootConstrainSelectedInstOperands,
     /* 538208 */     // GIR_Coverage, 12399,
     /* 538208 */     GIR_EraseRootFromParent_Done,
     /* 538209 */   // Label 7032: @538209
     /* 538209 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(538344), // Rule ID 12876 //
     /* 538214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538298 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538342 */     GIR_RootConstrainSelectedInstOperands,
     /* 538343 */     // GIR_Coverage, 12876,
     /* 538343 */     GIR_EraseRootFromParent_Done,
     /* 538344 */   // Label 7033: @538344
     /* 538344 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(538479), // Rule ID 12877 //
     /* 538349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538433 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538477 */     GIR_RootConstrainSelectedInstOperands,
     /* 538478 */     // GIR_Coverage, 12877,
     /* 538478 */     GIR_EraseRootFromParent_Done,
     /* 538479 */   // Label 7034: @538479
     /* 538479 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(538614), // Rule ID 12878 //
     /* 538484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538568 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538612 */     GIR_RootConstrainSelectedInstOperands,
     /* 538613 */     // GIR_Coverage, 12878,
     /* 538613 */     GIR_EraseRootFromParent_Done,
     /* 538614 */   // Label 7035: @538614
     /* 538614 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(538749), // Rule ID 12879 //
     /* 538619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538703 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538747 */     GIR_RootConstrainSelectedInstOperands,
     /* 538748 */     // GIR_Coverage, 12879,
     /* 538748 */     GIR_EraseRootFromParent_Done,
     /* 538749 */   // Label 7036: @538749
     /* 538749 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(538884), // Rule ID 11856 //
     /* 538754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538838 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538882 */     GIR_RootConstrainSelectedInstOperands,
     /* 538883 */     // GIR_Coverage, 11856,
     /* 538883 */     GIR_EraseRootFromParent_Done,
     /* 538884 */   // Label 7037: @538884
     /* 538884 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(539019), // Rule ID 11857 //
     /* 538889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538973 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539017 */     GIR_RootConstrainSelectedInstOperands,
     /* 539018 */     // GIR_Coverage, 11857,
     /* 539018 */     GIR_EraseRootFromParent_Done,
     /* 539019 */   // Label 7038: @539019
     /* 539019 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(539154), // Rule ID 11858 //
     /* 539024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 539027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539108 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 539111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539152 */     GIR_RootConstrainSelectedInstOperands,
     /* 539153 */     // GIR_Coverage, 11858,
     /* 539153 */     GIR_EraseRootFromParent_Done,
     /* 539154 */   // Label 7039: @539154
     /* 539154 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(539289), // Rule ID 11859 //
     /* 539159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 539162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539243 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 539246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539287 */     GIR_RootConstrainSelectedInstOperands,
     /* 539288 */     // GIR_Coverage, 11859,
     /* 539288 */     GIR_EraseRootFromParent_Done,
     /* 539289 */   // Label 7040: @539289
     /* 539289 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(539424), // Rule ID 12336 //
     /* 539294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539378 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539422 */     GIR_RootConstrainSelectedInstOperands,
     /* 539423 */     // GIR_Coverage, 12336,
     /* 539423 */     GIR_EraseRootFromParent_Done,
     /* 539424 */   // Label 7041: @539424
     /* 539424 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(539559), // Rule ID 12337 //
     /* 539429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539513 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539557 */     GIR_RootConstrainSelectedInstOperands,
     /* 539558 */     // GIR_Coverage, 12337,
     /* 539558 */     GIR_EraseRootFromParent_Done,
     /* 539559 */   // Label 7042: @539559
     /* 539559 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(539694), // Rule ID 12338 //
     /* 539564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539648 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539692 */     GIR_RootConstrainSelectedInstOperands,
     /* 539693 */     // GIR_Coverage, 12338,
     /* 539693 */     GIR_EraseRootFromParent_Done,
     /* 539694 */   // Label 7043: @539694
     /* 539694 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(539829), // Rule ID 12339 //
     /* 539699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539783 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539827 */     GIR_RootConstrainSelectedInstOperands,
     /* 539828 */     // GIR_Coverage, 12339,
     /* 539828 */     GIR_EraseRootFromParent_Done,
     /* 539829 */   // Label 7044: @539829
     /* 539829 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(539964), // Rule ID 12816 //
     /* 539834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539918 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539962 */     GIR_RootConstrainSelectedInstOperands,
     /* 539963 */     // GIR_Coverage, 12816,
     /* 539963 */     GIR_EraseRootFromParent_Done,
     /* 539964 */   // Label 7045: @539964
     /* 539964 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(540099), // Rule ID 12817 //
     /* 539969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 540000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540053 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 540056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540097 */     GIR_RootConstrainSelectedInstOperands,
     /* 540098 */     // GIR_Coverage, 12817,
     /* 540098 */     GIR_EraseRootFromParent_Done,
     /* 540099 */   // Label 7046: @540099
     /* 540099 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(540234), // Rule ID 12818 //
     /* 540104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 540107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 540135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540188 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 540191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540232 */     GIR_RootConstrainSelectedInstOperands,
     /* 540233 */     // GIR_Coverage, 12818,
     /* 540233 */     GIR_EraseRootFromParent_Done,
     /* 540234 */   // Label 7047: @540234
     /* 540234 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(540369), // Rule ID 12819 //
     /* 540239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 540242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 540270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540323 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 540326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540367 */     GIR_RootConstrainSelectedInstOperands,
     /* 540368 */     // GIR_Coverage, 12819,
     /* 540368 */     GIR_EraseRootFromParent_Done,
     /* 540369 */   // Label 7048: @540369
     /* 540369 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(540504), // Rule ID 11901 //
     /* 540374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540458 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540502 */     GIR_RootConstrainSelectedInstOperands,
     /* 540503 */     // GIR_Coverage, 11901,
     /* 540503 */     GIR_EraseRootFromParent_Done,
     /* 540504 */   // Label 7049: @540504
     /* 540504 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(540639), // Rule ID 11902 //
     /* 540509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540593 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540637 */     GIR_RootConstrainSelectedInstOperands,
     /* 540638 */     // GIR_Coverage, 11902,
     /* 540638 */     GIR_EraseRootFromParent_Done,
     /* 540639 */   // Label 7050: @540639
     /* 540639 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(540774), // Rule ID 11903 //
     /* 540644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540728 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540772 */     GIR_RootConstrainSelectedInstOperands,
     /* 540773 */     // GIR_Coverage, 11903,
     /* 540773 */     GIR_EraseRootFromParent_Done,
     /* 540774 */   // Label 7051: @540774
     /* 540774 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(540909), // Rule ID 11904 //
     /* 540779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540863 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540907 */     GIR_RootConstrainSelectedInstOperands,
     /* 540908 */     // GIR_Coverage, 11904,
     /* 540908 */     GIR_EraseRootFromParent_Done,
     /* 540909 */   // Label 7052: @540909
     /* 540909 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(541044), // Rule ID 12381 //
     /* 540914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540998 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541042 */     GIR_RootConstrainSelectedInstOperands,
     /* 541043 */     // GIR_Coverage, 12381,
     /* 541043 */     GIR_EraseRootFromParent_Done,
     /* 541044 */   // Label 7053: @541044
     /* 541044 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(541179), // Rule ID 12382 //
     /* 541049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541133 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541177 */     GIR_RootConstrainSelectedInstOperands,
     /* 541178 */     // GIR_Coverage, 12382,
     /* 541178 */     GIR_EraseRootFromParent_Done,
     /* 541179 */   // Label 7054: @541179
     /* 541179 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(541314), // Rule ID 12383 //
     /* 541184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541268 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541312 */     GIR_RootConstrainSelectedInstOperands,
     /* 541313 */     // GIR_Coverage, 12383,
     /* 541313 */     GIR_EraseRootFromParent_Done,
     /* 541314 */   // Label 7055: @541314
     /* 541314 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(541449), // Rule ID 12384 //
     /* 541319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541403 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541447 */     GIR_RootConstrainSelectedInstOperands,
     /* 541448 */     // GIR_Coverage, 12384,
     /* 541448 */     GIR_EraseRootFromParent_Done,
     /* 541449 */   // Label 7056: @541449
     /* 541449 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(541584), // Rule ID 12861 //
     /* 541454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541538 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541582 */     GIR_RootConstrainSelectedInstOperands,
     /* 541583 */     // GIR_Coverage, 12861,
     /* 541583 */     GIR_EraseRootFromParent_Done,
     /* 541584 */   // Label 7057: @541584
     /* 541584 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(541719), // Rule ID 12862 //
     /* 541589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541673 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541717 */     GIR_RootConstrainSelectedInstOperands,
     /* 541718 */     // GIR_Coverage, 12862,
     /* 541718 */     GIR_EraseRootFromParent_Done,
     /* 541719 */   // Label 7058: @541719
     /* 541719 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(541854), // Rule ID 12863 //
     /* 541724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541808 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541852 */     GIR_RootConstrainSelectedInstOperands,
     /* 541853 */     // GIR_Coverage, 12863,
     /* 541853 */     GIR_EraseRootFromParent_Done,
     /* 541854 */   // Label 7059: @541854
     /* 541854 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(541989), // Rule ID 12864 //
     /* 541859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541943 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541987 */     GIR_RootConstrainSelectedInstOperands,
     /* 541988 */     // GIR_Coverage, 12864,
     /* 541988 */     GIR_EraseRootFromParent_Done,
     /* 541989 */   // Label 7060: @541989
     /* 541989 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(542124), // Rule ID 11841 //
     /* 541994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542078 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542122 */     GIR_RootConstrainSelectedInstOperands,
     /* 542123 */     // GIR_Coverage, 11841,
     /* 542123 */     GIR_EraseRootFromParent_Done,
     /* 542124 */   // Label 7061: @542124
     /* 542124 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(542259), // Rule ID 11842 //
     /* 542129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 542132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542213 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542257 */     GIR_RootConstrainSelectedInstOperands,
     /* 542258 */     // GIR_Coverage, 11842,
     /* 542258 */     GIR_EraseRootFromParent_Done,
     /* 542259 */   // Label 7062: @542259
     /* 542259 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(542394), // Rule ID 11843 //
     /* 542264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 542267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542348 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542392 */     GIR_RootConstrainSelectedInstOperands,
     /* 542393 */     // GIR_Coverage, 11843,
     /* 542393 */     GIR_EraseRootFromParent_Done,
     /* 542394 */   // Label 7063: @542394
     /* 542394 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(542529), // Rule ID 11844 //
     /* 542399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 542402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542483 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542527 */     GIR_RootConstrainSelectedInstOperands,
     /* 542528 */     // GIR_Coverage, 11844,
     /* 542528 */     GIR_EraseRootFromParent_Done,
     /* 542529 */   // Label 7064: @542529
     /* 542529 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(542664), // Rule ID 12321 //
     /* 542534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542618 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542662 */     GIR_RootConstrainSelectedInstOperands,
     /* 542663 */     // GIR_Coverage, 12321,
     /* 542663 */     GIR_EraseRootFromParent_Done,
     /* 542664 */   // Label 7065: @542664
     /* 542664 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(542799), // Rule ID 12322 //
     /* 542669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542753 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542797 */     GIR_RootConstrainSelectedInstOperands,
     /* 542798 */     // GIR_Coverage, 12322,
     /* 542798 */     GIR_EraseRootFromParent_Done,
     /* 542799 */   // Label 7066: @542799
     /* 542799 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(542934), // Rule ID 12323 //
     /* 542804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542888 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542932 */     GIR_RootConstrainSelectedInstOperands,
     /* 542933 */     // GIR_Coverage, 12323,
     /* 542933 */     GIR_EraseRootFromParent_Done,
     /* 542934 */   // Label 7067: @542934
     /* 542934 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(543069), // Rule ID 12324 //
     /* 542939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543023 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543067 */     GIR_RootConstrainSelectedInstOperands,
     /* 543068 */     // GIR_Coverage, 12324,
     /* 543068 */     GIR_EraseRootFromParent_Done,
     /* 543069 */   // Label 7068: @543069
     /* 543069 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(543204), // Rule ID 12801 //
     /* 543074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543158 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543202 */     GIR_RootConstrainSelectedInstOperands,
     /* 543203 */     // GIR_Coverage, 12801,
     /* 543203 */     GIR_EraseRootFromParent_Done,
     /* 543204 */   // Label 7069: @543204
     /* 543204 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(543339), // Rule ID 12802 //
     /* 543209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543293 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543337 */     GIR_RootConstrainSelectedInstOperands,
     /* 543338 */     // GIR_Coverage, 12802,
     /* 543338 */     GIR_EraseRootFromParent_Done,
     /* 543339 */   // Label 7070: @543339
     /* 543339 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(543474), // Rule ID 12803 //
     /* 543344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543428 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543472 */     GIR_RootConstrainSelectedInstOperands,
     /* 543473 */     // GIR_Coverage, 12803,
     /* 543473 */     GIR_EraseRootFromParent_Done,
     /* 543474 */   // Label 7071: @543474
     /* 543474 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(543609), // Rule ID 12804 //
     /* 543479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543563 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543607 */     GIR_RootConstrainSelectedInstOperands,
     /* 543608 */     // GIR_Coverage, 12804,
     /* 543608 */     GIR_EraseRootFromParent_Done,
     /* 543609 */   // Label 7072: @543609
     /* 543609 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(543744), // Rule ID 11912 //
     /* 543614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543698 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 543708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 543713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543742 */     GIR_RootConstrainSelectedInstOperands,
     /* 543743 */     // GIR_Coverage, 11912,
     /* 543743 */     GIR_EraseRootFromParent_Done,
     /* 543744 */   // Label 7073: @543744
     /* 543744 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(543879), // Rule ID 11913 //
     /* 543749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543833 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 543843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 543848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543877 */     GIR_RootConstrainSelectedInstOperands,
     /* 543878 */     // GIR_Coverage, 11913,
     /* 543878 */     GIR_EraseRootFromParent_Done,
     /* 543879 */   // Label 7074: @543879
     /* 543879 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(544014), // Rule ID 11914 //
     /* 543884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543968 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 543988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 543993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544012 */     GIR_RootConstrainSelectedInstOperands,
     /* 544013 */     // GIR_Coverage, 11914,
     /* 544013 */     GIR_EraseRootFromParent_Done,
     /* 544014 */   // Label 7075: @544014
     /* 544014 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(544149), // Rule ID 11915 //
     /* 544019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544103 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 544106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544147 */     GIR_RootConstrainSelectedInstOperands,
     /* 544148 */     // GIR_Coverage, 11915,
     /* 544148 */     GIR_EraseRootFromParent_Done,
     /* 544149 */   // Label 7076: @544149
     /* 544149 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(544284), // Rule ID 12392 //
     /* 544154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544238 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544282 */     GIR_RootConstrainSelectedInstOperands,
     /* 544283 */     // GIR_Coverage, 12392,
     /* 544283 */     GIR_EraseRootFromParent_Done,
     /* 544284 */   // Label 7077: @544284
     /* 544284 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(544419), // Rule ID 12393 //
     /* 544289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544373 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544417 */     GIR_RootConstrainSelectedInstOperands,
     /* 544418 */     // GIR_Coverage, 12393,
     /* 544418 */     GIR_EraseRootFromParent_Done,
     /* 544419 */   // Label 7078: @544419
     /* 544419 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(544554), // Rule ID 12394 //
     /* 544424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544508 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544552 */     GIR_RootConstrainSelectedInstOperands,
     /* 544553 */     // GIR_Coverage, 12394,
     /* 544553 */     GIR_EraseRootFromParent_Done,
     /* 544554 */   // Label 7079: @544554
     /* 544554 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(544689), // Rule ID 12395 //
     /* 544559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544643 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544687 */     GIR_RootConstrainSelectedInstOperands,
     /* 544688 */     // GIR_Coverage, 12395,
     /* 544688 */     GIR_EraseRootFromParent_Done,
     /* 544689 */   // Label 7080: @544689
     /* 544689 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(544824), // Rule ID 12872 //
     /* 544694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544778 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544822 */     GIR_RootConstrainSelectedInstOperands,
     /* 544823 */     // GIR_Coverage, 12872,
     /* 544823 */     GIR_EraseRootFromParent_Done,
     /* 544824 */   // Label 7081: @544824
     /* 544824 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(544959), // Rule ID 12873 //
     /* 544829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544913 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544957 */     GIR_RootConstrainSelectedInstOperands,
     /* 544958 */     // GIR_Coverage, 12873,
     /* 544958 */     GIR_EraseRootFromParent_Done,
     /* 544959 */   // Label 7082: @544959
     /* 544959 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(545094), // Rule ID 12874 //
     /* 544964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545048 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 545051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545092 */     GIR_RootConstrainSelectedInstOperands,
     /* 545093 */     // GIR_Coverage, 12874,
     /* 545093 */     GIR_EraseRootFromParent_Done,
     /* 545094 */   // Label 7083: @545094
     /* 545094 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(545229), // Rule ID 12875 //
     /* 545099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 545102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545183 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 545186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545227 */     GIR_RootConstrainSelectedInstOperands,
     /* 545228 */     // GIR_Coverage, 12875,
     /* 545228 */     GIR_EraseRootFromParent_Done,
     /* 545229 */   // Label 7084: @545229
     /* 545229 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(545364), // Rule ID 11852 //
     /* 545234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545318 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545362 */     GIR_RootConstrainSelectedInstOperands,
     /* 545363 */     // GIR_Coverage, 11852,
     /* 545363 */     GIR_EraseRootFromParent_Done,
     /* 545364 */   // Label 7085: @545364
     /* 545364 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(545499), // Rule ID 11853 //
     /* 545369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545453 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545497 */     GIR_RootConstrainSelectedInstOperands,
     /* 545498 */     // GIR_Coverage, 11853,
     /* 545498 */     GIR_EraseRootFromParent_Done,
     /* 545499 */   // Label 7086: @545499
     /* 545499 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(545634), // Rule ID 11854 //
     /* 545504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545588 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545632 */     GIR_RootConstrainSelectedInstOperands,
     /* 545633 */     // GIR_Coverage, 11854,
     /* 545633 */     GIR_EraseRootFromParent_Done,
     /* 545634 */   // Label 7087: @545634
     /* 545634 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(545769), // Rule ID 11855 //
     /* 545639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545723 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545767 */     GIR_RootConstrainSelectedInstOperands,
     /* 545768 */     // GIR_Coverage, 11855,
     /* 545768 */     GIR_EraseRootFromParent_Done,
     /* 545769 */   // Label 7088: @545769
     /* 545769 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(545904), // Rule ID 12332 //
     /* 545774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545858 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545902 */     GIR_RootConstrainSelectedInstOperands,
     /* 545903 */     // GIR_Coverage, 12332,
     /* 545903 */     GIR_EraseRootFromParent_Done,
     /* 545904 */   // Label 7089: @545904
     /* 545904 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(546039), // Rule ID 12333 //
     /* 545909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545993 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546037 */     GIR_RootConstrainSelectedInstOperands,
     /* 546038 */     // GIR_Coverage, 12333,
     /* 546038 */     GIR_EraseRootFromParent_Done,
     /* 546039 */   // Label 7090: @546039
     /* 546039 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(546174), // Rule ID 12334 //
     /* 546044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 546047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 546051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546128 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 546131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546172 */     GIR_RootConstrainSelectedInstOperands,
     /* 546173 */     // GIR_Coverage, 12334,
     /* 546173 */     GIR_EraseRootFromParent_Done,
     /* 546174 */   // Label 7091: @546174
     /* 546174 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(546309), // Rule ID 12335 //
     /* 546179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 546182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 546186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546263 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 546266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546307 */     GIR_RootConstrainSelectedInstOperands,
     /* 546308 */     // GIR_Coverage, 12335,
     /* 546308 */     GIR_EraseRootFromParent_Done,
     /* 546309 */   // Label 7092: @546309
     /* 546309 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(546444), // Rule ID 12812 //
     /* 546314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546398 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546442 */     GIR_RootConstrainSelectedInstOperands,
     /* 546443 */     // GIR_Coverage, 12812,
     /* 546443 */     GIR_EraseRootFromParent_Done,
     /* 546444 */   // Label 7093: @546444
     /* 546444 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(546579), // Rule ID 12813 //
     /* 546449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546533 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546577 */     GIR_RootConstrainSelectedInstOperands,
     /* 546578 */     // GIR_Coverage, 12813,
     /* 546578 */     GIR_EraseRootFromParent_Done,
     /* 546579 */   // Label 7094: @546579
     /* 546579 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(546714), // Rule ID 12814 //
     /* 546584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546668 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546712 */     GIR_RootConstrainSelectedInstOperands,
     /* 546713 */     // GIR_Coverage, 12814,
     /* 546713 */     GIR_EraseRootFromParent_Done,
     /* 546714 */   // Label 7095: @546714
     /* 546714 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(546849), // Rule ID 12815 //
     /* 546719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546803 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546847 */     GIR_RootConstrainSelectedInstOperands,
     /* 546848 */     // GIR_Coverage, 12815,
     /* 546848 */     GIR_EraseRootFromParent_Done,
     /* 546849 */   // Label 7096: @546849
     /* 546849 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(546984), // Rule ID 11897 //
     /* 546854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546938 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546982 */     GIR_RootConstrainSelectedInstOperands,
     /* 546983 */     // GIR_Coverage, 11897,
     /* 546983 */     GIR_EraseRootFromParent_Done,
     /* 546984 */   // Label 7097: @546984
     /* 546984 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(547119), // Rule ID 11898 //
     /* 546989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547073 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547117 */     GIR_RootConstrainSelectedInstOperands,
     /* 547118 */     // GIR_Coverage, 11898,
     /* 547118 */     GIR_EraseRootFromParent_Done,
     /* 547119 */   // Label 7098: @547119
     /* 547119 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(547254), // Rule ID 11899 //
     /* 547124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 547127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547208 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547252 */     GIR_RootConstrainSelectedInstOperands,
     /* 547253 */     // GIR_Coverage, 11899,
     /* 547253 */     GIR_EraseRootFromParent_Done,
     /* 547254 */   // Label 7099: @547254
     /* 547254 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(547389), // Rule ID 11900 //
     /* 547259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 547262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547343 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547387 */     GIR_RootConstrainSelectedInstOperands,
     /* 547388 */     // GIR_Coverage, 11900,
     /* 547388 */     GIR_EraseRootFromParent_Done,
     /* 547389 */   // Label 7100: @547389
     /* 547389 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(547524), // Rule ID 12377 //
     /* 547394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547478 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547522 */     GIR_RootConstrainSelectedInstOperands,
     /* 547523 */     // GIR_Coverage, 12377,
     /* 547523 */     GIR_EraseRootFromParent_Done,
     /* 547524 */   // Label 7101: @547524
     /* 547524 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(547659), // Rule ID 12378 //
     /* 547529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547613 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547657 */     GIR_RootConstrainSelectedInstOperands,
     /* 547658 */     // GIR_Coverage, 12378,
     /* 547658 */     GIR_EraseRootFromParent_Done,
     /* 547659 */   // Label 7102: @547659
     /* 547659 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(547794), // Rule ID 12379 //
     /* 547664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547748 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547792 */     GIR_RootConstrainSelectedInstOperands,
     /* 547793 */     // GIR_Coverage, 12379,
     /* 547793 */     GIR_EraseRootFromParent_Done,
     /* 547794 */   // Label 7103: @547794
     /* 547794 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(547929), // Rule ID 12380 //
     /* 547799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547883 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547927 */     GIR_RootConstrainSelectedInstOperands,
     /* 547928 */     // GIR_Coverage, 12380,
     /* 547928 */     GIR_EraseRootFromParent_Done,
     /* 547929 */   // Label 7104: @547929
     /* 547929 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(548064), // Rule ID 12857 //
     /* 547934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548018 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548062 */     GIR_RootConstrainSelectedInstOperands,
     /* 548063 */     // GIR_Coverage, 12857,
     /* 548063 */     GIR_EraseRootFromParent_Done,
     /* 548064 */   // Label 7105: @548064
     /* 548064 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(548199), // Rule ID 12858 //
     /* 548069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548153 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548197 */     GIR_RootConstrainSelectedInstOperands,
     /* 548198 */     // GIR_Coverage, 12858,
     /* 548198 */     GIR_EraseRootFromParent_Done,
     /* 548199 */   // Label 7106: @548199
     /* 548199 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(548334), // Rule ID 12859 //
     /* 548204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548288 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548332 */     GIR_RootConstrainSelectedInstOperands,
     /* 548333 */     // GIR_Coverage, 12859,
     /* 548333 */     GIR_EraseRootFromParent_Done,
     /* 548334 */   // Label 7107: @548334
     /* 548334 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(548469), // Rule ID 12860 //
     /* 548339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548423 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548467 */     GIR_RootConstrainSelectedInstOperands,
     /* 548468 */     // GIR_Coverage, 12860,
     /* 548468 */     GIR_EraseRootFromParent_Done,
     /* 548469 */   // Label 7108: @548469
     /* 548469 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(548604), // Rule ID 11837 //
     /* 548474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548558 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548602 */     GIR_RootConstrainSelectedInstOperands,
     /* 548603 */     // GIR_Coverage, 11837,
     /* 548603 */     GIR_EraseRootFromParent_Done,
     /* 548604 */   // Label 7109: @548604
     /* 548604 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(548739), // Rule ID 11838 //
     /* 548609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548693 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548737 */     GIR_RootConstrainSelectedInstOperands,
     /* 548738 */     // GIR_Coverage, 11838,
     /* 548738 */     GIR_EraseRootFromParent_Done,
     /* 548739 */   // Label 7110: @548739
     /* 548739 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(548874), // Rule ID 11839 //
     /* 548744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548828 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548872 */     GIR_RootConstrainSelectedInstOperands,
     /* 548873 */     // GIR_Coverage, 11839,
     /* 548873 */     GIR_EraseRootFromParent_Done,
     /* 548874 */   // Label 7111: @548874
     /* 548874 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(549009), // Rule ID 11840 //
     /* 548879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548963 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549007 */     GIR_RootConstrainSelectedInstOperands,
     /* 549008 */     // GIR_Coverage, 11840,
     /* 549008 */     GIR_EraseRootFromParent_Done,
     /* 549009 */   // Label 7112: @549009
     /* 549009 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(549144), // Rule ID 12317 //
     /* 549014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549098 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549142 */     GIR_RootConstrainSelectedInstOperands,
     /* 549143 */     // GIR_Coverage, 12317,
     /* 549143 */     GIR_EraseRootFromParent_Done,
     /* 549144 */   // Label 7113: @549144
     /* 549144 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(549279), // Rule ID 12318 //
     /* 549149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549233 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549277 */     GIR_RootConstrainSelectedInstOperands,
     /* 549278 */     // GIR_Coverage, 12318,
     /* 549278 */     GIR_EraseRootFromParent_Done,
     /* 549279 */   // Label 7114: @549279
     /* 549279 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(549414), // Rule ID 12319 //
     /* 549284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549368 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549412 */     GIR_RootConstrainSelectedInstOperands,
     /* 549413 */     // GIR_Coverage, 12319,
     /* 549413 */     GIR_EraseRootFromParent_Done,
     /* 549414 */   // Label 7115: @549414
     /* 549414 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(549549), // Rule ID 12320 //
     /* 549419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549503 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549547 */     GIR_RootConstrainSelectedInstOperands,
     /* 549548 */     // GIR_Coverage, 12320,
     /* 549548 */     GIR_EraseRootFromParent_Done,
     /* 549549 */   // Label 7116: @549549
     /* 549549 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(549684), // Rule ID 12797 //
     /* 549554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549638 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549682 */     GIR_RootConstrainSelectedInstOperands,
     /* 549683 */     // GIR_Coverage, 12797,
     /* 549683 */     GIR_EraseRootFromParent_Done,
     /* 549684 */   // Label 7117: @549684
     /* 549684 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(549819), // Rule ID 12798 //
     /* 549689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549773 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549817 */     GIR_RootConstrainSelectedInstOperands,
     /* 549818 */     // GIR_Coverage, 12798,
     /* 549818 */     GIR_EraseRootFromParent_Done,
     /* 549819 */   // Label 7118: @549819
     /* 549819 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(549954), // Rule ID 12799 //
     /* 549824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549908 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549952 */     GIR_RootConstrainSelectedInstOperands,
     /* 549953 */     // GIR_Coverage, 12799,
     /* 549953 */     GIR_EraseRootFromParent_Done,
     /* 549954 */   // Label 7119: @549954
     /* 549954 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(550089), // Rule ID 12800 //
     /* 549959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550043 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550087 */     GIR_RootConstrainSelectedInstOperands,
     /* 550088 */     // GIR_Coverage, 12800,
     /* 550088 */     GIR_EraseRootFromParent_Done,
     /* 550089 */   // Label 7120: @550089
     /* 550089 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(550224), // Rule ID 11846 //
     /* 550094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550178 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550222 */     GIR_RootConstrainSelectedInstOperands,
     /* 550223 */     // GIR_Coverage, 11846,
     /* 550223 */     GIR_EraseRootFromParent_Done,
     /* 550224 */   // Label 7121: @550224
     /* 550224 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(550359), // Rule ID 11847 //
     /* 550229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550313 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550357 */     GIR_RootConstrainSelectedInstOperands,
     /* 550358 */     // GIR_Coverage, 11847,
     /* 550358 */     GIR_EraseRootFromParent_Done,
     /* 550359 */   // Label 7122: @550359
     /* 550359 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(550494), // Rule ID 11850 //
     /* 550364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550448 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550492 */     GIR_RootConstrainSelectedInstOperands,
     /* 550493 */     // GIR_Coverage, 11850,
     /* 550493 */     GIR_EraseRootFromParent_Done,
     /* 550494 */   // Label 7123: @550494
     /* 550494 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(550629), // Rule ID 11851 //
     /* 550499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550583 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550627 */     GIR_RootConstrainSelectedInstOperands,
     /* 550628 */     // GIR_Coverage, 11851,
     /* 550628 */     GIR_EraseRootFromParent_Done,
     /* 550629 */   // Label 7124: @550629
     /* 550629 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(550764), // Rule ID 12326 //
     /* 550634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550718 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550762 */     GIR_RootConstrainSelectedInstOperands,
     /* 550763 */     // GIR_Coverage, 12326,
     /* 550763 */     GIR_EraseRootFromParent_Done,
     /* 550764 */   // Label 7125: @550764
     /* 550764 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(550899), // Rule ID 12327 //
     /* 550769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550853 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550897 */     GIR_RootConstrainSelectedInstOperands,
     /* 550898 */     // GIR_Coverage, 12327,
     /* 550898 */     GIR_EraseRootFromParent_Done,
     /* 550899 */   // Label 7126: @550899
     /* 550899 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(551034), // Rule ID 12330 //
     /* 550904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550988 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551032 */     GIR_RootConstrainSelectedInstOperands,
     /* 551033 */     // GIR_Coverage, 12330,
     /* 551033 */     GIR_EraseRootFromParent_Done,
     /* 551034 */   // Label 7127: @551034
     /* 551034 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(551169), // Rule ID 12331 //
     /* 551039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551123 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 551126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551167 */     GIR_RootConstrainSelectedInstOperands,
     /* 551168 */     // GIR_Coverage, 12331,
     /* 551168 */     GIR_EraseRootFromParent_Done,
     /* 551169 */   // Label 7128: @551169
     /* 551169 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(551304), // Rule ID 12806 //
     /* 551174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551258 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551302 */     GIR_RootConstrainSelectedInstOperands,
     /* 551303 */     // GIR_Coverage, 12806,
     /* 551303 */     GIR_EraseRootFromParent_Done,
     /* 551304 */   // Label 7129: @551304
     /* 551304 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(551439), // Rule ID 12807 //
     /* 551309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551393 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551437 */     GIR_RootConstrainSelectedInstOperands,
     /* 551438 */     // GIR_Coverage, 12807,
     /* 551438 */     GIR_EraseRootFromParent_Done,
     /* 551439 */   // Label 7130: @551439
     /* 551439 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(551574), // Rule ID 12810 //
     /* 551444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551528 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551572 */     GIR_RootConstrainSelectedInstOperands,
     /* 551573 */     // GIR_Coverage, 12810,
     /* 551573 */     GIR_EraseRootFromParent_Done,
     /* 551574 */   // Label 7131: @551574
     /* 551574 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(551709), // Rule ID 12811 //
     /* 551579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551663 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551707 */     GIR_RootConstrainSelectedInstOperands,
     /* 551708 */     // GIR_Coverage, 12811,
     /* 551708 */     GIR_EraseRootFromParent_Done,
     /* 551709 */   // Label 7132: @551709
     /* 551709 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(551844), // Rule ID 11831 //
     /* 551714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551798 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551842 */     GIR_RootConstrainSelectedInstOperands,
     /* 551843 */     // GIR_Coverage, 11831,
     /* 551843 */     GIR_EraseRootFromParent_Done,
     /* 551844 */   // Label 7133: @551844
     /* 551844 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(551979), // Rule ID 11832 //
     /* 551849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551933 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551977 */     GIR_RootConstrainSelectedInstOperands,
     /* 551978 */     // GIR_Coverage, 11832,
     /* 551978 */     GIR_EraseRootFromParent_Done,
     /* 551979 */   // Label 7134: @551979
     /* 551979 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(552114), // Rule ID 11835 //
     /* 551984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552068 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 552071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552112 */     GIR_RootConstrainSelectedInstOperands,
     /* 552113 */     // GIR_Coverage, 11835,
     /* 552113 */     GIR_EraseRootFromParent_Done,
     /* 552114 */   // Label 7135: @552114
     /* 552114 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(552249), // Rule ID 11836 //
     /* 552119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 552122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552203 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 552206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552247 */     GIR_RootConstrainSelectedInstOperands,
     /* 552248 */     // GIR_Coverage, 11836,
     /* 552248 */     GIR_EraseRootFromParent_Done,
     /* 552249 */   // Label 7136: @552249
     /* 552249 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(552384), // Rule ID 12311 //
     /* 552254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552338 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552382 */     GIR_RootConstrainSelectedInstOperands,
     /* 552383 */     // GIR_Coverage, 12311,
     /* 552383 */     GIR_EraseRootFromParent_Done,
     /* 552384 */   // Label 7137: @552384
     /* 552384 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(552519), // Rule ID 12312 //
     /* 552389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552473 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552517 */     GIR_RootConstrainSelectedInstOperands,
     /* 552518 */     // GIR_Coverage, 12312,
     /* 552518 */     GIR_EraseRootFromParent_Done,
     /* 552519 */   // Label 7138: @552519
     /* 552519 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(552654), // Rule ID 12315 //
     /* 552524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552608 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552652 */     GIR_RootConstrainSelectedInstOperands,
     /* 552653 */     // GIR_Coverage, 12315,
     /* 552653 */     GIR_EraseRootFromParent_Done,
     /* 552654 */   // Label 7139: @552654
     /* 552654 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(552789), // Rule ID 12316 //
     /* 552659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552743 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552787 */     GIR_RootConstrainSelectedInstOperands,
     /* 552788 */     // GIR_Coverage, 12316,
     /* 552788 */     GIR_EraseRootFromParent_Done,
     /* 552789 */   // Label 7140: @552789
     /* 552789 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(552924), // Rule ID 12791 //
     /* 552794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552878 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552922 */     GIR_RootConstrainSelectedInstOperands,
     /* 552923 */     // GIR_Coverage, 12791,
     /* 552923 */     GIR_EraseRootFromParent_Done,
     /* 552924 */   // Label 7141: @552924
     /* 552924 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(553059), // Rule ID 12792 //
     /* 552929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553013 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553057 */     GIR_RootConstrainSelectedInstOperands,
     /* 553058 */     // GIR_Coverage, 12792,
     /* 553058 */     GIR_EraseRootFromParent_Done,
     /* 553059 */   // Label 7142: @553059
     /* 553059 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(553194), // Rule ID 12795 //
     /* 553064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 553107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553148 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553192 */     GIR_RootConstrainSelectedInstOperands,
     /* 553193 */     // GIR_Coverage, 12795,
     /* 553193 */     GIR_EraseRootFromParent_Done,
     /* 553194 */   // Label 7143: @553194
     /* 553194 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(553329), // Rule ID 12796 //
     /* 553199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 553242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553283 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553327 */     GIR_RootConstrainSelectedInstOperands,
     /* 553328 */     // GIR_Coverage, 12796,
     /* 553328 */     GIR_EraseRootFromParent_Done,
     /* 553329 */   // Label 7144: @553329
     /* 553329 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(553464), // Rule ID 7621 //
     /* 553334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553418 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553462 */     GIR_RootConstrainSelectedInstOperands,
     /* 553463 */     // GIR_Coverage, 7621,
     /* 553463 */     GIR_EraseRootFromParent_Done,
     /* 553464 */   // Label 7145: @553464
     /* 553464 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(553599), // Rule ID 7653 //
     /* 553469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553521 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553553 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553597 */     GIR_RootConstrainSelectedInstOperands,
     /* 553598 */     // GIR_Coverage, 7653,
     /* 553598 */     GIR_EraseRootFromParent_Done,
     /* 553599 */   // Label 7146: @553599
     /* 553599 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(553734), // Rule ID 7685 //
     /* 553604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553688 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553732 */     GIR_RootConstrainSelectedInstOperands,
     /* 553733 */     // GIR_Coverage, 7685,
     /* 553733 */     GIR_EraseRootFromParent_Done,
     /* 553734 */   // Label 7147: @553734
     /* 553734 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(553869), // Rule ID 11845 //
     /* 553739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553823 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553867 */     GIR_RootConstrainSelectedInstOperands,
     /* 553868 */     // GIR_Coverage, 11845,
     /* 553868 */     GIR_EraseRootFromParent_Done,
     /* 553869 */   // Label 7148: @553869
     /* 553869 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(554004), // Rule ID 11848 //
     /* 553874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553958 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554002 */     GIR_RootConstrainSelectedInstOperands,
     /* 554003 */     // GIR_Coverage, 11848,
     /* 554003 */     GIR_EraseRootFromParent_Done,
     /* 554004 */   // Label 7149: @554004
     /* 554004 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(554139), // Rule ID 11849 //
     /* 554009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554093 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554137 */     GIR_RootConstrainSelectedInstOperands,
     /* 554138 */     // GIR_Coverage, 11849,
     /* 554138 */     GIR_EraseRootFromParent_Done,
     /* 554139 */   // Label 7150: @554139
     /* 554139 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(554274), // Rule ID 12325 //
     /* 554144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554191 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554196 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554228 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554272 */     GIR_RootConstrainSelectedInstOperands,
     /* 554273 */     // GIR_Coverage, 12325,
     /* 554273 */     GIR_EraseRootFromParent_Done,
     /* 554274 */   // Label 7151: @554274
     /* 554274 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(554409), // Rule ID 12328 //
     /* 554279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554326 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554331 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554363 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554407 */     GIR_RootConstrainSelectedInstOperands,
     /* 554408 */     // GIR_Coverage, 12328,
     /* 554408 */     GIR_EraseRootFromParent_Done,
     /* 554409 */   // Label 7152: @554409
     /* 554409 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(554544), // Rule ID 12329 //
     /* 554414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554461 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554466 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554498 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554542 */     GIR_RootConstrainSelectedInstOperands,
     /* 554543 */     // GIR_Coverage, 12329,
     /* 554543 */     GIR_EraseRootFromParent_Done,
     /* 554544 */   // Label 7153: @554544
     /* 554544 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(554679), // Rule ID 12805 //
     /* 554549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554633 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554677 */     GIR_RootConstrainSelectedInstOperands,
     /* 554678 */     // GIR_Coverage, 12805,
     /* 554678 */     GIR_EraseRootFromParent_Done,
     /* 554679 */   // Label 7154: @554679
     /* 554679 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(554814), // Rule ID 12808 //
     /* 554684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554768 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554812 */     GIR_RootConstrainSelectedInstOperands,
     /* 554813 */     // GIR_Coverage, 12808,
     /* 554813 */     GIR_EraseRootFromParent_Done,
     /* 554814 */   // Label 7155: @554814
     /* 554814 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(554949), // Rule ID 12809 //
     /* 554819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554903 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554947 */     GIR_RootConstrainSelectedInstOperands,
     /* 554948 */     // GIR_Coverage, 12809,
     /* 554948 */     GIR_EraseRootFromParent_Done,
     /* 554949 */   // Label 7156: @554949
     /* 554949 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(555084), // Rule ID 7620 //
     /* 554954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555038 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555082 */     GIR_RootConstrainSelectedInstOperands,
     /* 555083 */     // GIR_Coverage, 7620,
     /* 555083 */     GIR_EraseRootFromParent_Done,
     /* 555084 */   // Label 7157: @555084
     /* 555084 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(555219), // Rule ID 7652 //
     /* 555089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555136 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555141 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555173 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555217 */     GIR_RootConstrainSelectedInstOperands,
     /* 555218 */     // GIR_Coverage, 7652,
     /* 555218 */     GIR_EraseRootFromParent_Done,
     /* 555219 */   // Label 7158: @555219
     /* 555219 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(555354), // Rule ID 7684 //
     /* 555224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555308 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555352 */     GIR_RootConstrainSelectedInstOperands,
     /* 555353 */     // GIR_Coverage, 7684,
     /* 555353 */     GIR_EraseRootFromParent_Done,
     /* 555354 */   // Label 7159: @555354
     /* 555354 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(555489), // Rule ID 11830 //
     /* 555359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555443 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555487 */     GIR_RootConstrainSelectedInstOperands,
     /* 555488 */     // GIR_Coverage, 11830,
     /* 555488 */     GIR_EraseRootFromParent_Done,
     /* 555489 */   // Label 7160: @555489
     /* 555489 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(555624), // Rule ID 11833 //
     /* 555494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555578 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555622 */     GIR_RootConstrainSelectedInstOperands,
     /* 555623 */     // GIR_Coverage, 11833,
     /* 555623 */     GIR_EraseRootFromParent_Done,
     /* 555624 */   // Label 7161: @555624
     /* 555624 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(555759), // Rule ID 11834 //
     /* 555629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555713 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555757 */     GIR_RootConstrainSelectedInstOperands,
     /* 555758 */     // GIR_Coverage, 11834,
     /* 555758 */     GIR_EraseRootFromParent_Done,
     /* 555759 */   // Label 7162: @555759
     /* 555759 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(555894), // Rule ID 12310 //
     /* 555764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555811 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555816 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555848 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555892 */     GIR_RootConstrainSelectedInstOperands,
     /* 555893 */     // GIR_Coverage, 12310,
     /* 555893 */     GIR_EraseRootFromParent_Done,
     /* 555894 */   // Label 7163: @555894
     /* 555894 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(556029), // Rule ID 12313 //
     /* 555899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555946 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555951 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555983 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556027 */     GIR_RootConstrainSelectedInstOperands,
     /* 556028 */     // GIR_Coverage, 12313,
     /* 556028 */     GIR_EraseRootFromParent_Done,
     /* 556029 */   // Label 7164: @556029
     /* 556029 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(556164), // Rule ID 12314 //
     /* 556034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556081 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556086 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556118 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556162 */     GIR_RootConstrainSelectedInstOperands,
     /* 556163 */     // GIR_Coverage, 12314,
     /* 556163 */     GIR_EraseRootFromParent_Done,
     /* 556164 */   // Label 7165: @556164
     /* 556164 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(556299), // Rule ID 12790 //
     /* 556169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556253 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 556256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556297 */     GIR_RootConstrainSelectedInstOperands,
     /* 556298 */     // GIR_Coverage, 12790,
     /* 556298 */     GIR_EraseRootFromParent_Done,
     /* 556299 */   // Label 7166: @556299
     /* 556299 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(556434), // Rule ID 12793 //
     /* 556304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556388 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 556391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556432 */     GIR_RootConstrainSelectedInstOperands,
     /* 556433 */     // GIR_Coverage, 12793,
     /* 556433 */     GIR_EraseRootFromParent_Done,
     /* 556434 */   // Label 7167: @556434
     /* 556434 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(556569), // Rule ID 12794 //
     /* 556439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556523 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 556526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556567 */     GIR_RootConstrainSelectedInstOperands,
     /* 556568 */     // GIR_Coverage, 12794,
     /* 556568 */     GIR_EraseRootFromParent_Done,
     /* 556569 */   // Label 7168: @556569
     /* 556569 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(556704), // Rule ID 11816 //
     /* 556574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556658 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556702 */     GIR_RootConstrainSelectedInstOperands,
     /* 556703 */     // GIR_Coverage, 11816,
     /* 556703 */     GIR_EraseRootFromParent_Done,
     /* 556704 */   // Label 7169: @556704
     /* 556704 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(556839), // Rule ID 11817 //
     /* 556709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556793 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556837 */     GIR_RootConstrainSelectedInstOperands,
     /* 556838 */     // GIR_Coverage, 11817,
     /* 556838 */     GIR_EraseRootFromParent_Done,
     /* 556839 */   // Label 7170: @556839
     /* 556839 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(556974), // Rule ID 11820 //
     /* 556844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556928 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556972 */     GIR_RootConstrainSelectedInstOperands,
     /* 556973 */     // GIR_Coverage, 11820,
     /* 556973 */     GIR_EraseRootFromParent_Done,
     /* 556974 */   // Label 7171: @556974
     /* 556974 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(557109), // Rule ID 11821 //
     /* 556979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557063 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 557066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557107 */     GIR_RootConstrainSelectedInstOperands,
     /* 557108 */     // GIR_Coverage, 11821,
     /* 557108 */     GIR_EraseRootFromParent_Done,
     /* 557109 */   // Label 7172: @557109
     /* 557109 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(557244), // Rule ID 12296 //
     /* 557114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557198 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557242 */     GIR_RootConstrainSelectedInstOperands,
     /* 557243 */     // GIR_Coverage, 12296,
     /* 557243 */     GIR_EraseRootFromParent_Done,
     /* 557244 */   // Label 7173: @557244
     /* 557244 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(557379), // Rule ID 12297 //
     /* 557249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557333 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557377 */     GIR_RootConstrainSelectedInstOperands,
     /* 557378 */     // GIR_Coverage, 12297,
     /* 557378 */     GIR_EraseRootFromParent_Done,
     /* 557379 */   // Label 7174: @557379
     /* 557379 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(557514), // Rule ID 12300 //
     /* 557384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557468 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557512 */     GIR_RootConstrainSelectedInstOperands,
     /* 557513 */     // GIR_Coverage, 12300,
     /* 557513 */     GIR_EraseRootFromParent_Done,
     /* 557514 */   // Label 7175: @557514
     /* 557514 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(557649), // Rule ID 12301 //
     /* 557519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557603 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557647 */     GIR_RootConstrainSelectedInstOperands,
     /* 557648 */     // GIR_Coverage, 12301,
     /* 557648 */     GIR_EraseRootFromParent_Done,
     /* 557649 */   // Label 7176: @557649
     /* 557649 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(557784), // Rule ID 12776 //
     /* 557654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557738 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557782 */     GIR_RootConstrainSelectedInstOperands,
     /* 557783 */     // GIR_Coverage, 12776,
     /* 557783 */     GIR_EraseRootFromParent_Done,
     /* 557784 */   // Label 7177: @557784
     /* 557784 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(557919), // Rule ID 12777 //
     /* 557789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557873 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557917 */     GIR_RootConstrainSelectedInstOperands,
     /* 557918 */     // GIR_Coverage, 12777,
     /* 557918 */     GIR_EraseRootFromParent_Done,
     /* 557919 */   // Label 7178: @557919
     /* 557919 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(558054), // Rule ID 12780 //
     /* 557924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558008 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 558011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558052 */     GIR_RootConstrainSelectedInstOperands,
     /* 558053 */     // GIR_Coverage, 12780,
     /* 558053 */     GIR_EraseRootFromParent_Done,
     /* 558054 */   // Label 7179: @558054
     /* 558054 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(558189), // Rule ID 12781 //
     /* 558059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 558062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558143 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 558146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558187 */     GIR_RootConstrainSelectedInstOperands,
     /* 558188 */     // GIR_Coverage, 12781,
     /* 558188 */     GIR_EraseRootFromParent_Done,
     /* 558189 */   // Label 7180: @558189
     /* 558189 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(558324), // Rule ID 11801 //
     /* 558194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558278 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558322 */     GIR_RootConstrainSelectedInstOperands,
     /* 558323 */     // GIR_Coverage, 11801,
     /* 558323 */     GIR_EraseRootFromParent_Done,
     /* 558324 */   // Label 7181: @558324
     /* 558324 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(558459), // Rule ID 11802 //
     /* 558329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558413 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558457 */     GIR_RootConstrainSelectedInstOperands,
     /* 558458 */     // GIR_Coverage, 11802,
     /* 558458 */     GIR_EraseRootFromParent_Done,
     /* 558459 */   // Label 7182: @558459
     /* 558459 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(558594), // Rule ID 11805 //
     /* 558464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558548 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558592 */     GIR_RootConstrainSelectedInstOperands,
     /* 558593 */     // GIR_Coverage, 11805,
     /* 558593 */     GIR_EraseRootFromParent_Done,
     /* 558594 */   // Label 7183: @558594
     /* 558594 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(558729), // Rule ID 11806 //
     /* 558599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558683 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558727 */     GIR_RootConstrainSelectedInstOperands,
     /* 558728 */     // GIR_Coverage, 11806,
     /* 558728 */     GIR_EraseRootFromParent_Done,
     /* 558729 */   // Label 7184: @558729
     /* 558729 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(558864), // Rule ID 12281 //
     /* 558734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558818 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558862 */     GIR_RootConstrainSelectedInstOperands,
     /* 558863 */     // GIR_Coverage, 12281,
     /* 558863 */     GIR_EraseRootFromParent_Done,
     /* 558864 */   // Label 7185: @558864
     /* 558864 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(558999), // Rule ID 12282 //
     /* 558869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558953 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558997 */     GIR_RootConstrainSelectedInstOperands,
     /* 558998 */     // GIR_Coverage, 12282,
     /* 558998 */     GIR_EraseRootFromParent_Done,
     /* 558999 */   // Label 7186: @558999
     /* 558999 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(559134), // Rule ID 12285 //
     /* 559004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559088 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 559091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559132 */     GIR_RootConstrainSelectedInstOperands,
     /* 559133 */     // GIR_Coverage, 12285,
     /* 559133 */     GIR_EraseRootFromParent_Done,
     /* 559134 */   // Label 7187: @559134
     /* 559134 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(559269), // Rule ID 12286 //
     /* 559139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559223 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 559226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559267 */     GIR_RootConstrainSelectedInstOperands,
     /* 559268 */     // GIR_Coverage, 12286,
     /* 559268 */     GIR_EraseRootFromParent_Done,
     /* 559269 */   // Label 7188: @559269
     /* 559269 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(559404), // Rule ID 12761 //
     /* 559274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559358 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559402 */     GIR_RootConstrainSelectedInstOperands,
     /* 559403 */     // GIR_Coverage, 12761,
     /* 559403 */     GIR_EraseRootFromParent_Done,
     /* 559404 */   // Label 7189: @559404
     /* 559404 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(559539), // Rule ID 12762 //
     /* 559409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559493 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559537 */     GIR_RootConstrainSelectedInstOperands,
     /* 559538 */     // GIR_Coverage, 12762,
     /* 559538 */     GIR_EraseRootFromParent_Done,
     /* 559539 */   // Label 7190: @559539
     /* 559539 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(559674), // Rule ID 12765 //
     /* 559544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559628 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559672 */     GIR_RootConstrainSelectedInstOperands,
     /* 559673 */     // GIR_Coverage, 12765,
     /* 559673 */     GIR_EraseRootFromParent_Done,
     /* 559674 */   // Label 7191: @559674
     /* 559674 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(559809), // Rule ID 12766 //
     /* 559679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559763 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559807 */     GIR_RootConstrainSelectedInstOperands,
     /* 559808 */     // GIR_Coverage, 12766,
     /* 559808 */     GIR_EraseRootFromParent_Done,
     /* 559809 */   // Label 7192: @559809
     /* 559809 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(559944), // Rule ID 7619 //
     /* 559814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559898 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559942 */     GIR_RootConstrainSelectedInstOperands,
     /* 559943 */     // GIR_Coverage, 7619,
     /* 559943 */     GIR_EraseRootFromParent_Done,
     /* 559944 */   // Label 7193: @559944
     /* 559944 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(560079), // Rule ID 7651 //
     /* 559949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559996 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560001 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560033 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560077 */     GIR_RootConstrainSelectedInstOperands,
     /* 560078 */     // GIR_Coverage, 7651,
     /* 560078 */     GIR_EraseRootFromParent_Done,
     /* 560079 */   // Label 7194: @560079
     /* 560079 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(560214), // Rule ID 7683 //
     /* 560084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560168 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560212 */     GIR_RootConstrainSelectedInstOperands,
     /* 560213 */     // GIR_Coverage, 7683,
     /* 560213 */     GIR_EraseRootFromParent_Done,
     /* 560214 */   // Label 7195: @560214
     /* 560214 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(560349), // Rule ID 11815 //
     /* 560219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560303 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560347 */     GIR_RootConstrainSelectedInstOperands,
     /* 560348 */     // GIR_Coverage, 11815,
     /* 560348 */     GIR_EraseRootFromParent_Done,
     /* 560349 */   // Label 7196: @560349
     /* 560349 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(560484), // Rule ID 11818 //
     /* 560354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560438 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560482 */     GIR_RootConstrainSelectedInstOperands,
     /* 560483 */     // GIR_Coverage, 11818,
     /* 560483 */     GIR_EraseRootFromParent_Done,
     /* 560484 */   // Label 7197: @560484
     /* 560484 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(560619), // Rule ID 11819 //
     /* 560489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560573 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560617 */     GIR_RootConstrainSelectedInstOperands,
     /* 560618 */     // GIR_Coverage, 11819,
     /* 560618 */     GIR_EraseRootFromParent_Done,
     /* 560619 */   // Label 7198: @560619
     /* 560619 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(560754), // Rule ID 12295 //
     /* 560624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560671 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560676 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560708 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560752 */     GIR_RootConstrainSelectedInstOperands,
     /* 560753 */     // GIR_Coverage, 12295,
     /* 560753 */     GIR_EraseRootFromParent_Done,
     /* 560754 */   // Label 7199: @560754
     /* 560754 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(560889), // Rule ID 12298 //
     /* 560759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560806 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560811 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560843 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560887 */     GIR_RootConstrainSelectedInstOperands,
     /* 560888 */     // GIR_Coverage, 12298,
     /* 560888 */     GIR_EraseRootFromParent_Done,
     /* 560889 */   // Label 7200: @560889
     /* 560889 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(561024), // Rule ID 12299 //
     /* 560894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560941 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560946 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560978 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561022 */     GIR_RootConstrainSelectedInstOperands,
     /* 561023 */     // GIR_Coverage, 12299,
     /* 561023 */     GIR_EraseRootFromParent_Done,
     /* 561024 */   // Label 7201: @561024
     /* 561024 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(561159), // Rule ID 12775 //
     /* 561029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561113 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561157 */     GIR_RootConstrainSelectedInstOperands,
     /* 561158 */     // GIR_Coverage, 12775,
     /* 561158 */     GIR_EraseRootFromParent_Done,
     /* 561159 */   // Label 7202: @561159
     /* 561159 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(561294), // Rule ID 12778 //
     /* 561164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561248 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561292 */     GIR_RootConstrainSelectedInstOperands,
     /* 561293 */     // GIR_Coverage, 12778,
     /* 561293 */     GIR_EraseRootFromParent_Done,
     /* 561294 */   // Label 7203: @561294
     /* 561294 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(561429), // Rule ID 12779 //
     /* 561299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561383 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561427 */     GIR_RootConstrainSelectedInstOperands,
     /* 561428 */     // GIR_Coverage, 12779,
     /* 561428 */     GIR_EraseRootFromParent_Done,
     /* 561429 */   // Label 7204: @561429
     /* 561429 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(561564), // Rule ID 7618 //
     /* 561434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561518 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561562 */     GIR_RootConstrainSelectedInstOperands,
     /* 561563 */     // GIR_Coverage, 7618,
     /* 561563 */     GIR_EraseRootFromParent_Done,
     /* 561564 */   // Label 7205: @561564
     /* 561564 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(561699), // Rule ID 7650 //
     /* 561569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561616 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561621 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561653 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561697 */     GIR_RootConstrainSelectedInstOperands,
     /* 561698 */     // GIR_Coverage, 7650,
     /* 561698 */     GIR_EraseRootFromParent_Done,
     /* 561699 */   // Label 7206: @561699
     /* 561699 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(561834), // Rule ID 7682 //
     /* 561704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561788 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561832 */     GIR_RootConstrainSelectedInstOperands,
     /* 561833 */     // GIR_Coverage, 7682,
     /* 561833 */     GIR_EraseRootFromParent_Done,
     /* 561834 */   // Label 7207: @561834
     /* 561834 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(561969), // Rule ID 11800 //
     /* 561839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561923 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561967 */     GIR_RootConstrainSelectedInstOperands,
     /* 561968 */     // GIR_Coverage, 11800,
     /* 561968 */     GIR_EraseRootFromParent_Done,
     /* 561969 */   // Label 7208: @561969
     /* 561969 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(562104), // Rule ID 11803 //
     /* 561974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562058 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562102 */     GIR_RootConstrainSelectedInstOperands,
     /* 562103 */     // GIR_Coverage, 11803,
     /* 562103 */     GIR_EraseRootFromParent_Done,
     /* 562104 */   // Label 7209: @562104
     /* 562104 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(562239), // Rule ID 11804 //
     /* 562109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562193 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562237 */     GIR_RootConstrainSelectedInstOperands,
     /* 562238 */     // GIR_Coverage, 11804,
     /* 562238 */     GIR_EraseRootFromParent_Done,
     /* 562239 */   // Label 7210: @562239
     /* 562239 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(562374), // Rule ID 12280 //
     /* 562244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562291 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562296 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562328 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562372 */     GIR_RootConstrainSelectedInstOperands,
     /* 562373 */     // GIR_Coverage, 12280,
     /* 562373 */     GIR_EraseRootFromParent_Done,
     /* 562374 */   // Label 7211: @562374
     /* 562374 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(562509), // Rule ID 12283 //
     /* 562379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562426 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562431 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562463 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562507 */     GIR_RootConstrainSelectedInstOperands,
     /* 562508 */     // GIR_Coverage, 12283,
     /* 562508 */     GIR_EraseRootFromParent_Done,
     /* 562509 */   // Label 7212: @562509
     /* 562509 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(562644), // Rule ID 12284 //
     /* 562514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562561 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562566 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562598 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562642 */     GIR_RootConstrainSelectedInstOperands,
     /* 562643 */     // GIR_Coverage, 12284,
     /* 562643 */     GIR_EraseRootFromParent_Done,
     /* 562644 */   // Label 7213: @562644
     /* 562644 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(562779), // Rule ID 12760 //
     /* 562649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562733 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562777 */     GIR_RootConstrainSelectedInstOperands,
     /* 562778 */     // GIR_Coverage, 12760,
     /* 562778 */     GIR_EraseRootFromParent_Done,
     /* 562779 */   // Label 7214: @562779
     /* 562779 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(562914), // Rule ID 12763 //
     /* 562784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562868 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562912 */     GIR_RootConstrainSelectedInstOperands,
     /* 562913 */     // GIR_Coverage, 12763,
     /* 562913 */     GIR_EraseRootFromParent_Done,
     /* 562914 */   // Label 7215: @562914
     /* 562914 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(563049), // Rule ID 12764 //
     /* 562919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563003 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 563023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 563028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563047 */     GIR_RootConstrainSelectedInstOperands,
     /* 563048 */     // GIR_Coverage, 12764,
     /* 563048 */     GIR_EraseRootFromParent_Done,
     /* 563049 */   // Label 7216: @563049
     /* 563049 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(563184), // Rule ID 11886 //
     /* 563054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563138 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563182 */     GIR_RootConstrainSelectedInstOperands,
     /* 563183 */     // GIR_Coverage, 11886,
     /* 563183 */     GIR_EraseRootFromParent_Done,
     /* 563184 */   // Label 7217: @563184
     /* 563184 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(563319), // Rule ID 11887 //
     /* 563189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563273 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563317 */     GIR_RootConstrainSelectedInstOperands,
     /* 563318 */     // GIR_Coverage, 11887,
     /* 563318 */     GIR_EraseRootFromParent_Done,
     /* 563319 */   // Label 7218: @563319
     /* 563319 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(563454), // Rule ID 11888 //
     /* 563324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563408 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563452 */     GIR_RootConstrainSelectedInstOperands,
     /* 563453 */     // GIR_Coverage, 11888,
     /* 563453 */     GIR_EraseRootFromParent_Done,
     /* 563454 */   // Label 7219: @563454
     /* 563454 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(563589), // Rule ID 11889 //
     /* 563459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563543 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563587 */     GIR_RootConstrainSelectedInstOperands,
     /* 563588 */     // GIR_Coverage, 11889,
     /* 563588 */     GIR_EraseRootFromParent_Done,
     /* 563589 */   // Label 7220: @563589
     /* 563589 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(563724), // Rule ID 12366 //
     /* 563594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563678 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563722 */     GIR_RootConstrainSelectedInstOperands,
     /* 563723 */     // GIR_Coverage, 12366,
     /* 563723 */     GIR_EraseRootFromParent_Done,
     /* 563724 */   // Label 7221: @563724
     /* 563724 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(563859), // Rule ID 12367 //
     /* 563729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563813 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563857 */     GIR_RootConstrainSelectedInstOperands,
     /* 563858 */     // GIR_Coverage, 12367,
     /* 563858 */     GIR_EraseRootFromParent_Done,
     /* 563859 */   // Label 7222: @563859
     /* 563859 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(563994), // Rule ID 12368 //
     /* 563864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563948 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563992 */     GIR_RootConstrainSelectedInstOperands,
     /* 563993 */     // GIR_Coverage, 12368,
     /* 563993 */     GIR_EraseRootFromParent_Done,
     /* 563994 */   // Label 7223: @563994
     /* 563994 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(564129), // Rule ID 12369 //
     /* 563999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 564002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 564006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564083 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 564086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564127 */     GIR_RootConstrainSelectedInstOperands,
     /* 564128 */     // GIR_Coverage, 12369,
     /* 564128 */     GIR_EraseRootFromParent_Done,
     /* 564129 */   // Label 7224: @564129
     /* 564129 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(564264), // Rule ID 12846 //
     /* 564134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564218 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564262 */     GIR_RootConstrainSelectedInstOperands,
     /* 564263 */     // GIR_Coverage, 12846,
     /* 564263 */     GIR_EraseRootFromParent_Done,
     /* 564264 */   // Label 7225: @564264
     /* 564264 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(564399), // Rule ID 12847 //
     /* 564269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564353 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564397 */     GIR_RootConstrainSelectedInstOperands,
     /* 564398 */     // GIR_Coverage, 12847,
     /* 564398 */     GIR_EraseRootFromParent_Done,
     /* 564399 */   // Label 7226: @564399
     /* 564399 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(564534), // Rule ID 12848 //
     /* 564404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564488 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564532 */     GIR_RootConstrainSelectedInstOperands,
     /* 564533 */     // GIR_Coverage, 12848,
     /* 564533 */     GIR_EraseRootFromParent_Done,
     /* 564534 */   // Label 7227: @564534
     /* 564534 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(564669), // Rule ID 12849 //
     /* 564539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564623 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564667 */     GIR_RootConstrainSelectedInstOperands,
     /* 564668 */     // GIR_Coverage, 12849,
     /* 564668 */     GIR_EraseRootFromParent_Done,
     /* 564669 */   // Label 7228: @564669
     /* 564669 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(564804), // Rule ID 11826 //
     /* 564674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564758 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564802 */     GIR_RootConstrainSelectedInstOperands,
     /* 564803 */     // GIR_Coverage, 11826,
     /* 564803 */     GIR_EraseRootFromParent_Done,
     /* 564804 */   // Label 7229: @564804
     /* 564804 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(564939), // Rule ID 11827 //
     /* 564809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564893 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564937 */     GIR_RootConstrainSelectedInstOperands,
     /* 564938 */     // GIR_Coverage, 11827,
     /* 564938 */     GIR_EraseRootFromParent_Done,
     /* 564939 */   // Label 7230: @564939
     /* 564939 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(565074), // Rule ID 11828 //
     /* 564944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565028 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 565031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565072 */     GIR_RootConstrainSelectedInstOperands,
     /* 565073 */     // GIR_Coverage, 11828,
     /* 565073 */     GIR_EraseRootFromParent_Done,
     /* 565074 */   // Label 7231: @565074
     /* 565074 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(565209), // Rule ID 11829 //
     /* 565079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 565082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565163 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 565166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565207 */     GIR_RootConstrainSelectedInstOperands,
     /* 565208 */     // GIR_Coverage, 11829,
     /* 565208 */     GIR_EraseRootFromParent_Done,
     /* 565209 */   // Label 7232: @565209
     /* 565209 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(565344), // Rule ID 12306 //
     /* 565214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565298 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565342 */     GIR_RootConstrainSelectedInstOperands,
     /* 565343 */     // GIR_Coverage, 12306,
     /* 565343 */     GIR_EraseRootFromParent_Done,
     /* 565344 */   // Label 7233: @565344
     /* 565344 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(565479), // Rule ID 12307 //
     /* 565349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565433 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565477 */     GIR_RootConstrainSelectedInstOperands,
     /* 565478 */     // GIR_Coverage, 12307,
     /* 565478 */     GIR_EraseRootFromParent_Done,
     /* 565479 */   // Label 7234: @565479
     /* 565479 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(565614), // Rule ID 12308 //
     /* 565484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565568 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565612 */     GIR_RootConstrainSelectedInstOperands,
     /* 565613 */     // GIR_Coverage, 12308,
     /* 565613 */     GIR_EraseRootFromParent_Done,
     /* 565614 */   // Label 7235: @565614
     /* 565614 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(565749), // Rule ID 12309 //
     /* 565619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565703 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565747 */     GIR_RootConstrainSelectedInstOperands,
     /* 565748 */     // GIR_Coverage, 12309,
     /* 565748 */     GIR_EraseRootFromParent_Done,
     /* 565749 */   // Label 7236: @565749
     /* 565749 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(565884), // Rule ID 12786 //
     /* 565754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565838 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565882 */     GIR_RootConstrainSelectedInstOperands,
     /* 565883 */     // GIR_Coverage, 12786,
     /* 565883 */     GIR_EraseRootFromParent_Done,
     /* 565884 */   // Label 7237: @565884
     /* 565884 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(566019), // Rule ID 12787 //
     /* 565889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565973 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566017 */     GIR_RootConstrainSelectedInstOperands,
     /* 566018 */     // GIR_Coverage, 12787,
     /* 566018 */     GIR_EraseRootFromParent_Done,
     /* 566019 */   // Label 7238: @566019
     /* 566019 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(566154), // Rule ID 12788 //
     /* 566024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 566027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 566055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566108 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 566111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566152 */     GIR_RootConstrainSelectedInstOperands,
     /* 566153 */     // GIR_Coverage, 12788,
     /* 566153 */     GIR_EraseRootFromParent_Done,
     /* 566154 */   // Label 7239: @566154
     /* 566154 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(566289), // Rule ID 12789 //
     /* 566159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 566162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 566190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566243 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 566246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566287 */     GIR_RootConstrainSelectedInstOperands,
     /* 566288 */     // GIR_Coverage, 12789,
     /* 566288 */     GIR_EraseRootFromParent_Done,
     /* 566289 */   // Label 7240: @566289
     /* 566289 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(566424), // Rule ID 11871 //
     /* 566294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566378 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566422 */     GIR_RootConstrainSelectedInstOperands,
     /* 566423 */     // GIR_Coverage, 11871,
     /* 566423 */     GIR_EraseRootFromParent_Done,
     /* 566424 */   // Label 7241: @566424
     /* 566424 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(566559), // Rule ID 11872 //
     /* 566429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566513 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566557 */     GIR_RootConstrainSelectedInstOperands,
     /* 566558 */     // GIR_Coverage, 11872,
     /* 566558 */     GIR_EraseRootFromParent_Done,
     /* 566559 */   // Label 7242: @566559
     /* 566559 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(566694), // Rule ID 11873 //
     /* 566564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566648 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566692 */     GIR_RootConstrainSelectedInstOperands,
     /* 566693 */     // GIR_Coverage, 11873,
     /* 566693 */     GIR_EraseRootFromParent_Done,
     /* 566694 */   // Label 7243: @566694
     /* 566694 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(566829), // Rule ID 11874 //
     /* 566699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566783 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566827 */     GIR_RootConstrainSelectedInstOperands,
     /* 566828 */     // GIR_Coverage, 11874,
     /* 566828 */     GIR_EraseRootFromParent_Done,
     /* 566829 */   // Label 7244: @566829
     /* 566829 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(566964), // Rule ID 12351 //
     /* 566834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566918 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566962 */     GIR_RootConstrainSelectedInstOperands,
     /* 566963 */     // GIR_Coverage, 12351,
     /* 566963 */     GIR_EraseRootFromParent_Done,
     /* 566964 */   // Label 7245: @566964
     /* 566964 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(567099), // Rule ID 12352 //
     /* 566969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567053 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567097 */     GIR_RootConstrainSelectedInstOperands,
     /* 567098 */     // GIR_Coverage, 12352,
     /* 567098 */     GIR_EraseRootFromParent_Done,
     /* 567099 */   // Label 7246: @567099
     /* 567099 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(567234), // Rule ID 12353 //
     /* 567104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 567107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 567111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567188 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567232 */     GIR_RootConstrainSelectedInstOperands,
     /* 567233 */     // GIR_Coverage, 12353,
     /* 567233 */     GIR_EraseRootFromParent_Done,
     /* 567234 */   // Label 7247: @567234
     /* 567234 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(567369), // Rule ID 12354 //
     /* 567239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 567242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 567246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567323 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567367 */     GIR_RootConstrainSelectedInstOperands,
     /* 567368 */     // GIR_Coverage, 12354,
     /* 567368 */     GIR_EraseRootFromParent_Done,
     /* 567369 */   // Label 7248: @567369
     /* 567369 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(567504), // Rule ID 12831 //
     /* 567374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567458 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567502 */     GIR_RootConstrainSelectedInstOperands,
     /* 567503 */     // GIR_Coverage, 12831,
     /* 567503 */     GIR_EraseRootFromParent_Done,
     /* 567504 */   // Label 7249: @567504
     /* 567504 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(567639), // Rule ID 12832 //
     /* 567509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567593 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567637 */     GIR_RootConstrainSelectedInstOperands,
     /* 567638 */     // GIR_Coverage, 12832,
     /* 567638 */     GIR_EraseRootFromParent_Done,
     /* 567639 */   // Label 7250: @567639
     /* 567639 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(567774), // Rule ID 12833 //
     /* 567644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567728 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567772 */     GIR_RootConstrainSelectedInstOperands,
     /* 567773 */     // GIR_Coverage, 12833,
     /* 567773 */     GIR_EraseRootFromParent_Done,
     /* 567774 */   // Label 7251: @567774
     /* 567774 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(567909), // Rule ID 12834 //
     /* 567779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567863 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567907 */     GIR_RootConstrainSelectedInstOperands,
     /* 567908 */     // GIR_Coverage, 12834,
     /* 567908 */     GIR_EraseRootFromParent_Done,
     /* 567909 */   // Label 7252: @567909
     /* 567909 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(568044), // Rule ID 11811 //
     /* 567914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567998 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568042 */     GIR_RootConstrainSelectedInstOperands,
     /* 568043 */     // GIR_Coverage, 11811,
     /* 568043 */     GIR_EraseRootFromParent_Done,
     /* 568044 */   // Label 7253: @568044
     /* 568044 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(568179), // Rule ID 11812 //
     /* 568049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568133 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568177 */     GIR_RootConstrainSelectedInstOperands,
     /* 568178 */     // GIR_Coverage, 11812,
     /* 568178 */     GIR_EraseRootFromParent_Done,
     /* 568179 */   // Label 7254: @568179
     /* 568179 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(568314), // Rule ID 11813 //
     /* 568184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568268 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568312 */     GIR_RootConstrainSelectedInstOperands,
     /* 568313 */     // GIR_Coverage, 11813,
     /* 568313 */     GIR_EraseRootFromParent_Done,
     /* 568314 */   // Label 7255: @568314
     /* 568314 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(568449), // Rule ID 11814 //
     /* 568319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568403 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568447 */     GIR_RootConstrainSelectedInstOperands,
     /* 568448 */     // GIR_Coverage, 11814,
     /* 568448 */     GIR_EraseRootFromParent_Done,
     /* 568449 */   // Label 7256: @568449
     /* 568449 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(568584), // Rule ID 12291 //
     /* 568454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568538 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568582 */     GIR_RootConstrainSelectedInstOperands,
     /* 568583 */     // GIR_Coverage, 12291,
     /* 568583 */     GIR_EraseRootFromParent_Done,
     /* 568584 */   // Label 7257: @568584
     /* 568584 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(568719), // Rule ID 12292 //
     /* 568589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568673 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568717 */     GIR_RootConstrainSelectedInstOperands,
     /* 568718 */     // GIR_Coverage, 12292,
     /* 568718 */     GIR_EraseRootFromParent_Done,
     /* 568719 */   // Label 7258: @568719
     /* 568719 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(568854), // Rule ID 12293 //
     /* 568724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568808 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568852 */     GIR_RootConstrainSelectedInstOperands,
     /* 568853 */     // GIR_Coverage, 12293,
     /* 568853 */     GIR_EraseRootFromParent_Done,
     /* 568854 */   // Label 7259: @568854
     /* 568854 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(568989), // Rule ID 12294 //
     /* 568859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568943 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568987 */     GIR_RootConstrainSelectedInstOperands,
     /* 568988 */     // GIR_Coverage, 12294,
     /* 568988 */     GIR_EraseRootFromParent_Done,
     /* 568989 */   // Label 7260: @568989
     /* 568989 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(569124), // Rule ID 12771 //
     /* 568994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569078 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569122 */     GIR_RootConstrainSelectedInstOperands,
     /* 569123 */     // GIR_Coverage, 12771,
     /* 569123 */     GIR_EraseRootFromParent_Done,
     /* 569124 */   // Label 7261: @569124
     /* 569124 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(569259), // Rule ID 12772 //
     /* 569129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 569132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569213 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569257 */     GIR_RootConstrainSelectedInstOperands,
     /* 569258 */     // GIR_Coverage, 12772,
     /* 569258 */     GIR_EraseRootFromParent_Done,
     /* 569259 */   // Label 7262: @569259
     /* 569259 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(569394), // Rule ID 12773 //
     /* 569264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 569267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569348 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569392 */     GIR_RootConstrainSelectedInstOperands,
     /* 569393 */     // GIR_Coverage, 12773,
     /* 569393 */     GIR_EraseRootFromParent_Done,
     /* 569394 */   // Label 7263: @569394
     /* 569394 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(569529), // Rule ID 12774 //
     /* 569399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 569402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569483 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569527 */     GIR_RootConstrainSelectedInstOperands,
     /* 569528 */     // GIR_Coverage, 12774,
     /* 569528 */     GIR_EraseRootFromParent_Done,
     /* 569529 */   // Label 7264: @569529
     /* 569529 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(569664), // Rule ID 11882 //
     /* 569534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569618 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 569628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 569633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569662 */     GIR_RootConstrainSelectedInstOperands,
     /* 569663 */     // GIR_Coverage, 11882,
     /* 569663 */     GIR_EraseRootFromParent_Done,
     /* 569664 */   // Label 7265: @569664
     /* 569664 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(569799), // Rule ID 11883 //
     /* 569669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569753 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 569763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 569768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569797 */     GIR_RootConstrainSelectedInstOperands,
     /* 569798 */     // GIR_Coverage, 11883,
     /* 569798 */     GIR_EraseRootFromParent_Done,
     /* 569799 */   // Label 7266: @569799
     /* 569799 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(569934), // Rule ID 11884 //
     /* 569804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569888 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 569908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 569913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569932 */     GIR_RootConstrainSelectedInstOperands,
     /* 569933 */     // GIR_Coverage, 11884,
     /* 569933 */     GIR_EraseRootFromParent_Done,
     /* 569934 */   // Label 7267: @569934
     /* 569934 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(570069), // Rule ID 11885 //
     /* 569939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570023 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570067 */     GIR_RootConstrainSelectedInstOperands,
     /* 570068 */     // GIR_Coverage, 11885,
     /* 570068 */     GIR_EraseRootFromParent_Done,
     /* 570069 */   // Label 7268: @570069
     /* 570069 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(570204), // Rule ID 12362 //
     /* 570074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570158 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570202 */     GIR_RootConstrainSelectedInstOperands,
     /* 570203 */     // GIR_Coverage, 12362,
     /* 570203 */     GIR_EraseRootFromParent_Done,
     /* 570204 */   // Label 7269: @570204
     /* 570204 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(570339), // Rule ID 12363 //
     /* 570209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570293 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570337 */     GIR_RootConstrainSelectedInstOperands,
     /* 570338 */     // GIR_Coverage, 12363,
     /* 570338 */     GIR_EraseRootFromParent_Done,
     /* 570339 */   // Label 7270: @570339
     /* 570339 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(570474), // Rule ID 12364 //
     /* 570344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570428 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570472 */     GIR_RootConstrainSelectedInstOperands,
     /* 570473 */     // GIR_Coverage, 12364,
     /* 570473 */     GIR_EraseRootFromParent_Done,
     /* 570474 */   // Label 7271: @570474
     /* 570474 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(570609), // Rule ID 12365 //
     /* 570479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570563 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570607 */     GIR_RootConstrainSelectedInstOperands,
     /* 570608 */     // GIR_Coverage, 12365,
     /* 570608 */     GIR_EraseRootFromParent_Done,
     /* 570609 */   // Label 7272: @570609
     /* 570609 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(570744), // Rule ID 12842 //
     /* 570614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570698 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570742 */     GIR_RootConstrainSelectedInstOperands,
     /* 570743 */     // GIR_Coverage, 12842,
     /* 570743 */     GIR_EraseRootFromParent_Done,
     /* 570744 */   // Label 7273: @570744
     /* 570744 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(570879), // Rule ID 12843 //
     /* 570749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570833 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570877 */     GIR_RootConstrainSelectedInstOperands,
     /* 570878 */     // GIR_Coverage, 12843,
     /* 570878 */     GIR_EraseRootFromParent_Done,
     /* 570879 */   // Label 7274: @570879
     /* 570879 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(571014), // Rule ID 12844 //
     /* 570884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570968 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571012 */     GIR_RootConstrainSelectedInstOperands,
     /* 571013 */     // GIR_Coverage, 12844,
     /* 571013 */     GIR_EraseRootFromParent_Done,
     /* 571014 */   // Label 7275: @571014
     /* 571014 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(571149), // Rule ID 12845 //
     /* 571019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571103 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 571106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571147 */     GIR_RootConstrainSelectedInstOperands,
     /* 571148 */     // GIR_Coverage, 12845,
     /* 571148 */     GIR_EraseRootFromParent_Done,
     /* 571149 */   // Label 7276: @571149
     /* 571149 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(571284), // Rule ID 11822 //
     /* 571154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571238 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571282 */     GIR_RootConstrainSelectedInstOperands,
     /* 571283 */     // GIR_Coverage, 11822,
     /* 571283 */     GIR_EraseRootFromParent_Done,
     /* 571284 */   // Label 7277: @571284
     /* 571284 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(571419), // Rule ID 11823 //
     /* 571289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571373 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571417 */     GIR_RootConstrainSelectedInstOperands,
     /* 571418 */     // GIR_Coverage, 11823,
     /* 571418 */     GIR_EraseRootFromParent_Done,
     /* 571419 */   // Label 7278: @571419
     /* 571419 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(571554), // Rule ID 11824 //
     /* 571424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571508 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571552 */     GIR_RootConstrainSelectedInstOperands,
     /* 571553 */     // GIR_Coverage, 11824,
     /* 571553 */     GIR_EraseRootFromParent_Done,
     /* 571554 */   // Label 7279: @571554
     /* 571554 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(571689), // Rule ID 11825 //
     /* 571559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571643 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571687 */     GIR_RootConstrainSelectedInstOperands,
     /* 571688 */     // GIR_Coverage, 11825,
     /* 571688 */     GIR_EraseRootFromParent_Done,
     /* 571689 */   // Label 7280: @571689
     /* 571689 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(571824), // Rule ID 12302 //
     /* 571694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571778 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571822 */     GIR_RootConstrainSelectedInstOperands,
     /* 571823 */     // GIR_Coverage, 12302,
     /* 571823 */     GIR_EraseRootFromParent_Done,
     /* 571824 */   // Label 7281: @571824
     /* 571824 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(571959), // Rule ID 12303 //
     /* 571829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571913 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571957 */     GIR_RootConstrainSelectedInstOperands,
     /* 571958 */     // GIR_Coverage, 12303,
     /* 571958 */     GIR_EraseRootFromParent_Done,
     /* 571959 */   // Label 7282: @571959
     /* 571959 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(572094), // Rule ID 12304 //
     /* 571964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572048 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 572051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572092 */     GIR_RootConstrainSelectedInstOperands,
     /* 572093 */     // GIR_Coverage, 12304,
     /* 572093 */     GIR_EraseRootFromParent_Done,
     /* 572094 */   // Label 7283: @572094
     /* 572094 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(572229), // Rule ID 12305 //
     /* 572099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 572102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 572106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572183 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 572186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572227 */     GIR_RootConstrainSelectedInstOperands,
     /* 572228 */     // GIR_Coverage, 12305,
     /* 572228 */     GIR_EraseRootFromParent_Done,
     /* 572229 */   // Label 7284: @572229
     /* 572229 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(572364), // Rule ID 12782 //
     /* 572234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572318 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572362 */     GIR_RootConstrainSelectedInstOperands,
     /* 572363 */     // GIR_Coverage, 12782,
     /* 572363 */     GIR_EraseRootFromParent_Done,
     /* 572364 */   // Label 7285: @572364
     /* 572364 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(572499), // Rule ID 12783 //
     /* 572369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572453 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572497 */     GIR_RootConstrainSelectedInstOperands,
     /* 572498 */     // GIR_Coverage, 12783,
     /* 572498 */     GIR_EraseRootFromParent_Done,
     /* 572499 */   // Label 7286: @572499
     /* 572499 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(572634), // Rule ID 12784 //
     /* 572504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572588 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572632 */     GIR_RootConstrainSelectedInstOperands,
     /* 572633 */     // GIR_Coverage, 12784,
     /* 572633 */     GIR_EraseRootFromParent_Done,
     /* 572634 */   // Label 7287: @572634
     /* 572634 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(572769), // Rule ID 12785 //
     /* 572639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572723 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572767 */     GIR_RootConstrainSelectedInstOperands,
     /* 572768 */     // GIR_Coverage, 12785,
     /* 572768 */     GIR_EraseRootFromParent_Done,
     /* 572769 */   // Label 7288: @572769
     /* 572769 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(572904), // Rule ID 11867 //
     /* 572774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572858 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572902 */     GIR_RootConstrainSelectedInstOperands,
     /* 572903 */     // GIR_Coverage, 11867,
     /* 572903 */     GIR_EraseRootFromParent_Done,
     /* 572904 */   // Label 7289: @572904
     /* 572904 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(573039), // Rule ID 11868 //
     /* 572909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572993 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573037 */     GIR_RootConstrainSelectedInstOperands,
     /* 573038 */     // GIR_Coverage, 11868,
     /* 573038 */     GIR_EraseRootFromParent_Done,
     /* 573039 */   // Label 7290: @573039
     /* 573039 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(573174), // Rule ID 11869 //
     /* 573044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 573047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573128 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 573131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573172 */     GIR_RootConstrainSelectedInstOperands,
     /* 573173 */     // GIR_Coverage, 11869,
     /* 573173 */     GIR_EraseRootFromParent_Done,
     /* 573174 */   // Label 7291: @573174
     /* 573174 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(573309), // Rule ID 11870 //
     /* 573179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 573182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573263 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 573266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573307 */     GIR_RootConstrainSelectedInstOperands,
     /* 573308 */     // GIR_Coverage, 11870,
     /* 573308 */     GIR_EraseRootFromParent_Done,
     /* 573309 */   // Label 7292: @573309
     /* 573309 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(573444), // Rule ID 12347 //
     /* 573314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573398 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573442 */     GIR_RootConstrainSelectedInstOperands,
     /* 573443 */     // GIR_Coverage, 12347,
     /* 573443 */     GIR_EraseRootFromParent_Done,
     /* 573444 */   // Label 7293: @573444
     /* 573444 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(573579), // Rule ID 12348 //
     /* 573449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573533 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573577 */     GIR_RootConstrainSelectedInstOperands,
     /* 573578 */     // GIR_Coverage, 12348,
     /* 573578 */     GIR_EraseRootFromParent_Done,
     /* 573579 */   // Label 7294: @573579
     /* 573579 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(573714), // Rule ID 12349 //
     /* 573584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573668 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573712 */     GIR_RootConstrainSelectedInstOperands,
     /* 573713 */     // GIR_Coverage, 12349,
     /* 573713 */     GIR_EraseRootFromParent_Done,
     /* 573714 */   // Label 7295: @573714
     /* 573714 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(573849), // Rule ID 12350 //
     /* 573719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573803 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573847 */     GIR_RootConstrainSelectedInstOperands,
     /* 573848 */     // GIR_Coverage, 12350,
     /* 573848 */     GIR_EraseRootFromParent_Done,
     /* 573849 */   // Label 7296: @573849
     /* 573849 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(573984), // Rule ID 12827 //
     /* 573854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573938 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573982 */     GIR_RootConstrainSelectedInstOperands,
     /* 573983 */     // GIR_Coverage, 12827,
     /* 573983 */     GIR_EraseRootFromParent_Done,
     /* 573984 */   // Label 7297: @573984
     /* 573984 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(574119), // Rule ID 12828 //
     /* 573989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574073 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574117 */     GIR_RootConstrainSelectedInstOperands,
     /* 574118 */     // GIR_Coverage, 12828,
     /* 574118 */     GIR_EraseRootFromParent_Done,
     /* 574119 */   // Label 7298: @574119
     /* 574119 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(574254), // Rule ID 12829 //
     /* 574124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 574127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574208 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574252 */     GIR_RootConstrainSelectedInstOperands,
     /* 574253 */     // GIR_Coverage, 12829,
     /* 574253 */     GIR_EraseRootFromParent_Done,
     /* 574254 */   // Label 7299: @574254
     /* 574254 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(574389), // Rule ID 12830 //
     /* 574259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 574262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574343 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574387 */     GIR_RootConstrainSelectedInstOperands,
     /* 574388 */     // GIR_Coverage, 12830,
     /* 574388 */     GIR_EraseRootFromParent_Done,
     /* 574389 */   // Label 7300: @574389
     /* 574389 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(574524), // Rule ID 11807 //
     /* 574394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574478 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574522 */     GIR_RootConstrainSelectedInstOperands,
     /* 574523 */     // GIR_Coverage, 11807,
     /* 574523 */     GIR_EraseRootFromParent_Done,
     /* 574524 */   // Label 7301: @574524
     /* 574524 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(574659), // Rule ID 11808 //
     /* 574529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574613 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574657 */     GIR_RootConstrainSelectedInstOperands,
     /* 574658 */     // GIR_Coverage, 11808,
     /* 574658 */     GIR_EraseRootFromParent_Done,
     /* 574659 */   // Label 7302: @574659
     /* 574659 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(574794), // Rule ID 11809 //
     /* 574664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574748 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574792 */     GIR_RootConstrainSelectedInstOperands,
     /* 574793 */     // GIR_Coverage, 11809,
     /* 574793 */     GIR_EraseRootFromParent_Done,
     /* 574794 */   // Label 7303: @574794
     /* 574794 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(574929), // Rule ID 11810 //
     /* 574799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574883 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574927 */     GIR_RootConstrainSelectedInstOperands,
     /* 574928 */     // GIR_Coverage, 11810,
     /* 574928 */     GIR_EraseRootFromParent_Done,
     /* 574929 */   // Label 7304: @574929
     /* 574929 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(575064), // Rule ID 12287 //
     /* 574934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575018 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575062 */     GIR_RootConstrainSelectedInstOperands,
     /* 575063 */     // GIR_Coverage, 12287,
     /* 575063 */     GIR_EraseRootFromParent_Done,
     /* 575064 */   // Label 7305: @575064
     /* 575064 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(575199), // Rule ID 12288 //
     /* 575069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575153 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575197 */     GIR_RootConstrainSelectedInstOperands,
     /* 575198 */     // GIR_Coverage, 12288,
     /* 575198 */     GIR_EraseRootFromParent_Done,
     /* 575199 */   // Label 7306: @575199
     /* 575199 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(575334), // Rule ID 12289 //
     /* 575204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575288 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575332 */     GIR_RootConstrainSelectedInstOperands,
     /* 575333 */     // GIR_Coverage, 12289,
     /* 575333 */     GIR_EraseRootFromParent_Done,
     /* 575334 */   // Label 7307: @575334
     /* 575334 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(575469), // Rule ID 12290 //
     /* 575339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575423 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575467 */     GIR_RootConstrainSelectedInstOperands,
     /* 575468 */     // GIR_Coverage, 12290,
     /* 575468 */     GIR_EraseRootFromParent_Done,
     /* 575469 */   // Label 7308: @575469
     /* 575469 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(575604), // Rule ID 12767 //
     /* 575474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575558 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575602 */     GIR_RootConstrainSelectedInstOperands,
     /* 575603 */     // GIR_Coverage, 12767,
     /* 575603 */     GIR_EraseRootFromParent_Done,
     /* 575604 */   // Label 7309: @575604
     /* 575604 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(575739), // Rule ID 12768 //
     /* 575609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575693 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575737 */     GIR_RootConstrainSelectedInstOperands,
     /* 575738 */     // GIR_Coverage, 12768,
     /* 575738 */     GIR_EraseRootFromParent_Done,
     /* 575739 */   // Label 7310: @575739
     /* 575739 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(575874), // Rule ID 12769 //
     /* 575744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575828 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575872 */     GIR_RootConstrainSelectedInstOperands,
     /* 575873 */     // GIR_Coverage, 12769,
     /* 575873 */     GIR_EraseRootFromParent_Done,
     /* 575874 */   // Label 7311: @575874
     /* 575874 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(576009), // Rule ID 12770 //
     /* 575879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575963 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576007 */     GIR_RootConstrainSelectedInstOperands,
     /* 576008 */     // GIR_Coverage, 12770,
     /* 576008 */     GIR_EraseRootFromParent_Done,
     /* 576009 */   // Label 7312: @576009
     /* 576009 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(576124), // Rule ID 13269 //
     /* 576014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576049 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576051 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576078 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576122 */     GIR_RootConstrainSelectedInstOperands,
     /* 576123 */     // GIR_Coverage, 13269,
     /* 576123 */     GIR_EraseRootFromParent_Done,
     /* 576124 */   // Label 7313: @576124
     /* 576124 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(576239), // Rule ID 13285 //
     /* 576129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576164 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576166 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576193 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576237 */     GIR_RootConstrainSelectedInstOperands,
     /* 576238 */     // GIR_Coverage, 13285,
     /* 576238 */     GIR_EraseRootFromParent_Done,
     /* 576239 */   // Label 7314: @576239
     /* 576239 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(576354), // Rule ID 13268 //
     /* 576244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576279 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576281 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576308 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576352 */     GIR_RootConstrainSelectedInstOperands,
     /* 576353 */     // GIR_Coverage, 13268,
     /* 576353 */     GIR_EraseRootFromParent_Done,
     /* 576354 */   // Label 7315: @576354
     /* 576354 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(576469), // Rule ID 13284 //
     /* 576359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576394 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576396 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576423 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576467 */     GIR_RootConstrainSelectedInstOperands,
     /* 576468 */     // GIR_Coverage, 13284,
     /* 576468 */     GIR_EraseRootFromParent_Done,
     /* 576469 */   // Label 7316: @576469
     /* 576469 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(576584), // Rule ID 7743 //
     /* 576474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576509 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576511 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576538 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576582 */     GIR_RootConstrainSelectedInstOperands,
     /* 576583 */     // GIR_Coverage, 7743,
     /* 576583 */     GIR_EraseRootFromParent_Done,
     /* 576584 */   // Label 7317: @576584
     /* 576584 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(576699), // Rule ID 7759 //
     /* 576589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576624 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576626 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576653 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576697 */     GIR_RootConstrainSelectedInstOperands,
     /* 576698 */     // GIR_Coverage, 7759,
     /* 576698 */     GIR_EraseRootFromParent_Done,
     /* 576699 */   // Label 7318: @576699
     /* 576699 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(576814), // Rule ID 7742 //
     /* 576704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576739 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576741 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576768 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576812 */     GIR_RootConstrainSelectedInstOperands,
     /* 576813 */     // GIR_Coverage, 7742,
     /* 576813 */     GIR_EraseRootFromParent_Done,
     /* 576814 */   // Label 7319: @576814
     /* 576814 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(576929), // Rule ID 7758 //
     /* 576819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576854 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576856 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 576860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576883 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576927 */     GIR_RootConstrainSelectedInstOperands,
     /* 576928 */     // GIR_Coverage, 7758,
     /* 576928 */     GIR_EraseRootFromParent_Done,
     /* 576929 */   // Label 7320: @576929
     /* 576929 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(577028), // Rule ID 13261 //
     /* 576934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576957 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 576959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 576961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576982 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 577002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 577007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 577012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 577017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577026 */     GIR_RootConstrainSelectedInstOperands,
     /* 577027 */     // GIR_Coverage, 13261,
     /* 577027 */     GIR_EraseRootFromParent_Done,
     /* 577028 */   // Label 7321: @577028
     /* 577028 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(577127), // Rule ID 13277 //
     /* 577033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 577044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577056 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577081 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 577101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 577106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 577111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 577116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577125 */     GIR_RootConstrainSelectedInstOperands,
     /* 577126 */     // GIR_Coverage, 13277,
     /* 577126 */     GIR_EraseRootFromParent_Done,
     /* 577127 */   // Label 7322: @577127
     /* 577127 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(577226), // Rule ID 13260 //
     /* 577132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 577143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577155 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577180 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 577183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 577200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 577205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 577210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 577215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577224 */     GIR_RootConstrainSelectedInstOperands,
     /* 577225 */     // GIR_Coverage, 13260,
     /* 577225 */     GIR_EraseRootFromParent_Done,
     /* 577226 */   // Label 7323: @577226
     /* 577226 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(577325), // Rule ID 13276 //
     /* 577231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 577242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577254 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577279 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 577299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 577304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 577309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 577314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577323 */     GIR_RootConstrainSelectedInstOperands,
     /* 577324 */     // GIR_Coverage, 13276,
     /* 577324 */     GIR_EraseRootFromParent_Done,
     /* 577325 */   // Label 7324: @577325
     /* 577325 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(577424), // Rule ID 7735 //
     /* 577330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577353 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577378 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 577381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577422 */     GIR_RootConstrainSelectedInstOperands,
     /* 577423 */     // GIR_Coverage, 7735,
     /* 577423 */     GIR_EraseRootFromParent_Done,
     /* 577424 */   // Label 7325: @577424
     /* 577424 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(577523), // Rule ID 7751 //
     /* 577429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577452 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577477 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577521 */     GIR_RootConstrainSelectedInstOperands,
     /* 577522 */     // GIR_Coverage, 7751,
     /* 577522 */     GIR_EraseRootFromParent_Done,
     /* 577523 */   // Label 7326: @577523
     /* 577523 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(577622), // Rule ID 7734 //
     /* 577528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577551 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577576 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 577579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577620 */     GIR_RootConstrainSelectedInstOperands,
     /* 577621 */     // GIR_Coverage, 7734,
     /* 577621 */     GIR_EraseRootFromParent_Done,
     /* 577622 */   // Label 7327: @577622
     /* 577622 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(577721), // Rule ID 7750 //
     /* 577627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577650 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577675 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577719 */     GIR_RootConstrainSelectedInstOperands,
     /* 577720 */     // GIR_Coverage, 7750,
     /* 577720 */     GIR_EraseRootFromParent_Done,
     /* 577721 */   // Label 7328: @577721
     /* 577721 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(577756), // Rule ID 102 //
     /* 577726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 577729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13766),
     /* 577745 */     // (fmaxnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13766>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 577745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 577750 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 577754 */     GIR_RootConstrainSelectedInstOperands,
     /* 577755 */     // GIR_Coverage, 102,
     /* 577755 */     GIR_Done,
     /* 577756 */   // Label 7329: @577756
     /* 577756 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(577819), // Rule ID 879 //
     /* 577761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 577764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577782 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 577785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 577792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 577802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 577812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 577817 */     GIR_RootConstrainSelectedInstOperands,
     /* 577818 */     // GIR_Coverage, 879,
     /* 577818 */     GIR_EraseRootFromParent_Done,
     /* 577819 */   // Label 7330: @577819
     /* 577819 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(577882), // Rule ID 883 //
     /* 577824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577845 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 577848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 577855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 577865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 577875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 577880 */     GIR_RootConstrainSelectedInstOperands,
     /* 577881 */     // GIR_Coverage, 883,
     /* 577881 */     GIR_EraseRootFromParent_Done,
     /* 577882 */   // Label 7331: @577882
     /* 577882 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(577945), // Rule ID 8437 //
     /* 577887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 577890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577908 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 577911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 577918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 577928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 577938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 577943 */     GIR_RootConstrainSelectedInstOperands,
     /* 577944 */     // GIR_Coverage, 8437,
     /* 577944 */     GIR_EraseRootFromParent_Done,
     /* 577945 */   // Label 7332: @577945
     /* 577945 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(578008), // Rule ID 8439 //
     /* 577950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577971 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 577974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 577981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 577991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 578001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 578006 */     GIR_RootConstrainSelectedInstOperands,
     /* 578007 */     // GIR_Coverage, 8439,
     /* 578007 */     GIR_EraseRootFromParent_Done,
     /* 578008 */   // Label 7333: @578008
     /* 578008 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(578070), // Rule ID 881 //
     /* 578013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 578016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 578020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 578027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 578034 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 578034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 578037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 578044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 578054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578068 */     GIR_RootConstrainSelectedInstOperands,
     /* 578069 */     // GIR_Coverage, 881,
     /* 578069 */     GIR_EraseRootFromParent_Done,
     /* 578070 */   // Label 7334: @578070
     /* 578070 */   GIM_Reject,
     /* 578071 */ // Label 6928: @578071
     /* 578071 */ GIM_Reject,
     /* 578072 */ // Label 6924: @578072
     /* 578072 */ GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(595583),
     /* 578077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 578080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 578083 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(578212), // Rule ID 11396 //
     /* 578088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578169 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578210 */     GIR_RootConstrainSelectedInstOperands,
     /* 578211 */     // GIR_Coverage, 11396,
     /* 578211 */     GIR_EraseRootFromParent_Done,
     /* 578212 */   // Label 7336: @578212
     /* 578212 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(578341), // Rule ID 11397 //
     /* 578217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578261 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578266 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578298 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578339 */     GIR_RootConstrainSelectedInstOperands,
     /* 578340 */     // GIR_Coverage, 11397,
     /* 578340 */     GIR_EraseRootFromParent_Done,
     /* 578341 */   // Label 7337: @578341
     /* 578341 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(578470), // Rule ID 11400 //
     /* 578346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578427 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578468 */     GIR_RootConstrainSelectedInstOperands,
     /* 578469 */     // GIR_Coverage, 11400,
     /* 578469 */     GIR_EraseRootFromParent_Done,
     /* 578470 */   // Label 7338: @578470
     /* 578470 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(578599), // Rule ID 11401 //
     /* 578475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578556 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578597 */     GIR_RootConstrainSelectedInstOperands,
     /* 578598 */     // GIR_Coverage, 11401,
     /* 578598 */     GIR_EraseRootFromParent_Done,
     /* 578599 */   // Label 7339: @578599
     /* 578599 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(578728), // Rule ID 11381 //
     /* 578604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578648 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578653 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578685 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578726 */     GIR_RootConstrainSelectedInstOperands,
     /* 578727 */     // GIR_Coverage, 11381,
     /* 578727 */     GIR_EraseRootFromParent_Done,
     /* 578728 */   // Label 7340: @578728
     /* 578728 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(578857), // Rule ID 11382 //
     /* 578733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578814 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578855 */     GIR_RootConstrainSelectedInstOperands,
     /* 578856 */     // GIR_Coverage, 11382,
     /* 578856 */     GIR_EraseRootFromParent_Done,
     /* 578857 */   // Label 7341: @578857
     /* 578857 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(578986), // Rule ID 11385 //
     /* 578862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578906 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578911 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578943 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578984 */     GIR_RootConstrainSelectedInstOperands,
     /* 578985 */     // GIR_Coverage, 11385,
     /* 578985 */     GIR_EraseRootFromParent_Done,
     /* 578986 */   // Label 7342: @578986
     /* 578986 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(579115), // Rule ID 11386 //
     /* 578991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 579031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579072 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579113 */     GIR_RootConstrainSelectedInstOperands,
     /* 579114 */     // GIR_Coverage, 11386,
     /* 579114 */     GIR_EraseRootFromParent_Done,
     /* 579115 */   // Label 7343: @579115
     /* 579115 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(579244), // Rule ID 7591 //
     /* 579120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579164 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579169 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579201 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579242 */     GIR_RootConstrainSelectedInstOperands,
     /* 579243 */     // GIR_Coverage, 7591,
     /* 579243 */     GIR_EraseRootFromParent_Done,
     /* 579244 */   // Label 7344: @579244
     /* 579244 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(579373), // Rule ID 11395 //
     /* 579249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579293 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579298 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579330 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579371 */     GIR_RootConstrainSelectedInstOperands,
     /* 579372 */     // GIR_Coverage, 11395,
     /* 579372 */     GIR_EraseRootFromParent_Done,
     /* 579373 */   // Label 7345: @579373
     /* 579373 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(579502), // Rule ID 11398 //
     /* 579378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579459 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579500 */     GIR_RootConstrainSelectedInstOperands,
     /* 579501 */     // GIR_Coverage, 11398,
     /* 579501 */     GIR_EraseRootFromParent_Done,
     /* 579502 */   // Label 7346: @579502
     /* 579502 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(579631), // Rule ID 11399 //
     /* 579507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579551 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579556 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579588 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579629 */     GIR_RootConstrainSelectedInstOperands,
     /* 579630 */     // GIR_Coverage, 11399,
     /* 579630 */     GIR_EraseRootFromParent_Done,
     /* 579631 */   // Label 7347: @579631
     /* 579631 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(579760), // Rule ID 7590 //
     /* 579636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579717 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579758 */     GIR_RootConstrainSelectedInstOperands,
     /* 579759 */     // GIR_Coverage, 7590,
     /* 579759 */     GIR_EraseRootFromParent_Done,
     /* 579760 */   // Label 7348: @579760
     /* 579760 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(579889), // Rule ID 11380 //
     /* 579765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579809 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579846 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579887 */     GIR_RootConstrainSelectedInstOperands,
     /* 579888 */     // GIR_Coverage, 11380,
     /* 579888 */     GIR_EraseRootFromParent_Done,
     /* 579889 */   // Label 7349: @579889
     /* 579889 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(580018), // Rule ID 11383 //
     /* 579894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579938 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579943 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579975 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580016 */     GIR_RootConstrainSelectedInstOperands,
     /* 580017 */     // GIR_Coverage, 11383,
     /* 580017 */     GIR_EraseRootFromParent_Done,
     /* 580018 */   // Label 7350: @580018
     /* 580018 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(580147), // Rule ID 11384 //
     /* 580023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 580063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580104 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580145 */     GIR_RootConstrainSelectedInstOperands,
     /* 580146 */     // GIR_Coverage, 11384,
     /* 580146 */     GIR_EraseRootFromParent_Done,
     /* 580147 */   // Label 7351: @580147
     /* 580147 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(580276), // Rule ID 11366 //
     /* 580152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580196 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580201 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580233 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580274 */     GIR_RootConstrainSelectedInstOperands,
     /* 580275 */     // GIR_Coverage, 11366,
     /* 580275 */     GIR_EraseRootFromParent_Done,
     /* 580276 */   // Label 7352: @580276
     /* 580276 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(580405), // Rule ID 11367 //
     /* 580281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580362 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580403 */     GIR_RootConstrainSelectedInstOperands,
     /* 580404 */     // GIR_Coverage, 11367,
     /* 580404 */     GIR_EraseRootFromParent_Done,
     /* 580405 */   // Label 7353: @580405
     /* 580405 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(580534), // Rule ID 11370 //
     /* 580410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580491 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580532 */     GIR_RootConstrainSelectedInstOperands,
     /* 580533 */     // GIR_Coverage, 11370,
     /* 580533 */     GIR_EraseRootFromParent_Done,
     /* 580534 */   // Label 7354: @580534
     /* 580534 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(580663), // Rule ID 11371 //
     /* 580539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580583 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580588 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580620 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580661 */     GIR_RootConstrainSelectedInstOperands,
     /* 580662 */     // GIR_Coverage, 11371,
     /* 580662 */     GIR_EraseRootFromParent_Done,
     /* 580663 */   // Label 7355: @580663
     /* 580663 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(580792), // Rule ID 11351 //
     /* 580668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580749 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580790 */     GIR_RootConstrainSelectedInstOperands,
     /* 580791 */     // GIR_Coverage, 11351,
     /* 580791 */     GIR_EraseRootFromParent_Done,
     /* 580792 */   // Label 7356: @580792
     /* 580792 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(580921), // Rule ID 11352 //
     /* 580797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580841 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580846 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580878 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580919 */     GIR_RootConstrainSelectedInstOperands,
     /* 580920 */     // GIR_Coverage, 11352,
     /* 580920 */     GIR_EraseRootFromParent_Done,
     /* 580921 */   // Label 7357: @580921
     /* 580921 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(581050), // Rule ID 11355 //
     /* 580926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581007 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581048 */     GIR_RootConstrainSelectedInstOperands,
     /* 581049 */     // GIR_Coverage, 11355,
     /* 581049 */     GIR_EraseRootFromParent_Done,
     /* 581050 */   // Label 7358: @581050
     /* 581050 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(581179), // Rule ID 11356 //
     /* 581055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 581095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581099 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581104 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581136 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581177 */     GIR_RootConstrainSelectedInstOperands,
     /* 581178 */     // GIR_Coverage, 11356,
     /* 581178 */     GIR_EraseRootFromParent_Done,
     /* 581179 */   // Label 7359: @581179
     /* 581179 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(581308), // Rule ID 7589 //
     /* 581184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581228 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581233 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581265 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581306 */     GIR_RootConstrainSelectedInstOperands,
     /* 581307 */     // GIR_Coverage, 7589,
     /* 581307 */     GIR_EraseRootFromParent_Done,
     /* 581308 */   // Label 7360: @581308
     /* 581308 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(581437), // Rule ID 11365 //
     /* 581313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581394 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581435 */     GIR_RootConstrainSelectedInstOperands,
     /* 581436 */     // GIR_Coverage, 11365,
     /* 581436 */     GIR_EraseRootFromParent_Done,
     /* 581437 */   // Label 7361: @581437
     /* 581437 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(581566), // Rule ID 11368 //
     /* 581442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581486 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581491 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581523 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581564 */     GIR_RootConstrainSelectedInstOperands,
     /* 581565 */     // GIR_Coverage, 11368,
     /* 581565 */     GIR_EraseRootFromParent_Done,
     /* 581566 */   // Label 7362: @581566
     /* 581566 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(581695), // Rule ID 11369 //
     /* 581571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581652 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581693 */     GIR_RootConstrainSelectedInstOperands,
     /* 581694 */     // GIR_Coverage, 11369,
     /* 581694 */     GIR_EraseRootFromParent_Done,
     /* 581695 */   // Label 7363: @581695
     /* 581695 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(581824), // Rule ID 7588 //
     /* 581700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581744 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581749 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581781 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581822 */     GIR_RootConstrainSelectedInstOperands,
     /* 581823 */     // GIR_Coverage, 7588,
     /* 581823 */     GIR_EraseRootFromParent_Done,
     /* 581824 */   // Label 7364: @581824
     /* 581824 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(581953), // Rule ID 11350 //
     /* 581829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581873 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581878 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581910 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581951 */     GIR_RootConstrainSelectedInstOperands,
     /* 581952 */     // GIR_Coverage, 11350,
     /* 581952 */     GIR_EraseRootFromParent_Done,
     /* 581953 */   // Label 7365: @581953
     /* 581953 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(582082), // Rule ID 11353 //
     /* 581958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 582002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582039 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 582059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582080 */     GIR_RootConstrainSelectedInstOperands,
     /* 582081 */     // GIR_Coverage, 11353,
     /* 582081 */     GIR_EraseRootFromParent_Done,
     /* 582082 */   // Label 7366: @582082
     /* 582082 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(582211), // Rule ID 11354 //
     /* 582087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 582127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 582131 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582136 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582168 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 582188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582209 */     GIR_RootConstrainSelectedInstOperands,
     /* 582210 */     // GIR_Coverage, 11354,
     /* 582210 */     GIR_EraseRootFromParent_Done,
     /* 582211 */   // Label 7367: @582211
     /* 582211 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(582340), // Rule ID 11406 //
     /* 582216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582297 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582338 */     GIR_RootConstrainSelectedInstOperands,
     /* 582339 */     // GIR_Coverage, 11406,
     /* 582339 */     GIR_EraseRootFromParent_Done,
     /* 582340 */   // Label 7368: @582340
     /* 582340 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(582469), // Rule ID 11407 //
     /* 582345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582426 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582467 */     GIR_RootConstrainSelectedInstOperands,
     /* 582468 */     // GIR_Coverage, 11407,
     /* 582468 */     GIR_EraseRootFromParent_Done,
     /* 582469 */   // Label 7369: @582469
     /* 582469 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(582598), // Rule ID 11408 //
     /* 582474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582518 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582555 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582596 */     GIR_RootConstrainSelectedInstOperands,
     /* 582597 */     // GIR_Coverage, 11408,
     /* 582597 */     GIR_EraseRootFromParent_Done,
     /* 582598 */   // Label 7370: @582598
     /* 582598 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(582727), // Rule ID 11409 //
     /* 582603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582684 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582725 */     GIR_RootConstrainSelectedInstOperands,
     /* 582726 */     // GIR_Coverage, 11409,
     /* 582726 */     GIR_EraseRootFromParent_Done,
     /* 582727 */   // Label 7371: @582727
     /* 582727 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(582856), // Rule ID 11346 //
     /* 582732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582776 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582781 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582813 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582854 */     GIR_RootConstrainSelectedInstOperands,
     /* 582855 */     // GIR_Coverage, 11346,
     /* 582855 */     GIR_EraseRootFromParent_Done,
     /* 582856 */   // Label 7372: @582856
     /* 582856 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(582985), // Rule ID 11347 //
     /* 582861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582942 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582983 */     GIR_RootConstrainSelectedInstOperands,
     /* 582984 */     // GIR_Coverage, 11347,
     /* 582984 */     GIR_EraseRootFromParent_Done,
     /* 582985 */   // Label 7373: @582985
     /* 582985 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(583114), // Rule ID 11348 //
     /* 582990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583034 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583039 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583071 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583112 */     GIR_RootConstrainSelectedInstOperands,
     /* 583113 */     // GIR_Coverage, 11348,
     /* 583113 */     GIR_EraseRootFromParent_Done,
     /* 583114 */   // Label 7374: @583114
     /* 583114 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(583243), // Rule ID 11349 //
     /* 583119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583168 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583200 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583241 */     GIR_RootConstrainSelectedInstOperands,
     /* 583242 */     // GIR_Coverage, 11349,
     /* 583242 */     GIR_EraseRootFromParent_Done,
     /* 583243 */   // Label 7375: @583243
     /* 583243 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(583372), // Rule ID 11391 //
     /* 583248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583329 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583370 */     GIR_RootConstrainSelectedInstOperands,
     /* 583371 */     // GIR_Coverage, 11391,
     /* 583371 */     GIR_EraseRootFromParent_Done,
     /* 583372 */   // Label 7376: @583372
     /* 583372 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(583501), // Rule ID 11392 //
     /* 583377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583421 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583426 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583458 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583499 */     GIR_RootConstrainSelectedInstOperands,
     /* 583500 */     // GIR_Coverage, 11392,
     /* 583500 */     GIR_EraseRootFromParent_Done,
     /* 583501 */   // Label 7377: @583501
     /* 583501 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(583630), // Rule ID 11393 //
     /* 583506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583587 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583628 */     GIR_RootConstrainSelectedInstOperands,
     /* 583629 */     // GIR_Coverage, 11393,
     /* 583629 */     GIR_EraseRootFromParent_Done,
     /* 583630 */   // Label 7378: @583630
     /* 583630 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(583759), // Rule ID 11394 //
     /* 583635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583716 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583757 */     GIR_RootConstrainSelectedInstOperands,
     /* 583758 */     // GIR_Coverage, 11394,
     /* 583758 */     GIR_EraseRootFromParent_Done,
     /* 583759 */   // Label 7379: @583759
     /* 583759 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(583888), // Rule ID 11331 //
     /* 583764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583845 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583886 */     GIR_RootConstrainSelectedInstOperands,
     /* 583887 */     // GIR_Coverage, 11331,
     /* 583887 */     GIR_EraseRootFromParent_Done,
     /* 583888 */   // Label 7380: @583888
     /* 583888 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(584017), // Rule ID 11332 //
     /* 583893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583974 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 584004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 584009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584015 */     GIR_RootConstrainSelectedInstOperands,
     /* 584016 */     // GIR_Coverage, 11332,
     /* 584016 */     GIR_EraseRootFromParent_Done,
     /* 584017 */   // Label 7381: @584017
     /* 584017 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(584146), // Rule ID 11333 //
     /* 584022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 584046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584066 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584071 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584103 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 584113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 584118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 584133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 584138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584144 */     GIR_RootConstrainSelectedInstOperands,
     /* 584145 */     // GIR_Coverage, 11333,
     /* 584145 */     GIR_EraseRootFromParent_Done,
     /* 584146 */   // Label 7382: @584146
     /* 584146 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(584275), // Rule ID 11334 //
     /* 584151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 584175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584232 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 584242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 584247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 584262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 584267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584273 */     GIR_RootConstrainSelectedInstOperands,
     /* 584274 */     // GIR_Coverage, 11334,
     /* 584274 */     GIR_EraseRootFromParent_Done,
     /* 584275 */   // Label 7383: @584275
     /* 584275 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(584404), // Rule ID 11402 //
     /* 584280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584361 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584402 */     GIR_RootConstrainSelectedInstOperands,
     /* 584403 */     // GIR_Coverage, 11402,
     /* 584403 */     GIR_EraseRootFromParent_Done,
     /* 584404 */   // Label 7384: @584404
     /* 584404 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(584533), // Rule ID 11403 //
     /* 584409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584458 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584490 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584531 */     GIR_RootConstrainSelectedInstOperands,
     /* 584532 */     // GIR_Coverage, 11403,
     /* 584532 */     GIR_EraseRootFromParent_Done,
     /* 584533 */   // Label 7385: @584533
     /* 584533 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(584662), // Rule ID 11404 //
     /* 584538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584619 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584660 */     GIR_RootConstrainSelectedInstOperands,
     /* 584661 */     // GIR_Coverage, 11404,
     /* 584661 */     GIR_EraseRootFromParent_Done,
     /* 584662 */   // Label 7386: @584662
     /* 584662 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(584791), // Rule ID 11405 //
     /* 584667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584711 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584716 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584748 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584789 */     GIR_RootConstrainSelectedInstOperands,
     /* 584790 */     // GIR_Coverage, 11405,
     /* 584790 */     GIR_EraseRootFromParent_Done,
     /* 584791 */   // Label 7387: @584791
     /* 584791 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(584920), // Rule ID 11342 //
     /* 584796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584877 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584918 */     GIR_RootConstrainSelectedInstOperands,
     /* 584919 */     // GIR_Coverage, 11342,
     /* 584919 */     GIR_EraseRootFromParent_Done,
     /* 584920 */   // Label 7388: @584920
     /* 584920 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(585049), // Rule ID 11343 //
     /* 584925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585006 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585047 */     GIR_RootConstrainSelectedInstOperands,
     /* 585048 */     // GIR_Coverage, 11343,
     /* 585048 */     GIR_EraseRootFromParent_Done,
     /* 585049 */   // Label 7389: @585049
     /* 585049 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(585178), // Rule ID 11344 //
     /* 585054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585135 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585176 */     GIR_RootConstrainSelectedInstOperands,
     /* 585177 */     // GIR_Coverage, 11344,
     /* 585177 */     GIR_EraseRootFromParent_Done,
     /* 585178 */   // Label 7390: @585178
     /* 585178 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(585307), // Rule ID 11345 //
     /* 585183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585264 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585305 */     GIR_RootConstrainSelectedInstOperands,
     /* 585306 */     // GIR_Coverage, 11345,
     /* 585306 */     GIR_EraseRootFromParent_Done,
     /* 585307 */   // Label 7391: @585307
     /* 585307 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(585436), // Rule ID 11387 //
     /* 585312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585356 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585361 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585393 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585434 */     GIR_RootConstrainSelectedInstOperands,
     /* 585435 */     // GIR_Coverage, 11387,
     /* 585435 */     GIR_EraseRootFromParent_Done,
     /* 585436 */   // Label 7392: @585436
     /* 585436 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(585565), // Rule ID 11388 //
     /* 585441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585522 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585563 */     GIR_RootConstrainSelectedInstOperands,
     /* 585564 */     // GIR_Coverage, 11388,
     /* 585564 */     GIR_EraseRootFromParent_Done,
     /* 585565 */   // Label 7393: @585565
     /* 585565 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(585694), // Rule ID 11389 //
     /* 585570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585614 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585619 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585651 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585692 */     GIR_RootConstrainSelectedInstOperands,
     /* 585693 */     // GIR_Coverage, 11389,
     /* 585693 */     GIR_EraseRootFromParent_Done,
     /* 585694 */   // Label 7394: @585694
     /* 585694 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(585823), // Rule ID 11390 //
     /* 585699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585780 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585821 */     GIR_RootConstrainSelectedInstOperands,
     /* 585822 */     // GIR_Coverage, 11390,
     /* 585822 */     GIR_EraseRootFromParent_Done,
     /* 585823 */   // Label 7395: @585823
     /* 585823 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(585952), // Rule ID 11327 //
     /* 585828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585909 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585950 */     GIR_RootConstrainSelectedInstOperands,
     /* 585951 */     // GIR_Coverage, 11327,
     /* 585951 */     GIR_EraseRootFromParent_Done,
     /* 585952 */   // Label 7396: @585952
     /* 585952 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(586081), // Rule ID 11328 //
     /* 585957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586001 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586006 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586038 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586079 */     GIR_RootConstrainSelectedInstOperands,
     /* 586080 */     // GIR_Coverage, 11328,
     /* 586080 */     GIR_EraseRootFromParent_Done,
     /* 586081 */   // Label 7397: @586081
     /* 586081 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(586210), // Rule ID 11329 //
     /* 586086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 586110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586167 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586208 */     GIR_RootConstrainSelectedInstOperands,
     /* 586209 */     // GIR_Coverage, 11329,
     /* 586209 */     GIR_EraseRootFromParent_Done,
     /* 586210 */   // Label 7398: @586210
     /* 586210 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(586339), // Rule ID 11330 //
     /* 586215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 586239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586264 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586296 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586337 */     GIR_RootConstrainSelectedInstOperands,
     /* 586338 */     // GIR_Coverage, 11330,
     /* 586338 */     GIR_EraseRootFromParent_Done,
     /* 586339 */   // Label 7399: @586339
     /* 586339 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(586468), // Rule ID 11336 //
     /* 586344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586425 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586466 */     GIR_RootConstrainSelectedInstOperands,
     /* 586467 */     // GIR_Coverage, 11336,
     /* 586467 */     GIR_EraseRootFromParent_Done,
     /* 586468 */   // Label 7400: @586468
     /* 586468 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(586597), // Rule ID 11337 //
     /* 586473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586554 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586595 */     GIR_RootConstrainSelectedInstOperands,
     /* 586596 */     // GIR_Coverage, 11337,
     /* 586596 */     GIR_EraseRootFromParent_Done,
     /* 586597 */   // Label 7401: @586597
     /* 586597 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(586726), // Rule ID 11340 //
     /* 586602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586646 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586651 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586683 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586724 */     GIR_RootConstrainSelectedInstOperands,
     /* 586725 */     // GIR_Coverage, 11340,
     /* 586725 */     GIR_EraseRootFromParent_Done,
     /* 586726 */   // Label 7402: @586726
     /* 586726 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(586855), // Rule ID 11341 //
     /* 586731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586812 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586853 */     GIR_RootConstrainSelectedInstOperands,
     /* 586854 */     // GIR_Coverage, 11341,
     /* 586854 */     GIR_EraseRootFromParent_Done,
     /* 586855 */   // Label 7403: @586855
     /* 586855 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(586984), // Rule ID 11321 //
     /* 586860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586941 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586982 */     GIR_RootConstrainSelectedInstOperands,
     /* 586983 */     // GIR_Coverage, 11321,
     /* 586983 */     GIR_EraseRootFromParent_Done,
     /* 586984 */   // Label 7404: @586984
     /* 586984 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(587113), // Rule ID 11322 //
     /* 586989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 587029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587033 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587038 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587070 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587111 */     GIR_RootConstrainSelectedInstOperands,
     /* 587112 */     // GIR_Coverage, 11322,
     /* 587112 */     GIR_EraseRootFromParent_Done,
     /* 587113 */   // Label 7405: @587113
     /* 587113 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(587242), // Rule ID 11325 //
     /* 587118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 587158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587199 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587240 */     GIR_RootConstrainSelectedInstOperands,
     /* 587241 */     // GIR_Coverage, 11325,
     /* 587241 */     GIR_EraseRootFromParent_Done,
     /* 587242 */   // Label 7406: @587242
     /* 587242 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(587371), // Rule ID 11326 //
     /* 587247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 587287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587291 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587296 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587328 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587369 */     GIR_RootConstrainSelectedInstOperands,
     /* 587370 */     // GIR_Coverage, 11326,
     /* 587370 */     GIR_EraseRootFromParent_Done,
     /* 587371 */   // Label 7407: @587371
     /* 587371 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(587500), // Rule ID 7587 //
     /* 587376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587457 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587498 */     GIR_RootConstrainSelectedInstOperands,
     /* 587499 */     // GIR_Coverage, 7587,
     /* 587499 */     GIR_EraseRootFromParent_Done,
     /* 587500 */   // Label 7408: @587500
     /* 587500 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(587629), // Rule ID 11335 //
     /* 587505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587554 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587586 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587627 */     GIR_RootConstrainSelectedInstOperands,
     /* 587628 */     // GIR_Coverage, 11335,
     /* 587628 */     GIR_EraseRootFromParent_Done,
     /* 587629 */   // Label 7409: @587629
     /* 587629 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(587758), // Rule ID 11338 //
     /* 587634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587715 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587756 */     GIR_RootConstrainSelectedInstOperands,
     /* 587757 */     // GIR_Coverage, 11338,
     /* 587757 */     GIR_EraseRootFromParent_Done,
     /* 587758 */   // Label 7410: @587758
     /* 587758 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(587887), // Rule ID 11339 //
     /* 587763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587844 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587885 */     GIR_RootConstrainSelectedInstOperands,
     /* 587886 */     // GIR_Coverage, 11339,
     /* 587886 */     GIR_EraseRootFromParent_Done,
     /* 587887 */   // Label 7411: @587887
     /* 587887 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(588016), // Rule ID 7586 //
     /* 587892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587936 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587941 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587973 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588014 */     GIR_RootConstrainSelectedInstOperands,
     /* 588015 */     // GIR_Coverage, 7586,
     /* 588015 */     GIR_EraseRootFromParent_Done,
     /* 588016 */   // Label 7412: @588016
     /* 588016 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(588145), // Rule ID 11320 //
     /* 588021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 588061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588102 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588143 */     GIR_RootConstrainSelectedInstOperands,
     /* 588144 */     // GIR_Coverage, 11320,
     /* 588144 */     GIR_EraseRootFromParent_Done,
     /* 588145 */   // Label 7413: @588145
     /* 588145 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(588274), // Rule ID 11323 //
     /* 588150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 588190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588231 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588272 */     GIR_RootConstrainSelectedInstOperands,
     /* 588273 */     // GIR_Coverage, 11323,
     /* 588273 */     GIR_EraseRootFromParent_Done,
     /* 588274 */   // Label 7414: @588274
     /* 588274 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(588403), // Rule ID 11324 //
     /* 588279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 588319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588360 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588401 */     GIR_RootConstrainSelectedInstOperands,
     /* 588402 */     // GIR_Coverage, 11324,
     /* 588402 */     GIR_EraseRootFromParent_Done,
     /* 588403 */   // Label 7415: @588403
     /* 588403 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(588532), // Rule ID 11306 //
     /* 588408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588489 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588530 */     GIR_RootConstrainSelectedInstOperands,
     /* 588531 */     // GIR_Coverage, 11306,
     /* 588531 */     GIR_EraseRootFromParent_Done,
     /* 588532 */   // Label 7416: @588532
     /* 588532 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(588661), // Rule ID 11307 //
     /* 588537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588581 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588586 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588618 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588659 */     GIR_RootConstrainSelectedInstOperands,
     /* 588660 */     // GIR_Coverage, 11307,
     /* 588660 */     GIR_EraseRootFromParent_Done,
     /* 588661 */   // Label 7417: @588661
     /* 588661 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(588790), // Rule ID 11310 //
     /* 588666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588747 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588788 */     GIR_RootConstrainSelectedInstOperands,
     /* 588789 */     // GIR_Coverage, 11310,
     /* 588789 */     GIR_EraseRootFromParent_Done,
     /* 588790 */   // Label 7418: @588790
     /* 588790 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(588919), // Rule ID 11311 //
     /* 588795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588876 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588917 */     GIR_RootConstrainSelectedInstOperands,
     /* 588918 */     // GIR_Coverage, 11311,
     /* 588918 */     GIR_EraseRootFromParent_Done,
     /* 588919 */   // Label 7419: @588919
     /* 588919 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(589048), // Rule ID 11291 //
     /* 588924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589005 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589046 */     GIR_RootConstrainSelectedInstOperands,
     /* 589047 */     // GIR_Coverage, 11291,
     /* 589047 */     GIR_EraseRootFromParent_Done,
     /* 589048 */   // Label 7420: @589048
     /* 589048 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(589177), // Rule ID 11292 //
     /* 589053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 589093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589134 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589175 */     GIR_RootConstrainSelectedInstOperands,
     /* 589176 */     // GIR_Coverage, 11292,
     /* 589176 */     GIR_EraseRootFromParent_Done,
     /* 589177 */   // Label 7421: @589177
     /* 589177 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(589306), // Rule ID 11295 //
     /* 589182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 589222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589226 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589231 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589263 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589304 */     GIR_RootConstrainSelectedInstOperands,
     /* 589305 */     // GIR_Coverage, 11295,
     /* 589305 */     GIR_EraseRootFromParent_Done,
     /* 589306 */   // Label 7422: @589306
     /* 589306 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(589435), // Rule ID 11296 //
     /* 589311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 589351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589392 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589433 */     GIR_RootConstrainSelectedInstOperands,
     /* 589434 */     // GIR_Coverage, 11296,
     /* 589434 */     GIR_EraseRootFromParent_Done,
     /* 589435 */   // Label 7423: @589435
     /* 589435 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(589564), // Rule ID 7585 //
     /* 589440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589521 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589562 */     GIR_RootConstrainSelectedInstOperands,
     /* 589563 */     // GIR_Coverage, 7585,
     /* 589563 */     GIR_EraseRootFromParent_Done,
     /* 589564 */   // Label 7424: @589564
     /* 589564 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(589693), // Rule ID 11305 //
     /* 589569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589650 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589691 */     GIR_RootConstrainSelectedInstOperands,
     /* 589692 */     // GIR_Coverage, 11305,
     /* 589692 */     GIR_EraseRootFromParent_Done,
     /* 589693 */   // Label 7425: @589693
     /* 589693 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(589822), // Rule ID 11308 //
     /* 589698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589779 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589820 */     GIR_RootConstrainSelectedInstOperands,
     /* 589821 */     // GIR_Coverage, 11308,
     /* 589821 */     GIR_EraseRootFromParent_Done,
     /* 589822 */   // Label 7426: @589822
     /* 589822 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(589951), // Rule ID 11309 //
     /* 589827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589871 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589876 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589908 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589949 */     GIR_RootConstrainSelectedInstOperands,
     /* 589950 */     // GIR_Coverage, 11309,
     /* 589950 */     GIR_EraseRootFromParent_Done,
     /* 589951 */   // Label 7427: @589951
     /* 589951 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(590080), // Rule ID 7584 //
     /* 589956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590037 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590078 */     GIR_RootConstrainSelectedInstOperands,
     /* 590079 */     // GIR_Coverage, 7584,
     /* 590079 */     GIR_EraseRootFromParent_Done,
     /* 590080 */   // Label 7428: @590080
     /* 590080 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(590209), // Rule ID 11290 //
     /* 590085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 590125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590134 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590166 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590207 */     GIR_RootConstrainSelectedInstOperands,
     /* 590208 */     // GIR_Coverage, 11290,
     /* 590208 */     GIR_EraseRootFromParent_Done,
     /* 590209 */   // Label 7429: @590209
     /* 590209 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(590338), // Rule ID 11293 //
     /* 590214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 590254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590295 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590336 */     GIR_RootConstrainSelectedInstOperands,
     /* 590337 */     // GIR_Coverage, 11293,
     /* 590337 */     GIR_EraseRootFromParent_Done,
     /* 590338 */   // Label 7430: @590338
     /* 590338 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(590467), // Rule ID 11294 //
     /* 590343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 590383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590424 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590465 */     GIR_RootConstrainSelectedInstOperands,
     /* 590466 */     // GIR_Coverage, 11294,
     /* 590466 */     GIR_EraseRootFromParent_Done,
     /* 590467 */   // Label 7431: @590467
     /* 590467 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(590596), // Rule ID 11376 //
     /* 590472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590521 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590553 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590594 */     GIR_RootConstrainSelectedInstOperands,
     /* 590595 */     // GIR_Coverage, 11376,
     /* 590595 */     GIR_EraseRootFromParent_Done,
     /* 590596 */   // Label 7432: @590596
     /* 590596 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(590725), // Rule ID 11377 //
     /* 590601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590682 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590723 */     GIR_RootConstrainSelectedInstOperands,
     /* 590724 */     // GIR_Coverage, 11377,
     /* 590724 */     GIR_EraseRootFromParent_Done,
     /* 590725 */   // Label 7433: @590725
     /* 590725 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(590854), // Rule ID 11378 //
     /* 590730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590811 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 590821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 590826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590852 */     GIR_RootConstrainSelectedInstOperands,
     /* 590853 */     // GIR_Coverage, 11378,
     /* 590853 */     GIR_EraseRootFromParent_Done,
     /* 590854 */   // Label 7434: @590854
     /* 590854 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(590983), // Rule ID 11379 //
     /* 590859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590940 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 590950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 590955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590981 */     GIR_RootConstrainSelectedInstOperands,
     /* 590982 */     // GIR_Coverage, 11379,
     /* 590982 */     GIR_EraseRootFromParent_Done,
     /* 590983 */   // Label 7435: @590983
     /* 590983 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(591112), // Rule ID 11316 //
     /* 590988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591069 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591110 */     GIR_RootConstrainSelectedInstOperands,
     /* 591111 */     // GIR_Coverage, 11316,
     /* 591111 */     GIR_EraseRootFromParent_Done,
     /* 591112 */   // Label 7436: @591112
     /* 591112 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(591241), // Rule ID 11317 //
     /* 591117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591161 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591166 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591198 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591239 */     GIR_RootConstrainSelectedInstOperands,
     /* 591240 */     // GIR_Coverage, 11317,
     /* 591240 */     GIR_EraseRootFromParent_Done,
     /* 591241 */   // Label 7437: @591241
     /* 591241 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(591370), // Rule ID 11318 //
     /* 591246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591327 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591368 */     GIR_RootConstrainSelectedInstOperands,
     /* 591369 */     // GIR_Coverage, 11318,
     /* 591369 */     GIR_EraseRootFromParent_Done,
     /* 591370 */   // Label 7438: @591370
     /* 591370 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(591499), // Rule ID 11319 //
     /* 591375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591456 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591497 */     GIR_RootConstrainSelectedInstOperands,
     /* 591498 */     // GIR_Coverage, 11319,
     /* 591498 */     GIR_EraseRootFromParent_Done,
     /* 591499 */   // Label 7439: @591499
     /* 591499 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(591628), // Rule ID 11361 //
     /* 591504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591585 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591626 */     GIR_RootConstrainSelectedInstOperands,
     /* 591627 */     // GIR_Coverage, 11361,
     /* 591627 */     GIR_EraseRootFromParent_Done,
     /* 591628 */   // Label 7440: @591628
     /* 591628 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(591757), // Rule ID 11362 //
     /* 591633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591714 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591755 */     GIR_RootConstrainSelectedInstOperands,
     /* 591756 */     // GIR_Coverage, 11362,
     /* 591756 */     GIR_EraseRootFromParent_Done,
     /* 591757 */   // Label 7441: @591757
     /* 591757 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(591886), // Rule ID 11363 //
     /* 591762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591806 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591811 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591843 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591884 */     GIR_RootConstrainSelectedInstOperands,
     /* 591885 */     // GIR_Coverage, 11363,
     /* 591885 */     GIR_EraseRootFromParent_Done,
     /* 591886 */   // Label 7442: @591886
     /* 591886 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(592015), // Rule ID 11364 //
     /* 591891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591972 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592013 */     GIR_RootConstrainSelectedInstOperands,
     /* 592014 */     // GIR_Coverage, 11364,
     /* 592014 */     GIR_EraseRootFromParent_Done,
     /* 592015 */   // Label 7443: @592015
     /* 592015 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(592144), // Rule ID 11301 //
     /* 592020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592101 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 592121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 592126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592142 */     GIR_RootConstrainSelectedInstOperands,
     /* 592143 */     // GIR_Coverage, 11301,
     /* 592143 */     GIR_EraseRootFromParent_Done,
     /* 592144 */   // Label 7444: @592144
     /* 592144 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(592273), // Rule ID 11302 //
     /* 592149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592230 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 592250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 592255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592271 */     GIR_RootConstrainSelectedInstOperands,
     /* 592272 */     // GIR_Coverage, 11302,
     /* 592272 */     GIR_EraseRootFromParent_Done,
     /* 592273 */   // Label 7445: @592273
     /* 592273 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(592402), // Rule ID 11303 //
     /* 592278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592359 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 592369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 592374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592400 */     GIR_RootConstrainSelectedInstOperands,
     /* 592401 */     // GIR_Coverage, 11303,
     /* 592401 */     GIR_EraseRootFromParent_Done,
     /* 592402 */   // Label 7446: @592402
     /* 592402 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(592531), // Rule ID 11304 //
     /* 592407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592451 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592456 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592488 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 592498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 592503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592529 */     GIR_RootConstrainSelectedInstOperands,
     /* 592530 */     // GIR_Coverage, 11304,
     /* 592530 */     GIR_EraseRootFromParent_Done,
     /* 592531 */   // Label 7447: @592531
     /* 592531 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(592660), // Rule ID 11372 //
     /* 592536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592617 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592658 */     GIR_RootConstrainSelectedInstOperands,
     /* 592659 */     // GIR_Coverage, 11372,
     /* 592659 */     GIR_EraseRootFromParent_Done,
     /* 592660 */   // Label 7448: @592660
     /* 592660 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(592789), // Rule ID 11373 //
     /* 592665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592746 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592787 */     GIR_RootConstrainSelectedInstOperands,
     /* 592788 */     // GIR_Coverage, 11373,
     /* 592788 */     GIR_EraseRootFromParent_Done,
     /* 592789 */   // Label 7449: @592789
     /* 592789 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(592918), // Rule ID 11374 //
     /* 592794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592843 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592875 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592916 */     GIR_RootConstrainSelectedInstOperands,
     /* 592917 */     // GIR_Coverage, 11374,
     /* 592917 */     GIR_EraseRootFromParent_Done,
     /* 592918 */   // Label 7450: @592918
     /* 592918 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(593047), // Rule ID 11375 //
     /* 592923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593004 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593045 */     GIR_RootConstrainSelectedInstOperands,
     /* 593046 */     // GIR_Coverage, 11375,
     /* 593046 */     GIR_EraseRootFromParent_Done,
     /* 593047 */   // Label 7451: @593047
     /* 593047 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(593176), // Rule ID 11312 //
     /* 593052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593096 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593101 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593133 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593174 */     GIR_RootConstrainSelectedInstOperands,
     /* 593175 */     // GIR_Coverage, 11312,
     /* 593175 */     GIR_EraseRootFromParent_Done,
     /* 593176 */   // Label 7452: @593176
     /* 593176 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(593305), // Rule ID 11313 //
     /* 593181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593262 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593303 */     GIR_RootConstrainSelectedInstOperands,
     /* 593304 */     // GIR_Coverage, 11313,
     /* 593304 */     GIR_EraseRootFromParent_Done,
     /* 593305 */   // Label 7453: @593305
     /* 593305 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(593434), // Rule ID 11314 //
     /* 593310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593391 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593432 */     GIR_RootConstrainSelectedInstOperands,
     /* 593433 */     // GIR_Coverage, 11314,
     /* 593433 */     GIR_EraseRootFromParent_Done,
     /* 593434 */   // Label 7454: @593434
     /* 593434 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(593563), // Rule ID 11315 //
     /* 593439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593520 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593561 */     GIR_RootConstrainSelectedInstOperands,
     /* 593562 */     // GIR_Coverage, 11315,
     /* 593562 */     GIR_EraseRootFromParent_Done,
     /* 593563 */   // Label 7455: @593563
     /* 593563 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(593692), // Rule ID 11357 //
     /* 593568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593649 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593690 */     GIR_RootConstrainSelectedInstOperands,
     /* 593691 */     // GIR_Coverage, 11357,
     /* 593691 */     GIR_EraseRootFromParent_Done,
     /* 593692 */   // Label 7456: @593692
     /* 593692 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(593821), // Rule ID 11358 //
     /* 593697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593741 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593746 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593778 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593819 */     GIR_RootConstrainSelectedInstOperands,
     /* 593820 */     // GIR_Coverage, 11358,
     /* 593820 */     GIR_EraseRootFromParent_Done,
     /* 593821 */   // Label 7457: @593821
     /* 593821 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(593950), // Rule ID 11359 //
     /* 593826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593907 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593948 */     GIR_RootConstrainSelectedInstOperands,
     /* 593949 */     // GIR_Coverage, 11359,
     /* 593949 */     GIR_EraseRootFromParent_Done,
     /* 593950 */   // Label 7458: @593950
     /* 593950 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(594079), // Rule ID 11360 //
     /* 593955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594036 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594077 */     GIR_RootConstrainSelectedInstOperands,
     /* 594078 */     // GIR_Coverage, 11360,
     /* 594078 */     GIR_EraseRootFromParent_Done,
     /* 594079 */   // Label 7459: @594079
     /* 594079 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(594208), // Rule ID 11297 //
     /* 594084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594133 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594165 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594206 */     GIR_RootConstrainSelectedInstOperands,
     /* 594207 */     // GIR_Coverage, 11297,
     /* 594207 */     GIR_EraseRootFromParent_Done,
     /* 594208 */   // Label 7460: @594208
     /* 594208 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(594337), // Rule ID 11298 //
     /* 594213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594294 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594335 */     GIR_RootConstrainSelectedInstOperands,
     /* 594336 */     // GIR_Coverage, 11298,
     /* 594336 */     GIR_EraseRootFromParent_Done,
     /* 594337 */   // Label 7461: @594337
     /* 594337 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(594466), // Rule ID 11299 //
     /* 594342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594386 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594391 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594423 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594464 */     GIR_RootConstrainSelectedInstOperands,
     /* 594465 */     // GIR_Coverage, 11299,
     /* 594465 */     GIR_EraseRootFromParent_Done,
     /* 594466 */   // Label 7462: @594466
     /* 594466 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(594595), // Rule ID 11300 //
     /* 594471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594552 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594593 */     GIR_RootConstrainSelectedInstOperands,
     /* 594594 */     // GIR_Coverage, 11300,
     /* 594594 */     GIR_EraseRootFromParent_Done,
     /* 594595 */   // Label 7463: @594595
     /* 594595 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(594707), // Rule ID 13253 //
     /* 594600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594635 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594637 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 594641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594664 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594705 */     GIR_RootConstrainSelectedInstOperands,
     /* 594706 */     // GIR_Coverage, 13253,
     /* 594706 */     GIR_EraseRootFromParent_Done,
     /* 594707 */   // Label 7464: @594707
     /* 594707 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(594819), // Rule ID 13252 //
     /* 594712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594747 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594749 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 594753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594776 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594817 */     GIR_RootConstrainSelectedInstOperands,
     /* 594818 */     // GIR_Coverage, 13252,
     /* 594818 */     GIR_EraseRootFromParent_Done,
     /* 594819 */   // Label 7465: @594819
     /* 594819 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(594931), // Rule ID 7727 //
     /* 594824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594859 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594861 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 594865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594888 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594929 */     GIR_RootConstrainSelectedInstOperands,
     /* 594930 */     // GIR_Coverage, 7727,
     /* 594930 */     GIR_EraseRootFromParent_Done,
     /* 594931 */   // Label 7466: @594931
     /* 594931 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(595043), // Rule ID 7726 //
     /* 594936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594971 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594973 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 594977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595000 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 595035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595041 */     GIR_RootConstrainSelectedInstOperands,
     /* 595042 */     // GIR_Coverage, 7726,
     /* 595042 */     GIR_EraseRootFromParent_Done,
     /* 595043 */   // Label 7467: @595043
     /* 595043 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(595139), // Rule ID 13245 //
     /* 595048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 595051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 595059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595071 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 595073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 595075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595096 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595137 */     GIR_RootConstrainSelectedInstOperands,
     /* 595138 */     // GIR_Coverage, 13245,
     /* 595138 */     GIR_EraseRootFromParent_Done,
     /* 595139 */   // Label 7468: @595139
     /* 595139 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(595235), // Rule ID 13244 //
     /* 595144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 595147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 595155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595167 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 595169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 595171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595192 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595233 */     GIR_RootConstrainSelectedInstOperands,
     /* 595234 */     // GIR_Coverage, 13244,
     /* 595234 */     GIR_EraseRootFromParent_Done,
     /* 595235 */   // Label 7469: @595235
     /* 595235 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(595331), // Rule ID 7719 //
     /* 595240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 595243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595263 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 595265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 595267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595288 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 595323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595329 */     GIR_RootConstrainSelectedInstOperands,
     /* 595330 */     // GIR_Coverage, 7719,
     /* 595330 */     GIR_EraseRootFromParent_Done,
     /* 595331 */   // Label 7470: @595331
     /* 595331 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(595427), // Rule ID 7718 //
     /* 595336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 595339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595359 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 595361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 595363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595384 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 595419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595425 */     GIR_RootConstrainSelectedInstOperands,
     /* 595426 */     // GIR_Coverage, 7718,
     /* 595426 */     GIR_EraseRootFromParent_Done,
     /* 595427 */   // Label 7471: @595427
     /* 595427 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(595462), // Rule ID 92 //
     /* 595432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 595435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13766),
     /* 595451 */     // (fmaxnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13766>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 595451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 595456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 595460 */     GIR_RootConstrainSelectedInstOperands,
     /* 595461 */     // GIR_Coverage, 92,
     /* 595461 */     GIR_Done,
     /* 595462 */   // Label 7472: @595462
     /* 595462 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(595522), // Rule ID 802 //
     /* 595467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595485 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 595488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595520 */     GIR_RootConstrainSelectedInstOperands,
     /* 595521 */     // GIR_Coverage, 802,
     /* 595521 */     GIR_EraseRootFromParent_Done,
     /* 595522 */   // Label 7473: @595522
     /* 595522 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(595582), // Rule ID 8426 //
     /* 595527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595545 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 595548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595580 */     GIR_RootConstrainSelectedInstOperands,
     /* 595581 */     // GIR_Coverage, 8426,
     /* 595581 */     GIR_EraseRootFromParent_Done,
     /* 595582 */   // Label 7474: @595582
     /* 595582 */   GIM_Reject,
     /* 595583 */ // Label 7335: @595583
     /* 595583 */ GIM_Reject,
     /* 595584 */ // Label 6925: @595584
     /* 595584 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(595836),
     /* 595589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 595592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 595595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 595599 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(595658), // Rule ID 917 //
     /* 595604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 595607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595621 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 595624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595656 */     GIR_RootConstrainSelectedInstOperands,
     /* 595657 */     // GIR_Coverage, 917,
     /* 595657 */     GIR_EraseRootFromParent_Done,
     /* 595658 */   // Label 7476: @595658
     /* 595658 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(595717), // Rule ID 936 //
     /* 595663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 595666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595680 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 595683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595715 */     GIR_RootConstrainSelectedInstOperands,
     /* 595716 */     // GIR_Coverage, 936,
     /* 595716 */     GIR_EraseRootFromParent_Done,
     /* 595717 */   // Label 7477: @595717
     /* 595717 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(595776), // Rule ID 8452 //
     /* 595722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 595725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595739 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 595742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595774 */     GIR_RootConstrainSelectedInstOperands,
     /* 595775 */     // GIR_Coverage, 8452,
     /* 595775 */     GIR_EraseRootFromParent_Done,
     /* 595776 */   // Label 7478: @595776
     /* 595776 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(595835), // Rule ID 8466 //
     /* 595781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 595784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595798 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 595801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595833 */     GIR_RootConstrainSelectedInstOperands,
     /* 595834 */     // GIR_Coverage, 8466,
     /* 595834 */     GIR_EraseRootFromParent_Done,
     /* 595835 */   // Label 7479: @595835
     /* 595835 */   GIM_Reject,
     /* 595836 */ // Label 7475: @595836
     /* 595836 */ GIM_Reject,
     /* 595837 */ // Label 6926: @595837
     /* 595837 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(595908), // Rule ID 1094 //
     /* 595842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 595845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 595848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 595859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 595866 */   // (fmaxnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 595866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 595869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595906 */   GIR_RootConstrainSelectedInstOperands,
     /* 595907 */   // GIR_Coverage, 1094,
     /* 595907 */   GIR_EraseRootFromParent_Done,
     /* 595908 */ // Label 7480: @595908
     /* 595908 */ GIM_Reject,
     /* 595909 */ // Label 6927: @595909
     /* 595909 */ GIM_Reject,
     /* 595910 */ // Label 84: @595910
     /* 595910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7485*/ GIMT_Encode4(598036),
     /* 595921 */ /*GILLT_s16*//*Label 7481*/ GIMT_Encode4(595937),
     /* 595925 */ /*GILLT_s32*//*Label 7482*/ GIMT_Encode4(597067),
     /* 595929 */ /*GILLT_s64*//*Label 7483*/ GIMT_Encode4(597746),
     /* 595933 */ /*GILLT_v2s16*//*Label 7484*/ GIMT_Encode4(597881),
     /* 595937 */ // Label 7481: @595937
     /* 595937 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(597066),
     /* 595942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 595945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 595948 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(596067), // Rule ID 13449 //
     /* 595953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 595956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 595960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 595964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 595968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 595972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 595976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 595980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 595984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 595988 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 595990 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 595994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 595998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596021 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596065 */     GIR_RootConstrainSelectedInstOperands,
     /* 596066 */     // GIR_Coverage, 13449,
     /* 596066 */     GIR_EraseRootFromParent_Done,
     /* 596067 */   // Label 7487: @596067
     /* 596067 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(596186), // Rule ID 13453 //
     /* 596072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 596103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 596107 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596109 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 596113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596140 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596184 */     GIR_RootConstrainSelectedInstOperands,
     /* 596185 */     // GIR_Coverage, 13453,
     /* 596185 */     GIR_EraseRootFromParent_Done,
     /* 596186 */   // Label 7488: @596186
     /* 596186 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(596305), // Rule ID 7783 //
     /* 596191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 596222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 596226 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596228 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 596232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596259 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596303 */     GIR_RootConstrainSelectedInstOperands,
     /* 596304 */     // GIR_Coverage, 7783,
     /* 596304 */     GIR_EraseRootFromParent_Done,
     /* 596305 */   // Label 7489: @596305
     /* 596305 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(596424), // Rule ID 7787 //
     /* 596310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 596341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 596345 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596347 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 596351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596378 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596422 */     GIR_RootConstrainSelectedInstOperands,
     /* 596423 */     // GIR_Coverage, 7787,
     /* 596423 */     GIR_EraseRootFromParent_Done,
     /* 596424 */   // Label 7490: @596424
     /* 596424 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(596527), // Rule ID 13447 //
     /* 596429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596452 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596481 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596525 */     GIR_RootConstrainSelectedInstOperands,
     /* 596526 */     // GIR_Coverage, 13447,
     /* 596526 */     GIR_EraseRootFromParent_Done,
     /* 596527 */   // Label 7491: @596527
     /* 596527 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(596630), // Rule ID 13451 //
     /* 596532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596555 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596584 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596628 */     GIR_RootConstrainSelectedInstOperands,
     /* 596629 */     // GIR_Coverage, 13451,
     /* 596629 */     GIR_EraseRootFromParent_Done,
     /* 596630 */   // Label 7492: @596630
     /* 596630 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(596733), // Rule ID 7781 //
     /* 596635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596658 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596687 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596731 */     GIR_RootConstrainSelectedInstOperands,
     /* 596732 */     // GIR_Coverage, 7781,
     /* 596732 */     GIR_EraseRootFromParent_Done,
     /* 596733 */   // Label 7493: @596733
     /* 596733 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(596836), // Rule ID 7785 //
     /* 596738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596761 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596790 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596834 */     GIR_RootConstrainSelectedInstOperands,
     /* 596835 */     // GIR_Coverage, 7785,
     /* 596835 */     GIR_EraseRootFromParent_Done,
     /* 596836 */   // Label 7494: @596836
     /* 596836 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(596902), // Rule ID 943 //
     /* 596841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 596844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596866 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20153>>  =>  (V_MINIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_e64),
     /* 596869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 596876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 596886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596900 */     GIR_RootConstrainSelectedInstOperands,
     /* 596901 */     // GIR_Coverage, 943,
     /* 596901 */     GIR_EraseRootFromParent_Done,
     /* 596902 */   // Label 7495: @596902
     /* 596902 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(596968), // Rule ID 944 //
     /* 596907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596932 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20153>>  =>  (V_MINIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_t16_e64),
     /* 596935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 596942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 596952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596966 */     GIR_RootConstrainSelectedInstOperands,
     /* 596967 */     // GIR_Coverage, 944,
     /* 596967 */     GIR_EraseRootFromParent_Done,
     /* 596968 */   // Label 7496: @596968
     /* 596968 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(597034), // Rule ID 945 //
     /* 596973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 596984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596998 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20153>>  =>  (V_MINIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_fake16_e64),
     /* 597001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597032 */     GIR_RootConstrainSelectedInstOperands,
     /* 597033 */     // GIR_Coverage, 945,
     /* 597033 */     GIR_EraseRootFromParent_Done,
     /* 597034 */   // Label 7497: @597034
     /* 597034 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(597065), // Rule ID 116 //
     /* 597039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13771),
     /* 597058 */     // (fminimum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13771>>  =>  (S_MINIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 597058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F16),
     /* 597063 */     GIR_RootConstrainSelectedInstOperands,
     /* 597064 */     // GIR_Coverage, 116,
     /* 597064 */     GIR_Done,
     /* 597065 */   // Label 7498: @597065
     /* 597065 */   GIM_Reject,
     /* 597066 */ // Label 7486: @597066
     /* 597066 */ GIM_Reject,
     /* 597067 */ // Label 7482: @597067
     /* 597067 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(597745),
     /* 597072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 597075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 597078 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(597194), // Rule ID 13445 //
     /* 597083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 597094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 597098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597118 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 597120 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 597124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 597130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597151 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 597171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 597176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 597181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 597186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597192 */     GIR_RootConstrainSelectedInstOperands,
     /* 597193 */     // GIR_Coverage, 13445,
     /* 597193 */     GIR_EraseRootFromParent_Done,
     /* 597194 */   // Label 7500: @597194
     /* 597194 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(597310), // Rule ID 7779 //
     /* 597199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 597214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597234 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 597236 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 597240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 597246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597267 */     // (fminimum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597308 */     GIR_RootConstrainSelectedInstOperands,
     /* 597309 */     // GIR_Coverage, 7779,
     /* 597309 */     GIR_EraseRootFromParent_Done,
     /* 597310 */   // Label 7501: @597310
     /* 597310 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(597410), // Rule ID 13443 //
     /* 597315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 597326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597338 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 597340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 597346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597367 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 597387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 597392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 597397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 597402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597408 */     GIR_RootConstrainSelectedInstOperands,
     /* 597409 */     // GIR_Coverage, 13443,
     /* 597409 */     GIR_EraseRootFromParent_Done,
     /* 597410 */   // Label 7502: @597410
     /* 597410 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(597510), // Rule ID 7777 //
     /* 597415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597438 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 597440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 597446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597467 */     // (fminimum:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20153>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597508 */     GIR_RootConstrainSelectedInstOperands,
     /* 597509 */     // GIR_Coverage, 7777,
     /* 597509 */     GIR_EraseRootFromParent_Done,
     /* 597510 */   // Label 7503: @597510
     /* 597510 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(597577), // Rule ID 941 //
     /* 597515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597540 */     // (fminimum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20153>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 597543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 597570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 597575 */     GIR_RootConstrainSelectedInstOperands,
     /* 597576 */     // GIR_Coverage, 941,
     /* 597576 */     GIR_EraseRootFromParent_Done,
     /* 597577 */   // Label 7504: @597577
     /* 597577 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(597644), // Rule ID 8471 //
     /* 597582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20153),
     /* 597593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597607 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20153>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 597610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 597617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 597627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 597637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 597642 */     GIR_RootConstrainSelectedInstOperands,
     /* 597643 */     // GIR_Coverage, 8471,
     /* 597643 */     GIR_EraseRootFromParent_Done,
     /* 597644 */   // Label 7505: @597644
     /* 597644 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(597713), // Rule ID 2710 //
     /* 597649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 597652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597670 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MINIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 597670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM3_F32_e64),
     /* 597673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597711 */     GIR_RootConstrainSelectedInstOperands,
     /* 597712 */     // GIR_Coverage, 2710,
     /* 597712 */     GIR_EraseRootFromParent_Done,
     /* 597713 */   // Label 7506: @597713
     /* 597713 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(597744), // Rule ID 114 //
     /* 597718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13771),
     /* 597737 */     // (fminimum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13771>>  =>  (S_MINIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 597737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F32),
     /* 597742 */     GIR_RootConstrainSelectedInstOperands,
     /* 597743 */     // GIR_Coverage, 114,
     /* 597743 */     GIR_Done,
     /* 597744 */   // Label 7507: @597744
     /* 597744 */   GIM_Reject,
     /* 597745 */ // Label 7499: @597745
     /* 597745 */ GIM_Reject,
     /* 597746 */ // Label 7483: @597746
     /* 597746 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(597880),
     /* 597751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 597754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 597757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 597761 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(597820), // Rule ID 949 //
     /* 597766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597783 */     // (fminimum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 597786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 597813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 597818 */     GIR_RootConstrainSelectedInstOperands,
     /* 597819 */     // GIR_Coverage, 949,
     /* 597819 */     GIR_EraseRootFromParent_Done,
     /* 597820 */   // Label 7509: @597820
     /* 597820 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(597879), // Rule ID 8473 //
     /* 597825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597842 */     // (fminimum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 597845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 597852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 597862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 597872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 597877 */     GIR_RootConstrainSelectedInstOperands,
     /* 597878 */     // GIR_Coverage, 8473,
     /* 597878 */     GIR_EraseRootFromParent_Done,
     /* 597879 */   // Label 7510: @597879
     /* 597879 */   GIM_Reject,
     /* 597880 */ // Label 7508: @597880
     /* 597880 */ GIM_Reject,
     /* 597881 */ // Label 7484: @597881
     /* 597881 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(598035),
     /* 597886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 597889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 597892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597896 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(597970), // Rule ID 2728 //
     /* 597901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 597904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597918 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MINIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 597918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM3_F16),
     /* 597921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597968 */     GIR_RootConstrainSelectedInstOperands,
     /* 597969 */     // GIR_Coverage, 2728,
     /* 597969 */     GIR_EraseRootFromParent_Done,
     /* 597970 */   // Label 7512: @597970
     /* 597970 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(598034), // Rule ID 1105 //
     /* 597975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597992 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MINIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 597992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM_F16),
     /* 597995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 598002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 598012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598032 */     GIR_RootConstrainSelectedInstOperands,
     /* 598033 */     // GIR_Coverage, 1105,
     /* 598033 */     GIR_EraseRootFromParent_Done,
     /* 598034 */   // Label 7513: @598034
     /* 598034 */   GIM_Reject,
     /* 598035 */ // Label 7511: @598035
     /* 598035 */ GIM_Reject,
     /* 598036 */ // Label 7485: @598036
     /* 598036 */ GIM_Reject,
     /* 598037 */ // Label 85: @598037
     /* 598037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7518*/ GIMT_Encode4(600163),
     /* 598048 */ /*GILLT_s16*//*Label 7514*/ GIMT_Encode4(598064),
     /* 598052 */ /*GILLT_s32*//*Label 7515*/ GIMT_Encode4(599194),
     /* 598056 */ /*GILLT_s64*//*Label 7516*/ GIMT_Encode4(599873),
     /* 598060 */ /*GILLT_v2s16*//*Label 7517*/ GIMT_Encode4(600008),
     /* 598064 */ // Label 7514: @598064
     /* 598064 */ GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(599193),
     /* 598069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 598072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 598075 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(598194), // Rule ID 13448 //
     /* 598080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598115 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598117 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 598121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598148 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598192 */     GIR_RootConstrainSelectedInstOperands,
     /* 598193 */     // GIR_Coverage, 13448,
     /* 598193 */     GIR_EraseRootFromParent_Done,
     /* 598194 */   // Label 7520: @598194
     /* 598194 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(598313), // Rule ID 13452 //
     /* 598199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598234 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598236 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 598240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598267 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598311 */     GIR_RootConstrainSelectedInstOperands,
     /* 598312 */     // GIR_Coverage, 13452,
     /* 598312 */     GIR_EraseRootFromParent_Done,
     /* 598313 */   // Label 7521: @598313
     /* 598313 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(598432), // Rule ID 7782 //
     /* 598318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598353 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 598359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598386 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598430 */     GIR_RootConstrainSelectedInstOperands,
     /* 598431 */     // GIR_Coverage, 7782,
     /* 598431 */     GIR_EraseRootFromParent_Done,
     /* 598432 */   // Label 7522: @598432
     /* 598432 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(598551), // Rule ID 7786 //
     /* 598437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598472 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598474 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 598478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598505 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598549 */     GIR_RootConstrainSelectedInstOperands,
     /* 598550 */     // GIR_Coverage, 7786,
     /* 598550 */     GIR_EraseRootFromParent_Done,
     /* 598551 */   // Label 7523: @598551
     /* 598551 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(598654), // Rule ID 13446 //
     /* 598556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598579 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598608 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598652 */     GIR_RootConstrainSelectedInstOperands,
     /* 598653 */     // GIR_Coverage, 13446,
     /* 598653 */     GIR_EraseRootFromParent_Done,
     /* 598654 */   // Label 7524: @598654
     /* 598654 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(598757), // Rule ID 13450 //
     /* 598659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598682 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598711 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598755 */     GIR_RootConstrainSelectedInstOperands,
     /* 598756 */     // GIR_Coverage, 13450,
     /* 598756 */     GIR_EraseRootFromParent_Done,
     /* 598757 */   // Label 7525: @598757
     /* 598757 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(598860), // Rule ID 7780 //
     /* 598762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598785 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598814 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598858 */     GIR_RootConstrainSelectedInstOperands,
     /* 598859 */     // GIR_Coverage, 7780,
     /* 598859 */     GIR_EraseRootFromParent_Done,
     /* 598860 */   // Label 7526: @598860
     /* 598860 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(598963), // Rule ID 7784 //
     /* 598865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598888 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598917 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598961 */     GIR_RootConstrainSelectedInstOperands,
     /* 598962 */     // GIR_Coverage, 7784,
     /* 598962 */     GIR_EraseRootFromParent_Done,
     /* 598963 */   // Label 7527: @598963
     /* 598963 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(599029), // Rule ID 946 //
     /* 598968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 598971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 598979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598993 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20156>>  =>  (V_MAXIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 598993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_e64),
     /* 598996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599027 */     GIR_RootConstrainSelectedInstOperands,
     /* 599028 */     // GIR_Coverage, 946,
     /* 599028 */     GIR_EraseRootFromParent_Done,
     /* 599029 */   // Label 7528: @599029
     /* 599029 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(599095), // Rule ID 947 //
     /* 599034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 599037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 599041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 599052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 599059 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20156>>  =>  (V_MAXIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 599059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_t16_e64),
     /* 599062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599093 */     GIR_RootConstrainSelectedInstOperands,
     /* 599094 */     // GIR_Coverage, 947,
     /* 599094 */     GIR_EraseRootFromParent_Done,
     /* 599095 */   // Label 7529: @599095
     /* 599095 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(599161), // Rule ID 948 //
     /* 599100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 599103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 599118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 599125 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20156>>  =>  (V_MAXIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 599125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_fake16_e64),
     /* 599128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599159 */     GIR_RootConstrainSelectedInstOperands,
     /* 599160 */     // GIR_Coverage, 948,
     /* 599160 */     GIR_EraseRootFromParent_Done,
     /* 599161 */   // Label 7530: @599161
     /* 599161 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(599192), // Rule ID 117 //
     /* 599166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13772),
     /* 599185 */     // (fmaximum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13772>>  =>  (S_MAXIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 599185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F16),
     /* 599190 */     GIR_RootConstrainSelectedInstOperands,
     /* 599191 */     // GIR_Coverage, 117,
     /* 599191 */     GIR_Done,
     /* 599192 */   // Label 7531: @599192
     /* 599192 */   GIM_Reject,
     /* 599193 */ // Label 7519: @599193
     /* 599193 */ GIM_Reject,
     /* 599194 */ // Label 7515: @599194
     /* 599194 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(599872),
     /* 599199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 599202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 599205 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(599321), // Rule ID 13444 //
     /* 599210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 599221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 599225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 599233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 599241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 599245 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 599247 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 599251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 599257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599278 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 599288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599319 */     GIR_RootConstrainSelectedInstOperands,
     /* 599320 */     // GIR_Coverage, 13444,
     /* 599320 */     GIR_EraseRootFromParent_Done,
     /* 599321 */   // Label 7533: @599321
     /* 599321 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(599437), // Rule ID 7778 //
     /* 599326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 599341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 599349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 599357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 599361 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 599363 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34981),
     /* 599367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 599373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599394 */     // (fmaximum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34981>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599435 */     GIR_RootConstrainSelectedInstOperands,
     /* 599436 */     // GIR_Coverage, 7778,
     /* 599436 */     GIR_EraseRootFromParent_Done,
     /* 599437 */   // Label 7534: @599437
     /* 599437 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(599537), // Rule ID 13442 //
     /* 599442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 599453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599465 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599494 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 599504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599535 */     GIR_RootConstrainSelectedInstOperands,
     /* 599536 */     // GIR_Coverage, 13442,
     /* 599536 */     GIR_EraseRootFromParent_Done,
     /* 599537 */   // Label 7535: @599537
     /* 599537 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(599637), // Rule ID 7776 //
     /* 599542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599565 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599594 */     // (fmaximum:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20156>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599635 */     GIR_RootConstrainSelectedInstOperands,
     /* 599636 */     // GIR_Coverage, 7776,
     /* 599636 */     GIR_EraseRootFromParent_Done,
     /* 599637 */   // Label 7536: @599637
     /* 599637 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(599704), // Rule ID 942 //
     /* 599642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599667 */     // (fmaximum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20156>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 599670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599702 */     GIR_RootConstrainSelectedInstOperands,
     /* 599703 */     // GIR_Coverage, 942,
     /* 599703 */     GIR_EraseRootFromParent_Done,
     /* 599704 */   // Label 7537: @599704
     /* 599704 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(599771), // Rule ID 8472 //
     /* 599709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20156),
     /* 599720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599734 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20156>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 599737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599769 */     GIR_RootConstrainSelectedInstOperands,
     /* 599770 */     // GIR_Coverage, 8472,
     /* 599770 */     GIR_EraseRootFromParent_Done,
     /* 599771 */   // Label 7538: @599771
     /* 599771 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(599840), // Rule ID 2711 //
     /* 599776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 599779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599797 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MAXIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 599797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM3_F32_e64),
     /* 599800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599838 */     GIR_RootConstrainSelectedInstOperands,
     /* 599839 */     // GIR_Coverage, 2711,
     /* 599839 */     GIR_EraseRootFromParent_Done,
     /* 599840 */   // Label 7539: @599840
     /* 599840 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(599871), // Rule ID 115 //
     /* 599845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13772),
     /* 599864 */     // (fmaximum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13772>>  =>  (S_MAXIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 599864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F32),
     /* 599869 */     GIR_RootConstrainSelectedInstOperands,
     /* 599870 */     // GIR_Coverage, 115,
     /* 599870 */     GIR_Done,
     /* 599871 */   // Label 7540: @599871
     /* 599871 */   GIM_Reject,
     /* 599872 */ // Label 7532: @599872
     /* 599872 */ GIM_Reject,
     /* 599873 */ // Label 7516: @599873
     /* 599873 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(600007),
     /* 599878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 599881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 599884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 599888 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(599947), // Rule ID 950 //
     /* 599893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599910 */     // (fmaximum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 599913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599945 */     GIR_RootConstrainSelectedInstOperands,
     /* 599946 */     // GIR_Coverage, 950,
     /* 599946 */     GIR_EraseRootFromParent_Done,
     /* 599947 */   // Label 7542: @599947
     /* 599947 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(600006), // Rule ID 8474 //
     /* 599952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599969 */     // (fmaximum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 599972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 600004 */     GIR_RootConstrainSelectedInstOperands,
     /* 600005 */     // GIR_Coverage, 8474,
     /* 600005 */     GIR_EraseRootFromParent_Done,
     /* 600006 */   // Label 7543: @600006
     /* 600006 */   GIM_Reject,
     /* 600007 */ // Label 7541: @600007
     /* 600007 */ GIM_Reject,
     /* 600008 */ // Label 7517: @600008
     /* 600008 */ GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(600162),
     /* 600013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 600016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 600019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600023 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(600097), // Rule ID 2729 //
     /* 600028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 600031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 600038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 600045 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MAXIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 600045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM3_F16),
     /* 600048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 600055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600095 */     GIR_RootConstrainSelectedInstOperands,
     /* 600096 */     // GIR_Coverage, 2729,
     /* 600096 */     GIR_EraseRootFromParent_Done,
     /* 600097 */   // Label 7545: @600097
     /* 600097 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(600161), // Rule ID 1104 //
     /* 600102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 600105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 600112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 600119 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAXIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 600119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM_F16),
     /* 600122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 600129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 600139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600159 */     GIR_RootConstrainSelectedInstOperands,
     /* 600160 */     // GIR_Coverage, 1104,
     /* 600160 */     GIR_EraseRootFromParent_Done,
     /* 600161 */   // Label 7546: @600161
     /* 600161 */   GIM_Reject,
     /* 600162 */ // Label 7544: @600162
     /* 600162 */ GIM_Reject,
     /* 600163 */ // Label 7518: @600163
     /* 600163 */ GIM_Reject,
     /* 600164 */ // Label 86: @600164
     /* 600164 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(600287),
     /* 600169 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 600172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 600176 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(600231), // Rule ID 1874 //
     /* 600181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 600184 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 8909823:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 47105:{ *:[i32] }))
     /* 600184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 600187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 600191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 600196 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(47105),
     /* 600206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 600208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 600211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 600213 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(8909823),
     /* 600223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 600226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 600229 */     GIR_RootConstrainSelectedInstOperands,
     /* 600230 */     // GIR_Coverage, 1874,
     /* 600230 */     GIR_EraseRootFromParent_Done,
     /* 600231 */   // Label 7548: @600231
     /* 600231 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(600286), // Rule ID 1875 //
     /* 600236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 600239 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 521215:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 36865:{ *:[i32] }))
     /* 600239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 600242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 600246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 600251 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(36865),
     /* 600261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 600263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 600266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 600268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(521215),
     /* 600278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 600281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 600284 */     GIR_RootConstrainSelectedInstOperands,
     /* 600285 */     // GIR_Coverage, 1875,
     /* 600285 */     GIR_EraseRootFromParent_Done,
     /* 600286 */   // Label 7549: @600286
     /* 600286 */   GIM_Reject,
     /* 600287 */ // Label 7547: @600287
     /* 600287 */ GIM_Reject,
     /* 600288 */ // Label 87: @600288
     /* 600288 */ GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(600364), // Rule ID 2594 //
     /* 600293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 600296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 600299 */   // MIs[0] DstI[vdst]
     /* 600299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 600303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600307 */   // MIs[0] Operand 1
     /* 600307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 600311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_PTR_ADD),
     /* 600319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 600323 */   GIM_CheckHasOneUse, /*MI*/1,
     /* 600325 */   // MIs[1] src0
     /* 600325 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/32,
     /* 600329 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /* 600333 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /* 600337 */   GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:4:z
     /* 600341 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20783),
     /* 600345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600347 */   // (ptradd:{ *:[i32] } (ptradd:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:4:x, i32:{ *:[i32] }:$src1:$pred:4:y)<<P:Predicate_anonymous_20784>>, i32:{ *:[i32] }:$src2:$pred:4:z)<<P:4:Predicate_anonymous_20783>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 600347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /* 600350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600352 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 600356 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 600360 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 600362 */   GIR_RootConstrainSelectedInstOperands,
     /* 600363 */   // GIR_Coverage, 2594,
     /* 600363 */   GIR_EraseRootFromParent_Done,
     /* 600364 */ // Label 7550: @600364
     /* 600364 */ GIM_Reject,
     /* 600365 */ // Label 88: @600365
     /* 600365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7554*/ GIMT_Encode4(606728),
     /* 600376 */ /*GILLT_s16*//*Label 7551*/ GIMT_Encode4(600392),
     /* 600380 */ /*GILLT_s32*//*Label 7552*/ GIMT_Encode4(605211), GIMT_Encode4(0),
     /* 600388 */ /*GILLT_v2s16*//*Label 7553*/ GIMT_Encode4(606656),
     /* 600392 */ // Label 7551: @600392
     /* 600392 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(605210),
     /* 600397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 600400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 600403 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(600501), // Rule ID 11792 //
     /* 600408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600455 */     // MIs[3] src0
     /* 600455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600460 */     // MIs[3] src1
     /* 600460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600467 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600499 */     GIR_RootConstrainSelectedInstOperands,
     /* 600500 */     // GIR_Coverage, 11792,
     /* 600500 */     GIR_EraseRootFromParent_Done,
     /* 600501 */   // Label 7556: @600501
     /* 600501 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(600599), // Rule ID 11793 //
     /* 600506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600553 */     // MIs[3] src1
     /* 600553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600558 */     // MIs[3] src0
     /* 600558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600565 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600597 */     GIR_RootConstrainSelectedInstOperands,
     /* 600598 */     // GIR_Coverage, 11793,
     /* 600598 */     GIR_EraseRootFromParent_Done,
     /* 600599 */   // Label 7557: @600599
     /* 600599 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(600697), // Rule ID 11794 //
     /* 600604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600651 */     // MIs[3] src0
     /* 600651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600656 */     // MIs[3] src1
     /* 600656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600663 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600695 */     GIR_RootConstrainSelectedInstOperands,
     /* 600696 */     // GIR_Coverage, 11794,
     /* 600696 */     GIR_EraseRootFromParent_Done,
     /* 600697 */   // Label 7558: @600697
     /* 600697 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(600795), // Rule ID 11795 //
     /* 600702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600749 */     // MIs[3] src1
     /* 600749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600754 */     // MIs[3] src0
     /* 600754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600761 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600793 */     GIR_RootConstrainSelectedInstOperands,
     /* 600794 */     // GIR_Coverage, 11795,
     /* 600794 */     GIR_EraseRootFromParent_Done,
     /* 600795 */   // Label 7559: @600795
     /* 600795 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(600893), // Rule ID 13344 //
     /* 600800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600847 */     // MIs[3] src0
     /* 600847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600852 */     // MIs[3] src1
     /* 600852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600859 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600891 */     GIR_RootConstrainSelectedInstOperands,
     /* 600892 */     // GIR_Coverage, 13344,
     /* 600892 */     GIR_EraseRootFromParent_Done,
     /* 600893 */   // Label 7560: @600893
     /* 600893 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(600991), // Rule ID 13345 //
     /* 600898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600945 */     // MIs[3] src1
     /* 600945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600950 */     // MIs[3] src0
     /* 600950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600957 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600989 */     GIR_RootConstrainSelectedInstOperands,
     /* 600990 */     // GIR_Coverage, 13345,
     /* 600990 */     GIR_EraseRootFromParent_Done,
     /* 600991 */   // Label 7561: @600991
     /* 600991 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(601089), // Rule ID 13346 //
     /* 600996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601043 */     // MIs[3] src0
     /* 601043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601048 */     // MIs[3] src1
     /* 601048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601055 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 601058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601087 */     GIR_RootConstrainSelectedInstOperands,
     /* 601088 */     // GIR_Coverage, 13346,
     /* 601088 */     GIR_EraseRootFromParent_Done,
     /* 601089 */   // Label 7562: @601089
     /* 601089 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(601187), // Rule ID 13347 //
     /* 601094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601141 */     // MIs[3] src1
     /* 601141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601146 */     // MIs[3] src0
     /* 601146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601153 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 601156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601185 */     GIR_RootConstrainSelectedInstOperands,
     /* 601186 */     // GIR_Coverage, 13347,
     /* 601186 */     GIR_EraseRootFromParent_Done,
     /* 601187 */   // Label 7563: @601187
     /* 601187 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(601285), // Rule ID 13404 //
     /* 601192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601239 */     // MIs[3] src0
     /* 601239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601244 */     // MIs[3] src1
     /* 601244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601251 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601283 */     GIR_RootConstrainSelectedInstOperands,
     /* 601284 */     // GIR_Coverage, 13404,
     /* 601284 */     GIR_EraseRootFromParent_Done,
     /* 601285 */   // Label 7564: @601285
     /* 601285 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(601383), // Rule ID 13405 //
     /* 601290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601337 */     // MIs[3] src1
     /* 601337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601342 */     // MIs[3] src0
     /* 601342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601349 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601381 */     GIR_RootConstrainSelectedInstOperands,
     /* 601382 */     // GIR_Coverage, 13405,
     /* 601382 */     GIR_EraseRootFromParent_Done,
     /* 601383 */   // Label 7565: @601383
     /* 601383 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(601481), // Rule ID 13406 //
     /* 601388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601435 */     // MIs[3] src0
     /* 601435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601440 */     // MIs[3] src1
     /* 601440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601447 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601479 */     GIR_RootConstrainSelectedInstOperands,
     /* 601480 */     // GIR_Coverage, 13406,
     /* 601480 */     GIR_EraseRootFromParent_Done,
     /* 601481 */   // Label 7566: @601481
     /* 601481 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(601579), // Rule ID 13407 //
     /* 601486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601533 */     // MIs[3] src1
     /* 601533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601538 */     // MIs[3] src0
     /* 601538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601545 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601577 */     GIR_RootConstrainSelectedInstOperands,
     /* 601578 */     // GIR_Coverage, 13407,
     /* 601578 */     GIR_EraseRootFromParent_Done,
     /* 601579 */   // Label 7567: @601579
     /* 601579 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(601677), // Rule ID 11796 //
     /* 601584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601631 */     // MIs[3] src0
     /* 601631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601636 */     // MIs[3] src1
     /* 601636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601643 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601675 */     GIR_RootConstrainSelectedInstOperands,
     /* 601676 */     // GIR_Coverage, 11796,
     /* 601676 */     GIR_EraseRootFromParent_Done,
     /* 601677 */   // Label 7568: @601677
     /* 601677 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(601775), // Rule ID 11797 //
     /* 601682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601729 */     // MIs[3] src1
     /* 601729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601734 */     // MIs[3] src0
     /* 601734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601741 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601773 */     GIR_RootConstrainSelectedInstOperands,
     /* 601774 */     // GIR_Coverage, 11797,
     /* 601774 */     GIR_EraseRootFromParent_Done,
     /* 601775 */   // Label 7569: @601775
     /* 601775 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(601873), // Rule ID 11798 //
     /* 601780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601827 */     // MIs[3] src0
     /* 601827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601832 */     // MIs[3] src1
     /* 601832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601839 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601871 */     GIR_RootConstrainSelectedInstOperands,
     /* 601872 */     // GIR_Coverage, 11798,
     /* 601872 */     GIR_EraseRootFromParent_Done,
     /* 601873 */   // Label 7570: @601873
     /* 601873 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(601971), // Rule ID 11799 //
     /* 601878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601925 */     // MIs[3] src1
     /* 601925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601930 */     // MIs[3] src0
     /* 601930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601937 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601969 */     GIR_RootConstrainSelectedInstOperands,
     /* 601970 */     // GIR_Coverage, 11799,
     /* 601970 */     GIR_EraseRootFromParent_Done,
     /* 601971 */   // Label 7571: @601971
     /* 601971 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(602069), // Rule ID 13348 //
     /* 601976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602023 */     // MIs[3] src0
     /* 602023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602028 */     // MIs[3] src1
     /* 602028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602035 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602067 */     GIR_RootConstrainSelectedInstOperands,
     /* 602068 */     // GIR_Coverage, 13348,
     /* 602068 */     GIR_EraseRootFromParent_Done,
     /* 602069 */   // Label 7572: @602069
     /* 602069 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(602167), // Rule ID 13349 //
     /* 602074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 602077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602121 */     // MIs[3] src1
     /* 602121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602126 */     // MIs[3] src0
     /* 602126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602133 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602165 */     GIR_RootConstrainSelectedInstOperands,
     /* 602166 */     // GIR_Coverage, 13349,
     /* 602166 */     GIR_EraseRootFromParent_Done,
     /* 602167 */   // Label 7573: @602167
     /* 602167 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(602265), // Rule ID 13350 //
     /* 602172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 602175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602219 */     // MIs[3] src0
     /* 602219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602224 */     // MIs[3] src1
     /* 602224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602231 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602263 */     GIR_RootConstrainSelectedInstOperands,
     /* 602264 */     // GIR_Coverage, 13350,
     /* 602264 */     GIR_EraseRootFromParent_Done,
     /* 602265 */   // Label 7574: @602265
     /* 602265 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(602363), // Rule ID 13351 //
     /* 602270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 602273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602317 */     // MIs[3] src1
     /* 602317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602322 */     // MIs[3] src0
     /* 602322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602329 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602361 */     GIR_RootConstrainSelectedInstOperands,
     /* 602362 */     // GIR_Coverage, 13351,
     /* 602362 */     GIR_EraseRootFromParent_Done,
     /* 602363 */   // Label 7575: @602363
     /* 602363 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(602461), // Rule ID 13408 //
     /* 602368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602415 */     // MIs[3] src0
     /* 602415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602420 */     // MIs[3] src1
     /* 602420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602427 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602459 */     GIR_RootConstrainSelectedInstOperands,
     /* 602460 */     // GIR_Coverage, 13408,
     /* 602460 */     GIR_EraseRootFromParent_Done,
     /* 602461 */   // Label 7576: @602461
     /* 602461 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(602559), // Rule ID 13409 //
     /* 602466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602513 */     // MIs[3] src1
     /* 602513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602518 */     // MIs[3] src0
     /* 602518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602525 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602557 */     GIR_RootConstrainSelectedInstOperands,
     /* 602558 */     // GIR_Coverage, 13409,
     /* 602558 */     GIR_EraseRootFromParent_Done,
     /* 602559 */   // Label 7577: @602559
     /* 602559 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(602657), // Rule ID 13410 //
     /* 602564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602611 */     // MIs[3] src0
     /* 602611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602616 */     // MIs[3] src1
     /* 602616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602623 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602655 */     GIR_RootConstrainSelectedInstOperands,
     /* 602656 */     // GIR_Coverage, 13410,
     /* 602656 */     GIR_EraseRootFromParent_Done,
     /* 602657 */   // Label 7578: @602657
     /* 602657 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(602755), // Rule ID 13411 //
     /* 602662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602709 */     // MIs[3] src1
     /* 602709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602714 */     // MIs[3] src0
     /* 602714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602721 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602753 */     GIR_RootConstrainSelectedInstOperands,
     /* 602754 */     // GIR_Coverage, 13411,
     /* 602754 */     GIR_EraseRootFromParent_Done,
     /* 602755 */   // Label 7579: @602755
     /* 602755 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(602853), // Rule ID 7617 //
     /* 602760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 602763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602807 */     // MIs[3] src0
     /* 602807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602812 */     // MIs[3] src1
     /* 602812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602819 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 602822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602851 */     GIR_RootConstrainSelectedInstOperands,
     /* 602852 */     // GIR_Coverage, 7617,
     /* 602852 */     GIR_EraseRootFromParent_Done,
     /* 602853 */   // Label 7580: @602853
     /* 602853 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(602951), // Rule ID 7769 //
     /* 602858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 602861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602905 */     // MIs[3] src0
     /* 602905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602910 */     // MIs[3] src1
     /* 602910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602917 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602949 */     GIR_RootConstrainSelectedInstOperands,
     /* 602950 */     // GIR_Coverage, 7769,
     /* 602950 */     GIR_EraseRootFromParent_Done,
     /* 602951 */   // Label 7581: @602951
     /* 602951 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(603049), // Rule ID 7773 //
     /* 602956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603003 */     // MIs[3] src0
     /* 603003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603008 */     // MIs[3] src1
     /* 603008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603015 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603047 */     GIR_RootConstrainSelectedInstOperands,
     /* 603048 */     // GIR_Coverage, 7773,
     /* 603048 */     GIR_EraseRootFromParent_Done,
     /* 603049 */   // Label 7582: @603049
     /* 603049 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(603147), // Rule ID 11785 //
     /* 603054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603101 */     // MIs[3] src1
     /* 603101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603106 */     // MIs[3] src0
     /* 603106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603113 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603145 */     GIR_RootConstrainSelectedInstOperands,
     /* 603146 */     // GIR_Coverage, 11785,
     /* 603146 */     GIR_EraseRootFromParent_Done,
     /* 603147 */   // Label 7583: @603147
     /* 603147 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(603245), // Rule ID 11788 //
     /* 603152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603199 */     // MIs[3] src0
     /* 603199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603204 */     // MIs[3] src1
     /* 603204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603211 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603243 */     GIR_RootConstrainSelectedInstOperands,
     /* 603244 */     // GIR_Coverage, 11788,
     /* 603244 */     GIR_EraseRootFromParent_Done,
     /* 603245 */   // Label 7584: @603245
     /* 603245 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(603343), // Rule ID 11789 //
     /* 603250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603297 */     // MIs[3] src1
     /* 603297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603302 */     // MIs[3] src0
     /* 603302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603309 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603341 */     GIR_RootConstrainSelectedInstOperands,
     /* 603342 */     // GIR_Coverage, 11789,
     /* 603342 */     GIR_EraseRootFromParent_Done,
     /* 603343 */   // Label 7585: @603343
     /* 603343 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(603441), // Rule ID 13337 //
     /* 603348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603395 */     // MIs[3] src1
     /* 603395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603400 */     // MIs[3] src0
     /* 603400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603407 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603439 */     GIR_RootConstrainSelectedInstOperands,
     /* 603440 */     // GIR_Coverage, 13337,
     /* 603440 */     GIR_EraseRootFromParent_Done,
     /* 603441 */   // Label 7586: @603441
     /* 603441 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(603539), // Rule ID 13340 //
     /* 603446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603493 */     // MIs[3] src0
     /* 603493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603498 */     // MIs[3] src1
     /* 603498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603505 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603537 */     GIR_RootConstrainSelectedInstOperands,
     /* 603538 */     // GIR_Coverage, 13340,
     /* 603538 */     GIR_EraseRootFromParent_Done,
     /* 603539 */   // Label 7587: @603539
     /* 603539 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(603637), // Rule ID 13341 //
     /* 603544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603591 */     // MIs[3] src1
     /* 603591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603596 */     // MIs[3] src0
     /* 603596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603603 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603635 */     GIR_RootConstrainSelectedInstOperands,
     /* 603636 */     // GIR_Coverage, 13341,
     /* 603636 */     GIR_EraseRootFromParent_Done,
     /* 603637 */   // Label 7588: @603637
     /* 603637 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(603735), // Rule ID 13397 //
     /* 603642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603689 */     // MIs[3] src1
     /* 603689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603694 */     // MIs[3] src0
     /* 603694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603701 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603733 */     GIR_RootConstrainSelectedInstOperands,
     /* 603734 */     // GIR_Coverage, 13397,
     /* 603734 */     GIR_EraseRootFromParent_Done,
     /* 603735 */   // Label 7589: @603735
     /* 603735 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(603833), // Rule ID 13400 //
     /* 603740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603787 */     // MIs[3] src0
     /* 603787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603792 */     // MIs[3] src1
     /* 603792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603799 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603831 */     GIR_RootConstrainSelectedInstOperands,
     /* 603832 */     // GIR_Coverage, 13400,
     /* 603832 */     GIR_EraseRootFromParent_Done,
     /* 603833 */   // Label 7590: @603833
     /* 603833 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(603931), // Rule ID 13401 //
     /* 603838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603885 */     // MIs[3] src1
     /* 603885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603890 */     // MIs[3] src0
     /* 603890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603897 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603929 */     GIR_RootConstrainSelectedInstOperands,
     /* 603930 */     // GIR_Coverage, 13401,
     /* 603930 */     GIR_EraseRootFromParent_Done,
     /* 603931 */   // Label 7591: @603931
     /* 603931 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(604029), // Rule ID 11786 //
     /* 603936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 603979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603983 */     // MIs[3] src0
     /* 603983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603988 */     // MIs[3] src1
     /* 603988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603995 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604027 */     GIR_RootConstrainSelectedInstOperands,
     /* 604028 */     // GIR_Coverage, 11786,
     /* 604028 */     GIR_EraseRootFromParent_Done,
     /* 604029 */   // Label 7592: @604029
     /* 604029 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(604127), // Rule ID 11787 //
     /* 604034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604081 */     // MIs[3] src1
     /* 604081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604086 */     // MIs[3] src0
     /* 604086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604093 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604125 */     GIR_RootConstrainSelectedInstOperands,
     /* 604126 */     // GIR_Coverage, 11787,
     /* 604126 */     GIR_EraseRootFromParent_Done,
     /* 604127 */   // Label 7593: @604127
     /* 604127 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(604225), // Rule ID 11790 //
     /* 604132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604179 */     // MIs[3] src0
     /* 604179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604184 */     // MIs[3] src1
     /* 604184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604191 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604223 */     GIR_RootConstrainSelectedInstOperands,
     /* 604224 */     // GIR_Coverage, 11790,
     /* 604224 */     GIR_EraseRootFromParent_Done,
     /* 604225 */   // Label 7594: @604225
     /* 604225 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(604323), // Rule ID 11791 //
     /* 604230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604277 */     // MIs[3] src1
     /* 604277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604282 */     // MIs[3] src0
     /* 604282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604289 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604321 */     GIR_RootConstrainSelectedInstOperands,
     /* 604322 */     // GIR_Coverage, 11791,
     /* 604322 */     GIR_EraseRootFromParent_Done,
     /* 604323 */   // Label 7595: @604323
     /* 604323 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(604421), // Rule ID 13338 //
     /* 604328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604375 */     // MIs[3] src0
     /* 604375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604380 */     // MIs[3] src1
     /* 604380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604387 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604419 */     GIR_RootConstrainSelectedInstOperands,
     /* 604420 */     // GIR_Coverage, 13338,
     /* 604420 */     GIR_EraseRootFromParent_Done,
     /* 604421 */   // Label 7596: @604421
     /* 604421 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(604519), // Rule ID 13339 //
     /* 604426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604473 */     // MIs[3] src1
     /* 604473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604478 */     // MIs[3] src0
     /* 604478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604485 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604517 */     GIR_RootConstrainSelectedInstOperands,
     /* 604518 */     // GIR_Coverage, 13339,
     /* 604518 */     GIR_EraseRootFromParent_Done,
     /* 604519 */   // Label 7597: @604519
     /* 604519 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(604617), // Rule ID 13342 //
     /* 604524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604571 */     // MIs[3] src0
     /* 604571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604576 */     // MIs[3] src1
     /* 604576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604583 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604615 */     GIR_RootConstrainSelectedInstOperands,
     /* 604616 */     // GIR_Coverage, 13342,
     /* 604616 */     GIR_EraseRootFromParent_Done,
     /* 604617 */   // Label 7598: @604617
     /* 604617 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(604715), // Rule ID 13343 //
     /* 604622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604669 */     // MIs[3] src1
     /* 604669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604674 */     // MIs[3] src0
     /* 604674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604681 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604713 */     GIR_RootConstrainSelectedInstOperands,
     /* 604714 */     // GIR_Coverage, 13343,
     /* 604714 */     GIR_EraseRootFromParent_Done,
     /* 604715 */   // Label 7599: @604715
     /* 604715 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(604813), // Rule ID 13398 //
     /* 604720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604767 */     // MIs[3] src0
     /* 604767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604772 */     // MIs[3] src1
     /* 604772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604779 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604811 */     GIR_RootConstrainSelectedInstOperands,
     /* 604812 */     // GIR_Coverage, 13398,
     /* 604812 */     GIR_EraseRootFromParent_Done,
     /* 604813 */   // Label 7600: @604813
     /* 604813 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(604911), // Rule ID 13399 //
     /* 604818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604865 */     // MIs[3] src1
     /* 604865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604870 */     // MIs[3] src0
     /* 604870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604877 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604909 */     GIR_RootConstrainSelectedInstOperands,
     /* 604910 */     // GIR_Coverage, 13399,
     /* 604910 */     GIR_EraseRootFromParent_Done,
     /* 604911 */   // Label 7601: @604911
     /* 604911 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(605009), // Rule ID 13402 //
     /* 604916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604963 */     // MIs[3] src0
     /* 604963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604968 */     // MIs[3] src1
     /* 604968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604975 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 605001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605007 */     GIR_RootConstrainSelectedInstOperands,
     /* 605008 */     // GIR_Coverage, 13402,
     /* 605008 */     GIR_EraseRootFromParent_Done,
     /* 605009 */   // Label 7602: @605009
     /* 605009 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(605107), // Rule ID 13403 //
     /* 605014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 605017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 605057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605061 */     // MIs[3] src1
     /* 605061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605066 */     // MIs[3] src0
     /* 605066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605073 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 605076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 605085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 605092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 605099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605105 */     GIR_RootConstrainSelectedInstOperands,
     /* 605106 */     // GIR_Coverage, 13403,
     /* 605106 */     GIR_EraseRootFromParent_Done,
     /* 605107 */   // Label 7603: @605107
     /* 605107 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(605163), // Rule ID 901 //
     /* 605112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 605115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 605119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 605126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 605133 */     // (smin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 605133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_t16_e64),
     /* 605136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 605143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 605148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 605153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 605158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605161 */     GIR_RootConstrainSelectedInstOperands,
     /* 605162 */     // GIR_Coverage, 901,
     /* 605162 */     GIR_EraseRootFromParent_Done,
     /* 605163 */   // Label 7604: @605163
     /* 605163 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(605186), // Rule ID 900 //
     /* 605168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 605171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605175 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 605175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 605180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 605184 */     GIR_RootConstrainSelectedInstOperands,
     /* 605185 */     // GIR_Coverage, 900,
     /* 605185 */     GIR_Done,
     /* 605186 */   // Label 7605: @605186
     /* 605186 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(605209), // Rule ID 902 //
     /* 605191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 605194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605198 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 605198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_fake16_e64),
     /* 605203 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 605207 */     GIR_RootConstrainSelectedInstOperands,
     /* 605208 */     // GIR_Coverage, 902,
     /* 605208 */     GIR_Done,
     /* 605209 */   // Label 7606: @605209
     /* 605209 */   GIM_Reject,
     /* 605210 */ // Label 7555: @605210
     /* 605210 */ GIM_Reject,
     /* 605211 */ // Label 7552: @605211
     /* 605211 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(606655),
     /* 605216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 605219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 605222 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(605302), // Rule ID 11237 //
     /* 605227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605271 */     // MIs[3] src0
     /* 605271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605276 */     // MIs[3] src1
     /* 605276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605283 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605300 */     GIR_RootConstrainSelectedInstOperands,
     /* 605301 */     // GIR_Coverage, 11237,
     /* 605301 */     GIR_EraseRootFromParent_Done,
     /* 605302 */   // Label 7608: @605302
     /* 605302 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(605382), // Rule ID 11238 //
     /* 605307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605351 */     // MIs[3] src1
     /* 605351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605356 */     // MIs[3] src0
     /* 605356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605363 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605380 */     GIR_RootConstrainSelectedInstOperands,
     /* 605381 */     // GIR_Coverage, 11238,
     /* 605381 */     GIR_EraseRootFromParent_Done,
     /* 605382 */   // Label 7609: @605382
     /* 605382 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(605462), // Rule ID 11239 //
     /* 605387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605431 */     // MIs[3] src0
     /* 605431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605436 */     // MIs[3] src1
     /* 605436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605443 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605460 */     GIR_RootConstrainSelectedInstOperands,
     /* 605461 */     // GIR_Coverage, 11239,
     /* 605461 */     GIR_EraseRootFromParent_Done,
     /* 605462 */   // Label 7610: @605462
     /* 605462 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(605542), // Rule ID 11240 //
     /* 605467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605511 */     // MIs[3] src1
     /* 605511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605516 */     // MIs[3] src0
     /* 605516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605523 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605540 */     GIR_RootConstrainSelectedInstOperands,
     /* 605541 */     // GIR_Coverage, 11240,
     /* 605541 */     GIR_EraseRootFromParent_Done,
     /* 605542 */   // Label 7611: @605542
     /* 605542 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(605622), // Rule ID 11241 //
     /* 605547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605591 */     // MIs[3] src0
     /* 605591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605596 */     // MIs[3] src1
     /* 605596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605603 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605620 */     GIR_RootConstrainSelectedInstOperands,
     /* 605621 */     // GIR_Coverage, 11241,
     /* 605621 */     GIR_EraseRootFromParent_Done,
     /* 605622 */   // Label 7612: @605622
     /* 605622 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(605702), // Rule ID 11242 //
     /* 605627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605671 */     // MIs[3] src1
     /* 605671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605676 */     // MIs[3] src0
     /* 605676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605683 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605700 */     GIR_RootConstrainSelectedInstOperands,
     /* 605701 */     // GIR_Coverage, 11242,
     /* 605701 */     GIR_EraseRootFromParent_Done,
     /* 605702 */   // Label 7613: @605702
     /* 605702 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(605782), // Rule ID 11243 //
     /* 605707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605751 */     // MIs[3] src0
     /* 605751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605756 */     // MIs[3] src1
     /* 605756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605763 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605780 */     GIR_RootConstrainSelectedInstOperands,
     /* 605781 */     // GIR_Coverage, 11243,
     /* 605781 */     GIR_EraseRootFromParent_Done,
     /* 605782 */   // Label 7614: @605782
     /* 605782 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(605862), // Rule ID 11244 //
     /* 605787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605831 */     // MIs[3] src1
     /* 605831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605836 */     // MIs[3] src0
     /* 605836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605843 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605860 */     GIR_RootConstrainSelectedInstOperands,
     /* 605861 */     // GIR_Coverage, 11244,
     /* 605861 */     GIR_EraseRootFromParent_Done,
     /* 605862 */   // Label 7615: @605862
     /* 605862 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(605942), // Rule ID 7580 //
     /* 605867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605911 */     // MIs[3] src0
     /* 605911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605916 */     // MIs[3] src1
     /* 605916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605923 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 605932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 605936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 605940 */     GIR_RootConstrainSelectedInstOperands,
     /* 605941 */     // GIR_Coverage, 7580,
     /* 605941 */     GIR_EraseRootFromParent_Done,
     /* 605942 */   // Label 7616: @605942
     /* 605942 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(606022), // Rule ID 11230 //
     /* 605947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605991 */     // MIs[3] src1
     /* 605991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605996 */     // MIs[3] src0
     /* 605996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606003 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 606020 */     GIR_RootConstrainSelectedInstOperands,
     /* 606021 */     // GIR_Coverage, 11230,
     /* 606021 */     GIR_EraseRootFromParent_Done,
     /* 606022 */   // Label 7617: @606022
     /* 606022 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(606102), // Rule ID 11233 //
     /* 606027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 606067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606071 */     // MIs[3] src0
     /* 606071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606076 */     // MIs[3] src1
     /* 606076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606083 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 606100 */     GIR_RootConstrainSelectedInstOperands,
     /* 606101 */     // GIR_Coverage, 11233,
     /* 606101 */     GIR_EraseRootFromParent_Done,
     /* 606102 */   // Label 7618: @606102
     /* 606102 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(606182), // Rule ID 11234 //
     /* 606107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 606147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606151 */     // MIs[3] src1
     /* 606151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606156 */     // MIs[3] src0
     /* 606156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606163 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 606180 */     GIR_RootConstrainSelectedInstOperands,
     /* 606181 */     // GIR_Coverage, 11234,
     /* 606181 */     GIR_EraseRootFromParent_Done,
     /* 606182 */   // Label 7619: @606182
     /* 606182 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(606262), // Rule ID 11231 //
     /* 606187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606231 */     // MIs[3] src0
     /* 606231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606236 */     // MIs[3] src1
     /* 606236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606243 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606260 */     GIR_RootConstrainSelectedInstOperands,
     /* 606261 */     // GIR_Coverage, 11231,
     /* 606261 */     GIR_EraseRootFromParent_Done,
     /* 606262 */   // Label 7620: @606262
     /* 606262 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(606342), // Rule ID 11232 //
     /* 606267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606311 */     // MIs[3] src1
     /* 606311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606316 */     // MIs[3] src0
     /* 606316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606323 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606340 */     GIR_RootConstrainSelectedInstOperands,
     /* 606341 */     // GIR_Coverage, 11232,
     /* 606341 */     GIR_EraseRootFromParent_Done,
     /* 606342 */   // Label 7621: @606342
     /* 606342 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(606422), // Rule ID 11235 //
     /* 606347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606391 */     // MIs[3] src0
     /* 606391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606396 */     // MIs[3] src1
     /* 606396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606403 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606420 */     GIR_RootConstrainSelectedInstOperands,
     /* 606421 */     // GIR_Coverage, 11235,
     /* 606421 */     GIR_EraseRootFromParent_Done,
     /* 606422 */   // Label 7622: @606422
     /* 606422 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(606502), // Rule ID 11236 //
     /* 606427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606471 */     // MIs[3] src1
     /* 606471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606476 */     // MIs[3] src0
     /* 606476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606483 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606500 */     GIR_RootConstrainSelectedInstOperands,
     /* 606501 */     // GIR_Coverage, 11236,
     /* 606501 */     GIR_EraseRootFromParent_Done,
     /* 606502 */   // Label 7623: @606502
     /* 606502 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(606555), // Rule ID 7714 //
     /* 606507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 606510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606530 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 606532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34983),
     /* 606536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 606538 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34983>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 606541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 606553 */     GIR_RootConstrainSelectedInstOperands,
     /* 606554 */     // GIR_Coverage, 7714,
     /* 606554 */     GIR_EraseRootFromParent_Done,
     /* 606555 */   // Label 7624: @606555
     /* 606555 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(606608), // Rule ID 13240 //
     /* 606560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 606563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 606571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606583 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 606585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34983),
     /* 606589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 606591 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>)<<P:Predicate_anonymous_34983>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 606594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 606606 */     GIR_RootConstrainSelectedInstOperands,
     /* 606607 */     // GIR_Coverage, 13240,
     /* 606607 */     GIR_EraseRootFromParent_Done,
     /* 606608 */   // Label 7625: @606608
     /* 606608 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(606634), // Rule ID 47 //
     /* 606613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 606617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13747),
     /* 606621 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13747>>  =>  (S_MIN_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 606621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_I32),
     /* 606626 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 606632 */     GIR_RootConstrainSelectedInstOperands,
     /* 606633 */     // GIR_Coverage, 47,
     /* 606633 */     GIR_Done,
     /* 606634 */   // Label 7626: @606634
     /* 606634 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(606654), // Rule ID 804 //
     /* 606639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606643 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 606643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I32_e64),
     /* 606648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 606652 */     GIR_RootConstrainSelectedInstOperands,
     /* 606653 */     // GIR_Coverage, 804,
     /* 606653 */     GIR_Done,
     /* 606654 */   // Label 7627: @606654
     /* 606654 */   GIM_Reject,
     /* 606655 */ // Label 7607: @606655
     /* 606655 */ GIM_Reject,
     /* 606656 */ // Label 7553: @606656
     /* 606656 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(606727), // Rule ID 1100 //
     /* 606661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 606664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 606667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 606678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 606685 */   // (smin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 606685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_I16),
     /* 606688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 606695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 606700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 606705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 606710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606725 */   GIR_RootConstrainSelectedInstOperands,
     /* 606726 */   // GIR_Coverage, 1100,
     /* 606726 */   GIR_EraseRootFromParent_Done,
     /* 606727 */ // Label 7628: @606727
     /* 606727 */ GIM_Reject,
     /* 606728 */ // Label 7554: @606728
     /* 606728 */ GIM_Reject,
     /* 606729 */ // Label 89: @606729
     /* 606729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7632*/ GIMT_Encode4(613254),
     /* 606740 */ /*GILLT_s16*//*Label 7629*/ GIMT_Encode4(606756),
     /* 606744 */ /*GILLT_s32*//*Label 7630*/ GIMT_Encode4(611575), GIMT_Encode4(0),
     /* 606752 */ /*GILLT_v2s16*//*Label 7631*/ GIMT_Encode4(613182),
     /* 606756 */ // Label 7629: @606756
     /* 606756 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(611574),
     /* 606761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 606764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 606767 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(606865), // Rule ID 11777 //
     /* 606772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606819 */     // MIs[3] src0
     /* 606819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606824 */     // MIs[3] src1
     /* 606824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606831 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606863 */     GIR_RootConstrainSelectedInstOperands,
     /* 606864 */     // GIR_Coverage, 11777,
     /* 606864 */     GIR_EraseRootFromParent_Done,
     /* 606865 */   // Label 7634: @606865
     /* 606865 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(606963), // Rule ID 11778 //
     /* 606870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606917 */     // MIs[3] src1
     /* 606917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606922 */     // MIs[3] src0
     /* 606922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606929 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606961 */     GIR_RootConstrainSelectedInstOperands,
     /* 606962 */     // GIR_Coverage, 11778,
     /* 606962 */     GIR_EraseRootFromParent_Done,
     /* 606963 */   // Label 7635: @606963
     /* 606963 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(607061), // Rule ID 11779 //
     /* 606968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607015 */     // MIs[3] src0
     /* 607015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607020 */     // MIs[3] src1
     /* 607020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607027 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607059 */     GIR_RootConstrainSelectedInstOperands,
     /* 607060 */     // GIR_Coverage, 11779,
     /* 607060 */     GIR_EraseRootFromParent_Done,
     /* 607061 */   // Label 7636: @607061
     /* 607061 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(607159), // Rule ID 11780 //
     /* 607066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607113 */     // MIs[3] src1
     /* 607113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607118 */     // MIs[3] src0
     /* 607118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607125 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607157 */     GIR_RootConstrainSelectedInstOperands,
     /* 607158 */     // GIR_Coverage, 11780,
     /* 607158 */     GIR_EraseRootFromParent_Done,
     /* 607159 */   // Label 7637: @607159
     /* 607159 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(607257), // Rule ID 13329 //
     /* 607164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607211 */     // MIs[3] src0
     /* 607211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607216 */     // MIs[3] src1
     /* 607216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607223 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607255 */     GIR_RootConstrainSelectedInstOperands,
     /* 607256 */     // GIR_Coverage, 13329,
     /* 607256 */     GIR_EraseRootFromParent_Done,
     /* 607257 */   // Label 7638: @607257
     /* 607257 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(607355), // Rule ID 13330 //
     /* 607262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607309 */     // MIs[3] src1
     /* 607309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607314 */     // MIs[3] src0
     /* 607314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607321 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607353 */     GIR_RootConstrainSelectedInstOperands,
     /* 607354 */     // GIR_Coverage, 13330,
     /* 607354 */     GIR_EraseRootFromParent_Done,
     /* 607355 */   // Label 7639: @607355
     /* 607355 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(607453), // Rule ID 13331 //
     /* 607360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607407 */     // MIs[3] src0
     /* 607407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607412 */     // MIs[3] src1
     /* 607412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607419 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607451 */     GIR_RootConstrainSelectedInstOperands,
     /* 607452 */     // GIR_Coverage, 13331,
     /* 607452 */     GIR_EraseRootFromParent_Done,
     /* 607453 */   // Label 7640: @607453
     /* 607453 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(607551), // Rule ID 13332 //
     /* 607458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607505 */     // MIs[3] src1
     /* 607505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607510 */     // MIs[3] src0
     /* 607510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607517 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607549 */     GIR_RootConstrainSelectedInstOperands,
     /* 607550 */     // GIR_Coverage, 13332,
     /* 607550 */     GIR_EraseRootFromParent_Done,
     /* 607551 */   // Label 7641: @607551
     /* 607551 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(607649), // Rule ID 13389 //
     /* 607556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607603 */     // MIs[3] src0
     /* 607603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607608 */     // MIs[3] src1
     /* 607608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607615 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607647 */     GIR_RootConstrainSelectedInstOperands,
     /* 607648 */     // GIR_Coverage, 13389,
     /* 607648 */     GIR_EraseRootFromParent_Done,
     /* 607649 */   // Label 7642: @607649
     /* 607649 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(607747), // Rule ID 13390 //
     /* 607654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607701 */     // MIs[3] src1
     /* 607701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607706 */     // MIs[3] src0
     /* 607706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607713 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607745 */     GIR_RootConstrainSelectedInstOperands,
     /* 607746 */     // GIR_Coverage, 13390,
     /* 607746 */     GIR_EraseRootFromParent_Done,
     /* 607747 */   // Label 7643: @607747
     /* 607747 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(607845), // Rule ID 13391 //
     /* 607752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607799 */     // MIs[3] src0
     /* 607799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607804 */     // MIs[3] src1
     /* 607804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607811 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607843 */     GIR_RootConstrainSelectedInstOperands,
     /* 607844 */     // GIR_Coverage, 13391,
     /* 607844 */     GIR_EraseRootFromParent_Done,
     /* 607845 */   // Label 7644: @607845
     /* 607845 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(607943), // Rule ID 13392 //
     /* 607850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607897 */     // MIs[3] src1
     /* 607897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607902 */     // MIs[3] src0
     /* 607902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607909 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607941 */     GIR_RootConstrainSelectedInstOperands,
     /* 607942 */     // GIR_Coverage, 13392,
     /* 607942 */     GIR_EraseRootFromParent_Done,
     /* 607943 */   // Label 7645: @607943
     /* 607943 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(608041), // Rule ID 11781 //
     /* 607948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 607975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607995 */     // MIs[3] src0
     /* 607995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608000 */     // MIs[3] src1
     /* 608000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608007 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608039 */     GIR_RootConstrainSelectedInstOperands,
     /* 608040 */     // GIR_Coverage, 11781,
     /* 608040 */     GIR_EraseRootFromParent_Done,
     /* 608041 */   // Label 7646: @608041
     /* 608041 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(608139), // Rule ID 11782 //
     /* 608046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608093 */     // MIs[3] src1
     /* 608093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608098 */     // MIs[3] src0
     /* 608098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608105 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608137 */     GIR_RootConstrainSelectedInstOperands,
     /* 608138 */     // GIR_Coverage, 11782,
     /* 608138 */     GIR_EraseRootFromParent_Done,
     /* 608139 */   // Label 7647: @608139
     /* 608139 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(608237), // Rule ID 11783 //
     /* 608144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608191 */     // MIs[3] src0
     /* 608191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608196 */     // MIs[3] src1
     /* 608196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608203 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608235 */     GIR_RootConstrainSelectedInstOperands,
     /* 608236 */     // GIR_Coverage, 11783,
     /* 608236 */     GIR_EraseRootFromParent_Done,
     /* 608237 */   // Label 7648: @608237
     /* 608237 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(608335), // Rule ID 11784 //
     /* 608242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608289 */     // MIs[3] src1
     /* 608289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608294 */     // MIs[3] src0
     /* 608294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608301 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608333 */     GIR_RootConstrainSelectedInstOperands,
     /* 608334 */     // GIR_Coverage, 11784,
     /* 608334 */     GIR_EraseRootFromParent_Done,
     /* 608335 */   // Label 7649: @608335
     /* 608335 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(608433), // Rule ID 13333 //
     /* 608340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608387 */     // MIs[3] src0
     /* 608387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608392 */     // MIs[3] src1
     /* 608392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608399 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608431 */     GIR_RootConstrainSelectedInstOperands,
     /* 608432 */     // GIR_Coverage, 13333,
     /* 608432 */     GIR_EraseRootFromParent_Done,
     /* 608433 */   // Label 7650: @608433
     /* 608433 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(608531), // Rule ID 13334 //
     /* 608438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608485 */     // MIs[3] src1
     /* 608485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608490 */     // MIs[3] src0
     /* 608490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608497 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608529 */     GIR_RootConstrainSelectedInstOperands,
     /* 608530 */     // GIR_Coverage, 13334,
     /* 608530 */     GIR_EraseRootFromParent_Done,
     /* 608531 */   // Label 7651: @608531
     /* 608531 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(608629), // Rule ID 13335 //
     /* 608536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608583 */     // MIs[3] src0
     /* 608583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608588 */     // MIs[3] src1
     /* 608588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608595 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608627 */     GIR_RootConstrainSelectedInstOperands,
     /* 608628 */     // GIR_Coverage, 13335,
     /* 608628 */     GIR_EraseRootFromParent_Done,
     /* 608629 */   // Label 7652: @608629
     /* 608629 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(608727), // Rule ID 13336 //
     /* 608634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608681 */     // MIs[3] src1
     /* 608681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608686 */     // MIs[3] src0
     /* 608686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608693 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608725 */     GIR_RootConstrainSelectedInstOperands,
     /* 608726 */     // GIR_Coverage, 13336,
     /* 608726 */     GIR_EraseRootFromParent_Done,
     /* 608727 */   // Label 7653: @608727
     /* 608727 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(608825), // Rule ID 13393 //
     /* 608732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608779 */     // MIs[3] src0
     /* 608779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608784 */     // MIs[3] src1
     /* 608784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608791 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608823 */     GIR_RootConstrainSelectedInstOperands,
     /* 608824 */     // GIR_Coverage, 13393,
     /* 608824 */     GIR_EraseRootFromParent_Done,
     /* 608825 */   // Label 7654: @608825
     /* 608825 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(608923), // Rule ID 13394 //
     /* 608830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608877 */     // MIs[3] src1
     /* 608877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608882 */     // MIs[3] src0
     /* 608882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608889 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608921 */     GIR_RootConstrainSelectedInstOperands,
     /* 608922 */     // GIR_Coverage, 13394,
     /* 608922 */     GIR_EraseRootFromParent_Done,
     /* 608923 */   // Label 7655: @608923
     /* 608923 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(609021), // Rule ID 13395 //
     /* 608928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608975 */     // MIs[3] src0
     /* 608975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608980 */     // MIs[3] src1
     /* 608980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608987 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609019 */     GIR_RootConstrainSelectedInstOperands,
     /* 609020 */     // GIR_Coverage, 13395,
     /* 609020 */     GIR_EraseRootFromParent_Done,
     /* 609021 */   // Label 7656: @609021
     /* 609021 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(609119), // Rule ID 13396 //
     /* 609026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 609053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609073 */     // MIs[3] src1
     /* 609073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609078 */     // MIs[3] src0
     /* 609078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609085 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 609097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609117 */     GIR_RootConstrainSelectedInstOperands,
     /* 609118 */     // GIR_Coverage, 13396,
     /* 609118 */     GIR_EraseRootFromParent_Done,
     /* 609119 */   // Label 7657: @609119
     /* 609119 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(609217), // Rule ID 7616 //
     /* 609124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609171 */     // MIs[3] src0
     /* 609171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609176 */     // MIs[3] src1
     /* 609176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609183 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609215 */     GIR_RootConstrainSelectedInstOperands,
     /* 609216 */     // GIR_Coverage, 7616,
     /* 609216 */     GIR_EraseRootFromParent_Done,
     /* 609217 */   // Label 7658: @609217
     /* 609217 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(609315), // Rule ID 7768 //
     /* 609222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609269 */     // MIs[3] src0
     /* 609269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609274 */     // MIs[3] src1
     /* 609274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609281 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609313 */     GIR_RootConstrainSelectedInstOperands,
     /* 609314 */     // GIR_Coverage, 7768,
     /* 609314 */     GIR_EraseRootFromParent_Done,
     /* 609315 */   // Label 7659: @609315
     /* 609315 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(609413), // Rule ID 7772 //
     /* 609320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609367 */     // MIs[3] src0
     /* 609367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609372 */     // MIs[3] src1
     /* 609372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609379 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609411 */     GIR_RootConstrainSelectedInstOperands,
     /* 609412 */     // GIR_Coverage, 7772,
     /* 609412 */     GIR_EraseRootFromParent_Done,
     /* 609413 */   // Label 7660: @609413
     /* 609413 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(609511), // Rule ID 11770 //
     /* 609418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609465 */     // MIs[3] src1
     /* 609465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609470 */     // MIs[3] src0
     /* 609470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609477 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609509 */     GIR_RootConstrainSelectedInstOperands,
     /* 609510 */     // GIR_Coverage, 11770,
     /* 609510 */     GIR_EraseRootFromParent_Done,
     /* 609511 */   // Label 7661: @609511
     /* 609511 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(609609), // Rule ID 11773 //
     /* 609516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609563 */     // MIs[3] src0
     /* 609563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609568 */     // MIs[3] src1
     /* 609568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609575 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609607 */     GIR_RootConstrainSelectedInstOperands,
     /* 609608 */     // GIR_Coverage, 11773,
     /* 609608 */     GIR_EraseRootFromParent_Done,
     /* 609609 */   // Label 7662: @609609
     /* 609609 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(609707), // Rule ID 11774 //
     /* 609614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609661 */     // MIs[3] src1
     /* 609661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609666 */     // MIs[3] src0
     /* 609666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609673 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609705 */     GIR_RootConstrainSelectedInstOperands,
     /* 609706 */     // GIR_Coverage, 11774,
     /* 609706 */     GIR_EraseRootFromParent_Done,
     /* 609707 */   // Label 7663: @609707
     /* 609707 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(609805), // Rule ID 13322 //
     /* 609712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609759 */     // MIs[3] src1
     /* 609759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609764 */     // MIs[3] src0
     /* 609764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609771 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609803 */     GIR_RootConstrainSelectedInstOperands,
     /* 609804 */     // GIR_Coverage, 13322,
     /* 609804 */     GIR_EraseRootFromParent_Done,
     /* 609805 */   // Label 7664: @609805
     /* 609805 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(609903), // Rule ID 13325 //
     /* 609810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609857 */     // MIs[3] src0
     /* 609857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609862 */     // MIs[3] src1
     /* 609862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609869 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609901 */     GIR_RootConstrainSelectedInstOperands,
     /* 609902 */     // GIR_Coverage, 13325,
     /* 609902 */     GIR_EraseRootFromParent_Done,
     /* 609903 */   // Label 7665: @609903
     /* 609903 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(610001), // Rule ID 13326 //
     /* 609908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609955 */     // MIs[3] src1
     /* 609955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609960 */     // MIs[3] src0
     /* 609960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609967 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609999 */     GIR_RootConstrainSelectedInstOperands,
     /* 610000 */     // GIR_Coverage, 13326,
     /* 610000 */     GIR_EraseRootFromParent_Done,
     /* 610001 */   // Label 7666: @610001
     /* 610001 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(610099), // Rule ID 13382 //
     /* 610006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610053 */     // MIs[3] src1
     /* 610053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610058 */     // MIs[3] src0
     /* 610058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610065 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 610068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610097 */     GIR_RootConstrainSelectedInstOperands,
     /* 610098 */     // GIR_Coverage, 13382,
     /* 610098 */     GIR_EraseRootFromParent_Done,
     /* 610099 */   // Label 7667: @610099
     /* 610099 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(610197), // Rule ID 13385 //
     /* 610104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610151 */     // MIs[3] src0
     /* 610151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610156 */     // MIs[3] src1
     /* 610156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610163 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 610166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610195 */     GIR_RootConstrainSelectedInstOperands,
     /* 610196 */     // GIR_Coverage, 13385,
     /* 610196 */     GIR_EraseRootFromParent_Done,
     /* 610197 */   // Label 7668: @610197
     /* 610197 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(610295), // Rule ID 13386 //
     /* 610202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610249 */     // MIs[3] src1
     /* 610249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610254 */     // MIs[3] src0
     /* 610254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610261 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 610264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610293 */     GIR_RootConstrainSelectedInstOperands,
     /* 610294 */     // GIR_Coverage, 13386,
     /* 610294 */     GIR_EraseRootFromParent_Done,
     /* 610295 */   // Label 7669: @610295
     /* 610295 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(610393), // Rule ID 11771 //
     /* 610300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610347 */     // MIs[3] src0
     /* 610347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610352 */     // MIs[3] src1
     /* 610352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610359 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610391 */     GIR_RootConstrainSelectedInstOperands,
     /* 610392 */     // GIR_Coverage, 11771,
     /* 610392 */     GIR_EraseRootFromParent_Done,
     /* 610393 */   // Label 7670: @610393
     /* 610393 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(610491), // Rule ID 11772 //
     /* 610398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610445 */     // MIs[3] src1
     /* 610445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610450 */     // MIs[3] src0
     /* 610450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610457 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610489 */     GIR_RootConstrainSelectedInstOperands,
     /* 610490 */     // GIR_Coverage, 11772,
     /* 610490 */     GIR_EraseRootFromParent_Done,
     /* 610491 */   // Label 7671: @610491
     /* 610491 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(610589), // Rule ID 11775 //
     /* 610496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610543 */     // MIs[3] src0
     /* 610543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610548 */     // MIs[3] src1
     /* 610548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610555 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610587 */     GIR_RootConstrainSelectedInstOperands,
     /* 610588 */     // GIR_Coverage, 11775,
     /* 610588 */     GIR_EraseRootFromParent_Done,
     /* 610589 */   // Label 7672: @610589
     /* 610589 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(610687), // Rule ID 11776 //
     /* 610594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610641 */     // MIs[3] src1
     /* 610641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610646 */     // MIs[3] src0
     /* 610646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610653 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610685 */     GIR_RootConstrainSelectedInstOperands,
     /* 610686 */     // GIR_Coverage, 11776,
     /* 610686 */     GIR_EraseRootFromParent_Done,
     /* 610687 */   // Label 7673: @610687
     /* 610687 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(610785), // Rule ID 13323 //
     /* 610692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610739 */     // MIs[3] src0
     /* 610739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610744 */     // MIs[3] src1
     /* 610744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610751 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610783 */     GIR_RootConstrainSelectedInstOperands,
     /* 610784 */     // GIR_Coverage, 13323,
     /* 610784 */     GIR_EraseRootFromParent_Done,
     /* 610785 */   // Label 7674: @610785
     /* 610785 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(610883), // Rule ID 13324 //
     /* 610790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610837 */     // MIs[3] src1
     /* 610837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610842 */     // MIs[3] src0
     /* 610842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610849 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610881 */     GIR_RootConstrainSelectedInstOperands,
     /* 610882 */     // GIR_Coverage, 13324,
     /* 610882 */     GIR_EraseRootFromParent_Done,
     /* 610883 */   // Label 7675: @610883
     /* 610883 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(610981), // Rule ID 13327 //
     /* 610888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610935 */     // MIs[3] src0
     /* 610935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610940 */     // MIs[3] src1
     /* 610940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610947 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610979 */     GIR_RootConstrainSelectedInstOperands,
     /* 610980 */     // GIR_Coverage, 13327,
     /* 610980 */     GIR_EraseRootFromParent_Done,
     /* 610981 */   // Label 7676: @610981
     /* 610981 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(611079), // Rule ID 13328 //
     /* 610986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611033 */     // MIs[3] src1
     /* 611033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611038 */     // MIs[3] src0
     /* 611038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611045 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 611048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 611057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 611064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611077 */     GIR_RootConstrainSelectedInstOperands,
     /* 611078 */     // GIR_Coverage, 13328,
     /* 611078 */     GIR_EraseRootFromParent_Done,
     /* 611079 */   // Label 7677: @611079
     /* 611079 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(611177), // Rule ID 13383 //
     /* 611084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611131 */     // MIs[3] src0
     /* 611131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611136 */     // MIs[3] src1
     /* 611136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611143 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 611155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 611162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611175 */     GIR_RootConstrainSelectedInstOperands,
     /* 611176 */     // GIR_Coverage, 13383,
     /* 611176 */     GIR_EraseRootFromParent_Done,
     /* 611177 */   // Label 7678: @611177
     /* 611177 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(611275), // Rule ID 13384 //
     /* 611182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611229 */     // MIs[3] src1
     /* 611229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611234 */     // MIs[3] src0
     /* 611234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611241 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 611253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 611260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611273 */     GIR_RootConstrainSelectedInstOperands,
     /* 611274 */     // GIR_Coverage, 13384,
     /* 611274 */     GIR_EraseRootFromParent_Done,
     /* 611275 */   // Label 7679: @611275
     /* 611275 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(611373), // Rule ID 13387 //
     /* 611280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611327 */     // MIs[3] src0
     /* 611327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611332 */     // MIs[3] src1
     /* 611332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611339 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 611351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 611358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611371 */     GIR_RootConstrainSelectedInstOperands,
     /* 611372 */     // GIR_Coverage, 13387,
     /* 611372 */     GIR_EraseRootFromParent_Done,
     /* 611373 */   // Label 7680: @611373
     /* 611373 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(611471), // Rule ID 13388 //
     /* 611378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611425 */     // MIs[3] src1
     /* 611425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611430 */     // MIs[3] src0
     /* 611430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611437 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 611449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 611456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611469 */     GIR_RootConstrainSelectedInstOperands,
     /* 611470 */     // GIR_Coverage, 13388,
     /* 611470 */     GIR_EraseRootFromParent_Done,
     /* 611471 */   // Label 7681: @611471
     /* 611471 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(611527), // Rule ID 895 //
     /* 611476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 611479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 611490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 611497 */     // (smax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 611497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_t16_e64),
     /* 611500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 611507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 611512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 611517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 611522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611525 */     GIR_RootConstrainSelectedInstOperands,
     /* 611526 */     // GIR_Coverage, 895,
     /* 611526 */     GIR_EraseRootFromParent_Done,
     /* 611527 */   // Label 7682: @611527
     /* 611527 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(611550), // Rule ID 894 //
     /* 611532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 611535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611539 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 611539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 611544 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 611548 */     GIR_RootConstrainSelectedInstOperands,
     /* 611549 */     // GIR_Coverage, 894,
     /* 611549 */     GIR_Done,
     /* 611550 */   // Label 7683: @611550
     /* 611550 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(611573), // Rule ID 896 //
     /* 611555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 611558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611562 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 611562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_fake16_e64),
     /* 611567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 611571 */     GIR_RootConstrainSelectedInstOperands,
     /* 611572 */     // GIR_Coverage, 896,
     /* 611572 */     GIR_Done,
     /* 611573 */   // Label 7684: @611573
     /* 611573 */   GIM_Reject,
     /* 611574 */ // Label 7633: @611574
     /* 611574 */ GIM_Reject,
     /* 611575 */ // Label 7630: @611575
     /* 611575 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(613181),
     /* 611580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 611583 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(611666), // Rule ID 11252 //
     /* 611588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611635 */     // MIs[3] src0
     /* 611635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611640 */     // MIs[3] src1
     /* 611640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611647 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611664 */     GIR_RootConstrainSelectedInstOperands,
     /* 611665 */     // GIR_Coverage, 11252,
     /* 611665 */     GIR_EraseRootFromParent_Done,
     /* 611666 */   // Label 7686: @611666
     /* 611666 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(611749), // Rule ID 11253 //
     /* 611671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611718 */     // MIs[3] src1
     /* 611718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611723 */     // MIs[3] src0
     /* 611723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611730 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611747 */     GIR_RootConstrainSelectedInstOperands,
     /* 611748 */     // GIR_Coverage, 11253,
     /* 611748 */     GIR_EraseRootFromParent_Done,
     /* 611749 */   // Label 7687: @611749
     /* 611749 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(611832), // Rule ID 11254 //
     /* 611754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611801 */     // MIs[3] src0
     /* 611801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611806 */     // MIs[3] src1
     /* 611806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611813 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611830 */     GIR_RootConstrainSelectedInstOperands,
     /* 611831 */     // GIR_Coverage, 11254,
     /* 611831 */     GIR_EraseRootFromParent_Done,
     /* 611832 */   // Label 7688: @611832
     /* 611832 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(611915), // Rule ID 11255 //
     /* 611837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611884 */     // MIs[3] src1
     /* 611884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611889 */     // MIs[3] src0
     /* 611889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611896 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611913 */     GIR_RootConstrainSelectedInstOperands,
     /* 611914 */     // GIR_Coverage, 11255,
     /* 611914 */     GIR_EraseRootFromParent_Done,
     /* 611915 */   // Label 7689: @611915
     /* 611915 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(611998), // Rule ID 11256 //
     /* 611920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 611947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611967 */     // MIs[3] src0
     /* 611967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611972 */     // MIs[3] src1
     /* 611972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611979 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 611996 */     GIR_RootConstrainSelectedInstOperands,
     /* 611997 */     // GIR_Coverage, 11256,
     /* 611997 */     GIR_EraseRootFromParent_Done,
     /* 611998 */   // Label 7690: @611998
     /* 611998 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(612081), // Rule ID 11257 //
     /* 612003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612050 */     // MIs[3] src1
     /* 612050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612055 */     // MIs[3] src0
     /* 612055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612062 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612079 */     GIR_RootConstrainSelectedInstOperands,
     /* 612080 */     // GIR_Coverage, 11257,
     /* 612080 */     GIR_EraseRootFromParent_Done,
     /* 612081 */   // Label 7691: @612081
     /* 612081 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(612164), // Rule ID 11258 //
     /* 612086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612133 */     // MIs[3] src0
     /* 612133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612138 */     // MIs[3] src1
     /* 612138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612145 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612162 */     GIR_RootConstrainSelectedInstOperands,
     /* 612163 */     // GIR_Coverage, 11258,
     /* 612163 */     GIR_EraseRootFromParent_Done,
     /* 612164 */   // Label 7692: @612164
     /* 612164 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(612247), // Rule ID 11259 //
     /* 612169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612216 */     // MIs[3] src1
     /* 612216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612221 */     // MIs[3] src0
     /* 612221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612228 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612245 */     GIR_RootConstrainSelectedInstOperands,
     /* 612246 */     // GIR_Coverage, 11259,
     /* 612246 */     GIR_EraseRootFromParent_Done,
     /* 612247 */   // Label 7693: @612247
     /* 612247 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(612330), // Rule ID 7581 //
     /* 612252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612299 */     // MIs[3] src0
     /* 612299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612304 */     // MIs[3] src1
     /* 612304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612311 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612328 */     GIR_RootConstrainSelectedInstOperands,
     /* 612329 */     // GIR_Coverage, 7581,
     /* 612329 */     GIR_EraseRootFromParent_Done,
     /* 612330 */   // Label 7694: @612330
     /* 612330 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(612413), // Rule ID 11245 //
     /* 612335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612382 */     // MIs[3] src1
     /* 612382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612387 */     // MIs[3] src0
     /* 612387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612394 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612411 */     GIR_RootConstrainSelectedInstOperands,
     /* 612412 */     // GIR_Coverage, 11245,
     /* 612412 */     GIR_EraseRootFromParent_Done,
     /* 612413 */   // Label 7695: @612413
     /* 612413 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(612496), // Rule ID 11248 //
     /* 612418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612465 */     // MIs[3] src0
     /* 612465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612470 */     // MIs[3] src1
     /* 612470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612477 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612494 */     GIR_RootConstrainSelectedInstOperands,
     /* 612495 */     // GIR_Coverage, 11248,
     /* 612495 */     GIR_EraseRootFromParent_Done,
     /* 612496 */   // Label 7696: @612496
     /* 612496 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(612579), // Rule ID 11249 //
     /* 612501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612548 */     // MIs[3] src1
     /* 612548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612553 */     // MIs[3] src0
     /* 612553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612560 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612577 */     GIR_RootConstrainSelectedInstOperands,
     /* 612578 */     // GIR_Coverage, 11249,
     /* 612578 */     GIR_EraseRootFromParent_Done,
     /* 612579 */   // Label 7697: @612579
     /* 612579 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(612662), // Rule ID 11246 //
     /* 612584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612631 */     // MIs[3] src0
     /* 612631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612636 */     // MIs[3] src1
     /* 612636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612643 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612660 */     GIR_RootConstrainSelectedInstOperands,
     /* 612661 */     // GIR_Coverage, 11246,
     /* 612661 */     GIR_EraseRootFromParent_Done,
     /* 612662 */   // Label 7698: @612662
     /* 612662 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(612745), // Rule ID 11247 //
     /* 612667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612714 */     // MIs[3] src1
     /* 612714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612719 */     // MIs[3] src0
     /* 612719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612726 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612743 */     GIR_RootConstrainSelectedInstOperands,
     /* 612744 */     // GIR_Coverage, 11247,
     /* 612744 */     GIR_EraseRootFromParent_Done,
     /* 612745 */   // Label 7699: @612745
     /* 612745 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(612828), // Rule ID 11250 //
     /* 612750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612797 */     // MIs[3] src0
     /* 612797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612802 */     // MIs[3] src1
     /* 612802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612809 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612826 */     GIR_RootConstrainSelectedInstOperands,
     /* 612827 */     // GIR_Coverage, 11250,
     /* 612827 */     GIR_EraseRootFromParent_Done,
     /* 612828 */   // Label 7700: @612828
     /* 612828 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(612911), // Rule ID 11251 //
     /* 612833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612880 */     // MIs[3] src1
     /* 612880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612885 */     // MIs[3] src0
     /* 612885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612892 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612909 */     GIR_RootConstrainSelectedInstOperands,
     /* 612910 */     // GIR_Coverage, 11251,
     /* 612910 */     GIR_EraseRootFromParent_Done,
     /* 612911 */   // Label 7701: @612911
     /* 612911 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(612965), // Rule ID 8479 //
     /* 612916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 612920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 612928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612936 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 612940 */     // MIs[0] x
     /* 612940 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 612949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 612951 */     // (smax:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$x)<<P:Predicate_anonymous_13749>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 612951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 612954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 612956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // x
     /* 612960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 612963 */     GIR_RootConstrainSelectedInstOperands,
     /* 612964 */     // GIR_Coverage, 8479,
     /* 612964 */     GIR_EraseRootFromParent_Done,
     /* 612965 */   // Label 7702: @612965
     /* 612965 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(613016), // Rule ID 1869 //
     /* 612970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 612977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 612981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 612985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 612993 */     // MIs[1] x
     /* 612993 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 612998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 613002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 613004 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$x, (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_13749>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 613004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 613007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 613009 */     GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 613011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 613014 */     GIR_RootConstrainSelectedInstOperands,
     /* 613015 */     // GIR_Coverage, 1869,
     /* 613015 */     GIR_EraseRootFromParent_Done,
     /* 613016 */   // Label 7703: @613016
     /* 613016 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(613072), // Rule ID 7715 //
     /* 613021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 613024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 613027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 613043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 613047 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 613049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34985),
     /* 613053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 613055 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34985>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 613055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 613058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 613070 */     GIR_RootConstrainSelectedInstOperands,
     /* 613071 */     // GIR_Coverage, 7715,
     /* 613071 */     GIR_EraseRootFromParent_Done,
     /* 613072 */   // Label 7704: @613072
     /* 613072 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(613128), // Rule ID 13241 //
     /* 613077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 613080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 613083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 613091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 613099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 613103 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 613105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34985),
     /* 613109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 613111 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>)<<P:Predicate_anonymous_34985>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 613111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 613114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 613126 */     GIR_RootConstrainSelectedInstOperands,
     /* 613127 */     // GIR_Coverage, 13241,
     /* 613127 */     GIR_EraseRootFromParent_Done,
     /* 613128 */   // Label 7705: @613128
     /* 613128 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(613157), // Rule ID 49 //
     /* 613133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 613136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 613140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 613144 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13749>>  =>  (S_MAX_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 613144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_I32),
     /* 613149 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 613155 */     GIR_RootConstrainSelectedInstOperands,
     /* 613156 */     // GIR_Coverage, 49,
     /* 613156 */     GIR_Done,
     /* 613157 */   // Label 7706: @613157
     /* 613157 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(613180), // Rule ID 805 //
     /* 613162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 613165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613169 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 613169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 613174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 613178 */     GIR_RootConstrainSelectedInstOperands,
     /* 613179 */     // GIR_Coverage, 805,
     /* 613179 */     GIR_Done,
     /* 613180 */   // Label 7707: @613180
     /* 613180 */   GIM_Reject,
     /* 613181 */ // Label 7685: @613181
     /* 613181 */ GIM_Reject,
     /* 613182 */ // Label 7631: @613182
     /* 613182 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(613253), // Rule ID 1102 //
     /* 613187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 613190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 613193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 613204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 613211 */   // (smax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 613211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_I16),
     /* 613214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 613221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 613226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 613231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 613236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613251 */   GIR_RootConstrainSelectedInstOperands,
     /* 613252 */   // GIR_Coverage, 1102,
     /* 613252 */   GIR_EraseRootFromParent_Done,
     /* 613253 */ // Label 7708: @613253
     /* 613253 */ GIM_Reject,
     /* 613254 */ // Label 7632: @613254
     /* 613254 */ GIM_Reject,
     /* 613255 */ // Label 90: @613255
     /* 613255 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7712*/ GIMT_Encode4(619618),
     /* 613266 */ /*GILLT_s16*//*Label 7709*/ GIMT_Encode4(613282),
     /* 613270 */ /*GILLT_s32*//*Label 7710*/ GIMT_Encode4(618101), GIMT_Encode4(0),
     /* 613278 */ /*GILLT_v2s16*//*Label 7711*/ GIMT_Encode4(619546),
     /* 613282 */ // Label 7709: @613282
     /* 613282 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(618100),
     /* 613287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 613290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 613293 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(613391), // Rule ID 13314 //
     /* 613298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613345 */     // MIs[3] src0
     /* 613345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613350 */     // MIs[3] src1
     /* 613350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613357 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613389 */     GIR_RootConstrainSelectedInstOperands,
     /* 613390 */     // GIR_Coverage, 13314,
     /* 613390 */     GIR_EraseRootFromParent_Done,
     /* 613391 */   // Label 7714: @613391
     /* 613391 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(613489), // Rule ID 13315 //
     /* 613396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613443 */     // MIs[3] src1
     /* 613443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613448 */     // MIs[3] src0
     /* 613448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613455 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613487 */     GIR_RootConstrainSelectedInstOperands,
     /* 613488 */     // GIR_Coverage, 13315,
     /* 613488 */     GIR_EraseRootFromParent_Done,
     /* 613489 */   // Label 7715: @613489
     /* 613489 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(613587), // Rule ID 13316 //
     /* 613494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613541 */     // MIs[3] src0
     /* 613541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613546 */     // MIs[3] src1
     /* 613546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613553 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613585 */     GIR_RootConstrainSelectedInstOperands,
     /* 613586 */     // GIR_Coverage, 13316,
     /* 613586 */     GIR_EraseRootFromParent_Done,
     /* 613587 */   // Label 7716: @613587
     /* 613587 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(613685), // Rule ID 13317 //
     /* 613592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613639 */     // MIs[3] src1
     /* 613639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613644 */     // MIs[3] src0
     /* 613644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613651 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613683 */     GIR_RootConstrainSelectedInstOperands,
     /* 613684 */     // GIR_Coverage, 13317,
     /* 613684 */     GIR_EraseRootFromParent_Done,
     /* 613685 */   // Label 7717: @613685
     /* 613685 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(613783), // Rule ID 13374 //
     /* 613690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613737 */     // MIs[3] src0
     /* 613737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613742 */     // MIs[3] src1
     /* 613742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613749 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613781 */     GIR_RootConstrainSelectedInstOperands,
     /* 613782 */     // GIR_Coverage, 13374,
     /* 613782 */     GIR_EraseRootFromParent_Done,
     /* 613783 */   // Label 7718: @613783
     /* 613783 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(613881), // Rule ID 13375 //
     /* 613788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613835 */     // MIs[3] src1
     /* 613835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613840 */     // MIs[3] src0
     /* 613840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613847 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613879 */     GIR_RootConstrainSelectedInstOperands,
     /* 613880 */     // GIR_Coverage, 13375,
     /* 613880 */     GIR_EraseRootFromParent_Done,
     /* 613881 */   // Label 7719: @613881
     /* 613881 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(613979), // Rule ID 13376 //
     /* 613886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613933 */     // MIs[3] src0
     /* 613933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613938 */     // MIs[3] src1
     /* 613938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613945 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613977 */     GIR_RootConstrainSelectedInstOperands,
     /* 613978 */     // GIR_Coverage, 13376,
     /* 613978 */     GIR_EraseRootFromParent_Done,
     /* 613979 */   // Label 7720: @613979
     /* 613979 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(614077), // Rule ID 13377 //
     /* 613984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614031 */     // MIs[3] src1
     /* 614031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614036 */     // MIs[3] src0
     /* 614036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614043 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614075 */     GIR_RootConstrainSelectedInstOperands,
     /* 614076 */     // GIR_Coverage, 13377,
     /* 614076 */     GIR_EraseRootFromParent_Done,
     /* 614077 */   // Label 7721: @614077
     /* 614077 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(614175), // Rule ID 13434 //
     /* 614082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614129 */     // MIs[3] src0
     /* 614129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614134 */     // MIs[3] src1
     /* 614134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614141 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614173 */     GIR_RootConstrainSelectedInstOperands,
     /* 614174 */     // GIR_Coverage, 13434,
     /* 614174 */     GIR_EraseRootFromParent_Done,
     /* 614175 */   // Label 7722: @614175
     /* 614175 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(614273), // Rule ID 13435 //
     /* 614180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614227 */     // MIs[3] src1
     /* 614227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614232 */     // MIs[3] src0
     /* 614232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614239 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614271 */     GIR_RootConstrainSelectedInstOperands,
     /* 614272 */     // GIR_Coverage, 13435,
     /* 614272 */     GIR_EraseRootFromParent_Done,
     /* 614273 */   // Label 7723: @614273
     /* 614273 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(614371), // Rule ID 13436 //
     /* 614278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614325 */     // MIs[3] src0
     /* 614325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614330 */     // MIs[3] src1
     /* 614330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614337 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614369 */     GIR_RootConstrainSelectedInstOperands,
     /* 614370 */     // GIR_Coverage, 13436,
     /* 614370 */     GIR_EraseRootFromParent_Done,
     /* 614371 */   // Label 7724: @614371
     /* 614371 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(614469), // Rule ID 13437 //
     /* 614376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614423 */     // MIs[3] src1
     /* 614423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614428 */     // MIs[3] src0
     /* 614428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614435 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614467 */     GIR_RootConstrainSelectedInstOperands,
     /* 614468 */     // GIR_Coverage, 13437,
     /* 614468 */     GIR_EraseRootFromParent_Done,
     /* 614469 */   // Label 7725: @614469
     /* 614469 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(614567), // Rule ID 13318 //
     /* 614474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614521 */     // MIs[3] src0
     /* 614521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614526 */     // MIs[3] src1
     /* 614526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614533 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614565 */     GIR_RootConstrainSelectedInstOperands,
     /* 614566 */     // GIR_Coverage, 13318,
     /* 614566 */     GIR_EraseRootFromParent_Done,
     /* 614567 */   // Label 7726: @614567
     /* 614567 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(614665), // Rule ID 13319 //
     /* 614572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614619 */     // MIs[3] src1
     /* 614619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614624 */     // MIs[3] src0
     /* 614624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614631 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614663 */     GIR_RootConstrainSelectedInstOperands,
     /* 614664 */     // GIR_Coverage, 13319,
     /* 614664 */     GIR_EraseRootFromParent_Done,
     /* 614665 */   // Label 7727: @614665
     /* 614665 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(614763), // Rule ID 13320 //
     /* 614670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614717 */     // MIs[3] src0
     /* 614717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614722 */     // MIs[3] src1
     /* 614722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614729 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614761 */     GIR_RootConstrainSelectedInstOperands,
     /* 614762 */     // GIR_Coverage, 13320,
     /* 614762 */     GIR_EraseRootFromParent_Done,
     /* 614763 */   // Label 7728: @614763
     /* 614763 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(614861), // Rule ID 13321 //
     /* 614768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614815 */     // MIs[3] src1
     /* 614815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614820 */     // MIs[3] src0
     /* 614820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614827 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614859 */     GIR_RootConstrainSelectedInstOperands,
     /* 614860 */     // GIR_Coverage, 13321,
     /* 614860 */     GIR_EraseRootFromParent_Done,
     /* 614861 */   // Label 7729: @614861
     /* 614861 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(614959), // Rule ID 13378 //
     /* 614866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614913 */     // MIs[3] src0
     /* 614913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614918 */     // MIs[3] src1
     /* 614918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614925 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614957 */     GIR_RootConstrainSelectedInstOperands,
     /* 614958 */     // GIR_Coverage, 13378,
     /* 614958 */     GIR_EraseRootFromParent_Done,
     /* 614959 */   // Label 7730: @614959
     /* 614959 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(615057), // Rule ID 13379 //
     /* 614964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615011 */     // MIs[3] src1
     /* 615011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615016 */     // MIs[3] src0
     /* 615016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615023 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 615026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615055 */     GIR_RootConstrainSelectedInstOperands,
     /* 615056 */     // GIR_Coverage, 13379,
     /* 615056 */     GIR_EraseRootFromParent_Done,
     /* 615057 */   // Label 7731: @615057
     /* 615057 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(615155), // Rule ID 13380 //
     /* 615062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615109 */     // MIs[3] src0
     /* 615109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615114 */     // MIs[3] src1
     /* 615114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615121 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 615124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615153 */     GIR_RootConstrainSelectedInstOperands,
     /* 615154 */     // GIR_Coverage, 13380,
     /* 615154 */     GIR_EraseRootFromParent_Done,
     /* 615155 */   // Label 7732: @615155
     /* 615155 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(615253), // Rule ID 13381 //
     /* 615160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615207 */     // MIs[3] src1
     /* 615207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615212 */     // MIs[3] src0
     /* 615212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615219 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 615222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615251 */     GIR_RootConstrainSelectedInstOperands,
     /* 615252 */     // GIR_Coverage, 13381,
     /* 615252 */     GIR_EraseRootFromParent_Done,
     /* 615253 */   // Label 7733: @615253
     /* 615253 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(615351), // Rule ID 13438 //
     /* 615258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615305 */     // MIs[3] src0
     /* 615305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615310 */     // MIs[3] src1
     /* 615310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615317 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615349 */     GIR_RootConstrainSelectedInstOperands,
     /* 615350 */     // GIR_Coverage, 13438,
     /* 615350 */     GIR_EraseRootFromParent_Done,
     /* 615351 */   // Label 7734: @615351
     /* 615351 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(615449), // Rule ID 13439 //
     /* 615356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615403 */     // MIs[3] src1
     /* 615403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615408 */     // MIs[3] src0
     /* 615408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615415 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615447 */     GIR_RootConstrainSelectedInstOperands,
     /* 615448 */     // GIR_Coverage, 13439,
     /* 615448 */     GIR_EraseRootFromParent_Done,
     /* 615449 */   // Label 7735: @615449
     /* 615449 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(615547), // Rule ID 13440 //
     /* 615454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615501 */     // MIs[3] src0
     /* 615501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615506 */     // MIs[3] src1
     /* 615506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615513 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615545 */     GIR_RootConstrainSelectedInstOperands,
     /* 615546 */     // GIR_Coverage, 13440,
     /* 615546 */     GIR_EraseRootFromParent_Done,
     /* 615547 */   // Label 7736: @615547
     /* 615547 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(615645), // Rule ID 13441 //
     /* 615552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615599 */     // MIs[3] src1
     /* 615599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615604 */     // MIs[3] src0
     /* 615604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615611 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615643 */     GIR_RootConstrainSelectedInstOperands,
     /* 615644 */     // GIR_Coverage, 13441,
     /* 615644 */     GIR_EraseRootFromParent_Done,
     /* 615645 */   // Label 7737: @615645
     /* 615645 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(615743), // Rule ID 7767 //
     /* 615650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615697 */     // MIs[3] src0
     /* 615697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615702 */     // MIs[3] src1
     /* 615702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615709 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 615712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615741 */     GIR_RootConstrainSelectedInstOperands,
     /* 615742 */     // GIR_Coverage, 7767,
     /* 615742 */     GIR_EraseRootFromParent_Done,
     /* 615743 */   // Label 7738: @615743
     /* 615743 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(615841), // Rule ID 7771 //
     /* 615748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615795 */     // MIs[3] src0
     /* 615795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615800 */     // MIs[3] src1
     /* 615800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615807 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 615810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615839 */     GIR_RootConstrainSelectedInstOperands,
     /* 615840 */     // GIR_Coverage, 7771,
     /* 615840 */     GIR_EraseRootFromParent_Done,
     /* 615841 */   // Label 7739: @615841
     /* 615841 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(615939), // Rule ID 7775 //
     /* 615846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615893 */     // MIs[3] src0
     /* 615893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615898 */     // MIs[3] src1
     /* 615898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615905 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615937 */     GIR_RootConstrainSelectedInstOperands,
     /* 615938 */     // GIR_Coverage, 7775,
     /* 615938 */     GIR_EraseRootFromParent_Done,
     /* 615939 */   // Label 7740: @615939
     /* 615939 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(616037), // Rule ID 13307 //
     /* 615944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615991 */     // MIs[3] src1
     /* 615991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615996 */     // MIs[3] src0
     /* 615996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616003 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616035 */     GIR_RootConstrainSelectedInstOperands,
     /* 616036 */     // GIR_Coverage, 13307,
     /* 616036 */     GIR_EraseRootFromParent_Done,
     /* 616037 */   // Label 7741: @616037
     /* 616037 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(616135), // Rule ID 13310 //
     /* 616042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616089 */     // MIs[3] src0
     /* 616089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616094 */     // MIs[3] src1
     /* 616094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616101 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616133 */     GIR_RootConstrainSelectedInstOperands,
     /* 616134 */     // GIR_Coverage, 13310,
     /* 616134 */     GIR_EraseRootFromParent_Done,
     /* 616135 */   // Label 7742: @616135
     /* 616135 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(616233), // Rule ID 13311 //
     /* 616140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616187 */     // MIs[3] src1
     /* 616187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616192 */     // MIs[3] src0
     /* 616192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616199 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616231 */     GIR_RootConstrainSelectedInstOperands,
     /* 616232 */     // GIR_Coverage, 13311,
     /* 616232 */     GIR_EraseRootFromParent_Done,
     /* 616233 */   // Label 7743: @616233
     /* 616233 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(616331), // Rule ID 13367 //
     /* 616238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616285 */     // MIs[3] src1
     /* 616285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616290 */     // MIs[3] src0
     /* 616290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616297 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616329 */     GIR_RootConstrainSelectedInstOperands,
     /* 616330 */     // GIR_Coverage, 13367,
     /* 616330 */     GIR_EraseRootFromParent_Done,
     /* 616331 */   // Label 7744: @616331
     /* 616331 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(616429), // Rule ID 13370 //
     /* 616336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616383 */     // MIs[3] src0
     /* 616383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616388 */     // MIs[3] src1
     /* 616388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616395 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616427 */     GIR_RootConstrainSelectedInstOperands,
     /* 616428 */     // GIR_Coverage, 13370,
     /* 616428 */     GIR_EraseRootFromParent_Done,
     /* 616429 */   // Label 7745: @616429
     /* 616429 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(616527), // Rule ID 13371 //
     /* 616434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616481 */     // MIs[3] src1
     /* 616481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616486 */     // MIs[3] src0
     /* 616486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616493 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616525 */     GIR_RootConstrainSelectedInstOperands,
     /* 616526 */     // GIR_Coverage, 13371,
     /* 616526 */     GIR_EraseRootFromParent_Done,
     /* 616527 */   // Label 7746: @616527
     /* 616527 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(616625), // Rule ID 13427 //
     /* 616532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616579 */     // MIs[3] src1
     /* 616579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616584 */     // MIs[3] src0
     /* 616584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616591 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616623 */     GIR_RootConstrainSelectedInstOperands,
     /* 616624 */     // GIR_Coverage, 13427,
     /* 616624 */     GIR_EraseRootFromParent_Done,
     /* 616625 */   // Label 7747: @616625
     /* 616625 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(616723), // Rule ID 13430 //
     /* 616630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616677 */     // MIs[3] src0
     /* 616677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616682 */     // MIs[3] src1
     /* 616682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616689 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616721 */     GIR_RootConstrainSelectedInstOperands,
     /* 616722 */     // GIR_Coverage, 13430,
     /* 616722 */     GIR_EraseRootFromParent_Done,
     /* 616723 */   // Label 7748: @616723
     /* 616723 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(616821), // Rule ID 13431 //
     /* 616728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616775 */     // MIs[3] src1
     /* 616775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616780 */     // MIs[3] src0
     /* 616780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616787 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616819 */     GIR_RootConstrainSelectedInstOperands,
     /* 616820 */     // GIR_Coverage, 13431,
     /* 616820 */     GIR_EraseRootFromParent_Done,
     /* 616821 */   // Label 7749: @616821
     /* 616821 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(616919), // Rule ID 13308 //
     /* 616826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616873 */     // MIs[3] src0
     /* 616873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616878 */     // MIs[3] src1
     /* 616878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616885 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616917 */     GIR_RootConstrainSelectedInstOperands,
     /* 616918 */     // GIR_Coverage, 13308,
     /* 616918 */     GIR_EraseRootFromParent_Done,
     /* 616919 */   // Label 7750: @616919
     /* 616919 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(617017), // Rule ID 13309 //
     /* 616924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616971 */     // MIs[3] src1
     /* 616971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616976 */     // MIs[3] src0
     /* 616976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616983 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617015 */     GIR_RootConstrainSelectedInstOperands,
     /* 617016 */     // GIR_Coverage, 13309,
     /* 617016 */     GIR_EraseRootFromParent_Done,
     /* 617017 */   // Label 7751: @617017
     /* 617017 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(617115), // Rule ID 13312 //
     /* 617022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617069 */     // MIs[3] src0
     /* 617069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617074 */     // MIs[3] src1
     /* 617074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617081 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617113 */     GIR_RootConstrainSelectedInstOperands,
     /* 617114 */     // GIR_Coverage, 13312,
     /* 617114 */     GIR_EraseRootFromParent_Done,
     /* 617115 */   // Label 7752: @617115
     /* 617115 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(617213), // Rule ID 13313 //
     /* 617120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617167 */     // MIs[3] src1
     /* 617167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617172 */     // MIs[3] src0
     /* 617172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617179 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617211 */     GIR_RootConstrainSelectedInstOperands,
     /* 617212 */     // GIR_Coverage, 13313,
     /* 617212 */     GIR_EraseRootFromParent_Done,
     /* 617213 */   // Label 7753: @617213
     /* 617213 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(617311), // Rule ID 13368 //
     /* 617218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617265 */     // MIs[3] src0
     /* 617265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617270 */     // MIs[3] src1
     /* 617270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617277 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617309 */     GIR_RootConstrainSelectedInstOperands,
     /* 617310 */     // GIR_Coverage, 13368,
     /* 617310 */     GIR_EraseRootFromParent_Done,
     /* 617311 */   // Label 7754: @617311
     /* 617311 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(617409), // Rule ID 13369 //
     /* 617316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617363 */     // MIs[3] src1
     /* 617363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617368 */     // MIs[3] src0
     /* 617368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617375 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617407 */     GIR_RootConstrainSelectedInstOperands,
     /* 617408 */     // GIR_Coverage, 13369,
     /* 617408 */     GIR_EraseRootFromParent_Done,
     /* 617409 */   // Label 7755: @617409
     /* 617409 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(617507), // Rule ID 13372 //
     /* 617414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617461 */     // MIs[3] src0
     /* 617461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617466 */     // MIs[3] src1
     /* 617466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617473 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617505 */     GIR_RootConstrainSelectedInstOperands,
     /* 617506 */     // GIR_Coverage, 13372,
     /* 617506 */     GIR_EraseRootFromParent_Done,
     /* 617507 */   // Label 7756: @617507
     /* 617507 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(617605), // Rule ID 13373 //
     /* 617512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617559 */     // MIs[3] src1
     /* 617559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617564 */     // MIs[3] src0
     /* 617564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617571 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617603 */     GIR_RootConstrainSelectedInstOperands,
     /* 617604 */     // GIR_Coverage, 13373,
     /* 617604 */     GIR_EraseRootFromParent_Done,
     /* 617605 */   // Label 7757: @617605
     /* 617605 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(617703), // Rule ID 13428 //
     /* 617610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617657 */     // MIs[3] src0
     /* 617657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617662 */     // MIs[3] src1
     /* 617662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617669 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617701 */     GIR_RootConstrainSelectedInstOperands,
     /* 617702 */     // GIR_Coverage, 13428,
     /* 617702 */     GIR_EraseRootFromParent_Done,
     /* 617703 */   // Label 7758: @617703
     /* 617703 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(617801), // Rule ID 13429 //
     /* 617708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617755 */     // MIs[3] src1
     /* 617755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617760 */     // MIs[3] src0
     /* 617760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617767 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617799 */     GIR_RootConstrainSelectedInstOperands,
     /* 617800 */     // GIR_Coverage, 13429,
     /* 617800 */     GIR_EraseRootFromParent_Done,
     /* 617801 */   // Label 7759: @617801
     /* 617801 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(617899), // Rule ID 13432 //
     /* 617806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617853 */     // MIs[3] src0
     /* 617853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617858 */     // MIs[3] src1
     /* 617858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617865 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617897 */     GIR_RootConstrainSelectedInstOperands,
     /* 617898 */     // GIR_Coverage, 13432,
     /* 617898 */     GIR_EraseRootFromParent_Done,
     /* 617899 */   // Label 7760: @617899
     /* 617899 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(617997), // Rule ID 13433 //
     /* 617904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617951 */     // MIs[3] src1
     /* 617951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617956 */     // MIs[3] src0
     /* 617956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617963 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617995 */     GIR_RootConstrainSelectedInstOperands,
     /* 617996 */     // GIR_Coverage, 13433,
     /* 617996 */     GIR_EraseRootFromParent_Done,
     /* 617997 */   // Label 7761: @617997
     /* 617997 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(618053), // Rule ID 898 //
     /* 618002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 618005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 618009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 618016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 618023 */     // (umin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 618023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_t16_e64),
     /* 618026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 618033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 618038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 618043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 618048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618051 */     GIR_RootConstrainSelectedInstOperands,
     /* 618052 */     // GIR_Coverage, 898,
     /* 618052 */     GIR_EraseRootFromParent_Done,
     /* 618053 */   // Label 7762: @618053
     /* 618053 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(618076), // Rule ID 897 //
     /* 618058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 618061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618065 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 618065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 618070 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 618074 */     GIR_RootConstrainSelectedInstOperands,
     /* 618075 */     // GIR_Coverage, 897,
     /* 618075 */     GIR_Done,
     /* 618076 */   // Label 7763: @618076
     /* 618076 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(618099), // Rule ID 899 //
     /* 618081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 618084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618088 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 618088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_fake16_e64),
     /* 618093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 618097 */     GIR_RootConstrainSelectedInstOperands,
     /* 618098 */     // GIR_Coverage, 899,
     /* 618098 */     GIR_Done,
     /* 618099 */   // Label 7764: @618099
     /* 618099 */   GIM_Reject,
     /* 618100 */ // Label 7713: @618100
     /* 618100 */ GIM_Reject,
     /* 618101 */ // Label 7710: @618101
     /* 618101 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(619545),
     /* 618106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 618109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 618112 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(618192), // Rule ID 11267 //
     /* 618117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618161 */     // MIs[3] src0
     /* 618161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618166 */     // MIs[3] src1
     /* 618166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618173 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618190 */     GIR_RootConstrainSelectedInstOperands,
     /* 618191 */     // GIR_Coverage, 11267,
     /* 618191 */     GIR_EraseRootFromParent_Done,
     /* 618192 */   // Label 7766: @618192
     /* 618192 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(618272), // Rule ID 11268 //
     /* 618197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618241 */     // MIs[3] src1
     /* 618241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618246 */     // MIs[3] src0
     /* 618246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618253 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618270 */     GIR_RootConstrainSelectedInstOperands,
     /* 618271 */     // GIR_Coverage, 11268,
     /* 618271 */     GIR_EraseRootFromParent_Done,
     /* 618272 */   // Label 7767: @618272
     /* 618272 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(618352), // Rule ID 11269 //
     /* 618277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618321 */     // MIs[3] src0
     /* 618321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618326 */     // MIs[3] src1
     /* 618326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618333 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618350 */     GIR_RootConstrainSelectedInstOperands,
     /* 618351 */     // GIR_Coverage, 11269,
     /* 618351 */     GIR_EraseRootFromParent_Done,
     /* 618352 */   // Label 7768: @618352
     /* 618352 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(618432), // Rule ID 11270 //
     /* 618357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618401 */     // MIs[3] src1
     /* 618401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618406 */     // MIs[3] src0
     /* 618406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618413 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618430 */     GIR_RootConstrainSelectedInstOperands,
     /* 618431 */     // GIR_Coverage, 11270,
     /* 618431 */     GIR_EraseRootFromParent_Done,
     /* 618432 */   // Label 7769: @618432
     /* 618432 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(618512), // Rule ID 11271 //
     /* 618437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618481 */     // MIs[3] src0
     /* 618481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618486 */     // MIs[3] src1
     /* 618486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618493 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618510 */     GIR_RootConstrainSelectedInstOperands,
     /* 618511 */     // GIR_Coverage, 11271,
     /* 618511 */     GIR_EraseRootFromParent_Done,
     /* 618512 */   // Label 7770: @618512
     /* 618512 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(618592), // Rule ID 11272 //
     /* 618517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618561 */     // MIs[3] src1
     /* 618561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618566 */     // MIs[3] src0
     /* 618566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618573 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618590 */     GIR_RootConstrainSelectedInstOperands,
     /* 618591 */     // GIR_Coverage, 11272,
     /* 618591 */     GIR_EraseRootFromParent_Done,
     /* 618592 */   // Label 7771: @618592
     /* 618592 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(618672), // Rule ID 11273 //
     /* 618597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618641 */     // MIs[3] src0
     /* 618641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618646 */     // MIs[3] src1
     /* 618646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618653 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618670 */     GIR_RootConstrainSelectedInstOperands,
     /* 618671 */     // GIR_Coverage, 11273,
     /* 618671 */     GIR_EraseRootFromParent_Done,
     /* 618672 */   // Label 7772: @618672
     /* 618672 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(618752), // Rule ID 11274 //
     /* 618677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618721 */     // MIs[3] src1
     /* 618721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618726 */     // MIs[3] src0
     /* 618726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618733 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618750 */     GIR_RootConstrainSelectedInstOperands,
     /* 618751 */     // GIR_Coverage, 11274,
     /* 618751 */     GIR_EraseRootFromParent_Done,
     /* 618752 */   // Label 7773: @618752
     /* 618752 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(618832), // Rule ID 7582 //
     /* 618757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618801 */     // MIs[3] src0
     /* 618801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618806 */     // MIs[3] src1
     /* 618806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618813 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618830 */     GIR_RootConstrainSelectedInstOperands,
     /* 618831 */     // GIR_Coverage, 7582,
     /* 618831 */     GIR_EraseRootFromParent_Done,
     /* 618832 */   // Label 7774: @618832
     /* 618832 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(618912), // Rule ID 11260 //
     /* 618837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618881 */     // MIs[3] src1
     /* 618881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618886 */     // MIs[3] src0
     /* 618886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618893 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618910 */     GIR_RootConstrainSelectedInstOperands,
     /* 618911 */     // GIR_Coverage, 11260,
     /* 618911 */     GIR_EraseRootFromParent_Done,
     /* 618912 */   // Label 7775: @618912
     /* 618912 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(618992), // Rule ID 11263 //
     /* 618917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618961 */     // MIs[3] src0
     /* 618961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618966 */     // MIs[3] src1
     /* 618966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618973 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 618982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 618986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618990 */     GIR_RootConstrainSelectedInstOperands,
     /* 618991 */     // GIR_Coverage, 11263,
     /* 618991 */     GIR_EraseRootFromParent_Done,
     /* 618992 */   // Label 7776: @618992
     /* 618992 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(619072), // Rule ID 11264 //
     /* 618997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 619037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619041 */     // MIs[3] src1
     /* 619041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619046 */     // MIs[3] src0
     /* 619046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619053 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 619062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 619066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 619070 */     GIR_RootConstrainSelectedInstOperands,
     /* 619071 */     // GIR_Coverage, 11264,
     /* 619071 */     GIR_EraseRootFromParent_Done,
     /* 619072 */   // Label 7777: @619072
     /* 619072 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(619152), // Rule ID 11261 //
     /* 619077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 619117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619121 */     // MIs[3] src0
     /* 619121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619126 */     // MIs[3] src1
     /* 619126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619133 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619150 */     GIR_RootConstrainSelectedInstOperands,
     /* 619151 */     // GIR_Coverage, 11261,
     /* 619151 */     GIR_EraseRootFromParent_Done,
     /* 619152 */   // Label 7778: @619152
     /* 619152 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(619232), // Rule ID 11262 //
     /* 619157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 619197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619201 */     // MIs[3] src1
     /* 619201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619206 */     // MIs[3] src0
     /* 619206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619213 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619230 */     GIR_RootConstrainSelectedInstOperands,
     /* 619231 */     // GIR_Coverage, 11262,
     /* 619231 */     GIR_EraseRootFromParent_Done,
     /* 619232 */   // Label 7779: @619232
     /* 619232 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(619312), // Rule ID 11265 //
     /* 619237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 619277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619281 */     // MIs[3] src0
     /* 619281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619286 */     // MIs[3] src1
     /* 619286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619293 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 619302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 619306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619310 */     GIR_RootConstrainSelectedInstOperands,
     /* 619311 */     // GIR_Coverage, 11265,
     /* 619311 */     GIR_EraseRootFromParent_Done,
     /* 619312 */   // Label 7780: @619312
     /* 619312 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(619392), // Rule ID 11266 //
     /* 619317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 619357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619361 */     // MIs[3] src1
     /* 619361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619366 */     // MIs[3] src0
     /* 619366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619373 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 619382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 619386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619390 */     GIR_RootConstrainSelectedInstOperands,
     /* 619391 */     // GIR_Coverage, 11266,
     /* 619391 */     GIR_EraseRootFromParent_Done,
     /* 619392 */   // Label 7781: @619392
     /* 619392 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(619445), // Rule ID 7716 //
     /* 619397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 619400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619420 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 619422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34987),
     /* 619426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 619428 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34987>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 619431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 619443 */     GIR_RootConstrainSelectedInstOperands,
     /* 619444 */     // GIR_Coverage, 7716,
     /* 619444 */     GIR_EraseRootFromParent_Done,
     /* 619445 */   // Label 7782: @619445
     /* 619445 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(619498), // Rule ID 13242 //
     /* 619450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 619453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 619461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619473 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 619475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34987),
     /* 619479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 619481 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>)<<P:Predicate_anonymous_34987>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 619484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 619496 */     GIR_RootConstrainSelectedInstOperands,
     /* 619497 */     // GIR_Coverage, 13242,
     /* 619497 */     GIR_EraseRootFromParent_Done,
     /* 619498 */   // Label 7783: @619498
     /* 619498 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(619524), // Rule ID 48 //
     /* 619503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 619507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13748),
     /* 619511 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13748>>  =>  (S_MIN_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 619511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_U32),
     /* 619516 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 619522 */     GIR_RootConstrainSelectedInstOperands,
     /* 619523 */     // GIR_Coverage, 48,
     /* 619523 */     GIR_Done,
     /* 619524 */   // Label 7784: @619524
     /* 619524 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(619544), // Rule ID 806 //
     /* 619529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619533 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 619533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U32_e64),
     /* 619538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 619542 */     GIR_RootConstrainSelectedInstOperands,
     /* 619543 */     // GIR_Coverage, 806,
     /* 619543 */     GIR_Done,
     /* 619544 */   // Label 7785: @619544
     /* 619544 */   GIM_Reject,
     /* 619545 */ // Label 7765: @619545
     /* 619545 */ GIM_Reject,
     /* 619546 */ // Label 7711: @619546
     /* 619546 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(619617), // Rule ID 1101 //
     /* 619551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 619554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 619557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 619568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 619575 */   // (umin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 619575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_U16),
     /* 619578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 619585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 619590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 619595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 619600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619615 */   GIR_RootConstrainSelectedInstOperands,
     /* 619616 */   // GIR_Coverage, 1101,
     /* 619616 */   GIR_EraseRootFromParent_Done,
     /* 619617 */ // Label 7786: @619617
     /* 619617 */ GIM_Reject,
     /* 619618 */ // Label 7712: @619618
     /* 619618 */ GIM_Reject,
     /* 619619 */ // Label 91: @619619
     /* 619619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7790*/ GIMT_Encode4(625982),
     /* 619630 */ /*GILLT_s16*//*Label 7787*/ GIMT_Encode4(619646),
     /* 619634 */ /*GILLT_s32*//*Label 7788*/ GIMT_Encode4(624465), GIMT_Encode4(0),
     /* 619642 */ /*GILLT_v2s16*//*Label 7789*/ GIMT_Encode4(625910),
     /* 619646 */ // Label 7787: @619646
     /* 619646 */ GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(624464),
     /* 619651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 619654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 619657 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(619755), // Rule ID 13299 //
     /* 619662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619709 */     // MIs[3] src0
     /* 619709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619714 */     // MIs[3] src1
     /* 619714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619721 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619753 */     GIR_RootConstrainSelectedInstOperands,
     /* 619754 */     // GIR_Coverage, 13299,
     /* 619754 */     GIR_EraseRootFromParent_Done,
     /* 619755 */   // Label 7792: @619755
     /* 619755 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(619853), // Rule ID 13300 //
     /* 619760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619807 */     // MIs[3] src1
     /* 619807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619812 */     // MIs[3] src0
     /* 619812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619819 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619851 */     GIR_RootConstrainSelectedInstOperands,
     /* 619852 */     // GIR_Coverage, 13300,
     /* 619852 */     GIR_EraseRootFromParent_Done,
     /* 619853 */   // Label 7793: @619853
     /* 619853 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(619951), // Rule ID 13301 //
     /* 619858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619905 */     // MIs[3] src0
     /* 619905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619910 */     // MIs[3] src1
     /* 619910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619917 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619949 */     GIR_RootConstrainSelectedInstOperands,
     /* 619950 */     // GIR_Coverage, 13301,
     /* 619950 */     GIR_EraseRootFromParent_Done,
     /* 619951 */   // Label 7794: @619951
     /* 619951 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(620049), // Rule ID 13302 //
     /* 619956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620003 */     // MIs[3] src1
     /* 620003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620008 */     // MIs[3] src0
     /* 620008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620015 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620047 */     GIR_RootConstrainSelectedInstOperands,
     /* 620048 */     // GIR_Coverage, 13302,
     /* 620048 */     GIR_EraseRootFromParent_Done,
     /* 620049 */   // Label 7795: @620049
     /* 620049 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(620147), // Rule ID 13359 //
     /* 620054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620101 */     // MIs[3] src0
     /* 620101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620106 */     // MIs[3] src1
     /* 620106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620113 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620145 */     GIR_RootConstrainSelectedInstOperands,
     /* 620146 */     // GIR_Coverage, 13359,
     /* 620146 */     GIR_EraseRootFromParent_Done,
     /* 620147 */   // Label 7796: @620147
     /* 620147 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(620245), // Rule ID 13360 //
     /* 620152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620199 */     // MIs[3] src1
     /* 620199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620204 */     // MIs[3] src0
     /* 620204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620211 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620243 */     GIR_RootConstrainSelectedInstOperands,
     /* 620244 */     // GIR_Coverage, 13360,
     /* 620244 */     GIR_EraseRootFromParent_Done,
     /* 620245 */   // Label 7797: @620245
     /* 620245 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(620343), // Rule ID 13361 //
     /* 620250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620297 */     // MIs[3] src0
     /* 620297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620302 */     // MIs[3] src1
     /* 620302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620309 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620341 */     GIR_RootConstrainSelectedInstOperands,
     /* 620342 */     // GIR_Coverage, 13361,
     /* 620342 */     GIR_EraseRootFromParent_Done,
     /* 620343 */   // Label 7798: @620343
     /* 620343 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(620441), // Rule ID 13362 //
     /* 620348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620395 */     // MIs[3] src1
     /* 620395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620400 */     // MIs[3] src0
     /* 620400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620407 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620439 */     GIR_RootConstrainSelectedInstOperands,
     /* 620440 */     // GIR_Coverage, 13362,
     /* 620440 */     GIR_EraseRootFromParent_Done,
     /* 620441 */   // Label 7799: @620441
     /* 620441 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(620539), // Rule ID 13419 //
     /* 620446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620493 */     // MIs[3] src0
     /* 620493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620498 */     // MIs[3] src1
     /* 620498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620505 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620537 */     GIR_RootConstrainSelectedInstOperands,
     /* 620538 */     // GIR_Coverage, 13419,
     /* 620538 */     GIR_EraseRootFromParent_Done,
     /* 620539 */   // Label 7800: @620539
     /* 620539 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(620637), // Rule ID 13420 //
     /* 620544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620591 */     // MIs[3] src1
     /* 620591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620596 */     // MIs[3] src0
     /* 620596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620603 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620635 */     GIR_RootConstrainSelectedInstOperands,
     /* 620636 */     // GIR_Coverage, 13420,
     /* 620636 */     GIR_EraseRootFromParent_Done,
     /* 620637 */   // Label 7801: @620637
     /* 620637 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(620735), // Rule ID 13421 //
     /* 620642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620689 */     // MIs[3] src0
     /* 620689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620694 */     // MIs[3] src1
     /* 620694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620701 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620733 */     GIR_RootConstrainSelectedInstOperands,
     /* 620734 */     // GIR_Coverage, 13421,
     /* 620734 */     GIR_EraseRootFromParent_Done,
     /* 620735 */   // Label 7802: @620735
     /* 620735 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(620833), // Rule ID 13422 //
     /* 620740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620787 */     // MIs[3] src1
     /* 620787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620792 */     // MIs[3] src0
     /* 620792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620799 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620831 */     GIR_RootConstrainSelectedInstOperands,
     /* 620832 */     // GIR_Coverage, 13422,
     /* 620832 */     GIR_EraseRootFromParent_Done,
     /* 620833 */   // Label 7803: @620833
     /* 620833 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(620931), // Rule ID 13303 //
     /* 620838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620885 */     // MIs[3] src0
     /* 620885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620890 */     // MIs[3] src1
     /* 620890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620897 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 620923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620929 */     GIR_RootConstrainSelectedInstOperands,
     /* 620930 */     // GIR_Coverage, 13303,
     /* 620930 */     GIR_EraseRootFromParent_Done,
     /* 620931 */   // Label 7804: @620931
     /* 620931 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(621029), // Rule ID 13304 //
     /* 620936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620983 */     // MIs[3] src1
     /* 620983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620988 */     // MIs[3] src0
     /* 620988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620995 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621027 */     GIR_RootConstrainSelectedInstOperands,
     /* 621028 */     // GIR_Coverage, 13304,
     /* 621028 */     GIR_EraseRootFromParent_Done,
     /* 621029 */   // Label 7805: @621029
     /* 621029 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(621127), // Rule ID 13305 //
     /* 621034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621081 */     // MIs[3] src0
     /* 621081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621086 */     // MIs[3] src1
     /* 621086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621093 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621125 */     GIR_RootConstrainSelectedInstOperands,
     /* 621126 */     // GIR_Coverage, 13305,
     /* 621126 */     GIR_EraseRootFromParent_Done,
     /* 621127 */   // Label 7806: @621127
     /* 621127 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(621225), // Rule ID 13306 //
     /* 621132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621179 */     // MIs[3] src1
     /* 621179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621184 */     // MIs[3] src0
     /* 621184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621191 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621223 */     GIR_RootConstrainSelectedInstOperands,
     /* 621224 */     // GIR_Coverage, 13306,
     /* 621224 */     GIR_EraseRootFromParent_Done,
     /* 621225 */   // Label 7807: @621225
     /* 621225 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(621323), // Rule ID 13363 //
     /* 621230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621277 */     // MIs[3] src0
     /* 621277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621282 */     // MIs[3] src1
     /* 621282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621289 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621321 */     GIR_RootConstrainSelectedInstOperands,
     /* 621322 */     // GIR_Coverage, 13363,
     /* 621322 */     GIR_EraseRootFromParent_Done,
     /* 621323 */   // Label 7808: @621323
     /* 621323 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(621421), // Rule ID 13364 //
     /* 621328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621375 */     // MIs[3] src1
     /* 621375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621380 */     // MIs[3] src0
     /* 621380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621387 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621419 */     GIR_RootConstrainSelectedInstOperands,
     /* 621420 */     // GIR_Coverage, 13364,
     /* 621420 */     GIR_EraseRootFromParent_Done,
     /* 621421 */   // Label 7809: @621421
     /* 621421 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(621519), // Rule ID 13365 //
     /* 621426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621473 */     // MIs[3] src0
     /* 621473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621478 */     // MIs[3] src1
     /* 621478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621485 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621517 */     GIR_RootConstrainSelectedInstOperands,
     /* 621518 */     // GIR_Coverage, 13365,
     /* 621518 */     GIR_EraseRootFromParent_Done,
     /* 621519 */   // Label 7810: @621519
     /* 621519 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(621617), // Rule ID 13366 //
     /* 621524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621571 */     // MIs[3] src1
     /* 621571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621576 */     // MIs[3] src0
     /* 621576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621583 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621615 */     GIR_RootConstrainSelectedInstOperands,
     /* 621616 */     // GIR_Coverage, 13366,
     /* 621616 */     GIR_EraseRootFromParent_Done,
     /* 621617 */   // Label 7811: @621617
     /* 621617 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(621715), // Rule ID 13423 //
     /* 621622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621669 */     // MIs[3] src0
     /* 621669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621674 */     // MIs[3] src1
     /* 621674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621681 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621713 */     GIR_RootConstrainSelectedInstOperands,
     /* 621714 */     // GIR_Coverage, 13423,
     /* 621714 */     GIR_EraseRootFromParent_Done,
     /* 621715 */   // Label 7812: @621715
     /* 621715 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(621813), // Rule ID 13424 //
     /* 621720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621767 */     // MIs[3] src1
     /* 621767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621772 */     // MIs[3] src0
     /* 621772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621779 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621811 */     GIR_RootConstrainSelectedInstOperands,
     /* 621812 */     // GIR_Coverage, 13424,
     /* 621812 */     GIR_EraseRootFromParent_Done,
     /* 621813 */   // Label 7813: @621813
     /* 621813 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(621911), // Rule ID 13425 //
     /* 621818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621865 */     // MIs[3] src0
     /* 621865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621870 */     // MIs[3] src1
     /* 621870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621877 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621909 */     GIR_RootConstrainSelectedInstOperands,
     /* 621910 */     // GIR_Coverage, 13425,
     /* 621910 */     GIR_EraseRootFromParent_Done,
     /* 621911 */   // Label 7814: @621911
     /* 621911 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(622009), // Rule ID 13426 //
     /* 621916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621963 */     // MIs[3] src1
     /* 621963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621968 */     // MIs[3] src0
     /* 621968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621975 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 622001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622007 */     GIR_RootConstrainSelectedInstOperands,
     /* 622008 */     // GIR_Coverage, 13426,
     /* 622008 */     GIR_EraseRootFromParent_Done,
     /* 622009 */   // Label 7815: @622009
     /* 622009 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(622107), // Rule ID 7766 //
     /* 622014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622061 */     // MIs[3] src0
     /* 622061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622066 */     // MIs[3] src1
     /* 622066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622073 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622105 */     GIR_RootConstrainSelectedInstOperands,
     /* 622106 */     // GIR_Coverage, 7766,
     /* 622106 */     GIR_EraseRootFromParent_Done,
     /* 622107 */   // Label 7816: @622107
     /* 622107 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(622205), // Rule ID 7770 //
     /* 622112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622159 */     // MIs[3] src0
     /* 622159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622164 */     // MIs[3] src1
     /* 622164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622171 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622203 */     GIR_RootConstrainSelectedInstOperands,
     /* 622204 */     // GIR_Coverage, 7770,
     /* 622204 */     GIR_EraseRootFromParent_Done,
     /* 622205 */   // Label 7817: @622205
     /* 622205 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(622303), // Rule ID 7774 //
     /* 622210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622257 */     // MIs[3] src0
     /* 622257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622262 */     // MIs[3] src1
     /* 622262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622269 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622301 */     GIR_RootConstrainSelectedInstOperands,
     /* 622302 */     // GIR_Coverage, 7774,
     /* 622302 */     GIR_EraseRootFromParent_Done,
     /* 622303 */   // Label 7818: @622303
     /* 622303 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(622401), // Rule ID 13292 //
     /* 622308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622355 */     // MIs[3] src1
     /* 622355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622360 */     // MIs[3] src0
     /* 622360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622367 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622399 */     GIR_RootConstrainSelectedInstOperands,
     /* 622400 */     // GIR_Coverage, 13292,
     /* 622400 */     GIR_EraseRootFromParent_Done,
     /* 622401 */   // Label 7819: @622401
     /* 622401 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(622499), // Rule ID 13295 //
     /* 622406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622453 */     // MIs[3] src0
     /* 622453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622458 */     // MIs[3] src1
     /* 622458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622465 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622497 */     GIR_RootConstrainSelectedInstOperands,
     /* 622498 */     // GIR_Coverage, 13295,
     /* 622498 */     GIR_EraseRootFromParent_Done,
     /* 622499 */   // Label 7820: @622499
     /* 622499 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(622597), // Rule ID 13296 //
     /* 622504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622551 */     // MIs[3] src1
     /* 622551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622556 */     // MIs[3] src0
     /* 622556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622563 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622595 */     GIR_RootConstrainSelectedInstOperands,
     /* 622596 */     // GIR_Coverage, 13296,
     /* 622596 */     GIR_EraseRootFromParent_Done,
     /* 622597 */   // Label 7821: @622597
     /* 622597 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(622695), // Rule ID 13352 //
     /* 622602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622649 */     // MIs[3] src1
     /* 622649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622654 */     // MIs[3] src0
     /* 622654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622661 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622693 */     GIR_RootConstrainSelectedInstOperands,
     /* 622694 */     // GIR_Coverage, 13352,
     /* 622694 */     GIR_EraseRootFromParent_Done,
     /* 622695 */   // Label 7822: @622695
     /* 622695 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(622793), // Rule ID 13355 //
     /* 622700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622747 */     // MIs[3] src0
     /* 622747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622752 */     // MIs[3] src1
     /* 622752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622759 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622791 */     GIR_RootConstrainSelectedInstOperands,
     /* 622792 */     // GIR_Coverage, 13355,
     /* 622792 */     GIR_EraseRootFromParent_Done,
     /* 622793 */   // Label 7823: @622793
     /* 622793 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(622891), // Rule ID 13356 //
     /* 622798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622845 */     // MIs[3] src1
     /* 622845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622850 */     // MIs[3] src0
     /* 622850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622857 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622889 */     GIR_RootConstrainSelectedInstOperands,
     /* 622890 */     // GIR_Coverage, 13356,
     /* 622890 */     GIR_EraseRootFromParent_Done,
     /* 622891 */   // Label 7824: @622891
     /* 622891 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(622989), // Rule ID 13412 //
     /* 622896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622943 */     // MIs[3] src1
     /* 622943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622948 */     // MIs[3] src0
     /* 622948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622955 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622987 */     GIR_RootConstrainSelectedInstOperands,
     /* 622988 */     // GIR_Coverage, 13412,
     /* 622988 */     GIR_EraseRootFromParent_Done,
     /* 622989 */   // Label 7825: @622989
     /* 622989 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(623087), // Rule ID 13415 //
     /* 622994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 623037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623041 */     // MIs[3] src0
     /* 623041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623046 */     // MIs[3] src1
     /* 623046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623053 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 623056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 623079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623085 */     GIR_RootConstrainSelectedInstOperands,
     /* 623086 */     // GIR_Coverage, 13415,
     /* 623086 */     GIR_EraseRootFromParent_Done,
     /* 623087 */   // Label 7826: @623087
     /* 623087 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(623185), // Rule ID 13416 //
     /* 623092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 623135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623139 */     // MIs[3] src1
     /* 623139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623144 */     // MIs[3] src0
     /* 623144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623151 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 623154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 623177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623183 */     GIR_RootConstrainSelectedInstOperands,
     /* 623184 */     // GIR_Coverage, 13416,
     /* 623184 */     GIR_EraseRootFromParent_Done,
     /* 623185 */   // Label 7827: @623185
     /* 623185 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(623283), // Rule ID 13293 //
     /* 623190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623237 */     // MIs[3] src0
     /* 623237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623242 */     // MIs[3] src1
     /* 623242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623249 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623281 */     GIR_RootConstrainSelectedInstOperands,
     /* 623282 */     // GIR_Coverage, 13293,
     /* 623282 */     GIR_EraseRootFromParent_Done,
     /* 623283 */   // Label 7828: @623283
     /* 623283 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(623381), // Rule ID 13294 //
     /* 623288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623335 */     // MIs[3] src1
     /* 623335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623340 */     // MIs[3] src0
     /* 623340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623347 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623379 */     GIR_RootConstrainSelectedInstOperands,
     /* 623380 */     // GIR_Coverage, 13294,
     /* 623380 */     GIR_EraseRootFromParent_Done,
     /* 623381 */   // Label 7829: @623381
     /* 623381 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(623479), // Rule ID 13297 //
     /* 623386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623433 */     // MIs[3] src0
     /* 623433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623438 */     // MIs[3] src1
     /* 623438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623445 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623477 */     GIR_RootConstrainSelectedInstOperands,
     /* 623478 */     // GIR_Coverage, 13297,
     /* 623478 */     GIR_EraseRootFromParent_Done,
     /* 623479 */   // Label 7830: @623479
     /* 623479 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(623577), // Rule ID 13298 //
     /* 623484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623531 */     // MIs[3] src1
     /* 623531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623536 */     // MIs[3] src0
     /* 623536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623543 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623575 */     GIR_RootConstrainSelectedInstOperands,
     /* 623576 */     // GIR_Coverage, 13298,
     /* 623576 */     GIR_EraseRootFromParent_Done,
     /* 623577 */   // Label 7831: @623577
     /* 623577 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(623675), // Rule ID 13353 //
     /* 623582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623629 */     // MIs[3] src0
     /* 623629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623634 */     // MIs[3] src1
     /* 623634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623641 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623673 */     GIR_RootConstrainSelectedInstOperands,
     /* 623674 */     // GIR_Coverage, 13353,
     /* 623674 */     GIR_EraseRootFromParent_Done,
     /* 623675 */   // Label 7832: @623675
     /* 623675 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(623773), // Rule ID 13354 //
     /* 623680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623727 */     // MIs[3] src1
     /* 623727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623732 */     // MIs[3] src0
     /* 623732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623739 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623771 */     GIR_RootConstrainSelectedInstOperands,
     /* 623772 */     // GIR_Coverage, 13354,
     /* 623772 */     GIR_EraseRootFromParent_Done,
     /* 623773 */   // Label 7833: @623773
     /* 623773 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(623871), // Rule ID 13357 //
     /* 623778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623825 */     // MIs[3] src0
     /* 623825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623830 */     // MIs[3] src1
     /* 623830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623837 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623869 */     GIR_RootConstrainSelectedInstOperands,
     /* 623870 */     // GIR_Coverage, 13357,
     /* 623870 */     GIR_EraseRootFromParent_Done,
     /* 623871 */   // Label 7834: @623871
     /* 623871 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(623969), // Rule ID 13358 //
     /* 623876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623923 */     // MIs[3] src1
     /* 623923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623928 */     // MIs[3] src0
     /* 623928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623935 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623967 */     GIR_RootConstrainSelectedInstOperands,
     /* 623968 */     // GIR_Coverage, 13358,
     /* 623968 */     GIR_EraseRootFromParent_Done,
     /* 623969 */   // Label 7835: @623969
     /* 623969 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(624067), // Rule ID 13413 //
     /* 623974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 624017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624021 */     // MIs[3] src0
     /* 624021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624026 */     // MIs[3] src1
     /* 624026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624033 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 624045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 624052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 624059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624065 */     GIR_RootConstrainSelectedInstOperands,
     /* 624066 */     // GIR_Coverage, 13413,
     /* 624066 */     GIR_EraseRootFromParent_Done,
     /* 624067 */   // Label 7836: @624067
     /* 624067 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(624165), // Rule ID 13414 //
     /* 624072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 624115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624119 */     // MIs[3] src1
     /* 624119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624124 */     // MIs[3] src0
     /* 624124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624131 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 624143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 624150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 624157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624163 */     GIR_RootConstrainSelectedInstOperands,
     /* 624164 */     // GIR_Coverage, 13414,
     /* 624164 */     GIR_EraseRootFromParent_Done,
     /* 624165 */   // Label 7837: @624165
     /* 624165 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(624263), // Rule ID 13417 //
     /* 624170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 624213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624217 */     // MIs[3] src0
     /* 624217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624222 */     // MIs[3] src1
     /* 624222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624229 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 624241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 624248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 624255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624261 */     GIR_RootConstrainSelectedInstOperands,
     /* 624262 */     // GIR_Coverage, 13417,
     /* 624262 */     GIR_EraseRootFromParent_Done,
     /* 624263 */   // Label 7838: @624263
     /* 624263 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(624361), // Rule ID 13418 //
     /* 624268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 624311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624315 */     // MIs[3] src1
     /* 624315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624320 */     // MIs[3] src0
     /* 624320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624327 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 624339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 624346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 624353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624359 */     GIR_RootConstrainSelectedInstOperands,
     /* 624360 */     // GIR_Coverage, 13418,
     /* 624360 */     GIR_EraseRootFromParent_Done,
     /* 624361 */   // Label 7839: @624361
     /* 624361 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(624417), // Rule ID 892 //
     /* 624366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 624369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 624380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 624387 */     // (umax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 624387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_t16_e64),
     /* 624390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 624397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 624402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 624407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 624412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624415 */     GIR_RootConstrainSelectedInstOperands,
     /* 624416 */     // GIR_Coverage, 892,
     /* 624416 */     GIR_EraseRootFromParent_Done,
     /* 624417 */   // Label 7840: @624417
     /* 624417 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(624440), // Rule ID 891 //
     /* 624422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 624425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624429 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 624429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 624434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 624438 */     GIR_RootConstrainSelectedInstOperands,
     /* 624439 */     // GIR_Coverage, 891,
     /* 624439 */     GIR_Done,
     /* 624440 */   // Label 7841: @624440
     /* 624440 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(624463), // Rule ID 893 //
     /* 624445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 624448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624452 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 624452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_fake16_e64),
     /* 624457 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 624461 */     GIR_RootConstrainSelectedInstOperands,
     /* 624462 */     // GIR_Coverage, 893,
     /* 624462 */     GIR_Done,
     /* 624463 */   // Label 7842: @624463
     /* 624463 */   GIM_Reject,
     /* 624464 */ // Label 7791: @624464
     /* 624464 */ GIM_Reject,
     /* 624465 */ // Label 7788: @624465
     /* 624465 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(625909),
     /* 624470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 624473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 624476 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(624556), // Rule ID 11282 //
     /* 624481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624525 */     // MIs[3] src0
     /* 624525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624530 */     // MIs[3] src1
     /* 624530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624537 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624554 */     GIR_RootConstrainSelectedInstOperands,
     /* 624555 */     // GIR_Coverage, 11282,
     /* 624555 */     GIR_EraseRootFromParent_Done,
     /* 624556 */   // Label 7844: @624556
     /* 624556 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(624636), // Rule ID 11283 //
     /* 624561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624605 */     // MIs[3] src1
     /* 624605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624610 */     // MIs[3] src0
     /* 624610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624617 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624634 */     GIR_RootConstrainSelectedInstOperands,
     /* 624635 */     // GIR_Coverage, 11283,
     /* 624635 */     GIR_EraseRootFromParent_Done,
     /* 624636 */   // Label 7845: @624636
     /* 624636 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(624716), // Rule ID 11284 //
     /* 624641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624685 */     // MIs[3] src0
     /* 624685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624690 */     // MIs[3] src1
     /* 624690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624697 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624714 */     GIR_RootConstrainSelectedInstOperands,
     /* 624715 */     // GIR_Coverage, 11284,
     /* 624715 */     GIR_EraseRootFromParent_Done,
     /* 624716 */   // Label 7846: @624716
     /* 624716 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(624796), // Rule ID 11285 //
     /* 624721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624765 */     // MIs[3] src1
     /* 624765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624770 */     // MIs[3] src0
     /* 624770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624777 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624794 */     GIR_RootConstrainSelectedInstOperands,
     /* 624795 */     // GIR_Coverage, 11285,
     /* 624795 */     GIR_EraseRootFromParent_Done,
     /* 624796 */   // Label 7847: @624796
     /* 624796 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(624876), // Rule ID 11286 //
     /* 624801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624845 */     // MIs[3] src0
     /* 624845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624850 */     // MIs[3] src1
     /* 624850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624857 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624874 */     GIR_RootConstrainSelectedInstOperands,
     /* 624875 */     // GIR_Coverage, 11286,
     /* 624875 */     GIR_EraseRootFromParent_Done,
     /* 624876 */   // Label 7848: @624876
     /* 624876 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(624956), // Rule ID 11287 //
     /* 624881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624925 */     // MIs[3] src1
     /* 624925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624930 */     // MIs[3] src0
     /* 624930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624937 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624954 */     GIR_RootConstrainSelectedInstOperands,
     /* 624955 */     // GIR_Coverage, 11287,
     /* 624955 */     GIR_EraseRootFromParent_Done,
     /* 624956 */   // Label 7849: @624956
     /* 624956 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(625036), // Rule ID 11288 //
     /* 624961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625005 */     // MIs[3] src0
     /* 625005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625010 */     // MIs[3] src1
     /* 625010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625017 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625034 */     GIR_RootConstrainSelectedInstOperands,
     /* 625035 */     // GIR_Coverage, 11288,
     /* 625035 */     GIR_EraseRootFromParent_Done,
     /* 625036 */   // Label 7850: @625036
     /* 625036 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(625116), // Rule ID 11289 //
     /* 625041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625085 */     // MIs[3] src1
     /* 625085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625090 */     // MIs[3] src0
     /* 625090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625097 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625114 */     GIR_RootConstrainSelectedInstOperands,
     /* 625115 */     // GIR_Coverage, 11289,
     /* 625115 */     GIR_EraseRootFromParent_Done,
     /* 625116 */   // Label 7851: @625116
     /* 625116 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(625196), // Rule ID 7583 //
     /* 625121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625165 */     // MIs[3] src0
     /* 625165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625170 */     // MIs[3] src1
     /* 625170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625177 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625194 */     GIR_RootConstrainSelectedInstOperands,
     /* 625195 */     // GIR_Coverage, 7583,
     /* 625195 */     GIR_EraseRootFromParent_Done,
     /* 625196 */   // Label 7852: @625196
     /* 625196 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(625276), // Rule ID 11275 //
     /* 625201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625245 */     // MIs[3] src1
     /* 625245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625250 */     // MIs[3] src0
     /* 625250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625257 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625274 */     GIR_RootConstrainSelectedInstOperands,
     /* 625275 */     // GIR_Coverage, 11275,
     /* 625275 */     GIR_EraseRootFromParent_Done,
     /* 625276 */   // Label 7853: @625276
     /* 625276 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(625356), // Rule ID 11278 //
     /* 625281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625325 */     // MIs[3] src0
     /* 625325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625330 */     // MIs[3] src1
     /* 625330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625337 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625354 */     GIR_RootConstrainSelectedInstOperands,
     /* 625355 */     // GIR_Coverage, 11278,
     /* 625355 */     GIR_EraseRootFromParent_Done,
     /* 625356 */   // Label 7854: @625356
     /* 625356 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(625436), // Rule ID 11279 //
     /* 625361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625405 */     // MIs[3] src1
     /* 625405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625410 */     // MIs[3] src0
     /* 625410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625417 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625434 */     GIR_RootConstrainSelectedInstOperands,
     /* 625435 */     // GIR_Coverage, 11279,
     /* 625435 */     GIR_EraseRootFromParent_Done,
     /* 625436 */   // Label 7855: @625436
     /* 625436 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(625516), // Rule ID 11276 //
     /* 625441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625485 */     // MIs[3] src0
     /* 625485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625490 */     // MIs[3] src1
     /* 625490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625497 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625514 */     GIR_RootConstrainSelectedInstOperands,
     /* 625515 */     // GIR_Coverage, 11276,
     /* 625515 */     GIR_EraseRootFromParent_Done,
     /* 625516 */   // Label 7856: @625516
     /* 625516 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(625596), // Rule ID 11277 //
     /* 625521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625565 */     // MIs[3] src1
     /* 625565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625570 */     // MIs[3] src0
     /* 625570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625577 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625594 */     GIR_RootConstrainSelectedInstOperands,
     /* 625595 */     // GIR_Coverage, 11277,
     /* 625595 */     GIR_EraseRootFromParent_Done,
     /* 625596 */   // Label 7857: @625596
     /* 625596 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(625676), // Rule ID 11280 //
     /* 625601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625645 */     // MIs[3] src0
     /* 625645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625650 */     // MIs[3] src1
     /* 625650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625657 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625674 */     GIR_RootConstrainSelectedInstOperands,
     /* 625675 */     // GIR_Coverage, 11280,
     /* 625675 */     GIR_EraseRootFromParent_Done,
     /* 625676 */   // Label 7858: @625676
     /* 625676 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(625756), // Rule ID 11281 //
     /* 625681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625725 */     // MIs[3] src1
     /* 625725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625730 */     // MIs[3] src0
     /* 625730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625737 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625754 */     GIR_RootConstrainSelectedInstOperands,
     /* 625755 */     // GIR_Coverage, 11281,
     /* 625755 */     GIR_EraseRootFromParent_Done,
     /* 625756 */   // Label 7859: @625756
     /* 625756 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(625809), // Rule ID 7717 //
     /* 625761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 625764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625784 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 625786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34989),
     /* 625790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 625792 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34989>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 625795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 625807 */     GIR_RootConstrainSelectedInstOperands,
     /* 625808 */     // GIR_Coverage, 7717,
     /* 625808 */     GIR_EraseRootFromParent_Done,
     /* 625809 */   // Label 7860: @625809
     /* 625809 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(625862), // Rule ID 13243 //
     /* 625814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 625817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 625825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625837 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 625839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34989),
     /* 625843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 625845 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>)<<P:Predicate_anonymous_34989>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 625848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 625860 */     GIR_RootConstrainSelectedInstOperands,
     /* 625861 */     // GIR_Coverage, 13243,
     /* 625861 */     GIR_EraseRootFromParent_Done,
     /* 625862 */   // Label 7861: @625862
     /* 625862 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(625888), // Rule ID 50 //
     /* 625867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13750),
     /* 625875 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13750>>  =>  (S_MAX_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 625875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_U32),
     /* 625880 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 625886 */     GIR_RootConstrainSelectedInstOperands,
     /* 625887 */     // GIR_Coverage, 50,
     /* 625887 */     GIR_Done,
     /* 625888 */   // Label 7862: @625888
     /* 625888 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(625908), // Rule ID 807 //
     /* 625893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625897 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 625897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U32_e64),
     /* 625902 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 625906 */     GIR_RootConstrainSelectedInstOperands,
     /* 625907 */     // GIR_Coverage, 807,
     /* 625907 */     GIR_Done,
     /* 625908 */   // Label 7863: @625908
     /* 625908 */   GIM_Reject,
     /* 625909 */ // Label 7843: @625909
     /* 625909 */ GIM_Reject,
     /* 625910 */ // Label 7789: @625910
     /* 625910 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(625981), // Rule ID 1103 //
     /* 625915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 625918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 625921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 625932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 625939 */   // (umax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 625939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_U16),
     /* 625942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 625949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 625954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 625959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 625964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625979 */   GIR_RootConstrainSelectedInstOperands,
     /* 625980 */   // GIR_Coverage, 1103,
     /* 625980 */   GIR_EraseRootFromParent_Done,
     /* 625981 */ // Label 7864: @625981
     /* 625981 */ GIM_Reject,
     /* 625982 */ // Label 7790: @625982
     /* 625982 */ GIM_Reject,
     /* 625983 */ // Label 92: @625983
     /* 625983 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(626119),
     /* 625988 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 625991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 625994 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(626043), // Rule ID 7443 //
     /* 625999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /* 626002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34781),
     /* 626010 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34781>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 626010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e32),
     /* 626017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 626025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 626029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 626034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 626041 */     GIR_RootConstrainSelectedInstOperands,
     /* 626042 */     // GIR_Coverage, 7443,
     /* 626042 */     GIR_EraseRootFromParent_Done,
     /* 626043 */   // Label 7866: @626043
     /* 626043 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(626069), // Rule ID 23 //
     /* 626048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /* 626056 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 626056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 626061 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 626067 */     GIR_RootConstrainSelectedInstOperands,
     /* 626068 */     // GIR_Coverage, 23,
     /* 626068 */     GIR_Done,
     /* 626069 */   // Label 7867: @626069
     /* 626069 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(626118), // Rule ID 7442 //
     /* 626074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34781),
     /* 626082 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34781>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_CO_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 626082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e32),
     /* 626089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 626097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 626101 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::VCC*/0,
     /* 626104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 626109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 626116 */     GIR_RootConstrainSelectedInstOperands,
     /* 626117 */     // GIR_Coverage, 7442,
     /* 626117 */     GIR_EraseRootFromParent_Done,
     /* 626118 */   // Label 7868: @626118
     /* 626118 */   GIM_Reject,
     /* 626119 */ // Label 7865: @626119
     /* 626119 */ GIM_Reject,
     /* 626120 */ // Label 93: @626120
     /* 626120 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(626153),
     /* 626125 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 626128 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(626140), // Rule ID 179 //
     /* 626133 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH (bb:{ *:[Other] }):$simm16)
     /* 626133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH),
     /* 626138 */     GIR_RootConstrainSelectedInstOperands,
     /* 626139 */     // GIR_Coverage, 179,
     /* 626139 */     GIR_Done,
     /* 626140 */   // Label 7870: @626140
     /* 626140 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(626152), // Rule ID 180 //
     /* 626145 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH_pad_s_nop (bb:{ *:[Other] }):$simm16)
     /* 626145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH_pad_s_nop),
     /* 626150 */     GIR_RootConstrainSelectedInstOperands,
     /* 626151 */     // GIR_Coverage, 180,
     /* 626151 */     GIR_Done,
     /* 626152 */   // Label 7871: @626152
     /* 626152 */   GIM_Reject,
     /* 626153 */ // Label 7869: @626153
     /* 626153 */ GIM_Reject,
     /* 626154 */ // Label 94: @626154
     /* 626154 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(626252),
     /* 626159 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 626162 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7875*/ GIMT_Encode4(626251),
     /* 626173 */   /*GILLT_s32*//*Label 7873*/ GIMT_Encode4(626181),
     /* 626177 */   /*GILLT_s64*//*Label 7874*/ GIMT_Encode4(626230),
     /* 626181 */   // Label 7873: @626181
     /* 626181 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(626201), // Rule ID 10 //
     /* 626186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13727),
     /* 626194 */     // (cttz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13727>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 626199 */     GIR_RootConstrainSelectedInstOperands,
     /* 626200 */     // GIR_Coverage, 10,
     /* 626200 */     GIR_Done,
     /* 626201 */   // Label 7876: @626201
     /* 626201 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(626229), // Rule ID 683 //
     /* 626206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 626217 */     // (cttz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 626220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 626227 */     GIR_RootConstrainSelectedInstOperands,
     /* 626228 */     // GIR_Coverage, 683,
     /* 626228 */     GIR_EraseRootFromParent_Done,
     /* 626229 */   // Label 7877: @626229
     /* 626229 */   GIM_Reject,
     /* 626230 */   // Label 7874: @626230
     /* 626230 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(626250), // Rule ID 8 //
     /* 626235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13727),
     /* 626243 */     // (cttz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13727>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 626243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 626248 */     GIR_RootConstrainSelectedInstOperands,
     /* 626249 */     // GIR_Coverage, 8,
     /* 626249 */     GIR_Done,
     /* 626250 */   // Label 7878: @626250
     /* 626250 */   GIM_Reject,
     /* 626251 */   // Label 7875: @626251
     /* 626251 */   GIM_Reject,
     /* 626252 */ // Label 7872: @626252
     /* 626252 */ GIM_Reject,
     /* 626253 */ // Label 95: @626253
     /* 626253 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(626354),
     /* 626258 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 626261 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7882*/ GIMT_Encode4(626322),
     /* 626272 */   /*GILLT_s32*//*Label 7880*/ GIMT_Encode4(626280),
     /* 626276 */   /*GILLT_s64*//*Label 7881*/ GIMT_Encode4(626301),
     /* 626280 */   // Label 7880: @626280
     /* 626280 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(626300), // Rule ID 12 //
     /* 626285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 626293 */     // (ctlz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13728>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 626298 */     GIR_RootConstrainSelectedInstOperands,
     /* 626299 */     // GIR_Coverage, 12,
     /* 626299 */     GIR_Done,
     /* 626300 */   // Label 7883: @626300
     /* 626300 */   GIM_Reject,
     /* 626301 */   // Label 7881: @626301
     /* 626301 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(626321), // Rule ID 14 //
     /* 626306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 626314 */     // (ctlz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13728>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 626314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 626319 */     GIR_RootConstrainSelectedInstOperands,
     /* 626320 */     // GIR_Coverage, 14,
     /* 626320 */     GIR_Done,
     /* 626321 */   // Label 7884: @626321
     /* 626321 */   GIM_Reject,
     /* 626322 */   // Label 7882: @626322
     /* 626322 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(626353), // Rule ID 681 //
     /* 626327 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 626341 */     // (ctlz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 626344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 626351 */     GIR_RootConstrainSelectedInstOperands,
     /* 626352 */     // GIR_Coverage, 681,
     /* 626352 */     GIR_EraseRootFromParent_Done,
     /* 626353 */   // Label 7885: @626353
     /* 626353 */   GIM_Reject,
     /* 626354 */ // Label 7879: @626354
     /* 626354 */ GIM_Reject,
     /* 626355 */ // Label 96: @626355
     /* 626355 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7888*/ GIMT_Encode4(626569),
     /* 626366 */ /*GILLT_s32*//*Label 7886*/ GIMT_Encode4(626374),
     /* 626370 */ /*GILLT_s64*//*Label 7887*/ GIMT_Encode4(626461),
     /* 626374 */ // Label 7886: @626374
     /* 626374 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(626403), // Rule ID 6 //
     /* 626379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626386 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13726),
     /* 626390 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13726>>  =>  (S_BCNT1_I32_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 626390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B32),
     /* 626395 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 626401 */   GIR_RootConstrainSelectedInstOperands,
     /* 626402 */   // GIR_Coverage, 6,
     /* 626402 */   GIR_Done,
     /* 626403 */ // Label 7889: @626403
     /* 626403 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(626432), // Rule ID 7 //
     /* 626408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 626411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626415 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13726),
     /* 626419 */   // (ctpop:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13726>>  =>  (S_BCNT1_I32_B64:{ *:[i32] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 626419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 626424 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 626430 */   GIR_RootConstrainSelectedInstOperands,
     /* 626431 */   // GIR_Coverage, 7,
     /* 626431 */   GIR_Done,
     /* 626432 */ // Label 7890: @626432
     /* 626432 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(626460), // Rule ID 7021 //
     /* 626437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626444 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34193),
     /* 626448 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34193>>  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$popcnt, 0:{ *:[i32] })
     /* 626448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /* 626451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626453 */   GIR_RootToRootCopy, /*OpIdx*/1, // popcnt
     /* 626455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626458 */   GIR_RootConstrainSelectedInstOperands,
     /* 626459 */   // GIR_Coverage, 7021,
     /* 626459 */   GIR_EraseRootFromParent_Done,
     /* 626460 */ // Label 7891: @626460
     /* 626460 */ GIM_Reject,
     /* 626461 */ // Label 7887: @626461
     /* 626461 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(626568), // Rule ID 1868 //
     /* 626466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 626469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 626473 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13726),
     /* 626477 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$src)<<P:Predicate_anonymous_13726>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_BCNT1_I32_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i64] }:$src), SReg_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 626477 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 626480 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626484 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626489 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626494 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 626497 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 626501 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 626510 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 626513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 626518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 626530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 626538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 626540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626543 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 626546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 626549 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 626552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 626557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 626562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 626567 */   // GIR_Coverage, 1868,
     /* 626567 */   GIR_EraseRootFromParent_Done,
     /* 626568 */ // Label 7892: @626568
     /* 626568 */ GIM_Reject,
     /* 626569 */ // Label 7888: @626569
     /* 626569 */ GIM_Reject,
     /* 626570 */ // Label 97: @626570
     /* 626570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7897*/ GIMT_Encode4(628318),
     /* 626581 */ /*GILLT_s16*//*Label 7893*/ GIMT_Encode4(626597),
     /* 626585 */ /*GILLT_s32*//*Label 7894*/ GIMT_Encode4(626809),
     /* 626589 */ /*GILLT_s64*//*Label 7895*/ GIMT_Encode4(627096),
     /* 626593 */ /*GILLT_v2s16*//*Label 7896*/ GIMT_Encode4(628263),
     /* 626597 */ // Label 7893: @626597
     /* 626597 */ GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(626808),
     /* 626602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 626605 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(626656), // Rule ID 7462 //
     /* 626610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 626613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626617 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 626617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626629 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 626639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626649 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626654 */     GIR_RootConstrainSelectedInstOperands,
     /* 626655 */     // GIR_Coverage, 7462,
     /* 626655 */     GIR_EraseRootFromParent_Done,
     /* 626656 */   // Label 7899: @626656
     /* 626656 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(626707), // Rule ID 7464 //
     /* 626661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 626664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626668 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 626668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626680 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 626690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626700 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626705 */     GIR_RootConstrainSelectedInstOperands,
     /* 626706 */     // GIR_Coverage, 7464,
     /* 626706 */     GIR_EraseRootFromParent_Done,
     /* 626707 */   // Label 7900: @626707
     /* 626707 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(626807), // Rule ID 7466 //
     /* 626712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 626715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626719 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i16] } (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] })), lo16:{ *:[i32] })
     /* 626719 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626722 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626726 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626731 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(202113025),
     /* 626741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626755 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 626776 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 626779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 626782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 626789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::lo16),
     /* 626796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626806 */     // GIR_Coverage, 7466,
     /* 626806 */     GIR_EraseRootFromParent_Done,
     /* 626807 */   // Label 7901: @626807
     /* 626807 */   GIM_Reject,
     /* 626808 */ // Label 7898: @626808
     /* 626808 */ GIM_Reject,
     /* 626809 */ // Label 7894: @626809
     /* 626809 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(627095),
     /* 626814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626821 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(626868), // Rule ID 7460 //
     /* 626826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 626829 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] }))
     /* 626829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626841 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(66051),
     /* 626851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626861 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626866 */     GIR_RootConstrainSelectedInstOperands,
     /* 626867 */     // GIR_Coverage, 7460,
     /* 626867 */     GIR_EraseRootFromParent_Done,
     /* 626868 */   // Label 7903: @626868
     /* 626868 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(626966), // Rule ID 7456 //
     /* 626873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 626876 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 8:{ *:[i32] }))
     /* 626876 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626879 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 626883 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626888 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626892 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626896 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 626899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 626908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626913 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626917 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626921 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 626924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626938 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 626948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 626953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 626961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 626964 */     GIR_RootConstrainSelectedInstOperands,
     /* 626965 */     // GIR_Coverage, 7456,
     /* 626965 */     GIR_EraseRootFromParent_Done,
     /* 626966 */   // Label 7904: @626966
     /* 626966 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(627094), // Rule ID 7457 //
     /* 626971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 626974 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 626974 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626977 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 626981 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626986 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626989 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626993 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626996 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 627000 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627003 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 627006 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627009 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 627014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 627017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627026 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 627029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 627033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 627036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 627040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 627043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 627046 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 627049 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 627052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 627054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627066 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 627076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 627078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 627086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 627089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 627092 */     GIR_RootConstrainSelectedInstOperands,
     /* 627093 */     // GIR_Coverage, 7457,
     /* 627093 */     GIR_EraseRootFromParent_Done,
     /* 627094 */   // Label 7905: @627094
     /* 627094 */   GIM_Reject,
     /* 627095 */ // Label 7902: @627095
     /* 627095 */ GIM_Reject,
     /* 627096 */ // Label 7895: @627096
     /* 627096 */ GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(628262),
     /* 627101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 627104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627108 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(627299), // Rule ID 7461 //
     /* 627113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 627116 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub0:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub1:{ *:[i32] })
     /* 627116 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 627119 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627123 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627128 */     GIR_AddImm, /*InsnID*/6, /*Imm*/GIMT_Encode8(66051),
     /* 627138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 627140 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 627143 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627147 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627152 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627158 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627163 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 627171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 627175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627180 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 627183 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 627186 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/5,
     /* 627189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 627191 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 627194 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627198 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627203 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(66051),
     /* 627213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 627215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 627218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627227 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 627250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 627258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 627261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 627264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 627266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 627269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 627271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 627274 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 627277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 627280 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 627283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627298 */     // GIR_Coverage, 7461,
     /* 627298 */     GIR_EraseRootFromParent_Done,
     /* 627299 */   // Label 7907: @627299
     /* 627299 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(627750), // Rule ID 7458 //
     /* 627304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 627307 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 8:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 8:{ *:[i32] })), sub1:{ *:[i32] })
     /* 627307 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 627310 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627314 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627319 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627325 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627330 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627335 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 627338 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627342 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627347 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627353 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627358 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627363 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 627366 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627370 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627375 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 627378 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 627381 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 627384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 627386 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 627389 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627393 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627398 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627404 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627409 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627414 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 627417 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627421 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627426 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627432 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627437 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627442 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 627445 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627449 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627454 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 627457 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 627460 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 627463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 627465 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 627468 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627472 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627477 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 627487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 627489 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 627492 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627496 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627501 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 627504 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 627507 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 627510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 627512 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 627515 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627519 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627524 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627530 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627535 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627540 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 627543 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627547 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627552 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627558 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627563 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627568 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 627571 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627575 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627580 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 627583 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 627586 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 627589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 627591 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 627594 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627598 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627603 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627609 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627614 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627619 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 627622 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627626 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627631 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627637 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627642 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627647 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 627650 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627654 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627659 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 627662 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 627665 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 627668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 627670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 627673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627682 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 627692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 627694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 627709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 627712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 627715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 627717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 627720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 627722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 627725 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 627728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 627731 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 627734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627749 */     // GIR_Coverage, 7458,
     /* 627749 */     GIR_EraseRootFromParent_Done,
     /* 627750 */   // Label 7908: @627750
     /* 627750 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(628261), // Rule ID 7459 //
     /* 627755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 627758 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 627758 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 627761 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627765 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627770 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627776 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627781 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627786 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 627789 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627793 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627798 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627804 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627809 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627814 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 627817 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627821 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627826 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627829 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 627832 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627835 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 627838 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627841 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 627844 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627847 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 627852 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 627855 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627859 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627864 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627870 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627875 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627880 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 627883 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627887 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627892 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627898 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627903 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627908 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 627911 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627915 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627920 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627923 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 627926 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627929 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 627932 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627935 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 627938 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627941 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 627946 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 627949 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627953 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627958 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 627968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 627970 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 627973 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627977 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627982 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 627985 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 627988 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 627991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 627993 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 627996 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628000 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628005 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628011 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628016 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628021 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 628024 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628028 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628033 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628039 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628044 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628049 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 628052 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 628056 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628061 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 628064 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 628067 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 628070 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 628073 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 628076 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 628079 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 628082 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 628085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 628087 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 628090 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628094 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628099 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628105 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628110 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628115 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 628118 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628122 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628127 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628133 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628138 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 628146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 628150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628155 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 628158 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 628161 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 628164 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 628167 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 628170 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 628173 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 628176 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 628179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 628181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 628184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 628188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628193 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 628203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 628205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 628208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 628212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 628220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 628223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 628226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 628231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 628233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628236 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 628239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 628242 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 628245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628260 */     // GIR_Coverage, 7459,
     /* 628260 */     GIR_EraseRootFromParent_Done,
     /* 628261 */   // Label 7909: @628261
     /* 628261 */   GIM_Reject,
     /* 628262 */ // Label 7906: @628262
     /* 628262 */ GIM_Reject,
     /* 628263 */ // Label 7896: @628263
     /* 628263 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(628317), // Rule ID 7468 //
     /* 628268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 628271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 628274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628278 */   // (bswap:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$a, (S_MOV_B32:{ *:[i16] } 33751041:{ *:[i32] }))
     /* 628278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 628281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 628285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628290 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(33751041),
     /* 628300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 628305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628310 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 628312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628315 */   GIR_RootConstrainSelectedInstOperands,
     /* 628316 */   // GIR_Coverage, 7468,
     /* 628316 */   GIR_EraseRootFromParent_Done,
     /* 628317 */ // Label 7910: @628317
     /* 628317 */ GIM_Reject,
     /* 628318 */ // Label 7897: @628318
     /* 628318 */ GIM_Reject,
     /* 628319 */ // Label 98: @628319
     /* 628319 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7913*/ GIMT_Encode4(628566),
     /* 628330 */ /*GILLT_s32*//*Label 7911*/ GIMT_Encode4(628338),
     /* 628334 */ /*GILLT_s64*//*Label 7912*/ GIMT_Encode4(628400),
     /* 628338 */ // Label 7911: @628338
     /* 628338 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(628399),
     /* 628343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628346 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(628366), // Rule ID 4 //
     /* 628351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13725),
     /* 628359 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13725>>  =>  (S_BREV_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 628359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B32),
     /* 628364 */     GIR_RootConstrainSelectedInstOperands,
     /* 628365 */     // GIR_Coverage, 4,
     /* 628365 */     GIR_Done,
     /* 628366 */   // Label 7915: @628366
     /* 628366 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(628398), // Rule ID 680 //
     /* 628371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18332),
     /* 628379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628386 */     // (bitreverse:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_18332>>  =>  (V_BFREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 628386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628396 */     GIR_RootConstrainSelectedInstOperands,
     /* 628397 */     // GIR_Coverage, 680,
     /* 628397 */     GIR_EraseRootFromParent_Done,
     /* 628398 */   // Label 7916: @628398
     /* 628398 */   GIM_Reject,
     /* 628399 */ // Label 7914: @628399
     /* 628399 */ GIM_Reject,
     /* 628400 */ // Label 7912: @628400
     /* 628400 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(628565),
     /* 628405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 628408 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(628428), // Rule ID 5 //
     /* 628413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 628417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13725),
     /* 628421 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13725>>  =>  (S_BREV_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 628421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B64),
     /* 628426 */     GIR_RootConstrainSelectedInstOperands,
     /* 628427 */     // GIR_Coverage, 5,
     /* 628427 */     GIR_Done,
     /* 628428 */   // Label 7918: @628428
     /* 628428 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(628564), // Rule ID 7469 //
     /* 628433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18332),
     /* 628441 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$a)<<P:Predicate_anonymous_18332>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 628441 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 628444 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628448 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628453 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 628459 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628464 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628469 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 628472 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628476 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628481 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 628484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 628486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 628489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628498 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 628517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 628529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 628534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 628536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628539 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 628542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 628545 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 628548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628563 */     // GIR_Coverage, 7469,
     /* 628563 */     GIR_EraseRootFromParent_Done,
     /* 628564 */   // Label 7919: @628564
     /* 628564 */   GIM_Reject,
     /* 628565 */ // Label 7917: @628565
     /* 628565 */ GIM_Reject,
     /* 628566 */ // Label 7913: @628566
     /* 628566 */ GIM_Reject,
     /* 628567 */ // Label 99: @628567
     /* 628567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7923*/ GIMT_Encode4(628894),
     /* 628578 */ /*GILLT_s16*//*Label 7920*/ GIMT_Encode4(628590),
     /* 628582 */ /*GILLT_s32*//*Label 7921*/ GIMT_Encode4(628764),
     /* 628586 */ /*GILLT_s64*//*Label 7922*/ GIMT_Encode4(628844),
     /* 628590 */ // Label 7920: @628590
     /* 628590 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(628763),
     /* 628595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 628598 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(628625), // Rule ID 37 //
     /* 628603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 628606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13738),
     /* 628614 */     // (fceil:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13738>>  =>  (S_CEIL_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 628614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F16),
     /* 628619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 628623 */     GIR_RootConstrainSelectedInstOperands,
     /* 628624 */     // GIR_Coverage, 37,
     /* 628624 */     GIR_Done,
     /* 628625 */   // Label 7925: @628625
     /* 628625 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(628671), // Rule ID 768 //
     /* 628630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 628633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628644 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_e64),
     /* 628647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628669 */     GIR_RootConstrainSelectedInstOperands,
     /* 628670 */     // GIR_Coverage, 768,
     /* 628670 */     GIR_EraseRootFromParent_Done,
     /* 628671 */   // Label 7926: @628671
     /* 628671 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(628717), // Rule ID 770 //
     /* 628676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 628679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628690 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_fake16_e64),
     /* 628693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628715 */     GIR_RootConstrainSelectedInstOperands,
     /* 628716 */     // GIR_Coverage, 770,
     /* 628716 */     GIR_EraseRootFromParent_Done,
     /* 628717 */   // Label 7927: @628717
     /* 628717 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(628762), // Rule ID 769 //
     /* 628722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 628725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 628729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 628736 */     // (fceil:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CEIL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 628736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_t16_e64),
     /* 628739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628760 */     GIR_RootConstrainSelectedInstOperands,
     /* 628761 */     // GIR_Coverage, 769,
     /* 628761 */     GIR_EraseRootFromParent_Done,
     /* 628762 */   // Label 7928: @628762
     /* 628762 */   GIM_Reject,
     /* 628763 */ // Label 7924: @628763
     /* 628763 */ GIM_Reject,
     /* 628764 */ // Label 7921: @628764
     /* 628764 */ GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(628843),
     /* 628769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628772 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(628799), // Rule ID 32 //
     /* 628777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 628780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13738),
     /* 628788 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13738>>  =>  (S_CEIL_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 628788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F32),
     /* 628793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 628797 */     GIR_RootConstrainSelectedInstOperands,
     /* 628798 */     // GIR_Coverage, 32,
     /* 628798 */     GIR_Done,
     /* 628799 */   // Label 7930: @628799
     /* 628799 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(628842), // Rule ID 658 //
     /* 628804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628815 */     // (fceil:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F32_e64),
     /* 628818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628840 */     GIR_RootConstrainSelectedInstOperands,
     /* 628841 */     // GIR_Coverage, 658,
     /* 628841 */     GIR_EraseRootFromParent_Done,
     /* 628842 */   // Label 7931: @628842
     /* 628842 */   GIM_Reject,
     /* 628843 */ // Label 7929: @628843
     /* 628843 */ GIM_Reject,
     /* 628844 */ // Label 7922: @628844
     /* 628844 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(628893), // Rule ID 702 //
     /* 628849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 628852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 628855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628866 */   // (fceil:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F64_e64),
     /* 628869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628891 */   GIR_RootConstrainSelectedInstOperands,
     /* 628892 */   // GIR_Coverage, 702,
     /* 628892 */   GIR_EraseRootFromParent_Done,
     /* 628893 */ // Label 7932: @628893
     /* 628893 */ GIM_Reject,
     /* 628894 */ // Label 7923: @628894
     /* 628894 */ GIM_Reject,
     /* 628895 */ // Label 100: @628895
     /* 628895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7935*/ GIMT_Encode4(629186),
     /* 628906 */ /*GILLT_s16*//*Label 7933*/ GIMT_Encode4(628914),
     /* 628910 */ /*GILLT_s32*//*Label 7934*/ GIMT_Encode4(629132),
     /* 628914 */ // Label 7933: @628914
     /* 628914 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(629131),
     /* 628919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 628922 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(628993), // Rule ID 2697 //
     /* 628927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 628930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 628934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21503),
     /* 628938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628945 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21503>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 628945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 628948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 628952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 628984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 628992 */     // GIR_Coverage, 2697,
     /* 628992 */     GIR_EraseRootFromParent_Done,
     /* 628993 */   // Label 7937: @628993
     /* 628993 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(629039), // Rule ID 723 //
     /* 628998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629012 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 629015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629037 */     GIR_RootConstrainSelectedInstOperands,
     /* 629038 */     // GIR_Coverage, 723,
     /* 629038 */     GIR_EraseRootFromParent_Done,
     /* 629039 */   // Label 7938: @629039
     /* 629039 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(629085), // Rule ID 727 //
     /* 629044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629058 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 629061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629083 */     GIR_RootConstrainSelectedInstOperands,
     /* 629084 */     // GIR_Coverage, 727,
     /* 629084 */     GIR_EraseRootFromParent_Done,
     /* 629085 */   // Label 7939: @629085
     /* 629085 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(629130), // Rule ID 725 //
     /* 629090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 629093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 629097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 629104 */     // (fsqrt:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 629104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 629107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629128 */     GIR_RootConstrainSelectedInstOperands,
     /* 629129 */     // GIR_Coverage, 725,
     /* 629129 */     GIR_EraseRootFromParent_Done,
     /* 629130 */   // Label 7940: @629130
     /* 629130 */   GIM_Reject,
     /* 629131 */ // Label 7936: @629131
     /* 629131 */ GIM_Reject,
     /* 629132 */ // Label 7934: @629132
     /* 629132 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(629185), // Rule ID 1083 //
     /* 629137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 629140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 629143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 629147 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21503),
     /* 629151 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629158 */   // (fsqrt:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21503>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 629161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629183 */   GIR_RootConstrainSelectedInstOperands,
     /* 629184 */   // GIR_Coverage, 1083,
     /* 629184 */   GIR_EraseRootFromParent_Done,
     /* 629185 */ // Label 7941: @629185
     /* 629185 */ GIM_Reject,
     /* 629186 */ // Label 7935: @629186
     /* 629186 */ GIM_Reject,
     /* 629187 */ // Label 101: @629187
     /* 629187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7945*/ GIMT_Encode4(629700),
     /* 629198 */ /*GILLT_s16*//*Label 7942*/ GIMT_Encode4(629210),
     /* 629202 */ /*GILLT_s32*//*Label 7943*/ GIMT_Encode4(629384),
     /* 629206 */ /*GILLT_s64*//*Label 7944*/ GIMT_Encode4(629464),
     /* 629210 */ // Label 7942: @629210
     /* 629210 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(629383),
     /* 629215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 629218 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(629245), // Rule ID 38 //
     /* 629223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13739),
     /* 629234 */     // (ffloor:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13739>>  =>  (S_FLOOR_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 629234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F16),
     /* 629239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629243 */     GIR_RootConstrainSelectedInstOperands,
     /* 629244 */     // GIR_Coverage, 38,
     /* 629244 */     GIR_Done,
     /* 629245 */   // Label 7947: @629245
     /* 629245 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(629291), // Rule ID 765 //
     /* 629250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629264 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_e64),
     /* 629267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629289 */     GIR_RootConstrainSelectedInstOperands,
     /* 629290 */     // GIR_Coverage, 765,
     /* 629290 */     GIR_EraseRootFromParent_Done,
     /* 629291 */   // Label 7948: @629291
     /* 629291 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(629337), // Rule ID 767 //
     /* 629296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629310 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_fake16_e64),
     /* 629313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629335 */     GIR_RootConstrainSelectedInstOperands,
     /* 629336 */     // GIR_Coverage, 767,
     /* 629336 */     GIR_EraseRootFromParent_Done,
     /* 629337 */   // Label 7949: @629337
     /* 629337 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(629382), // Rule ID 766 //
     /* 629342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 629345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 629349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 629356 */     // (ffloor:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FLOOR_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 629356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_t16_e64),
     /* 629359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629380 */     GIR_RootConstrainSelectedInstOperands,
     /* 629381 */     // GIR_Coverage, 766,
     /* 629381 */     GIR_EraseRootFromParent_Done,
     /* 629382 */   // Label 7950: @629382
     /* 629382 */   GIM_Reject,
     /* 629383 */ // Label 7946: @629383
     /* 629383 */ GIM_Reject,
     /* 629384 */ // Label 7943: @629384
     /* 629384 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(629463),
     /* 629389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 629392 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(629419), // Rule ID 33 //
     /* 629397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13739),
     /* 629408 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13739>>  =>  (S_FLOOR_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 629408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F32),
     /* 629413 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629417 */     GIR_RootConstrainSelectedInstOperands,
     /* 629418 */     // GIR_Coverage, 33,
     /* 629418 */     GIR_Done,
     /* 629419 */   // Label 7952: @629419
     /* 629419 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(629462), // Rule ID 660 //
     /* 629424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629435 */     // (ffloor:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F32_e64),
     /* 629438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629460 */     GIR_RootConstrainSelectedInstOperands,
     /* 629461 */     // GIR_Coverage, 660,
     /* 629461 */     GIR_EraseRootFromParent_Done,
     /* 629462 */   // Label 7953: @629462
     /* 629462 */   GIM_Reject,
     /* 629463 */ // Label 7951: @629463
     /* 629463 */ GIM_Reject,
     /* 629464 */ // Label 7944: @629464
     /* 629464 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(629699),
     /* 629469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 629472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 629476 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(629656), // Rule ID 7565 //
     /* 629481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 629484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629491 */     // (ffloor:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$x, i32:{ *:[i32] }:$mods))  =>  (V_ADD_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x, 1:{ *:[i32] }, (V_CNDMASK_B64_PSEUDO:{ *:[i64] } (V_MIN_F64_e64:{ *:[i64] } 0:{ *:[i32] }, (V_FRACT_F64_e64:{ *:[i64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x), 0:{ *:[i32] }, (V_MOV_B64_PSEUDO:{ *:[i64] } 4607182418800017407:{ *:[i64] })), ?:{ *:[f64] }:$x, (V_CMP_CLASS_F64_e64:{ *:[i1] } 0:{ *:[i32] }, ?:{ *:[f64] }:$x, 3:{ *:[i32] })))
     /* 629491 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 629494 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 629498 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629503 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/0,
     /* 629506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629511 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/3,
     /* 629514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 629516 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 629519 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 629523 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629528 */     GIR_AddImm, /*InsnID*/4, /*Imm*/GIMT_Encode8(4607182418800017407),
     /* 629538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 629540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 629543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 629547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 629557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629562 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 629565 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 629568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 629570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 629573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 629577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629585 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 629588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629591 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 629594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629597 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 629602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 629605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B64_PSEUDO),
     /* 629609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 629617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 629625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 629627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 629630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 629637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 629645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 629648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629654 */     GIR_RootConstrainSelectedInstOperands,
     /* 629655 */     // GIR_Coverage, 7565,
     /* 629655 */     GIR_EraseRootFromParent_Done,
     /* 629656 */   // Label 7955: @629656
     /* 629656 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(629698), // Rule ID 704 //
     /* 629661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 629664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629671 */     // (ffloor:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F64_e64),
     /* 629674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629696 */     GIR_RootConstrainSelectedInstOperands,
     /* 629697 */     // GIR_Coverage, 704,
     /* 629697 */     GIR_EraseRootFromParent_Done,
     /* 629698 */   // Label 7956: @629698
     /* 629698 */   GIM_Reject,
     /* 629699 */ // Label 7954: @629699
     /* 629699 */ GIM_Reject,
     /* 629700 */ // Label 7945: @629700
     /* 629700 */ GIM_Reject,
     /* 629701 */ // Label 102: @629701
     /* 629701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7962*/ GIMT_Encode4(630662),
     /* 629712 */ /*GILLT_s16*//*Label 7957*/ GIMT_Encode4(629732),
     /* 629716 */ /*GILLT_s32*//*Label 7958*/ GIMT_Encode4(630094),
     /* 629720 */ /*GILLT_s64*//*Label 7959*/ GIMT_Encode4(630262),
     /* 629724 */ /*GILLT_v2s16*//*Label 7960*/ GIMT_Encode4(630515),
     /* 629728 */ /*GILLT_v2s32*//*Label 7961*/ GIMT_Encode4(630587),
     /* 629732 */ // Label 7957: @629732
     /* 629732 */ GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(630093),
     /* 629737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 629740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 629743 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(629778), // Rule ID 96 //
     /* 629748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13764),
     /* 629767 */     // (strict_fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13764>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 629767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 629772 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629776 */     GIR_RootConstrainSelectedInstOperands,
     /* 629777 */     // GIR_Coverage, 96,
     /* 629777 */     GIR_Done,
     /* 629778 */   // Label 7964: @629778
     /* 629778 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(629841), // Rule ID 858 //
     /* 629783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629804 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 629807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629839 */     GIR_RootConstrainSelectedInstOperands,
     /* 629840 */     // GIR_Coverage, 858,
     /* 629840 */     GIR_EraseRootFromParent_Done,
     /* 629841 */   // Label 7965: @629841
     /* 629841 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(629904), // Rule ID 862 //
     /* 629846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629867 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 629870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629902 */     GIR_RootConstrainSelectedInstOperands,
     /* 629903 */     // GIR_Coverage, 862,
     /* 629903 */     GIR_EraseRootFromParent_Done,
     /* 629904 */   // Label 7966: @629904
     /* 629904 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(629967), // Rule ID 8429 //
     /* 629909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629930 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 629933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 629940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 629945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 629950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 629955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 629960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 629965 */     GIR_RootConstrainSelectedInstOperands,
     /* 629966 */     // GIR_Coverage, 8429,
     /* 629966 */     GIR_EraseRootFromParent_Done,
     /* 629967 */   // Label 7967: @629967
     /* 629967 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(630030), // Rule ID 8431 //
     /* 629972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629993 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 629996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630028 */     GIR_RootConstrainSelectedInstOperands,
     /* 630029 */     // GIR_Coverage, 8431,
     /* 630029 */     GIR_EraseRootFromParent_Done,
     /* 630030 */   // Label 7968: @630030
     /* 630030 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(630092), // Rule ID 860 //
     /* 630035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 630038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 630042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630056 */     // (strict_fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 630056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 630059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630090 */     GIR_RootConstrainSelectedInstOperands,
     /* 630091 */     // GIR_Coverage, 860,
     /* 630091 */     GIR_EraseRootFromParent_Done,
     /* 630092 */   // Label 7969: @630092
     /* 630092 */   GIM_Reject,
     /* 630093 */ // Label 7963: @630093
     /* 630093 */ GIM_Reject,
     /* 630094 */ // Label 7958: @630094
     /* 630094 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(630261),
     /* 630099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 630105 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(630140), // Rule ID 88 //
     /* 630110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13764),
     /* 630129 */     // (strict_fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13764>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 630129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 630134 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630138 */     GIR_RootConstrainSelectedInstOperands,
     /* 630139 */     // GIR_Coverage, 88,
     /* 630139 */     GIR_Done,
     /* 630140 */   // Label 7971: @630140
     /* 630140 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(630200), // Rule ID 784 //
     /* 630145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630163 */     // (strict_fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 630166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630198 */     GIR_RootConstrainSelectedInstOperands,
     /* 630199 */     // GIR_Coverage, 784,
     /* 630199 */     GIR_EraseRootFromParent_Done,
     /* 630200 */   // Label 7972: @630200
     /* 630200 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(630260), // Rule ID 8418 //
     /* 630205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630223 */     // (strict_fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 630226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630258 */     GIR_RootConstrainSelectedInstOperands,
     /* 630259 */     // GIR_Coverage, 8418,
     /* 630259 */     GIR_EraseRootFromParent_Done,
     /* 630260 */   // Label 7973: @630260
     /* 630260 */   GIM_Reject,
     /* 630261 */ // Label 7970: @630261
     /* 630261 */ GIM_Reject,
     /* 630262 */ // Label 7959: @630262
     /* 630262 */ GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(630514),
     /* 630267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 630270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 630273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 630277 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(630336), // Rule ID 912 //
     /* 630282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 630285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630299 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 630302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630334 */     GIR_RootConstrainSelectedInstOperands,
     /* 630335 */     // GIR_Coverage, 912,
     /* 630335 */     GIR_EraseRootFromParent_Done,
     /* 630336 */   // Label 7975: @630336
     /* 630336 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(630395), // Rule ID 930 //
     /* 630341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 630344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630358 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 630361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630393 */     GIR_RootConstrainSelectedInstOperands,
     /* 630394 */     // GIR_Coverage, 930,
     /* 630394 */     GIR_EraseRootFromParent_Done,
     /* 630395 */   // Label 7976: @630395
     /* 630395 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(630454), // Rule ID 8447 //
     /* 630400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 630403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630417 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 630420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630452 */     GIR_RootConstrainSelectedInstOperands,
     /* 630453 */     // GIR_Coverage, 8447,
     /* 630453 */     GIR_EraseRootFromParent_Done,
     /* 630454 */   // Label 7977: @630454
     /* 630454 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(630513), // Rule ID 8460 //
     /* 630459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 630462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630476 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 630479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630511 */     GIR_RootConstrainSelectedInstOperands,
     /* 630512 */     // GIR_Coverage, 8460,
     /* 630512 */     GIR_EraseRootFromParent_Done,
     /* 630513 */   // Label 7978: @630513
     /* 630513 */   GIM_Reject,
     /* 630514 */ // Label 7974: @630514
     /* 630514 */ GIM_Reject,
     /* 630515 */ // Label 7960: @630515
     /* 630515 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(630586), // Rule ID 1090 //
     /* 630520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 630523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 630526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630544 */   // (strict_fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 630544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 630547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630584 */   GIR_RootConstrainSelectedInstOperands,
     /* 630585 */   // GIR_Coverage, 1090,
     /* 630585 */   GIR_EraseRootFromParent_Done,
     /* 630586 */ // Label 7979: @630586
     /* 630586 */ GIM_Reject,
     /* 630587 */ // Label 7961: @630587
     /* 630587 */ GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(630661), // Rule ID 1311 //
     /* 630592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 630595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 630598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 630601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 630605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630619 */   // (strict_fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 630619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 630622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630659 */   GIR_RootConstrainSelectedInstOperands,
     /* 630660 */   // GIR_Coverage, 1311,
     /* 630660 */   GIR_EraseRootFromParent_Done,
     /* 630661 */ // Label 7980: @630661
     /* 630661 */ GIM_Reject,
     /* 630662 */ // Label 7962: @630662
     /* 630662 */ GIM_Reject,
     /* 630663 */ // Label 103: @630663
     /* 630663 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7983*/ GIMT_Encode4(631026),
     /* 630674 */ /*GILLT_s16*//*Label 7981*/ GIMT_Encode4(630682),
     /* 630678 */ /*GILLT_s32*//*Label 7982*/ GIMT_Encode4(630918),
     /* 630682 */ // Label 7981: @630682
     /* 630682 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(630917),
     /* 630687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 630690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 630693 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(630728), // Rule ID 104 //
     /* 630698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13768),
     /* 630717 */     // (strict_fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13768>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 630717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 630722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630726 */     GIR_RootConstrainSelectedInstOperands,
     /* 630727 */     // GIR_Coverage, 104,
     /* 630727 */     GIR_Done,
     /* 630728 */   // Label 7985: @630728
     /* 630728 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(630791), // Rule ID 864 //
     /* 630733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 630736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630754 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 630757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630789 */     GIR_RootConstrainSelectedInstOperands,
     /* 630790 */     // GIR_Coverage, 864,
     /* 630790 */     GIR_EraseRootFromParent_Done,
     /* 630791 */   // Label 7986: @630791
     /* 630791 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(630854), // Rule ID 868 //
     /* 630796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 630799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630817 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 630820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630852 */     GIR_RootConstrainSelectedInstOperands,
     /* 630853 */     // GIR_Coverage, 868,
     /* 630853 */     GIR_EraseRootFromParent_Done,
     /* 630854 */   // Label 7987: @630854
     /* 630854 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(630916), // Rule ID 866 //
     /* 630859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 630862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 630866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630880 */     // (strict_fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 630880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 630883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630914 */     GIR_RootConstrainSelectedInstOperands,
     /* 630915 */     // GIR_Coverage, 866,
     /* 630915 */     GIR_EraseRootFromParent_Done,
     /* 630916 */   // Label 7988: @630916
     /* 630916 */   GIM_Reject,
     /* 630917 */ // Label 7984: @630917
     /* 630917 */ GIM_Reject,
     /* 630918 */ // Label 7982: @630918
     /* 630918 */ GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(631025),
     /* 630923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 630929 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(630964), // Rule ID 106 //
     /* 630934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13768),
     /* 630953 */     // (strict_fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13768>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 630953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 630958 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630962 */     GIR_RootConstrainSelectedInstOperands,
     /* 630963 */     // GIR_Coverage, 106,
     /* 630963 */     GIR_Done,
     /* 630964 */   // Label 7990: @630964
     /* 630964 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(631024), // Rule ID 786 //
     /* 630969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630987 */     // (strict_fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 630990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631022 */     GIR_RootConstrainSelectedInstOperands,
     /* 631023 */     // GIR_Coverage, 786,
     /* 631023 */     GIR_EraseRootFromParent_Done,
     /* 631024 */   // Label 7991: @631024
     /* 631024 */   GIM_Reject,
     /* 631025 */ // Label 7989: @631025
     /* 631025 */ GIM_Reject,
     /* 631026 */ // Label 7983: @631026
     /* 631026 */ GIM_Reject,
     /* 631027 */ // Label 104: @631027
     /* 631027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7997*/ GIMT_Encode4(632294),
     /* 631038 */ /*GILLT_s16*//*Label 7992*/ GIMT_Encode4(631058),
     /* 631042 */ /*GILLT_s32*//*Label 7993*/ GIMT_Encode4(631420),
     /* 631046 */ /*GILLT_s64*//*Label 7994*/ GIMT_Encode4(631588),
     /* 631050 */ /*GILLT_v2s16*//*Label 7995*/ GIMT_Encode4(632147),
     /* 631054 */ /*GILLT_v2s32*//*Label 7996*/ GIMT_Encode4(632219),
     /* 631058 */ // Label 7992: @631058
     /* 631058 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(631419),
     /* 631063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 631066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 631069 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(631104), // Rule ID 98 //
     /* 631074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 631077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13767),
     /* 631093 */     // (strict_fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13767>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 631093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 631098 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 631102 */     GIR_RootConstrainSelectedInstOperands,
     /* 631103 */     // GIR_Coverage, 98,
     /* 631103 */     GIR_Done,
     /* 631104 */   // Label 7999: @631104
     /* 631104 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(631167), // Rule ID 870 //
     /* 631109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 631112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631130 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 631133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631165 */     GIR_RootConstrainSelectedInstOperands,
     /* 631166 */     // GIR_Coverage, 870,
     /* 631166 */     GIR_EraseRootFromParent_Done,
     /* 631167 */   // Label 8000: @631167
     /* 631167 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(631230), // Rule ID 874 //
     /* 631172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 631175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631193 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 631196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631228 */     GIR_RootConstrainSelectedInstOperands,
     /* 631229 */     // GIR_Coverage, 874,
     /* 631229 */     GIR_EraseRootFromParent_Done,
     /* 631230 */   // Label 8001: @631230
     /* 631230 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(631293), // Rule ID 8433 //
     /* 631235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 631238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631256 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 631259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631291 */     GIR_RootConstrainSelectedInstOperands,
     /* 631292 */     // GIR_Coverage, 8433,
     /* 631292 */     GIR_EraseRootFromParent_Done,
     /* 631293 */   // Label 8002: @631293
     /* 631293 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(631356), // Rule ID 8435 //
     /* 631298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 631301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631319 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 631322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631354 */     GIR_RootConstrainSelectedInstOperands,
     /* 631355 */     // GIR_Coverage, 8435,
     /* 631355 */     GIR_EraseRootFromParent_Done,
     /* 631356 */   // Label 8003: @631356
     /* 631356 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(631418), // Rule ID 872 //
     /* 631361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 631364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 631368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 631375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 631382 */     // (strict_fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 631382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 631385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631416 */     GIR_RootConstrainSelectedInstOperands,
     /* 631417 */     // GIR_Coverage, 872,
     /* 631417 */     GIR_EraseRootFromParent_Done,
     /* 631418 */   // Label 8004: @631418
     /* 631418 */   GIM_Reject,
     /* 631419 */ // Label 7998: @631419
     /* 631419 */ GIM_Reject,
     /* 631420 */ // Label 7993: @631420
     /* 631420 */ GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(631587),
     /* 631425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 631428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 631431 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(631466), // Rule ID 94 //
     /* 631436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 631439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13767),
     /* 631455 */     // (strict_fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13767>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 631455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 631460 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 631464 */     GIR_RootConstrainSelectedInstOperands,
     /* 631465 */     // GIR_Coverage, 94,
     /* 631465 */     GIR_Done,
     /* 631466 */   // Label 8006: @631466
     /* 631466 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(631526), // Rule ID 790 //
     /* 631471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631489 */     // (strict_fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 631492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631524 */     GIR_RootConstrainSelectedInstOperands,
     /* 631525 */     // GIR_Coverage, 790,
     /* 631525 */     GIR_EraseRootFromParent_Done,
     /* 631526 */   // Label 8007: @631526
     /* 631526 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(631586), // Rule ID 8422 //
     /* 631531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631549 */     // (strict_fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 631552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631584 */     GIR_RootConstrainSelectedInstOperands,
     /* 631585 */     // GIR_Coverage, 8422,
     /* 631585 */     GIR_EraseRootFromParent_Done,
     /* 631586 */   // Label 8008: @631586
     /* 631586 */   GIM_Reject,
     /* 631587 */ // Label 8005: @631587
     /* 631587 */ GIM_Reject,
     /* 631588 */ // Label 7994: @631588
     /* 631588 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(632146),
     /* 631593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 631596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 631599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631603 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(631677), // Rule ID 7788 //
     /* 631608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 631612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631616 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 631620 */     // MIs[1] Operand 1
     /* 631620 */     // No operand predicates
     /* 631620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631629 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631641 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 631658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631675 */     GIR_RootConstrainSelectedInstOperands,
     /* 631676 */     // GIR_Coverage, 7788,
     /* 631676 */     GIR_EraseRootFromParent_Done,
     /* 631677 */   // Label 8010: @631677
     /* 631677 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(631751), // Rule ID 13454 //
     /* 631682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631690 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 631694 */     // MIs[1] Operand 1
     /* 631694 */     // No operand predicates
     /* 631694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631703 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631715 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 631732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631749 */     GIR_RootConstrainSelectedInstOperands,
     /* 631750 */     // GIR_Coverage, 13454,
     /* 631750 */     GIR_EraseRootFromParent_Done,
     /* 631751 */   // Label 8011: @631751
     /* 631751 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(631827), // Rule ID 7792 //
     /* 631756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 631764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 631768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 631772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631776 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631780 */     // MIs[2] Operand 1
     /* 631780 */     // No operand predicates
     /* 631780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 631782 */     // (strict_fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631794 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 631809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 631813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631825 */     GIR_RootConstrainSelectedInstOperands,
     /* 631826 */     // GIR_Coverage, 7792,
     /* 631826 */     GIR_EraseRootFromParent_Done,
     /* 631827 */   // Label 8012: @631827
     /* 631827 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(631903), // Rule ID 13458 //
     /* 631832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631840 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631844 */     // MIs[1] Operand 1
     /* 631844 */     // No operand predicates
     /* 631844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 631848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 631852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 631856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 631858 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631870 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 631885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 631889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631901 */     GIR_RootConstrainSelectedInstOperands,
     /* 631902 */     // GIR_Coverage, 13458,
     /* 631902 */     GIR_EraseRootFromParent_Done,
     /* 631903 */   // Label 8013: @631903
     /* 631903 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(631965), // Rule ID 13456 //
     /* 631908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631916 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631920 */     // MIs[1] Operand 1
     /* 631920 */     // No operand predicates
     /* 631920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631922 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631934 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 631949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 631951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631963 */     GIR_RootConstrainSelectedInstOperands,
     /* 631964 */     // GIR_Coverage, 13456,
     /* 631964 */     GIR_EraseRootFromParent_Done,
     /* 631965 */   // Label 8014: @631965
     /* 631965 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(632027), // Rule ID 7790 //
     /* 631970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 631974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631978 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631982 */     // MIs[1] Operand 1
     /* 631982 */     // No operand predicates
     /* 631982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631984 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631996 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 632001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 632003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 632006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 632011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 632013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 632019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632025 */     GIR_RootConstrainSelectedInstOperands,
     /* 632026 */     // GIR_Coverage, 7790,
     /* 632026 */     GIR_EraseRootFromParent_Done,
     /* 632027 */   // Label 8015: @632027
     /* 632027 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(632086), // Rule ID 932 //
     /* 632032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 632035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632049 */     // (strict_fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 632052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632084 */     GIR_RootConstrainSelectedInstOperands,
     /* 632085 */     // GIR_Coverage, 932,
     /* 632085 */     GIR_EraseRootFromParent_Done,
     /* 632086 */   // Label 8016: @632086
     /* 632086 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(632145), // Rule ID 8462 //
     /* 632091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 632094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632108 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 632111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632143 */     GIR_RootConstrainSelectedInstOperands,
     /* 632144 */     // GIR_Coverage, 8462,
     /* 632144 */     GIR_EraseRootFromParent_Done,
     /* 632145 */   // Label 8017: @632145
     /* 632145 */   GIM_Reject,
     /* 632146 */ // Label 8009: @632146
     /* 632146 */ GIM_Reject,
     /* 632147 */ // Label 7995: @632147
     /* 632147 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(632218), // Rule ID 1092 //
     /* 632152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 632155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 632158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632176 */   // (strict_fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 632176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 632179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632216 */   GIR_RootConstrainSelectedInstOperands,
     /* 632217 */   // GIR_Coverage, 1092,
     /* 632217 */   GIR_EraseRootFromParent_Done,
     /* 632218 */ // Label 8018: @632218
     /* 632218 */ GIM_Reject,
     /* 632219 */ // Label 7996: @632219
     /* 632219 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(632293), // Rule ID 1309 //
     /* 632224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 632227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 632230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 632233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632251 */   // (strict_fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 632251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 632254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632291 */   GIR_RootConstrainSelectedInstOperands,
     /* 632292 */   // GIR_Coverage, 1309,
     /* 632292 */   GIR_EraseRootFromParent_Done,
     /* 632293 */ // Label 8019: @632293
     /* 632293 */ GIM_Reject,
     /* 632294 */ // Label 7997: @632294
     /* 632294 */ GIM_Reject,
     /* 632295 */ // Label 105: @632295
     /* 632295 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 8025*/ GIMT_Encode4(633340),
     /* 632306 */ /*GILLT_s16*//*Label 8020*/ GIMT_Encode4(632326),
     /* 632310 */ /*GILLT_s32*//*Label 8021*/ GIMT_Encode4(632778),
     /* 632314 */ /*GILLT_s64*//*Label 8022*/ GIMT_Encode4(632987),
     /* 632318 */ /*GILLT_v2s16*//*Label 8023*/ GIMT_Encode4(633153),
     /* 632322 */ /*GILLT_v2s32*//*Label 8024*/ GIMT_Encode4(633245),
     /* 632326 */ // Label 8020: @632326
     /* 632326 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(632777),
     /* 632331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 632334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 632337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 632340 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(632379), // Rule ID 112 //
     /* 632345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13770),
     /* 632368 */     // (strict_fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13770>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 632368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 632373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632377 */     GIR_RootConstrainSelectedInstOperands,
     /* 632378 */     // GIR_Coverage, 112,
     /* 632378 */     GIR_Done,
     /* 632379 */   // Label 8027: @632379
     /* 632379 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(632459), // Rule ID 999 //
     /* 632384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 632387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632412 */     // (strict_fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 632415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632457 */     GIR_RootConstrainSelectedInstOperands,
     /* 632458 */     // GIR_Coverage, 999,
     /* 632458 */     GIR_EraseRootFromParent_Done,
     /* 632459 */   // Label 8028: @632459
     /* 632459 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(632539), // Rule ID 8475 //
     /* 632464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 632467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632492 */     // (strict_fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 632495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632537 */     GIR_RootConstrainSelectedInstOperands,
     /* 632538 */     // GIR_Coverage, 8475,
     /* 632538 */     GIR_EraseRootFromParent_Done,
     /* 632539 */   // Label 8029: @632539
     /* 632539 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(632618), // Rule ID 1007 //
     /* 632544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 632547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632572 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 632575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632616 */     GIR_RootConstrainSelectedInstOperands,
     /* 632617 */     // GIR_Coverage, 1007,
     /* 632617 */     GIR_EraseRootFromParent_Done,
     /* 632618 */   // Label 8030: @632618
     /* 632618 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(632697), // Rule ID 1009 //
     /* 632623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 632626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 632630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632651 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 632654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632695 */     GIR_RootConstrainSelectedInstOperands,
     /* 632696 */     // GIR_Coverage, 1009,
     /* 632696 */     GIR_EraseRootFromParent_Done,
     /* 632697 */   // Label 8031: @632697
     /* 632697 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(632776), // Rule ID 1011 //
     /* 632702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 632705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632730 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 632733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632774 */     GIR_RootConstrainSelectedInstOperands,
     /* 632775 */     // GIR_Coverage, 1011,
     /* 632775 */     GIR_EraseRootFromParent_Done,
     /* 632776 */   // Label 8032: @632776
     /* 632776 */   GIM_Reject,
     /* 632777 */ // Label 8026: @632777
     /* 632777 */ GIM_Reject,
     /* 632778 */ // Label 8021: @632778
     /* 632778 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(632986),
     /* 632783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 632786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 632789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 632792 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(632831), // Rule ID 110 //
     /* 632797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13770),
     /* 632820 */     // (strict_fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13770>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 632820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 632825 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632829 */     GIR_RootConstrainSelectedInstOperands,
     /* 632830 */     // GIR_Coverage, 110,
     /* 632830 */     GIR_Done,
     /* 632831 */   // Label 8034: @632831
     /* 632831 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(632908), // Rule ID 925 //
     /* 632836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632861 */     // (strict_fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 632864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632906 */     GIR_RootConstrainSelectedInstOperands,
     /* 632907 */     // GIR_Coverage, 925,
     /* 632907 */     GIR_EraseRootFromParent_Done,
     /* 632908 */   // Label 8035: @632908
     /* 632908 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(632985), // Rule ID 8456 //
     /* 632913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632938 */     // (strict_fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 632941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632983 */     GIR_RootConstrainSelectedInstOperands,
     /* 632984 */     // GIR_Coverage, 8456,
     /* 632984 */     GIR_EraseRootFromParent_Done,
     /* 632985 */   // Label 8036: @632985
     /* 632985 */   GIM_Reject,
     /* 632986 */ // Label 8033: @632986
     /* 632986 */ GIM_Reject,
     /* 632987 */ // Label 8022: @632987
     /* 632987 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(633152),
     /* 632992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 632995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 632998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 633001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633005 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(633078), // Rule ID 928 //
     /* 633010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633031 */     // (strict_fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 633034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 633061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 633066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633076 */     GIR_RootConstrainSelectedInstOperands,
     /* 633077 */     // GIR_Coverage, 928,
     /* 633077 */     GIR_EraseRootFromParent_Done,
     /* 633078 */   // Label 8038: @633078
     /* 633078 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(633151), // Rule ID 8458 //
     /* 633083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633104 */     // (strict_fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 633107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 633114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 633119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 633124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 633129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 633134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 633139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 633144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 633149 */     GIR_RootConstrainSelectedInstOperands,
     /* 633150 */     // GIR_Coverage, 8458,
     /* 633150 */     GIR_EraseRootFromParent_Done,
     /* 633151 */   // Label 8039: @633151
     /* 633151 */   GIM_Reject,
     /* 633152 */ // Label 8037: @633152
     /* 633152 */ GIM_Reject,
     /* 633153 */ // Label 8023: @633153
     /* 633153 */ GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(633244), // Rule ID 1088 //
     /* 633158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 633161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 633164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 633167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633185 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633192 */   // (strict_fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 633192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 633195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 633222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 633227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633242 */   GIR_RootConstrainSelectedInstOperands,
     /* 633243 */   // GIR_Coverage, 1088,
     /* 633243 */   GIR_EraseRootFromParent_Done,
     /* 633244 */ // Label 8040: @633244
     /* 633244 */ GIM_Reject,
     /* 633245 */ // Label 8024: @633245
     /* 633245 */ GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(633339), // Rule ID 1307 //
     /* 633250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 633253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 633256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 633259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 633262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 633287 */   // (strict_fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 633287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 633290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 633317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 633322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633337 */   GIR_RootConstrainSelectedInstOperands,
     /* 633338 */   // GIR_Coverage, 1307,
     /* 633338 */   GIR_EraseRootFromParent_Done,
     /* 633339 */ // Label 8041: @633339
     /* 633339 */ GIM_Reject,
     /* 633340 */ // Label 8025: @633340
     /* 633340 */ GIM_Reject,
     /* 633341 */ // Label 106: @633341
     /* 633341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 8045*/ GIMT_Encode4(633703),
     /* 633352 */ /*GILLT_s16*//*Label 8042*/ GIMT_Encode4(633364),
     /* 633356 */ /*GILLT_s32*//*Label 8043*/ GIMT_Encode4(633569),
     /* 633360 */ /*GILLT_s64*//*Label 8044*/ GIMT_Encode4(633636),
     /* 633364 */ // Label 8042: @633364
     /* 633364 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(633568),
     /* 633369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 633372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 633375 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(633438), // Rule ID 2505 //
     /* 633380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 633383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633401 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 633401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 633404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633436 */     GIR_RootConstrainSelectedInstOperands,
     /* 633437 */     // GIR_Coverage, 2505,
     /* 633437 */     GIR_EraseRootFromParent_Done,
     /* 633438 */   // Label 8047: @633438
     /* 633438 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(633504), // Rule ID 2507 //
     /* 633443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 633446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 633450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633464 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 633464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 633467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633502 */     GIR_RootConstrainSelectedInstOperands,
     /* 633503 */     // GIR_Coverage, 2507,
     /* 633503 */     GIR_EraseRootFromParent_Done,
     /* 633504 */   // Label 8048: @633504
     /* 633504 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(633567), // Rule ID 2509 //
     /* 633509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 633512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633530 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 633530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 633533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633565 */     GIR_RootConstrainSelectedInstOperands,
     /* 633566 */     // GIR_Coverage, 2509,
     /* 633566 */     GIR_EraseRootFromParent_Done,
     /* 633567 */   // Label 8049: @633567
     /* 633567 */   GIM_Reject,
     /* 633568 */ // Label 8046: @633568
     /* 633568 */ GIM_Reject,
     /* 633569 */ // Label 8043: @633569
     /* 633569 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(633635), // Rule ID 820 //
     /* 633574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 633577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 633580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633598 */   // (strict_fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 633601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633633 */   GIR_RootConstrainSelectedInstOperands,
     /* 633634 */   // GIR_Coverage, 820,
     /* 633634 */   GIR_EraseRootFromParent_Done,
     /* 633635 */ // Label 8050: @633635
     /* 633635 */ GIM_Reject,
     /* 633636 */ // Label 8044: @633636
     /* 633636 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(633702), // Rule ID 980 //
     /* 633641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 633644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 633647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633665 */   // (strict_fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 633668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633700 */   GIR_RootConstrainSelectedInstOperands,
     /* 633701 */   // GIR_Coverage, 980,
     /* 633701 */   GIR_EraseRootFromParent_Done,
     /* 633702 */ // Label 8051: @633702
     /* 633702 */ GIM_Reject,
     /* 633703 */ // Label 8045: @633703
     /* 633703 */ GIM_Reject,
     /* 633704 */ // Label 107: @633704
     /* 633704 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8054*/ GIMT_Encode4(636007),
     /* 633715 */ /*GILLT_s32*//*Label 8052*/ GIMT_Encode4(633723),
     /* 633719 */ /*GILLT_s64*//*Label 8053*/ GIMT_Encode4(634865),
     /* 633723 */ // Label 8052: @633723
     /* 633723 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(634864),
     /* 633728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 633731 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(633793), // Rule ID 5799 //
     /* 633736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633746 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633759 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64),
     /* 633762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633791 */     GIR_RootConstrainSelectedInstOperands,
     /* 633792 */     // GIR_Coverage, 5799,
     /* 633792 */     GIR_EraseRootFromParent_Done,
     /* 633793 */   // Label 8056: @633793
     /* 633793 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(633852), // Rule ID 5803 //
     /* 633798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633805 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633818 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64),
     /* 633821 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633850 */     GIR_RootConstrainSelectedInstOperands,
     /* 633851 */     // GIR_Coverage, 5803,
     /* 633851 */     GIR_EraseRootFromParent_Done,
     /* 633852 */   // Label 8057: @633852
     /* 633852 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(633970), // Rule ID 5575 //
     /* 633857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633882 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 633882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 633885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN),
     /* 633889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 633898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633918 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 633921 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 633927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 633930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633939 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 633942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 633952 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 633959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633969 */     // GIR_Coverage, 5575,
     /* 633969 */     GIR_EraseRootFromParent_Done,
     /* 633970 */   // Label 8058: @633970
     /* 633970 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(634085), // Rule ID 5801 //
     /* 633975 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633997 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 633997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 634000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN),
     /* 634004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634009 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634036 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 634045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 634074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634084 */     // GIR_Coverage, 5801,
     /* 634084 */     GIR_EraseRootFromParent_Done,
     /* 634085 */   // Label 8059: @634085
     /* 634085 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(634142), // Rule ID 5798 //
     /* 634090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634093 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634100 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634113 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 634116 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634140 */     GIR_RootConstrainSelectedInstOperands,
     /* 634141 */     // GIR_Coverage, 5798,
     /* 634141 */     GIR_EraseRootFromParent_Done,
     /* 634142 */   // Label 8060: @634142
     /* 634142 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(634196), // Rule ID 5802 //
     /* 634147 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634154 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634167 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 634170 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634194 */     GIR_RootConstrainSelectedInstOperands,
     /* 634195 */     // GIR_Coverage, 5802,
     /* 634195 */     GIR_EraseRootFromParent_Done,
     /* 634196 */   // Label 8061: @634196
     /* 634196 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(634309), // Rule ID 5574 //
     /* 634201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634204 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634226 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 634226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 634229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 634233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634238 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634260 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 634269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634278 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 634298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634308 */     // GIR_Coverage, 5574,
     /* 634308 */     GIR_EraseRootFromParent_Done,
     /* 634309 */   // Label 8062: @634309
     /* 634309 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(634419), // Rule ID 5800 //
     /* 634314 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634336 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 634336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 634339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 634343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634348 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634367 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634370 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 634379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 634408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634418 */     // GIR_Coverage, 5800,
     /* 634418 */     GIR_EraseRootFromParent_Done,
     /* 634419 */   // Label 8063: @634419
     /* 634419 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(634476), // Rule ID 4050 //
     /* 634424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634427 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634434 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 634447 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 634447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR),
     /* 634450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 634455 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 634462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634474 */     GIR_RootConstrainSelectedInstOperands,
     /* 634475 */     // GIR_Coverage, 4050,
     /* 634475 */     GIR_EraseRootFromParent_Done,
     /* 634476 */   // Label 8064: @634476
     /* 634476 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(634537), // Rule ID 4052 //
     /* 634481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 634506 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 634506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN),
     /* 634509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 634516 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 634523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634535 */     GIR_RootConstrainSelectedInstOperands,
     /* 634536 */     // GIR_Coverage, 4052,
     /* 634536 */     GIR_EraseRootFromParent_Done,
     /* 634537 */   // Label 8065: @634537
     /* 634537 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(634589), // Rule ID 4049 //
     /* 634542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634552 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 634565 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP),
     /* 634568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634573 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634587 */     GIR_RootConstrainSelectedInstOperands,
     /* 634588 */     // GIR_Coverage, 4049,
     /* 634588 */     GIR_EraseRootFromParent_Done,
     /* 634589 */   // Label 8066: @634589
     /* 634589 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(634645), // Rule ID 4051 //
     /* 634594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634597 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 634619 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_RTN),
     /* 634622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634629 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634643 */     GIR_RootConstrainSelectedInstOperands,
     /* 634644 */     // GIR_Coverage, 4051,
     /* 634644 */     GIR_EraseRootFromParent_Done,
     /* 634645 */   // Label 8067: @634645
     /* 634645 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(634698), // Rule ID 3686 //
     /* 634650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634661 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634674 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 634677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634682 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634696 */     GIR_RootConstrainSelectedInstOperands,
     /* 634697 */     // GIR_Coverage, 3686,
     /* 634697 */     GIR_EraseRootFromParent_Done,
     /* 634698 */   // Label 8068: @634698
     /* 634698 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(634750), // Rule ID 3746 //
     /* 634703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634706 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634713 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634726 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 634729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634734 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634748 */     GIR_RootConstrainSelectedInstOperands,
     /* 634749 */     // GIR_Coverage, 3746,
     /* 634749 */     GIR_EraseRootFromParent_Done,
     /* 634750 */   // Label 8069: @634750
     /* 634750 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(634807), // Rule ID 3685 //
     /* 634755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634758 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634781 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 634784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634791 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634805 */     GIR_RootConstrainSelectedInstOperands,
     /* 634806 */     // GIR_Coverage, 3685,
     /* 634806 */     GIR_EraseRootFromParent_Done,
     /* 634807 */   // Label 8070: @634807
     /* 634807 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(634863), // Rule ID 3745 //
     /* 634812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634815 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634837 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9786:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 634840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634847 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634861 */     GIR_RootConstrainSelectedInstOperands,
     /* 634862 */     // GIR_Coverage, 3745,
     /* 634862 */     GIR_EraseRootFromParent_Done,
     /* 634863 */   // Label 8071: @634863
     /* 634863 */   GIM_Reject,
     /* 634864 */ // Label 8055: @634864
     /* 634864 */ GIM_Reject,
     /* 634865 */ // Label 8053: @634865
     /* 634865 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(636006),
     /* 634870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 634873 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(634935), // Rule ID 5807 //
     /* 634878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634881 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634888 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634901 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64),
     /* 634904 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634933 */     GIR_RootConstrainSelectedInstOperands,
     /* 634934 */     // GIR_Coverage, 5807,
     /* 634934 */     GIR_EraseRootFromParent_Done,
     /* 634935 */   // Label 8073: @634935
     /* 634935 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(634994), // Rule ID 5811 //
     /* 634940 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634947 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634960 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64),
     /* 634963 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634992 */     GIR_RootConstrainSelectedInstOperands,
     /* 634993 */     // GIR_Coverage, 5811,
     /* 634993 */     GIR_EraseRootFromParent_Done,
     /* 634994 */   // Label 8074: @634994
     /* 634994 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(635112), // Rule ID 5805 //
     /* 634999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 635024 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN),
     /* 635031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 635045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 635055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 635060 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635063 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635094 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635111 */     // GIR_Coverage, 5805,
     /* 635111 */     GIR_EraseRootFromParent_Done,
     /* 635112 */   // Label 8075: @635112
     /* 635112 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(635227), // Rule ID 5809 //
     /* 635117 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 635139 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635139 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635142 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN),
     /* 635146 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 635160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 635170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 635175 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635178 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635209 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635226 */     // GIR_Coverage, 5809,
     /* 635226 */     GIR_EraseRootFromParent_Done,
     /* 635227 */   // Label 8076: @635227
     /* 635227 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(635284), // Rule ID 5806 //
     /* 635232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635235 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635242 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635255 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 635255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 635258 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 635260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635282 */     GIR_RootConstrainSelectedInstOperands,
     /* 635283 */     // GIR_Coverage, 5806,
     /* 635283 */     GIR_EraseRootFromParent_Done,
     /* 635284 */   // Label 8077: @635284
     /* 635284 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(635338), // Rule ID 5810 //
     /* 635289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635296 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635309 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 635309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 635312 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 635314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635336 */     GIR_RootConstrainSelectedInstOperands,
     /* 635337 */     // GIR_Coverage, 5810,
     /* 635337 */     GIR_EraseRootFromParent_Done,
     /* 635338 */   // Label 8078: @635338
     /* 635338 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(635451), // Rule ID 5804 //
     /* 635343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635346 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635368 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635368 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635371 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 635375 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635380 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635399 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635402 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635433 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635440 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635450 */     // GIR_Coverage, 5804,
     /* 635450 */     GIR_EraseRootFromParent_Done,
     /* 635451 */   // Label 8079: @635451
     /* 635451 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(635561), // Rule ID 5808 //
     /* 635456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635478 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 635485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635509 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635512 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635530 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635543 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635560 */     // GIR_Coverage, 5808,
     /* 635560 */     GIR_EraseRootFromParent_Done,
     /* 635561 */   // Label 8080: @635561
     /* 635561 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(635618), // Rule ID 4106 //
     /* 635566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635569 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635576 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 635589 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 635589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR),
     /* 635592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 635597 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 635604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635616 */     GIR_RootConstrainSelectedInstOperands,
     /* 635617 */     // GIR_Coverage, 4106,
     /* 635617 */     GIR_EraseRootFromParent_Done,
     /* 635618 */   // Label 8081: @635618
     /* 635618 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(635679), // Rule ID 4108 //
     /* 635623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635626 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 635648 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 635648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN),
     /* 635651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 635658 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 635665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635677 */     GIR_RootConstrainSelectedInstOperands,
     /* 635678 */     // GIR_Coverage, 4108,
     /* 635678 */     GIR_EraseRootFromParent_Done,
     /* 635679 */   // Label 8082: @635679
     /* 635679 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(635731), // Rule ID 4105 //
     /* 635684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635694 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 635707 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2),
     /* 635710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635715 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635729 */     GIR_RootConstrainSelectedInstOperands,
     /* 635730 */     // GIR_Coverage, 4105,
     /* 635730 */     GIR_EraseRootFromParent_Done,
     /* 635731 */   // Label 8083: @635731
     /* 635731 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(635787), // Rule ID 4107 //
     /* 635736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 635761 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_RTN),
     /* 635764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635771 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635785 */     GIR_RootConstrainSelectedInstOperands,
     /* 635786 */     // GIR_Coverage, 4107,
     /* 635786 */     GIR_EraseRootFromParent_Done,
     /* 635787 */   // Label 8084: @635787
     /* 635787 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(635840), // Rule ID 3712 //
     /* 635792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635803 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635816 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 635819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635824 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635838 */     GIR_RootConstrainSelectedInstOperands,
     /* 635839 */     // GIR_Coverage, 3712,
     /* 635839 */     GIR_EraseRootFromParent_Done,
     /* 635840 */   // Label 8085: @635840
     /* 635840 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(635892), // Rule ID 3772 //
     /* 635845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635855 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635868 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 635871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635876 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635890 */     GIR_RootConstrainSelectedInstOperands,
     /* 635891 */     // GIR_Coverage, 3772,
     /* 635891 */     GIR_EraseRootFromParent_Done,
     /* 635892 */   // Label 8086: @635892
     /* 635892 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(635949), // Rule ID 3711 //
     /* 635897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635923 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 635926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635933 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635947 */     GIR_RootConstrainSelectedInstOperands,
     /* 635948 */     // GIR_Coverage, 3711,
     /* 635948 */     GIR_EraseRootFromParent_Done,
     /* 635949 */   // Label 8087: @635949
     /* 635949 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(636005), // Rule ID 3771 //
     /* 635954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635979 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9784:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 635982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635989 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636003 */     GIR_RootConstrainSelectedInstOperands,
     /* 636004 */     // GIR_Coverage, 3771,
     /* 636004 */     GIR_EraseRootFromParent_Done,
     /* 636005 */   // Label 8088: @636005
     /* 636005 */   GIM_Reject,
     /* 636006 */ // Label 8072: @636006
     /* 636006 */ GIM_Reject,
     /* 636007 */ // Label 8054: @636007
     /* 636007 */ GIM_Reject,
     /* 636008 */ // Label 108: @636008
     /* 636008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8091*/ GIMT_Encode4(638391),
     /* 636019 */ /*GILLT_s32*//*Label 8089*/ GIMT_Encode4(636027),
     /* 636023 */ /*GILLT_s64*//*Label 8090*/ GIMT_Encode4(637209),
     /* 636027 */ // Label 8089: @636027
     /* 636027 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(637208),
     /* 636032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 636035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 636038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 636041 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 636044 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 636047 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(636115), // Rule ID 5848 //
     /* 636052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636055 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636065 */     // MIs[0] offset
     /* 636065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636068 */     // MIs[0] auxiliary
     /* 636068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636071 */     // MIs[0] Operand 8
     /* 636071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636089 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 636092 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636101 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636113 */     GIR_RootConstrainSelectedInstOperands,
     /* 636114 */     // GIR_Coverage, 5848,
     /* 636114 */     GIR_EraseRootFromParent_Done,
     /* 636115 */   // Label 8093: @636115
     /* 636115 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(636180), // Rule ID 5856 //
     /* 636120 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636130 */     // MIs[0] offset
     /* 636130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636133 */     // MIs[0] auxiliary
     /* 636133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636136 */     // MIs[0] Operand 8
     /* 636136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636154 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 636157 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636166 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636178 */     GIR_RootConstrainSelectedInstOperands,
     /* 636179 */     // GIR_Coverage, 5856,
     /* 636179 */     GIR_EraseRootFromParent_Done,
     /* 636180 */   // Label 8094: @636180
     /* 636180 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(636252), // Rule ID 5844 //
     /* 636185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636200 */     // MIs[0] offset
     /* 636200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636203 */     // MIs[0] auxiliary
     /* 636203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636206 */     // MIs[0] Operand 8
     /* 636206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636224 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 636227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636229 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636238 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636240 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636250 */     GIR_RootConstrainSelectedInstOperands,
     /* 636251 */     // GIR_Coverage, 5844,
     /* 636251 */     GIR_EraseRootFromParent_Done,
     /* 636252 */   // Label 8095: @636252
     /* 636252 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(636321), // Rule ID 5852 //
     /* 636257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636269 */     // MIs[0] offset
     /* 636269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636272 */     // MIs[0] auxiliary
     /* 636272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636275 */     // MIs[0] Operand 8
     /* 636275 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636293 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 636296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636298 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636307 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636319 */     GIR_RootConstrainSelectedInstOperands,
     /* 636320 */     // GIR_Coverage, 5852,
     /* 636320 */     GIR_EraseRootFromParent_Done,
     /* 636321 */   // Label 8096: @636321
     /* 636321 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(636387), // Rule ID 5850 //
     /* 636326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636329 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636335 */     // MIs[0] offset
     /* 636335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636338 */     // MIs[0] auxiliary
     /* 636338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636341 */     // MIs[0] Operand 8
     /* 636341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636359 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN),
     /* 636362 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636364 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636373 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636385 */     GIR_RootConstrainSelectedInstOperands,
     /* 636386 */     // GIR_Coverage, 5850,
     /* 636386 */     GIR_EraseRootFromParent_Done,
     /* 636387 */   // Label 8097: @636387
     /* 636387 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(636450), // Rule ID 5858 //
     /* 636392 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636398 */     // MIs[0] offset
     /* 636398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636401 */     // MIs[0] auxiliary
     /* 636401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636404 */     // MIs[0] Operand 8
     /* 636404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636422 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN),
     /* 636425 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636427 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636436 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636448 */     GIR_RootConstrainSelectedInstOperands,
     /* 636449 */     // GIR_Coverage, 5858,
     /* 636449 */     GIR_EraseRootFromParent_Done,
     /* 636450 */   // Label 8098: @636450
     /* 636450 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(636520), // Rule ID 5846 //
     /* 636455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636466 */     // MIs[0] offset
     /* 636466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636469 */     // MIs[0] auxiliary
     /* 636469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636472 */     // MIs[0] Operand 8
     /* 636472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636490 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN_RTN),
     /* 636493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636495 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636497 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636506 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636518 */     GIR_RootConstrainSelectedInstOperands,
     /* 636519 */     // GIR_Coverage, 5846,
     /* 636519 */     GIR_EraseRootFromParent_Done,
     /* 636520 */   // Label 8099: @636520
     /* 636520 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(636587), // Rule ID 5854 //
     /* 636525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636533 */     // MIs[0] offset
     /* 636533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636536 */     // MIs[0] auxiliary
     /* 636536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636539 */     // MIs[0] Operand 8
     /* 636539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636557 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN),
     /* 636560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636562 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636564 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636573 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636585 */     GIR_RootConstrainSelectedInstOperands,
     /* 636586 */     // GIR_Coverage, 5854,
     /* 636586 */     GIR_EraseRootFromParent_Done,
     /* 636587 */   // Label 8100: @636587
     /* 636587 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(636645), // Rule ID 5849 //
     /* 636592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636595 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636601 */     // MIs[0] offset
     /* 636601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636604 */     // MIs[0] auxiliary
     /* 636604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636607 */     // MIs[0] Operand 8
     /* 636607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636617 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN),
     /* 636620 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636622 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636631 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636643 */     GIR_RootConstrainSelectedInstOperands,
     /* 636644 */     // GIR_Coverage, 5849,
     /* 636644 */     GIR_EraseRootFromParent_Done,
     /* 636645 */   // Label 8101: @636645
     /* 636645 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(636700), // Rule ID 5857 //
     /* 636650 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636656 */     // MIs[0] offset
     /* 636656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636659 */     // MIs[0] auxiliary
     /* 636659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636662 */     // MIs[0] Operand 8
     /* 636662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636672 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN),
     /* 636675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636677 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636686 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636698 */     GIR_RootConstrainSelectedInstOperands,
     /* 636699 */     // GIR_Coverage, 5857,
     /* 636699 */     GIR_EraseRootFromParent_Done,
     /* 636700 */   // Label 8102: @636700
     /* 636700 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(636762), // Rule ID 5845 //
     /* 636705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636716 */     // MIs[0] offset
     /* 636716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636719 */     // MIs[0] auxiliary
     /* 636719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636722 */     // MIs[0] Operand 8
     /* 636722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636732 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN_RTN),
     /* 636735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636737 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636739 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636748 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636760 */     GIR_RootConstrainSelectedInstOperands,
     /* 636761 */     // GIR_Coverage, 5845,
     /* 636761 */     GIR_EraseRootFromParent_Done,
     /* 636762 */   // Label 8103: @636762
     /* 636762 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(636821), // Rule ID 5853 //
     /* 636767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636775 */     // MIs[0] offset
     /* 636775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636778 */     // MIs[0] auxiliary
     /* 636778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636781 */     // MIs[0] Operand 8
     /* 636781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636791 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN),
     /* 636794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636796 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636798 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636807 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636819 */     GIR_RootConstrainSelectedInstOperands,
     /* 636820 */     // GIR_Coverage, 5853,
     /* 636820 */     GIR_EraseRootFromParent_Done,
     /* 636821 */   // Label 8104: @636821
     /* 636821 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(636917), // Rule ID 5851 //
     /* 636826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636829 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636831 */     // MIs[0] offset
     /* 636831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636834 */     // MIs[0] auxiliary
     /* 636834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636837 */     // MIs[0] Operand 8
     /* 636837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636847 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636863 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636870 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN),
     /* 636891 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636903 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636915 */     GIR_RootConstrainSelectedInstOperands,
     /* 636916 */     // GIR_Coverage, 5851,
     /* 636916 */     GIR_EraseRootFromParent_Done,
     /* 636917 */   // Label 8105: @636917
     /* 636917 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(637010), // Rule ID 5859 //
     /* 636922 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636924 */     // MIs[0] offset
     /* 636924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636927 */     // MIs[0] auxiliary
     /* 636927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636930 */     // MIs[0] Operand 8
     /* 636930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636940 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636956 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636963 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN),
     /* 636984 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636996 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637008 */     GIR_RootConstrainSelectedInstOperands,
     /* 637009 */     // GIR_Coverage, 5859,
     /* 637009 */     GIR_EraseRootFromParent_Done,
     /* 637010 */   // Label 8106: @637010
     /* 637010 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(637110), // Rule ID 5847 //
     /* 637015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 637022 */     // MIs[0] offset
     /* 637022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637025 */     // MIs[0] auxiliary
     /* 637025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637028 */     // MIs[0] Operand 8
     /* 637028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637038 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 637041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 637045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 637054 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 637057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 637061 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 637064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN_RTN),
     /* 637082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637084 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 637089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637096 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637108 */     GIR_RootConstrainSelectedInstOperands,
     /* 637109 */     // GIR_Coverage, 5847,
     /* 637109 */     GIR_EraseRootFromParent_Done,
     /* 637110 */   // Label 8107: @637110
     /* 637110 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(637207), // Rule ID 5855 //
     /* 637115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 637119 */     // MIs[0] offset
     /* 637119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637122 */     // MIs[0] auxiliary
     /* 637122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637125 */     // MIs[0] Operand 8
     /* 637125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637135 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 637138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 637142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 637151 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 637154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 637158 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 637161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN),
     /* 637179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637181 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 637186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637193 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637205 */     GIR_RootConstrainSelectedInstOperands,
     /* 637206 */     // GIR_Coverage, 5855,
     /* 637206 */     GIR_EraseRootFromParent_Done,
     /* 637207 */   // Label 8108: @637207
     /* 637207 */   GIM_Reject,
     /* 637208 */ // Label 8092: @637208
     /* 637208 */ GIM_Reject,
     /* 637209 */ // Label 8090: @637209
     /* 637209 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(638390),
     /* 637214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 637217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 637220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 637223 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 637226 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 637229 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(637297), // Rule ID 6048 //
     /* 637234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637237 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637247 */     // MIs[0] offset
     /* 637247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637250 */     // MIs[0] auxiliary
     /* 637250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637253 */     // MIs[0] Operand 8
     /* 637253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637271 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 637274 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637283 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637295 */     GIR_RootConstrainSelectedInstOperands,
     /* 637296 */     // GIR_Coverage, 6048,
     /* 637296 */     GIR_EraseRootFromParent_Done,
     /* 637297 */   // Label 8110: @637297
     /* 637297 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(637362), // Rule ID 6056 //
     /* 637302 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637312 */     // MIs[0] offset
     /* 637312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637315 */     // MIs[0] auxiliary
     /* 637315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637318 */     // MIs[0] Operand 8
     /* 637318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637336 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 637339 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637348 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637360 */     GIR_RootConstrainSelectedInstOperands,
     /* 637361 */     // GIR_Coverage, 6056,
     /* 637361 */     GIR_EraseRootFromParent_Done,
     /* 637362 */   // Label 8111: @637362
     /* 637362 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(637434), // Rule ID 6044 //
     /* 637367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637382 */     // MIs[0] offset
     /* 637382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637385 */     // MIs[0] auxiliary
     /* 637385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637388 */     // MIs[0] Operand 8
     /* 637388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637406 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 637409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637411 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637420 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637432 */     GIR_RootConstrainSelectedInstOperands,
     /* 637433 */     // GIR_Coverage, 6044,
     /* 637433 */     GIR_EraseRootFromParent_Done,
     /* 637434 */   // Label 8112: @637434
     /* 637434 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(637503), // Rule ID 6052 //
     /* 637439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637451 */     // MIs[0] offset
     /* 637451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637454 */     // MIs[0] auxiliary
     /* 637454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637457 */     // MIs[0] Operand 8
     /* 637457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637475 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 637478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637480 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637489 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637491 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637501 */     GIR_RootConstrainSelectedInstOperands,
     /* 637502 */     // GIR_Coverage, 6052,
     /* 637502 */     GIR_EraseRootFromParent_Done,
     /* 637503 */   // Label 8113: @637503
     /* 637503 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(637569), // Rule ID 6050 //
     /* 637508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637511 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637517 */     // MIs[0] offset
     /* 637517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637520 */     // MIs[0] auxiliary
     /* 637520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637523 */     // MIs[0] Operand 8
     /* 637523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637541 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN),
     /* 637544 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637546 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637555 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637567 */     GIR_RootConstrainSelectedInstOperands,
     /* 637568 */     // GIR_Coverage, 6050,
     /* 637568 */     GIR_EraseRootFromParent_Done,
     /* 637569 */   // Label 8114: @637569
     /* 637569 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(637632), // Rule ID 6058 //
     /* 637574 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637580 */     // MIs[0] offset
     /* 637580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637583 */     // MIs[0] auxiliary
     /* 637583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637586 */     // MIs[0] Operand 8
     /* 637586 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637604 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN),
     /* 637607 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637609 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637618 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637630 */     GIR_RootConstrainSelectedInstOperands,
     /* 637631 */     // GIR_Coverage, 6058,
     /* 637631 */     GIR_EraseRootFromParent_Done,
     /* 637632 */   // Label 8115: @637632
     /* 637632 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(637702), // Rule ID 6046 //
     /* 637637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637648 */     // MIs[0] offset
     /* 637648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637651 */     // MIs[0] auxiliary
     /* 637651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637654 */     // MIs[0] Operand 8
     /* 637654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637672 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN_RTN),
     /* 637675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637677 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637679 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637688 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637700 */     GIR_RootConstrainSelectedInstOperands,
     /* 637701 */     // GIR_Coverage, 6046,
     /* 637701 */     GIR_EraseRootFromParent_Done,
     /* 637702 */   // Label 8116: @637702
     /* 637702 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(637769), // Rule ID 6054 //
     /* 637707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637715 */     // MIs[0] offset
     /* 637715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637718 */     // MIs[0] auxiliary
     /* 637718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637721 */     // MIs[0] Operand 8
     /* 637721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637739 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN),
     /* 637742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637744 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637746 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637755 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637767 */     GIR_RootConstrainSelectedInstOperands,
     /* 637768 */     // GIR_Coverage, 6054,
     /* 637768 */     GIR_EraseRootFromParent_Done,
     /* 637769 */   // Label 8117: @637769
     /* 637769 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(637827), // Rule ID 6049 //
     /* 637774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637777 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637783 */     // MIs[0] offset
     /* 637783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637786 */     // MIs[0] auxiliary
     /* 637786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637789 */     // MIs[0] Operand 8
     /* 637789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637799 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN),
     /* 637802 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637804 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637813 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637825 */     GIR_RootConstrainSelectedInstOperands,
     /* 637826 */     // GIR_Coverage, 6049,
     /* 637826 */     GIR_EraseRootFromParent_Done,
     /* 637827 */   // Label 8118: @637827
     /* 637827 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(637882), // Rule ID 6057 //
     /* 637832 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637838 */     // MIs[0] offset
     /* 637838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637841 */     // MIs[0] auxiliary
     /* 637841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637844 */     // MIs[0] Operand 8
     /* 637844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637854 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN),
     /* 637857 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637859 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637868 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637880 */     GIR_RootConstrainSelectedInstOperands,
     /* 637881 */     // GIR_Coverage, 6057,
     /* 637881 */     GIR_EraseRootFromParent_Done,
     /* 637882 */   // Label 8119: @637882
     /* 637882 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(637944), // Rule ID 6045 //
     /* 637887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637898 */     // MIs[0] offset
     /* 637898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637901 */     // MIs[0] auxiliary
     /* 637901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637904 */     // MIs[0] Operand 8
     /* 637904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637914 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN_RTN),
     /* 637917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637919 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637921 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637930 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637942 */     GIR_RootConstrainSelectedInstOperands,
     /* 637943 */     // GIR_Coverage, 6045,
     /* 637943 */     GIR_EraseRootFromParent_Done,
     /* 637944 */   // Label 8120: @637944
     /* 637944 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(638003), // Rule ID 6053 //
     /* 637949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637957 */     // MIs[0] offset
     /* 637957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637960 */     // MIs[0] auxiliary
     /* 637960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637963 */     // MIs[0] Operand 8
     /* 637963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637973 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN),
     /* 637976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637978 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637980 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637989 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638001 */     GIR_RootConstrainSelectedInstOperands,
     /* 638002 */     // GIR_Coverage, 6053,
     /* 638002 */     GIR_EraseRootFromParent_Done,
     /* 638003 */   // Label 8121: @638003
     /* 638003 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(638099), // Rule ID 6051 //
     /* 638008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638011 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638013 */     // MIs[0] offset
     /* 638013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638016 */     // MIs[0] auxiliary
     /* 638016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638019 */     // MIs[0] Operand 8
     /* 638019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638029 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN),
     /* 638073 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638085 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638097 */     GIR_RootConstrainSelectedInstOperands,
     /* 638098 */     // GIR_Coverage, 6051,
     /* 638098 */     GIR_EraseRootFromParent_Done,
     /* 638099 */   // Label 8122: @638099
     /* 638099 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(638192), // Rule ID 6059 //
     /* 638104 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638106 */     // MIs[0] offset
     /* 638106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638109 */     // MIs[0] auxiliary
     /* 638109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638112 */     // MIs[0] Operand 8
     /* 638112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638122 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638138 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638145 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN),
     /* 638166 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638178 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638190 */     GIR_RootConstrainSelectedInstOperands,
     /* 638191 */     // GIR_Coverage, 6059,
     /* 638191 */     GIR_EraseRootFromParent_Done,
     /* 638192 */   // Label 8123: @638192
     /* 638192 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(638292), // Rule ID 6047 //
     /* 638197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 638204 */     // MIs[0] offset
     /* 638204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638207 */     // MIs[0] auxiliary
     /* 638207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638210 */     // MIs[0] Operand 8
     /* 638210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638220 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638236 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638243 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN),
     /* 638264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638266 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638278 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638290 */     GIR_RootConstrainSelectedInstOperands,
     /* 638291 */     // GIR_Coverage, 6047,
     /* 638291 */     GIR_EraseRootFromParent_Done,
     /* 638292 */   // Label 8124: @638292
     /* 638292 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(638389), // Rule ID 6055 //
     /* 638297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 638301 */     // MIs[0] offset
     /* 638301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638304 */     // MIs[0] auxiliary
     /* 638304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638307 */     // MIs[0] Operand 8
     /* 638307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638317 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638333 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638340 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN),
     /* 638361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638363 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638375 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638387 */     GIR_RootConstrainSelectedInstOperands,
     /* 638388 */     // GIR_Coverage, 6055,
     /* 638388 */     GIR_EraseRootFromParent_Done,
     /* 638389 */   // Label 8125: @638389
     /* 638389 */   GIM_Reject,
     /* 638390 */ // Label 8109: @638390
     /* 638390 */ GIM_Reject,
     /* 638391 */ // Label 8091: @638391
     /* 638391 */ GIM_Reject,
     /* 638392 */ // Label 109: @638392
     /* 638392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8128*/ GIMT_Encode4(640775),
     /* 638403 */ /*GILLT_s32*//*Label 8126*/ GIMT_Encode4(638411),
     /* 638407 */ /*GILLT_s64*//*Label 8127*/ GIMT_Encode4(639593),
     /* 638411 */ // Label 8126: @638411
     /* 638411 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(639592),
     /* 638416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 638419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 638422 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 638425 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 638428 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 638431 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(638499), // Rule ID 5944 //
     /* 638436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638439 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638449 */     // MIs[0] offset
     /* 638449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638452 */     // MIs[0] auxiliary
     /* 638452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638455 */     // MIs[0] Operand 8
     /* 638455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638473 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 638476 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638485 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638497 */     GIR_RootConstrainSelectedInstOperands,
     /* 638498 */     // GIR_Coverage, 5944,
     /* 638498 */     GIR_EraseRootFromParent_Done,
     /* 638499 */   // Label 8130: @638499
     /* 638499 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(638564), // Rule ID 5952 //
     /* 638504 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638514 */     // MIs[0] offset
     /* 638514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638517 */     // MIs[0] auxiliary
     /* 638517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638520 */     // MIs[0] Operand 8
     /* 638520 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638538 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 638541 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638550 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638562 */     GIR_RootConstrainSelectedInstOperands,
     /* 638563 */     // GIR_Coverage, 5952,
     /* 638563 */     GIR_EraseRootFromParent_Done,
     /* 638564 */   // Label 8131: @638564
     /* 638564 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(638636), // Rule ID 5940 //
     /* 638569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638584 */     // MIs[0] offset
     /* 638584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638587 */     // MIs[0] auxiliary
     /* 638587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638590 */     // MIs[0] Operand 8
     /* 638590 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638608 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 638611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638613 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638622 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638634 */     GIR_RootConstrainSelectedInstOperands,
     /* 638635 */     // GIR_Coverage, 5940,
     /* 638635 */     GIR_EraseRootFromParent_Done,
     /* 638636 */   // Label 8132: @638636
     /* 638636 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(638705), // Rule ID 5948 //
     /* 638641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638653 */     // MIs[0] offset
     /* 638653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638656 */     // MIs[0] auxiliary
     /* 638656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638659 */     // MIs[0] Operand 8
     /* 638659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638677 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 638680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638682 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638691 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638703 */     GIR_RootConstrainSelectedInstOperands,
     /* 638704 */     // GIR_Coverage, 5948,
     /* 638704 */     GIR_EraseRootFromParent_Done,
     /* 638705 */   // Label 8133: @638705
     /* 638705 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(638771), // Rule ID 5946 //
     /* 638710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638713 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638719 */     // MIs[0] offset
     /* 638719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638722 */     // MIs[0] auxiliary
     /* 638722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638725 */     // MIs[0] Operand 8
     /* 638725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638743 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN),
     /* 638746 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638748 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638757 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638769 */     GIR_RootConstrainSelectedInstOperands,
     /* 638770 */     // GIR_Coverage, 5946,
     /* 638770 */     GIR_EraseRootFromParent_Done,
     /* 638771 */   // Label 8134: @638771
     /* 638771 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(638834), // Rule ID 5954 //
     /* 638776 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638782 */     // MIs[0] offset
     /* 638782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638785 */     // MIs[0] auxiliary
     /* 638785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638788 */     // MIs[0] Operand 8
     /* 638788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638806 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN),
     /* 638809 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638811 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638820 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638832 */     GIR_RootConstrainSelectedInstOperands,
     /* 638833 */     // GIR_Coverage, 5954,
     /* 638833 */     GIR_EraseRootFromParent_Done,
     /* 638834 */   // Label 8135: @638834
     /* 638834 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(638904), // Rule ID 5942 //
     /* 638839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638850 */     // MIs[0] offset
     /* 638850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638853 */     // MIs[0] auxiliary
     /* 638853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638856 */     // MIs[0] Operand 8
     /* 638856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638874 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN_RTN),
     /* 638877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638879 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638881 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638890 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638902 */     GIR_RootConstrainSelectedInstOperands,
     /* 638903 */     // GIR_Coverage, 5942,
     /* 638903 */     GIR_EraseRootFromParent_Done,
     /* 638904 */   // Label 8136: @638904
     /* 638904 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(638971), // Rule ID 5950 //
     /* 638909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638917 */     // MIs[0] offset
     /* 638917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638920 */     // MIs[0] auxiliary
     /* 638920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638923 */     // MIs[0] Operand 8
     /* 638923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638941 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN),
     /* 638944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638946 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638948 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638957 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638969 */     GIR_RootConstrainSelectedInstOperands,
     /* 638970 */     // GIR_Coverage, 5950,
     /* 638970 */     GIR_EraseRootFromParent_Done,
     /* 638971 */   // Label 8137: @638971
     /* 638971 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(639029), // Rule ID 5945 //
     /* 638976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638979 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638985 */     // MIs[0] offset
     /* 638985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638988 */     // MIs[0] auxiliary
     /* 638988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638991 */     // MIs[0] Operand 8
     /* 638991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639001 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN),
     /* 639004 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639006 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639015 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639027 */     GIR_RootConstrainSelectedInstOperands,
     /* 639028 */     // GIR_Coverage, 5945,
     /* 639028 */     GIR_EraseRootFromParent_Done,
     /* 639029 */   // Label 8138: @639029
     /* 639029 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(639084), // Rule ID 5953 //
     /* 639034 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639040 */     // MIs[0] offset
     /* 639040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639043 */     // MIs[0] auxiliary
     /* 639043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639046 */     // MIs[0] Operand 8
     /* 639046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639056 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN),
     /* 639059 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639061 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639070 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639082 */     GIR_RootConstrainSelectedInstOperands,
     /* 639083 */     // GIR_Coverage, 5953,
     /* 639083 */     GIR_EraseRootFromParent_Done,
     /* 639084 */   // Label 8139: @639084
     /* 639084 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(639146), // Rule ID 5941 //
     /* 639089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639100 */     // MIs[0] offset
     /* 639100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639103 */     // MIs[0] auxiliary
     /* 639103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639106 */     // MIs[0] Operand 8
     /* 639106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639116 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN_RTN),
     /* 639119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639121 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639123 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639132 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639144 */     GIR_RootConstrainSelectedInstOperands,
     /* 639145 */     // GIR_Coverage, 5941,
     /* 639145 */     GIR_EraseRootFromParent_Done,
     /* 639146 */   // Label 8140: @639146
     /* 639146 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(639205), // Rule ID 5949 //
     /* 639151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639159 */     // MIs[0] offset
     /* 639159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639162 */     // MIs[0] auxiliary
     /* 639162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639165 */     // MIs[0] Operand 8
     /* 639165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639175 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN),
     /* 639178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639180 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639182 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639191 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639203 */     GIR_RootConstrainSelectedInstOperands,
     /* 639204 */     // GIR_Coverage, 5949,
     /* 639204 */     GIR_EraseRootFromParent_Done,
     /* 639205 */   // Label 8141: @639205
     /* 639205 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(639301), // Rule ID 5947 //
     /* 639210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639213 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639215 */     // MIs[0] offset
     /* 639215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639218 */     // MIs[0] auxiliary
     /* 639218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639221 */     // MIs[0] Operand 8
     /* 639221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639231 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639247 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639254 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN),
     /* 639275 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639287 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639299 */     GIR_RootConstrainSelectedInstOperands,
     /* 639300 */     // GIR_Coverage, 5947,
     /* 639300 */     GIR_EraseRootFromParent_Done,
     /* 639301 */   // Label 8142: @639301
     /* 639301 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(639394), // Rule ID 5955 //
     /* 639306 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639308 */     // MIs[0] offset
     /* 639308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639311 */     // MIs[0] auxiliary
     /* 639311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639314 */     // MIs[0] Operand 8
     /* 639314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639324 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639340 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639347 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN),
     /* 639368 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639380 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639382 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639392 */     GIR_RootConstrainSelectedInstOperands,
     /* 639393 */     // GIR_Coverage, 5955,
     /* 639393 */     GIR_EraseRootFromParent_Done,
     /* 639394 */   // Label 8143: @639394
     /* 639394 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(639494), // Rule ID 5943 //
     /* 639399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639406 */     // MIs[0] offset
     /* 639406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639409 */     // MIs[0] auxiliary
     /* 639409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639412 */     // MIs[0] Operand 8
     /* 639412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639422 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639438 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639445 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN_RTN),
     /* 639466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639468 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639480 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639492 */     GIR_RootConstrainSelectedInstOperands,
     /* 639493 */     // GIR_Coverage, 5943,
     /* 639493 */     GIR_EraseRootFromParent_Done,
     /* 639494 */   // Label 8144: @639494
     /* 639494 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(639591), // Rule ID 5951 //
     /* 639499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639503 */     // MIs[0] offset
     /* 639503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639506 */     // MIs[0] auxiliary
     /* 639506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639509 */     // MIs[0] Operand 8
     /* 639509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639519 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639535 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639542 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN),
     /* 639563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639565 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639577 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639589 */     GIR_RootConstrainSelectedInstOperands,
     /* 639590 */     // GIR_Coverage, 5951,
     /* 639590 */     GIR_EraseRootFromParent_Done,
     /* 639591 */   // Label 8145: @639591
     /* 639591 */   GIM_Reject,
     /* 639592 */ // Label 8129: @639592
     /* 639592 */ GIM_Reject,
     /* 639593 */ // Label 8127: @639593
     /* 639593 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(640774),
     /* 639598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 639601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 639604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 639607 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 639610 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 639613 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(639681), // Rule ID 6144 //
     /* 639618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639621 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639631 */     // MIs[0] offset
     /* 639631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639634 */     // MIs[0] auxiliary
     /* 639634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639637 */     // MIs[0] Operand 8
     /* 639637 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639655 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 639658 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639667 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639669 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639679 */     GIR_RootConstrainSelectedInstOperands,
     /* 639680 */     // GIR_Coverage, 6144,
     /* 639680 */     GIR_EraseRootFromParent_Done,
     /* 639681 */   // Label 8147: @639681
     /* 639681 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(639746), // Rule ID 6152 //
     /* 639686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639696 */     // MIs[0] offset
     /* 639696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639699 */     // MIs[0] auxiliary
     /* 639699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639702 */     // MIs[0] Operand 8
     /* 639702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639720 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 639723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639732 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639744 */     GIR_RootConstrainSelectedInstOperands,
     /* 639745 */     // GIR_Coverage, 6152,
     /* 639745 */     GIR_EraseRootFromParent_Done,
     /* 639746 */   // Label 8148: @639746
     /* 639746 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(639818), // Rule ID 6140 //
     /* 639751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639766 */     // MIs[0] offset
     /* 639766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639769 */     // MIs[0] auxiliary
     /* 639769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639772 */     // MIs[0] Operand 8
     /* 639772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639790 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 639793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639795 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639804 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639816 */     GIR_RootConstrainSelectedInstOperands,
     /* 639817 */     // GIR_Coverage, 6140,
     /* 639817 */     GIR_EraseRootFromParent_Done,
     /* 639818 */   // Label 8149: @639818
     /* 639818 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(639887), // Rule ID 6148 //
     /* 639823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639835 */     // MIs[0] offset
     /* 639835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639838 */     // MIs[0] auxiliary
     /* 639838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639841 */     // MIs[0] Operand 8
     /* 639841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639859 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 639862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639864 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639873 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639885 */     GIR_RootConstrainSelectedInstOperands,
     /* 639886 */     // GIR_Coverage, 6148,
     /* 639886 */     GIR_EraseRootFromParent_Done,
     /* 639887 */   // Label 8150: @639887
     /* 639887 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(639953), // Rule ID 6146 //
     /* 639892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639895 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639901 */     // MIs[0] offset
     /* 639901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639904 */     // MIs[0] auxiliary
     /* 639904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639907 */     // MIs[0] Operand 8
     /* 639907 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639925 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN),
     /* 639928 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639930 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639939 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639951 */     GIR_RootConstrainSelectedInstOperands,
     /* 639952 */     // GIR_Coverage, 6146,
     /* 639952 */     GIR_EraseRootFromParent_Done,
     /* 639953 */   // Label 8151: @639953
     /* 639953 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(640016), // Rule ID 6154 //
     /* 639958 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639964 */     // MIs[0] offset
     /* 639964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639967 */     // MIs[0] auxiliary
     /* 639967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639970 */     // MIs[0] Operand 8
     /* 639970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639988 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN),
     /* 639991 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639993 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640002 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640014 */     GIR_RootConstrainSelectedInstOperands,
     /* 640015 */     // GIR_Coverage, 6154,
     /* 640015 */     GIR_EraseRootFromParent_Done,
     /* 640016 */   // Label 8152: @640016
     /* 640016 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(640086), // Rule ID 6142 //
     /* 640021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640032 */     // MIs[0] offset
     /* 640032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640035 */     // MIs[0] auxiliary
     /* 640035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640038 */     // MIs[0] Operand 8
     /* 640038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640056 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN_RTN),
     /* 640059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640061 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640063 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640072 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640084 */     GIR_RootConstrainSelectedInstOperands,
     /* 640085 */     // GIR_Coverage, 6142,
     /* 640085 */     GIR_EraseRootFromParent_Done,
     /* 640086 */   // Label 8153: @640086
     /* 640086 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(640153), // Rule ID 6150 //
     /* 640091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640099 */     // MIs[0] offset
     /* 640099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640102 */     // MIs[0] auxiliary
     /* 640102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640105 */     // MIs[0] Operand 8
     /* 640105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640123 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN),
     /* 640126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640128 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640130 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640139 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640151 */     GIR_RootConstrainSelectedInstOperands,
     /* 640152 */     // GIR_Coverage, 6150,
     /* 640152 */     GIR_EraseRootFromParent_Done,
     /* 640153 */   // Label 8154: @640153
     /* 640153 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(640211), // Rule ID 6145 //
     /* 640158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640161 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640167 */     // MIs[0] offset
     /* 640167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640170 */     // MIs[0] auxiliary
     /* 640170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640173 */     // MIs[0] Operand 8
     /* 640173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640183 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN),
     /* 640186 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640188 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640197 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640209 */     GIR_RootConstrainSelectedInstOperands,
     /* 640210 */     // GIR_Coverage, 6145,
     /* 640210 */     GIR_EraseRootFromParent_Done,
     /* 640211 */   // Label 8155: @640211
     /* 640211 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(640266), // Rule ID 6153 //
     /* 640216 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640222 */     // MIs[0] offset
     /* 640222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640225 */     // MIs[0] auxiliary
     /* 640225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640228 */     // MIs[0] Operand 8
     /* 640228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640238 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN),
     /* 640241 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640243 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640252 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640264 */     GIR_RootConstrainSelectedInstOperands,
     /* 640265 */     // GIR_Coverage, 6153,
     /* 640265 */     GIR_EraseRootFromParent_Done,
     /* 640266 */   // Label 8156: @640266
     /* 640266 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(640328), // Rule ID 6141 //
     /* 640271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640282 */     // MIs[0] offset
     /* 640282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640285 */     // MIs[0] auxiliary
     /* 640285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640288 */     // MIs[0] Operand 8
     /* 640288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640298 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN_RTN),
     /* 640301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640303 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640305 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640314 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640326 */     GIR_RootConstrainSelectedInstOperands,
     /* 640327 */     // GIR_Coverage, 6141,
     /* 640327 */     GIR_EraseRootFromParent_Done,
     /* 640328 */   // Label 8157: @640328
     /* 640328 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(640387), // Rule ID 6149 //
     /* 640333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640341 */     // MIs[0] offset
     /* 640341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640344 */     // MIs[0] auxiliary
     /* 640344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640347 */     // MIs[0] Operand 8
     /* 640347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640357 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN),
     /* 640360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640362 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640364 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640373 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640385 */     GIR_RootConstrainSelectedInstOperands,
     /* 640386 */     // GIR_Coverage, 6149,
     /* 640386 */     GIR_EraseRootFromParent_Done,
     /* 640387 */   // Label 8158: @640387
     /* 640387 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(640483), // Rule ID 6147 //
     /* 640392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640397 */     // MIs[0] offset
     /* 640397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640400 */     // MIs[0] auxiliary
     /* 640400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640403 */     // MIs[0] Operand 8
     /* 640403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640413 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640429 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640436 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN),
     /* 640457 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640469 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640481 */     GIR_RootConstrainSelectedInstOperands,
     /* 640482 */     // GIR_Coverage, 6147,
     /* 640482 */     GIR_EraseRootFromParent_Done,
     /* 640483 */   // Label 8159: @640483
     /* 640483 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(640576), // Rule ID 6155 //
     /* 640488 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640490 */     // MIs[0] offset
     /* 640490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640493 */     // MIs[0] auxiliary
     /* 640493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640496 */     // MIs[0] Operand 8
     /* 640496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640506 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640522 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640529 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN),
     /* 640550 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640562 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640574 */     GIR_RootConstrainSelectedInstOperands,
     /* 640575 */     // GIR_Coverage, 6155,
     /* 640575 */     GIR_EraseRootFromParent_Done,
     /* 640576 */   // Label 8160: @640576
     /* 640576 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(640676), // Rule ID 6143 //
     /* 640581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640588 */     // MIs[0] offset
     /* 640588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640591 */     // MIs[0] auxiliary
     /* 640591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640594 */     // MIs[0] Operand 8
     /* 640594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640604 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640620 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640627 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN_RTN),
     /* 640648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640650 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640662 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640674 */     GIR_RootConstrainSelectedInstOperands,
     /* 640675 */     // GIR_Coverage, 6143,
     /* 640675 */     GIR_EraseRootFromParent_Done,
     /* 640676 */   // Label 8161: @640676
     /* 640676 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(640773), // Rule ID 6151 //
     /* 640681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640685 */     // MIs[0] offset
     /* 640685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640688 */     // MIs[0] auxiliary
     /* 640688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640691 */     // MIs[0] Operand 8
     /* 640691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640701 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640717 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN),
     /* 640745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640747 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640759 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640771 */     GIR_RootConstrainSelectedInstOperands,
     /* 640772 */     // GIR_Coverage, 6151,
     /* 640772 */     GIR_EraseRootFromParent_Done,
     /* 640773 */   // Label 8162: @640773
     /* 640773 */   GIM_Reject,
     /* 640774 */ // Label 8146: @640774
     /* 640774 */ GIM_Reject,
     /* 640775 */ // Label 8128: @640775
     /* 640775 */ GIM_Reject,
     /* 640776 */ // Label 110: @640776
     /* 640776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8165*/ GIMT_Encode4(645069),
     /* 640787 */ /*GILLT_s32*//*Label 8163*/ GIMT_Encode4(640795),
     /* 640791 */ /*GILLT_s64*//*Label 8164*/ GIMT_Encode4(642932),
     /* 640795 */ // Label 8163: @640795
     /* 640795 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(642931),
     /* 640800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 640803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 640806 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 640809 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 640812 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 640815 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 640818 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(640928), // Rule ID 6384 //
     /* 640823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640826 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640836 */     // MIs[0] offset
     /* 640836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640839 */     // MIs[0] auxiliary
     /* 640839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640842 */     // MIs[0] Operand 9
     /* 640842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640860 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640876 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640883 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 640904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 640909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640914 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 640916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640926 */     GIR_RootConstrainSelectedInstOperands,
     /* 640927 */     // GIR_Coverage, 6384,
     /* 640927 */     GIR_EraseRootFromParent_Done,
     /* 640928 */   // Label 8167: @640928
     /* 640928 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(641035), // Rule ID 6392 //
     /* 640933 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640943 */     // MIs[0] offset
     /* 640943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640946 */     // MIs[0] auxiliary
     /* 640946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640949 */     // MIs[0] Operand 9
     /* 640949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640967 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640983 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640990 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 641011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641021 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641033 */     GIR_RootConstrainSelectedInstOperands,
     /* 641034 */     // GIR_Coverage, 6392,
     /* 641034 */     GIR_EraseRootFromParent_Done,
     /* 641035 */   // Label 8168: @641035
     /* 641035 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(641183), // Rule ID 6380 //
     /* 641040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641055 */     // MIs[0] offset
     /* 641055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641058 */     // MIs[0] auxiliary
     /* 641058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641061 */     // MIs[0] Operand 9
     /* 641061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641079 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641091 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641095 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641102 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 641127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641148 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641154 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641182 */     // GIR_Coverage, 6380,
     /* 641182 */     GIR_EraseRootFromParent_Done,
     /* 641183 */   // Label 8169: @641183
     /* 641183 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(641328), // Rule ID 6388 //
     /* 641188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641200 */     // MIs[0] offset
     /* 641200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641203 */     // MIs[0] auxiliary
     /* 641203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641206 */     // MIs[0] Operand 9
     /* 641206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641224 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641224 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641227 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641231 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641236 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641240 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641247 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 641272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641293 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641299 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641310 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641327 */     // GIR_Coverage, 6388,
     /* 641327 */     GIR_EraseRootFromParent_Done,
     /* 641328 */   // Label 8170: @641328
     /* 641328 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(641436), // Rule ID 6386 //
     /* 641333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641336 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641342 */     // MIs[0] offset
     /* 641342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641345 */     // MIs[0] auxiliary
     /* 641345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641348 */     // MIs[0] Operand 9
     /* 641348 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641366 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641382 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641389 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN),
     /* 641410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641413 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 641415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641422 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641434 */     GIR_RootConstrainSelectedInstOperands,
     /* 641435 */     // GIR_Coverage, 6386,
     /* 641435 */     GIR_EraseRootFromParent_Done,
     /* 641436 */   // Label 8171: @641436
     /* 641436 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(641541), // Rule ID 6394 //
     /* 641441 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641447 */     // MIs[0] offset
     /* 641447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641450 */     // MIs[0] auxiliary
     /* 641450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641453 */     // MIs[0] Operand 9
     /* 641453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641471 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN),
     /* 641515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641518 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 641520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641527 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641539 */     GIR_RootConstrainSelectedInstOperands,
     /* 641540 */     // GIR_Coverage, 6394,
     /* 641540 */     GIR_EraseRootFromParent_Done,
     /* 641541 */   // Label 8172: @641541
     /* 641541 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(641689), // Rule ID 6382 //
     /* 641546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641557 */     // MIs[0] offset
     /* 641557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641560 */     // MIs[0] auxiliary
     /* 641560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641563 */     // MIs[0] Operand 9
     /* 641563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641581 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641597 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641604 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN),
     /* 641629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 641641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641654 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641660 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641688 */     // GIR_Coverage, 6382,
     /* 641688 */     GIR_EraseRootFromParent_Done,
     /* 641689 */   // Label 8173: @641689
     /* 641689 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(641834), // Rule ID 6390 //
     /* 641694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641702 */     // MIs[0] offset
     /* 641702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641705 */     // MIs[0] auxiliary
     /* 641705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641708 */     // MIs[0] Operand 9
     /* 641708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641726 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641742 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641749 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN),
     /* 641774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 641786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641799 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641816 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641833 */     // GIR_Coverage, 6390,
     /* 641833 */     GIR_EraseRootFromParent_Done,
     /* 641834 */   // Label 8174: @641834
     /* 641834 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(641934), // Rule ID 6385 //
     /* 641839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641842 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641848 */     // MIs[0] offset
     /* 641848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641851 */     // MIs[0] auxiliary
     /* 641851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641854 */     // MIs[0] Operand 9
     /* 641854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641864 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641880 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641887 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN),
     /* 641908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 641913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641920 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641932 */     GIR_RootConstrainSelectedInstOperands,
     /* 641933 */     // GIR_Coverage, 6385,
     /* 641933 */     GIR_EraseRootFromParent_Done,
     /* 641934 */   // Label 8175: @641934
     /* 641934 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(642031), // Rule ID 6393 //
     /* 641939 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641945 */     // MIs[0] offset
     /* 641945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641948 */     // MIs[0] auxiliary
     /* 641948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641951 */     // MIs[0] Operand 9
     /* 641951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641961 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641977 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN),
     /* 642005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 642010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642017 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642029 */     GIR_RootConstrainSelectedInstOperands,
     /* 642030 */     // GIR_Coverage, 6393,
     /* 642030 */     GIR_EraseRootFromParent_Done,
     /* 642031 */   // Label 8176: @642031
     /* 642031 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(642171), // Rule ID 6381 //
     /* 642036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642047 */     // MIs[0] offset
     /* 642047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642050 */     // MIs[0] auxiliary
     /* 642050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642053 */     // MIs[0] Operand 9
     /* 642053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642063 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642079 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642082 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642086 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN),
     /* 642111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642136 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642142 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642170 */     // GIR_Coverage, 6381,
     /* 642170 */     GIR_EraseRootFromParent_Done,
     /* 642171 */   // Label 8177: @642171
     /* 642171 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(642308), // Rule ID 6389 //
     /* 642176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642184 */     // MIs[0] offset
     /* 642184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642187 */     // MIs[0] auxiliary
     /* 642187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642190 */     // MIs[0] Operand 9
     /* 642190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642200 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642216 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642223 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN),
     /* 642248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642273 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642279 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642307 */     // GIR_Coverage, 6389,
     /* 642307 */     GIR_EraseRootFromParent_Done,
     /* 642308 */   // Label 8178: @642308
     /* 642308 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(642446), // Rule ID 6387 //
     /* 642313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642316 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642318 */     // MIs[0] offset
     /* 642318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642321 */     // MIs[0] auxiliary
     /* 642321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642324 */     // MIs[0] Operand 9
     /* 642324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642334 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642346 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642350 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642357 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642387 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642391 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642398 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN),
     /* 642419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 642425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642432 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642444 */     GIR_RootConstrainSelectedInstOperands,
     /* 642445 */     // GIR_Coverage, 6387,
     /* 642445 */     GIR_EraseRootFromParent_Done,
     /* 642446 */   // Label 8179: @642446
     /* 642446 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(642581), // Rule ID 6395 //
     /* 642451 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642453 */     // MIs[0] offset
     /* 642453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642456 */     // MIs[0] auxiliary
     /* 642456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642459 */     // MIs[0] Operand 9
     /* 642459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642469 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642485 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642492 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642526 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642533 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN),
     /* 642554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 642560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642567 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642579 */     GIR_RootConstrainSelectedInstOperands,
     /* 642580 */     // GIR_Coverage, 6395,
     /* 642580 */     GIR_EraseRootFromParent_Done,
     /* 642581 */   // Label 8180: @642581
     /* 642581 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(642757), // Rule ID 6383 //
     /* 642586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642593 */     // MIs[0] offset
     /* 642593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642596 */     // MIs[0] auxiliary
     /* 642596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642599 */     // MIs[0] Operand 9
     /* 642599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642609 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 642612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642621 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642625 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 642628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642632 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 642635 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642640 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642645 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642666 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642669 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642673 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN),
     /* 642698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 642709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642722 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642728 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642756 */     // GIR_Coverage, 6383,
     /* 642756 */     GIR_EraseRootFromParent_Done,
     /* 642757 */   // Label 8181: @642757
     /* 642757 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(642930), // Rule ID 6391 //
     /* 642762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642766 */     // MIs[0] offset
     /* 642766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642769 */     // MIs[0] auxiliary
     /* 642769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642772 */     // MIs[0] Operand 9
     /* 642772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642782 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9787:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642782 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 642785 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642789 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642794 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642798 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 642801 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642805 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 642808 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642813 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642818 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642839 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642846 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN),
     /* 642871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642876 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 642882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642895 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642929 */     // GIR_Coverage, 6391,
     /* 642929 */     GIR_EraseRootFromParent_Done,
     /* 642930 */   // Label 8182: @642930
     /* 642930 */   GIM_Reject,
     /* 642931 */ // Label 8166: @642931
     /* 642931 */ GIM_Reject,
     /* 642932 */ // Label 8164: @642932
     /* 642932 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(645068),
     /* 642937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 642940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 642943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 642946 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 642949 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 642952 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 642955 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(643065), // Rule ID 6400 //
     /* 642960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642963 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642973 */     // MIs[0] offset
     /* 642973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642976 */     // MIs[0] auxiliary
     /* 642976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642979 */     // MIs[0] Operand 9
     /* 642979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 642990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642997 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643013 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643020 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 643041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643051 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643063 */     GIR_RootConstrainSelectedInstOperands,
     /* 643064 */     // GIR_Coverage, 6400,
     /* 643064 */     GIR_EraseRootFromParent_Done,
     /* 643065 */   // Label 8184: @643065
     /* 643065 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(643172), // Rule ID 6408 //
     /* 643070 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643080 */     // MIs[0] offset
     /* 643080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643083 */     // MIs[0] auxiliary
     /* 643083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643086 */     // MIs[0] Operand 9
     /* 643086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643104 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643120 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643127 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 643148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643158 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643170 */     GIR_RootConstrainSelectedInstOperands,
     /* 643171 */     // GIR_Coverage, 6408,
     /* 643171 */     GIR_EraseRootFromParent_Done,
     /* 643172 */   // Label 8185: @643172
     /* 643172 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(643320), // Rule ID 6396 //
     /* 643177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643192 */     // MIs[0] offset
     /* 643192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643195 */     // MIs[0] auxiliary
     /* 643195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643198 */     // MIs[0] Operand 9
     /* 643198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643216 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643228 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643232 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643239 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 643264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643285 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643291 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643302 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643319 */     // GIR_Coverage, 6396,
     /* 643319 */     GIR_EraseRootFromParent_Done,
     /* 643320 */   // Label 8186: @643320
     /* 643320 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(643465), // Rule ID 6404 //
     /* 643325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643337 */     // MIs[0] offset
     /* 643337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643340 */     // MIs[0] auxiliary
     /* 643340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643343 */     // MIs[0] Operand 9
     /* 643343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643361 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643377 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643380 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643384 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643397 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 643409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643430 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643436 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643464 */     // GIR_Coverage, 6404,
     /* 643464 */     GIR_EraseRootFromParent_Done,
     /* 643465 */   // Label 8187: @643465
     /* 643465 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(643573), // Rule ID 6402 //
     /* 643470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643473 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643479 */     // MIs[0] offset
     /* 643479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643482 */     // MIs[0] auxiliary
     /* 643482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643485 */     // MIs[0] Operand 9
     /* 643485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643503 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643519 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643526 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN),
     /* 643547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643550 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 643552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643559 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643571 */     GIR_RootConstrainSelectedInstOperands,
     /* 643572 */     // GIR_Coverage, 6402,
     /* 643572 */     GIR_EraseRootFromParent_Done,
     /* 643573 */   // Label 8188: @643573
     /* 643573 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(643678), // Rule ID 6410 //
     /* 643578 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643584 */     // MIs[0] offset
     /* 643584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643587 */     // MIs[0] auxiliary
     /* 643587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643590 */     // MIs[0] Operand 9
     /* 643590 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643608 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643624 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643631 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN),
     /* 643652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643655 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 643657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643664 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643676 */     GIR_RootConstrainSelectedInstOperands,
     /* 643677 */     // GIR_Coverage, 6410,
     /* 643677 */     GIR_EraseRootFromParent_Done,
     /* 643678 */   // Label 8189: @643678
     /* 643678 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(643826), // Rule ID 6398 //
     /* 643683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643694 */     // MIs[0] offset
     /* 643694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643697 */     // MIs[0] auxiliary
     /* 643697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643700 */     // MIs[0] Operand 9
     /* 643700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643718 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643734 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643741 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN),
     /* 643766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 643778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643791 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643808 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643825 */     // GIR_Coverage, 6398,
     /* 643825 */     GIR_EraseRootFromParent_Done,
     /* 643826 */   // Label 8190: @643826
     /* 643826 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(643971), // Rule ID 6406 //
     /* 643831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643839 */     // MIs[0] offset
     /* 643839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643842 */     // MIs[0] auxiliary
     /* 643842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643845 */     // MIs[0] Operand 9
     /* 643845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643863 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643879 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643886 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN),
     /* 643911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 643923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643936 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643970 */     // GIR_Coverage, 6406,
     /* 643970 */     GIR_EraseRootFromParent_Done,
     /* 643971 */   // Label 8191: @643971
     /* 643971 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(644071), // Rule ID 6401 //
     /* 643976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643979 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643985 */     // MIs[0] offset
     /* 643985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643988 */     // MIs[0] auxiliary
     /* 643988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643991 */     // MIs[0] Operand 9
     /* 643991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 643994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644001 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644017 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644024 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN),
     /* 644045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 644050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644057 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644069 */     GIR_RootConstrainSelectedInstOperands,
     /* 644070 */     // GIR_Coverage, 6401,
     /* 644070 */     GIR_EraseRootFromParent_Done,
     /* 644071 */   // Label 8192: @644071
     /* 644071 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(644168), // Rule ID 6409 //
     /* 644076 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 644082 */     // MIs[0] offset
     /* 644082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644085 */     // MIs[0] auxiliary
     /* 644085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644088 */     // MIs[0] Operand 9
     /* 644088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644098 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644114 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN),
     /* 644142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 644147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644154 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644166 */     GIR_RootConstrainSelectedInstOperands,
     /* 644167 */     // GIR_Coverage, 6409,
     /* 644167 */     GIR_EraseRootFromParent_Done,
     /* 644168 */   // Label 8193: @644168
     /* 644168 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(644308), // Rule ID 6397 //
     /* 644173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 644184 */     // MIs[0] offset
     /* 644184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644187 */     // MIs[0] auxiliary
     /* 644187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644190 */     // MIs[0] Operand 9
     /* 644190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644200 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644200 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644203 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644207 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644216 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644223 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN),
     /* 644248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644273 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644279 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644307 */     // GIR_Coverage, 6397,
     /* 644307 */     GIR_EraseRootFromParent_Done,
     /* 644308 */   // Label 8194: @644308
     /* 644308 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(644445), // Rule ID 6405 //
     /* 644313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 644321 */     // MIs[0] offset
     /* 644321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644324 */     // MIs[0] auxiliary
     /* 644324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644327 */     // MIs[0] Operand 9
     /* 644327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644337 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644349 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644353 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644356 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644360 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644363 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN),
     /* 644385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644410 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644416 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644444 */     // GIR_Coverage, 6405,
     /* 644444 */     GIR_EraseRootFromParent_Done,
     /* 644445 */   // Label 8195: @644445
     /* 644445 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(644583), // Rule ID 6403 //
     /* 644450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644453 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644455 */     // MIs[0] offset
     /* 644455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644458 */     // MIs[0] auxiliary
     /* 644458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644461 */     // MIs[0] Operand 9
     /* 644461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644471 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 644474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644487 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 644490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644494 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 644497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644528 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644535 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN),
     /* 644556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 644562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644569 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644581 */     GIR_RootConstrainSelectedInstOperands,
     /* 644582 */     // GIR_Coverage, 6403,
     /* 644582 */     GIR_EraseRootFromParent_Done,
     /* 644583 */   // Label 8196: @644583
     /* 644583 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(644718), // Rule ID 6411 //
     /* 644588 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644590 */     // MIs[0] offset
     /* 644590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644593 */     // MIs[0] auxiliary
     /* 644593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644596 */     // MIs[0] Operand 9
     /* 644596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644606 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 644609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644622 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 644625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644629 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 644632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644663 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644670 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN),
     /* 644691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 644697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644704 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644716 */     GIR_RootConstrainSelectedInstOperands,
     /* 644717 */     // GIR_Coverage, 6411,
     /* 644717 */     GIR_EraseRootFromParent_Done,
     /* 644718 */   // Label 8197: @644718
     /* 644718 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(644894), // Rule ID 6399 //
     /* 644723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644730 */     // MIs[0] offset
     /* 644730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644733 */     // MIs[0] auxiliary
     /* 644733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644736 */     // MIs[0] Operand 9
     /* 644736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644746 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644746 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 644749 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644753 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644758 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644762 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 644765 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644769 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 644772 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644777 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644782 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644803 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644806 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644810 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN),
     /* 644835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644840 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 644846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644859 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644865 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644893 */     // GIR_Coverage, 6399,
     /* 644893 */     GIR_EraseRootFromParent_Done,
     /* 644894 */   // Label 8198: @644894
     /* 644894 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(645067), // Rule ID 6407 //
     /* 644899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644903 */     // MIs[0] offset
     /* 644903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644906 */     // MIs[0] auxiliary
     /* 644906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644909 */     // MIs[0] Operand 9
     /* 644909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644919 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9786:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644919 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 644922 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644926 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644931 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644935 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 644938 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644942 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 644945 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644950 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644955 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644972 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644976 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644983 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 645004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 645008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645013 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 645016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 645019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 645023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 645032 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645038 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 645044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 645047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 645049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 645056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 645061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 645066 */     // GIR_Coverage, 6407,
     /* 645066 */     GIR_EraseRootFromParent_Done,
     /* 645067 */   // Label 8199: @645067
     /* 645067 */   GIM_Reject,
     /* 645068 */ // Label 8183: @645068
     /* 645068 */ GIM_Reject,
     /* 645069 */ // Label 8165: @645069
     /* 645069 */ GIM_Reject,
     /* 645070 */ // Label 111: @645070
     /* 645070 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(645686),
     /* 645075 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 645078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 645081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 645084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 645087 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 645090 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 645093 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(645161), // Rule ID 6232 //
     /* 645098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645101 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645111 */     // MIs[0] offset
     /* 645111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645114 */     // MIs[0] auxiliary
     /* 645114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645117 */     // MIs[0] Operand 8
     /* 645117 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645135 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET),
     /* 645138 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645147 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645159 */     GIR_RootConstrainSelectedInstOperands,
     /* 645160 */     // GIR_Coverage, 6232,
     /* 645160 */     GIR_EraseRootFromParent_Done,
     /* 645161 */   // Label 8201: @645161
     /* 645161 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(645233), // Rule ID 6228 //
     /* 645166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645181 */     // MIs[0] offset
     /* 645181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645184 */     // MIs[0] auxiliary
     /* 645184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645187 */     // MIs[0] Operand 8
     /* 645187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645205 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN),
     /* 645208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645210 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645219 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645231 */     GIR_RootConstrainSelectedInstOperands,
     /* 645232 */     // GIR_Coverage, 6228,
     /* 645232 */     GIR_EraseRootFromParent_Done,
     /* 645233 */   // Label 8202: @645233
     /* 645233 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(645299), // Rule ID 6234 //
     /* 645238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645241 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645247 */     // MIs[0] offset
     /* 645247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645250 */     // MIs[0] auxiliary
     /* 645250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645253 */     // MIs[0] Operand 8
     /* 645253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645271 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN),
     /* 645274 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645276 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645285 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645297 */     GIR_RootConstrainSelectedInstOperands,
     /* 645298 */     // GIR_Coverage, 6234,
     /* 645298 */     GIR_EraseRootFromParent_Done,
     /* 645299 */   // Label 8203: @645299
     /* 645299 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(645369), // Rule ID 6230 //
     /* 645304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645315 */     // MIs[0] offset
     /* 645315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645318 */     // MIs[0] auxiliary
     /* 645318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645321 */     // MIs[0] Operand 8
     /* 645321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645339 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN),
     /* 645342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645344 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645346 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645355 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645367 */     GIR_RootConstrainSelectedInstOperands,
     /* 645368 */     // GIR_Coverage, 6230,
     /* 645368 */     GIR_EraseRootFromParent_Done,
     /* 645369 */   // Label 8204: @645369
     /* 645369 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(645427), // Rule ID 6233 //
     /* 645374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645377 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645383 */     // MIs[0] offset
     /* 645383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645386 */     // MIs[0] auxiliary
     /* 645386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645389 */     // MIs[0] Operand 8
     /* 645389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645399 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN),
     /* 645402 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645404 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 645406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645413 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645425 */     GIR_RootConstrainSelectedInstOperands,
     /* 645426 */     // GIR_Coverage, 6233,
     /* 645426 */     GIR_EraseRootFromParent_Done,
     /* 645427 */   // Label 8205: @645427
     /* 645427 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(645489), // Rule ID 6229 //
     /* 645432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645443 */     // MIs[0] offset
     /* 645443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645446 */     // MIs[0] auxiliary
     /* 645446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645449 */     // MIs[0] Operand 8
     /* 645449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645459 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN),
     /* 645462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645466 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 645468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645475 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645487 */     GIR_RootConstrainSelectedInstOperands,
     /* 645488 */     // GIR_Coverage, 6229,
     /* 645488 */     GIR_EraseRootFromParent_Done,
     /* 645489 */   // Label 8206: @645489
     /* 645489 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(645585), // Rule ID 6235 //
     /* 645494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645497 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645499 */     // MIs[0] offset
     /* 645499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645502 */     // MIs[0] auxiliary
     /* 645502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645505 */     // MIs[0] Operand 8
     /* 645505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645515 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 645531 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 645538 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN),
     /* 645559 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645571 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645583 */     GIR_RootConstrainSelectedInstOperands,
     /* 645584 */     // GIR_Coverage, 6235,
     /* 645584 */     GIR_EraseRootFromParent_Done,
     /* 645585 */   // Label 8207: @645585
     /* 645585 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(645685), // Rule ID 6231 //
     /* 645590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645597 */     // MIs[0] offset
     /* 645597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645600 */     // MIs[0] auxiliary
     /* 645600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645603 */     // MIs[0] Operand 8
     /* 645603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645613 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 645629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 645636 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN),
     /* 645657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645659 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645671 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645683 */     GIR_RootConstrainSelectedInstOperands,
     /* 645684 */     // GIR_Coverage, 6231,
     /* 645684 */     GIR_EraseRootFromParent_Done,
     /* 645685 */   // Label 8208: @645685
     /* 645685 */   GIM_Reject,
     /* 645686 */ // Label 8200: @645686
     /* 645686 */ GIM_Reject,
     /* 645687 */ // Label 112: @645687
     /* 645687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8211*/ GIMT_Encode4(648070),
     /* 645698 */ /*GILLT_s32*//*Label 8209*/ GIMT_Encode4(645706),
     /* 645702 */ /*GILLT_s64*//*Label 8210*/ GIMT_Encode4(646888),
     /* 645706 */ // Label 8209: @645706
     /* 645706 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(646887),
     /* 645711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 645714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 645717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 645720 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 645723 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 645726 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(645794), // Rule ID 6008 //
     /* 645731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645734 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645744 */     // MIs[0] offset
     /* 645744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645747 */     // MIs[0] auxiliary
     /* 645747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645750 */     // MIs[0] Operand 8
     /* 645750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645768 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 645771 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645780 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645792 */     GIR_RootConstrainSelectedInstOperands,
     /* 645793 */     // GIR_Coverage, 6008,
     /* 645793 */     GIR_EraseRootFromParent_Done,
     /* 645794 */   // Label 8213: @645794
     /* 645794 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(645859), // Rule ID 6016 //
     /* 645799 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645809 */     // MIs[0] offset
     /* 645809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645812 */     // MIs[0] auxiliary
     /* 645812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645815 */     // MIs[0] Operand 8
     /* 645815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645833 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 645836 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645845 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645857 */     GIR_RootConstrainSelectedInstOperands,
     /* 645858 */     // GIR_Coverage, 6016,
     /* 645858 */     GIR_EraseRootFromParent_Done,
     /* 645859 */   // Label 8214: @645859
     /* 645859 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(645931), // Rule ID 6004 //
     /* 645864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645879 */     // MIs[0] offset
     /* 645879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645882 */     // MIs[0] auxiliary
     /* 645882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645885 */     // MIs[0] Operand 8
     /* 645885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645903 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 645906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645908 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645917 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645929 */     GIR_RootConstrainSelectedInstOperands,
     /* 645930 */     // GIR_Coverage, 6004,
     /* 645930 */     GIR_EraseRootFromParent_Done,
     /* 645931 */   // Label 8215: @645931
     /* 645931 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(646000), // Rule ID 6012 //
     /* 645936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645948 */     // MIs[0] offset
     /* 645948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645951 */     // MIs[0] auxiliary
     /* 645951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645954 */     // MIs[0] Operand 8
     /* 645954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645972 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 645975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645977 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645986 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645998 */     GIR_RootConstrainSelectedInstOperands,
     /* 645999 */     // GIR_Coverage, 6012,
     /* 645999 */     GIR_EraseRootFromParent_Done,
     /* 646000 */   // Label 8216: @646000
     /* 646000 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(646066), // Rule ID 6010 //
     /* 646005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646008 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646014 */     // MIs[0] offset
     /* 646014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646017 */     // MIs[0] auxiliary
     /* 646017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646020 */     // MIs[0] Operand 8
     /* 646020 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646038 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN),
     /* 646041 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646043 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646052 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646064 */     GIR_RootConstrainSelectedInstOperands,
     /* 646065 */     // GIR_Coverage, 6010,
     /* 646065 */     GIR_EraseRootFromParent_Done,
     /* 646066 */   // Label 8217: @646066
     /* 646066 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(646129), // Rule ID 6018 //
     /* 646071 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646077 */     // MIs[0] offset
     /* 646077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646080 */     // MIs[0] auxiliary
     /* 646080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646083 */     // MIs[0] Operand 8
     /* 646083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646101 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN),
     /* 646104 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646106 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646115 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646127 */     GIR_RootConstrainSelectedInstOperands,
     /* 646128 */     // GIR_Coverage, 6018,
     /* 646128 */     GIR_EraseRootFromParent_Done,
     /* 646129 */   // Label 8218: @646129
     /* 646129 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(646199), // Rule ID 6006 //
     /* 646134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646145 */     // MIs[0] offset
     /* 646145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646148 */     // MIs[0] auxiliary
     /* 646148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646151 */     // MIs[0] Operand 8
     /* 646151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646169 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN_RTN),
     /* 646172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646174 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646176 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646185 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646197 */     GIR_RootConstrainSelectedInstOperands,
     /* 646198 */     // GIR_Coverage, 6006,
     /* 646198 */     GIR_EraseRootFromParent_Done,
     /* 646199 */   // Label 8219: @646199
     /* 646199 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(646266), // Rule ID 6014 //
     /* 646204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646212 */     // MIs[0] offset
     /* 646212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646215 */     // MIs[0] auxiliary
     /* 646215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646218 */     // MIs[0] Operand 8
     /* 646218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646236 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN),
     /* 646239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646241 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646243 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646252 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646264 */     GIR_RootConstrainSelectedInstOperands,
     /* 646265 */     // GIR_Coverage, 6014,
     /* 646265 */     GIR_EraseRootFromParent_Done,
     /* 646266 */   // Label 8220: @646266
     /* 646266 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(646324), // Rule ID 6009 //
     /* 646271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646274 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646280 */     // MIs[0] offset
     /* 646280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646283 */     // MIs[0] auxiliary
     /* 646283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646286 */     // MIs[0] Operand 8
     /* 646286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646296 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN),
     /* 646299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646301 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646310 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646322 */     GIR_RootConstrainSelectedInstOperands,
     /* 646323 */     // GIR_Coverage, 6009,
     /* 646323 */     GIR_EraseRootFromParent_Done,
     /* 646324 */   // Label 8221: @646324
     /* 646324 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(646379), // Rule ID 6017 //
     /* 646329 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646335 */     // MIs[0] offset
     /* 646335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646338 */     // MIs[0] auxiliary
     /* 646338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646341 */     // MIs[0] Operand 8
     /* 646341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646351 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN),
     /* 646354 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646356 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646365 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646377 */     GIR_RootConstrainSelectedInstOperands,
     /* 646378 */     // GIR_Coverage, 6017,
     /* 646378 */     GIR_EraseRootFromParent_Done,
     /* 646379 */   // Label 8222: @646379
     /* 646379 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(646441), // Rule ID 6005 //
     /* 646384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646395 */     // MIs[0] offset
     /* 646395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646398 */     // MIs[0] auxiliary
     /* 646398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646401 */     // MIs[0] Operand 8
     /* 646401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646411 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN_RTN),
     /* 646414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646416 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646418 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646427 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646439 */     GIR_RootConstrainSelectedInstOperands,
     /* 646440 */     // GIR_Coverage, 6005,
     /* 646440 */     GIR_EraseRootFromParent_Done,
     /* 646441 */   // Label 8223: @646441
     /* 646441 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(646500), // Rule ID 6013 //
     /* 646446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646454 */     // MIs[0] offset
     /* 646454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646457 */     // MIs[0] auxiliary
     /* 646457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646460 */     // MIs[0] Operand 8
     /* 646460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646470 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN),
     /* 646473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646475 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646477 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646486 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646498 */     GIR_RootConstrainSelectedInstOperands,
     /* 646499 */     // GIR_Coverage, 6013,
     /* 646499 */     GIR_EraseRootFromParent_Done,
     /* 646500 */   // Label 8224: @646500
     /* 646500 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(646596), // Rule ID 6011 //
     /* 646505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646508 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646510 */     // MIs[0] offset
     /* 646510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646513 */     // MIs[0] auxiliary
     /* 646513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646516 */     // MIs[0] Operand 8
     /* 646516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646526 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646542 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646549 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN),
     /* 646570 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646582 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646594 */     GIR_RootConstrainSelectedInstOperands,
     /* 646595 */     // GIR_Coverage, 6011,
     /* 646595 */     GIR_EraseRootFromParent_Done,
     /* 646596 */   // Label 8225: @646596
     /* 646596 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(646689), // Rule ID 6019 //
     /* 646601 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646603 */     // MIs[0] offset
     /* 646603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646606 */     // MIs[0] auxiliary
     /* 646606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646609 */     // MIs[0] Operand 8
     /* 646609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646619 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646635 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646642 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN),
     /* 646663 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646675 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646687 */     GIR_RootConstrainSelectedInstOperands,
     /* 646688 */     // GIR_Coverage, 6019,
     /* 646688 */     GIR_EraseRootFromParent_Done,
     /* 646689 */   // Label 8226: @646689
     /* 646689 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(646789), // Rule ID 6007 //
     /* 646694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646701 */     // MIs[0] offset
     /* 646701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646704 */     // MIs[0] auxiliary
     /* 646704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646707 */     // MIs[0] Operand 8
     /* 646707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646717 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646733 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646740 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN_RTN),
     /* 646761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646763 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646775 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646787 */     GIR_RootConstrainSelectedInstOperands,
     /* 646788 */     // GIR_Coverage, 6007,
     /* 646788 */     GIR_EraseRootFromParent_Done,
     /* 646789 */   // Label 8227: @646789
     /* 646789 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(646886), // Rule ID 6015 //
     /* 646794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646798 */     // MIs[0] offset
     /* 646798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646801 */     // MIs[0] auxiliary
     /* 646801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646804 */     // MIs[0] Operand 8
     /* 646804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646814 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646830 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646837 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN),
     /* 646858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646860 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646872 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646884 */     GIR_RootConstrainSelectedInstOperands,
     /* 646885 */     // GIR_Coverage, 6015,
     /* 646885 */     GIR_EraseRootFromParent_Done,
     /* 646886 */   // Label 8228: @646886
     /* 646886 */   GIM_Reject,
     /* 646887 */ // Label 8212: @646887
     /* 646887 */ GIM_Reject,
     /* 646888 */ // Label 8210: @646888
     /* 646888 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(648069),
     /* 646893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 646896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 646899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 646902 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 646905 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 646908 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(646976), // Rule ID 6208 //
     /* 646913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646916 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646926 */     // MIs[0] offset
     /* 646926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646929 */     // MIs[0] auxiliary
     /* 646929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646932 */     // MIs[0] Operand 8
     /* 646932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646950 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 646953 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646962 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646974 */     GIR_RootConstrainSelectedInstOperands,
     /* 646975 */     // GIR_Coverage, 6208,
     /* 646975 */     GIR_EraseRootFromParent_Done,
     /* 646976 */   // Label 8230: @646976
     /* 646976 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(647041), // Rule ID 6216 //
     /* 646981 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646991 */     // MIs[0] offset
     /* 646991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646994 */     // MIs[0] auxiliary
     /* 646994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646997 */     // MIs[0] Operand 8
     /* 646997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647015 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 647018 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647027 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647039 */     GIR_RootConstrainSelectedInstOperands,
     /* 647040 */     // GIR_Coverage, 6216,
     /* 647040 */     GIR_EraseRootFromParent_Done,
     /* 647041 */   // Label 8231: @647041
     /* 647041 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(647113), // Rule ID 6204 //
     /* 647046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647061 */     // MIs[0] offset
     /* 647061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647064 */     // MIs[0] auxiliary
     /* 647064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647067 */     // MIs[0] Operand 8
     /* 647067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647085 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 647088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647090 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647099 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647111 */     GIR_RootConstrainSelectedInstOperands,
     /* 647112 */     // GIR_Coverage, 6204,
     /* 647112 */     GIR_EraseRootFromParent_Done,
     /* 647113 */   // Label 8232: @647113
     /* 647113 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(647182), // Rule ID 6212 //
     /* 647118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647130 */     // MIs[0] offset
     /* 647130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647133 */     // MIs[0] auxiliary
     /* 647133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647136 */     // MIs[0] Operand 8
     /* 647136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647154 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 647157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647168 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647180 */     GIR_RootConstrainSelectedInstOperands,
     /* 647181 */     // GIR_Coverage, 6212,
     /* 647181 */     GIR_EraseRootFromParent_Done,
     /* 647182 */   // Label 8233: @647182
     /* 647182 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(647248), // Rule ID 6210 //
     /* 647187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647190 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647196 */     // MIs[0] offset
     /* 647196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647199 */     // MIs[0] auxiliary
     /* 647199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647202 */     // MIs[0] Operand 8
     /* 647202 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647220 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN),
     /* 647223 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647225 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647234 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647246 */     GIR_RootConstrainSelectedInstOperands,
     /* 647247 */     // GIR_Coverage, 6210,
     /* 647247 */     GIR_EraseRootFromParent_Done,
     /* 647248 */   // Label 8234: @647248
     /* 647248 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(647311), // Rule ID 6218 //
     /* 647253 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647259 */     // MIs[0] offset
     /* 647259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647262 */     // MIs[0] auxiliary
     /* 647262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647265 */     // MIs[0] Operand 8
     /* 647265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647283 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN),
     /* 647286 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647288 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647297 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647309 */     GIR_RootConstrainSelectedInstOperands,
     /* 647310 */     // GIR_Coverage, 6218,
     /* 647310 */     GIR_EraseRootFromParent_Done,
     /* 647311 */   // Label 8235: @647311
     /* 647311 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(647381), // Rule ID 6206 //
     /* 647316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647327 */     // MIs[0] offset
     /* 647327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647330 */     // MIs[0] auxiliary
     /* 647330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647333 */     // MIs[0] Operand 8
     /* 647333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647351 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN_RTN),
     /* 647354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647356 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647358 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647367 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647379 */     GIR_RootConstrainSelectedInstOperands,
     /* 647380 */     // GIR_Coverage, 6206,
     /* 647380 */     GIR_EraseRootFromParent_Done,
     /* 647381 */   // Label 8236: @647381
     /* 647381 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(647448), // Rule ID 6214 //
     /* 647386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647394 */     // MIs[0] offset
     /* 647394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647397 */     // MIs[0] auxiliary
     /* 647397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647400 */     // MIs[0] Operand 8
     /* 647400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647418 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN),
     /* 647421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647423 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647425 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647434 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647446 */     GIR_RootConstrainSelectedInstOperands,
     /* 647447 */     // GIR_Coverage, 6214,
     /* 647447 */     GIR_EraseRootFromParent_Done,
     /* 647448 */   // Label 8237: @647448
     /* 647448 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(647506), // Rule ID 6209 //
     /* 647453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647456 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647462 */     // MIs[0] offset
     /* 647462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647465 */     // MIs[0] auxiliary
     /* 647465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647468 */     // MIs[0] Operand 8
     /* 647468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647478 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN),
     /* 647481 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647483 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647492 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647504 */     GIR_RootConstrainSelectedInstOperands,
     /* 647505 */     // GIR_Coverage, 6209,
     /* 647505 */     GIR_EraseRootFromParent_Done,
     /* 647506 */   // Label 8238: @647506
     /* 647506 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(647561), // Rule ID 6217 //
     /* 647511 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647517 */     // MIs[0] offset
     /* 647517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647520 */     // MIs[0] auxiliary
     /* 647520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647523 */     // MIs[0] Operand 8
     /* 647523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647533 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN),
     /* 647536 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647538 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647547 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647559 */     GIR_RootConstrainSelectedInstOperands,
     /* 647560 */     // GIR_Coverage, 6217,
     /* 647560 */     GIR_EraseRootFromParent_Done,
     /* 647561 */   // Label 8239: @647561
     /* 647561 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(647623), // Rule ID 6205 //
     /* 647566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647577 */     // MIs[0] offset
     /* 647577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647580 */     // MIs[0] auxiliary
     /* 647580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647583 */     // MIs[0] Operand 8
     /* 647583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647593 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN_RTN),
     /* 647596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647598 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647600 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647609 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647621 */     GIR_RootConstrainSelectedInstOperands,
     /* 647622 */     // GIR_Coverage, 6205,
     /* 647622 */     GIR_EraseRootFromParent_Done,
     /* 647623 */   // Label 8240: @647623
     /* 647623 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(647682), // Rule ID 6213 //
     /* 647628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647636 */     // MIs[0] offset
     /* 647636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647639 */     // MIs[0] auxiliary
     /* 647639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647642 */     // MIs[0] Operand 8
     /* 647642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647652 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN),
     /* 647655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647657 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647659 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647668 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647680 */     GIR_RootConstrainSelectedInstOperands,
     /* 647681 */     // GIR_Coverage, 6213,
     /* 647681 */     GIR_EraseRootFromParent_Done,
     /* 647682 */   // Label 8241: @647682
     /* 647682 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(647778), // Rule ID 6211 //
     /* 647687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647690 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647692 */     // MIs[0] offset
     /* 647692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647695 */     // MIs[0] auxiliary
     /* 647695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647698 */     // MIs[0] Operand 8
     /* 647698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647708 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647731 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN),
     /* 647752 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647764 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647776 */     GIR_RootConstrainSelectedInstOperands,
     /* 647777 */     // GIR_Coverage, 6211,
     /* 647777 */     GIR_EraseRootFromParent_Done,
     /* 647778 */   // Label 8242: @647778
     /* 647778 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(647871), // Rule ID 6219 //
     /* 647783 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647785 */     // MIs[0] offset
     /* 647785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647788 */     // MIs[0] auxiliary
     /* 647788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647791 */     // MIs[0] Operand 8
     /* 647791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647801 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647817 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647824 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN),
     /* 647845 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647857 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647869 */     GIR_RootConstrainSelectedInstOperands,
     /* 647870 */     // GIR_Coverage, 6219,
     /* 647870 */     GIR_EraseRootFromParent_Done,
     /* 647871 */   // Label 8243: @647871
     /* 647871 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(647971), // Rule ID 6207 //
     /* 647876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647883 */     // MIs[0] offset
     /* 647883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647886 */     // MIs[0] auxiliary
     /* 647886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647889 */     // MIs[0] Operand 8
     /* 647889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647899 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647915 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647922 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN),
     /* 647943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647945 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647957 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647969 */     GIR_RootConstrainSelectedInstOperands,
     /* 647970 */     // GIR_Coverage, 6207,
     /* 647970 */     GIR_EraseRootFromParent_Done,
     /* 647971 */   // Label 8244: @647971
     /* 647971 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(648068), // Rule ID 6215 //
     /* 647976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647980 */     // MIs[0] offset
     /* 647980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647983 */     // MIs[0] auxiliary
     /* 647983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647986 */     // MIs[0] Operand 8
     /* 647986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647996 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648012 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648015 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648019 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN),
     /* 648040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648042 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648054 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648066 */     GIR_RootConstrainSelectedInstOperands,
     /* 648067 */     // GIR_Coverage, 6215,
     /* 648067 */     GIR_EraseRootFromParent_Done,
     /* 648068 */   // Label 8245: @648068
     /* 648068 */   GIM_Reject,
     /* 648069 */ // Label 8229: @648069
     /* 648069 */ GIM_Reject,
     /* 648070 */ // Label 8211: @648070
     /* 648070 */ GIM_Reject,
     /* 648071 */ // Label 113: @648071
     /* 648071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8249*/ GIMT_Encode4(651712),
     /* 648082 */ /*GILLT_s32*//*Label 8246*/ GIMT_Encode4(648094),
     /* 648086 */ /*GILLT_s64*//*Label 8247*/ GIMT_Encode4(649300),
     /* 648090 */ /*GILLT_v2s16*//*Label 8248*/ GIMT_Encode4(650506),
     /* 648094 */ // Label 8246: @648094
     /* 648094 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(649299),
     /* 648099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 648102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 648105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 648108 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 648111 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 648114 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(648182), // Rule ID 6300 //
     /* 648119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648122 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648132 */     // MIs[0] offset
     /* 648132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648135 */     // MIs[0] auxiliary
     /* 648135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648138 */     // MIs[0] Operand 8
     /* 648138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648156 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET),
     /* 648159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648168 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648180 */     GIR_RootConstrainSelectedInstOperands,
     /* 648181 */     // GIR_Coverage, 6300,
     /* 648181 */     GIR_EraseRootFromParent_Done,
     /* 648182 */   // Label 8251: @648182
     /* 648182 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(648250), // Rule ID 6304 //
     /* 648187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648190 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648200 */     // MIs[0] offset
     /* 648200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648203 */     // MIs[0] auxiliary
     /* 648203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648206 */     // MIs[0] Operand 8
     /* 648206 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648224 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET),
     /* 648227 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648236 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648248 */     GIR_RootConstrainSelectedInstOperands,
     /* 648249 */     // GIR_Coverage, 6304,
     /* 648249 */     GIR_EraseRootFromParent_Done,
     /* 648250 */   // Label 8252: @648250
     /* 648250 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(648322), // Rule ID 6316 //
     /* 648255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648270 */     // MIs[0] offset
     /* 648270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648273 */     // MIs[0] auxiliary
     /* 648273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648276 */     // MIs[0] Operand 8
     /* 648276 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648294 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET_RTN),
     /* 648297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648308 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648310 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648320 */     GIR_RootConstrainSelectedInstOperands,
     /* 648321 */     // GIR_Coverage, 6316,
     /* 648321 */     GIR_EraseRootFromParent_Done,
     /* 648322 */   // Label 8253: @648322
     /* 648322 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(648394), // Rule ID 6320 //
     /* 648327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648342 */     // MIs[0] offset
     /* 648342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648345 */     // MIs[0] auxiliary
     /* 648345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648348 */     // MIs[0] Operand 8
     /* 648348 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648366 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN),
     /* 648369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648371 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648380 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648382 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648392 */     GIR_RootConstrainSelectedInstOperands,
     /* 648393 */     // GIR_Coverage, 6320,
     /* 648393 */     GIR_EraseRootFromParent_Done,
     /* 648394 */   // Label 8254: @648394
     /* 648394 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(648460), // Rule ID 6302 //
     /* 648399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648402 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648408 */     // MIs[0] offset
     /* 648408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648411 */     // MIs[0] auxiliary
     /* 648411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648414 */     // MIs[0] Operand 8
     /* 648414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648432 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN),
     /* 648435 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648437 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648446 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648458 */     GIR_RootConstrainSelectedInstOperands,
     /* 648459 */     // GIR_Coverage, 6302,
     /* 648459 */     GIR_EraseRootFromParent_Done,
     /* 648460 */   // Label 8255: @648460
     /* 648460 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(648526), // Rule ID 6306 //
     /* 648465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648468 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648474 */     // MIs[0] offset
     /* 648474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648477 */     // MIs[0] auxiliary
     /* 648477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648480 */     // MIs[0] Operand 8
     /* 648480 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648498 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN),
     /* 648501 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648503 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648512 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648524 */     GIR_RootConstrainSelectedInstOperands,
     /* 648525 */     // GIR_Coverage, 6306,
     /* 648525 */     GIR_EraseRootFromParent_Done,
     /* 648526 */   // Label 8256: @648526
     /* 648526 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(648596), // Rule ID 6318 //
     /* 648531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648542 */     // MIs[0] offset
     /* 648542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648545 */     // MIs[0] auxiliary
     /* 648545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648548 */     // MIs[0] Operand 8
     /* 648548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648566 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN_RTN),
     /* 648569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648571 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648573 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648582 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648594 */     GIR_RootConstrainSelectedInstOperands,
     /* 648595 */     // GIR_Coverage, 6318,
     /* 648595 */     GIR_EraseRootFromParent_Done,
     /* 648596 */   // Label 8257: @648596
     /* 648596 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(648666), // Rule ID 6322 //
     /* 648601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648612 */     // MIs[0] offset
     /* 648612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648615 */     // MIs[0] auxiliary
     /* 648615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648618 */     // MIs[0] Operand 8
     /* 648618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648636 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN),
     /* 648639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648641 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648643 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648652 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648664 */     GIR_RootConstrainSelectedInstOperands,
     /* 648665 */     // GIR_Coverage, 6322,
     /* 648665 */     GIR_EraseRootFromParent_Done,
     /* 648666 */   // Label 8258: @648666
     /* 648666 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(648724), // Rule ID 6301 //
     /* 648671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648674 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648680 */     // MIs[0] offset
     /* 648680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648683 */     // MIs[0] auxiliary
     /* 648683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648686 */     // MIs[0] Operand 8
     /* 648686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648696 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN),
     /* 648699 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648701 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648710 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648722 */     GIR_RootConstrainSelectedInstOperands,
     /* 648723 */     // GIR_Coverage, 6301,
     /* 648723 */     GIR_EraseRootFromParent_Done,
     /* 648724 */   // Label 8259: @648724
     /* 648724 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(648782), // Rule ID 6305 //
     /* 648729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648732 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648738 */     // MIs[0] offset
     /* 648738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648741 */     // MIs[0] auxiliary
     /* 648741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648744 */     // MIs[0] Operand 8
     /* 648744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648754 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN),
     /* 648757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648759 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648768 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648780 */     GIR_RootConstrainSelectedInstOperands,
     /* 648781 */     // GIR_Coverage, 6305,
     /* 648781 */     GIR_EraseRootFromParent_Done,
     /* 648782 */   // Label 8260: @648782
     /* 648782 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(648844), // Rule ID 6317 //
     /* 648787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648798 */     // MIs[0] offset
     /* 648798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648801 */     // MIs[0] auxiliary
     /* 648801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648804 */     // MIs[0] Operand 8
     /* 648804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648814 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN_RTN),
     /* 648817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648819 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648821 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648830 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648842 */     GIR_RootConstrainSelectedInstOperands,
     /* 648843 */     // GIR_Coverage, 6317,
     /* 648843 */     GIR_EraseRootFromParent_Done,
     /* 648844 */   // Label 8261: @648844
     /* 648844 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(648906), // Rule ID 6321 //
     /* 648849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648860 */     // MIs[0] offset
     /* 648860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648863 */     // MIs[0] auxiliary
     /* 648863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648866 */     // MIs[0] Operand 8
     /* 648866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648876 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN),
     /* 648879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648881 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648883 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648892 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648904 */     GIR_RootConstrainSelectedInstOperands,
     /* 648905 */     // GIR_Coverage, 6321,
     /* 648905 */     GIR_EraseRootFromParent_Done,
     /* 648906 */   // Label 8262: @648906
     /* 648906 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(649002), // Rule ID 6303 //
     /* 648911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648914 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648916 */     // MIs[0] offset
     /* 648916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648919 */     // MIs[0] auxiliary
     /* 648919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648922 */     // MIs[0] Operand 8
     /* 648922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648932 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 648935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648948 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648955 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN),
     /* 648976 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648988 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649000 */     GIR_RootConstrainSelectedInstOperands,
     /* 649001 */     // GIR_Coverage, 6303,
     /* 649001 */     GIR_EraseRootFromParent_Done,
     /* 649002 */   // Label 8263: @649002
     /* 649002 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(649098), // Rule ID 6307 //
     /* 649007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 649010 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649012 */     // MIs[0] offset
     /* 649012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649015 */     // MIs[0] auxiliary
     /* 649015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649018 */     // MIs[0] Operand 8
     /* 649018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649028 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649044 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649051 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN),
     /* 649072 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649084 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649096 */     GIR_RootConstrainSelectedInstOperands,
     /* 649097 */     // GIR_Coverage, 6307,
     /* 649097 */     GIR_EraseRootFromParent_Done,
     /* 649098 */   // Label 8264: @649098
     /* 649098 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(649198), // Rule ID 6319 //
     /* 649103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 649106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649110 */     // MIs[0] offset
     /* 649110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649113 */     // MIs[0] auxiliary
     /* 649113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649116 */     // MIs[0] Operand 8
     /* 649116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649126 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649142 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN),
     /* 649170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649172 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649184 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649196 */     GIR_RootConstrainSelectedInstOperands,
     /* 649197 */     // GIR_Coverage, 6319,
     /* 649197 */     GIR_EraseRootFromParent_Done,
     /* 649198 */   // Label 8265: @649198
     /* 649198 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(649298), // Rule ID 6323 //
     /* 649203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 649206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649210 */     // MIs[0] offset
     /* 649210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649213 */     // MIs[0] auxiliary
     /* 649213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649216 */     // MIs[0] Operand 8
     /* 649216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649226 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN),
     /* 649270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649272 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649284 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649296 */     GIR_RootConstrainSelectedInstOperands,
     /* 649297 */     // GIR_Coverage, 6323,
     /* 649297 */     GIR_EraseRootFromParent_Done,
     /* 649298 */   // Label 8266: @649298
     /* 649298 */   GIM_Reject,
     /* 649299 */ // Label 8250: @649299
     /* 649299 */ GIM_Reject,
     /* 649300 */ // Label 8247: @649300
     /* 649300 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(650505),
     /* 649305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 649308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 649311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 649314 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 649317 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 649320 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(649388), // Rule ID 6336 //
     /* 649325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649328 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649338 */     // MIs[0] offset
     /* 649338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649341 */     // MIs[0] auxiliary
     /* 649341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649344 */     // MIs[0] Operand 8
     /* 649344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649362 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET),
     /* 649365 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649374 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649376 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649386 */     GIR_RootConstrainSelectedInstOperands,
     /* 649387 */     // GIR_Coverage, 6336,
     /* 649387 */     GIR_EraseRootFromParent_Done,
     /* 649388 */   // Label 8268: @649388
     /* 649388 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(649456), // Rule ID 6344 //
     /* 649393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649396 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649406 */     // MIs[0] offset
     /* 649406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649409 */     // MIs[0] auxiliary
     /* 649409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649412 */     // MIs[0] Operand 8
     /* 649412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649430 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET),
     /* 649433 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649442 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649454 */     GIR_RootConstrainSelectedInstOperands,
     /* 649455 */     // GIR_Coverage, 6344,
     /* 649455 */     GIR_EraseRootFromParent_Done,
     /* 649456 */   // Label 8269: @649456
     /* 649456 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(649528), // Rule ID 6332 //
     /* 649461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649476 */     // MIs[0] offset
     /* 649476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649479 */     // MIs[0] auxiliary
     /* 649479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649482 */     // MIs[0] Operand 8
     /* 649482 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649500 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET_RTN),
     /* 649503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649505 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649514 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649526 */     GIR_RootConstrainSelectedInstOperands,
     /* 649527 */     // GIR_Coverage, 6332,
     /* 649527 */     GIR_EraseRootFromParent_Done,
     /* 649528 */   // Label 8270: @649528
     /* 649528 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(649600), // Rule ID 6340 //
     /* 649533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649548 */     // MIs[0] offset
     /* 649548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649551 */     // MIs[0] auxiliary
     /* 649551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649554 */     // MIs[0] Operand 8
     /* 649554 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649572 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN),
     /* 649575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649577 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649586 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649588 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649598 */     GIR_RootConstrainSelectedInstOperands,
     /* 649599 */     // GIR_Coverage, 6340,
     /* 649599 */     GIR_EraseRootFromParent_Done,
     /* 649600 */   // Label 8271: @649600
     /* 649600 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(649666), // Rule ID 6338 //
     /* 649605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649608 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649614 */     // MIs[0] offset
     /* 649614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649617 */     // MIs[0] auxiliary
     /* 649617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649620 */     // MIs[0] Operand 8
     /* 649620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649638 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN),
     /* 649641 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649643 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649652 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649664 */     GIR_RootConstrainSelectedInstOperands,
     /* 649665 */     // GIR_Coverage, 6338,
     /* 649665 */     GIR_EraseRootFromParent_Done,
     /* 649666 */   // Label 8272: @649666
     /* 649666 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(649732), // Rule ID 6346 //
     /* 649671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649674 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649680 */     // MIs[0] offset
     /* 649680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649683 */     // MIs[0] auxiliary
     /* 649683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649686 */     // MIs[0] Operand 8
     /* 649686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649704 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN),
     /* 649707 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649709 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649718 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649730 */     GIR_RootConstrainSelectedInstOperands,
     /* 649731 */     // GIR_Coverage, 6346,
     /* 649731 */     GIR_EraseRootFromParent_Done,
     /* 649732 */   // Label 8273: @649732
     /* 649732 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(649802), // Rule ID 6334 //
     /* 649737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649748 */     // MIs[0] offset
     /* 649748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649751 */     // MIs[0] auxiliary
     /* 649751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649754 */     // MIs[0] Operand 8
     /* 649754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649772 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN_RTN),
     /* 649775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649777 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649779 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649788 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649800 */     GIR_RootConstrainSelectedInstOperands,
     /* 649801 */     // GIR_Coverage, 6334,
     /* 649801 */     GIR_EraseRootFromParent_Done,
     /* 649802 */   // Label 8274: @649802
     /* 649802 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(649872), // Rule ID 6342 //
     /* 649807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649818 */     // MIs[0] offset
     /* 649818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649821 */     // MIs[0] auxiliary
     /* 649821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649824 */     // MIs[0] Operand 8
     /* 649824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649842 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN),
     /* 649845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649847 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649849 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649858 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649870 */     GIR_RootConstrainSelectedInstOperands,
     /* 649871 */     // GIR_Coverage, 6342,
     /* 649871 */     GIR_EraseRootFromParent_Done,
     /* 649872 */   // Label 8275: @649872
     /* 649872 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(649930), // Rule ID 6337 //
     /* 649877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649880 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649886 */     // MIs[0] offset
     /* 649886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649889 */     // MIs[0] auxiliary
     /* 649889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649892 */     // MIs[0] Operand 8
     /* 649892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649902 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN),
     /* 649905 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649907 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649916 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649928 */     GIR_RootConstrainSelectedInstOperands,
     /* 649929 */     // GIR_Coverage, 6337,
     /* 649929 */     GIR_EraseRootFromParent_Done,
     /* 649930 */   // Label 8276: @649930
     /* 649930 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(649988), // Rule ID 6345 //
     /* 649935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649938 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649944 */     // MIs[0] offset
     /* 649944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649947 */     // MIs[0] auxiliary
     /* 649947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649950 */     // MIs[0] Operand 8
     /* 649950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649960 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN),
     /* 649963 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649965 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649974 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649986 */     GIR_RootConstrainSelectedInstOperands,
     /* 649987 */     // GIR_Coverage, 6345,
     /* 649987 */     GIR_EraseRootFromParent_Done,
     /* 649988 */   // Label 8277: @649988
     /* 649988 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(650050), // Rule ID 6333 //
     /* 649993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650004 */     // MIs[0] offset
     /* 650004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650007 */     // MIs[0] auxiliary
     /* 650007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650010 */     // MIs[0] Operand 8
     /* 650010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650020 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN_RTN),
     /* 650023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650025 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650027 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650036 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650038 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650048 */     GIR_RootConstrainSelectedInstOperands,
     /* 650049 */     // GIR_Coverage, 6333,
     /* 650049 */     GIR_EraseRootFromParent_Done,
     /* 650050 */   // Label 8278: @650050
     /* 650050 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(650112), // Rule ID 6341 //
     /* 650055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 650058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650066 */     // MIs[0] offset
     /* 650066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650069 */     // MIs[0] auxiliary
     /* 650069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650072 */     // MIs[0] Operand 8
     /* 650072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650082 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN),
     /* 650085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650087 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650089 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650098 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650110 */     GIR_RootConstrainSelectedInstOperands,
     /* 650111 */     // GIR_Coverage, 6341,
     /* 650111 */     GIR_EraseRootFromParent_Done,
     /* 650112 */   // Label 8279: @650112
     /* 650112 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(650208), // Rule ID 6339 //
     /* 650117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 650120 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650122 */     // MIs[0] offset
     /* 650122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650125 */     // MIs[0] auxiliary
     /* 650125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650128 */     // MIs[0] Operand 8
     /* 650128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650138 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650154 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650161 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN),
     /* 650182 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650194 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650206 */     GIR_RootConstrainSelectedInstOperands,
     /* 650207 */     // GIR_Coverage, 6339,
     /* 650207 */     GIR_EraseRootFromParent_Done,
     /* 650208 */   // Label 8280: @650208
     /* 650208 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(650304), // Rule ID 6347 //
     /* 650213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 650216 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650218 */     // MIs[0] offset
     /* 650218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650221 */     // MIs[0] auxiliary
     /* 650221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650224 */     // MIs[0] Operand 8
     /* 650224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650234 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650250 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650257 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN),
     /* 650278 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650290 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650302 */     GIR_RootConstrainSelectedInstOperands,
     /* 650303 */     // GIR_Coverage, 6347,
     /* 650303 */     GIR_EraseRootFromParent_Done,
     /* 650304 */   // Label 8281: @650304
     /* 650304 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(650404), // Rule ID 6335 //
     /* 650309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 650312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650316 */     // MIs[0] offset
     /* 650316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650319 */     // MIs[0] auxiliary
     /* 650319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650322 */     // MIs[0] Operand 8
     /* 650322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650332 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650348 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN),
     /* 650376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650378 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650390 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650402 */     GIR_RootConstrainSelectedInstOperands,
     /* 650403 */     // GIR_Coverage, 6335,
     /* 650403 */     GIR_EraseRootFromParent_Done,
     /* 650404 */   // Label 8282: @650404
     /* 650404 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(650504), // Rule ID 6343 //
     /* 650409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 650412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650416 */     // MIs[0] offset
     /* 650416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650419 */     // MIs[0] auxiliary
     /* 650419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650422 */     // MIs[0] Operand 8
     /* 650422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650432 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650448 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650455 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN),
     /* 650476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650478 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650490 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650502 */     GIR_RootConstrainSelectedInstOperands,
     /* 650503 */     // GIR_Coverage, 6343,
     /* 650503 */     GIR_EraseRootFromParent_Done,
     /* 650504 */   // Label 8283: @650504
     /* 650504 */   GIM_Reject,
     /* 650505 */ // Label 8267: @650505
     /* 650505 */ GIM_Reject,
     /* 650506 */ // Label 8248: @650506
     /* 650506 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(651711),
     /* 650511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 650514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 650517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 650520 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 650523 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 650526 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(650594), // Rule ID 6308 //
     /* 650531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 650534 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650544 */     // MIs[0] offset
     /* 650544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650547 */     // MIs[0] auxiliary
     /* 650547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650550 */     // MIs[0] Operand 8
     /* 650550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650568 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET anonymous_9787:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET),
     /* 650571 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650580 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650592 */     GIR_RootConstrainSelectedInstOperands,
     /* 650593 */     // GIR_Coverage, 6308,
     /* 650593 */     GIR_EraseRootFromParent_Done,
     /* 650594 */   // Label 8285: @650594
     /* 650594 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(650662), // Rule ID 6312 //
     /* 650599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 650602 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650612 */     // MIs[0] offset
     /* 650612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650615 */     // MIs[0] auxiliary
     /* 650615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650618 */     // MIs[0] Operand 8
     /* 650618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650636 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET anonymous_9787:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET),
     /* 650639 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650648 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650660 */     GIR_RootConstrainSelectedInstOperands,
     /* 650661 */     // GIR_Coverage, 6312,
     /* 650661 */     GIR_EraseRootFromParent_Done,
     /* 650662 */   // Label 8286: @650662
     /* 650662 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(650734), // Rule ID 6324 //
     /* 650667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 650670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650682 */     // MIs[0] offset
     /* 650682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650685 */     // MIs[0] auxiliary
     /* 650685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650688 */     // MIs[0] Operand 8
     /* 650688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650706 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN),
     /* 650709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650711 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650720 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650732 */     GIR_RootConstrainSelectedInstOperands,
     /* 650733 */     // GIR_Coverage, 6324,
     /* 650733 */     GIR_EraseRootFromParent_Done,
     /* 650734 */   // Label 8287: @650734
     /* 650734 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(650806), // Rule ID 6328 //
     /* 650739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 650742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650754 */     // MIs[0] offset
     /* 650754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650757 */     // MIs[0] auxiliary
     /* 650757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650760 */     // MIs[0] Operand 8
     /* 650760 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650778 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN),
     /* 650781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650783 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650792 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650804 */     GIR_RootConstrainSelectedInstOperands,
     /* 650805 */     // GIR_Coverage, 6328,
     /* 650805 */     GIR_EraseRootFromParent_Done,
     /* 650806 */   // Label 8288: @650806
     /* 650806 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(650872), // Rule ID 6310 //
     /* 650811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 650814 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650820 */     // MIs[0] offset
     /* 650820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650823 */     // MIs[0] auxiliary
     /* 650823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650826 */     // MIs[0] Operand 8
     /* 650826 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650844 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN),
     /* 650847 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650849 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650858 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650870 */     GIR_RootConstrainSelectedInstOperands,
     /* 650871 */     // GIR_Coverage, 6310,
     /* 650871 */     GIR_EraseRootFromParent_Done,
     /* 650872 */   // Label 8289: @650872
     /* 650872 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(650938), // Rule ID 6314 //
     /* 650877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 650880 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650886 */     // MIs[0] offset
     /* 650886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650889 */     // MIs[0] auxiliary
     /* 650889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650892 */     // MIs[0] Operand 8
     /* 650892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650910 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN),
     /* 650913 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650915 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650924 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650936 */     GIR_RootConstrainSelectedInstOperands,
     /* 650937 */     // GIR_Coverage, 6314,
     /* 650937 */     GIR_EraseRootFromParent_Done,
     /* 650938 */   // Label 8290: @650938
     /* 650938 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(651008), // Rule ID 6326 //
     /* 650943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 650946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650954 */     // MIs[0] offset
     /* 650954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650957 */     // MIs[0] auxiliary
     /* 650957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650960 */     // MIs[0] Operand 8
     /* 650960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650978 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN),
     /* 650981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650983 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650985 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650994 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651006 */     GIR_RootConstrainSelectedInstOperands,
     /* 651007 */     // GIR_Coverage, 6326,
     /* 651007 */     GIR_EraseRootFromParent_Done,
     /* 651008 */   // Label 8291: @651008
     /* 651008 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(651078), // Rule ID 6330 //
     /* 651013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 651016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651024 */     // MIs[0] offset
     /* 651024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651027 */     // MIs[0] auxiliary
     /* 651027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651030 */     // MIs[0] Operand 8
     /* 651030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651048 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN),
     /* 651051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651053 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651055 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651064 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651076 */     GIR_RootConstrainSelectedInstOperands,
     /* 651077 */     // GIR_Coverage, 6330,
     /* 651077 */     GIR_EraseRootFromParent_Done,
     /* 651078 */   // Label 8292: @651078
     /* 651078 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(651136), // Rule ID 6309 //
     /* 651083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 651086 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651092 */     // MIs[0] offset
     /* 651092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651095 */     // MIs[0] auxiliary
     /* 651095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651098 */     // MIs[0] Operand 8
     /* 651098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651108 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN),
     /* 651111 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651113 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651122 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651134 */     GIR_RootConstrainSelectedInstOperands,
     /* 651135 */     // GIR_Coverage, 6309,
     /* 651135 */     GIR_EraseRootFromParent_Done,
     /* 651136 */   // Label 8293: @651136
     /* 651136 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(651194), // Rule ID 6313 //
     /* 651141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 651144 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651150 */     // MIs[0] offset
     /* 651150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651153 */     // MIs[0] auxiliary
     /* 651153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651156 */     // MIs[0] Operand 8
     /* 651156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651166 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN),
     /* 651169 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651171 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651180 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651192 */     GIR_RootConstrainSelectedInstOperands,
     /* 651193 */     // GIR_Coverage, 6313,
     /* 651193 */     GIR_EraseRootFromParent_Done,
     /* 651194 */   // Label 8294: @651194
     /* 651194 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(651256), // Rule ID 6325 //
     /* 651199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 651202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651210 */     // MIs[0] offset
     /* 651210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651213 */     // MIs[0] auxiliary
     /* 651213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651216 */     // MIs[0] Operand 8
     /* 651216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651226 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN),
     /* 651229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651231 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651233 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651242 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651254 */     GIR_RootConstrainSelectedInstOperands,
     /* 651255 */     // GIR_Coverage, 6325,
     /* 651255 */     GIR_EraseRootFromParent_Done,
     /* 651256 */   // Label 8295: @651256
     /* 651256 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(651318), // Rule ID 6329 //
     /* 651261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 651264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651272 */     // MIs[0] offset
     /* 651272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651275 */     // MIs[0] auxiliary
     /* 651275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651278 */     // MIs[0] Operand 8
     /* 651278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651288 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN),
     /* 651291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651293 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651295 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651304 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651316 */     GIR_RootConstrainSelectedInstOperands,
     /* 651317 */     // GIR_Coverage, 6329,
     /* 651317 */     GIR_EraseRootFromParent_Done,
     /* 651318 */   // Label 8296: @651318
     /* 651318 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(651414), // Rule ID 6311 //
     /* 651323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 651326 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651328 */     // MIs[0] offset
     /* 651328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651331 */     // MIs[0] auxiliary
     /* 651331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651334 */     // MIs[0] Operand 8
     /* 651334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651344 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN anonymous_9787:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651360 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651367 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN),
     /* 651388 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651400 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651412 */     GIR_RootConstrainSelectedInstOperands,
     /* 651413 */     // GIR_Coverage, 6311,
     /* 651413 */     GIR_EraseRootFromParent_Done,
     /* 651414 */   // Label 8297: @651414
     /* 651414 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(651510), // Rule ID 6315 //
     /* 651419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 651422 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651424 */     // MIs[0] offset
     /* 651424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651427 */     // MIs[0] auxiliary
     /* 651427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651430 */     // MIs[0] Operand 8
     /* 651430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651440 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN anonymous_9787:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651456 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651463 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN),
     /* 651484 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651496 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651508 */     GIR_RootConstrainSelectedInstOperands,
     /* 651509 */     // GIR_Coverage, 6315,
     /* 651509 */     GIR_EraseRootFromParent_Done,
     /* 651510 */   // Label 8298: @651510
     /* 651510 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(651610), // Rule ID 6327 //
     /* 651515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 651518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651522 */     // MIs[0] offset
     /* 651522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651525 */     // MIs[0] auxiliary
     /* 651525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651528 */     // MIs[0] Operand 8
     /* 651528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651538 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651554 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651561 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN),
     /* 651582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651596 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651608 */     GIR_RootConstrainSelectedInstOperands,
     /* 651609 */     // GIR_Coverage, 6327,
     /* 651609 */     GIR_EraseRootFromParent_Done,
     /* 651610 */   // Label 8299: @651610
     /* 651610 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(651710), // Rule ID 6331 //
     /* 651615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 651618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651622 */     // MIs[0] offset
     /* 651622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651625 */     // MIs[0] auxiliary
     /* 651625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651628 */     // MIs[0] Operand 8
     /* 651628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651638 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN:{ *:[v2f16] } anonymous_9787:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651654 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651661 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN),
     /* 651682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651684 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651708 */     GIR_RootConstrainSelectedInstOperands,
     /* 651709 */     // GIR_Coverage, 6331,
     /* 651709 */     GIR_EraseRootFromParent_Done,
     /* 651710 */   // Label 8300: @651710
     /* 651710 */   GIM_Reject,
     /* 651711 */ // Label 8284: @651711
     /* 651711 */ GIM_Reject,
     /* 651712 */ // Label 8249: @651712
     /* 651712 */ GIM_Reject,
     /* 651713 */ // Label 114: @651713
     /* 651713 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8303*/ GIMT_Encode4(655328),
     /* 651724 */ /*GILLT_s32*//*Label 8301*/ GIMT_Encode4(651732),
     /* 651728 */ /*GILLT_s64*//*Label 8302*/ GIMT_Encode4(652938),
     /* 651732 */ // Label 8301: @651732
     /* 651732 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(652937),
     /* 651737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 651740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 651743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 651746 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 651749 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 651752 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(651820), // Rule ID 6256 //
     /* 651757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651760 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651770 */     // MIs[0] offset
     /* 651770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651773 */     // MIs[0] auxiliary
     /* 651773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651776 */     // MIs[0] Operand 8
     /* 651776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651794 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 651797 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651806 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651818 */     GIR_RootConstrainSelectedInstOperands,
     /* 651819 */     // GIR_Coverage, 6256,
     /* 651819 */     GIR_EraseRootFromParent_Done,
     /* 651820 */   // Label 8305: @651820
     /* 651820 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(651888), // Rule ID 6264 //
     /* 651825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651828 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651838 */     // MIs[0] offset
     /* 651838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651841 */     // MIs[0] auxiliary
     /* 651841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651844 */     // MIs[0] Operand 8
     /* 651844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651862 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 651865 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651874 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651886 */     GIR_RootConstrainSelectedInstOperands,
     /* 651887 */     // GIR_Coverage, 6264,
     /* 651887 */     GIR_EraseRootFromParent_Done,
     /* 651888 */   // Label 8306: @651888
     /* 651888 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(651960), // Rule ID 6252 //
     /* 651893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651908 */     // MIs[0] offset
     /* 651908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651911 */     // MIs[0] auxiliary
     /* 651911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651914 */     // MIs[0] Operand 8
     /* 651914 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651932 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 651935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651937 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651946 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651958 */     GIR_RootConstrainSelectedInstOperands,
     /* 651959 */     // GIR_Coverage, 6252,
     /* 651959 */     GIR_EraseRootFromParent_Done,
     /* 651960 */   // Label 8307: @651960
     /* 651960 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(652032), // Rule ID 6260 //
     /* 651965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651980 */     // MIs[0] offset
     /* 651980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651983 */     // MIs[0] auxiliary
     /* 651983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651986 */     // MIs[0] Operand 8
     /* 651986 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652004 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 652007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652009 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652018 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652030 */     GIR_RootConstrainSelectedInstOperands,
     /* 652031 */     // GIR_Coverage, 6260,
     /* 652031 */     GIR_EraseRootFromParent_Done,
     /* 652032 */   // Label 8308: @652032
     /* 652032 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(652098), // Rule ID 6258 //
     /* 652037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652040 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652046 */     // MIs[0] offset
     /* 652046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652049 */     // MIs[0] auxiliary
     /* 652049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652052 */     // MIs[0] Operand 8
     /* 652052 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652070 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN),
     /* 652073 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652075 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652084 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652096 */     GIR_RootConstrainSelectedInstOperands,
     /* 652097 */     // GIR_Coverage, 6258,
     /* 652097 */     GIR_EraseRootFromParent_Done,
     /* 652098 */   // Label 8309: @652098
     /* 652098 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(652164), // Rule ID 6266 //
     /* 652103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652106 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652112 */     // MIs[0] offset
     /* 652112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652115 */     // MIs[0] auxiliary
     /* 652115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652118 */     // MIs[0] Operand 8
     /* 652118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652136 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN),
     /* 652139 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652141 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652150 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652162 */     GIR_RootConstrainSelectedInstOperands,
     /* 652163 */     // GIR_Coverage, 6266,
     /* 652163 */     GIR_EraseRootFromParent_Done,
     /* 652164 */   // Label 8310: @652164
     /* 652164 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(652234), // Rule ID 6254 //
     /* 652169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652180 */     // MIs[0] offset
     /* 652180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652183 */     // MIs[0] auxiliary
     /* 652183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652186 */     // MIs[0] Operand 8
     /* 652186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652204 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN_RTN),
     /* 652207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652209 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652211 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652220 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652232 */     GIR_RootConstrainSelectedInstOperands,
     /* 652233 */     // GIR_Coverage, 6254,
     /* 652233 */     GIR_EraseRootFromParent_Done,
     /* 652234 */   // Label 8311: @652234
     /* 652234 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(652304), // Rule ID 6262 //
     /* 652239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652250 */     // MIs[0] offset
     /* 652250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652253 */     // MIs[0] auxiliary
     /* 652253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652256 */     // MIs[0] Operand 8
     /* 652256 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652274 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN),
     /* 652277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652279 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652281 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652290 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652302 */     GIR_RootConstrainSelectedInstOperands,
     /* 652303 */     // GIR_Coverage, 6262,
     /* 652303 */     GIR_EraseRootFromParent_Done,
     /* 652304 */   // Label 8312: @652304
     /* 652304 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(652362), // Rule ID 6257 //
     /* 652309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652312 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652318 */     // MIs[0] offset
     /* 652318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652321 */     // MIs[0] auxiliary
     /* 652321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652324 */     // MIs[0] Operand 8
     /* 652324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652334 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN),
     /* 652337 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652339 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652348 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652360 */     GIR_RootConstrainSelectedInstOperands,
     /* 652361 */     // GIR_Coverage, 6257,
     /* 652361 */     GIR_EraseRootFromParent_Done,
     /* 652362 */   // Label 8313: @652362
     /* 652362 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(652420), // Rule ID 6265 //
     /* 652367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652370 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652376 */     // MIs[0] offset
     /* 652376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652379 */     // MIs[0] auxiliary
     /* 652379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652382 */     // MIs[0] Operand 8
     /* 652382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652392 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN),
     /* 652395 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652397 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652406 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652418 */     GIR_RootConstrainSelectedInstOperands,
     /* 652419 */     // GIR_Coverage, 6265,
     /* 652419 */     GIR_EraseRootFromParent_Done,
     /* 652420 */   // Label 8314: @652420
     /* 652420 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(652482), // Rule ID 6253 //
     /* 652425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652436 */     // MIs[0] offset
     /* 652436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652439 */     // MIs[0] auxiliary
     /* 652439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652442 */     // MIs[0] Operand 8
     /* 652442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652452 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN_RTN),
     /* 652455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652457 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652459 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652468 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652480 */     GIR_RootConstrainSelectedInstOperands,
     /* 652481 */     // GIR_Coverage, 6253,
     /* 652481 */     GIR_EraseRootFromParent_Done,
     /* 652482 */   // Label 8315: @652482
     /* 652482 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(652544), // Rule ID 6261 //
     /* 652487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652498 */     // MIs[0] offset
     /* 652498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652501 */     // MIs[0] auxiliary
     /* 652501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652504 */     // MIs[0] Operand 8
     /* 652504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652514 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN),
     /* 652517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652519 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652521 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652530 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652542 */     GIR_RootConstrainSelectedInstOperands,
     /* 652543 */     // GIR_Coverage, 6261,
     /* 652543 */     GIR_EraseRootFromParent_Done,
     /* 652544 */   // Label 8316: @652544
     /* 652544 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(652640), // Rule ID 6259 //
     /* 652549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652552 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652554 */     // MIs[0] offset
     /* 652554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652557 */     // MIs[0] auxiliary
     /* 652557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652560 */     // MIs[0] Operand 8
     /* 652560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652570 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652586 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652593 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN),
     /* 652614 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652626 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652638 */     GIR_RootConstrainSelectedInstOperands,
     /* 652639 */     // GIR_Coverage, 6259,
     /* 652639 */     GIR_EraseRootFromParent_Done,
     /* 652640 */   // Label 8317: @652640
     /* 652640 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(652736), // Rule ID 6267 //
     /* 652645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652648 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652650 */     // MIs[0] offset
     /* 652650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652653 */     // MIs[0] auxiliary
     /* 652653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652656 */     // MIs[0] Operand 8
     /* 652656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652666 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652682 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652689 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN),
     /* 652710 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652722 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652734 */     GIR_RootConstrainSelectedInstOperands,
     /* 652735 */     // GIR_Coverage, 6267,
     /* 652735 */     GIR_EraseRootFromParent_Done,
     /* 652736 */   // Label 8318: @652736
     /* 652736 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(652836), // Rule ID 6255 //
     /* 652741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652748 */     // MIs[0] offset
     /* 652748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652751 */     // MIs[0] auxiliary
     /* 652751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652754 */     // MIs[0] Operand 8
     /* 652754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652764 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652780 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652787 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN_RTN),
     /* 652808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652810 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652822 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652834 */     GIR_RootConstrainSelectedInstOperands,
     /* 652835 */     // GIR_Coverage, 6255,
     /* 652835 */     GIR_EraseRootFromParent_Done,
     /* 652836 */   // Label 8319: @652836
     /* 652836 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(652936), // Rule ID 6263 //
     /* 652841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652848 */     // MIs[0] offset
     /* 652848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652851 */     // MIs[0] auxiliary
     /* 652851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652854 */     // MIs[0] Operand 8
     /* 652854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652864 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652880 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652887 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN),
     /* 652908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652910 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652922 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652934 */     GIR_RootConstrainSelectedInstOperands,
     /* 652935 */     // GIR_Coverage, 6263,
     /* 652935 */     GIR_EraseRootFromParent_Done,
     /* 652936 */   // Label 8320: @652936
     /* 652936 */   GIM_Reject,
     /* 652937 */ // Label 8304: @652937
     /* 652937 */ GIM_Reject,
     /* 652938 */ // Label 8302: @652938
     /* 652938 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(655327),
     /* 652943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 652946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 652949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 652952 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 652955 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 652958 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(653026), // Rule ID 6288 //
     /* 652963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 652966 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652976 */     // MIs[0] offset
     /* 652976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652979 */     // MIs[0] auxiliary
     /* 652979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652982 */     // MIs[0] Operand 8
     /* 652982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653000 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 653003 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653012 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653024 */     GIR_RootConstrainSelectedInstOperands,
     /* 653025 */     // GIR_Coverage, 6288,
     /* 653025 */     GIR_EraseRootFromParent_Done,
     /* 653026 */   // Label 8322: @653026
     /* 653026 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(653094), // Rule ID 6296 //
     /* 653031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653034 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653044 */     // MIs[0] offset
     /* 653044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653047 */     // MIs[0] auxiliary
     /* 653047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653050 */     // MIs[0] Operand 8
     /* 653050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653068 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 653071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653092 */     GIR_RootConstrainSelectedInstOperands,
     /* 653093 */     // GIR_Coverage, 6296,
     /* 653093 */     GIR_EraseRootFromParent_Done,
     /* 653094 */   // Label 8323: @653094
     /* 653094 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(653162), // Rule ID 6368 //
     /* 653099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653102 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653112 */     // MIs[0] offset
     /* 653112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653115 */     // MIs[0] auxiliary
     /* 653115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653118 */     // MIs[0] Operand 8
     /* 653118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653136 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 653139 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653148 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653160 */     GIR_RootConstrainSelectedInstOperands,
     /* 653161 */     // GIR_Coverage, 6368,
     /* 653161 */     GIR_EraseRootFromParent_Done,
     /* 653162 */   // Label 8324: @653162
     /* 653162 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(653230), // Rule ID 6376 //
     /* 653167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653170 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653180 */     // MIs[0] offset
     /* 653180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653183 */     // MIs[0] auxiliary
     /* 653183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653186 */     // MIs[0] Operand 8
     /* 653186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653204 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 653207 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653216 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653228 */     GIR_RootConstrainSelectedInstOperands,
     /* 653229 */     // GIR_Coverage, 6376,
     /* 653229 */     GIR_EraseRootFromParent_Done,
     /* 653230 */   // Label 8325: @653230
     /* 653230 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(653302), // Rule ID 6284 //
     /* 653235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653250 */     // MIs[0] offset
     /* 653250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653253 */     // MIs[0] auxiliary
     /* 653253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653256 */     // MIs[0] Operand 8
     /* 653256 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653274 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 653277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653279 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653288 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653300 */     GIR_RootConstrainSelectedInstOperands,
     /* 653301 */     // GIR_Coverage, 6284,
     /* 653301 */     GIR_EraseRootFromParent_Done,
     /* 653302 */   // Label 8326: @653302
     /* 653302 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(653374), // Rule ID 6292 //
     /* 653307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653322 */     // MIs[0] offset
     /* 653322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653325 */     // MIs[0] auxiliary
     /* 653325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653328 */     // MIs[0] Operand 8
     /* 653328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653346 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 653349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653351 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653360 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653372 */     GIR_RootConstrainSelectedInstOperands,
     /* 653373 */     // GIR_Coverage, 6292,
     /* 653373 */     GIR_EraseRootFromParent_Done,
     /* 653374 */   // Label 8327: @653374
     /* 653374 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(653446), // Rule ID 6364 //
     /* 653379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653394 */     // MIs[0] offset
     /* 653394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653397 */     // MIs[0] auxiliary
     /* 653397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653400 */     // MIs[0] Operand 8
     /* 653400 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653418 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 653421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653423 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653432 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653444 */     GIR_RootConstrainSelectedInstOperands,
     /* 653445 */     // GIR_Coverage, 6364,
     /* 653445 */     GIR_EraseRootFromParent_Done,
     /* 653446 */   // Label 8328: @653446
     /* 653446 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(653518), // Rule ID 6372 //
     /* 653451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653466 */     // MIs[0] offset
     /* 653466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653469 */     // MIs[0] auxiliary
     /* 653469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653472 */     // MIs[0] Operand 8
     /* 653472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653490 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 653493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653495 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653504 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653516 */     GIR_RootConstrainSelectedInstOperands,
     /* 653517 */     // GIR_Coverage, 6372,
     /* 653517 */     GIR_EraseRootFromParent_Done,
     /* 653518 */   // Label 8329: @653518
     /* 653518 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(653584), // Rule ID 6290 //
     /* 653523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653532 */     // MIs[0] offset
     /* 653532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653535 */     // MIs[0] auxiliary
     /* 653535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653538 */     // MIs[0] Operand 8
     /* 653538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653556 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 653559 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653561 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653570 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653582 */     GIR_RootConstrainSelectedInstOperands,
     /* 653583 */     // GIR_Coverage, 6290,
     /* 653583 */     GIR_EraseRootFromParent_Done,
     /* 653584 */   // Label 8330: @653584
     /* 653584 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(653650), // Rule ID 6298 //
     /* 653589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653592 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653598 */     // MIs[0] offset
     /* 653598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653601 */     // MIs[0] auxiliary
     /* 653601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653604 */     // MIs[0] Operand 8
     /* 653604 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653622 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 653625 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653627 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653636 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653648 */     GIR_RootConstrainSelectedInstOperands,
     /* 653649 */     // GIR_Coverage, 6298,
     /* 653649 */     GIR_EraseRootFromParent_Done,
     /* 653650 */   // Label 8331: @653650
     /* 653650 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(653716), // Rule ID 6370 //
     /* 653655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653658 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653664 */     // MIs[0] offset
     /* 653664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653667 */     // MIs[0] auxiliary
     /* 653667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653670 */     // MIs[0] Operand 8
     /* 653670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653688 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 653691 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653693 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653702 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653714 */     GIR_RootConstrainSelectedInstOperands,
     /* 653715 */     // GIR_Coverage, 6370,
     /* 653715 */     GIR_EraseRootFromParent_Done,
     /* 653716 */   // Label 8332: @653716
     /* 653716 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(653782), // Rule ID 6378 //
     /* 653721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653724 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653730 */     // MIs[0] offset
     /* 653730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653733 */     // MIs[0] auxiliary
     /* 653733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653736 */     // MIs[0] Operand 8
     /* 653736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653754 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 653757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653759 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653768 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653780 */     GIR_RootConstrainSelectedInstOperands,
     /* 653781 */     // GIR_Coverage, 6378,
     /* 653781 */     GIR_EraseRootFromParent_Done,
     /* 653782 */   // Label 8333: @653782
     /* 653782 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(653852), // Rule ID 6286 //
     /* 653787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653798 */     // MIs[0] offset
     /* 653798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653801 */     // MIs[0] auxiliary
     /* 653801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653804 */     // MIs[0] Operand 8
     /* 653804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653822 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 653825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653827 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653829 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653838 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653850 */     GIR_RootConstrainSelectedInstOperands,
     /* 653851 */     // GIR_Coverage, 6286,
     /* 653851 */     GIR_EraseRootFromParent_Done,
     /* 653852 */   // Label 8334: @653852
     /* 653852 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(653922), // Rule ID 6294 //
     /* 653857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653868 */     // MIs[0] offset
     /* 653868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653871 */     // MIs[0] auxiliary
     /* 653871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653874 */     // MIs[0] Operand 8
     /* 653874 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653892 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 653895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653897 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653899 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653908 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653920 */     GIR_RootConstrainSelectedInstOperands,
     /* 653921 */     // GIR_Coverage, 6294,
     /* 653921 */     GIR_EraseRootFromParent_Done,
     /* 653922 */   // Label 8335: @653922
     /* 653922 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(653992), // Rule ID 6366 //
     /* 653927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653938 */     // MIs[0] offset
     /* 653938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653941 */     // MIs[0] auxiliary
     /* 653941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653944 */     // MIs[0] Operand 8
     /* 653944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653962 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 653965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653967 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653969 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653978 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653990 */     GIR_RootConstrainSelectedInstOperands,
     /* 653991 */     // GIR_Coverage, 6366,
     /* 653991 */     GIR_EraseRootFromParent_Done,
     /* 653992 */   // Label 8336: @653992
     /* 653992 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(654062), // Rule ID 6374 //
     /* 653997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654008 */     // MIs[0] offset
     /* 654008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654011 */     // MIs[0] auxiliary
     /* 654011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654014 */     // MIs[0] Operand 8
     /* 654014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654032 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 654035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654037 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654039 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 654041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654048 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654060 */     GIR_RootConstrainSelectedInstOperands,
     /* 654061 */     // GIR_Coverage, 6374,
     /* 654061 */     GIR_EraseRootFromParent_Done,
     /* 654062 */   // Label 8337: @654062
     /* 654062 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(654120), // Rule ID 6289 //
     /* 654067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654070 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654076 */     // MIs[0] offset
     /* 654076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654079 */     // MIs[0] auxiliary
     /* 654079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654082 */     // MIs[0] Operand 8
     /* 654082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654092 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 654095 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654097 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654106 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654118 */     GIR_RootConstrainSelectedInstOperands,
     /* 654119 */     // GIR_Coverage, 6289,
     /* 654119 */     GIR_EraseRootFromParent_Done,
     /* 654120 */   // Label 8338: @654120
     /* 654120 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(654178), // Rule ID 6297 //
     /* 654125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654128 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654134 */     // MIs[0] offset
     /* 654134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654137 */     // MIs[0] auxiliary
     /* 654137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654140 */     // MIs[0] Operand 8
     /* 654140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654150 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 654153 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654155 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654164 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654176 */     GIR_RootConstrainSelectedInstOperands,
     /* 654177 */     // GIR_Coverage, 6297,
     /* 654177 */     GIR_EraseRootFromParent_Done,
     /* 654178 */   // Label 8339: @654178
     /* 654178 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(654236), // Rule ID 6369 //
     /* 654183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654186 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654192 */     // MIs[0] offset
     /* 654192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654195 */     // MIs[0] auxiliary
     /* 654195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654198 */     // MIs[0] Operand 8
     /* 654198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654208 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 654211 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654213 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654222 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654234 */     GIR_RootConstrainSelectedInstOperands,
     /* 654235 */     // GIR_Coverage, 6369,
     /* 654235 */     GIR_EraseRootFromParent_Done,
     /* 654236 */   // Label 8340: @654236
     /* 654236 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(654294), // Rule ID 6377 //
     /* 654241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654244 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654250 */     // MIs[0] offset
     /* 654250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654253 */     // MIs[0] auxiliary
     /* 654253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654256 */     // MIs[0] Operand 8
     /* 654256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654266 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 654269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654271 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654280 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654292 */     GIR_RootConstrainSelectedInstOperands,
     /* 654293 */     // GIR_Coverage, 6377,
     /* 654293 */     GIR_EraseRootFromParent_Done,
     /* 654294 */   // Label 8341: @654294
     /* 654294 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(654356), // Rule ID 6285 //
     /* 654299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654310 */     // MIs[0] offset
     /* 654310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654313 */     // MIs[0] auxiliary
     /* 654313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654316 */     // MIs[0] Operand 8
     /* 654316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654326 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 654329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654331 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654333 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654342 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654354 */     GIR_RootConstrainSelectedInstOperands,
     /* 654355 */     // GIR_Coverage, 6285,
     /* 654355 */     GIR_EraseRootFromParent_Done,
     /* 654356 */   // Label 8342: @654356
     /* 654356 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(654418), // Rule ID 6293 //
     /* 654361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654372 */     // MIs[0] offset
     /* 654372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654375 */     // MIs[0] auxiliary
     /* 654375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654378 */     // MIs[0] Operand 8
     /* 654378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654388 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 654391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654393 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654395 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654404 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654416 */     GIR_RootConstrainSelectedInstOperands,
     /* 654417 */     // GIR_Coverage, 6293,
     /* 654417 */     GIR_EraseRootFromParent_Done,
     /* 654418 */   // Label 8343: @654418
     /* 654418 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(654480), // Rule ID 6365 //
     /* 654423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654434 */     // MIs[0] offset
     /* 654434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654437 */     // MIs[0] auxiliary
     /* 654437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654440 */     // MIs[0] Operand 8
     /* 654440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654450 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 654453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654455 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654457 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654466 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654478 */     GIR_RootConstrainSelectedInstOperands,
     /* 654479 */     // GIR_Coverage, 6365,
     /* 654479 */     GIR_EraseRootFromParent_Done,
     /* 654480 */   // Label 8344: @654480
     /* 654480 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(654542), // Rule ID 6373 //
     /* 654485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654496 */     // MIs[0] offset
     /* 654496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654499 */     // MIs[0] auxiliary
     /* 654499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654502 */     // MIs[0] Operand 8
     /* 654502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654512 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 654515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654517 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654519 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654528 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654540 */     GIR_RootConstrainSelectedInstOperands,
     /* 654541 */     // GIR_Coverage, 6373,
     /* 654541 */     GIR_EraseRootFromParent_Done,
     /* 654542 */   // Label 8345: @654542
     /* 654542 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(654638), // Rule ID 6291 //
     /* 654547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654550 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654552 */     // MIs[0] offset
     /* 654552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654555 */     // MIs[0] auxiliary
     /* 654555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654558 */     // MIs[0] Operand 8
     /* 654558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654568 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654584 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654591 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 654612 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654624 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654636 */     GIR_RootConstrainSelectedInstOperands,
     /* 654637 */     // GIR_Coverage, 6291,
     /* 654637 */     GIR_EraseRootFromParent_Done,
     /* 654638 */   // Label 8346: @654638
     /* 654638 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(654734), // Rule ID 6299 //
     /* 654643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654646 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654648 */     // MIs[0] offset
     /* 654648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654651 */     // MIs[0] auxiliary
     /* 654651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654654 */     // MIs[0] Operand 8
     /* 654654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654664 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654680 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654687 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 654708 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654720 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654732 */     GIR_RootConstrainSelectedInstOperands,
     /* 654733 */     // GIR_Coverage, 6299,
     /* 654733 */     GIR_EraseRootFromParent_Done,
     /* 654734 */   // Label 8347: @654734
     /* 654734 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(654830), // Rule ID 6371 //
     /* 654739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654742 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654744 */     // MIs[0] offset
     /* 654744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654747 */     // MIs[0] auxiliary
     /* 654747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654750 */     // MIs[0] Operand 8
     /* 654750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654760 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654776 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654783 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 654804 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654816 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654828 */     GIR_RootConstrainSelectedInstOperands,
     /* 654829 */     // GIR_Coverage, 6371,
     /* 654829 */     GIR_EraseRootFromParent_Done,
     /* 654830 */   // Label 8348: @654830
     /* 654830 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(654926), // Rule ID 6379 //
     /* 654835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654838 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654840 */     // MIs[0] offset
     /* 654840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654843 */     // MIs[0] auxiliary
     /* 654843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654846 */     // MIs[0] Operand 8
     /* 654846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654856 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654872 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654879 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 654900 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654912 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654924 */     GIR_RootConstrainSelectedInstOperands,
     /* 654925 */     // GIR_Coverage, 6379,
     /* 654925 */     GIR_EraseRootFromParent_Done,
     /* 654926 */   // Label 8349: @654926
     /* 654926 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(655026), // Rule ID 6287 //
     /* 654931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654938 */     // MIs[0] offset
     /* 654938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654941 */     // MIs[0] auxiliary
     /* 654941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654944 */     // MIs[0] Operand 8
     /* 654944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654954 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654970 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654977 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 654998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655000 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655012 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655024 */     GIR_RootConstrainSelectedInstOperands,
     /* 655025 */     // GIR_Coverage, 6287,
     /* 655025 */     GIR_EraseRootFromParent_Done,
     /* 655026 */   // Label 8350: @655026
     /* 655026 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(655126), // Rule ID 6295 //
     /* 655031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 655034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 655038 */     // MIs[0] offset
     /* 655038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655041 */     // MIs[0] auxiliary
     /* 655041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655044 */     // MIs[0] Operand 8
     /* 655044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655054 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655070 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655077 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 655098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655100 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655112 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655124 */     GIR_RootConstrainSelectedInstOperands,
     /* 655125 */     // GIR_Coverage, 6295,
     /* 655125 */     GIR_EraseRootFromParent_Done,
     /* 655126 */   // Label 8351: @655126
     /* 655126 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(655226), // Rule ID 6367 //
     /* 655131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 655134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 655138 */     // MIs[0] offset
     /* 655138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655141 */     // MIs[0] auxiliary
     /* 655141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655144 */     // MIs[0] Operand 8
     /* 655144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655154 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655170 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655177 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 655198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655200 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655212 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655224 */     GIR_RootConstrainSelectedInstOperands,
     /* 655225 */     // GIR_Coverage, 6367,
     /* 655225 */     GIR_EraseRootFromParent_Done,
     /* 655226 */   // Label 8352: @655226
     /* 655226 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(655326), // Rule ID 6375 //
     /* 655231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 655234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 655238 */     // MIs[0] offset
     /* 655238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655241 */     // MIs[0] auxiliary
     /* 655241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655244 */     // MIs[0] Operand 8
     /* 655244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655254 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 655298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655300 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655312 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655324 */     GIR_RootConstrainSelectedInstOperands,
     /* 655325 */     // GIR_Coverage, 6375,
     /* 655325 */     GIR_EraseRootFromParent_Done,
     /* 655326 */   // Label 8353: @655326
     /* 655326 */   GIM_Reject,
     /* 655327 */ // Label 8321: @655327
     /* 655327 */ GIM_Reject,
     /* 655328 */ // Label 8303: @655328
     /* 655328 */ GIM_Reject,
     /* 655329 */ // Label 115: @655329
     /* 655329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8356*/ GIMT_Encode4(658944),
     /* 655340 */ /*GILLT_s32*//*Label 8354*/ GIMT_Encode4(655348),
     /* 655344 */ /*GILLT_s64*//*Label 8355*/ GIMT_Encode4(656554),
     /* 655348 */ // Label 8354: @655348
     /* 655348 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(656553),
     /* 655353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 655356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 655359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 655362 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 655365 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 655368 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(655436), // Rule ID 6240 //
     /* 655373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655376 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655386 */     // MIs[0] offset
     /* 655386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655389 */     // MIs[0] auxiliary
     /* 655389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655392 */     // MIs[0] Operand 8
     /* 655392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655410 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 655413 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655422 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655434 */     GIR_RootConstrainSelectedInstOperands,
     /* 655435 */     // GIR_Coverage, 6240,
     /* 655435 */     GIR_EraseRootFromParent_Done,
     /* 655436 */   // Label 8358: @655436
     /* 655436 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(655504), // Rule ID 6248 //
     /* 655441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655444 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655454 */     // MIs[0] offset
     /* 655454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655457 */     // MIs[0] auxiliary
     /* 655457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655460 */     // MIs[0] Operand 8
     /* 655460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655478 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 655481 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655490 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655502 */     GIR_RootConstrainSelectedInstOperands,
     /* 655503 */     // GIR_Coverage, 6248,
     /* 655503 */     GIR_EraseRootFromParent_Done,
     /* 655504 */   // Label 8359: @655504
     /* 655504 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(655576), // Rule ID 6236 //
     /* 655509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655524 */     // MIs[0] offset
     /* 655524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655527 */     // MIs[0] auxiliary
     /* 655527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655530 */     // MIs[0] Operand 8
     /* 655530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655548 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 655551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655553 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655562 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655574 */     GIR_RootConstrainSelectedInstOperands,
     /* 655575 */     // GIR_Coverage, 6236,
     /* 655575 */     GIR_EraseRootFromParent_Done,
     /* 655576 */   // Label 8360: @655576
     /* 655576 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(655648), // Rule ID 6244 //
     /* 655581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655596 */     // MIs[0] offset
     /* 655596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655599 */     // MIs[0] auxiliary
     /* 655599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655602 */     // MIs[0] Operand 8
     /* 655602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655620 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 655623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655625 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655634 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655646 */     GIR_RootConstrainSelectedInstOperands,
     /* 655647 */     // GIR_Coverage, 6244,
     /* 655647 */     GIR_EraseRootFromParent_Done,
     /* 655648 */   // Label 8361: @655648
     /* 655648 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(655714), // Rule ID 6242 //
     /* 655653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655656 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655662 */     // MIs[0] offset
     /* 655662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655665 */     // MIs[0] auxiliary
     /* 655665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655668 */     // MIs[0] Operand 8
     /* 655668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655686 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN),
     /* 655689 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655691 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655700 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655712 */     GIR_RootConstrainSelectedInstOperands,
     /* 655713 */     // GIR_Coverage, 6242,
     /* 655713 */     GIR_EraseRootFromParent_Done,
     /* 655714 */   // Label 8362: @655714
     /* 655714 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(655780), // Rule ID 6250 //
     /* 655719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655722 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655728 */     // MIs[0] offset
     /* 655728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655731 */     // MIs[0] auxiliary
     /* 655731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655734 */     // MIs[0] Operand 8
     /* 655734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655752 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN),
     /* 655755 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655757 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655766 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655778 */     GIR_RootConstrainSelectedInstOperands,
     /* 655779 */     // GIR_Coverage, 6250,
     /* 655779 */     GIR_EraseRootFromParent_Done,
     /* 655780 */   // Label 8363: @655780
     /* 655780 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(655850), // Rule ID 6238 //
     /* 655785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655796 */     // MIs[0] offset
     /* 655796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655799 */     // MIs[0] auxiliary
     /* 655799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655802 */     // MIs[0] Operand 8
     /* 655802 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655820 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN_RTN),
     /* 655823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655825 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655827 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655836 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655848 */     GIR_RootConstrainSelectedInstOperands,
     /* 655849 */     // GIR_Coverage, 6238,
     /* 655849 */     GIR_EraseRootFromParent_Done,
     /* 655850 */   // Label 8364: @655850
     /* 655850 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(655920), // Rule ID 6246 //
     /* 655855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655866 */     // MIs[0] offset
     /* 655866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655869 */     // MIs[0] auxiliary
     /* 655869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655872 */     // MIs[0] Operand 8
     /* 655872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655890 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN),
     /* 655893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655895 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655897 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655906 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655918 */     GIR_RootConstrainSelectedInstOperands,
     /* 655919 */     // GIR_Coverage, 6246,
     /* 655919 */     GIR_EraseRootFromParent_Done,
     /* 655920 */   // Label 8365: @655920
     /* 655920 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(655978), // Rule ID 6241 //
     /* 655925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655928 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655934 */     // MIs[0] offset
     /* 655934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655937 */     // MIs[0] auxiliary
     /* 655937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655940 */     // MIs[0] Operand 8
     /* 655940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655950 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN),
     /* 655953 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655955 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655964 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655976 */     GIR_RootConstrainSelectedInstOperands,
     /* 655977 */     // GIR_Coverage, 6241,
     /* 655977 */     GIR_EraseRootFromParent_Done,
     /* 655978 */   // Label 8366: @655978
     /* 655978 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(656036), // Rule ID 6249 //
     /* 655983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655986 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655992 */     // MIs[0] offset
     /* 655992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655995 */     // MIs[0] auxiliary
     /* 655995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655998 */     // MIs[0] Operand 8
     /* 655998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656008 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN),
     /* 656011 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656013 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656022 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656034 */     GIR_RootConstrainSelectedInstOperands,
     /* 656035 */     // GIR_Coverage, 6249,
     /* 656035 */     GIR_EraseRootFromParent_Done,
     /* 656036 */   // Label 8367: @656036
     /* 656036 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(656098), // Rule ID 6237 //
     /* 656041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656052 */     // MIs[0] offset
     /* 656052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656055 */     // MIs[0] auxiliary
     /* 656055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656058 */     // MIs[0] Operand 8
     /* 656058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656068 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN_RTN),
     /* 656071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656073 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656075 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656084 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656096 */     GIR_RootConstrainSelectedInstOperands,
     /* 656097 */     // GIR_Coverage, 6237,
     /* 656097 */     GIR_EraseRootFromParent_Done,
     /* 656098 */   // Label 8368: @656098
     /* 656098 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(656160), // Rule ID 6245 //
     /* 656103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656114 */     // MIs[0] offset
     /* 656114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656117 */     // MIs[0] auxiliary
     /* 656117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656120 */     // MIs[0] Operand 8
     /* 656120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656130 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN),
     /* 656133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656135 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656137 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656146 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656158 */     GIR_RootConstrainSelectedInstOperands,
     /* 656159 */     // GIR_Coverage, 6245,
     /* 656159 */     GIR_EraseRootFromParent_Done,
     /* 656160 */   // Label 8369: @656160
     /* 656160 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(656256), // Rule ID 6243 //
     /* 656165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656168 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656170 */     // MIs[0] offset
     /* 656170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656173 */     // MIs[0] auxiliary
     /* 656173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656176 */     // MIs[0] Operand 8
     /* 656176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656186 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656202 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656209 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN),
     /* 656230 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656242 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656254 */     GIR_RootConstrainSelectedInstOperands,
     /* 656255 */     // GIR_Coverage, 6243,
     /* 656255 */     GIR_EraseRootFromParent_Done,
     /* 656256 */   // Label 8370: @656256
     /* 656256 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(656352), // Rule ID 6251 //
     /* 656261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656264 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656266 */     // MIs[0] offset
     /* 656266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656269 */     // MIs[0] auxiliary
     /* 656269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656272 */     // MIs[0] Operand 8
     /* 656272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656282 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656298 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656305 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN),
     /* 656326 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656338 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656350 */     GIR_RootConstrainSelectedInstOperands,
     /* 656351 */     // GIR_Coverage, 6251,
     /* 656351 */     GIR_EraseRootFromParent_Done,
     /* 656352 */   // Label 8371: @656352
     /* 656352 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(656452), // Rule ID 6239 //
     /* 656357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656364 */     // MIs[0] offset
     /* 656364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656367 */     // MIs[0] auxiliary
     /* 656367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656370 */     // MIs[0] Operand 8
     /* 656370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656380 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656396 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656403 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN_RTN),
     /* 656424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656426 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656438 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656450 */     GIR_RootConstrainSelectedInstOperands,
     /* 656451 */     // GIR_Coverage, 6239,
     /* 656451 */     GIR_EraseRootFromParent_Done,
     /* 656452 */   // Label 8372: @656452
     /* 656452 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(656552), // Rule ID 6247 //
     /* 656457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656464 */     // MIs[0] offset
     /* 656464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656467 */     // MIs[0] auxiliary
     /* 656467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656470 */     // MIs[0] Operand 8
     /* 656470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656480 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656496 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656503 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN),
     /* 656524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656526 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656538 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656550 */     GIR_RootConstrainSelectedInstOperands,
     /* 656551 */     // GIR_Coverage, 6247,
     /* 656551 */     GIR_EraseRootFromParent_Done,
     /* 656552 */   // Label 8373: @656552
     /* 656552 */   GIM_Reject,
     /* 656553 */ // Label 8357: @656553
     /* 656553 */ GIM_Reject,
     /* 656554 */ // Label 8355: @656554
     /* 656554 */ GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(658943),
     /* 656559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 656562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 656565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 656568 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 656571 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 656574 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(656642), // Rule ID 6272 //
     /* 656579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656582 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656592 */     // MIs[0] offset
     /* 656592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656595 */     // MIs[0] auxiliary
     /* 656595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656598 */     // MIs[0] Operand 8
     /* 656598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656616 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 656619 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656628 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656640 */     GIR_RootConstrainSelectedInstOperands,
     /* 656641 */     // GIR_Coverage, 6272,
     /* 656641 */     GIR_EraseRootFromParent_Done,
     /* 656642 */   // Label 8375: @656642
     /* 656642 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(656710), // Rule ID 6280 //
     /* 656647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656650 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656660 */     // MIs[0] offset
     /* 656660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656663 */     // MIs[0] auxiliary
     /* 656663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656666 */     // MIs[0] Operand 8
     /* 656666 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656684 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 656687 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656708 */     GIR_RootConstrainSelectedInstOperands,
     /* 656709 */     // GIR_Coverage, 6280,
     /* 656709 */     GIR_EraseRootFromParent_Done,
     /* 656710 */   // Label 8376: @656710
     /* 656710 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(656778), // Rule ID 6352 //
     /* 656715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656728 */     // MIs[0] offset
     /* 656728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656731 */     // MIs[0] auxiliary
     /* 656731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656734 */     // MIs[0] Operand 8
     /* 656734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656752 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 656755 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656764 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656776 */     GIR_RootConstrainSelectedInstOperands,
     /* 656777 */     // GIR_Coverage, 6352,
     /* 656777 */     GIR_EraseRootFromParent_Done,
     /* 656778 */   // Label 8377: @656778
     /* 656778 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(656846), // Rule ID 6360 //
     /* 656783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656786 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656796 */     // MIs[0] offset
     /* 656796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656799 */     // MIs[0] auxiliary
     /* 656799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656802 */     // MIs[0] Operand 8
     /* 656802 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656820 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 656823 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656832 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656844 */     GIR_RootConstrainSelectedInstOperands,
     /* 656845 */     // GIR_Coverage, 6360,
     /* 656845 */     GIR_EraseRootFromParent_Done,
     /* 656846 */   // Label 8378: @656846
     /* 656846 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(656918), // Rule ID 6268 //
     /* 656851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656866 */     // MIs[0] offset
     /* 656866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656869 */     // MIs[0] auxiliary
     /* 656869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656872 */     // MIs[0] Operand 8
     /* 656872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656890 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 656893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656895 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656904 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656916 */     GIR_RootConstrainSelectedInstOperands,
     /* 656917 */     // GIR_Coverage, 6268,
     /* 656917 */     GIR_EraseRootFromParent_Done,
     /* 656918 */   // Label 8379: @656918
     /* 656918 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(656990), // Rule ID 6276 //
     /* 656923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656938 */     // MIs[0] offset
     /* 656938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656941 */     // MIs[0] auxiliary
     /* 656941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656944 */     // MIs[0] Operand 8
     /* 656944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656962 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 656965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656967 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656976 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656988 */     GIR_RootConstrainSelectedInstOperands,
     /* 656989 */     // GIR_Coverage, 6276,
     /* 656989 */     GIR_EraseRootFromParent_Done,
     /* 656990 */   // Label 8380: @656990
     /* 656990 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(657062), // Rule ID 6348 //
     /* 656995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657010 */     // MIs[0] offset
     /* 657010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657013 */     // MIs[0] auxiliary
     /* 657013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657016 */     // MIs[0] Operand 8
     /* 657016 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657034 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 657037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657039 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657048 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657060 */     GIR_RootConstrainSelectedInstOperands,
     /* 657061 */     // GIR_Coverage, 6348,
     /* 657061 */     GIR_EraseRootFromParent_Done,
     /* 657062 */   // Label 8381: @657062
     /* 657062 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(657134), // Rule ID 6356 //
     /* 657067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657082 */     // MIs[0] offset
     /* 657082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657085 */     // MIs[0] auxiliary
     /* 657085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657088 */     // MIs[0] Operand 8
     /* 657088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657106 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 657109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657111 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657120 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657132 */     GIR_RootConstrainSelectedInstOperands,
     /* 657133 */     // GIR_Coverage, 6356,
     /* 657133 */     GIR_EraseRootFromParent_Done,
     /* 657134 */   // Label 8382: @657134
     /* 657134 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(657200), // Rule ID 6274 //
     /* 657139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657142 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657148 */     // MIs[0] offset
     /* 657148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657151 */     // MIs[0] auxiliary
     /* 657151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657154 */     // MIs[0] Operand 8
     /* 657154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657172 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 657175 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657177 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657186 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657198 */     GIR_RootConstrainSelectedInstOperands,
     /* 657199 */     // GIR_Coverage, 6274,
     /* 657199 */     GIR_EraseRootFromParent_Done,
     /* 657200 */   // Label 8383: @657200
     /* 657200 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(657266), // Rule ID 6282 //
     /* 657205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657208 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657214 */     // MIs[0] offset
     /* 657214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657217 */     // MIs[0] auxiliary
     /* 657217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657220 */     // MIs[0] Operand 8
     /* 657220 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657238 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 657241 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657243 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657252 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657264 */     GIR_RootConstrainSelectedInstOperands,
     /* 657265 */     // GIR_Coverage, 6282,
     /* 657265 */     GIR_EraseRootFromParent_Done,
     /* 657266 */   // Label 8384: @657266
     /* 657266 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(657332), // Rule ID 6354 //
     /* 657271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657274 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657280 */     // MIs[0] offset
     /* 657280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657283 */     // MIs[0] auxiliary
     /* 657283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657286 */     // MIs[0] Operand 8
     /* 657286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657304 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 657307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657309 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657318 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657330 */     GIR_RootConstrainSelectedInstOperands,
     /* 657331 */     // GIR_Coverage, 6354,
     /* 657331 */     GIR_EraseRootFromParent_Done,
     /* 657332 */   // Label 8385: @657332
     /* 657332 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(657398), // Rule ID 6362 //
     /* 657337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657340 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657346 */     // MIs[0] offset
     /* 657346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657349 */     // MIs[0] auxiliary
     /* 657349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657352 */     // MIs[0] Operand 8
     /* 657352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657370 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 657373 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657375 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657384 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657396 */     GIR_RootConstrainSelectedInstOperands,
     /* 657397 */     // GIR_Coverage, 6362,
     /* 657397 */     GIR_EraseRootFromParent_Done,
     /* 657398 */   // Label 8386: @657398
     /* 657398 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(657468), // Rule ID 6270 //
     /* 657403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657414 */     // MIs[0] offset
     /* 657414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657417 */     // MIs[0] auxiliary
     /* 657417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657420 */     // MIs[0] Operand 8
     /* 657420 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657438 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 657441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657443 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657445 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657454 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657466 */     GIR_RootConstrainSelectedInstOperands,
     /* 657467 */     // GIR_Coverage, 6270,
     /* 657467 */     GIR_EraseRootFromParent_Done,
     /* 657468 */   // Label 8387: @657468
     /* 657468 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(657538), // Rule ID 6278 //
     /* 657473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657484 */     // MIs[0] offset
     /* 657484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657487 */     // MIs[0] auxiliary
     /* 657487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657490 */     // MIs[0] Operand 8
     /* 657490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657508 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 657511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657513 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657515 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657524 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657536 */     GIR_RootConstrainSelectedInstOperands,
     /* 657537 */     // GIR_Coverage, 6278,
     /* 657537 */     GIR_EraseRootFromParent_Done,
     /* 657538 */   // Label 8388: @657538
     /* 657538 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(657608), // Rule ID 6350 //
     /* 657543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657554 */     // MIs[0] offset
     /* 657554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657557 */     // MIs[0] auxiliary
     /* 657557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657560 */     // MIs[0] Operand 8
     /* 657560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657578 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 657581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657583 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657585 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657594 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657606 */     GIR_RootConstrainSelectedInstOperands,
     /* 657607 */     // GIR_Coverage, 6350,
     /* 657607 */     GIR_EraseRootFromParent_Done,
     /* 657608 */   // Label 8389: @657608
     /* 657608 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(657678), // Rule ID 6358 //
     /* 657613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657624 */     // MIs[0] offset
     /* 657624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657627 */     // MIs[0] auxiliary
     /* 657627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657630 */     // MIs[0] Operand 8
     /* 657630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657648 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 657651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657653 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657655 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657664 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657676 */     GIR_RootConstrainSelectedInstOperands,
     /* 657677 */     // GIR_Coverage, 6358,
     /* 657677 */     GIR_EraseRootFromParent_Done,
     /* 657678 */   // Label 8390: @657678
     /* 657678 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(657736), // Rule ID 6273 //
     /* 657683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657692 */     // MIs[0] offset
     /* 657692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657695 */     // MIs[0] auxiliary
     /* 657695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657698 */     // MIs[0] Operand 8
     /* 657698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657708 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 657711 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657713 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657722 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657734 */     GIR_RootConstrainSelectedInstOperands,
     /* 657735 */     // GIR_Coverage, 6273,
     /* 657735 */     GIR_EraseRootFromParent_Done,
     /* 657736 */   // Label 8391: @657736
     /* 657736 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(657794), // Rule ID 6281 //
     /* 657741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657744 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657750 */     // MIs[0] offset
     /* 657750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657753 */     // MIs[0] auxiliary
     /* 657753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657756 */     // MIs[0] Operand 8
     /* 657756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657766 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 657769 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657771 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657780 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657792 */     GIR_RootConstrainSelectedInstOperands,
     /* 657793 */     // GIR_Coverage, 6281,
     /* 657793 */     GIR_EraseRootFromParent_Done,
     /* 657794 */   // Label 8392: @657794
     /* 657794 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(657852), // Rule ID 6353 //
     /* 657799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657802 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657808 */     // MIs[0] offset
     /* 657808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657811 */     // MIs[0] auxiliary
     /* 657811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657814 */     // MIs[0] Operand 8
     /* 657814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657824 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 657827 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657829 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657838 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657850 */     GIR_RootConstrainSelectedInstOperands,
     /* 657851 */     // GIR_Coverage, 6353,
     /* 657851 */     GIR_EraseRootFromParent_Done,
     /* 657852 */   // Label 8393: @657852
     /* 657852 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(657910), // Rule ID 6361 //
     /* 657857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657860 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657866 */     // MIs[0] offset
     /* 657866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657869 */     // MIs[0] auxiliary
     /* 657869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657872 */     // MIs[0] Operand 8
     /* 657872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657882 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 657885 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657887 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657896 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657908 */     GIR_RootConstrainSelectedInstOperands,
     /* 657909 */     // GIR_Coverage, 6361,
     /* 657909 */     GIR_EraseRootFromParent_Done,
     /* 657910 */   // Label 8394: @657910
     /* 657910 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(657972), // Rule ID 6269 //
     /* 657915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657926 */     // MIs[0] offset
     /* 657926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657929 */     // MIs[0] auxiliary
     /* 657929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657932 */     // MIs[0] Operand 8
     /* 657932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657942 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 657945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657947 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657949 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657958 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657970 */     GIR_RootConstrainSelectedInstOperands,
     /* 657971 */     // GIR_Coverage, 6269,
     /* 657971 */     GIR_EraseRootFromParent_Done,
     /* 657972 */   // Label 8395: @657972
     /* 657972 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(658034), // Rule ID 6277 //
     /* 657977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657988 */     // MIs[0] offset
     /* 657988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657991 */     // MIs[0] auxiliary
     /* 657991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657994 */     // MIs[0] Operand 8
     /* 657994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658004 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 658007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658009 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658011 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658020 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658032 */     GIR_RootConstrainSelectedInstOperands,
     /* 658033 */     // GIR_Coverage, 6277,
     /* 658033 */     GIR_EraseRootFromParent_Done,
     /* 658034 */   // Label 8396: @658034
     /* 658034 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(658096), // Rule ID 6349 //
     /* 658039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658050 */     // MIs[0] offset
     /* 658050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658053 */     // MIs[0] auxiliary
     /* 658053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658056 */     // MIs[0] Operand 8
     /* 658056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658066 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 658069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658073 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658082 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658094 */     GIR_RootConstrainSelectedInstOperands,
     /* 658095 */     // GIR_Coverage, 6349,
     /* 658095 */     GIR_EraseRootFromParent_Done,
     /* 658096 */   // Label 8397: @658096
     /* 658096 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(658158), // Rule ID 6357 //
     /* 658101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658112 */     // MIs[0] offset
     /* 658112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658115 */     // MIs[0] auxiliary
     /* 658115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658118 */     // MIs[0] Operand 8
     /* 658118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658128 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 658131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658133 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658135 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658144 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658156 */     GIR_RootConstrainSelectedInstOperands,
     /* 658157 */     // GIR_Coverage, 6357,
     /* 658157 */     GIR_EraseRootFromParent_Done,
     /* 658158 */   // Label 8398: @658158
     /* 658158 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(658254), // Rule ID 6275 //
     /* 658163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658166 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658168 */     // MIs[0] offset
     /* 658168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658171 */     // MIs[0] auxiliary
     /* 658171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658174 */     // MIs[0] Operand 8
     /* 658174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658184 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658207 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 658228 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658240 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658252 */     GIR_RootConstrainSelectedInstOperands,
     /* 658253 */     // GIR_Coverage, 6275,
     /* 658253 */     GIR_EraseRootFromParent_Done,
     /* 658254 */   // Label 8399: @658254
     /* 658254 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(658350), // Rule ID 6283 //
     /* 658259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658262 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658264 */     // MIs[0] offset
     /* 658264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658267 */     // MIs[0] auxiliary
     /* 658267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658270 */     // MIs[0] Operand 8
     /* 658270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658280 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658296 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658303 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 658324 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658336 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658348 */     GIR_RootConstrainSelectedInstOperands,
     /* 658349 */     // GIR_Coverage, 6283,
     /* 658349 */     GIR_EraseRootFromParent_Done,
     /* 658350 */   // Label 8400: @658350
     /* 658350 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(658446), // Rule ID 6355 //
     /* 658355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658358 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658360 */     // MIs[0] offset
     /* 658360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658363 */     // MIs[0] auxiliary
     /* 658363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658366 */     // MIs[0] Operand 8
     /* 658366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658376 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658392 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658399 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 658420 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658432 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658444 */     GIR_RootConstrainSelectedInstOperands,
     /* 658445 */     // GIR_Coverage, 6355,
     /* 658445 */     GIR_EraseRootFromParent_Done,
     /* 658446 */   // Label 8401: @658446
     /* 658446 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(658542), // Rule ID 6363 //
     /* 658451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658454 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658456 */     // MIs[0] offset
     /* 658456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658459 */     // MIs[0] auxiliary
     /* 658459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658462 */     // MIs[0] Operand 8
     /* 658462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658472 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658488 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658495 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 658516 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658528 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658540 */     GIR_RootConstrainSelectedInstOperands,
     /* 658541 */     // GIR_Coverage, 6363,
     /* 658541 */     GIR_EraseRootFromParent_Done,
     /* 658542 */   // Label 8402: @658542
     /* 658542 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(658642), // Rule ID 6271 //
     /* 658547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658554 */     // MIs[0] offset
     /* 658554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658557 */     // MIs[0] auxiliary
     /* 658557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658560 */     // MIs[0] Operand 8
     /* 658560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658570 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658586 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658593 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 658614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658616 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658628 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658640 */     GIR_RootConstrainSelectedInstOperands,
     /* 658641 */     // GIR_Coverage, 6271,
     /* 658641 */     GIR_EraseRootFromParent_Done,
     /* 658642 */   // Label 8403: @658642
     /* 658642 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(658742), // Rule ID 6279 //
     /* 658647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658654 */     // MIs[0] offset
     /* 658654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658657 */     // MIs[0] auxiliary
     /* 658657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658660 */     // MIs[0] Operand 8
     /* 658660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658670 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658686 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658693 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 658714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658728 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658740 */     GIR_RootConstrainSelectedInstOperands,
     /* 658741 */     // GIR_Coverage, 6279,
     /* 658741 */     GIR_EraseRootFromParent_Done,
     /* 658742 */   // Label 8404: @658742
     /* 658742 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(658842), // Rule ID 6351 //
     /* 658747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658754 */     // MIs[0] offset
     /* 658754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658757 */     // MIs[0] auxiliary
     /* 658757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658760 */     // MIs[0] Operand 8
     /* 658760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658770 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658786 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658793 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 658814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658816 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658828 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658840 */     GIR_RootConstrainSelectedInstOperands,
     /* 658841 */     // GIR_Coverage, 6351,
     /* 658841 */     GIR_EraseRootFromParent_Done,
     /* 658842 */   // Label 8405: @658842
     /* 658842 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(658942), // Rule ID 6359 //
     /* 658847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658854 */     // MIs[0] offset
     /* 658854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658857 */     // MIs[0] auxiliary
     /* 658857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658860 */     // MIs[0] Operand 8
     /* 658860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658870 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9786:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658886 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658893 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 658914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658916 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658928 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658940 */     GIR_RootConstrainSelectedInstOperands,
     /* 658941 */     // GIR_Coverage, 6359,
     /* 658941 */     GIR_EraseRootFromParent_Done,
     /* 658942 */   // Label 8406: @658942
     /* 658942 */   GIM_Reject,
     /* 658943 */ // Label 8374: @658943
     /* 658943 */ GIM_Reject,
     /* 658944 */ // Label 8356: @658944
     /* 658944 */ GIM_Reject,
     /* 658945 */ // Label 116: @658945
     /* 658945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8409*/ GIMT_Encode4(661328),
     /* 658956 */ /*GILLT_s32*//*Label 8407*/ GIMT_Encode4(658964),
     /* 658960 */ /*GILLT_s64*//*Label 8408*/ GIMT_Encode4(660146),
     /* 658964 */ // Label 8407: @658964
     /* 658964 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(660145),
     /* 658969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 658972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 658975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 658978 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 658981 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 658984 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(659052), // Rule ID 5992 //
     /* 658989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 658992 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659002 */     // MIs[0] offset
     /* 659002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659005 */     // MIs[0] auxiliary
     /* 659005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659008 */     // MIs[0] Operand 8
     /* 659008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659026 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 659029 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659038 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659050 */     GIR_RootConstrainSelectedInstOperands,
     /* 659051 */     // GIR_Coverage, 5992,
     /* 659051 */     GIR_EraseRootFromParent_Done,
     /* 659052 */   // Label 8411: @659052
     /* 659052 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(659117), // Rule ID 6000 //
     /* 659057 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659067 */     // MIs[0] offset
     /* 659067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659070 */     // MIs[0] auxiliary
     /* 659070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659073 */     // MIs[0] Operand 8
     /* 659073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659091 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 659094 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659103 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659115 */     GIR_RootConstrainSelectedInstOperands,
     /* 659116 */     // GIR_Coverage, 6000,
     /* 659116 */     GIR_EraseRootFromParent_Done,
     /* 659117 */   // Label 8412: @659117
     /* 659117 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(659189), // Rule ID 5988 //
     /* 659122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659137 */     // MIs[0] offset
     /* 659137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659140 */     // MIs[0] auxiliary
     /* 659140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659143 */     // MIs[0] Operand 8
     /* 659143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659161 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 659164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659166 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659175 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659187 */     GIR_RootConstrainSelectedInstOperands,
     /* 659188 */     // GIR_Coverage, 5988,
     /* 659188 */     GIR_EraseRootFromParent_Done,
     /* 659189 */   // Label 8413: @659189
     /* 659189 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(659258), // Rule ID 5996 //
     /* 659194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659206 */     // MIs[0] offset
     /* 659206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659209 */     // MIs[0] auxiliary
     /* 659209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659212 */     // MIs[0] Operand 8
     /* 659212 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659230 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 659233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659235 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659244 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659256 */     GIR_RootConstrainSelectedInstOperands,
     /* 659257 */     // GIR_Coverage, 5996,
     /* 659257 */     GIR_EraseRootFromParent_Done,
     /* 659258 */   // Label 8414: @659258
     /* 659258 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(659324), // Rule ID 5994 //
     /* 659263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659266 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659272 */     // MIs[0] offset
     /* 659272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659275 */     // MIs[0] auxiliary
     /* 659275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659278 */     // MIs[0] Operand 8
     /* 659278 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659296 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN),
     /* 659299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659301 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659310 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659322 */     GIR_RootConstrainSelectedInstOperands,
     /* 659323 */     // GIR_Coverage, 5994,
     /* 659323 */     GIR_EraseRootFromParent_Done,
     /* 659324 */   // Label 8415: @659324
     /* 659324 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(659387), // Rule ID 6002 //
     /* 659329 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659335 */     // MIs[0] offset
     /* 659335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659338 */     // MIs[0] auxiliary
     /* 659338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659341 */     // MIs[0] Operand 8
     /* 659341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659359 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN),
     /* 659362 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659364 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659373 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659385 */     GIR_RootConstrainSelectedInstOperands,
     /* 659386 */     // GIR_Coverage, 6002,
     /* 659386 */     GIR_EraseRootFromParent_Done,
     /* 659387 */   // Label 8416: @659387
     /* 659387 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(659457), // Rule ID 5990 //
     /* 659392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659403 */     // MIs[0] offset
     /* 659403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659406 */     // MIs[0] auxiliary
     /* 659406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659409 */     // MIs[0] Operand 8
     /* 659409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659427 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN_RTN),
     /* 659430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659432 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659434 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659443 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659455 */     GIR_RootConstrainSelectedInstOperands,
     /* 659456 */     // GIR_Coverage, 5990,
     /* 659456 */     GIR_EraseRootFromParent_Done,
     /* 659457 */   // Label 8417: @659457
     /* 659457 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(659524), // Rule ID 5998 //
     /* 659462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659470 */     // MIs[0] offset
     /* 659470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659473 */     // MIs[0] auxiliary
     /* 659473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659476 */     // MIs[0] Operand 8
     /* 659476 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659494 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN),
     /* 659497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659499 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659501 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659510 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659522 */     GIR_RootConstrainSelectedInstOperands,
     /* 659523 */     // GIR_Coverage, 5998,
     /* 659523 */     GIR_EraseRootFromParent_Done,
     /* 659524 */   // Label 8418: @659524
     /* 659524 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(659582), // Rule ID 5993 //
     /* 659529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659532 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659538 */     // MIs[0] offset
     /* 659538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659541 */     // MIs[0] auxiliary
     /* 659541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659544 */     // MIs[0] Operand 8
     /* 659544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659554 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN),
     /* 659557 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659559 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659568 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659580 */     GIR_RootConstrainSelectedInstOperands,
     /* 659581 */     // GIR_Coverage, 5993,
     /* 659581 */     GIR_EraseRootFromParent_Done,
     /* 659582 */   // Label 8419: @659582
     /* 659582 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(659637), // Rule ID 6001 //
     /* 659587 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659593 */     // MIs[0] offset
     /* 659593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659596 */     // MIs[0] auxiliary
     /* 659596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659599 */     // MIs[0] Operand 8
     /* 659599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659609 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN),
     /* 659612 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659614 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659623 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659635 */     GIR_RootConstrainSelectedInstOperands,
     /* 659636 */     // GIR_Coverage, 6001,
     /* 659636 */     GIR_EraseRootFromParent_Done,
     /* 659637 */   // Label 8420: @659637
     /* 659637 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(659699), // Rule ID 5989 //
     /* 659642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659653 */     // MIs[0] offset
     /* 659653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659656 */     // MIs[0] auxiliary
     /* 659656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659659 */     // MIs[0] Operand 8
     /* 659659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659669 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN_RTN),
     /* 659672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659674 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659676 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659685 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659697 */     GIR_RootConstrainSelectedInstOperands,
     /* 659698 */     // GIR_Coverage, 5989,
     /* 659698 */     GIR_EraseRootFromParent_Done,
     /* 659699 */   // Label 8421: @659699
     /* 659699 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(659758), // Rule ID 5997 //
     /* 659704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659712 */     // MIs[0] offset
     /* 659712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659715 */     // MIs[0] auxiliary
     /* 659715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659718 */     // MIs[0] Operand 8
     /* 659718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659728 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN),
     /* 659731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659733 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659735 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659744 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659756 */     GIR_RootConstrainSelectedInstOperands,
     /* 659757 */     // GIR_Coverage, 5997,
     /* 659757 */     GIR_EraseRootFromParent_Done,
     /* 659758 */   // Label 8422: @659758
     /* 659758 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(659854), // Rule ID 5995 //
     /* 659763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659766 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659768 */     // MIs[0] offset
     /* 659768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659771 */     // MIs[0] auxiliary
     /* 659771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659774 */     // MIs[0] Operand 8
     /* 659774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659784 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659800 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659807 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN),
     /* 659828 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659840 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659852 */     GIR_RootConstrainSelectedInstOperands,
     /* 659853 */     // GIR_Coverage, 5995,
     /* 659853 */     GIR_EraseRootFromParent_Done,
     /* 659854 */   // Label 8423: @659854
     /* 659854 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(659947), // Rule ID 6003 //
     /* 659859 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659861 */     // MIs[0] offset
     /* 659861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659864 */     // MIs[0] auxiliary
     /* 659864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659867 */     // MIs[0] Operand 8
     /* 659867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659877 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659893 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN),
     /* 659921 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659933 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659945 */     GIR_RootConstrainSelectedInstOperands,
     /* 659946 */     // GIR_Coverage, 6003,
     /* 659946 */     GIR_EraseRootFromParent_Done,
     /* 659947 */   // Label 8424: @659947
     /* 659947 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(660047), // Rule ID 5991 //
     /* 659952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659959 */     // MIs[0] offset
     /* 659959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659962 */     // MIs[0] auxiliary
     /* 659962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659965 */     // MIs[0] Operand 8
     /* 659965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659975 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659991 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659998 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN_RTN),
     /* 660019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660021 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660033 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660045 */     GIR_RootConstrainSelectedInstOperands,
     /* 660046 */     // GIR_Coverage, 5991,
     /* 660046 */     GIR_EraseRootFromParent_Done,
     /* 660047 */   // Label 8425: @660047
     /* 660047 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(660144), // Rule ID 5999 //
     /* 660052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 660056 */     // MIs[0] offset
     /* 660056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660059 */     // MIs[0] auxiliary
     /* 660059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660062 */     // MIs[0] Operand 8
     /* 660062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660072 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660088 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660095 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN),
     /* 660116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660130 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660142 */     GIR_RootConstrainSelectedInstOperands,
     /* 660143 */     // GIR_Coverage, 5999,
     /* 660143 */     GIR_EraseRootFromParent_Done,
     /* 660144 */   // Label 8426: @660144
     /* 660144 */   GIM_Reject,
     /* 660145 */ // Label 8410: @660145
     /* 660145 */ GIM_Reject,
     /* 660146 */ // Label 8408: @660146
     /* 660146 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(661327),
     /* 660151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 660154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 660157 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 660160 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 660163 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 660166 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(660234), // Rule ID 6192 //
     /* 660171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660174 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660184 */     // MIs[0] offset
     /* 660184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660187 */     // MIs[0] auxiliary
     /* 660187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660190 */     // MIs[0] Operand 8
     /* 660190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660208 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 660211 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660220 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660232 */     GIR_RootConstrainSelectedInstOperands,
     /* 660233 */     // GIR_Coverage, 6192,
     /* 660233 */     GIR_EraseRootFromParent_Done,
     /* 660234 */   // Label 8428: @660234
     /* 660234 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(660299), // Rule ID 6200 //
     /* 660239 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660249 */     // MIs[0] offset
     /* 660249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660252 */     // MIs[0] auxiliary
     /* 660252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660255 */     // MIs[0] Operand 8
     /* 660255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660273 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 660276 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660285 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660297 */     GIR_RootConstrainSelectedInstOperands,
     /* 660298 */     // GIR_Coverage, 6200,
     /* 660298 */     GIR_EraseRootFromParent_Done,
     /* 660299 */   // Label 8429: @660299
     /* 660299 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(660371), // Rule ID 6188 //
     /* 660304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660319 */     // MIs[0] offset
     /* 660319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660322 */     // MIs[0] auxiliary
     /* 660322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660325 */     // MIs[0] Operand 8
     /* 660325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660343 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 660346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660348 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660357 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660369 */     GIR_RootConstrainSelectedInstOperands,
     /* 660370 */     // GIR_Coverage, 6188,
     /* 660370 */     GIR_EraseRootFromParent_Done,
     /* 660371 */   // Label 8430: @660371
     /* 660371 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(660440), // Rule ID 6196 //
     /* 660376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660388 */     // MIs[0] offset
     /* 660388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660391 */     // MIs[0] auxiliary
     /* 660391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660394 */     // MIs[0] Operand 8
     /* 660394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660412 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 660415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660417 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660426 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660438 */     GIR_RootConstrainSelectedInstOperands,
     /* 660439 */     // GIR_Coverage, 6196,
     /* 660439 */     GIR_EraseRootFromParent_Done,
     /* 660440 */   // Label 8431: @660440
     /* 660440 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(660506), // Rule ID 6194 //
     /* 660445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660448 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660454 */     // MIs[0] offset
     /* 660454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660457 */     // MIs[0] auxiliary
     /* 660457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660460 */     // MIs[0] Operand 8
     /* 660460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660478 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN),
     /* 660481 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660483 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660492 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660504 */     GIR_RootConstrainSelectedInstOperands,
     /* 660505 */     // GIR_Coverage, 6194,
     /* 660505 */     GIR_EraseRootFromParent_Done,
     /* 660506 */   // Label 8432: @660506
     /* 660506 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(660569), // Rule ID 6202 //
     /* 660511 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660517 */     // MIs[0] offset
     /* 660517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660520 */     // MIs[0] auxiliary
     /* 660520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660523 */     // MIs[0] Operand 8
     /* 660523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660541 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN),
     /* 660544 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660546 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660555 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660567 */     GIR_RootConstrainSelectedInstOperands,
     /* 660568 */     // GIR_Coverage, 6202,
     /* 660568 */     GIR_EraseRootFromParent_Done,
     /* 660569 */   // Label 8433: @660569
     /* 660569 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(660639), // Rule ID 6190 //
     /* 660574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660585 */     // MIs[0] offset
     /* 660585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660588 */     // MIs[0] auxiliary
     /* 660588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660591 */     // MIs[0] Operand 8
     /* 660591 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660609 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN_RTN),
     /* 660612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660614 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660616 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660625 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660637 */     GIR_RootConstrainSelectedInstOperands,
     /* 660638 */     // GIR_Coverage, 6190,
     /* 660638 */     GIR_EraseRootFromParent_Done,
     /* 660639 */   // Label 8434: @660639
     /* 660639 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(660706), // Rule ID 6198 //
     /* 660644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660652 */     // MIs[0] offset
     /* 660652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660655 */     // MIs[0] auxiliary
     /* 660655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660658 */     // MIs[0] Operand 8
     /* 660658 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660676 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN),
     /* 660679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660681 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660683 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660692 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660704 */     GIR_RootConstrainSelectedInstOperands,
     /* 660705 */     // GIR_Coverage, 6198,
     /* 660705 */     GIR_EraseRootFromParent_Done,
     /* 660706 */   // Label 8435: @660706
     /* 660706 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(660764), // Rule ID 6193 //
     /* 660711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660714 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660720 */     // MIs[0] offset
     /* 660720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660723 */     // MIs[0] auxiliary
     /* 660723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660726 */     // MIs[0] Operand 8
     /* 660726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660736 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN),
     /* 660739 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660741 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660750 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660762 */     GIR_RootConstrainSelectedInstOperands,
     /* 660763 */     // GIR_Coverage, 6193,
     /* 660763 */     GIR_EraseRootFromParent_Done,
     /* 660764 */   // Label 8436: @660764
     /* 660764 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(660819), // Rule ID 6201 //
     /* 660769 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660775 */     // MIs[0] offset
     /* 660775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660778 */     // MIs[0] auxiliary
     /* 660778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660781 */     // MIs[0] Operand 8
     /* 660781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660791 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN),
     /* 660794 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660796 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660805 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660817 */     GIR_RootConstrainSelectedInstOperands,
     /* 660818 */     // GIR_Coverage, 6201,
     /* 660818 */     GIR_EraseRootFromParent_Done,
     /* 660819 */   // Label 8437: @660819
     /* 660819 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(660881), // Rule ID 6189 //
     /* 660824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660835 */     // MIs[0] offset
     /* 660835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660838 */     // MIs[0] auxiliary
     /* 660838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660841 */     // MIs[0] Operand 8
     /* 660841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660851 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN_RTN),
     /* 660854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660856 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660858 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660867 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660879 */     GIR_RootConstrainSelectedInstOperands,
     /* 660880 */     // GIR_Coverage, 6189,
     /* 660880 */     GIR_EraseRootFromParent_Done,
     /* 660881 */   // Label 8438: @660881
     /* 660881 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(660940), // Rule ID 6197 //
     /* 660886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660894 */     // MIs[0] offset
     /* 660894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660897 */     // MIs[0] auxiliary
     /* 660897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660900 */     // MIs[0] Operand 8
     /* 660900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660910 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN),
     /* 660913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660915 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660917 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660926 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660938 */     GIR_RootConstrainSelectedInstOperands,
     /* 660939 */     // GIR_Coverage, 6197,
     /* 660939 */     GIR_EraseRootFromParent_Done,
     /* 660940 */   // Label 8439: @660940
     /* 660940 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(661036), // Rule ID 6195 //
     /* 660945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660948 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660950 */     // MIs[0] offset
     /* 660950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660953 */     // MIs[0] auxiliary
     /* 660953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660956 */     // MIs[0] Operand 8
     /* 660956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660966 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660982 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660989 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN),
     /* 661010 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661022 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661034 */     GIR_RootConstrainSelectedInstOperands,
     /* 661035 */     // GIR_Coverage, 6195,
     /* 661035 */     GIR_EraseRootFromParent_Done,
     /* 661036 */   // Label 8440: @661036
     /* 661036 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(661129), // Rule ID 6203 //
     /* 661041 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661043 */     // MIs[0] offset
     /* 661043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661046 */     // MIs[0] auxiliary
     /* 661046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661049 */     // MIs[0] Operand 8
     /* 661049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661059 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 661062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 661066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 661071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 661075 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 661078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 661082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 661085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 661090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN),
     /* 661103 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661115 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661127 */     GIR_RootConstrainSelectedInstOperands,
     /* 661128 */     // GIR_Coverage, 6203,
     /* 661128 */     GIR_EraseRootFromParent_Done,
     /* 661129 */   // Label 8441: @661129
     /* 661129 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(661229), // Rule ID 6191 //
     /* 661134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661141 */     // MIs[0] offset
     /* 661141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661144 */     // MIs[0] auxiliary
     /* 661144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661147 */     // MIs[0] Operand 8
     /* 661147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661157 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 661160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 661164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 661169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 661173 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 661176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 661180 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 661183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 661188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN_RTN),
     /* 661201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661203 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661215 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661227 */     GIR_RootConstrainSelectedInstOperands,
     /* 661228 */     // GIR_Coverage, 6191,
     /* 661228 */     GIR_EraseRootFromParent_Done,
     /* 661229 */   // Label 8442: @661229
     /* 661229 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(661326), // Rule ID 6199 //
     /* 661234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661238 */     // MIs[0] offset
     /* 661238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661241 */     // MIs[0] auxiliary
     /* 661241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661244 */     // MIs[0] Operand 8
     /* 661244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661254 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 661257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 661261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 661266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 661270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 661273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 661277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 661280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 661285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN),
     /* 661298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661300 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661312 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661324 */     GIR_RootConstrainSelectedInstOperands,
     /* 661325 */     // GIR_Coverage, 6199,
     /* 661325 */     GIR_EraseRootFromParent_Done,
     /* 661326 */   // Label 8443: @661326
     /* 661326 */   GIM_Reject,
     /* 661327 */ // Label 8427: @661327
     /* 661327 */ GIM_Reject,
     /* 661328 */ // Label 8409: @661328
     /* 661328 */ GIM_Reject,
     /* 661329 */ // Label 117: @661329
     /* 661329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8446*/ GIMT_Encode4(663712),
     /* 661340 */ /*GILLT_s32*//*Label 8444*/ GIMT_Encode4(661348),
     /* 661344 */ /*GILLT_s64*//*Label 8445*/ GIMT_Encode4(662530),
     /* 661348 */ // Label 8444: @661348
     /* 661348 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(662529),
     /* 661353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 661356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 661359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 661362 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 661365 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 661368 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(661436), // Rule ID 5960 //
     /* 661373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661376 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661386 */     // MIs[0] offset
     /* 661386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661389 */     // MIs[0] auxiliary
     /* 661389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661392 */     // MIs[0] Operand 8
     /* 661392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661410 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 661413 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661422 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661434 */     GIR_RootConstrainSelectedInstOperands,
     /* 661435 */     // GIR_Coverage, 5960,
     /* 661435 */     GIR_EraseRootFromParent_Done,
     /* 661436 */   // Label 8448: @661436
     /* 661436 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(661501), // Rule ID 5968 //
     /* 661441 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661451 */     // MIs[0] offset
     /* 661451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661454 */     // MIs[0] auxiliary
     /* 661454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661457 */     // MIs[0] Operand 8
     /* 661457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661475 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 661478 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661487 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661499 */     GIR_RootConstrainSelectedInstOperands,
     /* 661500 */     // GIR_Coverage, 5968,
     /* 661500 */     GIR_EraseRootFromParent_Done,
     /* 661501 */   // Label 8449: @661501
     /* 661501 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(661573), // Rule ID 5956 //
     /* 661506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661521 */     // MIs[0] offset
     /* 661521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661524 */     // MIs[0] auxiliary
     /* 661524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661527 */     // MIs[0] Operand 8
     /* 661527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661545 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 661548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661550 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661559 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661571 */     GIR_RootConstrainSelectedInstOperands,
     /* 661572 */     // GIR_Coverage, 5956,
     /* 661572 */     GIR_EraseRootFromParent_Done,
     /* 661573 */   // Label 8450: @661573
     /* 661573 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(661642), // Rule ID 5964 //
     /* 661578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661590 */     // MIs[0] offset
     /* 661590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661593 */     // MIs[0] auxiliary
     /* 661593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661596 */     // MIs[0] Operand 8
     /* 661596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661614 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 661617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661619 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661628 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661640 */     GIR_RootConstrainSelectedInstOperands,
     /* 661641 */     // GIR_Coverage, 5964,
     /* 661641 */     GIR_EraseRootFromParent_Done,
     /* 661642 */   // Label 8451: @661642
     /* 661642 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(661708), // Rule ID 5962 //
     /* 661647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661650 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661656 */     // MIs[0] offset
     /* 661656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661659 */     // MIs[0] auxiliary
     /* 661659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661662 */     // MIs[0] Operand 8
     /* 661662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661680 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN),
     /* 661683 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661685 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661694 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661706 */     GIR_RootConstrainSelectedInstOperands,
     /* 661707 */     // GIR_Coverage, 5962,
     /* 661707 */     GIR_EraseRootFromParent_Done,
     /* 661708 */   // Label 8452: @661708
     /* 661708 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(661771), // Rule ID 5970 //
     /* 661713 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661719 */     // MIs[0] offset
     /* 661719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661722 */     // MIs[0] auxiliary
     /* 661722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661725 */     // MIs[0] Operand 8
     /* 661725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661743 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN),
     /* 661746 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661748 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661757 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661769 */     GIR_RootConstrainSelectedInstOperands,
     /* 661770 */     // GIR_Coverage, 5970,
     /* 661770 */     GIR_EraseRootFromParent_Done,
     /* 661771 */   // Label 8453: @661771
     /* 661771 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(661841), // Rule ID 5958 //
     /* 661776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661787 */     // MIs[0] offset
     /* 661787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661790 */     // MIs[0] auxiliary
     /* 661790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661793 */     // MIs[0] Operand 8
     /* 661793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661811 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN_RTN),
     /* 661814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661816 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661818 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661827 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661839 */     GIR_RootConstrainSelectedInstOperands,
     /* 661840 */     // GIR_Coverage, 5958,
     /* 661840 */     GIR_EraseRootFromParent_Done,
     /* 661841 */   // Label 8454: @661841
     /* 661841 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(661908), // Rule ID 5966 //
     /* 661846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661854 */     // MIs[0] offset
     /* 661854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661857 */     // MIs[0] auxiliary
     /* 661857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661860 */     // MIs[0] Operand 8
     /* 661860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661878 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN),
     /* 661881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661883 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661885 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661894 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661906 */     GIR_RootConstrainSelectedInstOperands,
     /* 661907 */     // GIR_Coverage, 5966,
     /* 661907 */     GIR_EraseRootFromParent_Done,
     /* 661908 */   // Label 8455: @661908
     /* 661908 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(661966), // Rule ID 5961 //
     /* 661913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661916 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661922 */     // MIs[0] offset
     /* 661922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661925 */     // MIs[0] auxiliary
     /* 661925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661928 */     // MIs[0] Operand 8
     /* 661928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661938 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN),
     /* 661941 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661943 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661952 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661964 */     GIR_RootConstrainSelectedInstOperands,
     /* 661965 */     // GIR_Coverage, 5961,
     /* 661965 */     GIR_EraseRootFromParent_Done,
     /* 661966 */   // Label 8456: @661966
     /* 661966 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(662021), // Rule ID 5969 //
     /* 661971 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661977 */     // MIs[0] offset
     /* 661977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661980 */     // MIs[0] auxiliary
     /* 661980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661983 */     // MIs[0] Operand 8
     /* 661983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661993 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN),
     /* 661996 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661998 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662007 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662019 */     GIR_RootConstrainSelectedInstOperands,
     /* 662020 */     // GIR_Coverage, 5969,
     /* 662020 */     GIR_EraseRootFromParent_Done,
     /* 662021 */   // Label 8457: @662021
     /* 662021 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(662083), // Rule ID 5957 //
     /* 662026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662037 */     // MIs[0] offset
     /* 662037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662040 */     // MIs[0] auxiliary
     /* 662040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662043 */     // MIs[0] Operand 8
     /* 662043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662053 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN_RTN),
     /* 662056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662058 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662060 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662069 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662081 */     GIR_RootConstrainSelectedInstOperands,
     /* 662082 */     // GIR_Coverage, 5957,
     /* 662082 */     GIR_EraseRootFromParent_Done,
     /* 662083 */   // Label 8458: @662083
     /* 662083 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(662142), // Rule ID 5965 //
     /* 662088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662096 */     // MIs[0] offset
     /* 662096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662099 */     // MIs[0] auxiliary
     /* 662099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662102 */     // MIs[0] Operand 8
     /* 662102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662112 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN),
     /* 662115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662117 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662119 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662128 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662140 */     GIR_RootConstrainSelectedInstOperands,
     /* 662141 */     // GIR_Coverage, 5965,
     /* 662141 */     GIR_EraseRootFromParent_Done,
     /* 662142 */   // Label 8459: @662142
     /* 662142 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(662238), // Rule ID 5963 //
     /* 662147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662150 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662152 */     // MIs[0] offset
     /* 662152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662155 */     // MIs[0] auxiliary
     /* 662155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662158 */     // MIs[0] Operand 8
     /* 662158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662168 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662184 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662191 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN),
     /* 662212 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662224 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662236 */     GIR_RootConstrainSelectedInstOperands,
     /* 662237 */     // GIR_Coverage, 5963,
     /* 662237 */     GIR_EraseRootFromParent_Done,
     /* 662238 */   // Label 8460: @662238
     /* 662238 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(662331), // Rule ID 5971 //
     /* 662243 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662245 */     // MIs[0] offset
     /* 662245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662248 */     // MIs[0] auxiliary
     /* 662248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662251 */     // MIs[0] Operand 8
     /* 662251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662261 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662284 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN),
     /* 662305 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662317 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662329 */     GIR_RootConstrainSelectedInstOperands,
     /* 662330 */     // GIR_Coverage, 5971,
     /* 662330 */     GIR_EraseRootFromParent_Done,
     /* 662331 */   // Label 8461: @662331
     /* 662331 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(662431), // Rule ID 5959 //
     /* 662336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662343 */     // MIs[0] offset
     /* 662343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662346 */     // MIs[0] auxiliary
     /* 662346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662349 */     // MIs[0] Operand 8
     /* 662349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662359 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662375 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662382 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN_RTN),
     /* 662403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662405 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662417 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662429 */     GIR_RootConstrainSelectedInstOperands,
     /* 662430 */     // GIR_Coverage, 5959,
     /* 662430 */     GIR_EraseRootFromParent_Done,
     /* 662431 */   // Label 8462: @662431
     /* 662431 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(662528), // Rule ID 5967 //
     /* 662436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662440 */     // MIs[0] offset
     /* 662440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662443 */     // MIs[0] auxiliary
     /* 662443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662446 */     // MIs[0] Operand 8
     /* 662446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662456 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662472 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662479 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN),
     /* 662500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662514 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662526 */     GIR_RootConstrainSelectedInstOperands,
     /* 662527 */     // GIR_Coverage, 5967,
     /* 662527 */     GIR_EraseRootFromParent_Done,
     /* 662528 */   // Label 8463: @662528
     /* 662528 */   GIM_Reject,
     /* 662529 */ // Label 8447: @662529
     /* 662529 */ GIM_Reject,
     /* 662530 */ // Label 8445: @662530
     /* 662530 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(663711),
     /* 662535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 662538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 662541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 662544 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 662547 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 662550 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(662618), // Rule ID 6160 //
     /* 662555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662558 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662568 */     // MIs[0] offset
     /* 662568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662571 */     // MIs[0] auxiliary
     /* 662571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662574 */     // MIs[0] Operand 8
     /* 662574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662592 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 662595 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662604 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662616 */     GIR_RootConstrainSelectedInstOperands,
     /* 662617 */     // GIR_Coverage, 6160,
     /* 662617 */     GIR_EraseRootFromParent_Done,
     /* 662618 */   // Label 8465: @662618
     /* 662618 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(662683), // Rule ID 6168 //
     /* 662623 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662633 */     // MIs[0] offset
     /* 662633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662636 */     // MIs[0] auxiliary
     /* 662636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662639 */     // MIs[0] Operand 8
     /* 662639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662657 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 662660 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662669 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662681 */     GIR_RootConstrainSelectedInstOperands,
     /* 662682 */     // GIR_Coverage, 6168,
     /* 662682 */     GIR_EraseRootFromParent_Done,
     /* 662683 */   // Label 8466: @662683
     /* 662683 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(662755), // Rule ID 6156 //
     /* 662688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662703 */     // MIs[0] offset
     /* 662703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662706 */     // MIs[0] auxiliary
     /* 662706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662709 */     // MIs[0] Operand 8
     /* 662709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662727 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 662730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662732 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662741 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662753 */     GIR_RootConstrainSelectedInstOperands,
     /* 662754 */     // GIR_Coverage, 6156,
     /* 662754 */     GIR_EraseRootFromParent_Done,
     /* 662755 */   // Label 8467: @662755
     /* 662755 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(662824), // Rule ID 6164 //
     /* 662760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662772 */     // MIs[0] offset
     /* 662772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662775 */     // MIs[0] auxiliary
     /* 662775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662778 */     // MIs[0] Operand 8
     /* 662778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662796 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 662799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662801 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662810 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662822 */     GIR_RootConstrainSelectedInstOperands,
     /* 662823 */     // GIR_Coverage, 6164,
     /* 662823 */     GIR_EraseRootFromParent_Done,
     /* 662824 */   // Label 8468: @662824
     /* 662824 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(662890), // Rule ID 6162 //
     /* 662829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662832 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662838 */     // MIs[0] offset
     /* 662838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662841 */     // MIs[0] auxiliary
     /* 662841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662844 */     // MIs[0] Operand 8
     /* 662844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662862 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN),
     /* 662865 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662867 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662876 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662888 */     GIR_RootConstrainSelectedInstOperands,
     /* 662889 */     // GIR_Coverage, 6162,
     /* 662889 */     GIR_EraseRootFromParent_Done,
     /* 662890 */   // Label 8469: @662890
     /* 662890 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(662953), // Rule ID 6170 //
     /* 662895 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662901 */     // MIs[0] offset
     /* 662901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662904 */     // MIs[0] auxiliary
     /* 662904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662907 */     // MIs[0] Operand 8
     /* 662907 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662925 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN),
     /* 662928 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662930 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662939 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662951 */     GIR_RootConstrainSelectedInstOperands,
     /* 662952 */     // GIR_Coverage, 6170,
     /* 662952 */     GIR_EraseRootFromParent_Done,
     /* 662953 */   // Label 8470: @662953
     /* 662953 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(663023), // Rule ID 6158 //
     /* 662958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662969 */     // MIs[0] offset
     /* 662969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662972 */     // MIs[0] auxiliary
     /* 662972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662975 */     // MIs[0] Operand 8
     /* 662975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662993 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN_RTN),
     /* 662996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662998 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663000 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663009 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663021 */     GIR_RootConstrainSelectedInstOperands,
     /* 663022 */     // GIR_Coverage, 6158,
     /* 663022 */     GIR_EraseRootFromParent_Done,
     /* 663023 */   // Label 8471: @663023
     /* 663023 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(663090), // Rule ID 6166 //
     /* 663028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663036 */     // MIs[0] offset
     /* 663036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663039 */     // MIs[0] auxiliary
     /* 663039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663042 */     // MIs[0] Operand 8
     /* 663042 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663060 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN),
     /* 663063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663065 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663067 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663076 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663088 */     GIR_RootConstrainSelectedInstOperands,
     /* 663089 */     // GIR_Coverage, 6166,
     /* 663089 */     GIR_EraseRootFromParent_Done,
     /* 663090 */   // Label 8472: @663090
     /* 663090 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(663148), // Rule ID 6161 //
     /* 663095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663098 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663104 */     // MIs[0] offset
     /* 663104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663107 */     // MIs[0] auxiliary
     /* 663107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663110 */     // MIs[0] Operand 8
     /* 663110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663120 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN),
     /* 663123 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663125 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663134 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663146 */     GIR_RootConstrainSelectedInstOperands,
     /* 663147 */     // GIR_Coverage, 6161,
     /* 663147 */     GIR_EraseRootFromParent_Done,
     /* 663148 */   // Label 8473: @663148
     /* 663148 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(663203), // Rule ID 6169 //
     /* 663153 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663159 */     // MIs[0] offset
     /* 663159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663162 */     // MIs[0] auxiliary
     /* 663162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663165 */     // MIs[0] Operand 8
     /* 663165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663175 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN),
     /* 663178 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663180 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663189 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663201 */     GIR_RootConstrainSelectedInstOperands,
     /* 663202 */     // GIR_Coverage, 6169,
     /* 663202 */     GIR_EraseRootFromParent_Done,
     /* 663203 */   // Label 8474: @663203
     /* 663203 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(663265), // Rule ID 6157 //
     /* 663208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663219 */     // MIs[0] offset
     /* 663219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663222 */     // MIs[0] auxiliary
     /* 663222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663225 */     // MIs[0] Operand 8
     /* 663225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663235 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN_RTN),
     /* 663238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663240 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663242 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663251 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663263 */     GIR_RootConstrainSelectedInstOperands,
     /* 663264 */     // GIR_Coverage, 6157,
     /* 663264 */     GIR_EraseRootFromParent_Done,
     /* 663265 */   // Label 8475: @663265
     /* 663265 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(663324), // Rule ID 6165 //
     /* 663270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663278 */     // MIs[0] offset
     /* 663278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663281 */     // MIs[0] auxiliary
     /* 663281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663284 */     // MIs[0] Operand 8
     /* 663284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663294 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN),
     /* 663297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663299 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663301 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663310 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663322 */     GIR_RootConstrainSelectedInstOperands,
     /* 663323 */     // GIR_Coverage, 6165,
     /* 663323 */     GIR_EraseRootFromParent_Done,
     /* 663324 */   // Label 8476: @663324
     /* 663324 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(663420), // Rule ID 6163 //
     /* 663329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663332 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663334 */     // MIs[0] offset
     /* 663334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663337 */     // MIs[0] auxiliary
     /* 663337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663340 */     // MIs[0] Operand 8
     /* 663340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663350 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663366 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663369 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663373 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN),
     /* 663394 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663406 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663418 */     GIR_RootConstrainSelectedInstOperands,
     /* 663419 */     // GIR_Coverage, 6163,
     /* 663419 */     GIR_EraseRootFromParent_Done,
     /* 663420 */   // Label 8477: @663420
     /* 663420 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(663513), // Rule ID 6171 //
     /* 663425 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663427 */     // MIs[0] offset
     /* 663427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663430 */     // MIs[0] auxiliary
     /* 663430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663433 */     // MIs[0] Operand 8
     /* 663433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663443 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663459 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN),
     /* 663487 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663499 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663511 */     GIR_RootConstrainSelectedInstOperands,
     /* 663512 */     // GIR_Coverage, 6171,
     /* 663512 */     GIR_EraseRootFromParent_Done,
     /* 663513 */   // Label 8478: @663513
     /* 663513 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(663613), // Rule ID 6159 //
     /* 663518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663525 */     // MIs[0] offset
     /* 663525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663528 */     // MIs[0] auxiliary
     /* 663528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663531 */     // MIs[0] Operand 8
     /* 663531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663541 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663557 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663564 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN_RTN),
     /* 663585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663587 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663599 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663611 */     GIR_RootConstrainSelectedInstOperands,
     /* 663612 */     // GIR_Coverage, 6159,
     /* 663612 */     GIR_EraseRootFromParent_Done,
     /* 663613 */   // Label 8479: @663613
     /* 663613 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(663710), // Rule ID 6167 //
     /* 663618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663622 */     // MIs[0] offset
     /* 663622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663625 */     // MIs[0] auxiliary
     /* 663625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663628 */     // MIs[0] Operand 8
     /* 663628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663638 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663654 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663661 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN),
     /* 663682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663684 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663708 */     GIR_RootConstrainSelectedInstOperands,
     /* 663709 */     // GIR_Coverage, 6167,
     /* 663709 */     GIR_EraseRootFromParent_Done,
     /* 663710 */   // Label 8480: @663710
     /* 663710 */   GIM_Reject,
     /* 663711 */ // Label 8464: @663711
     /* 663711 */ GIM_Reject,
     /* 663712 */ // Label 8446: @663712
     /* 663712 */ GIM_Reject,
     /* 663713 */ // Label 118: @663713
     /* 663713 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8483*/ GIMT_Encode4(666096),
     /* 663724 */ /*GILLT_s32*//*Label 8481*/ GIMT_Encode4(663732),
     /* 663728 */ /*GILLT_s64*//*Label 8482*/ GIMT_Encode4(664914),
     /* 663732 */ // Label 8481: @663732
     /* 663732 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(664913),
     /* 663737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 663740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 663743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 663746 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 663749 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 663752 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(663820), // Rule ID 5912 //
     /* 663757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663760 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663770 */     // MIs[0] offset
     /* 663770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663773 */     // MIs[0] auxiliary
     /* 663773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663776 */     // MIs[0] Operand 8
     /* 663776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663794 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 663797 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663806 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663818 */     GIR_RootConstrainSelectedInstOperands,
     /* 663819 */     // GIR_Coverage, 5912,
     /* 663819 */     GIR_EraseRootFromParent_Done,
     /* 663820 */   // Label 8485: @663820
     /* 663820 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(663885), // Rule ID 5920 //
     /* 663825 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663835 */     // MIs[0] offset
     /* 663835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663838 */     // MIs[0] auxiliary
     /* 663838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663841 */     // MIs[0] Operand 8
     /* 663841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663859 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 663862 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663871 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663883 */     GIR_RootConstrainSelectedInstOperands,
     /* 663884 */     // GIR_Coverage, 5920,
     /* 663884 */     GIR_EraseRootFromParent_Done,
     /* 663885 */   // Label 8486: @663885
     /* 663885 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(663957), // Rule ID 5908 //
     /* 663890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663905 */     // MIs[0] offset
     /* 663905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663908 */     // MIs[0] auxiliary
     /* 663908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663911 */     // MIs[0] Operand 8
     /* 663911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663929 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 663932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663934 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663943 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663955 */     GIR_RootConstrainSelectedInstOperands,
     /* 663956 */     // GIR_Coverage, 5908,
     /* 663956 */     GIR_EraseRootFromParent_Done,
     /* 663957 */   // Label 8487: @663957
     /* 663957 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(664026), // Rule ID 5916 //
     /* 663962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663974 */     // MIs[0] offset
     /* 663974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663977 */     // MIs[0] auxiliary
     /* 663977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663980 */     // MIs[0] Operand 8
     /* 663980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663998 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 664001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664003 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664012 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664024 */     GIR_RootConstrainSelectedInstOperands,
     /* 664025 */     // GIR_Coverage, 5916,
     /* 664025 */     GIR_EraseRootFromParent_Done,
     /* 664026 */   // Label 8488: @664026
     /* 664026 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(664092), // Rule ID 5914 //
     /* 664031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664034 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664040 */     // MIs[0] offset
     /* 664040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664043 */     // MIs[0] auxiliary
     /* 664043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664046 */     // MIs[0] Operand 8
     /* 664046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664064 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN),
     /* 664067 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664069 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664078 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664090 */     GIR_RootConstrainSelectedInstOperands,
     /* 664091 */     // GIR_Coverage, 5914,
     /* 664091 */     GIR_EraseRootFromParent_Done,
     /* 664092 */   // Label 8489: @664092
     /* 664092 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(664155), // Rule ID 5922 //
     /* 664097 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664103 */     // MIs[0] offset
     /* 664103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664106 */     // MIs[0] auxiliary
     /* 664106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664109 */     // MIs[0] Operand 8
     /* 664109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664127 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN),
     /* 664130 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664132 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664141 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664153 */     GIR_RootConstrainSelectedInstOperands,
     /* 664154 */     // GIR_Coverage, 5922,
     /* 664154 */     GIR_EraseRootFromParent_Done,
     /* 664155 */   // Label 8490: @664155
     /* 664155 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(664225), // Rule ID 5910 //
     /* 664160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664171 */     // MIs[0] offset
     /* 664171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664174 */     // MIs[0] auxiliary
     /* 664174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664177 */     // MIs[0] Operand 8
     /* 664177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664195 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN_RTN),
     /* 664198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664200 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664202 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664211 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664223 */     GIR_RootConstrainSelectedInstOperands,
     /* 664224 */     // GIR_Coverage, 5910,
     /* 664224 */     GIR_EraseRootFromParent_Done,
     /* 664225 */   // Label 8491: @664225
     /* 664225 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(664292), // Rule ID 5918 //
     /* 664230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664238 */     // MIs[0] offset
     /* 664238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664241 */     // MIs[0] auxiliary
     /* 664241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664244 */     // MIs[0] Operand 8
     /* 664244 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664262 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN),
     /* 664265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664267 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664269 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664278 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664290 */     GIR_RootConstrainSelectedInstOperands,
     /* 664291 */     // GIR_Coverage, 5918,
     /* 664291 */     GIR_EraseRootFromParent_Done,
     /* 664292 */   // Label 8492: @664292
     /* 664292 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(664350), // Rule ID 5913 //
     /* 664297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664300 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664306 */     // MIs[0] offset
     /* 664306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664309 */     // MIs[0] auxiliary
     /* 664309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664312 */     // MIs[0] Operand 8
     /* 664312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664322 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN),
     /* 664325 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664327 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664336 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664348 */     GIR_RootConstrainSelectedInstOperands,
     /* 664349 */     // GIR_Coverage, 5913,
     /* 664349 */     GIR_EraseRootFromParent_Done,
     /* 664350 */   // Label 8493: @664350
     /* 664350 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(664405), // Rule ID 5921 //
     /* 664355 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664361 */     // MIs[0] offset
     /* 664361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664364 */     // MIs[0] auxiliary
     /* 664364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664367 */     // MIs[0] Operand 8
     /* 664367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664377 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN),
     /* 664380 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664382 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664391 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664403 */     GIR_RootConstrainSelectedInstOperands,
     /* 664404 */     // GIR_Coverage, 5921,
     /* 664404 */     GIR_EraseRootFromParent_Done,
     /* 664405 */   // Label 8494: @664405
     /* 664405 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(664467), // Rule ID 5909 //
     /* 664410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664421 */     // MIs[0] offset
     /* 664421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664424 */     // MIs[0] auxiliary
     /* 664424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664427 */     // MIs[0] Operand 8
     /* 664427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664437 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN_RTN),
     /* 664440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664442 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664444 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664453 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664465 */     GIR_RootConstrainSelectedInstOperands,
     /* 664466 */     // GIR_Coverage, 5909,
     /* 664466 */     GIR_EraseRootFromParent_Done,
     /* 664467 */   // Label 8495: @664467
     /* 664467 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(664526), // Rule ID 5917 //
     /* 664472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664480 */     // MIs[0] offset
     /* 664480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664483 */     // MIs[0] auxiliary
     /* 664483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664486 */     // MIs[0] Operand 8
     /* 664486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664496 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN),
     /* 664499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664501 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664503 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664512 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664524 */     GIR_RootConstrainSelectedInstOperands,
     /* 664525 */     // GIR_Coverage, 5917,
     /* 664525 */     GIR_EraseRootFromParent_Done,
     /* 664526 */   // Label 8496: @664526
     /* 664526 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(664622), // Rule ID 5915 //
     /* 664531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664534 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664536 */     // MIs[0] offset
     /* 664536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664539 */     // MIs[0] auxiliary
     /* 664539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664542 */     // MIs[0] Operand 8
     /* 664542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664552 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664568 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664575 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN),
     /* 664596 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664608 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664620 */     GIR_RootConstrainSelectedInstOperands,
     /* 664621 */     // GIR_Coverage, 5915,
     /* 664621 */     GIR_EraseRootFromParent_Done,
     /* 664622 */   // Label 8497: @664622
     /* 664622 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(664715), // Rule ID 5923 //
     /* 664627 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664629 */     // MIs[0] offset
     /* 664629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664632 */     // MIs[0] auxiliary
     /* 664632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664635 */     // MIs[0] Operand 8
     /* 664635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664645 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664661 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664668 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN),
     /* 664689 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664701 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664713 */     GIR_RootConstrainSelectedInstOperands,
     /* 664714 */     // GIR_Coverage, 5923,
     /* 664714 */     GIR_EraseRootFromParent_Done,
     /* 664715 */   // Label 8498: @664715
     /* 664715 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(664815), // Rule ID 5911 //
     /* 664720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664727 */     // MIs[0] offset
     /* 664727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664730 */     // MIs[0] auxiliary
     /* 664730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664733 */     // MIs[0] Operand 8
     /* 664733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664743 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664766 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN_RTN),
     /* 664787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664789 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664801 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664813 */     GIR_RootConstrainSelectedInstOperands,
     /* 664814 */     // GIR_Coverage, 5911,
     /* 664814 */     GIR_EraseRootFromParent_Done,
     /* 664815 */   // Label 8499: @664815
     /* 664815 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(664912), // Rule ID 5919 //
     /* 664820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664824 */     // MIs[0] offset
     /* 664824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664827 */     // MIs[0] auxiliary
     /* 664827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664830 */     // MIs[0] Operand 8
     /* 664830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664840 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664856 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664863 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN),
     /* 664884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664886 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664898 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664910 */     GIR_RootConstrainSelectedInstOperands,
     /* 664911 */     // GIR_Coverage, 5919,
     /* 664911 */     GIR_EraseRootFromParent_Done,
     /* 664912 */   // Label 8500: @664912
     /* 664912 */   GIM_Reject,
     /* 664913 */ // Label 8484: @664913
     /* 664913 */ GIM_Reject,
     /* 664914 */ // Label 8482: @664914
     /* 664914 */ GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(666095),
     /* 664919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 664922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 664925 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 664928 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 664931 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 664934 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(665002), // Rule ID 6112 //
     /* 664939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664942 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664952 */     // MIs[0] offset
     /* 664952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664955 */     // MIs[0] auxiliary
     /* 664955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664958 */     // MIs[0] Operand 8
     /* 664958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664976 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 664979 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664988 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665000 */     GIR_RootConstrainSelectedInstOperands,
     /* 665001 */     // GIR_Coverage, 6112,
     /* 665001 */     GIR_EraseRootFromParent_Done,
     /* 665002 */   // Label 8502: @665002
     /* 665002 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(665067), // Rule ID 6120 //
     /* 665007 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665017 */     // MIs[0] offset
     /* 665017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665020 */     // MIs[0] auxiliary
     /* 665020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665023 */     // MIs[0] Operand 8
     /* 665023 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665041 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 665044 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665053 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665065 */     GIR_RootConstrainSelectedInstOperands,
     /* 665066 */     // GIR_Coverage, 6120,
     /* 665066 */     GIR_EraseRootFromParent_Done,
     /* 665067 */   // Label 8503: @665067
     /* 665067 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(665139), // Rule ID 6108 //
     /* 665072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665087 */     // MIs[0] offset
     /* 665087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665090 */     // MIs[0] auxiliary
     /* 665090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665093 */     // MIs[0] Operand 8
     /* 665093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665111 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 665114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665116 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665125 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665137 */     GIR_RootConstrainSelectedInstOperands,
     /* 665138 */     // GIR_Coverage, 6108,
     /* 665138 */     GIR_EraseRootFromParent_Done,
     /* 665139 */   // Label 8504: @665139
     /* 665139 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(665208), // Rule ID 6116 //
     /* 665144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665156 */     // MIs[0] offset
     /* 665156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665159 */     // MIs[0] auxiliary
     /* 665159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665162 */     // MIs[0] Operand 8
     /* 665162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665180 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 665183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665185 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665194 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665206 */     GIR_RootConstrainSelectedInstOperands,
     /* 665207 */     // GIR_Coverage, 6116,
     /* 665207 */     GIR_EraseRootFromParent_Done,
     /* 665208 */   // Label 8505: @665208
     /* 665208 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(665274), // Rule ID 6114 //
     /* 665213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665216 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665222 */     // MIs[0] offset
     /* 665222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665225 */     // MIs[0] auxiliary
     /* 665225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665228 */     // MIs[0] Operand 8
     /* 665228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665246 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN),
     /* 665249 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665251 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665260 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665272 */     GIR_RootConstrainSelectedInstOperands,
     /* 665273 */     // GIR_Coverage, 6114,
     /* 665273 */     GIR_EraseRootFromParent_Done,
     /* 665274 */   // Label 8506: @665274
     /* 665274 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(665337), // Rule ID 6122 //
     /* 665279 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665285 */     // MIs[0] offset
     /* 665285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665288 */     // MIs[0] auxiliary
     /* 665288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665291 */     // MIs[0] Operand 8
     /* 665291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665309 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN),
     /* 665312 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665314 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665323 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665335 */     GIR_RootConstrainSelectedInstOperands,
     /* 665336 */     // GIR_Coverage, 6122,
     /* 665336 */     GIR_EraseRootFromParent_Done,
     /* 665337 */   // Label 8507: @665337
     /* 665337 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(665407), // Rule ID 6110 //
     /* 665342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665353 */     // MIs[0] offset
     /* 665353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665356 */     // MIs[0] auxiliary
     /* 665356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665359 */     // MIs[0] Operand 8
     /* 665359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665377 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN),
     /* 665380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665382 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665384 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665393 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665395 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665405 */     GIR_RootConstrainSelectedInstOperands,
     /* 665406 */     // GIR_Coverage, 6110,
     /* 665406 */     GIR_EraseRootFromParent_Done,
     /* 665407 */   // Label 8508: @665407
     /* 665407 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(665474), // Rule ID 6118 //
     /* 665412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665420 */     // MIs[0] offset
     /* 665420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665423 */     // MIs[0] auxiliary
     /* 665423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665426 */     // MIs[0] Operand 8
     /* 665426 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665444 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN),
     /* 665447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665449 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665451 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665460 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665472 */     GIR_RootConstrainSelectedInstOperands,
     /* 665473 */     // GIR_Coverage, 6118,
     /* 665473 */     GIR_EraseRootFromParent_Done,
     /* 665474 */   // Label 8509: @665474
     /* 665474 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(665532), // Rule ID 6113 //
     /* 665479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665482 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665488 */     // MIs[0] offset
     /* 665488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665491 */     // MIs[0] auxiliary
     /* 665491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665494 */     // MIs[0] Operand 8
     /* 665494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665504 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN),
     /* 665507 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665509 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665518 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665530 */     GIR_RootConstrainSelectedInstOperands,
     /* 665531 */     // GIR_Coverage, 6113,
     /* 665531 */     GIR_EraseRootFromParent_Done,
     /* 665532 */   // Label 8510: @665532
     /* 665532 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(665587), // Rule ID 6121 //
     /* 665537 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665543 */     // MIs[0] offset
     /* 665543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665546 */     // MIs[0] auxiliary
     /* 665546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665549 */     // MIs[0] Operand 8
     /* 665549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665559 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN),
     /* 665562 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665564 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665573 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665585 */     GIR_RootConstrainSelectedInstOperands,
     /* 665586 */     // GIR_Coverage, 6121,
     /* 665586 */     GIR_EraseRootFromParent_Done,
     /* 665587 */   // Label 8511: @665587
     /* 665587 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(665649), // Rule ID 6109 //
     /* 665592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665603 */     // MIs[0] offset
     /* 665603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665606 */     // MIs[0] auxiliary
     /* 665606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665609 */     // MIs[0] Operand 8
     /* 665609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665619 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN),
     /* 665622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665624 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665626 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665635 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665647 */     GIR_RootConstrainSelectedInstOperands,
     /* 665648 */     // GIR_Coverage, 6109,
     /* 665648 */     GIR_EraseRootFromParent_Done,
     /* 665649 */   // Label 8512: @665649
     /* 665649 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(665708), // Rule ID 6117 //
     /* 665654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665662 */     // MIs[0] offset
     /* 665662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665665 */     // MIs[0] auxiliary
     /* 665665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665668 */     // MIs[0] Operand 8
     /* 665668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665678 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN),
     /* 665681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665683 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665685 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665694 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665706 */     GIR_RootConstrainSelectedInstOperands,
     /* 665707 */     // GIR_Coverage, 6117,
     /* 665707 */     GIR_EraseRootFromParent_Done,
     /* 665708 */   // Label 8513: @665708
     /* 665708 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(665804), // Rule ID 6115 //
     /* 665713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665716 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665718 */     // MIs[0] offset
     /* 665718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665721 */     // MIs[0] auxiliary
     /* 665721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665724 */     // MIs[0] Operand 8
     /* 665724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665734 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665750 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665757 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN),
     /* 665778 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665790 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665802 */     GIR_RootConstrainSelectedInstOperands,
     /* 665803 */     // GIR_Coverage, 6115,
     /* 665803 */     GIR_EraseRootFromParent_Done,
     /* 665804 */   // Label 8514: @665804
     /* 665804 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(665897), // Rule ID 6123 //
     /* 665809 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665811 */     // MIs[0] offset
     /* 665811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665814 */     // MIs[0] auxiliary
     /* 665814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665817 */     // MIs[0] Operand 8
     /* 665817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665827 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665843 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665850 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN),
     /* 665871 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665883 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665895 */     GIR_RootConstrainSelectedInstOperands,
     /* 665896 */     // GIR_Coverage, 6123,
     /* 665896 */     GIR_EraseRootFromParent_Done,
     /* 665897 */   // Label 8515: @665897
     /* 665897 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(665997), // Rule ID 6111 //
     /* 665902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665909 */     // MIs[0] offset
     /* 665909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665912 */     // MIs[0] auxiliary
     /* 665912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665915 */     // MIs[0] Operand 8
     /* 665915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665925 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665941 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665948 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN),
     /* 665969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665971 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665983 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665995 */     GIR_RootConstrainSelectedInstOperands,
     /* 665996 */     // GIR_Coverage, 6111,
     /* 665996 */     GIR_EraseRootFromParent_Done,
     /* 665997 */   // Label 8516: @665997
     /* 665997 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(666094), // Rule ID 6119 //
     /* 666002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 666006 */     // MIs[0] offset
     /* 666006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666009 */     // MIs[0] auxiliary
     /* 666009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666012 */     // MIs[0] Operand 8
     /* 666012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666022 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666038 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 666066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666068 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666092 */     GIR_RootConstrainSelectedInstOperands,
     /* 666093 */     // GIR_Coverage, 6119,
     /* 666093 */     GIR_EraseRootFromParent_Done,
     /* 666094 */   // Label 8517: @666094
     /* 666094 */   GIM_Reject,
     /* 666095 */ // Label 8501: @666095
     /* 666095 */ GIM_Reject,
     /* 666096 */ // Label 8483: @666096
     /* 666096 */ GIM_Reject,
     /* 666097 */ // Label 119: @666097
     /* 666097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8520*/ GIMT_Encode4(668480),
     /* 666108 */ /*GILLT_s32*//*Label 8518*/ GIMT_Encode4(666116),
     /* 666112 */ /*GILLT_s64*//*Label 8519*/ GIMT_Encode4(667298),
     /* 666116 */ // Label 8518: @666116
     /* 666116 */ GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(667297),
     /* 666121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 666124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 666127 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 666130 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 666133 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 666136 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(666204), // Rule ID 5880 //
     /* 666141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666144 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666154 */     // MIs[0] offset
     /* 666154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666157 */     // MIs[0] auxiliary
     /* 666157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666160 */     // MIs[0] Operand 8
     /* 666160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666178 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 666181 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666190 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666202 */     GIR_RootConstrainSelectedInstOperands,
     /* 666203 */     // GIR_Coverage, 5880,
     /* 666203 */     GIR_EraseRootFromParent_Done,
     /* 666204 */   // Label 8522: @666204
     /* 666204 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(666269), // Rule ID 5888 //
     /* 666209 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666219 */     // MIs[0] offset
     /* 666219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666222 */     // MIs[0] auxiliary
     /* 666222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666225 */     // MIs[0] Operand 8
     /* 666225 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666243 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 666246 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666255 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666267 */     GIR_RootConstrainSelectedInstOperands,
     /* 666268 */     // GIR_Coverage, 5888,
     /* 666268 */     GIR_EraseRootFromParent_Done,
     /* 666269 */   // Label 8523: @666269
     /* 666269 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(666341), // Rule ID 5876 //
     /* 666274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666289 */     // MIs[0] offset
     /* 666289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666292 */     // MIs[0] auxiliary
     /* 666292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666295 */     // MIs[0] Operand 8
     /* 666295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666313 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 666316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666318 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666327 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666339 */     GIR_RootConstrainSelectedInstOperands,
     /* 666340 */     // GIR_Coverage, 5876,
     /* 666340 */     GIR_EraseRootFromParent_Done,
     /* 666341 */   // Label 8524: @666341
     /* 666341 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(666410), // Rule ID 5884 //
     /* 666346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666358 */     // MIs[0] offset
     /* 666358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666361 */     // MIs[0] auxiliary
     /* 666361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666364 */     // MIs[0] Operand 8
     /* 666364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666382 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 666385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666387 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666396 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666408 */     GIR_RootConstrainSelectedInstOperands,
     /* 666409 */     // GIR_Coverage, 5884,
     /* 666409 */     GIR_EraseRootFromParent_Done,
     /* 666410 */   // Label 8525: @666410
     /* 666410 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(666476), // Rule ID 5882 //
     /* 666415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666418 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666424 */     // MIs[0] offset
     /* 666424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666427 */     // MIs[0] auxiliary
     /* 666427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666430 */     // MIs[0] Operand 8
     /* 666430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666448 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN),
     /* 666451 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666453 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666462 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666474 */     GIR_RootConstrainSelectedInstOperands,
     /* 666475 */     // GIR_Coverage, 5882,
     /* 666475 */     GIR_EraseRootFromParent_Done,
     /* 666476 */   // Label 8526: @666476
     /* 666476 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(666539), // Rule ID 5890 //
     /* 666481 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666487 */     // MIs[0] offset
     /* 666487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666490 */     // MIs[0] auxiliary
     /* 666490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666493 */     // MIs[0] Operand 8
     /* 666493 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666511 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN),
     /* 666514 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666516 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666525 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666537 */     GIR_RootConstrainSelectedInstOperands,
     /* 666538 */     // GIR_Coverage, 5890,
     /* 666538 */     GIR_EraseRootFromParent_Done,
     /* 666539 */   // Label 8527: @666539
     /* 666539 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(666609), // Rule ID 5878 //
     /* 666544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666555 */     // MIs[0] offset
     /* 666555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666558 */     // MIs[0] auxiliary
     /* 666558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666561 */     // MIs[0] Operand 8
     /* 666561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666579 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN_RTN),
     /* 666582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666586 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666595 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666607 */     GIR_RootConstrainSelectedInstOperands,
     /* 666608 */     // GIR_Coverage, 5878,
     /* 666608 */     GIR_EraseRootFromParent_Done,
     /* 666609 */   // Label 8528: @666609
     /* 666609 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(666676), // Rule ID 5886 //
     /* 666614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666622 */     // MIs[0] offset
     /* 666622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666625 */     // MIs[0] auxiliary
     /* 666625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666628 */     // MIs[0] Operand 8
     /* 666628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666646 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN),
     /* 666649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666651 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666653 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666662 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666674 */     GIR_RootConstrainSelectedInstOperands,
     /* 666675 */     // GIR_Coverage, 5886,
     /* 666675 */     GIR_EraseRootFromParent_Done,
     /* 666676 */   // Label 8529: @666676
     /* 666676 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(666734), // Rule ID 5881 //
     /* 666681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666684 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666690 */     // MIs[0] offset
     /* 666690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666693 */     // MIs[0] auxiliary
     /* 666693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666696 */     // MIs[0] Operand 8
     /* 666696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666706 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN),
     /* 666709 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666711 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666720 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666732 */     GIR_RootConstrainSelectedInstOperands,
     /* 666733 */     // GIR_Coverage, 5881,
     /* 666733 */     GIR_EraseRootFromParent_Done,
     /* 666734 */   // Label 8530: @666734
     /* 666734 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(666789), // Rule ID 5889 //
     /* 666739 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666745 */     // MIs[0] offset
     /* 666745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666748 */     // MIs[0] auxiliary
     /* 666748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666751 */     // MIs[0] Operand 8
     /* 666751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666761 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN),
     /* 666764 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666766 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666775 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666787 */     GIR_RootConstrainSelectedInstOperands,
     /* 666788 */     // GIR_Coverage, 5889,
     /* 666788 */     GIR_EraseRootFromParent_Done,
     /* 666789 */   // Label 8531: @666789
     /* 666789 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(666851), // Rule ID 5877 //
     /* 666794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666805 */     // MIs[0] offset
     /* 666805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666808 */     // MIs[0] auxiliary
     /* 666808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666811 */     // MIs[0] Operand 8
     /* 666811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666821 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN_RTN),
     /* 666824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666826 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666828 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666837 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666849 */     GIR_RootConstrainSelectedInstOperands,
     /* 666850 */     // GIR_Coverage, 5877,
     /* 666850 */     GIR_EraseRootFromParent_Done,
     /* 666851 */   // Label 8532: @666851
     /* 666851 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(666910), // Rule ID 5885 //
     /* 666856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666864 */     // MIs[0] offset
     /* 666864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666867 */     // MIs[0] auxiliary
     /* 666867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666870 */     // MIs[0] Operand 8
     /* 666870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666880 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN),
     /* 666883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666885 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666887 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666896 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666908 */     GIR_RootConstrainSelectedInstOperands,
     /* 666909 */     // GIR_Coverage, 5885,
     /* 666909 */     GIR_EraseRootFromParent_Done,
     /* 666910 */   // Label 8533: @666910
     /* 666910 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(667006), // Rule ID 5883 //
     /* 666915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666918 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666920 */     // MIs[0] offset
     /* 666920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666923 */     // MIs[0] auxiliary
     /* 666923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666926 */     // MIs[0] Operand 8
     /* 666926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666936 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666952 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666959 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN),
     /* 666980 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666992 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667004 */     GIR_RootConstrainSelectedInstOperands,
     /* 667005 */     // GIR_Coverage, 5883,
     /* 667005 */     GIR_EraseRootFromParent_Done,
     /* 667006 */   // Label 8534: @667006
     /* 667006 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(667099), // Rule ID 5891 //
     /* 667011 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667013 */     // MIs[0] offset
     /* 667013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667016 */     // MIs[0] auxiliary
     /* 667016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667019 */     // MIs[0] Operand 8
     /* 667019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667029 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN),
     /* 667073 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667085 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667097 */     GIR_RootConstrainSelectedInstOperands,
     /* 667098 */     // GIR_Coverage, 5891,
     /* 667098 */     GIR_EraseRootFromParent_Done,
     /* 667099 */   // Label 8535: @667099
     /* 667099 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(667199), // Rule ID 5879 //
     /* 667104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 667111 */     // MIs[0] offset
     /* 667111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667114 */     // MIs[0] auxiliary
     /* 667114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667117 */     // MIs[0] Operand 8
     /* 667117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667127 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667143 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667150 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN_RTN),
     /* 667171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667173 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667185 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667197 */     GIR_RootConstrainSelectedInstOperands,
     /* 667198 */     // GIR_Coverage, 5879,
     /* 667198 */     GIR_EraseRootFromParent_Done,
     /* 667199 */   // Label 8536: @667199
     /* 667199 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(667296), // Rule ID 5887 //
     /* 667204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 667208 */     // MIs[0] offset
     /* 667208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667211 */     // MIs[0] auxiliary
     /* 667211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667214 */     // MIs[0] Operand 8
     /* 667214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667224 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667240 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667247 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN),
     /* 667268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667282 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667294 */     GIR_RootConstrainSelectedInstOperands,
     /* 667295 */     // GIR_Coverage, 5887,
     /* 667295 */     GIR_EraseRootFromParent_Done,
     /* 667296 */   // Label 8537: @667296
     /* 667296 */   GIM_Reject,
     /* 667297 */ // Label 8521: @667297
     /* 667297 */ GIM_Reject,
     /* 667298 */ // Label 8519: @667298
     /* 667298 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(668479),
     /* 667303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 667306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 667309 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 667312 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 667315 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 667318 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(667386), // Rule ID 6080 //
     /* 667323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667326 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667336 */     // MIs[0] offset
     /* 667336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667339 */     // MIs[0] auxiliary
     /* 667339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667342 */     // MIs[0] Operand 8
     /* 667342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667360 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 667363 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667372 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667384 */     GIR_RootConstrainSelectedInstOperands,
     /* 667385 */     // GIR_Coverage, 6080,
     /* 667385 */     GIR_EraseRootFromParent_Done,
     /* 667386 */   // Label 8539: @667386
     /* 667386 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(667451), // Rule ID 6088 //
     /* 667391 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667401 */     // MIs[0] offset
     /* 667401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667404 */     // MIs[0] auxiliary
     /* 667404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667407 */     // MIs[0] Operand 8
     /* 667407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667425 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 667428 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667437 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667449 */     GIR_RootConstrainSelectedInstOperands,
     /* 667450 */     // GIR_Coverage, 6088,
     /* 667450 */     GIR_EraseRootFromParent_Done,
     /* 667451 */   // Label 8540: @667451
     /* 667451 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(667523), // Rule ID 6076 //
     /* 667456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667471 */     // MIs[0] offset
     /* 667471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667474 */     // MIs[0] auxiliary
     /* 667474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667477 */     // MIs[0] Operand 8
     /* 667477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667495 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 667498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667500 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667509 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667521 */     GIR_RootConstrainSelectedInstOperands,
     /* 667522 */     // GIR_Coverage, 6076,
     /* 667522 */     GIR_EraseRootFromParent_Done,
     /* 667523 */   // Label 8541: @667523
     /* 667523 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(667592), // Rule ID 6084 //
     /* 667528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667540 */     // MIs[0] offset
     /* 667540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667543 */     // MIs[0] auxiliary
     /* 667543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667546 */     // MIs[0] Operand 8
     /* 667546 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667564 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 667567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667569 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667578 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667590 */     GIR_RootConstrainSelectedInstOperands,
     /* 667591 */     // GIR_Coverage, 6084,
     /* 667591 */     GIR_EraseRootFromParent_Done,
     /* 667592 */   // Label 8542: @667592
     /* 667592 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(667658), // Rule ID 6082 //
     /* 667597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667600 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667606 */     // MIs[0] offset
     /* 667606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667609 */     // MIs[0] auxiliary
     /* 667609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667612 */     // MIs[0] Operand 8
     /* 667612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667630 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN),
     /* 667633 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667635 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667644 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667656 */     GIR_RootConstrainSelectedInstOperands,
     /* 667657 */     // GIR_Coverage, 6082,
     /* 667657 */     GIR_EraseRootFromParent_Done,
     /* 667658 */   // Label 8543: @667658
     /* 667658 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(667721), // Rule ID 6090 //
     /* 667663 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667669 */     // MIs[0] offset
     /* 667669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667672 */     // MIs[0] auxiliary
     /* 667672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667675 */     // MIs[0] Operand 8
     /* 667675 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667693 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN),
     /* 667696 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667698 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667707 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667719 */     GIR_RootConstrainSelectedInstOperands,
     /* 667720 */     // GIR_Coverage, 6090,
     /* 667720 */     GIR_EraseRootFromParent_Done,
     /* 667721 */   // Label 8544: @667721
     /* 667721 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(667791), // Rule ID 6078 //
     /* 667726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667737 */     // MIs[0] offset
     /* 667737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667740 */     // MIs[0] auxiliary
     /* 667740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667743 */     // MIs[0] Operand 8
     /* 667743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667761 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN),
     /* 667764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667766 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667768 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667777 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667789 */     GIR_RootConstrainSelectedInstOperands,
     /* 667790 */     // GIR_Coverage, 6078,
     /* 667790 */     GIR_EraseRootFromParent_Done,
     /* 667791 */   // Label 8545: @667791
     /* 667791 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(667858), // Rule ID 6086 //
     /* 667796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667804 */     // MIs[0] offset
     /* 667804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667807 */     // MIs[0] auxiliary
     /* 667807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667810 */     // MIs[0] Operand 8
     /* 667810 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667828 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN),
     /* 667831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667833 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667835 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667844 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667856 */     GIR_RootConstrainSelectedInstOperands,
     /* 667857 */     // GIR_Coverage, 6086,
     /* 667857 */     GIR_EraseRootFromParent_Done,
     /* 667858 */   // Label 8546: @667858
     /* 667858 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(667916), // Rule ID 6081 //
     /* 667863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667866 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667872 */     // MIs[0] offset
     /* 667872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667875 */     // MIs[0] auxiliary
     /* 667875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667878 */     // MIs[0] Operand 8
     /* 667878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667888 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN),
     /* 667891 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667893 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667902 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667914 */     GIR_RootConstrainSelectedInstOperands,
     /* 667915 */     // GIR_Coverage, 6081,
     /* 667915 */     GIR_EraseRootFromParent_Done,
     /* 667916 */   // Label 8547: @667916
     /* 667916 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(667971), // Rule ID 6089 //
     /* 667921 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667927 */     // MIs[0] offset
     /* 667927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667930 */     // MIs[0] auxiliary
     /* 667930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667933 */     // MIs[0] Operand 8
     /* 667933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667943 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN),
     /* 667946 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667948 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667957 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667969 */     GIR_RootConstrainSelectedInstOperands,
     /* 667970 */     // GIR_Coverage, 6089,
     /* 667970 */     GIR_EraseRootFromParent_Done,
     /* 667971 */   // Label 8548: @667971
     /* 667971 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(668033), // Rule ID 6077 //
     /* 667976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667987 */     // MIs[0] offset
     /* 667987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667990 */     // MIs[0] auxiliary
     /* 667990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667993 */     // MIs[0] Operand 8
     /* 667993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668003 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN),
     /* 668006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668008 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668010 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668019 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668031 */     GIR_RootConstrainSelectedInstOperands,
     /* 668032 */     // GIR_Coverage, 6077,
     /* 668032 */     GIR_EraseRootFromParent_Done,
     /* 668033 */   // Label 8549: @668033
     /* 668033 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(668092), // Rule ID 6085 //
     /* 668038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 668042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668046 */     // MIs[0] offset
     /* 668046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668049 */     // MIs[0] auxiliary
     /* 668049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668052 */     // MIs[0] Operand 8
     /* 668052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668062 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN),
     /* 668065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668067 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668078 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668090 */     GIR_RootConstrainSelectedInstOperands,
     /* 668091 */     // GIR_Coverage, 6085,
     /* 668091 */     GIR_EraseRootFromParent_Done,
     /* 668092 */   // Label 8550: @668092
     /* 668092 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(668188), // Rule ID 6083 //
     /* 668097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668100 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668102 */     // MIs[0] offset
     /* 668102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668105 */     // MIs[0] auxiliary
     /* 668105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668108 */     // MIs[0] Operand 8
     /* 668108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668118 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668134 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668141 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN),
     /* 668162 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668174 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668186 */     GIR_RootConstrainSelectedInstOperands,
     /* 668187 */     // GIR_Coverage, 6083,
     /* 668187 */     GIR_EraseRootFromParent_Done,
     /* 668188 */   // Label 8551: @668188
     /* 668188 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(668281), // Rule ID 6091 //
     /* 668193 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668195 */     // MIs[0] offset
     /* 668195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668198 */     // MIs[0] auxiliary
     /* 668198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668201 */     // MIs[0] Operand 8
     /* 668201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668211 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668227 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668234 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN),
     /* 668255 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668267 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668279 */     GIR_RootConstrainSelectedInstOperands,
     /* 668280 */     // GIR_Coverage, 6091,
     /* 668280 */     GIR_EraseRootFromParent_Done,
     /* 668281 */   // Label 8552: @668281
     /* 668281 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(668381), // Rule ID 6079 //
     /* 668286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 668293 */     // MIs[0] offset
     /* 668293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668296 */     // MIs[0] auxiliary
     /* 668296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668299 */     // MIs[0] Operand 8
     /* 668299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668309 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668325 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668332 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN),
     /* 668353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668355 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668367 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668379 */     GIR_RootConstrainSelectedInstOperands,
     /* 668380 */     // GIR_Coverage, 6079,
     /* 668380 */     GIR_EraseRootFromParent_Done,
     /* 668381 */   // Label 8553: @668381
     /* 668381 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(668478), // Rule ID 6087 //
     /* 668386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 668390 */     // MIs[0] offset
     /* 668390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668393 */     // MIs[0] auxiliary
     /* 668393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668396 */     // MIs[0] Operand 8
     /* 668396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668406 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668422 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668429 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 668450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668452 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668464 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668476 */     GIR_RootConstrainSelectedInstOperands,
     /* 668477 */     // GIR_Coverage, 6087,
     /* 668477 */     GIR_EraseRootFromParent_Done,
     /* 668478 */   // Label 8554: @668478
     /* 668478 */   GIM_Reject,
     /* 668479 */ // Label 8538: @668479
     /* 668479 */ GIM_Reject,
     /* 668480 */ // Label 8520: @668480
     /* 668480 */ GIM_Reject,
     /* 668481 */ // Label 120: @668481
     /* 668481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8557*/ GIMT_Encode4(670864),
     /* 668492 */ /*GILLT_s32*//*Label 8555*/ GIMT_Encode4(668500),
     /* 668496 */ /*GILLT_s64*//*Label 8556*/ GIMT_Encode4(669682),
     /* 668500 */ // Label 8555: @668500
     /* 668500 */ GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(669681),
     /* 668505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 668508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 668511 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 668514 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 668517 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 668520 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(668588), // Rule ID 5864 //
     /* 668525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668528 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668538 */     // MIs[0] offset
     /* 668538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668541 */     // MIs[0] auxiliary
     /* 668541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668544 */     // MIs[0] Operand 8
     /* 668544 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668562 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 668565 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668574 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668586 */     GIR_RootConstrainSelectedInstOperands,
     /* 668587 */     // GIR_Coverage, 5864,
     /* 668587 */     GIR_EraseRootFromParent_Done,
     /* 668588 */   // Label 8559: @668588
     /* 668588 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(668653), // Rule ID 5872 //
     /* 668593 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668603 */     // MIs[0] offset
     /* 668603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668606 */     // MIs[0] auxiliary
     /* 668606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668609 */     // MIs[0] Operand 8
     /* 668609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668627 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 668630 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668639 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668651 */     GIR_RootConstrainSelectedInstOperands,
     /* 668652 */     // GIR_Coverage, 5872,
     /* 668652 */     GIR_EraseRootFromParent_Done,
     /* 668653 */   // Label 8560: @668653
     /* 668653 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(668725), // Rule ID 5860 //
     /* 668658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668673 */     // MIs[0] offset
     /* 668673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668676 */     // MIs[0] auxiliary
     /* 668676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668679 */     // MIs[0] Operand 8
     /* 668679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668697 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 668700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668702 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668711 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668713 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668723 */     GIR_RootConstrainSelectedInstOperands,
     /* 668724 */     // GIR_Coverage, 5860,
     /* 668724 */     GIR_EraseRootFromParent_Done,
     /* 668725 */   // Label 8561: @668725
     /* 668725 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(668794), // Rule ID 5868 //
     /* 668730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668742 */     // MIs[0] offset
     /* 668742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668745 */     // MIs[0] auxiliary
     /* 668745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668748 */     // MIs[0] Operand 8
     /* 668748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668766 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 668769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668771 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668780 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668792 */     GIR_RootConstrainSelectedInstOperands,
     /* 668793 */     // GIR_Coverage, 5868,
     /* 668793 */     GIR_EraseRootFromParent_Done,
     /* 668794 */   // Label 8562: @668794
     /* 668794 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(668860), // Rule ID 5866 //
     /* 668799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668802 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668808 */     // MIs[0] offset
     /* 668808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668811 */     // MIs[0] auxiliary
     /* 668811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668814 */     // MIs[0] Operand 8
     /* 668814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668832 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN),
     /* 668835 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668837 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668846 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668858 */     GIR_RootConstrainSelectedInstOperands,
     /* 668859 */     // GIR_Coverage, 5866,
     /* 668859 */     GIR_EraseRootFromParent_Done,
     /* 668860 */   // Label 8563: @668860
     /* 668860 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(668923), // Rule ID 5874 //
     /* 668865 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668871 */     // MIs[0] offset
     /* 668871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668874 */     // MIs[0] auxiliary
     /* 668874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668877 */     // MIs[0] Operand 8
     /* 668877 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668895 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN),
     /* 668898 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668900 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668909 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668911 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668921 */     GIR_RootConstrainSelectedInstOperands,
     /* 668922 */     // GIR_Coverage, 5874,
     /* 668922 */     GIR_EraseRootFromParent_Done,
     /* 668923 */   // Label 8564: @668923
     /* 668923 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(668993), // Rule ID 5862 //
     /* 668928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668939 */     // MIs[0] offset
     /* 668939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668942 */     // MIs[0] auxiliary
     /* 668942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668945 */     // MIs[0] Operand 8
     /* 668945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668963 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN_RTN),
     /* 668966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668968 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668970 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668979 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668991 */     GIR_RootConstrainSelectedInstOperands,
     /* 668992 */     // GIR_Coverage, 5862,
     /* 668992 */     GIR_EraseRootFromParent_Done,
     /* 668993 */   // Label 8565: @668993
     /* 668993 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(669060), // Rule ID 5870 //
     /* 668998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669006 */     // MIs[0] offset
     /* 669006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669009 */     // MIs[0] auxiliary
     /* 669009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669012 */     // MIs[0] Operand 8
     /* 669012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669030 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN),
     /* 669033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669035 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669037 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669046 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669058 */     GIR_RootConstrainSelectedInstOperands,
     /* 669059 */     // GIR_Coverage, 5870,
     /* 669059 */     GIR_EraseRootFromParent_Done,
     /* 669060 */   // Label 8566: @669060
     /* 669060 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(669118), // Rule ID 5865 //
     /* 669065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669068 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669074 */     // MIs[0] offset
     /* 669074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669077 */     // MIs[0] auxiliary
     /* 669077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669080 */     // MIs[0] Operand 8
     /* 669080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669090 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN),
     /* 669093 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669095 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669104 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669116 */     GIR_RootConstrainSelectedInstOperands,
     /* 669117 */     // GIR_Coverage, 5865,
     /* 669117 */     GIR_EraseRootFromParent_Done,
     /* 669118 */   // Label 8567: @669118
     /* 669118 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(669173), // Rule ID 5873 //
     /* 669123 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669129 */     // MIs[0] offset
     /* 669129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669132 */     // MIs[0] auxiliary
     /* 669132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669135 */     // MIs[0] Operand 8
     /* 669135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669145 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN),
     /* 669148 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669150 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669159 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669171 */     GIR_RootConstrainSelectedInstOperands,
     /* 669172 */     // GIR_Coverage, 5873,
     /* 669172 */     GIR_EraseRootFromParent_Done,
     /* 669173 */   // Label 8568: @669173
     /* 669173 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(669235), // Rule ID 5861 //
     /* 669178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669189 */     // MIs[0] offset
     /* 669189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669192 */     // MIs[0] auxiliary
     /* 669192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669195 */     // MIs[0] Operand 8
     /* 669195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669205 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN_RTN),
     /* 669208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669210 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669212 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669221 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669233 */     GIR_RootConstrainSelectedInstOperands,
     /* 669234 */     // GIR_Coverage, 5861,
     /* 669234 */     GIR_EraseRootFromParent_Done,
     /* 669235 */   // Label 8569: @669235
     /* 669235 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(669294), // Rule ID 5869 //
     /* 669240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669248 */     // MIs[0] offset
     /* 669248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669251 */     // MIs[0] auxiliary
     /* 669251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669254 */     // MIs[0] Operand 8
     /* 669254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669264 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN),
     /* 669267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669271 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669280 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669292 */     GIR_RootConstrainSelectedInstOperands,
     /* 669293 */     // GIR_Coverage, 5869,
     /* 669293 */     GIR_EraseRootFromParent_Done,
     /* 669294 */   // Label 8570: @669294
     /* 669294 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(669390), // Rule ID 5867 //
     /* 669299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669302 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669304 */     // MIs[0] offset
     /* 669304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669307 */     // MIs[0] auxiliary
     /* 669307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669310 */     // MIs[0] Operand 8
     /* 669310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669320 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669336 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669343 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN),
     /* 669364 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669376 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669388 */     GIR_RootConstrainSelectedInstOperands,
     /* 669389 */     // GIR_Coverage, 5867,
     /* 669389 */     GIR_EraseRootFromParent_Done,
     /* 669390 */   // Label 8571: @669390
     /* 669390 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(669483), // Rule ID 5875 //
     /* 669395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669397 */     // MIs[0] offset
     /* 669397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669400 */     // MIs[0] auxiliary
     /* 669400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669403 */     // MIs[0] Operand 8
     /* 669403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669413 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669429 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669436 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN),
     /* 669457 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669469 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669481 */     GIR_RootConstrainSelectedInstOperands,
     /* 669482 */     // GIR_Coverage, 5875,
     /* 669482 */     GIR_EraseRootFromParent_Done,
     /* 669483 */   // Label 8572: @669483
     /* 669483 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(669583), // Rule ID 5863 //
     /* 669488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669495 */     // MIs[0] offset
     /* 669495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669498 */     // MIs[0] auxiliary
     /* 669498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669501 */     // MIs[0] Operand 8
     /* 669501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669511 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669527 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669534 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN_RTN),
     /* 669555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669557 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669569 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669581 */     GIR_RootConstrainSelectedInstOperands,
     /* 669582 */     // GIR_Coverage, 5863,
     /* 669582 */     GIR_EraseRootFromParent_Done,
     /* 669583 */   // Label 8573: @669583
     /* 669583 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(669680), // Rule ID 5871 //
     /* 669588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669592 */     // MIs[0] offset
     /* 669592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669595 */     // MIs[0] auxiliary
     /* 669595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669598 */     // MIs[0] Operand 8
     /* 669598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669608 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669624 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669631 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN),
     /* 669652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669654 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669666 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669678 */     GIR_RootConstrainSelectedInstOperands,
     /* 669679 */     // GIR_Coverage, 5871,
     /* 669679 */     GIR_EraseRootFromParent_Done,
     /* 669680 */   // Label 8574: @669680
     /* 669680 */   GIM_Reject,
     /* 669681 */ // Label 8558: @669681
     /* 669681 */ GIM_Reject,
     /* 669682 */ // Label 8556: @669682
     /* 669682 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(670863),
     /* 669687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 669690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 669693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 669696 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 669699 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 669702 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(669770), // Rule ID 6064 //
     /* 669707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669710 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669720 */     // MIs[0] offset
     /* 669720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669723 */     // MIs[0] auxiliary
     /* 669723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669726 */     // MIs[0] Operand 8
     /* 669726 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669744 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 669747 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669756 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669768 */     GIR_RootConstrainSelectedInstOperands,
     /* 669769 */     // GIR_Coverage, 6064,
     /* 669769 */     GIR_EraseRootFromParent_Done,
     /* 669770 */   // Label 8576: @669770
     /* 669770 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(669835), // Rule ID 6072 //
     /* 669775 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669785 */     // MIs[0] offset
     /* 669785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669788 */     // MIs[0] auxiliary
     /* 669788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669791 */     // MIs[0] Operand 8
     /* 669791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669809 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 669812 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669821 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669833 */     GIR_RootConstrainSelectedInstOperands,
     /* 669834 */     // GIR_Coverage, 6072,
     /* 669834 */     GIR_EraseRootFromParent_Done,
     /* 669835 */   // Label 8577: @669835
     /* 669835 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(669907), // Rule ID 6060 //
     /* 669840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669855 */     // MIs[0] offset
     /* 669855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669858 */     // MIs[0] auxiliary
     /* 669858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669861 */     // MIs[0] Operand 8
     /* 669861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669879 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 669882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669884 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669893 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669905 */     GIR_RootConstrainSelectedInstOperands,
     /* 669906 */     // GIR_Coverage, 6060,
     /* 669906 */     GIR_EraseRootFromParent_Done,
     /* 669907 */   // Label 8578: @669907
     /* 669907 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(669976), // Rule ID 6068 //
     /* 669912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669924 */     // MIs[0] offset
     /* 669924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669927 */     // MIs[0] auxiliary
     /* 669927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669930 */     // MIs[0] Operand 8
     /* 669930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669948 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 669951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669953 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669962 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669974 */     GIR_RootConstrainSelectedInstOperands,
     /* 669975 */     // GIR_Coverage, 6068,
     /* 669975 */     GIR_EraseRootFromParent_Done,
     /* 669976 */   // Label 8579: @669976
     /* 669976 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(670042), // Rule ID 6066 //
     /* 669981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669984 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669990 */     // MIs[0] offset
     /* 669990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669993 */     // MIs[0] auxiliary
     /* 669993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669996 */     // MIs[0] Operand 8
     /* 669996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670014 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN),
     /* 670017 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670019 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670028 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670040 */     GIR_RootConstrainSelectedInstOperands,
     /* 670041 */     // GIR_Coverage, 6066,
     /* 670041 */     GIR_EraseRootFromParent_Done,
     /* 670042 */   // Label 8580: @670042
     /* 670042 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(670105), // Rule ID 6074 //
     /* 670047 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670053 */     // MIs[0] offset
     /* 670053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670056 */     // MIs[0] auxiliary
     /* 670056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670059 */     // MIs[0] Operand 8
     /* 670059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670077 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN),
     /* 670080 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670082 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670091 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670103 */     GIR_RootConstrainSelectedInstOperands,
     /* 670104 */     // GIR_Coverage, 6074,
     /* 670104 */     GIR_EraseRootFromParent_Done,
     /* 670105 */   // Label 8581: @670105
     /* 670105 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(670175), // Rule ID 6062 //
     /* 670110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670121 */     // MIs[0] offset
     /* 670121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670124 */     // MIs[0] auxiliary
     /* 670124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670127 */     // MIs[0] Operand 8
     /* 670127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670145 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN_RTN),
     /* 670148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670150 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670152 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670161 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670173 */     GIR_RootConstrainSelectedInstOperands,
     /* 670174 */     // GIR_Coverage, 6062,
     /* 670174 */     GIR_EraseRootFromParent_Done,
     /* 670175 */   // Label 8582: @670175
     /* 670175 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(670242), // Rule ID 6070 //
     /* 670180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670188 */     // MIs[0] offset
     /* 670188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670191 */     // MIs[0] auxiliary
     /* 670191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670194 */     // MIs[0] Operand 8
     /* 670194 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670212 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN),
     /* 670215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670217 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670219 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670228 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670240 */     GIR_RootConstrainSelectedInstOperands,
     /* 670241 */     // GIR_Coverage, 6070,
     /* 670241 */     GIR_EraseRootFromParent_Done,
     /* 670242 */   // Label 8583: @670242
     /* 670242 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(670300), // Rule ID 6065 //
     /* 670247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670250 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670256 */     // MIs[0] offset
     /* 670256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670259 */     // MIs[0] auxiliary
     /* 670259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670262 */     // MIs[0] Operand 8
     /* 670262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670272 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN),
     /* 670275 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670277 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670286 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670298 */     GIR_RootConstrainSelectedInstOperands,
     /* 670299 */     // GIR_Coverage, 6065,
     /* 670299 */     GIR_EraseRootFromParent_Done,
     /* 670300 */   // Label 8584: @670300
     /* 670300 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(670355), // Rule ID 6073 //
     /* 670305 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670311 */     // MIs[0] offset
     /* 670311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670314 */     // MIs[0] auxiliary
     /* 670314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670317 */     // MIs[0] Operand 8
     /* 670317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670327 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN),
     /* 670330 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670332 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670341 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670353 */     GIR_RootConstrainSelectedInstOperands,
     /* 670354 */     // GIR_Coverage, 6073,
     /* 670354 */     GIR_EraseRootFromParent_Done,
     /* 670355 */   // Label 8585: @670355
     /* 670355 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(670417), // Rule ID 6061 //
     /* 670360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670371 */     // MIs[0] offset
     /* 670371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670374 */     // MIs[0] auxiliary
     /* 670374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670377 */     // MIs[0] Operand 8
     /* 670377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670387 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN_RTN),
     /* 670390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670392 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670394 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670415 */     GIR_RootConstrainSelectedInstOperands,
     /* 670416 */     // GIR_Coverage, 6061,
     /* 670416 */     GIR_EraseRootFromParent_Done,
     /* 670417 */   // Label 8586: @670417
     /* 670417 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(670476), // Rule ID 6069 //
     /* 670422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670430 */     // MIs[0] offset
     /* 670430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670433 */     // MIs[0] auxiliary
     /* 670433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670436 */     // MIs[0] Operand 8
     /* 670436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670446 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN),
     /* 670449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670451 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670453 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670462 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670474 */     GIR_RootConstrainSelectedInstOperands,
     /* 670475 */     // GIR_Coverage, 6069,
     /* 670475 */     GIR_EraseRootFromParent_Done,
     /* 670476 */   // Label 8587: @670476
     /* 670476 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(670572), // Rule ID 6067 //
     /* 670481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670484 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670486 */     // MIs[0] offset
     /* 670486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670489 */     // MIs[0] auxiliary
     /* 670489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670492 */     // MIs[0] Operand 8
     /* 670492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670502 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670518 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670525 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN),
     /* 670546 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670558 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670570 */     GIR_RootConstrainSelectedInstOperands,
     /* 670571 */     // GIR_Coverage, 6067,
     /* 670571 */     GIR_EraseRootFromParent_Done,
     /* 670572 */   // Label 8588: @670572
     /* 670572 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(670665), // Rule ID 6075 //
     /* 670577 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670579 */     // MIs[0] offset
     /* 670579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670582 */     // MIs[0] auxiliary
     /* 670582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670585 */     // MIs[0] Operand 8
     /* 670585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670595 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670611 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670618 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN),
     /* 670639 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670651 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670663 */     GIR_RootConstrainSelectedInstOperands,
     /* 670664 */     // GIR_Coverage, 6075,
     /* 670664 */     GIR_EraseRootFromParent_Done,
     /* 670665 */   // Label 8589: @670665
     /* 670665 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(670765), // Rule ID 6063 //
     /* 670670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670677 */     // MIs[0] offset
     /* 670677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670680 */     // MIs[0] auxiliary
     /* 670680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670683 */     // MIs[0] Operand 8
     /* 670683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670693 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670709 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670716 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN),
     /* 670737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670739 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670751 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670763 */     GIR_RootConstrainSelectedInstOperands,
     /* 670764 */     // GIR_Coverage, 6063,
     /* 670764 */     GIR_EraseRootFromParent_Done,
     /* 670765 */   // Label 8590: @670765
     /* 670765 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(670862), // Rule ID 6071 //
     /* 670770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670774 */     // MIs[0] offset
     /* 670774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670777 */     // MIs[0] auxiliary
     /* 670777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670780 */     // MIs[0] Operand 8
     /* 670780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670790 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670806 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670813 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN),
     /* 670834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670836 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670848 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670860 */     GIR_RootConstrainSelectedInstOperands,
     /* 670861 */     // GIR_Coverage, 6071,
     /* 670861 */     GIR_EraseRootFromParent_Done,
     /* 670862 */   // Label 8591: @670862
     /* 670862 */   GIM_Reject,
     /* 670863 */ // Label 8575: @670863
     /* 670863 */ GIM_Reject,
     /* 670864 */ // Label 8557: @670864
     /* 670864 */ GIM_Reject,
     /* 670865 */ // Label 121: @670865
     /* 670865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8594*/ GIMT_Encode4(674408),
     /* 670876 */ /*GILLT_s32*//*Label 8592*/ GIMT_Encode4(670884),
     /* 670880 */ /*GILLT_s64*//*Label 8593*/ GIMT_Encode4(673226),
     /* 670884 */ // Label 8592: @670884
     /* 670884 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(673225),
     /* 670889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 670892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 670895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 670898 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 670901 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 670904 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(670972), // Rule ID 5816 //
     /* 670909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670912 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670922 */     // MIs[0] offset
     /* 670922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670925 */     // MIs[0] auxiliary
     /* 670925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670928 */     // MIs[0] Operand 8
     /* 670928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670946 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 670949 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670958 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670970 */     GIR_RootConstrainSelectedInstOperands,
     /* 670971 */     // GIR_Coverage, 5816,
     /* 670971 */     GIR_EraseRootFromParent_Done,
     /* 670972 */   // Label 8596: @670972
     /* 670972 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(671037), // Rule ID 5824 //
     /* 670977 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670987 */     // MIs[0] offset
     /* 670987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670990 */     // MIs[0] auxiliary
     /* 670990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670993 */     // MIs[0] Operand 8
     /* 670993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671011 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 671014 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671023 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671035 */     GIR_RootConstrainSelectedInstOperands,
     /* 671036 */     // GIR_Coverage, 5824,
     /* 671036 */     GIR_EraseRootFromParent_Done,
     /* 671037 */   // Label 8597: @671037
     /* 671037 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(671105), // Rule ID 5832 //
     /* 671042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671045 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671055 */     // MIs[0] offset
     /* 671055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671058 */     // MIs[0] auxiliary
     /* 671058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671061 */     // MIs[0] Operand 8
     /* 671061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671079 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 671082 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671091 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671103 */     GIR_RootConstrainSelectedInstOperands,
     /* 671104 */     // GIR_Coverage, 5832,
     /* 671104 */     GIR_EraseRootFromParent_Done,
     /* 671105 */   // Label 8598: @671105
     /* 671105 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(671170), // Rule ID 5840 //
     /* 671110 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671120 */     // MIs[0] offset
     /* 671120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671123 */     // MIs[0] auxiliary
     /* 671123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671126 */     // MIs[0] Operand 8
     /* 671126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671144 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 671147 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671156 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671168 */     GIR_RootConstrainSelectedInstOperands,
     /* 671169 */     // GIR_Coverage, 5840,
     /* 671169 */     GIR_EraseRootFromParent_Done,
     /* 671170 */   // Label 8599: @671170
     /* 671170 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(671242), // Rule ID 5812 //
     /* 671175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671190 */     // MIs[0] offset
     /* 671190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671193 */     // MIs[0] auxiliary
     /* 671193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671196 */     // MIs[0] Operand 8
     /* 671196 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671214 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 671217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671219 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671228 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671240 */     GIR_RootConstrainSelectedInstOperands,
     /* 671241 */     // GIR_Coverage, 5812,
     /* 671241 */     GIR_EraseRootFromParent_Done,
     /* 671242 */   // Label 8600: @671242
     /* 671242 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(671311), // Rule ID 5820 //
     /* 671247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671259 */     // MIs[0] offset
     /* 671259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671262 */     // MIs[0] auxiliary
     /* 671262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671265 */     // MIs[0] Operand 8
     /* 671265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671283 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 671286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671288 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671297 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671309 */     GIR_RootConstrainSelectedInstOperands,
     /* 671310 */     // GIR_Coverage, 5820,
     /* 671310 */     GIR_EraseRootFromParent_Done,
     /* 671311 */   // Label 8601: @671311
     /* 671311 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(671383), // Rule ID 5828 //
     /* 671316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671331 */     // MIs[0] offset
     /* 671331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671334 */     // MIs[0] auxiliary
     /* 671334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671337 */     // MIs[0] Operand 8
     /* 671337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671355 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 671358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671360 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671369 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671381 */     GIR_RootConstrainSelectedInstOperands,
     /* 671382 */     // GIR_Coverage, 5828,
     /* 671382 */     GIR_EraseRootFromParent_Done,
     /* 671383 */   // Label 8602: @671383
     /* 671383 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(671452), // Rule ID 5836 //
     /* 671388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671400 */     // MIs[0] offset
     /* 671400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671403 */     // MIs[0] auxiliary
     /* 671403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671406 */     // MIs[0] Operand 8
     /* 671406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671424 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 671427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671429 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671438 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671450 */     GIR_RootConstrainSelectedInstOperands,
     /* 671451 */     // GIR_Coverage, 5836,
     /* 671451 */     GIR_EraseRootFromParent_Done,
     /* 671452 */   // Label 8603: @671452
     /* 671452 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(671518), // Rule ID 5818 //
     /* 671457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671460 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671466 */     // MIs[0] offset
     /* 671466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671469 */     // MIs[0] auxiliary
     /* 671469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671472 */     // MIs[0] Operand 8
     /* 671472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671490 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 671493 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671495 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671504 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671516 */     GIR_RootConstrainSelectedInstOperands,
     /* 671517 */     // GIR_Coverage, 5818,
     /* 671517 */     GIR_EraseRootFromParent_Done,
     /* 671518 */   // Label 8604: @671518
     /* 671518 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(671581), // Rule ID 5826 //
     /* 671523 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671529 */     // MIs[0] offset
     /* 671529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671532 */     // MIs[0] auxiliary
     /* 671532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671535 */     // MIs[0] Operand 8
     /* 671535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671553 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 671556 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671558 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671567 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671579 */     GIR_RootConstrainSelectedInstOperands,
     /* 671580 */     // GIR_Coverage, 5826,
     /* 671580 */     GIR_EraseRootFromParent_Done,
     /* 671581 */   // Label 8605: @671581
     /* 671581 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(671647), // Rule ID 5834 //
     /* 671586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671589 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671595 */     // MIs[0] offset
     /* 671595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671598 */     // MIs[0] auxiliary
     /* 671598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671601 */     // MIs[0] Operand 8
     /* 671601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671619 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 671622 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671624 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671633 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671645 */     GIR_RootConstrainSelectedInstOperands,
     /* 671646 */     // GIR_Coverage, 5834,
     /* 671646 */     GIR_EraseRootFromParent_Done,
     /* 671647 */   // Label 8606: @671647
     /* 671647 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(671710), // Rule ID 5842 //
     /* 671652 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671658 */     // MIs[0] offset
     /* 671658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671661 */     // MIs[0] auxiliary
     /* 671661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671664 */     // MIs[0] Operand 8
     /* 671664 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671682 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 671685 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671687 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671708 */     GIR_RootConstrainSelectedInstOperands,
     /* 671709 */     // GIR_Coverage, 5842,
     /* 671709 */     GIR_EraseRootFromParent_Done,
     /* 671710 */   // Label 8607: @671710
     /* 671710 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(671780), // Rule ID 5814 //
     /* 671715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671726 */     // MIs[0] offset
     /* 671726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671729 */     // MIs[0] auxiliary
     /* 671729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671732 */     // MIs[0] Operand 8
     /* 671732 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671750 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 671753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671755 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671757 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671766 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671778 */     GIR_RootConstrainSelectedInstOperands,
     /* 671779 */     // GIR_Coverage, 5814,
     /* 671779 */     GIR_EraseRootFromParent_Done,
     /* 671780 */   // Label 8608: @671780
     /* 671780 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(671847), // Rule ID 5822 //
     /* 671785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671793 */     // MIs[0] offset
     /* 671793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671796 */     // MIs[0] auxiliary
     /* 671796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671799 */     // MIs[0] Operand 8
     /* 671799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671817 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 671820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671822 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671824 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671833 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671845 */     GIR_RootConstrainSelectedInstOperands,
     /* 671846 */     // GIR_Coverage, 5822,
     /* 671846 */     GIR_EraseRootFromParent_Done,
     /* 671847 */   // Label 8609: @671847
     /* 671847 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(671917), // Rule ID 5830 //
     /* 671852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671863 */     // MIs[0] offset
     /* 671863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671866 */     // MIs[0] auxiliary
     /* 671866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671869 */     // MIs[0] Operand 8
     /* 671869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671887 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 671890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671892 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671894 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671903 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671915 */     GIR_RootConstrainSelectedInstOperands,
     /* 671916 */     // GIR_Coverage, 5830,
     /* 671916 */     GIR_EraseRootFromParent_Done,
     /* 671917 */   // Label 8610: @671917
     /* 671917 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(671984), // Rule ID 5838 //
     /* 671922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671930 */     // MIs[0] offset
     /* 671930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671933 */     // MIs[0] auxiliary
     /* 671933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671936 */     // MIs[0] Operand 8
     /* 671936 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671954 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 671957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671959 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671961 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671970 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671982 */     GIR_RootConstrainSelectedInstOperands,
     /* 671983 */     // GIR_Coverage, 5838,
     /* 671983 */     GIR_EraseRootFromParent_Done,
     /* 671984 */   // Label 8611: @671984
     /* 671984 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(672042), // Rule ID 5817 //
     /* 671989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671992 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671998 */     // MIs[0] offset
     /* 671998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672001 */     // MIs[0] auxiliary
     /* 672001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672004 */     // MIs[0] Operand 8
     /* 672004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672014 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 672017 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672019 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672028 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672040 */     GIR_RootConstrainSelectedInstOperands,
     /* 672041 */     // GIR_Coverage, 5817,
     /* 672041 */     GIR_EraseRootFromParent_Done,
     /* 672042 */   // Label 8612: @672042
     /* 672042 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(672097), // Rule ID 5825 //
     /* 672047 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672053 */     // MIs[0] offset
     /* 672053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672056 */     // MIs[0] auxiliary
     /* 672056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672059 */     // MIs[0] Operand 8
     /* 672059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672069 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 672072 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672074 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672083 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672095 */     GIR_RootConstrainSelectedInstOperands,
     /* 672096 */     // GIR_Coverage, 5825,
     /* 672096 */     GIR_EraseRootFromParent_Done,
     /* 672097 */   // Label 8613: @672097
     /* 672097 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(672155), // Rule ID 5833 //
     /* 672102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672105 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672111 */     // MIs[0] offset
     /* 672111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672114 */     // MIs[0] auxiliary
     /* 672114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672117 */     // MIs[0] Operand 8
     /* 672117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672127 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 672130 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672132 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672141 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672153 */     GIR_RootConstrainSelectedInstOperands,
     /* 672154 */     // GIR_Coverage, 5833,
     /* 672154 */     GIR_EraseRootFromParent_Done,
     /* 672155 */   // Label 8614: @672155
     /* 672155 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(672210), // Rule ID 5841 //
     /* 672160 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672166 */     // MIs[0] offset
     /* 672166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672169 */     // MIs[0] auxiliary
     /* 672169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672172 */     // MIs[0] Operand 8
     /* 672172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672182 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 672185 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672187 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672196 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672208 */     GIR_RootConstrainSelectedInstOperands,
     /* 672209 */     // GIR_Coverage, 5841,
     /* 672209 */     GIR_EraseRootFromParent_Done,
     /* 672210 */   // Label 8615: @672210
     /* 672210 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(672272), // Rule ID 5813 //
     /* 672215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672226 */     // MIs[0] offset
     /* 672226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672229 */     // MIs[0] auxiliary
     /* 672229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672232 */     // MIs[0] Operand 8
     /* 672232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672242 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 672245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672247 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672249 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672258 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672270 */     GIR_RootConstrainSelectedInstOperands,
     /* 672271 */     // GIR_Coverage, 5813,
     /* 672271 */     GIR_EraseRootFromParent_Done,
     /* 672272 */   // Label 8616: @672272
     /* 672272 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(672331), // Rule ID 5821 //
     /* 672277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672285 */     // MIs[0] offset
     /* 672285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672288 */     // MIs[0] auxiliary
     /* 672288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672291 */     // MIs[0] Operand 8
     /* 672291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672301 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 672304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672306 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672308 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672317 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672329 */     GIR_RootConstrainSelectedInstOperands,
     /* 672330 */     // GIR_Coverage, 5821,
     /* 672330 */     GIR_EraseRootFromParent_Done,
     /* 672331 */   // Label 8617: @672331
     /* 672331 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(672393), // Rule ID 5829 //
     /* 672336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672347 */     // MIs[0] offset
     /* 672347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672350 */     // MIs[0] auxiliary
     /* 672350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672353 */     // MIs[0] Operand 8
     /* 672353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672363 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 672366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672368 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672370 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672379 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672391 */     GIR_RootConstrainSelectedInstOperands,
     /* 672392 */     // GIR_Coverage, 5829,
     /* 672392 */     GIR_EraseRootFromParent_Done,
     /* 672393 */   // Label 8618: @672393
     /* 672393 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(672452), // Rule ID 5837 //
     /* 672398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672406 */     // MIs[0] offset
     /* 672406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672409 */     // MIs[0] auxiliary
     /* 672409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672412 */     // MIs[0] Operand 8
     /* 672412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672422 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 672425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672427 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672429 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672438 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672450 */     GIR_RootConstrainSelectedInstOperands,
     /* 672451 */     // GIR_Coverage, 5837,
     /* 672451 */     GIR_EraseRootFromParent_Done,
     /* 672452 */   // Label 8619: @672452
     /* 672452 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(672548), // Rule ID 5819 //
     /* 672457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672460 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672462 */     // MIs[0] offset
     /* 672462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672465 */     // MIs[0] auxiliary
     /* 672465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672468 */     // MIs[0] Operand 8
     /* 672468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672478 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672501 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 672522 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672534 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672536 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672546 */     GIR_RootConstrainSelectedInstOperands,
     /* 672547 */     // GIR_Coverage, 5819,
     /* 672547 */     GIR_EraseRootFromParent_Done,
     /* 672548 */   // Label 8620: @672548
     /* 672548 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(672641), // Rule ID 5827 //
     /* 672553 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672555 */     // MIs[0] offset
     /* 672555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672558 */     // MIs[0] auxiliary
     /* 672558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672561 */     // MIs[0] Operand 8
     /* 672561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672571 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672594 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 672615 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672627 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672639 */     GIR_RootConstrainSelectedInstOperands,
     /* 672640 */     // GIR_Coverage, 5827,
     /* 672640 */     GIR_EraseRootFromParent_Done,
     /* 672641 */   // Label 8621: @672641
     /* 672641 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(672737), // Rule ID 5835 //
     /* 672646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672649 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672651 */     // MIs[0] offset
     /* 672651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672654 */     // MIs[0] auxiliary
     /* 672654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672657 */     // MIs[0] Operand 8
     /* 672657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672667 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672683 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672690 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 672711 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672723 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672725 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672735 */     GIR_RootConstrainSelectedInstOperands,
     /* 672736 */     // GIR_Coverage, 5835,
     /* 672736 */     GIR_EraseRootFromParent_Done,
     /* 672737 */   // Label 8622: @672737
     /* 672737 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(672830), // Rule ID 5843 //
     /* 672742 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672744 */     // MIs[0] offset
     /* 672744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672747 */     // MIs[0] auxiliary
     /* 672747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672750 */     // MIs[0] Operand 8
     /* 672750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672760 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672776 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672783 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 672804 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672816 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672828 */     GIR_RootConstrainSelectedInstOperands,
     /* 672829 */     // GIR_Coverage, 5843,
     /* 672829 */     GIR_EraseRootFromParent_Done,
     /* 672830 */   // Label 8623: @672830
     /* 672830 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(672930), // Rule ID 5815 //
     /* 672835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672842 */     // MIs[0] offset
     /* 672842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672845 */     // MIs[0] auxiliary
     /* 672845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672848 */     // MIs[0] Operand 8
     /* 672848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672858 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672874 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672881 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 672902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672904 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672916 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672928 */     GIR_RootConstrainSelectedInstOperands,
     /* 672929 */     // GIR_Coverage, 5815,
     /* 672929 */     GIR_EraseRootFromParent_Done,
     /* 672930 */   // Label 8624: @672930
     /* 672930 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(673027), // Rule ID 5823 //
     /* 672935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672939 */     // MIs[0] offset
     /* 672939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672942 */     // MIs[0] auxiliary
     /* 672942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672945 */     // MIs[0] Operand 8
     /* 672945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672955 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672971 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672978 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 672999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673001 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673013 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673015 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673025 */     GIR_RootConstrainSelectedInstOperands,
     /* 673026 */     // GIR_Coverage, 5823,
     /* 673026 */     GIR_EraseRootFromParent_Done,
     /* 673027 */   // Label 8625: @673027
     /* 673027 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(673127), // Rule ID 5831 //
     /* 673032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673039 */     // MIs[0] offset
     /* 673039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673042 */     // MIs[0] auxiliary
     /* 673042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673045 */     // MIs[0] Operand 8
     /* 673045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673055 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673071 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673078 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 673099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673101 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673113 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673125 */     GIR_RootConstrainSelectedInstOperands,
     /* 673126 */     // GIR_Coverage, 5831,
     /* 673126 */     GIR_EraseRootFromParent_Done,
     /* 673127 */   // Label 8626: @673127
     /* 673127 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(673224), // Rule ID 5839 //
     /* 673132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673136 */     // MIs[0] offset
     /* 673136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673139 */     // MIs[0] auxiliary
     /* 673139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673142 */     // MIs[0] Operand 8
     /* 673142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673152 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9787:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673168 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673175 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 673196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673198 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673210 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673222 */     GIR_RootConstrainSelectedInstOperands,
     /* 673223 */     // GIR_Coverage, 5839,
     /* 673223 */     GIR_EraseRootFromParent_Done,
     /* 673224 */   // Label 8627: @673224
     /* 673224 */   GIM_Reject,
     /* 673225 */ // Label 8595: @673225
     /* 673225 */ GIM_Reject,
     /* 673226 */ // Label 8593: @673226
     /* 673226 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(674407),
     /* 673231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 673234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 673237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 673240 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 673243 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 673246 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(673314), // Rule ID 6032 //
     /* 673251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673254 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673264 */     // MIs[0] offset
     /* 673264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673267 */     // MIs[0] auxiliary
     /* 673267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673270 */     // MIs[0] Operand 8
     /* 673270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673288 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 673291 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673300 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673302 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673312 */     GIR_RootConstrainSelectedInstOperands,
     /* 673313 */     // GIR_Coverage, 6032,
     /* 673313 */     GIR_EraseRootFromParent_Done,
     /* 673314 */   // Label 8629: @673314
     /* 673314 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(673379), // Rule ID 6040 //
     /* 673319 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673329 */     // MIs[0] offset
     /* 673329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673332 */     // MIs[0] auxiliary
     /* 673332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673335 */     // MIs[0] Operand 8
     /* 673335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673353 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 673356 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673365 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673377 */     GIR_RootConstrainSelectedInstOperands,
     /* 673378 */     // GIR_Coverage, 6040,
     /* 673378 */     GIR_EraseRootFromParent_Done,
     /* 673379 */   // Label 8630: @673379
     /* 673379 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(673451), // Rule ID 6028 //
     /* 673384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673399 */     // MIs[0] offset
     /* 673399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673402 */     // MIs[0] auxiliary
     /* 673402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673405 */     // MIs[0] Operand 8
     /* 673405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673423 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 673426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673428 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673437 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673449 */     GIR_RootConstrainSelectedInstOperands,
     /* 673450 */     // GIR_Coverage, 6028,
     /* 673450 */     GIR_EraseRootFromParent_Done,
     /* 673451 */   // Label 8631: @673451
     /* 673451 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(673520), // Rule ID 6036 //
     /* 673456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673468 */     // MIs[0] offset
     /* 673468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673471 */     // MIs[0] auxiliary
     /* 673471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673474 */     // MIs[0] Operand 8
     /* 673474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673492 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 673495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673497 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673506 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673518 */     GIR_RootConstrainSelectedInstOperands,
     /* 673519 */     // GIR_Coverage, 6036,
     /* 673519 */     GIR_EraseRootFromParent_Done,
     /* 673520 */   // Label 8632: @673520
     /* 673520 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(673586), // Rule ID 6034 //
     /* 673525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673528 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673534 */     // MIs[0] offset
     /* 673534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673537 */     // MIs[0] auxiliary
     /* 673537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673540 */     // MIs[0] Operand 8
     /* 673540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673558 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN),
     /* 673561 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673563 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673572 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673584 */     GIR_RootConstrainSelectedInstOperands,
     /* 673585 */     // GIR_Coverage, 6034,
     /* 673585 */     GIR_EraseRootFromParent_Done,
     /* 673586 */   // Label 8633: @673586
     /* 673586 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(673649), // Rule ID 6042 //
     /* 673591 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673597 */     // MIs[0] offset
     /* 673597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673600 */     // MIs[0] auxiliary
     /* 673600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673603 */     // MIs[0] Operand 8
     /* 673603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673621 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN),
     /* 673624 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673626 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673635 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673647 */     GIR_RootConstrainSelectedInstOperands,
     /* 673648 */     // GIR_Coverage, 6042,
     /* 673648 */     GIR_EraseRootFromParent_Done,
     /* 673649 */   // Label 8634: @673649
     /* 673649 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(673719), // Rule ID 6030 //
     /* 673654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673665 */     // MIs[0] offset
     /* 673665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673668 */     // MIs[0] auxiliary
     /* 673668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673671 */     // MIs[0] Operand 8
     /* 673671 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673689 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN),
     /* 673692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673694 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673696 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673705 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673717 */     GIR_RootConstrainSelectedInstOperands,
     /* 673718 */     // GIR_Coverage, 6030,
     /* 673718 */     GIR_EraseRootFromParent_Done,
     /* 673719 */   // Label 8635: @673719
     /* 673719 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(673786), // Rule ID 6038 //
     /* 673724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673732 */     // MIs[0] offset
     /* 673732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673735 */     // MIs[0] auxiliary
     /* 673735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673738 */     // MIs[0] Operand 8
     /* 673738 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673756 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN),
     /* 673759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673761 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673763 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673772 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673784 */     GIR_RootConstrainSelectedInstOperands,
     /* 673785 */     // GIR_Coverage, 6038,
     /* 673785 */     GIR_EraseRootFromParent_Done,
     /* 673786 */   // Label 8636: @673786
     /* 673786 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(673844), // Rule ID 6033 //
     /* 673791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673794 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673800 */     // MIs[0] offset
     /* 673800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673803 */     // MIs[0] auxiliary
     /* 673803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673806 */     // MIs[0] Operand 8
     /* 673806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673816 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN),
     /* 673819 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673821 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673830 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673842 */     GIR_RootConstrainSelectedInstOperands,
     /* 673843 */     // GIR_Coverage, 6033,
     /* 673843 */     GIR_EraseRootFromParent_Done,
     /* 673844 */   // Label 8637: @673844
     /* 673844 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(673899), // Rule ID 6041 //
     /* 673849 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673855 */     // MIs[0] offset
     /* 673855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673858 */     // MIs[0] auxiliary
     /* 673858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673861 */     // MIs[0] Operand 8
     /* 673861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673871 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN),
     /* 673874 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673876 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673885 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673897 */     GIR_RootConstrainSelectedInstOperands,
     /* 673898 */     // GIR_Coverage, 6041,
     /* 673898 */     GIR_EraseRootFromParent_Done,
     /* 673899 */   // Label 8638: @673899
     /* 673899 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(673961), // Rule ID 6029 //
     /* 673904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673915 */     // MIs[0] offset
     /* 673915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673918 */     // MIs[0] auxiliary
     /* 673918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673921 */     // MIs[0] Operand 8
     /* 673921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673931 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN),
     /* 673934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673936 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673938 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673947 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673959 */     GIR_RootConstrainSelectedInstOperands,
     /* 673960 */     // GIR_Coverage, 6029,
     /* 673960 */     GIR_EraseRootFromParent_Done,
     /* 673961 */   // Label 8639: @673961
     /* 673961 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(674020), // Rule ID 6037 //
     /* 673966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673974 */     // MIs[0] offset
     /* 673974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673977 */     // MIs[0] auxiliary
     /* 673977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673980 */     // MIs[0] Operand 8
     /* 673980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673990 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN),
     /* 673993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673995 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673997 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674006 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674018 */     GIR_RootConstrainSelectedInstOperands,
     /* 674019 */     // GIR_Coverage, 6037,
     /* 674019 */     GIR_EraseRootFromParent_Done,
     /* 674020 */   // Label 8640: @674020
     /* 674020 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(674116), // Rule ID 6035 //
     /* 674025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674028 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674030 */     // MIs[0] offset
     /* 674030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674033 */     // MIs[0] auxiliary
     /* 674033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674036 */     // MIs[0] Operand 8
     /* 674036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674046 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674062 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674069 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN),
     /* 674090 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674102 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674114 */     GIR_RootConstrainSelectedInstOperands,
     /* 674115 */     // GIR_Coverage, 6035,
     /* 674115 */     GIR_EraseRootFromParent_Done,
     /* 674116 */   // Label 8641: @674116
     /* 674116 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(674209), // Rule ID 6043 //
     /* 674121 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674123 */     // MIs[0] offset
     /* 674123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674126 */     // MIs[0] auxiliary
     /* 674126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674129 */     // MIs[0] Operand 8
     /* 674129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674139 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674155 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674162 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN),
     /* 674183 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674195 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674207 */     GIR_RootConstrainSelectedInstOperands,
     /* 674208 */     // GIR_Coverage, 6043,
     /* 674208 */     GIR_EraseRootFromParent_Done,
     /* 674209 */   // Label 8642: @674209
     /* 674209 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(674309), // Rule ID 6031 //
     /* 674214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674221 */     // MIs[0] offset
     /* 674221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674224 */     // MIs[0] auxiliary
     /* 674224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674227 */     // MIs[0] Operand 8
     /* 674227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674237 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674253 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674260 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN),
     /* 674281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674283 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674295 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674307 */     GIR_RootConstrainSelectedInstOperands,
     /* 674308 */     // GIR_Coverage, 6031,
     /* 674308 */     GIR_EraseRootFromParent_Done,
     /* 674309 */   // Label 8643: @674309
     /* 674309 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(674406), // Rule ID 6039 //
     /* 674314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674318 */     // MIs[0] offset
     /* 674318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674321 */     // MIs[0] auxiliary
     /* 674321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674324 */     // MIs[0] Operand 8
     /* 674324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674334 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674350 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674357 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 674378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674380 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674392 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674404 */     GIR_RootConstrainSelectedInstOperands,
     /* 674405 */     // GIR_Coverage, 6039,
     /* 674405 */     GIR_EraseRootFromParent_Done,
     /* 674406 */   // Label 8644: @674406
     /* 674406 */   GIM_Reject,
     /* 674407 */ // Label 8628: @674407
     /* 674407 */ GIM_Reject,
     /* 674408 */ // Label 8594: @674408
     /* 674408 */ GIM_Reject,
     /* 674409 */ // Label 122: @674409
     /* 674409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8647*/ GIMT_Encode4(676792),
     /* 674420 */ /*GILLT_s32*//*Label 8645*/ GIMT_Encode4(674428),
     /* 674424 */ /*GILLT_s64*//*Label 8646*/ GIMT_Encode4(675610),
     /* 674428 */ // Label 8645: @674428
     /* 674428 */ GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(675609),
     /* 674433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 674436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 674439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 674442 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 674445 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 674448 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(674516), // Rule ID 5928 //
     /* 674453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674456 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674466 */     // MIs[0] offset
     /* 674466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674469 */     // MIs[0] auxiliary
     /* 674469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674472 */     // MIs[0] Operand 8
     /* 674472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674490 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 674493 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674502 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674514 */     GIR_RootConstrainSelectedInstOperands,
     /* 674515 */     // GIR_Coverage, 5928,
     /* 674515 */     GIR_EraseRootFromParent_Done,
     /* 674516 */   // Label 8649: @674516
     /* 674516 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(674581), // Rule ID 5936 //
     /* 674521 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674531 */     // MIs[0] offset
     /* 674531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674534 */     // MIs[0] auxiliary
     /* 674534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674537 */     // MIs[0] Operand 8
     /* 674537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674555 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 674558 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674567 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674579 */     GIR_RootConstrainSelectedInstOperands,
     /* 674580 */     // GIR_Coverage, 5936,
     /* 674580 */     GIR_EraseRootFromParent_Done,
     /* 674581 */   // Label 8650: @674581
     /* 674581 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(674653), // Rule ID 5924 //
     /* 674586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674601 */     // MIs[0] offset
     /* 674601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674604 */     // MIs[0] auxiliary
     /* 674604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674607 */     // MIs[0] Operand 8
     /* 674607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674625 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 674628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674630 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674639 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674651 */     GIR_RootConstrainSelectedInstOperands,
     /* 674652 */     // GIR_Coverage, 5924,
     /* 674652 */     GIR_EraseRootFromParent_Done,
     /* 674653 */   // Label 8651: @674653
     /* 674653 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(674722), // Rule ID 5932 //
     /* 674658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674670 */     // MIs[0] offset
     /* 674670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674673 */     // MIs[0] auxiliary
     /* 674673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674676 */     // MIs[0] Operand 8
     /* 674676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674694 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 674697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674699 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674708 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674720 */     GIR_RootConstrainSelectedInstOperands,
     /* 674721 */     // GIR_Coverage, 5932,
     /* 674721 */     GIR_EraseRootFromParent_Done,
     /* 674722 */   // Label 8652: @674722
     /* 674722 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(674788), // Rule ID 5930 //
     /* 674727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674730 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674736 */     // MIs[0] offset
     /* 674736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674739 */     // MIs[0] auxiliary
     /* 674739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674742 */     // MIs[0] Operand 8
     /* 674742 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674760 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN),
     /* 674763 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674765 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674774 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674776 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674786 */     GIR_RootConstrainSelectedInstOperands,
     /* 674787 */     // GIR_Coverage, 5930,
     /* 674787 */     GIR_EraseRootFromParent_Done,
     /* 674788 */   // Label 8653: @674788
     /* 674788 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(674851), // Rule ID 5938 //
     /* 674793 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674799 */     // MIs[0] offset
     /* 674799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674802 */     // MIs[0] auxiliary
     /* 674802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674805 */     // MIs[0] Operand 8
     /* 674805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674823 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN),
     /* 674826 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674828 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674837 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674849 */     GIR_RootConstrainSelectedInstOperands,
     /* 674850 */     // GIR_Coverage, 5938,
     /* 674850 */     GIR_EraseRootFromParent_Done,
     /* 674851 */   // Label 8654: @674851
     /* 674851 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(674921), // Rule ID 5926 //
     /* 674856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674867 */     // MIs[0] offset
     /* 674867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674870 */     // MIs[0] auxiliary
     /* 674870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674873 */     // MIs[0] Operand 8
     /* 674873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674891 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN_RTN),
     /* 674894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674896 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674898 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674907 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674919 */     GIR_RootConstrainSelectedInstOperands,
     /* 674920 */     // GIR_Coverage, 5926,
     /* 674920 */     GIR_EraseRootFromParent_Done,
     /* 674921 */   // Label 8655: @674921
     /* 674921 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(674988), // Rule ID 5934 //
     /* 674926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674934 */     // MIs[0] offset
     /* 674934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674937 */     // MIs[0] auxiliary
     /* 674937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674940 */     // MIs[0] Operand 8
     /* 674940 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674958 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN),
     /* 674961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674963 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674965 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674974 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674986 */     GIR_RootConstrainSelectedInstOperands,
     /* 674987 */     // GIR_Coverage, 5934,
     /* 674987 */     GIR_EraseRootFromParent_Done,
     /* 674988 */   // Label 8656: @674988
     /* 674988 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(675046), // Rule ID 5929 //
     /* 674993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674996 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675002 */     // MIs[0] offset
     /* 675002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675005 */     // MIs[0] auxiliary
     /* 675005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675008 */     // MIs[0] Operand 8
     /* 675008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675018 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN),
     /* 675021 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675023 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675032 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675044 */     GIR_RootConstrainSelectedInstOperands,
     /* 675045 */     // GIR_Coverage, 5929,
     /* 675045 */     GIR_EraseRootFromParent_Done,
     /* 675046 */   // Label 8657: @675046
     /* 675046 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(675101), // Rule ID 5937 //
     /* 675051 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675057 */     // MIs[0] offset
     /* 675057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675060 */     // MIs[0] auxiliary
     /* 675060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675063 */     // MIs[0] Operand 8
     /* 675063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675073 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN),
     /* 675076 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675078 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675087 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675099 */     GIR_RootConstrainSelectedInstOperands,
     /* 675100 */     // GIR_Coverage, 5937,
     /* 675100 */     GIR_EraseRootFromParent_Done,
     /* 675101 */   // Label 8658: @675101
     /* 675101 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(675163), // Rule ID 5925 //
     /* 675106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675117 */     // MIs[0] offset
     /* 675117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675120 */     // MIs[0] auxiliary
     /* 675120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675123 */     // MIs[0] Operand 8
     /* 675123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675133 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN_RTN),
     /* 675136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675138 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675140 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675149 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675161 */     GIR_RootConstrainSelectedInstOperands,
     /* 675162 */     // GIR_Coverage, 5925,
     /* 675162 */     GIR_EraseRootFromParent_Done,
     /* 675163 */   // Label 8659: @675163
     /* 675163 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(675222), // Rule ID 5933 //
     /* 675168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675176 */     // MIs[0] offset
     /* 675176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675179 */     // MIs[0] auxiliary
     /* 675179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675182 */     // MIs[0] Operand 8
     /* 675182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675192 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN),
     /* 675195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675197 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675199 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675208 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675220 */     GIR_RootConstrainSelectedInstOperands,
     /* 675221 */     // GIR_Coverage, 5933,
     /* 675221 */     GIR_EraseRootFromParent_Done,
     /* 675222 */   // Label 8660: @675222
     /* 675222 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(675318), // Rule ID 5931 //
     /* 675227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675230 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675232 */     // MIs[0] offset
     /* 675232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675235 */     // MIs[0] auxiliary
     /* 675235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675238 */     // MIs[0] Operand 8
     /* 675238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675248 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675264 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675271 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN),
     /* 675292 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675304 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675316 */     GIR_RootConstrainSelectedInstOperands,
     /* 675317 */     // GIR_Coverage, 5931,
     /* 675317 */     GIR_EraseRootFromParent_Done,
     /* 675318 */   // Label 8661: @675318
     /* 675318 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(675411), // Rule ID 5939 //
     /* 675323 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675325 */     // MIs[0] offset
     /* 675325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675328 */     // MIs[0] auxiliary
     /* 675328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675331 */     // MIs[0] Operand 8
     /* 675331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675341 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675357 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675364 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN),
     /* 675385 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675397 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675409 */     GIR_RootConstrainSelectedInstOperands,
     /* 675410 */     // GIR_Coverage, 5939,
     /* 675410 */     GIR_EraseRootFromParent_Done,
     /* 675411 */   // Label 8662: @675411
     /* 675411 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(675511), // Rule ID 5927 //
     /* 675416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675423 */     // MIs[0] offset
     /* 675423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675426 */     // MIs[0] auxiliary
     /* 675426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675429 */     // MIs[0] Operand 8
     /* 675429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675439 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675455 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675462 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN_RTN),
     /* 675483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675485 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675497 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675509 */     GIR_RootConstrainSelectedInstOperands,
     /* 675510 */     // GIR_Coverage, 5927,
     /* 675510 */     GIR_EraseRootFromParent_Done,
     /* 675511 */   // Label 8663: @675511
     /* 675511 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(675608), // Rule ID 5935 //
     /* 675516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675520 */     // MIs[0] offset
     /* 675520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675523 */     // MIs[0] auxiliary
     /* 675523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675526 */     // MIs[0] Operand 8
     /* 675526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675536 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675552 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675559 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN),
     /* 675580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675582 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675594 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675606 */     GIR_RootConstrainSelectedInstOperands,
     /* 675607 */     // GIR_Coverage, 5935,
     /* 675607 */     GIR_EraseRootFromParent_Done,
     /* 675608 */   // Label 8664: @675608
     /* 675608 */   GIM_Reject,
     /* 675609 */ // Label 8648: @675609
     /* 675609 */ GIM_Reject,
     /* 675610 */ // Label 8646: @675610
     /* 675610 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(676791),
     /* 675615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 675618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 675621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 675624 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 675627 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 675630 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(675698), // Rule ID 6128 //
     /* 675635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675638 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675648 */     // MIs[0] offset
     /* 675648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675651 */     // MIs[0] auxiliary
     /* 675651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675654 */     // MIs[0] Operand 8
     /* 675654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675672 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 675675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675684 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675696 */     GIR_RootConstrainSelectedInstOperands,
     /* 675697 */     // GIR_Coverage, 6128,
     /* 675697 */     GIR_EraseRootFromParent_Done,
     /* 675698 */   // Label 8666: @675698
     /* 675698 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(675763), // Rule ID 6136 //
     /* 675703 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675713 */     // MIs[0] offset
     /* 675713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675716 */     // MIs[0] auxiliary
     /* 675716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675719 */     // MIs[0] Operand 8
     /* 675719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675737 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 675740 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675749 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675751 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675761 */     GIR_RootConstrainSelectedInstOperands,
     /* 675762 */     // GIR_Coverage, 6136,
     /* 675762 */     GIR_EraseRootFromParent_Done,
     /* 675763 */   // Label 8667: @675763
     /* 675763 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(675835), // Rule ID 6124 //
     /* 675768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675783 */     // MIs[0] offset
     /* 675783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675786 */     // MIs[0] auxiliary
     /* 675786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675789 */     // MIs[0] Operand 8
     /* 675789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675807 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 675810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675812 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675821 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675833 */     GIR_RootConstrainSelectedInstOperands,
     /* 675834 */     // GIR_Coverage, 6124,
     /* 675834 */     GIR_EraseRootFromParent_Done,
     /* 675835 */   // Label 8668: @675835
     /* 675835 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(675904), // Rule ID 6132 //
     /* 675840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675852 */     // MIs[0] offset
     /* 675852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675855 */     // MIs[0] auxiliary
     /* 675855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675858 */     // MIs[0] Operand 8
     /* 675858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675876 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 675879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675881 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675890 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675902 */     GIR_RootConstrainSelectedInstOperands,
     /* 675903 */     // GIR_Coverage, 6132,
     /* 675903 */     GIR_EraseRootFromParent_Done,
     /* 675904 */   // Label 8669: @675904
     /* 675904 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(675970), // Rule ID 6130 //
     /* 675909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675912 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675918 */     // MIs[0] offset
     /* 675918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675921 */     // MIs[0] auxiliary
     /* 675921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675924 */     // MIs[0] Operand 8
     /* 675924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675942 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN),
     /* 675945 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675947 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675956 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675968 */     GIR_RootConstrainSelectedInstOperands,
     /* 675969 */     // GIR_Coverage, 6130,
     /* 675969 */     GIR_EraseRootFromParent_Done,
     /* 675970 */   // Label 8670: @675970
     /* 675970 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(676033), // Rule ID 6138 //
     /* 675975 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675981 */     // MIs[0] offset
     /* 675981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675984 */     // MIs[0] auxiliary
     /* 675984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675987 */     // MIs[0] Operand 8
     /* 675987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676005 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN),
     /* 676008 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676010 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676019 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676031 */     GIR_RootConstrainSelectedInstOperands,
     /* 676032 */     // GIR_Coverage, 6138,
     /* 676032 */     GIR_EraseRootFromParent_Done,
     /* 676033 */   // Label 8671: @676033
     /* 676033 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(676103), // Rule ID 6126 //
     /* 676038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676049 */     // MIs[0] offset
     /* 676049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676052 */     // MIs[0] auxiliary
     /* 676052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676055 */     // MIs[0] Operand 8
     /* 676055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676073 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN),
     /* 676076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676078 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676080 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676089 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676101 */     GIR_RootConstrainSelectedInstOperands,
     /* 676102 */     // GIR_Coverage, 6126,
     /* 676102 */     GIR_EraseRootFromParent_Done,
     /* 676103 */   // Label 8672: @676103
     /* 676103 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(676170), // Rule ID 6134 //
     /* 676108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676116 */     // MIs[0] offset
     /* 676116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676119 */     // MIs[0] auxiliary
     /* 676119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676122 */     // MIs[0] Operand 8
     /* 676122 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676140 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN),
     /* 676143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676145 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676147 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676156 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676168 */     GIR_RootConstrainSelectedInstOperands,
     /* 676169 */     // GIR_Coverage, 6134,
     /* 676169 */     GIR_EraseRootFromParent_Done,
     /* 676170 */   // Label 8673: @676170
     /* 676170 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(676228), // Rule ID 6129 //
     /* 676175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676178 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676184 */     // MIs[0] offset
     /* 676184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676187 */     // MIs[0] auxiliary
     /* 676187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676190 */     // MIs[0] Operand 8
     /* 676190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676200 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN),
     /* 676203 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676205 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676214 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676226 */     GIR_RootConstrainSelectedInstOperands,
     /* 676227 */     // GIR_Coverage, 6129,
     /* 676227 */     GIR_EraseRootFromParent_Done,
     /* 676228 */   // Label 8674: @676228
     /* 676228 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(676283), // Rule ID 6137 //
     /* 676233 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676239 */     // MIs[0] offset
     /* 676239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676242 */     // MIs[0] auxiliary
     /* 676242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676245 */     // MIs[0] Operand 8
     /* 676245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676255 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN),
     /* 676258 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676260 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676269 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676281 */     GIR_RootConstrainSelectedInstOperands,
     /* 676282 */     // GIR_Coverage, 6137,
     /* 676282 */     GIR_EraseRootFromParent_Done,
     /* 676283 */   // Label 8675: @676283
     /* 676283 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(676345), // Rule ID 6125 //
     /* 676288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676299 */     // MIs[0] offset
     /* 676299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676302 */     // MIs[0] auxiliary
     /* 676302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676305 */     // MIs[0] Operand 8
     /* 676305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676315 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN),
     /* 676318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676320 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676322 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676331 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676343 */     GIR_RootConstrainSelectedInstOperands,
     /* 676344 */     // GIR_Coverage, 6125,
     /* 676344 */     GIR_EraseRootFromParent_Done,
     /* 676345 */   // Label 8676: @676345
     /* 676345 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(676404), // Rule ID 6133 //
     /* 676350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676358 */     // MIs[0] offset
     /* 676358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676361 */     // MIs[0] auxiliary
     /* 676361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676364 */     // MIs[0] Operand 8
     /* 676364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676374 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN),
     /* 676377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676379 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676381 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676390 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676402 */     GIR_RootConstrainSelectedInstOperands,
     /* 676403 */     // GIR_Coverage, 6133,
     /* 676403 */     GIR_EraseRootFromParent_Done,
     /* 676404 */   // Label 8677: @676404
     /* 676404 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(676500), // Rule ID 6131 //
     /* 676409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676412 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676414 */     // MIs[0] offset
     /* 676414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676417 */     // MIs[0] auxiliary
     /* 676417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676420 */     // MIs[0] Operand 8
     /* 676420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676430 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676446 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676453 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN),
     /* 676474 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676486 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676498 */     GIR_RootConstrainSelectedInstOperands,
     /* 676499 */     // GIR_Coverage, 6131,
     /* 676499 */     GIR_EraseRootFromParent_Done,
     /* 676500 */   // Label 8678: @676500
     /* 676500 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(676593), // Rule ID 6139 //
     /* 676505 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676507 */     // MIs[0] offset
     /* 676507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676510 */     // MIs[0] auxiliary
     /* 676510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676513 */     // MIs[0] Operand 8
     /* 676513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676523 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676539 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676546 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN),
     /* 676567 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676579 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676591 */     GIR_RootConstrainSelectedInstOperands,
     /* 676592 */     // GIR_Coverage, 6139,
     /* 676592 */     GIR_EraseRootFromParent_Done,
     /* 676593 */   // Label 8679: @676593
     /* 676593 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(676693), // Rule ID 6127 //
     /* 676598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676605 */     // MIs[0] offset
     /* 676605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676608 */     // MIs[0] auxiliary
     /* 676608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676611 */     // MIs[0] Operand 8
     /* 676611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676621 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676637 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676644 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN),
     /* 676665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676667 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676679 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676691 */     GIR_RootConstrainSelectedInstOperands,
     /* 676692 */     // GIR_Coverage, 6127,
     /* 676692 */     GIR_EraseRootFromParent_Done,
     /* 676693 */   // Label 8680: @676693
     /* 676693 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(676790), // Rule ID 6135 //
     /* 676698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676702 */     // MIs[0] offset
     /* 676702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676705 */     // MIs[0] auxiliary
     /* 676705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676708 */     // MIs[0] Operand 8
     /* 676708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676718 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676734 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676741 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 676762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676764 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676776 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676788 */     GIR_RootConstrainSelectedInstOperands,
     /* 676789 */     // GIR_Coverage, 6135,
     /* 676789 */     GIR_EraseRootFromParent_Done,
     /* 676790 */   // Label 8681: @676790
     /* 676790 */   GIM_Reject,
     /* 676791 */ // Label 8665: @676791
     /* 676791 */ GIM_Reject,
     /* 676792 */ // Label 8647: @676792
     /* 676792 */ GIM_Reject,
     /* 676793 */ // Label 123: @676793
     /* 676793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8684*/ GIMT_Encode4(679176),
     /* 676804 */ /*GILLT_s32*//*Label 8682*/ GIMT_Encode4(676812),
     /* 676808 */ /*GILLT_s64*//*Label 8683*/ GIMT_Encode4(677994),
     /* 676812 */ // Label 8682: @676812
     /* 676812 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(677993),
     /* 676817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 676820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 676823 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 676826 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 676829 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 676832 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(676900), // Rule ID 5896 //
     /* 676837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676840 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676850 */     // MIs[0] offset
     /* 676850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676853 */     // MIs[0] auxiliary
     /* 676853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676856 */     // MIs[0] Operand 8
     /* 676856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676874 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 676877 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676886 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676898 */     GIR_RootConstrainSelectedInstOperands,
     /* 676899 */     // GIR_Coverage, 5896,
     /* 676899 */     GIR_EraseRootFromParent_Done,
     /* 676900 */   // Label 8686: @676900
     /* 676900 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(676965), // Rule ID 5904 //
     /* 676905 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676915 */     // MIs[0] offset
     /* 676915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676918 */     // MIs[0] auxiliary
     /* 676918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676921 */     // MIs[0] Operand 8
     /* 676921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676939 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 676942 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676951 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676963 */     GIR_RootConstrainSelectedInstOperands,
     /* 676964 */     // GIR_Coverage, 5904,
     /* 676964 */     GIR_EraseRootFromParent_Done,
     /* 676965 */   // Label 8687: @676965
     /* 676965 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(677037), // Rule ID 5892 //
     /* 676970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676985 */     // MIs[0] offset
     /* 676985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676988 */     // MIs[0] auxiliary
     /* 676988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676991 */     // MIs[0] Operand 8
     /* 676991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677009 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 677012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677014 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677023 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677035 */     GIR_RootConstrainSelectedInstOperands,
     /* 677036 */     // GIR_Coverage, 5892,
     /* 677036 */     GIR_EraseRootFromParent_Done,
     /* 677037 */   // Label 8688: @677037
     /* 677037 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(677106), // Rule ID 5900 //
     /* 677042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677054 */     // MIs[0] offset
     /* 677054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677057 */     // MIs[0] auxiliary
     /* 677057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677060 */     // MIs[0] Operand 8
     /* 677060 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677078 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 677081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677083 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677092 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677104 */     GIR_RootConstrainSelectedInstOperands,
     /* 677105 */     // GIR_Coverage, 5900,
     /* 677105 */     GIR_EraseRootFromParent_Done,
     /* 677106 */   // Label 8689: @677106
     /* 677106 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(677172), // Rule ID 5898 //
     /* 677111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677114 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677120 */     // MIs[0] offset
     /* 677120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677123 */     // MIs[0] auxiliary
     /* 677123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677126 */     // MIs[0] Operand 8
     /* 677126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677144 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN),
     /* 677147 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677149 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677158 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677170 */     GIR_RootConstrainSelectedInstOperands,
     /* 677171 */     // GIR_Coverage, 5898,
     /* 677171 */     GIR_EraseRootFromParent_Done,
     /* 677172 */   // Label 8690: @677172
     /* 677172 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(677235), // Rule ID 5906 //
     /* 677177 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677183 */     // MIs[0] offset
     /* 677183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677186 */     // MIs[0] auxiliary
     /* 677186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677189 */     // MIs[0] Operand 8
     /* 677189 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677207 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN),
     /* 677210 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677212 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677221 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677233 */     GIR_RootConstrainSelectedInstOperands,
     /* 677234 */     // GIR_Coverage, 5906,
     /* 677234 */     GIR_EraseRootFromParent_Done,
     /* 677235 */   // Label 8691: @677235
     /* 677235 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(677305), // Rule ID 5894 //
     /* 677240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677251 */     // MIs[0] offset
     /* 677251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677254 */     // MIs[0] auxiliary
     /* 677254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677257 */     // MIs[0] Operand 8
     /* 677257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677275 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN_RTN),
     /* 677278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677280 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677282 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677291 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677303 */     GIR_RootConstrainSelectedInstOperands,
     /* 677304 */     // GIR_Coverage, 5894,
     /* 677304 */     GIR_EraseRootFromParent_Done,
     /* 677305 */   // Label 8692: @677305
     /* 677305 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(677372), // Rule ID 5902 //
     /* 677310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677318 */     // MIs[0] offset
     /* 677318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677321 */     // MIs[0] auxiliary
     /* 677321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677324 */     // MIs[0] Operand 8
     /* 677324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677342 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN),
     /* 677345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677347 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677349 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677358 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677370 */     GIR_RootConstrainSelectedInstOperands,
     /* 677371 */     // GIR_Coverage, 5902,
     /* 677371 */     GIR_EraseRootFromParent_Done,
     /* 677372 */   // Label 8693: @677372
     /* 677372 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(677430), // Rule ID 5897 //
     /* 677377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677380 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677386 */     // MIs[0] offset
     /* 677386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677389 */     // MIs[0] auxiliary
     /* 677389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677392 */     // MIs[0] Operand 8
     /* 677392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677402 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN),
     /* 677405 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677407 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677416 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677428 */     GIR_RootConstrainSelectedInstOperands,
     /* 677429 */     // GIR_Coverage, 5897,
     /* 677429 */     GIR_EraseRootFromParent_Done,
     /* 677430 */   // Label 8694: @677430
     /* 677430 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(677485), // Rule ID 5905 //
     /* 677435 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677441 */     // MIs[0] offset
     /* 677441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677444 */     // MIs[0] auxiliary
     /* 677444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677447 */     // MIs[0] Operand 8
     /* 677447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677457 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN),
     /* 677460 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677462 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677471 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677483 */     GIR_RootConstrainSelectedInstOperands,
     /* 677484 */     // GIR_Coverage, 5905,
     /* 677484 */     GIR_EraseRootFromParent_Done,
     /* 677485 */   // Label 8695: @677485
     /* 677485 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(677547), // Rule ID 5893 //
     /* 677490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677501 */     // MIs[0] offset
     /* 677501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677504 */     // MIs[0] auxiliary
     /* 677504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677507 */     // MIs[0] Operand 8
     /* 677507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677517 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN_RTN),
     /* 677520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677522 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677524 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677533 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677545 */     GIR_RootConstrainSelectedInstOperands,
     /* 677546 */     // GIR_Coverage, 5893,
     /* 677546 */     GIR_EraseRootFromParent_Done,
     /* 677547 */   // Label 8696: @677547
     /* 677547 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(677606), // Rule ID 5901 //
     /* 677552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677560 */     // MIs[0] offset
     /* 677560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677563 */     // MIs[0] auxiliary
     /* 677563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677566 */     // MIs[0] Operand 8
     /* 677566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677576 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN),
     /* 677579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677581 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677583 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677592 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677594 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677604 */     GIR_RootConstrainSelectedInstOperands,
     /* 677605 */     // GIR_Coverage, 5901,
     /* 677605 */     GIR_EraseRootFromParent_Done,
     /* 677606 */   // Label 8697: @677606
     /* 677606 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(677702), // Rule ID 5899 //
     /* 677611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677614 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677616 */     // MIs[0] offset
     /* 677616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677619 */     // MIs[0] auxiliary
     /* 677619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677622 */     // MIs[0] Operand 8
     /* 677622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677632 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677648 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN),
     /* 677676 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677688 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677700 */     GIR_RootConstrainSelectedInstOperands,
     /* 677701 */     // GIR_Coverage, 5899,
     /* 677701 */     GIR_EraseRootFromParent_Done,
     /* 677702 */   // Label 8698: @677702
     /* 677702 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(677795), // Rule ID 5907 //
     /* 677707 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677709 */     // MIs[0] offset
     /* 677709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677712 */     // MIs[0] auxiliary
     /* 677712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677715 */     // MIs[0] Operand 8
     /* 677715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677725 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677741 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677748 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN),
     /* 677769 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677781 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677793 */     GIR_RootConstrainSelectedInstOperands,
     /* 677794 */     // GIR_Coverage, 5907,
     /* 677794 */     GIR_EraseRootFromParent_Done,
     /* 677795 */   // Label 8699: @677795
     /* 677795 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(677895), // Rule ID 5895 //
     /* 677800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677807 */     // MIs[0] offset
     /* 677807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677810 */     // MIs[0] auxiliary
     /* 677810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677813 */     // MIs[0] Operand 8
     /* 677813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677823 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677839 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677846 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN_RTN),
     /* 677867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677869 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677881 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677893 */     GIR_RootConstrainSelectedInstOperands,
     /* 677894 */     // GIR_Coverage, 5895,
     /* 677894 */     GIR_EraseRootFromParent_Done,
     /* 677895 */   // Label 8700: @677895
     /* 677895 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(677992), // Rule ID 5903 //
     /* 677900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677904 */     // MIs[0] offset
     /* 677904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677907 */     // MIs[0] auxiliary
     /* 677907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677910 */     // MIs[0] Operand 8
     /* 677910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677920 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677936 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN),
     /* 677964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677966 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677978 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677990 */     GIR_RootConstrainSelectedInstOperands,
     /* 677991 */     // GIR_Coverage, 5903,
     /* 677991 */     GIR_EraseRootFromParent_Done,
     /* 677992 */   // Label 8701: @677992
     /* 677992 */   GIM_Reject,
     /* 677993 */ // Label 8685: @677993
     /* 677993 */ GIM_Reject,
     /* 677994 */ // Label 8683: @677994
     /* 677994 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(679175),
     /* 677999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 678002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 678005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 678008 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 678011 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 678014 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(678082), // Rule ID 6096 //
     /* 678019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678022 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678032 */     // MIs[0] offset
     /* 678032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678035 */     // MIs[0] auxiliary
     /* 678035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678038 */     // MIs[0] Operand 8
     /* 678038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678056 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 678059 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678068 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678080 */     GIR_RootConstrainSelectedInstOperands,
     /* 678081 */     // GIR_Coverage, 6096,
     /* 678081 */     GIR_EraseRootFromParent_Done,
     /* 678082 */   // Label 8703: @678082
     /* 678082 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(678147), // Rule ID 6104 //
     /* 678087 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678097 */     // MIs[0] offset
     /* 678097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678100 */     // MIs[0] auxiliary
     /* 678100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678103 */     // MIs[0] Operand 8
     /* 678103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678121 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 678124 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678133 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678145 */     GIR_RootConstrainSelectedInstOperands,
     /* 678146 */     // GIR_Coverage, 6104,
     /* 678146 */     GIR_EraseRootFromParent_Done,
     /* 678147 */   // Label 8704: @678147
     /* 678147 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(678219), // Rule ID 6092 //
     /* 678152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678167 */     // MIs[0] offset
     /* 678167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678170 */     // MIs[0] auxiliary
     /* 678170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678173 */     // MIs[0] Operand 8
     /* 678173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678191 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 678194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678196 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678205 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678217 */     GIR_RootConstrainSelectedInstOperands,
     /* 678218 */     // GIR_Coverage, 6092,
     /* 678218 */     GIR_EraseRootFromParent_Done,
     /* 678219 */   // Label 8705: @678219
     /* 678219 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(678288), // Rule ID 6100 //
     /* 678224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678236 */     // MIs[0] offset
     /* 678236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678239 */     // MIs[0] auxiliary
     /* 678239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678242 */     // MIs[0] Operand 8
     /* 678242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678260 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 678263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678265 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678274 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678286 */     GIR_RootConstrainSelectedInstOperands,
     /* 678287 */     // GIR_Coverage, 6100,
     /* 678287 */     GIR_EraseRootFromParent_Done,
     /* 678288 */   // Label 8706: @678288
     /* 678288 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(678354), // Rule ID 6098 //
     /* 678293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678296 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678302 */     // MIs[0] offset
     /* 678302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678305 */     // MIs[0] auxiliary
     /* 678305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678308 */     // MIs[0] Operand 8
     /* 678308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678326 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN),
     /* 678329 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678331 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678340 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678352 */     GIR_RootConstrainSelectedInstOperands,
     /* 678353 */     // GIR_Coverage, 6098,
     /* 678353 */     GIR_EraseRootFromParent_Done,
     /* 678354 */   // Label 8707: @678354
     /* 678354 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(678417), // Rule ID 6106 //
     /* 678359 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678365 */     // MIs[0] offset
     /* 678365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678368 */     // MIs[0] auxiliary
     /* 678368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678371 */     // MIs[0] Operand 8
     /* 678371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678389 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN),
     /* 678392 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678394 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678415 */     GIR_RootConstrainSelectedInstOperands,
     /* 678416 */     // GIR_Coverage, 6106,
     /* 678416 */     GIR_EraseRootFromParent_Done,
     /* 678417 */   // Label 8708: @678417
     /* 678417 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(678487), // Rule ID 6094 //
     /* 678422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678433 */     // MIs[0] offset
     /* 678433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678436 */     // MIs[0] auxiliary
     /* 678436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678439 */     // MIs[0] Operand 8
     /* 678439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678457 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN),
     /* 678460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678462 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678464 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678473 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678485 */     GIR_RootConstrainSelectedInstOperands,
     /* 678486 */     // GIR_Coverage, 6094,
     /* 678486 */     GIR_EraseRootFromParent_Done,
     /* 678487 */   // Label 8709: @678487
     /* 678487 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(678554), // Rule ID 6102 //
     /* 678492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678500 */     // MIs[0] offset
     /* 678500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678503 */     // MIs[0] auxiliary
     /* 678503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678506 */     // MIs[0] Operand 8
     /* 678506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678524 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN),
     /* 678527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678529 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678531 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678540 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678552 */     GIR_RootConstrainSelectedInstOperands,
     /* 678553 */     // GIR_Coverage, 6102,
     /* 678553 */     GIR_EraseRootFromParent_Done,
     /* 678554 */   // Label 8710: @678554
     /* 678554 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(678612), // Rule ID 6097 //
     /* 678559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678562 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678568 */     // MIs[0] offset
     /* 678568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678571 */     // MIs[0] auxiliary
     /* 678571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678574 */     // MIs[0] Operand 8
     /* 678574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678584 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN),
     /* 678587 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678589 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678598 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678610 */     GIR_RootConstrainSelectedInstOperands,
     /* 678611 */     // GIR_Coverage, 6097,
     /* 678611 */     GIR_EraseRootFromParent_Done,
     /* 678612 */   // Label 8711: @678612
     /* 678612 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(678667), // Rule ID 6105 //
     /* 678617 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678623 */     // MIs[0] offset
     /* 678623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678626 */     // MIs[0] auxiliary
     /* 678626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678629 */     // MIs[0] Operand 8
     /* 678629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678639 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN),
     /* 678642 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678644 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678653 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678665 */     GIR_RootConstrainSelectedInstOperands,
     /* 678666 */     // GIR_Coverage, 6105,
     /* 678666 */     GIR_EraseRootFromParent_Done,
     /* 678667 */   // Label 8712: @678667
     /* 678667 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(678729), // Rule ID 6093 //
     /* 678672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678683 */     // MIs[0] offset
     /* 678683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678686 */     // MIs[0] auxiliary
     /* 678686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678689 */     // MIs[0] Operand 8
     /* 678689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678699 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN),
     /* 678702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678704 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678706 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678715 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678727 */     GIR_RootConstrainSelectedInstOperands,
     /* 678728 */     // GIR_Coverage, 6093,
     /* 678728 */     GIR_EraseRootFromParent_Done,
     /* 678729 */   // Label 8713: @678729
     /* 678729 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(678788), // Rule ID 6101 //
     /* 678734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678742 */     // MIs[0] offset
     /* 678742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678745 */     // MIs[0] auxiliary
     /* 678745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678748 */     // MIs[0] Operand 8
     /* 678748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678758 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN),
     /* 678761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678763 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678765 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678774 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678776 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678786 */     GIR_RootConstrainSelectedInstOperands,
     /* 678787 */     // GIR_Coverage, 6101,
     /* 678787 */     GIR_EraseRootFromParent_Done,
     /* 678788 */   // Label 8714: @678788
     /* 678788 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(678884), // Rule ID 6099 //
     /* 678793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678796 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678798 */     // MIs[0] offset
     /* 678798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678801 */     // MIs[0] auxiliary
     /* 678801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678804 */     // MIs[0] Operand 8
     /* 678804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678814 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678830 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678837 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN),
     /* 678858 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678870 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678882 */     GIR_RootConstrainSelectedInstOperands,
     /* 678883 */     // GIR_Coverage, 6099,
     /* 678883 */     GIR_EraseRootFromParent_Done,
     /* 678884 */   // Label 8715: @678884
     /* 678884 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(678977), // Rule ID 6107 //
     /* 678889 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678891 */     // MIs[0] offset
     /* 678891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678894 */     // MIs[0] auxiliary
     /* 678894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678897 */     // MIs[0] Operand 8
     /* 678897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678907 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678923 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678930 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN),
     /* 678951 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678963 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678975 */     GIR_RootConstrainSelectedInstOperands,
     /* 678976 */     // GIR_Coverage, 6107,
     /* 678976 */     GIR_EraseRootFromParent_Done,
     /* 678977 */   // Label 8716: @678977
     /* 678977 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(679077), // Rule ID 6095 //
     /* 678982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678989 */     // MIs[0] offset
     /* 678989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678992 */     // MIs[0] auxiliary
     /* 678992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678995 */     // MIs[0] Operand 8
     /* 678995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679005 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679021 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679028 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN),
     /* 679049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679063 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679075 */     GIR_RootConstrainSelectedInstOperands,
     /* 679076 */     // GIR_Coverage, 6095,
     /* 679076 */     GIR_EraseRootFromParent_Done,
     /* 679077 */   // Label 8717: @679077
     /* 679077 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(679174), // Rule ID 6103 //
     /* 679082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 679086 */     // MIs[0] offset
     /* 679086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679089 */     // MIs[0] auxiliary
     /* 679089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679092 */     // MIs[0] Operand 8
     /* 679092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679102 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 679146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679148 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679160 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679172 */     GIR_RootConstrainSelectedInstOperands,
     /* 679173 */     // GIR_Coverage, 6103,
     /* 679173 */     GIR_EraseRootFromParent_Done,
     /* 679174 */   // Label 8718: @679174
     /* 679174 */   GIM_Reject,
     /* 679175 */ // Label 8702: @679175
     /* 679175 */ GIM_Reject,
     /* 679176 */ // Label 8684: @679176
     /* 679176 */ GIM_Reject,
     /* 679177 */ // Label 124: @679177
     /* 679177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8721*/ GIMT_Encode4(681560),
     /* 679188 */ /*GILLT_s32*//*Label 8719*/ GIMT_Encode4(679196),
     /* 679192 */ /*GILLT_s64*//*Label 8720*/ GIMT_Encode4(680378),
     /* 679196 */ // Label 8719: @679196
     /* 679196 */ GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(680377),
     /* 679201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 679204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 679207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 679210 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 679213 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 679216 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(679284), // Rule ID 5976 //
     /* 679221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679224 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679234 */     // MIs[0] offset
     /* 679234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679237 */     // MIs[0] auxiliary
     /* 679237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679240 */     // MIs[0] Operand 8
     /* 679240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679258 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 679261 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679270 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679282 */     GIR_RootConstrainSelectedInstOperands,
     /* 679283 */     // GIR_Coverage, 5976,
     /* 679283 */     GIR_EraseRootFromParent_Done,
     /* 679284 */   // Label 8723: @679284
     /* 679284 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(679349), // Rule ID 5984 //
     /* 679289 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679299 */     // MIs[0] offset
     /* 679299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679302 */     // MIs[0] auxiliary
     /* 679302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679305 */     // MIs[0] Operand 8
     /* 679305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679323 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 679326 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679335 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679347 */     GIR_RootConstrainSelectedInstOperands,
     /* 679348 */     // GIR_Coverage, 5984,
     /* 679348 */     GIR_EraseRootFromParent_Done,
     /* 679349 */   // Label 8724: @679349
     /* 679349 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(679421), // Rule ID 5972 //
     /* 679354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679369 */     // MIs[0] offset
     /* 679369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679372 */     // MIs[0] auxiliary
     /* 679372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679375 */     // MIs[0] Operand 8
     /* 679375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679393 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 679396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679398 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679407 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679419 */     GIR_RootConstrainSelectedInstOperands,
     /* 679420 */     // GIR_Coverage, 5972,
     /* 679420 */     GIR_EraseRootFromParent_Done,
     /* 679421 */   // Label 8725: @679421
     /* 679421 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(679490), // Rule ID 5980 //
     /* 679426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679438 */     // MIs[0] offset
     /* 679438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679441 */     // MIs[0] auxiliary
     /* 679441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679444 */     // MIs[0] Operand 8
     /* 679444 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679462 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 679465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679467 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679476 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679488 */     GIR_RootConstrainSelectedInstOperands,
     /* 679489 */     // GIR_Coverage, 5980,
     /* 679489 */     GIR_EraseRootFromParent_Done,
     /* 679490 */   // Label 8726: @679490
     /* 679490 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(679556), // Rule ID 5978 //
     /* 679495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679498 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679504 */     // MIs[0] offset
     /* 679504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679507 */     // MIs[0] auxiliary
     /* 679507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679510 */     // MIs[0] Operand 8
     /* 679510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679528 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN),
     /* 679531 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679533 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679542 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679554 */     GIR_RootConstrainSelectedInstOperands,
     /* 679555 */     // GIR_Coverage, 5978,
     /* 679555 */     GIR_EraseRootFromParent_Done,
     /* 679556 */   // Label 8727: @679556
     /* 679556 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(679619), // Rule ID 5986 //
     /* 679561 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679567 */     // MIs[0] offset
     /* 679567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679570 */     // MIs[0] auxiliary
     /* 679570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679573 */     // MIs[0] Operand 8
     /* 679573 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679591 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN),
     /* 679594 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679596 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679605 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679617 */     GIR_RootConstrainSelectedInstOperands,
     /* 679618 */     // GIR_Coverage, 5986,
     /* 679618 */     GIR_EraseRootFromParent_Done,
     /* 679619 */   // Label 8728: @679619
     /* 679619 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(679689), // Rule ID 5974 //
     /* 679624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679635 */     // MIs[0] offset
     /* 679635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679638 */     // MIs[0] auxiliary
     /* 679638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679641 */     // MIs[0] Operand 8
     /* 679641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679659 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN_RTN),
     /* 679662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679664 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679666 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679675 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679687 */     GIR_RootConstrainSelectedInstOperands,
     /* 679688 */     // GIR_Coverage, 5974,
     /* 679688 */     GIR_EraseRootFromParent_Done,
     /* 679689 */   // Label 8729: @679689
     /* 679689 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(679756), // Rule ID 5982 //
     /* 679694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679702 */     // MIs[0] offset
     /* 679702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679705 */     // MIs[0] auxiliary
     /* 679705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679708 */     // MIs[0] Operand 8
     /* 679708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679726 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN),
     /* 679729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679731 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679733 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679742 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679754 */     GIR_RootConstrainSelectedInstOperands,
     /* 679755 */     // GIR_Coverage, 5982,
     /* 679755 */     GIR_EraseRootFromParent_Done,
     /* 679756 */   // Label 8730: @679756
     /* 679756 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(679814), // Rule ID 5977 //
     /* 679761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679764 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679770 */     // MIs[0] offset
     /* 679770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679773 */     // MIs[0] auxiliary
     /* 679773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679776 */     // MIs[0] Operand 8
     /* 679776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679786 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN),
     /* 679789 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679791 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679800 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679812 */     GIR_RootConstrainSelectedInstOperands,
     /* 679813 */     // GIR_Coverage, 5977,
     /* 679813 */     GIR_EraseRootFromParent_Done,
     /* 679814 */   // Label 8731: @679814
     /* 679814 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(679869), // Rule ID 5985 //
     /* 679819 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679825 */     // MIs[0] offset
     /* 679825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679828 */     // MIs[0] auxiliary
     /* 679828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679831 */     // MIs[0] Operand 8
     /* 679831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679841 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN),
     /* 679844 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679846 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679855 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679867 */     GIR_RootConstrainSelectedInstOperands,
     /* 679868 */     // GIR_Coverage, 5985,
     /* 679868 */     GIR_EraseRootFromParent_Done,
     /* 679869 */   // Label 8732: @679869
     /* 679869 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(679931), // Rule ID 5973 //
     /* 679874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679885 */     // MIs[0] offset
     /* 679885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679888 */     // MIs[0] auxiliary
     /* 679888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679891 */     // MIs[0] Operand 8
     /* 679891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679901 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN_RTN),
     /* 679904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679906 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679908 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679917 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679929 */     GIR_RootConstrainSelectedInstOperands,
     /* 679930 */     // GIR_Coverage, 5973,
     /* 679930 */     GIR_EraseRootFromParent_Done,
     /* 679931 */   // Label 8733: @679931
     /* 679931 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(679990), // Rule ID 5981 //
     /* 679936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679944 */     // MIs[0] offset
     /* 679944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679947 */     // MIs[0] auxiliary
     /* 679947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679950 */     // MIs[0] Operand 8
     /* 679950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679960 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN),
     /* 679963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679965 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679967 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679976 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679988 */     GIR_RootConstrainSelectedInstOperands,
     /* 679989 */     // GIR_Coverage, 5981,
     /* 679989 */     GIR_EraseRootFromParent_Done,
     /* 679990 */   // Label 8734: @679990
     /* 679990 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(680086), // Rule ID 5979 //
     /* 679995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679998 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680000 */     // MIs[0] offset
     /* 680000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680003 */     // MIs[0] auxiliary
     /* 680003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680006 */     // MIs[0] Operand 8
     /* 680006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680016 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680032 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680039 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN),
     /* 680060 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680072 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680084 */     GIR_RootConstrainSelectedInstOperands,
     /* 680085 */     // GIR_Coverage, 5979,
     /* 680085 */     GIR_EraseRootFromParent_Done,
     /* 680086 */   // Label 8735: @680086
     /* 680086 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(680179), // Rule ID 5987 //
     /* 680091 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680093 */     // MIs[0] offset
     /* 680093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680096 */     // MIs[0] auxiliary
     /* 680096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680099 */     // MIs[0] Operand 8
     /* 680099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680109 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680132 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN),
     /* 680153 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680165 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680177 */     GIR_RootConstrainSelectedInstOperands,
     /* 680178 */     // GIR_Coverage, 5987,
     /* 680178 */     GIR_EraseRootFromParent_Done,
     /* 680179 */   // Label 8736: @680179
     /* 680179 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(680279), // Rule ID 5975 //
     /* 680184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 680191 */     // MIs[0] offset
     /* 680191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680194 */     // MIs[0] auxiliary
     /* 680194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680197 */     // MIs[0] Operand 8
     /* 680197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680207 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680223 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680230 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN_RTN),
     /* 680251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680253 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680265 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680277 */     GIR_RootConstrainSelectedInstOperands,
     /* 680278 */     // GIR_Coverage, 5975,
     /* 680278 */     GIR_EraseRootFromParent_Done,
     /* 680279 */   // Label 8737: @680279
     /* 680279 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(680376), // Rule ID 5983 //
     /* 680284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 680288 */     // MIs[0] offset
     /* 680288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680291 */     // MIs[0] auxiliary
     /* 680291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680294 */     // MIs[0] Operand 8
     /* 680294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680304 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9787:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680320 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680327 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN),
     /* 680348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680350 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680362 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680374 */     GIR_RootConstrainSelectedInstOperands,
     /* 680375 */     // GIR_Coverage, 5983,
     /* 680375 */     GIR_EraseRootFromParent_Done,
     /* 680376 */   // Label 8738: @680376
     /* 680376 */   GIM_Reject,
     /* 680377 */ // Label 8722: @680377
     /* 680377 */ GIM_Reject,
     /* 680378 */ // Label 8720: @680378
     /* 680378 */ GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(681559),
     /* 680383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 680386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 680389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 680392 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 680395 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 680398 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(680466), // Rule ID 6176 //
     /* 680403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680406 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680416 */     // MIs[0] offset
     /* 680416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680419 */     // MIs[0] auxiliary
     /* 680419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680422 */     // MIs[0] Operand 8
     /* 680422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680440 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 680443 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680452 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680464 */     GIR_RootConstrainSelectedInstOperands,
     /* 680465 */     // GIR_Coverage, 6176,
     /* 680465 */     GIR_EraseRootFromParent_Done,
     /* 680466 */   // Label 8740: @680466
     /* 680466 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(680531), // Rule ID 6184 //
     /* 680471 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680481 */     // MIs[0] offset
     /* 680481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680484 */     // MIs[0] auxiliary
     /* 680484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680487 */     // MIs[0] Operand 8
     /* 680487 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680505 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 680508 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680517 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680529 */     GIR_RootConstrainSelectedInstOperands,
     /* 680530 */     // GIR_Coverage, 6184,
     /* 680530 */     GIR_EraseRootFromParent_Done,
     /* 680531 */   // Label 8741: @680531
     /* 680531 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(680603), // Rule ID 6172 //
     /* 680536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680551 */     // MIs[0] offset
     /* 680551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680554 */     // MIs[0] auxiliary
     /* 680554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680557 */     // MIs[0] Operand 8
     /* 680557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680575 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 680578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680580 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680589 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680601 */     GIR_RootConstrainSelectedInstOperands,
     /* 680602 */     // GIR_Coverage, 6172,
     /* 680602 */     GIR_EraseRootFromParent_Done,
     /* 680603 */   // Label 8742: @680603
     /* 680603 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(680672), // Rule ID 6180 //
     /* 680608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680620 */     // MIs[0] offset
     /* 680620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680623 */     // MIs[0] auxiliary
     /* 680623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680626 */     // MIs[0] Operand 8
     /* 680626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680644 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 680647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680649 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680658 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680670 */     GIR_RootConstrainSelectedInstOperands,
     /* 680671 */     // GIR_Coverage, 6180,
     /* 680671 */     GIR_EraseRootFromParent_Done,
     /* 680672 */   // Label 8743: @680672
     /* 680672 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(680738), // Rule ID 6178 //
     /* 680677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680680 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680686 */     // MIs[0] offset
     /* 680686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680689 */     // MIs[0] auxiliary
     /* 680689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680692 */     // MIs[0] Operand 8
     /* 680692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680710 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN),
     /* 680713 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680715 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680724 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680736 */     GIR_RootConstrainSelectedInstOperands,
     /* 680737 */     // GIR_Coverage, 6178,
     /* 680737 */     GIR_EraseRootFromParent_Done,
     /* 680738 */   // Label 8744: @680738
     /* 680738 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(680801), // Rule ID 6186 //
     /* 680743 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680749 */     // MIs[0] offset
     /* 680749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680752 */     // MIs[0] auxiliary
     /* 680752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680755 */     // MIs[0] Operand 8
     /* 680755 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680773 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN),
     /* 680776 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680778 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680787 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680799 */     GIR_RootConstrainSelectedInstOperands,
     /* 680800 */     // GIR_Coverage, 6186,
     /* 680800 */     GIR_EraseRootFromParent_Done,
     /* 680801 */   // Label 8745: @680801
     /* 680801 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(680871), // Rule ID 6174 //
     /* 680806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680817 */     // MIs[0] offset
     /* 680817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680820 */     // MIs[0] auxiliary
     /* 680820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680823 */     // MIs[0] Operand 8
     /* 680823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680841 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN_RTN),
     /* 680844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680846 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680848 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680857 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680869 */     GIR_RootConstrainSelectedInstOperands,
     /* 680870 */     // GIR_Coverage, 6174,
     /* 680870 */     GIR_EraseRootFromParent_Done,
     /* 680871 */   // Label 8746: @680871
     /* 680871 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(680938), // Rule ID 6182 //
     /* 680876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680884 */     // MIs[0] offset
     /* 680884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680887 */     // MIs[0] auxiliary
     /* 680887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680890 */     // MIs[0] Operand 8
     /* 680890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680908 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN),
     /* 680911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680913 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680915 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680924 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680936 */     GIR_RootConstrainSelectedInstOperands,
     /* 680937 */     // GIR_Coverage, 6182,
     /* 680937 */     GIR_EraseRootFromParent_Done,
     /* 680938 */   // Label 8747: @680938
     /* 680938 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(680996), // Rule ID 6177 //
     /* 680943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680946 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680952 */     // MIs[0] offset
     /* 680952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680955 */     // MIs[0] auxiliary
     /* 680955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680958 */     // MIs[0] Operand 8
     /* 680958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680968 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN),
     /* 680971 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680973 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680982 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680994 */     GIR_RootConstrainSelectedInstOperands,
     /* 680995 */     // GIR_Coverage, 6177,
     /* 680995 */     GIR_EraseRootFromParent_Done,
     /* 680996 */   // Label 8748: @680996
     /* 680996 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(681051), // Rule ID 6185 //
     /* 681001 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681007 */     // MIs[0] offset
     /* 681007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681010 */     // MIs[0] auxiliary
     /* 681010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681013 */     // MIs[0] Operand 8
     /* 681013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681023 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN),
     /* 681026 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681028 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681037 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681049 */     GIR_RootConstrainSelectedInstOperands,
     /* 681050 */     // GIR_Coverage, 6185,
     /* 681050 */     GIR_EraseRootFromParent_Done,
     /* 681051 */   // Label 8749: @681051
     /* 681051 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(681113), // Rule ID 6173 //
     /* 681056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681067 */     // MIs[0] offset
     /* 681067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681070 */     // MIs[0] auxiliary
     /* 681070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681073 */     // MIs[0] Operand 8
     /* 681073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681083 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN_RTN),
     /* 681086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681088 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681090 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681099 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681111 */     GIR_RootConstrainSelectedInstOperands,
     /* 681112 */     // GIR_Coverage, 6173,
     /* 681112 */     GIR_EraseRootFromParent_Done,
     /* 681113 */   // Label 8750: @681113
     /* 681113 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(681172), // Rule ID 6181 //
     /* 681118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681126 */     // MIs[0] offset
     /* 681126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681129 */     // MIs[0] auxiliary
     /* 681129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681132 */     // MIs[0] Operand 8
     /* 681132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681142 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN),
     /* 681145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681147 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681149 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681158 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681170 */     GIR_RootConstrainSelectedInstOperands,
     /* 681171 */     // GIR_Coverage, 6181,
     /* 681171 */     GIR_EraseRootFromParent_Done,
     /* 681172 */   // Label 8751: @681172
     /* 681172 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(681268), // Rule ID 6179 //
     /* 681177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681180 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681182 */     // MIs[0] offset
     /* 681182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681185 */     // MIs[0] auxiliary
     /* 681185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681188 */     // MIs[0] Operand 8
     /* 681188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681198 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681214 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681221 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN),
     /* 681242 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681254 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681266 */     GIR_RootConstrainSelectedInstOperands,
     /* 681267 */     // GIR_Coverage, 6179,
     /* 681267 */     GIR_EraseRootFromParent_Done,
     /* 681268 */   // Label 8752: @681268
     /* 681268 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(681361), // Rule ID 6187 //
     /* 681273 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681275 */     // MIs[0] offset
     /* 681275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681278 */     // MIs[0] auxiliary
     /* 681278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681281 */     // MIs[0] Operand 8
     /* 681281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681291 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681307 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681314 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN),
     /* 681335 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681347 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681359 */     GIR_RootConstrainSelectedInstOperands,
     /* 681360 */     // GIR_Coverage, 6187,
     /* 681360 */     GIR_EraseRootFromParent_Done,
     /* 681361 */   // Label 8753: @681361
     /* 681361 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(681461), // Rule ID 6175 //
     /* 681366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681373 */     // MIs[0] offset
     /* 681373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681376 */     // MIs[0] auxiliary
     /* 681376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681379 */     // MIs[0] Operand 8
     /* 681379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681389 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681405 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681412 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN),
     /* 681433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681435 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681447 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681459 */     GIR_RootConstrainSelectedInstOperands,
     /* 681460 */     // GIR_Coverage, 6175,
     /* 681460 */     GIR_EraseRootFromParent_Done,
     /* 681461 */   // Label 8754: @681461
     /* 681461 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(681558), // Rule ID 6183 //
     /* 681466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681470 */     // MIs[0] offset
     /* 681470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681473 */     // MIs[0] auxiliary
     /* 681473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681476 */     // MIs[0] Operand 8
     /* 681476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681486 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9786:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681502 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681509 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN),
     /* 681530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681544 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681556 */     GIR_RootConstrainSelectedInstOperands,
     /* 681557 */     // GIR_Coverage, 6183,
     /* 681557 */     GIR_EraseRootFromParent_Done,
     /* 681558 */   // Label 8755: @681558
     /* 681558 */   GIM_Reject,
     /* 681559 */ // Label 8739: @681559
     /* 681559 */ GIM_Reject,
     /* 681560 */ // Label 8721: @681560
     /* 681560 */ GIM_Reject,
     /* 681561 */ // Label 125: @681561
     /* 681561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 8772*/ GIMT_Encode4(696932),
     /* 681572 */ /*GILLT_p0s64*//*Label 8756*/ GIMT_Encode4(681664),
     /* 681576 */ /*GILLT_p1s64*//*Label 8757*/ GIMT_Encode4(682283),
     /* 681580 */ /*GILLT_p2s32*//*Label 8758*/ GIMT_Encode4(682902),
     /* 681584 */ /*GILLT_p3s32*//*Label 8759*/ GIMT_Encode4(683521),
     /* 681588 */ /*GILLT_p4s64*//*Label 8760*/ GIMT_Encode4(684140),
     /* 681592 */ /*GILLT_p5s32*//*Label 8761*/ GIMT_Encode4(684759),
     /* 681596 */ /*GILLT_p6s32*//*Label 8762*/ GIMT_Encode4(685378), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 681608 */ /*GILLT_s32*//*Label 8763*/ GIMT_Encode4(685997),
     /* 681612 */ /*GILLT_s64*//*Label 8764*/ GIMT_Encode4(687212),
     /* 681616 */ /*GILLT_v2s16*//*Label 8765*/ GIMT_Encode4(688427),
     /* 681620 */ /*GILLT_v2s32*//*Label 8766*/ GIMT_Encode4(689642),
     /* 681624 */ /*GILLT_v2s64*//*Label 8767*/ GIMT_Encode4(690857),
     /* 681628 */ /*GILLT_v3s32*//*Label 8768*/ GIMT_Encode4(692072), GIMT_Encode4(0),
     /* 681636 */ /*GILLT_v4s16*//*Label 8769*/ GIMT_Encode4(693287),
     /* 681640 */ /*GILLT_v4s32*//*Label 8770*/ GIMT_Encode4(694502), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 681660 */ /*GILLT_v8s16*//*Label 8771*/ GIMT_Encode4(695717),
     /* 681664 */ // Label 8756: @681664
     /* 681664 */ GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(682282),
     /* 681669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 681672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 681675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 681678 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 681681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681685 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(681757), // Rule ID 4988 //
     /* 681690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681701 */     // MIs[0] offset
     /* 681701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681704 */     // MIs[0] auxiliary
     /* 681704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681707 */     // MIs[0] Operand 7
     /* 681707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681725 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 681728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681737 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681755 */     GIR_RootConstrainSelectedInstOperands,
     /* 681756 */     // GIR_Coverage, 4988,
     /* 681756 */     GIR_EraseRootFromParent_Done,
     /* 681757 */   // Label 8774: @681757
     /* 681757 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(681826), // Rule ID 4992 //
     /* 681762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681770 */     // MIs[0] offset
     /* 681770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681773 */     // MIs[0] auxiliary
     /* 681773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681776 */     // MIs[0] Operand 7
     /* 681776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681794 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 681797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681824 */     GIR_RootConstrainSelectedInstOperands,
     /* 681825 */     // GIR_Coverage, 4992,
     /* 681825 */     GIR_EraseRootFromParent_Done,
     /* 681826 */   // Label 8775: @681826
     /* 681826 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(681896), // Rule ID 4989 //
     /* 681831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681838 */     // MIs[0] offset
     /* 681838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681841 */     // MIs[0] auxiliary
     /* 681841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681844 */     // MIs[0] Operand 7
     /* 681844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681862 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 681865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681867 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 681869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681876 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681894 */     GIR_RootConstrainSelectedInstOperands,
     /* 681895 */     // GIR_Coverage, 4989,
     /* 681895 */     GIR_EraseRootFromParent_Done,
     /* 681896 */   // Label 8776: @681896
     /* 681896 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(681963), // Rule ID 4993 //
     /* 681901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681905 */     // MIs[0] offset
     /* 681905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681908 */     // MIs[0] auxiliary
     /* 681908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681911 */     // MIs[0] Operand 7
     /* 681911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681929 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 681932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681934 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 681936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681943 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681961 */     GIR_RootConstrainSelectedInstOperands,
     /* 681962 */     // GIR_Coverage, 4993,
     /* 681962 */     GIR_EraseRootFromParent_Done,
     /* 681963 */   // Label 8777: @681963
     /* 681963 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(682025), // Rule ID 4990 //
     /* 681968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681975 */     // MIs[0] offset
     /* 681975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681978 */     // MIs[0] auxiliary
     /* 681978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681981 */     // MIs[0] Operand 7
     /* 681981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681991 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 681994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681996 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 681998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682005 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682023 */     GIR_RootConstrainSelectedInstOperands,
     /* 682024 */     // GIR_Coverage, 4990,
     /* 682024 */     GIR_EraseRootFromParent_Done,
     /* 682025 */   // Label 8778: @682025
     /* 682025 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(682084), // Rule ID 4994 //
     /* 682030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682034 */     // MIs[0] offset
     /* 682034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682037 */     // MIs[0] auxiliary
     /* 682037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682040 */     // MIs[0] Operand 7
     /* 682040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682050 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 682053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682055 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682064 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682082 */     GIR_RootConstrainSelectedInstOperands,
     /* 682083 */     // GIR_Coverage, 4994,
     /* 682083 */     GIR_EraseRootFromParent_Done,
     /* 682084 */   // Label 8779: @682084
     /* 682084 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(682184), // Rule ID 4991 //
     /* 682089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682092 */     // MIs[0] offset
     /* 682092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682095 */     // MIs[0] auxiliary
     /* 682095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682098 */     // MIs[0] Operand 7
     /* 682098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682108 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682124 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682131 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 682152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682164 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682182 */     GIR_RootConstrainSelectedInstOperands,
     /* 682183 */     // GIR_Coverage, 4991,
     /* 682183 */     GIR_EraseRootFromParent_Done,
     /* 682184 */   // Label 8780: @682184
     /* 682184 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(682281), // Rule ID 4995 //
     /* 682189 */     // MIs[0] offset
     /* 682189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682192 */     // MIs[0] auxiliary
     /* 682192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682195 */     // MIs[0] Operand 7
     /* 682195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682205 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682221 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682228 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 682249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682279 */     GIR_RootConstrainSelectedInstOperands,
     /* 682280 */     // GIR_Coverage, 4995,
     /* 682280 */     GIR_EraseRootFromParent_Done,
     /* 682281 */   // Label 8781: @682281
     /* 682281 */   GIM_Reject,
     /* 682282 */ // Label 8773: @682282
     /* 682282 */ GIM_Reject,
     /* 682283 */ // Label 8757: @682283
     /* 682283 */ GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(682901),
     /* 682288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 682291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 682294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 682297 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 682300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682304 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(682376), // Rule ID 4996 //
     /* 682309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682320 */     // MIs[0] offset
     /* 682320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682323 */     // MIs[0] auxiliary
     /* 682323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682326 */     // MIs[0] Operand 7
     /* 682326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682344 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 682347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682356 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682374 */     GIR_RootConstrainSelectedInstOperands,
     /* 682375 */     // GIR_Coverage, 4996,
     /* 682375 */     GIR_EraseRootFromParent_Done,
     /* 682376 */   // Label 8783: @682376
     /* 682376 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(682445), // Rule ID 5000 //
     /* 682381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682389 */     // MIs[0] offset
     /* 682389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682392 */     // MIs[0] auxiliary
     /* 682392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682395 */     // MIs[0] Operand 7
     /* 682395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682413 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 682416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682425 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682443 */     GIR_RootConstrainSelectedInstOperands,
     /* 682444 */     // GIR_Coverage, 5000,
     /* 682444 */     GIR_EraseRootFromParent_Done,
     /* 682445 */   // Label 8784: @682445
     /* 682445 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(682515), // Rule ID 4997 //
     /* 682450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682457 */     // MIs[0] offset
     /* 682457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682460 */     // MIs[0] auxiliary
     /* 682460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682463 */     // MIs[0] Operand 7
     /* 682463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682481 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 682484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682486 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682495 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682497 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682513 */     GIR_RootConstrainSelectedInstOperands,
     /* 682514 */     // GIR_Coverage, 4997,
     /* 682514 */     GIR_EraseRootFromParent_Done,
     /* 682515 */   // Label 8785: @682515
     /* 682515 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(682582), // Rule ID 5001 //
     /* 682520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682524 */     // MIs[0] offset
     /* 682524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682527 */     // MIs[0] auxiliary
     /* 682527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682530 */     // MIs[0] Operand 7
     /* 682530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682548 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 682551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682553 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682580 */     GIR_RootConstrainSelectedInstOperands,
     /* 682581 */     // GIR_Coverage, 5001,
     /* 682581 */     GIR_EraseRootFromParent_Done,
     /* 682582 */   // Label 8786: @682582
     /* 682582 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(682644), // Rule ID 4998 //
     /* 682587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682594 */     // MIs[0] offset
     /* 682594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682597 */     // MIs[0] auxiliary
     /* 682597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682600 */     // MIs[0] Operand 7
     /* 682600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682610 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 682613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682615 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682642 */     GIR_RootConstrainSelectedInstOperands,
     /* 682643 */     // GIR_Coverage, 4998,
     /* 682643 */     GIR_EraseRootFromParent_Done,
     /* 682644 */   // Label 8787: @682644
     /* 682644 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(682703), // Rule ID 5002 //
     /* 682649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682653 */     // MIs[0] offset
     /* 682653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682656 */     // MIs[0] auxiliary
     /* 682656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682659 */     // MIs[0] Operand 7
     /* 682659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682669 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 682672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682674 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682683 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682701 */     GIR_RootConstrainSelectedInstOperands,
     /* 682702 */     // GIR_Coverage, 5002,
     /* 682702 */     GIR_EraseRootFromParent_Done,
     /* 682703 */   // Label 8788: @682703
     /* 682703 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(682803), // Rule ID 4999 //
     /* 682708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682711 */     // MIs[0] offset
     /* 682711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682714 */     // MIs[0] auxiliary
     /* 682714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682717 */     // MIs[0] Operand 7
     /* 682717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682727 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682743 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682750 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 682771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682783 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682801 */     GIR_RootConstrainSelectedInstOperands,
     /* 682802 */     // GIR_Coverage, 4999,
     /* 682802 */     GIR_EraseRootFromParent_Done,
     /* 682803 */   // Label 8789: @682803
     /* 682803 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(682900), // Rule ID 5003 //
     /* 682808 */     // MIs[0] offset
     /* 682808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682811 */     // MIs[0] auxiliary
     /* 682811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682814 */     // MIs[0] Operand 7
     /* 682814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682824 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682840 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682847 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 682868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682880 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682898 */     GIR_RootConstrainSelectedInstOperands,
     /* 682899 */     // GIR_Coverage, 5003,
     /* 682899 */     GIR_EraseRootFromParent_Done,
     /* 682900 */   // Label 8790: @682900
     /* 682900 */   GIM_Reject,
     /* 682901 */ // Label 8782: @682901
     /* 682901 */ GIM_Reject,
     /* 682902 */ // Label 8758: @682902
     /* 682902 */ GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(683520),
     /* 682907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 682910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 682913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 682916 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 682919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 682923 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(682995), // Rule ID 4924 //
     /* 682928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682939 */     // MIs[0] offset
     /* 682939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682942 */     // MIs[0] auxiliary
     /* 682942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682945 */     // MIs[0] Operand 7
     /* 682945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682963 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 682966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682975 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682993 */     GIR_RootConstrainSelectedInstOperands,
     /* 682994 */     // GIR_Coverage, 4924,
     /* 682994 */     GIR_EraseRootFromParent_Done,
     /* 682995 */   // Label 8792: @682995
     /* 682995 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(683064), // Rule ID 4928 //
     /* 683000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683008 */     // MIs[0] offset
     /* 683008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683011 */     // MIs[0] auxiliary
     /* 683011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683014 */     // MIs[0] Operand 7
     /* 683014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683032 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 683035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683044 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683062 */     GIR_RootConstrainSelectedInstOperands,
     /* 683063 */     // GIR_Coverage, 4928,
     /* 683063 */     GIR_EraseRootFromParent_Done,
     /* 683064 */   // Label 8793: @683064
     /* 683064 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(683134), // Rule ID 4925 //
     /* 683069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683076 */     // MIs[0] offset
     /* 683076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683079 */     // MIs[0] auxiliary
     /* 683079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683082 */     // MIs[0] Operand 7
     /* 683082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683100 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 683103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683105 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683114 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683132 */     GIR_RootConstrainSelectedInstOperands,
     /* 683133 */     // GIR_Coverage, 4925,
     /* 683133 */     GIR_EraseRootFromParent_Done,
     /* 683134 */   // Label 8794: @683134
     /* 683134 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(683201), // Rule ID 4929 //
     /* 683139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683143 */     // MIs[0] offset
     /* 683143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683146 */     // MIs[0] auxiliary
     /* 683146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683149 */     // MIs[0] Operand 7
     /* 683149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683167 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 683170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683172 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683181 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683199 */     GIR_RootConstrainSelectedInstOperands,
     /* 683200 */     // GIR_Coverage, 4929,
     /* 683200 */     GIR_EraseRootFromParent_Done,
     /* 683201 */   // Label 8795: @683201
     /* 683201 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(683263), // Rule ID 4926 //
     /* 683206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683213 */     // MIs[0] offset
     /* 683213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683216 */     // MIs[0] auxiliary
     /* 683216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683219 */     // MIs[0] Operand 7
     /* 683219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683229 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 683232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683234 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683261 */     GIR_RootConstrainSelectedInstOperands,
     /* 683262 */     // GIR_Coverage, 4926,
     /* 683262 */     GIR_EraseRootFromParent_Done,
     /* 683263 */   // Label 8796: @683263
     /* 683263 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(683322), // Rule ID 4930 //
     /* 683268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683272 */     // MIs[0] offset
     /* 683272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683275 */     // MIs[0] auxiliary
     /* 683275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683278 */     // MIs[0] Operand 7
     /* 683278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683288 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 683291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683293 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683302 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683310 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683320 */     GIR_RootConstrainSelectedInstOperands,
     /* 683321 */     // GIR_Coverage, 4930,
     /* 683321 */     GIR_EraseRootFromParent_Done,
     /* 683322 */   // Label 8797: @683322
     /* 683322 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(683422), // Rule ID 4927 //
     /* 683327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683330 */     // MIs[0] offset
     /* 683330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683333 */     // MIs[0] auxiliary
     /* 683333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683336 */     // MIs[0] Operand 7
     /* 683336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683346 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683369 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 683390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683402 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683420 */     GIR_RootConstrainSelectedInstOperands,
     /* 683421 */     // GIR_Coverage, 4927,
     /* 683421 */     GIR_EraseRootFromParent_Done,
     /* 683422 */   // Label 8798: @683422
     /* 683422 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(683519), // Rule ID 4931 //
     /* 683427 */     // MIs[0] offset
     /* 683427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683430 */     // MIs[0] auxiliary
     /* 683430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683433 */     // MIs[0] Operand 7
     /* 683433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683443 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683459 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 683487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683499 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683517 */     GIR_RootConstrainSelectedInstOperands,
     /* 683518 */     // GIR_Coverage, 4931,
     /* 683518 */     GIR_EraseRootFromParent_Done,
     /* 683519 */   // Label 8799: @683519
     /* 683519 */   GIM_Reject,
     /* 683520 */ // Label 8791: @683520
     /* 683520 */ GIM_Reject,
     /* 683521 */ // Label 8759: @683521
     /* 683521 */ GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(684139),
     /* 683526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 683529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 683532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 683535 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 683538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683542 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(683614), // Rule ID 4932 //
     /* 683547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683558 */     // MIs[0] offset
     /* 683558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683561 */     // MIs[0] auxiliary
     /* 683561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683564 */     // MIs[0] Operand 7
     /* 683564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683582 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 683585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683594 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683612 */     GIR_RootConstrainSelectedInstOperands,
     /* 683613 */     // GIR_Coverage, 4932,
     /* 683613 */     GIR_EraseRootFromParent_Done,
     /* 683614 */   // Label 8801: @683614
     /* 683614 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(683683), // Rule ID 4936 //
     /* 683619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683627 */     // MIs[0] offset
     /* 683627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683630 */     // MIs[0] auxiliary
     /* 683630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683633 */     // MIs[0] Operand 7
     /* 683633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683651 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 683654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683663 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683681 */     GIR_RootConstrainSelectedInstOperands,
     /* 683682 */     // GIR_Coverage, 4936,
     /* 683682 */     GIR_EraseRootFromParent_Done,
     /* 683683 */   // Label 8802: @683683
     /* 683683 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(683753), // Rule ID 4933 //
     /* 683688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683695 */     // MIs[0] offset
     /* 683695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683698 */     // MIs[0] auxiliary
     /* 683698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683701 */     // MIs[0] Operand 7
     /* 683701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683719 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 683722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683724 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683733 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683751 */     GIR_RootConstrainSelectedInstOperands,
     /* 683752 */     // GIR_Coverage, 4933,
     /* 683752 */     GIR_EraseRootFromParent_Done,
     /* 683753 */   // Label 8803: @683753
     /* 683753 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(683820), // Rule ID 4937 //
     /* 683758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683762 */     // MIs[0] offset
     /* 683762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683765 */     // MIs[0] auxiliary
     /* 683765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683768 */     // MIs[0] Operand 7
     /* 683768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683786 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 683789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683791 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683800 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683818 */     GIR_RootConstrainSelectedInstOperands,
     /* 683819 */     // GIR_Coverage, 4937,
     /* 683819 */     GIR_EraseRootFromParent_Done,
     /* 683820 */   // Label 8804: @683820
     /* 683820 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(683882), // Rule ID 4934 //
     /* 683825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683832 */     // MIs[0] offset
     /* 683832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683835 */     // MIs[0] auxiliary
     /* 683835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683838 */     // MIs[0] Operand 7
     /* 683838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683848 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 683851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683853 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683862 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683864 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683880 */     GIR_RootConstrainSelectedInstOperands,
     /* 683881 */     // GIR_Coverage, 4934,
     /* 683881 */     GIR_EraseRootFromParent_Done,
     /* 683882 */   // Label 8805: @683882
     /* 683882 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(683941), // Rule ID 4938 //
     /* 683887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683891 */     // MIs[0] offset
     /* 683891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683894 */     // MIs[0] auxiliary
     /* 683894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683897 */     // MIs[0] Operand 7
     /* 683897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683907 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 683910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683912 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683921 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683939 */     GIR_RootConstrainSelectedInstOperands,
     /* 683940 */     // GIR_Coverage, 4938,
     /* 683940 */     GIR_EraseRootFromParent_Done,
     /* 683941 */   // Label 8806: @683941
     /* 683941 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(684041), // Rule ID 4935 //
     /* 683946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683949 */     // MIs[0] offset
     /* 683949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683952 */     // MIs[0] auxiliary
     /* 683952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683955 */     // MIs[0] Operand 7
     /* 683955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683965 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683981 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683988 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 684009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684021 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684039 */     GIR_RootConstrainSelectedInstOperands,
     /* 684040 */     // GIR_Coverage, 4935,
     /* 684040 */     GIR_EraseRootFromParent_Done,
     /* 684041 */   // Label 8807: @684041
     /* 684041 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(684138), // Rule ID 4939 //
     /* 684046 */     // MIs[0] offset
     /* 684046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684049 */     // MIs[0] auxiliary
     /* 684049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684052 */     // MIs[0] Operand 7
     /* 684052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684062 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684078 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684085 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 684106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684118 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684136 */     GIR_RootConstrainSelectedInstOperands,
     /* 684137 */     // GIR_Coverage, 4939,
     /* 684137 */     GIR_EraseRootFromParent_Done,
     /* 684138 */   // Label 8808: @684138
     /* 684138 */   GIM_Reject,
     /* 684139 */ // Label 8800: @684139
     /* 684139 */ GIM_Reject,
     /* 684140 */ // Label 8760: @684140
     /* 684140 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(684758),
     /* 684145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 684148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 684151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 684154 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 684157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 684161 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(684233), // Rule ID 5004 //
     /* 684166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684177 */     // MIs[0] offset
     /* 684177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684180 */     // MIs[0] auxiliary
     /* 684180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684183 */     // MIs[0] Operand 7
     /* 684183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684201 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 684204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684213 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684231 */     GIR_RootConstrainSelectedInstOperands,
     /* 684232 */     // GIR_Coverage, 5004,
     /* 684232 */     GIR_EraseRootFromParent_Done,
     /* 684233 */   // Label 8810: @684233
     /* 684233 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(684302), // Rule ID 5008 //
     /* 684238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684246 */     // MIs[0] offset
     /* 684246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684249 */     // MIs[0] auxiliary
     /* 684249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684252 */     // MIs[0] Operand 7
     /* 684252 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684270 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 684273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684300 */     GIR_RootConstrainSelectedInstOperands,
     /* 684301 */     // GIR_Coverage, 5008,
     /* 684301 */     GIR_EraseRootFromParent_Done,
     /* 684302 */   // Label 8811: @684302
     /* 684302 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(684372), // Rule ID 5005 //
     /* 684307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684314 */     // MIs[0] offset
     /* 684314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684317 */     // MIs[0] auxiliary
     /* 684317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684320 */     // MIs[0] Operand 7
     /* 684320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684338 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 684341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684343 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684352 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684370 */     GIR_RootConstrainSelectedInstOperands,
     /* 684371 */     // GIR_Coverage, 5005,
     /* 684371 */     GIR_EraseRootFromParent_Done,
     /* 684372 */   // Label 8812: @684372
     /* 684372 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(684439), // Rule ID 5009 //
     /* 684377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684381 */     // MIs[0] offset
     /* 684381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684384 */     // MIs[0] auxiliary
     /* 684384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684387 */     // MIs[0] Operand 7
     /* 684387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684405 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 684408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684410 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684419 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684421 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684437 */     GIR_RootConstrainSelectedInstOperands,
     /* 684438 */     // GIR_Coverage, 5009,
     /* 684438 */     GIR_EraseRootFromParent_Done,
     /* 684439 */   // Label 8813: @684439
     /* 684439 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(684501), // Rule ID 5006 //
     /* 684444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684451 */     // MIs[0] offset
     /* 684451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684454 */     // MIs[0] auxiliary
     /* 684454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684457 */     // MIs[0] Operand 7
     /* 684457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684467 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 684470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684472 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684481 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684499 */     GIR_RootConstrainSelectedInstOperands,
     /* 684500 */     // GIR_Coverage, 5006,
     /* 684500 */     GIR_EraseRootFromParent_Done,
     /* 684501 */   // Label 8814: @684501
     /* 684501 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(684560), // Rule ID 5010 //
     /* 684506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684510 */     // MIs[0] offset
     /* 684510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684513 */     // MIs[0] auxiliary
     /* 684513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684516 */     // MIs[0] Operand 7
     /* 684516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684526 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 684529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684531 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684540 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684558 */     GIR_RootConstrainSelectedInstOperands,
     /* 684559 */     // GIR_Coverage, 5010,
     /* 684559 */     GIR_EraseRootFromParent_Done,
     /* 684560 */   // Label 8815: @684560
     /* 684560 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(684660), // Rule ID 5007 //
     /* 684565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684568 */     // MIs[0] offset
     /* 684568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684571 */     // MIs[0] auxiliary
     /* 684571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684574 */     // MIs[0] Operand 7
     /* 684574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684584 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684607 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 684628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684640 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684658 */     GIR_RootConstrainSelectedInstOperands,
     /* 684659 */     // GIR_Coverage, 5007,
     /* 684659 */     GIR_EraseRootFromParent_Done,
     /* 684660 */   // Label 8816: @684660
     /* 684660 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(684757), // Rule ID 5011 //
     /* 684665 */     // MIs[0] offset
     /* 684665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684668 */     // MIs[0] auxiliary
     /* 684668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684671 */     // MIs[0] Operand 7
     /* 684671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684681 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684697 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684704 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 684725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684737 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684755 */     GIR_RootConstrainSelectedInstOperands,
     /* 684756 */     // GIR_Coverage, 5011,
     /* 684756 */     GIR_EraseRootFromParent_Done,
     /* 684757 */   // Label 8817: @684757
     /* 684757 */   GIM_Reject,
     /* 684758 */ // Label 8809: @684758
     /* 684758 */ GIM_Reject,
     /* 684759 */ // Label 8761: @684759
     /* 684759 */ GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(685377),
     /* 684764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 684767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 684770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 684773 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 684776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 684780 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(684852), // Rule ID 4940 //
     /* 684785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684796 */     // MIs[0] offset
     /* 684796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684799 */     // MIs[0] auxiliary
     /* 684799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684802 */     // MIs[0] Operand 7
     /* 684802 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684820 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 684823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684832 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684850 */     GIR_RootConstrainSelectedInstOperands,
     /* 684851 */     // GIR_Coverage, 4940,
     /* 684851 */     GIR_EraseRootFromParent_Done,
     /* 684852 */   // Label 8819: @684852
     /* 684852 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(684921), // Rule ID 4944 //
     /* 684857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684865 */     // MIs[0] offset
     /* 684865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684868 */     // MIs[0] auxiliary
     /* 684868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684871 */     // MIs[0] Operand 7
     /* 684871 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684889 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 684892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684901 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684919 */     GIR_RootConstrainSelectedInstOperands,
     /* 684920 */     // GIR_Coverage, 4944,
     /* 684920 */     GIR_EraseRootFromParent_Done,
     /* 684921 */   // Label 8820: @684921
     /* 684921 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(684991), // Rule ID 4941 //
     /* 684926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684933 */     // MIs[0] offset
     /* 684933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684936 */     // MIs[0] auxiliary
     /* 684936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684939 */     // MIs[0] Operand 7
     /* 684939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684957 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 684960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684962 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684971 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684989 */     GIR_RootConstrainSelectedInstOperands,
     /* 684990 */     // GIR_Coverage, 4941,
     /* 684990 */     GIR_EraseRootFromParent_Done,
     /* 684991 */   // Label 8821: @684991
     /* 684991 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(685058), // Rule ID 4945 //
     /* 684996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685000 */     // MIs[0] offset
     /* 685000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685003 */     // MIs[0] auxiliary
     /* 685003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685006 */     // MIs[0] Operand 7
     /* 685006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685024 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 685027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685029 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685038 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685056 */     GIR_RootConstrainSelectedInstOperands,
     /* 685057 */     // GIR_Coverage, 4945,
     /* 685057 */     GIR_EraseRootFromParent_Done,
     /* 685058 */   // Label 8822: @685058
     /* 685058 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(685120), // Rule ID 4942 //
     /* 685063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685070 */     // MIs[0] offset
     /* 685070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685073 */     // MIs[0] auxiliary
     /* 685073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685076 */     // MIs[0] Operand 7
     /* 685076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685086 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 685089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685091 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685100 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685102 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685118 */     GIR_RootConstrainSelectedInstOperands,
     /* 685119 */     // GIR_Coverage, 4942,
     /* 685119 */     GIR_EraseRootFromParent_Done,
     /* 685120 */   // Label 8823: @685120
     /* 685120 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(685179), // Rule ID 4946 //
     /* 685125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685129 */     // MIs[0] offset
     /* 685129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685132 */     // MIs[0] auxiliary
     /* 685132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685135 */     // MIs[0] Operand 7
     /* 685135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685145 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 685148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685150 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685159 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685177 */     GIR_RootConstrainSelectedInstOperands,
     /* 685178 */     // GIR_Coverage, 4946,
     /* 685178 */     GIR_EraseRootFromParent_Done,
     /* 685179 */   // Label 8824: @685179
     /* 685179 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(685279), // Rule ID 4943 //
     /* 685184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685187 */     // MIs[0] offset
     /* 685187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685190 */     // MIs[0] auxiliary
     /* 685190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685193 */     // MIs[0] Operand 7
     /* 685193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685203 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685219 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685226 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 685247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685259 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685277 */     GIR_RootConstrainSelectedInstOperands,
     /* 685278 */     // GIR_Coverage, 4943,
     /* 685278 */     GIR_EraseRootFromParent_Done,
     /* 685279 */   // Label 8825: @685279
     /* 685279 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(685376), // Rule ID 4947 //
     /* 685284 */     // MIs[0] offset
     /* 685284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685287 */     // MIs[0] auxiliary
     /* 685287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685290 */     // MIs[0] Operand 7
     /* 685290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685300 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685316 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685323 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 685344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685356 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685374 */     GIR_RootConstrainSelectedInstOperands,
     /* 685375 */     // GIR_Coverage, 4947,
     /* 685375 */     GIR_EraseRootFromParent_Done,
     /* 685376 */   // Label 8826: @685376
     /* 685376 */   GIM_Reject,
     /* 685377 */ // Label 8818: @685377
     /* 685377 */ GIM_Reject,
     /* 685378 */ // Label 8762: @685378
     /* 685378 */ GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(685996),
     /* 685383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 685386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 685389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 685392 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 685395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 685399 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(685471), // Rule ID 4948 //
     /* 685404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685415 */     // MIs[0] offset
     /* 685415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685418 */     // MIs[0] auxiliary
     /* 685418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685421 */     // MIs[0] Operand 7
     /* 685421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685439 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 685442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685451 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685469 */     GIR_RootConstrainSelectedInstOperands,
     /* 685470 */     // GIR_Coverage, 4948,
     /* 685470 */     GIR_EraseRootFromParent_Done,
     /* 685471 */   // Label 8828: @685471
     /* 685471 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(685540), // Rule ID 4952 //
     /* 685476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685484 */     // MIs[0] offset
     /* 685484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685487 */     // MIs[0] auxiliary
     /* 685487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685490 */     // MIs[0] Operand 7
     /* 685490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685508 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 685511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685520 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685538 */     GIR_RootConstrainSelectedInstOperands,
     /* 685539 */     // GIR_Coverage, 4952,
     /* 685539 */     GIR_EraseRootFromParent_Done,
     /* 685540 */   // Label 8829: @685540
     /* 685540 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(685610), // Rule ID 4949 //
     /* 685545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685552 */     // MIs[0] offset
     /* 685552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685555 */     // MIs[0] auxiliary
     /* 685555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685558 */     // MIs[0] Operand 7
     /* 685558 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685576 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 685579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685581 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685590 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685608 */     GIR_RootConstrainSelectedInstOperands,
     /* 685609 */     // GIR_Coverage, 4949,
     /* 685609 */     GIR_EraseRootFromParent_Done,
     /* 685610 */   // Label 8830: @685610
     /* 685610 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(685677), // Rule ID 4953 //
     /* 685615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685619 */     // MIs[0] offset
     /* 685619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685622 */     // MIs[0] auxiliary
     /* 685622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685625 */     // MIs[0] Operand 7
     /* 685625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685643 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 685646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685648 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685657 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685659 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685675 */     GIR_RootConstrainSelectedInstOperands,
     /* 685676 */     // GIR_Coverage, 4953,
     /* 685676 */     GIR_EraseRootFromParent_Done,
     /* 685677 */   // Label 8831: @685677
     /* 685677 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(685739), // Rule ID 4950 //
     /* 685682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685689 */     // MIs[0] offset
     /* 685689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685692 */     // MIs[0] auxiliary
     /* 685692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685695 */     // MIs[0] Operand 7
     /* 685695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685705 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 685708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685710 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685719 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685737 */     GIR_RootConstrainSelectedInstOperands,
     /* 685738 */     // GIR_Coverage, 4950,
     /* 685738 */     GIR_EraseRootFromParent_Done,
     /* 685739 */   // Label 8832: @685739
     /* 685739 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(685798), // Rule ID 4954 //
     /* 685744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685748 */     // MIs[0] offset
     /* 685748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685751 */     // MIs[0] auxiliary
     /* 685751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685754 */     // MIs[0] Operand 7
     /* 685754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685764 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 685767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685769 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685796 */     GIR_RootConstrainSelectedInstOperands,
     /* 685797 */     // GIR_Coverage, 4954,
     /* 685797 */     GIR_EraseRootFromParent_Done,
     /* 685798 */   // Label 8833: @685798
     /* 685798 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(685898), // Rule ID 4951 //
     /* 685803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685806 */     // MIs[0] offset
     /* 685806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685809 */     // MIs[0] auxiliary
     /* 685809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685812 */     // MIs[0] Operand 7
     /* 685812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685822 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685838 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685845 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 685866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685878 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685896 */     GIR_RootConstrainSelectedInstOperands,
     /* 685897 */     // GIR_Coverage, 4951,
     /* 685897 */     GIR_EraseRootFromParent_Done,
     /* 685898 */   // Label 8834: @685898
     /* 685898 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(685995), // Rule ID 4955 //
     /* 685903 */     // MIs[0] offset
     /* 685903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685906 */     // MIs[0] auxiliary
     /* 685906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685909 */     // MIs[0] Operand 7
     /* 685909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685919 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685935 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685942 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 685963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685975 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685993 */     GIR_RootConstrainSelectedInstOperands,
     /* 685994 */     // GIR_Coverage, 4955,
     /* 685994 */     GIR_EraseRootFromParent_Done,
     /* 685995 */   // Label 8835: @685995
     /* 685995 */   GIM_Reject,
     /* 685996 */ // Label 8827: @685996
     /* 685996 */ GIM_Reject,
     /* 685997 */ // Label 8763: @685997
     /* 685997 */ GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(687211),
     /* 686002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 686005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 686008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 686011 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 686014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 686018 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(686090), // Rule ID 4892 //
     /* 686023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686034 */     // MIs[0] offset
     /* 686034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686037 */     // MIs[0] auxiliary
     /* 686037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686040 */     // MIs[0] Operand 7
     /* 686040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686058 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 686061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686070 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686088 */     GIR_RootConstrainSelectedInstOperands,
     /* 686089 */     // GIR_Coverage, 4892,
     /* 686089 */     GIR_EraseRootFromParent_Done,
     /* 686090 */   // Label 8837: @686090
     /* 686090 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(686159), // Rule ID 4896 //
     /* 686095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686103 */     // MIs[0] offset
     /* 686103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686106 */     // MIs[0] auxiliary
     /* 686106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686109 */     // MIs[0] Operand 7
     /* 686109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686127 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 686130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686139 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686157 */     GIR_RootConstrainSelectedInstOperands,
     /* 686158 */     // GIR_Coverage, 4896,
     /* 686158 */     GIR_EraseRootFromParent_Done,
     /* 686159 */   // Label 8838: @686159
     /* 686159 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(686231), // Rule ID 4900 //
     /* 686164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686175 */     // MIs[0] offset
     /* 686175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686178 */     // MIs[0] auxiliary
     /* 686178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686181 */     // MIs[0] Operand 7
     /* 686181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686199 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 686202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686211 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686229 */     GIR_RootConstrainSelectedInstOperands,
     /* 686230 */     // GIR_Coverage, 4900,
     /* 686230 */     GIR_EraseRootFromParent_Done,
     /* 686231 */   // Label 8839: @686231
     /* 686231 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(686300), // Rule ID 4904 //
     /* 686236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686244 */     // MIs[0] offset
     /* 686244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686247 */     // MIs[0] auxiliary
     /* 686247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686250 */     // MIs[0] Operand 7
     /* 686250 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686268 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 686271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686280 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686298 */     GIR_RootConstrainSelectedInstOperands,
     /* 686299 */     // GIR_Coverage, 4904,
     /* 686299 */     GIR_EraseRootFromParent_Done,
     /* 686300 */   // Label 8840: @686300
     /* 686300 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(686370), // Rule ID 4893 //
     /* 686305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686312 */     // MIs[0] offset
     /* 686312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686315 */     // MIs[0] auxiliary
     /* 686315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686318 */     // MIs[0] Operand 7
     /* 686318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686336 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 686339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686341 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686350 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686368 */     GIR_RootConstrainSelectedInstOperands,
     /* 686369 */     // GIR_Coverage, 4893,
     /* 686369 */     GIR_EraseRootFromParent_Done,
     /* 686370 */   // Label 8841: @686370
     /* 686370 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(686437), // Rule ID 4897 //
     /* 686375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686379 */     // MIs[0] offset
     /* 686379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686382 */     // MIs[0] auxiliary
     /* 686382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686385 */     // MIs[0] Operand 7
     /* 686385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686403 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 686406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686408 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686435 */     GIR_RootConstrainSelectedInstOperands,
     /* 686436 */     // GIR_Coverage, 4897,
     /* 686436 */     GIR_EraseRootFromParent_Done,
     /* 686437 */   // Label 8842: @686437
     /* 686437 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(686507), // Rule ID 4901 //
     /* 686442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686449 */     // MIs[0] offset
     /* 686449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686452 */     // MIs[0] auxiliary
     /* 686452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686455 */     // MIs[0] Operand 7
     /* 686455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686473 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 686476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686478 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686505 */     GIR_RootConstrainSelectedInstOperands,
     /* 686506 */     // GIR_Coverage, 4901,
     /* 686506 */     GIR_EraseRootFromParent_Done,
     /* 686507 */   // Label 8843: @686507
     /* 686507 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(686574), // Rule ID 4905 //
     /* 686512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686516 */     // MIs[0] offset
     /* 686516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686519 */     // MIs[0] auxiliary
     /* 686519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686522 */     // MIs[0] Operand 7
     /* 686522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686540 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 686543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686545 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686554 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686572 */     GIR_RootConstrainSelectedInstOperands,
     /* 686573 */     // GIR_Coverage, 4905,
     /* 686573 */     GIR_EraseRootFromParent_Done,
     /* 686574 */   // Label 8844: @686574
     /* 686574 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(686636), // Rule ID 4894 //
     /* 686579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686586 */     // MIs[0] offset
     /* 686586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686589 */     // MIs[0] auxiliary
     /* 686589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686592 */     // MIs[0] Operand 7
     /* 686592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686602 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 686605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686607 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686616 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686634 */     GIR_RootConstrainSelectedInstOperands,
     /* 686635 */     // GIR_Coverage, 4894,
     /* 686635 */     GIR_EraseRootFromParent_Done,
     /* 686636 */   // Label 8845: @686636
     /* 686636 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(686695), // Rule ID 4898 //
     /* 686641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686645 */     // MIs[0] offset
     /* 686645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686648 */     // MIs[0] auxiliary
     /* 686648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686651 */     // MIs[0] Operand 7
     /* 686651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686661 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 686664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686666 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686675 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686693 */     GIR_RootConstrainSelectedInstOperands,
     /* 686694 */     // GIR_Coverage, 4898,
     /* 686694 */     GIR_EraseRootFromParent_Done,
     /* 686695 */   // Label 8846: @686695
     /* 686695 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(686757), // Rule ID 4902 //
     /* 686700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686707 */     // MIs[0] offset
     /* 686707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686710 */     // MIs[0] auxiliary
     /* 686710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686713 */     // MIs[0] Operand 7
     /* 686713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686723 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 686726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686728 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686737 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686755 */     GIR_RootConstrainSelectedInstOperands,
     /* 686756 */     // GIR_Coverage, 4902,
     /* 686756 */     GIR_EraseRootFromParent_Done,
     /* 686757 */   // Label 8847: @686757
     /* 686757 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(686816), // Rule ID 4906 //
     /* 686762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686766 */     // MIs[0] offset
     /* 686766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686769 */     // MIs[0] auxiliary
     /* 686769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686772 */     // MIs[0] Operand 7
     /* 686772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686782 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 686785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686787 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686796 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686814 */     GIR_RootConstrainSelectedInstOperands,
     /* 686815 */     // GIR_Coverage, 4906,
     /* 686815 */     GIR_EraseRootFromParent_Done,
     /* 686816 */   // Label 8848: @686816
     /* 686816 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(686916), // Rule ID 4895 //
     /* 686821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686824 */     // MIs[0] offset
     /* 686824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686827 */     // MIs[0] auxiliary
     /* 686827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686830 */     // MIs[0] Operand 7
     /* 686830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686840 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686856 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686863 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 686884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686896 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686914 */     GIR_RootConstrainSelectedInstOperands,
     /* 686915 */     // GIR_Coverage, 4895,
     /* 686915 */     GIR_EraseRootFromParent_Done,
     /* 686916 */   // Label 8849: @686916
     /* 686916 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(687013), // Rule ID 4899 //
     /* 686921 */     // MIs[0] offset
     /* 686921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686924 */     // MIs[0] auxiliary
     /* 686924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686927 */     // MIs[0] Operand 7
     /* 686927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686937 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686953 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686960 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 686981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687011 */     GIR_RootConstrainSelectedInstOperands,
     /* 687012 */     // GIR_Coverage, 4899,
     /* 687012 */     GIR_EraseRootFromParent_Done,
     /* 687013 */   // Label 8850: @687013
     /* 687013 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(687113), // Rule ID 4903 //
     /* 687018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687021 */     // MIs[0] offset
     /* 687021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687024 */     // MIs[0] auxiliary
     /* 687024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687027 */     // MIs[0] Operand 7
     /* 687027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687037 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687053 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687060 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 687081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687093 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687111 */     GIR_RootConstrainSelectedInstOperands,
     /* 687112 */     // GIR_Coverage, 4903,
     /* 687112 */     GIR_EraseRootFromParent_Done,
     /* 687113 */   // Label 8851: @687113
     /* 687113 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(687210), // Rule ID 4907 //
     /* 687118 */     // MIs[0] offset
     /* 687118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687121 */     // MIs[0] auxiliary
     /* 687121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687124 */     // MIs[0] Operand 7
     /* 687124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687134 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687150 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687157 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 687178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687190 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687208 */     GIR_RootConstrainSelectedInstOperands,
     /* 687209 */     // GIR_Coverage, 4907,
     /* 687209 */     GIR_EraseRootFromParent_Done,
     /* 687210 */   // Label 8852: @687210
     /* 687210 */   GIM_Reject,
     /* 687211 */ // Label 8836: @687211
     /* 687211 */ GIM_Reject,
     /* 687212 */ // Label 8764: @687212
     /* 687212 */ GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(688426),
     /* 687217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 687220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 687223 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 687226 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 687229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 687233 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(687305), // Rule ID 4956 //
     /* 687238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687249 */     // MIs[0] offset
     /* 687249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687252 */     // MIs[0] auxiliary
     /* 687252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687255 */     // MIs[0] Operand 7
     /* 687255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687273 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 687276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687303 */     GIR_RootConstrainSelectedInstOperands,
     /* 687304 */     // GIR_Coverage, 4956,
     /* 687304 */     GIR_EraseRootFromParent_Done,
     /* 687305 */   // Label 8854: @687305
     /* 687305 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(687374), // Rule ID 4960 //
     /* 687310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687318 */     // MIs[0] offset
     /* 687318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687321 */     // MIs[0] auxiliary
     /* 687321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687324 */     // MIs[0] Operand 7
     /* 687324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687342 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 687345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687354 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687372 */     GIR_RootConstrainSelectedInstOperands,
     /* 687373 */     // GIR_Coverage, 4960,
     /* 687373 */     GIR_EraseRootFromParent_Done,
     /* 687374 */   // Label 8855: @687374
     /* 687374 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(687446), // Rule ID 4964 //
     /* 687379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687390 */     // MIs[0] offset
     /* 687390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687393 */     // MIs[0] auxiliary
     /* 687393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687396 */     // MIs[0] Operand 7
     /* 687396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687414 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 687417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687426 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687444 */     GIR_RootConstrainSelectedInstOperands,
     /* 687445 */     // GIR_Coverage, 4964,
     /* 687445 */     GIR_EraseRootFromParent_Done,
     /* 687446 */   // Label 8856: @687446
     /* 687446 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(687515), // Rule ID 4968 //
     /* 687451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687459 */     // MIs[0] offset
     /* 687459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687462 */     // MIs[0] auxiliary
     /* 687462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687465 */     // MIs[0] Operand 7
     /* 687465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687483 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 687486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687495 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687497 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687513 */     GIR_RootConstrainSelectedInstOperands,
     /* 687514 */     // GIR_Coverage, 4968,
     /* 687514 */     GIR_EraseRootFromParent_Done,
     /* 687515 */   // Label 8857: @687515
     /* 687515 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(687585), // Rule ID 4957 //
     /* 687520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687527 */     // MIs[0] offset
     /* 687527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687530 */     // MIs[0] auxiliary
     /* 687530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687533 */     // MIs[0] Operand 7
     /* 687533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687551 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 687554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687556 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687565 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687583 */     GIR_RootConstrainSelectedInstOperands,
     /* 687584 */     // GIR_Coverage, 4957,
     /* 687584 */     GIR_EraseRootFromParent_Done,
     /* 687585 */   // Label 8858: @687585
     /* 687585 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(687652), // Rule ID 4961 //
     /* 687590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687594 */     // MIs[0] offset
     /* 687594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687597 */     // MIs[0] auxiliary
     /* 687597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687600 */     // MIs[0] Operand 7
     /* 687600 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687618 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 687621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687623 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687632 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687650 */     GIR_RootConstrainSelectedInstOperands,
     /* 687651 */     // GIR_Coverage, 4961,
     /* 687651 */     GIR_EraseRootFromParent_Done,
     /* 687652 */   // Label 8859: @687652
     /* 687652 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(687722), // Rule ID 4965 //
     /* 687657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687664 */     // MIs[0] offset
     /* 687664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687667 */     // MIs[0] auxiliary
     /* 687667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687670 */     // MIs[0] Operand 7
     /* 687670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687688 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 687691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687693 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687720 */     GIR_RootConstrainSelectedInstOperands,
     /* 687721 */     // GIR_Coverage, 4965,
     /* 687721 */     GIR_EraseRootFromParent_Done,
     /* 687722 */   // Label 8860: @687722
     /* 687722 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(687789), // Rule ID 4969 //
     /* 687727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687731 */     // MIs[0] offset
     /* 687731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687734 */     // MIs[0] auxiliary
     /* 687734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687737 */     // MIs[0] Operand 7
     /* 687737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687755 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 687758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687760 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687769 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687787 */     GIR_RootConstrainSelectedInstOperands,
     /* 687788 */     // GIR_Coverage, 4969,
     /* 687788 */     GIR_EraseRootFromParent_Done,
     /* 687789 */   // Label 8861: @687789
     /* 687789 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(687851), // Rule ID 4958 //
     /* 687794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687801 */     // MIs[0] offset
     /* 687801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687804 */     // MIs[0] auxiliary
     /* 687804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687807 */     // MIs[0] Operand 7
     /* 687807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687817 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 687820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687822 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687831 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687849 */     GIR_RootConstrainSelectedInstOperands,
     /* 687850 */     // GIR_Coverage, 4958,
     /* 687850 */     GIR_EraseRootFromParent_Done,
     /* 687851 */   // Label 8862: @687851
     /* 687851 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(687910), // Rule ID 4962 //
     /* 687856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687860 */     // MIs[0] offset
     /* 687860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687863 */     // MIs[0] auxiliary
     /* 687863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687866 */     // MIs[0] Operand 7
     /* 687866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687876 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 687879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687881 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687890 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687908 */     GIR_RootConstrainSelectedInstOperands,
     /* 687909 */     // GIR_Coverage, 4962,
     /* 687909 */     GIR_EraseRootFromParent_Done,
     /* 687910 */   // Label 8863: @687910
     /* 687910 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(687972), // Rule ID 4966 //
     /* 687915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687922 */     // MIs[0] offset
     /* 687922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687925 */     // MIs[0] auxiliary
     /* 687925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687928 */     // MIs[0] Operand 7
     /* 687928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687938 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 687941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687943 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687952 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687970 */     GIR_RootConstrainSelectedInstOperands,
     /* 687971 */     // GIR_Coverage, 4966,
     /* 687971 */     GIR_EraseRootFromParent_Done,
     /* 687972 */   // Label 8864: @687972
     /* 687972 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(688031), // Rule ID 4970 //
     /* 687977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687981 */     // MIs[0] offset
     /* 687981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687984 */     // MIs[0] auxiliary
     /* 687984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687987 */     // MIs[0] Operand 7
     /* 687987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687997 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 688000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688002 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688011 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688029 */     GIR_RootConstrainSelectedInstOperands,
     /* 688030 */     // GIR_Coverage, 4970,
     /* 688030 */     GIR_EraseRootFromParent_Done,
     /* 688031 */   // Label 8865: @688031
     /* 688031 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(688131), // Rule ID 4959 //
     /* 688036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688039 */     // MIs[0] offset
     /* 688039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688042 */     // MIs[0] auxiliary
     /* 688042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688045 */     // MIs[0] Operand 7
     /* 688045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688055 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688071 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688078 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 688099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688111 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688129 */     GIR_RootConstrainSelectedInstOperands,
     /* 688130 */     // GIR_Coverage, 4959,
     /* 688130 */     GIR_EraseRootFromParent_Done,
     /* 688131 */   // Label 8866: @688131
     /* 688131 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(688228), // Rule ID 4963 //
     /* 688136 */     // MIs[0] offset
     /* 688136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688139 */     // MIs[0] auxiliary
     /* 688139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688142 */     // MIs[0] Operand 7
     /* 688142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688152 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688168 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688175 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 688196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688208 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688226 */     GIR_RootConstrainSelectedInstOperands,
     /* 688227 */     // GIR_Coverage, 4963,
     /* 688227 */     GIR_EraseRootFromParent_Done,
     /* 688228 */   // Label 8867: @688228
     /* 688228 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(688328), // Rule ID 4967 //
     /* 688233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688236 */     // MIs[0] offset
     /* 688236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688239 */     // MIs[0] auxiliary
     /* 688239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688242 */     // MIs[0] Operand 7
     /* 688242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688252 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688268 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688271 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688275 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 688296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688308 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688310 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688326 */     GIR_RootConstrainSelectedInstOperands,
     /* 688327 */     // GIR_Coverage, 4967,
     /* 688327 */     GIR_EraseRootFromParent_Done,
     /* 688328 */   // Label 8868: @688328
     /* 688328 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(688425), // Rule ID 4971 //
     /* 688333 */     // MIs[0] offset
     /* 688333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688336 */     // MIs[0] auxiliary
     /* 688336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688339 */     // MIs[0] Operand 7
     /* 688339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688349 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688365 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688372 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 688393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688405 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688423 */     GIR_RootConstrainSelectedInstOperands,
     /* 688424 */     // GIR_Coverage, 4971,
     /* 688424 */     GIR_EraseRootFromParent_Done,
     /* 688425 */   // Label 8869: @688425
     /* 688425 */   GIM_Reject,
     /* 688426 */ // Label 8853: @688426
     /* 688426 */ GIM_Reject,
     /* 688427 */ // Label 8765: @688427
     /* 688427 */ GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(689641),
     /* 688432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 688435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 688438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 688441 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 688444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 688448 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(688520), // Rule ID 4908 //
     /* 688453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688464 */     // MIs[0] offset
     /* 688464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688467 */     // MIs[0] auxiliary
     /* 688467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688470 */     // MIs[0] Operand 7
     /* 688470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688488 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 688491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688500 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688518 */     GIR_RootConstrainSelectedInstOperands,
     /* 688519 */     // GIR_Coverage, 4908,
     /* 688519 */     GIR_EraseRootFromParent_Done,
     /* 688520 */   // Label 8871: @688520
     /* 688520 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(688589), // Rule ID 4912 //
     /* 688525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688533 */     // MIs[0] offset
     /* 688533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688536 */     // MIs[0] auxiliary
     /* 688536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688539 */     // MIs[0] Operand 7
     /* 688539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688557 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 688560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688587 */     GIR_RootConstrainSelectedInstOperands,
     /* 688588 */     // GIR_Coverage, 4912,
     /* 688588 */     GIR_EraseRootFromParent_Done,
     /* 688589 */   // Label 8872: @688589
     /* 688589 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(688661), // Rule ID 4916 //
     /* 688594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688605 */     // MIs[0] offset
     /* 688605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688608 */     // MIs[0] auxiliary
     /* 688608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688611 */     // MIs[0] Operand 7
     /* 688611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688629 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 688632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688641 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688659 */     GIR_RootConstrainSelectedInstOperands,
     /* 688660 */     // GIR_Coverage, 4916,
     /* 688660 */     GIR_EraseRootFromParent_Done,
     /* 688661 */   // Label 8873: @688661
     /* 688661 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(688730), // Rule ID 4920 //
     /* 688666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688674 */     // MIs[0] offset
     /* 688674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688677 */     // MIs[0] auxiliary
     /* 688677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688680 */     // MIs[0] Operand 7
     /* 688680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688698 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 688701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688710 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688728 */     GIR_RootConstrainSelectedInstOperands,
     /* 688729 */     // GIR_Coverage, 4920,
     /* 688729 */     GIR_EraseRootFromParent_Done,
     /* 688730 */   // Label 8874: @688730
     /* 688730 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(688800), // Rule ID 4909 //
     /* 688735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688742 */     // MIs[0] offset
     /* 688742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688745 */     // MIs[0] auxiliary
     /* 688745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688748 */     // MIs[0] Operand 7
     /* 688748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688766 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 688769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688771 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688798 */     GIR_RootConstrainSelectedInstOperands,
     /* 688799 */     // GIR_Coverage, 4909,
     /* 688799 */     GIR_EraseRootFromParent_Done,
     /* 688800 */   // Label 8875: @688800
     /* 688800 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(688867), // Rule ID 4913 //
     /* 688805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688809 */     // MIs[0] offset
     /* 688809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688812 */     // MIs[0] auxiliary
     /* 688812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688815 */     // MIs[0] Operand 7
     /* 688815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688833 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 688836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688838 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688847 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688865 */     GIR_RootConstrainSelectedInstOperands,
     /* 688866 */     // GIR_Coverage, 4913,
     /* 688866 */     GIR_EraseRootFromParent_Done,
     /* 688867 */   // Label 8876: @688867
     /* 688867 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(688937), // Rule ID 4917 //
     /* 688872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688879 */     // MIs[0] offset
     /* 688879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688882 */     // MIs[0] auxiliary
     /* 688882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688885 */     // MIs[0] Operand 7
     /* 688885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688903 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 688906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688908 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688935 */     GIR_RootConstrainSelectedInstOperands,
     /* 688936 */     // GIR_Coverage, 4917,
     /* 688936 */     GIR_EraseRootFromParent_Done,
     /* 688937 */   // Label 8877: @688937
     /* 688937 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(689004), // Rule ID 4921 //
     /* 688942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688946 */     // MIs[0] offset
     /* 688946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688949 */     // MIs[0] auxiliary
     /* 688949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688952 */     // MIs[0] Operand 7
     /* 688952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688970 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 688973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688975 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689002 */     GIR_RootConstrainSelectedInstOperands,
     /* 689003 */     // GIR_Coverage, 4921,
     /* 689003 */     GIR_EraseRootFromParent_Done,
     /* 689004 */   // Label 8878: @689004
     /* 689004 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(689066), // Rule ID 4910 //
     /* 689009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689016 */     // MIs[0] offset
     /* 689016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689019 */     // MIs[0] auxiliary
     /* 689019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689022 */     // MIs[0] Operand 7
     /* 689022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689032 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 689035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689037 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689046 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689064 */     GIR_RootConstrainSelectedInstOperands,
     /* 689065 */     // GIR_Coverage, 4910,
     /* 689065 */     GIR_EraseRootFromParent_Done,
     /* 689066 */   // Label 8879: @689066
     /* 689066 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(689125), // Rule ID 4914 //
     /* 689071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689075 */     // MIs[0] offset
     /* 689075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689078 */     // MIs[0] auxiliary
     /* 689078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689081 */     // MIs[0] Operand 7
     /* 689081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689091 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 689094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689096 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689105 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689123 */     GIR_RootConstrainSelectedInstOperands,
     /* 689124 */     // GIR_Coverage, 4914,
     /* 689124 */     GIR_EraseRootFromParent_Done,
     /* 689125 */   // Label 8880: @689125
     /* 689125 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(689187), // Rule ID 4918 //
     /* 689130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689137 */     // MIs[0] offset
     /* 689137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689140 */     // MIs[0] auxiliary
     /* 689140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689143 */     // MIs[0] Operand 7
     /* 689143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689153 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 689156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689158 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689167 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689185 */     GIR_RootConstrainSelectedInstOperands,
     /* 689186 */     // GIR_Coverage, 4918,
     /* 689186 */     GIR_EraseRootFromParent_Done,
     /* 689187 */   // Label 8881: @689187
     /* 689187 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(689246), // Rule ID 4922 //
     /* 689192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689196 */     // MIs[0] offset
     /* 689196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689199 */     // MIs[0] auxiliary
     /* 689199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689202 */     // MIs[0] Operand 7
     /* 689202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689212 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 689215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689217 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689226 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689244 */     GIR_RootConstrainSelectedInstOperands,
     /* 689245 */     // GIR_Coverage, 4922,
     /* 689245 */     GIR_EraseRootFromParent_Done,
     /* 689246 */   // Label 8882: @689246
     /* 689246 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(689346), // Rule ID 4911 //
     /* 689251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689254 */     // MIs[0] offset
     /* 689254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689257 */     // MIs[0] auxiliary
     /* 689257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689260 */     // MIs[0] Operand 7
     /* 689260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689270 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689286 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689293 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689326 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689344 */     GIR_RootConstrainSelectedInstOperands,
     /* 689345 */     // GIR_Coverage, 4911,
     /* 689345 */     GIR_EraseRootFromParent_Done,
     /* 689346 */   // Label 8883: @689346
     /* 689346 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(689443), // Rule ID 4915 //
     /* 689351 */     // MIs[0] offset
     /* 689351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689354 */     // MIs[0] auxiliary
     /* 689354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689357 */     // MIs[0] Operand 7
     /* 689357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689367 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689383 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689390 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 689411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689423 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689441 */     GIR_RootConstrainSelectedInstOperands,
     /* 689442 */     // GIR_Coverage, 4915,
     /* 689442 */     GIR_EraseRootFromParent_Done,
     /* 689443 */   // Label 8884: @689443
     /* 689443 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(689543), // Rule ID 4919 //
     /* 689448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689451 */     // MIs[0] offset
     /* 689451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689454 */     // MIs[0] auxiliary
     /* 689454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689457 */     // MIs[0] Operand 7
     /* 689457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689467 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689483 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689490 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689523 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689541 */     GIR_RootConstrainSelectedInstOperands,
     /* 689542 */     // GIR_Coverage, 4919,
     /* 689542 */     GIR_EraseRootFromParent_Done,
     /* 689543 */   // Label 8885: @689543
     /* 689543 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(689640), // Rule ID 4923 //
     /* 689548 */     // MIs[0] offset
     /* 689548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689551 */     // MIs[0] auxiliary
     /* 689551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689554 */     // MIs[0] Operand 7
     /* 689554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689564 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689580 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 689608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689620 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689638 */     GIR_RootConstrainSelectedInstOperands,
     /* 689639 */     // GIR_Coverage, 4923,
     /* 689639 */     GIR_EraseRootFromParent_Done,
     /* 689640 */   // Label 8886: @689640
     /* 689640 */   GIM_Reject,
     /* 689641 */ // Label 8870: @689641
     /* 689641 */ GIM_Reject,
     /* 689642 */ // Label 8766: @689642
     /* 689642 */ GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(690856),
     /* 689647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 689650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 689653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 689656 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 689659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 689663 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(689735), // Rule ID 4972 //
     /* 689668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689679 */     // MIs[0] offset
     /* 689679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689682 */     // MIs[0] auxiliary
     /* 689682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689685 */     // MIs[0] Operand 7
     /* 689685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689703 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 689706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689733 */     GIR_RootConstrainSelectedInstOperands,
     /* 689734 */     // GIR_Coverage, 4972,
     /* 689734 */     GIR_EraseRootFromParent_Done,
     /* 689735 */   // Label 8888: @689735
     /* 689735 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(689804), // Rule ID 4976 //
     /* 689740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689748 */     // MIs[0] offset
     /* 689748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689751 */     // MIs[0] auxiliary
     /* 689751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689754 */     // MIs[0] Operand 7
     /* 689754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689772 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 689775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689784 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689802 */     GIR_RootConstrainSelectedInstOperands,
     /* 689803 */     // GIR_Coverage, 4976,
     /* 689803 */     GIR_EraseRootFromParent_Done,
     /* 689804 */   // Label 8889: @689804
     /* 689804 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(689876), // Rule ID 4980 //
     /* 689809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689820 */     // MIs[0] offset
     /* 689820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689823 */     // MIs[0] auxiliary
     /* 689823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689826 */     // MIs[0] Operand 7
     /* 689826 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689844 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 689847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689856 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689864 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689874 */     GIR_RootConstrainSelectedInstOperands,
     /* 689875 */     // GIR_Coverage, 4980,
     /* 689875 */     GIR_EraseRootFromParent_Done,
     /* 689876 */   // Label 8890: @689876
     /* 689876 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(689945), // Rule ID 4984 //
     /* 689881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689889 */     // MIs[0] offset
     /* 689889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689892 */     // MIs[0] auxiliary
     /* 689892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689895 */     // MIs[0] Operand 7
     /* 689895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689913 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 689916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689925 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689943 */     GIR_RootConstrainSelectedInstOperands,
     /* 689944 */     // GIR_Coverage, 4984,
     /* 689944 */     GIR_EraseRootFromParent_Done,
     /* 689945 */   // Label 8891: @689945
     /* 689945 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(690015), // Rule ID 4973 //
     /* 689950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689957 */     // MIs[0] offset
     /* 689957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689960 */     // MIs[0] auxiliary
     /* 689960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689963 */     // MIs[0] Operand 7
     /* 689963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689981 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 689984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689986 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689995 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690013 */     GIR_RootConstrainSelectedInstOperands,
     /* 690014 */     // GIR_Coverage, 4973,
     /* 690014 */     GIR_EraseRootFromParent_Done,
     /* 690015 */   // Label 8892: @690015
     /* 690015 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(690082), // Rule ID 4977 //
     /* 690020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690024 */     // MIs[0] offset
     /* 690024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690027 */     // MIs[0] auxiliary
     /* 690027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690030 */     // MIs[0] Operand 7
     /* 690030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690048 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 690051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690053 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690080 */     GIR_RootConstrainSelectedInstOperands,
     /* 690081 */     // GIR_Coverage, 4977,
     /* 690081 */     GIR_EraseRootFromParent_Done,
     /* 690082 */   // Label 8893: @690082
     /* 690082 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(690152), // Rule ID 4981 //
     /* 690087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690094 */     // MIs[0] offset
     /* 690094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690097 */     // MIs[0] auxiliary
     /* 690097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690100 */     // MIs[0] Operand 7
     /* 690100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690118 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 690121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690123 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690150 */     GIR_RootConstrainSelectedInstOperands,
     /* 690151 */     // GIR_Coverage, 4981,
     /* 690151 */     GIR_EraseRootFromParent_Done,
     /* 690152 */   // Label 8894: @690152
     /* 690152 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(690219), // Rule ID 4985 //
     /* 690157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690161 */     // MIs[0] offset
     /* 690161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690164 */     // MIs[0] auxiliary
     /* 690164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690167 */     // MIs[0] Operand 7
     /* 690167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690185 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 690188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690190 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690217 */     GIR_RootConstrainSelectedInstOperands,
     /* 690218 */     // GIR_Coverage, 4985,
     /* 690218 */     GIR_EraseRootFromParent_Done,
     /* 690219 */   // Label 8895: @690219
     /* 690219 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(690281), // Rule ID 4974 //
     /* 690224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690231 */     // MIs[0] offset
     /* 690231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690234 */     // MIs[0] auxiliary
     /* 690234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690237 */     // MIs[0] Operand 7
     /* 690237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690247 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 690250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690252 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690279 */     GIR_RootConstrainSelectedInstOperands,
     /* 690280 */     // GIR_Coverage, 4974,
     /* 690280 */     GIR_EraseRootFromParent_Done,
     /* 690281 */   // Label 8896: @690281
     /* 690281 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(690340), // Rule ID 4978 //
     /* 690286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690290 */     // MIs[0] offset
     /* 690290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690293 */     // MIs[0] auxiliary
     /* 690293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690296 */     // MIs[0] Operand 7
     /* 690296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690306 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 690309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690311 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690320 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690338 */     GIR_RootConstrainSelectedInstOperands,
     /* 690339 */     // GIR_Coverage, 4978,
     /* 690339 */     GIR_EraseRootFromParent_Done,
     /* 690340 */   // Label 8897: @690340
     /* 690340 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(690402), // Rule ID 4982 //
     /* 690345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690352 */     // MIs[0] offset
     /* 690352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690355 */     // MIs[0] auxiliary
     /* 690355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690358 */     // MIs[0] Operand 7
     /* 690358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690368 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 690371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690373 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690382 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690400 */     GIR_RootConstrainSelectedInstOperands,
     /* 690401 */     // GIR_Coverage, 4982,
     /* 690401 */     GIR_EraseRootFromParent_Done,
     /* 690402 */   // Label 8898: @690402
     /* 690402 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(690461), // Rule ID 4986 //
     /* 690407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690411 */     // MIs[0] offset
     /* 690411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690414 */     // MIs[0] auxiliary
     /* 690414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690417 */     // MIs[0] Operand 7
     /* 690417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690427 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 690430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690432 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690441 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690459 */     GIR_RootConstrainSelectedInstOperands,
     /* 690460 */     // GIR_Coverage, 4986,
     /* 690460 */     GIR_EraseRootFromParent_Done,
     /* 690461 */   // Label 8899: @690461
     /* 690461 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(690561), // Rule ID 4975 //
     /* 690466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690469 */     // MIs[0] offset
     /* 690469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690472 */     // MIs[0] auxiliary
     /* 690472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690475 */     // MIs[0] Operand 7
     /* 690475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690485 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690501 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690508 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 690529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690541 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690559 */     GIR_RootConstrainSelectedInstOperands,
     /* 690560 */     // GIR_Coverage, 4975,
     /* 690560 */     GIR_EraseRootFromParent_Done,
     /* 690561 */   // Label 8900: @690561
     /* 690561 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(690658), // Rule ID 4979 //
     /* 690566 */     // MIs[0] offset
     /* 690566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690569 */     // MIs[0] auxiliary
     /* 690569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690572 */     // MIs[0] Operand 7
     /* 690572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690582 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690605 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 690626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690656 */     GIR_RootConstrainSelectedInstOperands,
     /* 690657 */     // GIR_Coverage, 4979,
     /* 690657 */     GIR_EraseRootFromParent_Done,
     /* 690658 */   // Label 8901: @690658
     /* 690658 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(690758), // Rule ID 4983 //
     /* 690663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690666 */     // MIs[0] offset
     /* 690666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690669 */     // MIs[0] auxiliary
     /* 690669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690672 */     // MIs[0] Operand 7
     /* 690672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690682 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690698 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690705 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 690726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690738 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690756 */     GIR_RootConstrainSelectedInstOperands,
     /* 690757 */     // GIR_Coverage, 4983,
     /* 690757 */     GIR_EraseRootFromParent_Done,
     /* 690758 */   // Label 8902: @690758
     /* 690758 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(690855), // Rule ID 4987 //
     /* 690763 */     // MIs[0] offset
     /* 690763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690766 */     // MIs[0] auxiliary
     /* 690766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690769 */     // MIs[0] Operand 7
     /* 690769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690779 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690795 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690802 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 690823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690835 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690853 */     GIR_RootConstrainSelectedInstOperands,
     /* 690854 */     // GIR_Coverage, 4987,
     /* 690854 */     GIR_EraseRootFromParent_Done,
     /* 690855 */   // Label 8903: @690855
     /* 690855 */   GIM_Reject,
     /* 690856 */ // Label 8887: @690856
     /* 690856 */ GIM_Reject,
     /* 690857 */ // Label 8767: @690857
     /* 690857 */ GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(692071),
     /* 690862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 690865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 690868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 690871 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 690874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 690878 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(690950), // Rule ID 5060 //
     /* 690883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690894 */     // MIs[0] offset
     /* 690894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690897 */     // MIs[0] auxiliary
     /* 690897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690900 */     // MIs[0] Operand 7
     /* 690900 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690918 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 690921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690930 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690948 */     GIR_RootConstrainSelectedInstOperands,
     /* 690949 */     // GIR_Coverage, 5060,
     /* 690949 */     GIR_EraseRootFromParent_Done,
     /* 690950 */   // Label 8905: @690950
     /* 690950 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(691019), // Rule ID 5064 //
     /* 690955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690963 */     // MIs[0] offset
     /* 690963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690966 */     // MIs[0] auxiliary
     /* 690966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690969 */     // MIs[0] Operand 7
     /* 690969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690987 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 690990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690999 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691017 */     GIR_RootConstrainSelectedInstOperands,
     /* 691018 */     // GIR_Coverage, 5064,
     /* 691018 */     GIR_EraseRootFromParent_Done,
     /* 691019 */   // Label 8906: @691019
     /* 691019 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(691091), // Rule ID 5068 //
     /* 691024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691035 */     // MIs[0] offset
     /* 691035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691038 */     // MIs[0] auxiliary
     /* 691038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691041 */     // MIs[0] Operand 7
     /* 691041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691059 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 691062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691071 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691089 */     GIR_RootConstrainSelectedInstOperands,
     /* 691090 */     // GIR_Coverage, 5068,
     /* 691090 */     GIR_EraseRootFromParent_Done,
     /* 691091 */   // Label 8907: @691091
     /* 691091 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(691160), // Rule ID 5072 //
     /* 691096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691104 */     // MIs[0] offset
     /* 691104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691107 */     // MIs[0] auxiliary
     /* 691107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691110 */     // MIs[0] Operand 7
     /* 691110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691128 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 691131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691140 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691158 */     GIR_RootConstrainSelectedInstOperands,
     /* 691159 */     // GIR_Coverage, 5072,
     /* 691159 */     GIR_EraseRootFromParent_Done,
     /* 691160 */   // Label 8908: @691160
     /* 691160 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(691230), // Rule ID 5061 //
     /* 691165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691172 */     // MIs[0] offset
     /* 691172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691175 */     // MIs[0] auxiliary
     /* 691175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691178 */     // MIs[0] Operand 7
     /* 691178 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691196 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 691199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691201 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691210 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691228 */     GIR_RootConstrainSelectedInstOperands,
     /* 691229 */     // GIR_Coverage, 5061,
     /* 691229 */     GIR_EraseRootFromParent_Done,
     /* 691230 */   // Label 8909: @691230
     /* 691230 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(691297), // Rule ID 5065 //
     /* 691235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691239 */     // MIs[0] offset
     /* 691239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691242 */     // MIs[0] auxiliary
     /* 691242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691245 */     // MIs[0] Operand 7
     /* 691245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691263 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 691266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691268 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691277 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691295 */     GIR_RootConstrainSelectedInstOperands,
     /* 691296 */     // GIR_Coverage, 5065,
     /* 691296 */     GIR_EraseRootFromParent_Done,
     /* 691297 */   // Label 8910: @691297
     /* 691297 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(691367), // Rule ID 5069 //
     /* 691302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691309 */     // MIs[0] offset
     /* 691309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691312 */     // MIs[0] auxiliary
     /* 691312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691315 */     // MIs[0] Operand 7
     /* 691315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691333 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 691336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691338 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691347 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691365 */     GIR_RootConstrainSelectedInstOperands,
     /* 691366 */     // GIR_Coverage, 5069,
     /* 691366 */     GIR_EraseRootFromParent_Done,
     /* 691367 */   // Label 8911: @691367
     /* 691367 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(691434), // Rule ID 5073 //
     /* 691372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691376 */     // MIs[0] offset
     /* 691376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691379 */     // MIs[0] auxiliary
     /* 691379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691382 */     // MIs[0] Operand 7
     /* 691382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691400 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 691403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691405 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691414 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691432 */     GIR_RootConstrainSelectedInstOperands,
     /* 691433 */     // GIR_Coverage, 5073,
     /* 691433 */     GIR_EraseRootFromParent_Done,
     /* 691434 */   // Label 8912: @691434
     /* 691434 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(691496), // Rule ID 5062 //
     /* 691439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691446 */     // MIs[0] offset
     /* 691446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691449 */     // MIs[0] auxiliary
     /* 691449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691452 */     // MIs[0] Operand 7
     /* 691452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691462 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 691465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691467 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691476 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691494 */     GIR_RootConstrainSelectedInstOperands,
     /* 691495 */     // GIR_Coverage, 5062,
     /* 691495 */     GIR_EraseRootFromParent_Done,
     /* 691496 */   // Label 8913: @691496
     /* 691496 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(691555), // Rule ID 5066 //
     /* 691501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691505 */     // MIs[0] offset
     /* 691505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691508 */     // MIs[0] auxiliary
     /* 691508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691511 */     // MIs[0] Operand 7
     /* 691511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691521 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 691524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691526 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691535 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691553 */     GIR_RootConstrainSelectedInstOperands,
     /* 691554 */     // GIR_Coverage, 5066,
     /* 691554 */     GIR_EraseRootFromParent_Done,
     /* 691555 */   // Label 8914: @691555
     /* 691555 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(691617), // Rule ID 5070 //
     /* 691560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691567 */     // MIs[0] offset
     /* 691567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691570 */     // MIs[0] auxiliary
     /* 691570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691573 */     // MIs[0] Operand 7
     /* 691573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691583 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 691586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691588 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691597 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691615 */     GIR_RootConstrainSelectedInstOperands,
     /* 691616 */     // GIR_Coverage, 5070,
     /* 691616 */     GIR_EraseRootFromParent_Done,
     /* 691617 */   // Label 8915: @691617
     /* 691617 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(691676), // Rule ID 5074 //
     /* 691622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691626 */     // MIs[0] offset
     /* 691626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691629 */     // MIs[0] auxiliary
     /* 691629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691632 */     // MIs[0] Operand 7
     /* 691632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691642 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 691645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691647 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691674 */     GIR_RootConstrainSelectedInstOperands,
     /* 691675 */     // GIR_Coverage, 5074,
     /* 691675 */     GIR_EraseRootFromParent_Done,
     /* 691676 */   // Label 8916: @691676
     /* 691676 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(691776), // Rule ID 5063 //
     /* 691681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691684 */     // MIs[0] offset
     /* 691684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691687 */     // MIs[0] auxiliary
     /* 691687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691690 */     // MIs[0] Operand 7
     /* 691690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691700 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691716 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691723 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 691744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691756 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691774 */     GIR_RootConstrainSelectedInstOperands,
     /* 691775 */     // GIR_Coverage, 5063,
     /* 691775 */     GIR_EraseRootFromParent_Done,
     /* 691776 */   // Label 8917: @691776
     /* 691776 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(691873), // Rule ID 5067 //
     /* 691781 */     // MIs[0] offset
     /* 691781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691784 */     // MIs[0] auxiliary
     /* 691784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691787 */     // MIs[0] Operand 7
     /* 691787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691797 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691813 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691820 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 691841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691853 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691871 */     GIR_RootConstrainSelectedInstOperands,
     /* 691872 */     // GIR_Coverage, 5067,
     /* 691872 */     GIR_EraseRootFromParent_Done,
     /* 691873 */   // Label 8918: @691873
     /* 691873 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(691973), // Rule ID 5071 //
     /* 691878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691881 */     // MIs[0] offset
     /* 691881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691884 */     // MIs[0] auxiliary
     /* 691884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691887 */     // MIs[0] Operand 7
     /* 691887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691897 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691913 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691920 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 691941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691971 */     GIR_RootConstrainSelectedInstOperands,
     /* 691972 */     // GIR_Coverage, 5071,
     /* 691972 */     GIR_EraseRootFromParent_Done,
     /* 691973 */   // Label 8919: @691973
     /* 691973 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(692070), // Rule ID 5075 //
     /* 691978 */     // MIs[0] offset
     /* 691978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691981 */     // MIs[0] auxiliary
     /* 691981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691984 */     // MIs[0] Operand 7
     /* 691984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691994 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692010 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692017 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 692038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692050 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692068 */     GIR_RootConstrainSelectedInstOperands,
     /* 692069 */     // GIR_Coverage, 5075,
     /* 692069 */     GIR_EraseRootFromParent_Done,
     /* 692070 */   // Label 8920: @692070
     /* 692070 */   GIM_Reject,
     /* 692071 */ // Label 8904: @692071
     /* 692071 */ GIM_Reject,
     /* 692072 */ // Label 8768: @692072
     /* 692072 */ GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(693286),
     /* 692077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 692080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 692083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 692086 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 692089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 692093 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(692165), // Rule ID 5028 //
     /* 692098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692109 */     // MIs[0] offset
     /* 692109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692112 */     // MIs[0] auxiliary
     /* 692112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692115 */     // MIs[0] Operand 7
     /* 692115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692133 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 692136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692145 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692163 */     GIR_RootConstrainSelectedInstOperands,
     /* 692164 */     // GIR_Coverage, 5028,
     /* 692164 */     GIR_EraseRootFromParent_Done,
     /* 692165 */   // Label 8922: @692165
     /* 692165 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(692234), // Rule ID 5032 //
     /* 692170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692178 */     // MIs[0] offset
     /* 692178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692181 */     // MIs[0] auxiliary
     /* 692181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692184 */     // MIs[0] Operand 7
     /* 692184 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692202 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 692205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692214 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692232 */     GIR_RootConstrainSelectedInstOperands,
     /* 692233 */     // GIR_Coverage, 5032,
     /* 692233 */     GIR_EraseRootFromParent_Done,
     /* 692234 */   // Label 8923: @692234
     /* 692234 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(692306), // Rule ID 5036 //
     /* 692239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692250 */     // MIs[0] offset
     /* 692250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692253 */     // MIs[0] auxiliary
     /* 692253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692256 */     // MIs[0] Operand 7
     /* 692256 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692274 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 692277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692304 */     GIR_RootConstrainSelectedInstOperands,
     /* 692305 */     // GIR_Coverage, 5036,
     /* 692305 */     GIR_EraseRootFromParent_Done,
     /* 692306 */   // Label 8924: @692306
     /* 692306 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(692375), // Rule ID 5040 //
     /* 692311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692319 */     // MIs[0] offset
     /* 692319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692322 */     // MIs[0] auxiliary
     /* 692322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692325 */     // MIs[0] Operand 7
     /* 692325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692343 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 692346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692355 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692373 */     GIR_RootConstrainSelectedInstOperands,
     /* 692374 */     // GIR_Coverage, 5040,
     /* 692374 */     GIR_EraseRootFromParent_Done,
     /* 692375 */   // Label 8925: @692375
     /* 692375 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(692445), // Rule ID 5029 //
     /* 692380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692387 */     // MIs[0] offset
     /* 692387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692390 */     // MIs[0] auxiliary
     /* 692390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692393 */     // MIs[0] Operand 7
     /* 692393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692411 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 692414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692416 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692425 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692443 */     GIR_RootConstrainSelectedInstOperands,
     /* 692444 */     // GIR_Coverage, 5029,
     /* 692444 */     GIR_EraseRootFromParent_Done,
     /* 692445 */   // Label 8926: @692445
     /* 692445 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(692512), // Rule ID 5033 //
     /* 692450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692454 */     // MIs[0] offset
     /* 692454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692457 */     // MIs[0] auxiliary
     /* 692457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692460 */     // MIs[0] Operand 7
     /* 692460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692478 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 692481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692483 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692510 */     GIR_RootConstrainSelectedInstOperands,
     /* 692511 */     // GIR_Coverage, 5033,
     /* 692511 */     GIR_EraseRootFromParent_Done,
     /* 692512 */   // Label 8927: @692512
     /* 692512 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(692582), // Rule ID 5037 //
     /* 692517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692524 */     // MIs[0] offset
     /* 692524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692527 */     // MIs[0] auxiliary
     /* 692527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692530 */     // MIs[0] Operand 7
     /* 692530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692548 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 692551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692553 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692580 */     GIR_RootConstrainSelectedInstOperands,
     /* 692581 */     // GIR_Coverage, 5037,
     /* 692581 */     GIR_EraseRootFromParent_Done,
     /* 692582 */   // Label 8928: @692582
     /* 692582 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(692649), // Rule ID 5041 //
     /* 692587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692591 */     // MIs[0] offset
     /* 692591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692594 */     // MIs[0] auxiliary
     /* 692594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692597 */     // MIs[0] Operand 7
     /* 692597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692615 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 692618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692620 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692629 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692647 */     GIR_RootConstrainSelectedInstOperands,
     /* 692648 */     // GIR_Coverage, 5041,
     /* 692648 */     GIR_EraseRootFromParent_Done,
     /* 692649 */   // Label 8929: @692649
     /* 692649 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(692711), // Rule ID 5030 //
     /* 692654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692661 */     // MIs[0] offset
     /* 692661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692664 */     // MIs[0] auxiliary
     /* 692664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692667 */     // MIs[0] Operand 7
     /* 692667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692677 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 692680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692682 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692709 */     GIR_RootConstrainSelectedInstOperands,
     /* 692710 */     // GIR_Coverage, 5030,
     /* 692710 */     GIR_EraseRootFromParent_Done,
     /* 692711 */   // Label 8930: @692711
     /* 692711 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(692770), // Rule ID 5034 //
     /* 692716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692720 */     // MIs[0] offset
     /* 692720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692723 */     // MIs[0] auxiliary
     /* 692723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692726 */     // MIs[0] Operand 7
     /* 692726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692736 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 692739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692741 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692750 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692768 */     GIR_RootConstrainSelectedInstOperands,
     /* 692769 */     // GIR_Coverage, 5034,
     /* 692769 */     GIR_EraseRootFromParent_Done,
     /* 692770 */   // Label 8931: @692770
     /* 692770 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(692832), // Rule ID 5038 //
     /* 692775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692782 */     // MIs[0] offset
     /* 692782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692785 */     // MIs[0] auxiliary
     /* 692785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692788 */     // MIs[0] Operand 7
     /* 692788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692798 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 692801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692830 */     GIR_RootConstrainSelectedInstOperands,
     /* 692831 */     // GIR_Coverage, 5038,
     /* 692831 */     GIR_EraseRootFromParent_Done,
     /* 692832 */   // Label 8932: @692832
     /* 692832 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(692891), // Rule ID 5042 //
     /* 692837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692841 */     // MIs[0] offset
     /* 692841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692844 */     // MIs[0] auxiliary
     /* 692844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692847 */     // MIs[0] Operand 7
     /* 692847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692857 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 692860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692889 */     GIR_RootConstrainSelectedInstOperands,
     /* 692890 */     // GIR_Coverage, 5042,
     /* 692890 */     GIR_EraseRootFromParent_Done,
     /* 692891 */   // Label 8933: @692891
     /* 692891 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(692991), // Rule ID 5031 //
     /* 692896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692899 */     // MIs[0] offset
     /* 692899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692902 */     // MIs[0] auxiliary
     /* 692902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692905 */     // MIs[0] Operand 7
     /* 692905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692915 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692931 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 692959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692971 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692989 */     GIR_RootConstrainSelectedInstOperands,
     /* 692990 */     // GIR_Coverage, 5031,
     /* 692990 */     GIR_EraseRootFromParent_Done,
     /* 692991 */   // Label 8934: @692991
     /* 692991 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(693088), // Rule ID 5035 //
     /* 692996 */     // MIs[0] offset
     /* 692996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692999 */     // MIs[0] auxiliary
     /* 692999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693002 */     // MIs[0] Operand 7
     /* 693002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693012 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693028 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693035 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 693056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693068 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693086 */     GIR_RootConstrainSelectedInstOperands,
     /* 693087 */     // GIR_Coverage, 5035,
     /* 693087 */     GIR_EraseRootFromParent_Done,
     /* 693088 */   // Label 8935: @693088
     /* 693088 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(693188), // Rule ID 5039 //
     /* 693093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693096 */     // MIs[0] offset
     /* 693096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693099 */     // MIs[0] auxiliary
     /* 693099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693102 */     // MIs[0] Operand 7
     /* 693102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693112 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693128 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693135 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 693156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693186 */     GIR_RootConstrainSelectedInstOperands,
     /* 693187 */     // GIR_Coverage, 5039,
     /* 693187 */     GIR_EraseRootFromParent_Done,
     /* 693188 */   // Label 8936: @693188
     /* 693188 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(693285), // Rule ID 5043 //
     /* 693193 */     // MIs[0] offset
     /* 693193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693196 */     // MIs[0] auxiliary
     /* 693196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693199 */     // MIs[0] Operand 7
     /* 693199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693209 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693225 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693232 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 693253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693265 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693283 */     GIR_RootConstrainSelectedInstOperands,
     /* 693284 */     // GIR_Coverage, 5043,
     /* 693284 */     GIR_EraseRootFromParent_Done,
     /* 693285 */   // Label 8937: @693285
     /* 693285 */   GIM_Reject,
     /* 693286 */ // Label 8921: @693286
     /* 693286 */ GIM_Reject,
     /* 693287 */ // Label 8769: @693287
     /* 693287 */ GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(694501),
     /* 693292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 693295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 693298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 693301 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 693304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 693308 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(693380), // Rule ID 5012 //
     /* 693313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693324 */     // MIs[0] offset
     /* 693324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693327 */     // MIs[0] auxiliary
     /* 693327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693330 */     // MIs[0] Operand 7
     /* 693330 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693348 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693378 */     GIR_RootConstrainSelectedInstOperands,
     /* 693379 */     // GIR_Coverage, 5012,
     /* 693379 */     GIR_EraseRootFromParent_Done,
     /* 693380 */   // Label 8939: @693380
     /* 693380 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(693449), // Rule ID 5016 //
     /* 693385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693393 */     // MIs[0] offset
     /* 693393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693396 */     // MIs[0] auxiliary
     /* 693396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693399 */     // MIs[0] Operand 7
     /* 693399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693417 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 693420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693429 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693447 */     GIR_RootConstrainSelectedInstOperands,
     /* 693448 */     // GIR_Coverage, 5016,
     /* 693448 */     GIR_EraseRootFromParent_Done,
     /* 693449 */   // Label 8940: @693449
     /* 693449 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(693521), // Rule ID 5020 //
     /* 693454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693465 */     // MIs[0] offset
     /* 693465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693468 */     // MIs[0] auxiliary
     /* 693468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693471 */     // MIs[0] Operand 7
     /* 693471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693489 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693501 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693519 */     GIR_RootConstrainSelectedInstOperands,
     /* 693520 */     // GIR_Coverage, 5020,
     /* 693520 */     GIR_EraseRootFromParent_Done,
     /* 693521 */   // Label 8941: @693521
     /* 693521 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(693590), // Rule ID 5024 //
     /* 693526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693534 */     // MIs[0] offset
     /* 693534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693537 */     // MIs[0] auxiliary
     /* 693537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693540 */     // MIs[0] Operand 7
     /* 693540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693558 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 693561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693570 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693588 */     GIR_RootConstrainSelectedInstOperands,
     /* 693589 */     // GIR_Coverage, 5024,
     /* 693589 */     GIR_EraseRootFromParent_Done,
     /* 693590 */   // Label 8942: @693590
     /* 693590 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(693660), // Rule ID 5013 //
     /* 693595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693602 */     // MIs[0] offset
     /* 693602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693605 */     // MIs[0] auxiliary
     /* 693605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693608 */     // MIs[0] Operand 7
     /* 693608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693626 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 693629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693631 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693640 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693658 */     GIR_RootConstrainSelectedInstOperands,
     /* 693659 */     // GIR_Coverage, 5013,
     /* 693659 */     GIR_EraseRootFromParent_Done,
     /* 693660 */   // Label 8943: @693660
     /* 693660 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(693727), // Rule ID 5017 //
     /* 693665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693669 */     // MIs[0] offset
     /* 693669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693672 */     // MIs[0] auxiliary
     /* 693672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693675 */     // MIs[0] Operand 7
     /* 693675 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693693 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 693696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693698 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693707 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693725 */     GIR_RootConstrainSelectedInstOperands,
     /* 693726 */     // GIR_Coverage, 5017,
     /* 693726 */     GIR_EraseRootFromParent_Done,
     /* 693727 */   // Label 8944: @693727
     /* 693727 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(693797), // Rule ID 5021 //
     /* 693732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693739 */     // MIs[0] offset
     /* 693739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693742 */     // MIs[0] auxiliary
     /* 693742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693745 */     // MIs[0] Operand 7
     /* 693745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693763 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 693766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693768 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693795 */     GIR_RootConstrainSelectedInstOperands,
     /* 693796 */     // GIR_Coverage, 5021,
     /* 693796 */     GIR_EraseRootFromParent_Done,
     /* 693797 */   // Label 8945: @693797
     /* 693797 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(693864), // Rule ID 5025 //
     /* 693802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693806 */     // MIs[0] offset
     /* 693806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693809 */     // MIs[0] auxiliary
     /* 693809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693812 */     // MIs[0] Operand 7
     /* 693812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693830 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 693833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693835 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693844 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693862 */     GIR_RootConstrainSelectedInstOperands,
     /* 693863 */     // GIR_Coverage, 5025,
     /* 693863 */     GIR_EraseRootFromParent_Done,
     /* 693864 */   // Label 8946: @693864
     /* 693864 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(693926), // Rule ID 5014 //
     /* 693869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693876 */     // MIs[0] offset
     /* 693876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693879 */     // MIs[0] auxiliary
     /* 693879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693882 */     // MIs[0] Operand 7
     /* 693882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693892 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 693895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693897 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693906 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693924 */     GIR_RootConstrainSelectedInstOperands,
     /* 693925 */     // GIR_Coverage, 5014,
     /* 693925 */     GIR_EraseRootFromParent_Done,
     /* 693926 */   // Label 8947: @693926
     /* 693926 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(693985), // Rule ID 5018 //
     /* 693931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693935 */     // MIs[0] offset
     /* 693935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693938 */     // MIs[0] auxiliary
     /* 693938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693941 */     // MIs[0] Operand 7
     /* 693941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693951 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 693954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693956 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693965 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693983 */     GIR_RootConstrainSelectedInstOperands,
     /* 693984 */     // GIR_Coverage, 5018,
     /* 693984 */     GIR_EraseRootFromParent_Done,
     /* 693985 */   // Label 8948: @693985
     /* 693985 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(694047), // Rule ID 5022 //
     /* 693990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693997 */     // MIs[0] offset
     /* 693997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694000 */     // MIs[0] auxiliary
     /* 694000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694003 */     // MIs[0] Operand 7
     /* 694003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694013 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 694016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694018 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694027 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694045 */     GIR_RootConstrainSelectedInstOperands,
     /* 694046 */     // GIR_Coverage, 5022,
     /* 694046 */     GIR_EraseRootFromParent_Done,
     /* 694047 */   // Label 8949: @694047
     /* 694047 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(694106), // Rule ID 5026 //
     /* 694052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694056 */     // MIs[0] offset
     /* 694056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694059 */     // MIs[0] auxiliary
     /* 694059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694062 */     // MIs[0] Operand 7
     /* 694062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694072 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 694075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694077 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694086 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694104 */     GIR_RootConstrainSelectedInstOperands,
     /* 694105 */     // GIR_Coverage, 5026,
     /* 694105 */     GIR_EraseRootFromParent_Done,
     /* 694106 */   // Label 8950: @694106
     /* 694106 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(694206), // Rule ID 5015 //
     /* 694111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694114 */     // MIs[0] offset
     /* 694114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694117 */     // MIs[0] auxiliary
     /* 694117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694120 */     // MIs[0] Operand 7
     /* 694120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694130 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694146 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694153 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 694174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694186 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694204 */     GIR_RootConstrainSelectedInstOperands,
     /* 694205 */     // GIR_Coverage, 5015,
     /* 694205 */     GIR_EraseRootFromParent_Done,
     /* 694206 */   // Label 8951: @694206
     /* 694206 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(694303), // Rule ID 5019 //
     /* 694211 */     // MIs[0] offset
     /* 694211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694214 */     // MIs[0] auxiliary
     /* 694214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694217 */     // MIs[0] Operand 7
     /* 694217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694227 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694243 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694250 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 694271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694283 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694301 */     GIR_RootConstrainSelectedInstOperands,
     /* 694302 */     // GIR_Coverage, 5019,
     /* 694302 */     GIR_EraseRootFromParent_Done,
     /* 694303 */   // Label 8952: @694303
     /* 694303 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(694403), // Rule ID 5023 //
     /* 694308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694311 */     // MIs[0] offset
     /* 694311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694314 */     // MIs[0] auxiliary
     /* 694314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694317 */     // MIs[0] Operand 7
     /* 694317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694327 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694343 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694350 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 694371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694383 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694401 */     GIR_RootConstrainSelectedInstOperands,
     /* 694402 */     // GIR_Coverage, 5023,
     /* 694402 */     GIR_EraseRootFromParent_Done,
     /* 694403 */   // Label 8953: @694403
     /* 694403 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(694500), // Rule ID 5027 //
     /* 694408 */     // MIs[0] offset
     /* 694408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694411 */     // MIs[0] auxiliary
     /* 694411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694414 */     // MIs[0] Operand 7
     /* 694414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694424 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694440 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694447 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 694468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694480 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694498 */     GIR_RootConstrainSelectedInstOperands,
     /* 694499 */     // GIR_Coverage, 5027,
     /* 694499 */     GIR_EraseRootFromParent_Done,
     /* 694500 */   // Label 8954: @694500
     /* 694500 */   GIM_Reject,
     /* 694501 */ // Label 8938: @694501
     /* 694501 */ GIM_Reject,
     /* 694502 */ // Label 8770: @694502
     /* 694502 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(695716),
     /* 694507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 694510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 694513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 694516 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 694519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 694523 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(694595), // Rule ID 5044 //
     /* 694528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694539 */     // MIs[0] offset
     /* 694539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694542 */     // MIs[0] auxiliary
     /* 694542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694545 */     // MIs[0] Operand 7
     /* 694545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694563 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 694566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694575 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694593 */     GIR_RootConstrainSelectedInstOperands,
     /* 694594 */     // GIR_Coverage, 5044,
     /* 694594 */     GIR_EraseRootFromParent_Done,
     /* 694595 */   // Label 8956: @694595
     /* 694595 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(694664), // Rule ID 5048 //
     /* 694600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694608 */     // MIs[0] offset
     /* 694608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694611 */     // MIs[0] auxiliary
     /* 694611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694614 */     // MIs[0] Operand 7
     /* 694614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694632 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 694635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694644 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694662 */     GIR_RootConstrainSelectedInstOperands,
     /* 694663 */     // GIR_Coverage, 5048,
     /* 694663 */     GIR_EraseRootFromParent_Done,
     /* 694664 */   // Label 8957: @694664
     /* 694664 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(694736), // Rule ID 5052 //
     /* 694669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694680 */     // MIs[0] offset
     /* 694680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694683 */     // MIs[0] auxiliary
     /* 694683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694686 */     // MIs[0] Operand 7
     /* 694686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694704 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 694707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694716 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694734 */     GIR_RootConstrainSelectedInstOperands,
     /* 694735 */     // GIR_Coverage, 5052,
     /* 694735 */     GIR_EraseRootFromParent_Done,
     /* 694736 */   // Label 8958: @694736
     /* 694736 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(694805), // Rule ID 5056 //
     /* 694741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694749 */     // MIs[0] offset
     /* 694749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694752 */     // MIs[0] auxiliary
     /* 694752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694755 */     // MIs[0] Operand 7
     /* 694755 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694773 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 694776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694785 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694803 */     GIR_RootConstrainSelectedInstOperands,
     /* 694804 */     // GIR_Coverage, 5056,
     /* 694804 */     GIR_EraseRootFromParent_Done,
     /* 694805 */   // Label 8959: @694805
     /* 694805 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(694875), // Rule ID 5045 //
     /* 694810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694817 */     // MIs[0] offset
     /* 694817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694820 */     // MIs[0] auxiliary
     /* 694820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694823 */     // MIs[0] Operand 7
     /* 694823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694841 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 694844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694846 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694855 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694873 */     GIR_RootConstrainSelectedInstOperands,
     /* 694874 */     // GIR_Coverage, 5045,
     /* 694874 */     GIR_EraseRootFromParent_Done,
     /* 694875 */   // Label 8960: @694875
     /* 694875 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(694942), // Rule ID 5049 //
     /* 694880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694884 */     // MIs[0] offset
     /* 694884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694887 */     // MIs[0] auxiliary
     /* 694887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694890 */     // MIs[0] Operand 7
     /* 694890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694908 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 694911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694913 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694922 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694940 */     GIR_RootConstrainSelectedInstOperands,
     /* 694941 */     // GIR_Coverage, 5049,
     /* 694941 */     GIR_EraseRootFromParent_Done,
     /* 694942 */   // Label 8961: @694942
     /* 694942 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(695012), // Rule ID 5053 //
     /* 694947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694954 */     // MIs[0] offset
     /* 694954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694957 */     // MIs[0] auxiliary
     /* 694957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694960 */     // MIs[0] Operand 7
     /* 694960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694978 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 694981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694983 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695010 */     GIR_RootConstrainSelectedInstOperands,
     /* 695011 */     // GIR_Coverage, 5053,
     /* 695011 */     GIR_EraseRootFromParent_Done,
     /* 695012 */   // Label 8962: @695012
     /* 695012 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(695079), // Rule ID 5057 //
     /* 695017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695021 */     // MIs[0] offset
     /* 695021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695024 */     // MIs[0] auxiliary
     /* 695024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695027 */     // MIs[0] Operand 7
     /* 695027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695045 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 695048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695050 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695059 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695077 */     GIR_RootConstrainSelectedInstOperands,
     /* 695078 */     // GIR_Coverage, 5057,
     /* 695078 */     GIR_EraseRootFromParent_Done,
     /* 695079 */   // Label 8963: @695079
     /* 695079 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(695141), // Rule ID 5046 //
     /* 695084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695091 */     // MIs[0] offset
     /* 695091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695094 */     // MIs[0] auxiliary
     /* 695094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695097 */     // MIs[0] Operand 7
     /* 695097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695107 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 695110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695112 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695121 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695139 */     GIR_RootConstrainSelectedInstOperands,
     /* 695140 */     // GIR_Coverage, 5046,
     /* 695140 */     GIR_EraseRootFromParent_Done,
     /* 695141 */   // Label 8964: @695141
     /* 695141 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(695200), // Rule ID 5050 //
     /* 695146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695150 */     // MIs[0] offset
     /* 695150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695153 */     // MIs[0] auxiliary
     /* 695153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695156 */     // MIs[0] Operand 7
     /* 695156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695166 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 695169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695171 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695180 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695198 */     GIR_RootConstrainSelectedInstOperands,
     /* 695199 */     // GIR_Coverage, 5050,
     /* 695199 */     GIR_EraseRootFromParent_Done,
     /* 695200 */   // Label 8965: @695200
     /* 695200 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(695262), // Rule ID 5054 //
     /* 695205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695212 */     // MIs[0] offset
     /* 695212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695215 */     // MIs[0] auxiliary
     /* 695215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695218 */     // MIs[0] Operand 7
     /* 695218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695228 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 695231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695233 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695242 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695260 */     GIR_RootConstrainSelectedInstOperands,
     /* 695261 */     // GIR_Coverage, 5054,
     /* 695261 */     GIR_EraseRootFromParent_Done,
     /* 695262 */   // Label 8966: @695262
     /* 695262 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(695321), // Rule ID 5058 //
     /* 695267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695271 */     // MIs[0] offset
     /* 695271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695274 */     // MIs[0] auxiliary
     /* 695274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695277 */     // MIs[0] Operand 7
     /* 695277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695287 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 695290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695292 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695301 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695319 */     GIR_RootConstrainSelectedInstOperands,
     /* 695320 */     // GIR_Coverage, 5058,
     /* 695320 */     GIR_EraseRootFromParent_Done,
     /* 695321 */   // Label 8967: @695321
     /* 695321 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(695421), // Rule ID 5047 //
     /* 695326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695329 */     // MIs[0] offset
     /* 695329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695332 */     // MIs[0] auxiliary
     /* 695332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695335 */     // MIs[0] Operand 7
     /* 695335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695345 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 695389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695419 */     GIR_RootConstrainSelectedInstOperands,
     /* 695420 */     // GIR_Coverage, 5047,
     /* 695420 */     GIR_EraseRootFromParent_Done,
     /* 695421 */   // Label 8968: @695421
     /* 695421 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(695518), // Rule ID 5051 //
     /* 695426 */     // MIs[0] offset
     /* 695426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695429 */     // MIs[0] auxiliary
     /* 695429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695432 */     // MIs[0] Operand 7
     /* 695432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695442 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695458 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 695486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695498 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695516 */     GIR_RootConstrainSelectedInstOperands,
     /* 695517 */     // GIR_Coverage, 5051,
     /* 695517 */     GIR_EraseRootFromParent_Done,
     /* 695518 */   // Label 8969: @695518
     /* 695518 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(695618), // Rule ID 5055 //
     /* 695523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695526 */     // MIs[0] offset
     /* 695526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695529 */     // MIs[0] auxiliary
     /* 695529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695532 */     // MIs[0] Operand 7
     /* 695532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695542 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695565 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 695586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695616 */     GIR_RootConstrainSelectedInstOperands,
     /* 695617 */     // GIR_Coverage, 5055,
     /* 695617 */     GIR_EraseRootFromParent_Done,
     /* 695618 */   // Label 8970: @695618
     /* 695618 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(695715), // Rule ID 5059 //
     /* 695623 */     // MIs[0] offset
     /* 695623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695626 */     // MIs[0] auxiliary
     /* 695626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695629 */     // MIs[0] Operand 7
     /* 695629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695639 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 695683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695695 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695713 */     GIR_RootConstrainSelectedInstOperands,
     /* 695714 */     // GIR_Coverage, 5059,
     /* 695714 */     GIR_EraseRootFromParent_Done,
     /* 695715 */   // Label 8971: @695715
     /* 695715 */   GIM_Reject,
     /* 695716 */ // Label 8955: @695716
     /* 695716 */ GIM_Reject,
     /* 695717 */ // Label 8771: @695717
     /* 695717 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(696931),
     /* 695722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 695725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 695728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 695731 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 695734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 695738 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(695810), // Rule ID 5076 //
     /* 695743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695754 */     // MIs[0] offset
     /* 695754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695757 */     // MIs[0] auxiliary
     /* 695757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695760 */     // MIs[0] Operand 7
     /* 695760 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695778 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695790 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695808 */     GIR_RootConstrainSelectedInstOperands,
     /* 695809 */     // GIR_Coverage, 5076,
     /* 695809 */     GIR_EraseRootFromParent_Done,
     /* 695810 */   // Label 8973: @695810
     /* 695810 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(695879), // Rule ID 5080 //
     /* 695815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695823 */     // MIs[0] offset
     /* 695823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695826 */     // MIs[0] auxiliary
     /* 695826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695829 */     // MIs[0] Operand 7
     /* 695829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695847 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695859 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695877 */     GIR_RootConstrainSelectedInstOperands,
     /* 695878 */     // GIR_Coverage, 5080,
     /* 695878 */     GIR_EraseRootFromParent_Done,
     /* 695879 */   // Label 8974: @695879
     /* 695879 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(695951), // Rule ID 5084 //
     /* 695884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695895 */     // MIs[0] offset
     /* 695895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695898 */     // MIs[0] auxiliary
     /* 695898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695901 */     // MIs[0] Operand 7
     /* 695901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695919 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695931 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695949 */     GIR_RootConstrainSelectedInstOperands,
     /* 695950 */     // GIR_Coverage, 5084,
     /* 695950 */     GIR_EraseRootFromParent_Done,
     /* 695951 */   // Label 8975: @695951
     /* 695951 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(696020), // Rule ID 5088 //
     /* 695956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695964 */     // MIs[0] offset
     /* 695964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695967 */     // MIs[0] auxiliary
     /* 695967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695970 */     // MIs[0] Operand 7
     /* 695970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695988 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696000 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696018 */     GIR_RootConstrainSelectedInstOperands,
     /* 696019 */     // GIR_Coverage, 5088,
     /* 696019 */     GIR_EraseRootFromParent_Done,
     /* 696020 */   // Label 8976: @696020
     /* 696020 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(696090), // Rule ID 5077 //
     /* 696025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696032 */     // MIs[0] offset
     /* 696032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696035 */     // MIs[0] auxiliary
     /* 696035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696038 */     // MIs[0] Operand 7
     /* 696038 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696056 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 696059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696061 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696070 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696088 */     GIR_RootConstrainSelectedInstOperands,
     /* 696089 */     // GIR_Coverage, 5077,
     /* 696089 */     GIR_EraseRootFromParent_Done,
     /* 696090 */   // Label 8977: @696090
     /* 696090 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(696157), // Rule ID 5081 //
     /* 696095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696099 */     // MIs[0] offset
     /* 696099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696102 */     // MIs[0] auxiliary
     /* 696102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696105 */     // MIs[0] Operand 7
     /* 696105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696123 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 696126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696128 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696155 */     GIR_RootConstrainSelectedInstOperands,
     /* 696156 */     // GIR_Coverage, 5081,
     /* 696156 */     GIR_EraseRootFromParent_Done,
     /* 696157 */   // Label 8978: @696157
     /* 696157 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(696227), // Rule ID 5085 //
     /* 696162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696169 */     // MIs[0] offset
     /* 696169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696172 */     // MIs[0] auxiliary
     /* 696172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696175 */     // MIs[0] Operand 7
     /* 696175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696193 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 696196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696198 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696225 */     GIR_RootConstrainSelectedInstOperands,
     /* 696226 */     // GIR_Coverage, 5085,
     /* 696226 */     GIR_EraseRootFromParent_Done,
     /* 696227 */   // Label 8979: @696227
     /* 696227 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(696294), // Rule ID 5089 //
     /* 696232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696236 */     // MIs[0] offset
     /* 696236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696239 */     // MIs[0] auxiliary
     /* 696239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696242 */     // MIs[0] Operand 7
     /* 696242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696260 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 696263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696265 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696274 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696292 */     GIR_RootConstrainSelectedInstOperands,
     /* 696293 */     // GIR_Coverage, 5089,
     /* 696293 */     GIR_EraseRootFromParent_Done,
     /* 696294 */   // Label 8980: @696294
     /* 696294 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(696356), // Rule ID 5078 //
     /* 696299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696306 */     // MIs[0] offset
     /* 696306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696309 */     // MIs[0] auxiliary
     /* 696309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696312 */     // MIs[0] Operand 7
     /* 696312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696322 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 696325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696327 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696336 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696354 */     GIR_RootConstrainSelectedInstOperands,
     /* 696355 */     // GIR_Coverage, 5078,
     /* 696355 */     GIR_EraseRootFromParent_Done,
     /* 696356 */   // Label 8981: @696356
     /* 696356 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(696415), // Rule ID 5082 //
     /* 696361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696365 */     // MIs[0] offset
     /* 696365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696368 */     // MIs[0] auxiliary
     /* 696368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696371 */     // MIs[0] Operand 7
     /* 696371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696381 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 696384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696386 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696395 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696413 */     GIR_RootConstrainSelectedInstOperands,
     /* 696414 */     // GIR_Coverage, 5082,
     /* 696414 */     GIR_EraseRootFromParent_Done,
     /* 696415 */   // Label 8982: @696415
     /* 696415 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(696477), // Rule ID 5086 //
     /* 696420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696427 */     // MIs[0] offset
     /* 696427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696430 */     // MIs[0] auxiliary
     /* 696430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696433 */     // MIs[0] Operand 7
     /* 696433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696443 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 696446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696448 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696457 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696475 */     GIR_RootConstrainSelectedInstOperands,
     /* 696476 */     // GIR_Coverage, 5086,
     /* 696476 */     GIR_EraseRootFromParent_Done,
     /* 696477 */   // Label 8983: @696477
     /* 696477 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(696536), // Rule ID 5090 //
     /* 696482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696486 */     // MIs[0] offset
     /* 696486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696489 */     // MIs[0] auxiliary
     /* 696489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696492 */     // MIs[0] Operand 7
     /* 696492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696502 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 696505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696507 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696516 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696534 */     GIR_RootConstrainSelectedInstOperands,
     /* 696535 */     // GIR_Coverage, 5090,
     /* 696535 */     GIR_EraseRootFromParent_Done,
     /* 696536 */   // Label 8984: @696536
     /* 696536 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(696636), // Rule ID 5079 //
     /* 696541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696544 */     // MIs[0] offset
     /* 696544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696547 */     // MIs[0] auxiliary
     /* 696547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696550 */     // MIs[0] Operand 7
     /* 696550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696560 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696583 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 696604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696616 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696634 */     GIR_RootConstrainSelectedInstOperands,
     /* 696635 */     // GIR_Coverage, 5079,
     /* 696635 */     GIR_EraseRootFromParent_Done,
     /* 696636 */   // Label 8985: @696636
     /* 696636 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(696733), // Rule ID 5083 //
     /* 696641 */     // MIs[0] offset
     /* 696641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696644 */     // MIs[0] auxiliary
     /* 696644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696647 */     // MIs[0] Operand 7
     /* 696647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696657 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696669 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696673 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696680 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 696701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696713 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696731 */     GIR_RootConstrainSelectedInstOperands,
     /* 696732 */     // GIR_Coverage, 5083,
     /* 696732 */     GIR_EraseRootFromParent_Done,
     /* 696733 */   // Label 8986: @696733
     /* 696733 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(696833), // Rule ID 5087 //
     /* 696738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696741 */     // MIs[0] offset
     /* 696741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696744 */     // MIs[0] auxiliary
     /* 696744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696747 */     // MIs[0] Operand 7
     /* 696747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696757 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696773 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696780 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 696801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696831 */     GIR_RootConstrainSelectedInstOperands,
     /* 696832 */     // GIR_Coverage, 5087,
     /* 696832 */     GIR_EraseRootFromParent_Done,
     /* 696833 */   // Label 8987: @696833
     /* 696833 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(696930), // Rule ID 5091 //
     /* 696838 */     // MIs[0] offset
     /* 696838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696841 */     // MIs[0] auxiliary
     /* 696841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696844 */     // MIs[0] Operand 7
     /* 696844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696854 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696870 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696877 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 696898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696910 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696928 */     GIR_RootConstrainSelectedInstOperands,
     /* 696929 */     // GIR_Coverage, 5091,
     /* 696929 */     GIR_EraseRootFromParent_Done,
     /* 696930 */   // Label 8988: @696930
     /* 696930 */   GIM_Reject,
     /* 696931 */ // Label 8972: @696931
     /* 696931 */ GIM_Reject,
     /* 696932 */ // Label 8772: @696932
     /* 696932 */ GIM_Reject,
     /* 696933 */ // Label 126: @696933
     /* 696933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 8993*/ GIMT_Encode4(701840),
     /* 696944 */ /*GILLT_s32*//*Label 8989*/ GIMT_Encode4(696980), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 696956 */ /*GILLT_v2s32*//*Label 8990*/ GIMT_Encode4(698195), GIMT_Encode4(0),
     /* 696964 */ /*GILLT_v3s32*//*Label 8991*/ GIMT_Encode4(699410), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 696976 */ /*GILLT_v4s32*//*Label 8992*/ GIMT_Encode4(700625),
     /* 696980 */ // Label 8989: @696980
     /* 696980 */ GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(698194),
     /* 696985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 696988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 696991 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 696994 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 696997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 697001 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(697073), // Rule ID 4700 //
     /* 697006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697017 */     // MIs[0] offset
     /* 697017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697020 */     // MIs[0] auxiliary
     /* 697020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697023 */     // MIs[0] Operand 7
     /* 697023 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697041 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 697044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697053 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697071 */     GIR_RootConstrainSelectedInstOperands,
     /* 697072 */     // GIR_Coverage, 4700,
     /* 697072 */     GIR_EraseRootFromParent_Done,
     /* 697073 */   // Label 8995: @697073
     /* 697073 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(697142), // Rule ID 4704 //
     /* 697078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697086 */     // MIs[0] offset
     /* 697086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697089 */     // MIs[0] auxiliary
     /* 697089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697092 */     // MIs[0] Operand 7
     /* 697092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697110 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 697113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697122 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697140 */     GIR_RootConstrainSelectedInstOperands,
     /* 697141 */     // GIR_Coverage, 4704,
     /* 697141 */     GIR_EraseRootFromParent_Done,
     /* 697142 */   // Label 8996: @697142
     /* 697142 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(697214), // Rule ID 4708 //
     /* 697147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697158 */     // MIs[0] offset
     /* 697158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697161 */     // MIs[0] auxiliary
     /* 697161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697164 */     // MIs[0] Operand 7
     /* 697164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697182 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 697185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697212 */     GIR_RootConstrainSelectedInstOperands,
     /* 697213 */     // GIR_Coverage, 4708,
     /* 697213 */     GIR_EraseRootFromParent_Done,
     /* 697214 */   // Label 8997: @697214
     /* 697214 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(697283), // Rule ID 4712 //
     /* 697219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697227 */     // MIs[0] offset
     /* 697227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697230 */     // MIs[0] auxiliary
     /* 697230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697233 */     // MIs[0] Operand 7
     /* 697233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697251 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 697254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697281 */     GIR_RootConstrainSelectedInstOperands,
     /* 697282 */     // GIR_Coverage, 4712,
     /* 697282 */     GIR_EraseRootFromParent_Done,
     /* 697283 */   // Label 8998: @697283
     /* 697283 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(697353), // Rule ID 4701 //
     /* 697288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697295 */     // MIs[0] offset
     /* 697295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697298 */     // MIs[0] auxiliary
     /* 697298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697301 */     // MIs[0] Operand 7
     /* 697301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697319 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 697322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697324 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697333 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697335 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697341 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697351 */     GIR_RootConstrainSelectedInstOperands,
     /* 697352 */     // GIR_Coverage, 4701,
     /* 697352 */     GIR_EraseRootFromParent_Done,
     /* 697353 */   // Label 8999: @697353
     /* 697353 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(697420), // Rule ID 4705 //
     /* 697358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697362 */     // MIs[0] offset
     /* 697362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697365 */     // MIs[0] auxiliary
     /* 697365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697368 */     // MIs[0] Operand 7
     /* 697368 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697386 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 697389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697391 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697418 */     GIR_RootConstrainSelectedInstOperands,
     /* 697419 */     // GIR_Coverage, 4705,
     /* 697419 */     GIR_EraseRootFromParent_Done,
     /* 697420 */   // Label 9000: @697420
     /* 697420 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(697490), // Rule ID 4709 //
     /* 697425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697432 */     // MIs[0] offset
     /* 697432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697435 */     // MIs[0] auxiliary
     /* 697435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697438 */     // MIs[0] Operand 7
     /* 697438 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697456 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 697459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697461 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697470 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697488 */     GIR_RootConstrainSelectedInstOperands,
     /* 697489 */     // GIR_Coverage, 4709,
     /* 697489 */     GIR_EraseRootFromParent_Done,
     /* 697490 */   // Label 9001: @697490
     /* 697490 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(697557), // Rule ID 4713 //
     /* 697495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697499 */     // MIs[0] offset
     /* 697499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697502 */     // MIs[0] auxiliary
     /* 697502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697505 */     // MIs[0] Operand 7
     /* 697505 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697523 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 697526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697528 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697537 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697555 */     GIR_RootConstrainSelectedInstOperands,
     /* 697556 */     // GIR_Coverage, 4713,
     /* 697556 */     GIR_EraseRootFromParent_Done,
     /* 697557 */   // Label 9002: @697557
     /* 697557 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(697619), // Rule ID 4702 //
     /* 697562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697569 */     // MIs[0] offset
     /* 697569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697572 */     // MIs[0] auxiliary
     /* 697572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697575 */     // MIs[0] Operand 7
     /* 697575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697585 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 697588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697590 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697599 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697617 */     GIR_RootConstrainSelectedInstOperands,
     /* 697618 */     // GIR_Coverage, 4702,
     /* 697618 */     GIR_EraseRootFromParent_Done,
     /* 697619 */   // Label 9003: @697619
     /* 697619 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(697678), // Rule ID 4706 //
     /* 697624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697628 */     // MIs[0] offset
     /* 697628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697631 */     // MIs[0] auxiliary
     /* 697631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697634 */     // MIs[0] Operand 7
     /* 697634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697644 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 697647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697649 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697658 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697676 */     GIR_RootConstrainSelectedInstOperands,
     /* 697677 */     // GIR_Coverage, 4706,
     /* 697677 */     GIR_EraseRootFromParent_Done,
     /* 697678 */   // Label 9004: @697678
     /* 697678 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(697740), // Rule ID 4710 //
     /* 697683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697690 */     // MIs[0] offset
     /* 697690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697693 */     // MIs[0] auxiliary
     /* 697693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697696 */     // MIs[0] Operand 7
     /* 697696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697706 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 697709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697711 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697720 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697738 */     GIR_RootConstrainSelectedInstOperands,
     /* 697739 */     // GIR_Coverage, 4710,
     /* 697739 */     GIR_EraseRootFromParent_Done,
     /* 697740 */   // Label 9005: @697740
     /* 697740 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(697799), // Rule ID 4714 //
     /* 697745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697749 */     // MIs[0] offset
     /* 697749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697752 */     // MIs[0] auxiliary
     /* 697752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697755 */     // MIs[0] Operand 7
     /* 697755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697765 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 697768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697770 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697779 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697797 */     GIR_RootConstrainSelectedInstOperands,
     /* 697798 */     // GIR_Coverage, 4714,
     /* 697798 */     GIR_EraseRootFromParent_Done,
     /* 697799 */   // Label 9006: @697799
     /* 697799 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(697899), // Rule ID 4703 //
     /* 697804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697807 */     // MIs[0] offset
     /* 697807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697810 */     // MIs[0] auxiliary
     /* 697810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697813 */     // MIs[0] Operand 7
     /* 697813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697823 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697839 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697846 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 697867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697879 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697897 */     GIR_RootConstrainSelectedInstOperands,
     /* 697898 */     // GIR_Coverage, 4703,
     /* 697898 */     GIR_EraseRootFromParent_Done,
     /* 697899 */   // Label 9007: @697899
     /* 697899 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(697996), // Rule ID 4707 //
     /* 697904 */     // MIs[0] offset
     /* 697904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697907 */     // MIs[0] auxiliary
     /* 697907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697910 */     // MIs[0] Operand 7
     /* 697910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697920 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697936 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 697964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697976 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697994 */     GIR_RootConstrainSelectedInstOperands,
     /* 697995 */     // GIR_Coverage, 4707,
     /* 697995 */     GIR_EraseRootFromParent_Done,
     /* 697996 */   // Label 9008: @697996
     /* 697996 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(698096), // Rule ID 4711 //
     /* 698001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698004 */     // MIs[0] offset
     /* 698004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698007 */     // MIs[0] auxiliary
     /* 698007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698010 */     // MIs[0] Operand 7
     /* 698010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698020 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698036 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698043 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 698064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698076 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698094 */     GIR_RootConstrainSelectedInstOperands,
     /* 698095 */     // GIR_Coverage, 4711,
     /* 698095 */     GIR_EraseRootFromParent_Done,
     /* 698096 */   // Label 9009: @698096
     /* 698096 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(698193), // Rule ID 4715 //
     /* 698101 */     // MIs[0] offset
     /* 698101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698104 */     // MIs[0] auxiliary
     /* 698104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698107 */     // MIs[0] Operand 7
     /* 698107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698117 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698133 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698140 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 698161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698173 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698191 */     GIR_RootConstrainSelectedInstOperands,
     /* 698192 */     // GIR_Coverage, 4715,
     /* 698192 */     GIR_EraseRootFromParent_Done,
     /* 698193 */   // Label 9010: @698193
     /* 698193 */   GIM_Reject,
     /* 698194 */ // Label 8994: @698194
     /* 698194 */ GIM_Reject,
     /* 698195 */ // Label 8990: @698195
     /* 698195 */ GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(699409),
     /* 698200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 698203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 698206 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 698209 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 698212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 698216 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(698288), // Rule ID 4716 //
     /* 698221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698232 */     // MIs[0] offset
     /* 698232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698235 */     // MIs[0] auxiliary
     /* 698235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698238 */     // MIs[0] Operand 7
     /* 698238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698256 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 698259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698268 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698286 */     GIR_RootConstrainSelectedInstOperands,
     /* 698287 */     // GIR_Coverage, 4716,
     /* 698287 */     GIR_EraseRootFromParent_Done,
     /* 698288 */   // Label 9012: @698288
     /* 698288 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(698357), // Rule ID 4720 //
     /* 698293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698301 */     // MIs[0] offset
     /* 698301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698304 */     // MIs[0] auxiliary
     /* 698304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698307 */     // MIs[0] Operand 7
     /* 698307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698325 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 698328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698355 */     GIR_RootConstrainSelectedInstOperands,
     /* 698356 */     // GIR_Coverage, 4720,
     /* 698356 */     GIR_EraseRootFromParent_Done,
     /* 698357 */   // Label 9013: @698357
     /* 698357 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(698429), // Rule ID 4724 //
     /* 698362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698373 */     // MIs[0] offset
     /* 698373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698376 */     // MIs[0] auxiliary
     /* 698376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698379 */     // MIs[0] Operand 7
     /* 698379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698397 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 698400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698427 */     GIR_RootConstrainSelectedInstOperands,
     /* 698428 */     // GIR_Coverage, 4724,
     /* 698428 */     GIR_EraseRootFromParent_Done,
     /* 698429 */   // Label 9014: @698429
     /* 698429 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(698498), // Rule ID 4728 //
     /* 698434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698442 */     // MIs[0] offset
     /* 698442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698445 */     // MIs[0] auxiliary
     /* 698445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698448 */     // MIs[0] Operand 7
     /* 698448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698466 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 698469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698496 */     GIR_RootConstrainSelectedInstOperands,
     /* 698497 */     // GIR_Coverage, 4728,
     /* 698497 */     GIR_EraseRootFromParent_Done,
     /* 698498 */   // Label 9015: @698498
     /* 698498 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(698568), // Rule ID 4717 //
     /* 698503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698510 */     // MIs[0] offset
     /* 698510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698513 */     // MIs[0] auxiliary
     /* 698513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698516 */     // MIs[0] Operand 7
     /* 698516 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698534 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 698537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698539 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698548 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698566 */     GIR_RootConstrainSelectedInstOperands,
     /* 698567 */     // GIR_Coverage, 4717,
     /* 698567 */     GIR_EraseRootFromParent_Done,
     /* 698568 */   // Label 9016: @698568
     /* 698568 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(698635), // Rule ID 4721 //
     /* 698573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698577 */     // MIs[0] offset
     /* 698577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698580 */     // MIs[0] auxiliary
     /* 698580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698583 */     // MIs[0] Operand 7
     /* 698583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698601 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 698604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698606 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698615 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698633 */     GIR_RootConstrainSelectedInstOperands,
     /* 698634 */     // GIR_Coverage, 4721,
     /* 698634 */     GIR_EraseRootFromParent_Done,
     /* 698635 */   // Label 9017: @698635
     /* 698635 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(698705), // Rule ID 4725 //
     /* 698640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698647 */     // MIs[0] offset
     /* 698647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698650 */     // MIs[0] auxiliary
     /* 698650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698653 */     // MIs[0] Operand 7
     /* 698653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698671 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 698674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698676 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698685 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698703 */     GIR_RootConstrainSelectedInstOperands,
     /* 698704 */     // GIR_Coverage, 4725,
     /* 698704 */     GIR_EraseRootFromParent_Done,
     /* 698705 */   // Label 9018: @698705
     /* 698705 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(698772), // Rule ID 4729 //
     /* 698710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698714 */     // MIs[0] offset
     /* 698714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698717 */     // MIs[0] auxiliary
     /* 698717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698720 */     // MIs[0] Operand 7
     /* 698720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698738 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 698741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698743 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698770 */     GIR_RootConstrainSelectedInstOperands,
     /* 698771 */     // GIR_Coverage, 4729,
     /* 698771 */     GIR_EraseRootFromParent_Done,
     /* 698772 */   // Label 9019: @698772
     /* 698772 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(698834), // Rule ID 4718 //
     /* 698777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698784 */     // MIs[0] offset
     /* 698784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698787 */     // MIs[0] auxiliary
     /* 698787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698790 */     // MIs[0] Operand 7
     /* 698790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698800 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 698803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698805 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698814 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698832 */     GIR_RootConstrainSelectedInstOperands,
     /* 698833 */     // GIR_Coverage, 4718,
     /* 698833 */     GIR_EraseRootFromParent_Done,
     /* 698834 */   // Label 9020: @698834
     /* 698834 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(698893), // Rule ID 4722 //
     /* 698839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698843 */     // MIs[0] offset
     /* 698843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698846 */     // MIs[0] auxiliary
     /* 698846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698849 */     // MIs[0] Operand 7
     /* 698849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698859 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 698862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698864 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698873 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698891 */     GIR_RootConstrainSelectedInstOperands,
     /* 698892 */     // GIR_Coverage, 4722,
     /* 698892 */     GIR_EraseRootFromParent_Done,
     /* 698893 */   // Label 9021: @698893
     /* 698893 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(698955), // Rule ID 4726 //
     /* 698898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698905 */     // MIs[0] offset
     /* 698905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698908 */     // MIs[0] auxiliary
     /* 698908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698911 */     // MIs[0] Operand 7
     /* 698911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698921 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 698924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698926 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698935 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698953 */     GIR_RootConstrainSelectedInstOperands,
     /* 698954 */     // GIR_Coverage, 4726,
     /* 698954 */     GIR_EraseRootFromParent_Done,
     /* 698955 */   // Label 9022: @698955
     /* 698955 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(699014), // Rule ID 4730 //
     /* 698960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698964 */     // MIs[0] offset
     /* 698964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698967 */     // MIs[0] auxiliary
     /* 698967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698970 */     // MIs[0] Operand 7
     /* 698970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698980 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 698983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698985 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698994 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699012 */     GIR_RootConstrainSelectedInstOperands,
     /* 699013 */     // GIR_Coverage, 4730,
     /* 699013 */     GIR_EraseRootFromParent_Done,
     /* 699014 */   // Label 9023: @699014
     /* 699014 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(699114), // Rule ID 4719 //
     /* 699019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699022 */     // MIs[0] offset
     /* 699022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699025 */     // MIs[0] auxiliary
     /* 699025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699028 */     // MIs[0] Operand 7
     /* 699028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699038 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699054 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699061 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 699082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699094 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699096 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699102 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699112 */     GIR_RootConstrainSelectedInstOperands,
     /* 699113 */     // GIR_Coverage, 4719,
     /* 699113 */     GIR_EraseRootFromParent_Done,
     /* 699114 */   // Label 9024: @699114
     /* 699114 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(699211), // Rule ID 4723 //
     /* 699119 */     // MIs[0] offset
     /* 699119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699122 */     // MIs[0] auxiliary
     /* 699122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699125 */     // MIs[0] Operand 7
     /* 699125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699135 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699151 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699158 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 699179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699191 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699209 */     GIR_RootConstrainSelectedInstOperands,
     /* 699210 */     // GIR_Coverage, 4723,
     /* 699210 */     GIR_EraseRootFromParent_Done,
     /* 699211 */   // Label 9025: @699211
     /* 699211 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(699311), // Rule ID 4727 //
     /* 699216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699219 */     // MIs[0] offset
     /* 699219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699222 */     // MIs[0] auxiliary
     /* 699222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699225 */     // MIs[0] Operand 7
     /* 699225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699235 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699251 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699258 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 699279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699291 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699309 */     GIR_RootConstrainSelectedInstOperands,
     /* 699310 */     // GIR_Coverage, 4727,
     /* 699310 */     GIR_EraseRootFromParent_Done,
     /* 699311 */   // Label 9026: @699311
     /* 699311 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(699408), // Rule ID 4731 //
     /* 699316 */     // MIs[0] offset
     /* 699316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699319 */     // MIs[0] auxiliary
     /* 699319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699322 */     // MIs[0] Operand 7
     /* 699322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699332 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699348 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 699376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699388 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699406 */     GIR_RootConstrainSelectedInstOperands,
     /* 699407 */     // GIR_Coverage, 4731,
     /* 699407 */     GIR_EraseRootFromParent_Done,
     /* 699408 */   // Label 9027: @699408
     /* 699408 */   GIM_Reject,
     /* 699409 */ // Label 9011: @699409
     /* 699409 */ GIM_Reject,
     /* 699410 */ // Label 8991: @699410
     /* 699410 */ GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(700624),
     /* 699415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 699418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 699421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 699424 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 699427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 699431 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(699503), // Rule ID 4732 //
     /* 699436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699447 */     // MIs[0] offset
     /* 699447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699450 */     // MIs[0] auxiliary
     /* 699450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699453 */     // MIs[0] Operand 7
     /* 699453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699471 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 699474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699483 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699491 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699501 */     GIR_RootConstrainSelectedInstOperands,
     /* 699502 */     // GIR_Coverage, 4732,
     /* 699502 */     GIR_EraseRootFromParent_Done,
     /* 699503 */   // Label 9029: @699503
     /* 699503 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(699572), // Rule ID 4736 //
     /* 699508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699516 */     // MIs[0] offset
     /* 699516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699519 */     // MIs[0] auxiliary
     /* 699519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699522 */     // MIs[0] Operand 7
     /* 699522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699540 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 699543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699570 */     GIR_RootConstrainSelectedInstOperands,
     /* 699571 */     // GIR_Coverage, 4736,
     /* 699571 */     GIR_EraseRootFromParent_Done,
     /* 699572 */   // Label 9030: @699572
     /* 699572 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(699644), // Rule ID 4740 //
     /* 699577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699588 */     // MIs[0] offset
     /* 699588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699591 */     // MIs[0] auxiliary
     /* 699591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699594 */     // MIs[0] Operand 7
     /* 699594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699612 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 699615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699642 */     GIR_RootConstrainSelectedInstOperands,
     /* 699643 */     // GIR_Coverage, 4740,
     /* 699643 */     GIR_EraseRootFromParent_Done,
     /* 699644 */   // Label 9031: @699644
     /* 699644 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(699713), // Rule ID 4744 //
     /* 699649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699657 */     // MIs[0] offset
     /* 699657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699660 */     // MIs[0] auxiliary
     /* 699660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699663 */     // MIs[0] Operand 7
     /* 699663 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699681 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 699684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699711 */     GIR_RootConstrainSelectedInstOperands,
     /* 699712 */     // GIR_Coverage, 4744,
     /* 699712 */     GIR_EraseRootFromParent_Done,
     /* 699713 */   // Label 9032: @699713
     /* 699713 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(699783), // Rule ID 4733 //
     /* 699718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699725 */     // MIs[0] offset
     /* 699725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699728 */     // MIs[0] auxiliary
     /* 699728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699731 */     // MIs[0] Operand 7
     /* 699731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699749 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 699752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699754 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699781 */     GIR_RootConstrainSelectedInstOperands,
     /* 699782 */     // GIR_Coverage, 4733,
     /* 699782 */     GIR_EraseRootFromParent_Done,
     /* 699783 */   // Label 9033: @699783
     /* 699783 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(699850), // Rule ID 4737 //
     /* 699788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699792 */     // MIs[0] offset
     /* 699792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699795 */     // MIs[0] auxiliary
     /* 699795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699798 */     // MIs[0] Operand 7
     /* 699798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699816 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 699819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699821 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699830 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699848 */     GIR_RootConstrainSelectedInstOperands,
     /* 699849 */     // GIR_Coverage, 4737,
     /* 699849 */     GIR_EraseRootFromParent_Done,
     /* 699850 */   // Label 9034: @699850
     /* 699850 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(699920), // Rule ID 4741 //
     /* 699855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699862 */     // MIs[0] offset
     /* 699862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699865 */     // MIs[0] auxiliary
     /* 699865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699868 */     // MIs[0] Operand 7
     /* 699868 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699886 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 699889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699891 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699900 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699918 */     GIR_RootConstrainSelectedInstOperands,
     /* 699919 */     // GIR_Coverage, 4741,
     /* 699919 */     GIR_EraseRootFromParent_Done,
     /* 699920 */   // Label 9035: @699920
     /* 699920 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(699987), // Rule ID 4745 //
     /* 699925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699929 */     // MIs[0] offset
     /* 699929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699932 */     // MIs[0] auxiliary
     /* 699932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699935 */     // MIs[0] Operand 7
     /* 699935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699953 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 699956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699958 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699967 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699985 */     GIR_RootConstrainSelectedInstOperands,
     /* 699986 */     // GIR_Coverage, 4745,
     /* 699986 */     GIR_EraseRootFromParent_Done,
     /* 699987 */   // Label 9036: @699987
     /* 699987 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(700049), // Rule ID 4734 //
     /* 699992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699999 */     // MIs[0] offset
     /* 699999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700002 */     // MIs[0] auxiliary
     /* 700002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700005 */     // MIs[0] Operand 7
     /* 700005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700015 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 700018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700020 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700029 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700047 */     GIR_RootConstrainSelectedInstOperands,
     /* 700048 */     // GIR_Coverage, 4734,
     /* 700048 */     GIR_EraseRootFromParent_Done,
     /* 700049 */   // Label 9037: @700049
     /* 700049 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(700108), // Rule ID 4738 //
     /* 700054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700058 */     // MIs[0] offset
     /* 700058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700061 */     // MIs[0] auxiliary
     /* 700061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700064 */     // MIs[0] Operand 7
     /* 700064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700074 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 700077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700079 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700088 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700096 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700106 */     GIR_RootConstrainSelectedInstOperands,
     /* 700107 */     // GIR_Coverage, 4738,
     /* 700107 */     GIR_EraseRootFromParent_Done,
     /* 700108 */   // Label 9038: @700108
     /* 700108 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(700170), // Rule ID 4742 //
     /* 700113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700120 */     // MIs[0] offset
     /* 700120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700123 */     // MIs[0] auxiliary
     /* 700123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700126 */     // MIs[0] Operand 7
     /* 700126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700136 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 700139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700141 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700150 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700168 */     GIR_RootConstrainSelectedInstOperands,
     /* 700169 */     // GIR_Coverage, 4742,
     /* 700169 */     GIR_EraseRootFromParent_Done,
     /* 700170 */   // Label 9039: @700170
     /* 700170 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(700229), // Rule ID 4746 //
     /* 700175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700179 */     // MIs[0] offset
     /* 700179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700182 */     // MIs[0] auxiliary
     /* 700182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700185 */     // MIs[0] Operand 7
     /* 700185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700195 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 700198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700200 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700209 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700227 */     GIR_RootConstrainSelectedInstOperands,
     /* 700228 */     // GIR_Coverage, 4746,
     /* 700228 */     GIR_EraseRootFromParent_Done,
     /* 700229 */   // Label 9040: @700229
     /* 700229 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(700329), // Rule ID 4735 //
     /* 700234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700237 */     // MIs[0] offset
     /* 700237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700240 */     // MIs[0] auxiliary
     /* 700240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700243 */     // MIs[0] Operand 7
     /* 700243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700253 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700265 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700269 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700276 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 700297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700309 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700327 */     GIR_RootConstrainSelectedInstOperands,
     /* 700328 */     // GIR_Coverage, 4735,
     /* 700328 */     GIR_EraseRootFromParent_Done,
     /* 700329 */   // Label 9041: @700329
     /* 700329 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(700426), // Rule ID 4739 //
     /* 700334 */     // MIs[0] offset
     /* 700334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700337 */     // MIs[0] auxiliary
     /* 700337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700340 */     // MIs[0] Operand 7
     /* 700340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700350 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700366 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700369 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700373 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 700394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700406 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700424 */     GIR_RootConstrainSelectedInstOperands,
     /* 700425 */     // GIR_Coverage, 4739,
     /* 700425 */     GIR_EraseRootFromParent_Done,
     /* 700426 */   // Label 9042: @700426
     /* 700426 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(700526), // Rule ID 4743 //
     /* 700431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700434 */     // MIs[0] offset
     /* 700434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700437 */     // MIs[0] auxiliary
     /* 700437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700440 */     // MIs[0] Operand 7
     /* 700440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700450 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700473 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 700494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700506 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700524 */     GIR_RootConstrainSelectedInstOperands,
     /* 700525 */     // GIR_Coverage, 4743,
     /* 700525 */     GIR_EraseRootFromParent_Done,
     /* 700526 */   // Label 9043: @700526
     /* 700526 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(700623), // Rule ID 4747 //
     /* 700531 */     // MIs[0] offset
     /* 700531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700534 */     // MIs[0] auxiliary
     /* 700534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700537 */     // MIs[0] Operand 7
     /* 700537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700547 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700563 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 700591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700603 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700621 */     GIR_RootConstrainSelectedInstOperands,
     /* 700622 */     // GIR_Coverage, 4747,
     /* 700622 */     GIR_EraseRootFromParent_Done,
     /* 700623 */   // Label 9044: @700623
     /* 700623 */   GIM_Reject,
     /* 700624 */ // Label 9028: @700624
     /* 700624 */ GIM_Reject,
     /* 700625 */ // Label 8992: @700625
     /* 700625 */ GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(701839),
     /* 700630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 700633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 700636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 700639 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 700642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 700646 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(700718), // Rule ID 4748 //
     /* 700651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700662 */     // MIs[0] offset
     /* 700662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700665 */     // MIs[0] auxiliary
     /* 700665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700668 */     // MIs[0] Operand 7
     /* 700668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700686 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 700689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700698 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700716 */     GIR_RootConstrainSelectedInstOperands,
     /* 700717 */     // GIR_Coverage, 4748,
     /* 700717 */     GIR_EraseRootFromParent_Done,
     /* 700718 */   // Label 9046: @700718
     /* 700718 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(700787), // Rule ID 4752 //
     /* 700723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700731 */     // MIs[0] offset
     /* 700731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700734 */     // MIs[0] auxiliary
     /* 700734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700737 */     // MIs[0] Operand 7
     /* 700737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700755 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 700758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700767 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700775 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700785 */     GIR_RootConstrainSelectedInstOperands,
     /* 700786 */     // GIR_Coverage, 4752,
     /* 700786 */     GIR_EraseRootFromParent_Done,
     /* 700787 */   // Label 9047: @700787
     /* 700787 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(700859), // Rule ID 4756 //
     /* 700792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700803 */     // MIs[0] offset
     /* 700803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700806 */     // MIs[0] auxiliary
     /* 700806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700809 */     // MIs[0] Operand 7
     /* 700809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700827 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 700830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700839 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700857 */     GIR_RootConstrainSelectedInstOperands,
     /* 700858 */     // GIR_Coverage, 4756,
     /* 700858 */     GIR_EraseRootFromParent_Done,
     /* 700859 */   // Label 9048: @700859
     /* 700859 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(700928), // Rule ID 4760 //
     /* 700864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700872 */     // MIs[0] offset
     /* 700872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700875 */     // MIs[0] auxiliary
     /* 700875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700878 */     // MIs[0] Operand 7
     /* 700878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700896 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 700899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700908 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700926 */     GIR_RootConstrainSelectedInstOperands,
     /* 700927 */     // GIR_Coverage, 4760,
     /* 700927 */     GIR_EraseRootFromParent_Done,
     /* 700928 */   // Label 9049: @700928
     /* 700928 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(700998), // Rule ID 4749 //
     /* 700933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700940 */     // MIs[0] offset
     /* 700940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700943 */     // MIs[0] auxiliary
     /* 700943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700946 */     // MIs[0] Operand 7
     /* 700946 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700964 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 700967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700969 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700978 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700996 */     GIR_RootConstrainSelectedInstOperands,
     /* 700997 */     // GIR_Coverage, 4749,
     /* 700997 */     GIR_EraseRootFromParent_Done,
     /* 700998 */   // Label 9050: @700998
     /* 700998 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(701065), // Rule ID 4753 //
     /* 701003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701007 */     // MIs[0] offset
     /* 701007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701010 */     // MIs[0] auxiliary
     /* 701010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701013 */     // MIs[0] Operand 7
     /* 701013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701031 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 701034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701036 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701045 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701063 */     GIR_RootConstrainSelectedInstOperands,
     /* 701064 */     // GIR_Coverage, 4753,
     /* 701064 */     GIR_EraseRootFromParent_Done,
     /* 701065 */   // Label 9051: @701065
     /* 701065 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(701135), // Rule ID 4757 //
     /* 701070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701077 */     // MIs[0] offset
     /* 701077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701080 */     // MIs[0] auxiliary
     /* 701080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701083 */     // MIs[0] Operand 7
     /* 701083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701101 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 701104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701106 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701115 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701133 */     GIR_RootConstrainSelectedInstOperands,
     /* 701134 */     // GIR_Coverage, 4757,
     /* 701134 */     GIR_EraseRootFromParent_Done,
     /* 701135 */   // Label 9052: @701135
     /* 701135 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(701202), // Rule ID 4761 //
     /* 701140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701144 */     // MIs[0] offset
     /* 701144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701147 */     // MIs[0] auxiliary
     /* 701147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701150 */     // MIs[0] Operand 7
     /* 701150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701168 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 701171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701173 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701182 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701200 */     GIR_RootConstrainSelectedInstOperands,
     /* 701201 */     // GIR_Coverage, 4761,
     /* 701201 */     GIR_EraseRootFromParent_Done,
     /* 701202 */   // Label 9053: @701202
     /* 701202 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(701264), // Rule ID 4750 //
     /* 701207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701214 */     // MIs[0] offset
     /* 701214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701217 */     // MIs[0] auxiliary
     /* 701217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701220 */     // MIs[0] Operand 7
     /* 701220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701230 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 701233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701235 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701262 */     GIR_RootConstrainSelectedInstOperands,
     /* 701263 */     // GIR_Coverage, 4750,
     /* 701263 */     GIR_EraseRootFromParent_Done,
     /* 701264 */   // Label 9054: @701264
     /* 701264 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(701323), // Rule ID 4754 //
     /* 701269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701273 */     // MIs[0] offset
     /* 701273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701276 */     // MIs[0] auxiliary
     /* 701276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701279 */     // MIs[0] Operand 7
     /* 701279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701289 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 701292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701294 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701321 */     GIR_RootConstrainSelectedInstOperands,
     /* 701322 */     // GIR_Coverage, 4754,
     /* 701322 */     GIR_EraseRootFromParent_Done,
     /* 701323 */   // Label 9055: @701323
     /* 701323 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(701385), // Rule ID 4758 //
     /* 701328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701335 */     // MIs[0] offset
     /* 701335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701338 */     // MIs[0] auxiliary
     /* 701338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701341 */     // MIs[0] Operand 7
     /* 701341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701351 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 701354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701356 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701383 */     GIR_RootConstrainSelectedInstOperands,
     /* 701384 */     // GIR_Coverage, 4758,
     /* 701384 */     GIR_EraseRootFromParent_Done,
     /* 701385 */   // Label 9056: @701385
     /* 701385 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(701444), // Rule ID 4762 //
     /* 701390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701394 */     // MIs[0] offset
     /* 701394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701397 */     // MIs[0] auxiliary
     /* 701397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701400 */     // MIs[0] Operand 7
     /* 701400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701410 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 701413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701415 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701424 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701442 */     GIR_RootConstrainSelectedInstOperands,
     /* 701443 */     // GIR_Coverage, 4762,
     /* 701443 */     GIR_EraseRootFromParent_Done,
     /* 701444 */   // Label 9057: @701444
     /* 701444 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(701544), // Rule ID 4751 //
     /* 701449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701452 */     // MIs[0] offset
     /* 701452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701455 */     // MIs[0] auxiliary
     /* 701455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701458 */     // MIs[0] Operand 7
     /* 701458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701468 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701484 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701491 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 701512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701524 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701542 */     GIR_RootConstrainSelectedInstOperands,
     /* 701543 */     // GIR_Coverage, 4751,
     /* 701543 */     GIR_EraseRootFromParent_Done,
     /* 701544 */   // Label 9058: @701544
     /* 701544 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(701641), // Rule ID 4755 //
     /* 701549 */     // MIs[0] offset
     /* 701549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701552 */     // MIs[0] auxiliary
     /* 701552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701555 */     // MIs[0] Operand 7
     /* 701555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701565 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701581 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701588 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 701609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701621 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701639 */     GIR_RootConstrainSelectedInstOperands,
     /* 701640 */     // GIR_Coverage, 4755,
     /* 701640 */     GIR_EraseRootFromParent_Done,
     /* 701641 */   // Label 9059: @701641
     /* 701641 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(701741), // Rule ID 4759 //
     /* 701646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701649 */     // MIs[0] offset
     /* 701649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701652 */     // MIs[0] auxiliary
     /* 701652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701655 */     // MIs[0] Operand 7
     /* 701655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701665 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701681 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701688 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 701709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701721 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701739 */     GIR_RootConstrainSelectedInstOperands,
     /* 701740 */     // GIR_Coverage, 4759,
     /* 701740 */     GIR_EraseRootFromParent_Done,
     /* 701741 */   // Label 9060: @701741
     /* 701741 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(701838), // Rule ID 4763 //
     /* 701746 */     // MIs[0] offset
     /* 701746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701749 */     // MIs[0] auxiliary
     /* 701749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701752 */     // MIs[0] Operand 7
     /* 701752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701762 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701778 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 701806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701818 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701836 */     GIR_RootConstrainSelectedInstOperands,
     /* 701837 */     // GIR_Coverage, 4763,
     /* 701837 */     GIR_EraseRootFromParent_Done,
     /* 701838 */   // Label 9061: @701838
     /* 701838 */   GIM_Reject,
     /* 701839 */ // Label 9045: @701839
     /* 701839 */ GIM_Reject,
     /* 701840 */ // Label 8993: @701840
     /* 701840 */ GIM_Reject,
     /* 701841 */ // Label 127: @701841
     /* 701841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9069*/ GIMT_Encode4(709585),
     /* 701852 */ /*GILLT_s16*//*Label 9062*/ GIMT_Encode4(701892),
     /* 701856 */ /*GILLT_s32*//*Label 9063*/ GIMT_Encode4(703739), GIMT_Encode4(0),
     /* 701864 */ /*GILLT_v2s16*//*Label 9064*/ GIMT_Encode4(704674),
     /* 701868 */ /*GILLT_v2s32*//*Label 9065*/ GIMT_Encode4(705913), GIMT_Encode4(0),
     /* 701876 */ /*GILLT_v3s32*//*Label 9066*/ GIMT_Encode4(706240), GIMT_Encode4(0),
     /* 701884 */ /*GILLT_v4s16*//*Label 9067*/ GIMT_Encode4(706567),
     /* 701888 */ /*GILLT_v4s32*//*Label 9068*/ GIMT_Encode4(709258),
     /* 701892 */ // Label 9062: @701892
     /* 701892 */ GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(703738),
     /* 701897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 701900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 701903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 701906 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 701909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 701913 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(701985), // Rule ID 4796 //
     /* 701918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 701921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701929 */     // MIs[0] offset
     /* 701929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701932 */     // MIs[0] auxiliary
     /* 701932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701935 */     // MIs[0] Operand 7
     /* 701935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701953 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 701956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701965 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701983 */     GIR_RootConstrainSelectedInstOperands,
     /* 701984 */     // GIR_Coverage, 4796,
     /* 701984 */     GIR_EraseRootFromParent_Done,
     /* 701985 */   // Label 9071: @701985
     /* 701985 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(702057), // Rule ID 4800 //
     /* 701990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 701993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702001 */     // MIs[0] offset
     /* 702001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702004 */     // MIs[0] auxiliary
     /* 702004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702007 */     // MIs[0] Operand 7
     /* 702007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702025 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 702028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702037 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702055 */     GIR_RootConstrainSelectedInstOperands,
     /* 702056 */     // GIR_Coverage, 4800,
     /* 702056 */     GIR_EraseRootFromParent_Done,
     /* 702057 */   // Label 9072: @702057
     /* 702057 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(702129), // Rule ID 4820 //
     /* 702062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702073 */     // MIs[0] offset
     /* 702073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702076 */     // MIs[0] auxiliary
     /* 702076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702079 */     // MIs[0] Operand 7
     /* 702079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702097 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 702100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702109 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702127 */     GIR_RootConstrainSelectedInstOperands,
     /* 702128 */     // GIR_Coverage, 4820,
     /* 702128 */     GIR_EraseRootFromParent_Done,
     /* 702129 */   // Label 9073: @702129
     /* 702129 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(702201), // Rule ID 4824 //
     /* 702134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702145 */     // MIs[0] offset
     /* 702145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702148 */     // MIs[0] auxiliary
     /* 702148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702151 */     // MIs[0] Operand 7
     /* 702151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702169 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 702172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702181 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702199 */     GIR_RootConstrainSelectedInstOperands,
     /* 702200 */     // GIR_Coverage, 4824,
     /* 702200 */     GIR_EraseRootFromParent_Done,
     /* 702201 */   // Label 9074: @702201
     /* 702201 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(702273), // Rule ID 4828 //
     /* 702206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702217 */     // MIs[0] offset
     /* 702217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702220 */     // MIs[0] auxiliary
     /* 702220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702223 */     // MIs[0] Operand 7
     /* 702223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702241 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 702244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702253 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702255 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702271 */     GIR_RootConstrainSelectedInstOperands,
     /* 702272 */     // GIR_Coverage, 4828,
     /* 702272 */     GIR_EraseRootFromParent_Done,
     /* 702273 */   // Label 9075: @702273
     /* 702273 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(702345), // Rule ID 4832 //
     /* 702278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702289 */     // MIs[0] offset
     /* 702289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702292 */     // MIs[0] auxiliary
     /* 702292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702295 */     // MIs[0] Operand 7
     /* 702295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702313 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 702316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702325 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702343 */     GIR_RootConstrainSelectedInstOperands,
     /* 702344 */     // GIR_Coverage, 4832,
     /* 702344 */     GIR_EraseRootFromParent_Done,
     /* 702345 */   // Label 9076: @702345
     /* 702345 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(702415), // Rule ID 4797 //
     /* 702350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702357 */     // MIs[0] offset
     /* 702357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702360 */     // MIs[0] auxiliary
     /* 702360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702363 */     // MIs[0] Operand 7
     /* 702363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702381 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 702384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702386 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702395 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702413 */     GIR_RootConstrainSelectedInstOperands,
     /* 702414 */     // GIR_Coverage, 4797,
     /* 702414 */     GIR_EraseRootFromParent_Done,
     /* 702415 */   // Label 9077: @702415
     /* 702415 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(702485), // Rule ID 4801 //
     /* 702420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702427 */     // MIs[0] offset
     /* 702427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702430 */     // MIs[0] auxiliary
     /* 702430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702433 */     // MIs[0] Operand 7
     /* 702433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702451 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 702454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702456 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702465 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702483 */     GIR_RootConstrainSelectedInstOperands,
     /* 702484 */     // GIR_Coverage, 4801,
     /* 702484 */     GIR_EraseRootFromParent_Done,
     /* 702485 */   // Label 9078: @702485
     /* 702485 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(702555), // Rule ID 4821 //
     /* 702490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702497 */     // MIs[0] offset
     /* 702497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702500 */     // MIs[0] auxiliary
     /* 702500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702503 */     // MIs[0] Operand 7
     /* 702503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702521 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 702524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702526 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702535 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702553 */     GIR_RootConstrainSelectedInstOperands,
     /* 702554 */     // GIR_Coverage, 4821,
     /* 702554 */     GIR_EraseRootFromParent_Done,
     /* 702555 */   // Label 9079: @702555
     /* 702555 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(702625), // Rule ID 4825 //
     /* 702560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702567 */     // MIs[0] offset
     /* 702567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702570 */     // MIs[0] auxiliary
     /* 702570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702573 */     // MIs[0] Operand 7
     /* 702573 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702591 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 702594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702596 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702605 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702623 */     GIR_RootConstrainSelectedInstOperands,
     /* 702624 */     // GIR_Coverage, 4825,
     /* 702624 */     GIR_EraseRootFromParent_Done,
     /* 702625 */   // Label 9080: @702625
     /* 702625 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(702695), // Rule ID 4829 //
     /* 702630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702637 */     // MIs[0] offset
     /* 702637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702640 */     // MIs[0] auxiliary
     /* 702640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702643 */     // MIs[0] Operand 7
     /* 702643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702661 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 702664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702666 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702675 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702693 */     GIR_RootConstrainSelectedInstOperands,
     /* 702694 */     // GIR_Coverage, 4829,
     /* 702694 */     GIR_EraseRootFromParent_Done,
     /* 702695 */   // Label 9081: @702695
     /* 702695 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(702765), // Rule ID 4833 //
     /* 702700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702707 */     // MIs[0] offset
     /* 702707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702710 */     // MIs[0] auxiliary
     /* 702710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702713 */     // MIs[0] Operand 7
     /* 702713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702731 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 702734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702736 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702745 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702763 */     GIR_RootConstrainSelectedInstOperands,
     /* 702764 */     // GIR_Coverage, 4833,
     /* 702764 */     GIR_EraseRootFromParent_Done,
     /* 702765 */   // Label 9082: @702765
     /* 702765 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(702827), // Rule ID 4798 //
     /* 702770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702777 */     // MIs[0] offset
     /* 702777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702780 */     // MIs[0] auxiliary
     /* 702780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702783 */     // MIs[0] Operand 7
     /* 702783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702793 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 702796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702798 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702807 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702825 */     GIR_RootConstrainSelectedInstOperands,
     /* 702826 */     // GIR_Coverage, 4798,
     /* 702826 */     GIR_EraseRootFromParent_Done,
     /* 702827 */   // Label 9083: @702827
     /* 702827 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(702889), // Rule ID 4802 //
     /* 702832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702839 */     // MIs[0] offset
     /* 702839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702842 */     // MIs[0] auxiliary
     /* 702842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702845 */     // MIs[0] Operand 7
     /* 702845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702855 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 702858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702860 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702869 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702887 */     GIR_RootConstrainSelectedInstOperands,
     /* 702888 */     // GIR_Coverage, 4802,
     /* 702888 */     GIR_EraseRootFromParent_Done,
     /* 702889 */   // Label 9084: @702889
     /* 702889 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(702951), // Rule ID 4822 //
     /* 702894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702901 */     // MIs[0] offset
     /* 702901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702904 */     // MIs[0] auxiliary
     /* 702904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702907 */     // MIs[0] Operand 7
     /* 702907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702917 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 702920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702922 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702931 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702949 */     GIR_RootConstrainSelectedInstOperands,
     /* 702950 */     // GIR_Coverage, 4822,
     /* 702950 */     GIR_EraseRootFromParent_Done,
     /* 702951 */   // Label 9085: @702951
     /* 702951 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(703013), // Rule ID 4826 //
     /* 702956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702963 */     // MIs[0] offset
     /* 702963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702966 */     // MIs[0] auxiliary
     /* 702966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702969 */     // MIs[0] Operand 7
     /* 702969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702979 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 702982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702984 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703011 */     GIR_RootConstrainSelectedInstOperands,
     /* 703012 */     // GIR_Coverage, 4826,
     /* 703012 */     GIR_EraseRootFromParent_Done,
     /* 703013 */   // Label 9086: @703013
     /* 703013 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(703075), // Rule ID 4830 //
     /* 703018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703025 */     // MIs[0] offset
     /* 703025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703028 */     // MIs[0] auxiliary
     /* 703028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703031 */     // MIs[0] Operand 7
     /* 703031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703041 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 703044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703046 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703055 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703073 */     GIR_RootConstrainSelectedInstOperands,
     /* 703074 */     // GIR_Coverage, 4830,
     /* 703074 */     GIR_EraseRootFromParent_Done,
     /* 703075 */   // Label 9087: @703075
     /* 703075 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(703137), // Rule ID 4834 //
     /* 703080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703087 */     // MIs[0] offset
     /* 703087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703090 */     // MIs[0] auxiliary
     /* 703090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703093 */     // MIs[0] Operand 7
     /* 703093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703103 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 703106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703108 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703117 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703135 */     GIR_RootConstrainSelectedInstOperands,
     /* 703136 */     // GIR_Coverage, 4834,
     /* 703136 */     GIR_EraseRootFromParent_Done,
     /* 703137 */   // Label 9088: @703137
     /* 703137 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(703237), // Rule ID 4799 //
     /* 703142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703145 */     // MIs[0] offset
     /* 703145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703148 */     // MIs[0] auxiliary
     /* 703148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703151 */     // MIs[0] Operand 7
     /* 703151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703161 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703177 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703184 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 703205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703217 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703235 */     GIR_RootConstrainSelectedInstOperands,
     /* 703236 */     // GIR_Coverage, 4799,
     /* 703236 */     GIR_EraseRootFromParent_Done,
     /* 703237 */   // Label 9089: @703237
     /* 703237 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(703337), // Rule ID 4803 //
     /* 703242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703245 */     // MIs[0] offset
     /* 703245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703248 */     // MIs[0] auxiliary
     /* 703248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703251 */     // MIs[0] Operand 7
     /* 703251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703261 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703284 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 703305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703317 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703335 */     GIR_RootConstrainSelectedInstOperands,
     /* 703336 */     // GIR_Coverage, 4803,
     /* 703336 */     GIR_EraseRootFromParent_Done,
     /* 703337 */   // Label 9090: @703337
     /* 703337 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(703437), // Rule ID 4823 //
     /* 703342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703345 */     // MIs[0] offset
     /* 703345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703348 */     // MIs[0] auxiliary
     /* 703348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703351 */     // MIs[0] Operand 7
     /* 703351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703361 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703377 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703384 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 703405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703435 */     GIR_RootConstrainSelectedInstOperands,
     /* 703436 */     // GIR_Coverage, 4823,
     /* 703436 */     GIR_EraseRootFromParent_Done,
     /* 703437 */   // Label 9091: @703437
     /* 703437 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(703537), // Rule ID 4827 //
     /* 703442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703445 */     // MIs[0] offset
     /* 703445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703448 */     // MIs[0] auxiliary
     /* 703448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703451 */     // MIs[0] Operand 7
     /* 703451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703461 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703484 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 703505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703517 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703535 */     GIR_RootConstrainSelectedInstOperands,
     /* 703536 */     // GIR_Coverage, 4827,
     /* 703536 */     GIR_EraseRootFromParent_Done,
     /* 703537 */   // Label 9092: @703537
     /* 703537 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(703637), // Rule ID 4831 //
     /* 703542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703545 */     // MIs[0] offset
     /* 703545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703548 */     // MIs[0] auxiliary
     /* 703548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703551 */     // MIs[0] Operand 7
     /* 703551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703561 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703584 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 703605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703617 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703635 */     GIR_RootConstrainSelectedInstOperands,
     /* 703636 */     // GIR_Coverage, 4831,
     /* 703636 */     GIR_EraseRootFromParent_Done,
     /* 703637 */   // Label 9093: @703637
     /* 703637 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(703737), // Rule ID 4835 //
     /* 703642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703645 */     // MIs[0] offset
     /* 703645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703648 */     // MIs[0] auxiliary
     /* 703648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703651 */     // MIs[0] Operand 7
     /* 703651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703661 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703677 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 703705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703717 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703719 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703725 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703735 */     GIR_RootConstrainSelectedInstOperands,
     /* 703736 */     // GIR_Coverage, 4835,
     /* 703736 */     GIR_EraseRootFromParent_Done,
     /* 703737 */   // Label 9094: @703737
     /* 703737 */   GIM_Reject,
     /* 703738 */ // Label 9070: @703738
     /* 703738 */ GIM_Reject,
     /* 703739 */ // Label 9063: @703739
     /* 703739 */ GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(704673),
     /* 703744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 703747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 703750 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 703753 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 703756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 703760 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(703832), // Rule ID 4804 //
     /* 703765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703776 */     // MIs[0] offset
     /* 703776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703779 */     // MIs[0] auxiliary
     /* 703779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703782 */     // MIs[0] Operand 7
     /* 703782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703800 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 703803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703830 */     GIR_RootConstrainSelectedInstOperands,
     /* 703831 */     // GIR_Coverage, 4804,
     /* 703831 */     GIR_EraseRootFromParent_Done,
     /* 703832 */   // Label 9096: @703832
     /* 703832 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(703904), // Rule ID 4836 //
     /* 703837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703848 */     // MIs[0] offset
     /* 703848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703851 */     // MIs[0] auxiliary
     /* 703851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703854 */     // MIs[0] Operand 7
     /* 703854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703872 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 703875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703902 */     GIR_RootConstrainSelectedInstOperands,
     /* 703903 */     // GIR_Coverage, 4836,
     /* 703903 */     GIR_EraseRootFromParent_Done,
     /* 703904 */   // Label 9097: @703904
     /* 703904 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(703976), // Rule ID 4840 //
     /* 703909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703920 */     // MIs[0] offset
     /* 703920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703923 */     // MIs[0] auxiliary
     /* 703923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703926 */     // MIs[0] Operand 7
     /* 703926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703944 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 703947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703956 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703974 */     GIR_RootConstrainSelectedInstOperands,
     /* 703975 */     // GIR_Coverage, 4840,
     /* 703975 */     GIR_EraseRootFromParent_Done,
     /* 703976 */   // Label 9098: @703976
     /* 703976 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(704046), // Rule ID 4805 //
     /* 703981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703988 */     // MIs[0] offset
     /* 703988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703991 */     // MIs[0] auxiliary
     /* 703991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703994 */     // MIs[0] Operand 7
     /* 703994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704012 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 704015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704017 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704026 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704044 */     GIR_RootConstrainSelectedInstOperands,
     /* 704045 */     // GIR_Coverage, 4805,
     /* 704045 */     GIR_EraseRootFromParent_Done,
     /* 704046 */   // Label 9099: @704046
     /* 704046 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(704116), // Rule ID 4837 //
     /* 704051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704058 */     // MIs[0] offset
     /* 704058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704061 */     // MIs[0] auxiliary
     /* 704061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704064 */     // MIs[0] Operand 7
     /* 704064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704082 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 704085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704087 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704096 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704114 */     GIR_RootConstrainSelectedInstOperands,
     /* 704115 */     // GIR_Coverage, 4837,
     /* 704115 */     GIR_EraseRootFromParent_Done,
     /* 704116 */   // Label 9100: @704116
     /* 704116 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(704186), // Rule ID 4841 //
     /* 704121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704128 */     // MIs[0] offset
     /* 704128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704131 */     // MIs[0] auxiliary
     /* 704131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704134 */     // MIs[0] Operand 7
     /* 704134 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704152 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 704155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704157 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704166 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704184 */     GIR_RootConstrainSelectedInstOperands,
     /* 704185 */     // GIR_Coverage, 4841,
     /* 704185 */     GIR_EraseRootFromParent_Done,
     /* 704186 */   // Label 9101: @704186
     /* 704186 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(704248), // Rule ID 4806 //
     /* 704191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 704194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704198 */     // MIs[0] offset
     /* 704198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704201 */     // MIs[0] auxiliary
     /* 704201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704204 */     // MIs[0] Operand 7
     /* 704204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704214 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 704217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704219 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704228 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704246 */     GIR_RootConstrainSelectedInstOperands,
     /* 704247 */     // GIR_Coverage, 4806,
     /* 704247 */     GIR_EraseRootFromParent_Done,
     /* 704248 */   // Label 9102: @704248
     /* 704248 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(704310), // Rule ID 4838 //
     /* 704253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704260 */     // MIs[0] offset
     /* 704260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704263 */     // MIs[0] auxiliary
     /* 704263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704266 */     // MIs[0] Operand 7
     /* 704266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704276 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 704279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704281 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704290 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704308 */     GIR_RootConstrainSelectedInstOperands,
     /* 704309 */     // GIR_Coverage, 4838,
     /* 704309 */     GIR_EraseRootFromParent_Done,
     /* 704310 */   // Label 9103: @704310
     /* 704310 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(704372), // Rule ID 4842 //
     /* 704315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704322 */     // MIs[0] offset
     /* 704322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704325 */     // MIs[0] auxiliary
     /* 704325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704328 */     // MIs[0] Operand 7
     /* 704328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704338 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 704341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704343 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704352 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704370 */     GIR_RootConstrainSelectedInstOperands,
     /* 704371 */     // GIR_Coverage, 4842,
     /* 704371 */     GIR_EraseRootFromParent_Done,
     /* 704372 */   // Label 9104: @704372
     /* 704372 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(704472), // Rule ID 4807 //
     /* 704377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 704380 */     // MIs[0] offset
     /* 704380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704383 */     // MIs[0] auxiliary
     /* 704383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704386 */     // MIs[0] Operand 7
     /* 704386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704396 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704412 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704419 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 704440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704452 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704470 */     GIR_RootConstrainSelectedInstOperands,
     /* 704471 */     // GIR_Coverage, 4807,
     /* 704471 */     GIR_EraseRootFromParent_Done,
     /* 704472 */   // Label 9105: @704472
     /* 704472 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(704572), // Rule ID 4839 //
     /* 704477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704480 */     // MIs[0] offset
     /* 704480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704483 */     // MIs[0] auxiliary
     /* 704483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704486 */     // MIs[0] Operand 7
     /* 704486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704496 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704512 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704519 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 704540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704570 */     GIR_RootConstrainSelectedInstOperands,
     /* 704571 */     // GIR_Coverage, 4839,
     /* 704571 */     GIR_EraseRootFromParent_Done,
     /* 704572 */   // Label 9106: @704572
     /* 704572 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(704672), // Rule ID 4843 //
     /* 704577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704580 */     // MIs[0] offset
     /* 704580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704583 */     // MIs[0] auxiliary
     /* 704583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704586 */     // MIs[0] Operand 7
     /* 704586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704596 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704612 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704619 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 704640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704652 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704670 */     GIR_RootConstrainSelectedInstOperands,
     /* 704671 */     // GIR_Coverage, 4843,
     /* 704671 */     GIR_EraseRootFromParent_Done,
     /* 704672 */   // Label 9107: @704672
     /* 704672 */   GIM_Reject,
     /* 704673 */ // Label 9095: @704673
     /* 704673 */ GIM_Reject,
     /* 704674 */ // Label 9064: @704674
     /* 704674 */ GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(705912),
     /* 704679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 704682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 704685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 704688 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 704691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 704695 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(704767), // Rule ID 4844 //
     /* 704700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704711 */     // MIs[0] offset
     /* 704711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704714 */     // MIs[0] auxiliary
     /* 704714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704717 */     // MIs[0] Operand 7
     /* 704717 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704735 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 704738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704747 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704765 */     GIR_RootConstrainSelectedInstOperands,
     /* 704766 */     // GIR_Coverage, 4844,
     /* 704766 */     GIR_EraseRootFromParent_Done,
     /* 704767 */   // Label 9109: @704767
     /* 704767 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(704839), // Rule ID 4848 //
     /* 704772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704783 */     // MIs[0] offset
     /* 704783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704786 */     // MIs[0] auxiliary
     /* 704786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704789 */     // MIs[0] Operand 7
     /* 704789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704807 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 704810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704837 */     GIR_RootConstrainSelectedInstOperands,
     /* 704838 */     // GIR_Coverage, 4848,
     /* 704838 */     GIR_EraseRootFromParent_Done,
     /* 704839 */   // Label 9110: @704839
     /* 704839 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(704911), // Rule ID 4852 //
     /* 704844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704855 */     // MIs[0] offset
     /* 704855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704858 */     // MIs[0] auxiliary
     /* 704858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704861 */     // MIs[0] Operand 7
     /* 704861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704879 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 704882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704891 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704909 */     GIR_RootConstrainSelectedInstOperands,
     /* 704910 */     // GIR_Coverage, 4852,
     /* 704910 */     GIR_EraseRootFromParent_Done,
     /* 704911 */   // Label 9111: @704911
     /* 704911 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(704983), // Rule ID 4856 //
     /* 704916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704927 */     // MIs[0] offset
     /* 704927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704930 */     // MIs[0] auxiliary
     /* 704930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704933 */     // MIs[0] Operand 7
     /* 704933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704951 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 704954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704963 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704981 */     GIR_RootConstrainSelectedInstOperands,
     /* 704982 */     // GIR_Coverage, 4856,
     /* 704982 */     GIR_EraseRootFromParent_Done,
     /* 704983 */   // Label 9112: @704983
     /* 704983 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(705053), // Rule ID 4845 //
     /* 704988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704995 */     // MIs[0] offset
     /* 704995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704998 */     // MIs[0] auxiliary
     /* 704998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705001 */     // MIs[0] Operand 7
     /* 705001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705019 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 705022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705024 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705051 */     GIR_RootConstrainSelectedInstOperands,
     /* 705052 */     // GIR_Coverage, 4845,
     /* 705052 */     GIR_EraseRootFromParent_Done,
     /* 705053 */   // Label 9113: @705053
     /* 705053 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(705123), // Rule ID 4849 //
     /* 705058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705065 */     // MIs[0] offset
     /* 705065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705068 */     // MIs[0] auxiliary
     /* 705068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705071 */     // MIs[0] Operand 7
     /* 705071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705089 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 705092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705094 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705121 */     GIR_RootConstrainSelectedInstOperands,
     /* 705122 */     // GIR_Coverage, 4849,
     /* 705122 */     GIR_EraseRootFromParent_Done,
     /* 705123 */   // Label 9114: @705123
     /* 705123 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(705193), // Rule ID 4853 //
     /* 705128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705135 */     // MIs[0] offset
     /* 705135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705138 */     // MIs[0] auxiliary
     /* 705138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705141 */     // MIs[0] Operand 7
     /* 705141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705159 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 705162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705164 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705173 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705191 */     GIR_RootConstrainSelectedInstOperands,
     /* 705192 */     // GIR_Coverage, 4853,
     /* 705192 */     GIR_EraseRootFromParent_Done,
     /* 705193 */   // Label 9115: @705193
     /* 705193 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(705263), // Rule ID 4857 //
     /* 705198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705205 */     // MIs[0] offset
     /* 705205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705208 */     // MIs[0] auxiliary
     /* 705208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705211 */     // MIs[0] Operand 7
     /* 705211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705229 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 705232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705234 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705261 */     GIR_RootConstrainSelectedInstOperands,
     /* 705262 */     // GIR_Coverage, 4857,
     /* 705262 */     GIR_EraseRootFromParent_Done,
     /* 705263 */   // Label 9116: @705263
     /* 705263 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(705325), // Rule ID 4846 //
     /* 705268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705275 */     // MIs[0] offset
     /* 705275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705278 */     // MIs[0] auxiliary
     /* 705278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705281 */     // MIs[0] Operand 7
     /* 705281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705291 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 705294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705296 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705305 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705323 */     GIR_RootConstrainSelectedInstOperands,
     /* 705324 */     // GIR_Coverage, 4846,
     /* 705324 */     GIR_EraseRootFromParent_Done,
     /* 705325 */   // Label 9117: @705325
     /* 705325 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(705387), // Rule ID 4850 //
     /* 705330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705337 */     // MIs[0] offset
     /* 705337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705340 */     // MIs[0] auxiliary
     /* 705340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705343 */     // MIs[0] Operand 7
     /* 705343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705353 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 705356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705358 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705367 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705385 */     GIR_RootConstrainSelectedInstOperands,
     /* 705386 */     // GIR_Coverage, 4850,
     /* 705386 */     GIR_EraseRootFromParent_Done,
     /* 705387 */   // Label 9118: @705387
     /* 705387 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(705449), // Rule ID 4854 //
     /* 705392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705399 */     // MIs[0] offset
     /* 705399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705402 */     // MIs[0] auxiliary
     /* 705402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705405 */     // MIs[0] Operand 7
     /* 705405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705415 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 705418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705420 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705429 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705447 */     GIR_RootConstrainSelectedInstOperands,
     /* 705448 */     // GIR_Coverage, 4854,
     /* 705448 */     GIR_EraseRootFromParent_Done,
     /* 705449 */   // Label 9119: @705449
     /* 705449 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(705511), // Rule ID 4858 //
     /* 705454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705461 */     // MIs[0] offset
     /* 705461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705464 */     // MIs[0] auxiliary
     /* 705464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705467 */     // MIs[0] Operand 7
     /* 705467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705477 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 705480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705482 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705491 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705509 */     GIR_RootConstrainSelectedInstOperands,
     /* 705510 */     // GIR_Coverage, 4858,
     /* 705510 */     GIR_EraseRootFromParent_Done,
     /* 705511 */   // Label 9120: @705511
     /* 705511 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(705611), // Rule ID 4847 //
     /* 705516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705519 */     // MIs[0] offset
     /* 705519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705522 */     // MIs[0] auxiliary
     /* 705522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705525 */     // MIs[0] Operand 7
     /* 705525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705535 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705551 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 705579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705609 */     GIR_RootConstrainSelectedInstOperands,
     /* 705610 */     // GIR_Coverage, 4847,
     /* 705610 */     GIR_EraseRootFromParent_Done,
     /* 705611 */   // Label 9121: @705611
     /* 705611 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(705711), // Rule ID 4851 //
     /* 705616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705619 */     // MIs[0] offset
     /* 705619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705622 */     // MIs[0] auxiliary
     /* 705622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705625 */     // MIs[0] Operand 7
     /* 705625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705635 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705651 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705658 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 705679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705709 */     GIR_RootConstrainSelectedInstOperands,
     /* 705710 */     // GIR_Coverage, 4851,
     /* 705710 */     GIR_EraseRootFromParent_Done,
     /* 705711 */   // Label 9122: @705711
     /* 705711 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(705811), // Rule ID 4855 //
     /* 705716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705719 */     // MIs[0] offset
     /* 705719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705722 */     // MIs[0] auxiliary
     /* 705722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705725 */     // MIs[0] Operand 7
     /* 705725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705735 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705751 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705758 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 705779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705791 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705809 */     GIR_RootConstrainSelectedInstOperands,
     /* 705810 */     // GIR_Coverage, 4855,
     /* 705810 */     GIR_EraseRootFromParent_Done,
     /* 705811 */   // Label 9123: @705811
     /* 705811 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(705911), // Rule ID 4859 //
     /* 705816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705819 */     // MIs[0] offset
     /* 705819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705822 */     // MIs[0] auxiliary
     /* 705822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705825 */     // MIs[0] Operand 7
     /* 705825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705835 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705851 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705858 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 705879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705891 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705909 */     GIR_RootConstrainSelectedInstOperands,
     /* 705910 */     // GIR_Coverage, 4859,
     /* 705910 */     GIR_EraseRootFromParent_Done,
     /* 705911 */   // Label 9124: @705911
     /* 705911 */   GIM_Reject,
     /* 705912 */ // Label 9108: @705912
     /* 705912 */ GIM_Reject,
     /* 705913 */ // Label 9065: @705913
     /* 705913 */ GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(706239),
     /* 705918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 705921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 705924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 705927 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 705930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 705934 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(706006), // Rule ID 4808 //
     /* 705939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705950 */     // MIs[0] offset
     /* 705950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705953 */     // MIs[0] auxiliary
     /* 705953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705956 */     // MIs[0] Operand 7
     /* 705956 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705974 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 705977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705986 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706004 */     GIR_RootConstrainSelectedInstOperands,
     /* 706005 */     // GIR_Coverage, 4808,
     /* 706005 */     GIR_EraseRootFromParent_Done,
     /* 706006 */   // Label 9126: @706006
     /* 706006 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(706076), // Rule ID 4809 //
     /* 706011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706018 */     // MIs[0] offset
     /* 706018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706021 */     // MIs[0] auxiliary
     /* 706021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706024 */     // MIs[0] Operand 7
     /* 706024 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706042 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 706045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706047 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706056 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706074 */     GIR_RootConstrainSelectedInstOperands,
     /* 706075 */     // GIR_Coverage, 4809,
     /* 706075 */     GIR_EraseRootFromParent_Done,
     /* 706076 */   // Label 9127: @706076
     /* 706076 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(706138), // Rule ID 4810 //
     /* 706081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706088 */     // MIs[0] offset
     /* 706088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706091 */     // MIs[0] auxiliary
     /* 706091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706094 */     // MIs[0] Operand 7
     /* 706094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706104 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 706107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706109 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 706111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706118 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706136 */     GIR_RootConstrainSelectedInstOperands,
     /* 706137 */     // GIR_Coverage, 4810,
     /* 706137 */     GIR_EraseRootFromParent_Done,
     /* 706138 */   // Label 9128: @706138
     /* 706138 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(706238), // Rule ID 4811 //
     /* 706143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706146 */     // MIs[0] offset
     /* 706146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706149 */     // MIs[0] auxiliary
     /* 706149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706152 */     // MIs[0] Operand 7
     /* 706152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706162 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 706165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 706169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 706174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 706178 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 706181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 706185 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 706188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 706193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 706206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 706211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706218 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706236 */     GIR_RootConstrainSelectedInstOperands,
     /* 706237 */     // GIR_Coverage, 4811,
     /* 706237 */     GIR_EraseRootFromParent_Done,
     /* 706238 */   // Label 9129: @706238
     /* 706238 */   GIM_Reject,
     /* 706239 */ // Label 9125: @706239
     /* 706239 */ GIM_Reject,
     /* 706240 */ // Label 9066: @706240
     /* 706240 */ GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(706566),
     /* 706245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 706248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 706251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 706254 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 706257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 706261 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(706333), // Rule ID 4812 //
     /* 706266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706277 */     // MIs[0] offset
     /* 706277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706280 */     // MIs[0] auxiliary
     /* 706280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706283 */     // MIs[0] Operand 7
     /* 706283 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706301 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 706304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706313 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706331 */     GIR_RootConstrainSelectedInstOperands,
     /* 706332 */     // GIR_Coverage, 4812,
     /* 706332 */     GIR_EraseRootFromParent_Done,
     /* 706333 */   // Label 9131: @706333
     /* 706333 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(706403), // Rule ID 4813 //
     /* 706338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706345 */     // MIs[0] offset
     /* 706345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706348 */     // MIs[0] auxiliary
     /* 706348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706351 */     // MIs[0] Operand 7
     /* 706351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706369 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 706372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706374 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706383 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706401 */     GIR_RootConstrainSelectedInstOperands,
     /* 706402 */     // GIR_Coverage, 4813,
     /* 706402 */     GIR_EraseRootFromParent_Done,
     /* 706403 */   // Label 9132: @706403
     /* 706403 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(706465), // Rule ID 4814 //
     /* 706408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706415 */     // MIs[0] offset
     /* 706415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706418 */     // MIs[0] auxiliary
     /* 706418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706421 */     // MIs[0] Operand 7
     /* 706421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706431 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 706434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706436 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 706438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706445 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706463 */     GIR_RootConstrainSelectedInstOperands,
     /* 706464 */     // GIR_Coverage, 4814,
     /* 706464 */     GIR_EraseRootFromParent_Done,
     /* 706465 */   // Label 9133: @706465
     /* 706465 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(706565), // Rule ID 4815 //
     /* 706470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706473 */     // MIs[0] offset
     /* 706473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706476 */     // MIs[0] auxiliary
     /* 706476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706479 */     // MIs[0] Operand 7
     /* 706479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706489 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 706492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 706496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 706501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 706505 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 706508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 706512 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 706515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 706520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 706533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 706538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706545 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706563 */     GIR_RootConstrainSelectedInstOperands,
     /* 706564 */     // GIR_Coverage, 4815,
     /* 706564 */     GIR_EraseRootFromParent_Done,
     /* 706565 */   // Label 9134: @706565
     /* 706565 */   GIM_Reject,
     /* 706566 */ // Label 9130: @706566
     /* 706566 */ GIM_Reject,
     /* 706567 */ // Label 9067: @706567
     /* 706567 */ GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(709257),
     /* 706572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 706575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 706578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 706581 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 706584 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(706667), // Rule ID 4860 //
     /* 706589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706611 */     // MIs[0] offset
     /* 706611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706614 */     // MIs[0] auxiliary
     /* 706614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706617 */     // MIs[0] Operand 7
     /* 706617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706635 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 706638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706647 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706665 */     GIR_RootConstrainSelectedInstOperands,
     /* 706666 */     // GIR_Coverage, 4860,
     /* 706666 */     GIR_EraseRootFromParent_Done,
     /* 706667 */   // Label 9136: @706667
     /* 706667 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(706750), // Rule ID 4864 //
     /* 706672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706675 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706694 */     // MIs[0] offset
     /* 706694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706697 */     // MIs[0] auxiliary
     /* 706697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706700 */     // MIs[0] Operand 7
     /* 706700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706718 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 706721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706730 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706748 */     GIR_RootConstrainSelectedInstOperands,
     /* 706749 */     // GIR_Coverage, 4864,
     /* 706749 */     GIR_EraseRootFromParent_Done,
     /* 706750 */   // Label 9137: @706750
     /* 706750 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(706833), // Rule ID 4868 //
     /* 706755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706777 */     // MIs[0] offset
     /* 706777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706780 */     // MIs[0] auxiliary
     /* 706780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706783 */     // MIs[0] Operand 7
     /* 706783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706801 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 706804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706831 */     GIR_RootConstrainSelectedInstOperands,
     /* 706832 */     // GIR_Coverage, 4868,
     /* 706832 */     GIR_EraseRootFromParent_Done,
     /* 706833 */   // Label 9138: @706833
     /* 706833 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(706916), // Rule ID 4872 //
     /* 706838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706860 */     // MIs[0] offset
     /* 706860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706863 */     // MIs[0] auxiliary
     /* 706863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706866 */     // MIs[0] Operand 7
     /* 706866 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706884 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 706887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706896 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706914 */     GIR_RootConstrainSelectedInstOperands,
     /* 706915 */     // GIR_Coverage, 4872,
     /* 706915 */     GIR_EraseRootFromParent_Done,
     /* 706916 */   // Label 9139: @706916
     /* 706916 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(706992), // Rule ID 4876 //
     /* 706921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706936 */     // MIs[0] offset
     /* 706936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706939 */     // MIs[0] auxiliary
     /* 706939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706942 */     // MIs[0] Operand 7
     /* 706942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706960 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 706963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706972 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706990 */     GIR_RootConstrainSelectedInstOperands,
     /* 706991 */     // GIR_Coverage, 4876,
     /* 706991 */     GIR_EraseRootFromParent_Done,
     /* 706992 */   // Label 9140: @706992
     /* 706992 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(707068), // Rule ID 4880 //
     /* 706997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707012 */     // MIs[0] offset
     /* 707012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707015 */     // MIs[0] auxiliary
     /* 707015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707018 */     // MIs[0] Operand 7
     /* 707018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707036 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 707039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707048 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707066 */     GIR_RootConstrainSelectedInstOperands,
     /* 707067 */     // GIR_Coverage, 4880,
     /* 707067 */     GIR_EraseRootFromParent_Done,
     /* 707068 */   // Label 9141: @707068
     /* 707068 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(707144), // Rule ID 4884 //
     /* 707073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707088 */     // MIs[0] offset
     /* 707088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707091 */     // MIs[0] auxiliary
     /* 707091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707094 */     // MIs[0] Operand 7
     /* 707094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707112 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 707115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707142 */     GIR_RootConstrainSelectedInstOperands,
     /* 707143 */     // GIR_Coverage, 4884,
     /* 707143 */     GIR_EraseRootFromParent_Done,
     /* 707144 */   // Label 9142: @707144
     /* 707144 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(707220), // Rule ID 4888 //
     /* 707149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707164 */     // MIs[0] offset
     /* 707164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707167 */     // MIs[0] auxiliary
     /* 707167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707170 */     // MIs[0] Operand 7
     /* 707170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707188 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 707191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707200 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707218 */     GIR_RootConstrainSelectedInstOperands,
     /* 707219 */     // GIR_Coverage, 4888,
     /* 707219 */     GIR_EraseRootFromParent_Done,
     /* 707220 */   // Label 9143: @707220
     /* 707220 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(707301), // Rule ID 4861 //
     /* 707225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707243 */     // MIs[0] offset
     /* 707243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707246 */     // MIs[0] auxiliary
     /* 707246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707249 */     // MIs[0] Operand 7
     /* 707249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707267 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 707270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707272 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707281 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707299 */     GIR_RootConstrainSelectedInstOperands,
     /* 707300 */     // GIR_Coverage, 4861,
     /* 707300 */     GIR_EraseRootFromParent_Done,
     /* 707301 */   // Label 9144: @707301
     /* 707301 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(707382), // Rule ID 4865 //
     /* 707306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707309 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707324 */     // MIs[0] offset
     /* 707324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707327 */     // MIs[0] auxiliary
     /* 707327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707330 */     // MIs[0] Operand 7
     /* 707330 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707348 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 707351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707353 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707362 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707370 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707380 */     GIR_RootConstrainSelectedInstOperands,
     /* 707381 */     // GIR_Coverage, 4865,
     /* 707381 */     GIR_EraseRootFromParent_Done,
     /* 707382 */   // Label 9145: @707382
     /* 707382 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(707463), // Rule ID 4869 //
     /* 707387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707405 */     // MIs[0] offset
     /* 707405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707408 */     // MIs[0] auxiliary
     /* 707408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707411 */     // MIs[0] Operand 7
     /* 707411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707429 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 707432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707434 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707443 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707461 */     GIR_RootConstrainSelectedInstOperands,
     /* 707462 */     // GIR_Coverage, 4869,
     /* 707462 */     GIR_EraseRootFromParent_Done,
     /* 707463 */   // Label 9146: @707463
     /* 707463 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(707544), // Rule ID 4873 //
     /* 707468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707471 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707486 */     // MIs[0] offset
     /* 707486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707489 */     // MIs[0] auxiliary
     /* 707489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707492 */     // MIs[0] Operand 7
     /* 707492 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707510 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 707513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707515 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707524 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707542 */     GIR_RootConstrainSelectedInstOperands,
     /* 707543 */     // GIR_Coverage, 4873,
     /* 707543 */     GIR_EraseRootFromParent_Done,
     /* 707544 */   // Label 9147: @707544
     /* 707544 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(707618), // Rule ID 4877 //
     /* 707549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707560 */     // MIs[0] offset
     /* 707560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707563 */     // MIs[0] auxiliary
     /* 707563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707566 */     // MIs[0] Operand 7
     /* 707566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707584 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 707587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707589 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707616 */     GIR_RootConstrainSelectedInstOperands,
     /* 707617 */     // GIR_Coverage, 4877,
     /* 707617 */     GIR_EraseRootFromParent_Done,
     /* 707618 */   // Label 9148: @707618
     /* 707618 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(707692), // Rule ID 4881 //
     /* 707623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707634 */     // MIs[0] offset
     /* 707634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707637 */     // MIs[0] auxiliary
     /* 707637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707640 */     // MIs[0] Operand 7
     /* 707640 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707658 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 707661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707663 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707672 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707690 */     GIR_RootConstrainSelectedInstOperands,
     /* 707691 */     // GIR_Coverage, 4881,
     /* 707691 */     GIR_EraseRootFromParent_Done,
     /* 707692 */   // Label 9149: @707692
     /* 707692 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(707766), // Rule ID 4885 //
     /* 707697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707708 */     // MIs[0] offset
     /* 707708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707711 */     // MIs[0] auxiliary
     /* 707711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707714 */     // MIs[0] Operand 7
     /* 707714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707732 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 707735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707737 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707746 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707764 */     GIR_RootConstrainSelectedInstOperands,
     /* 707765 */     // GIR_Coverage, 4885,
     /* 707765 */     GIR_EraseRootFromParent_Done,
     /* 707766 */   // Label 9150: @707766
     /* 707766 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(707840), // Rule ID 4889 //
     /* 707771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707782 */     // MIs[0] offset
     /* 707782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707785 */     // MIs[0] auxiliary
     /* 707785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707788 */     // MIs[0] Operand 7
     /* 707788 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707806 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 707809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707811 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707820 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707838 */     GIR_RootConstrainSelectedInstOperands,
     /* 707839 */     // GIR_Coverage, 4889,
     /* 707839 */     GIR_EraseRootFromParent_Done,
     /* 707840 */   // Label 9151: @707840
     /* 707840 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(707913), // Rule ID 4862 //
     /* 707845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707863 */     // MIs[0] offset
     /* 707863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707866 */     // MIs[0] auxiliary
     /* 707866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707869 */     // MIs[0] Operand 7
     /* 707869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707879 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 707882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707884 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707893 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707911 */     GIR_RootConstrainSelectedInstOperands,
     /* 707912 */     // GIR_Coverage, 4862,
     /* 707912 */     GIR_EraseRootFromParent_Done,
     /* 707913 */   // Label 9152: @707913
     /* 707913 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(707986), // Rule ID 4866 //
     /* 707918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707936 */     // MIs[0] offset
     /* 707936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707939 */     // MIs[0] auxiliary
     /* 707939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707942 */     // MIs[0] Operand 7
     /* 707942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707952 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 707955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707957 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707966 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707984 */     GIR_RootConstrainSelectedInstOperands,
     /* 707985 */     // GIR_Coverage, 4866,
     /* 707985 */     GIR_EraseRootFromParent_Done,
     /* 707986 */   // Label 9153: @707986
     /* 707986 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(708059), // Rule ID 4870 //
     /* 707991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708009 */     // MIs[0] offset
     /* 708009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708012 */     // MIs[0] auxiliary
     /* 708012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708015 */     // MIs[0] Operand 7
     /* 708015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708025 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 708028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708030 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708039 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708057 */     GIR_RootConstrainSelectedInstOperands,
     /* 708058 */     // GIR_Coverage, 4870,
     /* 708058 */     GIR_EraseRootFromParent_Done,
     /* 708059 */   // Label 9154: @708059
     /* 708059 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(708132), // Rule ID 4874 //
     /* 708064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708082 */     // MIs[0] offset
     /* 708082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708085 */     // MIs[0] auxiliary
     /* 708085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708088 */     // MIs[0] Operand 7
     /* 708088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708098 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 708101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708103 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708112 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708130 */     GIR_RootConstrainSelectedInstOperands,
     /* 708131 */     // GIR_Coverage, 4874,
     /* 708131 */     GIR_EraseRootFromParent_Done,
     /* 708132 */   // Label 9155: @708132
     /* 708132 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(708198), // Rule ID 4878 //
     /* 708137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708148 */     // MIs[0] offset
     /* 708148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708151 */     // MIs[0] auxiliary
     /* 708151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708154 */     // MIs[0] Operand 7
     /* 708154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708164 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 708167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708169 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708178 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708196 */     GIR_RootConstrainSelectedInstOperands,
     /* 708197 */     // GIR_Coverage, 4878,
     /* 708197 */     GIR_EraseRootFromParent_Done,
     /* 708198 */   // Label 9156: @708198
     /* 708198 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(708264), // Rule ID 4882 //
     /* 708203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708214 */     // MIs[0] offset
     /* 708214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708217 */     // MIs[0] auxiliary
     /* 708217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708220 */     // MIs[0] Operand 7
     /* 708220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708230 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 708233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708235 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708262 */     GIR_RootConstrainSelectedInstOperands,
     /* 708263 */     // GIR_Coverage, 4882,
     /* 708263 */     GIR_EraseRootFromParent_Done,
     /* 708264 */   // Label 9157: @708264
     /* 708264 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(708330), // Rule ID 4886 //
     /* 708269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708280 */     // MIs[0] offset
     /* 708280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708283 */     // MIs[0] auxiliary
     /* 708283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708286 */     // MIs[0] Operand 7
     /* 708286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708296 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 708299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708301 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708310 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708328 */     GIR_RootConstrainSelectedInstOperands,
     /* 708329 */     // GIR_Coverage, 4886,
     /* 708329 */     GIR_EraseRootFromParent_Done,
     /* 708330 */   // Label 9158: @708330
     /* 708330 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(708396), // Rule ID 4890 //
     /* 708335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708346 */     // MIs[0] offset
     /* 708346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708349 */     // MIs[0] auxiliary
     /* 708349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708352 */     // MIs[0] Operand 7
     /* 708352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708362 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 708365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708367 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708376 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708394 */     GIR_RootConstrainSelectedInstOperands,
     /* 708395 */     // GIR_Coverage, 4890,
     /* 708395 */     GIR_EraseRootFromParent_Done,
     /* 708396 */   // Label 9159: @708396
     /* 708396 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(708507), // Rule ID 4863 //
     /* 708401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708415 */     // MIs[0] offset
     /* 708415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708418 */     // MIs[0] auxiliary
     /* 708418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708421 */     // MIs[0] Operand 7
     /* 708421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708431 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708447 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708454 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 708475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708505 */     GIR_RootConstrainSelectedInstOperands,
     /* 708506 */     // GIR_Coverage, 4863,
     /* 708506 */     GIR_EraseRootFromParent_Done,
     /* 708507 */   // Label 9160: @708507
     /* 708507 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(708618), // Rule ID 4867 //
     /* 708512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708526 */     // MIs[0] offset
     /* 708526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708529 */     // MIs[0] auxiliary
     /* 708529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708532 */     // MIs[0] Operand 7
     /* 708532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708542 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31394>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708565 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 708586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708616 */     GIR_RootConstrainSelectedInstOperands,
     /* 708617 */     // GIR_Coverage, 4867,
     /* 708617 */     GIR_EraseRootFromParent_Done,
     /* 708618 */   // Label 9161: @708618
     /* 708618 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(708729), // Rule ID 4871 //
     /* 708623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708637 */     // MIs[0] offset
     /* 708637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708640 */     // MIs[0] auxiliary
     /* 708640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708643 */     // MIs[0] Operand 7
     /* 708643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708653 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708669 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708676 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 708697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708709 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708727 */     GIR_RootConstrainSelectedInstOperands,
     /* 708728 */     // GIR_Coverage, 4871,
     /* 708728 */     GIR_EraseRootFromParent_Done,
     /* 708729 */   // Label 9162: @708729
     /* 708729 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(708840), // Rule ID 4875 //
     /* 708734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708748 */     // MIs[0] offset
     /* 708748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708751 */     // MIs[0] auxiliary
     /* 708751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708754 */     // MIs[0] Operand 7
     /* 708754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708764 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31404>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708780 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708787 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 708808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708820 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708838 */     GIR_RootConstrainSelectedInstOperands,
     /* 708839 */     // GIR_Coverage, 4875,
     /* 708839 */     GIR_EraseRootFromParent_Done,
     /* 708840 */   // Label 9163: @708840
     /* 708840 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(708944), // Rule ID 4879 //
     /* 708845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708852 */     // MIs[0] offset
     /* 708852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708855 */     // MIs[0] auxiliary
     /* 708855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708858 */     // MIs[0] Operand 7
     /* 708858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708868 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708891 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 708912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708924 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708942 */     GIR_RootConstrainSelectedInstOperands,
     /* 708943 */     // GIR_Coverage, 4879,
     /* 708943 */     GIR_EraseRootFromParent_Done,
     /* 708944 */   // Label 9164: @708944
     /* 708944 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(709048), // Rule ID 4883 //
     /* 708949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708956 */     // MIs[0] offset
     /* 708956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708959 */     // MIs[0] auxiliary
     /* 708959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708962 */     // MIs[0] Operand 7
     /* 708962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708972 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708988 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708995 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 709016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709028 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709046 */     GIR_RootConstrainSelectedInstOperands,
     /* 709047 */     // GIR_Coverage, 4883,
     /* 709047 */     GIR_EraseRootFromParent_Done,
     /* 709048 */   // Label 9165: @709048
     /* 709048 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(709152), // Rule ID 4887 //
     /* 709053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 709060 */     // MIs[0] offset
     /* 709060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709063 */     // MIs[0] auxiliary
     /* 709063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709066 */     // MIs[0] Operand 7
     /* 709066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709076 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709092 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709099 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 709120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709150 */     GIR_RootConstrainSelectedInstOperands,
     /* 709151 */     // GIR_Coverage, 4887,
     /* 709151 */     GIR_EraseRootFromParent_Done,
     /* 709152 */   // Label 9166: @709152
     /* 709152 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(709256), // Rule ID 4891 //
     /* 709157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 709164 */     // MIs[0] offset
     /* 709164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709167 */     // MIs[0] auxiliary
     /* 709167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709170 */     // MIs[0] Operand 7
     /* 709170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709180 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709196 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709203 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 709224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709254 */     GIR_RootConstrainSelectedInstOperands,
     /* 709255 */     // GIR_Coverage, 4891,
     /* 709255 */     GIR_EraseRootFromParent_Done,
     /* 709256 */   // Label 9167: @709256
     /* 709256 */   GIM_Reject,
     /* 709257 */ // Label 9135: @709257
     /* 709257 */ GIM_Reject,
     /* 709258 */ // Label 9068: @709258
     /* 709258 */ GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(709584),
     /* 709263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 709266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 709269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 709272 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 709275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 709279 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(709351), // Rule ID 4816 //
     /* 709284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709295 */     // MIs[0] offset
     /* 709295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709298 */     // MIs[0] auxiliary
     /* 709298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709301 */     // MIs[0] Operand 7
     /* 709301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709319 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 709322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709331 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709349 */     GIR_RootConstrainSelectedInstOperands,
     /* 709350 */     // GIR_Coverage, 4816,
     /* 709350 */     GIR_EraseRootFromParent_Done,
     /* 709351 */   // Label 9169: @709351
     /* 709351 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(709421), // Rule ID 4817 //
     /* 709356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709363 */     // MIs[0] offset
     /* 709363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709366 */     // MIs[0] auxiliary
     /* 709366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709369 */     // MIs[0] Operand 7
     /* 709369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709387 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 709390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709392 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709419 */     GIR_RootConstrainSelectedInstOperands,
     /* 709420 */     // GIR_Coverage, 4817,
     /* 709420 */     GIR_EraseRootFromParent_Done,
     /* 709421 */   // Label 9170: @709421
     /* 709421 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(709483), // Rule ID 4818 //
     /* 709426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709433 */     // MIs[0] offset
     /* 709433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709436 */     // MIs[0] auxiliary
     /* 709436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709439 */     // MIs[0] Operand 7
     /* 709439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709449 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 709452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709454 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709463 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709481 */     GIR_RootConstrainSelectedInstOperands,
     /* 709482 */     // GIR_Coverage, 4818,
     /* 709482 */     GIR_EraseRootFromParent_Done,
     /* 709483 */   // Label 9171: @709483
     /* 709483 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(709583), // Rule ID 4819 //
     /* 709488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709491 */     // MIs[0] offset
     /* 709491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709494 */     // MIs[0] auxiliary
     /* 709494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709497 */     // MIs[0] Operand 7
     /* 709497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709507 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709523 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709530 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 709551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709563 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709581 */     GIR_RootConstrainSelectedInstOperands,
     /* 709582 */     // GIR_Coverage, 4819,
     /* 709582 */     GIR_EraseRootFromParent_Done,
     /* 709583 */   // Label 9172: @709583
     /* 709583 */   GIM_Reject,
     /* 709584 */ // Label 9168: @709584
     /* 709584 */ GIM_Reject,
     /* 709585 */ // Label 9069: @709585
     /* 709585 */ GIM_Reject,
     /* 709586 */ // Label 128: @709586
     /* 709586 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9177*/ GIMT_Encode4(712105),
     /* 709597 */ /*GILLT_v2s32*//*Label 9173*/ GIMT_Encode4(709629), GIMT_Encode4(0),
     /* 709605 */ /*GILLT_v3s32*//*Label 9174*/ GIMT_Encode4(710248), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 709617 */ /*GILLT_v4s32*//*Label 9175*/ GIMT_Encode4(710867), GIMT_Encode4(0),
     /* 709625 */ /*GILLT_v5s32*//*Label 9176*/ GIMT_Encode4(711486),
     /* 709629 */ // Label 9173: @709629
     /* 709629 */ GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(710247),
     /* 709634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 709637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 709640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 709643 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 709646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 709650 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(709722), // Rule ID 4764 //
     /* 709655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709666 */     // MIs[0] offset
     /* 709666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709669 */     // MIs[0] auxiliary
     /* 709669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709672 */     // MIs[0] Operand 7
     /* 709672 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709690 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFSET),
     /* 709693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709720 */     GIR_RootConstrainSelectedInstOperands,
     /* 709721 */     // GIR_Coverage, 4764,
     /* 709721 */     GIR_EraseRootFromParent_Done,
     /* 709722 */   // Label 9179: @709722
     /* 709722 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(709791), // Rule ID 4768 //
     /* 709727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709735 */     // MIs[0] offset
     /* 709735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709738 */     // MIs[0] auxiliary
     /* 709738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709741 */     // MIs[0] Operand 7
     /* 709741 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709759 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET),
     /* 709762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709789 */     GIR_RootConstrainSelectedInstOperands,
     /* 709790 */     // GIR_Coverage, 4768,
     /* 709790 */     GIR_EraseRootFromParent_Done,
     /* 709791 */   // Label 9180: @709791
     /* 709791 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(709861), // Rule ID 4765 //
     /* 709796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709803 */     // MIs[0] offset
     /* 709803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709806 */     // MIs[0] auxiliary
     /* 709806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709809 */     // MIs[0] Operand 7
     /* 709809 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709827 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFEN),
     /* 709830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709832 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709841 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709859 */     GIR_RootConstrainSelectedInstOperands,
     /* 709860 */     // GIR_Coverage, 4765,
     /* 709860 */     GIR_EraseRootFromParent_Done,
     /* 709861 */   // Label 9181: @709861
     /* 709861 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(709928), // Rule ID 4769 //
     /* 709866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709870 */     // MIs[0] offset
     /* 709870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709873 */     // MIs[0] auxiliary
     /* 709873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709876 */     // MIs[0] Operand 7
     /* 709876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709894 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN),
     /* 709897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709899 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709908 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709926 */     GIR_RootConstrainSelectedInstOperands,
     /* 709927 */     // GIR_Coverage, 4769,
     /* 709927 */     GIR_EraseRootFromParent_Done,
     /* 709928 */   // Label 9182: @709928
     /* 709928 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(709990), // Rule ID 4766 //
     /* 709933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709940 */     // MIs[0] offset
     /* 709940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709943 */     // MIs[0] auxiliary
     /* 709943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709946 */     // MIs[0] Operand 7
     /* 709946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709956 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_IDXEN),
     /* 709959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709961 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709970 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709988 */     GIR_RootConstrainSelectedInstOperands,
     /* 709989 */     // GIR_Coverage, 4766,
     /* 709989 */     GIR_EraseRootFromParent_Done,
     /* 709990 */   // Label 9183: @709990
     /* 709990 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(710049), // Rule ID 4770 //
     /* 709995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709999 */     // MIs[0] offset
     /* 709999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710002 */     // MIs[0] auxiliary
     /* 710002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710005 */     // MIs[0] Operand 7
     /* 710005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710015 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN),
     /* 710018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710020 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710029 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710047 */     GIR_RootConstrainSelectedInstOperands,
     /* 710048 */     // GIR_Coverage, 4770,
     /* 710048 */     GIR_EraseRootFromParent_Done,
     /* 710049 */   // Label 9184: @710049
     /* 710049 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(710149), // Rule ID 4767 //
     /* 710054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710057 */     // MIs[0] offset
     /* 710057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710060 */     // MIs[0] auxiliary
     /* 710060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710063 */     // MIs[0] Operand 7
     /* 710063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710073 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710089 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710096 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_BOTHEN),
     /* 710117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710129 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710147 */     GIR_RootConstrainSelectedInstOperands,
     /* 710148 */     // GIR_Coverage, 4767,
     /* 710148 */     GIR_EraseRootFromParent_Done,
     /* 710149 */   // Label 9185: @710149
     /* 710149 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(710246), // Rule ID 4771 //
     /* 710154 */     // MIs[0] offset
     /* 710154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710157 */     // MIs[0] auxiliary
     /* 710157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710160 */     // MIs[0] Operand 7
     /* 710160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710170 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710186 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710193 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN),
     /* 710214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710226 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710244 */     GIR_RootConstrainSelectedInstOperands,
     /* 710245 */     // GIR_Coverage, 4771,
     /* 710245 */     GIR_EraseRootFromParent_Done,
     /* 710246 */   // Label 9186: @710246
     /* 710246 */   GIM_Reject,
     /* 710247 */ // Label 9178: @710247
     /* 710247 */ GIM_Reject,
     /* 710248 */ // Label 9174: @710248
     /* 710248 */ GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(710866),
     /* 710253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710262 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 710269 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(710341), // Rule ID 4772 //
     /* 710274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710285 */     // MIs[0] offset
     /* 710285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710288 */     // MIs[0] auxiliary
     /* 710288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710291 */     // MIs[0] Operand 7
     /* 710291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710309 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFSET),
     /* 710312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710321 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710339 */     GIR_RootConstrainSelectedInstOperands,
     /* 710340 */     // GIR_Coverage, 4772,
     /* 710340 */     GIR_EraseRootFromParent_Done,
     /* 710341 */   // Label 9188: @710341
     /* 710341 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(710410), // Rule ID 4776 //
     /* 710346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710354 */     // MIs[0] offset
     /* 710354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710357 */     // MIs[0] auxiliary
     /* 710357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710360 */     // MIs[0] Operand 7
     /* 710360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710378 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET),
     /* 710381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710390 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710408 */     GIR_RootConstrainSelectedInstOperands,
     /* 710409 */     // GIR_Coverage, 4776,
     /* 710409 */     GIR_EraseRootFromParent_Done,
     /* 710410 */   // Label 9189: @710410
     /* 710410 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(710480), // Rule ID 4773 //
     /* 710415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710422 */     // MIs[0] offset
     /* 710422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710425 */     // MIs[0] auxiliary
     /* 710425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710428 */     // MIs[0] Operand 7
     /* 710428 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710446 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFEN),
     /* 710449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710451 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710478 */     GIR_RootConstrainSelectedInstOperands,
     /* 710479 */     // GIR_Coverage, 4773,
     /* 710479 */     GIR_EraseRootFromParent_Done,
     /* 710480 */   // Label 9190: @710480
     /* 710480 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(710547), // Rule ID 4777 //
     /* 710485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710489 */     // MIs[0] offset
     /* 710489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710492 */     // MIs[0] auxiliary
     /* 710492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710495 */     // MIs[0] Operand 7
     /* 710495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710513 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN),
     /* 710516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710518 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710545 */     GIR_RootConstrainSelectedInstOperands,
     /* 710546 */     // GIR_Coverage, 4777,
     /* 710546 */     GIR_EraseRootFromParent_Done,
     /* 710547 */   // Label 9191: @710547
     /* 710547 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(710609), // Rule ID 4774 //
     /* 710552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710559 */     // MIs[0] offset
     /* 710559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710562 */     // MIs[0] auxiliary
     /* 710562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710565 */     // MIs[0] Operand 7
     /* 710565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710575 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_IDXEN),
     /* 710578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710580 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710589 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710607 */     GIR_RootConstrainSelectedInstOperands,
     /* 710608 */     // GIR_Coverage, 4774,
     /* 710608 */     GIR_EraseRootFromParent_Done,
     /* 710609 */   // Label 9192: @710609
     /* 710609 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(710668), // Rule ID 4778 //
     /* 710614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710618 */     // MIs[0] offset
     /* 710618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710621 */     // MIs[0] auxiliary
     /* 710621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710624 */     // MIs[0] Operand 7
     /* 710624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710634 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN),
     /* 710637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710639 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710648 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710666 */     GIR_RootConstrainSelectedInstOperands,
     /* 710667 */     // GIR_Coverage, 4778,
     /* 710667 */     GIR_EraseRootFromParent_Done,
     /* 710668 */   // Label 9193: @710668
     /* 710668 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(710768), // Rule ID 4775 //
     /* 710673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710676 */     // MIs[0] offset
     /* 710676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710679 */     // MIs[0] auxiliary
     /* 710679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710682 */     // MIs[0] Operand 7
     /* 710682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710692 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710708 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710715 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN),
     /* 710736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710748 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710766 */     GIR_RootConstrainSelectedInstOperands,
     /* 710767 */     // GIR_Coverage, 4775,
     /* 710767 */     GIR_EraseRootFromParent_Done,
     /* 710768 */   // Label 9194: @710768
     /* 710768 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(710865), // Rule ID 4779 //
     /* 710773 */     // MIs[0] offset
     /* 710773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710776 */     // MIs[0] auxiliary
     /* 710776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710779 */     // MIs[0] Operand 7
     /* 710779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710789 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710805 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710812 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN),
     /* 710833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710845 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710863 */     GIR_RootConstrainSelectedInstOperands,
     /* 710864 */     // GIR_Coverage, 4779,
     /* 710864 */     GIR_EraseRootFromParent_Done,
     /* 710865 */   // Label 9195: @710865
     /* 710865 */   GIM_Reject,
     /* 710866 */ // Label 9187: @710866
     /* 710866 */ GIM_Reject,
     /* 710867 */ // Label 9175: @710867
     /* 710867 */ GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(711485),
     /* 710872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710881 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 710888 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(710960), // Rule ID 4780 //
     /* 710893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710904 */     // MIs[0] offset
     /* 710904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710907 */     // MIs[0] auxiliary
     /* 710907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710910 */     // MIs[0] Operand 7
     /* 710910 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710928 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET),
     /* 710931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710940 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710958 */     GIR_RootConstrainSelectedInstOperands,
     /* 710959 */     // GIR_Coverage, 4780,
     /* 710959 */     GIR_EraseRootFromParent_Done,
     /* 710960 */   // Label 9197: @710960
     /* 710960 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(711029), // Rule ID 4784 //
     /* 710965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710973 */     // MIs[0] offset
     /* 710973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710976 */     // MIs[0] auxiliary
     /* 710976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710979 */     // MIs[0] Operand 7
     /* 710979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710997 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET),
     /* 711000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711009 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711027 */     GIR_RootConstrainSelectedInstOperands,
     /* 711028 */     // GIR_Coverage, 4784,
     /* 711028 */     GIR_EraseRootFromParent_Done,
     /* 711029 */   // Label 9198: @711029
     /* 711029 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(711099), // Rule ID 4781 //
     /* 711034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711041 */     // MIs[0] offset
     /* 711041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711044 */     // MIs[0] auxiliary
     /* 711044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711047 */     // MIs[0] Operand 7
     /* 711047 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711065 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN),
     /* 711068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711070 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711079 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711097 */     GIR_RootConstrainSelectedInstOperands,
     /* 711098 */     // GIR_Coverage, 4781,
     /* 711098 */     GIR_EraseRootFromParent_Done,
     /* 711099 */   // Label 9199: @711099
     /* 711099 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(711166), // Rule ID 4785 //
     /* 711104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711108 */     // MIs[0] offset
     /* 711108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711111 */     // MIs[0] auxiliary
     /* 711111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711114 */     // MIs[0] Operand 7
     /* 711114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711132 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN),
     /* 711135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711137 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711146 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711164 */     GIR_RootConstrainSelectedInstOperands,
     /* 711165 */     // GIR_Coverage, 4785,
     /* 711165 */     GIR_EraseRootFromParent_Done,
     /* 711166 */   // Label 9200: @711166
     /* 711166 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(711228), // Rule ID 4782 //
     /* 711171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711178 */     // MIs[0] offset
     /* 711178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711181 */     // MIs[0] auxiliary
     /* 711181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711184 */     // MIs[0] Operand 7
     /* 711184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711194 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN),
     /* 711197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711199 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711208 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711226 */     GIR_RootConstrainSelectedInstOperands,
     /* 711227 */     // GIR_Coverage, 4782,
     /* 711227 */     GIR_EraseRootFromParent_Done,
     /* 711228 */   // Label 9201: @711228
     /* 711228 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(711287), // Rule ID 4786 //
     /* 711233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711237 */     // MIs[0] offset
     /* 711237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711240 */     // MIs[0] auxiliary
     /* 711240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711243 */     // MIs[0] Operand 7
     /* 711243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711253 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN),
     /* 711256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711258 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711267 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711285 */     GIR_RootConstrainSelectedInstOperands,
     /* 711286 */     // GIR_Coverage, 4786,
     /* 711286 */     GIR_EraseRootFromParent_Done,
     /* 711287 */   // Label 9202: @711287
     /* 711287 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(711387), // Rule ID 4783 //
     /* 711292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711295 */     // MIs[0] offset
     /* 711295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711298 */     // MIs[0] auxiliary
     /* 711298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711301 */     // MIs[0] Operand 7
     /* 711301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711311 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711327 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711334 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN),
     /* 711355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711367 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711385 */     GIR_RootConstrainSelectedInstOperands,
     /* 711386 */     // GIR_Coverage, 4783,
     /* 711386 */     GIR_EraseRootFromParent_Done,
     /* 711387 */   // Label 9203: @711387
     /* 711387 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(711484), // Rule ID 4787 //
     /* 711392 */     // MIs[0] offset
     /* 711392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711395 */     // MIs[0] auxiliary
     /* 711395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711398 */     // MIs[0] Operand 7
     /* 711398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711408 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711424 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711431 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN),
     /* 711452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711464 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711482 */     GIR_RootConstrainSelectedInstOperands,
     /* 711483 */     // GIR_Coverage, 4787,
     /* 711483 */     GIR_EraseRootFromParent_Done,
     /* 711484 */   // Label 9204: @711484
     /* 711484 */   GIM_Reject,
     /* 711485 */ // Label 9196: @711485
     /* 711485 */ GIM_Reject,
     /* 711486 */ // Label 9176: @711486
     /* 711486 */ GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(712104),
     /* 711491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 711494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 711497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 711500 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 711503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 711507 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(711579), // Rule ID 4788 //
     /* 711512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711523 */     // MIs[0] offset
     /* 711523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711526 */     // MIs[0] auxiliary
     /* 711526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711529 */     // MIs[0] Operand 7
     /* 711529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711547 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET),
     /* 711550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711559 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711577 */     GIR_RootConstrainSelectedInstOperands,
     /* 711578 */     // GIR_Coverage, 4788,
     /* 711578 */     GIR_EraseRootFromParent_Done,
     /* 711579 */   // Label 9206: @711579
     /* 711579 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(711648), // Rule ID 4792 //
     /* 711584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711592 */     // MIs[0] offset
     /* 711592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711595 */     // MIs[0] auxiliary
     /* 711595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711598 */     // MIs[0] Operand 7
     /* 711598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711616 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET),
     /* 711619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711628 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711646 */     GIR_RootConstrainSelectedInstOperands,
     /* 711647 */     // GIR_Coverage, 4792,
     /* 711647 */     GIR_EraseRootFromParent_Done,
     /* 711648 */   // Label 9207: @711648
     /* 711648 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(711718), // Rule ID 4789 //
     /* 711653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711660 */     // MIs[0] offset
     /* 711660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711663 */     // MIs[0] auxiliary
     /* 711663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711666 */     // MIs[0] Operand 7
     /* 711666 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711684 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN),
     /* 711687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711689 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711698 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711716 */     GIR_RootConstrainSelectedInstOperands,
     /* 711717 */     // GIR_Coverage, 4789,
     /* 711717 */     GIR_EraseRootFromParent_Done,
     /* 711718 */   // Label 9208: @711718
     /* 711718 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(711785), // Rule ID 4793 //
     /* 711723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711727 */     // MIs[0] offset
     /* 711727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711730 */     // MIs[0] auxiliary
     /* 711730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711733 */     // MIs[0] Operand 7
     /* 711733 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711751 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN),
     /* 711754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711756 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711765 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711783 */     GIR_RootConstrainSelectedInstOperands,
     /* 711784 */     // GIR_Coverage, 4793,
     /* 711784 */     GIR_EraseRootFromParent_Done,
     /* 711785 */   // Label 9209: @711785
     /* 711785 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(711847), // Rule ID 4790 //
     /* 711790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711797 */     // MIs[0] offset
     /* 711797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711800 */     // MIs[0] auxiliary
     /* 711800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711803 */     // MIs[0] Operand 7
     /* 711803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711813 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN),
     /* 711816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711818 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711827 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711845 */     GIR_RootConstrainSelectedInstOperands,
     /* 711846 */     // GIR_Coverage, 4790,
     /* 711846 */     GIR_EraseRootFromParent_Done,
     /* 711847 */   // Label 9210: @711847
     /* 711847 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(711906), // Rule ID 4794 //
     /* 711852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711856 */     // MIs[0] offset
     /* 711856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711859 */     // MIs[0] auxiliary
     /* 711859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711862 */     // MIs[0] Operand 7
     /* 711862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711872 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN),
     /* 711875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711877 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711886 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711904 */     GIR_RootConstrainSelectedInstOperands,
     /* 711905 */     // GIR_Coverage, 4794,
     /* 711905 */     GIR_EraseRootFromParent_Done,
     /* 711906 */   // Label 9211: @711906
     /* 711906 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(712006), // Rule ID 4791 //
     /* 711911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711914 */     // MIs[0] offset
     /* 711914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711917 */     // MIs[0] auxiliary
     /* 711917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711920 */     // MIs[0] Operand 7
     /* 711920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711930 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711946 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711953 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN),
     /* 711974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711986 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712004 */     GIR_RootConstrainSelectedInstOperands,
     /* 712005 */     // GIR_Coverage, 4791,
     /* 712005 */     GIR_EraseRootFromParent_Done,
     /* 712006 */   // Label 9212: @712006
     /* 712006 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(712103), // Rule ID 4795 //
     /* 712011 */     // MIs[0] offset
     /* 712011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712014 */     // MIs[0] auxiliary
     /* 712014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712017 */     // MIs[0] Operand 7
     /* 712017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712027 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712043 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712050 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN),
     /* 712071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712083 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712101 */     GIR_RootConstrainSelectedInstOperands,
     /* 712102 */     // GIR_Coverage, 4795,
     /* 712102 */     GIR_EraseRootFromParent_Done,
     /* 712103 */   // Label 9213: @712103
     /* 712103 */   GIM_Reject,
     /* 712104 */ // Label 9205: @712104
     /* 712104 */ GIM_Reject,
     /* 712105 */ // Label 9177: @712105
     /* 712105 */ GIM_Reject,
     /* 712106 */ // Label 129: @712106
     /* 712106 */ GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(712711),
     /* 712111 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 712114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 712117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 712120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 712123 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 712126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 712130 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(712402),
     /* 712135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 712139 */     GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(712207), // Rule ID 5092 //
     /* 712144 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712147 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712151 */       // MIs[0] offset
     /* 712151 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712154 */       // MIs[0] auxiliary
     /* 712154 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712157 */       // MIs[0] Operand 7
     /* 712157 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712168 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712175 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712175 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 712178 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712180 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712182 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712187 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712189 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712195 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712201 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712205 */       GIR_RootConstrainSelectedInstOperands,
     /* 712206 */       // GIR_Coverage, 5092,
     /* 712206 */       GIR_EraseRootFromParent_Done,
     /* 712207 */     // Label 9216: @712207
     /* 712207 */     GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(712272), // Rule ID 5096 //
     /* 712212 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712216 */       // MIs[0] offset
     /* 712216 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712219 */       // MIs[0] auxiliary
     /* 712219 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712222 */       // MIs[0] Operand 7
     /* 712222 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712233 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712240 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712240 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 712243 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712245 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712247 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712252 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712254 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712260 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712266 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712270 */       GIR_RootConstrainSelectedInstOperands,
     /* 712271 */       // GIR_Coverage, 5096,
     /* 712271 */       GIR_EraseRootFromParent_Done,
     /* 712272 */     // Label 9217: @712272
     /* 712272 */     GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(712338), // Rule ID 5093 //
     /* 712277 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712280 */       // MIs[0] offset
     /* 712280 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712283 */       // MIs[0] auxiliary
     /* 712283 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712286 */       // MIs[0] Operand 7
     /* 712286 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712297 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712304 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 712307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712309 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712311 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712313 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712318 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712320 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712326 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712332 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712336 */       GIR_RootConstrainSelectedInstOperands,
     /* 712337 */       // GIR_Coverage, 5093,
     /* 712337 */       GIR_EraseRootFromParent_Done,
     /* 712338 */     // Label 9218: @712338
     /* 712338 */     GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(712401), // Rule ID 5097 //
     /* 712343 */       // MIs[0] offset
     /* 712343 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712346 */       // MIs[0] auxiliary
     /* 712346 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712349 */       // MIs[0] Operand 7
     /* 712349 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712360 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712367 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 712370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712372 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712374 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712376 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712381 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712383 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712389 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712395 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712399 */       GIR_RootConstrainSelectedInstOperands,
     /* 712400 */       // GIR_Coverage, 5097,
     /* 712400 */       GIR_EraseRootFromParent_Done,
     /* 712401 */     // Label 9219: @712401
     /* 712401 */     GIM_Reject,
     /* 712402 */   // Label 9215: @712402
     /* 712402 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(712516),
     /* 712407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712420 */     GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(712469), // Rule ID 5094 //
     /* 712425 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712435 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_IDXEN),
     /* 712438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712440 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712442 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712444 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712449 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712451 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712457 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712463 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712467 */       GIR_RootConstrainSelectedInstOperands,
     /* 712468 */       // GIR_Coverage, 5094,
     /* 712468 */       GIR_EraseRootFromParent_Done,
     /* 712469 */     // Label 9221: @712469
     /* 712469 */     GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(712515), // Rule ID 5098 //
     /* 712474 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712481 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712481 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_IDXEN),
     /* 712484 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712486 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712488 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712490 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712495 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712497 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712503 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712509 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712513 */       GIR_RootConstrainSelectedInstOperands,
     /* 712514 */       // GIR_Coverage, 5098,
     /* 712514 */       GIR_EraseRootFromParent_Done,
     /* 712515 */     // Label 9222: @712515
     /* 712515 */     GIM_Reject,
     /* 712516 */   // Label 9220: @712516
     /* 712516 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(712710),
     /* 712521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712530 */     GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(712621), // Rule ID 5095 //
     /* 712535 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712538 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712545 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712545 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712548 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712552 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712561 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712568 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712571 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_BOTHEN),
     /* 712589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712594 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712596 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712601 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712603 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712609 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712615 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712619 */       GIR_RootConstrainSelectedInstOperands,
     /* 712620 */       // GIR_Coverage, 5095,
     /* 712620 */       GIR_EraseRootFromParent_Done,
     /* 712621 */     // Label 9224: @712621
     /* 712621 */     GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(712709), // Rule ID 5099 //
     /* 712626 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712633 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712633 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712636 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712640 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712645 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712649 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712652 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712656 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712659 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712664 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712674 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN),
     /* 712677 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712679 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712682 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712684 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712689 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712691 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712697 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712703 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712707 */       GIR_RootConstrainSelectedInstOperands,
     /* 712708 */       // GIR_Coverage, 5099,
     /* 712708 */       GIR_EraseRootFromParent_Done,
     /* 712709 */     // Label 9225: @712709
     /* 712709 */     GIM_Reject,
     /* 712710 */   // Label 9223: @712710
     /* 712710 */   GIM_Reject,
     /* 712711 */ // Label 9214: @712711
     /* 712711 */ GIM_Reject,
     /* 712712 */ // Label 130: @712712
     /* 712712 */ GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(713317),
     /* 712717 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 712720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 712723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 712726 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 712729 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 712732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712736 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(713008),
     /* 712741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 712745 */     GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(712813), // Rule ID 5156 //
     /* 712750 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712753 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712757 */       // MIs[0] offset
     /* 712757 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712760 */       // MIs[0] auxiliary
     /* 712760 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712763 */       // MIs[0] Operand 7
     /* 712763 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712774 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712781 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712781 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFSET),
     /* 712784 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712786 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712788 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712793 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712795 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712801 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712807 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712811 */       GIR_RootConstrainSelectedInstOperands,
     /* 712812 */       // GIR_Coverage, 5156,
     /* 712812 */       GIR_EraseRootFromParent_Done,
     /* 712813 */     // Label 9228: @712813
     /* 712813 */     GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(712878), // Rule ID 5160 //
     /* 712818 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712822 */       // MIs[0] offset
     /* 712822 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712825 */       // MIs[0] auxiliary
     /* 712825 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712828 */       // MIs[0] Operand 7
     /* 712828 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712839 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712846 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET),
     /* 712849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712851 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712858 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712860 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712866 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712872 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712876 */       GIR_RootConstrainSelectedInstOperands,
     /* 712877 */       // GIR_Coverage, 5160,
     /* 712877 */       GIR_EraseRootFromParent_Done,
     /* 712878 */     // Label 9229: @712878
     /* 712878 */     GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(712944), // Rule ID 5157 //
     /* 712883 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712886 */       // MIs[0] offset
     /* 712886 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712889 */       // MIs[0] auxiliary
     /* 712889 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712892 */       // MIs[0] Operand 7
     /* 712892 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712903 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712910 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712910 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFEN),
     /* 712913 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712915 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712917 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712919 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712924 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712926 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712932 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712938 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712942 */       GIR_RootConstrainSelectedInstOperands,
     /* 712943 */       // GIR_Coverage, 5157,
     /* 712943 */       GIR_EraseRootFromParent_Done,
     /* 712944 */     // Label 9230: @712944
     /* 712944 */     GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(713007), // Rule ID 5161 //
     /* 712949 */       // MIs[0] offset
     /* 712949 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712952 */       // MIs[0] auxiliary
     /* 712952 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712955 */       // MIs[0] Operand 7
     /* 712955 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712966 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712973 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN),
     /* 712976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712978 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712980 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712982 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712987 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712989 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712995 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713001 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713005 */       GIR_RootConstrainSelectedInstOperands,
     /* 713006 */       // GIR_Coverage, 5161,
     /* 713006 */       GIR_EraseRootFromParent_Done,
     /* 713007 */     // Label 9231: @713007
     /* 713007 */     GIM_Reject,
     /* 713008 */   // Label 9227: @713008
     /* 713008 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(713122),
     /* 713013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713026 */     GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(713075), // Rule ID 5158 //
     /* 713031 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713034 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713041 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_IDXEN),
     /* 713044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713046 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713048 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713050 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713055 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713057 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713063 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713069 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713073 */       GIR_RootConstrainSelectedInstOperands,
     /* 713074 */       // GIR_Coverage, 5158,
     /* 713074 */       GIR_EraseRootFromParent_Done,
     /* 713075 */     // Label 9233: @713075
     /* 713075 */     GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(713121), // Rule ID 5162 //
     /* 713080 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713087 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713087 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN),
     /* 713090 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713092 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713094 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713096 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713101 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713103 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713109 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713115 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713119 */       GIR_RootConstrainSelectedInstOperands,
     /* 713120 */       // GIR_Coverage, 5162,
     /* 713120 */       GIR_EraseRootFromParent_Done,
     /* 713121 */     // Label 9234: @713121
     /* 713121 */     GIM_Reject,
     /* 713122 */   // Label 9232: @713122
     /* 713122 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(713316),
     /* 713127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713136 */     GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(713227), // Rule ID 5159 //
     /* 713141 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713144 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713151 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713151 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713154 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713158 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713163 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713167 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713170 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713174 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713182 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713187 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_BOTHEN),
     /* 713195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713197 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713200 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713202 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713207 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713209 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713215 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713221 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713225 */       GIR_RootConstrainSelectedInstOperands,
     /* 713226 */       // GIR_Coverage, 5159,
     /* 713226 */       GIR_EraseRootFromParent_Done,
     /* 713227 */     // Label 9236: @713227
     /* 713227 */     GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(713315), // Rule ID 5163 //
     /* 713232 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713239 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713239 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713242 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713246 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713251 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713255 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713258 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713262 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713275 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713280 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN),
     /* 713283 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713285 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713288 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713295 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713297 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713303 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713309 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713313 */       GIR_RootConstrainSelectedInstOperands,
     /* 713314 */       // GIR_Coverage, 5163,
     /* 713314 */       GIR_EraseRootFromParent_Done,
     /* 713315 */     // Label 9237: @713315
     /* 713315 */     GIM_Reject,
     /* 713316 */   // Label 9235: @713316
     /* 713316 */   GIM_Reject,
     /* 713317 */ // Label 9226: @713317
     /* 713317 */ GIM_Reject,
     /* 713318 */ // Label 131: @713318
     /* 713318 */ GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(713923),
     /* 713323 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 713326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713335 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 713342 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(713614),
     /* 713347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713351 */     GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(713419), // Rule ID 5100 //
     /* 713356 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713359 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713363 */       // MIs[0] offset
     /* 713363 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713366 */       // MIs[0] auxiliary
     /* 713366 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713369 */       // MIs[0] Operand 7
     /* 713369 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713380 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713387 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713387 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 713390 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713392 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713394 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713399 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713401 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713407 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713413 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713417 */       GIR_RootConstrainSelectedInstOperands,
     /* 713418 */       // GIR_Coverage, 5100,
     /* 713418 */       GIR_EraseRootFromParent_Done,
     /* 713419 */     // Label 9240: @713419
     /* 713419 */     GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(713484), // Rule ID 5104 //
     /* 713424 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713428 */       // MIs[0] offset
     /* 713428 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713431 */       // MIs[0] auxiliary
     /* 713431 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713434 */       // MIs[0] Operand 7
     /* 713434 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713445 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713452 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 713455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713457 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713464 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713466 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713472 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713478 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713482 */       GIR_RootConstrainSelectedInstOperands,
     /* 713483 */       // GIR_Coverage, 5104,
     /* 713483 */       GIR_EraseRootFromParent_Done,
     /* 713484 */     // Label 9241: @713484
     /* 713484 */     GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(713550), // Rule ID 5101 //
     /* 713489 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713492 */       // MIs[0] offset
     /* 713492 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713495 */       // MIs[0] auxiliary
     /* 713495 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713498 */       // MIs[0] Operand 7
     /* 713498 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713509 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713516 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713516 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 713519 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713521 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713523 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713525 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713530 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713532 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713538 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713544 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713548 */       GIR_RootConstrainSelectedInstOperands,
     /* 713549 */       // GIR_Coverage, 5101,
     /* 713549 */       GIR_EraseRootFromParent_Done,
     /* 713550 */     // Label 9242: @713550
     /* 713550 */     GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(713613), // Rule ID 5105 //
     /* 713555 */       // MIs[0] offset
     /* 713555 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713558 */       // MIs[0] auxiliary
     /* 713558 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713561 */       // MIs[0] Operand 7
     /* 713561 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713572 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713579 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 713582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713584 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713586 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713593 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713595 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713601 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713607 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713611 */       GIR_RootConstrainSelectedInstOperands,
     /* 713612 */       // GIR_Coverage, 5105,
     /* 713612 */       GIR_EraseRootFromParent_Done,
     /* 713613 */     // Label 9243: @713613
     /* 713613 */     GIM_Reject,
     /* 713614 */   // Label 9239: @713614
     /* 713614 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(713728),
     /* 713619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713632 */     GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(713681), // Rule ID 5102 //
     /* 713637 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713640 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713647 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713647 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_IDXEN),
     /* 713650 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713652 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713654 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713656 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713661 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713663 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713669 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713675 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713679 */       GIR_RootConstrainSelectedInstOperands,
     /* 713680 */       // GIR_Coverage, 5102,
     /* 713680 */       GIR_EraseRootFromParent_Done,
     /* 713681 */     // Label 9245: @713681
     /* 713681 */     GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(713727), // Rule ID 5106 //
     /* 713686 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713693 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713693 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_IDXEN),
     /* 713696 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713698 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713700 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713702 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713707 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713709 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713715 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713721 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713725 */       GIR_RootConstrainSelectedInstOperands,
     /* 713726 */       // GIR_Coverage, 5106,
     /* 713726 */       GIR_EraseRootFromParent_Done,
     /* 713727 */     // Label 9246: @713727
     /* 713727 */     GIM_Reject,
     /* 713728 */   // Label 9244: @713728
     /* 713728 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(713922),
     /* 713733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713742 */     GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(713833), // Rule ID 5103 //
     /* 713747 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713750 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713757 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713757 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713760 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713764 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713773 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713776 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713780 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713783 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713788 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713793 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713798 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_BOTHEN),
     /* 713801 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713803 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713806 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713808 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713813 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713815 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713821 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713827 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713831 */       GIR_RootConstrainSelectedInstOperands,
     /* 713832 */       // GIR_Coverage, 5103,
     /* 713832 */       GIR_EraseRootFromParent_Done,
     /* 713833 */     // Label 9248: @713833
     /* 713833 */     GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(713921), // Rule ID 5107 //
     /* 713838 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713845 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713845 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713848 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713852 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713857 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713861 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713864 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713868 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713876 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713881 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN),
     /* 713889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713891 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713894 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713896 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713901 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713903 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713909 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713915 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713919 */       GIR_RootConstrainSelectedInstOperands,
     /* 713920 */       // GIR_Coverage, 5107,
     /* 713920 */       GIR_EraseRootFromParent_Done,
     /* 713921 */     // Label 9249: @713921
     /* 713921 */     GIM_Reject,
     /* 713922 */   // Label 9247: @713922
     /* 713922 */   GIM_Reject,
     /* 713923 */ // Label 9238: @713923
     /* 713923 */ GIM_Reject,
     /* 713924 */ // Label 132: @713924
     /* 713924 */ GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(714529),
     /* 713929 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 713932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713941 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713948 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(714220),
     /* 713953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713957 */     GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(714025), // Rule ID 5164 //
     /* 713962 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713965 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713969 */       // MIs[0] offset
     /* 713969 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713972 */       // MIs[0] auxiliary
     /* 713972 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713975 */       // MIs[0] Operand 7
     /* 713975 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713986 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713993 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713993 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFSET),
     /* 713996 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713998 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714000 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714005 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714007 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714013 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714019 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714023 */       GIR_RootConstrainSelectedInstOperands,
     /* 714024 */       // GIR_Coverage, 5164,
     /* 714024 */       GIR_EraseRootFromParent_Done,
     /* 714025 */     // Label 9252: @714025
     /* 714025 */     GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(714090), // Rule ID 5168 //
     /* 714030 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714034 */       // MIs[0] offset
     /* 714034 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714037 */       // MIs[0] auxiliary
     /* 714037 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714040 */       // MIs[0] Operand 7
     /* 714040 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714051 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714058 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714058 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET),
     /* 714061 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714063 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714065 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714070 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714072 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714078 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714084 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714088 */       GIR_RootConstrainSelectedInstOperands,
     /* 714089 */       // GIR_Coverage, 5168,
     /* 714089 */       GIR_EraseRootFromParent_Done,
     /* 714090 */     // Label 9253: @714090
     /* 714090 */     GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(714156), // Rule ID 5165 //
     /* 714095 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714098 */       // MIs[0] offset
     /* 714098 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714101 */       // MIs[0] auxiliary
     /* 714101 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714104 */       // MIs[0] Operand 7
     /* 714104 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714115 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714122 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714122 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFEN),
     /* 714125 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714127 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714129 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714131 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714136 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714138 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714144 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714150 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714154 */       GIR_RootConstrainSelectedInstOperands,
     /* 714155 */       // GIR_Coverage, 5165,
     /* 714155 */       GIR_EraseRootFromParent_Done,
     /* 714156 */     // Label 9254: @714156
     /* 714156 */     GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(714219), // Rule ID 5169 //
     /* 714161 */       // MIs[0] offset
     /* 714161 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714164 */       // MIs[0] auxiliary
     /* 714164 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714167 */       // MIs[0] Operand 7
     /* 714167 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714178 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714185 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714185 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN),
     /* 714188 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714190 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714192 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714194 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714199 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714201 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714207 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714213 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714217 */       GIR_RootConstrainSelectedInstOperands,
     /* 714218 */       // GIR_Coverage, 5169,
     /* 714218 */       GIR_EraseRootFromParent_Done,
     /* 714219 */     // Label 9255: @714219
     /* 714219 */     GIM_Reject,
     /* 714220 */   // Label 9251: @714220
     /* 714220 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(714334),
     /* 714225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714238 */     GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(714287), // Rule ID 5166 //
     /* 714243 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714246 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714253 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714253 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_IDXEN),
     /* 714256 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714258 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714260 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714262 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714267 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714269 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714275 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714281 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714285 */       GIR_RootConstrainSelectedInstOperands,
     /* 714286 */       // GIR_Coverage, 5166,
     /* 714286 */       GIR_EraseRootFromParent_Done,
     /* 714287 */     // Label 9257: @714287
     /* 714287 */     GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(714333), // Rule ID 5170 //
     /* 714292 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714299 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN),
     /* 714302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714304 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714306 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714308 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714313 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714315 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714321 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714327 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714331 */       GIR_RootConstrainSelectedInstOperands,
     /* 714332 */       // GIR_Coverage, 5170,
     /* 714332 */       GIR_EraseRootFromParent_Done,
     /* 714333 */     // Label 9258: @714333
     /* 714333 */     GIM_Reject,
     /* 714334 */   // Label 9256: @714334
     /* 714334 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(714528),
     /* 714339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714348 */     GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(714439), // Rule ID 5167 //
     /* 714353 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714356 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714363 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714363 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714366 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714370 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714375 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714379 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714382 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714386 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714394 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714399 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714404 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_BOTHEN),
     /* 714407 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714409 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714412 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714414 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714419 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714421 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714427 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714433 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714437 */       GIR_RootConstrainSelectedInstOperands,
     /* 714438 */       // GIR_Coverage, 5167,
     /* 714438 */       GIR_EraseRootFromParent_Done,
     /* 714439 */     // Label 9260: @714439
     /* 714439 */     GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(714527), // Rule ID 5171 //
     /* 714444 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714451 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714451 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714454 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714458 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714463 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714467 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714474 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN),
     /* 714495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714497 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714500 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714502 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714507 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714509 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714515 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714521 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714525 */       GIR_RootConstrainSelectedInstOperands,
     /* 714526 */       // GIR_Coverage, 5171,
     /* 714526 */       GIR_EraseRootFromParent_Done,
     /* 714527 */     // Label 9261: @714527
     /* 714527 */     GIM_Reject,
     /* 714528 */   // Label 9259: @714528
     /* 714528 */   GIM_Reject,
     /* 714529 */ // Label 9250: @714529
     /* 714529 */ GIM_Reject,
     /* 714530 */ // Label 133: @714530
     /* 714530 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9266*/ GIMT_Encode4(717049),
     /* 714541 */ /*GILLT_v2s32*//*Label 9262*/ GIMT_Encode4(714573), GIMT_Encode4(0),
     /* 714549 */ /*GILLT_v3s32*//*Label 9263*/ GIMT_Encode4(715192), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 714561 */ /*GILLT_v4s32*//*Label 9264*/ GIMT_Encode4(715811), GIMT_Encode4(0),
     /* 714569 */ /*GILLT_v5s32*//*Label 9265*/ GIMT_Encode4(716430),
     /* 714573 */ // Label 9262: @714573
     /* 714573 */ GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(715191),
     /* 714578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 714581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 714584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 714587 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 714590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 714594 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(714666), // Rule ID 5124 //
     /* 714599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714610 */     // MIs[0] offset
     /* 714610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714613 */     // MIs[0] auxiliary
     /* 714613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714616 */     // MIs[0] Operand 7
     /* 714616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714634 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFSET),
     /* 714637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714646 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714664 */     GIR_RootConstrainSelectedInstOperands,
     /* 714665 */     // GIR_Coverage, 5124,
     /* 714665 */     GIR_EraseRootFromParent_Done,
     /* 714666 */   // Label 9268: @714666
     /* 714666 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(714735), // Rule ID 5128 //
     /* 714671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714679 */     // MIs[0] offset
     /* 714679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714682 */     // MIs[0] auxiliary
     /* 714682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714685 */     // MIs[0] Operand 7
     /* 714685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714703 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET),
     /* 714706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714733 */     GIR_RootConstrainSelectedInstOperands,
     /* 714734 */     // GIR_Coverage, 5128,
     /* 714734 */     GIR_EraseRootFromParent_Done,
     /* 714735 */   // Label 9269: @714735
     /* 714735 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(714805), // Rule ID 5125 //
     /* 714740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714747 */     // MIs[0] offset
     /* 714747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714750 */     // MIs[0] auxiliary
     /* 714750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714753 */     // MIs[0] Operand 7
     /* 714753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714771 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFEN),
     /* 714774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714776 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714785 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714803 */     GIR_RootConstrainSelectedInstOperands,
     /* 714804 */     // GIR_Coverage, 5125,
     /* 714804 */     GIR_EraseRootFromParent_Done,
     /* 714805 */   // Label 9270: @714805
     /* 714805 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(714872), // Rule ID 5129 //
     /* 714810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714814 */     // MIs[0] offset
     /* 714814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714817 */     // MIs[0] auxiliary
     /* 714817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714820 */     // MIs[0] Operand 7
     /* 714820 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714838 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN),
     /* 714841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714843 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714870 */     GIR_RootConstrainSelectedInstOperands,
     /* 714871 */     // GIR_Coverage, 5129,
     /* 714871 */     GIR_EraseRootFromParent_Done,
     /* 714872 */   // Label 9271: @714872
     /* 714872 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(714934), // Rule ID 5126 //
     /* 714877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714884 */     // MIs[0] offset
     /* 714884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714887 */     // MIs[0] auxiliary
     /* 714887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714890 */     // MIs[0] Operand 7
     /* 714890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714900 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_IDXEN),
     /* 714903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714905 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714914 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714932 */     GIR_RootConstrainSelectedInstOperands,
     /* 714933 */     // GIR_Coverage, 5126,
     /* 714933 */     GIR_EraseRootFromParent_Done,
     /* 714934 */   // Label 9272: @714934
     /* 714934 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(714993), // Rule ID 5130 //
     /* 714939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714943 */     // MIs[0] offset
     /* 714943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714946 */     // MIs[0] auxiliary
     /* 714946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714949 */     // MIs[0] Operand 7
     /* 714949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714959 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN),
     /* 714962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714964 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714973 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714991 */     GIR_RootConstrainSelectedInstOperands,
     /* 714992 */     // GIR_Coverage, 5130,
     /* 714992 */     GIR_EraseRootFromParent_Done,
     /* 714993 */   // Label 9273: @714993
     /* 714993 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(715093), // Rule ID 5127 //
     /* 714998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715001 */     // MIs[0] offset
     /* 715001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715004 */     // MIs[0] auxiliary
     /* 715004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715007 */     // MIs[0] Operand 7
     /* 715007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715017 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715033 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715040 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_BOTHEN),
     /* 715061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715073 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715091 */     GIR_RootConstrainSelectedInstOperands,
     /* 715092 */     // GIR_Coverage, 5127,
     /* 715092 */     GIR_EraseRootFromParent_Done,
     /* 715093 */   // Label 9274: @715093
     /* 715093 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(715190), // Rule ID 5131 //
     /* 715098 */     // MIs[0] offset
     /* 715098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715101 */     // MIs[0] auxiliary
     /* 715101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715104 */     // MIs[0] Operand 7
     /* 715104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715114 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715130 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715137 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN),
     /* 715158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715170 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715188 */     GIR_RootConstrainSelectedInstOperands,
     /* 715189 */     // GIR_Coverage, 5131,
     /* 715189 */     GIR_EraseRootFromParent_Done,
     /* 715190 */   // Label 9275: @715190
     /* 715190 */   GIM_Reject,
     /* 715191 */ // Label 9267: @715191
     /* 715191 */ GIM_Reject,
     /* 715192 */ // Label 9263: @715192
     /* 715192 */ GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(715810),
     /* 715197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 715200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 715203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 715206 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 715209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 715213 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(715285), // Rule ID 5132 //
     /* 715218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715229 */     // MIs[0] offset
     /* 715229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715232 */     // MIs[0] auxiliary
     /* 715232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715235 */     // MIs[0] Operand 7
     /* 715235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715253 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFSET),
     /* 715256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715265 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715283 */     GIR_RootConstrainSelectedInstOperands,
     /* 715284 */     // GIR_Coverage, 5132,
     /* 715284 */     GIR_EraseRootFromParent_Done,
     /* 715285 */   // Label 9277: @715285
     /* 715285 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(715354), // Rule ID 5136 //
     /* 715290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715298 */     // MIs[0] offset
     /* 715298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715301 */     // MIs[0] auxiliary
     /* 715301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715304 */     // MIs[0] Operand 7
     /* 715304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715322 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET),
     /* 715325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715334 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715352 */     GIR_RootConstrainSelectedInstOperands,
     /* 715353 */     // GIR_Coverage, 5136,
     /* 715353 */     GIR_EraseRootFromParent_Done,
     /* 715354 */   // Label 9278: @715354
     /* 715354 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(715424), // Rule ID 5133 //
     /* 715359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715366 */     // MIs[0] offset
     /* 715366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715369 */     // MIs[0] auxiliary
     /* 715369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715372 */     // MIs[0] Operand 7
     /* 715372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715390 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFEN),
     /* 715393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715395 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715404 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715412 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715422 */     GIR_RootConstrainSelectedInstOperands,
     /* 715423 */     // GIR_Coverage, 5133,
     /* 715423 */     GIR_EraseRootFromParent_Done,
     /* 715424 */   // Label 9279: @715424
     /* 715424 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(715491), // Rule ID 5137 //
     /* 715429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715433 */     // MIs[0] offset
     /* 715433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715436 */     // MIs[0] auxiliary
     /* 715436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715439 */     // MIs[0] Operand 7
     /* 715439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715457 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN),
     /* 715460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715462 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715471 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715489 */     GIR_RootConstrainSelectedInstOperands,
     /* 715490 */     // GIR_Coverage, 5137,
     /* 715490 */     GIR_EraseRootFromParent_Done,
     /* 715491 */   // Label 9280: @715491
     /* 715491 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(715553), // Rule ID 5134 //
     /* 715496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715503 */     // MIs[0] offset
     /* 715503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715506 */     // MIs[0] auxiliary
     /* 715506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715509 */     // MIs[0] Operand 7
     /* 715509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715519 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_IDXEN),
     /* 715522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715524 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715533 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715551 */     GIR_RootConstrainSelectedInstOperands,
     /* 715552 */     // GIR_Coverage, 5134,
     /* 715552 */     GIR_EraseRootFromParent_Done,
     /* 715553 */   // Label 9281: @715553
     /* 715553 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(715612), // Rule ID 5138 //
     /* 715558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715562 */     // MIs[0] offset
     /* 715562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715565 */     // MIs[0] auxiliary
     /* 715565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715568 */     // MIs[0] Operand 7
     /* 715568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715578 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN),
     /* 715581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715583 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715592 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715594 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715610 */     GIR_RootConstrainSelectedInstOperands,
     /* 715611 */     // GIR_Coverage, 5138,
     /* 715611 */     GIR_EraseRootFromParent_Done,
     /* 715612 */   // Label 9282: @715612
     /* 715612 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(715712), // Rule ID 5135 //
     /* 715617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715620 */     // MIs[0] offset
     /* 715620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715623 */     // MIs[0] auxiliary
     /* 715623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715626 */     // MIs[0] Operand 7
     /* 715626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715636 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715652 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715659 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_BOTHEN),
     /* 715680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715692 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715710 */     GIR_RootConstrainSelectedInstOperands,
     /* 715711 */     // GIR_Coverage, 5135,
     /* 715711 */     GIR_EraseRootFromParent_Done,
     /* 715712 */   // Label 9283: @715712
     /* 715712 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(715809), // Rule ID 5139 //
     /* 715717 */     // MIs[0] offset
     /* 715717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715720 */     // MIs[0] auxiliary
     /* 715720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715723 */     // MIs[0] Operand 7
     /* 715723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715733 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715749 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715756 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN),
     /* 715777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715789 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715807 */     GIR_RootConstrainSelectedInstOperands,
     /* 715808 */     // GIR_Coverage, 5139,
     /* 715808 */     GIR_EraseRootFromParent_Done,
     /* 715809 */   // Label 9284: @715809
     /* 715809 */   GIM_Reject,
     /* 715810 */ // Label 9276: @715810
     /* 715810 */ GIM_Reject,
     /* 715811 */ // Label 9264: @715811
     /* 715811 */ GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(716429),
     /* 715816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 715819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 715822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 715825 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 715828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 715832 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(715904), // Rule ID 5140 //
     /* 715837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715848 */     // MIs[0] offset
     /* 715848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715851 */     // MIs[0] auxiliary
     /* 715851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715854 */     // MIs[0] Operand 7
     /* 715854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715872 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFSET),
     /* 715875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715902 */     GIR_RootConstrainSelectedInstOperands,
     /* 715903 */     // GIR_Coverage, 5140,
     /* 715903 */     GIR_EraseRootFromParent_Done,
     /* 715904 */   // Label 9286: @715904
     /* 715904 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(715973), // Rule ID 5144 //
     /* 715909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715917 */     // MIs[0] offset
     /* 715917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715920 */     // MIs[0] auxiliary
     /* 715920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715923 */     // MIs[0] Operand 7
     /* 715923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715941 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET),
     /* 715944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715971 */     GIR_RootConstrainSelectedInstOperands,
     /* 715972 */     // GIR_Coverage, 5144,
     /* 715972 */     GIR_EraseRootFromParent_Done,
     /* 715973 */   // Label 9287: @715973
     /* 715973 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(716043), // Rule ID 5141 //
     /* 715978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715985 */     // MIs[0] offset
     /* 715985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715988 */     // MIs[0] auxiliary
     /* 715988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715991 */     // MIs[0] Operand 7
     /* 715991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716009 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFEN),
     /* 716012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716014 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716023 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716041 */     GIR_RootConstrainSelectedInstOperands,
     /* 716042 */     // GIR_Coverage, 5141,
     /* 716042 */     GIR_EraseRootFromParent_Done,
     /* 716043 */   // Label 9288: @716043
     /* 716043 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(716110), // Rule ID 5145 //
     /* 716048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716052 */     // MIs[0] offset
     /* 716052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716055 */     // MIs[0] auxiliary
     /* 716055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716058 */     // MIs[0] Operand 7
     /* 716058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716076 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN),
     /* 716079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716081 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716108 */     GIR_RootConstrainSelectedInstOperands,
     /* 716109 */     // GIR_Coverage, 5145,
     /* 716109 */     GIR_EraseRootFromParent_Done,
     /* 716110 */   // Label 9289: @716110
     /* 716110 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(716172), // Rule ID 5142 //
     /* 716115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716122 */     // MIs[0] offset
     /* 716122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716125 */     // MIs[0] auxiliary
     /* 716125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716128 */     // MIs[0] Operand 7
     /* 716128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716138 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_IDXEN),
     /* 716141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716143 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716152 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716170 */     GIR_RootConstrainSelectedInstOperands,
     /* 716171 */     // GIR_Coverage, 5142,
     /* 716171 */     GIR_EraseRootFromParent_Done,
     /* 716172 */   // Label 9290: @716172
     /* 716172 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(716231), // Rule ID 5146 //
     /* 716177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716181 */     // MIs[0] offset
     /* 716181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716184 */     // MIs[0] auxiliary
     /* 716184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716187 */     // MIs[0] Operand 7
     /* 716187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716197 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN),
     /* 716200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716202 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716211 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716229 */     GIR_RootConstrainSelectedInstOperands,
     /* 716230 */     // GIR_Coverage, 5146,
     /* 716230 */     GIR_EraseRootFromParent_Done,
     /* 716231 */   // Label 9291: @716231
     /* 716231 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(716331), // Rule ID 5143 //
     /* 716236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716239 */     // MIs[0] offset
     /* 716239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716242 */     // MIs[0] auxiliary
     /* 716242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716245 */     // MIs[0] Operand 7
     /* 716245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716255 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716271 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716278 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_BOTHEN),
     /* 716299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716311 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716329 */     GIR_RootConstrainSelectedInstOperands,
     /* 716330 */     // GIR_Coverage, 5143,
     /* 716330 */     GIR_EraseRootFromParent_Done,
     /* 716331 */   // Label 9292: @716331
     /* 716331 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(716428), // Rule ID 5147 //
     /* 716336 */     // MIs[0] offset
     /* 716336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716339 */     // MIs[0] auxiliary
     /* 716339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716342 */     // MIs[0] Operand 7
     /* 716342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716352 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716375 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN),
     /* 716396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716408 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716426 */     GIR_RootConstrainSelectedInstOperands,
     /* 716427 */     // GIR_Coverage, 5147,
     /* 716427 */     GIR_EraseRootFromParent_Done,
     /* 716428 */   // Label 9293: @716428
     /* 716428 */   GIM_Reject,
     /* 716429 */ // Label 9285: @716429
     /* 716429 */ GIM_Reject,
     /* 716430 */ // Label 9265: @716430
     /* 716430 */ GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(717048),
     /* 716435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 716438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 716441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 716444 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 716447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 716451 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(716523), // Rule ID 5148 //
     /* 716456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716467 */     // MIs[0] offset
     /* 716467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716470 */     // MIs[0] auxiliary
     /* 716470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716473 */     // MIs[0] Operand 7
     /* 716473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716491 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFSET),
     /* 716494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716503 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716521 */     GIR_RootConstrainSelectedInstOperands,
     /* 716522 */     // GIR_Coverage, 5148,
     /* 716522 */     GIR_EraseRootFromParent_Done,
     /* 716523 */   // Label 9295: @716523
     /* 716523 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(716592), // Rule ID 5152 //
     /* 716528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716536 */     // MIs[0] offset
     /* 716536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716539 */     // MIs[0] auxiliary
     /* 716539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716542 */     // MIs[0] Operand 7
     /* 716542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716560 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET),
     /* 716563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716572 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716590 */     GIR_RootConstrainSelectedInstOperands,
     /* 716591 */     // GIR_Coverage, 5152,
     /* 716591 */     GIR_EraseRootFromParent_Done,
     /* 716592 */   // Label 9296: @716592
     /* 716592 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(716662), // Rule ID 5149 //
     /* 716597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716604 */     // MIs[0] offset
     /* 716604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716607 */     // MIs[0] auxiliary
     /* 716607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716610 */     // MIs[0] Operand 7
     /* 716610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716628 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFEN),
     /* 716631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716633 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716642 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716660 */     GIR_RootConstrainSelectedInstOperands,
     /* 716661 */     // GIR_Coverage, 5149,
     /* 716661 */     GIR_EraseRootFromParent_Done,
     /* 716662 */   // Label 9297: @716662
     /* 716662 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(716729), // Rule ID 5153 //
     /* 716667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716671 */     // MIs[0] offset
     /* 716671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716674 */     // MIs[0] auxiliary
     /* 716674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716677 */     // MIs[0] Operand 7
     /* 716677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716695 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN),
     /* 716698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716700 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716709 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716727 */     GIR_RootConstrainSelectedInstOperands,
     /* 716728 */     // GIR_Coverage, 5153,
     /* 716728 */     GIR_EraseRootFromParent_Done,
     /* 716729 */   // Label 9298: @716729
     /* 716729 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(716791), // Rule ID 5150 //
     /* 716734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716741 */     // MIs[0] offset
     /* 716741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716744 */     // MIs[0] auxiliary
     /* 716744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716747 */     // MIs[0] Operand 7
     /* 716747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716757 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_IDXEN),
     /* 716760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716789 */     GIR_RootConstrainSelectedInstOperands,
     /* 716790 */     // GIR_Coverage, 5150,
     /* 716790 */     GIR_EraseRootFromParent_Done,
     /* 716791 */   // Label 9299: @716791
     /* 716791 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(716850), // Rule ID 5154 //
     /* 716796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716800 */     // MIs[0] offset
     /* 716800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716803 */     // MIs[0] auxiliary
     /* 716803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716806 */     // MIs[0] Operand 7
     /* 716806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716816 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN),
     /* 716819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716821 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716830 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716848 */     GIR_RootConstrainSelectedInstOperands,
     /* 716849 */     // GIR_Coverage, 5154,
     /* 716849 */     GIR_EraseRootFromParent_Done,
     /* 716850 */   // Label 9300: @716850
     /* 716850 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(716950), // Rule ID 5151 //
     /* 716855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716858 */     // MIs[0] offset
     /* 716858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716861 */     // MIs[0] auxiliary
     /* 716861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716864 */     // MIs[0] Operand 7
     /* 716864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716874 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716890 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716897 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_BOTHEN),
     /* 716918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716930 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716948 */     GIR_RootConstrainSelectedInstOperands,
     /* 716949 */     // GIR_Coverage, 5151,
     /* 716949 */     GIR_EraseRootFromParent_Done,
     /* 716950 */   // Label 9301: @716950
     /* 716950 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(717047), // Rule ID 5155 //
     /* 716955 */     // MIs[0] offset
     /* 716955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716958 */     // MIs[0] auxiliary
     /* 716958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716961 */     // MIs[0] Operand 7
     /* 716961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716971 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716987 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716994 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN),
     /* 717015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717027 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717045 */     GIR_RootConstrainSelectedInstOperands,
     /* 717046 */     // GIR_Coverage, 5155,
     /* 717046 */     GIR_EraseRootFromParent_Done,
     /* 717047 */   // Label 9302: @717047
     /* 717047 */   GIM_Reject,
     /* 717048 */ // Label 9294: @717048
     /* 717048 */ GIM_Reject,
     /* 717049 */ // Label 9266: @717049
     /* 717049 */ GIM_Reject,
     /* 717050 */ // Label 134: @717050
     /* 717050 */ GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(717655),
     /* 717055 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 717058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 717061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 717064 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 717067 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 717070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 717074 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(717346),
     /* 717079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 717083 */     GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(717151), // Rule ID 5108 //
     /* 717088 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717091 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717095 */       // MIs[0] offset
     /* 717095 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717098 */       // MIs[0] auxiliary
     /* 717098 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717101 */       // MIs[0] Operand 7
     /* 717101 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717112 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717119 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717119 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 717122 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717124 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717126 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717131 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717133 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717139 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717145 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717149 */       GIR_RootConstrainSelectedInstOperands,
     /* 717150 */       // GIR_Coverage, 5108,
     /* 717150 */       GIR_EraseRootFromParent_Done,
     /* 717151 */     // Label 9305: @717151
     /* 717151 */     GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(717216), // Rule ID 5112 //
     /* 717156 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717160 */       // MIs[0] offset
     /* 717160 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717163 */       // MIs[0] auxiliary
     /* 717163 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717166 */       // MIs[0] Operand 7
     /* 717166 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717177 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717184 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717184 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 717187 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717189 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717196 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717198 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717204 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717210 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717214 */       GIR_RootConstrainSelectedInstOperands,
     /* 717215 */       // GIR_Coverage, 5112,
     /* 717215 */       GIR_EraseRootFromParent_Done,
     /* 717216 */     // Label 9306: @717216
     /* 717216 */     GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(717282), // Rule ID 5109 //
     /* 717221 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717224 */       // MIs[0] offset
     /* 717224 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717227 */       // MIs[0] auxiliary
     /* 717227 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717230 */       // MIs[0] Operand 7
     /* 717230 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717241 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717248 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717248 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 717251 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717253 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717255 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717257 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717262 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717264 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717270 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717276 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717280 */       GIR_RootConstrainSelectedInstOperands,
     /* 717281 */       // GIR_Coverage, 5109,
     /* 717281 */       GIR_EraseRootFromParent_Done,
     /* 717282 */     // Label 9307: @717282
     /* 717282 */     GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(717345), // Rule ID 5113 //
     /* 717287 */       // MIs[0] offset
     /* 717287 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717290 */       // MIs[0] auxiliary
     /* 717290 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717293 */       // MIs[0] Operand 7
     /* 717293 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717304 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717311 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717311 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 717314 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717316 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717318 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717320 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717325 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717327 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717333 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717339 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717343 */       GIR_RootConstrainSelectedInstOperands,
     /* 717344 */       // GIR_Coverage, 5113,
     /* 717344 */       GIR_EraseRootFromParent_Done,
     /* 717345 */     // Label 9308: @717345
     /* 717345 */     GIM_Reject,
     /* 717346 */   // Label 9304: @717346
     /* 717346 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(717460),
     /* 717351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717364 */     GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(717413), // Rule ID 5110 //
     /* 717369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717372 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717379 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717379 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_IDXEN),
     /* 717382 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717384 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717386 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717388 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717393 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717395 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717401 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717407 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717411 */       GIR_RootConstrainSelectedInstOperands,
     /* 717412 */       // GIR_Coverage, 5110,
     /* 717412 */       GIR_EraseRootFromParent_Done,
     /* 717413 */     // Label 9310: @717413
     /* 717413 */     GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(717459), // Rule ID 5114 //
     /* 717418 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717425 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717425 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_IDXEN),
     /* 717428 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717430 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717432 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717434 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717439 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717441 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717447 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717453 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717457 */       GIR_RootConstrainSelectedInstOperands,
     /* 717458 */       // GIR_Coverage, 5114,
     /* 717458 */       GIR_EraseRootFromParent_Done,
     /* 717459 */     // Label 9311: @717459
     /* 717459 */     GIM_Reject,
     /* 717460 */   // Label 9309: @717460
     /* 717460 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(717654),
     /* 717465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717474 */     GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(717565), // Rule ID 5111 //
     /* 717479 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717482 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717489 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717489 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717492 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717496 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717501 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717505 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717508 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717512 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717520 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717525 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717530 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_BOTHEN),
     /* 717533 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717535 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717538 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717540 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717545 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717547 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717553 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717559 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717563 */       GIR_RootConstrainSelectedInstOperands,
     /* 717564 */       // GIR_Coverage, 5111,
     /* 717564 */       GIR_EraseRootFromParent_Done,
     /* 717565 */     // Label 9313: @717565
     /* 717565 */     GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(717653), // Rule ID 5115 //
     /* 717570 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717577 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717577 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717580 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717584 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717589 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717593 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717596 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717600 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717603 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717608 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717613 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717618 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN),
     /* 717621 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717623 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717626 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717628 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717633 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717635 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717641 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717647 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717651 */       GIR_RootConstrainSelectedInstOperands,
     /* 717652 */       // GIR_Coverage, 5115,
     /* 717652 */       GIR_EraseRootFromParent_Done,
     /* 717653 */     // Label 9314: @717653
     /* 717653 */     GIM_Reject,
     /* 717654 */   // Label 9312: @717654
     /* 717654 */   GIM_Reject,
     /* 717655 */ // Label 9303: @717655
     /* 717655 */ GIM_Reject,
     /* 717656 */ // Label 135: @717656
     /* 717656 */ GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(718261),
     /* 717661 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 717664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 717667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 717670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 717673 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 717676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 717680 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(717952),
     /* 717685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 717689 */     GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(717757), // Rule ID 5172 //
     /* 717694 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717697 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717701 */       // MIs[0] offset
     /* 717701 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717704 */       // MIs[0] auxiliary
     /* 717704 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717707 */       // MIs[0] Operand 7
     /* 717707 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717718 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717725 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717725 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFSET),
     /* 717728 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717730 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717737 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717739 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717745 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717751 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717755 */       GIR_RootConstrainSelectedInstOperands,
     /* 717756 */       // GIR_Coverage, 5172,
     /* 717756 */       GIR_EraseRootFromParent_Done,
     /* 717757 */     // Label 9317: @717757
     /* 717757 */     GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(717822), // Rule ID 5176 //
     /* 717762 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717766 */       // MIs[0] offset
     /* 717766 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717769 */       // MIs[0] auxiliary
     /* 717769 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717772 */       // MIs[0] Operand 7
     /* 717772 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717783 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717790 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717790 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET),
     /* 717793 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717795 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717797 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717802 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717804 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717810 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717816 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717820 */       GIR_RootConstrainSelectedInstOperands,
     /* 717821 */       // GIR_Coverage, 5176,
     /* 717821 */       GIR_EraseRootFromParent_Done,
     /* 717822 */     // Label 9318: @717822
     /* 717822 */     GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(717888), // Rule ID 5173 //
     /* 717827 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717830 */       // MIs[0] offset
     /* 717830 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717833 */       // MIs[0] auxiliary
     /* 717833 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717836 */       // MIs[0] Operand 7
     /* 717836 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717847 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717854 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717854 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFEN),
     /* 717857 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717859 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717861 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717868 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717870 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717876 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717882 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717886 */       GIR_RootConstrainSelectedInstOperands,
     /* 717887 */       // GIR_Coverage, 5173,
     /* 717887 */       GIR_EraseRootFromParent_Done,
     /* 717888 */     // Label 9319: @717888
     /* 717888 */     GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(717951), // Rule ID 5177 //
     /* 717893 */       // MIs[0] offset
     /* 717893 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717896 */       // MIs[0] auxiliary
     /* 717896 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717899 */       // MIs[0] Operand 7
     /* 717899 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717910 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717917 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN),
     /* 717920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717922 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717924 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717926 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717931 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717933 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717939 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717945 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717949 */       GIR_RootConstrainSelectedInstOperands,
     /* 717950 */       // GIR_Coverage, 5177,
     /* 717950 */       GIR_EraseRootFromParent_Done,
     /* 717951 */     // Label 9320: @717951
     /* 717951 */     GIM_Reject,
     /* 717952 */   // Label 9316: @717952
     /* 717952 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(718066),
     /* 717957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717970 */     GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(718019), // Rule ID 5174 //
     /* 717975 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717978 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717985 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_IDXEN),
     /* 717988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717990 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717992 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717994 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717999 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718001 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718007 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718013 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718017 */       GIR_RootConstrainSelectedInstOperands,
     /* 718018 */       // GIR_Coverage, 5174,
     /* 718018 */       GIR_EraseRootFromParent_Done,
     /* 718019 */     // Label 9322: @718019
     /* 718019 */     GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(718065), // Rule ID 5178 //
     /* 718024 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718031 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718031 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN),
     /* 718034 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718036 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718038 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718040 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718045 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718047 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718053 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718059 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718063 */       GIR_RootConstrainSelectedInstOperands,
     /* 718064 */       // GIR_Coverage, 5178,
     /* 718064 */       GIR_EraseRootFromParent_Done,
     /* 718065 */     // Label 9323: @718065
     /* 718065 */     GIM_Reject,
     /* 718066 */   // Label 9321: @718066
     /* 718066 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(718260),
     /* 718071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718080 */     GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(718171), // Rule ID 5175 //
     /* 718085 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718088 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718095 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718095 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718098 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718102 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718107 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718111 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718114 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718118 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718121 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718126 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718136 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_BOTHEN),
     /* 718139 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718141 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718144 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718146 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718151 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718153 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718159 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718165 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718169 */       GIR_RootConstrainSelectedInstOperands,
     /* 718170 */       // GIR_Coverage, 5175,
     /* 718170 */       GIR_EraseRootFromParent_Done,
     /* 718171 */     // Label 9325: @718171
     /* 718171 */     GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(718259), // Rule ID 5179 //
     /* 718176 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718183 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718183 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718186 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718190 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718195 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718199 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718202 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718206 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718219 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718224 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN),
     /* 718227 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718229 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718232 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718234 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718239 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718241 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718247 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718253 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718257 */       GIR_RootConstrainSelectedInstOperands,
     /* 718258 */       // GIR_Coverage, 5179,
     /* 718258 */       GIR_EraseRootFromParent_Done,
     /* 718259 */     // Label 9326: @718259
     /* 718259 */     GIM_Reject,
     /* 718260 */   // Label 9324: @718260
     /* 718260 */   GIM_Reject,
     /* 718261 */ // Label 9315: @718261
     /* 718261 */ GIM_Reject,
     /* 718262 */ // Label 136: @718262
     /* 718262 */ GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(718867),
     /* 718267 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 718270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 718273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 718276 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 718279 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 718282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 718286 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(718558),
     /* 718291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718295 */     GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(718363), // Rule ID 5116 //
     /* 718300 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718303 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718307 */       // MIs[0] offset
     /* 718307 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718310 */       // MIs[0] auxiliary
     /* 718310 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718313 */       // MIs[0] Operand 7
     /* 718313 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718324 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718331 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 718334 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718336 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718338 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718343 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718345 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718351 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718357 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718361 */       GIR_RootConstrainSelectedInstOperands,
     /* 718362 */       // GIR_Coverage, 5116,
     /* 718362 */       GIR_EraseRootFromParent_Done,
     /* 718363 */     // Label 9329: @718363
     /* 718363 */     GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(718428), // Rule ID 5120 //
     /* 718368 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718372 */       // MIs[0] offset
     /* 718372 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718375 */       // MIs[0] auxiliary
     /* 718375 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718378 */       // MIs[0] Operand 7
     /* 718378 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718389 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718396 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718396 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 718399 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718401 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718403 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718408 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718410 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718416 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718422 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718426 */       GIR_RootConstrainSelectedInstOperands,
     /* 718427 */       // GIR_Coverage, 5120,
     /* 718427 */       GIR_EraseRootFromParent_Done,
     /* 718428 */     // Label 9330: @718428
     /* 718428 */     GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(718494), // Rule ID 5117 //
     /* 718433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718436 */       // MIs[0] offset
     /* 718436 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718439 */       // MIs[0] auxiliary
     /* 718439 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718442 */       // MIs[0] Operand 7
     /* 718442 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718453 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718460 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718460 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 718463 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718465 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718467 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718469 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718474 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718476 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718482 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718488 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718492 */       GIR_RootConstrainSelectedInstOperands,
     /* 718493 */       // GIR_Coverage, 5117,
     /* 718493 */       GIR_EraseRootFromParent_Done,
     /* 718494 */     // Label 9331: @718494
     /* 718494 */     GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(718557), // Rule ID 5121 //
     /* 718499 */       // MIs[0] offset
     /* 718499 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718502 */       // MIs[0] auxiliary
     /* 718502 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718505 */       // MIs[0] Operand 7
     /* 718505 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718516 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718523 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718523 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 718526 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718528 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718530 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718532 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718537 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718539 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718545 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718551 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718555 */       GIR_RootConstrainSelectedInstOperands,
     /* 718556 */       // GIR_Coverage, 5121,
     /* 718556 */       GIR_EraseRootFromParent_Done,
     /* 718557 */     // Label 9332: @718557
     /* 718557 */     GIM_Reject,
     /* 718558 */   // Label 9328: @718558
     /* 718558 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(718672),
     /* 718563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718576 */     GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(718625), // Rule ID 5118 //
     /* 718581 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718584 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718591 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_IDXEN),
     /* 718594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718596 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718598 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718600 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718605 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718607 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718613 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718619 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718623 */       GIR_RootConstrainSelectedInstOperands,
     /* 718624 */       // GIR_Coverage, 5118,
     /* 718624 */       GIR_EraseRootFromParent_Done,
     /* 718625 */     // Label 9334: @718625
     /* 718625 */     GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(718671), // Rule ID 5122 //
     /* 718630 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718637 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718637 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_IDXEN),
     /* 718640 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718642 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718644 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718646 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718651 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718653 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718659 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718665 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718669 */       GIR_RootConstrainSelectedInstOperands,
     /* 718670 */       // GIR_Coverage, 5122,
     /* 718670 */       GIR_EraseRootFromParent_Done,
     /* 718671 */     // Label 9335: @718671
     /* 718671 */     GIM_Reject,
     /* 718672 */   // Label 9333: @718672
     /* 718672 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(718866),
     /* 718677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718686 */     GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(718777), // Rule ID 5119 //
     /* 718691 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718694 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718701 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718701 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718704 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718708 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718713 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718717 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718720 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718724 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718732 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718737 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718742 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_BOTHEN),
     /* 718745 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718747 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718750 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718752 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718757 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718759 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718765 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718771 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718775 */       GIR_RootConstrainSelectedInstOperands,
     /* 718776 */       // GIR_Coverage, 5119,
     /* 718776 */       GIR_EraseRootFromParent_Done,
     /* 718777 */     // Label 9337: @718777
     /* 718777 */     GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(718865), // Rule ID 5123 //
     /* 718782 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718789 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718789 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718792 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718796 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718801 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718805 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718808 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718812 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718815 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718820 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718825 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718830 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_BOTHEN),
     /* 718833 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718835 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718838 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718840 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718845 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718847 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718853 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718859 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718863 */       GIR_RootConstrainSelectedInstOperands,
     /* 718864 */       // GIR_Coverage, 5123,
     /* 718864 */       GIR_EraseRootFromParent_Done,
     /* 718865 */     // Label 9338: @718865
     /* 718865 */     GIM_Reject,
     /* 718866 */   // Label 9336: @718866
     /* 718866 */   GIM_Reject,
     /* 718867 */ // Label 9327: @718867
     /* 718867 */ GIM_Reject,
     /* 718868 */ // Label 137: @718868
     /* 718868 */ GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(719473),
     /* 718873 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 718876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 718879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 718882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 718885 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 718888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 718892 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(719164),
     /* 718897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718901 */     GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(718969), // Rule ID 5180 //
     /* 718906 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718909 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718913 */       // MIs[0] offset
     /* 718913 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718916 */       // MIs[0] auxiliary
     /* 718916 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718919 */       // MIs[0] Operand 7
     /* 718919 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718930 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718937 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718937 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFSET),
     /* 718940 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718942 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718944 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718949 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718951 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718957 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718963 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718967 */       GIR_RootConstrainSelectedInstOperands,
     /* 718968 */       // GIR_Coverage, 5180,
     /* 718968 */       GIR_EraseRootFromParent_Done,
     /* 718969 */     // Label 9341: @718969
     /* 718969 */     GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(719034), // Rule ID 5184 //
     /* 718974 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718978 */       // MIs[0] offset
     /* 718978 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718981 */       // MIs[0] auxiliary
     /* 718981 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718984 */       // MIs[0] Operand 7
     /* 718984 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718995 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719002 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719002 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET),
     /* 719005 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719007 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719009 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719014 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719016 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719022 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719028 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719032 */       GIR_RootConstrainSelectedInstOperands,
     /* 719033 */       // GIR_Coverage, 5184,
     /* 719033 */       GIR_EraseRootFromParent_Done,
     /* 719034 */     // Label 9342: @719034
     /* 719034 */     GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(719100), // Rule ID 5181 //
     /* 719039 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719042 */       // MIs[0] offset
     /* 719042 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719045 */       // MIs[0] auxiliary
     /* 719045 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719048 */       // MIs[0] Operand 7
     /* 719048 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719059 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719066 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFEN),
     /* 719069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719071 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719073 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719075 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719080 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719082 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719088 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719094 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719098 */       GIR_RootConstrainSelectedInstOperands,
     /* 719099 */       // GIR_Coverage, 5181,
     /* 719099 */       GIR_EraseRootFromParent_Done,
     /* 719100 */     // Label 9343: @719100
     /* 719100 */     GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(719163), // Rule ID 5185 //
     /* 719105 */       // MIs[0] offset
     /* 719105 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719108 */       // MIs[0] auxiliary
     /* 719108 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719111 */       // MIs[0] Operand 7
     /* 719111 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719122 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719129 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719129 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN),
     /* 719132 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719134 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719136 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719138 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719143 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719145 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719151 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719157 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719161 */       GIR_RootConstrainSelectedInstOperands,
     /* 719162 */       // GIR_Coverage, 5185,
     /* 719162 */       GIR_EraseRootFromParent_Done,
     /* 719163 */     // Label 9344: @719163
     /* 719163 */     GIM_Reject,
     /* 719164 */   // Label 9340: @719164
     /* 719164 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(719278),
     /* 719169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719182 */     GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(719231), // Rule ID 5182 //
     /* 719187 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719190 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719197 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719197 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_IDXEN),
     /* 719200 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719202 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719204 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719206 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719211 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719213 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719219 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719225 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719229 */       GIR_RootConstrainSelectedInstOperands,
     /* 719230 */       // GIR_Coverage, 5182,
     /* 719230 */       GIR_EraseRootFromParent_Done,
     /* 719231 */     // Label 9346: @719231
     /* 719231 */     GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(719277), // Rule ID 5186 //
     /* 719236 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719243 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719243 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN),
     /* 719246 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719248 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719250 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719252 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719257 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719259 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719265 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719271 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719275 */       GIR_RootConstrainSelectedInstOperands,
     /* 719276 */       // GIR_Coverage, 5186,
     /* 719276 */       GIR_EraseRootFromParent_Done,
     /* 719277 */     // Label 9347: @719277
     /* 719277 */     GIM_Reject,
     /* 719278 */   // Label 9345: @719278
     /* 719278 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(719472),
     /* 719283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719292 */     GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(719383), // Rule ID 5183 //
     /* 719297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719300 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719307 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719307 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719310 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719314 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719319 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719323 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719326 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719330 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719343 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_BOTHEN),
     /* 719351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719356 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719358 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719363 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719365 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719371 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719377 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719381 */       GIR_RootConstrainSelectedInstOperands,
     /* 719382 */       // GIR_Coverage, 5183,
     /* 719382 */       GIR_EraseRootFromParent_Done,
     /* 719383 */     // Label 9349: @719383
     /* 719383 */     GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(719471), // Rule ID 5187 //
     /* 719388 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719395 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719395 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719398 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719402 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719407 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719411 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719414 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719418 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719426 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719431 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN),
     /* 719439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719441 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719444 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719446 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719451 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719453 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719459 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719465 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719469 */       GIR_RootConstrainSelectedInstOperands,
     /* 719470 */       // GIR_Coverage, 5187,
     /* 719470 */       GIR_EraseRootFromParent_Done,
     /* 719471 */     // Label 9350: @719471
     /* 719471 */     GIM_Reject,
     /* 719472 */   // Label 9348: @719472
     /* 719472 */   GIM_Reject,
     /* 719473 */ // Label 9339: @719473
     /* 719473 */ GIM_Reject,
     /* 719474 */ // Label 138: @719474
     /* 719474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 9367*/ GIMT_Encode4(734781),
     /* 719485 */ /*GILLT_p0s64*//*Label 9351*/ GIMT_Encode4(719577),
     /* 719489 */ /*GILLT_p1s64*//*Label 9352*/ GIMT_Encode4(720192),
     /* 719493 */ /*GILLT_p2s32*//*Label 9353*/ GIMT_Encode4(720807),
     /* 719497 */ /*GILLT_p3s32*//*Label 9354*/ GIMT_Encode4(721422),
     /* 719501 */ /*GILLT_p4s64*//*Label 9355*/ GIMT_Encode4(722037),
     /* 719505 */ /*GILLT_p5s32*//*Label 9356*/ GIMT_Encode4(722652),
     /* 719509 */ /*GILLT_p6s32*//*Label 9357*/ GIMT_Encode4(723267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 719521 */ /*GILLT_s32*//*Label 9358*/ GIMT_Encode4(723882),
     /* 719525 */ /*GILLT_s64*//*Label 9359*/ GIMT_Encode4(725093),
     /* 719529 */ /*GILLT_v2s16*//*Label 9360*/ GIMT_Encode4(726304),
     /* 719533 */ /*GILLT_v2s32*//*Label 9361*/ GIMT_Encode4(727515),
     /* 719537 */ /*GILLT_v2s64*//*Label 9362*/ GIMT_Encode4(728726),
     /* 719541 */ /*GILLT_v3s32*//*Label 9363*/ GIMT_Encode4(729937), GIMT_Encode4(0),
     /* 719549 */ /*GILLT_v4s16*//*Label 9364*/ GIMT_Encode4(731148),
     /* 719553 */ /*GILLT_v4s32*//*Label 9365*/ GIMT_Encode4(732359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 719573 */ /*GILLT_v8s16*//*Label 9366*/ GIMT_Encode4(733570),
     /* 719577 */ // Label 9351: @719577
     /* 719577 */ GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(720191),
     /* 719582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 719585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 719588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 719591 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 719594 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(719666), // Rule ID 5452 //
     /* 719599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719610 */     // MIs[0] offset
     /* 719610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719613 */     // MIs[0] auxiliary
     /* 719613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719616 */     // MIs[0] Operand 7
     /* 719616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719634 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 719637 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719646 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719664 */     GIR_RootConstrainSelectedInstOperands,
     /* 719665 */     // GIR_Coverage, 5452,
     /* 719665 */     GIR_EraseRootFromParent_Done,
     /* 719666 */   // Label 9369: @719666
     /* 719666 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(719735), // Rule ID 5456 //
     /* 719671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719679 */     // MIs[0] offset
     /* 719679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719682 */     // MIs[0] auxiliary
     /* 719682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719685 */     // MIs[0] Operand 7
     /* 719685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719703 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 719706 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719733 */     GIR_RootConstrainSelectedInstOperands,
     /* 719734 */     // GIR_Coverage, 5456,
     /* 719734 */     GIR_EraseRootFromParent_Done,
     /* 719735 */   // Label 9370: @719735
     /* 719735 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(719805), // Rule ID 5453 //
     /* 719740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719747 */     // MIs[0] offset
     /* 719747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719750 */     // MIs[0] auxiliary
     /* 719750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719753 */     // MIs[0] Operand 7
     /* 719753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719771 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 719774 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719776 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719785 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719803 */     GIR_RootConstrainSelectedInstOperands,
     /* 719804 */     // GIR_Coverage, 5453,
     /* 719804 */     GIR_EraseRootFromParent_Done,
     /* 719805 */   // Label 9371: @719805
     /* 719805 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(719872), // Rule ID 5457 //
     /* 719810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719814 */     // MIs[0] offset
     /* 719814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719817 */     // MIs[0] auxiliary
     /* 719817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719820 */     // MIs[0] Operand 7
     /* 719820 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719838 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 719841 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719843 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719870 */     GIR_RootConstrainSelectedInstOperands,
     /* 719871 */     // GIR_Coverage, 5457,
     /* 719871 */     GIR_EraseRootFromParent_Done,
     /* 719872 */   // Label 9372: @719872
     /* 719872 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(719934), // Rule ID 5454 //
     /* 719877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719884 */     // MIs[0] offset
     /* 719884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719887 */     // MIs[0] auxiliary
     /* 719887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719890 */     // MIs[0] Operand 7
     /* 719890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719900 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 719903 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719905 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719914 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719932 */     GIR_RootConstrainSelectedInstOperands,
     /* 719933 */     // GIR_Coverage, 5454,
     /* 719933 */     GIR_EraseRootFromParent_Done,
     /* 719934 */   // Label 9373: @719934
     /* 719934 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(719993), // Rule ID 5458 //
     /* 719939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719943 */     // MIs[0] offset
     /* 719943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719946 */     // MIs[0] auxiliary
     /* 719946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719949 */     // MIs[0] Operand 7
     /* 719949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719959 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 719962 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719964 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719973 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719991 */     GIR_RootConstrainSelectedInstOperands,
     /* 719992 */     // GIR_Coverage, 5458,
     /* 719992 */     GIR_EraseRootFromParent_Done,
     /* 719993 */   // Label 9374: @719993
     /* 719993 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(720093), // Rule ID 5455 //
     /* 719998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720001 */     // MIs[0] offset
     /* 720001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720004 */     // MIs[0] auxiliary
     /* 720004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720007 */     // MIs[0] Operand 7
     /* 720007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720017 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720033 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720040 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 720061 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720073 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720091 */     GIR_RootConstrainSelectedInstOperands,
     /* 720092 */     // GIR_Coverage, 5455,
     /* 720092 */     GIR_EraseRootFromParent_Done,
     /* 720093 */   // Label 9375: @720093
     /* 720093 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(720190), // Rule ID 5459 //
     /* 720098 */     // MIs[0] offset
     /* 720098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720101 */     // MIs[0] auxiliary
     /* 720101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720104 */     // MIs[0] Operand 7
     /* 720104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720114 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720130 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720137 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 720158 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720170 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720188 */     GIR_RootConstrainSelectedInstOperands,
     /* 720189 */     // GIR_Coverage, 5459,
     /* 720189 */     GIR_EraseRootFromParent_Done,
     /* 720190 */   // Label 9376: @720190
     /* 720190 */   GIM_Reject,
     /* 720191 */ // Label 9368: @720191
     /* 720191 */ GIM_Reject,
     /* 720192 */ // Label 9352: @720192
     /* 720192 */ GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(720806),
     /* 720197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 720200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 720203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 720206 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 720209 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(720281), // Rule ID 5460 //
     /* 720214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720225 */     // MIs[0] offset
     /* 720225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720228 */     // MIs[0] auxiliary
     /* 720228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720231 */     // MIs[0] Operand 7
     /* 720231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720249 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 720252 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720279 */     GIR_RootConstrainSelectedInstOperands,
     /* 720280 */     // GIR_Coverage, 5460,
     /* 720280 */     GIR_EraseRootFromParent_Done,
     /* 720281 */   // Label 9378: @720281
     /* 720281 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(720350), // Rule ID 5464 //
     /* 720286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720294 */     // MIs[0] offset
     /* 720294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720297 */     // MIs[0] auxiliary
     /* 720297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720300 */     // MIs[0] Operand 7
     /* 720300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720318 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 720321 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720330 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720348 */     GIR_RootConstrainSelectedInstOperands,
     /* 720349 */     // GIR_Coverage, 5464,
     /* 720349 */     GIR_EraseRootFromParent_Done,
     /* 720350 */   // Label 9379: @720350
     /* 720350 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(720420), // Rule ID 5461 //
     /* 720355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720362 */     // MIs[0] offset
     /* 720362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720365 */     // MIs[0] auxiliary
     /* 720365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720368 */     // MIs[0] Operand 7
     /* 720368 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720386 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 720389 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720391 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720418 */     GIR_RootConstrainSelectedInstOperands,
     /* 720419 */     // GIR_Coverage, 5461,
     /* 720419 */     GIR_EraseRootFromParent_Done,
     /* 720420 */   // Label 9380: @720420
     /* 720420 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(720487), // Rule ID 5465 //
     /* 720425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720429 */     // MIs[0] offset
     /* 720429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720432 */     // MIs[0] auxiliary
     /* 720432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720435 */     // MIs[0] Operand 7
     /* 720435 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720453 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 720456 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720458 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720467 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720485 */     GIR_RootConstrainSelectedInstOperands,
     /* 720486 */     // GIR_Coverage, 5465,
     /* 720486 */     GIR_EraseRootFromParent_Done,
     /* 720487 */   // Label 9381: @720487
     /* 720487 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(720549), // Rule ID 5462 //
     /* 720492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720499 */     // MIs[0] offset
     /* 720499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720502 */     // MIs[0] auxiliary
     /* 720502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720505 */     // MIs[0] Operand 7
     /* 720505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720515 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 720518 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720520 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720529 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720547 */     GIR_RootConstrainSelectedInstOperands,
     /* 720548 */     // GIR_Coverage, 5462,
     /* 720548 */     GIR_EraseRootFromParent_Done,
     /* 720549 */   // Label 9382: @720549
     /* 720549 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(720608), // Rule ID 5466 //
     /* 720554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720558 */     // MIs[0] offset
     /* 720558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720561 */     // MIs[0] auxiliary
     /* 720561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720564 */     // MIs[0] Operand 7
     /* 720564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720574 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 720577 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720579 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720588 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720606 */     GIR_RootConstrainSelectedInstOperands,
     /* 720607 */     // GIR_Coverage, 5466,
     /* 720607 */     GIR_EraseRootFromParent_Done,
     /* 720608 */   // Label 9383: @720608
     /* 720608 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(720708), // Rule ID 5463 //
     /* 720613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720616 */     // MIs[0] offset
     /* 720616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720619 */     // MIs[0] auxiliary
     /* 720619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720622 */     // MIs[0] Operand 7
     /* 720622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720632 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720648 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 720676 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720688 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720706 */     GIR_RootConstrainSelectedInstOperands,
     /* 720707 */     // GIR_Coverage, 5463,
     /* 720707 */     GIR_EraseRootFromParent_Done,
     /* 720708 */   // Label 9384: @720708
     /* 720708 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(720805), // Rule ID 5467 //
     /* 720713 */     // MIs[0] offset
     /* 720713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720716 */     // MIs[0] auxiliary
     /* 720716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720719 */     // MIs[0] Operand 7
     /* 720719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720729 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720745 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 720773 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720785 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720803 */     GIR_RootConstrainSelectedInstOperands,
     /* 720804 */     // GIR_Coverage, 5467,
     /* 720804 */     GIR_EraseRootFromParent_Done,
     /* 720805 */   // Label 9385: @720805
     /* 720805 */   GIM_Reject,
     /* 720806 */ // Label 9377: @720806
     /* 720806 */ GIM_Reject,
     /* 720807 */ // Label 9353: @720807
     /* 720807 */ GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(721421),
     /* 720812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 720815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 720818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 720821 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 720824 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(720896), // Rule ID 5388 //
     /* 720829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720840 */     // MIs[0] offset
     /* 720840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720843 */     // MIs[0] auxiliary
     /* 720843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720846 */     // MIs[0] Operand 7
     /* 720846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720864 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 720867 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720876 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720894 */     GIR_RootConstrainSelectedInstOperands,
     /* 720895 */     // GIR_Coverage, 5388,
     /* 720895 */     GIR_EraseRootFromParent_Done,
     /* 720896 */   // Label 9387: @720896
     /* 720896 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(720965), // Rule ID 5392 //
     /* 720901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720909 */     // MIs[0] offset
     /* 720909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720912 */     // MIs[0] auxiliary
     /* 720912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720915 */     // MIs[0] Operand 7
     /* 720915 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720933 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 720936 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720945 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720963 */     GIR_RootConstrainSelectedInstOperands,
     /* 720964 */     // GIR_Coverage, 5392,
     /* 720964 */     GIR_EraseRootFromParent_Done,
     /* 720965 */   // Label 9388: @720965
     /* 720965 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(721035), // Rule ID 5389 //
     /* 720970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720977 */     // MIs[0] offset
     /* 720977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720980 */     // MIs[0] auxiliary
     /* 720980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720983 */     // MIs[0] Operand 7
     /* 720983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721001 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 721004 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721006 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721015 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721033 */     GIR_RootConstrainSelectedInstOperands,
     /* 721034 */     // GIR_Coverage, 5389,
     /* 721034 */     GIR_EraseRootFromParent_Done,
     /* 721035 */   // Label 9389: @721035
     /* 721035 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(721102), // Rule ID 5393 //
     /* 721040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721044 */     // MIs[0] offset
     /* 721044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721047 */     // MIs[0] auxiliary
     /* 721047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721050 */     // MIs[0] Operand 7
     /* 721050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721068 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 721071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721073 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721082 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721100 */     GIR_RootConstrainSelectedInstOperands,
     /* 721101 */     // GIR_Coverage, 5393,
     /* 721101 */     GIR_EraseRootFromParent_Done,
     /* 721102 */   // Label 9390: @721102
     /* 721102 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(721164), // Rule ID 5390 //
     /* 721107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721114 */     // MIs[0] offset
     /* 721114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721117 */     // MIs[0] auxiliary
     /* 721117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721120 */     // MIs[0] Operand 7
     /* 721120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721130 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 721133 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721144 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721162 */     GIR_RootConstrainSelectedInstOperands,
     /* 721163 */     // GIR_Coverage, 5390,
     /* 721163 */     GIR_EraseRootFromParent_Done,
     /* 721164 */   // Label 9391: @721164
     /* 721164 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(721223), // Rule ID 5394 //
     /* 721169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721173 */     // MIs[0] offset
     /* 721173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721176 */     // MIs[0] auxiliary
     /* 721176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721179 */     // MIs[0] Operand 7
     /* 721179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721189 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 721192 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721194 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721203 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721221 */     GIR_RootConstrainSelectedInstOperands,
     /* 721222 */     // GIR_Coverage, 5394,
     /* 721222 */     GIR_EraseRootFromParent_Done,
     /* 721223 */   // Label 9392: @721223
     /* 721223 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(721323), // Rule ID 5391 //
     /* 721228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721231 */     // MIs[0] offset
     /* 721231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721234 */     // MIs[0] auxiliary
     /* 721234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721237 */     // MIs[0] Operand 7
     /* 721237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721247 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721263 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 721291 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721321 */     GIR_RootConstrainSelectedInstOperands,
     /* 721322 */     // GIR_Coverage, 5391,
     /* 721322 */     GIR_EraseRootFromParent_Done,
     /* 721323 */   // Label 9393: @721323
     /* 721323 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(721420), // Rule ID 5395 //
     /* 721328 */     // MIs[0] offset
     /* 721328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721331 */     // MIs[0] auxiliary
     /* 721331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721334 */     // MIs[0] Operand 7
     /* 721334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721344 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721360 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721367 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 721388 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721418 */     GIR_RootConstrainSelectedInstOperands,
     /* 721419 */     // GIR_Coverage, 5395,
     /* 721419 */     GIR_EraseRootFromParent_Done,
     /* 721420 */   // Label 9394: @721420
     /* 721420 */   GIM_Reject,
     /* 721421 */ // Label 9386: @721421
     /* 721421 */ GIM_Reject,
     /* 721422 */ // Label 9354: @721422
     /* 721422 */ GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(722036),
     /* 721427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 721430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 721433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 721436 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 721439 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(721511), // Rule ID 5396 //
     /* 721444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721455 */     // MIs[0] offset
     /* 721455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721458 */     // MIs[0] auxiliary
     /* 721458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721461 */     // MIs[0] Operand 7
     /* 721461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721479 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 721482 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721491 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721509 */     GIR_RootConstrainSelectedInstOperands,
     /* 721510 */     // GIR_Coverage, 5396,
     /* 721510 */     GIR_EraseRootFromParent_Done,
     /* 721511 */   // Label 9396: @721511
     /* 721511 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(721580), // Rule ID 5400 //
     /* 721516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721524 */     // MIs[0] offset
     /* 721524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721527 */     // MIs[0] auxiliary
     /* 721527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721530 */     // MIs[0] Operand 7
     /* 721530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721548 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 721551 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721560 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721578 */     GIR_RootConstrainSelectedInstOperands,
     /* 721579 */     // GIR_Coverage, 5400,
     /* 721579 */     GIR_EraseRootFromParent_Done,
     /* 721580 */   // Label 9397: @721580
     /* 721580 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(721650), // Rule ID 5397 //
     /* 721585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721592 */     // MIs[0] offset
     /* 721592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721595 */     // MIs[0] auxiliary
     /* 721595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721598 */     // MIs[0] Operand 7
     /* 721598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721616 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 721619 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721621 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721630 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721648 */     GIR_RootConstrainSelectedInstOperands,
     /* 721649 */     // GIR_Coverage, 5397,
     /* 721649 */     GIR_EraseRootFromParent_Done,
     /* 721650 */   // Label 9398: @721650
     /* 721650 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(721717), // Rule ID 5401 //
     /* 721655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721659 */     // MIs[0] offset
     /* 721659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721662 */     // MIs[0] auxiliary
     /* 721662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721665 */     // MIs[0] Operand 7
     /* 721665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721683 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 721686 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721688 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721697 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721715 */     GIR_RootConstrainSelectedInstOperands,
     /* 721716 */     // GIR_Coverage, 5401,
     /* 721716 */     GIR_EraseRootFromParent_Done,
     /* 721717 */   // Label 9399: @721717
     /* 721717 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(721779), // Rule ID 5398 //
     /* 721722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721729 */     // MIs[0] offset
     /* 721729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721732 */     // MIs[0] auxiliary
     /* 721732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721735 */     // MIs[0] Operand 7
     /* 721735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721745 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 721748 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721750 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721759 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721777 */     GIR_RootConstrainSelectedInstOperands,
     /* 721778 */     // GIR_Coverage, 5398,
     /* 721778 */     GIR_EraseRootFromParent_Done,
     /* 721779 */   // Label 9400: @721779
     /* 721779 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(721838), // Rule ID 5402 //
     /* 721784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721788 */     // MIs[0] offset
     /* 721788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721791 */     // MIs[0] auxiliary
     /* 721791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721794 */     // MIs[0] Operand 7
     /* 721794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721804 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 721807 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721809 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721818 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721836 */     GIR_RootConstrainSelectedInstOperands,
     /* 721837 */     // GIR_Coverage, 5402,
     /* 721837 */     GIR_EraseRootFromParent_Done,
     /* 721838 */   // Label 9401: @721838
     /* 721838 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(721938), // Rule ID 5399 //
     /* 721843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721846 */     // MIs[0] offset
     /* 721846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721849 */     // MIs[0] auxiliary
     /* 721849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721852 */     // MIs[0] Operand 7
     /* 721852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721862 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721878 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721885 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 721906 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721918 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721936 */     GIR_RootConstrainSelectedInstOperands,
     /* 721937 */     // GIR_Coverage, 5399,
     /* 721937 */     GIR_EraseRootFromParent_Done,
     /* 721938 */   // Label 9402: @721938
     /* 721938 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(722035), // Rule ID 5403 //
     /* 721943 */     // MIs[0] offset
     /* 721943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721946 */     // MIs[0] auxiliary
     /* 721946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721949 */     // MIs[0] Operand 7
     /* 721949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721959 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721975 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721982 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 722003 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722015 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722033 */     GIR_RootConstrainSelectedInstOperands,
     /* 722034 */     // GIR_Coverage, 5403,
     /* 722034 */     GIR_EraseRootFromParent_Done,
     /* 722035 */   // Label 9403: @722035
     /* 722035 */   GIM_Reject,
     /* 722036 */ // Label 9395: @722036
     /* 722036 */ GIM_Reject,
     /* 722037 */ // Label 9355: @722037
     /* 722037 */ GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(722651),
     /* 722042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722051 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722054 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(722126), // Rule ID 5468 //
     /* 722059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722070 */     // MIs[0] offset
     /* 722070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722073 */     // MIs[0] auxiliary
     /* 722073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722076 */     // MIs[0] Operand 7
     /* 722076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722094 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 722097 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722106 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722124 */     GIR_RootConstrainSelectedInstOperands,
     /* 722125 */     // GIR_Coverage, 5468,
     /* 722125 */     GIR_EraseRootFromParent_Done,
     /* 722126 */   // Label 9405: @722126
     /* 722126 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(722195), // Rule ID 5472 //
     /* 722131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722139 */     // MIs[0] offset
     /* 722139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722142 */     // MIs[0] auxiliary
     /* 722142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722145 */     // MIs[0] Operand 7
     /* 722145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722163 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 722166 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722175 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722193 */     GIR_RootConstrainSelectedInstOperands,
     /* 722194 */     // GIR_Coverage, 5472,
     /* 722194 */     GIR_EraseRootFromParent_Done,
     /* 722195 */   // Label 9406: @722195
     /* 722195 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(722265), // Rule ID 5469 //
     /* 722200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722207 */     // MIs[0] offset
     /* 722207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722210 */     // MIs[0] auxiliary
     /* 722210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722213 */     // MIs[0] Operand 7
     /* 722213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722231 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 722234 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722236 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722245 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722263 */     GIR_RootConstrainSelectedInstOperands,
     /* 722264 */     // GIR_Coverage, 5469,
     /* 722264 */     GIR_EraseRootFromParent_Done,
     /* 722265 */   // Label 9407: @722265
     /* 722265 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(722332), // Rule ID 5473 //
     /* 722270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722274 */     // MIs[0] offset
     /* 722274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722277 */     // MIs[0] auxiliary
     /* 722277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722280 */     // MIs[0] Operand 7
     /* 722280 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722298 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 722301 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722303 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722330 */     GIR_RootConstrainSelectedInstOperands,
     /* 722331 */     // GIR_Coverage, 5473,
     /* 722331 */     GIR_EraseRootFromParent_Done,
     /* 722332 */   // Label 9408: @722332
     /* 722332 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(722394), // Rule ID 5470 //
     /* 722337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722344 */     // MIs[0] offset
     /* 722344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722347 */     // MIs[0] auxiliary
     /* 722347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722350 */     // MIs[0] Operand 7
     /* 722350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722360 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 722363 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722365 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722374 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722376 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722382 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722392 */     GIR_RootConstrainSelectedInstOperands,
     /* 722393 */     // GIR_Coverage, 5470,
     /* 722393 */     GIR_EraseRootFromParent_Done,
     /* 722394 */   // Label 9409: @722394
     /* 722394 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(722453), // Rule ID 5474 //
     /* 722399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722403 */     // MIs[0] offset
     /* 722403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722406 */     // MIs[0] auxiliary
     /* 722406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722409 */     // MIs[0] Operand 7
     /* 722409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722419 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 722422 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722424 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722433 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722451 */     GIR_RootConstrainSelectedInstOperands,
     /* 722452 */     // GIR_Coverage, 5474,
     /* 722452 */     GIR_EraseRootFromParent_Done,
     /* 722453 */   // Label 9410: @722453
     /* 722453 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(722553), // Rule ID 5471 //
     /* 722458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722461 */     // MIs[0] offset
     /* 722461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722464 */     // MIs[0] auxiliary
     /* 722464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722467 */     // MIs[0] Operand 7
     /* 722467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722477 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722493 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722500 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 722521 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722533 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722551 */     GIR_RootConstrainSelectedInstOperands,
     /* 722552 */     // GIR_Coverage, 5471,
     /* 722552 */     GIR_EraseRootFromParent_Done,
     /* 722553 */   // Label 9411: @722553
     /* 722553 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(722650), // Rule ID 5475 //
     /* 722558 */     // MIs[0] offset
     /* 722558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722561 */     // MIs[0] auxiliary
     /* 722561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722564 */     // MIs[0] Operand 7
     /* 722564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722574 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722590 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722597 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 722618 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722630 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722648 */     GIR_RootConstrainSelectedInstOperands,
     /* 722649 */     // GIR_Coverage, 5475,
     /* 722649 */     GIR_EraseRootFromParent_Done,
     /* 722650 */   // Label 9412: @722650
     /* 722650 */   GIM_Reject,
     /* 722651 */ // Label 9404: @722651
     /* 722651 */ GIM_Reject,
     /* 722652 */ // Label 9356: @722652
     /* 722652 */ GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(723266),
     /* 722657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722663 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722666 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722669 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(722741), // Rule ID 5404 //
     /* 722674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722685 */     // MIs[0] offset
     /* 722685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722688 */     // MIs[0] auxiliary
     /* 722688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722691 */     // MIs[0] Operand 7
     /* 722691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722709 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 722712 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722721 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722739 */     GIR_RootConstrainSelectedInstOperands,
     /* 722740 */     // GIR_Coverage, 5404,
     /* 722740 */     GIR_EraseRootFromParent_Done,
     /* 722741 */   // Label 9414: @722741
     /* 722741 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(722810), // Rule ID 5408 //
     /* 722746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722754 */     // MIs[0] offset
     /* 722754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722757 */     // MIs[0] auxiliary
     /* 722757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722760 */     // MIs[0] Operand 7
     /* 722760 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722778 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 722781 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722790 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722808 */     GIR_RootConstrainSelectedInstOperands,
     /* 722809 */     // GIR_Coverage, 5408,
     /* 722809 */     GIR_EraseRootFromParent_Done,
     /* 722810 */   // Label 9415: @722810
     /* 722810 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(722880), // Rule ID 5405 //
     /* 722815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722822 */     // MIs[0] offset
     /* 722822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722825 */     // MIs[0] auxiliary
     /* 722825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722828 */     // MIs[0] Operand 7
     /* 722828 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722846 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 722849 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722851 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722860 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722878 */     GIR_RootConstrainSelectedInstOperands,
     /* 722879 */     // GIR_Coverage, 5405,
     /* 722879 */     GIR_EraseRootFromParent_Done,
     /* 722880 */   // Label 9416: @722880
     /* 722880 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(722947), // Rule ID 5409 //
     /* 722885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722889 */     // MIs[0] offset
     /* 722889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722892 */     // MIs[0] auxiliary
     /* 722892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722895 */     // MIs[0] Operand 7
     /* 722895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722913 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 722916 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722918 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722927 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722945 */     GIR_RootConstrainSelectedInstOperands,
     /* 722946 */     // GIR_Coverage, 5409,
     /* 722946 */     GIR_EraseRootFromParent_Done,
     /* 722947 */   // Label 9417: @722947
     /* 722947 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(723009), // Rule ID 5406 //
     /* 722952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722959 */     // MIs[0] offset
     /* 722959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722962 */     // MIs[0] auxiliary
     /* 722962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722965 */     // MIs[0] Operand 7
     /* 722965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722975 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 722978 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722980 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722989 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723007 */     GIR_RootConstrainSelectedInstOperands,
     /* 723008 */     // GIR_Coverage, 5406,
     /* 723008 */     GIR_EraseRootFromParent_Done,
     /* 723009 */   // Label 9418: @723009
     /* 723009 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(723068), // Rule ID 5410 //
     /* 723014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723018 */     // MIs[0] offset
     /* 723018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723021 */     // MIs[0] auxiliary
     /* 723021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723024 */     // MIs[0] Operand 7
     /* 723024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723034 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 723037 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723039 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723048 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723066 */     GIR_RootConstrainSelectedInstOperands,
     /* 723067 */     // GIR_Coverage, 5410,
     /* 723067 */     GIR_EraseRootFromParent_Done,
     /* 723068 */   // Label 9419: @723068
     /* 723068 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(723168), // Rule ID 5407 //
     /* 723073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723076 */     // MIs[0] offset
     /* 723076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723079 */     // MIs[0] auxiliary
     /* 723079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723082 */     // MIs[0] Operand 7
     /* 723082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723092 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723108 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723115 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 723136 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723148 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723166 */     GIR_RootConstrainSelectedInstOperands,
     /* 723167 */     // GIR_Coverage, 5407,
     /* 723167 */     GIR_EraseRootFromParent_Done,
     /* 723168 */   // Label 9420: @723168
     /* 723168 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(723265), // Rule ID 5411 //
     /* 723173 */     // MIs[0] offset
     /* 723173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723176 */     // MIs[0] auxiliary
     /* 723176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723179 */     // MIs[0] Operand 7
     /* 723179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723189 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723205 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723212 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 723233 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723245 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723263 */     GIR_RootConstrainSelectedInstOperands,
     /* 723264 */     // GIR_Coverage, 5411,
     /* 723264 */     GIR_EraseRootFromParent_Done,
     /* 723265 */   // Label 9421: @723265
     /* 723265 */   GIM_Reject,
     /* 723266 */ // Label 9413: @723266
     /* 723266 */ GIM_Reject,
     /* 723267 */ // Label 9357: @723267
     /* 723267 */ GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(723881),
     /* 723272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 723275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 723278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 723281 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 723284 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(723356), // Rule ID 5412 //
     /* 723289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723300 */     // MIs[0] offset
     /* 723300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723303 */     // MIs[0] auxiliary
     /* 723303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723306 */     // MIs[0] Operand 7
     /* 723306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723324 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 723327 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723336 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723354 */     GIR_RootConstrainSelectedInstOperands,
     /* 723355 */     // GIR_Coverage, 5412,
     /* 723355 */     GIR_EraseRootFromParent_Done,
     /* 723356 */   // Label 9423: @723356
     /* 723356 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(723425), // Rule ID 5416 //
     /* 723361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723369 */     // MIs[0] offset
     /* 723369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723372 */     // MIs[0] auxiliary
     /* 723372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723375 */     // MIs[0] Operand 7
     /* 723375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723393 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 723396 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723405 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723423 */     GIR_RootConstrainSelectedInstOperands,
     /* 723424 */     // GIR_Coverage, 5416,
     /* 723424 */     GIR_EraseRootFromParent_Done,
     /* 723425 */   // Label 9424: @723425
     /* 723425 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(723495), // Rule ID 5413 //
     /* 723430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723437 */     // MIs[0] offset
     /* 723437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723440 */     // MIs[0] auxiliary
     /* 723440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723443 */     // MIs[0] Operand 7
     /* 723443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723461 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 723464 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723466 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723475 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723493 */     GIR_RootConstrainSelectedInstOperands,
     /* 723494 */     // GIR_Coverage, 5413,
     /* 723494 */     GIR_EraseRootFromParent_Done,
     /* 723495 */   // Label 9425: @723495
     /* 723495 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(723562), // Rule ID 5417 //
     /* 723500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723504 */     // MIs[0] offset
     /* 723504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723507 */     // MIs[0] auxiliary
     /* 723507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723510 */     // MIs[0] Operand 7
     /* 723510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723528 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 723531 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723533 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723542 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723560 */     GIR_RootConstrainSelectedInstOperands,
     /* 723561 */     // GIR_Coverage, 5417,
     /* 723561 */     GIR_EraseRootFromParent_Done,
     /* 723562 */   // Label 9426: @723562
     /* 723562 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(723624), // Rule ID 5414 //
     /* 723567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723574 */     // MIs[0] offset
     /* 723574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723577 */     // MIs[0] auxiliary
     /* 723577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723580 */     // MIs[0] Operand 7
     /* 723580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723590 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 723593 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723595 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723604 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723622 */     GIR_RootConstrainSelectedInstOperands,
     /* 723623 */     // GIR_Coverage, 5414,
     /* 723623 */     GIR_EraseRootFromParent_Done,
     /* 723624 */   // Label 9427: @723624
     /* 723624 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(723683), // Rule ID 5418 //
     /* 723629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723633 */     // MIs[0] offset
     /* 723633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723636 */     // MIs[0] auxiliary
     /* 723636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723639 */     // MIs[0] Operand 7
     /* 723639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723649 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 723652 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723654 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723663 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723681 */     GIR_RootConstrainSelectedInstOperands,
     /* 723682 */     // GIR_Coverage, 5418,
     /* 723682 */     GIR_EraseRootFromParent_Done,
     /* 723683 */   // Label 9428: @723683
     /* 723683 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(723783), // Rule ID 5415 //
     /* 723688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723691 */     // MIs[0] offset
     /* 723691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723694 */     // MIs[0] auxiliary
     /* 723694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723697 */     // MIs[0] Operand 7
     /* 723697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723707 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723723 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723730 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 723751 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723781 */     GIR_RootConstrainSelectedInstOperands,
     /* 723782 */     // GIR_Coverage, 5415,
     /* 723782 */     GIR_EraseRootFromParent_Done,
     /* 723783 */   // Label 9429: @723783
     /* 723783 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(723880), // Rule ID 5419 //
     /* 723788 */     // MIs[0] offset
     /* 723788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723791 */     // MIs[0] auxiliary
     /* 723791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723794 */     // MIs[0] Operand 7
     /* 723794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723804 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723820 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723827 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 723848 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723860 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723878 */     GIR_RootConstrainSelectedInstOperands,
     /* 723879 */     // GIR_Coverage, 5419,
     /* 723879 */     GIR_EraseRootFromParent_Done,
     /* 723880 */   // Label 9430: @723880
     /* 723880 */   GIM_Reject,
     /* 723881 */ // Label 9422: @723881
     /* 723881 */ GIM_Reject,
     /* 723882 */ // Label 9358: @723882
     /* 723882 */ GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(725092),
     /* 723887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 723890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 723893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 723896 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 723899 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(723971), // Rule ID 5356 //
     /* 723904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723915 */     // MIs[0] offset
     /* 723915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723918 */     // MIs[0] auxiliary
     /* 723918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723921 */     // MIs[0] Operand 7
     /* 723921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723939 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 723942 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723969 */     GIR_RootConstrainSelectedInstOperands,
     /* 723970 */     // GIR_Coverage, 5356,
     /* 723970 */     GIR_EraseRootFromParent_Done,
     /* 723971 */   // Label 9432: @723971
     /* 723971 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(724040), // Rule ID 5360 //
     /* 723976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723984 */     // MIs[0] offset
     /* 723984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723987 */     // MIs[0] auxiliary
     /* 723987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723990 */     // MIs[0] Operand 7
     /* 723990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724008 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 724011 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724020 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724038 */     GIR_RootConstrainSelectedInstOperands,
     /* 724039 */     // GIR_Coverage, 5360,
     /* 724039 */     GIR_EraseRootFromParent_Done,
     /* 724040 */   // Label 9433: @724040
     /* 724040 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(724112), // Rule ID 5364 //
     /* 724045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724056 */     // MIs[0] offset
     /* 724056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724059 */     // MIs[0] auxiliary
     /* 724059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724062 */     // MIs[0] Operand 7
     /* 724062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724080 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 724083 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724092 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724110 */     GIR_RootConstrainSelectedInstOperands,
     /* 724111 */     // GIR_Coverage, 5364,
     /* 724111 */     GIR_EraseRootFromParent_Done,
     /* 724112 */   // Label 9434: @724112
     /* 724112 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(724181), // Rule ID 5368 //
     /* 724117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724125 */     // MIs[0] offset
     /* 724125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724128 */     // MIs[0] auxiliary
     /* 724128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724131 */     // MIs[0] Operand 7
     /* 724131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724149 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 724152 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724161 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724179 */     GIR_RootConstrainSelectedInstOperands,
     /* 724180 */     // GIR_Coverage, 5368,
     /* 724180 */     GIR_EraseRootFromParent_Done,
     /* 724181 */   // Label 9435: @724181
     /* 724181 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(724251), // Rule ID 5357 //
     /* 724186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724193 */     // MIs[0] offset
     /* 724193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724196 */     // MIs[0] auxiliary
     /* 724196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724199 */     // MIs[0] Operand 7
     /* 724199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724217 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 724220 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724222 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724231 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724249 */     GIR_RootConstrainSelectedInstOperands,
     /* 724250 */     // GIR_Coverage, 5357,
     /* 724250 */     GIR_EraseRootFromParent_Done,
     /* 724251 */   // Label 9436: @724251
     /* 724251 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(724318), // Rule ID 5361 //
     /* 724256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724260 */     // MIs[0] offset
     /* 724260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724263 */     // MIs[0] auxiliary
     /* 724263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724266 */     // MIs[0] Operand 7
     /* 724266 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724284 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 724287 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724289 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724298 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724316 */     GIR_RootConstrainSelectedInstOperands,
     /* 724317 */     // GIR_Coverage, 5361,
     /* 724317 */     GIR_EraseRootFromParent_Done,
     /* 724318 */   // Label 9437: @724318
     /* 724318 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(724388), // Rule ID 5365 //
     /* 724323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724330 */     // MIs[0] offset
     /* 724330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724333 */     // MIs[0] auxiliary
     /* 724333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724336 */     // MIs[0] Operand 7
     /* 724336 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724354 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 724357 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724359 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724368 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724370 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724376 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724386 */     GIR_RootConstrainSelectedInstOperands,
     /* 724387 */     // GIR_Coverage, 5365,
     /* 724387 */     GIR_EraseRootFromParent_Done,
     /* 724388 */   // Label 9438: @724388
     /* 724388 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(724455), // Rule ID 5369 //
     /* 724393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724397 */     // MIs[0] offset
     /* 724397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724400 */     // MIs[0] auxiliary
     /* 724400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724403 */     // MIs[0] Operand 7
     /* 724403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724421 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 724424 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724426 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724435 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724453 */     GIR_RootConstrainSelectedInstOperands,
     /* 724454 */     // GIR_Coverage, 5369,
     /* 724454 */     GIR_EraseRootFromParent_Done,
     /* 724455 */   // Label 9439: @724455
     /* 724455 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(724517), // Rule ID 5358 //
     /* 724460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724467 */     // MIs[0] offset
     /* 724467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724470 */     // MIs[0] auxiliary
     /* 724470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724473 */     // MIs[0] Operand 7
     /* 724473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724483 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 724486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724488 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724515 */     GIR_RootConstrainSelectedInstOperands,
     /* 724516 */     // GIR_Coverage, 5358,
     /* 724516 */     GIR_EraseRootFromParent_Done,
     /* 724517 */   // Label 9440: @724517
     /* 724517 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(724576), // Rule ID 5362 //
     /* 724522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724526 */     // MIs[0] offset
     /* 724526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724529 */     // MIs[0] auxiliary
     /* 724529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724532 */     // MIs[0] Operand 7
     /* 724532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724542 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 724545 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724547 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724574 */     GIR_RootConstrainSelectedInstOperands,
     /* 724575 */     // GIR_Coverage, 5362,
     /* 724575 */     GIR_EraseRootFromParent_Done,
     /* 724576 */   // Label 9441: @724576
     /* 724576 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(724638), // Rule ID 5366 //
     /* 724581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724588 */     // MIs[0] offset
     /* 724588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724591 */     // MIs[0] auxiliary
     /* 724591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724594 */     // MIs[0] Operand 7
     /* 724594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724604 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 724607 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724609 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724618 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724636 */     GIR_RootConstrainSelectedInstOperands,
     /* 724637 */     // GIR_Coverage, 5366,
     /* 724637 */     GIR_EraseRootFromParent_Done,
     /* 724638 */   // Label 9442: @724638
     /* 724638 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(724697), // Rule ID 5370 //
     /* 724643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724647 */     // MIs[0] offset
     /* 724647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724650 */     // MIs[0] auxiliary
     /* 724650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724653 */     // MIs[0] Operand 7
     /* 724653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724663 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 724666 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724668 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724677 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724695 */     GIR_RootConstrainSelectedInstOperands,
     /* 724696 */     // GIR_Coverage, 5370,
     /* 724696 */     GIR_EraseRootFromParent_Done,
     /* 724697 */   // Label 9443: @724697
     /* 724697 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(724797), // Rule ID 5359 //
     /* 724702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724705 */     // MIs[0] offset
     /* 724705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724708 */     // MIs[0] auxiliary
     /* 724708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724711 */     // MIs[0] Operand 7
     /* 724711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724721 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724737 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724744 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 724765 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724795 */     GIR_RootConstrainSelectedInstOperands,
     /* 724796 */     // GIR_Coverage, 5359,
     /* 724796 */     GIR_EraseRootFromParent_Done,
     /* 724797 */   // Label 9444: @724797
     /* 724797 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(724894), // Rule ID 5363 //
     /* 724802 */     // MIs[0] offset
     /* 724802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724805 */     // MIs[0] auxiliary
     /* 724805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724808 */     // MIs[0] Operand 7
     /* 724808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724818 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724834 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724841 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 724862 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724874 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724892 */     GIR_RootConstrainSelectedInstOperands,
     /* 724893 */     // GIR_Coverage, 5363,
     /* 724893 */     GIR_EraseRootFromParent_Done,
     /* 724894 */   // Label 9445: @724894
     /* 724894 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(724994), // Rule ID 5367 //
     /* 724899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724902 */     // MIs[0] offset
     /* 724902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724905 */     // MIs[0] auxiliary
     /* 724905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724908 */     // MIs[0] Operand 7
     /* 724908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724918 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724934 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724941 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 724962 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724974 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724992 */     GIR_RootConstrainSelectedInstOperands,
     /* 724993 */     // GIR_Coverage, 5367,
     /* 724993 */     GIR_EraseRootFromParent_Done,
     /* 724994 */   // Label 9446: @724994
     /* 724994 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(725091), // Rule ID 5371 //
     /* 724999 */     // MIs[0] offset
     /* 724999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725002 */     // MIs[0] auxiliary
     /* 725002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725005 */     // MIs[0] Operand 7
     /* 725005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725015 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725031 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725038 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 725059 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725071 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725089 */     GIR_RootConstrainSelectedInstOperands,
     /* 725090 */     // GIR_Coverage, 5371,
     /* 725090 */     GIR_EraseRootFromParent_Done,
     /* 725091 */   // Label 9447: @725091
     /* 725091 */   GIM_Reject,
     /* 725092 */ // Label 9431: @725092
     /* 725092 */ GIM_Reject,
     /* 725093 */ // Label 9359: @725093
     /* 725093 */ GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(726303),
     /* 725098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 725101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 725104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 725107 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 725110 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(725182), // Rule ID 5420 //
     /* 725115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725126 */     // MIs[0] offset
     /* 725126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725129 */     // MIs[0] auxiliary
     /* 725129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725132 */     // MIs[0] Operand 7
     /* 725132 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725150 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 725153 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725162 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725180 */     GIR_RootConstrainSelectedInstOperands,
     /* 725181 */     // GIR_Coverage, 5420,
     /* 725181 */     GIR_EraseRootFromParent_Done,
     /* 725182 */   // Label 9449: @725182
     /* 725182 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(725251), // Rule ID 5424 //
     /* 725187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725195 */     // MIs[0] offset
     /* 725195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725198 */     // MIs[0] auxiliary
     /* 725198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725201 */     // MIs[0] Operand 7
     /* 725201 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725219 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 725222 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725231 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725249 */     GIR_RootConstrainSelectedInstOperands,
     /* 725250 */     // GIR_Coverage, 5424,
     /* 725250 */     GIR_EraseRootFromParent_Done,
     /* 725251 */   // Label 9450: @725251
     /* 725251 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(725323), // Rule ID 5428 //
     /* 725256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725267 */     // MIs[0] offset
     /* 725267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725270 */     // MIs[0] auxiliary
     /* 725270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725273 */     // MIs[0] Operand 7
     /* 725273 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725291 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 725294 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725321 */     GIR_RootConstrainSelectedInstOperands,
     /* 725322 */     // GIR_Coverage, 5428,
     /* 725322 */     GIR_EraseRootFromParent_Done,
     /* 725323 */   // Label 9451: @725323
     /* 725323 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(725392), // Rule ID 5432 //
     /* 725328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725336 */     // MIs[0] offset
     /* 725336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725339 */     // MIs[0] auxiliary
     /* 725339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725342 */     // MIs[0] Operand 7
     /* 725342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725360 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 725363 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725372 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725390 */     GIR_RootConstrainSelectedInstOperands,
     /* 725391 */     // GIR_Coverage, 5432,
     /* 725391 */     GIR_EraseRootFromParent_Done,
     /* 725392 */   // Label 9452: @725392
     /* 725392 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(725462), // Rule ID 5421 //
     /* 725397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725404 */     // MIs[0] offset
     /* 725404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725407 */     // MIs[0] auxiliary
     /* 725407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725410 */     // MIs[0] Operand 7
     /* 725410 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725428 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 725431 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725433 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725442 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725460 */     GIR_RootConstrainSelectedInstOperands,
     /* 725461 */     // GIR_Coverage, 5421,
     /* 725461 */     GIR_EraseRootFromParent_Done,
     /* 725462 */   // Label 9453: @725462
     /* 725462 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(725529), // Rule ID 5425 //
     /* 725467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725471 */     // MIs[0] offset
     /* 725471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725474 */     // MIs[0] auxiliary
     /* 725474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725477 */     // MIs[0] Operand 7
     /* 725477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725495 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 725498 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725500 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725509 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725527 */     GIR_RootConstrainSelectedInstOperands,
     /* 725528 */     // GIR_Coverage, 5425,
     /* 725528 */     GIR_EraseRootFromParent_Done,
     /* 725529 */   // Label 9454: @725529
     /* 725529 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(725599), // Rule ID 5429 //
     /* 725534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725541 */     // MIs[0] offset
     /* 725541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725544 */     // MIs[0] auxiliary
     /* 725544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725547 */     // MIs[0] Operand 7
     /* 725547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725565 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 725568 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725570 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725579 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725597 */     GIR_RootConstrainSelectedInstOperands,
     /* 725598 */     // GIR_Coverage, 5429,
     /* 725598 */     GIR_EraseRootFromParent_Done,
     /* 725599 */   // Label 9455: @725599
     /* 725599 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(725666), // Rule ID 5433 //
     /* 725604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725608 */     // MIs[0] offset
     /* 725608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725611 */     // MIs[0] auxiliary
     /* 725611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725614 */     // MIs[0] Operand 7
     /* 725614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725632 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 725635 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725637 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725646 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725664 */     GIR_RootConstrainSelectedInstOperands,
     /* 725665 */     // GIR_Coverage, 5433,
     /* 725665 */     GIR_EraseRootFromParent_Done,
     /* 725666 */   // Label 9456: @725666
     /* 725666 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(725728), // Rule ID 5422 //
     /* 725671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725678 */     // MIs[0] offset
     /* 725678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725681 */     // MIs[0] auxiliary
     /* 725681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725684 */     // MIs[0] Operand 7
     /* 725684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725694 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 725697 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725699 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725726 */     GIR_RootConstrainSelectedInstOperands,
     /* 725727 */     // GIR_Coverage, 5422,
     /* 725727 */     GIR_EraseRootFromParent_Done,
     /* 725728 */   // Label 9457: @725728
     /* 725728 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(725787), // Rule ID 5426 //
     /* 725733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725737 */     // MIs[0] offset
     /* 725737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725740 */     // MIs[0] auxiliary
     /* 725740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725743 */     // MIs[0] Operand 7
     /* 725743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725753 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 725756 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725758 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725767 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725775 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725785 */     GIR_RootConstrainSelectedInstOperands,
     /* 725786 */     // GIR_Coverage, 5426,
     /* 725786 */     GIR_EraseRootFromParent_Done,
     /* 725787 */   // Label 9458: @725787
     /* 725787 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(725849), // Rule ID 5430 //
     /* 725792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725799 */     // MIs[0] offset
     /* 725799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725802 */     // MIs[0] auxiliary
     /* 725802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725805 */     // MIs[0] Operand 7
     /* 725805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725815 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 725818 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725820 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725829 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725847 */     GIR_RootConstrainSelectedInstOperands,
     /* 725848 */     // GIR_Coverage, 5430,
     /* 725848 */     GIR_EraseRootFromParent_Done,
     /* 725849 */   // Label 9459: @725849
     /* 725849 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(725908), // Rule ID 5434 //
     /* 725854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725858 */     // MIs[0] offset
     /* 725858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725861 */     // MIs[0] auxiliary
     /* 725861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725864 */     // MIs[0] Operand 7
     /* 725864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725874 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 725877 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725879 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725888 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725906 */     GIR_RootConstrainSelectedInstOperands,
     /* 725907 */     // GIR_Coverage, 5434,
     /* 725907 */     GIR_EraseRootFromParent_Done,
     /* 725908 */   // Label 9460: @725908
     /* 725908 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(726008), // Rule ID 5423 //
     /* 725913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725916 */     // MIs[0] offset
     /* 725916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725919 */     // MIs[0] auxiliary
     /* 725919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725922 */     // MIs[0] Operand 7
     /* 725922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725932 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725948 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725955 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 725976 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726006 */     GIR_RootConstrainSelectedInstOperands,
     /* 726007 */     // GIR_Coverage, 5423,
     /* 726007 */     GIR_EraseRootFromParent_Done,
     /* 726008 */   // Label 9461: @726008
     /* 726008 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(726105), // Rule ID 5427 //
     /* 726013 */     // MIs[0] offset
     /* 726013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726016 */     // MIs[0] auxiliary
     /* 726016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726019 */     // MIs[0] Operand 7
     /* 726019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726029 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 726073 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726085 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726103 */     GIR_RootConstrainSelectedInstOperands,
     /* 726104 */     // GIR_Coverage, 5427,
     /* 726104 */     GIR_EraseRootFromParent_Done,
     /* 726105 */   // Label 9462: @726105
     /* 726105 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(726205), // Rule ID 5431 //
     /* 726110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726113 */     // MIs[0] offset
     /* 726113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726116 */     // MIs[0] auxiliary
     /* 726116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726119 */     // MIs[0] Operand 7
     /* 726119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726129 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726145 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726152 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 726173 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726185 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726203 */     GIR_RootConstrainSelectedInstOperands,
     /* 726204 */     // GIR_Coverage, 5431,
     /* 726204 */     GIR_EraseRootFromParent_Done,
     /* 726205 */   // Label 9463: @726205
     /* 726205 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(726302), // Rule ID 5435 //
     /* 726210 */     // MIs[0] offset
     /* 726210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726213 */     // MIs[0] auxiliary
     /* 726213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726216 */     // MIs[0] Operand 7
     /* 726216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726226 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 726270 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726300 */     GIR_RootConstrainSelectedInstOperands,
     /* 726301 */     // GIR_Coverage, 5435,
     /* 726301 */     GIR_EraseRootFromParent_Done,
     /* 726302 */   // Label 9464: @726302
     /* 726302 */   GIM_Reject,
     /* 726303 */ // Label 9448: @726303
     /* 726303 */ GIM_Reject,
     /* 726304 */ // Label 9360: @726304
     /* 726304 */ GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(727514),
     /* 726309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 726312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 726315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 726318 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 726321 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(726393), // Rule ID 5372 //
     /* 726326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726337 */     // MIs[0] offset
     /* 726337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726340 */     // MIs[0] auxiliary
     /* 726340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726343 */     // MIs[0] Operand 7
     /* 726343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726361 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 726364 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726373 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726391 */     GIR_RootConstrainSelectedInstOperands,
     /* 726392 */     // GIR_Coverage, 5372,
     /* 726392 */     GIR_EraseRootFromParent_Done,
     /* 726393 */   // Label 9466: @726393
     /* 726393 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(726462), // Rule ID 5376 //
     /* 726398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726406 */     // MIs[0] offset
     /* 726406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726409 */     // MIs[0] auxiliary
     /* 726409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726412 */     // MIs[0] Operand 7
     /* 726412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726430 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 726433 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726442 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726460 */     GIR_RootConstrainSelectedInstOperands,
     /* 726461 */     // GIR_Coverage, 5376,
     /* 726461 */     GIR_EraseRootFromParent_Done,
     /* 726462 */   // Label 9467: @726462
     /* 726462 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(726534), // Rule ID 5380 //
     /* 726467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726478 */     // MIs[0] offset
     /* 726478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726481 */     // MIs[0] auxiliary
     /* 726481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726484 */     // MIs[0] Operand 7
     /* 726484 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726502 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 726505 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726514 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726532 */     GIR_RootConstrainSelectedInstOperands,
     /* 726533 */     // GIR_Coverage, 5380,
     /* 726533 */     GIR_EraseRootFromParent_Done,
     /* 726534 */   // Label 9468: @726534
     /* 726534 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(726603), // Rule ID 5384 //
     /* 726539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726547 */     // MIs[0] offset
     /* 726547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726550 */     // MIs[0] auxiliary
     /* 726550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726553 */     // MIs[0] Operand 7
     /* 726553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726571 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 726574 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726583 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726601 */     GIR_RootConstrainSelectedInstOperands,
     /* 726602 */     // GIR_Coverage, 5384,
     /* 726602 */     GIR_EraseRootFromParent_Done,
     /* 726603 */   // Label 9469: @726603
     /* 726603 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(726673), // Rule ID 5373 //
     /* 726608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726615 */     // MIs[0] offset
     /* 726615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726618 */     // MIs[0] auxiliary
     /* 726618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726621 */     // MIs[0] Operand 7
     /* 726621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726639 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 726642 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726644 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726653 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726671 */     GIR_RootConstrainSelectedInstOperands,
     /* 726672 */     // GIR_Coverage, 5373,
     /* 726672 */     GIR_EraseRootFromParent_Done,
     /* 726673 */   // Label 9470: @726673
     /* 726673 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(726740), // Rule ID 5377 //
     /* 726678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726682 */     // MIs[0] offset
     /* 726682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726685 */     // MIs[0] auxiliary
     /* 726685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726688 */     // MIs[0] Operand 7
     /* 726688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726706 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 726709 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726711 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726720 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726738 */     GIR_RootConstrainSelectedInstOperands,
     /* 726739 */     // GIR_Coverage, 5377,
     /* 726739 */     GIR_EraseRootFromParent_Done,
     /* 726740 */   // Label 9471: @726740
     /* 726740 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(726810), // Rule ID 5381 //
     /* 726745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726752 */     // MIs[0] offset
     /* 726752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726755 */     // MIs[0] auxiliary
     /* 726755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726758 */     // MIs[0] Operand 7
     /* 726758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726776 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 726779 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726781 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726790 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726808 */     GIR_RootConstrainSelectedInstOperands,
     /* 726809 */     // GIR_Coverage, 5381,
     /* 726809 */     GIR_EraseRootFromParent_Done,
     /* 726810 */   // Label 9472: @726810
     /* 726810 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(726877), // Rule ID 5385 //
     /* 726815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726819 */     // MIs[0] offset
     /* 726819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726822 */     // MIs[0] auxiliary
     /* 726822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726825 */     // MIs[0] Operand 7
     /* 726825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726843 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 726846 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726848 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726857 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726875 */     GIR_RootConstrainSelectedInstOperands,
     /* 726876 */     // GIR_Coverage, 5385,
     /* 726876 */     GIR_EraseRootFromParent_Done,
     /* 726877 */   // Label 9473: @726877
     /* 726877 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(726939), // Rule ID 5374 //
     /* 726882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726889 */     // MIs[0] offset
     /* 726889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726892 */     // MIs[0] auxiliary
     /* 726892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726895 */     // MIs[0] Operand 7
     /* 726895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726905 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 726908 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726910 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726919 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726937 */     GIR_RootConstrainSelectedInstOperands,
     /* 726938 */     // GIR_Coverage, 5374,
     /* 726938 */     GIR_EraseRootFromParent_Done,
     /* 726939 */   // Label 9474: @726939
     /* 726939 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(726998), // Rule ID 5378 //
     /* 726944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726948 */     // MIs[0] offset
     /* 726948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726951 */     // MIs[0] auxiliary
     /* 726951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726954 */     // MIs[0] Operand 7
     /* 726954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726964 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 726967 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726969 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726978 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726996 */     GIR_RootConstrainSelectedInstOperands,
     /* 726997 */     // GIR_Coverage, 5378,
     /* 726997 */     GIR_EraseRootFromParent_Done,
     /* 726998 */   // Label 9475: @726998
     /* 726998 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(727060), // Rule ID 5382 //
     /* 727003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727010 */     // MIs[0] offset
     /* 727010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727013 */     // MIs[0] auxiliary
     /* 727013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727016 */     // MIs[0] Operand 7
     /* 727016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727026 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 727029 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727031 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727040 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727058 */     GIR_RootConstrainSelectedInstOperands,
     /* 727059 */     // GIR_Coverage, 5382,
     /* 727059 */     GIR_EraseRootFromParent_Done,
     /* 727060 */   // Label 9476: @727060
     /* 727060 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(727119), // Rule ID 5386 //
     /* 727065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727069 */     // MIs[0] offset
     /* 727069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727072 */     // MIs[0] auxiliary
     /* 727072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727075 */     // MIs[0] Operand 7
     /* 727075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727085 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 727088 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727090 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727099 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727117 */     GIR_RootConstrainSelectedInstOperands,
     /* 727118 */     // GIR_Coverage, 5386,
     /* 727118 */     GIR_EraseRootFromParent_Done,
     /* 727119 */   // Label 9477: @727119
     /* 727119 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(727219), // Rule ID 5375 //
     /* 727124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727127 */     // MIs[0] offset
     /* 727127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727130 */     // MIs[0] auxiliary
     /* 727130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727133 */     // MIs[0] Operand 7
     /* 727133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727143 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727159 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727166 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 727187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727217 */     GIR_RootConstrainSelectedInstOperands,
     /* 727218 */     // GIR_Coverage, 5375,
     /* 727218 */     GIR_EraseRootFromParent_Done,
     /* 727219 */   // Label 9478: @727219
     /* 727219 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(727316), // Rule ID 5379 //
     /* 727224 */     // MIs[0] offset
     /* 727224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727227 */     // MIs[0] auxiliary
     /* 727227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727230 */     // MIs[0] Operand 7
     /* 727230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727240 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727256 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727263 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 727284 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727296 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727314 */     GIR_RootConstrainSelectedInstOperands,
     /* 727315 */     // GIR_Coverage, 5379,
     /* 727315 */     GIR_EraseRootFromParent_Done,
     /* 727316 */   // Label 9479: @727316
     /* 727316 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(727416), // Rule ID 5383 //
     /* 727321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727324 */     // MIs[0] offset
     /* 727324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727327 */     // MIs[0] auxiliary
     /* 727327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727330 */     // MIs[0] Operand 7
     /* 727330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727340 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727356 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727363 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 727384 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727396 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727414 */     GIR_RootConstrainSelectedInstOperands,
     /* 727415 */     // GIR_Coverage, 5383,
     /* 727415 */     GIR_EraseRootFromParent_Done,
     /* 727416 */   // Label 9480: @727416
     /* 727416 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(727513), // Rule ID 5387 //
     /* 727421 */     // MIs[0] offset
     /* 727421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727424 */     // MIs[0] auxiliary
     /* 727424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727427 */     // MIs[0] Operand 7
     /* 727427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727437 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727453 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727460 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 727481 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727493 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727511 */     GIR_RootConstrainSelectedInstOperands,
     /* 727512 */     // GIR_Coverage, 5387,
     /* 727512 */     GIR_EraseRootFromParent_Done,
     /* 727513 */   // Label 9481: @727513
     /* 727513 */   GIM_Reject,
     /* 727514 */ // Label 9465: @727514
     /* 727514 */ GIM_Reject,
     /* 727515 */ // Label 9361: @727515
     /* 727515 */ GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(728725),
     /* 727520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 727523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 727526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 727529 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 727532 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(727604), // Rule ID 5436 //
     /* 727537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727548 */     // MIs[0] offset
     /* 727548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727551 */     // MIs[0] auxiliary
     /* 727551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727554 */     // MIs[0] Operand 7
     /* 727554 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727572 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 727575 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727584 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727602 */     GIR_RootConstrainSelectedInstOperands,
     /* 727603 */     // GIR_Coverage, 5436,
     /* 727603 */     GIR_EraseRootFromParent_Done,
     /* 727604 */   // Label 9483: @727604
     /* 727604 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(727673), // Rule ID 5440 //
     /* 727609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727617 */     // MIs[0] offset
     /* 727617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727620 */     // MIs[0] auxiliary
     /* 727620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727623 */     // MIs[0] Operand 7
     /* 727623 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727641 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 727644 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727653 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727671 */     GIR_RootConstrainSelectedInstOperands,
     /* 727672 */     // GIR_Coverage, 5440,
     /* 727672 */     GIR_EraseRootFromParent_Done,
     /* 727673 */   // Label 9484: @727673
     /* 727673 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(727745), // Rule ID 5444 //
     /* 727678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727689 */     // MIs[0] offset
     /* 727689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727692 */     // MIs[0] auxiliary
     /* 727692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727695 */     // MIs[0] Operand 7
     /* 727695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727713 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 727716 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727725 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727743 */     GIR_RootConstrainSelectedInstOperands,
     /* 727744 */     // GIR_Coverage, 5444,
     /* 727744 */     GIR_EraseRootFromParent_Done,
     /* 727745 */   // Label 9485: @727745
     /* 727745 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(727814), // Rule ID 5448 //
     /* 727750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727758 */     // MIs[0] offset
     /* 727758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727761 */     // MIs[0] auxiliary
     /* 727761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727764 */     // MIs[0] Operand 7
     /* 727764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727782 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 727785 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727794 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727812 */     GIR_RootConstrainSelectedInstOperands,
     /* 727813 */     // GIR_Coverage, 5448,
     /* 727813 */     GIR_EraseRootFromParent_Done,
     /* 727814 */   // Label 9486: @727814
     /* 727814 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(727884), // Rule ID 5437 //
     /* 727819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727822 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727826 */     // MIs[0] offset
     /* 727826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727829 */     // MIs[0] auxiliary
     /* 727829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727832 */     // MIs[0] Operand 7
     /* 727832 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727850 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 727853 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727855 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727864 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727866 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727882 */     GIR_RootConstrainSelectedInstOperands,
     /* 727883 */     // GIR_Coverage, 5437,
     /* 727883 */     GIR_EraseRootFromParent_Done,
     /* 727884 */   // Label 9487: @727884
     /* 727884 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(727951), // Rule ID 5441 //
     /* 727889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727893 */     // MIs[0] offset
     /* 727893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727896 */     // MIs[0] auxiliary
     /* 727896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727899 */     // MIs[0] Operand 7
     /* 727899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727917 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 727920 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727922 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727931 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727949 */     GIR_RootConstrainSelectedInstOperands,
     /* 727950 */     // GIR_Coverage, 5441,
     /* 727950 */     GIR_EraseRootFromParent_Done,
     /* 727951 */   // Label 9488: @727951
     /* 727951 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(728021), // Rule ID 5445 //
     /* 727956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727963 */     // MIs[0] offset
     /* 727963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727966 */     // MIs[0] auxiliary
     /* 727966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727969 */     // MIs[0] Operand 7
     /* 727969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727987 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 727990 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727992 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728001 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728019 */     GIR_RootConstrainSelectedInstOperands,
     /* 728020 */     // GIR_Coverage, 5445,
     /* 728020 */     GIR_EraseRootFromParent_Done,
     /* 728021 */   // Label 9489: @728021
     /* 728021 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(728088), // Rule ID 5449 //
     /* 728026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728030 */     // MIs[0] offset
     /* 728030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728033 */     // MIs[0] auxiliary
     /* 728033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728036 */     // MIs[0] Operand 7
     /* 728036 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728054 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 728057 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728059 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728068 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728086 */     GIR_RootConstrainSelectedInstOperands,
     /* 728087 */     // GIR_Coverage, 5449,
     /* 728087 */     GIR_EraseRootFromParent_Done,
     /* 728088 */   // Label 9490: @728088
     /* 728088 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(728150), // Rule ID 5438 //
     /* 728093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728100 */     // MIs[0] offset
     /* 728100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728103 */     // MIs[0] auxiliary
     /* 728103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728106 */     // MIs[0] Operand 7
     /* 728106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728116 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 728119 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728121 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728130 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728148 */     GIR_RootConstrainSelectedInstOperands,
     /* 728149 */     // GIR_Coverage, 5438,
     /* 728149 */     GIR_EraseRootFromParent_Done,
     /* 728150 */   // Label 9491: @728150
     /* 728150 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(728209), // Rule ID 5442 //
     /* 728155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728159 */     // MIs[0] offset
     /* 728159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728162 */     // MIs[0] auxiliary
     /* 728162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728165 */     // MIs[0] Operand 7
     /* 728165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728175 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 728178 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728180 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728189 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728207 */     GIR_RootConstrainSelectedInstOperands,
     /* 728208 */     // GIR_Coverage, 5442,
     /* 728208 */     GIR_EraseRootFromParent_Done,
     /* 728209 */   // Label 9492: @728209
     /* 728209 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(728271), // Rule ID 5446 //
     /* 728214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728221 */     // MIs[0] offset
     /* 728221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728224 */     // MIs[0] auxiliary
     /* 728224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728227 */     // MIs[0] Operand 7
     /* 728227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728237 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 728240 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728242 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728251 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728269 */     GIR_RootConstrainSelectedInstOperands,
     /* 728270 */     // GIR_Coverage, 5446,
     /* 728270 */     GIR_EraseRootFromParent_Done,
     /* 728271 */   // Label 9493: @728271
     /* 728271 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(728330), // Rule ID 5450 //
     /* 728276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728280 */     // MIs[0] offset
     /* 728280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728283 */     // MIs[0] auxiliary
     /* 728283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728286 */     // MIs[0] Operand 7
     /* 728286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728296 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 728299 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728301 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728310 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728328 */     GIR_RootConstrainSelectedInstOperands,
     /* 728329 */     // GIR_Coverage, 5450,
     /* 728329 */     GIR_EraseRootFromParent_Done,
     /* 728330 */   // Label 9494: @728330
     /* 728330 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(728430), // Rule ID 5439 //
     /* 728335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728338 */     // MIs[0] offset
     /* 728338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728341 */     // MIs[0] auxiliary
     /* 728341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728344 */     // MIs[0] Operand 7
     /* 728344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728354 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728370 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728377 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 728398 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728410 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728412 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728428 */     GIR_RootConstrainSelectedInstOperands,
     /* 728429 */     // GIR_Coverage, 5439,
     /* 728429 */     GIR_EraseRootFromParent_Done,
     /* 728430 */   // Label 9495: @728430
     /* 728430 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(728527), // Rule ID 5443 //
     /* 728435 */     // MIs[0] offset
     /* 728435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728438 */     // MIs[0] auxiliary
     /* 728438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728441 */     // MIs[0] Operand 7
     /* 728441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728451 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728467 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728474 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 728495 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728507 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728525 */     GIR_RootConstrainSelectedInstOperands,
     /* 728526 */     // GIR_Coverage, 5443,
     /* 728526 */     GIR_EraseRootFromParent_Done,
     /* 728527 */   // Label 9496: @728527
     /* 728527 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(728627), // Rule ID 5447 //
     /* 728532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728535 */     // MIs[0] offset
     /* 728535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728538 */     // MIs[0] auxiliary
     /* 728538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728541 */     // MIs[0] Operand 7
     /* 728541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728551 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728567 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728574 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 728595 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728607 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728625 */     GIR_RootConstrainSelectedInstOperands,
     /* 728626 */     // GIR_Coverage, 5447,
     /* 728626 */     GIR_EraseRootFromParent_Done,
     /* 728627 */   // Label 9497: @728627
     /* 728627 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(728724), // Rule ID 5451 //
     /* 728632 */     // MIs[0] offset
     /* 728632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728635 */     // MIs[0] auxiliary
     /* 728635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728638 */     // MIs[0] Operand 7
     /* 728638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728648 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728660 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728664 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728671 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 728692 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728704 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728722 */     GIR_RootConstrainSelectedInstOperands,
     /* 728723 */     // GIR_Coverage, 5451,
     /* 728723 */     GIR_EraseRootFromParent_Done,
     /* 728724 */   // Label 9498: @728724
     /* 728724 */   GIM_Reject,
     /* 728725 */ // Label 9482: @728725
     /* 728725 */ GIM_Reject,
     /* 728726 */ // Label 9362: @728726
     /* 728726 */ GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(729936),
     /* 728731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 728734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 728737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 728740 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 728743 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(728815), // Rule ID 5524 //
     /* 728748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728759 */     // MIs[0] offset
     /* 728759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728762 */     // MIs[0] auxiliary
     /* 728762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728765 */     // MIs[0] Operand 7
     /* 728765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728783 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 728786 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728795 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728813 */     GIR_RootConstrainSelectedInstOperands,
     /* 728814 */     // GIR_Coverage, 5524,
     /* 728814 */     GIR_EraseRootFromParent_Done,
     /* 728815 */   // Label 9500: @728815
     /* 728815 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(728884), // Rule ID 5528 //
     /* 728820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728828 */     // MIs[0] offset
     /* 728828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728831 */     // MIs[0] auxiliary
     /* 728831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728834 */     // MIs[0] Operand 7
     /* 728834 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728852 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 728855 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728864 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728866 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728882 */     GIR_RootConstrainSelectedInstOperands,
     /* 728883 */     // GIR_Coverage, 5528,
     /* 728883 */     GIR_EraseRootFromParent_Done,
     /* 728884 */   // Label 9501: @728884
     /* 728884 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(728956), // Rule ID 5532 //
     /* 728889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728900 */     // MIs[0] offset
     /* 728900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728903 */     // MIs[0] auxiliary
     /* 728903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728906 */     // MIs[0] Operand 7
     /* 728906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728924 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 728927 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728936 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728954 */     GIR_RootConstrainSelectedInstOperands,
     /* 728955 */     // GIR_Coverage, 5532,
     /* 728955 */     GIR_EraseRootFromParent_Done,
     /* 728956 */   // Label 9502: @728956
     /* 728956 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(729025), // Rule ID 5536 //
     /* 728961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728969 */     // MIs[0] offset
     /* 728969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728972 */     // MIs[0] auxiliary
     /* 728972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728975 */     // MIs[0] Operand 7
     /* 728975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728993 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 728996 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729005 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729023 */     GIR_RootConstrainSelectedInstOperands,
     /* 729024 */     // GIR_Coverage, 5536,
     /* 729024 */     GIR_EraseRootFromParent_Done,
     /* 729025 */   // Label 9503: @729025
     /* 729025 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(729095), // Rule ID 5525 //
     /* 729030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729037 */     // MIs[0] offset
     /* 729037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729040 */     // MIs[0] auxiliary
     /* 729040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729043 */     // MIs[0] Operand 7
     /* 729043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729061 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 729064 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729066 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729093 */     GIR_RootConstrainSelectedInstOperands,
     /* 729094 */     // GIR_Coverage, 5525,
     /* 729094 */     GIR_EraseRootFromParent_Done,
     /* 729095 */   // Label 9504: @729095
     /* 729095 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(729162), // Rule ID 5529 //
     /* 729100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729104 */     // MIs[0] offset
     /* 729104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729107 */     // MIs[0] auxiliary
     /* 729107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729110 */     // MIs[0] Operand 7
     /* 729110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729128 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 729131 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729133 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729142 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729160 */     GIR_RootConstrainSelectedInstOperands,
     /* 729161 */     // GIR_Coverage, 5529,
     /* 729161 */     GIR_EraseRootFromParent_Done,
     /* 729162 */   // Label 9505: @729162
     /* 729162 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(729232), // Rule ID 5533 //
     /* 729167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729174 */     // MIs[0] offset
     /* 729174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729177 */     // MIs[0] auxiliary
     /* 729177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729180 */     // MIs[0] Operand 7
     /* 729180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729198 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 729201 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729203 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729212 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729230 */     GIR_RootConstrainSelectedInstOperands,
     /* 729231 */     // GIR_Coverage, 5533,
     /* 729231 */     GIR_EraseRootFromParent_Done,
     /* 729232 */   // Label 9506: @729232
     /* 729232 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(729299), // Rule ID 5537 //
     /* 729237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729241 */     // MIs[0] offset
     /* 729241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729244 */     // MIs[0] auxiliary
     /* 729244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729247 */     // MIs[0] Operand 7
     /* 729247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729265 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 729268 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729270 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729279 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729297 */     GIR_RootConstrainSelectedInstOperands,
     /* 729298 */     // GIR_Coverage, 5537,
     /* 729298 */     GIR_EraseRootFromParent_Done,
     /* 729299 */   // Label 9507: @729299
     /* 729299 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(729361), // Rule ID 5526 //
     /* 729304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729311 */     // MIs[0] offset
     /* 729311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729314 */     // MIs[0] auxiliary
     /* 729314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729317 */     // MIs[0] Operand 7
     /* 729317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729327 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 729330 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729332 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729341 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729359 */     GIR_RootConstrainSelectedInstOperands,
     /* 729360 */     // GIR_Coverage, 5526,
     /* 729360 */     GIR_EraseRootFromParent_Done,
     /* 729361 */   // Label 9508: @729361
     /* 729361 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(729420), // Rule ID 5530 //
     /* 729366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729370 */     // MIs[0] offset
     /* 729370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729373 */     // MIs[0] auxiliary
     /* 729373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729376 */     // MIs[0] Operand 7
     /* 729376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729386 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 729389 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729391 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729418 */     GIR_RootConstrainSelectedInstOperands,
     /* 729419 */     // GIR_Coverage, 5530,
     /* 729419 */     GIR_EraseRootFromParent_Done,
     /* 729420 */   // Label 9509: @729420
     /* 729420 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(729482), // Rule ID 5534 //
     /* 729425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729432 */     // MIs[0] offset
     /* 729432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729435 */     // MIs[0] auxiliary
     /* 729435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729438 */     // MIs[0] Operand 7
     /* 729438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729448 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 729451 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729453 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729462 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729480 */     GIR_RootConstrainSelectedInstOperands,
     /* 729481 */     // GIR_Coverage, 5534,
     /* 729481 */     GIR_EraseRootFromParent_Done,
     /* 729482 */   // Label 9510: @729482
     /* 729482 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(729541), // Rule ID 5538 //
     /* 729487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729491 */     // MIs[0] offset
     /* 729491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729494 */     // MIs[0] auxiliary
     /* 729494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729497 */     // MIs[0] Operand 7
     /* 729497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729507 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 729510 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729512 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729521 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729539 */     GIR_RootConstrainSelectedInstOperands,
     /* 729540 */     // GIR_Coverage, 5538,
     /* 729540 */     GIR_EraseRootFromParent_Done,
     /* 729541 */   // Label 9511: @729541
     /* 729541 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(729641), // Rule ID 5527 //
     /* 729546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729549 */     // MIs[0] offset
     /* 729549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729552 */     // MIs[0] auxiliary
     /* 729552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729555 */     // MIs[0] Operand 7
     /* 729555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729565 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729581 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729588 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 729609 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729621 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729639 */     GIR_RootConstrainSelectedInstOperands,
     /* 729640 */     // GIR_Coverage, 5527,
     /* 729640 */     GIR_EraseRootFromParent_Done,
     /* 729641 */   // Label 9512: @729641
     /* 729641 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(729738), // Rule ID 5531 //
     /* 729646 */     // MIs[0] offset
     /* 729646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729649 */     // MIs[0] auxiliary
     /* 729649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729652 */     // MIs[0] Operand 7
     /* 729652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729662 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729678 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729685 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 729706 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729718 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729736 */     GIR_RootConstrainSelectedInstOperands,
     /* 729737 */     // GIR_Coverage, 5531,
     /* 729737 */     GIR_EraseRootFromParent_Done,
     /* 729738 */   // Label 9513: @729738
     /* 729738 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(729838), // Rule ID 5535 //
     /* 729743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729746 */     // MIs[0] offset
     /* 729746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729749 */     // MIs[0] auxiliary
     /* 729749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729752 */     // MIs[0] Operand 7
     /* 729752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729762 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729778 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 729806 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729818 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729836 */     GIR_RootConstrainSelectedInstOperands,
     /* 729837 */     // GIR_Coverage, 5535,
     /* 729837 */     GIR_EraseRootFromParent_Done,
     /* 729838 */   // Label 9514: @729838
     /* 729838 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(729935), // Rule ID 5539 //
     /* 729843 */     // MIs[0] offset
     /* 729843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729846 */     // MIs[0] auxiliary
     /* 729846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729849 */     // MIs[0] Operand 7
     /* 729849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729859 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729875 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 729903 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729915 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729933 */     GIR_RootConstrainSelectedInstOperands,
     /* 729934 */     // GIR_Coverage, 5539,
     /* 729934 */     GIR_EraseRootFromParent_Done,
     /* 729935 */   // Label 9515: @729935
     /* 729935 */   GIM_Reject,
     /* 729936 */ // Label 9499: @729936
     /* 729936 */ GIM_Reject,
     /* 729937 */ // Label 9363: @729937
     /* 729937 */ GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(731147),
     /* 729942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 729945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 729948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 729951 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 729954 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(730026), // Rule ID 5492 //
     /* 729959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729970 */     // MIs[0] offset
     /* 729970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729973 */     // MIs[0] auxiliary
     /* 729973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729976 */     // MIs[0] Operand 7
     /* 729976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729994 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 729997 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730006 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730024 */     GIR_RootConstrainSelectedInstOperands,
     /* 730025 */     // GIR_Coverage, 5492,
     /* 730025 */     GIR_EraseRootFromParent_Done,
     /* 730026 */   // Label 9517: @730026
     /* 730026 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(730095), // Rule ID 5496 //
     /* 730031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730039 */     // MIs[0] offset
     /* 730039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730042 */     // MIs[0] auxiliary
     /* 730042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730045 */     // MIs[0] Operand 7
     /* 730045 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730063 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 730066 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730093 */     GIR_RootConstrainSelectedInstOperands,
     /* 730094 */     // GIR_Coverage, 5496,
     /* 730094 */     GIR_EraseRootFromParent_Done,
     /* 730095 */   // Label 9518: @730095
     /* 730095 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(730167), // Rule ID 5500 //
     /* 730100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730111 */     // MIs[0] offset
     /* 730111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730114 */     // MIs[0] auxiliary
     /* 730114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730117 */     // MIs[0] Operand 7
     /* 730117 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730135 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 730138 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730147 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730165 */     GIR_RootConstrainSelectedInstOperands,
     /* 730166 */     // GIR_Coverage, 5500,
     /* 730166 */     GIR_EraseRootFromParent_Done,
     /* 730167 */   // Label 9519: @730167
     /* 730167 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(730236), // Rule ID 5504 //
     /* 730172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730180 */     // MIs[0] offset
     /* 730180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730183 */     // MIs[0] auxiliary
     /* 730183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730186 */     // MIs[0] Operand 7
     /* 730186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730204 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 730207 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730216 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730234 */     GIR_RootConstrainSelectedInstOperands,
     /* 730235 */     // GIR_Coverage, 5504,
     /* 730235 */     GIR_EraseRootFromParent_Done,
     /* 730236 */   // Label 9520: @730236
     /* 730236 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(730306), // Rule ID 5493 //
     /* 730241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730248 */     // MIs[0] offset
     /* 730248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730251 */     // MIs[0] auxiliary
     /* 730251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730254 */     // MIs[0] Operand 7
     /* 730254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730272 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 730275 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730277 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730304 */     GIR_RootConstrainSelectedInstOperands,
     /* 730305 */     // GIR_Coverage, 5493,
     /* 730305 */     GIR_EraseRootFromParent_Done,
     /* 730306 */   // Label 9521: @730306
     /* 730306 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(730373), // Rule ID 5497 //
     /* 730311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730315 */     // MIs[0] offset
     /* 730315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730318 */     // MIs[0] auxiliary
     /* 730318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730321 */     // MIs[0] Operand 7
     /* 730321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730339 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 730342 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730344 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730353 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730371 */     GIR_RootConstrainSelectedInstOperands,
     /* 730372 */     // GIR_Coverage, 5497,
     /* 730372 */     GIR_EraseRootFromParent_Done,
     /* 730373 */   // Label 9522: @730373
     /* 730373 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(730443), // Rule ID 5501 //
     /* 730378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730385 */     // MIs[0] offset
     /* 730385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730388 */     // MIs[0] auxiliary
     /* 730388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730391 */     // MIs[0] Operand 7
     /* 730391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730409 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 730412 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730414 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730423 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730441 */     GIR_RootConstrainSelectedInstOperands,
     /* 730442 */     // GIR_Coverage, 5501,
     /* 730442 */     GIR_EraseRootFromParent_Done,
     /* 730443 */   // Label 9523: @730443
     /* 730443 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(730510), // Rule ID 5505 //
     /* 730448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730452 */     // MIs[0] offset
     /* 730452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730455 */     // MIs[0] auxiliary
     /* 730455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730458 */     // MIs[0] Operand 7
     /* 730458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730476 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 730479 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730481 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730490 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730508 */     GIR_RootConstrainSelectedInstOperands,
     /* 730509 */     // GIR_Coverage, 5505,
     /* 730509 */     GIR_EraseRootFromParent_Done,
     /* 730510 */   // Label 9524: @730510
     /* 730510 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(730572), // Rule ID 5494 //
     /* 730515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730522 */     // MIs[0] offset
     /* 730522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730525 */     // MIs[0] auxiliary
     /* 730525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730528 */     // MIs[0] Operand 7
     /* 730528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730538 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 730541 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730543 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730570 */     GIR_RootConstrainSelectedInstOperands,
     /* 730571 */     // GIR_Coverage, 5494,
     /* 730571 */     GIR_EraseRootFromParent_Done,
     /* 730572 */   // Label 9525: @730572
     /* 730572 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(730631), // Rule ID 5498 //
     /* 730577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730581 */     // MIs[0] offset
     /* 730581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730584 */     // MIs[0] auxiliary
     /* 730584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730587 */     // MIs[0] Operand 7
     /* 730587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730597 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 730600 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730602 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730611 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730629 */     GIR_RootConstrainSelectedInstOperands,
     /* 730630 */     // GIR_Coverage, 5498,
     /* 730630 */     GIR_EraseRootFromParent_Done,
     /* 730631 */   // Label 9526: @730631
     /* 730631 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(730693), // Rule ID 5502 //
     /* 730636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730643 */     // MIs[0] offset
     /* 730643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730646 */     // MIs[0] auxiliary
     /* 730646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730649 */     // MIs[0] Operand 7
     /* 730649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730659 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 730662 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730664 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730673 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730691 */     GIR_RootConstrainSelectedInstOperands,
     /* 730692 */     // GIR_Coverage, 5502,
     /* 730692 */     GIR_EraseRootFromParent_Done,
     /* 730693 */   // Label 9527: @730693
     /* 730693 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(730752), // Rule ID 5506 //
     /* 730698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730702 */     // MIs[0] offset
     /* 730702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730705 */     // MIs[0] auxiliary
     /* 730705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730708 */     // MIs[0] Operand 7
     /* 730708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730718 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 730721 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730723 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730732 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730750 */     GIR_RootConstrainSelectedInstOperands,
     /* 730751 */     // GIR_Coverage, 5506,
     /* 730751 */     GIR_EraseRootFromParent_Done,
     /* 730752 */   // Label 9528: @730752
     /* 730752 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(730852), // Rule ID 5495 //
     /* 730757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730760 */     // MIs[0] offset
     /* 730760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730763 */     // MIs[0] auxiliary
     /* 730763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730766 */     // MIs[0] Operand 7
     /* 730766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730776 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730792 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730799 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 730820 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730832 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730850 */     GIR_RootConstrainSelectedInstOperands,
     /* 730851 */     // GIR_Coverage, 5495,
     /* 730851 */     GIR_EraseRootFromParent_Done,
     /* 730852 */   // Label 9529: @730852
     /* 730852 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(730949), // Rule ID 5499 //
     /* 730857 */     // MIs[0] offset
     /* 730857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730860 */     // MIs[0] auxiliary
     /* 730860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730863 */     // MIs[0] Operand 7
     /* 730863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730873 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730889 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730896 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 730917 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730929 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730947 */     GIR_RootConstrainSelectedInstOperands,
     /* 730948 */     // GIR_Coverage, 5499,
     /* 730948 */     GIR_EraseRootFromParent_Done,
     /* 730949 */   // Label 9530: @730949
     /* 730949 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(731049), // Rule ID 5503 //
     /* 730954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730957 */     // MIs[0] offset
     /* 730957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730960 */     // MIs[0] auxiliary
     /* 730960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730963 */     // MIs[0] Operand 7
     /* 730963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730973 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730989 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730996 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 731017 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731029 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731047 */     GIR_RootConstrainSelectedInstOperands,
     /* 731048 */     // GIR_Coverage, 5503,
     /* 731048 */     GIR_EraseRootFromParent_Done,
     /* 731049 */   // Label 9531: @731049
     /* 731049 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(731146), // Rule ID 5507 //
     /* 731054 */     // MIs[0] offset
     /* 731054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731057 */     // MIs[0] auxiliary
     /* 731057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731060 */     // MIs[0] Operand 7
     /* 731060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731070 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731086 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731093 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 731114 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731126 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731144 */     GIR_RootConstrainSelectedInstOperands,
     /* 731145 */     // GIR_Coverage, 5507,
     /* 731145 */     GIR_EraseRootFromParent_Done,
     /* 731146 */   // Label 9532: @731146
     /* 731146 */   GIM_Reject,
     /* 731147 */ // Label 9516: @731147
     /* 731147 */ GIM_Reject,
     /* 731148 */ // Label 9364: @731148
     /* 731148 */ GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(732358),
     /* 731153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 731156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 731159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 731162 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 731165 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(731237), // Rule ID 5476 //
     /* 731170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731181 */     // MIs[0] offset
     /* 731181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731184 */     // MIs[0] auxiliary
     /* 731184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731187 */     // MIs[0] Operand 7
     /* 731187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731205 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 731208 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731217 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731235 */     GIR_RootConstrainSelectedInstOperands,
     /* 731236 */     // GIR_Coverage, 5476,
     /* 731236 */     GIR_EraseRootFromParent_Done,
     /* 731237 */   // Label 9534: @731237
     /* 731237 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(731306), // Rule ID 5480 //
     /* 731242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731250 */     // MIs[0] offset
     /* 731250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731253 */     // MIs[0] auxiliary
     /* 731253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731256 */     // MIs[0] Operand 7
     /* 731256 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731274 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 731277 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731304 */     GIR_RootConstrainSelectedInstOperands,
     /* 731305 */     // GIR_Coverage, 5480,
     /* 731305 */     GIR_EraseRootFromParent_Done,
     /* 731306 */   // Label 9535: @731306
     /* 731306 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(731378), // Rule ID 5484 //
     /* 731311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731322 */     // MIs[0] offset
     /* 731322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731325 */     // MIs[0] auxiliary
     /* 731325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731328 */     // MIs[0] Operand 7
     /* 731328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731346 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 731349 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731358 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731376 */     GIR_RootConstrainSelectedInstOperands,
     /* 731377 */     // GIR_Coverage, 5484,
     /* 731377 */     GIR_EraseRootFromParent_Done,
     /* 731378 */   // Label 9536: @731378
     /* 731378 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(731447), // Rule ID 5488 //
     /* 731383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731391 */     // MIs[0] offset
     /* 731391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731394 */     // MIs[0] auxiliary
     /* 731394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731397 */     // MIs[0] Operand 7
     /* 731397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731415 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 731418 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731427 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731445 */     GIR_RootConstrainSelectedInstOperands,
     /* 731446 */     // GIR_Coverage, 5488,
     /* 731446 */     GIR_EraseRootFromParent_Done,
     /* 731447 */   // Label 9537: @731447
     /* 731447 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(731517), // Rule ID 5477 //
     /* 731452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731459 */     // MIs[0] offset
     /* 731459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731462 */     // MIs[0] auxiliary
     /* 731462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731465 */     // MIs[0] Operand 7
     /* 731465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731483 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 731486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731488 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731515 */     GIR_RootConstrainSelectedInstOperands,
     /* 731516 */     // GIR_Coverage, 5477,
     /* 731516 */     GIR_EraseRootFromParent_Done,
     /* 731517 */   // Label 9538: @731517
     /* 731517 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(731584), // Rule ID 5481 //
     /* 731522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731526 */     // MIs[0] offset
     /* 731526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731529 */     // MIs[0] auxiliary
     /* 731529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731532 */     // MIs[0] Operand 7
     /* 731532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731550 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 731553 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731555 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731564 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731582 */     GIR_RootConstrainSelectedInstOperands,
     /* 731583 */     // GIR_Coverage, 5481,
     /* 731583 */     GIR_EraseRootFromParent_Done,
     /* 731584 */   // Label 9539: @731584
     /* 731584 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(731654), // Rule ID 5485 //
     /* 731589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731596 */     // MIs[0] offset
     /* 731596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731599 */     // MIs[0] auxiliary
     /* 731599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731602 */     // MIs[0] Operand 7
     /* 731602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731620 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 731623 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731625 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731634 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731652 */     GIR_RootConstrainSelectedInstOperands,
     /* 731653 */     // GIR_Coverage, 5485,
     /* 731653 */     GIR_EraseRootFromParent_Done,
     /* 731654 */   // Label 9540: @731654
     /* 731654 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(731721), // Rule ID 5489 //
     /* 731659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731663 */     // MIs[0] offset
     /* 731663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731666 */     // MIs[0] auxiliary
     /* 731666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731669 */     // MIs[0] Operand 7
     /* 731669 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731687 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 731690 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731692 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731701 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731719 */     GIR_RootConstrainSelectedInstOperands,
     /* 731720 */     // GIR_Coverage, 5489,
     /* 731720 */     GIR_EraseRootFromParent_Done,
     /* 731721 */   // Label 9541: @731721
     /* 731721 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(731783), // Rule ID 5478 //
     /* 731726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731733 */     // MIs[0] offset
     /* 731733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731736 */     // MIs[0] auxiliary
     /* 731736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731739 */     // MIs[0] Operand 7
     /* 731739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731749 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 731752 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731754 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731781 */     GIR_RootConstrainSelectedInstOperands,
     /* 731782 */     // GIR_Coverage, 5478,
     /* 731782 */     GIR_EraseRootFromParent_Done,
     /* 731783 */   // Label 9542: @731783
     /* 731783 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(731842), // Rule ID 5482 //
     /* 731788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731792 */     // MIs[0] offset
     /* 731792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731795 */     // MIs[0] auxiliary
     /* 731795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731798 */     // MIs[0] Operand 7
     /* 731798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731808 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 731811 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731813 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731822 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731840 */     GIR_RootConstrainSelectedInstOperands,
     /* 731841 */     // GIR_Coverage, 5482,
     /* 731841 */     GIR_EraseRootFromParent_Done,
     /* 731842 */   // Label 9543: @731842
     /* 731842 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(731904), // Rule ID 5486 //
     /* 731847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731854 */     // MIs[0] offset
     /* 731854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731857 */     // MIs[0] auxiliary
     /* 731857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731860 */     // MIs[0] Operand 7
     /* 731860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731870 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 731873 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731875 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731902 */     GIR_RootConstrainSelectedInstOperands,
     /* 731903 */     // GIR_Coverage, 5486,
     /* 731903 */     GIR_EraseRootFromParent_Done,
     /* 731904 */   // Label 9544: @731904
     /* 731904 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(731963), // Rule ID 5490 //
     /* 731909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731913 */     // MIs[0] offset
     /* 731913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731916 */     // MIs[0] auxiliary
     /* 731916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731919 */     // MIs[0] Operand 7
     /* 731919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731929 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 731932 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731934 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731943 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731961 */     GIR_RootConstrainSelectedInstOperands,
     /* 731962 */     // GIR_Coverage, 5490,
     /* 731962 */     GIR_EraseRootFromParent_Done,
     /* 731963 */   // Label 9545: @731963
     /* 731963 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(732063), // Rule ID 5479 //
     /* 731968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731971 */     // MIs[0] offset
     /* 731971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731974 */     // MIs[0] auxiliary
     /* 731974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731977 */     // MIs[0] Operand 7
     /* 731977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731987 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732003 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732010 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 732031 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732061 */     GIR_RootConstrainSelectedInstOperands,
     /* 732062 */     // GIR_Coverage, 5479,
     /* 732062 */     GIR_EraseRootFromParent_Done,
     /* 732063 */   // Label 9546: @732063
     /* 732063 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(732160), // Rule ID 5483 //
     /* 732068 */     // MIs[0] offset
     /* 732068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732071 */     // MIs[0] auxiliary
     /* 732071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732074 */     // MIs[0] Operand 7
     /* 732074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732084 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732100 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732107 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 732128 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732140 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732158 */     GIR_RootConstrainSelectedInstOperands,
     /* 732159 */     // GIR_Coverage, 5483,
     /* 732159 */     GIR_EraseRootFromParent_Done,
     /* 732160 */   // Label 9547: @732160
     /* 732160 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(732260), // Rule ID 5487 //
     /* 732165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732168 */     // MIs[0] offset
     /* 732168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732171 */     // MIs[0] auxiliary
     /* 732171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732174 */     // MIs[0] Operand 7
     /* 732174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732184 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732207 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 732228 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732240 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732258 */     GIR_RootConstrainSelectedInstOperands,
     /* 732259 */     // GIR_Coverage, 5487,
     /* 732259 */     GIR_EraseRootFromParent_Done,
     /* 732260 */   // Label 9548: @732260
     /* 732260 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(732357), // Rule ID 5491 //
     /* 732265 */     // MIs[0] offset
     /* 732265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732268 */     // MIs[0] auxiliary
     /* 732268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732271 */     // MIs[0] Operand 7
     /* 732271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732281 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732297 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 732325 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732355 */     GIR_RootConstrainSelectedInstOperands,
     /* 732356 */     // GIR_Coverage, 5491,
     /* 732356 */     GIR_EraseRootFromParent_Done,
     /* 732357 */   // Label 9549: @732357
     /* 732357 */   GIM_Reject,
     /* 732358 */ // Label 9533: @732358
     /* 732358 */ GIM_Reject,
     /* 732359 */ // Label 9365: @732359
     /* 732359 */ GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(733569),
     /* 732364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 732367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 732370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 732373 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 732376 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(732448), // Rule ID 5508 //
     /* 732381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732392 */     // MIs[0] offset
     /* 732392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732395 */     // MIs[0] auxiliary
     /* 732395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732398 */     // MIs[0] Operand 7
     /* 732398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732416 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 732419 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732446 */     GIR_RootConstrainSelectedInstOperands,
     /* 732447 */     // GIR_Coverage, 5508,
     /* 732447 */     GIR_EraseRootFromParent_Done,
     /* 732448 */   // Label 9551: @732448
     /* 732448 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(732517), // Rule ID 5512 //
     /* 732453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732461 */     // MIs[0] offset
     /* 732461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732464 */     // MIs[0] auxiliary
     /* 732464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732467 */     // MIs[0] Operand 7
     /* 732467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732485 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 732488 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732515 */     GIR_RootConstrainSelectedInstOperands,
     /* 732516 */     // GIR_Coverage, 5512,
     /* 732516 */     GIR_EraseRootFromParent_Done,
     /* 732517 */   // Label 9552: @732517
     /* 732517 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(732589), // Rule ID 5516 //
     /* 732522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732533 */     // MIs[0] offset
     /* 732533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732536 */     // MIs[0] auxiliary
     /* 732536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732539 */     // MIs[0] Operand 7
     /* 732539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732557 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 732560 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732587 */     GIR_RootConstrainSelectedInstOperands,
     /* 732588 */     // GIR_Coverage, 5516,
     /* 732588 */     GIR_EraseRootFromParent_Done,
     /* 732589 */   // Label 9553: @732589
     /* 732589 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(732658), // Rule ID 5520 //
     /* 732594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732602 */     // MIs[0] offset
     /* 732602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732605 */     // MIs[0] auxiliary
     /* 732605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732608 */     // MIs[0] Operand 7
     /* 732608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732626 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 732629 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732656 */     GIR_RootConstrainSelectedInstOperands,
     /* 732657 */     // GIR_Coverage, 5520,
     /* 732657 */     GIR_EraseRootFromParent_Done,
     /* 732658 */   // Label 9554: @732658
     /* 732658 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(732728), // Rule ID 5509 //
     /* 732663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732670 */     // MIs[0] offset
     /* 732670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732673 */     // MIs[0] auxiliary
     /* 732673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732676 */     // MIs[0] Operand 7
     /* 732676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732694 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 732697 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732699 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732726 */     GIR_RootConstrainSelectedInstOperands,
     /* 732727 */     // GIR_Coverage, 5509,
     /* 732727 */     GIR_EraseRootFromParent_Done,
     /* 732728 */   // Label 9555: @732728
     /* 732728 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(732795), // Rule ID 5513 //
     /* 732733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732737 */     // MIs[0] offset
     /* 732737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732740 */     // MIs[0] auxiliary
     /* 732740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732743 */     // MIs[0] Operand 7
     /* 732743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732761 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 732764 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732766 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732775 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732793 */     GIR_RootConstrainSelectedInstOperands,
     /* 732794 */     // GIR_Coverage, 5513,
     /* 732794 */     GIR_EraseRootFromParent_Done,
     /* 732795 */   // Label 9556: @732795
     /* 732795 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(732865), // Rule ID 5517 //
     /* 732800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732807 */     // MIs[0] offset
     /* 732807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732810 */     // MIs[0] auxiliary
     /* 732810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732813 */     // MIs[0] Operand 7
     /* 732813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732831 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 732834 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732836 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732845 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732863 */     GIR_RootConstrainSelectedInstOperands,
     /* 732864 */     // GIR_Coverage, 5517,
     /* 732864 */     GIR_EraseRootFromParent_Done,
     /* 732865 */   // Label 9557: @732865
     /* 732865 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(732932), // Rule ID 5521 //
     /* 732870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732874 */     // MIs[0] offset
     /* 732874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732877 */     // MIs[0] auxiliary
     /* 732877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732880 */     // MIs[0] Operand 7
     /* 732880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732898 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 732901 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732903 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732912 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732930 */     GIR_RootConstrainSelectedInstOperands,
     /* 732931 */     // GIR_Coverage, 5521,
     /* 732931 */     GIR_EraseRootFromParent_Done,
     /* 732932 */   // Label 9558: @732932
     /* 732932 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(732994), // Rule ID 5510 //
     /* 732937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732944 */     // MIs[0] offset
     /* 732944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732947 */     // MIs[0] auxiliary
     /* 732947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732950 */     // MIs[0] Operand 7
     /* 732950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732960 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 732963 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732965 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732974 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732992 */     GIR_RootConstrainSelectedInstOperands,
     /* 732993 */     // GIR_Coverage, 5510,
     /* 732993 */     GIR_EraseRootFromParent_Done,
     /* 732994 */   // Label 9559: @732994
     /* 732994 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(733053), // Rule ID 5514 //
     /* 732999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733003 */     // MIs[0] offset
     /* 733003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733006 */     // MIs[0] auxiliary
     /* 733006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733009 */     // MIs[0] Operand 7
     /* 733009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733019 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 733022 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733024 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733051 */     GIR_RootConstrainSelectedInstOperands,
     /* 733052 */     // GIR_Coverage, 5514,
     /* 733052 */     GIR_EraseRootFromParent_Done,
     /* 733053 */   // Label 9560: @733053
     /* 733053 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(733115), // Rule ID 5518 //
     /* 733058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733065 */     // MIs[0] offset
     /* 733065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733068 */     // MIs[0] auxiliary
     /* 733068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733071 */     // MIs[0] Operand 7
     /* 733071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733081 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 733084 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733086 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733095 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733097 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733113 */     GIR_RootConstrainSelectedInstOperands,
     /* 733114 */     // GIR_Coverage, 5518,
     /* 733114 */     GIR_EraseRootFromParent_Done,
     /* 733115 */   // Label 9561: @733115
     /* 733115 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(733174), // Rule ID 5522 //
     /* 733120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733124 */     // MIs[0] offset
     /* 733124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733127 */     // MIs[0] auxiliary
     /* 733127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733130 */     // MIs[0] Operand 7
     /* 733130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733140 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 733143 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733145 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733154 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733172 */     GIR_RootConstrainSelectedInstOperands,
     /* 733173 */     // GIR_Coverage, 5522,
     /* 733173 */     GIR_EraseRootFromParent_Done,
     /* 733174 */   // Label 9562: @733174
     /* 733174 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(733274), // Rule ID 5511 //
     /* 733179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733182 */     // MIs[0] offset
     /* 733182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733185 */     // MIs[0] auxiliary
     /* 733185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733188 */     // MIs[0] Operand 7
     /* 733188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733198 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733210 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733214 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733221 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 733242 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733254 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733272 */     GIR_RootConstrainSelectedInstOperands,
     /* 733273 */     // GIR_Coverage, 5511,
     /* 733273 */     GIR_EraseRootFromParent_Done,
     /* 733274 */   // Label 9563: @733274
     /* 733274 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(733371), // Rule ID 5515 //
     /* 733279 */     // MIs[0] offset
     /* 733279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733282 */     // MIs[0] auxiliary
     /* 733282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733285 */     // MIs[0] Operand 7
     /* 733285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733295 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733318 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 733339 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733351 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733369 */     GIR_RootConstrainSelectedInstOperands,
     /* 733370 */     // GIR_Coverage, 5515,
     /* 733370 */     GIR_EraseRootFromParent_Done,
     /* 733371 */   // Label 9564: @733371
     /* 733371 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(733471), // Rule ID 5519 //
     /* 733376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733379 */     // MIs[0] offset
     /* 733379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733382 */     // MIs[0] auxiliary
     /* 733382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733385 */     // MIs[0] Operand 7
     /* 733385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733395 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733411 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733418 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 733439 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733451 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733469 */     GIR_RootConstrainSelectedInstOperands,
     /* 733470 */     // GIR_Coverage, 5519,
     /* 733470 */     GIR_EraseRootFromParent_Done,
     /* 733471 */   // Label 9565: @733471
     /* 733471 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(733568), // Rule ID 5523 //
     /* 733476 */     // MIs[0] offset
     /* 733476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733479 */     // MIs[0] auxiliary
     /* 733479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733482 */     // MIs[0] Operand 7
     /* 733482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733492 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733508 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733515 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 733536 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733548 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733566 */     GIR_RootConstrainSelectedInstOperands,
     /* 733567 */     // GIR_Coverage, 5523,
     /* 733567 */     GIR_EraseRootFromParent_Done,
     /* 733568 */   // Label 9566: @733568
     /* 733568 */   GIM_Reject,
     /* 733569 */ // Label 9550: @733569
     /* 733569 */ GIM_Reject,
     /* 733570 */ // Label 9366: @733570
     /* 733570 */ GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(734780),
     /* 733575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 733578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 733581 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 733584 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 733587 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(733659), // Rule ID 5540 //
     /* 733592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733603 */     // MIs[0] offset
     /* 733603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733606 */     // MIs[0] auxiliary
     /* 733606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733609 */     // MIs[0] Operand 7
     /* 733609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733627 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 733630 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733639 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733657 */     GIR_RootConstrainSelectedInstOperands,
     /* 733658 */     // GIR_Coverage, 5540,
     /* 733658 */     GIR_EraseRootFromParent_Done,
     /* 733659 */   // Label 9568: @733659
     /* 733659 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(733728), // Rule ID 5544 //
     /* 733664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733672 */     // MIs[0] offset
     /* 733672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733675 */     // MIs[0] auxiliary
     /* 733675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733678 */     // MIs[0] Operand 7
     /* 733678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733696 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 733699 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733726 */     GIR_RootConstrainSelectedInstOperands,
     /* 733727 */     // GIR_Coverage, 5544,
     /* 733727 */     GIR_EraseRootFromParent_Done,
     /* 733728 */   // Label 9569: @733728
     /* 733728 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(733800), // Rule ID 5548 //
     /* 733733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733744 */     // MIs[0] offset
     /* 733744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733747 */     // MIs[0] auxiliary
     /* 733747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733750 */     // MIs[0] Operand 7
     /* 733750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733768 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9784:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 733771 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733798 */     GIR_RootConstrainSelectedInstOperands,
     /* 733799 */     // GIR_Coverage, 5548,
     /* 733799 */     GIR_EraseRootFromParent_Done,
     /* 733800 */   // Label 9570: @733800
     /* 733800 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(733869), // Rule ID 5552 //
     /* 733805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733813 */     // MIs[0] offset
     /* 733813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733816 */     // MIs[0] auxiliary
     /* 733816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733819 */     // MIs[0] Operand 7
     /* 733819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733837 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 733840 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733849 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733867 */     GIR_RootConstrainSelectedInstOperands,
     /* 733868 */     // GIR_Coverage, 5552,
     /* 733868 */     GIR_EraseRootFromParent_Done,
     /* 733869 */   // Label 9571: @733869
     /* 733869 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(733939), // Rule ID 5541 //
     /* 733874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733881 */     // MIs[0] offset
     /* 733881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733884 */     // MIs[0] auxiliary
     /* 733884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733887 */     // MIs[0] Operand 7
     /* 733887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733905 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 733908 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733910 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733919 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733937 */     GIR_RootConstrainSelectedInstOperands,
     /* 733938 */     // GIR_Coverage, 5541,
     /* 733938 */     GIR_EraseRootFromParent_Done,
     /* 733939 */   // Label 9572: @733939
     /* 733939 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(734006), // Rule ID 5545 //
     /* 733944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733948 */     // MIs[0] offset
     /* 733948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733951 */     // MIs[0] auxiliary
     /* 733951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733954 */     // MIs[0] Operand 7
     /* 733954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733972 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 733975 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733977 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733986 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734004 */     GIR_RootConstrainSelectedInstOperands,
     /* 734005 */     // GIR_Coverage, 5545,
     /* 734005 */     GIR_EraseRootFromParent_Done,
     /* 734006 */   // Label 9573: @734006
     /* 734006 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(734076), // Rule ID 5549 //
     /* 734011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734018 */     // MIs[0] offset
     /* 734018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734021 */     // MIs[0] auxiliary
     /* 734021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734024 */     // MIs[0] Operand 7
     /* 734024 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734042 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 734045 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734047 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734056 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734074 */     GIR_RootConstrainSelectedInstOperands,
     /* 734075 */     // GIR_Coverage, 5549,
     /* 734075 */     GIR_EraseRootFromParent_Done,
     /* 734076 */   // Label 9574: @734076
     /* 734076 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(734143), // Rule ID 5553 //
     /* 734081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734085 */     // MIs[0] offset
     /* 734085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734088 */     // MIs[0] auxiliary
     /* 734088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734091 */     // MIs[0] Operand 7
     /* 734091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734109 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 734112 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734114 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734123 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734141 */     GIR_RootConstrainSelectedInstOperands,
     /* 734142 */     // GIR_Coverage, 5553,
     /* 734142 */     GIR_EraseRootFromParent_Done,
     /* 734143 */   // Label 9575: @734143
     /* 734143 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(734205), // Rule ID 5542 //
     /* 734148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734155 */     // MIs[0] offset
     /* 734155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734158 */     // MIs[0] auxiliary
     /* 734158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734161 */     // MIs[0] Operand 7
     /* 734161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734171 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 734174 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734176 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734185 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734203 */     GIR_RootConstrainSelectedInstOperands,
     /* 734204 */     // GIR_Coverage, 5542,
     /* 734204 */     GIR_EraseRootFromParent_Done,
     /* 734205 */   // Label 9576: @734205
     /* 734205 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(734264), // Rule ID 5546 //
     /* 734210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734214 */     // MIs[0] offset
     /* 734214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734217 */     // MIs[0] auxiliary
     /* 734217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734220 */     // MIs[0] Operand 7
     /* 734220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734230 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 734233 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734235 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734262 */     GIR_RootConstrainSelectedInstOperands,
     /* 734263 */     // GIR_Coverage, 5546,
     /* 734263 */     GIR_EraseRootFromParent_Done,
     /* 734264 */   // Label 9577: @734264
     /* 734264 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(734326), // Rule ID 5550 //
     /* 734269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734276 */     // MIs[0] offset
     /* 734276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734279 */     // MIs[0] auxiliary
     /* 734279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734282 */     // MIs[0] Operand 7
     /* 734282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734292 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 734295 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734297 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734306 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734308 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734324 */     GIR_RootConstrainSelectedInstOperands,
     /* 734325 */     // GIR_Coverage, 5550,
     /* 734325 */     GIR_EraseRootFromParent_Done,
     /* 734326 */   // Label 9578: @734326
     /* 734326 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(734385), // Rule ID 5554 //
     /* 734331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734335 */     // MIs[0] offset
     /* 734335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734338 */     // MIs[0] auxiliary
     /* 734338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734341 */     // MIs[0] Operand 7
     /* 734341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734351 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 734354 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734356 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734383 */     GIR_RootConstrainSelectedInstOperands,
     /* 734384 */     // GIR_Coverage, 5554,
     /* 734384 */     GIR_EraseRootFromParent_Done,
     /* 734385 */   // Label 9579: @734385
     /* 734385 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(734485), // Rule ID 5543 //
     /* 734390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734393 */     // MIs[0] offset
     /* 734393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734396 */     // MIs[0] auxiliary
     /* 734396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734399 */     // MIs[0] Operand 7
     /* 734399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734409 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734425 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734432 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 734453 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734465 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734483 */     GIR_RootConstrainSelectedInstOperands,
     /* 734484 */     // GIR_Coverage, 5543,
     /* 734484 */     GIR_EraseRootFromParent_Done,
     /* 734485 */   // Label 9580: @734485
     /* 734485 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(734582), // Rule ID 5547 //
     /* 734490 */     // MIs[0] offset
     /* 734490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734493 */     // MIs[0] auxiliary
     /* 734493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734496 */     // MIs[0] Operand 7
     /* 734496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734506 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734522 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734529 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 734550 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734580 */     GIR_RootConstrainSelectedInstOperands,
     /* 734581 */     // GIR_Coverage, 5547,
     /* 734581 */     GIR_EraseRootFromParent_Done,
     /* 734582 */   // Label 9581: @734582
     /* 734582 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(734682), // Rule ID 5551 //
     /* 734587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734590 */     // MIs[0] offset
     /* 734590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734593 */     // MIs[0] auxiliary
     /* 734593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734596 */     // MIs[0] Operand 7
     /* 734596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734606 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734622 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 734650 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734662 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734680 */     GIR_RootConstrainSelectedInstOperands,
     /* 734681 */     // GIR_Coverage, 5551,
     /* 734681 */     GIR_EraseRootFromParent_Done,
     /* 734682 */   // Label 9582: @734682
     /* 734682 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(734779), // Rule ID 5555 //
     /* 734687 */     // MIs[0] offset
     /* 734687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734690 */     // MIs[0] auxiliary
     /* 734690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734693 */     // MIs[0] Operand 7
     /* 734693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734703 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734719 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734726 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 734747 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734759 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734777 */     GIR_RootConstrainSelectedInstOperands,
     /* 734778 */     // GIR_Coverage, 5555,
     /* 734778 */     GIR_EraseRootFromParent_Done,
     /* 734779 */   // Label 9583: @734779
     /* 734779 */   GIM_Reject,
     /* 734780 */ // Label 9567: @734780
     /* 734780 */ GIM_Reject,
     /* 734781 */ // Label 9367: @734781
     /* 734781 */ GIM_Reject,
     /* 734782 */ // Label 139: @734782
     /* 734782 */ GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(735383),
     /* 734787 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 734790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 734793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 734796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 734799 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 734802 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(735074),
     /* 734807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734811 */     GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(734879), // Rule ID 5556 //
     /* 734816 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734819 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734823 */       // MIs[0] offset
     /* 734823 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734826 */       // MIs[0] auxiliary
     /* 734826 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734829 */       // MIs[0] Operand 7
     /* 734829 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734847 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET_exact),
     /* 734850 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734852 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734854 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734859 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734861 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734867 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734873 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734877 */       GIR_RootConstrainSelectedInstOperands,
     /* 734878 */       // GIR_Coverage, 5556,
     /* 734878 */       GIR_EraseRootFromParent_Done,
     /* 734879 */     // Label 9586: @734879
     /* 734879 */     GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(734944), // Rule ID 5560 //
     /* 734884 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734888 */       // MIs[0] offset
     /* 734888 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734891 */       // MIs[0] auxiliary
     /* 734891 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734894 */       // MIs[0] Operand 7
     /* 734894 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734905 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734912 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734912 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact),
     /* 734915 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734917 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734919 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734924 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734926 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734932 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734938 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734942 */       GIR_RootConstrainSelectedInstOperands,
     /* 734943 */       // GIR_Coverage, 5560,
     /* 734943 */       GIR_EraseRootFromParent_Done,
     /* 734944 */     // Label 9587: @734944
     /* 734944 */     GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(735010), // Rule ID 5557 //
     /* 734949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734952 */       // MIs[0] offset
     /* 734952 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734955 */       // MIs[0] auxiliary
     /* 734955 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734958 */       // MIs[0] Operand 7
     /* 734958 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734969 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734976 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN_exact),
     /* 734979 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734981 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734983 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734985 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734990 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734992 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734998 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735004 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735008 */       GIR_RootConstrainSelectedInstOperands,
     /* 735009 */       // GIR_Coverage, 5557,
     /* 735009 */       GIR_EraseRootFromParent_Done,
     /* 735010 */     // Label 9588: @735010
     /* 735010 */     GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(735073), // Rule ID 5561 //
     /* 735015 */       // MIs[0] offset
     /* 735015 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735018 */       // MIs[0] auxiliary
     /* 735018 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735021 */       // MIs[0] Operand 7
     /* 735021 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735032 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735039 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735039 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact),
     /* 735042 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735044 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735046 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735048 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735053 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735055 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735061 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735067 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735071 */       GIR_RootConstrainSelectedInstOperands,
     /* 735072 */       // GIR_Coverage, 5561,
     /* 735072 */       GIR_EraseRootFromParent_Done,
     /* 735073 */     // Label 9589: @735073
     /* 735073 */     GIM_Reject,
     /* 735074 */   // Label 9585: @735074
     /* 735074 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(735188),
     /* 735079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735092 */     GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(735141), // Rule ID 5558 //
     /* 735097 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735100 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735107 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735107 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_IDXEN_exact),
     /* 735110 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735112 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735114 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735116 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735121 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735123 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735129 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735135 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735139 */       GIR_RootConstrainSelectedInstOperands,
     /* 735140 */       // GIR_Coverage, 5558,
     /* 735140 */       GIR_EraseRootFromParent_Done,
     /* 735141 */     // Label 9591: @735141
     /* 735141 */     GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(735187), // Rule ID 5562 //
     /* 735146 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735153 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735153 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact),
     /* 735156 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735158 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735160 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735162 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735167 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735169 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735175 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735181 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735185 */       GIR_RootConstrainSelectedInstOperands,
     /* 735186 */       // GIR_Coverage, 5562,
     /* 735186 */       GIR_EraseRootFromParent_Done,
     /* 735187 */     // Label 9592: @735187
     /* 735187 */     GIM_Reject,
     /* 735188 */   // Label 9590: @735188
     /* 735188 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(735382),
     /* 735193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735202 */     GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(735293), // Rule ID 5559 //
     /* 735207 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735210 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735217 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735229 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735233 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735236 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735240 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735243 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735248 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735253 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735258 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_BOTHEN_exact),
     /* 735261 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735263 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735266 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735268 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735273 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735275 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735281 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735287 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735291 */       GIR_RootConstrainSelectedInstOperands,
     /* 735292 */       // GIR_Coverage, 5559,
     /* 735292 */       GIR_EraseRootFromParent_Done,
     /* 735293 */     // Label 9594: @735293
     /* 735293 */     GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(735381), // Rule ID 5563 //
     /* 735298 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735305 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735305 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735308 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735312 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735317 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735321 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735328 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735336 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735341 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact),
     /* 735349 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735351 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735354 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735356 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735361 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735363 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735369 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735375 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735379 */       GIR_RootConstrainSelectedInstOperands,
     /* 735380 */       // GIR_Coverage, 5563,
     /* 735380 */       GIR_EraseRootFromParent_Done,
     /* 735381 */     // Label 9595: @735381
     /* 735381 */     GIM_Reject,
     /* 735382 */   // Label 9593: @735382
     /* 735382 */   GIM_Reject,
     /* 735383 */ // Label 9584: @735383
     /* 735383 */ GIM_Reject,
     /* 735384 */ // Label 140: @735384
     /* 735384 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9600*/ GIMT_Encode4(740871),
     /* 735395 */ /*GILLT_s32*//*Label 9596*/ GIMT_Encode4(735431), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 735407 */ /*GILLT_v2s32*//*Label 9597*/ GIMT_Encode4(736642), GIMT_Encode4(0),
     /* 735415 */ /*GILLT_v3s32*//*Label 9598*/ GIMT_Encode4(738449), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 735427 */ /*GILLT_v4s32*//*Label 9599*/ GIMT_Encode4(739660),
     /* 735431 */ // Label 9596: @735431
     /* 735431 */ GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(736641),
     /* 735436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 735439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 735442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 735445 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 735448 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(735520), // Rule ID 5188 //
     /* 735453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735464 */     // MIs[0] offset
     /* 735464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735467 */     // MIs[0] auxiliary
     /* 735467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735470 */     // MIs[0] Operand 7
     /* 735470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735488 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 735491 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735500 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735518 */     GIR_RootConstrainSelectedInstOperands,
     /* 735519 */     // GIR_Coverage, 5188,
     /* 735519 */     GIR_EraseRootFromParent_Done,
     /* 735520 */   // Label 9602: @735520
     /* 735520 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(735589), // Rule ID 5192 //
     /* 735525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735533 */     // MIs[0] offset
     /* 735533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735536 */     // MIs[0] auxiliary
     /* 735536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735539 */     // MIs[0] Operand 7
     /* 735539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735557 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 735560 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735587 */     GIR_RootConstrainSelectedInstOperands,
     /* 735588 */     // GIR_Coverage, 5192,
     /* 735588 */     GIR_EraseRootFromParent_Done,
     /* 735589 */   // Label 9603: @735589
     /* 735589 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(735661), // Rule ID 5196 //
     /* 735594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735605 */     // MIs[0] offset
     /* 735605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735608 */     // MIs[0] auxiliary
     /* 735608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735611 */     // MIs[0] Operand 7
     /* 735611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735629 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 735632 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735641 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735659 */     GIR_RootConstrainSelectedInstOperands,
     /* 735660 */     // GIR_Coverage, 5196,
     /* 735660 */     GIR_EraseRootFromParent_Done,
     /* 735661 */   // Label 9604: @735661
     /* 735661 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(735730), // Rule ID 5200 //
     /* 735666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735674 */     // MIs[0] offset
     /* 735674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735677 */     // MIs[0] auxiliary
     /* 735677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735680 */     // MIs[0] Operand 7
     /* 735680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735698 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 735701 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735710 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735728 */     GIR_RootConstrainSelectedInstOperands,
     /* 735729 */     // GIR_Coverage, 5200,
     /* 735729 */     GIR_EraseRootFromParent_Done,
     /* 735730 */   // Label 9605: @735730
     /* 735730 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(735800), // Rule ID 5189 //
     /* 735735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735742 */     // MIs[0] offset
     /* 735742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735745 */     // MIs[0] auxiliary
     /* 735745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735748 */     // MIs[0] Operand 7
     /* 735748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735766 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 735769 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735771 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735798 */     GIR_RootConstrainSelectedInstOperands,
     /* 735799 */     // GIR_Coverage, 5189,
     /* 735799 */     GIR_EraseRootFromParent_Done,
     /* 735800 */   // Label 9606: @735800
     /* 735800 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(735867), // Rule ID 5193 //
     /* 735805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735809 */     // MIs[0] offset
     /* 735809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735812 */     // MIs[0] auxiliary
     /* 735812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735815 */     // MIs[0] Operand 7
     /* 735815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735833 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 735836 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735838 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735847 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735865 */     GIR_RootConstrainSelectedInstOperands,
     /* 735866 */     // GIR_Coverage, 5193,
     /* 735866 */     GIR_EraseRootFromParent_Done,
     /* 735867 */   // Label 9607: @735867
     /* 735867 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(735937), // Rule ID 5197 //
     /* 735872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735879 */     // MIs[0] offset
     /* 735879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735882 */     // MIs[0] auxiliary
     /* 735882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735885 */     // MIs[0] Operand 7
     /* 735885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735903 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 735906 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735908 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735935 */     GIR_RootConstrainSelectedInstOperands,
     /* 735936 */     // GIR_Coverage, 5197,
     /* 735936 */     GIR_EraseRootFromParent_Done,
     /* 735937 */   // Label 9608: @735937
     /* 735937 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(736004), // Rule ID 5201 //
     /* 735942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735946 */     // MIs[0] offset
     /* 735946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735949 */     // MIs[0] auxiliary
     /* 735949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735952 */     // MIs[0] Operand 7
     /* 735952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735970 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 735973 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735975 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736002 */     GIR_RootConstrainSelectedInstOperands,
     /* 736003 */     // GIR_Coverage, 5201,
     /* 736003 */     GIR_EraseRootFromParent_Done,
     /* 736004 */   // Label 9609: @736004
     /* 736004 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(736066), // Rule ID 5190 //
     /* 736009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736016 */     // MIs[0] offset
     /* 736016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736019 */     // MIs[0] auxiliary
     /* 736019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736022 */     // MIs[0] Operand 7
     /* 736022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736032 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 736035 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736037 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 736039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736046 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736064 */     GIR_RootConstrainSelectedInstOperands,
     /* 736065 */     // GIR_Coverage, 5190,
     /* 736065 */     GIR_EraseRootFromParent_Done,
     /* 736066 */   // Label 9610: @736066
     /* 736066 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(736125), // Rule ID 5194 //
     /* 736071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736075 */     // MIs[0] offset
     /* 736075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736078 */     // MIs[0] auxiliary
     /* 736078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736081 */     // MIs[0] Operand 7
     /* 736081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736091 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 736094 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736096 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 736098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736105 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736123 */     GIR_RootConstrainSelectedInstOperands,
     /* 736124 */     // GIR_Coverage, 5194,
     /* 736124 */     GIR_EraseRootFromParent_Done,
     /* 736125 */   // Label 9611: @736125
     /* 736125 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(736187), // Rule ID 5198 //
     /* 736130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736137 */     // MIs[0] offset
     /* 736137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736140 */     // MIs[0] auxiliary
     /* 736140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736143 */     // MIs[0] Operand 7
     /* 736143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736153 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 736156 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736158 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 736160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736167 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736185 */     GIR_RootConstrainSelectedInstOperands,
     /* 736186 */     // GIR_Coverage, 5198,
     /* 736186 */     GIR_EraseRootFromParent_Done,
     /* 736187 */   // Label 9612: @736187
     /* 736187 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(736246), // Rule ID 5202 //
     /* 736192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736196 */     // MIs[0] offset
     /* 736196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736199 */     // MIs[0] auxiliary
     /* 736199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736202 */     // MIs[0] Operand 7
     /* 736202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736212 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 736215 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736217 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 736219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736226 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736244 */     GIR_RootConstrainSelectedInstOperands,
     /* 736245 */     // GIR_Coverage, 5202,
     /* 736245 */     GIR_EraseRootFromParent_Done,
     /* 736246 */   // Label 9613: @736246
     /* 736246 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(736346), // Rule ID 5191 //
     /* 736251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736254 */     // MIs[0] offset
     /* 736254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736257 */     // MIs[0] auxiliary
     /* 736257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736260 */     // MIs[0] Operand 7
     /* 736260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736270 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736286 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736293 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 736314 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736326 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736344 */     GIR_RootConstrainSelectedInstOperands,
     /* 736345 */     // GIR_Coverage, 5191,
     /* 736345 */     GIR_EraseRootFromParent_Done,
     /* 736346 */   // Label 9614: @736346
     /* 736346 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(736443), // Rule ID 5195 //
     /* 736351 */     // MIs[0] offset
     /* 736351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736354 */     // MIs[0] auxiliary
     /* 736354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736357 */     // MIs[0] Operand 7
     /* 736357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736367 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736383 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736390 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 736411 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736423 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736441 */     GIR_RootConstrainSelectedInstOperands,
     /* 736442 */     // GIR_Coverage, 5195,
     /* 736442 */     GIR_EraseRootFromParent_Done,
     /* 736443 */   // Label 9615: @736443
     /* 736443 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(736543), // Rule ID 5199 //
     /* 736448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736451 */     // MIs[0] offset
     /* 736451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736454 */     // MIs[0] auxiliary
     /* 736454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736457 */     // MIs[0] Operand 7
     /* 736457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736467 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736483 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736490 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 736511 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736523 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736541 */     GIR_RootConstrainSelectedInstOperands,
     /* 736542 */     // GIR_Coverage, 5199,
     /* 736542 */     GIR_EraseRootFromParent_Done,
     /* 736543 */   // Label 9616: @736543
     /* 736543 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(736640), // Rule ID 5203 //
     /* 736548 */     // MIs[0] offset
     /* 736548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736551 */     // MIs[0] auxiliary
     /* 736551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736554 */     // MIs[0] Operand 7
     /* 736554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736564 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736580 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 736608 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736620 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736638 */     GIR_RootConstrainSelectedInstOperands,
     /* 736639 */     // GIR_Coverage, 5203,
     /* 736639 */     GIR_EraseRootFromParent_Done,
     /* 736640 */   // Label 9617: @736640
     /* 736640 */   GIM_Reject,
     /* 736641 */ // Label 9601: @736641
     /* 736641 */ GIM_Reject,
     /* 736642 */ // Label 9597: @736642
     /* 736642 */ GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(738448),
     /* 736647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 736650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 736653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 736656 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 736659 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(736731), // Rule ID 5204 //
     /* 736664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736675 */     // MIs[0] offset
     /* 736675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736678 */     // MIs[0] auxiliary
     /* 736678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736681 */     // MIs[0] Operand 7
     /* 736681 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736699 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736702 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736711 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736713 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736719 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736729 */     GIR_RootConstrainSelectedInstOperands,
     /* 736730 */     // GIR_Coverage, 5204,
     /* 736730 */     GIR_EraseRootFromParent_Done,
     /* 736731 */   // Label 9619: @736731
     /* 736731 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(736800), // Rule ID 5208 //
     /* 736736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736744 */     // MIs[0] offset
     /* 736744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736747 */     // MIs[0] auxiliary
     /* 736747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736750 */     // MIs[0] Operand 7
     /* 736750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736768 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 736771 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736798 */     GIR_RootConstrainSelectedInstOperands,
     /* 736799 */     // GIR_Coverage, 5208,
     /* 736799 */     GIR_EraseRootFromParent_Done,
     /* 736800 */   // Label 9620: @736800
     /* 736800 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(736872), // Rule ID 5212 //
     /* 736805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736816 */     // MIs[0] offset
     /* 736816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736819 */     // MIs[0] auxiliary
     /* 736819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736822 */     // MIs[0] Operand 7
     /* 736822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736840 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736843 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736870 */     GIR_RootConstrainSelectedInstOperands,
     /* 736871 */     // GIR_Coverage, 5212,
     /* 736871 */     GIR_EraseRootFromParent_Done,
     /* 736872 */   // Label 9621: @736872
     /* 736872 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(736941), // Rule ID 5216 //
     /* 736877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736885 */     // MIs[0] offset
     /* 736885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736888 */     // MIs[0] auxiliary
     /* 736888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736891 */     // MIs[0] Operand 7
     /* 736891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736909 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 736912 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736921 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736939 */     GIR_RootConstrainSelectedInstOperands,
     /* 736940 */     // GIR_Coverage, 5216,
     /* 736940 */     GIR_EraseRootFromParent_Done,
     /* 736941 */   // Label 9622: @736941
     /* 736941 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(737013), // Rule ID 5220 //
     /* 736946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736957 */     // MIs[0] offset
     /* 736957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736960 */     // MIs[0] auxiliary
     /* 736960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736963 */     // MIs[0] Operand 7
     /* 736963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736981 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736984 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737011 */     GIR_RootConstrainSelectedInstOperands,
     /* 737012 */     // GIR_Coverage, 5220,
     /* 737012 */     GIR_EraseRootFromParent_Done,
     /* 737013 */   // Label 9623: @737013
     /* 737013 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(737082), // Rule ID 5224 //
     /* 737018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737026 */     // MIs[0] offset
     /* 737026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737029 */     // MIs[0] auxiliary
     /* 737029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737032 */     // MIs[0] Operand 7
     /* 737032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737050 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 737053 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737080 */     GIR_RootConstrainSelectedInstOperands,
     /* 737081 */     // GIR_Coverage, 5224,
     /* 737081 */     GIR_EraseRootFromParent_Done,
     /* 737082 */   // Label 9624: @737082
     /* 737082 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(737152), // Rule ID 5205 //
     /* 737087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737094 */     // MIs[0] offset
     /* 737094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737097 */     // MIs[0] auxiliary
     /* 737097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737100 */     // MIs[0] Operand 7
     /* 737100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737118 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 737121 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737123 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737150 */     GIR_RootConstrainSelectedInstOperands,
     /* 737151 */     // GIR_Coverage, 5205,
     /* 737151 */     GIR_EraseRootFromParent_Done,
     /* 737152 */   // Label 9625: @737152
     /* 737152 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(737219), // Rule ID 5209 //
     /* 737157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737161 */     // MIs[0] offset
     /* 737161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737164 */     // MIs[0] auxiliary
     /* 737164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737167 */     // MIs[0] Operand 7
     /* 737167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737185 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 737188 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737190 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737217 */     GIR_RootConstrainSelectedInstOperands,
     /* 737218 */     // GIR_Coverage, 5209,
     /* 737218 */     GIR_EraseRootFromParent_Done,
     /* 737219 */   // Label 9626: @737219
     /* 737219 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(737289), // Rule ID 5213 //
     /* 737224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737231 */     // MIs[0] offset
     /* 737231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737234 */     // MIs[0] auxiliary
     /* 737234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737237 */     // MIs[0] Operand 7
     /* 737237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737255 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 737258 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737260 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737287 */     GIR_RootConstrainSelectedInstOperands,
     /* 737288 */     // GIR_Coverage, 5213,
     /* 737288 */     GIR_EraseRootFromParent_Done,
     /* 737289 */   // Label 9627: @737289
     /* 737289 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(737356), // Rule ID 5217 //
     /* 737294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737298 */     // MIs[0] offset
     /* 737298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737301 */     // MIs[0] auxiliary
     /* 737301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737304 */     // MIs[0] Operand 7
     /* 737304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737322 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 737325 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737327 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737336 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737354 */     GIR_RootConstrainSelectedInstOperands,
     /* 737355 */     // GIR_Coverage, 5217,
     /* 737355 */     GIR_EraseRootFromParent_Done,
     /* 737356 */   // Label 9628: @737356
     /* 737356 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(737426), // Rule ID 5221 //
     /* 737361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737368 */     // MIs[0] offset
     /* 737368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737371 */     // MIs[0] auxiliary
     /* 737371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737374 */     // MIs[0] Operand 7
     /* 737374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737392 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 737395 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737397 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737406 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737424 */     GIR_RootConstrainSelectedInstOperands,
     /* 737425 */     // GIR_Coverage, 5221,
     /* 737425 */     GIR_EraseRootFromParent_Done,
     /* 737426 */   // Label 9629: @737426
     /* 737426 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(737493), // Rule ID 5225 //
     /* 737431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737435 */     // MIs[0] offset
     /* 737435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737438 */     // MIs[0] auxiliary
     /* 737438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737441 */     // MIs[0] Operand 7
     /* 737441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737459 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 737462 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737464 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737473 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737491 */     GIR_RootConstrainSelectedInstOperands,
     /* 737492 */     // GIR_Coverage, 5225,
     /* 737492 */     GIR_EraseRootFromParent_Done,
     /* 737493 */   // Label 9630: @737493
     /* 737493 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(737555), // Rule ID 5206 //
     /* 737498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737505 */     // MIs[0] offset
     /* 737505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737508 */     // MIs[0] auxiliary
     /* 737508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737511 */     // MIs[0] Operand 7
     /* 737511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737521 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737524 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737526 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737535 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737553 */     GIR_RootConstrainSelectedInstOperands,
     /* 737554 */     // GIR_Coverage, 5206,
     /* 737554 */     GIR_EraseRootFromParent_Done,
     /* 737555 */   // Label 9631: @737555
     /* 737555 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(737614), // Rule ID 5210 //
     /* 737560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737564 */     // MIs[0] offset
     /* 737564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737567 */     // MIs[0] auxiliary
     /* 737567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737570 */     // MIs[0] Operand 7
     /* 737570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737580 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737583 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737585 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737594 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737612 */     GIR_RootConstrainSelectedInstOperands,
     /* 737613 */     // GIR_Coverage, 5210,
     /* 737613 */     GIR_EraseRootFromParent_Done,
     /* 737614 */   // Label 9632: @737614
     /* 737614 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(737676), // Rule ID 5214 //
     /* 737619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737626 */     // MIs[0] offset
     /* 737626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737629 */     // MIs[0] auxiliary
     /* 737629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737632 */     // MIs[0] Operand 7
     /* 737632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737642 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737645 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737647 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737674 */     GIR_RootConstrainSelectedInstOperands,
     /* 737675 */     // GIR_Coverage, 5214,
     /* 737675 */     GIR_EraseRootFromParent_Done,
     /* 737676 */   // Label 9633: @737676
     /* 737676 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(737735), // Rule ID 5218 //
     /* 737681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737685 */     // MIs[0] offset
     /* 737685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737688 */     // MIs[0] auxiliary
     /* 737688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737691 */     // MIs[0] Operand 7
     /* 737691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737701 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737704 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737706 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737733 */     GIR_RootConstrainSelectedInstOperands,
     /* 737734 */     // GIR_Coverage, 5218,
     /* 737734 */     GIR_EraseRootFromParent_Done,
     /* 737735 */   // Label 9634: @737735
     /* 737735 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(737797), // Rule ID 5222 //
     /* 737740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737747 */     // MIs[0] offset
     /* 737747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737750 */     // MIs[0] auxiliary
     /* 737750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737753 */     // MIs[0] Operand 7
     /* 737753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737763 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737766 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737768 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737795 */     GIR_RootConstrainSelectedInstOperands,
     /* 737796 */     // GIR_Coverage, 5222,
     /* 737796 */     GIR_EraseRootFromParent_Done,
     /* 737797 */   // Label 9635: @737797
     /* 737797 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(737856), // Rule ID 5226 //
     /* 737802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737806 */     // MIs[0] offset
     /* 737806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737809 */     // MIs[0] auxiliary
     /* 737809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737812 */     // MIs[0] Operand 7
     /* 737812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737822 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737825 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737827 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737836 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737854 */     GIR_RootConstrainSelectedInstOperands,
     /* 737855 */     // GIR_Coverage, 5226,
     /* 737855 */     GIR_EraseRootFromParent_Done,
     /* 737856 */   // Label 9636: @737856
     /* 737856 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(737956), // Rule ID 5207 //
     /* 737861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737864 */     // MIs[0] offset
     /* 737864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737867 */     // MIs[0] auxiliary
     /* 737867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737870 */     // MIs[0] Operand 7
     /* 737870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737880 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737896 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737903 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 737924 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737936 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737954 */     GIR_RootConstrainSelectedInstOperands,
     /* 737955 */     // GIR_Coverage, 5207,
     /* 737955 */     GIR_EraseRootFromParent_Done,
     /* 737956 */   // Label 9637: @737956
     /* 737956 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(738053), // Rule ID 5211 //
     /* 737961 */     // MIs[0] offset
     /* 737961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737964 */     // MIs[0] auxiliary
     /* 737964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737967 */     // MIs[0] Operand 7
     /* 737967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737977 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737993 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738000 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 738021 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738051 */     GIR_RootConstrainSelectedInstOperands,
     /* 738052 */     // GIR_Coverage, 5211,
     /* 738052 */     GIR_EraseRootFromParent_Done,
     /* 738053 */   // Label 9638: @738053
     /* 738053 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(738153), // Rule ID 5215 //
     /* 738058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738061 */     // MIs[0] offset
     /* 738061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738064 */     // MIs[0] auxiliary
     /* 738064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738067 */     // MIs[0] Operand 7
     /* 738067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738077 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738093 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738100 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 738121 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738151 */     GIR_RootConstrainSelectedInstOperands,
     /* 738152 */     // GIR_Coverage, 5215,
     /* 738152 */     GIR_EraseRootFromParent_Done,
     /* 738153 */   // Label 9639: @738153
     /* 738153 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(738250), // Rule ID 5219 //
     /* 738158 */     // MIs[0] offset
     /* 738158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738161 */     // MIs[0] auxiliary
     /* 738161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738164 */     // MIs[0] Operand 7
     /* 738164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738174 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738190 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738197 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 738218 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738248 */     GIR_RootConstrainSelectedInstOperands,
     /* 738249 */     // GIR_Coverage, 5219,
     /* 738249 */     GIR_EraseRootFromParent_Done,
     /* 738250 */   // Label 9640: @738250
     /* 738250 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(738350), // Rule ID 5223 //
     /* 738255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738258 */     // MIs[0] offset
     /* 738258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738261 */     // MIs[0] auxiliary
     /* 738261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738264 */     // MIs[0] Operand 7
     /* 738264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738274 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738290 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738297 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 738318 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738330 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738348 */     GIR_RootConstrainSelectedInstOperands,
     /* 738349 */     // GIR_Coverage, 5223,
     /* 738349 */     GIR_EraseRootFromParent_Done,
     /* 738350 */   // Label 9641: @738350
     /* 738350 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(738447), // Rule ID 5227 //
     /* 738355 */     // MIs[0] offset
     /* 738355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738358 */     // MIs[0] auxiliary
     /* 738358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738361 */     // MIs[0] Operand 7
     /* 738361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738371 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738387 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738394 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 738415 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738427 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738445 */     GIR_RootConstrainSelectedInstOperands,
     /* 738446 */     // GIR_Coverage, 5227,
     /* 738446 */     GIR_EraseRootFromParent_Done,
     /* 738447 */   // Label 9642: @738447
     /* 738447 */   GIM_Reject,
     /* 738448 */ // Label 9618: @738448
     /* 738448 */ GIM_Reject,
     /* 738449 */ // Label 9598: @738449
     /* 738449 */ GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(739659),
     /* 738454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 738457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 738460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 738463 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 738466 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(738538), // Rule ID 5228 //
     /* 738471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738482 */     // MIs[0] offset
     /* 738482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738485 */     // MIs[0] auxiliary
     /* 738485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738488 */     // MIs[0] Operand 7
     /* 738488 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738506 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 738509 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738518 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738536 */     GIR_RootConstrainSelectedInstOperands,
     /* 738537 */     // GIR_Coverage, 5228,
     /* 738537 */     GIR_EraseRootFromParent_Done,
     /* 738538 */   // Label 9644: @738538
     /* 738538 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(738607), // Rule ID 5232 //
     /* 738543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738551 */     // MIs[0] offset
     /* 738551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738554 */     // MIs[0] auxiliary
     /* 738554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738557 */     // MIs[0] Operand 7
     /* 738557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738575 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 738578 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738587 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738589 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738605 */     GIR_RootConstrainSelectedInstOperands,
     /* 738606 */     // GIR_Coverage, 5232,
     /* 738606 */     GIR_EraseRootFromParent_Done,
     /* 738607 */   // Label 9645: @738607
     /* 738607 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(738679), // Rule ID 5236 //
     /* 738612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738623 */     // MIs[0] offset
     /* 738623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738626 */     // MIs[0] auxiliary
     /* 738626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738629 */     // MIs[0] Operand 7
     /* 738629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738647 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 738650 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738659 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738677 */     GIR_RootConstrainSelectedInstOperands,
     /* 738678 */     // GIR_Coverage, 5236,
     /* 738678 */     GIR_EraseRootFromParent_Done,
     /* 738679 */   // Label 9646: @738679
     /* 738679 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(738748), // Rule ID 5240 //
     /* 738684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738692 */     // MIs[0] offset
     /* 738692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738695 */     // MIs[0] auxiliary
     /* 738695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738698 */     // MIs[0] Operand 7
     /* 738698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738716 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 738719 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738728 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738746 */     GIR_RootConstrainSelectedInstOperands,
     /* 738747 */     // GIR_Coverage, 5240,
     /* 738747 */     GIR_EraseRootFromParent_Done,
     /* 738748 */   // Label 9647: @738748
     /* 738748 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(738818), // Rule ID 5229 //
     /* 738753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738760 */     // MIs[0] offset
     /* 738760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738763 */     // MIs[0] auxiliary
     /* 738763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738766 */     // MIs[0] Operand 7
     /* 738766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738784 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 738787 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738789 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738798 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738816 */     GIR_RootConstrainSelectedInstOperands,
     /* 738817 */     // GIR_Coverage, 5229,
     /* 738817 */     GIR_EraseRootFromParent_Done,
     /* 738818 */   // Label 9648: @738818
     /* 738818 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(738885), // Rule ID 5233 //
     /* 738823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738827 */     // MIs[0] offset
     /* 738827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738830 */     // MIs[0] auxiliary
     /* 738830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738833 */     // MIs[0] Operand 7
     /* 738833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738851 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 738854 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738856 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738865 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738883 */     GIR_RootConstrainSelectedInstOperands,
     /* 738884 */     // GIR_Coverage, 5233,
     /* 738884 */     GIR_EraseRootFromParent_Done,
     /* 738885 */   // Label 9649: @738885
     /* 738885 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(738955), // Rule ID 5237 //
     /* 738890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738897 */     // MIs[0] offset
     /* 738897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738900 */     // MIs[0] auxiliary
     /* 738900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738903 */     // MIs[0] Operand 7
     /* 738903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738921 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 738924 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738926 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738935 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738953 */     GIR_RootConstrainSelectedInstOperands,
     /* 738954 */     // GIR_Coverage, 5237,
     /* 738954 */     GIR_EraseRootFromParent_Done,
     /* 738955 */   // Label 9650: @738955
     /* 738955 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(739022), // Rule ID 5241 //
     /* 738960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738964 */     // MIs[0] offset
     /* 738964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738967 */     // MIs[0] auxiliary
     /* 738967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738970 */     // MIs[0] Operand 7
     /* 738970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738988 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 738991 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738993 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739002 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739020 */     GIR_RootConstrainSelectedInstOperands,
     /* 739021 */     // GIR_Coverage, 5241,
     /* 739021 */     GIR_EraseRootFromParent_Done,
     /* 739022 */   // Label 9651: @739022
     /* 739022 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(739084), // Rule ID 5230 //
     /* 739027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739034 */     // MIs[0] offset
     /* 739034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739037 */     // MIs[0] auxiliary
     /* 739037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739040 */     // MIs[0] Operand 7
     /* 739040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739050 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 739053 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739055 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739064 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739082 */     GIR_RootConstrainSelectedInstOperands,
     /* 739083 */     // GIR_Coverage, 5230,
     /* 739083 */     GIR_EraseRootFromParent_Done,
     /* 739084 */   // Label 9652: @739084
     /* 739084 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(739143), // Rule ID 5234 //
     /* 739089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739093 */     // MIs[0] offset
     /* 739093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739096 */     // MIs[0] auxiliary
     /* 739096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739099 */     // MIs[0] Operand 7
     /* 739099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739109 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 739112 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739114 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739123 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739141 */     GIR_RootConstrainSelectedInstOperands,
     /* 739142 */     // GIR_Coverage, 5234,
     /* 739142 */     GIR_EraseRootFromParent_Done,
     /* 739143 */   // Label 9653: @739143
     /* 739143 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(739205), // Rule ID 5238 //
     /* 739148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739155 */     // MIs[0] offset
     /* 739155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739158 */     // MIs[0] auxiliary
     /* 739158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739161 */     // MIs[0] Operand 7
     /* 739161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739171 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 739174 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739176 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739185 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739203 */     GIR_RootConstrainSelectedInstOperands,
     /* 739204 */     // GIR_Coverage, 5238,
     /* 739204 */     GIR_EraseRootFromParent_Done,
     /* 739205 */   // Label 9654: @739205
     /* 739205 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(739264), // Rule ID 5242 //
     /* 739210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739214 */     // MIs[0] offset
     /* 739214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739217 */     // MIs[0] auxiliary
     /* 739217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739220 */     // MIs[0] Operand 7
     /* 739220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739230 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 739233 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739235 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739262 */     GIR_RootConstrainSelectedInstOperands,
     /* 739263 */     // GIR_Coverage, 5242,
     /* 739263 */     GIR_EraseRootFromParent_Done,
     /* 739264 */   // Label 9655: @739264
     /* 739264 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(739364), // Rule ID 5231 //
     /* 739269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739272 */     // MIs[0] offset
     /* 739272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739275 */     // MIs[0] auxiliary
     /* 739275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739278 */     // MIs[0] Operand 7
     /* 739278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739288 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 739332 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739344 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739362 */     GIR_RootConstrainSelectedInstOperands,
     /* 739363 */     // GIR_Coverage, 5231,
     /* 739363 */     GIR_EraseRootFromParent_Done,
     /* 739364 */   // Label 9656: @739364
     /* 739364 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(739461), // Rule ID 5235 //
     /* 739369 */     // MIs[0] offset
     /* 739369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739372 */     // MIs[0] auxiliary
     /* 739372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739375 */     // MIs[0] Operand 7
     /* 739375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739385 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739401 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739408 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 739429 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739441 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739459 */     GIR_RootConstrainSelectedInstOperands,
     /* 739460 */     // GIR_Coverage, 5235,
     /* 739460 */     GIR_EraseRootFromParent_Done,
     /* 739461 */   // Label 9657: @739461
     /* 739461 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(739561), // Rule ID 5239 //
     /* 739466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739469 */     // MIs[0] offset
     /* 739469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739472 */     // MIs[0] auxiliary
     /* 739472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739475 */     // MIs[0] Operand 7
     /* 739475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739485 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739501 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739508 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 739529 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739541 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739559 */     GIR_RootConstrainSelectedInstOperands,
     /* 739560 */     // GIR_Coverage, 5239,
     /* 739560 */     GIR_EraseRootFromParent_Done,
     /* 739561 */   // Label 9658: @739561
     /* 739561 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(739658), // Rule ID 5243 //
     /* 739566 */     // MIs[0] offset
     /* 739566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739569 */     // MIs[0] auxiliary
     /* 739569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739572 */     // MIs[0] Operand 7
     /* 739572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739582 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739605 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 739626 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739656 */     GIR_RootConstrainSelectedInstOperands,
     /* 739657 */     // GIR_Coverage, 5243,
     /* 739657 */     GIR_EraseRootFromParent_Done,
     /* 739658 */   // Label 9659: @739658
     /* 739658 */   GIM_Reject,
     /* 739659 */ // Label 9643: @739659
     /* 739659 */ GIM_Reject,
     /* 739660 */ // Label 9599: @739660
     /* 739660 */ GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(740870),
     /* 739665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 739668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 739671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 739674 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 739677 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(739749), // Rule ID 5244 //
     /* 739682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739693 */     // MIs[0] offset
     /* 739693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739696 */     // MIs[0] auxiliary
     /* 739696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739699 */     // MIs[0] Operand 7
     /* 739699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739717 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 739720 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739729 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739747 */     GIR_RootConstrainSelectedInstOperands,
     /* 739748 */     // GIR_Coverage, 5244,
     /* 739748 */     GIR_EraseRootFromParent_Done,
     /* 739749 */   // Label 9661: @739749
     /* 739749 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(739818), // Rule ID 5248 //
     /* 739754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739762 */     // MIs[0] offset
     /* 739762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739765 */     // MIs[0] auxiliary
     /* 739765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739768 */     // MIs[0] Operand 7
     /* 739768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739786 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 739789 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739798 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739816 */     GIR_RootConstrainSelectedInstOperands,
     /* 739817 */     // GIR_Coverage, 5248,
     /* 739817 */     GIR_EraseRootFromParent_Done,
     /* 739818 */   // Label 9662: @739818
     /* 739818 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(739890), // Rule ID 5252 //
     /* 739823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739834 */     // MIs[0] offset
     /* 739834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739837 */     // MIs[0] auxiliary
     /* 739837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739840 */     // MIs[0] Operand 7
     /* 739840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739858 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 739861 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739870 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739888 */     GIR_RootConstrainSelectedInstOperands,
     /* 739889 */     // GIR_Coverage, 5252,
     /* 739889 */     GIR_EraseRootFromParent_Done,
     /* 739890 */   // Label 9663: @739890
     /* 739890 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(739959), // Rule ID 5256 //
     /* 739895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739903 */     // MIs[0] offset
     /* 739903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739906 */     // MIs[0] auxiliary
     /* 739906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739909 */     // MIs[0] Operand 7
     /* 739909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739927 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 739930 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739939 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739957 */     GIR_RootConstrainSelectedInstOperands,
     /* 739958 */     // GIR_Coverage, 5256,
     /* 739958 */     GIR_EraseRootFromParent_Done,
     /* 739959 */   // Label 9664: @739959
     /* 739959 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(740029), // Rule ID 5245 //
     /* 739964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739971 */     // MIs[0] offset
     /* 739971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739974 */     // MIs[0] auxiliary
     /* 739974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739977 */     // MIs[0] Operand 7
     /* 739977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739995 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 739998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740000 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740009 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740027 */     GIR_RootConstrainSelectedInstOperands,
     /* 740028 */     // GIR_Coverage, 5245,
     /* 740028 */     GIR_EraseRootFromParent_Done,
     /* 740029 */   // Label 9665: @740029
     /* 740029 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(740096), // Rule ID 5249 //
     /* 740034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740038 */     // MIs[0] offset
     /* 740038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740041 */     // MIs[0] auxiliary
     /* 740041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740044 */     // MIs[0] Operand 7
     /* 740044 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740062 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 740065 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740067 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740076 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740094 */     GIR_RootConstrainSelectedInstOperands,
     /* 740095 */     // GIR_Coverage, 5249,
     /* 740095 */     GIR_EraseRootFromParent_Done,
     /* 740096 */   // Label 9666: @740096
     /* 740096 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(740166), // Rule ID 5253 //
     /* 740101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740108 */     // MIs[0] offset
     /* 740108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740111 */     // MIs[0] auxiliary
     /* 740111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740114 */     // MIs[0] Operand 7
     /* 740114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740132 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 740135 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740137 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740146 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740164 */     GIR_RootConstrainSelectedInstOperands,
     /* 740165 */     // GIR_Coverage, 5253,
     /* 740165 */     GIR_EraseRootFromParent_Done,
     /* 740166 */   // Label 9667: @740166
     /* 740166 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(740233), // Rule ID 5257 //
     /* 740171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740175 */     // MIs[0] offset
     /* 740175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740178 */     // MIs[0] auxiliary
     /* 740178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740181 */     // MIs[0] Operand 7
     /* 740181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740199 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 740202 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740204 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740213 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740231 */     GIR_RootConstrainSelectedInstOperands,
     /* 740232 */     // GIR_Coverage, 5257,
     /* 740232 */     GIR_EraseRootFromParent_Done,
     /* 740233 */   // Label 9668: @740233
     /* 740233 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(740295), // Rule ID 5246 //
     /* 740238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740245 */     // MIs[0] offset
     /* 740245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740248 */     // MIs[0] auxiliary
     /* 740248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740251 */     // MIs[0] Operand 7
     /* 740251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740261 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 740264 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740266 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740275 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740293 */     GIR_RootConstrainSelectedInstOperands,
     /* 740294 */     // GIR_Coverage, 5246,
     /* 740294 */     GIR_EraseRootFromParent_Done,
     /* 740295 */   // Label 9669: @740295
     /* 740295 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(740354), // Rule ID 5250 //
     /* 740300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740304 */     // MIs[0] offset
     /* 740304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740307 */     // MIs[0] auxiliary
     /* 740307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740310 */     // MIs[0] Operand 7
     /* 740310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740320 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 740323 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740325 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740334 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740352 */     GIR_RootConstrainSelectedInstOperands,
     /* 740353 */     // GIR_Coverage, 5250,
     /* 740353 */     GIR_EraseRootFromParent_Done,
     /* 740354 */   // Label 9670: @740354
     /* 740354 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(740416), // Rule ID 5254 //
     /* 740359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740366 */     // MIs[0] offset
     /* 740366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740369 */     // MIs[0] auxiliary
     /* 740369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740372 */     // MIs[0] Operand 7
     /* 740372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740382 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 740385 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740387 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740396 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740414 */     GIR_RootConstrainSelectedInstOperands,
     /* 740415 */     // GIR_Coverage, 5254,
     /* 740415 */     GIR_EraseRootFromParent_Done,
     /* 740416 */   // Label 9671: @740416
     /* 740416 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(740475), // Rule ID 5258 //
     /* 740421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740425 */     // MIs[0] offset
     /* 740425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740428 */     // MIs[0] auxiliary
     /* 740428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740431 */     // MIs[0] Operand 7
     /* 740431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740441 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 740444 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740446 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740455 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740473 */     GIR_RootConstrainSelectedInstOperands,
     /* 740474 */     // GIR_Coverage, 5258,
     /* 740474 */     GIR_EraseRootFromParent_Done,
     /* 740475 */   // Label 9672: @740475
     /* 740475 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(740575), // Rule ID 5247 //
     /* 740480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740483 */     // MIs[0] offset
     /* 740483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740486 */     // MIs[0] auxiliary
     /* 740486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740489 */     // MIs[0] Operand 7
     /* 740489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740499 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740515 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740522 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 740543 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740555 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740573 */     GIR_RootConstrainSelectedInstOperands,
     /* 740574 */     // GIR_Coverage, 5247,
     /* 740574 */     GIR_EraseRootFromParent_Done,
     /* 740575 */   // Label 9673: @740575
     /* 740575 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(740672), // Rule ID 5251 //
     /* 740580 */     // MIs[0] offset
     /* 740580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740583 */     // MIs[0] auxiliary
     /* 740583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740586 */     // MIs[0] Operand 7
     /* 740586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740596 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740612 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740619 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 740640 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740652 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740670 */     GIR_RootConstrainSelectedInstOperands,
     /* 740671 */     // GIR_Coverage, 5251,
     /* 740671 */     GIR_EraseRootFromParent_Done,
     /* 740672 */   // Label 9674: @740672
     /* 740672 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(740772), // Rule ID 5255 //
     /* 740677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740680 */     // MIs[0] offset
     /* 740680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740683 */     // MIs[0] auxiliary
     /* 740683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740686 */     // MIs[0] Operand 7
     /* 740686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740696 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740712 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740719 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 740740 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740770 */     GIR_RootConstrainSelectedInstOperands,
     /* 740771 */     // GIR_Coverage, 5255,
     /* 740771 */     GIR_EraseRootFromParent_Done,
     /* 740772 */   // Label 9675: @740772
     /* 740772 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(740869), // Rule ID 5259 //
     /* 740777 */     // MIs[0] offset
     /* 740777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740780 */     // MIs[0] auxiliary
     /* 740780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740783 */     // MIs[0] Operand 7
     /* 740783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740793 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740809 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740816 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 740837 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740849 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740867 */     GIR_RootConstrainSelectedInstOperands,
     /* 740868 */     // GIR_Coverage, 5259,
     /* 740868 */     GIR_EraseRootFromParent_Done,
     /* 740869 */   // Label 9676: @740869
     /* 740869 */   GIM_Reject,
     /* 740870 */ // Label 9660: @740870
     /* 740870 */ GIM_Reject,
     /* 740871 */ // Label 9600: @740871
     /* 740871 */ GIM_Reject,
     /* 740872 */ // Label 141: @740872
     /* 740872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9684*/ GIMT_Encode4(747136),
     /* 740883 */ /*GILLT_s16*//*Label 9677*/ GIMT_Encode4(740923),
     /* 740887 */ /*GILLT_s32*//*Label 9678*/ GIMT_Encode4(742766), GIMT_Encode4(0),
     /* 740895 */ /*GILLT_v2s16*//*Label 9679*/ GIMT_Encode4(743697),
     /* 740899 */ /*GILLT_v2s32*//*Label 9680*/ GIMT_Encode4(744932), GIMT_Encode4(0),
     /* 740907 */ /*GILLT_v3s32*//*Label 9681*/ GIMT_Encode4(745255), GIMT_Encode4(0),
     /* 740915 */ /*GILLT_v4s16*//*Label 9682*/ GIMT_Encode4(745578),
     /* 740919 */ /*GILLT_v4s32*//*Label 9683*/ GIMT_Encode4(746813),
     /* 740923 */ // Label 9677: @740923
     /* 740923 */ GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(742765),
     /* 740928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 740931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 740934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 740937 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 740940 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(741012), // Rule ID 5260 //
     /* 740945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 740948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740956 */     // MIs[0] offset
     /* 740956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740959 */     // MIs[0] auxiliary
     /* 740959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740962 */     // MIs[0] Operand 7
     /* 740962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740980 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 740983 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741010 */     GIR_RootConstrainSelectedInstOperands,
     /* 741011 */     // GIR_Coverage, 5260,
     /* 741011 */     GIR_EraseRootFromParent_Done,
     /* 741012 */   // Label 9686: @741012
     /* 741012 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(741084), // Rule ID 5264 //
     /* 741017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741028 */     // MIs[0] offset
     /* 741028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741031 */     // MIs[0] auxiliary
     /* 741031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741034 */     // MIs[0] Operand 7
     /* 741034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741052 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9787:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 741055 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741064 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741082 */     GIR_RootConstrainSelectedInstOperands,
     /* 741083 */     // GIR_Coverage, 5264,
     /* 741083 */     GIR_EraseRootFromParent_Done,
     /* 741084 */   // Label 9687: @741084
     /* 741084 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(741156), // Rule ID 5284 //
     /* 741089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741100 */     // MIs[0] offset
     /* 741100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741103 */     // MIs[0] auxiliary
     /* 741103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741106 */     // MIs[0] Operand 7
     /* 741106 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741124 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 741127 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741136 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741154 */     GIR_RootConstrainSelectedInstOperands,
     /* 741155 */     // GIR_Coverage, 5284,
     /* 741155 */     GIR_EraseRootFromParent_Done,
     /* 741156 */   // Label 9688: @741156
     /* 741156 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(741228), // Rule ID 5288 //
     /* 741161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741172 */     // MIs[0] offset
     /* 741172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741175 */     // MIs[0] auxiliary
     /* 741175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741178 */     // MIs[0] Operand 7
     /* 741178 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741196 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 741199 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741208 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741226 */     GIR_RootConstrainSelectedInstOperands,
     /* 741227 */     // GIR_Coverage, 5288,
     /* 741227 */     GIR_EraseRootFromParent_Done,
     /* 741228 */   // Label 9689: @741228
     /* 741228 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(741300), // Rule ID 5292 //
     /* 741233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741244 */     // MIs[0] offset
     /* 741244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741247 */     // MIs[0] auxiliary
     /* 741247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741250 */     // MIs[0] Operand 7
     /* 741250 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741268 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9787:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 741271 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741280 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741298 */     GIR_RootConstrainSelectedInstOperands,
     /* 741299 */     // GIR_Coverage, 5292,
     /* 741299 */     GIR_EraseRootFromParent_Done,
     /* 741300 */   // Label 9690: @741300
     /* 741300 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(741372), // Rule ID 5296 //
     /* 741305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741316 */     // MIs[0] offset
     /* 741316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741319 */     // MIs[0] auxiliary
     /* 741319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741322 */     // MIs[0] Operand 7
     /* 741322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741340 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 741343 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741352 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741370 */     GIR_RootConstrainSelectedInstOperands,
     /* 741371 */     // GIR_Coverage, 5296,
     /* 741371 */     GIR_EraseRootFromParent_Done,
     /* 741372 */   // Label 9691: @741372
     /* 741372 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(741442), // Rule ID 5261 //
     /* 741377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741384 */     // MIs[0] offset
     /* 741384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741387 */     // MIs[0] auxiliary
     /* 741387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741390 */     // MIs[0] Operand 7
     /* 741390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741408 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 741411 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741413 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741440 */     GIR_RootConstrainSelectedInstOperands,
     /* 741441 */     // GIR_Coverage, 5261,
     /* 741441 */     GIR_EraseRootFromParent_Done,
     /* 741442 */   // Label 9692: @741442
     /* 741442 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(741512), // Rule ID 5265 //
     /* 741447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741454 */     // MIs[0] offset
     /* 741454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741457 */     // MIs[0] auxiliary
     /* 741457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741460 */     // MIs[0] Operand 7
     /* 741460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741478 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 741481 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741483 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741510 */     GIR_RootConstrainSelectedInstOperands,
     /* 741511 */     // GIR_Coverage, 5265,
     /* 741511 */     GIR_EraseRootFromParent_Done,
     /* 741512 */   // Label 9693: @741512
     /* 741512 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(741582), // Rule ID 5285 //
     /* 741517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741524 */     // MIs[0] offset
     /* 741524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741527 */     // MIs[0] auxiliary
     /* 741527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741530 */     // MIs[0] Operand 7
     /* 741530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741548 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 741551 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741553 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741580 */     GIR_RootConstrainSelectedInstOperands,
     /* 741581 */     // GIR_Coverage, 5285,
     /* 741581 */     GIR_EraseRootFromParent_Done,
     /* 741582 */   // Label 9694: @741582
     /* 741582 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(741652), // Rule ID 5289 //
     /* 741587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741594 */     // MIs[0] offset
     /* 741594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741597 */     // MIs[0] auxiliary
     /* 741597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741600 */     // MIs[0] Operand 7
     /* 741600 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741618 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 741621 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741623 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741632 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741650 */     GIR_RootConstrainSelectedInstOperands,
     /* 741651 */     // GIR_Coverage, 5289,
     /* 741651 */     GIR_EraseRootFromParent_Done,
     /* 741652 */   // Label 9695: @741652
     /* 741652 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(741722), // Rule ID 5293 //
     /* 741657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741664 */     // MIs[0] offset
     /* 741664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741667 */     // MIs[0] auxiliary
     /* 741667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741670 */     // MIs[0] Operand 7
     /* 741670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741688 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 741691 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741693 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741720 */     GIR_RootConstrainSelectedInstOperands,
     /* 741721 */     // GIR_Coverage, 5293,
     /* 741721 */     GIR_EraseRootFromParent_Done,
     /* 741722 */   // Label 9696: @741722
     /* 741722 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(741792), // Rule ID 5297 //
     /* 741727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741734 */     // MIs[0] offset
     /* 741734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741737 */     // MIs[0] auxiliary
     /* 741737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741740 */     // MIs[0] Operand 7
     /* 741740 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741758 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 741761 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741763 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741772 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741790 */     GIR_RootConstrainSelectedInstOperands,
     /* 741791 */     // GIR_Coverage, 5297,
     /* 741791 */     GIR_EraseRootFromParent_Done,
     /* 741792 */   // Label 9697: @741792
     /* 741792 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(741854), // Rule ID 5262 //
     /* 741797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741804 */     // MIs[0] offset
     /* 741804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741807 */     // MIs[0] auxiliary
     /* 741807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741810 */     // MIs[0] Operand 7
     /* 741810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741820 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 741823 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741825 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741834 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741852 */     GIR_RootConstrainSelectedInstOperands,
     /* 741853 */     // GIR_Coverage, 5262,
     /* 741853 */     GIR_EraseRootFromParent_Done,
     /* 741854 */   // Label 9698: @741854
     /* 741854 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(741916), // Rule ID 5266 //
     /* 741859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741866 */     // MIs[0] offset
     /* 741866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741869 */     // MIs[0] auxiliary
     /* 741869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741872 */     // MIs[0] Operand 7
     /* 741872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741882 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 741885 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741887 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741896 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741914 */     GIR_RootConstrainSelectedInstOperands,
     /* 741915 */     // GIR_Coverage, 5266,
     /* 741915 */     GIR_EraseRootFromParent_Done,
     /* 741916 */   // Label 9699: @741916
     /* 741916 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(741978), // Rule ID 5286 //
     /* 741921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741928 */     // MIs[0] offset
     /* 741928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741931 */     // MIs[0] auxiliary
     /* 741931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741934 */     // MIs[0] Operand 7
     /* 741934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741944 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 741947 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741949 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741958 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741976 */     GIR_RootConstrainSelectedInstOperands,
     /* 741977 */     // GIR_Coverage, 5286,
     /* 741977 */     GIR_EraseRootFromParent_Done,
     /* 741978 */   // Label 9700: @741978
     /* 741978 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(742040), // Rule ID 5290 //
     /* 741983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741990 */     // MIs[0] offset
     /* 741990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741993 */     // MIs[0] auxiliary
     /* 741993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741996 */     // MIs[0] Operand 7
     /* 741996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742006 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 742009 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742011 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 742013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742020 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742038 */     GIR_RootConstrainSelectedInstOperands,
     /* 742039 */     // GIR_Coverage, 5290,
     /* 742039 */     GIR_EraseRootFromParent_Done,
     /* 742040 */   // Label 9701: @742040
     /* 742040 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(742102), // Rule ID 5294 //
     /* 742045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742052 */     // MIs[0] offset
     /* 742052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742055 */     // MIs[0] auxiliary
     /* 742055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742058 */     // MIs[0] Operand 7
     /* 742058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742068 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 742071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742073 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 742075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742082 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742100 */     GIR_RootConstrainSelectedInstOperands,
     /* 742101 */     // GIR_Coverage, 5294,
     /* 742101 */     GIR_EraseRootFromParent_Done,
     /* 742102 */   // Label 9702: @742102
     /* 742102 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(742164), // Rule ID 5298 //
     /* 742107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742114 */     // MIs[0] offset
     /* 742114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742117 */     // MIs[0] auxiliary
     /* 742117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742120 */     // MIs[0] Operand 7
     /* 742120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742130 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 742133 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 742137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742144 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742162 */     GIR_RootConstrainSelectedInstOperands,
     /* 742163 */     // GIR_Coverage, 5298,
     /* 742163 */     GIR_EraseRootFromParent_Done,
     /* 742164 */   // Label 9703: @742164
     /* 742164 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(742264), // Rule ID 5263 //
     /* 742169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742172 */     // MIs[0] offset
     /* 742172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742175 */     // MIs[0] auxiliary
     /* 742175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742178 */     // MIs[0] Operand 7
     /* 742178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742188 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742204 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742211 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 742232 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742262 */     GIR_RootConstrainSelectedInstOperands,
     /* 742263 */     // GIR_Coverage, 5263,
     /* 742263 */     GIR_EraseRootFromParent_Done,
     /* 742264 */   // Label 9704: @742264
     /* 742264 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(742364), // Rule ID 5267 //
     /* 742269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742272 */     // MIs[0] offset
     /* 742272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742275 */     // MIs[0] auxiliary
     /* 742275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742278 */     // MIs[0] Operand 7
     /* 742278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742288 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9787:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 742332 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742344 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742362 */     GIR_RootConstrainSelectedInstOperands,
     /* 742363 */     // GIR_Coverage, 5267,
     /* 742363 */     GIR_EraseRootFromParent_Done,
     /* 742364 */   // Label 9705: @742364
     /* 742364 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(742464), // Rule ID 5287 //
     /* 742369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742372 */     // MIs[0] offset
     /* 742372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742375 */     // MIs[0] auxiliary
     /* 742375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742378 */     // MIs[0] Operand 7
     /* 742378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742388 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742404 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742411 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 742432 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742444 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742462 */     GIR_RootConstrainSelectedInstOperands,
     /* 742463 */     // GIR_Coverage, 5287,
     /* 742463 */     GIR_EraseRootFromParent_Done,
     /* 742464 */   // Label 9706: @742464
     /* 742464 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(742564), // Rule ID 5291 //
     /* 742469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742472 */     // MIs[0] offset
     /* 742472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742475 */     // MIs[0] auxiliary
     /* 742475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742478 */     // MIs[0] Operand 7
     /* 742478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742488 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742504 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742511 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 742532 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742544 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742562 */     GIR_RootConstrainSelectedInstOperands,
     /* 742563 */     // GIR_Coverage, 5291,
     /* 742563 */     GIR_EraseRootFromParent_Done,
     /* 742564 */   // Label 9707: @742564
     /* 742564 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(742664), // Rule ID 5295 //
     /* 742569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742572 */     // MIs[0] offset
     /* 742572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742575 */     // MIs[0] auxiliary
     /* 742575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742578 */     // MIs[0] Operand 7
     /* 742578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742588 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9787:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742604 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742611 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 742632 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742644 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742662 */     GIR_RootConstrainSelectedInstOperands,
     /* 742663 */     // GIR_Coverage, 5295,
     /* 742663 */     GIR_EraseRootFromParent_Done,
     /* 742664 */   // Label 9708: @742664
     /* 742664 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(742764), // Rule ID 5299 //
     /* 742669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742672 */     // MIs[0] offset
     /* 742672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742675 */     // MIs[0] auxiliary
     /* 742675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742678 */     // MIs[0] Operand 7
     /* 742678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742688 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742704 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742711 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 742732 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742744 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742762 */     GIR_RootConstrainSelectedInstOperands,
     /* 742763 */     // GIR_Coverage, 5299,
     /* 742763 */     GIR_EraseRootFromParent_Done,
     /* 742764 */   // Label 9709: @742764
     /* 742764 */   GIM_Reject,
     /* 742765 */ // Label 9685: @742765
     /* 742765 */ GIM_Reject,
     /* 742766 */ // Label 9678: @742766
     /* 742766 */ GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(743696),
     /* 742771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 742774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 742777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 742780 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 742783 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(742855), // Rule ID 5268 //
     /* 742788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742799 */     // MIs[0] offset
     /* 742799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742802 */     // MIs[0] auxiliary
     /* 742802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742805 */     // MIs[0] Operand 7
     /* 742805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742823 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 742826 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742835 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742853 */     GIR_RootConstrainSelectedInstOperands,
     /* 742854 */     // GIR_Coverage, 5268,
     /* 742854 */     GIR_EraseRootFromParent_Done,
     /* 742855 */   // Label 9711: @742855
     /* 742855 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(742927), // Rule ID 5300 //
     /* 742860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742871 */     // MIs[0] offset
     /* 742871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742874 */     // MIs[0] auxiliary
     /* 742874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742877 */     // MIs[0] Operand 7
     /* 742877 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742895 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 742898 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742907 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742915 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742925 */     GIR_RootConstrainSelectedInstOperands,
     /* 742926 */     // GIR_Coverage, 5300,
     /* 742926 */     GIR_EraseRootFromParent_Done,
     /* 742927 */   // Label 9712: @742927
     /* 742927 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(742999), // Rule ID 5304 //
     /* 742932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742943 */     // MIs[0] offset
     /* 742943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742946 */     // MIs[0] auxiliary
     /* 742946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742949 */     // MIs[0] Operand 7
     /* 742949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742967 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 742970 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742979 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742997 */     GIR_RootConstrainSelectedInstOperands,
     /* 742998 */     // GIR_Coverage, 5304,
     /* 742998 */     GIR_EraseRootFromParent_Done,
     /* 742999 */   // Label 9713: @742999
     /* 742999 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(743069), // Rule ID 5269 //
     /* 743004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 743007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743011 */     // MIs[0] offset
     /* 743011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743014 */     // MIs[0] auxiliary
     /* 743014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743017 */     // MIs[0] Operand 7
     /* 743017 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743035 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 743038 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743040 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743049 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743067 */     GIR_RootConstrainSelectedInstOperands,
     /* 743068 */     // GIR_Coverage, 5269,
     /* 743068 */     GIR_EraseRootFromParent_Done,
     /* 743069 */   // Label 9714: @743069
     /* 743069 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(743139), // Rule ID 5301 //
     /* 743074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743081 */     // MIs[0] offset
     /* 743081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743084 */     // MIs[0] auxiliary
     /* 743084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743087 */     // MIs[0] Operand 7
     /* 743087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743105 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 743108 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743110 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743119 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743137 */     GIR_RootConstrainSelectedInstOperands,
     /* 743138 */     // GIR_Coverage, 5301,
     /* 743138 */     GIR_EraseRootFromParent_Done,
     /* 743139 */   // Label 9715: @743139
     /* 743139 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(743209), // Rule ID 5305 //
     /* 743144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743151 */     // MIs[0] offset
     /* 743151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743154 */     // MIs[0] auxiliary
     /* 743154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743157 */     // MIs[0] Operand 7
     /* 743157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743175 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 743178 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743180 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743189 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743207 */     GIR_RootConstrainSelectedInstOperands,
     /* 743208 */     // GIR_Coverage, 5305,
     /* 743208 */     GIR_EraseRootFromParent_Done,
     /* 743209 */   // Label 9716: @743209
     /* 743209 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(743271), // Rule ID 5270 //
     /* 743214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 743217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743221 */     // MIs[0] offset
     /* 743221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743224 */     // MIs[0] auxiliary
     /* 743224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743227 */     // MIs[0] Operand 7
     /* 743227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743237 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 743240 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743242 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743251 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743269 */     GIR_RootConstrainSelectedInstOperands,
     /* 743270 */     // GIR_Coverage, 5270,
     /* 743270 */     GIR_EraseRootFromParent_Done,
     /* 743271 */   // Label 9717: @743271
     /* 743271 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(743333), // Rule ID 5302 //
     /* 743276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743283 */     // MIs[0] offset
     /* 743283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743286 */     // MIs[0] auxiliary
     /* 743286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743289 */     // MIs[0] Operand 7
     /* 743289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743299 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 743302 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743304 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743313 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743331 */     GIR_RootConstrainSelectedInstOperands,
     /* 743332 */     // GIR_Coverage, 5302,
     /* 743332 */     GIR_EraseRootFromParent_Done,
     /* 743333 */   // Label 9718: @743333
     /* 743333 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(743395), // Rule ID 5306 //
     /* 743338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743345 */     // MIs[0] offset
     /* 743345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743348 */     // MIs[0] auxiliary
     /* 743348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743351 */     // MIs[0] Operand 7
     /* 743351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743361 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 743364 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743366 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743375 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743393 */     GIR_RootConstrainSelectedInstOperands,
     /* 743394 */     // GIR_Coverage, 5306,
     /* 743394 */     GIR_EraseRootFromParent_Done,
     /* 743395 */   // Label 9719: @743395
     /* 743395 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(743495), // Rule ID 5271 //
     /* 743400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 743403 */     // MIs[0] offset
     /* 743403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743406 */     // MIs[0] auxiliary
     /* 743406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743409 */     // MIs[0] Operand 7
     /* 743409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743419 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743435 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743442 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 743463 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743475 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743493 */     GIR_RootConstrainSelectedInstOperands,
     /* 743494 */     // GIR_Coverage, 5271,
     /* 743494 */     GIR_EraseRootFromParent_Done,
     /* 743495 */   // Label 9720: @743495
     /* 743495 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(743595), // Rule ID 5303 //
     /* 743500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743503 */     // MIs[0] offset
     /* 743503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743506 */     // MIs[0] auxiliary
     /* 743506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743509 */     // MIs[0] Operand 7
     /* 743509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743519 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743535 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743542 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 743563 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743575 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743593 */     GIR_RootConstrainSelectedInstOperands,
     /* 743594 */     // GIR_Coverage, 5303,
     /* 743594 */     GIR_EraseRootFromParent_Done,
     /* 743595 */   // Label 9721: @743595
     /* 743595 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(743695), // Rule ID 5307 //
     /* 743600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743603 */     // MIs[0] offset
     /* 743603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743606 */     // MIs[0] auxiliary
     /* 743606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743609 */     // MIs[0] Operand 7
     /* 743609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743619 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743635 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743642 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 743663 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743675 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743693 */     GIR_RootConstrainSelectedInstOperands,
     /* 743694 */     // GIR_Coverage, 5307,
     /* 743694 */     GIR_EraseRootFromParent_Done,
     /* 743695 */   // Label 9722: @743695
     /* 743695 */   GIM_Reject,
     /* 743696 */ // Label 9710: @743696
     /* 743696 */ GIM_Reject,
     /* 743697 */ // Label 9679: @743697
     /* 743697 */ GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(744931),
     /* 743702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 743705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 743708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 743711 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 743714 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(743786), // Rule ID 5308 //
     /* 743719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743730 */     // MIs[0] offset
     /* 743730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743733 */     // MIs[0] auxiliary
     /* 743733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743736 */     // MIs[0] Operand 7
     /* 743736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743754 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 743757 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743766 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743784 */     GIR_RootConstrainSelectedInstOperands,
     /* 743785 */     // GIR_Coverage, 5308,
     /* 743785 */     GIR_EraseRootFromParent_Done,
     /* 743786 */   // Label 9724: @743786
     /* 743786 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(743858), // Rule ID 5312 //
     /* 743791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743802 */     // MIs[0] offset
     /* 743802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743805 */     // MIs[0] auxiliary
     /* 743805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743808 */     // MIs[0] Operand 7
     /* 743808 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743826 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 743829 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743838 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743856 */     GIR_RootConstrainSelectedInstOperands,
     /* 743857 */     // GIR_Coverage, 5312,
     /* 743857 */     GIR_EraseRootFromParent_Done,
     /* 743858 */   // Label 9725: @743858
     /* 743858 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(743930), // Rule ID 5316 //
     /* 743863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743874 */     // MIs[0] offset
     /* 743874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743877 */     // MIs[0] auxiliary
     /* 743877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743880 */     // MIs[0] Operand 7
     /* 743880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743898 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9787:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 743901 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743910 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743928 */     GIR_RootConstrainSelectedInstOperands,
     /* 743929 */     // GIR_Coverage, 5316,
     /* 743929 */     GIR_EraseRootFromParent_Done,
     /* 743930 */   // Label 9726: @743930
     /* 743930 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(744002), // Rule ID 5320 //
     /* 743935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743946 */     // MIs[0] offset
     /* 743946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743949 */     // MIs[0] auxiliary
     /* 743949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743952 */     // MIs[0] Operand 7
     /* 743952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743970 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9787:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 743973 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743982 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744000 */     GIR_RootConstrainSelectedInstOperands,
     /* 744001 */     // GIR_Coverage, 5320,
     /* 744001 */     GIR_EraseRootFromParent_Done,
     /* 744002 */   // Label 9727: @744002
     /* 744002 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(744072), // Rule ID 5309 //
     /* 744007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744014 */     // MIs[0] offset
     /* 744014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744017 */     // MIs[0] auxiliary
     /* 744017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744020 */     // MIs[0] Operand 7
     /* 744020 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744038 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 744041 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744043 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744052 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744070 */     GIR_RootConstrainSelectedInstOperands,
     /* 744071 */     // GIR_Coverage, 5309,
     /* 744071 */     GIR_EraseRootFromParent_Done,
     /* 744072 */   // Label 9728: @744072
     /* 744072 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(744142), // Rule ID 5313 //
     /* 744077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744084 */     // MIs[0] offset
     /* 744084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744087 */     // MIs[0] auxiliary
     /* 744087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744090 */     // MIs[0] Operand 7
     /* 744090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744108 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 744111 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744113 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744122 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744140 */     GIR_RootConstrainSelectedInstOperands,
     /* 744141 */     // GIR_Coverage, 5313,
     /* 744141 */     GIR_EraseRootFromParent_Done,
     /* 744142 */   // Label 9729: @744142
     /* 744142 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(744212), // Rule ID 5317 //
     /* 744147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744154 */     // MIs[0] offset
     /* 744154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744157 */     // MIs[0] auxiliary
     /* 744157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744160 */     // MIs[0] Operand 7
     /* 744160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744178 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 744181 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744183 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744192 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744210 */     GIR_RootConstrainSelectedInstOperands,
     /* 744211 */     // GIR_Coverage, 5317,
     /* 744211 */     GIR_EraseRootFromParent_Done,
     /* 744212 */   // Label 9730: @744212
     /* 744212 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(744282), // Rule ID 5321 //
     /* 744217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744224 */     // MIs[0] offset
     /* 744224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744227 */     // MIs[0] auxiliary
     /* 744227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744230 */     // MIs[0] Operand 7
     /* 744230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744248 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 744251 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744253 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744262 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744280 */     GIR_RootConstrainSelectedInstOperands,
     /* 744281 */     // GIR_Coverage, 5321,
     /* 744281 */     GIR_EraseRootFromParent_Done,
     /* 744282 */   // Label 9731: @744282
     /* 744282 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(744344), // Rule ID 5310 //
     /* 744287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744294 */     // MIs[0] offset
     /* 744294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744297 */     // MIs[0] auxiliary
     /* 744297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744300 */     // MIs[0] Operand 7
     /* 744300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744310 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 744313 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744315 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744324 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744342 */     GIR_RootConstrainSelectedInstOperands,
     /* 744343 */     // GIR_Coverage, 5310,
     /* 744343 */     GIR_EraseRootFromParent_Done,
     /* 744344 */   // Label 9732: @744344
     /* 744344 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(744406), // Rule ID 5314 //
     /* 744349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744356 */     // MIs[0] offset
     /* 744356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744359 */     // MIs[0] auxiliary
     /* 744359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744362 */     // MIs[0] Operand 7
     /* 744362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744372 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 744375 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744377 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744386 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744404 */     GIR_RootConstrainSelectedInstOperands,
     /* 744405 */     // GIR_Coverage, 5314,
     /* 744405 */     GIR_EraseRootFromParent_Done,
     /* 744406 */   // Label 9733: @744406
     /* 744406 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(744468), // Rule ID 5318 //
     /* 744411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744418 */     // MIs[0] offset
     /* 744418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744421 */     // MIs[0] auxiliary
     /* 744421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744424 */     // MIs[0] Operand 7
     /* 744424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744434 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 744437 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744439 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744448 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744466 */     GIR_RootConstrainSelectedInstOperands,
     /* 744467 */     // GIR_Coverage, 5318,
     /* 744467 */     GIR_EraseRootFromParent_Done,
     /* 744468 */   // Label 9734: @744468
     /* 744468 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(744530), // Rule ID 5322 //
     /* 744473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744480 */     // MIs[0] offset
     /* 744480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744483 */     // MIs[0] auxiliary
     /* 744483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744486 */     // MIs[0] Operand 7
     /* 744486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744496 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 744499 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744501 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744528 */     GIR_RootConstrainSelectedInstOperands,
     /* 744529 */     // GIR_Coverage, 5322,
     /* 744529 */     GIR_EraseRootFromParent_Done,
     /* 744530 */   // Label 9735: @744530
     /* 744530 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(744630), // Rule ID 5311 //
     /* 744535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744538 */     // MIs[0] offset
     /* 744538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744541 */     // MIs[0] auxiliary
     /* 744541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744544 */     // MIs[0] Operand 7
     /* 744544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744554 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 744598 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744610 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744628 */     GIR_RootConstrainSelectedInstOperands,
     /* 744629 */     // GIR_Coverage, 5311,
     /* 744629 */     GIR_EraseRootFromParent_Done,
     /* 744630 */   // Label 9736: @744630
     /* 744630 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(744730), // Rule ID 5315 //
     /* 744635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744638 */     // MIs[0] offset
     /* 744638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744641 */     // MIs[0] auxiliary
     /* 744641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744644 */     // MIs[0] Operand 7
     /* 744644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744654 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744670 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744677 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 744698 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744710 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744728 */     GIR_RootConstrainSelectedInstOperands,
     /* 744729 */     // GIR_Coverage, 5315,
     /* 744729 */     GIR_EraseRootFromParent_Done,
     /* 744730 */   // Label 9737: @744730
     /* 744730 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(744830), // Rule ID 5319 //
     /* 744735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744738 */     // MIs[0] offset
     /* 744738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744741 */     // MIs[0] auxiliary
     /* 744741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744744 */     // MIs[0] Operand 7
     /* 744744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744754 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744770 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744777 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 744798 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744810 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744828 */     GIR_RootConstrainSelectedInstOperands,
     /* 744829 */     // GIR_Coverage, 5319,
     /* 744829 */     GIR_EraseRootFromParent_Done,
     /* 744830 */   // Label 9738: @744830
     /* 744830 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(744930), // Rule ID 5323 //
     /* 744835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744838 */     // MIs[0] offset
     /* 744838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744841 */     // MIs[0] auxiliary
     /* 744841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744844 */     // MIs[0] Operand 7
     /* 744844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744854 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744870 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744877 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 744898 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744910 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744928 */     GIR_RootConstrainSelectedInstOperands,
     /* 744929 */     // GIR_Coverage, 5323,
     /* 744929 */     GIR_EraseRootFromParent_Done,
     /* 744930 */   // Label 9739: @744930
     /* 744930 */   GIM_Reject,
     /* 744931 */ // Label 9723: @744931
     /* 744931 */ GIM_Reject,
     /* 744932 */ // Label 9680: @744932
     /* 744932 */ GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(745254),
     /* 744937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 744940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 744943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 744946 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 744949 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(745021), // Rule ID 5272 //
     /* 744954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744965 */     // MIs[0] offset
     /* 744965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744968 */     // MIs[0] auxiliary
     /* 744968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744971 */     // MIs[0] Operand 7
     /* 744971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744989 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 744992 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745001 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745019 */     GIR_RootConstrainSelectedInstOperands,
     /* 745020 */     // GIR_Coverage, 5272,
     /* 745020 */     GIR_EraseRootFromParent_Done,
     /* 745021 */   // Label 9741: @745021
     /* 745021 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(745091), // Rule ID 5273 //
     /* 745026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745033 */     // MIs[0] offset
     /* 745033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745036 */     // MIs[0] auxiliary
     /* 745036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745039 */     // MIs[0] Operand 7
     /* 745039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745057 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 745060 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745062 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745071 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745089 */     GIR_RootConstrainSelectedInstOperands,
     /* 745090 */     // GIR_Coverage, 5273,
     /* 745090 */     GIR_EraseRootFromParent_Done,
     /* 745091 */   // Label 9742: @745091
     /* 745091 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(745153), // Rule ID 5274 //
     /* 745096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745103 */     // MIs[0] offset
     /* 745103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745106 */     // MIs[0] auxiliary
     /* 745106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745109 */     // MIs[0] Operand 7
     /* 745109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745119 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 745122 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745124 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745151 */     GIR_RootConstrainSelectedInstOperands,
     /* 745152 */     // GIR_Coverage, 5274,
     /* 745152 */     GIR_EraseRootFromParent_Done,
     /* 745153 */   // Label 9743: @745153
     /* 745153 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(745253), // Rule ID 5275 //
     /* 745158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745161 */     // MIs[0] offset
     /* 745161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745164 */     // MIs[0] auxiliary
     /* 745164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745167 */     // MIs[0] Operand 7
     /* 745167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745177 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 745180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 745184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 745189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 745193 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 745196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 745200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 745203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 745208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 745221 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 745226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745233 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745241 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745251 */     GIR_RootConstrainSelectedInstOperands,
     /* 745252 */     // GIR_Coverage, 5275,
     /* 745252 */     GIR_EraseRootFromParent_Done,
     /* 745253 */   // Label 9744: @745253
     /* 745253 */   GIM_Reject,
     /* 745254 */ // Label 9740: @745254
     /* 745254 */ GIM_Reject,
     /* 745255 */ // Label 9681: @745255
     /* 745255 */ GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(745577),
     /* 745260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 745263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 745266 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 745269 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 745272 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(745344), // Rule ID 5276 //
     /* 745277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745288 */     // MIs[0] offset
     /* 745288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745291 */     // MIs[0] auxiliary
     /* 745291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745294 */     // MIs[0] Operand 7
     /* 745294 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745312 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 745315 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745324 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745342 */     GIR_RootConstrainSelectedInstOperands,
     /* 745343 */     // GIR_Coverage, 5276,
     /* 745343 */     GIR_EraseRootFromParent_Done,
     /* 745344 */   // Label 9746: @745344
     /* 745344 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(745414), // Rule ID 5277 //
     /* 745349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745356 */     // MIs[0] offset
     /* 745356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745359 */     // MIs[0] auxiliary
     /* 745359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745362 */     // MIs[0] Operand 7
     /* 745362 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745380 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 745383 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745385 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745412 */     GIR_RootConstrainSelectedInstOperands,
     /* 745413 */     // GIR_Coverage, 5277,
     /* 745413 */     GIR_EraseRootFromParent_Done,
     /* 745414 */   // Label 9747: @745414
     /* 745414 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(745476), // Rule ID 5278 //
     /* 745419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745426 */     // MIs[0] offset
     /* 745426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745429 */     // MIs[0] auxiliary
     /* 745429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745432 */     // MIs[0] Operand 7
     /* 745432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745442 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 745445 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745447 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745456 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745474 */     GIR_RootConstrainSelectedInstOperands,
     /* 745475 */     // GIR_Coverage, 5278,
     /* 745475 */     GIR_EraseRootFromParent_Done,
     /* 745476 */   // Label 9748: @745476
     /* 745476 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(745576), // Rule ID 5279 //
     /* 745481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745484 */     // MIs[0] offset
     /* 745484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745487 */     // MIs[0] auxiliary
     /* 745487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745490 */     // MIs[0] Operand 7
     /* 745490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745500 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 745503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 745507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 745512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 745516 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 745519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 745523 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 745526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 745531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 745544 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 745549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745574 */     GIR_RootConstrainSelectedInstOperands,
     /* 745575 */     // GIR_Coverage, 5279,
     /* 745575 */     GIR_EraseRootFromParent_Done,
     /* 745576 */   // Label 9749: @745576
     /* 745576 */   GIM_Reject,
     /* 745577 */ // Label 9745: @745577
     /* 745577 */ GIM_Reject,
     /* 745578 */ // Label 9682: @745578
     /* 745578 */ GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(746812),
     /* 745583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 745586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 745589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 745592 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 745595 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(745667), // Rule ID 5340 //
     /* 745600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745611 */     // MIs[0] offset
     /* 745611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745614 */     // MIs[0] auxiliary
     /* 745614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745617 */     // MIs[0] Operand 7
     /* 745617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745635 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 745638 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745647 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745665 */     GIR_RootConstrainSelectedInstOperands,
     /* 745666 */     // GIR_Coverage, 5340,
     /* 745666 */     GIR_EraseRootFromParent_Done,
     /* 745667 */   // Label 9751: @745667
     /* 745667 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(745739), // Rule ID 5344 //
     /* 745672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745683 */     // MIs[0] offset
     /* 745683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745686 */     // MIs[0] auxiliary
     /* 745686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745689 */     // MIs[0] Operand 7
     /* 745689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745707 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 745710 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745719 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745737 */     GIR_RootConstrainSelectedInstOperands,
     /* 745738 */     // GIR_Coverage, 5344,
     /* 745738 */     GIR_EraseRootFromParent_Done,
     /* 745739 */   // Label 9752: @745739
     /* 745739 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(745811), // Rule ID 5348 //
     /* 745744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745755 */     // MIs[0] offset
     /* 745755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745758 */     // MIs[0] auxiliary
     /* 745758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745761 */     // MIs[0] Operand 7
     /* 745761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745779 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9786:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 745782 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745791 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745809 */     GIR_RootConstrainSelectedInstOperands,
     /* 745810 */     // GIR_Coverage, 5348,
     /* 745810 */     GIR_EraseRootFromParent_Done,
     /* 745811 */   // Label 9753: @745811
     /* 745811 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(745883), // Rule ID 5352 //
     /* 745816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745827 */     // MIs[0] offset
     /* 745827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745830 */     // MIs[0] auxiliary
     /* 745830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745833 */     // MIs[0] Operand 7
     /* 745833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745851 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 745854 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745863 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745881 */     GIR_RootConstrainSelectedInstOperands,
     /* 745882 */     // GIR_Coverage, 5352,
     /* 745882 */     GIR_EraseRootFromParent_Done,
     /* 745883 */   // Label 9754: @745883
     /* 745883 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(745953), // Rule ID 5341 //
     /* 745888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745895 */     // MIs[0] offset
     /* 745895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745898 */     // MIs[0] auxiliary
     /* 745898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745901 */     // MIs[0] Operand 7
     /* 745901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745919 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 745922 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745924 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745933 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745951 */     GIR_RootConstrainSelectedInstOperands,
     /* 745952 */     // GIR_Coverage, 5341,
     /* 745952 */     GIR_EraseRootFromParent_Done,
     /* 745953 */   // Label 9755: @745953
     /* 745953 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(746023), // Rule ID 5345 //
     /* 745958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745965 */     // MIs[0] offset
     /* 745965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745968 */     // MIs[0] auxiliary
     /* 745968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745971 */     // MIs[0] Operand 7
     /* 745971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745989 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 745992 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745994 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746003 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746021 */     GIR_RootConstrainSelectedInstOperands,
     /* 746022 */     // GIR_Coverage, 5345,
     /* 746022 */     GIR_EraseRootFromParent_Done,
     /* 746023 */   // Label 9756: @746023
     /* 746023 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(746093), // Rule ID 5349 //
     /* 746028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746035 */     // MIs[0] offset
     /* 746035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746038 */     // MIs[0] auxiliary
     /* 746038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746041 */     // MIs[0] Operand 7
     /* 746041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746059 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 746062 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746064 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 746066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746073 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746091 */     GIR_RootConstrainSelectedInstOperands,
     /* 746092 */     // GIR_Coverage, 5349,
     /* 746092 */     GIR_EraseRootFromParent_Done,
     /* 746093 */   // Label 9757: @746093
     /* 746093 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(746163), // Rule ID 5353 //
     /* 746098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746105 */     // MIs[0] offset
     /* 746105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746108 */     // MIs[0] auxiliary
     /* 746108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746111 */     // MIs[0] Operand 7
     /* 746111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746129 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 746132 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746134 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 746136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746143 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746161 */     GIR_RootConstrainSelectedInstOperands,
     /* 746162 */     // GIR_Coverage, 5353,
     /* 746162 */     GIR_EraseRootFromParent_Done,
     /* 746163 */   // Label 9758: @746163
     /* 746163 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(746225), // Rule ID 5342 //
     /* 746168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746175 */     // MIs[0] offset
     /* 746175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746178 */     // MIs[0] auxiliary
     /* 746178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746181 */     // MIs[0] Operand 7
     /* 746181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746191 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 746194 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746196 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746205 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746223 */     GIR_RootConstrainSelectedInstOperands,
     /* 746224 */     // GIR_Coverage, 5342,
     /* 746224 */     GIR_EraseRootFromParent_Done,
     /* 746225 */   // Label 9759: @746225
     /* 746225 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(746287), // Rule ID 5346 //
     /* 746230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746237 */     // MIs[0] offset
     /* 746237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746240 */     // MIs[0] auxiliary
     /* 746240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746243 */     // MIs[0] Operand 7
     /* 746243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746253 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 746256 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746258 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746267 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746285 */     GIR_RootConstrainSelectedInstOperands,
     /* 746286 */     // GIR_Coverage, 5346,
     /* 746286 */     GIR_EraseRootFromParent_Done,
     /* 746287 */   // Label 9760: @746287
     /* 746287 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(746349), // Rule ID 5350 //
     /* 746292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746299 */     // MIs[0] offset
     /* 746299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746302 */     // MIs[0] auxiliary
     /* 746302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746305 */     // MIs[0] Operand 7
     /* 746305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746315 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 746318 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746320 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746329 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746347 */     GIR_RootConstrainSelectedInstOperands,
     /* 746348 */     // GIR_Coverage, 5350,
     /* 746348 */     GIR_EraseRootFromParent_Done,
     /* 746349 */   // Label 9761: @746349
     /* 746349 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(746411), // Rule ID 5354 //
     /* 746354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746361 */     // MIs[0] offset
     /* 746361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746364 */     // MIs[0] auxiliary
     /* 746364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746367 */     // MIs[0] Operand 7
     /* 746367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746377 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 746380 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746382 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746391 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746409 */     GIR_RootConstrainSelectedInstOperands,
     /* 746410 */     // GIR_Coverage, 5354,
     /* 746410 */     GIR_EraseRootFromParent_Done,
     /* 746411 */   // Label 9762: @746411
     /* 746411 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(746511), // Rule ID 5343 //
     /* 746416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746419 */     // MIs[0] offset
     /* 746419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746422 */     // MIs[0] auxiliary
     /* 746422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746425 */     // MIs[0] Operand 7
     /* 746425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746435 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746451 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746458 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 746479 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746491 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746509 */     GIR_RootConstrainSelectedInstOperands,
     /* 746510 */     // GIR_Coverage, 5343,
     /* 746510 */     GIR_EraseRootFromParent_Done,
     /* 746511 */   // Label 9763: @746511
     /* 746511 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(746611), // Rule ID 5347 //
     /* 746516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746519 */     // MIs[0] offset
     /* 746519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746522 */     // MIs[0] auxiliary
     /* 746522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746525 */     // MIs[0] Operand 7
     /* 746525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746535 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746551 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 746579 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746609 */     GIR_RootConstrainSelectedInstOperands,
     /* 746610 */     // GIR_Coverage, 5347,
     /* 746610 */     GIR_EraseRootFromParent_Done,
     /* 746611 */   // Label 9764: @746611
     /* 746611 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(746711), // Rule ID 5351 //
     /* 746616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746619 */     // MIs[0] offset
     /* 746619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746622 */     // MIs[0] auxiliary
     /* 746622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746625 */     // MIs[0] Operand 7
     /* 746625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746635 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746651 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746658 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 746679 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746709 */     GIR_RootConstrainSelectedInstOperands,
     /* 746710 */     // GIR_Coverage, 5351,
     /* 746710 */     GIR_EraseRootFromParent_Done,
     /* 746711 */   // Label 9765: @746711
     /* 746711 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(746811), // Rule ID 5355 //
     /* 746716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746719 */     // MIs[0] offset
     /* 746719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746722 */     // MIs[0] auxiliary
     /* 746722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746725 */     // MIs[0] Operand 7
     /* 746725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746735 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746751 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746758 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 746779 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746791 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746809 */     GIR_RootConstrainSelectedInstOperands,
     /* 746810 */     // GIR_Coverage, 5355,
     /* 746810 */     GIR_EraseRootFromParent_Done,
     /* 746811 */   // Label 9766: @746811
     /* 746811 */   GIM_Reject,
     /* 746812 */ // Label 9750: @746812
     /* 746812 */ GIM_Reject,
     /* 746813 */ // Label 9683: @746813
     /* 746813 */ GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(747135),
     /* 746818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 746821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 746824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 746827 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 746830 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(746902), // Rule ID 5280 //
     /* 746835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746846 */     // MIs[0] offset
     /* 746846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746849 */     // MIs[0] auxiliary
     /* 746849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746852 */     // MIs[0] Operand 7
     /* 746852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746870 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 746873 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746882 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746900 */     GIR_RootConstrainSelectedInstOperands,
     /* 746901 */     // GIR_Coverage, 5280,
     /* 746901 */     GIR_EraseRootFromParent_Done,
     /* 746902 */   // Label 9768: @746902
     /* 746902 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(746972), // Rule ID 5281 //
     /* 746907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746914 */     // MIs[0] offset
     /* 746914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746917 */     // MIs[0] auxiliary
     /* 746917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746920 */     // MIs[0] Operand 7
     /* 746920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746938 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 746941 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746943 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 746945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746952 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746970 */     GIR_RootConstrainSelectedInstOperands,
     /* 746971 */     // GIR_Coverage, 5281,
     /* 746971 */     GIR_EraseRootFromParent_Done,
     /* 746972 */   // Label 9769: @746972
     /* 746972 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(747034), // Rule ID 5282 //
     /* 746977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746984 */     // MIs[0] offset
     /* 746984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746987 */     // MIs[0] auxiliary
     /* 746987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746990 */     // MIs[0] Operand 7
     /* 746990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747000 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 747003 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747005 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747032 */     GIR_RootConstrainSelectedInstOperands,
     /* 747033 */     // GIR_Coverage, 5282,
     /* 747033 */     GIR_EraseRootFromParent_Done,
     /* 747034 */   // Label 9770: @747034
     /* 747034 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(747134), // Rule ID 5283 //
     /* 747039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 747042 */     // MIs[0] offset
     /* 747042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747045 */     // MIs[0] auxiliary
     /* 747045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747048 */     // MIs[0] Operand 7
     /* 747048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747058 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747074 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747081 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 747102 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747114 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747132 */     GIR_RootConstrainSelectedInstOperands,
     /* 747133 */     // GIR_Coverage, 5283,
     /* 747133 */     GIR_EraseRootFromParent_Done,
     /* 747134 */   // Label 9771: @747134
     /* 747134 */   GIM_Reject,
     /* 747135 */ // Label 9767: @747135
     /* 747135 */ GIM_Reject,
     /* 747136 */ // Label 9684: @747136
     /* 747136 */ GIM_Reject,
     /* 747137 */ // Label 142: @747137
     /* 747137 */ GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(747738),
     /* 747142 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 747145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 747148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 747151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 747154 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 747157 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(747429),
     /* 747162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747166 */     GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(747234), // Rule ID 5564 //
     /* 747171 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747174 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747178 */       // MIs[0] offset
     /* 747178 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747181 */       // MIs[0] auxiliary
     /* 747181 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747184 */       // MIs[0] Operand 7
     /* 747184 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747195 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747202 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747202 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET_exact),
     /* 747205 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747207 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747209 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747214 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747216 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747222 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747228 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747232 */       GIR_RootConstrainSelectedInstOperands,
     /* 747233 */       // GIR_Coverage, 5564,
     /* 747233 */       GIR_EraseRootFromParent_Done,
     /* 747234 */     // Label 9774: @747234
     /* 747234 */     GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(747299), // Rule ID 5568 //
     /* 747239 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747243 */       // MIs[0] offset
     /* 747243 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747246 */       // MIs[0] auxiliary
     /* 747246 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747249 */       // MIs[0] Operand 7
     /* 747249 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747260 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747267 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747267 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact),
     /* 747270 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747272 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747274 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747279 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747281 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747287 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747293 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747297 */       GIR_RootConstrainSelectedInstOperands,
     /* 747298 */       // GIR_Coverage, 5568,
     /* 747298 */       GIR_EraseRootFromParent_Done,
     /* 747299 */     // Label 9775: @747299
     /* 747299 */     GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(747365), // Rule ID 5565 //
     /* 747304 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747307 */       // MIs[0] offset
     /* 747307 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747310 */       // MIs[0] auxiliary
     /* 747310 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747313 */       // MIs[0] Operand 7
     /* 747313 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747324 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747331 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN_exact),
     /* 747334 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747336 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747338 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747340 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747345 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747347 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747353 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747359 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747363 */       GIR_RootConstrainSelectedInstOperands,
     /* 747364 */       // GIR_Coverage, 5565,
     /* 747364 */       GIR_EraseRootFromParent_Done,
     /* 747365 */     // Label 9776: @747365
     /* 747365 */     GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(747428), // Rule ID 5569 //
     /* 747370 */       // MIs[0] offset
     /* 747370 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747373 */       // MIs[0] auxiliary
     /* 747373 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747376 */       // MIs[0] Operand 7
     /* 747376 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747387 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747394 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747394 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact),
     /* 747397 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747399 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747401 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747403 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747408 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747410 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747416 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747422 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747426 */       GIR_RootConstrainSelectedInstOperands,
     /* 747427 */       // GIR_Coverage, 5569,
     /* 747427 */       GIR_EraseRootFromParent_Done,
     /* 747428 */     // Label 9777: @747428
     /* 747428 */     GIM_Reject,
     /* 747429 */   // Label 9773: @747429
     /* 747429 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(747543),
     /* 747434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747447 */     GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(747496), // Rule ID 5566 //
     /* 747452 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747455 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747462 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747462 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_IDXEN_exact),
     /* 747465 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747467 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747469 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747476 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747478 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747484 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747490 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747494 */       GIR_RootConstrainSelectedInstOperands,
     /* 747495 */       // GIR_Coverage, 5566,
     /* 747495 */       GIR_EraseRootFromParent_Done,
     /* 747496 */     // Label 9779: @747496
     /* 747496 */     GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(747542), // Rule ID 5570 //
     /* 747501 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747508 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747508 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact),
     /* 747511 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747513 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747515 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747517 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747522 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747524 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747530 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747536 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747540 */       GIR_RootConstrainSelectedInstOperands,
     /* 747541 */       // GIR_Coverage, 5570,
     /* 747541 */       GIR_EraseRootFromParent_Done,
     /* 747542 */     // Label 9780: @747542
     /* 747542 */     GIM_Reject,
     /* 747543 */   // Label 9778: @747543
     /* 747543 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(747737),
     /* 747548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747557 */     GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(747648), // Rule ID 5567 //
     /* 747562 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747565 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747572 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747572 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747575 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747579 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747584 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747588 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747591 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747595 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747598 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747603 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747608 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747613 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_BOTHEN_exact),
     /* 747616 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747618 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747621 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747623 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747628 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747630 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747636 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747642 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747646 */       GIR_RootConstrainSelectedInstOperands,
     /* 747647 */       // GIR_Coverage, 5567,
     /* 747647 */       GIR_EraseRootFromParent_Done,
     /* 747648 */     // Label 9782: @747648
     /* 747648 */     GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(747736), // Rule ID 5571 //
     /* 747653 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747660 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747660 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747663 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747667 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747672 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747676 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747679 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747683 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747686 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747691 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747696 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747701 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact),
     /* 747704 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747706 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747709 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747711 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747716 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747718 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747724 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747730 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747734 */       GIR_RootConstrainSelectedInstOperands,
     /* 747735 */       // GIR_Coverage, 5571,
     /* 747735 */       GIR_EraseRootFromParent_Done,
     /* 747736 */     // Label 9783: @747736
     /* 747736 */     GIM_Reject,
     /* 747737 */   // Label 9781: @747737
     /* 747737 */   GIM_Reject,
     /* 747738 */ // Label 9772: @747738
     /* 747738 */ GIM_Reject,
     /* 747739 */ // Label 143: @747739
     /* 747739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 9788*/ GIMT_Encode4(748677),
     /* 747750 */ /*GILLT_s16*//*Label 9784*/ GIMT_Encode4(747766),
     /* 747754 */ /*GILLT_s32*//*Label 9785*/ GIMT_Encode4(747935),
     /* 747758 */ /*GILLT_s64*//*Label 9786*/ GIMT_Encode4(747988),
     /* 747762 */ /*GILLT_v2s16*//*Label 9787*/ GIMT_Encode4(748098),
     /* 747766 */ // Label 9784: @747766
     /* 747766 */ GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(747934),
     /* 747771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 747774 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(747826), // Rule ID 7228 //
     /* 747779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 747782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747793 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 747796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747824 */     GIR_RootConstrainSelectedInstOperands,
     /* 747825 */     // GIR_Coverage, 7228,
     /* 747825 */     GIR_EraseRootFromParent_Done,
     /* 747826 */   // Label 9790: @747826
     /* 747826 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(747881), // Rule ID 7229 //
     /* 747831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 747834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 747838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747845 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 747848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747879 */     GIR_RootConstrainSelectedInstOperands,
     /* 747880 */     // GIR_Coverage, 7229,
     /* 747880 */     GIR_EraseRootFromParent_Done,
     /* 747881 */   // Label 9791: @747881
     /* 747881 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(747933), // Rule ID 7230 //
     /* 747886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 747889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747900 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 747903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747931 */     GIR_RootConstrainSelectedInstOperands,
     /* 747932 */     // GIR_Coverage, 7230,
     /* 747932 */     GIR_EraseRootFromParent_Done,
     /* 747933 */   // Label 9792: @747933
     /* 747933 */   GIM_Reject,
     /* 747934 */ // Label 9789: @747934
     /* 747934 */ GIM_Reject,
     /* 747935 */ // Label 9785: @747935
     /* 747935 */ GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(747987), // Rule ID 7225 //
     /* 747940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 747943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747954 */   // (AMDGPUclamp:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 747957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747985 */   GIR_RootConstrainSelectedInstOperands,
     /* 747986 */   // GIR_Coverage, 7225,
     /* 747986 */   GIR_EraseRootFromParent_Done,
     /* 747987 */ // Label 9793: @747987
     /* 747987 */ GIM_Reject,
     /* 747988 */ // Label 9786: @747988
     /* 747988 */ GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(748097),
     /* 747993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 747996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 748000 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(748048), // Rule ID 7226 //
     /* 748005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 748008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 748015 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 748015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 748018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748046 */     GIR_RootConstrainSelectedInstOperands,
     /* 748047 */     // GIR_Coverage, 7226,
     /* 748047 */     GIR_EraseRootFromParent_Done,
     /* 748048 */   // Label 9795: @748048
     /* 748048 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(748096), // Rule ID 7227 //
     /* 748053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 748056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 748063 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 748063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 748066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748094 */     GIR_RootConstrainSelectedInstOperands,
     /* 748095 */     // GIR_Coverage, 7227,
     /* 748095 */     GIR_EraseRootFromParent_Done,
     /* 748096 */   // Label 9796: @748096
     /* 748096 */   GIM_Reject,
     /* 748097 */ // Label 9794: @748097
     /* 748097 */ GIM_Reject,
     /* 748098 */ // Label 9787: @748098
     /* 748098 */ GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(748676),
     /* 748103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 748106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748110 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(748364), // Rule ID 2735 //
     /* 748115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 748118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 748122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 748126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 748129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 748133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 748137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 748141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 748149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 748153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 748157 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 748161 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 748165 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 748169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 748173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748177 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 748181 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 748185 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 748189 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 748193 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 748197 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 748201 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 748203 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748210 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748217 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748224 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748231 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748238 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748245 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_FMA_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 748245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 748248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 748252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 748259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 748262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 748266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 748276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 748281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 748286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 748291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 748296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 748301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 748304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 748307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748310 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 748315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /* 748318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 748325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 748330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 748335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 748340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 748345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 748350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748362 */     GIR_RootConstrainSelectedInstOperands,
     /* 748363 */     // GIR_Coverage, 2735,
     /* 748363 */     GIR_EraseRootFromParent_Done,
     /* 748364 */   // Label 9798: @748364
     /* 748364 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(748618), // Rule ID 2719 //
     /* 748369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 748372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 748376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 748380 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 748383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 748387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 748391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 748395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 748403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 748407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 748411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 748415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 748419 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 748423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 748427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 748435 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 748439 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 748443 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 748447 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 748451 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 748455 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 748457 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748464 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748471 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748478 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748485 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748492 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748499 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_MAD_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 748499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 748502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 748506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 748513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 748516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 748520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 748530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 748535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 748540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 748545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 748550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 748555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 748558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 748561 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748564 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 748569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /* 748572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 748579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 748584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 748589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 748594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 748599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 748604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748616 */     GIR_RootConstrainSelectedInstOperands,
     /* 748617 */     // GIR_Coverage, 2719,
     /* 748617 */     GIR_EraseRootFromParent_Done,
     /* 748618 */   // Label 9799: @748618
     /* 748618 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(748675), // Rule ID 7231 //
     /* 748623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 748626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 748633 */     // (AMDGPUclamp:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, 1:{ *:[i1] })
     /* 748633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 748636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748673 */     GIR_RootConstrainSelectedInstOperands,
     /* 748674 */     // GIR_Coverage, 7231,
     /* 748674 */     GIR_EraseRootFromParent_Done,
     /* 748675 */   // Label 9800: @748675
     /* 748675 */   GIM_Reject,
     /* 748676 */ // Label 9797: @748676
     /* 748676 */ GIM_Reject,
     /* 748677 */ // Label 9788: @748677
     /* 748677 */ GIM_Reject,
     /* 748678 */ // Label 144: @748678
     /* 748678 */ GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(748722), // Rule ID 651 //
     /* 748683 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748700 */   // (AMDGPUcvt_f32_ubyte0:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE0_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE0_e64),
     /* 748703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748720 */   GIR_RootConstrainSelectedInstOperands,
     /* 748721 */   // GIR_Coverage, 651,
     /* 748721 */   GIR_EraseRootFromParent_Done,
     /* 748722 */ // Label 9801: @748722
     /* 748722 */ GIM_Reject,
     /* 748723 */ // Label 145: @748723
     /* 748723 */ GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(748767), // Rule ID 652 //
     /* 748728 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748745 */   // (AMDGPUcvt_f32_ubyte1:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE1_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE1_e64),
     /* 748748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748765 */   GIR_RootConstrainSelectedInstOperands,
     /* 748766 */   // GIR_Coverage, 652,
     /* 748766 */   GIR_EraseRootFromParent_Done,
     /* 748767 */ // Label 9802: @748767
     /* 748767 */ GIM_Reject,
     /* 748768 */ // Label 146: @748768
     /* 748768 */ GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(748812), // Rule ID 653 //
     /* 748773 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748790 */   // (AMDGPUcvt_f32_ubyte2:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE2_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE2_e64),
     /* 748793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748810 */   GIR_RootConstrainSelectedInstOperands,
     /* 748811 */   // GIR_Coverage, 653,
     /* 748811 */   GIR_EraseRootFromParent_Done,
     /* 748812 */ // Label 9803: @748812
     /* 748812 */ GIM_Reject,
     /* 748813 */ // Label 147: @748813
     /* 748813 */ GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(748857), // Rule ID 654 //
     /* 748818 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748835 */   // (AMDGPUcvt_f32_ubyte3:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE3_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE3_e64),
     /* 748838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748855 */   GIR_RootConstrainSelectedInstOperands,
     /* 748856 */   // GIR_Coverage, 654,
     /* 748856 */   GIR_EraseRootFromParent_Done,
     /* 748857 */ // Label 9804: @748857
     /* 748857 */ GIM_Reject,
     /* 748858 */ // Label 148: @748858
     /* 748858 */ GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(748887), // Rule ID 831 //
     /* 748863 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 748866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 748872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748876 */   // (AMDGPUpk_i16_i32_impl:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 748876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 748881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 748885 */   GIR_RootConstrainSelectedInstOperands,
     /* 748886 */   // GIR_Coverage, 831,
     /* 748886 */   GIR_Done,
     /* 748887 */ // Label 9805: @748887
     /* 748887 */ GIM_Reject,
     /* 748888 */ // Label 149: @748888
     /* 748888 */ GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(748989),
     /* 748893 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748896 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9809*/ GIMT_Encode4(748957),
     /* 748907 */   /*GILLT_s32*//*Label 9807*/ GIMT_Encode4(748915),
     /* 748911 */   /*GILLT_s64*//*Label 9808*/ GIMT_Encode4(748936),
     /* 748915 */   // Label 9807: @748915
     /* 748915 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(748935), // Rule ID 13 //
     /* 748920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 748928 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13728>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 748933 */     GIR_RootConstrainSelectedInstOperands,
     /* 748934 */     // GIR_Coverage, 13,
     /* 748934 */     GIR_Done,
     /* 748935 */   // Label 9810: @748935
     /* 748935 */   GIM_Reject,
     /* 748936 */   // Label 9808: @748936
     /* 748936 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(748956), // Rule ID 15 //
     /* 748941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 748949 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13728>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 748949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 748954 */     GIR_RootConstrainSelectedInstOperands,
     /* 748955 */     // GIR_Coverage, 15,
     /* 748955 */     GIR_Done,
     /* 748956 */   // Label 9811: @748956
     /* 748956 */   GIM_Reject,
     /* 748957 */   // Label 9809: @748957
     /* 748957 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(748988), // Rule ID 682 //
     /* 748962 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748976 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 748979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748986 */     GIR_RootConstrainSelectedInstOperands,
     /* 748987 */     // GIR_Coverage, 682,
     /* 748987 */     GIR_EraseRootFromParent_Done,
     /* 748988 */   // Label 9812: @748988
     /* 748988 */   GIM_Reject,
     /* 748989 */ // Label 9806: @748989
     /* 748989 */ GIM_Reject,
     /* 748990 */ // Label 150: @748990
     /* 748990 */ GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(749088),
     /* 748995 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748998 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9816*/ GIMT_Encode4(749087),
     /* 749009 */   /*GILLT_s32*//*Label 9814*/ GIMT_Encode4(749017),
     /* 749013 */   /*GILLT_s64*//*Label 9815*/ GIMT_Encode4(749066),
     /* 749017 */   // Label 9814: @749017
     /* 749017 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(749037), // Rule ID 11 //
     /* 749022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 749026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13727),
     /* 749030 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13727>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 749030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 749035 */     GIR_RootConstrainSelectedInstOperands,
     /* 749036 */     // GIR_Coverage, 11,
     /* 749036 */     GIR_Done,
     /* 749037 */   // Label 9817: @749037
     /* 749037 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(749065), // Rule ID 684 //
     /* 749042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749053 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 749053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 749056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749063 */     GIR_RootConstrainSelectedInstOperands,
     /* 749064 */     // GIR_Coverage, 684,
     /* 749064 */     GIR_EraseRootFromParent_Done,
     /* 749065 */   // Label 9818: @749065
     /* 749065 */   GIM_Reject,
     /* 749066 */   // Label 9815: @749066
     /* 749066 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(749086), // Rule ID 9 //
     /* 749071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 749075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13727),
     /* 749079 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13727>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 749079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 749084 */     GIR_RootConstrainSelectedInstOperands,
     /* 749085 */     // GIR_Coverage, 9,
     /* 749085 */     GIR_Done,
     /* 749086 */   // Label 9819: @749086
     /* 749086 */   GIM_Reject,
     /* 749087 */   // Label 9816: @749087
     /* 749087 */   GIM_Reject,
     /* 749088 */ // Label 9813: @749088
     /* 749088 */ GIM_Reject,
     /* 749089 */ // Label 151: @749089
     /* 749089 */ GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(749161), // Rule ID 833 //
     /* 749094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 749097 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 749100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749110 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749124 */   // (AMDGPUfmax_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_LEGACY_F32_e64),
     /* 749127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749159 */   GIR_RootConstrainSelectedInstOperands,
     /* 749160 */   // GIR_Coverage, 833,
     /* 749160 */   GIR_EraseRootFromParent_Done,
     /* 749161 */ // Label 9820: @749161
     /* 749161 */ GIM_Reject,
     /* 749162 */ // Label 152: @749162
     /* 749162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9823*/ GIMT_Encode4(749521),
     /* 749173 */ /*GILLT_s16*//*Label 9821*/ GIMT_Encode4(749181),
     /* 749177 */ /*GILLT_s32*//*Label 9822*/ GIMT_Encode4(749434),
     /* 749181 */ // Label 9821: @749181
     /* 749181 */ GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(749433),
     /* 749186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 749189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 749192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 749195 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(749274), // Rule ID 1019 //
     /* 749200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 749203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749228 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 749228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 749231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749272 */     GIR_RootConstrainSelectedInstOperands,
     /* 749273 */     // GIR_Coverage, 1019,
     /* 749273 */     GIR_EraseRootFromParent_Done,
     /* 749274 */   // Label 9825: @749274
     /* 749274 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(749353), // Rule ID 1021 //
     /* 749279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 749282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 749286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749307 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 749307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 749310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749351 */     GIR_RootConstrainSelectedInstOperands,
     /* 749352 */     // GIR_Coverage, 1021,
     /* 749352 */     GIR_EraseRootFromParent_Done,
     /* 749353 */   // Label 9826: @749353
     /* 749353 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(749432), // Rule ID 1023 //
     /* 749358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 749361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749386 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 749386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 749389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749430 */     GIR_RootConstrainSelectedInstOperands,
     /* 749431 */     // GIR_Coverage, 1023,
     /* 749431 */     GIR_EraseRootFromParent_Done,
     /* 749432 */   // Label 9827: @749432
     /* 749432 */   GIM_Reject,
     /* 749433 */ // Label 9824: @749433
     /* 749433 */ GIM_Reject,
     /* 749434 */ // Label 9822: @749434
     /* 749434 */ GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(749520), // Rule ID 972 //
     /* 749439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749473 */   // (AMDGPUfmed3_impl:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 749476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749518 */   GIR_RootConstrainSelectedInstOperands,
     /* 749519 */   // GIR_Coverage, 972,
     /* 749519 */   GIR_EraseRootFromParent_Done,
     /* 749520 */ // Label 9828: @749520
     /* 749520 */ GIM_Reject,
     /* 749521 */ // Label 9823: @749521
     /* 749521 */ GIM_Reject,
     /* 749522 */ // Label 153: @749522
     /* 749522 */ GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(749594), // Rule ID 832 //
     /* 749527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 749530 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 749533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749557 */   // (AMDGPUfmin_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_LEGACY_F32_e64),
     /* 749560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749592 */   GIR_RootConstrainSelectedInstOperands,
     /* 749593 */   // GIR_Coverage, 832,
     /* 749593 */   GIR_EraseRootFromParent_Done,
     /* 749594 */ // Label 9829: @749594
     /* 749594 */ GIM_Reject,
     /* 749595 */ // Label 154: @749595
     /* 749595 */ GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(749644), // Rule ID 667 //
     /* 749600 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 749603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749617 */   // (AMDGPUrcp_iflag:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_IFLAG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_IFLAG_F32_e64),
     /* 749620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749642 */   GIR_RootConstrainSelectedInstOperands,
     /* 749643 */   // GIR_Coverage, 667,
     /* 749643 */   GIR_EraseRootFromParent_Done,
     /* 749644 */ // Label 9830: @749644
     /* 749644 */ GIM_Reject,
     /* 749645 */ // Label 155: @749645
     /* 749645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9833*/ GIMT_Encode4(749950),
     /* 749656 */ /*GILLT_s16*//*Label 9831*/ GIMT_Encode4(749664),
     /* 749660 */ /*GILLT_s32*//*Label 9832*/ GIMT_Encode4(749908),
     /* 749664 */ // Label 9831: @749664
     /* 749664 */ GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(749907),
     /* 749669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 749672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 749675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 749678 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(749754), // Rule ID 1024 //
     /* 749683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 749686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749711 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 749714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749752 */     GIR_RootConstrainSelectedInstOperands,
     /* 749753 */     // GIR_Coverage, 1024,
     /* 749753 */     GIR_EraseRootFromParent_Done,
     /* 749754 */   // Label 9835: @749754
     /* 749754 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(749830), // Rule ID 1025 //
     /* 749759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 749762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 749766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749787 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 749790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749828 */     GIR_RootConstrainSelectedInstOperands,
     /* 749829 */     // GIR_Coverage, 1025,
     /* 749829 */     GIR_EraseRootFromParent_Done,
     /* 749830 */   // Label 9836: @749830
     /* 749830 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(749906), // Rule ID 1026 //
     /* 749835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 749838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749863 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 749866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749904 */     GIR_RootConstrainSelectedInstOperands,
     /* 749905 */     // GIR_Coverage, 1026,
     /* 749905 */     GIR_EraseRootFromParent_Done,
     /* 749906 */   // Label 9837: @749906
     /* 749906 */   GIM_Reject,
     /* 749907 */ // Label 9834: @749907
     /* 749907 */ GIM_Reject,
     /* 749908 */ // Label 9832: @749908
     /* 749908 */ GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(749949), // Rule ID 967 //
     /* 749913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749933 */   // (AMDGPUsmed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 749933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 749936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749943 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 749945 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 749947 */   GIR_RootConstrainSelectedInstOperands,
     /* 749948 */   // GIR_Coverage, 967,
     /* 749948 */   GIR_EraseRootFromParent_Done,
     /* 749949 */ // Label 9838: @749949
     /* 749949 */ GIM_Reject,
     /* 749950 */ // Label 9833: @749950
     /* 749950 */ GIM_Reject,
     /* 749951 */ // Label 156: @749951
     /* 749951 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(31), /*)*//*default:*//*Label 9845*/ GIMT_Encode4(752252),
     /* 749962 */ /*GILLT_s32*//*Label 9839*/ GIMT_Encode4(750050), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749974 */ /*GILLT_v2s32*//*Label 9840*/ GIMT_Encode4(750430), GIMT_Encode4(0),
     /* 749982 */ /*GILLT_v3s32*//*Label 9841*/ GIMT_Encode4(750810), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749994 */ /*GILLT_v4s32*//*Label 9842*/ GIMT_Encode4(751112), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 750018 */ /*GILLT_v8s32*//*Label 9843*/ GIMT_Encode4(751492), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 750046 */ /*GILLT_v16s32*//*Label 9844*/ GIMT_Encode4(751872),
     /* 750050 */ // Label 9839: @750050
     /* 750050 */ GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(750429),
     /* 750055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 750065 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750068 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(750112), // Rule ID 2895 //
     /* 750073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750083 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750088 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750110 */     GIR_RootConstrainSelectedInstOperands,
     /* 750111 */     // GIR_Coverage, 2895,
     /* 750111 */     GIR_EraseRootFromParent_Done,
     /* 750112 */   // Label 9847: @750112
     /* 750112 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(750156), // Rule ID 3500 //
     /* 750117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750127 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750132 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750154 */     GIR_RootConstrainSelectedInstOperands,
     /* 750155 */     // GIR_Coverage, 3500,
     /* 750155 */     GIR_EraseRootFromParent_Done,
     /* 750156 */   // Label 9848: @750156
     /* 750156 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(750192), // Rule ID 2891 //
     /* 750161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750168 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 750171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750173 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750190 */     GIR_RootConstrainSelectedInstOperands,
     /* 750191 */     // GIR_Coverage, 2891,
     /* 750191 */     GIR_EraseRootFromParent_Done,
     /* 750192 */   // Label 9849: @750192
     /* 750192 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(750228), // Rule ID 3496 //
     /* 750197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750204 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 750207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750209 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750226 */     GIR_RootConstrainSelectedInstOperands,
     /* 750227 */     // GIR_Coverage, 3496,
     /* 750227 */     GIR_EraseRootFromParent_Done,
     /* 750228 */   // Label 9850: @750228
     /* 750228 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(750267), // Rule ID 2892 //
     /* 750233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750243 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 750246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750248 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750255 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750265 */     GIR_RootConstrainSelectedInstOperands,
     /* 750266 */     // GIR_Coverage, 2892,
     /* 750266 */     GIR_EraseRootFromParent_Done,
     /* 750267 */   // Label 9851: @750267
     /* 750267 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(750306), // Rule ID 3497 //
     /* 750272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750282 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 750285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750287 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750304 */     GIR_RootConstrainSelectedInstOperands,
     /* 750305 */     // GIR_Coverage, 3497,
     /* 750305 */     GIR_EraseRootFromParent_Done,
     /* 750306 */   // Label 9852: @750306
     /* 750306 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(750335), // Rule ID 2893 //
     /* 750311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750314 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 750317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750319 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750321 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750333 */     GIR_RootConstrainSelectedInstOperands,
     /* 750334 */     // GIR_Coverage, 2893,
     /* 750334 */     GIR_EraseRootFromParent_Done,
     /* 750335 */   // Label 9853: @750335
     /* 750335 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(750367), // Rule ID 2894 //
     /* 750340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750343 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750348 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750350 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750365 */     GIR_RootConstrainSelectedInstOperands,
     /* 750366 */     // GIR_Coverage, 2894,
     /* 750366 */     GIR_EraseRootFromParent_Done,
     /* 750367 */   // Label 9854: @750367
     /* 750367 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(750396), // Rule ID 3498 //
     /* 750372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750375 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 750378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750380 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750382 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750394 */     GIR_RootConstrainSelectedInstOperands,
     /* 750395 */     // GIR_Coverage, 3498,
     /* 750395 */     GIR_EraseRootFromParent_Done,
     /* 750396 */   // Label 9855: @750396
     /* 750396 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(750428), // Rule ID 3499 //
     /* 750401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750404 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750409 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750411 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750426 */     GIR_RootConstrainSelectedInstOperands,
     /* 750427 */     // GIR_Coverage, 3499,
     /* 750427 */     GIR_EraseRootFromParent_Done,
     /* 750428 */   // Label 9856: @750428
     /* 750428 */   GIM_Reject,
     /* 750429 */ // Label 9846: @750429
     /* 750429 */ GIM_Reject,
     /* 750430 */ // Label 9840: @750430
     /* 750430 */ GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(750809),
     /* 750435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 750445 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750448 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(750492), // Rule ID 3476 //
     /* 750453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750463 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750468 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750490 */     GIR_RootConstrainSelectedInstOperands,
     /* 750491 */     // GIR_Coverage, 3476,
     /* 750491 */     GIR_EraseRootFromParent_Done,
     /* 750492 */   // Label 9858: @750492
     /* 750492 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(750536), // Rule ID 3505 //
     /* 750497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750507 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750512 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750534 */     GIR_RootConstrainSelectedInstOperands,
     /* 750535 */     // GIR_Coverage, 3505,
     /* 750535 */     GIR_EraseRootFromParent_Done,
     /* 750536 */   // Label 9859: @750536
     /* 750536 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(750572), // Rule ID 3472 //
     /* 750541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750548 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 750551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750553 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750570 */     GIR_RootConstrainSelectedInstOperands,
     /* 750571 */     // GIR_Coverage, 3472,
     /* 750571 */     GIR_EraseRootFromParent_Done,
     /* 750572 */   // Label 9860: @750572
     /* 750572 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(750608), // Rule ID 3501 //
     /* 750577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750584 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 750587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750589 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750606 */     GIR_RootConstrainSelectedInstOperands,
     /* 750607 */     // GIR_Coverage, 3501,
     /* 750607 */     GIR_EraseRootFromParent_Done,
     /* 750608 */   // Label 9861: @750608
     /* 750608 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(750647), // Rule ID 3473 //
     /* 750613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750623 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 750626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750628 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750645 */     GIR_RootConstrainSelectedInstOperands,
     /* 750646 */     // GIR_Coverage, 3473,
     /* 750646 */     GIR_EraseRootFromParent_Done,
     /* 750647 */   // Label 9862: @750647
     /* 750647 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(750686), // Rule ID 3502 //
     /* 750652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750662 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 750665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750667 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750684 */     GIR_RootConstrainSelectedInstOperands,
     /* 750685 */     // GIR_Coverage, 3502,
     /* 750685 */     GIR_EraseRootFromParent_Done,
     /* 750686 */   // Label 9863: @750686
     /* 750686 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(750715), // Rule ID 3474 //
     /* 750691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750694 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 750697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750699 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750701 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750713 */     GIR_RootConstrainSelectedInstOperands,
     /* 750714 */     // GIR_Coverage, 3474,
     /* 750714 */     GIR_EraseRootFromParent_Done,
     /* 750715 */   // Label 9864: @750715
     /* 750715 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(750747), // Rule ID 3475 //
     /* 750720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750723 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750728 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750730 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750745 */     GIR_RootConstrainSelectedInstOperands,
     /* 750746 */     // GIR_Coverage, 3475,
     /* 750746 */     GIR_EraseRootFromParent_Done,
     /* 750747 */   // Label 9865: @750747
     /* 750747 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(750776), // Rule ID 3503 //
     /* 750752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750755 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 750758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750760 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750762 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750774 */     GIR_RootConstrainSelectedInstOperands,
     /* 750775 */     // GIR_Coverage, 3503,
     /* 750775 */     GIR_EraseRootFromParent_Done,
     /* 750776 */   // Label 9866: @750776
     /* 750776 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(750808), // Rule ID 3504 //
     /* 750781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750784 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750789 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750791 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750806 */     GIR_RootConstrainSelectedInstOperands,
     /* 750807 */     // GIR_Coverage, 3504,
     /* 750807 */     GIR_EraseRootFromParent_Done,
     /* 750808 */   // Label 9867: @750808
     /* 750808 */   GIM_Reject,
     /* 750809 */ // Label 9857: @750809
     /* 750809 */ GIM_Reject,
     /* 750810 */ // Label 9841: @750810
     /* 750810 */ GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(751111),
     /* 750815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 750825 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750828 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(750872), // Rule ID 3480 //
     /* 750833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750843 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750848 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750870 */     GIR_RootConstrainSelectedInstOperands,
     /* 750871 */     // GIR_Coverage, 3480,
     /* 750871 */     GIR_EraseRootFromParent_Done,
     /* 750872 */   // Label 9869: @750872
     /* 750872 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(750916), // Rule ID 3509 //
     /* 750877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750887 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750892 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750914 */     GIR_RootConstrainSelectedInstOperands,
     /* 750915 */     // GIR_Coverage, 3509,
     /* 750915 */     GIR_EraseRootFromParent_Done,
     /* 750916 */   // Label 9870: @750916
     /* 750916 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(750952), // Rule ID 3477 //
     /* 750921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750928 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 750931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750933 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750950 */     GIR_RootConstrainSelectedInstOperands,
     /* 750951 */     // GIR_Coverage, 3477,
     /* 750951 */     GIR_EraseRootFromParent_Done,
     /* 750952 */   // Label 9871: @750952
     /* 750952 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(750988), // Rule ID 3506 //
     /* 750957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750964 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 750967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750969 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750986 */     GIR_RootConstrainSelectedInstOperands,
     /* 750987 */     // GIR_Coverage, 3506,
     /* 750987 */     GIR_EraseRootFromParent_Done,
     /* 750988 */   // Label 9872: @750988
     /* 750988 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(751017), // Rule ID 3478 //
     /* 750993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750996 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 750999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751001 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751003 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751015 */     GIR_RootConstrainSelectedInstOperands,
     /* 751016 */     // GIR_Coverage, 3478,
     /* 751016 */     GIR_EraseRootFromParent_Done,
     /* 751017 */   // Label 9873: @751017
     /* 751017 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(751049), // Rule ID 3479 //
     /* 751022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751025 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 751028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751030 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751032 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751047 */     GIR_RootConstrainSelectedInstOperands,
     /* 751048 */     // GIR_Coverage, 3479,
     /* 751048 */     GIR_EraseRootFromParent_Done,
     /* 751049 */   // Label 9874: @751049
     /* 751049 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(751078), // Rule ID 3507 //
     /* 751054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751057 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 751060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751062 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751064 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751076 */     GIR_RootConstrainSelectedInstOperands,
     /* 751077 */     // GIR_Coverage, 3507,
     /* 751077 */     GIR_EraseRootFromParent_Done,
     /* 751078 */   // Label 9875: @751078
     /* 751078 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(751110), // Rule ID 3508 //
     /* 751083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751086 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 751089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751091 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751093 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751108 */     GIR_RootConstrainSelectedInstOperands,
     /* 751109 */     // GIR_Coverage, 3508,
     /* 751109 */     GIR_EraseRootFromParent_Done,
     /* 751110 */   // Label 9876: @751110
     /* 751110 */   GIM_Reject,
     /* 751111 */ // Label 9868: @751111
     /* 751111 */ GIM_Reject,
     /* 751112 */ // Label 9842: @751112
     /* 751112 */ GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(751491),
     /* 751117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 751127 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751130 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(751174), // Rule ID 3485 //
     /* 751135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751145 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751150 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751172 */     GIR_RootConstrainSelectedInstOperands,
     /* 751173 */     // GIR_Coverage, 3485,
     /* 751173 */     GIR_EraseRootFromParent_Done,
     /* 751174 */   // Label 9878: @751174
     /* 751174 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(751218), // Rule ID 3514 //
     /* 751179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751189 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751194 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751216 */     GIR_RootConstrainSelectedInstOperands,
     /* 751217 */     // GIR_Coverage, 3514,
     /* 751217 */     GIR_EraseRootFromParent_Done,
     /* 751218 */   // Label 9879: @751218
     /* 751218 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(751254), // Rule ID 3481 //
     /* 751223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751230 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 751233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751235 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751252 */     GIR_RootConstrainSelectedInstOperands,
     /* 751253 */     // GIR_Coverage, 3481,
     /* 751253 */     GIR_EraseRootFromParent_Done,
     /* 751254 */   // Label 9880: @751254
     /* 751254 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(751290), // Rule ID 3510 //
     /* 751259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751266 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 751269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751271 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751288 */     GIR_RootConstrainSelectedInstOperands,
     /* 751289 */     // GIR_Coverage, 3510,
     /* 751289 */     GIR_EraseRootFromParent_Done,
     /* 751290 */   // Label 9881: @751290
     /* 751290 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(751329), // Rule ID 3482 //
     /* 751295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751305 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 751308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751310 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751327 */     GIR_RootConstrainSelectedInstOperands,
     /* 751328 */     // GIR_Coverage, 3482,
     /* 751328 */     GIR_EraseRootFromParent_Done,
     /* 751329 */   // Label 9882: @751329
     /* 751329 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(751368), // Rule ID 3511 //
     /* 751334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751344 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 751347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751349 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751366 */     GIR_RootConstrainSelectedInstOperands,
     /* 751367 */     // GIR_Coverage, 3511,
     /* 751367 */     GIR_EraseRootFromParent_Done,
     /* 751368 */   // Label 9883: @751368
     /* 751368 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(751397), // Rule ID 3483 //
     /* 751373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751376 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 751379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751381 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751383 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751395 */     GIR_RootConstrainSelectedInstOperands,
     /* 751396 */     // GIR_Coverage, 3483,
     /* 751396 */     GIR_EraseRootFromParent_Done,
     /* 751397 */   // Label 9884: @751397
     /* 751397 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(751429), // Rule ID 3484 //
     /* 751402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751405 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751410 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751412 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751427 */     GIR_RootConstrainSelectedInstOperands,
     /* 751428 */     // GIR_Coverage, 3484,
     /* 751428 */     GIR_EraseRootFromParent_Done,
     /* 751429 */   // Label 9885: @751429
     /* 751429 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(751458), // Rule ID 3512 //
     /* 751434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751437 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 751440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751442 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751444 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751456 */     GIR_RootConstrainSelectedInstOperands,
     /* 751457 */     // GIR_Coverage, 3512,
     /* 751457 */     GIR_EraseRootFromParent_Done,
     /* 751458 */   // Label 9886: @751458
     /* 751458 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(751490), // Rule ID 3513 //
     /* 751463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751466 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751471 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751473 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751488 */     GIR_RootConstrainSelectedInstOperands,
     /* 751489 */     // GIR_Coverage, 3513,
     /* 751489 */     GIR_EraseRootFromParent_Done,
     /* 751490 */   // Label 9887: @751490
     /* 751490 */   GIM_Reject,
     /* 751491 */ // Label 9877: @751491
     /* 751491 */ GIM_Reject,
     /* 751492 */ // Label 9843: @751492
     /* 751492 */ GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(751871),
     /* 751497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 751507 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751510 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(751554), // Rule ID 3490 //
     /* 751515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751525 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751530 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751552 */     GIR_RootConstrainSelectedInstOperands,
     /* 751553 */     // GIR_Coverage, 3490,
     /* 751553 */     GIR_EraseRootFromParent_Done,
     /* 751554 */   // Label 9889: @751554
     /* 751554 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(751598), // Rule ID 3519 //
     /* 751559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751569 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751574 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751596 */     GIR_RootConstrainSelectedInstOperands,
     /* 751597 */     // GIR_Coverage, 3519,
     /* 751597 */     GIR_EraseRootFromParent_Done,
     /* 751598 */   // Label 9890: @751598
     /* 751598 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(751634), // Rule ID 3486 //
     /* 751603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751610 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 751613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751615 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751632 */     GIR_RootConstrainSelectedInstOperands,
     /* 751633 */     // GIR_Coverage, 3486,
     /* 751633 */     GIR_EraseRootFromParent_Done,
     /* 751634 */   // Label 9891: @751634
     /* 751634 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(751670), // Rule ID 3515 //
     /* 751639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751646 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 751649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751651 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751668 */     GIR_RootConstrainSelectedInstOperands,
     /* 751669 */     // GIR_Coverage, 3515,
     /* 751669 */     GIR_EraseRootFromParent_Done,
     /* 751670 */   // Label 9892: @751670
     /* 751670 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(751709), // Rule ID 3487 //
     /* 751675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751685 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 751688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751690 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751707 */     GIR_RootConstrainSelectedInstOperands,
     /* 751708 */     // GIR_Coverage, 3487,
     /* 751708 */     GIR_EraseRootFromParent_Done,
     /* 751709 */   // Label 9893: @751709
     /* 751709 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(751748), // Rule ID 3516 //
     /* 751714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751724 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 751727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751729 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751746 */     GIR_RootConstrainSelectedInstOperands,
     /* 751747 */     // GIR_Coverage, 3516,
     /* 751747 */     GIR_EraseRootFromParent_Done,
     /* 751748 */   // Label 9894: @751748
     /* 751748 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(751777), // Rule ID 3488 //
     /* 751753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751756 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 751759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751761 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751763 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751775 */     GIR_RootConstrainSelectedInstOperands,
     /* 751776 */     // GIR_Coverage, 3488,
     /* 751776 */     GIR_EraseRootFromParent_Done,
     /* 751777 */   // Label 9895: @751777
     /* 751777 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(751809), // Rule ID 3489 //
     /* 751782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751785 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751790 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751792 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751807 */     GIR_RootConstrainSelectedInstOperands,
     /* 751808 */     // GIR_Coverage, 3489,
     /* 751808 */     GIR_EraseRootFromParent_Done,
     /* 751809 */   // Label 9896: @751809
     /* 751809 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(751838), // Rule ID 3517 //
     /* 751814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751817 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 751820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751822 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751824 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751836 */     GIR_RootConstrainSelectedInstOperands,
     /* 751837 */     // GIR_Coverage, 3517,
     /* 751837 */     GIR_EraseRootFromParent_Done,
     /* 751838 */   // Label 9897: @751838
     /* 751838 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(751870), // Rule ID 3518 //
     /* 751843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751846 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751851 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751853 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751868 */     GIR_RootConstrainSelectedInstOperands,
     /* 751869 */     // GIR_Coverage, 3518,
     /* 751869 */     GIR_EraseRootFromParent_Done,
     /* 751870 */   // Label 9898: @751870
     /* 751870 */   GIM_Reject,
     /* 751871 */ // Label 9888: @751871
     /* 751871 */ GIM_Reject,
     /* 751872 */ // Label 9844: @751872
     /* 751872 */ GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(752251),
     /* 751877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 751887 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751890 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(751934), // Rule ID 3495 //
     /* 751895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751905 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751910 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751932 */     GIR_RootConstrainSelectedInstOperands,
     /* 751933 */     // GIR_Coverage, 3495,
     /* 751933 */     GIR_EraseRootFromParent_Done,
     /* 751934 */   // Label 9900: @751934
     /* 751934 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(751978), // Rule ID 3524 //
     /* 751939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751949 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751954 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751976 */     GIR_RootConstrainSelectedInstOperands,
     /* 751977 */     // GIR_Coverage, 3524,
     /* 751977 */     GIR_EraseRootFromParent_Done,
     /* 751978 */   // Label 9901: @751978
     /* 751978 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(752014), // Rule ID 3491 //
     /* 751983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751990 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 751993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751995 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752012 */     GIR_RootConstrainSelectedInstOperands,
     /* 752013 */     // GIR_Coverage, 3491,
     /* 752013 */     GIR_EraseRootFromParent_Done,
     /* 752014 */   // Label 9902: @752014
     /* 752014 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(752050), // Rule ID 3520 //
     /* 752019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752026 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 752029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752031 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752038 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752048 */     GIR_RootConstrainSelectedInstOperands,
     /* 752049 */     // GIR_Coverage, 3520,
     /* 752049 */     GIR_EraseRootFromParent_Done,
     /* 752050 */   // Label 9903: @752050
     /* 752050 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(752089), // Rule ID 3492 //
     /* 752055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 752058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 752065 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 752068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752070 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752087 */     GIR_RootConstrainSelectedInstOperands,
     /* 752088 */     // GIR_Coverage, 3492,
     /* 752088 */     GIR_EraseRootFromParent_Done,
     /* 752089 */   // Label 9904: @752089
     /* 752089 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(752128), // Rule ID 3521 //
     /* 752094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 752097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 752104 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 752107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752109 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752126 */     GIR_RootConstrainSelectedInstOperands,
     /* 752127 */     // GIR_Coverage, 3521,
     /* 752127 */     GIR_EraseRootFromParent_Done,
     /* 752128 */   // Label 9905: @752128
     /* 752128 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(752157), // Rule ID 3493 //
     /* 752133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 752136 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 752139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752141 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752143 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752155 */     GIR_RootConstrainSelectedInstOperands,
     /* 752156 */     // GIR_Coverage, 3493,
     /* 752156 */     GIR_EraseRootFromParent_Done,
     /* 752157 */   // Label 9906: @752157
     /* 752157 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(752189), // Rule ID 3494 //
     /* 752162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 752165 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 752168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752170 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752172 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752187 */     GIR_RootConstrainSelectedInstOperands,
     /* 752188 */     // GIR_Coverage, 3494,
     /* 752188 */     GIR_EraseRootFromParent_Done,
     /* 752189 */   // Label 9907: @752189
     /* 752189 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(752218), // Rule ID 3522 //
     /* 752194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 752197 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 752200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752202 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752204 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752216 */     GIR_RootConstrainSelectedInstOperands,
     /* 752217 */     // GIR_Coverage, 3522,
     /* 752217 */     GIR_EraseRootFromParent_Done,
     /* 752218 */   // Label 9908: @752218
     /* 752218 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(752250), // Rule ID 3523 //
     /* 752223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 752226 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 752229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752231 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752233 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752248 */     GIR_RootConstrainSelectedInstOperands,
     /* 752249 */     // GIR_Coverage, 3523,
     /* 752249 */     GIR_EraseRootFromParent_Done,
     /* 752250 */   // Label 9909: @752250
     /* 752250 */   GIM_Reject,
     /* 752251 */ // Label 9899: @752251
     /* 752251 */ GIM_Reject,
     /* 752252 */ // Label 9845: @752252
     /* 752252 */ GIM_Reject,
     /* 752253 */ // Label 157: @752253
     /* 752253 */ GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(752390),
     /* 752258 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752271 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752274 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(752318), // Rule ID 2902 //
     /* 752279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752289 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 752292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752294 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752316 */     GIR_RootConstrainSelectedInstOperands,
     /* 752317 */     // GIR_Coverage, 2902,
     /* 752317 */     GIR_EraseRootFromParent_Done,
     /* 752318 */   // Label 9911: @752318
     /* 752318 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(752357), // Rule ID 2900 //
     /* 752323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752333 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_IMM),
     /* 752336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752338 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752355 */     GIR_RootConstrainSelectedInstOperands,
     /* 752356 */     // GIR_Coverage, 2900,
     /* 752356 */     GIR_EraseRootFromParent_Done,
     /* 752357 */   // Label 9912: @752357
     /* 752357 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(752389), // Rule ID 2901 //
     /* 752362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752365 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 752368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752370 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752372 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752387 */     GIR_RootConstrainSelectedInstOperands,
     /* 752388 */     // GIR_Coverage, 2901,
     /* 752388 */     GIR_EraseRootFromParent_Done,
     /* 752389 */   // Label 9913: @752389
     /* 752389 */   GIM_Reject,
     /* 752390 */ // Label 9910: @752390
     /* 752390 */ GIM_Reject,
     /* 752391 */ // Label 158: @752391
     /* 752391 */ GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(752528),
     /* 752396 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752409 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752412 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(752456), // Rule ID 2928 //
     /* 752417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752427 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 752430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752432 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752454 */     GIR_RootConstrainSelectedInstOperands,
     /* 752455 */     // GIR_Coverage, 2928,
     /* 752455 */     GIR_EraseRootFromParent_Done,
     /* 752456 */   // Label 9915: @752456
     /* 752456 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(752495), // Rule ID 2926 //
     /* 752461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752471 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_IMM),
     /* 752474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752476 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752493 */     GIR_RootConstrainSelectedInstOperands,
     /* 752494 */     // GIR_Coverage, 2926,
     /* 752494 */     GIR_EraseRootFromParent_Done,
     /* 752495 */   // Label 9916: @752495
     /* 752495 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(752527), // Rule ID 2927 //
     /* 752500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752503 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 752506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752508 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752510 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752525 */     GIR_RootConstrainSelectedInstOperands,
     /* 752526 */     // GIR_Coverage, 2927,
     /* 752526 */     GIR_EraseRootFromParent_Done,
     /* 752527 */   // Label 9917: @752527
     /* 752527 */   GIM_Reject,
     /* 752528 */ // Label 9914: @752528
     /* 752528 */ GIM_Reject,
     /* 752529 */ // Label 159: @752529
     /* 752529 */ GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(752666),
     /* 752534 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752547 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752550 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(752594), // Rule ID 2925 //
     /* 752555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752565 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 752568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752570 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752592 */     GIR_RootConstrainSelectedInstOperands,
     /* 752593 */     // GIR_Coverage, 2925,
     /* 752593 */     GIR_EraseRootFromParent_Done,
     /* 752594 */   // Label 9919: @752594
     /* 752594 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(752633), // Rule ID 2923 //
     /* 752599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752609 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_IMM),
     /* 752612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752614 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752631 */     GIR_RootConstrainSelectedInstOperands,
     /* 752632 */     // GIR_Coverage, 2923,
     /* 752632 */     GIR_EraseRootFromParent_Done,
     /* 752633 */   // Label 9920: @752633
     /* 752633 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(752665), // Rule ID 2924 //
     /* 752638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752641 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 752644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752646 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752648 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752663 */     GIR_RootConstrainSelectedInstOperands,
     /* 752664 */     // GIR_Coverage, 2924,
     /* 752664 */     GIR_EraseRootFromParent_Done,
     /* 752665 */   // Label 9921: @752665
     /* 752665 */   GIM_Reject,
     /* 752666 */ // Label 9918: @752666
     /* 752666 */ GIM_Reject,
     /* 752667 */ // Label 160: @752667
     /* 752667 */ GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(752804),
     /* 752672 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752685 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752688 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(752732), // Rule ID 2931 //
     /* 752693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752703 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 752706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752708 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752730 */     GIR_RootConstrainSelectedInstOperands,
     /* 752731 */     // GIR_Coverage, 2931,
     /* 752731 */     GIR_EraseRootFromParent_Done,
     /* 752732 */   // Label 9923: @752732
     /* 752732 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(752771), // Rule ID 2929 //
     /* 752737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752747 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_IMM),
     /* 752750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752752 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752769 */     GIR_RootConstrainSelectedInstOperands,
     /* 752770 */     // GIR_Coverage, 2929,
     /* 752770 */     GIR_EraseRootFromParent_Done,
     /* 752771 */   // Label 9924: @752771
     /* 752771 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(752803), // Rule ID 2930 //
     /* 752776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752779 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 752782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752784 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752786 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752801 */     GIR_RootConstrainSelectedInstOperands,
     /* 752802 */     // GIR_Coverage, 2930,
     /* 752802 */     GIR_EraseRootFromParent_Done,
     /* 752803 */   // Label 9925: @752803
     /* 752803 */   GIM_Reject,
     /* 752804 */ // Label 9922: @752804
     /* 752804 */ GIM_Reject,
     /* 752805 */ // Label 161: @752805
     /* 752805 */ GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(752911),
     /* 752810 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 752813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752816 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(752870), // Rule ID 3540 //
     /* 752821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 752828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 752832 */     // MIs[1] Operand 1
     /* 752832 */     // No operand predicates
     /* 752832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 752834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752841 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 752841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 752844 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 752846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 752857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 752863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 752868 */     GIR_RootConstrainSelectedInstOperands,
     /* 752869 */     // GIR_Coverage, 3540,
     /* 752869 */     GIR_EraseRootFromParent_Done,
     /* 752870 */   // Label 9927: @752870
     /* 752870 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(752910), // Rule ID 3539 //
     /* 752875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 752882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752889 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 752889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 752892 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 752894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752899 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 752901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752908 */     GIR_RootConstrainSelectedInstOperands,
     /* 752909 */     // GIR_Coverage, 3539,
     /* 752909 */     GIR_EraseRootFromParent_Done,
     /* 752910 */   // Label 9928: @752910
     /* 752910 */   GIM_Reject,
     /* 752911 */ // Label 9926: @752911
     /* 752911 */ GIM_Reject,
     /* 752912 */ // Label 162: @752912
     /* 752912 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9933*/ GIMT_Encode4(758395),
     /* 752923 */ /*GILLT_s32*//*Label 9929*/ GIMT_Encode4(752959), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 752935 */ /*GILLT_v2s32*//*Label 9930*/ GIMT_Encode4(754318), GIMT_Encode4(0),
     /* 752943 */ /*GILLT_v3s32*//*Label 9931*/ GIMT_Encode4(755677), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 752955 */ /*GILLT_v4s32*//*Label 9932*/ GIMT_Encode4(757036),
     /* 752959 */ // Label 9929: @752959
     /* 752959 */ GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(754317),
     /* 752964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 752973 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 752976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 752980 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(753061), // Rule ID 6652 //
     /* 752985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752996 */     // MIs[0] offset
     /* 752996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752999 */     // MIs[0] format
     /* 752999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753002 */     // MIs[0] auxiliary
     /* 753002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753005 */     // MIs[0] Operand 8
     /* 753005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753023 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 753026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753035 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753059 */     GIR_RootConstrainSelectedInstOperands,
     /* 753060 */     // GIR_Coverage, 6652,
     /* 753060 */     GIR_EraseRootFromParent_Done,
     /* 753061 */   // Label 9935: @753061
     /* 753061 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(753139), // Rule ID 6656 //
     /* 753066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753074 */     // MIs[0] offset
     /* 753074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753077 */     // MIs[0] format
     /* 753077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753080 */     // MIs[0] auxiliary
     /* 753080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753083 */     // MIs[0] Operand 8
     /* 753083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753101 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 753104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753113 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753137 */     GIR_RootConstrainSelectedInstOperands,
     /* 753138 */     // GIR_Coverage, 6656,
     /* 753138 */     GIR_EraseRootFromParent_Done,
     /* 753139 */   // Label 9936: @753139
     /* 753139 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(753220), // Rule ID 6684 //
     /* 753144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753155 */     // MIs[0] offset
     /* 753155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753158 */     // MIs[0] format
     /* 753158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753161 */     // MIs[0] auxiliary
     /* 753161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753164 */     // MIs[0] Operand 8
     /* 753164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753182 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 753185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753218 */     GIR_RootConstrainSelectedInstOperands,
     /* 753219 */     // GIR_Coverage, 6684,
     /* 753219 */     GIR_EraseRootFromParent_Done,
     /* 753220 */   // Label 9937: @753220
     /* 753220 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(753298), // Rule ID 6688 //
     /* 753225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753233 */     // MIs[0] offset
     /* 753233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753236 */     // MIs[0] format
     /* 753236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753239 */     // MIs[0] auxiliary
     /* 753239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753242 */     // MIs[0] Operand 8
     /* 753242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753260 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 753263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753272 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753296 */     GIR_RootConstrainSelectedInstOperands,
     /* 753297 */     // GIR_Coverage, 6688,
     /* 753297 */     GIR_EraseRootFromParent_Done,
     /* 753298 */   // Label 9938: @753298
     /* 753298 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(753377), // Rule ID 6654 //
     /* 753303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753310 */     // MIs[0] offset
     /* 753310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753313 */     // MIs[0] format
     /* 753313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753316 */     // MIs[0] auxiliary
     /* 753316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753319 */     // MIs[0] Operand 8
     /* 753319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753337 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 753340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753342 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753351 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753375 */     GIR_RootConstrainSelectedInstOperands,
     /* 753376 */     // GIR_Coverage, 6654,
     /* 753376 */     GIR_EraseRootFromParent_Done,
     /* 753377 */   // Label 9939: @753377
     /* 753377 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(753453), // Rule ID 6658 //
     /* 753382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753386 */     // MIs[0] offset
     /* 753386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753389 */     // MIs[0] format
     /* 753389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753392 */     // MIs[0] auxiliary
     /* 753392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753395 */     // MIs[0] Operand 8
     /* 753395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753413 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 753416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753418 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753427 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753451 */     GIR_RootConstrainSelectedInstOperands,
     /* 753452 */     // GIR_Coverage, 6658,
     /* 753452 */     GIR_EraseRootFromParent_Done,
     /* 753453 */   // Label 9940: @753453
     /* 753453 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(753532), // Rule ID 6686 //
     /* 753458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753465 */     // MIs[0] offset
     /* 753465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753468 */     // MIs[0] format
     /* 753468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753471 */     // MIs[0] auxiliary
     /* 753471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753474 */     // MIs[0] Operand 8
     /* 753474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753492 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 753495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753497 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753506 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753530 */     GIR_RootConstrainSelectedInstOperands,
     /* 753531 */     // GIR_Coverage, 6686,
     /* 753531 */     GIR_EraseRootFromParent_Done,
     /* 753532 */   // Label 9941: @753532
     /* 753532 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(753608), // Rule ID 6690 //
     /* 753537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753541 */     // MIs[0] offset
     /* 753541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753544 */     // MIs[0] format
     /* 753544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753547 */     // MIs[0] auxiliary
     /* 753547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753550 */     // MIs[0] Operand 8
     /* 753550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753568 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 753571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753573 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753582 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753606 */     GIR_RootConstrainSelectedInstOperands,
     /* 753607 */     // GIR_Coverage, 6690,
     /* 753607 */     GIR_EraseRootFromParent_Done,
     /* 753608 */   // Label 9942: @753608
     /* 753608 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(753679), // Rule ID 6653 //
     /* 753613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753620 */     // MIs[0] offset
     /* 753620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753623 */     // MIs[0] format
     /* 753623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753626 */     // MIs[0] auxiliary
     /* 753626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753629 */     // MIs[0] Operand 8
     /* 753629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753639 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 753642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753644 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753653 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753677 */     GIR_RootConstrainSelectedInstOperands,
     /* 753678 */     // GIR_Coverage, 6653,
     /* 753678 */     GIR_EraseRootFromParent_Done,
     /* 753679 */   // Label 9943: @753679
     /* 753679 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(753747), // Rule ID 6657 //
     /* 753684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753688 */     // MIs[0] offset
     /* 753688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753691 */     // MIs[0] format
     /* 753691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753694 */     // MIs[0] auxiliary
     /* 753694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753697 */     // MIs[0] Operand 8
     /* 753697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753707 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 753710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753712 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753721 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753745 */     GIR_RootConstrainSelectedInstOperands,
     /* 753746 */     // GIR_Coverage, 6657,
     /* 753746 */     GIR_EraseRootFromParent_Done,
     /* 753747 */   // Label 9944: @753747
     /* 753747 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(753818), // Rule ID 6685 //
     /* 753752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753759 */     // MIs[0] offset
     /* 753759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753762 */     // MIs[0] format
     /* 753762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753765 */     // MIs[0] auxiliary
     /* 753765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753768 */     // MIs[0] Operand 8
     /* 753768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753778 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 753781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753783 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753792 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753816 */     GIR_RootConstrainSelectedInstOperands,
     /* 753817 */     // GIR_Coverage, 6685,
     /* 753817 */     GIR_EraseRootFromParent_Done,
     /* 753818 */   // Label 9945: @753818
     /* 753818 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(753886), // Rule ID 6689 //
     /* 753823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753827 */     // MIs[0] offset
     /* 753827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753830 */     // MIs[0] format
     /* 753830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753833 */     // MIs[0] auxiliary
     /* 753833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753836 */     // MIs[0] Operand 8
     /* 753836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753846 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 753849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753851 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753860 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753884 */     GIR_RootConstrainSelectedInstOperands,
     /* 753885 */     // GIR_Coverage, 6689,
     /* 753885 */     GIR_EraseRootFromParent_Done,
     /* 753886 */   // Label 9946: @753886
     /* 753886 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(753995), // Rule ID 6655 //
     /* 753891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753894 */     // MIs[0] offset
     /* 753894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753897 */     // MIs[0] format
     /* 753897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753900 */     // MIs[0] auxiliary
     /* 753900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753903 */     // MIs[0] Operand 8
     /* 753903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753913 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753929 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753936 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 753957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753969 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753993 */     GIR_RootConstrainSelectedInstOperands,
     /* 753994 */     // GIR_Coverage, 6655,
     /* 753994 */     GIR_EraseRootFromParent_Done,
     /* 753995 */   // Label 9947: @753995
     /* 753995 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(754101), // Rule ID 6659 //
     /* 754000 */     // MIs[0] offset
     /* 754000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754003 */     // MIs[0] format
     /* 754003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754006 */     // MIs[0] auxiliary
     /* 754006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754009 */     // MIs[0] Operand 8
     /* 754009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754019 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 754022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 754026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 754031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 754035 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 754038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 754042 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 754045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 754050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 754063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 754068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754099 */     GIR_RootConstrainSelectedInstOperands,
     /* 754100 */     // GIR_Coverage, 6659,
     /* 754100 */     GIR_EraseRootFromParent_Done,
     /* 754101 */   // Label 9948: @754101
     /* 754101 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(754210), // Rule ID 6687 //
     /* 754106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754109 */     // MIs[0] offset
     /* 754109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754112 */     // MIs[0] format
     /* 754112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754115 */     // MIs[0] auxiliary
     /* 754115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754118 */     // MIs[0] Operand 8
     /* 754118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754128 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 754131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 754135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 754140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 754144 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 754147 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 754151 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 754154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 754159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 754172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 754177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754184 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754208 */     GIR_RootConstrainSelectedInstOperands,
     /* 754209 */     // GIR_Coverage, 6687,
     /* 754209 */     GIR_EraseRootFromParent_Done,
     /* 754210 */   // Label 9949: @754210
     /* 754210 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(754316), // Rule ID 6691 //
     /* 754215 */     // MIs[0] offset
     /* 754215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754218 */     // MIs[0] format
     /* 754218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754221 */     // MIs[0] auxiliary
     /* 754221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754224 */     // MIs[0] Operand 8
     /* 754224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754234 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 754237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 754241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 754246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 754250 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 754253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 754257 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 754260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 754265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 754278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 754283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754290 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754314 */     GIR_RootConstrainSelectedInstOperands,
     /* 754315 */     // GIR_Coverage, 6691,
     /* 754315 */     GIR_EraseRootFromParent_Done,
     /* 754316 */   // Label 9950: @754316
     /* 754316 */   GIM_Reject,
     /* 754317 */ // Label 9934: @754317
     /* 754317 */ GIM_Reject,
     /* 754318 */ // Label 9930: @754318
     /* 754318 */ GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(755676),
     /* 754323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 754326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 754332 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 754335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 754339 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(754420), // Rule ID 6660 //
     /* 754344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754355 */     // MIs[0] offset
     /* 754355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754358 */     // MIs[0] format
     /* 754358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754361 */     // MIs[0] auxiliary
     /* 754361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754364 */     // MIs[0] Operand 8
     /* 754364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754382 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 754385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754418 */     GIR_RootConstrainSelectedInstOperands,
     /* 754419 */     // GIR_Coverage, 6660,
     /* 754419 */     GIR_EraseRootFromParent_Done,
     /* 754420 */   // Label 9952: @754420
     /* 754420 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(754498), // Rule ID 6664 //
     /* 754425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754433 */     // MIs[0] offset
     /* 754433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754436 */     // MIs[0] format
     /* 754436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754439 */     // MIs[0] auxiliary
     /* 754439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754442 */     // MIs[0] Operand 8
     /* 754442 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754460 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 754463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754472 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754496 */     GIR_RootConstrainSelectedInstOperands,
     /* 754497 */     // GIR_Coverage, 6664,
     /* 754497 */     GIR_EraseRootFromParent_Done,
     /* 754498 */   // Label 9953: @754498
     /* 754498 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(754579), // Rule ID 6692 //
     /* 754503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754514 */     // MIs[0] offset
     /* 754514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754517 */     // MIs[0] format
     /* 754517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754520 */     // MIs[0] auxiliary
     /* 754520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754523 */     // MIs[0] Operand 8
     /* 754523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754541 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 754544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754553 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754555 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754577 */     GIR_RootConstrainSelectedInstOperands,
     /* 754578 */     // GIR_Coverage, 6692,
     /* 754578 */     GIR_EraseRootFromParent_Done,
     /* 754579 */   // Label 9954: @754579
     /* 754579 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(754657), // Rule ID 6696 //
     /* 754584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754592 */     // MIs[0] offset
     /* 754592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754595 */     // MIs[0] format
     /* 754595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754598 */     // MIs[0] auxiliary
     /* 754598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754601 */     // MIs[0] Operand 8
     /* 754601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754619 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 754622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754631 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754655 */     GIR_RootConstrainSelectedInstOperands,
     /* 754656 */     // GIR_Coverage, 6696,
     /* 754656 */     GIR_EraseRootFromParent_Done,
     /* 754657 */   // Label 9955: @754657
     /* 754657 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(754736), // Rule ID 6662 //
     /* 754662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754669 */     // MIs[0] offset
     /* 754669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754672 */     // MIs[0] format
     /* 754672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754675 */     // MIs[0] auxiliary
     /* 754675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754678 */     // MIs[0] Operand 8
     /* 754678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754696 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 754699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754701 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754710 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754734 */     GIR_RootConstrainSelectedInstOperands,
     /* 754735 */     // GIR_Coverage, 6662,
     /* 754735 */     GIR_EraseRootFromParent_Done,
     /* 754736 */   // Label 9956: @754736
     /* 754736 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(754812), // Rule ID 6666 //
     /* 754741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754745 */     // MIs[0] offset
     /* 754745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754748 */     // MIs[0] format
     /* 754748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754751 */     // MIs[0] auxiliary
     /* 754751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754754 */     // MIs[0] Operand 8
     /* 754754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754772 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 754775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754777 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754786 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754810 */     GIR_RootConstrainSelectedInstOperands,
     /* 754811 */     // GIR_Coverage, 6666,
     /* 754811 */     GIR_EraseRootFromParent_Done,
     /* 754812 */   // Label 9957: @754812
     /* 754812 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(754891), // Rule ID 6694 //
     /* 754817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754824 */     // MIs[0] offset
     /* 754824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754827 */     // MIs[0] format
     /* 754827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754830 */     // MIs[0] auxiliary
     /* 754830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754833 */     // MIs[0] Operand 8
     /* 754833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754851 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 754854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754856 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754865 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754889 */     GIR_RootConstrainSelectedInstOperands,
     /* 754890 */     // GIR_Coverage, 6694,
     /* 754890 */     GIR_EraseRootFromParent_Done,
     /* 754891 */   // Label 9958: @754891
     /* 754891 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(754967), // Rule ID 6698 //
     /* 754896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754900 */     // MIs[0] offset
     /* 754900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754903 */     // MIs[0] format
     /* 754903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754906 */     // MIs[0] auxiliary
     /* 754906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754909 */     // MIs[0] Operand 8
     /* 754909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754927 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 754930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754932 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754941 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754965 */     GIR_RootConstrainSelectedInstOperands,
     /* 754966 */     // GIR_Coverage, 6698,
     /* 754966 */     GIR_EraseRootFromParent_Done,
     /* 754967 */   // Label 9959: @754967
     /* 754967 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(755038), // Rule ID 6661 //
     /* 754972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754979 */     // MIs[0] offset
     /* 754979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754982 */     // MIs[0] format
     /* 754982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754985 */     // MIs[0] auxiliary
     /* 754985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754988 */     // MIs[0] Operand 8
     /* 754988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754998 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 755001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755003 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 755005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755012 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755036 */     GIR_RootConstrainSelectedInstOperands,
     /* 755037 */     // GIR_Coverage, 6661,
     /* 755037 */     GIR_EraseRootFromParent_Done,
     /* 755038 */   // Label 9960: @755038
     /* 755038 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(755106), // Rule ID 6665 //
     /* 755043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755047 */     // MIs[0] offset
     /* 755047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755050 */     // MIs[0] format
     /* 755050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755053 */     // MIs[0] auxiliary
     /* 755053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755056 */     // MIs[0] Operand 8
     /* 755056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755066 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 755069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755071 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 755073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755080 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755104 */     GIR_RootConstrainSelectedInstOperands,
     /* 755105 */     // GIR_Coverage, 6665,
     /* 755105 */     GIR_EraseRootFromParent_Done,
     /* 755106 */   // Label 9961: @755106
     /* 755106 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(755177), // Rule ID 6693 //
     /* 755111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755118 */     // MIs[0] offset
     /* 755118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755121 */     // MIs[0] format
     /* 755121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755124 */     // MIs[0] auxiliary
     /* 755124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755127 */     // MIs[0] Operand 8
     /* 755127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755137 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 755140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755142 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 755144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755151 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755175 */     GIR_RootConstrainSelectedInstOperands,
     /* 755176 */     // GIR_Coverage, 6693,
     /* 755176 */     GIR_EraseRootFromParent_Done,
     /* 755177 */   // Label 9962: @755177
     /* 755177 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(755245), // Rule ID 6697 //
     /* 755182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755186 */     // MIs[0] offset
     /* 755186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755189 */     // MIs[0] format
     /* 755189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755192 */     // MIs[0] auxiliary
     /* 755192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755195 */     // MIs[0] Operand 8
     /* 755195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755205 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 755208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755210 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 755212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755219 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755243 */     GIR_RootConstrainSelectedInstOperands,
     /* 755244 */     // GIR_Coverage, 6697,
     /* 755244 */     GIR_EraseRootFromParent_Done,
     /* 755245 */   // Label 9963: @755245
     /* 755245 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(755354), // Rule ID 6663 //
     /* 755250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755253 */     // MIs[0] offset
     /* 755253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755256 */     // MIs[0] format
     /* 755256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755259 */     // MIs[0] auxiliary
     /* 755259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755262 */     // MIs[0] Operand 8
     /* 755262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755272 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755288 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755295 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 755316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755328 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755352 */     GIR_RootConstrainSelectedInstOperands,
     /* 755353 */     // GIR_Coverage, 6663,
     /* 755353 */     GIR_EraseRootFromParent_Done,
     /* 755354 */   // Label 9964: @755354
     /* 755354 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(755460), // Rule ID 6667 //
     /* 755359 */     // MIs[0] offset
     /* 755359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755362 */     // MIs[0] format
     /* 755362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755365 */     // MIs[0] auxiliary
     /* 755365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755368 */     // MIs[0] Operand 8
     /* 755368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755378 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755394 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755401 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 755422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755434 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755458 */     GIR_RootConstrainSelectedInstOperands,
     /* 755459 */     // GIR_Coverage, 6667,
     /* 755459 */     GIR_EraseRootFromParent_Done,
     /* 755460 */   // Label 9965: @755460
     /* 755460 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(755569), // Rule ID 6695 //
     /* 755465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755468 */     // MIs[0] offset
     /* 755468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755471 */     // MIs[0] format
     /* 755471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755474 */     // MIs[0] auxiliary
     /* 755474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755477 */     // MIs[0] Operand 8
     /* 755477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755487 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755503 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755510 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 755531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755543 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755551 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755567 */     GIR_RootConstrainSelectedInstOperands,
     /* 755568 */     // GIR_Coverage, 6695,
     /* 755568 */     GIR_EraseRootFromParent_Done,
     /* 755569 */   // Label 9966: @755569
     /* 755569 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(755675), // Rule ID 6699 //
     /* 755574 */     // MIs[0] offset
     /* 755574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755577 */     // MIs[0] format
     /* 755577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755580 */     // MIs[0] auxiliary
     /* 755580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755583 */     // MIs[0] Operand 8
     /* 755583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755593 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755609 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755616 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 755637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755649 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755657 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755673 */     GIR_RootConstrainSelectedInstOperands,
     /* 755674 */     // GIR_Coverage, 6699,
     /* 755674 */     GIR_EraseRootFromParent_Done,
     /* 755675 */   // Label 9967: @755675
     /* 755675 */   GIM_Reject,
     /* 755676 */ // Label 9951: @755676
     /* 755676 */ GIM_Reject,
     /* 755677 */ // Label 9931: @755677
     /* 755677 */ GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(757035),
     /* 755682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 755685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 755688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 755691 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 755694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 755698 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(755779), // Rule ID 6668 //
     /* 755703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755714 */     // MIs[0] offset
     /* 755714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755717 */     // MIs[0] format
     /* 755717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755720 */     // MIs[0] auxiliary
     /* 755720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755723 */     // MIs[0] Operand 8
     /* 755723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755741 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 755744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755753 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755777 */     GIR_RootConstrainSelectedInstOperands,
     /* 755778 */     // GIR_Coverage, 6668,
     /* 755778 */     GIR_EraseRootFromParent_Done,
     /* 755779 */   // Label 9969: @755779
     /* 755779 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(755857), // Rule ID 6672 //
     /* 755784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755792 */     // MIs[0] offset
     /* 755792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755795 */     // MIs[0] format
     /* 755795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755798 */     // MIs[0] auxiliary
     /* 755798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755801 */     // MIs[0] Operand 8
     /* 755801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755819 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 755822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755831 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755855 */     GIR_RootConstrainSelectedInstOperands,
     /* 755856 */     // GIR_Coverage, 6672,
     /* 755856 */     GIR_EraseRootFromParent_Done,
     /* 755857 */   // Label 9970: @755857
     /* 755857 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(755938), // Rule ID 6700 //
     /* 755862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755873 */     // MIs[0] offset
     /* 755873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755876 */     // MIs[0] format
     /* 755876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755879 */     // MIs[0] auxiliary
     /* 755879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755882 */     // MIs[0] Operand 8
     /* 755882 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755900 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 755903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755912 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755936 */     GIR_RootConstrainSelectedInstOperands,
     /* 755937 */     // GIR_Coverage, 6700,
     /* 755937 */     GIR_EraseRootFromParent_Done,
     /* 755938 */   // Label 9971: @755938
     /* 755938 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(756016), // Rule ID 6704 //
     /* 755943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755951 */     // MIs[0] offset
     /* 755951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755954 */     // MIs[0] format
     /* 755954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755957 */     // MIs[0] auxiliary
     /* 755957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755960 */     // MIs[0] Operand 8
     /* 755960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755978 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 755981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755990 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756014 */     GIR_RootConstrainSelectedInstOperands,
     /* 756015 */     // GIR_Coverage, 6704,
     /* 756015 */     GIR_EraseRootFromParent_Done,
     /* 756016 */   // Label 9972: @756016
     /* 756016 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(756095), // Rule ID 6670 //
     /* 756021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756028 */     // MIs[0] offset
     /* 756028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756031 */     // MIs[0] format
     /* 756031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756034 */     // MIs[0] auxiliary
     /* 756034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756037 */     // MIs[0] Operand 8
     /* 756037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756055 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 756058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756060 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 756062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756069 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756093 */     GIR_RootConstrainSelectedInstOperands,
     /* 756094 */     // GIR_Coverage, 6670,
     /* 756094 */     GIR_EraseRootFromParent_Done,
     /* 756095 */   // Label 9973: @756095
     /* 756095 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(756171), // Rule ID 6674 //
     /* 756100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756104 */     // MIs[0] offset
     /* 756104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756107 */     // MIs[0] format
     /* 756107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756110 */     // MIs[0] auxiliary
     /* 756110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756113 */     // MIs[0] Operand 8
     /* 756113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756131 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 756134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756136 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 756138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756145 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756169 */     GIR_RootConstrainSelectedInstOperands,
     /* 756170 */     // GIR_Coverage, 6674,
     /* 756170 */     GIR_EraseRootFromParent_Done,
     /* 756171 */   // Label 9974: @756171
     /* 756171 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(756250), // Rule ID 6702 //
     /* 756176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756183 */     // MIs[0] offset
     /* 756183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756186 */     // MIs[0] format
     /* 756186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756189 */     // MIs[0] auxiliary
     /* 756189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756192 */     // MIs[0] Operand 8
     /* 756192 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756210 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 756213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756215 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 756217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756224 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756248 */     GIR_RootConstrainSelectedInstOperands,
     /* 756249 */     // GIR_Coverage, 6702,
     /* 756249 */     GIR_EraseRootFromParent_Done,
     /* 756250 */   // Label 9975: @756250
     /* 756250 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(756326), // Rule ID 6706 //
     /* 756255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756259 */     // MIs[0] offset
     /* 756259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756262 */     // MIs[0] format
     /* 756262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756265 */     // MIs[0] auxiliary
     /* 756265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756268 */     // MIs[0] Operand 8
     /* 756268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756286 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 756289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756291 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 756293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756300 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756302 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756308 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756324 */     GIR_RootConstrainSelectedInstOperands,
     /* 756325 */     // GIR_Coverage, 6706,
     /* 756325 */     GIR_EraseRootFromParent_Done,
     /* 756326 */   // Label 9976: @756326
     /* 756326 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(756397), // Rule ID 6669 //
     /* 756331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756338 */     // MIs[0] offset
     /* 756338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756341 */     // MIs[0] format
     /* 756341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756344 */     // MIs[0] auxiliary
     /* 756344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756347 */     // MIs[0] Operand 8
     /* 756347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756357 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 756360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756362 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756371 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756379 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756395 */     GIR_RootConstrainSelectedInstOperands,
     /* 756396 */     // GIR_Coverage, 6669,
     /* 756396 */     GIR_EraseRootFromParent_Done,
     /* 756397 */   // Label 9977: @756397
     /* 756397 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(756465), // Rule ID 6673 //
     /* 756402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756406 */     // MIs[0] offset
     /* 756406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756409 */     // MIs[0] format
     /* 756409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756412 */     // MIs[0] auxiliary
     /* 756412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756415 */     // MIs[0] Operand 8
     /* 756415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756425 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 756428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756430 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756439 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756463 */     GIR_RootConstrainSelectedInstOperands,
     /* 756464 */     // GIR_Coverage, 6673,
     /* 756464 */     GIR_EraseRootFromParent_Done,
     /* 756465 */   // Label 9978: @756465
     /* 756465 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(756536), // Rule ID 6701 //
     /* 756470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756477 */     // MIs[0] offset
     /* 756477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756480 */     // MIs[0] format
     /* 756480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756483 */     // MIs[0] auxiliary
     /* 756483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756486 */     // MIs[0] Operand 8
     /* 756486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756496 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 756499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756501 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756534 */     GIR_RootConstrainSelectedInstOperands,
     /* 756535 */     // GIR_Coverage, 6701,
     /* 756535 */     GIR_EraseRootFromParent_Done,
     /* 756536 */   // Label 9979: @756536
     /* 756536 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(756604), // Rule ID 6705 //
     /* 756541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756545 */     // MIs[0] offset
     /* 756545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756548 */     // MIs[0] format
     /* 756548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756551 */     // MIs[0] auxiliary
     /* 756551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756554 */     // MIs[0] Operand 8
     /* 756554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756564 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 756567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756569 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756578 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756602 */     GIR_RootConstrainSelectedInstOperands,
     /* 756603 */     // GIR_Coverage, 6705,
     /* 756603 */     GIR_EraseRootFromParent_Done,
     /* 756604 */   // Label 9980: @756604
     /* 756604 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(756713), // Rule ID 6671 //
     /* 756609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756612 */     // MIs[0] offset
     /* 756612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756615 */     // MIs[0] format
     /* 756615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756618 */     // MIs[0] auxiliary
     /* 756618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756621 */     // MIs[0] Operand 8
     /* 756621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756631 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756647 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756654 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 756675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756687 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756711 */     GIR_RootConstrainSelectedInstOperands,
     /* 756712 */     // GIR_Coverage, 6671,
     /* 756712 */     GIR_EraseRootFromParent_Done,
     /* 756713 */   // Label 9981: @756713
     /* 756713 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(756819), // Rule ID 6675 //
     /* 756718 */     // MIs[0] offset
     /* 756718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756721 */     // MIs[0] format
     /* 756721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756724 */     // MIs[0] auxiliary
     /* 756724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756727 */     // MIs[0] Operand 8
     /* 756727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756737 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756753 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756760 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 756781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756793 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756817 */     GIR_RootConstrainSelectedInstOperands,
     /* 756818 */     // GIR_Coverage, 6675,
     /* 756818 */     GIR_EraseRootFromParent_Done,
     /* 756819 */   // Label 9982: @756819
     /* 756819 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(756928), // Rule ID 6703 //
     /* 756824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756827 */     // MIs[0] offset
     /* 756827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756830 */     // MIs[0] format
     /* 756830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756833 */     // MIs[0] auxiliary
     /* 756833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756836 */     // MIs[0] Operand 8
     /* 756836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756846 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756862 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756869 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 756890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756902 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756926 */     GIR_RootConstrainSelectedInstOperands,
     /* 756927 */     // GIR_Coverage, 6703,
     /* 756927 */     GIR_EraseRootFromParent_Done,
     /* 756928 */   // Label 9983: @756928
     /* 756928 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(757034), // Rule ID 6707 //
     /* 756933 */     // MIs[0] offset
     /* 756933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756936 */     // MIs[0] format
     /* 756936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756939 */     // MIs[0] auxiliary
     /* 756939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756942 */     // MIs[0] Operand 8
     /* 756942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756952 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756968 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756975 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 756996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 757001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757008 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757032 */     GIR_RootConstrainSelectedInstOperands,
     /* 757033 */     // GIR_Coverage, 6707,
     /* 757033 */     GIR_EraseRootFromParent_Done,
     /* 757034 */   // Label 9984: @757034
     /* 757034 */   GIM_Reject,
     /* 757035 */ // Label 9968: @757035
     /* 757035 */ GIM_Reject,
     /* 757036 */ // Label 9932: @757036
     /* 757036 */ GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(758394),
     /* 757041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 757044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 757047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 757050 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 757053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 757057 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(757138), // Rule ID 6676 //
     /* 757062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757073 */     // MIs[0] offset
     /* 757073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757076 */     // MIs[0] format
     /* 757076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757079 */     // MIs[0] auxiliary
     /* 757079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757082 */     // MIs[0] Operand 8
     /* 757082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757100 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 757103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757112 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757136 */     GIR_RootConstrainSelectedInstOperands,
     /* 757137 */     // GIR_Coverage, 6676,
     /* 757137 */     GIR_EraseRootFromParent_Done,
     /* 757138 */   // Label 9986: @757138
     /* 757138 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(757216), // Rule ID 6680 //
     /* 757143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757151 */     // MIs[0] offset
     /* 757151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757154 */     // MIs[0] format
     /* 757154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757157 */     // MIs[0] auxiliary
     /* 757157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757160 */     // MIs[0] Operand 8
     /* 757160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757178 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 757181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757190 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757214 */     GIR_RootConstrainSelectedInstOperands,
     /* 757215 */     // GIR_Coverage, 6680,
     /* 757215 */     GIR_EraseRootFromParent_Done,
     /* 757216 */   // Label 9987: @757216
     /* 757216 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(757297), // Rule ID 6708 //
     /* 757221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757232 */     // MIs[0] offset
     /* 757232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757235 */     // MIs[0] format
     /* 757235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757238 */     // MIs[0] auxiliary
     /* 757238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757241 */     // MIs[0] Operand 8
     /* 757241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757259 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 757262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757271 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757295 */     GIR_RootConstrainSelectedInstOperands,
     /* 757296 */     // GIR_Coverage, 6708,
     /* 757296 */     GIR_EraseRootFromParent_Done,
     /* 757297 */   // Label 9988: @757297
     /* 757297 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(757375), // Rule ID 6712 //
     /* 757302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757310 */     // MIs[0] offset
     /* 757310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757313 */     // MIs[0] format
     /* 757313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757316 */     // MIs[0] auxiliary
     /* 757316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757319 */     // MIs[0] Operand 8
     /* 757319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757337 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 757340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757349 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757373 */     GIR_RootConstrainSelectedInstOperands,
     /* 757374 */     // GIR_Coverage, 6712,
     /* 757374 */     GIR_EraseRootFromParent_Done,
     /* 757375 */   // Label 9989: @757375
     /* 757375 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(757454), // Rule ID 6678 //
     /* 757380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757387 */     // MIs[0] offset
     /* 757387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757390 */     // MIs[0] format
     /* 757390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757393 */     // MIs[0] auxiliary
     /* 757393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757396 */     // MIs[0] Operand 8
     /* 757396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757414 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 757417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757419 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757452 */     GIR_RootConstrainSelectedInstOperands,
     /* 757453 */     // GIR_Coverage, 6678,
     /* 757453 */     GIR_EraseRootFromParent_Done,
     /* 757454 */   // Label 9990: @757454
     /* 757454 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(757530), // Rule ID 6682 //
     /* 757459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757463 */     // MIs[0] offset
     /* 757463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757466 */     // MIs[0] format
     /* 757466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757469 */     // MIs[0] auxiliary
     /* 757469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757472 */     // MIs[0] Operand 8
     /* 757472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757490 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 757493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757495 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757504 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757528 */     GIR_RootConstrainSelectedInstOperands,
     /* 757529 */     // GIR_Coverage, 6682,
     /* 757529 */     GIR_EraseRootFromParent_Done,
     /* 757530 */   // Label 9991: @757530
     /* 757530 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(757609), // Rule ID 6710 //
     /* 757535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757542 */     // MIs[0] offset
     /* 757542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757545 */     // MIs[0] format
     /* 757545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757548 */     // MIs[0] auxiliary
     /* 757548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757551 */     // MIs[0] Operand 8
     /* 757551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757569 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 757572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757574 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757583 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757607 */     GIR_RootConstrainSelectedInstOperands,
     /* 757608 */     // GIR_Coverage, 6710,
     /* 757608 */     GIR_EraseRootFromParent_Done,
     /* 757609 */   // Label 9992: @757609
     /* 757609 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(757685), // Rule ID 6714 //
     /* 757614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757618 */     // MIs[0] offset
     /* 757618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757621 */     // MIs[0] format
     /* 757621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757624 */     // MIs[0] auxiliary
     /* 757624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757627 */     // MIs[0] Operand 8
     /* 757627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757645 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 757648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757650 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757659 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757683 */     GIR_RootConstrainSelectedInstOperands,
     /* 757684 */     // GIR_Coverage, 6714,
     /* 757684 */     GIR_EraseRootFromParent_Done,
     /* 757685 */   // Label 9993: @757685
     /* 757685 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(757756), // Rule ID 6677 //
     /* 757690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757697 */     // MIs[0] offset
     /* 757697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757700 */     // MIs[0] format
     /* 757700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757703 */     // MIs[0] auxiliary
     /* 757703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757706 */     // MIs[0] Operand 8
     /* 757706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757716 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 757719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757721 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757730 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757754 */     GIR_RootConstrainSelectedInstOperands,
     /* 757755 */     // GIR_Coverage, 6677,
     /* 757755 */     GIR_EraseRootFromParent_Done,
     /* 757756 */   // Label 9994: @757756
     /* 757756 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(757824), // Rule ID 6681 //
     /* 757761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757765 */     // MIs[0] offset
     /* 757765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757768 */     // MIs[0] format
     /* 757768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757771 */     // MIs[0] auxiliary
     /* 757771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757774 */     // MIs[0] Operand 8
     /* 757774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757784 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 757787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757789 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757798 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757822 */     GIR_RootConstrainSelectedInstOperands,
     /* 757823 */     // GIR_Coverage, 6681,
     /* 757823 */     GIR_EraseRootFromParent_Done,
     /* 757824 */   // Label 9995: @757824
     /* 757824 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(757895), // Rule ID 6709 //
     /* 757829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757836 */     // MIs[0] offset
     /* 757836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757839 */     // MIs[0] format
     /* 757839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757842 */     // MIs[0] auxiliary
     /* 757842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757845 */     // MIs[0] Operand 8
     /* 757845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757855 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 757858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757860 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757869 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757893 */     GIR_RootConstrainSelectedInstOperands,
     /* 757894 */     // GIR_Coverage, 6709,
     /* 757894 */     GIR_EraseRootFromParent_Done,
     /* 757895 */   // Label 9996: @757895
     /* 757895 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(757963), // Rule ID 6713 //
     /* 757900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757904 */     // MIs[0] offset
     /* 757904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757907 */     // MIs[0] format
     /* 757907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757910 */     // MIs[0] auxiliary
     /* 757910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757913 */     // MIs[0] Operand 8
     /* 757913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757923 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 757926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757928 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757937 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757961 */     GIR_RootConstrainSelectedInstOperands,
     /* 757962 */     // GIR_Coverage, 6713,
     /* 757962 */     GIR_EraseRootFromParent_Done,
     /* 757963 */   // Label 9997: @757963
     /* 757963 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(758072), // Rule ID 6679 //
     /* 757968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757971 */     // MIs[0] offset
     /* 757971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757974 */     // MIs[0] format
     /* 757974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757977 */     // MIs[0] auxiliary
     /* 757977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757980 */     // MIs[0] Operand 8
     /* 757980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757990 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 757993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 757997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758006 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758013 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 758034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758046 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758070 */     GIR_RootConstrainSelectedInstOperands,
     /* 758071 */     // GIR_Coverage, 6679,
     /* 758071 */     GIR_EraseRootFromParent_Done,
     /* 758072 */   // Label 9998: @758072
     /* 758072 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(758178), // Rule ID 6683 //
     /* 758077 */     // MIs[0] offset
     /* 758077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758080 */     // MIs[0] format
     /* 758080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758083 */     // MIs[0] auxiliary
     /* 758083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758086 */     // MIs[0] Operand 8
     /* 758086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758096 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 758099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 758103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758112 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758119 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 758140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758152 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758176 */     GIR_RootConstrainSelectedInstOperands,
     /* 758177 */     // GIR_Coverage, 6683,
     /* 758177 */     GIR_EraseRootFromParent_Done,
     /* 758178 */   // Label 9999: @758178
     /* 758178 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(758287), // Rule ID 6711 //
     /* 758183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 758186 */     // MIs[0] offset
     /* 758186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758189 */     // MIs[0] format
     /* 758189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758192 */     // MIs[0] auxiliary
     /* 758192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758195 */     // MIs[0] Operand 8
     /* 758195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758205 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 758208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 758212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758221 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758228 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 758249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758285 */     GIR_RootConstrainSelectedInstOperands,
     /* 758286 */     // GIR_Coverage, 6711,
     /* 758286 */     GIR_EraseRootFromParent_Done,
     /* 758287 */   // Label 10000: @758287
     /* 758287 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(758393), // Rule ID 6715 //
     /* 758292 */     // MIs[0] offset
     /* 758292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758295 */     // MIs[0] format
     /* 758295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758298 */     // MIs[0] auxiliary
     /* 758298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758301 */     // MIs[0] Operand 8
     /* 758301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758311 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 758314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 758318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758327 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758334 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 758355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758367 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758391 */     GIR_RootConstrainSelectedInstOperands,
     /* 758392 */     // GIR_Coverage, 6715,
     /* 758392 */     GIR_EraseRootFromParent_Done,
     /* 758393 */   // Label 10001: @758393
     /* 758393 */   GIM_Reject,
     /* 758394 */ // Label 9985: @758394
     /* 758394 */ GIM_Reject,
     /* 758395 */ // Label 9933: @758395
     /* 758395 */ GIM_Reject,
     /* 758396 */ // Label 163: @758396
     /* 758396 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10009*/ GIMT_Encode4(763824),
     /* 758407 */ /*GILLT_s16*//*Label 10002*/ GIMT_Encode4(758447),
     /* 758411 */ /*GILLT_s32*//*Label 10003*/ GIMT_Encode4(759490), GIMT_Encode4(0),
     /* 758419 */ /*GILLT_v2s16*//*Label 10004*/ GIMT_Encode4(760533),
     /* 758423 */ /*GILLT_v2s32*//*Label 10005*/ GIMT_Encode4(761236), GIMT_Encode4(0),
     /* 758431 */ /*GILLT_v3s32*//*Label 10006*/ GIMT_Encode4(761599), GIMT_Encode4(0),
     /* 758439 */ /*GILLT_v4s16*//*Label 10007*/ GIMT_Encode4(761962),
     /* 758443 */ /*GILLT_v4s32*//*Label 10008*/ GIMT_Encode4(763461),
     /* 758447 */ // Label 10002: @758447
     /* 758447 */ GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(759489),
     /* 758452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 758455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 758458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 758461 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 758464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 758468 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(758549), // Rule ID 6716 //
     /* 758473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758484 */     // MIs[0] offset
     /* 758484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758487 */     // MIs[0] format
     /* 758487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758490 */     // MIs[0] auxiliary
     /* 758490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758493 */     // MIs[0] Operand 8
     /* 758493 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758511 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 758514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758523 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758547 */     GIR_RootConstrainSelectedInstOperands,
     /* 758548 */     // GIR_Coverage, 6716,
     /* 758548 */     GIR_EraseRootFromParent_Done,
     /* 758549 */   // Label 10011: @758549
     /* 758549 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(758630), // Rule ID 6736 //
     /* 758554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758565 */     // MIs[0] offset
     /* 758565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758568 */     // MIs[0] format
     /* 758568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758571 */     // MIs[0] auxiliary
     /* 758571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758574 */     // MIs[0] Operand 8
     /* 758574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758592 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 758595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758604 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758628 */     GIR_RootConstrainSelectedInstOperands,
     /* 758629 */     // GIR_Coverage, 6736,
     /* 758629 */     GIR_EraseRootFromParent_Done,
     /* 758630 */   // Label 10012: @758630
     /* 758630 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(758711), // Rule ID 6740 //
     /* 758635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 758638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758646 */     // MIs[0] offset
     /* 758646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758649 */     // MIs[0] format
     /* 758649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758652 */     // MIs[0] auxiliary
     /* 758652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758655 */     // MIs[0] Operand 8
     /* 758655 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758673 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 758676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758685 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758709 */     GIR_RootConstrainSelectedInstOperands,
     /* 758710 */     // GIR_Coverage, 6740,
     /* 758710 */     GIR_EraseRootFromParent_Done,
     /* 758711 */   // Label 10013: @758711
     /* 758711 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(758790), // Rule ID 6718 //
     /* 758716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758723 */     // MIs[0] offset
     /* 758723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758726 */     // MIs[0] format
     /* 758726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758729 */     // MIs[0] auxiliary
     /* 758729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758732 */     // MIs[0] Operand 8
     /* 758732 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758750 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 758753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758755 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758764 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758772 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758788 */     GIR_RootConstrainSelectedInstOperands,
     /* 758789 */     // GIR_Coverage, 6718,
     /* 758789 */     GIR_EraseRootFromParent_Done,
     /* 758790 */   // Label 10014: @758790
     /* 758790 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(758869), // Rule ID 6738 //
     /* 758795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758802 */     // MIs[0] offset
     /* 758802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758805 */     // MIs[0] format
     /* 758805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758808 */     // MIs[0] auxiliary
     /* 758808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758811 */     // MIs[0] Operand 8
     /* 758811 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758829 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 758832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758834 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758843 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758867 */     GIR_RootConstrainSelectedInstOperands,
     /* 758868 */     // GIR_Coverage, 6738,
     /* 758868 */     GIR_EraseRootFromParent_Done,
     /* 758869 */   // Label 10015: @758869
     /* 758869 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(758948), // Rule ID 6742 //
     /* 758874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 758877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758881 */     // MIs[0] offset
     /* 758881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758884 */     // MIs[0] format
     /* 758884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758887 */     // MIs[0] auxiliary
     /* 758887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758890 */     // MIs[0] Operand 8
     /* 758890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758908 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 758911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758913 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758922 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758946 */     GIR_RootConstrainSelectedInstOperands,
     /* 758947 */     // GIR_Coverage, 6742,
     /* 758947 */     GIR_EraseRootFromParent_Done,
     /* 758948 */   // Label 10016: @758948
     /* 758948 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(759019), // Rule ID 6717 //
     /* 758953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758960 */     // MIs[0] offset
     /* 758960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758963 */     // MIs[0] format
     /* 758963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758966 */     // MIs[0] auxiliary
     /* 758966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758969 */     // MIs[0] Operand 8
     /* 758969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758979 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 758982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758984 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 758986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759017 */     GIR_RootConstrainSelectedInstOperands,
     /* 759018 */     // GIR_Coverage, 6717,
     /* 759018 */     GIR_EraseRootFromParent_Done,
     /* 759019 */   // Label 10017: @759019
     /* 759019 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(759090), // Rule ID 6737 //
     /* 759024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759031 */     // MIs[0] offset
     /* 759031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759034 */     // MIs[0] format
     /* 759034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759037 */     // MIs[0] auxiliary
     /* 759037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759040 */     // MIs[0] Operand 8
     /* 759040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759050 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 759053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759055 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759064 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759088 */     GIR_RootConstrainSelectedInstOperands,
     /* 759089 */     // GIR_Coverage, 6737,
     /* 759089 */     GIR_EraseRootFromParent_Done,
     /* 759090 */   // Label 10018: @759090
     /* 759090 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(759161), // Rule ID 6741 //
     /* 759095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759102 */     // MIs[0] offset
     /* 759102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759105 */     // MIs[0] format
     /* 759105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759108 */     // MIs[0] auxiliary
     /* 759108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759111 */     // MIs[0] Operand 8
     /* 759111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759121 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 759124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759126 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759135 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759159 */     GIR_RootConstrainSelectedInstOperands,
     /* 759160 */     // GIR_Coverage, 6741,
     /* 759160 */     GIR_EraseRootFromParent_Done,
     /* 759161 */   // Label 10019: @759161
     /* 759161 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(759270), // Rule ID 6719 //
     /* 759166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759169 */     // MIs[0] offset
     /* 759169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759172 */     // MIs[0] format
     /* 759172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759175 */     // MIs[0] auxiliary
     /* 759175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759178 */     // MIs[0] Operand 8
     /* 759178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759188 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759204 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759211 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 759232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759268 */     GIR_RootConstrainSelectedInstOperands,
     /* 759269 */     // GIR_Coverage, 6719,
     /* 759269 */     GIR_EraseRootFromParent_Done,
     /* 759270 */   // Label 10020: @759270
     /* 759270 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(759379), // Rule ID 6739 //
     /* 759275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759278 */     // MIs[0] offset
     /* 759278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759281 */     // MIs[0] format
     /* 759281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759284 */     // MIs[0] auxiliary
     /* 759284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759287 */     // MIs[0] Operand 8
     /* 759287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759297 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759313 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759320 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 759341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759353 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759377 */     GIR_RootConstrainSelectedInstOperands,
     /* 759378 */     // GIR_Coverage, 6739,
     /* 759378 */     GIR_EraseRootFromParent_Done,
     /* 759379 */   // Label 10021: @759379
     /* 759379 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(759488), // Rule ID 6743 //
     /* 759384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759387 */     // MIs[0] offset
     /* 759387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759390 */     // MIs[0] format
     /* 759390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759393 */     // MIs[0] auxiliary
     /* 759393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759396 */     // MIs[0] Operand 8
     /* 759396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759406 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759422 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759429 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 759450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759462 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759486 */     GIR_RootConstrainSelectedInstOperands,
     /* 759487 */     // GIR_Coverage, 6743,
     /* 759487 */     GIR_EraseRootFromParent_Done,
     /* 759488 */   // Label 10022: @759488
     /* 759488 */   GIM_Reject,
     /* 759489 */ // Label 10010: @759489
     /* 759489 */ GIM_Reject,
     /* 759490 */ // Label 10003: @759490
     /* 759490 */ GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(760532),
     /* 759495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 759498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 759501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 759504 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 759507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 759511 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(759592), // Rule ID 6720 //
     /* 759516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759527 */     // MIs[0] offset
     /* 759527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759530 */     // MIs[0] format
     /* 759530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759533 */     // MIs[0] auxiliary
     /* 759533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759536 */     // MIs[0] Operand 8
     /* 759536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759554 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 759557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759566 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759590 */     GIR_RootConstrainSelectedInstOperands,
     /* 759591 */     // GIR_Coverage, 6720,
     /* 759591 */     GIR_EraseRootFromParent_Done,
     /* 759592 */   // Label 10024: @759592
     /* 759592 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(759673), // Rule ID 6744 //
     /* 759597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759608 */     // MIs[0] offset
     /* 759608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759611 */     // MIs[0] format
     /* 759611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759614 */     // MIs[0] auxiliary
     /* 759614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759617 */     // MIs[0] Operand 8
     /* 759617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759635 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 759638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759647 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759671 */     GIR_RootConstrainSelectedInstOperands,
     /* 759672 */     // GIR_Coverage, 6744,
     /* 759672 */     GIR_EraseRootFromParent_Done,
     /* 759673 */   // Label 10025: @759673
     /* 759673 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(759754), // Rule ID 6748 //
     /* 759678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759689 */     // MIs[0] offset
     /* 759689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759692 */     // MIs[0] format
     /* 759692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759695 */     // MIs[0] auxiliary
     /* 759695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759698 */     // MIs[0] Operand 8
     /* 759698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759716 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 759719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759728 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759752 */     GIR_RootConstrainSelectedInstOperands,
     /* 759753 */     // GIR_Coverage, 6748,
     /* 759753 */     GIR_EraseRootFromParent_Done,
     /* 759754 */   // Label 10026: @759754
     /* 759754 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(759833), // Rule ID 6722 //
     /* 759759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759766 */     // MIs[0] offset
     /* 759766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759769 */     // MIs[0] format
     /* 759769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759772 */     // MIs[0] auxiliary
     /* 759772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759775 */     // MIs[0] Operand 8
     /* 759775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759793 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 759796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759798 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759807 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759831 */     GIR_RootConstrainSelectedInstOperands,
     /* 759832 */     // GIR_Coverage, 6722,
     /* 759832 */     GIR_EraseRootFromParent_Done,
     /* 759833 */   // Label 10027: @759833
     /* 759833 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(759912), // Rule ID 6746 //
     /* 759838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759845 */     // MIs[0] offset
     /* 759845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759848 */     // MIs[0] format
     /* 759848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759851 */     // MIs[0] auxiliary
     /* 759851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759854 */     // MIs[0] Operand 8
     /* 759854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759872 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 759875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759877 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759886 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759910 */     GIR_RootConstrainSelectedInstOperands,
     /* 759911 */     // GIR_Coverage, 6746,
     /* 759911 */     GIR_EraseRootFromParent_Done,
     /* 759912 */   // Label 10028: @759912
     /* 759912 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(759991), // Rule ID 6750 //
     /* 759917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759924 */     // MIs[0] offset
     /* 759924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759927 */     // MIs[0] format
     /* 759927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759930 */     // MIs[0] auxiliary
     /* 759930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759933 */     // MIs[0] Operand 8
     /* 759933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759951 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 759954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759956 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759965 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759989 */     GIR_RootConstrainSelectedInstOperands,
     /* 759990 */     // GIR_Coverage, 6750,
     /* 759990 */     GIR_EraseRootFromParent_Done,
     /* 759991 */   // Label 10029: @759991
     /* 759991 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(760062), // Rule ID 6721 //
     /* 759996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760003 */     // MIs[0] offset
     /* 760003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760006 */     // MIs[0] format
     /* 760006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760009 */     // MIs[0] auxiliary
     /* 760009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760012 */     // MIs[0] Operand 8
     /* 760012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760022 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 760025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760027 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760036 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760038 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760044 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760060 */     GIR_RootConstrainSelectedInstOperands,
     /* 760061 */     // GIR_Coverage, 6721,
     /* 760061 */     GIR_EraseRootFromParent_Done,
     /* 760062 */   // Label 10030: @760062
     /* 760062 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(760133), // Rule ID 6745 //
     /* 760067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760074 */     // MIs[0] offset
     /* 760074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760077 */     // MIs[0] format
     /* 760077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760080 */     // MIs[0] auxiliary
     /* 760080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760083 */     // MIs[0] Operand 8
     /* 760083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760093 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 760096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760098 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760131 */     GIR_RootConstrainSelectedInstOperands,
     /* 760132 */     // GIR_Coverage, 6745,
     /* 760132 */     GIR_EraseRootFromParent_Done,
     /* 760133 */   // Label 10031: @760133
     /* 760133 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(760204), // Rule ID 6749 //
     /* 760138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760145 */     // MIs[0] offset
     /* 760145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760148 */     // MIs[0] format
     /* 760148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760151 */     // MIs[0] auxiliary
     /* 760151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760154 */     // MIs[0] Operand 8
     /* 760154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760164 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 760167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760169 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760178 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760202 */     GIR_RootConstrainSelectedInstOperands,
     /* 760203 */     // GIR_Coverage, 6749,
     /* 760203 */     GIR_EraseRootFromParent_Done,
     /* 760204 */   // Label 10032: @760204
     /* 760204 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(760313), // Rule ID 6723 //
     /* 760209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 760212 */     // MIs[0] offset
     /* 760212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760215 */     // MIs[0] format
     /* 760215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760218 */     // MIs[0] auxiliary
     /* 760218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760221 */     // MIs[0] Operand 8
     /* 760221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760231 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760247 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760254 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 760275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760287 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760295 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760311 */     GIR_RootConstrainSelectedInstOperands,
     /* 760312 */     // GIR_Coverage, 6723,
     /* 760312 */     GIR_EraseRootFromParent_Done,
     /* 760313 */   // Label 10033: @760313
     /* 760313 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(760422), // Rule ID 6747 //
     /* 760318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760321 */     // MIs[0] offset
     /* 760321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760324 */     // MIs[0] format
     /* 760324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760327 */     // MIs[0] auxiliary
     /* 760327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760330 */     // MIs[0] Operand 8
     /* 760330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760340 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760356 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760363 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 760384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760396 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760420 */     GIR_RootConstrainSelectedInstOperands,
     /* 760421 */     // GIR_Coverage, 6747,
     /* 760421 */     GIR_EraseRootFromParent_Done,
     /* 760422 */   // Label 10034: @760422
     /* 760422 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(760531), // Rule ID 6751 //
     /* 760427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760430 */     // MIs[0] offset
     /* 760430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760433 */     // MIs[0] format
     /* 760433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760436 */     // MIs[0] auxiliary
     /* 760436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760439 */     // MIs[0] Operand 8
     /* 760439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760449 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760472 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 760493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760529 */     GIR_RootConstrainSelectedInstOperands,
     /* 760530 */     // GIR_Coverage, 6751,
     /* 760530 */     GIR_EraseRootFromParent_Done,
     /* 760531 */   // Label 10035: @760531
     /* 760531 */   GIM_Reject,
     /* 760532 */ // Label 10023: @760532
     /* 760532 */ GIM_Reject,
     /* 760533 */ // Label 10004: @760533
     /* 760533 */ GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(761235),
     /* 760538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 760541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 760544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 760547 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 760550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 760554 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(760635), // Rule ID 6752 //
     /* 760559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760570 */     // MIs[0] offset
     /* 760570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760573 */     // MIs[0] format
     /* 760573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760576 */     // MIs[0] auxiliary
     /* 760576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760579 */     // MIs[0] Operand 8
     /* 760579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760597 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 760600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760609 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760633 */     GIR_RootConstrainSelectedInstOperands,
     /* 760634 */     // GIR_Coverage, 6752,
     /* 760634 */     GIR_EraseRootFromParent_Done,
     /* 760635 */   // Label 10037: @760635
     /* 760635 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(760716), // Rule ID 6756 //
     /* 760640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760651 */     // MIs[0] offset
     /* 760651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760654 */     // MIs[0] format
     /* 760654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760657 */     // MIs[0] auxiliary
     /* 760657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760660 */     // MIs[0] Operand 8
     /* 760660 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760678 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 760681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760690 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760714 */     GIR_RootConstrainSelectedInstOperands,
     /* 760715 */     // GIR_Coverage, 6756,
     /* 760715 */     GIR_EraseRootFromParent_Done,
     /* 760716 */   // Label 10038: @760716
     /* 760716 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(760795), // Rule ID 6754 //
     /* 760721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760728 */     // MIs[0] offset
     /* 760728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760731 */     // MIs[0] format
     /* 760731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760734 */     // MIs[0] auxiliary
     /* 760734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760737 */     // MIs[0] Operand 8
     /* 760737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760755 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 760758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760760 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760769 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760793 */     GIR_RootConstrainSelectedInstOperands,
     /* 760794 */     // GIR_Coverage, 6754,
     /* 760794 */     GIR_EraseRootFromParent_Done,
     /* 760795 */   // Label 10039: @760795
     /* 760795 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(760874), // Rule ID 6758 //
     /* 760800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760807 */     // MIs[0] offset
     /* 760807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760810 */     // MIs[0] format
     /* 760810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760813 */     // MIs[0] auxiliary
     /* 760813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760816 */     // MIs[0] Operand 8
     /* 760816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760834 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 760837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760839 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760848 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760872 */     GIR_RootConstrainSelectedInstOperands,
     /* 760873 */     // GIR_Coverage, 6758,
     /* 760873 */     GIR_EraseRootFromParent_Done,
     /* 760874 */   // Label 10040: @760874
     /* 760874 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(760945), // Rule ID 6753 //
     /* 760879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760886 */     // MIs[0] offset
     /* 760886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760889 */     // MIs[0] format
     /* 760889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760892 */     // MIs[0] auxiliary
     /* 760892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760895 */     // MIs[0] Operand 8
     /* 760895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760905 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 760908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760910 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760919 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760943 */     GIR_RootConstrainSelectedInstOperands,
     /* 760944 */     // GIR_Coverage, 6753,
     /* 760944 */     GIR_EraseRootFromParent_Done,
     /* 760945 */   // Label 10041: @760945
     /* 760945 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(761016), // Rule ID 6757 //
     /* 760950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760957 */     // MIs[0] offset
     /* 760957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760960 */     // MIs[0] format
     /* 760960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760963 */     // MIs[0] auxiliary
     /* 760963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760966 */     // MIs[0] Operand 8
     /* 760966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760976 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 760979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760981 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760990 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761014 */     GIR_RootConstrainSelectedInstOperands,
     /* 761015 */     // GIR_Coverage, 6757,
     /* 761015 */     GIR_EraseRootFromParent_Done,
     /* 761016 */   // Label 10042: @761016
     /* 761016 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(761125), // Rule ID 6755 //
     /* 761021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 761024 */     // MIs[0] offset
     /* 761024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761027 */     // MIs[0] format
     /* 761027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761030 */     // MIs[0] auxiliary
     /* 761030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761033 */     // MIs[0] Operand 8
     /* 761033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761043 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761059 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761066 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 761087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761099 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761123 */     GIR_RootConstrainSelectedInstOperands,
     /* 761124 */     // GIR_Coverage, 6755,
     /* 761124 */     GIR_EraseRootFromParent_Done,
     /* 761125 */   // Label 10043: @761125
     /* 761125 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(761234), // Rule ID 6759 //
     /* 761130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 761133 */     // MIs[0] offset
     /* 761133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761136 */     // MIs[0] format
     /* 761136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761139 */     // MIs[0] auxiliary
     /* 761139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761142 */     // MIs[0] Operand 8
     /* 761142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761152 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761168 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761175 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 761196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761208 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761232 */     GIR_RootConstrainSelectedInstOperands,
     /* 761233 */     // GIR_Coverage, 6759,
     /* 761233 */     GIR_EraseRootFromParent_Done,
     /* 761234 */   // Label 10044: @761234
     /* 761234 */   GIM_Reject,
     /* 761235 */ // Label 10036: @761235
     /* 761235 */ GIM_Reject,
     /* 761236 */ // Label 10005: @761236
     /* 761236 */ GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(761598),
     /* 761241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761250 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761257 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(761338), // Rule ID 6724 //
     /* 761262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761273 */     // MIs[0] offset
     /* 761273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761276 */     // MIs[0] format
     /* 761276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761279 */     // MIs[0] auxiliary
     /* 761279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761282 */     // MIs[0] Operand 8
     /* 761282 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761300 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 761303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761336 */     GIR_RootConstrainSelectedInstOperands,
     /* 761337 */     // GIR_Coverage, 6724,
     /* 761337 */     GIR_EraseRootFromParent_Done,
     /* 761338 */   // Label 10046: @761338
     /* 761338 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(761417), // Rule ID 6726 //
     /* 761343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761350 */     // MIs[0] offset
     /* 761350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761353 */     // MIs[0] format
     /* 761353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761356 */     // MIs[0] auxiliary
     /* 761356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761359 */     // MIs[0] Operand 8
     /* 761359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761377 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 761380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761382 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761391 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761415 */     GIR_RootConstrainSelectedInstOperands,
     /* 761416 */     // GIR_Coverage, 6726,
     /* 761416 */     GIR_EraseRootFromParent_Done,
     /* 761417 */   // Label 10047: @761417
     /* 761417 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(761488), // Rule ID 6725 //
     /* 761422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761429 */     // MIs[0] offset
     /* 761429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761432 */     // MIs[0] format
     /* 761432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761435 */     // MIs[0] auxiliary
     /* 761435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761438 */     // MIs[0] Operand 8
     /* 761438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761448 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 761451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761453 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761462 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761486 */     GIR_RootConstrainSelectedInstOperands,
     /* 761487 */     // GIR_Coverage, 6725,
     /* 761487 */     GIR_EraseRootFromParent_Done,
     /* 761488 */   // Label 10048: @761488
     /* 761488 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(761597), // Rule ID 6727 //
     /* 761493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761496 */     // MIs[0] offset
     /* 761496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761499 */     // MIs[0] format
     /* 761499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761502 */     // MIs[0] auxiliary
     /* 761502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761505 */     // MIs[0] Operand 8
     /* 761505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761515 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761531 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761538 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 761559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761571 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761595 */     GIR_RootConstrainSelectedInstOperands,
     /* 761596 */     // GIR_Coverage, 6727,
     /* 761596 */     GIR_EraseRootFromParent_Done,
     /* 761597 */   // Label 10049: @761597
     /* 761597 */   GIM_Reject,
     /* 761598 */ // Label 10045: @761598
     /* 761598 */ GIM_Reject,
     /* 761599 */ // Label 10006: @761599
     /* 761599 */ GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(761961),
     /* 761604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761613 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 761620 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(761701), // Rule ID 6728 //
     /* 761625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761636 */     // MIs[0] offset
     /* 761636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761639 */     // MIs[0] format
     /* 761639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761642 */     // MIs[0] auxiliary
     /* 761642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761645 */     // MIs[0] Operand 8
     /* 761645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761663 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 761666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761675 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761699 */     GIR_RootConstrainSelectedInstOperands,
     /* 761700 */     // GIR_Coverage, 6728,
     /* 761700 */     GIR_EraseRootFromParent_Done,
     /* 761701 */   // Label 10051: @761701
     /* 761701 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(761780), // Rule ID 6730 //
     /* 761706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761713 */     // MIs[0] offset
     /* 761713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761716 */     // MIs[0] format
     /* 761716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761719 */     // MIs[0] auxiliary
     /* 761719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761722 */     // MIs[0] Operand 8
     /* 761722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761740 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 761743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761745 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761754 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761778 */     GIR_RootConstrainSelectedInstOperands,
     /* 761779 */     // GIR_Coverage, 6730,
     /* 761779 */     GIR_EraseRootFromParent_Done,
     /* 761780 */   // Label 10052: @761780
     /* 761780 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(761851), // Rule ID 6729 //
     /* 761785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761792 */     // MIs[0] offset
     /* 761792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761795 */     // MIs[0] format
     /* 761795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761798 */     // MIs[0] auxiliary
     /* 761798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761801 */     // MIs[0] Operand 8
     /* 761801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761811 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 761814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761816 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761825 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761849 */     GIR_RootConstrainSelectedInstOperands,
     /* 761850 */     // GIR_Coverage, 6729,
     /* 761850 */     GIR_EraseRootFromParent_Done,
     /* 761851 */   // Label 10053: @761851
     /* 761851 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(761960), // Rule ID 6731 //
     /* 761856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761859 */     // MIs[0] offset
     /* 761859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761862 */     // MIs[0] format
     /* 761862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761865 */     // MIs[0] auxiliary
     /* 761865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761868 */     // MIs[0] Operand 8
     /* 761868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761878 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761894 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761901 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 761922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761934 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761958 */     GIR_RootConstrainSelectedInstOperands,
     /* 761959 */     // GIR_Coverage, 6731,
     /* 761959 */     GIR_EraseRootFromParent_Done,
     /* 761960 */   // Label 10054: @761960
     /* 761960 */   GIM_Reject,
     /* 761961 */ // Label 10050: @761961
     /* 761961 */ GIM_Reject,
     /* 761962 */ // Label 10007: @761962
     /* 761962 */ GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(763460),
     /* 761967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761976 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761979 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(762071), // Rule ID 6760 //
     /* 761984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 761987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 761994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762006 */     // MIs[0] offset
     /* 762006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762009 */     // MIs[0] format
     /* 762009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762012 */     // MIs[0] auxiliary
     /* 762012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762015 */     // MIs[0] Operand 8
     /* 762015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762033 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 762036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762045 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762069 */     GIR_RootConstrainSelectedInstOperands,
     /* 762070 */     // GIR_Coverage, 6760,
     /* 762070 */     GIR_EraseRootFromParent_Done,
     /* 762071 */   // Label 10056: @762071
     /* 762071 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(762163), // Rule ID 6764 //
     /* 762076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762079 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762098 */     // MIs[0] offset
     /* 762098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762101 */     // MIs[0] format
     /* 762101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762104 */     // MIs[0] auxiliary
     /* 762104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762107 */     // MIs[0] Operand 8
     /* 762107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762125 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 762128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762161 */     GIR_RootConstrainSelectedInstOperands,
     /* 762162 */     // GIR_Coverage, 6764,
     /* 762162 */     GIR_EraseRootFromParent_Done,
     /* 762163 */   // Label 10057: @762163
     /* 762163 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(762248), // Rule ID 6768 //
     /* 762168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762183 */     // MIs[0] offset
     /* 762183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762186 */     // MIs[0] format
     /* 762186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762189 */     // MIs[0] auxiliary
     /* 762189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762192 */     // MIs[0] Operand 8
     /* 762192 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762210 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 762213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762222 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762246 */     GIR_RootConstrainSelectedInstOperands,
     /* 762247 */     // GIR_Coverage, 6768,
     /* 762247 */     GIR_EraseRootFromParent_Done,
     /* 762248 */   // Label 10058: @762248
     /* 762248 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(762333), // Rule ID 6772 //
     /* 762253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762268 */     // MIs[0] offset
     /* 762268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762271 */     // MIs[0] format
     /* 762271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762274 */     // MIs[0] auxiliary
     /* 762274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762277 */     // MIs[0] Operand 8
     /* 762277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762295 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 762298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762307 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762331 */     GIR_RootConstrainSelectedInstOperands,
     /* 762332 */     // GIR_Coverage, 6772,
     /* 762332 */     GIR_EraseRootFromParent_Done,
     /* 762333 */   // Label 10059: @762333
     /* 762333 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(762423), // Rule ID 6762 //
     /* 762338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762356 */     // MIs[0] offset
     /* 762356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762359 */     // MIs[0] format
     /* 762359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762362 */     // MIs[0] auxiliary
     /* 762362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762365 */     // MIs[0] Operand 8
     /* 762365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762383 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 762386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762388 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762397 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762421 */     GIR_RootConstrainSelectedInstOperands,
     /* 762422 */     // GIR_Coverage, 6762,
     /* 762422 */     GIR_EraseRootFromParent_Done,
     /* 762423 */   // Label 10060: @762423
     /* 762423 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(762513), // Rule ID 6766 //
     /* 762428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762446 */     // MIs[0] offset
     /* 762446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762449 */     // MIs[0] format
     /* 762449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762452 */     // MIs[0] auxiliary
     /* 762452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762455 */     // MIs[0] Operand 8
     /* 762455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762473 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 762476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762478 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762511 */     GIR_RootConstrainSelectedInstOperands,
     /* 762512 */     // GIR_Coverage, 6766,
     /* 762512 */     GIR_EraseRootFromParent_Done,
     /* 762513 */   // Label 10061: @762513
     /* 762513 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(762596), // Rule ID 6770 //
     /* 762518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762529 */     // MIs[0] offset
     /* 762529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762532 */     // MIs[0] format
     /* 762532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762535 */     // MIs[0] auxiliary
     /* 762535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762538 */     // MIs[0] Operand 8
     /* 762538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762556 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 762559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762561 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762570 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762594 */     GIR_RootConstrainSelectedInstOperands,
     /* 762595 */     // GIR_Coverage, 6770,
     /* 762595 */     GIR_EraseRootFromParent_Done,
     /* 762596 */   // Label 10062: @762596
     /* 762596 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(762679), // Rule ID 6774 //
     /* 762601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762612 */     // MIs[0] offset
     /* 762612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762615 */     // MIs[0] format
     /* 762615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762618 */     // MIs[0] auxiliary
     /* 762618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762621 */     // MIs[0] Operand 8
     /* 762621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762639 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 762642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762644 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762653 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762677 */     GIR_RootConstrainSelectedInstOperands,
     /* 762678 */     // GIR_Coverage, 6774,
     /* 762678 */     GIR_EraseRootFromParent_Done,
     /* 762679 */   // Label 10063: @762679
     /* 762679 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(762761), // Rule ID 6761 //
     /* 762684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762702 */     // MIs[0] offset
     /* 762702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762705 */     // MIs[0] format
     /* 762705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762708 */     // MIs[0] auxiliary
     /* 762708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762711 */     // MIs[0] Operand 8
     /* 762711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762721 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 762724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762726 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762735 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762759 */     GIR_RootConstrainSelectedInstOperands,
     /* 762760 */     // GIR_Coverage, 6761,
     /* 762760 */     GIR_EraseRootFromParent_Done,
     /* 762761 */   // Label 10064: @762761
     /* 762761 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(762843), // Rule ID 6765 //
     /* 762766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762784 */     // MIs[0] offset
     /* 762784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762787 */     // MIs[0] format
     /* 762787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762790 */     // MIs[0] auxiliary
     /* 762790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762793 */     // MIs[0] Operand 8
     /* 762793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762803 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 762806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762808 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762817 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762819 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762841 */     GIR_RootConstrainSelectedInstOperands,
     /* 762842 */     // GIR_Coverage, 6765,
     /* 762842 */     GIR_EraseRootFromParent_Done,
     /* 762843 */   // Label 10065: @762843
     /* 762843 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(762918), // Rule ID 6769 //
     /* 762848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762859 */     // MIs[0] offset
     /* 762859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762862 */     // MIs[0] format
     /* 762862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762865 */     // MIs[0] auxiliary
     /* 762865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762868 */     // MIs[0] Operand 8
     /* 762868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762878 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 762881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762892 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762916 */     GIR_RootConstrainSelectedInstOperands,
     /* 762917 */     // GIR_Coverage, 6769,
     /* 762917 */     GIR_EraseRootFromParent_Done,
     /* 762918 */   // Label 10066: @762918
     /* 762918 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(762993), // Rule ID 6773 //
     /* 762923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762934 */     // MIs[0] offset
     /* 762934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762937 */     // MIs[0] format
     /* 762937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762940 */     // MIs[0] auxiliary
     /* 762940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762943 */     // MIs[0] Operand 8
     /* 762943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762953 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 762956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762958 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762967 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762991 */     GIR_RootConstrainSelectedInstOperands,
     /* 762992 */     // GIR_Coverage, 6773,
     /* 762992 */     GIR_EraseRootFromParent_Done,
     /* 762993 */   // Label 10067: @762993
     /* 762993 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(763113), // Rule ID 6763 //
     /* 762998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 763001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 763008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 763012 */     // MIs[0] offset
     /* 763012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763015 */     // MIs[0] format
     /* 763015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763018 */     // MIs[0] auxiliary
     /* 763018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763021 */     // MIs[0] Operand 8
     /* 763021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763031 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763054 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 763075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763087 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763111 */     GIR_RootConstrainSelectedInstOperands,
     /* 763112 */     // GIR_Coverage, 6763,
     /* 763112 */     GIR_EraseRootFromParent_Done,
     /* 763113 */   // Label 10068: @763113
     /* 763113 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(763233), // Rule ID 6767 //
     /* 763118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 763121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 763128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 763132 */     // MIs[0] offset
     /* 763132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763135 */     // MIs[0] format
     /* 763135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763138 */     // MIs[0] auxiliary
     /* 763138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763141 */     // MIs[0] Operand 8
     /* 763141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763151 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33578>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763167 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763174 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 763195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763231 */     GIR_RootConstrainSelectedInstOperands,
     /* 763232 */     // GIR_Coverage, 6767,
     /* 763232 */     GIR_EraseRootFromParent_Done,
     /* 763233 */   // Label 10069: @763233
     /* 763233 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(763346), // Rule ID 6771 //
     /* 763238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 763241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 763245 */     // MIs[0] offset
     /* 763245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763248 */     // MIs[0] format
     /* 763248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763251 */     // MIs[0] auxiliary
     /* 763251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763254 */     // MIs[0] Operand 8
     /* 763254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763264 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763280 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763287 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 763308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763320 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763344 */     GIR_RootConstrainSelectedInstOperands,
     /* 763345 */     // GIR_Coverage, 6771,
     /* 763345 */     GIR_EraseRootFromParent_Done,
     /* 763346 */   // Label 10070: @763346
     /* 763346 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(763459), // Rule ID 6775 //
     /* 763351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 763354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 763358 */     // MIs[0] offset
     /* 763358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763361 */     // MIs[0] format
     /* 763361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763364 */     // MIs[0] auxiliary
     /* 763364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763367 */     // MIs[0] Operand 8
     /* 763367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763377 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763393 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763400 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 763421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763433 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763457 */     GIR_RootConstrainSelectedInstOperands,
     /* 763458 */     // GIR_Coverage, 6775,
     /* 763458 */     GIR_EraseRootFromParent_Done,
     /* 763459 */   // Label 10071: @763459
     /* 763459 */   GIM_Reject,
     /* 763460 */ // Label 10055: @763460
     /* 763460 */ GIM_Reject,
     /* 763461 */ // Label 10008: @763461
     /* 763461 */ GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(763823),
     /* 763466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 763469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 763472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 763475 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 763478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 763482 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(763563), // Rule ID 6732 //
     /* 763487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763498 */     // MIs[0] offset
     /* 763498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763501 */     // MIs[0] format
     /* 763501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763504 */     // MIs[0] auxiliary
     /* 763504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763507 */     // MIs[0] Operand 8
     /* 763507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763525 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 763528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763537 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763551 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763561 */     GIR_RootConstrainSelectedInstOperands,
     /* 763562 */     // GIR_Coverage, 6732,
     /* 763562 */     GIR_EraseRootFromParent_Done,
     /* 763563 */   // Label 10073: @763563
     /* 763563 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(763642), // Rule ID 6734 //
     /* 763568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763575 */     // MIs[0] offset
     /* 763575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763578 */     // MIs[0] format
     /* 763578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763581 */     // MIs[0] auxiliary
     /* 763581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763584 */     // MIs[0] Operand 8
     /* 763584 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763602 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 763605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763607 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 763609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763616 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763640 */     GIR_RootConstrainSelectedInstOperands,
     /* 763641 */     // GIR_Coverage, 6734,
     /* 763641 */     GIR_EraseRootFromParent_Done,
     /* 763642 */   // Label 10074: @763642
     /* 763642 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(763713), // Rule ID 6733 //
     /* 763647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763654 */     // MIs[0] offset
     /* 763654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763657 */     // MIs[0] format
     /* 763657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763660 */     // MIs[0] auxiliary
     /* 763660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763663 */     // MIs[0] Operand 8
     /* 763663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763673 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 763676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763678 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763687 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763711 */     GIR_RootConstrainSelectedInstOperands,
     /* 763712 */     // GIR_Coverage, 6733,
     /* 763712 */     GIR_EraseRootFromParent_Done,
     /* 763713 */   // Label 10075: @763713
     /* 763713 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(763822), // Rule ID 6735 //
     /* 763718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763721 */     // MIs[0] offset
     /* 763721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763724 */     // MIs[0] format
     /* 763724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763727 */     // MIs[0] auxiliary
     /* 763727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763730 */     // MIs[0] Operand 8
     /* 763730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763740 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763756 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763763 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 763784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763796 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763820 */     GIR_RootConstrainSelectedInstOperands,
     /* 763821 */     // GIR_Coverage, 6735,
     /* 763821 */     GIR_EraseRootFromParent_Done,
     /* 763822 */   // Label 10076: @763822
     /* 763822 */   GIM_Reject,
     /* 763823 */ // Label 10072: @763823
     /* 763823 */ GIM_Reject,
     /* 763824 */ // Label 10009: @763824
     /* 763824 */ GIM_Reject,
     /* 763825 */ // Label 164: @763825
     /* 763825 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 10081*/ GIMT_Encode4(769292),
     /* 763836 */ /*GILLT_s32*//*Label 10077*/ GIMT_Encode4(763872), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 763848 */ /*GILLT_v2s32*//*Label 10078*/ GIMT_Encode4(765227), GIMT_Encode4(0),
     /* 763856 */ /*GILLT_v3s32*//*Label 10079*/ GIMT_Encode4(766582), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 763868 */ /*GILLT_v4s32*//*Label 10080*/ GIMT_Encode4(767937),
     /* 763872 */ // Label 10077: @763872
     /* 763872 */ GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(765226),
     /* 763877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 763880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 763883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 763886 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 763889 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(763970), // Rule ID 6776 //
     /* 763894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763905 */     // MIs[0] offset
     /* 763905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763908 */     // MIs[0] format
     /* 763908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763911 */     // MIs[0] auxiliary
     /* 763911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763914 */     // MIs[0] Operand 8
     /* 763914 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763932 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 763935 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763944 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763968 */     GIR_RootConstrainSelectedInstOperands,
     /* 763969 */     // GIR_Coverage, 6776,
     /* 763969 */     GIR_EraseRootFromParent_Done,
     /* 763970 */   // Label 10083: @763970
     /* 763970 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(764048), // Rule ID 6780 //
     /* 763975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763983 */     // MIs[0] offset
     /* 763983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763986 */     // MIs[0] format
     /* 763986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763989 */     // MIs[0] auxiliary
     /* 763989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763992 */     // MIs[0] Operand 8
     /* 763992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764010 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 764013 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764022 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764046 */     GIR_RootConstrainSelectedInstOperands,
     /* 764047 */     // GIR_Coverage, 6780,
     /* 764047 */     GIR_EraseRootFromParent_Done,
     /* 764048 */   // Label 10084: @764048
     /* 764048 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(764129), // Rule ID 6808 //
     /* 764053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764064 */     // MIs[0] offset
     /* 764064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764067 */     // MIs[0] format
     /* 764067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764070 */     // MIs[0] auxiliary
     /* 764070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764073 */     // MIs[0] Operand 8
     /* 764073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764091 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 764094 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764127 */     GIR_RootConstrainSelectedInstOperands,
     /* 764128 */     // GIR_Coverage, 6808,
     /* 764128 */     GIR_EraseRootFromParent_Done,
     /* 764129 */   // Label 10085: @764129
     /* 764129 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(764207), // Rule ID 6812 //
     /* 764134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764142 */     // MIs[0] offset
     /* 764142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764145 */     // MIs[0] format
     /* 764145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764148 */     // MIs[0] auxiliary
     /* 764148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764151 */     // MIs[0] Operand 8
     /* 764151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764169 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 764172 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764181 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764205 */     GIR_RootConstrainSelectedInstOperands,
     /* 764206 */     // GIR_Coverage, 6812,
     /* 764206 */     GIR_EraseRootFromParent_Done,
     /* 764207 */   // Label 10086: @764207
     /* 764207 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(764286), // Rule ID 6778 //
     /* 764212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764219 */     // MIs[0] offset
     /* 764219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764222 */     // MIs[0] format
     /* 764222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764225 */     // MIs[0] auxiliary
     /* 764225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764228 */     // MIs[0] Operand 8
     /* 764228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764246 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 764249 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764251 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764260 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764284 */     GIR_RootConstrainSelectedInstOperands,
     /* 764285 */     // GIR_Coverage, 6778,
     /* 764285 */     GIR_EraseRootFromParent_Done,
     /* 764286 */   // Label 10087: @764286
     /* 764286 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(764362), // Rule ID 6782 //
     /* 764291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764295 */     // MIs[0] offset
     /* 764295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764298 */     // MIs[0] format
     /* 764298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764301 */     // MIs[0] auxiliary
     /* 764301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764304 */     // MIs[0] Operand 8
     /* 764304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764322 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 764325 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764327 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764336 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764360 */     GIR_RootConstrainSelectedInstOperands,
     /* 764361 */     // GIR_Coverage, 6782,
     /* 764361 */     GIR_EraseRootFromParent_Done,
     /* 764362 */   // Label 10088: @764362
     /* 764362 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(764441), // Rule ID 6810 //
     /* 764367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764374 */     // MIs[0] offset
     /* 764374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764377 */     // MIs[0] format
     /* 764377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764380 */     // MIs[0] auxiliary
     /* 764380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764383 */     // MIs[0] Operand 8
     /* 764383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764401 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 764404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764406 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764415 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764439 */     GIR_RootConstrainSelectedInstOperands,
     /* 764440 */     // GIR_Coverage, 6810,
     /* 764440 */     GIR_EraseRootFromParent_Done,
     /* 764441 */   // Label 10089: @764441
     /* 764441 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(764517), // Rule ID 6814 //
     /* 764446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764450 */     // MIs[0] offset
     /* 764450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764453 */     // MIs[0] format
     /* 764453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764456 */     // MIs[0] auxiliary
     /* 764456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764459 */     // MIs[0] Operand 8
     /* 764459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764477 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 764480 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764482 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764491 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764515 */     GIR_RootConstrainSelectedInstOperands,
     /* 764516 */     // GIR_Coverage, 6814,
     /* 764516 */     GIR_EraseRootFromParent_Done,
     /* 764517 */   // Label 10090: @764517
     /* 764517 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(764588), // Rule ID 6777 //
     /* 764522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764529 */     // MIs[0] offset
     /* 764529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764532 */     // MIs[0] format
     /* 764532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764535 */     // MIs[0] auxiliary
     /* 764535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764538 */     // MIs[0] Operand 8
     /* 764538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764548 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 764551 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764553 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764586 */     GIR_RootConstrainSelectedInstOperands,
     /* 764587 */     // GIR_Coverage, 6777,
     /* 764587 */     GIR_EraseRootFromParent_Done,
     /* 764588 */   // Label 10091: @764588
     /* 764588 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(764656), // Rule ID 6781 //
     /* 764593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764597 */     // MIs[0] offset
     /* 764597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764600 */     // MIs[0] format
     /* 764600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764603 */     // MIs[0] auxiliary
     /* 764603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764606 */     // MIs[0] Operand 8
     /* 764606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764616 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 764619 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764621 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764630 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764654 */     GIR_RootConstrainSelectedInstOperands,
     /* 764655 */     // GIR_Coverage, 6781,
     /* 764655 */     GIR_EraseRootFromParent_Done,
     /* 764656 */   // Label 10092: @764656
     /* 764656 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(764727), // Rule ID 6809 //
     /* 764661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764668 */     // MIs[0] offset
     /* 764668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764671 */     // MIs[0] format
     /* 764671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764674 */     // MIs[0] auxiliary
     /* 764674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764677 */     // MIs[0] Operand 8
     /* 764677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764687 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 764690 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764692 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764701 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764725 */     GIR_RootConstrainSelectedInstOperands,
     /* 764726 */     // GIR_Coverage, 6809,
     /* 764726 */     GIR_EraseRootFromParent_Done,
     /* 764727 */   // Label 10093: @764727
     /* 764727 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(764795), // Rule ID 6813 //
     /* 764732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764736 */     // MIs[0] offset
     /* 764736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764739 */     // MIs[0] format
     /* 764739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764742 */     // MIs[0] auxiliary
     /* 764742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764745 */     // MIs[0] Operand 8
     /* 764745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764755 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 764758 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764760 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764769 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764793 */     GIR_RootConstrainSelectedInstOperands,
     /* 764794 */     // GIR_Coverage, 6813,
     /* 764794 */     GIR_EraseRootFromParent_Done,
     /* 764795 */   // Label 10094: @764795
     /* 764795 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(764904), // Rule ID 6779 //
     /* 764800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764803 */     // MIs[0] offset
     /* 764803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764806 */     // MIs[0] format
     /* 764806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764809 */     // MIs[0] auxiliary
     /* 764809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764812 */     // MIs[0] Operand 8
     /* 764812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764822 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764838 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764845 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 764866 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764878 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764902 */     GIR_RootConstrainSelectedInstOperands,
     /* 764903 */     // GIR_Coverage, 6779,
     /* 764903 */     GIR_EraseRootFromParent_Done,
     /* 764904 */   // Label 10095: @764904
     /* 764904 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(765010), // Rule ID 6783 //
     /* 764909 */     // MIs[0] offset
     /* 764909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764912 */     // MIs[0] format
     /* 764912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764915 */     // MIs[0] auxiliary
     /* 764915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764918 */     // MIs[0] Operand 8
     /* 764918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764928 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764944 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764951 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 764972 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765008 */     GIR_RootConstrainSelectedInstOperands,
     /* 765009 */     // GIR_Coverage, 6783,
     /* 765009 */     GIR_EraseRootFromParent_Done,
     /* 765010 */   // Label 10096: @765010
     /* 765010 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(765119), // Rule ID 6811 //
     /* 765015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765018 */     // MIs[0] offset
     /* 765018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765021 */     // MIs[0] format
     /* 765021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765024 */     // MIs[0] auxiliary
     /* 765024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765027 */     // MIs[0] Operand 8
     /* 765027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765037 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765053 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765060 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 765081 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765093 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765117 */     GIR_RootConstrainSelectedInstOperands,
     /* 765118 */     // GIR_Coverage, 6811,
     /* 765118 */     GIR_EraseRootFromParent_Done,
     /* 765119 */   // Label 10097: @765119
     /* 765119 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(765225), // Rule ID 6815 //
     /* 765124 */     // MIs[0] offset
     /* 765124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765127 */     // MIs[0] format
     /* 765127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765130 */     // MIs[0] auxiliary
     /* 765130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765133 */     // MIs[0] Operand 8
     /* 765133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765143 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765159 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765166 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 765187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765223 */     GIR_RootConstrainSelectedInstOperands,
     /* 765224 */     // GIR_Coverage, 6815,
     /* 765224 */     GIR_EraseRootFromParent_Done,
     /* 765225 */   // Label 10098: @765225
     /* 765225 */   GIM_Reject,
     /* 765226 */ // Label 10082: @765226
     /* 765226 */ GIM_Reject,
     /* 765227 */ // Label 10078: @765227
     /* 765227 */ GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(766581),
     /* 765232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 765235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 765238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 765241 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 765244 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(765325), // Rule ID 6784 //
     /* 765249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765260 */     // MIs[0] offset
     /* 765260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765263 */     // MIs[0] format
     /* 765263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765266 */     // MIs[0] auxiliary
     /* 765266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765269 */     // MIs[0] Operand 8
     /* 765269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765287 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 765290 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765299 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765323 */     GIR_RootConstrainSelectedInstOperands,
     /* 765324 */     // GIR_Coverage, 6784,
     /* 765324 */     GIR_EraseRootFromParent_Done,
     /* 765325 */   // Label 10100: @765325
     /* 765325 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(765403), // Rule ID 6788 //
     /* 765330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765338 */     // MIs[0] offset
     /* 765338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765341 */     // MIs[0] format
     /* 765341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765344 */     // MIs[0] auxiliary
     /* 765344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765347 */     // MIs[0] Operand 8
     /* 765347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765365 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 765368 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765377 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765379 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765401 */     GIR_RootConstrainSelectedInstOperands,
     /* 765402 */     // GIR_Coverage, 6788,
     /* 765402 */     GIR_EraseRootFromParent_Done,
     /* 765403 */   // Label 10101: @765403
     /* 765403 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(765484), // Rule ID 6816 //
     /* 765408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765419 */     // MIs[0] offset
     /* 765419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765422 */     // MIs[0] format
     /* 765422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765425 */     // MIs[0] auxiliary
     /* 765425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765428 */     // MIs[0] Operand 8
     /* 765428 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765446 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 765449 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765458 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765482 */     GIR_RootConstrainSelectedInstOperands,
     /* 765483 */     // GIR_Coverage, 6816,
     /* 765483 */     GIR_EraseRootFromParent_Done,
     /* 765484 */   // Label 10102: @765484
     /* 765484 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(765562), // Rule ID 6820 //
     /* 765489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765497 */     // MIs[0] offset
     /* 765497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765500 */     // MIs[0] format
     /* 765500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765503 */     // MIs[0] auxiliary
     /* 765503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765506 */     // MIs[0] Operand 8
     /* 765506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765524 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 765527 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765536 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765560 */     GIR_RootConstrainSelectedInstOperands,
     /* 765561 */     // GIR_Coverage, 6820,
     /* 765561 */     GIR_EraseRootFromParent_Done,
     /* 765562 */   // Label 10103: @765562
     /* 765562 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(765641), // Rule ID 6786 //
     /* 765567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765574 */     // MIs[0] offset
     /* 765574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765577 */     // MIs[0] format
     /* 765577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765580 */     // MIs[0] auxiliary
     /* 765580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765583 */     // MIs[0] Operand 8
     /* 765583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765601 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 765604 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765606 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765615 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765639 */     GIR_RootConstrainSelectedInstOperands,
     /* 765640 */     // GIR_Coverage, 6786,
     /* 765640 */     GIR_EraseRootFromParent_Done,
     /* 765641 */   // Label 10104: @765641
     /* 765641 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(765717), // Rule ID 6790 //
     /* 765646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765650 */     // MIs[0] offset
     /* 765650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765653 */     // MIs[0] format
     /* 765653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765656 */     // MIs[0] auxiliary
     /* 765656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765659 */     // MIs[0] Operand 8
     /* 765659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765677 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 765680 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765682 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765715 */     GIR_RootConstrainSelectedInstOperands,
     /* 765716 */     // GIR_Coverage, 6790,
     /* 765716 */     GIR_EraseRootFromParent_Done,
     /* 765717 */   // Label 10105: @765717
     /* 765717 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(765796), // Rule ID 6818 //
     /* 765722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765729 */     // MIs[0] offset
     /* 765729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765732 */     // MIs[0] format
     /* 765732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765735 */     // MIs[0] auxiliary
     /* 765735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765738 */     // MIs[0] Operand 8
     /* 765738 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765756 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 765759 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765761 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765770 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765772 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765794 */     GIR_RootConstrainSelectedInstOperands,
     /* 765795 */     // GIR_Coverage, 6818,
     /* 765795 */     GIR_EraseRootFromParent_Done,
     /* 765796 */   // Label 10106: @765796
     /* 765796 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(765872), // Rule ID 6822 //
     /* 765801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765805 */     // MIs[0] offset
     /* 765805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765808 */     // MIs[0] format
     /* 765808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765811 */     // MIs[0] auxiliary
     /* 765811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765814 */     // MIs[0] Operand 8
     /* 765814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765832 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 765835 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765837 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765846 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765870 */     GIR_RootConstrainSelectedInstOperands,
     /* 765871 */     // GIR_Coverage, 6822,
     /* 765871 */     GIR_EraseRootFromParent_Done,
     /* 765872 */   // Label 10107: @765872
     /* 765872 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(765943), // Rule ID 6785 //
     /* 765877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765884 */     // MIs[0] offset
     /* 765884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765887 */     // MIs[0] format
     /* 765887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765890 */     // MIs[0] auxiliary
     /* 765890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765893 */     // MIs[0] Operand 8
     /* 765893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765903 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 765906 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765908 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765941 */     GIR_RootConstrainSelectedInstOperands,
     /* 765942 */     // GIR_Coverage, 6785,
     /* 765942 */     GIR_EraseRootFromParent_Done,
     /* 765943 */   // Label 10108: @765943
     /* 765943 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(766011), // Rule ID 6789 //
     /* 765948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765952 */     // MIs[0] offset
     /* 765952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765955 */     // MIs[0] format
     /* 765955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765958 */     // MIs[0] auxiliary
     /* 765958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765961 */     // MIs[0] Operand 8
     /* 765961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765971 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 765974 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765976 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765985 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766009 */     GIR_RootConstrainSelectedInstOperands,
     /* 766010 */     // GIR_Coverage, 6789,
     /* 766010 */     GIR_EraseRootFromParent_Done,
     /* 766011 */   // Label 10109: @766011
     /* 766011 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(766082), // Rule ID 6817 //
     /* 766016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766023 */     // MIs[0] offset
     /* 766023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766026 */     // MIs[0] format
     /* 766026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766029 */     // MIs[0] auxiliary
     /* 766029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766032 */     // MIs[0] Operand 8
     /* 766032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766042 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 766045 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766047 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766056 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766080 */     GIR_RootConstrainSelectedInstOperands,
     /* 766081 */     // GIR_Coverage, 6817,
     /* 766081 */     GIR_EraseRootFromParent_Done,
     /* 766082 */   // Label 10110: @766082
     /* 766082 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(766150), // Rule ID 6821 //
     /* 766087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766091 */     // MIs[0] offset
     /* 766091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766094 */     // MIs[0] format
     /* 766094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766097 */     // MIs[0] auxiliary
     /* 766097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766100 */     // MIs[0] Operand 8
     /* 766100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766110 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 766113 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766115 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766148 */     GIR_RootConstrainSelectedInstOperands,
     /* 766149 */     // GIR_Coverage, 6821,
     /* 766149 */     GIR_EraseRootFromParent_Done,
     /* 766150 */   // Label 10111: @766150
     /* 766150 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(766259), // Rule ID 6787 //
     /* 766155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766158 */     // MIs[0] offset
     /* 766158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766161 */     // MIs[0] format
     /* 766161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766164 */     // MIs[0] auxiliary
     /* 766164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766167 */     // MIs[0] Operand 8
     /* 766167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766177 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766193 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 766221 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766233 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766241 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766257 */     GIR_RootConstrainSelectedInstOperands,
     /* 766258 */     // GIR_Coverage, 6787,
     /* 766258 */     GIR_EraseRootFromParent_Done,
     /* 766259 */   // Label 10112: @766259
     /* 766259 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(766365), // Rule ID 6791 //
     /* 766264 */     // MIs[0] offset
     /* 766264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766267 */     // MIs[0] format
     /* 766267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766270 */     // MIs[0] auxiliary
     /* 766270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766273 */     // MIs[0] Operand 8
     /* 766273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766283 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766295 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766299 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766306 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 766327 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766339 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766341 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766363 */     GIR_RootConstrainSelectedInstOperands,
     /* 766364 */     // GIR_Coverage, 6791,
     /* 766364 */     GIR_EraseRootFromParent_Done,
     /* 766365 */   // Label 10113: @766365
     /* 766365 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(766474), // Rule ID 6819 //
     /* 766370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766373 */     // MIs[0] offset
     /* 766373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766376 */     // MIs[0] format
     /* 766376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766379 */     // MIs[0] auxiliary
     /* 766379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766382 */     // MIs[0] Operand 8
     /* 766382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766392 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766408 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766415 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 766436 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766448 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766472 */     GIR_RootConstrainSelectedInstOperands,
     /* 766473 */     // GIR_Coverage, 6819,
     /* 766473 */     GIR_EraseRootFromParent_Done,
     /* 766474 */   // Label 10114: @766474
     /* 766474 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(766580), // Rule ID 6823 //
     /* 766479 */     // MIs[0] offset
     /* 766479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766482 */     // MIs[0] format
     /* 766482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766485 */     // MIs[0] auxiliary
     /* 766485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766488 */     // MIs[0] Operand 8
     /* 766488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766498 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766514 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766517 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766521 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 766542 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766554 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766578 */     GIR_RootConstrainSelectedInstOperands,
     /* 766579 */     // GIR_Coverage, 6823,
     /* 766579 */     GIR_EraseRootFromParent_Done,
     /* 766580 */   // Label 10115: @766580
     /* 766580 */   GIM_Reject,
     /* 766581 */ // Label 10099: @766581
     /* 766581 */ GIM_Reject,
     /* 766582 */ // Label 10079: @766582
     /* 766582 */ GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(767936),
     /* 766587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 766590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 766593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 766596 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 766599 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(766680), // Rule ID 6792 //
     /* 766604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766615 */     // MIs[0] offset
     /* 766615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766618 */     // MIs[0] format
     /* 766618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766621 */     // MIs[0] auxiliary
     /* 766621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766624 */     // MIs[0] Operand 8
     /* 766624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766642 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 766645 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766654 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766678 */     GIR_RootConstrainSelectedInstOperands,
     /* 766679 */     // GIR_Coverage, 6792,
     /* 766679 */     GIR_EraseRootFromParent_Done,
     /* 766680 */   // Label 10117: @766680
     /* 766680 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(766758), // Rule ID 6796 //
     /* 766685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766693 */     // MIs[0] offset
     /* 766693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766696 */     // MIs[0] format
     /* 766696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766699 */     // MIs[0] auxiliary
     /* 766699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766702 */     // MIs[0] Operand 8
     /* 766702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766720 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 766723 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766732 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766756 */     GIR_RootConstrainSelectedInstOperands,
     /* 766757 */     // GIR_Coverage, 6796,
     /* 766757 */     GIR_EraseRootFromParent_Done,
     /* 766758 */   // Label 10118: @766758
     /* 766758 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(766839), // Rule ID 6824 //
     /* 766763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766774 */     // MIs[0] offset
     /* 766774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766777 */     // MIs[0] format
     /* 766777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766780 */     // MIs[0] auxiliary
     /* 766780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766783 */     // MIs[0] Operand 8
     /* 766783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766801 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 766804 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766837 */     GIR_RootConstrainSelectedInstOperands,
     /* 766838 */     // GIR_Coverage, 6824,
     /* 766838 */     GIR_EraseRootFromParent_Done,
     /* 766839 */   // Label 10119: @766839
     /* 766839 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(766917), // Rule ID 6828 //
     /* 766844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766852 */     // MIs[0] offset
     /* 766852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766855 */     // MIs[0] format
     /* 766855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766858 */     // MIs[0] auxiliary
     /* 766858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766861 */     // MIs[0] Operand 8
     /* 766861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766879 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9785:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 766882 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766891 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766915 */     GIR_RootConstrainSelectedInstOperands,
     /* 766916 */     // GIR_Coverage, 6828,
     /* 766916 */     GIR_EraseRootFromParent_Done,
     /* 766917 */   // Label 10120: @766917
     /* 766917 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(766996), // Rule ID 6794 //
     /* 766922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766929 */     // MIs[0] offset
     /* 766929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766932 */     // MIs[0] format
     /* 766932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766935 */     // MIs[0] auxiliary
     /* 766935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766938 */     // MIs[0] Operand 8
     /* 766938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766956 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 766959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766961 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766970 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766994 */     GIR_RootConstrainSelectedInstOperands,
     /* 766995 */     // GIR_Coverage, 6794,
     /* 766995 */     GIR_EraseRootFromParent_Done,
     /* 766996 */   // Label 10121: @766996
     /* 766996 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(767072), // Rule ID 6798 //
     /* 767001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767005 */     // MIs[0] offset
     /* 767005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767008 */     // MIs[0] format
     /* 767008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767011 */     // MIs[0] auxiliary
     /* 767011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767014 */     // MIs[0] Operand 8
     /* 767014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767032 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 767035 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767037 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767046 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767070 */     GIR_RootConstrainSelectedInstOperands,
     /* 767071 */     // GIR_Coverage, 6798,
     /* 767071 */     GIR_EraseRootFromParent_Done,
     /* 767072 */   // Label 10122: @767072
     /* 767072 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(767151), // Rule ID 6826 //
     /* 767077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767084 */     // MIs[0] offset
     /* 767084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767087 */     // MIs[0] format
     /* 767087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767090 */     // MIs[0] auxiliary
     /* 767090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767093 */     // MIs[0] Operand 8
     /* 767093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767111 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 767114 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767116 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767125 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767149 */     GIR_RootConstrainSelectedInstOperands,
     /* 767150 */     // GIR_Coverage, 6826,
     /* 767150 */     GIR_EraseRootFromParent_Done,
     /* 767151 */   // Label 10123: @767151
     /* 767151 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(767227), // Rule ID 6830 //
     /* 767156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767160 */     // MIs[0] offset
     /* 767160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767163 */     // MIs[0] format
     /* 767163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767166 */     // MIs[0] auxiliary
     /* 767166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767169 */     // MIs[0] Operand 8
     /* 767169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767187 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 767190 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767192 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767201 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767203 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767225 */     GIR_RootConstrainSelectedInstOperands,
     /* 767226 */     // GIR_Coverage, 6830,
     /* 767226 */     GIR_EraseRootFromParent_Done,
     /* 767227 */   // Label 10124: @767227
     /* 767227 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(767298), // Rule ID 6793 //
     /* 767232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767239 */     // MIs[0] offset
     /* 767239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767242 */     // MIs[0] format
     /* 767242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767245 */     // MIs[0] auxiliary
     /* 767245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767248 */     // MIs[0] Operand 8
     /* 767248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767258 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 767261 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767263 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767272 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767296 */     GIR_RootConstrainSelectedInstOperands,
     /* 767297 */     // GIR_Coverage, 6793,
     /* 767297 */     GIR_EraseRootFromParent_Done,
     /* 767298 */   // Label 10125: @767298
     /* 767298 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(767366), // Rule ID 6797 //
     /* 767303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767307 */     // MIs[0] offset
     /* 767307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767310 */     // MIs[0] format
     /* 767310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767313 */     // MIs[0] auxiliary
     /* 767313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767316 */     // MIs[0] Operand 8
     /* 767316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767326 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 767329 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767331 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767340 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767364 */     GIR_RootConstrainSelectedInstOperands,
     /* 767365 */     // GIR_Coverage, 6797,
     /* 767365 */     GIR_EraseRootFromParent_Done,
     /* 767366 */   // Label 10126: @767366
     /* 767366 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(767437), // Rule ID 6825 //
     /* 767371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767378 */     // MIs[0] offset
     /* 767378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767381 */     // MIs[0] format
     /* 767381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767384 */     // MIs[0] auxiliary
     /* 767384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767387 */     // MIs[0] Operand 8
     /* 767387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767397 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 767400 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767402 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767411 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767435 */     GIR_RootConstrainSelectedInstOperands,
     /* 767436 */     // GIR_Coverage, 6825,
     /* 767436 */     GIR_EraseRootFromParent_Done,
     /* 767437 */   // Label 10127: @767437
     /* 767437 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(767505), // Rule ID 6829 //
     /* 767442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767446 */     // MIs[0] offset
     /* 767446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767449 */     // MIs[0] format
     /* 767449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767452 */     // MIs[0] auxiliary
     /* 767452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767455 */     // MIs[0] Operand 8
     /* 767455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767465 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 767468 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767470 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767479 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767503 */     GIR_RootConstrainSelectedInstOperands,
     /* 767504 */     // GIR_Coverage, 6829,
     /* 767504 */     GIR_EraseRootFromParent_Done,
     /* 767505 */   // Label 10128: @767505
     /* 767505 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(767614), // Rule ID 6795 //
     /* 767510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767513 */     // MIs[0] offset
     /* 767513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767516 */     // MIs[0] format
     /* 767516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767519 */     // MIs[0] auxiliary
     /* 767519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767522 */     // MIs[0] Operand 8
     /* 767522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767532 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767548 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767555 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 767576 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767588 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767612 */     GIR_RootConstrainSelectedInstOperands,
     /* 767613 */     // GIR_Coverage, 6795,
     /* 767613 */     GIR_EraseRootFromParent_Done,
     /* 767614 */   // Label 10129: @767614
     /* 767614 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(767720), // Rule ID 6799 //
     /* 767619 */     // MIs[0] offset
     /* 767619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767622 */     // MIs[0] format
     /* 767622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767625 */     // MIs[0] auxiliary
     /* 767625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767628 */     // MIs[0] Operand 8
     /* 767628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767638 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767654 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767661 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 767682 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767694 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767718 */     GIR_RootConstrainSelectedInstOperands,
     /* 767719 */     // GIR_Coverage, 6799,
     /* 767719 */     GIR_EraseRootFromParent_Done,
     /* 767720 */   // Label 10130: @767720
     /* 767720 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(767829), // Rule ID 6827 //
     /* 767725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767728 */     // MIs[0] offset
     /* 767728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767731 */     // MIs[0] format
     /* 767731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767734 */     // MIs[0] auxiliary
     /* 767734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767737 */     // MIs[0] Operand 8
     /* 767737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767747 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767763 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767770 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 767791 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767803 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767827 */     GIR_RootConstrainSelectedInstOperands,
     /* 767828 */     // GIR_Coverage, 6827,
     /* 767828 */     GIR_EraseRootFromParent_Done,
     /* 767829 */   // Label 10131: @767829
     /* 767829 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(767935), // Rule ID 6831 //
     /* 767834 */     // MIs[0] offset
     /* 767834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767837 */     // MIs[0] format
     /* 767837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767840 */     // MIs[0] auxiliary
     /* 767840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767843 */     // MIs[0] Operand 8
     /* 767843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767853 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9785:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767869 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767876 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 767897 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767909 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767911 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767933 */     GIR_RootConstrainSelectedInstOperands,
     /* 767934 */     // GIR_Coverage, 6831,
     /* 767934 */     GIR_EraseRootFromParent_Done,
     /* 767935 */   // Label 10132: @767935
     /* 767935 */   GIM_Reject,
     /* 767936 */ // Label 10116: @767936
     /* 767936 */ GIM_Reject,
     /* 767937 */ // Label 10080: @767937
     /* 767937 */ GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(769291),
     /* 767942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 767945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 767948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 767951 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 767954 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(768035), // Rule ID 6800 //
     /* 767959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767970 */     // MIs[0] offset
     /* 767970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767973 */     // MIs[0] format
     /* 767973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767976 */     // MIs[0] auxiliary
     /* 767976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767979 */     // MIs[0] Operand 8
     /* 767979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767997 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 768000 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768009 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768033 */     GIR_RootConstrainSelectedInstOperands,
     /* 768034 */     // GIR_Coverage, 6800,
     /* 768034 */     GIR_EraseRootFromParent_Done,
     /* 768035 */   // Label 10134: @768035
     /* 768035 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(768113), // Rule ID 6804 //
     /* 768040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768048 */     // MIs[0] offset
     /* 768048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768051 */     // MIs[0] format
     /* 768051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768054 */     // MIs[0] auxiliary
     /* 768054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768057 */     // MIs[0] Operand 8
     /* 768057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768075 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 768078 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768087 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768111 */     GIR_RootConstrainSelectedInstOperands,
     /* 768112 */     // GIR_Coverage, 6804,
     /* 768112 */     GIR_EraseRootFromParent_Done,
     /* 768113 */   // Label 10135: @768113
     /* 768113 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(768194), // Rule ID 6832 //
     /* 768118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768129 */     // MIs[0] offset
     /* 768129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768132 */     // MIs[0] format
     /* 768132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768135 */     // MIs[0] auxiliary
     /* 768135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768138 */     // MIs[0] Operand 8
     /* 768138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768156 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 768159 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768192 */     GIR_RootConstrainSelectedInstOperands,
     /* 768193 */     // GIR_Coverage, 6832,
     /* 768193 */     GIR_EraseRootFromParent_Done,
     /* 768194 */   // Label 10136: @768194
     /* 768194 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(768272), // Rule ID 6836 //
     /* 768199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768207 */     // MIs[0] offset
     /* 768207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768210 */     // MIs[0] format
     /* 768210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768213 */     // MIs[0] auxiliary
     /* 768213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768216 */     // MIs[0] Operand 8
     /* 768216 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768234 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9784:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 768237 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768246 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768270 */     GIR_RootConstrainSelectedInstOperands,
     /* 768271 */     // GIR_Coverage, 6836,
     /* 768271 */     GIR_EraseRootFromParent_Done,
     /* 768272 */   // Label 10137: @768272
     /* 768272 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(768351), // Rule ID 6802 //
     /* 768277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768284 */     // MIs[0] offset
     /* 768284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768287 */     // MIs[0] format
     /* 768287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768290 */     // MIs[0] auxiliary
     /* 768290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768293 */     // MIs[0] Operand 8
     /* 768293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768311 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 768314 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768316 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768325 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768349 */     GIR_RootConstrainSelectedInstOperands,
     /* 768350 */     // GIR_Coverage, 6802,
     /* 768350 */     GIR_EraseRootFromParent_Done,
     /* 768351 */   // Label 10138: @768351
     /* 768351 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(768427), // Rule ID 6806 //
     /* 768356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768360 */     // MIs[0] offset
     /* 768360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768363 */     // MIs[0] format
     /* 768363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768366 */     // MIs[0] auxiliary
     /* 768366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768369 */     // MIs[0] Operand 8
     /* 768369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768387 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 768390 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768392 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768425 */     GIR_RootConstrainSelectedInstOperands,
     /* 768426 */     // GIR_Coverage, 6806,
     /* 768426 */     GIR_EraseRootFromParent_Done,
     /* 768427 */   // Label 10139: @768427
     /* 768427 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(768506), // Rule ID 6834 //
     /* 768432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768439 */     // MIs[0] offset
     /* 768439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768442 */     // MIs[0] format
     /* 768442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768445 */     // MIs[0] auxiliary
     /* 768445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768448 */     // MIs[0] Operand 8
     /* 768448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768466 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 768469 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768471 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768480 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768504 */     GIR_RootConstrainSelectedInstOperands,
     /* 768505 */     // GIR_Coverage, 6834,
     /* 768505 */     GIR_EraseRootFromParent_Done,
     /* 768506 */   // Label 10140: @768506
     /* 768506 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(768582), // Rule ID 6838 //
     /* 768511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768515 */     // MIs[0] offset
     /* 768515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768518 */     // MIs[0] format
     /* 768518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768521 */     // MIs[0] auxiliary
     /* 768521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768524 */     // MIs[0] Operand 8
     /* 768524 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768542 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 768545 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768547 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768580 */     GIR_RootConstrainSelectedInstOperands,
     /* 768581 */     // GIR_Coverage, 6838,
     /* 768581 */     GIR_EraseRootFromParent_Done,
     /* 768582 */   // Label 10141: @768582
     /* 768582 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(768653), // Rule ID 6801 //
     /* 768587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768594 */     // MIs[0] offset
     /* 768594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768597 */     // MIs[0] format
     /* 768597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768600 */     // MIs[0] auxiliary
     /* 768600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768603 */     // MIs[0] Operand 8
     /* 768603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768613 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 768616 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768618 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768627 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768651 */     GIR_RootConstrainSelectedInstOperands,
     /* 768652 */     // GIR_Coverage, 6801,
     /* 768652 */     GIR_EraseRootFromParent_Done,
     /* 768653 */   // Label 10142: @768653
     /* 768653 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(768721), // Rule ID 6805 //
     /* 768658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768662 */     // MIs[0] offset
     /* 768662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768665 */     // MIs[0] format
     /* 768665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768668 */     // MIs[0] auxiliary
     /* 768668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768671 */     // MIs[0] Operand 8
     /* 768671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768681 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 768684 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768686 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768695 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768719 */     GIR_RootConstrainSelectedInstOperands,
     /* 768720 */     // GIR_Coverage, 6805,
     /* 768720 */     GIR_EraseRootFromParent_Done,
     /* 768721 */   // Label 10143: @768721
     /* 768721 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(768792), // Rule ID 6833 //
     /* 768726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768733 */     // MIs[0] offset
     /* 768733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768736 */     // MIs[0] format
     /* 768736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768739 */     // MIs[0] auxiliary
     /* 768739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768742 */     // MIs[0] Operand 8
     /* 768742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768752 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 768755 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768757 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768766 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768790 */     GIR_RootConstrainSelectedInstOperands,
     /* 768791 */     // GIR_Coverage, 6833,
     /* 768791 */     GIR_EraseRootFromParent_Done,
     /* 768792 */   // Label 10144: @768792
     /* 768792 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(768860), // Rule ID 6837 //
     /* 768797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768801 */     // MIs[0] offset
     /* 768801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768804 */     // MIs[0] format
     /* 768804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768807 */     // MIs[0] auxiliary
     /* 768807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768810 */     // MIs[0] Operand 8
     /* 768810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768820 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 768823 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768825 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768834 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768858 */     GIR_RootConstrainSelectedInstOperands,
     /* 768859 */     // GIR_Coverage, 6837,
     /* 768859 */     GIR_EraseRootFromParent_Done,
     /* 768860 */   // Label 10145: @768860
     /* 768860 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(768969), // Rule ID 6803 //
     /* 768865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768868 */     // MIs[0] offset
     /* 768868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768871 */     // MIs[0] format
     /* 768871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768874 */     // MIs[0] auxiliary
     /* 768874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768877 */     // MIs[0] Operand 8
     /* 768877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768887 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768903 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768910 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 768931 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768943 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768957 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768967 */     GIR_RootConstrainSelectedInstOperands,
     /* 768968 */     // GIR_Coverage, 6803,
     /* 768968 */     GIR_EraseRootFromParent_Done,
     /* 768969 */   // Label 10146: @768969
     /* 768969 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(769075), // Rule ID 6807 //
     /* 768974 */     // MIs[0] offset
     /* 768974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768977 */     // MIs[0] format
     /* 768977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768980 */     // MIs[0] auxiliary
     /* 768980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768983 */     // MIs[0] Operand 8
     /* 768983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768993 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769009 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769016 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 769037 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769049 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769073 */     GIR_RootConstrainSelectedInstOperands,
     /* 769074 */     // GIR_Coverage, 6807,
     /* 769074 */     GIR_EraseRootFromParent_Done,
     /* 769075 */   // Label 10147: @769075
     /* 769075 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(769184), // Rule ID 6835 //
     /* 769080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769083 */     // MIs[0] offset
     /* 769083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769086 */     // MIs[0] format
     /* 769086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769089 */     // MIs[0] auxiliary
     /* 769089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769092 */     // MIs[0] Operand 8
     /* 769092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769102 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 769105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 769146 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769158 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769182 */     GIR_RootConstrainSelectedInstOperands,
     /* 769183 */     // GIR_Coverage, 6835,
     /* 769183 */     GIR_EraseRootFromParent_Done,
     /* 769184 */   // Label 10148: @769184
     /* 769184 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(769290), // Rule ID 6839 //
     /* 769189 */     // MIs[0] offset
     /* 769189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769192 */     // MIs[0] format
     /* 769192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769195 */     // MIs[0] auxiliary
     /* 769195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769198 */     // MIs[0] Operand 8
     /* 769198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769208 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9784:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 769211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769224 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769231 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 769252 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769264 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769266 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769288 */     GIR_RootConstrainSelectedInstOperands,
     /* 769289 */     // GIR_Coverage, 6839,
     /* 769289 */     GIR_EraseRootFromParent_Done,
     /* 769290 */   // Label 10149: @769290
     /* 769290 */   GIM_Reject,
     /* 769291 */ // Label 10133: @769291
     /* 769291 */ GIM_Reject,
     /* 769292 */ // Label 10081: @769292
     /* 769292 */ GIM_Reject,
     /* 769293 */ // Label 165: @769293
     /* 769293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10157*/ GIMT_Encode4(773897),
     /* 769304 */ /*GILLT_s16*//*Label 10150*/ GIMT_Encode4(769344),
     /* 769308 */ /*GILLT_s32*//*Label 10151*/ GIMT_Encode4(770383), GIMT_Encode4(0),
     /* 769316 */ /*GILLT_v2s16*//*Label 10152*/ GIMT_Encode4(771422),
     /* 769320 */ /*GILLT_v2s32*//*Label 10153*/ GIMT_Encode4(772121), GIMT_Encode4(0),
     /* 769328 */ /*GILLT_v3s32*//*Label 10154*/ GIMT_Encode4(772480), GIMT_Encode4(0),
     /* 769336 */ /*GILLT_v4s16*//*Label 10155*/ GIMT_Encode4(772839),
     /* 769340 */ /*GILLT_v4s32*//*Label 10156*/ GIMT_Encode4(773538),
     /* 769344 */ // Label 10150: @769344
     /* 769344 */ GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(770382),
     /* 769349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 769352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 769355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 769358 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 769361 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(769442), // Rule ID 6840 //
     /* 769366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769377 */     // MIs[0] offset
     /* 769377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769380 */     // MIs[0] format
     /* 769380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769383 */     // MIs[0] auxiliary
     /* 769383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769386 */     // MIs[0] Operand 8
     /* 769386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769404 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 769407 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769440 */     GIR_RootConstrainSelectedInstOperands,
     /* 769441 */     // GIR_Coverage, 6840,
     /* 769441 */     GIR_EraseRootFromParent_Done,
     /* 769442 */   // Label 10159: @769442
     /* 769442 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(769523), // Rule ID 6860 //
     /* 769447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769458 */     // MIs[0] offset
     /* 769458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769461 */     // MIs[0] format
     /* 769461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769464 */     // MIs[0] auxiliary
     /* 769464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769467 */     // MIs[0] Operand 8
     /* 769467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769485 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 769488 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769521 */     GIR_RootConstrainSelectedInstOperands,
     /* 769522 */     // GIR_Coverage, 6860,
     /* 769522 */     GIR_EraseRootFromParent_Done,
     /* 769523 */   // Label 10160: @769523
     /* 769523 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(769604), // Rule ID 6864 //
     /* 769528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769539 */     // MIs[0] offset
     /* 769539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769542 */     // MIs[0] format
     /* 769542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769545 */     // MIs[0] auxiliary
     /* 769545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769548 */     // MIs[0] Operand 8
     /* 769548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769566 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 769569 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769578 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769602 */     GIR_RootConstrainSelectedInstOperands,
     /* 769603 */     // GIR_Coverage, 6864,
     /* 769603 */     GIR_EraseRootFromParent_Done,
     /* 769604 */   // Label 10161: @769604
     /* 769604 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(769683), // Rule ID 6842 //
     /* 769609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769616 */     // MIs[0] offset
     /* 769616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769619 */     // MIs[0] format
     /* 769619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769622 */     // MIs[0] auxiliary
     /* 769622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769625 */     // MIs[0] Operand 8
     /* 769625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769643 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 769646 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769648 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769657 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769659 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769681 */     GIR_RootConstrainSelectedInstOperands,
     /* 769682 */     // GIR_Coverage, 6842,
     /* 769682 */     GIR_EraseRootFromParent_Done,
     /* 769683 */   // Label 10162: @769683
     /* 769683 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(769762), // Rule ID 6862 //
     /* 769688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769695 */     // MIs[0] offset
     /* 769695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769698 */     // MIs[0] format
     /* 769698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769701 */     // MIs[0] auxiliary
     /* 769701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769704 */     // MIs[0] Operand 8
     /* 769704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769722 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 769725 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769727 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769760 */     GIR_RootConstrainSelectedInstOperands,
     /* 769761 */     // GIR_Coverage, 6862,
     /* 769761 */     GIR_EraseRootFromParent_Done,
     /* 769762 */   // Label 10163: @769762
     /* 769762 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(769841), // Rule ID 6866 //
     /* 769767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769774 */     // MIs[0] offset
     /* 769774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769777 */     // MIs[0] format
     /* 769777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769780 */     // MIs[0] auxiliary
     /* 769780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769783 */     // MIs[0] Operand 8
     /* 769783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769801 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 769804 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769806 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769815 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769839 */     GIR_RootConstrainSelectedInstOperands,
     /* 769840 */     // GIR_Coverage, 6866,
     /* 769840 */     GIR_EraseRootFromParent_Done,
     /* 769841 */   // Label 10164: @769841
     /* 769841 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(769912), // Rule ID 6841 //
     /* 769846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769853 */     // MIs[0] offset
     /* 769853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769856 */     // MIs[0] format
     /* 769856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769859 */     // MIs[0] auxiliary
     /* 769859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769862 */     // MIs[0] Operand 8
     /* 769862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769872 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 769875 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769877 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769886 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769910 */     GIR_RootConstrainSelectedInstOperands,
     /* 769911 */     // GIR_Coverage, 6841,
     /* 769911 */     GIR_EraseRootFromParent_Done,
     /* 769912 */   // Label 10165: @769912
     /* 769912 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(769983), // Rule ID 6861 //
     /* 769917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769924 */     // MIs[0] offset
     /* 769924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769927 */     // MIs[0] format
     /* 769927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769930 */     // MIs[0] auxiliary
     /* 769930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769933 */     // MIs[0] Operand 8
     /* 769933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769943 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 769946 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769948 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769957 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769981 */     GIR_RootConstrainSelectedInstOperands,
     /* 769982 */     // GIR_Coverage, 6861,
     /* 769982 */     GIR_EraseRootFromParent_Done,
     /* 769983 */   // Label 10166: @769983
     /* 769983 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(770054), // Rule ID 6865 //
     /* 769988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769995 */     // MIs[0] offset
     /* 769995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769998 */     // MIs[0] format
     /* 769998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770001 */     // MIs[0] auxiliary
     /* 770001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770004 */     // MIs[0] Operand 8
     /* 770004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770014 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 770017 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770019 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770028 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770052 */     GIR_RootConstrainSelectedInstOperands,
     /* 770053 */     // GIR_Coverage, 6865,
     /* 770053 */     GIR_EraseRootFromParent_Done,
     /* 770054 */   // Label 10167: @770054
     /* 770054 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(770163), // Rule ID 6843 //
     /* 770059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770062 */     // MIs[0] offset
     /* 770062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770065 */     // MIs[0] format
     /* 770065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770068 */     // MIs[0] auxiliary
     /* 770068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770071 */     // MIs[0] Operand 8
     /* 770071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770081 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770097 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770104 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 770125 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770161 */     GIR_RootConstrainSelectedInstOperands,
     /* 770162 */     // GIR_Coverage, 6843,
     /* 770162 */     GIR_EraseRootFromParent_Done,
     /* 770163 */   // Label 10168: @770163
     /* 770163 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(770272), // Rule ID 6863 //
     /* 770168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770171 */     // MIs[0] offset
     /* 770171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770174 */     // MIs[0] format
     /* 770174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770177 */     // MIs[0] auxiliary
     /* 770177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770180 */     // MIs[0] Operand 8
     /* 770180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770190 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770206 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770213 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 770234 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770246 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770270 */     GIR_RootConstrainSelectedInstOperands,
     /* 770271 */     // GIR_Coverage, 6863,
     /* 770271 */     GIR_EraseRootFromParent_Done,
     /* 770272 */   // Label 10169: @770272
     /* 770272 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(770381), // Rule ID 6867 //
     /* 770277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770280 */     // MIs[0] offset
     /* 770280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770283 */     // MIs[0] format
     /* 770283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770286 */     // MIs[0] auxiliary
     /* 770286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770289 */     // MIs[0] Operand 8
     /* 770289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770299 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770315 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770322 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 770343 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770355 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770379 */     GIR_RootConstrainSelectedInstOperands,
     /* 770380 */     // GIR_Coverage, 6867,
     /* 770380 */     GIR_EraseRootFromParent_Done,
     /* 770381 */   // Label 10170: @770381
     /* 770381 */   GIM_Reject,
     /* 770382 */ // Label 10158: @770382
     /* 770382 */ GIM_Reject,
     /* 770383 */ // Label 10151: @770383
     /* 770383 */ GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(771421),
     /* 770388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 770391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 770394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 770397 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 770400 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(770481), // Rule ID 6844 //
     /* 770405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770416 */     // MIs[0] offset
     /* 770416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770419 */     // MIs[0] format
     /* 770419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770422 */     // MIs[0] auxiliary
     /* 770422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770425 */     // MIs[0] Operand 8
     /* 770425 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770443 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 770446 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770455 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770479 */     GIR_RootConstrainSelectedInstOperands,
     /* 770480 */     // GIR_Coverage, 6844,
     /* 770480 */     GIR_EraseRootFromParent_Done,
     /* 770481 */   // Label 10172: @770481
     /* 770481 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(770562), // Rule ID 6868 //
     /* 770486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770497 */     // MIs[0] offset
     /* 770497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770500 */     // MIs[0] format
     /* 770500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770503 */     // MIs[0] auxiliary
     /* 770503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770506 */     // MIs[0] Operand 8
     /* 770506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770524 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 770527 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770536 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770560 */     GIR_RootConstrainSelectedInstOperands,
     /* 770561 */     // GIR_Coverage, 6868,
     /* 770561 */     GIR_EraseRootFromParent_Done,
     /* 770562 */   // Label 10173: @770562
     /* 770562 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(770643), // Rule ID 6872 //
     /* 770567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770578 */     // MIs[0] offset
     /* 770578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770581 */     // MIs[0] format
     /* 770581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770584 */     // MIs[0] auxiliary
     /* 770584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770587 */     // MIs[0] Operand 8
     /* 770587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770605 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9787:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 770608 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770617 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770641 */     GIR_RootConstrainSelectedInstOperands,
     /* 770642 */     // GIR_Coverage, 6872,
     /* 770642 */     GIR_EraseRootFromParent_Done,
     /* 770643 */   // Label 10174: @770643
     /* 770643 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(770722), // Rule ID 6846 //
     /* 770648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770655 */     // MIs[0] offset
     /* 770655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770658 */     // MIs[0] format
     /* 770658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770661 */     // MIs[0] auxiliary
     /* 770661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770664 */     // MIs[0] Operand 8
     /* 770664 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770682 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 770685 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770687 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770696 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770720 */     GIR_RootConstrainSelectedInstOperands,
     /* 770721 */     // GIR_Coverage, 6846,
     /* 770721 */     GIR_EraseRootFromParent_Done,
     /* 770722 */   // Label 10175: @770722
     /* 770722 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(770801), // Rule ID 6870 //
     /* 770727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770734 */     // MIs[0] offset
     /* 770734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770737 */     // MIs[0] format
     /* 770737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770740 */     // MIs[0] auxiliary
     /* 770740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770743 */     // MIs[0] Operand 8
     /* 770743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770761 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 770764 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770766 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770775 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770799 */     GIR_RootConstrainSelectedInstOperands,
     /* 770800 */     // GIR_Coverage, 6870,
     /* 770800 */     GIR_EraseRootFromParent_Done,
     /* 770801 */   // Label 10176: @770801
     /* 770801 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(770880), // Rule ID 6874 //
     /* 770806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770813 */     // MIs[0] offset
     /* 770813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770816 */     // MIs[0] format
     /* 770816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770819 */     // MIs[0] auxiliary
     /* 770819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770822 */     // MIs[0] Operand 8
     /* 770822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770840 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 770843 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770845 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770854 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770878 */     GIR_RootConstrainSelectedInstOperands,
     /* 770879 */     // GIR_Coverage, 6874,
     /* 770879 */     GIR_EraseRootFromParent_Done,
     /* 770880 */   // Label 10177: @770880
     /* 770880 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(770951), // Rule ID 6845 //
     /* 770885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770892 */     // MIs[0] offset
     /* 770892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770895 */     // MIs[0] format
     /* 770895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770898 */     // MIs[0] auxiliary
     /* 770898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770901 */     // MIs[0] Operand 8
     /* 770901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770911 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 770914 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770916 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770925 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770949 */     GIR_RootConstrainSelectedInstOperands,
     /* 770950 */     // GIR_Coverage, 6845,
     /* 770950 */     GIR_EraseRootFromParent_Done,
     /* 770951 */   // Label 10178: @770951
     /* 770951 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(771022), // Rule ID 6869 //
     /* 770956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770963 */     // MIs[0] offset
     /* 770963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770966 */     // MIs[0] format
     /* 770966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770969 */     // MIs[0] auxiliary
     /* 770969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770972 */     // MIs[0] Operand 8
     /* 770972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770982 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 770985 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770987 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770996 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771020 */     GIR_RootConstrainSelectedInstOperands,
     /* 771021 */     // GIR_Coverage, 6869,
     /* 771021 */     GIR_EraseRootFromParent_Done,
     /* 771022 */   // Label 10179: @771022
     /* 771022 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(771093), // Rule ID 6873 //
     /* 771027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771034 */     // MIs[0] offset
     /* 771034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771037 */     // MIs[0] format
     /* 771037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771040 */     // MIs[0] auxiliary
     /* 771040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771043 */     // MIs[0] Operand 8
     /* 771043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771053 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9787:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 771056 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771058 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771067 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771091 */     GIR_RootConstrainSelectedInstOperands,
     /* 771092 */     // GIR_Coverage, 6873,
     /* 771092 */     GIR_EraseRootFromParent_Done,
     /* 771093 */   // Label 10180: @771093
     /* 771093 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(771202), // Rule ID 6847 //
     /* 771098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 771101 */     // MIs[0] offset
     /* 771101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771104 */     // MIs[0] format
     /* 771104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771107 */     // MIs[0] auxiliary
     /* 771107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771110 */     // MIs[0] Operand 8
     /* 771110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771120 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771143 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 771164 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771176 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771200 */     GIR_RootConstrainSelectedInstOperands,
     /* 771201 */     // GIR_Coverage, 6847,
     /* 771201 */     GIR_EraseRootFromParent_Done,
     /* 771202 */   // Label 10181: @771202
     /* 771202 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(771311), // Rule ID 6871 //
     /* 771207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771210 */     // MIs[0] offset
     /* 771210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771213 */     // MIs[0] format
     /* 771213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771216 */     // MIs[0] auxiliary
     /* 771216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771219 */     // MIs[0] Operand 8
     /* 771219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771229 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771245 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771252 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 771273 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771309 */     GIR_RootConstrainSelectedInstOperands,
     /* 771310 */     // GIR_Coverage, 6871,
     /* 771310 */     GIR_EraseRootFromParent_Done,
     /* 771311 */   // Label 10182: @771311
     /* 771311 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(771420), // Rule ID 6875 //
     /* 771316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771319 */     // MIs[0] offset
     /* 771319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771322 */     // MIs[0] format
     /* 771322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771325 */     // MIs[0] auxiliary
     /* 771325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771328 */     // MIs[0] Operand 8
     /* 771328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771338 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771354 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 771382 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771418 */     GIR_RootConstrainSelectedInstOperands,
     /* 771419 */     // GIR_Coverage, 6875,
     /* 771419 */     GIR_EraseRootFromParent_Done,
     /* 771420 */   // Label 10183: @771420
     /* 771420 */   GIM_Reject,
     /* 771421 */ // Label 10171: @771421
     /* 771421 */ GIM_Reject,
     /* 771422 */ // Label 10152: @771422
     /* 771422 */ GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(772120),
     /* 771427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 771430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 771433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 771436 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 771439 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(771520), // Rule ID 6876 //
     /* 771444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771455 */     // MIs[0] offset
     /* 771455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771458 */     // MIs[0] format
     /* 771458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771461 */     // MIs[0] auxiliary
     /* 771461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771464 */     // MIs[0] Operand 8
     /* 771464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771482 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 771485 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771494 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771518 */     GIR_RootConstrainSelectedInstOperands,
     /* 771519 */     // GIR_Coverage, 6876,
     /* 771519 */     GIR_EraseRootFromParent_Done,
     /* 771520 */   // Label 10185: @771520
     /* 771520 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(771601), // Rule ID 6880 //
     /* 771525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771536 */     // MIs[0] offset
     /* 771536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771539 */     // MIs[0] format
     /* 771539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771542 */     // MIs[0] auxiliary
     /* 771542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771545 */     // MIs[0] Operand 8
     /* 771545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771563 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9787:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 771566 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771575 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771589 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771599 */     GIR_RootConstrainSelectedInstOperands,
     /* 771600 */     // GIR_Coverage, 6880,
     /* 771600 */     GIR_EraseRootFromParent_Done,
     /* 771601 */   // Label 10186: @771601
     /* 771601 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(771680), // Rule ID 6878 //
     /* 771606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771613 */     // MIs[0] offset
     /* 771613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771616 */     // MIs[0] format
     /* 771616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771619 */     // MIs[0] auxiliary
     /* 771619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771622 */     // MIs[0] Operand 8
     /* 771622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771640 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 771643 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771645 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771654 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771678 */     GIR_RootConstrainSelectedInstOperands,
     /* 771679 */     // GIR_Coverage, 6878,
     /* 771679 */     GIR_EraseRootFromParent_Done,
     /* 771680 */   // Label 10187: @771680
     /* 771680 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(771759), // Rule ID 6882 //
     /* 771685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771692 */     // MIs[0] offset
     /* 771692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771695 */     // MIs[0] format
     /* 771695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771698 */     // MIs[0] auxiliary
     /* 771698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771701 */     // MIs[0] Operand 8
     /* 771701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771719 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 771722 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771724 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771733 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771757 */     GIR_RootConstrainSelectedInstOperands,
     /* 771758 */     // GIR_Coverage, 6882,
     /* 771758 */     GIR_EraseRootFromParent_Done,
     /* 771759 */   // Label 10188: @771759
     /* 771759 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(771830), // Rule ID 6877 //
     /* 771764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771771 */     // MIs[0] offset
     /* 771771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771774 */     // MIs[0] format
     /* 771774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771777 */     // MIs[0] auxiliary
     /* 771777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771780 */     // MIs[0] Operand 8
     /* 771780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771790 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 771793 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771795 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771804 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771828 */     GIR_RootConstrainSelectedInstOperands,
     /* 771829 */     // GIR_Coverage, 6877,
     /* 771829 */     GIR_EraseRootFromParent_Done,
     /* 771830 */   // Label 10189: @771830
     /* 771830 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(771901), // Rule ID 6881 //
     /* 771835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771842 */     // MIs[0] offset
     /* 771842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771845 */     // MIs[0] format
     /* 771845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771848 */     // MIs[0] auxiliary
     /* 771848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771851 */     // MIs[0] Operand 8
     /* 771851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771861 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 771864 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771866 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771875 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771899 */     GIR_RootConstrainSelectedInstOperands,
     /* 771900 */     // GIR_Coverage, 6881,
     /* 771900 */     GIR_EraseRootFromParent_Done,
     /* 771901 */   // Label 10190: @771901
     /* 771901 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(772010), // Rule ID 6879 //
     /* 771906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771909 */     // MIs[0] offset
     /* 771909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771912 */     // MIs[0] format
     /* 771912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771915 */     // MIs[0] auxiliary
     /* 771915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771918 */     // MIs[0] Operand 8
     /* 771918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771928 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771944 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771951 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 771972 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772008 */     GIR_RootConstrainSelectedInstOperands,
     /* 772009 */     // GIR_Coverage, 6879,
     /* 772009 */     GIR_EraseRootFromParent_Done,
     /* 772010 */   // Label 10191: @772010
     /* 772010 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(772119), // Rule ID 6883 //
     /* 772015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 772018 */     // MIs[0] offset
     /* 772018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772021 */     // MIs[0] format
     /* 772021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772024 */     // MIs[0] auxiliary
     /* 772024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772027 */     // MIs[0] Operand 8
     /* 772027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772037 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9787:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772053 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772060 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 772081 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 772086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772093 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772117 */     GIR_RootConstrainSelectedInstOperands,
     /* 772118 */     // GIR_Coverage, 6883,
     /* 772118 */     GIR_EraseRootFromParent_Done,
     /* 772119 */   // Label 10192: @772119
     /* 772119 */   GIM_Reject,
     /* 772120 */ // Label 10184: @772120
     /* 772120 */ GIM_Reject,
     /* 772121 */ // Label 10153: @772121
     /* 772121 */ GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(772479),
     /* 772126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772135 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772138 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(772219), // Rule ID 6848 //
     /* 772143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772154 */     // MIs[0] offset
     /* 772154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772157 */     // MIs[0] format
     /* 772157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772160 */     // MIs[0] auxiliary
     /* 772160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772163 */     // MIs[0] Operand 8
     /* 772163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772181 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9786:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 772184 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772193 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772217 */     GIR_RootConstrainSelectedInstOperands,
     /* 772218 */     // GIR_Coverage, 6848,
     /* 772218 */     GIR_EraseRootFromParent_Done,
     /* 772219 */   // Label 10194: @772219
     /* 772219 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(772298), // Rule ID 6850 //
     /* 772224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772231 */     // MIs[0] offset
     /* 772231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772234 */     // MIs[0] format
     /* 772234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772237 */     // MIs[0] auxiliary
     /* 772237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772240 */     // MIs[0] Operand 8
     /* 772240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772258 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 772261 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772263 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772272 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772296 */     GIR_RootConstrainSelectedInstOperands,
     /* 772297 */     // GIR_Coverage, 6850,
     /* 772297 */     GIR_EraseRootFromParent_Done,
     /* 772298 */   // Label 10195: @772298
     /* 772298 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(772369), // Rule ID 6849 //
     /* 772303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772310 */     // MIs[0] offset
     /* 772310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772313 */     // MIs[0] format
     /* 772313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772316 */     // MIs[0] auxiliary
     /* 772316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772319 */     // MIs[0] Operand 8
     /* 772319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772329 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 772332 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772334 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772343 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772367 */     GIR_RootConstrainSelectedInstOperands,
     /* 772368 */     // GIR_Coverage, 6849,
     /* 772368 */     GIR_EraseRootFromParent_Done,
     /* 772369 */   // Label 10196: @772369
     /* 772369 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(772478), // Rule ID 6851 //
     /* 772374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772377 */     // MIs[0] offset
     /* 772377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772380 */     // MIs[0] format
     /* 772380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772383 */     // MIs[0] auxiliary
     /* 772383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772386 */     // MIs[0] Operand 8
     /* 772386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772396 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9786:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772412 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772419 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 772440 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 772445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772452 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772476 */     GIR_RootConstrainSelectedInstOperands,
     /* 772477 */     // GIR_Coverage, 6851,
     /* 772477 */     GIR_EraseRootFromParent_Done,
     /* 772478 */   // Label 10197: @772478
     /* 772478 */   GIM_Reject,
     /* 772479 */ // Label 10193: @772479
     /* 772479 */ GIM_Reject,
     /* 772480 */ // Label 10154: @772480
     /* 772480 */ GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(772838),
     /* 772485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772494 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772497 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(772578), // Rule ID 6852 //
     /* 772502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772513 */     // MIs[0] offset
     /* 772513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772516 */     // MIs[0] format
     /* 772516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772519 */     // MIs[0] auxiliary
     /* 772519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772522 */     // MIs[0] Operand 8
     /* 772522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772540 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9785:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 772543 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772576 */     GIR_RootConstrainSelectedInstOperands,
     /* 772577 */     // GIR_Coverage, 6852,
     /* 772577 */     GIR_EraseRootFromParent_Done,
     /* 772578 */   // Label 10199: @772578
     /* 772578 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(772657), // Rule ID 6854 //
     /* 772583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772590 */     // MIs[0] offset
     /* 772590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772593 */     // MIs[0] format
     /* 772593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772596 */     // MIs[0] auxiliary
     /* 772596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772599 */     // MIs[0] Operand 8
     /* 772599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772617 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 772620 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772622 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772631 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772655 */     GIR_RootConstrainSelectedInstOperands,
     /* 772656 */     // GIR_Coverage, 6854,
     /* 772656 */     GIR_EraseRootFromParent_Done,
     /* 772657 */   // Label 10200: @772657
     /* 772657 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(772728), // Rule ID 6853 //
     /* 772662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772669 */     // MIs[0] offset
     /* 772669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772672 */     // MIs[0] format
     /* 772672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772675 */     // MIs[0] auxiliary
     /* 772675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772678 */     // MIs[0] Operand 8
     /* 772678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772688 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 772691 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772693 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772726 */     GIR_RootConstrainSelectedInstOperands,
     /* 772727 */     // GIR_Coverage, 6853,
     /* 772727 */     GIR_EraseRootFromParent_Done,
     /* 772728 */   // Label 10201: @772728
     /* 772728 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(772837), // Rule ID 6855 //
     /* 772733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772736 */     // MIs[0] offset
     /* 772736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772739 */     // MIs[0] format
     /* 772739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772742 */     // MIs[0] auxiliary
     /* 772742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772745 */     // MIs[0] Operand 8
     /* 772745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772755 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9785:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772771 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772778 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 772799 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 772804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772811 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772819 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772835 */     GIR_RootConstrainSelectedInstOperands,
     /* 772836 */     // GIR_Coverage, 6855,
     /* 772836 */     GIR_EraseRootFromParent_Done,
     /* 772837 */   // Label 10202: @772837
     /* 772837 */   GIM_Reject,
     /* 772838 */ // Label 10198: @772838
     /* 772838 */ GIM_Reject,
     /* 772839 */ // Label 10155: @772839
     /* 772839 */ GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(773537),
     /* 772844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772853 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772856 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(772937), // Rule ID 6892 //
     /* 772861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 772864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772872 */     // MIs[0] offset
     /* 772872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772875 */     // MIs[0] format
     /* 772875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772878 */     // MIs[0] auxiliary
     /* 772878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772881 */     // MIs[0] Operand 8
     /* 772881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772899 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 772902 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772911 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772935 */     GIR_RootConstrainSelectedInstOperands,
     /* 772936 */     // GIR_Coverage, 6892,
     /* 772936 */     GIR_EraseRootFromParent_Done,
     /* 772937 */   // Label 10204: @772937
     /* 772937 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(773018), // Rule ID 6896 //
     /* 772942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 772945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772953 */     // MIs[0] offset
     /* 772953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772956 */     // MIs[0] format
     /* 772956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772959 */     // MIs[0] auxiliary
     /* 772959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772962 */     // MIs[0] Operand 8
     /* 772962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772980 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9786:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 772983 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773016 */     GIR_RootConstrainSelectedInstOperands,
     /* 773017 */     // GIR_Coverage, 6896,
     /* 773017 */     GIR_EraseRootFromParent_Done,
     /* 773018 */   // Label 10205: @773018
     /* 773018 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(773097), // Rule ID 6894 //
     /* 773023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 773026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773030 */     // MIs[0] offset
     /* 773030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773033 */     // MIs[0] format
     /* 773033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773036 */     // MIs[0] auxiliary
     /* 773036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773039 */     // MIs[0] Operand 8
     /* 773039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773057 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 773060 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773062 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773071 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773095 */     GIR_RootConstrainSelectedInstOperands,
     /* 773096 */     // GIR_Coverage, 6894,
     /* 773096 */     GIR_EraseRootFromParent_Done,
     /* 773097 */   // Label 10206: @773097
     /* 773097 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(773176), // Rule ID 6898 //
     /* 773102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 773105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773109 */     // MIs[0] offset
     /* 773109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773112 */     // MIs[0] format
     /* 773112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773115 */     // MIs[0] auxiliary
     /* 773115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773118 */     // MIs[0] Operand 8
     /* 773118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773136 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 773139 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773141 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773150 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773174 */     GIR_RootConstrainSelectedInstOperands,
     /* 773175 */     // GIR_Coverage, 6898,
     /* 773175 */     GIR_EraseRootFromParent_Done,
     /* 773176 */   // Label 10207: @773176
     /* 773176 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(773247), // Rule ID 6893 //
     /* 773181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 773184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773188 */     // MIs[0] offset
     /* 773188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773191 */     // MIs[0] format
     /* 773191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773194 */     // MIs[0] auxiliary
     /* 773194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773197 */     // MIs[0] Operand 8
     /* 773197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773207 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 773210 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773212 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 773214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773221 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773245 */     GIR_RootConstrainSelectedInstOperands,
     /* 773246 */     // GIR_Coverage, 6893,
     /* 773246 */     GIR_EraseRootFromParent_Done,
     /* 773247 */   // Label 10208: @773247
     /* 773247 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(773318), // Rule ID 6897 //
     /* 773252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 773255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773259 */     // MIs[0] offset
     /* 773259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773262 */     // MIs[0] format
     /* 773262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773265 */     // MIs[0] auxiliary
     /* 773265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773268 */     // MIs[0] Operand 8
     /* 773268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773278 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 773281 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773283 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 773285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773292 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773316 */     GIR_RootConstrainSelectedInstOperands,
     /* 773317 */     // GIR_Coverage, 6897,
     /* 773317 */     GIR_EraseRootFromParent_Done,
     /* 773318 */   // Label 10209: @773318
     /* 773318 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(773427), // Rule ID 6895 //
     /* 773323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 773326 */     // MIs[0] offset
     /* 773326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773329 */     // MIs[0] format
     /* 773329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773332 */     // MIs[0] auxiliary
     /* 773332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773335 */     // MIs[0] Operand 8
     /* 773335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773345 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 773389 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773425 */     GIR_RootConstrainSelectedInstOperands,
     /* 773426 */     // GIR_Coverage, 6895,
     /* 773426 */     GIR_EraseRootFromParent_Done,
     /* 773427 */   // Label 10210: @773427
     /* 773427 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(773536), // Rule ID 6899 //
     /* 773432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 773435 */     // MIs[0] offset
     /* 773435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773438 */     // MIs[0] format
     /* 773438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773441 */     // MIs[0] auxiliary
     /* 773441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773444 */     // MIs[0] Operand 8
     /* 773444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773454 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9786:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773470 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 773498 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773534 */     GIR_RootConstrainSelectedInstOperands,
     /* 773535 */     // GIR_Coverage, 6899,
     /* 773535 */     GIR_EraseRootFromParent_Done,
     /* 773536 */   // Label 10211: @773536
     /* 773536 */   GIM_Reject,
     /* 773537 */ // Label 10203: @773537
     /* 773537 */ GIM_Reject,
     /* 773538 */ // Label 10156: @773538
     /* 773538 */ GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(773896),
     /* 773543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 773546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 773549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 773552 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 773555 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(773636), // Rule ID 6856 //
     /* 773560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773571 */     // MIs[0] offset
     /* 773571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773574 */     // MIs[0] format
     /* 773574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773577 */     // MIs[0] auxiliary
     /* 773577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773580 */     // MIs[0] Operand 8
     /* 773580 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773598 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9784:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 773601 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773610 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773634 */     GIR_RootConstrainSelectedInstOperands,
     /* 773635 */     // GIR_Coverage, 6856,
     /* 773635 */     GIR_EraseRootFromParent_Done,
     /* 773636 */   // Label 10213: @773636
     /* 773636 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(773715), // Rule ID 6858 //
     /* 773641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773648 */     // MIs[0] offset
     /* 773648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773651 */     // MIs[0] format
     /* 773651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773654 */     // MIs[0] auxiliary
     /* 773654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773657 */     // MIs[0] Operand 8
     /* 773657 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773675 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 773678 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773680 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773689 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773713 */     GIR_RootConstrainSelectedInstOperands,
     /* 773714 */     // GIR_Coverage, 6858,
     /* 773714 */     GIR_EraseRootFromParent_Done,
     /* 773715 */   // Label 10214: @773715
     /* 773715 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(773786), // Rule ID 6857 //
     /* 773720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773727 */     // MIs[0] offset
     /* 773727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773730 */     // MIs[0] format
     /* 773730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773733 */     // MIs[0] auxiliary
     /* 773733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773736 */     // MIs[0] Operand 8
     /* 773736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773746 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 773749 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773751 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 773753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773760 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773784 */     GIR_RootConstrainSelectedInstOperands,
     /* 773785 */     // GIR_Coverage, 6857,
     /* 773785 */     GIR_EraseRootFromParent_Done,
     /* 773786 */   // Label 10215: @773786
     /* 773786 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(773895), // Rule ID 6859 //
     /* 773791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773794 */     // MIs[0] offset
     /* 773794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773797 */     // MIs[0] format
     /* 773797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773800 */     // MIs[0] auxiliary
     /* 773800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773803 */     // MIs[0] Operand 8
     /* 773803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773813 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9784:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773829 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773836 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 773857 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773869 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773893 */     GIR_RootConstrainSelectedInstOperands,
     /* 773894 */     // GIR_Coverage, 6859,
     /* 773894 */     GIR_EraseRootFromParent_Done,
     /* 773895 */   // Label 10216: @773895
     /* 773895 */   GIM_Reject,
     /* 773896 */ // Label 10212: @773896
     /* 773896 */ GIM_Reject,
     /* 773897 */ // Label 10157: @773897
     /* 773897 */ GIM_Reject,
     /* 773898 */ // Label 166: @773898
     /* 773898 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 10219*/ GIMT_Encode4(774203),
     /* 773909 */ /*GILLT_s16*//*Label 10217*/ GIMT_Encode4(773917),
     /* 773913 */ /*GILLT_s32*//*Label 10218*/ GIMT_Encode4(774161),
     /* 773917 */ // Label 10217: @773917
     /* 773917 */ GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(774160),
     /* 773922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 773925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 773928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 773931 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(774007), // Rule ID 1027 //
     /* 773936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 773939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773964 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 773964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 773967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 773969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 773974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 773979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 773984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 773989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 773994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 773999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774005 */     GIR_RootConstrainSelectedInstOperands,
     /* 774006 */     // GIR_Coverage, 1027,
     /* 774006 */     GIR_EraseRootFromParent_Done,
     /* 774007 */   // Label 10221: @774007
     /* 774007 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(774083), // Rule ID 1028 //
     /* 774012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 774015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 774019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774040 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 774040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 774043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 774045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 774050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 774055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 774060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 774065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 774070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 774075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774081 */     GIR_RootConstrainSelectedInstOperands,
     /* 774082 */     // GIR_Coverage, 1028,
     /* 774082 */     GIR_EraseRootFromParent_Done,
     /* 774083 */   // Label 10222: @774083
     /* 774083 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(774159), // Rule ID 1029 //
     /* 774088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 774091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 774116 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 774116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 774119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 774121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 774126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 774131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 774136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 774141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 774146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 774151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 774157 */     GIR_RootConstrainSelectedInstOperands,
     /* 774158 */     // GIR_Coverage, 1029,
     /* 774158 */     GIR_EraseRootFromParent_Done,
     /* 774159 */   // Label 10223: @774159
     /* 774159 */   GIM_Reject,
     /* 774160 */ // Label 10220: @774160
     /* 774160 */ GIM_Reject,
     /* 774161 */ // Label 10218: @774161
     /* 774161 */ GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(774202), // Rule ID 968 //
     /* 774166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 774169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 774172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 774175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 774186 */   // (AMDGPUumed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 774186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 774189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 774191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 774196 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 774198 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 774200 */   GIR_RootConstrainSelectedInstOperands,
     /* 774201 */   // GIR_Coverage, 968,
     /* 774201 */   GIR_EraseRootFromParent_Done,
     /* 774202 */ // Label 10224: @774202
     /* 774202 */ GIM_Reject,
     /* 774203 */ // Label 10219: @774203
     /* 774203 */ GIM_Reject,
     /* 774204 */ // Label 167: @774204
     /* 774204 */ GIM_Reject,
     /* 774205 */ }; // Size: 774205 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
